var N = null;var searchIndex = {};
searchIndex["arena"]={"doc":"The arena, a fast but limited type of allocator.","items":[[3,"TypedArena","arena","An arena that can hold objects of only one type.",N,N],[12,"ptr","","A pointer to the next object to be allocated.",0,N],[12,"end","","A pointer to the end of the allocated area. When this pointer is reached, a new chunk is allocated.",0,N],[12,"chunks","","A vector of arena chunks.",0,N],[12,"_own","","Marker indicating that dropping the arena causes its owned instances of `T` to be dropped.",0,N],[3,"TypedArenaChunk","","",N,N],[12,"storage","","The raw storage for the arena chunk.",1,N],[3,"DroplessArena","","",N,N],[12,"ptr","","A pointer to the next object to be allocated.",2,N],[12,"end","","A pointer to the end of the allocated area. When this pointer is reached, a new chunk is allocated.",2,N],[12,"chunks","","A vector of arena chunks.",2,N],[3,"SyncTypedArena","","",N,N],[12,"lock","","",3,N],[3,"SyncDroplessArena","","",N,N],[12,"lock","","",4,N],[17,"PAGE","","",N,N],[11,"new","","",1,[[["usize"]],["typedarenachunk"]]],[11,"destroy","","Destroys this arena chunk.",1,[[["self"],["usize"]]]],[11,"start","","",1,N],[11,"end","","",1,N],[11,"new","","Creates a new `TypedArena`.",0,[[],["typedarena"]]],[11,"alloc","","Allocates an object in the `TypedArena`, returning a reference to it.",0,[[["self"],["t"]],["t"]]],[11,"alloc_slice","","Allocates a slice of objects that are copied into the `TypedArena`, returning a mutable reference to it. Will panic if passed a zero-sized types.",0,N],[11,"grow","","Grows the arena.",0,[[["self"],["usize"]]]],[11,"clear","","Clears the arena. Deallocates all but the longest chunk which may be reused.",0,[[["self"]]]],[11,"clear_last_chunk","","",0,[[["self"],["typedarenachunk"]]]],[11,"drop","","",0,[[["self"]]]],[11,"new","","",2,[[],["droplessarena"]]],[11,"in_arena","","",2,N],[11,"align","","",2,[[["self"],["usize"]]]],[11,"grow","","",2,[[["self"],["usize"]]]],[11,"alloc_raw","","",2,N],[11,"alloc","","",2,[[["self"],["t"]],["t"]]],[11,"alloc_slice","","Allocates a slice of objects that are copied into the `DroplessArena`, returning a mutable reference to it. Will panic if passed a zero-sized type.",2,N],[11,"new","","",3,[[],["synctypedarena"]]],[11,"alloc","","",3,[[["self"],["t"]],["t"]]],[11,"alloc_slice","","",3,N],[11,"clear","","",3,[[["self"]]]],[11,"new","","",4,[[],["syncdroplessarena"]]],[11,"in_arena","","",4,N],[11,"alloc_raw","","",4,N],[11,"alloc","","",4,[[["self"],["t"]],["t"]]],[11,"alloc_slice","","",4,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]]],"paths":[[3,"TypedArena"],[3,"TypedArenaChunk"],[3,"DroplessArena"],[3,"SyncTypedArena"],[3,"SyncDroplessArena"]]};
searchIndex["bitflags"]={"doc":"A typesafe bitmask flag generator useful for sets of C-style bitmask flags. It can be used for creating typesafe wrappers around C APIs.","items":[[0,"example_generated","bitflags","This module shows an example of code generated by the macro. IT MUST NOT BE USED OUTSIDE THIS CRATE.",N,N],[3,"Flags","bitflags::example_generated","This is the same `Flags` struct defined in the crate level example. Note that this struct is just for documentation purposes only, it must not be used outside this crate.",N,N],[12,"bits","","",0,N],[17,"FLAG_A","","",N,N],[17,"FLAG_B","","",N,N],[17,"FLAG_C","","",N,N],[17,"FLAG_ABC","","",N,N],[11,"eq","","",0,[[["self"],["flags"]],["bool"]]],[11,"ne","","",0,[[["self"],["flags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"clone","","",0,[[["self"]],["flags"]]],[11,"partial_cmp","","",0,[[["self"],["flags"]],["option",["ordering"]]]],[11,"lt","","",0,[[["self"],["flags"]],["bool"]]],[11,"le","","",0,[[["self"],["flags"]],["bool"]]],[11,"gt","","",0,[[["self"],["flags"]],["bool"]]],[11,"ge","","",0,[[["self"],["flags"]],["bool"]]],[11,"cmp","","",0,[[["self"],["flags"]],["ordering"]]],[11,"hash","","",0,N],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"empty","","Returns an empty set of flags.",0,[[],["flags"]]],[11,"all","","Returns the set containing all flags.",0,[[],["flags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",0,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",0,[[["u32"]],["option",["flags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",0,[[["u32"]],["flags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",0,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",0,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",0,[[["self"],["flags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",0,[[["self"],["flags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",0,[[["self"],["flags"]]]],[11,"remove","","Removes the specified flags in-place.",0,[[["self"],["flags"]]]],[11,"toggle","","Toggles the specified flags in-place.",0,[[["self"],["flags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",0,[[["self"],["flags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",0,[[["self"],["flags"]],["flags"]]],[11,"bitor_assign","","Adds the set of flags.",0,[[["self"],["flags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",0,[[["self"],["flags"]],["flags"]]],[11,"bitxor_assign","","Toggles the set of flags.",0,[[["self"],["flags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",0,[[["self"],["flags"]],["flags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",0,[[["self"],["flags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",0,[[["self"],["flags"]],["flags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",0,[[["self"],["flags"]]]],[11,"not","","Returns the complement of this set of flags.",0,[[["self"]],["flags"]]],[11,"extend","","",0,[[["self"],["t"]]]],[11,"from_iter","","",0,[[["t"]],["flags"]]],[14,"bitflags","bitflags","The macro used to generate the flag structure.",N,N],[14,"__impl_bitflags","","",N,N],[11,"try_from","bitflags::example_generated","",0,[[["u"]],["result"]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]]],"paths":[[3,"Flags"]]};
searchIndex["build_helper"]={"doc":"","items":[[3,"NativeLibBoilerplate","build_helper","",N,N],[12,"src_dir","","",0,N],[12,"out_dir","","",0,N],[5,"run","","",N,[[["command"]]]],[5,"run_silent","","",N,[[["command"]]]],[5,"try_run_silent","","",N,[[["command"]],["bool"]]],[5,"run_suppressed","","",N,[[["command"]]]],[5,"try_run_suppressed","","",N,[[["command"]],["bool"]]],[5,"gnu_target","","",N,[[["str"]],["string"]]],[5,"make","","",N,[[["str"]],["pathbuf"]]],[5,"output","","",N,[[["command"]],["string"]]],[5,"rerun_if_changed_anything_in_dir","","",N,[[["path"]]]],[5,"mtime","","Returns the last-modified time for `path`, or zero if it doesn't exist.",N,[[["path"]],["systemtime"]]],[5,"up_to_date","","Returns whether `dst` is up to date given that the file or files in `src` are used to generate it.",N,[[["path"],["path"]],["bool"]]],[5,"native_lib_boilerplate","","",N,[[["str"],["str"],["str"],["str"]],["result",["nativelibboilerplate"]]]],[5,"sanitizer_lib_boilerplate","","",N,[[["str"]],["result"]]],[5,"dir_up_to_date","","",N,[[["path"],["systemtime"]],["bool"]]],[5,"fail","","",N,N],[11,"drop","","",0,[[["self"]]]],[14,"t","","A helper macro to `unwrap` a result except also print out details like:",N,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]]],"paths":[[3,"NativeLibBoilerplate"]]};
searchIndex["fmt_macros"]={"doc":"Macro support for format strings","items":[[3,"Argument","fmt_macros","Representation of an argument specification.",N,N],[12,"position","","Where to find this argument",0,N],[12,"format","","How to format the argument",0,N],[3,"FormatSpec","","Specification for the formatting of an argument in the format string.",N,N],[12,"fill","","Optionally specified character to fill alignment with",1,N],[12,"align","","Optionally specified alignment",1,N],[12,"flags","","Packed version of various flags provided",1,N],[12,"precision","","The integer precision to use",1,N],[12,"width","","The string width requested for the resulting format",1,N],[12,"ty","","The descriptor string representing the name of the format desired for this argument, this can be empty or any number of characters, although it is required to be one word.",1,N],[3,"ParseError","","",N,N],[12,"description","","",2,N],[12,"note","","",2,N],[12,"label","","",2,N],[12,"start","","",2,N],[12,"end","","",2,N],[3,"Parser","","The parser structure for interpreting the input format string. This is modeled as an iterator over `Piece` structures to form a stream of tokens being output.",N,N],[12,"input","","",3,N],[12,"cur","","",3,N],[12,"errors","","Error messages accumulated during parsing",3,N],[12,"curarg","","Current position of implicit positional argument pointer",3,N],[12,"style","","`Some(raw count)` when the string is \"raw\", used to position spans correctly",3,N],[12,"seen_newlines","","How many newlines have been seen in the string so far, to adjust the error spans",3,N],[12,"arg_places","","Start and end byte offset of every successfully parsed argument",3,N],[4,"Piece","","A piece is a portion of the format string which represents the next part to emit. These are emitted as a stream by the `Parser` class.",N,N],[13,"String","","A literal string which should directly be emitted",4,N],[13,"NextArgument","","This describes that formatting should process the next argument (as specified inside) for emission.",4,N],[4,"Position","","Enum describing where an argument for a format can be located.",N,N],[13,"ArgumentImplicitlyIs","","The argument is implied to be located at an index",5,N],[13,"ArgumentIs","","The argument is located at a specific index given in the format",5,N],[13,"ArgumentNamed","","The argument has a name.",5,N],[4,"Alignment","","Enum of alignments which are supported.",N,N],[13,"AlignLeft","","The value will be aligned to the left.",6,N],[13,"AlignRight","","The value will be aligned to the right.",6,N],[13,"AlignCenter","","The value will be aligned in the center.",6,N],[13,"AlignUnknown","","The value will take on a default alignment.",6,N],[4,"Flag","","Various flags which can be applied to format strings. The meaning of these flags is defined by the formatters themselves.",N,N],[13,"FlagSignPlus","","A `+` will be used to denote positive numbers.",7,N],[13,"FlagSignMinus","","A `-` will be used to denote negative numbers. This is the default.",7,N],[13,"FlagAlternate","","An alternate form will be used for the value. In the case of numbers, this means that the number will be prefixed with the supplied string.",7,N],[13,"FlagSignAwareZeroPad","","For numbers, this means that the number will be padded with zeroes, and the sign (`+` or `-`) will precede them.",7,N],[13,"FlagDebugLowerHex","","For Debug / `?`, format integers in lower-case hexadecimal.",7,N],[13,"FlagDebugUpperHex","","For Debug / `?`, format integers in upper-case hexadecimal.",7,N],[4,"Count","","A count is used for the precision and width parameters of an integer, and can reference either an argument or a literal integer.",N,N],[13,"CountIs","","The count is specified explicitly.",8,N],[13,"CountIsName","","The count is specified by the argument with the given name.",8,N],[13,"CountIsParam","","The count is specified by the argument at the given index.",8,N],[13,"CountImplied","","The count is implied and cannot be explicitly specified.",8,N],[11,"clone","","",4,[[["self"]],["piece"]]],[11,"eq","","",4,[[["self"],["piece"]],["bool"]]],[11,"ne","","",4,[[["self"],["piece"]],["bool"]]],[11,"clone","","",0,[[["self"]],["argument"]]],[11,"eq","","",0,[[["self"],["argument"]],["bool"]]],[11,"ne","","",0,[[["self"],["argument"]],["bool"]]],[11,"clone","","",1,[[["self"]],["formatspec"]]],[11,"eq","","",1,[[["self"],["formatspec"]],["bool"]]],[11,"ne","","",1,[[["self"],["formatspec"]],["bool"]]],[11,"clone","","",5,[[["self"]],["position"]]],[11,"eq","","",5,[[["self"],["position"]],["bool"]]],[11,"ne","","",5,[[["self"],["position"]],["bool"]]],[11,"clone","","",6,[[["self"]],["alignment"]]],[11,"eq","","",6,[[["self"],["alignment"]],["bool"]]],[11,"clone","","",7,[[["self"]],["flag"]]],[11,"eq","","",7,[[["self"],["flag"]],["bool"]]],[11,"clone","","",8,[[["self"]],["count"]]],[11,"eq","","",8,[[["self"],["count"]],["bool"]]],[11,"ne","","",8,[[["self"],["count"]],["bool"]]],[11,"next","","",3,[[["self"]],["option",["piece"]]]],[11,"new","","Creates a new parser for the given format string",3,[[["str"],["option",["usize"]]],["parser"]]],[11,"err","","Notifies of an error. The message doesn't actually need to be of type String, but I think it does when this eventually uses conditions so it might as well start using it now.",3,[[["self"],["s1"],["s2"],["usize"],["usize"]]]],[11,"err_with_note","","Notifies of an error. The message doesn't actually need to be of type String, but I think it does when this eventually uses conditions so it might as well start using it now.",3,[[["self"],["s1"],["s2"],["s3"],["usize"],["usize"]]]],[11,"consume","","Optionally consumes the specified character. If the character is not at the current position, then the current iterator isn't moved and false is returned, otherwise the character is consumed and true is returned.",3,[[["self"],["char"]],["bool"]]],[11,"must_consume","","Forces consumption of the specified character. If the character is not found, an error is emitted.",3,[[["self"],["char"]],["option",["usize"]]]],[11,"ws","","Consumes all whitespace characters until the first non-whitespace character",3,[[["self"]]]],[11,"string","","Parses all of a string which is to be considered a \"raw literal\" in a format string. This is everything outside of the braces.",3,[[["self"],["usize"]],["str"]]],[11,"argument","","Parses an Argument structure, or what's contained within braces inside the format string",3,[[["self"]],["argument"]]],[11,"position","","Parses a positional argument for a format. This could either be an integer index of an argument, a named argument, or a blank string. Returns `Some(parsed_position)` if the position is not implicitly consuming a macro argument, `None` if it's the case.",3,[[["self"]],["option",["position"]]]],[11,"format","","Parses a format specifier at the current position, returning all of the relevant information in the FormatSpec struct.",3,[[["self"]],["formatspec"]]],[11,"count","","Parses a Count parameter at the current position. This does not check for 'CountIsNextParam' because that is only used in precision, not width.",3,[[["self"]],["count"]]],[11,"word","","Parses a word starting at the current position. A word is considered to be an alphabetic character followed by any number of alphanumeric characters.",3,[[["self"]],["str"]]],[11,"integer","","Optionally parses an integer at the current position. This doesn't deal with overflow at all, it's just accumulating digits.",3,[[["self"]],["option",["usize"]]]],[11,"to_owned","","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into_iter","","",3,[[["self"]],["i"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]]],"paths":[[3,"Argument"],[3,"FormatSpec"],[3,"ParseError"],[3,"Parser"],[4,"Piece"],[4,"Position"],[4,"Alignment"],[4,"Flag"],[4,"Count"]]};
searchIndex["graphviz"]={"doc":"Generate files suitable for use with Graphviz","items":[[3,"Id","graphviz","`Id` is a Graphviz `ID`.",N,N],[12,"name","","",0,N],[4,"LabelText","","The text for a graphviz label on a node or edge.",N,N],[13,"LabelStr","","This kind of label preserves the text directly as is.",1,N],[13,"EscStr","","This kind of label uses the graphviz label escString type: http://www.graphviz.org/content/attrs#kescString",1,N],[13,"HtmlStr","","This uses a graphviz [HTML string label][html]. The string is printed exactly as given, but between `<` and `>`. No escaping is performed.",1,N],[4,"Style","","The style for a node or edge. See http://www.graphviz.org/doc/info/attrs.html#k:style for descriptions. Note that some of these are not valid for edges.",N,N],[13,"None","","",2,N],[13,"Solid","","",2,N],[13,"Dashed","","",2,N],[13,"Dotted","","",2,N],[13,"Bold","","",2,N],[13,"Rounded","","",2,N],[13,"Diagonals","","",2,N],[13,"Filled","","",2,N],[13,"Striped","","",2,N],[13,"Wedged","","",2,N],[4,"RenderOption","","",N,N],[13,"NoEdgeLabels","","",3,N],[13,"NoNodeLabels","","",3,N],[13,"NoEdgeStyles","","",3,N],[13,"NoNodeStyles","","",3,N],[5,"escape_html","","Escape tags in such a way that it is suitable for inclusion in a Graphviz HTML label.",N,[[["str"]],["string"]]],[5,"default_options","","Returns vec holding all the default render options.",N,[[],["vec",["renderoption"]]]],[5,"render","","Renders directed graph `g` into the writer `w` in DOT syntax. (Simple wrapper around `render_opts` that passes a default set of options.)",N,[[["g"],["w"]],["result"]]],[5,"render_opts","","Renders directed graph `g` into the writer `w` in DOT syntax. (Main entry point for the library.)",N,N],[6,"Nodes","","",N,N],[6,"Edges","","",N,N],[8,"Labeller","","Each instance of a type that implements `Label<C>` maps to a unique identifier with respect to `C`, which is used to identify it in the generated .dot file. They can also provide more elaborate (and non-unique) label text that is used in the graphviz rendered output. The graph instance is responsible for providing the DOT compatible identifiers for the nodes and (optionally) rendered labels for the nodes and edges, as well as an identifier for the graph itself.",N,N],[16,"Node","","",4,N],[16,"Edge","","",4,N],[10,"graph_id","","Must return a DOT compatible identifier naming the graph.",4,[[["self"]],["id"]]],[10,"node_id","","Maps `n` to a unique identifier with respect to `self`. The implementor is responsible for ensuring that the returned name is a valid DOT identifier.",4,N],[11,"node_shape","","Maps `n` to one of the [graphviz `shape` names][1]. If `None` is returned, no `shape` attribute is specified.",4,N],[11,"node_label","","Maps `n` to a label that will be used in the rendered output. The label need not be unique, and may be the empty string; the default is just the output from `node_id`.",4,N],[11,"edge_label","","Maps `e` to a label that will be used in the rendered output. The label need not be unique, and may be the empty string; the default is in fact the empty string.",4,N],[11,"node_style","","Maps `n` to a style that will be used in the rendered output.",4,N],[11,"edge_style","","Maps `e` to a style that will be used in the rendered output.",4,N],[8,"GraphWalk","","GraphWalk is an abstraction over a directed graph = (nodes,edges) made up of node handles `N` and edge handles `E`, where each `E` can be mapped to its source and target nodes.",N,N],[16,"Node","","",5,N],[16,"Edge","","",5,N],[10,"nodes","","Returns all the nodes in this graph.",5,[[["self"]],["nodes"]]],[10,"edges","","Returns all of the edges in this graph.",5,[[["self"]],["edges"]]],[10,"source","","The source node for `edge`.",5,N],[10,"target","","The target node for `edge`.",5,N],[8,"IntoCow","","",N,N],[10,"into_cow","","",6,[[["self"]],["cow"]]],[11,"clone","","",2,[[["self"]],["style"]]],[11,"eq","","",2,[[["self"],["style"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"as_slice","","",2,[[["self"]],["str"]]],[11,"new","","Creates an `Id` named `name`.",0,[[["name"]],["result",["id"]]]],[11,"as_slice","","",0,[[["self"]],["str"]]],[11,"name","","",0,[[["self"]],["cow",["str"]]]],[11,"label","","",1,[[["s"]],["labeltext"]]],[11,"escaped","","",1,[[["s"]],["labeltext"]]],[11,"html","","",1,[[["s"]],["labeltext"]]],[11,"escape_char","","",1,[[["char"],["f"]]]],[11,"escape_str","","",1,[[["str"]],["string"]]],[11,"to_dot_string","","Renders text as string suitable for a label in a .dot file. This includes quotes or suitable delimiters.",1,[[["self"]],["string"]]],[11,"pre_escaped_content","","Decomposes content into string suitable for making EscStr that yields same content as self.  The result obeys the law render(`lt`) == render(`EscStr(lt.pre_escaped_content())`) for all `lt: LabelText`.",1,[[["self"]],["cow",["str"]]]],[11,"prefix_line","","Puts `prefix` on a line above this label, with a blank line separator.",1,[[["self"],["labeltext"]],["labeltext"]]],[11,"suffix_line","","Puts `suffix` on a line below this label, with a blank line separator.",1,[[["self"],["labeltext"]],["labeltext"]]],[11,"clone","","",3,[[["self"]],["renderoption"]]],[11,"eq","","",3,[[["self"],["renderoption"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]]],"paths":[[3,"Id"],[4,"LabelText"],[4,"Style"],[4,"RenderOption"],[8,"Labeller"],[8,"GraphWalk"],[8,"IntoCow"]]};
searchIndex["libc"]={"doc":"Crate docs","items":[[3,"group","libc","",N,N],[12,"gr_name","","",0,N],[12,"gr_passwd","","",0,N],[12,"gr_gid","","",0,N],[12,"gr_mem","","",0,N],[3,"utimbuf","","",N,N],[12,"actime","","",1,N],[12,"modtime","","",1,N],[3,"timeval","","",N,N],[12,"tv_sec","","",2,N],[12,"tv_usec","","",2,N],[3,"timespec","","",N,N],[12,"tv_sec","","",3,N],[12,"tv_nsec","","",3,N],[3,"rlimit","","",N,N],[12,"rlim_cur","","",4,N],[12,"rlim_max","","",4,N],[3,"rusage","","",N,N],[12,"ru_utime","","",5,N],[12,"ru_stime","","",5,N],[12,"ru_maxrss","","",5,N],[12,"ru_ixrss","","",5,N],[12,"ru_idrss","","",5,N],[12,"ru_isrss","","",5,N],[12,"ru_minflt","","",5,N],[12,"ru_majflt","","",5,N],[12,"ru_nswap","","",5,N],[12,"ru_inblock","","",5,N],[12,"ru_oublock","","",5,N],[12,"ru_msgsnd","","",5,N],[12,"ru_msgrcv","","",5,N],[12,"ru_nsignals","","",5,N],[12,"ru_nvcsw","","",5,N],[12,"ru_nivcsw","","",5,N],[3,"in_addr","","",N,N],[12,"s_addr","","",6,N],[3,"in6_addr","","",N,N],[12,"s6_addr","","",7,N],[12,"__align","","",7,N],[3,"ip_mreq","","",N,N],[12,"imr_multiaddr","","",8,N],[12,"imr_interface","","",8,N],[3,"ipv6_mreq","","",N,N],[12,"ipv6mr_multiaddr","","",9,N],[12,"ipv6mr_interface","","",9,N],[3,"hostent","","",N,N],[12,"h_name","","",10,N],[12,"h_aliases","","",10,N],[12,"h_addrtype","","",10,N],[12,"h_length","","",10,N],[12,"h_addr_list","","",10,N],[3,"iovec","","",N,N],[12,"iov_base","","",11,N],[12,"iov_len","","",11,N],[3,"pollfd","","",N,N],[12,"fd","","",12,N],[12,"events","","",12,N],[12,"revents","","",12,N],[3,"winsize","","",N,N],[12,"ws_row","","",13,N],[12,"ws_col","","",13,N],[12,"ws_xpixel","","",13,N],[12,"ws_ypixel","","",13,N],[3,"linger","","",N,N],[12,"l_onoff","","",14,N],[12,"l_linger","","",14,N],[3,"sigval","","",N,N],[12,"sival_ptr","","",15,N],[3,"itimerval","","",N,N],[12,"it_interval","","",16,N],[12,"it_value","","",16,N],[3,"tms","","",N,N],[12,"tms_utime","","",17,N],[12,"tms_stime","","",17,N],[12,"tms_cutime","","",17,N],[12,"tms_cstime","","",17,N],[3,"servent","","",N,N],[12,"s_name","","",18,N],[12,"s_aliases","","",18,N],[12,"s_port","","",18,N],[12,"s_proto","","",18,N],[3,"protoent","","",N,N],[12,"p_name","","",19,N],[12,"p_aliases","","",19,N],[12,"p_proto","","",19,N],[3,"sockaddr","","",N,N],[12,"sa_family","","",20,N],[12,"sa_data","","",20,N],[3,"sockaddr_in","","",N,N],[12,"sin_family","","",21,N],[12,"sin_port","","",21,N],[12,"sin_addr","","",21,N],[12,"sin_zero","","",21,N],[3,"sockaddr_in6","","",N,N],[12,"sin6_family","","",22,N],[12,"sin6_port","","",22,N],[12,"sin6_flowinfo","","",22,N],[12,"sin6_addr","","",22,N],[12,"sin6_scope_id","","",22,N],[3,"sockaddr_un","","",N,N],[12,"sun_family","","",23,N],[12,"sun_path","","",23,N],[3,"sockaddr_storage","","",N,N],[12,"ss_family","","",24,N],[12,"__ss_align","","",24,N],[12,"__ss_pad2","","",24,N],[3,"addrinfo","","",N,N],[12,"ai_flags","","",25,N],[12,"ai_family","","",25,N],[12,"ai_socktype","","",25,N],[12,"ai_protocol","","",25,N],[12,"ai_addrlen","","",25,N],[12,"ai_addr","","",25,N],[12,"ai_canonname","","",25,N],[12,"ai_next","","",25,N],[3,"sockaddr_nl","","",N,N],[12,"nl_family","","",26,N],[12,"nl_pad","","",26,N],[12,"nl_pid","","",26,N],[12,"nl_groups","","",26,N],[3,"sockaddr_ll","","",N,N],[12,"sll_family","","",27,N],[12,"sll_protocol","","",27,N],[12,"sll_ifindex","","",27,N],[12,"sll_hatype","","",27,N],[12,"sll_pkttype","","",27,N],[12,"sll_halen","","",27,N],[12,"sll_addr","","",27,N],[3,"fd_set","","",N,N],[12,"fds_bits","","",28,N],[3,"tm","","",N,N],[12,"tm_sec","","",29,N],[12,"tm_min","","",29,N],[12,"tm_hour","","",29,N],[12,"tm_mday","","",29,N],[12,"tm_mon","","",29,N],[12,"tm_year","","",29,N],[12,"tm_wday","","",29,N],[12,"tm_yday","","",29,N],[12,"tm_isdst","","",29,N],[12,"tm_gmtoff","","",29,N],[12,"tm_zone","","",29,N],[3,"sched_param","","",N,N],[12,"sched_priority","","",30,N],[3,"Dl_info","","",N,N],[12,"dli_fname","","",31,N],[12,"dli_fbase","","",31,N],[12,"dli_sname","","",31,N],[12,"dli_saddr","","",31,N],[3,"epoll_event","","",N,N],[12,"events","","",32,N],[12,"u64","","",32,N],[3,"utsname","","",N,N],[12,"sysname","","",33,N],[12,"nodename","","",33,N],[12,"release","","",33,N],[12,"version","","",33,N],[12,"machine","","",33,N],[12,"domainname","","",33,N],[3,"lconv","","",N,N],[12,"decimal_point","","",34,N],[12,"thousands_sep","","",34,N],[12,"grouping","","",34,N],[12,"int_curr_symbol","","",34,N],[12,"currency_symbol","","",34,N],[12,"mon_decimal_point","","",34,N],[12,"mon_thousands_sep","","",34,N],[12,"mon_grouping","","",34,N],[12,"positive_sign","","",34,N],[12,"negative_sign","","",34,N],[12,"int_frac_digits","","",34,N],[12,"frac_digits","","",34,N],[12,"p_cs_precedes","","",34,N],[12,"p_sep_by_space","","",34,N],[12,"n_cs_precedes","","",34,N],[12,"n_sep_by_space","","",34,N],[12,"p_sign_posn","","",34,N],[12,"n_sign_posn","","",34,N],[12,"int_p_cs_precedes","","",34,N],[12,"int_p_sep_by_space","","",34,N],[12,"int_n_cs_precedes","","",34,N],[12,"int_n_sep_by_space","","",34,N],[12,"int_p_sign_posn","","",34,N],[12,"int_n_sign_posn","","",34,N],[3,"sigevent","","",N,N],[12,"sigev_value","","",35,N],[12,"sigev_signo","","",35,N],[12,"sigev_notify","","",35,N],[12,"sigev_notify_thread_id","","",35,N],[12,"__unused1","","",35,N],[3,"in_pktinfo","","",N,N],[12,"ipi_ifindex","","",36,N],[12,"ipi_spec_dst","","",36,N],[12,"ipi_addr","","",36,N],[3,"ifaddrs","","",N,N],[12,"ifa_next","","",37,N],[12,"ifa_name","","",37,N],[12,"ifa_flags","","",37,N],[12,"ifa_addr","","",37,N],[12,"ifa_netmask","","",37,N],[12,"ifa_ifu","","",37,N],[12,"ifa_data","","",37,N],[3,"in6_rtmsg","","",N,N],[12,"rtmsg_dst","","",38,N],[12,"rtmsg_src","","",38,N],[12,"rtmsg_gateway","","",38,N],[12,"rtmsg_type","","",38,N],[12,"rtmsg_dst_len","","",38,N],[12,"rtmsg_src_len","","",38,N],[12,"rtmsg_metric","","",38,N],[12,"rtmsg_info","","",38,N],[12,"rtmsg_flags","","",38,N],[12,"rtmsg_ifindex","","",38,N],[3,"arpreq","","",N,N],[12,"arp_pa","","",39,N],[12,"arp_ha","","",39,N],[12,"arp_flags","","",39,N],[12,"arp_netmask","","",39,N],[12,"arp_dev","","",39,N],[3,"arpreq_old","","",N,N],[12,"arp_pa","","",40,N],[12,"arp_ha","","",40,N],[12,"arp_flags","","",40,N],[12,"arp_netmask","","",40,N],[3,"arphdr","","",N,N],[12,"ar_hrd","","",41,N],[12,"ar_pro","","",41,N],[12,"ar_hln","","",41,N],[12,"ar_pln","","",41,N],[12,"ar_op","","",41,N],[3,"dirent","","",N,N],[12,"d_ino","","",42,N],[12,"d_off","","",42,N],[12,"d_reclen","","",42,N],[12,"d_type","","",42,N],[12,"d_name","","",42,N],[3,"dirent64","","",N,N],[12,"d_ino","","",43,N],[12,"d_off","","",43,N],[12,"d_reclen","","",43,N],[12,"d_type","","",43,N],[12,"d_name","","",43,N],[3,"rlimit64","","",N,N],[12,"rlim_cur","","",44,N],[12,"rlim_max","","",44,N],[3,"glob_t","","",N,N],[12,"gl_pathc","","",45,N],[12,"gl_pathv","","",45,N],[12,"gl_offs","","",45,N],[12,"gl_flags","","",45,N],[12,"__unused1","","",45,N],[12,"__unused2","","",45,N],[12,"__unused3","","",45,N],[12,"__unused4","","",45,N],[12,"__unused5","","",45,N],[3,"pthread_mutex_t","","",N,N],[12,"__align","","",46,N],[12,"size","","",46,N],[3,"pthread_rwlock_t","","",N,N],[12,"__align","","",47,N],[12,"size","","",47,N],[3,"pthread_mutexattr_t","","",N,N],[12,"__align","","",48,N],[12,"size","","",48,N],[3,"pthread_rwlockattr_t","","",N,N],[12,"__align","","",49,N],[12,"size","","",49,N],[3,"pthread_cond_t","","",N,N],[12,"__align","","",50,N],[12,"size","","",50,N],[3,"pthread_condattr_t","","",N,N],[12,"__align","","",51,N],[12,"size","","",51,N],[3,"passwd","","",N,N],[12,"pw_name","","",52,N],[12,"pw_passwd","","",52,N],[12,"pw_uid","","",52,N],[12,"pw_gid","","",52,N],[12,"pw_gecos","","",52,N],[12,"pw_dir","","",52,N],[12,"pw_shell","","",52,N],[3,"spwd","","",N,N],[12,"sp_namp","","",53,N],[12,"sp_pwdp","","",53,N],[12,"sp_lstchg","","",53,N],[12,"sp_min","","",53,N],[12,"sp_max","","",53,N],[12,"sp_warn","","",53,N],[12,"sp_inact","","",53,N],[12,"sp_expire","","",53,N],[12,"sp_flag","","",53,N],[3,"dqblk","","",N,N],[12,"dqb_bhardlimit","","",54,N],[12,"dqb_bsoftlimit","","",54,N],[12,"dqb_curspace","","",54,N],[12,"dqb_ihardlimit","","",54,N],[12,"dqb_isoftlimit","","",54,N],[12,"dqb_curinodes","","",54,N],[12,"dqb_btime","","",54,N],[12,"dqb_itime","","",54,N],[12,"dqb_valid","","",54,N],[3,"signalfd_siginfo","","",N,N],[12,"ssi_signo","","",55,N],[12,"ssi_errno","","",55,N],[12,"ssi_code","","",55,N],[12,"ssi_pid","","",55,N],[12,"ssi_uid","","",55,N],[12,"ssi_fd","","",55,N],[12,"ssi_tid","","",55,N],[12,"ssi_band","","",55,N],[12,"ssi_overrun","","",55,N],[12,"ssi_trapno","","",55,N],[12,"ssi_status","","",55,N],[12,"ssi_int","","",55,N],[12,"ssi_ptr","","",55,N],[12,"ssi_utime","","",55,N],[12,"ssi_stime","","",55,N],[12,"ssi_addr","","",55,N],[12,"_pad","","",55,N],[3,"itimerspec","","",N,N],[12,"it_interval","","",56,N],[12,"it_value","","",56,N],[3,"fsid_t","","",N,N],[12,"__val","","",57,N],[3,"mq_attr","","",N,N],[12,"mq_flags","","",58,N],[12,"mq_maxmsg","","",58,N],[12,"mq_msgsize","","",58,N],[12,"mq_curmsgs","","",58,N],[12,"pad","","",58,N],[3,"packet_mreq","","",N,N],[12,"mr_ifindex","","",59,N],[12,"mr_type","","",59,N],[12,"mr_alen","","",59,N],[12,"mr_address","","",59,N],[3,"cpu_set_t","","",N,N],[12,"bits","","",60,N],[3,"if_nameindex","","",N,N],[12,"if_index","","",61,N],[12,"if_name","","",61,N],[3,"msginfo","","",N,N],[12,"msgpool","","",62,N],[12,"msgmap","","",62,N],[12,"msgmax","","",62,N],[12,"msgmnb","","",62,N],[12,"msgmni","","",62,N],[12,"msgssz","","",62,N],[12,"msgtql","","",62,N],[12,"msgseg","","",62,N],[3,"mmsghdr","","",N,N],[12,"msg_hdr","","",63,N],[12,"msg_len","","",63,N],[3,"sembuf","","",N,N],[12,"sem_num","","",64,N],[12,"sem_op","","",64,N],[12,"sem_flg","","",64,N],[3,"input_event","","",N,N],[12,"time","","",65,N],[12,"type_","","",65,N],[12,"code","","",65,N],[12,"value","","",65,N],[3,"input_id","","",N,N],[12,"bustype","","",66,N],[12,"vendor","","",66,N],[12,"product","","",66,N],[12,"version","","",66,N],[3,"input_absinfo","","",N,N],[12,"value","","",67,N],[12,"minimum","","",67,N],[12,"maximum","","",67,N],[12,"fuzz","","",67,N],[12,"flat","","",67,N],[12,"resolution","","",67,N],[3,"input_keymap_entry","","",N,N],[12,"flags","","",68,N],[12,"len","","",68,N],[12,"index","","",68,N],[12,"keycode","","",68,N],[12,"scancode","","",68,N],[3,"input_mask","","",N,N],[12,"type_","","",69,N],[12,"codes_size","","",69,N],[12,"codes_ptr","","",69,N],[3,"ff_replay","","",N,N],[12,"length","","",70,N],[12,"delay","","",70,N],[3,"ff_trigger","","",N,N],[12,"button","","",71,N],[12,"interval","","",71,N],[3,"ff_envelope","","",N,N],[12,"attack_length","","",72,N],[12,"attack_level","","",72,N],[12,"fade_length","","",72,N],[12,"fade_level","","",72,N],[3,"ff_constant_effect","","",N,N],[12,"level","","",73,N],[12,"envelope","","",73,N],[3,"ff_ramp_effect","","",N,N],[12,"start_level","","",74,N],[12,"end_level","","",74,N],[12,"envelope","","",74,N],[3,"ff_condition_effect","","",N,N],[12,"right_saturation","","",75,N],[12,"left_saturation","","",75,N],[12,"right_coeff","","",75,N],[12,"left_coeff","","",75,N],[12,"deadband","","",75,N],[12,"center","","",75,N],[3,"ff_periodic_effect","","",N,N],[12,"waveform","","",76,N],[12,"period","","",76,N],[12,"magnitude","","",76,N],[12,"offset","","",76,N],[12,"phase","","",76,N],[12,"envelope","","",76,N],[12,"custom_len","","",76,N],[12,"custom_data","","",76,N],[3,"ff_rumble_effect","","",N,N],[12,"strong_magnitude","","",77,N],[12,"weak_magnitude","","",77,N],[3,"ff_effect","","",N,N],[12,"type_","","",78,N],[12,"id","","",78,N],[12,"direction","","",78,N],[12,"trigger","","",78,N],[12,"replay","","",78,N],[12,"u","","",78,N],[3,"dl_phdr_info","","",N,N],[12,"dlpi_addr","","",79,N],[12,"dlpi_name","","",79,N],[12,"dlpi_phdr","","",79,N],[12,"dlpi_phnum","","",79,N],[12,"dlpi_adds","","",79,N],[12,"dlpi_subs","","",79,N],[12,"dlpi_tls_modid","","",79,N],[12,"dlpi_tls_data","","",79,N],[3,"Elf32_Phdr","","",N,N],[12,"p_type","","",80,N],[12,"p_offset","","",80,N],[12,"p_vaddr","","",80,N],[12,"p_paddr","","",80,N],[12,"p_filesz","","",80,N],[12,"p_memsz","","",80,N],[12,"p_flags","","",80,N],[12,"p_align","","",80,N],[3,"Elf64_Phdr","","",N,N],[12,"p_type","","",81,N],[12,"p_flags","","",81,N],[12,"p_offset","","",81,N],[12,"p_vaddr","","",81,N],[12,"p_paddr","","",81,N],[12,"p_filesz","","",81,N],[12,"p_memsz","","",81,N],[12,"p_align","","",81,N],[3,"ucred","","",N,N],[12,"pid","","",82,N],[12,"uid","","",82,N],[12,"gid","","",82,N],[3,"mntent","","",N,N],[12,"mnt_fsname","","",83,N],[12,"mnt_dir","","",83,N],[12,"mnt_type","","",83,N],[12,"mnt_opts","","",83,N],[12,"mnt_freq","","",83,N],[12,"mnt_passno","","",83,N],[3,"posix_spawn_file_actions_t","","",N,N],[12,"__allocated","","",84,N],[12,"__used","","",84,N],[12,"__actions","","",84,N],[12,"__pad","","",84,N],[3,"posix_spawnattr_t","","",N,N],[12,"__flags","","",85,N],[12,"__pgrp","","",85,N],[12,"__sd","","",85,N],[12,"__ss","","",85,N],[12,"__sp","","",85,N],[12,"__policy","","",85,N],[12,"__pad","","",85,N],[3,"genlmsghdr","","",N,N],[12,"cmd","","",86,N],[12,"version","","",86,N],[12,"reserved","","",86,N],[3,"in6_pktinfo","","",N,N],[12,"ipi6_addr","","",87,N],[12,"ipi6_ifindex","","",87,N],[3,"arpd_request","","",N,N],[12,"req","","",88,N],[12,"ip","","",88,N],[12,"dev","","",88,N],[12,"stamp","","",88,N],[12,"updated","","",88,N],[12,"ha","","",88,N],[3,"aiocb","","",N,N],[12,"aio_fildes","","",89,N],[12,"aio_lio_opcode","","",89,N],[12,"aio_reqprio","","",89,N],[12,"aio_buf","","",89,N],[12,"aio_nbytes","","",89,N],[12,"aio_sigevent","","",89,N],[12,"__next_prio","","",89,N],[12,"__abs_prio","","",89,N],[12,"__policy","","",89,N],[12,"__error_code","","",89,N],[12,"__return_value","","",89,N],[12,"aio_offset","","",89,N],[12,"__glibc_reserved","","",89,N],[3,"__exit_status","","",N,N],[12,"e_termination","","",90,N],[12,"e_exit","","",90,N],[3,"__timeval","","",N,N],[12,"tv_sec","","",91,N],[12,"tv_usec","","",91,N],[3,"utmpx","","",N,N],[12,"ut_type","","",92,N],[12,"ut_pid","","",92,N],[12,"ut_line","","",92,N],[12,"ut_id","","",92,N],[12,"ut_user","","",92,N],[12,"ut_host","","",92,N],[12,"ut_exit","","",92,N],[12,"ut_session","","",92,N],[12,"ut_tv","","",92,N],[12,"ut_addr_v6","","",92,N],[12,"__glibc_reserved","","",92,N],[3,"sigaction","","",N,N],[12,"sa_sigaction","","",93,N],[12,"sa_mask","","",93,N],[12,"sa_flags","","",93,N],[12,"sa_restorer","","",93,N],[3,"stack_t","","",N,N],[12,"ss_sp","","",94,N],[12,"ss_flags","","",94,N],[12,"ss_size","","",94,N],[3,"siginfo_t","","",N,N],[12,"si_signo","","",95,N],[12,"si_errno","","",95,N],[12,"si_code","","",95,N],[12,"_pad","","",95,N],[12,"_align","","",95,N],[3,"glob64_t","","",N,N],[12,"gl_pathc","","",96,N],[12,"gl_pathv","","",96,N],[12,"gl_offs","","",96,N],[12,"gl_flags","","",96,N],[12,"__unused1","","",96,N],[12,"__unused2","","",96,N],[12,"__unused3","","",96,N],[12,"__unused4","","",96,N],[12,"__unused5","","",96,N],[3,"statfs","","",N,N],[12,"f_type","","",97,N],[12,"f_bsize","","",97,N],[12,"f_blocks","","",97,N],[12,"f_bfree","","",97,N],[12,"f_bavail","","",97,N],[12,"f_files","","",97,N],[12,"f_ffree","","",97,N],[12,"f_fsid","","",97,N],[12,"f_namelen","","",97,N],[12,"f_frsize","","",97,N],[12,"f_spare","","",97,N],[3,"msghdr","","",N,N],[12,"msg_name","","",98,N],[12,"msg_namelen","","",98,N],[12,"msg_iov","","",98,N],[12,"msg_iovlen","","",98,N],[12,"msg_control","","",98,N],[12,"msg_controllen","","",98,N],[12,"msg_flags","","",98,N],[3,"cmsghdr","","",N,N],[12,"cmsg_len","","",99,N],[12,"cmsg_level","","",99,N],[12,"cmsg_type","","",99,N],[3,"termios","","",N,N],[12,"c_iflag","","",100,N],[12,"c_oflag","","",100,N],[12,"c_cflag","","",100,N],[12,"c_lflag","","",100,N],[12,"c_line","","",100,N],[12,"c_cc","","",100,N],[12,"c_ispeed","","",100,N],[12,"c_ospeed","","",100,N],[3,"flock","","",N,N],[12,"l_type","","",101,N],[12,"l_whence","","",101,N],[12,"l_start","","",101,N],[12,"l_len","","",101,N],[12,"l_pid","","",101,N],[3,"sem_t","","",N,N],[12,"__size","","",102,N],[12,"__align","","",102,N],[3,"mallinfo","","",N,N],[12,"arena","","",103,N],[12,"ordblks","","",103,N],[12,"smblks","","",103,N],[12,"hblks","","",103,N],[12,"hblkhd","","",103,N],[12,"usmblks","","",103,N],[12,"fsmblks","","",103,N],[12,"uordblks","","",103,N],[12,"fordblks","","",103,N],[12,"keepcost","","",103,N],[3,"nlmsghdr","","",N,N],[12,"nlmsg_len","","",104,N],[12,"nlmsg_type","","",104,N],[12,"nlmsg_flags","","",104,N],[12,"nlmsg_seq","","",104,N],[12,"nlmsg_pid","","",104,N],[3,"nlmsgerr","","",N,N],[12,"error","","",105,N],[12,"msg","","",105,N],[3,"nl_pktinfo","","",N,N],[12,"group","","",106,N],[3,"nl_mmap_req","","",N,N],[12,"nm_block_size","","",107,N],[12,"nm_block_nr","","",107,N],[12,"nm_frame_size","","",107,N],[12,"nm_frame_nr","","",107,N],[3,"nl_mmap_hdr","","",N,N],[12,"nm_status","","",108,N],[12,"nm_len","","",108,N],[12,"nm_group","","",108,N],[12,"nm_pid","","",108,N],[12,"nm_uid","","",108,N],[12,"nm_gid","","",108,N],[3,"nlattr","","",N,N],[12,"nla_len","","",109,N],[12,"nla_type","","",109,N],[3,"rtentry","","",N,N],[12,"rt_pad1","","",110,N],[12,"rt_dst","","",110,N],[12,"rt_gateway","","",110,N],[12,"rt_genmask","","",110,N],[12,"rt_flags","","",110,N],[12,"rt_pad2","","",110,N],[12,"rt_pad3","","",110,N],[12,"rt_tos","","",110,N],[12,"rt_class","","",110,N],[12,"rt_pad4","","",110,N],[12,"rt_metric","","",110,N],[12,"rt_dev","","",110,N],[12,"rt_mtu","","",110,N],[12,"rt_window","","",110,N],[12,"rt_irtt","","",110,N],[3,"sigset_t","","",N,N],[12,"__val","","",111,N],[3,"sysinfo","","",N,N],[12,"uptime","","",112,N],[12,"loads","","",112,N],[12,"totalram","","",112,N],[12,"freeram","","",112,N],[12,"sharedram","","",112,N],[12,"bufferram","","",112,N],[12,"totalswap","","",112,N],[12,"freeswap","","",112,N],[12,"procs","","",112,N],[12,"pad","","",112,N],[12,"totalhigh","","",112,N],[12,"freehigh","","",112,N],[12,"mem_unit","","",112,N],[12,"_f","","",112,N],[3,"msqid_ds","","",N,N],[12,"msg_perm","","",113,N],[12,"msg_stime","","",113,N],[12,"msg_rtime","","",113,N],[12,"msg_ctime","","",113,N],[12,"__msg_cbytes","","",113,N],[12,"msg_qnum","","",113,N],[12,"msg_qbytes","","",113,N],[12,"msg_lspid","","",113,N],[12,"msg_lrpid","","",113,N],[12,"__glibc_reserved4","","",113,N],[12,"__glibc_reserved5","","",113,N],[3,"stat","","",N,N],[12,"st_dev","","",114,N],[12,"st_ino","","",114,N],[12,"st_nlink","","",114,N],[12,"st_mode","","",114,N],[12,"st_uid","","",114,N],[12,"st_gid","","",114,N],[12,"__pad0","","",114,N],[12,"st_rdev","","",114,N],[12,"st_size","","",114,N],[12,"st_blksize","","",114,N],[12,"st_blocks","","",114,N],[12,"st_atime","","",114,N],[12,"st_atime_nsec","","",114,N],[12,"st_mtime","","",114,N],[12,"st_mtime_nsec","","",114,N],[12,"st_ctime","","",114,N],[12,"st_ctime_nsec","","",114,N],[12,"__unused","","",114,N],[3,"stat64","","",N,N],[12,"st_dev","","",115,N],[12,"st_ino","","",115,N],[12,"st_nlink","","",115,N],[12,"st_mode","","",115,N],[12,"st_uid","","",115,N],[12,"st_gid","","",115,N],[12,"__pad0","","",115,N],[12,"st_rdev","","",115,N],[12,"st_size","","",115,N],[12,"st_blksize","","",115,N],[12,"st_blocks","","",115,N],[12,"st_atime","","",115,N],[12,"st_atime_nsec","","",115,N],[12,"st_mtime","","",115,N],[12,"st_mtime_nsec","","",115,N],[12,"st_ctime","","",115,N],[12,"st_ctime_nsec","","",115,N],[12,"__reserved","","",115,N],[3,"statfs64","","",N,N],[12,"f_type","","",116,N],[12,"f_bsize","","",116,N],[12,"f_blocks","","",116,N],[12,"f_bfree","","",116,N],[12,"f_bavail","","",116,N],[12,"f_files","","",116,N],[12,"f_ffree","","",116,N],[12,"f_fsid","","",116,N],[12,"f_namelen","","",116,N],[12,"f_frsize","","",116,N],[12,"f_flags","","",116,N],[12,"f_spare","","",116,N],[3,"statvfs64","","",N,N],[12,"f_bsize","","",117,N],[12,"f_frsize","","",117,N],[12,"f_blocks","","",117,N],[12,"f_bfree","","",117,N],[12,"f_bavail","","",117,N],[12,"f_files","","",117,N],[12,"f_ffree","","",117,N],[12,"f_favail","","",117,N],[12,"f_fsid","","",117,N],[12,"f_flag","","",117,N],[12,"f_namemax","","",117,N],[12,"__f_spare","","",117,N],[3,"pthread_attr_t","","",N,N],[12,"__size","","",118,N],[3,"_libc_fpxreg","","",N,N],[12,"significand","","",119,N],[12,"exponent","","",119,N],[12,"__private","","",119,N],[3,"_libc_xmmreg","","",N,N],[12,"element","","",120,N],[3,"_libc_fpstate","","",N,N],[12,"cwd","","",121,N],[12,"swd","","",121,N],[12,"ftw","","",121,N],[12,"fop","","",121,N],[12,"rip","","",121,N],[12,"rdp","","",121,N],[12,"mxcsr","","",121,N],[12,"mxcr_mask","","",121,N],[12,"_st","","",121,N],[12,"_xmm","","",121,N],[12,"__private","","",121,N],[3,"user_fpregs_struct","","",N,N],[12,"cwd","","",122,N],[12,"swd","","",122,N],[12,"ftw","","",122,N],[12,"fop","","",122,N],[12,"rip","","",122,N],[12,"rdp","","",122,N],[12,"mxcsr","","",122,N],[12,"mxcr_mask","","",122,N],[12,"st_space","","",122,N],[12,"xmm_space","","",122,N],[12,"padding","","",122,N],[3,"user_regs_struct","","",N,N],[12,"r15","","",123,N],[12,"r14","","",123,N],[12,"r13","","",123,N],[12,"r12","","",123,N],[12,"rbp","","",123,N],[12,"rbx","","",123,N],[12,"r11","","",123,N],[12,"r10","","",123,N],[12,"r9","","",123,N],[12,"r8","","",123,N],[12,"rax","","",123,N],[12,"rcx","","",123,N],[12,"rdx","","",123,N],[12,"rsi","","",123,N],[12,"rdi","","",123,N],[12,"orig_rax","","",123,N],[12,"rip","","",123,N],[12,"cs","","",123,N],[12,"eflags","","",123,N],[12,"rsp","","",123,N],[12,"ss","","",123,N],[12,"fs_base","","",123,N],[12,"gs_base","","",123,N],[12,"ds","","",123,N],[12,"es","","",123,N],[12,"fs","","",123,N],[12,"gs","","",123,N],[3,"user","","",N,N],[12,"regs","","",124,N],[12,"u_fpvalid","","",124,N],[12,"i387","","",124,N],[12,"u_tsize","","",124,N],[12,"u_dsize","","",124,N],[12,"u_ssize","","",124,N],[12,"start_code","","",124,N],[12,"start_stack","","",124,N],[12,"signal","","",124,N],[12,"__reserved","","",124,N],[12,"u_ar0","","",124,N],[12,"u_fpstate","","",124,N],[12,"magic","","",124,N],[12,"u_comm","","",124,N],[12,"u_debugreg","","",124,N],[3,"mcontext_t","","",N,N],[12,"gregs","","",125,N],[12,"fpregs","","",125,N],[12,"__private","","",125,N],[3,"ucontext_t","","",N,N],[12,"uc_flags","","",126,N],[12,"uc_link","","",126,N],[12,"uc_stack","","",126,N],[12,"uc_mcontext","","",126,N],[12,"uc_sigmask","","",126,N],[12,"__private","","",126,N],[3,"ipc_perm","","",N,N],[12,"__key","","",127,N],[12,"uid","","",127,N],[12,"gid","","",127,N],[12,"cuid","","",127,N],[12,"cgid","","",127,N],[12,"mode","","",127,N],[12,"__pad1","","",127,N],[12,"__seq","","",127,N],[12,"__pad2","","",127,N],[12,"__unused1","","",127,N],[12,"__unused2","","",127,N],[3,"shmid_ds","","",N,N],[12,"shm_perm","","",128,N],[12,"shm_segsz","","",128,N],[12,"shm_atime","","",128,N],[12,"shm_dtime","","",128,N],[12,"shm_ctime","","",128,N],[12,"shm_cpid","","",128,N],[12,"shm_lpid","","",128,N],[12,"shm_nattch","","",128,N],[12,"__unused4","","",128,N],[12,"__unused5","","",128,N],[3,"termios2","","",N,N],[12,"c_iflag","","",129,N],[12,"c_oflag","","",129,N],[12,"c_cflag","","",129,N],[12,"c_lflag","","",129,N],[12,"c_line","","",129,N],[12,"c_cc","","",129,N],[12,"c_ispeed","","",129,N],[12,"c_ospeed","","",129,N],[3,"statvfs","","",N,N],[12,"f_bsize","","",130,N],[12,"f_frsize","","",130,N],[12,"f_blocks","","",130,N],[12,"f_bfree","","",130,N],[12,"f_bavail","","",130,N],[12,"f_files","","",130,N],[12,"f_ffree","","",130,N],[12,"f_favail","","",130,N],[12,"f_fsid","","",130,N],[12,"f_flag","","",130,N],[12,"f_namemax","","",130,N],[12,"__f_spare","","",130,N],[4,"c_void","","",N,N],[13,"__variant1","","",131,N],[13,"__variant2","","",131,N],[4,"FILE","","",N,N],[4,"fpos_t","","",N,N],[4,"DIR","","",N,N],[4,"locale_t","","",N,N],[4,"timezone","","",N,N],[4,"fpos64_t","","",N,N],[5,"FD_CLR","","",N,N],[5,"FD_ISSET","","",N,N],[5,"FD_SET","","",N,N],[5,"FD_ZERO","","",N,N],[5,"WIFSTOPPED","","",N,[[["c_int"]],["bool"]]],[5,"WSTOPSIG","","",N,[[["c_int"]],["c_int"]]],[5,"WIFCONTINUED","","",N,[[["c_int"]],["bool"]]],[5,"WIFSIGNALED","","",N,[[["c_int"]],["bool"]]],[5,"WTERMSIG","","",N,[[["c_int"]],["c_int"]]],[5,"WIFEXITED","","",N,[[["c_int"]],["bool"]]],[5,"WEXITSTATUS","","",N,[[["c_int"]],["c_int"]]],[5,"WCOREDUMP","","",N,[[["c_int"]],["bool"]]],[5,"QCMD","","",N,[[["c_int"],["c_int"]],["c_int"]]],[5,"IPOPT_COPIED","","",N,[[["u8"]],["u8"]]],[5,"IPOPT_CLASS","","",N,[[["u8"]],["u8"]]],[5,"IPOPT_NUMBER","","",N,[[["u8"]],["u8"]]],[5,"CPU_ZERO","","",N,N],[5,"CPU_SET","","",N,N],[5,"CPU_CLR","","",N,N],[5,"CPU_ISSET","","",N,[[["usize"],["cpu_set_t"]],["bool"]]],[5,"CPU_EQUAL","","",N,[[["cpu_set_t"],["cpu_set_t"]],["bool"]]],[5,"major","","",N,[[["dev_t"]],["c_uint"]]],[5,"minor","","",N,[[["dev_t"]],["c_uint"]]],[5,"makedev","","",N,[[["c_uint"],["c_uint"]],["dev_t"]]],[5,"IPTOS_TOS","","",N,[[["u8"]],["u8"]]],[5,"IPTOS_PREC","","",N,[[["u8"]],["u8"]]],[5,"RT_TOS","","",N,[[["u8"]],["u8"]]],[5,"RT_ADDRCLASS","","",N,[[["u32"]],["u32"]]],[5,"RT_LOCALADDR","","",N,[[["u32"]],["bool"]]],[5,"NLA_ALIGN","","",N,[[["c_int"]],["c_int"]]],[5,"isalnum","","",N,N],[5,"isalpha","","",N,N],[5,"iscntrl","","",N,N],[5,"isdigit","","",N,N],[5,"isgraph","","",N,N],[5,"islower","","",N,N],[5,"isprint","","",N,N],[5,"ispunct","","",N,N],[5,"isspace","","",N,N],[5,"isupper","","",N,N],[5,"isxdigit","","",N,N],[5,"tolower","","",N,N],[5,"toupper","","",N,N],[5,"fopen","","",N,N],[5,"freopen","","",N,N],[5,"fflush","","",N,N],[5,"fclose","","",N,N],[5,"remove","","",N,N],[5,"rename","","",N,N],[5,"tmpfile","","",N,N],[5,"setvbuf","","",N,N],[5,"setbuf","","",N,N],[5,"getchar","","",N,N],[5,"putchar","","",N,N],[5,"fgetc","","",N,N],[5,"fgets","","",N,N],[5,"fputc","","",N,N],[5,"fputs","","",N,N],[5,"puts","","",N,N],[5,"ungetc","","",N,N],[5,"fread","","",N,N],[5,"fwrite","","",N,N],[5,"fseek","","",N,N],[5,"ftell","","",N,N],[5,"rewind","","",N,N],[5,"fgetpos","","",N,N],[5,"fsetpos","","",N,N],[5,"feof","","",N,N],[5,"ferror","","",N,N],[5,"perror","","",N,N],[5,"atoi","","",N,N],[5,"strtod","","",N,N],[5,"strtol","","",N,N],[5,"strtoul","","",N,N],[5,"calloc","","",N,N],[5,"malloc","","",N,N],[5,"realloc","","",N,N],[5,"free","","",N,N],[5,"abort","","",N,N],[5,"exit","","",N,N],[5,"_exit","","",N,N],[5,"atexit","","",N,N],[5,"system","","",N,N],[5,"getenv","","",N,N],[5,"strcpy","","",N,N],[5,"strncpy","","",N,N],[5,"strcat","","",N,N],[5,"strncat","","",N,N],[5,"strcmp","","",N,N],[5,"strncmp","","",N,N],[5,"strcoll","","",N,N],[5,"strchr","","",N,N],[5,"strrchr","","",N,N],[5,"strspn","","",N,N],[5,"strcspn","","",N,N],[5,"strdup","","",N,N],[5,"strpbrk","","",N,N],[5,"strstr","","",N,N],[5,"strlen","","",N,N],[5,"strnlen","","",N,N],[5,"strerror","","",N,N],[5,"strtok","","",N,N],[5,"strxfrm","","",N,N],[5,"wcslen","","",N,N],[5,"wcstombs","","",N,N],[5,"memchr","","",N,N],[5,"memcmp","","",N,N],[5,"memcpy","","",N,N],[5,"memmove","","",N,N],[5,"memset","","",N,N],[5,"abs","","",N,N],[5,"atof","","",N,N],[5,"labs","","",N,N],[5,"rand","","",N,N],[5,"srand","","",N,N],[5,"getpwnam","","",N,N],[5,"getpwuid","","",N,N],[5,"fprintf","","",N,N],[5,"printf","","",N,N],[5,"snprintf","","",N,N],[5,"sprintf","","",N,N],[5,"fscanf","","",N,N],[5,"scanf","","",N,N],[5,"sscanf","","",N,N],[5,"getchar_unlocked","","",N,N],[5,"putchar_unlocked","","",N,N],[5,"socket","","",N,N],[5,"connect","","",N,N],[5,"listen","","",N,N],[5,"accept","","",N,N],[5,"getpeername","","",N,N],[5,"getsockname","","",N,N],[5,"setsockopt","","",N,N],[5,"socketpair","","",N,N],[5,"sendto","","",N,N],[5,"shutdown","","",N,N],[5,"chmod","","",N,N],[5,"fchmod","","",N,N],[5,"fstat","","",N,N],[5,"mkdir","","",N,N],[5,"stat","","",N,N],[5,"pclose","","",N,N],[5,"fdopen","","",N,N],[5,"fileno","","",N,N],[5,"open","","",N,N],[5,"creat","","",N,N],[5,"fcntl","","",N,N],[5,"opendir","","",N,N],[5,"fdopendir","","",N,N],[5,"readdir","","",N,N],[5,"readdir_r","","",N,N],[5,"closedir","","",N,N],[5,"rewinddir","","",N,N],[5,"openat","","",N,N],[5,"fchmodat","","",N,N],[5,"fchown","","",N,N],[5,"fchownat","","",N,N],[5,"fstatat","","",N,N],[5,"linkat","","",N,N],[5,"mkdirat","","",N,N],[5,"readlinkat","","",N,N],[5,"renameat","","",N,N],[5,"symlinkat","","",N,N],[5,"unlinkat","","",N,N],[5,"access","","",N,N],[5,"alarm","","",N,N],[5,"chdir","","",N,N],[5,"fchdir","","",N,N],[5,"chown","","",N,N],[5,"lchown","","",N,N],[5,"close","","",N,N],[5,"dup","","",N,N],[5,"dup2","","",N,N],[5,"execl","","",N,N],[5,"execle","","",N,N],[5,"execlp","","",N,N],[5,"execv","","",N,N],[5,"execve","","",N,N],[5,"execvp","","",N,N],[5,"fork","","",N,N],[5,"fpathconf","","",N,N],[5,"getcwd","","",N,N],[5,"getegid","","",N,N],[5,"geteuid","","",N,N],[5,"getgid","","",N,N],[5,"getgroups","","",N,N],[5,"getlogin","","",N,N],[5,"getopt","","",N,N],[5,"getpgid","","",N,N],[5,"getpgrp","","",N,N],[5,"getpid","","",N,N],[5,"getppid","","",N,N],[5,"getuid","","",N,N],[5,"isatty","","",N,N],[5,"link","","",N,N],[5,"lseek","","",N,N],[5,"pathconf","","",N,N],[5,"pause","","",N,N],[5,"pipe","","",N,N],[5,"posix_memalign","","",N,N],[5,"read","","",N,N],[5,"rmdir","","",N,N],[5,"seteuid","","",N,N],[5,"setgid","","",N,N],[5,"setpgid","","",N,N],[5,"setsid","","",N,N],[5,"setuid","","",N,N],[5,"sleep","","",N,N],[5,"nanosleep","","",N,N],[5,"tcgetpgrp","","",N,N],[5,"tcsetpgrp","","",N,N],[5,"ttyname","","",N,N],[5,"unlink","","",N,N],[5,"wait","","",N,N],[5,"waitpid","","",N,N],[5,"write","","",N,N],[5,"pread","","",N,N],[5,"pwrite","","",N,N],[5,"umask","","",N,N],[5,"utime","","",N,N],[5,"kill","","",N,N],[5,"killpg","","",N,N],[5,"mlock","","",N,N],[5,"munlock","","",N,N],[5,"mlockall","","",N,N],[5,"munlockall","","",N,N],[5,"mmap","","",N,N],[5,"munmap","","",N,N],[5,"if_nametoindex","","",N,N],[5,"if_indextoname","","",N,N],[5,"lstat","","",N,N],[5,"fsync","","",N,N],[5,"setenv","","",N,N],[5,"unsetenv","","",N,N],[5,"symlink","","",N,N],[5,"ftruncate","","",N,N],[5,"signal","","",N,N],[5,"getrlimit","","",N,N],[5,"setrlimit","","",N,N],[5,"getrusage","","",N,N],[5,"realpath","","",N,N],[5,"flock","","",N,N],[5,"gettimeofday","","",N,N],[5,"times","","",N,N],[5,"pthread_self","","",N,N],[5,"pthread_join","","",N,N],[5,"pthread_exit","","",N,N],[5,"pthread_attr_init","","",N,N],[5,"pthread_attr_destroy","","",N,N],[5,"pthread_attr_setstacksize","","",N,N],[5,"pthread_attr_setdetachstate","","",N,N],[5,"pthread_detach","","",N,N],[5,"sched_yield","","",N,N],[5,"pthread_key_create","","",N,N],[5,"pthread_key_delete","","",N,N],[5,"pthread_getspecific","","",N,N],[5,"pthread_setspecific","","",N,N],[5,"pthread_mutex_init","","",N,N],[5,"pthread_mutex_destroy","","",N,N],[5,"pthread_mutex_lock","","",N,N],[5,"pthread_mutex_trylock","","",N,N],[5,"pthread_mutex_unlock","","",N,N],[5,"pthread_mutexattr_init","","",N,N],[5,"pthread_mutexattr_destroy","","",N,N],[5,"pthread_mutexattr_settype","","",N,N],[5,"pthread_cond_init","","",N,N],[5,"pthread_cond_wait","","",N,N],[5,"pthread_cond_timedwait","","",N,N],[5,"pthread_cond_signal","","",N,N],[5,"pthread_cond_broadcast","","",N,N],[5,"pthread_cond_destroy","","",N,N],[5,"pthread_condattr_init","","",N,N],[5,"pthread_condattr_destroy","","",N,N],[5,"pthread_rwlock_init","","",N,N],[5,"pthread_rwlock_destroy","","",N,N],[5,"pthread_rwlock_rdlock","","",N,N],[5,"pthread_rwlock_tryrdlock","","",N,N],[5,"pthread_rwlock_wrlock","","",N,N],[5,"pthread_rwlock_trywrlock","","",N,N],[5,"pthread_rwlock_unlock","","",N,N],[5,"pthread_rwlockattr_init","","",N,N],[5,"pthread_rwlockattr_destroy","","",N,N],[5,"strerror_r","","",N,N],[5,"getsockopt","","",N,N],[5,"raise","","",N,N],[5,"sigaction","","",N,N],[5,"utimes","","",N,N],[5,"dlopen","","",N,N],[5,"dlerror","","",N,N],[5,"dlsym","","",N,N],[5,"dlclose","","",N,N],[5,"dladdr","","",N,N],[5,"getaddrinfo","","",N,N],[5,"freeaddrinfo","","",N,N],[5,"gai_strerror","","",N,N],[5,"res_init","","",N,N],[5,"gmtime_r","","",N,N],[5,"localtime_r","","",N,N],[5,"mktime","","",N,N],[5,"time","","",N,N],[5,"gmtime","","",N,N],[5,"localtime","","",N,N],[5,"difftime","","",N,N],[5,"mknod","","",N,N],[5,"uname","","",N,N],[5,"gethostname","","",N,N],[5,"getservbyname","","",N,N],[5,"getprotobyname","","",N,N],[5,"getprotobynumber","","",N,N],[5,"chroot","","",N,N],[5,"usleep","","",N,N],[5,"send","","",N,N],[5,"recv","","",N,N],[5,"putenv","","",N,N],[5,"poll","","",N,N],[5,"select","","",N,N],[5,"setlocale","","",N,N],[5,"localeconv","","",N,N],[5,"sem_destroy","","",N,N],[5,"sem_wait","","",N,N],[5,"sem_trywait","","",N,N],[5,"sem_post","","",N,N],[5,"sem_init","","",N,N],[5,"statvfs","","",N,N],[5,"fstatvfs","","",N,N],[5,"readlink","","",N,N],[5,"sigemptyset","","",N,N],[5,"sigaddset","","",N,N],[5,"sigfillset","","",N,N],[5,"sigdelset","","",N,N],[5,"sigismember","","",N,N],[5,"sigprocmask","","",N,N],[5,"sigpending","","",N,N],[5,"timegm","","",N,N],[5,"getsid","","",N,N],[5,"sysconf","","",N,N],[5,"mkfifo","","",N,N],[5,"pselect","","",N,N],[5,"fseeko","","",N,N],[5,"ftello","","",N,N],[5,"tcdrain","","",N,N],[5,"cfgetispeed","","",N,N],[5,"cfgetospeed","","",N,N],[5,"cfmakeraw","","",N,N],[5,"cfsetispeed","","",N,N],[5,"cfsetospeed","","",N,N],[5,"cfsetspeed","","",N,N],[5,"tcgetattr","","",N,N],[5,"tcsetattr","","",N,N],[5,"tcflow","","",N,N],[5,"tcflush","","",N,N],[5,"tcgetsid","","",N,N],[5,"tcsendbreak","","",N,N],[5,"mkstemp","","",N,N],[5,"mkdtemp","","",N,N],[5,"tmpnam","","",N,N],[5,"openlog","","",N,N],[5,"closelog","","",N,N],[5,"setlogmask","","",N,N],[5,"syslog","","",N,N],[5,"nice","","",N,N],[5,"grantpt","","",N,N],[5,"posix_openpt","","",N,N],[5,"ptsname","","",N,N],[5,"unlockpt","","",N,N],[5,"fdatasync","","",N,N],[5,"mincore","","",N,N],[5,"clock_getres","","",N,N],[5,"clock_gettime","","",N,N],[5,"clock_settime","","",N,N],[5,"dirfd","","",N,N],[5,"pthread_getattr_np","","",N,N],[5,"pthread_attr_getstack","","",N,N],[5,"memalign","","",N,N],[5,"setgroups","","",N,N],[5,"pipe2","","",N,N],[5,"statfs","","",N,N],[5,"statfs64","","",N,N],[5,"fstatfs","","",N,N],[5,"fstatfs64","","",N,N],[5,"statvfs64","","",N,N],[5,"fstatvfs64","","",N,N],[5,"memrchr","","",N,N],[5,"posix_fadvise","","",N,N],[5,"futimens","","",N,N],[5,"utimensat","","",N,N],[5,"duplocale","","",N,N],[5,"freelocale","","",N,N],[5,"newlocale","","",N,N],[5,"uselocale","","",N,N],[5,"creat64","","",N,N],[5,"fstat64","","",N,N],[5,"fstatat64","","",N,N],[5,"ftruncate64","","",N,N],[5,"getrlimit64","","",N,N],[5,"lseek64","","",N,N],[5,"lstat64","","",N,N],[5,"mmap64","","",N,N],[5,"open64","","",N,N],[5,"openat64","","",N,N],[5,"pread64","","",N,N],[5,"preadv64","","",N,N],[5,"pwrite64","","",N,N],[5,"pwritev64","","",N,N],[5,"readdir64","","",N,N],[5,"readdir64_r","","",N,N],[5,"setrlimit64","","",N,N],[5,"stat64","","",N,N],[5,"truncate64","","",N,N],[5,"mknodat","","",N,N],[5,"pthread_condattr_getclock","","",N,N],[5,"pthread_condattr_setclock","","",N,N],[5,"pthread_condattr_setpshared","","",N,N],[5,"accept4","","",N,N],[5,"pthread_mutexattr_setpshared","","",N,N],[5,"pthread_rwlockattr_getpshared","","",N,N],[5,"pthread_rwlockattr_setpshared","","",N,N],[5,"ptsname_r","","",N,N],[5,"clearenv","","",N,N],[5,"waitid","","",N,N],[5,"setreuid","","",N,N],[5,"setregid","","",N,N],[5,"getresuid","","",N,N],[5,"getresgid","","",N,N],[5,"acct","","",N,N],[5,"brk","","",N,N],[5,"sbrk","","",N,N],[5,"vfork","","",N,N],[5,"setresgid","","",N,N],[5,"setresuid","","",N,N],[5,"wait4","","",N,N],[5,"openpty","","",N,N],[5,"execvpe","","",N,N],[5,"fexecve","","",N,N],[5,"getifaddrs","","",N,N],[5,"freeifaddrs","","",N,N],[5,"bind","","",N,N],[5,"writev","","",N,N],[5,"readv","","",N,N],[5,"sendmsg","","",N,N],[5,"recvmsg","","",N,N],[5,"aio_read","","",N,N],[5,"aio_write","","",N,N],[5,"aio_fsync","","",N,N],[5,"aio_error","","",N,N],[5,"aio_return","","",N,N],[5,"aio_suspend","","",N,N],[5,"aio_cancel","","",N,N],[5,"lio_listio","","",N,N],[5,"lutimes","","",N,N],[5,"setpwent","","",N,N],[5,"endpwent","","",N,N],[5,"getpwent","","",N,N],[5,"setgrent","","",N,N],[5,"endgrent","","",N,N],[5,"getgrent","","",N,N],[5,"setspent","","",N,N],[5,"endspent","","",N,N],[5,"getspent","","",N,N],[5,"getspnam","","",N,N],[5,"shm_open","","",N,N],[5,"shmget","","",N,N],[5,"shmat","","",N,N],[5,"shmdt","","",N,N],[5,"shmctl","","",N,N],[5,"ftok","","",N,N],[5,"semget","","",N,N],[5,"semop","","",N,N],[5,"semctl","","",N,N],[5,"msgctl","","",N,N],[5,"msgget","","",N,N],[5,"msgrcv","","",N,N],[5,"msgsnd","","",N,N],[5,"mprotect","","",N,N],[5,"__errno_location","","",N,N],[5,"fopen64","","",N,N],[5,"freopen64","","",N,N],[5,"tmpfile64","","",N,N],[5,"fgetpos64","","",N,N],[5,"fsetpos64","","",N,N],[5,"fseeko64","","",N,N],[5,"ftello64","","",N,N],[5,"fallocate","","",N,N],[5,"posix_fallocate","","",N,N],[5,"readahead","","",N,N],[5,"getxattr","","",N,N],[5,"lgetxattr","","",N,N],[5,"fgetxattr","","",N,N],[5,"setxattr","","",N,N],[5,"lsetxattr","","",N,N],[5,"fsetxattr","","",N,N],[5,"listxattr","","",N,N],[5,"llistxattr","","",N,N],[5,"flistxattr","","",N,N],[5,"removexattr","","",N,N],[5,"lremovexattr","","",N,N],[5,"fremovexattr","","",N,N],[5,"signalfd","","",N,N],[5,"timerfd_create","","",N,N],[5,"timerfd_gettime","","",N,N],[5,"timerfd_settime","","",N,N],[5,"pwritev","","",N,N],[5,"preadv","","",N,N],[5,"quotactl","","",N,N],[5,"mq_open","","",N,N],[5,"mq_close","","",N,N],[5,"mq_unlink","","",N,N],[5,"mq_receive","","",N,N],[5,"mq_send","","",N,N],[5,"mq_getattr","","",N,N],[5,"mq_setattr","","",N,N],[5,"epoll_pwait","","",N,N],[5,"dup3","","",N,N],[5,"mkostemp","","",N,N],[5,"mkostemps","","",N,N],[5,"sigtimedwait","","",N,N],[5,"sigwaitinfo","","",N,N],[5,"nl_langinfo_l","","",N,N],[5,"getnameinfo","","",N,N],[5,"pthread_setschedprio","","",N,N],[5,"prlimit","","",N,N],[5,"prlimit64","","",N,N],[5,"getloadavg","","",N,N],[5,"process_vm_readv","","",N,N],[5,"process_vm_writev","","",N,N],[5,"reboot","","",N,N],[5,"setfsgid","","",N,N],[5,"setfsuid","","",N,N],[5,"mkfifoat","","",N,N],[5,"if_nameindex","","",N,N],[5,"if_freenameindex","","",N,N],[5,"sync_file_range","","",N,N],[5,"mremap","","",N,N],[5,"glob","","",N,N],[5,"globfree","","",N,N],[5,"posix_madvise","","",N,N],[5,"shm_unlink","","",N,N],[5,"seekdir","","",N,N],[5,"telldir","","",N,N],[5,"madvise","","",N,N],[5,"msync","","",N,N],[5,"remap_file_pages","","",N,N],[5,"recvfrom","","",N,N],[5,"mkstemps","","",N,N],[5,"futimes","","",N,N],[5,"nl_langinfo","","",N,N],[5,"getdomainname","","",N,N],[5,"setdomainname","","",N,N],[5,"vhangup","","",N,N],[5,"sendmmsg","","",N,N],[5,"recvmmsg","","",N,N],[5,"sync","","",N,N],[5,"syscall","","",N,N],[5,"sched_getaffinity","","",N,N],[5,"sched_setaffinity","","",N,N],[5,"epoll_create","","",N,N],[5,"epoll_create1","","",N,N],[5,"epoll_wait","","",N,N],[5,"epoll_ctl","","",N,N],[5,"pthread_getschedparam","","",N,N],[5,"unshare","","",N,N],[5,"umount","","",N,N],[5,"sched_get_priority_max","","",N,N],[5,"tee","","",N,N],[5,"settimeofday","","",N,N],[5,"splice","","",N,N],[5,"eventfd","","",N,N],[5,"sched_rr_get_interval","","",N,N],[5,"sem_timedwait","","",N,N],[5,"sem_getvalue","","",N,N],[5,"sched_setparam","","",N,N],[5,"setns","","",N,N],[5,"swapoff","","",N,N],[5,"vmsplice","","",N,N],[5,"mount","","",N,N],[5,"personality","","",N,N],[5,"prctl","","",N,N],[5,"sched_getparam","","",N,N],[5,"ppoll","","",N,N],[5,"pthread_mutex_timedlock","","",N,N],[5,"clone","","",N,N],[5,"sched_getscheduler","","",N,N],[5,"clock_nanosleep","","",N,N],[5,"pthread_attr_getguardsize","","",N,N],[5,"sethostname","","",N,N],[5,"sched_get_priority_min","","",N,N],[5,"pthread_condattr_getpshared","","",N,N],[5,"sysinfo","","",N,N],[5,"umount2","","",N,N],[5,"pthread_setschedparam","","",N,N],[5,"swapon","","",N,N],[5,"sched_setscheduler","","",N,N],[5,"sendfile","","",N,N],[5,"sigsuspend","","",N,N],[5,"getgrgid_r","","",N,N],[5,"sigaltstack","","",N,N],[5,"sem_close","","",N,N],[5,"getdtablesize","","",N,N],[5,"getgrnam_r","","",N,N],[5,"initgroups","","",N,N],[5,"pthread_sigmask","","",N,N],[5,"sem_open","","",N,N],[5,"getgrnam","","",N,N],[5,"pthread_cancel","","",N,N],[5,"pthread_kill","","",N,N],[5,"sem_unlink","","",N,N],[5,"daemon","","",N,N],[5,"getpwnam_r","","",N,N],[5,"getpwuid_r","","",N,N],[5,"sigwait","","",N,N],[5,"pthread_atfork","","",N,N],[5,"getgrgid","","",N,N],[5,"getgrouplist","","",N,N],[5,"pthread_mutexattr_getpshared","","",N,N],[5,"popen","","",N,N],[5,"faccessat","","",N,N],[5,"pthread_create","","",N,N],[5,"dl_iterate_phdr","","",N,N],[5,"setmntent","","",N,N],[5,"getmntent","","",N,N],[5,"addmntent","","",N,N],[5,"endmntent","","",N,N],[5,"hasmntopt","","",N,N],[5,"posix_spawn","","",N,N],[5,"posix_spawnp","","",N,N],[5,"posix_spawnattr_init","","",N,N],[5,"posix_spawnattr_destroy","","",N,N],[5,"posix_spawnattr_getsigdefault","","",N,N],[5,"posix_spawnattr_setsigdefault","","",N,N],[5,"posix_spawnattr_getsigmask","","",N,N],[5,"posix_spawnattr_setsigmask","","",N,N],[5,"posix_spawnattr_getflags","","",N,N],[5,"posix_spawnattr_setflags","","",N,N],[5,"posix_spawnattr_getpgroup","","",N,N],[5,"posix_spawnattr_setpgroup","","",N,N],[5,"posix_spawnattr_getschedpolicy","","",N,N],[5,"posix_spawnattr_setschedpolicy","","",N,N],[5,"posix_spawnattr_getschedparam","","",N,N],[5,"posix_spawnattr_setschedparam","","",N,N],[5,"posix_spawn_file_actions_init","","",N,N],[5,"posix_spawn_file_actions_destroy","","",N,N],[5,"posix_spawn_file_actions_addopen","","",N,N],[5,"posix_spawn_file_actions_addclose","","",N,N],[5,"posix_spawn_file_actions_adddup2","","",N,N],[5,"fread_unlocked","","",N,N],[5,"utmpxname","","",N,N],[5,"getutxent","","",N,N],[5,"getutxid","","",N,N],[5,"getutxline","","",N,N],[5,"pututxline","","",N,N],[5,"setutxent","","",N,N],[5,"endutxent","","",N,N],[5,"getpt","","",N,N],[5,"ioctl","","",N,N],[5,"backtrace","","",N,N],[5,"glob64","","",N,N],[5,"globfree64","","",N,N],[5,"ptrace","","",N,N],[5,"pthread_attr_getaffinity_np","","",N,N],[5,"pthread_attr_setaffinity_np","","",N,N],[5,"getpriority","","",N,N],[5,"setpriority","","",N,N],[5,"pthread_getaffinity_np","","",N,N],[5,"pthread_setaffinity_np","","",N,N],[5,"pthread_rwlockattr_getkind_np","","",N,N],[5,"pthread_rwlockattr_setkind_np","","",N,N],[5,"sched_getcpu","","",N,N],[5,"mallinfo","","",N,N],[5,"malloc_usable_size","","",N,N],[5,"getauxval","","",N,N],[5,"getpwent_r","","",N,N],[5,"getgrent_r","","",N,N],[5,"getcontext","","",N,N],[5,"setcontext","","",N,N],[5,"makecontext","","",N,N],[5,"swapcontext","","",N,N],[5,"iopl","","",N,N],[5,"ioperm","","",N,N],[5,"sysctl","","",N,N],[0,"macros","","",N,N],[0,"dox","","",N,N],[0,"imp","libc::dox","",N,N],[4,"Option","libc::dox::imp","The `Option` type. See the module level documentation for more.",N,N],[13,"None","","No value",132,N],[13,"Some","","Some value `T`",132,N],[8,"Clone","","A common trait for the ability to explicitly duplicate an object.",N,N],[10,"clone","","Returns a copy of the value.",133,[[["self"]],["self"]]],[11,"clone_from","","Performs copy-assignment from `source`.",133,N],[8,"Copy","","Types whose values can be duplicated simply by copying bits.",N,N],[0,"mem","","Basic functions for dealing with memory.",N,N],[5,"forget","libc::dox::imp::mem","Takes ownership and \"forgets\" about the value without running its destructor.",N,N],[5,"size_of","","Returns the size of a type in bytes.",N,[[],["usize"]]],[5,"size_of_val","","Returns the size of the pointed-to value in bytes.",N,[[["t"]],["usize"]]],[5,"min_align_of","","Returns the [ABI]-required minimum alignment of a type.",N,[[],["usize"]]],[5,"min_align_of_val","","Returns the [ABI]-required minimum alignment of the type of the value that `val` points to.",N,[[["t"]],["usize"]]],[5,"align_of","","Returns the [ABI]-required minimum alignment of a type.",N,[[],["usize"]]],[5,"align_of_val","","Returns the [ABI]-required minimum alignment of the type of the value that `val` points to.",N,[[["t"]],["usize"]]],[5,"needs_drop","","Returns whether dropping values of type `T` matters.",N,[[],["bool"]]],[5,"zeroed","","Creates a value whose bytes are all zero.",N,[[],["t"]]],[5,"uninitialized","","Bypasses Rust's normal memory-initialization checks by pretending to produce a value of type `T`, while doing nothing at all.",N,[[],["t"]]],[5,"swap","","Swaps the values at two mutable locations, without deinitializing either one.",N,N],[5,"replace","","Moves `src` into the referenced `dest`, returning the previous `dest` value.",N,[[["t"],["t"]],["t"]]],[5,"drop","","Disposes of a value.",N,N],[5,"transmute_copy","","Interprets `src` as having type `&U`, and then reads `src` without moving the contained value.",N,[[["t"]],["u"]]],[3,"Discriminant","","Opaque type representing the discriminant of an enum.",N,N],[12,"0","","",134,N],[12,"1","","",134,N],[5,"discriminant","","Returns a value uniquely identifying the enum variant in `v`.",N,[[["t"]],["discriminant"]]],[3,"ManuallyDrop","","A wrapper to inhibit compiler from automatically calling `T`’s destructor.",N,N],[12,"value","","",135,N],[5,"transmute","","Reinterprets the bits of a value of one type as another type.",N,[[["t"]],["u"]]],[0,"unix","libc","Definitions found commonly among almost all Unix derivatives",N,N],[3,"group","libc::unix","",N,N],[12,"gr_name","","",0,N],[12,"gr_passwd","","",0,N],[12,"gr_gid","","",0,N],[12,"gr_mem","","",0,N],[3,"utimbuf","","",N,N],[12,"actime","","",1,N],[12,"modtime","","",1,N],[3,"timeval","","",N,N],[12,"tv_sec","","",2,N],[12,"tv_usec","","",2,N],[3,"timespec","","",N,N],[12,"tv_sec","","",3,N],[12,"tv_nsec","","",3,N],[3,"rlimit","","",N,N],[12,"rlim_cur","","",4,N],[12,"rlim_max","","",4,N],[3,"rusage","","",N,N],[12,"ru_utime","","",5,N],[12,"ru_stime","","",5,N],[12,"ru_maxrss","","",5,N],[12,"ru_ixrss","","",5,N],[12,"ru_idrss","","",5,N],[12,"ru_isrss","","",5,N],[12,"ru_minflt","","",5,N],[12,"ru_majflt","","",5,N],[12,"ru_nswap","","",5,N],[12,"ru_inblock","","",5,N],[12,"ru_oublock","","",5,N],[12,"ru_msgsnd","","",5,N],[12,"ru_msgrcv","","",5,N],[12,"ru_nsignals","","",5,N],[12,"ru_nvcsw","","",5,N],[12,"ru_nivcsw","","",5,N],[3,"in_addr","","",N,N],[12,"s_addr","","",6,N],[3,"in6_addr","","",N,N],[12,"s6_addr","","",7,N],[12,"__align","","",7,N],[3,"ip_mreq","","",N,N],[12,"imr_multiaddr","","",8,N],[12,"imr_interface","","",8,N],[3,"ipv6_mreq","","",N,N],[12,"ipv6mr_multiaddr","","",9,N],[12,"ipv6mr_interface","","",9,N],[3,"hostent","","",N,N],[12,"h_name","","",10,N],[12,"h_aliases","","",10,N],[12,"h_addrtype","","",10,N],[12,"h_length","","",10,N],[12,"h_addr_list","","",10,N],[3,"iovec","","",N,N],[12,"iov_base","","",11,N],[12,"iov_len","","",11,N],[3,"pollfd","","",N,N],[12,"fd","","",12,N],[12,"events","","",12,N],[12,"revents","","",12,N],[3,"winsize","","",N,N],[12,"ws_row","","",13,N],[12,"ws_col","","",13,N],[12,"ws_xpixel","","",13,N],[12,"ws_ypixel","","",13,N],[3,"linger","","",N,N],[12,"l_onoff","","",14,N],[12,"l_linger","","",14,N],[3,"sigval","","",N,N],[12,"sival_ptr","","",15,N],[3,"itimerval","","",N,N],[12,"it_interval","","",16,N],[12,"it_value","","",16,N],[3,"tms","","",N,N],[12,"tms_utime","","",17,N],[12,"tms_stime","","",17,N],[12,"tms_cutime","","",17,N],[12,"tms_cstime","","",17,N],[3,"servent","","",N,N],[12,"s_name","","",18,N],[12,"s_aliases","","",18,N],[12,"s_port","","",18,N],[12,"s_proto","","",18,N],[3,"protoent","","",N,N],[12,"p_name","","",19,N],[12,"p_aliases","","",19,N],[12,"p_proto","","",19,N],[4,"DIR","","",N,N],[4,"locale_t","","",N,N],[5,"getpwnam","","",N,N],[5,"getpwuid","","",N,N],[5,"fprintf","","",N,N],[5,"printf","","",N,N],[5,"snprintf","","",N,N],[5,"sprintf","","",N,N],[5,"fscanf","","",N,N],[5,"scanf","","",N,N],[5,"sscanf","","",N,N],[5,"getchar_unlocked","","",N,N],[5,"putchar_unlocked","","",N,N],[5,"socket","","",N,N],[5,"connect","","",N,N],[5,"listen","","",N,N],[5,"accept","","",N,N],[5,"getpeername","","",N,N],[5,"getsockname","","",N,N],[5,"setsockopt","","",N,N],[5,"socketpair","","",N,N],[5,"sendto","","",N,N],[5,"shutdown","","",N,N],[5,"chmod","","",N,N],[5,"fchmod","","",N,N],[5,"fstat","","",N,N],[5,"mkdir","","",N,N],[5,"stat","","",N,N],[5,"pclose","","",N,N],[5,"fdopen","","",N,N],[5,"fileno","","",N,N],[5,"open","","",N,N],[5,"creat","","",N,N],[5,"fcntl","","",N,N],[5,"opendir","","",N,N],[5,"fdopendir","","",N,N],[5,"readdir","","",N,N],[5,"readdir_r","","",N,N],[5,"closedir","","",N,N],[5,"rewinddir","","",N,N],[5,"openat","","",N,N],[5,"fchmodat","","",N,N],[5,"fchown","","",N,N],[5,"fchownat","","",N,N],[5,"fstatat","","",N,N],[5,"linkat","","",N,N],[5,"mkdirat","","",N,N],[5,"readlinkat","","",N,N],[5,"renameat","","",N,N],[5,"symlinkat","","",N,N],[5,"unlinkat","","",N,N],[5,"access","","",N,N],[5,"alarm","","",N,N],[5,"chdir","","",N,N],[5,"fchdir","","",N,N],[5,"chown","","",N,N],[5,"lchown","","",N,N],[5,"close","","",N,N],[5,"dup","","",N,N],[5,"dup2","","",N,N],[5,"execl","","",N,N],[5,"execle","","",N,N],[5,"execlp","","",N,N],[5,"execv","","",N,N],[5,"execve","","",N,N],[5,"execvp","","",N,N],[5,"fork","","",N,N],[5,"fpathconf","","",N,N],[5,"getcwd","","",N,N],[5,"getegid","","",N,N],[5,"geteuid","","",N,N],[5,"getgid","","",N,N],[5,"getgroups","","",N,N],[5,"getlogin","","",N,N],[5,"getopt","","",N,N],[5,"getpgid","","",N,N],[5,"getpgrp","","",N,N],[5,"getpid","","",N,N],[5,"getppid","","",N,N],[5,"getuid","","",N,N],[5,"isatty","","",N,N],[5,"link","","",N,N],[5,"lseek","","",N,N],[5,"pathconf","","",N,N],[5,"pause","","",N,N],[5,"pipe","","",N,N],[5,"posix_memalign","","",N,N],[5,"read","","",N,N],[5,"rmdir","","",N,N],[5,"seteuid","","",N,N],[5,"setgid","","",N,N],[5,"setpgid","","",N,N],[5,"setsid","","",N,N],[5,"setuid","","",N,N],[5,"sleep","","",N,N],[5,"nanosleep","","",N,N],[5,"tcgetpgrp","","",N,N],[5,"tcsetpgrp","","",N,N],[5,"ttyname","","",N,N],[5,"unlink","","",N,N],[5,"wait","","",N,N],[5,"waitpid","","",N,N],[5,"write","","",N,N],[5,"pread","","",N,N],[5,"pwrite","","",N,N],[5,"umask","","",N,N],[5,"utime","","",N,N],[5,"kill","","",N,N],[5,"killpg","","",N,N],[5,"mlock","","",N,N],[5,"munlock","","",N,N],[5,"mlockall","","",N,N],[5,"munlockall","","",N,N],[5,"mmap","","",N,N],[5,"munmap","","",N,N],[5,"if_nametoindex","","",N,N],[5,"if_indextoname","","",N,N],[5,"lstat","","",N,N],[5,"fsync","","",N,N],[5,"setenv","","",N,N],[5,"unsetenv","","",N,N],[5,"symlink","","",N,N],[5,"ftruncate","","",N,N],[5,"signal","","",N,N],[5,"getrlimit","","",N,N],[5,"setrlimit","","",N,N],[5,"getrusage","","",N,N],[5,"realpath","","",N,N],[5,"flock","","",N,N],[5,"gettimeofday","","",N,N],[5,"times","","",N,N],[5,"pthread_self","","",N,N],[5,"pthread_join","","",N,N],[5,"pthread_exit","","",N,N],[5,"pthread_attr_init","","",N,N],[5,"pthread_attr_destroy","","",N,N],[5,"pthread_attr_setstacksize","","",N,N],[5,"pthread_attr_setdetachstate","","",N,N],[5,"pthread_detach","","",N,N],[5,"sched_yield","","",N,N],[5,"pthread_key_create","","",N,N],[5,"pthread_key_delete","","",N,N],[5,"pthread_getspecific","","",N,N],[5,"pthread_setspecific","","",N,N],[5,"pthread_mutex_init","","",N,N],[5,"pthread_mutex_destroy","","",N,N],[5,"pthread_mutex_lock","","",N,N],[5,"pthread_mutex_trylock","","",N,N],[5,"pthread_mutex_unlock","","",N,N],[5,"pthread_mutexattr_init","","",N,N],[5,"pthread_mutexattr_destroy","","",N,N],[5,"pthread_mutexattr_settype","","",N,N],[5,"pthread_cond_init","","",N,N],[5,"pthread_cond_wait","","",N,N],[5,"pthread_cond_timedwait","","",N,N],[5,"pthread_cond_signal","","",N,N],[5,"pthread_cond_broadcast","","",N,N],[5,"pthread_cond_destroy","","",N,N],[5,"pthread_condattr_init","","",N,N],[5,"pthread_condattr_destroy","","",N,N],[5,"pthread_rwlock_init","","",N,N],[5,"pthread_rwlock_destroy","","",N,N],[5,"pthread_rwlock_rdlock","","",N,N],[5,"pthread_rwlock_tryrdlock","","",N,N],[5,"pthread_rwlock_wrlock","","",N,N],[5,"pthread_rwlock_trywrlock","","",N,N],[5,"pthread_rwlock_unlock","","",N,N],[5,"pthread_rwlockattr_init","","",N,N],[5,"pthread_rwlockattr_destroy","","",N,N],[5,"strerror_r","","",N,N],[5,"getsockopt","","",N,N],[5,"raise","","",N,N],[5,"sigaction","","",N,N],[5,"utimes","","",N,N],[5,"dlopen","","",N,N],[5,"dlerror","","",N,N],[5,"dlsym","","",N,N],[5,"dlclose","","",N,N],[5,"dladdr","","",N,N],[5,"getaddrinfo","","",N,N],[5,"freeaddrinfo","","",N,N],[5,"gai_strerror","","",N,N],[5,"res_init","","",N,N],[5,"gmtime_r","","",N,N],[5,"localtime_r","","",N,N],[5,"mktime","","",N,N],[5,"time","","",N,N],[5,"gmtime","","",N,N],[5,"localtime","","",N,N],[5,"difftime","","",N,N],[5,"mknod","","",N,N],[5,"uname","","",N,N],[5,"gethostname","","",N,N],[5,"getservbyname","","",N,N],[5,"getprotobyname","","",N,N],[5,"getprotobynumber","","",N,N],[5,"chroot","","",N,N],[5,"usleep","","",N,N],[5,"send","","",N,N],[5,"recv","","",N,N],[5,"putenv","","",N,N],[5,"poll","","",N,N],[5,"select","","",N,N],[5,"setlocale","","",N,N],[5,"localeconv","","",N,N],[5,"sem_destroy","","",N,N],[5,"sem_wait","","",N,N],[5,"sem_trywait","","",N,N],[5,"sem_post","","",N,N],[5,"sem_init","","",N,N],[5,"statvfs","","",N,N],[5,"fstatvfs","","",N,N],[5,"readlink","","",N,N],[5,"sigemptyset","","",N,N],[5,"sigaddset","","",N,N],[5,"sigfillset","","",N,N],[5,"sigdelset","","",N,N],[5,"sigismember","","",N,N],[5,"sigprocmask","","",N,N],[5,"sigpending","","",N,N],[5,"timegm","","",N,N],[5,"getsid","","",N,N],[5,"sysconf","","",N,N],[5,"mkfifo","","",N,N],[5,"pselect","","",N,N],[5,"fseeko","","",N,N],[5,"ftello","","",N,N],[5,"tcdrain","","",N,N],[5,"cfgetispeed","","",N,N],[5,"cfgetospeed","","",N,N],[5,"cfmakeraw","","",N,N],[5,"cfsetispeed","","",N,N],[5,"cfsetospeed","","",N,N],[5,"cfsetspeed","","",N,N],[5,"tcgetattr","","",N,N],[5,"tcsetattr","","",N,N],[5,"tcflow","","",N,N],[5,"tcflush","","",N,N],[5,"tcgetsid","","",N,N],[5,"tcsendbreak","","",N,N],[5,"mkstemp","","",N,N],[5,"mkdtemp","","",N,N],[5,"tmpnam","","",N,N],[5,"openlog","","",N,N],[5,"closelog","","",N,N],[5,"setlogmask","","",N,N],[5,"syslog","","",N,N],[5,"nice","","",N,N],[5,"grantpt","","",N,N],[5,"posix_openpt","","",N,N],[5,"ptsname","","",N,N],[5,"unlockpt","","",N,N],[0,"notbsd","","",N,N],[3,"sockaddr","libc::unix::notbsd","",N,N],[12,"sa_family","","",20,N],[12,"sa_data","","",20,N],[3,"sockaddr_in","","",N,N],[12,"sin_family","","",21,N],[12,"sin_port","","",21,N],[12,"sin_addr","","",21,N],[12,"sin_zero","","",21,N],[3,"sockaddr_in6","","",N,N],[12,"sin6_family","","",22,N],[12,"sin6_port","","",22,N],[12,"sin6_flowinfo","","",22,N],[12,"sin6_addr","","",22,N],[12,"sin6_scope_id","","",22,N],[3,"sockaddr_un","","",N,N],[12,"sun_family","","",23,N],[12,"sun_path","","",23,N],[3,"sockaddr_storage","","",N,N],[12,"ss_family","","",24,N],[12,"__ss_align","","",24,N],[12,"__ss_pad2","","",24,N],[3,"addrinfo","","",N,N],[12,"ai_flags","","",25,N],[12,"ai_family","","",25,N],[12,"ai_socktype","","",25,N],[12,"ai_protocol","","",25,N],[12,"ai_addrlen","","",25,N],[12,"ai_addr","","",25,N],[12,"ai_canonname","","",25,N],[12,"ai_next","","",25,N],[3,"sockaddr_nl","","",N,N],[12,"nl_family","","",26,N],[12,"nl_pad","","",26,N],[12,"nl_pid","","",26,N],[12,"nl_groups","","",26,N],[3,"sockaddr_ll","","",N,N],[12,"sll_family","","",27,N],[12,"sll_protocol","","",27,N],[12,"sll_ifindex","","",27,N],[12,"sll_hatype","","",27,N],[12,"sll_pkttype","","",27,N],[12,"sll_halen","","",27,N],[12,"sll_addr","","",27,N],[3,"fd_set","","",N,N],[12,"fds_bits","","",28,N],[3,"tm","","",N,N],[12,"tm_sec","","",29,N],[12,"tm_min","","",29,N],[12,"tm_hour","","",29,N],[12,"tm_mday","","",29,N],[12,"tm_mon","","",29,N],[12,"tm_year","","",29,N],[12,"tm_wday","","",29,N],[12,"tm_yday","","",29,N],[12,"tm_isdst","","",29,N],[12,"tm_gmtoff","","",29,N],[12,"tm_zone","","",29,N],[3,"sched_param","","",N,N],[12,"sched_priority","","",30,N],[3,"Dl_info","","",N,N],[12,"dli_fname","","",31,N],[12,"dli_fbase","","",31,N],[12,"dli_sname","","",31,N],[12,"dli_saddr","","",31,N],[3,"epoll_event","","",N,N],[12,"events","","",32,N],[12,"u64","","",32,N],[3,"utsname","","",N,N],[12,"sysname","","",33,N],[12,"nodename","","",33,N],[12,"release","","",33,N],[12,"version","","",33,N],[12,"machine","","",33,N],[12,"domainname","","",33,N],[3,"lconv","","",N,N],[12,"decimal_point","","",34,N],[12,"thousands_sep","","",34,N],[12,"grouping","","",34,N],[12,"int_curr_symbol","","",34,N],[12,"currency_symbol","","",34,N],[12,"mon_decimal_point","","",34,N],[12,"mon_thousands_sep","","",34,N],[12,"mon_grouping","","",34,N],[12,"positive_sign","","",34,N],[12,"negative_sign","","",34,N],[12,"int_frac_digits","","",34,N],[12,"frac_digits","","",34,N],[12,"p_cs_precedes","","",34,N],[12,"p_sep_by_space","","",34,N],[12,"n_cs_precedes","","",34,N],[12,"n_sep_by_space","","",34,N],[12,"p_sign_posn","","",34,N],[12,"n_sign_posn","","",34,N],[12,"int_p_cs_precedes","","",34,N],[12,"int_p_sep_by_space","","",34,N],[12,"int_n_cs_precedes","","",34,N],[12,"int_n_sep_by_space","","",34,N],[12,"int_p_sign_posn","","",34,N],[12,"int_n_sign_posn","","",34,N],[3,"sigevent","","",N,N],[12,"sigev_value","","",35,N],[12,"sigev_signo","","",35,N],[12,"sigev_notify","","",35,N],[12,"sigev_notify_thread_id","","",35,N],[12,"__unused1","","",35,N],[3,"in_pktinfo","","",N,N],[12,"ipi_ifindex","","",36,N],[12,"ipi_spec_dst","","",36,N],[12,"ipi_addr","","",36,N],[3,"ifaddrs","","",N,N],[12,"ifa_next","","",37,N],[12,"ifa_name","","",37,N],[12,"ifa_flags","","",37,N],[12,"ifa_addr","","",37,N],[12,"ifa_netmask","","",37,N],[12,"ifa_ifu","","",37,N],[12,"ifa_data","","",37,N],[3,"in6_rtmsg","","",N,N],[12,"rtmsg_dst","","",38,N],[12,"rtmsg_src","","",38,N],[12,"rtmsg_gateway","","",38,N],[12,"rtmsg_type","","",38,N],[12,"rtmsg_dst_len","","",38,N],[12,"rtmsg_src_len","","",38,N],[12,"rtmsg_metric","","",38,N],[12,"rtmsg_info","","",38,N],[12,"rtmsg_flags","","",38,N],[12,"rtmsg_ifindex","","",38,N],[3,"arpreq","","",N,N],[12,"arp_pa","","",39,N],[12,"arp_ha","","",39,N],[12,"arp_flags","","",39,N],[12,"arp_netmask","","",39,N],[12,"arp_dev","","",39,N],[3,"arpreq_old","","",N,N],[12,"arp_pa","","",40,N],[12,"arp_ha","","",40,N],[12,"arp_flags","","",40,N],[12,"arp_netmask","","",40,N],[3,"arphdr","","",N,N],[12,"ar_hrd","","",41,N],[12,"ar_pro","","",41,N],[12,"ar_hln","","",41,N],[12,"ar_pln","","",41,N],[12,"ar_op","","",41,N],[4,"timezone","","",N,N],[5,"FD_CLR","","",N,N],[5,"FD_ISSET","","",N,N],[5,"FD_SET","","",N,N],[5,"FD_ZERO","","",N,N],[5,"WIFSTOPPED","","",N,[[["c_int"]],["bool"]]],[5,"WSTOPSIG","","",N,[[["c_int"]],["c_int"]]],[5,"WIFCONTINUED","","",N,[[["c_int"]],["bool"]]],[5,"WIFSIGNALED","","",N,[[["c_int"]],["bool"]]],[5,"WTERMSIG","","",N,[[["c_int"]],["c_int"]]],[5,"WIFEXITED","","",N,[[["c_int"]],["bool"]]],[5,"WEXITSTATUS","","",N,[[["c_int"]],["c_int"]]],[5,"WCOREDUMP","","",N,[[["c_int"]],["bool"]]],[5,"QCMD","","",N,[[["c_int"],["c_int"]],["c_int"]]],[5,"IPOPT_COPIED","","",N,[[["u8"]],["u8"]]],[5,"IPOPT_CLASS","","",N,[[["u8"]],["u8"]]],[5,"IPOPT_NUMBER","","",N,[[["u8"]],["u8"]]],[5,"fdatasync","","",N,N],[5,"mincore","","",N,N],[5,"clock_getres","","",N,N],[5,"clock_gettime","","",N,N],[5,"clock_settime","","",N,N],[5,"dirfd","","",N,N],[5,"pthread_getattr_np","","",N,N],[5,"pthread_attr_getstack","","",N,N],[5,"memalign","","",N,N],[5,"setgroups","","",N,N],[5,"pipe2","","",N,N],[5,"statfs","","",N,N],[5,"statfs64","","",N,N],[5,"fstatfs","","",N,N],[5,"fstatfs64","","",N,N],[5,"statvfs64","","",N,N],[5,"fstatvfs64","","",N,N],[5,"memrchr","","",N,N],[5,"posix_fadvise","","",N,N],[5,"futimens","","",N,N],[5,"utimensat","","",N,N],[5,"duplocale","","",N,N],[5,"freelocale","","",N,N],[5,"newlocale","","",N,N],[5,"uselocale","","",N,N],[5,"creat64","","",N,N],[5,"fstat64","","",N,N],[5,"fstatat64","","",N,N],[5,"ftruncate64","","",N,N],[5,"getrlimit64","","",N,N],[5,"lseek64","","",N,N],[5,"lstat64","","",N,N],[5,"mmap64","","",N,N],[5,"open64","","",N,N],[5,"openat64","","",N,N],[5,"pread64","","",N,N],[5,"preadv64","","",N,N],[5,"pwrite64","","",N,N],[5,"pwritev64","","",N,N],[5,"readdir64","","",N,N],[5,"readdir64_r","","",N,N],[5,"setrlimit64","","",N,N],[5,"stat64","","",N,N],[5,"truncate64","","",N,N],[5,"mknodat","","",N,N],[5,"pthread_condattr_getclock","","",N,N],[5,"pthread_condattr_setclock","","",N,N],[5,"pthread_condattr_setpshared","","",N,N],[5,"accept4","","",N,N],[5,"pthread_mutexattr_setpshared","","",N,N],[5,"pthread_rwlockattr_getpshared","","",N,N],[5,"pthread_rwlockattr_setpshared","","",N,N],[5,"ptsname_r","","",N,N],[5,"clearenv","","",N,N],[5,"waitid","","",N,N],[5,"setreuid","","",N,N],[5,"setregid","","",N,N],[5,"getresuid","","",N,N],[5,"getresgid","","",N,N],[5,"acct","","",N,N],[5,"brk","","",N,N],[5,"sbrk","","",N,N],[5,"vfork","","",N,N],[5,"setresgid","","",N,N],[5,"setresuid","","",N,N],[5,"wait4","","",N,N],[5,"openpty","","",N,N],[5,"execvpe","","",N,N],[5,"fexecve","","",N,N],[5,"getifaddrs","","",N,N],[5,"freeifaddrs","","",N,N],[5,"bind","","",N,N],[5,"writev","","",N,N],[5,"readv","","",N,N],[5,"sendmsg","","",N,N],[5,"recvmsg","","",N,N],[0,"linux","","Linux-specific definitions for linux-like values",N,N],[3,"dirent","libc::unix::notbsd::linux","",N,N],[12,"d_ino","","",42,N],[12,"d_off","","",42,N],[12,"d_reclen","","",42,N],[12,"d_type","","",42,N],[12,"d_name","","",42,N],[3,"dirent64","","",N,N],[12,"d_ino","","",43,N],[12,"d_off","","",43,N],[12,"d_reclen","","",43,N],[12,"d_type","","",43,N],[12,"d_name","","",43,N],[3,"rlimit64","","",N,N],[12,"rlim_cur","","",44,N],[12,"rlim_max","","",44,N],[3,"glob_t","","",N,N],[12,"gl_pathc","","",45,N],[12,"gl_pathv","","",45,N],[12,"gl_offs","","",45,N],[12,"gl_flags","","",45,N],[12,"__unused1","","",45,N],[12,"__unused2","","",45,N],[12,"__unused3","","",45,N],[12,"__unused4","","",45,N],[12,"__unused5","","",45,N],[3,"pthread_mutex_t","","",N,N],[12,"__align","","",46,N],[12,"size","","",46,N],[3,"pthread_rwlock_t","","",N,N],[12,"__align","","",47,N],[12,"size","","",47,N],[3,"pthread_mutexattr_t","","",N,N],[12,"__align","","",48,N],[12,"size","","",48,N],[3,"pthread_rwlockattr_t","","",N,N],[12,"__align","","",49,N],[12,"size","","",49,N],[3,"pthread_cond_t","","",N,N],[12,"__align","","",50,N],[12,"size","","",50,N],[3,"pthread_condattr_t","","",N,N],[12,"__align","","",51,N],[12,"size","","",51,N],[3,"passwd","","",N,N],[12,"pw_name","","",52,N],[12,"pw_passwd","","",52,N],[12,"pw_uid","","",52,N],[12,"pw_gid","","",52,N],[12,"pw_gecos","","",52,N],[12,"pw_dir","","",52,N],[12,"pw_shell","","",52,N],[3,"spwd","","",N,N],[12,"sp_namp","","",53,N],[12,"sp_pwdp","","",53,N],[12,"sp_lstchg","","",53,N],[12,"sp_min","","",53,N],[12,"sp_max","","",53,N],[12,"sp_warn","","",53,N],[12,"sp_inact","","",53,N],[12,"sp_expire","","",53,N],[12,"sp_flag","","",53,N],[3,"dqblk","","",N,N],[12,"dqb_bhardlimit","","",54,N],[12,"dqb_bsoftlimit","","",54,N],[12,"dqb_curspace","","",54,N],[12,"dqb_ihardlimit","","",54,N],[12,"dqb_isoftlimit","","",54,N],[12,"dqb_curinodes","","",54,N],[12,"dqb_btime","","",54,N],[12,"dqb_itime","","",54,N],[12,"dqb_valid","","",54,N],[3,"signalfd_siginfo","","",N,N],[12,"ssi_signo","","",55,N],[12,"ssi_errno","","",55,N],[12,"ssi_code","","",55,N],[12,"ssi_pid","","",55,N],[12,"ssi_uid","","",55,N],[12,"ssi_fd","","",55,N],[12,"ssi_tid","","",55,N],[12,"ssi_band","","",55,N],[12,"ssi_overrun","","",55,N],[12,"ssi_trapno","","",55,N],[12,"ssi_status","","",55,N],[12,"ssi_int","","",55,N],[12,"ssi_ptr","","",55,N],[12,"ssi_utime","","",55,N],[12,"ssi_stime","","",55,N],[12,"ssi_addr","","",55,N],[12,"_pad","","",55,N],[3,"itimerspec","","",N,N],[12,"it_interval","","",56,N],[12,"it_value","","",56,N],[3,"fsid_t","","",N,N],[12,"__val","","",57,N],[3,"mq_attr","","",N,N],[12,"mq_flags","","",58,N],[12,"mq_maxmsg","","",58,N],[12,"mq_msgsize","","",58,N],[12,"mq_curmsgs","","",58,N],[12,"pad","","",58,N],[3,"packet_mreq","","",N,N],[12,"mr_ifindex","","",59,N],[12,"mr_type","","",59,N],[12,"mr_alen","","",59,N],[12,"mr_address","","",59,N],[3,"cpu_set_t","","",N,N],[12,"bits","","",60,N],[3,"if_nameindex","","",N,N],[12,"if_index","","",61,N],[12,"if_name","","",61,N],[3,"msginfo","","",N,N],[12,"msgpool","","",62,N],[12,"msgmap","","",62,N],[12,"msgmax","","",62,N],[12,"msgmnb","","",62,N],[12,"msgmni","","",62,N],[12,"msgssz","","",62,N],[12,"msgtql","","",62,N],[12,"msgseg","","",62,N],[3,"mmsghdr","","",N,N],[12,"msg_hdr","","",63,N],[12,"msg_len","","",63,N],[3,"sembuf","","",N,N],[12,"sem_num","","",64,N],[12,"sem_op","","",64,N],[12,"sem_flg","","",64,N],[3,"input_event","","",N,N],[12,"time","","",65,N],[12,"type_","","",65,N],[12,"code","","",65,N],[12,"value","","",65,N],[3,"input_id","","",N,N],[12,"bustype","","",66,N],[12,"vendor","","",66,N],[12,"product","","",66,N],[12,"version","","",66,N],[3,"input_absinfo","","",N,N],[12,"value","","",67,N],[12,"minimum","","",67,N],[12,"maximum","","",67,N],[12,"fuzz","","",67,N],[12,"flat","","",67,N],[12,"resolution","","",67,N],[3,"input_keymap_entry","","",N,N],[12,"flags","","",68,N],[12,"len","","",68,N],[12,"index","","",68,N],[12,"keycode","","",68,N],[12,"scancode","","",68,N],[3,"input_mask","","",N,N],[12,"type_","","",69,N],[12,"codes_size","","",69,N],[12,"codes_ptr","","",69,N],[3,"ff_replay","","",N,N],[12,"length","","",70,N],[12,"delay","","",70,N],[3,"ff_trigger","","",N,N],[12,"button","","",71,N],[12,"interval","","",71,N],[3,"ff_envelope","","",N,N],[12,"attack_length","","",72,N],[12,"attack_level","","",72,N],[12,"fade_length","","",72,N],[12,"fade_level","","",72,N],[3,"ff_constant_effect","","",N,N],[12,"level","","",73,N],[12,"envelope","","",73,N],[3,"ff_ramp_effect","","",N,N],[12,"start_level","","",74,N],[12,"end_level","","",74,N],[12,"envelope","","",74,N],[3,"ff_condition_effect","","",N,N],[12,"right_saturation","","",75,N],[12,"left_saturation","","",75,N],[12,"right_coeff","","",75,N],[12,"left_coeff","","",75,N],[12,"deadband","","",75,N],[12,"center","","",75,N],[3,"ff_periodic_effect","","",N,N],[12,"waveform","","",76,N],[12,"period","","",76,N],[12,"magnitude","","",76,N],[12,"offset","","",76,N],[12,"phase","","",76,N],[12,"envelope","","",76,N],[12,"custom_len","","",76,N],[12,"custom_data","","",76,N],[3,"ff_rumble_effect","","",N,N],[12,"strong_magnitude","","",77,N],[12,"weak_magnitude","","",77,N],[3,"ff_effect","","",N,N],[12,"type_","","",78,N],[12,"id","","",78,N],[12,"direction","","",78,N],[12,"trigger","","",78,N],[12,"replay","","",78,N],[12,"u","","",78,N],[3,"dl_phdr_info","","",N,N],[12,"dlpi_addr","","",79,N],[12,"dlpi_name","","",79,N],[12,"dlpi_phdr","","",79,N],[12,"dlpi_phnum","","",79,N],[12,"dlpi_adds","","",79,N],[12,"dlpi_subs","","",79,N],[12,"dlpi_tls_modid","","",79,N],[12,"dlpi_tls_data","","",79,N],[3,"Elf32_Phdr","","",N,N],[12,"p_type","","",80,N],[12,"p_offset","","",80,N],[12,"p_vaddr","","",80,N],[12,"p_paddr","","",80,N],[12,"p_filesz","","",80,N],[12,"p_memsz","","",80,N],[12,"p_flags","","",80,N],[12,"p_align","","",80,N],[3,"Elf64_Phdr","","",N,N],[12,"p_type","","",81,N],[12,"p_flags","","",81,N],[12,"p_offset","","",81,N],[12,"p_vaddr","","",81,N],[12,"p_paddr","","",81,N],[12,"p_filesz","","",81,N],[12,"p_memsz","","",81,N],[12,"p_align","","",81,N],[3,"ucred","","",N,N],[12,"pid","","",82,N],[12,"uid","","",82,N],[12,"gid","","",82,N],[3,"mntent","","",N,N],[12,"mnt_fsname","","",83,N],[12,"mnt_dir","","",83,N],[12,"mnt_type","","",83,N],[12,"mnt_opts","","",83,N],[12,"mnt_freq","","",83,N],[12,"mnt_passno","","",83,N],[3,"posix_spawn_file_actions_t","","",N,N],[12,"__allocated","","",84,N],[12,"__used","","",84,N],[12,"__actions","","",84,N],[12,"__pad","","",84,N],[3,"posix_spawnattr_t","","",N,N],[12,"__flags","","",85,N],[12,"__pgrp","","",85,N],[12,"__sd","","",85,N],[12,"__ss","","",85,N],[12,"__sp","","",85,N],[12,"__policy","","",85,N],[12,"__pad","","",85,N],[3,"genlmsghdr","","",N,N],[12,"cmd","","",86,N],[12,"version","","",86,N],[12,"reserved","","",86,N],[3,"in6_pktinfo","","",N,N],[12,"ipi6_addr","","",87,N],[12,"ipi6_ifindex","","",87,N],[3,"arpd_request","","",N,N],[12,"req","","",88,N],[12,"ip","","",88,N],[12,"dev","","",88,N],[12,"stamp","","",88,N],[12,"updated","","",88,N],[12,"ha","","",88,N],[4,"fpos64_t","","",N,N],[5,"CPU_ZERO","","",N,N],[5,"CPU_SET","","",N,N],[5,"CPU_CLR","","",N,N],[5,"CPU_ISSET","","",N,[[["usize"],["cpu_set_t"]],["bool"]]],[5,"CPU_EQUAL","","",N,[[["cpu_set_t"],["cpu_set_t"]],["bool"]]],[5,"major","","",N,[[["dev_t"]],["c_uint"]]],[5,"minor","","",N,[[["dev_t"]],["c_uint"]]],[5,"makedev","","",N,[[["c_uint"],["c_uint"]],["dev_t"]]],[5,"IPTOS_TOS","","",N,[[["u8"]],["u8"]]],[5,"IPTOS_PREC","","",N,[[["u8"]],["u8"]]],[5,"RT_TOS","","",N,[[["u8"]],["u8"]]],[5,"RT_ADDRCLASS","","",N,[[["u32"]],["u32"]]],[5,"RT_LOCALADDR","","",N,[[["u32"]],["bool"]]],[5,"aio_read","","",N,N],[5,"aio_write","","",N,N],[5,"aio_fsync","","",N,N],[5,"aio_error","","",N,N],[5,"aio_return","","",N,N],[5,"aio_suspend","","",N,N],[5,"aio_cancel","","",N,N],[5,"lio_listio","","",N,N],[5,"lutimes","","",N,N],[5,"setpwent","","",N,N],[5,"endpwent","","",N,N],[5,"getpwent","","",N,N],[5,"setgrent","","",N,N],[5,"endgrent","","",N,N],[5,"getgrent","","",N,N],[5,"setspent","","",N,N],[5,"endspent","","",N,N],[5,"getspent","","",N,N],[5,"getspnam","","",N,N],[5,"shm_open","","",N,N],[5,"shmget","","",N,N],[5,"shmat","","",N,N],[5,"shmdt","","",N,N],[5,"shmctl","","",N,N],[5,"ftok","","",N,N],[5,"semget","","",N,N],[5,"semop","","",N,N],[5,"semctl","","",N,N],[5,"msgctl","","",N,N],[5,"msgget","","",N,N],[5,"msgrcv","","",N,N],[5,"msgsnd","","",N,N],[5,"mprotect","","",N,N],[5,"__errno_location","","",N,N],[5,"fopen64","","",N,N],[5,"freopen64","","",N,N],[5,"tmpfile64","","",N,N],[5,"fgetpos64","","",N,N],[5,"fsetpos64","","",N,N],[5,"fseeko64","","",N,N],[5,"ftello64","","",N,N],[5,"fallocate","","",N,N],[5,"posix_fallocate","","",N,N],[5,"readahead","","",N,N],[5,"getxattr","","",N,N],[5,"lgetxattr","","",N,N],[5,"fgetxattr","","",N,N],[5,"setxattr","","",N,N],[5,"lsetxattr","","",N,N],[5,"fsetxattr","","",N,N],[5,"listxattr","","",N,N],[5,"llistxattr","","",N,N],[5,"flistxattr","","",N,N],[5,"removexattr","","",N,N],[5,"lremovexattr","","",N,N],[5,"fremovexattr","","",N,N],[5,"signalfd","","",N,N],[5,"timerfd_create","","",N,N],[5,"timerfd_gettime","","",N,N],[5,"timerfd_settime","","",N,N],[5,"pwritev","","",N,N],[5,"preadv","","",N,N],[5,"quotactl","","",N,N],[5,"mq_open","","",N,N],[5,"mq_close","","",N,N],[5,"mq_unlink","","",N,N],[5,"mq_receive","","",N,N],[5,"mq_send","","",N,N],[5,"mq_getattr","","",N,N],[5,"mq_setattr","","",N,N],[5,"epoll_pwait","","",N,N],[5,"dup3","","",N,N],[5,"mkostemp","","",N,N],[5,"mkostemps","","",N,N],[5,"sigtimedwait","","",N,N],[5,"sigwaitinfo","","",N,N],[5,"nl_langinfo_l","","",N,N],[5,"getnameinfo","","",N,N],[5,"pthread_setschedprio","","",N,N],[5,"prlimit","","",N,N],[5,"prlimit64","","",N,N],[5,"getloadavg","","",N,N],[5,"process_vm_readv","","",N,N],[5,"process_vm_writev","","",N,N],[5,"reboot","","",N,N],[5,"setfsgid","","",N,N],[5,"setfsuid","","",N,N],[5,"mkfifoat","","",N,N],[5,"if_nameindex","","",N,N],[5,"if_freenameindex","","",N,N],[5,"sync_file_range","","",N,N],[5,"mremap","","",N,N],[5,"glob","","",N,N],[5,"globfree","","",N,N],[5,"posix_madvise","","",N,N],[5,"shm_unlink","","",N,N],[5,"seekdir","","",N,N],[5,"telldir","","",N,N],[5,"madvise","","",N,N],[5,"msync","","",N,N],[5,"remap_file_pages","","",N,N],[5,"recvfrom","","",N,N],[5,"mkstemps","","",N,N],[5,"futimes","","",N,N],[5,"nl_langinfo","","",N,N],[5,"getdomainname","","",N,N],[5,"setdomainname","","",N,N],[5,"vhangup","","",N,N],[5,"sendmmsg","","",N,N],[5,"recvmmsg","","",N,N],[5,"sync","","",N,N],[5,"syscall","","",N,N],[5,"sched_getaffinity","","",N,N],[5,"sched_setaffinity","","",N,N],[5,"epoll_create","","",N,N],[5,"epoll_create1","","",N,N],[5,"epoll_wait","","",N,N],[5,"epoll_ctl","","",N,N],[5,"pthread_getschedparam","","",N,N],[5,"unshare","","",N,N],[5,"umount","","",N,N],[5,"sched_get_priority_max","","",N,N],[5,"tee","","",N,N],[5,"settimeofday","","",N,N],[5,"splice","","",N,N],[5,"eventfd","","",N,N],[5,"sched_rr_get_interval","","",N,N],[5,"sem_timedwait","","",N,N],[5,"sem_getvalue","","",N,N],[5,"sched_setparam","","",N,N],[5,"setns","","",N,N],[5,"swapoff","","",N,N],[5,"vmsplice","","",N,N],[5,"mount","","",N,N],[5,"personality","","",N,N],[5,"prctl","","",N,N],[5,"sched_getparam","","",N,N],[5,"ppoll","","",N,N],[5,"pthread_mutex_timedlock","","",N,N],[5,"clone","","",N,N],[5,"sched_getscheduler","","",N,N],[5,"clock_nanosleep","","",N,N],[5,"pthread_attr_getguardsize","","",N,N],[5,"sethostname","","",N,N],[5,"sched_get_priority_min","","",N,N],[5,"pthread_condattr_getpshared","","",N,N],[5,"sysinfo","","",N,N],[5,"umount2","","",N,N],[5,"pthread_setschedparam","","",N,N],[5,"swapon","","",N,N],[5,"sched_setscheduler","","",N,N],[5,"sendfile","","",N,N],[5,"sigsuspend","","",N,N],[5,"getgrgid_r","","",N,N],[5,"sigaltstack","","",N,N],[5,"sem_close","","",N,N],[5,"getdtablesize","","",N,N],[5,"getgrnam_r","","",N,N],[5,"initgroups","","",N,N],[5,"pthread_sigmask","","",N,N],[5,"sem_open","","",N,N],[5,"getgrnam","","",N,N],[5,"pthread_cancel","","",N,N],[5,"pthread_kill","","",N,N],[5,"sem_unlink","","",N,N],[5,"daemon","","",N,N],[5,"getpwnam_r","","",N,N],[5,"getpwuid_r","","",N,N],[5,"sigwait","","",N,N],[5,"pthread_atfork","","",N,N],[5,"getgrgid","","",N,N],[5,"getgrouplist","","",N,N],[5,"pthread_mutexattr_getpshared","","",N,N],[5,"popen","","",N,N],[5,"faccessat","","",N,N],[5,"pthread_create","","",N,N],[5,"dl_iterate_phdr","","",N,N],[5,"setmntent","","",N,N],[5,"getmntent","","",N,N],[5,"addmntent","","",N,N],[5,"endmntent","","",N,N],[5,"hasmntopt","","",N,N],[5,"posix_spawn","","",N,N],[5,"posix_spawnp","","",N,N],[5,"posix_spawnattr_init","","",N,N],[5,"posix_spawnattr_destroy","","",N,N],[5,"posix_spawnattr_getsigdefault","","",N,N],[5,"posix_spawnattr_setsigdefault","","",N,N],[5,"posix_spawnattr_getsigmask","","",N,N],[5,"posix_spawnattr_setsigmask","","",N,N],[5,"posix_spawnattr_getflags","","",N,N],[5,"posix_spawnattr_setflags","","",N,N],[5,"posix_spawnattr_getpgroup","","",N,N],[5,"posix_spawnattr_setpgroup","","",N,N],[5,"posix_spawnattr_getschedpolicy","","",N,N],[5,"posix_spawnattr_setschedpolicy","","",N,N],[5,"posix_spawnattr_getschedparam","","",N,N],[5,"posix_spawnattr_setschedparam","","",N,N],[5,"posix_spawn_file_actions_init","","",N,N],[5,"posix_spawn_file_actions_destroy","","",N,N],[5,"posix_spawn_file_actions_addopen","","",N,N],[5,"posix_spawn_file_actions_addclose","","",N,N],[5,"posix_spawn_file_actions_adddup2","","",N,N],[5,"fread_unlocked","","",N,N],[0,"other","","",N,N],[3,"aiocb","libc::unix::notbsd::linux::other","",N,N],[12,"aio_fildes","","",89,N],[12,"aio_lio_opcode","","",89,N],[12,"aio_reqprio","","",89,N],[12,"aio_buf","","",89,N],[12,"aio_nbytes","","",89,N],[12,"aio_sigevent","","",89,N],[12,"__next_prio","","",89,N],[12,"__abs_prio","","",89,N],[12,"__policy","","",89,N],[12,"__error_code","","",89,N],[12,"__return_value","","",89,N],[12,"aio_offset","","",89,N],[12,"__glibc_reserved","","",89,N],[3,"__exit_status","","",N,N],[12,"e_termination","","",90,N],[12,"e_exit","","",90,N],[3,"__timeval","","",N,N],[12,"tv_sec","","",91,N],[12,"tv_usec","","",91,N],[3,"utmpx","","",N,N],[12,"ut_type","","",92,N],[12,"ut_pid","","",92,N],[12,"ut_line","","",92,N],[12,"ut_id","","",92,N],[12,"ut_user","","",92,N],[12,"ut_host","","",92,N],[12,"ut_exit","","",92,N],[12,"ut_session","","",92,N],[12,"ut_tv","","",92,N],[12,"ut_addr_v6","","",92,N],[12,"__glibc_reserved","","",92,N],[3,"sigaction","","",N,N],[12,"sa_sigaction","","",93,N],[12,"sa_mask","","",93,N],[12,"sa_flags","","",93,N],[12,"sa_restorer","","",93,N],[3,"stack_t","","",N,N],[12,"ss_sp","","",94,N],[12,"ss_flags","","",94,N],[12,"ss_size","","",94,N],[3,"siginfo_t","","",N,N],[12,"si_signo","","",95,N],[12,"si_errno","","",95,N],[12,"si_code","","",95,N],[12,"_pad","","",95,N],[12,"_align","","",95,N],[3,"glob64_t","","",N,N],[12,"gl_pathc","","",96,N],[12,"gl_pathv","","",96,N],[12,"gl_offs","","",96,N],[12,"gl_flags","","",96,N],[12,"__unused1","","",96,N],[12,"__unused2","","",96,N],[12,"__unused3","","",96,N],[12,"__unused4","","",96,N],[12,"__unused5","","",96,N],[3,"statfs","","",N,N],[12,"f_type","","",97,N],[12,"f_bsize","","",97,N],[12,"f_blocks","","",97,N],[12,"f_bfree","","",97,N],[12,"f_bavail","","",97,N],[12,"f_files","","",97,N],[12,"f_ffree","","",97,N],[12,"f_fsid","","",97,N],[12,"f_namelen","","",97,N],[12,"f_frsize","","",97,N],[12,"f_spare","","",97,N],[3,"msghdr","","",N,N],[12,"msg_name","","",98,N],[12,"msg_namelen","","",98,N],[12,"msg_iov","","",98,N],[12,"msg_iovlen","","",98,N],[12,"msg_control","","",98,N],[12,"msg_controllen","","",98,N],[12,"msg_flags","","",98,N],[3,"cmsghdr","","",N,N],[12,"cmsg_len","","",99,N],[12,"cmsg_level","","",99,N],[12,"cmsg_type","","",99,N],[3,"termios","","",N,N],[12,"c_iflag","","",100,N],[12,"c_oflag","","",100,N],[12,"c_cflag","","",100,N],[12,"c_lflag","","",100,N],[12,"c_line","","",100,N],[12,"c_cc","","",100,N],[12,"c_ispeed","","",100,N],[12,"c_ospeed","","",100,N],[3,"flock","","",N,N],[12,"l_type","","",101,N],[12,"l_whence","","",101,N],[12,"l_start","","",101,N],[12,"l_len","","",101,N],[12,"l_pid","","",101,N],[3,"sem_t","","",N,N],[12,"__size","","",102,N],[12,"__align","","",102,N],[3,"mallinfo","","",N,N],[12,"arena","","",103,N],[12,"ordblks","","",103,N],[12,"smblks","","",103,N],[12,"hblks","","",103,N],[12,"hblkhd","","",103,N],[12,"usmblks","","",103,N],[12,"fsmblks","","",103,N],[12,"uordblks","","",103,N],[12,"fordblks","","",103,N],[12,"keepcost","","",103,N],[3,"nlmsghdr","","",N,N],[12,"nlmsg_len","","",104,N],[12,"nlmsg_type","","",104,N],[12,"nlmsg_flags","","",104,N],[12,"nlmsg_seq","","",104,N],[12,"nlmsg_pid","","",104,N],[3,"nlmsgerr","","",N,N],[12,"error","","",105,N],[12,"msg","","",105,N],[3,"nl_pktinfo","","",N,N],[12,"group","","",106,N],[3,"nl_mmap_req","","",N,N],[12,"nm_block_size","","",107,N],[12,"nm_block_nr","","",107,N],[12,"nm_frame_size","","",107,N],[12,"nm_frame_nr","","",107,N],[3,"nl_mmap_hdr","","",N,N],[12,"nm_status","","",108,N],[12,"nm_len","","",108,N],[12,"nm_group","","",108,N],[12,"nm_pid","","",108,N],[12,"nm_uid","","",108,N],[12,"nm_gid","","",108,N],[3,"nlattr","","",N,N],[12,"nla_len","","",109,N],[12,"nla_type","","",109,N],[3,"rtentry","","",N,N],[12,"rt_pad1","","",110,N],[12,"rt_dst","","",110,N],[12,"rt_gateway","","",110,N],[12,"rt_genmask","","",110,N],[12,"rt_flags","","",110,N],[12,"rt_pad2","","",110,N],[12,"rt_pad3","","",110,N],[12,"rt_tos","","",110,N],[12,"rt_class","","",110,N],[12,"rt_pad4","","",110,N],[12,"rt_metric","","",110,N],[12,"rt_dev","","",110,N],[12,"rt_mtu","","",110,N],[12,"rt_window","","",110,N],[12,"rt_irtt","","",110,N],[5,"NLA_ALIGN","","",N,[[["c_int"]],["c_int"]]],[5,"utmpxname","","",N,N],[5,"getutxent","","",N,N],[5,"getutxid","","",N,N],[5,"getutxline","","",N,N],[5,"pututxline","","",N,N],[5,"setutxent","","",N,N],[5,"endutxent","","",N,N],[5,"getpt","","",N,N],[5,"ioctl","","",N,N],[5,"backtrace","","",N,N],[5,"glob64","","",N,N],[5,"globfree64","","",N,N],[5,"ptrace","","",N,N],[5,"pthread_attr_getaffinity_np","","",N,N],[5,"pthread_attr_setaffinity_np","","",N,N],[5,"getpriority","","",N,N],[5,"setpriority","","",N,N],[5,"pthread_getaffinity_np","","",N,N],[5,"pthread_setaffinity_np","","",N,N],[5,"pthread_rwlockattr_getkind_np","","",N,N],[5,"pthread_rwlockattr_setkind_np","","",N,N],[5,"sched_getcpu","","",N,N],[5,"mallinfo","","",N,N],[5,"malloc_usable_size","","",N,N],[5,"getauxval","","",N,N],[5,"getpwent_r","","",N,N],[5,"getgrent_r","","",N,N],[0,"b64","","64-bit specific definitions for linux-like values",N,N],[3,"sigset_t","libc::unix::notbsd::linux::other::b64","",N,N],[12,"__val","","",111,N],[3,"sysinfo","","",N,N],[12,"uptime","","",112,N],[12,"loads","","",112,N],[12,"totalram","","",112,N],[12,"freeram","","",112,N],[12,"sharedram","","",112,N],[12,"bufferram","","",112,N],[12,"totalswap","","",112,N],[12,"freeswap","","",112,N],[12,"procs","","",112,N],[12,"pad","","",112,N],[12,"totalhigh","","",112,N],[12,"freehigh","","",112,N],[12,"mem_unit","","",112,N],[12,"_f","","",112,N],[3,"msqid_ds","","",N,N],[12,"msg_perm","","",113,N],[12,"msg_stime","","",113,N],[12,"msg_rtime","","",113,N],[12,"msg_ctime","","",113,N],[12,"__msg_cbytes","","",113,N],[12,"msg_qnum","","",113,N],[12,"msg_qbytes","","",113,N],[12,"msg_lspid","","",113,N],[12,"msg_lrpid","","",113,N],[12,"__glibc_reserved4","","",113,N],[12,"__glibc_reserved5","","",113,N],[0,"x86_64","","x86_64-specific definitions for 64-bit linux-like values",N,N],[3,"stat","libc::unix::notbsd::linux::other::b64::x86_64","",N,N],[12,"st_dev","","",114,N],[12,"st_ino","","",114,N],[12,"st_nlink","","",114,N],[12,"st_mode","","",114,N],[12,"st_uid","","",114,N],[12,"st_gid","","",114,N],[12,"__pad0","","",114,N],[12,"st_rdev","","",114,N],[12,"st_size","","",114,N],[12,"st_blksize","","",114,N],[12,"st_blocks","","",114,N],[12,"st_atime","","",114,N],[12,"st_atime_nsec","","",114,N],[12,"st_mtime","","",114,N],[12,"st_mtime_nsec","","",114,N],[12,"st_ctime","","",114,N],[12,"st_ctime_nsec","","",114,N],[12,"__unused","","",114,N],[3,"stat64","","",N,N],[12,"st_dev","","",115,N],[12,"st_ino","","",115,N],[12,"st_nlink","","",115,N],[12,"st_mode","","",115,N],[12,"st_uid","","",115,N],[12,"st_gid","","",115,N],[12,"__pad0","","",115,N],[12,"st_rdev","","",115,N],[12,"st_size","","",115,N],[12,"st_blksize","","",115,N],[12,"st_blocks","","",115,N],[12,"st_atime","","",115,N],[12,"st_atime_nsec","","",115,N],[12,"st_mtime","","",115,N],[12,"st_mtime_nsec","","",115,N],[12,"st_ctime","","",115,N],[12,"st_ctime_nsec","","",115,N],[12,"__reserved","","",115,N],[3,"statfs64","","",N,N],[12,"f_type","","",116,N],[12,"f_bsize","","",116,N],[12,"f_blocks","","",116,N],[12,"f_bfree","","",116,N],[12,"f_bavail","","",116,N],[12,"f_files","","",116,N],[12,"f_ffree","","",116,N],[12,"f_fsid","","",116,N],[12,"f_namelen","","",116,N],[12,"f_frsize","","",116,N],[12,"f_flags","","",116,N],[12,"f_spare","","",116,N],[3,"statvfs64","","",N,N],[12,"f_bsize","","",117,N],[12,"f_frsize","","",117,N],[12,"f_blocks","","",117,N],[12,"f_bfree","","",117,N],[12,"f_bavail","","",117,N],[12,"f_files","","",117,N],[12,"f_ffree","","",117,N],[12,"f_favail","","",117,N],[12,"f_fsid","","",117,N],[12,"f_flag","","",117,N],[12,"f_namemax","","",117,N],[12,"__f_spare","","",117,N],[3,"pthread_attr_t","","",N,N],[12,"__size","","",118,N],[3,"_libc_fpxreg","","",N,N],[12,"significand","","",119,N],[12,"exponent","","",119,N],[12,"__private","","",119,N],[3,"_libc_xmmreg","","",N,N],[12,"element","","",120,N],[3,"_libc_fpstate","","",N,N],[12,"cwd","","",121,N],[12,"swd","","",121,N],[12,"ftw","","",121,N],[12,"fop","","",121,N],[12,"rip","","",121,N],[12,"rdp","","",121,N],[12,"mxcsr","","",121,N],[12,"mxcr_mask","","",121,N],[12,"_st","","",121,N],[12,"_xmm","","",121,N],[12,"__private","","",121,N],[3,"user_fpregs_struct","","",N,N],[12,"cwd","","",122,N],[12,"swd","","",122,N],[12,"ftw","","",122,N],[12,"fop","","",122,N],[12,"rip","","",122,N],[12,"rdp","","",122,N],[12,"mxcsr","","",122,N],[12,"mxcr_mask","","",122,N],[12,"st_space","","",122,N],[12,"xmm_space","","",122,N],[12,"padding","","",122,N],[3,"user_regs_struct","","",N,N],[12,"r15","","",123,N],[12,"r14","","",123,N],[12,"r13","","",123,N],[12,"r12","","",123,N],[12,"rbp","","",123,N],[12,"rbx","","",123,N],[12,"r11","","",123,N],[12,"r10","","",123,N],[12,"r9","","",123,N],[12,"r8","","",123,N],[12,"rax","","",123,N],[12,"rcx","","",123,N],[12,"rdx","","",123,N],[12,"rsi","","",123,N],[12,"rdi","","",123,N],[12,"orig_rax","","",123,N],[12,"rip","","",123,N],[12,"cs","","",123,N],[12,"eflags","","",123,N],[12,"rsp","","",123,N],[12,"ss","","",123,N],[12,"fs_base","","",123,N],[12,"gs_base","","",123,N],[12,"ds","","",123,N],[12,"es","","",123,N],[12,"fs","","",123,N],[12,"gs","","",123,N],[3,"user","","",N,N],[12,"regs","","",124,N],[12,"u_fpvalid","","",124,N],[12,"i387","","",124,N],[12,"u_tsize","","",124,N],[12,"u_dsize","","",124,N],[12,"u_ssize","","",124,N],[12,"start_code","","",124,N],[12,"start_stack","","",124,N],[12,"signal","","",124,N],[12,"__reserved","","",124,N],[12,"u_ar0","","",124,N],[12,"u_fpstate","","",124,N],[12,"magic","","",124,N],[12,"u_comm","","",124,N],[12,"u_debugreg","","",124,N],[3,"mcontext_t","","",N,N],[12,"gregs","","",125,N],[12,"fpregs","","",125,N],[12,"__private","","",125,N],[3,"ucontext_t","","",N,N],[12,"uc_flags","","",126,N],[12,"uc_link","","",126,N],[12,"uc_stack","","",126,N],[12,"uc_mcontext","","",126,N],[12,"uc_sigmask","","",126,N],[12,"__private","","",126,N],[3,"ipc_perm","","",N,N],[12,"__key","","",127,N],[12,"uid","","",127,N],[12,"gid","","",127,N],[12,"cuid","","",127,N],[12,"cgid","","",127,N],[12,"mode","","",127,N],[12,"__pad1","","",127,N],[12,"__seq","","",127,N],[12,"__pad2","","",127,N],[12,"__unused1","","",127,N],[12,"__unused2","","",127,N],[3,"shmid_ds","","",N,N],[12,"shm_perm","","",128,N],[12,"shm_segsz","","",128,N],[12,"shm_atime","","",128,N],[12,"shm_dtime","","",128,N],[12,"shm_ctime","","",128,N],[12,"shm_cpid","","",128,N],[12,"shm_lpid","","",128,N],[12,"shm_nattch","","",128,N],[12,"__unused4","","",128,N],[12,"__unused5","","",128,N],[3,"termios2","","",N,N],[12,"c_iflag","","",129,N],[12,"c_oflag","","",129,N],[12,"c_cflag","","",129,N],[12,"c_lflag","","",129,N],[12,"c_line","","",129,N],[12,"c_cc","","",129,N],[12,"c_ispeed","","",129,N],[12,"c_ospeed","","",129,N],[5,"getcontext","","",N,N],[5,"setcontext","","",N,N],[5,"makecontext","","",N,N],[5,"swapcontext","","",N,N],[5,"iopl","","",N,N],[5,"ioperm","","",N,N],[6,"c_char","","",N,N],[6,"wchar_t","","",N,N],[6,"nlink_t","","",N,N],[6,"blksize_t","","",N,N],[6,"greg_t","","",N,N],[6,"suseconds_t","","",N,N],[6,"__u64","","",N,N],[17,"TIOCGSOFTCAR","","",N,N],[17,"TIOCSSOFTCAR","","",N,N],[17,"RLIMIT_NOFILE","","",N,N],[17,"RLIMIT_NPROC","","",N,N],[17,"O_APPEND","","",N,N],[17,"O_CREAT","","",N,N],[17,"O_EXCL","","",N,N],[17,"O_NOCTTY","","",N,N],[17,"O_NONBLOCK","","",N,N],[17,"O_SYNC","","",N,N],[17,"O_RSYNC","","",N,N],[17,"O_DSYNC","","",N,N],[17,"O_FSYNC","","",N,N],[17,"O_NOATIME","","",N,N],[17,"O_PATH","","",N,N],[17,"O_TMPFILE","","",N,N],[17,"MAP_GROWSDOWN","","",N,N],[17,"EDEADLK","","",N,N],[17,"ENAMETOOLONG","","",N,N],[17,"ENOLCK","","",N,N],[17,"ENOSYS","","",N,N],[17,"ENOTEMPTY","","",N,N],[17,"ELOOP","","",N,N],[17,"ENOMSG","","",N,N],[17,"EIDRM","","",N,N],[17,"ECHRNG","","",N,N],[17,"EL2NSYNC","","",N,N],[17,"EL3HLT","","",N,N],[17,"EL3RST","","",N,N],[17,"ELNRNG","","",N,N],[17,"EUNATCH","","",N,N],[17,"ENOCSI","","",N,N],[17,"EL2HLT","","",N,N],[17,"EBADE","","",N,N],[17,"EBADR","","",N,N],[17,"EXFULL","","",N,N],[17,"ENOANO","","",N,N],[17,"EBADRQC","","",N,N],[17,"EBADSLT","","",N,N],[17,"EMULTIHOP","","",N,N],[17,"EOVERFLOW","","",N,N],[17,"ENOTUNIQ","","",N,N],[17,"EBADFD","","",N,N],[17,"EBADMSG","","",N,N],[17,"EREMCHG","","",N,N],[17,"ELIBACC","","",N,N],[17,"ELIBBAD","","",N,N],[17,"ELIBSCN","","",N,N],[17,"ELIBMAX","","",N,N],[17,"ELIBEXEC","","",N,N],[17,"EILSEQ","","",N,N],[17,"ERESTART","","",N,N],[17,"ESTRPIPE","","",N,N],[17,"EUSERS","","",N,N],[17,"ENOTSOCK","","",N,N],[17,"EDESTADDRREQ","","",N,N],[17,"EMSGSIZE","","",N,N],[17,"EPROTOTYPE","","",N,N],[17,"ENOPROTOOPT","","",N,N],[17,"EPROTONOSUPPORT","","",N,N],[17,"ESOCKTNOSUPPORT","","",N,N],[17,"EOPNOTSUPP","","",N,N],[17,"EPFNOSUPPORT","","",N,N],[17,"EAFNOSUPPORT","","",N,N],[17,"EADDRINUSE","","",N,N],[17,"EADDRNOTAVAIL","","",N,N],[17,"ENETDOWN","","",N,N],[17,"ENETUNREACH","","",N,N],[17,"ENETRESET","","",N,N],[17,"ECONNABORTED","","",N,N],[17,"ECONNRESET","","",N,N],[17,"ENOBUFS","","",N,N],[17,"EISCONN","","",N,N],[17,"ENOTCONN","","",N,N],[17,"ESHUTDOWN","","",N,N],[17,"ETOOMANYREFS","","",N,N],[17,"ETIMEDOUT","","",N,N],[17,"ECONNREFUSED","","",N,N],[17,"EHOSTDOWN","","",N,N],[17,"EHOSTUNREACH","","",N,N],[17,"EALREADY","","",N,N],[17,"EINPROGRESS","","",N,N],[17,"ESTALE","","",N,N],[17,"EDQUOT","","",N,N],[17,"ENOMEDIUM","","",N,N],[17,"EMEDIUMTYPE","","",N,N],[17,"ECANCELED","","",N,N],[17,"ENOKEY","","",N,N],[17,"EKEYEXPIRED","","",N,N],[17,"EKEYREVOKED","","",N,N],[17,"EKEYREJECTED","","",N,N],[17,"EOWNERDEAD","","",N,N],[17,"ENOTRECOVERABLE","","",N,N],[17,"EHWPOISON","","",N,N],[17,"ERFKILL","","",N,N],[17,"SOL_SOCKET","","",N,N],[17,"SO_REUSEADDR","","",N,N],[17,"SO_TYPE","","",N,N],[17,"SO_ERROR","","",N,N],[17,"SO_DONTROUTE","","",N,N],[17,"SO_BROADCAST","","",N,N],[17,"SO_SNDBUF","","",N,N],[17,"SO_RCVBUF","","",N,N],[17,"SO_SNDBUFFORCE","","",N,N],[17,"SO_RCVBUFFORCE","","",N,N],[17,"SO_KEEPALIVE","","",N,N],[17,"SO_OOBINLINE","","",N,N],[17,"SO_NO_CHECK","","",N,N],[17,"SO_PRIORITY","","",N,N],[17,"SO_LINGER","","",N,N],[17,"SO_BSDCOMPAT","","",N,N],[17,"SO_REUSEPORT","","",N,N],[17,"SO_PASSCRED","","",N,N],[17,"SO_PEERCRED","","",N,N],[17,"SO_RCVLOWAT","","",N,N],[17,"SO_SNDLOWAT","","",N,N],[17,"SO_RCVTIMEO","","",N,N],[17,"SO_SNDTIMEO","","",N,N],[17,"SO_SECURITY_AUTHENTICATION","","",N,N],[17,"SO_SECURITY_ENCRYPTION_TRANSPORT","","",N,N],[17,"SO_SECURITY_ENCRYPTION_NETWORK","","",N,N],[17,"SO_BINDTODEVICE","","",N,N],[17,"SO_ATTACH_FILTER","","",N,N],[17,"SO_DETACH_FILTER","","",N,N],[17,"SO_GET_FILTER","","",N,N],[17,"SO_PEERNAME","","",N,N],[17,"SO_TIMESTAMP","","",N,N],[17,"SO_ACCEPTCONN","","",N,N],[17,"SO_PEERSEC","","",N,N],[17,"SO_PASSSEC","","",N,N],[17,"SO_TIMESTAMPNS","","",N,N],[17,"SCM_TIMESTAMPNS","","",N,N],[17,"SO_MARK","","",N,N],[17,"SO_TIMESTAMPING","","",N,N],[17,"SCM_TIMESTAMPING","","",N,N],[17,"SO_PROTOCOL","","",N,N],[17,"SO_DOMAIN","","",N,N],[17,"SO_RXQ_OVFL","","",N,N],[17,"SO_WIFI_STATUS","","",N,N],[17,"SCM_WIFI_STATUS","","",N,N],[17,"SO_PEEK_OFF","","",N,N],[17,"SO_NOFCS","","",N,N],[17,"SO_LOCK_FILTER","","",N,N],[17,"SO_SELECT_ERR_QUEUE","","",N,N],[17,"SO_BUSY_POLL","","",N,N],[17,"SO_MAX_PACING_RATE","","",N,N],[17,"SO_BPF_EXTENSIONS","","",N,N],[17,"SO_INCOMING_CPU","","",N,N],[17,"SO_ATTACH_BPF","","",N,N],[17,"SO_DETACH_BPF","","",N,N],[17,"SA_ONSTACK","","",N,N],[17,"SA_SIGINFO","","",N,N],[17,"SA_NOCLDWAIT","","",N,N],[17,"SIGCHLD","","",N,N],[17,"SIGBUS","","",N,N],[17,"SIGUSR1","","",N,N],[17,"SIGUSR2","","",N,N],[17,"SIGCONT","","",N,N],[17,"SIGSTOP","","",N,N],[17,"SIGTSTP","","",N,N],[17,"SIGURG","","",N,N],[17,"SIGIO","","",N,N],[17,"SIGSYS","","",N,N],[17,"SIGSTKFLT","","",N,N],[17,"SIGUNUSED","","",N,N],[17,"SIGPOLL","","",N,N],[17,"SIGPWR","","",N,N],[17,"SIG_SETMASK","","",N,N],[17,"SIG_BLOCK","","",N,N],[17,"SIG_UNBLOCK","","",N,N],[17,"POLLWRNORM","","",N,N],[17,"POLLWRBAND","","",N,N],[17,"O_ASYNC","","",N,N],[17,"O_NDELAY","","",N,N],[17,"PTRACE_DETACH","","",N,N],[17,"EFD_NONBLOCK","","",N,N],[17,"F_GETLK","","",N,N],[17,"F_GETOWN","","",N,N],[17,"F_SETOWN","","",N,N],[17,"F_SETLK","","",N,N],[17,"F_SETLKW","","",N,N],[17,"F_RDLCK","","",N,N],[17,"F_WRLCK","","",N,N],[17,"F_UNLCK","","",N,N],[17,"SFD_NONBLOCK","","",N,N],[17,"TIOCEXCL","","",N,N],[17,"TIOCNXCL","","",N,N],[17,"TIOCSCTTY","","",N,N],[17,"TIOCSTI","","",N,N],[17,"TIOCMGET","","",N,N],[17,"TIOCMBIS","","",N,N],[17,"TIOCMBIC","","",N,N],[17,"TIOCMSET","","",N,N],[17,"TIOCCONS","","",N,N],[17,"SFD_CLOEXEC","","",N,N],[17,"NCCS","","",N,N],[17,"O_TRUNC","","",N,N],[17,"O_CLOEXEC","","",N,N],[17,"EBFONT","","",N,N],[17,"ENOSTR","","",N,N],[17,"ENODATA","","",N,N],[17,"ETIME","","",N,N],[17,"ENOSR","","",N,N],[17,"ENONET","","",N,N],[17,"ENOPKG","","",N,N],[17,"EREMOTE","","",N,N],[17,"ENOLINK","","",N,N],[17,"EADV","","",N,N],[17,"ESRMNT","","",N,N],[17,"ECOMM","","",N,N],[17,"EPROTO","","",N,N],[17,"EDOTDOT","","",N,N],[17,"SA_NODEFER","","",N,N],[17,"SA_RESETHAND","","",N,N],[17,"SA_RESTART","","",N,N],[17,"SA_NOCLDSTOP","","",N,N],[17,"EPOLL_CLOEXEC","","",N,N],[17,"EFD_CLOEXEC","","",N,N],[17,"__SIZEOF_PTHREAD_CONDATTR_T","","",N,N],[17,"__SIZEOF_PTHREAD_MUTEXATTR_T","","",N,N],[17,"O_DIRECT","","",N,N],[17,"O_DIRECTORY","","",N,N],[17,"O_NOFOLLOW","","",N,N],[17,"MAP_LOCKED","","",N,N],[17,"MAP_NORESERVE","","",N,N],[17,"MAP_32BIT","","",N,N],[17,"EDEADLOCK","","",N,N],[17,"FIOCLEX","","",N,N],[17,"FIONBIO","","",N,N],[17,"PTRACE_GETFPREGS","","",N,N],[17,"PTRACE_SETFPREGS","","",N,N],[17,"PTRACE_GETFPXREGS","","",N,N],[17,"PTRACE_SETFPXREGS","","",N,N],[17,"PTRACE_GETREGS","","",N,N],[17,"PTRACE_SETREGS","","",N,N],[17,"PTRACE_PEEKSIGINFO_SHARED","","",N,N],[17,"MCL_CURRENT","","",N,N],[17,"MCL_FUTURE","","",N,N],[17,"SIGSTKSZ","","",N,N],[17,"MINSIGSTKSZ","","",N,N],[17,"CBAUD","","",N,N],[17,"TAB1","","",N,N],[17,"TAB2","","",N,N],[17,"TAB3","","",N,N],[17,"CR1","","",N,N],[17,"CR2","","",N,N],[17,"CR3","","",N,N],[17,"FF1","","",N,N],[17,"BS1","","",N,N],[17,"VT1","","",N,N],[17,"VWERASE","","",N,N],[17,"VREPRINT","","",N,N],[17,"VSUSP","","",N,N],[17,"VSTART","","",N,N],[17,"VSTOP","","",N,N],[17,"VDISCARD","","",N,N],[17,"VTIME","","",N,N],[17,"IXON","","",N,N],[17,"IXOFF","","",N,N],[17,"ONLCR","","",N,N],[17,"CSIZE","","",N,N],[17,"CS6","","",N,N],[17,"CS7","","",N,N],[17,"CS8","","",N,N],[17,"CSTOPB","","",N,N],[17,"CREAD","","",N,N],[17,"PARENB","","",N,N],[17,"PARODD","","",N,N],[17,"HUPCL","","",N,N],[17,"CLOCAL","","",N,N],[17,"ECHOKE","","",N,N],[17,"ECHOE","","",N,N],[17,"ECHOK","","",N,N],[17,"ECHONL","","",N,N],[17,"ECHOPRT","","",N,N],[17,"ECHOCTL","","",N,N],[17,"ISIG","","",N,N],[17,"ICANON","","",N,N],[17,"PENDIN","","",N,N],[17,"NOFLSH","","",N,N],[17,"CIBAUD","","",N,N],[17,"CBAUDEX","","",N,N],[17,"VSWTC","","",N,N],[17,"OLCUC","","",N,N],[17,"NLDLY","","",N,N],[17,"CRDLY","","",N,N],[17,"TABDLY","","",N,N],[17,"BSDLY","","",N,N],[17,"FFDLY","","",N,N],[17,"VTDLY","","",N,N],[17,"XTABS","","",N,N],[17,"B0","","",N,N],[17,"B50","","",N,N],[17,"B75","","",N,N],[17,"B110","","",N,N],[17,"B134","","",N,N],[17,"B150","","",N,N],[17,"B200","","",N,N],[17,"B300","","",N,N],[17,"B600","","",N,N],[17,"B1200","","",N,N],[17,"B1800","","",N,N],[17,"B2400","","",N,N],[17,"B4800","","",N,N],[17,"B9600","","",N,N],[17,"B19200","","",N,N],[17,"B38400","","",N,N],[17,"EXTA","","",N,N],[17,"EXTB","","",N,N],[17,"BOTHER","","",N,N],[17,"B57600","","",N,N],[17,"B115200","","",N,N],[17,"B230400","","",N,N],[17,"B460800","","",N,N],[17,"B500000","","",N,N],[17,"B576000","","",N,N],[17,"B921600","","",N,N],[17,"B1000000","","",N,N],[17,"B1152000","","",N,N],[17,"B1500000","","",N,N],[17,"B2000000","","",N,N],[17,"B2500000","","",N,N],[17,"B3000000","","",N,N],[17,"B3500000","","",N,N],[17,"B4000000","","",N,N],[17,"VEOL","","",N,N],[17,"VEOL2","","",N,N],[17,"VMIN","","",N,N],[17,"IEXTEN","","",N,N],[17,"TOSTOP","","",N,N],[17,"FLUSHO","","",N,N],[17,"EXTPROC","","",N,N],[17,"TCGETS","","",N,N],[17,"TCSETS","","",N,N],[17,"TCSETSW","","",N,N],[17,"TCSETSF","","",N,N],[17,"TCGETA","","",N,N],[17,"TCSETA","","",N,N],[17,"TCSETAW","","",N,N],[17,"TCSETAF","","",N,N],[17,"TCSBRK","","",N,N],[17,"TCXONC","","",N,N],[17,"TCFLSH","","",N,N],[17,"TIOCINQ","","",N,N],[17,"TIOCGPGRP","","",N,N],[17,"TIOCSPGRP","","",N,N],[17,"TIOCOUTQ","","",N,N],[17,"TIOCGWINSZ","","",N,N],[17,"TIOCSWINSZ","","",N,N],[17,"FIONREAD","","",N,N],[17,"R15","","",N,N],[17,"R14","","",N,N],[17,"R13","","",N,N],[17,"R12","","",N,N],[17,"RBP","","",N,N],[17,"RBX","","",N,N],[17,"R11","","",N,N],[17,"R10","","",N,N],[17,"R9","","",N,N],[17,"R8","","",N,N],[17,"RAX","","",N,N],[17,"RCX","","",N,N],[17,"RDX","","",N,N],[17,"RSI","","",N,N],[17,"RDI","","",N,N],[17,"ORIG_RAX","","",N,N],[17,"RIP","","",N,N],[17,"CS","","",N,N],[17,"EFLAGS","","",N,N],[17,"RSP","","",N,N],[17,"SS","","",N,N],[17,"FS_BASE","","",N,N],[17,"GS_BASE","","",N,N],[17,"DS","","",N,N],[17,"ES","","",N,N],[17,"FS","","",N,N],[17,"GS","","",N,N],[11,"clone","libc","",114,[[["self"]],["stat"]]],[11,"clone","","",115,[[["self"]],["stat64"]]],[11,"clone","","",116,[[["self"]],["statfs64"]]],[11,"clone","","",117,[[["self"]],["statvfs64"]]],[11,"clone","","",118,[[["self"]],["pthread_attr_t"]]],[11,"clone","","",119,[[["self"]],["_libc_fpxreg"]]],[11,"clone","","",120,[[["self"]],["_libc_xmmreg"]]],[11,"clone","","",121,[[["self"]],["_libc_fpstate"]]],[11,"clone","","",122,[[["self"]],["user_fpregs_struct"]]],[11,"clone","","",123,[[["self"]],["user_regs_struct"]]],[11,"clone","","",124,[[["self"]],["user"]]],[11,"clone","","",125,[[["self"]],["mcontext_t"]]],[11,"clone","","",126,[[["self"]],["ucontext_t"]]],[11,"clone","","",127,[[["self"]],["ipc_perm"]]],[11,"clone","","",128,[[["self"]],["shmid_ds"]]],[11,"clone","","",129,[[["self"]],["termios2"]]],[0,"not_x32","libc::unix::notbsd::linux::other::b64","",N,N],[3,"statvfs","libc::unix::notbsd::linux::other::b64::not_x32","",N,N],[12,"f_bsize","","",130,N],[12,"f_frsize","","",130,N],[12,"f_blocks","","",130,N],[12,"f_bfree","","",130,N],[12,"f_bavail","","",130,N],[12,"f_files","","",130,N],[12,"f_ffree","","",130,N],[12,"f_favail","","",130,N],[12,"f_fsid","","",130,N],[12,"f_flag","","",130,N],[12,"f_namemax","","",130,N],[12,"__f_spare","","",130,N],[5,"sysctl","","",N,N],[6,"c_long","","",N,N],[6,"c_ulong","","",N,N],[17,"__SIZEOF_PTHREAD_MUTEX_T","","",N,N],[17,"__SIZEOF_PTHREAD_RWLOCK_T","","",N,N],[17,"PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP","","",N,N],[17,"PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP","","",N,N],[17,"PTHREAD_ADAPTIVE_MUTEX_INITIALIZER_NP","","",N,N],[17,"SYS_read","","",N,N],[17,"SYS_write","","",N,N],[17,"SYS_open","","",N,N],[17,"SYS_close","","",N,N],[17,"SYS_stat","","",N,N],[17,"SYS_fstat","","",N,N],[17,"SYS_lstat","","",N,N],[17,"SYS_poll","","",N,N],[17,"SYS_lseek","","",N,N],[17,"SYS_mmap","","",N,N],[17,"SYS_mprotect","","",N,N],[17,"SYS_munmap","","",N,N],[17,"SYS_brk","","",N,N],[17,"SYS_rt_sigaction","","",N,N],[17,"SYS_rt_sigprocmask","","",N,N],[17,"SYS_rt_sigreturn","","",N,N],[17,"SYS_ioctl","","",N,N],[17,"SYS_pread64","","",N,N],[17,"SYS_pwrite64","","",N,N],[17,"SYS_readv","","",N,N],[17,"SYS_writev","","",N,N],[17,"SYS_access","","",N,N],[17,"SYS_pipe","","",N,N],[17,"SYS_select","","",N,N],[17,"SYS_sched_yield","","",N,N],[17,"SYS_mremap","","",N,N],[17,"SYS_msync","","",N,N],[17,"SYS_mincore","","",N,N],[17,"SYS_madvise","","",N,N],[17,"SYS_shmget","","",N,N],[17,"SYS_shmat","","",N,N],[17,"SYS_shmctl","","",N,N],[17,"SYS_dup","","",N,N],[17,"SYS_dup2","","",N,N],[17,"SYS_pause","","",N,N],[17,"SYS_nanosleep","","",N,N],[17,"SYS_getitimer","","",N,N],[17,"SYS_alarm","","",N,N],[17,"SYS_setitimer","","",N,N],[17,"SYS_getpid","","",N,N],[17,"SYS_sendfile","","",N,N],[17,"SYS_socket","","",N,N],[17,"SYS_connect","","",N,N],[17,"SYS_accept","","",N,N],[17,"SYS_sendto","","",N,N],[17,"SYS_recvfrom","","",N,N],[17,"SYS_sendmsg","","",N,N],[17,"SYS_recvmsg","","",N,N],[17,"SYS_shutdown","","",N,N],[17,"SYS_bind","","",N,N],[17,"SYS_listen","","",N,N],[17,"SYS_getsockname","","",N,N],[17,"SYS_getpeername","","",N,N],[17,"SYS_socketpair","","",N,N],[17,"SYS_setsockopt","","",N,N],[17,"SYS_getsockopt","","",N,N],[17,"SYS_clone","","",N,N],[17,"SYS_fork","","",N,N],[17,"SYS_vfork","","",N,N],[17,"SYS_execve","","",N,N],[17,"SYS_exit","","",N,N],[17,"SYS_wait4","","",N,N],[17,"SYS_kill","","",N,N],[17,"SYS_uname","","",N,N],[17,"SYS_semget","","",N,N],[17,"SYS_semop","","",N,N],[17,"SYS_semctl","","",N,N],[17,"SYS_shmdt","","",N,N],[17,"SYS_msgget","","",N,N],[17,"SYS_msgsnd","","",N,N],[17,"SYS_msgrcv","","",N,N],[17,"SYS_msgctl","","",N,N],[17,"SYS_fcntl","","",N,N],[17,"SYS_flock","","",N,N],[17,"SYS_fsync","","",N,N],[17,"SYS_fdatasync","","",N,N],[17,"SYS_truncate","","",N,N],[17,"SYS_ftruncate","","",N,N],[17,"SYS_getdents","","",N,N],[17,"SYS_getcwd","","",N,N],[17,"SYS_chdir","","",N,N],[17,"SYS_fchdir","","",N,N],[17,"SYS_rename","","",N,N],[17,"SYS_mkdir","","",N,N],[17,"SYS_rmdir","","",N,N],[17,"SYS_creat","","",N,N],[17,"SYS_link","","",N,N],[17,"SYS_unlink","","",N,N],[17,"SYS_symlink","","",N,N],[17,"SYS_readlink","","",N,N],[17,"SYS_chmod","","",N,N],[17,"SYS_fchmod","","",N,N],[17,"SYS_chown","","",N,N],[17,"SYS_fchown","","",N,N],[17,"SYS_lchown","","",N,N],[17,"SYS_umask","","",N,N],[17,"SYS_gettimeofday","","",N,N],[17,"SYS_getrlimit","","",N,N],[17,"SYS_getrusage","","",N,N],[17,"SYS_sysinfo","","",N,N],[17,"SYS_times","","",N,N],[17,"SYS_ptrace","","",N,N],[17,"SYS_getuid","","",N,N],[17,"SYS_syslog","","",N,N],[17,"SYS_getgid","","",N,N],[17,"SYS_setuid","","",N,N],[17,"SYS_setgid","","",N,N],[17,"SYS_geteuid","","",N,N],[17,"SYS_getegid","","",N,N],[17,"SYS_setpgid","","",N,N],[17,"SYS_getppid","","",N,N],[17,"SYS_getpgrp","","",N,N],[17,"SYS_setsid","","",N,N],[17,"SYS_setreuid","","",N,N],[17,"SYS_setregid","","",N,N],[17,"SYS_getgroups","","",N,N],[17,"SYS_setgroups","","",N,N],[17,"SYS_setresuid","","",N,N],[17,"SYS_getresuid","","",N,N],[17,"SYS_setresgid","","",N,N],[17,"SYS_getresgid","","",N,N],[17,"SYS_getpgid","","",N,N],[17,"SYS_setfsuid","","",N,N],[17,"SYS_setfsgid","","",N,N],[17,"SYS_getsid","","",N,N],[17,"SYS_capget","","",N,N],[17,"SYS_capset","","",N,N],[17,"SYS_rt_sigpending","","",N,N],[17,"SYS_rt_sigtimedwait","","",N,N],[17,"SYS_rt_sigqueueinfo","","",N,N],[17,"SYS_rt_sigsuspend","","",N,N],[17,"SYS_sigaltstack","","",N,N],[17,"SYS_utime","","",N,N],[17,"SYS_mknod","","",N,N],[17,"SYS_uselib","","",N,N],[17,"SYS_personality","","",N,N],[17,"SYS_ustat","","",N,N],[17,"SYS_statfs","","",N,N],[17,"SYS_fstatfs","","",N,N],[17,"SYS_sysfs","","",N,N],[17,"SYS_getpriority","","",N,N],[17,"SYS_setpriority","","",N,N],[17,"SYS_sched_setparam","","",N,N],[17,"SYS_sched_getparam","","",N,N],[17,"SYS_sched_setscheduler","","",N,N],[17,"SYS_sched_getscheduler","","",N,N],[17,"SYS_sched_get_priority_max","","",N,N],[17,"SYS_sched_get_priority_min","","",N,N],[17,"SYS_sched_rr_get_interval","","",N,N],[17,"SYS_mlock","","",N,N],[17,"SYS_munlock","","",N,N],[17,"SYS_mlockall","","",N,N],[17,"SYS_munlockall","","",N,N],[17,"SYS_vhangup","","",N,N],[17,"SYS_modify_ldt","","",N,N],[17,"SYS_pivot_root","","",N,N],[17,"SYS__sysctl","","",N,N],[17,"SYS_prctl","","",N,N],[17,"SYS_arch_prctl","","",N,N],[17,"SYS_adjtimex","","",N,N],[17,"SYS_setrlimit","","",N,N],[17,"SYS_chroot","","",N,N],[17,"SYS_sync","","",N,N],[17,"SYS_acct","","",N,N],[17,"SYS_settimeofday","","",N,N],[17,"SYS_mount","","",N,N],[17,"SYS_umount2","","",N,N],[17,"SYS_swapon","","",N,N],[17,"SYS_swapoff","","",N,N],[17,"SYS_reboot","","",N,N],[17,"SYS_sethostname","","",N,N],[17,"SYS_setdomainname","","",N,N],[17,"SYS_iopl","","",N,N],[17,"SYS_ioperm","","",N,N],[17,"SYS_create_module","","",N,N],[17,"SYS_init_module","","",N,N],[17,"SYS_delete_module","","",N,N],[17,"SYS_get_kernel_syms","","",N,N],[17,"SYS_query_module","","",N,N],[17,"SYS_quotactl","","",N,N],[17,"SYS_nfsservctl","","",N,N],[17,"SYS_getpmsg","","",N,N],[17,"SYS_putpmsg","","",N,N],[17,"SYS_afs_syscall","","",N,N],[17,"SYS_tuxcall","","",N,N],[17,"SYS_security","","",N,N],[17,"SYS_gettid","","",N,N],[17,"SYS_readahead","","",N,N],[17,"SYS_setxattr","","",N,N],[17,"SYS_lsetxattr","","",N,N],[17,"SYS_fsetxattr","","",N,N],[17,"SYS_getxattr","","",N,N],[17,"SYS_lgetxattr","","",N,N],[17,"SYS_fgetxattr","","",N,N],[17,"SYS_listxattr","","",N,N],[17,"SYS_llistxattr","","",N,N],[17,"SYS_flistxattr","","",N,N],[17,"SYS_removexattr","","",N,N],[17,"SYS_lremovexattr","","",N,N],[17,"SYS_fremovexattr","","",N,N],[17,"SYS_tkill","","",N,N],[17,"SYS_time","","",N,N],[17,"SYS_futex","","",N,N],[17,"SYS_sched_setaffinity","","",N,N],[17,"SYS_sched_getaffinity","","",N,N],[17,"SYS_set_thread_area","","",N,N],[17,"SYS_io_setup","","",N,N],[17,"SYS_io_destroy","","",N,N],[17,"SYS_io_getevents","","",N,N],[17,"SYS_io_submit","","",N,N],[17,"SYS_io_cancel","","",N,N],[17,"SYS_get_thread_area","","",N,N],[17,"SYS_lookup_dcookie","","",N,N],[17,"SYS_epoll_create","","",N,N],[17,"SYS_epoll_ctl_old","","",N,N],[17,"SYS_epoll_wait_old","","",N,N],[17,"SYS_remap_file_pages","","",N,N],[17,"SYS_getdents64","","",N,N],[17,"SYS_set_tid_address","","",N,N],[17,"SYS_restart_syscall","","",N,N],[17,"SYS_semtimedop","","",N,N],[17,"SYS_fadvise64","","",N,N],[17,"SYS_timer_create","","",N,N],[17,"SYS_timer_settime","","",N,N],[17,"SYS_timer_gettime","","",N,N],[17,"SYS_timer_getoverrun","","",N,N],[17,"SYS_timer_delete","","",N,N],[17,"SYS_clock_settime","","",N,N],[17,"SYS_clock_gettime","","",N,N],[17,"SYS_clock_getres","","",N,N],[17,"SYS_clock_nanosleep","","",N,N],[17,"SYS_exit_group","","",N,N],[17,"SYS_epoll_wait","","",N,N],[17,"SYS_epoll_ctl","","",N,N],[17,"SYS_tgkill","","",N,N],[17,"SYS_utimes","","",N,N],[17,"SYS_vserver","","",N,N],[17,"SYS_mbind","","",N,N],[17,"SYS_set_mempolicy","","",N,N],[17,"SYS_get_mempolicy","","",N,N],[17,"SYS_mq_open","","",N,N],[17,"SYS_mq_unlink","","",N,N],[17,"SYS_mq_timedsend","","",N,N],[17,"SYS_mq_timedreceive","","",N,N],[17,"SYS_mq_notify","","",N,N],[17,"SYS_mq_getsetattr","","",N,N],[17,"SYS_kexec_load","","",N,N],[17,"SYS_waitid","","",N,N],[17,"SYS_add_key","","",N,N],[17,"SYS_request_key","","",N,N],[17,"SYS_keyctl","","",N,N],[17,"SYS_ioprio_set","","",N,N],[17,"SYS_ioprio_get","","",N,N],[17,"SYS_inotify_init","","",N,N],[17,"SYS_inotify_add_watch","","",N,N],[17,"SYS_inotify_rm_watch","","",N,N],[17,"SYS_migrate_pages","","",N,N],[17,"SYS_openat","","",N,N],[17,"SYS_mkdirat","","",N,N],[17,"SYS_mknodat","","",N,N],[17,"SYS_fchownat","","",N,N],[17,"SYS_futimesat","","",N,N],[17,"SYS_newfstatat","","",N,N],[17,"SYS_unlinkat","","",N,N],[17,"SYS_renameat","","",N,N],[17,"SYS_linkat","","",N,N],[17,"SYS_symlinkat","","",N,N],[17,"SYS_readlinkat","","",N,N],[17,"SYS_fchmodat","","",N,N],[17,"SYS_faccessat","","",N,N],[17,"SYS_pselect6","","",N,N],[17,"SYS_ppoll","","",N,N],[17,"SYS_unshare","","",N,N],[17,"SYS_set_robust_list","","",N,N],[17,"SYS_get_robust_list","","",N,N],[17,"SYS_splice","","",N,N],[17,"SYS_tee","","",N,N],[17,"SYS_sync_file_range","","",N,N],[17,"SYS_vmsplice","","",N,N],[17,"SYS_move_pages","","",N,N],[17,"SYS_utimensat","","",N,N],[17,"SYS_epoll_pwait","","",N,N],[17,"SYS_signalfd","","",N,N],[17,"SYS_timerfd_create","","",N,N],[17,"SYS_eventfd","","",N,N],[17,"SYS_fallocate","","",N,N],[17,"SYS_timerfd_settime","","",N,N],[17,"SYS_timerfd_gettime","","",N,N],[17,"SYS_accept4","","",N,N],[17,"SYS_signalfd4","","",N,N],[17,"SYS_eventfd2","","",N,N],[17,"SYS_epoll_create1","","",N,N],[17,"SYS_dup3","","",N,N],[17,"SYS_pipe2","","",N,N],[17,"SYS_inotify_init1","","",N,N],[17,"SYS_preadv","","",N,N],[17,"SYS_pwritev","","",N,N],[17,"SYS_rt_tgsigqueueinfo","","",N,N],[17,"SYS_perf_event_open","","",N,N],[17,"SYS_recvmmsg","","",N,N],[17,"SYS_fanotify_init","","",N,N],[17,"SYS_fanotify_mark","","",N,N],[17,"SYS_prlimit64","","",N,N],[17,"SYS_name_to_handle_at","","",N,N],[17,"SYS_open_by_handle_at","","",N,N],[17,"SYS_clock_adjtime","","",N,N],[17,"SYS_syncfs","","",N,N],[17,"SYS_sendmmsg","","",N,N],[17,"SYS_setns","","",N,N],[17,"SYS_getcpu","","",N,N],[17,"SYS_process_vm_readv","","",N,N],[17,"SYS_process_vm_writev","","",N,N],[17,"SYS_kcmp","","",N,N],[17,"SYS_finit_module","","",N,N],[17,"SYS_sched_setattr","","",N,N],[17,"SYS_sched_getattr","","",N,N],[17,"SYS_renameat2","","",N,N],[17,"SYS_seccomp","","",N,N],[17,"SYS_getrandom","","",N,N],[17,"SYS_memfd_create","","",N,N],[17,"SYS_kexec_file_load","","",N,N],[17,"SYS_bpf","","",N,N],[17,"SYS_execveat","","",N,N],[17,"SYS_userfaultfd","","",N,N],[17,"SYS_membarrier","","",N,N],[17,"SYS_mlock2","","",N,N],[17,"SYS_copy_file_range","","",N,N],[17,"SYS_preadv2","","",N,N],[17,"SYS_pwritev2","","",N,N],[17,"SYS_pkey_mprotect","","",N,N],[17,"SYS_pkey_alloc","","",N,N],[17,"SYS_pkey_free","","",N,N],[11,"clone","libc","",130,[[["self"]],["statvfs"]]],[6,"clock_t","libc::unix::notbsd::linux::other::b64","",N,N],[6,"time_t","","",N,N],[6,"ino_t","","",N,N],[6,"off_t","","",N,N],[6,"blkcnt_t","","",N,N],[6,"__fsword_t","","",N,N],[6,"shmatt_t","","",N,N],[6,"msgqnum_t","","",N,N],[6,"msglen_t","","",N,N],[6,"fsblkcnt_t","","",N,N],[6,"fsfilcnt_t","","",N,N],[6,"rlim_t","","",N,N],[17,"__SIZEOF_PTHREAD_RWLOCKATTR_T","","",N,N],[17,"O_LARGEFILE","","",N,N],[11,"clone","libc","",111,[[["self"]],["sigset_t"]]],[11,"clone","","",112,[[["self"]],["sysinfo"]]],[11,"clone","","",113,[[["self"]],["msqid_ds"]]],[6,"__priority_which_t","libc::unix::notbsd::linux::other","",N,N],[17,"__UT_LINESIZE","","",N,N],[17,"__UT_NAMESIZE","","",N,N],[17,"__UT_HOSTSIZE","","",N,N],[17,"EMPTY","","",N,N],[17,"RUN_LVL","","",N,N],[17,"BOOT_TIME","","",N,N],[17,"NEW_TIME","","",N,N],[17,"OLD_TIME","","",N,N],[17,"INIT_PROCESS","","",N,N],[17,"LOGIN_PROCESS","","",N,N],[17,"USER_PROCESS","","",N,N],[17,"DEAD_PROCESS","","",N,N],[17,"ACCOUNTING","","",N,N],[17,"RLIMIT_RSS","","",N,N],[17,"RLIMIT_AS","","",N,N],[17,"RLIMIT_MEMLOCK","","",N,N],[17,"RLIM_INFINITY","","",N,N],[17,"RLIMIT_RTTIME","","",N,N],[17,"RLIMIT_NLIMITS","","",N,N],[17,"SOCK_NONBLOCK","","",N,N],[17,"SOL_RXRPC","","",N,N],[17,"SOL_PPPOL2TP","","",N,N],[17,"SOL_BLUETOOTH","","",N,N],[17,"SOL_PNPIPE","","",N,N],[17,"SOL_RDS","","",N,N],[17,"SOL_IUCV","","",N,N],[17,"SOL_CAIF","","",N,N],[17,"SOL_ALG","","",N,N],[17,"SOL_NFC","","",N,N],[17,"MSG_TRYHARD","","",N,N],[17,"LC_PAPER","","",N,N],[17,"LC_NAME","","",N,N],[17,"LC_ADDRESS","","",N,N],[17,"LC_TELEPHONE","","",N,N],[17,"LC_MEASUREMENT","","",N,N],[17,"LC_IDENTIFICATION","","",N,N],[17,"LC_PAPER_MASK","","",N,N],[17,"LC_NAME_MASK","","",N,N],[17,"LC_ADDRESS_MASK","","",N,N],[17,"LC_TELEPHONE_MASK","","",N,N],[17,"LC_MEASUREMENT_MASK","","",N,N],[17,"LC_IDENTIFICATION_MASK","","",N,N],[17,"LC_ALL_MASK","","",N,N],[17,"MAP_ANON","","",N,N],[17,"MAP_ANONYMOUS","","",N,N],[17,"MAP_DENYWRITE","","",N,N],[17,"MAP_EXECUTABLE","","",N,N],[17,"MAP_POPULATE","","",N,N],[17,"MAP_NONBLOCK","","",N,N],[17,"MAP_STACK","","",N,N],[17,"ENOTSUP","","",N,N],[17,"EUCLEAN","","",N,N],[17,"ENOTNAM","","",N,N],[17,"ENAVAIL","","",N,N],[17,"EISNAM","","",N,N],[17,"EREMOTEIO","","",N,N],[17,"SOCK_STREAM","","",N,N],[17,"SOCK_DGRAM","","",N,N],[17,"SOCK_SEQPACKET","","",N,N],[17,"SOCK_DCCP","","",N,N],[17,"SOCK_PACKET","","",N,N],[17,"TCP_COOKIE_TRANSACTIONS","","",N,N],[17,"TCP_THIN_LINEAR_TIMEOUTS","","",N,N],[17,"TCP_THIN_DUPACK","","",N,N],[17,"TCP_USER_TIMEOUT","","",N,N],[17,"TCP_REPAIR","","",N,N],[17,"TCP_REPAIR_QUEUE","","",N,N],[17,"TCP_QUEUE_SEQ","","",N,N],[17,"TCP_REPAIR_OPTIONS","","",N,N],[17,"TCP_FASTOPEN","","",N,N],[17,"TCP_TIMESTAMP","","",N,N],[17,"DCCP_SOCKOPT_PACKET_SIZE","","",N,N],[17,"DCCP_SOCKOPT_SERVICE","","",N,N],[17,"DCCP_SOCKOPT_CHANGE_L","","",N,N],[17,"DCCP_SOCKOPT_CHANGE_R","","",N,N],[17,"DCCP_SOCKOPT_GET_CUR_MPS","","",N,N],[17,"DCCP_SOCKOPT_SERVER_TIMEWAIT","","",N,N],[17,"DCCP_SOCKOPT_SEND_CSCOV","","",N,N],[17,"DCCP_SOCKOPT_RECV_CSCOV","","",N,N],[17,"DCCP_SOCKOPT_AVAILABLE_CCIDS","","",N,N],[17,"DCCP_SOCKOPT_CCID","","",N,N],[17,"DCCP_SOCKOPT_TX_CCID","","",N,N],[17,"DCCP_SOCKOPT_RX_CCID","","",N,N],[17,"DCCP_SOCKOPT_QPOLICY_ID","","",N,N],[17,"DCCP_SOCKOPT_QPOLICY_TXQLEN","","",N,N],[17,"DCCP_SOCKOPT_CCID_RX_INFO","","",N,N],[17,"DCCP_SOCKOPT_CCID_TX_INFO","","",N,N],[17,"DCCP_SERVICE_LIST_MAX_LEN","","maximum number of services provided on the same listening port",N,N],[17,"SIGTTIN","","",N,N],[17,"SIGTTOU","","",N,N],[17,"SIGXCPU","","",N,N],[17,"SIGXFSZ","","",N,N],[17,"SIGVTALRM","","",N,N],[17,"SIGPROF","","",N,N],[17,"SIGWINCH","","",N,N],[17,"SIGEV_THREAD_ID","","",N,N],[17,"BUFSIZ","","",N,N],[17,"TMP_MAX","","",N,N],[17,"FOPEN_MAX","","",N,N],[17,"POSIX_FADV_DONTNEED","","",N,N],[17,"POSIX_FADV_NOREUSE","","",N,N],[17,"POSIX_MADV_DONTNEED","","",N,N],[17,"_SC_EQUIV_CLASS_MAX","","",N,N],[17,"_SC_CHARCLASS_NAME_MAX","","",N,N],[17,"_SC_PII","","",N,N],[17,"_SC_PII_XTI","","",N,N],[17,"_SC_PII_SOCKET","","",N,N],[17,"_SC_PII_INTERNET","","",N,N],[17,"_SC_PII_OSI","","",N,N],[17,"_SC_POLL","","",N,N],[17,"_SC_SELECT","","",N,N],[17,"_SC_PII_INTERNET_STREAM","","",N,N],[17,"_SC_PII_INTERNET_DGRAM","","",N,N],[17,"_SC_PII_OSI_COTS","","",N,N],[17,"_SC_PII_OSI_CLTS","","",N,N],[17,"_SC_PII_OSI_M","","",N,N],[17,"_SC_T_IOV_MAX","","",N,N],[17,"_SC_2_C_VERSION","","",N,N],[17,"_SC_CHAR_BIT","","",N,N],[17,"_SC_CHAR_MAX","","",N,N],[17,"_SC_CHAR_MIN","","",N,N],[17,"_SC_INT_MAX","","",N,N],[17,"_SC_INT_MIN","","",N,N],[17,"_SC_LONG_BIT","","",N,N],[17,"_SC_WORD_BIT","","",N,N],[17,"_SC_MB_LEN_MAX","","",N,N],[17,"_SC_SSIZE_MAX","","",N,N],[17,"_SC_SCHAR_MAX","","",N,N],[17,"_SC_SCHAR_MIN","","",N,N],[17,"_SC_SHRT_MAX","","",N,N],[17,"_SC_SHRT_MIN","","",N,N],[17,"_SC_UCHAR_MAX","","",N,N],[17,"_SC_UINT_MAX","","",N,N],[17,"_SC_ULONG_MAX","","",N,N],[17,"_SC_USHRT_MAX","","",N,N],[17,"_SC_NL_ARGMAX","","",N,N],[17,"_SC_NL_LANGMAX","","",N,N],[17,"_SC_NL_MSGMAX","","",N,N],[17,"_SC_NL_NMAX","","",N,N],[17,"_SC_NL_SETMAX","","",N,N],[17,"_SC_NL_TEXTMAX","","",N,N],[17,"_SC_BASE","","",N,N],[17,"_SC_C_LANG_SUPPORT","","",N,N],[17,"_SC_C_LANG_SUPPORT_R","","",N,N],[17,"_SC_DEVICE_IO","","",N,N],[17,"_SC_DEVICE_SPECIFIC","","",N,N],[17,"_SC_DEVICE_SPECIFIC_R","","",N,N],[17,"_SC_FD_MGMT","","",N,N],[17,"_SC_FIFO","","",N,N],[17,"_SC_PIPE","","",N,N],[17,"_SC_FILE_ATTRIBUTES","","",N,N],[17,"_SC_FILE_LOCKING","","",N,N],[17,"_SC_FILE_SYSTEM","","",N,N],[17,"_SC_MULTI_PROCESS","","",N,N],[17,"_SC_SINGLE_PROCESS","","",N,N],[17,"_SC_NETWORKING","","",N,N],[17,"_SC_REGEX_VERSION","","",N,N],[17,"_SC_SIGNALS","","",N,N],[17,"_SC_SYSTEM_DATABASE","","",N,N],[17,"_SC_SYSTEM_DATABASE_R","","",N,N],[17,"_SC_USER_GROUPS","","",N,N],[17,"_SC_USER_GROUPS_R","","",N,N],[17,"_SC_LEVEL1_ICACHE_SIZE","","",N,N],[17,"_SC_LEVEL1_ICACHE_ASSOC","","",N,N],[17,"_SC_LEVEL1_ICACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL1_DCACHE_SIZE","","",N,N],[17,"_SC_LEVEL1_DCACHE_ASSOC","","",N,N],[17,"_SC_LEVEL1_DCACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL2_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL2_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL2_CACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL3_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL3_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL3_CACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL4_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL4_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL4_CACHE_LINESIZE","","",N,N],[17,"O_ACCMODE","","",N,N],[17,"ST_RELATIME","","",N,N],[17,"NI_MAXHOST","","",N,N],[17,"ADFS_SUPER_MAGIC","","",N,N],[17,"AFFS_SUPER_MAGIC","","",N,N],[17,"CODA_SUPER_MAGIC","","",N,N],[17,"CRAMFS_MAGIC","","",N,N],[17,"EFS_SUPER_MAGIC","","",N,N],[17,"EXT2_SUPER_MAGIC","","",N,N],[17,"EXT3_SUPER_MAGIC","","",N,N],[17,"EXT4_SUPER_MAGIC","","",N,N],[17,"HPFS_SUPER_MAGIC","","",N,N],[17,"HUGETLBFS_MAGIC","","",N,N],[17,"ISOFS_SUPER_MAGIC","","",N,N],[17,"JFFS2_SUPER_MAGIC","","",N,N],[17,"MINIX_SUPER_MAGIC","","",N,N],[17,"MINIX_SUPER_MAGIC2","","",N,N],[17,"MINIX2_SUPER_MAGIC","","",N,N],[17,"MINIX2_SUPER_MAGIC2","","",N,N],[17,"MSDOS_SUPER_MAGIC","","",N,N],[17,"NCP_SUPER_MAGIC","","",N,N],[17,"NFS_SUPER_MAGIC","","",N,N],[17,"OPENPROM_SUPER_MAGIC","","",N,N],[17,"PROC_SUPER_MAGIC","","",N,N],[17,"QNX4_SUPER_MAGIC","","",N,N],[17,"REISERFS_SUPER_MAGIC","","",N,N],[17,"SMB_SUPER_MAGIC","","",N,N],[17,"TMPFS_MAGIC","","",N,N],[17,"USBDEVICE_SUPER_MAGIC","","",N,N],[17,"VEOF","","",N,N],[17,"CPU_SETSIZE","","",N,N],[17,"PTRACE_TRACEME","","",N,N],[17,"PTRACE_PEEKTEXT","","",N,N],[17,"PTRACE_PEEKDATA","","",N,N],[17,"PTRACE_PEEKUSER","","",N,N],[17,"PTRACE_POKETEXT","","",N,N],[17,"PTRACE_POKEDATA","","",N,N],[17,"PTRACE_POKEUSER","","",N,N],[17,"PTRACE_CONT","","",N,N],[17,"PTRACE_KILL","","",N,N],[17,"PTRACE_SINGLESTEP","","",N,N],[17,"PTRACE_ATTACH","","",N,N],[17,"PTRACE_SYSCALL","","",N,N],[17,"PTRACE_SETOPTIONS","","",N,N],[17,"PTRACE_GETEVENTMSG","","",N,N],[17,"PTRACE_GETSIGINFO","","",N,N],[17,"PTRACE_SETSIGINFO","","",N,N],[17,"PTRACE_GETREGSET","","",N,N],[17,"PTRACE_SETREGSET","","",N,N],[17,"PTRACE_SEIZE","","",N,N],[17,"PTRACE_INTERRUPT","","",N,N],[17,"PTRACE_LISTEN","","",N,N],[17,"PTRACE_PEEKSIGINFO","","",N,N],[17,"EPOLLWAKEUP","","",N,N],[17,"MAP_HUGETLB","","",N,N],[17,"SEEK_DATA","","",N,N],[17,"SEEK_HOLE","","",N,N],[17,"TCSANOW","","",N,N],[17,"TCSADRAIN","","",N,N],[17,"TCSAFLUSH","","",N,N],[17,"TIOCLINUX","","",N,N],[17,"TIOCGSERIAL","","",N,N],[17,"RTLD_DEEPBIND","","",N,N],[17,"RTLD_GLOBAL","","",N,N],[17,"RTLD_NOLOAD","","",N,N],[17,"LINUX_REBOOT_MAGIC1","","",N,N],[17,"LINUX_REBOOT_MAGIC2","","",N,N],[17,"LINUX_REBOOT_MAGIC2A","","",N,N],[17,"LINUX_REBOOT_MAGIC2B","","",N,N],[17,"LINUX_REBOOT_MAGIC2C","","",N,N],[17,"LINUX_REBOOT_CMD_RESTART","","",N,N],[17,"LINUX_REBOOT_CMD_HALT","","",N,N],[17,"LINUX_REBOOT_CMD_CAD_ON","","",N,N],[17,"LINUX_REBOOT_CMD_CAD_OFF","","",N,N],[17,"LINUX_REBOOT_CMD_POWER_OFF","","",N,N],[17,"LINUX_REBOOT_CMD_RESTART2","","",N,N],[17,"LINUX_REBOOT_CMD_SW_SUSPEND","","",N,N],[17,"LINUX_REBOOT_CMD_KEXEC","","",N,N],[17,"NETLINK_ROUTE","","",N,N],[17,"NETLINK_UNUSED","","",N,N],[17,"NETLINK_USERSOCK","","",N,N],[17,"NETLINK_FIREWALL","","",N,N],[17,"NETLINK_SOCK_DIAG","","",N,N],[17,"NETLINK_NFLOG","","",N,N],[17,"NETLINK_XFRM","","",N,N],[17,"NETLINK_SELINUX","","",N,N],[17,"NETLINK_ISCSI","","",N,N],[17,"NETLINK_AUDIT","","",N,N],[17,"NETLINK_FIB_LOOKUP","","",N,N],[17,"NETLINK_CONNECTOR","","",N,N],[17,"NETLINK_NETFILTER","","",N,N],[17,"NETLINK_IP6_FW","","",N,N],[17,"NETLINK_DNRTMSG","","",N,N],[17,"NETLINK_KOBJECT_UEVENT","","",N,N],[17,"NETLINK_GENERIC","","",N,N],[17,"NETLINK_SCSITRANSPORT","","",N,N],[17,"NETLINK_ECRYPTFS","","",N,N],[17,"NETLINK_RDMA","","",N,N],[17,"NETLINK_CRYPTO","","",N,N],[17,"NETLINK_INET_DIAG","","",N,N],[17,"MAX_LINKS","","",N,N],[17,"NLM_F_REQUEST","","",N,N],[17,"NLM_F_MULTI","","",N,N],[17,"NLM_F_ACK","","",N,N],[17,"NLM_F_ECHO","","",N,N],[17,"NLM_F_DUMP_INTR","","",N,N],[17,"NLM_F_DUMP_FILTERED","","",N,N],[17,"NLM_F_ROOT","","",N,N],[17,"NLM_F_MATCH","","",N,N],[17,"NLM_F_ATOMIC","","",N,N],[17,"NLM_F_DUMP","","",N,N],[17,"NLM_F_REPLACE","","",N,N],[17,"NLM_F_EXCL","","",N,N],[17,"NLM_F_CREATE","","",N,N],[17,"NLM_F_APPEND","","",N,N],[17,"NETLINK_ADD_MEMBERSHIP","","",N,N],[17,"NETLINK_DROP_MEMBERSHIP","","",N,N],[17,"NETLINK_PKTINFO","","",N,N],[17,"NETLINK_BROADCAST_ERROR","","",N,N],[17,"NETLINK_NO_ENOBUFS","","",N,N],[17,"NETLINK_RX_RING","","",N,N],[17,"NETLINK_TX_RING","","",N,N],[17,"NETLINK_LISTEN_ALL_NSID","","",N,N],[17,"NETLINK_LIST_MEMBERSHIPS","","",N,N],[17,"NETLINK_CAP_ACK","","",N,N],[17,"NLA_F_NESTED","","",N,N],[17,"NLA_F_NET_BYTEORDER","","",N,N],[17,"NLA_TYPE_MASK","","",N,N],[17,"NLA_ALIGNTO","","",N,N],[17,"GENL_UNS_ADMIN_PERM","","",N,N],[17,"GENL_ID_VFS_DQUOT","","",N,N],[17,"GENL_ID_PMCRAID","","",N,N],[17,"TIOCM_LE","","",N,N],[17,"TIOCM_DTR","","",N,N],[17,"TIOCM_RTS","","",N,N],[17,"TIOCM_ST","","",N,N],[17,"TIOCM_SR","","",N,N],[17,"TIOCM_CTS","","",N,N],[17,"TIOCM_CAR","","",N,N],[17,"TIOCM_RNG","","",N,N],[17,"TIOCM_DSR","","",N,N],[17,"TIOCM_CD","","",N,N],[17,"TIOCM_RI","","",N,N],[17,"NF_NETDEV_INGRESS","","",N,N],[17,"NF_NETDEV_NUMHOOKS","","",N,N],[17,"NFPROTO_INET","","",N,N],[17,"NFPROTO_NETDEV","","",N,N],[17,"NFT_TABLE_MAXNAMELEN","","",N,N],[17,"NFT_CHAIN_MAXNAMELEN","","",N,N],[17,"NFT_SET_MAXNAMELEN","","",N,N],[17,"NFT_OBJ_MAXNAMELEN","","",N,N],[17,"NFT_USERDATA_MAXLEN","","",N,N],[17,"NFT_REG_VERDICT","","",N,N],[17,"NFT_REG_1","","",N,N],[17,"NFT_REG_2","","",N,N],[17,"NFT_REG_3","","",N,N],[17,"NFT_REG_4","","",N,N],[17,"__NFT_REG_MAX","","",N,N],[17,"NFT_REG32_00","","",N,N],[17,"NFT_REG32_01","","",N,N],[17,"NFT_REG32_02","","",N,N],[17,"NFT_REG32_03","","",N,N],[17,"NFT_REG32_04","","",N,N],[17,"NFT_REG32_05","","",N,N],[17,"NFT_REG32_06","","",N,N],[17,"NFT_REG32_07","","",N,N],[17,"NFT_REG32_08","","",N,N],[17,"NFT_REG32_09","","",N,N],[17,"NFT_REG32_10","","",N,N],[17,"NFT_REG32_11","","",N,N],[17,"NFT_REG32_12","","",N,N],[17,"NFT_REG32_13","","",N,N],[17,"NFT_REG32_14","","",N,N],[17,"NFT_REG32_15","","",N,N],[17,"NFT_REG_SIZE","","",N,N],[17,"NFT_REG32_SIZE","","",N,N],[17,"NFT_CONTINUE","","",N,N],[17,"NFT_BREAK","","",N,N],[17,"NFT_JUMP","","",N,N],[17,"NFT_GOTO","","",N,N],[17,"NFT_RETURN","","",N,N],[17,"NFT_MSG_NEWTABLE","","",N,N],[17,"NFT_MSG_GETTABLE","","",N,N],[17,"NFT_MSG_DELTABLE","","",N,N],[17,"NFT_MSG_NEWCHAIN","","",N,N],[17,"NFT_MSG_GETCHAIN","","",N,N],[17,"NFT_MSG_DELCHAIN","","",N,N],[17,"NFT_MSG_NEWRULE","","",N,N],[17,"NFT_MSG_GETRULE","","",N,N],[17,"NFT_MSG_DELRULE","","",N,N],[17,"NFT_MSG_NEWSET","","",N,N],[17,"NFT_MSG_GETSET","","",N,N],[17,"NFT_MSG_DELSET","","",N,N],[17,"NFT_MSG_NEWSETELEM","","",N,N],[17,"NFT_MSG_GETSETELEM","","",N,N],[17,"NFT_MSG_DELSETELEM","","",N,N],[17,"NFT_MSG_NEWGEN","","",N,N],[17,"NFT_MSG_GETGEN","","",N,N],[17,"NFT_MSG_TRACE","","",N,N],[17,"NFT_MSG_NEWOBJ","","",N,N],[17,"NFT_MSG_GETOBJ","","",N,N],[17,"NFT_MSG_DELOBJ","","",N,N],[17,"NFT_MSG_GETOBJ_RESET","","",N,N],[17,"NFT_MSG_MAX","","",N,N],[17,"NFT_SET_ANONYMOUS","","",N,N],[17,"NFT_SET_CONSTANT","","",N,N],[17,"NFT_SET_INTERVAL","","",N,N],[17,"NFT_SET_MAP","","",N,N],[17,"NFT_SET_TIMEOUT","","",N,N],[17,"NFT_SET_EVAL","","",N,N],[17,"NFT_SET_POL_PERFORMANCE","","",N,N],[17,"NFT_SET_POL_MEMORY","","",N,N],[17,"NFT_SET_ELEM_INTERVAL_END","","",N,N],[17,"NFT_DATA_VALUE","","",N,N],[17,"NFT_DATA_VERDICT","","",N,N],[17,"NFT_DATA_RESERVED_MASK","","",N,N],[17,"NFT_DATA_VALUE_MAXLEN","","",N,N],[17,"NFT_BYTEORDER_NTOH","","",N,N],[17,"NFT_BYTEORDER_HTON","","",N,N],[17,"NFT_CMP_EQ","","",N,N],[17,"NFT_CMP_NEQ","","",N,N],[17,"NFT_CMP_LT","","",N,N],[17,"NFT_CMP_LTE","","",N,N],[17,"NFT_CMP_GT","","",N,N],[17,"NFT_CMP_GTE","","",N,N],[17,"NFT_RANGE_EQ","","",N,N],[17,"NFT_RANGE_NEQ","","",N,N],[17,"NFT_LOOKUP_F_INV","","",N,N],[17,"NFT_DYNSET_OP_ADD","","",N,N],[17,"NFT_DYNSET_OP_UPDATE","","",N,N],[17,"NFT_DYNSET_F_INV","","",N,N],[17,"NFT_PAYLOAD_LL_HEADER","","",N,N],[17,"NFT_PAYLOAD_NETWORK_HEADER","","",N,N],[17,"NFT_PAYLOAD_TRANSPORT_HEADER","","",N,N],[17,"NFT_PAYLOAD_CSUM_NONE","","",N,N],[17,"NFT_PAYLOAD_CSUM_INET","","",N,N],[17,"NFT_META_LEN","","",N,N],[17,"NFT_META_PROTOCOL","","",N,N],[17,"NFT_META_PRIORITY","","",N,N],[17,"NFT_META_MARK","","",N,N],[17,"NFT_META_IIF","","",N,N],[17,"NFT_META_OIF","","",N,N],[17,"NFT_META_IIFNAME","","",N,N],[17,"NFT_META_OIFNAME","","",N,N],[17,"NFT_META_IIFTYPE","","",N,N],[17,"NFT_META_OIFTYPE","","",N,N],[17,"NFT_META_SKUID","","",N,N],[17,"NFT_META_SKGID","","",N,N],[17,"NFT_META_NFTRACE","","",N,N],[17,"NFT_META_RTCLASSID","","",N,N],[17,"NFT_META_SECMARK","","",N,N],[17,"NFT_META_NFPROTO","","",N,N],[17,"NFT_META_L4PROTO","","",N,N],[17,"NFT_META_BRI_IIFNAME","","",N,N],[17,"NFT_META_BRI_OIFNAME","","",N,N],[17,"NFT_META_PKTTYPE","","",N,N],[17,"NFT_META_CPU","","",N,N],[17,"NFT_META_IIFGROUP","","",N,N],[17,"NFT_META_OIFGROUP","","",N,N],[17,"NFT_META_CGROUP","","",N,N],[17,"NFT_META_PRANDOM","","",N,N],[17,"NFT_CT_STATE","","",N,N],[17,"NFT_CT_DIRECTION","","",N,N],[17,"NFT_CT_STATUS","","",N,N],[17,"NFT_CT_MARK","","",N,N],[17,"NFT_CT_SECMARK","","",N,N],[17,"NFT_CT_EXPIRATION","","",N,N],[17,"NFT_CT_HELPER","","",N,N],[17,"NFT_CT_L3PROTOCOL","","",N,N],[17,"NFT_CT_SRC","","",N,N],[17,"NFT_CT_DST","","",N,N],[17,"NFT_CT_PROTOCOL","","",N,N],[17,"NFT_CT_PROTO_SRC","","",N,N],[17,"NFT_CT_PROTO_DST","","",N,N],[17,"NFT_CT_LABELS","","",N,N],[17,"NFT_CT_PKTS","","",N,N],[17,"NFT_CT_BYTES","","",N,N],[17,"NFT_LIMIT_PKTS","","",N,N],[17,"NFT_LIMIT_PKT_BYTES","","",N,N],[17,"NFT_LIMIT_F_INV","","",N,N],[17,"NFT_QUEUE_FLAG_BYPASS","","",N,N],[17,"NFT_QUEUE_FLAG_CPU_FANOUT","","",N,N],[17,"NFT_QUEUE_FLAG_MASK","","",N,N],[17,"NFT_QUOTA_F_INV","","",N,N],[17,"NFT_REJECT_ICMP_UNREACH","","",N,N],[17,"NFT_REJECT_TCP_RST","","",N,N],[17,"NFT_REJECT_ICMPX_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_NO_ROUTE","","",N,N],[17,"NFT_REJECT_ICMPX_PORT_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_HOST_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_ADMIN_PROHIBITED","","",N,N],[17,"NFT_NAT_SNAT","","",N,N],[17,"NFT_NAT_DNAT","","",N,N],[17,"NFT_TRACETYPE_UNSPEC","","",N,N],[17,"NFT_TRACETYPE_POLICY","","",N,N],[17,"NFT_TRACETYPE_RETURN","","",N,N],[17,"NFT_TRACETYPE_RULE","","",N,N],[17,"NFT_NG_INCREMENTAL","","",N,N],[17,"NFT_NG_RANDOM","","",N,N],[17,"AF_MAX","","",N,N],[17,"PF_MAX","","",N,N],[17,"PTHREAD_STACK_MIN","","",N,N],[17,"PTHREAD_MUTEX_ADAPTIVE_NP","","",N,N],[11,"clone","libc","",89,[[["self"]],["aiocb"]]],[11,"clone","","",90,[[["self"]],["__exit_status"]]],[11,"clone","","",91,[[["self"]],["__timeval"]]],[11,"clone","","",92,[[["self"]],["utmpx"]]],[11,"clone","","",93,[[["self"]],["sigaction"]]],[11,"clone","","",94,[[["self"]],["stack_t"]]],[11,"clone","","",95,[[["self"]],["siginfo_t"]]],[11,"clone","","",96,[[["self"]],["glob64_t"]]],[11,"clone","","",97,[[["self"]],["statfs"]]],[11,"clone","","",98,[[["self"]],["msghdr"]]],[11,"clone","","",99,[[["self"]],["cmsghdr"]]],[11,"clone","","",100,[[["self"]],["termios"]]],[11,"clone","","",101,[[["self"]],["flock"]]],[11,"clone","","",102,[[["self"]],["sem_t"]]],[11,"clone","","",103,[[["self"]],["mallinfo"]]],[11,"clone","","",104,[[["self"]],["nlmsghdr"]]],[11,"clone","","",105,[[["self"]],["nlmsgerr"]]],[11,"clone","","",106,[[["self"]],["nl_pktinfo"]]],[11,"clone","","",107,[[["self"]],["nl_mmap_req"]]],[11,"clone","","",108,[[["self"]],["nl_mmap_hdr"]]],[11,"clone","","",109,[[["self"]],["nlattr"]]],[11,"clone","","",110,[[["self"]],["rtentry"]]],[6,"useconds_t","libc::unix::notbsd::linux","",N,N],[6,"dev_t","","",N,N],[6,"socklen_t","","",N,N],[6,"pthread_t","","",N,N],[6,"mode_t","","",N,N],[6,"ino64_t","","",N,N],[6,"off64_t","","",N,N],[6,"blkcnt64_t","","",N,N],[6,"rlim64_t","","",N,N],[6,"mqd_t","","",N,N],[6,"nfds_t","","",N,N],[6,"nl_item","","",N,N],[6,"idtype_t","","",N,N],[6,"loff_t","","",N,N],[6,"__u8","","",N,N],[6,"__u16","","",N,N],[6,"__s16","","",N,N],[6,"__u32","","",N,N],[6,"__s32","","",N,N],[6,"Elf32_Half","","",N,N],[6,"Elf32_Word","","",N,N],[6,"Elf32_Off","","",N,N],[6,"Elf32_Addr","","",N,N],[6,"Elf64_Half","","",N,N],[6,"Elf64_Word","","",N,N],[6,"Elf64_Off","","",N,N],[6,"Elf64_Addr","","",N,N],[6,"Elf64_Xword","","",N,N],[17,"ABDAY_1","","",N,N],[17,"ABDAY_2","","",N,N],[17,"ABDAY_3","","",N,N],[17,"ABDAY_4","","",N,N],[17,"ABDAY_5","","",N,N],[17,"ABDAY_6","","",N,N],[17,"ABDAY_7","","",N,N],[17,"DAY_1","","",N,N],[17,"DAY_2","","",N,N],[17,"DAY_3","","",N,N],[17,"DAY_4","","",N,N],[17,"DAY_5","","",N,N],[17,"DAY_6","","",N,N],[17,"DAY_7","","",N,N],[17,"ABMON_1","","",N,N],[17,"ABMON_2","","",N,N],[17,"ABMON_3","","",N,N],[17,"ABMON_4","","",N,N],[17,"ABMON_5","","",N,N],[17,"ABMON_6","","",N,N],[17,"ABMON_7","","",N,N],[17,"ABMON_8","","",N,N],[17,"ABMON_9","","",N,N],[17,"ABMON_10","","",N,N],[17,"ABMON_11","","",N,N],[17,"ABMON_12","","",N,N],[17,"MON_1","","",N,N],[17,"MON_2","","",N,N],[17,"MON_3","","",N,N],[17,"MON_4","","",N,N],[17,"MON_5","","",N,N],[17,"MON_6","","",N,N],[17,"MON_7","","",N,N],[17,"MON_8","","",N,N],[17,"MON_9","","",N,N],[17,"MON_10","","",N,N],[17,"MON_11","","",N,N],[17,"MON_12","","",N,N],[17,"AM_STR","","",N,N],[17,"PM_STR","","",N,N],[17,"D_T_FMT","","",N,N],[17,"D_FMT","","",N,N],[17,"T_FMT","","",N,N],[17,"T_FMT_AMPM","","",N,N],[17,"ERA","","",N,N],[17,"ERA_D_FMT","","",N,N],[17,"ALT_DIGITS","","",N,N],[17,"ERA_D_T_FMT","","",N,N],[17,"ERA_T_FMT","","",N,N],[17,"CODESET","","",N,N],[17,"CRNCYSTR","","",N,N],[17,"RUSAGE_THREAD","","",N,N],[17,"RUSAGE_CHILDREN","","",N,N],[17,"RADIXCHAR","","",N,N],[17,"THOUSEP","","",N,N],[17,"YESEXPR","","",N,N],[17,"NOEXPR","","",N,N],[17,"YESSTR","","",N,N],[17,"NOSTR","","",N,N],[17,"FILENAME_MAX","","",N,N],[17,"L_tmpnam","","",N,N],[17,"_PC_LINK_MAX","","",N,N],[17,"_PC_MAX_CANON","","",N,N],[17,"_PC_MAX_INPUT","","",N,N],[17,"_PC_NAME_MAX","","",N,N],[17,"_PC_PATH_MAX","","",N,N],[17,"_PC_PIPE_BUF","","",N,N],[17,"_PC_CHOWN_RESTRICTED","","",N,N],[17,"_PC_NO_TRUNC","","",N,N],[17,"_PC_VDISABLE","","",N,N],[17,"_PC_SYNC_IO","","",N,N],[17,"_PC_ASYNC_IO","","",N,N],[17,"_PC_PRIO_IO","","",N,N],[17,"_PC_SOCK_MAXBUF","","",N,N],[17,"_PC_FILESIZEBITS","","",N,N],[17,"_PC_REC_INCR_XFER_SIZE","","",N,N],[17,"_PC_REC_MAX_XFER_SIZE","","",N,N],[17,"_PC_REC_MIN_XFER_SIZE","","",N,N],[17,"_PC_REC_XFER_ALIGN","","",N,N],[17,"_PC_ALLOC_SIZE_MIN","","",N,N],[17,"_PC_SYMLINK_MAX","","",N,N],[17,"_PC_2_SYMLINKS","","",N,N],[17,"_SC_ARG_MAX","","",N,N],[17,"_SC_CHILD_MAX","","",N,N],[17,"_SC_CLK_TCK","","",N,N],[17,"_SC_NGROUPS_MAX","","",N,N],[17,"_SC_OPEN_MAX","","",N,N],[17,"_SC_STREAM_MAX","","",N,N],[17,"_SC_TZNAME_MAX","","",N,N],[17,"_SC_JOB_CONTROL","","",N,N],[17,"_SC_SAVED_IDS","","",N,N],[17,"_SC_REALTIME_SIGNALS","","",N,N],[17,"_SC_PRIORITY_SCHEDULING","","",N,N],[17,"_SC_TIMERS","","",N,N],[17,"_SC_ASYNCHRONOUS_IO","","",N,N],[17,"_SC_PRIORITIZED_IO","","",N,N],[17,"_SC_SYNCHRONIZED_IO","","",N,N],[17,"_SC_FSYNC","","",N,N],[17,"_SC_MAPPED_FILES","","",N,N],[17,"_SC_MEMLOCK","","",N,N],[17,"_SC_MEMLOCK_RANGE","","",N,N],[17,"_SC_MEMORY_PROTECTION","","",N,N],[17,"_SC_MESSAGE_PASSING","","",N,N],[17,"_SC_SEMAPHORES","","",N,N],[17,"_SC_SHARED_MEMORY_OBJECTS","","",N,N],[17,"_SC_AIO_LISTIO_MAX","","",N,N],[17,"_SC_AIO_MAX","","",N,N],[17,"_SC_AIO_PRIO_DELTA_MAX","","",N,N],[17,"_SC_DELAYTIMER_MAX","","",N,N],[17,"_SC_MQ_OPEN_MAX","","",N,N],[17,"_SC_MQ_PRIO_MAX","","",N,N],[17,"_SC_VERSION","","",N,N],[17,"_SC_PAGESIZE","","",N,N],[17,"_SC_PAGE_SIZE","","",N,N],[17,"_SC_RTSIG_MAX","","",N,N],[17,"_SC_SEM_NSEMS_MAX","","",N,N],[17,"_SC_SEM_VALUE_MAX","","",N,N],[17,"_SC_SIGQUEUE_MAX","","",N,N],[17,"_SC_TIMER_MAX","","",N,N],[17,"_SC_BC_BASE_MAX","","",N,N],[17,"_SC_BC_DIM_MAX","","",N,N],[17,"_SC_BC_SCALE_MAX","","",N,N],[17,"_SC_BC_STRING_MAX","","",N,N],[17,"_SC_COLL_WEIGHTS_MAX","","",N,N],[17,"_SC_EXPR_NEST_MAX","","",N,N],[17,"_SC_LINE_MAX","","",N,N],[17,"_SC_RE_DUP_MAX","","",N,N],[17,"_SC_2_VERSION","","",N,N],[17,"_SC_2_C_BIND","","",N,N],[17,"_SC_2_C_DEV","","",N,N],[17,"_SC_2_FORT_DEV","","",N,N],[17,"_SC_2_FORT_RUN","","",N,N],[17,"_SC_2_SW_DEV","","",N,N],[17,"_SC_2_LOCALEDEF","","",N,N],[17,"_SC_UIO_MAXIOV","","",N,N],[17,"_SC_IOV_MAX","","",N,N],[17,"_SC_THREADS","","",N,N],[17,"_SC_THREAD_SAFE_FUNCTIONS","","",N,N],[17,"_SC_GETGR_R_SIZE_MAX","","",N,N],[17,"_SC_GETPW_R_SIZE_MAX","","",N,N],[17,"_SC_LOGIN_NAME_MAX","","",N,N],[17,"_SC_TTY_NAME_MAX","","",N,N],[17,"_SC_THREAD_DESTRUCTOR_ITERATIONS","","",N,N],[17,"_SC_THREAD_KEYS_MAX","","",N,N],[17,"_SC_THREAD_STACK_MIN","","",N,N],[17,"_SC_THREAD_THREADS_MAX","","",N,N],[17,"_SC_THREAD_ATTR_STACKADDR","","",N,N],[17,"_SC_THREAD_ATTR_STACKSIZE","","",N,N],[17,"_SC_THREAD_PRIORITY_SCHEDULING","","",N,N],[17,"_SC_THREAD_PRIO_INHERIT","","",N,N],[17,"_SC_THREAD_PRIO_PROTECT","","",N,N],[17,"_SC_THREAD_PROCESS_SHARED","","",N,N],[17,"_SC_NPROCESSORS_CONF","","",N,N],[17,"_SC_NPROCESSORS_ONLN","","",N,N],[17,"_SC_PHYS_PAGES","","",N,N],[17,"_SC_AVPHYS_PAGES","","",N,N],[17,"_SC_ATEXIT_MAX","","",N,N],[17,"_SC_PASS_MAX","","",N,N],[17,"_SC_XOPEN_VERSION","","",N,N],[17,"_SC_XOPEN_XCU_VERSION","","",N,N],[17,"_SC_XOPEN_UNIX","","",N,N],[17,"_SC_XOPEN_CRYPT","","",N,N],[17,"_SC_XOPEN_ENH_I18N","","",N,N],[17,"_SC_XOPEN_SHM","","",N,N],[17,"_SC_2_CHAR_TERM","","",N,N],[17,"_SC_2_UPE","","",N,N],[17,"_SC_XOPEN_XPG2","","",N,N],[17,"_SC_XOPEN_XPG3","","",N,N],[17,"_SC_XOPEN_XPG4","","",N,N],[17,"_SC_NZERO","","",N,N],[17,"_SC_XBS5_ILP32_OFF32","","",N,N],[17,"_SC_XBS5_ILP32_OFFBIG","","",N,N],[17,"_SC_XBS5_LP64_OFF64","","",N,N],[17,"_SC_XBS5_LPBIG_OFFBIG","","",N,N],[17,"_SC_XOPEN_LEGACY","","",N,N],[17,"_SC_XOPEN_REALTIME","","",N,N],[17,"_SC_XOPEN_REALTIME_THREADS","","",N,N],[17,"_SC_ADVISORY_INFO","","",N,N],[17,"_SC_BARRIERS","","",N,N],[17,"_SC_CLOCK_SELECTION","","",N,N],[17,"_SC_CPUTIME","","",N,N],[17,"_SC_THREAD_CPUTIME","","",N,N],[17,"_SC_MONOTONIC_CLOCK","","",N,N],[17,"_SC_READER_WRITER_LOCKS","","",N,N],[17,"_SC_SPIN_LOCKS","","",N,N],[17,"_SC_REGEXP","","",N,N],[17,"_SC_SHELL","","",N,N],[17,"_SC_SPAWN","","",N,N],[17,"_SC_SPORADIC_SERVER","","",N,N],[17,"_SC_THREAD_SPORADIC_SERVER","","",N,N],[17,"_SC_TIMEOUTS","","",N,N],[17,"_SC_TYPED_MEMORY_OBJECTS","","",N,N],[17,"_SC_2_PBS","","",N,N],[17,"_SC_2_PBS_ACCOUNTING","","",N,N],[17,"_SC_2_PBS_LOCATE","","",N,N],[17,"_SC_2_PBS_MESSAGE","","",N,N],[17,"_SC_2_PBS_TRACK","","",N,N],[17,"_SC_SYMLOOP_MAX","","",N,N],[17,"_SC_STREAMS","","",N,N],[17,"_SC_2_PBS_CHECKPOINT","","",N,N],[17,"_SC_V6_ILP32_OFF32","","",N,N],[17,"_SC_V6_ILP32_OFFBIG","","",N,N],[17,"_SC_V6_LP64_OFF64","","",N,N],[17,"_SC_V6_LPBIG_OFFBIG","","",N,N],[17,"_SC_HOST_NAME_MAX","","",N,N],[17,"_SC_TRACE","","",N,N],[17,"_SC_TRACE_EVENT_FILTER","","",N,N],[17,"_SC_TRACE_INHERIT","","",N,N],[17,"_SC_TRACE_LOG","","",N,N],[17,"_SC_IPV6","","",N,N],[17,"_SC_RAW_SOCKETS","","",N,N],[17,"_SC_V7_ILP32_OFF32","","",N,N],[17,"_SC_V7_ILP32_OFFBIG","","",N,N],[17,"_SC_V7_LP64_OFF64","","",N,N],[17,"_SC_V7_LPBIG_OFFBIG","","",N,N],[17,"_SC_SS_REPL_MAX","","",N,N],[17,"_SC_TRACE_EVENT_NAME_MAX","","",N,N],[17,"_SC_TRACE_NAME_MAX","","",N,N],[17,"_SC_TRACE_SYS_MAX","","",N,N],[17,"_SC_TRACE_USER_EVENT_MAX","","",N,N],[17,"_SC_XOPEN_STREAMS","","",N,N],[17,"_SC_THREAD_ROBUST_PRIO_INHERIT","","",N,N],[17,"_SC_THREAD_ROBUST_PRIO_PROTECT","","",N,N],[17,"RLIM_SAVED_MAX","","",N,N],[17,"RLIM_SAVED_CUR","","",N,N],[17,"GLOB_ERR","","",N,N],[17,"GLOB_MARK","","",N,N],[17,"GLOB_NOSORT","","",N,N],[17,"GLOB_DOOFFS","","",N,N],[17,"GLOB_NOCHECK","","",N,N],[17,"GLOB_APPEND","","",N,N],[17,"GLOB_NOESCAPE","","",N,N],[17,"GLOB_NOSPACE","","",N,N],[17,"GLOB_ABORTED","","",N,N],[17,"GLOB_NOMATCH","","",N,N],[17,"POSIX_MADV_NORMAL","","",N,N],[17,"POSIX_MADV_RANDOM","","",N,N],[17,"POSIX_MADV_SEQUENTIAL","","",N,N],[17,"POSIX_MADV_WILLNEED","","",N,N],[17,"S_IEXEC","","",N,N],[17,"S_IWRITE","","",N,N],[17,"S_IREAD","","",N,N],[17,"F_LOCK","","",N,N],[17,"F_TEST","","",N,N],[17,"F_TLOCK","","",N,N],[17,"F_ULOCK","","",N,N],[17,"IFF_LOWER_UP","","",N,N],[17,"IFF_DORMANT","","",N,N],[17,"IFF_ECHO","","",N,N],[17,"IFF_TUN","","",N,N],[17,"IFF_TAP","","",N,N],[17,"IFF_NO_PI","","",N,N],[17,"TUN_READQ_SIZE","","",N,N],[17,"TUN_TUN_DEV","","",N,N],[17,"TUN_TAP_DEV","","",N,N],[17,"TUN_TYPE_MASK","","",N,N],[17,"IFF_ONE_QUEUE","","",N,N],[17,"IFF_VNET_HDR","","",N,N],[17,"IFF_TUN_EXCL","","",N,N],[17,"IFF_MULTI_QUEUE","","",N,N],[17,"IFF_ATTACH_QUEUE","","",N,N],[17,"IFF_DETACH_QUEUE","","",N,N],[17,"IFF_PERSIST","","",N,N],[17,"IFF_NOFILTER","","",N,N],[17,"ST_RDONLY","","",N,N],[17,"ST_NOSUID","","",N,N],[17,"ST_NODEV","","",N,N],[17,"ST_NOEXEC","","",N,N],[17,"ST_SYNCHRONOUS","","",N,N],[17,"ST_MANDLOCK","","",N,N],[17,"ST_WRITE","","",N,N],[17,"ST_APPEND","","",N,N],[17,"ST_IMMUTABLE","","",N,N],[17,"ST_NOATIME","","",N,N],[17,"ST_NODIRATIME","","",N,N],[17,"RTLD_NEXT","","",N,N],[17,"RTLD_DEFAULT","","",N,N],[17,"RTLD_NODELETE","","",N,N],[17,"RTLD_NOW","","",N,N],[17,"TCP_MD5SIG","","",N,N],[17,"PTHREAD_MUTEX_INITIALIZER","","",N,N],[17,"PTHREAD_COND_INITIALIZER","","",N,N],[17,"PTHREAD_RWLOCK_INITIALIZER","","",N,N],[17,"PTHREAD_MUTEX_NORMAL","","",N,N],[17,"PTHREAD_MUTEX_RECURSIVE","","",N,N],[17,"PTHREAD_MUTEX_ERRORCHECK","","",N,N],[17,"PTHREAD_MUTEX_DEFAULT","","",N,N],[17,"PTHREAD_PROCESS_PRIVATE","","",N,N],[17,"PTHREAD_PROCESS_SHARED","","",N,N],[17,"__SIZEOF_PTHREAD_COND_T","","",N,N],[17,"RENAME_NOREPLACE","","",N,N],[17,"RENAME_EXCHANGE","","",N,N],[17,"RENAME_WHITEOUT","","",N,N],[17,"SCHED_OTHER","","",N,N],[17,"SCHED_FIFO","","",N,N],[17,"SCHED_RR","","",N,N],[17,"SCHED_BATCH","","",N,N],[17,"SCHED_IDLE","","",N,N],[17,"IPPROTO_HOPOPTS","","Hop-by-hop option header",N,N],[17,"IPPROTO_IGMP","","group mgmt protocol",N,N],[17,"IPPROTO_IPIP","","for compatibility",N,N],[17,"IPPROTO_EGP","","exterior gateway protocol",N,N],[17,"IPPROTO_PUP","","pup",N,N],[17,"IPPROTO_IDP","","xns idp",N,N],[17,"IPPROTO_TP","","tp-4 w/ class negotiation",N,N],[17,"IPPROTO_DCCP","","DCCP",N,N],[17,"IPPROTO_ROUTING","","IP6 routing header",N,N],[17,"IPPROTO_FRAGMENT","","IP6 fragmentation header",N,N],[17,"IPPROTO_RSVP","","resource reservation",N,N],[17,"IPPROTO_GRE","","General Routing Encap.",N,N],[17,"IPPROTO_ESP","","IP6 Encap Sec. Payload",N,N],[17,"IPPROTO_AH","","IP6 Auth Header",N,N],[17,"IPPROTO_NONE","","IP6 no next header",N,N],[17,"IPPROTO_DSTOPTS","","IP6 destination option",N,N],[17,"IPPROTO_MTP","","",N,N],[17,"IPPROTO_BEETPH","","",N,N],[17,"IPPROTO_ENCAP","","encapsulation header",N,N],[17,"IPPROTO_PIM","","Protocol indep. multicast",N,N],[17,"IPPROTO_COMP","","IP Payload Comp. Protocol",N,N],[17,"IPPROTO_SCTP","","SCTP",N,N],[17,"IPPROTO_MH","","",N,N],[17,"IPPROTO_UDPLITE","","",N,N],[17,"IPPROTO_MPLS","","",N,N],[17,"IPPROTO_RAW","","raw IP packet",N,N],[17,"IPPROTO_MAX","","",N,N],[17,"AF_IB","","",N,N],[17,"AF_MPLS","","",N,N],[17,"AF_NFC","","",N,N],[17,"AF_VSOCK","","",N,N],[17,"PF_IB","","",N,N],[17,"PF_MPLS","","",N,N],[17,"PF_NFC","","",N,N],[17,"PF_VSOCK","","",N,N],[17,"IPC_PRIVATE","","",N,N],[17,"IPC_CREAT","","",N,N],[17,"IPC_EXCL","","",N,N],[17,"IPC_NOWAIT","","",N,N],[17,"IPC_RMID","","",N,N],[17,"IPC_SET","","",N,N],[17,"IPC_STAT","","",N,N],[17,"IPC_INFO","","",N,N],[17,"MSG_STAT","","",N,N],[17,"MSG_INFO","","",N,N],[17,"MSG_NOERROR","","",N,N],[17,"MSG_EXCEPT","","",N,N],[17,"MSG_COPY","","",N,N],[17,"SHM_R","","",N,N],[17,"SHM_W","","",N,N],[17,"SHM_RDONLY","","",N,N],[17,"SHM_RND","","",N,N],[17,"SHM_REMAP","","",N,N],[17,"SHM_EXEC","","",N,N],[17,"SHM_LOCK","","",N,N],[17,"SHM_UNLOCK","","",N,N],[17,"SHM_HUGETLB","","",N,N],[17,"SHM_NORESERVE","","",N,N],[17,"EPOLLRDHUP","","",N,N],[17,"EPOLLEXCLUSIVE","","",N,N],[17,"EPOLLONESHOT","","",N,N],[17,"QFMT_VFS_OLD","","",N,N],[17,"QFMT_VFS_V0","","",N,N],[17,"QFMT_VFS_V1","","",N,N],[17,"EFD_SEMAPHORE","","",N,N],[17,"LOG_NFACILITIES","","",N,N],[17,"SEM_FAILED","","",N,N],[17,"RB_AUTOBOOT","","",N,N],[17,"RB_HALT_SYSTEM","","",N,N],[17,"RB_ENABLE_CAD","","",N,N],[17,"RB_DISABLE_CAD","","",N,N],[17,"RB_POWER_OFF","","",N,N],[17,"RB_SW_SUSPEND","","",N,N],[17,"RB_KEXEC","","",N,N],[17,"AI_PASSIVE","","",N,N],[17,"AI_CANONNAME","","",N,N],[17,"AI_NUMERICHOST","","",N,N],[17,"AI_V4MAPPED","","",N,N],[17,"AI_ALL","","",N,N],[17,"AI_ADDRCONFIG","","",N,N],[17,"AI_NUMERICSERV","","",N,N],[17,"EAI_BADFLAGS","","",N,N],[17,"EAI_NONAME","","",N,N],[17,"EAI_AGAIN","","",N,N],[17,"EAI_FAIL","","",N,N],[17,"EAI_NODATA","","",N,N],[17,"EAI_FAMILY","","",N,N],[17,"EAI_SOCKTYPE","","",N,N],[17,"EAI_SERVICE","","",N,N],[17,"EAI_MEMORY","","",N,N],[17,"EAI_SYSTEM","","",N,N],[17,"EAI_OVERFLOW","","",N,N],[17,"NI_NUMERICHOST","","",N,N],[17,"NI_NUMERICSERV","","",N,N],[17,"NI_NOFQDN","","",N,N],[17,"NI_NAMEREQD","","",N,N],[17,"NI_DGRAM","","",N,N],[17,"SYNC_FILE_RANGE_WAIT_BEFORE","","",N,N],[17,"SYNC_FILE_RANGE_WRITE","","",N,N],[17,"SYNC_FILE_RANGE_WAIT_AFTER","","",N,N],[17,"AIO_CANCELED","","",N,N],[17,"AIO_NOTCANCELED","","",N,N],[17,"AIO_ALLDONE","","",N,N],[17,"LIO_READ","","",N,N],[17,"LIO_WRITE","","",N,N],[17,"LIO_NOP","","",N,N],[17,"LIO_WAIT","","",N,N],[17,"LIO_NOWAIT","","",N,N],[17,"MREMAP_MAYMOVE","","",N,N],[17,"MREMAP_FIXED","","",N,N],[17,"PR_SET_PDEATHSIG","","",N,N],[17,"PR_GET_PDEATHSIG","","",N,N],[17,"PR_GET_DUMPABLE","","",N,N],[17,"PR_SET_DUMPABLE","","",N,N],[17,"PR_GET_UNALIGN","","",N,N],[17,"PR_SET_UNALIGN","","",N,N],[17,"PR_UNALIGN_NOPRINT","","",N,N],[17,"PR_UNALIGN_SIGBUS","","",N,N],[17,"PR_GET_KEEPCAPS","","",N,N],[17,"PR_SET_KEEPCAPS","","",N,N],[17,"PR_GET_FPEMU","","",N,N],[17,"PR_SET_FPEMU","","",N,N],[17,"PR_FPEMU_NOPRINT","","",N,N],[17,"PR_FPEMU_SIGFPE","","",N,N],[17,"PR_GET_FPEXC","","",N,N],[17,"PR_SET_FPEXC","","",N,N],[17,"PR_FP_EXC_SW_ENABLE","","",N,N],[17,"PR_FP_EXC_DIV","","",N,N],[17,"PR_FP_EXC_OVF","","",N,N],[17,"PR_FP_EXC_UND","","",N,N],[17,"PR_FP_EXC_RES","","",N,N],[17,"PR_FP_EXC_INV","","",N,N],[17,"PR_FP_EXC_DISABLED","","",N,N],[17,"PR_FP_EXC_NONRECOV","","",N,N],[17,"PR_FP_EXC_ASYNC","","",N,N],[17,"PR_FP_EXC_PRECISE","","",N,N],[17,"PR_GET_TIMING","","",N,N],[17,"PR_SET_TIMING","","",N,N],[17,"PR_TIMING_STATISTICAL","","",N,N],[17,"PR_TIMING_TIMESTAMP","","",N,N],[17,"PR_SET_NAME","","",N,N],[17,"PR_GET_NAME","","",N,N],[17,"PR_GET_ENDIAN","","",N,N],[17,"PR_SET_ENDIAN","","",N,N],[17,"PR_ENDIAN_BIG","","",N,N],[17,"PR_ENDIAN_LITTLE","","",N,N],[17,"PR_ENDIAN_PPC_LITTLE","","",N,N],[17,"PR_GET_SECCOMP","","",N,N],[17,"PR_SET_SECCOMP","","",N,N],[17,"PR_CAPBSET_READ","","",N,N],[17,"PR_CAPBSET_DROP","","",N,N],[17,"PR_GET_TSC","","",N,N],[17,"PR_SET_TSC","","",N,N],[17,"PR_TSC_ENABLE","","",N,N],[17,"PR_TSC_SIGSEGV","","",N,N],[17,"PR_GET_SECUREBITS","","",N,N],[17,"PR_SET_SECUREBITS","","",N,N],[17,"PR_SET_TIMERSLACK","","",N,N],[17,"PR_GET_TIMERSLACK","","",N,N],[17,"PR_TASK_PERF_EVENTS_DISABLE","","",N,N],[17,"PR_TASK_PERF_EVENTS_ENABLE","","",N,N],[17,"PR_MCE_KILL","","",N,N],[17,"PR_MCE_KILL_CLEAR","","",N,N],[17,"PR_MCE_KILL_SET","","",N,N],[17,"PR_MCE_KILL_LATE","","",N,N],[17,"PR_MCE_KILL_EARLY","","",N,N],[17,"PR_MCE_KILL_DEFAULT","","",N,N],[17,"PR_MCE_KILL_GET","","",N,N],[17,"PR_SET_MM","","",N,N],[17,"PR_SET_MM_START_CODE","","",N,N],[17,"PR_SET_MM_END_CODE","","",N,N],[17,"PR_SET_MM_START_DATA","","",N,N],[17,"PR_SET_MM_END_DATA","","",N,N],[17,"PR_SET_MM_START_STACK","","",N,N],[17,"PR_SET_MM_START_BRK","","",N,N],[17,"PR_SET_MM_BRK","","",N,N],[17,"PR_SET_MM_ARG_START","","",N,N],[17,"PR_SET_MM_ARG_END","","",N,N],[17,"PR_SET_MM_ENV_START","","",N,N],[17,"PR_SET_MM_ENV_END","","",N,N],[17,"PR_SET_MM_AUXV","","",N,N],[17,"PR_SET_MM_EXE_FILE","","",N,N],[17,"PR_SET_MM_MAP","","",N,N],[17,"PR_SET_MM_MAP_SIZE","","",N,N],[17,"PR_SET_PTRACER","","",N,N],[17,"PR_SET_CHILD_SUBREAPER","","",N,N],[17,"PR_GET_CHILD_SUBREAPER","","",N,N],[17,"PR_SET_NO_NEW_PRIVS","","",N,N],[17,"PR_GET_NO_NEW_PRIVS","","",N,N],[17,"PR_GET_TID_ADDRESS","","",N,N],[17,"PR_SET_THP_DISABLE","","",N,N],[17,"PR_GET_THP_DISABLE","","",N,N],[17,"PR_MPX_ENABLE_MANAGEMENT","","",N,N],[17,"PR_MPX_DISABLE_MANAGEMENT","","",N,N],[17,"PR_SET_FP_MODE","","",N,N],[17,"PR_GET_FP_MODE","","",N,N],[17,"PR_FP_MODE_FR","","",N,N],[17,"PR_FP_MODE_FRE","","",N,N],[17,"PR_CAP_AMBIENT","","",N,N],[17,"PR_CAP_AMBIENT_IS_SET","","",N,N],[17,"PR_CAP_AMBIENT_RAISE","","",N,N],[17,"PR_CAP_AMBIENT_LOWER","","",N,N],[17,"PR_CAP_AMBIENT_CLEAR_ALL","","",N,N],[17,"GRND_NONBLOCK","","",N,N],[17,"GRND_RANDOM","","",N,N],[17,"SECCOMP_MODE_DISABLED","","",N,N],[17,"SECCOMP_MODE_STRICT","","",N,N],[17,"SECCOMP_MODE_FILTER","","",N,N],[17,"ITIMER_REAL","","",N,N],[17,"ITIMER_VIRTUAL","","",N,N],[17,"ITIMER_PROF","","",N,N],[17,"TFD_CLOEXEC","","",N,N],[17,"TFD_NONBLOCK","","",N,N],[17,"TFD_TIMER_ABSTIME","","",N,N],[17,"XATTR_CREATE","","",N,N],[17,"XATTR_REPLACE","","",N,N],[17,"_POSIX_VDISABLE","","",N,N],[17,"FALLOC_FL_KEEP_SIZE","","",N,N],[17,"FALLOC_FL_PUNCH_HOLE","","",N,N],[17,"FALLOC_FL_COLLAPSE_RANGE","","",N,N],[17,"FALLOC_FL_ZERO_RANGE","","",N,N],[17,"FALLOC_FL_INSERT_RANGE","","",N,N],[17,"FALLOC_FL_UNSHARE_RANGE","","",N,N],[17,"ENOATTR","","",N,N],[17,"SO_ORIGINAL_DST","","",N,N],[17,"IUTF8","","",N,N],[17,"CMSPAR","","",N,N],[17,"MFD_CLOEXEC","","",N,N],[17,"MFD_ALLOW_SEALING","","",N,N],[17,"PT_NULL","","",N,N],[17,"PT_LOAD","","",N,N],[17,"PT_DYNAMIC","","",N,N],[17,"PT_INTERP","","",N,N],[17,"PT_NOTE","","",N,N],[17,"PT_SHLIB","","",N,N],[17,"PT_PHDR","","",N,N],[17,"PT_TLS","","",N,N],[17,"PT_NUM","","",N,N],[17,"PT_LOOS","","",N,N],[17,"PT_GNU_EH_FRAME","","",N,N],[17,"PT_GNU_STACK","","",N,N],[17,"PT_GNU_RELRO","","",N,N],[17,"ETH_ALEN","","",N,N],[17,"ETH_HLEN","","",N,N],[17,"ETH_ZLEN","","",N,N],[17,"ETH_DATA_LEN","","",N,N],[17,"ETH_FRAME_LEN","","",N,N],[17,"ETH_FCS_LEN","","",N,N],[17,"ETH_P_LOOP","","",N,N],[17,"ETH_P_PUP","","",N,N],[17,"ETH_P_PUPAT","","",N,N],[17,"ETH_P_IP","","",N,N],[17,"ETH_P_X25","","",N,N],[17,"ETH_P_ARP","","",N,N],[17,"ETH_P_BPQ","","",N,N],[17,"ETH_P_IEEEPUP","","",N,N],[17,"ETH_P_IEEEPUPAT","","",N,N],[17,"ETH_P_BATMAN","","",N,N],[17,"ETH_P_DEC","","",N,N],[17,"ETH_P_DNA_DL","","",N,N],[17,"ETH_P_DNA_RC","","",N,N],[17,"ETH_P_DNA_RT","","",N,N],[17,"ETH_P_LAT","","",N,N],[17,"ETH_P_DIAG","","",N,N],[17,"ETH_P_CUST","","",N,N],[17,"ETH_P_SCA","","",N,N],[17,"ETH_P_TEB","","",N,N],[17,"ETH_P_RARP","","",N,N],[17,"ETH_P_ATALK","","",N,N],[17,"ETH_P_AARP","","",N,N],[17,"ETH_P_8021Q","","",N,N],[17,"ETH_P_IPX","","",N,N],[17,"ETH_P_IPV6","","",N,N],[17,"ETH_P_PAUSE","","",N,N],[17,"ETH_P_SLOW","","",N,N],[17,"ETH_P_WCCP","","",N,N],[17,"ETH_P_MPLS_UC","","",N,N],[17,"ETH_P_MPLS_MC","","",N,N],[17,"ETH_P_ATMMPOA","","",N,N],[17,"ETH_P_PPP_DISC","","",N,N],[17,"ETH_P_PPP_SES","","",N,N],[17,"ETH_P_LINK_CTL","","",N,N],[17,"ETH_P_ATMFATE","","",N,N],[17,"ETH_P_PAE","","",N,N],[17,"ETH_P_AOE","","",N,N],[17,"ETH_P_8021AD","","",N,N],[17,"ETH_P_802_EX1","","",N,N],[17,"ETH_P_TIPC","","",N,N],[17,"ETH_P_MACSEC","","",N,N],[17,"ETH_P_8021AH","","",N,N],[17,"ETH_P_MVRP","","",N,N],[17,"ETH_P_1588","","",N,N],[17,"ETH_P_PRP","","",N,N],[17,"ETH_P_FCOE","","",N,N],[17,"ETH_P_TDLS","","",N,N],[17,"ETH_P_FIP","","",N,N],[17,"ETH_P_80221","","",N,N],[17,"ETH_P_LOOPBACK","","",N,N],[17,"ETH_P_QINQ1","","",N,N],[17,"ETH_P_QINQ2","","",N,N],[17,"ETH_P_QINQ3","","",N,N],[17,"ETH_P_EDSA","","",N,N],[17,"ETH_P_AF_IUCV","","",N,N],[17,"ETH_P_802_3_MIN","","",N,N],[17,"ETH_P_802_3","","",N,N],[17,"ETH_P_AX25","","",N,N],[17,"ETH_P_ALL","","",N,N],[17,"ETH_P_802_2","","",N,N],[17,"ETH_P_SNAP","","",N,N],[17,"ETH_P_DDCMP","","",N,N],[17,"ETH_P_WAN_PPP","","",N,N],[17,"ETH_P_PPP_MP","","",N,N],[17,"ETH_P_LOCALTALK","","",N,N],[17,"ETH_P_CANFD","","",N,N],[17,"ETH_P_PPPTALK","","",N,N],[17,"ETH_P_TR_802_2","","",N,N],[17,"ETH_P_MOBITEX","","",N,N],[17,"ETH_P_CONTROL","","",N,N],[17,"ETH_P_IRDA","","",N,N],[17,"ETH_P_ECONET","","",N,N],[17,"ETH_P_HDLC","","",N,N],[17,"ETH_P_ARCNET","","",N,N],[17,"ETH_P_DSA","","",N,N],[17,"ETH_P_TRAILER","","",N,N],[17,"ETH_P_PHONET","","",N,N],[17,"ETH_P_IEEE802154","","",N,N],[17,"ETH_P_CAIF","","",N,N],[17,"POSIX_SPAWN_RESETIDS","","",N,N],[17,"POSIX_SPAWN_SETPGROUP","","",N,N],[17,"POSIX_SPAWN_SETSIGDEF","","",N,N],[17,"POSIX_SPAWN_SETSIGMASK","","",N,N],[17,"POSIX_SPAWN_SETSCHEDPARAM","","",N,N],[17,"POSIX_SPAWN_SETSCHEDULER","","",N,N],[17,"NLMSG_NOOP","","",N,N],[17,"NLMSG_ERROR","","",N,N],[17,"NLMSG_DONE","","",N,N],[17,"NLMSG_OVERRUN","","",N,N],[17,"NLMSG_MIN_TYPE","","",N,N],[17,"GENL_NAMSIZ","","",N,N],[17,"GENL_MIN_ID","","",N,N],[17,"GENL_MAX_ID","","",N,N],[17,"GENL_ADMIN_PERM","","",N,N],[17,"GENL_CMD_CAP_DO","","",N,N],[17,"GENL_CMD_CAP_DUMP","","",N,N],[17,"GENL_CMD_CAP_HASPOL","","",N,N],[17,"GENL_ID_CTRL","","",N,N],[17,"CTRL_CMD_UNSPEC","","",N,N],[17,"CTRL_CMD_NEWFAMILY","","",N,N],[17,"CTRL_CMD_DELFAMILY","","",N,N],[17,"CTRL_CMD_GETFAMILY","","",N,N],[17,"CTRL_CMD_NEWOPS","","",N,N],[17,"CTRL_CMD_DELOPS","","",N,N],[17,"CTRL_CMD_GETOPS","","",N,N],[17,"CTRL_CMD_NEWMCAST_GRP","","",N,N],[17,"CTRL_CMD_DELMCAST_GRP","","",N,N],[17,"CTRL_CMD_GETMCAST_GRP","","",N,N],[17,"CTRL_ATTR_UNSPEC","","",N,N],[17,"CTRL_ATTR_FAMILY_ID","","",N,N],[17,"CTRL_ATTR_FAMILY_NAME","","",N,N],[17,"CTRL_ATTR_VERSION","","",N,N],[17,"CTRL_ATTR_HDRSIZE","","",N,N],[17,"CTRL_ATTR_MAXATTR","","",N,N],[17,"CTRL_ATTR_OPS","","",N,N],[17,"CTRL_ATTR_MCAST_GROUPS","","",N,N],[17,"CTRL_ATTR_OP_UNSPEC","","",N,N],[17,"CTRL_ATTR_OP_ID","","",N,N],[17,"CTRL_ATTR_OP_FLAGS","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_UNSPEC","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_NAME","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_ID","","",N,N],[17,"PACKET_ADD_MEMBERSHIP","","",N,N],[17,"PACKET_DROP_MEMBERSHIP","","",N,N],[17,"PACKET_MR_MULTICAST","","",N,N],[17,"PACKET_MR_PROMISC","","",N,N],[17,"PACKET_MR_ALLMULTI","","",N,N],[17,"PACKET_MR_UNICAST","","",N,N],[17,"NF_DROP","","",N,N],[17,"NF_ACCEPT","","",N,N],[17,"NF_STOLEN","","",N,N],[17,"NF_QUEUE","","",N,N],[17,"NF_REPEAT","","",N,N],[17,"NF_STOP","","",N,N],[17,"NF_MAX_VERDICT","","",N,N],[17,"NF_VERDICT_MASK","","",N,N],[17,"NF_VERDICT_FLAG_QUEUE_BYPASS","","",N,N],[17,"NF_VERDICT_QMASK","","",N,N],[17,"NF_VERDICT_QBITS","","",N,N],[17,"NF_VERDICT_BITS","","",N,N],[17,"NF_INET_PRE_ROUTING","","",N,N],[17,"NF_INET_LOCAL_IN","","",N,N],[17,"NF_INET_FORWARD","","",N,N],[17,"NF_INET_LOCAL_OUT","","",N,N],[17,"NF_INET_POST_ROUTING","","",N,N],[17,"NF_INET_NUMHOOKS","","",N,N],[17,"NFPROTO_UNSPEC","","",N,N],[17,"NFPROTO_IPV4","","",N,N],[17,"NFPROTO_ARP","","",N,N],[17,"NFPROTO_BRIDGE","","",N,N],[17,"NFPROTO_IPV6","","",N,N],[17,"NFPROTO_DECNET","","",N,N],[17,"NFPROTO_NUMPROTO","","",N,N],[17,"NF_IP_PRE_ROUTING","","",N,N],[17,"NF_IP_LOCAL_IN","","",N,N],[17,"NF_IP_FORWARD","","",N,N],[17,"NF_IP_LOCAL_OUT","","",N,N],[17,"NF_IP_POST_ROUTING","","",N,N],[17,"NF_IP_NUMHOOKS","","",N,N],[17,"NF_IP_PRI_FIRST","","",N,N],[17,"NF_IP_PRI_CONNTRACK_DEFRAG","","",N,N],[17,"NF_IP_PRI_RAW","","",N,N],[17,"NF_IP_PRI_SELINUX_FIRST","","",N,N],[17,"NF_IP_PRI_CONNTRACK","","",N,N],[17,"NF_IP_PRI_MANGLE","","",N,N],[17,"NF_IP_PRI_NAT_DST","","",N,N],[17,"NF_IP_PRI_FILTER","","",N,N],[17,"NF_IP_PRI_SECURITY","","",N,N],[17,"NF_IP_PRI_NAT_SRC","","",N,N],[17,"NF_IP_PRI_SELINUX_LAST","","",N,N],[17,"NF_IP_PRI_CONNTRACK_HELPER","","",N,N],[17,"NF_IP_PRI_CONNTRACK_CONFIRM","","",N,N],[17,"NF_IP_PRI_LAST","","",N,N],[17,"NF_IP6_PRE_ROUTING","","",N,N],[17,"NF_IP6_LOCAL_IN","","",N,N],[17,"NF_IP6_FORWARD","","",N,N],[17,"NF_IP6_LOCAL_OUT","","",N,N],[17,"NF_IP6_POST_ROUTING","","",N,N],[17,"NF_IP6_NUMHOOKS","","",N,N],[17,"NF_IP6_PRI_FIRST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK_DEFRAG","","",N,N],[17,"NF_IP6_PRI_RAW","","",N,N],[17,"NF_IP6_PRI_SELINUX_FIRST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK","","",N,N],[17,"NF_IP6_PRI_MANGLE","","",N,N],[17,"NF_IP6_PRI_NAT_DST","","",N,N],[17,"NF_IP6_PRI_FILTER","","",N,N],[17,"NF_IP6_PRI_SECURITY","","",N,N],[17,"NF_IP6_PRI_NAT_SRC","","",N,N],[17,"NF_IP6_PRI_SELINUX_LAST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK_HELPER","","",N,N],[17,"NF_IP6_PRI_LAST","","",N,N],[17,"SIOCADDRT","","",N,N],[17,"SIOCDELRT","","",N,N],[17,"SIOCGIFNAME","","",N,N],[17,"SIOCSIFLINK","","",N,N],[17,"SIOCGIFCONF","","",N,N],[17,"SIOCGIFFLAGS","","",N,N],[17,"SIOCSIFFLAGS","","",N,N],[17,"SIOCGIFADDR","","",N,N],[17,"SIOCSIFADDR","","",N,N],[17,"SIOCGIFDSTADDR","","",N,N],[17,"SIOCSIFDSTADDR","","",N,N],[17,"SIOCGIFBRDADDR","","",N,N],[17,"SIOCSIFBRDADDR","","",N,N],[17,"SIOCGIFNETMASK","","",N,N],[17,"SIOCSIFNETMASK","","",N,N],[17,"SIOCGIFMETRIC","","",N,N],[17,"SIOCSIFMETRIC","","",N,N],[17,"SIOCGIFMEM","","",N,N],[17,"SIOCSIFMEM","","",N,N],[17,"SIOCGIFMTU","","",N,N],[17,"SIOCSIFMTU","","",N,N],[17,"SIOCSIFHWADDR","","",N,N],[17,"SIOCGIFENCAP","","",N,N],[17,"SIOCSIFENCAP","","",N,N],[17,"SIOCGIFHWADDR","","",N,N],[17,"SIOCGIFSLAVE","","",N,N],[17,"SIOCSIFSLAVE","","",N,N],[17,"SIOCADDMULTI","","",N,N],[17,"SIOCDELMULTI","","",N,N],[17,"SIOCDARP","","",N,N],[17,"SIOCGARP","","",N,N],[17,"SIOCSARP","","",N,N],[17,"SIOCDRARP","","",N,N],[17,"SIOCGRARP","","",N,N],[17,"SIOCSRARP","","",N,N],[17,"SIOCGIFMAP","","",N,N],[17,"SIOCSIFMAP","","",N,N],[17,"IPTOS_TOS_MASK","","",N,N],[17,"IPTOS_PREC_MASK","","",N,N],[17,"RTF_UP","","",N,N],[17,"RTF_GATEWAY","","",N,N],[17,"RTF_HOST","","",N,N],[17,"RTF_REINSTATE","","",N,N],[17,"RTF_DYNAMIC","","",N,N],[17,"RTF_MODIFIED","","",N,N],[17,"RTF_MTU","","",N,N],[17,"RTF_MSS","","",N,N],[17,"RTF_WINDOW","","",N,N],[17,"RTF_IRTT","","",N,N],[17,"RTF_REJECT","","",N,N],[17,"RTF_STATIC","","",N,N],[17,"RTF_XRESOLVE","","",N,N],[17,"RTF_NOFORWARD","","",N,N],[17,"RTF_THROW","","",N,N],[17,"RTF_NOPMTUDISC","","",N,N],[17,"RTF_DEFAULT","","",N,N],[17,"RTF_ALLONLINK","","",N,N],[17,"RTF_ADDRCONF","","",N,N],[17,"RTF_LINKRT","","",N,N],[17,"RTF_NONEXTHOP","","",N,N],[17,"RTF_CACHE","","",N,N],[17,"RTF_FLOW","","",N,N],[17,"RTF_POLICY","","",N,N],[17,"RTCF_VALVE","","",N,N],[17,"RTCF_MASQ","","",N,N],[17,"RTCF_NAT","","",N,N],[17,"RTCF_DOREDIRECT","","",N,N],[17,"RTCF_LOG","","",N,N],[17,"RTCF_DIRECTSRC","","",N,N],[17,"RTF_LOCAL","","",N,N],[17,"RTF_INTERFACE","","",N,N],[17,"RTF_MULTICAST","","",N,N],[17,"RTF_BROADCAST","","",N,N],[17,"RTF_NAT","","",N,N],[17,"RTF_ADDRCLASSMASK","","",N,N],[17,"RT_CLASS_UNSPEC","","",N,N],[17,"RT_CLASS_DEFAULT","","",N,N],[17,"RT_CLASS_MAIN","","",N,N],[17,"RT_CLASS_LOCAL","","",N,N],[17,"RT_CLASS_MAX","","",N,N],[17,"RTMSG_OVERRUN","","",N,N],[17,"RTMSG_NEWDEVICE","","",N,N],[17,"RTMSG_DELDEVICE","","",N,N],[17,"RTMSG_NEWROUTE","","",N,N],[17,"RTMSG_DELROUTE","","",N,N],[17,"RTMSG_NEWRULE","","",N,N],[17,"RTMSG_DELRULE","","",N,N],[17,"RTMSG_CONTROL","","",N,N],[17,"RTMSG_AR_FAILED","","",N,N],[17,"MAX_ADDR_LEN","","",N,N],[17,"ARPD_UPDATE","","",N,N],[17,"ARPD_LOOKUP","","",N,N],[17,"ARPD_FLUSH","","",N,N],[17,"ATF_MAGIC","","",N,N],[17,"MODULE_INIT_IGNORE_MODVERSIONS","","",N,N],[17,"MODULE_INIT_IGNORE_VERMAGIC","","",N,N],[11,"clone","libc","",42,[[["self"]],["dirent"]]],[11,"clone","","",43,[[["self"]],["dirent64"]]],[11,"clone","","",44,[[["self"]],["rlimit64"]]],[11,"clone","","",45,[[["self"]],["glob_t"]]],[11,"clone","","",46,[[["self"]],["pthread_mutex_t"]]],[11,"clone","","",47,[[["self"]],["pthread_rwlock_t"]]],[11,"clone","","",48,[[["self"]],["pthread_mutexattr_t"]]],[11,"clone","","",49,[[["self"]],["pthread_rwlockattr_t"]]],[11,"clone","","",50,[[["self"]],["pthread_cond_t"]]],[11,"clone","","",51,[[["self"]],["pthread_condattr_t"]]],[11,"clone","","",52,[[["self"]],["passwd"]]],[11,"clone","","",53,[[["self"]],["spwd"]]],[11,"clone","","",54,[[["self"]],["dqblk"]]],[11,"clone","","",55,[[["self"]],["signalfd_siginfo"]]],[11,"clone","","",56,[[["self"]],["itimerspec"]]],[11,"clone","","",57,[[["self"]],["fsid_t"]]],[11,"clone","","",58,[[["self"]],["mq_attr"]]],[11,"clone","","",59,[[["self"]],["packet_mreq"]]],[11,"clone","","",60,[[["self"]],["cpu_set_t"]]],[11,"clone","","",61,[[["self"]],["if_nameindex"]]],[11,"clone","","",62,[[["self"]],["msginfo"]]],[11,"clone","","",63,[[["self"]],["mmsghdr"]]],[11,"clone","","",64,[[["self"]],["sembuf"]]],[11,"clone","","",65,[[["self"]],["input_event"]]],[11,"clone","","",66,[[["self"]],["input_id"]]],[11,"clone","","",67,[[["self"]],["input_absinfo"]]],[11,"clone","","",68,[[["self"]],["input_keymap_entry"]]],[11,"clone","","",69,[[["self"]],["input_mask"]]],[11,"clone","","",70,[[["self"]],["ff_replay"]]],[11,"clone","","",71,[[["self"]],["ff_trigger"]]],[11,"clone","","",72,[[["self"]],["ff_envelope"]]],[11,"clone","","",73,[[["self"]],["ff_constant_effect"]]],[11,"clone","","",74,[[["self"]],["ff_ramp_effect"]]],[11,"clone","","",75,[[["self"]],["ff_condition_effect"]]],[11,"clone","","",76,[[["self"]],["ff_periodic_effect"]]],[11,"clone","","",77,[[["self"]],["ff_rumble_effect"]]],[11,"clone","","",78,[[["self"]],["ff_effect"]]],[11,"clone","","",79,[[["self"]],["dl_phdr_info"]]],[11,"clone","","",80,[[["self"]],["elf32_phdr"]]],[11,"clone","","",81,[[["self"]],["elf64_phdr"]]],[11,"clone","","",82,[[["self"]],["ucred"]]],[11,"clone","","",83,[[["self"]],["mntent"]]],[11,"clone","","",84,[[["self"]],["posix_spawn_file_actions_t"]]],[11,"clone","","",85,[[["self"]],["posix_spawnattr_t"]]],[11,"clone","","",86,[[["self"]],["genlmsghdr"]]],[11,"clone","","",87,[[["self"]],["in6_pktinfo"]]],[11,"clone","","",88,[[["self"]],["arpd_request"]]],[6,"sa_family_t","libc::unix::notbsd","",N,N],[6,"pthread_key_t","","",N,N],[6,"speed_t","","",N,N],[6,"tcflag_t","","",N,N],[6,"clockid_t","","",N,N],[6,"key_t","","",N,N],[6,"id_t","","",N,N],[17,"ULONG_SIZE","","",N,N],[17,"EXIT_FAILURE","","",N,N],[17,"EXIT_SUCCESS","","",N,N],[17,"RAND_MAX","","",N,N],[17,"EOF","","",N,N],[17,"SEEK_SET","","",N,N],[17,"SEEK_CUR","","",N,N],[17,"SEEK_END","","",N,N],[17,"_IOFBF","","",N,N],[17,"_IONBF","","",N,N],[17,"_IOLBF","","",N,N],[17,"F_DUPFD","","",N,N],[17,"F_GETFD","","",N,N],[17,"F_SETFD","","",N,N],[17,"F_GETFL","","",N,N],[17,"F_SETFL","","",N,N],[17,"F_SETLEASE","","",N,N],[17,"F_GETLEASE","","",N,N],[17,"F_NOTIFY","","",N,N],[17,"F_CANCELLK","","",N,N],[17,"F_DUPFD_CLOEXEC","","",N,N],[17,"F_SETPIPE_SZ","","",N,N],[17,"F_GETPIPE_SZ","","",N,N],[17,"F_ADD_SEALS","","",N,N],[17,"F_GET_SEALS","","",N,N],[17,"F_SEAL_SEAL","","",N,N],[17,"F_SEAL_SHRINK","","",N,N],[17,"F_SEAL_GROW","","",N,N],[17,"F_SEAL_WRITE","","",N,N],[17,"SIGTRAP","","",N,N],[17,"PTHREAD_CREATE_JOINABLE","","",N,N],[17,"PTHREAD_CREATE_DETACHED","","",N,N],[17,"CLOCK_REALTIME","","",N,N],[17,"CLOCK_MONOTONIC","","",N,N],[17,"CLOCK_PROCESS_CPUTIME_ID","","",N,N],[17,"CLOCK_THREAD_CPUTIME_ID","","",N,N],[17,"CLOCK_MONOTONIC_RAW","","",N,N],[17,"CLOCK_REALTIME_COARSE","","",N,N],[17,"CLOCK_MONOTONIC_COARSE","","",N,N],[17,"CLOCK_BOOTTIME","","",N,N],[17,"CLOCK_REALTIME_ALARM","","",N,N],[17,"CLOCK_BOOTTIME_ALARM","","",N,N],[17,"TIMER_ABSTIME","","",N,N],[17,"RLIMIT_CPU","","",N,N],[17,"RLIMIT_FSIZE","","",N,N],[17,"RLIMIT_DATA","","",N,N],[17,"RLIMIT_STACK","","",N,N],[17,"RLIMIT_CORE","","",N,N],[17,"RLIMIT_LOCKS","","",N,N],[17,"RLIMIT_SIGPENDING","","",N,N],[17,"RLIMIT_MSGQUEUE","","",N,N],[17,"RLIMIT_NICE","","",N,N],[17,"RLIMIT_RTPRIO","","",N,N],[17,"RUSAGE_SELF","","",N,N],[17,"O_RDONLY","","",N,N],[17,"O_WRONLY","","",N,N],[17,"O_RDWR","","",N,N],[17,"SOCK_CLOEXEC","","",N,N],[17,"S_IFIFO","","",N,N],[17,"S_IFCHR","","",N,N],[17,"S_IFBLK","","",N,N],[17,"S_IFDIR","","",N,N],[17,"S_IFREG","","",N,N],[17,"S_IFLNK","","",N,N],[17,"S_IFSOCK","","",N,N],[17,"S_IFMT","","",N,N],[17,"S_IRWXU","","",N,N],[17,"S_IXUSR","","",N,N],[17,"S_IWUSR","","",N,N],[17,"S_IRUSR","","",N,N],[17,"S_IRWXG","","",N,N],[17,"S_IXGRP","","",N,N],[17,"S_IWGRP","","",N,N],[17,"S_IRGRP","","",N,N],[17,"S_IRWXO","","",N,N],[17,"S_IXOTH","","",N,N],[17,"S_IWOTH","","",N,N],[17,"S_IROTH","","",N,N],[17,"F_OK","","",N,N],[17,"R_OK","","",N,N],[17,"W_OK","","",N,N],[17,"X_OK","","",N,N],[17,"STDIN_FILENO","","",N,N],[17,"STDOUT_FILENO","","",N,N],[17,"STDERR_FILENO","","",N,N],[17,"SIGHUP","","",N,N],[17,"SIGINT","","",N,N],[17,"SIGQUIT","","",N,N],[17,"SIGILL","","",N,N],[17,"SIGABRT","","",N,N],[17,"SIGFPE","","",N,N],[17,"SIGKILL","","",N,N],[17,"SIGSEGV","","",N,N],[17,"SIGPIPE","","",N,N],[17,"SIGALRM","","",N,N],[17,"SIGTERM","","",N,N],[17,"PROT_NONE","","",N,N],[17,"PROT_READ","","",N,N],[17,"PROT_WRITE","","",N,N],[17,"PROT_EXEC","","",N,N],[17,"LC_CTYPE","","",N,N],[17,"LC_NUMERIC","","",N,N],[17,"LC_TIME","","",N,N],[17,"LC_COLLATE","","",N,N],[17,"LC_MONETARY","","",N,N],[17,"LC_MESSAGES","","",N,N],[17,"LC_ALL","","",N,N],[17,"LC_CTYPE_MASK","","",N,N],[17,"LC_NUMERIC_MASK","","",N,N],[17,"LC_TIME_MASK","","",N,N],[17,"LC_COLLATE_MASK","","",N,N],[17,"LC_MONETARY_MASK","","",N,N],[17,"LC_MESSAGES_MASK","","",N,N],[17,"MAP_FILE","","",N,N],[17,"MAP_SHARED","","",N,N],[17,"MAP_PRIVATE","","",N,N],[17,"MAP_FIXED","","",N,N],[17,"MAP_FAILED","","",N,N],[17,"MS_ASYNC","","",N,N],[17,"MS_INVALIDATE","","",N,N],[17,"MS_SYNC","","",N,N],[17,"MS_RDONLY","","",N,N],[17,"MS_NOSUID","","",N,N],[17,"MS_NODEV","","",N,N],[17,"MS_NOEXEC","","",N,N],[17,"MS_SYNCHRONOUS","","",N,N],[17,"MS_REMOUNT","","",N,N],[17,"MS_MANDLOCK","","",N,N],[17,"MS_DIRSYNC","","",N,N],[17,"MS_NOATIME","","",N,N],[17,"MS_NODIRATIME","","",N,N],[17,"MS_BIND","","",N,N],[17,"MS_MOVE","","",N,N],[17,"MS_REC","","",N,N],[17,"MS_SILENT","","",N,N],[17,"MS_POSIXACL","","",N,N],[17,"MS_UNBINDABLE","","",N,N],[17,"MS_PRIVATE","","",N,N],[17,"MS_SLAVE","","",N,N],[17,"MS_SHARED","","",N,N],[17,"MS_RELATIME","","",N,N],[17,"MS_KERNMOUNT","","",N,N],[17,"MS_I_VERSION","","",N,N],[17,"MS_STRICTATIME","","",N,N],[17,"MS_ACTIVE","","",N,N],[17,"MS_NOUSER","","",N,N],[17,"MS_MGC_VAL","","",N,N],[17,"MS_MGC_MSK","","",N,N],[17,"MS_RMT_MASK","","",N,N],[17,"EPERM","","",N,N],[17,"ENOENT","","",N,N],[17,"ESRCH","","",N,N],[17,"EINTR","","",N,N],[17,"EIO","","",N,N],[17,"ENXIO","","",N,N],[17,"E2BIG","","",N,N],[17,"ENOEXEC","","",N,N],[17,"EBADF","","",N,N],[17,"ECHILD","","",N,N],[17,"EAGAIN","","",N,N],[17,"ENOMEM","","",N,N],[17,"EACCES","","",N,N],[17,"EFAULT","","",N,N],[17,"ENOTBLK","","",N,N],[17,"EBUSY","","",N,N],[17,"EEXIST","","",N,N],[17,"EXDEV","","",N,N],[17,"ENODEV","","",N,N],[17,"ENOTDIR","","",N,N],[17,"EISDIR","","",N,N],[17,"EINVAL","","",N,N],[17,"ENFILE","","",N,N],[17,"EMFILE","","",N,N],[17,"ENOTTY","","",N,N],[17,"ETXTBSY","","",N,N],[17,"EFBIG","","",N,N],[17,"ENOSPC","","",N,N],[17,"ESPIPE","","",N,N],[17,"EROFS","","",N,N],[17,"EMLINK","","",N,N],[17,"EPIPE","","",N,N],[17,"EDOM","","",N,N],[17,"ERANGE","","",N,N],[17,"EWOULDBLOCK","","",N,N],[17,"SCM_RIGHTS","","",N,N],[17,"SCM_CREDENTIALS","","",N,N],[17,"PROT_GROWSDOWN","","",N,N],[17,"PROT_GROWSUP","","",N,N],[17,"MAP_TYPE","","",N,N],[17,"MADV_NORMAL","","",N,N],[17,"MADV_RANDOM","","",N,N],[17,"MADV_SEQUENTIAL","","",N,N],[17,"MADV_WILLNEED","","",N,N],[17,"MADV_DONTNEED","","",N,N],[17,"MADV_FREE","","",N,N],[17,"MADV_REMOVE","","",N,N],[17,"MADV_DONTFORK","","",N,N],[17,"MADV_DOFORK","","",N,N],[17,"MADV_MERGEABLE","","",N,N],[17,"MADV_UNMERGEABLE","","",N,N],[17,"MADV_HUGEPAGE","","",N,N],[17,"MADV_NOHUGEPAGE","","",N,N],[17,"MADV_DONTDUMP","","",N,N],[17,"MADV_DODUMP","","",N,N],[17,"MADV_HWPOISON","","",N,N],[17,"MADV_SOFT_OFFLINE","","",N,N],[17,"IFF_UP","","",N,N],[17,"IFF_BROADCAST","","",N,N],[17,"IFF_DEBUG","","",N,N],[17,"IFF_LOOPBACK","","",N,N],[17,"IFF_POINTOPOINT","","",N,N],[17,"IFF_NOTRAILERS","","",N,N],[17,"IFF_RUNNING","","",N,N],[17,"IFF_NOARP","","",N,N],[17,"IFF_PROMISC","","",N,N],[17,"IFF_ALLMULTI","","",N,N],[17,"IFF_MASTER","","",N,N],[17,"IFF_SLAVE","","",N,N],[17,"IFF_MULTICAST","","",N,N],[17,"IFF_PORTSEL","","",N,N],[17,"IFF_AUTOMEDIA","","",N,N],[17,"IFF_DYNAMIC","","",N,N],[17,"SOL_IP","","",N,N],[17,"SOL_TCP","","",N,N],[17,"SOL_UDP","","",N,N],[17,"SOL_IPV6","","",N,N],[17,"SOL_ICMPV6","","",N,N],[17,"SOL_RAW","","",N,N],[17,"SOL_DECNET","","",N,N],[17,"SOL_X25","","",N,N],[17,"SOL_PACKET","","",N,N],[17,"SOL_ATM","","",N,N],[17,"SOL_AAL","","",N,N],[17,"SOL_IRDA","","",N,N],[17,"SOL_NETBEUI","","",N,N],[17,"SOL_LLC","","",N,N],[17,"SOL_DCCP","","",N,N],[17,"SOL_NETLINK","","",N,N],[17,"SOL_TIPC","","",N,N],[17,"AF_UNSPEC","","",N,N],[17,"AF_UNIX","","",N,N],[17,"AF_LOCAL","","",N,N],[17,"AF_INET","","",N,N],[17,"AF_AX25","","",N,N],[17,"AF_IPX","","",N,N],[17,"AF_APPLETALK","","",N,N],[17,"AF_NETROM","","",N,N],[17,"AF_BRIDGE","","",N,N],[17,"AF_ATMPVC","","",N,N],[17,"AF_X25","","",N,N],[17,"AF_INET6","","",N,N],[17,"AF_ROSE","","",N,N],[17,"AF_DECnet","","",N,N],[17,"AF_NETBEUI","","",N,N],[17,"AF_SECURITY","","",N,N],[17,"AF_KEY","","",N,N],[17,"AF_NETLINK","","",N,N],[17,"AF_ROUTE","","",N,N],[17,"AF_PACKET","","",N,N],[17,"AF_ASH","","",N,N],[17,"AF_ECONET","","",N,N],[17,"AF_ATMSVC","","",N,N],[17,"AF_RDS","","",N,N],[17,"AF_SNA","","",N,N],[17,"AF_IRDA","","",N,N],[17,"AF_PPPOX","","",N,N],[17,"AF_WANPIPE","","",N,N],[17,"AF_LLC","","",N,N],[17,"AF_CAN","","",N,N],[17,"AF_TIPC","","",N,N],[17,"AF_BLUETOOTH","","",N,N],[17,"AF_IUCV","","",N,N],[17,"AF_RXRPC","","",N,N],[17,"AF_ISDN","","",N,N],[17,"AF_PHONET","","",N,N],[17,"AF_IEEE802154","","",N,N],[17,"AF_CAIF","","",N,N],[17,"AF_ALG","","",N,N],[17,"PF_UNSPEC","","",N,N],[17,"PF_UNIX","","",N,N],[17,"PF_LOCAL","","",N,N],[17,"PF_INET","","",N,N],[17,"PF_AX25","","",N,N],[17,"PF_IPX","","",N,N],[17,"PF_APPLETALK","","",N,N],[17,"PF_NETROM","","",N,N],[17,"PF_BRIDGE","","",N,N],[17,"PF_ATMPVC","","",N,N],[17,"PF_X25","","",N,N],[17,"PF_INET6","","",N,N],[17,"PF_ROSE","","",N,N],[17,"PF_DECnet","","",N,N],[17,"PF_NETBEUI","","",N,N],[17,"PF_SECURITY","","",N,N],[17,"PF_KEY","","",N,N],[17,"PF_NETLINK","","",N,N],[17,"PF_ROUTE","","",N,N],[17,"PF_PACKET","","",N,N],[17,"PF_ASH","","",N,N],[17,"PF_ECONET","","",N,N],[17,"PF_ATMSVC","","",N,N],[17,"PF_RDS","","",N,N],[17,"PF_SNA","","",N,N],[17,"PF_IRDA","","",N,N],[17,"PF_PPPOX","","",N,N],[17,"PF_WANPIPE","","",N,N],[17,"PF_LLC","","",N,N],[17,"PF_CAN","","",N,N],[17,"PF_TIPC","","",N,N],[17,"PF_BLUETOOTH","","",N,N],[17,"PF_IUCV","","",N,N],[17,"PF_RXRPC","","",N,N],[17,"PF_ISDN","","",N,N],[17,"PF_PHONET","","",N,N],[17,"PF_IEEE802154","","",N,N],[17,"PF_CAIF","","",N,N],[17,"PF_ALG","","",N,N],[17,"SOMAXCONN","","",N,N],[17,"MSG_OOB","","",N,N],[17,"MSG_PEEK","","",N,N],[17,"MSG_DONTROUTE","","",N,N],[17,"MSG_CTRUNC","","",N,N],[17,"MSG_TRUNC","","",N,N],[17,"MSG_DONTWAIT","","",N,N],[17,"MSG_EOR","","",N,N],[17,"MSG_WAITALL","","",N,N],[17,"MSG_FIN","","",N,N],[17,"MSG_SYN","","",N,N],[17,"MSG_CONFIRM","","",N,N],[17,"MSG_RST","","",N,N],[17,"MSG_ERRQUEUE","","",N,N],[17,"MSG_NOSIGNAL","","",N,N],[17,"MSG_MORE","","",N,N],[17,"MSG_WAITFORONE","","",N,N],[17,"MSG_FASTOPEN","","",N,N],[17,"MSG_CMSG_CLOEXEC","","",N,N],[17,"SCM_TIMESTAMP","","",N,N],[17,"SOCK_RAW","","",N,N],[17,"SOCK_RDM","","",N,N],[17,"IP_MULTICAST_IF","","",N,N],[17,"IP_MULTICAST_TTL","","",N,N],[17,"IP_MULTICAST_LOOP","","",N,N],[17,"IP_TTL","","",N,N],[17,"IP_HDRINCL","","",N,N],[17,"IP_PKTINFO","","",N,N],[17,"IP_ADD_MEMBERSHIP","","",N,N],[17,"IP_DROP_MEMBERSHIP","","",N,N],[17,"IP_TRANSPARENT","","",N,N],[17,"IPV6_UNICAST_HOPS","","",N,N],[17,"IPV6_MULTICAST_IF","","",N,N],[17,"IPV6_MULTICAST_HOPS","","",N,N],[17,"IPV6_MULTICAST_LOOP","","",N,N],[17,"IPV6_ADD_MEMBERSHIP","","",N,N],[17,"IPV6_DROP_MEMBERSHIP","","",N,N],[17,"IPV6_V6ONLY","","",N,N],[17,"IPV6_RECVPKTINFO","","",N,N],[17,"IPV6_PKTINFO","","",N,N],[17,"TCP_NODELAY","","",N,N],[17,"TCP_MAXSEG","","",N,N],[17,"TCP_CORK","","",N,N],[17,"TCP_KEEPIDLE","","",N,N],[17,"TCP_KEEPINTVL","","",N,N],[17,"TCP_KEEPCNT","","",N,N],[17,"TCP_SYNCNT","","",N,N],[17,"TCP_LINGER2","","",N,N],[17,"TCP_DEFER_ACCEPT","","",N,N],[17,"TCP_WINDOW_CLAMP","","",N,N],[17,"TCP_INFO","","",N,N],[17,"TCP_QUICKACK","","",N,N],[17,"TCP_CONGESTION","","",N,N],[17,"SO_DEBUG","","",N,N],[17,"SHUT_RD","","",N,N],[17,"SHUT_WR","","",N,N],[17,"SHUT_RDWR","","",N,N],[17,"LOCK_SH","","",N,N],[17,"LOCK_EX","","",N,N],[17,"LOCK_NB","","",N,N],[17,"LOCK_UN","","",N,N],[17,"SS_ONSTACK","","",N,N],[17,"SS_DISABLE","","",N,N],[17,"PATH_MAX","","",N,N],[17,"FD_SETSIZE","","",N,N],[17,"EPOLLIN","","",N,N],[17,"EPOLLPRI","","",N,N],[17,"EPOLLOUT","","",N,N],[17,"EPOLLRDNORM","","",N,N],[17,"EPOLLRDBAND","","",N,N],[17,"EPOLLWRNORM","","",N,N],[17,"EPOLLWRBAND","","",N,N],[17,"EPOLLMSG","","",N,N],[17,"EPOLLERR","","",N,N],[17,"EPOLLHUP","","",N,N],[17,"EPOLLET","","",N,N],[17,"EPOLL_CTL_ADD","","",N,N],[17,"EPOLL_CTL_MOD","","",N,N],[17,"EPOLL_CTL_DEL","","",N,N],[17,"MNT_DETACH","","",N,N],[17,"MNT_EXPIRE","","",N,N],[17,"Q_GETFMT","","",N,N],[17,"Q_GETINFO","","",N,N],[17,"Q_SETINFO","","",N,N],[17,"QIF_BLIMITS","","",N,N],[17,"QIF_SPACE","","",N,N],[17,"QIF_ILIMITS","","",N,N],[17,"QIF_INODES","","",N,N],[17,"QIF_BTIME","","",N,N],[17,"QIF_ITIME","","",N,N],[17,"QIF_LIMITS","","",N,N],[17,"QIF_USAGE","","",N,N],[17,"QIF_TIMES","","",N,N],[17,"QIF_ALL","","",N,N],[17,"MNT_FORCE","","",N,N],[17,"Q_SYNC","","",N,N],[17,"Q_QUOTAON","","",N,N],[17,"Q_QUOTAOFF","","",N,N],[17,"Q_GETQUOTA","","",N,N],[17,"Q_SETQUOTA","","",N,N],[17,"TCIOFF","","",N,N],[17,"TCION","","",N,N],[17,"TCOOFF","","",N,N],[17,"TCOON","","",N,N],[17,"TCIFLUSH","","",N,N],[17,"TCOFLUSH","","",N,N],[17,"TCIOFLUSH","","",N,N],[17,"NL0","","",N,N],[17,"NL1","","",N,N],[17,"TAB0","","",N,N],[17,"CR0","","",N,N],[17,"FF0","","",N,N],[17,"BS0","","",N,N],[17,"VT0","","",N,N],[17,"VERASE","","",N,N],[17,"VKILL","","",N,N],[17,"VINTR","","",N,N],[17,"VQUIT","","",N,N],[17,"VLNEXT","","",N,N],[17,"IGNBRK","","",N,N],[17,"BRKINT","","",N,N],[17,"IGNPAR","","",N,N],[17,"PARMRK","","",N,N],[17,"INPCK","","",N,N],[17,"ISTRIP","","",N,N],[17,"INLCR","","",N,N],[17,"IGNCR","","",N,N],[17,"ICRNL","","",N,N],[17,"IXANY","","",N,N],[17,"IMAXBEL","","",N,N],[17,"OPOST","","",N,N],[17,"CS5","","",N,N],[17,"CRTSCTS","","",N,N],[17,"ECHO","","",N,N],[17,"OCRNL","","",N,N],[17,"ONOCR","","",N,N],[17,"ONLRET","","",N,N],[17,"OFILL","","",N,N],[17,"OFDEL","","",N,N],[17,"CLONE_VM","","",N,N],[17,"CLONE_FS","","",N,N],[17,"CLONE_FILES","","",N,N],[17,"CLONE_SIGHAND","","",N,N],[17,"CLONE_PTRACE","","",N,N],[17,"CLONE_VFORK","","",N,N],[17,"CLONE_PARENT","","",N,N],[17,"CLONE_THREAD","","",N,N],[17,"CLONE_NEWNS","","",N,N],[17,"CLONE_SYSVSEM","","",N,N],[17,"CLONE_SETTLS","","",N,N],[17,"CLONE_PARENT_SETTID","","",N,N],[17,"CLONE_CHILD_CLEARTID","","",N,N],[17,"CLONE_DETACHED","","",N,N],[17,"CLONE_UNTRACED","","",N,N],[17,"CLONE_CHILD_SETTID","","",N,N],[17,"CLONE_NEWUTS","","",N,N],[17,"CLONE_NEWIPC","","",N,N],[17,"CLONE_NEWUSER","","",N,N],[17,"CLONE_NEWPID","","",N,N],[17,"CLONE_NEWNET","","",N,N],[17,"CLONE_IO","","",N,N],[17,"CLONE_NEWCGROUP","","",N,N],[17,"WNOHANG","","",N,N],[17,"WUNTRACED","","",N,N],[17,"WSTOPPED","","",N,N],[17,"WEXITED","","",N,N],[17,"WCONTINUED","","",N,N],[17,"WNOWAIT","","",N,N],[17,"PTRACE_O_TRACESYSGOOD","","",N,N],[17,"PTRACE_O_TRACEFORK","","",N,N],[17,"PTRACE_O_TRACEVFORK","","",N,N],[17,"PTRACE_O_TRACECLONE","","",N,N],[17,"PTRACE_O_TRACEEXEC","","",N,N],[17,"PTRACE_O_TRACEVFORKDONE","","",N,N],[17,"PTRACE_O_TRACEEXIT","","",N,N],[17,"PTRACE_O_TRACESECCOMP","","",N,N],[17,"PTRACE_O_EXITKILL","","",N,N],[17,"PTRACE_O_SUSPEND_SECCOMP","","",N,N],[17,"PTRACE_O_MASK","","",N,N],[17,"PTRACE_EVENT_FORK","","",N,N],[17,"PTRACE_EVENT_VFORK","","",N,N],[17,"PTRACE_EVENT_CLONE","","",N,N],[17,"PTRACE_EVENT_EXEC","","",N,N],[17,"PTRACE_EVENT_VFORK_DONE","","",N,N],[17,"PTRACE_EVENT_EXIT","","",N,N],[17,"PTRACE_EVENT_SECCOMP","","",N,N],[17,"__WNOTHREAD","","",N,N],[17,"__WALL","","",N,N],[17,"__WCLONE","","",N,N],[17,"SPLICE_F_MOVE","","",N,N],[17,"SPLICE_F_NONBLOCK","","",N,N],[17,"SPLICE_F_MORE","","",N,N],[17,"SPLICE_F_GIFT","","",N,N],[17,"RTLD_LOCAL","","",N,N],[17,"RTLD_LAZY","","",N,N],[17,"POSIX_FADV_NORMAL","","",N,N],[17,"POSIX_FADV_RANDOM","","",N,N],[17,"POSIX_FADV_SEQUENTIAL","","",N,N],[17,"POSIX_FADV_WILLNEED","","",N,N],[17,"AT_FDCWD","","",N,N],[17,"AT_SYMLINK_NOFOLLOW","","",N,N],[17,"AT_REMOVEDIR","","",N,N],[17,"AT_SYMLINK_FOLLOW","","",N,N],[17,"AT_NO_AUTOMOUNT","","",N,N],[17,"AT_EMPTY_PATH","","",N,N],[17,"LOG_CRON","","",N,N],[17,"LOG_AUTHPRIV","","",N,N],[17,"LOG_FTP","","",N,N],[17,"LOG_PERROR","","",N,N],[17,"PIPE_BUF","","",N,N],[17,"SI_LOAD_SHIFT","","",N,N],[17,"SIGEV_SIGNAL","","",N,N],[17,"SIGEV_NONE","","",N,N],[17,"SIGEV_THREAD","","",N,N],[17,"P_ALL","","",N,N],[17,"P_PID","","",N,N],[17,"P_PGID","","",N,N],[17,"UTIME_OMIT","","",N,N],[17,"UTIME_NOW","","",N,N],[17,"POLLIN","","",N,N],[17,"POLLPRI","","",N,N],[17,"POLLOUT","","",N,N],[17,"POLLERR","","",N,N],[17,"POLLHUP","","",N,N],[17,"POLLNVAL","","",N,N],[17,"POLLRDNORM","","",N,N],[17,"POLLRDBAND","","",N,N],[17,"IPTOS_LOWDELAY","","",N,N],[17,"IPTOS_THROUGHPUT","","",N,N],[17,"IPTOS_RELIABILITY","","",N,N],[17,"IPTOS_MINCOST","","",N,N],[17,"IPTOS_PREC_NETCONTROL","","",N,N],[17,"IPTOS_PREC_INTERNETCONTROL","","",N,N],[17,"IPTOS_PREC_CRITIC_ECP","","",N,N],[17,"IPTOS_PREC_FLASHOVERRIDE","","",N,N],[17,"IPTOS_PREC_FLASH","","",N,N],[17,"IPTOS_PREC_IMMEDIATE","","",N,N],[17,"IPTOS_PREC_PRIORITY","","",N,N],[17,"IPTOS_PREC_ROUTINE","","",N,N],[17,"IPOPT_COPY","","",N,N],[17,"IPOPT_CLASS_MASK","","",N,N],[17,"IPOPT_NUMBER_MASK","","",N,N],[17,"IPOPT_CONTROL","","",N,N],[17,"IPOPT_RESERVED1","","",N,N],[17,"IPOPT_MEASUREMENT","","",N,N],[17,"IPOPT_RESERVED2","","",N,N],[17,"IPOPT_END","","",N,N],[17,"IPOPT_NOOP","","",N,N],[17,"IPOPT_SEC","","",N,N],[17,"IPOPT_LSRR","","",N,N],[17,"IPOPT_TIMESTAMP","","",N,N],[17,"IPOPT_RR","","",N,N],[17,"IPOPT_SID","","",N,N],[17,"IPOPT_SSRR","","",N,N],[17,"IPOPT_RA","","",N,N],[17,"IPVERSION","","",N,N],[17,"MAXTTL","","",N,N],[17,"IPDEFTTL","","",N,N],[17,"IPOPT_OPTVAL","","",N,N],[17,"IPOPT_OLEN","","",N,N],[17,"IPOPT_OFFSET","","",N,N],[17,"IPOPT_MINOFF","","",N,N],[17,"MAX_IPOPTLEN","","",N,N],[17,"IPOPT_NOP","","",N,N],[17,"IPOPT_EOL","","",N,N],[17,"IPOPT_TS","","",N,N],[17,"IPOPT_TS_TSONLY","","",N,N],[17,"IPOPT_TS_TSANDADDR","","",N,N],[17,"IPOPT_TS_PRESPEC","","",N,N],[17,"ARPOP_RREQUEST","","",N,N],[17,"ARPOP_RREPLY","","",N,N],[17,"ARPOP_InREQUEST","","",N,N],[17,"ARPOP_InREPLY","","",N,N],[17,"ARPOP_NAK","","",N,N],[17,"ATF_NETMASK","","",N,N],[17,"ATF_DONTPUB","","",N,N],[17,"ARPHRD_NETROM","","",N,N],[17,"ARPHRD_ETHER","","",N,N],[17,"ARPHRD_EETHER","","",N,N],[17,"ARPHRD_AX25","","",N,N],[17,"ARPHRD_PRONET","","",N,N],[17,"ARPHRD_CHAOS","","",N,N],[17,"ARPHRD_IEEE802","","",N,N],[17,"ARPHRD_ARCNET","","",N,N],[17,"ARPHRD_APPLETLK","","",N,N],[17,"ARPHRD_DLCI","","",N,N],[17,"ARPHRD_ATM","","",N,N],[17,"ARPHRD_METRICOM","","",N,N],[17,"ARPHRD_IEEE1394","","",N,N],[17,"ARPHRD_EUI64","","",N,N],[17,"ARPHRD_INFINIBAND","","",N,N],[17,"ARPHRD_SLIP","","",N,N],[17,"ARPHRD_CSLIP","","",N,N],[17,"ARPHRD_SLIP6","","",N,N],[17,"ARPHRD_CSLIP6","","",N,N],[17,"ARPHRD_RSRVD","","",N,N],[17,"ARPHRD_ADAPT","","",N,N],[17,"ARPHRD_ROSE","","",N,N],[17,"ARPHRD_X25","","",N,N],[17,"ARPHRD_HWX25","","",N,N],[17,"ARPHRD_PPP","","",N,N],[17,"ARPHRD_CISCO","","",N,N],[17,"ARPHRD_HDLC","","",N,N],[17,"ARPHRD_LAPB","","",N,N],[17,"ARPHRD_DDCMP","","",N,N],[17,"ARPHRD_RAWHDLC","","",N,N],[17,"ARPHRD_TUNNEL","","",N,N],[17,"ARPHRD_TUNNEL6","","",N,N],[17,"ARPHRD_FRAD","","",N,N],[17,"ARPHRD_SKIP","","",N,N],[17,"ARPHRD_LOOPBACK","","",N,N],[17,"ARPHRD_LOCALTLK","","",N,N],[17,"ARPHRD_FDDI","","",N,N],[17,"ARPHRD_BIF","","",N,N],[17,"ARPHRD_SIT","","",N,N],[17,"ARPHRD_IPDDP","","",N,N],[17,"ARPHRD_IPGRE","","",N,N],[17,"ARPHRD_PIMREG","","",N,N],[17,"ARPHRD_HIPPI","","",N,N],[17,"ARPHRD_ASH","","",N,N],[17,"ARPHRD_ECONET","","",N,N],[17,"ARPHRD_IRDA","","",N,N],[17,"ARPHRD_FCPP","","",N,N],[17,"ARPHRD_FCAL","","",N,N],[17,"ARPHRD_FCPL","","",N,N],[17,"ARPHRD_FCFABRIC","","",N,N],[17,"ARPHRD_IEEE802_TR","","",N,N],[17,"ARPHRD_IEEE80211","","",N,N],[17,"ARPHRD_IEEE80211_PRISM","","",N,N],[17,"ARPHRD_IEEE80211_RADIOTAP","","",N,N],[17,"ARPHRD_IEEE802154","","",N,N],[17,"ARPHRD_VOID","","",N,N],[17,"ARPHRD_NONE","","",N,N],[11,"clone","libc","",20,[[["self"]],["sockaddr"]]],[11,"clone","","",21,[[["self"]],["sockaddr_in"]]],[11,"clone","","",22,[[["self"]],["sockaddr_in6"]]],[11,"clone","","",23,[[["self"]],["sockaddr_un"]]],[11,"clone","","",24,[[["self"]],["sockaddr_storage"]]],[11,"clone","","",25,[[["self"]],["addrinfo"]]],[11,"clone","","",26,[[["self"]],["sockaddr_nl"]]],[11,"clone","","",27,[[["self"]],["sockaddr_ll"]]],[11,"clone","","",28,[[["self"]],["fd_set"]]],[11,"clone","","",29,[[["self"]],["tm"]]],[11,"clone","","",30,[[["self"]],["sched_param"]]],[11,"clone","","",31,[[["self"]],["dl_info"]]],[11,"clone","","",32,[[["self"]],["epoll_event"]]],[11,"clone","","",33,[[["self"]],["utsname"]]],[11,"clone","","",34,[[["self"]],["lconv"]]],[11,"clone","","",35,[[["self"]],["sigevent"]]],[11,"clone","","",36,[[["self"]],["in_pktinfo"]]],[11,"clone","","",37,[[["self"]],["ifaddrs"]]],[11,"clone","","",38,[[["self"]],["in6_rtmsg"]]],[11,"clone","","",39,[[["self"]],["arpreq"]]],[11,"clone","","",40,[[["self"]],["arpreq_old"]]],[11,"clone","","",41,[[["self"]],["arphdr"]]],[6,"pid_t","libc::unix","",N,N],[6,"uid_t","","",N,N],[6,"gid_t","","",N,N],[6,"in_addr_t","","",N,N],[6,"in_port_t","","",N,N],[6,"sighandler_t","","",N,N],[6,"cc_t","","",N,N],[17,"SIG_DFL","","",N,N],[17,"SIG_IGN","","",N,N],[17,"SIG_ERR","","",N,N],[17,"DT_UNKNOWN","","",N,N],[17,"DT_FIFO","","",N,N],[17,"DT_CHR","","",N,N],[17,"DT_DIR","","",N,N],[17,"DT_BLK","","",N,N],[17,"DT_REG","","",N,N],[17,"DT_LNK","","",N,N],[17,"DT_SOCK","","",N,N],[17,"FD_CLOEXEC","","",N,N],[17,"USRQUOTA","","",N,N],[17,"GRPQUOTA","","",N,N],[17,"SIGIOT","","",N,N],[17,"S_ISUID","","",N,N],[17,"S_ISGID","","",N,N],[17,"S_ISVTX","","",N,N],[17,"IF_NAMESIZE","","",N,N],[17,"IFNAMSIZ","","",N,N],[17,"LOG_EMERG","","",N,N],[17,"LOG_ALERT","","",N,N],[17,"LOG_CRIT","","",N,N],[17,"LOG_ERR","","",N,N],[17,"LOG_WARNING","","",N,N],[17,"LOG_NOTICE","","",N,N],[17,"LOG_INFO","","",N,N],[17,"LOG_DEBUG","","",N,N],[17,"LOG_KERN","","",N,N],[17,"LOG_USER","","",N,N],[17,"LOG_MAIL","","",N,N],[17,"LOG_DAEMON","","",N,N],[17,"LOG_AUTH","","",N,N],[17,"LOG_SYSLOG","","",N,N],[17,"LOG_LPR","","",N,N],[17,"LOG_NEWS","","",N,N],[17,"LOG_UUCP","","",N,N],[17,"LOG_LOCAL0","","",N,N],[17,"LOG_LOCAL1","","",N,N],[17,"LOG_LOCAL2","","",N,N],[17,"LOG_LOCAL3","","",N,N],[17,"LOG_LOCAL4","","",N,N],[17,"LOG_LOCAL5","","",N,N],[17,"LOG_LOCAL6","","",N,N],[17,"LOG_LOCAL7","","",N,N],[17,"LOG_PID","","",N,N],[17,"LOG_CONS","","",N,N],[17,"LOG_ODELAY","","",N,N],[17,"LOG_NDELAY","","",N,N],[17,"LOG_NOWAIT","","",N,N],[17,"LOG_PRIMASK","","",N,N],[17,"LOG_FACMASK","","",N,N],[17,"PRIO_PROCESS","","",N,N],[17,"PRIO_PGRP","","",N,N],[17,"PRIO_USER","","",N,N],[17,"PRIO_MIN","","",N,N],[17,"PRIO_MAX","","",N,N],[17,"IPPROTO_ICMP","","",N,N],[17,"IPPROTO_ICMPV6","","",N,N],[17,"IPPROTO_TCP","","",N,N],[17,"IPPROTO_UDP","","",N,N],[17,"IPPROTO_IP","","",N,N],[17,"IPPROTO_IPV6","","",N,N],[17,"INADDR_LOOPBACK","","",N,N],[17,"INADDR_ANY","","",N,N],[17,"INADDR_BROADCAST","","",N,N],[17,"INADDR_NONE","","",N,N],[17,"ARPOP_REQUEST","","",N,N],[17,"ARPOP_REPLY","","",N,N],[17,"ATF_COM","","",N,N],[17,"ATF_PERM","","",N,N],[17,"ATF_PUBL","","",N,N],[17,"ATF_USETRAILERS","","",N,N],[11,"clone","libc","",0,[[["self"]],["group"]]],[11,"clone","","",1,[[["self"]],["utimbuf"]]],[11,"clone","","",2,[[["self"]],["timeval"]]],[11,"clone","","",3,[[["self"]],["timespec"]]],[11,"clone","","",4,[[["self"]],["rlimit"]]],[11,"clone","","",5,[[["self"]],["rusage"]]],[11,"clone","","",6,[[["self"]],["in_addr"]]],[11,"clone","","",7,[[["self"]],["in6_addr"]]],[11,"clone","","",8,[[["self"]],["ip_mreq"]]],[11,"clone","","",9,[[["self"]],["ipv6_mreq"]]],[11,"clone","","",10,[[["self"]],["hostent"]]],[11,"clone","","",11,[[["self"]],["iovec"]]],[11,"clone","","",12,[[["self"]],["pollfd"]]],[11,"clone","","",13,[[["self"]],["winsize"]]],[11,"clone","","",14,[[["self"]],["linger"]]],[11,"clone","","",15,[[["self"]],["sigval"]]],[11,"clone","","",16,[[["self"]],["itimerval"]]],[11,"clone","","",17,[[["self"]],["tms"]]],[11,"clone","","",18,[[["self"]],["servent"]]],[11,"clone","","",19,[[["self"]],["protoent"]]],[6,"int8_t","","",N,N],[6,"int16_t","","",N,N],[6,"int32_t","","",N,N],[6,"int64_t","","",N,N],[6,"uint8_t","","",N,N],[6,"uint16_t","","",N,N],[6,"uint32_t","","",N,N],[6,"uint64_t","","",N,N],[6,"c_schar","","",N,N],[6,"c_uchar","","",N,N],[6,"c_short","","",N,N],[6,"c_ushort","","",N,N],[6,"c_int","","",N,N],[6,"c_uint","","",N,N],[6,"c_float","","",N,N],[6,"c_double","","",N,N],[6,"c_longlong","","",N,N],[6,"c_ulonglong","","",N,N],[6,"intmax_t","","",N,N],[6,"uintmax_t","","",N,N],[6,"size_t","","",N,N],[6,"ptrdiff_t","","",N,N],[6,"intptr_t","","",N,N],[6,"uintptr_t","","",N,N],[6,"ssize_t","","",N,N],[6,"pid_t","","",N,N],[6,"uid_t","","",N,N],[6,"gid_t","","",N,N],[6,"in_addr_t","","",N,N],[6,"in_port_t","","",N,N],[6,"sighandler_t","","",N,N],[6,"cc_t","","",N,N],[6,"sa_family_t","","",N,N],[6,"pthread_key_t","","",N,N],[6,"speed_t","","",N,N],[6,"tcflag_t","","",N,N],[6,"clockid_t","","",N,N],[6,"key_t","","",N,N],[6,"id_t","","",N,N],[6,"useconds_t","","",N,N],[6,"dev_t","","",N,N],[6,"socklen_t","","",N,N],[6,"pthread_t","","",N,N],[6,"mode_t","","",N,N],[6,"ino64_t","","",N,N],[6,"off64_t","","",N,N],[6,"blkcnt64_t","","",N,N],[6,"rlim64_t","","",N,N],[6,"mqd_t","","",N,N],[6,"nfds_t","","",N,N],[6,"nl_item","","",N,N],[6,"idtype_t","","",N,N],[6,"loff_t","","",N,N],[6,"__u8","","",N,N],[6,"__u16","","",N,N],[6,"__s16","","",N,N],[6,"__u32","","",N,N],[6,"__s32","","",N,N],[6,"Elf32_Half","","",N,N],[6,"Elf32_Word","","",N,N],[6,"Elf32_Off","","",N,N],[6,"Elf32_Addr","","",N,N],[6,"Elf64_Half","","",N,N],[6,"Elf64_Word","","",N,N],[6,"Elf64_Off","","",N,N],[6,"Elf64_Addr","","",N,N],[6,"Elf64_Xword","","",N,N],[6,"__priority_which_t","","",N,N],[6,"clock_t","","",N,N],[6,"time_t","","",N,N],[6,"ino_t","","",N,N],[6,"off_t","","",N,N],[6,"blkcnt_t","","",N,N],[6,"__fsword_t","","",N,N],[6,"shmatt_t","","",N,N],[6,"msgqnum_t","","",N,N],[6,"msglen_t","","",N,N],[6,"fsblkcnt_t","","",N,N],[6,"fsfilcnt_t","","",N,N],[6,"rlim_t","","",N,N],[6,"c_char","","",N,N],[6,"wchar_t","","",N,N],[6,"nlink_t","","",N,N],[6,"blksize_t","","",N,N],[6,"greg_t","","",N,N],[6,"suseconds_t","","",N,N],[6,"__u64","","",N,N],[6,"c_long","","",N,N],[6,"c_ulong","","",N,N],[17,"INT_MIN","","",N,N],[17,"INT_MAX","","",N,N],[17,"SIG_DFL","","",N,N],[17,"SIG_IGN","","",N,N],[17,"SIG_ERR","","",N,N],[17,"DT_UNKNOWN","","",N,N],[17,"DT_FIFO","","",N,N],[17,"DT_CHR","","",N,N],[17,"DT_DIR","","",N,N],[17,"DT_BLK","","",N,N],[17,"DT_REG","","",N,N],[17,"DT_LNK","","",N,N],[17,"DT_SOCK","","",N,N],[17,"FD_CLOEXEC","","",N,N],[17,"USRQUOTA","","",N,N],[17,"GRPQUOTA","","",N,N],[17,"SIGIOT","","",N,N],[17,"S_ISUID","","",N,N],[17,"S_ISGID","","",N,N],[17,"S_ISVTX","","",N,N],[17,"IF_NAMESIZE","","",N,N],[17,"IFNAMSIZ","","",N,N],[17,"LOG_EMERG","","",N,N],[17,"LOG_ALERT","","",N,N],[17,"LOG_CRIT","","",N,N],[17,"LOG_ERR","","",N,N],[17,"LOG_WARNING","","",N,N],[17,"LOG_NOTICE","","",N,N],[17,"LOG_INFO","","",N,N],[17,"LOG_DEBUG","","",N,N],[17,"LOG_KERN","","",N,N],[17,"LOG_USER","","",N,N],[17,"LOG_MAIL","","",N,N],[17,"LOG_DAEMON","","",N,N],[17,"LOG_AUTH","","",N,N],[17,"LOG_SYSLOG","","",N,N],[17,"LOG_LPR","","",N,N],[17,"LOG_NEWS","","",N,N],[17,"LOG_UUCP","","",N,N],[17,"LOG_LOCAL0","","",N,N],[17,"LOG_LOCAL1","","",N,N],[17,"LOG_LOCAL2","","",N,N],[17,"LOG_LOCAL3","","",N,N],[17,"LOG_LOCAL4","","",N,N],[17,"LOG_LOCAL5","","",N,N],[17,"LOG_LOCAL6","","",N,N],[17,"LOG_LOCAL7","","",N,N],[17,"LOG_PID","","",N,N],[17,"LOG_CONS","","",N,N],[17,"LOG_ODELAY","","",N,N],[17,"LOG_NDELAY","","",N,N],[17,"LOG_NOWAIT","","",N,N],[17,"LOG_PRIMASK","","",N,N],[17,"LOG_FACMASK","","",N,N],[17,"PRIO_PROCESS","","",N,N],[17,"PRIO_PGRP","","",N,N],[17,"PRIO_USER","","",N,N],[17,"PRIO_MIN","","",N,N],[17,"PRIO_MAX","","",N,N],[17,"IPPROTO_ICMP","","",N,N],[17,"IPPROTO_ICMPV6","","",N,N],[17,"IPPROTO_TCP","","",N,N],[17,"IPPROTO_UDP","","",N,N],[17,"IPPROTO_IP","","",N,N],[17,"IPPROTO_IPV6","","",N,N],[17,"INADDR_LOOPBACK","","",N,N],[17,"INADDR_ANY","","",N,N],[17,"INADDR_BROADCAST","","",N,N],[17,"INADDR_NONE","","",N,N],[17,"ARPOP_REQUEST","","",N,N],[17,"ARPOP_REPLY","","",N,N],[17,"ATF_COM","","",N,N],[17,"ATF_PERM","","",N,N],[17,"ATF_PUBL","","",N,N],[17,"ATF_USETRAILERS","","",N,N],[17,"EXIT_FAILURE","","",N,N],[17,"EXIT_SUCCESS","","",N,N],[17,"RAND_MAX","","",N,N],[17,"EOF","","",N,N],[17,"SEEK_SET","","",N,N],[17,"SEEK_CUR","","",N,N],[17,"SEEK_END","","",N,N],[17,"_IOFBF","","",N,N],[17,"_IONBF","","",N,N],[17,"_IOLBF","","",N,N],[17,"F_DUPFD","","",N,N],[17,"F_GETFD","","",N,N],[17,"F_SETFD","","",N,N],[17,"F_GETFL","","",N,N],[17,"F_SETFL","","",N,N],[17,"F_SETLEASE","","",N,N],[17,"F_GETLEASE","","",N,N],[17,"F_NOTIFY","","",N,N],[17,"F_CANCELLK","","",N,N],[17,"F_DUPFD_CLOEXEC","","",N,N],[17,"F_SETPIPE_SZ","","",N,N],[17,"F_GETPIPE_SZ","","",N,N],[17,"F_ADD_SEALS","","",N,N],[17,"F_GET_SEALS","","",N,N],[17,"F_SEAL_SEAL","","",N,N],[17,"F_SEAL_SHRINK","","",N,N],[17,"F_SEAL_GROW","","",N,N],[17,"F_SEAL_WRITE","","",N,N],[17,"SIGTRAP","","",N,N],[17,"PTHREAD_CREATE_JOINABLE","","",N,N],[17,"PTHREAD_CREATE_DETACHED","","",N,N],[17,"CLOCK_REALTIME","","",N,N],[17,"CLOCK_MONOTONIC","","",N,N],[17,"CLOCK_PROCESS_CPUTIME_ID","","",N,N],[17,"CLOCK_THREAD_CPUTIME_ID","","",N,N],[17,"CLOCK_MONOTONIC_RAW","","",N,N],[17,"CLOCK_REALTIME_COARSE","","",N,N],[17,"CLOCK_MONOTONIC_COARSE","","",N,N],[17,"CLOCK_BOOTTIME","","",N,N],[17,"CLOCK_REALTIME_ALARM","","",N,N],[17,"CLOCK_BOOTTIME_ALARM","","",N,N],[17,"TIMER_ABSTIME","","",N,N],[17,"RLIMIT_CPU","","",N,N],[17,"RLIMIT_FSIZE","","",N,N],[17,"RLIMIT_DATA","","",N,N],[17,"RLIMIT_STACK","","",N,N],[17,"RLIMIT_CORE","","",N,N],[17,"RLIMIT_LOCKS","","",N,N],[17,"RLIMIT_SIGPENDING","","",N,N],[17,"RLIMIT_MSGQUEUE","","",N,N],[17,"RLIMIT_NICE","","",N,N],[17,"RLIMIT_RTPRIO","","",N,N],[17,"RUSAGE_SELF","","",N,N],[17,"O_RDONLY","","",N,N],[17,"O_WRONLY","","",N,N],[17,"O_RDWR","","",N,N],[17,"SOCK_CLOEXEC","","",N,N],[17,"S_IFIFO","","",N,N],[17,"S_IFCHR","","",N,N],[17,"S_IFBLK","","",N,N],[17,"S_IFDIR","","",N,N],[17,"S_IFREG","","",N,N],[17,"S_IFLNK","","",N,N],[17,"S_IFSOCK","","",N,N],[17,"S_IFMT","","",N,N],[17,"S_IRWXU","","",N,N],[17,"S_IXUSR","","",N,N],[17,"S_IWUSR","","",N,N],[17,"S_IRUSR","","",N,N],[17,"S_IRWXG","","",N,N],[17,"S_IXGRP","","",N,N],[17,"S_IWGRP","","",N,N],[17,"S_IRGRP","","",N,N],[17,"S_IRWXO","","",N,N],[17,"S_IXOTH","","",N,N],[17,"S_IWOTH","","",N,N],[17,"S_IROTH","","",N,N],[17,"F_OK","","",N,N],[17,"R_OK","","",N,N],[17,"W_OK","","",N,N],[17,"X_OK","","",N,N],[17,"STDIN_FILENO","","",N,N],[17,"STDOUT_FILENO","","",N,N],[17,"STDERR_FILENO","","",N,N],[17,"SIGHUP","","",N,N],[17,"SIGINT","","",N,N],[17,"SIGQUIT","","",N,N],[17,"SIGILL","","",N,N],[17,"SIGABRT","","",N,N],[17,"SIGFPE","","",N,N],[17,"SIGKILL","","",N,N],[17,"SIGSEGV","","",N,N],[17,"SIGPIPE","","",N,N],[17,"SIGALRM","","",N,N],[17,"SIGTERM","","",N,N],[17,"PROT_NONE","","",N,N],[17,"PROT_READ","","",N,N],[17,"PROT_WRITE","","",N,N],[17,"PROT_EXEC","","",N,N],[17,"LC_CTYPE","","",N,N],[17,"LC_NUMERIC","","",N,N],[17,"LC_TIME","","",N,N],[17,"LC_COLLATE","","",N,N],[17,"LC_MONETARY","","",N,N],[17,"LC_MESSAGES","","",N,N],[17,"LC_ALL","","",N,N],[17,"LC_CTYPE_MASK","","",N,N],[17,"LC_NUMERIC_MASK","","",N,N],[17,"LC_TIME_MASK","","",N,N],[17,"LC_COLLATE_MASK","","",N,N],[17,"LC_MONETARY_MASK","","",N,N],[17,"LC_MESSAGES_MASK","","",N,N],[17,"MAP_FILE","","",N,N],[17,"MAP_SHARED","","",N,N],[17,"MAP_PRIVATE","","",N,N],[17,"MAP_FIXED","","",N,N],[17,"MAP_FAILED","","",N,N],[17,"MS_ASYNC","","",N,N],[17,"MS_INVALIDATE","","",N,N],[17,"MS_SYNC","","",N,N],[17,"MS_RDONLY","","",N,N],[17,"MS_NOSUID","","",N,N],[17,"MS_NODEV","","",N,N],[17,"MS_NOEXEC","","",N,N],[17,"MS_SYNCHRONOUS","","",N,N],[17,"MS_REMOUNT","","",N,N],[17,"MS_MANDLOCK","","",N,N],[17,"MS_DIRSYNC","","",N,N],[17,"MS_NOATIME","","",N,N],[17,"MS_NODIRATIME","","",N,N],[17,"MS_BIND","","",N,N],[17,"MS_MOVE","","",N,N],[17,"MS_REC","","",N,N],[17,"MS_SILENT","","",N,N],[17,"MS_POSIXACL","","",N,N],[17,"MS_UNBINDABLE","","",N,N],[17,"MS_PRIVATE","","",N,N],[17,"MS_SLAVE","","",N,N],[17,"MS_SHARED","","",N,N],[17,"MS_RELATIME","","",N,N],[17,"MS_KERNMOUNT","","",N,N],[17,"MS_I_VERSION","","",N,N],[17,"MS_STRICTATIME","","",N,N],[17,"MS_ACTIVE","","",N,N],[17,"MS_NOUSER","","",N,N],[17,"MS_MGC_VAL","","",N,N],[17,"MS_MGC_MSK","","",N,N],[17,"MS_RMT_MASK","","",N,N],[17,"EPERM","","",N,N],[17,"ENOENT","","",N,N],[17,"ESRCH","","",N,N],[17,"EINTR","","",N,N],[17,"EIO","","",N,N],[17,"ENXIO","","",N,N],[17,"E2BIG","","",N,N],[17,"ENOEXEC","","",N,N],[17,"EBADF","","",N,N],[17,"ECHILD","","",N,N],[17,"EAGAIN","","",N,N],[17,"ENOMEM","","",N,N],[17,"EACCES","","",N,N],[17,"EFAULT","","",N,N],[17,"ENOTBLK","","",N,N],[17,"EBUSY","","",N,N],[17,"EEXIST","","",N,N],[17,"EXDEV","","",N,N],[17,"ENODEV","","",N,N],[17,"ENOTDIR","","",N,N],[17,"EISDIR","","",N,N],[17,"EINVAL","","",N,N],[17,"ENFILE","","",N,N],[17,"EMFILE","","",N,N],[17,"ENOTTY","","",N,N],[17,"ETXTBSY","","",N,N],[17,"EFBIG","","",N,N],[17,"ENOSPC","","",N,N],[17,"ESPIPE","","",N,N],[17,"EROFS","","",N,N],[17,"EMLINK","","",N,N],[17,"EPIPE","","",N,N],[17,"EDOM","","",N,N],[17,"ERANGE","","",N,N],[17,"EWOULDBLOCK","","",N,N],[17,"SCM_RIGHTS","","",N,N],[17,"SCM_CREDENTIALS","","",N,N],[17,"PROT_GROWSDOWN","","",N,N],[17,"PROT_GROWSUP","","",N,N],[17,"MAP_TYPE","","",N,N],[17,"MADV_NORMAL","","",N,N],[17,"MADV_RANDOM","","",N,N],[17,"MADV_SEQUENTIAL","","",N,N],[17,"MADV_WILLNEED","","",N,N],[17,"MADV_DONTNEED","","",N,N],[17,"MADV_FREE","","",N,N],[17,"MADV_REMOVE","","",N,N],[17,"MADV_DONTFORK","","",N,N],[17,"MADV_DOFORK","","",N,N],[17,"MADV_MERGEABLE","","",N,N],[17,"MADV_UNMERGEABLE","","",N,N],[17,"MADV_HUGEPAGE","","",N,N],[17,"MADV_NOHUGEPAGE","","",N,N],[17,"MADV_DONTDUMP","","",N,N],[17,"MADV_DODUMP","","",N,N],[17,"MADV_HWPOISON","","",N,N],[17,"MADV_SOFT_OFFLINE","","",N,N],[17,"IFF_UP","","",N,N],[17,"IFF_BROADCAST","","",N,N],[17,"IFF_DEBUG","","",N,N],[17,"IFF_LOOPBACK","","",N,N],[17,"IFF_POINTOPOINT","","",N,N],[17,"IFF_NOTRAILERS","","",N,N],[17,"IFF_RUNNING","","",N,N],[17,"IFF_NOARP","","",N,N],[17,"IFF_PROMISC","","",N,N],[17,"IFF_ALLMULTI","","",N,N],[17,"IFF_MASTER","","",N,N],[17,"IFF_SLAVE","","",N,N],[17,"IFF_MULTICAST","","",N,N],[17,"IFF_PORTSEL","","",N,N],[17,"IFF_AUTOMEDIA","","",N,N],[17,"IFF_DYNAMIC","","",N,N],[17,"SOL_IP","","",N,N],[17,"SOL_TCP","","",N,N],[17,"SOL_UDP","","",N,N],[17,"SOL_IPV6","","",N,N],[17,"SOL_ICMPV6","","",N,N],[17,"SOL_RAW","","",N,N],[17,"SOL_DECNET","","",N,N],[17,"SOL_X25","","",N,N],[17,"SOL_PACKET","","",N,N],[17,"SOL_ATM","","",N,N],[17,"SOL_AAL","","",N,N],[17,"SOL_IRDA","","",N,N],[17,"SOL_NETBEUI","","",N,N],[17,"SOL_LLC","","",N,N],[17,"SOL_DCCP","","",N,N],[17,"SOL_NETLINK","","",N,N],[17,"SOL_TIPC","","",N,N],[17,"AF_UNSPEC","","",N,N],[17,"AF_UNIX","","",N,N],[17,"AF_LOCAL","","",N,N],[17,"AF_INET","","",N,N],[17,"AF_AX25","","",N,N],[17,"AF_IPX","","",N,N],[17,"AF_APPLETALK","","",N,N],[17,"AF_NETROM","","",N,N],[17,"AF_BRIDGE","","",N,N],[17,"AF_ATMPVC","","",N,N],[17,"AF_X25","","",N,N],[17,"AF_INET6","","",N,N],[17,"AF_ROSE","","",N,N],[17,"AF_DECnet","","",N,N],[17,"AF_NETBEUI","","",N,N],[17,"AF_SECURITY","","",N,N],[17,"AF_KEY","","",N,N],[17,"AF_NETLINK","","",N,N],[17,"AF_ROUTE","","",N,N],[17,"AF_PACKET","","",N,N],[17,"AF_ASH","","",N,N],[17,"AF_ECONET","","",N,N],[17,"AF_ATMSVC","","",N,N],[17,"AF_RDS","","",N,N],[17,"AF_SNA","","",N,N],[17,"AF_IRDA","","",N,N],[17,"AF_PPPOX","","",N,N],[17,"AF_WANPIPE","","",N,N],[17,"AF_LLC","","",N,N],[17,"AF_CAN","","",N,N],[17,"AF_TIPC","","",N,N],[17,"AF_BLUETOOTH","","",N,N],[17,"AF_IUCV","","",N,N],[17,"AF_RXRPC","","",N,N],[17,"AF_ISDN","","",N,N],[17,"AF_PHONET","","",N,N],[17,"AF_IEEE802154","","",N,N],[17,"AF_CAIF","","",N,N],[17,"AF_ALG","","",N,N],[17,"PF_UNSPEC","","",N,N],[17,"PF_UNIX","","",N,N],[17,"PF_LOCAL","","",N,N],[17,"PF_INET","","",N,N],[17,"PF_AX25","","",N,N],[17,"PF_IPX","","",N,N],[17,"PF_APPLETALK","","",N,N],[17,"PF_NETROM","","",N,N],[17,"PF_BRIDGE","","",N,N],[17,"PF_ATMPVC","","",N,N],[17,"PF_X25","","",N,N],[17,"PF_INET6","","",N,N],[17,"PF_ROSE","","",N,N],[17,"PF_DECnet","","",N,N],[17,"PF_NETBEUI","","",N,N],[17,"PF_SECURITY","","",N,N],[17,"PF_KEY","","",N,N],[17,"PF_NETLINK","","",N,N],[17,"PF_ROUTE","","",N,N],[17,"PF_PACKET","","",N,N],[17,"PF_ASH","","",N,N],[17,"PF_ECONET","","",N,N],[17,"PF_ATMSVC","","",N,N],[17,"PF_RDS","","",N,N],[17,"PF_SNA","","",N,N],[17,"PF_IRDA","","",N,N],[17,"PF_PPPOX","","",N,N],[17,"PF_WANPIPE","","",N,N],[17,"PF_LLC","","",N,N],[17,"PF_CAN","","",N,N],[17,"PF_TIPC","","",N,N],[17,"PF_BLUETOOTH","","",N,N],[17,"PF_IUCV","","",N,N],[17,"PF_RXRPC","","",N,N],[17,"PF_ISDN","","",N,N],[17,"PF_PHONET","","",N,N],[17,"PF_IEEE802154","","",N,N],[17,"PF_CAIF","","",N,N],[17,"PF_ALG","","",N,N],[17,"SOMAXCONN","","",N,N],[17,"MSG_OOB","","",N,N],[17,"MSG_PEEK","","",N,N],[17,"MSG_DONTROUTE","","",N,N],[17,"MSG_CTRUNC","","",N,N],[17,"MSG_TRUNC","","",N,N],[17,"MSG_DONTWAIT","","",N,N],[17,"MSG_EOR","","",N,N],[17,"MSG_WAITALL","","",N,N],[17,"MSG_FIN","","",N,N],[17,"MSG_SYN","","",N,N],[17,"MSG_CONFIRM","","",N,N],[17,"MSG_RST","","",N,N],[17,"MSG_ERRQUEUE","","",N,N],[17,"MSG_NOSIGNAL","","",N,N],[17,"MSG_MORE","","",N,N],[17,"MSG_WAITFORONE","","",N,N],[17,"MSG_FASTOPEN","","",N,N],[17,"MSG_CMSG_CLOEXEC","","",N,N],[17,"SCM_TIMESTAMP","","",N,N],[17,"SOCK_RAW","","",N,N],[17,"SOCK_RDM","","",N,N],[17,"IP_MULTICAST_IF","","",N,N],[17,"IP_MULTICAST_TTL","","",N,N],[17,"IP_MULTICAST_LOOP","","",N,N],[17,"IP_TTL","","",N,N],[17,"IP_HDRINCL","","",N,N],[17,"IP_PKTINFO","","",N,N],[17,"IP_ADD_MEMBERSHIP","","",N,N],[17,"IP_DROP_MEMBERSHIP","","",N,N],[17,"IP_TRANSPARENT","","",N,N],[17,"IPV6_UNICAST_HOPS","","",N,N],[17,"IPV6_MULTICAST_IF","","",N,N],[17,"IPV6_MULTICAST_HOPS","","",N,N],[17,"IPV6_MULTICAST_LOOP","","",N,N],[17,"IPV6_ADD_MEMBERSHIP","","",N,N],[17,"IPV6_DROP_MEMBERSHIP","","",N,N],[17,"IPV6_V6ONLY","","",N,N],[17,"IPV6_RECVPKTINFO","","",N,N],[17,"IPV6_PKTINFO","","",N,N],[17,"TCP_NODELAY","","",N,N],[17,"TCP_MAXSEG","","",N,N],[17,"TCP_CORK","","",N,N],[17,"TCP_KEEPIDLE","","",N,N],[17,"TCP_KEEPINTVL","","",N,N],[17,"TCP_KEEPCNT","","",N,N],[17,"TCP_SYNCNT","","",N,N],[17,"TCP_LINGER2","","",N,N],[17,"TCP_DEFER_ACCEPT","","",N,N],[17,"TCP_WINDOW_CLAMP","","",N,N],[17,"TCP_INFO","","",N,N],[17,"TCP_QUICKACK","","",N,N],[17,"TCP_CONGESTION","","",N,N],[17,"SO_DEBUG","","",N,N],[17,"SHUT_RD","","",N,N],[17,"SHUT_WR","","",N,N],[17,"SHUT_RDWR","","",N,N],[17,"LOCK_SH","","",N,N],[17,"LOCK_EX","","",N,N],[17,"LOCK_NB","","",N,N],[17,"LOCK_UN","","",N,N],[17,"SS_ONSTACK","","",N,N],[17,"SS_DISABLE","","",N,N],[17,"PATH_MAX","","",N,N],[17,"FD_SETSIZE","","",N,N],[17,"EPOLLIN","","",N,N],[17,"EPOLLPRI","","",N,N],[17,"EPOLLOUT","","",N,N],[17,"EPOLLRDNORM","","",N,N],[17,"EPOLLRDBAND","","",N,N],[17,"EPOLLWRNORM","","",N,N],[17,"EPOLLWRBAND","","",N,N],[17,"EPOLLMSG","","",N,N],[17,"EPOLLERR","","",N,N],[17,"EPOLLHUP","","",N,N],[17,"EPOLLET","","",N,N],[17,"EPOLL_CTL_ADD","","",N,N],[17,"EPOLL_CTL_MOD","","",N,N],[17,"EPOLL_CTL_DEL","","",N,N],[17,"MNT_DETACH","","",N,N],[17,"MNT_EXPIRE","","",N,N],[17,"Q_GETFMT","","",N,N],[17,"Q_GETINFO","","",N,N],[17,"Q_SETINFO","","",N,N],[17,"QIF_BLIMITS","","",N,N],[17,"QIF_SPACE","","",N,N],[17,"QIF_ILIMITS","","",N,N],[17,"QIF_INODES","","",N,N],[17,"QIF_BTIME","","",N,N],[17,"QIF_ITIME","","",N,N],[17,"QIF_LIMITS","","",N,N],[17,"QIF_USAGE","","",N,N],[17,"QIF_TIMES","","",N,N],[17,"QIF_ALL","","",N,N],[17,"MNT_FORCE","","",N,N],[17,"Q_SYNC","","",N,N],[17,"Q_QUOTAON","","",N,N],[17,"Q_QUOTAOFF","","",N,N],[17,"Q_GETQUOTA","","",N,N],[17,"Q_SETQUOTA","","",N,N],[17,"TCIOFF","","",N,N],[17,"TCION","","",N,N],[17,"TCOOFF","","",N,N],[17,"TCOON","","",N,N],[17,"TCIFLUSH","","",N,N],[17,"TCOFLUSH","","",N,N],[17,"TCIOFLUSH","","",N,N],[17,"NL0","","",N,N],[17,"NL1","","",N,N],[17,"TAB0","","",N,N],[17,"CR0","","",N,N],[17,"FF0","","",N,N],[17,"BS0","","",N,N],[17,"VT0","","",N,N],[17,"VERASE","","",N,N],[17,"VKILL","","",N,N],[17,"VINTR","","",N,N],[17,"VQUIT","","",N,N],[17,"VLNEXT","","",N,N],[17,"IGNBRK","","",N,N],[17,"BRKINT","","",N,N],[17,"IGNPAR","","",N,N],[17,"PARMRK","","",N,N],[17,"INPCK","","",N,N],[17,"ISTRIP","","",N,N],[17,"INLCR","","",N,N],[17,"IGNCR","","",N,N],[17,"ICRNL","","",N,N],[17,"IXANY","","",N,N],[17,"IMAXBEL","","",N,N],[17,"OPOST","","",N,N],[17,"CS5","","",N,N],[17,"CRTSCTS","","",N,N],[17,"ECHO","","",N,N],[17,"OCRNL","","",N,N],[17,"ONOCR","","",N,N],[17,"ONLRET","","",N,N],[17,"OFILL","","",N,N],[17,"OFDEL","","",N,N],[17,"CLONE_VM","","",N,N],[17,"CLONE_FS","","",N,N],[17,"CLONE_FILES","","",N,N],[17,"CLONE_SIGHAND","","",N,N],[17,"CLONE_PTRACE","","",N,N],[17,"CLONE_VFORK","","",N,N],[17,"CLONE_PARENT","","",N,N],[17,"CLONE_THREAD","","",N,N],[17,"CLONE_NEWNS","","",N,N],[17,"CLONE_SYSVSEM","","",N,N],[17,"CLONE_SETTLS","","",N,N],[17,"CLONE_PARENT_SETTID","","",N,N],[17,"CLONE_CHILD_CLEARTID","","",N,N],[17,"CLONE_DETACHED","","",N,N],[17,"CLONE_UNTRACED","","",N,N],[17,"CLONE_CHILD_SETTID","","",N,N],[17,"CLONE_NEWUTS","","",N,N],[17,"CLONE_NEWIPC","","",N,N],[17,"CLONE_NEWUSER","","",N,N],[17,"CLONE_NEWPID","","",N,N],[17,"CLONE_NEWNET","","",N,N],[17,"CLONE_IO","","",N,N],[17,"CLONE_NEWCGROUP","","",N,N],[17,"WNOHANG","","",N,N],[17,"WUNTRACED","","",N,N],[17,"WSTOPPED","","",N,N],[17,"WEXITED","","",N,N],[17,"WCONTINUED","","",N,N],[17,"WNOWAIT","","",N,N],[17,"PTRACE_O_TRACESYSGOOD","","",N,N],[17,"PTRACE_O_TRACEFORK","","",N,N],[17,"PTRACE_O_TRACEVFORK","","",N,N],[17,"PTRACE_O_TRACECLONE","","",N,N],[17,"PTRACE_O_TRACEEXEC","","",N,N],[17,"PTRACE_O_TRACEVFORKDONE","","",N,N],[17,"PTRACE_O_TRACEEXIT","","",N,N],[17,"PTRACE_O_TRACESECCOMP","","",N,N],[17,"PTRACE_O_EXITKILL","","",N,N],[17,"PTRACE_O_SUSPEND_SECCOMP","","",N,N],[17,"PTRACE_O_MASK","","",N,N],[17,"PTRACE_EVENT_FORK","","",N,N],[17,"PTRACE_EVENT_VFORK","","",N,N],[17,"PTRACE_EVENT_CLONE","","",N,N],[17,"PTRACE_EVENT_EXEC","","",N,N],[17,"PTRACE_EVENT_VFORK_DONE","","",N,N],[17,"PTRACE_EVENT_EXIT","","",N,N],[17,"PTRACE_EVENT_SECCOMP","","",N,N],[17,"__WNOTHREAD","","",N,N],[17,"__WALL","","",N,N],[17,"__WCLONE","","",N,N],[17,"SPLICE_F_MOVE","","",N,N],[17,"SPLICE_F_NONBLOCK","","",N,N],[17,"SPLICE_F_MORE","","",N,N],[17,"SPLICE_F_GIFT","","",N,N],[17,"RTLD_LOCAL","","",N,N],[17,"RTLD_LAZY","","",N,N],[17,"POSIX_FADV_NORMAL","","",N,N],[17,"POSIX_FADV_RANDOM","","",N,N],[17,"POSIX_FADV_SEQUENTIAL","","",N,N],[17,"POSIX_FADV_WILLNEED","","",N,N],[17,"AT_FDCWD","","",N,N],[17,"AT_SYMLINK_NOFOLLOW","","",N,N],[17,"AT_REMOVEDIR","","",N,N],[17,"AT_SYMLINK_FOLLOW","","",N,N],[17,"AT_NO_AUTOMOUNT","","",N,N],[17,"AT_EMPTY_PATH","","",N,N],[17,"LOG_CRON","","",N,N],[17,"LOG_AUTHPRIV","","",N,N],[17,"LOG_FTP","","",N,N],[17,"LOG_PERROR","","",N,N],[17,"PIPE_BUF","","",N,N],[17,"SI_LOAD_SHIFT","","",N,N],[17,"SIGEV_SIGNAL","","",N,N],[17,"SIGEV_NONE","","",N,N],[17,"SIGEV_THREAD","","",N,N],[17,"P_ALL","","",N,N],[17,"P_PID","","",N,N],[17,"P_PGID","","",N,N],[17,"UTIME_OMIT","","",N,N],[17,"UTIME_NOW","","",N,N],[17,"POLLIN","","",N,N],[17,"POLLPRI","","",N,N],[17,"POLLOUT","","",N,N],[17,"POLLERR","","",N,N],[17,"POLLHUP","","",N,N],[17,"POLLNVAL","","",N,N],[17,"POLLRDNORM","","",N,N],[17,"POLLRDBAND","","",N,N],[17,"IPTOS_LOWDELAY","","",N,N],[17,"IPTOS_THROUGHPUT","","",N,N],[17,"IPTOS_RELIABILITY","","",N,N],[17,"IPTOS_MINCOST","","",N,N],[17,"IPTOS_PREC_NETCONTROL","","",N,N],[17,"IPTOS_PREC_INTERNETCONTROL","","",N,N],[17,"IPTOS_PREC_CRITIC_ECP","","",N,N],[17,"IPTOS_PREC_FLASHOVERRIDE","","",N,N],[17,"IPTOS_PREC_FLASH","","",N,N],[17,"IPTOS_PREC_IMMEDIATE","","",N,N],[17,"IPTOS_PREC_PRIORITY","","",N,N],[17,"IPTOS_PREC_ROUTINE","","",N,N],[17,"IPOPT_COPY","","",N,N],[17,"IPOPT_CLASS_MASK","","",N,N],[17,"IPOPT_NUMBER_MASK","","",N,N],[17,"IPOPT_CONTROL","","",N,N],[17,"IPOPT_RESERVED1","","",N,N],[17,"IPOPT_MEASUREMENT","","",N,N],[17,"IPOPT_RESERVED2","","",N,N],[17,"IPOPT_END","","",N,N],[17,"IPOPT_NOOP","","",N,N],[17,"IPOPT_SEC","","",N,N],[17,"IPOPT_LSRR","","",N,N],[17,"IPOPT_TIMESTAMP","","",N,N],[17,"IPOPT_RR","","",N,N],[17,"IPOPT_SID","","",N,N],[17,"IPOPT_SSRR","","",N,N],[17,"IPOPT_RA","","",N,N],[17,"IPVERSION","","",N,N],[17,"MAXTTL","","",N,N],[17,"IPDEFTTL","","",N,N],[17,"IPOPT_OPTVAL","","",N,N],[17,"IPOPT_OLEN","","",N,N],[17,"IPOPT_OFFSET","","",N,N],[17,"IPOPT_MINOFF","","",N,N],[17,"MAX_IPOPTLEN","","",N,N],[17,"IPOPT_NOP","","",N,N],[17,"IPOPT_EOL","","",N,N],[17,"IPOPT_TS","","",N,N],[17,"IPOPT_TS_TSONLY","","",N,N],[17,"IPOPT_TS_TSANDADDR","","",N,N],[17,"IPOPT_TS_PRESPEC","","",N,N],[17,"ARPOP_RREQUEST","","",N,N],[17,"ARPOP_RREPLY","","",N,N],[17,"ARPOP_InREQUEST","","",N,N],[17,"ARPOP_InREPLY","","",N,N],[17,"ARPOP_NAK","","",N,N],[17,"ATF_NETMASK","","",N,N],[17,"ATF_DONTPUB","","",N,N],[17,"ARPHRD_NETROM","","",N,N],[17,"ARPHRD_ETHER","","",N,N],[17,"ARPHRD_EETHER","","",N,N],[17,"ARPHRD_AX25","","",N,N],[17,"ARPHRD_PRONET","","",N,N],[17,"ARPHRD_CHAOS","","",N,N],[17,"ARPHRD_IEEE802","","",N,N],[17,"ARPHRD_ARCNET","","",N,N],[17,"ARPHRD_APPLETLK","","",N,N],[17,"ARPHRD_DLCI","","",N,N],[17,"ARPHRD_ATM","","",N,N],[17,"ARPHRD_METRICOM","","",N,N],[17,"ARPHRD_IEEE1394","","",N,N],[17,"ARPHRD_EUI64","","",N,N],[17,"ARPHRD_INFINIBAND","","",N,N],[17,"ARPHRD_SLIP","","",N,N],[17,"ARPHRD_CSLIP","","",N,N],[17,"ARPHRD_SLIP6","","",N,N],[17,"ARPHRD_CSLIP6","","",N,N],[17,"ARPHRD_RSRVD","","",N,N],[17,"ARPHRD_ADAPT","","",N,N],[17,"ARPHRD_ROSE","","",N,N],[17,"ARPHRD_X25","","",N,N],[17,"ARPHRD_HWX25","","",N,N],[17,"ARPHRD_PPP","","",N,N],[17,"ARPHRD_CISCO","","",N,N],[17,"ARPHRD_HDLC","","",N,N],[17,"ARPHRD_LAPB","","",N,N],[17,"ARPHRD_DDCMP","","",N,N],[17,"ARPHRD_RAWHDLC","","",N,N],[17,"ARPHRD_TUNNEL","","",N,N],[17,"ARPHRD_TUNNEL6","","",N,N],[17,"ARPHRD_FRAD","","",N,N],[17,"ARPHRD_SKIP","","",N,N],[17,"ARPHRD_LOOPBACK","","",N,N],[17,"ARPHRD_LOCALTLK","","",N,N],[17,"ARPHRD_FDDI","","",N,N],[17,"ARPHRD_BIF","","",N,N],[17,"ARPHRD_SIT","","",N,N],[17,"ARPHRD_IPDDP","","",N,N],[17,"ARPHRD_IPGRE","","",N,N],[17,"ARPHRD_PIMREG","","",N,N],[17,"ARPHRD_HIPPI","","",N,N],[17,"ARPHRD_ASH","","",N,N],[17,"ARPHRD_ECONET","","",N,N],[17,"ARPHRD_IRDA","","",N,N],[17,"ARPHRD_FCPP","","",N,N],[17,"ARPHRD_FCAL","","",N,N],[17,"ARPHRD_FCPL","","",N,N],[17,"ARPHRD_FCFABRIC","","",N,N],[17,"ARPHRD_IEEE802_TR","","",N,N],[17,"ARPHRD_IEEE80211","","",N,N],[17,"ARPHRD_IEEE80211_PRISM","","",N,N],[17,"ARPHRD_IEEE80211_RADIOTAP","","",N,N],[17,"ARPHRD_IEEE802154","","",N,N],[17,"ARPHRD_VOID","","",N,N],[17,"ARPHRD_NONE","","",N,N],[17,"ABDAY_1","","",N,N],[17,"ABDAY_2","","",N,N],[17,"ABDAY_3","","",N,N],[17,"ABDAY_4","","",N,N],[17,"ABDAY_5","","",N,N],[17,"ABDAY_6","","",N,N],[17,"ABDAY_7","","",N,N],[17,"DAY_1","","",N,N],[17,"DAY_2","","",N,N],[17,"DAY_3","","",N,N],[17,"DAY_4","","",N,N],[17,"DAY_5","","",N,N],[17,"DAY_6","","",N,N],[17,"DAY_7","","",N,N],[17,"ABMON_1","","",N,N],[17,"ABMON_2","","",N,N],[17,"ABMON_3","","",N,N],[17,"ABMON_4","","",N,N],[17,"ABMON_5","","",N,N],[17,"ABMON_6","","",N,N],[17,"ABMON_7","","",N,N],[17,"ABMON_8","","",N,N],[17,"ABMON_9","","",N,N],[17,"ABMON_10","","",N,N],[17,"ABMON_11","","",N,N],[17,"ABMON_12","","",N,N],[17,"MON_1","","",N,N],[17,"MON_2","","",N,N],[17,"MON_3","","",N,N],[17,"MON_4","","",N,N],[17,"MON_5","","",N,N],[17,"MON_6","","",N,N],[17,"MON_7","","",N,N],[17,"MON_8","","",N,N],[17,"MON_9","","",N,N],[17,"MON_10","","",N,N],[17,"MON_11","","",N,N],[17,"MON_12","","",N,N],[17,"AM_STR","","",N,N],[17,"PM_STR","","",N,N],[17,"D_T_FMT","","",N,N],[17,"D_FMT","","",N,N],[17,"T_FMT","","",N,N],[17,"T_FMT_AMPM","","",N,N],[17,"ERA","","",N,N],[17,"ERA_D_FMT","","",N,N],[17,"ALT_DIGITS","","",N,N],[17,"ERA_D_T_FMT","","",N,N],[17,"ERA_T_FMT","","",N,N],[17,"CODESET","","",N,N],[17,"CRNCYSTR","","",N,N],[17,"RUSAGE_THREAD","","",N,N],[17,"RUSAGE_CHILDREN","","",N,N],[17,"RADIXCHAR","","",N,N],[17,"THOUSEP","","",N,N],[17,"YESEXPR","","",N,N],[17,"NOEXPR","","",N,N],[17,"YESSTR","","",N,N],[17,"NOSTR","","",N,N],[17,"FILENAME_MAX","","",N,N],[17,"L_tmpnam","","",N,N],[17,"_PC_LINK_MAX","","",N,N],[17,"_PC_MAX_CANON","","",N,N],[17,"_PC_MAX_INPUT","","",N,N],[17,"_PC_NAME_MAX","","",N,N],[17,"_PC_PATH_MAX","","",N,N],[17,"_PC_PIPE_BUF","","",N,N],[17,"_PC_CHOWN_RESTRICTED","","",N,N],[17,"_PC_NO_TRUNC","","",N,N],[17,"_PC_VDISABLE","","",N,N],[17,"_PC_SYNC_IO","","",N,N],[17,"_PC_ASYNC_IO","","",N,N],[17,"_PC_PRIO_IO","","",N,N],[17,"_PC_SOCK_MAXBUF","","",N,N],[17,"_PC_FILESIZEBITS","","",N,N],[17,"_PC_REC_INCR_XFER_SIZE","","",N,N],[17,"_PC_REC_MAX_XFER_SIZE","","",N,N],[17,"_PC_REC_MIN_XFER_SIZE","","",N,N],[17,"_PC_REC_XFER_ALIGN","","",N,N],[17,"_PC_ALLOC_SIZE_MIN","","",N,N],[17,"_PC_SYMLINK_MAX","","",N,N],[17,"_PC_2_SYMLINKS","","",N,N],[17,"_SC_ARG_MAX","","",N,N],[17,"_SC_CHILD_MAX","","",N,N],[17,"_SC_CLK_TCK","","",N,N],[17,"_SC_NGROUPS_MAX","","",N,N],[17,"_SC_OPEN_MAX","","",N,N],[17,"_SC_STREAM_MAX","","",N,N],[17,"_SC_TZNAME_MAX","","",N,N],[17,"_SC_JOB_CONTROL","","",N,N],[17,"_SC_SAVED_IDS","","",N,N],[17,"_SC_REALTIME_SIGNALS","","",N,N],[17,"_SC_PRIORITY_SCHEDULING","","",N,N],[17,"_SC_TIMERS","","",N,N],[17,"_SC_ASYNCHRONOUS_IO","","",N,N],[17,"_SC_PRIORITIZED_IO","","",N,N],[17,"_SC_SYNCHRONIZED_IO","","",N,N],[17,"_SC_FSYNC","","",N,N],[17,"_SC_MAPPED_FILES","","",N,N],[17,"_SC_MEMLOCK","","",N,N],[17,"_SC_MEMLOCK_RANGE","","",N,N],[17,"_SC_MEMORY_PROTECTION","","",N,N],[17,"_SC_MESSAGE_PASSING","","",N,N],[17,"_SC_SEMAPHORES","","",N,N],[17,"_SC_SHARED_MEMORY_OBJECTS","","",N,N],[17,"_SC_AIO_LISTIO_MAX","","",N,N],[17,"_SC_AIO_MAX","","",N,N],[17,"_SC_AIO_PRIO_DELTA_MAX","","",N,N],[17,"_SC_DELAYTIMER_MAX","","",N,N],[17,"_SC_MQ_OPEN_MAX","","",N,N],[17,"_SC_MQ_PRIO_MAX","","",N,N],[17,"_SC_VERSION","","",N,N],[17,"_SC_PAGESIZE","","",N,N],[17,"_SC_PAGE_SIZE","","",N,N],[17,"_SC_RTSIG_MAX","","",N,N],[17,"_SC_SEM_NSEMS_MAX","","",N,N],[17,"_SC_SEM_VALUE_MAX","","",N,N],[17,"_SC_SIGQUEUE_MAX","","",N,N],[17,"_SC_TIMER_MAX","","",N,N],[17,"_SC_BC_BASE_MAX","","",N,N],[17,"_SC_BC_DIM_MAX","","",N,N],[17,"_SC_BC_SCALE_MAX","","",N,N],[17,"_SC_BC_STRING_MAX","","",N,N],[17,"_SC_COLL_WEIGHTS_MAX","","",N,N],[17,"_SC_EXPR_NEST_MAX","","",N,N],[17,"_SC_LINE_MAX","","",N,N],[17,"_SC_RE_DUP_MAX","","",N,N],[17,"_SC_2_VERSION","","",N,N],[17,"_SC_2_C_BIND","","",N,N],[17,"_SC_2_C_DEV","","",N,N],[17,"_SC_2_FORT_DEV","","",N,N],[17,"_SC_2_FORT_RUN","","",N,N],[17,"_SC_2_SW_DEV","","",N,N],[17,"_SC_2_LOCALEDEF","","",N,N],[17,"_SC_UIO_MAXIOV","","",N,N],[17,"_SC_IOV_MAX","","",N,N],[17,"_SC_THREADS","","",N,N],[17,"_SC_THREAD_SAFE_FUNCTIONS","","",N,N],[17,"_SC_GETGR_R_SIZE_MAX","","",N,N],[17,"_SC_GETPW_R_SIZE_MAX","","",N,N],[17,"_SC_LOGIN_NAME_MAX","","",N,N],[17,"_SC_TTY_NAME_MAX","","",N,N],[17,"_SC_THREAD_DESTRUCTOR_ITERATIONS","","",N,N],[17,"_SC_THREAD_KEYS_MAX","","",N,N],[17,"_SC_THREAD_STACK_MIN","","",N,N],[17,"_SC_THREAD_THREADS_MAX","","",N,N],[17,"_SC_THREAD_ATTR_STACKADDR","","",N,N],[17,"_SC_THREAD_ATTR_STACKSIZE","","",N,N],[17,"_SC_THREAD_PRIORITY_SCHEDULING","","",N,N],[17,"_SC_THREAD_PRIO_INHERIT","","",N,N],[17,"_SC_THREAD_PRIO_PROTECT","","",N,N],[17,"_SC_THREAD_PROCESS_SHARED","","",N,N],[17,"_SC_NPROCESSORS_CONF","","",N,N],[17,"_SC_NPROCESSORS_ONLN","","",N,N],[17,"_SC_PHYS_PAGES","","",N,N],[17,"_SC_AVPHYS_PAGES","","",N,N],[17,"_SC_ATEXIT_MAX","","",N,N],[17,"_SC_PASS_MAX","","",N,N],[17,"_SC_XOPEN_VERSION","","",N,N],[17,"_SC_XOPEN_XCU_VERSION","","",N,N],[17,"_SC_XOPEN_UNIX","","",N,N],[17,"_SC_XOPEN_CRYPT","","",N,N],[17,"_SC_XOPEN_ENH_I18N","","",N,N],[17,"_SC_XOPEN_SHM","","",N,N],[17,"_SC_2_CHAR_TERM","","",N,N],[17,"_SC_2_UPE","","",N,N],[17,"_SC_XOPEN_XPG2","","",N,N],[17,"_SC_XOPEN_XPG3","","",N,N],[17,"_SC_XOPEN_XPG4","","",N,N],[17,"_SC_NZERO","","",N,N],[17,"_SC_XBS5_ILP32_OFF32","","",N,N],[17,"_SC_XBS5_ILP32_OFFBIG","","",N,N],[17,"_SC_XBS5_LP64_OFF64","","",N,N],[17,"_SC_XBS5_LPBIG_OFFBIG","","",N,N],[17,"_SC_XOPEN_LEGACY","","",N,N],[17,"_SC_XOPEN_REALTIME","","",N,N],[17,"_SC_XOPEN_REALTIME_THREADS","","",N,N],[17,"_SC_ADVISORY_INFO","","",N,N],[17,"_SC_BARRIERS","","",N,N],[17,"_SC_CLOCK_SELECTION","","",N,N],[17,"_SC_CPUTIME","","",N,N],[17,"_SC_THREAD_CPUTIME","","",N,N],[17,"_SC_MONOTONIC_CLOCK","","",N,N],[17,"_SC_READER_WRITER_LOCKS","","",N,N],[17,"_SC_SPIN_LOCKS","","",N,N],[17,"_SC_REGEXP","","",N,N],[17,"_SC_SHELL","","",N,N],[17,"_SC_SPAWN","","",N,N],[17,"_SC_SPORADIC_SERVER","","",N,N],[17,"_SC_THREAD_SPORADIC_SERVER","","",N,N],[17,"_SC_TIMEOUTS","","",N,N],[17,"_SC_TYPED_MEMORY_OBJECTS","","",N,N],[17,"_SC_2_PBS","","",N,N],[17,"_SC_2_PBS_ACCOUNTING","","",N,N],[17,"_SC_2_PBS_LOCATE","","",N,N],[17,"_SC_2_PBS_MESSAGE","","",N,N],[17,"_SC_2_PBS_TRACK","","",N,N],[17,"_SC_SYMLOOP_MAX","","",N,N],[17,"_SC_STREAMS","","",N,N],[17,"_SC_2_PBS_CHECKPOINT","","",N,N],[17,"_SC_V6_ILP32_OFF32","","",N,N],[17,"_SC_V6_ILP32_OFFBIG","","",N,N],[17,"_SC_V6_LP64_OFF64","","",N,N],[17,"_SC_V6_LPBIG_OFFBIG","","",N,N],[17,"_SC_HOST_NAME_MAX","","",N,N],[17,"_SC_TRACE","","",N,N],[17,"_SC_TRACE_EVENT_FILTER","","",N,N],[17,"_SC_TRACE_INHERIT","","",N,N],[17,"_SC_TRACE_LOG","","",N,N],[17,"_SC_IPV6","","",N,N],[17,"_SC_RAW_SOCKETS","","",N,N],[17,"_SC_V7_ILP32_OFF32","","",N,N],[17,"_SC_V7_ILP32_OFFBIG","","",N,N],[17,"_SC_V7_LP64_OFF64","","",N,N],[17,"_SC_V7_LPBIG_OFFBIG","","",N,N],[17,"_SC_SS_REPL_MAX","","",N,N],[17,"_SC_TRACE_EVENT_NAME_MAX","","",N,N],[17,"_SC_TRACE_NAME_MAX","","",N,N],[17,"_SC_TRACE_SYS_MAX","","",N,N],[17,"_SC_TRACE_USER_EVENT_MAX","","",N,N],[17,"_SC_XOPEN_STREAMS","","",N,N],[17,"_SC_THREAD_ROBUST_PRIO_INHERIT","","",N,N],[17,"_SC_THREAD_ROBUST_PRIO_PROTECT","","",N,N],[17,"RLIM_SAVED_MAX","","",N,N],[17,"RLIM_SAVED_CUR","","",N,N],[17,"GLOB_ERR","","",N,N],[17,"GLOB_MARK","","",N,N],[17,"GLOB_NOSORT","","",N,N],[17,"GLOB_DOOFFS","","",N,N],[17,"GLOB_NOCHECK","","",N,N],[17,"GLOB_APPEND","","",N,N],[17,"GLOB_NOESCAPE","","",N,N],[17,"GLOB_NOSPACE","","",N,N],[17,"GLOB_ABORTED","","",N,N],[17,"GLOB_NOMATCH","","",N,N],[17,"POSIX_MADV_NORMAL","","",N,N],[17,"POSIX_MADV_RANDOM","","",N,N],[17,"POSIX_MADV_SEQUENTIAL","","",N,N],[17,"POSIX_MADV_WILLNEED","","",N,N],[17,"S_IEXEC","","",N,N],[17,"S_IWRITE","","",N,N],[17,"S_IREAD","","",N,N],[17,"F_LOCK","","",N,N],[17,"F_TEST","","",N,N],[17,"F_TLOCK","","",N,N],[17,"F_ULOCK","","",N,N],[17,"IFF_LOWER_UP","","",N,N],[17,"IFF_DORMANT","","",N,N],[17,"IFF_ECHO","","",N,N],[17,"IFF_TUN","","",N,N],[17,"IFF_TAP","","",N,N],[17,"IFF_NO_PI","","",N,N],[17,"TUN_READQ_SIZE","","",N,N],[17,"TUN_TUN_DEV","","",N,N],[17,"TUN_TAP_DEV","","",N,N],[17,"TUN_TYPE_MASK","","",N,N],[17,"IFF_ONE_QUEUE","","",N,N],[17,"IFF_VNET_HDR","","",N,N],[17,"IFF_TUN_EXCL","","",N,N],[17,"IFF_MULTI_QUEUE","","",N,N],[17,"IFF_ATTACH_QUEUE","","",N,N],[17,"IFF_DETACH_QUEUE","","",N,N],[17,"IFF_PERSIST","","",N,N],[17,"IFF_NOFILTER","","",N,N],[17,"ST_RDONLY","","",N,N],[17,"ST_NOSUID","","",N,N],[17,"ST_NODEV","","",N,N],[17,"ST_NOEXEC","","",N,N],[17,"ST_SYNCHRONOUS","","",N,N],[17,"ST_MANDLOCK","","",N,N],[17,"ST_WRITE","","",N,N],[17,"ST_APPEND","","",N,N],[17,"ST_IMMUTABLE","","",N,N],[17,"ST_NOATIME","","",N,N],[17,"ST_NODIRATIME","","",N,N],[17,"RTLD_NEXT","","",N,N],[17,"RTLD_DEFAULT","","",N,N],[17,"RTLD_NODELETE","","",N,N],[17,"RTLD_NOW","","",N,N],[17,"TCP_MD5SIG","","",N,N],[17,"PTHREAD_MUTEX_INITIALIZER","","",N,N],[17,"PTHREAD_COND_INITIALIZER","","",N,N],[17,"PTHREAD_RWLOCK_INITIALIZER","","",N,N],[17,"PTHREAD_MUTEX_NORMAL","","",N,N],[17,"PTHREAD_MUTEX_RECURSIVE","","",N,N],[17,"PTHREAD_MUTEX_ERRORCHECK","","",N,N],[17,"PTHREAD_MUTEX_DEFAULT","","",N,N],[17,"PTHREAD_PROCESS_PRIVATE","","",N,N],[17,"PTHREAD_PROCESS_SHARED","","",N,N],[17,"__SIZEOF_PTHREAD_COND_T","","",N,N],[17,"RENAME_NOREPLACE","","",N,N],[17,"RENAME_EXCHANGE","","",N,N],[17,"RENAME_WHITEOUT","","",N,N],[17,"SCHED_OTHER","","",N,N],[17,"SCHED_FIFO","","",N,N],[17,"SCHED_RR","","",N,N],[17,"SCHED_BATCH","","",N,N],[17,"SCHED_IDLE","","",N,N],[17,"IPPROTO_HOPOPTS","","Hop-by-hop option header",N,N],[17,"IPPROTO_IGMP","","group mgmt protocol",N,N],[17,"IPPROTO_IPIP","","for compatibility",N,N],[17,"IPPROTO_EGP","","exterior gateway protocol",N,N],[17,"IPPROTO_PUP","","pup",N,N],[17,"IPPROTO_IDP","","xns idp",N,N],[17,"IPPROTO_TP","","tp-4 w/ class negotiation",N,N],[17,"IPPROTO_DCCP","","DCCP",N,N],[17,"IPPROTO_ROUTING","","IP6 routing header",N,N],[17,"IPPROTO_FRAGMENT","","IP6 fragmentation header",N,N],[17,"IPPROTO_RSVP","","resource reservation",N,N],[17,"IPPROTO_GRE","","General Routing Encap.",N,N],[17,"IPPROTO_ESP","","IP6 Encap Sec. Payload",N,N],[17,"IPPROTO_AH","","IP6 Auth Header",N,N],[17,"IPPROTO_NONE","","IP6 no next header",N,N],[17,"IPPROTO_DSTOPTS","","IP6 destination option",N,N],[17,"IPPROTO_MTP","","",N,N],[17,"IPPROTO_BEETPH","","",N,N],[17,"IPPROTO_ENCAP","","encapsulation header",N,N],[17,"IPPROTO_PIM","","Protocol indep. multicast",N,N],[17,"IPPROTO_COMP","","IP Payload Comp. Protocol",N,N],[17,"IPPROTO_SCTP","","SCTP",N,N],[17,"IPPROTO_MH","","",N,N],[17,"IPPROTO_UDPLITE","","",N,N],[17,"IPPROTO_MPLS","","",N,N],[17,"IPPROTO_RAW","","raw IP packet",N,N],[17,"IPPROTO_MAX","","",N,N],[17,"AF_IB","","",N,N],[17,"AF_MPLS","","",N,N],[17,"AF_NFC","","",N,N],[17,"AF_VSOCK","","",N,N],[17,"PF_IB","","",N,N],[17,"PF_MPLS","","",N,N],[17,"PF_NFC","","",N,N],[17,"PF_VSOCK","","",N,N],[17,"IPC_PRIVATE","","",N,N],[17,"IPC_CREAT","","",N,N],[17,"IPC_EXCL","","",N,N],[17,"IPC_NOWAIT","","",N,N],[17,"IPC_RMID","","",N,N],[17,"IPC_SET","","",N,N],[17,"IPC_STAT","","",N,N],[17,"IPC_INFO","","",N,N],[17,"MSG_STAT","","",N,N],[17,"MSG_INFO","","",N,N],[17,"MSG_NOERROR","","",N,N],[17,"MSG_EXCEPT","","",N,N],[17,"MSG_COPY","","",N,N],[17,"SHM_R","","",N,N],[17,"SHM_W","","",N,N],[17,"SHM_RDONLY","","",N,N],[17,"SHM_RND","","",N,N],[17,"SHM_REMAP","","",N,N],[17,"SHM_EXEC","","",N,N],[17,"SHM_LOCK","","",N,N],[17,"SHM_UNLOCK","","",N,N],[17,"SHM_HUGETLB","","",N,N],[17,"SHM_NORESERVE","","",N,N],[17,"EPOLLRDHUP","","",N,N],[17,"EPOLLEXCLUSIVE","","",N,N],[17,"EPOLLONESHOT","","",N,N],[17,"QFMT_VFS_OLD","","",N,N],[17,"QFMT_VFS_V0","","",N,N],[17,"QFMT_VFS_V1","","",N,N],[17,"EFD_SEMAPHORE","","",N,N],[17,"LOG_NFACILITIES","","",N,N],[17,"SEM_FAILED","","",N,N],[17,"RB_AUTOBOOT","","",N,N],[17,"RB_HALT_SYSTEM","","",N,N],[17,"RB_ENABLE_CAD","","",N,N],[17,"RB_DISABLE_CAD","","",N,N],[17,"RB_POWER_OFF","","",N,N],[17,"RB_SW_SUSPEND","","",N,N],[17,"RB_KEXEC","","",N,N],[17,"AI_PASSIVE","","",N,N],[17,"AI_CANONNAME","","",N,N],[17,"AI_NUMERICHOST","","",N,N],[17,"AI_V4MAPPED","","",N,N],[17,"AI_ALL","","",N,N],[17,"AI_ADDRCONFIG","","",N,N],[17,"AI_NUMERICSERV","","",N,N],[17,"EAI_BADFLAGS","","",N,N],[17,"EAI_NONAME","","",N,N],[17,"EAI_AGAIN","","",N,N],[17,"EAI_FAIL","","",N,N],[17,"EAI_NODATA","","",N,N],[17,"EAI_FAMILY","","",N,N],[17,"EAI_SOCKTYPE","","",N,N],[17,"EAI_SERVICE","","",N,N],[17,"EAI_MEMORY","","",N,N],[17,"EAI_SYSTEM","","",N,N],[17,"EAI_OVERFLOW","","",N,N],[17,"NI_NUMERICHOST","","",N,N],[17,"NI_NUMERICSERV","","",N,N],[17,"NI_NOFQDN","","",N,N],[17,"NI_NAMEREQD","","",N,N],[17,"NI_DGRAM","","",N,N],[17,"SYNC_FILE_RANGE_WAIT_BEFORE","","",N,N],[17,"SYNC_FILE_RANGE_WRITE","","",N,N],[17,"SYNC_FILE_RANGE_WAIT_AFTER","","",N,N],[17,"AIO_CANCELED","","",N,N],[17,"AIO_NOTCANCELED","","",N,N],[17,"AIO_ALLDONE","","",N,N],[17,"LIO_READ","","",N,N],[17,"LIO_WRITE","","",N,N],[17,"LIO_NOP","","",N,N],[17,"LIO_WAIT","","",N,N],[17,"LIO_NOWAIT","","",N,N],[17,"MREMAP_MAYMOVE","","",N,N],[17,"MREMAP_FIXED","","",N,N],[17,"PR_SET_PDEATHSIG","","",N,N],[17,"PR_GET_PDEATHSIG","","",N,N],[17,"PR_GET_DUMPABLE","","",N,N],[17,"PR_SET_DUMPABLE","","",N,N],[17,"PR_GET_UNALIGN","","",N,N],[17,"PR_SET_UNALIGN","","",N,N],[17,"PR_UNALIGN_NOPRINT","","",N,N],[17,"PR_UNALIGN_SIGBUS","","",N,N],[17,"PR_GET_KEEPCAPS","","",N,N],[17,"PR_SET_KEEPCAPS","","",N,N],[17,"PR_GET_FPEMU","","",N,N],[17,"PR_SET_FPEMU","","",N,N],[17,"PR_FPEMU_NOPRINT","","",N,N],[17,"PR_FPEMU_SIGFPE","","",N,N],[17,"PR_GET_FPEXC","","",N,N],[17,"PR_SET_FPEXC","","",N,N],[17,"PR_FP_EXC_SW_ENABLE","","",N,N],[17,"PR_FP_EXC_DIV","","",N,N],[17,"PR_FP_EXC_OVF","","",N,N],[17,"PR_FP_EXC_UND","","",N,N],[17,"PR_FP_EXC_RES","","",N,N],[17,"PR_FP_EXC_INV","","",N,N],[17,"PR_FP_EXC_DISABLED","","",N,N],[17,"PR_FP_EXC_NONRECOV","","",N,N],[17,"PR_FP_EXC_ASYNC","","",N,N],[17,"PR_FP_EXC_PRECISE","","",N,N],[17,"PR_GET_TIMING","","",N,N],[17,"PR_SET_TIMING","","",N,N],[17,"PR_TIMING_STATISTICAL","","",N,N],[17,"PR_TIMING_TIMESTAMP","","",N,N],[17,"PR_SET_NAME","","",N,N],[17,"PR_GET_NAME","","",N,N],[17,"PR_GET_ENDIAN","","",N,N],[17,"PR_SET_ENDIAN","","",N,N],[17,"PR_ENDIAN_BIG","","",N,N],[17,"PR_ENDIAN_LITTLE","","",N,N],[17,"PR_ENDIAN_PPC_LITTLE","","",N,N],[17,"PR_GET_SECCOMP","","",N,N],[17,"PR_SET_SECCOMP","","",N,N],[17,"PR_CAPBSET_READ","","",N,N],[17,"PR_CAPBSET_DROP","","",N,N],[17,"PR_GET_TSC","","",N,N],[17,"PR_SET_TSC","","",N,N],[17,"PR_TSC_ENABLE","","",N,N],[17,"PR_TSC_SIGSEGV","","",N,N],[17,"PR_GET_SECUREBITS","","",N,N],[17,"PR_SET_SECUREBITS","","",N,N],[17,"PR_SET_TIMERSLACK","","",N,N],[17,"PR_GET_TIMERSLACK","","",N,N],[17,"PR_TASK_PERF_EVENTS_DISABLE","","",N,N],[17,"PR_TASK_PERF_EVENTS_ENABLE","","",N,N],[17,"PR_MCE_KILL","","",N,N],[17,"PR_MCE_KILL_CLEAR","","",N,N],[17,"PR_MCE_KILL_SET","","",N,N],[17,"PR_MCE_KILL_LATE","","",N,N],[17,"PR_MCE_KILL_EARLY","","",N,N],[17,"PR_MCE_KILL_DEFAULT","","",N,N],[17,"PR_MCE_KILL_GET","","",N,N],[17,"PR_SET_MM","","",N,N],[17,"PR_SET_MM_START_CODE","","",N,N],[17,"PR_SET_MM_END_CODE","","",N,N],[17,"PR_SET_MM_START_DATA","","",N,N],[17,"PR_SET_MM_END_DATA","","",N,N],[17,"PR_SET_MM_START_STACK","","",N,N],[17,"PR_SET_MM_START_BRK","","",N,N],[17,"PR_SET_MM_BRK","","",N,N],[17,"PR_SET_MM_ARG_START","","",N,N],[17,"PR_SET_MM_ARG_END","","",N,N],[17,"PR_SET_MM_ENV_START","","",N,N],[17,"PR_SET_MM_ENV_END","","",N,N],[17,"PR_SET_MM_AUXV","","",N,N],[17,"PR_SET_MM_EXE_FILE","","",N,N],[17,"PR_SET_MM_MAP","","",N,N],[17,"PR_SET_MM_MAP_SIZE","","",N,N],[17,"PR_SET_PTRACER","","",N,N],[17,"PR_SET_CHILD_SUBREAPER","","",N,N],[17,"PR_GET_CHILD_SUBREAPER","","",N,N],[17,"PR_SET_NO_NEW_PRIVS","","",N,N],[17,"PR_GET_NO_NEW_PRIVS","","",N,N],[17,"PR_GET_TID_ADDRESS","","",N,N],[17,"PR_SET_THP_DISABLE","","",N,N],[17,"PR_GET_THP_DISABLE","","",N,N],[17,"PR_MPX_ENABLE_MANAGEMENT","","",N,N],[17,"PR_MPX_DISABLE_MANAGEMENT","","",N,N],[17,"PR_SET_FP_MODE","","",N,N],[17,"PR_GET_FP_MODE","","",N,N],[17,"PR_FP_MODE_FR","","",N,N],[17,"PR_FP_MODE_FRE","","",N,N],[17,"PR_CAP_AMBIENT","","",N,N],[17,"PR_CAP_AMBIENT_IS_SET","","",N,N],[17,"PR_CAP_AMBIENT_RAISE","","",N,N],[17,"PR_CAP_AMBIENT_LOWER","","",N,N],[17,"PR_CAP_AMBIENT_CLEAR_ALL","","",N,N],[17,"GRND_NONBLOCK","","",N,N],[17,"GRND_RANDOM","","",N,N],[17,"SECCOMP_MODE_DISABLED","","",N,N],[17,"SECCOMP_MODE_STRICT","","",N,N],[17,"SECCOMP_MODE_FILTER","","",N,N],[17,"ITIMER_REAL","","",N,N],[17,"ITIMER_VIRTUAL","","",N,N],[17,"ITIMER_PROF","","",N,N],[17,"TFD_CLOEXEC","","",N,N],[17,"TFD_NONBLOCK","","",N,N],[17,"TFD_TIMER_ABSTIME","","",N,N],[17,"XATTR_CREATE","","",N,N],[17,"XATTR_REPLACE","","",N,N],[17,"_POSIX_VDISABLE","","",N,N],[17,"FALLOC_FL_KEEP_SIZE","","",N,N],[17,"FALLOC_FL_PUNCH_HOLE","","",N,N],[17,"FALLOC_FL_COLLAPSE_RANGE","","",N,N],[17,"FALLOC_FL_ZERO_RANGE","","",N,N],[17,"FALLOC_FL_INSERT_RANGE","","",N,N],[17,"FALLOC_FL_UNSHARE_RANGE","","",N,N],[17,"ENOATTR","","",N,N],[17,"SO_ORIGINAL_DST","","",N,N],[17,"IUTF8","","",N,N],[17,"CMSPAR","","",N,N],[17,"MFD_CLOEXEC","","",N,N],[17,"MFD_ALLOW_SEALING","","",N,N],[17,"PT_NULL","","",N,N],[17,"PT_LOAD","","",N,N],[17,"PT_DYNAMIC","","",N,N],[17,"PT_INTERP","","",N,N],[17,"PT_NOTE","","",N,N],[17,"PT_SHLIB","","",N,N],[17,"PT_PHDR","","",N,N],[17,"PT_TLS","","",N,N],[17,"PT_NUM","","",N,N],[17,"PT_LOOS","","",N,N],[17,"PT_GNU_EH_FRAME","","",N,N],[17,"PT_GNU_STACK","","",N,N],[17,"PT_GNU_RELRO","","",N,N],[17,"ETH_ALEN","","",N,N],[17,"ETH_HLEN","","",N,N],[17,"ETH_ZLEN","","",N,N],[17,"ETH_DATA_LEN","","",N,N],[17,"ETH_FRAME_LEN","","",N,N],[17,"ETH_FCS_LEN","","",N,N],[17,"ETH_P_LOOP","","",N,N],[17,"ETH_P_PUP","","",N,N],[17,"ETH_P_PUPAT","","",N,N],[17,"ETH_P_IP","","",N,N],[17,"ETH_P_X25","","",N,N],[17,"ETH_P_ARP","","",N,N],[17,"ETH_P_BPQ","","",N,N],[17,"ETH_P_IEEEPUP","","",N,N],[17,"ETH_P_IEEEPUPAT","","",N,N],[17,"ETH_P_BATMAN","","",N,N],[17,"ETH_P_DEC","","",N,N],[17,"ETH_P_DNA_DL","","",N,N],[17,"ETH_P_DNA_RC","","",N,N],[17,"ETH_P_DNA_RT","","",N,N],[17,"ETH_P_LAT","","",N,N],[17,"ETH_P_DIAG","","",N,N],[17,"ETH_P_CUST","","",N,N],[17,"ETH_P_SCA","","",N,N],[17,"ETH_P_TEB","","",N,N],[17,"ETH_P_RARP","","",N,N],[17,"ETH_P_ATALK","","",N,N],[17,"ETH_P_AARP","","",N,N],[17,"ETH_P_8021Q","","",N,N],[17,"ETH_P_IPX","","",N,N],[17,"ETH_P_IPV6","","",N,N],[17,"ETH_P_PAUSE","","",N,N],[17,"ETH_P_SLOW","","",N,N],[17,"ETH_P_WCCP","","",N,N],[17,"ETH_P_MPLS_UC","","",N,N],[17,"ETH_P_MPLS_MC","","",N,N],[17,"ETH_P_ATMMPOA","","",N,N],[17,"ETH_P_PPP_DISC","","",N,N],[17,"ETH_P_PPP_SES","","",N,N],[17,"ETH_P_LINK_CTL","","",N,N],[17,"ETH_P_ATMFATE","","",N,N],[17,"ETH_P_PAE","","",N,N],[17,"ETH_P_AOE","","",N,N],[17,"ETH_P_8021AD","","",N,N],[17,"ETH_P_802_EX1","","",N,N],[17,"ETH_P_TIPC","","",N,N],[17,"ETH_P_MACSEC","","",N,N],[17,"ETH_P_8021AH","","",N,N],[17,"ETH_P_MVRP","","",N,N],[17,"ETH_P_1588","","",N,N],[17,"ETH_P_PRP","","",N,N],[17,"ETH_P_FCOE","","",N,N],[17,"ETH_P_TDLS","","",N,N],[17,"ETH_P_FIP","","",N,N],[17,"ETH_P_80221","","",N,N],[17,"ETH_P_LOOPBACK","","",N,N],[17,"ETH_P_QINQ1","","",N,N],[17,"ETH_P_QINQ2","","",N,N],[17,"ETH_P_QINQ3","","",N,N],[17,"ETH_P_EDSA","","",N,N],[17,"ETH_P_AF_IUCV","","",N,N],[17,"ETH_P_802_3_MIN","","",N,N],[17,"ETH_P_802_3","","",N,N],[17,"ETH_P_AX25","","",N,N],[17,"ETH_P_ALL","","",N,N],[17,"ETH_P_802_2","","",N,N],[17,"ETH_P_SNAP","","",N,N],[17,"ETH_P_DDCMP","","",N,N],[17,"ETH_P_WAN_PPP","","",N,N],[17,"ETH_P_PPP_MP","","",N,N],[17,"ETH_P_LOCALTALK","","",N,N],[17,"ETH_P_CANFD","","",N,N],[17,"ETH_P_PPPTALK","","",N,N],[17,"ETH_P_TR_802_2","","",N,N],[17,"ETH_P_MOBITEX","","",N,N],[17,"ETH_P_CONTROL","","",N,N],[17,"ETH_P_IRDA","","",N,N],[17,"ETH_P_ECONET","","",N,N],[17,"ETH_P_HDLC","","",N,N],[17,"ETH_P_ARCNET","","",N,N],[17,"ETH_P_DSA","","",N,N],[17,"ETH_P_TRAILER","","",N,N],[17,"ETH_P_PHONET","","",N,N],[17,"ETH_P_IEEE802154","","",N,N],[17,"ETH_P_CAIF","","",N,N],[17,"POSIX_SPAWN_RESETIDS","","",N,N],[17,"POSIX_SPAWN_SETPGROUP","","",N,N],[17,"POSIX_SPAWN_SETSIGDEF","","",N,N],[17,"POSIX_SPAWN_SETSIGMASK","","",N,N],[17,"POSIX_SPAWN_SETSCHEDPARAM","","",N,N],[17,"POSIX_SPAWN_SETSCHEDULER","","",N,N],[17,"NLMSG_NOOP","","",N,N],[17,"NLMSG_ERROR","","",N,N],[17,"NLMSG_DONE","","",N,N],[17,"NLMSG_OVERRUN","","",N,N],[17,"NLMSG_MIN_TYPE","","",N,N],[17,"GENL_NAMSIZ","","",N,N],[17,"GENL_MIN_ID","","",N,N],[17,"GENL_MAX_ID","","",N,N],[17,"GENL_ADMIN_PERM","","",N,N],[17,"GENL_CMD_CAP_DO","","",N,N],[17,"GENL_CMD_CAP_DUMP","","",N,N],[17,"GENL_CMD_CAP_HASPOL","","",N,N],[17,"GENL_ID_CTRL","","",N,N],[17,"CTRL_CMD_UNSPEC","","",N,N],[17,"CTRL_CMD_NEWFAMILY","","",N,N],[17,"CTRL_CMD_DELFAMILY","","",N,N],[17,"CTRL_CMD_GETFAMILY","","",N,N],[17,"CTRL_CMD_NEWOPS","","",N,N],[17,"CTRL_CMD_DELOPS","","",N,N],[17,"CTRL_CMD_GETOPS","","",N,N],[17,"CTRL_CMD_NEWMCAST_GRP","","",N,N],[17,"CTRL_CMD_DELMCAST_GRP","","",N,N],[17,"CTRL_CMD_GETMCAST_GRP","","",N,N],[17,"CTRL_ATTR_UNSPEC","","",N,N],[17,"CTRL_ATTR_FAMILY_ID","","",N,N],[17,"CTRL_ATTR_FAMILY_NAME","","",N,N],[17,"CTRL_ATTR_VERSION","","",N,N],[17,"CTRL_ATTR_HDRSIZE","","",N,N],[17,"CTRL_ATTR_MAXATTR","","",N,N],[17,"CTRL_ATTR_OPS","","",N,N],[17,"CTRL_ATTR_MCAST_GROUPS","","",N,N],[17,"CTRL_ATTR_OP_UNSPEC","","",N,N],[17,"CTRL_ATTR_OP_ID","","",N,N],[17,"CTRL_ATTR_OP_FLAGS","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_UNSPEC","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_NAME","","",N,N],[17,"CTRL_ATTR_MCAST_GRP_ID","","",N,N],[17,"PACKET_ADD_MEMBERSHIP","","",N,N],[17,"PACKET_DROP_MEMBERSHIP","","",N,N],[17,"PACKET_MR_MULTICAST","","",N,N],[17,"PACKET_MR_PROMISC","","",N,N],[17,"PACKET_MR_ALLMULTI","","",N,N],[17,"PACKET_MR_UNICAST","","",N,N],[17,"NF_DROP","","",N,N],[17,"NF_ACCEPT","","",N,N],[17,"NF_STOLEN","","",N,N],[17,"NF_QUEUE","","",N,N],[17,"NF_REPEAT","","",N,N],[17,"NF_STOP","","",N,N],[17,"NF_MAX_VERDICT","","",N,N],[17,"NF_VERDICT_MASK","","",N,N],[17,"NF_VERDICT_FLAG_QUEUE_BYPASS","","",N,N],[17,"NF_VERDICT_QMASK","","",N,N],[17,"NF_VERDICT_QBITS","","",N,N],[17,"NF_VERDICT_BITS","","",N,N],[17,"NF_INET_PRE_ROUTING","","",N,N],[17,"NF_INET_LOCAL_IN","","",N,N],[17,"NF_INET_FORWARD","","",N,N],[17,"NF_INET_LOCAL_OUT","","",N,N],[17,"NF_INET_POST_ROUTING","","",N,N],[17,"NF_INET_NUMHOOKS","","",N,N],[17,"NFPROTO_UNSPEC","","",N,N],[17,"NFPROTO_IPV4","","",N,N],[17,"NFPROTO_ARP","","",N,N],[17,"NFPROTO_BRIDGE","","",N,N],[17,"NFPROTO_IPV6","","",N,N],[17,"NFPROTO_DECNET","","",N,N],[17,"NFPROTO_NUMPROTO","","",N,N],[17,"NF_IP_PRE_ROUTING","","",N,N],[17,"NF_IP_LOCAL_IN","","",N,N],[17,"NF_IP_FORWARD","","",N,N],[17,"NF_IP_LOCAL_OUT","","",N,N],[17,"NF_IP_POST_ROUTING","","",N,N],[17,"NF_IP_NUMHOOKS","","",N,N],[17,"NF_IP_PRI_FIRST","","",N,N],[17,"NF_IP_PRI_CONNTRACK_DEFRAG","","",N,N],[17,"NF_IP_PRI_RAW","","",N,N],[17,"NF_IP_PRI_SELINUX_FIRST","","",N,N],[17,"NF_IP_PRI_CONNTRACK","","",N,N],[17,"NF_IP_PRI_MANGLE","","",N,N],[17,"NF_IP_PRI_NAT_DST","","",N,N],[17,"NF_IP_PRI_FILTER","","",N,N],[17,"NF_IP_PRI_SECURITY","","",N,N],[17,"NF_IP_PRI_NAT_SRC","","",N,N],[17,"NF_IP_PRI_SELINUX_LAST","","",N,N],[17,"NF_IP_PRI_CONNTRACK_HELPER","","",N,N],[17,"NF_IP_PRI_CONNTRACK_CONFIRM","","",N,N],[17,"NF_IP_PRI_LAST","","",N,N],[17,"NF_IP6_PRE_ROUTING","","",N,N],[17,"NF_IP6_LOCAL_IN","","",N,N],[17,"NF_IP6_FORWARD","","",N,N],[17,"NF_IP6_LOCAL_OUT","","",N,N],[17,"NF_IP6_POST_ROUTING","","",N,N],[17,"NF_IP6_NUMHOOKS","","",N,N],[17,"NF_IP6_PRI_FIRST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK_DEFRAG","","",N,N],[17,"NF_IP6_PRI_RAW","","",N,N],[17,"NF_IP6_PRI_SELINUX_FIRST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK","","",N,N],[17,"NF_IP6_PRI_MANGLE","","",N,N],[17,"NF_IP6_PRI_NAT_DST","","",N,N],[17,"NF_IP6_PRI_FILTER","","",N,N],[17,"NF_IP6_PRI_SECURITY","","",N,N],[17,"NF_IP6_PRI_NAT_SRC","","",N,N],[17,"NF_IP6_PRI_SELINUX_LAST","","",N,N],[17,"NF_IP6_PRI_CONNTRACK_HELPER","","",N,N],[17,"NF_IP6_PRI_LAST","","",N,N],[17,"SIOCADDRT","","",N,N],[17,"SIOCDELRT","","",N,N],[17,"SIOCGIFNAME","","",N,N],[17,"SIOCSIFLINK","","",N,N],[17,"SIOCGIFCONF","","",N,N],[17,"SIOCGIFFLAGS","","",N,N],[17,"SIOCSIFFLAGS","","",N,N],[17,"SIOCGIFADDR","","",N,N],[17,"SIOCSIFADDR","","",N,N],[17,"SIOCGIFDSTADDR","","",N,N],[17,"SIOCSIFDSTADDR","","",N,N],[17,"SIOCGIFBRDADDR","","",N,N],[17,"SIOCSIFBRDADDR","","",N,N],[17,"SIOCGIFNETMASK","","",N,N],[17,"SIOCSIFNETMASK","","",N,N],[17,"SIOCGIFMETRIC","","",N,N],[17,"SIOCSIFMETRIC","","",N,N],[17,"SIOCGIFMEM","","",N,N],[17,"SIOCSIFMEM","","",N,N],[17,"SIOCGIFMTU","","",N,N],[17,"SIOCSIFMTU","","",N,N],[17,"SIOCSIFHWADDR","","",N,N],[17,"SIOCGIFENCAP","","",N,N],[17,"SIOCSIFENCAP","","",N,N],[17,"SIOCGIFHWADDR","","",N,N],[17,"SIOCGIFSLAVE","","",N,N],[17,"SIOCSIFSLAVE","","",N,N],[17,"SIOCADDMULTI","","",N,N],[17,"SIOCDELMULTI","","",N,N],[17,"SIOCDARP","","",N,N],[17,"SIOCGARP","","",N,N],[17,"SIOCSARP","","",N,N],[17,"SIOCDRARP","","",N,N],[17,"SIOCGRARP","","",N,N],[17,"SIOCSRARP","","",N,N],[17,"SIOCGIFMAP","","",N,N],[17,"SIOCSIFMAP","","",N,N],[17,"IPTOS_TOS_MASK","","",N,N],[17,"IPTOS_PREC_MASK","","",N,N],[17,"RTF_UP","","",N,N],[17,"RTF_GATEWAY","","",N,N],[17,"RTF_HOST","","",N,N],[17,"RTF_REINSTATE","","",N,N],[17,"RTF_DYNAMIC","","",N,N],[17,"RTF_MODIFIED","","",N,N],[17,"RTF_MTU","","",N,N],[17,"RTF_MSS","","",N,N],[17,"RTF_WINDOW","","",N,N],[17,"RTF_IRTT","","",N,N],[17,"RTF_REJECT","","",N,N],[17,"RTF_STATIC","","",N,N],[17,"RTF_XRESOLVE","","",N,N],[17,"RTF_NOFORWARD","","",N,N],[17,"RTF_THROW","","",N,N],[17,"RTF_NOPMTUDISC","","",N,N],[17,"RTF_DEFAULT","","",N,N],[17,"RTF_ALLONLINK","","",N,N],[17,"RTF_ADDRCONF","","",N,N],[17,"RTF_LINKRT","","",N,N],[17,"RTF_NONEXTHOP","","",N,N],[17,"RTF_CACHE","","",N,N],[17,"RTF_FLOW","","",N,N],[17,"RTF_POLICY","","",N,N],[17,"RTCF_VALVE","","",N,N],[17,"RTCF_MASQ","","",N,N],[17,"RTCF_NAT","","",N,N],[17,"RTCF_DOREDIRECT","","",N,N],[17,"RTCF_LOG","","",N,N],[17,"RTCF_DIRECTSRC","","",N,N],[17,"RTF_LOCAL","","",N,N],[17,"RTF_INTERFACE","","",N,N],[17,"RTF_MULTICAST","","",N,N],[17,"RTF_BROADCAST","","",N,N],[17,"RTF_NAT","","",N,N],[17,"RTF_ADDRCLASSMASK","","",N,N],[17,"RT_CLASS_UNSPEC","","",N,N],[17,"RT_CLASS_DEFAULT","","",N,N],[17,"RT_CLASS_MAIN","","",N,N],[17,"RT_CLASS_LOCAL","","",N,N],[17,"RT_CLASS_MAX","","",N,N],[17,"RTMSG_OVERRUN","","",N,N],[17,"RTMSG_NEWDEVICE","","",N,N],[17,"RTMSG_DELDEVICE","","",N,N],[17,"RTMSG_NEWROUTE","","",N,N],[17,"RTMSG_DELROUTE","","",N,N],[17,"RTMSG_NEWRULE","","",N,N],[17,"RTMSG_DELRULE","","",N,N],[17,"RTMSG_CONTROL","","",N,N],[17,"RTMSG_AR_FAILED","","",N,N],[17,"MAX_ADDR_LEN","","",N,N],[17,"ARPD_UPDATE","","",N,N],[17,"ARPD_LOOKUP","","",N,N],[17,"ARPD_FLUSH","","",N,N],[17,"ATF_MAGIC","","",N,N],[17,"MODULE_INIT_IGNORE_MODVERSIONS","","",N,N],[17,"MODULE_INIT_IGNORE_VERMAGIC","","",N,N],[17,"__UT_LINESIZE","","",N,N],[17,"__UT_NAMESIZE","","",N,N],[17,"__UT_HOSTSIZE","","",N,N],[17,"EMPTY","","",N,N],[17,"RUN_LVL","","",N,N],[17,"BOOT_TIME","","",N,N],[17,"NEW_TIME","","",N,N],[17,"OLD_TIME","","",N,N],[17,"INIT_PROCESS","","",N,N],[17,"LOGIN_PROCESS","","",N,N],[17,"USER_PROCESS","","",N,N],[17,"DEAD_PROCESS","","",N,N],[17,"ACCOUNTING","","",N,N],[17,"RLIMIT_RSS","","",N,N],[17,"RLIMIT_AS","","",N,N],[17,"RLIMIT_MEMLOCK","","",N,N],[17,"RLIM_INFINITY","","",N,N],[17,"RLIMIT_RTTIME","","",N,N],[17,"RLIMIT_NLIMITS","","",N,N],[17,"SOCK_NONBLOCK","","",N,N],[17,"SOL_RXRPC","","",N,N],[17,"SOL_PPPOL2TP","","",N,N],[17,"SOL_BLUETOOTH","","",N,N],[17,"SOL_PNPIPE","","",N,N],[17,"SOL_RDS","","",N,N],[17,"SOL_IUCV","","",N,N],[17,"SOL_CAIF","","",N,N],[17,"SOL_ALG","","",N,N],[17,"SOL_NFC","","",N,N],[17,"MSG_TRYHARD","","",N,N],[17,"LC_PAPER","","",N,N],[17,"LC_NAME","","",N,N],[17,"LC_ADDRESS","","",N,N],[17,"LC_TELEPHONE","","",N,N],[17,"LC_MEASUREMENT","","",N,N],[17,"LC_IDENTIFICATION","","",N,N],[17,"LC_PAPER_MASK","","",N,N],[17,"LC_NAME_MASK","","",N,N],[17,"LC_ADDRESS_MASK","","",N,N],[17,"LC_TELEPHONE_MASK","","",N,N],[17,"LC_MEASUREMENT_MASK","","",N,N],[17,"LC_IDENTIFICATION_MASK","","",N,N],[17,"LC_ALL_MASK","","",N,N],[17,"MAP_ANON","","",N,N],[17,"MAP_ANONYMOUS","","",N,N],[17,"MAP_DENYWRITE","","",N,N],[17,"MAP_EXECUTABLE","","",N,N],[17,"MAP_POPULATE","","",N,N],[17,"MAP_NONBLOCK","","",N,N],[17,"MAP_STACK","","",N,N],[17,"ENOTSUP","","",N,N],[17,"EUCLEAN","","",N,N],[17,"ENOTNAM","","",N,N],[17,"ENAVAIL","","",N,N],[17,"EISNAM","","",N,N],[17,"EREMOTEIO","","",N,N],[17,"SOCK_STREAM","","",N,N],[17,"SOCK_DGRAM","","",N,N],[17,"SOCK_SEQPACKET","","",N,N],[17,"SOCK_DCCP","","",N,N],[17,"SOCK_PACKET","","",N,N],[17,"TCP_COOKIE_TRANSACTIONS","","",N,N],[17,"TCP_THIN_LINEAR_TIMEOUTS","","",N,N],[17,"TCP_THIN_DUPACK","","",N,N],[17,"TCP_USER_TIMEOUT","","",N,N],[17,"TCP_REPAIR","","",N,N],[17,"TCP_REPAIR_QUEUE","","",N,N],[17,"TCP_QUEUE_SEQ","","",N,N],[17,"TCP_REPAIR_OPTIONS","","",N,N],[17,"TCP_FASTOPEN","","",N,N],[17,"TCP_TIMESTAMP","","",N,N],[17,"DCCP_SOCKOPT_PACKET_SIZE","","",N,N],[17,"DCCP_SOCKOPT_SERVICE","","",N,N],[17,"DCCP_SOCKOPT_CHANGE_L","","",N,N],[17,"DCCP_SOCKOPT_CHANGE_R","","",N,N],[17,"DCCP_SOCKOPT_GET_CUR_MPS","","",N,N],[17,"DCCP_SOCKOPT_SERVER_TIMEWAIT","","",N,N],[17,"DCCP_SOCKOPT_SEND_CSCOV","","",N,N],[17,"DCCP_SOCKOPT_RECV_CSCOV","","",N,N],[17,"DCCP_SOCKOPT_AVAILABLE_CCIDS","","",N,N],[17,"DCCP_SOCKOPT_CCID","","",N,N],[17,"DCCP_SOCKOPT_TX_CCID","","",N,N],[17,"DCCP_SOCKOPT_RX_CCID","","",N,N],[17,"DCCP_SOCKOPT_QPOLICY_ID","","",N,N],[17,"DCCP_SOCKOPT_QPOLICY_TXQLEN","","",N,N],[17,"DCCP_SOCKOPT_CCID_RX_INFO","","",N,N],[17,"DCCP_SOCKOPT_CCID_TX_INFO","","",N,N],[17,"DCCP_SERVICE_LIST_MAX_LEN","","maximum number of services provided on the same listening port",N,N],[17,"SIGTTIN","","",N,N],[17,"SIGTTOU","","",N,N],[17,"SIGXCPU","","",N,N],[17,"SIGXFSZ","","",N,N],[17,"SIGVTALRM","","",N,N],[17,"SIGPROF","","",N,N],[17,"SIGWINCH","","",N,N],[17,"SIGEV_THREAD_ID","","",N,N],[17,"BUFSIZ","","",N,N],[17,"TMP_MAX","","",N,N],[17,"FOPEN_MAX","","",N,N],[17,"POSIX_FADV_DONTNEED","","",N,N],[17,"POSIX_FADV_NOREUSE","","",N,N],[17,"POSIX_MADV_DONTNEED","","",N,N],[17,"_SC_EQUIV_CLASS_MAX","","",N,N],[17,"_SC_CHARCLASS_NAME_MAX","","",N,N],[17,"_SC_PII","","",N,N],[17,"_SC_PII_XTI","","",N,N],[17,"_SC_PII_SOCKET","","",N,N],[17,"_SC_PII_INTERNET","","",N,N],[17,"_SC_PII_OSI","","",N,N],[17,"_SC_POLL","","",N,N],[17,"_SC_SELECT","","",N,N],[17,"_SC_PII_INTERNET_STREAM","","",N,N],[17,"_SC_PII_INTERNET_DGRAM","","",N,N],[17,"_SC_PII_OSI_COTS","","",N,N],[17,"_SC_PII_OSI_CLTS","","",N,N],[17,"_SC_PII_OSI_M","","",N,N],[17,"_SC_T_IOV_MAX","","",N,N],[17,"_SC_2_C_VERSION","","",N,N],[17,"_SC_CHAR_BIT","","",N,N],[17,"_SC_CHAR_MAX","","",N,N],[17,"_SC_CHAR_MIN","","",N,N],[17,"_SC_INT_MAX","","",N,N],[17,"_SC_INT_MIN","","",N,N],[17,"_SC_LONG_BIT","","",N,N],[17,"_SC_WORD_BIT","","",N,N],[17,"_SC_MB_LEN_MAX","","",N,N],[17,"_SC_SSIZE_MAX","","",N,N],[17,"_SC_SCHAR_MAX","","",N,N],[17,"_SC_SCHAR_MIN","","",N,N],[17,"_SC_SHRT_MAX","","",N,N],[17,"_SC_SHRT_MIN","","",N,N],[17,"_SC_UCHAR_MAX","","",N,N],[17,"_SC_UINT_MAX","","",N,N],[17,"_SC_ULONG_MAX","","",N,N],[17,"_SC_USHRT_MAX","","",N,N],[17,"_SC_NL_ARGMAX","","",N,N],[17,"_SC_NL_LANGMAX","","",N,N],[17,"_SC_NL_MSGMAX","","",N,N],[17,"_SC_NL_NMAX","","",N,N],[17,"_SC_NL_SETMAX","","",N,N],[17,"_SC_NL_TEXTMAX","","",N,N],[17,"_SC_BASE","","",N,N],[17,"_SC_C_LANG_SUPPORT","","",N,N],[17,"_SC_C_LANG_SUPPORT_R","","",N,N],[17,"_SC_DEVICE_IO","","",N,N],[17,"_SC_DEVICE_SPECIFIC","","",N,N],[17,"_SC_DEVICE_SPECIFIC_R","","",N,N],[17,"_SC_FD_MGMT","","",N,N],[17,"_SC_FIFO","","",N,N],[17,"_SC_PIPE","","",N,N],[17,"_SC_FILE_ATTRIBUTES","","",N,N],[17,"_SC_FILE_LOCKING","","",N,N],[17,"_SC_FILE_SYSTEM","","",N,N],[17,"_SC_MULTI_PROCESS","","",N,N],[17,"_SC_SINGLE_PROCESS","","",N,N],[17,"_SC_NETWORKING","","",N,N],[17,"_SC_REGEX_VERSION","","",N,N],[17,"_SC_SIGNALS","","",N,N],[17,"_SC_SYSTEM_DATABASE","","",N,N],[17,"_SC_SYSTEM_DATABASE_R","","",N,N],[17,"_SC_USER_GROUPS","","",N,N],[17,"_SC_USER_GROUPS_R","","",N,N],[17,"_SC_LEVEL1_ICACHE_SIZE","","",N,N],[17,"_SC_LEVEL1_ICACHE_ASSOC","","",N,N],[17,"_SC_LEVEL1_ICACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL1_DCACHE_SIZE","","",N,N],[17,"_SC_LEVEL1_DCACHE_ASSOC","","",N,N],[17,"_SC_LEVEL1_DCACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL2_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL2_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL2_CACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL3_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL3_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL3_CACHE_LINESIZE","","",N,N],[17,"_SC_LEVEL4_CACHE_SIZE","","",N,N],[17,"_SC_LEVEL4_CACHE_ASSOC","","",N,N],[17,"_SC_LEVEL4_CACHE_LINESIZE","","",N,N],[17,"O_ACCMODE","","",N,N],[17,"ST_RELATIME","","",N,N],[17,"NI_MAXHOST","","",N,N],[17,"ADFS_SUPER_MAGIC","","",N,N],[17,"AFFS_SUPER_MAGIC","","",N,N],[17,"CODA_SUPER_MAGIC","","",N,N],[17,"CRAMFS_MAGIC","","",N,N],[17,"EFS_SUPER_MAGIC","","",N,N],[17,"EXT2_SUPER_MAGIC","","",N,N],[17,"EXT3_SUPER_MAGIC","","",N,N],[17,"EXT4_SUPER_MAGIC","","",N,N],[17,"HPFS_SUPER_MAGIC","","",N,N],[17,"HUGETLBFS_MAGIC","","",N,N],[17,"ISOFS_SUPER_MAGIC","","",N,N],[17,"JFFS2_SUPER_MAGIC","","",N,N],[17,"MINIX_SUPER_MAGIC","","",N,N],[17,"MINIX_SUPER_MAGIC2","","",N,N],[17,"MINIX2_SUPER_MAGIC","","",N,N],[17,"MINIX2_SUPER_MAGIC2","","",N,N],[17,"MSDOS_SUPER_MAGIC","","",N,N],[17,"NCP_SUPER_MAGIC","","",N,N],[17,"NFS_SUPER_MAGIC","","",N,N],[17,"OPENPROM_SUPER_MAGIC","","",N,N],[17,"PROC_SUPER_MAGIC","","",N,N],[17,"QNX4_SUPER_MAGIC","","",N,N],[17,"REISERFS_SUPER_MAGIC","","",N,N],[17,"SMB_SUPER_MAGIC","","",N,N],[17,"TMPFS_MAGIC","","",N,N],[17,"USBDEVICE_SUPER_MAGIC","","",N,N],[17,"VEOF","","",N,N],[17,"CPU_SETSIZE","","",N,N],[17,"PTRACE_TRACEME","","",N,N],[17,"PTRACE_PEEKTEXT","","",N,N],[17,"PTRACE_PEEKDATA","","",N,N],[17,"PTRACE_PEEKUSER","","",N,N],[17,"PTRACE_POKETEXT","","",N,N],[17,"PTRACE_POKEDATA","","",N,N],[17,"PTRACE_POKEUSER","","",N,N],[17,"PTRACE_CONT","","",N,N],[17,"PTRACE_KILL","","",N,N],[17,"PTRACE_SINGLESTEP","","",N,N],[17,"PTRACE_ATTACH","","",N,N],[17,"PTRACE_SYSCALL","","",N,N],[17,"PTRACE_SETOPTIONS","","",N,N],[17,"PTRACE_GETEVENTMSG","","",N,N],[17,"PTRACE_GETSIGINFO","","",N,N],[17,"PTRACE_SETSIGINFO","","",N,N],[17,"PTRACE_GETREGSET","","",N,N],[17,"PTRACE_SETREGSET","","",N,N],[17,"PTRACE_SEIZE","","",N,N],[17,"PTRACE_INTERRUPT","","",N,N],[17,"PTRACE_LISTEN","","",N,N],[17,"PTRACE_PEEKSIGINFO","","",N,N],[17,"EPOLLWAKEUP","","",N,N],[17,"MAP_HUGETLB","","",N,N],[17,"SEEK_DATA","","",N,N],[17,"SEEK_HOLE","","",N,N],[17,"TCSANOW","","",N,N],[17,"TCSADRAIN","","",N,N],[17,"TCSAFLUSH","","",N,N],[17,"TIOCLINUX","","",N,N],[17,"TIOCGSERIAL","","",N,N],[17,"RTLD_DEEPBIND","","",N,N],[17,"RTLD_GLOBAL","","",N,N],[17,"RTLD_NOLOAD","","",N,N],[17,"LINUX_REBOOT_MAGIC1","","",N,N],[17,"LINUX_REBOOT_MAGIC2","","",N,N],[17,"LINUX_REBOOT_MAGIC2A","","",N,N],[17,"LINUX_REBOOT_MAGIC2B","","",N,N],[17,"LINUX_REBOOT_MAGIC2C","","",N,N],[17,"LINUX_REBOOT_CMD_RESTART","","",N,N],[17,"LINUX_REBOOT_CMD_HALT","","",N,N],[17,"LINUX_REBOOT_CMD_CAD_ON","","",N,N],[17,"LINUX_REBOOT_CMD_CAD_OFF","","",N,N],[17,"LINUX_REBOOT_CMD_POWER_OFF","","",N,N],[17,"LINUX_REBOOT_CMD_RESTART2","","",N,N],[17,"LINUX_REBOOT_CMD_SW_SUSPEND","","",N,N],[17,"LINUX_REBOOT_CMD_KEXEC","","",N,N],[17,"NETLINK_ROUTE","","",N,N],[17,"NETLINK_UNUSED","","",N,N],[17,"NETLINK_USERSOCK","","",N,N],[17,"NETLINK_FIREWALL","","",N,N],[17,"NETLINK_SOCK_DIAG","","",N,N],[17,"NETLINK_NFLOG","","",N,N],[17,"NETLINK_XFRM","","",N,N],[17,"NETLINK_SELINUX","","",N,N],[17,"NETLINK_ISCSI","","",N,N],[17,"NETLINK_AUDIT","","",N,N],[17,"NETLINK_FIB_LOOKUP","","",N,N],[17,"NETLINK_CONNECTOR","","",N,N],[17,"NETLINK_NETFILTER","","",N,N],[17,"NETLINK_IP6_FW","","",N,N],[17,"NETLINK_DNRTMSG","","",N,N],[17,"NETLINK_KOBJECT_UEVENT","","",N,N],[17,"NETLINK_GENERIC","","",N,N],[17,"NETLINK_SCSITRANSPORT","","",N,N],[17,"NETLINK_ECRYPTFS","","",N,N],[17,"NETLINK_RDMA","","",N,N],[17,"NETLINK_CRYPTO","","",N,N],[17,"NETLINK_INET_DIAG","","",N,N],[17,"MAX_LINKS","","",N,N],[17,"NLM_F_REQUEST","","",N,N],[17,"NLM_F_MULTI","","",N,N],[17,"NLM_F_ACK","","",N,N],[17,"NLM_F_ECHO","","",N,N],[17,"NLM_F_DUMP_INTR","","",N,N],[17,"NLM_F_DUMP_FILTERED","","",N,N],[17,"NLM_F_ROOT","","",N,N],[17,"NLM_F_MATCH","","",N,N],[17,"NLM_F_ATOMIC","","",N,N],[17,"NLM_F_DUMP","","",N,N],[17,"NLM_F_REPLACE","","",N,N],[17,"NLM_F_EXCL","","",N,N],[17,"NLM_F_CREATE","","",N,N],[17,"NLM_F_APPEND","","",N,N],[17,"NETLINK_ADD_MEMBERSHIP","","",N,N],[17,"NETLINK_DROP_MEMBERSHIP","","",N,N],[17,"NETLINK_PKTINFO","","",N,N],[17,"NETLINK_BROADCAST_ERROR","","",N,N],[17,"NETLINK_NO_ENOBUFS","","",N,N],[17,"NETLINK_RX_RING","","",N,N],[17,"NETLINK_TX_RING","","",N,N],[17,"NETLINK_LISTEN_ALL_NSID","","",N,N],[17,"NETLINK_LIST_MEMBERSHIPS","","",N,N],[17,"NETLINK_CAP_ACK","","",N,N],[17,"NLA_F_NESTED","","",N,N],[17,"NLA_F_NET_BYTEORDER","","",N,N],[17,"NLA_TYPE_MASK","","",N,N],[17,"NLA_ALIGNTO","","",N,N],[17,"GENL_UNS_ADMIN_PERM","","",N,N],[17,"GENL_ID_VFS_DQUOT","","",N,N],[17,"GENL_ID_PMCRAID","","",N,N],[17,"TIOCM_LE","","",N,N],[17,"TIOCM_DTR","","",N,N],[17,"TIOCM_RTS","","",N,N],[17,"TIOCM_ST","","",N,N],[17,"TIOCM_SR","","",N,N],[17,"TIOCM_CTS","","",N,N],[17,"TIOCM_CAR","","",N,N],[17,"TIOCM_RNG","","",N,N],[17,"TIOCM_DSR","","",N,N],[17,"TIOCM_CD","","",N,N],[17,"TIOCM_RI","","",N,N],[17,"NF_NETDEV_INGRESS","","",N,N],[17,"NF_NETDEV_NUMHOOKS","","",N,N],[17,"NFPROTO_INET","","",N,N],[17,"NFPROTO_NETDEV","","",N,N],[17,"NFT_TABLE_MAXNAMELEN","","",N,N],[17,"NFT_CHAIN_MAXNAMELEN","","",N,N],[17,"NFT_SET_MAXNAMELEN","","",N,N],[17,"NFT_OBJ_MAXNAMELEN","","",N,N],[17,"NFT_USERDATA_MAXLEN","","",N,N],[17,"NFT_REG_VERDICT","","",N,N],[17,"NFT_REG_1","","",N,N],[17,"NFT_REG_2","","",N,N],[17,"NFT_REG_3","","",N,N],[17,"NFT_REG_4","","",N,N],[17,"__NFT_REG_MAX","","",N,N],[17,"NFT_REG32_00","","",N,N],[17,"NFT_REG32_01","","",N,N],[17,"NFT_REG32_02","","",N,N],[17,"NFT_REG32_03","","",N,N],[17,"NFT_REG32_04","","",N,N],[17,"NFT_REG32_05","","",N,N],[17,"NFT_REG32_06","","",N,N],[17,"NFT_REG32_07","","",N,N],[17,"NFT_REG32_08","","",N,N],[17,"NFT_REG32_09","","",N,N],[17,"NFT_REG32_10","","",N,N],[17,"NFT_REG32_11","","",N,N],[17,"NFT_REG32_12","","",N,N],[17,"NFT_REG32_13","","",N,N],[17,"NFT_REG32_14","","",N,N],[17,"NFT_REG32_15","","",N,N],[17,"NFT_REG_SIZE","","",N,N],[17,"NFT_REG32_SIZE","","",N,N],[17,"NFT_CONTINUE","","",N,N],[17,"NFT_BREAK","","",N,N],[17,"NFT_JUMP","","",N,N],[17,"NFT_GOTO","","",N,N],[17,"NFT_RETURN","","",N,N],[17,"NFT_MSG_NEWTABLE","","",N,N],[17,"NFT_MSG_GETTABLE","","",N,N],[17,"NFT_MSG_DELTABLE","","",N,N],[17,"NFT_MSG_NEWCHAIN","","",N,N],[17,"NFT_MSG_GETCHAIN","","",N,N],[17,"NFT_MSG_DELCHAIN","","",N,N],[17,"NFT_MSG_NEWRULE","","",N,N],[17,"NFT_MSG_GETRULE","","",N,N],[17,"NFT_MSG_DELRULE","","",N,N],[17,"NFT_MSG_NEWSET","","",N,N],[17,"NFT_MSG_GETSET","","",N,N],[17,"NFT_MSG_DELSET","","",N,N],[17,"NFT_MSG_NEWSETELEM","","",N,N],[17,"NFT_MSG_GETSETELEM","","",N,N],[17,"NFT_MSG_DELSETELEM","","",N,N],[17,"NFT_MSG_NEWGEN","","",N,N],[17,"NFT_MSG_GETGEN","","",N,N],[17,"NFT_MSG_TRACE","","",N,N],[17,"NFT_MSG_NEWOBJ","","",N,N],[17,"NFT_MSG_GETOBJ","","",N,N],[17,"NFT_MSG_DELOBJ","","",N,N],[17,"NFT_MSG_GETOBJ_RESET","","",N,N],[17,"NFT_MSG_MAX","","",N,N],[17,"NFT_SET_ANONYMOUS","","",N,N],[17,"NFT_SET_CONSTANT","","",N,N],[17,"NFT_SET_INTERVAL","","",N,N],[17,"NFT_SET_MAP","","",N,N],[17,"NFT_SET_TIMEOUT","","",N,N],[17,"NFT_SET_EVAL","","",N,N],[17,"NFT_SET_POL_PERFORMANCE","","",N,N],[17,"NFT_SET_POL_MEMORY","","",N,N],[17,"NFT_SET_ELEM_INTERVAL_END","","",N,N],[17,"NFT_DATA_VALUE","","",N,N],[17,"NFT_DATA_VERDICT","","",N,N],[17,"NFT_DATA_RESERVED_MASK","","",N,N],[17,"NFT_DATA_VALUE_MAXLEN","","",N,N],[17,"NFT_BYTEORDER_NTOH","","",N,N],[17,"NFT_BYTEORDER_HTON","","",N,N],[17,"NFT_CMP_EQ","","",N,N],[17,"NFT_CMP_NEQ","","",N,N],[17,"NFT_CMP_LT","","",N,N],[17,"NFT_CMP_LTE","","",N,N],[17,"NFT_CMP_GT","","",N,N],[17,"NFT_CMP_GTE","","",N,N],[17,"NFT_RANGE_EQ","","",N,N],[17,"NFT_RANGE_NEQ","","",N,N],[17,"NFT_LOOKUP_F_INV","","",N,N],[17,"NFT_DYNSET_OP_ADD","","",N,N],[17,"NFT_DYNSET_OP_UPDATE","","",N,N],[17,"NFT_DYNSET_F_INV","","",N,N],[17,"NFT_PAYLOAD_LL_HEADER","","",N,N],[17,"NFT_PAYLOAD_NETWORK_HEADER","","",N,N],[17,"NFT_PAYLOAD_TRANSPORT_HEADER","","",N,N],[17,"NFT_PAYLOAD_CSUM_NONE","","",N,N],[17,"NFT_PAYLOAD_CSUM_INET","","",N,N],[17,"NFT_META_LEN","","",N,N],[17,"NFT_META_PROTOCOL","","",N,N],[17,"NFT_META_PRIORITY","","",N,N],[17,"NFT_META_MARK","","",N,N],[17,"NFT_META_IIF","","",N,N],[17,"NFT_META_OIF","","",N,N],[17,"NFT_META_IIFNAME","","",N,N],[17,"NFT_META_OIFNAME","","",N,N],[17,"NFT_META_IIFTYPE","","",N,N],[17,"NFT_META_OIFTYPE","","",N,N],[17,"NFT_META_SKUID","","",N,N],[17,"NFT_META_SKGID","","",N,N],[17,"NFT_META_NFTRACE","","",N,N],[17,"NFT_META_RTCLASSID","","",N,N],[17,"NFT_META_SECMARK","","",N,N],[17,"NFT_META_NFPROTO","","",N,N],[17,"NFT_META_L4PROTO","","",N,N],[17,"NFT_META_BRI_IIFNAME","","",N,N],[17,"NFT_META_BRI_OIFNAME","","",N,N],[17,"NFT_META_PKTTYPE","","",N,N],[17,"NFT_META_CPU","","",N,N],[17,"NFT_META_IIFGROUP","","",N,N],[17,"NFT_META_OIFGROUP","","",N,N],[17,"NFT_META_CGROUP","","",N,N],[17,"NFT_META_PRANDOM","","",N,N],[17,"NFT_CT_STATE","","",N,N],[17,"NFT_CT_DIRECTION","","",N,N],[17,"NFT_CT_STATUS","","",N,N],[17,"NFT_CT_MARK","","",N,N],[17,"NFT_CT_SECMARK","","",N,N],[17,"NFT_CT_EXPIRATION","","",N,N],[17,"NFT_CT_HELPER","","",N,N],[17,"NFT_CT_L3PROTOCOL","","",N,N],[17,"NFT_CT_SRC","","",N,N],[17,"NFT_CT_DST","","",N,N],[17,"NFT_CT_PROTOCOL","","",N,N],[17,"NFT_CT_PROTO_SRC","","",N,N],[17,"NFT_CT_PROTO_DST","","",N,N],[17,"NFT_CT_LABELS","","",N,N],[17,"NFT_CT_PKTS","","",N,N],[17,"NFT_CT_BYTES","","",N,N],[17,"NFT_LIMIT_PKTS","","",N,N],[17,"NFT_LIMIT_PKT_BYTES","","",N,N],[17,"NFT_LIMIT_F_INV","","",N,N],[17,"NFT_QUEUE_FLAG_BYPASS","","",N,N],[17,"NFT_QUEUE_FLAG_CPU_FANOUT","","",N,N],[17,"NFT_QUEUE_FLAG_MASK","","",N,N],[17,"NFT_QUOTA_F_INV","","",N,N],[17,"NFT_REJECT_ICMP_UNREACH","","",N,N],[17,"NFT_REJECT_TCP_RST","","",N,N],[17,"NFT_REJECT_ICMPX_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_NO_ROUTE","","",N,N],[17,"NFT_REJECT_ICMPX_PORT_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_HOST_UNREACH","","",N,N],[17,"NFT_REJECT_ICMPX_ADMIN_PROHIBITED","","",N,N],[17,"NFT_NAT_SNAT","","",N,N],[17,"NFT_NAT_DNAT","","",N,N],[17,"NFT_TRACETYPE_UNSPEC","","",N,N],[17,"NFT_TRACETYPE_POLICY","","",N,N],[17,"NFT_TRACETYPE_RETURN","","",N,N],[17,"NFT_TRACETYPE_RULE","","",N,N],[17,"NFT_NG_INCREMENTAL","","",N,N],[17,"NFT_NG_RANDOM","","",N,N],[17,"AF_MAX","","",N,N],[17,"PF_MAX","","",N,N],[17,"PTHREAD_STACK_MIN","","",N,N],[17,"PTHREAD_MUTEX_ADAPTIVE_NP","","",N,N],[17,"__SIZEOF_PTHREAD_RWLOCKATTR_T","","",N,N],[17,"O_LARGEFILE","","",N,N],[17,"TIOCGSOFTCAR","","",N,N],[17,"TIOCSSOFTCAR","","",N,N],[17,"RLIMIT_NOFILE","","",N,N],[17,"RLIMIT_NPROC","","",N,N],[17,"O_APPEND","","",N,N],[17,"O_CREAT","","",N,N],[17,"O_EXCL","","",N,N],[17,"O_NOCTTY","","",N,N],[17,"O_NONBLOCK","","",N,N],[17,"O_SYNC","","",N,N],[17,"O_RSYNC","","",N,N],[17,"O_DSYNC","","",N,N],[17,"O_FSYNC","","",N,N],[17,"O_NOATIME","","",N,N],[17,"O_PATH","","",N,N],[17,"O_TMPFILE","","",N,N],[17,"MAP_GROWSDOWN","","",N,N],[17,"EDEADLK","","",N,N],[17,"ENAMETOOLONG","","",N,N],[17,"ENOLCK","","",N,N],[17,"ENOSYS","","",N,N],[17,"ENOTEMPTY","","",N,N],[17,"ELOOP","","",N,N],[17,"ENOMSG","","",N,N],[17,"EIDRM","","",N,N],[17,"ECHRNG","","",N,N],[17,"EL2NSYNC","","",N,N],[17,"EL3HLT","","",N,N],[17,"EL3RST","","",N,N],[17,"ELNRNG","","",N,N],[17,"EUNATCH","","",N,N],[17,"ENOCSI","","",N,N],[17,"EL2HLT","","",N,N],[17,"EBADE","","",N,N],[17,"EBADR","","",N,N],[17,"EXFULL","","",N,N],[17,"ENOANO","","",N,N],[17,"EBADRQC","","",N,N],[17,"EBADSLT","","",N,N],[17,"EMULTIHOP","","",N,N],[17,"EOVERFLOW","","",N,N],[17,"ENOTUNIQ","","",N,N],[17,"EBADFD","","",N,N],[17,"EBADMSG","","",N,N],[17,"EREMCHG","","",N,N],[17,"ELIBACC","","",N,N],[17,"ELIBBAD","","",N,N],[17,"ELIBSCN","","",N,N],[17,"ELIBMAX","","",N,N],[17,"ELIBEXEC","","",N,N],[17,"EILSEQ","","",N,N],[17,"ERESTART","","",N,N],[17,"ESTRPIPE","","",N,N],[17,"EUSERS","","",N,N],[17,"ENOTSOCK","","",N,N],[17,"EDESTADDRREQ","","",N,N],[17,"EMSGSIZE","","",N,N],[17,"EPROTOTYPE","","",N,N],[17,"ENOPROTOOPT","","",N,N],[17,"EPROTONOSUPPORT","","",N,N],[17,"ESOCKTNOSUPPORT","","",N,N],[17,"EOPNOTSUPP","","",N,N],[17,"EPFNOSUPPORT","","",N,N],[17,"EAFNOSUPPORT","","",N,N],[17,"EADDRINUSE","","",N,N],[17,"EADDRNOTAVAIL","","",N,N],[17,"ENETDOWN","","",N,N],[17,"ENETUNREACH","","",N,N],[17,"ENETRESET","","",N,N],[17,"ECONNABORTED","","",N,N],[17,"ECONNRESET","","",N,N],[17,"ENOBUFS","","",N,N],[17,"EISCONN","","",N,N],[17,"ENOTCONN","","",N,N],[17,"ESHUTDOWN","","",N,N],[17,"ETOOMANYREFS","","",N,N],[17,"ETIMEDOUT","","",N,N],[17,"ECONNREFUSED","","",N,N],[17,"EHOSTDOWN","","",N,N],[17,"EHOSTUNREACH","","",N,N],[17,"EALREADY","","",N,N],[17,"EINPROGRESS","","",N,N],[17,"ESTALE","","",N,N],[17,"EDQUOT","","",N,N],[17,"ENOMEDIUM","","",N,N],[17,"EMEDIUMTYPE","","",N,N],[17,"ECANCELED","","",N,N],[17,"ENOKEY","","",N,N],[17,"EKEYEXPIRED","","",N,N],[17,"EKEYREVOKED","","",N,N],[17,"EKEYREJECTED","","",N,N],[17,"EOWNERDEAD","","",N,N],[17,"ENOTRECOVERABLE","","",N,N],[17,"EHWPOISON","","",N,N],[17,"ERFKILL","","",N,N],[17,"SOL_SOCKET","","",N,N],[17,"SO_REUSEADDR","","",N,N],[17,"SO_TYPE","","",N,N],[17,"SO_ERROR","","",N,N],[17,"SO_DONTROUTE","","",N,N],[17,"SO_BROADCAST","","",N,N],[17,"SO_SNDBUF","","",N,N],[17,"SO_RCVBUF","","",N,N],[17,"SO_SNDBUFFORCE","","",N,N],[17,"SO_RCVBUFFORCE","","",N,N],[17,"SO_KEEPALIVE","","",N,N],[17,"SO_OOBINLINE","","",N,N],[17,"SO_NO_CHECK","","",N,N],[17,"SO_PRIORITY","","",N,N],[17,"SO_LINGER","","",N,N],[17,"SO_BSDCOMPAT","","",N,N],[17,"SO_REUSEPORT","","",N,N],[17,"SO_PASSCRED","","",N,N],[17,"SO_PEERCRED","","",N,N],[17,"SO_RCVLOWAT","","",N,N],[17,"SO_SNDLOWAT","","",N,N],[17,"SO_RCVTIMEO","","",N,N],[17,"SO_SNDTIMEO","","",N,N],[17,"SO_SECURITY_AUTHENTICATION","","",N,N],[17,"SO_SECURITY_ENCRYPTION_TRANSPORT","","",N,N],[17,"SO_SECURITY_ENCRYPTION_NETWORK","","",N,N],[17,"SO_BINDTODEVICE","","",N,N],[17,"SO_ATTACH_FILTER","","",N,N],[17,"SO_DETACH_FILTER","","",N,N],[17,"SO_GET_FILTER","","",N,N],[17,"SO_PEERNAME","","",N,N],[17,"SO_TIMESTAMP","","",N,N],[17,"SO_ACCEPTCONN","","",N,N],[17,"SO_PEERSEC","","",N,N],[17,"SO_PASSSEC","","",N,N],[17,"SO_TIMESTAMPNS","","",N,N],[17,"SCM_TIMESTAMPNS","","",N,N],[17,"SO_MARK","","",N,N],[17,"SO_TIMESTAMPING","","",N,N],[17,"SCM_TIMESTAMPING","","",N,N],[17,"SO_PROTOCOL","","",N,N],[17,"SO_DOMAIN","","",N,N],[17,"SO_RXQ_OVFL","","",N,N],[17,"SO_WIFI_STATUS","","",N,N],[17,"SCM_WIFI_STATUS","","",N,N],[17,"SO_PEEK_OFF","","",N,N],[17,"SO_NOFCS","","",N,N],[17,"SO_LOCK_FILTER","","",N,N],[17,"SO_SELECT_ERR_QUEUE","","",N,N],[17,"SO_BUSY_POLL","","",N,N],[17,"SO_MAX_PACING_RATE","","",N,N],[17,"SO_BPF_EXTENSIONS","","",N,N],[17,"SO_INCOMING_CPU","","",N,N],[17,"SO_ATTACH_BPF","","",N,N],[17,"SO_DETACH_BPF","","",N,N],[17,"SA_ONSTACK","","",N,N],[17,"SA_SIGINFO","","",N,N],[17,"SA_NOCLDWAIT","","",N,N],[17,"SIGCHLD","","",N,N],[17,"SIGBUS","","",N,N],[17,"SIGUSR1","","",N,N],[17,"SIGUSR2","","",N,N],[17,"SIGCONT","","",N,N],[17,"SIGSTOP","","",N,N],[17,"SIGTSTP","","",N,N],[17,"SIGURG","","",N,N],[17,"SIGIO","","",N,N],[17,"SIGSYS","","",N,N],[17,"SIGSTKFLT","","",N,N],[17,"SIGUNUSED","","",N,N],[17,"SIGPOLL","","",N,N],[17,"SIGPWR","","",N,N],[17,"SIG_SETMASK","","",N,N],[17,"SIG_BLOCK","","",N,N],[17,"SIG_UNBLOCK","","",N,N],[17,"POLLWRNORM","","",N,N],[17,"POLLWRBAND","","",N,N],[17,"O_ASYNC","","",N,N],[17,"O_NDELAY","","",N,N],[17,"PTRACE_DETACH","","",N,N],[17,"EFD_NONBLOCK","","",N,N],[17,"F_GETLK","","",N,N],[17,"F_GETOWN","","",N,N],[17,"F_SETOWN","","",N,N],[17,"F_SETLK","","",N,N],[17,"F_SETLKW","","",N,N],[17,"F_RDLCK","","",N,N],[17,"F_WRLCK","","",N,N],[17,"F_UNLCK","","",N,N],[17,"SFD_NONBLOCK","","",N,N],[17,"TIOCEXCL","","",N,N],[17,"TIOCNXCL","","",N,N],[17,"TIOCSCTTY","","",N,N],[17,"TIOCSTI","","",N,N],[17,"TIOCMGET","","",N,N],[17,"TIOCMBIS","","",N,N],[17,"TIOCMBIC","","",N,N],[17,"TIOCMSET","","",N,N],[17,"TIOCCONS","","",N,N],[17,"SFD_CLOEXEC","","",N,N],[17,"NCCS","","",N,N],[17,"O_TRUNC","","",N,N],[17,"O_CLOEXEC","","",N,N],[17,"EBFONT","","",N,N],[17,"ENOSTR","","",N,N],[17,"ENODATA","","",N,N],[17,"ETIME","","",N,N],[17,"ENOSR","","",N,N],[17,"ENONET","","",N,N],[17,"ENOPKG","","",N,N],[17,"EREMOTE","","",N,N],[17,"ENOLINK","","",N,N],[17,"EADV","","",N,N],[17,"ESRMNT","","",N,N],[17,"ECOMM","","",N,N],[17,"EPROTO","","",N,N],[17,"EDOTDOT","","",N,N],[17,"SA_NODEFER","","",N,N],[17,"SA_RESETHAND","","",N,N],[17,"SA_RESTART","","",N,N],[17,"SA_NOCLDSTOP","","",N,N],[17,"EPOLL_CLOEXEC","","",N,N],[17,"EFD_CLOEXEC","","",N,N],[17,"__SIZEOF_PTHREAD_CONDATTR_T","","",N,N],[17,"__SIZEOF_PTHREAD_MUTEXATTR_T","","",N,N],[17,"O_DIRECT","","",N,N],[17,"O_DIRECTORY","","",N,N],[17,"O_NOFOLLOW","","",N,N],[17,"MAP_LOCKED","","",N,N],[17,"MAP_NORESERVE","","",N,N],[17,"MAP_32BIT","","",N,N],[17,"EDEADLOCK","","",N,N],[17,"FIOCLEX","","",N,N],[17,"FIONBIO","","",N,N],[17,"PTRACE_GETFPREGS","","",N,N],[17,"PTRACE_SETFPREGS","","",N,N],[17,"PTRACE_GETFPXREGS","","",N,N],[17,"PTRACE_SETFPXREGS","","",N,N],[17,"PTRACE_GETREGS","","",N,N],[17,"PTRACE_SETREGS","","",N,N],[17,"PTRACE_PEEKSIGINFO_SHARED","","",N,N],[17,"MCL_CURRENT","","",N,N],[17,"MCL_FUTURE","","",N,N],[17,"SIGSTKSZ","","",N,N],[17,"MINSIGSTKSZ","","",N,N],[17,"CBAUD","","",N,N],[17,"TAB1","","",N,N],[17,"TAB2","","",N,N],[17,"TAB3","","",N,N],[17,"CR1","","",N,N],[17,"CR2","","",N,N],[17,"CR3","","",N,N],[17,"FF1","","",N,N],[17,"BS1","","",N,N],[17,"VT1","","",N,N],[17,"VWERASE","","",N,N],[17,"VREPRINT","","",N,N],[17,"VSUSP","","",N,N],[17,"VSTART","","",N,N],[17,"VSTOP","","",N,N],[17,"VDISCARD","","",N,N],[17,"VTIME","","",N,N],[17,"IXON","","",N,N],[17,"IXOFF","","",N,N],[17,"ONLCR","","",N,N],[17,"CSIZE","","",N,N],[17,"CS6","","",N,N],[17,"CS7","","",N,N],[17,"CS8","","",N,N],[17,"CSTOPB","","",N,N],[17,"CREAD","","",N,N],[17,"PARENB","","",N,N],[17,"PARODD","","",N,N],[17,"HUPCL","","",N,N],[17,"CLOCAL","","",N,N],[17,"ECHOKE","","",N,N],[17,"ECHOE","","",N,N],[17,"ECHOK","","",N,N],[17,"ECHONL","","",N,N],[17,"ECHOPRT","","",N,N],[17,"ECHOCTL","","",N,N],[17,"ISIG","","",N,N],[17,"ICANON","","",N,N],[17,"PENDIN","","",N,N],[17,"NOFLSH","","",N,N],[17,"CIBAUD","","",N,N],[17,"CBAUDEX","","",N,N],[17,"VSWTC","","",N,N],[17,"OLCUC","","",N,N],[17,"NLDLY","","",N,N],[17,"CRDLY","","",N,N],[17,"TABDLY","","",N,N],[17,"BSDLY","","",N,N],[17,"FFDLY","","",N,N],[17,"VTDLY","","",N,N],[17,"XTABS","","",N,N],[17,"B0","","",N,N],[17,"B50","","",N,N],[17,"B75","","",N,N],[17,"B110","","",N,N],[17,"B134","","",N,N],[17,"B150","","",N,N],[17,"B200","","",N,N],[17,"B300","","",N,N],[17,"B600","","",N,N],[17,"B1200","","",N,N],[17,"B1800","","",N,N],[17,"B2400","","",N,N],[17,"B4800","","",N,N],[17,"B9600","","",N,N],[17,"B19200","","",N,N],[17,"B38400","","",N,N],[17,"EXTA","","",N,N],[17,"EXTB","","",N,N],[17,"BOTHER","","",N,N],[17,"B57600","","",N,N],[17,"B115200","","",N,N],[17,"B230400","","",N,N],[17,"B460800","","",N,N],[17,"B500000","","",N,N],[17,"B576000","","",N,N],[17,"B921600","","",N,N],[17,"B1000000","","",N,N],[17,"B1152000","","",N,N],[17,"B1500000","","",N,N],[17,"B2000000","","",N,N],[17,"B2500000","","",N,N],[17,"B3000000","","",N,N],[17,"B3500000","","",N,N],[17,"B4000000","","",N,N],[17,"VEOL","","",N,N],[17,"VEOL2","","",N,N],[17,"VMIN","","",N,N],[17,"IEXTEN","","",N,N],[17,"TOSTOP","","",N,N],[17,"FLUSHO","","",N,N],[17,"EXTPROC","","",N,N],[17,"TCGETS","","",N,N],[17,"TCSETS","","",N,N],[17,"TCSETSW","","",N,N],[17,"TCSETSF","","",N,N],[17,"TCGETA","","",N,N],[17,"TCSETA","","",N,N],[17,"TCSETAW","","",N,N],[17,"TCSETAF","","",N,N],[17,"TCSBRK","","",N,N],[17,"TCXONC","","",N,N],[17,"TCFLSH","","",N,N],[17,"TIOCINQ","","",N,N],[17,"TIOCGPGRP","","",N,N],[17,"TIOCSPGRP","","",N,N],[17,"TIOCOUTQ","","",N,N],[17,"TIOCGWINSZ","","",N,N],[17,"TIOCSWINSZ","","",N,N],[17,"FIONREAD","","",N,N],[17,"R15","","",N,N],[17,"R14","","",N,N],[17,"R13","","",N,N],[17,"R12","","",N,N],[17,"RBP","","",N,N],[17,"RBX","","",N,N],[17,"R11","","",N,N],[17,"R10","","",N,N],[17,"R9","","",N,N],[17,"R8","","",N,N],[17,"RAX","","",N,N],[17,"RCX","","",N,N],[17,"RDX","","",N,N],[17,"RSI","","",N,N],[17,"RDI","","",N,N],[17,"ORIG_RAX","","",N,N],[17,"RIP","","",N,N],[17,"CS","","",N,N],[17,"EFLAGS","","",N,N],[17,"RSP","","",N,N],[17,"SS","","",N,N],[17,"FS_BASE","","",N,N],[17,"GS_BASE","","",N,N],[17,"DS","","",N,N],[17,"ES","","",N,N],[17,"FS","","",N,N],[17,"GS","","",N,N],[17,"__SIZEOF_PTHREAD_MUTEX_T","","",N,N],[17,"__SIZEOF_PTHREAD_RWLOCK_T","","",N,N],[17,"PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP","","",N,N],[17,"PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP","","",N,N],[17,"PTHREAD_ADAPTIVE_MUTEX_INITIALIZER_NP","","",N,N],[17,"SYS_read","","",N,N],[17,"SYS_write","","",N,N],[17,"SYS_open","","",N,N],[17,"SYS_close","","",N,N],[17,"SYS_stat","","",N,N],[17,"SYS_fstat","","",N,N],[17,"SYS_lstat","","",N,N],[17,"SYS_poll","","",N,N],[17,"SYS_lseek","","",N,N],[17,"SYS_mmap","","",N,N],[17,"SYS_mprotect","","",N,N],[17,"SYS_munmap","","",N,N],[17,"SYS_brk","","",N,N],[17,"SYS_rt_sigaction","","",N,N],[17,"SYS_rt_sigprocmask","","",N,N],[17,"SYS_rt_sigreturn","","",N,N],[17,"SYS_ioctl","","",N,N],[17,"SYS_pread64","","",N,N],[17,"SYS_pwrite64","","",N,N],[17,"SYS_readv","","",N,N],[17,"SYS_writev","","",N,N],[17,"SYS_access","","",N,N],[17,"SYS_pipe","","",N,N],[17,"SYS_select","","",N,N],[17,"SYS_sched_yield","","",N,N],[17,"SYS_mremap","","",N,N],[17,"SYS_msync","","",N,N],[17,"SYS_mincore","","",N,N],[17,"SYS_madvise","","",N,N],[17,"SYS_shmget","","",N,N],[17,"SYS_shmat","","",N,N],[17,"SYS_shmctl","","",N,N],[17,"SYS_dup","","",N,N],[17,"SYS_dup2","","",N,N],[17,"SYS_pause","","",N,N],[17,"SYS_nanosleep","","",N,N],[17,"SYS_getitimer","","",N,N],[17,"SYS_alarm","","",N,N],[17,"SYS_setitimer","","",N,N],[17,"SYS_getpid","","",N,N],[17,"SYS_sendfile","","",N,N],[17,"SYS_socket","","",N,N],[17,"SYS_connect","","",N,N],[17,"SYS_accept","","",N,N],[17,"SYS_sendto","","",N,N],[17,"SYS_recvfrom","","",N,N],[17,"SYS_sendmsg","","",N,N],[17,"SYS_recvmsg","","",N,N],[17,"SYS_shutdown","","",N,N],[17,"SYS_bind","","",N,N],[17,"SYS_listen","","",N,N],[17,"SYS_getsockname","","",N,N],[17,"SYS_getpeername","","",N,N],[17,"SYS_socketpair","","",N,N],[17,"SYS_setsockopt","","",N,N],[17,"SYS_getsockopt","","",N,N],[17,"SYS_clone","","",N,N],[17,"SYS_fork","","",N,N],[17,"SYS_vfork","","",N,N],[17,"SYS_execve","","",N,N],[17,"SYS_exit","","",N,N],[17,"SYS_wait4","","",N,N],[17,"SYS_kill","","",N,N],[17,"SYS_uname","","",N,N],[17,"SYS_semget","","",N,N],[17,"SYS_semop","","",N,N],[17,"SYS_semctl","","",N,N],[17,"SYS_shmdt","","",N,N],[17,"SYS_msgget","","",N,N],[17,"SYS_msgsnd","","",N,N],[17,"SYS_msgrcv","","",N,N],[17,"SYS_msgctl","","",N,N],[17,"SYS_fcntl","","",N,N],[17,"SYS_flock","","",N,N],[17,"SYS_fsync","","",N,N],[17,"SYS_fdatasync","","",N,N],[17,"SYS_truncate","","",N,N],[17,"SYS_ftruncate","","",N,N],[17,"SYS_getdents","","",N,N],[17,"SYS_getcwd","","",N,N],[17,"SYS_chdir","","",N,N],[17,"SYS_fchdir","","",N,N],[17,"SYS_rename","","",N,N],[17,"SYS_mkdir","","",N,N],[17,"SYS_rmdir","","",N,N],[17,"SYS_creat","","",N,N],[17,"SYS_link","","",N,N],[17,"SYS_unlink","","",N,N],[17,"SYS_symlink","","",N,N],[17,"SYS_readlink","","",N,N],[17,"SYS_chmod","","",N,N],[17,"SYS_fchmod","","",N,N],[17,"SYS_chown","","",N,N],[17,"SYS_fchown","","",N,N],[17,"SYS_lchown","","",N,N],[17,"SYS_umask","","",N,N],[17,"SYS_gettimeofday","","",N,N],[17,"SYS_getrlimit","","",N,N],[17,"SYS_getrusage","","",N,N],[17,"SYS_sysinfo","","",N,N],[17,"SYS_times","","",N,N],[17,"SYS_ptrace","","",N,N],[17,"SYS_getuid","","",N,N],[17,"SYS_syslog","","",N,N],[17,"SYS_getgid","","",N,N],[17,"SYS_setuid","","",N,N],[17,"SYS_setgid","","",N,N],[17,"SYS_geteuid","","",N,N],[17,"SYS_getegid","","",N,N],[17,"SYS_setpgid","","",N,N],[17,"SYS_getppid","","",N,N],[17,"SYS_getpgrp","","",N,N],[17,"SYS_setsid","","",N,N],[17,"SYS_setreuid","","",N,N],[17,"SYS_setregid","","",N,N],[17,"SYS_getgroups","","",N,N],[17,"SYS_setgroups","","",N,N],[17,"SYS_setresuid","","",N,N],[17,"SYS_getresuid","","",N,N],[17,"SYS_setresgid","","",N,N],[17,"SYS_getresgid","","",N,N],[17,"SYS_getpgid","","",N,N],[17,"SYS_setfsuid","","",N,N],[17,"SYS_setfsgid","","",N,N],[17,"SYS_getsid","","",N,N],[17,"SYS_capget","","",N,N],[17,"SYS_capset","","",N,N],[17,"SYS_rt_sigpending","","",N,N],[17,"SYS_rt_sigtimedwait","","",N,N],[17,"SYS_rt_sigqueueinfo","","",N,N],[17,"SYS_rt_sigsuspend","","",N,N],[17,"SYS_sigaltstack","","",N,N],[17,"SYS_utime","","",N,N],[17,"SYS_mknod","","",N,N],[17,"SYS_uselib","","",N,N],[17,"SYS_personality","","",N,N],[17,"SYS_ustat","","",N,N],[17,"SYS_statfs","","",N,N],[17,"SYS_fstatfs","","",N,N],[17,"SYS_sysfs","","",N,N],[17,"SYS_getpriority","","",N,N],[17,"SYS_setpriority","","",N,N],[17,"SYS_sched_setparam","","",N,N],[17,"SYS_sched_getparam","","",N,N],[17,"SYS_sched_setscheduler","","",N,N],[17,"SYS_sched_getscheduler","","",N,N],[17,"SYS_sched_get_priority_max","","",N,N],[17,"SYS_sched_get_priority_min","","",N,N],[17,"SYS_sched_rr_get_interval","","",N,N],[17,"SYS_mlock","","",N,N],[17,"SYS_munlock","","",N,N],[17,"SYS_mlockall","","",N,N],[17,"SYS_munlockall","","",N,N],[17,"SYS_vhangup","","",N,N],[17,"SYS_modify_ldt","","",N,N],[17,"SYS_pivot_root","","",N,N],[17,"SYS__sysctl","","",N,N],[17,"SYS_prctl","","",N,N],[17,"SYS_arch_prctl","","",N,N],[17,"SYS_adjtimex","","",N,N],[17,"SYS_setrlimit","","",N,N],[17,"SYS_chroot","","",N,N],[17,"SYS_sync","","",N,N],[17,"SYS_acct","","",N,N],[17,"SYS_settimeofday","","",N,N],[17,"SYS_mount","","",N,N],[17,"SYS_umount2","","",N,N],[17,"SYS_swapon","","",N,N],[17,"SYS_swapoff","","",N,N],[17,"SYS_reboot","","",N,N],[17,"SYS_sethostname","","",N,N],[17,"SYS_setdomainname","","",N,N],[17,"SYS_iopl","","",N,N],[17,"SYS_ioperm","","",N,N],[17,"SYS_create_module","","",N,N],[17,"SYS_init_module","","",N,N],[17,"SYS_delete_module","","",N,N],[17,"SYS_get_kernel_syms","","",N,N],[17,"SYS_query_module","","",N,N],[17,"SYS_quotactl","","",N,N],[17,"SYS_nfsservctl","","",N,N],[17,"SYS_getpmsg","","",N,N],[17,"SYS_putpmsg","","",N,N],[17,"SYS_afs_syscall","","",N,N],[17,"SYS_tuxcall","","",N,N],[17,"SYS_security","","",N,N],[17,"SYS_gettid","","",N,N],[17,"SYS_readahead","","",N,N],[17,"SYS_setxattr","","",N,N],[17,"SYS_lsetxattr","","",N,N],[17,"SYS_fsetxattr","","",N,N],[17,"SYS_getxattr","","",N,N],[17,"SYS_lgetxattr","","",N,N],[17,"SYS_fgetxattr","","",N,N],[17,"SYS_listxattr","","",N,N],[17,"SYS_llistxattr","","",N,N],[17,"SYS_flistxattr","","",N,N],[17,"SYS_removexattr","","",N,N],[17,"SYS_lremovexattr","","",N,N],[17,"SYS_fremovexattr","","",N,N],[17,"SYS_tkill","","",N,N],[17,"SYS_time","","",N,N],[17,"SYS_futex","","",N,N],[17,"SYS_sched_setaffinity","","",N,N],[17,"SYS_sched_getaffinity","","",N,N],[17,"SYS_set_thread_area","","",N,N],[17,"SYS_io_setup","","",N,N],[17,"SYS_io_destroy","","",N,N],[17,"SYS_io_getevents","","",N,N],[17,"SYS_io_submit","","",N,N],[17,"SYS_io_cancel","","",N,N],[17,"SYS_get_thread_area","","",N,N],[17,"SYS_lookup_dcookie","","",N,N],[17,"SYS_epoll_create","","",N,N],[17,"SYS_epoll_ctl_old","","",N,N],[17,"SYS_epoll_wait_old","","",N,N],[17,"SYS_remap_file_pages","","",N,N],[17,"SYS_getdents64","","",N,N],[17,"SYS_set_tid_address","","",N,N],[17,"SYS_restart_syscall","","",N,N],[17,"SYS_semtimedop","","",N,N],[17,"SYS_fadvise64","","",N,N],[17,"SYS_timer_create","","",N,N],[17,"SYS_timer_settime","","",N,N],[17,"SYS_timer_gettime","","",N,N],[17,"SYS_timer_getoverrun","","",N,N],[17,"SYS_timer_delete","","",N,N],[17,"SYS_clock_settime","","",N,N],[17,"SYS_clock_gettime","","",N,N],[17,"SYS_clock_getres","","",N,N],[17,"SYS_clock_nanosleep","","",N,N],[17,"SYS_exit_group","","",N,N],[17,"SYS_epoll_wait","","",N,N],[17,"SYS_epoll_ctl","","",N,N],[17,"SYS_tgkill","","",N,N],[17,"SYS_utimes","","",N,N],[17,"SYS_vserver","","",N,N],[17,"SYS_mbind","","",N,N],[17,"SYS_set_mempolicy","","",N,N],[17,"SYS_get_mempolicy","","",N,N],[17,"SYS_mq_open","","",N,N],[17,"SYS_mq_unlink","","",N,N],[17,"SYS_mq_timedsend","","",N,N],[17,"SYS_mq_timedreceive","","",N,N],[17,"SYS_mq_notify","","",N,N],[17,"SYS_mq_getsetattr","","",N,N],[17,"SYS_kexec_load","","",N,N],[17,"SYS_waitid","","",N,N],[17,"SYS_add_key","","",N,N],[17,"SYS_request_key","","",N,N],[17,"SYS_keyctl","","",N,N],[17,"SYS_ioprio_set","","",N,N],[17,"SYS_ioprio_get","","",N,N],[17,"SYS_inotify_init","","",N,N],[17,"SYS_inotify_add_watch","","",N,N],[17,"SYS_inotify_rm_watch","","",N,N],[17,"SYS_migrate_pages","","",N,N],[17,"SYS_openat","","",N,N],[17,"SYS_mkdirat","","",N,N],[17,"SYS_mknodat","","",N,N],[17,"SYS_fchownat","","",N,N],[17,"SYS_futimesat","","",N,N],[17,"SYS_newfstatat","","",N,N],[17,"SYS_unlinkat","","",N,N],[17,"SYS_renameat","","",N,N],[17,"SYS_linkat","","",N,N],[17,"SYS_symlinkat","","",N,N],[17,"SYS_readlinkat","","",N,N],[17,"SYS_fchmodat","","",N,N],[17,"SYS_faccessat","","",N,N],[17,"SYS_pselect6","","",N,N],[17,"SYS_ppoll","","",N,N],[17,"SYS_unshare","","",N,N],[17,"SYS_set_robust_list","","",N,N],[17,"SYS_get_robust_list","","",N,N],[17,"SYS_splice","","",N,N],[17,"SYS_tee","","",N,N],[17,"SYS_sync_file_range","","",N,N],[17,"SYS_vmsplice","","",N,N],[17,"SYS_move_pages","","",N,N],[17,"SYS_utimensat","","",N,N],[17,"SYS_epoll_pwait","","",N,N],[17,"SYS_signalfd","","",N,N],[17,"SYS_timerfd_create","","",N,N],[17,"SYS_eventfd","","",N,N],[17,"SYS_fallocate","","",N,N],[17,"SYS_timerfd_settime","","",N,N],[17,"SYS_timerfd_gettime","","",N,N],[17,"SYS_accept4","","",N,N],[17,"SYS_signalfd4","","",N,N],[17,"SYS_eventfd2","","",N,N],[17,"SYS_epoll_create1","","",N,N],[17,"SYS_dup3","","",N,N],[17,"SYS_pipe2","","",N,N],[17,"SYS_inotify_init1","","",N,N],[17,"SYS_preadv","","",N,N],[17,"SYS_pwritev","","",N,N],[17,"SYS_rt_tgsigqueueinfo","","",N,N],[17,"SYS_perf_event_open","","",N,N],[17,"SYS_recvmmsg","","",N,N],[17,"SYS_fanotify_init","","",N,N],[17,"SYS_fanotify_mark","","",N,N],[17,"SYS_prlimit64","","",N,N],[17,"SYS_name_to_handle_at","","",N,N],[17,"SYS_open_by_handle_at","","",N,N],[17,"SYS_clock_adjtime","","",N,N],[17,"SYS_syncfs","","",N,N],[17,"SYS_sendmmsg","","",N,N],[17,"SYS_setns","","",N,N],[17,"SYS_getcpu","","",N,N],[17,"SYS_process_vm_readv","","",N,N],[17,"SYS_process_vm_writev","","",N,N],[17,"SYS_kcmp","","",N,N],[17,"SYS_finit_module","","",N,N],[17,"SYS_sched_setattr","","",N,N],[17,"SYS_sched_getattr","","",N,N],[17,"SYS_renameat2","","",N,N],[17,"SYS_seccomp","","",N,N],[17,"SYS_getrandom","","",N,N],[17,"SYS_memfd_create","","",N,N],[17,"SYS_kexec_file_load","","",N,N],[17,"SYS_bpf","","",N,N],[17,"SYS_execveat","","",N,N],[17,"SYS_userfaultfd","","",N,N],[17,"SYS_membarrier","","",N,N],[17,"SYS_mlock2","","",N,N],[17,"SYS_copy_file_range","","",N,N],[17,"SYS_preadv2","","",N,N],[17,"SYS_pwritev2","","",N,N],[17,"SYS_pkey_mprotect","","",N,N],[17,"SYS_pkey_alloc","","",N,N],[17,"SYS_pkey_free","","",N,N],[11,"to_owned","","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"to_owned","","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"to_owned","","",12,[[["self"]],["t"]]],[11,"clone_into","","",12,N],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"to_owned","","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"to_owned","","",14,[[["self"]],["t"]]],[11,"clone_into","","",14,N],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"to_owned","","",15,[[["self"]],["t"]]],[11,"clone_into","","",15,N],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"to_owned","","",16,[[["self"]],["t"]]],[11,"clone_into","","",16,N],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"to_owned","","",17,[[["self"]],["t"]]],[11,"clone_into","","",17,N],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"to_owned","","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"to_owned","","",22,[[["self"]],["t"]]],[11,"clone_into","","",22,N],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"to_owned","","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"to_owned","","",24,[[["self"]],["t"]]],[11,"clone_into","","",24,N],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"to_owned","","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"to_owned","","",26,[[["self"]],["t"]]],[11,"clone_into","","",26,N],[11,"from","","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"to_owned","","",27,[[["self"]],["t"]]],[11,"clone_into","","",27,N],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"to_owned","","",28,[[["self"]],["t"]]],[11,"clone_into","","",28,N],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"to_owned","","",29,[[["self"]],["t"]]],[11,"clone_into","","",29,N],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"to_owned","","",30,[[["self"]],["t"]]],[11,"clone_into","","",30,N],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"to_owned","","",31,[[["self"]],["t"]]],[11,"clone_into","","",31,N],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"to_owned","","",32,[[["self"]],["t"]]],[11,"clone_into","","",32,N],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"to_owned","","",33,[[["self"]],["t"]]],[11,"clone_into","","",33,N],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"to_owned","","",34,[[["self"]],["t"]]],[11,"clone_into","","",34,N],[11,"from","","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"to_owned","","",35,[[["self"]],["t"]]],[11,"clone_into","","",35,N],[11,"from","","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"to_owned","","",36,[[["self"]],["t"]]],[11,"clone_into","","",36,N],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"to_owned","","",37,[[["self"]],["t"]]],[11,"clone_into","","",37,N],[11,"from","","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"to_owned","","",38,[[["self"]],["t"]]],[11,"clone_into","","",38,N],[11,"from","","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"to_owned","","",39,[[["self"]],["t"]]],[11,"clone_into","","",39,N],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"to_owned","","",40,[[["self"]],["t"]]],[11,"clone_into","","",40,N],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"to_owned","","",41,[[["self"]],["t"]]],[11,"clone_into","","",41,N],[11,"from","","",41,[[["t"]],["t"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"to_owned","","",42,[[["self"]],["t"]]],[11,"clone_into","","",42,N],[11,"from","","",42,[[["t"]],["t"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"to_owned","","",43,[[["self"]],["t"]]],[11,"clone_into","","",43,N],[11,"from","","",43,[[["t"]],["t"]]],[11,"into","","",43,[[["self"]],["u"]]],[11,"try_from","","",43,[[["u"]],["result"]]],[11,"borrow","","",43,[[["self"]],["t"]]],[11,"try_into","","",43,[[["self"]],["result"]]],[11,"borrow_mut","","",43,[[["self"]],["t"]]],[11,"get_type_id","","",43,[[["self"]],["typeid"]]],[11,"to_owned","","",44,[[["self"]],["t"]]],[11,"clone_into","","",44,N],[11,"from","","",44,[[["t"]],["t"]]],[11,"into","","",44,[[["self"]],["u"]]],[11,"try_from","","",44,[[["u"]],["result"]]],[11,"borrow","","",44,[[["self"]],["t"]]],[11,"try_into","","",44,[[["self"]],["result"]]],[11,"borrow_mut","","",44,[[["self"]],["t"]]],[11,"get_type_id","","",44,[[["self"]],["typeid"]]],[11,"to_owned","","",45,[[["self"]],["t"]]],[11,"clone_into","","",45,N],[11,"from","","",45,[[["t"]],["t"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"to_owned","","",46,[[["self"]],["t"]]],[11,"clone_into","","",46,N],[11,"from","","",46,[[["t"]],["t"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"to_owned","","",47,[[["self"]],["t"]]],[11,"clone_into","","",47,N],[11,"from","","",47,[[["t"]],["t"]]],[11,"into","","",47,[[["self"]],["u"]]],[11,"try_from","","",47,[[["u"]],["result"]]],[11,"borrow","","",47,[[["self"]],["t"]]],[11,"try_into","","",47,[[["self"]],["result"]]],[11,"borrow_mut","","",47,[[["self"]],["t"]]],[11,"get_type_id","","",47,[[["self"]],["typeid"]]],[11,"to_owned","","",48,[[["self"]],["t"]]],[11,"clone_into","","",48,N],[11,"from","","",48,[[["t"]],["t"]]],[11,"into","","",48,[[["self"]],["u"]]],[11,"try_from","","",48,[[["u"]],["result"]]],[11,"borrow","","",48,[[["self"]],["t"]]],[11,"try_into","","",48,[[["self"]],["result"]]],[11,"borrow_mut","","",48,[[["self"]],["t"]]],[11,"get_type_id","","",48,[[["self"]],["typeid"]]],[11,"to_owned","","",49,[[["self"]],["t"]]],[11,"clone_into","","",49,N],[11,"from","","",49,[[["t"]],["t"]]],[11,"into","","",49,[[["self"]],["u"]]],[11,"try_from","","",49,[[["u"]],["result"]]],[11,"borrow","","",49,[[["self"]],["t"]]],[11,"try_into","","",49,[[["self"]],["result"]]],[11,"borrow_mut","","",49,[[["self"]],["t"]]],[11,"get_type_id","","",49,[[["self"]],["typeid"]]],[11,"to_owned","","",50,[[["self"]],["t"]]],[11,"clone_into","","",50,N],[11,"from","","",50,[[["t"]],["t"]]],[11,"into","","",50,[[["self"]],["u"]]],[11,"try_from","","",50,[[["u"]],["result"]]],[11,"borrow","","",50,[[["self"]],["t"]]],[11,"try_into","","",50,[[["self"]],["result"]]],[11,"borrow_mut","","",50,[[["self"]],["t"]]],[11,"get_type_id","","",50,[[["self"]],["typeid"]]],[11,"to_owned","","",51,[[["self"]],["t"]]],[11,"clone_into","","",51,N],[11,"from","","",51,[[["t"]],["t"]]],[11,"into","","",51,[[["self"]],["u"]]],[11,"try_from","","",51,[[["u"]],["result"]]],[11,"borrow","","",51,[[["self"]],["t"]]],[11,"try_into","","",51,[[["self"]],["result"]]],[11,"borrow_mut","","",51,[[["self"]],["t"]]],[11,"get_type_id","","",51,[[["self"]],["typeid"]]],[11,"to_owned","","",52,[[["self"]],["t"]]],[11,"clone_into","","",52,N],[11,"from","","",52,[[["t"]],["t"]]],[11,"into","","",52,[[["self"]],["u"]]],[11,"try_from","","",52,[[["u"]],["result"]]],[11,"borrow","","",52,[[["self"]],["t"]]],[11,"try_into","","",52,[[["self"]],["result"]]],[11,"borrow_mut","","",52,[[["self"]],["t"]]],[11,"get_type_id","","",52,[[["self"]],["typeid"]]],[11,"to_owned","","",53,[[["self"]],["t"]]],[11,"clone_into","","",53,N],[11,"from","","",53,[[["t"]],["t"]]],[11,"into","","",53,[[["self"]],["u"]]],[11,"try_from","","",53,[[["u"]],["result"]]],[11,"borrow","","",53,[[["self"]],["t"]]],[11,"try_into","","",53,[[["self"]],["result"]]],[11,"borrow_mut","","",53,[[["self"]],["t"]]],[11,"get_type_id","","",53,[[["self"]],["typeid"]]],[11,"to_owned","","",54,[[["self"]],["t"]]],[11,"clone_into","","",54,N],[11,"from","","",54,[[["t"]],["t"]]],[11,"into","","",54,[[["self"]],["u"]]],[11,"try_from","","",54,[[["u"]],["result"]]],[11,"borrow","","",54,[[["self"]],["t"]]],[11,"try_into","","",54,[[["self"]],["result"]]],[11,"borrow_mut","","",54,[[["self"]],["t"]]],[11,"get_type_id","","",54,[[["self"]],["typeid"]]],[11,"to_owned","","",55,[[["self"]],["t"]]],[11,"clone_into","","",55,N],[11,"from","","",55,[[["t"]],["t"]]],[11,"into","","",55,[[["self"]],["u"]]],[11,"try_from","","",55,[[["u"]],["result"]]],[11,"borrow","","",55,[[["self"]],["t"]]],[11,"try_into","","",55,[[["self"]],["result"]]],[11,"borrow_mut","","",55,[[["self"]],["t"]]],[11,"get_type_id","","",55,[[["self"]],["typeid"]]],[11,"to_owned","","",56,[[["self"]],["t"]]],[11,"clone_into","","",56,N],[11,"from","","",56,[[["t"]],["t"]]],[11,"into","","",56,[[["self"]],["u"]]],[11,"try_from","","",56,[[["u"]],["result"]]],[11,"borrow","","",56,[[["self"]],["t"]]],[11,"try_into","","",56,[[["self"]],["result"]]],[11,"borrow_mut","","",56,[[["self"]],["t"]]],[11,"get_type_id","","",56,[[["self"]],["typeid"]]],[11,"to_owned","","",57,[[["self"]],["t"]]],[11,"clone_into","","",57,N],[11,"from","","",57,[[["t"]],["t"]]],[11,"into","","",57,[[["self"]],["u"]]],[11,"try_from","","",57,[[["u"]],["result"]]],[11,"borrow","","",57,[[["self"]],["t"]]],[11,"try_into","","",57,[[["self"]],["result"]]],[11,"borrow_mut","","",57,[[["self"]],["t"]]],[11,"get_type_id","","",57,[[["self"]],["typeid"]]],[11,"to_owned","","",58,[[["self"]],["t"]]],[11,"clone_into","","",58,N],[11,"from","","",58,[[["t"]],["t"]]],[11,"into","","",58,[[["self"]],["u"]]],[11,"try_from","","",58,[[["u"]],["result"]]],[11,"borrow","","",58,[[["self"]],["t"]]],[11,"try_into","","",58,[[["self"]],["result"]]],[11,"borrow_mut","","",58,[[["self"]],["t"]]],[11,"get_type_id","","",58,[[["self"]],["typeid"]]],[11,"to_owned","","",59,[[["self"]],["t"]]],[11,"clone_into","","",59,N],[11,"from","","",59,[[["t"]],["t"]]],[11,"into","","",59,[[["self"]],["u"]]],[11,"try_from","","",59,[[["u"]],["result"]]],[11,"borrow","","",59,[[["self"]],["t"]]],[11,"try_into","","",59,[[["self"]],["result"]]],[11,"borrow_mut","","",59,[[["self"]],["t"]]],[11,"get_type_id","","",59,[[["self"]],["typeid"]]],[11,"to_owned","","",60,[[["self"]],["t"]]],[11,"clone_into","","",60,N],[11,"from","","",60,[[["t"]],["t"]]],[11,"into","","",60,[[["self"]],["u"]]],[11,"try_from","","",60,[[["u"]],["result"]]],[11,"borrow","","",60,[[["self"]],["t"]]],[11,"try_into","","",60,[[["self"]],["result"]]],[11,"borrow_mut","","",60,[[["self"]],["t"]]],[11,"get_type_id","","",60,[[["self"]],["typeid"]]],[11,"to_owned","","",61,[[["self"]],["t"]]],[11,"clone_into","","",61,N],[11,"from","","",61,[[["t"]],["t"]]],[11,"into","","",61,[[["self"]],["u"]]],[11,"try_from","","",61,[[["u"]],["result"]]],[11,"borrow","","",61,[[["self"]],["t"]]],[11,"try_into","","",61,[[["self"]],["result"]]],[11,"borrow_mut","","",61,[[["self"]],["t"]]],[11,"get_type_id","","",61,[[["self"]],["typeid"]]],[11,"to_owned","","",62,[[["self"]],["t"]]],[11,"clone_into","","",62,N],[11,"from","","",62,[[["t"]],["t"]]],[11,"into","","",62,[[["self"]],["u"]]],[11,"try_from","","",62,[[["u"]],["result"]]],[11,"borrow","","",62,[[["self"]],["t"]]],[11,"try_into","","",62,[[["self"]],["result"]]],[11,"borrow_mut","","",62,[[["self"]],["t"]]],[11,"get_type_id","","",62,[[["self"]],["typeid"]]],[11,"to_owned","","",63,[[["self"]],["t"]]],[11,"clone_into","","",63,N],[11,"from","","",63,[[["t"]],["t"]]],[11,"into","","",63,[[["self"]],["u"]]],[11,"try_from","","",63,[[["u"]],["result"]]],[11,"borrow","","",63,[[["self"]],["t"]]],[11,"try_into","","",63,[[["self"]],["result"]]],[11,"borrow_mut","","",63,[[["self"]],["t"]]],[11,"get_type_id","","",63,[[["self"]],["typeid"]]],[11,"to_owned","","",64,[[["self"]],["t"]]],[11,"clone_into","","",64,N],[11,"from","","",64,[[["t"]],["t"]]],[11,"into","","",64,[[["self"]],["u"]]],[11,"try_from","","",64,[[["u"]],["result"]]],[11,"borrow","","",64,[[["self"]],["t"]]],[11,"try_into","","",64,[[["self"]],["result"]]],[11,"borrow_mut","","",64,[[["self"]],["t"]]],[11,"get_type_id","","",64,[[["self"]],["typeid"]]],[11,"to_owned","","",65,[[["self"]],["t"]]],[11,"clone_into","","",65,N],[11,"from","","",65,[[["t"]],["t"]]],[11,"into","","",65,[[["self"]],["u"]]],[11,"try_from","","",65,[[["u"]],["result"]]],[11,"borrow","","",65,[[["self"]],["t"]]],[11,"try_into","","",65,[[["self"]],["result"]]],[11,"borrow_mut","","",65,[[["self"]],["t"]]],[11,"get_type_id","","",65,[[["self"]],["typeid"]]],[11,"to_owned","","",66,[[["self"]],["t"]]],[11,"clone_into","","",66,N],[11,"from","","",66,[[["t"]],["t"]]],[11,"into","","",66,[[["self"]],["u"]]],[11,"try_from","","",66,[[["u"]],["result"]]],[11,"borrow","","",66,[[["self"]],["t"]]],[11,"try_into","","",66,[[["self"]],["result"]]],[11,"borrow_mut","","",66,[[["self"]],["t"]]],[11,"get_type_id","","",66,[[["self"]],["typeid"]]],[11,"to_owned","","",67,[[["self"]],["t"]]],[11,"clone_into","","",67,N],[11,"from","","",67,[[["t"]],["t"]]],[11,"into","","",67,[[["self"]],["u"]]],[11,"try_from","","",67,[[["u"]],["result"]]],[11,"borrow","","",67,[[["self"]],["t"]]],[11,"try_into","","",67,[[["self"]],["result"]]],[11,"borrow_mut","","",67,[[["self"]],["t"]]],[11,"get_type_id","","",67,[[["self"]],["typeid"]]],[11,"to_owned","","",68,[[["self"]],["t"]]],[11,"clone_into","","",68,N],[11,"from","","",68,[[["t"]],["t"]]],[11,"into","","",68,[[["self"]],["u"]]],[11,"try_from","","",68,[[["u"]],["result"]]],[11,"borrow","","",68,[[["self"]],["t"]]],[11,"try_into","","",68,[[["self"]],["result"]]],[11,"borrow_mut","","",68,[[["self"]],["t"]]],[11,"get_type_id","","",68,[[["self"]],["typeid"]]],[11,"to_owned","","",69,[[["self"]],["t"]]],[11,"clone_into","","",69,N],[11,"from","","",69,[[["t"]],["t"]]],[11,"into","","",69,[[["self"]],["u"]]],[11,"try_from","","",69,[[["u"]],["result"]]],[11,"borrow","","",69,[[["self"]],["t"]]],[11,"try_into","","",69,[[["self"]],["result"]]],[11,"borrow_mut","","",69,[[["self"]],["t"]]],[11,"get_type_id","","",69,[[["self"]],["typeid"]]],[11,"to_owned","","",70,[[["self"]],["t"]]],[11,"clone_into","","",70,N],[11,"from","","",70,[[["t"]],["t"]]],[11,"into","","",70,[[["self"]],["u"]]],[11,"try_from","","",70,[[["u"]],["result"]]],[11,"borrow","","",70,[[["self"]],["t"]]],[11,"try_into","","",70,[[["self"]],["result"]]],[11,"borrow_mut","","",70,[[["self"]],["t"]]],[11,"get_type_id","","",70,[[["self"]],["typeid"]]],[11,"to_owned","","",71,[[["self"]],["t"]]],[11,"clone_into","","",71,N],[11,"from","","",71,[[["t"]],["t"]]],[11,"into","","",71,[[["self"]],["u"]]],[11,"try_from","","",71,[[["u"]],["result"]]],[11,"borrow","","",71,[[["self"]],["t"]]],[11,"try_into","","",71,[[["self"]],["result"]]],[11,"borrow_mut","","",71,[[["self"]],["t"]]],[11,"get_type_id","","",71,[[["self"]],["typeid"]]],[11,"to_owned","","",72,[[["self"]],["t"]]],[11,"clone_into","","",72,N],[11,"from","","",72,[[["t"]],["t"]]],[11,"into","","",72,[[["self"]],["u"]]],[11,"try_from","","",72,[[["u"]],["result"]]],[11,"borrow","","",72,[[["self"]],["t"]]],[11,"try_into","","",72,[[["self"]],["result"]]],[11,"borrow_mut","","",72,[[["self"]],["t"]]],[11,"get_type_id","","",72,[[["self"]],["typeid"]]],[11,"to_owned","","",73,[[["self"]],["t"]]],[11,"clone_into","","",73,N],[11,"from","","",73,[[["t"]],["t"]]],[11,"into","","",73,[[["self"]],["u"]]],[11,"try_from","","",73,[[["u"]],["result"]]],[11,"borrow","","",73,[[["self"]],["t"]]],[11,"try_into","","",73,[[["self"]],["result"]]],[11,"borrow_mut","","",73,[[["self"]],["t"]]],[11,"get_type_id","","",73,[[["self"]],["typeid"]]],[11,"to_owned","","",74,[[["self"]],["t"]]],[11,"clone_into","","",74,N],[11,"from","","",74,[[["t"]],["t"]]],[11,"into","","",74,[[["self"]],["u"]]],[11,"try_from","","",74,[[["u"]],["result"]]],[11,"borrow","","",74,[[["self"]],["t"]]],[11,"try_into","","",74,[[["self"]],["result"]]],[11,"borrow_mut","","",74,[[["self"]],["t"]]],[11,"get_type_id","","",74,[[["self"]],["typeid"]]],[11,"to_owned","","",75,[[["self"]],["t"]]],[11,"clone_into","","",75,N],[11,"from","","",75,[[["t"]],["t"]]],[11,"into","","",75,[[["self"]],["u"]]],[11,"try_from","","",75,[[["u"]],["result"]]],[11,"borrow","","",75,[[["self"]],["t"]]],[11,"try_into","","",75,[[["self"]],["result"]]],[11,"borrow_mut","","",75,[[["self"]],["t"]]],[11,"get_type_id","","",75,[[["self"]],["typeid"]]],[11,"to_owned","","",76,[[["self"]],["t"]]],[11,"clone_into","","",76,N],[11,"from","","",76,[[["t"]],["t"]]],[11,"into","","",76,[[["self"]],["u"]]],[11,"try_from","","",76,[[["u"]],["result"]]],[11,"borrow","","",76,[[["self"]],["t"]]],[11,"try_into","","",76,[[["self"]],["result"]]],[11,"borrow_mut","","",76,[[["self"]],["t"]]],[11,"get_type_id","","",76,[[["self"]],["typeid"]]],[11,"to_owned","","",77,[[["self"]],["t"]]],[11,"clone_into","","",77,N],[11,"from","","",77,[[["t"]],["t"]]],[11,"into","","",77,[[["self"]],["u"]]],[11,"try_from","","",77,[[["u"]],["result"]]],[11,"borrow","","",77,[[["self"]],["t"]]],[11,"try_into","","",77,[[["self"]],["result"]]],[11,"borrow_mut","","",77,[[["self"]],["t"]]],[11,"get_type_id","","",77,[[["self"]],["typeid"]]],[11,"to_owned","","",78,[[["self"]],["t"]]],[11,"clone_into","","",78,N],[11,"from","","",78,[[["t"]],["t"]]],[11,"into","","",78,[[["self"]],["u"]]],[11,"try_from","","",78,[[["u"]],["result"]]],[11,"borrow","","",78,[[["self"]],["t"]]],[11,"try_into","","",78,[[["self"]],["result"]]],[11,"borrow_mut","","",78,[[["self"]],["t"]]],[11,"get_type_id","","",78,[[["self"]],["typeid"]]],[11,"to_owned","","",79,[[["self"]],["t"]]],[11,"clone_into","","",79,N],[11,"from","","",79,[[["t"]],["t"]]],[11,"into","","",79,[[["self"]],["u"]]],[11,"try_from","","",79,[[["u"]],["result"]]],[11,"borrow","","",79,[[["self"]],["t"]]],[11,"try_into","","",79,[[["self"]],["result"]]],[11,"borrow_mut","","",79,[[["self"]],["t"]]],[11,"get_type_id","","",79,[[["self"]],["typeid"]]],[11,"to_owned","","",80,[[["self"]],["t"]]],[11,"clone_into","","",80,N],[11,"from","","",80,[[["t"]],["t"]]],[11,"into","","",80,[[["self"]],["u"]]],[11,"try_from","","",80,[[["u"]],["result"]]],[11,"borrow","","",80,[[["self"]],["t"]]],[11,"try_into","","",80,[[["self"]],["result"]]],[11,"borrow_mut","","",80,[[["self"]],["t"]]],[11,"get_type_id","","",80,[[["self"]],["typeid"]]],[11,"to_owned","","",81,[[["self"]],["t"]]],[11,"clone_into","","",81,N],[11,"from","","",81,[[["t"]],["t"]]],[11,"into","","",81,[[["self"]],["u"]]],[11,"try_from","","",81,[[["u"]],["result"]]],[11,"borrow","","",81,[[["self"]],["t"]]],[11,"try_into","","",81,[[["self"]],["result"]]],[11,"borrow_mut","","",81,[[["self"]],["t"]]],[11,"get_type_id","","",81,[[["self"]],["typeid"]]],[11,"to_owned","","",82,[[["self"]],["t"]]],[11,"clone_into","","",82,N],[11,"from","","",82,[[["t"]],["t"]]],[11,"into","","",82,[[["self"]],["u"]]],[11,"try_from","","",82,[[["u"]],["result"]]],[11,"borrow","","",82,[[["self"]],["t"]]],[11,"try_into","","",82,[[["self"]],["result"]]],[11,"borrow_mut","","",82,[[["self"]],["t"]]],[11,"get_type_id","","",82,[[["self"]],["typeid"]]],[11,"to_owned","","",83,[[["self"]],["t"]]],[11,"clone_into","","",83,N],[11,"from","","",83,[[["t"]],["t"]]],[11,"into","","",83,[[["self"]],["u"]]],[11,"try_from","","",83,[[["u"]],["result"]]],[11,"borrow","","",83,[[["self"]],["t"]]],[11,"try_into","","",83,[[["self"]],["result"]]],[11,"borrow_mut","","",83,[[["self"]],["t"]]],[11,"get_type_id","","",83,[[["self"]],["typeid"]]],[11,"to_owned","","",84,[[["self"]],["t"]]],[11,"clone_into","","",84,N],[11,"from","","",84,[[["t"]],["t"]]],[11,"into","","",84,[[["self"]],["u"]]],[11,"try_from","","",84,[[["u"]],["result"]]],[11,"borrow","","",84,[[["self"]],["t"]]],[11,"try_into","","",84,[[["self"]],["result"]]],[11,"borrow_mut","","",84,[[["self"]],["t"]]],[11,"get_type_id","","",84,[[["self"]],["typeid"]]],[11,"to_owned","","",85,[[["self"]],["t"]]],[11,"clone_into","","",85,N],[11,"from","","",85,[[["t"]],["t"]]],[11,"into","","",85,[[["self"]],["u"]]],[11,"try_from","","",85,[[["u"]],["result"]]],[11,"borrow","","",85,[[["self"]],["t"]]],[11,"try_into","","",85,[[["self"]],["result"]]],[11,"borrow_mut","","",85,[[["self"]],["t"]]],[11,"get_type_id","","",85,[[["self"]],["typeid"]]],[11,"to_owned","","",86,[[["self"]],["t"]]],[11,"clone_into","","",86,N],[11,"from","","",86,[[["t"]],["t"]]],[11,"into","","",86,[[["self"]],["u"]]],[11,"try_from","","",86,[[["u"]],["result"]]],[11,"borrow","","",86,[[["self"]],["t"]]],[11,"try_into","","",86,[[["self"]],["result"]]],[11,"borrow_mut","","",86,[[["self"]],["t"]]],[11,"get_type_id","","",86,[[["self"]],["typeid"]]],[11,"to_owned","","",87,[[["self"]],["t"]]],[11,"clone_into","","",87,N],[11,"from","","",87,[[["t"]],["t"]]],[11,"into","","",87,[[["self"]],["u"]]],[11,"try_from","","",87,[[["u"]],["result"]]],[11,"borrow","","",87,[[["self"]],["t"]]],[11,"try_into","","",87,[[["self"]],["result"]]],[11,"borrow_mut","","",87,[[["self"]],["t"]]],[11,"get_type_id","","",87,[[["self"]],["typeid"]]],[11,"to_owned","","",88,[[["self"]],["t"]]],[11,"clone_into","","",88,N],[11,"from","","",88,[[["t"]],["t"]]],[11,"into","","",88,[[["self"]],["u"]]],[11,"try_from","","",88,[[["u"]],["result"]]],[11,"borrow","","",88,[[["self"]],["t"]]],[11,"try_into","","",88,[[["self"]],["result"]]],[11,"borrow_mut","","",88,[[["self"]],["t"]]],[11,"get_type_id","","",88,[[["self"]],["typeid"]]],[11,"to_owned","","",89,[[["self"]],["t"]]],[11,"clone_into","","",89,N],[11,"from","","",89,[[["t"]],["t"]]],[11,"into","","",89,[[["self"]],["u"]]],[11,"try_from","","",89,[[["u"]],["result"]]],[11,"borrow","","",89,[[["self"]],["t"]]],[11,"try_into","","",89,[[["self"]],["result"]]],[11,"borrow_mut","","",89,[[["self"]],["t"]]],[11,"get_type_id","","",89,[[["self"]],["typeid"]]],[11,"to_owned","","",90,[[["self"]],["t"]]],[11,"clone_into","","",90,N],[11,"from","","",90,[[["t"]],["t"]]],[11,"into","","",90,[[["self"]],["u"]]],[11,"try_from","","",90,[[["u"]],["result"]]],[11,"borrow","","",90,[[["self"]],["t"]]],[11,"try_into","","",90,[[["self"]],["result"]]],[11,"borrow_mut","","",90,[[["self"]],["t"]]],[11,"get_type_id","","",90,[[["self"]],["typeid"]]],[11,"to_owned","","",91,[[["self"]],["t"]]],[11,"clone_into","","",91,N],[11,"from","","",91,[[["t"]],["t"]]],[11,"into","","",91,[[["self"]],["u"]]],[11,"try_from","","",91,[[["u"]],["result"]]],[11,"borrow","","",91,[[["self"]],["t"]]],[11,"try_into","","",91,[[["self"]],["result"]]],[11,"borrow_mut","","",91,[[["self"]],["t"]]],[11,"get_type_id","","",91,[[["self"]],["typeid"]]],[11,"to_owned","","",92,[[["self"]],["t"]]],[11,"clone_into","","",92,N],[11,"from","","",92,[[["t"]],["t"]]],[11,"into","","",92,[[["self"]],["u"]]],[11,"try_from","","",92,[[["u"]],["result"]]],[11,"borrow","","",92,[[["self"]],["t"]]],[11,"try_into","","",92,[[["self"]],["result"]]],[11,"borrow_mut","","",92,[[["self"]],["t"]]],[11,"get_type_id","","",92,[[["self"]],["typeid"]]],[11,"to_owned","","",93,[[["self"]],["t"]]],[11,"clone_into","","",93,N],[11,"from","","",93,[[["t"]],["t"]]],[11,"into","","",93,[[["self"]],["u"]]],[11,"try_from","","",93,[[["u"]],["result"]]],[11,"borrow","","",93,[[["self"]],["t"]]],[11,"try_into","","",93,[[["self"]],["result"]]],[11,"borrow_mut","","",93,[[["self"]],["t"]]],[11,"get_type_id","","",93,[[["self"]],["typeid"]]],[11,"to_owned","","",94,[[["self"]],["t"]]],[11,"clone_into","","",94,N],[11,"from","","",94,[[["t"]],["t"]]],[11,"into","","",94,[[["self"]],["u"]]],[11,"try_from","","",94,[[["u"]],["result"]]],[11,"borrow","","",94,[[["self"]],["t"]]],[11,"try_into","","",94,[[["self"]],["result"]]],[11,"borrow_mut","","",94,[[["self"]],["t"]]],[11,"get_type_id","","",94,[[["self"]],["typeid"]]],[11,"to_owned","","",95,[[["self"]],["t"]]],[11,"clone_into","","",95,N],[11,"from","","",95,[[["t"]],["t"]]],[11,"into","","",95,[[["self"]],["u"]]],[11,"try_from","","",95,[[["u"]],["result"]]],[11,"borrow","","",95,[[["self"]],["t"]]],[11,"try_into","","",95,[[["self"]],["result"]]],[11,"borrow_mut","","",95,[[["self"]],["t"]]],[11,"get_type_id","","",95,[[["self"]],["typeid"]]],[11,"to_owned","","",96,[[["self"]],["t"]]],[11,"clone_into","","",96,N],[11,"from","","",96,[[["t"]],["t"]]],[11,"into","","",96,[[["self"]],["u"]]],[11,"try_from","","",96,[[["u"]],["result"]]],[11,"borrow","","",96,[[["self"]],["t"]]],[11,"try_into","","",96,[[["self"]],["result"]]],[11,"borrow_mut","","",96,[[["self"]],["t"]]],[11,"get_type_id","","",96,[[["self"]],["typeid"]]],[11,"to_owned","","",97,[[["self"]],["t"]]],[11,"clone_into","","",97,N],[11,"from","","",97,[[["t"]],["t"]]],[11,"into","","",97,[[["self"]],["u"]]],[11,"try_from","","",97,[[["u"]],["result"]]],[11,"borrow","","",97,[[["self"]],["t"]]],[11,"try_into","","",97,[[["self"]],["result"]]],[11,"borrow_mut","","",97,[[["self"]],["t"]]],[11,"get_type_id","","",97,[[["self"]],["typeid"]]],[11,"to_owned","","",98,[[["self"]],["t"]]],[11,"clone_into","","",98,N],[11,"from","","",98,[[["t"]],["t"]]],[11,"into","","",98,[[["self"]],["u"]]],[11,"try_from","","",98,[[["u"]],["result"]]],[11,"borrow","","",98,[[["self"]],["t"]]],[11,"try_into","","",98,[[["self"]],["result"]]],[11,"borrow_mut","","",98,[[["self"]],["t"]]],[11,"get_type_id","","",98,[[["self"]],["typeid"]]],[11,"to_owned","","",99,[[["self"]],["t"]]],[11,"clone_into","","",99,N],[11,"from","","",99,[[["t"]],["t"]]],[11,"into","","",99,[[["self"]],["u"]]],[11,"try_from","","",99,[[["u"]],["result"]]],[11,"borrow","","",99,[[["self"]],["t"]]],[11,"try_into","","",99,[[["self"]],["result"]]],[11,"borrow_mut","","",99,[[["self"]],["t"]]],[11,"get_type_id","","",99,[[["self"]],["typeid"]]],[11,"to_owned","","",100,[[["self"]],["t"]]],[11,"clone_into","","",100,N],[11,"from","","",100,[[["t"]],["t"]]],[11,"into","","",100,[[["self"]],["u"]]],[11,"try_from","","",100,[[["u"]],["result"]]],[11,"borrow","","",100,[[["self"]],["t"]]],[11,"try_into","","",100,[[["self"]],["result"]]],[11,"borrow_mut","","",100,[[["self"]],["t"]]],[11,"get_type_id","","",100,[[["self"]],["typeid"]]],[11,"to_owned","","",101,[[["self"]],["t"]]],[11,"clone_into","","",101,N],[11,"from","","",101,[[["t"]],["t"]]],[11,"into","","",101,[[["self"]],["u"]]],[11,"try_from","","",101,[[["u"]],["result"]]],[11,"borrow","","",101,[[["self"]],["t"]]],[11,"try_into","","",101,[[["self"]],["result"]]],[11,"borrow_mut","","",101,[[["self"]],["t"]]],[11,"get_type_id","","",101,[[["self"]],["typeid"]]],[11,"to_owned","","",102,[[["self"]],["t"]]],[11,"clone_into","","",102,N],[11,"from","","",102,[[["t"]],["t"]]],[11,"into","","",102,[[["self"]],["u"]]],[11,"try_from","","",102,[[["u"]],["result"]]],[11,"borrow","","",102,[[["self"]],["t"]]],[11,"try_into","","",102,[[["self"]],["result"]]],[11,"borrow_mut","","",102,[[["self"]],["t"]]],[11,"get_type_id","","",102,[[["self"]],["typeid"]]],[11,"to_owned","","",103,[[["self"]],["t"]]],[11,"clone_into","","",103,N],[11,"from","","",103,[[["t"]],["t"]]],[11,"into","","",103,[[["self"]],["u"]]],[11,"try_from","","",103,[[["u"]],["result"]]],[11,"borrow","","",103,[[["self"]],["t"]]],[11,"try_into","","",103,[[["self"]],["result"]]],[11,"borrow_mut","","",103,[[["self"]],["t"]]],[11,"get_type_id","","",103,[[["self"]],["typeid"]]],[11,"to_owned","","",104,[[["self"]],["t"]]],[11,"clone_into","","",104,N],[11,"from","","",104,[[["t"]],["t"]]],[11,"into","","",104,[[["self"]],["u"]]],[11,"try_from","","",104,[[["u"]],["result"]]],[11,"borrow","","",104,[[["self"]],["t"]]],[11,"try_into","","",104,[[["self"]],["result"]]],[11,"borrow_mut","","",104,[[["self"]],["t"]]],[11,"get_type_id","","",104,[[["self"]],["typeid"]]],[11,"to_owned","","",105,[[["self"]],["t"]]],[11,"clone_into","","",105,N],[11,"from","","",105,[[["t"]],["t"]]],[11,"into","","",105,[[["self"]],["u"]]],[11,"try_from","","",105,[[["u"]],["result"]]],[11,"borrow","","",105,[[["self"]],["t"]]],[11,"try_into","","",105,[[["self"]],["result"]]],[11,"borrow_mut","","",105,[[["self"]],["t"]]],[11,"get_type_id","","",105,[[["self"]],["typeid"]]],[11,"to_owned","","",106,[[["self"]],["t"]]],[11,"clone_into","","",106,N],[11,"from","","",106,[[["t"]],["t"]]],[11,"into","","",106,[[["self"]],["u"]]],[11,"try_from","","",106,[[["u"]],["result"]]],[11,"borrow","","",106,[[["self"]],["t"]]],[11,"try_into","","",106,[[["self"]],["result"]]],[11,"borrow_mut","","",106,[[["self"]],["t"]]],[11,"get_type_id","","",106,[[["self"]],["typeid"]]],[11,"to_owned","","",107,[[["self"]],["t"]]],[11,"clone_into","","",107,N],[11,"from","","",107,[[["t"]],["t"]]],[11,"into","","",107,[[["self"]],["u"]]],[11,"try_from","","",107,[[["u"]],["result"]]],[11,"borrow","","",107,[[["self"]],["t"]]],[11,"try_into","","",107,[[["self"]],["result"]]],[11,"borrow_mut","","",107,[[["self"]],["t"]]],[11,"get_type_id","","",107,[[["self"]],["typeid"]]],[11,"to_owned","","",108,[[["self"]],["t"]]],[11,"clone_into","","",108,N],[11,"from","","",108,[[["t"]],["t"]]],[11,"into","","",108,[[["self"]],["u"]]],[11,"try_from","","",108,[[["u"]],["result"]]],[11,"borrow","","",108,[[["self"]],["t"]]],[11,"try_into","","",108,[[["self"]],["result"]]],[11,"borrow_mut","","",108,[[["self"]],["t"]]],[11,"get_type_id","","",108,[[["self"]],["typeid"]]],[11,"to_owned","","",109,[[["self"]],["t"]]],[11,"clone_into","","",109,N],[11,"from","","",109,[[["t"]],["t"]]],[11,"into","","",109,[[["self"]],["u"]]],[11,"try_from","","",109,[[["u"]],["result"]]],[11,"borrow","","",109,[[["self"]],["t"]]],[11,"try_into","","",109,[[["self"]],["result"]]],[11,"borrow_mut","","",109,[[["self"]],["t"]]],[11,"get_type_id","","",109,[[["self"]],["typeid"]]],[11,"to_owned","","",110,[[["self"]],["t"]]],[11,"clone_into","","",110,N],[11,"from","","",110,[[["t"]],["t"]]],[11,"into","","",110,[[["self"]],["u"]]],[11,"try_from","","",110,[[["u"]],["result"]]],[11,"borrow","","",110,[[["self"]],["t"]]],[11,"try_into","","",110,[[["self"]],["result"]]],[11,"borrow_mut","","",110,[[["self"]],["t"]]],[11,"get_type_id","","",110,[[["self"]],["typeid"]]],[11,"to_owned","","",111,[[["self"]],["t"]]],[11,"clone_into","","",111,N],[11,"from","","",111,[[["t"]],["t"]]],[11,"into","","",111,[[["self"]],["u"]]],[11,"try_from","","",111,[[["u"]],["result"]]],[11,"borrow","","",111,[[["self"]],["t"]]],[11,"try_into","","",111,[[["self"]],["result"]]],[11,"borrow_mut","","",111,[[["self"]],["t"]]],[11,"get_type_id","","",111,[[["self"]],["typeid"]]],[11,"to_owned","","",112,[[["self"]],["t"]]],[11,"clone_into","","",112,N],[11,"from","","",112,[[["t"]],["t"]]],[11,"into","","",112,[[["self"]],["u"]]],[11,"try_from","","",112,[[["u"]],["result"]]],[11,"borrow","","",112,[[["self"]],["t"]]],[11,"try_into","","",112,[[["self"]],["result"]]],[11,"borrow_mut","","",112,[[["self"]],["t"]]],[11,"get_type_id","","",112,[[["self"]],["typeid"]]],[11,"to_owned","","",113,[[["self"]],["t"]]],[11,"clone_into","","",113,N],[11,"from","","",113,[[["t"]],["t"]]],[11,"into","","",113,[[["self"]],["u"]]],[11,"try_from","","",113,[[["u"]],["result"]]],[11,"borrow","","",113,[[["self"]],["t"]]],[11,"try_into","","",113,[[["self"]],["result"]]],[11,"borrow_mut","","",113,[[["self"]],["t"]]],[11,"get_type_id","","",113,[[["self"]],["typeid"]]],[11,"to_owned","","",114,[[["self"]],["t"]]],[11,"clone_into","","",114,N],[11,"from","","",114,[[["t"]],["t"]]],[11,"into","","",114,[[["self"]],["u"]]],[11,"try_from","","",114,[[["u"]],["result"]]],[11,"borrow","","",114,[[["self"]],["t"]]],[11,"try_into","","",114,[[["self"]],["result"]]],[11,"borrow_mut","","",114,[[["self"]],["t"]]],[11,"get_type_id","","",114,[[["self"]],["typeid"]]],[11,"to_owned","","",115,[[["self"]],["t"]]],[11,"clone_into","","",115,N],[11,"from","","",115,[[["t"]],["t"]]],[11,"into","","",115,[[["self"]],["u"]]],[11,"try_from","","",115,[[["u"]],["result"]]],[11,"borrow","","",115,[[["self"]],["t"]]],[11,"try_into","","",115,[[["self"]],["result"]]],[11,"borrow_mut","","",115,[[["self"]],["t"]]],[11,"get_type_id","","",115,[[["self"]],["typeid"]]],[11,"to_owned","","",116,[[["self"]],["t"]]],[11,"clone_into","","",116,N],[11,"from","","",116,[[["t"]],["t"]]],[11,"into","","",116,[[["self"]],["u"]]],[11,"try_from","","",116,[[["u"]],["result"]]],[11,"borrow","","",116,[[["self"]],["t"]]],[11,"try_into","","",116,[[["self"]],["result"]]],[11,"borrow_mut","","",116,[[["self"]],["t"]]],[11,"get_type_id","","",116,[[["self"]],["typeid"]]],[11,"to_owned","","",117,[[["self"]],["t"]]],[11,"clone_into","","",117,N],[11,"from","","",117,[[["t"]],["t"]]],[11,"into","","",117,[[["self"]],["u"]]],[11,"try_from","","",117,[[["u"]],["result"]]],[11,"borrow","","",117,[[["self"]],["t"]]],[11,"try_into","","",117,[[["self"]],["result"]]],[11,"borrow_mut","","",117,[[["self"]],["t"]]],[11,"get_type_id","","",117,[[["self"]],["typeid"]]],[11,"to_owned","","",118,[[["self"]],["t"]]],[11,"clone_into","","",118,N],[11,"from","","",118,[[["t"]],["t"]]],[11,"into","","",118,[[["self"]],["u"]]],[11,"try_from","","",118,[[["u"]],["result"]]],[11,"borrow","","",118,[[["self"]],["t"]]],[11,"try_into","","",118,[[["self"]],["result"]]],[11,"borrow_mut","","",118,[[["self"]],["t"]]],[11,"get_type_id","","",118,[[["self"]],["typeid"]]],[11,"to_owned","","",119,[[["self"]],["t"]]],[11,"clone_into","","",119,N],[11,"from","","",119,[[["t"]],["t"]]],[11,"into","","",119,[[["self"]],["u"]]],[11,"try_from","","",119,[[["u"]],["result"]]],[11,"borrow","","",119,[[["self"]],["t"]]],[11,"try_into","","",119,[[["self"]],["result"]]],[11,"borrow_mut","","",119,[[["self"]],["t"]]],[11,"get_type_id","","",119,[[["self"]],["typeid"]]],[11,"to_owned","","",120,[[["self"]],["t"]]],[11,"clone_into","","",120,N],[11,"from","","",120,[[["t"]],["t"]]],[11,"into","","",120,[[["self"]],["u"]]],[11,"try_from","","",120,[[["u"]],["result"]]],[11,"borrow","","",120,[[["self"]],["t"]]],[11,"try_into","","",120,[[["self"]],["result"]]],[11,"borrow_mut","","",120,[[["self"]],["t"]]],[11,"get_type_id","","",120,[[["self"]],["typeid"]]],[11,"to_owned","","",121,[[["self"]],["t"]]],[11,"clone_into","","",121,N],[11,"from","","",121,[[["t"]],["t"]]],[11,"into","","",121,[[["self"]],["u"]]],[11,"try_from","","",121,[[["u"]],["result"]]],[11,"borrow","","",121,[[["self"]],["t"]]],[11,"try_into","","",121,[[["self"]],["result"]]],[11,"borrow_mut","","",121,[[["self"]],["t"]]],[11,"get_type_id","","",121,[[["self"]],["typeid"]]],[11,"to_owned","","",122,[[["self"]],["t"]]],[11,"clone_into","","",122,N],[11,"from","","",122,[[["t"]],["t"]]],[11,"into","","",122,[[["self"]],["u"]]],[11,"try_from","","",122,[[["u"]],["result"]]],[11,"borrow","","",122,[[["self"]],["t"]]],[11,"try_into","","",122,[[["self"]],["result"]]],[11,"borrow_mut","","",122,[[["self"]],["t"]]],[11,"get_type_id","","",122,[[["self"]],["typeid"]]],[11,"to_owned","","",123,[[["self"]],["t"]]],[11,"clone_into","","",123,N],[11,"from","","",123,[[["t"]],["t"]]],[11,"into","","",123,[[["self"]],["u"]]],[11,"try_from","","",123,[[["u"]],["result"]]],[11,"borrow","","",123,[[["self"]],["t"]]],[11,"try_into","","",123,[[["self"]],["result"]]],[11,"borrow_mut","","",123,[[["self"]],["t"]]],[11,"get_type_id","","",123,[[["self"]],["typeid"]]],[11,"to_owned","","",124,[[["self"]],["t"]]],[11,"clone_into","","",124,N],[11,"from","","",124,[[["t"]],["t"]]],[11,"into","","",124,[[["self"]],["u"]]],[11,"try_from","","",124,[[["u"]],["result"]]],[11,"borrow","","",124,[[["self"]],["t"]]],[11,"try_into","","",124,[[["self"]],["result"]]],[11,"borrow_mut","","",124,[[["self"]],["t"]]],[11,"get_type_id","","",124,[[["self"]],["typeid"]]],[11,"to_owned","","",125,[[["self"]],["t"]]],[11,"clone_into","","",125,N],[11,"from","","",125,[[["t"]],["t"]]],[11,"into","","",125,[[["self"]],["u"]]],[11,"try_from","","",125,[[["u"]],["result"]]],[11,"borrow","","",125,[[["self"]],["t"]]],[11,"try_into","","",125,[[["self"]],["result"]]],[11,"borrow_mut","","",125,[[["self"]],["t"]]],[11,"get_type_id","","",125,[[["self"]],["typeid"]]],[11,"to_owned","","",126,[[["self"]],["t"]]],[11,"clone_into","","",126,N],[11,"from","","",126,[[["t"]],["t"]]],[11,"into","","",126,[[["self"]],["u"]]],[11,"try_from","","",126,[[["u"]],["result"]]],[11,"borrow","","",126,[[["self"]],["t"]]],[11,"try_into","","",126,[[["self"]],["result"]]],[11,"borrow_mut","","",126,[[["self"]],["t"]]],[11,"get_type_id","","",126,[[["self"]],["typeid"]]],[11,"to_owned","","",127,[[["self"]],["t"]]],[11,"clone_into","","",127,N],[11,"from","","",127,[[["t"]],["t"]]],[11,"into","","",127,[[["self"]],["u"]]],[11,"try_from","","",127,[[["u"]],["result"]]],[11,"borrow","","",127,[[["self"]],["t"]]],[11,"try_into","","",127,[[["self"]],["result"]]],[11,"borrow_mut","","",127,[[["self"]],["t"]]],[11,"get_type_id","","",127,[[["self"]],["typeid"]]],[11,"to_owned","","",128,[[["self"]],["t"]]],[11,"clone_into","","",128,N],[11,"from","","",128,[[["t"]],["t"]]],[11,"into","","",128,[[["self"]],["u"]]],[11,"try_from","","",128,[[["u"]],["result"]]],[11,"borrow","","",128,[[["self"]],["t"]]],[11,"try_into","","",128,[[["self"]],["result"]]],[11,"borrow_mut","","",128,[[["self"]],["t"]]],[11,"get_type_id","","",128,[[["self"]],["typeid"]]],[11,"to_owned","","",129,[[["self"]],["t"]]],[11,"clone_into","","",129,N],[11,"from","","",129,[[["t"]],["t"]]],[11,"into","","",129,[[["self"]],["u"]]],[11,"try_from","","",129,[[["u"]],["result"]]],[11,"borrow","","",129,[[["self"]],["t"]]],[11,"try_into","","",129,[[["self"]],["result"]]],[11,"borrow_mut","","",129,[[["self"]],["t"]]],[11,"get_type_id","","",129,[[["self"]],["typeid"]]],[11,"to_owned","","",130,[[["self"]],["t"]]],[11,"clone_into","","",130,N],[11,"from","","",130,[[["t"]],["t"]]],[11,"into","","",130,[[["self"]],["u"]]],[11,"try_from","","",130,[[["u"]],["result"]]],[11,"borrow","","",130,[[["self"]],["t"]]],[11,"try_into","","",130,[[["self"]],["result"]]],[11,"borrow_mut","","",130,[[["self"]],["t"]]],[11,"get_type_id","","",130,[[["self"]],["typeid"]]],[11,"from","","",131,[[["t"]],["t"]]],[11,"into","","",131,[[["self"]],["u"]]],[11,"try_from","","",131,[[["u"]],["result"]]],[11,"borrow","","",131,[[["self"]],["t"]]],[11,"try_into","","",131,[[["self"]],["result"]]],[11,"borrow_mut","","",131,[[["self"]],["t"]]],[11,"get_type_id","","",131,[[["self"]],["typeid"]]],[11,"from","","",136,[[["t"]],["t"]]],[11,"into","","",136,[[["self"]],["u"]]],[11,"try_from","","",136,[[["u"]],["result"]]],[11,"borrow","","",136,[[["self"]],["t"]]],[11,"try_into","","",136,[[["self"]],["result"]]],[11,"borrow_mut","","",136,[[["self"]],["t"]]],[11,"get_type_id","","",136,[[["self"]],["typeid"]]],[11,"from","","",137,[[["t"]],["t"]]],[11,"into","","",137,[[["self"]],["u"]]],[11,"try_from","","",137,[[["u"]],["result"]]],[11,"borrow","","",137,[[["self"]],["t"]]],[11,"try_into","","",137,[[["self"]],["result"]]],[11,"borrow_mut","","",137,[[["self"]],["t"]]],[11,"get_type_id","","",137,[[["self"]],["typeid"]]],[11,"from","","",138,[[["t"]],["t"]]],[11,"into","","",138,[[["self"]],["u"]]],[11,"try_from","","",138,[[["u"]],["result"]]],[11,"borrow","","",138,[[["self"]],["t"]]],[11,"try_into","","",138,[[["self"]],["result"]]],[11,"borrow_mut","","",138,[[["self"]],["t"]]],[11,"get_type_id","","",138,[[["self"]],["typeid"]]],[11,"from","","",139,[[["t"]],["t"]]],[11,"into","","",139,[[["self"]],["u"]]],[11,"try_from","","",139,[[["u"]],["result"]]],[11,"borrow","","",139,[[["self"]],["t"]]],[11,"try_into","","",139,[[["self"]],["result"]]],[11,"borrow_mut","","",139,[[["self"]],["t"]]],[11,"get_type_id","","",139,[[["self"]],["typeid"]]],[11,"from","","",140,[[["t"]],["t"]]],[11,"into","","",140,[[["self"]],["u"]]],[11,"try_from","","",140,[[["u"]],["result"]]],[11,"borrow","","",140,[[["self"]],["t"]]],[11,"try_into","","",140,[[["self"]],["result"]]],[11,"borrow_mut","","",140,[[["self"]],["t"]]],[11,"get_type_id","","",140,[[["self"]],["typeid"]]],[11,"from","","",141,[[["t"]],["t"]]],[11,"into","","",141,[[["self"]],["u"]]],[11,"try_from","","",141,[[["u"]],["result"]]],[11,"borrow","","",141,[[["self"]],["t"]]],[11,"try_into","","",141,[[["self"]],["result"]]],[11,"borrow_mut","","",141,[[["self"]],["t"]]],[11,"get_type_id","","",141,[[["self"]],["typeid"]]],[11,"is_some","libc::dox::imp","Returns `true` if the option is a [`Some`] value.",132,[[["self"]],["bool"]]],[11,"is_none","","Returns `true` if the option is a [`None`] value.",132,[[["self"]],["bool"]]],[11,"as_ref","","Converts from `Option<T>` to `Option<&T>`.",132,[[["self"]],["option"]]],[11,"as_mut","","Converts from `Option<T>` to `Option<&mut T>`.",132,[[["self"]],["option"]]],[11,"as_pin_mut","","Converts from `Option<T>` to `Option<PinMut<'_, T>>`",132,[[["pinmut",["option"]]],["option",["pinmut"]]]],[11,"expect","","Unwraps an option, yielding the content of a [`Some`].",132,[[["self"],["str"]],["t"]]],[11,"unwrap","","Moves the value `v` out of the `Option<T>` if it is [`Some(v)`].",132,[[["self"]],["t"]]],[11,"unwrap_or","","Returns the contained value or a default.",132,[[["self"],["t"]],["t"]]],[11,"unwrap_or_else","","Returns the contained value or computes it from a closure.",132,[[["self"],["f"]],["t"]]],[11,"map","","Maps an `Option<T>` to `Option<U>` by applying a function to a contained value.",132,[[["self"],["f"]],["option"]]],[11,"map_or","","Applies a function to the contained value (if any), or returns the provided default (if not).",132,[[["self"],["u"],["f"]],["u"]]],[11,"map_or_else","","Applies a function to the contained value (if any), or computes a default (if not).",132,[[["self"],["d"],["f"]],["u"]]],[11,"ok_or","","Transforms the `Option<T>` into a [`Result<T, E>`], mapping [`Some(v)`] to [`Ok(v)`] and [`None`] to [`Err(err)`].",132,[[["self"],["e"]],["result"]]],[11,"ok_or_else","","Transforms the `Option<T>` into a [`Result<T, E>`], mapping [`Some(v)`] to [`Ok(v)`] and [`None`] to [`Err(err())`].",132,[[["self"],["f"]],["result"]]],[11,"iter","","Returns an iterator over the possibly contained value.",132,[[["self"]],["iter"]]],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",132,[[["self"]],["itermut"]]],[11,"and","","Returns [`None`] if the option is [`None`], otherwise returns `optb`.",132,[[["self"],["option"]],["option"]]],[11,"and_then","","Returns [`None`] if the option is [`None`], otherwise calls `f` with the wrapped value and returns the result.",132,[[["self"],["f"]],["option"]]],[11,"filter","","Returns `None` if the option is `None`, otherwise calls `predicate` with the wrapped value and returns:",132,[[["self"],["p"]],["option"]]],[11,"or","","Returns the option if it contains a value, otherwise returns `optb`.",132,[[["self"],["option"]],["option"]]],[11,"or_else","","Returns the option if it contains a value, otherwise calls `f` and returns the result.",132,[[["self"],["f"]],["option"]]],[11,"xor","","Returns [`Some`] if exactly one of `self`, `optb` is [`Some`], otherwise returns `None`.",132,[[["self"],["option"]],["option"]]],[11,"get_or_insert","","Inserts `v` into the option if it is [`None`], then returns a mutable reference to the contained value.",132,[[["self"],["t"]],["t"]]],[11,"get_or_insert_with","","Inserts a value computed from `f` into the option if it is [`None`], then returns a mutable reference to the contained value.",132,[[["self"],["f"]],["t"]]],[11,"take","","Takes the value out of the option, leaving a [`None`] in its place.",132,[[["self"]],["option"]]],[11,"replace","","Replaces the actual value in the option by the value given in parameter, returning the old value if present, leaving a [`Some`] in its place without deinitializing either one.",132,[[["self"],["t"]],["option"]]],[11,"cloned","","Maps an `Option<&T>` to an `Option<T>` by cloning the contents of the option.",132,[[["self"]],["option"]]],[11,"cloned","","Maps an `Option<&mut T>` to an `Option<T>` by cloning the contents of the option.",132,[[["self"]],["option"]]],[11,"unwrap_or_default","","Returns the contained value or a default",132,[[["self"]],["t"]]],[11,"deref","","Converts from `&Option<T>` to `Option<&T::Target>`.",132,[[["self"]],["option"]]],[11,"transpose","","Transposes an `Option` of a `Result` into a `Result` of an `Option`.",132,[[["self"]],["result",["option"]]]],[11,"to_owned","","",132,[[["self"]],["t"]]],[11,"clone_into","","",132,N],[11,"from","","",132,[[["t"]],["t"]]],[11,"into_iter","","",132,[[["self"]],["i"]]],[11,"into","","",132,[[["self"]],["u"]]],[11,"try_from","","",132,[[["u"]],["result"]]],[11,"borrow","","",132,[[["self"]],["t"]]],[11,"try_into","","",132,[[["self"]],["result"]]],[11,"borrow_mut","","",132,[[["self"]],["t"]]],[11,"get_type_id","","",132,[[["self"]],["typeid"]]],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",132,[[["self"]],["intoiter"]]],[11,"hash","libc::dox::imp::mem","",134,N],[11,"hash","libc::dox::imp","",132,N],[11,"hash","libc::dox::imp::mem","",135,N],[11,"clone","libc::dox::imp","",132,[[["self"]],["option"]]],[11,"clone","libc::dox::imp::mem","",135,[[["self"]],["manuallydrop"]]],[11,"clone","","",134,[[["self"]],["discriminant"]]],[11,"partial_cmp","","",135,[[["self"],["manuallydrop"]],["option",["ordering"]]]],[11,"lt","","",135,[[["self"],["manuallydrop"]],["bool"]]],[11,"le","","",135,[[["self"],["manuallydrop"]],["bool"]]],[11,"gt","","",135,[[["self"],["manuallydrop"]],["bool"]]],[11,"ge","","",135,[[["self"],["manuallydrop"]],["bool"]]],[11,"partial_cmp","libc::dox::imp","",132,[[["self"],["option"]],["option",["ordering"]]]],[11,"lt","","",132,[[["self"],["option"]],["bool"]]],[11,"le","","",132,[[["self"],["option"]],["bool"]]],[11,"gt","","",132,[[["self"],["option"]],["bool"]]],[11,"ge","","",132,[[["self"],["option"]],["bool"]]],[11,"cmp","","",132,[[["self"],["option"]],["ordering"]]],[11,"cmp","libc::dox::imp::mem","",135,[[["self"],["manuallydrop"]],["ordering"]]],[11,"fmt","","",135,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","libc::dox::imp","",132,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","libc::dox::imp::mem","",134,[[["self"],["formatter"]],["result",["error"]]]],[11,"assert_receiver_is_total_eq","libc::dox::imp","",132,N],[11,"assert_receiver_is_total_eq","libc::dox::imp::mem","",135,N],[11,"eq","","",134,[[["self"],["discriminant"]],["bool"]]],[11,"eq","libc::dox::imp","",132,[[["self"],["option"]],["bool"]]],[11,"ne","","",132,[[["self"],["option"]],["bool"]]],[11,"eq","libc::dox::imp::mem","",135,[[["self"],["manuallydrop"]],["bool"]]],[11,"ne","","",135,[[["self"],["manuallydrop"]],["bool"]]],[11,"from","libc::dox::imp","",132,[[["option"]],["option"]]],[11,"from","","",132,[[["t"]],["option"]]],[11,"from","","",132,[[["option"]],["option"]]],[11,"from_iter","","Takes each element in the [`Iterator`]: if it is [`None`][Option::None], no further elements are taken, and the [`None`][Option::None] is returned. Should no [`None`][Option::None] occur, a container with the values of each [`Option`] is returned.",132,[[["i"]],["option"]]],[11,"into_result","","",132,[[["self"]],["result",["noneerror"]]]],[11,"from_ok","","",132,[[["t"]],["option"]]],[11,"from_error","","",132,[[["noneerror"]],["option"]]],[11,"deref_mut","libc::dox::imp::mem","",135,N],[11,"default","","",135,[[],["manuallydrop"]]],[11,"default","libc::dox::imp","Returns [`None`][Option::None].",132,[[],["option"]]],[11,"deref","libc::dox::imp::mem","",135,N],[11,"to_owned","","",134,[[["self"]],["t"]]],[11,"clone_into","","",134,N],[11,"from","","",134,[[["t"]],["t"]]],[11,"into","","",134,[[["self"]],["u"]]],[11,"try_from","","",134,[[["u"]],["result"]]],[11,"borrow","","",134,[[["self"]],["t"]]],[11,"try_into","","",134,[[["self"]],["result"]]],[11,"borrow_mut","","",134,[[["self"]],["t"]]],[11,"get_type_id","","",134,[[["self"]],["typeid"]]],[11,"new","","Wrap a value to be manually dropped.",135,[[["t"]],["manuallydrop"]]],[11,"into_inner","","Extract the value from the `ManuallyDrop` container.",135,[[["manuallydrop"]],["t"]]],[11,"drop","","Manually drops the contained value.",135,N],[11,"to_owned","","",135,[[["self"]],["t"]]],[11,"clone_into","","",135,N],[11,"from","","",135,[[["t"]],["t"]]],[11,"into","","",135,[[["self"]],["u"]]],[11,"try_from","","",135,[[["u"]],["result"]]],[11,"borrow","","",135,[[["self"]],["t"]]],[11,"try_into","","",135,[[["self"]],["result"]]],[11,"borrow_mut","","",135,[[["self"]],["t"]]],[11,"get_type_id","","",135,[[["self"]],["typeid"]]]],"paths":[[3,"group"],[3,"utimbuf"],[3,"timeval"],[3,"timespec"],[3,"rlimit"],[3,"rusage"],[3,"in_addr"],[3,"in6_addr"],[3,"ip_mreq"],[3,"ipv6_mreq"],[3,"hostent"],[3,"iovec"],[3,"pollfd"],[3,"winsize"],[3,"linger"],[3,"sigval"],[3,"itimerval"],[3,"tms"],[3,"servent"],[3,"protoent"],[3,"sockaddr"],[3,"sockaddr_in"],[3,"sockaddr_in6"],[3,"sockaddr_un"],[3,"sockaddr_storage"],[3,"addrinfo"],[3,"sockaddr_nl"],[3,"sockaddr_ll"],[3,"fd_set"],[3,"tm"],[3,"sched_param"],[3,"Dl_info"],[3,"epoll_event"],[3,"utsname"],[3,"lconv"],[3,"sigevent"],[3,"in_pktinfo"],[3,"ifaddrs"],[3,"in6_rtmsg"],[3,"arpreq"],[3,"arpreq_old"],[3,"arphdr"],[3,"dirent"],[3,"dirent64"],[3,"rlimit64"],[3,"glob_t"],[3,"pthread_mutex_t"],[3,"pthread_rwlock_t"],[3,"pthread_mutexattr_t"],[3,"pthread_rwlockattr_t"],[3,"pthread_cond_t"],[3,"pthread_condattr_t"],[3,"passwd"],[3,"spwd"],[3,"dqblk"],[3,"signalfd_siginfo"],[3,"itimerspec"],[3,"fsid_t"],[3,"mq_attr"],[3,"packet_mreq"],[3,"cpu_set_t"],[3,"if_nameindex"],[3,"msginfo"],[3,"mmsghdr"],[3,"sembuf"],[3,"input_event"],[3,"input_id"],[3,"input_absinfo"],[3,"input_keymap_entry"],[3,"input_mask"],[3,"ff_replay"],[3,"ff_trigger"],[3,"ff_envelope"],[3,"ff_constant_effect"],[3,"ff_ramp_effect"],[3,"ff_condition_effect"],[3,"ff_periodic_effect"],[3,"ff_rumble_effect"],[3,"ff_effect"],[3,"dl_phdr_info"],[3,"Elf32_Phdr"],[3,"Elf64_Phdr"],[3,"ucred"],[3,"mntent"],[3,"posix_spawn_file_actions_t"],[3,"posix_spawnattr_t"],[3,"genlmsghdr"],[3,"in6_pktinfo"],[3,"arpd_request"],[3,"aiocb"],[3,"__exit_status"],[3,"__timeval"],[3,"utmpx"],[3,"sigaction"],[3,"stack_t"],[3,"siginfo_t"],[3,"glob64_t"],[3,"statfs"],[3,"msghdr"],[3,"cmsghdr"],[3,"termios"],[3,"flock"],[3,"sem_t"],[3,"mallinfo"],[3,"nlmsghdr"],[3,"nlmsgerr"],[3,"nl_pktinfo"],[3,"nl_mmap_req"],[3,"nl_mmap_hdr"],[3,"nlattr"],[3,"rtentry"],[3,"sigset_t"],[3,"sysinfo"],[3,"msqid_ds"],[3,"stat"],[3,"stat64"],[3,"statfs64"],[3,"statvfs64"],[3,"pthread_attr_t"],[3,"_libc_fpxreg"],[3,"_libc_xmmreg"],[3,"_libc_fpstate"],[3,"user_fpregs_struct"],[3,"user_regs_struct"],[3,"user"],[3,"mcontext_t"],[3,"ucontext_t"],[3,"ipc_perm"],[3,"shmid_ds"],[3,"termios2"],[3,"statvfs"],[4,"c_void"],[4,"Option"],[8,"Clone"],[3,"Discriminant"],[3,"ManuallyDrop"],[4,"FILE"],[4,"fpos_t"],[4,"DIR"],[4,"locale_t"],[4,"timezone"],[4,"fpos64_t"]]};
searchIndex["macro_utils"]={"doc":"Some useful and funny macros.","items":[[0,"if_match","macro_utils","",N,N],[0,"tern_c","","",N,N],[0,"tern_haskell","","",N,N],[0,"tern_python","","",N,N],[14,"if_match","","A macro to make big else if conditions easier to read:",N,N],[14,"tern_c","","You miss C-like ternary conditions? Why not having them in Rust then?",N,N],[14,"tern_haskell","","You miss Haskell-like ternary conditions? Why not having them in Rust then?",N,N],[14,"tern_python","","You miss Python-like ternary conditions? Why not having them in Rust then?",N,N],[14,"tern_py","","The same as [`tern_python`] macro but shorter:",N,N]],"paths":[]};
searchIndex["minifier"]={"doc":"","items":[[0,"css","minifier","",N,N],[5,"minify","minifier::css","Minifies a given CSS source code.",N,[[["str"]],["result",["string","str"]]]],[0,"token","","",N,N],[3,"Tokens","minifier::css::token","",N,N],[12,"0","","",0,N],[4,"ReservedChar","","",N,N],[13,"Comma","","",1,N],[13,"SuperiorThan","","",1,N],[13,"OpenParenthese","","",1,N],[13,"CloseParenthese","","",1,N],[13,"OpenCurlyBrace","","",1,N],[13,"CloseCurlyBrace","","",1,N],[13,"OpenBracket","","",1,N],[13,"CloseBracket","","",1,N],[13,"Colon","","",1,N],[13,"SemiColon","","",1,N],[13,"Slash","","",1,N],[13,"Plus","","",1,N],[13,"EqualSign","","",1,N],[13,"Space","","",1,N],[13,"Tab","","",1,N],[13,"Backline","","",1,N],[13,"Star","","",1,N],[13,"Quote","","",1,N],[13,"DoubleQuote","","",1,N],[13,"Pipe","","",1,N],[13,"Tilde","","",1,N],[13,"Dollar","","",1,N],[13,"Circumflex","","",1,N],[4,"SelectorElement","","",N,N],[13,"PseudoClass","","",2,N],[13,"Class","","",2,N],[13,"Id","","",2,N],[13,"Tag","","",2,N],[13,"Media","","",2,N],[4,"SelectorOperator","","",N,N],[13,"OneAttributeEquals","","`~=`",3,N],[13,"EqualsOrStartsWithFollowedByDash","","`|=`",3,N],[13,"EndsWith","","`$=`",3,N],[13,"FirstStartsWith","","`^=`",3,N],[13,"Contains","","`*=`",3,N],[4,"Token","","",N,N],[13,"Comment","","Comment.",4,N],[13,"License","","Comment starting with `/**`.",4,N],[13,"Char","","",4,N],[13,"Other","","",4,N],[13,"SelectorElement","","",4,N],[13,"String","","",4,N],[13,"SelectorOperator","","",4,N],[5,"get_line_comment","","",N,[[["str"],["peekable"],["usize"]],["option",["token"]]]],[5,"get_comment","","",N,[[["str"],["peekable"],["usize"]],["option",["token"]]]],[5,"get_string","","",N,[[["str"],["peekable"],["usize"],["reservedchar"]],["option",["token"]]]],[5,"fill_other","","",N,[[["str"],["vec"],["usize"],["usize"],["isize"],["bool"],["bool"]]]],[5,"tokenize","","",N,[[["str"]],["result",["tokens","str"]]]],[5,"clean_tokens","","",N,[[["vec",["token"]]],["vec",["token"]]]],[8,"MyTryFrom","","",N,N],[16,"Error","","",5,N],[10,"try_from","","",5,[[["t"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"eq","","",1,[[["self"],["reservedchar"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1,N],[11,"clone","","",1,[[["self"]],["reservedchar"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",1,[[["char"]],["result",["reservedchar"]]]],[11,"is_useless","","",1,[[["self"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"eq","","",2,[[["self"],["selectorelement"]],["bool"]]],[11,"ne","","",2,[[["self"],["selectorelement"]],["bool"]]],[11,"clone","","",2,[[["self"]],["selectorelement"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",2,[[["str"]],["result",["selectorelement"]]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"eq","","",3,[[["self"],["selectoroperator"]],["bool"]]],[11,"clone","","",3,[[["self"]],["selectoroperator"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"eq","","",4,[[["self"],["token"]],["bool"]]],[11,"ne","","",4,[[["self"],["token"]],["bool"]]],[11,"clone","","",4,[[["self"]],["token"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"is_comment","","",4,[[["self"]],["bool"]]],[11,"is_char","","",4,[[["self"]],["bool"]]],[11,"get_char","","",4,[[["self"]],["option",["reservedchar"]]]],[11,"is_useless","","",4,[[["self"]],["bool"]]],[11,"is_media","","",4,[[["self"],["str"]],["bool"]]],[11,"is_a_media","","",4,[[["self"]],["bool"]]],[11,"is_a_license","","",4,[[["self"]],["bool"]]],[11,"eq","","",4,[[["self"],["reservedchar"]],["bool"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"eq","","",0,[[["self"],["tokens"]],["bool"]]],[11,"ne","","",0,[[["self"],["tokens"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"clone","","",0,[[["self"]],["tokens"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[0,"css","minifier::css","",N,N],[5,"minify","minifier::css::css","Minifies a given CSS source code.",N,[[["str"]],["result",["string","str"]]]],[0,"js","minifier","",N,N],[4,"Keyword","minifier::js","",N,N],[13,"Break","","",6,N],[13,"Case","","",6,N],[13,"Catch","","",6,N],[13,"Const","","",6,N],[13,"Continue","","",6,N],[13,"Default","","",6,N],[13,"Do","","",6,N],[13,"Else","","",6,N],[13,"False","","",6,N],[13,"Finally","","",6,N],[13,"Function","","",6,N],[13,"For","","",6,N],[13,"If","","",6,N],[13,"In","","",6,N],[13,"InstanceOf","","",6,N],[13,"New","","",6,N],[13,"Null","","",6,N],[13,"Private","","",6,N],[13,"Protected","","",6,N],[13,"Public","","",6,N],[13,"Return","","",6,N],[13,"Switch","","",6,N],[13,"This","","",6,N],[13,"Throw","","",6,N],[13,"True","","",6,N],[13,"Try","","",6,N],[13,"Typeof","","",6,N],[13,"Static","","",6,N],[13,"Var","","",6,N],[13,"While","","",6,N],[5,"minify","","Minifies a given JS source code.",N,[[["str"]],["string"]]],[5,"minify_and_replace_keywords","","Minifies a given JS source code and to replace keywords.",N,N],[0,"token","","",N,N],[3,"Tokens","minifier::js::token","",N,N],[12,"0","","",7,N],[4,"ReservedChar","","",N,N],[13,"Comma","","",8,N],[13,"OpenParenthese","","",8,N],[13,"CloseParenthese","","",8,N],[13,"OpenCurlyBrace","","",8,N],[13,"CloseCurlyBrace","","",8,N],[13,"OpenBracket","","",8,N],[13,"CloseBracket","","",8,N],[13,"Colon","","",8,N],[13,"SemiColon","","",8,N],[13,"Dot","","",8,N],[13,"Quote","","",8,N],[13,"DoubleQuote","","",8,N],[13,"ExclamationMark","","",8,N],[13,"QuestionMark","","",8,N],[13,"Slash","","",8,N],[13,"Modulo","","",8,N],[13,"Star","","",8,N],[13,"Minus","","",8,N],[13,"Plus","","",8,N],[13,"EqualSign","","",8,N],[13,"Backslash","","",8,N],[13,"Space","","",8,N],[13,"Tab","","",8,N],[13,"Backline","","",8,N],[13,"LessThan","","",8,N],[13,"SuperiorThan","","",8,N],[13,"Pipe","","",8,N],[13,"Ampersand","","",8,N],[4,"Keyword","","",N,N],[13,"Break","","",6,N],[13,"Case","","",6,N],[13,"Catch","","",6,N],[13,"Const","","",6,N],[13,"Continue","","",6,N],[13,"Default","","",6,N],[13,"Do","","",6,N],[13,"Else","","",6,N],[13,"False","","",6,N],[13,"Finally","","",6,N],[13,"Function","","",6,N],[13,"For","","",6,N],[13,"If","","",6,N],[13,"In","","",6,N],[13,"InstanceOf","","",6,N],[13,"New","","",6,N],[13,"Null","","",6,N],[13,"Private","","",6,N],[13,"Protected","","",6,N],[13,"Public","","",6,N],[13,"Return","","",6,N],[13,"Switch","","",6,N],[13,"This","","",6,N],[13,"Throw","","",6,N],[13,"True","","",6,N],[13,"Try","","",6,N],[13,"Typeof","","",6,N],[13,"Static","","",6,N],[13,"Var","","",6,N],[13,"While","","",6,N],[4,"Condition","","",N,N],[13,"And","","",9,N],[13,"Or","","",9,N],[13,"DifferentThan","","",9,N],[13,"SuperDifferentThan","","",9,N],[13,"EqualTo","","",9,N],[13,"SuperEqualTo","","",9,N],[13,"SuperiorThan","","",9,N],[13,"SuperiorOrEqualTo","","",9,N],[13,"InferiorThan","","",9,N],[13,"InferiorOrEqualTo","","",9,N],[4,"Operation","","",N,N],[13,"Addition","","",10,N],[13,"AdditionEqual","","",10,N],[13,"Subtract","","",10,N],[13,"SubtractEqual","","",10,N],[13,"Multiply","","",10,N],[13,"MultiplyEqual","","",10,N],[13,"Divide","","",10,N],[13,"DivideEqual","","",10,N],[13,"Modulo","","",10,N],[13,"ModuloEqual","","",10,N],[13,"Equal","","",10,N],[4,"Token","","",N,N],[13,"Keyword","","",11,N],[13,"Char","","",11,N],[13,"String","","",11,N],[13,"Comment","","",11,N],[13,"License","","",11,N],[13,"Other","","",11,N],[13,"Regex","","",11,N],[12,"regex","minifier::js::token::Token","",11,N],[12,"is_global","","",11,N],[12,"is_interactive","","",11,N],[13,"Condition","minifier::js::token","",11,N],[13,"Operation","","",11,N],[5,"get_required","","",N,[[["token"]],["option",["char"]]]],[5,"get_line_comment","","",N,[[["str"],["peekable"],["usize"]],["option",["token"]]]],[5,"get_regex","","",N,[[["str"],["peekable"],["usize"]],["option",["token"]]]],[5,"get_comment","","",N,[[["str"],["peekable"],["usize"]],["option",["token"]]]],[5,"get_string","","",N,[[["str"],["peekable"],["usize"],["reservedchar"]],["option",["token"]]]],[5,"first_useful","","",N,N],[5,"fill_other","","",N,[[["str"],["vec"],["usize"],["usize"]]]],[5,"handle_equal_sign","","",N,[[["vec"],["reservedchar"]],["bool"]]],[5,"tokenize","","",N,[[["str"]],["tokens"]]],[5,"clean_tokens","","",N,[[["tokens"]]]],[8,"MyTryFrom","","",N,N],[16,"Error","","",12,N],[10,"try_from","","",12,[[["t"]],["result"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"eq","","",8,[[["self"],["reservedchar"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",8,N],[11,"clone","","",8,[[["self"]],["reservedchar"]]],[11,"is_useless","","",8,[[["self"]],["bool"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",8,[[["char"]],["result",["reservedchar"]]]],[11,"fmt","minifier::js","",6,[[["self"],["formatter"]],["result"]]],[11,"eq","","",6,[[["self"],["keyword"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",6,N],[11,"clone","","",6,[[["self"]],["keyword"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",6,[[["str"]],["result",["keyword"]]]],[11,"fmt","minifier::js::token","",9,[[["self"],["formatter"]],["result"]]],[11,"eq","","",9,[[["self"],["condition"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"clone","","",9,[[["self"]],["condition"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",9,[[["reservedchar"]],["result",["condition"]]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"eq","","",10,[[["self"],["operation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"clone","","",10,[[["self"]],["operation"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"try_from","","",10,[[["reservedchar"]],["result",["operation"]]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"eq","","",11,[[["self"],["token"]],["bool"]]],[11,"ne","","",11,[[["self"],["token"]],["bool"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"is_comment","","",11,[[["self"]],["bool"]]],[11,"get_char","","",11,[[["self"]],["option",["reservedchar"]]]],[11,"is_char","","",11,[[["self"],["reservedchar"]],["bool"]]],[11,"is_operation","","",11,[[["self"],["operation"]],["bool"]]],[11,"is_condition","","",11,[[["self"],["condition"]],["bool"]]],[11,"is_other","","",11,[[["self"]],["bool"]]],[11,"is_white_character","","",11,[[["self"]],["bool"]]],[11,"get_keyword","","",11,[[["self"]],["option",["keyword"]]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"eq","","",7,[[["self"],["tokens"]],["bool"]]],[11,"ne","","",7,[[["self"],["tokens"]],["bool"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[0,"js","minifier::js","",N,N],[5,"minify","minifier::js::js","Minifies a given JS source code.",N,[[["str"]],["string"]]],[5,"minify_and_replace_keywords","","Minifies a given JS source code and to replace keywords.",N,N],[0,"json","minifier","",N,N],[5,"minify","minifier::json","Minifies a given String by JSON minification rules",N,[[["str"]],["string"]]],[5,"minify_from_read","","Minifies a given Read by JSON minification rules",N,[[["r"]],["jsonread"]]],[0,"read","","",N,N],[0,"byte_to_char","minifier::json::read","",N,N],[3,"ByteToChar","minifier::json::read::byte_to_char","",N,N],[12,"iter","","",13,N],[4,"CharsError","","An enumeration of possible errors that can be generated from the `Chars` adapter.",N,N],[13,"NotUtf8","","Variant representing that the underlying stream was read successfully but it did not contain valid utf8 data.",14,N],[13,"Other","","Variant representing that an I/O error occurred.",14,N],[5,"utf8_char_width","","",N,[[["u8"]],["usize"]]],[7,"UTF8_CHAR_WIDTH","","",N,N],[11,"new","","",13,[[["r"],["usize"]],["result",["error"]]]],[11,"get_next","","",13,[[["self"]],["result",["option","charserror"]]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"next","","",13,[[["self"]],["option",["result"]]]],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"description","","",14,[[["self"]],["str"]]],[11,"cause","","",14,[[["self"]],["option",["error"]]]],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[0,"internal_buffer","minifier::json::read","",N,N],[3,"Buffer","minifier::json::read::internal_buffer","",N,N],[12,"buffer","","",15,N],[12,"read_pos","","",15,N],[12,"buffer_size","","",15,N],[12,"data_size","","",15,N],[17,"ARRAY_DEFAULT","","",N,N],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"new","","",15,[[["usize"]],["buffer"]]],[11,"as_mut","","",15,N],[11,"update_metadata","","",15,[[["self"],["usize"]]]],[11,"next","","",15,[[["self"]],["option",["u8"]]]],[11,"cont","","",15,[[["self"]],["bool"]]],[0,"internal_reader","minifier::json::read","",N,N],[3,"InternalReader","minifier::json::read::internal_reader","",N,N],[12,"read","","",16,N],[12,"buffer_size","","",16,N],[12,"buffer","","",16,N],[11,"new","","",16,[[["r"],["usize"]],["result",["error"]]]],[11,"read_data","","",16,[[["r"],["buffer"]],["result",["error"]]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"next","","",16,[[["self"]],["option",["result"]]]],[0,"json_read","minifier::json::read","",N,N],[3,"JsonRead","minifier::json::read::json_read","",N,N],[12,"minifier","","",17,N],[12,"read","","",17,N],[12,"iter","","",17,N],[12,"predicate","","",17,N],[12,"initialized","","",17,N],[12,"item_iter","","",17,N],[12,"item1","","",17,N],[11,"new","","",17,[[["r"],["p"]],["self"]]],[11,"get_next","","",17,[[["self"]],["result",["option","charserror"]]]],[11,"add_char_to_buffer","","",17,N],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"read","","",17,N],[0,"json_minifier","minifier::json","",N,N],[3,"JsonMinifier","minifier::json::json_minifier","",N,N],[12,"is_string","","",18,N],[12,"escaped_quotation","","",18,N],[5,"keep_element","","",N,[[["jsonminifier"],["char"],["option",["char"]]],["bool"]]],[5,"is_whitespace_outside_string","","",N,[[["jsonminifier"],["char"],["option",["char"]]],["bool"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"default","","",18,[[],["self"]]],[11,"new","","",18,[[],["self"]]],[0,"string","minifier::json","",N,N],[3,"JsonMultiFilter","minifier::json::string","",N,N],[12,"minifier","","",19,N],[12,"iter","","",19,N],[12,"predicate","","",19,N],[12,"initialized","","",19,N],[12,"item1","","",19,N],[11,"new","","",19,[[["i"],["p"]],["self"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"next","","",19,[[["self"]],["option"]]],[6,"JsonMethod","minifier::json","",N,N],[11,"to_owned","minifier::css::token","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"to_string","","",0,[[["self"]],["string"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"to_string","","",1,[[["self"]],["string"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"to_string","","",2,[[["self"]],["string"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"to_string","","",3,[[["self"]],["string"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"to_string","","",4,[[["self"]],["string"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"to_owned","minifier::js","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"to_string","","",6,[[["self"]],["string"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"from","minifier::js::token","",7,[[["t"]],["t"]]],[11,"to_string","","",7,[[["self"]],["string"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"to_string","","",8,[[["self"]],["string"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"to_string","","",9,[[["self"]],["string"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"to_string","","",10,[[["self"]],["string"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"from","","",11,[[["t"]],["t"]]],[11,"to_string","","",11,[[["self"]],["string"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"from","minifier::json::read::byte_to_char","",13,[[["t"]],["t"]]],[11,"into_iter","","",13,[[["self"]],["i"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"from","","",14,[[["t"]],["t"]]],[11,"to_string","","",14,[[["self"]],["string"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"from","minifier::json::read::internal_buffer","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"from","minifier::json::read::internal_reader","",16,[[["t"]],["t"]]],[11,"into_iter","","",16,[[["self"]],["i"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"from","minifier::json::read::json_read","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"from","minifier::json::json_minifier","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"from","minifier::json::string","",19,[[["t"]],["t"]]],[11,"into_iter","","",19,[[["self"]],["i"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]]],"paths":[[3,"Tokens"],[4,"ReservedChar"],[4,"SelectorElement"],[4,"SelectorOperator"],[4,"Token"],[8,"MyTryFrom"],[4,"Keyword"],[3,"Tokens"],[4,"ReservedChar"],[4,"Condition"],[4,"Operation"],[4,"Token"],[8,"MyTryFrom"],[3,"ByteToChar"],[4,"CharsError"],[3,"Buffer"],[3,"InternalReader"],[3,"JsonRead"],[3,"JsonMinifier"],[3,"JsonMultiFilter"]]};
searchIndex["proc_macro"]={"doc":"A support library for macro authors when defining new macros.","items":[[3,"Diagnostic","proc_macro","A structure representing a diagnostic message and associated children messages.",N,N],[12,"level","","",0,N],[12,"message","","",0,N],[12,"spans","","",0,N],[12,"children","","",0,N],[3,"TokenStream","","The main type provided by this crate, representing an abstract stream of tokens, or, more specifically, a sequence of token trees. The type provide interfaces for iterating over those token trees and, conversely, collecting a number of token trees into one stream.",N,N],[12,"0","","",1,N],[3,"LexError","","Error returned from `TokenStream::from_str`.",N,N],[12,"_inner","","",2,N],[3,"Span","","A region of source code, along with macro expansion information.",N,N],[12,"0","","",3,N],[3,"LineColumn","","A line-column pair representing the start or end of a `Span`.",N,N],[12,"line","","The 1-indexed line in the source file on which the span starts or ends (inclusive).",4,N],[12,"column","","The 0-indexed column (in UTF-8 characters) in the source file on which the span starts or ends (inclusive).",4,N],[3,"SourceFile","","The source file of a given `Span`.",N,N],[12,"source_file","","",5,N],[3,"Group","","A delimited token stream.",N,N],[12,"delimiter","","",6,N],[12,"stream","","",6,N],[12,"span","","",6,N],[3,"Punct","","An `Punct` is an single punctuation character like `+`, `-` or `#`.",N,N],[12,"ch","","",7,N],[12,"spacing","","",7,N],[12,"span","","",7,N],[3,"Ident","","An identifier (`ident`).",N,N],[12,"sym","","",8,N],[12,"span","","",8,N],[12,"is_raw","","",8,N],[3,"Literal","","A literal string (`\"hello\"`), byte string (`b\"hello\"`), character (`'a'`), byte character (`b'a'`), an integer or floating point number with or without a suffix (`1`, `1u8`, `2.3`, `2.3f32`). Boolean literals like `true` and `false` do not belong here, they are `Ident`s.",N,N],[12,"lit","","",9,N],[12,"suffix","","",9,N],[12,"span","","",9,N],[4,"Level","","An enum representing a diagnostic level.",N,N],[13,"Error","","An error.",10,N],[13,"Warning","","A warning.",10,N],[13,"Note","","A note.",10,N],[13,"Help","","A help message.",10,N],[4,"TokenTree","","A single token or a delimited sequence of token trees (e.g. `[1, (), ..]`).",N,N],[13,"Group","","A token stream surrounded by bracket delimiters.",11,N],[13,"Ident","","An identifier.",11,N],[13,"Punct","","A single punctuation character (`+`, `,`, `$`, etc.).",11,N],[13,"Literal","","A literal character (`'a'`), string (`\"hello\"`), number (`2.3`), etc.",11,N],[4,"Delimiter","","Describes how a sequence of token trees is delimited.",N,N],[13,"Parenthesis","","`( ... )`",12,N],[13,"Brace","","`{ ... }`",12,N],[13,"Bracket","","`[ ... ]`",12,N],[13,"None","","`Ø ... Ø` An implicit delimiter, that may, for example, appear around tokens coming from a \"macro variable\" `$var`. It is important to preserve operator priorities in cases like `$var * 3` where `$var` is `1 + 2`. Implicit delimiters may not survive roundtrip of a token stream through a string.",12,N],[4,"Spacing","","Whether an `Punct` is followed immediately by another `Punct` or followed by another token or whitespace.",N,N],[13,"Alone","","E.g. `+` is `Alone` in `+ =`, `+ident` or `+()`.",13,N],[13,"Joint","","E.g. `+` is `Joint` in `+=` or `'#`. Additionally, single quote `'` can join with identifiers to form lifetimes `'ident`.",13,N],[5,"quote","","Quote a `TokenStream` into a `TokenStream`. This is the actual `quote!()` proc macro.",N,[[["tokenstream"]],["tokenstream"]]],[5,"quote_span","","Quote a `Span` into a `TokenStream`. This is needed to implement a custom quoter.",N,[[["span"]],["tokenstream"]]],[5,"parse_to_lex_err","","",N,[[["diagnosticbuilder"]],["lexerror"]]],[0,"rustc","","",N,N],[11,"new_maybe_raw","","",8,[[["str"],["span"],["bool"]],["ident"]]],[11,"from_internal","","",12,[[["delimtoken"]],["delimiter"]]],[11,"to_internal","","",12,[[["self"]],["delimtoken"]]],[11,"from_internal","","",11,[[["tokenstream"],["vec"]],["tokentree"]]],[11,"to_internal","","",11,[[["self"]],["tokenstream"]]],[11,"to_internal","","",10,[[["self"]],["level"]]],[0,"diagnostic","","",N,N],[3,"Diagnostic","proc_macro::diagnostic","A structure representing a diagnostic message and associated children messages.",N,N],[12,"level","","",0,N],[12,"message","","",0,N],[12,"spans","","",0,N],[12,"children","","",0,N],[3,"Children","","Iterator over the children diagnostics of a `Diagnostic`.",N,N],[12,"0","","",14,N],[4,"Level","","An enum representing a diagnostic level.",N,N],[13,"Error","","An error.",10,N],[13,"Warning","","A warning.",10,N],[13,"Note","","A note.",10,N],[13,"Help","","A help message.",10,N],[8,"MultiSpan","","Trait implemented by types that can be converted into a set of `Span`s.",N,N],[10,"into_spans","","Converts `self` into a `Vec<Span>`.",15,[[["self"]],["vec",["span"]]]],[11,"clone","proc_macro","",10,[[["self"]],["level"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"into_spans","","",3,[[["self"]],["vec",["span"]]]],[11,"clone","","",0,[[["self"]],["diagnostic"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","proc_macro::diagnostic","",14,[[["self"],["formatter"]],["result"]]],[11,"clone","","",14,[[["self"]],["children"]]],[11,"next","","",14,[[["self"]],["option"]]],[11,"new","proc_macro","Create a new diagnostic with the given `level` and `message`.",0,[[["level"],["t"]],["diagnostic"]]],[11,"spanned","","Create a new diagnostic with the given `level` and `message` pointing to the given set of `spans`.",0,[[["s"],["level"],["t"]],["diagnostic"]]],[11,"span_error","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `spans` and `message`.",0,[[["self"],["s"],["t"]],["diagnostic"]]],[11,"error","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,[[["self"],["t"]],["diagnostic"]]],[11,"span_warning","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `spans` and `message`.",0,[[["self"],["s"],["t"]],["diagnostic"]]],[11,"warning","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,[[["self"],["t"]],["diagnostic"]]],[11,"span_note","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `spans` and `message`.",0,[[["self"],["s"],["t"]],["diagnostic"]]],[11,"note","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,[[["self"],["t"]],["diagnostic"]]],[11,"span_help","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `spans` and `message`.",0,[[["self"],["s"],["t"]],["diagnostic"]]],[11,"help","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,[[["self"],["t"]],["diagnostic"]]],[11,"level","","Returns the diagnostic `level` for `self`.",0,[[["self"]],["level"]]],[11,"set_level","","Sets the level in `self` to `level`.",0,[[["self"],["level"]]]],[11,"message","","Returns the message in `self`.",0,[[["self"]],["str"]]],[11,"set_message","","Sets the message in `self` to `message`.",0,[[["self"],["t"]]]],[11,"spans","","Returns the `Span`s in `self`.",0,N],[11,"set_spans","","Sets the `Span`s in `self` to `spans`.",0,[[["self"],["s"]]]],[11,"children","","Returns an iterator over the children diagnostics of `self`.",0,[[["self"]],["children"]]],[11,"emit","","Emit the diagnostic.",0,[[["self"]]]],[0,"token_stream","","Public implementation details for the `TokenStream` type, such as iterators.",N,N],[3,"IntoIter","proc_macro::token_stream","An iterator over `TokenStream`'s `TokenTree`s. The iteration is \"shallow\", e.g. the iterator doesn't recurse into delimited groups, and returns whole groups as token trees.",N,N],[12,"cursor","","",16,N],[12,"stack","","",16,N],[11,"clone","","",16,[[["self"]],["intoiter"]]],[11,"next","","",16,[[["self"]],["option",["tokentree"]]]],[11,"into_iter","proc_macro","",1,[[["self"]],["intoiter"]]],[0,"quote","","Quasiquoter This file contains the implementation internals of the quasiquoter provided by `quote!`. This quasiquoter uses macros 2.0 hygiene to reliably access items from `proc_macro`, to build a `proc_macro::TokenStream`.",N,N],[5,"quote","proc_macro::quote","Quote a `TokenStream` into a `TokenStream`. This is the actual `quote!()` proc macro.",N,[[["tokenstream"]],["tokenstream"]]],[5,"quote_span","","Quote a `Span` into a `TokenStream`. This is needed to implement a custom quoter.",N,[[["span"]],["tokenstream"]]],[0,"__internal","proc_macro","Permanently unstable internal implementation details of this crate. This should not be used.",N,N],[3,"ProcMacroData","proc_macro::__internal","",N,N],[12,"def_site","","",17,N],[12,"call_site","","",17,N],[3,"ProcMacroSess","","",N,N],[12,"parse_sess","","",18,N],[12,"data","","",18,N],[5,"lookup_char_pos","","",N,[[["bytepos"]],["loc"]]],[5,"new_token_stream","","",N,[[["p",["item"]]],["tokenstream"]]],[5,"token_stream_wrap","","",N,[[["tokenstream"]],["tokenstream"]]],[5,"token_stream_parse_items","","",N,[[["tokenstream"]],["result",["vec","lexerror"]]]],[5,"token_stream_inner","","",N,[[["tokenstream"]],["tokenstream"]]],[5,"set_sess","","",N,[[["extctxt"],["f"]],["r"]]],[5,"in_sess","","",N,[[],["bool"]]],[5,"with_sess","","",N,[[["f"]],["r"]]],[17,"CURRENT_SESS","","",N,N],[8,"Registry","","",N,N],[10,"register_custom_derive","","",19,N],[10,"register_attr_proc_macro","","",19,N],[10,"register_bang_proc_macro","","",19,N],[11,"clone","","",17,[[["self"]],["procmacrodata"]]],[11,"clone","","",18,[[["self"]],["procmacrosess"]]],[11,"clone","proc_macro","",1,[[["self"]],["tokenstream"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"new","","Returns an empty `TokenStream` containing no token trees.",1,[[],["tokenstream"]]],[11,"is_empty","","Checks if this `TokenStream` is empty.",1,[[["self"]],["bool"]]],[11,"from_str","","",1,[[["str"]],["result",["tokenstream","lexerror"]]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"from","","",1,[[["tokentree"]],["tokenstream"]]],[11,"from_iter","","",1,[[["i"]],["self"]]],[11,"from_iter","","",1,[[["i"]],["self"]]],[11,"extend","","",1,[[["self"],["i"]]]],[11,"extend","","",1,[[["self"],["i"]]]],[11,"clone","","",3,[[["self"]],["span"]]],[11,"def_site","","A span that resolves at the macro definition site.",3,[[],["span"]]],[11,"call_site","","The span of the invocation of the current procedural macro. Identifiers created with this span will be resolved as if they were written directly at the macro call location (call-site hygiene) and other code at the macro call site will be able to refer to them as well.",3,[[],["span"]]],[11,"source_file","","The original source file into which this span points.",3,[[["self"]],["sourcefile"]]],[11,"parent","","The `Span` for the tokens in the previous macro expansion from which `self` was generated from, if any.",3,[[["self"]],["option",["span"]]]],[11,"source","","The span for the origin source code that `self` was generated from. If this `Span` wasn't generated from other macro expansions then the return value is the same as `*self`.",3,[[["self"]],["span"]]],[11,"start","","Get the starting line/column in the source file for this span.",3,[[["self"]],["linecolumn"]]],[11,"end","","Get the ending line/column in the source file for this span.",3,[[["self"]],["linecolumn"]]],[11,"join","","Create a new span encompassing `self` and `other`.",3,[[["self"],["span"]],["option",["span"]]]],[11,"resolved_at","","Creates a new span with the same line/column information as `self` but that resolves symbols as though it were at `other`.",3,[[["self"],["span"]],["span"]]],[11,"located_at","","Creates a new span with the same name resolution behavior as `self` but with the line/column information of `other`.",3,[[["self"],["span"]],["span"]]],[11,"eq","","Compares to spans to see if they're equal.",3,[[["self"],["span"]],["bool"]]],[11,"error","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,[[["self"],["t"]],["diagnostic"]]],[11,"warning","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,[[["self"],["t"]],["diagnostic"]]],[11,"note","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,[[["self"],["t"]],["diagnostic"]]],[11,"help","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,[[["self"],["t"]],["diagnostic"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",4,[[["self"]],["linecolumn"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["linecolumn"]],["bool"]]],[11,"ne","","",4,[[["self"],["linecolumn"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"clone","","",5,[[["self"]],["sourcefile"]]],[11,"path","","Get the path to this source file.",5,[[["self"]],["pathbuf"]]],[11,"is_real","","Returns `true` if this source file is a real source file, and not generated by an external macro's expansion.",5,[[["self"]],["bool"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"eq","","",5,[[["self"],["self"]],["bool"]]],[11,"clone","","",11,[[["self"]],["tokentree"]]],[11,"span","","Returns the span of this tree, delegating to the `span` method of the contained token or a delimited stream.",11,[[["self"]],["span"]]],[11,"set_span","","Configures the span for only this token.",11,[[["self"],["span"]]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"from","","",11,[[["group"]],["tokentree"]]],[11,"from","","",11,[[["ident"]],["tokentree"]]],[11,"from","","",11,[[["punct"]],["tokentree"]]],[11,"from","","",11,[[["literal"]],["tokentree"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"clone","","",6,[[["self"]],["group"]]],[11,"clone","","",12,[[["self"]],["delimiter"]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"eq","","",12,[[["self"],["delimiter"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",12,N],[11,"new","","Creates a new `Group` with the given delimiter and token stream.",6,[[["delimiter"],["tokenstream"]],["group"]]],[11,"delimiter","","Returns the delimiter of this `Group`",6,[[["self"]],["delimiter"]]],[11,"stream","","Returns the `TokenStream` of tokens that are delimited in this `Group`.",6,[[["self"]],["tokenstream"]]],[11,"span","","Returns the span for the delimiters of this token stream, spanning the entire `Group`.",6,[[["self"]],["span"]]],[11,"span_open","","Returns the span pointing to the opening delimiter of this group.",6,[[["self"]],["span"]]],[11,"span_close","","Returns the span pointing to the closing delimiter of this group.",6,[[["self"]],["span"]]],[11,"set_span","","Configures the span for this `Group`'s delimiters, but not its internal tokens.",6,[[["self"],["span"]]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"clone","","",7,[[["self"]],["punct"]]],[11,"clone","","",13,[[["self"]],["spacing"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"eq","","",13,[[["self"],["spacing"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",13,N],[11,"new","","Creates a new `Punct` from the given character and spacing. The `ch` argument must be a valid punctuation character permitted by the language, otherwise the function will panic.",7,[[["char"],["spacing"]],["punct"]]],[11,"as_char","","Returns the value of this punctuation character as `char`.",7,[[["self"]],["char"]]],[11,"spacing","","Returns the spacing of this punctuation character, indicating whether it's immediately followed by another `Punct` in the token stream, so they can potentially be combined into a multicharacter operator (`Joint`), or it's followed by some other token or whitespace (`Alone`) so the operator has certainly ended.",7,[[["self"]],["spacing"]]],[11,"span","","Returns the span for this punctuation character.",7,[[["self"]],["span"]]],[11,"set_span","","Configure the span for this punctuation character.",7,[[["self"],["span"]]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"clone","","",8,[[["self"]],["ident"]]],[11,"is_valid","","",8,[[["str"]],["bool"]]],[11,"new","","Creates a new `Ident` with the given `string` as well as the specified `span`. The `string` argument must be a valid identifier permitted by the language, otherwise the function will panic.",8,[[["str"],["span"]],["ident"]]],[11,"new_raw","","Same as `Ident::new`, but creates a raw identifier (`r#ident`).",8,[[["str"],["span"]],["ident"]]],[11,"span","","Returns the span of this `Ident`, encompassing the entire string returned by `as_str`.",8,[[["self"]],["span"]]],[11,"set_span","","Configures the span of this `Ident`, possibly changing its hygiene context.",8,[[["self"],["span"]]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"clone","","",9,[[["self"]],["literal"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"u8_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["u8"]],["literal"]]],[11,"u16_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["u16"]],["literal"]]],[11,"u32_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["u32"]],["literal"]]],[11,"u64_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["u64"]],["literal"]]],[11,"u128_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["u128"]],["literal"]]],[11,"usize_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["usize"]],["literal"]]],[11,"i8_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["i8"]],["literal"]]],[11,"i16_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["i16"]],["literal"]]],[11,"i32_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["i32"]],["literal"]]],[11,"i64_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["i64"]],["literal"]]],[11,"i128_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["i128"]],["literal"]]],[11,"isize_suffixed","","Creates a new suffixed integer literal with the specified value.",9,[[["isize"]],["literal"]]],[11,"u8_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["u8"]],["literal"]]],[11,"u16_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["u16"]],["literal"]]],[11,"u32_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["u32"]],["literal"]]],[11,"u64_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["u64"]],["literal"]]],[11,"u128_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["u128"]],["literal"]]],[11,"usize_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["usize"]],["literal"]]],[11,"i8_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["i8"]],["literal"]]],[11,"i16_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["i16"]],["literal"]]],[11,"i32_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["i32"]],["literal"]]],[11,"i64_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["i64"]],["literal"]]],[11,"i128_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["i128"]],["literal"]]],[11,"isize_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,[[["isize"]],["literal"]]],[11,"f32_unsuffixed","","Creates a new unsuffixed floating-point literal.",9,[[["f32"]],["literal"]]],[11,"f32_suffixed","","Creates a new suffixed floating-point literal.",9,[[["f32"]],["literal"]]],[11,"f64_unsuffixed","","Creates a new unsuffixed floating-point literal.",9,[[["f64"]],["literal"]]],[11,"f64_suffixed","","Creates a new suffixed floating-point literal.",9,[[["f64"]],["literal"]]],[11,"string","","String literal.",9,[[["str"]],["literal"]]],[11,"character","","Character literal.",9,[[["char"]],["literal"]]],[11,"byte_string","","Byte string literal.",9,N],[11,"span","","Returns the span encompassing this literal.",9,[[["self"]],["span"]]],[11,"set_span","","Configures the span associated for this literal.",9,[[["self"],["span"]]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[14,"quote","","`quote!(..)` accepts arbitrary tokens and expands into a `TokenStream` describing the input. For example, `quote!(a + b)` will produce a expression, that, when evaluated, constructs the `TokenStream` `[Ident(\"a\"), Punct('+', Alone), Ident(\"b\")]`.",N,N],[11,"to_owned","","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"to_string","","",1,[[["self"]],["string"]]],[11,"into_iter","","",1,[[["self"]],["i"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"to_string","","",6,[[["self"]],["string"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"to_string","","",7,[[["self"]],["string"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"to_string","","",8,[[["self"]],["string"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"to_string","","",9,[[["self"]],["string"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"to_owned","","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"to_string","","",11,[[["self"]],["string"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"to_owned","","",12,[[["self"]],["t"]]],[11,"clone_into","","",12,N],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"to_owned","","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"to_owned","proc_macro::diagnostic","",14,[[["self"]],["t"]]],[11,"clone_into","","",14,N],[11,"from","","",14,[[["t"]],["t"]]],[11,"into_iter","","",14,[[["self"]],["i"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"to_owned","proc_macro::token_stream","",16,[[["self"]],["t"]]],[11,"clone_into","","",16,N],[11,"from","","",16,[[["t"]],["t"]]],[11,"into_iter","","",16,[[["self"]],["i"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"to_owned","proc_macro::__internal","",17,[[["self"]],["t"]]],[11,"clone_into","","",17,N],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]]],"paths":[[3,"Diagnostic"],[3,"TokenStream"],[3,"LexError"],[3,"Span"],[3,"LineColumn"],[3,"SourceFile"],[3,"Group"],[3,"Punct"],[3,"Ident"],[3,"Literal"],[4,"Level"],[4,"TokenTree"],[4,"Delimiter"],[4,"Spacing"],[3,"Children"],[8,"MultiSpan"],[3,"IntoIter"],[3,"ProcMacroData"],[3,"ProcMacroSess"],[8,"Registry"]]};
searchIndex["pulldown_cmark"]={"doc":"Pull parser for commonmark.","items":[[3,"Parser","pulldown_cmark","",N,N],[12,"inner","","",0,N],[12,"loose_lists","","",0,N],[12,"loose_stack","","",0,N],[3,"Options","","",N,N],[12,"bits","","",1,N],[4,"Alignment","","",N,N],[13,"None","","",2,N],[13,"Left","","",2,N],[13,"Center","","",2,N],[13,"Right","","",2,N],[4,"Event","","",N,N],[13,"Start","","",3,N],[13,"End","","",3,N],[13,"Text","","",3,N],[13,"Html","","",3,N],[13,"InlineHtml","","",3,N],[13,"FootnoteReference","","",3,N],[13,"SoftBreak","","",3,N],[13,"HardBreak","","",3,N],[4,"Tag","","",N,N],[13,"Paragraph","","",4,N],[13,"Rule","","",4,N],[13,"Header","","A heading. The field indicates the level of the heading.",4,N],[13,"BlockQuote","","",4,N],[13,"CodeBlock","","",4,N],[13,"List","","A list. If the list is ordered the field indicates the number of the first item.",4,N],[13,"Item","","",4,N],[13,"FootnoteDefinition","","",4,N],[13,"Table","","",4,N],[13,"TableHead","","",4,N],[13,"TableRow","","",4,N],[13,"TableCell","","",4,N],[13,"Emphasis","","",4,N],[13,"Strong","","",4,N],[13,"Code","","",4,N],[13,"Link","","A link. The first field is the destination URL, the second is a title",4,N],[13,"Image","","An image. The first field is the destination URL, the second is a title",4,N],[0,"html","","HTML renderer that takes an iterator of events as input.",N,N],[3,"Ctx","pulldown_cmark::html","",N,N],[12,"iter","","",5,N],[12,"buf","","",5,N],[12,"table_state","","",5,N],[12,"table_alignments","","",5,N],[12,"table_cell_index","","",5,N],[4,"TableState","","",N,N],[13,"Head","","",6,N],[13,"Body","","",6,N],[5,"push_html","","Iterate over an `Iterator` of `Event`s, generate HTML for each `Event`, and push it to a `String`.",N,[[["string"],["i"]]]],[11,"fresh_line","","",5,[[["self"]]]],[11,"run","","",5,[[["self"]]]],[11,"start_tag","","",5,[[["self"],["tag"],["hashmap"]]]],[11,"end_tag","","",5,[[["self"],["tag"]]]],[11,"raw_text","","",5,[[["self"],["hashmap"]]]],[0,"passes","pulldown_cmark","Main public pull parse interface, running two passes over input.",N,N],[3,"Parser","pulldown_cmark::passes","",N,N],[12,"inner","","",0,N],[12,"loose_lists","","",0,N],[12,"loose_stack","","",0,N],[11,"new","pulldown_cmark","",0,[[["str"]],["parser"]]],[11,"new_ext","","",0,[[["str"],["options"]],["parser"]]],[11,"new_with_broken_link_callback","","In case the parser encounters any potential links that have a broken reference (e.g `[foo]` when there is no `[foo]:` entry at the bottom) the provided callback will be called with the reference name, and the returned pair will be used as the link name and title if not None.",0,[[["str"],["options"],["option",["fn"]]],["parser"]]],[11,"get_offset","","",0,[[["self"]],["usize"]]],[11,"next","","",0,[[["self"]],["option",["event"]]]],[0,"parse","","Raw parser, for doing a single pass over input.",N,N],[3,"RawParser","pulldown_cmark::parse","",N,N],[12,"text","","",7,N],[12,"off","","",7,N],[12,"opts","","",7,N],[12,"active_tab","","",7,N],[12,"state","","",7,N],[12,"stack","","",7,N],[12,"leading_space","","",7,N],[12,"containers","","",7,N],[12,"last_line_was_empty","","",7,N],[12,"broken_link_callback","","In case we have a broken link/image reference, we can call this callback with the reference name (both normalized and not normalized) and use the link/title pair returned instead",7,N],[12,"fence_char","","",7,N],[12,"fence_count","","",7,N],[12,"fence_indent","","",7,N],[12,"loose_lists","","",7,N],[12,"links","","",7,N],[3,"ParseInfo","","",N,N],[12,"loose_lists","","",8,N],[12,"links","","",8,N],[3,"Options","","",N,N],[12,"bits","","",1,N],[4,"State","","",N,N],[13,"StartBlock","","",9,N],[13,"InContainers","","",9,N],[13,"Inline","","",9,N],[13,"TableHead","","",9,N],[13,"TableBody","","",9,N],[13,"TableRow","","",9,N],[13,"CodeLineStart","","",9,N],[13,"Code","","",9,N],[13,"InlineCode","","",9,N],[13,"Literal","","",9,N],[4,"Container","","",N,N],[13,"BlockQuote","","",10,N],[13,"List","","",10,N],[13,"ListItem","","",10,N],[13,"FootnoteDefinition","","",10,N],[4,"Tag","","",N,N],[13,"Paragraph","","",4,N],[13,"Rule","","",4,N],[13,"Header","","A heading. The field indicates the level of the heading.",4,N],[13,"BlockQuote","","",4,N],[13,"CodeBlock","","",4,N],[13,"List","","A list. If the list is ordered the field indicates the number of the first item.",4,N],[13,"Item","","",4,N],[13,"FootnoteDefinition","","",4,N],[13,"Table","","",4,N],[13,"TableHead","","",4,N],[13,"TableRow","","",4,N],[13,"TableCell","","",4,N],[13,"Emphasis","","",4,N],[13,"Strong","","",4,N],[13,"Code","","",4,N],[13,"Link","","A link. The first field is the destination URL, the second is a title",4,N],[13,"Image","","An image. The first field is the destination URL, the second is a title",4,N],[4,"Event","","",N,N],[13,"Start","","",3,N],[13,"End","","",3,N],[13,"Text","","",3,N],[13,"Html","","",3,N],[13,"InlineHtml","","",3,N],[13,"FootnoteReference","","",3,N],[13,"SoftBreak","","",3,N],[13,"HardBreak","","",3,N],[4,"Alignment","","",N,N],[13,"None","","",2,N],[13,"Left","","",2,N],[13,"Center","","",2,N],[13,"Right","","",2,N],[17,"OPTION_FIRST_PASS","","",N,N],[17,"OPTION_ENABLE_TABLES","","",N,N],[17,"OPTION_ENABLE_FOOTNOTES","","",N,N],[17,"MAX_LINK_NEST","","",N,N],[11,"eq","","",9,[[["self"],["state"]],["bool"]]],[11,"ne","","",9,[[["self"],["state"]],["bool"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"clone","","",10,[[["self"]],["container"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"eq","","",10,[[["self"],["container"]],["bool"]]],[11,"ne","","",10,[[["self"],["container"]],["bool"]]],[11,"clone","pulldown_cmark","",4,[[["self"]],["tag"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["tag"]],["bool"]]],[11,"ne","","",4,[[["self"],["tag"]],["bool"]]],[11,"clone","","",3,[[["self"]],["event"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"eq","","",3,[[["self"],["event"]],["bool"]]],[11,"ne","","",3,[[["self"],["event"]],["bool"]]],[11,"clone","","",2,[[["self"]],["alignment"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"eq","","",2,[[["self"],["alignment"]],["bool"]]],[11,"eq","","",1,[[["self"],["options"]],["bool"]]],[11,"ne","","",1,[[["self"],["options"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1,N],[11,"clone","","",1,[[["self"]],["options"]]],[11,"partial_cmp","","",1,[[["self"],["options"]],["option",["ordering"]]]],[11,"lt","","",1,[[["self"],["options"]],["bool"]]],[11,"le","","",1,[[["self"],["options"]],["bool"]]],[11,"gt","","",1,[[["self"],["options"]],["bool"]]],[11,"ge","","",1,[[["self"],["options"]],["bool"]]],[11,"cmp","","",1,[[["self"],["options"]],["ordering"]]],[11,"hash","","",1,N],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"empty","","Returns an empty set of flags.",1,[[],["options"]]],[11,"all","","Returns the set containing all flags.",1,[[],["options"]]],[11,"bits","","Returns the raw value of the flags currently stored.",1,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",1,[[["u32"]],["option",["options"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",1,[[["u32"]],["options"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",1,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",1,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",1,[[["self"],["options"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",1,[[["self"],["options"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",1,[[["self"],["options"]]]],[11,"remove","","Removes the specified flags in-place.",1,[[["self"],["options"]]]],[11,"toggle","","Toggles the specified flags in-place.",1,[[["self"],["options"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",1,[[["self"],["options"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",1,[[["self"],["options"]],["options"]]],[11,"bitor_assign","","Adds the set of flags.",1,[[["self"],["options"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",1,[[["self"],["options"]],["options"]]],[11,"bitxor_assign","","Toggles the set of flags.",1,[[["self"],["options"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",1,[[["self"],["options"]],["options"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",1,[[["self"],["options"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",1,[[["self"],["options"]],["options"]]],[11,"sub_assign","","Disables all flags enabled in the set.",1,[[["self"],["options"]]]],[11,"not","","Returns the complement of this set of flags.",1,[[["self"]],["options"]]],[11,"extend","","",1,[[["self"],["t"]]]],[11,"from_iter","","",1,[[["t"]],["options"]]],[11,"new_with_links_and_callback","pulldown_cmark::parse","",7,[[["str"],["options"],["hashmap",["string"]],["option",["fn"]]],["rawparser"]]],[11,"new_with_links","","",7,[[["str"],["options"],["hashmap",["string"]]],["rawparser"]]],[11,"new","","",7,[[["str"],["options"]],["rawparser"]]],[11,"get_offset","","",7,[[["self"]],["usize"]]],[11,"get_info","","",7,[[["self"]],["parseinfo"]]],[11,"init_active","","",7,[[["self"]]]],[11,"limit","","",7,[[["self"]],["usize"]]],[11,"start","","",7,[[["self"],["tag"],["usize"],["usize"]],["event"]]],[11,"end","","",7,[[["self"]],["event"]]],[11,"skip_leading_whitespace","","",7,[[["self"]]]],[11,"skip_blank_lines","","",7,[[["self"]]]],[11,"scan_containers","","",7,N],[11,"scan_empty_lines","","",7,N],[11,"scan_whitespace_inline","","",7,[[["self"],["str"]],["usize"]]],[11,"at_list","","",7,[[["self"],["usize"]],["option",["usize"]]]],[11,"start_block","","",7,[[["self"]],["option",["event"]]]],[11,"start_paragraph","","",7,[[["self"]],["event"]]],[11,"start_table_head","","",7,[[["self"]],["event"]]],[11,"start_table_body","","",7,[[["self"]],["event"]]],[11,"start_hrule","","",7,[[["self"]],["event"]]],[11,"start_atx_header","","",7,[[["self"],["i32"]],["event"]]],[11,"start_indented_code","","",7,[[["self"]],["event"]]],[11,"start_listitem","","",7,[[["self"],["usize"],["u8"],["usize"],["usize"]],["event"]]],[11,"start_code_fence","","",7,[[["self"],["usize"],["u8"],["usize"]],["event"]]],[11,"next_code_line_start","","",7,[[["self"]],["event"]]],[11,"next_code","","",7,[[["self"]],["event"]]],[11,"is_code_block_end","","",7,[[["self"],["usize"],["usize"]],["bool"]]],[11,"scan_html_block_tag","","",7,N],[11,"is_html_block","","",7,[[["self"],["str"]],["bool"]]],[11,"get_html_tag","","",7,[[["self"]],["option",["str"]]]],[11,"do_html_block","","",7,[[["self"]],["event"]]],[11,"try_link_reference_definition","","",7,[[["self"],["str"]],["bool"]]],[11,"normalize_link_ref","","",7,[[["self"],["str"]],["string"]]],[11,"is_inline_block_end","","",7,[[["self"],["str"],["usize"]],["bool"]]],[11,"next_table_cell","","",7,[[["self"]],["event"]]],[11,"next_inline","","",7,[[["self"]],["event"]]],[11,"active_char","","",7,[[["self"],["u8"]],["option",["event"]]]],[11,"char_null","","",7,[[["self"]],["event"]]],[11,"char_tab","","",7,[[["self"]],["event"]]],[11,"char_backslash","","",7,[[["self"]],["option",["event"]]]],[11,"char_entity","","",7,[[["self"]],["option",["event"]]]],[11,"char_emphasis","","",7,[[["self"]],["option",["event"]]]],[11,"scan_link_label","","",7,N],[11,"scan_link_title","","",7,N],[11,"char_link","","",7,[[["self"]],["option",["event"]]]],[11,"parse_link","","",7,[[["self"],["str"],["bool"]],["option"]]],[11,"contains_link","","",7,[[["self"],["str"]],["bool"]]],[11,"parse_footnote_definition","","",7,[[["self"],["str"]],["option"]]],[11,"char_link_footnote","","",7,[[["self"]],["option",["event"]]]],[11,"parse_footnote","","",7,[[["self"],["str"]],["option"]]],[11,"scan_footnote_label","","",7,N],[11,"char_lt","","",7,[[["self"]],["option",["event"]]]],[11,"scan_autolink_or_html","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_inline_html","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_html_tag","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_attribute_value","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_html_comment","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_processing_instruction","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_declaration","","",7,[[["self"],["str"]],["usize"]]],[11,"scan_cdata","","",7,[[["self"],["str"]],["usize"]]],[11,"inline_html_event","","",7,[[["self"],["usize"]],["event"]]],[11,"next_literal","","",7,[[["self"]],["event"]]],[11,"scan_inline_code","","",7,N],[11,"char_backtick","","",7,[[["self"]],["option",["event"]]]],[11,"next_inline_code","","",7,[[["self"]],["event"]]],[11,"next","","",7,[[["self"]],["option",["event"]]]],[0,"scanners","pulldown_cmark","Scanners for fragments of CommonMark syntax",N,N],[5,"is_ascii_whitespace","pulldown_cmark::scanners","",N,[[["u8"]],["bool"]]],[5,"is_ascii_whitespace_no_nl","","",N,[[["u8"]],["bool"]]],[5,"is_ascii_alpha","","",N,[[["u8"]],["bool"]]],[5,"is_ascii_upper","","",N,[[["u8"]],["bool"]]],[5,"is_ascii_alphanumeric","","",N,[[["u8"]],["bool"]]],[5,"is_hexdigit","","",N,[[["u8"]],["bool"]]],[5,"is_digit","","",N,[[["u8"]],["bool"]]],[5,"scan_ch","","",N,[[["str"],["u8"]],["usize"]]],[5,"scan_while","","",N,[[["str"],["f"]],["usize"]]],[5,"scan_ch_repeat","","",N,[[["str"],["u8"]],["usize"]]],[5,"scan_whitespace_no_nl","","",N,[[["str"]],["usize"]]],[5,"scan_eol","","",N,N],[5,"scan_trailing_whitespace","","",N,[[["str"]],["usize"]]],[5,"scan_codepoint","","",N,[[["str"]],["option",["char"]]]],[5,"scan_trailing_codepoint","","",N,[[["str"]],["option",["char"]]]],[5,"scan_blank_line","","",N,[[["str"]],["usize"]]],[5,"scan_nextline","","",N,[[["str"]],["usize"]]],[5,"count_tab","","",N,N],[5,"scan_leading_space","","",N,N],[5,"calc_indent","","",N,N],[5,"scan_hrule","","",N,[[["str"]],["usize"]]],[5,"scan_atx_header","","",N,N],[5,"scan_setext_header","","",N,N],[5,"scan_table_head","","",N,N],[5,"scan_code_fence","","",N,N],[5,"scan_backticks","","",N,[[["str"]],["usize"]]],[5,"scan_blockquote_start","","",N,[[["str"]],["usize"]]],[5,"scan_listitem","","",N,N],[5,"compute_open_close","","",N,N],[5,"cow_from_codepoint_str","","",N,[[["str"],["u32"]],["cow",["str"]]]],[5,"scan_entity","","",N,N],[5,"scan_link_dest","","",N,[[["str"]],["option"]]],[5,"scan_autolink","","",N,[[["str"]],["option"]]],[5,"scan_uri","","",N,[[["str"]],["usize"]]],[5,"scan_email","","",N,[[["str"]],["usize"]]],[5,"scan_attribute_name","","",N,[[["str"]],["usize"]]],[5,"is_escaped","","",N,[[["str"],["usize"]],["bool"]]],[5,"unescape","","",N,[[["str"]],["cow",["str"]]]],[5,"is_html_tag","","",N,[[["str"]],["bool"]]],[5,"spaces","","",N,[[["usize"]],["cow",["str"]]]],[17,"HTML_TAGS","","",N,N],[17,"URI_SCHEMES","","",N,N],[0,"entities","pulldown_cmark","Expansions of HTML5 entities",N,N],[5,"get_entity","pulldown_cmark::entities","",N,[[["str"]],["option",["str"]]]],[17,"ENTITIES","","",N,N],[17,"ENTITY_VALUES","","",N,N],[0,"escape","pulldown_cmark","Utility functions for HTML escaping",N,N],[5,"escape_href","pulldown_cmark::escape","",N,[[["string"],["str"]]]],[5,"escape_html","","",N,[[["string"],["str"],["bool"]]]],[7,"HREF_SAFE","","",N,N],[7,"HEX_CHARS","","",N,N],[7,"HTML_ESCAPE_TABLE","","",N,N],[7,"HTML_ESCAPES","","",N,N],[0,"puncttable","pulldown_cmark","CommonMark punctuation set based on spec and Unicode properties.",N,N],[5,"is_ascii_punctuation","pulldown_cmark::puncttable","",N,[[["u8"]],["bool"]]],[5,"is_punctuation","","",N,[[["char"]],["bool"]]],[17,"PUNCT_MASKS_ASCII","","",N,N],[17,"PUNCT_TAB","","",N,N],[17,"PUNCT_MASKS","","",N,N],[0,"utils","pulldown_cmark","Utilities for manipulating strings.",N,N],[5,"ascii_tolower","pulldown_cmark::utils","",N,[[["u8"]],["u8"]]],[5,"strcasecmp","","",N,[[["str"],["str"]],["ordering"]]],[5,"cow_append","","",N,[[["cow",["str"]],["cow",["str"]]],["cow",["str"]]]],[17,"OPTION_ENABLE_TABLES","pulldown_cmark","",N,N],[17,"OPTION_ENABLE_FOOTNOTES","","",N,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into_iter","","",0,[[["self"]],["i"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"from","pulldown_cmark::html","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"from","pulldown_cmark::parse","",7,[[["t"]],["t"]]],[11,"into_iter","","",7,[[["self"]],["i"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]]],"paths":[[3,"Parser"],[3,"Options"],[4,"Alignment"],[4,"Event"],[4,"Tag"],[3,"Ctx"],[4,"TableState"],[3,"RawParser"],[3,"ParseInfo"],[4,"State"],[4,"Container"]]};
searchIndex["rand"]={"doc":"Utilities for random number generation","items":[[8,"RngCore","rand","The core of a random number generator.",N,N],[10,"next_u32","","Return the next random `u32`.",0,[[["self"]],["u32"]]],[10,"next_u64","","Return the next random `u64`.",0,[[["self"]],["u64"]]],[10,"fill_bytes","","Fill `dest` with random data.",0,N],[10,"try_fill_bytes","","Fill `dest` entirely with random data.",0,N],[8,"CryptoRng","","A marker trait used to indicate that an [`RngCore`] or [`BlockRngCore`] implementation is supposed to be cryptographically secure.",N,N],[8,"SeedableRng","","A random number generator that can be explicitly seeded.",N,N],[16,"Seed","","Seed type, which is restricted to types mutably-dereferencable as `u8` arrays (we recommend `[u8; N]` for some `N`).",1,N],[10,"from_seed","","Create a new PRNG using the given seed.",1,N],[11,"from_rng","","Create a new PRNG seeded from another `Rng`.",1,[[["r"]],["result",["error"]]]],[4,"ErrorKind","","Error kind which can be matched over.",N,N],[13,"Unavailable","","Feature is not available; not recoverable.",2,N],[13,"Unexpected","","General failure; there may be a chance of recovery on retry.",2,N],[13,"Transient","","A transient failure which likely can be resolved or worked around.",2,N],[13,"NotReady","","Not ready yet: recommended to try again a little later.",2,N],[13,"__Nonexhaustive","","",2,N],[3,"Error","","Error type of random number generators",N,N],[12,"kind","","The error kind",3,N],[12,"msg","","The error message",3,N],[12,"cause","","",3,N],[3,"Generator","","Iterator which will generate a stream of random items.",N,N],[12,"rng","","",4,N],[12,"_marker","","",4,N],[3,"AsciiGenerator","","Iterator which will continuously generate random ascii characters.",N,N],[12,"rng","","",5,N],[5,"thread_rng","","Retrieve the lazily-initialized thread-local random number generator, seeded by the system. Intended to be used in method chaining style, e.g. `thread_rng().gen::<i32>()`, or cached locally, e.g. `let mut rng = thread_rng();`.",N,[[],["threadrng"]]],[5,"weak_rng","","DEPRECATED: use [`SmallRng`] instead.",N,[[],["xorshiftrng"]]],[5,"random","","Generates a random value using the thread-local random number generator.",N,[[],["t"]]],[5,"sample","","DEPRECATED: use `seq::sample_iter` instead.",N,[[["r"],["i"],["usize"]],["vec"]]],[0,"distributions","","Generating random samples from probability distributions.",N,N],[3,"Alphanumeric","rand::distributions","Sample a `char`, uniformly distributed over ASCII letters and numbers: a-z, A-Z and 0-9.",N,N],[3,"Uniform","","Sample values uniformly between two bounds.",N,N],[12,"inner","","",6,N],[3,"OpenClosed01","","A distribution to sample floating point numbers uniformly in the half-open interval `(0, 1]`, i.e. including 1 but not 0.",N,N],[3,"Open01","","A distribution to sample floating point numbers uniformly in the open interval `(0, 1)`, i.e. not including either endpoint.",N,N],[3,"Gamma","","The Gamma distribution `Gamma(shape, scale)` distribution.",N,N],[12,"repr","","",7,N],[3,"ChiSquared","","The chi-squared distribution `χ²(k)`, where `k` is the degrees of freedom.",N,N],[12,"repr","","",8,N],[3,"FisherF","","The Fisher F distribution `F(m, n)`.",N,N],[12,"numer","","",9,N],[12,"denom","","",9,N],[12,"dof_ratio","","",9,N],[3,"StudentT","","The Student t distribution, `t(nu)`, where `nu` is the degrees of freedom.",N,N],[12,"chi","","",10,N],[12,"dof","","",10,N],[3,"Normal","","The normal distribution `N(mean, std_dev**2)`.",N,N],[12,"mean","","",11,N],[12,"std_dev","","",11,N],[3,"LogNormal","","The log-normal distribution `ln N(mean, std_dev**2)`.",N,N],[12,"norm","","",12,N],[3,"StandardNormal","","Samples floating-point numbers according to the normal distribution `N(0, 1)` (a.k.a. a standard normal, or Gaussian). This is equivalent to `Normal::new(0.0, 1.0)` but faster.",N,N],[3,"Exp","","The exponential distribution `Exp(lambda)`.",N,N],[12,"lambda_inverse","","`lambda` stored as `1/lambda`, since this is what we scale by.",13,N],[3,"Exp1","","Samples floating-point numbers according to the exponential distribution, with rate parameter `λ = 1`. This is equivalent to `Exp::new(1.0)` or sampling with `-rng.gen::<f64>().ln()`, but faster.",N,N],[3,"Pareto","","Samples floating-point numbers according to the Pareto distribution",N,N],[12,"scale","","",14,N],[12,"inv_neg_shape","","",14,N],[3,"Poisson","","The Poisson distribution `Poisson(lambda)`.",N,N],[12,"lambda","","",15,N],[12,"exp_lambda","","",15,N],[12,"log_lambda","","",15,N],[12,"sqrt_2lambda","","",15,N],[12,"magic_val","","",15,N],[3,"Binomial","","The binomial distribution `Binomial(n, p)`.",N,N],[12,"n","","Number of trials.",16,N],[12,"p","","Probability of success.",16,N],[3,"Bernoulli","","The Bernoulli distribution.",N,N],[12,"p_int","","Probability of success, relative to the maximal integer.",17,N],[3,"Cauchy","","The Cauchy distribution `Cauchy(median, scale)`.",N,N],[12,"median","","",18,N],[12,"scale","","",18,N],[3,"DistIter","","An iterator that generates random values of `T` with distribution `D`, using `R` as the source of randomness.",N,N],[12,"distr","","",19,N],[12,"rng","","",19,N],[12,"phantom","","",19,N],[3,"Standard","","A generic random value distribution, implemented for many primitive types. Usually generates values with a numerically uniform distribution, and with a range appropriate to the type.",N,N],[3,"Weighted","","A value with a particular weight for use with `WeightedChoice`.",N,N],[12,"weight","","The numerical weight of this item",20,N],[12,"item","","The actual item which is being weighted",20,N],[3,"WeightedChoice","","A distribution that selects from a finite collection of weighted items.",N,N],[12,"items","","",21,N],[12,"weight_range","","",21,N],[5,"ziggurat","","Sample a random number using the Ziggurat method (specifically the ZIGNOR variant from Doornik 2005). Most of the arguments are directly from the paper:",N,N],[0,"uniform","","A distribution uniformly sampling numbers within a given range.",N,N],[3,"Uniform","rand::distributions::uniform","Sample values uniformly between two bounds.",N,N],[12,"inner","","",6,N],[3,"UniformInt","","The back-end implementing [`UniformSampler`] for integer types.",N,N],[12,"low","","",22,N],[12,"range","","",22,N],[12,"zone","","",22,N],[3,"UniformFloat","","The back-end implementing [`UniformSampler`] for floating-point types.",N,N],[12,"scale","","",23,N],[12,"offset","","",23,N],[3,"UniformDuration","","The back-end implementing [`UniformSampler`] for `Duration`.",N,N],[12,"offset","","",24,N],[12,"mode","","",24,N],[4,"UniformDurationMode","","",N,N],[13,"Small","","",25,N],[12,"nanos","rand::distributions::uniform::UniformDurationMode","",25,N],[13,"Large","rand::distributions::uniform","",25,N],[12,"size","rand::distributions::uniform::UniformDurationMode","",25,N],[12,"secs","","",25,N],[8,"SampleUniform","rand::distributions::uniform","Helper trait for creating objects using the correct implementation of [`UniformSampler`] for the sampling type.",N,N],[16,"Sampler","","The `UniformSampler` implementation supporting type `X`.",26,N],[8,"UniformSampler","","Helper trait handling actual uniform sampling.",N,N],[16,"X","","The type sampled by this implementation.",27,N],[10,"new","","Construct self, with inclusive lower bound and exclusive upper bound `[low, high)`.",27,N],[10,"new_inclusive","","Construct self, with inclusive bounds `[low, high]`.",27,N],[10,"sample","","Sample a value.",27,N],[11,"sample_single","","Sample a single value uniformly from a range with inclusive lower bound and exclusive upper bound `[low, high)`.",27,N],[8,"WideningMultiply","","",N,N],[16,"Output","","",28,N],[10,"wmul","","",28,N],[11,"clone","","",6,[[["self"]],["uniform"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `Uniform` instance which samples uniformly from the half open range `[low, high)` (excluding `high`). Panics if `low >= high`.",6,[[["x"],["x"]],["uniform"]]],[11,"new_inclusive","","Create a new `Uniform` instance which samples uniformly from the closed range `[low, high]` (inclusive). Panics if `low > high`.",6,[[["x"],["x"]],["uniform"]]],[11,"sample","","",6,[[["self"],["r"]],["x"]]],[11,"from","","",6,[[["range"]],["uniform"]]],[11,"clone","","",22,[[["self"]],["uniformint"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"new","","",22,N],[11,"new_inclusive","","",22,N],[11,"sample","","",22,N],[11,"sample_single","","",22,N],[11,"new","","",22,N],[11,"new_inclusive","","",22,N],[11,"sample","","",22,N],[11,"sample_single","","",22,N],[11,"new","","",22,N],[11,"new_inclusive","","",22,N],[11,"sample","","",22,N],[11,"sample_single","","",22,N],[11,"new","","",22,N],[11,"new_inclusive","","",22,N],[11,"sample","","",22,N],[11,"sample_single","","",22,N],[11,"new","","",22,N],[11,"new_inclusive","","",22,N],[11,"sample","","",22,N],[11,"sample_single","","",22,N],[11,"new","","",22,N],[11,"new_inclusive","","",22,N],[11,"sample","","",22,N],[11,"sample_single","","",22,N],[11,"new","","",22,N],[11,"new_inclusive","","",22,N],[11,"sample","","",22,N],[11,"sample_single","","",22,N],[11,"new","","",22,N],[11,"new_inclusive","","",22,N],[11,"sample","","",22,N],[11,"sample_single","","",22,N],[11,"new","","",22,N],[11,"new_inclusive","","",22,N],[11,"sample","","",22,N],[11,"sample_single","","",22,N],[11,"new","","",22,N],[11,"new_inclusive","","",22,N],[11,"sample","","",22,N],[11,"sample_single","","",22,N],[11,"clone","","",23,[[["self"]],["uniformfloat"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"new","","",23,N],[11,"new_inclusive","","",23,N],[11,"sample","","",23,N],[11,"sample_single","","",23,N],[11,"new","","",23,N],[11,"new_inclusive","","",23,N],[11,"sample","","",23,N],[11,"sample_single","","",23,N],[11,"clone","","",24,[[["self"]],["uniformduration"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"clone","","",25,[[["self"]],["uniformdurationmode"]]],[11,"new","","",24,[[["duration"],["duration"]],["uniformduration"]]],[11,"new_inclusive","","",24,[[["duration"],["duration"]],["uniformduration"]]],[11,"sample","","",24,[[["self"],["r"]],["duration"]]],[0,"gamma","rand::distributions","The Gamma and derived distributions.",N,N],[3,"Gamma","rand::distributions::gamma","The Gamma distribution `Gamma(shape, scale)` distribution.",N,N],[12,"repr","","",7,N],[3,"GammaSmallShape","","Gamma distribution where the shape parameter is less than 1.",N,N],[12,"inv_shape","","",29,N],[12,"large_shape","","",29,N],[3,"GammaLargeShape","","Gamma distribution where the shape parameter is larger than 1.",N,N],[12,"scale","","",30,N],[12,"c","","",30,N],[12,"d","","",30,N],[3,"ChiSquared","","The chi-squared distribution `χ²(k)`, where `k` is the degrees of freedom.",N,N],[12,"repr","","",8,N],[3,"FisherF","","The Fisher F distribution `F(m, n)`.",N,N],[12,"numer","","",9,N],[12,"denom","","",9,N],[12,"dof_ratio","","",9,N],[3,"StudentT","","The Student t distribution, `t(nu)`, where `nu` is the degrees of freedom.",N,N],[12,"chi","","",10,N],[12,"dof","","",10,N],[4,"GammaRepr","","",N,N],[13,"Large","","",31,N],[13,"One","","",31,N],[13,"Small","","",31,N],[4,"ChiSquaredRepr","","",N,N],[13,"DoFExactlyOne","","",32,N],[13,"DoFAnythingElse","","",32,N],[11,"clone","","",7,[[["self"]],["gamma"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"clone","","",31,[[["self"]],["gammarepr"]]],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"clone","","",29,[[["self"]],["gammasmallshape"]]],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"clone","","",30,[[["self"]],["gammalargeshape"]]],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct an object representing the `Gamma(shape, scale)` distribution.",7,[[["f64"],["f64"]],["gamma"]]],[11,"new_raw","","",29,[[["f64"],["f64"]],["gammasmallshape"]]],[11,"new_raw","","",30,[[["f64"],["f64"]],["gammalargeshape"]]],[11,"sample","","",7,[[["self"],["r"]],["f64"]]],[11,"sample","","",29,[[["self"],["r"]],["f64"]]],[11,"sample","","",30,[[["self"],["r"]],["f64"]]],[11,"clone","","",8,[[["self"]],["chisquared"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"clone","","",32,[[["self"]],["chisquaredrepr"]]],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new chi-squared distribution with degrees-of-freedom `k`. Panics if `k < 0`.",8,[[["f64"]],["chisquared"]]],[11,"sample","","",8,[[["self"],["r"]],["f64"]]],[11,"clone","","",9,[[["self"]],["fisherf"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `FisherF` distribution, with the given parameter. Panics if either `m` or `n` are not positive.",9,[[["f64"],["f64"]],["fisherf"]]],[11,"sample","","",9,[[["self"],["r"]],["f64"]]],[11,"clone","","",10,[[["self"]],["studentt"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new Student t distribution with `n` degrees of freedom. Panics if `n <= 0`.",10,[[["f64"]],["studentt"]]],[11,"sample","","",10,[[["self"],["r"]],["f64"]]],[0,"normal","rand::distributions","The normal and derived distributions.",N,N],[3,"StandardNormal","rand::distributions::normal","Samples floating-point numbers according to the normal distribution `N(0, 1)` (a.k.a. a standard normal, or Gaussian). This is equivalent to `Normal::new(0.0, 1.0)` but faster.",N,N],[3,"Normal","","The normal distribution `N(mean, std_dev**2)`.",N,N],[12,"mean","","",11,N],[12,"std_dev","","",11,N],[3,"LogNormal","","The log-normal distribution `ln N(mean, std_dev**2)`.",N,N],[12,"norm","","",12,N],[11,"clone","","",33,[[["self"]],["standardnormal"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"sample","","",33,[[["self"],["r"]],["f64"]]],[11,"clone","","",11,[[["self"]],["normal"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new `Normal` distribution with the given mean and standard deviation.",11,[[["f64"],["f64"]],["normal"]]],[11,"sample","","",11,[[["self"],["r"]],["f64"]]],[11,"clone","","",12,[[["self"]],["lognormal"]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new `LogNormal` distribution with the given mean and standard deviation.",12,[[["f64"],["f64"]],["lognormal"]]],[11,"sample","","",12,[[["self"],["r"]],["f64"]]],[0,"exponential","rand::distributions","The exponential distribution.",N,N],[3,"Exp1","rand::distributions::exponential","Samples floating-point numbers according to the exponential distribution, with rate parameter `λ = 1`. This is equivalent to `Exp::new(1.0)` or sampling with `-rng.gen::<f64>().ln()`, but faster.",N,N],[3,"Exp","","The exponential distribution `Exp(lambda)`.",N,N],[12,"lambda_inverse","","`lambda` stored as `1/lambda`, since this is what we scale by.",13,N],[11,"clone","","",34,[[["self"]],["exp1"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"sample","","",34,[[["self"],["r"]],["f64"]]],[11,"clone","","",13,[[["self"]],["exp"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new `Exp` with the given shape parameter `lambda`. Panics if `lambda <= 0`.",13,[[["f64"]],["exp"]]],[11,"sample","","",13,[[["self"],["r"]],["f64"]]],[0,"pareto","rand::distributions","The Pareto distribution.",N,N],[3,"Pareto","rand::distributions::pareto","Samples floating-point numbers according to the Pareto distribution",N,N],[12,"scale","","",14,N],[12,"inv_neg_shape","","",14,N],[11,"clone","","",14,[[["self"]],["pareto"]]],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new Pareto distribution with given `scale` and `shape`.",14,[[["f64"],["f64"]],["pareto"]]],[11,"sample","","",14,[[["self"],["r"]],["f64"]]],[0,"poisson","rand::distributions","The Poisson distribution.",N,N],[3,"Poisson","rand::distributions::poisson","The Poisson distribution `Poisson(lambda)`.",N,N],[12,"lambda","","",15,N],[12,"exp_lambda","","",15,N],[12,"log_lambda","","",15,N],[12,"sqrt_2lambda","","",15,N],[12,"magic_val","","",15,N],[11,"clone","","",15,[[["self"]],["poisson"]]],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new `Poisson` with the given shape parameter `lambda`. Panics if `lambda <= 0`.",15,[[["f64"]],["poisson"]]],[11,"sample","","",15,[[["self"],["r"]],["u64"]]],[0,"binomial","rand::distributions","The binomial distribution.",N,N],[3,"Binomial","rand::distributions::binomial","The binomial distribution `Binomial(n, p)`.",N,N],[12,"n","","Number of trials.",16,N],[12,"p","","Probability of success.",16,N],[11,"clone","","",16,[[["self"]],["binomial"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new `Binomial` with the given shape parameters `n` (number of trials) and `p` (probability of success).",16,[[["u64"],["f64"]],["binomial"]]],[11,"sample","","",16,[[["self"],["r"]],["u64"]]],[0,"bernoulli","rand::distributions","The Bernoulli distribution.",N,N],[3,"Bernoulli","rand::distributions::bernoulli","The Bernoulli distribution.",N,N],[12,"p_int","","Probability of success, relative to the maximal integer.",17,N],[11,"clone","","",17,[[["self"]],["bernoulli"]]],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new `Bernoulli` with the given probability of success `p`.",17,[[["f64"]],["bernoulli"]]],[11,"sample","","",17,[[["self"],["r"]],["bool"]]],[0,"cauchy","rand::distributions","The Cauchy distribution.",N,N],[3,"Cauchy","rand::distributions::cauchy","The Cauchy distribution `Cauchy(median, scale)`.",N,N],[12,"median","","",18,N],[12,"scale","","",18,N],[11,"clone","","",18,[[["self"]],["cauchy"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"new","","Construct a new `Cauchy` with the given shape parameters `median` the peak location and `scale` the scale factor. Panics if `scale <= 0`.",18,[[["f64"],["f64"]],["cauchy"]]],[11,"sample","","",18,[[["self"],["r"]],["f64"]]],[0,"float","rand::distributions","Basic floating-point number distributions",N,N],[3,"OpenClosed01","rand::distributions::float","A distribution to sample floating point numbers uniformly in the half-open interval `(0, 1]`, i.e. including 1 but not 0.",N,N],[3,"Open01","","A distribution to sample floating point numbers uniformly in the open interval `(0, 1)`, i.e. not including either endpoint.",N,N],[8,"IntoFloat","","",N,N],[16,"F","","",35,N],[10,"into_float_with_exponent","","Helper method to combine the fraction and a contant exponent into a float.",35,N],[11,"clone","rand::distributions","",36,[[["self"]],["openclosed01"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"clone","","",37,[[["self"]],["open01"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"sample","","",38,[[["self"],["r"]],["f32"]]],[11,"sample","","",36,[[["self"],["r"]],["f32"]]],[11,"sample","","",37,[[["self"],["r"]],["f32"]]],[11,"sample","","",38,[[["self"],["r"]],["f64"]]],[11,"sample","","",36,[[["self"],["r"]],["f64"]]],[11,"sample","","",37,[[["self"],["r"]],["f64"]]],[0,"integer","","The implementations of the `Standard` distribution for integer types.",N,N],[11,"sample","","",38,[[["self"],["r"]],["u8"]]],[11,"sample","","",38,[[["self"],["r"]],["u16"]]],[11,"sample","","",38,[[["self"],["r"]],["u32"]]],[11,"sample","","",38,[[["self"],["r"]],["u64"]]],[11,"sample","","",38,[[["self"],["r"]],["usize"]]],[11,"sample","","",38,[[["self"],["r"]],["i8"]]],[11,"sample","","",38,[[["self"],["r"]],["i16"]]],[11,"sample","","",38,[[["self"],["r"]],["i32"]]],[11,"sample","","",38,[[["self"],["r"]],["i64"]]],[11,"sample","","",38,[[["self"],["r"]],["isize"]]],[0,"log_gamma","","",N,N],[5,"log_gamma","rand::distributions::log_gamma","Calculates ln(gamma(x)) (natural logarithm of the gamma function) using the Lanczos approximation.",N,[[["f64"]],["f64"]]],[0,"other","rand::distributions","The implementations of the `Standard` distribution for other built-in types.",N,N],[3,"Alphanumeric","rand::distributions::other","Sample a `char`, uniformly distributed over ASCII letters and numbers: a-z, A-Z and 0-9.",N,N],[11,"fmt","rand::distributions","",39,[[["self"],["formatter"]],["result"]]],[11,"sample","","",38,[[["self"],["r"]],["char"]]],[11,"sample","","",39,[[["self"],["r"]],["char"]]],[11,"sample","","",38,[[["self"],["r"]],["bool"]]],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,N],[11,"sample","","",38,[[["self"],["r"]],["option"]]],[11,"sample","","",38,[[["self"],["r"]],["wrapping"]]],[0,"ziggurat_tables","","",N,N],[6,"ZigTable","rand::distributions::ziggurat_tables","",N,N],[7,"ZIG_NORM_X","","",N,N],[7,"ZIG_NORM_F","","",N,N],[7,"ZIG_EXP_X","","",N,N],[7,"ZIG_EXP_F","","",N,N],[17,"ZIG_NORM_R","","",N,N],[17,"ZIG_EXP_R","","",N,N],[0,"range","rand::distributions","DEPRECATED: Use `distributions::uniform` instead.",N,N],[0,"impls","","",N,N],[11,"sample","","",21,[[["self"],["r"]],["t"]]],[11,"ind_sample","","",21,[[["self"],["r"]],["t"]]],[11,"sample","rand::distributions::uniform","",6,[[["self"],["r"]],["t"]]],[11,"ind_sample","","",6,[[["self"],["r"]],["t"]]],[11,"sample","rand::distributions::exponential","",13,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",13,[[["self"],["r"]],["f64"]]],[11,"sample","rand::distributions::gamma","",7,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",7,[[["self"],["r"]],["f64"]]],[11,"sample","","",8,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",8,[[["self"],["r"]],["f64"]]],[11,"sample","","",9,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",9,[[["self"],["r"]],["f64"]]],[11,"sample","","",10,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",10,[[["self"],["r"]],["f64"]]],[11,"sample","rand::distributions::normal","",11,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",11,[[["self"],["r"]],["f64"]]],[11,"sample","","",12,[[["self"],["r"]],["f64"]]],[11,"ind_sample","","",12,[[["self"],["r"]],["f64"]]],[8,"Sample","rand::distributions","Types that can be used to create a random instance of `Support`.",N,N],[10,"sample","","Generate a random value of `Support`, using `rng` as the source of randomness.",40,[[["self"],["r"]],["support"]]],[8,"IndependentSample","","`Sample`s that do not require keeping track of state.",N,N],[10,"ind_sample","","Generate a random value.",41,[[["self"],["r"]],["support"]]],[8,"Distribution","","Types (distributions) that can be used to create a random instance of `T`.",N,N],[10,"sample","","Generate a random value of `T`, using `rng` as the source of randomness.",42,[[["self"],["r"]],["t"]]],[11,"sample_iter","","Create an iterator that generates random values of `T`, using `rng` as the source of randomness.",42,[[["self"],["r"]],["distiter"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"next","","",19,[[["self"]],["option"]]],[11,"size_hint","","",19,N],[11,"clone","","",38,[[["self"]],["standard"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"clone","","",20,[[["self"]],["weighted"]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `WeightedChoice`.",21,N],[11,"sample","","",21,[[["self"],["r"]],["t"]]],[0,"prelude","rand","Convenience re-export of common members",N,N],[0,"prng","","Pseudo-random number generators.",N,N],[3,"XorShiftRng","rand::prng","An Xorshift random number generator.",N,N],[12,"x","","",43,N],[12,"y","","",43,N],[12,"z","","",43,N],[12,"w","","",43,N],[0,"chacha","","The ChaCha random number generator.",N,N],[3,"ChaChaRng","rand::prng::chacha","A cryptographically secure random number generator that uses the ChaCha algorithm.",N,N],[12,"0","","",44,N],[3,"ChaChaCore","","The core of `ChaChaRng`, used with `BlockRng`.",N,N],[12,"state","","",45,N],[17,"SEED_WORDS","","",N,N],[17,"STATE_WORDS","","",N,N],[11,"clone","","",44,[[["self"]],["chacharng"]]],[11,"fmt","","",44,[[["self"],["formatter"]],["result"]]],[11,"next_u32","","",44,[[["self"]],["u32"]]],[11,"next_u64","","",44,[[["self"]],["u64"]]],[11,"fill_bytes","","",44,N],[11,"try_fill_bytes","","",44,N],[11,"from_seed","","",44,N],[11,"from_rng","","",44,[[["r"]],["result",["error"]]]],[11,"new_unseeded","","Create an ChaCha random number generator using the default fixed key of 8 zero words.",44,[[],["chacharng"]]],[11,"set_stream","","Set the stream number.",44,[[["self"],["u64"]]]],[11,"clone","","",45,[[["self"]],["chachacore"]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"generate","","",45,N],[11,"from_seed","","",45,N],[11,"from","","",44,[[["chachacore"]],["self"]]],[0,"hc128","rand::prng","The HC-128 random number generator.",N,N],[3,"Hc128Rng","rand::prng::hc128","A cryptographically secure random number generator that uses the HC-128 algorithm.",N,N],[12,"0","","",46,N],[3,"Hc128Core","","The core of `Hc128Rng`, used with `BlockRng`.",N,N],[12,"t","","",47,N],[12,"counter1024","","",47,N],[17,"SEED_WORDS","","",N,N],[11,"clone","","",46,[[["self"]],["hc128rng"]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"next_u32","","",46,[[["self"]],["u32"]]],[11,"next_u64","","",46,[[["self"]],["u64"]]],[11,"fill_bytes","","",46,N],[11,"try_fill_bytes","","",46,N],[11,"from_seed","","",46,N],[11,"from_rng","","",46,[[["r"]],["result",["error"]]]],[11,"clone","","",47,[[["self"]],["hc128core"]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"generate","","",47,N],[11,"step_p","","",47,[[["self"],["usize"],["usize"],["usize"],["usize"],["usize"]],["u32"]]],[11,"step_q","","",47,[[["self"],["usize"],["usize"],["usize"],["usize"],["usize"]],["u32"]]],[11,"sixteen_steps","","",47,[[["self"]]]],[11,"init","","",47,N],[11,"from_seed","","Create an HC-128 random number generator with a seed. The seed has to be 256 bits in length, matching the 128 bit `key` followed by 128 bit `iv` when HC-128 where to be used as a stream cipher.",47,N],[0,"isaac","rand::prng","The ISAAC random number generator.",N,N],[3,"IsaacRng","rand::prng::isaac","A random number generator that uses the ISAAC algorithm.",N,N],[12,"0","","",48,N],[3,"IsaacCore","","The core of `IsaacRng`, used with `BlockRng`.",N,N],[12,"mem","","",49,N],[12,"a","","",49,N],[12,"b","","",49,N],[12,"c","","",49,N],[6,"w32","","",N,N],[17,"RAND_SIZE_LEN","","",N,N],[17,"RAND_SIZE","","",N,N],[11,"clone","","",48,[[["self"]],["isaacrng"]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"next_u32","","",48,[[["self"]],["u32"]]],[11,"next_u64","","",48,[[["self"]],["u64"]]],[11,"fill_bytes","","",48,N],[11,"try_fill_bytes","","",48,N],[11,"from_seed","","",48,N],[11,"from_rng","","",48,[[["s"]],["result",["error"]]]],[11,"new_unseeded","","Create an ISAAC random number generator using the default fixed seed.",48,[[],["self"]]],[11,"new_from_u64","","Create an ISAAC random number generator using an `u64` as seed. If `seed == 0` this will produce the same stream of random numbers as the reference implementation when used unseeded.",48,[[["u64"]],["self"]]],[11,"clone","","",49,[[["self"]],["isaaccore"]]],[11,"fmt","","",49,[[["self"],["formatter"]],["result"]]],[11,"generate","","Refills the output buffer, `results`. See also the pseudocode desciption of the algorithm in the [`IsaacRng`] documentation.",49,[[["self"],["isaacarray"]]]],[11,"init","","Create a new ISAAC random number generator.",49,N],[11,"new_from_u64","","Create an ISAAC random number generator using an `u64` as seed. If `seed == 0` this will produce the same stream of random numbers as the reference implementation when used unseeded.",49,[[["u64"]],["self"]]],[11,"from_seed","","",49,N],[11,"from_rng","","",49,[[["r"]],["result",["error"]]]],[0,"isaac64","rand::prng","The ISAAC-64 random number generator.",N,N],[3,"Isaac64Rng","rand::prng::isaac64","A random number generator that uses ISAAC-64, the 64-bit variant of the ISAAC algorithm.",N,N],[12,"0","","",50,N],[3,"Isaac64Core","","The core of `Isaac64Rng`, used with `BlockRng`.",N,N],[12,"mem","","",51,N],[12,"a","","",51,N],[12,"b","","",51,N],[12,"c","","",51,N],[6,"w64","","",N,N],[17,"RAND_SIZE_LEN","","",N,N],[17,"RAND_SIZE","","",N,N],[11,"clone","","",50,[[["self"]],["isaac64rng"]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"next_u32","","",50,[[["self"]],["u32"]]],[11,"next_u64","","",50,[[["self"]],["u64"]]],[11,"fill_bytes","","",50,N],[11,"try_fill_bytes","","",50,N],[11,"from_seed","","",50,N],[11,"from_rng","","",50,[[["s"]],["result",["error"]]]],[11,"new_unseeded","","Create a 64-bit ISAAC random number generator using the default fixed seed.",50,[[],["self"]]],[11,"new_from_u64","","Create an ISAAC-64 random number generator using an `u64` as seed. If `seed == 0` this will produce the same stream of random numbers as the reference implementation when used unseeded.",50,[[["u64"]],["self"]]],[11,"clone","","",51,[[["self"]],["isaac64core"]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"generate","","Refills the output buffer, `results`. See also the pseudocode desciption of the algorithm in the [`Isaac64Rng`] documentation.",51,[[["self"],["isaacarray"]]]],[11,"init","","Create a new ISAAC-64 random number generator.",51,N],[11,"new_from_u64","","Create an ISAAC-64 random number generator using an `u64` as seed. If `seed == 0` this will produce the same stream of random numbers as the reference implementation when used unseeded.",51,[[["u64"]],["self"]]],[11,"from_seed","","",51,N],[11,"from_rng","","",51,[[["r"]],["result",["error"]]]],[0,"xorshift","rand::prng","Xorshift generators",N,N],[3,"XorShiftRng","rand::prng::xorshift","An Xorshift random number generator.",N,N],[12,"x","","",43,N],[12,"y","","",43,N],[12,"z","","",43,N],[12,"w","","",43,N],[11,"clone","rand::prng","",43,[[["self"]],["xorshiftrng"]]],[11,"fmt","","",43,[[["self"],["formatter"]],["result"]]],[11,"new_unseeded","","Creates a new XorShiftRng instance which is not seeded.",43,[[],["xorshiftrng"]]],[11,"next_u32","","",43,[[["self"]],["u32"]]],[11,"next_u64","","",43,[[["self"]],["u64"]]],[11,"fill_bytes","","",43,N],[11,"try_fill_bytes","","",43,N],[11,"from_seed","","",43,N],[11,"from_rng","","",43,[[["r"]],["result",["error"]]]],[0,"isaac_array","","ISAAC helper functions for 256-element arrays.",N,N],[3,"IsaacArray","rand::prng::isaac_array","",N,N],[12,"inner","","",52,N],[17,"RAND_SIZE_LEN","","",N,N],[17,"RAND_SIZE","","",N,N],[11,"clone","","",52,[[["self"]],["isaacarray"]]],[11,"as_ref","","",52,N],[11,"as_mut","","",52,N],[11,"deref","","",52,N],[11,"deref_mut","","",52,N],[11,"default","","",52,[[],["isaacarray"]]],[0,"rngs","rand","Random number generators and adapters for common usage:",N,N],[3,"JitterRng","rand::rngs","A true random number generator based on jitter in the CPU execution time, and jitter in memory access time.",N,N],[12,"data","","",53,N],[12,"rounds","","",53,N],[12,"timer","","",53,N],[12,"mem_prev_index","","",53,N],[12,"data_half_used","","",53,N],[3,"EntropyRng","","An interface returning random data from external source(s), provided specifically for securely seeding algorithmic generators (PRNGs).",N,N],[12,"source","","",54,N],[3,"SmallRng","","An RNG recommended when small state, cheap initialization and good performance are required. The PRNG algorithm in `SmallRng` is chosen to be efficient on the current platform, without consideration for cryptography or security. The size of its state is much smaller than for [`StdRng`].",N,N],[12,"0","","",55,N],[3,"StdRng","","The standard RNG. The PRNG algorithm in `StdRng` is chosen to be efficient on the current platform, to be statistically strong and unpredictable (meaning a cryptographically secure PRNG).",N,N],[12,"0","","",56,N],[3,"ThreadRng","","The type returned by [`thread_rng`], essentially just a reference to the PRNG in thread-local memory.",N,N],[12,"rng","","",57,N],[3,"OsRng","","A random number generator that retrieves randomness straight from the operating system.",N,N],[12,"0","","",58,N],[4,"TimerError","","An error that can occur when [`JitterRng::test_timer`] fails.",N,N],[13,"NoTimer","","No timer available.",59,N],[13,"CoarseTimer","","Timer too coarse to use as an entropy source.",59,N],[13,"NotMonotonic","","Timer is not monotonically increasing.",59,N],[13,"TinyVariantions","","Variations of deltas of time too small.",59,N],[13,"TooManyStuck","","Too many stuck results (indicating no added entropy).",59,N],[13,"__Nonexhaustive","","",59,N],[0,"adapter","","Wrappers / adapters forming RNGs",N,N],[3,"ReadRng","rand::rngs::adapter","An RNG that reads random bytes straight from any type supporting `std::io::Read`, for example files.",N,N],[12,"reader","","",60,N],[3,"ReseedingRng","","A wrapper around any PRNG which reseeds the underlying PRNG after it has generated a certain number of random bytes.",N,N],[12,"0","","",61,N],[0,"read","","A wrapper around any Read to treat it as an RNG.",N,N],[3,"ReadRng","rand::rngs::adapter::read","An RNG that reads random bytes straight from any type supporting `std::io::Read`, for example files.",N,N],[12,"reader","","",60,N],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `ReadRng` from a `Read`.",60,[[["r"]],["readrng"]]],[11,"next_u32","","",60,[[["self"]],["u32"]]],[11,"next_u64","","",60,[[["self"]],["u64"]]],[11,"fill_bytes","","",60,N],[11,"try_fill_bytes","","",60,N],[0,"reseeding","rand::rngs::adapter","A wrapper around another PRNG that reseeds it after it generates a certain number of random bytes.",N,N],[3,"ReseedingRng","rand::rngs::adapter::reseeding","A wrapper around any PRNG which reseeds the underlying PRNG after it has generated a certain number of random bytes.",N,N],[12,"0","","",61,N],[3,"ReseedingCore","","",N,N],[12,"inner","","",62,N],[12,"reseeder","","",62,N],[12,"threshold","","",62,N],[12,"bytes_until_reseed","","",62,N],[11,"fmt","rand::rngs::adapter","",61,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `ReseedingRng` with the given parameters.",61,[[["r"],["u64"],["rsdr"]],["self"]]],[11,"reseed","","Reseed the internal PRNG.",61,[[["self"]],["result",["error"]]]],[11,"next_u32","","",61,[[["self"]],["u32"]]],[11,"next_u64","","",61,[[["self"]],["u64"]]],[11,"fill_bytes","","",61,N],[11,"try_fill_bytes","","",61,N],[11,"clone","","",61,[[["self"]],["reseedingrng"]]],[11,"fmt","rand::rngs::adapter::reseeding","",62,[[["self"],["formatter"]],["result"]]],[11,"generate","","",62,N],[11,"new","","Create a new `ReseedingCore` with the given parameters.",62,[[["r"],["u64"],["rsdr"]],["self"]]],[11,"reseed","","Reseed the internal PRNG.",62,[[["self"]],["result",["error"]]]],[11,"reseed_and_generate","","",62,N],[11,"clone","","",62,[[["self"]],["reseedingcore"]]],[0,"entropy","rand::rngs","Entropy generator, or wrapper around external generators",N,N],[3,"EntropyRng","rand::rngs::entropy","An interface returning random data from external source(s), provided specifically for securely seeding algorithmic generators (PRNGs).",N,N],[12,"source","","",54,N],[3,"NoSource","","",N,N],[3,"Os","","",N,N],[12,"0","","",63,N],[3,"Jitter","","",N,N],[12,"0","","",64,N],[4,"Source","","",N,N],[13,"Os","","",65,N],[13,"Custom","","",65,N],[13,"Jitter","","",65,N],[13,"None","","",65,N],[6,"Custom","","",N,N],[8,"EntropySource","","",N,N],[10,"new_and_fill","","",66,N],[10,"fill","","",66,N],[11,"is_supported","","",66,[[],["bool"]]],[11,"fmt","rand::rngs","",54,[[["self"],["formatter"]],["result"]]],[11,"fmt","rand::rngs::entropy","",65,[[["self"],["formatter"]],["result"]]],[11,"new","rand::rngs","Create a new `EntropyRng`.",54,[[],["self"]]],[11,"default","","",54,[[],["self"]]],[11,"next_u32","","",54,[[["self"]],["u32"]]],[11,"next_u64","","",54,[[["self"]],["u64"]]],[11,"fill_bytes","","",54,N],[11,"try_fill_bytes","","",54,N],[11,"clone","rand::rngs::entropy","",67,[[["self"]],["nosource"]]],[11,"fmt","","",67,[[["self"],["formatter"]],["result"]]],[11,"new_and_fill","","",67,N],[11,"fill","","",67,N],[11,"is_supported","","",67,[[],["bool"]]],[11,"clone","","",63,[[["self"]],["os"]]],[11,"fmt","","",63,[[["self"],["formatter"]],["result"]]],[11,"new_and_fill","","",63,N],[11,"fill","","",63,N],[11,"clone","","",64,[[["self"]],["jitter"]]],[11,"fmt","","",64,[[["self"],["formatter"]],["result"]]],[11,"new_and_fill","","",64,N],[11,"fill","","",64,N],[0,"jitter","rand::rngs","Non-physical true random number generator based on timing jitter.",N,N],[3,"JitterRng","rand::rngs::jitter","A true random number generator based on jitter in the CPU execution time, and jitter in memory access time.",N,N],[12,"data","","",53,N],[12,"rounds","","",53,N],[12,"timer","","",53,N],[12,"mem_prev_index","","",53,N],[12,"data_half_used","","",53,N],[3,"EcState","","",N,N],[12,"prev_time","","",68,N],[12,"last_delta","","",68,N],[12,"last_delta2","","",68,N],[12,"mem","","",68,N],[4,"TimerError","","An error that can occur when [`JitterRng::test_timer`] fails.",N,N],[13,"NoTimer","","No timer available.",59,N],[13,"CoarseTimer","","Timer too coarse to use as an entropy source.",59,N],[13,"NotMonotonic","","Timer is not monotonically increasing.",59,N],[13,"TinyVariantions","","Variations of deltas of time too small.",59,N],[13,"TooManyStuck","","Too many stuck results (indicating no added entropy).",59,N],[13,"__Nonexhaustive","","",59,N],[5,"black_box","","",N,[[["t"]],["t"]]],[0,"platform","","",N,N],[5,"get_nstime","rand::rngs::jitter::platform","",N,[[],["u64"]]],[7,"JITTER_ROUNDS","rand::rngs::jitter","",N,N],[17,"MEMORY_BLOCKS","","",N,N],[17,"MEMORY_BLOCKSIZE","","",N,N],[17,"MEMORY_SIZE","","",N,N],[11,"stuck","","",68,[[["self"],["i32"]],["bool"]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"clone","","",53,[[["self"]],["jitterrng"]]],[11,"fmt","","",59,[[["self"],["formatter"]],["result"]]],[11,"clone","","",59,[[["self"]],["timererror"]]],[11,"eq","","",59,[[["self"],["timererror"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",59,N],[11,"description","","",59,[[["self"]],["str"]]],[11,"fmt","","",59,[[["self"],["formatter"]],["result"]]],[11,"description","","",59,[[["self"]],["str"]]],[11,"from","rand","",3,[[["timererror"]],["error"]]],[11,"new","rand::rngs::jitter","Create a new `JitterRng`. Makes use of `std::time` for a timer, or a platform-specific function with higher accuracy if necessary and available.",53,[[],["result",["jitterrng","timererror"]]]],[11,"new_with_timer","","Create a new `JitterRng`. A custom timer can be supplied, making it possible to use `JitterRng` in `no_std` environments.",53,N],[11,"set_rounds","","Configures how many rounds are used to generate each 64-bit value. This must be greater than zero, and has a big impact on performance and output quality.",53,[[["self"],["u8"]]]],[11,"random_loop_cnt","","",53,[[["self"],["u32"]],["u32"]]],[11,"lfsr_time","","",53,[[["self"],["u64"],["bool"]]]],[11,"memaccess","","",53,N],[11,"measure_jitter","","",53,[[["self"],["ecstate"]],["option"]]],[11,"stir_pool","","",53,[[["self"]]]],[11,"gen_entropy","","",53,[[["self"]],["u64"]]],[11,"test_timer","","Basic quality tests on the timer, by measuring CPU timing jitter a few hundred times.",53,[[["self"]],["result",["u8","timererror"]]]],[11,"timer_stats","","Statistical test: return the timer delta of one normal run of the `JitterRng` entropy collector.",53,[[["self"],["bool"]],["i64"]]],[11,"next_u32","","",53,[[["self"]],["u32"]]],[11,"next_u64","","",53,[[["self"]],["u64"]]],[11,"fill_bytes","","",53,N],[11,"try_fill_bytes","","",53,N],[0,"mock","rand::rngs","Mock random number generator",N,N],[3,"StepRng","rand::rngs::mock","A simple implementation of `RngCore` for testing purposes.",N,N],[12,"v","","",69,N],[12,"a","","",69,N],[11,"fmt","","",69,[[["self"],["formatter"]],["result"]]],[11,"clone","","",69,[[["self"]],["steprng"]]],[11,"new","","Create a `StepRng`, yielding an arithmetic sequence starting with `initial` and incremented by `increment` each time.",69,[[["u64"],["u64"]],["self"]]],[11,"next_u32","","",69,[[["self"]],["u32"]]],[11,"next_u64","","",69,[[["self"]],["u64"]]],[11,"fill_bytes","","",69,N],[11,"try_fill_bytes","","",69,N],[0,"small","rand::rngs","A small fast RNG",N,N],[3,"SmallRng","rand::rngs::small","An RNG recommended when small state, cheap initialization and good performance are required. The PRNG algorithm in `SmallRng` is chosen to be efficient on the current platform, without consideration for cryptography or security. The size of its state is much smaller than for [`StdRng`].",N,N],[12,"0","","",55,N],[11,"clone","rand::rngs","",55,[[["self"]],["smallrng"]]],[11,"fmt","","",55,[[["self"],["formatter"]],["result"]]],[11,"next_u32","","",55,[[["self"]],["u32"]]],[11,"next_u64","","",55,[[["self"]],["u64"]]],[11,"fill_bytes","","",55,N],[11,"try_fill_bytes","","",55,N],[11,"from_seed","","",55,N],[11,"from_rng","","",55,[[["r"]],["result",["error"]]]],[0,"std","","The standard RNG",N,N],[3,"StdRng","rand::rngs::std","The standard RNG. The PRNG algorithm in `StdRng` is chosen to be efficient on the current platform, to be statistically strong and unpredictable (meaning a cryptographically secure PRNG).",N,N],[12,"0","","",56,N],[11,"clone","rand::rngs","",56,[[["self"]],["stdrng"]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"next_u32","","",56,[[["self"]],["u32"]]],[11,"next_u64","","",56,[[["self"]],["u64"]]],[11,"fill_bytes","","",56,N],[11,"try_fill_bytes","","",56,N],[11,"from_seed","","",56,N],[11,"from_rng","","",56,[[["r"]],["result",["error"]]]],[0,"thread","","Thread-local random number generator",N,N],[3,"ThreadRng","rand::rngs::thread","The type returned by [`thread_rng`], essentially just a reference to the PRNG in thread-local memory.",N,N],[12,"rng","","",57,N],[5,"thread_rng","","Retrieve the lazily-initialized thread-local random number generator, seeded by the system. Intended to be used in method chaining style, e.g. `thread_rng().gen::<i32>()`, or cached locally, e.g. `let mut rng = thread_rng();`.",N,[[],["threadrng"]]],[17,"THREAD_RNG_RESEED_THRESHOLD","","",N,N],[17,"THREAD_RNG_KEY","","",N,N],[11,"clone","rand::rngs","",57,[[["self"]],["threadrng"]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"next_u32","","",57,[[["self"]],["u32"]]],[11,"next_u64","","",57,[[["self"]],["u64"]]],[11,"fill_bytes","","",57,N],[11,"try_fill_bytes","","",57,N],[0,"os","","Interface to the random number generator of the operating system.",N,N],[3,"OsRng","rand::rngs::os","A random number generator that retrieves randomness straight from the operating system.",N,N],[12,"0","","",58,N],[0,"random_device","","",N,N],[5,"open","rand::rngs::os::random_device","",N,[[["str"],["f"]],["result",["error"]]]],[5,"read","","",N,N],[5,"map_err","","",N,[[["error"]],["error"]]],[7,"READ_RNG_FILE","","",N,N],[7,"READ_RNG_ONCE","","",N,N],[0,"imp","rand::rngs::os","",N,N],[3,"OsRng","rand::rngs::os::imp","",N,N],[12,"method","","",70,N],[12,"initialized","","",70,N],[4,"OsRngMethod","","",N,N],[13,"GetRandom","","",71,N],[13,"RandomDevice","","",71,N],[5,"getrandom","","",N,N],[5,"getrandom_try_fill","","",N,N],[5,"is_getrandom_available","","",N,[[],["bool"]]],[17,"NR_GETRANDOM","","",N,N],[11,"clone","","",70,[[["self"]],["osrng"]]],[11,"fmt","","",70,[[["self"],["formatter"]],["result"]]],[11,"clone","","",71,[[["self"]],["osrngmethod"]]],[11,"fmt","","",71,[[["self"],["formatter"]],["result"]]],[11,"new","","",70,[[],["result",["osrng","error"]]]],[11,"fill_chunk","","",70,N],[11,"test_initialized","","",70,N],[11,"method_str","","",70,[[["self"]],["str"]]],[8,"OsRngImpl","rand::rngs::os","",N,N],[10,"new","","",72,[[],["result",["error"]]]],[10,"fill_chunk","","",72,N],[11,"test_initialized","","",72,N],[11,"max_chunk_size","","",72,[[["self"]],["usize"]]],[10,"method_str","","",72,[[["self"]],["str"]]],[11,"clone","rand::rngs","",58,[[["self"]],["osrng"]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `OsRng`.",58,[[],["result",["osrng","error"]]]],[11,"next_u32","","",58,[[["self"]],["u32"]]],[11,"next_u64","","",58,[[["self"]],["u64"]]],[11,"fill_bytes","","",58,N],[11,"try_fill_bytes","","",58,N],[0,"seq","rand","Functions for randomly accessing and sampling sequences.",N,N],[5,"sample_iter","rand::seq","Randomly sample `amount` elements from a finite iterator.",N,[[["r"],["i"],["usize"]],["result",["vec","vec"]]]],[5,"sample_slice","","Randomly sample exactly `amount` values from `slice`.",N,N],[5,"sample_slice_ref","","Randomly sample exactly `amount` references from `slice`.",N,N],[5,"sample_indices","","Randomly sample exactly `amount` indices from `0..length`.",N,[[["r"],["usize"],["usize"]],["vec",["usize"]]]],[5,"sample_indices_inplace","","Sample an amount of indices using an inplace partial fisher yates method.",N,[[["r"],["usize"],["usize"]],["vec",["usize"]]]],[5,"sample_indices_cache","","This method performs a partial fisher-yates on a range of indices using a `HashMap` as a cache to record potential collisions.",N,[[["r"],["usize"],["usize"]],["vec",["usize"]]]],[0,"jitter","rand","",N,N],[3,"JitterRng","rand::jitter","A true random number generator based on jitter in the CPU execution time, and jitter in memory access time.",N,N],[12,"data","","",53,N],[12,"rounds","","",53,N],[12,"timer","","",53,N],[12,"mem_prev_index","","",53,N],[12,"data_half_used","","",53,N],[4,"TimerError","","An error that can occur when [`JitterRng::test_timer`] fails.",N,N],[13,"NoTimer","","No timer available.",59,N],[13,"CoarseTimer","","Timer too coarse to use as an entropy source.",59,N],[13,"NotMonotonic","","Timer is not monotonically increasing.",59,N],[13,"TinyVariantions","","Variations of deltas of time too small.",59,N],[13,"TooManyStuck","","Too many stuck results (indicating no added entropy).",59,N],[13,"__Nonexhaustive","","",59,N],[0,"os","rand","",N,N],[3,"OsRng","rand::os","A random number generator that retrieves randomness straight from the operating system.",N,N],[12,"0","","",58,N],[0,"chacha","rand","The ChaCha random number generator.",N,N],[0,"isaac","","The ISAAC random number generator.",N,N],[8,"Rand","","A type that can be randomly generated using an [`Rng`].",N,N],[10,"rand","","Generates a random instance of this type using the specified source of randomness.",73,[[["r"]],["self"]]],[8,"Rng","","An automatically-implemented extension trait on [`RngCore`] providing high-level generic methods for sampling values and other convenience methods.",N,N],[11,"gen","","Return a random value supporting the [`Standard`] distribution.",74,[[["self"]],["t"]]],[11,"gen_range","","Generate a random value in the range [`low`, `high`), i.e. inclusive of `low` and exclusive of `high`.",74,[[["self"],["t"],["t"]],["t"]]],[11,"sample","","Sample a new value, using the given distribution.",74,[[["self"],["d"]],["t"]]],[11,"sample_iter","","Create an iterator that generates values using the given distribution.",74,[[["self"],["d"]],["distiter"]]],[11,"fill","","Fill `dest` entirely with random bytes (uniform value distribution), where `dest` is any type supporting [`AsByteSliceMut`], namely slices and arrays over primitive integer types (`i8`, `i16`, `u32`, etc.).",74,[[["self"],["t"]]]],[11,"try_fill","","Fill `dest` entirely with random bytes (uniform value distribution), where `dest` is any type supporting [`AsByteSliceMut`], namely slices and arrays over primitive integer types (`i8`, `i16`, `u32`, etc.).",74,[[["self"],["t"]],["result",["error"]]]],[11,"gen_bool","","Return a bool with a probability `p` of being true.",74,[[["self"],["f64"]],["bool"]]],[11,"choose","","Return a random element from `values`.",74,N],[11,"choose_mut","","Return a mutable pointer to a random element from `values`.",74,N],[11,"shuffle","","Shuffle a mutable slice in place.",74,N],[11,"gen_iter","","Return an iterator that will yield an infinite number of randomly generated items.",74,[[["self"]],["generator"]]],[11,"gen_weighted_bool","","Return a bool with a 1 in n chance of true",74,[[["self"],["u32"]],["bool"]]],[11,"gen_ascii_chars","","Return an iterator of random characters from the set A-Z,a-z,0-9.",74,[[["self"]],["asciigenerator"]]],[8,"AsByteSliceMut","","Trait for casting types to byte slices",N,N],[10,"as_byte_slice_mut","","Return a mutable reference to self as a byte slice",75,N],[10,"to_le","","Call `to_le` on each element (i.e. byte-swap on Big Endian platforms).",75,[[["self"]]]],[8,"FromEntropy","","A convenience extension to [`SeedableRng`] allowing construction from fresh entropy. This trait is automatically implemented for any PRNG implementing [`SeedableRng`] and is not intended to be implemented by users.",N,N],[10,"from_entropy","","Creates a new instance, automatically seeded with fresh entropy.",76,[[],["self"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"next","","",4,[[["self"]],["option"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"next","","",5,[[["self"]],["option",["char"]]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"eq","","",2,[[["self"],["errorkind"]],["bool"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result",["error"]]]],[11,"description","","",3,[[["self"]],["str"]]],[11,"cause","","",3,[[["self"]],["option",["error"]]]],[11,"read","","",0,N],[11,"fmt","","",3,[[["self"],["formatter"]],["result",["error"]]]],[11,"clone","","",2,[[["self"]],["errorkind"]]],[11,"should_retry","","True if this kind of error may resolve itself on retry.",2,[[["self"]],["bool"]]],[11,"should_wait","","True if we should retry but wait before retrying",2,[[["self"]],["bool"]]],[11,"description","","A description of this error kind",2,[[["self"]],["str"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"new","","Create a new instance, with specified kind and a message.",3,[[["errorkind"],["str"]],["error"]]],[11,"with_cause","","Create a new instance, with specified kind, message, and a chained cause.",3,[[["errorkind"],["str"],["e"]],["error"]]],[11,"take_cause","","Take the cause, if any. This allows the embedded cause to be extracted. This uses `Option::take`, leaving `self` with no cause.",3,[[["self"]],["option",["box"]]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"to_string","","",3,[[["self"]],["string"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"into_iter","","",4,[[["self"]],["i"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"from","","",5,[[["t"]],["t"]]],[11,"into_iter","","",5,[[["self"]],["i"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"from","rand::distributions","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::uniform","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions","",36,[[["self"]],["t"]]],[11,"clone_into","","",36,N],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"to_owned","","",37,[[["self"]],["t"]]],[11,"clone_into","","",37,N],[11,"from","","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::gamma","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::normal","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"to_owned","","",12,[[["self"]],["t"]]],[11,"clone_into","","",12,N],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"to_owned","","",33,[[["self"]],["t"]]],[11,"clone_into","","",33,N],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::exponential","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"to_owned","","",34,[[["self"]],["t"]]],[11,"clone_into","","",34,N],[11,"from","","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::pareto","",14,[[["self"]],["t"]]],[11,"clone_into","","",14,N],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::poisson","",15,[[["self"]],["t"]]],[11,"clone_into","","",15,N],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::binomial","",16,[[["self"]],["t"]]],[11,"clone_into","","",16,N],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::bernoulli","",17,[[["self"]],["t"]]],[11,"clone_into","","",17,N],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::cauchy","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"from","rand::distributions","",19,[[["t"]],["t"]]],[11,"into_iter","","",19,[[["self"]],["i"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"to_owned","","",38,[[["self"]],["t"]]],[11,"clone_into","","",38,N],[11,"from","","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::uniform","",22,[[["self"]],["t"]]],[11,"clone_into","","",22,N],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"to_owned","","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"to_owned","","",24,[[["self"]],["t"]]],[11,"clone_into","","",24,N],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"to_owned","","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"to_owned","rand::distributions::gamma","",29,[[["self"]],["t"]]],[11,"clone_into","","",29,N],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"to_owned","","",30,[[["self"]],["t"]]],[11,"clone_into","","",30,N],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"to_owned","","",31,[[["self"]],["t"]]],[11,"clone_into","","",31,N],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"to_owned","","",32,[[["self"]],["t"]]],[11,"clone_into","","",32,N],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"from_entropy","rand::prng","",43,[[],["r"]]],[11,"to_owned","","",43,[[["self"]],["t"]]],[11,"clone_into","","",43,N],[11,"from","","",43,[[["t"]],["t"]]],[11,"into","","",43,[[["self"]],["u"]]],[11,"try_from","","",43,[[["u"]],["result"]]],[11,"borrow","","",43,[[["self"]],["t"]]],[11,"try_into","","",43,[[["self"]],["result"]]],[11,"borrow_mut","","",43,[[["self"]],["t"]]],[11,"get_type_id","","",43,[[["self"]],["typeid"]]],[11,"from_entropy","rand::prng::chacha","",44,[[],["r"]]],[11,"to_owned","","",44,[[["self"]],["t"]]],[11,"clone_into","","",44,N],[11,"from","","",44,[[["t"]],["t"]]],[11,"into","","",44,[[["self"]],["u"]]],[11,"try_from","","",44,[[["u"]],["result"]]],[11,"borrow","","",44,[[["self"]],["t"]]],[11,"try_into","","",44,[[["self"]],["result"]]],[11,"borrow_mut","","",44,[[["self"]],["t"]]],[11,"get_type_id","","",44,[[["self"]],["typeid"]]],[11,"from_entropy","","",45,[[],["r"]]],[11,"to_owned","","",45,[[["self"]],["t"]]],[11,"clone_into","","",45,N],[11,"from","","",45,[[["t"]],["t"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"from_entropy","rand::prng::hc128","",46,[[],["r"]]],[11,"to_owned","","",46,[[["self"]],["t"]]],[11,"clone_into","","",46,N],[11,"from","","",46,[[["t"]],["t"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"from_entropy","","",47,[[],["r"]]],[11,"to_owned","","",47,[[["self"]],["t"]]],[11,"clone_into","","",47,N],[11,"from","","",47,[[["t"]],["t"]]],[11,"into","","",47,[[["self"]],["u"]]],[11,"try_from","","",47,[[["u"]],["result"]]],[11,"borrow","","",47,[[["self"]],["t"]]],[11,"try_into","","",47,[[["self"]],["result"]]],[11,"borrow_mut","","",47,[[["self"]],["t"]]],[11,"get_type_id","","",47,[[["self"]],["typeid"]]],[11,"from_entropy","rand::prng::isaac","",48,[[],["r"]]],[11,"to_owned","","",48,[[["self"]],["t"]]],[11,"clone_into","","",48,N],[11,"from","","",48,[[["t"]],["t"]]],[11,"into","","",48,[[["self"]],["u"]]],[11,"try_from","","",48,[[["u"]],["result"]]],[11,"borrow","","",48,[[["self"]],["t"]]],[11,"try_into","","",48,[[["self"]],["result"]]],[11,"borrow_mut","","",48,[[["self"]],["t"]]],[11,"get_type_id","","",48,[[["self"]],["typeid"]]],[11,"from_entropy","","",49,[[],["r"]]],[11,"to_owned","","",49,[[["self"]],["t"]]],[11,"clone_into","","",49,N],[11,"from","","",49,[[["t"]],["t"]]],[11,"into","","",49,[[["self"]],["u"]]],[11,"try_from","","",49,[[["u"]],["result"]]],[11,"borrow","","",49,[[["self"]],["t"]]],[11,"try_into","","",49,[[["self"]],["result"]]],[11,"borrow_mut","","",49,[[["self"]],["t"]]],[11,"get_type_id","","",49,[[["self"]],["typeid"]]],[11,"from_entropy","rand::prng::isaac64","",50,[[],["r"]]],[11,"to_owned","","",50,[[["self"]],["t"]]],[11,"clone_into","","",50,N],[11,"from","","",50,[[["t"]],["t"]]],[11,"into","","",50,[[["self"]],["u"]]],[11,"try_from","","",50,[[["u"]],["result"]]],[11,"borrow","","",50,[[["self"]],["t"]]],[11,"try_into","","",50,[[["self"]],["result"]]],[11,"borrow_mut","","",50,[[["self"]],["t"]]],[11,"get_type_id","","",50,[[["self"]],["typeid"]]],[11,"from_entropy","","",51,[[],["r"]]],[11,"to_owned","","",51,[[["self"]],["t"]]],[11,"clone_into","","",51,N],[11,"from","","",51,[[["t"]],["t"]]],[11,"into","","",51,[[["self"]],["u"]]],[11,"try_from","","",51,[[["u"]],["result"]]],[11,"borrow","","",51,[[["self"]],["t"]]],[11,"try_into","","",51,[[["self"]],["result"]]],[11,"borrow_mut","","",51,[[["self"]],["t"]]],[11,"get_type_id","","",51,[[["self"]],["typeid"]]],[11,"to_owned","rand::prng::isaac_array","",52,[[["self"]],["t"]]],[11,"clone_into","","",52,N],[11,"from","","",52,[[["t"]],["t"]]],[11,"into","","",52,[[["self"]],["u"]]],[11,"try_from","","",52,[[["u"]],["result"]]],[11,"borrow","","",52,[[["self"]],["t"]]],[11,"try_into","","",52,[[["self"]],["result"]]],[11,"borrow_mut","","",52,[[["self"]],["t"]]],[11,"get_type_id","","",52,[[["self"]],["typeid"]]],[11,"to_owned","rand::jitter","",53,[[["self"]],["t"]]],[11,"clone_into","","",53,N],[11,"from","","",53,[[["t"]],["t"]]],[11,"into","","",53,[[["self"]],["u"]]],[11,"try_from","","",53,[[["u"]],["result"]]],[11,"borrow","","",53,[[["self"]],["t"]]],[11,"try_into","","",53,[[["self"]],["result"]]],[11,"borrow_mut","","",53,[[["self"]],["t"]]],[11,"get_type_id","","",53,[[["self"]],["typeid"]]],[11,"from","rand::rngs","",54,[[["t"]],["t"]]],[11,"into","","",54,[[["self"]],["u"]]],[11,"try_from","","",54,[[["u"]],["result"]]],[11,"borrow","","",54,[[["self"]],["t"]]],[11,"try_into","","",54,[[["self"]],["result"]]],[11,"borrow_mut","","",54,[[["self"]],["t"]]],[11,"get_type_id","","",54,[[["self"]],["typeid"]]],[11,"from_entropy","","",55,[[],["r"]]],[11,"to_owned","","",55,[[["self"]],["t"]]],[11,"clone_into","","",55,N],[11,"from","","",55,[[["t"]],["t"]]],[11,"into","","",55,[[["self"]],["u"]]],[11,"try_from","","",55,[[["u"]],["result"]]],[11,"borrow","","",55,[[["self"]],["t"]]],[11,"try_into","","",55,[[["self"]],["result"]]],[11,"borrow_mut","","",55,[[["self"]],["t"]]],[11,"get_type_id","","",55,[[["self"]],["typeid"]]],[11,"from_entropy","","",56,[[],["r"]]],[11,"to_owned","","",56,[[["self"]],["t"]]],[11,"clone_into","","",56,N],[11,"from","","",56,[[["t"]],["t"]]],[11,"into","","",56,[[["self"]],["u"]]],[11,"try_from","","",56,[[["u"]],["result"]]],[11,"borrow","","",56,[[["self"]],["t"]]],[11,"try_into","","",56,[[["self"]],["result"]]],[11,"borrow_mut","","",56,[[["self"]],["t"]]],[11,"get_type_id","","",56,[[["self"]],["typeid"]]],[11,"to_owned","","",57,[[["self"]],["t"]]],[11,"clone_into","","",57,N],[11,"from","","",57,[[["t"]],["t"]]],[11,"into","","",57,[[["self"]],["u"]]],[11,"try_from","","",57,[[["u"]],["result"]]],[11,"borrow","","",57,[[["self"]],["t"]]],[11,"try_into","","",57,[[["self"]],["result"]]],[11,"borrow_mut","","",57,[[["self"]],["t"]]],[11,"get_type_id","","",57,[[["self"]],["typeid"]]],[11,"to_owned","","",58,[[["self"]],["t"]]],[11,"clone_into","","",58,N],[11,"from","","",58,[[["t"]],["t"]]],[11,"into","","",58,[[["self"]],["u"]]],[11,"try_from","","",58,[[["u"]],["result"]]],[11,"borrow","","",58,[[["self"]],["t"]]],[11,"try_into","","",58,[[["self"]],["result"]]],[11,"borrow_mut","","",58,[[["self"]],["t"]]],[11,"get_type_id","","",58,[[["self"]],["typeid"]]],[11,"to_owned","rand::jitter","",59,[[["self"]],["t"]]],[11,"clone_into","","",59,N],[11,"from","","",59,[[["t"]],["t"]]],[11,"to_string","","",59,[[["self"]],["string"]]],[11,"into","","",59,[[["self"]],["u"]]],[11,"try_from","","",59,[[["u"]],["result"]]],[11,"borrow","","",59,[[["self"]],["t"]]],[11,"try_into","","",59,[[["self"]],["result"]]],[11,"borrow_mut","","",59,[[["self"]],["t"]]],[11,"get_type_id","","",59,[[["self"]],["typeid"]]],[11,"from","rand::rngs::adapter::read","",60,[[["t"]],["t"]]],[11,"into","","",60,[[["self"]],["u"]]],[11,"try_from","","",60,[[["u"]],["result"]]],[11,"borrow","","",60,[[["self"]],["t"]]],[11,"try_into","","",60,[[["self"]],["result"]]],[11,"borrow_mut","","",60,[[["self"]],["t"]]],[11,"get_type_id","","",60,[[["self"]],["typeid"]]],[11,"to_owned","rand::rngs::adapter","",61,[[["self"]],["t"]]],[11,"clone_into","","",61,N],[11,"from","","",61,[[["t"]],["t"]]],[11,"into","","",61,[[["self"]],["u"]]],[11,"try_from","","",61,[[["u"]],["result"]]],[11,"borrow","","",61,[[["self"]],["t"]]],[11,"try_into","","",61,[[["self"]],["result"]]],[11,"borrow_mut","","",61,[[["self"]],["t"]]],[11,"get_type_id","","",61,[[["self"]],["typeid"]]],[11,"to_owned","rand::rngs::adapter::reseeding","",62,[[["self"]],["t"]]],[11,"clone_into","","",62,N],[11,"from","","",62,[[["t"]],["t"]]],[11,"into","","",62,[[["self"]],["u"]]],[11,"try_from","","",62,[[["u"]],["result"]]],[11,"borrow","","",62,[[["self"]],["t"]]],[11,"try_into","","",62,[[["self"]],["result"]]],[11,"borrow_mut","","",62,[[["self"]],["t"]]],[11,"get_type_id","","",62,[[["self"]],["typeid"]]],[11,"to_owned","rand::rngs::entropy","",67,[[["self"]],["t"]]],[11,"clone_into","","",67,N],[11,"from","","",67,[[["t"]],["t"]]],[11,"into","","",67,[[["self"]],["u"]]],[11,"try_from","","",67,[[["u"]],["result"]]],[11,"borrow","","",67,[[["self"]],["t"]]],[11,"try_into","","",67,[[["self"]],["result"]]],[11,"borrow_mut","","",67,[[["self"]],["t"]]],[11,"get_type_id","","",67,[[["self"]],["typeid"]]],[11,"to_owned","","",63,[[["self"]],["t"]]],[11,"clone_into","","",63,N],[11,"from","","",63,[[["t"]],["t"]]],[11,"into","","",63,[[["self"]],["u"]]],[11,"try_from","","",63,[[["u"]],["result"]]],[11,"borrow","","",63,[[["self"]],["t"]]],[11,"try_into","","",63,[[["self"]],["result"]]],[11,"borrow_mut","","",63,[[["self"]],["t"]]],[11,"get_type_id","","",63,[[["self"]],["typeid"]]],[11,"to_owned","","",64,[[["self"]],["t"]]],[11,"clone_into","","",64,N],[11,"from","","",64,[[["t"]],["t"]]],[11,"into","","",64,[[["self"]],["u"]]],[11,"try_from","","",64,[[["u"]],["result"]]],[11,"borrow","","",64,[[["self"]],["t"]]],[11,"try_into","","",64,[[["self"]],["result"]]],[11,"borrow_mut","","",64,[[["self"]],["t"]]],[11,"get_type_id","","",64,[[["self"]],["typeid"]]],[11,"from","","",65,[[["t"]],["t"]]],[11,"into","","",65,[[["self"]],["u"]]],[11,"try_from","","",65,[[["u"]],["result"]]],[11,"borrow","","",65,[[["self"]],["t"]]],[11,"try_into","","",65,[[["self"]],["result"]]],[11,"borrow_mut","","",65,[[["self"]],["t"]]],[11,"get_type_id","","",65,[[["self"]],["typeid"]]],[11,"from","rand::rngs::jitter","",68,[[["t"]],["t"]]],[11,"into","","",68,[[["self"]],["u"]]],[11,"try_from","","",68,[[["u"]],["result"]]],[11,"borrow","","",68,[[["self"]],["t"]]],[11,"try_into","","",68,[[["self"]],["result"]]],[11,"borrow_mut","","",68,[[["self"]],["t"]]],[11,"get_type_id","","",68,[[["self"]],["typeid"]]],[11,"to_owned","rand::rngs::mock","",69,[[["self"]],["t"]]],[11,"clone_into","","",69,N],[11,"from","","",69,[[["t"]],["t"]]],[11,"into","","",69,[[["self"]],["u"]]],[11,"try_from","","",69,[[["u"]],["result"]]],[11,"borrow","","",69,[[["self"]],["t"]]],[11,"try_into","","",69,[[["self"]],["result"]]],[11,"borrow_mut","","",69,[[["self"]],["t"]]],[11,"get_type_id","","",69,[[["self"]],["typeid"]]],[11,"to_owned","rand::rngs::os::imp","",70,[[["self"]],["t"]]],[11,"clone_into","","",70,N],[11,"from","","",70,[[["t"]],["t"]]],[11,"into","","",70,[[["self"]],["u"]]],[11,"try_from","","",70,[[["u"]],["result"]]],[11,"borrow","","",70,[[["self"]],["t"]]],[11,"try_into","","",70,[[["self"]],["result"]]],[11,"borrow_mut","","",70,[[["self"]],["t"]]],[11,"get_type_id","","",70,[[["self"]],["typeid"]]],[11,"to_owned","","",71,[[["self"]],["t"]]],[11,"clone_into","","",71,N],[11,"from","","",71,[[["t"]],["t"]]],[11,"into","","",71,[[["self"]],["u"]]],[11,"try_from","","",71,[[["u"]],["result"]]],[11,"borrow","","",71,[[["self"]],["t"]]],[11,"try_into","","",71,[[["self"]],["result"]]],[11,"borrow_mut","","",71,[[["self"]],["t"]]],[11,"get_type_id","","",71,[[["self"]],["typeid"]]]],"paths":[[8,"RngCore"],[8,"SeedableRng"],[4,"ErrorKind"],[3,"Error"],[3,"Generator"],[3,"AsciiGenerator"],[3,"Uniform"],[3,"Gamma"],[3,"ChiSquared"],[3,"FisherF"],[3,"StudentT"],[3,"Normal"],[3,"LogNormal"],[3,"Exp"],[3,"Pareto"],[3,"Poisson"],[3,"Binomial"],[3,"Bernoulli"],[3,"Cauchy"],[3,"DistIter"],[3,"Weighted"],[3,"WeightedChoice"],[3,"UniformInt"],[3,"UniformFloat"],[3,"UniformDuration"],[4,"UniformDurationMode"],[8,"SampleUniform"],[8,"UniformSampler"],[8,"WideningMultiply"],[3,"GammaSmallShape"],[3,"GammaLargeShape"],[4,"GammaRepr"],[4,"ChiSquaredRepr"],[3,"StandardNormal"],[3,"Exp1"],[8,"IntoFloat"],[3,"OpenClosed01"],[3,"Open01"],[3,"Standard"],[3,"Alphanumeric"],[8,"Sample"],[8,"IndependentSample"],[8,"Distribution"],[3,"XorShiftRng"],[3,"ChaChaRng"],[3,"ChaChaCore"],[3,"Hc128Rng"],[3,"Hc128Core"],[3,"IsaacRng"],[3,"IsaacCore"],[3,"Isaac64Rng"],[3,"Isaac64Core"],[3,"IsaacArray"],[3,"JitterRng"],[3,"EntropyRng"],[3,"SmallRng"],[3,"StdRng"],[3,"ThreadRng"],[3,"OsRng"],[4,"TimerError"],[3,"ReadRng"],[3,"ReseedingRng"],[3,"ReseedingCore"],[3,"Os"],[3,"Jitter"],[4,"Source"],[8,"EntropySource"],[3,"NoSource"],[3,"EcState"],[3,"StepRng"],[3,"OsRng"],[4,"OsRngMethod"],[8,"OsRngImpl"],[8,"Rand"],[8,"Rng"],[8,"AsByteSliceMut"],[8,"FromEntropy"]]};
searchIndex["rand_core"]={"doc":"Random number generation traits","items":[[3,"Error","rand_core","Error type of random number generators",N,N],[12,"kind","","The error kind",0,N],[12,"msg","","The error message",0,N],[12,"cause","","",0,N],[4,"ErrorKind","","Error kind which can be matched over.",N,N],[13,"Unavailable","","Feature is not available; not recoverable.",1,N],[13,"Unexpected","","General failure; there may be a chance of recovery on retry.",1,N],[13,"Transient","","A transient failure which likely can be resolved or worked around.",1,N],[13,"NotReady","","Not ready yet: recommended to try again a little later.",1,N],[13,"__Nonexhaustive","","",1,N],[0,"error","","Error types",N,N],[3,"Error","rand_core::error","Error type of random number generators",N,N],[12,"kind","","The error kind",0,N],[12,"msg","","The error message",0,N],[12,"cause","","",0,N],[4,"ErrorKind","","Error kind which can be matched over.",N,N],[13,"Unavailable","","Feature is not available; not recoverable.",1,N],[13,"Unexpected","","General failure; there may be a chance of recovery on retry.",1,N],[13,"Transient","","A transient failure which likely can be resolved or worked around.",1,N],[13,"NotReady","","Not ready yet: recommended to try again a little later.",1,N],[13,"__Nonexhaustive","","",1,N],[11,"eq","rand_core","",1,[[["self"],["errorkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1,N],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"clone","","",1,[[["self"]],["errorkind"]]],[11,"should_retry","","True if this kind of error may resolve itself on retry.",1,[[["self"]],["bool"]]],[11,"should_wait","","True if we should retry but wait before retrying",1,[[["self"]],["bool"]]],[11,"description","","A description of this error kind",1,[[["self"]],["str"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new instance, with specified kind and a message.",0,[[["errorkind"],["str"]],["self"]]],[11,"with_cause","","Create a new instance, with specified kind, message, and a chained cause.",0,[[["errorkind"],["str"],["e"]],["self"]]],[11,"take_cause","","Take the cause, if any. This allows the embedded cause to be extracted. This uses `Option::take`, leaving `self` with no cause.",0,[[["self"]],["option",["box"]]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"description","","",0,[[["self"]],["str"]]],[11,"cause","","",0,[[["self"]],["option",["stderror"]]]],[0,"block","","The `BlockRngCore` trait and implementation helpers",N,N],[3,"BlockRng","rand_core::block","A wrapper type implementing [`RngCore`] for some type implementing [`BlockRngCore`] with `u32` array buffer; i.e. this can be used to implement a full RNG from just a `generate` function.",N,N],[12,"results","","",2,N],[12,"index","","",2,N],[12,"core","","The core part of the RNG, implementing the `generate` function.",2,N],[3,"BlockRng64","","A wrapper type implementing [`RngCore`] for some type implementing [`BlockRngCore`] with `u64` array buffer; i.e. this can be used to implement a full RNG from just a `generate` function.",N,N],[12,"results","","",3,N],[12,"index","","",3,N],[12,"half_used","","",3,N],[12,"core","","The core part of the RNG, implementing the `generate` function.",3,N],[8,"BlockRngCore","","A trait for RNGs which do not generate random numbers individually, but in blocks (typically `[u32; N]`). This technique is commonly used by cryptographic RNGs to improve performance.",N,N],[16,"Item","","Results element type, e.g. `u32`.",4,N],[16,"Results","","Results type. This is the 'block' an RNG implementing `BlockRngCore` generates, which will usually be an array like `[u32; 16]`.",4,N],[10,"generate","","Generate a new block of results.",4,N],[11,"clone","","",2,[[["self"]],["blockrng"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `BlockRng` from an existing RNG implementing `BlockRngCore`. Results will be generated on first use.",2,[[["r"]],["blockrng"]]],[11,"index","","Get the index into the result buffer.",2,[[["self"]],["usize"]]],[11,"reset","","Reset the number of available results. This will force a new set of results to be generated on next use.",2,[[["self"]]]],[11,"generate_and_set","","Generate a new set of results immediately, setting the index to the given value.",2,[[["self"],["usize"]]]],[11,"next_u32","","",2,[[["self"]],["u32"]]],[11,"next_u64","","",2,[[["self"]],["u64"]]],[11,"fill_bytes","","",2,N],[11,"try_fill_bytes","","",2,N],[11,"from_seed","","",2,N],[11,"from_rng","","",2,[[["s"]],["result",["error"]]]],[11,"clone","","",3,[[["self"]],["blockrng64"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `BlockRng` from an existing RNG implementing `BlockRngCore`. Results will be generated on first use.",3,[[["r"]],["blockrng64"]]],[11,"index","","Get the index into the result buffer.",3,[[["self"]],["usize"]]],[11,"reset","","Reset the number of available results. This will force a new set of results to be generated on next use.",3,[[["self"]]]],[11,"generate_and_set","","Generate a new set of results immediately, setting the index to the given value.",3,[[["self"],["usize"]]]],[11,"next_u32","","",3,[[["self"]],["u32"]]],[11,"next_u64","","",3,[[["self"]],["u64"]]],[11,"fill_bytes","","",3,N],[11,"try_fill_bytes","","",3,N],[11,"from_seed","","",3,N],[11,"from_rng","","",3,[[["s"]],["result",["error"]]]],[0,"impls","rand_core","Helper functions for implementing `RngCore` functions.",N,N],[5,"next_u64_via_u32","rand_core::impls","Implement `next_u64` via `next_u32`, little-endian order.",N,[[["r"]],["u64"]]],[5,"fill_bytes_via_next","","Implement `fill_bytes` via `next_u64` and `next_u32`, little-endian order.",N,N],[5,"fill_via_u32_chunks","","Implement `fill_bytes` by reading chunks from the output buffer of a block based RNG.",N,N],[5,"fill_via_u64_chunks","","Implement `fill_bytes` by reading chunks from the output buffer of a block based RNG.",N,N],[5,"next_u32_via_fill","","Implement `next_u32` via `fill_bytes`, little-endian order.",N,[[["r"]],["u32"]]],[5,"next_u64_via_fill","","Implement `next_u64` via `fill_bytes`, little-endian order.",N,[[["r"]],["u64"]]],[0,"le","rand_core","Little-Endian utilities",N,N],[5,"read_u32_into","rand_core::le","Reads unsigned 32 bit integers from `src` into `dst`. Borrowed from the `byteorder` crate.",N,N],[5,"read_u64_into","","Reads unsigned 64 bit integers from `src` into `dst`. Borrowed from the `byteorder` crate.",N,N],[8,"RngCore","rand_core","The core of a random number generator.",N,N],[10,"next_u32","","Return the next random `u32`.",5,[[["self"]],["u32"]]],[10,"next_u64","","Return the next random `u64`.",5,[[["self"]],["u64"]]],[10,"fill_bytes","","Fill `dest` with random data.",5,N],[10,"try_fill_bytes","","Fill `dest` entirely with random data.",5,N],[8,"CryptoRng","","A marker trait used to indicate that an [`RngCore`] or [`BlockRngCore`] implementation is supposed to be cryptographically secure.",N,N],[8,"SeedableRng","","A random number generator that can be explicitly seeded.",N,N],[16,"Seed","","Seed type, which is restricted to types mutably-dereferencable as `u8` arrays (we recommend `[u8; N]` for some `N`).",6,N],[10,"from_seed","","Create a new PRNG using the given seed.",6,N],[11,"from_rng","","Create a new PRNG seeded from another `Rng`.",6,[[["r"]],["result",["error"]]]],[11,"read","","",5,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"to_string","","",0,[[["self"]],["string"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"to_owned","rand_core::block","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]]],"paths":[[3,"Error"],[4,"ErrorKind"],[3,"BlockRng"],[3,"BlockRng64"],[8,"BlockRngCore"],[8,"RngCore"],[8,"SeedableRng"]]};
searchIndex["remove_dir_all"]={"doc":"","items":[[5,"remove_dir_all","remove_dir_all","Removes a directory at this path, after removing all its contents. Use carefully!",N,[[["p"]],["result",["error"]]]]],"paths":[]};
searchIndex["rustc"]={"doc":"The \"main crate\" of the Rust compiler. This crate contains common type definitions that are used by the other crates in the rustc \"family\". Some prominent examples (note that each of these modules has their own README with further details).","items":[[0,"macros","rustc","",N,N],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0038","rustc::diagnostics","",N,N],[0,"__register_diagnostic_E0072","","",N,N],[0,"__register_diagnostic_E0080","","",N,N],[0,"__register_diagnostic_E0106","","",N,N],[0,"__register_diagnostic_E0119","","",N,N],[0,"__register_diagnostic_E0136","","",N,N],[0,"__register_diagnostic_E0137","","",N,N],[0,"__register_diagnostic_E0138","","",N,N],[0,"__register_diagnostic_E0139","","",N,N],[0,"__register_diagnostic_E0152","","",N,N],[0,"__register_diagnostic_E0214","","",N,N],[0,"__register_diagnostic_E0230","","",N,N],[0,"__register_diagnostic_E0231","","",N,N],[0,"__register_diagnostic_E0232","","",N,N],[0,"__register_diagnostic_E0261","","",N,N],[0,"__register_diagnostic_E0262","","",N,N],[0,"__register_diagnostic_E0263","","",N,N],[0,"__register_diagnostic_E0264","","",N,N],[0,"__register_diagnostic_E0271","","",N,N],[0,"__register_diagnostic_E0275","","",N,N],[0,"__register_diagnostic_E0276","","",N,N],[0,"__register_diagnostic_E0277","","",N,N],[0,"__register_diagnostic_E0281","","",N,N],[0,"__register_diagnostic_E0282","","",N,N],[0,"__register_diagnostic_E0283","","",N,N],[0,"__register_diagnostic_E0296","","",N,N],[0,"__register_diagnostic_E0308","","",N,N],[0,"__register_diagnostic_E0309","","",N,N],[0,"__register_diagnostic_E0310","","",N,N],[0,"__register_diagnostic_E0317","","",N,N],[0,"__register_diagnostic_E0391","","",N,N],[0,"__register_diagnostic_E0398","","",N,N],[0,"__register_diagnostic_E0452","","",N,N],[0,"__register_diagnostic_E0453","","",N,N],[0,"__register_diagnostic_E0478","","",N,N],[0,"__register_diagnostic_E0491","","",N,N],[0,"__register_diagnostic_E0496","","",N,N],[0,"__register_diagnostic_E0497","","",N,N],[0,"__register_diagnostic_E0512","","",N,N],[0,"__register_diagnostic_E0517","","",N,N],[0,"__register_diagnostic_E0518","","",N,N],[0,"__register_diagnostic_E0522","","",N,N],[0,"__register_diagnostic_E0525","","",N,N],[0,"__register_diagnostic_E0580","","",N,N],[0,"__register_diagnostic_E0562","","",N,N],[0,"__register_diagnostic_E0591","","",N,N],[0,"__register_diagnostic_E0593","","",N,N],[0,"__register_diagnostic_E0601","","",N,N],[0,"__register_diagnostic_E0602","","",N,N],[0,"__register_diagnostic_E0621","","",N,N],[0,"__register_diagnostic_E0635","","",N,N],[0,"__register_diagnostic_E0636","","",N,N],[0,"__register_diagnostic_E0644","","",N,N],[0,"__register_diagnostic_E0692","","",N,N],[0,"__register_diagnostic_E0700","","",N,N],[0,"__register_diagnostic_E0701","","",N,N],[0,"__register_diagnostic_E0702","","",N,N],[0,"__register_diagnostic_E0278","","",N,N],[0,"__register_diagnostic_E0279","","",N,N],[0,"__register_diagnostic_E0280","","",N,N],[0,"__register_diagnostic_E0284","","",N,N],[0,"__register_diagnostic_E0311","","",N,N],[0,"__register_diagnostic_E0312","","",N,N],[0,"__register_diagnostic_E0313","","",N,N],[0,"__register_diagnostic_E0314","","",N,N],[0,"__register_diagnostic_E0315","","",N,N],[0,"__register_diagnostic_E0316","","",N,N],[0,"__register_diagnostic_E0320","","",N,N],[0,"__register_diagnostic_E0473","","",N,N],[0,"__register_diagnostic_E0474","","",N,N],[0,"__register_diagnostic_E0475","","",N,N],[0,"__register_diagnostic_E0476","","",N,N],[0,"__register_diagnostic_E0477","","",N,N],[0,"__register_diagnostic_E0479","","",N,N],[0,"__register_diagnostic_E0480","","",N,N],[0,"__register_diagnostic_E0481","","",N,N],[0,"__register_diagnostic_E0482","","",N,N],[0,"__register_diagnostic_E0483","","",N,N],[0,"__register_diagnostic_E0484","","",N,N],[0,"__register_diagnostic_E0485","","",N,N],[0,"__register_diagnostic_E0486","","",N,N],[0,"__register_diagnostic_E0487","","",N,N],[0,"__register_diagnostic_E0488","","",N,N],[0,"__register_diagnostic_E0489","","",N,N],[0,"__register_diagnostic_E0490","","",N,N],[0,"__register_diagnostic_E0495","","",N,N],[0,"__register_diagnostic_E0566","","",N,N],[0,"__register_diagnostic_E0623","","",N,N],[0,"__register_diagnostic_E0628","","",N,N],[0,"__register_diagnostic_E0631","","",N,N],[0,"__register_diagnostic_E0637","","",N,N],[0,"__register_diagnostic_E0657","","",N,N],[0,"__register_diagnostic_E0687","","",N,N],[0,"__register_diagnostic_E0688","","",N,N],[0,"__register_diagnostic_E0697","","",N,N],[0,"__register_diagnostic_E0707","","",N,N],[0,"__register_diagnostic_E0708","","",N,N],[0,"__register_diagnostic_E0709","","",N,N],[0,"__register_diagnostic_E0710","","",N,N],[0,"__register_diagnostic_E0711","","",N,N],[0,"cfg","rustc","Module that constructs a control-flow graph representing an item. Uses `Graph` as the underlying representation.",N,N],[3,"CFG","rustc::cfg","",N,N],[12,"owner_def_id","","",0,N],[12,"graph","","",0,N],[12,"entry","","",0,N],[12,"exit","","",0,N],[3,"CFGEdgeData","","",N,N],[12,"exiting_scopes","","",1,N],[4,"CFGNodeData","","",N,N],[13,"AST","","",2,N],[13,"Entry","","",2,N],[13,"Exit","","",2,N],[13,"Dummy","","",2,N],[13,"Unreachable","","",2,N],[0,"construct","","",N,N],[3,"CFGBuilder","rustc::cfg::construct","",N,N],[12,"tcx","","",3,N],[12,"owner_def_id","","",3,N],[12,"tables","","",3,N],[12,"graph","","",3,N],[12,"fn_exit","","",3,N],[12,"loop_scopes","","",3,N],[12,"breakable_block_scopes","","",3,N],[3,"BlockScope","","",N,N],[12,"block_expr_id","","",4,N],[12,"break_index","","",4,N],[3,"LoopScope","","",N,N],[12,"loop_id","","",5,N],[12,"continue_index","","",5,N],[12,"break_index","","",5,N],[4,"ScopeCfKind","","",N,N],[13,"Break","","",6,N],[13,"Continue","","",6,N],[5,"construct","","",N,[[["tyctxt"],["body"]],["cfg"]]],[11,"clone","","",4,[[["self"]],["blockscope"]]],[11,"clone","","",5,[[["self"]],["loopscope"]]],[11,"block","","",3,[[["self"],["block"],["cfgindex"]],["cfgindex"]]],[11,"stmt","","",3,[[["self"],["stmt"],["cfgindex"]],["cfgindex"]]],[11,"decl","","",3,[[["self"],["decl"],["cfgindex"]],["cfgindex"]]],[11,"pat","","",3,[[["self"],["pat"],["cfgindex"]],["cfgindex"]]],[11,"pats_all","","Handles case where all of the patterns must match.",3,[[["self"],["i"],["cfgindex"]],["cfgindex"]]],[11,"expr","","",3,[[["self"],["expr"],["cfgindex"]],["cfgindex"]]],[11,"call","","",3,[[["self"],["expr"],["cfgindex"],["expr"],["i"]],["cfgindex"]]],[11,"exprs","","Constructs graph for `exprs` evaluated in order",3,[[["self"],["i"],["cfgindex"]],["cfgindex"]]],[11,"opt_expr","","Constructs graph for `opt_expr` evaluated, if Some",3,[[["self"],["option"],["cfgindex"]],["cfgindex"]]],[11,"straightline","","Handles case of an expression that evaluates `subexprs` in order",3,[[["self"],["expr"],["cfgindex"],["i"]],["cfgindex"]]],[11,"match_","","",3,N],[11,"add_dummy_node","","",3,N],[11,"add_ast_node","","",3,N],[11,"add_unreachable_node","","",3,[[["self"]],["cfgindex"]]],[11,"add_node","","",3,N],[11,"add_contained_edge","","",3,[[["self"],["cfgindex"],["cfgindex"]]]],[11,"add_exiting_edge","","",3,[[["self"],["expr"],["cfgindex"],["scope"],["cfgindex"]]]],[11,"add_returning_edge","","",3,[[["self"],["expr"],["cfgindex"]]]],[11,"find_scope_edge","","",3,N],[11,"clone","","",6,[[["self"]],["scopecfkind"]]],[11,"assert_receiver_is_total_eq","","",6,N],[11,"eq","","",6,[[["self"],["scopecfkind"]],["bool"]]],[0,"graphviz","rustc::cfg","",N,N],[3,"LabelledCFG","rustc::cfg::graphviz","",N,N],[12,"tcx","","",7,N],[12,"cfg","","",7,N],[12,"name","","",7,N],[12,"labelled_edges","","`labelled_edges` controls whether we emit labels on the edges",7,N],[6,"Node","","",N,N],[6,"Edge","","",N,N],[11,"local_id_to_string","","",7,[[["self"],["itemlocalid"]],["string"]]],[11,"graph_id","","",7,[[["self"]],["id"]]],[11,"node_id","","",7,[[["self"],["node"]],["id"]]],[11,"node_label","","",7,[[["self"],["node"]],["labeltext"]]],[11,"edge_label","","",7,[[["self"],["edge"]],["labeltext"]]],[11,"nodes","","",7,[[["self"]],["nodes",["node"]]]],[11,"edges","","",7,[[["self"]],["edges",["edge"]]]],[11,"source","","",7,[[["self"],["edge"]],["node"]]],[11,"target","","",7,[[["self"],["edge"]],["node"]]],[6,"CFGIndex","rustc::cfg","",N,N],[6,"CFGGraph","","",N,N],[6,"CFGNode","","",N,N],[6,"CFGEdge","","",N,N],[11,"clone","","",2,[[["self"]],["cfgnodedata"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"eq","","",2,[[["self"],["cfgnodedata"]],["bool"]]],[11,"ne","","",2,[[["self"],["cfgnodedata"]],["bool"]]],[11,"id","","",2,[[["self"]],["itemlocalid"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"new","","",0,[[["tyctxt"],["body"]],["cfg"]]],[11,"node_is_reachable","","",0,[[["self"],["itemlocalid"]],["bool"]]],[0,"dep_graph","rustc","",N,N],[3,"DepTrackingMap","rustc::dep_graph","A DepTrackingMap offers a subset of the `Map` API and ensures that we make calls to `read` and `write` as appropriate. We key the maps with a unique type for brevity.",N,N],[12,"phantom","","",8,N],[12,"graph","","",8,N],[12,"map","","",8,N],[3,"DepNode","","",N,N],[12,"kind","","",9,N],[12,"hash","","",9,N],[3,"WorkProductId","","A \"work product\" corresponds to a `.o` (or other) file that we save in between runs. These ids do not have a DefId but rather some independent path or string that persists between runs without the need to be mapped or unmapped. (This ensures we can serialize them even in the absence of a tcx.)",N,N],[12,"hash","","",10,N],[3,"DepGraph","","",N,N],[12,"data","","",11,N],[12,"fingerprints","","",11,N],[3,"WorkProduct","","A \"work product\" is an intermediate result that we save into the incremental directory for later re-use. The primary example are the object files that we save for each partition at code generation time.",N,N],[12,"cgu_name","","",12,N],[12,"saved_files","","Saved files associated with this CGU",12,N],[3,"DepNodeIndex","","",N,N],[12,"private","","",13,N],[3,"PreviousDepGraph","","",N,N],[12,"data","","",14,N],[12,"index","","",14,N],[3,"DepGraphQuery","","",N,N],[12,"graph","","",15,N],[12,"indices","","",15,N],[3,"AssertDepGraphSafe","","A convenient override that lets you pass arbitrary state into a task. Every use should be accompanied by a comment explaining why it makes sense (or how it could be refactored away in the future).",N,N],[12,"0","","",16,N],[3,"SerializedDepGraph","","Data for use when recompiling the current crate.",N,N],[12,"nodes","","The set of all DepNodes in the graph",17,N],[12,"fingerprints","","The set of all Fingerprints in the graph. Each Fingerprint corresponds to the DepNode at the same index in the nodes vector.",17,N],[12,"edge_list_indices","","For each DepNode, stores the list of edges originating from that DepNode. Encoded as a [start, end) pair indexing into edge_list_data, which holds the actual DepNodeIndices of the target nodes.",17,N],[12,"edge_list_data","","A flattened list of all edge targets in the graph. Edge sources are implicit in edge_list_indices.",17,N],[3,"SerializedDepNodeIndex","","",N,N],[12,"private","","",18,N],[4,"DepKind","","",N,N],[13,"Null","","",19,N],[13,"Krate","","",19,N],[13,"HirBody","","",19,N],[13,"Hir","","",19,N],[13,"CrateMetadata","","",19,N],[13,"RegionScopeTree","","",19,N],[13,"Coherence","","",19,N],[13,"CoherenceInherentImplOverlapCheck","","",19,N],[13,"CoherenceCheckTrait","","",19,N],[13,"PrivacyAccessLevels","","",19,N],[13,"MirConstQualif","","",19,N],[13,"MirBuilt","","",19,N],[13,"MirConst","","",19,N],[13,"MirValidated","","",19,N],[13,"MirOptimized","","",19,N],[13,"MirShim","","",19,N],[13,"BorrowCheckKrate","","",19,N],[13,"BorrowCheck","","",19,N],[13,"MirBorrowCheck","","",19,N],[13,"UnsafetyCheckResult","","",19,N],[13,"UnsafeDeriveOnReprPacked","","",19,N],[13,"Reachability","","",19,N],[13,"MirKeys","","",19,N],[13,"CrateVariances","","",19,N],[13,"AssociatedItems","","",19,N],[13,"TypeOfItem","","",19,N],[13,"GenericsOfItem","","",19,N],[13,"PredicatesOfItem","","",19,N],[13,"ExplicitPredicatesOfItem","","",19,N],[13,"PredicatesDefinedOnItem","","",19,N],[13,"InferredOutlivesOf","","",19,N],[13,"InferredOutlivesCrate","","",19,N],[13,"SuperPredicatesOfItem","","",19,N],[13,"TraitDefOfItem","","",19,N],[13,"AdtDefOfItem","","",19,N],[13,"ImplTraitRef","","",19,N],[13,"ImplPolarity","","",19,N],[13,"FnSignature","","",19,N],[13,"CoerceUnsizedInfo","","",19,N],[13,"ItemVarianceConstraints","","",19,N],[13,"ItemVariances","","",19,N],[13,"IsConstFn","","",19,N],[13,"IsForeignItem","","",19,N],[13,"TypeParamPredicates","","",19,N],[13,"SizedConstraint","","",19,N],[13,"DtorckConstraint","","",19,N],[13,"AdtDestructor","","",19,N],[13,"AssociatedItemDefIds","","",19,N],[13,"InherentImpls","","",19,N],[13,"TypeckBodiesKrate","","",19,N],[13,"TypeckTables","","",19,N],[13,"UsedTraitImports","","",19,N],[13,"HasTypeckTables","","",19,N],[13,"ConstEval","","",19,N],[13,"CheckMatch","","",19,N],[13,"SymbolName","","",19,N],[13,"InstanceSymbolName","","",19,N],[13,"SpecializationGraph","","",19,N],[13,"ObjectSafety","","",19,N],[13,"FulfillObligation","","",19,N],[13,"VtableMethods","","",19,N],[13,"IsCopy","","",19,N],[13,"IsSized","","",19,N],[13,"IsFreeze","","",19,N],[13,"NeedsDrop","","",19,N],[13,"Layout","","",19,N],[13,"TraitImpls","","",19,N],[13,"AllLocalTraitImpls","","",19,N],[13,"TraitSelect","","",19,N],[13,"ParamEnv","","",19,N],[13,"DescribeDef","","",19,N],[13,"DefSpan","","",19,N],[13,"LookupStability","","",19,N],[13,"LookupDeprecationEntry","","",19,N],[13,"ConstIsRvaluePromotableToStatic","","",19,N],[13,"RvaluePromotableMap","","",19,N],[13,"ImplParent","","",19,N],[13,"TraitOfItem","","",19,N],[13,"IsReachableNonGeneric","","",19,N],[13,"IsUnreachableLocalDefinition","","",19,N],[13,"IsMirAvailable","","",19,N],[13,"ItemAttrs","","",19,N],[13,"CodegenFnAttrs","","",19,N],[13,"FnArgNames","","",19,N],[13,"RenderedConst","","",19,N],[13,"DylibDepFormats","","",19,N],[13,"IsPanicRuntime","","",19,N],[13,"IsCompilerBuiltins","","",19,N],[13,"HasGlobalAllocator","","",19,N],[13,"HasPanicHandler","","",19,N],[13,"ExternCrate","","",19,N],[13,"LintLevels","","",19,N],[13,"Specializes","","",19,N],[13,"InScopeTraits","","",19,N],[13,"ModuleExports","","",19,N],[13,"IsSanitizerRuntime","","",19,N],[13,"IsProfilerRuntime","","",19,N],[13,"GetPanicStrategy","","",19,N],[13,"IsNoBuiltins","","",19,N],[13,"ImplDefaultness","","",19,N],[13,"CheckItemWellFormed","","",19,N],[13,"CheckTraitItemWellFormed","","",19,N],[13,"CheckImplItemWellFormed","","",19,N],[13,"ReachableNonGenerics","","",19,N],[13,"NativeLibraries","","",19,N],[13,"PluginRegistrarFn","","",19,N],[13,"DeriveRegistrarFn","","",19,N],[13,"CrateDisambiguator","","",19,N],[13,"CrateHash","","",19,N],[13,"OriginalCrateName","","",19,N],[13,"ExtraFileName","","",19,N],[13,"ImplementationsOfTrait","","",19,N],[13,"AllTraitImplementations","","",19,N],[13,"DllimportForeignItems","","",19,N],[13,"IsDllimportForeignItem","","",19,N],[13,"IsStaticallyIncludedForeignItem","","",19,N],[13,"NativeLibraryKind","","",19,N],[13,"LinkArgs","","",19,N],[13,"ResolveLifetimes","","",19,N],[13,"NamedRegion","","",19,N],[13,"IsLateBound","","",19,N],[13,"ObjectLifetimeDefaults","","",19,N],[13,"Visibility","","",19,N],[13,"DepKind","","",19,N],[13,"CrateName","","",19,N],[13,"ItemChildren","","",19,N],[13,"ExternModStmtCnum","","",19,N],[13,"GetLibFeatures","","",19,N],[13,"DefinedLibFeatures","","",19,N],[13,"GetLangItems","","",19,N],[13,"DefinedLangItems","","",19,N],[13,"MissingLangItems","","",19,N],[13,"VisibleParentMap","","",19,N],[13,"MissingExternCrateItem","","",19,N],[13,"UsedCrateSource","","",19,N],[13,"PostorderCnums","","",19,N],[13,"EraseRegionsTy","","",19,N],[13,"Freevars","","",19,N],[13,"MaybeUnusedTraitImport","","",19,N],[13,"MaybeUnusedExternCrates","","",19,N],[13,"StabilityIndex","","",19,N],[13,"AllTraits","","",19,N],[13,"AllCrateNums","","",19,N],[13,"ExportedSymbols","","",19,N],[13,"CollectAndPartitionMonoItems","","",19,N],[13,"IsCodegenedItem","","",19,N],[13,"CodegenUnit","","",19,N],[13,"CompileCodegenUnit","","",19,N],[13,"OutputFilenames","","",19,N],[13,"NormalizeProjectionTy","","",19,N],[13,"NormalizeTyAfterErasingRegions","","",19,N],[13,"ImpliedOutlivesBounds","","",19,N],[13,"DropckOutlives","","",19,N],[13,"EvaluateObligation","","",19,N],[13,"TypeOpEq","","",19,N],[13,"TypeOpSubtype","","",19,N],[13,"TypeOpProvePredicate","","",19,N],[13,"TypeOpNormalizeTy","","",19,N],[13,"TypeOpNormalizePredicate","","",19,N],[13,"TypeOpNormalizePolyFnSig","","",19,N],[13,"TypeOpNormalizeFnSig","","",19,N],[13,"SubstituteNormalizeAndTestPredicates","","",19,N],[13,"TargetFeaturesWhitelist","","",19,N],[13,"InstanceDefSizeEstimate","","",19,N],[13,"Features","","",19,N],[13,"ProgramClausesFor","","",19,N],[13,"ProgramClausesForEnv","","",19,N],[13,"WasmImportModuleMap","","",19,N],[13,"ForeignModules","","",19,N],[13,"UpstreamMonomorphizations","","",19,N],[13,"UpstreamMonomorphizationsFor","","",19,N],[4,"DepConstructor","","",N,N],[13,"Null","","",20,N],[13,"Krate","","",20,N],[13,"HirBody","","",20,N],[13,"Hir","","",20,N],[13,"CrateMetadata","","",20,N],[13,"RegionScopeTree","","",20,N],[13,"Coherence","","",20,N],[13,"CoherenceInherentImplOverlapCheck","","",20,N],[13,"CoherenceCheckTrait","","",20,N],[13,"PrivacyAccessLevels","","",20,N],[13,"MirConstQualif","","",20,N],[13,"MirBuilt","","",20,N],[13,"MirConst","","",20,N],[13,"MirValidated","","",20,N],[13,"MirOptimized","","",20,N],[13,"MirShim","","",20,N],[12,"instance_def","rustc::dep_graph::DepConstructor","",20,N],[13,"BorrowCheckKrate","rustc::dep_graph","",20,N],[13,"BorrowCheck","","",20,N],[13,"MirBorrowCheck","","",20,N],[13,"UnsafetyCheckResult","","",20,N],[13,"UnsafeDeriveOnReprPacked","","",20,N],[13,"Reachability","","",20,N],[13,"MirKeys","","",20,N],[13,"CrateVariances","","",20,N],[13,"AssociatedItems","","",20,N],[13,"TypeOfItem","","",20,N],[13,"GenericsOfItem","","",20,N],[13,"PredicatesOfItem","","",20,N],[13,"ExplicitPredicatesOfItem","","",20,N],[13,"PredicatesDefinedOnItem","","",20,N],[13,"InferredOutlivesOf","","",20,N],[13,"InferredOutlivesCrate","","",20,N],[13,"SuperPredicatesOfItem","","",20,N],[13,"TraitDefOfItem","","",20,N],[13,"AdtDefOfItem","","",20,N],[13,"ImplTraitRef","","",20,N],[13,"ImplPolarity","","",20,N],[13,"FnSignature","","",20,N],[13,"CoerceUnsizedInfo","","",20,N],[13,"ItemVarianceConstraints","","",20,N],[13,"ItemVariances","","",20,N],[13,"IsConstFn","","",20,N],[13,"IsForeignItem","","",20,N],[13,"TypeParamPredicates","","",20,N],[12,"item_id","rustc::dep_graph::DepConstructor","",20,N],[12,"param_id","","",20,N],[13,"SizedConstraint","rustc::dep_graph","",20,N],[13,"DtorckConstraint","","",20,N],[13,"AdtDestructor","","",20,N],[13,"AssociatedItemDefIds","","",20,N],[13,"InherentImpls","","",20,N],[13,"TypeckBodiesKrate","","",20,N],[13,"TypeckTables","","",20,N],[13,"UsedTraitImports","","",20,N],[13,"HasTypeckTables","","",20,N],[13,"ConstEval","","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"CheckMatch","rustc::dep_graph","",20,N],[13,"SymbolName","","",20,N],[13,"InstanceSymbolName","","",20,N],[12,"instance","rustc::dep_graph::DepConstructor","",20,N],[13,"SpecializationGraph","rustc::dep_graph","",20,N],[13,"ObjectSafety","","",20,N],[13,"FulfillObligation","","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[12,"trait_ref","","",20,N],[13,"VtableMethods","rustc::dep_graph","",20,N],[12,"trait_ref","rustc::dep_graph::DepConstructor","",20,N],[13,"IsCopy","rustc::dep_graph","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"IsSized","rustc::dep_graph","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"IsFreeze","rustc::dep_graph","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"NeedsDrop","rustc::dep_graph","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"Layout","rustc::dep_graph","",20,N],[12,"param_env","rustc::dep_graph::DepConstructor","",20,N],[13,"TraitImpls","rustc::dep_graph","",20,N],[13,"AllLocalTraitImpls","","",20,N],[13,"TraitSelect","","",20,N],[13,"ParamEnv","","",20,N],[13,"DescribeDef","","",20,N],[13,"DefSpan","","",20,N],[13,"LookupStability","","",20,N],[13,"LookupDeprecationEntry","","",20,N],[13,"ConstIsRvaluePromotableToStatic","","",20,N],[13,"RvaluePromotableMap","","",20,N],[13,"ImplParent","","",20,N],[13,"TraitOfItem","","",20,N],[13,"IsReachableNonGeneric","","",20,N],[13,"IsUnreachableLocalDefinition","","",20,N],[13,"IsMirAvailable","","",20,N],[13,"ItemAttrs","","",20,N],[13,"CodegenFnAttrs","","",20,N],[13,"FnArgNames","","",20,N],[13,"RenderedConst","","",20,N],[13,"DylibDepFormats","","",20,N],[13,"IsPanicRuntime","","",20,N],[13,"IsCompilerBuiltins","","",20,N],[13,"HasGlobalAllocator","","",20,N],[13,"HasPanicHandler","","",20,N],[13,"ExternCrate","","",20,N],[13,"LintLevels","","",20,N],[13,"Specializes","","",20,N],[12,"impl1","rustc::dep_graph::DepConstructor","",20,N],[12,"impl2","","",20,N],[13,"InScopeTraits","rustc::dep_graph","",20,N],[13,"ModuleExports","","",20,N],[13,"IsSanitizerRuntime","","",20,N],[13,"IsProfilerRuntime","","",20,N],[13,"GetPanicStrategy","","",20,N],[13,"IsNoBuiltins","","",20,N],[13,"ImplDefaultness","","",20,N],[13,"CheckItemWellFormed","","",20,N],[13,"CheckTraitItemWellFormed","","",20,N],[13,"CheckImplItemWellFormed","","",20,N],[13,"ReachableNonGenerics","","",20,N],[13,"NativeLibraries","","",20,N],[13,"PluginRegistrarFn","","",20,N],[13,"DeriveRegistrarFn","","",20,N],[13,"CrateDisambiguator","","",20,N],[13,"CrateHash","","",20,N],[13,"OriginalCrateName","","",20,N],[13,"ExtraFileName","","",20,N],[13,"ImplementationsOfTrait","","",20,N],[12,"krate","rustc::dep_graph::DepConstructor","",20,N],[12,"trait_id","","",20,N],[13,"AllTraitImplementations","rustc::dep_graph","",20,N],[13,"DllimportForeignItems","","",20,N],[13,"IsDllimportForeignItem","","",20,N],[13,"IsStaticallyIncludedForeignItem","","",20,N],[13,"NativeLibraryKind","","",20,N],[13,"LinkArgs","","",20,N],[13,"ResolveLifetimes","","",20,N],[13,"NamedRegion","","",20,N],[13,"IsLateBound","","",20,N],[13,"ObjectLifetimeDefaults","","",20,N],[13,"Visibility","","",20,N],[13,"DepKind","","",20,N],[13,"CrateName","","",20,N],[13,"ItemChildren","","",20,N],[13,"ExternModStmtCnum","","",20,N],[13,"GetLibFeatures","","",20,N],[13,"DefinedLibFeatures","","",20,N],[13,"GetLangItems","","",20,N],[13,"DefinedLangItems","","",20,N],[13,"MissingLangItems","","",20,N],[13,"VisibleParentMap","","",20,N],[13,"MissingExternCrateItem","","",20,N],[13,"UsedCrateSource","","",20,N],[13,"PostorderCnums","","",20,N],[13,"EraseRegionsTy","","",20,N],[12,"ty","rustc::dep_graph::DepConstructor","",20,N],[13,"Freevars","rustc::dep_graph","",20,N],[13,"MaybeUnusedTraitImport","","",20,N],[13,"MaybeUnusedExternCrates","","",20,N],[13,"StabilityIndex","","",20,N],[13,"AllTraits","","",20,N],[13,"AllCrateNums","","",20,N],[13,"ExportedSymbols","","",20,N],[13,"CollectAndPartitionMonoItems","","",20,N],[13,"IsCodegenedItem","","",20,N],[13,"CodegenUnit","","",20,N],[13,"CompileCodegenUnit","","",20,N],[13,"OutputFilenames","","",20,N],[13,"NormalizeProjectionTy","","",20,N],[13,"NormalizeTyAfterErasingRegions","","",20,N],[13,"ImpliedOutlivesBounds","","",20,N],[13,"DropckOutlives","","",20,N],[13,"EvaluateObligation","","",20,N],[13,"TypeOpEq","","",20,N],[13,"TypeOpSubtype","","",20,N],[13,"TypeOpProvePredicate","","",20,N],[13,"TypeOpNormalizeTy","","",20,N],[13,"TypeOpNormalizePredicate","","",20,N],[13,"TypeOpNormalizePolyFnSig","","",20,N],[13,"TypeOpNormalizeFnSig","","",20,N],[13,"SubstituteNormalizeAndTestPredicates","","",20,N],[12,"key","rustc::dep_graph::DepConstructor","",20,N],[13,"TargetFeaturesWhitelist","rustc::dep_graph","",20,N],[13,"InstanceDefSizeEstimate","","",20,N],[12,"instance_def","rustc::dep_graph::DepConstructor","",20,N],[13,"Features","rustc::dep_graph","",20,N],[13,"ProgramClausesFor","","",20,N],[13,"ProgramClausesForEnv","","",20,N],[13,"WasmImportModuleMap","","",20,N],[13,"ForeignModules","","",20,N],[13,"UpstreamMonomorphizations","","",20,N],[13,"UpstreamMonomorphizationsFor","","",20,N],[4,"DepNodeColor","","",N,N],[13,"Red","","",21,N],[13,"Green","","",21,N],[4,"OpenTask","","",N,N],[13,"Regular","","",22,N],[13,"Anon","","",22,N],[13,"Ignore","","",22,N],[13,"EvalAlways","","",22,N],[12,"node","rustc::dep_graph::OpenTask","",22,N],[4,"WorkProductFileKind","rustc::dep_graph","",N,N],[13,"Object","","",23,N],[13,"Bytecode","","",23,N],[13,"BytecodeCompressed","","",23,N],[0,"debug","","Code for debugging the dep-graph.",N,N],[3,"DepNodeFilter","rustc::dep_graph::debug","A dep-node filter goes from a user-defined string to a query over nodes. Right now the format is like this:",N,N],[12,"text","","",24,N],[3,"EdgeFilter","","A filter like `F -> G` where `F` and `G` are valid dep-node filters. This can be used to test the source/target independently.",N,N],[12,"source","","",25,N],[12,"target","","",25,N],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"new","","",24,[[["str"]],["self"]]],[11,"accepts_all","","True if all nodes always pass the filter.",24,[[["self"]],["bool"]]],[11,"test","","Tests whether `node` meets the filter, returning true if so.",24,[[["self"],["depnode"]],["bool"]]],[11,"new","","",25,[[["str"]],["result",["edgefilter","box"]]]],[11,"test","","",25,[[["self"],["depnode"],["depnode"]],["bool"]]],[0,"dep_node","rustc::dep_graph","This module defines the `DepNode` type which the compiler uses to represent nodes in the dependency graph. A `DepNode` consists of a `DepKind` (which specifies the kind of thing it represents, like a piece of HIR, MIR, etc) and a `Fingerprint`, a 128 bit hash value the exact meaning of which depends on the node's `DepKind`. Together, the kind and the fingerprint fully identify a dependency node, even across multiple compilation sessions. In other words, the value of the fingerprint does not depend on anything that is specific to a given compilation session, like an unpredictable interning key (e.g. NodeId, DefId, Symbol) or the numeric value of a pointer. The concept behind this could be compared to how git commit hashes uniquely identify a given commit and has a few advantages:",N,N],[3,"DepNode","rustc::dep_graph::dep_node","",N,N],[12,"kind","","",9,N],[12,"hash","","",9,N],[3,"WorkProductId","","A \"work product\" corresponds to a `.o` (or other) file that we save in between runs. These ids do not have a DefId but rather some independent path or string that persists between runs without the need to be mapped or unmapped. (This ensures we can serialize them even in the absence of a tcx.)",N,N],[12,"hash","","",10,N],[4,"DepKind","","",N,N],[13,"Null","","",19,N],[13,"Krate","","",19,N],[13,"HirBody","","",19,N],[13,"Hir","","",19,N],[13,"CrateMetadata","","",19,N],[13,"RegionScopeTree","","",19,N],[13,"Coherence","","",19,N],[13,"CoherenceInherentImplOverlapCheck","","",19,N],[13,"CoherenceCheckTrait","","",19,N],[13,"PrivacyAccessLevels","","",19,N],[13,"MirConstQualif","","",19,N],[13,"MirBuilt","","",19,N],[13,"MirConst","","",19,N],[13,"MirValidated","","",19,N],[13,"MirOptimized","","",19,N],[13,"MirShim","","",19,N],[13,"BorrowCheckKrate","","",19,N],[13,"BorrowCheck","","",19,N],[13,"MirBorrowCheck","","",19,N],[13,"UnsafetyCheckResult","","",19,N],[13,"UnsafeDeriveOnReprPacked","","",19,N],[13,"Reachability","","",19,N],[13,"MirKeys","","",19,N],[13,"CrateVariances","","",19,N],[13,"AssociatedItems","","",19,N],[13,"TypeOfItem","","",19,N],[13,"GenericsOfItem","","",19,N],[13,"PredicatesOfItem","","",19,N],[13,"ExplicitPredicatesOfItem","","",19,N],[13,"PredicatesDefinedOnItem","","",19,N],[13,"InferredOutlivesOf","","",19,N],[13,"InferredOutlivesCrate","","",19,N],[13,"SuperPredicatesOfItem","","",19,N],[13,"TraitDefOfItem","","",19,N],[13,"AdtDefOfItem","","",19,N],[13,"ImplTraitRef","","",19,N],[13,"ImplPolarity","","",19,N],[13,"FnSignature","","",19,N],[13,"CoerceUnsizedInfo","","",19,N],[13,"ItemVarianceConstraints","","",19,N],[13,"ItemVariances","","",19,N],[13,"IsConstFn","","",19,N],[13,"IsForeignItem","","",19,N],[13,"TypeParamPredicates","","",19,N],[13,"SizedConstraint","","",19,N],[13,"DtorckConstraint","","",19,N],[13,"AdtDestructor","","",19,N],[13,"AssociatedItemDefIds","","",19,N],[13,"InherentImpls","","",19,N],[13,"TypeckBodiesKrate","","",19,N],[13,"TypeckTables","","",19,N],[13,"UsedTraitImports","","",19,N],[13,"HasTypeckTables","","",19,N],[13,"ConstEval","","",19,N],[13,"CheckMatch","","",19,N],[13,"SymbolName","","",19,N],[13,"InstanceSymbolName","","",19,N],[13,"SpecializationGraph","","",19,N],[13,"ObjectSafety","","",19,N],[13,"FulfillObligation","","",19,N],[13,"VtableMethods","","",19,N],[13,"IsCopy","","",19,N],[13,"IsSized","","",19,N],[13,"IsFreeze","","",19,N],[13,"NeedsDrop","","",19,N],[13,"Layout","","",19,N],[13,"TraitImpls","","",19,N],[13,"AllLocalTraitImpls","","",19,N],[13,"TraitSelect","","",19,N],[13,"ParamEnv","","",19,N],[13,"DescribeDef","","",19,N],[13,"DefSpan","","",19,N],[13,"LookupStability","","",19,N],[13,"LookupDeprecationEntry","","",19,N],[13,"ConstIsRvaluePromotableToStatic","","",19,N],[13,"RvaluePromotableMap","","",19,N],[13,"ImplParent","","",19,N],[13,"TraitOfItem","","",19,N],[13,"IsReachableNonGeneric","","",19,N],[13,"IsUnreachableLocalDefinition","","",19,N],[13,"IsMirAvailable","","",19,N],[13,"ItemAttrs","","",19,N],[13,"CodegenFnAttrs","","",19,N],[13,"FnArgNames","","",19,N],[13,"RenderedConst","","",19,N],[13,"DylibDepFormats","","",19,N],[13,"IsPanicRuntime","","",19,N],[13,"IsCompilerBuiltins","","",19,N],[13,"HasGlobalAllocator","","",19,N],[13,"HasPanicHandler","","",19,N],[13,"ExternCrate","","",19,N],[13,"LintLevels","","",19,N],[13,"Specializes","","",19,N],[13,"InScopeTraits","","",19,N],[13,"ModuleExports","","",19,N],[13,"IsSanitizerRuntime","","",19,N],[13,"IsProfilerRuntime","","",19,N],[13,"GetPanicStrategy","","",19,N],[13,"IsNoBuiltins","","",19,N],[13,"ImplDefaultness","","",19,N],[13,"CheckItemWellFormed","","",19,N],[13,"CheckTraitItemWellFormed","","",19,N],[13,"CheckImplItemWellFormed","","",19,N],[13,"ReachableNonGenerics","","",19,N],[13,"NativeLibraries","","",19,N],[13,"PluginRegistrarFn","","",19,N],[13,"DeriveRegistrarFn","","",19,N],[13,"CrateDisambiguator","","",19,N],[13,"CrateHash","","",19,N],[13,"OriginalCrateName","","",19,N],[13,"ExtraFileName","","",19,N],[13,"ImplementationsOfTrait","","",19,N],[13,"AllTraitImplementations","","",19,N],[13,"DllimportForeignItems","","",19,N],[13,"IsDllimportForeignItem","","",19,N],[13,"IsStaticallyIncludedForeignItem","","",19,N],[13,"NativeLibraryKind","","",19,N],[13,"LinkArgs","","",19,N],[13,"ResolveLifetimes","","",19,N],[13,"NamedRegion","","",19,N],[13,"IsLateBound","","",19,N],[13,"ObjectLifetimeDefaults","","",19,N],[13,"Visibility","","",19,N],[13,"DepKind","","",19,N],[13,"CrateName","","",19,N],[13,"ItemChildren","","",19,N],[13,"ExternModStmtCnum","","",19,N],[13,"GetLibFeatures","","",19,N],[13,"DefinedLibFeatures","","",19,N],[13,"GetLangItems","","",19,N],[13,"DefinedLangItems","","",19,N],[13,"MissingLangItems","","",19,N],[13,"VisibleParentMap","","",19,N],[13,"MissingExternCrateItem","","",19,N],[13,"UsedCrateSource","","",19,N],[13,"PostorderCnums","","",19,N],[13,"EraseRegionsTy","","",19,N],[13,"Freevars","","",19,N],[13,"MaybeUnusedTraitImport","","",19,N],[13,"MaybeUnusedExternCrates","","",19,N],[13,"StabilityIndex","","",19,N],[13,"AllTraits","","",19,N],[13,"AllCrateNums","","",19,N],[13,"ExportedSymbols","","",19,N],[13,"CollectAndPartitionMonoItems","","",19,N],[13,"IsCodegenedItem","","",19,N],[13,"CodegenUnit","","",19,N],[13,"CompileCodegenUnit","","",19,N],[13,"OutputFilenames","","",19,N],[13,"NormalizeProjectionTy","","",19,N],[13,"NormalizeTyAfterErasingRegions","","",19,N],[13,"ImpliedOutlivesBounds","","",19,N],[13,"DropckOutlives","","",19,N],[13,"EvaluateObligation","","",19,N],[13,"TypeOpEq","","",19,N],[13,"TypeOpSubtype","","",19,N],[13,"TypeOpProvePredicate","","",19,N],[13,"TypeOpNormalizeTy","","",19,N],[13,"TypeOpNormalizePredicate","","",19,N],[13,"TypeOpNormalizePolyFnSig","","",19,N],[13,"TypeOpNormalizeFnSig","","",19,N],[13,"SubstituteNormalizeAndTestPredicates","","",19,N],[13,"TargetFeaturesWhitelist","","",19,N],[13,"InstanceDefSizeEstimate","","",19,N],[13,"Features","","",19,N],[13,"ProgramClausesFor","","",19,N],[13,"ProgramClausesForEnv","","",19,N],[13,"WasmImportModuleMap","","",19,N],[13,"ForeignModules","","",19,N],[13,"UpstreamMonomorphizations","","",19,N],[13,"UpstreamMonomorphizationsFor","","",19,N],[4,"DepConstructor","","",N,N],[13,"Null","","",20,N],[13,"Krate","","",20,N],[13,"HirBody","","",20,N],[13,"Hir","","",20,N],[13,"CrateMetadata","","",20,N],[13,"RegionScopeTree","","",20,N],[13,"Coherence","","",20,N],[13,"CoherenceInherentImplOverlapCheck","","",20,N],[13,"CoherenceCheckTrait","","",20,N],[13,"PrivacyAccessLevels","","",20,N],[13,"MirConstQualif","","",20,N],[13,"MirBuilt","","",20,N],[13,"MirConst","","",20,N],[13,"MirValidated","","",20,N],[13,"MirOptimized","","",20,N],[13,"MirShim","","",20,N],[12,"instance_def","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"BorrowCheckKrate","rustc::dep_graph::dep_node","",20,N],[13,"BorrowCheck","","",20,N],[13,"MirBorrowCheck","","",20,N],[13,"UnsafetyCheckResult","","",20,N],[13,"UnsafeDeriveOnReprPacked","","",20,N],[13,"Reachability","","",20,N],[13,"MirKeys","","",20,N],[13,"CrateVariances","","",20,N],[13,"AssociatedItems","","",20,N],[13,"TypeOfItem","","",20,N],[13,"GenericsOfItem","","",20,N],[13,"PredicatesOfItem","","",20,N],[13,"ExplicitPredicatesOfItem","","",20,N],[13,"PredicatesDefinedOnItem","","",20,N],[13,"InferredOutlivesOf","","",20,N],[13,"InferredOutlivesCrate","","",20,N],[13,"SuperPredicatesOfItem","","",20,N],[13,"TraitDefOfItem","","",20,N],[13,"AdtDefOfItem","","",20,N],[13,"ImplTraitRef","","",20,N],[13,"ImplPolarity","","",20,N],[13,"FnSignature","","",20,N],[13,"CoerceUnsizedInfo","","",20,N],[13,"ItemVarianceConstraints","","",20,N],[13,"ItemVariances","","",20,N],[13,"IsConstFn","","",20,N],[13,"IsForeignItem","","",20,N],[13,"TypeParamPredicates","","",20,N],[12,"item_id","rustc::dep_graph::dep_node::DepConstructor","",20,N],[12,"param_id","","",20,N],[13,"SizedConstraint","rustc::dep_graph::dep_node","",20,N],[13,"DtorckConstraint","","",20,N],[13,"AdtDestructor","","",20,N],[13,"AssociatedItemDefIds","","",20,N],[13,"InherentImpls","","",20,N],[13,"TypeckBodiesKrate","","",20,N],[13,"TypeckTables","","",20,N],[13,"UsedTraitImports","","",20,N],[13,"HasTypeckTables","","",20,N],[13,"ConstEval","","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"CheckMatch","rustc::dep_graph::dep_node","",20,N],[13,"SymbolName","","",20,N],[13,"InstanceSymbolName","","",20,N],[12,"instance","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"SpecializationGraph","rustc::dep_graph::dep_node","",20,N],[13,"ObjectSafety","","",20,N],[13,"FulfillObligation","","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[12,"trait_ref","","",20,N],[13,"VtableMethods","rustc::dep_graph::dep_node","",20,N],[12,"trait_ref","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"IsCopy","rustc::dep_graph::dep_node","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"IsSized","rustc::dep_graph::dep_node","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"IsFreeze","rustc::dep_graph::dep_node","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"NeedsDrop","rustc::dep_graph::dep_node","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"Layout","rustc::dep_graph::dep_node","",20,N],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"TraitImpls","rustc::dep_graph::dep_node","",20,N],[13,"AllLocalTraitImpls","","",20,N],[13,"TraitSelect","","",20,N],[13,"ParamEnv","","",20,N],[13,"DescribeDef","","",20,N],[13,"DefSpan","","",20,N],[13,"LookupStability","","",20,N],[13,"LookupDeprecationEntry","","",20,N],[13,"ConstIsRvaluePromotableToStatic","","",20,N],[13,"RvaluePromotableMap","","",20,N],[13,"ImplParent","","",20,N],[13,"TraitOfItem","","",20,N],[13,"IsReachableNonGeneric","","",20,N],[13,"IsUnreachableLocalDefinition","","",20,N],[13,"IsMirAvailable","","",20,N],[13,"ItemAttrs","","",20,N],[13,"CodegenFnAttrs","","",20,N],[13,"FnArgNames","","",20,N],[13,"RenderedConst","","",20,N],[13,"DylibDepFormats","","",20,N],[13,"IsPanicRuntime","","",20,N],[13,"IsCompilerBuiltins","","",20,N],[13,"HasGlobalAllocator","","",20,N],[13,"HasPanicHandler","","",20,N],[13,"ExternCrate","","",20,N],[13,"LintLevels","","",20,N],[13,"Specializes","","",20,N],[12,"impl1","rustc::dep_graph::dep_node::DepConstructor","",20,N],[12,"impl2","","",20,N],[13,"InScopeTraits","rustc::dep_graph::dep_node","",20,N],[13,"ModuleExports","","",20,N],[13,"IsSanitizerRuntime","","",20,N],[13,"IsProfilerRuntime","","",20,N],[13,"GetPanicStrategy","","",20,N],[13,"IsNoBuiltins","","",20,N],[13,"ImplDefaultness","","",20,N],[13,"CheckItemWellFormed","","",20,N],[13,"CheckTraitItemWellFormed","","",20,N],[13,"CheckImplItemWellFormed","","",20,N],[13,"ReachableNonGenerics","","",20,N],[13,"NativeLibraries","","",20,N],[13,"PluginRegistrarFn","","",20,N],[13,"DeriveRegistrarFn","","",20,N],[13,"CrateDisambiguator","","",20,N],[13,"CrateHash","","",20,N],[13,"OriginalCrateName","","",20,N],[13,"ExtraFileName","","",20,N],[13,"ImplementationsOfTrait","","",20,N],[12,"krate","rustc::dep_graph::dep_node::DepConstructor","",20,N],[12,"trait_id","","",20,N],[13,"AllTraitImplementations","rustc::dep_graph::dep_node","",20,N],[13,"DllimportForeignItems","","",20,N],[13,"IsDllimportForeignItem","","",20,N],[13,"IsStaticallyIncludedForeignItem","","",20,N],[13,"NativeLibraryKind","","",20,N],[13,"LinkArgs","","",20,N],[13,"ResolveLifetimes","","",20,N],[13,"NamedRegion","","",20,N],[13,"IsLateBound","","",20,N],[13,"ObjectLifetimeDefaults","","",20,N],[13,"Visibility","","",20,N],[13,"DepKind","","",20,N],[13,"CrateName","","",20,N],[13,"ItemChildren","","",20,N],[13,"ExternModStmtCnum","","",20,N],[13,"GetLibFeatures","","",20,N],[13,"DefinedLibFeatures","","",20,N],[13,"GetLangItems","","",20,N],[13,"DefinedLangItems","","",20,N],[13,"MissingLangItems","","",20,N],[13,"VisibleParentMap","","",20,N],[13,"MissingExternCrateItem","","",20,N],[13,"UsedCrateSource","","",20,N],[13,"PostorderCnums","","",20,N],[13,"EraseRegionsTy","","",20,N],[12,"ty","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"Freevars","rustc::dep_graph::dep_node","",20,N],[13,"MaybeUnusedTraitImport","","",20,N],[13,"MaybeUnusedExternCrates","","",20,N],[13,"StabilityIndex","","",20,N],[13,"AllTraits","","",20,N],[13,"AllCrateNums","","",20,N],[13,"ExportedSymbols","","",20,N],[13,"CollectAndPartitionMonoItems","","",20,N],[13,"IsCodegenedItem","","",20,N],[13,"CodegenUnit","","",20,N],[13,"CompileCodegenUnit","","",20,N],[13,"OutputFilenames","","",20,N],[13,"NormalizeProjectionTy","","",20,N],[13,"NormalizeTyAfterErasingRegions","","",20,N],[13,"ImpliedOutlivesBounds","","",20,N],[13,"DropckOutlives","","",20,N],[13,"EvaluateObligation","","",20,N],[13,"TypeOpEq","","",20,N],[13,"TypeOpSubtype","","",20,N],[13,"TypeOpProvePredicate","","",20,N],[13,"TypeOpNormalizeTy","","",20,N],[13,"TypeOpNormalizePredicate","","",20,N],[13,"TypeOpNormalizePolyFnSig","","",20,N],[13,"TypeOpNormalizeFnSig","","",20,N],[13,"SubstituteNormalizeAndTestPredicates","","",20,N],[12,"key","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"TargetFeaturesWhitelist","rustc::dep_graph::dep_node","",20,N],[13,"InstanceDefSizeEstimate","","",20,N],[12,"instance_def","rustc::dep_graph::dep_node::DepConstructor","",20,N],[13,"Features","rustc::dep_graph::dep_node","",20,N],[13,"ProgramClausesFor","","",20,N],[13,"ProgramClausesForEnv","","",20,N],[13,"WasmImportModuleMap","","",20,N],[13,"ForeignModules","","",20,N],[13,"UpstreamMonomorphizations","","",20,N],[13,"UpstreamMonomorphizationsFor","","",20,N],[0,"label_strs","","Contains variant => str representations for constructing DepNode groups for tests.",N,N],[17,"Null","rustc::dep_graph::dep_node::label_strs","",N,N],[17,"Krate","","",N,N],[17,"HirBody","","",N,N],[17,"Hir","","",N,N],[17,"CrateMetadata","","",N,N],[17,"RegionScopeTree","","",N,N],[17,"Coherence","","",N,N],[17,"CoherenceInherentImplOverlapCheck","","",N,N],[17,"CoherenceCheckTrait","","",N,N],[17,"PrivacyAccessLevels","","",N,N],[17,"MirConstQualif","","",N,N],[17,"MirBuilt","","",N,N],[17,"MirConst","","",N,N],[17,"MirValidated","","",N,N],[17,"MirOptimized","","",N,N],[17,"MirShim","","",N,N],[17,"BorrowCheckKrate","","",N,N],[17,"BorrowCheck","","",N,N],[17,"MirBorrowCheck","","",N,N],[17,"UnsafetyCheckResult","","",N,N],[17,"UnsafeDeriveOnReprPacked","","",N,N],[17,"Reachability","","",N,N],[17,"MirKeys","","",N,N],[17,"CrateVariances","","",N,N],[17,"AssociatedItems","","",N,N],[17,"TypeOfItem","","",N,N],[17,"GenericsOfItem","","",N,N],[17,"PredicatesOfItem","","",N,N],[17,"ExplicitPredicatesOfItem","","",N,N],[17,"PredicatesDefinedOnItem","","",N,N],[17,"InferredOutlivesOf","","",N,N],[17,"InferredOutlivesCrate","","",N,N],[17,"SuperPredicatesOfItem","","",N,N],[17,"TraitDefOfItem","","",N,N],[17,"AdtDefOfItem","","",N,N],[17,"ImplTraitRef","","",N,N],[17,"ImplPolarity","","",N,N],[17,"FnSignature","","",N,N],[17,"CoerceUnsizedInfo","","",N,N],[17,"ItemVarianceConstraints","","",N,N],[17,"ItemVariances","","",N,N],[17,"IsConstFn","","",N,N],[17,"IsForeignItem","","",N,N],[17,"TypeParamPredicates","","",N,N],[17,"SizedConstraint","","",N,N],[17,"DtorckConstraint","","",N,N],[17,"AdtDestructor","","",N,N],[17,"AssociatedItemDefIds","","",N,N],[17,"InherentImpls","","",N,N],[17,"TypeckBodiesKrate","","",N,N],[17,"TypeckTables","","",N,N],[17,"UsedTraitImports","","",N,N],[17,"HasTypeckTables","","",N,N],[17,"ConstEval","","",N,N],[17,"CheckMatch","","",N,N],[17,"SymbolName","","",N,N],[17,"InstanceSymbolName","","",N,N],[17,"SpecializationGraph","","",N,N],[17,"ObjectSafety","","",N,N],[17,"FulfillObligation","","",N,N],[17,"VtableMethods","","",N,N],[17,"IsCopy","","",N,N],[17,"IsSized","","",N,N],[17,"IsFreeze","","",N,N],[17,"NeedsDrop","","",N,N],[17,"Layout","","",N,N],[17,"TraitImpls","","",N,N],[17,"AllLocalTraitImpls","","",N,N],[17,"TraitSelect","","",N,N],[17,"ParamEnv","","",N,N],[17,"DescribeDef","","",N,N],[17,"DefSpan","","",N,N],[17,"LookupStability","","",N,N],[17,"LookupDeprecationEntry","","",N,N],[17,"ConstIsRvaluePromotableToStatic","","",N,N],[17,"RvaluePromotableMap","","",N,N],[17,"ImplParent","","",N,N],[17,"TraitOfItem","","",N,N],[17,"IsReachableNonGeneric","","",N,N],[17,"IsUnreachableLocalDefinition","","",N,N],[17,"IsMirAvailable","","",N,N],[17,"ItemAttrs","","",N,N],[17,"CodegenFnAttrs","","",N,N],[17,"FnArgNames","","",N,N],[17,"RenderedConst","","",N,N],[17,"DylibDepFormats","","",N,N],[17,"IsPanicRuntime","","",N,N],[17,"IsCompilerBuiltins","","",N,N],[17,"HasGlobalAllocator","","",N,N],[17,"HasPanicHandler","","",N,N],[17,"ExternCrate","","",N,N],[17,"LintLevels","","",N,N],[17,"Specializes","","",N,N],[17,"InScopeTraits","","",N,N],[17,"ModuleExports","","",N,N],[17,"IsSanitizerRuntime","","",N,N],[17,"IsProfilerRuntime","","",N,N],[17,"GetPanicStrategy","","",N,N],[17,"IsNoBuiltins","","",N,N],[17,"ImplDefaultness","","",N,N],[17,"CheckItemWellFormed","","",N,N],[17,"CheckTraitItemWellFormed","","",N,N],[17,"CheckImplItemWellFormed","","",N,N],[17,"ReachableNonGenerics","","",N,N],[17,"NativeLibraries","","",N,N],[17,"PluginRegistrarFn","","",N,N],[17,"DeriveRegistrarFn","","",N,N],[17,"CrateDisambiguator","","",N,N],[17,"CrateHash","","",N,N],[17,"OriginalCrateName","","",N,N],[17,"ExtraFileName","","",N,N],[17,"ImplementationsOfTrait","","",N,N],[17,"AllTraitImplementations","","",N,N],[17,"DllimportForeignItems","","",N,N],[17,"IsDllimportForeignItem","","",N,N],[17,"IsStaticallyIncludedForeignItem","","",N,N],[17,"NativeLibraryKind","","",N,N],[17,"LinkArgs","","",N,N],[17,"ResolveLifetimes","","",N,N],[17,"NamedRegion","","",N,N],[17,"IsLateBound","","",N,N],[17,"ObjectLifetimeDefaults","","",N,N],[17,"Visibility","","",N,N],[17,"DepKind","","",N,N],[17,"CrateName","","",N,N],[17,"ItemChildren","","",N,N],[17,"ExternModStmtCnum","","",N,N],[17,"GetLibFeatures","","",N,N],[17,"DefinedLibFeatures","","",N,N],[17,"GetLangItems","","",N,N],[17,"DefinedLangItems","","",N,N],[17,"MissingLangItems","","",N,N],[17,"VisibleParentMap","","",N,N],[17,"MissingExternCrateItem","","",N,N],[17,"UsedCrateSource","","",N,N],[17,"PostorderCnums","","",N,N],[17,"EraseRegionsTy","","",N,N],[17,"Freevars","","",N,N],[17,"MaybeUnusedTraitImport","","",N,N],[17,"MaybeUnusedExternCrates","","",N,N],[17,"StabilityIndex","","",N,N],[17,"AllTraits","","",N,N],[17,"AllCrateNums","","",N,N],[17,"ExportedSymbols","","",N,N],[17,"CollectAndPartitionMonoItems","","",N,N],[17,"IsCodegenedItem","","",N,N],[17,"CodegenUnit","","",N,N],[17,"CompileCodegenUnit","","",N,N],[17,"OutputFilenames","","",N,N],[17,"NormalizeProjectionTy","","",N,N],[17,"NormalizeTyAfterErasingRegions","","",N,N],[17,"ImpliedOutlivesBounds","","",N,N],[17,"DropckOutlives","","",N,N],[17,"EvaluateObligation","","",N,N],[17,"TypeOpEq","","",N,N],[17,"TypeOpSubtype","","",N,N],[17,"TypeOpProvePredicate","","",N,N],[17,"TypeOpNormalizeTy","","",N,N],[17,"TypeOpNormalizePredicate","","",N,N],[17,"TypeOpNormalizePolyFnSig","","",N,N],[17,"TypeOpNormalizeFnSig","","",N,N],[17,"SubstituteNormalizeAndTestPredicates","","",N,N],[17,"TargetFeaturesWhitelist","","",N,N],[17,"InstanceDefSizeEstimate","","",N,N],[17,"Features","","",N,N],[17,"ProgramClausesFor","","",N,N],[17,"ProgramClausesForEnv","","",N,N],[17,"WasmImportModuleMap","","",N,N],[17,"ForeignModules","","",N,N],[17,"UpstreamMonomorphizations","","",N,N],[17,"UpstreamMonomorphizationsFor","","",N,N],[8,"DepNodeParams","rustc::dep_graph::dep_node","",N,N],[18,"CAN_RECONSTRUCT_QUERY_KEY","","",26,N],[11,"to_fingerprint","","This method turns the parameters of a DepNodeConstructor into an opaque Fingerprint to be used in DepNode. Not all DepNodeParams support being turned into a Fingerprint (they don't need to if the corresponding DepNode is anonymous).",26,[[["self"],["tyctxt"]],["fingerprint"]]],[11,"to_debug_str","","",26,[[["self"],["tyctxt"]],["string"]]],[11,"fmt","rustc::dep_graph","",9,[[["self"],["formatter"]],["result"]]],[11,"fingerprint_needed_for_crate_hash","","",19,[[["self"]],["bool"]]],[11,"clone","","",19,[[["self"]],["depkind"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"eq","","",19,[[["self"],["depkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"partial_cmp","","",19,[[["self"],["depkind"]],["option",["ordering"]]]],[11,"cmp","","",19,[[["self"],["depkind"]],["ordering"]]],[11,"hash","","",19,N],[11,"encode","","",19,[[["self"],["__s"]],["result"]]],[11,"decode","","",19,[[["__d"]],["result",["depkind"]]]],[11,"can_reconstruct_query_key","","",19,[[["self"]],["bool"]]],[11,"is_anon","","",19,[[["self"]],["bool"]]],[11,"is_input","","",19,[[["self"]],["bool"]]],[11,"is_eval_always","","",19,[[["self"]],["bool"]]],[11,"has_params","","",19,[[["self"]],["bool"]]],[11,"clone","","",9,[[["self"]],["depnode"]]],[11,"eq","","",9,[[["self"],["depnode"]],["bool"]]],[11,"ne","","",9,[[["self"],["depnode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"partial_cmp","","",9,[[["self"],["depnode"]],["option",["ordering"]]]],[11,"lt","","",9,[[["self"],["depnode"]],["bool"]]],[11,"le","","",9,[[["self"],["depnode"]],["bool"]]],[11,"gt","","",9,[[["self"],["depnode"]],["bool"]]],[11,"ge","","",9,[[["self"],["depnode"]],["bool"]]],[11,"cmp","","",9,[[["self"],["depnode"]],["ordering"]]],[11,"hash","","",9,N],[11,"encode","","",9,[[["self"],["__s"]],["result"]]],[11,"decode","","",9,[[["__d"]],["result",["depnode"]]]],[11,"new","","",9,[[["tyctxt"],["depconstructor"]],["depnode"]]],[11,"from_def_path_hash","","Construct a DepNode from the given DepKind and DefPathHash. This method will assert that the given DepKind actually requires a single DefId/DefPathHash parameter.",9,[[["depkind"],["defpathhash"]],["depnode"]]],[11,"new_no_params","","Create a new, parameterless DepNode. This method will assert that the DepNode corresponding to the given DepKind actually does not require any parameters.",9,[[["depkind"]],["depnode"]]],[11,"extract_def_id","","Extract the DefId corresponding to this DepNode. This will work if two conditions are met:",9,[[["self"],["tyctxt"]],["option",["defid"]]]],[11,"from_label_string","","Used in testing",9,[[["str"],["defpathhash"]],["result",["depnode"]]]],[11,"has_label_string","","Used in testing",9,[[["str"]],["bool"]]],[11,"clone","","",10,[[["self"]],["workproductid"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"eq","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"ne","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"partial_cmp","","",10,[[["self"],["workproductid"]],["option",["ordering"]]]],[11,"lt","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"le","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"gt","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"ge","","",10,[[["self"],["workproductid"]],["bool"]]],[11,"cmp","","",10,[[["self"],["workproductid"]],["ordering"]]],[11,"hash","","",10,N],[11,"encode","","",10,[[["self"],["__s"]],["result"]]],[11,"decode","","",10,[[["__d"]],["result",["workproductid"]]]],[11,"from_cgu_name","","",10,[[["str"]],["workproductid"]]],[11,"from_fingerprint","","",10,[[["fingerprint"]],["workproductid"]]],[11,"hash_stable","","",10,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"dep_tracking_map","","",N,N],[3,"DepTrackingMap","rustc::dep_graph::dep_tracking_map","A DepTrackingMap offers a subset of the `Map` API and ensures that we make calls to `read` and `write` as appropriate. We key the maps with a unique type for brevity.",N,N],[12,"phantom","","",8,N],[12,"graph","","",8,N],[12,"map","","",8,N],[8,"DepTrackingMapConfig","","",N,N],[16,"Key","","",27,N],[16,"Value","","",27,N],[10,"to_dep_kind","","",27,[[],["depkind"]]],[11,"new","rustc::dep_graph","",8,[[["depgraph"]],["deptrackingmap"]]],[0,"graph","","",N,N],[3,"DepGraph","rustc::dep_graph::graph","",N,N],[12,"data","","",11,N],[12,"fingerprints","","",11,N],[3,"DepNodeIndex","","",N,N],[12,"private","","",13,N],[3,"DepGraphData","","",N,N],[12,"current","","The new encoding of the dependency graph, optimized for red/green tracking. The `current` field is the dependency graph of only the current compilation session: We don't merge the previous dep-graph into current one anymore.",28,N],[12,"previous","","The dep-graph from the previous compilation session. It contains all nodes and edges as well as all fingerprints of nodes that have them.",28,N],[12,"colors","","",28,N],[12,"previous_work_products","","When we load, there may be `.o` files, cached mir, or other such things available to us. If we find that they are not dirty, we load the path to the file storing those work-products here into this map. We can later look for and extract that data.",28,N],[12,"dep_node_debug","","",28,N],[12,"loaded_from_cache","","",28,N],[3,"WorkProduct","","A \"work product\" is an intermediate result that we save into the incremental directory for later re-use. The primary example are the object files that we save for each partition at code generation time.",N,N],[12,"cgu_name","","",12,N],[12,"saved_files","","Saved files associated with this CGU",12,N],[3,"CurrentDepGraph","","",N,N],[12,"nodes","","",29,N],[12,"edges","","",29,N],[12,"node_to_node_index","","",29,N],[12,"forbidden_edge","","",29,N],[12,"anon_id_seed","","",29,N],[12,"total_read_count","","",29,N],[12,"total_duplicate_read_count","","",29,N],[3,"RegularOpenTask","","",N,N],[12,"node","","",30,N],[12,"reads","","",30,N],[12,"read_set","","",30,N],[3,"AnonOpenTask","","",N,N],[12,"reads","","",31,N],[12,"read_set","","",31,N],[3,"DepNodeColorMap","","",N,N],[12,"values","","",32,N],[4,"DepNodeColor","","",N,N],[13,"Red","","",21,N],[13,"Green","","",21,N],[4,"WorkProductFileKind","","",N,N],[13,"Object","","",23,N],[13,"Bytecode","","",23,N],[13,"BytecodeCompressed","","",23,N],[4,"OpenTask","","",N,N],[13,"Regular","","",22,N],[13,"Anon","","",22,N],[13,"Ignore","","",22,N],[13,"EvalAlways","","",22,N],[12,"node","rustc::dep_graph::graph::OpenTask","",22,N],[17,"COMPRESSED_NONE","rustc::dep_graph::graph","",N,N],[17,"COMPRESSED_RED","","",N,N],[17,"COMPRESSED_FIRST_GREEN","","",N,N],[11,"clone","rustc::dep_graph","",11,[[["self"]],["depgraph"]]],[11,"clone","","",13,[[["self"]],["depnodeindex"]]],[11,"eq","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"ne","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",13,N],[11,"hash","","",13,N],[11,"partial_cmp","","",13,[[["self"],["depnodeindex"]],["option",["ordering"]]]],[11,"lt","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"le","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"gt","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"ge","","",13,[[["self"],["depnodeindex"]],["bool"]]],[11,"cmp","","",13,[[["self"],["depnodeindex"]],["ordering"]]],[11,"decode","","",13,[[["__d"]],["result",["depnodeindex"]]]],[11,"encode","","",13,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",13,N],[18,"MAX","","",13,N],[11,"from_usize","","",13,[[["usize"]],["self"]]],[11,"from_u32","","",13,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",13,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",13,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",13,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",13,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",13,[[["self"]],["usize"]]],[11,"new","","",13,[[["usize"]],["self"]]],[11,"index","","",13,[[["self"]],["usize"]]],[11,"steps_between","","",13,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",13,[[["self"]],["self"]]],[11,"replace_zero","","",13,[[["self"]],["self"]]],[11,"add_one","","",13,[[["self"]],["self"]]],[11,"sub_one","","",13,[[["self"]],["self"]]],[11,"add_usize","","",13,[[["self"],["usize"]],["option"]]],[11,"from","","",13,[[["usize"]],["self"]]],[11,"from","","",13,[[["u32"]],["self"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[18,"INVALID","","",13,N],[11,"clone","","",21,[[["self"]],["depnodecolor"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"eq","","",21,[[["self"],["depnodecolor"]],["bool"]]],[11,"ne","","",21,[[["self"],["depnodecolor"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"hash","","",21,N],[11,"is_green","","",21,[[["self"]],["bool"]]],[11,"new","","",11,[[["previousdepgraph"],["fxhashmap",["workproductid","workproduct"]]],["depgraph"]]],[11,"new_disabled","","",11,[[],["depgraph"]]],[11,"is_fully_enabled","","True if we are actually building the full dep-graph.",11,[[["self"]],["bool"]]],[11,"query","","",11,[[["self"]],["depgraphquery"]]],[11,"assert_ignored","","",11,[[["self"]]]],[11,"with_ignore","","",11,[[["self"],["op"]],["r"]]],[11,"with_task","","Starts a new dep-graph task. Dep-graph tasks are specified using a free function (`task`) and not a closure -- this is intentional because we want to exercise tight control over what state they have access to. In particular, we want to prevent implicit 'leaks' of tracked state into the task (which could then be read without generating correct edges in the dep-graph -- see the [rustc guide] for more details on the dep-graph). To this end, the task function gets exactly two pieces of state: the context `cx` and an argument `arg`. Both of these bits of state must be of some type that implements `DepGraphSafe` and hence does not leak.",11,N],[11,"input_task","","Creates a new dep-graph input with value `input`",11,N],[11,"with_task_impl","","",11,N],[11,"with_anon_task","","Execute something within an \"anonymous\" task, that is, a task the DepNode of which is determined by the list of inputs it read from.",11,N],[11,"with_eval_always_task","","Execute something within an \"eval-always\" task which is a task",11,N],[11,"read","","",11,[[["self"],["depnode"]]]],[11,"read_index","","",11,[[["self"],["depnodeindex"]]]],[11,"dep_node_index_of","","",11,[[["self"],["depnode"]],["depnodeindex"]]],[11,"dep_node_exists","","",11,[[["self"],["depnode"]],["bool"]]],[11,"fingerprint_of","","",11,[[["self"],["depnodeindex"]],["fingerprint"]]],[11,"prev_fingerprint_of","","",11,[[["self"],["depnode"]],["option",["fingerprint"]]]],[11,"prev_dep_node_index_of","","",11,[[["self"],["depnode"]],["serializeddepnodeindex"]]],[11,"previous_work_product","","Check whether a previous work product exists for `v` and, if so, return the path that leads to it. Used to skip doing work.",11,[[["self"],["workproductid"]],["option",["workproduct"]]]],[11,"previous_work_products","","Access the map of work-products created during the cached run. Only used during saving of the dep-graph.",11,[[["self"]],["fxhashmap"]]],[11,"register_dep_node_debug_str","","",11,[[["self"],["depnode"],["f"]]]],[11,"dep_node_debug_str","","",11,[[["self"],["depnode"]],["option",["string"]]]],[11,"edge_deduplication_data","","",11,N],[11,"serialize","","",11,[[["self"]],["serializeddepgraph"]]],[11,"node_color","","",11,[[["self"],["depnode"]],["option",["depnodecolor"]]]],[11,"try_mark_green","","",11,[[["self"],["tyctxt"],["depnode"]],["option",["depnodeindex"]]]],[11,"is_green","","",11,[[["self"],["depnode"]],["bool"]]],[11,"exec_cache_promotions","","",11,[[["self"],["tyctxt"]]]],[11,"mark_loaded_from_cache","","",11,[[["self"],["depnodeindex"],["bool"]]]],[11,"was_loaded_from_cache","","",11,[[["self"],["depnode"]],["option",["bool"]]]],[11,"clone","","",12,[[["self"]],["workproduct"]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"encode","","",12,[[["self"],["__s"]],["result"]]],[11,"decode","","",12,[[["__d"]],["result",["workproduct"]]]],[11,"clone","","",23,[[["self"]],["workproductfilekind"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"encode","","",23,[[["self"],["__s"]],["result"]]],[11,"decode","","",23,[[["__d"]],["result",["workproductfilekind"]]]],[11,"eq","","",23,[[["self"],["workproductfilekind"]],["bool"]]],[11,"new","rustc::dep_graph::graph","",29,[[],["currentdepgraph"]]],[11,"complete_task","","",29,[[["self"],["depnode"],["opentask"]],["depnodeindex"]]],[11,"pop_anon_task","","",29,[[["self"],["depkind"],["opentask"]],["depnodeindex"]]],[11,"complete_eval_always_task","","",29,[[["self"],["depnode"],["opentask"]],["depnodeindex"]]],[11,"read_index","","",29,[[["self"],["depnodeindex"]]]],[11,"alloc_node","","",29,[[["self"],["depnode"],["smallvec"]],["depnodeindex"]]],[11,"new","","",32,[[["usize"]],["depnodecolormap"]]],[11,"get","","",32,[[["self"],["serializeddepnodeindex"]],["option",["depnodecolor"]]]],[11,"insert","","",32,[[["self"],["serializeddepnodeindex"],["depnodecolor"]]]],[0,"prev","rustc::dep_graph","",N,N],[3,"PreviousDepGraph","rustc::dep_graph::prev","",N,N],[12,"data","","",14,N],[12,"index","","",14,N],[11,"fmt","rustc::dep_graph","",14,[[["self"],["formatter"]],["result"]]],[11,"encode","","",14,[[["self"],["__s"]],["result"]]],[11,"decode","","",14,[[["__d"]],["result",["previousdepgraph"]]]],[11,"new","","",14,[[["serializeddepgraph"]],["previousdepgraph"]]],[11,"edges_from","","",14,[[["self"],["depnode"]],["option"]]],[11,"index_to_node","","",14,[[["self"],["serializeddepnodeindex"]],["depnode"]]],[11,"node_to_index","","",14,[[["self"],["depnode"]],["serializeddepnodeindex"]]],[11,"node_to_index_opt","","",14,[[["self"],["depnode"]],["option",["serializeddepnodeindex"]]]],[11,"fingerprint_of","","",14,[[["self"],["depnode"]],["option",["fingerprint"]]]],[11,"fingerprint_by_index","","",14,[[["self"],["serializeddepnodeindex"]],["fingerprint"]]],[11,"node_count","","",14,[[["self"]],["usize"]]],[0,"query","","",N,N],[3,"DepGraphQuery","rustc::dep_graph::query","",N,N],[12,"graph","","",15,N],[12,"indices","","",15,N],[11,"new","rustc::dep_graph","",15,N],[11,"contains_node","","",15,[[["self"],["depnode"]],["bool"]]],[11,"nodes","","",15,[[["self"]],["vec",["depnode"]]]],[11,"edges","","",15,[[["self"]],["vec"]]],[11,"reachable_nodes","","",15,[[["self"],["depnode"],["direction"]],["vec",["depnode"]]]],[11,"transitive_successors","","All nodes reachable from `node`. In other words, things that will have to be recomputed if `node` changes.",15,[[["self"],["depnode"]],["vec",["depnode"]]]],[11,"transitive_predecessors","","All nodes that can reach `node`.",15,[[["self"],["depnode"]],["vec",["depnode"]]]],[11,"immediate_successors","","Just the outgoing edges from `node`.",15,[[["self"],["depnode"]],["vec",["depnode"]]]],[0,"safe","","The `DepGraphSafe` trait",N,N],[3,"AssertDepGraphSafe","rustc::dep_graph::safe","A convenient override that lets you pass arbitrary state into a task. Every use should be accompanied by a comment explaining why it makes sense (or how it could be refactored away in the future).",N,N],[12,"0","","",16,N],[8,"DepGraphSafe","","The `DepGraphSafe` trait is used to specify what kinds of values are safe to \"leak\" into a task. The idea is that this should be only be implemented for things like the tcx as well as various id types, which will create reads in the dep-graph whenever the trait loads anything that might depend on the input program.",N,N],[0,"serialized","rustc::dep_graph","The data that we will serialize and deserialize.",N,N],[3,"SerializedDepNodeIndex","rustc::dep_graph::serialized","",N,N],[12,"private","","",18,N],[3,"SerializedDepGraph","","Data for use when recompiling the current crate.",N,N],[12,"nodes","","The set of all DepNodes in the graph",17,N],[12,"fingerprints","","The set of all Fingerprints in the graph. Each Fingerprint corresponds to the DepNode at the same index in the nodes vector.",17,N],[12,"edge_list_indices","","For each DepNode, stores the list of edges originating from that DepNode. Encoded as a [start, end) pair indexing into edge_list_data, which holds the actual DepNodeIndices of the target nodes.",17,N],[12,"edge_list_data","","A flattened list of all edge targets in the graph. Edge sources are implicit in edge_list_indices.",17,N],[11,"clone","rustc::dep_graph","",18,[[["self"]],["serializeddepnodeindex"]]],[11,"eq","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"ne","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",18,N],[11,"hash","","",18,N],[11,"partial_cmp","","",18,[[["self"],["serializeddepnodeindex"]],["option",["ordering"]]]],[11,"lt","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"le","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"gt","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"ge","","",18,[[["self"],["serializeddepnodeindex"]],["bool"]]],[11,"cmp","","",18,[[["self"],["serializeddepnodeindex"]],["ordering"]]],[11,"decode","","",18,[[["__d"]],["result",["serializeddepnodeindex"]]]],[11,"encode","","",18,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",18,N],[18,"MAX","","",18,N],[11,"from_usize","","",18,[[["usize"]],["self"]]],[11,"from_u32","","",18,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",18,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",18,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",18,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",18,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",18,[[["self"]],["usize"]]],[11,"new","","",18,[[["usize"]],["self"]]],[11,"index","","",18,[[["self"]],["usize"]]],[11,"steps_between","","",18,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",18,[[["self"]],["self"]]],[11,"replace_zero","","",18,[[["self"]],["self"]]],[11,"add_one","","",18,[[["self"]],["self"]]],[11,"sub_one","","",18,[[["self"]],["self"]]],[11,"add_usize","","",18,[[["self"],["usize"]],["option"]]],[11,"from","","",18,[[["usize"]],["self"]]],[11,"from","","",18,[[["u32"]],["self"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"encode","","",17,[[["self"],["__s"]],["result"]]],[11,"decode","","",17,[[["__d"]],["result",["serializeddepgraph"]]]],[11,"new","","",17,[[],["serializeddepgraph"]]],[11,"edge_targets_from","","",17,N],[0,"label_strs","","Contains variant => str representations for constructing DepNode groups for tests.",N,N],[17,"Null","rustc::dep_graph::label_strs","",N,N],[17,"Krate","","",N,N],[17,"HirBody","","",N,N],[17,"Hir","","",N,N],[17,"CrateMetadata","","",N,N],[17,"RegionScopeTree","","",N,N],[17,"Coherence","","",N,N],[17,"CoherenceInherentImplOverlapCheck","","",N,N],[17,"CoherenceCheckTrait","","",N,N],[17,"PrivacyAccessLevels","","",N,N],[17,"MirConstQualif","","",N,N],[17,"MirBuilt","","",N,N],[17,"MirConst","","",N,N],[17,"MirValidated","","",N,N],[17,"MirOptimized","","",N,N],[17,"MirShim","","",N,N],[17,"BorrowCheckKrate","","",N,N],[17,"BorrowCheck","","",N,N],[17,"MirBorrowCheck","","",N,N],[17,"UnsafetyCheckResult","","",N,N],[17,"UnsafeDeriveOnReprPacked","","",N,N],[17,"Reachability","","",N,N],[17,"MirKeys","","",N,N],[17,"CrateVariances","","",N,N],[17,"AssociatedItems","","",N,N],[17,"TypeOfItem","","",N,N],[17,"GenericsOfItem","","",N,N],[17,"PredicatesOfItem","","",N,N],[17,"ExplicitPredicatesOfItem","","",N,N],[17,"PredicatesDefinedOnItem","","",N,N],[17,"InferredOutlivesOf","","",N,N],[17,"InferredOutlivesCrate","","",N,N],[17,"SuperPredicatesOfItem","","",N,N],[17,"TraitDefOfItem","","",N,N],[17,"AdtDefOfItem","","",N,N],[17,"ImplTraitRef","","",N,N],[17,"ImplPolarity","","",N,N],[17,"FnSignature","","",N,N],[17,"CoerceUnsizedInfo","","",N,N],[17,"ItemVarianceConstraints","","",N,N],[17,"ItemVariances","","",N,N],[17,"IsConstFn","","",N,N],[17,"IsForeignItem","","",N,N],[17,"TypeParamPredicates","","",N,N],[17,"SizedConstraint","","",N,N],[17,"DtorckConstraint","","",N,N],[17,"AdtDestructor","","",N,N],[17,"AssociatedItemDefIds","","",N,N],[17,"InherentImpls","","",N,N],[17,"TypeckBodiesKrate","","",N,N],[17,"TypeckTables","","",N,N],[17,"UsedTraitImports","","",N,N],[17,"HasTypeckTables","","",N,N],[17,"ConstEval","","",N,N],[17,"CheckMatch","","",N,N],[17,"SymbolName","","",N,N],[17,"InstanceSymbolName","","",N,N],[17,"SpecializationGraph","","",N,N],[17,"ObjectSafety","","",N,N],[17,"FulfillObligation","","",N,N],[17,"VtableMethods","","",N,N],[17,"IsCopy","","",N,N],[17,"IsSized","","",N,N],[17,"IsFreeze","","",N,N],[17,"NeedsDrop","","",N,N],[17,"Layout","","",N,N],[17,"TraitImpls","","",N,N],[17,"AllLocalTraitImpls","","",N,N],[17,"TraitSelect","","",N,N],[17,"ParamEnv","","",N,N],[17,"DescribeDef","","",N,N],[17,"DefSpan","","",N,N],[17,"LookupStability","","",N,N],[17,"LookupDeprecationEntry","","",N,N],[17,"ConstIsRvaluePromotableToStatic","","",N,N],[17,"RvaluePromotableMap","","",N,N],[17,"ImplParent","","",N,N],[17,"TraitOfItem","","",N,N],[17,"IsReachableNonGeneric","","",N,N],[17,"IsUnreachableLocalDefinition","","",N,N],[17,"IsMirAvailable","","",N,N],[17,"ItemAttrs","","",N,N],[17,"CodegenFnAttrs","","",N,N],[17,"FnArgNames","","",N,N],[17,"RenderedConst","","",N,N],[17,"DylibDepFormats","","",N,N],[17,"IsPanicRuntime","","",N,N],[17,"IsCompilerBuiltins","","",N,N],[17,"HasGlobalAllocator","","",N,N],[17,"HasPanicHandler","","",N,N],[17,"ExternCrate","","",N,N],[17,"LintLevels","","",N,N],[17,"Specializes","","",N,N],[17,"InScopeTraits","","",N,N],[17,"ModuleExports","","",N,N],[17,"IsSanitizerRuntime","","",N,N],[17,"IsProfilerRuntime","","",N,N],[17,"GetPanicStrategy","","",N,N],[17,"IsNoBuiltins","","",N,N],[17,"ImplDefaultness","","",N,N],[17,"CheckItemWellFormed","","",N,N],[17,"CheckTraitItemWellFormed","","",N,N],[17,"CheckImplItemWellFormed","","",N,N],[17,"ReachableNonGenerics","","",N,N],[17,"NativeLibraries","","",N,N],[17,"PluginRegistrarFn","","",N,N],[17,"DeriveRegistrarFn","","",N,N],[17,"CrateDisambiguator","","",N,N],[17,"CrateHash","","",N,N],[17,"OriginalCrateName","","",N,N],[17,"ExtraFileName","","",N,N],[17,"ImplementationsOfTrait","","",N,N],[17,"AllTraitImplementations","","",N,N],[17,"DllimportForeignItems","","",N,N],[17,"IsDllimportForeignItem","","",N,N],[17,"IsStaticallyIncludedForeignItem","","",N,N],[17,"NativeLibraryKind","","",N,N],[17,"LinkArgs","","",N,N],[17,"ResolveLifetimes","","",N,N],[17,"NamedRegion","","",N,N],[17,"IsLateBound","","",N,N],[17,"ObjectLifetimeDefaults","","",N,N],[17,"Visibility","","",N,N],[17,"DepKind","","",N,N],[17,"CrateName","","",N,N],[17,"ItemChildren","","",N,N],[17,"ExternModStmtCnum","","",N,N],[17,"GetLibFeatures","","",N,N],[17,"DefinedLibFeatures","","",N,N],[17,"GetLangItems","","",N,N],[17,"DefinedLangItems","","",N,N],[17,"MissingLangItems","","",N,N],[17,"VisibleParentMap","","",N,N],[17,"MissingExternCrateItem","","",N,N],[17,"UsedCrateSource","","",N,N],[17,"PostorderCnums","","",N,N],[17,"EraseRegionsTy","","",N,N],[17,"Freevars","","",N,N],[17,"MaybeUnusedTraitImport","","",N,N],[17,"MaybeUnusedExternCrates","","",N,N],[17,"StabilityIndex","","",N,N],[17,"AllTraits","","",N,N],[17,"AllCrateNums","","",N,N],[17,"ExportedSymbols","","",N,N],[17,"CollectAndPartitionMonoItems","","",N,N],[17,"IsCodegenedItem","","",N,N],[17,"CodegenUnit","","",N,N],[17,"CompileCodegenUnit","","",N,N],[17,"OutputFilenames","","",N,N],[17,"NormalizeProjectionTy","","",N,N],[17,"NormalizeTyAfterErasingRegions","","",N,N],[17,"ImpliedOutlivesBounds","","",N,N],[17,"DropckOutlives","","",N,N],[17,"EvaluateObligation","","",N,N],[17,"TypeOpEq","","",N,N],[17,"TypeOpSubtype","","",N,N],[17,"TypeOpProvePredicate","","",N,N],[17,"TypeOpNormalizeTy","","",N,N],[17,"TypeOpNormalizePredicate","","",N,N],[17,"TypeOpNormalizePolyFnSig","","",N,N],[17,"TypeOpNormalizeFnSig","","",N,N],[17,"SubstituteNormalizeAndTestPredicates","","",N,N],[17,"TargetFeaturesWhitelist","","",N,N],[17,"InstanceDefSizeEstimate","","",N,N],[17,"Features","","",N,N],[17,"ProgramClausesFor","","",N,N],[17,"ProgramClausesForEnv","","",N,N],[17,"WasmImportModuleMap","","",N,N],[17,"ForeignModules","","",N,N],[17,"UpstreamMonomorphizations","","",N,N],[17,"UpstreamMonomorphizationsFor","","",N,N],[8,"DepTrackingMapConfig","rustc::dep_graph","",N,N],[16,"Key","","",27,N],[16,"Value","","",27,N],[10,"to_dep_kind","","",27,[[],["depkind"]]],[8,"DepGraphSafe","","The `DepGraphSafe` trait is used to specify what kinds of values are safe to \"leak\" into a task. The idea is that this should be only be implemented for things like the tcx as well as various id types, which will create reads in the dep-graph whenever the trait loads anything that might depend on the input program.",N,N],[0,"hir","rustc","",N,N],[3,"HirId","rustc::hir","A HirId uniquely identifies a node in the HIR of the current crate. It is composed of the `owner`, which is the DefIndex of the directly enclosing hir::Item, hir::TraitItem, or hir::ImplItem (i.e. the closest \"item-like\"), and the `local_id` which is unique within the given owner.",N,N],[12,"owner","","",33,N],[12,"local_id","","",33,N],[3,"ItemLocalId","","An `ItemLocalId` uniquely identifies something within a given \"item-like\", that is within a hir::Item, hir::TraitItem, or hir::ImplItem. There is no guarantee that the numerical value of a given `ItemLocalId` corresponds to the node's position within the owning item in any way, but there is a guarantee that the `LocalItemId`s within an owner occupy a dense range of integers starting at zero, so a mapping that maps all or most nodes within an \"item-like\" to something else can be implement by a `Vec` instead of a tree or hash map.",N,N],[12,"0","","",34,N],[3,"Label","","",N,N],[12,"ident","","",35,N],[3,"Lifetime","","",N,N],[12,"id","","",36,N],[12,"span","","",36,N],[12,"name","","Either \"'a\", referring to a named lifetime definition, or \"\" (aka keywords::Invalid), for elision placeholders.",36,N],[3,"Path","","A \"Path\" is essentially Rust's notion of a name; for instance: `std::cmp::PartialEq`. It's represented as a sequence of identifiers, along with a bunch of supporting information.",N,N],[12,"span","","",37,N],[12,"def","","The definition that the path resolved to.",37,N],[12,"segments","","The segments in the path: the things separated by `::`.",37,N],[3,"PathSegment","","A segment of a path: an identifier, an optional lifetime, and a set of types.",N,N],[12,"ident","","The identifier portion of this path segment.",38,N],[12,"args","","Type/lifetime parameters attached to this path. They come in two flavors: `Path<A,B,C>` and `Path(A,B) -> C`. Note that this is more than just simple syntactic sugar; the use of parens affects the region binding rules, so we preserve the distinction.",38,N],[12,"infer_types","","Whether to infer remaining type parameters, if any. This only applies to expression and pattern paths, and out of those only the segments with no type parameters to begin with, e.g. `Vec::new` is `<Vec<..>>::new::<..>`.",38,N],[3,"GenericArgs","","",N,N],[12,"args","","The generic arguments for this path segment.",39,N],[12,"bindings","","Bindings (equality constraints) on associated types, if present. E.g., `Foo<A=Bar>`.",39,N],[12,"parenthesized","","Were arguments written in parenthesized form `Fn(T) -> U`? This is required mostly for pretty-printing and diagnostics, but also for changing lifetime elision rules to be \"function-like\".",39,N],[3,"GenericParam","","",N,N],[12,"id","","",40,N],[12,"name","","",40,N],[12,"attrs","","",40,N],[12,"bounds","","",40,N],[12,"span","","",40,N],[12,"pure_wrt_drop","","",40,N],[12,"kind","","",40,N],[3,"GenericParamCount","","",N,N],[12,"lifetimes","","",41,N],[12,"types","","",41,N],[3,"Generics","","Represents lifetimes and type parameters attached to a declaration of a function, enum, trait, etc.",N,N],[12,"params","","",42,N],[12,"where_clause","","",42,N],[12,"span","","",42,N],[3,"WhereClause","","A `where` clause in a definition",N,N],[12,"id","","",43,N],[12,"predicates","","",43,N],[3,"WhereBoundPredicate","","A type bound, eg `for<'c> Foo: Send+Clone+'c`",N,N],[12,"span","","",44,N],[12,"bound_generic_params","","Any generics from a `for` binding",44,N],[12,"bounded_ty","","The type being bounded",44,N],[12,"bounds","","Trait and lifetime bounds (`Clone+Send+'static`)",44,N],[3,"WhereRegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",N,N],[12,"span","","",45,N],[12,"lifetime","","",45,N],[12,"bounds","","",45,N],[3,"WhereEqPredicate","","An equality predicate (unsupported), e.g. `T=int`",N,N],[12,"id","","",46,N],[12,"span","","",46,N],[12,"lhs_ty","","",46,N],[12,"rhs_ty","","",46,N],[3,"Crate","","The top-level data structure that stores the entire contents of the crate currently being compiled.",N,N],[12,"module","","",47,N],[12,"attrs","","",47,N],[12,"span","","",47,N],[12,"exported_macros","","",47,N],[12,"items","","",47,N],[12,"trait_items","","",47,N],[12,"impl_items","","",47,N],[12,"bodies","","",47,N],[12,"trait_impls","","",47,N],[12,"trait_auto_impl","","",47,N],[12,"body_ids","","A list of the body ids written out in the order in which they appear in the crate. If you're going to process all the bodies in the crate, you should iterate over this list rather than the keys of bodies.",47,N],[3,"MacroDef","","A macro definition, in this crate or imported from another.",N,N],[12,"name","","",48,N],[12,"vis","","",48,N],[12,"attrs","","",48,N],[12,"id","","",48,N],[12,"span","","",48,N],[12,"body","","",48,N],[12,"legacy","","",48,N],[3,"Block","","",N,N],[12,"stmts","","Statements in a block",49,N],[12,"expr","","An expression at the end of the block without a semicolon, if any",49,N],[12,"id","","",49,N],[12,"hir_id","","",49,N],[12,"rules","","Distinguishes between `unsafe { ... }` and `{ ... }`",49,N],[12,"span","","",49,N],[12,"targeted_by_break","","If true, then there may exist `break 'a` values that aim to break out of this block early. Used by `'label: {}` blocks and by `catch` statements.",49,N],[12,"recovered","","If true, don't emit return value type errors as the parser had to recover from a parse error so this block will not have an appropriate type. A parse error will have been emitted so the compilation will never succeed if this is true.",49,N],[3,"Pat","","",N,N],[12,"id","","",50,N],[12,"hir_id","","",50,N],[12,"node","","",50,N],[12,"span","","",50,N],[3,"FieldPat","","A single field in a struct pattern",N,N],[12,"id","","",51,N],[12,"ident","","The identifier for the field",51,N],[12,"pat","","The pattern the field is destructured to",51,N],[12,"is_shorthand","","",51,N],[3,"Local","","Local represents a `let` statement, e.g., `let <pat>:<ty> = <expr>;`",N,N],[12,"pat","","",52,N],[12,"ty","","",52,N],[12,"init","","Initializer expression to set the value, if any",52,N],[12,"id","","",52,N],[12,"hir_id","","",52,N],[12,"span","","",52,N],[12,"attrs","","",52,N],[12,"source","","",52,N],[3,"Arm","","represents one arm of a 'match'",N,N],[12,"attrs","","",53,N],[12,"pats","","",53,N],[12,"guard","","",53,N],[12,"body","","",53,N],[3,"Field","","",N,N],[12,"id","","",54,N],[12,"ident","","",54,N],[12,"expr","","",54,N],[12,"span","","",54,N],[12,"is_shorthand","","",54,N],[3,"BodyId","","",N,N],[12,"node_id","","",55,N],[3,"Body","","The body of a function, closure, or constant value. In the case of a function, the body contains not only the function body itself (which is an expression), but also the argument patterns, since those are something that the caller doesn't really care about.",N,N],[12,"arguments","","",56,N],[12,"value","","",56,N],[12,"is_generator","","",56,N],[3,"AnonConst","","A constant (expression) that's not an item or associated item, but needs its own `DefId` for type-checking, const-eval, etc. These are usually found nested inside types (e.g. array lengths) or expressions (e.g. repeat counts), and also used to define explicit discriminant values for enum variants.",N,N],[12,"id","","",57,N],[12,"hir_id","","",57,N],[12,"body","","",57,N],[3,"Expr","","An expression",N,N],[12,"id","","",58,N],[12,"span","","",58,N],[12,"node","","",58,N],[12,"attrs","","",58,N],[12,"hir_id","","",58,N],[3,"Destination","","",N,N],[12,"label","","",59,N],[12,"target_id","","",59,N],[3,"MutTy","","",N,N],[12,"ty","","",60,N],[12,"mutbl","","",60,N],[3,"MethodSig","","Represents a method's signature in a trait declaration or implementation.",N,N],[12,"header","","",61,N],[12,"decl","","",61,N],[3,"TraitItemId","","",N,N],[12,"node_id","","",62,N],[3,"TraitItem","","Represents an item declaration within a trait declaration, possibly including a default implementation. A trait item is either required (meaning it doesn't have an implementation, just a signature) or provided (meaning it has a default implementation).",N,N],[12,"id","","",63,N],[12,"ident","","",63,N],[12,"hir_id","","",63,N],[12,"attrs","","",63,N],[12,"generics","","",63,N],[12,"node","","",63,N],[12,"span","","",63,N],[3,"ImplItemId","","",N,N],[12,"node_id","","",64,N],[3,"ImplItem","","Represents anything within an `impl` block",N,N],[12,"id","","",65,N],[12,"ident","","",65,N],[12,"hir_id","","",65,N],[12,"vis","","",65,N],[12,"defaultness","","",65,N],[12,"attrs","","",65,N],[12,"generics","","",65,N],[12,"node","","",65,N],[12,"span","","",65,N],[3,"TypeBinding","","",N,N],[12,"id","","",66,N],[12,"ident","","",66,N],[12,"ty","","",66,N],[12,"span","","",66,N],[3,"Ty","","",N,N],[12,"id","","",67,N],[12,"node","","",67,N],[12,"span","","",67,N],[12,"hir_id","","",67,N],[3,"BareFnTy","","",N,N],[12,"unsafety","","",68,N],[12,"abi","","",68,N],[12,"generic_params","","",68,N],[12,"decl","","",68,N],[12,"arg_names","","",68,N],[3,"ExistTy","","",N,N],[12,"generics","","",69,N],[12,"bounds","","",69,N],[12,"impl_trait_fn","","",69,N],[3,"InlineAsmOutput","","",N,N],[12,"constraint","","",70,N],[12,"is_rw","","",70,N],[12,"is_indirect","","",70,N],[3,"InlineAsm","","",N,N],[12,"asm","","",71,N],[12,"asm_str_style","","",71,N],[12,"outputs","","",71,N],[12,"inputs","","",71,N],[12,"clobbers","","",71,N],[12,"volatile","","",71,N],[12,"alignstack","","",71,N],[12,"dialect","","",71,N],[12,"ctxt","","",71,N],[3,"Arg","","represents an argument in a function header",N,N],[12,"pat","","",72,N],[12,"id","","",72,N],[12,"hir_id","","",72,N],[3,"FnDecl","","Represents the header (not the body) of a function declaration",N,N],[12,"inputs","","",73,N],[12,"output","","",73,N],[12,"variadic","","",73,N],[12,"has_implicit_self","","True if this function has an `self`, `&self` or `&mut self` receiver (but not a `self: Xxx` one).",73,N],[3,"Mod","","",N,N],[12,"inner","","A span from the first token past `{` to the last token until `}`. For `mod foo;`, the inner span ranges from the first token to the last token in the external file.",74,N],[12,"item_ids","","",74,N],[3,"ForeignMod","","",N,N],[12,"abi","","",75,N],[12,"items","","",75,N],[3,"GlobalAsm","","",N,N],[12,"asm","","",76,N],[12,"ctxt","","",76,N],[3,"EnumDef","","",N,N],[12,"variants","","",77,N],[3,"VariantKind","","",N,N],[12,"name","","",78,N],[12,"attrs","","",78,N],[12,"data","","",78,N],[12,"disr_expr","","Explicit discriminant, eg `Foo = 1`",78,N],[3,"TraitRef","","TraitRef's appear in impls.",N,N],[12,"path","","",79,N],[12,"ref_id","","",79,N],[12,"hir_ref_id","","",79,N],[3,"PolyTraitRef","","",N,N],[12,"bound_generic_params","","The `'a` in `<'a> Foo<&'a T>`",80,N],[12,"trait_ref","","The `Foo<&'a T>` in `<'a> Foo<&'a T>`",80,N],[12,"span","","",80,N],[3,"StructField","","",N,N],[12,"span","","",81,N],[12,"ident","","",81,N],[12,"vis","","",81,N],[12,"id","","",81,N],[12,"ty","","",81,N],[12,"attrs","","",81,N],[3,"ItemId","","",N,N],[12,"id","","",82,N],[3,"Item","","An item",N,N],[12,"name","","",83,N],[12,"id","","",83,N],[12,"hir_id","","",83,N],[12,"attrs","","",83,N],[12,"node","","",83,N],[12,"vis","","",83,N],[12,"span","","",83,N],[3,"FnHeader","","",N,N],[12,"unsafety","","",84,N],[12,"constness","","",84,N],[12,"asyncness","","",84,N],[12,"abi","","",84,N],[3,"TraitItemRef","","A reference from an trait to one of its associated items. This contains the item's id, naturally, but also the item's name and some other high-level details (like whether it is an associated type or method, and whether it is public). This allows other passes to find the impl they want without loading the id (which means fewer edges in the incremental compilation graph).",N,N],[12,"id","","",85,N],[12,"ident","","",85,N],[12,"kind","","",85,N],[12,"span","","",85,N],[12,"defaultness","","",85,N],[3,"ImplItemRef","","A reference from an impl to one of its associated items. This contains the item's id, naturally, but also the item's name and some other high-level details (like whether it is an associated type or method, and whether it is public). This allows other passes to find the impl they want without loading the id (which means fewer edges in the incremental compilation graph).",N,N],[12,"id","","",86,N],[12,"ident","","",86,N],[12,"kind","","",86,N],[12,"span","","",86,N],[12,"vis","","",86,N],[12,"defaultness","","",86,N],[3,"ForeignItem","","",N,N],[12,"name","","",87,N],[12,"attrs","","",87,N],[12,"node","","",87,N],[12,"id","","",87,N],[12,"span","","",87,N],[12,"vis","","",87,N],[3,"Freevar","","A free variable referred to in a function.",N,N],[12,"def","","The variable being accessed free.",88,N],[12,"span","","",88,N],[3,"TraitCandidate","","",N,N],[12,"def_id","","",89,N],[12,"import_id","","",89,N],[3,"CodegenFnAttrs","","",N,N],[12,"flags","","",90,N],[12,"inline","","Parsed representation of the `#[inline]` attribute",90,N],[12,"export_name","","The `#[export_name = \"...\"]` attribute, indicating a custom symbol a function should be exported under",90,N],[12,"link_name","","The `#[link_name = \"...\"]` attribute, indicating a custom symbol an imported function should be imported as. Note that `export_name` probably isn't set when this is set, this is for foreign items while `#[export_name]` is for Rust-defined functions.",90,N],[12,"target_features","","The `#[target_feature(enable = \"...\")]` attribute and the enabled features (only enabled features are supported right now).",90,N],[12,"linkage","","The `#[linkage = \"...\"]` attribute and the value we found.",90,N],[12,"link_section","","The `#[link_section = \"...\"]` attribute, or what executable section this should be placed in.",90,N],[3,"CodegenFnAttrFlags","","",N,N],[12,"bits","","",91,N],[4,"ParamName","","",N,N],[13,"Plain","","Some user-given name like `T` or `'x`.",92,N],[13,"Fresh","","Synthetic name generated when user elided a lifetime in an impl header, e.g. the lifetimes in cases like these:",92,N],[4,"LifetimeName","","",N,N],[13,"Param","","User-given names or fresh (synthetic) names.",93,N],[13,"Implicit","","User typed nothing. e.g. the lifetime in `&u32`.",93,N],[13,"Underscore","","User typed `'_`.",93,N],[13,"Static","","User wrote `'static`",93,N],[4,"GenericArg","","",N,N],[13,"Lifetime","","",94,N],[13,"Type","","",94,N],[4,"TraitBoundModifier","","A modifier on a bound, currently this is only used for `?Sized`, where the modifier is `Maybe`. Negative bounds should also be handled here.",N,N],[13,"None","","",95,N],[13,"Maybe","","",95,N],[4,"GenericBound","","The AST represents all type param bounds as types. typeck::collect::compute_bounds matches these against the \"special\" built-in traits (see middle::lang_items) and detects Copy, Send and Sync.",N,N],[13,"Trait","","",96,N],[13,"Outlives","","",96,N],[4,"GenericParamKind","","",N,N],[13,"Lifetime","","A lifetime definition, eg `'a: 'b + 'c + 'd`.",97,N],[12,"in_band","rustc::hir::GenericParamKind","",97,N],[13,"Type","rustc::hir","",97,N],[12,"default","rustc::hir::GenericParamKind","",97,N],[12,"synthetic","","",97,N],[4,"SyntheticTyParamKind","rustc::hir","Synthetic Type Parameters are converted to an other form during lowering, this allows to track the original form they had. Useful for error messages.",N,N],[13,"ImplTrait","","",98,N],[4,"WherePredicate","","A single predicate in a `where` clause",N,N],[13,"BoundPredicate","","A type binding, eg `for<'c> Foo: Send+Clone+'c`",99,N],[13,"RegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",99,N],[13,"EqPredicate","","An equality predicate (unsupported)",99,N],[4,"BindingAnnotation","","Explicit binding annotations given in the HIR for a binding. Note that this is not the final binding mode that we infer after type inference.",N,N],[13,"Unannotated","","No binding annotation given: this means that the final binding mode will depend on whether we have skipped through a `&` reference when matching. For example, the `x` in `Some(x)` will have binding mode `None`; if you do `let Some(x) = &Some(22)`, it will ultimately be inferred to be by-reference.",100,N],[13,"Mutable","","Annotated with `mut x` -- could be either ref or not, similar to `None`.",100,N],[13,"Ref","","Annotated as `ref`, like `ref x`",100,N],[13,"RefMut","","Annotated as `ref mut x`.",100,N],[4,"RangeEnd","","",N,N],[13,"Included","","",101,N],[13,"Excluded","","",101,N],[4,"PatKind","","",N,N],[13,"Wild","","Represents a wildcard pattern (`_`)",102,N],[13,"Binding","","A fresh binding `ref mut binding @ OPT_SUBPATTERN`. The `NodeId` is the canonical ID for the variable being bound, e.g. in `Ok(x) | Err(x)`, both `x` use the same canonical ID, which is the pattern ID of the first `x`.",102,N],[13,"Struct","","A struct or struct variant pattern, e.g. `Variant {x, y, ..}`. The `bool` is `true` in the presence of a `..`.",102,N],[13,"TupleStruct","","A tuple struct/variant pattern `Variant(x, y, .., z)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",102,N],[13,"Path","","A path pattern for an unit struct/variant or a (maybe-associated) constant.",102,N],[13,"Tuple","","A tuple pattern `(a, b)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",102,N],[13,"Box","","A `box` pattern",102,N],[13,"Ref","","A reference pattern, e.g. `&mut (a, b)`",102,N],[13,"Lit","","A literal",102,N],[13,"Range","","A range pattern, e.g. `1...2` or `1..2`",102,N],[13,"Slice","","`[a, b, ..i, y, z]` is represented as: `PatKind::Slice(box [a, b], Some(i), box [y, z])`",102,N],[4,"Mutability","","",N,N],[13,"MutMutable","","",103,N],[13,"MutImmutable","","",103,N],[4,"BinOpKind","","",N,N],[13,"Add","","The `+` operator (addition)",104,N],[13,"Sub","","The `-` operator (subtraction)",104,N],[13,"Mul","","The `*` operator (multiplication)",104,N],[13,"Div","","The `/` operator (division)",104,N],[13,"Rem","","The `%` operator (modulus)",104,N],[13,"And","","The `&&` operator (logical and)",104,N],[13,"Or","","The `||` operator (logical or)",104,N],[13,"BitXor","","The `^` operator (bitwise xor)",104,N],[13,"BitAnd","","The `&` operator (bitwise and)",104,N],[13,"BitOr","","The `|` operator (bitwise or)",104,N],[13,"Shl","","The `<<` operator (shift left)",104,N],[13,"Shr","","The `>>` operator (shift right)",104,N],[13,"Eq","","The `==` operator (equality)",104,N],[13,"Lt","","The `<` operator (less than)",104,N],[13,"Le","","The `<=` operator (less than or equal to)",104,N],[13,"Ne","","The `!=` operator (not equal to)",104,N],[13,"Ge","","The `>=` operator (greater than or equal to)",104,N],[13,"Gt","","The `>` operator (greater than)",104,N],[4,"UnOp","","",N,N],[13,"UnDeref","","The `*` operator for dereferencing",105,N],[13,"UnNot","","The `!` operator for logical inversion",105,N],[13,"UnNeg","","The `-` operator for negation",105,N],[4,"StmtKind","","",N,N],[13,"Decl","","Could be an item or a local (let) binding:",106,N],[13,"Expr","","Expr without trailing semi-colon (must have unit type):",106,N],[13,"Semi","","Expr with trailing semi-colon (may have any type):",106,N],[4,"DeclKind","","",N,N],[13,"Local","","A local (let) binding:",107,N],[13,"Item","","An item binding:",107,N],[4,"Guard","","",N,N],[13,"If","","",108,N],[4,"BlockCheckMode","","",N,N],[13,"DefaultBlock","","",109,N],[13,"UnsafeBlock","","",109,N],[13,"PushUnsafeBlock","","",109,N],[13,"PopUnsafeBlock","","",109,N],[4,"UnsafeSource","","",N,N],[13,"CompilerGenerated","","",110,N],[13,"UserProvided","","",110,N],[4,"BodyOwnerKind","","",N,N],[13,"Fn","","Functions and methods.",111,N],[13,"Const","","Constants and associated constants.",111,N],[13,"Static","","Initializer of a `static` item.",111,N],[4,"ExprKind","","",N,N],[13,"Box","","A `box x` expression.",112,N],[13,"Array","","An array (`[a, b, c, d]`)",112,N],[13,"Call","","A function call",112,N],[13,"MethodCall","","A method call (`x.foo::<'static, Bar, Baz>(a, b, c, d)`)",112,N],[13,"Tup","","A tuple (`(a, b, c ,d)`)",112,N],[13,"Binary","","A binary operation (For example: `a + b`, `a * b`)",112,N],[13,"Unary","","A unary operation (For example: `!x`, `*x`)",112,N],[13,"Lit","","A literal (For example: `1`, `\"foo\"`)",112,N],[13,"Cast","","A cast (`foo as f64`)",112,N],[13,"Type","","",112,N],[13,"If","","An `if` block, with an optional else block",112,N],[13,"While","","A while loop, with an optional label",112,N],[13,"Loop","","Conditionless loop (can be exited with break, continue, or return)",112,N],[13,"Match","","A `match` block, with a source that indicates whether or not it is the result of a desugaring, and if so, which kind.",112,N],[13,"Closure","","A closure (for example, `move |a, b, c| {a + b + c}`).",112,N],[13,"Block","","A block (`'label: { ... }`)",112,N],[13,"Assign","","An assignment (`a = foo()`)",112,N],[13,"AssignOp","","An assignment with an operator",112,N],[13,"Field","","Access of a named (`obj.foo`) or unnamed (`obj.0`) struct or tuple field",112,N],[13,"Index","","An indexing operation (`foo[2]`)",112,N],[13,"Path","","Path to a definition, possibly containing lifetime or type parameters.",112,N],[13,"AddrOf","","A referencing operation (`&a` or `&mut a`)",112,N],[13,"Break","","A `break`, with an optional label to break",112,N],[13,"Continue","","A `continue`, with an optional label",112,N],[13,"Ret","","A `return`, with an optional value to be returned",112,N],[13,"InlineAsm","","Inline assembly (from `asm!`), with its outputs and inputs.",112,N],[13,"Struct","","A struct or struct-like variant literal expression.",112,N],[13,"Repeat","","An array literal constructed from one repeated element.",112,N],[13,"Yield","","A suspension point for generators. This is `yield <expr>` in Rust.",112,N],[4,"QPath","","Optionally `Self`-qualified value/type path or associated extension.",N,N],[13,"Resolved","","Path to a definition, optionally \"fully-qualified\" with a `Self` type, if the path points to an associated item in a trait.",113,N],[13,"TypeRelative","","Type-related paths, e.g. `<T>::default` or `<T>::Output`. Will be resolved by type-checking to an associated item.",113,N],[4,"LocalSource","","Hints at the original code for a let statement",N,N],[13,"Normal","","A `match _ { .. }`",114,N],[13,"ForLoopDesugar","","A desugared `for _ in _ { .. }` loop",114,N],[4,"MatchSource","","Hints at the original code for a `match _ { .. }`",N,N],[13,"Normal","","A `match _ { .. }`",115,N],[13,"IfLetDesugar","","An `if let _ = _ { .. }` (optionally with `else { .. }`)",115,N],[12,"contains_else_clause","rustc::hir::MatchSource","",115,N],[13,"WhileLetDesugar","rustc::hir","A `while let _ = _ { .. }` (which was desugared to a `loop { match _ { .. } }`)",115,N],[13,"ForLoopDesugar","","A desugared `for _ in _ { .. }` loop",115,N],[13,"TryDesugar","","A desugared `?` operator",115,N],[4,"LoopSource","","The loop type that yielded an ExprKind::Loop",N,N],[13,"Loop","","A `loop { .. }` loop",116,N],[13,"WhileLet","","A `while let _ = _ { .. }` loop",116,N],[13,"ForLoop","","A `for _ in _ { .. }` loop",116,N],[4,"LoopIdError","","",N,N],[13,"OutsideLoopScope","","",117,N],[13,"UnlabeledCfInWhileCondition","","",117,N],[13,"UnresolvedLabel","","",117,N],[4,"GeneratorMovability","","",N,N],[13,"Static","","",118,N],[13,"Movable","","",118,N],[4,"CaptureClause","","",N,N],[13,"CaptureByValue","","",119,N],[13,"CaptureByRef","","",119,N],[4,"TraitMethod","","A trait method's body (or just argument names).",N,N],[13,"Required","","No default body in the trait, just a signature.",120,N],[13,"Provided","","Both signature and body are provided in the trait.",120,N],[4,"TraitItemKind","","Represents a trait method or associated constant or type",N,N],[13,"Const","","An associated constant with an optional value (otherwise `impl`s must contain a value)",121,N],[13,"Method","","A method with an optional body",121,N],[13,"Type","","An associated type with (possibly empty) bounds and optional concrete type",121,N],[4,"ImplItemKind","","Represents different contents within `impl`s",N,N],[13,"Const","","An associated constant of the given type, set to the constant result of the expression",122,N],[13,"Method","","A method implementation with the given signature and body",122,N],[13,"Type","","An associated type",122,N],[13,"Existential","","An associated existential type",122,N],[4,"PrimTy","","Not represented directly in the AST, referred to by name through a ty_path.",N,N],[13,"Int","","",123,N],[13,"Uint","","",123,N],[13,"Float","","",123,N],[13,"Str","","",123,N],[13,"Bool","","",123,N],[13,"Char","","",123,N],[4,"TyKind","","The different kinds of types recognized by the compiler",N,N],[13,"Slice","","A variable length slice (`[T]`)",124,N],[13,"Array","","A fixed length array (`[T; n]`)",124,N],[13,"Ptr","","A raw pointer (`*const T` or `*mut T`)",124,N],[13,"Rptr","","A reference (`&'a T` or `&'a mut T`)",124,N],[13,"BareFn","","A bare function (e.g. `fn(usize) -> bool`)",124,N],[13,"Never","","The never type (`!`)",124,N],[13,"Tup","","A tuple (`(A, B, C, D,...)`)",124,N],[13,"Path","","A path to a type definition (`module::module::...::Type`), or an associated type, e.g. `<Vec<T> as Trait>::Type` or `<T>::Target`.",124,N],[13,"TraitObject","","A trait object type `Bound1 + Bound2 + Bound3` where `Bound` is a trait or a lifetime.",124,N],[13,"Typeof","","Unused for now",124,N],[13,"Infer","","TyKind::Infer means the type should be inferred instead of it having been specified. This can appear anywhere in a type.",124,N],[13,"Err","","Placeholder for a type that has failed to be defined.",124,N],[4,"IsAuto","","Is the trait definition an auto trait?",N,N],[13,"Yes","","",125,N],[13,"No","","",125,N],[4,"IsAsync","","",N,N],[13,"Async","","",126,N],[13,"NotAsync","","",126,N],[4,"Unsafety","","",N,N],[13,"Unsafe","","",127,N],[13,"Normal","","",127,N],[4,"Constness","","",N,N],[13,"Const","","",128,N],[13,"NotConst","","",128,N],[4,"Defaultness","","",N,N],[13,"Default","","",129,N],[12,"has_value","rustc::hir::Defaultness","",129,N],[13,"Final","rustc::hir","",129,N],[4,"ImplPolarity","","",N,N],[13,"Positive","","`impl Trait for Type`",130,N],[13,"Negative","","`impl !Trait for Type`",130,N],[4,"FunctionRetTy","","",N,N],[13,"DefaultReturn","","Return type is not specified.",131,N],[13,"Return","","Everything else",131,N],[4,"UseKind","","",N,N],[13,"Single","","One import, e.g. `use foo::bar` or `use foo::bar as baz`. Also produced for each element of a list `use`, e.g.",132,N],[13,"Glob","","Glob import, e.g. `use foo::*`.",132,N],[13,"ListStem","","Degenerate list import, e.g. `use foo::{a, b}` produces an additional `use foo::{}` for performing checks such as unstable feature gating. May be removed in the future.",132,N],[4,"VisibilityKind","","",N,N],[13,"Public","","",133,N],[13,"Crate","","",133,N],[13,"Restricted","","",133,N],[12,"path","rustc::hir::VisibilityKind","",133,N],[12,"id","","",133,N],[12,"hir_id","","",133,N],[13,"Inherited","rustc::hir","",133,N],[4,"VariantData","","Fields and Ids of enum variants and structs",N,N],[13,"Struct","","",134,N],[13,"Tuple","","",134,N],[13,"Unit","","",134,N],[4,"ItemKind","","",N,N],[13,"ExternCrate","","An `extern crate` item, with optional original crate name if the crate was renamed.",135,N],[13,"Use","","`use foo::bar::*;` or `use foo::bar::baz as quux;`",135,N],[13,"Static","","A `static` item",135,N],[13,"Const","","A `const` item",135,N],[13,"Fn","","A function declaration",135,N],[13,"Mod","","A module",135,N],[13,"ForeignMod","","An external module",135,N],[13,"GlobalAsm","","Module-level inline assembly (from global_asm!)",135,N],[13,"Ty","","A type alias, e.g. `type Foo = Bar<u8>`",135,N],[13,"Existential","","An existential type definition, e.g. `existential type Foo: Bar;`",135,N],[13,"Enum","","An enum definition, e.g. `enum Foo<A, B> {C<A>, D<B>}`",135,N],[13,"Struct","","A struct definition, e.g. `struct Foo<A> {x: A}`",135,N],[13,"Union","","A union definition, e.g. `union Foo<A, B> {x: A, y: B}`",135,N],[13,"Trait","","Represents a Trait Declaration",135,N],[13,"TraitAlias","","Represents a Trait Alias Declaration",135,N],[13,"Impl","","An implementation, eg `impl<A> Trait for Foo { .. }`",135,N],[4,"AssociatedItemKind","","",N,N],[13,"Const","","",136,N],[13,"Method","","",136,N],[12,"has_self","rustc::hir::AssociatedItemKind","",136,N],[13,"Type","rustc::hir","",136,N],[13,"Existential","","",136,N],[4,"ForeignItemKind","","An item within an `extern` block",N,N],[13,"Fn","","A foreign function",137,N],[13,"Static","","A foreign static item (`static ext: u8`), with optional mutability (the boolean is true when mutable)",137,N],[13,"Type","","A foreign type",137,N],[4,"Node","","",N,N],[13,"Item","","",138,N],[13,"ForeignItem","","",138,N],[13,"TraitItem","","",138,N],[13,"ImplItem","","",138,N],[13,"Variant","","",138,N],[13,"Field","","",138,N],[13,"AnonConst","","",138,N],[13,"Expr","","",138,N],[13,"Stmt","","",138,N],[13,"Ty","","",138,N],[13,"TraitRef","","",138,N],[13,"Binding","","",138,N],[13,"Pat","","",138,N],[13,"Block","","",138,N],[13,"Local","","",138,N],[13,"MacroDef","","",138,N],[13,"StructCtor","","StructCtor represents a tuple struct.",138,N],[13,"Lifetime","","",138,N],[13,"GenericParam","","",138,N],[13,"Visibility","","",138,N],[13,"Crate","","",138,N],[5,"provide","","",N,[[["providers"]]]],[0,"check_attr","","This module implements some validity checks for attributes. In particular it verifies that `#[inline]` and `#[repr]` attributes are attached to items that actually support them and if there are conflicts between multiple such attributes attached to the same item.",N,N],[3,"CheckAttrVisitor","rustc::hir::check_attr","",N,N],[12,"tcx","","",139,N],[4,"Target","","",N,N],[13,"Fn","","",140,N],[13,"Struct","","",140,N],[13,"Union","","",140,N],[13,"Enum","","",140,N],[13,"Const","","",140,N],[13,"ForeignMod","","",140,N],[13,"Expression","","",140,N],[13,"Statement","","",140,N],[13,"Closure","","",140,N],[13,"Static","","",140,N],[13,"Other","","",140,N],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"is_c_like_enum","","",N,[[["item"]],["bool"]]],[11,"clone","","",140,[[["self"]],["target"]]],[11,"eq","","",140,[[["self"],["target"]],["bool"]]],[11,"from_item","","",140,[[["item"]],["target"]]],[11,"check_attributes","","Check any attribute.",139,[[["self"],["item"],["target"]]]],[11,"check_inline","","Check if an `#[inline]` is applied to a function or a closure.",139,[[["self"],["attribute"],["span"],["target"]]]],[11,"check_non_exhaustive","","Check if the `#[non_exhaustive]` attribute on an `item` is valid.",139,[[["self"],["attribute"],["item"],["target"]]]],[11,"check_repr","","Check if the `#[repr]` attributes on `item` are valid.",139,[[["self"],["item"],["target"]]]],[11,"emit_repr_error","","",139,[[["self"],["span"],["span"],["str"],["str"]]]],[11,"check_stmt_attributes","","",139,[[["self"],["stmt"]]]],[11,"check_expr_attributes","","",139,[[["self"],["expr"]]]],[11,"check_used","","",139,[[["self"],["item"],["target"]]]],[11,"nested_visit_map","","",139,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",139,[[["self"],["item"]]]],[11,"visit_stmt","","",139,[[["self"],["stmt"]]]],[11,"visit_expr","","",139,[[["self"],["expr"]]]],[0,"def","rustc::hir","",N,N],[3,"PathResolution","rustc::hir::def","The result of resolving a path before lowering to HIR. `base_def` is definition of resolved part of the path, `unresolved_segments` is the number of unresolved segments.",N,N],[12,"base_def","","",141,N],[12,"unresolved_segments","","",141,N],[3,"PerNS","","Just a helper ‒ separate structure for each namespace.",N,N],[12,"value_ns","","",142,N],[12,"type_ns","","",142,N],[12,"macro_ns","","",142,N],[3,"Export","","",N,N],[12,"ident","","The name of the target.",143,N],[12,"def","","The definition of the target.",143,N],[12,"span","","The span of the target definition.",143,N],[12,"vis","","The visibility of the export. We include non-`pub` exports for hygienic macros that get used from extern crates.",143,N],[4,"CtorKind","","",N,N],[13,"Fn","","Constructor function automatically created by a tuple struct/variant.",144,N],[13,"Const","","Constructor constant automatically created by a unit struct/variant.",144,N],[13,"Fictive","","Unusable name in value namespace created by a struct variant.",144,N],[4,"NonMacroAttrKind","","",N,N],[13,"Builtin","","Single-segment attribute defined by the language (`#[inline]`)",145,N],[13,"Tool","","Multi-segment custom attribute living in a \"tool module\" (`#[rustfmt::skip]`).",145,N],[13,"DeriveHelper","","Single-segment custom attribute registered by a derive macro (`#[serde(default)]`).",145,N],[13,"Custom","","Single-segment custom attribute not registered in any way (`#[my_attr]`).",145,N],[4,"Def","","",N,N],[13,"Mod","","",146,N],[13,"Struct","","",146,N],[13,"Union","","",146,N],[13,"Enum","","",146,N],[13,"Variant","","",146,N],[13,"Trait","","",146,N],[13,"Existential","","`existential type Foo: Bar;`",146,N],[13,"TyAlias","","`type Foo = Bar;`",146,N],[13,"ForeignTy","","",146,N],[13,"TraitAlias","","",146,N],[13,"AssociatedTy","","",146,N],[13,"AssociatedExistential","","`existential type Foo: Bar;`",146,N],[13,"PrimTy","","",146,N],[13,"TyParam","","",146,N],[13,"SelfTy","","",146,N],[13,"ToolMod","","",146,N],[13,"Fn","","",146,N],[13,"Const","","",146,N],[13,"Static","","",146,N],[13,"StructCtor","","",146,N],[13,"VariantCtor","","",146,N],[13,"SelfCtor","","",146,N],[13,"Method","","",146,N],[13,"AssociatedConst","","",146,N],[13,"Local","","",146,N],[13,"Upvar","","",146,N],[13,"Label","","",146,N],[13,"Macro","","",146,N],[13,"NonMacroAttr","","",146,N],[13,"Err","","",146,N],[4,"Namespace","","Different kinds of symbols don't influence each other.",N,N],[13,"TypeNS","","",147,N],[13,"ValueNS","","",147,N],[13,"MacroNS","","",147,N],[6,"DefMap","","Definition mapping",N,N],[6,"ExportMap","","This is the replacement export map. It maps a module to all of the exports within.",N,N],[6,"ImportMap","","Map used to track the `use` statements within a scope, matching it with all the items in every namespace.",N,N],[22,"","","",N,N],[11,"clone","","",144,[[["self"]],["ctorkind"]]],[11,"eq","","",144,[[["self"],["ctorkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",144,N],[11,"encode","","",144,[[["self"],["__s"]],["result"]]],[11,"decode","","",144,[[["__d"]],["result",["ctorkind"]]]],[11,"hash","","",144,N],[11,"fmt","","",144,[[["self"],["formatter"]],["result"]]],[11,"clone","","",145,[[["self"]],["nonmacroattrkind"]]],[11,"eq","","",145,[[["self"],["nonmacroattrkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",145,N],[11,"encode","","",145,[[["self"],["__s"]],["result"]]],[11,"decode","","",145,[[["__d"]],["result",["nonmacroattrkind"]]]],[11,"hash","","",145,N],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[11,"clone","","",146,[[["self"]],["def"]]],[11,"eq","","",146,[[["self"],["def"]],["bool"]]],[11,"ne","","",146,[[["self"],["def"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",146,N],[11,"encode","","",146,[[["self"],["__s"]],["result"]]],[11,"decode","","",146,[[["__d"]],["result",["def"]]]],[11,"hash","","",146,N],[11,"fmt","","",146,[[["self"],["formatter"]],["result"]]],[11,"clone","","",141,[[["self"]],["pathresolution"]]],[11,"fmt","","",141,[[["self"],["formatter"]],["result"]]],[11,"new","","",141,[[["def"]],["self"]]],[11,"with_unresolved_segments","","",141,[[["def"],["usize"]],["self"]]],[11,"base_def","","",141,[[["self"]],["def"]]],[11,"unresolved_segments","","",141,[[["self"]],["usize"]]],[11,"kind_name","","",141,[[["self"]],["str"]]],[11,"clone","","",147,[[["self"]],["namespace"]]],[11,"eq","","",147,[[["self"],["namespace"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",147,N],[11,"partial_cmp","","",147,[[["self"],["namespace"]],["option",["ordering"]]]],[11,"cmp","","",147,[[["self"],["namespace"]],["ordering"]]],[11,"hash","","",147,N],[11,"fmt","","",147,[[["self"],["formatter"]],["result"]]],[11,"descr","","",147,[[["self"]],["str"]]],[11,"clone","","",142,[[["self"]],["perns"]]],[11,"default","","",142,[[],["perns"]]],[11,"fmt","","",142,[[["self"],["formatter"]],["result"]]],[11,"map","","",142,[[["self"],["f"]],["perns"]]],[11,"index","","",142,[[["self"],["namespace"]],["t"]]],[11,"index_mut","","",142,[[["self"],["namespace"]],["t"]]],[11,"is_empty","","Returns whether all the items in this collection are `None`.",142,[[["self"]],["bool"]]],[11,"present_items","","Returns an iterator over the items which are `Some`.",142,N],[11,"clone","","",143,[[["self"]],["export"]]],[11,"fmt","","",143,[[["self"],["formatter"]],["result"]]],[11,"encode","","",143,[[["self"],["__s"]],["result"]]],[11,"decode","","",143,[[["__d"]],["result",["export"]]]],[11,"from_ast","","",144,[[["variantdata"]],["ctorkind"]]],[11,"from_hir","","",144,[[["variantdata"]],["ctorkind"]]],[11,"descr","","",145,[[["self"]],["str"]]],[11,"def_id","","",146,[[["self"]],["defid"]]],[11,"kind_name","","A human readable kind name",146,[[["self"]],["str"]]],[0,"def_id","rustc::hir","",N,N],[3,"CrateId","rustc::hir::def_id","",N,N],[12,"private","","",148,N],[3,"DefIndex","","A DefIndex is an index into the hir-map for a crate, identifying a particular definition. It should really be considered an interned shorthand for a particular DefPath.",N,N],[12,"0","","",149,N],[3,"DefId","","A DefId identifies a particular definition, by combining a crate index and a def index.",N,N],[12,"krate","","",150,N],[12,"index","","",150,N],[3,"LocalDefId","","A LocalDefId is equivalent to a DefId with `krate == LOCAL_CRATE`. Since we encode this information in the type, we can ensure at compile time that no DefIds from upstream crates get thrown into the mix. There are quite a few cases where we know that only DefIds from the local crate are expected and a DefId from a different crate would signify a bug somewhere. This is when LocalDefId comes in handy.",N,N],[12,"0","","",151,N],[4,"CrateNum","","",N,N],[13,"BuiltinMacros","","Virtual crate for builtin macros",152,N],[13,"Invalid","","A CrateNum value that indicates that something is wrong.",152,N],[13,"ReservedForIncrCompCache","","A special CrateNum that we use for the tcx.rcache when decoding from the incr. comp. cache.",152,N],[13,"Index","","",152,N],[4,"DefIndexAddressSpace","","",N,N],[13,"Low","","",153,N],[13,"High","","",153,N],[17,"LOCAL_CRATE","","Item definitions in the currently-compiled crate would have the CrateNum LOCAL_CRATE in their DefId.",N,N],[17,"CRATE_DEF_INDEX","","The crate root is always assigned index 0 by the AST Map code, thanks to `NodeCollector::new`.",N,N],[11,"clone","","",148,[[["self"]],["crateid"]]],[11,"eq","","",148,[[["self"],["crateid"]],["bool"]]],[11,"ne","","",148,[[["self"],["crateid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",148,N],[11,"hash","","",148,N],[11,"partial_cmp","","",148,[[["self"],["crateid"]],["option",["ordering"]]]],[11,"lt","","",148,[[["self"],["crateid"]],["bool"]]],[11,"le","","",148,[[["self"],["crateid"]],["bool"]]],[11,"gt","","",148,[[["self"],["crateid"]],["bool"]]],[11,"ge","","",148,[[["self"],["crateid"]],["bool"]]],[11,"cmp","","",148,[[["self"],["crateid"]],["ordering"]]],[18,"MAX_AS_U32","","",148,N],[18,"MAX","","",148,N],[11,"from_usize","","",148,[[["usize"]],["self"]]],[11,"from_u32","","",148,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",148,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",148,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",148,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",148,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",148,[[["self"]],["usize"]]],[11,"new","","",148,[[["usize"]],["self"]]],[11,"index","","",148,[[["self"]],["usize"]]],[11,"steps_between","","",148,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",148,[[["self"]],["self"]]],[11,"replace_zero","","",148,[[["self"]],["self"]]],[11,"add_one","","",148,[[["self"]],["self"]]],[11,"sub_one","","",148,[[["self"]],["self"]]],[11,"add_usize","","",148,[[["self"],["usize"]],["option"]]],[11,"from","","",148,[[["usize"]],["self"]]],[11,"from","","",148,[[["u32"]],["self"]]],[11,"fmt","","",148,[[["self"],["formatter"]],["result"]]],[11,"clone","","",152,[[["self"]],["cratenum"]]],[11,"eq","","",152,[[["self"],["cratenum"]],["bool"]]],[11,"ne","","",152,[[["self"],["cratenum"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",152,N],[11,"partial_cmp","","",152,[[["self"],["cratenum"]],["option",["ordering"]]]],[11,"lt","","",152,[[["self"],["cratenum"]],["bool"]]],[11,"le","","",152,[[["self"],["cratenum"]],["bool"]]],[11,"gt","","",152,[[["self"],["cratenum"]],["bool"]]],[11,"ge","","",152,[[["self"],["cratenum"]],["bool"]]],[11,"cmp","","",152,[[["self"],["cratenum"]],["ordering"]]],[11,"hash","","",152,N],[11,"fmt","","",152,[[["self"],["formatter"]],["result"]]],[11,"new","","",152,[[["usize"]],["self"]]],[11,"index","","",152,[[["self"]],["usize"]]],[11,"new","","",152,[[["usize"]],["cratenum"]]],[11,"from_usize","","",152,[[["usize"]],["cratenum"]]],[11,"from_u32","","",152,[[["u32"]],["cratenum"]]],[11,"as_usize","","",152,[[["self"]],["usize"]]],[11,"as_u32","","",152,[[["self"]],["u32"]]],[11,"as_def_id","","",152,[[["self"]],["defid"]]],[11,"fmt","","",152,[[["self"],["formatter"]],["result"]]],[11,"clone","","",149,[[["self"]],["defindex"]]],[11,"eq","","",149,[[["self"],["defindex"]],["bool"]]],[11,"ne","","",149,[[["self"],["defindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",149,N],[11,"partial_cmp","","",149,[[["self"],["defindex"]],["option",["ordering"]]]],[11,"lt","","",149,[[["self"],["defindex"]],["bool"]]],[11,"le","","",149,[[["self"],["defindex"]],["bool"]]],[11,"gt","","",149,[[["self"],["defindex"]],["bool"]]],[11,"ge","","",149,[[["self"],["defindex"]],["bool"]]],[11,"cmp","","",149,[[["self"],["defindex"]],["ordering"]]],[11,"hash","","",149,N],[11,"fmt","","",149,[[["self"],["formatter"]],["result"]]],[11,"address_space","","",149,[[["self"]],["defindexaddressspace"]]],[11,"as_array_index","","Converts this DefIndex into a zero-based array index. This index is the offset within the given DefIndexAddressSpace.",149,[[["self"]],["usize"]]],[11,"from_array_index","","",149,[[["usize"],["defindexaddressspace"]],["defindex"]]],[11,"from_proc_macro_index","","",149,[[["usize"]],["defindex"]]],[11,"to_proc_macro_index","","",149,[[["defindex"]],["usize"]]],[11,"from_raw_u32","","",149,[[["u32"]],["defindex"]]],[11,"as_raw_u32","","",149,[[["self"]],["u32"]]],[11,"clone","","",153,[[["self"]],["defindexaddressspace"]]],[11,"fmt","","",153,[[["self"],["formatter"]],["result"]]],[11,"eq","","",153,[[["self"],["defindexaddressspace"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",153,N],[11,"hash","","",153,N],[11,"index","","",153,[[["self"]],["usize"]]],[11,"clone","","",150,[[["self"]],["defid"]]],[11,"eq","","",150,[[["self"],["defid"]],["bool"]]],[11,"ne","","",150,[[["self"],["defid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",150,N],[11,"partial_cmp","","",150,[[["self"],["defid"]],["option",["ordering"]]]],[11,"lt","","",150,[[["self"],["defid"]],["bool"]]],[11,"le","","",150,[[["self"],["defid"]],["bool"]]],[11,"gt","","",150,[[["self"],["defid"]],["bool"]]],[11,"ge","","",150,[[["self"],["defid"]],["bool"]]],[11,"cmp","","",150,[[["self"],["defid"]],["ordering"]]],[11,"hash","","",150,N],[11,"fmt","","",150,[[["self"],["formatter"]],["result"]]],[11,"local","","Make a local `DefId` with the given index.",150,[[["defindex"]],["defid"]]],[11,"is_local","","",150,[[["self"]],["bool"]]],[11,"to_local","","",150,[[["self"]],["localdefid"]]],[11,"clone","","",151,[[["self"]],["localdefid"]]],[11,"eq","","",151,[[["self"],["localdefid"]],["bool"]]],[11,"ne","","",151,[[["self"],["localdefid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",151,N],[11,"hash","","",151,N],[11,"from_def_id","","",151,[[["defid"]],["localdefid"]]],[11,"to_def_id","","",151,[[["self"]],["defid"]]],[11,"fmt","","",151,[[["self"],["formatter"]],["result"]]],[0,"intravisit","rustc::hir","HIR walker for walking the contents of nodes.",N,N],[3,"IdRange","rustc::hir::intravisit","",N,N],[12,"min","","",154,N],[12,"max","","",154,N],[3,"IdRangeComputingVisitor","","",N,N],[12,"result","","",155,N],[12,"map","","",155,N],[4,"FnKind","","",N,N],[13,"ItemFn","","#[xxx] pub async/const/extern \"Abi\" fn foo()",156,N],[13,"Method","","fn foo(&self)",156,N],[13,"Closure","","|x, y| {}",156,N],[4,"NestedVisitorMap","","Specifies what nested things a visitor wants to visit. The most common choice is `OnlyBodies`, which will cause the visitor to visit fn bodies for fns that it encounters, but skip over nested item-like things.",N,N],[13,"None","","Do not visit any nested things. When you add a new \"non-nested\" thing, you will want to audit such uses to see if they remain valid.",157,N],[13,"OnlyBodies","","Do not visit nested item-like things, but visit nested things that are inside of an item-like.",157,N],[13,"All","","Visit all nested things, including item-likes.",157,N],[5,"walk_crate","","Walks the contents of a crate. See also `Crate::visit_all_items`.",N,[[["v"],["crate"]]]],[5,"walk_macro_def","","",N,[[["v"],["macrodef"]]]],[5,"walk_mod","","",N,[[["v"],["mod"],["nodeid"]]]],[5,"walk_body","","",N,[[["v"],["body"]]]],[5,"walk_local","","",N,[[["v"],["local"]]]],[5,"walk_ident","","",N,[[["v"],["ident"]]]],[5,"walk_label","","",N,[[["v"],["label"]]]],[5,"walk_lifetime","","",N,[[["v"],["lifetime"]]]],[5,"walk_poly_trait_ref","","",N,[[["v"],["polytraitref"],["traitboundmodifier"]]]],[5,"walk_trait_ref","","",N,[[["v"],["traitref"]]]],[5,"walk_item","","",N,[[["v"],["item"]]]],[5,"walk_enum_def","","",N,[[["v"],["enumdef"],["generics"],["nodeid"]]]],[5,"walk_variant","","",N,[[["v"],["variant"],["generics"],["nodeid"]]]],[5,"walk_ty","","",N,[[["v"],["ty"]]]],[5,"walk_qpath","","",N,[[["v"],["qpath"],["hirid"],["span"]]]],[5,"walk_path","","",N,[[["v"],["path"]]]],[5,"walk_path_segment","","",N,[[["v"],["span"],["pathsegment"]]]],[5,"walk_generic_args","","",N,[[["v"],["span"],["genericargs"]]]],[5,"walk_assoc_type_binding","","",N,[[["v"],["typebinding"]]]],[5,"walk_pat","","",N,[[["v"],["pat"]]]],[5,"walk_foreign_item","","",N,[[["v"],["foreignitem"]]]],[5,"walk_param_bound","","",N,[[["v"],["genericbound"]]]],[5,"walk_generic_param","","",N,[[["v"],["genericparam"]]]],[5,"walk_generics","","",N,[[["v"],["generics"]]]],[5,"walk_where_predicate","","",N,[[["v"],["wherepredicate"]]]],[5,"walk_fn_ret_ty","","",N,[[["v"],["functionretty"]]]],[5,"walk_fn_decl","","",N,[[["v"],["fndecl"]]]],[5,"walk_fn_kind","","",N,[[["v"],["fnkind"]]]],[5,"walk_fn","","",N,[[["v"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[5,"walk_trait_item","","",N,[[["v"],["traititem"]]]],[5,"walk_trait_item_ref","","",N,[[["v"],["traititemref"]]]],[5,"walk_impl_item","","",N,[[["v"],["implitem"]]]],[5,"walk_impl_item_ref","","",N,[[["v"],["implitemref"]]]],[5,"walk_struct_def","","",N,[[["v"],["variantdata"]]]],[5,"walk_struct_field","","",N,[[["v"],["structfield"]]]],[5,"walk_block","","",N,[[["v"],["block"]]]],[5,"walk_stmt","","",N,[[["v"],["stmt"]]]],[5,"walk_decl","","",N,[[["v"],["decl"]]]],[5,"walk_anon_const","","",N,[[["v"],["anonconst"]]]],[5,"walk_expr","","",N,[[["v"],["expr"]]]],[5,"walk_arm","","",N,[[["v"],["arm"]]]],[5,"walk_vis","","",N,[[["v"],["visibility"]]]],[5,"walk_associated_item_kind","","",N,[[["v"],["associateditemkind"]]]],[5,"walk_defaultness","","",N,[[["v"],["defaultness"]]]],[8,"Visitor","","Each method of the Visitor trait is a hook to be potentially overridden.  Each method's default implementation recursively visits the substructure of the input via the corresponding `walk` method; e.g. the `visit_mod` method by default calls `intravisit::walk_mod`.",N,N],[10,"nested_visit_map","","The default versions of the `visit_nested_XXX` routines invoke this method to get a map to use. By selecting an enum variant, you control which kinds of nested HIR are visited; see `NestedVisitorMap` for details. By \"nested HIR\", we are referring to bits of HIR that are not directly embedded within one another but rather indirectly, through a table in the crate. This is done to control dependencies during incremental compilation: the non-inline bits of HIR can be tracked and hashed separately.",158,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_item","","Invoked when a nested item is encountered. By default does nothing unless you override `nested_visit_map` to return `Some(_)`, in which case it will walk the item. You probably don't want to override this method -- instead, override `nested_visit_map` or use the \"shallow\" or \"deep\" visit patterns described on `itemlikevisit::ItemLikeVisitor`. The only reason to override this method is if you want a nested pattern but cannot supply a `Map`; see `nested_visit_map` for advice.",158,[[["self"],["itemid"]]]],[11,"visit_nested_trait_item","","Like `visit_nested_item()`, but for trait items. See `visit_nested_item()` for advice on when to override this method.",158,[[["self"],["traititemid"]]]],[11,"visit_nested_impl_item","","Like `visit_nested_item()`, but for impl items. See `visit_nested_item()` for advice on when to override this method.",158,[[["self"],["implitemid"]]]],[11,"visit_nested_body","","Invoked to visit the body of a function, method or closure. Like visit_nested_item, does nothing by default unless you override `nested_visit_map` to return `Some(_)`, in which case it will walk the body.",158,[[["self"],["bodyid"]]]],[11,"visit_item","","Visit the top-level item and (optionally) nested items / impl items. See `visit_nested_item` for details.",158,[[["self"],["item"]]]],[11,"visit_body","","",158,[[["self"],["body"]]]],[11,"as_deep_visitor","","When invoking `visit_all_item_likes()`, you need to supply an item-like visitor.  This method converts a \"intra-visit\" visitor into an item-like visitor that walks the entire tree. If you use this, you probably don't want to process the contents of nested item-like things, since the outer loop will visit them as well.",158,[[["self"]],["deepvisitor"]]],[11,"visit_id","","",158,[[["self"],["nodeid"]]]],[11,"visit_def_mention","","",158,[[["self"],["def"]]]],[11,"visit_name","","",158,[[["self"],["span"],["name"]]]],[11,"visit_ident","","",158,[[["self"],["ident"]]]],[11,"visit_mod","","",158,[[["self"],["mod"],["span"],["nodeid"]]]],[11,"visit_foreign_item","","",158,[[["self"],["foreignitem"]]]],[11,"visit_local","","",158,[[["self"],["local"]]]],[11,"visit_block","","",158,[[["self"],["block"]]]],[11,"visit_stmt","","",158,[[["self"],["stmt"]]]],[11,"visit_arm","","",158,[[["self"],["arm"]]]],[11,"visit_pat","","",158,[[["self"],["pat"]]]],[11,"visit_decl","","",158,[[["self"],["decl"]]]],[11,"visit_anon_const","","",158,[[["self"],["anonconst"]]]],[11,"visit_expr","","",158,[[["self"],["expr"]]]],[11,"visit_ty","","",158,[[["self"],["ty"]]]],[11,"visit_generic_param","","",158,[[["self"],["genericparam"]]]],[11,"visit_generics","","",158,[[["self"],["generics"]]]],[11,"visit_where_predicate","","",158,[[["self"],["wherepredicate"]]]],[11,"visit_fn_decl","","",158,[[["self"],["fndecl"]]]],[11,"visit_fn","","",158,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_trait_item","","",158,[[["self"],["traititem"]]]],[11,"visit_trait_item_ref","","",158,[[["self"],["traititemref"]]]],[11,"visit_impl_item","","",158,[[["self"],["implitem"]]]],[11,"visit_impl_item_ref","","",158,[[["self"],["implitemref"]]]],[11,"visit_trait_ref","","",158,[[["self"],["traitref"]]]],[11,"visit_param_bound","","",158,[[["self"],["genericbound"]]]],[11,"visit_poly_trait_ref","","",158,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_variant_data","","",158,[[["self"],["variantdata"],["name"],["generics"],["nodeid"],["span"]]]],[11,"visit_struct_field","","",158,[[["self"],["structfield"]]]],[11,"visit_enum_def","","",158,[[["self"],["enumdef"],["generics"],["nodeid"],["span"]]]],[11,"visit_variant","","",158,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_label","","",158,[[["self"],["label"]]]],[11,"visit_generic_arg","","",158,[[["self"],["genericarg"]]]],[11,"visit_lifetime","","",158,[[["self"],["lifetime"]]]],[11,"visit_qpath","","",158,[[["self"],["qpath"],["hirid"],["span"]]]],[11,"visit_path","","",158,[[["self"],["path"],["hirid"]]]],[11,"visit_path_segment","","",158,[[["self"],["span"],["pathsegment"]]]],[11,"visit_generic_args","","",158,[[["self"],["span"],["genericargs"]]]],[11,"visit_assoc_type_binding","","",158,[[["self"],["typebinding"]]]],[11,"visit_attribute","","",158,[[["self"],["attribute"]]]],[11,"visit_macro_def","","",158,[[["self"],["macrodef"]]]],[11,"visit_vis","","",158,[[["self"],["visibility"]]]],[11,"visit_associated_item_kind","","",158,[[["self"],["associateditemkind"]]]],[11,"visit_defaultness","","",158,[[["self"],["defaultness"]]]],[11,"clone","","",156,[[["self"]],["fnkind"]]],[11,"attrs","","",156,N],[11,"intra","","Returns the map to use for an \"intra item-like\" thing (if any). e.g., function body.",157,[[["self"]],["option",["map"]]]],[11,"inter","","Returns the map to use for an \"item-like\" thing (if any). e.g., item, impl-item.",157,[[["self"]],["option",["map"]]]],[11,"clone","","",154,[[["self"]],["idrange"]]],[11,"encode","","",154,[[["self"],["__s"]],["result"]]],[11,"decode","","",154,[[["__d"]],["result",["idrange"]]]],[11,"fmt","","",154,[[["self"],["formatter"]],["result"]]],[11,"max","","",154,[[],["idrange"]]],[11,"empty","","",154,[[["self"]],["bool"]]],[11,"contains","","",154,[[["self"],["nodeid"]],["bool"]]],[11,"add","","",154,[[["self"],["nodeid"]]]],[11,"new","","",155,[[["map"]],["idrangecomputingvisitor"]]],[11,"result","","",155,[[["self"]],["idrange"]]],[11,"nested_visit_map","","",155,[[["self"]],["nestedvisitormap"]]],[11,"visit_id","","",155,[[["self"],["nodeid"]]]],[0,"itemlikevisit","rustc::hir","",N,N],[3,"DeepVisitor","rustc::hir::itemlikevisit","",N,N],[12,"visitor","","",159,N],[3,"ParDeepVisitor","","",N,N],[12,"0","","",160,N],[8,"ItemLikeVisitor","","The \"item-like visitor\" visitor defines only the top-level methods that can be invoked by `Crate::visit_all_item_likes()`. Whether this trait is the right one to implement will depend on the overall pattern you need. Here are the three available patterns, in roughly the order of desirability:",N,N],[10,"visit_item","","",161,[[["self"],["item"]]]],[10,"visit_trait_item","","",161,[[["self"],["traititem"]]]],[10,"visit_impl_item","","",161,[[["self"],["implitem"]]]],[8,"ParItemLikeVisitor","","A parallel variant of ItemLikeVisitor",N,N],[10,"visit_item","","",162,[[["self"],["item"]]]],[10,"visit_trait_item","","",162,[[["self"],["traititem"]]]],[10,"visit_impl_item","","",162,[[["self"],["implitem"]]]],[8,"IntoVisitor","","",N,N],[16,"Visitor","","",163,N],[10,"into_visitor","","",163,N],[11,"new","","",159,[[["v"]],["self"]]],[11,"visit_item","","",159,[[["self"],["item"]]]],[11,"visit_trait_item","","",159,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",159,[[["self"],["implitem"]]]],[11,"visit_item","","",160,[[["self"],["item"]]]],[11,"visit_trait_item","","",160,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",160,[[["self"],["implitem"]]]],[0,"lowering","rustc::hir","Lowers the AST to the HIR.",N,N],[3,"LoweringContext","rustc::hir::lowering","",N,N],[12,"crate_root","","",164,N],[12,"sess","","",164,N],[12,"cstore","","",164,N],[12,"resolver","","",164,N],[12,"items","","The items being lowered are collected here.",164,N],[12,"trait_items","","",164,N],[12,"impl_items","","",164,N],[12,"bodies","","",164,N],[12,"exported_macros","","",164,N],[12,"trait_impls","","",164,N],[12,"trait_auto_impl","","",164,N],[12,"is_generator","","",164,N],[12,"catch_scopes","","",164,N],[12,"loop_scopes","","",164,N],[12,"is_in_loop_condition","","",164,N],[12,"is_in_trait_impl","","",164,N],[12,"anonymous_lifetime_mode","","What to do when we encounter either an \"anonymous lifetime reference\". The term \"anonymous\" is meant to encompass both `'_` lifetimes as well as fully elided cases where nothing is written at all (e.g., `&T` or `std::cell::Ref<T>`).",164,N],[12,"lifetimes_to_define","","",164,N],[12,"is_collecting_in_band_lifetimes","","",164,N],[12,"in_scope_lifetimes","","",164,N],[12,"type_def_lifetime_params","","",164,N],[12,"current_hir_id_owner","","",164,N],[12,"item_local_id_counters","","",164,N],[12,"node_id_to_hir_id","","",164,N],[3,"LoweredNodeId","","",N,N],[12,"node_id","","",165,N],[12,"hir_id","","",165,N],[4,"ImplTraitContext","","",N,N],[13,"Universal","","Treat `impl Trait` as shorthand for a new universal generic parameter. Example: `fn foo(x: impl Debug)`, where `impl Debug` is conceptually equivalent to a fresh universal parameter like `fn foo<T: Debug>(x: T)`.",166,N],[13,"Existential","","Treat `impl Trait` as shorthand for a new universal existential parameter. Example: `fn foo() -> impl Debug`, where `impl Debug` is conceptually equivalent to a fresh existential parameter like `abstract type T; fn foo() -> T`.",166,N],[13,"Disallowed","","`impl Trait` is not accepted in this position.",166,N],[4,"ParamMode","","",N,N],[13,"Explicit","","Any path in a type context.",167,N],[13,"Optional","","The `module::Type` in `module::Type::method` in an expression.",167,N],[4,"ParenthesizedGenericArgs","","",N,N],[13,"Ok","","",168,N],[13,"Warn","","",168,N],[13,"Err","","",168,N],[4,"AnonymousLifetimeMode","","What to do when we encounter an anonymous lifetime reference. Anonymous lifetime references come in two flavors.  You have implicit, or fully elided, references to lifetimes, like the one in `&T` or `Ref<T>`, and you have `'_` lifetimes, like `&'_ T` or `Ref<'_, T>`.  These often behave the same, but not always:",N,N],[13,"CreateParameter","","For Modern cases, create a new anonymous region parameter and reference that.",169,N],[13,"PassThrough","","Pass responsibility to `resolve_lifetime` code for all cases.",169,N],[5,"lower_crate","","",N,[[["session"],["cratestore"],["depgraph"],["crate"],["resolver"]],["crate"]]],[5,"body_ids","","",N,[[["btreemap"]],["vec",["bodyid"]]]],[22,"","","",N,N],[17,"HIR_ID_COUNTER_LOCKED","","",N,N],[8,"Resolver","","",N,N],[10,"resolve_hir_path","","Resolve a hir path generated by the lowerer when expanding `for`, `if let`, etc.",170,[[["self"],["path"],["bool"]]]],[10,"get_resolution","","Obtain the resolution for a node id",170,[[["self"],["nodeid"]],["option",["pathresolution"]]]],[10,"get_import","","Obtain the possible resolutions for the given `use` statement.",170,[[["self"],["nodeid"]],["perns",["option"]]]],[10,"definitions","","We must keep the set of definitions up to date as we add nodes that weren't in the AST. This should only return `None` during testing.",170,[[["self"]],["definitions"]]],[10,"resolve_str_path","","Given suffix [\"b\",\"c\",\"d\"], creates a HIR path for `[::crate_root]::b::c::d` and resolves it based on `is_value`.",170,N],[11,"fmt","","",166,[[["self"],["formatter"]],["result"]]],[11,"reborrow","","",166,[[["self"]],["impltraitcontext"]]],[11,"clone","","",167,[[["self"]],["parammode"]]],[11,"eq","","",167,[[["self"],["parammode"]],["bool"]]],[11,"fmt","","",165,[[["self"],["formatter"]],["result"]]],[11,"clone","","",169,[[["self"]],["anonymouslifetimemode"]]],[11,"lower_crate","","",164,[[["self"],["crate"]],["crate"]]],[11,"allocate_hir_id_counter","","",164,[[["self"],["nodeid"],["t"]],["lowerednodeid"]]],[11,"lower_node_id_generic","","",164,[[["self"],["nodeid"],["f"]],["lowerednodeid"]]],[11,"with_hir_id_owner","","",164,[[["self"],["nodeid"],["f"]],["t"]]],[11,"lower_node_id","","This method allocates a new HirId for the given NodeId and stores it in the LoweringContext's NodeId => HirId map. Take care not to call this method if the resulting HirId is then not actually used in the HIR, as that would trigger an assertion in the HirIdValidator later on, which makes sure that all NodeIds got mapped properly. Calling the method twice with the same NodeId is fine though.",164,[[["self"],["nodeid"]],["lowerednodeid"]]],[11,"lower_node_id_with_owner","","",164,[[["self"],["nodeid"],["nodeid"]],["lowerednodeid"]]],[11,"record_body","","",164,[[["self"],["expr"],["option",["fndecl"]]],["bodyid"]]],[11,"next_id","","",164,[[["self"]],["lowerednodeid"]]],[11,"expect_full_def","","",164,[[["self"],["nodeid"]],["def"]]],[11,"expect_full_def_from_use","","",164,N],[11,"diagnostic","","",164,[[["self"]],["handler"]]],[11,"str_to_ident","","",164,[[["self"],["str"]],["ident"]]],[11,"allow_internal_unstable","","",164,[[["self"],["compilerdesugaringkind"],["span"]],["span"]]],[11,"with_anonymous_lifetime_mode","","",164,N],[11,"collect_in_band_defs","","Creates a new hir::GenericParam for every new lifetime and type parameter encountered while evaluating `f`. Definitions are created with the parent provided. If no `parent_id` is provided, no definitions will be returned.",164,N],[11,"maybe_collect_in_band_lifetime","","When there is a reference to some lifetime `'a`, and in-band lifetimes are enabled, then we want to push that lifetime into the vector of names to define later. In that case, it will get added to the appropriate generics.",164,[[["self"],["ident"]]]],[11,"collect_fresh_in_band_lifetime","","When we have either an elided or `'_` lifetime in an impl header, we convert it to",164,[[["self"],["span"]],["paramname"]]],[11,"with_in_scope_lifetime_defs","","",164,N],[11,"with_parent_impl_lifetime_defs","","",164,[[["self"],["hirvec"],["f"]],["t"]]],[11,"add_in_band_defs","","Appends in-band lifetime defs and argument-position `impl Trait` defs to the existing set of generics.",164,N],[11,"with_catch_scope","","",164,[[["self"],["nodeid"],["f"]],["t"]]],[11,"make_async_expr","","",164,N],[11,"lower_body","","",164,[[["self"],["option",["fndecl"]],["f"]],["bodyid"]]],[11,"with_loop_scope","","",164,[[["self"],["nodeid"],["f"]],["t"]]],[11,"with_loop_condition_scope","","",164,[[["self"],["f"]],["t"]]],[11,"with_new_scopes","","",164,[[["self"],["f"]],["t"]]],[11,"def_key","","",164,[[["self"],["defid"]],["defkey"]]],[11,"lower_label","","",164,[[["self"],["option",["label"]]],["option",["label"]]]],[11,"lower_loop_destination","","",164,[[["self"],["option"]],["destination"]]],[11,"lower_attrs","","",164,N],[11,"lower_attr","","",164,[[["self"],["attribute"]],["attribute"]]],[11,"lower_token_stream","","",164,[[["self"],["tokenstream"]],["tokenstream"]]],[11,"lower_token_tree","","",164,[[["self"],["tokentree"]],["tokenstream"]]],[11,"lower_token","","",164,[[["self"],["token"],["span"]],["tokenstream"]]],[11,"lower_arm","","",164,[[["self"],["arm"]],["arm"]]],[11,"lower_ty_binding","","",164,[[["self"],["typebinding"],["impltraitcontext"]],["typebinding"]]],[11,"lower_generic_arg","","",164,[[["self"],["genericarg"],["impltraitcontext"]],["genericarg"]]],[11,"lower_ty","","",164,[[["self"],["ty"],["impltraitcontext"]],["p",["ty"]]]],[11,"lower_ty_direct","","",164,[[["self"],["ty"],["impltraitcontext"]],["ty"]]],[11,"lower_existential_impl_trait","","",164,N],[11,"lifetimes_from_impl_trait_bounds","","",164,N],[11,"lower_foreign_mod","","",164,[[["self"],["foreignmod"]],["foreignmod"]]],[11,"lower_global_asm","","",164,[[["self"],["globalasm"]],["p",["globalasm"]]]],[11,"lower_variant","","",164,[[["self"],["variant"]],["variant"]]],[11,"lower_qpath","","",164,[[["self"],["nodeid"],["option"],["path"],["parammode"],["impltraitcontext"]],["qpath"]]],[11,"lower_path_extra","","",164,[[["self"],["def"],["path"],["option",["ident"]],["parammode"]],["path"]]],[11,"lower_path","","",164,[[["self"],["nodeid"],["path"],["parammode"]],["path"]]],[11,"lower_path_segment","","",164,[[["self"],["span"],["pathsegment"],["parammode"],["usize"],["parenthesizedgenericargs"],["impltraitcontext"]],["pathsegment"]]],[11,"lower_angle_bracketed_parameter_data","","",164,N],[11,"lower_parenthesized_parameter_data","","",164,N],[11,"lower_local","","",164,[[["self"],["local"]],["p",["local"]]]],[11,"lower_mutability","","",164,[[["self"],["mutability"]],["mutability"]]],[11,"lower_arg","","",164,[[["self"],["arg"]],["arg"]]],[11,"lower_fn_args_to_names","","",164,[[["self"],["fndecl"]],["hirvec",["ident"]]]],[11,"lower_fn_decl","","",164,[[["self"],["fndecl"],["option"],["bool"],["option",["nodeid"]]],["p",["fndecl"]]]],[11,"lower_async_fn_ret_ty","","",164,N],[11,"lower_param_bound","","",164,[[["self"],["genericbound"],["impltraitcontext"]],["genericbound"]]],[11,"lower_lifetime","","",164,[[["self"],["lifetime"]],["lifetime"]]],[11,"new_named_lifetime","","",164,[[["self"],["nodeid"],["span"],["lifetimename"]],["lifetime"]]],[11,"lower_generic_params","","",164,N],[11,"lower_generic_param","","",164,[[["self"],["genericparam"],["nodemap"],["impltraitcontext"]],["genericparam"]]],[11,"lower_generics","","",164,[[["self"],["generics"],["impltraitcontext"]],["generics"]]],[11,"lower_where_clause","","",164,[[["self"],["whereclause"]],["whereclause"]]],[11,"lower_where_predicate","","",164,[[["self"],["wherepredicate"]],["wherepredicate"]]],[11,"lower_variant_data","","",164,[[["self"],["variantdata"]],["variantdata"]]],[11,"lower_trait_ref","","",164,[[["self"],["traitref"],["impltraitcontext"]],["traitref"]]],[11,"lower_poly_trait_ref","","",164,[[["self"],["polytraitref"],["impltraitcontext"]],["polytraitref"]]],[11,"lower_struct_field","","",164,N],[11,"lower_field","","",164,[[["self"],["field"]],["field"]]],[11,"lower_mt","","",164,[[["self"],["mutty"],["impltraitcontext"]],["mutty"]]],[11,"lower_param_bounds","","",164,N],[11,"lower_block","","",164,[[["self"],["block"],["bool"]],["p",["block"]]]],[11,"lower_async_body","","",164,[[["self"],["fndecl"],["isasync"],["block"]],["bodyid"]]],[11,"lower_item_kind","","",164,[[["self"],["nodeid"],["name"],["hirvec"],["visibility"],["itemkind"]],["itemkind"]]],[11,"lower_use_tree","","",164,[[["self"],["usetree"],["path"],["nodeid"],["visibility"],["name"],["hirvec"]],["itemkind"]]],[11,"lower_trait_item","","",164,[[["self"],["traititem"]],["traititem"]]],[11,"lower_trait_item_ref","","",164,[[["self"],["traititem"]],["traititemref"]]],[11,"lower_impl_item","","",164,[[["self"],["implitem"]],["implitem"]]],[11,"lower_impl_item_ref","","",164,[[["self"],["implitem"]],["implitemref"]]],[11,"lower_mod","","",164,[[["self"],["mod"]],["mod"]]],[11,"lower_impl_trait_ids","","Lowers `impl Trait` items and appends them to the list",164,[[["self"],["fndecl"],["fnheader"],["onevector"]]]],[11,"lower_item_id","","",164,[[["self"],["item"]],["onevector",["itemid"]]]],[11,"lower_item_id_use_tree","","",164,[[["self"],["usetree"],["nodeid"],["onevector"]]]],[11,"lower_item","","",164,[[["self"],["item"]],["option",["item"]]]],[11,"lower_foreign_item","","",164,[[["self"],["foreignitem"]],["foreignitem"]]],[11,"lower_method_sig","","",164,N],[11,"lower_is_auto","","",164,[[["self"],["isauto"]],["isauto"]]],[11,"lower_fn_header","","",164,[[["self"],["fnheader"]],["fnheader"]]],[11,"lower_unsafety","","",164,[[["self"],["unsafety"]],["unsafety"]]],[11,"lower_constness","","",164,[[["self"],["spanned",["constness"]]],["constness"]]],[11,"lower_asyncness","","",164,[[["self"],["isasync"]],["isasync"]]],[11,"lower_unop","","",164,[[["self"],["unop"]],["unop"]]],[11,"lower_binop","","",164,[[["self"],["binop"]],["binop"]]],[11,"lower_pat","","",164,[[["self"],["pat"]],["p",["pat"]]]],[11,"lower_range_end","","",164,[[["self"],["rangeend"]],["rangeend"]]],[11,"lower_anon_const","","",164,[[["self"],["anonconst"]],["anonconst"]]],[11,"lower_expr","","",164,[[["self"],["expr"]],["expr"]]],[11,"lower_stmt","","",164,[[["self"],["stmt"]],["onevector",["stmt"]]]],[11,"lower_capture_clause","","",164,[[["self"],["captureby"]],["captureclause"]]],[11,"lower_visibility","","If an `explicit_owner` is given, this method allocates the `HirId` in the address space of that item instead of the item currently being lowered. This can happen during `lower_impl_item_ref()` where we need to lower a `Visibility` value although we haven't lowered the owning `ImplItem` in question yet.",164,[[["self"],["visibility"],["option",["nodeid"]]],["visibility"]]],[11,"lower_defaultness","","",164,[[["self"],["defaultness"],["bool"]],["defaultness"]]],[11,"lower_block_check_mode","","",164,[[["self"],["blockcheckmode"]],["blockcheckmode"]]],[11,"lower_binding_mode","","",164,[[["self"],["bindingmode"]],["bindingannotation"]]],[11,"lower_unsafe_source","","",164,[[["self"],["unsafesource"]],["unsafesource"]]],[11,"lower_impl_polarity","","",164,[[["self"],["implpolarity"]],["implpolarity"]]],[11,"lower_trait_bound_modifier","","",164,[[["self"],["traitboundmodifier"]],["traitboundmodifier"]]],[11,"arm","","",164,[[["self"],["hirvec",["p"]],["p",["expr"]]],["arm"]]],[11,"field","","",164,[[["self"],["ident"],["p",["expr"]],["span"]],["field"]]],[11,"expr_break","","",164,[[["self"],["span"],["thinvec",["attribute"]]],["p",["expr"]]]],[11,"expr_call","","",164,[[["self"],["span"],["p",["expr"]],["hirvec",["expr"]]],["expr"]]],[11,"expr_ident","","",164,[[["self"],["span"],["ident"],["nodeid"]],["expr"]]],[11,"expr_ident_with_attrs","","",164,[[["self"],["span"],["ident"],["nodeid"],["thinvec",["attribute"]]],["expr"]]],[11,"expr_mut_addr_of","","",164,[[["self"],["span"],["p",["expr"]]],["expr"]]],[11,"expr_std_path","","",164,N],[11,"expr_match","","",164,[[["self"],["span"],["p",["expr"]],["hirvec",["arm"]],["matchsource"]],["expr"]]],[11,"expr_block","","",164,[[["self"],["p",["block"]],["thinvec",["attribute"]]],["expr"]]],[11,"expr_tuple","","",164,[[["self"],["span"],["hirvec",["expr"]]],["p",["expr"]]]],[11,"expr","","",164,[[["self"],["span"],["exprkind"],["thinvec",["attribute"]]],["expr"]]],[11,"stmt_let_pat","","",164,[[["self"],["span"],["option",["p"]],["p",["pat"]],["localsource"]],["stmt"]]],[11,"stmt_let","","",164,N],[11,"block_expr","","",164,[[["self"],["p",["expr"]]],["block"]]],[11,"block_all","","",164,[[["self"],["span"],["hirvec",["stmt"]],["option",["p"]]],["block"]]],[11,"pat_ok","","",164,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"pat_err","","",164,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"pat_some","","",164,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"pat_none","","",164,[[["self"],["span"]],["p",["pat"]]]],[11,"pat_std_enum","","",164,N],[11,"pat_ident","","",164,[[["self"],["span"],["ident"]],["p",["pat"]]]],[11,"pat_ident_binding_mode","","",164,[[["self"],["span"],["ident"],["bindingannotation"]],["p",["pat"]]]],[11,"pat_wild","","",164,[[["self"],["span"]],["p",["pat"]]]],[11,"pat","","",164,[[["self"],["span"],["patkind"]],["p",["pat"]]]],[11,"std_path","","Given suffix [\"b\",\"c\",\"d\"], returns path `::std::b::c::d` when `fld.cx.use_std`, and `::core::b::c::d` otherwise. The path is also resolved according to `is_value`.",164,N],[11,"ty_path","","",164,[[["self"],["lowerednodeid"],["span"],["qpath"]],["ty"]]],[11,"elided_ref_lifetime","","Invoked to create the lifetime argument for a type `&T` with no explicit lifetime.",164,[[["self"],["span"]],["lifetime"]]],[11,"elided_path_lifetimes","","Invoked to create the lifetime argument(s) for a path like `std::cell::Ref<T>`; note that implicit lifetimes in these sorts of cases are deprecated. This may therefore report a warning or an error, depending on the mode.",164,[[["self"],["span"],["usize"]],["p"]]],[11,"elided_dyn_bound","","Invoked to create the lifetime argument(s) for an elided trait object bound, like the bound in `Box<dyn Debug>`. This method is not invoked when the bound is written, even if it is written with `'_` like in `Box<dyn Debug + '_>`. In those cases, `lower_lifetime` is invoked.",164,[[["self"],["span"]],["lifetime"]]],[11,"new_implicit_lifetime","","",164,[[["self"],["span"]],["lifetime"]]],[11,"maybe_lint_bare_trait","","",164,[[["self"],["span"],["nodeid"],["bool"]]]],[11,"wrap_in_try_constructor","","",164,[[["self"],["str"],["expr"],["span"]],["p",["expr"]]]],[11,"check_self_struct_ctor_feature","","",164,[[["self"],["qpath"]]]],[0,"map","rustc::hir","",N,N],[3,"DefCollector","rustc::hir::map","Creates def ids for nodes in the AST.",N,N],[12,"definitions","","",171,N],[12,"parent_def","","",171,N],[12,"expansion","","",171,N],[12,"visit_macro_invoc","","",171,N],[3,"MacroInvocationData","","",N,N],[12,"mark","","",172,N],[12,"def_index","","",172,N],[3,"Entry","","Represents an entry and its parent NodeId.",N,N],[12,"parent","","",173,N],[12,"dep_node","","",173,N],[12,"node","","",173,N],[3,"Forest","","Stores a crate and any number of inlined items from other crates.",N,N],[12,"krate","","",174,N],[12,"dep_graph","","",174,N],[3,"Map","","Represents a mapping from Node IDs to AST elements and their parent Node IDs",N,N],[12,"forest","","The backing storage for all the AST nodes.",175,N],[12,"dep_graph","","Same as the dep_graph in forest, just available with one fewer deref. This is a gratuitous micro-optimization.",175,N],[12,"crate_hash","","The SVH of the local crate.",175,N],[12,"map","","`NodeId`s are sequential integers from 0, so we can be super-compact by storing them in a vector. Not everything with a `NodeId` is in the map, but empirically the occupancy is about 75-80%, so there's not too much overhead (certainly less than a hashmap, since they (at the time of writing) have a maximum of 75% occupancy).",175,N],[12,"definitions","","",175,N],[12,"hir_to_node_id","","The reverse mapping of `node_to_hir_id`.",175,N],[3,"NodesMatchingSuffix","","",N,N],[12,"map","","",176,N],[12,"item_name","","",176,N],[12,"in_which","","",176,N],[12,"idx","","",176,N],[5,"map_crate","","",N,[[["session"],["cratestore"],["forest"],["definitions"]],["map"]]],[5,"node_id_to_string","","",N,[[["map"],["nodeid"],["bool"]],["string"]]],[5,"describe_def","","",N,[[["tyctxt"],["defid"]],["option",["def"]]]],[0,"blocks","","This module provides a simplified abstraction for working with code blocks identified by their integer node-id.  In particular, it captures a common set of attributes that all \"function-like things\" (represented by `FnLike` instances) share.  For example, all `FnLike` instances have a type signature (be it explicit or inferred).  And all `FnLike` instances have a body, i.e. the code that is run when the function-like thing it represents is invoked.",N,N],[3,"FnLikeNode","rustc::hir::map::blocks","An FnLikeNode is a Node that is like a fn, in that it has a decl and a body (as well as a NodeId, a span, etc).",N,N],[12,"node","","",177,N],[3,"ItemFnParts","","These are all the components one can extract from a fn item for use when implementing FnLikeNode operations.",N,N],[12,"name","","",178,N],[12,"decl","","",178,N],[12,"header","","",178,N],[12,"vis","","",178,N],[12,"generics","","",178,N],[12,"body","","",178,N],[12,"id","","",178,N],[12,"span","","",178,N],[12,"attrs","","",178,N],[3,"ClosureParts","","These are all the components one can extract from a closure expr for use when implementing FnLikeNode operations.",N,N],[12,"decl","","",179,N],[12,"body","","",179,N],[12,"id","","",179,N],[12,"span","","",179,N],[12,"attrs","","",179,N],[4,"Code","","Carries either an FnLikeNode or a Expr, as these are the two constructs that correspond to \"code\" (as in, something from which we can construct a control-flow graph).",N,N],[13,"FnLike","","",180,N],[13,"Expr","","",180,N],[8,"MaybeFnLike","","MaybeFnLike wraps a method that indicates if an object corresponds to some FnLikeNode.",N,N],[10,"is_fn_like","","",181,[[["self"]],["bool"]]],[11,"clone","","",177,[[["self"]],["fnlikenode"]]],[11,"fmt","","",177,[[["self"],["formatter"]],["result"]]],[11,"is_fn_like","rustc::hir","",83,[[["self"]],["bool"]]],[11,"is_fn_like","","",65,[[["self"]],["bool"]]],[11,"is_fn_like","","",63,[[["self"]],["bool"]]],[11,"is_fn_like","","",58,[[["self"]],["bool"]]],[11,"clone","rustc::hir::map::blocks","",180,[[["self"]],["code"]]],[11,"id","","",180,[[["self"]],["nodeid"]]],[11,"from_node","","Attempts to construct a Code from presumed FnLike or Expr node input.",180,[[["map"],["nodeid"]],["option",["code"]]]],[11,"new","","",179,N],[11,"from_node","","Attempts to construct a FnLikeNode from presumed FnLike node input.",177,[[["node"]],["option",["fnlikenode"]]]],[11,"body","","",177,[[["self"]],["bodyid"]]],[11,"decl","","",177,[[["self"]],["fndecl"]]],[11,"span","","",177,[[["self"]],["span"]]],[11,"id","","",177,[[["self"]],["nodeid"]]],[11,"constness","","",177,[[["self"]],["constness"]]],[11,"asyncness","","",177,[[["self"]],["isasync"]]],[11,"unsafety","","",177,[[["self"]],["unsafety"]]],[11,"kind","","",177,[[["self"]],["fnkind"]]],[11,"handle","","",177,[[["self"],["i"],["m"],["c"]],["a"]]],[0,"collector","rustc::hir::map","",N,N],[3,"NodeCollector","rustc::hir::map::collector","A Visitor that walks over the HIR and collects Nodes into a HIR map",N,N],[12,"krate","","The crate",182,N],[12,"map","","The node map",182,N],[12,"parent_node","","The parent of this node",182,N],[12,"current_dep_node_owner","","",182,N],[12,"current_signature_dep_index","","",182,N],[12,"current_full_dep_index","","",182,N],[12,"currently_in_body","","",182,N],[12,"dep_graph","","",182,N],[12,"definitions","","",182,N],[12,"hcx","","",182,N],[12,"hir_body_nodes","","",182,N],[3,"HirItemLike","","",N,N],[12,"item_like","","",183,N],[12,"hash_bodies","","",183,N],[11,"root","","",182,[[["crate"],["depgraph"],["definitions"],["stablehashingcontext"]],["nodecollector"]]],[11,"finalize_and_compute_crate_hash","","",182,N],[11,"insert_entry","","",182,[[["self"],["nodeid"],["entry"]]]],[11,"insert","","",182,[[["self"],["nodeid"],["node"]]]],[11,"with_parent","","",182,[[["self"],["nodeid"],["f"]]]],[11,"with_dep_node_owner","","",182,[[["self"],["defindex"],["t"],["f"]]]],[11,"nested_visit_map","","Because we want to track parent items and so forth, enable deep walking so that we walk nested items in the context of their outer items.",182,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_item","","",182,[[["self"],["itemid"]]]],[11,"visit_nested_trait_item","","",182,[[["self"],["traititemid"]]]],[11,"visit_nested_impl_item","","",182,[[["self"],["implitemid"]]]],[11,"visit_nested_body","","",182,[[["self"],["bodyid"]]]],[11,"visit_item","","",182,[[["self"],["item"]]]],[11,"visit_foreign_item","","",182,[[["self"],["foreignitem"]]]],[11,"visit_generic_param","","",182,[[["self"],["genericparam"]]]],[11,"visit_trait_item","","",182,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",182,[[["self"],["implitem"]]]],[11,"visit_pat","","",182,[[["self"],["pat"]]]],[11,"visit_anon_const","","",182,[[["self"],["anonconst"]]]],[11,"visit_expr","","",182,[[["self"],["expr"]]]],[11,"visit_stmt","","",182,[[["self"],["stmt"]]]],[11,"visit_ty","","",182,[[["self"],["ty"]]]],[11,"visit_trait_ref","","",182,[[["self"],["traitref"]]]],[11,"visit_fn","","",182,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_block","","",182,[[["self"],["block"]]]],[11,"visit_local","","",182,[[["self"],["local"]]]],[11,"visit_lifetime","","",182,[[["self"],["lifetime"]]]],[11,"visit_vis","","",182,[[["self"],["visibility"]]]],[11,"visit_macro_def","","",182,[[["self"],["macrodef"]]]],[11,"visit_variant","","",182,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_struct_field","","",182,[[["self"],["structfield"]]]],[11,"visit_trait_item_ref","","",182,[[["self"],["traititemref"]]]],[11,"visit_impl_item_ref","","",182,[[["self"],["implitemref"]]]],[11,"hash_stable","","",183,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"def_collector","rustc::hir::map","",N,N],[3,"DefCollector","rustc::hir::map::def_collector","Creates def ids for nodes in the AST.",N,N],[12,"definitions","","",171,N],[12,"parent_def","","",171,N],[12,"expansion","","",171,N],[12,"visit_macro_invoc","","",171,N],[3,"MacroInvocationData","","",N,N],[12,"mark","","",172,N],[12,"def_index","","",172,N],[11,"new","rustc::hir::map","",171,[[["definitions"],["mark"]],["self"]]],[11,"collect_root","","",171,[[["self"],["str"],["cratedisambiguator"]]]],[11,"create_def","","",171,[[["self"],["nodeid"],["defpathdata"],["defindexaddressspace"],["span"]],["defindex"]]],[11,"with_parent","","",171,[[["self"],["defindex"],["f"]]]],[11,"visit_async_fn","","",171,[[["self"],["nodeid"],["name"],["span"],["fnheader"],["generics"],["fndecl"],["block"]]]],[11,"visit_macro_invoc","","",171,[[["self"],["nodeid"]]]],[11,"visit_item","","",171,[[["self"],["item"]]]],[11,"visit_use_tree","","",171,[[["self"],["usetree"],["nodeid"],["bool"]]]],[11,"visit_foreign_item","","",171,[[["self"],["foreignitem"]]]],[11,"visit_variant","","",171,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_variant_data","","",171,[[["self"],["variantdata"],["ident"],["generics"],["nodeid"],["span"]]]],[11,"visit_generic_param","","",171,[[["self"],["genericparam"]]]],[11,"visit_trait_item","","",171,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",171,[[["self"],["implitem"]]]],[11,"visit_pat","","",171,[[["self"],["pat"]]]],[11,"visit_anon_const","","",171,[[["self"],["anonconst"]]]],[11,"visit_expr","","",171,[[["self"],["expr"]]]],[11,"visit_ty","","",171,[[["self"],["ty"]]]],[11,"visit_stmt","","",171,[[["self"],["stmt"]]]],[11,"visit_token","","",171,[[["self"],["token"]]]],[0,"definitions","","For each definition, we track the following data.  A definition here is defined somewhat circularly as \"something with a def-id\", but it generally corresponds to things like structs, enums, etc. There are also some rather random cases (like const initializer expressions) that are mostly just leftovers.",N,N],[3,"DefPathTable","rustc::hir::map::definitions","The DefPathTable maps DefIndexes to DefKeys and vice versa. Internally the DefPathTable holds a tree of DefKeys, where each DefKey stores the DefIndex of its parent. There is one DefPathTable for each crate.",N,N],[12,"index_to_key","","",184,N],[12,"def_path_hashes","","",184,N],[3,"Definitions","","The definition table containing node definitions. It holds the DefPathTable for local DefIds/DefPaths and it also stores a mapping from NodeIds to local DefIds.",N,N],[12,"table","","",185,N],[12,"node_to_def_index","","",185,N],[12,"def_index_to_node","","",185,N],[12,"node_to_hir_id","","",185,N],[12,"parent_modules_of_macro_defs","","If `Mark` is an ID of some macro expansion, then `DefId` is the normal module (`mod`) in which the expanded macro was defined.",185,N],[12,"expansions_that_defined","","Item with a given `DefIndex` was defined during macro expansion with ID `Mark`.",185,N],[12,"next_disambiguator","","",185,N],[12,"def_index_to_span","","",185,N],[3,"DefKey","","A unique identifier that we can use to lookup a definition precisely. It combines the index of the definition's parent (if any) with a `DisambiguatedDefPathData`.",N,N],[12,"parent","","Parent path.",186,N],[12,"disambiguated_data","","Identifier of this node.",186,N],[3,"DisambiguatedDefPathData","","Pair of `DefPathData` and an integer disambiguator. The integer is normally 0, but in the event that there are multiple defs with the same `parent` and `data`, we use this field to disambiguate between them. This introduces some artificial ordering dependency but means that if you have (e.g.) two impls for the same type in the same module, they do get distinct def-ids.",N,N],[12,"data","","",187,N],[12,"disambiguator","","",187,N],[3,"DefPath","","",N,N],[12,"data","","the path leading from the crate root to the item",188,N],[12,"krate","","what krate root is this path relative to?",188,N],[3,"DefPathHash","","",N,N],[12,"0","","",189,N],[4,"DefPathData","","",N,N],[13,"CrateRoot","","The crate root (marker)",190,N],[13,"Misc","","",190,N],[13,"Impl","","An impl",190,N],[13,"Trait","","A trait",190,N],[13,"AssocTypeInTrait","","An associated type declaration (i.e., in a trait)",190,N],[13,"AssocTypeInImpl","","An associated type value (i.e., in an impl)",190,N],[13,"AssocExistentialInImpl","","An existential associated type value (i.e., in an impl)",190,N],[13,"TypeNs","","Something in the type NS",190,N],[13,"ValueNs","","Something in the value NS",190,N],[13,"Module","","A module declaration",190,N],[13,"MacroDef","","A macro rule",190,N],[13,"ClosureExpr","","A closure expression",190,N],[13,"TypeParam","","A type parameter (generic parameter)",190,N],[13,"LifetimeParam","","A lifetime definition",190,N],[13,"EnumVariant","","A variant of a enum",190,N],[13,"Field","","A struct field",190,N],[13,"StructCtor","","Implicit ctor for a tuple-like struct",190,N],[13,"AnonConst","","A constant expression (see {ast,hir}::AnonConst).",190,N],[13,"ImplTrait","","An `impl Trait` type node",190,N],[13,"GlobalMetaData","","GlobalMetaData identifies a piece of crate metadata that is global to a whole crate (as opposed to just one item). GlobalMetaData components are only supposed to show up right below the crate root.",190,N],[4,"GlobalMetaDataKind","","",N,N],[13,"Krate","","",191,N],[13,"CrateDeps","","",191,N],[13,"DylibDependencyFormats","","",191,N],[13,"LangItems","","",191,N],[13,"LangItemsMissing","","",191,N],[13,"NativeLibraries","","",191,N],[13,"SourceMap","","",191,N],[13,"Impls","","",191,N],[13,"ExportedSymbols","","",191,N],[17,"GLOBAL_MD_ADDRESS_SPACE","","",N,N],[17,"FIRST_FREE_HIGH_DEF_INDEX","","",N,N],[11,"clone","","",184,[[["self"]],["self"]]],[11,"allocate","","",184,[[["self"],["defkey"],["defpathhash"],["defindexaddressspace"]],["defindex"]]],[11,"next_id","","",184,[[["self"],["defindexaddressspace"]],["defindex"]]],[11,"def_key","","",184,[[["self"],["defindex"]],["defkey"]]],[11,"def_path_hash","","",184,[[["self"],["defindex"]],["defpathhash"]]],[11,"add_def_path_hashes_to","","",184,[[["self"],["cratenum"],["fxhashmap"]]]],[11,"size","","",184,[[["self"]],["usize"]]],[11,"encode","","",184,[[["self"],["s"]],["result"]]],[11,"decode","","",184,[[["d"]],["result",["defpathtable"]]]],[11,"clone","","",185,[[["self"]],["definitions"]]],[11,"clone","","",186,[[["self"]],["defkey"]]],[11,"eq","","",186,[[["self"],["defkey"]],["bool"]]],[11,"ne","","",186,[[["self"],["defkey"]],["bool"]]],[11,"fmt","","",186,[[["self"],["formatter"]],["result"]]],[11,"hash","","",186,N],[11,"encode","","",186,[[["self"],["__s"]],["result"]]],[11,"decode","","",186,[[["__d"]],["result",["defkey"]]]],[11,"compute_stable_hash","","",186,[[["self"],["defpathhash"]],["defpathhash"]]],[11,"root_parent_stable_hash","","",186,[[["str"],["cratedisambiguator"]],["defpathhash"]]],[11,"clone","","",187,[[["self"]],["disambiguateddefpathdata"]]],[11,"eq","","",187,[[["self"],["disambiguateddefpathdata"]],["bool"]]],[11,"ne","","",187,[[["self"],["disambiguateddefpathdata"]],["bool"]]],[11,"fmt","","",187,[[["self"],["formatter"]],["result"]]],[11,"hash","","",187,N],[11,"encode","","",187,[[["self"],["__s"]],["result"]]],[11,"decode","","",187,[[["__d"]],["result",["disambiguateddefpathdata"]]]],[11,"clone","","",188,[[["self"]],["defpath"]]],[11,"fmt","","",188,[[["self"],["formatter"]],["result"]]],[11,"hash","","",188,N],[11,"encode","","",188,[[["self"],["__s"]],["result"]]],[11,"decode","","",188,[[["__d"]],["result",["defpath"]]]],[11,"is_local","","",188,[[["self"]],["bool"]]],[11,"make","","",188,[[["cratenum"],["defindex"],["fn"]],["defpath"]]],[11,"to_string_no_crate","","Returns a string representation of the DefPath without the crate-prefix. This method is useful if you don't have a TyCtxt available.",188,[[["self"]],["string"]]],[11,"to_string_friendly","","Return filename friendly string of the DefPah with the crate-prefix.",188,[[["self"],["f"]],["string"]]],[11,"to_filename_friendly_no_crate","","Return filename friendly string of the DefPah without the crate-prefix. This method is useful if you don't have a TyCtxt available.",188,[[["self"]],["string"]]],[11,"clone","","",190,[[["self"]],["defpathdata"]]],[11,"fmt","","",190,[[["self"],["formatter"]],["result"]]],[11,"eq","","",190,[[["self"],["defpathdata"]],["bool"]]],[11,"ne","","",190,[[["self"],["defpathdata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",190,N],[11,"hash","","",190,N],[11,"encode","","",190,[[["self"],["__s"]],["result"]]],[11,"decode","","",190,[[["__d"]],["result",["defpathdata"]]]],[11,"clone","","",189,[[["self"]],["defpathhash"]]],[11,"hash","","",189,N],[11,"eq","","",189,[[["self"],["defpathhash"]],["bool"]]],[11,"ne","","",189,[[["self"],["defpathhash"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",189,N],[11,"partial_cmp","","",189,[[["self"],["defpathhash"]],["option",["ordering"]]]],[11,"lt","","",189,[[["self"],["defpathhash"]],["bool"]]],[11,"le","","",189,[[["self"],["defpathhash"]],["bool"]]],[11,"gt","","",189,[[["self"],["defpathhash"]],["bool"]]],[11,"ge","","",189,[[["self"],["defpathhash"]],["bool"]]],[11,"cmp","","",189,[[["self"],["defpathhash"]],["ordering"]]],[11,"fmt","","",189,[[["self"],["formatter"]],["result"]]],[11,"encode","","",189,[[["self"],["__s"]],["result"]]],[11,"decode","","",189,[[["__d"]],["result",["defpathhash"]]]],[11,"hash_stable","","",189,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"borrow","","",189,[[["self"]],["fingerprint"]]],[11,"new","","Create new empty definition map.",185,[[],["definitions"]]],[11,"def_path_table","","",185,[[["self"]],["defpathtable"]]],[11,"def_index_counts_lo_hi","","Get the number of definitions.",185,N],[11,"def_key","","",185,[[["self"],["defindex"]],["defkey"]]],[11,"def_path_hash","","",185,[[["self"],["defindex"]],["defpathhash"]]],[11,"def_path","","Returns the path from the crate root to `index`. The root nodes are not included in the path (i.e., this will be an empty vector for the crate root). For an inlined item, this will be the path of the item in the external crate (but the path will begin with the path to the external crate).",185,[[["self"],["defindex"]],["defpath"]]],[11,"opt_def_index","","",185,[[["self"],["nodeid"]],["option",["defindex"]]]],[11,"opt_local_def_id","","",185,[[["self"],["nodeid"]],["option",["defid"]]]],[11,"local_def_id","","",185,[[["self"],["nodeid"]],["defid"]]],[11,"as_local_node_id","","",185,[[["self"],["defid"]],["option",["nodeid"]]]],[11,"node_to_hir_id","","",185,[[["self"],["nodeid"]],["hirid"]]],[11,"def_index_to_hir_id","","",185,[[["self"],["defindex"]],["hirid"]]],[11,"opt_span","","Retrieve the span of the given `DefId` if `DefId` is in the local crate, the span exists and it's not DUMMY_SP",185,[[["self"],["defid"]],["option",["span"]]]],[11,"create_root_def","","Add a definition with a parent definition.",185,[[["self"],["str"],["cratedisambiguator"]],["defindex"]]],[11,"create_def_with_parent","","Add a definition with a parent definition.",185,[[["self"],["defindex"],["nodeid"],["defpathdata"],["defindexaddressspace"],["mark"],["span"]],["defindex"]]],[11,"init_node_id_to_hir_id_mapping","","Initialize the ast::NodeId to HirId mapping once it has been generated during AST to HIR lowering.",185,[[["self"],["indexvec",["nodeid","hirid"]]]]],[11,"expansion_that_defined","","",185,[[["self"],["defindex"]],["mark"]]],[11,"parent_module_of_macro_def","","",185,[[["self"],["mark"]],["defid"]]],[11,"add_parent_module_of_macro_def","","",185,[[["self"],["mark"],["defid"]]]],[11,"get_opt_name","","",190,[[["self"]],["option",["internedstring"]]]],[11,"as_interned_str","","",190,[[["self"]],["internedstring"]]],[11,"to_string","","",190,[[["self"]],["string"]]],[11,"clone","","",191,[[["self"]],["globalmetadatakind"]]],[11,"fmt","","",191,[[["self"],["formatter"]],["result"]]],[11,"hash","","",191,N],[11,"encode","","",191,[[["self"],["__s"]],["result"]]],[11,"decode","","",191,[[["__d"]],["result",["globalmetadatakind"]]]],[11,"allocate_def_indices","","",191,[[["definitions"]]]],[11,"def_index","","",191,[[["self"],["defpathtable"]],["defindex"]]],[11,"name","","",191,[[["self"]],["symbol"]]],[0,"hir_id_validator","rustc::hir::map","",N,N],[3,"HirIdValidator","rustc::hir::map::hir_id_validator","",N,N],[12,"hir_map","","",192,N],[12,"owner_def_index","","",192,N],[12,"hir_ids_seen","","",192,N],[12,"errors","","",192,N],[3,"OuterVisitor","","",N,N],[12,"hir_map","","",193,N],[12,"errors","","",193,N],[5,"check_crate","","",N,[[["map"]]]],[11,"new_inner_visitor","","",193,[[["self"],["map"]],["hiridvalidator"]]],[11,"visit_item","","",193,[[["self"],["item"]]]],[11,"visit_trait_item","","",193,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",193,[[["self"],["implitem"]]]],[11,"check","","",192,[[["self"],["nodeid"],["f"]]]],[11,"nested_visit_map","","",192,[[["self"]],["nestedvisitormap"]]],[11,"visit_id","","",192,[[["self"],["nodeid"]]]],[11,"visit_impl_item_ref","","",192,[[["self"],["implitemref"]]]],[17,"ITEM_LIKE_SPACE","rustc::hir::map","",N,N],[17,"REGULAR_SPACE","","",N,N],[8,"Named","","",N,N],[10,"name","","",194,[[["self"]],["name"]]],[11,"clone","","",173,[[["self"]],["entry"]]],[11,"fmt","","",173,[[["self"],["formatter"]],["result"]]],[11,"parent_node","","",173,[[["self"]],["option",["nodeid"]]]],[11,"fn_decl","","",173,[[["self"]],["option",["fndecl"]]]],[11,"associated_body","","",173,[[["self"]],["option",["bodyid"]]]],[11,"is_body_owner","","",173,[[["self"],["nodeid"]],["bool"]]],[11,"new","","",174,[[["crate"],["depgraph"]],["forest"]]],[11,"krate","","",174,[[["self"]],["crate"]]],[11,"clone","","",175,[[["self"]],["map"]]],[11,"read","","Registers a read in the dependency graph of the AST node with the given `id`. This needs to be called each time a public function returns the HIR for a node -- in other words, when it \"reveals\" the content of a node to the caller (who might not otherwise have had access to those contents, and hence needs a read recorded). If the function just returns a DefId or NodeId, no actual content was returned, so no read is needed.",175,[[["self"],["nodeid"]]]],[11,"definitions","","",175,[[["self"]],["definitions"]]],[11,"def_key","","",175,[[["self"],["defid"]],["defkey"]]],[11,"def_path_from_id","","",175,[[["self"],["nodeid"]],["option",["defpath"]]]],[11,"def_path","","",175,[[["self"],["defid"]],["defpath"]]],[11,"local_def_id","","",175,[[["self"],["nodeid"]],["defid"]]],[11,"opt_local_def_id","","",175,[[["self"],["nodeid"]],["option",["defid"]]]],[11,"as_local_node_id","","",175,[[["self"],["defid"]],["option",["nodeid"]]]],[11,"hir_to_node_id","","",175,[[["self"],["hirid"]],["nodeid"]]],[11,"node_to_hir_id","","",175,[[["self"],["nodeid"]],["hirid"]]],[11,"def_index_to_hir_id","","",175,[[["self"],["defindex"]],["hirid"]]],[11,"def_index_to_node_id","","",175,[[["self"],["defindex"]],["nodeid"]]],[11,"local_def_id_to_hir_id","","",175,[[["self"],["localdefid"]],["hirid"]]],[11,"local_def_id_to_node_id","","",175,[[["self"],["localdefid"]],["nodeid"]]],[11,"describe_def","","",175,[[["self"],["nodeid"]],["option",["def"]]]],[11,"entry_count","","",175,[[["self"]],["usize"]]],[11,"find_entry","","",175,[[["self"],["nodeid"]],["option",["entry"]]]],[11,"krate","","",175,[[["self"]],["crate"]]],[11,"trait_item","","",175,[[["self"],["traititemid"]],["traititem"]]],[11,"impl_item","","",175,[[["self"],["implitemid"]],["implitem"]]],[11,"body","","",175,[[["self"],["bodyid"]],["body"]]],[11,"fn_decl","","",175,[[["self"],["nodeid"]],["option",["fndecl"]]]],[11,"body_owner","","Returns the `NodeId` that corresponds to the definition of which this is the body of, i.e. a `fn`, `const` or `static` item (possibly associated), a closure, or a `hir::AnonConst`.",175,[[["self"],["bodyid"]],["nodeid"]]],[11,"body_owner_def_id","","",175,[[["self"],["bodyid"]],["defid"]]],[11,"maybe_body_owned_by","","Given a node id, returns the `BodyId` associated with it, if the node is a body owner, otherwise returns `None`.",175,[[["self"],["nodeid"]],["option",["bodyid"]]]],[11,"body_owned_by","","Given a body owner's id, returns the `BodyId` associated with it.",175,[[["self"],["nodeid"]],["bodyid"]]],[11,"body_owner_kind","","",175,[[["self"],["nodeid"]],["bodyownerkind"]]],[11,"ty_param_owner","","",175,[[["self"],["nodeid"]],["nodeid"]]],[11,"ty_param_name","","",175,[[["self"],["nodeid"]],["name"]]],[11,"trait_impls","","",175,N],[11,"trait_auto_impl","","",175,[[["self"],["defid"]],["option",["nodeid"]]]],[11,"trait_is_auto","","",175,[[["self"],["defid"]],["bool"]]],[11,"krate_attrs","","Get the attributes on the krate. This is preferable to invoking `krate.attrs` because it registers a tighter dep-graph access.",175,N],[11,"get","","Retrieve the Node corresponding to `id`, panicking if it cannot be found.",175,[[["self"],["nodeid"]],["node"]]],[11,"get_if_local","","",175,[[["self"],["defid"]],["option",["node"]]]],[11,"get_generics","","",175,[[["self"],["defid"]],["option",["generics"]]]],[11,"get_generics_span","","",175,[[["self"],["defid"]],["option",["span"]]]],[11,"find","","Retrieve the Node corresponding to `id`, returning None if cannot be found.",175,[[["self"],["nodeid"]],["option",["node"]]]],[11,"get_parent_node","","Similar to get_parent, returns the parent node id or id if there is no parent. Note that the parent may be CRATE_NODE_ID, which is not itself present in the map -- so passing the return value of get_parent_node to get may actually panic. This function returns the immediate parent in the AST, whereas get_parent returns the enclosing item. Note that this might not be the actual parent node in the AST - some kinds of nodes are not in the map and these will never appear as the parent_node. So you can always walk the parent_nodes from a node to the root of the ast (unless you get the same id back here that can happen if the id is not in the map itself or is just weird).",175,[[["self"],["nodeid"]],["nodeid"]]],[11,"is_argument","","Check if the node is an argument. An argument is a local variable whose immediate parent is an item or a closure.",175,[[["self"],["nodeid"]],["bool"]]],[11,"walk_parent_nodes","","If there is some error when walking the parents (e.g., a node does not have a parent in the map or a node can't be found), then we return the last good node id we found. Note that reaching the crate root (id == 0), is not an error, since items in the crate module have the crate root as parent.",175,[[["self"],["nodeid"],["f"],["f2"]],["result",["nodeid","nodeid"]]]],[11,"get_return_block","","Retrieve the NodeId for `id`'s enclosing method, unless there's a `while` or `loop` before reaching it, as block tail returns are not available in them.",175,[[["self"],["nodeid"]],["option",["nodeid"]]]],[11,"get_parent","","Retrieve the NodeId for `id`'s parent item, or `id` itself if no parent item is in this map. The \"parent item\" is the closest parent node in the HIR which is recorded by the map and is an item, either an item in a module, trait, or impl.",175,[[["self"],["nodeid"]],["nodeid"]]],[11,"get_module_parent","","Returns the NodeId of `id`'s nearest module parent, or `id` itself if no module parent is in this map.",175,[[["self"],["nodeid"]],["defid"]]],[11,"get_enclosing_scope","","Returns the nearest enclosing scope. A scope is an item or block. FIXME it is not clear to me that all items qualify as scopes - statics and associated types probably shouldn't, for example. Behavior in this regard should be expected to be highly unstable.",175,[[["self"],["nodeid"]],["option",["nodeid"]]]],[11,"get_parent_did","","",175,[[["self"],["nodeid"]],["defid"]]],[11,"get_foreign_abi","","",175,[[["self"],["nodeid"]],["abi"]]],[11,"expect_item","","",175,[[["self"],["nodeid"]],["item"]]],[11,"expect_impl_item","","",175,[[["self"],["nodeid"]],["implitem"]]],[11,"expect_trait_item","","",175,[[["self"],["nodeid"]],["traititem"]]],[11,"expect_variant_data","","",175,[[["self"],["nodeid"]],["variantdata"]]],[11,"expect_variant","","",175,[[["self"],["nodeid"]],["variant"]]],[11,"expect_foreign_item","","",175,[[["self"],["nodeid"]],["foreignitem"]]],[11,"expect_expr","","",175,[[["self"],["nodeid"]],["expr"]]],[11,"name","","Returns the name associated with the given NodeId's AST.",175,[[["self"],["nodeid"]],["name"]]],[11,"attrs","","Given a node ID, get a list of attributes associated with the AST corresponding to the Node ID",175,N],[11,"nodes_matching_suffix","","Returns an iterator that yields the node id's with paths that match `parts`.  (Requires `parts` is non-empty.)",175,N],[11,"span","","",175,[[["self"],["nodeid"]],["span"]]],[11,"span_if_local","","",175,[[["self"],["defid"]],["option",["span"]]]],[11,"node_to_string","","",175,[[["self"],["nodeid"]],["string"]]],[11,"node_to_user_string","","",175,[[["self"],["nodeid"]],["string"]]],[11,"node_to_pretty_string","","",175,[[["self"],["nodeid"]],["string"]]],[11,"suffix_matches","","Returns true only if some suffix of the module path for parent matches `self.in_which`.",176,[[["self"],["nodeid"]],["bool"]]],[11,"matches_names","","",176,[[["self"],["nodeid"],["name"]],["bool"]]],[11,"next","","",176,[[["self"]],["option",["nodeid"]]]],[11,"name","rustc::hir","",83,[[["self"]],["name"]]],[11,"name","","",87,[[["self"]],["name"]]],[11,"name","","",78,[[["self"]],["name"]]],[11,"name","","",81,[[["self"]],["name"]]],[11,"name","","",63,[[["self"]],["name"]]],[11,"name","","",65,[[["self"]],["name"]]],[11,"nested","rustc::hir::map","",175,[[["self"],["state"],["nested"]],["result"]]],[0,"pat_util","rustc::hir","",N,N],[3,"EnumerateAndAdjust","rustc::hir::pat_util","",N,N],[12,"enumerate","","",195,N],[12,"gap_pos","","",195,N],[12,"gap_len","","",195,N],[8,"EnumerateAndAdjustIterator","","",N,N],[10,"enumerate_and_adjust","","",196,[[["self"],["usize"],["option",["usize"]]],["enumerateandadjust"]]],[11,"next","","",195,[[["self"]],["option"]]],[11,"size_hint","","",195,N],[11,"is_refutable","rustc::hir","",50,[[["self"]],["bool"]]],[11,"is_const","","",50,[[["self"]],["bool"]]],[11,"each_binding","","Call `f` on every \"binding\" in a pattern, e.g., on `a` in `match foo() { Some(a) => (), None => () }`",50,[[["self"],["f"]]]],[11,"contains_bindings","","Checks if the pattern contains any patterns that bind something to an ident, e.g. `foo`, or `Foo(foo)` or `foo @ Bar(..)`.",50,[[["self"]],["bool"]]],[11,"contains_bindings_or_wild","","Checks if the pattern contains any patterns that bind something to an ident or wildcard, e.g. `foo`, or `Foo(_)`, `foo @ Bar(..)`,",50,[[["self"]],["bool"]]],[11,"simple_ident","","",50,[[["self"]],["option",["ident"]]]],[11,"necessary_variants","","Return variants that are necessary to exist for the pattern to match.",50,[[["self"]],["vec",["defid"]]]],[11,"contains_explicit_ref_binding","","Checks if the pattern contains any `ref` or `ref mut` bindings, and if yes whether it contains mutable or just immutables ones.",50,[[["self"]],["option",["mutability"]]]],[11,"contains_explicit_ref_binding","","Checks if the patterns for this arm contain any `ref` or `ref mut` bindings, and if yes whether its containing mutable ones or just immutables ones.",53,[[["self"]],["option",["mutability"]]]],[0,"print","","",N,N],[3,"NoAnn","rustc::hir::print","",N,N],[3,"State","","",N,N],[12,"s","","",197,N],[12,"cm","","",197,N],[12,"comments","","",197,N],[12,"literals","","",197,N],[12,"cur_cmnt","","",197,N],[12,"boxes","","",197,N],[12,"ann","","",197,N],[4,"AnnNode","","",N,N],[13,"Name","","",198,N],[13,"Block","","",198,N],[13,"Item","","",198,N],[13,"SubItem","","",198,N],[13,"Expr","","",198,N],[13,"Pat","","",198,N],[4,"Nested","","",N,N],[13,"Item","","",199,N],[13,"TraitItem","","",199,N],[13,"ImplItem","","",199,N],[13,"Body","","",199,N],[13,"BodyArgPat","","",199,N],[5,"print_crate","","Requires you to pass an input filename and reader so that it can scan the input text for comments and literals to copy forward.",N,[[["sourcemap"],["parsesess"],["crate"],["filename"],["read"],["box",["write"]],["ppann"],["bool"]],["result"]]],[5,"to_string","","",N,[[["ppann"],["f"]],["string"]]],[5,"visibility_qualified","","",N,[[["visibility"],["str"]],["string"]]],[5,"expr_requires_semi_to_be_stmt","","Does this expression require a semicolon to be treated as a statement? The negation of this: 'can this expression be used as a statement without a semicolon' -- is used as an early-bail-out in the parser so that, for instance,     if true {...} else {...}      |x| 5 isn't parsed as (if true {...} else {...} | x) | 5",N,[[["expr"]],["bool"]]],[5,"stmt_ends_with_semi","","this statement requires a semicolon after it. note that in one case (stmt_semi), we've already seen the semicolon, and thus don't need another.",N,[[["stmtkind"]],["bool"]]],[5,"bin_op_to_assoc_op","","",N,[[["binopkind"]],["assocop"]]],[5,"contains_exterior_struct_lit","","Expressions that syntactically contain an \"exterior\" struct literal i.e. not surrounded by any parens or other delimiters, e.g. `X { y: 1 }`, `X { y: 1 }.method()`, `foo == X { y: 1 }` and `X { y: 1 } == foo` all do, but `(X { y: 1 }) == foo` does not.",N,[[["expr"]],["bool"]]],[17,"NO_ANN","","",N,N],[17,"indent_unit","","",N,N],[17,"default_columns","","",N,N],[8,"PpAnn","","",N,N],[11,"nested","","",200,[[["self"],["state"],["nested"]],["result"]]],[11,"pre","","",200,[[["self"],["state"],["annnode"]],["result"]]],[11,"post","","",200,[[["self"],["state"],["annnode"]],["result"]]],[11,"try_fetch_item","","",200,[[["self"],["nodeid"]],["option",["item"]]]],[11,"try_fetch_item","rustc::hir","",47,[[["self"],["nodeid"]],["option",["item"]]]],[11,"nested","","",47,[[["self"],["state"],["nested"]],["result"]]],[11,"writer","rustc::hir::print","",197,[[["self"]],["printer"]]],[11,"boxes","","",197,[[["self"]],["vec"]]],[11,"comments","","",197,[[["self"]],["option"]]],[11,"cur_cmnt","","",197,[[["self"]],["usize"]]],[11,"cur_lit","","",197,[[["self"]],["option",["literal"]]]],[11,"bump_lit","","",197,[[["self"]],["option",["literal"]]]],[11,"new_from_input","","",197,[[["sourcemap"],["parsesess"],["filename"],["read"],["box",["write"]],["ppann"],["bool"]],["state"]]],[11,"new","","",197,[[["sourcemap"],["box",["write"]],["ppann"],["option",["vec"]],["option",["vec"]]],["state"]]],[11,"cbox","","",197,[[["self"],["usize"]],["result"]]],[11,"nbsp","","",197,[[["self"]],["result"]]],[11,"word_nbsp","","",197,[[["self"],["str"]],["result"]]],[11,"head","","",197,[[["self"],["str"]],["result"]]],[11,"bopen","","",197,[[["self"]],["result"]]],[11,"bclose_","","",197,[[["self"],["span"],["usize"]],["result"]]],[11,"bclose_maybe_open","","",197,[[["self"],["span"],["usize"],["bool"]],["result"]]],[11,"bclose","","",197,[[["self"],["span"]],["result"]]],[11,"in_cbox","","",197,[[["self"]],["bool"]]],[11,"space_if_not_bol","","",197,[[["self"]],["result"]]],[11,"break_offset_if_not_bol","","",197,[[["self"],["usize"],["isize"]],["result"]]],[11,"synth_comment","","",197,[[["self"],["string"]],["result"]]],[11,"commasep_cmnt","","",197,N],[11,"commasep_exprs","","",197,N],[11,"print_mod","","",197,N],[11,"print_foreign_mod","","",197,N],[11,"print_opt_lifetime","","",197,[[["self"],["lifetime"]],["result"]]],[11,"print_type","","",197,[[["self"],["ty"]],["result"]]],[11,"print_foreign_item","","",197,[[["self"],["foreignitem"]],["result"]]],[11,"print_associated_const","","",197,[[["self"],["ident"],["ty"],["option",["bodyid"]],["visibility"]],["result"]]],[11,"print_associated_type","","",197,[[["self"],["ident"],["option",["genericbounds"]],["option",["ty"]]],["result"]]],[11,"print_item","","Pretty-print an item",197,[[["self"],["item"]],["result"]]],[11,"print_trait_ref","","",197,[[["self"],["traitref"]],["result"]]],[11,"print_formal_generic_params","","",197,N],[11,"print_poly_trait_ref","","",197,[[["self"],["polytraitref"]],["result"]]],[11,"print_enum_def","","",197,[[["self"],["enumdef"],["generics"],["name"],["span"],["visibility"]],["result"]]],[11,"print_variants","","",197,N],[11,"print_visibility","","",197,[[["self"],["visibility"]],["result"]]],[11,"print_defaultness","","",197,[[["self"],["defaultness"]],["result"]]],[11,"print_struct","","",197,[[["self"],["variantdata"],["generics"],["name"],["span"],["bool"]],["result"]]],[11,"print_variant","","",197,[[["self"],["variant"]],["result"]]],[11,"print_method_sig","","",197,N],[11,"print_trait_item","","",197,[[["self"],["traititem"]],["result"]]],[11,"print_impl_item","","",197,[[["self"],["implitem"]],["result"]]],[11,"print_stmt","","",197,[[["self"],["stmt"]],["result"]]],[11,"print_block","","",197,[[["self"],["block"]],["result"]]],[11,"print_block_unclosed","","",197,[[["self"],["block"]],["result"]]],[11,"print_block_unclosed_indent","","",197,[[["self"],["block"],["usize"]],["result"]]],[11,"print_block_with_attrs","","",197,N],[11,"print_block_maybe_unclosed","","",197,N],[11,"print_else","","",197,[[["self"],["option",["expr"]]],["result"]]],[11,"print_if","","",197,[[["self"],["expr"],["expr"],["option",["expr"]]],["result"]]],[11,"print_if_let","","",197,[[["self"],["pat"],["expr"],["block"],["option",["expr"]]],["result"]]],[11,"print_anon_const","","",197,[[["self"],["anonconst"]],["result"]]],[11,"print_call_post","","",197,N],[11,"print_expr_maybe_paren","","",197,[[["self"],["expr"],["i8"]],["result"]]],[11,"print_expr_as_cond","","Print an expr using syntax that's acceptable in a condition position, such as the `cond` in `if cond { ... }`.",197,[[["self"],["expr"]],["result"]]],[11,"print_expr_vec","","",197,N],[11,"print_expr_repeat","","",197,[[["self"],["expr"],["anonconst"]],["result"]]],[11,"print_expr_struct","","",197,N],[11,"print_expr_tup","","",197,N],[11,"print_expr_call","","",197,N],[11,"print_expr_method_call","","",197,N],[11,"print_expr_binary","","",197,[[["self"],["binop"],["expr"],["expr"]],["result"]]],[11,"print_expr_unary","","",197,[[["self"],["unop"],["expr"]],["result"]]],[11,"print_expr_addr_of","","",197,[[["self"],["mutability"],["expr"]],["result"]]],[11,"print_expr","","",197,[[["self"],["expr"]],["result"]]],[11,"print_local_decl","","",197,[[["self"],["local"]],["result"]]],[11,"print_decl","","",197,[[["self"],["decl"]],["result"]]],[11,"print_usize","","",197,[[["self"],["usize"]],["result"]]],[11,"print_ident","","",197,[[["self"],["ident"]],["result"]]],[11,"print_name","","",197,[[["self"],["name"]],["result"]]],[11,"print_for_decl","","",197,[[["self"],["local"],["expr"]],["result"]]],[11,"print_path","","",197,[[["self"],["path"],["bool"]],["result"]]],[11,"print_qpath","","",197,[[["self"],["qpath"],["bool"]],["result"]]],[11,"print_generic_args","","",197,[[["self"],["genericargs"],["bool"],["bool"]],["result"]]],[11,"print_pat","","",197,[[["self"],["pat"]],["result"]]],[11,"print_arm","","",197,[[["self"],["arm"]],["result"]]],[11,"print_fn","","",197,N],[11,"print_closure_args","","",197,[[["self"],["fndecl"],["bodyid"]],["result"]]],[11,"print_capture_clause","","",197,[[["self"],["captureclause"]],["result"]]],[11,"print_bounds","","",197,N],[11,"print_generic_params","","",197,N],[11,"print_generic_param","","",197,[[["self"],["genericparam"]],["result"]]],[11,"print_lifetime","","",197,[[["self"],["lifetime"]],["result"]]],[11,"print_where_clause","","",197,[[["self"],["whereclause"]],["result"]]],[11,"print_mutability","","",197,[[["self"],["mutability"]],["result"]]],[11,"print_mt","","",197,[[["self"],["mutty"]],["result"]]],[11,"print_fn_output","","",197,[[["self"],["fndecl"]],["result"]]],[11,"print_ty_fn","","",197,N],[11,"maybe_print_trailing_comment","","",197,[[["self"],["span"],["option",["bytepos"]]],["result"]]],[11,"print_remaining_comments","","",197,[[["self"]],["result"]]],[11,"print_opt_abi_and_extern_if_nondefault","","",197,[[["self"],["option",["abi"]]],["result"]]],[11,"print_extern_opt_abi","","",197,[[["self"],["option",["abi"]]],["result"]]],[11,"print_fn_header_info","","",197,[[["self"],["fnheader"],["visibility"]],["result"]]],[11,"print_unsafety","","",197,[[["self"],["unsafety"]],["result"]]],[11,"print_is_auto","","",197,[[["self"],["isauto"]],["result"]]],[6,"HirVec","rustc::hir","HIR doesn't commit to a concrete storage type and has its own alias for a vector. It can be `Vec`, `P<[T]>` or potentially `Box<[T]>`, or some other container with similar behavior. Unlike AST, HIR is mostly a static structure, so we can use an owned slice instead of `Vec` to avoid keeping extra capacity.",N,N],[6,"GenericBounds","","",N,N],[6,"CrateConfig","","",N,N],[6,"BinOp","","",N,N],[6,"Stmt","","A statement",N,N],[6,"Decl","","",N,N],[6,"Variant","","",N,N],[6,"Visibility","","",N,N],[6,"FreevarMap","","",N,N],[6,"CaptureModeMap","","",N,N],[6,"TraitMap","","",N,N],[6,"GlobMap","","",N,N],[17,"CRATE_HIR_ID","","The `HirId` corresponding to CRATE_NODE_ID and CRATE_DEF_INDEX",N,N],[17,"DUMMY_HIR_ID","","",N,N],[17,"DUMMY_ITEM_LOCAL_ID","","",N,N],[11,"clone","","",33,[[["self"]],["hirid"]]],[11,"eq","","",33,[[["self"],["hirid"]],["bool"]]],[11,"ne","","",33,[[["self"],["hirid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",33,N],[11,"hash","","",33,N],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"owner_def_id","","",33,[[["self"]],["defid"]]],[11,"owner_local_def_id","","",33,[[["self"]],["localdefid"]]],[11,"default_encode","","",33,[[["self"],["s"]],["result"]]],[11,"default_decode","","",33,[[["d"]],["result",["hirid"]]]],[11,"clone","","",34,[[["self"]],["itemlocalid"]]],[11,"eq","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"ne","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",34,N],[11,"partial_cmp","","",34,[[["self"],["itemlocalid"]],["option",["ordering"]]]],[11,"lt","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"le","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"gt","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"ge","","",34,[[["self"],["itemlocalid"]],["bool"]]],[11,"cmp","","",34,[[["self"],["itemlocalid"]],["ordering"]]],[11,"hash","","",34,N],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"encode","","",34,[[["self"],["__s"]],["result"]]],[11,"decode","","",34,[[["__d"]],["result",["itemlocalid"]]]],[11,"as_usize","","",34,[[["self"]],["usize"]]],[11,"new","","",34,[[["usize"]],["self"]]],[11,"index","","",34,[[["self"]],["usize"]]],[11,"clone","","",35,[[["self"]],["label"]]],[11,"encode","","",35,[[["self"],["__s"]],["result"]]],[11,"decode","","",35,[[["__d"]],["result",["label"]]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"clone","","",36,[[["self"]],["lifetime"]]],[11,"encode","","",36,[[["self"],["__s"]],["result"]]],[11,"decode","","",36,[[["__d"]],["result",["lifetime"]]]],[11,"fmt","","",92,[[["self"],["formatter"]],["result"]]],[11,"clone","","",92,[[["self"]],["paramname"]]],[11,"eq","","",92,[[["self"],["paramname"]],["bool"]]],[11,"ne","","",92,[[["self"],["paramname"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",92,N],[11,"encode","","",92,[[["self"],["__s"]],["result"]]],[11,"decode","","",92,[[["__d"]],["result",["paramname"]]]],[11,"hash","","",92,N],[11,"ident","","",92,[[["self"]],["ident"]]],[11,"modern","","",92,[[["self"]],["paramname"]]],[11,"fmt","","",93,[[["self"],["formatter"]],["result"]]],[11,"clone","","",93,[[["self"]],["lifetimename"]]],[11,"eq","","",93,[[["self"],["lifetimename"]],["bool"]]],[11,"ne","","",93,[[["self"],["lifetimename"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",93,N],[11,"encode","","",93,[[["self"],["__s"]],["result"]]],[11,"decode","","",93,[[["__d"]],["result",["lifetimename"]]]],[11,"hash","","",93,N],[11,"ident","","",93,[[["self"]],["ident"]]],[11,"is_elided","","",93,[[["self"]],["bool"]]],[11,"is_static","","",93,[[["self"]],["bool"]]],[11,"modern","","",93,[[["self"]],["lifetimename"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"is_elided","","",36,[[["self"]],["bool"]]],[11,"is_static","","",36,[[["self"]],["bool"]]],[11,"clone","","",37,[[["self"]],["path"]]],[11,"encode","","",37,[[["self"],["__s"]],["result"]]],[11,"decode","","",37,[[["__d"]],["result",["path"]]]],[11,"is_global","","",37,[[["self"]],["bool"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"clone","","",38,[[["self"]],["pathsegment"]]],[11,"encode","","",38,[[["self"],["__s"]],["result"]]],[11,"decode","","",38,[[["__d"]],["result",["pathsegment"]]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"from_ident","","Convert an identifier to the corresponding segment.",38,[[["ident"]],["pathsegment"]]],[11,"new","","",38,[[["ident"],["genericargs"],["bool"]],["self"]]],[11,"with_generic_args","","",38,[[["self"],["f"]],["r"]]],[11,"clone","","",94,[[["self"]],["genericarg"]]],[11,"encode","","",94,[[["self"],["__s"]],["result"]]],[11,"decode","","",94,[[["__d"]],["result",["genericarg"]]]],[11,"fmt","","",94,[[["self"],["formatter"]],["result"]]],[11,"span","","",94,[[["self"]],["span"]]],[11,"id","","",94,[[["self"]],["nodeid"]]],[11,"clone","","",39,[[["self"]],["genericargs"]]],[11,"encode","","",39,[[["self"],["__s"]],["result"]]],[11,"decode","","",39,[[["__d"]],["result",["genericargs"]]]],[11,"fmt","","",39,[[["self"],["formatter"]],["result"]]],[11,"none","","",39,[[],["self"]]],[11,"is_empty","","",39,[[["self"]],["bool"]]],[11,"inputs","","",39,N],[11,"own_counts","","",39,[[["self"]],["genericparamcount"]]],[11,"clone","","",95,[[["self"]],["traitboundmodifier"]]],[11,"eq","","",95,[[["self"],["traitboundmodifier"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",95,N],[11,"encode","","",95,[[["self"],["__s"]],["result"]]],[11,"decode","","",95,[[["__d"]],["result",["traitboundmodifier"]]]],[11,"hash","","",95,N],[11,"fmt","","",95,[[["self"],["formatter"]],["result"]]],[11,"clone","","",96,[[["self"]],["genericbound"]]],[11,"encode","","",96,[[["self"],["__s"]],["result"]]],[11,"decode","","",96,[[["__d"]],["result",["genericbound"]]]],[11,"fmt","","",96,[[["self"],["formatter"]],["result"]]],[11,"span","","",96,[[["self"]],["span"]]],[11,"clone","","",97,[[["self"]],["genericparamkind"]]],[11,"encode","","",97,[[["self"],["__s"]],["result"]]],[11,"decode","","",97,[[["__d"]],["result",["genericparamkind"]]]],[11,"fmt","","",97,[[["self"],["formatter"]],["result"]]],[11,"clone","","",40,[[["self"]],["genericparam"]]],[11,"encode","","",40,[[["self"],["__s"]],["result"]]],[11,"decode","","",40,[[["__d"]],["result",["genericparam"]]]],[11,"fmt","","",40,[[["self"],["formatter"]],["result"]]],[11,"default","","",41,[[],["genericparamcount"]]],[11,"clone","","",42,[[["self"]],["generics"]]],[11,"encode","","",42,[[["self"],["__s"]],["result"]]],[11,"decode","","",42,[[["__d"]],["result",["generics"]]]],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"empty","","",42,[[],["generics"]]],[11,"own_counts","","",42,[[["self"]],["genericparamcount"]]],[11,"get_named","","",42,[[["self"],["internedstring"]],["option",["genericparam"]]]],[11,"clone","","",98,[[["self"]],["synthetictyparamkind"]]],[11,"eq","","",98,[[["self"],["synthetictyparamkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",98,N],[11,"encode","","",98,[[["self"],["__s"]],["result"]]],[11,"decode","","",98,[[["__d"]],["result",["synthetictyparamkind"]]]],[11,"hash","","",98,N],[11,"fmt","","",98,[[["self"],["formatter"]],["result"]]],[11,"clone","","",43,[[["self"]],["whereclause"]]],[11,"encode","","",43,[[["self"],["__s"]],["result"]]],[11,"decode","","",43,[[["__d"]],["result",["whereclause"]]]],[11,"fmt","","",43,[[["self"],["formatter"]],["result"]]],[11,"span","","",43,[[["self"]],["option",["span"]]]],[11,"clone","","",99,[[["self"]],["wherepredicate"]]],[11,"encode","","",99,[[["self"],["__s"]],["result"]]],[11,"decode","","",99,[[["__d"]],["result",["wherepredicate"]]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result"]]],[11,"span","","",99,[[["self"]],["span"]]],[11,"clone","","",44,[[["self"]],["whereboundpredicate"]]],[11,"encode","","",44,[[["self"],["__s"]],["result"]]],[11,"decode","","",44,[[["__d"]],["result",["whereboundpredicate"]]]],[11,"fmt","","",44,[[["self"],["formatter"]],["result"]]],[11,"clone","","",45,[[["self"]],["whereregionpredicate"]]],[11,"encode","","",45,[[["self"],["__s"]],["result"]]],[11,"decode","","",45,[[["__d"]],["result",["whereregionpredicate"]]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"clone","","",46,[[["self"]],["whereeqpredicate"]]],[11,"encode","","",46,[[["self"],["__s"]],["result"]]],[11,"decode","","",46,[[["__d"]],["result",["whereeqpredicate"]]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"clone","","",47,[[["self"]],["crate"]]],[11,"encode","","",47,[[["self"],["__s"]],["result"]]],[11,"decode","","",47,[[["__d"]],["result",["crate"]]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"item","","",47,[[["self"],["nodeid"]],["item"]]],[11,"trait_item","","",47,[[["self"],["traititemid"]],["traititem"]]],[11,"impl_item","","",47,[[["self"],["implitemid"]],["implitem"]]],[11,"visit_all_item_likes","","Visits all items in the crate in some deterministic (but unspecified) order. If you just need to process every item, but don't care about nesting, this method is the best choice.",47,[[["self"],["v"]]]],[11,"par_visit_all_item_likes","","A parallel version of visit_all_item_likes",47,[[["self"],["v"]]]],[11,"body","","",47,[[["self"],["bodyid"]],["body"]]],[11,"clone","","",48,[[["self"]],["macrodef"]]],[11,"encode","","",48,[[["self"],["__s"]],["result"]]],[11,"decode","","",48,[[["__d"]],["result",["macrodef"]]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"clone","","",49,[[["self"]],["block"]]],[11,"encode","","",49,[[["self"],["__s"]],["result"]]],[11,"decode","","",49,[[["__d"]],["result",["block"]]]],[11,"fmt","","",49,[[["self"],["formatter"]],["result"]]],[11,"clone","","",50,[[["self"]],["pat"]]],[11,"encode","","",50,[[["self"],["__s"]],["result"]]],[11,"decode","","",50,[[["__d"]],["result",["pat"]]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"walk_","","",50,[[["self"],["g"]],["bool"]]],[11,"walk","","",50,[[["self"],["f"]],["bool"]]],[11,"clone","","",51,[[["self"]],["fieldpat"]]],[11,"encode","","",51,[[["self"],["__s"]],["result"]]],[11,"decode","","",51,[[["__d"]],["result",["fieldpat"]]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"clone","","",100,[[["self"]],["bindingannotation"]]],[11,"eq","","",100,[[["self"],["bindingannotation"]],["bool"]]],[11,"encode","","",100,[[["self"],["__s"]],["result"]]],[11,"decode","","",100,[[["__d"]],["result",["bindingannotation"]]]],[11,"fmt","","",100,[[["self"],["formatter"]],["result"]]],[11,"clone","","",101,[[["self"]],["rangeend"]]],[11,"eq","","",101,[[["self"],["rangeend"]],["bool"]]],[11,"encode","","",101,[[["self"],["__s"]],["result"]]],[11,"decode","","",101,[[["__d"]],["result",["rangeend"]]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result"]]],[11,"clone","","",102,[[["self"]],["patkind"]]],[11,"encode","","",102,[[["self"],["__s"]],["result"]]],[11,"decode","","",102,[[["__d"]],["result",["patkind"]]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result"]]],[11,"clone","","",103,[[["self"]],["mutability"]]],[11,"eq","","",103,[[["self"],["mutability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",103,N],[11,"partial_cmp","","",103,[[["self"],["mutability"]],["option",["ordering"]]]],[11,"cmp","","",103,[[["self"],["mutability"]],["ordering"]]],[11,"encode","","",103,[[["self"],["__s"]],["result"]]],[11,"decode","","",103,[[["__d"]],["result",["mutability"]]]],[11,"hash","","",103,N],[11,"fmt","","",103,[[["self"],["formatter"]],["result"]]],[11,"and","","Return MutMutable only if both arguments are mutable.",103,[[["self"],["self"]],["self"]]],[11,"clone","","",104,[[["self"]],["binopkind"]]],[11,"eq","","",104,[[["self"],["binopkind"]],["bool"]]],[11,"encode","","",104,[[["self"],["__s"]],["result"]]],[11,"decode","","",104,[[["__d"]],["result",["binopkind"]]]],[11,"fmt","","",104,[[["self"],["formatter"]],["result"]]],[11,"hash","","",104,N],[11,"as_str","","",104,[[["self"]],["str"]]],[11,"is_lazy","","",104,[[["self"]],["bool"]]],[11,"is_shift","","",104,[[["self"]],["bool"]]],[11,"is_comparison","","",104,[[["self"]],["bool"]]],[11,"is_by_value","","Returns `true` if the binary operator takes its arguments by value",104,[[["self"]],["bool"]]],[11,"into","","",104,[[["self"]],["binopkind"]]],[11,"clone","","",105,[[["self"]],["unop"]]],[11,"eq","","",105,[[["self"],["unop"]],["bool"]]],[11,"encode","","",105,[[["self"],["__s"]],["result"]]],[11,"decode","","",105,[[["__d"]],["result",["unop"]]]],[11,"fmt","","",105,[[["self"],["formatter"]],["result"]]],[11,"hash","","",105,N],[11,"as_str","","",105,[[["self"]],["str"]]],[11,"is_by_value","","Returns `true` if the unary operator takes its argument by value",105,[[["self"]],["bool"]]],[11,"fmt","","",106,[[["self"],["formatter"]],["result"]]],[11,"clone","","",106,[[["self"]],["stmtkind"]]],[11,"encode","","",106,[[["self"],["__s"]],["result"]]],[11,"decode","","",106,[[["__d"]],["result",["stmtkind"]]]],[11,"attrs","","",106,N],[11,"id","","",106,[[["self"]],["nodeid"]]],[11,"clone","","",52,[[["self"]],["local"]]],[11,"encode","","",52,[[["self"],["__s"]],["result"]]],[11,"decode","","",52,[[["__d"]],["result",["local"]]]],[11,"fmt","","",52,[[["self"],["formatter"]],["result"]]],[11,"clone","","",107,[[["self"]],["declkind"]]],[11,"encode","","",107,[[["self"],["__s"]],["result"]]],[11,"decode","","",107,[[["__d"]],["result",["declkind"]]]],[11,"fmt","","",107,[[["self"],["formatter"]],["result"]]],[11,"attrs","","",107,N],[11,"is_local","","",107,[[["self"]],["bool"]]],[11,"clone","","",53,[[["self"]],["arm"]]],[11,"encode","","",53,[[["self"],["__s"]],["result"]]],[11,"decode","","",53,[[["__d"]],["result",["arm"]]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"clone","","",108,[[["self"]],["guard"]]],[11,"encode","","",108,[[["self"],["__s"]],["result"]]],[11,"decode","","",108,[[["__d"]],["result",["guard"]]]],[11,"fmt","","",108,[[["self"],["formatter"]],["result"]]],[11,"clone","","",54,[[["self"]],["field"]]],[11,"encode","","",54,[[["self"],["__s"]],["result"]]],[11,"decode","","",54,[[["__d"]],["result",["field"]]]],[11,"fmt","","",54,[[["self"],["formatter"]],["result"]]],[11,"clone","","",109,[[["self"]],["blockcheckmode"]]],[11,"eq","","",109,[[["self"],["blockcheckmode"]],["bool"]]],[11,"ne","","",109,[[["self"],["blockcheckmode"]],["bool"]]],[11,"encode","","",109,[[["self"],["__s"]],["result"]]],[11,"decode","","",109,[[["__d"]],["result",["blockcheckmode"]]]],[11,"fmt","","",109,[[["self"],["formatter"]],["result"]]],[11,"clone","","",110,[[["self"]],["unsafesource"]]],[11,"eq","","",110,[[["self"],["unsafesource"]],["bool"]]],[11,"encode","","",110,[[["self"],["__s"]],["result"]]],[11,"decode","","",110,[[["__d"]],["result",["unsafesource"]]]],[11,"fmt","","",110,[[["self"],["formatter"]],["result"]]],[11,"clone","","",55,[[["self"]],["bodyid"]]],[11,"eq","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"ne","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",55,N],[11,"partial_cmp","","",55,[[["self"],["bodyid"]],["option",["ordering"]]]],[11,"lt","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"le","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"gt","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"ge","","",55,[[["self"],["bodyid"]],["bool"]]],[11,"cmp","","",55,[[["self"],["bodyid"]],["ordering"]]],[11,"encode","","",55,[[["self"],["__s"]],["result"]]],[11,"decode","","",55,[[["__d"]],["result",["bodyid"]]]],[11,"hash","","",55,N],[11,"fmt","","",55,[[["self"],["formatter"]],["result"]]],[11,"clone","","",56,[[["self"]],["body"]]],[11,"encode","","",56,[[["self"],["__s"]],["result"]]],[11,"decode","","",56,[[["__d"]],["result",["body"]]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"id","","",56,[[["self"]],["bodyid"]]],[11,"clone","","",111,[[["self"]],["bodyownerkind"]]],[11,"fmt","","",111,[[["self"],["formatter"]],["result"]]],[11,"clone","","",57,[[["self"]],["anonconst"]]],[11,"eq","","",57,[[["self"],["anonconst"]],["bool"]]],[11,"ne","","",57,[[["self"],["anonconst"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",57,N],[11,"encode","","",57,[[["self"],["__s"]],["result"]]],[11,"decode","","",57,[[["__d"]],["result",["anonconst"]]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"clone","","",58,[[["self"]],["expr"]]],[11,"encode","","",58,[[["self"],["__s"]],["result"]]],[11,"decode","","",58,[[["__d"]],["result",["expr"]]]],[11,"precedence","","",58,[[["self"]],["exprprecedence"]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result"]]],[11,"clone","","",112,[[["self"]],["exprkind"]]],[11,"encode","","",112,[[["self"],["__s"]],["result"]]],[11,"decode","","",112,[[["__d"]],["result",["exprkind"]]]],[11,"fmt","","",112,[[["self"],["formatter"]],["result"]]],[11,"clone","","",113,[[["self"]],["qpath"]]],[11,"encode","","",113,[[["self"],["__s"]],["result"]]],[11,"decode","","",113,[[["__d"]],["result",["qpath"]]]],[11,"fmt","","",113,[[["self"],["formatter"]],["result"]]],[11,"clone","","",114,[[["self"]],["localsource"]]],[11,"encode","","",114,[[["self"],["__s"]],["result"]]],[11,"decode","","",114,[[["__d"]],["result",["localsource"]]]],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"clone","","",115,[[["self"]],["matchsource"]]],[11,"eq","","",115,[[["self"],["matchsource"]],["bool"]]],[11,"ne","","",115,[[["self"],["matchsource"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",115,N],[11,"encode","","",115,[[["self"],["__s"]],["result"]]],[11,"decode","","",115,[[["__d"]],["result",["matchsource"]]]],[11,"hash","","",115,N],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"clone","","",116,[[["self"]],["loopsource"]]],[11,"eq","","",116,[[["self"],["loopsource"]],["bool"]]],[11,"encode","","",116,[[["self"],["__s"]],["result"]]],[11,"decode","","",116,[[["__d"]],["result",["loopsource"]]]],[11,"fmt","","",116,[[["self"],["formatter"]],["result"]]],[11,"clone","","",117,[[["self"]],["loopiderror"]]],[11,"encode","","",117,[[["self"],["__s"]],["result"]]],[11,"decode","","",117,[[["__d"]],["result",["loopiderror"]]]],[11,"fmt","","",117,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",117,[[["self"],["formatter"]],["result"]]],[11,"clone","","",59,[[["self"]],["destination"]]],[11,"encode","","",59,[[["self"],["__s"]],["result"]]],[11,"decode","","",59,[[["__d"]],["result",["destination"]]]],[11,"fmt","","",59,[[["self"],["formatter"]],["result"]]],[11,"clone","","",118,[[["self"]],["generatormovability"]]],[11,"eq","","",118,[[["self"],["generatormovability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",118,N],[11,"partial_cmp","","",118,[[["self"],["generatormovability"]],["option",["ordering"]]]],[11,"cmp","","",118,[[["self"],["generatormovability"]],["ordering"]]],[11,"encode","","",118,[[["self"],["__s"]],["result"]]],[11,"decode","","",118,[[["__d"]],["result",["generatormovability"]]]],[11,"hash","","",118,N],[11,"fmt","","",118,[[["self"],["formatter"]],["result"]]],[11,"clone","","",119,[[["self"]],["captureclause"]]],[11,"encode","","",119,[[["self"],["__s"]],["result"]]],[11,"decode","","",119,[[["__d"]],["result",["captureclause"]]]],[11,"fmt","","",119,[[["self"],["formatter"]],["result"]]],[11,"clone","","",60,[[["self"]],["mutty"]]],[11,"encode","","",60,[[["self"],["__s"]],["result"]]],[11,"decode","","",60,[[["__d"]],["result",["mutty"]]]],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"clone","","",61,[[["self"]],["methodsig"]]],[11,"encode","","",61,[[["self"],["__s"]],["result"]]],[11,"decode","","",61,[[["__d"]],["result",["methodsig"]]]],[11,"fmt","","",61,[[["self"],["formatter"]],["result"]]],[11,"clone","","",62,[[["self"]],["traititemid"]]],[11,"eq","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"ne","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",62,N],[11,"partial_cmp","","",62,[[["self"],["traititemid"]],["option",["ordering"]]]],[11,"lt","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"le","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"gt","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"ge","","",62,[[["self"],["traititemid"]],["bool"]]],[11,"cmp","","",62,[[["self"],["traititemid"]],["ordering"]]],[11,"encode","","",62,[[["self"],["__s"]],["result"]]],[11,"decode","","",62,[[["__d"]],["result",["traititemid"]]]],[11,"fmt","","",62,[[["self"],["formatter"]],["result"]]],[11,"clone","","",63,[[["self"]],["traititem"]]],[11,"encode","","",63,[[["self"],["__s"]],["result"]]],[11,"decode","","",63,[[["__d"]],["result",["traititem"]]]],[11,"fmt","","",63,[[["self"],["formatter"]],["result"]]],[11,"clone","","",120,[[["self"]],["traitmethod"]]],[11,"encode","","",120,[[["self"],["__s"]],["result"]]],[11,"decode","","",120,[[["__d"]],["result",["traitmethod"]]]],[11,"fmt","","",120,[[["self"],["formatter"]],["result"]]],[11,"clone","","",121,[[["self"]],["traititemkind"]]],[11,"encode","","",121,[[["self"],["__s"]],["result"]]],[11,"decode","","",121,[[["__d"]],["result",["traititemkind"]]]],[11,"fmt","","",121,[[["self"],["formatter"]],["result"]]],[11,"clone","","",64,[[["self"]],["implitemid"]]],[11,"eq","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"ne","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",64,N],[11,"partial_cmp","","",64,[[["self"],["implitemid"]],["option",["ordering"]]]],[11,"lt","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"le","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"gt","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"ge","","",64,[[["self"],["implitemid"]],["bool"]]],[11,"cmp","","",64,[[["self"],["implitemid"]],["ordering"]]],[11,"encode","","",64,[[["self"],["__s"]],["result"]]],[11,"decode","","",64,[[["__d"]],["result",["implitemid"]]]],[11,"fmt","","",64,[[["self"],["formatter"]],["result"]]],[11,"clone","","",65,[[["self"]],["implitem"]]],[11,"encode","","",65,[[["self"],["__s"]],["result"]]],[11,"decode","","",65,[[["__d"]],["result",["implitem"]]]],[11,"fmt","","",65,[[["self"],["formatter"]],["result"]]],[11,"clone","","",122,[[["self"]],["implitemkind"]]],[11,"encode","","",122,[[["self"],["__s"]],["result"]]],[11,"decode","","",122,[[["__d"]],["result",["implitemkind"]]]],[11,"fmt","","",122,[[["self"],["formatter"]],["result"]]],[11,"clone","","",66,[[["self"]],["typebinding"]]],[11,"encode","","",66,[[["self"],["__s"]],["result"]]],[11,"decode","","",66,[[["__d"]],["result",["typebinding"]]]],[11,"fmt","","",66,[[["self"],["formatter"]],["result"]]],[11,"clone","","",67,[[["self"]],["ty"]]],[11,"encode","","",67,[[["self"],["__s"]],["result"]]],[11,"decode","","",67,[[["__d"]],["result",["ty"]]]],[11,"fmt","","",67,[[["self"],["formatter"]],["result"]]],[11,"clone","","",123,[[["self"]],["primty"]]],[11,"eq","","",123,[[["self"],["primty"]],["bool"]]],[11,"ne","","",123,[[["self"],["primty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",123,N],[11,"encode","","",123,[[["self"],["__s"]],["result"]]],[11,"decode","","",123,[[["__d"]],["result",["primty"]]]],[11,"hash","","",123,N],[11,"fmt","","",123,[[["self"],["formatter"]],["result"]]],[11,"clone","","",68,[[["self"]],["barefnty"]]],[11,"encode","","",68,[[["self"],["__s"]],["result"]]],[11,"decode","","",68,[[["__d"]],["result",["barefnty"]]]],[11,"fmt","","",68,[[["self"],["formatter"]],["result"]]],[11,"clone","","",69,[[["self"]],["existty"]]],[11,"encode","","",69,[[["self"],["__s"]],["result"]]],[11,"decode","","",69,[[["__d"]],["result",["existty"]]]],[11,"fmt","","",69,[[["self"],["formatter"]],["result"]]],[11,"clone","","",124,[[["self"]],["tykind"]]],[11,"encode","","",124,[[["self"],["__s"]],["result"]]],[11,"decode","","",124,[[["__d"]],["result",["tykind"]]]],[11,"fmt","","",124,[[["self"],["formatter"]],["result"]]],[11,"clone","","",70,[[["self"]],["inlineasmoutput"]]],[11,"encode","","",70,[[["self"],["__s"]],["result"]]],[11,"decode","","",70,[[["__d"]],["result",["inlineasmoutput"]]]],[11,"fmt","","",70,[[["self"],["formatter"]],["result"]]],[11,"clone","","",71,[[["self"]],["inlineasm"]]],[11,"encode","","",71,[[["self"],["__s"]],["result"]]],[11,"decode","","",71,[[["__d"]],["result",["inlineasm"]]]],[11,"fmt","","",71,[[["self"],["formatter"]],["result"]]],[11,"clone","","",72,[[["self"]],["arg"]]],[11,"encode","","",72,[[["self"],["__s"]],["result"]]],[11,"decode","","",72,[[["__d"]],["result",["arg"]]]],[11,"fmt","","",72,[[["self"],["formatter"]],["result"]]],[11,"clone","","",73,[[["self"]],["fndecl"]]],[11,"encode","","",73,[[["self"],["__s"]],["result"]]],[11,"decode","","",73,[[["__d"]],["result",["fndecl"]]]],[11,"fmt","","",73,[[["self"],["formatter"]],["result"]]],[11,"clone","","",125,[[["self"]],["isauto"]]],[11,"eq","","",125,[[["self"],["isauto"]],["bool"]]],[11,"encode","","",125,[[["self"],["__s"]],["result"]]],[11,"decode","","",125,[[["__d"]],["result",["isauto"]]]],[11,"fmt","","",125,[[["self"],["formatter"]],["result"]]],[11,"clone","","",126,[[["self"]],["isasync"]]],[11,"eq","","",126,[[["self"],["isasync"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",126,N],[11,"partial_cmp","","",126,[[["self"],["isasync"]],["option",["ordering"]]]],[11,"cmp","","",126,[[["self"],["isasync"]],["ordering"]]],[11,"encode","","",126,[[["self"],["__s"]],["result"]]],[11,"decode","","",126,[[["__d"]],["result",["isasync"]]]],[11,"fmt","","",126,[[["self"],["formatter"]],["result"]]],[11,"clone","","",127,[[["self"]],["unsafety"]]],[11,"eq","","",127,[[["self"],["unsafety"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",127,N],[11,"partial_cmp","","",127,[[["self"],["unsafety"]],["option",["ordering"]]]],[11,"cmp","","",127,[[["self"],["unsafety"]],["ordering"]]],[11,"encode","","",127,[[["self"],["__s"]],["result"]]],[11,"decode","","",127,[[["__d"]],["result",["unsafety"]]]],[11,"hash","","",127,N],[11,"fmt","","",127,[[["self"],["formatter"]],["result"]]],[11,"clone","","",128,[[["self"]],["constness"]]],[11,"eq","","",128,[[["self"],["constness"]],["bool"]]],[11,"encode","","",128,[[["self"],["__s"]],["result"]]],[11,"decode","","",128,[[["__d"]],["result",["constness"]]]],[11,"fmt","","",128,[[["self"],["formatter"]],["result"]]],[11,"clone","","",129,[[["self"]],["defaultness"]]],[11,"eq","","",129,[[["self"],["defaultness"]],["bool"]]],[11,"ne","","",129,[[["self"],["defaultness"]],["bool"]]],[11,"encode","","",129,[[["self"],["__s"]],["result"]]],[11,"decode","","",129,[[["__d"]],["result",["defaultness"]]]],[11,"fmt","","",129,[[["self"],["formatter"]],["result"]]],[11,"has_value","","",129,[[["self"]],["bool"]]],[11,"is_final","","",129,[[["self"]],["bool"]]],[11,"is_default","","",129,[[["self"]],["bool"]]],[11,"fmt","","",127,[[["self"],["formatter"]],["result"]]],[11,"clone","","",130,[[["self"]],["implpolarity"]]],[11,"eq","","",130,[[["self"],["implpolarity"]],["bool"]]],[11,"encode","","",130,[[["self"],["__s"]],["result"]]],[11,"decode","","",130,[[["__d"]],["result",["implpolarity"]]]],[11,"fmt","","",130,[[["self"],["formatter"]],["result"]]],[11,"clone","","",131,[[["self"]],["functionretty"]]],[11,"encode","","",131,[[["self"],["__s"]],["result"]]],[11,"decode","","",131,[[["__d"]],["result",["functionretty"]]]],[11,"fmt","","",131,[[["self"],["formatter"]],["result"]]],[11,"span","","",131,[[["self"]],["span"]]],[11,"clone","","",74,[[["self"]],["mod"]]],[11,"encode","","",74,[[["self"],["__s"]],["result"]]],[11,"decode","","",74,[[["__d"]],["result",["mod"]]]],[11,"fmt","","",74,[[["self"],["formatter"]],["result"]]],[11,"clone","","",75,[[["self"]],["foreignmod"]]],[11,"encode","","",75,[[["self"],["__s"]],["result"]]],[11,"decode","","",75,[[["__d"]],["result",["foreignmod"]]]],[11,"fmt","","",75,[[["self"],["formatter"]],["result"]]],[11,"clone","","",76,[[["self"]],["globalasm"]]],[11,"encode","","",76,[[["self"],["__s"]],["result"]]],[11,"decode","","",76,[[["__d"]],["result",["globalasm"]]]],[11,"fmt","","",76,[[["self"],["formatter"]],["result"]]],[11,"clone","","",77,[[["self"]],["enumdef"]]],[11,"encode","","",77,[[["self"],["__s"]],["result"]]],[11,"decode","","",77,[[["__d"]],["result",["enumdef"]]]],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[11,"clone","","",78,[[["self"]],["variantkind"]]],[11,"encode","","",78,[[["self"],["__s"]],["result"]]],[11,"decode","","",78,[[["__d"]],["result",["variantkind"]]]],[11,"fmt","","",78,[[["self"],["formatter"]],["result"]]],[11,"clone","","",132,[[["self"]],["usekind"]]],[11,"eq","","",132,[[["self"],["usekind"]],["bool"]]],[11,"encode","","",132,[[["self"],["__s"]],["result"]]],[11,"decode","","",132,[[["__d"]],["result",["usekind"]]]],[11,"fmt","","",132,[[["self"],["formatter"]],["result"]]],[11,"clone","","",79,[[["self"]],["traitref"]]],[11,"encode","","",79,[[["self"],["__s"]],["result"]]],[11,"decode","","",79,[[["__d"]],["result",["traitref"]]]],[11,"fmt","","",79,[[["self"],["formatter"]],["result"]]],[11,"clone","","",80,[[["self"]],["polytraitref"]]],[11,"encode","","",80,[[["self"],["__s"]],["result"]]],[11,"decode","","",80,[[["__d"]],["result",["polytraitref"]]]],[11,"fmt","","",80,[[["self"],["formatter"]],["result"]]],[11,"clone","","",133,[[["self"]],["visibilitykind"]]],[11,"encode","","",133,[[["self"],["__s"]],["result"]]],[11,"decode","","",133,[[["__d"]],["result",["visibilitykind"]]]],[11,"fmt","","",133,[[["self"],["formatter"]],["result"]]],[11,"is_pub","","",133,[[["self"]],["bool"]]],[11,"is_pub_restricted","","",133,[[["self"]],["bool"]]],[11,"clone","","",81,[[["self"]],["structfield"]]],[11,"encode","","",81,[[["self"],["__s"]],["result"]]],[11,"decode","","",81,[[["__d"]],["result",["structfield"]]]],[11,"fmt","","",81,[[["self"],["formatter"]],["result"]]],[11,"is_positional","","",81,[[["self"]],["bool"]]],[11,"clone","","",134,[[["self"]],["variantdata"]]],[11,"encode","","",134,[[["self"],["__s"]],["result"]]],[11,"decode","","",134,[[["__d"]],["result",["variantdata"]]]],[11,"fmt","","",134,[[["self"],["formatter"]],["result"]]],[11,"fields","","",134,N],[11,"id","","",134,[[["self"]],["nodeid"]]],[11,"is_struct","","",134,[[["self"]],["bool"]]],[11,"is_tuple","","",134,[[["self"]],["bool"]]],[11,"is_unit","","",134,[[["self"]],["bool"]]],[11,"clone","","",82,[[["self"]],["itemid"]]],[11,"encode","","",82,[[["self"],["__s"]],["result"]]],[11,"decode","","",82,[[["__d"]],["result",["itemid"]]]],[11,"fmt","","",82,[[["self"],["formatter"]],["result"]]],[11,"clone","","",83,[[["self"]],["item"]]],[11,"encode","","",83,[[["self"],["__s"]],["result"]]],[11,"decode","","",83,[[["__d"]],["result",["item"]]]],[11,"fmt","","",83,[[["self"],["formatter"]],["result"]]],[11,"clone","","",84,[[["self"]],["fnheader"]]],[11,"encode","","",84,[[["self"],["__s"]],["result"]]],[11,"decode","","",84,[[["__d"]],["result",["fnheader"]]]],[11,"fmt","","",84,[[["self"],["formatter"]],["result"]]],[11,"clone","","",135,[[["self"]],["itemkind"]]],[11,"encode","","",135,[[["self"],["__s"]],["result"]]],[11,"decode","","",135,[[["__d"]],["result",["itemkind"]]]],[11,"fmt","","",135,[[["self"],["formatter"]],["result"]]],[11,"descriptive_variant","","",135,[[["self"]],["str"]]],[11,"adt_kind","","",135,[[["self"]],["option",["adtkind"]]]],[11,"generics","","",135,[[["self"]],["option",["generics"]]]],[11,"clone","","",85,[[["self"]],["traititemref"]]],[11,"encode","","",85,[[["self"],["__s"]],["result"]]],[11,"decode","","",85,[[["__d"]],["result",["traititemref"]]]],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"clone","","",86,[[["self"]],["implitemref"]]],[11,"encode","","",86,[[["self"],["__s"]],["result"]]],[11,"decode","","",86,[[["__d"]],["result",["implitemref"]]]],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[11,"clone","","",136,[[["self"]],["associateditemkind"]]],[11,"eq","","",136,[[["self"],["associateditemkind"]],["bool"]]],[11,"ne","","",136,[[["self"],["associateditemkind"]],["bool"]]],[11,"encode","","",136,[[["self"],["__s"]],["result"]]],[11,"decode","","",136,[[["__d"]],["result",["associateditemkind"]]]],[11,"fmt","","",136,[[["self"],["formatter"]],["result"]]],[11,"clone","","",87,[[["self"]],["foreignitem"]]],[11,"encode","","",87,[[["self"],["__s"]],["result"]]],[11,"decode","","",87,[[["__d"]],["result",["foreignitem"]]]],[11,"fmt","","",87,[[["self"],["formatter"]],["result"]]],[11,"clone","","",137,[[["self"]],["foreignitemkind"]]],[11,"encode","","",137,[[["self"],["__s"]],["result"]]],[11,"decode","","",137,[[["__d"]],["result",["foreignitemkind"]]]],[11,"fmt","","",137,[[["self"],["formatter"]],["result"]]],[11,"descriptive_variant","","",137,[[["self"]],["str"]]],[11,"fmt","","",88,[[["self"],["formatter"]],["result"]]],[11,"clone","","",88,[[["self"]],["freevar"]]],[11,"encode","","",88,[[["self"],["__s"]],["result"]]],[11,"decode","","",88,[[["__d"]],["result",["freevar"]]]],[11,"var_id","","",88,[[["self"]],["nodeid"]]],[11,"clone","","",89,[[["self"]],["traitcandidate"]]],[11,"fmt","","",89,[[["self"],["formatter"]],["result"]]],[11,"clone","","",90,[[["self"]],["codegenfnattrs"]]],[11,"encode","","",90,[[["self"],["__s"]],["result"]]],[11,"decode","","",90,[[["__d"]],["result",["codegenfnattrs"]]]],[11,"eq","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"ne","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",91,N],[11,"clone","","",91,[[["self"]],["codegenfnattrflags"]]],[11,"partial_cmp","","",91,[[["self"],["codegenfnattrflags"]],["option",["ordering"]]]],[11,"lt","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"le","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"gt","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"ge","","",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"cmp","","",91,[[["self"],["codegenfnattrflags"]],["ordering"]]],[11,"hash","","",91,N],[11,"encode","","",91,[[["self"],["__s"]],["result"]]],[11,"decode","","",91,[[["__d"]],["result",["codegenfnattrflags"]]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[18,"COLD","","#[cold], a hint to LLVM that this function, when called, is never on the hot path",91,N],[18,"ALLOCATOR","","#[allocator], a hint to LLVM that the pointer returned from this function is never null",91,N],[18,"UNWIND","","#[unwind], an indicator that this function may unwind despite what its ABI signature may otherwise imply",91,N],[18,"RUSTC_ALLOCATOR_NOUNWIND","","#[rust_allocator_nounwind], an indicator that an imported FFI function will never unwind. Probably obsolete by recent changes with #[unwind], but hasn't been removed/migrated yet",91,N],[18,"NAKED","","#[naked], indicates to LLVM that no function prologue/epilogue should be generated",91,N],[18,"NO_MANGLE","","#[no_mangle], the function's name should be the same as its symbol",91,N],[18,"RUSTC_STD_INTERNAL_SYMBOL","","#[rustc_std_internal_symbol], and indicator that this symbol is a \"weird symbol\" for the standard library in that it has slightly different linkage, visibility, and reachability rules.",91,N],[18,"NO_DEBUG","","#[no_debug], indicates that no debugging information should be generated for this function by LLVM",91,N],[18,"THREAD_LOCAL","","#[thread_local], indicates a static is actually a thread local piece of memory",91,N],[18,"USED","","#[used], indicates that LLVM can't eliminate this function (but the linker can!)",91,N],[11,"empty","","Returns an empty set of flags.",91,[[],["codegenfnattrflags"]]],[11,"all","","Returns the set containing all flags.",91,[[],["codegenfnattrflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",91,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",91,[[["u32"]],["option",["codegenfnattrflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",91,[[["u32"]],["codegenfnattrflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",91,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",91,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",91,[[["self"],["codegenfnattrflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",91,[[["self"],["codegenfnattrflags"]]]],[11,"remove","","Removes the specified flags in-place.",91,[[["self"],["codegenfnattrflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",91,[[["self"],["codegenfnattrflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",91,[[["self"],["codegenfnattrflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",91,[[["self"],["codegenfnattrflags"]],["codegenfnattrflags"]]],[11,"bitor_assign","","Adds the set of flags.",91,[[["self"],["codegenfnattrflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",91,[[["self"],["codegenfnattrflags"]],["codegenfnattrflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",91,[[["self"],["codegenfnattrflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",91,[[["self"],["codegenfnattrflags"]],["codegenfnattrflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",91,[[["self"],["codegenfnattrflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",91,[[["self"],["codegenfnattrflags"]],["codegenfnattrflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",91,[[["self"],["codegenfnattrflags"]]]],[11,"not","","Returns the complement of this set of flags.",91,[[["self"]],["codegenfnattrflags"]]],[11,"extend","","",91,[[["self"],["t"]]]],[11,"from_iter","","",91,[[["t"]],["codegenfnattrflags"]]],[11,"new","","",90,[[],["codegenfnattrs"]]],[11,"requests_inline","","True if `#[inline]` or `#[inline(always)]` is present.",90,[[["self"]],["bool"]]],[11,"contains_extern_indicator","","True if `#[no_mangle]` or `#[export_name(...)]` is present.",90,[[["self"]],["bool"]]],[11,"clone","","",138,[[["self"]],["node"]]],[11,"fmt","","",138,[[["self"],["formatter"]],["result"]]],[0,"ich","rustc","ICH - Incremental Compilation Hash",N,N],[3,"CachingSourceMapView","rustc::ich","",N,N],[12,"source_map","","",201,N],[12,"line_cache","","",201,N],[12,"time_stamp","","",201,N],[3,"StableHashingContext","","This is the context state available during incr. comp. hashing. It contains enough information to transform DefIds and HirIds into stable DefPaths (i.e. a reference to the TyCtxt) and it holds a few caches for speeding up various things (e.g. each DefId/DefPath is only hashed once).",N,N],[12,"sess","","",202,N],[12,"definitions","","",202,N],[12,"cstore","","",202,N],[12,"body_resolver","","",202,N],[12,"hash_spans","","",202,N],[12,"hash_bodies","","",202,N],[12,"node_id_hashing_mode","","",202,N],[12,"raw_source_map","","",202,N],[12,"caching_source_map","","",202,N],[4,"NodeIdHashingMode","","",N,N],[13,"Ignore","","",203,N],[13,"HashDefPath","","",203,N],[5,"hash_stable_trait_impls","","",N,N],[0,"caching_codemap_view","","",N,N],[3,"CacheEntry","rustc::ich::caching_codemap_view","",N,N],[12,"time_stamp","","",204,N],[12,"line_number","","",204,N],[12,"line_start","","",204,N],[12,"line_end","","",204,N],[12,"file","","",204,N],[12,"file_index","","",204,N],[3,"CachingSourceMapView","","",N,N],[12,"source_map","","",201,N],[12,"line_cache","","",201,N],[12,"time_stamp","","",201,N],[11,"clone","","",204,[[["self"]],["cacheentry"]]],[11,"clone","rustc::ich","",201,[[["self"]],["cachingsourcemapview"]]],[11,"new","","",201,[[["sourcemap"]],["cachingsourcemapview"]]],[11,"byte_pos_to_line_and_col","","",201,[[["self"],["bytepos"]],["option"]]],[0,"hcx","","",N,N],[3,"StableHashingContext","rustc::ich::hcx","This is the context state available during incr. comp. hashing. It contains enough information to transform DefIds and HirIds into stable DefPaths (i.e. a reference to the TyCtxt) and it holds a few caches for speeding up various things (e.g. each DefId/DefPath is only hashed once).",N,N],[12,"sess","","",202,N],[12,"definitions","","",202,N],[12,"cstore","","",202,N],[12,"body_resolver","","",202,N],[12,"hash_spans","","",202,N],[12,"hash_bodies","","",202,N],[12,"node_id_hashing_mode","","",202,N],[12,"raw_source_map","","",202,N],[12,"caching_source_map","","",202,N],[3,"BodyResolver","","The BodyResolver allows to map a BodyId to the corresponding hir::Body. We could also just store a plain reference to the hir::Crate but we want to avoid that the crate is used to get untracked access to all of the HIR.",N,N],[12,"0","","",205,N],[4,"NodeIdHashingMode","","",N,N],[13,"Ignore","","",203,N],[13,"HashDefPath","","",203,N],[5,"compute_ignored_attr_names","","",N,[[],["fxhashset",["symbol"]]]],[5,"hash_stable_trait_impls","","",N,N],[8,"StableHashingContextProvider","","Something that can provide a stable hashing context.",N,N],[10,"get_stable_hashing_context","","",206,[[["self"]],["stablehashingcontext"]]],[11,"clone","rustc::ich","",202,[[["self"]],["stablehashingcontext"]]],[11,"eq","","",203,[[["self"],["nodeidhashingmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",203,N],[11,"clone","","",203,[[["self"]],["nodeidhashingmode"]]],[11,"clone","rustc::ich::hcx","",205,[[["self"]],["bodyresolver"]]],[11,"body","","",205,[[["self"],["bodyid"]],["body"]]],[11,"new","rustc::ich","",202,[[["session"],["crate"],["definitions"],["cratestore"]],["self"]]],[11,"sess","","",202,[[["self"]],["session"]]],[11,"while_hashing_hir_bodies","","",202,[[["self"],["bool"],["f"]]]],[11,"while_hashing_spans","","",202,[[["self"],["bool"],["f"]]]],[11,"with_node_id_hashing_mode","","",202,[[["self"],["nodeidhashingmode"],["f"]]]],[11,"def_path_hash","","",202,[[["self"],["defid"]],["defpathhash"]]],[11,"local_def_path_hash","","",202,[[["self"],["defindex"]],["defpathhash"]]],[11,"node_to_hir_id","","",202,[[["self"],["nodeid"]],["hirid"]]],[11,"hash_bodies","","",202,[[["self"]],["bool"]]],[11,"source_map","","",202,[[["self"]],["cachingsourcemapview"]]],[11,"is_ignored_attr","","",202,[[["self"],["symbol"]],["bool"]]],[11,"hash_hir_item_like","","",202,[[["self"],["f"]]]],[11,"get_stable_hashing_context","","",202,[[["self"]],["stablehashingcontext"]]],[11,"hash_stable","rustc::hir","",55,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",33,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",33,N],[0,"impls_cstore","rustc::ich","This module contains `HashStable` implementations for various data types from rustc::middle::cstore in no particular order.",N,N],[0,"impls_hir","","This module contains `HashStable` implementations for various HIR data types in no particular order.",N,N],[11,"hash_stable","rustc::hir::def_id","",150,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",150,[[["self"],["stablehashingcontext"]],["defpathhash"]]],[11,"hash_stable","","",151,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",151,[[["self"],["stablehashingcontext"]],["defpathhash"]]],[11,"hash_stable","","",152,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",152,[[["self"],["stablehashingcontext"]],["defpathhash"]]],[11,"hash_stable","rustc::hir","",34,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",34,[[["self"],["stablehashingcontext"]],["itemlocalid"]]],[11,"hash_stable","","",82,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",62,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",64,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",92,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",93,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",35,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",36,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",37,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",38,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",94,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",39,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",96,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",95,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",40,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",97,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",42,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",98,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",43,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",99,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",44,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",45,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",46,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",60,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",61,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",66,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",84,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",67,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",123,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",68,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",69,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",124,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",73,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",131,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",79,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",80,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",113,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",48,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",49,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",50,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",51,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",100,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",101,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",102,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",104,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",105,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",52,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",107,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",53,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",108,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",54,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",109,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",110,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",57,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",58,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",112,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",114,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",116,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",115,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",118,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",119,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",59,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",117,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",63,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",120,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",121,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",65,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",122,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",133,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",129,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",130,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",74,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",75,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",77,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",78,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",132,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",81,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",134,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",83,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",135,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",85,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",86,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",136,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",87,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",137,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",106,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",72,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",56,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",55,N],[11,"hash_stable","","",70,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",76,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",71,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::hir::def","",144,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",145,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",146,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::hir","",103,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",125,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",127,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",126,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",128,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::hir::def_id","",149,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",149,[[["self"],["stablehashingcontext"]],["defpathhash"]]],[11,"hash_stable","rustc::hir::def","",143,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::hir","",89,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",89,N],[11,"hash_stable","","",90,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",91,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",88,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"impls_mir","rustc::ich","This module contains `HashStable` implementations for various MIR data types in no particular order.",N,N],[0,"impls_misc","","This module contains `HashStable` implementations for various data types that don't fit into any of the other impls_xxx modules.",N,N],[0,"impls_ty","","This module contains `HashStable` implementations for various data types from rustc::ty in no particular order.",N,N],[0,"impls_syntax","","This module contains `HashStable` implementations for various data types from libsyntax in no particular order.",N,N],[5,"hash_token","rustc::ich::impls_syntax","",N,[[["token"],["stablehashingcontext"],["stablehasher"]]]],[5,"stable_byte_pos","","",N,[[["bytepos"],["bytepos"]],["u32"]]],[5,"stable_multibyte_char","","",N,N],[5,"stable_non_narrow_char","","",N,N],[17,"ATTR_DIRTY","rustc::ich","",N,N],[17,"ATTR_CLEAN","","",N,N],[17,"ATTR_IF_THIS_CHANGED","","",N,N],[17,"ATTR_THEN_THIS_WOULD_NEED","","",N,N],[17,"ATTR_PARTITION_REUSED","","",N,N],[17,"ATTR_PARTITION_CODEGENED","","",N,N],[17,"DEP_GRAPH_ASSERT_ATTRS","","",N,N],[17,"IGNORED_ATTRIBUTES","","",N,N],[8,"StableHashingContextProvider","","Something that can provide a stable hashing context.",N,N],[10,"get_stable_hashing_context","","",206,[[["self"]],["stablehashingcontext"]]],[0,"infer","rustc","See the Book for more information.",N,N],[3,"TypeFreshener","rustc::infer","",N,N],[12,"infcx","","",207,N],[12,"freshen_count","","",207,N],[12,"freshen_map","","",207,N],[3,"InferOk","","",N,N],[12,"value","","",208,N],[12,"obligations","","",208,N],[3,"InferCtxt","","",N,N],[12,"tcx","","",209,N],[12,"in_progress_tables","","During type-checking/inference of a body, `in_progress_tables` contains a reference to the tables being built up, which are used for reading closure kinds/signatures as they are inferred, and for error reporting logic to read arbitrary node types.",209,N],[12,"projection_cache","","",209,N],[12,"type_variables","","",209,N],[12,"int_unification_table","","",209,N],[12,"float_unification_table","","",209,N],[12,"region_constraints","","",209,N],[12,"lexical_region_resolutions","","",209,N],[12,"selection_cache","","Caches the results of trait selection. This cache is used for things that have to do with the parameters in scope.",209,N],[12,"evaluation_cache","","Caches the results of trait evaluation.",209,N],[12,"reported_trait_errors","","",209,N],[12,"tainted_by_errors_flag","","",209,N],[12,"err_count_on_creation","","",209,N],[12,"in_snapshot","","",209,N],[12,"region_obligations","","",209,N],[12,"universe","","What is the innermost universe we have created? Starts out as `UniverseIndex::root()` but grows from there as we enter universal quantifiers.",209,N],[3,"TypeTrace","","The trace designates the path through inference that we took to encounter an error or subtyping constraint.",N,N],[12,"cause","","",210,N],[12,"values","","",210,N],[3,"RegionObligation","","See the `region_obligations` field for more information.",N,N],[12,"sub_region","","",211,N],[12,"sup_type","","",211,N],[12,"cause","","",211,N],[3,"InferCtxtBuilder","","Helper type of a temporary returned by tcx.infer_ctxt(). Necessary because we can't write the following bound: F: for<'b, 'tcx> where 'gcx: 'tcx FnOnce(InferCtxt<'b, 'gcx, 'tcx>).",N,N],[12,"global_tcx","","",212,N],[12,"arena","","",212,N],[12,"fresh_tables","","",212,N],[3,"CombinedSnapshot","","",N,N],[12,"projection_cache_snapshot","","",213,N],[12,"type_snapshot","","",213,N],[12,"int_snapshot","","",213,N],[12,"float_snapshot","","",213,N],[12,"region_constraints_snapshot","","",213,N],[12,"region_obligations_snapshot","","",213,N],[12,"universe","","",213,N],[12,"was_in_snapshot","","",213,N],[12,"_in_progress_tables","","",213,N],[4,"ValuePairs","","See `error_reporting` module for more details",N,N],[13,"Types","","",214,N],[13,"Regions","","",214,N],[13,"TraitRefs","","",214,N],[13,"PolyTraitRefs","","",214,N],[4,"SubregionOrigin","","The origin of a `r1 <= r2` constraint.",N,N],[13,"Subtype","","",215,N],[13,"InfStackClosure","","",215,N],[13,"InvokeClosure","","",215,N],[13,"DerefPointer","","",215,N],[13,"FreeVariable","","",215,N],[13,"IndexSlice","","",215,N],[13,"RelateObjectBound","","",215,N],[13,"RelateParamBound","","",215,N],[13,"RelateRegionParamBound","","",215,N],[13,"RelateDefaultParamBound","","",215,N],[13,"Reborrow","","",215,N],[13,"ReborrowUpvar","","",215,N],[13,"DataBorrowed","","",215,N],[13,"ReferenceOutlivesReferent","","",215,N],[13,"ParameterInScope","","",215,N],[13,"ExprTypeIsNotInScope","","",215,N],[13,"BindingTypeIsNotValidAtDecl","","",215,N],[13,"CallRcvr","","",215,N],[13,"CallArg","","",215,N],[13,"CallReturn","","",215,N],[13,"Operand","","",215,N],[13,"AddrOf","","",215,N],[13,"AutoBorrow","","",215,N],[13,"SafeDestructor","","",215,N],[13,"CompareImplMethodObligation","","",215,N],[12,"span","rustc::infer::SubregionOrigin","",215,N],[12,"item_name","","",215,N],[12,"impl_item_def_id","","",215,N],[12,"trait_item_def_id","","",215,N],[4,"ParameterOrigin","rustc::infer","Places that type/region parameters can appear.",N,N],[13,"Path","","",216,N],[13,"MethodCall","","",216,N],[13,"OverloadedOperator","","",216,N],[13,"OverloadedDeref","","",216,N],[4,"LateBoundRegionConversionTime","","Times when we replace late-bound regions with variables:",N,N],[13,"FnCall","","when a fn is called",217,N],[13,"HigherRankedType","","when two higher-ranked types are compared",217,N],[13,"AssocTypeProjection","","when projecting an associated type",217,N],[4,"RegionVariableOrigin","","Reasons to create a region inference variable",N,N],[13,"MiscVariable","","",218,N],[13,"PatternRegion","","",218,N],[13,"AddrOfRegion","","",218,N],[13,"Autoref","","",218,N],[13,"Coercion","","",218,N],[13,"EarlyBoundRegion","","",218,N],[13,"LateBoundRegion","","",218,N],[13,"UpvarRegion","","",218,N],[13,"BoundRegionInCoherence","","",218,N],[13,"NLL","","",218,N],[4,"NLLRegionVariableOrigin","","",N,N],[13,"FreeRegion","","",219,N],[13,"BoundRegion","","",219,N],[13,"Existential","","",219,N],[4,"FixupError","","",N,N],[13,"UnresolvedIntTy","","",220,N],[13,"UnresolvedFloatTy","","",220,N],[13,"UnresolvedTy","","",220,N],[0,"opaque_types","","",N,N],[3,"OpaqueTypeDecl","rustc::infer::opaque_types","Information about the opaque, abstract types whose values we are inferring in this function (these are the `impl Trait` that appear in the return type).",N,N],[12,"substs","","The substitutions that we apply to the abstract that that this `impl Trait` desugars to. e.g., if:",221,N],[12,"concrete_ty","","The type variable that represents the value of the abstract type that we require. In other words, after we compile this function, we will be created a constraint like:",221,N],[12,"has_required_region_bounds","","True if the `impl Trait` bounds include region bounds. For example, this would be true for:",221,N],[3,"ReverseMapper","","",N,N],[12,"tcx","","",222,N],[12,"tainted_by_errors","","If errors have already been reported in this fn, we suppress our own errors because they are sometimes derivative.",222,N],[12,"opaque_type_def_id","","",222,N],[12,"map","","",222,N],[12,"map_missing_regions_to_empty","","",222,N],[12,"hidden_ty","","initially `Some`, set to `None` once error has been reported",222,N],[3,"Instantiator","","",N,N],[12,"infcx","","",223,N],[12,"parent_def_id","","",223,N],[12,"body_id","","",223,N],[12,"param_env","","",223,N],[12,"opaque_types","","",223,N],[12,"obligations","","",223,N],[5,"may_define_existential_type","","Whether `opaque_node_id` is a sibling or a child of a sibling of `def_id`",N,[[["tyctxt"],["defid"],["nodeid"]],["bool"]]],[6,"OpaqueTypeMap","","",N,N],[11,"clone","","",221,[[["self"]],["opaquetypedecl"]]],[11,"fmt","","",221,[[["self"],["formatter"]],["result"]]],[11,"instantiate_opaque_types","rustc::infer","Replace all opaque types in `value` with fresh inference variables and creates appropriate obligations. For example, given the input:",209,[[["self"],["defid"],["nodeid"],["paramenv"],["t"]],["inferok"]]],[11,"constrain_opaque_types","","Given the map `opaque_types` containing the existential `impl Trait` types whose underlying, hidden types are being inferred, this method adds constraints to the regions appearing in those underlying hidden types to ensure that they at least do not refer to random scopes within the current function. These constraints are not (quite) sufficient to guarantee that the regions are actually legal values; that final condition is imposed after region inference is done.",209,[[["self"],["opaquetypemap"],["frr"]]]],[11,"constrain_opaque_type","","",209,[[["self"],["defid"],["opaquetypedecl"],["frr"]]]],[11,"infer_opaque_definition_from_instantiation","","Given the fully resolved, instantiated type for an opaque type, i.e., the value of an inference variable like C1 or C2 (*), computes the \"definition type\" for an abstract type definition -- that is, the inferred value of `Foo1<'x>` or `Foo2<'x>` that we would conceptually use in its definition:",209,[[["self"],["defid"],["opaquetypedecl"],["ty"]],["ty"]]],[11,"new","rustc::infer::opaque_types","",222,[[["tyctxt"],["bool"],["defid"],["fxhashmap",["kind","kind"]],["ty"]],["self"]]],[11,"fold_kind_mapping_missing_regions_to_empty","","",222,[[["self"],["kind"]],["kind"]]],[11,"fold_kind_normally","","",222,[[["self"],["kind"]],["kind"]]],[11,"tcx","","",222,[[["self"]],["tyctxt"]]],[11,"fold_region","","",222,[[["self"],["region"]],["region"]]],[11,"fold_ty","","",222,[[["self"],["ty"]],["ty"]]],[11,"instantiate_opaque_types_in_map","","",223,[[["self"],["t"]],["t"]]],[11,"fold_opaque_ty","","",223,[[["self"],["ty"],["defid"],["substs"]],["ty"]]],[0,"at","rustc::infer","A nice interface for working with the infcx.  The basic idea is to do `infcx.at(cause, param_env)`, which sets the \"cause\" of the operation as well as the surrounding parameter environment.  Then you can do something like `.sub(a, b)` or `.eq(a, b)` to create a subtype or equality relationship respectively. The first argument is always the \"expected\" output from the POV of diagnostics.",N,N],[3,"At","rustc::infer::at","",N,N],[12,"infcx","","",224,N],[12,"cause","","",224,N],[12,"param_env","","",224,N],[3,"Trace","","",N,N],[12,"at","","",225,N],[12,"a_is_expected","","",225,N],[12,"trace","","",225,N],[8,"ToTrace","","",N,N],[10,"to_trace","","",226,[[["obligationcause"],["bool"],["self"],["self"]],["typetrace"]]],[11,"at","rustc::infer","",209,[[["self"],["obligationcause"],["paramenv"]],["at"]]],[11,"eq_impl_headers","rustc::infer::at","Hacky routine for equating two impl headers in coherence.",224,[[["self"],["implheader"],["implheader"]],["inferresult"]]],[11,"sub_exp","","Make `a <: b` where `a` may or may not be expected",224,[[["self"],["bool"],["t"],["t"]],["inferresult"]]],[11,"sup","","Make `actual <: expected`. For example, if type-checking a call like `foo(x)`, where `foo: fn(i32)`, you might have `sup(i32, x)`, since the \"expected\" type is the type that appears in the signature.",224,[[["self"],["t"],["t"]],["inferresult"]]],[11,"sub","","Make `expected <: actual`",224,[[["self"],["t"],["t"]],["inferresult"]]],[11,"eq_exp","","Make `expected <: actual`",224,[[["self"],["bool"],["t"],["t"]],["inferresult"]]],[11,"eq","","Make `expected <: actual`",224,[[["self"],["t"],["t"]],["inferresult"]]],[11,"lub","","Compute the least-upper-bound, or mutual supertype, of two values. The order of the arguments doesn't matter, but since this can result in an error (e.g., if asked to compute LUB of u32 and i32), it is meaningful to call one of them the \"expected type\".",224,[[["self"],["t"],["t"]],["inferresult"]]],[11,"glb","","Compute the greatest-lower-bound, or mutual subtype, of two values. As with `lub` order doesn't matter, except for error cases.",224,[[["self"],["t"],["t"]],["inferresult"]]],[11,"trace","","Sets the \"trace\" values that will be used for error-reporting, but doesn't actually perform any operation yet (this is useful when you want to set the trace using distinct values from those you wish to operate upon).",224,[[["self"],["t"],["t"]],["trace"]]],[11,"trace_exp","","Like `trace`, but the expected value is determined by the boolean argument (if true, then the first argument `a` is the \"expected\" value).",224,[[["self"],["bool"],["t"],["t"]],["trace"]]],[11,"sub","","Make `a <: b` where `a` may or may not be expected (if `a_is_expected` is true, then `a` is expected). Make `expected <: actual`",225,[[["self"],["t"],["t"]],["inferresult"]]],[11,"eq","","Make `a == b`; the expectation is set by the call to `trace()`.",225,[[["self"],["t"],["t"]],["inferresult"]]],[11,"lub","","",225,[[["self"],["t"],["t"]],["inferresult"]]],[11,"glb","","",225,[[["self"],["t"],["t"]],["inferresult"]]],[0,"canonical","rustc::infer","Canonicalization is the key to constructing a query in the middle of type inference. Ordinarily, it is not possible to store types from type inference in query keys, because they contain references to inference variables whose lifetimes are too short and so forth. Canonicalizing a value T1 using `canonicalize_query` produces two things:",N,N],[3,"Canonical","rustc::infer::canonical","A \"canonicalized\" type `V` is one where all free inference variables have been rewritten to \"canonical vars\". These are numbered starting from 0 in order of first appearance.",N,N],[12,"variables","","",227,N],[12,"value","","",227,N],[3,"CanonicalVarValues","","A set of values corresponding to the canonical variables from some `Canonical`. You can give these values to `canonical_value.substitute` to substitute them into the canonical value at the right places.",N,N],[12,"var_values","","",228,N],[3,"CanonicalVarInfo","","Information about a canonical variable that is included with the canonical value. This is sufficient information for code to create a copy of the canonical value in some other inference context, with fresh inference variables replacing the canonical values.",N,N],[12,"kind","","",229,N],[3,"QueryResult","","After we execute a query with a canonicalized key, we get back a `Canonical<QueryResult<..>>`. You can use `instantiate_query_result` to access the data in this result.",N,N],[12,"var_values","","",230,N],[12,"region_constraints","","",230,N],[12,"certainty","","",230,N],[12,"value","","",230,N],[4,"CanonicalVarKind","","Describes the \"kind\" of the canonical variable. This is a \"kind\" in the type-theory sense of the term -- i.e., a \"meta\" type system that analyzes type-like values.",N,N],[13,"Ty","","Some kind of type inference variable.",231,N],[13,"Region","","Region variable `'?R`.",231,N],[4,"CanonicalTyVarKind","","Rust actually has more than one category of type variables; notably, the type variables we create for literals (e.g., 22 or 22.) can only be instantiated with integral/float types (e.g., usize or f32). In order to faithfully reproduce a type, we need to know what set of types a given type variable can be unified with.",N,N],[13,"General","","General type variable `?T` that can be unified with arbitrary types.",232,N],[13,"Int","","Integral type variable `?I` (that can only be unified with integral types).",232,N],[13,"Float","","Floating-point type variable `?F` (that can only be unified with float types).",232,N],[4,"Certainty","","Indicates whether or not we were able to prove the query to be true.",N,N],[13,"Proven","","The query is known to be true, presuming that you apply the given `var_values` and the region-constraints are satisfied.",233,N],[13,"Ambiguous","","The query is not known to be true, but also not known to be false. The `var_values` represent either values that must hold in order for the query to be true, or helpful tips that might make it true. Currently rustc's trait solver cannot distinguish the two (e.g., due to our preference for where clauses over impls).",233,N],[0,"canonicalizer","","This module contains the \"canonicalizer\" itself.",N,N],[3,"CanonicalizeRegionMode","rustc::infer::canonical::canonicalizer","If this flag is true, then all free regions will be replaced with a canonical var. This is used to make queries as generic as possible. For example, the query `F: Foo<'static>` would be canonicalized to `F: Foo<'0>`.",N,N],[12,"static_region","","",234,N],[12,"other_free_regions","","",234,N],[3,"Canonicalizer","","",N,N],[12,"infcx","","",235,N],[12,"tcx","","",235,N],[12,"variables","","",235,N],[12,"var_values","","",235,N],[12,"indices","","",235,N],[12,"canonicalize_region_mode","","",235,N],[12,"needs_canonical_flags","","",235,N],[11,"canonicalize_query","rustc::infer","Canonicalizes a query value `V`. When we canonicalize a query, we not only canonicalize unbound inference variables, but we also replace all free regions whatsoever. So for example a query like `T: Trait<'static>` would be canonicalized to",209,[[["self"],["v"],["smallcanonicalvarvalues"]],["canonicalized"]]],[11,"canonicalize_response","","Canonicalizes a query response `V`. When we canonicalize a query response, we only canonicalize unbound inference variables, and we leave other free regions alone. So, continuing with the example from `canonicalize_query`, if there was an input query `T: Trait<'static>`, it would have been canonicalized to",209,[[["self"],["v"]],["canonicalized"]]],[11,"canonicalize_hr_query_hack","","A hacky variant of `canonicalize_query` that does not canonicalize `'static`.  Unfortunately, the existing leak check treaks `'static` differently in some cases (see also #33684), so if we are performing an operation that may need to prove \"leak-check\" related things, we leave `'static` alone.",209,[[["self"],["v"],["smallcanonicalvarvalues"]],["canonicalized"]]],[11,"any","rustc::infer::canonical::canonicalizer","",234,[[["self"]],["bool"]]],[11,"tcx","","",235,[[["self"]],["tyctxt"]]],[11,"fold_region","","",235,[[["self"],["region"]],["region"]]],[11,"fold_ty","","",235,[[["self"],["ty"]],["ty"]]],[11,"canonicalize","","The main `canonicalize` method, shared impl of `canonicalize_query` and `canonicalize_response`.",235,[[["v"],["option",["inferctxt"]],["tyctxt"],["canonicalizeregionmode"],["smallcanonicalvarvalues"]],["canonicalized"]]],[11,"canonical_var","","Creates a canonical variable replacing `kind` from the input, or returns an existing variable if `kind` has already been seen. `kind` is expected to be an unbound variable (or potentially a free region).",235,[[["self"],["canonicalvarinfo"],["kind"]],["canonicalvar"]]],[11,"canonicalize_ty_var","","Given a type variable `ty_var` of the given kind, first check if `ty_var` is bound to anything; if so, canonicalize that. Otherwise, create a new canonical variable for `ty_var`.",235,[[["self"],["canonicaltyvarkind"],["ty"]],["ty"]]],[0,"query_result","rustc::infer::canonical","This module contains the code to instantiate a \"query result\", and in particular to extract out the resulting region obligations and encode them therein.",N,N],[5,"make_query_outlives","rustc::infer::canonical::query_result","Given the region obligations and constraints scraped from the infcx, creates query region constraints.",N,N],[22,"","","",N,N],[11,"enter_canonical_trait_query","rustc::infer","The \"main method\" for a canonicalized trait query. Given the canonical key `canonical_key`, this method will create a new inference context, instantiate the key, and run your operation `op`. The operation should yield up a result (of type `R`) as well as a set of trait obligations that must be fully satisfied. These obligations will be processed and the canonical result created.",212,N],[11,"make_canonicalized_query_result","","This method is meant to be invoked as the final step of a canonical query implementation. It is given:",209,[[["self"],["canonicalvarvalues"],["t"],["fulfillmentcontext"]],["fallible",["canonicalizedqueryresult"]]]],[11,"make_query_result","","Helper for `make_canonicalized_query_result` that does everything up until the final canonicalization.",209,[[["self"],["canonicalvarvalues"],["t"],["fulfillmentcontext"]],["result",["queryresult","nosolution"]]]],[11,"instantiate_query_result_and_region_obligations","","Given the (canonicalized) result to a canonical query, instantiates the result so it can be used, plugging in the values from the canonical query. (Note that the result may have been ambiguous; you should check the certainty level of the query before applying this function.)",209,[[["self"],["obligationcause"],["paramenv"],["smallcanonicalvarvalues"],["canonical"]],["inferresult"]]],[11,"instantiate_nll_query_result_and_region_obligations","","An alternative to `instantiate_query_result_and_region_obligations` that is more efficient for NLL. NLL is a bit more advanced in the \"transition to chalk\" than the rest of the compiler. During the NLL type check, all of the \"processing\" of types and things happens in queries -- the NLL checker itself is only interested in the region obligations (`'a: 'b` or `T: 'b`) that come out of these queries, which it wants to convert into MIR-based constraints and solve. Therefore, it is most convenient for the NLL Type Checker to directly consume the `QueryRegionConstraint` values that arise from doing a query. This is contrast to other parts of the compiler, which would prefer for those `QueryRegionConstraint` to be converted into the older infcx-style constraints (e.g., calls to `sub_regions` or `register_region_obligation`).",209,[[["self"],["obligationcause"],["paramenv"],["smallcanonicalvarvalues"],["canonical"],["vec"]],["inferresult"]]],[11,"query_result_substitution","","Given the original values and the (canonicalized) result from computing a query, returns a substitution that can be applied to the query result to convert the result back into the original namespace.",209,[[["self"],["obligationcause"],["paramenv"],["smallcanonicalvarvalues"],["canonical"]],["inferresult",["canonicalvarvalues"]]]],[11,"query_result_substitution_guess","","Given the original values and the (canonicalized) result from computing a query, returns a guess at a substitution that can be applied to the query result to convert the result back into the original namespace. This is called a guess because it uses a quick heuristic to find the values for each canonical variable; if that quick heuristic fails, then we will instantiate fresh inference variables for each canonical variable instead. Therefore, the result of this method must be properly unified",209,[[["self"],["obligationcause"],["smallcanonicalvarvalues"],["canonical"]],["canonicalvarvalues"]]],[11,"unify_query_result_substitution_guess","","Given a \"guess\" at the values for the canonical variables in the input, try to unify with the actual values found in the query result.  Often, but not always, this is a no-op, because we already found the mapping in the \"guessing\" step.",209,[[["self"],["obligationcause"],["paramenv"],["smallcanonicalvarvalues"],["canonicalvarvalues"],["canonical"]],["inferresult"]]],[11,"query_region_constraints_into_obligations","","Converts the region constraints resulting from a query into an iterator of obligations.",209,N],[11,"unify_canonical_vars","","Given two sets of values for the same set of canonical variables, unify them. The second set is produced lazilly by supplying indices from the first set.",209,N],[0,"substitute","rustc::infer::canonical","This module contains code to substitute new values into a `Canonical<'tcx, T>`.",N,N],[3,"CanonicalVarValuesSubst","rustc::infer::canonical::substitute","",N,N],[12,"tcx","","",236,N],[12,"var_values","","",236,N],[5,"substitute_value","","Substitute the values from `var_values` into `value`. `var_values` must be values for the set of canonical variables that appear in `value`.",N,[[["tyctxt"],["canonicalvarvalues"],["t"]],["t"]]],[11,"substitute","rustc::infer::canonical","Instantiate the wrapped value, replacing each canonical value with the value given in `var_values`.",227,[[["self"],["tyctxt"],["canonicalvarvalues"]],["v"]]],[11,"substitute_projected","","Allows one to apply a substitute to some subset of `self.value`. Invoke `projection_fn` with `self.value` to get a value V that is expressed in terms of the same canonical variables bound in `self` (usually this extracts from subset of `self`). Apply the substitution `var_values` to this value V, replacing each of the canonical variables.",227,N],[11,"tcx","rustc::infer::canonical::substitute","",236,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",236,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",236,[[["self"],["region"]],["region"]]],[6,"CanonicalVarInfos","rustc::infer::canonical","",N,N],[6,"SmallCanonicalVarValues","","Like CanonicalVarValues, but for use in places where a SmallVec is appropriate.",N,N],[6,"Canonicalized","","",N,N],[6,"CanonicalizedQueryResult","","",N,N],[6,"QueryRegionConstraint","","",N,N],[11,"clone","","",227,[[["self"]],["canonical"]]],[11,"fmt","","",227,[[["self"],["formatter"]],["result"]]],[11,"eq","","",227,[[["self"],["canonical"]],["bool"]]],[11,"ne","","",227,[[["self"],["canonical"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",227,N],[11,"hash","","",227,N],[11,"decode","","",227,[[["__dv"]],["result",["canonical"]]]],[11,"encode","","",227,[[["self"],["__sv"]],["result"]]],[11,"clone","","",228,[[["self"]],["canonicalvarvalues"]]],[11,"fmt","","",228,[[["self"],["formatter"]],["result"]]],[11,"eq","","",228,[[["self"],["canonicalvarvalues"]],["bool"]]],[11,"ne","","",228,[[["self"],["canonicalvarvalues"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",228,N],[11,"hash","","",228,N],[11,"decode","","",228,[[["__d"]],["result",["canonicalvarvalues"]]]],[11,"encode","","",228,[[["self"],["__s"]],["result"]]],[11,"clone","","",229,[[["self"]],["canonicalvarinfo"]]],[11,"fmt","","",229,[[["self"],["formatter"]],["result"]]],[11,"eq","","",229,[[["self"],["canonicalvarinfo"]],["bool"]]],[11,"ne","","",229,[[["self"],["canonicalvarinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",229,N],[11,"hash","","",229,N],[11,"decode","","",229,[[["__d"]],["result",["canonicalvarinfo"]]]],[11,"encode","","",229,[[["self"],["__s"]],["result"]]],[11,"clone","","",231,[[["self"]],["canonicalvarkind"]]],[11,"fmt","","",231,[[["self"],["formatter"]],["result"]]],[11,"eq","","",231,[[["self"],["canonicalvarkind"]],["bool"]]],[11,"ne","","",231,[[["self"],["canonicalvarkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",231,N],[11,"hash","","",231,N],[11,"decode","","",231,[[["__d"]],["result",["canonicalvarkind"]]]],[11,"encode","","",231,[[["self"],["__s"]],["result"]]],[11,"clone","","",232,[[["self"]],["canonicaltyvarkind"]]],[11,"fmt","","",232,[[["self"],["formatter"]],["result"]]],[11,"eq","","",232,[[["self"],["canonicaltyvarkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",232,N],[11,"hash","","",232,N],[11,"decode","","",232,[[["__d"]],["result",["canonicaltyvarkind"]]]],[11,"encode","","",232,[[["self"],["__s"]],["result"]]],[11,"clone","","",230,[[["self"]],["queryresult"]]],[11,"fmt","","",230,[[["self"],["formatter"]],["result"]]],[11,"clone","","",233,[[["self"]],["certainty"]]],[11,"fmt","","",233,[[["self"],["formatter"]],["result"]]],[11,"is_proven","","",233,[[["self"]],["bool"]]],[11,"is_ambiguous","","",233,[[["self"]],["bool"]]],[11,"is_proven","","",230,[[["self"]],["bool"]]],[11,"is_ambiguous","","",230,[[["self"]],["bool"]]],[11,"is_proven","","",227,[[["self"]],["bool"]]],[11,"is_ambiguous","","",227,[[["self"]],["bool"]]],[11,"unchecked_map","","Allows you to map the `value` of a canonical while keeping the same set of bound variables.",227,N],[11,"instantiate_canonical_with_fresh_inference_vars","rustc::infer","Creates a substitution S for the canonical value with fresh inference variables and applies it to the canonical value. Returns both the instantiated result and the substitution S.",209,N],[11,"fresh_inference_vars_for_canonical_vars","","Given the \"infos\" about the canonical variables from some canonical, creates fresh inference variables with the same characteristics. You can then use `substitute` to instantiate the canonical variable with these inference variables.",209,[[["self"],["span"],["list"]],["canonicalvarvalues"]]],[11,"fresh_inference_var_for_canonical_var","","Given the \"info\" about a canonical variable, creates a fresh inference variable with the same characteristics.",209,[[["self"],["span"],["canonicalvarinfo"]],["kind"]]],[11,"super_fold_with","rustc::infer::canonical","",233,[[["self"],["f"]],["certainty"]]],[11,"super_visit_with","","",233,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",229,[[["self"],["f"]],["canonicalvarinfo"]]],[11,"super_visit_with","","",229,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",231,[[["self"],["f"]],["canonicalvarkind"]]],[11,"super_visit_with","","",231,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",233,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",229,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",231,[[["self"],["tyctxt"]],["option"]]],[11,"super_fold_with","","",237,[[["self"],["f"]],["canonicalvarinfos"]]],[11,"super_visit_with","","",237,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",227,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",227,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",227,[[["self"],["tyctxt"]],["option",["canonical"]]]],[11,"len","","",228,[[["self"]],["usize"]]],[11,"lift_to_tcx","","",228,[[["self"],["tyctxt"]],["option",["canonicalvarvalues"]]]],[11,"super_fold_with","","",228,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",228,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",230,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",230,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",230,[[["self"],["tyctxt"]],["option",["queryresult"]]]],[11,"index","","",228,[[["self"],["canonicalvar"]],["kind"]]],[0,"combine","rustc::infer","",N,N],[3,"CombineFields","rustc::infer::combine","",N,N],[12,"infcx","","",238,N],[12,"trace","","",238,N],[12,"cause","","",238,N],[12,"param_env","","",238,N],[12,"obligations","","",238,N],[3,"Generalizer","","",N,N],[12,"infcx","","",239,N],[12,"span","","Span, used when creating new type variables and things.",239,N],[12,"for_vid_sub_root","","The vid of the type variable that is in the process of being instantiated; if we find this within the type we are folding, that means we would have created a cyclic type.",239,N],[12,"ambient_variance","","Track the variance as we descend into the type.",239,N],[12,"needs_wf","","See the field `needs_wf` in `Generalization`.",239,N],[12,"root_ty","","The root type that we are generalizing. Used when reporting cycles.",239,N],[3,"Generalization","","Result from a generalization operation. This includes not only the generalized type, but also a bool flag indicating whether further WF checks are needed.",N,N],[12,"ty","","",240,N],[12,"needs_wf","","If true, then the generalized type may not be well-formed, even if the source type is well-formed, so we should add an additional check to enforce that it is. This arises in particular around 'bivariant' type parameters that are only constrained by a where-clause. As an example, imagine a type:",240,N],[4,"RelationDir","","",N,N],[13,"SubtypeOf","","",241,N],[13,"SupertypeOf","","",241,N],[13,"EqTo","","",241,N],[5,"int_unification_error","","",N,N],[5,"float_unification_error","","",N,N],[8,"RelateResultCompare","","",N,N],[10,"compare","","",242,[[["self"],["t"],["f"]],["relateresult"]]],[11,"clone","","",238,[[["self"]],["combinefields"]]],[11,"clone","","",241,[[["self"]],["relationdir"]]],[11,"assert_receiver_is_total_eq","","",241,N],[11,"eq","","",241,[[["self"],["relationdir"]],["bool"]]],[11,"hash","","",241,N],[11,"fmt","","",241,[[["self"],["formatter"]],["result"]]],[11,"super_combine_tys","rustc::infer","",209,[[["self"],["r"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"unify_integral_variable","","",209,[[["self"],["bool"],["intvid"],["intvarvalue"]],["relateresult",["ty"]]]],[11,"unify_float_variable","","",209,[[["self"],["bool"],["floatvid"],["floatty"]],["relateresult",["ty"]]]],[11,"tcx","rustc::infer::combine","",238,[[["self"]],["tyctxt"]]],[11,"equate","","",238,[[["self"],["bool"]],["equate"]]],[11,"sub","","",238,[[["self"],["bool"]],["sub"]]],[11,"lub","","",238,[[["self"],["bool"]],["lub"]]],[11,"glb","","",238,[[["self"],["bool"]],["glb"]]],[11,"instantiate","","Here dir is either EqTo, SubtypeOf, or SupertypeOf. The idea is that we should ensure that the type `a_ty` is equal to, a subtype of, or a supertype of (respectively) the type to which `b_vid` is bound.",238,[[["self"],["ty"],["relationdir"],["tyvid"],["bool"]],["relateresult"]]],[11,"generalize","","Attempts to generalize `ty` for the type variable `for_vid`. This checks for cycle -- that is, whether the type `ty` references `for_vid`. The `dir` is the \"direction\" for which we a performing the generalization (i.e., are we producing a type that can be used as a supertype etc).",238,[[["self"],["ty"],["tyvid"],["relationdir"]],["relateresult",["generalization"]]]],[11,"tcx","","",239,[[["self"]],["tyctxt"]]],[11,"tag","","",239,[[["self"]],["str"]]],[11,"a_is_expected","","",239,[[["self"]],["bool"]]],[11,"binders","","",239,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[11,"relate_item_substs","","",239,[[["self"],["defid"],["substs"],["substs"]],["relateresult",["substs"]]]],[11,"relate_with_variance","","",239,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",239,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",239,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[0,"equate","rustc::infer","",N,N],[3,"Equate","rustc::infer::equate","Ensures `a` is made equal to `b`. Returns `a` on success.",N,N],[12,"fields","","",243,N],[12,"a_is_expected","","",243,N],[11,"new","","",243,[[["combinefields"],["bool"]],["equate"]]],[11,"tag","","",243,[[["self"]],["str"]]],[11,"tcx","","",243,[[["self"]],["tyctxt"]]],[11,"a_is_expected","","",243,[[["self"]],["bool"]]],[11,"relate_item_substs","","",243,[[["self"],["defid"],["substs"],["substs"]],["relateresult",["substs"]]]],[11,"relate_with_variance","","",243,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",243,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",243,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",243,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[0,"error_reporting","rustc::infer","Error Reporting Code for the inference engine",N,N],[4,"FailureCode","rustc::infer::error_reporting","",N,N],[13,"Error0317","","",244,N],[13,"Error0580","","",244,N],[13,"Error0308","","",244,N],[13,"Error0644","","",244,N],[0,"note","","",N,N],[11,"note_region_origin","rustc::infer","",209,[[["self"],["diagnosticbuilder"],["subregionorigin"]]]],[11,"report_concrete_failure","","",209,[[["self"],["scopetree"],["subregionorigin"],["region"],["region"]],["diagnosticbuilder"]]],[0,"need_type_info","rustc::infer::error_reporting","",N,N],[3,"FindLocalByTypeVisitor","rustc::infer::error_reporting::need_type_info","",N,N],[12,"infcx","","",245,N],[12,"target_ty","","",245,N],[12,"hir_map","","",245,N],[12,"found_local_pattern","","",245,N],[12,"found_arg_pattern","","",245,N],[11,"node_matches_type","","",245,[[["self"],["hirid"]],["bool"]]],[11,"nested_visit_map","","",245,[[["self"]],["nestedvisitormap"]]],[11,"visit_local","","",245,[[["self"],["local"]]]],[11,"visit_body","","",245,[[["self"],["body"]]]],[11,"extract_type_name","rustc::infer","",209,[[["self"],["ty"]],["string"]]],[11,"need_type_info_err","","",209,[[["self"],["option",["bodyid"]],["span"],["ty"]],["diagnosticbuilder"]]],[0,"nice_region_error","rustc::infer::error_reporting","",N,N],[3,"NiceRegionError","rustc::infer::error_reporting::nice_region_error","",N,N],[12,"tcx","","",246,N],[12,"error","","",246,N],[12,"regions","","",246,N],[12,"tables","","",246,N],[0,"different_lifetimes","","Error Reporting for Anonymous Region Lifetime Errors where both the regions are anonymous.",N,N],[11,"try_report_anon_anon_conflict","","Print the error message for lifetime errors when both the concerned regions are anonymous.",246,[[["self"]],["option",["errorreported"]]]],[0,"find_anon_type","","",N,N],[3,"FindNestedTypeVisitor","rustc::infer::error_reporting::nice_region_error::find_anon_type","",N,N],[12,"tcx","","",247,N],[12,"bound_region","","",247,N],[12,"found_type","","",247,N],[12,"current_index","","",247,N],[3,"TyPathVisitor","","",N,N],[12,"tcx","","",248,N],[12,"found_it","","",248,N],[12,"bound_region","","",248,N],[12,"current_index","","",248,N],[11,"find_anon_type","rustc::infer::error_reporting::nice_region_error","This function calls the `visit_ty` method for the parameters corresponding to the anonymous regions. The `nested_visitor.found_type` contains the anonymous type.",246,[[["self"],["region"],["boundregion"]],["option"]]],[11,"find_component_for_bound_region","","",246,[[["self"],["ty"],["boundregion"]],["option",["ty"]]]],[11,"nested_visit_map","rustc::infer::error_reporting::nice_region_error::find_anon_type","",247,[[["self"]],["nestedvisitormap"]]],[11,"visit_ty","","",247,[[["self"],["ty"]]]],[11,"nested_visit_map","","",248,[[["self"]],["nestedvisitormap"]]],[11,"visit_lifetime","","",248,[[["self"],["lifetime"]]]],[11,"visit_ty","","",248,[[["self"],["ty"]]]],[0,"named_anon_conflict","rustc::infer::error_reporting::nice_region_error","Error Reporting for Anonymous Region Lifetime Errors where one region is named and the other is anonymous.",N,N],[11,"try_report_named_anon_conflict","","When given a `ConcreteFailure` for a function with arguments containing a named region and an anonymous region, emit an descriptive diagnostic error.",246,[[["self"]],["option",["errorreported"]]]],[11,"is_named_region","","",246,[[["self"],["region"]],["bool"]]],[0,"outlives_closure","","Error Reporting for Anonymous Region Lifetime Errors where both the regions are anonymous.",N,N],[11,"try_report_outlives_closure","","Print the error message for lifetime errors when binding excapes a closure.",246,[[["self"]],["option",["errorreported"]]]],[0,"static_impl_trait","","Error Reporting for static impl Traits.",N,N],[11,"try_report_static_impl_trait","","Print the error message for lifetime errors when the return type is a static impl Trait.",246,[[["self"]],["option",["errorreported"]]]],[0,"util","","Helper functions corresponding to lifetime errors due to anonymous regions.",N,N],[3,"AnonymousArgInfo","rustc::infer::error_reporting::nice_region_error::util","",N,N],[12,"arg","","",249,N],[12,"arg_ty","","",249,N],[12,"bound_region","","",249,N],[12,"arg_ty_span","","",249,N],[12,"is_first","","",249,N],[3,"FreeRegionInfo","","",N,N],[12,"def_id","","",250,N],[12,"boundregion","","",250,N],[12,"is_impl_item","","",250,N],[11,"fmt","","",249,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",250,[[["self"],["formatter"]],["result"]]],[11,"find_arg_with_region","rustc::infer::error_reporting::nice_region_error","",246,[[["self"],["region"],["region"]],["option",["anonymousarginfo"]]]],[11,"is_suitable_region","","",246,[[["self"],["region"]],["option",["freeregioninfo"]]]],[11,"is_return_type_anon","","",246,[[["self"],["defid"],["boundregion"],["fndecl"]],["option",["span"]]]],[11,"is_return_type_impl_trait","","",246,[[["self"],["defid"]],["bool"]]],[11,"is_self_anon","","",246,[[["self"],["bool"],["defid"]],["bool"]]],[11,"is_bound_region_in_impl_item","","",246,[[["self"],["defid"]],["bool"]]],[11,"try_report_nice_region_error","rustc::infer","",209,[[["self"],["regionresolutionerror"]],["bool"]]],[11,"new","rustc::infer::error_reporting::nice_region_error","",246,[[["tyctxt"],["regionresolutionerror"],["option",["typecktables"]]],["self"]]],[11,"new_from_span","","",246,[[["tyctxt"],["span"],["region"],["region"],["option",["typecktables"]]],["self"]]],[11,"try_report_from_nll","","",246,[[["self"]],["option",["errorreported"]]]],[11,"try_report","","",246,[[["self"]],["option",["errorreported"]]]],[11,"get_regions","","",246,N],[11,"report_region_errors","rustc::infer","",209,[[["self"],["scopetree"],["vec"],["bool"]]]],[11,"process_errors","","",209,[[["self"],["vec"]],["vec",["regionresolutionerror"]]]],[11,"check_and_note_conflicting_crates","","Adds a note if the types come from similarly named crates",209,[[["self"],["diagnosticbuilder"],["typeerror"],["span"]]]],[11,"note_error_origin","","",209,[[["self"],["diagnosticbuilder"],["obligationcause"]]]],[11,"highlight_outer","","Given that `other_ty` is the same as a type argument for `name` in `sub`, populate `value` highlighting `name` and every type argument that isn't at `pos` (which is `other_ty`), and populate `other_value` with `other_ty`.",209,[[["self"],["diagnosticstyledstring"],["diagnosticstyledstring"],["string"],["substs"],["usize"],["ty"]]]],[11,"cmp_type_arg","","If `other_ty` is the same as a type argument present in `sub`, highlight `path` in `t1_out`, as that is the difference to the other type.",209,[[["self"],["diagnosticstyledstring"],["diagnosticstyledstring"],["string"],["substs"],["string"],["ty"]],["option"]]],[11,"push_comma","","Add a `,` to the type representation only if it is appropriate.",209,[[["self"],["diagnosticstyledstring"],["diagnosticstyledstring"],["usize"],["usize"]]]],[11,"strip_generic_default_params","","For generic types with parameters with defaults, remove the parameters corresponding to the defaults. This repeats a lot of the logic found in `PrintContext::parameterized`.",209,[[["self"],["defid"],["substs"]],["substs"]]],[11,"cmp","","Compare two given types, eliding parts that are the same between them and highlighting relevant differences, and return two representation of those types for highlighted printing.",209,N],[11,"note_type_err","","",209,[[["self"],["diagnosticbuilder"],["obligationcause"],["option"],["option",["valuepairs"]],["typeerror"]]]],[11,"report_and_explain_type_error","","",209,[[["self"],["typetrace"],["typeerror"]],["diagnosticbuilder"]]],[11,"values_str","","",209,[[["self"],["valuepairs"]],["option"]]],[11,"expected_found_str_ty","","",209,[[["self"],["expectedfound"]],["option"]]],[11,"expected_found_str","","Returns a string of the form \"expected `{}`, found `{}`\".",209,[[["self"],["expectedfound"]],["option"]]],[11,"report_generic_bound_failure","","",209,[[["self"],["scopetree"],["span"],["option",["subregionorigin"]],["generickind"],["region"]]]],[11,"construct_generic_bound_failure","","",209,[[["self"],["scopetree"],["span"],["option",["subregionorigin"]],["generickind"],["region"]],["diagnosticbuilder"]]],[11,"report_sub_sup_conflict","","",209,[[["self"],["scopetree"],["regionvariableorigin"],["subregionorigin"],["region"],["subregionorigin"],["region"]]]],[11,"report_inference_failure","","",209,[[["self"],["regionvariableorigin"]],["diagnosticbuilder"]]],[0,"freshen","","Freshening is the process of replacing unknown variables with fresh types. The idea is that the type, after freshening, contains no inference variables but instead contains either a value for each variable or fresh \"arbitrary\" types wherever a variable would have been.",N,N],[3,"TypeFreshener","rustc::infer::freshen","",N,N],[12,"infcx","","",207,N],[12,"freshen_count","","",207,N],[12,"freshen_map","","",207,N],[11,"new","rustc::infer","",207,[[["inferctxt"]],["typefreshener"]]],[11,"freshen","","",207,[[["self"],["option",["ty"]],["inferty"],["f"]],["ty"]]],[11,"tcx","","",207,[[["self"]],["tyctxt"]]],[11,"fold_region","","",207,[[["self"],["region"]],["region"]]],[11,"fold_ty","","",207,[[["self"],["ty"]],["ty"]]],[0,"fudge","","",N,N],[3,"RegionFudger","rustc::infer::fudge","",N,N],[12,"infcx","","",251,N],[12,"type_variables","","",251,N],[12,"region_vars","","",251,N],[12,"origin","","",251,N],[11,"fudge_regions_if_ok","rustc::infer","This rather funky routine is used while processing expected types. What happens here is that we want to propagate a coercion through the return type of a fn to its argument. Consider the type of `Option::Some`, which is basically `for<T> fn(T) -> Option<T>`. So if we have an expression `Some(&[1, 2, 3])`, and that has the expected type `Option<&[u32]>`, we would like to type check `&[1, 2, 3]` with the expectation of `&[u32]`. This will cause us to coerce from `&[u32; 3]` to `&[u32]` and make the users life more pleasant.",209,[[["self"],["regionvariableorigin"],["f"]],["result"]]],[11,"tcx","rustc::infer::fudge","",251,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",251,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",251,[[["self"],["region"]],["region"]]],[0,"glb","rustc::infer","",N,N],[3,"Glb","rustc::infer::glb","\"Greatest lower bound\" (common subtype)",N,N],[12,"fields","","",252,N],[12,"a_is_expected","","",252,N],[11,"new","","",252,[[["combinefields"],["bool"]],["glb"]]],[11,"tag","","",252,[[["self"]],["str"]]],[11,"tcx","","",252,[[["self"]],["tyctxt"]]],[11,"a_is_expected","","",252,[[["self"]],["bool"]]],[11,"relate_with_variance","","",252,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",252,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",252,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",252,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[11,"infcx","","",252,[[["self"]],["inferctxt"]]],[11,"cause","","",252,[[["self"]],["obligationcause"]]],[11,"relate_bound","","",252,[[["self"],["ty"],["ty"],["ty"]],["relateresult"]]],[0,"higher_ranked","rustc::infer","Helper routines for higher-ranked things. See the `doc` module at the end of the file for details.",N,N],[3,"HrMatchResult","rustc::infer::higher_ranked","",N,N],[12,"value","","",253,N],[5,"var_ids","","",N,[[["combinefields"],["btreemap"]],["vec",["regionvid"]]]],[5,"is_var_in_set","","",N,N],[5,"fold_regions_in","","",N,[[["tyctxt"],["t"],["f"]],["t"]]],[11,"higher_ranked_sub","rustc::infer::combine","",238,[[["self"],["binder"],["binder"],["bool"]],["relateresult",["binder"]]]],[11,"higher_ranked_match","","The value consists of a pair `(t, u)` where `t` is the matcher and `u` is a value. The idea is to find a substitution `S` such that `S(t) == b`, and then return `S(u)`. In other words, find values for the late-bound regions in `a` that can make `t == b` and then replace the LBR in `u` with those values.",238,[[["self"],["binder"],["t"],["bool"]],["relateresult",["hrmatchresult"]]]],[11,"higher_ranked_lub","","",238,[[["self"],["binder"],["binder"],["bool"]],["relateresult",["binder"]]]],[11,"higher_ranked_glb","","",238,[[["self"],["binder"],["binder"],["bool"]],["relateresult",["binder"]]]],[11,"tainted_regions","rustc::infer","",209,[[["self"],["combinedsnapshot"],["region"],["taintdirections"]],["fxhashset",["region"]]]],[11,"region_vars_confined_to_snapshot","","Returns the set of region variables that do not affect any types/regions which existed before `snapshot` was started. This is used in the sub/lub/glb computations. The idea here is that when we are computing lub/glb of two regions, we sometimes create intermediate region variables. Those region variables may touch some of the skolemized or other \"forbidden\" regions we created to replace bound regions, but they don't really represent an \"external\" constraint.",209,[[["self"],["combinedsnapshot"]],["vec",["regionvid"]]]],[11,"skolemize_late_bound_regions","","Replace all regions bound by `binder` with skolemized regions and return a map indicating which bound-region was replaced with what skolemized region. This is the first step of checking subtyping when higher-ranked things are involved.",209,N],[11,"leak_check","","Searches the region constraints created since `snapshot` was started and checks to determine whether any of the skolemized regions created in `skol_map` would \"escape\" -- meaning that they are related to other regions in some way. If so, the higher-ranked subtyping doesn't hold. See `README.md` for more details.",209,[[["self"],["bool"],["span"],["skolemizationmap"],["combinedsnapshot"]],["relateresult"]]],[11,"plug_leaks","","This code converts from skolemized regions back to late-bound regions. It works by replacing each region in the taint set of a skolemized region with a bound-region. The bound region will be bound by the outer-most binder in `value`; the caller must ensure that there is such a binder and it is the right place.",209,[[["self"],["skolemizationmap"],["combinedsnapshot"],["t"]],["t"]]],[11,"pop_skolemized","","Pops the skolemized regions found in `skol_map` from the region inference context. Whenever you create skolemized regions via `skolemize_late_bound_regions`, they must be popped before you commit the enclosing snapshot (if you do not commit, e.g. within a probe or as a result of an error, then this is not necessary, as popping happens as part of the rollback).",209,[[["self"],["skolemizationmap"],["combinedsnapshot"]]]],[0,"lattice","","Lattice Variables",N,N],[5,"super_lattice_tys","rustc::infer::lattice","",N,[[["l"],["ty"],["ty"]],["relateresult",["ty"]]]],[8,"LatticeDir","","",N,N],[10,"infcx","","",254,[[["self"]],["inferctxt"]]],[10,"cause","","",254,[[["self"]],["obligationcause"]]],[10,"relate_bound","","",254,[[["self"],["ty"],["ty"],["ty"]],["relateresult"]]],[0,"lexical_region_resolve","rustc::infer","The code to do lexical region resolution.",N,N],[3,"LexicalRegionResolutions","rustc::infer::lexical_region_resolve","Contains the result of lexical region resolution. Offers methods to lookup up the final value of a region variable.",N,N],[12,"values","","",255,N],[12,"error_region","","",255,N],[3,"RegionAndOrigin","","",N,N],[12,"region","","",256,N],[12,"origin","","",256,N],[3,"LexicalResolver","","",N,N],[12,"region_rels","","",257,N],[12,"var_infos","","",257,N],[12,"data","","",257,N],[4,"VarValue","","",N,N],[13,"Value","","",258,N],[13,"ErrorValue","","",258,N],[4,"RegionResolutionError","","",N,N],[13,"ConcreteFailure","","`ConcreteFailure(o, a, b)`:",259,N],[13,"GenericBoundFailure","","`GenericBoundFailure(p, s, a)",259,N],[13,"SubSupConflict","","`SubSupConflict(v, sub_origin, sub_r, sup_origin, sup_r)`:",259,N],[5,"resolve","","This function performs lexical region resolution given a complete set of constraints and variable origins. It performs a fixed-point iteration to find region values which satisfy all constraints, assuming such values can be found. It returns the final values of all the variables as well as a set of errors that must be reported.",N,N],[0,"graphviz","","This module provides linkage between libgraphviz traits and `rustc::middle::typeck::infer::region_constraints`, generating a rendering of the graph represented by the list of `Constraint` instances (which make up the edges of the graph), as well as the origin for each constraint (which are attached to the labels on each edge).",N,N],[3,"ConstraintGraph","rustc::infer::lexical_region_resolve::graphviz","",N,N],[12,"graph_name","","",260,N],[12,"region_rels","","",260,N],[12,"map","","",260,N],[12,"node_ids","","",260,N],[4,"Node","","",N,N],[13,"RegionVid","","",261,N],[13,"Region","","",261,N],[4,"Edge","","",N,N],[13,"Constraint","","",262,N],[13,"EnclScope","","",262,N],[5,"print_help_message","","",N,[[]]],[5,"maybe_print_constraints_for","","",N,[[["regionconstraintdata"],["regionrelations"]]]],[5,"constraint_to_nodes","","",N,N],[5,"edge_to_nodes","","",N,N],[5,"dump_region_data_to","","",N,[[["regionrelations"],["btreemap"],["str"]],["result"]]],[6,"ConstraintMap","","",N,N],[11,"clone","","",261,[[["self"]],["node"]]],[11,"hash","","",261,N],[11,"eq","","",261,[[["self"],["node"]],["bool"]]],[11,"ne","","",261,[[["self"],["node"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",261,N],[11,"fmt","","",261,[[["self"],["formatter"]],["result"]]],[11,"clone","","",262,[[["self"]],["edge"]]],[11,"eq","","",262,[[["self"],["edge"]],["bool"]]],[11,"ne","","",262,[[["self"],["edge"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",262,N],[11,"fmt","","",262,[[["self"],["formatter"]],["result"]]],[11,"new","","",260,[[["string"],["regionrelations"],["btreemap"]],["constraintgraph"]]],[11,"graph_id","","",260,[[["self"]],["id"]]],[11,"node_id","","",260,[[["self"],["node"]],["id"]]],[11,"node_label","","",260,[[["self"],["node"]],["labeltext"]]],[11,"edge_label","","",260,[[["self"],["edge"]],["labeltext"]]],[11,"nodes","","",260,[[["self"]],["nodes",["node"]]]],[11,"edges","","",260,[[["self"]],["edges",["edge"]]]],[11,"source","","",260,[[["self"],["edge"]],["node"]]],[11,"target","","",260,[[["self"],["edge"]],["node"]]],[6,"RegionGraph","rustc::infer::lexical_region_resolve","",N,N],[11,"clone","","",258,[[["self"]],["varvalue"]]],[11,"fmt","","",258,[[["self"],["formatter"]],["result"]]],[11,"clone","","",259,[[["self"]],["regionresolutionerror"]]],[11,"fmt","","",259,[[["self"],["formatter"]],["result"]]],[11,"infer_variable_values","","",257,[[["self"],["vec"]],["lexicalregionresolutions"]]],[11,"num_vars","","",257,[[["self"]],["usize"]]],[11,"construct_var_data","","Initially, the value for all variables is set to `'empty`, the empty region. The `expansion` phase will grow this larger.",257,[[["self"],["tyctxt"]],["lexicalregionresolutions"]]],[11,"dump_constraints","","",257,[[["self"],["regionrelations"]]]],[11,"expand_givens","","",257,[[["self"],["graph"]]]],[11,"expansion","","",257,[[["self"],["lexicalregionresolutions"]]]],[11,"expand_node","","",257,[[["self"],["region"],["regionvid"],["varvalue"]],["bool"]]],[11,"lub_concrete_regions","","",257,[[["self"],["region"],["region"]],["region"]]],[11,"collect_errors","","After expansion is complete, go and check upper bounds (i.e., cases where the region cannot grow larger than a fixed point) and check that they are satisfied.",257,[[["self"],["lexicalregionresolutions"],["vec"]]]],[11,"collect_var_errors","","Go over the variables that were declared to be error variables and create a `RegionResolutionError` for each of them.",257,[[["self"],["lexicalregionresolutions"],["graph"],["vec"]]]],[11,"construct_graph","","",257,[[["self"]],["graph",["constraint"]]]],[11,"collect_error_for_expanding_node","","",257,N],[11,"collect_concrete_regions","","",257,N],[11,"iterate_until_fixed_point","","",257,[[["self"],["str"],["f"]]]],[11,"bound_is_met","","",257,[[["self"],["verifybound"],["lexicalregionresolutions"],["region"]],["bool"]]],[11,"fmt","","",256,[[["self"],["formatter"]],["result"]]],[11,"normalize","","",255,[[["self"],["region"]],["region"]]],[11,"value","","",255,[[["self"],["regionvid"]],["varvalue"]]],[11,"value_mut","","",255,[[["self"],["regionvid"]],["varvalue"]]],[11,"resolve_var","","",255,[[["self"],["regionvid"]],["region"]]],[0,"lub","rustc::infer","",N,N],[3,"Lub","rustc::infer::lub","\"Least upper bound\" (common supertype)",N,N],[12,"fields","","",263,N],[12,"a_is_expected","","",263,N],[11,"new","","",263,[[["combinefields"],["bool"]],["lub"]]],[11,"tag","","",263,[[["self"]],["str"]]],[11,"tcx","","",263,[[["self"]],["tyctxt"]]],[11,"a_is_expected","","",263,[[["self"]],["bool"]]],[11,"relate_with_variance","","",263,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",263,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",263,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",263,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[11,"infcx","","",263,[[["self"]],["inferctxt"]]],[11,"cause","","",263,[[["self"]],["obligationcause"]]],[11,"relate_bound","","",263,[[["self"],["ty"],["ty"],["ty"]],["relateresult"]]],[0,"outlives","rustc::infer","Various code related to computing outlives relations.",N,N],[0,"env","rustc::infer::outlives","",N,N],[3,"OutlivesEnvironment","rustc::infer::outlives::env","The `OutlivesEnvironment` collects information about what outlives what in a given type-checking setting. For example, if we have a where-clause like `where T: 'a` in scope, then the `OutlivesEnvironment` would record that (in its `region_bound_pairs` field). Similarly, it contains methods for processing and adding implied bounds into the outlives environment.",N,N],[12,"param_env","","",264,N],[12,"free_region_map","","",264,N],[12,"region_bound_pairs","","",264,N],[11,"clone","","",264,[[["self"]],["outlivesenvironment"]]],[11,"new","","",264,[[["paramenv"]],["self"]]],[11,"free_region_map","","Borrows current value of the `free_region_map`.",264,[[["self"]],["freeregionmap"]]],[11,"region_bound_pairs","","Borrows current value of the `region_bound_pairs`.",264,N],[11,"into_free_region_map","","Returns ownership of the `free_region_map`.",264,[[["self"]],["freeregionmap"]]],[11,"push_snapshot_pre_closure","","This is a hack to support the old-skool regionck, which processes region constraints from the main function and the closure together. In that context, when we enter a closure, we want to be able to \"save\" the state of the surrounding a function. We can then add implied bounds and the like from the closure arguments into the environment -- these should only apply in the closure body, so once we exit, we invoke `pop_snapshot_post_closure` to remove them.",264,[[["self"]],["usize"]]],[11,"pop_snapshot_post_closure","","See `push_snapshot_pre_closure`.",264,[[["self"],["usize"]]]],[11,"add_implied_bounds","","This method adds \"implied bounds\" into the outlives environment. Implied bounds are outlives relationships that we can deduce on the basis that certain types must be well-formed -- these are either the types that appear in the function signature or else the input types to an impl. For example, if you have a function like",264,N],[11,"add_outlives_bounds","","Processes outlives bounds that are known to hold, whether from implied or other sources.",264,[[["self"],["option",["inferctxt"]],["i"]]]],[0,"free_region_map","rustc::infer::outlives","",N,N],[3,"FreeRegionMap","rustc::infer::outlives::free_region_map","",N,N],[12,"relation","","",265,N],[5,"is_free","","",N,[[["region"]],["bool"]]],[5,"is_free_or_static","","",N,[[["region"]],["bool"]]],[8,"FreeRegionRelations","","The NLL region handling code represents free region relations in a slightly different way; this trait allows functions to be abstract over which version is in use.",N,N],[10,"sub_free_regions","","Tests whether `r_a <= r_b`. Both must be free regions or `'static`.",266,[[["self"],["region"],["region"]],["bool"]]],[11,"clone","","",265,[[["self"]],["freeregionmap"]]],[11,"encode","","",265,[[["self"],["__s"]],["result"]]],[11,"decode","","",265,[[["__d"]],["result",["freeregionmap"]]]],[11,"fmt","","",265,[[["self"],["formatter"]],["result"]]],[11,"new","","",265,[[],["self"]]],[11,"is_empty","","",265,[[["self"]],["bool"]]],[11,"relate_regions","","",265,[[["self"],["region"],["region"]]]],[11,"lub_free_regions","","Compute the least-upper-bound of two free regions. In some cases, this is more conservative than necessary, in order to avoid making arbitrary choices. See `TransitiveRelation::postdom_upper_bound` for more details.",265,[[["self"],["tyctxt"],["region"],["region"]],["region"]]],[11,"sub_free_regions","","",265,[[["self"],["region"],["region"]],["bool"]]],[11,"hash_stable","","",265,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"lift_to_tcx","","",265,[[["self"],["tyctxt"]],["option",["freeregionmap"]]]],[0,"obligations","rustc::infer::outlives","Code that handles \"type-outlives\" constraints like `T: 'a`. This is based on the `outlives_components` function defined on the tcx, but it adds a bit of heuristics on top, in particular to deal with associated types and projections.",N,N],[3,"TypeOutlives","rustc::infer::outlives::obligations","The `TypeOutlives` struct has the job of \"lowering\" a `T: 'a` obligation into a series of `'a: 'b` constraints and \"verifys\", as described on the module comment. The final constraints are emitted via a \"delegate\" of type `D` -- this is usually the `infcx`, which accrues them into the `region_obligations` code, but for NLL we use something else.",N,N],[12,"delegate","","",267,N],[12,"tcx","","",267,N],[12,"region_bound_pairs","","",267,N],[12,"implicit_region_bound","","",267,N],[12,"param_env","","",267,N],[8,"TypeOutlivesDelegate","","",N,N],[10,"push_sub_region_constraint","","",268,[[["self"],["subregionorigin"],["region"],["region"]]]],[10,"push_verify","","",268,[[["self"],["subregionorigin"],["generickind"],["region"],["verifybound"]]]],[11,"register_region_obligation","rustc::infer","Registers that the given region obligation must be resolved from within the scope of `body_id`. These regions are enqueued and later processed by regionck, when full type information is available (see `region_obligations` field for more information).",209,[[["self"],["nodeid"],["regionobligation"]]]],[11,"take_registered_region_obligations","","Trait queries just want to pass back type obligations \"as is\"",209,[[["self"]],["vec"]]],[11,"process_registered_region_obligations","","Process the region obligations that must be proven (during `regionck`) for the given `body_id`, given information about the region bounds in scope and so forth. This function must be invoked for all relevant body-ids before region inference is done (or else an assert will fire).",209,N],[11,"type_must_outlive","","Processes a single ad-hoc region obligation that was not registered in advance.",209,N],[11,"new","rustc::infer::outlives::obligations","",267,N],[11,"type_must_outlive","","Adds constraints to inference such that `T: 'a` holds (or reports an error if it cannot).",267,[[["self"],["subregionorigin"],["ty"],["region"]]]],[11,"components_must_outlive","","",267,[[["self"],["subregionorigin"],["vec",["component"]],["region"]]]],[11,"param_ty_must_outlive","","",267,[[["self"],["subregionorigin"],["region"],["paramty"]]]],[11,"projection_must_outlive","","",267,[[["self"],["subregionorigin"],["region"],["projectionty"]]]],[11,"type_bound","","",267,[[["self"],["ty"]],["verifybound"]]],[11,"param_bound","","",267,[[["self"],["paramty"]],["verifybound"]]],[11,"projection_declared_bounds","","",267,[[["self"],["projectionty"]],["vec",["region"]]]],[11,"projection_bound","","",267,[[["self"],["vec",["region"]],["projectionty"]],["verifybound"]]],[11,"recursive_type_bound","","",267,[[["self"],["ty"]],["verifybound"]]],[11,"declared_generic_bounds_from_env","","",267,[[["self"],["generickind"]],["vec",["region"]]]],[11,"declared_projection_bounds_from_trait","","Given a projection like `<T as Foo<'x>>::Bar`, returns any bounds declared in the trait definition. For example, if the trait were",267,[[["self"],["projectionty"]],["vec",["region"]]]],[11,"region_bounds_declared_on_associated_item","","Given the def-id of an associated item, returns any region bounds attached to that associated item from the trait definition.",267,[[["self"],["defid"]],["vec",["region"]]]],[11,"collect_outlives_from_predicate_list","","Searches through a predicate list for a predicate `T: 'a`.",267,[[["self"],["ty"],["i"]],["vec",["region"]]]],[0,"region_constraints","rustc::infer","See README.md",N,N],[3,"RegionConstraintCollector","rustc::infer::region_constraints","",N,N],[12,"var_infos","","For each `RegionVid`, the corresponding `RegionVariableOrigin`.",269,N],[12,"data","","",269,N],[12,"lubs","","For a given pair of regions (R1, R2), maps to a region R3 that is designated as their LUB (edges R1 <= R3 and R2 <= R3 exist). This prevents us from making many such regions.",269,N],[12,"glbs","","For a given pair of regions (R1, R2), maps to a region R3 that is designated as their GLB (edges R3 <= R1 and R3 <= R2 exist). This prevents us from making many such regions.",269,N],[12,"bound_count","","Global counter used during the GLB algorithm to create unique names for fresh bound regions",269,N],[12,"undo_log","","The undo log records actions that might later be undone.",269,N],[12,"unification_table","","When we add a R1 == R2 constriant, we currently add (a) edges R1 <= R2 and R2 <= R1 and (b) we unify the two regions in this table. You can then call `opportunistic_resolve_var` early which will map R1 and R2 to some common region (i.e., either R1 or R2). This is important when dropck and other such code is iterating to a fixed point, because otherwise we sometimes would wind up with a fresh stream of region variables that have been equated but appear distinct.",269,N],[12,"any_unifications","","a flag set to true when we perform any unifications; this is used to micro-optimize `take_and_reset_data`",269,N],[3,"RegionConstraintData","","The full set of region constraints gathered up by the collector. Describes constraints between the region variables and other regions, as well as other conditions that must be verified, or assumptions that can be made.",N,N],[12,"constraints","","Constraints of the form `A <= B`, where either `A` or `B` can be a region variable (or neither, as it happens).",270,N],[12,"verifys","","A \"verify\" is something that we need to verify after inference is done, but which does not directly affect inference in any way.",270,N],[12,"givens","","A \"given\" is a relationship that is known to hold. In particular, we often know from closure fn signatures that a particular free region must be a subregion of a region variable:",270,N],[3,"Verify","","VerifyGenericBound(T, _, R, RS): The parameter type `T` (or associated type) must outlive the region `R`. `T` is known to outlive `RS`. Therefore verify that `R <= RS[i]` for some `i`. Inference variables may be involved (but this verification step doesn't influence inference).",N,N],[12,"kind","","",271,N],[12,"origin","","",271,N],[12,"region","","",271,N],[12,"bound","","",271,N],[3,"TwoRegions","","",N,N],[12,"a","","",272,N],[12,"b","","",272,N],[3,"RegionVariableInfo","","",N,N],[12,"origin","","",273,N],[12,"universe","","",273,N],[3,"RegionSnapshot","","",N,N],[12,"length","","",274,N],[12,"region_snapshot","","",274,N],[12,"any_unifications","","",274,N],[3,"TaintDirections","","When working with skolemized regions, we often wish to find all of the regions that are either reachable from a skolemized region, or which can reach a skolemized region, or both. We call such regions tained regions.  This struct allows you to decide what set of tainted regions you want.",N,N],[12,"incoming","","",275,N],[12,"outgoing","","",275,N],[4,"Constraint","","A constraint that influences the inference process.",N,N],[13,"VarSubVar","","One region variable is subregion of another",276,N],[13,"RegSubVar","","Concrete region is subregion of region variable",276,N],[13,"VarSubReg","","Region variable is subregion of concrete region. This does not directly affect inference, but instead is checked after inference is complete.",276,N],[13,"RegSubReg","","A constraint where neither side is a variable. This does not directly affect inference, but instead is checked after inference is complete.",276,N],[4,"GenericKind","","",N,N],[13,"Param","","",277,N],[13,"Projection","","",277,N],[4,"VerifyBound","","When we introduce a verification step, we wish to test that a particular region (let's call it `'min`) meets some bound. The bound is described the by the following grammar:",N,N],[13,"AnyRegion","","B = exists {R} --> some 'r in {R} must outlive 'min",278,N],[13,"AllRegions","","B = forall {R} --> all 'r in {R} must outlive 'min",278,N],[13,"AnyBound","","B = exists {B} --> 'min must meet some bound b in {B}",278,N],[13,"AllBounds","","B = forall {B} --> 'min must meet all bounds b in {B}",278,N],[4,"UndoLogEntry","","",N,N],[13,"OpenSnapshot","","Pushed when we start a snapshot.",279,N],[13,"CommitedSnapshot","","Replaces an `OpenSnapshot` when a snapshot is committed, but that snapshot is not the root. If the root snapshot is unrolled, all nested snapshots must be committed.",279,N],[13,"AddVar","","We added `RegionVid`",279,N],[13,"AddConstraint","","We added the given `constraint`",279,N],[13,"AddVerify","","We added the given `verify`",279,N],[13,"AddGiven","","We added the given `given`",279,N],[13,"AddCombination","","We added a GLB/LUB \"combination variable\"",279,N],[13,"Purged","","During skolemization, we sometimes purge entries from the undo log in a kind of minisnapshot (unlike other snapshots, this purging actually takes place on success). In that case, we replace the corresponding entry with `Noop` so as to avoid the need to do a bunch of swapping. (We can't use `swap_remove` as the order of the vector is important.)",279,N],[4,"CombineMapType","","",N,N],[13,"Lub","","",280,N],[13,"Glb","","",280,N],[0,"taint","","",N,N],[3,"TaintSet","rustc::infer::region_constraints::taint","",N,N],[12,"directions","","",281,N],[12,"regions","","",281,N],[11,"fmt","","",281,[[["self"],["formatter"]],["result"]]],[11,"new","","",281,[[["taintdirections"],["region"]],["self"]]],[11,"fixed_point","","",281,N],[11,"into_set","","",281,[[["self"]],["fxhashset",["region"]]]],[11,"len","","",281,[[["self"]],["usize"]]],[11,"add_edge","","",281,[[["self"],["region"],["region"]]]],[6,"VarInfos","rustc::infer::region_constraints","",N,N],[6,"CombineMap","","",N,N],[11,"fmt","","",270,[[["self"],["formatter"]],["result"]]],[11,"default","","",270,[[],["regionconstraintdata"]]],[11,"clone","","",270,[[["self"]],["regionconstraintdata"]]],[11,"clone","","",276,[[["self"]],["constraint"]]],[11,"eq","","",276,[[["self"],["constraint"]],["bool"]]],[11,"ne","","",276,[[["self"],["constraint"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",276,N],[11,"hash","","",276,N],[11,"fmt","","",276,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",276,[[["self"],["constraint"]],["option",["ordering"]]]],[11,"lt","","",276,[[["self"],["constraint"]],["bool"]]],[11,"le","","",276,[[["self"],["constraint"]],["bool"]]],[11,"gt","","",276,[[["self"],["constraint"]],["bool"]]],[11,"ge","","",276,[[["self"],["constraint"]],["bool"]]],[11,"cmp","","",276,[[["self"],["constraint"]],["ordering"]]],[11,"fmt","","",271,[[["self"],["formatter"]],["result"]]],[11,"clone","","",271,[[["self"]],["verify"]]],[11,"clone","","",277,[[["self"]],["generickind"]]],[11,"eq","","",277,[[["self"],["generickind"]],["bool"]]],[11,"ne","","",277,[[["self"],["generickind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",277,N],[11,"fmt","","",278,[[["self"],["formatter"]],["result"]]],[11,"clone","","",278,[[["self"]],["verifybound"]]],[11,"clone","","",272,[[["self"]],["tworegions"]]],[11,"eq","","",272,[[["self"],["tworegions"]],["bool"]]],[11,"ne","","",272,[[["self"],["tworegions"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",272,N],[11,"hash","","",272,N],[11,"clone","","",279,[[["self"]],["undologentry"]]],[11,"eq","","",279,[[["self"],["undologentry"]],["bool"]]],[11,"ne","","",279,[[["self"],["undologentry"]],["bool"]]],[11,"clone","","",280,[[["self"]],["combinemaptype"]]],[11,"eq","","",280,[[["self"],["combinemaptype"]],["bool"]]],[11,"fmt","","",273,[[["self"],["formatter"]],["result"]]],[11,"clone","","",273,[[["self"]],["regionvariableinfo"]]],[11,"fmt","","",275,[[["self"],["formatter"]],["result"]]],[11,"incoming","","",275,[[],["self"]]],[11,"outgoing","","",275,[[],["self"]]],[11,"both","","",275,[[],["self"]]],[11,"new","","",269,[[],["regionconstraintcollector"]]],[11,"num_region_vars","","",269,[[["self"]],["usize"]]],[11,"region_constraint_data","","",269,[[["self"]],["regionconstraintdata"]]],[11,"into_infos_and_data","","Once all the constraints have been gathered, extract out the final data.",269,N],[11,"take_and_reset_data","","Takes (and clears) the current set of constraints. Note that the set of variables remains intact, but all relationships between them are reset.  This is used during NLL checking to grab the set of constraints that arose from a particular operation.",269,[[["self"]],["regionconstraintdata"]]],[11,"data","","",269,[[["self"]],["regionconstraintdata"]]],[11,"in_snapshot","","",269,[[["self"]],["bool"]]],[11,"start_snapshot","","",269,[[["self"]],["regionsnapshot"]]],[11,"commit","","",269,[[["self"],["regionsnapshot"]]]],[11,"rollback_to","","",269,[[["self"],["regionsnapshot"]]]],[11,"rollback_undo_entry","","",269,[[["self"],["undologentry"]]]],[11,"new_region_var","","",269,[[["self"],["universeindex"],["regionvariableorigin"]],["regionvid"]]],[11,"var_universe","","Returns the universe for the given variable.",269,[[["self"],["regionvid"]],["universeindex"]]],[11,"var_origin","","Returns the origin for the given variable.",269,[[["self"],["regionvid"]],["regionvariableorigin"]]],[11,"pop_skolemized","","Removes all the edges to/from the skolemized regions that are in `skols`. This is used after a higher-ranked operation completes to remove all trace of the skolemized regions created in that time.",269,[[["self"],["universeindex"],["fxhashset"],["regionsnapshot"]]]],[11,"new_bound","","",269,[[["self"],["tyctxt"],["debruijnindex"]],["region"]]],[11,"add_constraint","","",269,[[["self"],["constraint"],["subregionorigin"]]]],[11,"add_verify","","",269,[[["self"],["verify"]]]],[11,"add_given","","",269,[[["self"],["region"],["regionvid"]]]],[11,"make_eqregion","","",269,[[["self"],["subregionorigin"],["region"],["region"]]]],[11,"make_subregion","","",269,[[["self"],["subregionorigin"],["region"],["region"]]]],[11,"verify_generic_bound","","See `Verify::VerifyGenericBound`",269,[[["self"],["subregionorigin"],["generickind"],["region"],["verifybound"]]]],[11,"lub_regions","","",269,[[["self"],["tyctxt"],["subregionorigin"],["region"],["region"]],["region"]]],[11,"glb_regions","","",269,[[["self"],["tyctxt"],["subregionorigin"],["region"],["region"]],["region"]]],[11,"opportunistic_resolve_var","","",269,[[["self"],["tyctxt"],["regionvid"]],["region"]]],[11,"combine_map","","",269,[[["self"],["combinemaptype"]],["fxhashmap"]]],[11,"combine_vars","","",269,[[["self"],["tyctxt"],["combinemaptype"],["region"],["region"],["subregionorigin"]],["region"]]],[11,"universe","","",269,[[["self"],["region"]],["universeindex"]]],[11,"vars_created_since_snapshot","","",269,[[["self"],["regionsnapshot"]],["vec",["regionvid"]]]],[11,"tainted","","Computes all regions that have been related to `r0` since the mark `mark` was made---`r0` itself will be the first entry. The `directions` parameter controls what kind of relations are considered. For example, one can say that only \"incoming\" edges to `r0` are desired, in which case one will get the set of regions `{r|r <= r0}`. This is used when checking whether skolemized regions are being improperly related to other regions.",269,[[["self"],["tyctxt"],["regionsnapshot"],["region"],["taintdirections"]],["fxhashset",["region"]]]],[11,"fmt","","",274,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",277,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",277,[[["self"],["formatter"]],["result"]]],[11,"to_ty","","",277,[[["self"],["tyctxt"]],["ty"]]],[11,"for_each_region","","",278,[[["self"],["fnmut"]]]],[11,"must_hold","","",278,[[["self"]],["bool"]]],[11,"cannot_hold","","",278,[[["self"]],["bool"]]],[11,"or","","",278,[[["self"],["verifybound"]],["verifybound"]]],[11,"and","","",278,[[["self"],["verifybound"]],["verifybound"]]],[11,"is_empty","","True if this region constraint data contains no constraints.",270,[[["self"]],["bool"]]],[0,"resolve","rustc::infer","",N,N],[3,"OpportunisticTypeResolver","rustc::infer::resolve","The opportunistic type resolver can be used at any time. It simply replaces type variables that have been unified with the things they have been unified with (similar to `shallow_resolve`, but deep). This is useful for printing messages etc but also required at various points for correctness.",N,N],[12,"infcx","","",282,N],[3,"OpportunisticTypeAndRegionResolver","","The opportunistic type and region resolver is similar to the opportunistic type resolver, but also opportunistically resolves regions. It is useful for canonicalization.",N,N],[12,"infcx","","",283,N],[3,"UnresolvedTypeFinder","","The unresolved type finder walks your type and searches for type variables that don't yet have a value. They get pushed into a vector. It does not construct the fully resolved type (which might involve some hashing and so forth).",N,N],[12,"infcx","","",284,N],[3,"FullTypeResolver","","",N,N],[12,"infcx","","",285,N],[12,"err","","",285,N],[5,"fully_resolve","","Full type resolution replaces all type and region variables with their concrete results. If any variable cannot be replaced (never unified, etc) then an `Err` result is returned.",N,[[["inferctxt"],["t"]],["fixupresult"]]],[11,"new","","",282,[[["inferctxt"]],["self"]]],[11,"tcx","","",282,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",282,[[["self"],["ty"]],["ty"]]],[11,"new","","",283,[[["inferctxt"]],["self"]]],[11,"tcx","","",283,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",283,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",283,[[["self"],["region"]],["region"]]],[11,"new","","",284,[[["inferctxt"]],["self"]]],[11,"visit_ty","","",284,[[["self"],["ty"]],["bool"]]],[11,"tcx","","",285,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",285,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",285,[[["self"],["region"]],["region"]]],[0,"sub","rustc::infer","",N,N],[3,"Sub","rustc::infer::sub","Ensures `a` is made a subtype of `b`. Returns `a` on success.",N,N],[12,"fields","","",286,N],[12,"a_is_expected","","",286,N],[11,"new","","",286,[[["combinefields"],["bool"]],["sub"]]],[11,"with_expected_switched","","",286,[[["self"],["f"]],["r"]]],[11,"tag","","",286,[[["self"]],["str"]]],[11,"tcx","","",286,[[["self"]],["tyctxt"]]],[11,"a_is_expected","","",286,[[["self"]],["bool"]]],[11,"with_cause","","",286,[[["self"],["cause"],["f"]],["r"]]],[11,"relate_with_variance","","",286,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",286,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",286,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",286,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[0,"type_variable","rustc::infer","",N,N],[3,"TypeVariableTable","rustc::infer::type_variable","",N,N],[12,"values","","",287,N],[12,"eq_relations","","Two variables are unified in `eq_relations` when we have a constraint `?X == ?Y`. This table also stores, for each key, the known value.",287,N],[12,"sub_relations","","Two variables are unified in `eq_relations` when we have a constraint `?X <: ?Y` or a constraint `?Y <: ?X`. This second table exists only to help with the occurs check. In particular, we want to report constraints like these as an occurs check violation:",287,N],[3,"TypeVariableData","","",N,N],[12,"origin","","",288,N],[12,"diverging","","",288,N],[3,"Snapshot","","",N,N],[12,"snapshot","","",289,N],[12,"eq_snapshot","","",289,N],[12,"sub_snapshot","","",289,N],[3,"Instantiate","","",N,N],[12,"vid","","",290,N],[3,"Delegate","","",N,N],[3,"TyVidEqKey","","These structs (a newtyped TyVid) are used as the unification key for the `eq_relations`; they carry a `TypeVariableValue` along with them.",N,N],[12,"vid","","",291,N],[12,"phantom","","",291,N],[4,"TypeVariableOrigin","","Reasons to create a type inference variable",N,N],[13,"MiscVariable","","",292,N],[13,"NormalizeProjectionType","","",292,N],[13,"TypeInference","","",292,N],[13,"TypeParameterDefinition","","",292,N],[13,"ClosureSynthetic","","one of the upvars or closure kind parameters in a `ClosureSubsts` (before it has been determined)",292,N],[13,"SubstitutionPlaceholder","","",292,N],[13,"AutoDeref","","",292,N],[13,"AdjustmentType","","",292,N],[13,"DivergingStmt","","",292,N],[13,"DivergingBlockExpr","","",292,N],[13,"DivergingFn","","",292,N],[13,"LatticeVariable","","",292,N],[13,"Generalized","","",292,N],[4,"TypeVariableValue","","",N,N],[13,"Known","","",293,N],[12,"value","rustc::infer::type_variable::TypeVariableValue","",293,N],[13,"Unknown","rustc::infer::type_variable","",293,N],[12,"universe","rustc::infer::type_variable::TypeVariableValue","",293,N],[6,"TypeVariableMap","rustc::infer::type_variable","",N,N],[11,"clone","","",292,[[["self"]],["typevariableorigin"]]],[11,"fmt","","",292,[[["self"],["formatter"]],["result"]]],[11,"clone","","",293,[[["self"]],["typevariablevalue"]]],[11,"fmt","","",293,[[["self"],["formatter"]],["result"]]],[11,"known","","If this value is known, returns the type it is known to be. Otherwise, `None`.",293,[[["self"]],["option",["ty"]]]],[11,"is_unknown","","",293,[[["self"]],["bool"]]],[11,"new","","",287,[[],["typevariabletable"]]],[11,"var_diverges","","Returns the diverges flag given when `vid` was created.",287,[[["self"],["tyvid"]],["bool"]]],[11,"var_origin","","Returns the origin that was given when `vid` was created.",287,[[["self"],["tyvid"]],["typevariableorigin"]]],[11,"equate","","Records that `a == b`, depending on `dir`.",287,[[["self"],["tyvid"],["tyvid"]]]],[11,"sub","","Records that `a <: b`, depending on `dir`.",287,[[["self"],["tyvid"],["tyvid"]]]],[11,"instantiate","","Instantiates `vid` with the type `ty`.",287,[[["self"],["tyvid"],["ty"]]]],[11,"new_var","","Creates a new type variable.",287,[[["self"],["universeindex"],["bool"],["typevariableorigin"]],["tyvid"]]],[11,"num_vars","","Returns the number of type variables created thus far.",287,[[["self"]],["usize"]]],[11,"root_var","","Returns the \"root\" variable of `vid` in the `eq_relations` equivalence table. All type variables that have been equated will yield the same root variable (per the union-find algorithm), so `root_var(a) == root_var(b)` implies that `a == b` (transitively).",287,[[["self"],["tyvid"]],["tyvid"]]],[11,"sub_root_var","","Returns the \"root\" variable of `vid` in the `sub_relations` equivalence table. All type variables that have been are related via equality or subtyping will yield the same root variable (per the union-find algorithm), so `sub_root_var(a) == sub_root_var(b)` implies that:",287,[[["self"],["tyvid"]],["tyvid"]]],[11,"sub_unified","","True if `a` and `b` have same \"sub-root\" (i.e., exists some type X such that `forall i in {a, b}. (i <: X || X <: i)`.",287,[[["self"],["tyvid"],["tyvid"]],["bool"]]],[11,"probe","","Retrieves the type to which `vid` has been instantiated, if any.",287,[[["self"],["tyvid"]],["typevariablevalue"]]],[11,"replace_if_possible","","If `t` is a type-inference variable, and it has been instantiated, then return the with which it was instantiated. Otherwise, returns `t`.",287,[[["self"],["ty"]],["ty"]]],[11,"snapshot","","Creates a snapshot of the type variable state.  This snapshot must later be committed (`commit()`) or rolled back (`rollback_to()`).  Nested snapshots are permitted, but must be processed in a stack-like fashion.",287,[[["self"]],["snapshot"]]],[11,"rollback_to","","Undoes all changes since the snapshot was created. Any snapshots created since that point must already have been committed or rolled back.",287,[[["self"],["snapshot"]]]],[11,"commit","","Commits all changes since the snapshot was created, making them permanent (unless this snapshot was created within another snapshot). Any snapshots created since that point must already have been committed or rolled back.",287,[[["self"],["snapshot"]]]],[11,"types_created_since_snapshot","","Returns a map `{V1 -> V2}`, where the keys `{V1}` are ty-variables created during the snapshot, and the values `{V2}` are the root variables that they were unified with, along with their origin.",287,[[["self"],["snapshot"]],["typevariablemap"]]],[11,"types_escaping_snapshot","","Find the set of type variables that existed before `s` but which have only been unified since `s` started, and return the types with which they were unified. So if we had a type variable `V0`, then we started the snapshot, then we created a type variable `V1`, unifed `V0` with `T0`, and unified `V1` with `T1`, this function would return `{T0}`.",287,[[["self"],["snapshot"]],["vec",["ty"]]]],[11,"unsolved_variables","","Returns indices of all variables that are not yet instantiated.",287,[[["self"]],["vec",["tyvid"]]]],[11,"reverse","","",294,[[["vec"],["instantiate"]]]],[11,"clone","","",291,[[["self"]],["tyvideqkey"]]],[11,"fmt","","",291,[[["self"],["formatter"]],["result"]]],[11,"eq","","",291,[[["self"],["tyvideqkey"]],["bool"]]],[11,"ne","","",291,[[["self"],["tyvideqkey"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",291,N],[11,"from","","",291,[[["tyvid"]],["self"]]],[11,"index","","",291,[[["self"]],["u32"]]],[11,"from_index","","",291,[[["u32"]],["self"]]],[11,"tag","","",291,[[],["str"]]],[11,"unify_values","","",293,[[["self"],["self"]],["result",["noerror"]]]],[0,"unify_key","rustc::infer","",N,N],[3,"RegionVidKey","rustc::infer::unify_key","",N,N],[12,"min_vid","","The minimum region vid in the unification set. This is needed to have a canonical name for a type to prevent infinite recursion.",295,N],[8,"ToType","","",N,N],[10,"to_type","","",296,[[["self"],["tyctxt"]],["ty"]]],[11,"eq","","",295,[[["self"],["regionvidkey"]],["bool"]]],[11,"ne","","",295,[[["self"],["regionvidkey"]],["bool"]]],[11,"clone","","",295,[[["self"]],["regionvidkey"]]],[11,"fmt","","",295,[[["self"],["formatter"]],["result"]]],[11,"unify_values","","",295,[[["self"],["self"]],["result",["noerror"]]]],[6,"InferResult","rustc::infer","",N,N],[6,"Bound","","",N,N],[6,"UnitResult","","",N,N],[6,"FixupResult","","",N,N],[6,"SkolemizationMap","","A map returned by `skolemize_late_bound_regions()` indicating the skolemized region that each late-bound region was replaced with.",N,N],[11,"fmt","","",208,[[["self"],["formatter"]],["result"]]],[11,"clone","","",214,[[["self"]],["valuepairs"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"clone","","",210,[[["self"]],["typetrace"]]],[11,"clone","","",215,[[["self"]],["subregionorigin"]]],[11,"fmt","","",215,[[["self"],["formatter"]],["result"]]],[11,"clone","","",216,[[["self"]],["parameterorigin"]]],[11,"fmt","","",216,[[["self"],["formatter"]],["result"]]],[11,"clone","","",217,[[["self"]],["lateboundregionconversiontime"]]],[11,"fmt","","",217,[[["self"],["formatter"]],["result"]]],[11,"clone","","",218,[[["self"]],["regionvariableorigin"]]],[11,"fmt","","",218,[[["self"],["formatter"]],["result"]]],[11,"clone","","",219,[[["self"]],["nllregionvariableorigin"]]],[11,"fmt","","",219,[[["self"],["formatter"]],["result"]]],[11,"eq","","",219,[[["self"],["nllregionvariableorigin"]],["bool"]]],[11,"ne","","",219,[[["self"],["nllregionvariableorigin"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",219,N],[11,"hash","","",219,N],[11,"is_universal","","",219,[[["self"]],["bool"]]],[11,"is_existential","","",219,[[["self"]],["bool"]]],[11,"clone","","",220,[[["self"]],["fixuperror"]]],[11,"fmt","","",220,[[["self"],["formatter"]],["result"]]],[11,"clone","","",211,[[["self"]],["regionobligation"]]],[11,"fmt","","",220,[[["self"],["formatter"]],["result"]]],[11,"with_fresh_in_progress_tables","","Used only by `rustc_typeck` during body type-checking/inference, will initialize `in_progress_tables` with fresh `TypeckTables`.",212,[[["self"],["defid"]],["self"]]],[11,"enter","","",212,[[["self"],["f"]],["r"]]],[11,"unit","","",208,[[["self"]],["inferok"]]],[11,"into_value_registering_obligations","","Extract `value`, registering any obligations into `fulfill_cx`",208,N],[11,"into_obligations","","",208,[[["self"]],["predicateobligations"]]],[11,"is_in_snapshot","","",209,[[["self"]],["bool"]]],[11,"freshen","","",209,[[["self"],["t"]],["t"]]],[11,"type_var_diverges","","",209,[[["self"],["ty"]],["bool"]]],[11,"freshener","","",209,[[["self"]],["typefreshener"]]],[11,"type_is_unconstrained_numeric","","",209,[[["self"],["ty"]],["unconstrainednumeric"]]],[11,"unsolved_variables","","",209,[[["self"]],["vec",["ty"]]]],[11,"combine_fields","","",209,[[["self"],["typetrace"],["paramenv"]],["combinefields"]]],[11,"save_and_restore_in_snapshot_flag","","",209,[[["self"],["f"]],["r"]]],[11,"start_snapshot","","",209,[[["self"]],["combinedsnapshot"]]],[11,"rollback_to","","",209,[[["self"],["str"],["combinedsnapshot"]]]],[11,"commit_from","","",209,[[["self"],["combinedsnapshot"]]]],[11,"commit_unconditionally","","Execute `f` and commit the bindings",209,[[["self"],["f"]],["r"]]],[11,"commit_if_ok","","Execute `f` and commit the bindings if closure `f` returns `Ok(_)`",209,[[["self"],["f"]],["result"]]],[11,"in_snapshot","","",209,[[["self"],["f"]],["t"]]],[11,"probe","","Execute `f` then unroll any bindings it creates",209,[[["self"],["f"]],["r"]]],[11,"add_given","","",209,[[["self"],["region"],["regionvid"]]]],[11,"can_sub","","",209,[[["self"],["paramenv"],["t"],["t"]],["unitresult"]]],[11,"can_eq","","",209,[[["self"],["paramenv"],["t"],["t"]],["unitresult"]]],[11,"sub_regions","","",209,[[["self"],["subregionorigin"],["region"],["region"]]]],[11,"subtype_predicate","","",209,[[["self"],["obligationcause"],["paramenv"],["polysubtypepredicate"]],["option",["inferresult"]]]],[11,"region_outlives_predicate","","",209,[[["self"],["obligationcause"],["polyregionoutlivespredicate"]],["unitresult"]]],[11,"next_ty_var_id","","",209,[[["self"],["bool"],["typevariableorigin"]],["tyvid"]]],[11,"next_ty_var","","",209,[[["self"],["typevariableorigin"]],["ty"]]],[11,"next_diverging_ty_var","","",209,[[["self"],["typevariableorigin"]],["ty"]]],[11,"next_int_var_id","","",209,[[["self"]],["intvid"]]],[11,"next_float_var_id","","",209,[[["self"]],["floatvid"]]],[11,"next_region_var","","Create a fresh region variable with the next available index. The variable will be created in the maximum universe created thus far, allowing it to name any region created thus far.",209,[[["self"],["regionvariableorigin"]],["region"]]],[11,"next_region_var_in_universe","","Create a fresh region variable with the next available index in the given universe; typically, you can use `next_region_var` and just use the maximal universe.",209,[[["self"],["regionvariableorigin"],["universeindex"]],["region"]]],[11,"num_region_vars","","Number of region variables created so far.",209,[[["self"]],["usize"]]],[11,"next_nll_region_var","","Just a convenient wrapper of `next_region_var` for using during NLL.",209,[[["self"],["nllregionvariableorigin"]],["region"]]],[11,"next_nll_region_var_in_universe","","Just a convenient wrapper of `next_region_var` for using during NLL.",209,[[["self"],["nllregionvariableorigin"],["universeindex"]],["region"]]],[11,"var_for_def","","",209,[[["self"],["span"],["genericparamdef"]],["kind"]]],[11,"fresh_substs_for_item","","Given a set of generics defined on a type or impl, returns a substitution mapping each type/region parameter to a fresh inference variable.",209,[[["self"],["span"],["defid"]],["substs"]]],[11,"is_tainted_by_errors","","True if errors have been reported since this infcx was created.  This is sometimes used as a heuristic to skip reporting errors that often occur as a result of earlier errors, but where it's hard to be 100% sure (e.g., unresolved inference variables, regionck errors).",209,[[["self"]],["bool"]]],[11,"set_tainted_by_errors","","Set the \"tainted by errors\" flag to true. We call this when we observe an error from a prior pass.",209,[[["self"]]]],[11,"resolve_regions_and_report_errors","","Process the region constraints and report any errors that result. After this, no more unification operations should be done -- or the compiler will panic -- but it is legal to use `resolve_type_vars_if_possible` as well as `fully_resolve`.",209,[[["self"],["defid"],["scopetree"],["outlivesenvironment"]]]],[11,"resolve_regions_and_report_errors_unless_nll","","Like `resolve_regions_and_report_errors`, but skips error reporting if NLL is enabled.  This is used for fn bodies where the same error may later be reported by the NLL-based inference.",209,[[["self"],["defid"],["scopetree"],["outlivesenvironment"]]]],[11,"resolve_regions_and_report_errors_inner","","",209,[[["self"],["defid"],["scopetree"],["outlivesenvironment"],["bool"]]]],[11,"take_and_reset_region_constraints","","Obtains (and clears) the current set of region constraints. The inference context is still usable: further unifications will simply add new constraints.",209,[[["self"]],["regionconstraintdata"]]],[11,"with_region_constraints","","Gives temporary access to the region constraint data.",209,N],[11,"take_region_var_origins","","Takes ownership of the list of variable regions. This implies that all the region constriants have already been taken, and hence that `resolve_regions_and_report_errors` can never be called. This is used only during NLL processing to \"hand off\" ownership of the set of region vairables into the NLL region context.",209,[[["self"]],["varinfos"]]],[11,"ty_to_string","","",209,[[["self"],["ty"]],["string"]]],[11,"tys_to_string","","",209,N],[11,"trait_ref_to_string","","",209,[[["self"],["traitref"]],["string"]]],[11,"inlined_shallow_resolve","","",209,[[["self"],["ty"]],["ty"]]],[11,"shallow_resolve","","",209,[[["self"],["ty"]],["ty"]]],[11,"resolve_type_vars_if_possible","","Where possible, replaces type/int/float variables in `value` with their final value. Note that region variables are unaffected. If a type variable has not been unified, it is left as is.  This is an idempotent operation that does not affect inference state in any way and so you can do it at will.",209,[[["self"],["t"]],["t"]]],[11,"any_unresolved_type_vars","","Returns true if `T` contains unresolved type variables. In the process of visiting `T`, this will resolve (where possible) type variables in `T`, but it never constructs the final, resolved type, so it's more efficient than `resolve_type_vars_if_possible()`.",209,[[["self"],["t"]],["bool"]]],[11,"resolve_type_and_region_vars_if_possible","","",209,[[["self"],["t"]],["t"]]],[11,"fully_resolve","","Attempts to resolve all type/region variables in `value`. Region inference must have been run already (e.g., by calling `resolve_regions_and_report_errors`).  If some variable was never unified, an `Err` results.",209,[[["self"],["t"]],["fixupresult"]]],[11,"type_error_struct_with_diag","","",209,[[["self"],["span"],["m"],["ty"]],["diagnosticbuilder"]]],[11,"report_mismatched_types","","",209,[[["self"],["obligationcause"],["ty"],["ty"],["typeerror"]],["diagnosticbuilder"]]],[11,"replace_late_bound_regions_with_fresh_var","","",209,N],[11,"match_poly_projection_predicate","","Given a higher-ranked projection predicate like:",209,[[["self"],["obligationcause"],["paramenv"],["polyprojectionpredicate"],["traitref"]],["inferresult",["hrmatchresult"]]]],[11,"verify_generic_bound","","See `verify_generic_bound` method in `region_constraints`",209,[[["self"],["subregionorigin"],["generickind"],["region"],["verifybound"]]]],[11,"type_moves_by_default","","",209,[[["self"],["paramenv"],["ty"],["span"]],["bool"]]],[11,"closure_kind","","Obtains the latest type of the given closure; this may be a closure in the current function, in which case its `ClosureKind` may not yet be known.",209,[[["self"],["defid"],["closuresubsts"]],["option",["closurekind"]]]],[11,"closure_sig","","Obtain the signature of a closure.  For closures, unlike `tcx.fn_sig(def_id)`, this method will work during the type-checking of the enclosing function and return the closure signature in its partially inferred state.",209,[[["self"],["defid"],["closuresubsts"]],["polyfnsig"]]],[11,"partially_normalize_associated_types_in","","Normalizes associated types in `value`, potentially returning new obligations that must further be processed.",209,[[["self"],["span"],["nodeid"],["paramenv"],["t"]],["inferok"]]],[11,"borrow_region_constraints","","",209,[[["self"]],["refmut",["regionconstraintcollector"]]]],[11,"clear_caches","","Clears the selection, evaluation, and projection cachesThis is useful when repeatedly attemping to select an Obligation while changing only its ParamEnv, since FulfillmentContext doesn't use 'probe'",209,[[["self"]]]],[11,"universe","","",209,[[["self"]],["universeindex"]]],[11,"create_subuniverse","","Create and return a new subunivese of the current universe; update `self.universe` to that new subuniverse. At present, used only in the NLL subtyping code, which uses the new universe-based scheme instead of the more limited leak-check scheme.",209,[[["self"]],["universeindex"]]],[11,"span","","",210,[[["self"]],["span"]]],[11,"types","","",210,[[["obligationcause"],["bool"],["ty"],["ty"]],["typetrace"]]],[11,"dummy","","",210,[[["tyctxt"]],["typetrace"]]],[11,"fmt","","",210,[[["self"],["formatter"]],["result"]]],[11,"span","","",215,[[["self"]],["span"]]],[11,"from_obligation_cause","","",215,[[["obligationcause"],["f"]],["self"]]],[11,"span","","",218,[[["self"]],["span"]]],[11,"super_fold_with","","",214,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",214,[[["self"],["v"]],["bool"]]],[11,"fmt","","",211,[[["self"],["formatter"]],["result"]]],[0,"lint","rustc","Lints, aka compiler warnings.",N,N],[3,"LateContext","rustc::lint","Context for lint checking after type checking.",N,N],[12,"tcx","","Type context we're checking in.",297,N],[12,"tables","","Side-tables for the body we are in.",297,N],[12,"param_env","","Parameter environment for the item we are in.",297,N],[12,"access_levels","","Items accessible from the crate being checked.",297,N],[12,"lint_sess","","The store of registered lints and the lint levels.",297,N],[12,"last_ast_node_with_lint_attrs","","",297,N],[12,"generics","","Generic type parameters in scope for the item we are in.",297,N],[3,"EarlyContext","","Context for lint checking of the AST, after expansion, before lowering to HIR.",N,N],[12,"sess","","Type context we're checking in.",298,N],[12,"krate","","The crate being checked.",298,N],[12,"builder","","",298,N],[12,"lint_sess","","The store of registered lints and the lint levels.",298,N],[12,"buffered","","",298,N],[3,"LintStore","","Information about the registered lints.",N,N],[12,"lints","","Registered lints. The bool is true if the lint was added by a plugin.",299,N],[12,"pre_expansion_passes","","Trait objects for each lint pass. This is only `None` while performing a lint pass.",299,N],[12,"early_passes","","",299,N],[12,"late_passes","","",299,N],[12,"by_name","","Lints indexed by name.",299,N],[12,"lint_groups","","Map of registered lint groups to what lints they expand to. The first bool is true if the lint group was added by a plugin. The optional string is used to store the new names of deprecated lint group names.",299,N],[12,"future_incompatible","","Extra info for future incompatibility lints, describing the issue or RFC that caused the incompatibility.",299,N],[3,"FutureIncompatibleInfo","","Extra information for a future incompatibility lint. See the call to `register_future_incompatible` in `librustc_lint/lib.rs` for guidelines.",N,N],[12,"id","","",300,N],[12,"reference","","e.g., a URL for an issue/PR/RFC or error code",300,N],[12,"edition","","If this is an edition fixing lint, the edition in which this lint becomes obsolete",300,N],[3,"BufferedEarlyLint","","Lints that are buffered up early on in the `Session` before the `LintLevels` is calculated",N,N],[12,"lint_id","","",301,N],[12,"ast_id","","",301,N],[12,"span","","",301,N],[12,"msg","","",301,N],[12,"diagnostic","","",301,N],[3,"Lint","","Specification of a single lint.",N,N],[12,"name","","A string identifier for the lint.",302,N],[12,"default_level","","Default level for the lint.",302,N],[12,"desc","","Description of the lint or the issue it detects.",302,N],[12,"edition_lint_opts","","Starting at the given edition, default to the given lint level. If this is `None`, then use `default_level`.",302,N],[12,"report_in_external_macro","","Whether this lint is reported even inside expansions of external macros",302,N],[3,"LintId","","Identifies a lint known to the compiler.",N,N],[12,"lint","","",303,N],[3,"LintLevelSets","","",N,N],[12,"list","","",304,N],[12,"lint_cap","","",304,N],[3,"LintLevelMap","","",N,N],[12,"sets","","",305,N],[12,"id_to_set","","",305,N],[3,"LintBuffer","","",N,N],[12,"map","","",306,N],[3,"LintLevelMapBuilder","","",N,N],[12,"levels","","",307,N],[12,"tcx","","",307,N],[4,"CheckLintNameResult","","",N,N],[13,"Ok","","",308,N],[13,"NoLint","","Lint doesn't exist",308,N],[13,"Warning","","The lint is either renamed or removed. This is the warning message, and an optional new name (`None` if removed).",308,N],[13,"Tool","","The lint is from a tool. If the Option is None, then either the lint does not exist in the tool or the code was not compiled with the tool and therefore the lint was never added to the `LintStore`. Otherwise the `LintId` will be returned as if it where a rustc lint.",308,N],[4,"Level","","Setting for how to handle a lint.",N,N],[13,"Allow","","",309,N],[13,"Warn","","",309,N],[13,"Deny","","",309,N],[13,"Forbid","","",309,N],[4,"LintSource","","How a lint level was set.",N,N],[13,"Default","","Lint is at the default level as declared in rustc or a plugin.",310,N],[13,"Node","","Lint level was set by an attribute.",310,N],[13,"CommandLine","","Lint level was set by a command-line flag.",310,N],[5,"check_crate","","Perform lint checking on a crate.",N,[[["tyctxt"]]]],[5,"check_ast_crate","","",N,[[["session"],["crate"],["bool"]]]],[5,"struct_lint_level","","",N,[[["session"],["lint"],["level"],["lintsource"],["option",["multispan"]],["str"]],["diagnosticbuilder"]]],[5,"lint_levels","","",N,[[["tyctxt"],["cratenum"]],["lrc",["lintlevelmap"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"in_external_macro","","Returns whether `span` originates in a foreign crate's external macro.",N,[[["session"],["span"]],["bool"]]],[0,"builtin","","Some lints that are built in to the compiler.",N,N],[3,"HardwiredLints","rustc::lint::builtin","Does nothing as a lint pass, but registers some `Lint`s which are used by other parts of the compiler.",N,N],[4,"BuiltinLintDiagnostics","","",N,N],[13,"Normal","","",311,N],[13,"BareTraitObject","","",311,N],[13,"AbsPathWithModule","","",311,N],[13,"DuplicatedMacroExports","","",311,N],[13,"ProcMacroDeriveResolutionFallback","","",311,N],[13,"MacroExpandedMacroExportsAccessedByAbsolutePaths","","",311,N],[13,"ElidedLifetimesInPaths","","",311,N],[13,"UnknownCrateTypes","","",311,N],[0,"parser","","Some lints that are buffered from `libsyntax`. See `syntax::early_buffered_lints`.",N,N],[7,"QUESTION_MARK_MACRO_SEP","rustc::lint::builtin::parser","",N,N],[7,"EXCEEDING_BITSHIFTS","rustc::lint::builtin","",N,N],[7,"CONST_ERR","","",N,N],[7,"UNUSED_IMPORTS","","",N,N],[7,"UNUSED_EXTERN_CRATES","","",N,N],[7,"UNUSED_QUALIFICATIONS","","",N,N],[7,"UNKNOWN_LINTS","","",N,N],[7,"UNUSED_VARIABLES","","",N,N],[7,"UNUSED_ASSIGNMENTS","","",N,N],[7,"DEAD_CODE","","",N,N],[7,"UNREACHABLE_CODE","","",N,N],[7,"UNREACHABLE_PATTERNS","","",N,N],[7,"UNUSED_MACROS","","",N,N],[7,"WARNINGS","","",N,N],[7,"UNUSED_FEATURES","","",N,N],[7,"STABLE_FEATURES","","",N,N],[7,"UNKNOWN_CRATE_TYPES","","",N,N],[7,"TRIVIAL_CASTS","","",N,N],[7,"TRIVIAL_NUMERIC_CASTS","","",N,N],[7,"PRIVATE_IN_PUBLIC","","",N,N],[7,"PUB_USE_OF_PRIVATE_EXTERN_CRATE","","",N,N],[7,"INVALID_TYPE_PARAM_DEFAULT","","",N,N],[7,"RENAMED_AND_REMOVED_LINTS","","",N,N],[7,"SAFE_EXTERN_STATICS","","",N,N],[7,"SAFE_PACKED_BORROWS","","",N,N],[7,"PATTERNS_IN_FNS_WITHOUT_BODY","","",N,N],[7,"LEGACY_DIRECTORY_OWNERSHIP","","",N,N],[7,"LEGACY_CONSTRUCTOR_VISIBILITY","","",N,N],[7,"MISSING_FRAGMENT_SPECIFIER","","",N,N],[7,"PARENTHESIZED_PARAMS_IN_TYPES_AND_MODULES","","",N,N],[7,"LATE_BOUND_LIFETIME_ARGUMENTS","","",N,N],[7,"INCOHERENT_FUNDAMENTAL_IMPLS","","",N,N],[7,"BAD_REPR","","",N,N],[7,"DEPRECATED","","",N,N],[7,"UNUSED_UNSAFE","","",N,N],[7,"UNUSED_MUT","","",N,N],[7,"SINGLE_USE_LIFETIMES","","",N,N],[7,"UNUSED_LIFETIMES","","",N,N],[7,"TYVAR_BEHIND_RAW_POINTER","","",N,N],[7,"ELIDED_LIFETIMES_IN_PATHS","","",N,N],[7,"BARE_TRAIT_OBJECTS","","",N,N],[7,"ABSOLUTE_PATHS_NOT_STARTING_WITH_CRATE","","",N,N],[7,"ILLEGAL_FLOATING_POINT_LITERAL_PATTERN","","",N,N],[7,"UNSTABLE_NAME_COLLISIONS","","",N,N],[7,"IRREFUTABLE_LET_PATTERNS","","",N,N],[7,"UNUSED_LABELS","","",N,N],[7,"DUPLICATE_ASSOCIATED_TYPE_BINDINGS","","",N,N],[7,"DUPLICATE_MACRO_EXPORTS","","",N,N],[7,"INTRA_DOC_LINK_RESOLUTION_FAILURE","","",N,N],[7,"WHERE_CLAUSES_OBJECT_SAFETY","","",N,N],[7,"PROC_MACRO_DERIVE_RESOLUTION_FALLBACK","","",N,N],[7,"MACRO_USE_EXTERN_CRATE","","",N,N],[7,"MACRO_EXPANDED_MACRO_EXPORTS_ACCESSED_BY_ABSOLUTE_PATHS","","",N,N],[11,"clone","","",312,[[["self"]],["hardwiredlints"]]],[11,"get_lints","","",312,[[["self"]],["lintarray"]]],[11,"eq","","",311,[[["self"],["builtinlintdiagnostics"]],["bool"]]],[11,"ne","","",311,[[["self"],["builtinlintdiagnostics"]],["bool"]]],[11,"encode","","",311,[[["self"],["__s"]],["result"]]],[11,"decode","","",311,[[["__d"]],["result",["builtinlintdiagnostics"]]]],[11,"fmt","","",311,[[["self"],["formatter"]],["result"]]],[11,"run","","",311,[[["self"],["session"],["diagnosticbuilder"]]]],[0,"context","rustc::lint","Implementation of lint checking.",N,N],[3,"LintStore","rustc::lint::context","Information about the registered lints.",N,N],[12,"lints","","Registered lints. The bool is true if the lint was added by a plugin.",299,N],[12,"pre_expansion_passes","","Trait objects for each lint pass. This is only `None` while performing a lint pass.",299,N],[12,"early_passes","","",299,N],[12,"late_passes","","",299,N],[12,"by_name","","Lints indexed by name.",299,N],[12,"lint_groups","","Map of registered lint groups to what lints they expand to. The first bool is true if the lint group was added by a plugin. The optional string is used to store the new names of deprecated lint group names.",299,N],[12,"future_incompatible","","Extra info for future incompatibility lints, describing the issue or RFC that caused the incompatibility.",299,N],[3,"LintSession","","",N,N],[12,"lints","","Reference to the store of registered lints.",313,N],[12,"passes","","Trait objects for each lint pass.",313,N],[3,"BufferedEarlyLint","","Lints that are buffered up early on in the `Session` before the `LintLevels` is calculated",N,N],[12,"lint_id","","",301,N],[12,"ast_id","","",301,N],[12,"span","","",301,N],[12,"msg","","",301,N],[12,"diagnostic","","",301,N],[3,"FutureIncompatibleInfo","","Extra information for a future incompatibility lint. See the call to `register_future_incompatible` in `librustc_lint/lib.rs` for guidelines.",N,N],[12,"id","","",300,N],[12,"reference","","e.g., a URL for an issue/PR/RFC or error code",300,N],[12,"edition","","If this is an edition fixing lint, the edition in which this lint becomes obsolete",300,N],[3,"LateContext","","Context for lint checking after type checking.",N,N],[12,"tcx","","Type context we're checking in.",297,N],[12,"tables","","Side-tables for the body we are in.",297,N],[12,"param_env","","Parameter environment for the item we are in.",297,N],[12,"access_levels","","Items accessible from the crate being checked.",297,N],[12,"lint_sess","","The store of registered lints and the lint levels.",297,N],[12,"last_ast_node_with_lint_attrs","","",297,N],[12,"generics","","Generic type parameters in scope for the item we are in.",297,N],[3,"EarlyContext","","Context for lint checking of the AST, after expansion, before lowering to HIR.",N,N],[12,"sess","","Type context we're checking in.",298,N],[12,"krate","","The crate being checked.",298,N],[12,"builder","","",298,N],[12,"lint_sess","","The store of registered lints and the lint levels.",298,N],[12,"buffered","","",298,N],[4,"TargetLint","","The target of the `by_name` map, which accounts for renaming/deprecation.",N,N],[13,"Id","","A direct lint target",314,N],[13,"Renamed","","Temporary renaming, used for easing migration pain; see #16545",314,N],[13,"Removed","","Lint with this name existed previously, but has been removed/deprecated. The string argument is the reason for removal.",314,N],[4,"FindLintError","","",N,N],[13,"NotFound","","",315,N],[13,"Removed","","",315,N],[4,"CheckLintNameResult","","",N,N],[13,"Ok","","",308,N],[13,"NoLint","","Lint doesn't exist",308,N],[13,"Warning","","The lint is either renamed or removed. This is the warning message, and an optional new name (`None` if removed).",308,N],[13,"Tool","","The lint is from a tool. If the Option is None, then either the lint does not exist in the tool or the code was not compiled with the tool and therefore the lint was never added to the `LintStore`. Otherwise the `LintId` will be returned as if it where a rustc lint.",308,N],[5,"check_crate","","Perform lint checking on a crate.",N,[[["tyctxt"]]]],[5,"check_ast_crate","","",N,[[["session"],["crate"],["bool"]]]],[8,"LintPassObject","","",N,N],[8,"LintContext","","",N,N],[16,"PassObject","","",316,N],[10,"sess","","",316,[[["self"]],["session"]]],[10,"lints","","",316,[[["self"]],["lintstore"]]],[10,"lint_sess","","",316,[[["self"]],["lintsession"]]],[10,"lint_sess_mut","","",316,[[["self"]],["lintsession"]]],[10,"enter_attrs","","",316,N],[10,"exit_attrs","","",316,N],[11,"lookup_and_emit","","",316,[[["self"],["lint"],["option"],["str"]]]],[11,"lookup_and_emit_with_diagnostics","","",316,[[["self"],["lint"],["option"],["str"],["builtinlintdiagnostics"]]]],[10,"lookup","","",316,[[["self"],["lint"],["option"],["str"]],["diagnosticbuilder"]]],[11,"span_lint","","Emit a lint at the appropriate level, for a particular span.",316,[[["self"],["lint"],["s"],["str"]]]],[11,"struct_span_lint","","",316,[[["self"],["lint"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_lint_note","","Emit a lint and note at the appropriate level, for a particular span.",316,[[["self"],["lint"],["span"],["str"],["span"],["str"]]]],[11,"span_lint_help","","Emit a lint and help at the appropriate level, for a particular span.",316,[[["self"],["lint"],["span"],["str"],["str"]]]],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",316,[[["self"],["lint"],["str"]]]],[10,"with_lint_attrs","","Merge the lints specified by any lint attributes into the current lint context, call the provided function, then reset the lints in effect to their previous state.",316,N],[11,"eq","rustc::lint","",301,[[["self"],["bufferedearlylint"]],["bool"]]],[11,"ne","","",301,[[["self"],["bufferedearlylint"]],["bool"]]],[11,"encode","","",301,[[["self"],["__s"]],["result"]]],[11,"decode","","",301,[[["__d"]],["result",["bufferedearlylint"]]]],[11,"fmt","","",301,[[["self"],["formatter"]],["result"]]],[11,"new","","",299,[[],["lintstore"]]],[11,"get_lints","","",299,N],[11,"get_lint_groups","","",299,[[["self"]],["vec"]]],[11,"register_early_pass","","",299,[[["self"],["option",["session"]],["bool"],["earlylintpassobject"]]]],[11,"register_pre_expansion_pass","","",299,[[["self"],["option",["session"]],["earlylintpassobject"]]]],[11,"register_late_pass","","",299,[[["self"],["option",["session"]],["bool"],["latelintpassobject"]]]],[11,"push_pass","","",299,[[["self"],["option",["session"]],["bool"],["box"]]]],[11,"register_future_incompatible","","",299,[[["self"],["option",["session"]],["vec",["futureincompatibleinfo"]]]]],[11,"future_incompatible","","",299,[[["self"],["lintid"]],["option",["futureincompatibleinfo"]]]],[11,"register_group","","",299,[[["self"],["option",["session"]],["bool"],["str"],["option",["str"]],["vec",["lintid"]]]]],[11,"register_renamed","","",299,[[["self"],["str"],["str"]]]],[11,"register_removed","","",299,[[["self"],["str"],["str"]]]],[11,"find_lints","","",299,[[["self"],["str"]],["result",["vec","findlinterror"]]]],[11,"check_lint_name_cmdline","","Checks the validity of lint names derived from the command line",299,[[["self"],["session"],["str"],["level"]]]],[11,"check_lint_name","","Checks the name of a lint for its existence, and whether it was renamed or removed. Generates a DiagnosticBuilder containing a warning for renamed and removed lints. This is over both lint names from attributes and those passed on the command line. Since it emits non-fatal warnings and there are two lint passes that inspect attributes, this is only run from the late pass to avoid printing duplicate warnings.",299,[[["self"],["str"],["option",["localinternedstring"]]],["checklintnameresult"]]],[11,"check_tool_name_for_backwards_compat","","",299,[[["self"],["str"],["str"]],["checklintnameresult"]]],[11,"new","","",298,[[["session"],["crate"],["option",["vec"]],["lintbuffer"]],["earlycontext"]]],[11,"check_id","","",298,[[["self"],["nodeid"]]]],[11,"sess","","Get the overall compiler `Session` object.",297,[[["self"]],["session"]]],[11,"lints","","",297,[[["self"]],["lintstore"]]],[11,"lint_sess","","",297,[[["self"]],["lintsession"]]],[11,"lint_sess_mut","","",297,[[["self"]],["lintsession"]]],[11,"enter_attrs","","",297,N],[11,"exit_attrs","","",297,N],[11,"lookup","","",297,[[["self"],["lint"],["option"],["str"]],["diagnosticbuilder"]]],[11,"with_lint_attrs","","",297,N],[11,"sess","","Get the overall compiler `Session` object.",298,[[["self"]],["session"]]],[11,"lints","","",298,[[["self"]],["lintstore"]]],[11,"lint_sess","","",298,[[["self"]],["lintsession"]]],[11,"lint_sess_mut","","",298,[[["self"]],["lintsession"]]],[11,"enter_attrs","","",298,N],[11,"exit_attrs","","",298,N],[11,"lookup","","",298,[[["self"],["lint"],["option"],["str"]],["diagnosticbuilder"]]],[11,"with_lint_attrs","","",298,N],[11,"with_param_env","","",297,[[["self"],["nodeid"],["f"]]]],[11,"current_lint_root","","",297,[[["self"]],["nodeid"]]],[11,"nested_visit_map","","Because lints are scoped lexically, we want to walk nested items in the context of the outer item, so enable deep-walking.",297,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",297,[[["self"],["bodyid"]]]],[11,"visit_body","","",297,[[["self"],["body"]]]],[11,"visit_item","","",297,[[["self"],["item"]]]],[11,"visit_foreign_item","","",297,[[["self"],["foreignitem"]]]],[11,"visit_pat","","",297,[[["self"],["pat"]]]],[11,"visit_expr","","",297,[[["self"],["expr"]]]],[11,"visit_stmt","","",297,[[["self"],["stmt"]]]],[11,"visit_fn","","",297,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_variant_data","","",297,[[["self"],["variantdata"],["name"],["generics"],["nodeid"],["span"]]]],[11,"visit_struct_field","","",297,[[["self"],["structfield"]]]],[11,"visit_variant","","",297,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_ty","","",297,[[["self"],["ty"]]]],[11,"visit_name","","",297,[[["self"],["span"],["name"]]]],[11,"visit_mod","","",297,[[["self"],["mod"],["span"],["nodeid"]]]],[11,"visit_local","","",297,[[["self"],["local"]]]],[11,"visit_block","","",297,[[["self"],["block"]]]],[11,"visit_arm","","",297,[[["self"],["arm"]]]],[11,"visit_decl","","",297,[[["self"],["decl"]]]],[11,"visit_generic_param","","",297,[[["self"],["genericparam"]]]],[11,"visit_generics","","",297,[[["self"],["generics"]]]],[11,"visit_where_predicate","","",297,[[["self"],["wherepredicate"]]]],[11,"visit_poly_trait_ref","","",297,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_trait_item","","",297,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",297,[[["self"],["implitem"]]]],[11,"visit_lifetime","","",297,[[["self"],["lifetime"]]]],[11,"visit_path","","",297,[[["self"],["path"],["hirid"]]]],[11,"visit_attribute","","",297,[[["self"],["attribute"]]]],[11,"visit_item","","",298,[[["self"],["item"]]]],[11,"visit_foreign_item","","",298,[[["self"],["foreignitem"]]]],[11,"visit_pat","","",298,[[["self"],["pat"]]]],[11,"visit_expr","","",298,[[["self"],["expr"]]]],[11,"visit_stmt","","",298,[[["self"],["stmt"]]]],[11,"visit_fn","","",298,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_variant_data","","",298,[[["self"],["variantdata"],["ident"],["generics"],["nodeid"],["span"]]]],[11,"visit_struct_field","","",298,[[["self"],["structfield"]]]],[11,"visit_variant","","",298,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_ty","","",298,[[["self"],["ty"]]]],[11,"visit_ident","","",298,[[["self"],["ident"]]]],[11,"visit_mod","","",298,N],[11,"visit_local","","",298,[[["self"],["local"]]]],[11,"visit_block","","",298,[[["self"],["block"]]]],[11,"visit_arm","","",298,[[["self"],["arm"]]]],[11,"visit_expr_post","","",298,[[["self"],["expr"]]]],[11,"visit_generic_param","","",298,[[["self"],["genericparam"]]]],[11,"visit_generics","","",298,[[["self"],["generics"]]]],[11,"visit_where_predicate","","",298,[[["self"],["wherepredicate"]]]],[11,"visit_poly_trait_ref","","",298,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_trait_item","","",298,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",298,[[["self"],["implitem"]]]],[11,"visit_lifetime","","",298,[[["self"],["lifetime"]]]],[11,"visit_path","","",298,[[["self"],["path"],["nodeid"]]]],[11,"visit_attribute","","",298,[[["self"],["attribute"]]]],[11,"visit_mac_def","","",298,[[["self"],["macrodef"],["nodeid"]]]],[11,"visit_mac","","",298,[[["self"],["mac"]]]],[11,"encode","","",303,[[["self"],["s"]],["result"]]],[11,"decode","","",303,[[["d"]],["result",["lintid"]]]],[0,"levels","","",N,N],[3,"LintLevelSets","rustc::lint::levels","",N,N],[12,"list","","",304,N],[12,"lint_cap","","",304,N],[3,"LintLevelsBuilder","","",N,N],[12,"sess","","",317,N],[12,"sets","","",317,N],[12,"id_to_set","","",317,N],[12,"cur","","",317,N],[12,"warn_about_weird_lints","","",317,N],[3,"BuilderPush","","",N,N],[12,"prev","","",318,N],[3,"LintLevelMap","","",N,N],[12,"sets","","",305,N],[12,"id_to_set","","",305,N],[4,"LintSet","","",N,N],[13,"CommandLine","","",319,N],[12,"specs","rustc::lint::levels::LintSet","",319,N],[13,"Node","rustc::lint::levels","",319,N],[12,"specs","rustc::lint::levels::LintSet","",319,N],[12,"parent","","",319,N],[11,"new","rustc::lint","",304,[[["session"]],["lintlevelsets"]]],[11,"builder","","",304,[[["session"]],["lintlevelsbuilder"]]],[11,"process_command_line","","",304,[[["self"],["session"]]]],[11,"get_lint_level","","",304,N],[11,"get_lint_id_level","","",304,N],[11,"new","rustc::lint::levels","",317,[[["session"],["lintlevelsets"]],["lintlevelsbuilder"]]],[11,"push","","Pushes a list of AST lint attributes onto this context.",317,N],[11,"pop","","Called after `push` when the scope of a set of attributes are exited.",317,[[["self"],["builderpush"]]]],[11,"struct_lint","","Used to emit a lint-related diagnostic based on the current state of this lint context.",317,[[["self"],["lint"],["option",["multispan"]],["str"]],["diagnosticbuilder"]]],[11,"register_id","","Registers the ID provided with the current set of lints stored in this context.",317,[[["self"],["hirid"]]]],[11,"build","","",317,[[["self"]],["lintlevelsets"]]],[11,"build_map","","",317,[[["self"]],["lintlevelmap"]]],[11,"level_and_source","rustc::lint","If the `id` was previously registered with `register_id` when building this `LintLevelMap` this returns the corresponding lint level and source of the lint level for the lint provided.",305,[[["self"],["lint"],["hirid"],["session"]],["option"]]],[11,"lint_level_set","","Returns if this `id` has lint level information.",305,[[["self"],["hirid"]],["option",["u32"]]]],[11,"hash_stable","","",305,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",303,[[["self"],["hcx"],["stablehasher"]]]],[11,"to_stable_hash_key","","",303,[[["self"],["hcx"]],["str"]]],[6,"LintArray","","",N,N],[6,"EarlyLintPassObject","","A lint pass boxed up as a trait object.",N,N],[6,"LateLintPassObject","","",N,N],[6,"LevelSource","","",N,N],[8,"LintContext","","",N,N],[16,"PassObject","","",316,N],[10,"sess","","",316,[[["self"]],["session"]]],[10,"lints","","",316,[[["self"]],["lintstore"]]],[10,"lint_sess","","",316,[[["self"]],["lintsession"]]],[10,"lint_sess_mut","","",316,[[["self"]],["lintsession"]]],[10,"enter_attrs","","",316,N],[10,"exit_attrs","","",316,N],[11,"lookup_and_emit","rustc::lint::context","",316,[[["self"],["lint"],["option"],["str"]]]],[11,"lookup_and_emit_with_diagnostics","","",316,[[["self"],["lint"],["option"],["str"],["builtinlintdiagnostics"]]]],[10,"lookup","rustc::lint","",316,[[["self"],["lint"],["option"],["str"]],["diagnosticbuilder"]]],[11,"span_lint","rustc::lint::context","Emit a lint at the appropriate level, for a particular span.",316,[[["self"],["lint"],["s"],["str"]]]],[11,"struct_span_lint","","",316,[[["self"],["lint"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_lint_note","","Emit a lint and note at the appropriate level, for a particular span.",316,[[["self"],["lint"],["span"],["str"],["span"],["str"]]]],[11,"span_lint_help","","Emit a lint and help at the appropriate level, for a particular span.",316,[[["self"],["lint"],["span"],["str"],["str"]]]],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",316,[[["self"],["lint"],["str"]]]],[10,"with_lint_attrs","rustc::lint","Merge the lints specified by any lint attributes into the current lint context, call the provided function, then reset the lints in effect to their previous state.",316,N],[8,"LintPass","","",N,N],[10,"get_lints","","Get descriptions of the lints this `LintPass` object can emit.",320,[[["self"]],["lintarray"]]],[8,"LateLintPass","","",N,N],[11,"check_body","","",321,[[["self"],["latecontext"],["body"]]]],[11,"check_body_post","","",321,[[["self"],["latecontext"],["body"]]]],[11,"check_name","","",321,[[["self"],["latecontext"],["span"],["name"]]]],[11,"check_crate","","",321,[[["self"],["latecontext"],["crate"]]]],[11,"check_crate_post","","",321,[[["self"],["latecontext"],["crate"]]]],[11,"check_mod","","",321,[[["self"],["latecontext"],["mod"],["span"],["nodeid"]]]],[11,"check_mod_post","","",321,[[["self"],["latecontext"],["mod"],["span"],["nodeid"]]]],[11,"check_foreign_item","","",321,[[["self"],["latecontext"],["foreignitem"]]]],[11,"check_foreign_item_post","","",321,[[["self"],["latecontext"],["foreignitem"]]]],[11,"check_item","","",321,[[["self"],["latecontext"],["item"]]]],[11,"check_item_post","","",321,[[["self"],["latecontext"],["item"]]]],[11,"check_local","","",321,[[["self"],["latecontext"],["local"]]]],[11,"check_block","","",321,[[["self"],["latecontext"],["block"]]]],[11,"check_block_post","","",321,[[["self"],["latecontext"],["block"]]]],[11,"check_stmt","","",321,[[["self"],["latecontext"],["stmt"]]]],[11,"check_arm","","",321,[[["self"],["latecontext"],["arm"]]]],[11,"check_pat","","",321,[[["self"],["latecontext"],["pat"]]]],[11,"check_decl","","",321,[[["self"],["latecontext"],["decl"]]]],[11,"check_expr","","",321,[[["self"],["latecontext"],["expr"]]]],[11,"check_expr_post","","",321,[[["self"],["latecontext"],["expr"]]]],[11,"check_ty","","",321,[[["self"],["latecontext"],["ty"]]]],[11,"check_generic_param","","",321,[[["self"],["latecontext"],["genericparam"]]]],[11,"check_generics","","",321,[[["self"],["latecontext"],["generics"]]]],[11,"check_where_predicate","","",321,[[["self"],["latecontext"],["wherepredicate"]]]],[11,"check_poly_trait_ref","","",321,[[["self"],["latecontext"],["polytraitref"],["traitboundmodifier"]]]],[11,"check_fn","","",321,[[["self"],["latecontext"],["fnkind"],["fndecl"],["body"],["span"],["nodeid"]]]],[11,"check_fn_post","","",321,[[["self"],["latecontext"],["fnkind"],["fndecl"],["body"],["span"],["nodeid"]]]],[11,"check_trait_item","","",321,[[["self"],["latecontext"],["traititem"]]]],[11,"check_trait_item_post","","",321,[[["self"],["latecontext"],["traititem"]]]],[11,"check_impl_item","","",321,[[["self"],["latecontext"],["implitem"]]]],[11,"check_impl_item_post","","",321,[[["self"],["latecontext"],["implitem"]]]],[11,"check_struct_def","","",321,[[["self"],["latecontext"],["variantdata"],["name"],["generics"],["nodeid"]]]],[11,"check_struct_def_post","","",321,[[["self"],["latecontext"],["variantdata"],["name"],["generics"],["nodeid"]]]],[11,"check_struct_field","","",321,[[["self"],["latecontext"],["structfield"]]]],[11,"check_variant","","",321,[[["self"],["latecontext"],["variant"],["generics"]]]],[11,"check_variant_post","","",321,[[["self"],["latecontext"],["variant"],["generics"]]]],[11,"check_lifetime","","",321,[[["self"],["latecontext"],["lifetime"]]]],[11,"check_path","","",321,[[["self"],["latecontext"],["path"],["hirid"]]]],[11,"check_attribute","","",321,[[["self"],["latecontext"],["attribute"]]]],[11,"enter_lint_attrs","","",321,N],[11,"exit_lint_attrs","","",321,N],[8,"EarlyLintPass","","",N,N],[11,"check_ident","","",322,[[["self"],["earlycontext"],["ident"]]]],[11,"check_crate","","",322,[[["self"],["earlycontext"],["crate"]]]],[11,"check_crate_post","","",322,[[["self"],["earlycontext"],["crate"]]]],[11,"check_mod","","",322,[[["self"],["earlycontext"],["mod"],["span"],["nodeid"]]]],[11,"check_mod_post","","",322,[[["self"],["earlycontext"],["mod"],["span"],["nodeid"]]]],[11,"check_foreign_item","","",322,[[["self"],["earlycontext"],["foreignitem"]]]],[11,"check_foreign_item_post","","",322,[[["self"],["earlycontext"],["foreignitem"]]]],[11,"check_item","","",322,[[["self"],["earlycontext"],["item"]]]],[11,"check_item_post","","",322,[[["self"],["earlycontext"],["item"]]]],[11,"check_local","","",322,[[["self"],["earlycontext"],["local"]]]],[11,"check_block","","",322,[[["self"],["earlycontext"],["block"]]]],[11,"check_block_post","","",322,[[["self"],["earlycontext"],["block"]]]],[11,"check_stmt","","",322,[[["self"],["earlycontext"],["stmt"]]]],[11,"check_arm","","",322,[[["self"],["earlycontext"],["arm"]]]],[11,"check_pat","","",322,[[["self"],["earlycontext"],["pat"]]]],[11,"check_expr","","",322,[[["self"],["earlycontext"],["expr"]]]],[11,"check_expr_post","","",322,[[["self"],["earlycontext"],["expr"]]]],[11,"check_ty","","",322,[[["self"],["earlycontext"],["ty"]]]],[11,"check_generic_param","","",322,[[["self"],["earlycontext"],["genericparam"]]]],[11,"check_generics","","",322,[[["self"],["earlycontext"],["generics"]]]],[11,"check_where_predicate","","",322,[[["self"],["earlycontext"],["wherepredicate"]]]],[11,"check_poly_trait_ref","","",322,[[["self"],["earlycontext"],["polytraitref"],["traitboundmodifier"]]]],[11,"check_fn","","",322,[[["self"],["earlycontext"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"check_fn_post","","",322,[[["self"],["earlycontext"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"check_trait_item","","",322,[[["self"],["earlycontext"],["traititem"]]]],[11,"check_trait_item_post","","",322,[[["self"],["earlycontext"],["traititem"]]]],[11,"check_impl_item","","",322,[[["self"],["earlycontext"],["implitem"]]]],[11,"check_impl_item_post","","",322,[[["self"],["earlycontext"],["implitem"]]]],[11,"check_struct_def","","",322,[[["self"],["earlycontext"],["variantdata"],["ident"],["generics"],["nodeid"]]]],[11,"check_struct_def_post","","",322,[[["self"],["earlycontext"],["variantdata"],["ident"],["generics"],["nodeid"]]]],[11,"check_struct_field","","",322,[[["self"],["earlycontext"],["structfield"]]]],[11,"check_variant","","",322,[[["self"],["earlycontext"],["variant"],["generics"]]]],[11,"check_variant_post","","",322,[[["self"],["earlycontext"],["variant"],["generics"]]]],[11,"check_lifetime","","",322,[[["self"],["earlycontext"],["lifetime"]]]],[11,"check_path","","",322,[[["self"],["earlycontext"],["path"],["nodeid"]]]],[11,"check_attribute","","",322,[[["self"],["earlycontext"],["attribute"]]]],[11,"check_mac_def","","",322,[[["self"],["earlycontext"],["macrodef"],["nodeid"]]]],[11,"check_mac","","",322,[[["self"],["earlycontext"],["mac"]]]],[11,"enter_lint_attrs","","Called when entering a syntax node that can have lint attributes such as `#[allow(...)]`. Called with all the attributes of that node.",322,N],[11,"exit_lint_attrs","","Counterpart to `enter_lint_attrs`.",322,N],[11,"clone","","",302,[[["self"]],["lint"]]],[11,"fmt","","",302,[[["self"],["formatter"]],["result"]]],[11,"from_parser_lint_id","","Returns the `rust::lint::Lint` for a `syntax::early_buffered_lints::BufferedEarlyLintId`.",302,[[["bufferedearlylintid"]],["self"]]],[11,"name_lower","","Get the lint's name, with ASCII letters converted to lowercase.",302,[[["self"]],["string"]]],[11,"default_level","","",302,[[["self"],["session"]],["level"]]],[11,"clone","","",303,[[["self"]],["lintid"]]],[11,"fmt","","",303,[[["self"],["formatter"]],["result"]]],[11,"eq","","",303,[[["self"],["lintid"]],["bool"]]],[11,"hash","","",303,[[["self"],["h"]]]],[11,"of","","Get the `LintId` for a `Lint`.",303,[[["lint"]],["lintid"]]],[11,"lint_name_raw","","",303,[[["self"]],["str"]]],[11,"to_string","","Get the name of the lint.",303,[[["self"]],["string"]]],[11,"clone","","",309,[[["self"]],["level"]]],[11,"eq","","",309,[[["self"],["level"]],["bool"]]],[11,"partial_cmp","","",309,[[["self"],["level"]],["option",["ordering"]]]],[11,"assert_receiver_is_total_eq","","",309,N],[11,"cmp","","",309,[[["self"],["level"]],["ordering"]]],[11,"fmt","","",309,[[["self"],["formatter"]],["result"]]],[11,"hash","","",309,N],[11,"hash_stable","","",309,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"as_str","","Convert a level to a lower-case string.",309,[[["self"]],["str"]]],[11,"from_str","","Convert a lower-case string to a level.",309,[[["str"]],["option",["level"]]]],[11,"clone","","",310,[[["self"]],["lintsource"]]],[11,"eq","","",310,[[["self"],["lintsource"]],["bool"]]],[11,"ne","","",310,[[["self"],["lintsource"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",310,N],[11,"hash_stable","","",310,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",306,[[],["lintbuffer"]]],[11,"add_lint","","",306,[[["self"],["lint"],["nodeid"],["multispan"],["str"],["builtinlintdiagnostics"]]]],[11,"take","","",306,[[["self"],["nodeid"]],["vec",["bufferedearlylint"]]]],[11,"get_any","","",306,[[["self"]],["option"]]],[11,"with_lint_attrs","","",307,N],[11,"nested_visit_map","","",307,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",307,[[["self"],["item"]]]],[11,"visit_foreign_item","","",307,[[["self"],["foreignitem"]]]],[11,"visit_expr","","",307,[[["self"],["expr"]]]],[11,"visit_struct_field","","",307,[[["self"],["structfield"]]]],[11,"visit_variant","","",307,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_local","","",307,[[["self"],["local"]]]],[11,"visit_trait_item","","",307,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",307,[[["self"],["implitem"]]]],[0,"middle","rustc","",N,N],[0,"allocator","rustc::middle","",N,N],[4,"AllocatorKind","rustc::middle::allocator","",N,N],[13,"Global","","",323,N],[13,"DefaultLib","","",323,N],[13,"DefaultExe","","",323,N],[11,"clone","","",323,[[["self"]],["allocatorkind"]]],[11,"fn_name","","",323,[[["self"],["str"]],["string"]]],[0,"borrowck","rustc::middle","",N,N],[3,"BorrowCheckResult","rustc::middle::borrowck","",N,N],[12,"used_mut_nodes","","",324,N],[12,"signalled_any_error","","",324,N],[4,"SignalledError","","",N,N],[13,"SawSomeError","","",325,N],[13,"NoErrorsSeen","","",325,N],[11,"clone","","",325,[[["self"]],["signallederror"]]],[11,"fmt","","",325,[[["self"],["formatter"]],["result"]]],[11,"encode","","",325,[[["self"],["__s"]],["result"]]],[11,"decode","","",325,[[["__d"]],["result",["signallederror"]]]],[11,"hash_stable","","",325,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"fmt","","",324,[[["self"],["formatter"]],["result"]]],[11,"encode","","",324,[[["self"],["__s"]],["result"]]],[11,"decode","","",324,[[["__d"]],["result",["borrowcheckresult"]]]],[11,"hash_stable","","",324,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"expr_use_visitor","rustc::middle","A different sort of visitor for walking fn bodies.  Unlike the normal visitor, which just walks the entire body in one shot, the `ExprUseVisitor` determines how expressions are being used.",N,N],[3,"ExprUseVisitor","rustc::middle::expr_use_visitor","",N,N],[12,"mc","","",326,N],[12,"delegate","","",326,N],[12,"param_env","","",326,N],[4,"LoanCause","","",N,N],[13,"ClosureCapture","","",327,N],[13,"AddrOf","","",327,N],[13,"AutoRef","","",327,N],[13,"AutoUnsafe","","",327,N],[13,"RefBinding","","",327,N],[13,"OverloadedOperator","","",327,N],[13,"ClosureInvocation","","",327,N],[13,"ForLoop","","",327,N],[13,"MatchDiscriminant","","",327,N],[4,"ConsumeMode","","",N,N],[13,"Copy","","",328,N],[13,"Move","","",328,N],[4,"MoveReason","","",N,N],[13,"DirectRefMove","","",329,N],[13,"PatBindingMove","","",329,N],[13,"CaptureMove","","",329,N],[4,"MatchMode","","",N,N],[13,"NonBindingMatch","","",330,N],[13,"BorrowingMatch","","",330,N],[13,"CopyingMatch","","",330,N],[13,"MovingMatch","","",330,N],[4,"TrackMatchMode","","",N,N],[13,"Unknown","","",331,N],[13,"Definite","","",331,N],[13,"Conflicting","","",331,N],[4,"MutateMode","","",N,N],[13,"Init","","",332,N],[13,"JustWrite","","",332,N],[13,"WriteAndRead","","",332,N],[4,"OverloadedCallType","","",N,N],[13,"FnOverloadedCall","","",333,N],[13,"FnMutOverloadedCall","","",333,N],[13,"FnOnceOverloadedCall","","",333,N],[5,"copy_or_move","","",N,[[["memcategorizationcontext"],["paramenv"],["cmt_"],["movereason"]],["consumemode"]]],[8,"Delegate","","This trait defines the callbacks you can expect to receive when employing the ExprUseVisitor.",N,N],[10,"consume","","",334,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[10,"matched_pat","","",334,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[10,"consume_pat","","",334,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[10,"borrow","","",334,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[10,"decl_without_init","","",334,[[["self"],["nodeid"],["span"]]]],[10,"mutate","","",334,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"clone","","",327,[[["self"]],["loancause"]]],[11,"eq","","",327,[[["self"],["loancause"]],["bool"]]],[11,"ne","","",327,[[["self"],["loancause"]],["bool"]]],[11,"fmt","","",327,[[["self"],["formatter"]],["result"]]],[11,"clone","","",328,[[["self"]],["consumemode"]]],[11,"eq","","",328,[[["self"],["consumemode"]],["bool"]]],[11,"ne","","",328,[[["self"],["consumemode"]],["bool"]]],[11,"fmt","","",328,[[["self"],["formatter"]],["result"]]],[11,"clone","","",329,[[["self"]],["movereason"]]],[11,"eq","","",329,[[["self"],["movereason"]],["bool"]]],[11,"fmt","","",329,[[["self"],["formatter"]],["result"]]],[11,"clone","","",330,[[["self"]],["matchmode"]]],[11,"eq","","",330,[[["self"],["matchmode"]],["bool"]]],[11,"fmt","","",330,[[["self"],["formatter"]],["result"]]],[11,"clone","","",331,[[["self"]],["trackmatchmode"]]],[11,"eq","","",331,[[["self"],["trackmatchmode"]],["bool"]]],[11,"ne","","",331,[[["self"],["trackmatchmode"]],["bool"]]],[11,"fmt","","",331,[[["self"],["formatter"]],["result"]]],[11,"lub","","",331,[[["self"],["matchmode"]]]],[11,"match_mode","","",331,[[["self"]],["matchmode"]]],[11,"clone","","",332,[[["self"]],["mutatemode"]]],[11,"eq","","",332,[[["self"],["mutatemode"]],["bool"]]],[11,"fmt","","",332,[[["self"],["formatter"]],["result"]]],[11,"clone","","",333,[[["self"]],["overloadedcalltype"]]],[11,"from_trait_id","","",333,[[["tyctxt"],["defid"]],["overloadedcalltype"]]],[11,"from_method_id","","",333,[[["tyctxt"],["defid"]],["overloadedcalltype"]]],[11,"new","","Creates the ExprUseVisitor, configuring it with the various options provided:",326,[[["delegate"],["tyctxt"],["paramenv"],["scopetree"],["typecktables"],["option",["lrc"]]],["self"]]],[11,"with_infer","","",326,[[["delegate"],["inferctxt"],["paramenv"],["scopetree"],["typecktables"]],["self"]]],[11,"consume_body","","",326,[[["self"],["body"]]]],[11,"tcx","","",326,[[["self"]],["tyctxt"]]],[11,"delegate_consume","","",326,[[["self"],["nodeid"],["span"],["cmt_"]]]],[11,"consume_exprs","","",326,N],[11,"consume_expr","","",326,[[["self"],["expr"]]]],[11,"mutate_expr","","",326,[[["self"],["expr"],["expr"],["mutatemode"]]]],[11,"borrow_expr","","",326,[[["self"],["expr"],["region"],["borrowkind"],["loancause"]]]],[11,"select_from_expr","","",326,[[["self"],["expr"]]]],[11,"walk_expr","","",326,[[["self"],["expr"]]]],[11,"walk_callee","","",326,[[["self"],["expr"],["expr"]]]],[11,"walk_stmt","","",326,[[["self"],["stmt"]]]],[11,"walk_local","","",326,[[["self"],["local"]]]],[11,"walk_block","","Indicates that the value of `blk` will be consumed, meaning either copied or moved depending on its type.",326,[[["self"],["block"]]]],[11,"walk_struct_expr","","",326,N],[11,"walk_adjustment","","",326,[[["self"],["expr"]]]],[11,"walk_autoref","","Walks the autoref `autoref` applied to the autoderef'd `expr`. `cmt_base` is the mem-categorized form of `expr` after all relevant autoderefs have occurred.",326,[[["self"],["expr"],["cmt_"],["autoborrow"]]]],[11,"arm_move_mode","","",326,[[["self"],["cmt"],["arm"]],["trackmatchmode"]]],[11,"walk_arm","","",326,[[["self"],["cmt"],["arm"],["matchmode"]]]],[11,"walk_irrefutable_pat","","Walks a pat that occurs in isolation (i.e. top-level of fn arg or let binding.  Not a match arm or nested pat.)",326,[[["self"],["cmt"],["pat"]]]],[11,"determine_pat_move_mode","","Identifies any bindings within `pat` and accumulates within `mode` whether the overall pattern/match structure is a move, copy, or borrow.",326,[[["self"],["cmt"],["pat"],["trackmatchmode"]]]],[11,"walk_pat","","The core driver for walking a pattern; `match_mode` must be established up front, e.g. via `determine_pat_move_mode` (see also `walk_irrefutable_pat` for patterns that stand alone).",326,[[["self"],["cmt"],["pat"],["matchmode"]]]],[11,"walk_captures","","",326,[[["self"],["expr"],["span"]]]],[11,"cat_captured_var","","",326,[[["self"],["hirid"],["span"],["freevar"]],["mcresult",["cmt_"]]]],[0,"cstore","rustc::middle","the rustc crate store interface. This also includes types that are mostly used as a part of that interface, but these should probably get a better home if someone can find one.",N,N],[3,"CrateSource","rustc::middle::cstore","Where a crate came from on the local filesystem. One of these three options must be non-None.",N,N],[12,"dylib","","",335,N],[12,"rlib","","",335,N],[12,"rmeta","","",335,N],[3,"NativeLibrary","","",N,N],[12,"kind","","",336,N],[12,"name","","",336,N],[12,"cfg","","",336,N],[12,"foreign_module","","",336,N],[12,"wasm_import_module","","",336,N],[3,"ForeignModule","","",N,N],[12,"foreign_items","","",337,N],[12,"def_id","","",337,N],[3,"ExternCrate","","",N,N],[12,"src","","",338,N],[12,"span","","span of the extern crate that caused this to be loaded",338,N],[12,"path_len","","Number of links to reach the extern; used to select the extern with the shortest path",338,N],[12,"direct","","If true, then this crate is the crate named by the extern crate referenced above. If false, then this crate is a dep of the crate.",338,N],[3,"EncodedMetadata","","",N,N],[12,"raw_data","","",339,N],[4,"DepKind","","",N,N],[13,"UnexportedMacrosOnly","","A dependency that is only used for its macros, none of which are visible from other crates. These are included in the metadata only as placeholders and are ignored when decoding.",340,N],[13,"MacrosOnly","","A dependency that is only used for its macros.",340,N],[13,"Implicit","","A dependency that is always injected into the dependency list and so doesn't need to be linked to an rlib, e.g. the injected allocator.",340,N],[13,"Explicit","","A dependency that is required by an rlib version of this crate. Ordinary `extern crate`s result in `Explicit` dependencies.",340,N],[4,"LibSource","","",N,N],[13,"Some","","",341,N],[13,"MetadataOnly","","",341,N],[13,"None","","",341,N],[4,"LinkagePreference","","",N,N],[13,"RequireDynamic","","",342,N],[13,"RequireStatic","","",342,N],[4,"NativeLibraryKind","","",N,N],[13,"NativeStatic","","native static library (.a archive)",343,N],[13,"NativeStaticNobundle","","native static library, which doesn't get bundled into .rlibs",343,N],[13,"NativeFramework","","macOS-specific",343,N],[13,"NativeUnknown","","default way to specify a dynamic library",343,N],[4,"ExternCrateSource","","",N,N],[13,"Extern","","Crate is loaded by `extern crate`.",344,N],[13,"Use","","",344,N],[13,"Path","","Crate is implicitly loaded by an absolute or an `extern::` path.",344,N],[5,"used_crates","","",N,[[["tyctxt"],["linkagepreference"]],["vec"]]],[6,"CrateStoreDyn","","",N,N],[8,"MetadataLoader","","The backend's way to give the crate store access to the metadata in a library. Note that it returns the raw metadata bytes stored in the library file, whether it is compressed, uncompressed, some weird mix, etc. rmeta files are backend independent and not handled here.",N,N],[10,"get_rlib_metadata","","",345,[[["self"],["target"],["path"]],["result",["metadataref","string"]]]],[10,"get_dylib_metadata","","",345,[[["self"],["target"],["path"]],["result",["metadataref","string"]]]],[8,"CrateStore","","A store of Rust crates, through with their metadata can be accessed.",N,N],[10,"crate_data_as_rc_any","","",346,[[["self"],["cratenum"]],["lrc",["any"]]]],[10,"def_key","","",346,[[["self"],["defid"]],["defkey"]]],[10,"def_path","","",346,[[["self"],["defid"]],["defpath"]]],[10,"def_path_hash","","",346,[[["self"],["defid"]],["defpathhash"]]],[10,"def_path_table","","",346,[[["self"],["cratenum"]],["lrc",["defpathtable"]]]],[10,"crate_name_untracked","","",346,[[["self"],["cratenum"]],["symbol"]]],[10,"crate_disambiguator_untracked","","",346,[[["self"],["cratenum"]],["cratedisambiguator"]]],[10,"crate_hash_untracked","","",346,[[["self"],["cratenum"]],["svh"]]],[10,"extern_mod_stmt_cnum_untracked","","",346,[[["self"],["nodeid"]],["option",["cratenum"]]]],[10,"item_generics_cloned_untracked","","",346,[[["self"],["defid"],["session"]],["generics"]]],[10,"postorder_cnums_untracked","","",346,[[["self"]],["vec",["cratenum"]]]],[10,"crates_untracked","","",346,[[["self"]],["vec",["cratenum"]]]],[10,"encode_metadata","","",346,[[["self"],["tyctxt"]],["encodedmetadata"]]],[10,"metadata_encoding_version","","",346,N],[11,"eq","","",335,[[["self"],["cratesource"]],["bool"]]],[11,"ne","","",335,[[["self"],["cratesource"]],["bool"]]],[11,"clone","","",335,[[["self"]],["cratesource"]]],[11,"fmt","","",335,[[["self"],["formatter"]],["result"]]],[11,"encode","","",340,[[["self"],["__s"]],["result"]]],[11,"decode","","",340,[[["__d"]],["result",["depkind"]]]],[11,"clone","","",340,[[["self"]],["depkind"]]],[11,"cmp","","",340,[[["self"],["depkind"]],["ordering"]]],[11,"partial_cmp","","",340,[[["self"],["depkind"]],["option",["ordering"]]]],[11,"assert_receiver_is_total_eq","","",340,N],[11,"eq","","",340,[[["self"],["depkind"]],["bool"]]],[11,"fmt","","",340,[[["self"],["formatter"]],["result"]]],[11,"macros_only","","",340,[[["self"]],["bool"]]],[11,"eq","","",341,[[["self"],["libsource"]],["bool"]]],[11,"ne","","",341,[[["self"],["libsource"]],["bool"]]],[11,"clone","","",341,[[["self"]],["libsource"]]],[11,"fmt","","",341,[[["self"],["formatter"]],["result"]]],[11,"is_some","","",341,[[["self"]],["bool"]]],[11,"option","","",341,[[["self"]],["option",["pathbuf"]]]],[11,"fmt","","",342,[[["self"],["formatter"]],["result"]]],[11,"eq","","",342,[[["self"],["linkagepreference"]],["bool"]]],[11,"clone","","",342,[[["self"]],["linkagepreference"]]],[11,"encode","","",342,[[["self"],["__s"]],["result"]]],[11,"decode","","",342,[[["__d"]],["result",["linkagepreference"]]]],[11,"clone","","",343,[[["self"]],["nativelibrarykind"]]],[11,"eq","","",343,[[["self"],["nativelibrarykind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",343,N],[11,"partial_cmp","","",343,[[["self"],["nativelibrarykind"]],["option",["ordering"]]]],[11,"cmp","","",343,[[["self"],["nativelibrarykind"]],["ordering"]]],[11,"hash","","",343,N],[11,"encode","","",343,[[["self"],["__s"]],["result"]]],[11,"decode","","",343,[[["__d"]],["result",["nativelibrarykind"]]]],[11,"clone","","",336,[[["self"]],["nativelibrary"]]],[11,"encode","","",336,[[["self"],["__s"]],["result"]]],[11,"decode","","",336,[[["__d"]],["result",["nativelibrary"]]]],[11,"clone","","",337,[[["self"]],["foreignmodule"]]],[11,"hash","","",337,N],[11,"encode","","",337,[[["self"],["__s"]],["result"]]],[11,"decode","","",337,[[["__d"]],["result",["foreignmodule"]]]],[11,"clone","","",338,[[["self"]],["externcrate"]]],[11,"fmt","","",338,[[["self"],["formatter"]],["result"]]],[11,"clone","","",344,[[["self"]],["externcratesource"]]],[11,"fmt","","",344,[[["self"],["formatter"]],["result"]]],[11,"new","","",339,[[],["encodedmetadata"]]],[0,"dead","rustc::middle","",N,N],[3,"MarkSymbolVisitor","rustc::middle::dead","",N,N],[12,"worklist","","",347,N],[12,"tcx","","",347,N],[12,"tables","","",347,N],[12,"live_symbols","","",347,N],[12,"repr_has_repr_c","","",347,N],[12,"in_pat","","",347,N],[12,"inherited_pub_visibility","","",347,N],[12,"ignore_variant_stack","","",347,N],[3,"LifeSeeder","","",N,N],[12,"worklist","","",348,N],[12,"krate","","",348,N],[12,"tcx","","",348,N],[3,"DeadVisitor","","",N,N],[12,"tcx","","",349,N],[12,"live_symbols","","",349,N],[5,"should_explore","","",N,[[["tyctxt"],["nodeid"]],["bool"]]],[5,"has_allow_dead_code_or_lang_attr","","",N,N],[5,"create_and_seed_worklist","","",N,[[["tyctxt"],["accesslevels"],["crate"]],["vec",["nodeid"]]]],[5,"find_live","","",N,[[["tyctxt"],["accesslevels"],["crate"]],["box",["fxhashset"]]]],[5,"get_struct_ctor_id","","",N,[[["item"]],["option",["nodeid"]]]],[5,"check_crate","","",N,[[["tyctxt"]]]],[11,"check_def_id","","",347,[[["self"],["defid"]]]],[11,"insert_def_id","","",347,[[["self"],["defid"]]]],[11,"handle_definition","","",347,[[["self"],["def"]]]],[11,"lookup_and_handle_method","","",347,[[["self"],["hirid"]]]],[11,"handle_field_access","","",347,[[["self"],["expr"],["nodeid"]]]],[11,"handle_field_pattern_match","","",347,N],[11,"mark_live_symbols","","",347,[[["self"]]]],[11,"visit_node","","",347,[[["self"],["node"]]]],[11,"mark_as_used_if_union","","",347,[[["self"],["adtdef"],["hirvec"]]]],[11,"nested_visit_map","","",347,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",347,[[["self"],["bodyid"]]]],[11,"visit_variant_data","","",347,[[["self"],["variantdata"],["name"],["generics"],["nodeid"],["span"]]]],[11,"visit_expr","","",347,[[["self"],["expr"]]]],[11,"visit_arm","","",347,[[["self"],["arm"]]]],[11,"visit_pat","","",347,[[["self"],["pat"]]]],[11,"visit_path","","",347,[[["self"],["path"],["hirid"]]]],[11,"visit_item","","",348,[[["self"],["item"]]]],[11,"visit_trait_item","","",348,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",348,[[["self"],["implitem"]]]],[11,"should_warn_about_item","","",349,[[["self"],["item"]],["bool"]]],[11,"should_warn_about_field","","",349,[[["self"],["structfield"]],["bool"]]],[11,"should_warn_about_variant","","",349,[[["self"],["variantkind"]],["bool"]]],[11,"should_warn_about_foreign_item","","",349,[[["self"],["foreignitem"]],["bool"]]],[11,"symbol_is_live","","",349,[[["self"],["nodeid"],["option",["nodeid"]]],["bool"]]],[11,"warn_dead_code","","",349,[[["self"],["nodeid"],["span"],["name"],["str"],["str"]]]],[11,"nested_visit_map","","Walk nested items in place so that we don't report dead-code on inner functions when the outer function is already getting an error. We could do this also by checking the parents, but this is how the code is setup and it seems harmless enough.",349,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",349,[[["self"],["item"]]]],[11,"visit_variant","","",349,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_foreign_item","","",349,[[["self"],["foreignitem"]]]],[11,"visit_struct_field","","",349,[[["self"],["structfield"]]]],[11,"visit_impl_item","","",349,[[["self"],["implitem"]]]],[11,"visit_trait_item","","",349,[[["self"],["traititem"]]]],[0,"dependency_format","rustc::middle","Resolution of mixing rlibs and dylibs",N,N],[4,"Linkage","rustc::middle::dependency_format","",N,N],[13,"NotLinked","","",350,N],[13,"IncludedFromDylib","","",350,N],[13,"Static","","",350,N],[13,"Dynamic","","",350,N],[5,"calculate","","",N,[[["tyctxt"]]]],[5,"calculate_type","","",N,[[["tyctxt"],["cratetype"]],["dependencylist"]]],[5,"add_library","","",N,[[["tyctxt"],["cratenum"],["linkagepreference"],["fxhashmap"]]]],[5,"attempt_static","","",N,[[["tyctxt"]],["option",["dependencylist"]]]],[5,"activate_injected_dep","","",N,[[["option",["cratenum"]],["dependencylist"],["fn"]]]],[5,"activate_injected_allocator","","",N,[[["session"],["dependencylist"]]]],[5,"verify_ok","","",N,N],[6,"DependencyList","","A list of dependencies for a certain crate type.",N,N],[6,"Dependencies","","A mapping of all required dependencies for a particular flavor of output.",N,N],[11,"clone","","",350,[[["self"]],["linkage"]]],[11,"eq","","",350,[[["self"],["linkage"]],["bool"]]],[11,"fmt","","",350,[[["self"],["formatter"]],["result"]]],[0,"entry","rustc::middle","",N,N],[3,"EntryContext","rustc::middle::entry","",N,N],[12,"session","","",351,N],[12,"map","","",351,N],[12,"main_fn","","",351,N],[12,"attr_main_fn","","",351,N],[12,"start_fn","","",351,N],[12,"non_main_fns","","",351,N],[5,"find_entry_point","","",N,[[["session"],["map"],["str"]]]],[5,"entry_point_type","","",N,[[["item"],["bool"]],["entrypointtype"]]],[5,"find_item","","",N,[[["item"],["entrycontext"],["bool"]]]],[5,"configure_main","","",N,[[["entrycontext"],["str"]]]],[11,"visit_item","","",351,[[["self"],["item"]]]],[11,"visit_trait_item","","",351,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",351,[[["self"],["implitem"]]]],[0,"exported_symbols","rustc::middle","",N,N],[4,"SymbolExportLevel","rustc::middle::exported_symbols","The SymbolExportLevel of a symbols specifies from which kinds of crates the symbol will be exported. `C` symbols will be exported from any kind of crate, including cdylibs which export very few things. `Rust` will only be exported if the crate produced is a Rust dylib.",N,N],[13,"C","","",352,N],[13,"Rust","","",352,N],[4,"ExportedSymbol","","",N,N],[13,"NonGeneric","","",353,N],[13,"Generic","","",353,N],[13,"NoDefId","","",353,N],[5,"metadata_symbol_name","","",N,[[["tyctxt"]],["string"]]],[11,"assert_receiver_is_total_eq","","",352,N],[11,"eq","","",352,[[["self"],["symbolexportlevel"]],["bool"]]],[11,"fmt","","",352,[[["self"],["formatter"]],["result"]]],[11,"clone","","",352,[[["self"]],["symbolexportlevel"]]],[11,"encode","","",352,[[["self"],["__s"]],["result"]]],[11,"decode","","",352,[[["__d"]],["result",["symbolexportlevel"]]]],[11,"hash_stable","","",352,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"is_below_threshold","","",352,[[["self"],["symbolexportlevel"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",353,N],[11,"eq","","",353,[[["self"],["exportedsymbol"]],["bool"]]],[11,"ne","","",353,[[["self"],["exportedsymbol"]],["bool"]]],[11,"fmt","","",353,[[["self"],["formatter"]],["result"]]],[11,"clone","","",353,[[["self"]],["exportedsymbol"]]],[11,"encode","","",353,[[["self"],["__s"]],["result"]]],[11,"decode","","",353,[[["__d"]],["result",["exportedsymbol"]]]],[11,"symbol_name","","",353,[[["self"],["tyctxt"]],["symbolname"]]],[11,"compare_stable","","",353,[[["self"],["tyctxt"],["exportedsymbol"]],["ordering"]]],[11,"hash_stable","","",353,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"free_region","rustc::middle","This file handles the relationships between free regions -- meaning lifetime parameters. Ordinarily, free regions are unrelated to one another, but they can be related via implied or explicit bounds.  In that case, we track the bounds using the `TransitiveRelation` type and use that to decide when one free region outlives another and so forth.",N,N],[3,"RegionRelations","rustc::middle::free_region","Combines a `region::ScopeTree` (which governs relationships between scopes) and a `FreeRegionMap` (which governs relationships between free regions) to yield a complete relation between concrete regions.",N,N],[12,"tcx","","",354,N],[12,"context","","context used to fetch the region maps",354,N],[12,"region_scope_tree","","region maps for the given context",354,N],[12,"free_regions","","free-region relationships",354,N],[11,"new","","",354,[[["tyctxt"],["defid"],["scopetree"],["freeregionmap"]],["self"]]],[11,"is_subregion_of","","Determines whether one region is a subregion of another.  This is intended to run after inference and sadly the logic is somewhat duplicated with the code in infer.rs.",354,[[["self"],["region"],["region"]],["bool"]]],[11,"is_static","","Determines whether this free-region is required to be 'static",354,[[["self"],["region"]],["bool"]]],[11,"lub_free_regions","","",354,[[["self"],["region"],["region"]],["region"]]],[0,"intrinsicck","rustc::middle","",N,N],[3,"ItemVisitor","rustc::middle::intrinsicck","",N,N],[12,"tcx","","",355,N],[3,"ExprVisitor","","",N,N],[12,"tcx","","",356,N],[12,"tables","","",356,N],[12,"param_env","","",356,N],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"unpack_option_like","","If the type is `Option<T>`, it will return `T`, otherwise the type itself. Works on most `Option`-like types.",N,[[["tyctxt"],["ty"]],["ty"]]],[11,"def_id_is_transmute","","",356,[[["self"],["defid"]],["bool"]]],[11,"check_transmute","","",356,[[["self"],["span"],["ty"],["ty"]]]],[11,"nested_visit_map","","",355,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",355,[[["self"],["bodyid"]]]],[11,"nested_visit_map","","",356,[[["self"]],["nestedvisitormap"]]],[11,"visit_expr","","",356,[[["self"],["expr"]]]],[0,"lib_features","rustc::middle","",N,N],[3,"LibFeatures","rustc::middle::lib_features","",N,N],[12,"stable","","",357,N],[12,"unstable","","",357,N],[3,"LibFeatureCollector","","",N,N],[12,"tcx","","",358,N],[12,"lib_features","","",358,N],[5,"collect","","",N,[[["tyctxt"]],["libfeatures"]]],[11,"new","","",357,[[],["libfeatures"]]],[11,"to_vec","","",357,[[["self"]],["vec"]]],[11,"new","","",358,[[["tyctxt"]],["libfeaturecollector"]]],[11,"extract","","",358,[[["self"],["attribute"]],["option"]]],[11,"collect_feature","","",358,[[["self"],["symbol"],["option",["symbol"]],["span"]]]],[11,"nested_visit_map","","",358,[[["self"]],["nestedvisitormap"]]],[11,"visit_attribute","","",358,[[["self"],["attribute"]]]],[0,"lang_items","rustc::middle","",N,N],[3,"LanguageItems","rustc::middle::lang_items","",N,N],[12,"items","","",359,N],[12,"missing","","",359,N],[3,"LanguageItemCollector","","",N,N],[12,"items","","",360,N],[12,"tcx","","",360,N],[12,"item_refs","","",360,N],[4,"LangItem","","",N,N],[13,"CharImplItem","","",361,N],[13,"StrImplItem","","",361,N],[13,"SliceImplItem","","",361,N],[13,"SliceU8ImplItem","","",361,N],[13,"StrAllocImplItem","","",361,N],[13,"SliceAllocImplItem","","",361,N],[13,"SliceU8AllocImplItem","","",361,N],[13,"ConstPtrImplItem","","",361,N],[13,"MutPtrImplItem","","",361,N],[13,"I8ImplItem","","",361,N],[13,"I16ImplItem","","",361,N],[13,"I32ImplItem","","",361,N],[13,"I64ImplItem","","",361,N],[13,"I128ImplItem","","",361,N],[13,"IsizeImplItem","","",361,N],[13,"U8ImplItem","","",361,N],[13,"U16ImplItem","","",361,N],[13,"U32ImplItem","","",361,N],[13,"U64ImplItem","","",361,N],[13,"U128ImplItem","","",361,N],[13,"UsizeImplItem","","",361,N],[13,"F32ImplItem","","",361,N],[13,"F64ImplItem","","",361,N],[13,"F32RuntimeImplItem","","",361,N],[13,"F64RuntimeImplItem","","",361,N],[13,"SizedTraitLangItem","","",361,N],[13,"UnsizeTraitLangItem","","",361,N],[13,"CopyTraitLangItem","","",361,N],[13,"CloneTraitLangItem","","",361,N],[13,"SyncTraitLangItem","","",361,N],[13,"FreezeTraitLangItem","","",361,N],[13,"DropTraitLangItem","","",361,N],[13,"CoerceUnsizedTraitLangItem","","",361,N],[13,"AddTraitLangItem","","",361,N],[13,"SubTraitLangItem","","",361,N],[13,"MulTraitLangItem","","",361,N],[13,"DivTraitLangItem","","",361,N],[13,"RemTraitLangItem","","",361,N],[13,"NegTraitLangItem","","",361,N],[13,"NotTraitLangItem","","",361,N],[13,"BitXorTraitLangItem","","",361,N],[13,"BitAndTraitLangItem","","",361,N],[13,"BitOrTraitLangItem","","",361,N],[13,"ShlTraitLangItem","","",361,N],[13,"ShrTraitLangItem","","",361,N],[13,"AddAssignTraitLangItem","","",361,N],[13,"SubAssignTraitLangItem","","",361,N],[13,"MulAssignTraitLangItem","","",361,N],[13,"DivAssignTraitLangItem","","",361,N],[13,"RemAssignTraitLangItem","","",361,N],[13,"BitXorAssignTraitLangItem","","",361,N],[13,"BitAndAssignTraitLangItem","","",361,N],[13,"BitOrAssignTraitLangItem","","",361,N],[13,"ShlAssignTraitLangItem","","",361,N],[13,"ShrAssignTraitLangItem","","",361,N],[13,"IndexTraitLangItem","","",361,N],[13,"IndexMutTraitLangItem","","",361,N],[13,"UnsafeCellTypeLangItem","","",361,N],[13,"DerefTraitLangItem","","",361,N],[13,"DerefMutTraitLangItem","","",361,N],[13,"FnTraitLangItem","","",361,N],[13,"FnMutTraitLangItem","","",361,N],[13,"FnOnceTraitLangItem","","",361,N],[13,"GeneratorStateLangItem","","",361,N],[13,"GeneratorTraitLangItem","","",361,N],[13,"EqTraitLangItem","","",361,N],[13,"PartialOrdTraitLangItem","","",361,N],[13,"OrdTraitLangItem","","",361,N],[13,"PanicFnLangItem","","",361,N],[13,"PanicBoundsCheckFnLangItem","","",361,N],[13,"PanicInfoLangItem","","",361,N],[13,"PanicImplLangItem","","",361,N],[13,"BeginPanicFnLangItem","","",361,N],[13,"ExchangeMallocFnLangItem","","",361,N],[13,"BoxFreeFnLangItem","","",361,N],[13,"DropInPlaceFnLangItem","","",361,N],[13,"OomLangItem","","",361,N],[13,"AllocLayoutLangItem","","",361,N],[13,"StartFnLangItem","","",361,N],[13,"EhPersonalityLangItem","","",361,N],[13,"EhUnwindResumeLangItem","","",361,N],[13,"MSVCTryFilterLangItem","","",361,N],[13,"OwnedBoxLangItem","","",361,N],[13,"PhantomDataItem","","",361,N],[13,"ManuallyDropItem","","",361,N],[13,"DebugTraitLangItem","","",361,N],[13,"I128AddFnLangItem","","",361,N],[13,"U128AddFnLangItem","","",361,N],[13,"I128SubFnLangItem","","",361,N],[13,"U128SubFnLangItem","","",361,N],[13,"I128MulFnLangItem","","",361,N],[13,"U128MulFnLangItem","","",361,N],[13,"I128DivFnLangItem","","",361,N],[13,"U128DivFnLangItem","","",361,N],[13,"I128RemFnLangItem","","",361,N],[13,"U128RemFnLangItem","","",361,N],[13,"I128ShlFnLangItem","","",361,N],[13,"U128ShlFnLangItem","","",361,N],[13,"I128ShrFnLangItem","","",361,N],[13,"U128ShrFnLangItem","","",361,N],[13,"I128AddoFnLangItem","","",361,N],[13,"U128AddoFnLangItem","","",361,N],[13,"I128SuboFnLangItem","","",361,N],[13,"U128SuboFnLangItem","","",361,N],[13,"I128MuloFnLangItem","","",361,N],[13,"U128MuloFnLangItem","","",361,N],[13,"I128ShloFnLangItem","","",361,N],[13,"U128ShloFnLangItem","","",361,N],[13,"I128ShroFnLangItem","","",361,N],[13,"U128ShroFnLangItem","","",361,N],[13,"AlignOffsetLangItem","","",361,N],[13,"TerminationTraitLangItem","","",361,N],[5,"extract","","",N,N],[5,"collect","","",N,[[["tyctxt"]],["languageitems"]]],[11,"fmt","","",361,[[["self"],["formatter"]],["result"]]],[11,"clone","","",361,[[["self"]],["langitem"]]],[11,"eq","","",361,[[["self"],["langitem"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",361,N],[11,"hash","","",361,N],[11,"encode","","",361,[[["self"],["__s"]],["result"]]],[11,"decode","","",361,[[["__d"]],["result",["langitem"]]]],[11,"from_u32","","",361,[[["u32"]],["option",["langitem"]]]],[11,"name","","",361,[[["self"]],["str"]]],[11,"new","","",359,[[],["languageitems"]]],[11,"items","","",359,N],[11,"require","","",359,[[["self"],["langitem"]],["result",["defid","string"]]]],[11,"fn_trait_kind","","",359,[[["self"],["defid"]],["option",["closurekind"]]]],[11,"char_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"str_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"slice_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"slice_u8_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"str_alloc_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"slice_alloc_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"slice_u8_alloc_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"const_ptr_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"mut_ptr_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"i8_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"i16_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"i32_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"i64_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"isize_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"u8_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"u16_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"u32_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"u64_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"usize_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"f32_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"f64_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"f32_runtime_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"f64_runtime_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"sized_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"unsize_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"copy_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"clone_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"sync_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"freeze_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"drop_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"coerce_unsized_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"add_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"sub_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"mul_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"div_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"rem_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"neg_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"not_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"bitxor_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"bitand_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"bitor_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"shl_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"shr_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"add_assign_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"sub_assign_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"mul_assign_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"div_assign_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"rem_assign_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"bitxor_assign_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"bitand_assign_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"bitor_assign_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"shl_assign_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"shr_assign_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"index_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"index_mut_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"unsafe_cell_type","","",359,[[["self"]],["option",["defid"]]]],[11,"deref_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"deref_mut_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"fn_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"fn_mut_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"fn_once_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"gen_state","","",359,[[["self"]],["option",["defid"]]]],[11,"gen_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"eq_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"partial_ord_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"ord_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"panic_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"panic_bounds_check_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"panic_info","","",359,[[["self"]],["option",["defid"]]]],[11,"panic_impl","","",359,[[["self"]],["option",["defid"]]]],[11,"begin_panic_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"exchange_malloc_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"box_free_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"drop_in_place_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"oom","","",359,[[["self"]],["option",["defid"]]]],[11,"alloc_layout","","",359,[[["self"]],["option",["defid"]]]],[11,"start_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"eh_personality","","",359,[[["self"]],["option",["defid"]]]],[11,"eh_unwind_resume","","",359,[[["self"]],["option",["defid"]]]],[11,"msvc_try_filter","","",359,[[["self"]],["option",["defid"]]]],[11,"owned_box","","",359,[[["self"]],["option",["defid"]]]],[11,"phantom_data","","",359,[[["self"]],["option",["defid"]]]],[11,"manually_drop","","",359,[[["self"]],["option",["defid"]]]],[11,"debug_trait","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_add_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_add_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_sub_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_sub_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_mul_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_mul_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_div_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_div_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_rem_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_rem_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_shl_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_shl_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_shr_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_shr_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_addo_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_addo_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_subo_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_subo_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_mulo_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_mulo_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_shlo_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_shlo_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"i128_shro_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"u128_shro_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"align_offset_fn","","",359,[[["self"]],["option",["defid"]]]],[11,"termination","","",359,[[["self"]],["option",["defid"]]]],[11,"visit_item","","",360,[[["self"],["item"]]]],[11,"visit_trait_item","","",360,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",360,[[["self"],["implitem"]]]],[11,"new","","",360,[[["tyctxt"]],["languageitemcollector"]]],[11,"collect_item","","",360,[[["self"],["usize"],["defid"]]]],[0,"liveness","rustc::middle","A classic liveness analysis based on dataflow over the AST.  Computes, for each local variable in a function, whether that variable is live at a given point.  Program execution points are identified by their id.",N,N],[3,"Variable","rustc::middle::liveness","",N,N],[12,"0","","",362,N],[3,"LiveNode","","",N,N],[12,"0","","",363,N],[3,"CaptureInfo","","",N,N],[12,"ln","","",364,N],[12,"var_hid","","",364,N],[3,"LocalInfo","","",N,N],[12,"id","","",365,N],[12,"name","","",365,N],[12,"is_shorthand","","",365,N],[3,"IrMaps","","",N,N],[12,"tcx","","",366,N],[12,"num_live_nodes","","",366,N],[12,"num_vars","","",366,N],[12,"live_node_map","","",366,N],[12,"variable_map","","",366,N],[12,"capture_info_map","","",366,N],[12,"var_kinds","","",366,N],[12,"lnks","","",366,N],[3,"Users","","",N,N],[12,"reader","","",367,N],[12,"writer","","",367,N],[12,"used","","",367,N],[3,"Specials","","",N,N],[12,"exit_ln","","",368,N],[12,"fallthrough_ln","","",368,N],[12,"clean_exit_var","","",368,N],[3,"Liveness","","",N,N],[12,"ir","","",369,N],[12,"tables","","",369,N],[12,"s","","",369,N],[12,"successors","","",369,N],[12,"users","","",369,N],[12,"break_ln","","",369,N],[12,"cont_ln","","",369,N],[4,"LoopKind","","For use with `propagate_through_loop`.",N,N],[13,"LoopLoop","","An endless `loop` loop.",370,N],[13,"WhileLoop","","A `while` loop, with the given expression as condition.",370,N],[4,"LiveNodeKind","","",N,N],[13,"FreeVarNode","","",371,N],[13,"ExprNode","","",371,N],[13,"VarDefNode","","",371,N],[13,"ExitNode","","",371,N],[4,"VarKind","","",N,N],[13,"Arg","","",372,N],[13,"Local","","",372,N],[13,"CleanExit","","",372,N],[5,"live_node_kind_to_string","","",N,[[["livenodekind"],["tyctxt"]],["string"]]],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"invalid_node","","",N,[[],["livenode"]]],[5,"visit_fn","","",N,[[["irmaps"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[5,"add_from_pat","","",N,[[["irmaps"],["p"]]]],[5,"visit_local","","",N,[[["irmaps"],["local"]]]],[5,"visit_arm","","",N,[[["irmaps"],["arm"]]]],[5,"visit_expr","","",N,[[["irmaps"],["expr"]]]],[5,"invalid_users","","",N,[[],["users"]]],[5,"check_local","","",N,[[["liveness"],["local"]]]],[5,"check_arm","","",N,[[["liveness"],["arm"]]]],[5,"check_expr","","",N,[[["liveness"],["expr"]]]],[17,"ACC_READ","","",N,N],[17,"ACC_WRITE","","",N,N],[17,"ACC_USE","","",N,N],[11,"clone","","",362,[[["self"]],["variable"]]],[11,"eq","","",362,[[["self"],["variable"]],["bool"]]],[11,"ne","","",362,[[["self"],["variable"]],["bool"]]],[11,"clone","","",363,[[["self"]],["livenode"]]],[11,"eq","","",363,[[["self"],["livenode"]],["bool"]]],[11,"ne","","",363,[[["self"],["livenode"]],["bool"]]],[11,"get","","",362,[[["self"]],["usize"]]],[11,"get","","",363,[[["self"]],["usize"]]],[11,"clone","","",371,[[["self"]],["livenodekind"]]],[11,"eq","","",371,[[["self"],["livenodekind"]],["bool"]]],[11,"ne","","",371,[[["self"],["livenodekind"]],["bool"]]],[11,"fmt","","",371,[[["self"],["formatter"]],["result"]]],[11,"nested_visit_map","","",366,[[["self"]],["nestedvisitormap"]]],[11,"visit_fn","","",366,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_local","","",366,[[["self"],["local"]]]],[11,"visit_expr","","",366,[[["self"],["expr"]]]],[11,"visit_arm","","",366,[[["self"],["arm"]]]],[11,"fmt","","",363,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",362,[[["self"],["formatter"]],["result"]]],[11,"is_valid","","",363,[[["self"]],["bool"]]],[11,"clone","","",365,[[["self"]],["localinfo"]]],[11,"fmt","","",365,[[["self"],["formatter"]],["result"]]],[11,"clone","","",372,[[["self"]],["varkind"]]],[11,"fmt","","",372,[[["self"],["formatter"]],["result"]]],[11,"new","","",366,[[["tyctxt"]],["irmaps"]]],[11,"add_live_node","","",366,[[["self"],["livenodekind"]],["livenode"]]],[11,"add_live_node_for_node","","",366,[[["self"],["hirid"],["livenodekind"]]]],[11,"add_variable","","",366,[[["self"],["varkind"]],["variable"]]],[11,"variable","","",366,[[["self"],["hirid"],["span"]],["variable"]]],[11,"variable_name","","",366,[[["self"],["variable"]],["string"]]],[11,"variable_is_shorthand","","",366,[[["self"],["variable"]],["bool"]]],[11,"set_captures","","",366,[[["self"],["nodeid"],["vec",["captureinfo"]]]]],[11,"lnk","","",366,[[["self"],["livenode"]],["livenodekind"]]],[11,"clone","","",367,[[["self"]],["users"]]],[11,"clone","","",368,[[["self"]],["specials"]]],[11,"new","","",369,[[["irmaps"],["bodyid"]],["liveness"]]],[11,"live_node","","",369,[[["self"],["hirid"],["span"]],["livenode"]]],[11,"variable","","",369,[[["self"],["hirid"],["span"]],["variable"]]],[11,"pat_bindings","","",369,[[["self"],["pat"],["f"]]]],[11,"arm_pats_bindings","","",369,[[["self"],["option",["pat"]],["f"]]]],[11,"define_bindings_in_pat","","",369,[[["self"],["pat"],["livenode"]],["livenode"]]],[11,"define_bindings_in_arm_pats","","",369,[[["self"],["option",["pat"]],["livenode"]],["livenode"]]],[11,"idx","","",369,[[["self"],["livenode"],["variable"]],["usize"]]],[11,"live_on_entry","","",369,[[["self"],["livenode"],["variable"]],["option",["livenodekind"]]]],[11,"live_on_exit","","",369,[[["self"],["livenode"],["variable"]],["option",["livenodekind"]]]],[11,"used_on_entry","","",369,[[["self"],["livenode"],["variable"]],["bool"]]],[11,"assigned_on_entry","","",369,[[["self"],["livenode"],["variable"]],["option",["livenodekind"]]]],[11,"assigned_on_exit","","",369,[[["self"],["livenode"],["variable"]],["option",["livenodekind"]]]],[11,"indices2","","",369,[[["self"],["livenode"],["livenode"],["f"]]]],[11,"write_vars","","",369,[[["self"],["write"],["livenode"],["f"]],["result"]]],[11,"ln_str","","",369,[[["self"],["livenode"]],["string"]]],[11,"init_empty","","",369,[[["self"],["livenode"],["livenode"]]]],[11,"init_from_succ","","",369,[[["self"],["livenode"],["livenode"]]]],[11,"merge_from_succ","","",369,[[["self"],["livenode"],["livenode"],["bool"]],["bool"]]],[11,"define","","",369,[[["self"],["livenode"],["variable"]]]],[11,"acc","","",369,[[["self"],["livenode"],["variable"],["u32"]]]],[11,"compute","","",369,[[["self"],["expr"]],["livenode"]]],[11,"propagate_through_block","","",369,[[["self"],["block"],["livenode"]],["livenode"]]],[11,"propagate_through_stmt","","",369,[[["self"],["stmt"],["livenode"]],["livenode"]]],[11,"propagate_through_decl","","",369,[[["self"],["decl"],["livenode"]],["livenode"]]],[11,"propagate_through_local","","",369,[[["self"],["local"],["livenode"]],["livenode"]]],[11,"propagate_through_exprs","","",369,N],[11,"propagate_through_opt_expr","","",369,[[["self"],["option",["expr"]],["livenode"]],["livenode"]]],[11,"propagate_through_expr","","",369,[[["self"],["expr"],["livenode"]],["livenode"]]],[11,"propagate_through_place_components","","",369,[[["self"],["expr"],["livenode"]],["livenode"]]],[11,"write_place","","",369,[[["self"],["expr"],["livenode"],["u32"]],["livenode"]]],[11,"access_var","","",369,[[["self"],["hirid"],["nodeid"],["livenode"],["u32"],["span"]],["livenode"]]],[11,"access_path","","",369,[[["self"],["hirid"],["path"],["livenode"],["u32"]],["livenode"]]],[11,"propagate_through_loop","","",369,[[["self"],["expr"],["loopkind"],["block"],["livenode"]],["livenode"]]],[11,"nested_visit_map","","",369,[[["self"]],["nestedvisitormap"]]],[11,"visit_local","","",369,[[["self"],["local"]]]],[11,"visit_expr","","",369,[[["self"],["expr"]]]],[11,"visit_arm","","",369,[[["self"],["arm"]]]],[11,"check_place","","",369,[[["self"],["expr"]]]],[11,"should_warn","","",369,[[["self"],["variable"]],["option",["string"]]]],[11,"warn_about_unused_args","","",369,[[["self"],["body"],["livenode"]]]],[11,"warn_about_unused_or_dead_vars_in_pat","","",369,[[["self"],["pat"]]]],[11,"warn_about_unused","","",369,[[["self"],["span"],["hirid"],["livenode"],["variable"]],["bool"]]],[11,"warn_about_dead_assign","","",369,[[["self"],["span"],["hirid"],["livenode"],["variable"]]]],[11,"report_dead_assign","","",369,[[["self"],["hirid"],["span"],["variable"],["bool"]]]],[0,"mem_categorization","rustc::middle","Categorization",N,N],[3,"Upvar","rustc::middle::mem_categorization","",N,N],[12,"id","","",373,N],[12,"kind","","",373,N],[3,"FieldIndex","","",N,N],[12,"0","","",374,N],[12,"1","","",374,N],[3,"cmt_","","",N,N],[12,"hir_id","","",375,N],[12,"span","","",375,N],[12,"cat","","",375,N],[12,"mutbl","","",375,N],[12,"ty","","",375,N],[12,"note","","",375,N],[3,"MemCategorizationContext","","",N,N],[12,"tcx","","",376,N],[12,"region_scope_tree","","",376,N],[12,"tables","","",376,N],[12,"rvalue_promotable_map","","",376,N],[12,"infcx","","",376,N],[4,"Categorization","","",N,N],[13,"Rvalue","","",377,N],[13,"StaticItem","","",377,N],[13,"Upvar","","",377,N],[13,"Local","","",377,N],[13,"Deref","","",377,N],[13,"Interior","","",377,N],[13,"Downcast","","",377,N],[4,"PointerKind","","",N,N],[13,"Unique","","`Box<T>`",378,N],[13,"BorrowedPtr","","`&T`",378,N],[13,"UnsafePtr","","`*T`",378,N],[4,"InteriorKind","","",N,N],[13,"InteriorField","","",379,N],[13,"InteriorElement","","",379,N],[4,"InteriorOffsetKind","","",N,N],[13,"Index","","",380,N],[13,"Pattern","","",380,N],[4,"MutabilityCategory","","",N,N],[13,"McImmutable","","",381,N],[13,"McDeclared","","",381,N],[13,"McInherited","","",381,N],[4,"Note","","",N,N],[13,"NoteClosureEnv","","",382,N],[13,"NoteUpvarRef","","",382,N],[13,"NoteIndex","","",382,N],[13,"NoteNone","","",382,N],[4,"ImmutabilityBlame","","",N,N],[13,"ImmLocal","","",383,N],[13,"ClosureEnv","","",383,N],[13,"LocalDeref","","",383,N],[13,"AdtFieldDeref","","",383,N],[4,"Aliasability","","",N,N],[13,"FreelyAliasable","","",384,N],[13,"NonAliasable","","",384,N],[13,"ImmutableUnique","","",384,N],[4,"AliasableReason","","",N,N],[13,"AliasableBorrowed","","",385,N],[13,"AliasableStatic","","",385,N],[13,"AliasableStaticMut","","",385,N],[5,"ptr_sigil","","",N,[[["pointerkind"]],["str"]]],[6,"cmt","","",N,N],[6,"McResult","","",N,N],[8,"HirNode","","",N,N],[10,"hir_id","","",386,[[["self"]],["hirid"]]],[10,"span","","",386,[[["self"]],["span"]]],[11,"clone","","",377,[[["self"]],["categorization"]]],[11,"fmt","","",377,[[["self"],["formatter"]],["result"]]],[11,"eq","","",377,[[["self"],["categorization"]],["bool"]]],[11,"ne","","",377,[[["self"],["categorization"]],["bool"]]],[11,"clone","","",373,[[["self"]],["upvar"]]],[11,"eq","","",373,[[["self"],["upvar"]],["bool"]]],[11,"ne","","",373,[[["self"],["upvar"]],["bool"]]],[11,"clone","","",378,[[["self"]],["pointerkind"]]],[11,"fmt","","",378,[[["self"],["formatter"]],["result"]]],[11,"eq","","",378,[[["self"],["pointerkind"]],["bool"]]],[11,"ne","","",378,[[["self"],["pointerkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",378,N],[11,"hash","","",378,N],[11,"clone","","",379,[[["self"]],["interiorkind"]]],[11,"eq","","",379,[[["self"],["interiorkind"]],["bool"]]],[11,"ne","","",379,[[["self"],["interiorkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",379,N],[11,"hash","","",379,N],[11,"clone","","",374,[[["self"]],["fieldindex"]]],[11,"assert_receiver_is_total_eq","","",374,N],[11,"eq","","",374,[[["self"],["self"]],["bool"]]],[11,"hash","","",374,[[["self"],["h"]]]],[11,"clone","","",380,[[["self"]],["interioroffsetkind"]]],[11,"eq","","",380,[[["self"],["interioroffsetkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",380,N],[11,"hash","","",380,N],[11,"fmt","","",380,[[["self"],["formatter"]],["result"]]],[11,"clone","","",381,[[["self"]],["mutabilitycategory"]]],[11,"eq","","",381,[[["self"],["mutabilitycategory"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",381,N],[11,"hash","","",381,N],[11,"fmt","","",381,[[["self"],["formatter"]],["result"]]],[11,"clone","","",382,[[["self"]],["note"]]],[11,"eq","","",382,[[["self"],["note"]],["bool"]]],[11,"ne","","",382,[[["self"],["note"]],["bool"]]],[11,"fmt","","",382,[[["self"],["formatter"]],["result"]]],[11,"clone","","",375,[[["self"]],["cmt_"]]],[11,"fmt","","",375,[[["self"],["formatter"]],["result"]]],[11,"eq","","",375,[[["self"],["cmt_"]],["bool"]]],[11,"ne","","",375,[[["self"],["cmt_"]],["bool"]]],[11,"resolve_field","","",375,[[["self"],["usize"]],["option"]]],[11,"immutability_blame","","",375,[[["self"]],["option",["immutabilityblame"]]]],[11,"hir_id","rustc::hir","",58,[[["self"]],["hirid"]]],[11,"span","","",58,[[["self"]],["span"]]],[11,"hir_id","","",50,[[["self"]],["hirid"]]],[11,"span","","",50,[[["self"]],["span"]]],[11,"clone","rustc::middle::mem_categorization","",376,[[["self"]],["memcategorizationcontext"]]],[11,"from_mutbl","","",381,[[["mutability"]],["mutabilitycategory"]]],[11,"from_borrow_kind","","",381,[[["borrowkind"]],["mutabilitycategory"]]],[11,"from_pointer_kind","","",381,[[["mutabilitycategory"],["pointerkind"]],["mutabilitycategory"]]],[11,"from_local","","",381,[[["tyctxt"],["typecktables"],["nodeid"]],["mutabilitycategory"]]],[11,"inherit","","",381,[[["self"]],["mutabilitycategory"]]],[11,"is_mutable","","",381,[[["self"]],["bool"]]],[11,"is_immutable","","",381,[[["self"]],["bool"]]],[11,"to_user_str","","",381,[[["self"]],["str"]]],[11,"new","","",376,[[["tyctxt"],["scopetree"],["typecktables"],["option",["lrc"]]],["memcategorizationcontext"]]],[11,"with_infer","","Creates a `MemCategorizationContext` during type inference. This is used during upvar analysis and a few other places. Because the typeck tables are not yet complete, the results from the analysis must be used with caution:",376,[[["inferctxt"],["scopetree"],["typecktables"]],["memcategorizationcontext"]]],[11,"type_moves_by_default","","",376,[[["self"],["paramenv"],["ty"],["span"]],["bool"]]],[11,"resolve_type_vars_if_possible","","",376,[[["self"],["t"]],["t"]]],[11,"is_tainted_by_errors","","",376,[[["self"]],["bool"]]],[11,"resolve_type_vars_or_error","","",376,[[["self"],["hirid"],["option",["ty"]]],["mcresult",["ty"]]]],[11,"node_ty","","",376,[[["self"],["hirid"]],["mcresult",["ty"]]]],[11,"expr_ty","","",376,[[["self"],["expr"]],["mcresult",["ty"]]]],[11,"expr_ty_adjusted","","",376,[[["self"],["expr"]],["mcresult",["ty"]]]],[11,"pat_ty_adjusted","","Returns the type of value that this pattern matches against. Some non-obvious cases:",376,[[["self"],["pat"]],["mcresult",["ty"]]]],[11,"pat_ty_unadjusted","","Like `pat_ty`, but ignores implicit `&` patterns.",376,[[["self"],["pat"]],["mcresult",["ty"]]]],[11,"cat_expr","","",376,[[["self"],["expr"]],["mcresult",["cmt_"]]]],[11,"cat_expr_adjusted","","",376,[[["self"],["expr"],["cmt_"],["adjustment"]],["mcresult",["cmt_"]]]],[11,"cat_expr_adjusted_with","","",376,[[["self"],["expr"],["f"],["adjustment"]],["mcresult",["cmt_"]]]],[11,"cat_expr_unadjusted","","",376,[[["self"],["expr"]],["mcresult",["cmt_"]]]],[11,"cat_def","","",376,[[["self"],["hirid"],["span"],["ty"],["def"]],["mcresult",["cmt_"]]]],[11,"cat_upvar","","",376,[[["self"],["hirid"],["span"],["nodeid"],["nodeid"]],["mcresult",["cmt_"]]]],[11,"env_deref","","",376,[[["self"],["hirid"],["span"],["upvarid"],["mutabilitycategory"],["borrowkind"],["cmt_"]],["cmt_"]]],[11,"temporary_scope","","Returns the lifetime of a temporary created by expr with id `id`. This could be `'static` if `id` is part of a constant expression.",376,[[["self"],["itemlocalid"]],["region"]]],[11,"cat_rvalue_node","","",376,[[["self"],["hirid"],["span"],["ty"]],["cmt_"]]],[11,"cat_rvalue","","",376,[[["self"],["hirid"],["span"],["region"],["ty"]],["cmt_"]]],[11,"cat_field","","",376,[[["self"],["n"],["cmt"],["usize"],["ident"],["ty"]],["cmt_"]]],[11,"cat_overloaded_place","","",376,[[["self"],["expr"],["expr"],["note"]],["mcresult",["cmt_"]]]],[11,"cat_deref","","",376,N],[11,"cat_index","","Creates a cmt for an indexing operation (`[]`).",376,[[["self"],["n"],["cmt"],["ty"],["interioroffsetkind"]],["mcresult",["cmt_"]]]],[11,"cat_imm_interior","","",376,[[["self"],["n"],["cmt"],["ty"],["interiorkind"]],["cmt_"]]],[11,"cat_downcast_if_needed","","",376,[[["self"],["n"],["cmt"],["defid"]],["cmt"]]],[11,"cat_pattern","","",376,[[["self"],["cmt"],["pat"],["f"]],["mcresult"]]],[11,"cat_pattern_","","",376,[[["self"],["cmt"],["pat"],["f"]],["mcresult"]]],[11,"clone","","",384,[[["self"]],["aliasability"]]],[11,"fmt","","",384,[[["self"],["formatter"]],["result"]]],[11,"clone","","",385,[[["self"]],["aliasablereason"]]],[11,"fmt","","",385,[[["self"],["formatter"]],["result"]]],[11,"guarantor","","Returns `self` after stripping away any derefs or interior content. The return value is basically the `cmt` which determines how long the value in `self` remains live.",375,[[["self"]],["cmt_"]]],[11,"freely_aliasable","","Returns `FreelyAliasable(_)` if this place represents a freely aliasable pointer type.",375,[[["self"]],["aliasability"]]],[11,"upvar_cat","","",375,[[["self"]],["option",["categorization"]]]],[11,"descriptive_string","","",375,[[["self"],["tyctxt"]],["string"]]],[11,"fmt","","",379,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",373,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",373,[[["self"],["formatter"]],["result"]]],[0,"privacy","rustc::middle","A pass that checks to make sure private fields and methods aren't used outside their scopes. This pass will also generate a set of exported items which are available for use externally when compiled as a library.",N,N],[3,"AccessLevels","rustc::middle::privacy","",N,N],[12,"map","","",387,N],[4,"AccessLevel","","",N,N],[13,"ReachableFromImplTrait","","",388,N],[13,"Reachable","","",388,N],[13,"Exported","","",388,N],[13,"Public","","",388,N],[6,"ExternalExports","","A set containing all exported definitions from external crates. The set does not contain any entries from local crates.",N,N],[11,"clone","","",388,[[["self"]],["accesslevel"]]],[11,"fmt","","",388,[[["self"],["formatter"]],["result"]]],[11,"eq","","",388,[[["self"],["accesslevel"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",388,N],[11,"partial_cmp","","",388,[[["self"],["accesslevel"]],["option",["ordering"]]]],[11,"cmp","","",388,[[["self"],["accesslevel"]],["ordering"]]],[11,"clone","","",387,[[["self"]],["accesslevels"]]],[11,"is_reachable","","",387,[[["self"],["id"]],["bool"]]],[11,"is_exported","","",387,[[["self"],["id"]],["bool"]]],[11,"is_public","","",387,[[["self"],["id"]],["bool"]]],[11,"default","","",387,[[],["self"]]],[11,"fmt","","",387,[[["self"],["formatter"]],["result"]]],[0,"reachable","rustc::middle","",N,N],[3,"ReachableContext","rustc::middle::reachable","",N,N],[12,"tcx","","",389,N],[12,"tables","","",389,N],[12,"reachable_symbols","","",389,N],[12,"worklist","","",389,N],[12,"any_library","","",389,N],[3,"CollectPrivateImplItemsVisitor","","",N,N],[12,"tcx","","",390,N],[12,"access_levels","","",390,N],[12,"worklist","","",390,N],[3,"ReachableSet","","",N,N],[12,"0","","",391,N],[5,"item_might_be_inlined","","",N,[[["tyctxt"],["item"],["codegenfnattrs"]],["bool"]]],[5,"method_might_be_inlined","","",N,[[["tyctxt"],["implitem"],["defid"]],["bool"]]],[5,"reachable_set","","",N,[[["tyctxt"],["cratenum"]],["reachableset"]]],[5,"provide","","",N,[[["providers"]]]],[11,"nested_visit_map","","",389,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",389,[[["self"],["bodyid"]]]],[11,"visit_expr","","",389,[[["self"],["expr"]]]],[11,"def_id_represents_local_inlined_item","","",389,[[["self"],["defid"]],["bool"]]],[11,"propagate","","",389,[[["self"]]]],[11,"propagate_node","","",389,[[["self"],["node"],["nodeid"]]]],[11,"visit_item","","",390,[[["self"],["item"]]]],[11,"visit_trait_item","","",390,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",390,[[["self"],["implitem"]]]],[11,"clone","","",391,[[["self"]],["reachableset"]]],[0,"region","rustc::middle","This file builds up the `ScopeTree`, which describes the parent links in the region hierarchy.",N,N],[3,"Scope","rustc::middle::region","Scope represents a statically-describable scope that can be used to bound the lifetime/region for values.",N,N],[12,"id","","",392,N],[12,"data","","",392,N],[3,"FirstStatementIndex","","",N,N],[12,"private","","",393,N],[3,"ScopeTree","","The region scope tree encodes information about region relationships.",N,N],[12,"root_body","","If not empty, this body is the root of this region hierarchy.",394,N],[12,"root_parent","","The parent of the root body owner, if the latter is an an associated const or method, as impls/traits can also have lifetime parameters free in this body.",394,N],[12,"parent_map","","`parent_map` maps from a scope id to the enclosing scope id; this is usually corresponding to the lexical nesting, though in the case of closures the parent scope is the innermost conditional expression or repeating block. (Note that the enclosing scope id for the block associated with a closure is the closure itself.)",394,N],[12,"var_map","","`var_map` maps from a variable or binding id to the block in which that variable is declared.",394,N],[12,"destruction_scopes","","maps from a node-id to the associated destruction scope (if any)",394,N],[12,"rvalue_scopes","","`rvalue_scopes` includes entries for those expressions whose cleanup scope is larger than the default. The map goes from the expression id to the cleanup scope id. For rvalues not present in this table, the appropriate cleanup scope is the innermost enclosing statement, conditional expression, or repeating block (see `terminating_scopes`). In constants, None is used to indicate that certain expressions escape into 'static and should have no local cleanup scope.",394,N],[12,"closure_tree","","Encodes the hierarchy of fn bodies. Every fn body (including closures) forms its own distinct region hierarchy, rooted in the block that is the fn body. This map points from the id of that root block to the id of the root block for the enclosing fn, if any. Thus the map structures the fn bodies into a hierarchy based on their lexical mapping. This is used to handle the relationships between regions in a fn and in a closure defined by that fn. See the \"Modeling closures\" section of the README in infer::region_constraints for more details.",394,N],[12,"yield_in_scope","","If there are any `yield` nested within a scope, this map stores the `Span` of the last one and its index in the postorder of the Visitor traversal on the HIR.",394,N],[12,"body_expr_count","","The number of visit_expr and visit_pat calls done in the body. Used to sanity check visit_expr/visit_pat call count when calculating generator interiors.",394,N],[3,"Context","","",N,N],[12,"root_id","","the root of the current region tree. This is typically the id of the innermost fn body. Each fn forms its own disjoint tree in the region hierarchy. These fn bodies are themselves arranged into a tree. See the \"Modeling closures\" section of the README in infer::region_constraints for more details.",395,N],[12,"var_parent","","The scope that contains any new variables declared, plus its depth in the scope tree.",395,N],[12,"parent","","Region parent of expressions, etc., plus its depth in the scope tree.",395,N],[3,"RegionResolutionVisitor","","",N,N],[12,"tcx","","",396,N],[12,"expr_and_pat_count","","",396,N],[12,"scope_tree","","",396,N],[12,"cx","","",396,N],[12,"terminating_scopes","","`terminating_scopes` is a set containing the ids of each statement, or conditional/repeating expression. These scopes are calling \"terminating scopes\" because, when attempting to find the scope of a temporary, by default we search up the enclosing scopes until we encounter the terminating scope. A conditional/repeating expression is one which is not guaranteed to execute exactly once upon entering the parent scope. This could be because the expression only executes conditionally, such as the expression `b` in `a && b`, or because the expression may execute many times, such as a loop body. The reason that we distinguish such expressions is that, upon exiting the parent scope, we cannot statically know how many times the expression executed, and thus if the expression creates temporaries we cannot know statically how many such temporaries we would have to cleanup. Therefore we ensure that the temporaries never outlast the conditional/repeating expression, preventing the need for dynamic checks and/or arbitrary amounts of stack space. Terminating scopes end up being contained in a DestructionScope that contains the destructor's execution.",396,N],[3,"ExprLocatorVisitor","","",N,N],[12,"hir_id","","",397,N],[12,"result","","",397,N],[12,"expr_and_pat_count","","",397,N],[4,"ScopeData","","",N,N],[13,"Node","","",398,N],[13,"CallSite","","",398,N],[13,"Arguments","","",398,N],[13,"Destruction","","",398,N],[13,"Remainder","","",398,N],[5,"record_var_lifetime","","Records the lifetime of a local variable as `cx.var_parent`",N,[[["regionresolutionvisitor"],["itemlocalid"],["span"]]]],[5,"resolve_block","","",N,[[["regionresolutionvisitor"],["block"]]]],[5,"resolve_arm","","",N,[[["regionresolutionvisitor"],["arm"]]]],[5,"resolve_pat","","",N,[[["regionresolutionvisitor"],["pat"]]]],[5,"resolve_stmt","","",N,[[["regionresolutionvisitor"],["stmt"]]]],[5,"resolve_expr","","",N,[[["regionresolutionvisitor"],["expr"]]]],[5,"resolve_local","","",N,[[["regionresolutionvisitor"],["option",["pat"]],["option",["expr"]]]]],[5,"region_scope_tree","","",N,[[["tyctxt"],["defid"]],["lrc",["scopetree"]]]],[5,"provide","","",N,[[["providers"]]]],[6,"ScopeDepth","","",N,N],[7,"ASSERT","","",N,N],[11,"clone","","",392,[[["self"]],["scope"]]],[11,"eq","","",392,[[["self"],["scope"]],["bool"]]],[11,"ne","","",392,[[["self"],["scope"]],["bool"]]],[11,"partial_cmp","","",392,[[["self"],["scope"]],["option",["ordering"]]]],[11,"lt","","",392,[[["self"],["scope"]],["bool"]]],[11,"le","","",392,[[["self"],["scope"]],["bool"]]],[11,"gt","","",392,[[["self"],["scope"]],["bool"]]],[11,"ge","","",392,[[["self"],["scope"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",392,N],[11,"cmp","","",392,[[["self"],["scope"]],["ordering"]]],[11,"hash","","",392,N],[11,"encode","","",392,[[["self"],["__s"]],["result"]]],[11,"decode","","",392,[[["__d"]],["result",["scope"]]]],[11,"fmt","","",392,[[["self"],["formatter"]],["result"]]],[11,"clone","","",398,[[["self"]],["scopedata"]]],[11,"eq","","",398,[[["self"],["scopedata"]],["bool"]]],[11,"ne","","",398,[[["self"],["scopedata"]],["bool"]]],[11,"partial_cmp","","",398,[[["self"],["scopedata"]],["option",["ordering"]]]],[11,"lt","","",398,[[["self"],["scopedata"]],["bool"]]],[11,"le","","",398,[[["self"],["scopedata"]],["bool"]]],[11,"gt","","",398,[[["self"],["scopedata"]],["bool"]]],[11,"ge","","",398,[[["self"],["scopedata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",398,N],[11,"cmp","","",398,[[["self"],["scopedata"]],["ordering"]]],[11,"hash","","",398,N],[11,"fmt","","",398,[[["self"],["formatter"]],["result"]]],[11,"encode","","",398,[[["self"],["__s"]],["result"]]],[11,"decode","","",398,[[["__d"]],["result",["scopedata"]]]],[11,"clone","","",393,[[["self"]],["firststatementindex"]]],[11,"eq","","",393,[[["self"],["firststatementindex"]],["bool"]]],[11,"ne","","",393,[[["self"],["firststatementindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",393,N],[11,"hash","","",393,N],[11,"partial_cmp","","",393,[[["self"],["firststatementindex"]],["option",["ordering"]]]],[11,"lt","","",393,[[["self"],["firststatementindex"]],["bool"]]],[11,"le","","",393,[[["self"],["firststatementindex"]],["bool"]]],[11,"gt","","",393,[[["self"],["firststatementindex"]],["bool"]]],[11,"ge","","",393,[[["self"],["firststatementindex"]],["bool"]]],[11,"cmp","","",393,[[["self"],["firststatementindex"]],["ordering"]]],[11,"decode","","",393,[[["__d"]],["result",["firststatementindex"]]]],[11,"encode","","",393,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",393,N],[18,"MAX","","",393,N],[11,"from_usize","","",393,[[["usize"]],["self"]]],[11,"from_u32","","",393,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",393,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",393,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",393,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",393,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",393,[[["self"]],["usize"]]],[11,"new","","",393,[[["usize"]],["self"]]],[11,"index","","",393,[[["self"]],["usize"]]],[11,"steps_between","","",393,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",393,[[["self"]],["self"]]],[11,"replace_zero","","",393,[[["self"]],["self"]]],[11,"add_one","","",393,[[["self"]],["self"]]],[11,"sub_one","","",393,[[["self"]],["self"]]],[11,"add_usize","","",393,[[["self"],["usize"]],["option"]]],[11,"from","","",393,[[["usize"]],["self"]]],[11,"from","","",393,[[["u32"]],["self"]]],[11,"fmt","","",393,[[["self"],["formatter"]],["result"]]],[11,"hash_stable","","",393,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"item_local_id","","Returns a item-local id associated with this scope.",392,[[["self"]],["itemlocalid"]]],[11,"node_id","","",392,[[["self"],["tyctxt"],["scopetree"]],["nodeid"]]],[11,"span","","Returns the span of this Scope.  Note that in general the returned span may not correspond to the span of any node id in the AST.",392,[[["self"],["tyctxt"],["scopetree"]],["span"]]],[11,"default","","",394,[[],["scopetree"]]],[11,"fmt","","",394,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",395,[[["self"],["formatter"]],["result"]]],[11,"clone","","",395,[[["self"]],["context"]]],[11,"nested_visit_map","","",397,[[["self"]],["nestedvisitormap"]]],[11,"visit_pat","","",397,[[["self"],["pat"]]]],[11,"visit_expr","","",397,[[["self"],["expr"]]]],[11,"record_scope_parent","","",394,[[["self"],["scope"],["option"]]]],[11,"each_encl_scope","","",394,[[["self"],["e"]]]],[11,"each_var_scope","","",394,[[["self"],["e"]]]],[11,"opt_destruction_scope","","",394,[[["self"],["itemlocalid"]],["option",["scope"]]]],[11,"record_closure_parent","","Records that `sub_closure` is defined within `sup_closure`. These ids should be the id of the block that is the fn body, which is also the root of the region hierarchy for that fn.",394,[[["self"],["itemlocalid"],["itemlocalid"]]]],[11,"record_var_scope","","",394,[[["self"],["itemlocalid"],["scope"]]]],[11,"record_rvalue_scope","","",394,[[["self"],["itemlocalid"],["option",["scope"]]]]],[11,"opt_encl_scope","","Returns the narrowest scope that encloses `id`, if any.",394,[[["self"],["scope"]],["option",["scope"]]]],[11,"encl_scope","","Returns the narrowest scope that encloses `id`, if any.",394,[[["self"],["scope"]],["scope"]]],[11,"var_scope","","Returns the lifetime of the local variable `var_id`",394,[[["self"],["itemlocalid"]],["scope"]]],[11,"temporary_scope","","Returns the scope when temp created by expr_id will be cleaned up",394,[[["self"],["itemlocalid"]],["option",["scope"]]]],[11,"var_region","","Returns the lifetime of the variable `id`.",394,[[["self"],["itemlocalid"]],["regionkind"]]],[11,"scopes_intersect","","",394,[[["self"],["scope"],["scope"]],["bool"]]],[11,"is_subscope_of","","Returns true if `subscope` is equal to or is lexically nested inside `superscope` and false otherwise.",394,[[["self"],["scope"],["scope"]],["bool"]]],[11,"containing_body","","Returns the id of the innermost containing body",394,[[["self"],["scope"]],["option",["itemlocalid"]]]],[11,"nearest_common_ancestor","","Finds the nearest common ancestor of two scopes.  That is, finds the smallest scope which is greater than or equal to both `scope_a` and `scope_b`.",394,[[["self"],["scope"],["scope"]],["scope"]]],[11,"early_free_scope","","Assuming that the provided region was defined within this `ScopeTree`, returns the outermost `Scope` that the region outlives.",394,[[["self"],["tyctxt"],["earlyboundregion"]],["scope"]]],[11,"free_scope","","Assuming that the provided region was defined within this `ScopeTree`, returns the outermost `Scope` that the region outlives.",394,[[["self"],["tyctxt"],["freeregion"]],["scope"]]],[11,"yield_in_scope","","Checks whether the given scope contains a `yield`. If so, returns `Some((span, expr_count))` with the span of a yield we found and the number of expressions and patterns appearing before the `yield` in the body + 1. If there a are multiple yields in a scope, the one with the highest number is returned.",394,[[["self"],["scope"]],["option"]]],[11,"yield_in_scope_for_expr","","Checks whether the given scope contains a `yield` and if that yield could execute after `expr`. If so, it returns the span of that `yield`. `scope` must be inside the body.",394,[[["self"],["scope"],["hirid"],["body"]],["option",["span"]]]],[11,"body_expr_count","","Gives the number of expressions visited in a body. Used to sanity check visit_expr call count when calculating generator interiors.",394,[[["self"],["bodyid"]],["option",["usize"]]]],[11,"record_child_scope","","Records the current parent (if any) as the parent of `child_scope`. Returns the depth of `child_scope`.",396,[[["self"],["scope"]],["scopedepth"]]],[11,"enter_scope","","Records the current parent (if any) as the parent of `child_scope`, and sets `child_scope` as the new current parent.",396,[[["self"],["scope"]]]],[11,"enter_node_scope_with_dtor","","",396,[[["self"],["itemlocalid"]]]],[11,"nested_visit_map","","",396,[[["self"]],["nestedvisitormap"]]],[11,"visit_block","","",396,[[["self"],["block"]]]],[11,"visit_body","","",396,[[["self"],["body"]]]],[11,"visit_arm","","",396,[[["self"],["arm"]]]],[11,"visit_pat","","",396,[[["self"],["pat"]]]],[11,"visit_stmt","","",396,[[["self"],["stmt"]]]],[11,"visit_expr","","",396,[[["self"],["expr"]]]],[11,"visit_local","","",396,[[["self"],["local"]]]],[11,"hash_stable","","",394,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"recursion_limit","rustc::middle","",N,N],[5,"update_limits","rustc::middle::recursion_limit","",N,[[["session"],["crate"]]]],[5,"update_limit","","",N,[[["session"],["crate"],["once"],["str"],["str"],["usize"]]]],[0,"resolve_lifetime","rustc::middle","Name resolution for lifetimes.",N,N],[3,"NamedRegionMap","rustc::middle::resolve_lifetime","Maps the id of each lifetime reference to the lifetime decl that it corresponds to.",N,N],[12,"defs","","",399,N],[12,"late_bound","","",399,N],[12,"object_lifetime_defaults","","",399,N],[3,"ResolveLifetimes","","See `NamedRegionMap`.",N,N],[12,"defs","","",400,N],[12,"late_bound","","",400,N],[12,"object_lifetime_defaults","","",400,N],[3,"LifetimeContext","","",N,N],[12,"tcx","","",401,N],[12,"map","","",401,N],[12,"scope","","",401,N],[12,"trait_ref_hack","","Deep breath. Our representation for poly trait refs contains a single binder and thus we only allow a single level of quantification. However, the syntax of Rust permits quantification in two places, e.g., `T: for <'a> Foo<'a>` and `for <'a, 'b> &'b T: Foo<'a>`. In order to get the de Bruijn indices correct when representing these constraints, we should only introduce one scope. However, we want to support both locations for the quantifier and during lifetime resolution we want precise information (so we can't desugar in an earlier phase).",401,N],[12,"is_in_fn_syntax","","Used to disallow the use of in-band lifetimes in `fn` or `Fn` syntax.",401,N],[12,"labels_in_fn","","List of labels in the function/method currently under analysis.",401,N],[12,"xcrate_object_lifetime_defaults","","Cache for cross-crate per-definition object lifetime defaults.",401,N],[12,"lifetime_uses","","",401,N],[3,"ElisionFailureInfo","","",N,N],[12,"parent","","Where we can find the argument pattern.",402,N],[12,"index","","The index of the argument in the original definition.",402,N],[12,"lifetime_count","","",402,N],[12,"have_bound_regions","","",402,N],[3,"Original","","",N,N],[12,"kind","","",403,N],[12,"span","","",403,N],[3,"Shadower","","",N,N],[12,"kind","","",404,N],[12,"span","","",404,N],[4,"LifetimeDefOrigin","","The origin of a named lifetime definition.",N,N],[13,"Explicit","","",405,N],[13,"InBand","","",405,N],[4,"LifetimeUseSet","","",N,N],[13,"One","","",406,N],[13,"Many","","",406,N],[4,"Region","","",N,N],[13,"Static","","",407,N],[13,"EarlyBound","","",407,N],[13,"LateBound","","",407,N],[13,"LateBoundAnon","","",407,N],[13,"Free","","",407,N],[4,"Set1","","A set containing, at most, one known element. If two distinct values are inserted into a set, then it becomes `Many`, which can be used to detect ambiguities.",N,N],[13,"Empty","","",408,N],[13,"One","","",408,N],[13,"Many","","",408,N],[4,"Scope","","",N,N],[13,"Binder","","Declares lifetimes, and each can be early-bound or late-bound. The `DebruijnIndex` of late-bound lifetimes starts at `1` and it should be shifted by the number of `Binder`s in between the declaration `Binder` and the location it's referenced from.",409,N],[12,"lifetimes","rustc::middle::resolve_lifetime::Scope","",409,N],[12,"next_early_index","","if we extend this scope with another scope, what is the next index we should use for an early-bound region?",409,N],[12,"track_lifetime_uses","","Flag is set to true if, in this binder, `'_` would be equivalent to a \"single-use region\". This is true on impls, but not other kinds of items.",409,N],[12,"abstract_type_parent","","Whether or not this binder would serve as the parent binder for abstract types introduced within. For example:",409,N],[12,"s","","",409,N],[13,"Body","rustc::middle::resolve_lifetime","Lifetimes introduced by a fn are scoped to the call-site for that fn, if this is a fn body, otherwise the original definitions are used. Unspecified lifetimes are inferred, unless an elision scope is nested, e.g. `(&T, fn(&T) -> &T);` becomes `(&'_ T, for<'a> fn(&'a T) -> &'a T)`.",409,N],[12,"id","rustc::middle::resolve_lifetime::Scope","",409,N],[12,"s","","",409,N],[13,"Elision","rustc::middle::resolve_lifetime","A scope which either determines unspecified lifetimes or errors on them (e.g. due to ambiguity). For more details, see `Elide`.",409,N],[12,"elide","rustc::middle::resolve_lifetime::Scope","",409,N],[12,"s","","",409,N],[13,"ObjectLifetimeDefault","rustc::middle::resolve_lifetime","Use a specific lifetime (if `Some`) or leave it unset (to be inferred in a function body or potentially error outside one), for the default choice of lifetime in a trait object type.",409,N],[12,"lifetime","rustc::middle::resolve_lifetime::Scope","",409,N],[12,"s","","",409,N],[13,"Root","rustc::middle::resolve_lifetime","",409,N],[4,"Elide","","",N,N],[13,"FreshLateAnon","","Use a fresh anonymous late-bound lifetime each time, by incrementing the counter to generate sequential indices.",410,N],[13,"Exact","","Always use this one lifetime.",410,N],[13,"Error","","Less or more than one lifetime were found, error on unspecified.",410,N],[4,"ShadowKind","","",N,N],[13,"Label","","",411,N],[13,"Lifetime","","",411,N],[5,"provide","","",N,[[["providers"]]]],[5,"resolve_lifetimes","","Computes the `ResolveLifetimes` map that contains data for the entire crate. You should not read the result of this query directly, but rather use `named_region_map`, `is_late_bound_map`, etc.",N,[[["tyctxt"],["cratenum"]],["lrc",["resolvelifetimes"]]]],[5,"krate","","",N,[[["tyctxt"]],["namedregionmap"]]],[5,"original_label","","",N,[[["span"]],["original"]]],[5,"shadower_label","","",N,[[["span"]],["shadower"]]],[5,"original_lifetime","","",N,[[["span"]],["original"]]],[5,"shadower_lifetime","","",N,[[["genericparam"]],["shadower"]]],[5,"check_mixed_explicit_and_in_band_defs","","",N,[[["tyctxt"],["p"]]]],[5,"signal_shadowing_problem","","",N,[[["tyctxt"],["name"],["original"],["shadower"]]]],[5,"extract_labels","","",N,[[["lifetimecontext"],["body"]]]],[5,"compute_object_lifetime_defaults","","",N,[[["tyctxt"]],["nodemap",["vec"]]]],[5,"object_lifetime_defaults_for_item","","Scan the bounds and where-clauses on parameters to extract bounds of the form `T:'a` so as to determine the `ObjectLifetimeDefault` for each type parameter.",N,[[["tyctxt"],["generics"]],["vec",["objectlifetimedefault"]]]],[5,"insert_late_bound_lifetimes","","Detects late-bound lifetimes and inserts them into `map.late_bound`.",N,[[["namedregionmap"],["fndecl"],["generics"]]]],[5,"report_missing_lifetime_specifiers","","",N,[[["session"],["span"],["usize"]],["diagnosticbuilder"]]],[6,"ObjectLifetimeDefault","","",N,N],[6,"ScopeRef","","",N,N],[17,"ROOT_SCOPE","","",N,N],[11,"clone","","",405,[[["self"]],["lifetimedeforigin"]]],[11,"eq","","",405,[[["self"],["lifetimedeforigin"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",405,N],[11,"hash","","",405,N],[11,"encode","","",405,[[["self"],["__s"]],["result"]]],[11,"decode","","",405,[[["__d"]],["result",["lifetimedeforigin"]]]],[11,"fmt","","",405,[[["self"],["formatter"]],["result"]]],[11,"from_param","","",405,[[["genericparam"]],["self"]]],[11,"clone","","",406,[[["self"]],["lifetimeuseset"]]],[11,"fmt","","",406,[[["self"],["formatter"]],["result"]]],[11,"clone","","",407,[[["self"]],["region"]]],[11,"eq","","",407,[[["self"],["region"]],["bool"]]],[11,"ne","","",407,[[["self"],["region"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",407,N],[11,"hash","","",407,N],[11,"encode","","",407,[[["self"],["__s"]],["result"]]],[11,"decode","","",407,[[["__d"]],["result",["region"]]]],[11,"fmt","","",407,[[["self"],["formatter"]],["result"]]],[11,"early","","",407,N],[11,"late","","",407,N],[11,"late_anon","","",407,[[["cell"]],["region"]]],[11,"id","","",407,[[["self"]],["option",["defid"]]]],[11,"shifted","","",407,[[["self"],["u32"]],["region"]]],[11,"shifted_out_to_binder","","",407,[[["self"],["debruijnindex"]],["region"]]],[11,"subst","","",407,[[["self"],["l"],["namedregionmap"]],["option",["region"]]]],[11,"clone","","",408,[[["self"]],["set1"]]],[11,"eq","","",408,[[["self"],["set1"]],["bool"]]],[11,"ne","","",408,[[["self"],["set1"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",408,N],[11,"encode","","",408,[[["self"],["__st"]],["result"]]],[11,"decode","","",408,[[["__dt"]],["result",["set1"]]]],[11,"fmt","","",408,[[["self"],["formatter"]],["result"]]],[11,"insert","","",408,[[["self"],["t"]]]],[11,"default","","",399,[[],["namedregionmap"]]],[11,"hash_stable","","",400,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"fmt","","",409,[[["self"],["formatter"]],["result"]]],[11,"clone","","",410,[[["self"]],["elide"]]],[11,"fmt","","",410,[[["self"],["formatter"]],["result"]]],[11,"clone","","",402,[[["self"]],["elisionfailureinfo"]]],[11,"fmt","","",402,[[["self"],["formatter"]],["result"]]],[11,"nested_visit_map","","",401,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_item","","",401,[[["self"],["itemid"]]]],[11,"visit_nested_body","","",401,[[["self"],["bodyid"]]]],[11,"visit_item","","",401,[[["self"],["item"]]]],[11,"visit_foreign_item","","",401,[[["self"],["foreignitem"]]]],[11,"visit_ty","","",401,[[["self"],["ty"]]]],[11,"visit_trait_item","","",401,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",401,[[["self"],["implitem"]]]],[11,"visit_lifetime","","",401,[[["self"],["lifetime"]]]],[11,"visit_path","","",401,[[["self"],["path"],["hirid"]]]],[11,"visit_fn_decl","","",401,[[["self"],["fndecl"]]]],[11,"visit_generics","","",401,[[["self"],["generics"]]]],[11,"visit_poly_trait_ref","","",401,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"clone","","",411,[[["self"]],["shadowkind"]]],[11,"eq","","",411,[[["self"],["shadowkind"]],["bool"]]],[11,"desc","","",411,[[["self"]],["str"]]],[11,"hack","","",401,[[["self"],["f"]]]],[11,"with","","",401,[[["self"],["scope"],["f"]]]],[11,"check_uses_for_lifetimes_defined_by_scope","","",401,[[["self"]]]],[11,"visit_early_late","","Visits self by adding a scope and handling recursive walk over the contents with `walk`.",401,[[["self"],["option",["nodeid"]],["fndecl"],["generics"],["f"]]]],[11,"next_early_index_helper","","",401,[[["self"],["bool"]],["u32"]]],[11,"next_early_index","","Returns the next index one would use for an early-bound-region if extending the current scope.",401,[[["self"]],["u32"]]],[11,"next_early_index_for_abstract_type","","Returns the next index one would use for an `impl Trait` that is being converted into an `abstract type`. This will be the next early index from the enclosing item, for the most part. See the `abstract_type_parent` field for more info.",401,[[["self"]],["u32"]]],[11,"resolve_lifetime_ref","","",401,[[["self"],["lifetime"]]]],[11,"visit_segment_args","","",401,[[["self"],["def"],["usize"],["genericargs"]]]],[11,"visit_fn_like_elision","","",401,N],[11,"resolve_elided_lifetimes","","",401,[[["self"],["vec",["lifetime"]]]]],[11,"report_elision_failure","","",401,N],[11,"resolve_object_lifetime_default","","",401,[[["self"],["lifetime"]]]],[11,"check_lifetime_params","","",401,N],[11,"check_lifetime_param_for_shadowing","","",401,[[["self"],["scope"],["genericparam"]]]],[11,"track_lifetime_uses","","Returns true if, in the current scope, replacing `'_` would be equivalent to a single-use lifetime.",401,[[["self"]],["bool"]]],[11,"insert_lifetime","","",401,[[["self"],["lifetime"],["region"]]]],[11,"uninsert_lifetime_on_error","","Sometimes we resolve a lifetime, but later find that it is an error (esp. around impl trait). In that case, we remove the entry into `map.defs` so as not to confuse later code.",401,[[["self"],["lifetime"],["region"]]]],[0,"stability","rustc::middle","A pass that annotates every item and method with its stability level, propagating default levels lexically from parent to children ast nodes.",N,N],[3,"DeprecationEntry","rustc::middle::stability","An entry in the `depr_map`.",N,N],[12,"attr","","The metadata of the attribute associated with this entry.",412,N],[12,"origin","","The def id where the attr was originally attached. `None` for non-local `DefId`'s.",412,N],[3,"Index","","A stability index, giving the stability level for items and methods.",N,N],[12,"stab_map","","This is mostly a cache, except the stabilities of local items are filled by the annotator.",413,N],[12,"depr_map","","",413,N],[12,"staged_api","","Maps for each crate whether it is part of the staged API.",413,N],[12,"active_features","","Features enabled for this crate.",413,N],[3,"Annotator","","",N,N],[12,"tcx","","",414,N],[12,"index","","",414,N],[12,"parent_stab","","",414,N],[12,"parent_depr","","",414,N],[12,"in_trait_impl","","",414,N],[3,"MissingStabilityAnnotations","","",N,N],[12,"tcx","","",415,N],[12,"access_levels","","",415,N],[3,"Checker","","",N,N],[12,"tcx","","",416,N],[4,"StabilityLevel","","",N,N],[13,"Unstable","","",417,N],[13,"Stable","","",417,N],[4,"AnnotationKind","","",N,N],[13,"Required","","",418,N],[13,"Prohibited","","",418,N],[13,"Container","","",418,N],[4,"EvalResult","","Result of `TyCtxt::eval_stability`.",N,N],[13,"Allow","","We can use the item because it is stable or we provided the corresponding feature gate.",419,N],[13,"Deny","","We cannot use the item because it is unstable and we did not provide the corresponding feature gate.",419,N],[12,"feature","rustc::middle::stability::EvalResult","",419,N],[12,"reason","","",419,N],[12,"issue","","",419,N],[13,"Unmarked","rustc::middle::stability","The item does not have the `#[stable]` or `#[unstable]` marker assigned.",419,N],[5,"check_unstable_api_usage","","Cross-references the feature names of unstable APIs with enabled features and possibly prints errors.",N,[[["tyctxt"]]]],[5,"deprecation_in_effect","","Check whether an item marked with `deprecated(since=\"X\")` is currently deprecated (i.e. whether X is not greater than the current rustc version).",N,[[["str"]],["bool"]]],[5,"check_unused_or_stable_features","","Given the list of enabled features that were not language features (i.e. that were expected to be library features), and the list of features used from libraries, identify activated features that don't exist and error about them.",N,[[["tyctxt"]]]],[5,"unnecessary_stable_feature_lint","","",N,[[["tyctxt"],["span"],["symbol"],["symbol"]]]],[5,"duplicate_feature_err","","",N,[[["session"],["span"],["symbol"]]]],[11,"encode","","",417,[[["self"],["__s"]],["result"]]],[11,"decode","","",417,[[["__d"]],["result",["stabilitylevel"]]]],[11,"eq","","",417,[[["self"],["stabilitylevel"]],["bool"]]],[11,"partial_cmp","","",417,[[["self"],["stabilitylevel"]],["option",["ordering"]]]],[11,"clone","","",417,[[["self"]],["stabilitylevel"]]],[11,"fmt","","",417,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",417,N],[11,"hash","","",417,N],[11,"from_attr_level","","",417,[[["stabilitylevel"]],["self"]]],[11,"eq","","",418,[[["self"],["annotationkind"]],["bool"]]],[11,"clone","","",412,[[["self"]],["deprecationentry"]]],[11,"hash_stable","","",412,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"local","","",412,[[["deprecation"],["hirid"]],["deprecationentry"]]],[11,"external","","",412,[[["deprecation"]],["deprecationentry"]]],[11,"same_origin","","",412,[[["self"],["deprecationentry"]],["bool"]]],[11,"hash_stable","","",413,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"annotate","","",414,N],[11,"nested_visit_map","","Because stability levels are scoped lexically, we want to walk nested items in the context of the outer item, so enable deep-walking.",414,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",414,[[["self"],["item"]]]],[11,"visit_trait_item","","",414,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",414,[[["self"],["implitem"]]]],[11,"visit_variant","","",414,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_struct_field","","",414,[[["self"],["structfield"]]]],[11,"visit_foreign_item","","",414,[[["self"],["foreignitem"]]]],[11,"visit_macro_def","","",414,[[["self"],["macrodef"]]]],[11,"check_missing_stability","","",415,[[["self"],["nodeid"],["span"]]]],[11,"nested_visit_map","","",415,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",415,[[["self"],["item"]]]],[11,"visit_trait_item","","",415,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",415,[[["self"],["implitem"]]]],[11,"visit_variant","","",415,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_struct_field","","",415,[[["self"],["structfield"]]]],[11,"visit_foreign_item","","",415,[[["self"],["foreignitem"]]]],[11,"visit_macro_def","","",415,[[["self"],["macrodef"]]]],[11,"new","","",413,[[["tyctxt"]],["index"]]],[11,"local_stability","","",413,[[["self"],["hirid"]],["option",["stability"]]]],[11,"local_deprecation_entry","","",413,[[["self"],["hirid"]],["option",["deprecationentry"]]]],[11,"nested_visit_map","","Because stability levels are scoped lexically, we want to walk nested items in the context of the outer item, so enable deep-walking.",416,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",416,[[["self"],["item"]]]],[11,"visit_path","","",416,[[["self"],["path"],["hirid"]]]],[0,"weak_lang_items","rustc::middle","Validity checking for weak lang items",N,N],[3,"Context","rustc::middle::weak_lang_items","",N,N],[12,"tcx","","",420,N],[12,"items","","",420,N],[5,"check_crate","","Checks the crate for usage of weak lang items, returning a vector of all the language items required by this crate, but not defined yet.",N,[[["tyctxt"],["languageitems"]]]],[5,"link_name","","",N,N],[5,"whitelisted","","Returns whether the specified `lang_item` doesn't actually need to be present for this compilation.",N,[[["tyctxt"],["langitem"]],["bool"]]],[5,"verify","","",N,[[["tyctxt"],["languageitems"]]]],[11,"register","","",420,[[["self"],["str"],["span"]]]],[11,"nested_visit_map","","",420,[[["self"]],["nestedvisitormap"]]],[11,"visit_foreign_item","","",420,[[["self"],["foreignitem"]]]],[0,"mir","rustc","MIR datatypes and passes. See the [rustc guide] for more info.",N,N],[3,"Mir","rustc::mir","Lowered representation of a single function.",N,N],[12,"basic_blocks","","List of basic blocks. References to basic block use a newtyped index type `BasicBlock` that indexes into this vector.",421,N],[12,"source_scopes","","List of source scopes; these are referenced by statements and used for debuginfo. Indexed by a `SourceScope`.",421,N],[12,"source_scope_local_data","","Crate-local information for each source scope, that can't (and needn't) be tracked across crates.",421,N],[12,"promoted","","Rvalues promoted from this function, such as borrows of constants. Each of them is the Mir of a constant with the fn's type parameters in scope, but a separate set of locals.",421,N],[12,"yield_ty","","Yield type of the function, if it is a generator.",421,N],[12,"generator_drop","","Generator drop glue",421,N],[12,"generator_layout","","The layout of a generator. Produced by the state transformation.",421,N],[12,"local_decls","","Declarations of locals.",421,N],[12,"arg_count","","Number of arguments this function takes.",421,N],[12,"upvar_decls","","Names and capture modes of all the closure upvars, assuming the first argument is either the closure or a reference to it.",421,N],[12,"spread_arg","","Mark an argument local (which must be a tuple) as getting passed as its individual components at the LLVM level.",421,N],[12,"span","","A span representing this MIR, for error reporting",421,N],[12,"cache","","A cache for various calculations",421,N],[3,"SourceInfo","","Grouped information about the source code origin of a MIR entity. Intended to be inspected by diagnostics and debuginfo. Most passes can work with it as a whole, within a single function.",N,N],[12,"span","","Source span for the AST pertaining to this MIR entity.",422,N],[12,"scope","","The source scope, keeping track of which bindings can be seen by debuginfo, active lint levels, `unsafe {...}`, etc.",422,N],[3,"Local","","",N,N],[12,"private","","",423,N],[3,"VarBindingForm","","",N,N],[12,"binding_mode","","Is variable bound via `x`, `mut x`, `ref x`, or `ref mut x`?",424,N],[12,"opt_ty_info","","If an explicit type was provided for this variable binding, this holds the source Span of that type.",424,N],[12,"opt_match_place","","Place of the RHS of the =, or the subject of the `match` where this variable is initialized. None in the case of `let PATTERN;`. Some((None, ..)) in the case of and `let [mut] x = ...` because (a) the right-hand side isn't evaluated as a place expression. (b) it gives a way to separate this case from the remaining cases     for diagnostics.",424,N],[12,"pat_span","","Span of the pattern in which this variable was bound.",424,N],[3,"LocalDecl","","A MIR local.",N,N],[12,"mutability","","`let mut x` vs `let x`.",425,N],[12,"is_user_variable","","Some(binding_mode) if this corresponds to a user-declared local variable.",425,N],[12,"internal","","True if this is an internal local",425,N],[12,"ty","","Type of this local.",425,N],[12,"user_ty","","If the user manually ascribed a type to this variable, e.g. via `let x: T`, then we carry that type here. The MIR borrow checker needs this information since it can affect region inference.",425,N],[12,"name","","Name of the local, used in debuginfo and pretty-printing.",425,N],[12,"source_info","","The syntactic (i.e. not visibility) source scope the local is defined in. If the local was defined in a let-statement, this is within the let-statement, rather than outside of it.",425,N],[12,"visibility_scope","","Source scope within which the local is visible (for debuginfo) (see `source_info` for more details).",425,N],[3,"UpvarDecl","","A closure capture, with its name and mode.",N,N],[12,"debug_name","","",426,N],[12,"var_hir_id","","`HirId` of the captured variable",426,N],[12,"by_ref","","If true, the capture is behind a reference.",426,N],[12,"mutability","","",426,N],[3,"BasicBlock","","",N,N],[12,"private","","",427,N],[3,"BasicBlockData","","",N,N],[12,"statements","","List of statements in this block.",428,N],[12,"terminator","","Terminator for this block.",428,N],[12,"is_cleanup","","If true, this block lies on an unwind path. This is used during codegen where distinct kinds of basic blocks may be generated (particularly for MSVC cleanup). Unwind blocks must only branch to other unwind blocks.",428,N],[3,"Terminator","","",N,N],[12,"source_info","","",429,N],[12,"kind","","",429,N],[3,"Statement","","",N,N],[12,"source_info","","",430,N],[12,"kind","","",430,N],[3,"ValidationOperand","","",N,N],[12,"place","","",431,N],[12,"ty","","",431,N],[12,"re","","",431,N],[12,"mutbl","","",431,N],[3,"Static","","The def-id of a static, along with its normalized type (which is stored to avoid requiring normalization when reading MIR).",N,N],[12,"def_id","","",432,N],[12,"ty","","",432,N],[3,"Projection","","The `Projection` data structure defines things of the form `B.x` or `*B` or `B[index]`. Note that it is parameterized because it is shared between `Constant` and `Place`. See the aliases `PlaceProjection` etc below.",N,N],[12,"base","","",433,N],[12,"elem","","",433,N],[3,"Field","","",N,N],[12,"private","","",434,N],[3,"SourceScope","","",N,N],[12,"private","","",435,N],[3,"SourceScopeData","","",N,N],[12,"span","","",436,N],[12,"parent_scope","","",436,N],[3,"SourceScopeLocalData","","",N,N],[12,"lint_root","","A NodeId with lint levels equivalent to this scope's lint levels.",437,N],[12,"safety","","The unsafe block that contains this node.",437,N],[3,"Constant","","Constants",N,N],[12,"span","","",438,N],[12,"ty","","",438,N],[12,"user_ty","","Optional user-given type: for something like `collect::<Vec<_>>`, this would be present and would indicate that `Vec<_>` was explicitly specified.",438,N],[12,"literal","","",438,N],[3,"Promoted","","",N,N],[12,"private","","",439,N],[3,"Location","","",N,N],[12,"block","","the location is within this block",440,N],[12,"statement_index","","the location is the start of the statement; or, if `statement_index` == num-statements, then the start of the terminator.",440,N],[3,"UnsafetyViolation","","",N,N],[12,"source_info","","",441,N],[12,"description","","",441,N],[12,"details","","",441,N],[12,"kind","","",441,N],[3,"UnsafetyCheckResult","","",N,N],[12,"violations","","Violations that are propagated upwards from this function",442,N],[12,"unsafe_blocks","","unsafe blocks in this function, along with whether they are used. This is used for the \"unused_unsafe\" lint.",442,N],[3,"GeneratorLayout","","The layout of generator state",N,N],[12,"fields","","",443,N],[3,"BorrowCheckResult","","",N,N],[12,"closure_requirements","","",444,N],[12,"used_mut_upvars","","",444,N],[3,"ClosureRegionRequirements","","After we borrow check a closure, we are left with various requirements that we have inferred between the free regions that appear in the closure's signature or on its field types.  These requirements are then verified and proved by the closure's creating function. This struct encodes those requirements.",N,N],[12,"num_external_vids","","The number of external regions defined on the closure.  In our example above, it would be 3 -- one for `'static`, then `'1` and `'2`. This is just used for a sanity check later on, to make sure that the number of regions we see at the callsite matches.",445,N],[12,"outlives_requirements","","Requirements between the various free regions defined in indices.",445,N],[3,"ClosureOutlivesRequirement","","Indicates an outlives constraint between a type or between two free-regions declared on the closure.",N,N],[12,"subject","","",446,N],[12,"outlived_free_region","","",446,N],[12,"blame_span","","",446,N],[4,"Safety","","",N,N],[13,"Safe","","",447,N],[13,"BuiltinUnsafe","","Unsafe because of a PushUnsafeBlock",447,N],[13,"FnUnsafe","","Unsafe because of an unsafe fn",447,N],[13,"ExplicitUnsafe","","Unsafe because of an `unsafe` block",447,N],[4,"ClearCrossCrate","","",N,N],[13,"Clear","","",448,N],[13,"Set","","",448,N],[4,"Mutability","","",N,N],[13,"Mut","","",449,N],[13,"Not","","",449,N],[4,"BorrowKind","","",N,N],[13,"Shared","","Data must be immutable and is aliasable.",450,N],[13,"Unique","","Data must be immutable but not aliasable.  This kind of borrow cannot currently be expressed by the user and is used only in implicit closure bindings. It is needed when the closure is borrowing or mutating a mutable referent, e.g.:",450,N],[13,"Mut","","Data is mutable and not aliasable.",450,N],[12,"allow_two_phase_borrow","rustc::mir::BorrowKind","True if this borrow arose from method-call auto-ref (i.e. `adjustment::Adjust::Borrow`)",450,N],[4,"LocalKind","rustc::mir","Classifies locals into categories. See `Mir::local_kind`.",N,N],[13,"Var","","User-declared variable binding",451,N],[13,"Temp","","Compiler-introduced temporary",451,N],[13,"Arg","","Function argument",451,N],[13,"ReturnPointer","","Location of function's return value",451,N],[4,"BindingForm","","",N,N],[13,"Var","","This is a binding for a non-`self` binding, or a `self` that has an explicit type.",452,N],[13,"ImplicitSelf","","Binding for a `self`/`&self`/`&mut self` binding where the type is implicit.",452,N],[13,"RefForGuard","","Reference used in a guard expression to ensure immutability.",452,N],[4,"TerminatorKind","","",N,N],[13,"Goto","","block should have one successor in the graph; we jump there",453,N],[12,"target","rustc::mir::TerminatorKind","",453,N],[13,"SwitchInt","rustc::mir","operand evaluates to an integer; jump depending on its value to one of the targets, and otherwise fallback to `otherwise`",453,N],[12,"discr","rustc::mir::TerminatorKind","discriminant value being tested",453,N],[12,"switch_ty","","type of value being tested",453,N],[12,"values","","Possible values. The locations to branch to in each case are found in the corresponding indices from the `targets` vector.",453,N],[12,"targets","","Possible branch sites. The last element of this vector is used for the otherwise branch, so targets.len() == values.len() + 1 should hold.",453,N],[13,"Resume","rustc::mir","Indicates that the landing pad is finished and unwinding should continue. Emitted by build::scope::diverge_cleanup.",453,N],[13,"Abort","","Indicates that the landing pad is finished and that the process should abort. Used to prevent unwinding for foreign items.",453,N],[13,"Return","","Indicates a normal return. The return place should have been filled in by now. This should occur at most once.",453,N],[13,"Unreachable","","Indicates a terminator that can never be reached.",453,N],[13,"Drop","","Drop the Place",453,N],[12,"location","rustc::mir::TerminatorKind","",453,N],[12,"target","","",453,N],[12,"unwind","","",453,N],[13,"DropAndReplace","rustc::mir","Drop the Place and assign the new value over it. This ensures that the assignment to `P` occurs even if the destructor for place unwinds. Its semantics are best explained by the elaboration:",453,N],[12,"location","rustc::mir::TerminatorKind","",453,N],[12,"value","","",453,N],[12,"target","","",453,N],[12,"unwind","","",453,N],[13,"Call","rustc::mir","Block ends with a call of a converging function",453,N],[12,"func","rustc::mir::TerminatorKind","The function that’s being called",453,N],[12,"args","","Arguments the function is called with. These are owned by the callee, which is free to modify them. This allows the memory occupied by \"by-value\" arguments to be reused across function calls without duplicating the contents.",453,N],[12,"destination","","Destination for the return value. If some, the call is converging.",453,N],[12,"cleanup","","Cleanups to be done if the call unwinds.",453,N],[13,"Assert","rustc::mir","Jump to the target if the condition has the expected value, otherwise panic with a message and a cleanup target.",453,N],[12,"cond","rustc::mir::TerminatorKind","",453,N],[12,"expected","","",453,N],[12,"msg","","",453,N],[12,"target","","",453,N],[12,"cleanup","","",453,N],[13,"Yield","rustc::mir","A suspend point",453,N],[12,"value","rustc::mir::TerminatorKind","The value to return",453,N],[12,"resume","","Where to resume to",453,N],[12,"drop","","Cleanup to be done if the generator is dropped at this suspend point",453,N],[13,"GeneratorDrop","rustc::mir","Indicates the end of the dropping of a generator",453,N],[13,"FalseEdges","","A block where control flow only ever takes one real path, but borrowck needs to be more conservative.",453,N],[12,"real_target","rustc::mir::TerminatorKind","The target normal control flow will take",453,N],[12,"imaginary_targets","","The list of blocks control flow could conceptually take, but won't in practice",453,N],[13,"FalseUnwind","rustc::mir","A terminator for blocks that only take one path in reality, but where we reserve the right to unwind in borrowck, even if it won't happen in practice. This can arise in infinite loops with no function calls for example.",453,N],[12,"real_target","rustc::mir::TerminatorKind","The target normal control flow will take",453,N],[12,"unwind","","The imaginary cleanup block link. This particular path will never be taken in practice, but in order to avoid fragility we want to always consider it in borrowck. We don't want to accept programs which pass borrowck only when panic=abort or some assertions are disabled due to release vs. debug mode builds. This needs to be an Option because of the remove_noop_landing_pads and no_landing_pads passes",453,N],[4,"StatementKind","rustc::mir","",N,N],[13,"Assign","","Write the RHS Rvalue to the LHS Place.",454,N],[13,"ReadForMatch","","This represents all the reading that a pattern match may do (e.g. inspecting constants and discriminant values).",454,N],[13,"SetDiscriminant","","Write the discriminant for a variant to the enum Place.",454,N],[12,"place","rustc::mir::StatementKind","",454,N],[12,"variant_index","","",454,N],[13,"StorageLive","rustc::mir","Start a live range for the storage of the local.",454,N],[13,"StorageDead","","End the current live range for the storage of the local.",454,N],[13,"InlineAsm","","Execute a piece of inline Assembly.",454,N],[12,"asm","rustc::mir::StatementKind","",454,N],[12,"outputs","","",454,N],[12,"inputs","","",454,N],[13,"Validate","rustc::mir","Assert the given places to be valid inhabitants of their type.  These statements are currently only interpreted by miri and only generated when \"-Z mir-emit-validate\" is passed. See https://internals.rust-lang.org/t/types-as-contracts/5562/73 for more details.",454,N],[13,"EndRegion","","Mark one terminating point of a region scope (i.e. static region). (The starting point(s) arise implicitly from borrows.)",454,N],[13,"AscribeUserType","","Encodes a user's type ascription. These need to be preserved intact so that NLL can respect them. For example:",454,N],[13,"Nop","","No-op. Useful for deleting instructions without affecting statement indices.",454,N],[4,"ValidationOp","","The `ValidationOp` describes what happens with each of the operands of a `Validate` statement.",N,N],[13,"Acquire","","Recursively traverse the place following the type and validate that all type invariants are maintained.  Furthermore, acquire exclusive/read-only access to the memory reachable from the place.",455,N],[13,"Release","","Recursive traverse the mutable part of the type and relinquish all exclusive access.",455,N],[13,"Suspend","","Recursive traverse the mutable part of the type and relinquish all exclusive access until the given region ends.  Then, access will be recovered.",455,N],[4,"Place","","A path to a value; something that can be evaluated without changing or disturbing program state.",N,N],[13,"Local","","local variable",456,N],[13,"Static","","static or static mut variable",456,N],[13,"Promoted","","Constant code promoted to an injected static",456,N],[13,"Projection","","projection out of a place (access a field, deref a pointer, etc)",456,N],[4,"ProjectionElem","","",N,N],[13,"Deref","","",457,N],[13,"Field","","",457,N],[13,"Index","","",457,N],[13,"ConstantIndex","","These indices are generated by slice patterns. Easiest to explain by example:",457,N],[12,"offset","rustc::mir::ProjectionElem","index or -index (in Python terms), depending on from_end",457,N],[12,"min_length","","thing being indexed must be at least this long",457,N],[12,"from_end","","counting backwards from end?",457,N],[13,"Subslice","rustc::mir","These indices are generated by slice patterns.",457,N],[12,"from","rustc::mir::ProjectionElem","",457,N],[12,"to","","",457,N],[13,"Downcast","rustc::mir","\"Downcast\" to a variant of an ADT. Currently, we only introduce this for ADTs with more than one variant. It may be better to just introduce it always, or always for enums.",457,N],[4,"Operand","","These are values that can appear inside an rvalue (or an index place). They are intentionally limited to prevent rvalues from being nested in one another.",N,N],[13,"Copy","","Copy: The value must be available for use afterwards.",458,N],[13,"Move","","Move: The value (including old borrows of it) will not be used again.",458,N],[13,"Constant","","Synthesizes a constant value.",458,N],[4,"Rvalue","","Rvalues",N,N],[13,"Use","","x (either a move or copy, depending on type of x)",459,N],[13,"Repeat","","[x; 32]",459,N],[13,"Ref","","&x or &mut x",459,N],[13,"Len","","length of a [X] or [X;n] value",459,N],[13,"Cast","","",459,N],[13,"BinaryOp","","",459,N],[13,"CheckedBinaryOp","","",459,N],[13,"NullaryOp","","",459,N],[13,"UnaryOp","","",459,N],[13,"Discriminant","","Read the discriminant of an ADT.",459,N],[13,"Aggregate","","Create an aggregate value, like a tuple or struct.  This is only needed because we want to distinguish `dest = Foo { x: ..., y: ... }` from `dest.x = ...; dest.y = ...;` in the case that `Foo` has a destructor. These rvalues can be optimized away after type-checking and before lowering.",459,N],[4,"CastKind","","",N,N],[13,"Misc","","",460,N],[13,"ReifyFnPointer","","Convert unique, zero-sized type for a fn to fn()",460,N],[13,"ClosureFnPointer","","Convert non capturing closure to fn()",460,N],[13,"UnsafeFnPointer","","Convert safe fn() to unsafe fn()",460,N],[13,"Unsize","","\"Unsize\" -- convert a thin-or-fat pointer to a fat pointer. codegen must figure out the details once full monomorphization is known. For example, this could be used to cast from a `&[i32;N]` to a `&[i32]`, or a `Box<T>` to a `Box<Trait>` (presuming `T: Trait`).",460,N],[4,"AggregateKind","","",N,N],[13,"Array","","The type is of the element",461,N],[13,"Tuple","","",461,N],[13,"Adt","","The second field is the variant index. It's equal to 0 for struct and union expressions. The fourth field is active field number and is present only for union expressions -- e.g. for a union expression `SomeUnion { c: .. }`, the active field index would identity the field `c`",461,N],[13,"Closure","","",461,N],[13,"Generator","","",461,N],[4,"BinOp","","",N,N],[13,"Add","","The `+` operator (addition)",462,N],[13,"Sub","","The `-` operator (subtraction)",462,N],[13,"Mul","","The `*` operator (multiplication)",462,N],[13,"Div","","The `/` operator (division)",462,N],[13,"Rem","","The `%` operator (modulus)",462,N],[13,"BitXor","","The `^` operator (bitwise xor)",462,N],[13,"BitAnd","","The `&` operator (bitwise and)",462,N],[13,"BitOr","","The `|` operator (bitwise or)",462,N],[13,"Shl","","The `<<` operator (shift left)",462,N],[13,"Shr","","The `>>` operator (shift right)",462,N],[13,"Eq","","The `==` operator (equality)",462,N],[13,"Lt","","The `<` operator (less than)",462,N],[13,"Le","","The `<=` operator (less than or equal to)",462,N],[13,"Ne","","The `!=` operator (not equal to)",462,N],[13,"Ge","","The `>=` operator (greater than or equal to)",462,N],[13,"Gt","","The `>` operator (greater than)",462,N],[13,"Offset","","The `ptr.offset` operator",462,N],[4,"NullOp","","",N,N],[13,"SizeOf","","Return the size of a value of that type",463,N],[13,"Box","","Create a new uninitialized box for a value of that type",463,N],[4,"UnOp","","",N,N],[13,"Not","","The `!` operator for logical inversion",464,N],[13,"Neg","","The `-` operator for negation",464,N],[4,"UnsafetyViolationKind","","",N,N],[13,"General","","",465,N],[13,"MinConstFn","","unsafety is not allowed at all in min const fn",465,N],[13,"ExternStatic","","",465,N],[13,"BorrowPacked","","",465,N],[4,"ClosureOutlivesSubject","","The subject of a ClosureOutlivesRequirement -- that is, the thing that must outlive some region.",N,N],[13,"Ty","","Subject is a type, typically a type parameter, but could also be a projection. Indicates a requirement like `T: 'a` being passed to the caller, where the type here is `T`.",466,N],[13,"Region","","Subject is a free region from the closure. Indicates a requirement like `'a: 'b` being passed to the caller; the region here is `'a`.",466,N],[5,"fmt_const_val","","Write a `ConstValue` in a way closer to the original source code than the `Debug` output.",N,N],[5,"item_path_str","","",N,[[["defid"]],["string"]]],[0,"cache","","",N,N],[3,"Cache","rustc::mir::cache","",N,N],[12,"predecessors","","",467,N],[5,"calculate_predecessors","","",N,[[["mir"]],["indexvec",["basicblock","vec"]]]],[11,"clone","","",467,[[["self"]],["cache"]]],[11,"fmt","","",467,[[["self"],["formatter"]],["result"]]],[11,"encode","","",467,[[["self"],["s"]],["result"]]],[11,"decode","","",467,[[["d"]],["result"]]],[11,"hash_stable","","",467,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",467,[[],["self"]]],[11,"invalidate","","",467,[[["self"]]]],[11,"predecessors","","",467,[[["self"],["mir"]],["mappedreadguard",["indexvec"]]]],[11,"super_fold_with","","",467,[[["self"],["f"]],["cache"]]],[11,"super_visit_with","","",467,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",467,[[["self"],["tyctxt"]],["option"]]],[0,"interpret","rustc::mir","An interpreter for MIR used in CTFE and by miri",N,N],[3,"EvalError","rustc::mir::interpret","",N,N],[12,"kind","","",468,N],[3,"ConstEvalErr","","",N,N],[12,"span","","",469,N],[12,"error","","",469,N],[12,"stacktrace","","",469,N],[3,"FrameInfo","","",N,N],[12,"span","","",470,N],[12,"location","","",470,N],[12,"lint_root","","",470,N],[3,"DynamicLifetime","","",N,N],[12,"frame","","",471,N],[12,"region","","",471,N],[3,"GlobalId","","Uniquely identifies a specific constant or static.",N,N],[12,"instance","","For a constant or static, the `Instance` of the item itself. For a promoted global, the `Instance` of the function they belong to.",472,N],[12,"promoted","","The index for promoted globals within their function's `Mir`.",472,N],[3,"Pointer","","Pointer is generic over the type that represents a reference to Allocations, thus making it possible for the most convenient representation to be used in each context.",N,N],[12,"alloc_id","","",473,N],[12,"offset","","",473,N],[3,"AllocId","","",N,N],[12,"0","","",474,N],[3,"AllocDecodingState","","",N,N],[12,"decoding_state","","",475,N],[12,"data_offsets","","",475,N],[3,"AllocDecodingSession","","",N,N],[12,"state","","",476,N],[12,"session_id","","",476,N],[3,"AllocMap","","",N,N],[12,"id_to_type","","Lets you know what an AllocId refers to",477,N],[12,"type_interner","","Used to ensure that functions and statics only get one associated AllocId",477,N],[12,"next_id","","The AllocId to assign to the next requested id. Always incremented, never gets smaller.",477,N],[3,"Allocation","","",N,N],[12,"bytes","","The actual bytes of the allocation. Note that the bytes of a pointer represent the offset of the pointer",478,N],[12,"relocations","","Maps from byte addresses to allocations. Only the first byte of a pointer is inserted into the map; i.e., every entry in this map applies to `pointer_size` consecutive bytes starting at the given offset.",478,N],[12,"undef_mask","","Denotes undefined memory. Reading from undefined memory is forbidden in miri",478,N],[12,"align","","The alignment of the allocation to detect unaligned reads.",478,N],[12,"mutability","","Whether the allocation is mutable. Also used by codegen to determine if a static should be put into mutable memory, which happens for `static mut` and `static` with interior mutability.",478,N],[3,"Relocations","","",N,N],[12,"0","","",479,N],[3,"UndefMask","","",N,N],[12,"blocks","","",480,N],[12,"len","","",480,N],[4,"EvalErrorKind","","",N,N],[13,"MachineError","","This variant is used by machines to signal their own errors that do not match an existing variant",481,N],[13,"FunctionAbiMismatch","","",481,N],[13,"FunctionArgMismatch","","",481,N],[13,"FunctionArgCountMismatch","","",481,N],[13,"NoMirFor","","",481,N],[13,"UnterminatedCString","","",481,N],[13,"DanglingPointerDeref","","",481,N],[13,"DoubleFree","","",481,N],[13,"InvalidMemoryAccess","","",481,N],[13,"InvalidFunctionPointer","","",481,N],[13,"InvalidBool","","",481,N],[13,"InvalidDiscriminant","","",481,N],[13,"PointerOutOfBounds","","",481,N],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",481,N],[12,"access","","",481,N],[12,"allocation_size","","",481,N],[13,"InvalidNullPointerUsage","rustc::mir::interpret","",481,N],[13,"ReadPointerAsBytes","","",481,N],[13,"ReadBytesAsPointer","","",481,N],[13,"ReadForeignStatic","","",481,N],[13,"InvalidPointerMath","","",481,N],[13,"ReadUndefBytes","","",481,N],[13,"DeadLocal","","",481,N],[13,"InvalidBoolOp","","",481,N],[13,"Unimplemented","","",481,N],[13,"DerefFunctionPointer","","",481,N],[13,"ExecuteMemory","","",481,N],[13,"BoundsCheck","","",481,N],[12,"len","rustc::mir::interpret::EvalErrorKind","",481,N],[12,"index","","",481,N],[13,"Overflow","rustc::mir::interpret","",481,N],[13,"OverflowNeg","","",481,N],[13,"DivisionByZero","","",481,N],[13,"RemainderByZero","","",481,N],[13,"Intrinsic","","",481,N],[13,"InvalidChar","","",481,N],[13,"StackFrameLimitReached","","",481,N],[13,"OutOfTls","","",481,N],[13,"TlsOutOfBounds","","",481,N],[13,"AbiViolation","","",481,N],[13,"AlignmentCheckFailed","","",481,N],[12,"required","rustc::mir::interpret::EvalErrorKind","",481,N],[12,"has","","",481,N],[13,"MemoryLockViolation","rustc::mir::interpret","",481,N],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",481,N],[12,"len","","",481,N],[12,"frame","","",481,N],[12,"access","","",481,N],[12,"lock","","",481,N],[13,"MemoryAcquireConflict","rustc::mir::interpret","",481,N],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",481,N],[12,"len","","",481,N],[12,"kind","","",481,N],[12,"lock","","",481,N],[13,"InvalidMemoryLockRelease","rustc::mir::interpret","",481,N],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",481,N],[12,"len","","",481,N],[12,"frame","","",481,N],[12,"lock","","",481,N],[13,"DeallocatedLockedMemory","rustc::mir::interpret","",481,N],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",481,N],[12,"lock","","",481,N],[13,"ValidationFailure","rustc::mir::interpret","",481,N],[13,"CalledClosureAsFunction","","",481,N],[13,"VtableForArgumentlessMethod","","",481,N],[13,"ModifiedConstantMemory","","",481,N],[13,"AssumptionNotHeld","","",481,N],[13,"InlineAsm","","",481,N],[13,"TypeNotPrimitive","","",481,N],[13,"ReallocatedWrongMemoryKind","","",481,N],[13,"DeallocatedWrongMemoryKind","","",481,N],[13,"ReallocateNonBasePtr","","",481,N],[13,"DeallocateNonBasePtr","","",481,N],[13,"IncorrectAllocationInformation","","",481,N],[13,"Layout","","",481,N],[13,"HeapAllocZeroBytes","","",481,N],[13,"HeapAllocNonPowerOfTwoAlignment","","",481,N],[13,"Unreachable","","",481,N],[13,"Panic","","",481,N],[12,"msg","rustc::mir::interpret::EvalErrorKind","",481,N],[12,"line","","",481,N],[12,"col","","",481,N],[12,"file","","",481,N],[13,"ReadFromReturnPointer","rustc::mir::interpret","",481,N],[13,"PathNotFound","","",481,N],[13,"UnimplementedTraitSelection","","",481,N],[13,"TypeckError","","Abort in case type errors are reached",481,N],[13,"TooGeneric","","Resolution can fail if we are in a too generic context",481,N],[13,"CheckMatchError","","",481,N],[13,"ReferencedConstant","","Cannot compute this constant because it depends on another one which already produced an error",481,N],[13,"GeneratorResumedAfterReturn","","",481,N],[13,"GeneratorResumedAfterPanic","","",481,N],[13,"InfiniteLoop","","",481,N],[4,"Scalar","","A `Scalar` represents an immediate, primitive value existing outside of a `memory::Allocation`. It is in many ways like a small chunk of a `Allocation`, up to 8 bytes in size. Like a range of bytes in an `Allocation`, a `Scalar` can either represent the raw bytes of a simple value or a pointer into another `Allocation`",N,N],[13,"Bits","","The raw bytes of a simple value.",482,N],[12,"size","rustc::mir::interpret::Scalar","The first `size` bytes are the value. Do not try to read less or more bytes that that. The remaining bytes must be 0.",482,N],[12,"bits","","",482,N],[13,"Ptr","rustc::mir::interpret","A pointer into an `Allocation`. An `Allocation` in the `memory` module has a list of relocations, but a `Scalar` is only large enough to contain one, so we just represent the relocation and its associated offset together as a `Pointer` here.",482,N],[4,"ConstValue","","Represents a constant value in Rust. Scalar and ScalarPair are optimizations which matches the LocalValue optimizations for easy conversions between Value and ConstValue.",N,N],[13,"Unevaluated","","Never returned from the `const_eval` query, but the HIR contains these frequently in order to allow HIR creation to happen for everything before needing to be able to run constant evaluation",483,N],[13,"Scalar","","Used only for types with layout::abi::Scalar ABI and ZSTs",483,N],[13,"ScalarPair","","Used only for types with layout::abi::ScalarPair",483,N],[13,"ByRef","","Used only for the remaining cases. An allocation + offset into the allocation. Invariant: The AllocId matches the allocation.",483,N],[4,"ScalarMaybeUndef","","",N,N],[13,"Scalar","","",484,N],[13,"Undef","","",484,N],[4,"Lock","","",N,N],[13,"NoLock","","",485,N],[13,"WriteLock","","",485,N],[13,"ReadLock","","This should never be empty -- that would be a read lock held and nobody there to release it...",485,N],[4,"AccessKind","","",N,N],[13,"Read","","",486,N],[13,"Write","","",486,N],[4,"AllocKind","","",N,N],[13,"Alloc","","",487,N],[13,"Fn","","",487,N],[13,"Static","","",487,N],[4,"State","","",N,N],[13,"Empty","","",488,N],[13,"InProgressNonAlloc","","",488,N],[13,"InProgress","","",488,N],[13,"Done","","",488,N],[4,"AllocType","","",N,N],[13,"Function","","The alloc id is used as a function pointer",489,N],[13,"Static","","The alloc id points to a \"lazy\" static variable that did not get computed (yet). This is also used to break the cycle in recursive statics.",489,N],[13,"Memory","","The alloc id points to memory",489,N],[5,"struct_error","","",N,[[["tyctxtat"],["str"]],["diagnosticbuilder"]]],[5,"specialized_encode_alloc_id","","",N,[[["e"],["tyctxt"],["allocid"]],["result"]]],[5,"write_target_uint","","",N,N],[5,"read_target_uint","","",N,N],[5,"sign_extend","","",N,[[["u128"],["size"]],["u128"]]],[5,"truncate","","",N,[[["u128"],["size"]],["u128"]]],[5,"bit_index","","",N,N],[0,"error","","",N,N],[3,"ConstEvalErr","rustc::mir::interpret::error","",N,N],[12,"span","","",469,N],[12,"error","","",469,N],[12,"stacktrace","","",469,N],[3,"FrameInfo","","",N,N],[12,"span","","",470,N],[12,"location","","",470,N],[12,"lint_root","","",470,N],[3,"EvalError","","",N,N],[12,"kind","","",468,N],[4,"EvalErrorKind","","",N,N],[13,"MachineError","","This variant is used by machines to signal their own errors that do not match an existing variant",481,N],[13,"FunctionAbiMismatch","","",481,N],[13,"FunctionArgMismatch","","",481,N],[13,"FunctionArgCountMismatch","","",481,N],[13,"NoMirFor","","",481,N],[13,"UnterminatedCString","","",481,N],[13,"DanglingPointerDeref","","",481,N],[13,"DoubleFree","","",481,N],[13,"InvalidMemoryAccess","","",481,N],[13,"InvalidFunctionPointer","","",481,N],[13,"InvalidBool","","",481,N],[13,"InvalidDiscriminant","","",481,N],[13,"PointerOutOfBounds","","",481,N],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",481,N],[12,"access","","",481,N],[12,"allocation_size","","",481,N],[13,"InvalidNullPointerUsage","rustc::mir::interpret::error","",481,N],[13,"ReadPointerAsBytes","","",481,N],[13,"ReadBytesAsPointer","","",481,N],[13,"ReadForeignStatic","","",481,N],[13,"InvalidPointerMath","","",481,N],[13,"ReadUndefBytes","","",481,N],[13,"DeadLocal","","",481,N],[13,"InvalidBoolOp","","",481,N],[13,"Unimplemented","","",481,N],[13,"DerefFunctionPointer","","",481,N],[13,"ExecuteMemory","","",481,N],[13,"BoundsCheck","","",481,N],[12,"len","rustc::mir::interpret::error::EvalErrorKind","",481,N],[12,"index","","",481,N],[13,"Overflow","rustc::mir::interpret::error","",481,N],[13,"OverflowNeg","","",481,N],[13,"DivisionByZero","","",481,N],[13,"RemainderByZero","","",481,N],[13,"Intrinsic","","",481,N],[13,"InvalidChar","","",481,N],[13,"StackFrameLimitReached","","",481,N],[13,"OutOfTls","","",481,N],[13,"TlsOutOfBounds","","",481,N],[13,"AbiViolation","","",481,N],[13,"AlignmentCheckFailed","","",481,N],[12,"required","rustc::mir::interpret::error::EvalErrorKind","",481,N],[12,"has","","",481,N],[13,"MemoryLockViolation","rustc::mir::interpret::error","",481,N],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",481,N],[12,"len","","",481,N],[12,"frame","","",481,N],[12,"access","","",481,N],[12,"lock","","",481,N],[13,"MemoryAcquireConflict","rustc::mir::interpret::error","",481,N],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",481,N],[12,"len","","",481,N],[12,"kind","","",481,N],[12,"lock","","",481,N],[13,"InvalidMemoryLockRelease","rustc::mir::interpret::error","",481,N],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",481,N],[12,"len","","",481,N],[12,"frame","","",481,N],[12,"lock","","",481,N],[13,"DeallocatedLockedMemory","rustc::mir::interpret::error","",481,N],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",481,N],[12,"lock","","",481,N],[13,"ValidationFailure","rustc::mir::interpret::error","",481,N],[13,"CalledClosureAsFunction","","",481,N],[13,"VtableForArgumentlessMethod","","",481,N],[13,"ModifiedConstantMemory","","",481,N],[13,"AssumptionNotHeld","","",481,N],[13,"InlineAsm","","",481,N],[13,"TypeNotPrimitive","","",481,N],[13,"ReallocatedWrongMemoryKind","","",481,N],[13,"DeallocatedWrongMemoryKind","","",481,N],[13,"ReallocateNonBasePtr","","",481,N],[13,"DeallocateNonBasePtr","","",481,N],[13,"IncorrectAllocationInformation","","",481,N],[13,"Layout","","",481,N],[13,"HeapAllocZeroBytes","","",481,N],[13,"HeapAllocNonPowerOfTwoAlignment","","",481,N],[13,"Unreachable","","",481,N],[13,"Panic","","",481,N],[12,"msg","rustc::mir::interpret::error::EvalErrorKind","",481,N],[12,"line","","",481,N],[12,"col","","",481,N],[12,"file","","",481,N],[13,"ReadFromReturnPointer","rustc::mir::interpret::error","",481,N],[13,"PathNotFound","","",481,N],[13,"UnimplementedTraitSelection","","",481,N],[13,"TypeckError","","Abort in case type errors are reached",481,N],[13,"TooGeneric","","Resolution can fail if we are in a too generic context",481,N],[13,"CheckMatchError","","",481,N],[13,"ReferencedConstant","","Cannot compute this constant because it depends on another one which already produced an error",481,N],[13,"GeneratorResumedAfterReturn","","",481,N],[13,"GeneratorResumedAfterPanic","","",481,N],[13,"InfiniteLoop","","",481,N],[5,"struct_error","","",N,[[["tyctxtat"],["str"]],["diagnosticbuilder"]]],[6,"ConstEvalResult","","",N,N],[6,"AssertMessage","","",N,N],[6,"EvalResult","","",N,N],[11,"clone","rustc::mir::interpret","",469,[[["self"]],["constevalerr"]]],[11,"fmt","","",469,[[["self"],["formatter"]],["result"]]],[11,"encode","","",469,[[["self"],["__s"]],["result"]]],[11,"decode","","",469,[[["__d"]],["result",["constevalerr"]]]],[11,"clone","","",470,[[["self"]],["frameinfo"]]],[11,"fmt","","",470,[[["self"],["formatter"]],["result"]]],[11,"encode","","",470,[[["self"],["__s"]],["result"]]],[11,"decode","","",470,[[["__d"]],["result",["frameinfo"]]]],[11,"struct_error","","",469,[[["self"],["tyctxtat"],["str"]],["option",["diagnosticbuilder"]]]],[11,"report_as_error","","",469,[[["self"],["tyctxtat"],["str"]]]],[11,"report_as_lint","","",469,[[["self"],["tyctxtat"],["str"],["nodeid"]]]],[11,"struct_generic","","",469,[[["self"],["tyctxtat"],["str"],["option",["nodeid"]]],["option",["diagnosticbuilder"]]]],[11,"fmt","","",468,[[["self"],["formatter"]],["result"]]],[11,"clone","","",468,[[["self"]],["evalerror"]]],[11,"encode","","",468,[[["self"],["__s"]],["result"]]],[11,"decode","","",468,[[["__d"]],["result",["evalerror"]]]],[11,"from","","",468,[[["evalerrorkind",["u64"]]],["self"]]],[11,"clone","","",481,[[["self"]],["evalerrorkind"]]],[11,"encode","","",481,[[["self"],["__so"]],["result"]]],[11,"decode","","",481,[[["__do"]],["result",["evalerrorkind"]]]],[11,"description","","",481,[[["self"]],["str"]]],[11,"fmt","","",468,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",481,[[["self"],["formatter"]],["result"]]],[0,"value","","",N,N],[4,"ConstValue","rustc::mir::interpret::value","Represents a constant value in Rust. Scalar and ScalarPair are optimizations which matches the LocalValue optimizations for easy conversions between Value and ConstValue.",N,N],[13,"Unevaluated","","Never returned from the `const_eval` query, but the HIR contains these frequently in order to allow HIR creation to happen for everything before needing to be able to run constant evaluation",483,N],[13,"Scalar","","Used only for types with layout::abi::Scalar ABI and ZSTs",483,N],[13,"ScalarPair","","Used only for types with layout::abi::ScalarPair",483,N],[13,"ByRef","","Used only for the remaining cases. An allocation + offset into the allocation. Invariant: The AllocId matches the allocation.",483,N],[4,"Scalar","","A `Scalar` represents an immediate, primitive value existing outside of a `memory::Allocation`. It is in many ways like a small chunk of a `Allocation`, up to 8 bytes in size. Like a range of bytes in an `Allocation`, a `Scalar` can either represent the raw bytes of a simple value or a pointer into another `Allocation`",N,N],[13,"Bits","","The raw bytes of a simple value.",482,N],[12,"size","rustc::mir::interpret::value::Scalar","The first `size` bytes are the value. Do not try to read less or more bytes that that. The remaining bytes must be 0.",482,N],[12,"bits","","",482,N],[13,"Ptr","rustc::mir::interpret::value","A pointer into an `Allocation`. An `Allocation` in the `memory` module has a list of relocations, but a `Scalar` is only large enough to contain one, so we just represent the relocation and its associated offset together as a `Pointer` here.",482,N],[4,"ScalarMaybeUndef","","",N,N],[13,"Scalar","","",484,N],[13,"Undef","","",484,N],[11,"clone","rustc::mir::interpret","",483,[[["self"]],["constvalue"]]],[11,"fmt","","",483,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",483,N],[11,"eq","","",483,[[["self"],["constvalue"]],["bool"]]],[11,"ne","","",483,[[["self"],["constvalue"]],["bool"]]],[11,"partial_cmp","","",483,[[["self"],["constvalue"]],["option",["ordering"]]]],[11,"lt","","",483,[[["self"],["constvalue"]],["bool"]]],[11,"le","","",483,[[["self"],["constvalue"]],["bool"]]],[11,"gt","","",483,[[["self"],["constvalue"]],["bool"]]],[11,"ge","","",483,[[["self"],["constvalue"]],["bool"]]],[11,"cmp","","",483,[[["self"],["constvalue"]],["ordering"]]],[11,"encode","","",483,[[["self"],["__s"]],["result"]]],[11,"decode","","",483,[[["__d"]],["result",["constvalue"]]]],[11,"hash","","",483,N],[11,"try_to_scalar","","",483,[[["self"]],["option",["scalar"]]]],[11,"try_to_bits","","",483,[[["self"],["size"]],["option",["u128"]]]],[11,"try_to_ptr","","",483,[[["self"]],["option",["pointer"]]]],[11,"new_slice","","",483,N],[11,"new_dyn_trait","","",483,[[["scalar"],["pointer"]],["self"]]],[11,"ptr_null","","",482,N],[11,"zst","","",482,[[],["self"]]],[11,"ptr_signed_offset","","",482,N],[11,"ptr_offset","","",482,N],[11,"ptr_wrapping_signed_offset","","",482,N],[11,"is_null_ptr","","",482,N],[11,"is_null","","",482,[[["self"]],["bool"]]],[11,"from_bool","","",482,[[["bool"]],["self"]]],[11,"from_char","","",482,[[["char"]],["self"]]],[11,"from_uint","","",482,N],[11,"from_int","","",482,N],[11,"from_f32","","",482,[[["f32"]],["self"]]],[11,"from_f64","","",482,[[["f64"]],["self"]]],[11,"to_bits","","",482,[[["self"],["size"]],["evalresult",["u128"]]]],[11,"to_ptr","","",482,[[["self"]],["evalresult",["pointer"]]]],[11,"is_bits","","",482,[[["self"]],["bool"]]],[11,"is_ptr","","",482,[[["self"]],["bool"]]],[11,"to_bool","","",482,[[["self"]],["evalresult",["bool"]]]],[11,"to_char","","",482,[[["self"]],["evalresult",["char"]]]],[11,"to_u8","","",482,[[["self"]],["evalresult",["u8"]]]],[11,"to_u32","","",482,[[["self"]],["evalresult",["u32"]]]],[11,"to_u64","","",482,[[["self"]],["evalresult",["u64"]]]],[11,"to_usize","","",482,N],[11,"to_i8","","",482,[[["self"]],["evalresult",["i8"]]]],[11,"to_i32","","",482,[[["self"]],["evalresult",["i32"]]]],[11,"to_i64","","",482,[[["self"]],["evalresult",["i64"]]]],[11,"to_isize","","",482,N],[11,"to_f32","","",482,[[["self"]],["evalresult",["f32"]]]],[11,"to_f64","","",482,[[["self"]],["evalresult",["f64"]]]],[11,"from","","",482,[[["pointer"]],["self"]]],[11,"clone","","",482,[[["self"]],["scalar"]]],[11,"fmt","","",482,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",482,N],[11,"eq","","",482,[[["self"],["scalar"]],["bool"]]],[11,"ne","","",482,[[["self"],["scalar"]],["bool"]]],[11,"cmp","","",482,[[["self"],["scalar"]],["ordering"]]],[11,"partial_cmp","","",482,[[["self"],["scalar"]],["option",["ordering"]]]],[11,"lt","","",482,[[["self"],["scalar"]],["bool"]]],[11,"le","","",482,[[["self"],["scalar"]],["bool"]]],[11,"gt","","",482,[[["self"],["scalar"]],["bool"]]],[11,"ge","","",482,[[["self"],["scalar"]],["bool"]]],[11,"encode","","",482,[[["self"],["__sid"]],["result"]]],[11,"decode","","",482,[[["__did"]],["result",["scalar"]]]],[11,"hash","","",482,N],[11,"clone","","",484,[[["self"]],["scalarmaybeundef"]]],[11,"fmt","","",484,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",484,N],[11,"eq","","",484,[[["self"],["scalarmaybeundef"]],["bool"]]],[11,"ne","","",484,[[["self"],["scalarmaybeundef"]],["bool"]]],[11,"cmp","","",484,[[["self"],["scalarmaybeundef"]],["ordering"]]],[11,"partial_cmp","","",484,[[["self"],["scalarmaybeundef"]],["option",["ordering"]]]],[11,"lt","","",484,[[["self"],["scalarmaybeundef"]],["bool"]]],[11,"le","","",484,[[["self"],["scalarmaybeundef"]],["bool"]]],[11,"gt","","",484,[[["self"],["scalarmaybeundef"]],["bool"]]],[11,"ge","","",484,[[["self"],["scalarmaybeundef"]],["bool"]]],[11,"encode","","",484,[[["self"],["__sid"]],["result"]]],[11,"decode","","",484,[[["__did"]],["result",["scalarmaybeundef"]]]],[11,"hash","","",484,N],[11,"from","","",484,[[["scalar"]],["self"]]],[11,"not_undef","","",484,[[["self"]],["evalresult",["scalar"]]]],[11,"to_ptr","","",484,[[["self"]],["evalresult",["pointer"]]]],[11,"to_bits","","",484,[[["self"],["size"]],["evalresult",["u128"]]]],[11,"to_bool","","",484,[[["self"]],["evalresult",["bool"]]]],[11,"to_char","","",484,[[["self"]],["evalresult",["char"]]]],[11,"to_f32","","",484,[[["self"]],["evalresult",["f32"]]]],[11,"to_f64","","",484,[[["self"]],["evalresult",["f64"]]]],[11,"to_u8","","",484,[[["self"]],["evalresult",["u8"]]]],[11,"to_u32","","",484,[[["self"]],["evalresult",["u32"]]]],[11,"to_u64","","",484,[[["self"]],["evalresult",["u64"]]]],[11,"to_usize","","",484,N],[11,"to_i8","","",484,[[["self"]],["evalresult",["i8"]]]],[11,"to_i32","","",484,[[["self"]],["evalresult",["i32"]]]],[11,"to_i64","","",484,[[["self"]],["evalresult",["i64"]]]],[11,"to_isize","","",484,N],[6,"EvalResult","","",N,N],[6,"AssertMessage","","",N,N],[6,"ConstEvalResult","","",N,N],[6,"DecodingSessionId","","",N,N],[6,"Block","","",N,N],[17,"BLOCK_SIZE","","",N,N],[8,"PointerArithmetic","","",N,N],[11,"pointer_size","","",490,[[["self"]],["size"]]],[11,"truncate_to_ptr","","",490,N],[11,"overflowing_signed_offset","","",490,N],[11,"overflowing_offset","","",490,N],[11,"signed_offset","","",490,[[["self"],["u64"],["i64"]],["evalresult",["u64"]]]],[11,"offset","","",490,[[["self"],["u64"],["u64"]],["evalresult",["u64"]]]],[11,"wrapping_signed_offset","","",490,[[["self"],["u64"],["i64"]],["u64"]]],[11,"clone","","",485,[[["self"]],["lock"]]],[11,"fmt","","",485,[[["self"],["formatter"]],["result"]]],[11,"eq","","",485,[[["self"],["lock"]],["bool"]]],[11,"ne","","",485,[[["self"],["lock"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",485,N],[11,"hash","","",485,N],[11,"encode","","",485,[[["self"],["__s"]],["result"]]],[11,"decode","","",485,[[["__d"]],["result",["lock"]]]],[11,"clone","","",471,[[["self"]],["dynamiclifetime"]]],[11,"fmt","","",471,[[["self"],["formatter"]],["result"]]],[11,"eq","","",471,[[["self"],["dynamiclifetime"]],["bool"]]],[11,"ne","","",471,[[["self"],["dynamiclifetime"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",471,N],[11,"hash","","",471,N],[11,"encode","","",471,[[["self"],["__s"]],["result"]]],[11,"decode","","",471,[[["__d"]],["result",["dynamiclifetime"]]]],[11,"clone","","",486,[[["self"]],["accesskind"]]],[11,"fmt","","",486,[[["self"],["formatter"]],["result"]]],[11,"eq","","",486,[[["self"],["accesskind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",486,N],[11,"encode","","",486,[[["self"],["__s"]],["result"]]],[11,"decode","","",486,[[["__d"]],["result",["accesskind"]]]],[11,"clone","","",472,[[["self"]],["globalid"]]],[11,"fmt","","",472,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",472,N],[11,"eq","","",472,[[["self"],["globalid"]],["bool"]]],[11,"ne","","",472,[[["self"],["globalid"]],["bool"]]],[11,"hash","","",472,N],[11,"encode","","",472,[[["self"],["__s"]],["result"]]],[11,"decode","","",472,[[["__d"]],["result",["globalid"]]]],[11,"clone","","",473,[[["self"]],["pointer"]]],[11,"fmt","","",473,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",473,N],[11,"eq","","",473,[[["self"],["pointer"]],["bool"]]],[11,"ne","","",473,[[["self"],["pointer"]],["bool"]]],[11,"cmp","","",473,[[["self"],["pointer"]],["ordering"]]],[11,"partial_cmp","","",473,[[["self"],["pointer"]],["option",["ordering"]]]],[11,"lt","","",473,[[["self"],["pointer"]],["bool"]]],[11,"le","","",473,[[["self"],["pointer"]],["bool"]]],[11,"gt","","",473,[[["self"],["pointer"]],["bool"]]],[11,"ge","","",473,[[["self"],["pointer"]],["bool"]]],[11,"encode","","",473,[[["self"],["__sid"]],["result"]]],[11,"decode","","",473,[[["__did"]],["result",["pointer"]]]],[11,"hash","","",473,N],[11,"from","","",473,[[["allocid"]],["self"]]],[11,"new","","",473,[[["allocid"],["size"]],["self"]]],[11,"wrapping_signed_offset","","",473,[[["self"],["i64"],["c"]],["self"]]],[11,"overflowing_signed_offset","","",473,N],[11,"signed_offset","","",473,[[["self"],["i64"],["c"]],["evalresult"]]],[11,"overflowing_offset","","",473,N],[11,"offset","","",473,[[["self"],["size"],["c"]],["evalresult"]]],[11,"clone","","",474,[[["self"]],["allocid"]]],[11,"assert_receiver_is_total_eq","","",474,N],[11,"hash","","",474,N],[11,"cmp","","",474,[[["self"],["allocid"]],["ordering"]]],[11,"eq","","",474,[[["self"],["allocid"]],["bool"]]],[11,"ne","","",474,[[["self"],["allocid"]],["bool"]]],[11,"partial_cmp","","",474,[[["self"],["allocid"]],["option",["ordering"]]]],[11,"lt","","",474,[[["self"],["allocid"]],["bool"]]],[11,"le","","",474,[[["self"],["allocid"]],["bool"]]],[11,"gt","","",474,[[["self"],["allocid"]],["bool"]]],[11,"ge","","",474,[[["self"],["allocid"]],["bool"]]],[11,"fmt","","",474,[[["self"],["formatter"]],["result"]]],[11,"decode","","",487,[[["__d"]],["result",["allockind"]]]],[11,"encode","","",487,[[["self"],["__s"]],["result"]]],[11,"clone","","",488,[[["self"]],["state"]]],[11,"new_decoding_session","","",475,[[["self"]],["allocdecodingsession"]]],[11,"new","","",475,[[["vec",["u32"]]],["allocdecodingstate"]]],[11,"clone","","",476,[[["self"]],["allocdecodingsession"]]],[11,"decode_alloc_id","","",476,[[["self"],["d"]],["result",["allocid"]]]],[11,"fmt","","",474,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",489,[[["self"],["formatter"]],["result"]]],[11,"clone","","",489,[[["self"]],["alloctype"]]],[11,"assert_receiver_is_total_eq","","",489,N],[11,"eq","","",489,[[["self"],["alloctype"]],["bool"]]],[11,"ne","","",489,[[["self"],["alloctype"]],["bool"]]],[11,"hash","","",489,N],[11,"decode","","",489,[[["__dm"]],["result",["alloctype"]]]],[11,"encode","","",489,[[["self"],["__sm"]],["result"]]],[11,"new","","",477,[[],["self"]]],[11,"reserve","","obtains a new allocation ID that can be referenced but does not yet have an allocation backing it.",477,[[["self"]],["allocid"]]],[11,"intern","","",477,[[["self"],["alloctype"]],["allocid"]]],[11,"create_fn_alloc","","",477,[[["self"],["instance"]],["allocid"]]],[11,"get","","",477,[[["self"],["allocid"]],["option",["alloctype"]]]],[11,"unwrap_memory","","",477,[[["self"],["allocid"]],["m"]]],[11,"intern_static","","",477,[[["self"],["defid"]],["allocid"]]],[11,"allocate","","",477,[[["self"],["m"]],["allocid"]]],[11,"set_id_memory","","",477,[[["self"],["allocid"],["m"]]]],[11,"set_id_same_memory","","",477,[[["self"],["allocid"],["m"]]]],[11,"clone","","",478,[[["self"]],["allocation"]]],[11,"fmt","","",478,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",478,N],[11,"eq","","",478,[[["self"],["allocation"]],["bool"]]],[11,"ne","","",478,[[["self"],["allocation"]],["bool"]]],[11,"partial_cmp","","",478,[[["self"],["allocation"]],["option",["ordering"]]]],[11,"lt","","",478,[[["self"],["allocation"]],["bool"]]],[11,"le","","",478,[[["self"],["allocation"]],["bool"]]],[11,"gt","","",478,[[["self"],["allocation"]],["bool"]]],[11,"ge","","",478,[[["self"],["allocation"]],["bool"]]],[11,"cmp","","",478,[[["self"],["allocation"]],["ordering"]]],[11,"hash","","",478,N],[11,"encode","","",478,[[["self"],["__s"]],["result"]]],[11,"decode","","",478,[[["__d"]],["result",["allocation"]]]],[11,"from_bytes","","Creates a read-only allocation initialized by the given bytes",478,N],[11,"from_byte_aligned_bytes","","",478,N],[11,"undef","","",478,[[["size"],["align"]],["self"]]],[11,"clone","","",479,[[["self"]],["relocations"]]],[11,"eq","","",479,[[["self"],["relocations"]],["bool"]]],[11,"ne","","",479,[[["self"],["relocations"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",479,N],[11,"partial_cmp","","",479,[[["self"],["relocations"]],["option",["ordering"]]]],[11,"lt","","",479,[[["self"],["relocations"]],["bool"]]],[11,"le","","",479,[[["self"],["relocations"]],["bool"]]],[11,"gt","","",479,[[["self"],["relocations"]],["bool"]]],[11,"ge","","",479,[[["self"],["relocations"]],["bool"]]],[11,"cmp","","",479,[[["self"],["relocations"]],["ordering"]]],[11,"hash","","",479,N],[11,"fmt","","",479,[[["self"],["formatter"]],["result"]]],[11,"encode","","",479,[[["self"],["__sid"]],["result"]]],[11,"decode","","",479,[[["__did"]],["result",["relocations"]]]],[11,"new","","",479,[[],["self"]]],[11,"from_presorted","","",479,[[["vec"]],["self"]]],[11,"deref","","",479,N],[11,"deref_mut","","",479,N],[11,"clone","","",480,[[["self"]],["undefmask"]]],[11,"fmt","","",480,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",480,N],[11,"eq","","",480,[[["self"],["undefmask"]],["bool"]]],[11,"ne","","",480,[[["self"],["undefmask"]],["bool"]]],[11,"partial_cmp","","",480,[[["self"],["undefmask"]],["option",["ordering"]]]],[11,"lt","","",480,[[["self"],["undefmask"]],["bool"]]],[11,"le","","",480,[[["self"],["undefmask"]],["bool"]]],[11,"gt","","",480,[[["self"],["undefmask"]],["bool"]]],[11,"ge","","",480,[[["self"],["undefmask"]],["bool"]]],[11,"cmp","","",480,[[["self"],["undefmask"]],["ordering"]]],[11,"hash","","",480,N],[11,"encode","","",480,[[["self"],["__s"]],["result"]]],[11,"decode","","",480,[[["__d"]],["result",["undefmask"]]]],[11,"hash_stable","","",480,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",480,[[["size"]],["self"]]],[11,"is_range_defined","","Check whether the range `start..end` (end-exclusive) is entirely defined.",480,[[["self"],["size"],["size"]],["result",["size"]]]],[11,"set_range","","",480,[[["self"],["size"],["size"],["bool"]]]],[11,"set_range_inbounds","","",480,[[["self"],["size"],["size"],["bool"]]]],[11,"get","","",480,[[["self"],["size"]],["bool"]]],[11,"set","","",480,[[["self"],["size"],["bool"]]]],[11,"grow","","",480,[[["self"],["size"],["bool"]]]],[0,"mono","rustc::mir","",N,N],[3,"CodegenUnit","rustc::mir::mono","",N,N],[12,"name","","A name for this CGU. Incremental compilation requires that name be unique amongst all crates.  Therefore, it should contain something unique to this crate (e.g., a module path) as well as the crate name and disambiguator.",491,N],[12,"items","","",491,N],[12,"size_estimate","","",491,N],[3,"Stats","","",N,N],[12,"n_glues_created","","",492,N],[12,"n_null_glues","","",492,N],[12,"n_real_glues","","",492,N],[12,"n_fns","","",492,N],[12,"n_inlines","","",492,N],[12,"n_closures","","",492,N],[12,"n_llvm_insns","","",492,N],[12,"llvm_insns","","",492,N],[12,"fn_stats","","",492,N],[3,"CodegenUnitNameBuilder","","",N,N],[12,"tcx","","",493,N],[12,"cache","","",493,N],[4,"MonoItem","","",N,N],[13,"Fn","","",494,N],[13,"Static","","",494,N],[13,"GlobalAsm","","",494,N],[4,"Linkage","","",N,N],[13,"External","","",495,N],[13,"AvailableExternally","","",495,N],[13,"LinkOnceAny","","",495,N],[13,"LinkOnceODR","","",495,N],[13,"WeakAny","","",495,N],[13,"WeakODR","","",495,N],[13,"Appending","","",495,N],[13,"Internal","","",495,N],[13,"Private","","",495,N],[13,"ExternalWeak","","",495,N],[13,"Common","","",495,N],[4,"Visibility","","",N,N],[13,"Default","","",496,N],[13,"Hidden","","",496,N],[13,"Protected","","",496,N],[11,"eq","","",494,[[["self"],["monoitem"]],["bool"]]],[11,"ne","","",494,[[["self"],["monoitem"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",494,N],[11,"clone","","",494,[[["self"]],["monoitem"]]],[11,"fmt","","",494,[[["self"],["formatter"]],["result"]]],[11,"hash","","",494,N],[11,"size_estimate","","",494,[[["self"],["tyctxt"]],["usize"]]],[11,"hash_stable","","",494,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",495,[[["self"]],["linkage"]]],[11,"eq","","",495,[[["self"],["linkage"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",495,N],[11,"hash","","",495,N],[11,"fmt","","",495,[[["self"],["formatter"]],["result"]]],[11,"encode","","",495,[[["self"],["__s"]],["result"]]],[11,"decode","","",495,[[["__d"]],["result",["linkage"]]]],[11,"hash_stable","","",495,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",496,[[["self"]],["visibility"]]],[11,"eq","","",496,[[["self"],["visibility"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",496,N],[11,"hash","","",496,N],[11,"fmt","","",496,[[["self"],["formatter"]],["result"]]],[11,"hash_stable","","",496,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",491,[[["internedstring"]],["codegenunit"]]],[11,"name","","",491,[[["self"]],["internedstring"]]],[11,"set_name","","",491,[[["self"],["internedstring"]]]],[11,"items","","",491,[[["self"]],["fxhashmap"]]],[11,"items_mut","","",491,[[["self"]],["fxhashmap"]]],[11,"mangle_name","","",491,[[["str"]],["string"]]],[11,"estimate_size","","",491,[[["self"],["tyctxt"]]]],[11,"size_estimate","","",491,[[["self"]],["usize"]]],[11,"modify_size_estimate","","",491,[[["self"],["usize"]]]],[11,"hash_stable","","",491,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",492,[[["self"]],["stats"]]],[11,"default","","",492,[[],["stats"]]],[11,"hash_stable","","",492,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"extend","","",492,[[["self"],["stats"]]]],[11,"new","","",493,[[["tyctxt"]],["self"]]],[11,"build_cgu_name","","CGU names should fulfill the following requirements: - They should be able to act as a file name on any kind of file system - They should not collide with other CGU names, even for different versions   of the same crate.",493,[[["self"],["cratenum"],["i"],["option"]],["internedstring"]]],[11,"build_cgu_name_no_mangle","","Same as `CodegenUnit::build_cgu_name()` but will never mangle the resulting name.",493,[[["self"],["cratenum"],["i"],["option"]],["internedstring"]]],[0,"tcx","rustc::mir","Methods for the various MIR types. These are intended for use after building is complete.",N,N],[4,"PlaceTy","rustc::mir::tcx","",N,N],[13,"Ty","","Normal type.",497,N],[12,"ty","rustc::mir::tcx::PlaceTy","",497,N],[13,"Downcast","rustc::mir::tcx","Downcast to a particular variant of an enum.",497,N],[12,"adt_def","rustc::mir::tcx::PlaceTy","",497,N],[12,"substs","","",497,N],[12,"variant_index","","",497,N],[4,"RvalueInitializationState","rustc::mir::tcx","",N,N],[13,"Shallow","","",498,N],[13,"Deep","","",498,N],[11,"clone","","",497,[[["self"]],["placety"]]],[11,"fmt","","",497,[[["self"],["formatter"]],["result"]]],[11,"from_ty","","",497,[[["ty"]],["placety"]]],[11,"to_ty","","",497,[[["self"],["tyctxt"]],["ty"]]],[11,"projection_ty","","",497,[[["self"],["tyctxt"],["placeelem"]],["placety"]]],[11,"super_fold_with","","",497,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",497,[[["self"],["v"]],["bool"]]],[11,"ty","rustc::mir","",456,[[["self"],["d"],["tyctxt"]],["placety"]]],[11,"is_upvar_field_projection","","If this is a field projection, and the field is being projected from a closure type, then returns the index of the field being projected. Note that this closure will always be `self` in the current MIR, because that is the only time we directly access the fields of a closure type.",456,[[["self"],["mir"],["tyctxt"]],["option",["field"]]]],[11,"ty","","",459,[[["self"],["d"],["tyctxt"]],["ty"]]],[11,"initialization_state","","Returns whether this rvalue is deeply initialized (most rvalues) or whether its only shallowly initialized (`Rvalue::Box`).",459,[[["self"]],["rvalueinitializationstate"]]],[11,"ty","","",458,[[["self"],["d"],["tyctxt"]],["ty"]]],[11,"ty","","",462,[[["self"],["tyctxt"],["ty"],["ty"]],["ty"]]],[11,"to_mutbl_lossy","","",450,[[["self"]],["mutability"]]],[11,"to_hir_binop","","",462,[[["self"]],["binopkind"]]],[0,"traversal","","",N,N],[3,"Preorder","rustc::mir::traversal","Preorder traversal of a graph.",N,N],[12,"mir","","",499,N],[12,"visited","","",499,N],[12,"worklist","","",499,N],[3,"Postorder","","Postorder traversal of a graph.",N,N],[12,"mir","","",500,N],[12,"visited","","",500,N],[12,"visit_stack","","",500,N],[3,"ReversePostorder","","Reverse postorder traversal of a graph",N,N],[12,"mir","","",501,N],[12,"blocks","","",501,N],[12,"idx","","",501,N],[5,"preorder","","",N,[[["mir"]],["preorder"]]],[5,"postorder","","",N,[[["mir"]],["postorder"]]],[5,"reverse_postorder","","",N,[[["mir"]],["reversepostorder"]]],[11,"clone","","",499,[[["self"]],["preorder"]]],[11,"new","","",499,[[["mir"],["basicblock"]],["preorder"]]],[11,"next","","",499,[[["self"]],["option"]]],[11,"size_hint","","",499,N],[11,"new","","",500,[[["mir"],["basicblock"]],["postorder"]]],[11,"traverse_successor","","",500,[[["self"]]]],[11,"next","","",500,[[["self"]],["option"]]],[11,"size_hint","","",500,N],[11,"clone","","",501,[[["self"]],["reversepostorder"]]],[11,"new","","",501,[[["mir"],["basicblock"]],["reversepostorder"]]],[11,"reset","","",501,[[["self"]]]],[11,"next","","",501,[[["self"]],["option"]]],[11,"size_hint","","",501,N],[0,"visit","rustc::mir","",N,N],[4,"TyContext","rustc::mir::visit","Extra information passed to `visit_ty` and friends to give context about where the type etc appears.",N,N],[13,"LocalDecl","","",502,N],[12,"local","rustc::mir::visit::TyContext","The index of the local variable we are visiting.",502,N],[12,"source_info","","The source location where this local variable was declared.",502,N],[13,"ReturnTy","rustc::mir::visit","The return type of the function.",502,N],[13,"YieldTy","","",502,N],[13,"Location","","A type found at some location.",502,N],[4,"PlaceContext","","",N,N],[13,"Store","","",503,N],[13,"AsmOutput","","",503,N],[13,"Call","","",503,N],[13,"Drop","","",503,N],[13,"Inspect","","",503,N],[13,"Borrow","","",503,N],[12,"region","rustc::mir::visit::PlaceContext","",503,N],[12,"kind","","",503,N],[13,"Projection","rustc::mir::visit","",503,N],[13,"Copy","","",503,N],[13,"Move","","",503,N],[13,"StorageLive","","",503,N],[13,"StorageDead","","",503,N],[13,"Validate","","",503,N],[8,"Visitor","","",N,N],[11,"visit_mir","","",504,[[["self"],["mir"]]]],[11,"visit_basic_block_data","","",504,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_source_scope_data","","",504,[[["self"],["sourcescopedata"]]]],[11,"visit_statement","","",504,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_assign","","",504,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_terminator","","",504,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_terminator_kind","","",504,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_assert_message","","",504,[[["self"],["assertmessage"],["location"]]]],[11,"visit_rvalue","","",504,[[["self"],["rvalue"],["location"]]]],[11,"visit_operand","","",504,[[["self"],["operand"],["location"]]]],[11,"visit_ascribe_user_ty","","",504,[[["self"],["place"],["variance"],["canonicalty"],["location"]]]],[11,"visit_place","","",504,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_static","","",504,[[["self"],["static"],["placecontext"],["location"]]]],[11,"visit_projection","","",504,[[["self"],["placeprojection"],["placecontext"],["location"]]]],[11,"visit_projection_elem","","",504,[[["self"],["placeelem"],["placecontext"],["location"]]]],[11,"visit_branch","","",504,[[["self"],["basicblock"],["basicblock"]]]],[11,"visit_constant","","",504,[[["self"],["constant"],["location"]]]],[11,"visit_def_id","","",504,[[["self"],["defid"],["location"]]]],[11,"visit_span","","",504,[[["self"],["span"]]]],[11,"visit_source_info","","",504,[[["self"],["sourceinfo"]]]],[11,"visit_ty","","",504,[[["self"],["ty"],["tycontext"]]]],[11,"visit_canonical_ty","","",504,[[["self"],["canonicalty"]]]],[11,"visit_region","","",504,[[["self"],["region"],["location"]]]],[11,"visit_const","","",504,[[["self"],["const"],["location"]]]],[11,"visit_substs","","",504,[[["self"],["substs"],["location"]]]],[11,"visit_closure_substs","","",504,[[["self"],["closuresubsts"],["location"]]]],[11,"visit_generator_substs","","",504,[[["self"],["generatorsubsts"],["location"]]]],[11,"visit_local_decl","","",504,[[["self"],["local"],["localdecl"]]]],[11,"visit_local","","",504,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_source_scope","","",504,[[["self"],["sourcescope"]]]],[11,"super_mir","","",504,[[["self"],["mir"]]]],[11,"super_basic_block_data","","",504,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"super_source_scope_data","","",504,[[["self"],["sourcescopedata"]]]],[11,"super_statement","","",504,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"super_assign","","",504,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"super_terminator","","",504,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"super_terminator_kind","","",504,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"super_assert_message","","",504,[[["self"],["assertmessage"],["location"]]]],[11,"super_rvalue","","",504,[[["self"],["rvalue"],["location"]]]],[11,"super_operand","","",504,[[["self"],["operand"],["location"]]]],[11,"super_ascribe_user_ty","","",504,[[["self"],["place"],["variance"],["canonicalty"],["location"]]]],[11,"super_place","","",504,[[["self"],["place"],["placecontext"],["location"]]]],[11,"super_static","","",504,[[["self"],["static"],["placecontext"],["location"]]]],[11,"super_projection","","",504,[[["self"],["placeprojection"],["placecontext"],["location"]]]],[11,"super_projection_elem","","",504,[[["self"],["placeelem"],["placecontext"],["location"]]]],[11,"super_local_decl","","",504,[[["self"],["local"],["localdecl"]]]],[11,"super_source_scope","","",504,[[["self"],["sourcescope"]]]],[11,"super_branch","","",504,[[["self"],["basicblock"],["basicblock"]]]],[11,"super_constant","","",504,[[["self"],["constant"],["location"]]]],[11,"super_def_id","","",504,[[["self"],["defid"]]]],[11,"super_span","","",504,[[["self"],["span"]]]],[11,"super_source_info","","",504,[[["self"],["sourceinfo"]]]],[11,"super_canonical_ty","","",504,[[["self"],["canonicalty"]]]],[11,"super_ty","","",504,[[["self"],["ty"]]]],[11,"super_region","","",504,[[["self"],["region"]]]],[11,"super_const","","",504,[[["self"],["const"]]]],[11,"super_substs","","",504,[[["self"],["substs"]]]],[11,"super_generator_substs","","",504,[[["self"],["generatorsubsts"]]]],[11,"super_closure_substs","","",504,[[["self"],["closuresubsts"]]]],[11,"visit_location","","",504,[[["self"],["mir"],["location"]]]],[8,"MutVisitor","","",N,N],[11,"visit_mir","","",505,[[["self"],["mir"]]]],[11,"visit_basic_block_data","","",505,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_source_scope_data","","",505,[[["self"],["sourcescopedata"]]]],[11,"visit_statement","","",505,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_assign","","",505,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_terminator","","",505,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_terminator_kind","","",505,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_assert_message","","",505,[[["self"],["assertmessage"],["location"]]]],[11,"visit_rvalue","","",505,[[["self"],["rvalue"],["location"]]]],[11,"visit_operand","","",505,[[["self"],["operand"],["location"]]]],[11,"visit_ascribe_user_ty","","",505,[[["self"],["place"],["variance"],["canonicalty"],["location"]]]],[11,"visit_place","","",505,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_static","","",505,[[["self"],["static"],["placecontext"],["location"]]]],[11,"visit_projection","","",505,[[["self"],["placeprojection"],["placecontext"],["location"]]]],[11,"visit_projection_elem","","",505,[[["self"],["placeelem"],["placecontext"],["location"]]]],[11,"visit_branch","","",505,[[["self"],["basicblock"],["basicblock"]]]],[11,"visit_constant","","",505,[[["self"],["constant"],["location"]]]],[11,"visit_def_id","","",505,[[["self"],["defid"],["location"]]]],[11,"visit_span","","",505,[[["self"],["span"]]]],[11,"visit_source_info","","",505,[[["self"],["sourceinfo"]]]],[11,"visit_ty","","",505,[[["self"],["ty"],["tycontext"]]]],[11,"visit_canonical_ty","","",505,[[["self"],["canonicalty"]]]],[11,"visit_region","","",505,[[["self"],["region"],["location"]]]],[11,"visit_const","","",505,[[["self"],["const"],["location"]]]],[11,"visit_substs","","",505,[[["self"],["substs"],["location"]]]],[11,"visit_closure_substs","","",505,[[["self"],["closuresubsts"],["location"]]]],[11,"visit_generator_substs","","",505,[[["self"],["generatorsubsts"],["location"]]]],[11,"visit_local_decl","","",505,[[["self"],["local"],["localdecl"]]]],[11,"visit_local","","",505,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_source_scope","","",505,[[["self"],["sourcescope"]]]],[11,"super_mir","","",505,[[["self"],["mir"]]]],[11,"super_basic_block_data","","",505,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"super_source_scope_data","","",505,[[["self"],["sourcescopedata"]]]],[11,"super_statement","","",505,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"super_assign","","",505,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"super_terminator","","",505,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"super_terminator_kind","","",505,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"super_assert_message","","",505,[[["self"],["assertmessage"],["location"]]]],[11,"super_rvalue","","",505,[[["self"],["rvalue"],["location"]]]],[11,"super_operand","","",505,[[["self"],["operand"],["location"]]]],[11,"super_ascribe_user_ty","","",505,[[["self"],["place"],["variance"],["canonicalty"],["location"]]]],[11,"super_place","","",505,[[["self"],["place"],["placecontext"],["location"]]]],[11,"super_static","","",505,[[["self"],["static"],["placecontext"],["location"]]]],[11,"super_projection","","",505,[[["self"],["placeprojection"],["placecontext"],["location"]]]],[11,"super_projection_elem","","",505,[[["self"],["placeelem"],["placecontext"],["location"]]]],[11,"super_local_decl","","",505,[[["self"],["local"],["localdecl"]]]],[11,"super_source_scope","","",505,[[["self"],["sourcescope"]]]],[11,"super_branch","","",505,[[["self"],["basicblock"],["basicblock"]]]],[11,"super_constant","","",505,[[["self"],["constant"],["location"]]]],[11,"super_def_id","","",505,[[["self"],["defid"]]]],[11,"super_span","","",505,[[["self"],["span"]]]],[11,"super_source_info","","",505,[[["self"],["sourceinfo"]]]],[11,"super_canonical_ty","","",505,[[["self"],["canonicalty"]]]],[11,"super_ty","","",505,[[["self"],["ty"]]]],[11,"super_region","","",505,[[["self"],["region"]]]],[11,"super_const","","",505,[[["self"],["const"]]]],[11,"super_substs","","",505,[[["self"],["substs"]]]],[11,"super_generator_substs","","",505,[[["self"],["generatorsubsts"]]]],[11,"super_closure_substs","","",505,[[["self"],["closuresubsts"]]]],[11,"visit_location","","",505,[[["self"],["mir"],["location"]]]],[8,"MirVisitable","","",N,N],[10,"apply","","",506,[[["self"],["location"],["visitor"]]]],[11,"apply","rustc::mir","",430,[[["self"],["location"],["visitor"]]]],[11,"apply","","",429,[[["self"],["location"],["visitor"]]]],[11,"clone","rustc::mir::visit","",502,[[["self"]],["tycontext"]]],[11,"fmt","","",502,[[["self"],["formatter"]],["result"]]],[11,"eq","","",502,[[["self"],["tycontext"]],["bool"]]],[11,"ne","","",502,[[["self"],["tycontext"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",502,N],[11,"hash","","",502,N],[11,"clone","","",503,[[["self"]],["placecontext"]]],[11,"fmt","","",503,[[["self"],["formatter"]],["result"]]],[11,"eq","","",503,[[["self"],["placecontext"]],["bool"]]],[11,"ne","","",503,[[["self"],["placecontext"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",503,N],[11,"is_drop","","Returns true if this place context represents a drop.",503,[[["self"]],["bool"]]],[11,"is_storage_marker","","Returns true if this place context represents a storage live or storage dead marker.",503,[[["self"]],["bool"]]],[11,"is_storage_live_marker","","Returns true if this place context represents a storage live marker.",503,[[["self"]],["bool"]]],[11,"is_storage_dead_marker","","Returns true if this place context represents a storage dead marker.",503,[[["self"]],["bool"]]],[11,"is_mutating_use","","Returns true if this place context represents a use that potentially changes the value.",503,[[["self"]],["bool"]]],[11,"is_nonmutating_use","","Returns true if this place context represents a use that does not change the value.",503,[[["self"]],["bool"]]],[11,"is_use","","",503,[[["self"]],["bool"]]],[0,"binding_form_impl","rustc::mir","",N,N],[11,"hash_stable","","",452,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[6,"AssertMessage","","",N,N],[6,"LocalDecls","","Types for locals",N,N],[6,"Successors","","",N,N],[6,"SuccessorsMut","","",N,N],[6,"PlaceProjection","","Alias for projections as they appear in places, where the base is a place and the index is a local.",N,N],[6,"PlaceElem","","Alias for projections as they appear in places, where the base is a place and the index is a local.",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"RETURN_PLACE","","",N,N],[17,"START_BLOCK","","",N,N],[17,"OUTERMOST_SOURCE_SCOPE","","",N,N],[8,"HasLocalDecls","","",N,N],[10,"local_decls","","",507,[[["self"]],["indexvec"]]],[11,"local_decls","","",421,[[["self"]],["indexvec"]]],[11,"clone","","",421,[[["self"]],["mir"]]],[11,"encode","","",421,[[["self"],["__s"]],["result"]]],[11,"decode","","",421,[[["__d"]],["result",["mir"]]]],[11,"fmt","","",421,[[["self"],["formatter"]],["result"]]],[11,"new","","",421,[[["indexvec",["basicblock","basicblockdata"]],["indexvec",["sourcescope","sourcescopedata"]],["clearcrosscrate",["indexvec"]],["indexvec",["promoted","mir"]],["option",["ty"]],["indexvec",["local","localdecl"]],["usize"],["vec",["upvardecl"]],["span"]],["self"]]],[11,"basic_blocks","","",421,[[["self"]],["indexvec"]]],[11,"basic_blocks_mut","","",421,[[["self"]],["indexvec"]]],[11,"basic_blocks_and_local_decls_mut","","",421,N],[11,"predecessors","","",421,[[["self"]],["mappedreadguard",["indexvec"]]]],[11,"predecessors_for","","",421,[[["self"],["basicblock"]],["mappedreadguard",["vec"]]]],[11,"predecessor_locations","","",421,N],[11,"dominators","","",421,[[["self"]],["dominators",["basicblock"]]]],[11,"local_kind","","",421,[[["self"],["local"]],["localkind"]]],[11,"temps_iter","","Returns an iterator over all temporaries.",421,N],[11,"vars_iter","","Returns an iterator over all user-declared locals.",421,N],[11,"mut_vars_and_args_iter","","Returns an iterator over all user-declared mutable arguments and locals.",421,N],[11,"args_iter","","Returns an iterator over all function arguments.",421,N],[11,"vars_and_temps_iter","","Returns an iterator over all user-defined variables and compiler-generated temporaries (all locals that are neither arguments nor the return place).",421,N],[11,"make_statement_nop","","Changes a statement to a nop. This is both faster than deleting instructions and avoids invalidating statement indices in `Location`s.",421,[[["self"],["location"]]]],[11,"source_info","","Returns the source info associated with `location`.",421,[[["self"],["location"]],["sourceinfo"]]],[11,"is_sub_scope","","Check if `sub` is a sub scope of `sup`",421,[[["self"],["sourcescope"],["sourcescope"]],["bool"]]],[11,"return_ty","","Return the return type, it always return first element from `local_decls` array",421,[[["self"]],["ty"]]],[11,"terminator_loc","","Get the location of the terminator for the given block",421,[[["self"],["basicblock"]],["location"]]],[11,"clone","","",447,[[["self"]],["safety"]]],[11,"fmt","","",447,[[["self"],["formatter"]],["result"]]],[11,"encode","","",447,[[["self"],["__s"]],["result"]]],[11,"decode","","",447,[[["__d"]],["result",["safety"]]]],[11,"hash_stable","","",421,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"index","","",421,[[["self"],["basicblock"]],["basicblockdata"]]],[11,"index_mut","","",421,[[["self"],["basicblock"]],["basicblockdata"]]],[11,"clone","","",448,[[["self"]],["clearcrosscrate"]]],[11,"fmt","","",448,[[["self"],["formatter"]],["result"]]],[11,"assert_crate_local","","",448,[[["self"]],["t"]]],[11,"clone","","",422,[[["self"]],["sourceinfo"]]],[11,"fmt","","",422,[[["self"],["formatter"]],["result"]]],[11,"eq","","",422,[[["self"],["sourceinfo"]],["bool"]]],[11,"ne","","",422,[[["self"],["sourceinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",422,N],[11,"encode","","",422,[[["self"],["__s"]],["result"]]],[11,"decode","","",422,[[["__d"]],["result",["sourceinfo"]]]],[11,"hash","","",422,N],[11,"clone","","",449,[[["self"]],["mutability"]]],[11,"fmt","","",449,[[["self"],["formatter"]],["result"]]],[11,"eq","","",449,[[["self"],["mutability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",449,N],[11,"encode","","",449,[[["self"],["__s"]],["result"]]],[11,"decode","","",449,[[["__d"]],["result",["mutability"]]]],[11,"from","rustc::hir","",103,[[["mutability"]],["self"]]],[11,"clone","rustc::mir","",450,[[["self"]],["borrowkind"]]],[11,"fmt","","",450,[[["self"],["formatter"]],["result"]]],[11,"eq","","",450,[[["self"],["borrowkind"]],["bool"]]],[11,"ne","","",450,[[["self"],["borrowkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",450,N],[11,"encode","","",450,[[["self"],["__s"]],["result"]]],[11,"decode","","",450,[[["__d"]],["result",["borrowkind"]]]],[11,"allows_two_phase_borrow","","",450,[[["self"]],["bool"]]],[11,"clone","","",423,[[["self"]],["local"]]],[11,"eq","","",423,[[["self"],["local"]],["bool"]]],[11,"ne","","",423,[[["self"],["local"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",423,N],[11,"hash","","",423,N],[11,"partial_cmp","","",423,[[["self"],["local"]],["option",["ordering"]]]],[11,"lt","","",423,[[["self"],["local"]],["bool"]]],[11,"le","","",423,[[["self"],["local"]],["bool"]]],[11,"gt","","",423,[[["self"],["local"]],["bool"]]],[11,"ge","","",423,[[["self"],["local"]],["bool"]]],[11,"cmp","","",423,[[["self"],["local"]],["ordering"]]],[11,"decode","","",423,[[["__d"]],["result",["local"]]]],[11,"encode","","",423,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",423,N],[18,"MAX","","",423,N],[11,"from_usize","","",423,[[["usize"]],["self"]]],[11,"from_u32","","",423,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",423,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",423,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",423,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",423,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",423,[[["self"]],["usize"]]],[11,"new","","",423,[[["usize"]],["self"]]],[11,"index","","",423,[[["self"]],["usize"]]],[11,"steps_between","","",423,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",423,[[["self"]],["self"]]],[11,"replace_zero","","",423,[[["self"]],["self"]]],[11,"add_one","","",423,[[["self"]],["self"]]],[11,"sub_one","","",423,[[["self"]],["self"]]],[11,"add_usize","","",423,[[["self"],["usize"]],["option"]]],[11,"from","","",423,[[["usize"]],["self"]]],[11,"from","","",423,[[["u32"]],["self"]]],[11,"fmt","","",423,[[["self"],["formatter"]],["result"]]],[11,"eq","","",451,[[["self"],["localkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",451,N],[11,"fmt","","",451,[[["self"],["formatter"]],["result"]]],[11,"clone","","",424,[[["self"]],["varbindingform"]]],[11,"eq","","",424,[[["self"],["varbindingform"]],["bool"]]],[11,"ne","","",424,[[["self"],["varbindingform"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",424,N],[11,"hash","","",424,N],[11,"fmt","","",424,[[["self"],["formatter"]],["result"]]],[11,"encode","","",424,[[["self"],["__s"]],["result"]]],[11,"decode","","",424,[[["__d"]],["result",["varbindingform"]]]],[11,"clone","","",452,[[["self"]],["bindingform"]]],[11,"eq","","",452,[[["self"],["bindingform"]],["bool"]]],[11,"ne","","",452,[[["self"],["bindingform"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",452,N],[11,"hash","","",452,N],[11,"fmt","","",452,[[["self"],["formatter"]],["result"]]],[11,"encode","","",452,[[["self"],["__s"]],["result"]]],[11,"decode","","",452,[[["__d"]],["result",["bindingform"]]]],[11,"super_fold_with","","",452,[[["self"],["f"]],["bindingform"]]],[11,"super_visit_with","","",452,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",452,[[["self"],["tyctxt"]],["option"]]],[11,"hash_stable","","",424,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",425,[[["self"]],["localdecl"]]],[11,"fmt","","",425,[[["self"],["formatter"]],["result"]]],[11,"encode","","",425,[[["self"],["__s"]],["result"]]],[11,"decode","","",425,[[["__d"]],["result",["localdecl"]]]],[11,"can_be_made_mutable","","Returns true only if local is a binding that can itself be made mutable via the addition of the `mut` keyword, namely something like the occurrences of `x` in: - `fn foo(x: Type) { ... }`, - `let x = ...`, - or `match ... { C(x) => ... }`",425,[[["self"]],["bool"]]],[11,"is_nonref_binding","","Returns true if local is definitely not a `ref ident` or `ref mut ident` binding. (Such bindings cannot be made into mutable bindings, but the inverse does not necessarily hold).",425,[[["self"]],["bool"]]],[11,"new_temp","","Create a new `LocalDecl` for a temporary.",425,[[["ty"],["span"]],["self"]]],[11,"new_immutable_temp","","Create a new immutable `LocalDecl` for a temporary.",425,[[["ty"],["span"]],["self"]]],[11,"new_internal","","Create a new `LocalDecl` for a internal temporary.",425,[[["ty"],["span"]],["self"]]],[11,"new_local","","",425,[[["ty"],["mutability"],["bool"],["span"]],["self"]]],[11,"new_return_place","","Builds a `LocalDecl` for the return place.",425,[[["ty"],["span"]],["localdecl"]]],[11,"clone","","",426,[[["self"]],["upvardecl"]]],[11,"fmt","","",426,[[["self"],["formatter"]],["result"]]],[11,"encode","","",426,[[["self"],["__s"]],["result"]]],[11,"decode","","",426,[[["__d"]],["result",["upvardecl"]]]],[11,"clone","","",427,[[["self"]],["basicblock"]]],[11,"eq","","",427,[[["self"],["basicblock"]],["bool"]]],[11,"ne","","",427,[[["self"],["basicblock"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",427,N],[11,"hash","","",427,N],[11,"partial_cmp","","",427,[[["self"],["basicblock"]],["option",["ordering"]]]],[11,"lt","","",427,[[["self"],["basicblock"]],["bool"]]],[11,"le","","",427,[[["self"],["basicblock"]],["bool"]]],[11,"gt","","",427,[[["self"],["basicblock"]],["bool"]]],[11,"ge","","",427,[[["self"],["basicblock"]],["bool"]]],[11,"cmp","","",427,[[["self"],["basicblock"]],["ordering"]]],[11,"decode","","",427,[[["__d"]],["result",["basicblock"]]]],[11,"encode","","",427,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",427,N],[18,"MAX","","",427,N],[11,"from_usize","","",427,[[["usize"]],["self"]]],[11,"from_u32","","",427,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",427,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",427,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",427,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",427,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",427,[[["self"]],["usize"]]],[11,"new","","",427,[[["usize"]],["self"]]],[11,"index","","",427,[[["self"]],["usize"]]],[11,"steps_between","","",427,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",427,[[["self"]],["self"]]],[11,"replace_zero","","",427,[[["self"]],["self"]]],[11,"add_one","","",427,[[["self"]],["self"]]],[11,"sub_one","","",427,[[["self"]],["self"]]],[11,"add_usize","","",427,[[["self"],["usize"]],["option"]]],[11,"from","","",427,[[["usize"]],["self"]]],[11,"from","","",427,[[["u32"]],["self"]]],[11,"fmt","","",427,[[["self"],["formatter"]],["result"]]],[11,"start_location","","",427,[[["self"]],["location"]]],[11,"clone","","",428,[[["self"]],["basicblockdata"]]],[11,"fmt","","",428,[[["self"],["formatter"]],["result"]]],[11,"encode","","",428,[[["self"],["__s"]],["result"]]],[11,"decode","","",428,[[["__d"]],["result",["basicblockdata"]]]],[11,"clone","","",429,[[["self"]],["terminator"]]],[11,"fmt","","",429,[[["self"],["formatter"]],["result"]]],[11,"encode","","",429,[[["self"],["__s"]],["result"]]],[11,"decode","","",429,[[["__d"]],["result",["terminator"]]]],[11,"clone","","",453,[[["self"]],["terminatorkind"]]],[11,"encode","","",453,[[["self"],["__s"]],["result"]]],[11,"decode","","",453,[[["__d"]],["result",["terminatorkind"]]]],[11,"successors","","",429,[[["self"]],["successors"]]],[11,"successors_mut","","",429,[[["self"]],["successorsmut"]]],[11,"unwind","","",429,[[["self"]],["option",["option"]]]],[11,"unwind_mut","","",429,[[["self"]],["option",["option"]]]],[11,"if_","","",453,[[["tyctxt"],["operand"],["basicblock"],["basicblock"]],["terminatorkind"]]],[11,"successors","","",453,[[["self"]],["successors"]]],[11,"successors_mut","","",453,[[["self"]],["successorsmut"]]],[11,"unwind","","",453,[[["self"]],["option",["option"]]]],[11,"unwind_mut","","",453,[[["self"]],["option",["option"]]]],[11,"new","","",428,[[["option",["terminator"]]],["basicblockdata"]]],[11,"terminator","","Accessor for terminator.",428,[[["self"]],["terminator"]]],[11,"terminator_mut","","",428,[[["self"]],["terminator"]]],[11,"retain_statements","","",428,[[["self"],["f"]]]],[11,"expand_statements","","",428,[[["self"],["f"]]]],[11,"visitable","","",428,[[["self"],["usize"]],["mirvisitable"]]],[11,"fmt","","",453,[[["self"],["formatter"]],["result"]]],[11,"fmt_head","","Write the \"head\" part of the terminator; that is, its name and the data it uses to pick the successor basic block, if any. The only information not included is the list of possible successors, which may be rendered differently between the text and the graphviz format.",453,[[["self"],["w"]],["result"]]],[11,"fmt_successor_labels","","Return the list of labels for the edges to the successor basic blocks.",453,[[["self"]],["vec",["cow"]]]],[11,"clone","","",430,[[["self"]],["statement"]]],[11,"encode","","",430,[[["self"],["__s"]],["result"]]],[11,"decode","","",430,[[["__d"]],["result",["statement"]]]],[11,"make_nop","","Changes a statement to a nop. This is both faster than deleting instructions and avoids invalidating statement indices in `Location`s.",430,[[["self"]]]],[11,"replace_nop","","Changes a statement to a nop and returns the original statement.",430,[[["self"]],["self"]]],[11,"clone","","",454,[[["self"]],["statementkind"]]],[11,"fmt","","",454,[[["self"],["formatter"]],["result"]]],[11,"encode","","",454,[[["self"],["__s"]],["result"]]],[11,"decode","","",454,[[["__d"]],["result",["statementkind"]]]],[11,"clone","","",455,[[["self"]],["validationop"]]],[11,"encode","","",455,[[["self"],["__s"]],["result"]]],[11,"decode","","",455,[[["__d"]],["result",["validationop"]]]],[11,"eq","","",455,[[["self"],["validationop"]],["bool"]]],[11,"ne","","",455,[[["self"],["validationop"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",455,N],[11,"fmt","","",455,[[["self"],["formatter"]],["result"]]],[11,"clone","","",431,[[["self"]],["validationoperand"]]],[11,"hash","","",431,N],[11,"eq","","",431,[[["self"],["validationoperand"]],["bool"]]],[11,"ne","","",431,[[["self"],["validationoperand"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",431,N],[11,"encode","","",431,[[["self"],["__st"]],["result"]]],[11,"decode","","",431,[[["__dt"]],["result",["validationoperand"]]]],[11,"fmt","","",431,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",430,[[["self"],["formatter"]],["result"]]],[11,"clone","","",456,[[["self"]],["place"]]],[11,"eq","","",456,[[["self"],["place"]],["bool"]]],[11,"ne","","",456,[[["self"],["place"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",456,N],[11,"hash","","",456,N],[11,"encode","","",456,[[["self"],["__s"]],["result"]]],[11,"decode","","",456,[[["__d"]],["result",["place"]]]],[11,"clone","","",432,[[["self"]],["static"]]],[11,"eq","","",432,[[["self"],["static"]],["bool"]]],[11,"ne","","",432,[[["self"],["static"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",432,N],[11,"hash","","",432,N],[11,"encode","","",432,[[["self"],["__s"]],["result"]]],[11,"decode","","",432,[[["__d"]],["result",["static"]]]],[11,"hash_stable","","",432,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",433,[[["self"]],["projection"]]],[11,"fmt","","",433,[[["self"],["formatter"]],["result"]]],[11,"eq","","",433,[[["self"],["projection"]],["bool"]]],[11,"ne","","",433,[[["self"],["projection"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",433,N],[11,"hash","","",433,N],[11,"encode","","",433,[[["self"],["__sbvt"]],["result"]]],[11,"decode","","",433,[[["__dbvt"]],["result",["projection"]]]],[11,"clone","","",457,[[["self"]],["projectionelem"]]],[11,"fmt","","",457,[[["self"],["formatter"]],["result"]]],[11,"eq","","",457,[[["self"],["projectionelem"]],["bool"]]],[11,"ne","","",457,[[["self"],["projectionelem"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",457,N],[11,"hash","","",457,N],[11,"encode","","",457,[[["self"],["__svt"]],["result"]]],[11,"decode","","",457,[[["__dvt"]],["result",["projectionelem"]]]],[11,"clone","","",434,[[["self"]],["field"]]],[11,"eq","","",434,[[["self"],["field"]],["bool"]]],[11,"ne","","",434,[[["self"],["field"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",434,N],[11,"hash","","",434,N],[11,"partial_cmp","","",434,[[["self"],["field"]],["option",["ordering"]]]],[11,"lt","","",434,[[["self"],["field"]],["bool"]]],[11,"le","","",434,[[["self"],["field"]],["bool"]]],[11,"gt","","",434,[[["self"],["field"]],["bool"]]],[11,"ge","","",434,[[["self"],["field"]],["bool"]]],[11,"cmp","","",434,[[["self"],["field"]],["ordering"]]],[11,"decode","","",434,[[["__d"]],["result",["field"]]]],[11,"encode","","",434,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",434,N],[18,"MAX","","",434,N],[11,"from_usize","","",434,[[["usize"]],["self"]]],[11,"from_u32","","",434,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",434,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",434,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",434,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",434,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",434,[[["self"]],["usize"]]],[11,"new","","",434,[[["usize"]],["self"]]],[11,"index","","",434,[[["self"]],["usize"]]],[11,"steps_between","","",434,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",434,[[["self"]],["self"]]],[11,"replace_zero","","",434,[[["self"]],["self"]]],[11,"add_one","","",434,[[["self"]],["self"]]],[11,"sub_one","","",434,[[["self"]],["self"]]],[11,"add_usize","","",434,[[["self"],["usize"]],["option"]]],[11,"from","","",434,[[["usize"]],["self"]]],[11,"from","","",434,[[["u32"]],["self"]]],[11,"fmt","","",434,[[["self"],["formatter"]],["result"]]],[11,"field","","",456,[[["self"],["field"],["ty"]],["place"]]],[11,"deref","","",456,[[["self"]],["place"]]],[11,"downcast","","",456,[[["self"],["adtdef"],["usize"]],["place"]]],[11,"index","","",456,[[["self"],["local"]],["place"]]],[11,"elem","","",456,[[["self"],["placeelem"]],["place"]]],[11,"fmt","","",456,[[["self"],["formatter"]],["result"]]],[11,"clone","","",435,[[["self"]],["sourcescope"]]],[11,"eq","","",435,[[["self"],["sourcescope"]],["bool"]]],[11,"ne","","",435,[[["self"],["sourcescope"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",435,N],[11,"hash","","",435,N],[11,"partial_cmp","","",435,[[["self"],["sourcescope"]],["option",["ordering"]]]],[11,"lt","","",435,[[["self"],["sourcescope"]],["bool"]]],[11,"le","","",435,[[["self"],["sourcescope"]],["bool"]]],[11,"gt","","",435,[[["self"],["sourcescope"]],["bool"]]],[11,"ge","","",435,[[["self"],["sourcescope"]],["bool"]]],[11,"cmp","","",435,[[["self"],["sourcescope"]],["ordering"]]],[11,"decode","","",435,[[["__d"]],["result",["sourcescope"]]]],[11,"encode","","",435,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",435,N],[18,"MAX","","",435,N],[11,"from_usize","","",435,[[["usize"]],["self"]]],[11,"from_u32","","",435,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",435,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",435,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",435,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",435,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",435,[[["self"]],["usize"]]],[11,"new","","",435,[[["usize"]],["self"]]],[11,"index","","",435,[[["self"]],["usize"]]],[11,"steps_between","","",435,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",435,[[["self"]],["self"]]],[11,"replace_zero","","",435,[[["self"]],["self"]]],[11,"add_one","","",435,[[["self"]],["self"]]],[11,"sub_one","","",435,[[["self"]],["self"]]],[11,"add_usize","","",435,[[["self"],["usize"]],["option"]]],[11,"from","","",435,[[["usize"]],["self"]]],[11,"from","","",435,[[["u32"]],["self"]]],[11,"fmt","","",435,[[["self"],["formatter"]],["result"]]],[11,"clone","","",436,[[["self"]],["sourcescopedata"]]],[11,"fmt","","",436,[[["self"],["formatter"]],["result"]]],[11,"encode","","",436,[[["self"],["__s"]],["result"]]],[11,"decode","","",436,[[["__d"]],["result",["sourcescopedata"]]]],[11,"clone","","",437,[[["self"]],["sourcescopelocaldata"]]],[11,"fmt","","",437,[[["self"],["formatter"]],["result"]]],[11,"encode","","",437,[[["self"],["__s"]],["result"]]],[11,"decode","","",437,[[["__d"]],["result",["sourcescopelocaldata"]]]],[11,"clone","","",458,[[["self"]],["operand"]]],[11,"eq","","",458,[[["self"],["operand"]],["bool"]]],[11,"ne","","",458,[[["self"],["operand"]],["bool"]]],[11,"encode","","",458,[[["self"],["__s"]],["result"]]],[11,"decode","","",458,[[["__d"]],["result",["operand"]]]],[11,"fmt","","",458,[[["self"],["formatter"]],["result"]]],[11,"function_handle","","Convenience helper to make a constant that refers to the fn with given def-id and substs. Since this is used to synthesize MIR, assumes `user_ty` is None.",458,[[["tyctxt"],["defid"],["substs"],["span"]],["self"]]],[11,"to_copy","","",458,[[["self"]],["self"]]],[11,"clone","","",459,[[["self"]],["rvalue"]]],[11,"encode","","",459,[[["self"],["__s"]],["result"]]],[11,"decode","","",459,[[["__d"]],["result",["rvalue"]]]],[11,"clone","","",460,[[["self"]],["castkind"]]],[11,"fmt","","",460,[[["self"],["formatter"]],["result"]]],[11,"eq","","",460,[[["self"],["castkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",460,N],[11,"encode","","",460,[[["self"],["__s"]],["result"]]],[11,"decode","","",460,[[["__d"]],["result",["castkind"]]]],[11,"clone","","",461,[[["self"]],["aggregatekind"]]],[11,"fmt","","",461,[[["self"],["formatter"]],["result"]]],[11,"eq","","",461,[[["self"],["aggregatekind"]],["bool"]]],[11,"ne","","",461,[[["self"],["aggregatekind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",461,N],[11,"encode","","",461,[[["self"],["__s"]],["result"]]],[11,"decode","","",461,[[["__d"]],["result",["aggregatekind"]]]],[11,"clone","","",462,[[["self"]],["binop"]]],[11,"fmt","","",462,[[["self"],["formatter"]],["result"]]],[11,"eq","","",462,[[["self"],["binop"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",462,N],[11,"encode","","",462,[[["self"],["__s"]],["result"]]],[11,"decode","","",462,[[["__d"]],["result",["binop"]]]],[11,"is_checkable","","",462,[[["self"]],["bool"]]],[11,"clone","","",463,[[["self"]],["nullop"]]],[11,"fmt","","",463,[[["self"],["formatter"]],["result"]]],[11,"eq","","",463,[[["self"],["nullop"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",463,N],[11,"encode","","",463,[[["self"],["__s"]],["result"]]],[11,"decode","","",463,[[["__d"]],["result",["nullop"]]]],[11,"clone","","",464,[[["self"]],["unop"]]],[11,"fmt","","",464,[[["self"],["formatter"]],["result"]]],[11,"eq","","",464,[[["self"],["unop"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",464,N],[11,"encode","","",464,[[["self"],["__s"]],["result"]]],[11,"decode","","",464,[[["__d"]],["result",["unop"]]]],[11,"fmt","","",459,[[["self"],["formatter"]],["result"]]],[11,"clone","","",438,[[["self"]],["constant"]]],[11,"eq","","",438,[[["self"],["constant"]],["bool"]]],[11,"ne","","",438,[[["self"],["constant"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",438,N],[11,"hash","","",438,N],[11,"encode","","",438,[[["self"],["__s"]],["result"]]],[11,"decode","","",438,[[["__d"]],["result",["constant"]]]],[11,"clone","","",439,[[["self"]],["promoted"]]],[11,"eq","","",439,[[["self"],["promoted"]],["bool"]]],[11,"ne","","",439,[[["self"],["promoted"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",439,N],[11,"hash","","",439,N],[11,"partial_cmp","","",439,[[["self"],["promoted"]],["option",["ordering"]]]],[11,"lt","","",439,[[["self"],["promoted"]],["bool"]]],[11,"le","","",439,[[["self"],["promoted"]],["bool"]]],[11,"gt","","",439,[[["self"],["promoted"]],["bool"]]],[11,"ge","","",439,[[["self"],["promoted"]],["bool"]]],[11,"cmp","","",439,[[["self"],["promoted"]],["ordering"]]],[11,"decode","","",439,[[["__d"]],["result",["promoted"]]]],[11,"encode","","",439,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",439,N],[18,"MAX","","",439,N],[11,"from_usize","","",439,[[["usize"]],["self"]]],[11,"from_u32","","",439,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",439,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",439,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",439,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",439,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",439,[[["self"]],["usize"]]],[11,"new","","",439,[[["usize"]],["self"]]],[11,"index","","",439,[[["self"]],["usize"]]],[11,"steps_between","","",439,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",439,[[["self"]],["self"]]],[11,"replace_zero","","",439,[[["self"]],["self"]]],[11,"add_one","","",439,[[["self"]],["self"]]],[11,"sub_one","","",439,[[["self"]],["self"]]],[11,"add_usize","","",439,[[["self"],["usize"]],["option"]]],[11,"from","","",439,[[["usize"]],["self"]]],[11,"from","","",439,[[["u32"]],["self"]]],[11,"fmt","","",439,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",438,[[["self"],["formatter"]],["result"]]],[11,"num_nodes","","",421,[[["self"]],["usize"]]],[11,"start_node","","",421,N],[11,"predecessors","","",421,N],[11,"successors","","",421,N],[11,"clone","","",440,[[["self"]],["location"]]],[11,"eq","","",440,[[["self"],["location"]],["bool"]]],[11,"ne","","",440,[[["self"],["location"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",440,N],[11,"hash","","",440,N],[11,"cmp","","",440,[[["self"],["location"]],["ordering"]]],[11,"partial_cmp","","",440,[[["self"],["location"]],["option",["ordering"]]]],[11,"lt","","",440,[[["self"],["location"]],["bool"]]],[11,"le","","",440,[[["self"],["location"]],["bool"]]],[11,"gt","","",440,[[["self"],["location"]],["bool"]]],[11,"ge","","",440,[[["self"],["location"]],["bool"]]],[11,"fmt","","",440,[[["self"],["formatter"]],["result"]]],[18,"START","","",440,N],[11,"successor_within_block","","Returns the location immediately after this one within the enclosing block.",440,[[["self"]],["location"]]],[11,"dominates","","",440,[[["self"],["location"],["dominators"]],["bool"]]],[11,"clone","","",465,[[["self"]],["unsafetyviolationkind"]]],[11,"fmt","","",465,[[["self"],["formatter"]],["result"]]],[11,"eq","","",465,[[["self"],["unsafetyviolationkind"]],["bool"]]],[11,"ne","","",465,[[["self"],["unsafetyviolationkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",465,N],[11,"hash","","",465,N],[11,"encode","","",465,[[["self"],["__s"]],["result"]]],[11,"decode","","",465,[[["__d"]],["result",["unsafetyviolationkind"]]]],[11,"clone","","",441,[[["self"]],["unsafetyviolation"]]],[11,"fmt","","",441,[[["self"],["formatter"]],["result"]]],[11,"eq","","",441,[[["self"],["unsafetyviolation"]],["bool"]]],[11,"ne","","",441,[[["self"],["unsafetyviolation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",441,N],[11,"hash","","",441,N],[11,"encode","","",441,[[["self"],["__s"]],["result"]]],[11,"decode","","",441,[[["__d"]],["result",["unsafetyviolation"]]]],[11,"clone","","",442,[[["self"]],["unsafetycheckresult"]]],[11,"fmt","","",442,[[["self"],["formatter"]],["result"]]],[11,"eq","","",442,[[["self"],["unsafetycheckresult"]],["bool"]]],[11,"ne","","",442,[[["self"],["unsafetycheckresult"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",442,N],[11,"hash","","",442,N],[11,"encode","","",442,[[["self"],["__s"]],["result"]]],[11,"decode","","",442,[[["__d"]],["result",["unsafetycheckresult"]]]],[11,"clone","","",443,[[["self"]],["generatorlayout"]]],[11,"fmt","","",443,[[["self"],["formatter"]],["result"]]],[11,"encode","","",443,[[["self"],["__s"]],["result"]]],[11,"decode","","",443,[[["__d"]],["result",["generatorlayout"]]]],[11,"clone","","",444,[[["self"]],["borrowcheckresult"]]],[11,"fmt","","",444,[[["self"],["formatter"]],["result"]]],[11,"encode","","",444,[[["self"],["__s"]],["result"]]],[11,"decode","","",444,[[["__d"]],["result",["borrowcheckresult"]]]],[11,"clone","","",445,[[["self"]],["closureregionrequirements"]]],[11,"fmt","","",445,[[["self"],["formatter"]],["result"]]],[11,"encode","","",445,[[["self"],["__s"]],["result"]]],[11,"decode","","",445,[[["__d"]],["result",["closureregionrequirements"]]]],[11,"clone","","",446,[[["self"]],["closureoutlivesrequirement"]]],[11,"fmt","","",446,[[["self"],["formatter"]],["result"]]],[11,"encode","","",446,[[["self"],["__s"]],["result"]]],[11,"decode","","",446,[[["__d"]],["result",["closureoutlivesrequirement"]]]],[11,"clone","","",466,[[["self"]],["closureoutlivessubject"]]],[11,"fmt","","",466,[[["self"],["formatter"]],["result"]]],[11,"encode","","",466,[[["self"],["__s"]],["result"]]],[11,"decode","","",466,[[["__d"]],["result",["closureoutlivessubject"]]]],[11,"super_fold_with","","",449,[[["self"],["f"]],["mutability"]]],[11,"super_visit_with","","",449,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",422,[[["self"],["f"]],["sourceinfo"]]],[11,"super_visit_with","","",422,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",426,[[["self"],["f"]],["upvardecl"]]],[11,"super_visit_with","","",426,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",455,[[["self"],["f"]],["validationop"]]],[11,"super_visit_with","","",455,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",435,[[["self"],["f"]],["sourcescope"]]],[11,"super_visit_with","","",435,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",436,[[["self"],["f"]],["sourcescopedata"]]],[11,"super_visit_with","","",436,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",437,[[["self"],["f"]],["sourcescopelocaldata"]]],[11,"super_visit_with","","",437,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",449,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",422,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",426,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",455,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",435,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",436,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",437,[[["self"],["tyctxt"]],["option"]]],[11,"super_fold_with","","",421,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",421,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",443,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",443,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",425,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",425,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",428,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",428,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",431,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",431,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",430,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",430,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",454,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",454,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",448,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",448,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",429,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",429,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",456,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",456,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",459,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",459,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",458,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",458,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",433,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",433,[[["self"],["vs"]],["bool"]]],[11,"super_fold_with","","",434,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",434,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",438,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",438,[[["self"],["v"]],["bool"]]],[0,"session","rustc","",N,N],[3,"FieldInfo","rustc::session","",N,N],[12,"name","","",508,N],[12,"offset","","",508,N],[12,"size","","",508,N],[12,"align","","",508,N],[3,"VariantInfo","","",N,N],[12,"name","","",509,N],[12,"kind","","",509,N],[12,"size","","",509,N],[12,"align","","",509,N],[12,"fields","","",509,N],[3,"Session","","Represents the data associated with a compilation session for a single crate.",N,N],[12,"target","","",510,N],[12,"host","","",510,N],[12,"opts","","",510,N],[12,"parse_sess","","",510,N],[12,"entry_fn","","For a library crate, this is always none",510,N],[12,"plugin_registrar_fn","","",510,N],[12,"derive_registrar_fn","","",510,N],[12,"default_sysroot","","",510,N],[12,"local_crate_source_file","","The name of the root source file of the crate, in the local file system. `None` means that there is no source file.",510,N],[12,"working_dir","","The directory the compiler has been executed in plus a flag indicating if the value stored here has been affected by path remapping.",510,N],[12,"lint_store","","",510,N],[12,"buffered_lints","","",510,N],[12,"one_time_diagnostics","","Set of (DiagnosticId, Option, message) tuples tracking (sub)diagnostics that have been set once, but should not be set again, in order to avoid redundantly verbose output (Issue #24690, #44953).",510,N],[12,"plugin_llvm_passes","","",510,N],[12,"plugin_attributes","","",510,N],[12,"crate_types","","",510,N],[12,"dependency_formats","","",510,N],[12,"crate_disambiguator","","The crate_disambiguator is constructed out of all the `-C metadata` arguments passed to the compiler. Its value together with the crate-name forms a unique global identifier for the crate. It is used to allow multiple crates with the same name to coexist. See the rustc_codegen_llvm::back::symbol_names module for more information.",510,N],[12,"features","","",510,N],[12,"recursion_limit","","The maximum recursion limit for potentially infinitely recursive operations such as auto-dereference and monomorphization.",510,N],[12,"type_length_limit","","The maximum length of types during monomorphization.",510,N],[12,"const_eval_stack_frame_limit","","The maximum number of stackframes allowed in const eval",510,N],[12,"injected_allocator","","The metadata::creader module may inject an allocator/panic_runtime dependency if it didn't already find one, and this tracks what was injected.",510,N],[12,"allocator_kind","","",510,N],[12,"injected_panic_runtime","","",510,N],[12,"imported_macro_spans","","Map from imported macro spans (which consist of the localized span for the macro body) to the macro name and definition span in the source crate.",510,N],[12,"incr_comp_session","","",510,N],[12,"profile_channel","","Used by -Z profile-queries in util::common",510,N],[12,"self_profiling","","Used by -Z self-profile",510,N],[12,"perf_stats","","Some measurements that are being gathered during compilation.",510,N],[12,"code_stats","","Data about code being compiled, gathered during compilation.",510,N],[12,"next_node_id","","",510,N],[12,"optimization_fuel_crate","","If -zfuel=crate=n is specified, Some(crate).",510,N],[12,"optimization_fuel_limit","","If -zfuel=crate=n is specified, initially set to n. Otherwise 0.",510,N],[12,"out_of_fuel","","We're rejecting all further optimizations.",510,N],[12,"print_fuel_crate","","If -zprint-fuel=crate, Some(crate).",510,N],[12,"print_fuel","","Always set to zero and incremented so that we can print fuel expended by a crate.",510,N],[12,"jobserver","","Loaded up early on in the initialization of this `Session` to avoid false positives about a job server in our environment.",510,N],[12,"has_global_allocator","","Metadata about the allocators for the current crate being compiled",510,N],[12,"has_panic_handler","","Metadata about the panic handlers for the current crate being compiled",510,N],[12,"driver_lint_caps","","Cap lint level specified by a driver specifically.",510,N],[3,"PerfStats","","",N,N],[12,"symbol_hash_time","","The accumulated time spent on computing symbol hashes",511,N],[12,"decode_def_path_tables_time","","The accumulated time spent decoding def path tables from metadata",511,N],[12,"queries_canonicalized","","Total number of values canonicalized queries constructed.",511,N],[12,"normalize_ty_after_erasing_regions","","Number of times this query is invoked.",511,N],[12,"normalize_projection_ty","","Number of times this query is invoked.",511,N],[3,"CrateDisambiguator","","Hash value constructed out of all the `-C metadata` arguments passed to the compiler. Together with the crate-name forms a unique global identifier for the crate.",N,N],[12,"0","","",512,N],[4,"DataTypeKind","","",N,N],[13,"Struct","","",513,N],[13,"Union","","",513,N],[13,"Enum","","",513,N],[13,"Closure","","",513,N],[4,"SizeKind","","",N,N],[13,"Exact","","",514,N],[13,"Min","","",514,N],[4,"DiagnosticBuilderMethod","","Enum to support dispatch of one-time diagnostics (in Session.diag_once)",N,N],[13,"Note","","",515,N],[13,"SpanNote","","",515,N],[13,"SpanSuggestion","","",515,N],[4,"DiagnosticMessageId","","Diagnostic message ID—used by `Session.one_time_diagnostics` to avoid emitting the same message more than once",N,N],[13,"ErrorId","","",516,N],[13,"LintId","","",516,N],[13,"StabilityId","","",516,N],[4,"IncrCompSession","","Holds data on the current incremental compilation session, if there is one.",N,N],[13,"NotInitialized","","This is the state the session will be in until the incr. comp. dir is needed.",517,N],[13,"Active","","This is the state during which the session directory is private and can be modified.",517,N],[12,"session_directory","rustc::session::IncrCompSession","",517,N],[12,"lock_file","","",517,N],[12,"load_dep_graph","","",517,N],[13,"Finalized","rustc::session","This is the state after the session directory has been finalized. In this state, the contents of the directory must not be modified any more.",517,N],[12,"session_directory","rustc::session::IncrCompSession","",517,N],[13,"InvalidBecauseOfErrors","rustc::session","This is an error state that is reached when some compilation error has occurred. It indicates that the contents of the session directory must not be used, since they might be invalid.",517,N],[12,"session_directory","rustc::session::IncrCompSession","",517,N],[4,"CompileIncomplete","rustc::session","",N,N],[13,"Stopped","","",518,N],[13,"Errored","","",518,N],[5,"build_session","","",N,[[["options"],["option",["pathbuf"]],["registry"]],["session"]]],[5,"build_session_with_source_map","","",N,[[["options"],["option",["pathbuf"]],["registry"],["lrc",["sourcemap"]],["option",["box"]]],["session"]]],[5,"build_session_","","",N,[[["options"],["option",["pathbuf"]],["handler"],["lrc",["sourcemap"]]],["session"]]],[5,"validate_commandline_args_with_session_available","","",N,[[["session"]]]],[5,"early_error","","",N,N],[5,"early_warn","","",N,[[["erroroutputtype"],["str"]]]],[5,"compile_result_from_err_count","","",N,[[["usize"]],["compileresult"]]],[0,"code_stats","","",N,N],[3,"VariantInfo","rustc::session::code_stats","",N,N],[12,"name","","",509,N],[12,"kind","","",509,N],[12,"size","","",509,N],[12,"align","","",509,N],[12,"fields","","",509,N],[3,"FieldInfo","","",N,N],[12,"name","","",508,N],[12,"offset","","",508,N],[12,"size","","",508,N],[12,"align","","",508,N],[3,"TypeSizeInfo","","",N,N],[12,"kind","","",519,N],[12,"type_description","","",519,N],[12,"align","","",519,N],[12,"overall_size","","",519,N],[12,"packed","","",519,N],[12,"opt_discr_size","","",519,N],[12,"variants","","",519,N],[3,"CodeStats","","",N,N],[12,"type_sizes","","",520,N],[4,"SizeKind","","",N,N],[13,"Exact","","",514,N],[13,"Min","","",514,N],[4,"DataTypeKind","","",N,N],[13,"Struct","","",513,N],[13,"Union","","",513,N],[13,"Enum","","",513,N],[13,"Closure","","",513,N],[11,"clone","rustc::session","",509,[[["self"]],["variantinfo"]]],[11,"eq","","",509,[[["self"],["variantinfo"]],["bool"]]],[11,"ne","","",509,[[["self"],["variantinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",509,N],[11,"hash","","",509,N],[11,"fmt","","",509,[[["self"],["formatter"]],["result"]]],[11,"clone","","",514,[[["self"]],["sizekind"]]],[11,"eq","","",514,[[["self"],["sizekind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",514,N],[11,"hash","","",514,N],[11,"fmt","","",514,[[["self"],["formatter"]],["result"]]],[11,"clone","","",508,[[["self"]],["fieldinfo"]]],[11,"eq","","",508,[[["self"],["fieldinfo"]],["bool"]]],[11,"ne","","",508,[[["self"],["fieldinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",508,N],[11,"hash","","",508,N],[11,"fmt","","",508,[[["self"],["formatter"]],["result"]]],[11,"clone","","",513,[[["self"]],["datatypekind"]]],[11,"eq","","",513,[[["self"],["datatypekind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",513,N],[11,"hash","","",513,N],[11,"fmt","","",513,[[["self"],["formatter"]],["result"]]],[11,"eq","rustc::session::code_stats","",519,[[["self"],["typesizeinfo"]],["bool"]]],[11,"ne","","",519,[[["self"],["typesizeinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",519,N],[11,"hash","","",519,N],[11,"fmt","","",519,[[["self"],["formatter"]],["result"]]],[11,"eq","","",520,[[["self"],["codestats"]],["bool"]]],[11,"ne","","",520,[[["self"],["codestats"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",520,N],[11,"fmt","","",520,[[["self"],["formatter"]],["result"]]],[11,"new","","",520,[[],["self"]]],[11,"record_type_size","","",520,[[["self"],["datatypekind"],["s"],["align"],["size"],["bool"],["option",["size"]],["vec",["variantinfo"]]]]],[11,"print_type_sizes","","",520,[[["self"]]]],[0,"config","rustc::session","Contains infrastructure for configuring the compiler, including parsing command line options.",N,N],[3,"Config","rustc::session::config","",N,N],[12,"target","","",521,N],[12,"isize_ty","","",521,N],[12,"usize_ty","","",521,N],[3,"OutputTypes","","",N,N],[12,"0","","",522,N],[3,"Externs","","",N,N],[12,"0","","",523,N],[3,"Options","","",N,N],[12,"crate_types","","",524,N],[12,"optimize","","",524,N],[12,"debug_assertions","","",524,N],[12,"debuginfo","","",524,N],[12,"lint_opts","","",524,N],[12,"lint_cap","","",524,N],[12,"describe_lints","","",524,N],[12,"output_types","","",524,N],[12,"search_paths","","",524,N],[12,"libs","","",524,N],[12,"maybe_sysroot","","",524,N],[12,"target_triple","","",524,N],[12,"test","","",524,N],[12,"error_format","","",524,N],[12,"incremental","","",524,N],[12,"debugging_opts","","",524,N],[12,"prints","","",524,N],[12,"borrowck_mode","","",524,N],[12,"cg","","",524,N],[12,"externs","","",524,N],[12,"crate_name","","",524,N],[12,"alt_std_name","","",524,N],[12,"unstable_features","","",524,N],[12,"actually_rustdoc","","",524,N],[12,"cli_forced_codegen_units","","",524,N],[12,"cli_forced_thinlto_off","","",524,N],[12,"remap_path_prefix","","",524,N],[12,"edition","","",524,N],[3,"OutputFilenames","","",N,N],[12,"out_directory","","",525,N],[12,"out_filestem","","",525,N],[12,"single_output_file","","",525,N],[12,"extra","","",525,N],[12,"outputs","","",525,N],[3,"CodegenOptions","","",N,N],[12,"ar","","",526,N],[12,"linker","","",526,N],[12,"link_arg","","",526,N],[12,"link_args","","",526,N],[12,"link_dead_code","","",526,N],[12,"lto","","",526,N],[12,"target_cpu","","",526,N],[12,"target_feature","","",526,N],[12,"passes","","",526,N],[12,"llvm_args","","",526,N],[12,"save_temps","","",526,N],[12,"rpath","","",526,N],[12,"overflow_checks","","",526,N],[12,"no_prepopulate_passes","","",526,N],[12,"no_vectorize_loops","","",526,N],[12,"no_vectorize_slp","","",526,N],[12,"soft_float","","",526,N],[12,"prefer_dynamic","","",526,N],[12,"no_integrated_as","","",526,N],[12,"no_redzone","","",526,N],[12,"relocation_model","","",526,N],[12,"code_model","","",526,N],[12,"metadata","","",526,N],[12,"extra_filename","","",526,N],[12,"codegen_units","","",526,N],[12,"remark","","",526,N],[12,"no_stack_check","","",526,N],[12,"debuginfo","","",526,N],[12,"opt_level","","",526,N],[12,"force_frame_pointers","","",526,N],[12,"debug_assertions","","",526,N],[12,"inline_threshold","","",526,N],[12,"panic","","",526,N],[12,"incremental","","",526,N],[3,"DebuggingOptions","","",N,N],[12,"codegen_backend","","",527,N],[12,"verbose","","",527,N],[12,"span_free_formats","","",527,N],[12,"identify_regions","","",527,N],[12,"emit_end_regions","","",527,N],[12,"borrowck","","",527,N],[12,"two_phase_borrows","","",527,N],[12,"two_phase_beyond_autoref","","",527,N],[12,"time_passes","","",527,N],[12,"count_llvm_insns","","",527,N],[12,"time_llvm_passes","","",527,N],[12,"input_stats","","",527,N],[12,"codegen_stats","","",527,N],[12,"asm_comments","","",527,N],[12,"verify_llvm_ir","","",527,N],[12,"borrowck_stats","","",527,N],[12,"no_landing_pads","","",527,N],[12,"fewer_names","","",527,N],[12,"meta_stats","","",527,N],[12,"print_link_args","","",527,N],[12,"print_llvm_passes","","",527,N],[12,"ast_json","","",527,N],[12,"query_threads","","",527,N],[12,"ast_json_noexpand","","",527,N],[12,"ls","","",527,N],[12,"save_analysis","","",527,N],[12,"flowgraph_print_loans","","",527,N],[12,"flowgraph_print_moves","","",527,N],[12,"flowgraph_print_assigns","","",527,N],[12,"flowgraph_print_all","","",527,N],[12,"print_region_graph","","",527,N],[12,"parse_only","","",527,N],[12,"no_codegen","","",527,N],[12,"treat_err_as_bug","","",527,N],[12,"report_delayed_bugs","","",527,N],[12,"external_macro_backtrace","","",527,N],[12,"teach","","",527,N],[12,"continue_parse_after_error","","",527,N],[12,"incremental","","",527,N],[12,"incremental_queries","","",527,N],[12,"incremental_info","","",527,N],[12,"incremental_dump_hash","","",527,N],[12,"incremental_verify_ich","","",527,N],[12,"incremental_ignore_spans","","",527,N],[12,"dump_dep_graph","","",527,N],[12,"query_dep_graph","","",527,N],[12,"profile_queries","","",527,N],[12,"profile_queries_and_keys","","",527,N],[12,"no_analysis","","",527,N],[12,"extra_plugins","","",527,N],[12,"unstable_options","","",527,N],[12,"force_overflow_checks","","",527,N],[12,"trace_macros","","",527,N],[12,"debug_macros","","",527,N],[12,"keep_hygiene_data","","",527,N],[12,"keep_ast","","",527,N],[12,"show_span","","",527,N],[12,"print_type_sizes","","",527,N],[12,"print_mono_items","","",527,N],[12,"mir_opt_level","","",527,N],[12,"mutable_noalias","","",527,N],[12,"arg_align_attributes","","",527,N],[12,"dump_mir","","",527,N],[12,"dump_mir_dir","","",527,N],[12,"dump_mir_graphviz","","",527,N],[12,"dump_mir_exclude_pass_number","","",527,N],[12,"mir_emit_validate","","",527,N],[12,"perf_stats","","",527,N],[12,"hir_stats","","",527,N],[12,"mir_stats","","",527,N],[12,"always_encode_mir","","",527,N],[12,"osx_rpath_install_name","","",527,N],[12,"sanitizer","","",527,N],[12,"linker_flavor","","",527,N],[12,"fuel","","",527,N],[12,"print_fuel","","",527,N],[12,"force_unstable_if_unmarked","","",527,N],[12,"pre_link_arg","","",527,N],[12,"pre_link_args","","",527,N],[12,"profile","","",527,N],[12,"pgo_gen","","",527,N],[12,"pgo_use","","",527,N],[12,"disable_instrumentation_preinliner","","",527,N],[12,"relro_level","","",527,N],[12,"disable_ast_check_for_mutation_in_guard","","",527,N],[12,"nll_subminimal_causes","","",527,N],[12,"nll_facts","","",527,N],[12,"disable_nll_user_type_assert","","",527,N],[12,"nll_dont_emit_read_for_match","","",527,N],[12,"polonius","","",527,N],[12,"codegen_time_graph","","",527,N],[12,"thinlto","","",527,N],[12,"inline_in_all_cgus","","",527,N],[12,"tls_model","","",527,N],[12,"saturating_float_casts","","",527,N],[12,"lower_128bit_ops","","",527,N],[12,"human_readable_cgu_names","","",527,N],[12,"dep_info_omit_d_target","","",527,N],[12,"unpretty","","",527,N],[12,"run_dsymutil","","",527,N],[12,"ui_testing","","",527,N],[12,"embed_bitcode","","",527,N],[12,"strip_debuginfo_if_disabled","","",527,N],[12,"share_generics","","",527,N],[12,"chalk","","",527,N],[12,"cross_lang_lto","","",527,N],[12,"no_parallel_llvm","","",527,N],[12,"no_leak_check","","",527,N],[12,"crate_attr","","",527,N],[12,"self_profile","","",527,N],[12,"profile_json","","",527,N],[3,"RustcOptGroup","","",N,N],[12,"apply","","",528,N],[12,"name","","",528,N],[12,"stability","","",528,N],[4,"Sanitizer","","",N,N],[13,"Address","","",529,N],[13,"Leak","","",529,N],[13,"Memory","","",529,N],[13,"Thread","","",529,N],[4,"OptLevel","","",N,N],[13,"No","","",530,N],[13,"Less","","",530,N],[13,"Default","","",530,N],[13,"Aggressive","","",530,N],[13,"Size","","",530,N],[13,"SizeMin","","",530,N],[4,"Lto","","This is what the `LtoCli` values get mapped to after resolving defaults and and taking other command line options into account.",N,N],[13,"No","","Don't do any LTO whatsoever",531,N],[13,"Thin","","Do a full crate graph LTO with ThinLTO",531,N],[13,"ThinLocal","","Do a local graph LTO with ThinLTO (only relevant for multiple codegen units).",531,N],[13,"Fat","","Do a full crate graph LTO with \"fat\" LTO",531,N],[4,"LtoCli","","The different settings that the `-C lto` flag can have.",N,N],[13,"No","","`-C lto=no`",532,N],[13,"Yes","","`-C lto=yes`",532,N],[13,"NoParam","","`-C lto`",532,N],[13,"Thin","","`-C lto=thin`",532,N],[13,"Fat","","`-C lto=fat`",532,N],[13,"Unspecified","","No `-C lto` flag passed",532,N],[4,"CrossLangLto","","",N,N],[13,"LinkerPlugin","","",533,N],[13,"LinkerPluginAuto","","",533,N],[13,"Disabled","","",533,N],[4,"DebugInfo","","",N,N],[13,"None","","",534,N],[13,"Limited","","",534,N],[13,"Full","","",534,N],[4,"OutputType","","",N,N],[13,"Bitcode","","",535,N],[13,"Assembly","","",535,N],[13,"LlvmAssembly","","",535,N],[13,"Mir","","",535,N],[13,"Metadata","","",535,N],[13,"Object","","",535,N],[13,"Exe","","",535,N],[13,"DepInfo","","",535,N],[4,"ErrorOutputType","","",N,N],[13,"HumanReadable","","",536,N],[13,"Json","","",536,N],[13,"Short","","",536,N],[4,"PrintRequest","","",N,N],[13,"FileNames","","",537,N],[13,"Sysroot","","",537,N],[13,"CrateName","","",537,N],[13,"Cfg","","",537,N],[13,"TargetList","","",537,N],[13,"TargetCPUs","","",537,N],[13,"TargetFeatures","","",537,N],[13,"RelocationModels","","",537,N],[13,"CodeModels","","",537,N],[13,"TlsModels","","",537,N],[13,"TargetSpec","","",537,N],[13,"NativeStaticLibs","","",537,N],[4,"BorrowckMode","","",N,N],[13,"Ast","","",538,N],[13,"Mir","","",538,N],[13,"Compare","","",538,N],[13,"Migrate","","",538,N],[4,"Input","","",N,N],[13,"File","","Load source from file",539,N],[13,"Str","","",539,N],[12,"name","rustc::session::config::Input","String that is shown in place of a filename",539,N],[12,"input","","Anonymous source string",539,N],[4,"EntryFnType","rustc::session::config","",N,N],[13,"Main","","",540,N],[13,"Start","","",540,N],[4,"CrateType","","",N,N],[13,"Executable","","",541,N],[13,"Dylib","","",541,N],[13,"Rlib","","",541,N],[13,"Staticlib","","",541,N],[13,"Cdylib","","",541,N],[13,"ProcMacro","","",541,N],[4,"Passes","","",N,N],[13,"Some","","",542,N],[13,"All","","",542,N],[4,"OptionStability","","",N,N],[13,"Stable","","",543,N],[13,"Unstable","","",543,N],[5,"host_triple","","",N,[[],["str"]]],[5,"basic_codegen_options","","",N,[[],["codegenoptions"]]],[5,"build_codegen_options","","",N,[[["matches"],["erroroutputtype"]],["codegenoptions"]]],[5,"basic_debugging_options","","",N,[[],["debuggingoptions"]]],[5,"build_debugging_options","","",N,[[["matches"],["erroroutputtype"]],["debuggingoptions"]]],[5,"default_lib_output","","",N,[[],["cratetype"]]],[5,"default_configuration","","",N,[[["session"]],["crateconfig"]]],[5,"build_configuration","","",N,[[["session"],["crateconfig"]],["crateconfig"]]],[5,"build_target_config","","",N,[[["options"],["handler"]],["config"]]],[5,"rustc_short_optgroups","","Returns the \"short\" subset of the rustc command line options, including metadata for each option, such as whether the option is part of the stable long-term interface for rustc.",N,[[],["vec",["rustcoptgroup"]]]],[5,"rustc_optgroups","","Returns all rustc command line options, including metadata for each option, such as whether the option is part of the stable long-term interface for rustc.",N,[[],["vec",["rustcoptgroup"]]]],[5,"parse_cfgspecs","","",N,[[["vec",["string"]]],["crateconfig"]]],[5,"get_cmd_lint_options","","",N,N],[5,"build_session_options_and_crate_config","","",N,N],[5,"parse_crate_types_from_list","","",N,[[["vec",["string"]]],["result",["vec","string"]]]],[0,"cg_type_desc","","",N,N],[17,"parse_bool","rustc::session::config::cg_type_desc","",N,N],[17,"parse_opt_bool","","",N,N],[17,"parse_string","","",N,N],[17,"parse_string_push","","",N,N],[17,"parse_pathbuf_push","","",N,N],[17,"parse_opt_string","","",N,N],[17,"parse_opt_pathbuf","","",N,N],[17,"parse_list","","",N,N],[17,"parse_opt_list","","",N,N],[17,"parse_uint","","",N,N],[17,"parse_passes","","",N,N],[17,"parse_opt_uint","","",N,N],[17,"parse_panic_strategy","","",N,N],[17,"parse_relro_level","","",N,N],[17,"parse_sanitizer","","",N,N],[17,"parse_linker_flavor","","",N,N],[17,"parse_optimization_fuel","","",N,N],[17,"parse_unpretty","","",N,N],[17,"parse_lto","","",N,N],[17,"parse_cross_lang_lto","","",N,N],[0,"cgsetters","rustc::session::config","",N,N],[5,"ar","rustc::session::config::cgsetters","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"linker","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"link_arg","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"link_args","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"link_dead_code","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"lto","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"target_cpu","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"target_feature","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"passes","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"llvm_args","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"save_temps","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"rpath","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"overflow_checks","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_prepopulate_passes","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_vectorize_loops","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_vectorize_slp","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"soft_float","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"prefer_dynamic","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_integrated_as","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_redzone","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"relocation_model","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"code_model","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"metadata","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"extra_filename","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"codegen_units","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"remark","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"no_stack_check","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"debuginfo","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"opt_level","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"force_frame_pointers","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"debug_assertions","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"inline_threshold","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"panic","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"incremental","","",N,[[["codegenoptions"],["option",["str"]]],["bool"]]],[5,"parse_bool","","",N,[[["bool"],["option",["str"]]],["bool"]]],[5,"parse_opt_bool","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_opt_string","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_opt_pathbuf","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_string","","",N,[[["string"],["option",["str"]]],["bool"]]],[5,"parse_string_push","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_pathbuf_push","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_list","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_opt_list","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_uint","","",N,[[["usize"],["option",["str"]]],["bool"]]],[5,"parse_opt_uint","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_passes","","",N,[[["passes"],["option",["str"]]],["bool"]]],[5,"parse_panic_strategy","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_relro_level","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_sanitizer","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_linker_flavor","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_optimization_fuel","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_unpretty","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_lto","","",N,[[["ltocli"],["option",["str"]]],["bool"]]],[5,"parse_cross_lang_lto","","",N,[[["crosslanglto"],["option",["str"]]],["bool"]]],[0,"db_type_desc","rustc::session::config","",N,N],[17,"parse_bool","rustc::session::config::db_type_desc","",N,N],[17,"parse_opt_bool","","",N,N],[17,"parse_string","","",N,N],[17,"parse_string_push","","",N,N],[17,"parse_pathbuf_push","","",N,N],[17,"parse_opt_string","","",N,N],[17,"parse_opt_pathbuf","","",N,N],[17,"parse_list","","",N,N],[17,"parse_opt_list","","",N,N],[17,"parse_uint","","",N,N],[17,"parse_passes","","",N,N],[17,"parse_opt_uint","","",N,N],[17,"parse_panic_strategy","","",N,N],[17,"parse_relro_level","","",N,N],[17,"parse_sanitizer","","",N,N],[17,"parse_linker_flavor","","",N,N],[17,"parse_optimization_fuel","","",N,N],[17,"parse_unpretty","","",N,N],[17,"parse_lto","","",N,N],[17,"parse_cross_lang_lto","","",N,N],[0,"dbsetters","rustc::session::config","",N,N],[5,"codegen_backend","rustc::session::config::dbsetters","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"verbose","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"span_free_formats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"identify_regions","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"emit_end_regions","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"borrowck","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"two_phase_borrows","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"two_phase_beyond_autoref","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"time_passes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"count_llvm_insns","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"time_llvm_passes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"input_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"codegen_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"asm_comments","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"verify_llvm_ir","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"borrowck_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"no_landing_pads","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"fewer_names","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"meta_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_link_args","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_llvm_passes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"ast_json","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"query_threads","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"ast_json_noexpand","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"ls","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"save_analysis","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"flowgraph_print_loans","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"flowgraph_print_moves","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"flowgraph_print_assigns","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"flowgraph_print_all","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_region_graph","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"parse_only","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"no_codegen","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"treat_err_as_bug","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"report_delayed_bugs","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"external_macro_backtrace","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"teach","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"continue_parse_after_error","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental_queries","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental_info","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental_dump_hash","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental_verify_ich","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"incremental_ignore_spans","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dump_dep_graph","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"query_dep_graph","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"profile_queries","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"profile_queries_and_keys","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"no_analysis","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"extra_plugins","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"unstable_options","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"force_overflow_checks","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"trace_macros","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"debug_macros","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"keep_hygiene_data","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"keep_ast","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"show_span","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_type_sizes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_mono_items","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"mir_opt_level","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"mutable_noalias","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"arg_align_attributes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dump_mir","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dump_mir_dir","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dump_mir_graphviz","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dump_mir_exclude_pass_number","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"mir_emit_validate","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"perf_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"hir_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"mir_stats","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"always_encode_mir","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"osx_rpath_install_name","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"sanitizer","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"linker_flavor","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"fuel","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"print_fuel","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"force_unstable_if_unmarked","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"pre_link_arg","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"pre_link_args","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"profile","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"pgo_gen","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"pgo_use","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"disable_instrumentation_preinliner","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"relro_level","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"disable_ast_check_for_mutation_in_guard","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"nll_subminimal_causes","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"nll_facts","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"disable_nll_user_type_assert","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"nll_dont_emit_read_for_match","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"polonius","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"codegen_time_graph","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"thinlto","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"inline_in_all_cgus","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"tls_model","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"saturating_float_casts","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"lower_128bit_ops","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"human_readable_cgu_names","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"dep_info_omit_d_target","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"unpretty","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"run_dsymutil","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"ui_testing","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"embed_bitcode","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"strip_debuginfo_if_disabled","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"share_generics","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"chalk","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"cross_lang_lto","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"no_parallel_llvm","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"no_leak_check","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"crate_attr","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"self_profile","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"profile_json","","",N,[[["debuggingoptions"],["option",["str"]]],["bool"]]],[5,"parse_bool","","",N,[[["bool"],["option",["str"]]],["bool"]]],[5,"parse_opt_bool","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_opt_string","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_opt_pathbuf","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_string","","",N,[[["string"],["option",["str"]]],["bool"]]],[5,"parse_string_push","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_pathbuf_push","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_list","","",N,[[["vec"],["option",["str"]]],["bool"]]],[5,"parse_opt_list","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_uint","","",N,[[["usize"],["option",["str"]]],["bool"]]],[5,"parse_opt_uint","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_passes","","",N,[[["passes"],["option",["str"]]],["bool"]]],[5,"parse_panic_strategy","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_relro_level","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_sanitizer","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_linker_flavor","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_optimization_fuel","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_unpretty","","",N,[[["option"],["option",["str"]]],["bool"]]],[5,"parse_lto","","",N,[[["ltocli"],["option",["str"]]],["bool"]]],[5,"parse_cross_lang_lto","","",N,[[["crosslanglto"],["option",["str"]]],["bool"]]],[0,"opt","rustc::session::config","",N,N],[5,"stable","rustc::session::config::opt","",N,[[["str"],["f"]],["rustcoptgroup"]]],[5,"unstable","","",N,[[["str"],["f"]],["rustcoptgroup"]]],[5,"longer","","",N,[[["str"],["str"]],["str"]]],[5,"opt_s","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"multi_s","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flag_s","","",N,[[["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flagopt_s","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flagmulti_s","","",N,[[["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"opt","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"multi","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flag","","",N,[[["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flagopt","","",N,[[["str"],["str"],["str"],["str"]],["rustcoptgroup"]]],[5,"flagmulti","","",N,[[["str"],["str"],["str"]],["rustcoptgroup"]]],[6,"R","","",N,N],[6,"S","","",N,N],[0,"nightly_options","rustc::session::config","",N,N],[5,"is_unstable_enabled","rustc::session::config::nightly_options","",N,[[["matches"]],["bool"]]],[5,"is_nightly_build","","",N,[[],["bool"]]],[5,"check_nightly_options","","",N,N],[0,"dep_tracking","rustc::session::config","Commandline arguments passed to the compiler have to be incorporated with the dependency tracking system for incremental compilation. This module provides some utilities to make this more convenient.",N,N],[5,"stable_hash","rustc::session::config::dep_tracking","",N,[[["btreemap",["str","deptrackinghash"]],["defaulthasher"],["erroroutputtype"]]]],[8,"DepTrackingHash","","",N,N],[10,"hash","","",544,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","rustc::lint","",309,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","rustc::session::config","",541,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",542,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",530,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",532,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",534,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",522,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","rustc::middle::cstore","",343,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","rustc::session::config","",529,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"hash","","",533,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[6,"CodegenSetter","","",N,N],[6,"DebuggingSetter","","",N,N],[17,"RUST_CGU_EXT","","",N,N],[17,"CG_OPTIONS","","",N,N],[17,"DB_OPTIONS","","",N,N],[11,"clone","","",529,[[["self"]],["sanitizer"]]],[11,"hash","","",529,N],[11,"fmt","","",529,[[["self"],["formatter"]],["result"]]],[11,"clone","","",530,[[["self"]],["optlevel"]]],[11,"fmt","","",530,[[["self"],["formatter"]],["result"]]],[11,"eq","","",530,[[["self"],["optlevel"]],["bool"]]],[11,"hash","","",530,N],[11,"clone","","",531,[[["self"]],["lto"]]],[11,"eq","","",531,[[["self"],["lto"]],["bool"]]],[11,"hash","","",531,N],[11,"fmt","","",531,[[["self"],["formatter"]],["result"]]],[11,"clone","","",532,[[["self"]],["ltocli"]]],[11,"eq","","",532,[[["self"],["ltocli"]],["bool"]]],[11,"hash","","",532,N],[11,"fmt","","",532,[[["self"],["formatter"]],["result"]]],[11,"clone","","",533,[[["self"]],["crosslanglto"]]],[11,"eq","","",533,[[["self"],["crosslanglto"]],["bool"]]],[11,"ne","","",533,[[["self"],["crosslanglto"]],["bool"]]],[11,"hash","","",533,N],[11,"enabled","","",533,[[["self"]],["bool"]]],[11,"clone","","",534,[[["self"]],["debuginfo"]]],[11,"eq","","",534,[[["self"],["debuginfo"]],["bool"]]],[11,"hash","","",534,N],[11,"clone","","",535,[[["self"]],["outputtype"]]],[11,"eq","","",535,[[["self"],["outputtype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",535,N],[11,"hash","","",535,N],[11,"fmt","","",535,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",535,[[["self"],["outputtype"]],["option",["ordering"]]]],[11,"cmp","","",535,[[["self"],["outputtype"]],["ordering"]]],[11,"encode","","",535,[[["self"],["__s"]],["result"]]],[11,"decode","","",535,[[["__d"]],["result",["outputtype"]]]],[11,"hash_stable","","",535,[[["self"],["ctx"],["stablehasher"]]]],[11,"is_compatible_with_codegen_units_and_single_output_file","","",535,[[["self"]],["bool"]]],[11,"shorthand","","",535,[[["self"]],["str"]]],[11,"from_shorthand","","",535,[[["str"]],["option"]]],[11,"shorthands_display","","",535,[[],["string"]]],[11,"extension","","",535,[[["self"]],["str"]]],[11,"clone","","",536,[[["self"]],["erroroutputtype"]]],[11,"fmt","","",536,[[["self"],["formatter"]],["result"]]],[11,"eq","","",536,[[["self"],["erroroutputtype"]],["bool"]]],[11,"ne","","",536,[[["self"],["erroroutputtype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",536,N],[11,"default","","",536,[[],["erroroutputtype"]]],[11,"clone","","",522,[[["self"]],["outputtypes"]]],[11,"hash","","",522,N],[11,"hash_stable","","",522,[[["self"],["ctx"],["stablehasher"]]]],[11,"new","","",522,N],[11,"get","","",522,[[["self"],["outputtype"]],["option",["option"]]]],[11,"contains_key","","",522,[[["self"],["outputtype"]],["bool"]]],[11,"keys","","",522,[[["self"]],["btreemapkeysiter",["outputtype","option"]]]],[11,"values","","",522,[[["self"]],["btreemapvaluesiter",["outputtype","option"]]]],[11,"len","","",522,[[["self"]],["usize"]]],[11,"should_codegen","","",522,[[["self"]],["bool"]]],[11,"clone","","",523,[[["self"]],["externs"]]],[11,"hash","","",523,N],[11,"new","","",523,[[["btreemap",["string","btreeset"]]],["externs"]]],[11,"get","","",523,[[["self"],["str"]],["option",["btreeset"]]]],[11,"iter","","",523,[[["self"]],["btreemapiter",["string","btreeset"]]]],[11,"clone","","",524,[[["self"]],["options"]]],[11,"dep_tracking_hash","","",524,[[["self"]],["u64"]]],[11,"clone","","",537,[[["self"]],["printrequest"]]],[11,"eq","","",537,[[["self"],["printrequest"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",537,N],[11,"fmt","","",537,[[["self"],["formatter"]],["result"]]],[11,"clone","","",538,[[["self"]],["borrowckmode"]]],[11,"fmt","","",538,[[["self"],["formatter"]],["result"]]],[11,"eq","","",538,[[["self"],["borrowckmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",538,N],[11,"partial_cmp","","",538,[[["self"],["borrowckmode"]],["option",["ordering"]]]],[11,"cmp","","",538,[[["self"],["borrowckmode"]],["ordering"]]],[11,"hash","","",538,N],[11,"migrate","","Should we run the MIR-based borrow check, but also fall back on the AST borrow check if the MIR-based one errors.",538,[[["self"]],["bool"]]],[11,"use_ast","","Should we emit the AST-based borrow checker errors?",538,[[["self"]],["bool"]]],[11,"use_mir","","Should we emit the MIR-based borrow checker errors?",538,[[["self"]],["bool"]]],[11,"filestem","","",539,[[["self"]],["string"]]],[11,"get_input","","",539,[[["self"]],["option",["string"]]]],[11,"clone","","",525,[[["self"]],["outputfilenames"]]],[11,"hash","","",525,N],[11,"hash_stable","","",525,[[["self"],["ctx"],["stablehasher"]]]],[11,"path","","",525,[[["self"],["outputtype"]],["pathbuf"]]],[11,"temp_path","","Get the path where a compilation artifact of the given type for the given codegen unit should be placed on disk. If codegen_unit_name is None, a path distinct from those of any codegen unit will be generated.",525,[[["self"],["outputtype"],["option",["str"]]],["pathbuf"]]],[11,"temp_path_ext","","Like temp_path, but also supports things where there is no corresponding OutputType, like no-opt-bitcode or lto-bitcode.",525,[[["self"],["str"],["option",["str"]]],["pathbuf"]]],[11,"with_extension","","",525,[[["self"],["str"]],["pathbuf"]]],[11,"filestem","","",525,[[["self"]],["string"]]],[11,"default","","",524,[[],["options"]]],[11,"build_dep_graph","","True if there is a reason to build the dep graph.",524,[[["self"]],["bool"]]],[11,"enable_dep_node_debug_strs","","",524,[[["self"]],["bool"]]],[11,"file_path_mapping","","",524,[[["self"]],["filepathmapping"]]],[11,"will_create_output_file","","True if there will be an output file generated",524,[[["self"]],["bool"]]],[11,"share_generics","","",524,[[["self"]],["bool"]]],[11,"clone","","",540,[[["self"]],["entryfntype"]]],[11,"eq","","",540,[[["self"],["entryfntype"]],["bool"]]],[11,"eq","","",541,[[["self"],["cratetype"]],["bool"]]],[11,"partial_cmp","","",541,[[["self"],["cratetype"]],["option",["ordering"]]]],[11,"clone","","",541,[[["self"]],["cratetype"]]],[11,"cmp","","",541,[[["self"],["cratetype"]],["ordering"]]],[11,"assert_receiver_is_total_eq","","",541,N],[11,"hash","","",541,N],[11,"fmt","","",541,[[["self"],["formatter"]],["result"]]],[11,"clone","","",542,[[["self"]],["passes"]]],[11,"hash","","",542,N],[11,"is_empty","","",542,[[["self"]],["bool"]]],[11,"clone","","",526,[[["self"]],["codegenoptions"]]],[11,"hash","","",526,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"clone","","",527,[[["self"]],["debuggingoptions"]]],[11,"hash","","",527,[[["self"],["defaulthasher"],["erroroutputtype"]]]],[11,"clone","","",543,[[["self"]],["optionstability"]]],[11,"eq","","",543,[[["self"],["optionstability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",543,N],[11,"fmt","","",543,[[["self"],["formatter"]],["result"]]],[11,"is_stable","","",528,[[["self"]],["bool"]]],[11,"stable","","",528,[[["str"],["f"]],["rustcoptgroup"]]],[11,"unstable","","",528,[[["str"],["f"]],["rustcoptgroup"]]],[11,"fmt","","",541,[[["self"],["formatter"]],["result"]]],[0,"filesearch","rustc::session","",N,N],[3,"FileSearch","rustc::session::filesearch","",N,N],[12,"sysroot","","",545,N],[12,"search_paths","","",545,N],[12,"triple","","",545,N],[12,"kind","","",545,N],[4,"FileMatch","","",N,N],[13,"FileMatches","","",546,N],[13,"FileDoesntMatch","","",546,N],[5,"relative_target_lib_path","","",N,[[["path"],["str"]],["pathbuf"]]],[5,"make_target_lib_path","","",N,[[["path"],["str"]],["pathbuf"]]],[5,"get_or_default_sysroot","","",N,[[],["pathbuf"]]],[5,"find_libdir","","",N,[[["path"]],["cow",["str"]]]],[17,"RUST_LIB_DIR","","",N,N],[11,"clone","","",546,[[["self"]],["filematch"]]],[11,"for_each_lib_search_path","","",545,[[["self"],["f"]]]],[11,"get_lib_path","","",545,[[["self"]],["pathbuf"]]],[11,"search","","",545,[[["self"],["f"]]]],[11,"new","","",545,[[["path"],["str"],["searchpaths"],["pathkind"]],["filesearch"]]],[11,"get_dylib_search_paths","","",545,[[["self"]],["vec",["pathbuf"]]]],[11,"get_tools_search_paths","","",545,[[["self"]],["vec",["pathbuf"]]]],[0,"search_paths","rustc::session","",N,N],[3,"SearchPaths","rustc::session::search_paths","",N,N],[12,"paths","","",547,N],[3,"Iter","","",N,N],[12,"kind","","",548,N],[12,"iter","","",548,N],[4,"PathKind","","",N,N],[13,"Native","","",549,N],[13,"Crate","","",549,N],[13,"Dependency","","",549,N],[13,"Framework","","",549,N],[13,"ExternFlag","","",549,N],[13,"All","","",549,N],[11,"clone","","",547,[[["self"]],["searchpaths"]]],[11,"fmt","","",547,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",549,N],[11,"eq","","",549,[[["self"],["pathkind"]],["bool"]]],[11,"clone","","",549,[[["self"]],["pathkind"]]],[11,"fmt","","",549,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",549,[[["self"],["pathkind"]],["option",["ordering"]]]],[11,"cmp","","",549,[[["self"],["pathkind"]],["ordering"]]],[11,"hash","","",549,N],[11,"new","","",547,[[],["searchpaths"]]],[11,"add_path","","",547,[[["self"],["str"],["erroroutputtype"]]]],[11,"iter","","",547,[[["self"],["pathkind"]],["iter"]]],[11,"next","","",548,[[["self"]],["option"]]],[11,"size_hint","","",548,N],[6,"CompileResult","rustc::session","",N,N],[11,"clone","","",516,[[["self"]],["diagnosticmessageid"]]],[11,"fmt","","",516,[[["self"],["formatter"]],["result"]]],[11,"eq","","",516,[[["self"],["diagnosticmessageid"]],["bool"]]],[11,"ne","","",516,[[["self"],["diagnosticmessageid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",516,N],[11,"hash","","",516,N],[11,"from","","",516,[[["lint"]],["self"]]],[11,"local_crate_disambiguator","","",510,[[["self"]],["cratedisambiguator"]]],[11,"struct_span_warn","","",510,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_warn_with_code","","",510,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_warn","","",510,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err","","",510,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err_with_code","","",510,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_err","","",510,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_err_with_code","","",510,[[["self"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_span_fatal","","",510,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_fatal_with_code","","",510,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_fatal","","",510,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"span_fatal","","",510,N],[11,"span_fatal_with_code","","",510,N],[11,"fatal","","",510,N],[11,"span_err_or_warn","","",510,[[["self"],["bool"],["s"],["str"]]]],[11,"span_err","","",510,[[["self"],["s"],["str"]]]],[11,"span_err_with_code","","",510,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"err","","",510,[[["self"],["str"]]]],[11,"err_count","","",510,[[["self"]],["usize"]]],[11,"has_errors","","",510,[[["self"]],["bool"]]],[11,"abort_if_errors","","",510,[[["self"]]]],[11,"compile_status","","",510,[[["self"]],["result",["compileincomplete"]]]],[11,"track_errors","","",510,[[["self"],["f"]],["result",["errorreported"]]]],[11,"span_warn","","",510,[[["self"],["s"],["str"]]]],[11,"span_warn_with_code","","",510,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"warn","","",510,[[["self"],["str"]]]],[11,"opt_span_warn","","",510,[[["self"],["option"],["str"]]]],[11,"delay_span_bug","","Delay a span_bug() call until abort_if_errors()",510,[[["self"],["s"],["str"]]]],[11,"note_without_error","","",510,[[["self"],["str"]]]],[11,"span_note_without_error","","",510,[[["self"],["s"],["str"]]]],[11,"span_unimpl","","",510,N],[11,"unimpl","","",510,N],[11,"buffer_lint","","",510,[[["self"],["lint"],["nodeid"],["s"],["str"]]]],[11,"buffer_lint_with_diagnostic","","",510,[[["self"],["lint"],["nodeid"],["s"],["str"],["builtinlintdiagnostics"]]]],[11,"reserve_node_ids","","",510,[[["self"],["usize"]],["nodeid"]]],[11,"next_node_id","","",510,[[["self"]],["nodeid"]]],[11,"diagnostic","","",510,[[["self"]],["handler"]]],[11,"diag_once","","Analogous to calling methods on the given `DiagnosticBuilder`, but deduplicates on lint ID, span (if any), and message for this `Session`",510,[[["self"],["diagnosticbuilder"],["diagnosticbuildermethod"],["diagnosticmessageid"],["str"],["option",["span"]]]]],[11,"diag_span_note_once","","",510,[[["self"],["diagnosticbuilder"],["diagnosticmessageid"],["span"],["str"]]]],[11,"diag_note_once","","",510,[[["self"],["diagnosticbuilder"],["diagnosticmessageid"],["str"]]]],[11,"diag_span_suggestion_once","","",510,[[["self"],["diagnosticbuilder"],["diagnosticmessageid"],["span"],["str"],["string"]]]],[11,"source_map","","",510,[[["self"]],["sourcemap"]]],[11,"verbose","","",510,[[["self"]],["bool"]]],[11,"time_passes","","",510,[[["self"]],["bool"]]],[11,"profile_queries","","",510,[[["self"]],["bool"]]],[11,"profile_queries_and_keys","","",510,[[["self"]],["bool"]]],[11,"count_llvm_insns","","",510,[[["self"]],["bool"]]],[11,"time_llvm_passes","","",510,[[["self"]],["bool"]]],[11,"codegen_stats","","",510,[[["self"]],["bool"]]],[11,"meta_stats","","",510,[[["self"]],["bool"]]],[11,"asm_comments","","",510,[[["self"]],["bool"]]],[11,"verify_llvm_ir","","",510,[[["self"]],["bool"]]],[11,"borrowck_stats","","",510,[[["self"]],["bool"]]],[11,"print_llvm_passes","","",510,[[["self"]],["bool"]]],[11,"features_untracked","","Get the features enabled for the current compilation session. DO NOT USE THIS METHOD if there is a TyCtxt available, as it circumvents dependency tracking. Use tcx.features() instead.",510,[[["self"]],["features"]]],[11,"init_features","","",510,[[["self"],["features"]]]],[11,"lto","","Calculates the flavor of LTO to use for this compilation.",510,[[["self"]],["lto"]]],[11,"panic_strategy","","Returns the panic strategy for this compile session. If the user explicitly selected one using '-C panic', use that, otherwise use the panic strategy defined by the target.",510,[[["self"]],["panicstrategy"]]],[11,"fewer_names","","",510,[[["self"]],["bool"]]],[11,"no_landing_pads","","",510,[[["self"]],["bool"]]],[11,"unstable_options","","",510,[[["self"]],["bool"]]],[11,"overflow_checks","","",510,[[["self"]],["bool"]]],[11,"crt_static","","",510,[[["self"]],["bool"]]],[11,"crt_static_feature","","",510,[[["self"]],["bool"]]],[11,"must_not_eliminate_frame_pointers","","",510,[[["self"]],["bool"]]],[11,"generate_plugin_registrar_symbol","","Returns the symbol name for the registrar function, given the crate Svh and the function DefIndex.",510,[[["self"],["cratedisambiguator"]],["string"]]],[11,"generate_derive_registrar_symbol","","",510,[[["self"],["cratedisambiguator"]],["string"]]],[11,"sysroot","","",510,[[["self"]],["path"]]],[11,"target_filesearch","","",510,[[["self"],["pathkind"]],["filesearch"]]],[11,"host_filesearch","","",510,[[["self"],["pathkind"]],["filesearch"]]],[11,"set_incr_session_load_dep_graph","","",510,[[["self"],["bool"]]]],[11,"incr_session_load_dep_graph","","",510,[[["self"]],["bool"]]],[11,"init_incr_comp_session","","",510,[[["self"],["pathbuf"],["lock"],["bool"]]]],[11,"finalize_incr_comp_session","","",510,[[["self"],["pathbuf"]]]],[11,"mark_incr_comp_session_as_invalid","","",510,[[["self"]]]],[11,"incr_comp_session_dir","","",510,[[["self"]],["ref",["pathbuf"]]]],[11,"incr_comp_session_dir_opt","","",510,[[["self"]],["option",["ref"]]]],[11,"profiler","","",510,[[["self"],["f"]]]],[11,"print_profiler_results","","",510,[[["self"]]]],[11,"save_json_results","","",510,[[["self"]]]],[11,"print_perf_stats","","",510,[[["self"]]]],[11,"consider_optimizing","","We want to know if we're allowed to do an optimization for crate foo from -z fuel=foo=n. This expends fuel if applicable, and records fuel if applicable.",510,[[["self"],["str"],["t"]],["bool"]]],[11,"query_threads_from_opts","","Returns the number of query threads that should be used for this compilation",510,[[["options"]],["usize"]]],[11,"query_threads","","Returns the number of query threads that should be used for this compilation",510,[[["self"]],["usize"]]],[11,"codegen_units","","Returns the number of codegen units that should be used for this compilation",510,[[["self"]],["usize"]]],[11,"teach","","",510,[[["self"],["diagnosticid"]],["bool"]]],[11,"rust_2018","","Are we allowed to use features from the Rust 2018 edition?",510,[[["self"]],["bool"]]],[11,"edition","","",510,[[["self"]],["edition"]]],[11,"assert_receiver_is_total_eq","","",512,N],[11,"eq","","",512,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"ne","","",512,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"cmp","","",512,[[["self"],["cratedisambiguator"]],["ordering"]]],[11,"partial_cmp","","",512,[[["self"],["cratedisambiguator"]],["option",["ordering"]]]],[11,"lt","","",512,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"le","","",512,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"gt","","",512,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"ge","","",512,[[["self"],["cratedisambiguator"]],["bool"]]],[11,"hash","","",512,N],[11,"fmt","","",512,[[["self"],["formatter"]],["result"]]],[11,"clone","","",512,[[["self"]],["cratedisambiguator"]]],[11,"encode","","",512,[[["self"],["__s"]],["result"]]],[11,"decode","","",512,[[["__d"]],["result",["cratedisambiguator"]]]],[11,"to_fingerprint","","",512,[[["self"]],["fingerprint"]]],[11,"fmt","","",512,[[["self"],["formatter"]],["result",["error"]]]],[11,"from","","",512,[[["fingerprint"]],["cratedisambiguator"]]],[11,"hash_stable","","",512,[[["self"],["ctx"],["stablehasher"]]]],[11,"fmt","","",517,[[["self"],["formatter"]],["result"]]],[11,"clone","","",518,[[["self"]],["compileincomplete"]]],[11,"fmt","","",518,[[["self"],["formatter"]],["result"]]],[11,"from","","",518,[[["errorreported"]],["compileincomplete"]]],[0,"traits","rustc","Trait Resolution. See [rustc guide] for more info on how this works.",N,N],[3,"OverlapResult","rustc::traits","",N,N],[12,"impl_header","","",550,N],[12,"intercrate_ambiguity_causes","","",550,N],[3,"FulfillmentContext","","The fulfillment context is used to drive trait resolution.  It consists of a list of obligations that must be (eventually) satisfied. The job is to track which are satisfied, which yielded errors, and which are still pending. At any point, users can call `select_where_possible`, and the fulfillment context will try to do selection, retaining only those obligations that remain ambiguous. This may be helpful in pushing type inference along. Once all type inference constraints have been generated, the method `select_all_or_error` can be used to report any remaining ambiguous cases as errors.",N,N],[12,"predicates","","",551,N],[12,"register_region_obligations","","",551,N],[3,"PendingPredicateObligation","","",N,N],[12,"obligation","","",552,N],[12,"stalled_on","","",552,N],[3,"MismatchedProjectionTypes","","",N,N],[12,"err","","",553,N],[3,"ProjectionCache","","The projection cache. Unlike the standard caches, this can include infcx-dependent type variables - therefore, we have to roll the cache back each time we roll a snapshot back, to avoid assumptions on yet-unresolved inference variables. Types with skolemized regions also have to be removed when the respective snapshot ends.",N,N],[12,"map","","",554,N],[3,"ProjectionCacheSnapshot","","",N,N],[12,"snapshot","","",555,N],[3,"Normalized","","",N,N],[12,"value","","",556,N],[12,"obligations","","",556,N],[3,"OnUnimplementedDirective","","",N,N],[12,"condition","","",557,N],[12,"subcommands","","",557,N],[12,"message","","",557,N],[12,"label","","",557,N],[12,"note","","",557,N],[3,"OnUnimplementedNote","","",N,N],[12,"message","","",558,N],[12,"label","","",558,N],[12,"note","","",558,N],[3,"EvaluationCache","","",N,N],[12,"hashmap","","",559,N],[3,"SelectionContext","","",N,N],[12,"infcx","","",560,N],[12,"freshener","","Freshener used specifically for skolemizing entries on the obligation stack. This ensures that all entries on the stack at one time will have the same set of skolemized entries, which is important for checking for trait bounds that recursively require themselves.",560,N],[12,"intercrate","","If true, indicates that the evaluation should be conservative and consider the possibility of types outside this crate. This comes up primarily when resolving ambiguity. Imagine there is some trait reference `$0 : Bar` where `$0` is an inference variable. If `intercrate` is true, then we can never say for sure that this reference is not implemented, even if there are no impls at all for `Bar`, because `$0` could be bound to some type that in a downstream crate that implements `Bar`. This is the suitable mode for coherence. Elsewhere, though, we set this to false, because we are only interested in types that the user could actually have written --- in other words, we consider `$0 : Bar` to be unimplemented if there is no type that the user could actually name that would satisfy it. This avoids crippling inference, basically.",560,N],[12,"intercrate_ambiguity_causes","","",560,N],[12,"allow_negative_impls","","Controls whether or not to filter out negative impls when selecting. This is used in librustdoc to distinguish between the lack of an impl and a negative impl",560,N],[12,"query_mode","","The mode that trait queries run in, which informs our error handling policy. In essence, canonicalized queries need their errors propagated rather than immediately reported because we do not have accurate spans.",560,N],[3,"SelectionCache","","",N,N],[12,"hashmap","","",561,N],[3,"OverflowError","","Indicates that trait evaluation caused overflow.",N,N],[3,"OverlapError","","Information pertinent to an overlapping impl error.",N,N],[12,"with_impl","","",562,N],[12,"trait_desc","","",562,N],[12,"self_desc","","",562,N],[12,"intercrate_ambiguity_causes","","",562,N],[3,"SpecializesCache","","",N,N],[12,"map","","",563,N],[3,"SupertraitDefIds","","",N,N],[12,"tcx","","",564,N],[12,"stack","","",564,N],[12,"visited","","",564,N],[3,"Obligation","","An `Obligation` represents some trait reference (e.g. `int:Eq`) for which the vtable must be found.  The process of finding a vtable is called \"resolving\" the `Obligation`. This process consists of either identifying an `impl` (e.g., `impl Eq for int`) that provides the required vtable, or else finding a bound that is in scope. The eventual result is usually a `Selection` (defined below).",N,N],[12,"cause","","Why do we have to prove this thing?",565,N],[12,"param_env","","In which environment should we prove this thing?",565,N],[12,"predicate","","What are we trying to prove?",565,N],[12,"recursion_depth","","If we started proving this as a result of trying to prove something else, track the total depth to ensure termination. If this goes over a certain threshold, we abort compilation -- in such cases, we can not say whether or not the predicate holds for certain. Stupid halting problem. Such a drag.",565,N],[3,"ObligationCause","","Why did we incur this obligation? Used for error reporting.",N,N],[12,"span","","",566,N],[12,"body_id","","",566,N],[12,"code","","",566,N],[3,"DerivedObligationCause","","",N,N],[12,"parent_trait_ref","","The trait reference of the parent obligation that led to the current obligation. Note that only trait obligations lead to derived obligations, so we just store the trait reference here directly.",567,N],[12,"parent_code","","The parent trait had this cause",567,N],[3,"ProgramClause","","A \"program clause\" has the form `D :- G1, ..., Gn`. It is saying that the domain goal `D` is true if `G1...Gn` are provable. This is equivalent to the implication `G1..Gn => D`; we usually write it with the reverse implication operator `:-` to emphasize the way that programs are actually solved (via backchaining, which starts with the goal to solve and proceeds from there).",N,N],[12,"goal","","This goal will be considered true...",568,N],[12,"hypotheses","","...if we can prove these hypotheses (there may be no hypotheses at all):",568,N],[3,"FulfillmentError","","",N,N],[12,"obligation","","",569,N],[12,"code","","",569,N],[3,"VtableImplData","","Identifies a particular impl in the source, along with a set of substitutions from the impl's type/lifetime parameters. The `nested` vector corresponds to the nested obligations attached to the impl's type parameters.",N,N],[12,"impl_def_id","","",570,N],[12,"substs","","",570,N],[12,"nested","","",570,N],[3,"VtableGeneratorData","","",N,N],[12,"generator_def_id","","",571,N],[12,"substs","","",571,N],[12,"nested","","Nested obligations. This can be non-empty if the generator signature contains associated types.",571,N],[3,"VtableClosureData","","",N,N],[12,"closure_def_id","","",572,N],[12,"substs","","",572,N],[12,"nested","","Nested obligations. This can be non-empty if the closure signature contains associated types.",572,N],[3,"VtableAutoImplData","","",N,N],[12,"trait_def_id","","",573,N],[12,"nested","","",573,N],[3,"VtableBuiltinData","","",N,N],[12,"nested","","",574,N],[3,"VtableObjectData","","A vtable for some object-safe trait `Foo` automatically derived for the object type `Foo`.",N,N],[12,"upcast_trait_ref","","`Foo` upcast to the obligation trait. This will be some supertrait of `Foo`.",575,N],[12,"vtable_base","","The vtable is formed by concatenating together the method lists of the base object trait and all supertraits; this is the start of `upcast_trait_ref`'s methods in that vtable.",575,N],[12,"nested","","",575,N],[3,"VtableFnPointerData","","",N,N],[12,"fn_ty","","",576,N],[12,"nested","","",576,N],[4,"OrphanCheckErr","","",N,N],[13,"NoLocalInputType","","",577,N],[13,"UncoveredTy","","",577,N],[4,"Reveal","","Depending on the stage of compilation, we want projection to be more or less conservative.",N,N],[13,"UserFacing","","At type-checking time, we refuse to project any associated type that is marked `default`. Non-`default` (\"final\") types are always projected. This is necessary in general for soundness of specialization. However, we could allow projections in fully-monomorphic cases. We choose not to, because we prefer for `default type` to force the type definition to be treated abstractly by any consumers of the impl. Concretely, that means that the following example will fail to compile:",578,N],[13,"All","","At codegen time, all monomorphic projections will succeed. Also, `impl Trait` is normalized to the concrete type, which has to be already collected by type-checking.",578,N],[4,"ObjectSafetyViolation","","",N,N],[13,"SizedSelf","","Self : Sized declared on the trait",579,N],[13,"SupertraitSelf","","Supertrait reference references `Self` an in illegal location (e.g. `trait Foo : Bar<Self>`)",579,N],[13,"Method","","Method has something illegal",579,N],[13,"AssociatedConst","","Associated const",579,N],[4,"MethodViolationCode","","Reasons a method might not be object-safe.",N,N],[13,"StaticMethod","","e.g., `fn foo()`",580,N],[13,"ReferencesSelf","","e.g., `fn foo(&self, x: Self)` or `fn foo(&self) -> Self`",580,N],[13,"WhereClauseReferencesSelf","","e.g. `fn foo(&self) where Self: Clone`",580,N],[13,"Generic","","e.g., `fn foo<A>()`",580,N],[13,"NonStandardSelfType","","arbitrary `self` type, e.g. `self: Rc<Self>`",580,N],[4,"EvaluationResult","","The result of trait evaluation. The order is important here as the evaluation of a list is the maximum of the evaluations.",N,N],[13,"EvaluatedToOk","","Evaluation successful",581,N],[13,"EvaluatedToAmbig","","Evaluation is known to be ambiguous - it might hold for some assignment of inference variables, but it might not.",581,N],[13,"EvaluatedToUnknown","","Evaluation failed because of recursion involving inference variables. We are somewhat imprecise there, so we don't actually know the real result.",581,N],[13,"EvaluatedToRecur","","Evaluation failed because we encountered an obligation we are already trying to prove on this branch.",581,N],[13,"EvaluatedToErr","","Evaluation failed",581,N],[4,"IntercrateAmbiguityCause","","",N,N],[13,"DownstreamCrate","","",582,N],[12,"trait_desc","rustc::traits::IntercrateAmbiguityCause","",582,N],[12,"self_desc","","",582,N],[13,"UpstreamCrateUpdate","rustc::traits","",582,N],[12,"trait_desc","rustc::traits::IntercrateAmbiguityCause","",582,N],[12,"self_desc","","",582,N],[4,"IntercrateMode","rustc::traits","",N,N],[13,"Issue43355","","",583,N],[13,"Fixed","","",583,N],[4,"TraitQueryMode","","",N,N],[13,"Standard","","",584,N],[13,"Canonical","","",584,N],[4,"ObligationCauseCode","","",N,N],[13,"MiscObligation","","Not well classified or should be obvious from span.",585,N],[13,"SliceOrArrayElem","","A slice or array is WF only if `T: Sized`",585,N],[13,"TupleElem","","A tuple is WF only if its middle elements are Sized",585,N],[13,"ProjectionWf","","This is the trait reference from the given projection",585,N],[13,"ItemObligation","","In an impl of trait X for type Y, type Y must also implement all supertraits of X.",585,N],[13,"ReferenceOutlivesReferent","","A type like `&'a T` is WF only if `T: 'a`.",585,N],[13,"ObjectTypeBound","","A type like `Box<Foo<'a> + 'b>` is WF only if `'b: 'a`.",585,N],[13,"ObjectCastObligation","","Obligation incurred due to an object cast.",585,N],[13,"AssignmentLhsSized","","L = X implies that L is Sized",585,N],[13,"TupleInitializerSized","","(x1, .., xn) must be Sized",585,N],[13,"StructInitializerSized","","S { ... } must be Sized",585,N],[13,"VariableType","","Type of each variable must be Sized",585,N],[13,"SizedArgumentType","","Argument type must be Sized",585,N],[13,"SizedReturnType","","Return type must be Sized",585,N],[13,"SizedYieldType","","Yield type must be Sized",585,N],[13,"RepeatVec","","[T,..n] --> T must be Copy",585,N],[13,"FieldSized","","Types of fields (other than the last, except for packed structs) in a struct must be sized.",585,N],[12,"adt_kind","rustc::traits::ObligationCauseCode","",585,N],[12,"last","","",585,N],[13,"ConstSized","rustc::traits","Constant expressions must be sized.",585,N],[13,"SharedStatic","","static items must have `Sync` type",585,N],[13,"BuiltinDerivedObligation","","",585,N],[13,"ImplDerivedObligation","","",585,N],[13,"CompareImplMethodObligation","","error derived when matching traits/impls; see ObligationCause for more details",585,N],[12,"item_name","rustc::traits::ObligationCauseCode","",585,N],[12,"impl_item_def_id","","",585,N],[12,"trait_item_def_id","","",585,N],[13,"ExprAssignable","rustc::traits","Checking that this expression can be assigned where it needs to be",585,N],[13,"MatchExpressionArm","","Computing common supertype in the arms of a match expression",585,N],[12,"arm_span","rustc::traits::ObligationCauseCode","",585,N],[12,"source","","",585,N],[13,"IfExpression","rustc::traits","Computing common supertype in an if expression",585,N],[13,"IfExpressionWithNoElse","","Computing common supertype of an if expression with no else counter-part",585,N],[13,"MainFunctionType","","`main` has wrong type",585,N],[13,"StartFunctionType","","`start` has wrong type",585,N],[13,"IntrinsicType","","intrinsic has wrong type",585,N],[13,"MethodReceiver","","method receiver",585,N],[13,"ReturnNoExpression","","`return` with no expression",585,N],[13,"ReturnType","","`return` with an expression",585,N],[13,"BlockTailExpression","","Block implicit return",585,N],[13,"TrivialBound","","#[feature(trivial_bounds)] is not enabled",585,N],[4,"WhereClause","","The following types: * `WhereClause` * `WellFormed` * `FromEnv` * `DomainGoal` * `Goal` * `Clause` are used for representing the trait system in the form of logic programming clauses. They are part of the interface for the chalk SLG solver.",N,N],[13,"Implemented","","",586,N],[13,"ProjectionEq","","",586,N],[13,"RegionOutlives","","",586,N],[13,"TypeOutlives","","",586,N],[4,"WellFormed","","",N,N],[13,"Trait","","",587,N],[13,"Ty","","",587,N],[4,"FromEnv","","",N,N],[13,"Trait","","",588,N],[13,"Ty","","",588,N],[4,"DomainGoal","","",N,N],[13,"Holds","","",589,N],[13,"WellFormed","","",589,N],[13,"FromEnv","","",589,N],[13,"Normalize","","",589,N],[4,"QuantifierKind","","",N,N],[13,"Universal","","",590,N],[13,"Existential","","",590,N],[4,"Goal","","",N,N],[13,"Implies","","",591,N],[13,"And","","",591,N],[13,"Not","","",591,N],[13,"DomainGoal","","",591,N],[13,"Quantified","","",591,N],[13,"CannotProve","","",591,N],[4,"Clause","","This matches the definition from Page 7 of \"A Proof Procedure for the Logic of Hereditary Harrop Formulas\".",N,N],[13,"Implies","","",592,N],[13,"ForAll","","",592,N],[4,"SelectionError","","",N,N],[13,"Unimplemented","","",593,N],[13,"OutputTypeParameterMismatch","","",593,N],[13,"TraitNotObjectSafe","","",593,N],[13,"ConstEvalFailure","","",593,N],[13,"Overflow","","",593,N],[4,"FulfillmentErrorCode","","",N,N],[13,"CodeSelectionError","","",594,N],[13,"CodeProjectionError","","",594,N],[13,"CodeSubtypeError","","",594,N],[13,"CodeAmbiguity","","",594,N],[4,"Vtable","","Given the successful resolution of an obligation, the `Vtable` indicates where the vtable comes from. Note that while we call this a \"vtable\", it does not necessarily indicate dynamic dispatch at runtime. `Vtable` instances just tell the compiler where to find methods, but in generic code those methods are typically statically dispatched -- only when an object is constructed is a `Vtable` instance reified into an actual vtable.",N,N],[13,"VtableImpl","","Vtable identifying a particular impl.",595,N],[13,"VtableAutoImpl","","Vtable for auto trait implementations This carries the information and nested obligations with regards to an auto implementation for a trait `Trait`. The nested obligations ensure the trait implementation holds for all the constituent types.",595,N],[13,"VtableParam","","Successful resolution to an obligation provided by the caller for some type parameter. The `Vec<N>` represents the obligations incurred from normalizing the where-clause (if any).",595,N],[13,"VtableObject","","Virtual calls through an object",595,N],[13,"VtableBuiltin","","Successful resolution for a builtin trait.",595,N],[13,"VtableClosure","","Vtable automatically generated for a closure. The def ID is the ID of the closure expression. This is a `VtableImpl` in spirit, but the impl is generated by the compiler and does not appear in the source.",595,N],[13,"VtableFnPointer","","Same as above, but for a fn pointer type with the given signature.",595,N],[13,"VtableGenerator","","Vtable automatically generated for a generator",595,N],[5,"orphan_check","","Checks the coherence orphan rules. `impl_def_id` should be the def-id of a trait impl. To pass, either the trait must be local, or else two conditions must be satisfied:",N,[[["tyctxt"],["defid"]],["result",["orphancheckerr"]]]],[5,"overlapping_impls","","If there are types that satisfy both impls, invokes `on_overlap` with a suitably-freshened `ImplHeader` with those types substituted. Otherwise, invokes `no_overlap`.",N,[[["tyctxt"],["defid"],["defid"],["intercratemode"],["f1"],["f2"]],["r"]]],[5,"normalize","","Normalizes any associated type projections in `value`, replacing them with a fully resolved type where possible. The return value combines the normalized result and any additional obligations that were incurred as result.",N,[[["selectioncontext"],["paramenv"],["obligationcause"],["t"]],["normalized"]]],[5,"normalize_projection_type","","The guts of `normalize`: normalize a specific projection like `<T as Trait>::Item`. The result is always a type (and possibly additional obligations). If ambiguity arises, which implies that there are unresolved type variables in the projection, we will substitute a fresh type variable `$X` and generate a new obligation `<T as Trait>::Item == $X` for later.",N,[[["selectioncontext"],["paramenv"],["projectionty"],["obligationcause"],["usize"],["vec"]],["ty"]]],[5,"poly_project_and_unify_type","","Evaluates constraints of the form:",N,[[["selectioncontext"],["obligation"]],["result",["option","mismatchedprojectiontypes"]]]],[5,"translate_substs","","Given a subst for the requested impl, translate it to a subst appropriate for the actual item definition (whether it be in that impl, a parent impl, or the trait).",N,[[["inferctxt"],["paramenv"],["defid"],["substs"],["node"]],["substs"]]],[5,"find_associated_item","","Given a selected impl described by `impl_data`, returns the definition and substitutions for the method with the name `name` the kind `kind`, and trait method substitutions `substs`, in that impl, a less specialized impl, or the trait default, whichever applies.",N,N],[5,"elaborate_predicates","","",N,[[["tyctxt"],["vec",["predicate"]]],["elaborator"]]],[5,"supertraits","","",N,[[["tyctxt"],["polytraitref"]],["supertraits"]]],[5,"supertrait_def_ids","","",N,[[["tyctxt"],["defid"]],["supertraitdefids"]]],[5,"transitive_bounds","","",N,N],[5,"predicates_for_generics","","Creates predicate obligations from the generic bounds.",N,[[["obligationcause"],["paramenv"],["instantiatedpredicates"]],["predicateobligations"]]],[5,"type_known_to_meet_bound","","Determines whether the type `ty` is known to meet `bound` and returns true if so. Returns false if `ty` either does not meet `bound` or is not known to meet bound (note that this is conservative towards no impl, which is the opposite of the `evaluate` methods).",N,[[["inferctxt"],["paramenv"],["ty"],["defid"],["span"]],["bool"]]],[5,"normalize_param_env_or_error","","Normalizes the parameter environment, reporting errors if they occur.",N,[[["tyctxt"],["defid"],["paramenv"],["obligationcause"]],["paramenv"]]],[5,"fully_normalize","","",N,[[["inferctxt"],["fulfillmentcontext"],["obligationcause"],["paramenv"],["t"]],["result",["vec"]]]],[5,"normalize_and_test_predicates","","Normalizes the predicates and checks whether they hold in an empty environment. If this returns false, then either normalize encountered an error or one of the predicates did not hold. Used when creating vtables to check for unsatisfiable methods.",N,[[["tyctxt"],["vec",["predicate"]]],["bool"]]],[5,"substitute_normalize_and_test_predicates","","",N,N],[5,"vtable_methods","","Given a trait `trait_ref`, iterates the vtable entries that come from `trait_ref`, including its supertraits.",N,[[["tyctxt"],["polytraitref"]],["lrc",["vec"]]]],[5,"provide","","",N,[[["providers"]]]],[0,"specialization_graph","","",N,N],[3,"Graph","rustc::traits::specialization_graph","A per-trait graph of impls in specialization order. At the moment, this graph forms a tree rooted with the trait itself, with all other nodes representing impls, and parent-child relationships representing specializations.",N,N],[12,"parent","","",596,N],[12,"children","","",596,N],[3,"Ancestors","","",N,N],[12,"trait_def_id","","",597,N],[12,"specialization_graph","","",597,N],[12,"current_source","","",597,N],[3,"NodeItem","","",N,N],[12,"node","","",598,N],[12,"item","","",598,N],[4,"Node","","A node in the specialization graph is either an impl or a trait definition; either can serve as a source of item definitions. There is always exactly one trait definition node: the root.",N,N],[13,"Impl","","",599,N],[13,"Trait","","",599,N],[5,"ancestors","","Walk up the specialization ancestors of a given impl, starting with that impl itself.",N,[[["tyctxt"],["defid"],["defid"]],["ancestors"]]],[0,"auto_trait","rustc::traits","Support code for rustdoc and external tools . You really don't want to be using this unless you need to.",N,N],[3,"RegionDeps","rustc::traits::auto_trait","",N,N],[12,"larger","","",600,N],[12,"smaller","","",600,N],[3,"AutoTraitInfo","","",N,N],[12,"full_user_env","","",601,N],[12,"region_data","","",601,N],[12,"names_map","","",601,N],[12,"vid_to_region","","",601,N],[3,"AutoTraitFinder","","",N,N],[12,"tcx","","",602,N],[3,"RegionReplacer","","",N,N],[12,"vid_to_region","","",603,N],[12,"tcx","","",603,N],[4,"RegionTarget","","",N,N],[13,"Region","","",604,N],[13,"RegionVid","","",604,N],[4,"AutoTraitResult","","",N,N],[13,"ExplicitImpl","","",605,N],[13,"PositiveImpl","","",605,N],[13,"NegativeImpl","","",605,N],[11,"assert_receiver_is_total_eq","","",604,N],[11,"eq","","",604,[[["self"],["regiontarget"]],["bool"]]],[11,"ne","","",604,[[["self"],["regiontarget"]],["bool"]]],[11,"hash","","",604,N],[11,"clone","","",604,[[["self"]],["regiontarget"]]],[11,"fmt","","",604,[[["self"],["formatter"]],["result"]]],[11,"default","","",600,[[],["regiondeps"]]],[11,"fmt","","",600,[[["self"],["formatter"]],["result"]]],[11,"clone","","",600,[[["self"]],["regiondeps"]]],[11,"is_auto","","",605,[[["self"]],["bool"]]],[11,"new","","",602,[[["tyctxt"]],["self"]]],[11,"find_auto_trait_generics","","Make a best effort to determine whether and under which conditions an auto trait is implemented for a type. For example, if you have",602,N],[11,"evaluate_predicates","","",602,[[["self"],["inferctxt"],["defid"],["defid"],["ty"],["paramenv"],["paramenv"],["fxhashset"],["bool"]],["option"]]],[11,"add_user_pred","","",602,[[["self"],["fxhashset"],["predicate"]]]],[11,"region_name","","",602,[[["self"],["region"]],["option",["string"]]]],[11,"get_lifetime","","",602,[[["self"],["region"],["fxhashmap"]],["string"]]],[11,"map_vid_to_region","","",602,[[["self"],["regionconstraintdata"]],["fxhashmap",["regionvid","region"]]]],[11,"is_of_param","","",602,[[["self"],["substs"]],["bool"]]],[11,"evaluate_nested_obligations","","",602,[[["self"],["ty"],["t"],["fxhashset"],["fxhashset"],["vecdeque"],["selectioncontext"],["bool"]],["bool"]]],[11,"clean_pred","","",602,[[["self"],["inferctxt"],["predicate"]],["predicate"]]],[11,"tcx","","",603,[[["self"]],["tyctxt"]]],[11,"fold_region","","",603,[[["self"],["region"]],["region"]]],[0,"coherence","rustc::traits","See rustc guide chapters on [trait-resolution] and [trait-specialization] for more info on how this works.",N,N],[3,"OverlapResult","rustc::traits::coherence","",N,N],[12,"impl_header","","",550,N],[12,"intercrate_ambiguity_causes","","",550,N],[4,"InCrate","","Whether we do the orphan check relative to this crate or to some remote crate.",N,N],[13,"Local","","",606,N],[13,"Remote","","",606,N],[4,"Conflict","","",N,N],[13,"Upstream","","",607,N],[13,"Downstream","","",607,N],[12,"used_to_be_broken","rustc::traits::coherence::Conflict","",607,N],[4,"OrphanCheckErr","rustc::traits::coherence","",N,N],[13,"NoLocalInputType","","",577,N],[13,"UncoveredTy","","",577,N],[5,"overlapping_impls","","If there are types that satisfy both impls, invokes `on_overlap` with a suitably-freshened `ImplHeader` with those types substituted. Otherwise, invokes `no_overlap`.",N,[[["tyctxt"],["defid"],["defid"],["intercratemode"],["f1"],["f2"]],["r"]]],[5,"with_fresh_ty_vars","","",N,[[["selectioncontext"],["paramenv"],["defid"]],["implheader"]]],[5,"overlap","","Can both impl `a` and impl `b` be satisfied by a common type (including `where` clauses)? If so, returns an `ImplHeader` that unifies the two impls.",N,[[["selectioncontext"],["defid"],["defid"]],["option",["overlapresult"]]]],[5,"trait_ref_is_knowable","","",N,[[["tyctxt"],["traitref"]],["option",["conflict"]]]],[5,"trait_ref_is_local_or_fundamental","","",N,[[["tyctxt"],["traitref"]],["bool"]]],[5,"orphan_check","","Checks the coherence orphan rules. `impl_def_id` should be the def-id of a trait impl. To pass, either the trait must be local, or else two conditions must be satisfied:",N,[[["tyctxt"],["defid"]],["result",["orphancheckerr"]]]],[5,"orphan_check_trait_ref","","Check whether a trait-ref is potentially implementable by a crate.",N,[[["tyctxt"],["traitref"],["incrate"]],["result",["orphancheckerr"]]]],[5,"uncovered_tys","","",N,[[["tyctxt"],["ty"],["incrate"]],["vec",["ty"]]]],[5,"is_possibly_remote_type","","",N,[[["ty"],["incrate"]],["bool"]]],[5,"ty_is_local","","",N,[[["tyctxt"],["ty"],["incrate"]],["bool"]]],[5,"fundamental_ty","","",N,[[["tyctxt"],["ty"]],["bool"]]],[5,"def_id_is_local","","",N,[[["defid"],["incrate"]],["bool"]]],[5,"ty_is_local_constructor","","",N,[[["ty"],["incrate"]],["bool"]]],[11,"clone","","",606,[[["self"]],["incrate"]]],[11,"fmt","","",606,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",607,[[["self"],["formatter"]],["result"]]],[11,"clone","","",607,[[["self"]],["conflict"]]],[0,"error_reporting","rustc::traits","",N,N],[4,"ArgKind","rustc::traits::error_reporting","Summarizes information",N,N],[13,"Arg","","An argument of non-tuple type. Parameters are (name, ty)",608,N],[13,"Tuple","","An argument of tuple type. For a \"found\" argument, the span is the locationo in the source of the pattern. For a \"expected\" argument, it will be None. The vector is a list of (name, ty) strings for the components of the tuple.",608,N],[11,"report_fulfillment_errors","rustc::infer","",209,N],[11,"error_implies","","",209,[[["self"],["predicate"],["predicate"]],["bool"]]],[11,"report_fulfillment_error","","",209,[[["self"],["fulfillmenterror"],["option",["bodyid"]],["bool"]]]],[11,"report_projection_error","","",209,[[["self"],["predicateobligation"],["mismatchedprojectiontypes"]]]],[11,"fuzzy_match_tys","","",209,[[["self"],["ty"],["ty"]],["bool"]]],[11,"impl_similar_to","","",209,[[["self"],["polytraitref"],["predicateobligation"]],["option",["defid"]]]],[11,"on_unimplemented_note","","",209,[[["self"],["polytraitref"],["predicateobligation"]],["onunimplementednote"]]],[11,"find_similar_impl_candidates","","",209,[[["self"],["polytraitref"]],["vec",["traitref"]]]],[11,"report_similar_impl_candidates","","",209,[[["self"],["vec",["traitref"]],["diagnosticbuilder"]]]],[11,"report_overflow_error","","Reports that an overflow has occurred and halts compilation. We halt compilation unconditionally because it is important that overflows never be masked -- they basically represent computations whose result could not be truly determined and thus we can't say if the program type checks or not -- and they are unusual occurrences in any case.",209,N],[11,"report_overflow_error_cycle","","Reports that a cycle was detected which led to overflow and halts compilation. This is equivalent to `report_overflow_error` except that we can give a more helpful error message (and, in particular, we do not suggest increasing the overflow limit, which is not going to help).",209,N],[11,"report_extra_impl_obligation","","",209,[[["self"],["span"],["name"],["defid"],["defid"],["display"]],["diagnosticbuilder"]]],[11,"get_parent_trait_ref","","Get the parent trait chain start",209,[[["self"],["obligationcausecode"]],["option",["string"]]]],[11,"report_selection_error","","",209,[[["self"],["predicateobligation"],["selectionerror"],["bool"]]]],[11,"suggest_borrow_on_unsized_slice","","When encountering an assignment of an unsized trait, like `let x = \"\"[..];`, provide a suggestion to borrow the initializer in order to use have a slice instead.",209,[[["self"],["obligationcausecode"],["diagnosticbuilder"]]]],[11,"suggest_remove_reference","","Whenever references are used by mistake, like `for (i, e) in &vec.iter().enumerate()`, suggest removing these references until we reach a type that implements the trait.",209,[[["self"],["predicateobligation"],["diagnosticbuilder"],["binder"]]]],[11,"get_fn_like_arguments","","Given some node representing a fn-like thing in the HIR map, returns a span and `ArgKind` information that describes the arguments it expects. This can be supplied to `report_arg_count_mismatch`.",209,N],[11,"report_arg_count_mismatch","","Reports an error when the number of arguments needed by a trait match doesn't match the number that the expression provides.",209,[[["self"],["span"],["option",["span"]],["vec",["argkind"]],["vec",["argkind"]],["bool"]],["diagnosticbuilder"]]],[11,"report_closure_arg_mismatch","","",209,[[["self"],["span"],["option",["span"]],["polytraitref"],["polytraitref"]],["diagnosticbuilder"]]],[11,"maybe_report_ambiguity","","",209,[[["self"],["predicateobligation"],["option",["bodyid"]]]]],[11,"predicate_can_apply","","Returns whether the trait predicate may apply for some assignment to the type parameters.",209,[[["self"],["paramenv"],["polytraitref"]],["bool"]]],[11,"note_obligation_cause","","",209,[[["self"],["diagnosticbuilder"],["obligation"]]]],[11,"note_obligation_cause_code","","",209,[[["self"],["diagnosticbuilder"],["t"],["obligationcausecode"],["vec"]]]],[11,"suggest_new_overflow_limit","","",209,[[["self"],["diagnosticbuilder"]]]],[11,"is_recursive_obligation","","",209,[[["self"],["vec"],["obligationcausecode"]],["bool"]]],[11,"empty","rustc::traits::error_reporting","",608,[[],["argkind"]]],[11,"from_expected_ty","","Creates an `ArgKind` from the expected type of an argument. This has no name (`_`) and no source spans..",608,[[["ty"]],["argkind"]]],[0,"engine","rustc::traits","",N,N],[8,"TraitEngine","rustc::traits::engine","",N,N],[10,"normalize_projection_type","","",609,[[["self"],["inferctxt"],["paramenv"],["projectionty"],["obligationcause"]],["ty"]]],[10,"register_bound","","",609,[[["self"],["inferctxt"],["paramenv"],["ty"],["defid"],["obligationcause"]]]],[10,"register_predicate_obligation","","",609,[[["self"],["inferctxt"],["predicateobligation"]]]],[10,"select_all_or_error","","",609,[[["self"],["inferctxt"]],["result",["vec"]]]],[10,"select_where_possible","","",609,[[["self"],["inferctxt"]],["result",["vec"]]]],[10,"pending_obligations","","",609,[[["self"]],["vec",["predicateobligation"]]]],[8,"TraitEngineExt","","",N,N],[10,"register_predicate_obligations","","",610,N],[11,"new","","",609,[[["tyctxt"]],["box"]]],[0,"fulfill","rustc::traits","",N,N],[3,"FulfillmentContext","rustc::traits::fulfill","The fulfillment context is used to drive trait resolution.  It consists of a list of obligations that must be (eventually) satisfied. The job is to track which are satisfied, which yielded errors, and which are still pending. At any point, users can call `select_where_possible`, and the fulfillment context will try to do selection, retaining only those obligations that remain ambiguous. This may be helpful in pushing type inference along. Once all type inference constraints have been generated, the method `select_all_or_error` can be used to report any remaining ambiguous cases as errors.",N,N],[12,"predicates","","",551,N],[12,"register_region_obligations","","",551,N],[3,"PendingPredicateObligation","","",N,N],[12,"obligation","","",552,N],[12,"stalled_on","","",552,N],[3,"FulfillProcessor","","",N,N],[12,"selcx","","",611,N],[12,"register_region_obligations","","",611,N],[5,"mk_pending","","",N,[[["vec",["predicateobligation"]]],["vec",["pendingpredicateobligation"]]]],[5,"trait_ref_type_vars","","Return the set of type variables contained in a trait ref",N,[[["selectioncontext"],["polytraitref"]],["vec",["ty"]]]],[5,"to_fulfillment_error","","",N,[[["error",["pendingpredicateobligation","fulfillmenterrorcode"]]],["fulfillmenterror"]]],[11,"as_predicate","rustc::traits","",552,N],[11,"clone","","",552,[[["self"]],["pendingpredicateobligation"]]],[11,"fmt","","",552,[[["self"],["formatter"]],["result"]]],[11,"new","","Creates a new fulfillment context.",551,[[],["fulfillmentcontext"]]],[11,"new_ignoring_regions","","",551,[[],["fulfillmentcontext"]]],[11,"select","","Attempts to select obligations using `selcx`.",551,[[["self"],["selectioncontext"]],["result",["vec"]]]],[11,"normalize_projection_type","","\"Normalize\" a projection type `<SomeType as SomeTrait>::X` by creating a fresh type variable `$0` as well as a projection predicate `<SomeType as SomeTrait>::X == $0`. When the inference engine runs, it will attempt to find an impl of `SomeTrait` or a where clause that lets us unify `$0` with something concrete. If this fails, we'll unify `$0` with `projection_ty` again.",551,[[["self"],["inferctxt"],["paramenv"],["projectionty"],["obligationcause"]],["ty"]]],[11,"register_bound","","Requires that `ty` must implement the trait with `def_id` in the given environment. This trait must not have any type parameters (except for `Self`).",551,[[["self"],["inferctxt"],["paramenv"],["ty"],["defid"],["obligationcause"]]]],[11,"register_predicate_obligation","","",551,[[["self"],["inferctxt"],["predicateobligation"]]]],[11,"select_all_or_error","","",551,[[["self"],["inferctxt"]],["result",["vec"]]]],[11,"select_where_possible","","",551,[[["self"],["inferctxt"]],["result",["vec"]]]],[11,"pending_obligations","","",551,[[["self"]],["vec",["predicateobligation"]]]],[11,"process_obligation","rustc::traits::fulfill","Processes a predicate obligation and returns either: - `Changed(v)` if the predicate is true, presuming that `v` are also true - `Unchanged` if we don't have enough info to be sure - `Error(e)` if the predicate does not hold",611,N],[11,"process_backedge","","",611,[[["self"],["i"],["phantomdata",["pendingpredicateobligation"]]]]],[0,"project","rustc::traits","Code for projecting associated types out of trait references.",N,N],[3,"MismatchedProjectionTypes","rustc::traits::project","",N,N],[12,"err","","",553,N],[3,"AssociatedTypeNormalizer","","",N,N],[12,"selcx","","",612,N],[12,"param_env","","",612,N],[12,"cause","","",612,N],[12,"obligations","","",612,N],[12,"depth","","",612,N],[3,"Normalized","","",N,N],[12,"value","","",556,N],[12,"obligations","","",556,N],[3,"Progress","","",N,N],[12,"ty","","",613,N],[12,"obligations","","",613,N],[3,"ProjectionCache","","The projection cache. Unlike the standard caches, this can include infcx-dependent type variables - therefore, we have to roll the cache back each time we roll a snapshot back, to avoid assumptions on yet-unresolved inference variables. Types with skolemized regions also have to be removed when the respective snapshot ends.",N,N],[12,"map","","",554,N],[3,"ProjectionCacheKey","","",N,N],[12,"ty","","",614,N],[3,"ProjectionCacheSnapshot","","",N,N],[12,"snapshot","","",555,N],[4,"Reveal","","Depending on the stage of compilation, we want projection to be more or less conservative.",N,N],[13,"UserFacing","","At type-checking time, we refuse to project any associated type that is marked `default`. Non-`default` (\"final\") types are always projected. This is necessary in general for soundness of specialization. However, we could allow projections in fully-monomorphic cases. We choose not to, because we prefer for `default type` to force the type definition to be treated abstractly by any consumers of the impl. Concretely, that means that the following example will fail to compile:",578,N],[13,"All","","At codegen time, all monomorphic projections will succeed. Also, `impl Trait` is normalized to the concrete type, which has to be already collected by type-checking.",578,N],[4,"ProjectionTyError","","When attempting to resolve `<T as TraitRef>::Name` ...",N,N],[13,"TooManyCandidates","","...we found multiple sources of information and couldn't resolve the ambiguity.",615,N],[13,"TraitSelectionError","","...an error occurred matching `T : TraitRef`",615,N],[4,"ProjectionTyCandidate","","",N,N],[13,"ParamEnv","","",616,N],[13,"TraitDef","","",616,N],[13,"Select","","",616,N],[4,"ProjectionTyCandidateSet","","",N,N],[13,"None","","",617,N],[13,"Single","","",617,N],[13,"Ambiguous","","",617,N],[13,"Error","","",617,N],[4,"ProjectedTy","","",N,N],[13,"Progress","","",618,N],[13,"NoProgress","","",618,N],[4,"ProjectionCacheEntry","","",N,N],[13,"InProgress","","",619,N],[13,"Ambiguous","","",619,N],[13,"Error","","",619,N],[13,"NormalizedTy","","",619,N],[5,"poly_project_and_unify_type","","Evaluates constraints of the form:",N,[[["selectioncontext"],["obligation"]],["result",["option","mismatchedprojectiontypes"]]]],[5,"project_and_unify_type","","Evaluates constraints of the form:",N,[[["selectioncontext"],["obligation"]],["result",["option","mismatchedprojectiontypes"]]]],[5,"normalize","","Normalizes any associated type projections in `value`, replacing them with a fully resolved type where possible. The return value combines the normalized result and any additional obligations that were incurred as result.",N,[[["selectioncontext"],["paramenv"],["obligationcause"],["t"]],["normalized"]]],[5,"normalize_with_depth","","As `normalize`, but with a custom depth.",N,[[["selectioncontext"],["paramenv"],["obligationcause"],["usize"],["t"]],["normalized"]]],[5,"normalize_projection_type","","The guts of `normalize`: normalize a specific projection like `<T as Trait>::Item`. The result is always a type (and possibly additional obligations). If ambiguity arises, which implies that there are unresolved type variables in the projection, we will substitute a fresh type variable `$X` and generate a new obligation `<T as Trait>::Item == $X` for later.",N,[[["selectioncontext"],["paramenv"],["projectionty"],["obligationcause"],["usize"],["vec"]],["ty"]]],[5,"opt_normalize_projection_type","","The guts of `normalize`: normalize a specific projection like `<T as Trait>::Item`. The result is always a type (and possibly additional obligations). Returns `None` in the case of ambiguity, which indicates that there are unbound type variables.",N,[[["selectioncontext"],["paramenv"],["projectionty"],["obligationcause"],["usize"],["vec"]],["option",["ty"]]]],[5,"prune_cache_value_obligations","","If there are unresolved type variables, then we need to include any subobligations that bind them, at least until those type variables are fully resolved.",N,[[["inferctxt"],["normalized"]],["normalized",["ty"]]]],[5,"get_paranoid_cache_value_obligation","","Whenever we give back a cache result for a projection like `<T as Trait>::Item ==> X`, we always include the obligation to prove that `T: Trait` (we may also include some other obligations). This may or may not be necessary -- in principle, all the obligations that must be proven to show that `T: Trait` were also returned when the cache was first populated. But there are some vague concerns, and so we take the precautionary measure of including `T: Trait` in the result:",N,[[["inferctxt"],["paramenv"],["projectionty"],["obligationcause"],["usize"]],["predicateobligation"]]],[5,"normalize_to_error","","If we are projecting `<T as Trait>::Item`, but `T: Trait` does not hold. In various error cases, we cannot generate a valid normalized projection. Therefore, we create an inference variable return an associated obligation that, when fulfilled, will lead to an error.",N,[[["selectioncontext"],["paramenv"],["projectionty"],["obligationcause"],["usize"]],["normalized",["ty"]]]],[5,"project_type","","Compute the result of a projection type (if we can).",N,[[["selectioncontext"],["obligation"]],["result",["projectedty","projectiontyerror"]]]],[5,"assemble_candidates_from_param_env","","The first thing we have to do is scan through the parameter environment to see whether there are any projection predicates there that can answer this question.",N,[[["selectioncontext"],["obligation"],["traitref"],["projectiontycandidateset"]]]],[5,"assemble_candidates_from_trait_def","","In the case of a nested projection like <::FooT as Bar>::BarT, we may find that the definition of `Foo` has some clues:",N,[[["selectioncontext"],["obligation"],["traitref"],["projectiontycandidateset"]]]],[5,"assemble_candidates_from_predicates","","",N,N],[5,"assemble_candidates_from_impls","","",N,[[["selectioncontext"],["obligation"],["traitref"],["projectiontycandidateset"]]]],[5,"confirm_candidate","","",N,[[["selectioncontext"],["obligation"],["traitref"],["projectiontycandidate"]],["progress"]]],[5,"confirm_select_candidate","","",N,[[["selectioncontext"],["obligation"],["traitref"],["selection"]],["progress"]]],[5,"confirm_object_candidate","","",N,[[["selectioncontext"],["obligation"],["traitref"]],["progress"]]],[5,"confirm_generator_candidate","","",N,[[["selectioncontext"],["obligation"],["vtablegeneratordata",["predicateobligation"]]],["progress"]]],[5,"confirm_fn_pointer_candidate","","",N,[[["selectioncontext"],["obligation"],["vtablefnpointerdata",["predicateobligation"]]],["progress"]]],[5,"confirm_closure_candidate","","",N,[[["selectioncontext"],["obligation"],["vtableclosuredata",["predicateobligation"]]],["progress"]]],[5,"confirm_callable_candidate","","",N,[[["selectioncontext"],["obligation"],["polyfnsig"],["tupleargumentsflag"]],["progress"]]],[5,"confirm_param_env_candidate","","",N,[[["selectioncontext"],["obligation"],["polyprojectionpredicate"]],["progress"]]],[5,"confirm_impl_candidate","","",N,[[["selectioncontext"],["obligation"],["vtableimpldata",["predicateobligation"]]],["progress"]]],[5,"assoc_ty_def","","Locate the definition of an associated type in the specialization hierarchy, starting from the given impl.",N,[[["selectioncontext"],["defid"],["defid"]],["nodeitem",["associateditem"]]]],[6,"PolyProjectionObligation","","",N,N],[6,"ProjectionObligation","","",N,N],[6,"ProjectionTyObligation","","",N,N],[6,"NormalizedTy","","",N,N],[11,"fmt","rustc::traits","",578,[[["self"],["formatter"]],["result"]]],[11,"clone","","",578,[[["self"]],["reveal"]]],[11,"eq","","",578,[[["self"],["reveal"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",578,N],[11,"hash","","",578,N],[11,"fmt","rustc::traits::project","",615,[[["self"],["formatter"]],["result"]]],[11,"clone","rustc::traits","",553,[[["self"]],["mismatchedprojectiontypes"]]],[11,"eq","rustc::traits::project","",616,[[["self"],["projectiontycandidate"]],["bool"]]],[11,"ne","","",616,[[["self"],["projectiontycandidate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",616,N],[11,"fmt","","",616,[[["self"],["formatter"]],["result"]]],[11,"mark_ambiguous","","",617,[[["self"]]]],[11,"mark_error","","",617,[[["self"],["selectionerror"]]]],[11,"push_candidate","","",617,[[["self"],["projectiontycandidate"]],["bool"]]],[11,"new","","",612,[[["selectioncontext"],["paramenv"],["obligationcause"],["usize"]],["associatedtypenormalizer"]]],[11,"fold","","",612,[[["self"],["t"]],["t"]]],[11,"tcx","","",612,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",612,[[["self"],["ty"]],["ty"]]],[11,"fold_const","","",612,[[["self"],["const"]],["const"]]],[11,"clone","rustc::traits","",556,[[["self"]],["normalized"]]],[11,"with","","",556,[[["self"],["u"]],["normalized"]]],[11,"error","rustc::traits::project","",613,[[["tyctxt"]],["self"]]],[11,"with_addl_obligations","","",613,[[["self"],["vec",["predicateobligation"]]],["self"]]],[11,"clone","","",614,[[["self"]],["projectioncachekey"]]],[11,"fmt","","",614,[[["self"],["formatter"]],["result"]]],[11,"hash","","",614,N],[11,"eq","","",614,[[["self"],["projectioncachekey"]],["bool"]]],[11,"ne","","",614,[[["self"],["projectioncachekey"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",614,N],[11,"from_poly_projection_predicate","","",614,[[["selectioncontext"],["polyprojectionpredicate"]],["option"]]],[11,"clone","","",619,[[["self"]],["projectioncacheentry"]]],[11,"fmt","","",619,[[["self"],["formatter"]],["result"]]],[11,"new","rustc::traits","",554,[[],["self"]]],[11,"clear","","",554,[[["self"]]]],[11,"snapshot","","",554,[[["self"]],["projectioncachesnapshot"]]],[11,"rollback_to","","",554,[[["self"],["projectioncachesnapshot"]]]],[11,"rollback_skolemized","","",554,[[["self"],["projectioncachesnapshot"]]]],[11,"commit","","",554,[[["self"],["projectioncachesnapshot"]]]],[11,"try_start","","Try to start normalize `key`; returns an error if normalization already occurred (this error corresponds to a cache hit, so it's actually a good thing).",554,[[["self"],["projectioncachekey"]],["result",["projectioncacheentry"]]]],[11,"insert_ty","","Indicates that `key` was normalized to `value`.",554,[[["self"],["projectioncachekey"],["normalized",["ty"]]]]],[11,"complete","","Mark the relevant projection cache key as having its derived obligations complete, so they won't have to be re-computed (this is OK to do in a snapshot - if the snapshot is rolled back, the obligations will be marked as incomplete again).",554,[[["self"],["projectioncachekey"]]]],[11,"complete_normalized","","A specialized version of `complete` for when the key's value is known to be a NormalizedTy.",554,[[["self"],["projectioncachekey"],["normalized"]]]],[11,"ambiguous","","Indicates that trying to normalize `key` resulted in ambiguity. No point in trying it again then until we gain more type information (in which case, the \"fully resolved\" key will be different).",554,[[["self"],["projectioncachekey"]]]],[11,"error","","Indicates that trying to normalize `key` resulted in error.",554,[[["self"],["projectioncachekey"]]]],[0,"object_safety","","\"Object safety\" refers to the ability for a trait to be converted to an object. In general, traits may only be converted to an object if all of their methods meet certain criteria. In particular, they must:",N,N],[4,"ObjectSafetyViolation","rustc::traits::object_safety","",N,N],[13,"SizedSelf","","Self : Sized declared on the trait",579,N],[13,"SupertraitSelf","","Supertrait reference references `Self` an in illegal location (e.g. `trait Foo : Bar<Self>`)",579,N],[13,"Method","","Method has something illegal",579,N],[13,"AssociatedConst","","Associated const",579,N],[4,"MethodViolationCode","","Reasons a method might not be object-safe.",N,N],[13,"StaticMethod","","e.g., `fn foo()`",580,N],[13,"ReferencesSelf","","e.g., `fn foo(&self, x: Self)` or `fn foo(&self) -> Self`",580,N],[13,"WhereClauseReferencesSelf","","e.g. `fn foo(&self) where Self: Clone`",580,N],[13,"Generic","","e.g., `fn foo<A>()`",580,N],[13,"NonStandardSelfType","","arbitrary `self` type, e.g. `self: Rc<Self>`",580,N],[5,"is_object_safe_provider","","",N,[[["tyctxt"],["defid"]],["bool"]]],[11,"clone","rustc::traits","",579,[[["self"]],["objectsafetyviolation"]]],[11,"fmt","","",579,[[["self"],["formatter"]],["result"]]],[11,"eq","","",579,[[["self"],["objectsafetyviolation"]],["bool"]]],[11,"ne","","",579,[[["self"],["objectsafetyviolation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",579,N],[11,"hash","","",579,N],[11,"error_msg","","",579,[[["self"]],["cow",["str"]]]],[11,"clone","","",580,[[["self"]],["methodviolationcode"]]],[11,"fmt","","",580,[[["self"],["formatter"]],["result"]]],[11,"eq","","",580,[[["self"],["methodviolationcode"]],["bool"]]],[11,"ne","","",580,[[["self"],["methodviolationcode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",580,N],[11,"hash","","",580,N],[0,"on_unimplemented","","",N,N],[3,"OnUnimplementedFormatString","rustc::traits::on_unimplemented","",N,N],[12,"0","","",620,N],[3,"OnUnimplementedDirective","","",N,N],[12,"condition","","",557,N],[12,"subcommands","","",557,N],[12,"message","","",557,N],[12,"label","","",557,N],[12,"note","","",557,N],[3,"OnUnimplementedNote","","",N,N],[12,"message","","",558,N],[12,"label","","",558,N],[12,"note","","",558,N],[5,"parse_error","","",N,[[["tyctxt"],["span"],["str"],["str"],["option",["str"]]],["errorreported"]]],[11,"clone","","",620,[[["self"]],["onunimplementedformatstring"]]],[11,"fmt","","",620,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustc::traits","",557,[[["self"],["formatter"]],["result"]]],[11,"empty","","",558,[[],["self"]]],[11,"parse","","",557,N],[11,"of_item","","",557,[[["tyctxt"],["defid"],["defid"]],["result",["option","errorreported"]]]],[11,"evaluate","","",557,N],[11,"try_parse","rustc::traits::on_unimplemented","",620,[[["tyctxt"],["defid"],["localinternedstring"],["span"]],["result",["errorreported"]]]],[11,"verify","","",620,[[["self"],["tyctxt"],["defid"],["span"]],["result",["errorreported"]]]],[11,"format","","",620,[[["self"],["tyctxt"],["traitref"],["fxhashmap"]],["string"]]],[0,"select","rustc::traits","See [rustc guide] for more info on how this works.",N,N],[3,"SelectionContext","rustc::traits::select","",N,N],[12,"infcx","","",560,N],[12,"freshener","","Freshener used specifically for skolemizing entries on the obligation stack. This ensures that all entries on the stack at one time will have the same set of skolemized entries, which is important for checking for trait bounds that recursively require themselves.",560,N],[12,"intercrate","","If true, indicates that the evaluation should be conservative and consider the possibility of types outside this crate. This comes up primarily when resolving ambiguity. Imagine there is some trait reference `$0 : Bar` where `$0` is an inference variable. If `intercrate` is true, then we can never say for sure that this reference is not implemented, even if there are no impls at all for `Bar`, because `$0` could be bound to some type that in a downstream crate that implements `Bar`. This is the suitable mode for coherence. Elsewhere, though, we set this to false, because we are only interested in types that the user could actually have written --- in other words, we consider `$0 : Bar` to be unimplemented if there is no type that the user could actually name that would satisfy it. This avoids crippling inference, basically.",560,N],[12,"intercrate_ambiguity_causes","","",560,N],[12,"allow_negative_impls","","Controls whether or not to filter out negative impls when selecting. This is used in librustdoc to distinguish between the lack of an impl and a negative impl",560,N],[12,"query_mode","","The mode that trait queries run in, which informs our error handling policy. In essence, canonicalized queries need their errors propagated rather than immediately reported because we do not have accurate spans.",560,N],[3,"TraitObligationStack","","",N,N],[12,"obligation","","",621,N],[12,"fresh_trait_ref","","Trait ref from `obligation` but skolemized with the selection-context's freshener. Used to check for recursion.",621,N],[12,"previous","","",621,N],[3,"SelectionCache","","",N,N],[12,"hashmap","","",561,N],[3,"SelectionCandidateSet","","",N,N],[12,"vec","","",622,N],[12,"ambiguous","","",622,N],[3,"EvaluatedCandidate","","",N,N],[12,"candidate","","",623,N],[12,"evaluation","","",623,N],[3,"OverflowError","","Indicates that trait evaluation caused overflow.",N,N],[3,"EvaluationCache","","",N,N],[12,"hashmap","","",559,N],[3,"TraitObligationStackList","","",N,N],[12,"head","","",624,N],[3,"WithDepNode","","",N,N],[12,"dep_node","","",625,N],[12,"cached_value","","",625,N],[4,"IntercrateAmbiguityCause","","",N,N],[13,"DownstreamCrate","","",582,N],[12,"trait_desc","rustc::traits::select::IntercrateAmbiguityCause","",582,N],[12,"self_desc","","",582,N],[13,"UpstreamCrateUpdate","rustc::traits::select","",582,N],[12,"trait_desc","rustc::traits::select::IntercrateAmbiguityCause","",582,N],[12,"self_desc","","",582,N],[4,"SelectionCandidate","rustc::traits::select","The selection process begins by considering all impls, where clauses, and so forth that might resolve an obligation.  Sometimes we'll be able to say definitively that (e.g.) an impl does not apply to the obligation: perhaps it is defined for `usize` but the obligation is for `int`. In that case, we drop the impl out of the list.  But the other cases are considered candidates.",N,N],[13,"BuiltinCandidate","","If has_nested is false, there are no further obligations",626,N],[12,"has_nested","rustc::traits::select::SelectionCandidate","",626,N],[13,"ParamCandidate","rustc::traits::select","",626,N],[13,"ImplCandidate","","",626,N],[13,"AutoImplCandidate","","",626,N],[13,"ProjectionCandidate","","This is a trait matching with a projected type as `Self`, and we found an applicable bound in the trait definition.",626,N],[13,"ClosureCandidate","","Implementation of a `Fn`-family trait by one of the anonymous types generated for a `||` expression.",626,N],[13,"GeneratorCandidate","","Implementation of a `Generator` trait by one of the anonymous types generated for a generator.",626,N],[13,"FnPointerCandidate","","Implementation of a `Fn`-family trait by one of the anonymous types generated for a fn pointer type (e.g., `fn(int)->int`)",626,N],[13,"ObjectCandidate","","",626,N],[13,"BuiltinObjectCandidate","","",626,N],[13,"BuiltinUnsizeCandidate","","",626,N],[4,"BuiltinImplConditions","","When does the builtin impl for `T: Trait` apply?",N,N],[13,"Where","","The impl is conditional on T1,T2,.. : Trait",627,N],[13,"None","","There is no built-in impl. There may be some other candidate (a where-clause or user-defined impl).",627,N],[13,"Ambiguous","","It is unknown whether there is an impl.",627,N],[4,"EvaluationResult","","The result of trait evaluation. The order is important here as the evaluation of a list is the maximum of the evaluations.",N,N],[13,"EvaluatedToOk","","Evaluation successful",581,N],[13,"EvaluatedToAmbig","","Evaluation is known to be ambiguous - it might hold for some assignment of inference variables, but it might not.",581,N],[13,"EvaluatedToUnknown","","Evaluation failed because of recursion involving inference variables. We are somewhat imprecise there, so we don't actually know the real result.",581,N],[13,"EvaluatedToRecur","","Evaluation failed because we encountered an obligation we are already trying to prove on this branch.",581,N],[13,"EvaluatedToErr","","Evaluation failed",581,N],[11,"clone","rustc::traits","",582,[[["self"]],["intercrateambiguitycause"]]],[11,"fmt","","",582,[[["self"],["formatter"]],["result"]]],[11,"add_intercrate_ambiguity_hint","","Emits notes when the overlap is caused by complex intercrate ambiguities. See #23980 for details.",582,[[["self"],["diagnosticbuilder"]]]],[11,"intercrate_ambiguity_hint","","",582,[[["self"]],["string"]]],[11,"clone","","",561,[[["self"]],["selectioncache"]]],[11,"eq","rustc::traits::select","",626,[[["self"],["selectioncandidate"]],["bool"]]],[11,"ne","","",626,[[["self"],["selectioncandidate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",626,N],[11,"fmt","","",626,[[["self"],["formatter"]],["result"]]],[11,"clone","","",626,[[["self"]],["selectioncandidate"]]],[11,"lift_to_tcx","","",626,[[["self"],["tyctxt"]],["option"]]],[11,"eq","","",623,[[["self"],["evaluatedcandidate"]],["bool"]]],[11,"ne","","",623,[[["self"],["evaluatedcandidate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",623,N],[11,"fmt","","",623,[[["self"],["formatter"]],["result"]]],[11,"clone","","",623,[[["self"]],["evaluatedcandidate"]]],[11,"clone","rustc::traits","",581,[[["self"]],["evaluationresult"]]],[11,"fmt","","",581,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",581,[[["self"],["evaluationresult"]],["option",["ordering"]]]],[11,"cmp","","",581,[[["self"],["evaluationresult"]],["ordering"]]],[11,"eq","","",581,[[["self"],["evaluationresult"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",581,N],[11,"may_apply","","",581,[[["self"]],["bool"]]],[11,"is_stack_dependent","","",581,[[["self"]],["bool"]]],[11,"hash_stable","","",581,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",628,[[["self"]],["overflowerror"]]],[11,"fmt","","",628,[[["self"],["formatter"]],["result"]]],[11,"eq","","",628,[[["self"],["overflowerror"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",628,N],[11,"hash_stable","","",628,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"from","","",593,[[["overflowerror"]],["selectionerror"]]],[11,"clone","","",559,[[["self"]],["evaluationcache"]]],[11,"new","","",560,[[["inferctxt"]],["selectioncontext"]]],[11,"intercrate","","",560,[[["inferctxt"],["intercratemode"]],["selectioncontext"]]],[11,"with_negative","","",560,[[["inferctxt"],["bool"]],["selectioncontext"]]],[11,"with_query_mode","","",560,[[["inferctxt"],["traitquerymode"]],["selectioncontext"]]],[11,"enable_tracking_intercrate_ambiguity_causes","","Enables tracking of intercrate ambiguity causes. These are used in coherence to give improved diagnostics. We don't do this until we detect a coherence error because it can lead to false overflow results (#47139) and because it costs computation time.",560,[[["self"]]]],[11,"take_intercrate_ambiguity_causes","","Gets the intercrate ambiguity causes collected since tracking was enabled and disables tracking at the same time. If tracking is not enabled, just returns an empty vector.",560,[[["self"]],["vec",["intercrateambiguitycause"]]]],[11,"infcx","","",560,[[["self"]],["inferctxt"]]],[11,"tcx","","",560,[[["self"]],["tyctxt"]]],[11,"closure_typer","","",560,[[["self"]],["inferctxt"]]],[11,"in_snapshot","","Wraps the inference context's in_snapshot s.t. snapshot handling is only from the selection context's self.",560,[[["self"],["f"]],["r"]]],[11,"probe","","Wraps a probe s.t. obligations collected during it are ignored and old obligations are retained.",560,[[["self"],["f"]],["r"]]],[11,"commit_if_ok","","Wraps a commit_if_ok s.t. obligations collected during it are not returned in selection if the transaction fails and s.t. old obligations are retained.",560,[[["self"],["f"]],["result"]]],[11,"select","","Attempts to satisfy the obligation. If successful, this will affect the surrounding type environment by performing unification.",560,[[["self"],["traitobligation"]],["selectionresult",["selection"]]]],[11,"predicate_may_hold_fatal","","Evaluates whether the obligation `obligation` can be satisfied (by any means).",560,[[["self"],["predicateobligation"]],["bool"]]],[11,"evaluate_obligation_recursively","","Evaluates whether the obligation `obligation` can be satisfied and returns an `EvaluationResult`.",560,[[["self"],["predicateobligation"]],["result",["evaluationresult","overflowerror"]]]],[11,"evaluate_predicates_recursively","","Evaluates the predicates in `predicates` recursively. Note that this applies projections in the predicates, and therefore is run within an inference probe.",560,[[["self"],["traitobligationstacklist"],["i"]],["result",["evaluationresult","overflowerror"]]]],[11,"evaluate_predicate_recursively","","",560,[[["self"],["traitobligationstacklist"],["predicateobligation"]],["result",["evaluationresult","overflowerror"]]]],[11,"evaluate_trait_predicate_recursively","","",560,[[["self"],["traitobligationstacklist"],["traitobligation"]],["result",["evaluationresult","overflowerror"]]]],[11,"evaluate_stack","","",560,[[["self"],["traitobligationstack"]],["result",["evaluationresult","overflowerror"]]]],[11,"coinductive_match","","For defaulted traits, we use a co-inductive strategy to solve, so that recursion is ok. This routine returns true if the top of the stack (`cycle[0]`):",560,[[["self"],["i"]],["bool"]]],[11,"coinductive_predicate","","",560,[[["self"],["predicate"]],["bool"]]],[11,"evaluate_candidate","","Further evaluate `candidate` to decide whether all type parameters match and whether nested obligations are met. Returns true if `candidate` remains viable after this further scrutiny.",560,[[["self"],["traitobligationstack"],["selectioncandidate"]],["result",["evaluationresult","overflowerror"]]]],[11,"check_evaluation_cache","","",560,[[["self"],["paramenv"],["polytraitref"]],["option",["evaluationresult"]]]],[11,"insert_evaluation_cache","","",560,[[["self"],["paramenv"],["polytraitref"],["depnodeindex"],["evaluationresult"]]]],[11,"candidate_from_obligation","","",560,[[["self"],["traitobligationstack"]],["selectionresult",["selectioncandidate"]]]],[11,"in_task","","",560,N],[11,"filter_negative_impls","","",560,[[["self"],["selectioncandidate"]],["selectionresult",["selectioncandidate"]]]],[11,"candidate_from_obligation_no_cache","","",560,[[["self"],["traitobligationstack"]],["selectionresult",["selectioncandidate"]]]],[11,"is_knowable","","",560,[[["self"],["traitobligationstack"]],["option",["conflict"]]]],[11,"can_use_global_caches","","Returns true if the global caches can be used. Do note that if the type itself is not in the global tcx, the local caches will be used.",560,[[["self"],["paramenv"]],["bool"]]],[11,"check_candidate_cache","","",560,[[["self"],["paramenv"],["polytraitpredicate"]],["option",["selectionresult"]]]],[11,"insert_candidate_cache","","",560,[[["self"],["paramenv"],["polytraitpredicate"],["depnodeindex"],["selectionresult",["selectioncandidate"]]]]],[11,"assemble_candidates","","",560,[[["self"],["traitobligationstack"]],["result",["selectioncandidateset","selectionerror"]]]],[11,"assemble_candidates_from_projected_tys","","",560,[[["self"],["traitobligation"],["selectioncandidateset"]]]],[11,"match_projection_obligation_against_definition_bounds","","",560,[[["self"],["traitobligation"],["combinedsnapshot"]],["bool"]]],[11,"match_projection","","",560,[[["self"],["traitobligation"],["polytraitref"],["traitref"],["skolemizationmap"],["combinedsnapshot"]],["bool"]]],[11,"assemble_candidates_from_caller_bounds","","Given an obligation like `<SomeTrait for T>`, search the obligations that the caller supplied to find out whether it is listed among them.",560,[[["self"],["traitobligationstack"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"evaluate_where_clause","","",560,[[["self"],["traitobligationstack"],["polytraitref"]],["result",["evaluationresult","overflowerror"]]]],[11,"assemble_generator_candidates","","",560,[[["self"],["traitobligation"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"assemble_closure_candidates","","Check for the artificial impl that the compiler will create for an obligation like `X : FnMut<..>` where `X` is a closure type.",560,[[["self"],["traitobligation"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"assemble_fn_pointer_candidates","","Implement one of the `Fn()` family for a fn pointer.",560,[[["self"],["traitobligation"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"assemble_candidates_from_impls","","Search for impls that might apply to `obligation`.",560,[[["self"],["traitobligation"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"assemble_candidates_from_auto_impls","","",560,[[["self"],["traitobligation"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"assemble_candidates_from_object_ty","","Search for impls that might apply to `obligation`.",560,[[["self"],["traitobligation"],["selectioncandidateset"]]]],[11,"assemble_candidates_for_unsizing","","Search for unsizing that might apply to `obligation`.",560,[[["self"],["traitobligation"],["selectioncandidateset"]]]],[11,"candidate_should_be_dropped_in_favor_of","","Returns true if `victim` should be dropped in favor of `other`.  Generally speaking we will drop duplicate candidates and prefer where-clause candidates.",560,[[["self"],["evaluatedcandidate"],["evaluatedcandidate"]],["bool"]]],[11,"assemble_builtin_bound_candidates","","",560,[[["self"],["builtinimplconditions"],["selectioncandidateset"]],["result",["selectionerror"]]]],[11,"sized_conditions","","",560,[[["self"],["traitobligation"]],["builtinimplconditions"]]],[11,"copy_clone_conditions","","",560,[[["self"],["traitobligation"]],["builtinimplconditions"]]],[11,"constituent_types_for_ty","","For default impls, we need to break apart a type into its \"constituent types\" -- meaning, the types that it contains.",560,[[["self"],["ty"]],["vec",["ty"]]]],[11,"collect_predicates_for_types","","",560,[[["self"],["paramenv"],["obligationcause"],["usize"],["defid"],["binder",["vec"]]],["vec",["predicateobligation"]]]],[11,"confirm_candidate","","",560,[[["self"],["traitobligation"],["selectioncandidate"]],["result",["selection","selectionerror"]]]],[11,"confirm_projection_candidate","","",560,[[["self"],["traitobligation"]]]],[11,"confirm_param_candidate","","",560,[[["self"],["traitobligation"],["polytraitref"]],["vec",["predicateobligation"]]]],[11,"confirm_builtin_candidate","","",560,[[["self"],["traitobligation"],["bool"]],["vtablebuiltindata",["predicateobligation"]]]],[11,"confirm_auto_impl_candidate","","This handles the case where a `auto trait Foo` impl is being used. The idea is that the impl applies to `X : Foo` if the following conditions are met:",560,[[["self"],["traitobligation"],["defid"]],["vtableautoimpldata",["predicateobligation"]]]],[11,"vtable_auto_impl","","See `confirm_auto_impl_candidate`",560,[[["self"],["traitobligation"],["defid"],["binder",["vec"]]],["vtableautoimpldata",["predicateobligation"]]]],[11,"confirm_impl_candidate","","",560,[[["self"],["traitobligation"],["defid"]],["vtableimpldata",["predicateobligation"]]]],[11,"vtable_impl","","",560,[[["self"],["defid"],["normalized",["substs"]],["obligationcause"],["usize"],["paramenv"],["skolemizationmap"],["combinedsnapshot"]],["vtableimpldata",["predicateobligation"]]]],[11,"confirm_object_candidate","","",560,[[["self"],["traitobligation"]],["vtableobjectdata",["predicateobligation"]]]],[11,"confirm_fn_pointer_candidate","","",560,[[["self"],["traitobligation"]],["result",["vtablefnpointerdata","selectionerror"]]]],[11,"confirm_generator_candidate","","",560,[[["self"],["traitobligation"]],["result",["vtablegeneratordata","selectionerror"]]]],[11,"confirm_closure_candidate","","",560,[[["self"],["traitobligation"]],["result",["vtableclosuredata","selectionerror"]]]],[11,"confirm_poly_trait_refs","","In the case of closure types and fn pointers, we currently treat the input type parameters on the trait as outputs. This means that when we have a match we have only considered the self type, so we have to go back and make sure to relate the argument types too.  This is kind of wrong, but since we control the full set of impls, also not that wrong, and it DOES yield better error messages (since we don't report errors as if there is no applicable impl, but rather report errors are about mismatched argument types.",560,[[["self"],["obligationcause"],["paramenv"],["polytraitref"],["polytraitref"]],["result",["vec","selectionerror"]]]],[11,"confirm_builtin_unsize_candidate","","",560,[[["self"],["traitobligation"]],["result",["vtablebuiltindata","selectionerror"]]]],[11,"rematch_impl","","",560,N],[11,"match_impl","","",560,[[["self"],["defid"],["traitobligation"],["combinedsnapshot"]],["result"]]],[11,"fast_reject_trait_refs","","",560,[[["self"],["traitobligation"],["traitref"]],["bool"]]],[11,"match_where_clause_trait_ref","","Normalize `where_clause_trait_ref` and try to match it against `obligation`.  If successful, return any predicates that result from the normalization. Normalization is necessary because where-clauses are stored in the parameter environment unnormalized.",560,[[["self"],["traitobligation"],["polytraitref"]],["result",["vec"]]]],[11,"match_poly_trait_ref","","Returns `Ok` if `poly_trait_ref` being true implies that the obligation is satisfied.",560,[[["self"],["traitobligation"],["polytraitref"]],["result",["vec"]]]],[11,"match_fresh_trait_refs","","",560,[[["self"],["polytraitref"],["polytraitref"]],["bool"]]],[11,"push_stack","","",560,[[["self"],["traitobligationstacklist"],["traitobligation"]],["traitobligationstack"]]],[11,"closure_trait_ref_unnormalized","","",560,[[["self"],["traitobligation"],["defid"],["closuresubsts"]],["polytraitref"]]],[11,"generator_trait_ref_unnormalized","","",560,[[["self"],["traitobligation"],["defid"],["generatorsubsts"]],["polytraitref"]]],[11,"impl_or_trait_obligations","","Returns the obligations that are implied by instantiating an impl or trait. The obligations are substituted and fully normalized. This is used when confirming an impl or default impl.",560,[[["self"],["obligationcause"],["usize"],["paramenv"],["defid"],["substs"],["skolemizationmap"],["combinedsnapshot"]],["vec",["predicateobligation"]]]],[11,"new","","",561,[[],["selectioncache"]]],[11,"clear","","",561,[[["self"]]]],[11,"new","","",559,[[],["evaluationcache"]]],[11,"clear","","",559,[[["self"]]]],[11,"list","rustc::traits::select","",621,[[["self"]],["traitobligationstacklist"]]],[11,"iter","","",621,[[["self"]],["traitobligationstacklist"]]],[11,"clone","","",624,[[["self"]],["traitobligationstacklist"]]],[11,"empty","","",624,[[],["traitobligationstacklist"]]],[11,"with","","",624,[[["traitobligationstack"]],["traitobligationstacklist"]]],[11,"next","","",624,[[["self"]],["option",["traitobligationstack"]]]],[11,"fmt","","",621,[[["self"],["formatter"]],["result"]]],[11,"clone","","",625,[[["self"]],["withdepnode"]]],[11,"assert_receiver_is_total_eq","","",625,N],[11,"eq","","",625,[[["self"],["withdepnode"]],["bool"]]],[11,"ne","","",625,[[["self"],["withdepnode"]],["bool"]]],[11,"new","","",625,[[["depnodeindex"],["t"]],["self"]]],[11,"get","","",625,[[["self"],["tyctxt"]],["t"]]],[0,"specialize","rustc::traits","Logic and data structures related to impl specialization, explained in greater detail below.",N,N],[3,"OverlapError","rustc::traits::specialize","Information pertinent to an overlapping impl error.",N,N],[12,"with_impl","","",562,N],[12,"trait_desc","","",562,N],[12,"self_desc","","",562,N],[12,"intercrate_ambiguity_causes","","",562,N],[3,"SpecializesCache","","",N,N],[12,"map","","",563,N],[5,"translate_substs","","Given a subst for the requested impl, translate it to a subst appropriate for the actual item definition (whether it be in that impl, a parent impl, or the trait).",N,[[["inferctxt"],["paramenv"],["defid"],["substs"],["node"]],["substs"]]],[5,"find_associated_item","","Given a selected impl described by `impl_data`, returns the definition and substitutions for the method with the name `name` the kind `kind`, and trait method substitutions `substs`, in that impl, a less specialized impl, or the trait default, whichever applies.",N,N],[5,"specializes","","Is impl1 a specialization of impl2?",N,N],[5,"fulfill_implication","","Attempt to fulfill all obligations of `target_impl` after unification with `source_trait_ref`. If successful, returns a substitution for all the generics of `target_impl`, including both those needed to unify with `source_trait_ref` and those whose identity is determined via a where clause in the impl.",N,[[["inferctxt"],["paramenv"],["traitref"],["defid"]],["result",["substs"]]]],[5,"specialization_graph_provider","","",N,[[["tyctxt"],["defid"]],["lrc",["graph"]]]],[5,"to_pretty_impl_header","","Recovers the \"impl X for Y\" signature from `impl_def_id` and returns it as a string.",N,[[["tyctxt"],["defid"]],["option",["string"]]]],[0,"specialization_graph","","",N,N],[3,"Graph","rustc::traits::specialize::specialization_graph","A per-trait graph of impls in specialization order. At the moment, this graph forms a tree rooted with the trait itself, with all other nodes representing impls, and parent-child relationships representing specializations.",N,N],[12,"parent","","",596,N],[12,"children","","",596,N],[3,"Children","","Children of a given impl, grouped into blanket/non-blanket varieties as is done in `TraitDef`.",N,N],[12,"nonblanket_impls","","Impls of the trait.",629,N],[12,"blanket_impls","","Blanket impls associated with the trait.",629,N],[3,"Ancestors","","",N,N],[12,"trait_def_id","","",597,N],[12,"specialization_graph","","",597,N],[12,"current_source","","",597,N],[3,"NodeItem","","",N,N],[12,"node","","",598,N],[12,"item","","",598,N],[4,"Inserted","","The result of attempting to insert an impl into a group of children.",N,N],[13,"BecameNewSibling","","The impl was inserted as a new child in this group of children.",630,N],[13,"ReplaceChild","","The impl should replace an existing impl X, because the impl specializes X.",630,N],[13,"ShouldRecurseOn","","The impl is a specialization of an existing child.",630,N],[4,"Node","","A node in the specialization graph is either an impl or a trait definition; either can serve as a source of item definitions. There is always exactly one trait definition node: the root.",N,N],[13,"Impl","","",599,N],[13,"Trait","","",599,N],[5,"ancestors","","Walk up the specialization ancestors of a given impl, starting with that impl itself.",N,[[["tyctxt"],["defid"],["defid"]],["ancestors"]]],[22,"","","",N,N],[22,"","","",N,N],[11,"encode","rustc::traits::specialization_graph","",596,[[["self"],["__s"]],["result"]]],[11,"decode","","",596,[[["__d"]],["result",["graph"]]]],[11,"default","rustc::traits::specialize::specialization_graph","",629,[[],["children"]]],[11,"encode","","",629,[[["self"],["__s"]],["result"]]],[11,"decode","","",629,[[["__d"]],["result",["children"]]]],[11,"insert_blindly","","Insert an impl into this set of children without comparing to any existing impls",629,[[["self"],["tyctxt"],["defid"]]]],[11,"remove_existing","","Remove an impl from this set of children. Used when replacing an impl with a parent. The impl must be present in the list of children already.",629,[[["self"],["tyctxt"],["defid"]]]],[11,"insert","","Attempt to insert an impl into this set of children, while comparing for specialization relationships.",629,[[["self"],["tyctxt"],["defid"],["option",["simplifiedtype"]]],["result",["inserted","overlaperror"]]]],[11,"iter","","",629,[[["self"]],["box",["iterator"]]]],[11,"filtered","","",629,[[["self"],["simplifiedtype"]],["box",["iterator"]]]],[11,"new","rustc::traits::specialization_graph","",596,[[],["graph"]]],[11,"insert","","Insert a local impl into the specialization graph. If an existing impl conflicts with it (has overlap, but neither specializes the other), information about the area of overlap is returned in the `Err`.",596,[[["self"],["tyctxt"],["defid"]],["result",["option","overlaperror"]]]],[11,"record_impl_from_cstore","","Insert cached metadata mapping from a child impl back to its parent.",596,[[["self"],["tyctxt"],["defid"],["defid"]]]],[11,"parent","","The parent of a given impl, which is the def id of the trait when the impl is a \"specialization root\".",596,[[["self"],["defid"]],["defid"]]],[11,"fmt","","",599,[[["self"],["formatter"]],["result"]]],[11,"clone","","",599,[[["self"]],["node"]]],[11,"is_from_trait","","",599,[[["self"]],["bool"]]],[11,"items","","Iterate over the items defined directly by the given (impl or trait) node.",599,N],[11,"def_id","","",599,[[["self"]],["defid"]]],[11,"next","","",597,[[["self"]],["option",["node"]]]],[11,"map","","",598,[[["self"],["f"]],["nodeitem"]]],[11,"defs","","Search the items from the given ancestors, returning each definition with the given name and the given kind.",597,N],[11,"hash_stable","rustc::traits::specialize::specialization_graph","",629,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::traits::specialization_graph","",596,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","rustc::traits","",563,[[],["self"]]],[11,"check","","",563,[[["self"],["defid"],["defid"]],["option",["bool"]]]],[11,"insert","","",563,[[["self"],["defid"],["defid"],["bool"]]]],[0,"structural_impls","","",N,N],[11,"fmt","","",556,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",565,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",595,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",570,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",571,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",572,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",574,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",573,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",575,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",576,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",569,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",594,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",553,[[["self"],["formatter"]],["result"]]],[11,"lift_to_tcx","","",593,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",585,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",567,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",566,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",595,[[["self"],["tyctxt"]],["option"]]],[11,"super_fold_with","","",565,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",565,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",570,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",570,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",571,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",571,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",572,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",572,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",573,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",573,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",574,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",574,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",575,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",575,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",576,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",576,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",595,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",595,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",556,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",556,[[["self"],["v"]],["bool"]]],[11,"fmt","","",586,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",587,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",588,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",589,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",590,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",591,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",568,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",592,[[["self"],["formatter"]],["result"]]],[11,"super_fold_with","","",586,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",586,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",586,[[["self"],["tyctxt"]],["option",["whereclause"]]]],[11,"super_fold_with","","",587,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",587,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",587,[[["self"],["tyctxt"]],["option",["wellformed"]]]],[11,"super_fold_with","","",588,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",588,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",588,[[["self"],["tyctxt"]],["option",["fromenv"]]]],[11,"super_fold_with","","",589,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",589,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",589,[[["self"],["tyctxt"]],["option",["domaingoal"]]]],[11,"super_fold_with","","",590,[[["self"],["f"]],["quantifierkind"]]],[11,"super_visit_with","","",590,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",590,[[["self"],["tyctxt"]],["option"]]],[11,"super_fold_with","","",591,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",591,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",591,[[["self"],["tyctxt"]],["option",["goal"]]]],[11,"super_fold_with","","",568,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",568,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",592,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",592,[[["self"],["v"]],["bool"]]],[0,"codegen","","",N,N],[3,"TraitSelectionCache","rustc::traits::codegen","",N,N],[12,"data","","",631,N],[3,"ProjectionCache","","",N,N],[12,"data","","",632,N],[5,"codegen_fulfill_obligation","","Attempts to resolve an obligation to a vtable.. The result is a shallow vtable resolution -- meaning that we do not (necessarily) resolve all nested obligations on the impl. Note that type check should guarantee to us that all nested obligations could be resolved if we wanted to. Assumes that this is run after the entire crate has been successfully type-checked.",N,N],[11,"to_dep_kind","","",631,[[],["depkind"]]],[11,"to_dep_kind","","",632,[[],["depkind"]]],[11,"drain_fulfillment_cx_or_panic","rustc::infer","Finishes processes any obligations that remain in the fulfillment context, and then returns the result with all type variables removed and regions erased. Because this is intended for use after type-check has completed, if any errors occur, it will panic. It is used during normalization and other cases where processing the obligations in `fulfill_cx` may cause type inference variables that appear in `result` to be unified, and hence we need to process those obligations to get the complete picture of the type.",209,N],[0,"util","rustc::traits","",N,N],[3,"PredicateSet","rustc::traits::util","",N,N],[12,"tcx","","",633,N],[12,"set","","",633,N],[3,"Elaborator","","\"Elaboration\" is the process of identifying all the predicates that are implied by a source predicate. Currently this basically means walking the \"supertraits\" and other similar assumptions. For example, if we know that `T : Ord`, the elaborator would deduce that `T : PartialOrd` holds as well. Similarly, if we have `trait Foo : 'static`, and we know that `T : Foo`, then we know that `T : 'static`.",N,N],[12,"stack","","",634,N],[12,"visited","","",634,N],[3,"SupertraitDefIds","","",N,N],[12,"tcx","","",564,N],[12,"stack","","",564,N],[12,"visited","","",564,N],[3,"FilterToTraits","","A filter around an iterator of predicates that makes it yield up just trait references.",N,N],[12,"base_iterator","","",635,N],[4,"TupleArgumentsFlag","","",N,N],[13,"Yes","","",636,N],[13,"No","","",636,N],[5,"anonymize_predicate","","",N,[[["tyctxt"],["predicate"]],["predicate"]]],[5,"elaborate_trait_ref","","",N,[[["tyctxt"],["polytraitref"]],["elaborator"]]],[5,"elaborate_trait_refs","","",N,N],[5,"elaborate_predicates","","",N,[[["tyctxt"],["vec",["predicate"]]],["elaborator"]]],[5,"supertraits","","",N,[[["tyctxt"],["polytraitref"]],["supertraits"]]],[5,"transitive_bounds","","",N,N],[5,"supertrait_def_ids","","",N,[[["tyctxt"],["defid"]],["supertraitdefids"]]],[5,"impl_trait_ref_and_oblig","","Instantiate all bound parameters of the impl with the given substs, returning the resulting trait ref and all obligations that arise. The obligations are closed under normalization.",N,N],[5,"predicates_for_generics","","See `super::obligations_for_generics`",N,[[["obligationcause"],["usize"],["paramenv"],["instantiatedpredicates"]],["vec",["predicateobligation"]]]],[5,"predicate_for_trait_ref","","",N,[[["obligationcause"],["paramenv"],["traitref"],["usize"]],["predicateobligation"]]],[6,"Supertraits","","",N,N],[11,"new","","",633,[[["tyctxt"]],["predicateset"]]],[11,"insert","","",633,[[["self"],["predicate"]],["bool"]]],[11,"filter_to_traits","","",634,[[["self"]],["filtertotraits"]]],[11,"push","","",634,[[["self"],["predicate"]]]],[11,"size_hint","","",634,N],[11,"next","","",634,[[["self"]],["option",["predicate"]]]],[11,"next","rustc::traits","",564,[[["self"]],["option",["defid"]]]],[11,"new","rustc::traits::util","",635,[[["i"]],["filtertotraits"]]],[11,"next","","",635,[[["self"]],["option",["polytraitref"]]]],[11,"size_hint","","",635,N],[0,"query","rustc::traits","Experimental types for the trait query interface. The methods defined in this module are all based on canonicalization, which makes a canonical query by replacing unbound inference variables and regions, so that results can be reused more broadly. The providers for the queries defined here can be found in `librustc_traits`.",N,N],[3,"NoSolution","rustc::traits::query","",N,N],[0,"dropck_outlives","","",N,N],[3,"DropckOutlivesResult","rustc::traits::query::dropck_outlives","",N,N],[12,"kinds","","",637,N],[12,"overflows","","",637,N],[3,"DtorckConstraint","","A set of constraints that need to be satisfied in order for a type to be valid for destruction.",N,N],[12,"outlives","","Types that are required to be alive in order for this type to be valid for destruction.",638,N],[12,"dtorck_types","","Types that could not be resolved: projections and params.",638,N],[12,"overflows","","If, during the computation of the dtorck constraint, we overflow, that gets recorded here. The caller is expected to report an error.",638,N],[5,"trivial_dropck_outlives","","This returns true if the type `ty` is \"trivial\" for dropck-outlives -- that is, if it doesn't require any types to outlive. This is similar but not quite the same as the `needs_drop` test in the compiler already -- that is, for every type T for which this function return true, needs-drop would return false. But the reverse does not hold: in particular, `needs_drop` returns false for `PhantomData`, but it is not trivial for dropck-outlives.",N,[[["tyctxt"],["ty"]],["bool"]]],[11,"dropck_outlives","rustc::infer::at","Given a type `ty` of some value being dropped, computes a set of \"kinds\" (types, regions) that must be outlive the execution of the destructor. These basically correspond to data that the destructor might access. This is used during regionck to impose \"outlives\" constraints on any lifetimes referenced within.",224,[[["self"],["ty"]],["inferok",["vec"]]]],[11,"clone","rustc::traits::query::dropck_outlives","",637,[[["self"]],["dropckoutlivesresult"]]],[11,"fmt","","",637,[[["self"],["formatter"]],["result"]]],[11,"default","","",637,[[],["dropckoutlivesresult"]]],[11,"report_overflows","","",637,[[["self"],["tyctxt"],["span"],["ty"]]]],[11,"into_kinds_reporting_overflows","","",637,[[["self"],["tyctxt"],["span"],["ty"]],["vec",["kind"]]]],[11,"clone","","",638,[[["self"]],["dtorckconstraint"]]],[11,"fmt","","",638,[[["self"],["formatter"]],["result"]]],[11,"empty","","",638,[[],["dtorckconstraint"]]],[11,"from_iter","","",638,[[["i"]],["self"]]],[11,"super_fold_with","","",637,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",637,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",637,[[["self"],["tyctxt"]],["option",["dropckoutlivesresult"]]]],[11,"hash_stable","","",637,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",638,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"evaluate_obligation","rustc::traits::query","",N,N],[11,"predicate_may_hold","rustc::infer","Evaluates whether the predicate can be satisfied (by any means) in the given `ParamEnv`.",209,[[["self"],["predicateobligation"]],["bool"]]],[11,"predicate_must_hold","","Evaluates whether the predicate can be satisfied in the given `ParamEnv`, and returns `false` if not certain. However, this is not entirely accurate if inference variables are involved.",209,[[["self"],["predicateobligation"]],["bool"]]],[11,"evaluate_obligation","","Evaluate a given predicate, capturing overflow and propagating it back.",209,[[["self"],["predicateobligation"]],["result",["evaluationresult","overflowerror"]]]],[11,"evaluate_obligation_no_overflow","","",209,[[["self"],["predicateobligation"]],["evaluationresult"]]],[0,"normalize","rustc::traits::query","Code for the 'normalization' query. This consists of a wrapper which folds deeply, invoking the underlying `normalize_projection_ty` query when it encounters projections.",N,N],[3,"NormalizationResult","rustc::traits::query::normalize","Result from the `normalize_projection_ty` query.",N,N],[12,"normalized_ty","","Result of normalization.",639,N],[3,"QueryNormalizer","","",N,N],[12,"infcx","","",640,N],[12,"cause","","",640,N],[12,"param_env","","",640,N],[12,"obligations","","",640,N],[12,"error","","",640,N],[12,"anon_depth","","",640,N],[11,"normalize","rustc::infer::at","Normalize `value` in the context of the inference context, yielding a resulting type, or an error if `value` cannot be normalized. If you don't care about regions, you should prefer `normalize_erasing_regions`, which is more efficient.",224,[[["self"],["t"]],["result",["normalized","nosolution"]]]],[11,"clone","rustc::traits::query::normalize","",639,[[["self"]],["normalizationresult"]]],[11,"fmt","","",639,[[["self"],["formatter"]],["result"]]],[11,"tcx","","",640,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",640,[[["self"],["ty"]],["ty"]]],[11,"fold_const","","",640,[[["self"],["const"]],["const"]]],[11,"super_fold_with","","",639,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",639,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",639,[[["self"],["tyctxt"]],["option",["normalizationresult"]]]],[11,"hash_stable","","",639,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"normalize_erasing_regions","rustc::traits::query","Methods for normalizing when you don't care about regions (and aren't doing type inference). If either of those things don't apply to you, use `infcx.normalize(...)`.",N,N],[3,"NormalizeAfterErasingRegionsFolder","rustc::traits::query::normalize_erasing_regions","",N,N],[12,"tcx","","",641,N],[12,"param_env","","",641,N],[11,"tcx","","",641,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",641,[[["self"],["ty"]],["ty"]]],[0,"outlives_bounds","rustc::traits::query","",N,N],[4,"OutlivesBound","rustc::traits::query::outlives_bounds","Outlives bounds are relationships between generic parameters, whether they both be regions (`'a: 'b`) or whether types are involved (`T: 'a`).  These relationships can be extracted from the full set of predicates we understand or also from types (in which case they are called implied bounds). They are fed to the `OutlivesEnv` which in turn is supplied to the region checker and other parts of the inference system.",N,N],[13,"RegionSubRegion","","",642,N],[13,"RegionSubParam","","",642,N],[13,"RegionSubProjection","","",642,N],[5,"explicit_outlives_bounds","","",N,N],[22,"","","",N,N],[11,"clone","","",642,[[["self"]],["outlivesbound"]]],[11,"fmt","","",642,[[["self"],["formatter"]],["result"]]],[11,"lift_to_tcx","","",642,[[["self"],["tyctxt"]],["option",["outlivesbound"]]]],[11,"super_fold_with","","",642,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",642,[[["self"],["v"]],["bool"]]],[11,"hash_stable","","",642,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"implied_outlives_bounds","rustc::infer","Implied bounds are region relationships that we deduce automatically.  The idea is that (e.g.) a caller must check that a function's argument types are well-formed immediately before calling that fn, and hence the callee can assume that its argument types are well-formed. This may imply certain relationships between generic parameters. For example:",209,[[["self"],["paramenv"],["nodeid"],["ty"],["span"]],["vec",["outlivesbound"]]]],[0,"type_op","rustc::traits::query","",N,N],[0,"custom","rustc::traits::query::type_op","",N,N],[3,"CustomTypeOp","rustc::traits::query::type_op::custom","",N,N],[12,"closure","","",643,N],[12,"description","","",643,N],[5,"scrape_region_constraints","","Executes `op` and then scrapes out all the \"old style\" region constraints that result, creating query-region-constraints.",N,N],[11,"new","","",643,[[["f"],["g"]],["self"]]],[11,"fully_perform","","Processes the operation and all resulting obligations, returning the final result along with any region constraints (they will be given over to the NLL region solver).",643,[[["self"],["inferctxt"]],["fallible"]]],[11,"fmt","","",643,[[["self"],["formatter"]],["result"]]],[0,"eq","rustc::traits::query::type_op","",N,N],[3,"Eq","rustc::traits::query::type_op::eq","",N,N],[12,"a","","",644,N],[12,"b","","",644,N],[11,"clone","","",644,[[["self"]],["eq"]]],[11,"fmt","","",644,[[["self"],["formatter"]],["result"]]],[11,"hash","","",644,N],[11,"eq","","",644,[[["self"],["eq"]],["bool"]]],[11,"ne","","",644,[[["self"],["eq"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",644,N],[11,"new","","",644,[[["ty"],["ty"]],["self"]]],[11,"try_fast_path","","",644,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",644,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",644,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",644,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",644,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",644,[[["self"],["tyctxt"]],["option",["eq"]]]],[11,"hash_stable","","",644,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"implied_outlives_bounds","rustc::traits::query::type_op","",N,N],[3,"ImpliedOutlivesBounds","rustc::traits::query::type_op::implied_outlives_bounds","",N,N],[12,"ty","","",645,N],[11,"clone","","",645,[[["self"]],["impliedoutlivesbounds"]]],[11,"fmt","","",645,[[["self"],["formatter"]],["result"]]],[11,"hash","","",645,N],[11,"eq","","",645,[[["self"],["impliedoutlivesbounds"]],["bool"]]],[11,"ne","","",645,[[["self"],["impliedoutlivesbounds"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",645,N],[11,"new","","",645,[[["ty"]],["self"]]],[11,"try_fast_path","","",645,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",645,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",645,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",645,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",645,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",645,[[["self"],["tyctxt"]],["option",["impliedoutlivesbounds"]]]],[11,"hash_stable","","",645,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"normalize","rustc::traits::query::type_op","",N,N],[3,"Normalize","rustc::traits::query::type_op::normalize","",N,N],[12,"value","","",646,N],[8,"Normalizable","","",N,N],[10,"type_op_method","","",647,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[10,"shrink_to_tcx_lifetime","","Convert from the `'gcx` (lifted) form of `Self` into the `tcx` form of `Self`.",647,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"clone","","",646,[[["self"]],["normalize"]]],[11,"fmt","","",646,[[["self"],["formatter"]],["result"]]],[11,"hash","","",646,N],[11,"eq","","",646,[[["self"],["normalize"]],["bool"]]],[11,"ne","","",646,[[["self"],["normalize"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",646,N],[11,"new","","",646,[[["t"]],["self"]]],[11,"try_fast_path","","",646,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",646,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",646,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",646,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",646,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",646,[[["self"],["tyctxt"]],["option",["normalize"]]]],[11,"hash_stable","","",646,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"outlives","rustc::traits::query::type_op","",N,N],[3,"DropckOutlives","rustc::traits::query::type_op::outlives","",N,N],[12,"dropped_ty","","",648,N],[11,"clone","","",648,[[["self"]],["dropckoutlives"]]],[11,"fmt","","",648,[[["self"],["formatter"]],["result"]]],[11,"new","","",648,[[["ty"]],["self"]]],[11,"try_fast_path","","",648,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",648,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",648,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",648,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",648,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",648,[[["self"],["tyctxt"]],["option",["dropckoutlives"]]]],[11,"hash_stable","","",648,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"prove_predicate","rustc::traits::query::type_op","",N,N],[3,"ProvePredicate","rustc::traits::query::type_op::prove_predicate","",N,N],[12,"predicate","","",649,N],[11,"clone","","",649,[[["self"]],["provepredicate"]]],[11,"fmt","","",649,[[["self"],["formatter"]],["result"]]],[11,"hash","","",649,N],[11,"eq","","",649,[[["self"],["provepredicate"]],["bool"]]],[11,"ne","","",649,[[["self"],["provepredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",649,N],[11,"new","","",649,[[["predicate"]],["self"]]],[11,"try_fast_path","","",649,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",649,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",649,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",649,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",649,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",649,[[["self"],["tyctxt"]],["option",["provepredicate"]]]],[11,"hash_stable","","",649,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"subtype","rustc::traits::query::type_op","",N,N],[3,"Subtype","rustc::traits::query::type_op::subtype","",N,N],[12,"sub","","",650,N],[12,"sup","","",650,N],[11,"clone","","",650,[[["self"]],["subtype"]]],[11,"fmt","","",650,[[["self"],["formatter"]],["result"]]],[11,"hash","","",650,N],[11,"eq","","",650,[[["self"],["subtype"]],["bool"]]],[11,"ne","","",650,[[["self"],["subtype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",650,N],[11,"new","","",650,[[["ty"],["ty"]],["self"]]],[11,"try_fast_path","","",650,[[["tyctxt"],["paramenvand"]],["option"]]],[11,"perform_query","","",650,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",650,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"super_fold_with","","",650,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",650,[[["self"],["v"]],["bool"]]],[11,"lift_to_tcx","","",650,[[["self"],["tyctxt"]],["option",["subtype"]]]],[11,"hash_stable","","",650,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[8,"TypeOp","rustc::traits::query::type_op","\"Type ops\" are used in NLL to perform some particular action and extract out the resulting region constraints (or an error if it cannot be completed).",N,N],[16,"Output","","",651,N],[10,"fully_perform","","Processes the operation and all resulting obligations, returning the final result along with any region constraints (they will be given over to the NLL region solver).",651,[[["self"],["inferctxt"]],["fallible"]]],[8,"QueryTypeOp","","\"Query type ops\" are type ops that are implemented using a [canonical query][c]. The `Self` type here contains the kernel of information needed to do the operation -- `TypeOp` is actually implemented for `ParamEnvAnd<Self>`, since we always need to bring along a parameter environment as well. For query type-ops, we will first canonicalize the key and then invoke the query on the tcx, which produces the resulting query region constraints.",N,N],[16,"QueryResult","","",652,N],[10,"try_fast_path","","Give query the option for a simple fast path that never actually hits the tcx cache lookup etc. Return `Some(r)` with a final result or `None` to do the full path.",652,[[["tyctxt"],["paramenvand"]],["option"]]],[10,"perform_query","","Performs the actual query with the canonicalized key -- the real work happens here. This method is not given an `infcx` because it shouldn't need one -- and if it had access to one, it might do things like invoke `sub_regions`, which would be bad, because it would create subregion relationships that are not captured in the return value.",652,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[10,"shrink_to_tcx_lifetime","","Casts a lifted query result (which is in the gcx lifetime) into the tcx lifetime. This is always just an identity cast, but the generic code doesn't realize it -- put another way, in the generic code, we have a `Lifted<'gcx, Self::QueryResult>` and we want to convert that to a `Self::QueryResult`. This is not a priori valid, so we can't do it -- but in practice, it is always a no-op (e.g., the lifted form of a type, `Ty<'gcx>`, is a subtype of `Ty<'tcx>`). So we have to push the operation into the impls that know more specifically what `QueryResult` is. This operation would (maybe) be nicer with something like HKTs or GATs, since then we could make `QueryResult` parametric and `'gcx` and `'tcx` etc.",652,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"fully_perform_into","","",652,[[["paramenvand"],["inferctxt"],["vec"]],["fallible"]]],[6,"CanonicalProjectionGoal","rustc::traits::query","",N,N],[6,"CanonicalTyGoal","","",N,N],[6,"CanonicalPredicateGoal","","",N,N],[6,"CanonicalTypeOpEqGoal","","",N,N],[6,"CanonicalTypeOpSubtypeGoal","","",N,N],[6,"CanonicalTypeOpProvePredicateGoal","","",N,N],[6,"CanonicalTypeOpNormalizeGoal","","",N,N],[6,"Fallible","","",N,N],[11,"clone","","",653,[[["self"]],["nosolution"]]],[11,"fmt","","",653,[[["self"],["formatter"]],["result"]]],[11,"eq","","",653,[[["self"],["nosolution"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",653,N],[11,"hash","","",653,N],[11,"from","","",653,[[["typeerror"]],["nosolution"]]],[11,"hash_stable","","",653,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[6,"Supertraits","rustc::traits","",N,N],[6,"PredicateObligation","","",N,N],[6,"TraitObligation","","",N,N],[6,"Obligations","","",N,N],[6,"PredicateObligations","","",N,N],[6,"TraitObligations","","",N,N],[6,"PolyDomainGoal","","",N,N],[6,"Goals","","",N,N],[6,"Clauses","","Multiple clauses.",N,N],[6,"Selection","","",N,N],[6,"SelectionResult","","When performing resolution, it is typically the case that there can be one of three outcomes:",N,N],[8,"TraitEngine","","",N,N],[10,"normalize_projection_type","","",609,[[["self"],["inferctxt"],["paramenv"],["projectionty"],["obligationcause"]],["ty"]]],[10,"register_bound","","",609,[[["self"],["inferctxt"],["paramenv"],["ty"],["defid"],["obligationcause"]]]],[10,"register_predicate_obligation","","",609,[[["self"],["inferctxt"],["predicateobligation"]]]],[10,"select_all_or_error","","",609,[[["self"],["inferctxt"]],["result",["vec"]]]],[10,"select_where_possible","","",609,[[["self"],["inferctxt"]],["result",["vec"]]]],[10,"pending_obligations","","",609,[[["self"]],["vec",["predicateobligation"]]]],[8,"TraitEngineExt","","",N,N],[10,"register_predicate_obligations","","",610,N],[8,"ExClauseFold","","",N,N],[10,"fold_ex_clause_with","","",654,[[["exclause"],["f"]],["exclause"]]],[10,"visit_ex_clause_with","","",654,[[["exclause"],["v"]],["bool"]]],[8,"ExClauseLift","","",N,N],[16,"LiftedExClause","","",655,N],[10,"lift_ex_clause_to_tcx","","",655,[[["exclause"],["tyctxt"]],["option"]]],[11,"clone","","",583,[[["self"]],["intercratemode"]]],[11,"eq","","",583,[[["self"],["intercratemode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",583,N],[11,"fmt","","",583,[[["self"],["formatter"]],["result"]]],[11,"clone","","",584,[[["self"]],["traitquerymode"]]],[11,"eq","","",584,[[["self"],["traitquerymode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",584,N],[11,"fmt","","",584,[[["self"],["formatter"]],["result"]]],[11,"clone","","",565,[[["self"]],["obligation"]]],[11,"eq","","",565,[[["self"],["obligation"]],["bool"]]],[11,"ne","","",565,[[["self"],["obligation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",565,N],[11,"hash","","",565,N],[11,"clone","","",566,[[["self"]],["obligationcause"]]],[11,"fmt","","",566,[[["self"],["formatter"]],["result"]]],[11,"eq","","",566,[[["self"],["obligationcause"]],["bool"]]],[11,"ne","","",566,[[["self"],["obligationcause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",566,N],[11,"hash","","",566,N],[11,"span","","",566,[[["self"],["tyctxt"]],["span"]]],[11,"clone","","",585,[[["self"]],["obligationcausecode"]]],[11,"fmt","","",585,[[["self"],["formatter"]],["result"]]],[11,"eq","","",585,[[["self"],["obligationcausecode"]],["bool"]]],[11,"ne","","",585,[[["self"],["obligationcausecode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",585,N],[11,"hash","","",585,N],[11,"clone","","",567,[[["self"]],["derivedobligationcause"]]],[11,"fmt","","",567,[[["self"],["formatter"]],["result"]]],[11,"eq","","",567,[[["self"],["derivedobligationcause"]],["bool"]]],[11,"ne","","",567,[[["self"],["derivedobligationcause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",567,N],[11,"hash","","",567,N],[11,"clone","","",586,[[["self"]],["whereclause"]]],[11,"eq","","",586,[[["self"],["whereclause"]],["bool"]]],[11,"ne","","",586,[[["self"],["whereclause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",586,N],[11,"hash","","",586,N],[11,"fmt","","",586,[[["self"],["formatter"]],["result"]]],[11,"clone","","",587,[[["self"]],["wellformed"]]],[11,"eq","","",587,[[["self"],["wellformed"]],["bool"]]],[11,"ne","","",587,[[["self"],["wellformed"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",587,N],[11,"hash","","",587,N],[11,"fmt","","",587,[[["self"],["formatter"]],["result"]]],[11,"clone","","",588,[[["self"]],["fromenv"]]],[11,"eq","","",588,[[["self"],["fromenv"]],["bool"]]],[11,"ne","","",588,[[["self"],["fromenv"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",588,N],[11,"hash","","",588,N],[11,"fmt","","",588,[[["self"],["formatter"]],["result"]]],[11,"clone","","",589,[[["self"]],["domaingoal"]]],[11,"eq","","",589,[[["self"],["domaingoal"]],["bool"]]],[11,"ne","","",589,[[["self"],["domaingoal"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",589,N],[11,"hash","","",589,N],[11,"fmt","","",589,[[["self"],["formatter"]],["result"]]],[11,"clone","","",590,[[["self"]],["quantifierkind"]]],[11,"eq","","",590,[[["self"],["quantifierkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",590,N],[11,"hash","","",590,N],[11,"fmt","","",590,[[["self"],["formatter"]],["result"]]],[11,"clone","","",591,[[["self"]],["goal"]]],[11,"eq","","",591,[[["self"],["goal"]],["bool"]]],[11,"ne","","",591,[[["self"],["goal"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",591,N],[11,"hash","","",591,N],[11,"fmt","","",591,[[["self"],["formatter"]],["result"]]],[11,"into_goal","","",589,[[["self"]],["goal"]]],[11,"from_poly_domain_goal","","",591,[[["polydomaingoal"],["tyctxt"]],["goal"]]],[11,"clone","","",592,[[["self"]],["clause"]]],[11,"eq","","",592,[[["self"],["clause"]],["bool"]]],[11,"ne","","",592,[[["self"],["clause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",592,N],[11,"hash","","",592,N],[11,"fmt","","",592,[[["self"],["formatter"]],["result"]]],[11,"clone","","",568,[[["self"]],["programclause"]]],[11,"eq","","",568,[[["self"],["programclause"]],["bool"]]],[11,"ne","","",568,[[["self"],["programclause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",568,N],[11,"hash","","",568,N],[11,"fmt","","",568,[[["self"],["formatter"]],["result"]]],[11,"clone","","",593,[[["self"]],["selectionerror"]]],[11,"fmt","","",593,[[["self"],["formatter"]],["result"]]],[11,"clone","","",594,[[["self"]],["fulfillmenterrorcode"]]],[11,"clone","","",595,[[["self"]],["vtable"]]],[11,"eq","","",595,[[["self"],["vtable"]],["bool"]]],[11,"ne","","",595,[[["self"],["vtable"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",595,N],[11,"encode","","",595,[[["self"],["__sn"]],["result"]]],[11,"decode","","",595,[[["__dn"]],["result",["vtable"]]]],[11,"clone","","",570,[[["self"]],["vtableimpldata"]]],[11,"eq","","",570,[[["self"],["vtableimpldata"]],["bool"]]],[11,"ne","","",570,[[["self"],["vtableimpldata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",570,N],[11,"encode","","",570,[[["self"],["__sn"]],["result"]]],[11,"decode","","",570,[[["__dn"]],["result",["vtableimpldata"]]]],[11,"clone","","",571,[[["self"]],["vtablegeneratordata"]]],[11,"eq","","",571,[[["self"],["vtablegeneratordata"]],["bool"]]],[11,"ne","","",571,[[["self"],["vtablegeneratordata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",571,N],[11,"encode","","",571,[[["self"],["__sn"]],["result"]]],[11,"decode","","",571,[[["__dn"]],["result",["vtablegeneratordata"]]]],[11,"clone","","",572,[[["self"]],["vtableclosuredata"]]],[11,"eq","","",572,[[["self"],["vtableclosuredata"]],["bool"]]],[11,"ne","","",572,[[["self"],["vtableclosuredata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",572,N],[11,"encode","","",572,[[["self"],["__sn"]],["result"]]],[11,"decode","","",572,[[["__dn"]],["result",["vtableclosuredata"]]]],[11,"clone","","",573,[[["self"]],["vtableautoimpldata"]]],[11,"eq","","",573,[[["self"],["vtableautoimpldata"]],["bool"]]],[11,"ne","","",573,[[["self"],["vtableautoimpldata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",573,N],[11,"encode","","",573,[[["self"],["__sn"]],["result"]]],[11,"decode","","",573,[[["__dn"]],["result",["vtableautoimpldata"]]]],[11,"clone","","",574,[[["self"]],["vtablebuiltindata"]]],[11,"eq","","",574,[[["self"],["vtablebuiltindata"]],["bool"]]],[11,"ne","","",574,[[["self"],["vtablebuiltindata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",574,N],[11,"encode","","",574,[[["self"],["__sn"]],["result"]]],[11,"decode","","",574,[[["__dn"]],["result",["vtablebuiltindata"]]]],[11,"eq","","",575,[[["self"],["vtableobjectdata"]],["bool"]]],[11,"ne","","",575,[[["self"],["vtableobjectdata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",575,N],[11,"clone","","",575,[[["self"]],["vtableobjectdata"]]],[11,"encode","","",575,[[["self"],["__sn"]],["result"]]],[11,"decode","","",575,[[["__dn"]],["result",["vtableobjectdata"]]]],[11,"clone","","",576,[[["self"]],["vtablefnpointerdata"]]],[11,"eq","","",576,[[["self"],["vtablefnpointerdata"]],["bool"]]],[11,"ne","","",576,[[["self"],["vtablefnpointerdata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",576,N],[11,"encode","","",576,[[["self"],["__sn"]],["result"]]],[11,"decode","","",576,[[["__dn"]],["result",["vtablefnpointerdata"]]]],[11,"new","","",565,[[["obligationcause"],["paramenv"],["o"]],["obligation"]]],[11,"with_depth","","",565,[[["obligationcause"],["usize"],["paramenv"],["o"]],["obligation"]]],[11,"misc","","",565,[[["span"],["nodeid"],["paramenv"],["o"]],["obligation"]]],[11,"with","","",565,[[["self"],["p"]],["obligation"]]],[11,"new","","",566,[[["span"],["nodeid"],["obligationcausecode"]],["obligationcause"]]],[11,"misc","","",566,[[["span"],["nodeid"]],["obligationcause"]]],[11,"dummy","","",566,[[],["obligationcause"]]],[11,"nested_obligations","","",595,[[["self"]],["vec"]]],[11,"map","","",595,[[["self"],["f"]],["vtable"]]],[11,"new","","",569,[[["predicateobligation"],["fulfillmenterrorcode"]],["fulfillmenterror"]]],[11,"self_ty","","",656,[[["self"]],["binder",["ty"]]]],[0,"ty","rustc","",N,N],[3,"Binder","rustc::ty","Binder is a binder for higher-ranked lifetimes. It is part of the compiler's representation for things like `for<'a> Fn(&'a isize)` (which would be represented by the type `PolyTraitRef == Binder<TraitRef>`). Note that when we skolemize, instantiate, erase, or otherwise \"discharge\" these bound regions, we change the type from `Binder<T>` to just `T` (see e.g. `liberate_late_bound_regions`).",N,N],[12,"0","","",657,N],[3,"CanonicalVar","","",N,N],[12,"private","","",658,N],[3,"DebruijnIndex","","",N,N],[12,"private","","",659,N],[3,"FnSig","","Signature of a function type, which I have arbitrarily decided to use to refer to the input/output types.",N,N],[12,"inputs_and_output","","",660,N],[12,"variadic","","",660,N],[12,"unsafety","","",660,N],[12,"abi","","",660,N],[3,"GenSig","","",N,N],[12,"yield_ty","","",661,N],[12,"return_ty","","",661,N],[3,"ParamTy","","",N,N],[12,"idx","","",662,N],[12,"name","","",662,N],[3,"ProjectionTy","","Represents the projection of an associated type. In explicit UFCS form this would be written `<T as Trait<..>>::N`.",N,N],[12,"substs","","The parameters of the associated item.",663,N],[12,"item_def_id","","The DefId of the TraitItem for the associated type N.",663,N],[3,"ClosureSubsts","","A closure can be modeled as a struct that looks like:",N,N],[12,"substs","","Lifetime and type parameters from the enclosing function, concatenated with the types of the upvars.",664,N],[3,"GeneratorSubsts","","",N,N],[12,"substs","","",665,N],[3,"TypeAndMut","","",N,N],[12,"ty","","",666,N],[12,"mutbl","","",666,N],[3,"TraitRef","","A complete reference to a trait. These take numerous guises in syntax, but perhaps the most recognizable form is in a where clause:",N,N],[12,"def_id","","",667,N],[12,"substs","","",667,N],[3,"ExistentialTraitRef","","An existential reference to a trait, where `Self` is erased. For example, the trait object `Trait<'a, 'b, X, Y>` is:",N,N],[12,"def_id","","",668,N],[12,"substs","","",668,N],[3,"ExistentialProjection","","A `ProjectionPredicate` for an `ExistentialTraitRef`.",N,N],[12,"item_def_id","","",669,N],[12,"substs","","",669,N],[12,"ty","","",669,N],[3,"Const","","Typed constant value.",N,N],[12,"ty","","",670,N],[12,"val","","",670,N],[3,"EarlyBoundRegion","","",N,N],[12,"def_id","","",671,N],[12,"index","","",671,N],[12,"name","","",671,N],[3,"FreeRegion","","A \"free\" region `fr` can be interpreted as \"some region at least as big as the scope `fr.scope`\".",N,N],[12,"scope","","",672,N],[12,"bound_region","","",672,N],[3,"TyVid","","",N,N],[12,"index","","",673,N],[3,"IntVid","","",N,N],[12,"index","","",674,N],[3,"FloatVid","","",N,N],[12,"index","","",675,N],[3,"RegionVid","","",N,N],[12,"private","","",676,N],[3,"TyCtxt","","The central data structure of the compiler. It stores references to the various arenas and also houses the results of the various compiler queries that have been performed. See the [rustc guide] for more details.",N,N],[12,"gcx","","",677,N],[12,"interners","","",677,N],[3,"GlobalArenas","","Internal storage",N,N],[12,"layout","","",678,N],[12,"generics","","",678,N],[12,"trait_def","","",678,N],[12,"adt_def","","",678,N],[12,"steal_mir","","",678,N],[12,"mir","","",678,N],[12,"tables","","",678,N],[12,"const_allocs","","miri allocations",678,N],[3,"AllArenas","","",N,N],[12,"global","","",679,N],[12,"interner","","",679,N],[3,"TypeckTables","","",N,N],[12,"local_id_root","","The HirId::owner all ItemLocalIds in this table are relative to.",680,N],[12,"type_dependent_defs","","Resolved definitions for `<T>::X` associated paths and method calls, including those of overloaded operators.",680,N],[12,"field_indices","","Resolved field indices for field accesses in expressions (`S { field }`, `obj.field`) or patterns (`S { field }`). The index is often useful by itself, but to learn more about the field you also need definition of the variant to which the field belongs, but it may not exist if it's a tuple field (`tuple.0`).",680,N],[12,"user_provided_tys","","Stores the canonicalized types provided by the user. See also `AscribeUserType` statement in MIR.",680,N],[12,"node_types","","Stores the types for various nodes in the AST.  Note that this table is not guaranteed to be populated until after typeck.  See typeck::check::fn_ctxt for details.",680,N],[12,"node_substs","","Stores the type parameters which were substituted to obtain the type of this node.  This only applies to nodes that refer to entities parameterized by type parameters, such as generic fns, types, or other items.",680,N],[12,"user_substs","","Stores the substitutions that the user explicitly gave (if any) attached to `id`. These will not include any inferred values. The canonical form is used to capture things like `_` or other unspecified values.",680,N],[12,"adjustments","","",680,N],[12,"pat_binding_modes","","Stores the actual binding mode for all instances of hir::BindingAnnotation.",680,N],[12,"pat_adjustments","","Stores the types which were implicitly dereferenced in pattern binding modes for later usage in HAIR lowering. For example,",680,N],[12,"upvar_capture_map","","Borrows",680,N],[12,"closure_kind_origins","","Records the reasons that we picked the kind of each closure; not all closures are present in the map.",680,N],[12,"liberated_fn_sigs","","For each fn, records the \"liberated\" types of its arguments and return type. Liberated means that all bound regions (including late-bound regions) are replaced with free equivalents. This table is not used in codegen (since regions are erased there) and hence is not serialized to metadata.",680,N],[12,"fru_field_types","","For each FRU expression, record the normalized types of the fields of the struct - this is needed because it is non-trivial to normalize while preserving regions. This table is used only in MIR construction and hence is not serialized to metadata.",680,N],[12,"cast_kinds","","Maps a cast expression to its kind. This is keyed on the from expression of the cast, not the cast itself.",680,N],[12,"used_trait_imports","","Set of trait imports actually used in the method resolution. This is used for warning unused imports. During type checking, this `Lrc` should not be cloned: it must have a ref-count of 1 so that we can insert things into the set mutably.",680,N],[12,"tainted_by_errors","","If any errors occurred while type-checking this body, this field will be set to `true`.",680,N],[12,"free_region_map","","Stores the free-region relationships that were deduced from its where clauses and parameter types. These are then read-again by borrowck.",680,N],[12,"concrete_existential_types","","All the existential types that are restricted to concrete types by this function",680,N],[3,"Instance","","",N,N],[12,"def","","",681,N],[12,"substs","","",681,N],[3,"CrateAnalysis","","The complete set of all analyses described in this module. This is produced by the driver and fed to codegen and later passes.",N,N],[12,"access_levels","","",682,N],[12,"name","","",682,N],[12,"glob_map","","",682,N],[3,"Resolutions","","",N,N],[12,"freevars","","",683,N],[12,"trait_map","","",683,N],[12,"maybe_unused_trait_imports","","",683,N],[12,"maybe_unused_extern_crates","","",683,N],[12,"export_map","","",683,N],[12,"extern_prelude","","",683,N],[3,"ImplHeader","","The \"header\" of an impl is everything outside the body: a Self type, a trait ref (in the case of a trait impl), and a set of predicates (from the bounds/where clauses).",N,N],[12,"impl_def_id","","",684,N],[12,"self_ty","","",684,N],[12,"trait_ref","","",684,N],[12,"predicates","","",684,N],[3,"AssociatedItem","","",N,N],[12,"def_id","","",685,N],[12,"ident","","",685,N],[12,"kind","","",685,N],[12,"vis","","",685,N],[12,"defaultness","","",685,N],[12,"container","","",685,N],[12,"method_has_self_argument","","Whether this is a method with an explicit self as its first argument, allowing method calls.",685,N],[3,"CrateVariancesMap","","The crate variances map is computed during typeck and contains the variance of every item in the local crate. You should not use it directly, because to do so will make your pass dependent on the HIR of every item in the local crate. Instead, use `tcx.variances_of()` to get the variance for a particular item.",N,N],[12,"variances","","For each item with generics, maps to a vector of the variance of its generics.  If an item has no generics, it will have no entry.",686,N],[12,"empty_variance","","An empty vector, useful for cloning.",686,N],[3,"CReaderCacheKey","","",N,N],[12,"cnum","","",687,N],[12,"pos","","",687,N],[3,"TypeFlags","","",N,N],[12,"bits","","",688,N],[3,"TyS","","",N,N],[12,"sty","","",689,N],[12,"flags","","",689,N],[12,"outer_exclusive_binder","","This is a kind of confusing thing: it stores the smallest binder such that",689,N],[3,"List","","A wrapper for slices with the additional invariant that the slice is interned and no other slice with the same contents can exist in the same context. This means we can use pointer for both equality comparisons and hashing. Note: `Slice` was already taken by the `Ty`.",N,N],[12,"len","","",690,N],[12,"data","","",690,N],[12,"opaque","","",690,N],[3,"UpvarId","","Upvars do not get their own node-id. Instead, we use the pair of the original var id (that is, the root variable that is referenced by the upvar) and the id of the closure expression.",N,N],[12,"var_id","","",691,N],[12,"closure_expr_id","","",691,N],[3,"UpvarBorrow","","",N,N],[12,"kind","","The kind of borrow: by-ref upvars have access to shared immutable borrows, which are not part of the normal language syntax.",692,N],[12,"region","","Region of the resulting reference.",692,N],[3,"ClosureUpvar","","",N,N],[12,"def","","",693,N],[12,"span","","",693,N],[12,"ty","","",693,N],[3,"FloatVarValue","","",N,N],[12,"0","","",694,N],[3,"GenericParamDef","","",N,N],[12,"name","","",695,N],[12,"def_id","","",695,N],[12,"index","","",695,N],[12,"pure_wrt_drop","","`pure_wrt_drop`, set by the (unsafe) `#[may_dangle]` attribute on generic parameter `'a`/`T`, asserts data behind the parameter `'a`/`T` won't be accessed during the parent type's `Drop` impl.",695,N],[12,"kind","","",695,N],[3,"GenericParamCount","","",N,N],[12,"lifetimes","","",696,N],[12,"types","","",696,N],[3,"Generics","","Information about the formal type/lifetime parameters associated with an item or method. Analogous to hir::Generics.",N,N],[12,"parent","","",697,N],[12,"parent_count","","",697,N],[12,"params","","",697,N],[12,"param_def_id_to_index","","Reverse map to the `index` field of each `GenericParamDef`",697,N],[12,"has_self","","",697,N],[12,"has_late_bound_regions","","",697,N],[3,"GenericPredicates","","Bounds on generics.",N,N],[12,"parent","","",698,N],[12,"predicates","","",698,N],[3,"CratePredicatesMap","","The crate outlives map is computed during typeck and contains the outlives of every item in the local crate. You should not use it directly, because to do so will make your pass dependent on the HIR of every item in the local crate. Instead, use `tcx.inferred_outlives_of()` to get the outlives for a particular item.",N,N],[12,"predicates","","For each struct with outlive bounds, maps to a vector of the predicate of its outlive bounds. If an item has no outlives bounds, it will have no entry.",699,N],[12,"empty_predicate","","An empty vector, useful for cloning.",699,N],[3,"TraitPredicate","","",N,N],[12,"trait_ref","","",700,N],[3,"OutlivesPredicate","","",N,N],[12,"0","","",701,N],[12,"1","","",701,N],[3,"SubtypePredicate","","",N,N],[12,"a_is_expected","","",702,N],[12,"a","","",702,N],[12,"b","","",702,N],[3,"ProjectionPredicate","","This kind of predicate has no direct correspondent in the syntax, but it roughly corresponds to the syntactic forms:",N,N],[12,"projection_ty","","",703,N],[12,"ty","","",703,N],[3,"InstantiatedPredicates","","Represents the bounds declared on a particular set of type parameters.  Should eventually be generalized into a flag list of where clauses.  You can obtain a `InstantiatedPredicates` list from a `GenericPredicates` by using the `instantiate` method. Note that this method reflects an important semantic invariant of `InstantiatedPredicates`: while the `GenericPredicates` are expressed in terms of the bound type parameters of the impl/trait/whatever, an `InstantiatedPredicates` instance represented a set of bounds for some particular instantiation, meaning that the generic parameters have been substituted with their values.",N,N],[12,"predicates","","",704,N],[3,"UniverseIndex","","\"Universes\" are used during type- and trait-checking in the presence of `for<..>` binders to control what sets of names are visible. Universes are arranged into a tree: the root universe contains names that are always visible. But when you enter into some subuniverse, then it may add names that are only visible within that subtree (but it can still name the names of its ancestor universes).",N,N],[12,"0","","",705,N],[3,"ParamEnv","","When type checking, we use the `ParamEnv` to track details about the set of where-clauses that are in scope at this particular point.",N,N],[12,"caller_bounds","","Obligations that the caller must satisfy. This is basically the set of bounds on the in-scope type parameters, translated into Obligations, and elaborated and normalized.",706,N],[12,"reveal","","Typically, this is `Reveal::UserFacing`, but during codegen we want `Reveal::All` -- note that this is always paired with an empty environment. To get that, use `ParamEnv::reveal()`.",706,N],[3,"ParamEnvAnd","","",N,N],[12,"param_env","","",707,N],[12,"value","","",707,N],[3,"Destructor","","",N,N],[12,"did","","The def-id of the destructor method",708,N],[3,"AdtFlags","","",N,N],[12,"bits","","",709,N],[3,"VariantFlags","","",N,N],[12,"bits","","",710,N],[3,"VariantDef","","",N,N],[12,"did","","The variant's DefId. If this is a tuple-like struct, this is the DefId of the struct's ctor.",711,N],[12,"name","","",711,N],[12,"discr","","",711,N],[12,"fields","","",711,N],[12,"ctor_kind","","",711,N],[12,"flags","","",711,N],[3,"FieldDef","","",N,N],[12,"did","","",712,N],[12,"ident","","",712,N],[12,"vis","","",712,N],[3,"AdtDef","","The definition of an abstract data type - a struct or enum.",N,N],[12,"did","","",713,N],[12,"variants","","",713,N],[12,"flags","","",713,N],[12,"repr","","",713,N],[3,"ReprFlags","","",N,N],[12,"bits","","",714,N],[3,"ReprOptions","","Represents the repr options provided by the user,",N,N],[12,"int","","",715,N],[12,"align","","",715,N],[12,"pack","","",715,N],[12,"flags","","",715,N],[3,"CrateInherentImpls","","A map for the local crate mapping each type to a vector of its inherent impls. This is not meant to be used outside of coherence; rather, you should request the vector for a specific type via `tcx.inherent_impls(def_id)` so as to minimize your dependencies (constructing this map requires touching the entire crate).",N,N],[12,"inherent_impls","","",716,N],[3,"SymbolName","","",N,N],[12,"name","","",717,N],[4,"InferTy","","",N,N],[13,"TyVar","","",718,N],[13,"IntVar","","",718,N],[13,"FloatVar","","",718,N],[13,"FreshTy","","A `FreshTy` is one that is generated as a replacement for an unbound type variable. This is convenient for caching etc. See `infer::freshen` for more details.",718,N],[13,"FreshIntTy","","",718,N],[13,"FreshFloatTy","","",718,N],[13,"CanonicalTy","","Canonicalized type variable, used only when preparing a trait query.",718,N],[4,"ExistentialPredicate","","",N,N],[13,"Trait","","e.g. Iterator",719,N],[13,"Projection","","e.g. Iterator::Item = T",719,N],[13,"AutoTrait","","e.g. Send",719,N],[4,"UpvarSubsts","","",N,N],[13,"Closure","","",720,N],[13,"Generator","","",720,N],[4,"TyKind","","NB: If you change this, you'll probably want to change the corresponding AST structure in libsyntax/ast.rs as well.",N,N],[13,"Bool","","The primitive boolean type. Written as `bool`.",721,N],[13,"Char","","The primitive character type; holds a Unicode scalar value (a non-surrogate code point).  Written as `char`.",721,N],[13,"Int","","A primitive signed integer type. For example, `i32`.",721,N],[13,"Uint","","A primitive unsigned integer type. For example, `u32`.",721,N],[13,"Float","","A primitive floating-point type. For example, `f64`.",721,N],[13,"Adt","","Structures, enumerations and unions.",721,N],[13,"Foreign","","",721,N],[13,"Str","","The pointee of a string slice. Written as `str`.",721,N],[13,"Array","","An array with the given length. Written as `[T; n]`.",721,N],[13,"Slice","","The pointee of an array slice.  Written as `[T]`.",721,N],[13,"RawPtr","","A raw pointer. Written as `*mut T` or `*const T`",721,N],[13,"Ref","","A reference; a pointer with an associated lifetime. Written as `&'a mut T` or `&'a T`.",721,N],[13,"FnDef","","The anonymous type of a function declaration/definition. Each function has a unique type.",721,N],[13,"FnPtr","","A pointer to a function.  Written as `fn() -> i32`.",721,N],[13,"Dynamic","","A trait, defined with `trait`.",721,N],[13,"Closure","","The anonymous type of a closure. Used to represent the type of `|a| a`.",721,N],[13,"Generator","","The anonymous type of a generator. Used to represent the type of `|a| yield a`.",721,N],[13,"GeneratorWitness","","A type representin the types stored inside a generator. This should only appear in GeneratorInteriors.",721,N],[13,"Never","","The never type `!`",721,N],[13,"Tuple","","A tuple type.  For example, `(i32, bool)`.",721,N],[13,"Projection","","The projection of an associated type.  For example, `<T as Trait<..>>::N`.",721,N],[13,"Opaque","","Opaque (`impl Trait`) type found in a return type. The DefId comes either from * the `impl Trait` ast::Ty node, * or the `existential type` declaration The substitutions are for the generics of the function in question. After typeck, the concrete type can be found in the `types` map.",721,N],[13,"Param","","A type parameter; for example, `T` in `fn f(x: T) {}",721,N],[13,"Infer","","A type variable used during type-checking.",721,N],[13,"Error","","A placeholder for a type which could not be computed; this is propagated to avoid useless error messages.",721,N],[4,"BoundRegion","","",N,N],[13,"BrAnon","","An anonymous region parameter for a given fn (&T)",722,N],[13,"BrNamed","","Named region parameters for functions (a in &'a T)",722,N],[13,"BrFresh","","Fresh bound identifiers created during GLB computations.",722,N],[13,"BrEnv","","Anonymous region for the implicit env pointer parameter to a closure",722,N],[4,"RegionKind","","Representation of regions.",N,N],[13,"ReEarlyBound","","",723,N],[13,"ReLateBound","","",723,N],[13,"ReFree","","When checking a function body, the types of all arguments and so forth that refer to bound region parameters are modified to refer to free region parameters.",723,N],[13,"ReScope","","A concrete region naming some statically determined scope (e.g. an expression or sequence of statements) within the current function.",723,N],[13,"ReStatic","","Static data that has an \"infinite\" lifetime. Top in the region lattice.",723,N],[13,"ReVar","","A region variable.  Should not exist after typeck.",723,N],[13,"ReSkolemized","","A skolemized region - basically the higher-ranked version of ReFree. Should not exist after typeck.",723,N],[13,"ReEmpty","","Empty lifetime is for data that is never accessed. Bottom in the region lattice. We treat ReEmpty somewhat specially; at least right now, we do not generate instances of it during the GLB computations, but rather generate an error instead. This is to improve error messages. The only way to get an instance of ReEmpty is to have a region variable with no constraints.",723,N],[13,"ReErased","","Erased region, used by trait selection, in MIR and during codegen.",723,N],[13,"ReClosureBound","","These are regions bound in the \"defining type\" for a closure. They are used ONLY as part of the `ClosureRegionRequirements` that are produced by MIR borrowck. See `ClosureRegionRequirements` for more details.",723,N],[13,"ReCanonical","","Canonicalized region, used only when preparing a trait query.",723,N],[4,"InstanceDef","","",N,N],[13,"Item","","",724,N],[13,"Intrinsic","","",724,N],[13,"FnPtrShim","","<fn() as FnTrait>::call_* def-id is FnTrait::call_*",724,N],[13,"Virtual","","::fn",724,N],[13,"ClosureOnceShim","","<[mut closure] as FnOnce>::call_once",724,N],[12,"call_once","rustc::ty::InstanceDef","",724,N],[13,"DropGlue","rustc::ty","drop_in_place::; None for empty drop glue.",724,N],[13,"CloneShim","","`<T as Clone>::clone` shim.",724,N],[4,"AssociatedItemContainer","","",N,N],[13,"TraitContainer","","",725,N],[13,"ImplContainer","","",725,N],[4,"AssociatedKind","","",N,N],[13,"Const","","",726,N],[13,"Method","","",726,N],[13,"Existential","","",726,N],[13,"Type","","",726,N],[4,"Visibility","","",N,N],[13,"Public","","Visible everywhere (including in other crates).",727,N],[13,"Restricted","","Visible only in the given crate-local module.",727,N],[13,"Invisible","","Not visible anywhere in the local crate. This is the visibility of private external items.",727,N],[4,"Variance","","",N,N],[13,"Covariant","","",728,N],[13,"Invariant","","",728,N],[13,"Contravariant","","",728,N],[13,"Bivariant","","",728,N],[4,"BorrowKind","","",N,N],[13,"ImmBorrow","","Data must be immutable and is aliasable.",729,N],[13,"UniqueImmBorrow","","Data must be immutable but not aliasable.  This kind of borrow cannot currently be expressed by the user and is used only in implicit closure bindings. It is needed when the closure is borrowing or mutating a mutable referent, e.g.:",729,N],[13,"MutBorrow","","Data is mutable and not aliasable.",729,N],[4,"UpvarCapture","","Information describing the capture of an upvar. This is computed during `typeck`, specifically by `regionck`.",N,N],[13,"ByValue","","Upvar is captured by value. This is always true when the closure is labeled `move`, but can also be true in other cases depending on inference.",730,N],[13,"ByRef","","Upvar is captured by reference.",730,N],[4,"IntVarValue","","",N,N],[13,"IntType","","",731,N],[13,"UintType","","",731,N],[4,"GenericParamDefKind","","",N,N],[13,"Lifetime","","",732,N],[13,"Type","","",732,N],[12,"has_default","rustc::ty::GenericParamDefKind","",732,N],[12,"object_lifetime_default","","",732,N],[12,"synthetic","","",732,N],[4,"Predicate","rustc::ty","",N,N],[13,"Trait","","Corresponds to `where Foo : Bar<A,B,C>`. `Foo` here would be the `Self` type of the trait reference and `A`, `B`, and `C` would be the type parameters.",733,N],[13,"RegionOutlives","","where 'a : 'b",733,N],[13,"TypeOutlives","","where T : 'a",733,N],[13,"Projection","","where ::Name == X, approximately. See `ProjectionPredicate` struct for details.",733,N],[13,"WellFormed","","no syntax: T WF",733,N],[13,"ObjectSafe","","trait must be object-safe",733,N],[13,"ClosureKind","","No direct syntax. May be thought of as `where T : FnFoo<...>` for some substitutions `...` and T being a closure type. Satisfied (or refuted) once we know the closure's kind.",733,N],[13,"Subtype","","`T1 <: T2`",733,N],[13,"ConstEvaluatable","","Constant initializer must evaluate successfully.",733,N],[4,"VariantDiscr","","",N,N],[13,"Explicit","","Explicit value for this variant, i.e. `X = 123`. The `DefId` corresponds to the embedded constant.",734,N],[13,"Relative","","The previous variant's discriminant plus one. For efficiency reasons, the distance from the last `Explicit` discriminant is being stored, or `0` for the first variant, if it has none.",734,N],[4,"AdtKind","","",N,N],[13,"Struct","","",735,N],[13,"Union","","",735,N],[13,"Enum","","",735,N],[4,"ClosureKind","","Represents the various closure traits in the Rust language. This will determine the type of the environment (`self`, in the desuaring) argument that the closure expects.",N,N],[13,"Fn","","",736,N],[13,"FnMut","","",736,N],[13,"FnOnce","","",736,N],[4,"Attributes","","",N,N],[13,"Owned","","",737,N],[13,"Borrowed","","",737,N],[5,"keep_local","","",N,[[["t"]],["bool"]]],[5,"associated_item","","",N,[[["tyctxt"],["defid"]],["associateditem"]]],[5,"adt_sized_constraint","","Calculates the Sized-constraint.",N,N],[5,"associated_item_def_ids","","",N,[[["tyctxt"],["defid"]],["lrc",["vec"]]]],[5,"def_span","","",N,[[["tyctxt"],["defid"]],["span"]]],[5,"trait_of_item","","If the given def ID describes an item belonging to a trait, return the ID of the trait that the trait item belongs to. Otherwise, return `None`.",N,[[["tyctxt"],["defid"]],["option",["defid"]]]],[5,"is_impl_trait_defn","","Yields the parent function's `DefId` if `def_id` is an `impl Trait` definition",N,[[["tyctxt"],["defid"]],["option",["defid"]]]],[5,"param_env","","See `ParamEnv` struct def'n for details.",N,[[["tyctxt"],["defid"]],["paramenv"]]],[5,"crate_disambiguator","","",N,[[["tyctxt"],["cratenum"]],["cratedisambiguator"]]],[5,"original_crate_name","","",N,[[["tyctxt"],["cratenum"]],["symbol"]]],[5,"crate_hash","","",N,[[["tyctxt"],["cratenum"]],["svh"]]],[5,"instance_def_size_estimate","","",N,[[["tyctxt"],["instancedef"]],["usize"]]],[5,"provide","","",N,[[["providers"]]]],[20,"OpaqueListContents","","A dummy type used to force List to by unsized without requiring fat pointers",N,N],[0,"tls","","",N,N],[3,"ImplicitCtxt","rustc::ty::tls","This is the implicit state of rustc. It contains the current TyCtxt and query. It is updated when creating a local interner or executing a new query. Whenever there's a TyCtxt value available you should also have access to an ImplicitCtxt through the functions in this module.",N,N],[12,"tcx","","The current TyCtxt. Initially created by `enter_global` and updated by `enter_local` with a new local interner",738,N],[12,"query","","The current query job, if any. This is updated by start_job in ty::query::plumbing when executing a query",738,N],[12,"layout_depth","","Used to prevent layout from recursing too deeply.",738,N],[12,"task","","The current dep graph task. This is used to add dependencies to queries when executing them",738,N],[5,"with_thread_locals","","Sets up the callbacks from libsyntax on the current thread",N,[[["f"]],["r"]]],[5,"enter_context","","Sets `context` as the new current ImplicitCtxt for the duration of the function `f`",N,[[["implicitctxt"],["f"]],["r"]]],[5,"enter_global","","Enters GlobalCtxt by setting up libsyntax callbacks and creating a initial TyCtxt and ImplicitCtxt. This happens once per rustc session and TyCtxts only exists inside the `f` function.",N,[[["globalctxt"],["f"]],["r"]]],[5,"with_global","","Creates a TyCtxt and ImplicitCtxt based on the GCX_PTR thread local. This is used in the deadlock handler.",N,[[["f"]],["r"]]],[5,"with_context_opt","","Allows access to the current ImplicitCtxt in a closure if one is available",N,[[["f"]],["r"]]],[5,"with_context","","Allows access to the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[5,"with_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'gcx lifetime as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner from the current ImplicitCtxt's tcx field.",N,[[["tyctxt"],["f"]],["r"]]],[5,"with_fully_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner and local interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'tcx and 'gcx lifetimes as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner or a different local interner from the current ImplicitCtxt's tcx field.",N,[[["tyctxt"],["f"]],["r"]]],[5,"with","","Allows access to the TyCtxt in the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[5,"with_opt","","Allows access to the TyCtxt in the current ImplicitCtxt. The closure is passed None if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[7,"GCX_PTR","","",N,N],[0,"adjustment","rustc::ty","",N,N],[3,"Adjustment","rustc::ty::adjustment","Represents coercing a value to a different type of value.",N,N],[12,"kind","","",739,N],[12,"target","","",739,N],[3,"OverloadedDeref","","An overloaded autoderef step, representing a `Deref(Mut)::deref(_mut)` call, with the signature `&'a T -> &'a U` or `&'a mut T -> &'a mut U`. The target type is `U` in both cases, with the region and mutability being those shared by both the receiver and the returned reference.",N,N],[12,"region","","",740,N],[12,"mutbl","","",740,N],[3,"CoerceUnsizedInfo","","Information for `CoerceUnsized` impls, storing information we have computed about the coercion.",N,N],[12,"custom_kind","","If this is a \"custom coerce\" impl, then what kind of custom coercion is it? This applies to impls of `CoerceUnsized` for structs, primarily, where we store a bit of info about which fields need to be coerced.",741,N],[4,"Adjust","","",N,N],[13,"NeverToAny","","Go from ! to any type.",742,N],[13,"ReifyFnPointer","","Go from a fn-item type to a fn-pointer type.",742,N],[13,"UnsafeFnPointer","","Go from a safe fn pointer to an unsafe fn pointer.",742,N],[13,"ClosureFnPointer","","Go from a non-capturing closure to an fn pointer.",742,N],[13,"MutToConstPointer","","Go from a mut raw pointer to a const raw pointer.",742,N],[13,"Deref","","Dereference once, producing a place.",742,N],[13,"Borrow","","Take the address and produce either a `&` or `*` pointer.",742,N],[13,"Unsize","","Unsize a pointer/reference value, e.g. `&[T; n]` to `&[T]`. Note that the source could be a thin or fat pointer. This will do things like convert thin pointers to fat pointers, or convert structs containing thin pointers to structs containing fat pointers, or convert between fat pointers.  We don't store the details of how the transform is done (in fact, we don't know that, because it might depend on the precise type parameters). We just store the target type. Codegen backends and miri figure out what has to be done based on the precise source/target type at hand.",742,N],[4,"AllowTwoPhase","","At least for initial deployment, we want to limit two-phase borrows to only a few specific cases. Right now, those mostly \"things that desugar\" into method calls     - using x.some_method() syntax, where some_method takes &mut self     - using Foo::some_method(&mut x, ...) syntax     - binary assignment operators (+=, -=, *=, etc.) Anything else should be rejected until generalized two phase borrow support is implemented. Right now, dataflow can't handle the general case where there is more than one use of a mutable borrow, and we don't want to accept too much new code via two-phase borrows, so we try to limit where we create two-phase capable mutable borrows. See #49434 for tracking.",N,N],[13,"Yes","","",743,N],[13,"No","","",743,N],[4,"AutoBorrowMutability","","",N,N],[13,"Mutable","","",744,N],[12,"allow_two_phase_borrow","rustc::ty::adjustment::AutoBorrowMutability","",744,N],[13,"Immutable","rustc::ty::adjustment","",744,N],[4,"AutoBorrow","","",N,N],[13,"Ref","","Convert from T to &T.",745,N],[13,"RawPtr","","Convert from T to *T.",745,N],[4,"CustomCoerceUnsized","","",N,N],[13,"Struct","","Records the index of the field being coerced.",746,N],[11,"clone","","",739,[[["self"]],["adjustment"]]],[11,"encode","","",739,[[["self"],["__s"]],["result"]]],[11,"decode","","",739,[[["__d"]],["result",["adjustment"]]]],[11,"clone","","",742,[[["self"]],["adjust"]]],[11,"fmt","","",742,[[["self"],["formatter"]],["result"]]],[11,"encode","","",742,[[["self"],["__s"]],["result"]]],[11,"decode","","",742,[[["__d"]],["result",["adjust"]]]],[11,"clone","","",740,[[["self"]],["overloadedderef"]]],[11,"eq","","",740,[[["self"],["overloadedderef"]],["bool"]]],[11,"ne","","",740,[[["self"],["overloadedderef"]],["bool"]]],[11,"fmt","","",740,[[["self"],["formatter"]],["result"]]],[11,"encode","","",740,[[["self"],["__s"]],["result"]]],[11,"decode","","",740,[[["__d"]],["result",["overloadedderef"]]]],[11,"method_call","","",740,N],[11,"clone","","",743,[[["self"]],["allowtwophase"]]],[11,"eq","","",743,[[["self"],["allowtwophase"]],["bool"]]],[11,"fmt","","",743,[[["self"],["formatter"]],["result"]]],[11,"encode","","",743,[[["self"],["__s"]],["result"]]],[11,"decode","","",743,[[["__d"]],["result",["allowtwophase"]]]],[11,"clone","","",744,[[["self"]],["autoborrowmutability"]]],[11,"eq","","",744,[[["self"],["autoborrowmutability"]],["bool"]]],[11,"ne","","",744,[[["self"],["autoborrowmutability"]],["bool"]]],[11,"fmt","","",744,[[["self"],["formatter"]],["result"]]],[11,"encode","","",744,[[["self"],["__s"]],["result"]]],[11,"decode","","",744,[[["__d"]],["result",["autoborrowmutability"]]]],[11,"from","rustc::hir","",103,[[["autoborrowmutability"]],["self"]]],[11,"clone","rustc::ty::adjustment","",745,[[["self"]],["autoborrow"]]],[11,"eq","","",745,[[["self"],["autoborrow"]],["bool"]]],[11,"ne","","",745,[[["self"],["autoborrow"]],["bool"]]],[11,"fmt","","",745,[[["self"],["formatter"]],["result"]]],[11,"encode","","",745,[[["self"],["__s"]],["result"]]],[11,"decode","","",745,[[["__d"]],["result",["autoborrow"]]]],[11,"clone","","",741,[[["self"]],["coerceunsizedinfo"]]],[11,"encode","","",741,[[["self"],["__s"]],["result"]]],[11,"decode","","",741,[[["__d"]],["result",["coerceunsizedinfo"]]]],[11,"fmt","","",741,[[["self"],["formatter"]],["result"]]],[11,"clone","","",746,[[["self"]],["customcoerceunsized"]]],[11,"encode","","",746,[[["self"],["__s"]],["result"]]],[11,"decode","","",746,[[["__d"]],["result",["customcoerceunsized"]]]],[11,"fmt","","",746,[[["self"],["formatter"]],["result"]]],[0,"binding","rustc::ty","",N,N],[4,"BindingMode","rustc::ty::binding","",N,N],[13,"BindByReference","","",747,N],[13,"BindByValue","","",747,N],[11,"clone","","",747,[[["self"]],["bindingmode"]]],[11,"eq","","",747,[[["self"],["bindingmode"]],["bool"]]],[11,"ne","","",747,[[["self"],["bindingmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",747,N],[11,"encode","","",747,[[["self"],["__s"]],["result"]]],[11,"decode","","",747,[[["__d"]],["result",["bindingmode"]]]],[11,"hash","","",747,N],[11,"fmt","","",747,[[["self"],["formatter"]],["result"]]],[11,"super_fold_with","","",747,[[["self"],["f"]],["bindingmode"]]],[11,"super_visit_with","","",747,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","","",747,[[["self"],["tyctxt"]],["option"]]],[11,"convert","","",747,[[["bindingannotation"]],["bindingmode"]]],[11,"hash_stable","","",747,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"cast","rustc::ty","",N,N],[4,"IntTy","rustc::ty::cast","Types that are represented as ints.",N,N],[13,"U","","",748,N],[13,"I","","",748,N],[13,"CEnum","","",748,N],[13,"Bool","","",748,N],[13,"Char","","",748,N],[4,"CastTy","","",N,N],[13,"Int","","Various types that are represented as ints and handled mostly in the same way, merged for easier matching.",749,N],[13,"Float","","Floating-Point types",749,N],[13,"FnPtr","","Function Pointers",749,N],[13,"Ptr","","Raw pointers",749,N],[13,"RPtr","","References",749,N],[4,"CastKind","","Cast Kind. See RFC 401 (or librustc_typeck/check/cast.rs)",N,N],[13,"CoercionCast","","",750,N],[13,"PtrPtrCast","","",750,N],[13,"PtrAddrCast","","",750,N],[13,"AddrPtrCast","","",750,N],[13,"NumericCast","","",750,N],[13,"EnumCast","","",750,N],[13,"PrimIntCast","","",750,N],[13,"U8CharCast","","",750,N],[13,"ArrayPtrCast","","",750,N],[13,"FnPtrPtrCast","","",750,N],[13,"FnPtrAddrCast","","",750,N],[11,"clone","","",748,[[["self"]],["intty"]]],[11,"fmt","","",748,[[["self"],["formatter"]],["result"]]],[11,"eq","","",748,[[["self"],["intty"]],["bool"]]],[11,"ne","","",748,[[["self"],["intty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",748,N],[11,"clone","","",749,[[["self"]],["castty"]]],[11,"fmt","","",749,[[["self"],["formatter"]],["result"]]],[11,"eq","","",749,[[["self"],["castty"]],["bool"]]],[11,"ne","","",749,[[["self"],["castty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",749,N],[11,"clone","","",750,[[["self"]],["castkind"]]],[11,"fmt","","",750,[[["self"],["formatter"]],["result"]]],[11,"encode","","",750,[[["self"],["__s"]],["result"]]],[11,"decode","","",750,[[["__d"]],["result",["castkind"]]]],[11,"from_ty","","",749,[[["ty"]],["option",["castty"]]]],[0,"codec","rustc::ty","",N,N],[5,"encode_with_shorthand","rustc::ty::codec","Encode the given value or a previously cached shorthand.",N,[[["e"],["t"],["m"]],["result"]]],[5,"encode_predicates","","",N,[[["e"],["genericpredicates"],["c"]],["result"]]],[5,"decode_cnum","","",N,[[["d"]],["result",["cratenum"]]]],[5,"decode_ty","","",N,[[["d"]],["result",["ty"]]]],[5,"decode_predicates","","",N,[[["d"]],["result",["genericpredicates"]]]],[5,"decode_substs","","",N,[[["d"]],["result",["substs"]]]],[5,"decode_region","","",N,[[["d"]],["result",["region"]]]],[5,"decode_ty_slice","","",N,[[["d"]],["result",["list"]]]],[5,"decode_adt_def","","",N,[[["d"]],["result",["adtdef"]]]],[5,"decode_existential_predicate_slice","","",N,[[["d"]],["result",["list"]]]],[5,"decode_canonical_var_infos","","",N,[[["d"]],["result",["canonicalvarinfos"]]]],[5,"decode_const","","",N,[[["d"]],["result",["const"]]]],[5,"decode_allocation","","",N,[[["d"]],["result",["allocation"]]]],[17,"SHORTHAND_OFFSET","","The shorthand encoding uses an enum's variant index `usize` and is offset by this value so it never matches a real variant. This offset is also chosen so that the first byte is never < 0x80.",N,N],[8,"EncodableWithShorthand","","",N,N],[16,"Variant","","",751,N],[10,"variant","","",751,N],[8,"TyEncoder","","",N,N],[10,"position","","",752,[[["self"]],["usize"]]],[8,"TyDecoder","","",N,N],[10,"tcx","","",753,[[["self"]],["tyctxt"]]],[10,"peek_byte","","",753,[[["self"]],["u8"]]],[10,"position","","",753,[[["self"]],["usize"]]],[10,"cached_ty_for_shorthand","","",753,[[["self"],["usize"],["f"]],["result",["ty"]]]],[10,"with_position","","",753,[[["self"],["usize"],["f"]],["r"]]],[10,"map_encoded_cnum_to_current","","",753,[[["self"],["cratenum"]],["cratenum"]]],[11,"positioned_at_shorthand","","",753,[[["self"]],["bool"]]],[11,"variant","rustc::ty","",733,N],[0,"error","","",N,N],[3,"ExpectedFound","rustc::ty::error","",N,N],[12,"expected","","",754,N],[12,"found","","",754,N],[4,"TypeError","","",N,N],[13,"Mismatch","","",755,N],[13,"UnsafetyMismatch","","",755,N],[13,"AbiMismatch","","",755,N],[13,"Mutability","","",755,N],[13,"TupleSize","","",755,N],[13,"FixedArraySize","","",755,N],[13,"ArgCount","","",755,N],[13,"RegionsDoesNotOutlive","","",755,N],[13,"RegionsInsufficientlyPolymorphic","","",755,N],[13,"RegionsOverlyPolymorphic","","",755,N],[13,"Sorts","","",755,N],[13,"IntMismatch","","",755,N],[13,"FloatMismatch","","",755,N],[13,"Traits","","",755,N],[13,"VariadicMismatch","","",755,N],[13,"CyclicTy","","Instantiating a type variable with the given type would have created a cycle (because it appears somewhere within that type).",755,N],[13,"ProjectionMismatched","","",755,N],[13,"ProjectionBoundsLength","","",755,N],[13,"ExistentialMismatch","","",755,N],[13,"OldStyleLUB","","",755,N],[4,"UnconstrainedNumeric","","",N,N],[13,"UnconstrainedFloat","","",756,N],[13,"UnconstrainedInt","","",756,N],[13,"Neither","","",756,N],[11,"clone","","",754,[[["self"]],["expectedfound"]]],[11,"fmt","","",754,[[["self"],["formatter"]],["result"]]],[11,"clone","","",755,[[["self"]],["typeerror"]]],[11,"fmt","","",755,[[["self"],["formatter"]],["result"]]],[11,"clone","","",756,[[["self"]],["unconstrainednumeric"]]],[11,"encode","","",756,[[["self"],["__s"]],["result"]]],[11,"decode","","",756,[[["__d"]],["result",["unconstrainednumeric"]]]],[11,"eq","","",756,[[["self"],["unconstrainednumeric"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",756,N],[11,"hash","","",756,N],[11,"fmt","","",756,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",755,[[["self"],["formatter"]],["result"]]],[11,"sort_string","rustc::ty","",689,[[["self"],["tyctxt"]],["string"]]],[11,"note_and_explain_type_err","","",677,[[["self"],["diagnosticbuilder"],["typeerror"],["span"]]]],[0,"erase_regions","","",N,N],[3,"RegionEraserVisitor","rustc::ty::erase_regions","",N,N],[12,"tcx","","",757,N],[5,"provide","","",N,[[["providers"]]]],[5,"erase_regions_ty","","",N,[[["tyctxt"],["ty"]],["ty"]]],[11,"erase_regions","rustc::ty","Returns an equivalent value with all free regions removed (note that late-bound regions remain, because they are important for subtyping, but they are anonymized and normalized as well)..",677,[[["self"],["t"]],["t"]]],[11,"tcx","rustc::ty::erase_regions","",757,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",757,[[["self"],["ty"]],["ty"]]],[11,"fold_binder","","",757,[[["self"],["binder"]],["binder"]]],[11,"fold_region","","",757,[[["self"],["region"]],["region"]]],[0,"fast_reject","rustc::ty","",N,N],[4,"SimplifiedTypeGen","rustc::ty::fast_reject","See `simplify_type`",N,N],[13,"BoolSimplifiedType","","",758,N],[13,"CharSimplifiedType","","",758,N],[13,"IntSimplifiedType","","",758,N],[13,"UintSimplifiedType","","",758,N],[13,"FloatSimplifiedType","","",758,N],[13,"AdtSimplifiedType","","",758,N],[13,"StrSimplifiedType","","",758,N],[13,"ArraySimplifiedType","","",758,N],[13,"PtrSimplifiedType","","",758,N],[13,"NeverSimplifiedType","","",758,N],[13,"TupleSimplifiedType","","",758,N],[13,"TraitSimplifiedType","","",758,N],[13,"ClosureSimplifiedType","","",758,N],[13,"GeneratorSimplifiedType","","",758,N],[13,"GeneratorWitnessSimplifiedType","","",758,N],[13,"OpaqueSimplifiedType","","",758,N],[13,"FunctionSimplifiedType","","",758,N],[13,"ParameterSimplifiedType","","",758,N],[13,"ForeignSimplifiedType","","",758,N],[5,"simplify_type","","Tries to simplify a type by dropping type parameters, deref'ing away any reference types, etc. The idea is to get something simple that we can use to quickly decide if two types could unify during method lookup.",N,[[["tyctxt"],["ty"],["bool"]],["option",["simplifiedtype"]]]],[6,"SimplifiedType","","",N,N],[11,"clone","","",758,[[["self"]],["simplifiedtypegen"]]],[11,"fmt","","",758,[[["self"],["formatter"]],["result"]]],[11,"eq","","",758,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"ne","","",758,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",758,N],[11,"hash","","",758,N],[11,"partial_cmp","","",758,[[["self"],["simplifiedtypegen"]],["option",["ordering"]]]],[11,"lt","","",758,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"le","","",758,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"gt","","",758,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"ge","","",758,[[["self"],["simplifiedtypegen"]],["bool"]]],[11,"cmp","","",758,[[["self"],["simplifiedtypegen"]],["ordering"]]],[11,"encode","","",758,[[["self"],["__sd"]],["result"]]],[11,"decode","","",758,[[["__dd"]],["result",["simplifiedtypegen"]]]],[11,"map_def","","",758,[[["self"],["f"]],["simplifiedtypegen"]]],[11,"hash_stable","","",758,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"fold","rustc::ty","Generalized type folding mechanism. The setup is a bit convoluted but allows for convenient usage. Let T be an instance of some \"foldable type\" (one which implements `TypeFoldable`) and F be an instance of a \"folder\" (a type which implements `TypeFolder`). Then the setup is intended to be:",N,N],[3,"BottomUpFolder","rustc::ty::fold","",N,N],[12,"tcx","","",759,N],[12,"fldop","","",759,N],[12,"reg_op","","",759,N],[3,"RegionFolder","","Folds over the substructure of a type, visiting its component types and all regions that occur free within it.",N,N],[12,"tcx","","",760,N],[12,"skipped_regions","","",760,N],[12,"current_index","","Stores the index of a binder just outside the stuff we have visited.  So this begins as INNERMOST; when we pass through a binder, it is incremented (via `shift_in`).",760,N],[12,"fold_region_fn","","Callback invokes for each free region. The `DebruijnIndex` points to the binder just outside the ones we have passed through.",760,N],[3,"RegionReplacer","","",N,N],[12,"tcx","","",761,N],[12,"current_index","","As with `RegionFolder`, represents the index of a binder just outside the ones we have visited.",761,N],[12,"fld_r","","",761,N],[12,"map","","",761,N],[3,"HasEscapingRegionsVisitor","","An \"escaping region\" is a bound region whose binder is not part of `t`.",N,N],[12,"outer_index","","Anything bound by `outer_index` or \"above\" is escaping",762,N],[3,"HasTypeFlagsVisitor","","",N,N],[12,"flags","","",763,N],[3,"LateBoundRegionsCollector","","Collects all the late-bound regions at the innermost binding level into a hash set.",N,N],[12,"current_index","","",764,N],[12,"regions","","",764,N],[12,"just_constrained","","If true, we only want regions that are known to be \"constrained\" when you equate this type with another type. In partcular, if you have e.g. `&'a u32` and `&'b u32`, equating them constraints `'a == 'b`.  But if you have `<&'a u32 as Trait>::Foo` and `<&'b u32 as Trait>::Foo`, normalizing those types may mean that `'a` and `'b` don't appear in the results, so they are not considered constrained.",764,N],[5,"shift_region","","",N,[[["regionkind"],["u32"]],["regionkind"]]],[5,"shift_region_ref","","",N,[[["tyctxt"],["region"],["u32"]],["region"]]],[5,"shift_regions","","",N,[[["tyctxt"],["u32"],["t"]],["t"]]],[8,"TypeFoldable","","The TypeFoldable trait is implemented for every type that can be folded. Basically, every type that has a corresponding method in TypeFolder.",N,N],[10,"super_fold_with","","",765,[[["self"],["f"]],["self"]]],[11,"fold_with","","",765,[[["self"],["f"]],["self"]]],[10,"super_visit_with","","",765,[[["self"],["v"]],["bool"]]],[11,"visit_with","","",765,[[["self"],["v"]],["bool"]]],[11,"has_regions_bound_at_or_above","","True if `self` has any late-bound regions that are either bound by `binder` or bound by some binder outside of `binder`. If `binder` is `ty::INNERMOST`, this indicates whether there are any late-bound regions that appear free.",765,[[["self"],["debruijnindex"]],["bool"]]],[11,"has_regions_bound_above","","True if this `self` has any regions that escape `binder` (and hence are not bound by it).",765,[[["self"],["debruijnindex"]],["bool"]]],[11,"has_escaping_regions","","",765,[[["self"]],["bool"]]],[11,"has_type_flags","","",765,[[["self"],["typeflags"]],["bool"]]],[11,"has_projections","","",765,[[["self"]],["bool"]]],[11,"references_error","","",765,[[["self"]],["bool"]]],[11,"has_param_types","","",765,[[["self"]],["bool"]]],[11,"has_self_ty","","",765,[[["self"]],["bool"]]],[11,"has_infer_types","","",765,[[["self"]],["bool"]]],[11,"needs_infer","","",765,[[["self"]],["bool"]]],[11,"has_skol","","",765,[[["self"]],["bool"]]],[11,"needs_subst","","",765,[[["self"]],["bool"]]],[11,"has_re_skol","","",765,[[["self"]],["bool"]]],[11,"has_closure_types","","",765,[[["self"]],["bool"]]],[11,"has_free_regions","","\"Free\" regions in this context means that it has any region that is not (a) erased or (b) late-bound.",765,[[["self"]],["bool"]]],[11,"has_erasable_regions","","True if there any any un-erased free regions.",765,[[["self"]],["bool"]]],[11,"is_global","","Indicates whether this value references only 'global' types/lifetimes that are the same regardless of what fn we are in. This is used for caching.",765,[[["self"]],["bool"]]],[11,"has_late_bound_regions","","True if there are any late-bound regions",765,[[["self"]],["bool"]]],[11,"visit_tys_shallow","","A visitor that does not recurse into types, works like `fn walk_shallow` in `Ty`.",765,N],[8,"TypeFolder","","The TypeFolder trait defines the actual folding. There is a method defined for every foldable type. Each of these has a default implementation that does an \"identity\" fold. Within each identity fold, it should invoke `foo.fold_with(self)` to fold each sub-item.",N,N],[10,"tcx","","",766,[[["self"]],["tyctxt"]]],[11,"fold_binder","","",766,[[["self"],["binder"]],["binder"]]],[11,"fold_ty","","",766,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",766,[[["self"],["region"]],["region"]]],[11,"fold_const","","",766,[[["self"],["const"]],["const"]]],[8,"TypeVisitor","","",N,N],[11,"visit_binder","","",767,[[["self"],["binder"]],["bool"]]],[11,"visit_ty","","",767,[[["self"],["ty"]],["bool"]]],[11,"visit_region","","",767,[[["self"],["region"]],["bool"]]],[11,"visit_const","","",767,[[["self"],["const"]],["bool"]]],[11,"tcx","","",759,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",759,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",759,[[["self"],["region"]],["region"]]],[11,"collect_regions","rustc::ty","Collects the free and escaping regions in `value` into `region_set`. Returns whether any late-bound regions were skipped",677,[[["self"],["t"],["fxhashset"]],["bool"]]],[11,"fold_regions","","Folds the escaping and free regions in `value` using `f`, and sets `skipped_regions` to true if any late-bound region was found and skipped.",677,N],[11,"for_each_free_region","","Invoke `callback` on every region appearing free in `value`.",677,N],[11,"all_free_regions_meet","","True if `callback` returns true for every region appearing free in `value`.",677,N],[11,"any_free_region_meets","","True if `callback` returns true for some region appearing free in `value`.",677,N],[11,"new","rustc::ty::fold","",760,[[["tyctxt"],["bool"],["fnmut"]],["regionfolder"]]],[11,"tcx","","",760,[[["self"]],["tyctxt"]]],[11,"fold_binder","","",760,[[["self"],["binder"]],["binder"]]],[11,"fold_region","","",760,[[["self"],["region"]],["region"]]],[11,"replace_late_bound_regions","rustc::ty","Replace all regions bound by the given `Binder` with the results returned by the closure; the closure is expected to return a free region (relative to this binder), and hence the binder is removed in the return type. The closure is invoked once for each unique `BoundRegion`; multiple references to the same `BoundRegion` will reuse the previous result.  A map is returned at the end with each bound region and the free region that replaced it.",677,N],[11,"liberate_late_bound_regions","","Replace any late-bound regions bound in `value` with free variants attached to `all_outlive_scope`.",677,[[["self"],["defid"],["binder"]],["t"]]],[11,"flatten_late_bound_regions","","Flattens multiple binding levels into one. So `for<'a> for<'b> Foo` becomes `for<'a,'b> Foo`.",677,[[["self"],["binder"]],["binder"]]],[11,"collect_constrained_late_bound_regions","","Returns a set of all late-bound regions that are constrained by `value`, meaning that if we instantiate those LBR with variables and equate `value` with something else, those variables will also be equated.",677,[[["self"],["binder"]],["fxhashset",["boundregion"]]]],[11,"collect_referenced_late_bound_regions","","Returns a set of all late-bound regions that appear in `value` anywhere.",677,[[["self"],["binder"]],["fxhashset",["boundregion"]]]],[11,"collect_late_bound_regions","","",677,[[["self"],["binder"],["bool"]],["fxhashset",["boundregion"]]]],[11,"erase_late_bound_regions","","Replace any late-bound regions bound in `value` with `'erased`. Useful in codegen but also method lookup and a few other places where precise region relationships are not required.",677,[[["self"],["binder"]],["t"]]],[11,"anonymize_late_bound_regions","","Rewrite any late-bound regions so that they are anonymous.  Region numbers are assigned starting at 1 and increasing monotonically in the order traversed by the fold operation.",677,[[["self"],["binder"]],["binder"]]],[11,"new","rustc::ty::fold","",761,[[["tyctxt"],["f"]],["regionreplacer"]]],[11,"tcx","","",761,[[["self"]],["tyctxt"]]],[11,"fold_binder","","",761,[[["self"],["binder"]],["binder"]]],[11,"fold_ty","","",761,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",761,[[["self"],["region"]],["region"]]],[11,"visit_binder","","",762,[[["self"],["binder"]],["bool"]]],[11,"visit_ty","","",762,[[["self"],["ty"]],["bool"]]],[11,"visit_region","","",762,[[["self"],["region"]],["bool"]]],[11,"visit_ty","","",763,[[["self"],["ty"]],["bool"]]],[11,"visit_region","","",763,[[["self"],["region"]],["bool"]]],[11,"visit_const","","",763,[[["self"],["const"]],["bool"]]],[11,"new","","",764,[[["bool"]],["self"]]],[11,"visit_binder","","",764,[[["self"],["binder"]],["bool"]]],[11,"visit_ty","","",764,[[["self"],["ty"]],["bool"]]],[11,"visit_region","","",764,[[["self"],["region"]],["bool"]]],[0,"inhabitedness","rustc::ty","",N,N],[3,"DefIdForest","rustc::ty::inhabitedness","Represents a forest of DefIds closed under the ancestor relation. That is, if a DefId representing a module is contained in the forest then all DefIds defined in that module or submodules are also implicitly contained in the forest.",N,N],[12,"root_ids","","The minimal set of DefIds required to represent the whole set. If A and B are DefIds in the DefIdForest, and A is a descendant of B, then only B will be in root_ids. We use a SmallVec here because (for its use for caching inhabitedness) its rare that this will contain even two ids.",768,N],[0,"def_id_forest","","",N,N],[3,"DefIdForest","rustc::ty::inhabitedness::def_id_forest","Represents a forest of DefIds closed under the ancestor relation. That is, if a DefId representing a module is contained in the forest then all DefIds defined in that module or submodules are also implicitly contained in the forest.",N,N],[12,"root_ids","","The minimal set of DefIds required to represent the whole set. If A and B are DefIds in the DefIdForest, and A is a descendant of B, then only B will be in root_ids. We use a SmallVec here because (for its use for caching inhabitedness) its rare that this will contain even two ids.",768,N],[11,"clone","rustc::ty::inhabitedness","",768,[[["self"]],["defidforest"]]],[11,"empty","","Create an empty forest.",768,[[],["defidforest"]]],[11,"full","","Create a forest consisting of a single tree representing the entire crate.",768,[[["tyctxt"]],["defidforest"]]],[11,"from_id","","Create a forest containing a DefId and all its descendants.",768,[[["defid"]],["defidforest"]]],[11,"is_empty","","Test whether the forest is empty.",768,[[["self"]],["bool"]]],[11,"contains","","Test whether the forest contains a given DefId.",768,[[["self"],["tyctxt"],["defid"]],["bool"]]],[11,"intersection","","Calculate the intersection of a collection of forests.",768,[[["tyctxt"],["i"]],["defidforest"]]],[11,"union","","Calculate the union of a collection of forests.",768,[[["tyctxt"],["i"]],["defidforest"]]],[11,"is_ty_uninhabited_from","rustc::ty","Checks whether a type is visibly uninhabited from a particular module. # Example ```rust enum Void {} mod a {     pub mod b {         pub struct SecretlyUninhabited {             _priv: !,         }     } }",677,[[["self"],["defid"],["ty"]],["bool"]]],[11,"is_ty_uninhabited_from_all_modules","","",677,[[["self"],["ty"]],["bool"]]],[11,"ty_inhabitedness_forest","","",677,[[["self"],["ty"]],["defidforest"]]],[11,"is_enum_variant_uninhabited_from","","",677,[[["self"],["defid"],["variantdef"],["substs"]],["bool"]]],[11,"is_variant_uninhabited_from_all_modules","","",677,[[["self"],["variantdef"],["substs"]],["bool"]]],[11,"variant_inhabitedness_forest","","",677,[[["self"],["variantdef"],["substs"]],["defidforest"]]],[11,"uninhabited_from","","Calculate the forest of DefIds from which this adt is visibly uninhabited.",713,[[["self"],["fxhashmap"],["tyctxt"],["substs"]],["defidforest"]]],[11,"uninhabited_from","","Calculate the forest of DefIds from which this variant is visibly uninhabited.",711,[[["self"],["fxhashmap"],["tyctxt"],["substs"],["adtkind"]],["defidforest"]]],[11,"uninhabited_from","","Calculate the forest of DefIds from which this field is visibly uninhabited.",712,[[["self"],["fxhashmap"],["tyctxt"],["substs"],["bool"]],["defidforest"]]],[11,"uninhabited_from","","Calculate the forest of DefIds from which this type is visibly uninhabited.",689,[[["self"],["fxhashmap"],["tyctxt"]],["defidforest"]]],[0,"item_path","","",N,N],[3,"LocalPathBuffer","rustc::ty::item_path","",N,N],[12,"root_mode","","",769,N],[12,"str","","",769,N],[4,"RootMode","","",N,N],[13,"Local","","Try to make a path relative to the local crate.  In particular, local paths have no prefix, and if the path comes from an extern crate, start with the path to the `extern crate` declaration.",770,N],[13,"Absolute","","Always prepend the crate name to the path, forming an absolute path from within a given set of crates.",770,N],[5,"with_forced_absolute_paths","","Enforces that item_path_str always returns an absolute path and also enables \"type-based\" impl paths. This is used when building symbols that contain types, where we want the crate name to be part of the symbol.",N,[[["f"]],["r"]]],[5,"with_forced_impl_filename_line","","Force us to name impls with just the filename/line number. We normally try to use types. But at some points, notably while printing cycle errors, this can result in extra or suboptimal error output, so this variable disables that check.",N,[[["f"]],["r"]]],[5,"characteristic_def_id_of_type","","As a heuristic, when we see an impl, if we see that the 'self-type' is a type defined in the same module as the impl, we can omit including the path to the impl itself. This function tries to find a \"characteristic def-id\" for a type. It's just a heuristic so it makes some questionable decisions and we may want to adjust it later.",N,[[["ty"]],["option",["defid"]]]],[17,"FORCE_ABSOLUTE","","",N,N],[17,"FORCE_IMPL_FILENAME_LINE","","",N,N],[8,"ItemPathBuffer","","Unifying Trait for different kinds of item paths we might construct. The basic interface is that components get pushed: the instance can also customize how we handle the root of a crate.",N,N],[10,"root_mode","","",771,[[["self"]],["rootmode"]]],[10,"push","","",771,[[["self"],["str"]]]],[11,"item_path_str","rustc::ty","Returns a string identifying this def-id. This string is suitable for user output. It is relative to the current crate root, unless with_forced_absolute_paths was used.",677,[[["self"],["defid"]],["string"]]],[11,"node_path_str","","Returns a string identifying this local node-id.",677,[[["self"],["nodeid"]],["string"]]],[11,"absolute_item_path_str","","Returns a string identifying this def-id. This string is suitable for user output. It always begins with a crate identifier.",677,[[["self"],["defid"]],["string"]]],[11,"push_krate_path","","Returns the \"path\" to a particular crate. This can proceed in various ways, depending on the `root_mode` of the `buffer`. (See `RootMode` enum for more details.)",677,[[["self"],["t"],["cratenum"]]]],[11,"try_push_visible_item_path","","If possible, this pushes a global path resolving to `external_def_id` that is visible from at least one local module and returns true. If the crate defining `external_def_id` is declared with an `extern crate`, the path is guaranteed to use the `extern crate`.",677,[[["self"],["t"],["defid"]],["bool"]]],[11,"push_item_path","","",677,[[["self"],["t"],["defid"]]]],[11,"push_impl_path","","",677,[[["self"],["t"],["defid"]]]],[11,"push_impl_path_fallback","","",677,[[["self"],["t"],["defid"]]]],[11,"parent_def_id","","Returns the def-id of `def_id`'s parent in the def tree. If this returns `None`, then `def_id` represents a crate root or inlined root.",677,[[["self"],["defid"]],["option",["defid"]]]],[11,"fmt","rustc::ty::item_path","",770,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",769,[[["self"],["formatter"]],["result"]]],[11,"new","","",769,[[["rootmode"]],["localpathbuffer"]]],[11,"into_string","","",769,[[["self"]],["string"]]],[11,"root_mode","","",769,[[["self"]],["rootmode"]]],[11,"push","","",769,[[["self"],["str"]]]],[0,"layout","rustc::ty","",N,N],[0,"call","rustc::ty::layout","",N,N],[4,"PassMode","rustc::ty::layout::call","",N,N],[13,"Ignore","","Ignore the argument (useful for empty struct).",772,N],[13,"Direct","","Pass the argument directly.",772,N],[13,"Pair","","Pass a pair's elements directly in two arguments.",772,N],[13,"Cast","","Pass the argument after casting it, to either a single uniform or a pair of registers.",772,N],[13,"Indirect","","Pass the argument indirectly via a hidden pointer. The second value, if any, is for the extra data (vtable or length) which indicates that it refers to an unsized rvalue.",772,N],[3,"ArgAttributes","","A compact representation of LLVM attributes (at least those relevant for this module) that can be manipulated without interacting with LLVM's Attribute machinery.",N,N],[12,"regular","","",773,N],[12,"pointee_size","","",773,N],[12,"pointee_align","","",773,N],[4,"RegKind","","",N,N],[13,"Integer","","",774,N],[13,"Float","","",774,N],[13,"Vector","","",774,N],[3,"Reg","","",N,N],[12,"kind","","",775,N],[12,"size","","",775,N],[3,"Uniform","","An argument passed entirely registers with the same kind (e.g. HFA / HVA on PPC64 and AArch64).",N,N],[12,"unit","","",776,N],[12,"total","","The total size of the argument, which can be: * equal to `unit.size` (one scalar/vector) * a multiple of `unit.size` (an array of scalar/vectors) * if `unit.kind` is `Integer`, the last element   can be shorter, i.e. `{ i64, i64, i32 }` for   64-bit integers with a total size of 20 bytes",776,N],[3,"CastTarget","","",N,N],[12,"prefix","","",777,N],[12,"prefix_chunk","","",777,N],[12,"rest","","",777,N],[3,"ArgType","","Information about how to pass an argument to, or return a value from, a function, under some ABI.",N,N],[12,"layout","","",778,N],[12,"pad","","Dummy argument, which is emitted before the real argument.",778,N],[12,"mode","","",778,N],[4,"Conv","","",N,N],[13,"C","","",779,N],[13,"ArmAapcs","","",779,N],[13,"Msp430Intr","","",779,N],[13,"PtxKernel","","",779,N],[13,"X86Fastcall","","",779,N],[13,"X86Intr","","",779,N],[13,"X86Stdcall","","",779,N],[13,"X86ThisCall","","",779,N],[13,"X86VectorCall","","",779,N],[13,"X86_64SysV","","",779,N],[13,"X86_64Win64","","",779,N],[13,"AmdGpuKernel","","",779,N],[3,"FnType","","Metadata describing how the arguments to a native function should be passed in order to respect the native ABI.",N,N],[12,"args","","The LLVM types of each argument.",780,N],[12,"ret","","LLVM return type.",780,N],[12,"variadic","","",780,N],[12,"conv","","",780,N],[3,"ArgAttribute","","",N,N],[12,"bits","","",781,N],[3,"TargetDataLayout","rustc::ty::layout","Parsed Data layout for a target, which contains everything needed to compute layouts.",N,N],[12,"endian","","",782,N],[12,"i1_align","","",782,N],[12,"i8_align","","",782,N],[12,"i16_align","","",782,N],[12,"i32_align","","",782,N],[12,"i64_align","","",782,N],[12,"i128_align","","",782,N],[12,"f32_align","","",782,N],[12,"f64_align","","",782,N],[12,"pointer_size","","",782,N],[12,"pointer_align","","",782,N],[12,"aggregate_align","","",782,N],[12,"vector_align","","Alignments for vector types.",782,N],[8,"HasDataLayout","","",N,N],[10,"data_layout","","",783,[[["self"]],["targetdatalayout"]]],[4,"Endian","","Endianness of the target, which must match cfg(target-endian).",N,N],[13,"Little","","",784,N],[13,"Big","","",784,N],[3,"Size","","Size of a type in bytes.",N,N],[12,"raw","","",785,N],[3,"Align","","Alignment of a type in bytes, both ABI-mandated and preferred. Each field is a power of two, giving the alignment a maximum value of 2(28 - 1), which is limited by LLVM to a maximum capacity of 229 or 536870912.",N,N],[12,"abi_pow2","","",786,N],[12,"pref_pow2","","",786,N],[4,"Integer","","Integers, also used for enum discriminants.",N,N],[13,"I8","","",787,N],[13,"I16","","",787,N],[13,"I32","","",787,N],[13,"I64","","",787,N],[13,"I128","","",787,N],[4,"FloatTy","","",N,N],[13,"F32","","",788,N],[13,"F64","","",788,N],[4,"Primitive","","Fundamental unit of memory access and layout.",N,N],[13,"Int","","The `bool` is the signedness of the `Integer` type.",789,N],[13,"Float","","",789,N],[13,"Pointer","","",789,N],[3,"Scalar","","Information about one scalar component of a Rust type.",N,N],[12,"value","","",790,N],[12,"valid_range","","Inclusive wrap-around range of valid values, that is, if start > end, it represents `start..=max_value()`, followed by `0..=end`.",790,N],[4,"FieldPlacement","","Describes how the fields of a type are located in memory.",N,N],[13,"Union","","All fields start at no offset. The `usize` is the field count.",791,N],[13,"Array","","Array/vector-like placement, with all fields of identical types.",791,N],[12,"stride","rustc::ty::layout::FieldPlacement","",791,N],[12,"count","","",791,N],[13,"Arbitrary","rustc::ty::layout","Struct-like placement, with precomputed offsets.",791,N],[12,"offsets","rustc::ty::layout::FieldPlacement","Offsets for the first byte of each field, ordered to match the source definition order. This vector does not go in increasing order.",791,N],[12,"memory_index","","Maps source order field indices to memory order indices, depending how fields were permuted.",791,N],[4,"Abi","rustc::ty::layout","Describes how values of the type are passed by target ABIs, in terms of categories of C types there are ABI rules for.",N,N],[13,"Uninhabited","","",792,N],[13,"Scalar","","",792,N],[13,"ScalarPair","","",792,N],[13,"Vector","","",792,N],[12,"element","rustc::ty::layout::Abi","",792,N],[12,"count","","",792,N],[13,"Aggregate","rustc::ty::layout","",792,N],[12,"sized","rustc::ty::layout::Abi","If true, the size is exact, otherwise it's only a lower bound.",792,N],[4,"Variants","rustc::ty::layout","",N,N],[13,"Single","","Single enum variants, structs/tuples, unions, and all non-ADTs.",793,N],[12,"index","rustc::ty::layout::Variants","",793,N],[13,"Tagged","rustc::ty::layout","General-case enums: for each case there is a struct, and they all have all space reserved for the tag, and their first field starts at a non-0 offset, after where the tag would go.",793,N],[12,"tag","rustc::ty::layout::Variants","",793,N],[12,"variants","","",793,N],[13,"NicheFilling","rustc::ty::layout","Multiple cases distinguished by a niche (values invalid for a type): the variant `dataful_variant` contains a niche at an arbitrary offset (field 0 of the enum), which for a variant with discriminant `d` is set to `(d - niche_variants.start).wrapping_add(niche_start)`.",793,N],[12,"dataful_variant","rustc::ty::layout::Variants","",793,N],[12,"niche_variants","","",793,N],[12,"niche","","",793,N],[12,"niche_start","","",793,N],[12,"variants","","",793,N],[3,"LayoutDetails","rustc::ty::layout","",N,N],[12,"variants","","",794,N],[12,"fields","","",794,N],[12,"abi","","",794,N],[12,"align","","",794,N],[12,"size","","",794,N],[3,"TyLayout","","The details of the layout of a type, alongside the type itself. Provides various type traversal APIs (e.g. recursing into fields).",N,N],[12,"ty","","",795,N],[12,"details","","",795,N],[8,"LayoutOf","","",N,N],[16,"Ty","","",796,N],[16,"TyLayout","","",796,N],[10,"layout_of","","",796,N],[8,"TyLayoutMethods","","",N,N],[10,"for_variant","","",797,[[["tylayout"],["c"],["usize"]],["tylayout"]]],[10,"field","","",797,N],[3,"LayoutCx","","",N,N],[12,"tcx","","",798,N],[12,"param_env","","",798,N],[3,"Niche","","",N,N],[12,"offset","","",799,N],[12,"scalar","","",799,N],[12,"available","","",799,N],[4,"LayoutError","","",N,N],[13,"Unknown","","",800,N],[13,"SizeOverflow","","",800,N],[4,"SizeSkeleton","","Type size \"skeleton\", i.e. the only information determining a type's size. While this is conservative, (aside from constant sizes, only pointers, newtypes thereof and null pointer optimized enums are allowed), it is enough to statically check common usecases of transmute.",N,N],[13,"Known","","Any statically computable Layout.",801,N],[13,"Pointer","","A potentially-fat pointer.",801,N],[12,"non_zero","rustc::ty::layout::SizeSkeleton","If true, this pointer is never null.",801,N],[12,"tail","","The type which determines the unsized metadata, if any, of this pointer. Either a type parameter or a projection depending on one, with regions erased.",801,N],[5,"layout_raw","rustc::ty::layout","",N,[[["tyctxt"],["paramenvand",["ty"]]],["result",["layoutdetails","layouterror"]]]],[5,"provide","","",N,[[["providers"]]]],[6,"TyLayout","","",N,N],[17,"FAT_PTR_ADDR","","The first half of a fat pointer.",N,N],[17,"FAT_PTR_EXTRA","","The second half of a fat pointer.",N,N],[8,"IntegerExt","","",N,N],[10,"to_ty","","",802,[[["self"],["tyctxt"],["bool"]],["ty"]]],[10,"from_attr","","",802,[[["c"],["inttype"]],["integer"]]],[10,"repr_discr","","",802,N],[8,"PrimitiveExt","","",N,N],[10,"to_ty","","",803,[[["self"],["tyctxt"]],["ty"]]],[8,"HasTyCtxt","","",N,N],[10,"tcx","","",804,[[["self"]],["tyctxt"]]],[8,"MaybeResult","","",N,N],[10,"from_ok","","",805,[[["t"]],["self"]]],[10,"map_same","","",805,[[["self"],["f"]],["self"]]],[11,"to_ty","","",787,[[["self"],["tyctxt"],["bool"]],["ty"]]],[11,"from_attr","","Get the Integer type from an attr::IntType.",787,[[["c"],["inttype"]],["integer"]]],[11,"repr_discr","","Find the appropriate Integer type and signedness for the given signed discriminant range and #[repr] attribute. N.B.: u128 values above i128::MAX will be treated as signed, but that shouldn't affect anything, other than maybe debuginfo.",787,N],[11,"to_ty","","",789,[[["self"],["tyctxt"]],["ty"]]],[11,"clone","","",800,[[["self"]],["layouterror"]]],[11,"fmt","","",800,[[["self"],["formatter"]],["result"]]],[11,"encode","","",800,[[["self"],["__s"]],["result"]]],[11,"decode","","",800,[[["__d"]],["result",["layouterror"]]]],[11,"fmt","","",800,[[["self"],["formatter"]],["result"]]],[11,"clone","","",798,[[["self"]],["layoutcx"]]],[11,"layout_raw_uncached","","",798,[[["self"],["ty"]],["result",["layoutdetails","layouterror"]]]],[11,"record_layout_for_printing","","This is invoked by the `layout_raw` query to record the final layout of each type.",798,[[["self"],["tylayout"]]]],[11,"record_layout_for_printing_outlined","","",798,[[["self"],["tylayout"]]]],[11,"clone","","",801,[[["self"]],["sizeskeleton"]]],[11,"fmt","","",801,[[["self"],["formatter"]],["result"]]],[11,"compute","","",801,[[["ty"],["tyctxt"],["paramenv"]],["result",["sizeskeleton","layouterror"]]]],[11,"same_size","","",801,[[["self"],["sizeskeleton"]],["bool"]]],[11,"data_layout","rustc::ty","",677,[[["self"]],["targetdatalayout"]]],[11,"tcx","","",677,[[["self"]],["tyctxt"]]],[11,"data_layout","rustc::ty::layout","",798,[[["self"]],["targetdatalayout"]]],[11,"tcx","","",798,[[["self"]],["tyctxt"]]],[11,"layout_of","","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",798,N],[11,"layout_of","","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",798,N],[11,"layout_of","rustc::ty","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",677,[[["self"],["paramenvand",["ty"]]],["result",["tylayout","layouterror"]]]],[11,"reserve","rustc::ty::layout","",799,[[["self"],["layoutcx",["tyctxt"]],["u128"]],["option"]]],[11,"find_niche","","Find the offset of a niche leaf field, starting from the given type and recursing through aggregates.",798,[[["self"],["tylayout"]],["result",["option","layouterror"]]]],[11,"hash_stable","","",793,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",791,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",792,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",790,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",794,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",787,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",789,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",786,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",785,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",800,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"_match","rustc::ty","",N,N],[3,"Match","rustc::ty::_match","A type \"A\" matches \"B\" if the fresh types in B could be substituted with values so as to make it equal to A. Matching is intended to be used only on freshened types, and it basically indicates if the non-freshened versions of A and B could have been unified.",N,N],[12,"tcx","","",806,N],[11,"new","","",806,[[["tyctxt"]],["match"]]],[11,"tag","","",806,[[["self"]],["str"]]],[11,"tcx","","",806,[[["self"]],["tyctxt"]]],[11,"a_is_expected","","",806,[[["self"]],["bool"]]],[11,"relate_with_variance","","",806,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"regions","","",806,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"tys","","",806,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"binders","","",806,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[0,"outlives","rustc::ty","",N,N],[4,"Component","rustc::ty::outlives","",N,N],[13,"Region","","",807,N],[13,"Param","","",807,N],[13,"UnresolvedInferenceVariable","","",807,N],[13,"Projection","","",807,N],[13,"EscapingProjection","","",807,N],[5,"push_region_constraints","","",N,[[["vec"],["vec",["region"]]]]],[11,"fmt","","",807,[[["self"],["formatter"]],["result"]]],[11,"outlives_components","rustc::ty","Returns all the things that must outlive `'a` for the condition `ty0: 'a` to hold. Note that `ty0` must be a fully resolved type.",677,[[["self"],["ty"]],["vec",["component"]]]],[11,"compute_components","","",677,[[["self"],["ty"],["vec"]]]],[11,"capture_components","","",677,[[["self"],["ty"]],["vec",["component"]]]],[0,"query","","",N,N],[3,"CycleError","rustc::ty::query","",N,N],[12,"usage","","The query and related span which uses the cycle",808,N],[12,"cycle","","",808,N],[3,"QueryJob","","A object representing an active query job.",N,N],[12,"info","","",809,N],[12,"parent","","The parent query job which created this job and is implicitly waiting on it.",809,N],[12,"diagnostics","","Diagnostic messages which are emitted while the query executes",809,N],[3,"QueryInfo","","A span and a query key",N,N],[12,"span","","The span for a reason this query was required",810,N],[12,"query","","",810,N],[3,"OnDiskCache","","`OnDiskCache` provides an interface to incr. comp. data cached from the previous compilation session. This data will eventually include the results of a few selected queries (like `typeck_tables_of` and `mir_optimized`) and any diagnostics that have been emitted during a query.",N,N],[12,"serialized_data","","",811,N],[12,"current_diagnostics","","",811,N],[12,"prev_cnums","","",811,N],[12,"cnum_map","","",811,N],[12,"source_map","","",811,N],[12,"file_index_to_stable_id","","",811,N],[12,"file_index_to_file","","",811,N],[12,"synthetic_expansion_infos","","",811,N],[12,"query_result_index","","",811,N],[12,"prev_diagnostics_index","","",811,N],[12,"alloc_decoding_state","","",811,N],[3,"Queries","","",N,N],[12,"on_disk_cache","","This provides access to the incr. comp. on-disk cache for query results. Do not access this directly. It is only meant to be used by `DepGraph::try_mark_green()` and the query infrastructure.",812,N],[12,"providers","","",812,N],[12,"fallback_extern_providers","","",812,N],[12,"type_of","","Records the type of every item.",812,N],[12,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics.",812,N],[12,"predicates_of","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) that must be proven true in order to reference it. This is almost always the \"predicates query\" that you want.",812,N],[12,"predicates_defined_on","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) directly defined on it. This is equal to the `explicit_predicates_of` predicates plus the `inferred_outlives_of` predicates.",812,N],[12,"explicit_predicates_of","","Returns the predicates written explicit by the user.",812,N],[12,"inferred_outlives_of","","Returns the inferred outlives predicates (e.g., for `struct Foo<'a, T> { x: &'a T }`, this would return `T: 'a`).",812,N],[12,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",812,N],[12,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",812,N],[12,"trait_def","","",812,N],[12,"adt_def","","",812,N],[12,"adt_destructor","","",812,N],[12,"adt_sized_constraint","","",812,N],[12,"adt_dtorck_constraint","","",812,N],[12,"is_const_fn","","True if this is a const fn",812,N],[12,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",812,N],[12,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",812,N],[12,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",812,N],[12,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",812,N],[12,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",812,N],[12,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",812,N],[12,"impl_trait_ref","","",812,N],[12,"impl_polarity","","",812,N],[12,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",812,N],[12,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",812,N],[12,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",812,N],[12,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",812,N],[12,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",812,N],[12,"mir_validated","","",812,N],[12,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for codegen. This is also the only query that can fetch non-local MIR, at present.",812,N],[12,"unsafety_check_result","","The result of unsafety-checking this def-id.",812,N],[12,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",812,N],[12,"fn_sig","","The signature of functions and closures.",812,N],[12,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",812,N],[12,"typeck_item_bodies","","",812,N],[12,"typeck_tables_of","","",812,N],[12,"used_trait_imports","","",812,N],[12,"has_typeck_tables","","",812,N],[12,"coherent_trait","","",812,N],[12,"borrowck","","",812,N],[12,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",812,N],[12,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",812,N],[12,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",812,N],[12,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",812,N],[12,"check_match","","",812,N],[12,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",812,N],[12,"reachable_set","","",812,N],[12,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",812,N],[12,"mir_shims","","",812,N],[12,"def_symbol_name","","",812,N],[12,"symbol_name","","",812,N],[12,"describe_def","","",812,N],[12,"def_span","","",812,N],[12,"lookup_stability","","",812,N],[12,"lookup_deprecation_entry","","",812,N],[12,"item_attrs","","",812,N],[12,"codegen_fn_attrs","","",812,N],[12,"fn_arg_names","","",812,N],[12,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",812,N],[12,"impl_parent","","",812,N],[12,"trait_of_item","","",812,N],[12,"const_is_rvalue_promotable_to_static","","",812,N],[12,"rvalue_promotable_map","","",812,N],[12,"is_mir_available","","",812,N],[12,"vtable_methods","","",812,N],[12,"codegen_fulfill_obligation","","",812,N],[12,"trait_impls_of","","",812,N],[12,"specialization_graph_of","","",812,N],[12,"is_object_safe","","",812,N],[12,"param_env","","",812,N],[12,"is_copy_raw","","",812,N],[12,"is_sized_raw","","",812,N],[12,"is_freeze_raw","","",812,N],[12,"needs_drop_raw","","",812,N],[12,"layout_raw","","",812,N],[12,"dylib_dependency_formats","","",812,N],[12,"is_panic_runtime","","",812,N],[12,"is_compiler_builtins","","",812,N],[12,"has_global_allocator","","",812,N],[12,"has_panic_handler","","",812,N],[12,"is_sanitizer_runtime","","",812,N],[12,"is_profiler_runtime","","",812,N],[12,"panic_strategy","","",812,N],[12,"is_no_builtins","","",812,N],[12,"extern_crate","","",812,N],[12,"specializes","","",812,N],[12,"in_scope_traits_map","","",812,N],[12,"module_exports","","",812,N],[12,"lint_levels","","",812,N],[12,"impl_defaultness","","",812,N],[12,"check_item_well_formed","","",812,N],[12,"check_trait_item_well_formed","","",812,N],[12,"check_impl_item_well_formed","","",812,N],[12,"reachable_non_generics","","",812,N],[12,"is_reachable_non_generic","","",812,N],[12,"is_unreachable_local_definition","","",812,N],[12,"upstream_monomorphizations","","",812,N],[12,"upstream_monomorphizations_for","","",812,N],[12,"native_libraries","","",812,N],[12,"foreign_modules","","",812,N],[12,"plugin_registrar_fn","","",812,N],[12,"derive_registrar_fn","","",812,N],[12,"crate_disambiguator","","",812,N],[12,"crate_hash","","",812,N],[12,"original_crate_name","","",812,N],[12,"extra_filename","","",812,N],[12,"implementations_of_trait","","",812,N],[12,"all_trait_implementations","","",812,N],[12,"dllimport_foreign_items","","",812,N],[12,"is_dllimport_foreign_item","","",812,N],[12,"is_statically_included_foreign_item","","",812,N],[12,"native_library_kind","","",812,N],[12,"link_args","","",812,N],[12,"resolve_lifetimes","","",812,N],[12,"named_region_map","","",812,N],[12,"is_late_bound_map","","",812,N],[12,"object_lifetime_defaults_map","","",812,N],[12,"visibility","","",812,N],[12,"dep_kind","","",812,N],[12,"crate_name","","",812,N],[12,"item_children","","",812,N],[12,"extern_mod_stmt_cnum","","",812,N],[12,"get_lib_features","","",812,N],[12,"defined_lib_features","","",812,N],[12,"get_lang_items","","",812,N],[12,"defined_lang_items","","",812,N],[12,"missing_lang_items","","",812,N],[12,"visible_parent_map","","",812,N],[12,"missing_extern_crate_item","","",812,N],[12,"used_crate_source","","",812,N],[12,"postorder_cnums","","",812,N],[12,"freevars","","",812,N],[12,"maybe_unused_trait_import","","",812,N],[12,"maybe_unused_extern_crates","","",812,N],[12,"stability_index","","",812,N],[12,"all_crate_nums","","",812,N],[12,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",812,N],[12,"exported_symbols","","",812,N],[12,"collect_and_partition_mono_items","","",812,N],[12,"is_codegened_item","","",812,N],[12,"codegen_unit","","",812,N],[12,"output_filenames","","",812,N],[12,"erase_regions_ty","","",812,N],[12,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",812,N],[12,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",812,N],[12,"implied_outlives_bounds","","",812,N],[12,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",812,N],[12,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",812,N],[12,"type_op_eq","","Do not call this query directly: part of the `Eq` type-op",812,N],[12,"type_op_subtype","","Do not call this query directly: part of the `Subtype` type-op",812,N],[12,"type_op_prove_predicate","","Do not call this query directly: part of the `ProvePredicate` type-op",812,N],[12,"type_op_normalize_ty","","Do not call this query directly: part of the `Normalize` type-op",812,N],[12,"type_op_normalize_predicate","","Do not call this query directly: part of the `Normalize` type-op",812,N],[12,"type_op_normalize_poly_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",812,N],[12,"type_op_normalize_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",812,N],[12,"substitute_normalize_and_test_predicates","","",812,N],[12,"target_features_whitelist","","",812,N],[12,"instance_def_size_estimate","","",812,N],[12,"features_query","","",812,N],[12,"program_clauses_for","","",812,N],[12,"program_clauses_for_env","","",812,N],[12,"wasm_import_module_map","","",812,N],[3,"TyCtxtAt","","",N,N],[12,"tcx","","",813,N],[12,"span","","",813,N],[3,"Providers","","",N,N],[12,"type_of","","",814,N],[12,"generics_of","","",814,N],[12,"predicates_of","","",814,N],[12,"predicates_defined_on","","",814,N],[12,"explicit_predicates_of","","",814,N],[12,"inferred_outlives_of","","",814,N],[12,"super_predicates_of","","",814,N],[12,"type_param_predicates","","",814,N],[12,"trait_def","","",814,N],[12,"adt_def","","",814,N],[12,"adt_destructor","","",814,N],[12,"adt_sized_constraint","","",814,N],[12,"adt_dtorck_constraint","","",814,N],[12,"is_const_fn","","",814,N],[12,"is_foreign_item","","",814,N],[12,"crate_variances","","",814,N],[12,"variances_of","","",814,N],[12,"inferred_outlives_crate","","",814,N],[12,"associated_item_def_ids","","",814,N],[12,"associated_item","","",814,N],[12,"impl_trait_ref","","",814,N],[12,"impl_polarity","","",814,N],[12,"inherent_impls","","",814,N],[12,"mir_keys","","",814,N],[12,"mir_const_qualif","","",814,N],[12,"mir_built","","",814,N],[12,"mir_const","","",814,N],[12,"mir_validated","","",814,N],[12,"optimized_mir","","",814,N],[12,"unsafety_check_result","","",814,N],[12,"unsafe_derive_on_repr_packed","","",814,N],[12,"fn_sig","","",814,N],[12,"coerce_unsized_info","","",814,N],[12,"typeck_item_bodies","","",814,N],[12,"typeck_tables_of","","",814,N],[12,"used_trait_imports","","",814,N],[12,"has_typeck_tables","","",814,N],[12,"coherent_trait","","",814,N],[12,"borrowck","","",814,N],[12,"mir_borrowck","","",814,N],[12,"crate_inherent_impls","","",814,N],[12,"crate_inherent_impls_overlap_check","","",814,N],[12,"const_eval","","",814,N],[12,"check_match","","",814,N],[12,"privacy_access_levels","","",814,N],[12,"reachable_set","","",814,N],[12,"region_scope_tree","","",814,N],[12,"mir_shims","","",814,N],[12,"def_symbol_name","","",814,N],[12,"symbol_name","","",814,N],[12,"describe_def","","",814,N],[12,"def_span","","",814,N],[12,"lookup_stability","","",814,N],[12,"lookup_deprecation_entry","","",814,N],[12,"item_attrs","","",814,N],[12,"codegen_fn_attrs","","",814,N],[12,"fn_arg_names","","",814,N],[12,"rendered_const","","",814,N],[12,"impl_parent","","",814,N],[12,"trait_of_item","","",814,N],[12,"const_is_rvalue_promotable_to_static","","",814,N],[12,"rvalue_promotable_map","","",814,N],[12,"is_mir_available","","",814,N],[12,"vtable_methods","","",814,N],[12,"codegen_fulfill_obligation","","",814,N],[12,"trait_impls_of","","",814,N],[12,"specialization_graph_of","","",814,N],[12,"is_object_safe","","",814,N],[12,"param_env","","",814,N],[12,"is_copy_raw","","",814,N],[12,"is_sized_raw","","",814,N],[12,"is_freeze_raw","","",814,N],[12,"needs_drop_raw","","",814,N],[12,"layout_raw","","",814,N],[12,"dylib_dependency_formats","","",814,N],[12,"is_panic_runtime","","",814,N],[12,"is_compiler_builtins","","",814,N],[12,"has_global_allocator","","",814,N],[12,"has_panic_handler","","",814,N],[12,"is_sanitizer_runtime","","",814,N],[12,"is_profiler_runtime","","",814,N],[12,"panic_strategy","","",814,N],[12,"is_no_builtins","","",814,N],[12,"extern_crate","","",814,N],[12,"specializes","","",814,N],[12,"in_scope_traits_map","","",814,N],[12,"module_exports","","",814,N],[12,"lint_levels","","",814,N],[12,"impl_defaultness","","",814,N],[12,"check_item_well_formed","","",814,N],[12,"check_trait_item_well_formed","","",814,N],[12,"check_impl_item_well_formed","","",814,N],[12,"reachable_non_generics","","",814,N],[12,"is_reachable_non_generic","","",814,N],[12,"is_unreachable_local_definition","","",814,N],[12,"upstream_monomorphizations","","",814,N],[12,"upstream_monomorphizations_for","","",814,N],[12,"native_libraries","","",814,N],[12,"foreign_modules","","",814,N],[12,"plugin_registrar_fn","","",814,N],[12,"derive_registrar_fn","","",814,N],[12,"crate_disambiguator","","",814,N],[12,"crate_hash","","",814,N],[12,"original_crate_name","","",814,N],[12,"extra_filename","","",814,N],[12,"implementations_of_trait","","",814,N],[12,"all_trait_implementations","","",814,N],[12,"dllimport_foreign_items","","",814,N],[12,"is_dllimport_foreign_item","","",814,N],[12,"is_statically_included_foreign_item","","",814,N],[12,"native_library_kind","","",814,N],[12,"link_args","","",814,N],[12,"resolve_lifetimes","","",814,N],[12,"named_region_map","","",814,N],[12,"is_late_bound_map","","",814,N],[12,"object_lifetime_defaults_map","","",814,N],[12,"visibility","","",814,N],[12,"dep_kind","","",814,N],[12,"crate_name","","",814,N],[12,"item_children","","",814,N],[12,"extern_mod_stmt_cnum","","",814,N],[12,"get_lib_features","","",814,N],[12,"defined_lib_features","","",814,N],[12,"get_lang_items","","",814,N],[12,"defined_lang_items","","",814,N],[12,"missing_lang_items","","",814,N],[12,"visible_parent_map","","",814,N],[12,"missing_extern_crate_item","","",814,N],[12,"used_crate_source","","",814,N],[12,"postorder_cnums","","",814,N],[12,"freevars","","",814,N],[12,"maybe_unused_trait_import","","",814,N],[12,"maybe_unused_extern_crates","","",814,N],[12,"stability_index","","",814,N],[12,"all_crate_nums","","",814,N],[12,"all_traits","","",814,N],[12,"exported_symbols","","",814,N],[12,"collect_and_partition_mono_items","","",814,N],[12,"is_codegened_item","","",814,N],[12,"codegen_unit","","",814,N],[12,"output_filenames","","",814,N],[12,"erase_regions_ty","","",814,N],[12,"normalize_projection_ty","","",814,N],[12,"normalize_ty_after_erasing_regions","","",814,N],[12,"implied_outlives_bounds","","",814,N],[12,"dropck_outlives","","",814,N],[12,"evaluate_obligation","","",814,N],[12,"type_op_eq","","",814,N],[12,"type_op_subtype","","",814,N],[12,"type_op_prove_predicate","","",814,N],[12,"type_op_normalize_ty","","",814,N],[12,"type_op_normalize_predicate","","",814,N],[12,"type_op_normalize_poly_fn_sig","","",814,N],[12,"type_op_normalize_fn_sig","","",814,N],[12,"substitute_normalize_and_test_predicates","","",814,N],[12,"target_features_whitelist","","",814,N],[12,"instance_def_size_estimate","","",814,N],[12,"features_query","","",814,N],[12,"program_clauses_for","","",814,N],[12,"program_clauses_for_env","","",814,N],[12,"wasm_import_module_map","","",814,N],[4,"Query","","",N,N],[13,"type_of","","Records the type of every item.",815,N],[13,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics.",815,N],[13,"predicates_of","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) that must be proven true in order to reference it. This is almost always the \"predicates query\" that you want.",815,N],[13,"predicates_defined_on","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) directly defined on it. This is equal to the `explicit_predicates_of` predicates plus the `inferred_outlives_of` predicates.",815,N],[13,"explicit_predicates_of","","Returns the predicates written explicit by the user.",815,N],[13,"inferred_outlives_of","","Returns the inferred outlives predicates (e.g., for `struct Foo<'a, T> { x: &'a T }`, this would return `T: 'a`).",815,N],[13,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",815,N],[13,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",815,N],[13,"trait_def","","",815,N],[13,"adt_def","","",815,N],[13,"adt_destructor","","",815,N],[13,"adt_sized_constraint","","",815,N],[13,"adt_dtorck_constraint","","",815,N],[13,"is_const_fn","","True if this is a const fn",815,N],[13,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",815,N],[13,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",815,N],[13,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",815,N],[13,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",815,N],[13,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",815,N],[13,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",815,N],[13,"impl_trait_ref","","",815,N],[13,"impl_polarity","","",815,N],[13,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",815,N],[13,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",815,N],[13,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",815,N],[13,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",815,N],[13,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",815,N],[13,"mir_validated","","",815,N],[13,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for codegen. This is also the only query that can fetch non-local MIR, at present.",815,N],[13,"unsafety_check_result","","The result of unsafety-checking this def-id.",815,N],[13,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",815,N],[13,"fn_sig","","The signature of functions and closures.",815,N],[13,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",815,N],[13,"typeck_item_bodies","","",815,N],[13,"typeck_tables_of","","",815,N],[13,"used_trait_imports","","",815,N],[13,"has_typeck_tables","","",815,N],[13,"coherent_trait","","",815,N],[13,"borrowck","","",815,N],[13,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",815,N],[13,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",815,N],[13,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",815,N],[13,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",815,N],[13,"check_match","","",815,N],[13,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",815,N],[13,"reachable_set","","",815,N],[13,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",815,N],[13,"mir_shims","","",815,N],[13,"def_symbol_name","","",815,N],[13,"symbol_name","","",815,N],[13,"describe_def","","",815,N],[13,"def_span","","",815,N],[13,"lookup_stability","","",815,N],[13,"lookup_deprecation_entry","","",815,N],[13,"item_attrs","","",815,N],[13,"codegen_fn_attrs","","",815,N],[13,"fn_arg_names","","",815,N],[13,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",815,N],[13,"impl_parent","","",815,N],[13,"trait_of_item","","",815,N],[13,"const_is_rvalue_promotable_to_static","","",815,N],[13,"rvalue_promotable_map","","",815,N],[13,"is_mir_available","","",815,N],[13,"vtable_methods","","",815,N],[13,"codegen_fulfill_obligation","","",815,N],[13,"trait_impls_of","","",815,N],[13,"specialization_graph_of","","",815,N],[13,"is_object_safe","","",815,N],[13,"param_env","","",815,N],[13,"is_copy_raw","","",815,N],[13,"is_sized_raw","","",815,N],[13,"is_freeze_raw","","",815,N],[13,"needs_drop_raw","","",815,N],[13,"layout_raw","","",815,N],[13,"dylib_dependency_formats","","",815,N],[13,"is_panic_runtime","","",815,N],[13,"is_compiler_builtins","","",815,N],[13,"has_global_allocator","","",815,N],[13,"has_panic_handler","","",815,N],[13,"is_sanitizer_runtime","","",815,N],[13,"is_profiler_runtime","","",815,N],[13,"panic_strategy","","",815,N],[13,"is_no_builtins","","",815,N],[13,"extern_crate","","",815,N],[13,"specializes","","",815,N],[13,"in_scope_traits_map","","",815,N],[13,"module_exports","","",815,N],[13,"lint_levels","","",815,N],[13,"impl_defaultness","","",815,N],[13,"check_item_well_formed","","",815,N],[13,"check_trait_item_well_formed","","",815,N],[13,"check_impl_item_well_formed","","",815,N],[13,"reachable_non_generics","","",815,N],[13,"is_reachable_non_generic","","",815,N],[13,"is_unreachable_local_definition","","",815,N],[13,"upstream_monomorphizations","","",815,N],[13,"upstream_monomorphizations_for","","",815,N],[13,"native_libraries","","",815,N],[13,"foreign_modules","","",815,N],[13,"plugin_registrar_fn","","",815,N],[13,"derive_registrar_fn","","",815,N],[13,"crate_disambiguator","","",815,N],[13,"crate_hash","","",815,N],[13,"original_crate_name","","",815,N],[13,"extra_filename","","",815,N],[13,"implementations_of_trait","","",815,N],[13,"all_trait_implementations","","",815,N],[13,"dllimport_foreign_items","","",815,N],[13,"is_dllimport_foreign_item","","",815,N],[13,"is_statically_included_foreign_item","","",815,N],[13,"native_library_kind","","",815,N],[13,"link_args","","",815,N],[13,"resolve_lifetimes","","",815,N],[13,"named_region_map","","",815,N],[13,"is_late_bound_map","","",815,N],[13,"object_lifetime_defaults_map","","",815,N],[13,"visibility","","",815,N],[13,"dep_kind","","",815,N],[13,"crate_name","","",815,N],[13,"item_children","","",815,N],[13,"extern_mod_stmt_cnum","","",815,N],[13,"get_lib_features","","",815,N],[13,"defined_lib_features","","",815,N],[13,"get_lang_items","","",815,N],[13,"defined_lang_items","","",815,N],[13,"missing_lang_items","","",815,N],[13,"visible_parent_map","","",815,N],[13,"missing_extern_crate_item","","",815,N],[13,"used_crate_source","","",815,N],[13,"postorder_cnums","","",815,N],[13,"freevars","","",815,N],[13,"maybe_unused_trait_import","","",815,N],[13,"maybe_unused_extern_crates","","",815,N],[13,"stability_index","","",815,N],[13,"all_crate_nums","","",815,N],[13,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",815,N],[13,"exported_symbols","","",815,N],[13,"collect_and_partition_mono_items","","",815,N],[13,"is_codegened_item","","",815,N],[13,"codegen_unit","","",815,N],[13,"output_filenames","","",815,N],[13,"erase_regions_ty","","",815,N],[13,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",815,N],[13,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",815,N],[13,"implied_outlives_bounds","","",815,N],[13,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",815,N],[13,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",815,N],[13,"type_op_eq","","Do not call this query directly: part of the `Eq` type-op",815,N],[13,"type_op_subtype","","Do not call this query directly: part of the `Subtype` type-op",815,N],[13,"type_op_prove_predicate","","Do not call this query directly: part of the `ProvePredicate` type-op",815,N],[13,"type_op_normalize_ty","","Do not call this query directly: part of the `Normalize` type-op",815,N],[13,"type_op_normalize_predicate","","Do not call this query directly: part of the `Normalize` type-op",815,N],[13,"type_op_normalize_poly_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",815,N],[13,"type_op_normalize_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",815,N],[13,"substitute_normalize_and_test_predicates","","",815,N],[13,"target_features_whitelist","","",815,N],[13,"instance_def_size_estimate","","",815,N],[13,"features_query","","",815,N],[13,"program_clauses_for","","",815,N],[13,"program_clauses_for_env","","",815,N],[13,"wasm_import_module_map","","",815,N],[5,"force_from_dep_node","","The red/green evaluation system will try to mark a specific DepNode in the dependency graph as green by recursively trying to mark the dependencies of that DepNode as green. While doing so, it will sometimes encounter a DepNode where we don't know if it is red or green and we therefore actually have to recompute its value in order to find out. Since the only piece of information that we have at that point is the DepNode we are trying to re-evaluate, we need some way to re-run a query from just that. This is what `force_from_dep_node()` implements.",N,[[["tyctxt"],["depnode"]],["bool"]]],[5,"features_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"codegen_fn_attrs","","",N,[[["defid"]],["depconstructor"]]],[5,"erase_regions_ty","","",N,[[["ty"]],["depconstructor"]]],[5,"type_param_predicates","","",N,N],[5,"fulfill_obligation_dep_node","","",N,N],[5,"crate_inherent_impls_dep_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"inherent_impls_overlap_check_dep_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"reachability_dep_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"mir_shim_dep_node","","",N,[[["instancedef"]],["depconstructor"]]],[5,"symbol_name_dep_node","","",N,[[["instance"]],["depconstructor"]]],[5,"typeck_item_bodies_dep_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"const_eval_dep_node","","",N,[[["paramenvand",["globalid"]]],["depconstructor"]]],[5,"mir_keys","","",N,[[["cratenum"]],["depconstructor"]]],[5,"crate_variances","","",N,[[["cratenum"]],["depconstructor"]]],[5,"is_copy_dep_node","","",N,[[["paramenvand",["ty"]]],["depconstructor"]]],[5,"is_sized_dep_node","","",N,[[["paramenvand",["ty"]]],["depconstructor"]]],[5,"is_freeze_dep_node","","",N,[[["paramenvand",["ty"]]],["depconstructor"]]],[5,"needs_drop_dep_node","","",N,[[["paramenvand",["ty"]]],["depconstructor"]]],[5,"layout_dep_node","","",N,[[["paramenvand",["ty"]]],["depconstructor"]]],[5,"lint_levels_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"specializes_node","","",N,N],[5,"implementations_of_trait_node","","",N,N],[5,"link_args_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"get_lib_features_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"get_lang_items_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"visible_parent_map_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"postorder_cnums_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"maybe_unused_extern_crates_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"stability_index_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"all_crate_nums_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"all_traits_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"collect_and_partition_mono_items_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"output_filenames_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"vtable_methods_node","","",N,[[["polytraitref"]],["depconstructor"]]],[5,"substitute_normalize_and_test_predicates_node","","",N,N],[5,"target_features_whitelist_node","","",N,[[["cratenum"]],["depconstructor"]]],[5,"instance_def_size_estimate_dep_node","","",N,[[["instancedef"]],["depconstructor"]]],[0,"plumbing","","The implementation of the query system itself. Defines the macros that generate the actual methods on tcx which find and execute the provider, manage the caches, and so forth.",N,N],[3,"QueryCache","rustc::ty::query::plumbing","",N,N],[12,"results","","",816,N],[12,"active","","",816,N],[3,"QueryValue","","",N,N],[12,"value","","",817,N],[12,"index","","",817,N],[3,"JobOwner","","A type representing the responsibility to execute the job in the `job` field. This will poison the relevant query if dropped.",N,N],[12,"cache","","",818,N],[12,"key","","",818,N],[12,"job","","",818,N],[3,"CycleError","","",N,N],[12,"usage","","The query and related span which uses the cycle",808,N],[12,"cycle","","",808,N],[4,"TryGetJob","","The result of `try_get_lock`",N,N],[13,"NotYetStarted","","The query is not yet started. Contains a guard to the cache eventually used to start it.",819,N],[13,"JobCompleted","","The query was already completed. Returns the result of the query and its dep node index if it succeeded or a cycle error if it failed",819,N],[5,"force_from_dep_node","","The red/green evaluation system will try to mark a specific DepNode in the dependency graph as green by recursively trying to mark the dependencies of that DepNode as green. While doing so, it will sometimes encounter a DepNode where we don't know if it is red or green and we therefore actually have to recompute its value in order to find out. Since the only piece of information that we have at that point is the DepNode we are trying to re-evaluate, we need some way to re-run a query from just that. This is what `force_from_dep_node()` implements.",N,[[["tyctxt"],["depnode"]],["bool"]]],[11,"new","","",817,[[["t"],["depnodeindex"]],["queryvalue"]]],[11,"new","","",816,[[],["querycache"]]],[11,"try_get","","Either gets a JobOwner corresponding the the query, allowing us to start executing the query, or it returns with the result of the query. If the query is executing elsewhere, this will wait for it. If the query panicked, this will silently panic.",818,N],[11,"complete","","Completes the query by updating the query cache with the `result`, signals the waiter and forgets the JobOwner, so it won't poison the query",818,N],[11,"start","","Executes a job by changing the ImplicitCtxt to point to the new query job while it executes. It returns the diagnostics captured during execution and the actual result.",818,N],[11,"drop","","",818,[[["self"]]]],[11,"clone","rustc::ty::query","",808,[[["self"]],["cycleerror"]]],[11,"report_cycle","rustc::ty","",677,[[["self"],["cycleerror"]],["diagnosticbuilder"]]],[11,"try_print_query_stack","","",677,[[]]],[11,"try_mark_green_and_read","","Try to read a node index for the node dep_node. A node will have an index, when it's already been marked green, or when we can mark it green. This function will mark the current task as a reader of the specified node, when the a node index can be found for that node.",677,[[["self"],["depnode"]],["option",["depnodeindex"]]]],[11,"try_get_with","","",677,N],[11,"load_from_disk_and_cache_in_memory","","",677,N],[11,"force_query_with_job","","",677,N],[11,"ensure_query","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",677,N],[11,"force_query","","",677,N],[11,"try_get_query","","",677,N],[11,"get_query","","",677,N],[11,"cache_on_disk","rustc::dep_graph","",9,[[["self"],["tyctxt"]],["bool"]]],[11,"load_from_on_disk_cache","","",9,[[["self"],["tyctxt"]]]],[0,"job","rustc::ty::query","",N,N],[3,"QueryInfo","rustc::ty::query::job","A span and a query key",N,N],[12,"span","","The span for a reason this query was required",810,N],[12,"query","","",810,N],[3,"QueryJob","","A object representing an active query job.",N,N],[12,"info","","",809,N],[12,"parent","","The parent query job which created this job and is implicitly waiting on it.",809,N],[12,"diagnostics","","Diagnostic messages which are emitted while the query executes",809,N],[4,"QueryResult","","Indicates the state of a query for a given key in a query map",N,N],[13,"Started","","An already executing query. The query job can be used to await for its completion",820,N],[13,"Poisoned","","The query panicked. Queries trying to wait on this will raise a fatal error / silently panic",820,N],[11,"clone","rustc::ty::query","",810,[[["self"]],["queryinfo"]]],[11,"fmt","","",810,[[["self"],["formatter"]],["result"]]],[11,"new","","Creates a new query job",809,[[["queryinfo"],["option",["lrc"]]],["self"]]],[11,"await","","Awaits for the query job to complete.",809,[[["self"],["tyctxt"],["span"]],["result",["cycleerror"]]]],[11,"find_cycle_in_stack","","",809,[[["self"],["tyctxt"],["span"]],["result",["cycleerror"]]]],[11,"signal_complete","","Signals to waiters that the query is complete.",809,[[["self"]]]],[11,"as_ptr","","",809,N],[0,"keys","","Defines the set of legal keys that can be used in queries.",N,N],[8,"Key","rustc::ty::query::keys","The `Key` trait controls what types can legally be used as the key for a query.",N,N],[10,"query_crate","","Given an instance of this key, what crate is it referring to? This is used to find the provider.",821,[[["self"]],["cratenum"]]],[10,"default_span","","In the event that a cycle occurs, if no explicit span has been given for a query with key `self`, what span should we use?",821,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::ty","",724,[[["self"]],["cratenum"]]],[11,"default_span","","",724,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","","",681,[[["self"]],["cratenum"]]],[11,"default_span","","",681,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::mir::interpret","",472,[[["self"]],["cratenum"]]],[11,"default_span","","",472,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::hir::def_id","",152,[[["self"]],["cratenum"]]],[11,"default_span","","",152,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","","",149,[[["self"]],["cratenum"]]],[11,"default_span","","",149,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","","",150,[[["self"]],["cratenum"]]],[11,"default_span","","",150,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::ty","",706,[[["self"]],["cratenum"]]],[11,"default_span","","",706,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","","",707,[[["self"]],["cratenum"]]],[11,"default_span","","",707,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::infer::canonical","",227,[[["self"]],["cratenum"]]],[11,"default_span","","",227,[[["self"],["tyctxt"]],["span"]]],[0,"values","rustc::ty::query","",N,N],[8,"Value","rustc::ty::query::values","",N,N],[10,"from_cycle_error","","",822,[[["tyctxt"]],["self"]]],[11,"from_cycle_error","rustc::ty","",717,[[["tyctxt"]],["self"]]],[0,"config","rustc::ty::query","",N,N],[8,"QueryConfig","rustc::ty::query::config","",N,N],[18,"NAME","","",823,N],[18,"CATEGORY","","",823,N],[16,"Key","","",823,N],[16,"Value","","",823,N],[8,"QueryAccessors","","",N,N],[10,"query","","",824,N],[10,"query_cache","","",824,[[["tyctxt"]],["lock"]]],[10,"to_dep_node","","",824,N],[10,"compute","","",824,N],[10,"handle_cycle_error","","",824,N],[8,"QueryDescription","","",N,N],[10,"describe","","",825,N],[11,"cache_on_disk","","",825,N],[11,"try_load_from_disk","","",825,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[0,"on_disk_cache","rustc::ty::query","",N,N],[3,"OnDiskCache","rustc::ty::query::on_disk_cache","`OnDiskCache` provides an interface to incr. comp. data cached from the previous compilation session. This data will eventually include the results of a few selected queries (like `typeck_tables_of` and `mir_optimized`) and any diagnostics that have been emitted during a query.",N,N],[12,"serialized_data","","",811,N],[12,"current_diagnostics","","",811,N],[12,"prev_cnums","","",811,N],[12,"cnum_map","","",811,N],[12,"source_map","","",811,N],[12,"file_index_to_stable_id","","",811,N],[12,"file_index_to_file","","",811,N],[12,"synthetic_expansion_infos","","",811,N],[12,"query_result_index","","",811,N],[12,"prev_diagnostics_index","","",811,N],[12,"alloc_decoding_state","","",811,N],[3,"Footer","","",N,N],[12,"file_index_to_stable_id","","",826,N],[12,"prev_cnums","","",826,N],[12,"query_result_index","","",826,N],[12,"diagnostics_index","","",826,N],[12,"interpret_alloc_index","","",826,N],[3,"SourceFileIndex","","",N,N],[12,"0","","",827,N],[3,"AbsoluteBytePos","","",N,N],[12,"0","","",828,N],[3,"CacheDecoder","","A decoder that can read the incr. comp. cache. It is similar to the one we use for crate metadata decoding in that it can rebase spans and eventually will also handle things that contain `Ty` instances.",N,N],[12,"tcx","","",829,N],[12,"opaque","","",829,N],[12,"source_map","","",829,N],[12,"cnum_map","","",829,N],[12,"synthetic_expansion_infos","","",829,N],[12,"file_index_to_file","","",829,N],[12,"file_index_to_stable_id","","",829,N],[12,"alloc_decoding_session","","",829,N],[3,"CacheEncoder","","",N,N],[12,"tcx","","",830,N],[12,"encoder","","",830,N],[12,"type_shorthands","","",830,N],[12,"predicate_shorthands","","",830,N],[12,"expn_info_shorthands","","",830,N],[12,"interpret_allocs","","",830,N],[12,"interpret_allocs_inverse","","",830,N],[12,"source_map","","",830,N],[12,"file_to_file_index","","",830,N],[3,"IntEncodedWithFixedSize","","",N,N],[12,"0","","",831,N],[5,"decode_tagged","","",N,[[["d"],["t"]],["result"]]],[5,"encode_query_results","","",N,[[["tyctxt"],["cacheencoder"],["vec"]],["result"]]],[0,"__ty_decoder_impl","","",N,N],[11,"read_nil","","",829,[[["self"]],["result"]]],[11,"read_u128","","",829,[[["self"]],["result",["u128"]]]],[11,"read_u64","","",829,[[["self"]],["result",["u64"]]]],[11,"read_u32","","",829,[[["self"]],["result",["u32"]]]],[11,"read_u16","","",829,[[["self"]],["result",["u16"]]]],[11,"read_u8","","",829,[[["self"]],["result",["u8"]]]],[11,"read_usize","","",829,[[["self"]],["result",["usize"]]]],[11,"read_i128","","",829,[[["self"]],["result",["i128"]]]],[11,"read_i64","","",829,[[["self"]],["result",["i64"]]]],[11,"read_i32","","",829,[[["self"]],["result",["i32"]]]],[11,"read_i16","","",829,[[["self"]],["result",["i16"]]]],[11,"read_i8","","",829,[[["self"]],["result",["i8"]]]],[11,"read_isize","","",829,[[["self"]],["result",["isize"]]]],[11,"read_bool","","",829,[[["self"]],["result",["bool"]]]],[11,"read_f64","","",829,[[["self"]],["result",["f64"]]]],[11,"read_f32","","",829,[[["self"]],["result",["f32"]]]],[11,"read_char","","",829,[[["self"]],["result",["char"]]]],[11,"read_str","","",829,[[["self"]],["result",["cow"]]]],[11,"error","","",829,N],[11,"specialized_decode","","",829,[[["self"]],["result",["cratenum"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["ty"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["genericpredicates"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["substs"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["region"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["list"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["adtdef"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["list"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["canonicalvarinfos"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["const"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["allocation"]]]],[6,"EncodedQueryResultIndex","","",N,N],[6,"EncodedDiagnosticsIndex","","",N,N],[6,"EncodedDiagnostics","","",N,N],[17,"TAG_FILE_FOOTER","","",N,N],[17,"TAG_CLEAR_CROSS_CRATE_CLEAR","","",N,N],[17,"TAG_CLEAR_CROSS_CRATE_SET","","",N,N],[17,"TAG_NO_EXPANSION_INFO","","",N,N],[17,"TAG_EXPANSION_INFO_SHORTHAND","","",N,N],[17,"TAG_EXPANSION_INFO_INLINE","","",N,N],[17,"TAG_VALID_SPAN","","",N,N],[17,"TAG_INVALID_SPAN","","",N,N],[8,"DecoderWithPosition","","",N,N],[10,"position","","",832,[[["self"]],["usize"]]],[11,"encode","","",826,[[["self"],["__s"]],["result"]]],[11,"decode","","",826,[[["__d"]],["result",["footer"]]]],[11,"clone","","",827,[[["self"]],["sourcefileindex"]]],[11,"eq","","",827,[[["self"],["sourcefileindex"]],["bool"]]],[11,"ne","","",827,[[["self"],["sourcefileindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",827,N],[11,"hash","","",827,N],[11,"fmt","","",827,[[["self"],["formatter"]],["result"]]],[11,"encode","","",827,[[["self"],["__s"]],["result"]]],[11,"decode","","",827,[[["__d"]],["result",["sourcefileindex"]]]],[11,"clone","","",828,[[["self"]],["absolutebytepos"]]],[11,"fmt","","",828,[[["self"],["formatter"]],["result"]]],[11,"hash","","",828,N],[11,"assert_receiver_is_total_eq","","",828,N],[11,"eq","","",828,[[["self"],["absolutebytepos"]],["bool"]]],[11,"ne","","",828,[[["self"],["absolutebytepos"]],["bool"]]],[11,"encode","","",828,[[["self"],["__s"]],["result"]]],[11,"decode","","",828,[[["__d"]],["result",["absolutebytepos"]]]],[11,"new","","",828,[[["usize"]],["absolutebytepos"]]],[11,"to_usize","","",828,[[["self"]],["usize"]]],[11,"new","rustc::ty::query","Create a new OnDiskCache instance from the serialized data in `data`.",811,[[["session"],["vec",["u8"]],["usize"]],["ondiskcache"]]],[11,"new_empty","","",811,[[["sourcemap"]],["ondiskcache"]]],[11,"serialize","","",811,[[["self"],["tyctxt"],["e"]],["result"]]],[11,"load_diagnostics","","Load a diagnostic emitted during the previous compilation session.",811,[[["self"],["tyctxt"],["serializeddepnodeindex"]],["vec",["diagnostic"]]]],[11,"store_diagnostics","","Store a diagnostic emitted during the current compilation session. Anything stored like this will be available via `load_diagnostics` in the next compilation session.",811,[[["self"],["depnodeindex"],["vec",["diagnostic"]]]]],[11,"try_load_query_result","","Returns the cached query result if there is something in the cache for the given SerializedDepNodeIndex. Otherwise returns None.",811,[[["self"],["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"store_diagnostics_for_anon_node","","Store a diagnostic emitted during computation of an anonymous query. Since many anonymous queries can share the same `DepNode`, we aggregate them -- as opposed to regular queries where we assume that there is a 1:1 relationship between query-key and `DepNode`.",811,[[["self"],["depnodeindex"],["vec",["diagnostic"]]]]],[11,"load_indexed","","",811,[[["self"],["tyctxt"],["serializeddepnodeindex"],["fxhashmap"],["str"]],["option"]]],[11,"compute_cnum_map","","",811,N],[11,"file_index_to_file","rustc::ty::query::on_disk_cache","",829,[[["self"],["sourcefileindex"]],["lrc",["sourcefile"]]]],[11,"position","","",829,[[["self"]],["usize"]]],[11,"tcx","","",829,[[["self"]],["tyctxt"]]],[11,"position","","",829,[[["self"]],["usize"]]],[11,"peek_byte","","",829,[[["self"]],["u8"]]],[11,"cached_ty_for_shorthand","","",829,[[["self"],["usize"],["f"]],["result",["ty"]]]],[11,"with_position","","",829,[[["self"],["usize"],["f"]],["r"]]],[11,"map_encoded_cnum_to_current","","",829,[[["self"],["cratenum"]],["cratenum"]]],[11,"specialized_decode","","",829,[[["self"]],["result",["allocid"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["span"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["defindex"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["defid"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["localdefid"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["hirid"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["nodeid"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["fingerprint"]]]],[11,"specialized_decode","","",829,[[["self"]],["result",["clearcrosscrate"]]]],[11,"source_file_index","","",830,[[["self"],["lrc",["sourcefile"]]],["sourcefileindex"]]],[11,"encode_tagged","","Encode something with additional information that allows to do some sanity checks when decoding the data again. This method will first encode the specified tag, then the given value, then the number of bytes taken up by tag and value. On decoding, we can then verify that we get the expected tag and read the expected number of bytes.",830,[[["self"],["t"],["v"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["allocid"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["span"]],["result"]]],[11,"position","","",830,[[["self"]],["usize"]]],[11,"specialized_encode","","",830,[[["self"],["cratenum"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["ty"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["genericpredicates"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["hirid"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["defid"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["localdefid"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["defindex"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["nodeid"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["fingerprint"]],["result"]]],[11,"specialized_encode","","",830,[[["self"],["clearcrosscrate"]],["result"]]],[11,"emit_unit","","",830,[[["self"]],["result"]]],[11,"emit_usize","","",830,[[["self"],["usize"]],["result"]]],[11,"emit_u128","","",830,[[["self"],["u128"]],["result"]]],[11,"emit_u64","","",830,[[["self"],["u64"]],["result"]]],[11,"emit_u32","","",830,[[["self"],["u32"]],["result"]]],[11,"emit_u16","","",830,[[["self"],["u16"]],["result"]]],[11,"emit_u8","","",830,[[["self"],["u8"]],["result"]]],[11,"emit_isize","","",830,[[["self"],["isize"]],["result"]]],[11,"emit_i128","","",830,[[["self"],["i128"]],["result"]]],[11,"emit_i64","","",830,[[["self"],["i64"]],["result"]]],[11,"emit_i32","","",830,[[["self"],["i32"]],["result"]]],[11,"emit_i16","","",830,[[["self"],["i16"]],["result"]]],[11,"emit_i8","","",830,[[["self"],["i8"]],["result"]]],[11,"emit_bool","","",830,[[["self"],["bool"]],["result"]]],[11,"emit_f64","","",830,[[["self"],["f64"]],["result"]]],[11,"emit_f32","","",830,[[["self"],["f32"]],["result"]]],[11,"emit_char","","",830,[[["self"],["char"]],["result"]]],[11,"emit_str","","",830,[[["self"],["str"]],["result"]]],[18,"ENCODED_SIZE","","",831,N],[0,"queries","rustc::ty::query","",N,N],[3,"type_of","rustc::ty::query::queries","",N,N],[12,"data","","",833,N],[3,"generics_of","","",N,N],[12,"data","","",834,N],[3,"predicates_of","","",N,N],[12,"data","","",835,N],[3,"predicates_defined_on","","",N,N],[12,"data","","",836,N],[3,"explicit_predicates_of","","",N,N],[12,"data","","",837,N],[3,"inferred_outlives_of","","",N,N],[12,"data","","",838,N],[3,"super_predicates_of","","",N,N],[12,"data","","",839,N],[3,"type_param_predicates","","",N,N],[12,"data","","",840,N],[3,"trait_def","","",N,N],[12,"data","","",841,N],[3,"adt_def","","",N,N],[12,"data","","",842,N],[3,"adt_destructor","","",N,N],[12,"data","","",843,N],[3,"adt_sized_constraint","","",N,N],[12,"data","","",844,N],[3,"adt_dtorck_constraint","","",N,N],[12,"data","","",845,N],[3,"is_const_fn","","",N,N],[12,"data","","",846,N],[3,"is_foreign_item","","",N,N],[12,"data","","",847,N],[3,"crate_variances","","",N,N],[12,"data","","",848,N],[3,"variances_of","","",N,N],[12,"data","","",849,N],[3,"inferred_outlives_crate","","",N,N],[12,"data","","",850,N],[3,"associated_item_def_ids","","",N,N],[12,"data","","",851,N],[3,"associated_item","","",N,N],[12,"data","","",852,N],[3,"impl_trait_ref","","",N,N],[12,"data","","",853,N],[3,"impl_polarity","","",N,N],[12,"data","","",854,N],[3,"inherent_impls","","",N,N],[12,"data","","",855,N],[3,"mir_keys","","",N,N],[12,"data","","",856,N],[3,"mir_const_qualif","","",N,N],[12,"data","","",857,N],[3,"mir_built","","",N,N],[12,"data","","",858,N],[3,"mir_const","","",N,N],[12,"data","","",859,N],[3,"mir_validated","","",N,N],[12,"data","","",860,N],[3,"optimized_mir","","",N,N],[12,"data","","",861,N],[3,"unsafety_check_result","","",N,N],[12,"data","","",862,N],[3,"unsafe_derive_on_repr_packed","","",N,N],[12,"data","","",863,N],[3,"fn_sig","","",N,N],[12,"data","","",864,N],[3,"coerce_unsized_info","","",N,N],[12,"data","","",865,N],[3,"typeck_item_bodies","","",N,N],[12,"data","","",866,N],[3,"typeck_tables_of","","",N,N],[12,"data","","",867,N],[3,"used_trait_imports","","",N,N],[12,"data","","",868,N],[3,"has_typeck_tables","","",N,N],[12,"data","","",869,N],[3,"coherent_trait","","",N,N],[12,"data","","",870,N],[3,"borrowck","","",N,N],[12,"data","","",871,N],[3,"mir_borrowck","","",N,N],[12,"data","","",872,N],[3,"crate_inherent_impls","","",N,N],[12,"data","","",873,N],[3,"crate_inherent_impls_overlap_check","","",N,N],[12,"data","","",874,N],[3,"const_eval","","",N,N],[12,"data","","",875,N],[3,"check_match","","",N,N],[12,"data","","",876,N],[3,"privacy_access_levels","","",N,N],[12,"data","","",877,N],[3,"reachable_set","","",N,N],[12,"data","","",878,N],[3,"region_scope_tree","","",N,N],[12,"data","","",879,N],[3,"mir_shims","","",N,N],[12,"data","","",880,N],[3,"def_symbol_name","","",N,N],[12,"data","","",881,N],[3,"symbol_name","","",N,N],[12,"data","","",882,N],[3,"describe_def","","",N,N],[12,"data","","",883,N],[3,"def_span","","",N,N],[12,"data","","",884,N],[3,"lookup_stability","","",N,N],[12,"data","","",885,N],[3,"lookup_deprecation_entry","","",N,N],[12,"data","","",886,N],[3,"item_attrs","","",N,N],[12,"data","","",887,N],[3,"codegen_fn_attrs","","",N,N],[12,"data","","",888,N],[3,"fn_arg_names","","",N,N],[12,"data","","",889,N],[3,"rendered_const","","",N,N],[12,"data","","",890,N],[3,"impl_parent","","",N,N],[12,"data","","",891,N],[3,"trait_of_item","","",N,N],[12,"data","","",892,N],[3,"const_is_rvalue_promotable_to_static","","",N,N],[12,"data","","",893,N],[3,"rvalue_promotable_map","","",N,N],[12,"data","","",894,N],[3,"is_mir_available","","",N,N],[12,"data","","",895,N],[3,"vtable_methods","","",N,N],[12,"data","","",896,N],[3,"codegen_fulfill_obligation","","",N,N],[12,"data","","",897,N],[3,"trait_impls_of","","",N,N],[12,"data","","",898,N],[3,"specialization_graph_of","","",N,N],[12,"data","","",899,N],[3,"is_object_safe","","",N,N],[12,"data","","",900,N],[3,"param_env","","",N,N],[12,"data","","",901,N],[3,"is_copy_raw","","",N,N],[12,"data","","",902,N],[3,"is_sized_raw","","",N,N],[12,"data","","",903,N],[3,"is_freeze_raw","","",N,N],[12,"data","","",904,N],[3,"needs_drop_raw","","",N,N],[12,"data","","",905,N],[3,"layout_raw","","",N,N],[12,"data","","",906,N],[3,"dylib_dependency_formats","","",N,N],[12,"data","","",907,N],[3,"is_panic_runtime","","",N,N],[12,"data","","",908,N],[3,"is_compiler_builtins","","",N,N],[12,"data","","",909,N],[3,"has_global_allocator","","",N,N],[12,"data","","",910,N],[3,"has_panic_handler","","",N,N],[12,"data","","",911,N],[3,"is_sanitizer_runtime","","",N,N],[12,"data","","",912,N],[3,"is_profiler_runtime","","",N,N],[12,"data","","",913,N],[3,"panic_strategy","","",N,N],[12,"data","","",914,N],[3,"is_no_builtins","","",N,N],[12,"data","","",915,N],[3,"extern_crate","","",N,N],[12,"data","","",916,N],[3,"specializes","","",N,N],[12,"data","","",917,N],[3,"in_scope_traits_map","","",N,N],[12,"data","","",918,N],[3,"module_exports","","",N,N],[12,"data","","",919,N],[3,"lint_levels","","",N,N],[12,"data","","",920,N],[3,"impl_defaultness","","",N,N],[12,"data","","",921,N],[3,"check_item_well_formed","","",N,N],[12,"data","","",922,N],[3,"check_trait_item_well_formed","","",N,N],[12,"data","","",923,N],[3,"check_impl_item_well_formed","","",N,N],[12,"data","","",924,N],[3,"reachable_non_generics","","",N,N],[12,"data","","",925,N],[3,"is_reachable_non_generic","","",N,N],[12,"data","","",926,N],[3,"is_unreachable_local_definition","","",N,N],[12,"data","","",927,N],[3,"upstream_monomorphizations","","",N,N],[12,"data","","",928,N],[3,"upstream_monomorphizations_for","","",N,N],[12,"data","","",929,N],[3,"native_libraries","","",N,N],[12,"data","","",930,N],[3,"foreign_modules","","",N,N],[12,"data","","",931,N],[3,"plugin_registrar_fn","","",N,N],[12,"data","","",932,N],[3,"derive_registrar_fn","","",N,N],[12,"data","","",933,N],[3,"crate_disambiguator","","",N,N],[12,"data","","",934,N],[3,"crate_hash","","",N,N],[12,"data","","",935,N],[3,"original_crate_name","","",N,N],[12,"data","","",936,N],[3,"extra_filename","","",N,N],[12,"data","","",937,N],[3,"implementations_of_trait","","",N,N],[12,"data","","",938,N],[3,"all_trait_implementations","","",N,N],[12,"data","","",939,N],[3,"dllimport_foreign_items","","",N,N],[12,"data","","",940,N],[3,"is_dllimport_foreign_item","","",N,N],[12,"data","","",941,N],[3,"is_statically_included_foreign_item","","",N,N],[12,"data","","",942,N],[3,"native_library_kind","","",N,N],[12,"data","","",943,N],[3,"link_args","","",N,N],[12,"data","","",944,N],[3,"resolve_lifetimes","","",N,N],[12,"data","","",945,N],[3,"named_region_map","","",N,N],[12,"data","","",946,N],[3,"is_late_bound_map","","",N,N],[12,"data","","",947,N],[3,"object_lifetime_defaults_map","","",N,N],[12,"data","","",948,N],[3,"visibility","","",N,N],[12,"data","","",949,N],[3,"dep_kind","","",N,N],[12,"data","","",950,N],[3,"crate_name","","",N,N],[12,"data","","",951,N],[3,"item_children","","",N,N],[12,"data","","",952,N],[3,"extern_mod_stmt_cnum","","",N,N],[12,"data","","",953,N],[3,"get_lib_features","","",N,N],[12,"data","","",954,N],[3,"defined_lib_features","","",N,N],[12,"data","","",955,N],[3,"get_lang_items","","",N,N],[12,"data","","",956,N],[3,"defined_lang_items","","",N,N],[12,"data","","",957,N],[3,"missing_lang_items","","",N,N],[12,"data","","",958,N],[3,"visible_parent_map","","",N,N],[12,"data","","",959,N],[3,"missing_extern_crate_item","","",N,N],[12,"data","","",960,N],[3,"used_crate_source","","",N,N],[12,"data","","",961,N],[3,"postorder_cnums","","",N,N],[12,"data","","",962,N],[3,"freevars","","",N,N],[12,"data","","",963,N],[3,"maybe_unused_trait_import","","",N,N],[12,"data","","",964,N],[3,"maybe_unused_extern_crates","","",N,N],[12,"data","","",965,N],[3,"stability_index","","",N,N],[12,"data","","",966,N],[3,"all_crate_nums","","",N,N],[12,"data","","",967,N],[3,"all_traits","","",N,N],[12,"data","","",968,N],[3,"exported_symbols","","",N,N],[12,"data","","",969,N],[3,"collect_and_partition_mono_items","","",N,N],[12,"data","","",970,N],[3,"is_codegened_item","","",N,N],[12,"data","","",971,N],[3,"codegen_unit","","",N,N],[12,"data","","",972,N],[3,"output_filenames","","",N,N],[12,"data","","",973,N],[3,"erase_regions_ty","","",N,N],[12,"data","","",974,N],[3,"normalize_projection_ty","","",N,N],[12,"data","","",975,N],[3,"normalize_ty_after_erasing_regions","","",N,N],[12,"data","","",976,N],[3,"implied_outlives_bounds","","",N,N],[12,"data","","",977,N],[3,"dropck_outlives","","",N,N],[12,"data","","",978,N],[3,"evaluate_obligation","","",N,N],[12,"data","","",979,N],[3,"type_op_eq","","",N,N],[12,"data","","",980,N],[3,"type_op_subtype","","",N,N],[12,"data","","",981,N],[3,"type_op_prove_predicate","","",N,N],[12,"data","","",982,N],[3,"type_op_normalize_ty","","",N,N],[12,"data","","",983,N],[3,"type_op_normalize_predicate","","",N,N],[12,"data","","",984,N],[3,"type_op_normalize_poly_fn_sig","","",N,N],[12,"data","","",985,N],[3,"type_op_normalize_fn_sig","","",N,N],[12,"data","","",986,N],[3,"substitute_normalize_and_test_predicates","","",N,N],[12,"data","","",987,N],[3,"target_features_whitelist","","",N,N],[12,"data","","",988,N],[3,"instance_def_size_estimate","","",N,N],[12,"data","","",989,N],[3,"features_query","","",N,N],[12,"data","","",990,N],[3,"program_clauses_for","","",N,N],[12,"data","","",991,N],[3,"program_clauses_for_env","","",N,N],[12,"data","","",992,N],[3,"wasm_import_module_map","","",N,N],[12,"data","","",993,N],[0,"__query_compute","rustc::ty::query","",N,N],[5,"type_of","rustc::ty::query::__query_compute","",N,[[["f"]],["r"]]],[5,"generics_of","","",N,[[["f"]],["r"]]],[5,"predicates_of","","",N,[[["f"]],["r"]]],[5,"predicates_defined_on","","",N,[[["f"]],["r"]]],[5,"explicit_predicates_of","","",N,[[["f"]],["r"]]],[5,"inferred_outlives_of","","",N,[[["f"]],["r"]]],[5,"super_predicates_of","","",N,[[["f"]],["r"]]],[5,"type_param_predicates","","",N,[[["f"]],["r"]]],[5,"trait_def","","",N,[[["f"]],["r"]]],[5,"adt_def","","",N,[[["f"]],["r"]]],[5,"adt_destructor","","",N,[[["f"]],["r"]]],[5,"adt_sized_constraint","","",N,[[["f"]],["r"]]],[5,"adt_dtorck_constraint","","",N,[[["f"]],["r"]]],[5,"is_const_fn","","",N,[[["f"]],["r"]]],[5,"is_foreign_item","","",N,[[["f"]],["r"]]],[5,"crate_variances","","",N,[[["f"]],["r"]]],[5,"variances_of","","",N,[[["f"]],["r"]]],[5,"inferred_outlives_crate","","",N,[[["f"]],["r"]]],[5,"associated_item_def_ids","","",N,[[["f"]],["r"]]],[5,"associated_item","","",N,[[["f"]],["r"]]],[5,"impl_trait_ref","","",N,[[["f"]],["r"]]],[5,"impl_polarity","","",N,[[["f"]],["r"]]],[5,"inherent_impls","","",N,[[["f"]],["r"]]],[5,"mir_keys","","",N,[[["f"]],["r"]]],[5,"mir_const_qualif","","",N,[[["f"]],["r"]]],[5,"mir_built","","",N,[[["f"]],["r"]]],[5,"mir_const","","",N,[[["f"]],["r"]]],[5,"mir_validated","","",N,[[["f"]],["r"]]],[5,"optimized_mir","","",N,[[["f"]],["r"]]],[5,"unsafety_check_result","","",N,[[["f"]],["r"]]],[5,"unsafe_derive_on_repr_packed","","",N,[[["f"]],["r"]]],[5,"fn_sig","","",N,[[["f"]],["r"]]],[5,"coerce_unsized_info","","",N,[[["f"]],["r"]]],[5,"typeck_item_bodies","","",N,[[["f"]],["r"]]],[5,"typeck_tables_of","","",N,[[["f"]],["r"]]],[5,"used_trait_imports","","",N,[[["f"]],["r"]]],[5,"has_typeck_tables","","",N,[[["f"]],["r"]]],[5,"coherent_trait","","",N,[[["f"]],["r"]]],[5,"borrowck","","",N,[[["f"]],["r"]]],[5,"mir_borrowck","","",N,[[["f"]],["r"]]],[5,"crate_inherent_impls","","",N,[[["f"]],["r"]]],[5,"crate_inherent_impls_overlap_check","","",N,[[["f"]],["r"]]],[5,"const_eval","","",N,[[["f"]],["r"]]],[5,"check_match","","",N,[[["f"]],["r"]]],[5,"privacy_access_levels","","",N,[[["f"]],["r"]]],[5,"reachable_set","","",N,[[["f"]],["r"]]],[5,"region_scope_tree","","",N,[[["f"]],["r"]]],[5,"mir_shims","","",N,[[["f"]],["r"]]],[5,"def_symbol_name","","",N,[[["f"]],["r"]]],[5,"symbol_name","","",N,[[["f"]],["r"]]],[5,"describe_def","","",N,[[["f"]],["r"]]],[5,"def_span","","",N,[[["f"]],["r"]]],[5,"lookup_stability","","",N,[[["f"]],["r"]]],[5,"lookup_deprecation_entry","","",N,[[["f"]],["r"]]],[5,"item_attrs","","",N,[[["f"]],["r"]]],[5,"codegen_fn_attrs","","",N,[[["f"]],["r"]]],[5,"fn_arg_names","","",N,[[["f"]],["r"]]],[5,"rendered_const","","",N,[[["f"]],["r"]]],[5,"impl_parent","","",N,[[["f"]],["r"]]],[5,"trait_of_item","","",N,[[["f"]],["r"]]],[5,"const_is_rvalue_promotable_to_static","","",N,[[["f"]],["r"]]],[5,"rvalue_promotable_map","","",N,[[["f"]],["r"]]],[5,"is_mir_available","","",N,[[["f"]],["r"]]],[5,"vtable_methods","","",N,[[["f"]],["r"]]],[5,"codegen_fulfill_obligation","","",N,[[["f"]],["r"]]],[5,"trait_impls_of","","",N,[[["f"]],["r"]]],[5,"specialization_graph_of","","",N,[[["f"]],["r"]]],[5,"is_object_safe","","",N,[[["f"]],["r"]]],[5,"param_env","","",N,[[["f"]],["r"]]],[5,"is_copy_raw","","",N,[[["f"]],["r"]]],[5,"is_sized_raw","","",N,[[["f"]],["r"]]],[5,"is_freeze_raw","","",N,[[["f"]],["r"]]],[5,"needs_drop_raw","","",N,[[["f"]],["r"]]],[5,"layout_raw","","",N,[[["f"]],["r"]]],[5,"dylib_dependency_formats","","",N,[[["f"]],["r"]]],[5,"is_panic_runtime","","",N,[[["f"]],["r"]]],[5,"is_compiler_builtins","","",N,[[["f"]],["r"]]],[5,"has_global_allocator","","",N,[[["f"]],["r"]]],[5,"has_panic_handler","","",N,[[["f"]],["r"]]],[5,"is_sanitizer_runtime","","",N,[[["f"]],["r"]]],[5,"is_profiler_runtime","","",N,[[["f"]],["r"]]],[5,"panic_strategy","","",N,[[["f"]],["r"]]],[5,"is_no_builtins","","",N,[[["f"]],["r"]]],[5,"extern_crate","","",N,[[["f"]],["r"]]],[5,"specializes","","",N,[[["f"]],["r"]]],[5,"in_scope_traits_map","","",N,[[["f"]],["r"]]],[5,"module_exports","","",N,[[["f"]],["r"]]],[5,"lint_levels","","",N,[[["f"]],["r"]]],[5,"impl_defaultness","","",N,[[["f"]],["r"]]],[5,"check_item_well_formed","","",N,[[["f"]],["r"]]],[5,"check_trait_item_well_formed","","",N,[[["f"]],["r"]]],[5,"check_impl_item_well_formed","","",N,[[["f"]],["r"]]],[5,"reachable_non_generics","","",N,[[["f"]],["r"]]],[5,"is_reachable_non_generic","","",N,[[["f"]],["r"]]],[5,"is_unreachable_local_definition","","",N,[[["f"]],["r"]]],[5,"upstream_monomorphizations","","",N,[[["f"]],["r"]]],[5,"upstream_monomorphizations_for","","",N,[[["f"]],["r"]]],[5,"native_libraries","","",N,[[["f"]],["r"]]],[5,"foreign_modules","","",N,[[["f"]],["r"]]],[5,"plugin_registrar_fn","","",N,[[["f"]],["r"]]],[5,"derive_registrar_fn","","",N,[[["f"]],["r"]]],[5,"crate_disambiguator","","",N,[[["f"]],["r"]]],[5,"crate_hash","","",N,[[["f"]],["r"]]],[5,"original_crate_name","","",N,[[["f"]],["r"]]],[5,"extra_filename","","",N,[[["f"]],["r"]]],[5,"implementations_of_trait","","",N,[[["f"]],["r"]]],[5,"all_trait_implementations","","",N,[[["f"]],["r"]]],[5,"dllimport_foreign_items","","",N,[[["f"]],["r"]]],[5,"is_dllimport_foreign_item","","",N,[[["f"]],["r"]]],[5,"is_statically_included_foreign_item","","",N,[[["f"]],["r"]]],[5,"native_library_kind","","",N,[[["f"]],["r"]]],[5,"link_args","","",N,[[["f"]],["r"]]],[5,"resolve_lifetimes","","",N,[[["f"]],["r"]]],[5,"named_region_map","","",N,[[["f"]],["r"]]],[5,"is_late_bound_map","","",N,[[["f"]],["r"]]],[5,"object_lifetime_defaults_map","","",N,[[["f"]],["r"]]],[5,"visibility","","",N,[[["f"]],["r"]]],[5,"dep_kind","","",N,[[["f"]],["r"]]],[5,"crate_name","","",N,[[["f"]],["r"]]],[5,"item_children","","",N,[[["f"]],["r"]]],[5,"extern_mod_stmt_cnum","","",N,[[["f"]],["r"]]],[5,"get_lib_features","","",N,[[["f"]],["r"]]],[5,"defined_lib_features","","",N,[[["f"]],["r"]]],[5,"get_lang_items","","",N,[[["f"]],["r"]]],[5,"defined_lang_items","","",N,[[["f"]],["r"]]],[5,"missing_lang_items","","",N,[[["f"]],["r"]]],[5,"visible_parent_map","","",N,[[["f"]],["r"]]],[5,"missing_extern_crate_item","","",N,[[["f"]],["r"]]],[5,"used_crate_source","","",N,[[["f"]],["r"]]],[5,"postorder_cnums","","",N,[[["f"]],["r"]]],[5,"freevars","","",N,[[["f"]],["r"]]],[5,"maybe_unused_trait_import","","",N,[[["f"]],["r"]]],[5,"maybe_unused_extern_crates","","",N,[[["f"]],["r"]]],[5,"stability_index","","",N,[[["f"]],["r"]]],[5,"all_crate_nums","","",N,[[["f"]],["r"]]],[5,"all_traits","","",N,[[["f"]],["r"]]],[5,"exported_symbols","","",N,[[["f"]],["r"]]],[5,"collect_and_partition_mono_items","","",N,[[["f"]],["r"]]],[5,"is_codegened_item","","",N,[[["f"]],["r"]]],[5,"codegen_unit","","",N,[[["f"]],["r"]]],[5,"output_filenames","","",N,[[["f"]],["r"]]],[5,"erase_regions_ty","","",N,[[["f"]],["r"]]],[5,"normalize_projection_ty","","",N,[[["f"]],["r"]]],[5,"normalize_ty_after_erasing_regions","","",N,[[["f"]],["r"]]],[5,"implied_outlives_bounds","","",N,[[["f"]],["r"]]],[5,"dropck_outlives","","",N,[[["f"]],["r"]]],[5,"evaluate_obligation","","",N,[[["f"]],["r"]]],[5,"type_op_eq","","",N,[[["f"]],["r"]]],[5,"type_op_subtype","","",N,[[["f"]],["r"]]],[5,"type_op_prove_predicate","","",N,[[["f"]],["r"]]],[5,"type_op_normalize_ty","","",N,[[["f"]],["r"]]],[5,"type_op_normalize_predicate","","",N,[[["f"]],["r"]]],[5,"type_op_normalize_poly_fn_sig","","",N,[[["f"]],["r"]]],[5,"type_op_normalize_fn_sig","","",N,[[["f"]],["r"]]],[5,"substitute_normalize_and_test_predicates","","",N,[[["f"]],["r"]]],[5,"target_features_whitelist","","",N,[[["f"]],["r"]]],[5,"instance_def_size_estimate","","",N,[[["f"]],["r"]]],[5,"features_query","","",N,[[["f"]],["r"]]],[5,"program_clauses_for","","",N,[[["f"]],["r"]]],[5,"program_clauses_for_env","","",N,[[["f"]],["r"]]],[5,"wasm_import_module_map","","",N,[[["f"]],["r"]]],[8,"QueryConfig","rustc::ty::query","",N,N],[18,"NAME","rustc::ty::query::config","",823,N],[18,"CATEGORY","","",823,N],[16,"Key","rustc::ty::query","",823,N],[16,"Value","","",823,N],[11,"new","","",812,[[["indexvec",["cratenum","providers"]],["providers"],["ondiskcache"]],["self"]]],[11,"clone","","",815,[[["self"]],["query"]]],[11,"fmt","","",815,[[["self"],["formatter"]],["result"]]],[11,"eq","","",815,[[["self"],["query"]],["bool"]]],[11,"ne","","",815,[[["self"],["query"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",815,N],[11,"hash","","",815,N],[11,"name","","",815,[[["self"]],["str"]]],[11,"describe","","",815,[[["self"],["tyctxt"]],["string"]]],[11,"default_span","","",815,[[["self"],["tyctxt"],["span"]],["span"]]],[11,"hash_stable","","",815,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"query","rustc::ty::query::queries","",833,N],[11,"query_cache","","",833,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",833,N],[11,"compute","","",833,N],[11,"handle_cycle_error","","",833,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",833,N],[11,"query","","",834,N],[11,"query_cache","","",834,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",834,N],[11,"compute","","",834,N],[11,"handle_cycle_error","","",834,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",834,N],[11,"query","","",835,N],[11,"query_cache","","",835,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",835,N],[11,"compute","","",835,N],[11,"handle_cycle_error","","",835,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",835,N],[11,"query","","",836,N],[11,"query_cache","","",836,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",836,N],[11,"compute","","",836,N],[11,"handle_cycle_error","","",836,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",836,N],[11,"query","","",837,N],[11,"query_cache","","",837,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",837,N],[11,"compute","","",837,N],[11,"handle_cycle_error","","",837,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",837,N],[11,"query","","",838,N],[11,"query_cache","","",838,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",838,N],[11,"compute","","",838,N],[11,"handle_cycle_error","","",838,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",838,N],[11,"query","","",839,N],[11,"query_cache","","",839,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",839,N],[11,"compute","","",839,N],[11,"handle_cycle_error","","",839,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",839,N],[11,"query","","",840,N],[11,"query_cache","","",840,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",840,N],[11,"compute","","",840,N],[11,"handle_cycle_error","","",840,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",840,N],[11,"query","","",841,N],[11,"query_cache","","",841,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",841,N],[11,"compute","","",841,N],[11,"handle_cycle_error","","",841,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",841,N],[11,"query","","",842,N],[11,"query_cache","","",842,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",842,N],[11,"compute","","",842,N],[11,"handle_cycle_error","","",842,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",842,N],[11,"query","","",843,N],[11,"query_cache","","",843,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",843,N],[11,"compute","","",843,N],[11,"handle_cycle_error","","",843,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",843,N],[11,"query","","",844,N],[11,"query_cache","","",844,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",844,N],[11,"compute","","",844,N],[11,"handle_cycle_error","","",844,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",844,N],[11,"query","","",845,N],[11,"query_cache","","",845,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",845,N],[11,"compute","","",845,N],[11,"handle_cycle_error","","",845,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",845,N],[11,"query","","",846,N],[11,"query_cache","","",846,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",846,N],[11,"compute","","",846,N],[11,"handle_cycle_error","","",846,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",846,N],[11,"query","","",847,N],[11,"query_cache","","",847,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",847,N],[11,"compute","","",847,N],[11,"handle_cycle_error","","",847,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",847,N],[11,"query","","",848,N],[11,"query_cache","","",848,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",848,N],[11,"compute","","",848,N],[11,"handle_cycle_error","","",848,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",848,N],[11,"query","","",849,N],[11,"query_cache","","",849,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",849,N],[11,"compute","","",849,N],[11,"handle_cycle_error","","",849,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",849,N],[11,"query","","",850,N],[11,"query_cache","","",850,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",850,N],[11,"compute","","",850,N],[11,"handle_cycle_error","","",850,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",850,N],[11,"query","","",851,N],[11,"query_cache","","",851,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",851,N],[11,"compute","","",851,N],[11,"handle_cycle_error","","",851,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",851,N],[11,"query","","",852,N],[11,"query_cache","","",852,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",852,N],[11,"compute","","",852,N],[11,"handle_cycle_error","","",852,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",852,N],[11,"query","","",853,N],[11,"query_cache","","",853,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",853,N],[11,"compute","","",853,N],[11,"handle_cycle_error","","",853,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",853,N],[11,"query","","",854,N],[11,"query_cache","","",854,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",854,N],[11,"compute","","",854,N],[11,"handle_cycle_error","","",854,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",854,N],[11,"query","","",855,N],[11,"query_cache","","",855,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",855,N],[11,"compute","","",855,N],[11,"handle_cycle_error","","",855,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",855,N],[11,"query","","",856,N],[11,"query_cache","","",856,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",856,N],[11,"compute","","",856,N],[11,"handle_cycle_error","","",856,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",856,N],[11,"query","","",857,N],[11,"query_cache","","",857,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",857,N],[11,"compute","","",857,N],[11,"handle_cycle_error","","",857,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",857,N],[11,"query","","",858,N],[11,"query_cache","","",858,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",858,N],[11,"compute","","",858,N],[11,"handle_cycle_error","","",858,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",858,N],[11,"query","","",859,N],[11,"query_cache","","",859,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",859,N],[11,"compute","","",859,N],[11,"handle_cycle_error","","",859,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",859,N],[11,"query","","",860,N],[11,"query_cache","","",860,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",860,N],[11,"compute","","",860,N],[11,"handle_cycle_error","","",860,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",860,N],[11,"query","","",861,N],[11,"query_cache","","",861,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",861,N],[11,"compute","","",861,N],[11,"handle_cycle_error","","",861,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",861,N],[11,"query","","",862,N],[11,"query_cache","","",862,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",862,N],[11,"compute","","",862,N],[11,"handle_cycle_error","","",862,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",862,N],[11,"query","","",863,N],[11,"query_cache","","",863,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",863,N],[11,"compute","","",863,N],[11,"handle_cycle_error","","",863,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",863,N],[11,"query","","",864,N],[11,"query_cache","","",864,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",864,N],[11,"compute","","",864,N],[11,"handle_cycle_error","","",864,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",864,N],[11,"query","","",865,N],[11,"query_cache","","",865,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",865,N],[11,"compute","","",865,N],[11,"handle_cycle_error","","",865,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",865,N],[11,"query","","",866,N],[11,"query_cache","","",866,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",866,N],[11,"compute","","",866,N],[11,"handle_cycle_error","","",866,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",866,N],[11,"query","","",867,N],[11,"query_cache","","",867,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",867,N],[11,"compute","","",867,N],[11,"handle_cycle_error","","",867,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",867,N],[11,"query","","",868,N],[11,"query_cache","","",868,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",868,N],[11,"compute","","",868,N],[11,"handle_cycle_error","","",868,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",868,N],[11,"query","","",869,N],[11,"query_cache","","",869,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",869,N],[11,"compute","","",869,N],[11,"handle_cycle_error","","",869,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",869,N],[11,"query","","",870,N],[11,"query_cache","","",870,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",870,N],[11,"compute","","",870,N],[11,"handle_cycle_error","","",870,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",870,N],[11,"query","","",871,N],[11,"query_cache","","",871,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",871,N],[11,"compute","","",871,N],[11,"handle_cycle_error","","",871,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",871,N],[11,"query","","",872,N],[11,"query_cache","","",872,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",872,N],[11,"compute","","",872,N],[11,"handle_cycle_error","","",872,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",872,N],[11,"query","","",873,N],[11,"query_cache","","",873,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",873,N],[11,"compute","","",873,N],[11,"handle_cycle_error","","",873,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",873,N],[11,"query","","",874,N],[11,"query_cache","","",874,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",874,N],[11,"compute","","",874,N],[11,"handle_cycle_error","","",874,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",874,N],[11,"query","","",875,N],[11,"query_cache","","",875,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",875,N],[11,"compute","","",875,N],[11,"handle_cycle_error","","",875,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",875,N],[11,"query","","",876,N],[11,"query_cache","","",876,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",876,N],[11,"compute","","",876,N],[11,"handle_cycle_error","","",876,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",876,N],[11,"query","","",877,N],[11,"query_cache","","",877,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",877,N],[11,"compute","","",877,N],[11,"handle_cycle_error","","",877,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",877,N],[11,"query","","",878,N],[11,"query_cache","","",878,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",878,N],[11,"compute","","",878,N],[11,"handle_cycle_error","","",878,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",878,N],[11,"query","","",879,N],[11,"query_cache","","",879,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",879,N],[11,"compute","","",879,N],[11,"handle_cycle_error","","",879,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",879,N],[11,"query","","",880,N],[11,"query_cache","","",880,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",880,N],[11,"compute","","",880,N],[11,"handle_cycle_error","","",880,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",880,N],[11,"query","","",881,N],[11,"query_cache","","",881,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",881,N],[11,"compute","","",881,N],[11,"handle_cycle_error","","",881,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",881,N],[11,"query","","",882,N],[11,"query_cache","","",882,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",882,N],[11,"compute","","",882,N],[11,"handle_cycle_error","","",882,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",882,N],[11,"query","","",883,N],[11,"query_cache","","",883,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",883,N],[11,"compute","","",883,N],[11,"handle_cycle_error","","",883,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",883,N],[11,"query","","",884,N],[11,"query_cache","","",884,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",884,N],[11,"compute","","",884,N],[11,"handle_cycle_error","","",884,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",884,N],[11,"query","","",885,N],[11,"query_cache","","",885,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",885,N],[11,"compute","","",885,N],[11,"handle_cycle_error","","",885,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",885,N],[11,"query","","",886,N],[11,"query_cache","","",886,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",886,N],[11,"compute","","",886,N],[11,"handle_cycle_error","","",886,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",886,N],[11,"query","","",887,N],[11,"query_cache","","",887,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",887,N],[11,"compute","","",887,N],[11,"handle_cycle_error","","",887,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",887,N],[11,"query","","",888,N],[11,"query_cache","","",888,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",888,N],[11,"compute","","",888,N],[11,"handle_cycle_error","","",888,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",888,N],[11,"query","","",889,N],[11,"query_cache","","",889,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",889,N],[11,"compute","","",889,N],[11,"handle_cycle_error","","",889,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",889,N],[11,"query","","",890,N],[11,"query_cache","","",890,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",890,N],[11,"compute","","",890,N],[11,"handle_cycle_error","","",890,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",890,N],[11,"query","","",891,N],[11,"query_cache","","",891,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",891,N],[11,"compute","","",891,N],[11,"handle_cycle_error","","",891,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",891,N],[11,"query","","",892,N],[11,"query_cache","","",892,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",892,N],[11,"compute","","",892,N],[11,"handle_cycle_error","","",892,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",892,N],[11,"query","","",893,N],[11,"query_cache","","",893,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",893,N],[11,"compute","","",893,N],[11,"handle_cycle_error","","",893,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",893,N],[11,"query","","",894,N],[11,"query_cache","","",894,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",894,N],[11,"compute","","",894,N],[11,"handle_cycle_error","","",894,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",894,N],[11,"query","","",895,N],[11,"query_cache","","",895,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",895,N],[11,"compute","","",895,N],[11,"handle_cycle_error","","",895,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",895,N],[11,"query","","",896,N],[11,"query_cache","","",896,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",896,N],[11,"compute","","",896,N],[11,"handle_cycle_error","","",896,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",896,N],[11,"query","","",897,N],[11,"query_cache","","",897,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",897,N],[11,"compute","","",897,N],[11,"handle_cycle_error","","",897,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",897,N],[11,"query","","",898,N],[11,"query_cache","","",898,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",898,N],[11,"compute","","",898,N],[11,"handle_cycle_error","","",898,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",898,N],[11,"query","","",899,N],[11,"query_cache","","",899,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",899,N],[11,"compute","","",899,N],[11,"handle_cycle_error","","",899,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",899,N],[11,"query","","",900,N],[11,"query_cache","","",900,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",900,N],[11,"compute","","",900,N],[11,"handle_cycle_error","","",900,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",900,N],[11,"query","","",901,N],[11,"query_cache","","",901,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",901,N],[11,"compute","","",901,N],[11,"handle_cycle_error","","",901,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",901,N],[11,"query","","",902,N],[11,"query_cache","","",902,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",902,N],[11,"compute","","",902,N],[11,"handle_cycle_error","","",902,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",902,N],[11,"query","","",903,N],[11,"query_cache","","",903,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",903,N],[11,"compute","","",903,N],[11,"handle_cycle_error","","",903,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",903,N],[11,"query","","",904,N],[11,"query_cache","","",904,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",904,N],[11,"compute","","",904,N],[11,"handle_cycle_error","","",904,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",904,N],[11,"query","","",905,N],[11,"query_cache","","",905,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",905,N],[11,"compute","","",905,N],[11,"handle_cycle_error","","",905,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",905,N],[11,"query","","",906,N],[11,"query_cache","","",906,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",906,N],[11,"compute","","",906,N],[11,"handle_cycle_error","","",906,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",906,N],[11,"query","","",907,N],[11,"query_cache","","",907,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",907,N],[11,"compute","","",907,N],[11,"handle_cycle_error","","",907,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",907,N],[11,"query","","",908,N],[11,"query_cache","","",908,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",908,N],[11,"compute","","",908,N],[11,"handle_cycle_error","","",908,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",908,N],[11,"query","","",909,N],[11,"query_cache","","",909,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",909,N],[11,"compute","","",909,N],[11,"handle_cycle_error","","",909,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",909,N],[11,"query","","",910,N],[11,"query_cache","","",910,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",910,N],[11,"compute","","",910,N],[11,"handle_cycle_error","","",910,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",910,N],[11,"query","","",911,N],[11,"query_cache","","",911,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",911,N],[11,"compute","","",911,N],[11,"handle_cycle_error","","",911,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",911,N],[11,"query","","",912,N],[11,"query_cache","","",912,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",912,N],[11,"compute","","",912,N],[11,"handle_cycle_error","","",912,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",912,N],[11,"query","","",913,N],[11,"query_cache","","",913,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",913,N],[11,"compute","","",913,N],[11,"handle_cycle_error","","",913,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",913,N],[11,"query","","",914,N],[11,"query_cache","","",914,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",914,N],[11,"compute","","",914,N],[11,"handle_cycle_error","","",914,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",914,N],[11,"query","","",915,N],[11,"query_cache","","",915,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",915,N],[11,"compute","","",915,N],[11,"handle_cycle_error","","",915,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",915,N],[11,"query","","",916,N],[11,"query_cache","","",916,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",916,N],[11,"compute","","",916,N],[11,"handle_cycle_error","","",916,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",916,N],[11,"query","","",917,N],[11,"query_cache","","",917,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",917,N],[11,"compute","","",917,N],[11,"handle_cycle_error","","",917,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",917,N],[11,"query","","",918,N],[11,"query_cache","","",918,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",918,N],[11,"compute","","",918,N],[11,"handle_cycle_error","","",918,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",918,N],[11,"query","","",919,N],[11,"query_cache","","",919,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",919,N],[11,"compute","","",919,N],[11,"handle_cycle_error","","",919,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",919,N],[11,"query","","",920,N],[11,"query_cache","","",920,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",920,N],[11,"compute","","",920,N],[11,"handle_cycle_error","","",920,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",920,N],[11,"query","","",921,N],[11,"query_cache","","",921,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",921,N],[11,"compute","","",921,N],[11,"handle_cycle_error","","",921,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",921,N],[11,"query","","",922,N],[11,"query_cache","","",922,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",922,N],[11,"compute","","",922,N],[11,"handle_cycle_error","","",922,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",922,N],[11,"query","","",923,N],[11,"query_cache","","",923,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",923,N],[11,"compute","","",923,N],[11,"handle_cycle_error","","",923,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",923,N],[11,"query","","",924,N],[11,"query_cache","","",924,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",924,N],[11,"compute","","",924,N],[11,"handle_cycle_error","","",924,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",924,N],[11,"query","","",925,N],[11,"query_cache","","",925,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",925,N],[11,"compute","","",925,N],[11,"handle_cycle_error","","",925,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",925,N],[11,"query","","",926,N],[11,"query_cache","","",926,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",926,N],[11,"compute","","",926,N],[11,"handle_cycle_error","","",926,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",926,N],[11,"query","","",927,N],[11,"query_cache","","",927,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",927,N],[11,"compute","","",927,N],[11,"handle_cycle_error","","",927,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",927,N],[11,"query","","",928,N],[11,"query_cache","","",928,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",928,N],[11,"compute","","",928,N],[11,"handle_cycle_error","","",928,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",928,N],[11,"query","","",929,N],[11,"query_cache","","",929,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",929,N],[11,"compute","","",929,N],[11,"handle_cycle_error","","",929,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",929,N],[11,"query","","",930,N],[11,"query_cache","","",930,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",930,N],[11,"compute","","",930,N],[11,"handle_cycle_error","","",930,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",930,N],[11,"query","","",931,N],[11,"query_cache","","",931,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",931,N],[11,"compute","","",931,N],[11,"handle_cycle_error","","",931,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",931,N],[11,"query","","",932,N],[11,"query_cache","","",932,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",932,N],[11,"compute","","",932,N],[11,"handle_cycle_error","","",932,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",932,N],[11,"query","","",933,N],[11,"query_cache","","",933,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",933,N],[11,"compute","","",933,N],[11,"handle_cycle_error","","",933,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",933,N],[11,"query","","",934,N],[11,"query_cache","","",934,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",934,N],[11,"compute","","",934,N],[11,"handle_cycle_error","","",934,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",934,N],[11,"query","","",935,N],[11,"query_cache","","",935,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",935,N],[11,"compute","","",935,N],[11,"handle_cycle_error","","",935,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",935,N],[11,"query","","",936,N],[11,"query_cache","","",936,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",936,N],[11,"compute","","",936,N],[11,"handle_cycle_error","","",936,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",936,N],[11,"query","","",937,N],[11,"query_cache","","",937,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",937,N],[11,"compute","","",937,N],[11,"handle_cycle_error","","",937,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",937,N],[11,"query","","",938,N],[11,"query_cache","","",938,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",938,N],[11,"compute","","",938,N],[11,"handle_cycle_error","","",938,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",938,N],[11,"query","","",939,N],[11,"query_cache","","",939,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",939,N],[11,"compute","","",939,N],[11,"handle_cycle_error","","",939,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",939,N],[11,"query","","",940,N],[11,"query_cache","","",940,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",940,N],[11,"compute","","",940,N],[11,"handle_cycle_error","","",940,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",940,N],[11,"query","","",941,N],[11,"query_cache","","",941,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",941,N],[11,"compute","","",941,N],[11,"handle_cycle_error","","",941,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",941,N],[11,"query","","",942,N],[11,"query_cache","","",942,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",942,N],[11,"compute","","",942,N],[11,"handle_cycle_error","","",942,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",942,N],[11,"query","","",943,N],[11,"query_cache","","",943,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",943,N],[11,"compute","","",943,N],[11,"handle_cycle_error","","",943,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",943,N],[11,"query","","",944,N],[11,"query_cache","","",944,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",944,N],[11,"compute","","",944,N],[11,"handle_cycle_error","","",944,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",944,N],[11,"query","","",945,N],[11,"query_cache","","",945,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",945,N],[11,"compute","","",945,N],[11,"handle_cycle_error","","",945,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",945,N],[11,"query","","",946,N],[11,"query_cache","","",946,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",946,N],[11,"compute","","",946,N],[11,"handle_cycle_error","","",946,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",946,N],[11,"query","","",947,N],[11,"query_cache","","",947,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",947,N],[11,"compute","","",947,N],[11,"handle_cycle_error","","",947,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",947,N],[11,"query","","",948,N],[11,"query_cache","","",948,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",948,N],[11,"compute","","",948,N],[11,"handle_cycle_error","","",948,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",948,N],[11,"query","","",949,N],[11,"query_cache","","",949,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",949,N],[11,"compute","","",949,N],[11,"handle_cycle_error","","",949,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",949,N],[11,"query","","",950,N],[11,"query_cache","","",950,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",950,N],[11,"compute","","",950,N],[11,"handle_cycle_error","","",950,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",950,N],[11,"query","","",951,N],[11,"query_cache","","",951,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",951,N],[11,"compute","","",951,N],[11,"handle_cycle_error","","",951,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",951,N],[11,"query","","",952,N],[11,"query_cache","","",952,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",952,N],[11,"compute","","",952,N],[11,"handle_cycle_error","","",952,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",952,N],[11,"query","","",953,N],[11,"query_cache","","",953,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",953,N],[11,"compute","","",953,N],[11,"handle_cycle_error","","",953,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",953,N],[11,"query","","",954,N],[11,"query_cache","","",954,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",954,N],[11,"compute","","",954,N],[11,"handle_cycle_error","","",954,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",954,N],[11,"query","","",955,N],[11,"query_cache","","",955,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",955,N],[11,"compute","","",955,N],[11,"handle_cycle_error","","",955,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",955,N],[11,"query","","",956,N],[11,"query_cache","","",956,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",956,N],[11,"compute","","",956,N],[11,"handle_cycle_error","","",956,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",956,N],[11,"query","","",957,N],[11,"query_cache","","",957,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",957,N],[11,"compute","","",957,N],[11,"handle_cycle_error","","",957,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",957,N],[11,"query","","",958,N],[11,"query_cache","","",958,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",958,N],[11,"compute","","",958,N],[11,"handle_cycle_error","","",958,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",958,N],[11,"query","","",959,N],[11,"query_cache","","",959,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",959,N],[11,"compute","","",959,N],[11,"handle_cycle_error","","",959,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",959,N],[11,"query","","",960,N],[11,"query_cache","","",960,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",960,N],[11,"compute","","",960,N],[11,"handle_cycle_error","","",960,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",960,N],[11,"query","","",961,N],[11,"query_cache","","",961,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",961,N],[11,"compute","","",961,N],[11,"handle_cycle_error","","",961,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",961,N],[11,"query","","",962,N],[11,"query_cache","","",962,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",962,N],[11,"compute","","",962,N],[11,"handle_cycle_error","","",962,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",962,N],[11,"query","","",963,N],[11,"query_cache","","",963,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",963,N],[11,"compute","","",963,N],[11,"handle_cycle_error","","",963,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",963,N],[11,"query","","",964,N],[11,"query_cache","","",964,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",964,N],[11,"compute","","",964,N],[11,"handle_cycle_error","","",964,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",964,N],[11,"query","","",965,N],[11,"query_cache","","",965,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",965,N],[11,"compute","","",965,N],[11,"handle_cycle_error","","",965,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",965,N],[11,"query","","",966,N],[11,"query_cache","","",966,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",966,N],[11,"compute","","",966,N],[11,"handle_cycle_error","","",966,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",966,N],[11,"query","","",967,N],[11,"query_cache","","",967,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",967,N],[11,"compute","","",967,N],[11,"handle_cycle_error","","",967,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",967,N],[11,"query","","",968,N],[11,"query_cache","","",968,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",968,N],[11,"compute","","",968,N],[11,"handle_cycle_error","","",968,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",968,N],[11,"query","","",969,N],[11,"query_cache","","",969,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",969,N],[11,"compute","","",969,N],[11,"handle_cycle_error","","",969,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",969,N],[11,"query","","",970,N],[11,"query_cache","","",970,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",970,N],[11,"compute","","",970,N],[11,"handle_cycle_error","","",970,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",970,N],[11,"query","","",971,N],[11,"query_cache","","",971,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",971,N],[11,"compute","","",971,N],[11,"handle_cycle_error","","",971,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",971,N],[11,"query","","",972,N],[11,"query_cache","","",972,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",972,N],[11,"compute","","",972,N],[11,"handle_cycle_error","","",972,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",972,N],[11,"query","","",973,N],[11,"query_cache","","",973,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",973,N],[11,"compute","","",973,N],[11,"handle_cycle_error","","",973,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",973,N],[11,"query","","",974,N],[11,"query_cache","","",974,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",974,N],[11,"compute","","",974,N],[11,"handle_cycle_error","","",974,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",974,N],[11,"query","","",975,N],[11,"query_cache","","",975,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",975,N],[11,"compute","","",975,N],[11,"handle_cycle_error","","",975,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",975,N],[11,"query","","",976,N],[11,"query_cache","","",976,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",976,N],[11,"compute","","",976,N],[11,"handle_cycle_error","","",976,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",976,N],[11,"query","","",977,N],[11,"query_cache","","",977,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",977,N],[11,"compute","","",977,N],[11,"handle_cycle_error","","",977,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",977,N],[11,"query","","",978,N],[11,"query_cache","","",978,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",978,N],[11,"compute","","",978,N],[11,"handle_cycle_error","","",978,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",978,N],[11,"query","","",979,N],[11,"query_cache","","",979,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",979,N],[11,"compute","","",979,N],[11,"handle_cycle_error","","",979,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",979,N],[11,"query","","",980,N],[11,"query_cache","","",980,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",980,N],[11,"compute","","",980,N],[11,"handle_cycle_error","","",980,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",980,N],[11,"query","","",981,N],[11,"query_cache","","",981,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",981,N],[11,"compute","","",981,N],[11,"handle_cycle_error","","",981,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",981,N],[11,"query","","",982,N],[11,"query_cache","","",982,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",982,N],[11,"compute","","",982,N],[11,"handle_cycle_error","","",982,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",982,N],[11,"query","","",983,N],[11,"query_cache","","",983,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",983,N],[11,"compute","","",983,N],[11,"handle_cycle_error","","",983,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",983,N],[11,"query","","",984,N],[11,"query_cache","","",984,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",984,N],[11,"compute","","",984,N],[11,"handle_cycle_error","","",984,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",984,N],[11,"query","","",985,N],[11,"query_cache","","",985,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",985,N],[11,"compute","","",985,N],[11,"handle_cycle_error","","",985,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",985,N],[11,"query","","",986,N],[11,"query_cache","","",986,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",986,N],[11,"compute","","",986,N],[11,"handle_cycle_error","","",986,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",986,N],[11,"query","","",987,N],[11,"query_cache","","",987,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",987,N],[11,"compute","","",987,N],[11,"handle_cycle_error","","",987,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",987,N],[11,"query","","",988,N],[11,"query_cache","","",988,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",988,N],[11,"compute","","",988,N],[11,"handle_cycle_error","","",988,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",988,N],[11,"query","","",989,N],[11,"query_cache","","",989,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",989,N],[11,"compute","","",989,N],[11,"handle_cycle_error","","",989,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",989,N],[11,"query","","",990,N],[11,"query_cache","","",990,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",990,N],[11,"compute","","",990,N],[11,"handle_cycle_error","","",990,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",990,N],[11,"query","","",991,N],[11,"query_cache","","",991,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",991,N],[11,"compute","","",991,N],[11,"handle_cycle_error","","",991,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",991,N],[11,"query","","",992,N],[11,"query_cache","","",992,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",992,N],[11,"compute","","",992,N],[11,"handle_cycle_error","","",992,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",992,N],[11,"query","","",993,N],[11,"query_cache","","",993,[[["tyctxt"]],["lock"]]],[11,"to_dep_node","","",993,N],[11,"compute","","",993,N],[11,"handle_cycle_error","","",993,N],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",993,N],[11,"clone","rustc::ty::query","",813,[[["self"]],["tyctxtat"]]],[11,"deref","","",813,N],[11,"at","rustc::ty","Return a transparent wrapper for `TyCtxt` which uses `span` as the location of queries performed through it.",677,[[["self"],["span"]],["tyctxtat"]]],[11,"type_of","","Records the type of every item.",677,[[["self"],["defid"]],["ty"]]],[11,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics.",677,[[["self"],["defid"]],["generics"]]],[11,"predicates_of","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) that must be proven true in order to reference it. This is almost always the \"predicates query\" that you want.",677,[[["self"],["defid"]],["genericpredicates"]]],[11,"predicates_defined_on","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) directly defined on it. This is equal to the `explicit_predicates_of` predicates plus the `inferred_outlives_of` predicates.",677,[[["self"],["defid"]],["genericpredicates"]]],[11,"explicit_predicates_of","","Returns the predicates written explicit by the user.",677,[[["self"],["defid"]],["genericpredicates"]]],[11,"inferred_outlives_of","","Returns the inferred outlives predicates (e.g., for `struct Foo<'a, T> { x: &'a T }`, this would return `T: 'a`).",677,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",677,[[["self"],["defid"]],["genericpredicates"]]],[11,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",677,N],[11,"trait_def","","",677,[[["self"],["defid"]],["traitdef"]]],[11,"adt_def","","",677,[[["self"],["defid"]],["adtdef"]]],[11,"adt_destructor","","",677,[[["self"],["defid"]],["option",["destructor"]]]],[11,"adt_sized_constraint","","",677,N],[11,"adt_dtorck_constraint","","",677,[[["self"],["defid"]],["result",["dtorckconstraint","nosolution"]]]],[11,"is_const_fn","","True if this is a const fn",677,[[["self"],["defid"]],["bool"]]],[11,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",677,[[["self"],["defid"]],["bool"]]],[11,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",677,[[["self"],["cratenum"]],["lrc",["cratevariancesmap"]]]],[11,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",677,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",677,[[["self"],["cratenum"]],["lrc",["cratepredicatesmap"]]]],[11,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",677,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",677,[[["self"],["defid"]],["associateditem"]]],[11,"impl_trait_ref","","",677,[[["self"],["defid"]],["option",["traitref"]]]],[11,"impl_polarity","","",677,[[["self"],["defid"]],["implpolarity"]]],[11,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",677,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",677,[[["self"],["cratenum"]],["lrc",["defidset"]]]],[11,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",677,N],[11,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",677,[[["self"],["defid"]],["steal"]]],[11,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",677,[[["self"],["defid"]],["steal"]]],[11,"mir_validated","","",677,[[["self"],["defid"]],["steal"]]],[11,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for codegen. This is also the only query that can fetch non-local MIR, at present.",677,[[["self"],["defid"]],["mir"]]],[11,"unsafety_check_result","","The result of unsafety-checking this def-id.",677,[[["self"],["defid"]],["unsafetycheckresult"]]],[11,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",677,N],[11,"fn_sig","","The signature of functions and closures.",677,[[["self"],["defid"]],["polyfnsig"]]],[11,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",677,[[["self"],["defid"]],["coerceunsizedinfo"]]],[11,"typeck_item_bodies","","",677,[[["self"],["cratenum"]],["compileresult"]]],[11,"typeck_tables_of","","",677,[[["self"],["defid"]],["typecktables"]]],[11,"used_trait_imports","","",677,[[["self"],["defid"]],["lrc",["defidset"]]]],[11,"has_typeck_tables","","",677,[[["self"],["defid"]],["bool"]]],[11,"coherent_trait","","",677,N],[11,"borrowck","","",677,[[["self"],["defid"]],["lrc",["borrowcheckresult"]]]],[11,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",677,[[["self"],["defid"]],["borrowcheckresult"]]],[11,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",677,[[["self"],["cratenum"]],["crateinherentimpls"]]],[11,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",677,N],[11,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",677,[[["self"],["paramenvand",["globalid"]]],["constevalresult"]]],[11,"check_match","","",677,[[["self"],["defid"]],["result",["errorreported"]]]],[11,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",677,[[["self"],["cratenum"]],["lrc",["accesslevels"]]]],[11,"reachable_set","","",677,[[["self"],["cratenum"]],["reachableset"]]],[11,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",677,[[["self"],["defid"]],["lrc",["scopetree"]]]],[11,"mir_shims","","",677,[[["self"],["instancedef"]],["mir"]]],[11,"def_symbol_name","","",677,[[["self"],["defid"]],["symbolname"]]],[11,"symbol_name","","",677,[[["self"],["instance"]],["symbolname"]]],[11,"describe_def","","",677,[[["self"],["defid"]],["option",["def"]]]],[11,"def_span","","",677,[[["self"],["defid"]],["span"]]],[11,"lookup_stability","","",677,[[["self"],["defid"]],["option",["stability"]]]],[11,"lookup_deprecation_entry","","",677,[[["self"],["defid"]],["option",["deprecationentry"]]]],[11,"item_attrs","","",677,[[["self"],["defid"]],["lrc"]]],[11,"codegen_fn_attrs","","",677,[[["self"],["defid"]],["codegenfnattrs"]]],[11,"fn_arg_names","","",677,[[["self"],["defid"]],["vec",["name"]]]],[11,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",677,[[["self"],["defid"]],["string"]]],[11,"impl_parent","","",677,[[["self"],["defid"]],["option",["defid"]]]],[11,"trait_of_item","","",677,[[["self"],["defid"]],["option",["defid"]]]],[11,"const_is_rvalue_promotable_to_static","","",677,[[["self"],["defid"]],["bool"]]],[11,"rvalue_promotable_map","","",677,[[["self"],["defid"]],["lrc",["itemlocalset"]]]],[11,"is_mir_available","","",677,[[["self"],["defid"]],["bool"]]],[11,"vtable_methods","","",677,[[["self"],["polytraitref"]],["lrc",["vec"]]]],[11,"codegen_fulfill_obligation","","",677,N],[11,"trait_impls_of","","",677,[[["self"],["defid"]],["lrc",["traitimpls"]]]],[11,"specialization_graph_of","","",677,[[["self"],["defid"]],["lrc",["graph"]]]],[11,"is_object_safe","","",677,[[["self"],["defid"]],["bool"]]],[11,"param_env","","",677,[[["self"],["defid"]],["paramenv"]]],[11,"is_copy_raw","","",677,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"is_sized_raw","","",677,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"is_freeze_raw","","",677,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"needs_drop_raw","","",677,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"layout_raw","","",677,[[["self"],["paramenvand",["ty"]]],["result",["layoutdetails","layouterror"]]]],[11,"dylib_dependency_formats","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"is_panic_runtime","","",677,[[["self"],["cratenum"]],["bool"]]],[11,"is_compiler_builtins","","",677,[[["self"],["cratenum"]],["bool"]]],[11,"has_global_allocator","","",677,[[["self"],["cratenum"]],["bool"]]],[11,"has_panic_handler","","",677,[[["self"],["cratenum"]],["bool"]]],[11,"is_sanitizer_runtime","","",677,[[["self"],["cratenum"]],["bool"]]],[11,"is_profiler_runtime","","",677,[[["self"],["cratenum"]],["bool"]]],[11,"panic_strategy","","",677,[[["self"],["cratenum"]],["panicstrategy"]]],[11,"is_no_builtins","","",677,[[["self"],["cratenum"]],["bool"]]],[11,"extern_crate","","",677,[[["self"],["defid"]],["lrc",["option"]]]],[11,"specializes","","",677,N],[11,"in_scope_traits_map","","",677,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"module_exports","","",677,[[["self"],["defid"]],["option",["lrc"]]]],[11,"lint_levels","","",677,[[["self"],["cratenum"]],["lrc",["lintlevelmap"]]]],[11,"impl_defaultness","","",677,[[["self"],["defid"]],["defaultness"]]],[11,"check_item_well_formed","","",677,N],[11,"check_trait_item_well_formed","","",677,N],[11,"check_impl_item_well_formed","","",677,N],[11,"reachable_non_generics","","",677,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"is_reachable_non_generic","","",677,[[["self"],["defid"]],["bool"]]],[11,"is_unreachable_local_definition","","",677,[[["self"],["defid"]],["bool"]]],[11,"upstream_monomorphizations","","",677,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"upstream_monomorphizations_for","","",677,[[["self"],["defid"]],["option",["lrc"]]]],[11,"native_libraries","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"foreign_modules","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"plugin_registrar_fn","","",677,[[["self"],["cratenum"]],["option",["defid"]]]],[11,"derive_registrar_fn","","",677,[[["self"],["cratenum"]],["option",["defid"]]]],[11,"crate_disambiguator","","",677,[[["self"],["cratenum"]],["cratedisambiguator"]]],[11,"crate_hash","","",677,[[["self"],["cratenum"]],["svh"]]],[11,"original_crate_name","","",677,[[["self"],["cratenum"]],["symbol"]]],[11,"extra_filename","","",677,[[["self"],["cratenum"]],["string"]]],[11,"implementations_of_trait","","",677,N],[11,"all_trait_implementations","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"dllimport_foreign_items","","",677,[[["self"],["cratenum"]],["lrc",["fxhashset"]]]],[11,"is_dllimport_foreign_item","","",677,[[["self"],["defid"]],["bool"]]],[11,"is_statically_included_foreign_item","","",677,[[["self"],["defid"]],["bool"]]],[11,"native_library_kind","","",677,[[["self"],["defid"]],["option",["nativelibrarykind"]]]],[11,"link_args","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"resolve_lifetimes","","",677,[[["self"],["cratenum"]],["lrc",["resolvelifetimes"]]]],[11,"named_region_map","","",677,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"is_late_bound_map","","",677,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"object_lifetime_defaults_map","","",677,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"visibility","","",677,[[["self"],["defid"]],["visibility"]]],[11,"dep_kind","","",677,[[["self"],["cratenum"]],["depkind"]]],[11,"crate_name","","",677,[[["self"],["cratenum"]],["symbol"]]],[11,"item_children","","",677,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"extern_mod_stmt_cnum","","",677,[[["self"],["defid"]],["option",["cratenum"]]]],[11,"get_lib_features","","",677,[[["self"],["cratenum"]],["lrc",["libfeatures"]]]],[11,"defined_lib_features","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"get_lang_items","","",677,[[["self"],["cratenum"]],["lrc",["languageitems"]]]],[11,"defined_lang_items","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"missing_lang_items","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"visible_parent_map","","",677,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"missing_extern_crate_item","","",677,[[["self"],["cratenum"]],["bool"]]],[11,"used_crate_source","","",677,[[["self"],["cratenum"]],["lrc",["cratesource"]]]],[11,"postorder_cnums","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"freevars","","",677,[[["self"],["defid"]],["option",["lrc"]]]],[11,"maybe_unused_trait_import","","",677,[[["self"],["defid"]],["bool"]]],[11,"maybe_unused_extern_crates","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"stability_index","","",677,[[["self"],["cratenum"]],["lrc",["index"]]]],[11,"all_crate_nums","","",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",677,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"exported_symbols","","",677,[[["self"],["cratenum"]],["arc",["vec"]]]],[11,"collect_and_partition_mono_items","","",677,N],[11,"is_codegened_item","","",677,[[["self"],["defid"]],["bool"]]],[11,"codegen_unit","","",677,[[["self"],["internedstring"]],["arc",["codegenunit"]]]],[11,"output_filenames","","",677,[[["self"],["cratenum"]],["arc",["outputfilenames"]]]],[11,"erase_regions_ty","","",677,[[["self"],["ty"]],["ty"]]],[11,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",677,[[["self"],["canonicalprojectiongoal"]],["result",["lrc","nosolution"]]]],[11,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",677,[[["self"],["paramenvand",["ty"]]],["ty"]]],[11,"implied_outlives_bounds","","",677,[[["self"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[11,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",677,[[["self"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[11,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",677,[[["self"],["canonicalpredicategoal"]],["result",["evaluationresult","overflowerror"]]]],[11,"type_op_eq","","Do not call this query directly: part of the `Eq` type-op",677,[[["self"],["canonicaltypeopeqgoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_subtype","","Do not call this query directly: part of the `Subtype` type-op",677,[[["self"],["canonicaltypeopsubtypegoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_prove_predicate","","Do not call this query directly: part of the `ProvePredicate` type-op",677,[[["self"],["canonicaltypeopprovepredicategoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_ty","","Do not call this query directly: part of the `Normalize` type-op",677,[[["self"],["canonicaltypeopnormalizegoal",["ty"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_predicate","","Do not call this query directly: part of the `Normalize` type-op",677,[[["self"],["canonicaltypeopnormalizegoal",["predicate"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_poly_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",677,[[["self"],["canonicaltypeopnormalizegoal",["polyfnsig"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",677,[[["self"],["canonicaltypeopnormalizegoal",["fnsig"]]],["result",["lrc","nosolution"]]]],[11,"substitute_normalize_and_test_predicates","","",677,N],[11,"target_features_whitelist","","",677,[[["self"],["cratenum"]],["lrc",["fxhashmap"]]]],[11,"instance_def_size_estimate","","",677,[[["self"],["instancedef"]],["usize"]]],[11,"features_query","","",677,[[["self"],["cratenum"]],["lrc",["features"]]]],[11,"program_clauses_for","","",677,[[["self"],["defid"]],["clauses"]]],[11,"program_clauses_for_env","","",677,[[["self"],["paramenv"]],["clauses"]]],[11,"wasm_import_module_map","","",677,[[["self"],["cratenum"]],["lrc",["fxhashmap"]]]],[11,"type_of","rustc::ty::query","Records the type of every item.",813,[[["self"],["defid"]],["ty"]]],[11,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics.",813,[[["self"],["defid"]],["generics"]]],[11,"predicates_of","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) that must be proven true in order to reference it. This is almost always the \"predicates query\" that you want.",813,[[["self"],["defid"]],["genericpredicates"]]],[11,"predicates_defined_on","","Maps from the def-id of an item (trait/struct/enum/fn) to the predicates (where clauses) directly defined on it. This is equal to the `explicit_predicates_of` predicates plus the `inferred_outlives_of` predicates.",813,[[["self"],["defid"]],["genericpredicates"]]],[11,"explicit_predicates_of","","Returns the predicates written explicit by the user.",813,[[["self"],["defid"]],["genericpredicates"]]],[11,"inferred_outlives_of","","Returns the inferred outlives predicates (e.g., for `struct Foo<'a, T> { x: &'a T }`, this would return `T: 'a`).",813,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",813,[[["self"],["defid"]],["genericpredicates"]]],[11,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",813,N],[11,"trait_def","","",813,[[["self"],["defid"]],["traitdef"]]],[11,"adt_def","","",813,[[["self"],["defid"]],["adtdef"]]],[11,"adt_destructor","","",813,[[["self"],["defid"]],["option",["destructor"]]]],[11,"adt_sized_constraint","","",813,N],[11,"adt_dtorck_constraint","","",813,[[["self"],["defid"]],["result",["dtorckconstraint","nosolution"]]]],[11,"is_const_fn","","True if this is a const fn",813,[[["self"],["defid"]],["bool"]]],[11,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",813,[[["self"],["defid"]],["bool"]]],[11,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",813,[[["self"],["cratenum"]],["lrc",["cratevariancesmap"]]]],[11,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",813,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",813,[[["self"],["cratenum"]],["lrc",["cratepredicatesmap"]]]],[11,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",813,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",813,[[["self"],["defid"]],["associateditem"]]],[11,"impl_trait_ref","","",813,[[["self"],["defid"]],["option",["traitref"]]]],[11,"impl_polarity","","",813,[[["self"],["defid"]],["implpolarity"]]],[11,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",813,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",813,[[["self"],["cratenum"]],["lrc",["defidset"]]]],[11,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",813,N],[11,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",813,[[["self"],["defid"]],["steal"]]],[11,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",813,[[["self"],["defid"]],["steal"]]],[11,"mir_validated","","",813,[[["self"],["defid"]],["steal"]]],[11,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for codegen. This is also the only query that can fetch non-local MIR, at present.",813,[[["self"],["defid"]],["mir"]]],[11,"unsafety_check_result","","The result of unsafety-checking this def-id.",813,[[["self"],["defid"]],["unsafetycheckresult"]]],[11,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",813,N],[11,"fn_sig","","The signature of functions and closures.",813,[[["self"],["defid"]],["polyfnsig"]]],[11,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",813,[[["self"],["defid"]],["coerceunsizedinfo"]]],[11,"typeck_item_bodies","","",813,[[["self"],["cratenum"]],["compileresult"]]],[11,"typeck_tables_of","","",813,[[["self"],["defid"]],["typecktables"]]],[11,"used_trait_imports","","",813,[[["self"],["defid"]],["lrc",["defidset"]]]],[11,"has_typeck_tables","","",813,[[["self"],["defid"]],["bool"]]],[11,"coherent_trait","","",813,N],[11,"borrowck","","",813,[[["self"],["defid"]],["lrc",["borrowcheckresult"]]]],[11,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",813,[[["self"],["defid"]],["borrowcheckresult"]]],[11,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",813,[[["self"],["cratenum"]],["crateinherentimpls"]]],[11,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",813,N],[11,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",813,[[["self"],["paramenvand",["globalid"]]],["constevalresult"]]],[11,"check_match","","",813,[[["self"],["defid"]],["result",["errorreported"]]]],[11,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",813,[[["self"],["cratenum"]],["lrc",["accesslevels"]]]],[11,"reachable_set","","",813,[[["self"],["cratenum"]],["reachableset"]]],[11,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",813,[[["self"],["defid"]],["lrc",["scopetree"]]]],[11,"mir_shims","","",813,[[["self"],["instancedef"]],["mir"]]],[11,"def_symbol_name","","",813,[[["self"],["defid"]],["symbolname"]]],[11,"symbol_name","","",813,[[["self"],["instance"]],["symbolname"]]],[11,"describe_def","","",813,[[["self"],["defid"]],["option",["def"]]]],[11,"def_span","","",813,[[["self"],["defid"]],["span"]]],[11,"lookup_stability","","",813,[[["self"],["defid"]],["option",["stability"]]]],[11,"lookup_deprecation_entry","","",813,[[["self"],["defid"]],["option",["deprecationentry"]]]],[11,"item_attrs","","",813,[[["self"],["defid"]],["lrc"]]],[11,"codegen_fn_attrs","","",813,[[["self"],["defid"]],["codegenfnattrs"]]],[11,"fn_arg_names","","",813,[[["self"],["defid"]],["vec",["name"]]]],[11,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",813,[[["self"],["defid"]],["string"]]],[11,"impl_parent","","",813,[[["self"],["defid"]],["option",["defid"]]]],[11,"trait_of_item","","",813,[[["self"],["defid"]],["option",["defid"]]]],[11,"const_is_rvalue_promotable_to_static","","",813,[[["self"],["defid"]],["bool"]]],[11,"rvalue_promotable_map","","",813,[[["self"],["defid"]],["lrc",["itemlocalset"]]]],[11,"is_mir_available","","",813,[[["self"],["defid"]],["bool"]]],[11,"vtable_methods","","",813,[[["self"],["polytraitref"]],["lrc",["vec"]]]],[11,"codegen_fulfill_obligation","","",813,N],[11,"trait_impls_of","","",813,[[["self"],["defid"]],["lrc",["traitimpls"]]]],[11,"specialization_graph_of","","",813,[[["self"],["defid"]],["lrc",["graph"]]]],[11,"is_object_safe","","",813,[[["self"],["defid"]],["bool"]]],[11,"param_env","","",813,[[["self"],["defid"]],["paramenv"]]],[11,"is_copy_raw","","",813,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"is_sized_raw","","",813,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"is_freeze_raw","","",813,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"needs_drop_raw","","",813,[[["self"],["paramenvand",["ty"]]],["bool"]]],[11,"layout_raw","","",813,[[["self"],["paramenvand",["ty"]]],["result",["layoutdetails","layouterror"]]]],[11,"dylib_dependency_formats","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"is_panic_runtime","","",813,[[["self"],["cratenum"]],["bool"]]],[11,"is_compiler_builtins","","",813,[[["self"],["cratenum"]],["bool"]]],[11,"has_global_allocator","","",813,[[["self"],["cratenum"]],["bool"]]],[11,"has_panic_handler","","",813,[[["self"],["cratenum"]],["bool"]]],[11,"is_sanitizer_runtime","","",813,[[["self"],["cratenum"]],["bool"]]],[11,"is_profiler_runtime","","",813,[[["self"],["cratenum"]],["bool"]]],[11,"panic_strategy","","",813,[[["self"],["cratenum"]],["panicstrategy"]]],[11,"is_no_builtins","","",813,[[["self"],["cratenum"]],["bool"]]],[11,"extern_crate","","",813,[[["self"],["defid"]],["lrc",["option"]]]],[11,"specializes","","",813,N],[11,"in_scope_traits_map","","",813,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"module_exports","","",813,[[["self"],["defid"]],["option",["lrc"]]]],[11,"lint_levels","","",813,[[["self"],["cratenum"]],["lrc",["lintlevelmap"]]]],[11,"impl_defaultness","","",813,[[["self"],["defid"]],["defaultness"]]],[11,"check_item_well_formed","","",813,N],[11,"check_trait_item_well_formed","","",813,N],[11,"check_impl_item_well_formed","","",813,N],[11,"reachable_non_generics","","",813,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"is_reachable_non_generic","","",813,[[["self"],["defid"]],["bool"]]],[11,"is_unreachable_local_definition","","",813,[[["self"],["defid"]],["bool"]]],[11,"upstream_monomorphizations","","",813,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"upstream_monomorphizations_for","","",813,[[["self"],["defid"]],["option",["lrc"]]]],[11,"native_libraries","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"foreign_modules","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"plugin_registrar_fn","","",813,[[["self"],["cratenum"]],["option",["defid"]]]],[11,"derive_registrar_fn","","",813,[[["self"],["cratenum"]],["option",["defid"]]]],[11,"crate_disambiguator","","",813,[[["self"],["cratenum"]],["cratedisambiguator"]]],[11,"crate_hash","","",813,[[["self"],["cratenum"]],["svh"]]],[11,"original_crate_name","","",813,[[["self"],["cratenum"]],["symbol"]]],[11,"extra_filename","","",813,[[["self"],["cratenum"]],["string"]]],[11,"implementations_of_trait","","",813,N],[11,"all_trait_implementations","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"dllimport_foreign_items","","",813,[[["self"],["cratenum"]],["lrc",["fxhashset"]]]],[11,"is_dllimport_foreign_item","","",813,[[["self"],["defid"]],["bool"]]],[11,"is_statically_included_foreign_item","","",813,[[["self"],["defid"]],["bool"]]],[11,"native_library_kind","","",813,[[["self"],["defid"]],["option",["nativelibrarykind"]]]],[11,"link_args","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"resolve_lifetimes","","",813,[[["self"],["cratenum"]],["lrc",["resolvelifetimes"]]]],[11,"named_region_map","","",813,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"is_late_bound_map","","",813,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"object_lifetime_defaults_map","","",813,[[["self"],["defindex"]],["option",["lrc"]]]],[11,"visibility","","",813,[[["self"],["defid"]],["visibility"]]],[11,"dep_kind","","",813,[[["self"],["cratenum"]],["depkind"]]],[11,"crate_name","","",813,[[["self"],["cratenum"]],["symbol"]]],[11,"item_children","","",813,[[["self"],["defid"]],["lrc",["vec"]]]],[11,"extern_mod_stmt_cnum","","",813,[[["self"],["defid"]],["option",["cratenum"]]]],[11,"get_lib_features","","",813,[[["self"],["cratenum"]],["lrc",["libfeatures"]]]],[11,"defined_lib_features","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"get_lang_items","","",813,[[["self"],["cratenum"]],["lrc",["languageitems"]]]],[11,"defined_lang_items","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"missing_lang_items","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"visible_parent_map","","",813,[[["self"],["cratenum"]],["lrc",["defidmap"]]]],[11,"missing_extern_crate_item","","",813,[[["self"],["cratenum"]],["bool"]]],[11,"used_crate_source","","",813,[[["self"],["cratenum"]],["lrc",["cratesource"]]]],[11,"postorder_cnums","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"freevars","","",813,[[["self"],["defid"]],["option",["lrc"]]]],[11,"maybe_unused_trait_import","","",813,[[["self"],["defid"]],["bool"]]],[11,"maybe_unused_extern_crates","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"stability_index","","",813,[[["self"],["cratenum"]],["lrc",["index"]]]],[11,"all_crate_nums","","",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",813,[[["self"],["cratenum"]],["lrc",["vec"]]]],[11,"exported_symbols","","",813,[[["self"],["cratenum"]],["arc",["vec"]]]],[11,"collect_and_partition_mono_items","","",813,N],[11,"is_codegened_item","","",813,[[["self"],["defid"]],["bool"]]],[11,"codegen_unit","","",813,[[["self"],["internedstring"]],["arc",["codegenunit"]]]],[11,"output_filenames","","",813,[[["self"],["cratenum"]],["arc",["outputfilenames"]]]],[11,"erase_regions_ty","","",813,[[["self"],["ty"]],["ty"]]],[11,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",813,[[["self"],["canonicalprojectiongoal"]],["result",["lrc","nosolution"]]]],[11,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",813,[[["self"],["paramenvand",["ty"]]],["ty"]]],[11,"implied_outlives_bounds","","",813,[[["self"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[11,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",813,[[["self"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[11,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",813,[[["self"],["canonicalpredicategoal"]],["result",["evaluationresult","overflowerror"]]]],[11,"type_op_eq","","Do not call this query directly: part of the `Eq` type-op",813,[[["self"],["canonicaltypeopeqgoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_subtype","","Do not call this query directly: part of the `Subtype` type-op",813,[[["self"],["canonicaltypeopsubtypegoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_prove_predicate","","Do not call this query directly: part of the `ProvePredicate` type-op",813,[[["self"],["canonicaltypeopprovepredicategoal"]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_ty","","Do not call this query directly: part of the `Normalize` type-op",813,[[["self"],["canonicaltypeopnormalizegoal",["ty"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_predicate","","Do not call this query directly: part of the `Normalize` type-op",813,[[["self"],["canonicaltypeopnormalizegoal",["predicate"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_poly_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",813,[[["self"],["canonicaltypeopnormalizegoal",["polyfnsig"]]],["result",["lrc","nosolution"]]]],[11,"type_op_normalize_fn_sig","","Do not call this query directly: part of the `Normalize` type-op",813,[[["self"],["canonicaltypeopnormalizegoal",["fnsig"]]],["result",["lrc","nosolution"]]]],[11,"substitute_normalize_and_test_predicates","","",813,N],[11,"target_features_whitelist","","",813,[[["self"],["cratenum"]],["lrc",["fxhashmap"]]]],[11,"instance_def_size_estimate","","",813,[[["self"],["instancedef"]],["usize"]]],[11,"features_query","","",813,[[["self"],["cratenum"]],["lrc",["features"]]]],[11,"program_clauses_for","","",813,[[["self"],["defid"]],["clauses"]]],[11,"program_clauses_for_env","","",813,[[["self"],["paramenv"]],["clauses"]]],[11,"wasm_import_module_map","","",813,[[["self"],["cratenum"]],["lrc",["fxhashmap"]]]],[11,"default","","",814,[[],["self"]]],[11,"clone","","",814,[[["self"]],["self"]]],[11,"try_adt_sized_constraint","rustc::ty","",677,[[["self"],["span"],["defid"]],["result",["diagnosticbuilder"]]]],[11,"try_needs_drop_raw","","",677,[[["self"],["span"],["paramenvand",["ty"]]],["result",["bool","diagnosticbuilder"]]]],[11,"try_optimized_mir","","",677,[[["self"],["span"],["defid"]],["result",["mir","diagnosticbuilder"]]]],[0,"relate","","Generalized type relating mechanism. A type relation R relates a pair of values (A, B). A and B are usually types or regions but can be other things. Examples of type relations are subtyping, type equality, etc.",N,N],[3,"GeneratorWitness","rustc::ty::relate","",N,N],[12,"0","","",994,N],[4,"Cause","","",N,N],[13,"ExistentialRegionBound","","",995,N],[5,"relate_substs","","",N,[[["r"],["option",["vec"]],["substs"],["substs"]],["relateresult",["substs"]]]],[5,"super_relate_tys","","The main \"type relation\" routine. Note that this does not handle inference artifacts, so you should filter those out before calling it.",N,[[["r"],["ty"],["ty"]],["relateresult",["ty"]]]],[5,"expected_found","","",N,[[["r"],["t"],["t"]],["expectedfound"]]],[5,"expected_found_bool","","",N,[[["bool"],["t"],["t"]],["expectedfound"]]],[6,"RelateResult","","",N,N],[8,"TypeRelation","","",N,N],[10,"tcx","","",996,[[["self"]],["tyctxt"]]],[10,"tag","","Returns a static string we can use for printouts.",996,[[["self"]],["str"]]],[10,"a_is_expected","","Returns true if the value `a` is the \"expected\" type in the relation. Just affects error messages.",996,[[["self"]],["bool"]]],[11,"with_cause","","",996,[[["self"],["cause"],["f"]],["r"]]],[11,"relate","","Generic relation routine suitable for most anything.",996,[[["self"],["t"],["t"]],["relateresult"]]],[11,"relate_item_substs","","Relate the two substitutions for the given item. The default is to look up the variance for the item and proceed accordingly.",996,[[["self"],["defid"],["substs"],["substs"]],["relateresult",["substs"]]]],[10,"relate_with_variance","","Switch variance for the purpose of relating `a` and `b`.",996,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[10,"tys","","",996,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[10,"regions","","",996,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[10,"binders","","",996,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[8,"Relate","","",N,N],[10,"relate","","",997,[[["r"],["self"],["self"]],["relateresult"]]],[11,"clone","","",995,[[["self"]],["cause"]]],[11,"fmt","","",995,[[["self"],["formatter"]],["result"]]],[11,"relate","rustc::ty","",666,[[["r"],["typeandmut"],["typeandmut"]],["relateresult",["typeandmut"]]]],[11,"relate","","",660,[[["r"],["fnsig"],["fnsig"]],["relateresult",["fnsig"]]]],[11,"relate","rustc::hir","",127,[[["r"],["unsafety"],["unsafety"]],["relateresult",["unsafety"]]]],[11,"relate","rustc::ty","",663,[[["r"],["projectionty"],["projectionty"]],["relateresult",["projectionty"]]]],[11,"relate","","",669,[[["r"],["existentialprojection"],["existentialprojection"]],["relateresult",["existentialprojection"]]]],[11,"relate","","",667,[[["r"],["traitref"],["traitref"]],["relateresult",["traitref"]]]],[11,"relate","","",668,[[["r"],["existentialtraitref"],["existentialtraitref"]],["relateresult",["existentialtraitref"]]]],[11,"fmt","rustc::ty::relate","",994,[[["self"],["formatter"]],["result"]]],[11,"clone","","",994,[[["self"]],["generatorwitness"]]],[11,"super_fold_with","","",994,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",994,[[["self"],["v"]],["bool"]]],[11,"relate","","",994,[[["r"],["generatorwitness"],["generatorwitness"]],["relateresult",["generatorwitness"]]]],[11,"relate","rustc::ty","",664,[[["r"],["closuresubsts"],["closuresubsts"]],["relateresult",["closuresubsts"]]]],[11,"relate","","",665,[[["r"],["generatorsubsts"],["generatorsubsts"]],["relateresult",["generatorsubsts"]]]],[11,"relate","","",657,[[["r"],["binder"],["binder"]],["relateresult",["binder"]]]],[0,"steal","","",N,N],[3,"Steal","rustc::ty::steal","The `Steal` struct is intended to used as the value for a query. Specifically, we sometimes have queries (cough MIR cough) where we create a large, complex value that we want to iteratively update (e.g., optimize). We could clone the value for each optimization, but that'd be expensive. And yet we don't just want to mutate it in place, because that would spoil the idea that queries are these pure functions that produce an immutable value (since if you did the query twice, you could observe the mutations). So instead we have the query produce a `&'tcx Steal<Mir<'tcx>>` (to be very specific). Now we can read from this as much as we want (using `borrow()`), but you can also `steal()`. Once you steal, any further attempt to read will panic. Therefore we know that -- assuming no ICE -- nobody is observing the fact that the MIR was updated.",N,N],[12,"value","","",998,N],[11,"new","","",998,[[["t"]],["self"]]],[11,"borrow","","",998,[[["self"]],["mappedreadguard"]]],[11,"steal","","",998,[[["self"]],["t"]]],[0,"subst","rustc::ty","",N,N],[3,"Kind","rustc::ty::subst","An entity in the Rust typesystem, which can be one of several kinds (only types and lifetimes for now). To reduce memory usage, a `Kind` is a interned pointer, with the lowest 2 bits being reserved for a tag to indicate the type (`Ty` or `Region`) it points to.",N,N],[12,"ptr","","",999,N],[12,"marker","","",999,N],[3,"SubstFolder","","",N,N],[12,"tcx","","",1000,N],[12,"substs","","",1000,N],[12,"span","","",1000,N],[12,"root_ty","","",1000,N],[12,"ty_stack_depth","","",1000,N],[12,"region_binders_passed","","",1000,N],[4,"UnpackedKind","","",N,N],[13,"Lifetime","","",1001,N],[13,"Type","","",1001,N],[6,"Substs","","A substitution mapping generic parameters to new values.",N,N],[6,"CanonicalSubsts","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"TAG_MASK","","",N,N],[17,"TYPE_TAG","","",N,N],[17,"REGION_TAG","","",N,N],[8,"Subst","","",N,N],[11,"subst","","",1002,N],[10,"subst_spanned","","",1002,N],[11,"clone","","",999,[[["self"]],["kind"]]],[11,"eq","","",999,[[["self"],["kind"]],["bool"]]],[11,"ne","","",999,[[["self"],["kind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",999,N],[11,"hash","","",999,N],[11,"fmt","","",1001,[[["self"],["formatter"]],["result"]]],[11,"encode","","",1001,[[["self"],["__s"]],["result"]]],[11,"decode","","",1001,[[["__d"]],["result",["unpackedkind"]]]],[11,"eq","","",1001,[[["self"],["unpackedkind"]],["bool"]]],[11,"ne","","",1001,[[["self"],["unpackedkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1001,N],[11,"partial_cmp","","",1001,[[["self"],["unpackedkind"]],["option",["ordering"]]]],[11,"lt","","",1001,[[["self"],["unpackedkind"]],["bool"]]],[11,"le","","",1001,[[["self"],["unpackedkind"]],["bool"]]],[11,"gt","","",1001,[[["self"],["unpackedkind"]],["bool"]]],[11,"ge","","",1001,[[["self"],["unpackedkind"]],["bool"]]],[11,"cmp","","",1001,[[["self"],["unpackedkind"]],["ordering"]]],[11,"pack","","",1001,[[["self"]],["kind"]]],[11,"cmp","","",999,[[["self"],["kind"]],["ordering"]]],[11,"partial_cmp","","",999,[[["self"],["kind"]],["option",["ordering"]]]],[11,"from","","",999,[[["region"]],["kind"]]],[11,"from","","",999,[[["ty"]],["kind"]]],[11,"unpack","","",999,[[["self"]],["unpackedkind"]]],[11,"fmt","","",999,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",999,[[["self"],["formatter"]],["result"]]],[11,"lift_to_tcx","","",999,[[["self"],["tyctxt"]],["option"]]],[11,"super_fold_with","","",999,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",999,[[["self"],["v"]],["bool"]]],[11,"encode","","",999,[[["self"],["e"]],["result"]]],[11,"decode","","",999,[[["d"]],["result",["kind"]]]],[11,"identity_for_item","","Creates a Substs that maps each generic parameter to itself.",1003,[[["tyctxt"],["defid"]],["substs"]]],[11,"for_item","","Creates a Substs for generic parameter definitions, by calling closures to obtain each kind. The closures get to observe the Substs as they're being built, which can be used to correctly substitute defaults of generic parameters.",1003,[[["tyctxt"],["defid"],["f"]],["substs"]]],[11,"extend_to","","",1003,[[["self"],["tyctxt"],["defid"],["f"]],["substs"]]],[11,"fill_item","","",1003,[[["smallvec"],["tyctxt"],["generics"],["f"]]]],[11,"fill_single","","",1003,[[["smallvec"],["generics"],["f"]]]],[11,"is_noop","","",1003,[[["self"]],["bool"]]],[11,"types","","",1003,N],[11,"regions","","",1003,N],[11,"type_at","","",1003,[[["self"],["usize"]],["ty"]]],[11,"region_at","","",1003,[[["self"],["usize"]],["region"]]],[11,"type_for_def","","",1003,[[["self"],["genericparamdef"]],["kind"]]],[11,"rebase_onto","","Transform from substitutions for a child of `source_ancestor` (e.g. a trait or impl) to substitutions for the same child in a different item, with `target_substs` as the base for the target impl/trait, with the source child-specific parameters (e.g. method parameters) on top of that base.",1003,[[["self"],["tyctxt"],["defid"],["substs"]],["substs"]]],[11,"truncate_to","","",1003,[[["self"],["tyctxt"],["generics"]],["substs"]]],[11,"is_identity","","True if this represents a substitution like",1004,[[["self"]],["bool"]]],[11,"tcx","","",1000,[[["self"]],["tyctxt"]]],[11,"fold_binder","","",1000,[[["self"],["binder"]],["binder"]]],[11,"fold_region","","",1000,[[["self"],["region"]],["region"]]],[11,"fold_ty","","",1000,[[["self"],["ty"]],["ty"]]],[11,"ty_for_param","","",1000,[[["self"],["paramty"],["ty"]],["ty"]]],[11,"shift_regions_through_binders","","It is sometimes necessary to adjust the debruijn indices during substitution. This occurs when we are substituting a type with escaping regions into a context where we have passed through region binders. That's quite a mouthful. Let's see an example:",1000,[[["self"],["ty"]],["ty"]]],[11,"shift_region_through_binders","","",1000,[[["self"],["region"]],["region"]]],[0,"trait_def","rustc::ty","",N,N],[3,"TraitDef","rustc::ty::trait_def","A trait's definition with type information.",N,N],[12,"def_id","","",1005,N],[12,"unsafety","","",1005,N],[12,"paren_sugar","","If `true`, then this trait had the `#[rustc_paren_sugar]` attribute, indicating that it should be used with `Foo()` sugar. This is a temporary thing -- eventually any trait will be usable with the sugar (or without it).",1005,N],[12,"has_auto_impl","","",1005,N],[12,"def_path_hash","","The ICH of this trait's DefPath, cached here so it doesn't have to be recomputed all the time.",1005,N],[3,"TraitImpls","","",N,N],[12,"blanket_impls","","",1006,N],[12,"non_blanket_impls","","Impls indexed by their simplified self-type, for fast lookup.",1006,N],[5,"trait_impls_of_provider","","",N,[[["tyctxt"],["defid"]],["lrc",["traitimpls"]]]],[11,"default","","",1006,[[],["traitimpls"]]],[11,"new","","",1005,[[["defid"],["unsafety"],["bool"],["bool"],["defpathhash"]],["traitdef"]]],[11,"ancestors","","",1005,[[["self"],["tyctxt"],["defid"]],["ancestors"]]],[11,"for_each_impl","rustc::ty","",677,[[["self"],["defid"],["f"]]]],[11,"for_each_relevant_impl","","Iterate over every impl that could possibly match the self-type `self_ty`.",677,[[["self"],["defid"],["ty"],["f"]]]],[11,"hash_stable","rustc::ty::trait_def","",1006,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[0,"walk","rustc::ty","An iterator over the type substructure. WARNING: this does not keep track of the region depth.",N,N],[3,"TypeWalker","rustc::ty::walk","",N,N],[12,"stack","","",1007,N],[12,"last_subtree","","",1007,N],[5,"walk_shallow","","",N,[[["ty"]],["intoiter",["typewalkerarray"]]]],[5,"push_subtypes","","",N,[[["typewalkerstack"],["ty"]]]],[5,"push_const","","",N,[[["typewalkerstack"],["const"]]]],[6,"TypeWalkerArray","","",N,N],[6,"TypeWalkerStack","","",N,N],[11,"new","","",1007,[[["ty"]],["typewalker"]]],[11,"skip_current_subtree","","Skips the subtree of types corresponding to the last type returned by `next()`.",1007,[[["self"]]]],[11,"next","","",1007,[[["self"]],["option",["ty"]]]],[0,"wf","rustc::ty","",N,N],[3,"WfPredicates","rustc::ty::wf","",N,N],[12,"infcx","","",1008,N],[12,"param_env","","",1008,N],[12,"body_id","","",1008,N],[12,"span","","",1008,N],[12,"out","","",1008,N],[4,"Elaborate","","Controls whether we \"elaborate\" supertraits and so forth on the WF predicates. This is a kind of hack to address #43784. The underlying problem in that issue was a trait structure like:",N,N],[13,"All","","",1009,N],[13,"None","","",1009,N],[5,"obligations","","Returns the set of obligations needed to make `ty` well-formed. If `ty` contains unresolved inference variables, this may include further WF obligations. However, if `ty` IS an unresolved inference variable, returns `None`, because we are not able to make any progress at all. This is to prevent \"livelock\" where we say \"$0 is WF if $0 is WF\".",N,[[["inferctxt"],["paramenv"],["nodeid"],["ty"],["span"]],["option",["vec"]]]],[5,"trait_obligations","","Returns the obligations that make this trait reference well-formed.  For example, if there is a trait `Set` defined like `trait Set<K:Eq>`, then the trait reference `Foo: Set<Bar>` is WF if `Bar: Eq`.",N,[[["inferctxt"],["paramenv"],["nodeid"],["traitref"],["span"]],["vec",["predicateobligation"]]]],[5,"predicate_obligations","","",N,[[["inferctxt"],["paramenv"],["nodeid"],["predicate"],["span"]],["vec",["predicateobligation"]]]],[5,"object_region_bounds","","Given an object type like `SomeTrait+Send`, computes the lifetime bounds that must hold on the elided self type. These are derived from the declarations of `SomeTrait`, `Send`, and friends -- if they declare `trait SomeTrait : 'static`, for example, then `'static` would appear in the list. The hard work is done by `ty::required_region_bounds`, see that for more information.",N,[[["tyctxt"],["binder",["list"]]],["vec",["region"]]]],[11,"fmt","","",1009,[[["self"],["formatter"]],["result"]]],[11,"eq","","",1009,[[["self"],["elaborate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1009,N],[11,"clone","","",1009,[[["self"]],["elaborate"]]],[11,"cause","","",1008,[[["self"],["obligationcausecode"]],["obligationcause"]]],[11,"normalize","","",1008,[[["self"]],["vec",["predicateobligation"]]]],[11,"compute_trait_ref","","Pushes the obligations required for `trait_ref` to be WF into `self.out`.",1008,[[["self"],["traitref"],["elaborate"]]]],[11,"compute_projection","","Pushes the obligations required for `trait_ref::Item` to be WF into `self.out`.",1008,[[["self"],["projectionty"]]]],[11,"compute_const","","Pushes the obligations required for a constant value to be WF into `self.out`.",1008,[[["self"],["const"]]]],[11,"require_sized","","",1008,[[["self"],["ty"],["obligationcausecode"]]]],[11,"compute","","Push new obligations into `out`. Returns true if it was able to generate all the predicates needed to validate that `ty0` is WF. Returns false if `ty0` is an unresolved type variable, in which case we are not able to simplify at all.",1008,[[["self"],["ty"]],["bool"]]],[11,"nominal_obligations","","",1008,[[["self"],["defid"],["substs"]],["vec",["predicateobligation"]]]],[11,"from_object_ty","","",1008,[[["self"],["ty"],["binder",["list"]],["region"]]]],[0,"util","rustc::ty","misc. type-system utilities too small to deserve their own file",N,N],[3,"Discr","rustc::ty::util","",N,N],[12,"val","","bit representation of the discriminant, so `-128i8` is `0xFF_u128`",1010,N],[12,"ty","","",1010,N],[4,"CopyImplementationError","","",N,N],[13,"InfrigingFields","","",1011,N],[13,"NotAnAdt","","",1011,N],[13,"HasDestructor","","",1011,N],[4,"Representability","","Describes whether a type is representable. For types that are not representable, 'SelfRecursive' and 'ContainsRecursive' are used to distinguish between types that are recursive with themselves and types that contain a different recursive type. These cases can therefore be treated differently when reporting errors.",N,N],[13,"Representable","","",1012,N],[13,"ContainsRecursive","","",1012,N],[13,"SelfRecursive","","",1012,N],[4,"ExplicitSelf","","",N,N],[13,"ByValue","","",1013,N],[13,"ByReference","","",1013,N],[13,"ByRawPointer","","",1013,N],[13,"ByBox","","",1013,N],[13,"Other","","",1013,N],[5,"is_copy_raw","","",N,[[["tyctxt"],["paramenvand",["ty"]]],["bool"]]],[5,"is_sized_raw","","",N,[[["tyctxt"],["paramenvand",["ty"]]],["bool"]]],[5,"is_freeze_raw","","",N,[[["tyctxt"],["paramenvand",["ty"]]],["bool"]]],[5,"needs_drop_raw","","",N,[[["tyctxt"],["paramenvand",["ty"]]],["bool"]]],[5,"provide","","",N,[[["providers"]]]],[8,"IntTypeExt","","",N,N],[10,"to_ty","","",1014,[[["self"],["tyctxt"]],["ty"]]],[10,"disr_incr","","",1014,[[["self"],["tyctxt"],["option",["discr"]]],["option",["discr"]]]],[10,"initial_discriminant","","",1014,[[["self"],["tyctxt"]],["discr"]]],[11,"clone","","",1010,[[["self"]],["discr"]]],[11,"fmt","","",1010,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",1010,[[["self"],["formatter"]],["result"]]],[11,"wrap_incr","","Adds 1 to the value and wraps around if the maximum for the type is reached",1010,[[["self"],["tyctxt"]],["self"]]],[11,"checked_add","","",1010,N],[11,"clone","","",1011,[[["self"]],["copyimplementationerror"]]],[11,"clone","","",1012,[[["self"]],["representability"]]],[11,"partial_cmp","","",1012,[[["self"],["representability"]],["option",["ordering"]]]],[11,"lt","","",1012,[[["self"],["representability"]],["bool"]]],[11,"le","","",1012,[[["self"],["representability"]],["bool"]]],[11,"gt","","",1012,[[["self"],["representability"]],["bool"]]],[11,"ge","","",1012,[[["self"],["representability"]],["bool"]]],[11,"cmp","","",1012,[[["self"],["representability"]],["ordering"]]],[11,"assert_receiver_is_total_eq","","",1012,N],[11,"eq","","",1012,[[["self"],["representability"]],["bool"]]],[11,"ne","","",1012,[[["self"],["representability"]],["bool"]]],[11,"fmt","","",1012,[[["self"],["formatter"]],["result"]]],[11,"can_type_implement_copy","rustc::ty","",706,[[["self"],["tyctxt"],["ty"]],["result",["copyimplementationerror"]]]],[11,"type_id_hash","","Creates a hash of the type `Ty` which will be the same no matter what crate context it's calculated within. This is used by the `type_id` intrinsic.",677,[[["self"],["ty"]],["u64"]]],[11,"has_error_field","","",677,[[["self"],["ty"]],["bool"]]],[11,"struct_tail","","Returns the deeply last field of nested structures, or the same type, if not a structure at all. Corresponds to the only possible unsized field, and its type can be used to determine unsizing strategy.",677,[[["self"],["ty"]],["ty"]]],[11,"struct_lockstep_tails","","Same as applying struct_tail on `source` and `target`, but only keeps going as long as the two types are instances of the same structure definitions. For `(Foo<Foo<T>>, Foo<Trait>)`, the result will be `(Foo<T>, Trait)`, whereas struct_tail produces `T`, and `Trait`, respectively.",677,N],[11,"required_region_bounds","","Given a set of predicates that apply to an object type, returns the region bounds that the (erased) `Self` type must outlive. Precisely because the `Self` type is erased, the parameter `erased_self_ty` must be supplied to indicate what type has been used to represent `Self` in the predicates themselves. This should really be a unique type; `FreshTy(0)` is a popular choice.",677,[[["self"],["ty"],["vec",["predicate"]]],["vec",["region"]]]],[11,"calculate_dtor","","Calculate the destructor of a given type.",677,[[["self"],["defid"],["fnmut"]],["option",["destructor"]]]],[11,"destructor_constraints","","Return the set of types that are required to be alive in order to run the destructor of `def` (see RFCs 769 and 1238).",677,[[["self"],["adtdef"]],["vec",["kind"]]]],[11,"is_closure","","True if `def_id` refers to a closure (e.g., `|x| x * 2`). Note that closures have a def-id, but the closure expression also has a `HirId` that is located within the context where the closure appears (and, sadly, a corresponding `NodeId`, since those are not yet phased out). The parent of the closure's def-id will also be the context where it appears.",677,[[["self"],["defid"]],["bool"]]],[11,"is_trait","","True if `def_id` refers to a trait (e.g., `trait Foo { ... }`).",677,[[["self"],["defid"]],["bool"]]],[11,"is_struct_constructor","","True if this def-id refers to the implicit constructor for a tuple struct like `struct Foo(u32)`.",677,[[["self"],["defid"]],["bool"]]],[11,"closure_base_def_id","","Given the `DefId` of a fn or closure, returns the `DefId` of the innermost fn item that the closure is contained within. This is a significant def-id because, when we do type-checking, we type-check this fn item and all of its (transitive) closures together.  Therefore, when we fetch the `typeck_tables_of` the closure, for example, we really wind up fetching the `typeck_tables_of` the enclosing fn item.",677,[[["self"],["defid"]],["defid"]]],[11,"closure_env_ty","","Given the def-id and substs a closure, creates the type of `self` argument that the closure expects. For example, for a `Fn` closure, this would return a reference type `&T` where `T=closure_ty`.",677,[[["self"],["defid"],["closuresubsts"]],["option",["binder"]]]],[11,"empty_substs_for_def_id","","Given the def-id of some item that has no type parameters, make a suitable \"empty substs\" for it.",677,[[["self"],["defid"]],["substs"]]],[11,"is_static","","Return whether the node pointed to by def_id is a static item, and its mutability",677,[[["self"],["defid"]],["option",["mutability"]]]],[11,"moves_by_default","","",689,[[["self"],["tyctxt"],["paramenv"],["span"]],["bool"]]],[11,"is_sized","","",689,[[["self"],["tyctxtat"],["paramenv"]],["bool"]]],[11,"is_freeze","","",689,[[["self"],["tyctxt"],["paramenv"],["span"]],["bool"]]],[11,"needs_drop","","If `ty.needs_drop(...)` returns `true`, then `ty` is definitely non-copy and might have a destructor attached; if it returns `false`, then `ty` definitely has no destructor (i.e. no drop glue).",689,[[["self"],["tyctxt"],["paramenv"]],["bool"]]],[11,"is_representable","","Check whether a type is representable. This means it cannot contain unboxed structural recursion. This check is needed for structs and enums.",689,[[["self"],["tyctxt"],["span"]],["representability"]]],[11,"determine","rustc::ty::util","Categorizes an explicit self declaration like `self: SomeType` into either `self`, `&self`, `&mut self`, `Box<self>`, or `Other`. This is mainly used to require the arbitrary_self_types feature in the case of `Other`, to improve error messages in the common cases, and to make `Other` non-object-safe.",1013,[[["ty"],["p"]],["explicitself"]]],[0,"context","rustc::ty","type context book-keeping",N,N],[3,"AllArenas","rustc::ty::context","",N,N],[12,"global","","",679,N],[12,"interner","","",679,N],[3,"GlobalArenas","","Internal storage",N,N],[12,"layout","","",678,N],[12,"generics","","",678,N],[12,"trait_def","","",678,N],[12,"adt_def","","",678,N],[12,"steal_mir","","",678,N],[12,"mir","","",678,N],[12,"tables","","",678,N],[12,"const_allocs","","miri allocations",678,N],[3,"CtxtInterners","","",N,N],[12,"arena","","The arena that types, regions, etc are allocated from",1015,N],[12,"type_","","Specifically use a speedy hash algorithm for these hash sets, they're accessed quite often.",1015,N],[12,"type_list","","",1015,N],[12,"substs","","",1015,N],[12,"canonical_var_infos","","",1015,N],[12,"region","","",1015,N],[12,"existential_predicates","","",1015,N],[12,"predicates","","",1015,N],[12,"const_","","",1015,N],[12,"clauses","","",1015,N],[12,"goals","","",1015,N],[3,"CommonTypes","","",N,N],[12,"bool","","",1016,N],[12,"char","","",1016,N],[12,"isize","","",1016,N],[12,"i8","","",1016,N],[12,"i16","","",1016,N],[12,"i32","","",1016,N],[12,"i64","","",1016,N],[12,"i128","","",1016,N],[12,"usize","","",1016,N],[12,"u8","","",1016,N],[12,"u16","","",1016,N],[12,"u32","","",1016,N],[12,"u64","","",1016,N],[12,"u128","","",1016,N],[12,"f32","","",1016,N],[12,"f64","","",1016,N],[12,"never","","",1016,N],[12,"err","","",1016,N],[12,"re_empty","","",1016,N],[12,"re_static","","",1016,N],[12,"re_erased","","",1016,N],[3,"LocalTableInContext","","",N,N],[12,"local_id_root","","",1017,N],[12,"data","","",1017,N],[3,"LocalTableInContextMut","","",N,N],[12,"local_id_root","","",1018,N],[12,"data","","",1018,N],[3,"TypeckTables","","",N,N],[12,"local_id_root","","The HirId::owner all ItemLocalIds in this table are relative to.",680,N],[12,"type_dependent_defs","","Resolved definitions for `<T>::X` associated paths and method calls, including those of overloaded operators.",680,N],[12,"field_indices","","Resolved field indices for field accesses in expressions (`S { field }`, `obj.field`) or patterns (`S { field }`). The index is often useful by itself, but to learn more about the field you also need definition of the variant to which the field belongs, but it may not exist if it's a tuple field (`tuple.0`).",680,N],[12,"user_provided_tys","","Stores the canonicalized types provided by the user. See also `AscribeUserType` statement in MIR.",680,N],[12,"node_types","","Stores the types for various nodes in the AST.  Note that this table is not guaranteed to be populated until after typeck.  See typeck::check::fn_ctxt for details.",680,N],[12,"node_substs","","Stores the type parameters which were substituted to obtain the type of this node.  This only applies to nodes that refer to entities parameterized by type parameters, such as generic fns, types, or other items.",680,N],[12,"user_substs","","Stores the substitutions that the user explicitly gave (if any) attached to `id`. These will not include any inferred values. The canonical form is used to capture things like `_` or other unspecified values.",680,N],[12,"adjustments","","",680,N],[12,"pat_binding_modes","","Stores the actual binding mode for all instances of hir::BindingAnnotation.",680,N],[12,"pat_adjustments","","Stores the types which were implicitly dereferenced in pattern binding modes for later usage in HAIR lowering. For example,",680,N],[12,"upvar_capture_map","","Borrows",680,N],[12,"closure_kind_origins","","Records the reasons that we picked the kind of each closure; not all closures are present in the map.",680,N],[12,"liberated_fn_sigs","","For each fn, records the \"liberated\" types of its arguments and return type. Liberated means that all bound regions (including late-bound regions) are replaced with free equivalents. This table is not used in codegen (since regions are erased there) and hence is not serialized to metadata.",680,N],[12,"fru_field_types","","For each FRU expression, record the normalized types of the fields of the struct - this is needed because it is non-trivial to normalize while preserving regions. This table is used only in MIR construction and hence is not serialized to metadata.",680,N],[12,"cast_kinds","","Maps a cast expression to its kind. This is keyed on the from expression of the cast, not the cast itself.",680,N],[12,"used_trait_imports","","Set of trait imports actually used in the method resolution. This is used for warning unused imports. During type checking, this `Lrc` should not be cloned: it must have a ref-count of 1 so that we can insert things into the set mutably.",680,N],[12,"tainted_by_errors","","If any errors occurred while type-checking this body, this field will be set to `true`.",680,N],[12,"free_region_map","","Stores the free-region relationships that were deduced from its where clauses and parameter types. These are then read-again by borrowck.",680,N],[12,"concrete_existential_types","","All the existential types that are restricted to concrete types by this function",680,N],[3,"TyCtxt","","The central data structure of the compiler. It stores references to the various arenas and also houses the results of the various compiler queries that have been performed. See the [rustc guide] for more details.",N,N],[12,"gcx","","",677,N],[12,"interners","","",677,N],[3,"GlobalCtxt","","",N,N],[12,"global_arenas","","",1019,N],[12,"global_interners","","",1019,N],[12,"cstore","","",1019,N],[12,"sess","","",1019,N],[12,"dep_graph","","",1019,N],[12,"types","","Common types, pre-interned for your convenience.",1019,N],[12,"trait_map","","Map indicating what traits are in scope for places where this is relevant; generated by resolve.",1019,N],[12,"export_map","","Export map produced by name resolution.",1019,N],[12,"hir","","",1019,N],[12,"def_path_hash_to_def_id","","A map from DefPathHash -> DefId. Includes DefIds from the local crate as well as all upstream crates. Only populated in incremental mode.",1019,N],[12,"queries","","",1019,N],[12,"freevars","","",1019,N],[12,"maybe_unused_trait_imports","","",1019,N],[12,"maybe_unused_extern_crates","","",1019,N],[12,"extern_prelude","","",1019,N],[12,"rcache","","",1019,N],[12,"selection_cache","","Caches the results of trait selection. This cache is used for things that do not have to do with the parameters in scope.",1019,N],[12,"evaluation_cache","","Caches the results of trait evaluation. This cache is used for things that do not have to do with the parameters in scope. Merge this with `selection_cache`?",1019,N],[12,"crate_name","","The definite name of the current crate after taking into account attributes, commandline parameters, etc.",1019,N],[12,"data_layout","","Data layout specification for the current target.",1019,N],[12,"stability_interner","","",1019,N],[12,"allocation_interner","","Stores the value of constants (and deduplicates the actual memory)",1019,N],[12,"alloc_map","","",1019,N],[12,"layout_interner","","",1019,N],[12,"tx_to_llvm_workers","","A general purpose channel to throw data out the back towards LLVM worker threads.",1019,N],[12,"output_filenames","","",1019,N],[3,"Interned","","An entry in an interner.",N,N],[12,"0","","",1020,N],[5,"validate_hir_id_for_typeck_tables","","Validate that the given HirId (respectively its `local_id` part) can be safely used as a key in the tables of a TypeckTable. For that to be the case, the HirId must have the same `owner` as all the other IDs in this table (signified by `local_id_root`). Otherwise the HirId would be in a different frame of reference and using its `local_id` would result in lookup errors, or worse, in silently wrong data being stored/returned.",N,[[["option",["defid"]],["hirid"],["bool"]]]],[5,"keep_local","","",N,[[["t"]],["bool"]]],[5,"provide","","",N,[[["providers"]]]],[0,"tls","","",N,N],[3,"ImplicitCtxt","rustc::ty::context::tls","This is the implicit state of rustc. It contains the current TyCtxt and query. It is updated when creating a local interner or executing a new query. Whenever there's a TyCtxt value available you should also have access to an ImplicitCtxt through the functions in this module.",N,N],[12,"tcx","","The current TyCtxt. Initially created by `enter_global` and updated by `enter_local` with a new local interner",738,N],[12,"query","","The current query job, if any. This is updated by start_job in ty::query::plumbing when executing a query",738,N],[12,"layout_depth","","Used to prevent layout from recursing too deeply.",738,N],[12,"task","","The current dep graph task. This is used to add dependencies to queries when executing them",738,N],[5,"set_tlv","","Sets TLV to `value` during the call to `f`. It is restored to its previous value after. This is used to set the pointer to the new ImplicitCtxt.",N,[[["usize"],["f"]],["r"]]],[5,"get_tlv","","This is used to get the pointer to the current ImplicitCtxt.",N,[[],["usize"]]],[5,"span_debug","","This is a callback from libsyntax as it cannot access the implicit state in librustc otherwise",N,[[["span"],["formatter"]],["result"]]],[5,"track_diagnostic","","This is a callback from libsyntax as it cannot access the implicit state in librustc otherwise. It is used to when diagnostic messages are emitted and stores them in the current query, if there is one.",N,[[["diagnostic"]]]],[5,"with_thread_locals","","Sets up the callbacks from libsyntax on the current thread",N,[[["f"]],["r"]]],[5,"enter_context","","Sets `context` as the new current ImplicitCtxt for the duration of the function `f`",N,[[["implicitctxt"],["f"]],["r"]]],[5,"enter_global","","Enters GlobalCtxt by setting up libsyntax callbacks and creating a initial TyCtxt and ImplicitCtxt. This happens once per rustc session and TyCtxts only exists inside the `f` function.",N,[[["globalctxt"],["f"]],["r"]]],[5,"with_global","","Creates a TyCtxt and ImplicitCtxt based on the GCX_PTR thread local. This is used in the deadlock handler.",N,[[["f"]],["r"]]],[5,"with_context_opt","","Allows access to the current ImplicitCtxt in a closure if one is available",N,[[["f"]],["r"]]],[5,"with_context","","Allows access to the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[5,"with_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'gcx lifetime as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner from the current ImplicitCtxt's tcx field.",N,[[["tyctxt"],["f"]],["r"]]],[5,"with_fully_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner and local interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'tcx and 'gcx lifetimes as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner or a different local interner from the current ImplicitCtxt's tcx field.",N,[[["tyctxt"],["f"]],["r"]]],[5,"with","","Allows access to the TyCtxt in the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[5,"with_opt","","Allows access to the TyCtxt in the current ImplicitCtxt. The closure is passed None if there is no ImplicitCtxt available",N,[[["f"]],["r"]]],[7,"GCX_PTR","","",N,N],[17,"TLV","","",N,N],[11,"clone","rustc::ty::tls","",738,[[["self"]],["implicitctxt"]]],[6,"InternedSet","rustc::ty::context","",N,N],[8,"Lift","","A trait implemented for all X<'a> types which can be safely and efficiently converted to X<'tcx> as long as they are part of the provided TyCtxt<'tcx>. This can be done, for example, for Ty<'tcx> or &'tcx Substs<'tcx> by looking them up in their respective interners.",N,N],[16,"Lifted","","",1021,N],[10,"lift_to_tcx","","",1021,[[["self"],["tyctxt"]],["option"]]],[8,"InternAs","","",N,N],[16,"Output","","",1022,N],[10,"intern_with","","",1022,N],[8,"InternIteratorElement","","",N,N],[16,"Output","","",1023,N],[10,"intern_with","","",1023,N],[11,"new","rustc::ty","",679,[[],["self"]]],[11,"new","","",678,[[],["globalarenas"]]],[11,"new","rustc::ty::context","",1015,[[["syncdroplessarena"]],["ctxtinterners"]]],[11,"intern_ty","","Intern a type",1015,[[["ctxtinterners"],["ctxtinterners"],["tykind"]],["ty"]]],[11,"contains_key","","",1017,[[["self"],["hirid"]],["bool"]]],[11,"get","","",1017,[[["self"],["hirid"]],["option"]]],[11,"iter","","",1017,[[["self"]],["iter",["itemlocalid"]]]],[11,"index","","",1017,[[["self"],["hirid"]],["v"]]],[11,"get_mut","","",1018,[[["self"],["hirid"]],["option"]]],[11,"entry","","",1018,[[["self"],["hirid"]],["entry",["itemlocalid"]]]],[11,"insert","","",1018,[[["self"],["hirid"],["v"]],["option"]]],[11,"remove","","",1018,[[["self"],["hirid"]],["option"]]],[11,"encode","rustc::ty","",680,[[["self"],["__s"]],["result"]]],[11,"decode","","",680,[[["__d"]],["result",["typecktables"]]]],[11,"fmt","","",680,[[["self"],["formatter"]],["result"]]],[11,"empty","","",680,[[["option",["defid"]]],["typecktables"]]],[11,"qpath_def","","Returns the final resolution of a `QPath` in an `Expr` or `Pat` node.",680,[[["self"],["qpath"],["hirid"]],["def"]]],[11,"type_dependent_defs","","",680,[[["self"]],["localtableincontext",["def"]]]],[11,"type_dependent_defs_mut","","",680,[[["self"]],["localtableincontextmut",["def"]]]],[11,"field_indices","","",680,[[["self"]],["localtableincontext",["usize"]]]],[11,"field_indices_mut","","",680,[[["self"]],["localtableincontextmut",["usize"]]]],[11,"user_provided_tys","","",680,[[["self"]],["localtableincontext",["canonicalty"]]]],[11,"user_provided_tys_mut","","",680,[[["self"]],["localtableincontextmut",["canonicalty"]]]],[11,"node_types","","",680,[[["self"]],["localtableincontext",["ty"]]]],[11,"node_types_mut","","",680,[[["self"]],["localtableincontextmut",["ty"]]]],[11,"node_id_to_type","","",680,[[["self"],["hirid"]],["ty"]]],[11,"node_id_to_type_opt","","",680,[[["self"],["hirid"]],["option",["ty"]]]],[11,"node_substs_mut","","",680,[[["self"]],["localtableincontextmut",["substs"]]]],[11,"node_substs","","",680,[[["self"],["hirid"]],["substs"]]],[11,"node_substs_opt","","",680,[[["self"],["hirid"]],["option",["substs"]]]],[11,"user_substs_mut","","",680,[[["self"]],["localtableincontextmut",["canonicalsubsts"]]]],[11,"user_substs","","",680,[[["self"],["hirid"]],["option",["canonicalsubsts"]]]],[11,"pat_ty","","",680,[[["self"],["pat"]],["ty"]]],[11,"pat_ty_opt","","",680,[[["self"],["pat"]],["option",["ty"]]]],[11,"expr_ty","","",680,[[["self"],["expr"]],["ty"]]],[11,"expr_ty_opt","","",680,[[["self"],["expr"]],["option",["ty"]]]],[11,"adjustments","","",680,[[["self"]],["localtableincontext",["vec"]]]],[11,"adjustments_mut","","",680,[[["self"]],["localtableincontextmut",["vec"]]]],[11,"expr_adjustments","","",680,N],[11,"expr_ty_adjusted","","Returns the type of `expr`, considering any `Adjustment` entry recorded for that expression.",680,[[["self"],["expr"]],["ty"]]],[11,"expr_ty_adjusted_opt","","",680,[[["self"],["expr"]],["option",["ty"]]]],[11,"is_method_call","","",680,[[["self"],["expr"]],["bool"]]],[11,"pat_binding_modes","","",680,[[["self"]],["localtableincontext",["bindingmode"]]]],[11,"pat_binding_modes_mut","","",680,[[["self"]],["localtableincontextmut",["bindingmode"]]]],[11,"pat_adjustments","","",680,[[["self"]],["localtableincontext",["vec"]]]],[11,"pat_adjustments_mut","","",680,[[["self"]],["localtableincontextmut",["vec"]]]],[11,"upvar_capture","","",680,[[["self"],["upvarid"]],["upvarcapture"]]],[11,"closure_kind_origins","","",680,[[["self"]],["localtableincontext"]]],[11,"closure_kind_origins_mut","","",680,[[["self"]],["localtableincontextmut"]]],[11,"liberated_fn_sigs","","",680,[[["self"]],["localtableincontext",["fnsig"]]]],[11,"liberated_fn_sigs_mut","","",680,[[["self"]],["localtableincontextmut",["fnsig"]]]],[11,"fru_field_types","","",680,[[["self"]],["localtableincontext",["vec"]]]],[11,"fru_field_types_mut","","",680,[[["self"]],["localtableincontextmut",["vec"]]]],[11,"cast_kinds","","",680,[[["self"]],["localtableincontext",["castkind"]]]],[11,"cast_kinds_mut","","",680,[[["self"]],["localtableincontextmut",["castkind"]]]],[11,"hash_stable","","",680,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","rustc::ty::context","",1016,[[["ctxtinterners"]],["commontypes"]]],[11,"clone","rustc::ty","",677,[[["self"]],["tyctxt"]]],[11,"deref","","",677,N],[11,"global_tcx","","Get the global TyCtxt.",677,[[["self"]],["tyctxt"]]],[11,"alloc_generics","","",677,[[["self"],["generics"]],["generics"]]],[11,"alloc_steal_mir","","",677,[[["self"],["mir"]],["steal"]]],[11,"alloc_mir","","",677,[[["self"],["mir"]],["mir"]]],[11,"alloc_tables","","",677,[[["self"],["typecktables"]],["typecktables"]]],[11,"alloc_trait_def","","",677,[[["self"],["traitdef"]],["traitdef"]]],[11,"alloc_adt_def","","",677,[[["self"],["defid"],["adtkind"],["vec",["variantdef"]],["reproptions"]],["adtdef"]]],[11,"alloc_byte_array","","",677,N],[11,"alloc_const_slice","","",677,N],[11,"alloc_name_const_slice","","",677,N],[11,"intern_const_alloc","","",677,[[["self"],["allocation"]],["allocation"]]],[11,"allocate_bytes","","Allocates a byte or string literal for `mir::interpret`, read-only",677,N],[11,"intern_stability","","",677,[[["self"],["stability"]],["stability"]]],[11,"intern_layout","","",677,[[["self"],["layoutdetails"]],["layoutdetails"]]],[11,"layout_scalar_valid_range","","Returns a range of the start/end indices specified with the `rustc_layout_scalar_valid_range` attribute.",677,N],[11,"lift","","",677,[[["self"],["t"]],["option"]]],[11,"lift_to_global","","Like lift, but only tries in the global tcx.",677,[[["self"],["t"]],["option"]]],[11,"is_global","","Returns true if self is the same as self.global_tcx().",677,[[["self"]],["bool"]]],[11,"is_min_const_fn","","Returns true if this function must conform to `min_const_fn`",677,[[["self"],["defid"]],["bool"]]],[11,"create_and_enter","","Create a type context and call the closure with a `TyCtxt` reference to the context. The closure enforces that the type context and any interned value (types, substs, etc.) can only be used while `ty::tls` has a valid reference to the context, to allow formatting values that need it.",677,[[["session"],["cratestoredyn"],["providers"],["providers"],["allarenas"],["resolutions"],["map"],["ondiskcache"],["str"],["sender",["box"]],["outputfilenames"],["f"]],["r"]]],[11,"consider_optimizing","","",677,[[["self"],["t"]],["bool"]]],[11,"lib_features","","",677,[[["self"]],["lrc",["libfeatures"]]]],[11,"lang_items","","",677,[[["self"]],["lrc",["languageitems"]]]],[11,"is_binop_lang_item","","Due to missing llvm support for lowering 128 bit math to software emulation (on some targets), the lowering can be done in MIR.",677,[[["self"],["defid"]],["option"]]],[11,"stability","","",677,[[["self"]],["lrc",["index"]]]],[11,"crates","","",677,[[["self"]],["lrc",["vec"]]]],[11,"features","","",677,[[["self"]],["lrc",["features"]]]],[11,"def_key","","",677,[[["self"],["defid"]],["defkey"]]],[11,"def_path","","Convert a `DefId` into its fully expanded `DefPath` (every `DefId` is really just an interned def-path).",677,[[["self"],["defid"]],["defpath"]]],[11,"def_path_hash","","",677,[[["self"],["defid"]],["defpathhash"]]],[11,"def_path_debug_str","","",677,[[["self"],["defid"]],["string"]]],[11,"metadata_encoding_version","","",677,[[["self"]],["vec",["u8"]]]],[11,"crate_data_as_rc_any","","",677,[[["self"],["cratenum"]],["lrc",["any"]]]],[11,"create_stable_hashing_context","","",677,[[["self"]],["stablehashingcontext"]]],[11,"allocate_metadata_dep_nodes","","",677,[[["self"]]]],[11,"precompute_in_scope_traits_hashes","","",677,[[["self"]]]],[11,"serialize_query_result_cache","","",677,[[["self"],["e"]],["result"]]],[11,"check_for_mutation_in_guard_via_ast_walk","","If true, we should use a naive AST walk to determine if match guard could perform bad mutations (or mutable-borrows).",677,[[["self"]],["bool"]]],[11,"use_ast_borrowck","","If true, we should use the AST-based borrowck (we may also use the MIR-based borrowck).",677,[[["self"]],["bool"]]],[11,"use_mir_borrowck","","If true, we should use the MIR-based borrowck (we may also use the AST-based borrowck).",677,[[["self"]],["bool"]]],[11,"migrate_borrowck","","If true, we should use the MIR-based borrow check, but also fall back on the AST borrow check if the MIR-based one errors.",677,[[["self"]],["bool"]]],[11,"generate_borrow_of_any_match_input","","If true, make MIR codegen for `match` emit a temp that holds a borrow of the input to the match expression.",677,[[["self"]],["bool"]]],[11,"emit_read_for_match","","If true, make MIR codegen for `match` emit ReadForMatch statements (which simulate the maximal effect of executing the patterns in a match arm).",677,[[["self"]],["bool"]]],[11,"all_pat_vars_are_implicit_refs_within_guards","","If true, pattern variables for use in guards on match arms will be bound as references to the data, and occurrences of those variables in the guard expression will implicitly dereference those bindings. (See rust-lang/rust#27282.)",677,[[["self"]],["bool"]]],[11,"two_phase_borrows","","If true, we should enable two-phase borrows checks. This is done with either: `-Ztwo-phase-borrows`, `#![feature(nll)]`, or by opting into an edition after 2015.",677,[[["self"]],["bool"]]],[11,"borrowck_mode","","What mode(s) of borrowck should we run? AST? MIR? both? (Also considers the `#![feature(nll)]` setting.)",677,[[["self"]],["borrowckmode"]]],[11,"emit_end_regions","","Should we emit EndRegion MIR statements? These are consumed by MIR borrowck, but not when NLL is used. They are also consumed by the validation stuff.",677,[[["self"]],["bool"]]],[11,"local_crate_exports_generics","","",677,[[["self"]],["bool"]]],[11,"encode_metadata","","",677,[[["self"]],["encodedmetadata"]]],[11,"enter_local","rustc::ty::context","Call the closure with a local `TyCtxt` using the given arena.",1019,[[["self"],["syncdroplessarena"],["f"]],["r"]]],[11,"print_debug_stats","rustc::ty","",677,[[["self"]]]],[11,"eq","rustc::ty::context","",1020,[[["self"],["interned"]],["bool"]]],[11,"hash","","",1020,[[["self"],["h"]]]],[11,"borrow","","",1020,[[["self"]],["tykind"]]],[11,"eq","","",1020,[[["self"],["interned"]],["bool"]]],[11,"hash","","",1020,[[["self"],["h"]]]],[11,"borrow","","",1020,N],[11,"borrow","","",1020,N],[11,"borrow","","",1020,N],[11,"borrow","","",1020,[[["self"]],["regionkind"]]],[11,"borrow","","",1020,N],[11,"borrow","","",1020,N],[11,"borrow","","",1020,[[["self"]],["const"]]],[11,"borrow","","",1020,N],[11,"borrow","","",1020,N],[11,"eq","","",1020,[[["self"],["self"]],["bool"]]],[11,"hash","","",1020,[[["self"],["h"]]]],[11,"mk_region","rustc::ty","",677,[[["self"],["regionkind"]],["regionkind"]]],[11,"eq","rustc::ty::context","",1020,[[["self"],["self"]],["bool"]]],[11,"hash","","",1020,[[["self"],["h"]]]],[11,"mk_const","rustc::ty","",677,[[["self"],["const"]],["const"]]],[11,"_intern_existential_predicates","","",677,N],[11,"_intern_predicates","","",677,N],[11,"_intern_type_list","","",677,N],[11,"_intern_substs","","",677,N],[11,"_intern_clauses","","",677,N],[11,"_intern_goals","","",677,N],[11,"_intern_canonical_var_infos","","",677,N],[11,"safe_to_unsafe_fn_ty","","Given a `fn` type, returns an equivalent `unsafe fn` type; that is, a `fn` type that is equivalent in every way for being unsafe.",677,[[["self"],["polyfnsig"]],["ty"]]],[11,"coerce_closure_fn_ty","","Given a closure signature `sig`, returns an equivalent `fn` type with the same signature. Detuples and so forth -- so e.g. if we have a sig with `Fn<(u32, i32)>` then you would get a `fn(u32, i32)`.",677,[[["self"],["polyfnsig"]],["ty"]]],[11,"mk_ty","","",677,[[["self"],["tykind"]],["ty"]]],[11,"mk_mach_int","","",677,[[["self"],["intty"]],["ty"]]],[11,"mk_mach_uint","","",677,[[["self"],["uintty"]],["ty"]]],[11,"mk_mach_float","","",677,[[["self"],["floatty"]],["ty"]]],[11,"mk_str","","",677,[[["self"]],["ty"]]],[11,"mk_static_str","","",677,[[["self"]],["ty"]]],[11,"mk_adt","","",677,[[["self"],["adtdef"],["substs"]],["ty"]]],[11,"mk_foreign","","",677,[[["self"],["defid"]],["ty"]]],[11,"mk_box","","",677,[[["self"],["ty"]],["ty"]]],[11,"mk_ptr","","",677,[[["self"],["typeandmut"]],["ty"]]],[11,"mk_ref","","",677,[[["self"],["region"],["typeandmut"]],["ty"]]],[11,"mk_mut_ref","","",677,[[["self"],["region"],["ty"]],["ty"]]],[11,"mk_imm_ref","","",677,[[["self"],["region"],["ty"]],["ty"]]],[11,"mk_mut_ptr","","",677,[[["self"],["ty"]],["ty"]]],[11,"mk_imm_ptr","","",677,[[["self"],["ty"]],["ty"]]],[11,"mk_nil_ptr","","",677,[[["self"]],["ty"]]],[11,"mk_array","","",677,[[["self"],["ty"],["u64"]],["ty"]]],[11,"mk_slice","","",677,[[["self"],["ty"]],["ty"]]],[11,"intern_tup","","",677,N],[11,"mk_tup","","",677,N],[11,"mk_unit","","",677,[[["self"]],["ty"]]],[11,"mk_diverging_default","","",677,[[["self"]],["ty"]]],[11,"mk_bool","","",677,[[["self"]],["ty"]]],[11,"mk_fn_def","","",677,[[["self"],["defid"],["substs"]],["ty"]]],[11,"mk_fn_ptr","","",677,[[["self"],["polyfnsig"]],["ty"]]],[11,"mk_dynamic","","",677,[[["self"],["binder",["list"]],["region"]],["ty"]]],[11,"mk_projection","","",677,[[["self"],["defid"],["substs"]],["ty"]]],[11,"mk_closure","","",677,[[["self"],["defid"],["closuresubsts"]],["ty"]]],[11,"mk_generator","","",677,[[["self"],["defid"],["generatorsubsts"],["generatormovability"]],["ty"]]],[11,"mk_generator_witness","","",677,[[["self"],["binder",["list"]]],["ty"]]],[11,"mk_var","","",677,[[["self"],["tyvid"]],["ty"]]],[11,"mk_int_var","","",677,[[["self"],["intvid"]],["ty"]]],[11,"mk_float_var","","",677,[[["self"],["floatvid"]],["ty"]]],[11,"mk_infer","","",677,[[["self"],["inferty"]],["ty"]]],[11,"mk_ty_param","","",677,[[["self"],["u32"],["internedstring"]],["ty"]]],[11,"mk_self_type","","",677,[[["self"]],["ty"]]],[11,"mk_param_from_def","","",677,[[["self"],["genericparamdef"]],["kind"]]],[11,"mk_opaque","","",677,[[["self"],["defid"],["substs"]],["ty"]]],[11,"intern_existential_predicates","","",677,N],[11,"intern_predicates","","",677,N],[11,"intern_type_list","","",677,N],[11,"intern_substs","","",677,N],[11,"intern_canonical_var_infos","","",677,N],[11,"intern_clauses","","",677,N],[11,"intern_goals","","",677,N],[11,"mk_fn_sig","","",677,N],[11,"mk_existential_predicates","","",677,N],[11,"mk_predicates","","",677,N],[11,"mk_type_list","","",677,N],[11,"mk_substs","","",677,N],[11,"mk_substs_trait","","",677,N],[11,"mk_clauses","","",677,N],[11,"mk_goals","","",677,N],[11,"mk_goal","","",677,[[["self"],["goal"]],["goal"]]],[11,"lint_hir","","",677,[[["self"],["lint"],["hirid"],["s"],["str"]]]],[11,"lint_node","","",677,[[["self"],["lint"],["nodeid"],["s"],["str"]]]],[11,"lint_hir_note","","",677,[[["self"],["lint"],["hirid"],["s"],["str"],["str"]]]],[11,"lint_node_note","","",677,[[["self"],["lint"],["nodeid"],["s"],["str"],["str"]]]],[11,"lint_level_at_node","","",677,N],[11,"struct_span_lint_hir","","",677,[[["self"],["lint"],["hirid"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_lint_node","","",677,[[["self"],["lint"],["nodeid"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_lint_node","","",677,[[["self"],["lint"],["nodeid"],["str"]],["diagnosticbuilder"]]],[11,"in_scope_traits","","",677,[[["self"],["hirid"]],["option",["lrc"]]]],[11,"named_region","","",677,[[["self"],["hirid"]],["option",["region"]]]],[11,"is_late_bound","","",677,[[["self"],["hirid"]],["bool"]]],[11,"object_lifetime_defaults","","",677,[[["self"],["hirid"]],["option",["lrc"]]]],[0,"flags","","",N,N],[3,"FlagComputation","rustc::ty::flags","",N,N],[12,"flags","","",1024,N],[12,"outer_exclusive_binder","","",1024,N],[11,"fmt","","",1024,[[["self"],["formatter"]],["result"]]],[11,"new","","",1024,[[],["flagcomputation"]]],[11,"for_sty","","",1024,[[["tykind"]],["flagcomputation"]]],[11,"add_flags","","",1024,[[["self"],["typeflags"]]]],[11,"add_binder","","indicates that `self` refers to something at binding level `binder`",1024,[[["self"],["debruijnindex"]]]],[11,"add_exclusive_binder","","indicates that `self` refers to something inside binding level `binder` -- not bound by `binder`, but bound by the next binder internal to it",1024,[[["self"],["debruijnindex"]]]],[11,"add_bound_computation","","Adds the flags/depth from a set of types that appear within the current type, but within a region binder.",1024,[[["self"],["flagcomputation"]]]],[11,"add_sty","","",1024,[[["self"],["tykind"]]]],[11,"add_ty","","",1024,[[["self"],["ty"]]]],[11,"add_tys","","",1024,N],[11,"add_fn_sig","","",1024,[[["self"],["polyfnsig"]]]],[11,"add_region","","",1024,[[["self"],["region"]]]],[11,"add_const","","",1024,[[["self"],["const"]]]],[11,"add_existential_projection","","",1024,[[["self"],["existentialprojection"]]]],[11,"add_projection_ty","","",1024,[[["self"],["projectionty"]]]],[11,"add_substs","","",1024,[[["self"],["substs"]]]],[0,"instance","rustc::ty","",N,N],[3,"Instance","rustc::ty::instance","",N,N],[12,"def","","",681,N],[12,"substs","","",681,N],[4,"InstanceDef","","",N,N],[13,"Item","","",724,N],[13,"Intrinsic","","",724,N],[13,"FnPtrShim","","<fn() as FnTrait>::call_* def-id is FnTrait::call_*",724,N],[13,"Virtual","","::fn",724,N],[13,"ClosureOnceShim","","<[mut closure] as FnOnce>::call_once",724,N],[12,"call_once","rustc::ty::instance::InstanceDef","",724,N],[13,"DropGlue","rustc::ty::instance","drop_in_place::; None for empty drop glue.",724,N],[13,"CloneShim","","`<T as Clone>::clone` shim.",724,N],[5,"resolve_associated_item","","",N,[[["tyctxt"],["associateditem"],["paramenv"],["defid"],["substs"]],["option",["instance"]]]],[5,"needs_fn_once_adapter_shim","","",N,[[["closurekind"],["closurekind"]],["result",["bool"]]]],[5,"fn_once_adapter_instance","","",N,[[["tyctxt"],["defid"],["closuresubsts"]],["instance"]]],[11,"clone","rustc::ty","",681,[[["self"]],["instance"]]],[11,"eq","","",681,[[["self"],["instance"]],["bool"]]],[11,"ne","","",681,[[["self"],["instance"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",681,N],[11,"hash","","",681,N],[11,"fmt","","",681,[[["self"],["formatter"]],["result"]]],[11,"encode","","",681,[[["self"],["__s"]],["result"]]],[11,"decode","","",681,[[["__d"]],["result",["instance"]]]],[11,"clone","","",724,[[["self"]],["instancedef"]]],[11,"eq","","",724,[[["self"],["instancedef"]],["bool"]]],[11,"ne","","",724,[[["self"],["instancedef"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",724,N],[11,"hash","","",724,N],[11,"fmt","","",724,[[["self"],["formatter"]],["result"]]],[11,"encode","","",724,[[["self"],["__s"]],["result"]]],[11,"decode","","",724,[[["__d"]],["result",["instancedef"]]]],[11,"ty","","",681,[[["self"],["tyctxt"]],["ty"]]],[11,"def_id","","",724,[[["self"]],["defid"]]],[11,"attrs","","",724,[[["self"],["tyctxt"]],["attributes"]]],[11,"is_inline","","",724,[[["self"],["tyctxt"]],["bool"]]],[11,"requires_local","","",724,[[["self"],["tyctxt"]],["bool"]]],[11,"fmt","","",681,[[["self"],["formatter"]],["result"]]],[11,"new","","",681,[[["defid"],["substs"]],["instance"]]],[11,"mono","","",681,[[["tyctxt"],["defid"]],["instance"]]],[11,"def_id","","",681,[[["self"]],["defid"]]],[11,"resolve","","Resolve a (def_id, substs) pair to an (optional) instance -- most commonly, this is used to find the precise code that will run for a trait method invocation, if known.",681,[[["tyctxt"],["paramenv"],["defid"],["substs"]],["option",["instance"]]]],[11,"resolve_closure","","",681,[[["tyctxt"],["defid"],["closuresubsts"],["closurekind"]],["instance"]]],[0,"structural_impls","","This module contains implements of the `Lift` and `TypeFoldable` traits for various types in the Rust compiler. Most are written by hand, though we've recently added some macros (e.g., `BraceStructLiftImpl!`) to help with the tedium.",N,N],[11,"super_fold_with","rustc::middle::region","",392,[[["self"],["f"]],["scope"]]],[11,"super_visit_with","","",392,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::ty::layout","",788,[[["self"],["f"]],["floatty"]]],[11,"super_visit_with","","",788,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::hir::def","",146,[[["self"],["f"]],["def"]]],[11,"super_visit_with","","",146,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::hir::def_id","",150,[[["self"],["f"]],["defid"]]],[11,"super_visit_with","","",150,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::hir","",71,[[["self"],["f"]],["inlineasm"]]],[11,"super_visit_with","","",71,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",115,[[["self"],["f"]],["matchsource"]]],[11,"super_visit_with","","",115,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",103,[[["self"],["f"]],["mutability"]]],[11,"super_visit_with","","",103,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",127,[[["self"],["f"]],["unsafety"]]],[11,"super_visit_with","","",127,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::mir","",423,[[["self"],["f"]],["local"]]],[11,"super_visit_with","","",423,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",439,[[["self"],["f"]],["promoted"]]],[11,"super_visit_with","","",439,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::traits","",578,[[["self"],["f"]],["reveal"]]],[11,"super_visit_with","","",578,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::ty::adjustment","",744,[[["self"],["f"]],["autoborrowmutability"]]],[11,"super_visit_with","","",744,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","rustc::ty","",735,[[["self"],["f"]],["adtkind"]]],[11,"super_visit_with","","",735,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",722,[[["self"],["f"]],["boundregion"]]],[11,"super_visit_with","","",722,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",736,[[["self"],["f"]],["closurekind"]]],[11,"super_visit_with","","",736,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",731,[[["self"],["f"]],["intvarvalue"]]],[11,"super_visit_with","","",731,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",662,[[["self"],["f"]],["paramty"]]],[11,"super_visit_with","","",662,[[["self"],["f"]],["bool"]]],[11,"super_fold_with","","",728,[[["self"],["f"]],["variance"]]],[11,"super_visit_with","","",728,[[["self"],["f"]],["bool"]]],[11,"lift_to_tcx","rustc::middle::region","",392,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty::layout","",788,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::hir::def","",146,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::hir::def_id","",150,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::hir","",71,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",115,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",103,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",127,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::mir","",423,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",439,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::traits","",578,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty::adjustment","",744,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty","",735,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",722,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",736,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",731,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",662,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",728,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",667,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",668,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",700,[[["self"],["tyctxt"]],["option",["traitpredicate"]]]],[11,"lift_to_tcx","","",702,[[["self"],["tyctxt"]],["option",["subtypepredicate"]]]],[11,"lift_to_tcx","","",701,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",663,[[["self"],["tyctxt"]],["option",["projectionty"]]]],[11,"lift_to_tcx","","",703,[[["self"],["tyctxt"]],["option",["projectionpredicate"]]]],[11,"lift_to_tcx","","",669,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",733,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",657,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",706,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",707,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",664,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",665,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty::adjustment","",739,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",742,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",740,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",745,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty","",661,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",660,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty::error","",754,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",755,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::mir::interpret","",469,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",468,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",481,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty::layout","",800,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","rustc::ty","",724,[[["self"],["tyctxt"]],["option"]]],[11,"lift_to_tcx","","",681,[[["self"],["tyctxt"]],["option",["instance"]]]],[11,"lift_to_tcx","rustc::mir::interpret","",472,[[["self"],["tyctxt"]],["option",["globalid"]]]],[11,"super_fold_with","rustc::ty","",657,[[["self"],["f"]],["self"]]],[11,"fold_with","","",657,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",657,[[["self"],["v"]],["bool"]]],[11,"visit_with","","",657,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",706,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",706,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",719,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",719,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",681,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",681,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::mir::interpret","",472,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",472,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::ty","",666,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",666,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",661,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",661,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",660,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",660,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",667,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",667,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",668,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",668,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",684,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",684,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",664,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",664,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",665,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",665,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::ty::adjustment","",739,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",739,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",742,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",742,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",740,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",740,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",745,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",745,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::ty","",698,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",698,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",733,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",733,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",703,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",703,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",669,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",669,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",663,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",663,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",704,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",704,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",707,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",707,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",702,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",702,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",700,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",700,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",701,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",701,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",693,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",693,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::ty::error","",754,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",754,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","","",755,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",755,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::mir::interpret","",483,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",483,[[["self"],["v"]],["bool"]]],[0,"sty","rustc::ty","This module contains TyKind and its major components",N,N],[3,"TypeAndMut","rustc::ty::sty","",N,N],[12,"ty","","",666,N],[12,"mutbl","","",666,N],[3,"FreeRegion","","A \"free\" region `fr` can be interpreted as \"some region at least as big as the scope `fr.scope`\".",N,N],[12,"scope","","",672,N],[12,"bound_region","","",672,N],[3,"ClosureSubsts","","A closure can be modeled as a struct that looks like:",N,N],[12,"substs","","Lifetime and type parameters from the enclosing function, concatenated with the types of the upvars.",664,N],[3,"SplitClosureSubsts","","Struct returned by `split()`. Note that these are subslices of the parent slice and not canonical substs themselves.",N,N],[12,"closure_kind_ty","","",1025,N],[12,"closure_sig_ty","","",1025,N],[12,"upvar_kinds","","",1025,N],[3,"GeneratorSubsts","","",N,N],[12,"substs","","",665,N],[3,"SplitGeneratorSubsts","","",N,N],[12,"yield_ty","","",1026,N],[12,"return_ty","","",1026,N],[12,"witness","","",1026,N],[12,"upvar_kinds","","",1026,N],[3,"TraitRef","","A complete reference to a trait. These take numerous guises in syntax, but perhaps the most recognizable form is in a where clause:",N,N],[12,"def_id","","",667,N],[12,"substs","","",667,N],[3,"ExistentialTraitRef","","An existential reference to a trait, where `Self` is erased. For example, the trait object `Trait<'a, 'b, X, Y>` is:",N,N],[12,"def_id","","",668,N],[12,"substs","","",668,N],[3,"Binder","","Binder is a binder for higher-ranked lifetimes. It is part of the compiler's representation for things like `for<'a> Fn(&'a isize)` (which would be represented by the type `PolyTraitRef == Binder<TraitRef>`). Note that when we skolemize, instantiate, erase, or otherwise \"discharge\" these bound regions, we change the type from `Binder<T>` to just `T` (see e.g. `liberate_late_bound_regions`).",N,N],[12,"0","","",657,N],[3,"ProjectionTy","","Represents the projection of an associated type. In explicit UFCS form this would be written `<T as Trait<..>>::N`.",N,N],[12,"substs","","The parameters of the associated item.",663,N],[12,"item_def_id","","The DefId of the TraitItem for the associated type N.",663,N],[3,"GenSig","","",N,N],[12,"yield_ty","","",661,N],[12,"return_ty","","",661,N],[3,"FnSig","","Signature of a function type, which I have arbitrarily decided to use to refer to the input/output types.",N,N],[12,"inputs_and_output","","",660,N],[12,"variadic","","",660,N],[12,"unsafety","","",660,N],[12,"abi","","",660,N],[3,"ParamTy","","",N,N],[12,"idx","","",662,N],[12,"name","","",662,N],[3,"DebruijnIndex","","",N,N],[12,"private","","",659,N],[3,"EarlyBoundRegion","","",N,N],[12,"def_id","","",671,N],[12,"index","","",671,N],[12,"name","","",671,N],[3,"TyVid","","",N,N],[12,"index","","",673,N],[3,"IntVid","","",N,N],[12,"index","","",674,N],[3,"FloatVid","","",N,N],[12,"index","","",675,N],[3,"RegionVid","","",N,N],[12,"private","","",676,N],[3,"CanonicalVar","","",N,N],[12,"private","","",658,N],[3,"ExistentialProjection","","A `ProjectionPredicate` for an `ExistentialTraitRef`.",N,N],[12,"item_def_id","","",669,N],[12,"substs","","",669,N],[12,"ty","","",669,N],[3,"Const","","Typed constant value.",N,N],[12,"ty","","",670,N],[12,"val","","",670,N],[4,"BoundRegion","","",N,N],[13,"BrAnon","","An anonymous region parameter for a given fn (&T)",722,N],[13,"BrNamed","","Named region parameters for functions (a in &'a T)",722,N],[13,"BrFresh","","Fresh bound identifiers created during GLB computations.",722,N],[13,"BrEnv","","Anonymous region for the implicit env pointer parameter to a closure",722,N],[4,"TyKind","","NB: If you change this, you'll probably want to change the corresponding AST structure in libsyntax/ast.rs as well.",N,N],[13,"Bool","","The primitive boolean type. Written as `bool`.",721,N],[13,"Char","","The primitive character type; holds a Unicode scalar value (a non-surrogate code point).  Written as `char`.",721,N],[13,"Int","","A primitive signed integer type. For example, `i32`.",721,N],[13,"Uint","","A primitive unsigned integer type. For example, `u32`.",721,N],[13,"Float","","A primitive floating-point type. For example, `f64`.",721,N],[13,"Adt","","Structures, enumerations and unions.",721,N],[13,"Foreign","","",721,N],[13,"Str","","The pointee of a string slice. Written as `str`.",721,N],[13,"Array","","An array with the given length. Written as `[T; n]`.",721,N],[13,"Slice","","The pointee of an array slice.  Written as `[T]`.",721,N],[13,"RawPtr","","A raw pointer. Written as `*mut T` or `*const T`",721,N],[13,"Ref","","A reference; a pointer with an associated lifetime. Written as `&'a mut T` or `&'a T`.",721,N],[13,"FnDef","","The anonymous type of a function declaration/definition. Each function has a unique type.",721,N],[13,"FnPtr","","A pointer to a function.  Written as `fn() -> i32`.",721,N],[13,"Dynamic","","A trait, defined with `trait`.",721,N],[13,"Closure","","The anonymous type of a closure. Used to represent the type of `|a| a`.",721,N],[13,"Generator","","The anonymous type of a generator. Used to represent the type of `|a| yield a`.",721,N],[13,"GeneratorWitness","","A type representin the types stored inside a generator. This should only appear in GeneratorInteriors.",721,N],[13,"Never","","The never type `!`",721,N],[13,"Tuple","","A tuple type.  For example, `(i32, bool)`.",721,N],[13,"Projection","","The projection of an associated type.  For example, `<T as Trait<..>>::N`.",721,N],[13,"Opaque","","Opaque (`impl Trait`) type found in a return type. The DefId comes either from * the `impl Trait` ast::Ty node, * or the `existential type` declaration The substitutions are for the generics of the function in question. After typeck, the concrete type can be found in the `types` map.",721,N],[13,"Param","","A type parameter; for example, `T` in `fn f(x: T) {}",721,N],[13,"Infer","","A type variable used during type-checking.",721,N],[13,"Error","","A placeholder for a type which could not be computed; this is propagated to avoid useless error messages.",721,N],[4,"UpvarSubsts","","",N,N],[13,"Closure","","",720,N],[13,"Generator","","",720,N],[4,"ExistentialPredicate","","",N,N],[13,"Trait","","e.g. Iterator",719,N],[13,"Projection","","e.g. Iterator::Item = T",719,N],[13,"AutoTrait","","e.g. Send",719,N],[4,"RegionKind","","Representation of regions.",N,N],[13,"ReEarlyBound","","",723,N],[13,"ReLateBound","","",723,N],[13,"ReFree","","When checking a function body, the types of all arguments and so forth that refer to bound region parameters are modified to refer to free region parameters.",723,N],[13,"ReScope","","A concrete region naming some statically determined scope (e.g. an expression or sequence of statements) within the current function.",723,N],[13,"ReStatic","","Static data that has an \"infinite\" lifetime. Top in the region lattice.",723,N],[13,"ReVar","","A region variable.  Should not exist after typeck.",723,N],[13,"ReSkolemized","","A skolemized region - basically the higher-ranked version of ReFree. Should not exist after typeck.",723,N],[13,"ReEmpty","","Empty lifetime is for data that is never accessed. Bottom in the region lattice. We treat ReEmpty somewhat specially; at least right now, we do not generate instances of it during the GLB computations, but rather generate an error instead. This is to improve error messages. The only way to get an instance of ReEmpty is to have a region variable with no constraints.",723,N],[13,"ReErased","","Erased region, used by trait selection, in MIR and during codegen.",723,N],[13,"ReClosureBound","","These are regions bound in the \"defining type\" for a closure. They are used ONLY as part of the `ClosureRegionRequirements` that are produced by MIR borrowck. See `ClosureRegionRequirements` for more details.",723,N],[13,"ReCanonical","","Canonicalized region, used only when preparing a trait query.",723,N],[4,"InferTy","","",N,N],[13,"TyVar","","",718,N],[13,"IntVar","","",718,N],[13,"FloatVar","","",718,N],[13,"FreshTy","","A `FreshTy` is one that is generated as a replacement for an unbound type variable. This is convenient for caching etc. See `infer::freshen` for more details.",718,N],[13,"FreshIntTy","","",718,N],[13,"FreshFloatTy","","",718,N],[13,"CanonicalTy","","Canonicalized type variable, used only when preparing a trait query.",718,N],[6,"PolyTraitRef","","",N,N],[6,"PolyExistentialTraitRef","","",N,N],[6,"PolyGenSig","","",N,N],[6,"PolyFnSig","","",N,N],[6,"Region","","",N,N],[6,"PolyExistentialProjection","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"INNERMOST","","",N,N],[11,"clone","rustc::ty","",666,[[["self"]],["typeandmut"]]],[11,"eq","","",666,[[["self"],["typeandmut"]],["bool"]]],[11,"ne","","",666,[[["self"],["typeandmut"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",666,N],[11,"partial_cmp","","",666,[[["self"],["typeandmut"]],["option",["ordering"]]]],[11,"lt","","",666,[[["self"],["typeandmut"]],["bool"]]],[11,"le","","",666,[[["self"],["typeandmut"]],["bool"]]],[11,"gt","","",666,[[["self"],["typeandmut"]],["bool"]]],[11,"ge","","",666,[[["self"],["typeandmut"]],["bool"]]],[11,"cmp","","",666,[[["self"],["typeandmut"]],["ordering"]]],[11,"hash","","",666,N],[11,"fmt","","",666,[[["self"],["formatter"]],["result"]]],[11,"encode","","",666,[[["self"],["__s"]],["result"]]],[11,"decode","","",666,[[["__d"]],["result",["typeandmut"]]]],[11,"clone","","",672,[[["self"]],["freeregion"]]],[11,"eq","","",672,[[["self"],["freeregion"]],["bool"]]],[11,"ne","","",672,[[["self"],["freeregion"]],["bool"]]],[11,"partial_cmp","","",672,[[["self"],["freeregion"]],["option",["ordering"]]]],[11,"lt","","",672,[[["self"],["freeregion"]],["bool"]]],[11,"le","","",672,[[["self"],["freeregion"]],["bool"]]],[11,"gt","","",672,[[["self"],["freeregion"]],["bool"]]],[11,"ge","","",672,[[["self"],["freeregion"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",672,N],[11,"cmp","","",672,[[["self"],["freeregion"]],["ordering"]]],[11,"hash","","",672,N],[11,"encode","","",672,[[["self"],["__s"]],["result"]]],[11,"decode","","",672,[[["__d"]],["result",["freeregion"]]]],[11,"clone","","",722,[[["self"]],["boundregion"]]],[11,"eq","","",722,[[["self"],["boundregion"]],["bool"]]],[11,"ne","","",722,[[["self"],["boundregion"]],["bool"]]],[11,"partial_cmp","","",722,[[["self"],["boundregion"]],["option",["ordering"]]]],[11,"lt","","",722,[[["self"],["boundregion"]],["bool"]]],[11,"le","","",722,[[["self"],["boundregion"]],["bool"]]],[11,"gt","","",722,[[["self"],["boundregion"]],["bool"]]],[11,"ge","","",722,[[["self"],["boundregion"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",722,N],[11,"cmp","","",722,[[["self"],["boundregion"]],["ordering"]]],[11,"hash","","",722,N],[11,"encode","","",722,[[["self"],["__s"]],["result"]]],[11,"decode","","",722,[[["__d"]],["result",["boundregion"]]]],[11,"is_named","","",722,[[["self"]],["bool"]]],[11,"clone","","",721,[[["self"]],["tykind"]]],[11,"eq","","",721,[[["self"],["tykind"]],["bool"]]],[11,"ne","","",721,[[["self"],["tykind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",721,N],[11,"partial_cmp","","",721,[[["self"],["tykind"]],["option",["ordering"]]]],[11,"lt","","",721,[[["self"],["tykind"]],["bool"]]],[11,"le","","",721,[[["self"],["tykind"]],["bool"]]],[11,"gt","","",721,[[["self"],["tykind"]],["bool"]]],[11,"ge","","",721,[[["self"],["tykind"]],["bool"]]],[11,"cmp","","",721,[[["self"],["tykind"]],["ordering"]]],[11,"hash","","",721,N],[11,"fmt","","",721,[[["self"],["formatter"]],["result"]]],[11,"encode","","",721,[[["self"],["__s"]],["result"]]],[11,"decode","","",721,[[["__d"]],["result",["tykind"]]]],[11,"clone","","",664,[[["self"]],["closuresubsts"]]],[11,"eq","","",664,[[["self"],["closuresubsts"]],["bool"]]],[11,"ne","","",664,[[["self"],["closuresubsts"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",664,N],[11,"partial_cmp","","",664,[[["self"],["closuresubsts"]],["option",["ordering"]]]],[11,"lt","","",664,[[["self"],["closuresubsts"]],["bool"]]],[11,"le","","",664,[[["self"],["closuresubsts"]],["bool"]]],[11,"gt","","",664,[[["self"],["closuresubsts"]],["bool"]]],[11,"ge","","",664,[[["self"],["closuresubsts"]],["bool"]]],[11,"cmp","","",664,[[["self"],["closuresubsts"]],["ordering"]]],[11,"hash","","",664,N],[11,"fmt","","",664,[[["self"],["formatter"]],["result"]]],[11,"encode","","",664,[[["self"],["__s"]],["result"]]],[11,"decode","","",664,[[["__d"]],["result",["closuresubsts"]]]],[11,"split","","Divides the closure substs into their respective components. Single source of truth with respect to the ordering.",664,[[["self"],["defid"],["tyctxt"]],["splitclosuresubsts"]]],[11,"upvar_tys","","",664,N],[11,"closure_kind_ty","","Returns the closure kind for this closure; may return a type variable during inference. To get the closure kind during inference, use `infcx.closure_kind(def_id, substs)`.",664,[[["self"],["defid"],["tyctxt"]],["ty"]]],[11,"closure_sig_ty","","Returns the type representing the closure signature for this closure; may contain type variables during inference. To get the closure signature during inference, use `infcx.fn_sig(def_id)`.",664,[[["self"],["defid"],["tyctxt"]],["ty"]]],[11,"closure_kind","","Returns the closure kind for this closure; only usable outside of an inference context, because in that context we know that there are no type variables.",664,[[["self"],["defid"],["tyctxt"]],["closurekind"]]],[11,"closure_sig","","Extracts the signature from the closure; only usable outside of an inference context, because in that context we know that there are no type variables.",664,[[["self"],["defid"],["tyctxt"]],["polyfnsig"]]],[11,"clone","","",665,[[["self"]],["generatorsubsts"]]],[11,"eq","","",665,[[["self"],["generatorsubsts"]],["bool"]]],[11,"ne","","",665,[[["self"],["generatorsubsts"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",665,N],[11,"partial_cmp","","",665,[[["self"],["generatorsubsts"]],["option",["ordering"]]]],[11,"lt","","",665,[[["self"],["generatorsubsts"]],["bool"]]],[11,"le","","",665,[[["self"],["generatorsubsts"]],["bool"]]],[11,"gt","","",665,[[["self"],["generatorsubsts"]],["bool"]]],[11,"ge","","",665,[[["self"],["generatorsubsts"]],["bool"]]],[11,"cmp","","",665,[[["self"],["generatorsubsts"]],["ordering"]]],[11,"hash","","",665,N],[11,"fmt","","",665,[[["self"],["formatter"]],["result"]]],[11,"encode","","",665,[[["self"],["__s"]],["result"]]],[11,"decode","","",665,[[["__d"]],["result",["generatorsubsts"]]]],[11,"split","","",665,[[["self"],["defid"],["tyctxt"]],["splitgeneratorsubsts"]]],[11,"witness","","This describes the types that can be contained in a generator. It will be a type variable initially and unified in the last stages of typeck of a body. It contains a tuple of all the types that could end up on a generator frame. The state transformation MIR pass may only produce layouts which mention types in this tuple. Upvars are not counted here.",665,[[["self"],["defid"],["tyctxt"]],["ty"]]],[11,"upvar_tys","","",665,N],[11,"yield_ty","","Returns the type representing the yield type of the generator.",665,[[["self"],["defid"],["tyctxt"]],["ty"]]],[11,"return_ty","","Returns the type representing the return type of the generator.",665,[[["self"],["defid"],["tyctxt"]],["ty"]]],[11,"poly_sig","","Return the \"generator signature\", which consists of its yield and return types.",665,[[["self"],["defid"],["tyctxt"]],["polygensig"]]],[11,"sig","","Return the \"generator signature\", which consists of its yield and return types.",665,[[["self"],["defid"],["tyctxt"]],["gensig"]]],[11,"state_tys","","This returns the types of the MIR locals which had to be stored across suspension points. It is calculated in rustc_mir::transform::generator::StateTransform. All the types here must be in the tuple in GeneratorInterior.",665,N],[11,"pre_transforms_tys","","This is the types of the fields of a generate which is available before the generator transformation. It includes the upvars and the state discriminant which is u32.",665,N],[11,"field_tys","","This is the types of all the fields stored in a generator. It includes the upvars, state types and the state discriminant which is u32.",665,N],[11,"fmt","","",720,[[["self"],["formatter"]],["result"]]],[11,"clone","","",720,[[["self"]],["upvarsubsts"]]],[11,"upvar_tys","","",720,N],[11,"fmt","","",719,[[["self"],["formatter"]],["result"]]],[11,"clone","","",719,[[["self"]],["existentialpredicate"]]],[11,"eq","","",719,[[["self"],["existentialpredicate"]],["bool"]]],[11,"ne","","",719,[[["self"],["existentialpredicate"]],["bool"]]],[11,"partial_cmp","","",719,[[["self"],["existentialpredicate"]],["option",["ordering"]]]],[11,"lt","","",719,[[["self"],["existentialpredicate"]],["bool"]]],[11,"le","","",719,[[["self"],["existentialpredicate"]],["bool"]]],[11,"gt","","",719,[[["self"],["existentialpredicate"]],["bool"]]],[11,"ge","","",719,[[["self"],["existentialpredicate"]],["bool"]]],[11,"cmp","","",719,[[["self"],["existentialpredicate"]],["ordering"]]],[11,"assert_receiver_is_total_eq","","",719,N],[11,"hash","","",719,N],[11,"encode","","",719,[[["self"],["__s"]],["result"]]],[11,"decode","","",719,[[["__d"]],["result",["existentialpredicate"]]]],[11,"stable_cmp","","Compares via an ordering that will not change if modules are reordered or other changes are made to the tree. In particular, this ordering is preserved across incremental compilations.",719,[[["self"],["tyctxt"],["self"]],["ordering"]]],[11,"with_self_ty","","",657,[[["self"],["tyctxt"],["ty"]],["predicate"]]],[11,"principal","","",690,[[["self"]],["option",["existentialtraitref"]]]],[11,"projection_bounds","","",690,N],[11,"auto_traits","","",690,N],[11,"principal","","",657,[[["self"]],["option",["polyexistentialtraitref"]]]],[11,"projection_bounds","","",657,N],[11,"auto_traits","","",657,N],[11,"iter","","",657,N],[11,"clone","","",667,[[["self"]],["traitref"]]],[11,"eq","","",667,[[["self"],["traitref"]],["bool"]]],[11,"ne","","",667,[[["self"],["traitref"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",667,N],[11,"hash","","",667,N],[11,"encode","","",667,[[["self"],["__s"]],["result"]]],[11,"decode","","",667,[[["__d"]],["result",["traitref"]]]],[11,"new","","",667,[[["defid"],["substs"]],["traitref"]]],[11,"identity","","Returns a TraitRef of the form `P0: Foo<P1..Pn>` where `Pi` are the parameters defined on trait.",667,[[["tyctxt"],["defid"]],["traitref"]]],[11,"self_ty","","",667,[[["self"]],["ty"]]],[11,"input_types","","",667,N],[11,"from_method","","",667,[[["tyctxt"],["defid"],["substs"]],["traitref"]]],[11,"self_ty","rustc::ty::sty","",1027,[[["self"]],["ty"]]],[11,"def_id","","",1027,[[["self"]],["defid"]]],[11,"to_poly_trait_predicate","","",1027,[[["self"]],["polytraitpredicate"]]],[11,"clone","rustc::ty","",668,[[["self"]],["existentialtraitref"]]],[11,"eq","","",668,[[["self"],["existentialtraitref"]],["bool"]]],[11,"ne","","",668,[[["self"],["existentialtraitref"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",668,N],[11,"partial_cmp","","",668,[[["self"],["existentialtraitref"]],["option",["ordering"]]]],[11,"lt","","",668,[[["self"],["existentialtraitref"]],["bool"]]],[11,"le","","",668,[[["self"],["existentialtraitref"]],["bool"]]],[11,"gt","","",668,[[["self"],["existentialtraitref"]],["bool"]]],[11,"ge","","",668,[[["self"],["existentialtraitref"]],["bool"]]],[11,"cmp","","",668,[[["self"],["existentialtraitref"]],["ordering"]]],[11,"hash","","",668,N],[11,"encode","","",668,[[["self"],["__s"]],["result"]]],[11,"decode","","",668,[[["__d"]],["result",["existentialtraitref"]]]],[11,"input_types","","",668,N],[11,"erase_self_ty","","",668,[[["tyctxt"],["traitref"]],["existentialtraitref"]]],[11,"with_self_ty","","Object types don't have a self-type specified. Therefore, when we convert the principal trait-ref into a normal trait-ref, you must give some self-type. A common choice is `mk_err()` or some skolemized type.",668,[[["self"],["tyctxt"],["ty"]],["traitref"]]],[11,"def_id","rustc::ty::sty","",1028,[[["self"]],["defid"]]],[11,"with_self_ty","","Object types don't have a self-type specified. Therefore, when we convert the principal trait-ref into a normal trait-ref, you must give some self-type. A common choice is `mk_err()` or some skolemized type.",1028,[[["self"],["tyctxt"],["ty"]],["polytraitref"]]],[11,"clone","rustc::ty","",657,[[["self"]],["binder"]]],[11,"eq","","",657,[[["self"],["binder"]],["bool"]]],[11,"ne","","",657,[[["self"],["binder"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",657,N],[11,"partial_cmp","","",657,[[["self"],["binder"]],["option",["ordering"]]]],[11,"lt","","",657,[[["self"],["binder"]],["bool"]]],[11,"le","","",657,[[["self"],["binder"]],["bool"]]],[11,"gt","","",657,[[["self"],["binder"]],["bool"]]],[11,"ge","","",657,[[["self"],["binder"]],["bool"]]],[11,"cmp","","",657,[[["self"],["binder"]],["ordering"]]],[11,"hash","","",657,N],[11,"fmt","","",657,[[["self"],["formatter"]],["result"]]],[11,"encode","","",657,[[["self"],["__st"]],["result"]]],[11,"decode","","",657,[[["__dt"]],["result",["binder"]]]],[11,"dummy","","Wraps `value` in a binder, asserting that `value` does not contain any bound regions that would be bound by the binder. This is commonly used to 'inject' a value T into a different binding level.",657,[[["t"]],["binder"]]],[11,"bind","","Wraps `value` in a binder, binding late-bound regions (if any).",657,[[["t"]],["binder"]]],[11,"skip_binder","","Skips the binder and returns the \"bound\" value. This is a risky thing to do because it's easy to get confused about debruijn indices and the like. It is usually better to discharge the binder using `no_late_bound_regions` or `replace_late_bound_regions` or something like that. `skip_binder` is only valid when you are either extracting data that has nothing to do with bound regions, you are doing some sort of test that does not involve bound regions, or you are being very careful about your depth accounting.",657,[[["self"]],["t"]]],[11,"as_ref","","",657,[[["self"]],["binder"]]],[11,"map_bound_ref","","",657,[[["self"],["f"]],["binder"]]],[11,"map_bound","","",657,[[["self"],["f"]],["binder"]]],[11,"no_late_bound_regions","","Unwraps and returns the value within, but only if it contains no bound regions at all. (In other words, if this binder -- and indeed any enclosing binder -- doesn't bind anything at all.) Otherwise, returns `None`.",657,[[["self"]],["option"]]],[11,"fuse","","Given two things that have the same binder level, and an operation that wraps on their contents, execute the operation and then wrap its result.",657,[[["self"],["binder"],["f"]],["binder"]]],[11,"split","","Split the contents into two things that share the same binder level as the original, returning two distinct binders.",657,N],[11,"clone","","",663,[[["self"]],["projectionty"]]],[11,"eq","","",663,[[["self"],["projectionty"]],["bool"]]],[11,"ne","","",663,[[["self"],["projectionty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",663,N],[11,"partial_cmp","","",663,[[["self"],["projectionty"]],["option",["ordering"]]]],[11,"lt","","",663,[[["self"],["projectionty"]],["bool"]]],[11,"le","","",663,[[["self"],["projectionty"]],["bool"]]],[11,"gt","","",663,[[["self"],["projectionty"]],["bool"]]],[11,"ge","","",663,[[["self"],["projectionty"]],["bool"]]],[11,"cmp","","",663,[[["self"],["projectionty"]],["ordering"]]],[11,"hash","","",663,N],[11,"fmt","","",663,[[["self"],["formatter"]],["result"]]],[11,"encode","","",663,[[["self"],["__s"]],["result"]]],[11,"decode","","",663,[[["__d"]],["result",["projectionty"]]]],[11,"from_ref_and_name","","Construct a ProjectionTy by searching the trait from trait_ref for the associated item named item_name.",663,[[["tyctxt"],["traitref"],["ident"]],["projectionty"]]],[11,"trait_ref","","Extracts the underlying trait reference from this projection. For example, if this is a projection of `<T as Iterator>::Item`, then this function would return a `T: Iterator` trait reference.",663,[[["self"],["tyctxt"]],["traitref"]]],[11,"self_ty","","",663,[[["self"]],["ty"]]],[11,"clone","","",661,[[["self"]],["gensig"]]],[11,"fmt","","",661,[[["self"],["formatter"]],["result"]]],[11,"eq","","",661,[[["self"],["gensig"]],["bool"]]],[11,"ne","","",661,[[["self"],["gensig"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",661,N],[11,"hash","","",661,N],[11,"encode","","",661,[[["self"],["__s"]],["result"]]],[11,"decode","","",661,[[["__d"]],["result",["gensig"]]]],[11,"yield_ty","rustc::ty::sty","",1029,[[["self"]],["binder",["ty"]]]],[11,"return_ty","","",1029,[[["self"]],["binder",["ty"]]]],[11,"clone","rustc::ty","",660,[[["self"]],["fnsig"]]],[11,"eq","","",660,[[["self"],["fnsig"]],["bool"]]],[11,"ne","","",660,[[["self"],["fnsig"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",660,N],[11,"partial_cmp","","",660,[[["self"],["fnsig"]],["option",["ordering"]]]],[11,"lt","","",660,[[["self"],["fnsig"]],["bool"]]],[11,"le","","",660,[[["self"],["fnsig"]],["bool"]]],[11,"gt","","",660,[[["self"],["fnsig"]],["bool"]]],[11,"ge","","",660,[[["self"],["fnsig"]],["bool"]]],[11,"cmp","","",660,[[["self"],["fnsig"]],["ordering"]]],[11,"hash","","",660,N],[11,"encode","","",660,[[["self"],["__s"]],["result"]]],[11,"decode","","",660,[[["__d"]],["result",["fnsig"]]]],[11,"inputs","","",660,N],[11,"output","","",660,[[["self"]],["ty"]]],[11,"inputs","rustc::ty::sty","",1030,[[["self"]],["binder"]]],[11,"input","","",1030,[[["self"],["usize"]],["binder",["ty"]]]],[11,"inputs_and_output","","",1030,[[["self"]],["binder",["list"]]]],[11,"output","","",1030,[[["self"]],["binder",["ty"]]]],[11,"variadic","","",1030,[[["self"]],["bool"]]],[11,"unsafety","","",1030,[[["self"]],["unsafety"]]],[11,"abi","","",1030,[[["self"]],["abi"]]],[11,"clone","rustc::ty","",662,[[["self"]],["paramty"]]],[11,"eq","","",662,[[["self"],["paramty"]],["bool"]]],[11,"ne","","",662,[[["self"],["paramty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",662,N],[11,"partial_cmp","","",662,[[["self"],["paramty"]],["option",["ordering"]]]],[11,"lt","","",662,[[["self"],["paramty"]],["bool"]]],[11,"le","","",662,[[["self"],["paramty"]],["bool"]]],[11,"gt","","",662,[[["self"],["paramty"]],["bool"]]],[11,"ge","","",662,[[["self"],["paramty"]],["bool"]]],[11,"cmp","","",662,[[["self"],["paramty"]],["ordering"]]],[11,"hash","","",662,N],[11,"encode","","",662,[[["self"],["__s"]],["result"]]],[11,"decode","","",662,[[["__d"]],["result",["paramty"]]]],[11,"new","","",662,[[["u32"],["internedstring"]],["paramty"]]],[11,"for_self","","",662,[[],["paramty"]]],[11,"for_def","","",662,[[["genericparamdef"]],["paramty"]]],[11,"to_ty","","",662,[[["self"],["tyctxt"]],["ty"]]],[11,"is_self","","",662,[[["self"]],["bool"]]],[11,"clone","","",659,[[["self"]],["debruijnindex"]]],[11,"eq","","",659,[[["self"],["debruijnindex"]],["bool"]]],[11,"ne","","",659,[[["self"],["debruijnindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",659,N],[11,"hash","","",659,N],[11,"partial_cmp","","",659,[[["self"],["debruijnindex"]],["option",["ordering"]]]],[11,"lt","","",659,[[["self"],["debruijnindex"]],["bool"]]],[11,"le","","",659,[[["self"],["debruijnindex"]],["bool"]]],[11,"gt","","",659,[[["self"],["debruijnindex"]],["bool"]]],[11,"ge","","",659,[[["self"],["debruijnindex"]],["bool"]]],[11,"cmp","","",659,[[["self"],["debruijnindex"]],["ordering"]]],[11,"decode","","",659,[[["__d"]],["result",["debruijnindex"]]]],[11,"encode","","",659,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",659,N],[18,"MAX","","",659,N],[11,"from_usize","","",659,[[["usize"]],["self"]]],[11,"from_u32","","",659,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",659,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",659,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",659,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",659,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",659,[[["self"]],["usize"]]],[11,"new","","",659,[[["usize"]],["self"]]],[11,"index","","",659,[[["self"]],["usize"]]],[11,"steps_between","","",659,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",659,[[["self"]],["self"]]],[11,"replace_zero","","",659,[[["self"]],["self"]]],[11,"add_one","","",659,[[["self"]],["self"]]],[11,"sub_one","","",659,[[["self"]],["self"]]],[11,"add_usize","","",659,[[["self"],["usize"]],["option"]]],[11,"from","","",659,[[["usize"]],["self"]]],[11,"from","","",659,[[["u32"]],["self"]]],[11,"fmt","","",659,[[["self"],["formatter"]],["result"]]],[11,"clone","","",723,[[["self"]],["regionkind"]]],[11,"eq","","",723,[[["self"],["regionkind"]],["bool"]]],[11,"ne","","",723,[[["self"],["regionkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",723,N],[11,"hash","","",723,N],[11,"encode","","",723,[[["self"],["__s"]],["result"]]],[11,"decode","","",723,[[["__d"]],["result",["regionkind"]]]],[11,"partial_cmp","","",723,[[["self"],["regionkind"]],["option",["ordering"]]]],[11,"lt","","",723,[[["self"],["regionkind"]],["bool"]]],[11,"le","","",723,[[["self"],["regionkind"]],["bool"]]],[11,"gt","","",723,[[["self"],["regionkind"]],["bool"]]],[11,"ge","","",723,[[["self"],["regionkind"]],["bool"]]],[11,"cmp","","",723,[[["self"],["regionkind"]],["ordering"]]],[11,"clone","","",671,[[["self"]],["earlyboundregion"]]],[11,"eq","","",671,[[["self"],["earlyboundregion"]],["bool"]]],[11,"ne","","",671,[[["self"],["earlyboundregion"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",671,N],[11,"hash","","",671,N],[11,"encode","","",671,[[["self"],["__s"]],["result"]]],[11,"decode","","",671,[[["__d"]],["result",["earlyboundregion"]]]],[11,"fmt","","",671,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",671,[[["self"],["earlyboundregion"]],["option",["ordering"]]]],[11,"lt","","",671,[[["self"],["earlyboundregion"]],["bool"]]],[11,"le","","",671,[[["self"],["earlyboundregion"]],["bool"]]],[11,"gt","","",671,[[["self"],["earlyboundregion"]],["bool"]]],[11,"ge","","",671,[[["self"],["earlyboundregion"]],["bool"]]],[11,"cmp","","",671,[[["self"],["earlyboundregion"]],["ordering"]]],[11,"clone","","",673,[[["self"]],["tyvid"]]],[11,"eq","","",673,[[["self"],["tyvid"]],["bool"]]],[11,"ne","","",673,[[["self"],["tyvid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",673,N],[11,"partial_cmp","","",673,[[["self"],["tyvid"]],["option",["ordering"]]]],[11,"lt","","",673,[[["self"],["tyvid"]],["bool"]]],[11,"le","","",673,[[["self"],["tyvid"]],["bool"]]],[11,"gt","","",673,[[["self"],["tyvid"]],["bool"]]],[11,"ge","","",673,[[["self"],["tyvid"]],["bool"]]],[11,"cmp","","",673,[[["self"],["tyvid"]],["ordering"]]],[11,"hash","","",673,N],[11,"encode","","",673,[[["self"],["__s"]],["result"]]],[11,"decode","","",673,[[["__d"]],["result",["tyvid"]]]],[11,"clone","","",674,[[["self"]],["intvid"]]],[11,"eq","","",674,[[["self"],["intvid"]],["bool"]]],[11,"ne","","",674,[[["self"],["intvid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",674,N],[11,"partial_cmp","","",674,[[["self"],["intvid"]],["option",["ordering"]]]],[11,"lt","","",674,[[["self"],["intvid"]],["bool"]]],[11,"le","","",674,[[["self"],["intvid"]],["bool"]]],[11,"gt","","",674,[[["self"],["intvid"]],["bool"]]],[11,"ge","","",674,[[["self"],["intvid"]],["bool"]]],[11,"cmp","","",674,[[["self"],["intvid"]],["ordering"]]],[11,"hash","","",674,N],[11,"encode","","",674,[[["self"],["__s"]],["result"]]],[11,"decode","","",674,[[["__d"]],["result",["intvid"]]]],[11,"clone","","",675,[[["self"]],["floatvid"]]],[11,"eq","","",675,[[["self"],["floatvid"]],["bool"]]],[11,"ne","","",675,[[["self"],["floatvid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",675,N],[11,"partial_cmp","","",675,[[["self"],["floatvid"]],["option",["ordering"]]]],[11,"lt","","",675,[[["self"],["floatvid"]],["bool"]]],[11,"le","","",675,[[["self"],["floatvid"]],["bool"]]],[11,"gt","","",675,[[["self"],["floatvid"]],["bool"]]],[11,"ge","","",675,[[["self"],["floatvid"]],["bool"]]],[11,"cmp","","",675,[[["self"],["floatvid"]],["ordering"]]],[11,"hash","","",675,N],[11,"encode","","",675,[[["self"],["__s"]],["result"]]],[11,"decode","","",675,[[["__d"]],["result",["floatvid"]]]],[11,"clone","","",676,[[["self"]],["regionvid"]]],[11,"eq","","",676,[[["self"],["regionvid"]],["bool"]]],[11,"ne","","",676,[[["self"],["regionvid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",676,N],[11,"hash","","",676,N],[11,"partial_cmp","","",676,[[["self"],["regionvid"]],["option",["ordering"]]]],[11,"lt","","",676,[[["self"],["regionvid"]],["bool"]]],[11,"le","","",676,[[["self"],["regionvid"]],["bool"]]],[11,"gt","","",676,[[["self"],["regionvid"]],["bool"]]],[11,"ge","","",676,[[["self"],["regionvid"]],["bool"]]],[11,"cmp","","",676,[[["self"],["regionvid"]],["ordering"]]],[11,"decode","","",676,[[["__d"]],["result",["regionvid"]]]],[11,"encode","","",676,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",676,N],[18,"MAX","","",676,N],[11,"from_usize","","",676,[[["usize"]],["self"]]],[11,"from_u32","","",676,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",676,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",676,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",676,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",676,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",676,[[["self"]],["usize"]]],[11,"new","","",676,[[["usize"]],["self"]]],[11,"index","","",676,[[["self"]],["usize"]]],[11,"steps_between","","",676,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",676,[[["self"]],["self"]]],[11,"replace_zero","","",676,[[["self"]],["self"]]],[11,"add_one","","",676,[[["self"]],["self"]]],[11,"sub_one","","",676,[[["self"]],["self"]]],[11,"add_usize","","",676,[[["self"],["usize"]],["option"]]],[11,"from","","",676,[[["usize"]],["self"]]],[11,"from","","",676,[[["u32"]],["self"]]],[11,"index","","",676,[[["self"]],["usize"]]],[11,"clone","","",718,[[["self"]],["inferty"]]],[11,"eq","","",718,[[["self"],["inferty"]],["bool"]]],[11,"ne","","",718,[[["self"],["inferty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",718,N],[11,"partial_cmp","","",718,[[["self"],["inferty"]],["option",["ordering"]]]],[11,"lt","","",718,[[["self"],["inferty"]],["bool"]]],[11,"le","","",718,[[["self"],["inferty"]],["bool"]]],[11,"gt","","",718,[[["self"],["inferty"]],["bool"]]],[11,"ge","","",718,[[["self"],["inferty"]],["bool"]]],[11,"cmp","","",718,[[["self"],["inferty"]],["ordering"]]],[11,"hash","","",718,N],[11,"encode","","",718,[[["self"],["__s"]],["result"]]],[11,"decode","","",718,[[["__d"]],["result",["inferty"]]]],[11,"clone","","",658,[[["self"]],["canonicalvar"]]],[11,"eq","","",658,[[["self"],["canonicalvar"]],["bool"]]],[11,"ne","","",658,[[["self"],["canonicalvar"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",658,N],[11,"hash","","",658,N],[11,"partial_cmp","","",658,[[["self"],["canonicalvar"]],["option",["ordering"]]]],[11,"lt","","",658,[[["self"],["canonicalvar"]],["bool"]]],[11,"le","","",658,[[["self"],["canonicalvar"]],["bool"]]],[11,"gt","","",658,[[["self"],["canonicalvar"]],["bool"]]],[11,"ge","","",658,[[["self"],["canonicalvar"]],["bool"]]],[11,"cmp","","",658,[[["self"],["canonicalvar"]],["ordering"]]],[11,"decode","","",658,[[["__d"]],["result",["canonicalvar"]]]],[11,"encode","","",658,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",658,N],[18,"MAX","","",658,N],[11,"from_usize","","",658,[[["usize"]],["self"]]],[11,"from_u32","","",658,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",658,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",658,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",658,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",658,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",658,[[["self"]],["usize"]]],[11,"new","","",658,[[["usize"]],["self"]]],[11,"index","","",658,[[["self"]],["usize"]]],[11,"steps_between","","",658,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",658,[[["self"]],["self"]]],[11,"replace_zero","","",658,[[["self"]],["self"]]],[11,"add_one","","",658,[[["self"]],["self"]]],[11,"sub_one","","",658,[[["self"]],["self"]]],[11,"add_usize","","",658,[[["self"],["usize"]],["option"]]],[11,"from","","",658,[[["usize"]],["self"]]],[11,"from","","",658,[[["u32"]],["self"]]],[11,"fmt","","",658,[[["self"],["formatter"]],["result"]]],[11,"clone","","",669,[[["self"]],["existentialprojection"]]],[11,"eq","","",669,[[["self"],["existentialprojection"]],["bool"]]],[11,"ne","","",669,[[["self"],["existentialprojection"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",669,N],[11,"partial_cmp","","",669,[[["self"],["existentialprojection"]],["option",["ordering"]]]],[11,"lt","","",669,[[["self"],["existentialprojection"]],["bool"]]],[11,"le","","",669,[[["self"],["existentialprojection"]],["bool"]]],[11,"gt","","",669,[[["self"],["existentialprojection"]],["bool"]]],[11,"ge","","",669,[[["self"],["existentialprojection"]],["bool"]]],[11,"cmp","","",669,[[["self"],["existentialprojection"]],["ordering"]]],[11,"hash","","",669,N],[11,"fmt","","",669,[[["self"],["formatter"]],["result"]]],[11,"encode","","",669,[[["self"],["__s"]],["result"]]],[11,"decode","","",669,[[["__d"]],["result",["existentialprojection"]]]],[11,"trait_ref","","Extracts the underlying existential trait reference from this projection. For example, if this is a projection of `exists T. <T as Iterator>::Item == X`, then this function would return a `exists T. T: Iterator` existential trait reference.",669,[[["self"],["tyctxt"]],["existentialtraitref"]]],[11,"with_self_ty","","",669,[[["self"],["tyctxt"],["ty"]],["projectionpredicate"]]],[11,"with_self_ty","rustc::ty::sty","",1031,[[["self"],["tyctxt"],["ty"]],["polyprojectionpredicate"]]],[11,"item_def_id","","",1031,[[["self"]],["defid"]]],[11,"shifted_in","rustc::ty","Returns the resulting index when this value is moved into `amount` number of new binders. So e.g. if you had",659,[[["self"],["u32"]],["debruijnindex"]]],[11,"shift_in","","Update this index in place by shifting it \"in\" through `amount` number of binders.",659,[[["self"],["u32"]]]],[11,"shifted_out","","Returns the resulting index when this value is moved out from `amount` number of new binders.",659,[[["self"],["u32"]],["debruijnindex"]]],[11,"shift_out","","Update in place by shifting out from `amount` binders.",659,[[["self"],["u32"]]]],[11,"shifted_out_to_binder","","Adjusts any Debruijn Indices so as to make `to_binder` the innermost binder. That is, if we have something bound at `to_binder`, it will now be bound at INNERMOST. This is an appropriate thing to do when moving a region out from inside binders:",659,[[["self"],["debruijnindex"]],["self"]]],[11,"hash_stable","","",659,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"is_late_bound","","",723,[[["self"]],["bool"]]],[11,"bound_at_or_above_binder","","",723,[[["self"],["debruijnindex"]],["bool"]]],[11,"shifted_out_to_binder","","Adjusts any Debruijn Indices so as to make `to_binder` the innermost binder. That is, if we have something bound at `to_binder`, it will now be bound at INNERMOST. This is an appropriate thing to do when moving a region out from inside binders:",723,[[["self"],["debruijnindex"]],["regionkind"]]],[11,"keep_in_local_tcx","","",723,[[["self"]],["bool"]]],[11,"type_flags","","",723,[[["self"]],["typeflags"]]],[11,"free_region_binding_scope","","Given an early-bound or free region, returns the def-id where it was bound. For example, consider the regions in this snippet of code:",723,[[["self"],["tyctxt"]],["defid"]]],[11,"is_unit","","",689,[[["self"]],["bool"]]],[11,"is_never","","",689,[[["self"]],["bool"]]],[11,"is_primitive","","",689,[[["self"]],["bool"]]],[11,"is_ty_var","","",689,[[["self"]],["bool"]]],[11,"is_ty_infer","","",689,[[["self"]],["bool"]]],[11,"is_phantom_data","","",689,[[["self"]],["bool"]]],[11,"is_bool","","",689,[[["self"]],["bool"]]],[11,"is_param","","",689,[[["self"],["u32"]],["bool"]]],[11,"is_self","","",689,[[["self"]],["bool"]]],[11,"is_slice","","",689,[[["self"]],["bool"]]],[11,"is_simd","","",689,[[["self"]],["bool"]]],[11,"sequence_element_type","","",689,[[["self"],["tyctxt"]],["ty"]]],[11,"simd_type","","",689,[[["self"],["tyctxt"]],["ty"]]],[11,"simd_size","","",689,[[["self"],["tyctxt"]],["usize"]]],[11,"is_region_ptr","","",689,[[["self"]],["bool"]]],[11,"is_mutable_pointer","","",689,[[["self"]],["bool"]]],[11,"is_unsafe_ptr","","",689,[[["self"]],["bool"]]],[11,"is_box","","",689,[[["self"]],["bool"]]],[11,"boxed_ty","","panics if called on any type other than `Box<T>`",689,[[["self"]],["ty"]]],[11,"is_scalar","","A scalar type is one that denotes an atomic datum, with no sub-components. (A RawPtr is scalar because it represents a non-managed pointer, so its contents are abstract to rustc.)",689,[[["self"]],["bool"]]],[11,"is_floating_point","","Returns true if this type is a floating point type and false otherwise.",689,[[["self"]],["bool"]]],[11,"is_trait","","",689,[[["self"]],["bool"]]],[11,"is_enum","","",689,[[["self"]],["bool"]]],[11,"is_closure","","",689,[[["self"]],["bool"]]],[11,"is_generator","","",689,[[["self"]],["bool"]]],[11,"is_integral","","",689,[[["self"]],["bool"]]],[11,"is_fresh_ty","","",689,[[["self"]],["bool"]]],[11,"is_fresh","","",689,[[["self"]],["bool"]]],[11,"is_char","","",689,[[["self"]],["bool"]]],[11,"is_fp","","",689,[[["self"]],["bool"]]],[11,"is_numeric","","",689,[[["self"]],["bool"]]],[11,"is_signed","","",689,[[["self"]],["bool"]]],[11,"is_machine","","",689,[[["self"]],["bool"]]],[11,"has_concrete_skeleton","","",689,[[["self"]],["bool"]]],[11,"builtin_deref","","Returns the type and mutability of *ty.",689,[[["self"],["bool"]],["option",["typeandmut"]]]],[11,"builtin_index","","Returns the type of `ty[i]`.",689,[[["self"]],["option",["ty"]]]],[11,"fn_sig","","",689,[[["self"],["tyctxt"]],["polyfnsig"]]],[11,"is_fn","","",689,[[["self"]],["bool"]]],[11,"is_impl_trait","","",689,[[["self"]],["bool"]]],[11,"ty_adt_def","","",689,[[["self"]],["option",["adtdef"]]]],[11,"regions","","Returns the regions directly referenced from this type (but not types reachable from this type via `walk_tys`). This ignores late-bound regions binders.",689,[[["self"]],["vec",["region"]]]],[11,"to_opt_closure_kind","","When we create a closure, we record its kind (i.e., what trait it implements) into its `ClosureSubsts` using a type parameter. This is kind of a phantom type, except that the most convenient thing for us to are the integral types. This function converts such a special type into the closure kind. To go the other way, use `tcx.closure_kind_ty(closure_kind)`.",689,[[["self"]],["option",["closurekind"]]]],[11,"is_trivially_sized","","Fast path helper for testing if a type is `Sized`.",689,[[["self"],["tyctxt"]],["bool"]]],[11,"clone","","",670,[[["self"]],["const"]]],[11,"fmt","","",670,[[["self"],["formatter"]],["result"]]],[11,"hash","","",670,N],[11,"encode","","",670,[[["self"],["__s"]],["result"]]],[11,"decode","","",670,[[["__d"]],["result",["const"]]]],[11,"assert_receiver_is_total_eq","","",670,N],[11,"eq","","",670,[[["self"],["const"]],["bool"]]],[11,"ne","","",670,[[["self"],["const"]],["bool"]]],[11,"cmp","","",670,[[["self"],["const"]],["ordering"]]],[11,"partial_cmp","","",670,[[["self"],["const"]],["option",["ordering"]]]],[11,"lt","","",670,[[["self"],["const"]],["bool"]]],[11,"le","","",670,[[["self"],["const"]],["bool"]]],[11,"gt","","",670,[[["self"],["const"]],["bool"]]],[11,"ge","","",670,[[["self"],["const"]],["bool"]]],[11,"unevaluated","","",670,[[["tyctxt"],["defid"],["substs"],["ty"]],["self"]]],[11,"from_const_value","","",670,[[["tyctxt"],["constvalue"],["ty"]],["self"]]],[11,"from_scalar","","",670,[[["tyctxt"],["scalar"],["ty"]],["self"]]],[11,"from_bits","","",670,[[["tyctxt"],["u128"],["paramenvand",["ty"]]],["self"]]],[11,"zero_sized","","",670,[[["tyctxt"],["ty"]],["self"]]],[11,"from_bool","","",670,[[["tyctxt"],["bool"]],["self"]]],[11,"from_usize","","",670,[[["tyctxt"],["u64"]],["self"]]],[11,"to_bits","","",670,[[["self"],["tyctxt"],["paramenvand",["ty"]]],["option",["u128"]]]],[11,"to_ptr","","",670,[[["self"]],["option",["pointer"]]]],[11,"assert_bits","","",670,[[["self"],["tyctxt"],["paramenvand",["ty"]]],["option",["u128"]]]],[11,"assert_bool","","",670,[[["self"],["tyctxt"]],["option",["bool"]]]],[11,"assert_usize","","",670,[[["self"],["tyctxt"]],["option",["u64"]]]],[11,"unwrap_bits","","",670,[[["self"],["tyctxt"],["paramenvand",["ty"]]],["u128"]]],[11,"unwrap_usize","","",670,[[["self"],["tyctxt"]],["u64"]]],[6,"PolyFnSig","","",N,N],[6,"PolyGenSig","","",N,N],[6,"PolyTraitRef","","",N,N],[6,"PolyExistentialTraitRef","","",N,N],[6,"PolyExistentialProjection","","",N,N],[6,"Region","","",N,N],[6,"Ty","","",N,N],[6,"CanonicalTy","","",N,N],[6,"UpvarCaptureMap","","",N,N],[6,"PolyTraitPredicate","","",N,N],[6,"PolyOutlivesPredicate","","",N,N],[6,"RegionOutlivesPredicate","","",N,N],[6,"TypeOutlivesPredicate","","",N,N],[6,"PolyRegionOutlivesPredicate","","",N,N],[6,"PolyTypeOutlivesPredicate","","",N,N],[6,"PolySubtypePredicate","","",N,N],[6,"PolyProjectionPredicate","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"INNERMOST","","",N,N],[8,"Lift","","A trait implemented for all X<'a> types which can be safely and efficiently converted to X<'tcx> as long as they are part of the provided TyCtxt<'tcx>. This can be done, for example, for Ty<'tcx> or &'tcx Substs<'tcx> by looking them up in their respective interners.",N,N],[16,"Lifted","","",1021,N],[10,"lift_to_tcx","","",1021,[[["self"],["tyctxt"]],["option"]]],[8,"DefIdTree","","",N,N],[10,"parent","","",1032,[[["self"],["defid"]],["option",["defid"]]]],[11,"is_descendant_of","","",1032,[[["self"],["defid"],["defid"]],["bool"]]],[8,"ToPolyTraitRef","","",N,N],[10,"to_poly_trait_ref","","",1033,[[["self"]],["polytraitref"]]],[8,"ToPredicate","","",N,N],[10,"to_predicate","","",1034,[[["self"]],["predicate"]]],[11,"clone","","",682,[[["self"]],["crateanalysis"]]],[11,"clone","","",683,[[["self"]],["resolutions"]]],[11,"clone","","",725,[[["self"]],["associateditemcontainer"]]],[11,"eq","","",725,[[["self"],["associateditemcontainer"]],["bool"]]],[11,"ne","","",725,[[["self"],["associateditemcontainer"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",725,N],[11,"fmt","","",725,[[["self"],["formatter"]],["result"]]],[11,"assert_trait","","Asserts that this is the def-id of an associated item declared in a trait, and returns the trait def-id.",725,[[["self"]],["defid"]]],[11,"id","","",725,[[["self"]],["defid"]]],[11,"clone","","",684,[[["self"]],["implheader"]]],[11,"eq","","",684,[[["self"],["implheader"]],["bool"]]],[11,"ne","","",684,[[["self"],["implheader"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",684,N],[11,"hash","","",684,N],[11,"fmt","","",684,[[["self"],["formatter"]],["result"]]],[11,"clone","","",685,[[["self"]],["associateditem"]]],[11,"fmt","","",685,[[["self"],["formatter"]],["result"]]],[11,"eq","","",685,[[["self"],["associateditem"]],["bool"]]],[11,"ne","","",685,[[["self"],["associateditem"]],["bool"]]],[11,"clone","","",726,[[["self"]],["associatedkind"]]],[11,"eq","","",726,[[["self"],["associatedkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",726,N],[11,"fmt","","",726,[[["self"],["formatter"]],["result"]]],[11,"hash","","",726,N],[11,"encode","","",726,[[["self"],["__s"]],["result"]]],[11,"decode","","",726,[[["__d"]],["result",["associatedkind"]]]],[11,"def","","",685,[[["self"]],["def"]]],[11,"relevant_for_never","","Tests whether the associated item admits a non-trivial implementation for !",685,[[["self"]],["bool"]]],[11,"signature","","",685,[[["self"],["tyctxt"]],["string"]]],[11,"clone","","",727,[[["self"]],["visibility"]]],[11,"fmt","","",727,[[["self"],["formatter"]],["result"]]],[11,"eq","","",727,[[["self"],["visibility"]],["bool"]]],[11,"ne","","",727,[[["self"],["visibility"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",727,N],[11,"encode","","",727,[[["self"],["__s"]],["result"]]],[11,"decode","","",727,[[["__d"]],["result",["visibility"]]]],[11,"parent","","",677,[[["self"],["defid"]],["option",["defid"]]]],[11,"from_hir","","",727,[[["visibility"],["nodeid"],["tyctxt"]],["self"]]],[11,"is_accessible_from","","Returns true if an item with this visibility is accessible from the given block.",727,[[["self"],["defid"],["t"]],["bool"]]],[11,"is_at_least","","Returns true if this visibility is at least as accessible as the given visibility",727,[[["self"],["visibility"],["t"]],["bool"]]],[11,"is_visible_locally","","",727,[[["self"]],["bool"]]],[11,"clone","","",728,[[["self"]],["variance"]]],[11,"eq","","",728,[[["self"],["variance"]],["bool"]]],[11,"decode","","",728,[[["__d"]],["result",["variance"]]]],[11,"encode","","",728,[[["self"],["__s"]],["result"]]],[11,"xform","","`a.xform(b)` combines the variance of a context with the variance of a type with the following meaning.  If we are in a context with variance `a`, and we encounter a type argument in a position with variance `b`, then `a.xform(b)` is the new variance with which the argument appears.",728,[[["self"],["variance"]],["variance"]]],[11,"clone","","",687,[[["self"]],["creadercachekey"]]],[11,"eq","","",687,[[["self"],["creadercachekey"]],["bool"]]],[11,"ne","","",687,[[["self"],["creadercachekey"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",687,N],[11,"hash","","",687,N],[11,"eq","","",688,[[["self"],["typeflags"]],["bool"]]],[11,"ne","","",688,[[["self"],["typeflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",688,N],[11,"clone","","",688,[[["self"]],["typeflags"]]],[11,"partial_cmp","","",688,[[["self"],["typeflags"]],["option",["ordering"]]]],[11,"lt","","",688,[[["self"],["typeflags"]],["bool"]]],[11,"le","","",688,[[["self"],["typeflags"]],["bool"]]],[11,"gt","","",688,[[["self"],["typeflags"]],["bool"]]],[11,"ge","","",688,[[["self"],["typeflags"]],["bool"]]],[11,"cmp","","",688,[[["self"],["typeflags"]],["ordering"]]],[11,"hash","","",688,N],[11,"fmt","","",688,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",688,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",688,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",688,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",688,[[["self"],["formatter"]],["result"]]],[18,"HAS_PARAMS","","",688,N],[18,"HAS_SELF","","",688,N],[18,"HAS_TY_INFER","","",688,N],[18,"HAS_RE_INFER","","",688,N],[18,"HAS_RE_SKOL","","",688,N],[18,"HAS_RE_EARLY_BOUND","","Does this have any `ReEarlyBound` regions? Used to determine whether substitition is required, since those represent regions that are bound in a `ty::Generics` and hence may be substituted.",688,N],[18,"HAS_FREE_REGIONS","","Does this have any region that \"appears free\" in the type? Basically anything but `ReLateBound` and `ReErased`.",688,N],[18,"HAS_TY_ERR","","Is an error type reachable?",688,N],[18,"HAS_PROJECTION","","",688,N],[18,"HAS_TY_CLOSURE","","",688,N],[18,"HAS_FREE_LOCAL_NAMES","","",688,N],[18,"KEEP_IN_LOCAL_TCX","","",688,N],[18,"HAS_NORMALIZABLE_PROJECTION","","",688,N],[18,"HAS_CANONICAL_VARS","","",688,N],[18,"HAS_RE_LATE_BOUND","","Does this have any `ReLateBound` regions? Used to check if a global bound is safe to evaluate.",688,N],[18,"NEEDS_SUBST","","",688,N],[18,"NOMINAL_FLAGS","","",688,N],[11,"empty","","Returns an empty set of flags.",688,[[],["typeflags"]]],[11,"all","","Returns the set containing all flags.",688,[[],["typeflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",688,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",688,[[["u32"]],["option",["typeflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",688,[[["u32"]],["typeflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",688,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",688,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",688,[[["self"],["typeflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",688,[[["self"],["typeflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",688,[[["self"],["typeflags"]]]],[11,"remove","","Removes the specified flags in-place.",688,[[["self"],["typeflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",688,[[["self"],["typeflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",688,[[["self"],["typeflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",688,[[["self"],["typeflags"]],["typeflags"]]],[11,"bitor_assign","","Adds the set of flags.",688,[[["self"],["typeflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",688,[[["self"],["typeflags"]],["typeflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",688,[[["self"],["typeflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",688,[[["self"],["typeflags"]],["typeflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",688,[[["self"],["typeflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",688,[[["self"],["typeflags"]],["typeflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",688,[[["self"],["typeflags"]]]],[11,"not","","Returns the complement of this set of flags.",688,[[["self"]],["typeflags"]]],[11,"extend","","",688,[[["self"],["t"]]]],[11,"from_iter","","",688,[[["t"]],["typeflags"]]],[11,"cmp","","",689,[[["self"],["tys"]],["ordering"]]],[11,"partial_cmp","","",689,[[["self"],["tys"]],["option",["ordering"]]]],[11,"eq","","",689,[[["self"],["tys"]],["bool"]]],[11,"hash","","",689,[[["self"],["h"]]]],[11,"is_primitive_ty","","",689,[[["self"]],["bool"]]],[11,"is_suggestable","","",689,[[["self"]],["bool"]]],[11,"hash_stable","","",689,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"from_arena","","",690,N],[11,"fmt","","",690,[[["self"],["formatter"]],["result"]]],[11,"encode","","",690,[[["self"],["s"]],["result"]]],[11,"cmp","","",690,[[["self"],["list"]],["ordering"]]],[11,"partial_cmp","","",690,[[["self"],["list"]],["option",["ordering"]]]],[11,"eq","","",690,[[["self"],["list"]],["bool"]]],[11,"hash","","",690,[[["self"],["h"]]]],[11,"deref","","",690,N],[11,"empty","","",690,[[],["list"]]],[11,"clone","","",691,[[["self"]],["upvarid"]]],[11,"eq","","",691,[[["self"],["upvarid"]],["bool"]]],[11,"ne","","",691,[[["self"],["upvarid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",691,N],[11,"hash","","",691,N],[11,"encode","","",691,[[["self"],["__s"]],["result"]]],[11,"decode","","",691,[[["__d"]],["result",["upvarid"]]]],[11,"clone","","",729,[[["self"]],["borrowkind"]]],[11,"eq","","",729,[[["self"],["borrowkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",729,N],[11,"hash","","",729,N],[11,"fmt","","",729,[[["self"],["formatter"]],["result"]]],[11,"encode","","",729,[[["self"],["__s"]],["result"]]],[11,"decode","","",729,[[["__d"]],["result",["borrowkind"]]]],[11,"eq","","",730,[[["self"],["upvarcapture"]],["bool"]]],[11,"ne","","",730,[[["self"],["upvarcapture"]],["bool"]]],[11,"clone","","",730,[[["self"]],["upvarcapture"]]],[11,"fmt","","",730,[[["self"],["formatter"]],["result"]]],[11,"encode","","",730,[[["self"],["__s"]],["result"]]],[11,"decode","","",730,[[["__d"]],["result",["upvarcapture"]]]],[11,"eq","","",692,[[["self"],["upvarborrow"]],["bool"]]],[11,"ne","","",692,[[["self"],["upvarborrow"]],["bool"]]],[11,"clone","","",692,[[["self"]],["upvarborrow"]]],[11,"encode","","",692,[[["self"],["__s"]],["result"]]],[11,"decode","","",692,[[["__d"]],["result",["upvarborrow"]]]],[11,"clone","","",693,[[["self"]],["closureupvar"]]],[11,"clone","","",731,[[["self"]],["intvarvalue"]]],[11,"eq","","",731,[[["self"],["intvarvalue"]],["bool"]]],[11,"ne","","",731,[[["self"],["intvarvalue"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",731,N],[11,"clone","","",694,[[["self"]],["floatvarvalue"]]],[11,"eq","","",694,[[["self"],["floatvarvalue"]],["bool"]]],[11,"ne","","",694,[[["self"],["floatvarvalue"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",694,N],[11,"to_bound_region","","",671,[[["self"]],["boundregion"]]],[11,"has_name","","Does this early bound region have a name? Early bound regions normally always have names except when using anonymous lifetimes (`'_`).",671,[[["self"]],["bool"]]],[11,"clone","","",732,[[["self"]],["genericparamdefkind"]]],[11,"fmt","","",732,[[["self"],["formatter"]],["result"]]],[11,"encode","","",732,[[["self"],["__s"]],["result"]]],[11,"decode","","",732,[[["__d"]],["result",["genericparamdefkind"]]]],[11,"clone","","",695,[[["self"]],["genericparamdef"]]],[11,"encode","","",695,[[["self"],["__s"]],["result"]]],[11,"decode","","",695,[[["__d"]],["result",["genericparamdef"]]]],[11,"to_early_bound_region_data","","",695,[[["self"]],["earlyboundregion"]]],[11,"to_bound_region","","",695,[[["self"]],["boundregion"]]],[11,"default","","",696,[[],["genericparamcount"]]],[11,"clone","","",697,[[["self"]],["generics"]]],[11,"fmt","","",697,[[["self"],["formatter"]],["result"]]],[11,"encode","","",697,[[["self"],["__s"]],["result"]]],[11,"decode","","",697,[[["__d"]],["result",["generics"]]]],[11,"count","","",697,[[["self"]],["usize"]]],[11,"own_counts","","",697,[[["self"]],["genericparamcount"]]],[11,"requires_monomorphization","","",697,[[["self"],["tyctxt"]],["bool"]]],[11,"region_param","","",697,[[["self"],["earlyboundregion"],["tyctxt"]],["genericparamdef"]]],[11,"type_param","","Returns the `GenericParamDef` associated with this `ParamTy`.",697,[[["self"],["paramty"],["tyctxt"]],["genericparamdef"]]],[11,"clone","","",698,[[["self"]],["genericpredicates"]]],[11,"default","","",698,[[],["genericpredicates"]]],[11,"instantiate","","",698,[[["self"],["tyctxt"],["substs"]],["instantiatedpredicates"]]],[11,"instantiate_own","","",698,[[["self"],["tyctxt"],["substs"]],["instantiatedpredicates"]]],[11,"instantiate_into","","",698,[[["self"],["tyctxt"],["instantiatedpredicates"],["substs"]]]],[11,"instantiate_identity","","",698,[[["self"],["tyctxt"]],["instantiatedpredicates"]]],[11,"instantiate_identity_into","","",698,[[["self"],["tyctxt"],["instantiatedpredicates"]]]],[11,"instantiate_supertrait","","",698,[[["self"],["tyctxt"],["polytraitref"]],["instantiatedpredicates"]]],[11,"clone","","",733,[[["self"]],["predicate"]]],[11,"eq","","",733,[[["self"],["predicate"]],["bool"]]],[11,"ne","","",733,[[["self"],["predicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",733,N],[11,"hash","","",733,N],[11,"encode","","",733,[[["self"],["__s"]],["result"]]],[11,"decode","","",733,[[["__d"]],["result",["predicate"]]]],[11,"as_ref","","",733,[[["self"]],["predicate"]]],[11,"subst_supertrait","","Performs a substitution suitable for going from a poly-trait-ref to supertraits that must hold if that poly-trait-ref holds. This is slightly different from a normal substitution in terms of what happens with bound regions.  See lengthy comment below for details.",733,[[["self"],["tyctxt"],["polytraitref"]],["predicate"]]],[11,"clone","","",700,[[["self"]],["traitpredicate"]]],[11,"eq","","",700,[[["self"],["traitpredicate"]],["bool"]]],[11,"ne","","",700,[[["self"],["traitpredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",700,N],[11,"hash","","",700,N],[11,"encode","","",700,[[["self"],["__s"]],["result"]]],[11,"decode","","",700,[[["__d"]],["result",["traitpredicate"]]]],[11,"def_id","","",700,[[["self"]],["defid"]]],[11,"input_types","","",700,N],[11,"self_ty","","",700,[[["self"]],["ty"]]],[11,"def_id","","",1035,[[["self"]],["defid"]]],[11,"clone","","",701,[[["self"]],["outlivespredicate"]]],[11,"eq","","",701,[[["self"],["outlivespredicate"]],["bool"]]],[11,"ne","","",701,[[["self"],["outlivespredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",701,N],[11,"partial_cmp","","",701,[[["self"],["outlivespredicate"]],["option",["ordering"]]]],[11,"lt","","",701,[[["self"],["outlivespredicate"]],["bool"]]],[11,"le","","",701,[[["self"],["outlivespredicate"]],["bool"]]],[11,"gt","","",701,[[["self"],["outlivespredicate"]],["bool"]]],[11,"ge","","",701,[[["self"],["outlivespredicate"]],["bool"]]],[11,"cmp","","",701,[[["self"],["outlivespredicate"]],["ordering"]]],[11,"hash","","",701,N],[11,"fmt","","",701,[[["self"],["formatter"]],["result"]]],[11,"encode","","",701,[[["self"],["__sab"]],["result"]]],[11,"decode","","",701,[[["__dab"]],["result",["outlivespredicate"]]]],[11,"clone","","",702,[[["self"]],["subtypepredicate"]]],[11,"eq","","",702,[[["self"],["subtypepredicate"]],["bool"]]],[11,"ne","","",702,[[["self"],["subtypepredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",702,N],[11,"hash","","",702,N],[11,"fmt","","",702,[[["self"],["formatter"]],["result"]]],[11,"encode","","",702,[[["self"],["__s"]],["result"]]],[11,"decode","","",702,[[["__d"]],["result",["subtypepredicate"]]]],[11,"clone","","",703,[[["self"]],["projectionpredicate"]]],[11,"eq","","",703,[[["self"],["projectionpredicate"]],["bool"]]],[11,"ne","","",703,[[["self"],["projectionpredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",703,N],[11,"hash","","",703,N],[11,"encode","","",703,[[["self"],["__s"]],["result"]]],[11,"decode","","",703,[[["__d"]],["result",["projectionpredicate"]]]],[11,"item_def_id","","Returns the def-id of the associated item being projected.",1036,[[["self"]],["defid"]]],[11,"to_poly_trait_ref","","",1036,[[["self"],["tyctxt"]],["polytraitref"]]],[11,"ty","","",1036,[[["self"]],["binder",["ty"]]]],[11,"projection_def_id","","The DefId of the TraitItem for the associated type.",1036,[[["self"]],["defid"]]],[11,"to_poly_trait_ref","","",667,[[["self"]],["polytraitref"]]],[11,"to_poly_trait_ref","","",1035,[[["self"]],["polytraitref"]]],[11,"to_predicate","","",667,[[["self"]],["predicate"]]],[11,"to_predicate","","",1027,[[["self"]],["predicate"]]],[11,"to_predicate","","",1037,[[["self"]],["predicate"]]],[11,"to_predicate","","",1038,[[["self"]],["predicate"]]],[11,"to_predicate","","",1036,[[["self"]],["predicate"]]],[11,"walk_tys","","Iterates over the types in this predicate. Note that in all cases this is skipping over a binder, so late-bound regions with depth 0 are bound by the predicate.",733,[[["self"]],["intoiter",["ty"]]]],[11,"to_opt_poly_trait_ref","","",733,[[["self"]],["option",["polytraitref"]]]],[11,"to_opt_type_outlives","","",733,[[["self"]],["option",["polytypeoutlivespredicate"]]]],[11,"clone","","",704,[[["self"]],["instantiatedpredicates"]]],[11,"empty","","",704,[[],["instantiatedpredicates"]]],[11,"is_empty","","",704,[[["self"]],["bool"]]],[11,"clone","","",705,[[["self"]],["universeindex"]]],[11,"eq","","",705,[[["self"],["universeindex"]],["bool"]]],[11,"ne","","",705,[[["self"],["universeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",705,N],[11,"partial_cmp","","",705,[[["self"],["universeindex"]],["option",["ordering"]]]],[11,"lt","","",705,[[["self"],["universeindex"]],["bool"]]],[11,"le","","",705,[[["self"],["universeindex"]],["bool"]]],[11,"gt","","",705,[[["self"],["universeindex"]],["bool"]]],[11,"ge","","",705,[[["self"],["universeindex"]],["bool"]]],[11,"cmp","","",705,[[["self"],["universeindex"]],["ordering"]]],[11,"hash","","",705,N],[11,"encode","","",705,[[["self"],["__s"]],["result"]]],[11,"decode","","",705,[[["__d"]],["result",["universeindex"]]]],[18,"ROOT","","The root universe, where things that the user defined are visible.",705,N],[18,"MAX","","The \"max universe\" -- this isn't really a valid universe, but it's useful sometimes as a \"starting value\" when you are taking the minimum of a (non-empty!) set of universes.",705,N],[11,"from_u32","","Creates a universe index from the given integer.  Not to be used lightly lest you pick a bad value. But sometimes we convert universe indices into integers and back for various reasons.",705,[[["u32"]],["self"]]],[11,"subuniverse","","A \"subuniverse\" corresponds to being inside a `forall` quantifier. So, for example, suppose we have this type in universe `U`:",705,[[["self"]],["universeindex"]]],[11,"is_subset_of","","True if the names in this universe are a subset of the names in `other`.",705,[[["self"],["universeindex"]],["bool"]]],[11,"as_u32","","",705,[[["self"]],["u32"]]],[11,"as_usize","","",705,[[["self"]],["usize"]]],[11,"fmt","","",705,[[["self"],["formatter"]],["result"]]],[11,"from","","",705,[[["u32"]],["self"]]],[11,"clone","","",706,[[["self"]],["paramenv"]]],[11,"fmt","","",706,[[["self"],["formatter"]],["result"]]],[11,"eq","","",706,[[["self"],["paramenv"]],["bool"]]],[11,"ne","","",706,[[["self"],["paramenv"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",706,N],[11,"hash","","",706,N],[11,"empty","","Construct a trait environment suitable for contexts where there are no where clauses in scope. Hidden types (like `impl Trait`) are left hidden, so this is suitable for ordinary type-checking.",706,[[],["self"]]],[11,"reveal_all","","Construct a trait environment with no where clauses in scope where the values of all `impl Trait` and other hidden types are revealed. This is suitable for monomorphized, post-typeck environments like codegen or doing optimizations.",706,[[],["self"]]],[11,"new","","Construct a trait environment with the given set of predicates.",706,[[["list"],["reveal"]],["self"]]],[11,"with_reveal_all","","Returns a new parameter environment with the same clauses, but which \"reveals\" the true results of projections in all cases (even for associated types that are specializable).  This is the desired behavior during codegen and certain other special contexts; normally though we want to use `Reveal::UserFacing`, which is the default.",706,[[["self"]],["self"]]],[11,"without_caller_bounds","","Returns this same environment but with no caller bounds.",706,[[["self"]],["self"]]],[11,"and","","Creates a suitable environment in which to perform trait queries on the given value. When type-checking, this is simply the pair of the environment plus value. But when reveal is set to All, then if `value` does not reference any type parameters, we will pair it with the empty environment. This improves caching and is generally invisible.",706,[[["self"],["t"]],["paramenvand"]]],[11,"clone","","",707,[[["self"]],["paramenvand"]]],[11,"fmt","","",707,[[["self"],["formatter"]],["result"]]],[11,"eq","","",707,[[["self"],["paramenvand"]],["bool"]]],[11,"ne","","",707,[[["self"],["paramenvand"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",707,N],[11,"hash","","",707,N],[11,"into_parts","","",707,N],[11,"hash_stable","","",707,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",708,[[["self"]],["destructor"]]],[11,"fmt","","",708,[[["self"],["formatter"]],["result"]]],[11,"eq","","",709,[[["self"],["adtflags"]],["bool"]]],[11,"ne","","",709,[[["self"],["adtflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",709,N],[11,"clone","","",709,[[["self"]],["adtflags"]]],[11,"partial_cmp","","",709,[[["self"],["adtflags"]],["option",["ordering"]]]],[11,"lt","","",709,[[["self"],["adtflags"]],["bool"]]],[11,"le","","",709,[[["self"],["adtflags"]],["bool"]]],[11,"gt","","",709,[[["self"],["adtflags"]],["bool"]]],[11,"ge","","",709,[[["self"],["adtflags"]],["bool"]]],[11,"cmp","","",709,[[["self"],["adtflags"]],["ordering"]]],[11,"hash","","",709,N],[11,"fmt","","",709,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",709,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",709,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",709,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",709,[[["self"],["formatter"]],["result"]]],[18,"NO_ADT_FLAGS","","",709,N],[18,"IS_ENUM","","",709,N],[18,"IS_PHANTOM_DATA","","",709,N],[18,"IS_FUNDAMENTAL","","",709,N],[18,"IS_UNION","","",709,N],[18,"IS_BOX","","",709,N],[18,"IS_VARIANT_LIST_NON_EXHAUSTIVE","","Indicates whether the variant list of this ADT is `#[non_exhaustive]`. (i.e., this flag is never set unless this ADT is an enum).",709,N],[11,"empty","","Returns an empty set of flags.",709,[[],["adtflags"]]],[11,"all","","Returns the set containing all flags.",709,[[],["adtflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",709,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",709,[[["u32"]],["option",["adtflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",709,[[["u32"]],["adtflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",709,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",709,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",709,[[["self"],["adtflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",709,[[["self"],["adtflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",709,[[["self"],["adtflags"]]]],[11,"remove","","Removes the specified flags in-place.",709,[[["self"],["adtflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",709,[[["self"],["adtflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",709,[[["self"],["adtflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",709,[[["self"],["adtflags"]],["adtflags"]]],[11,"bitor_assign","","Adds the set of flags.",709,[[["self"],["adtflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",709,[[["self"],["adtflags"]],["adtflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",709,[[["self"],["adtflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",709,[[["self"],["adtflags"]],["adtflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",709,[[["self"],["adtflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",709,[[["self"],["adtflags"]],["adtflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",709,[[["self"],["adtflags"]]]],[11,"not","","Returns the complement of this set of flags.",709,[[["self"]],["adtflags"]]],[11,"extend","","",709,[[["self"],["t"]]]],[11,"from_iter","","",709,[[["t"]],["adtflags"]]],[11,"eq","","",710,[[["self"],["variantflags"]],["bool"]]],[11,"ne","","",710,[[["self"],["variantflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",710,N],[11,"clone","","",710,[[["self"]],["variantflags"]]],[11,"partial_cmp","","",710,[[["self"],["variantflags"]],["option",["ordering"]]]],[11,"lt","","",710,[[["self"],["variantflags"]],["bool"]]],[11,"le","","",710,[[["self"],["variantflags"]],["bool"]]],[11,"gt","","",710,[[["self"],["variantflags"]],["bool"]]],[11,"ge","","",710,[[["self"],["variantflags"]],["bool"]]],[11,"cmp","","",710,[[["self"],["variantflags"]],["ordering"]]],[11,"hash","","",710,N],[11,"fmt","","",710,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",710,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",710,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",710,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",710,[[["self"],["formatter"]],["result"]]],[18,"NO_VARIANT_FLAGS","","",710,N],[18,"IS_FIELD_LIST_NON_EXHAUSTIVE","","Indicates whether the field list of this variant is `#[non_exhaustive]`.",710,N],[11,"empty","","Returns an empty set of flags.",710,[[],["variantflags"]]],[11,"all","","Returns the set containing all flags.",710,[[],["variantflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",710,[[["self"]],["u32"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",710,[[["u32"]],["option",["variantflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",710,[[["u32"]],["variantflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",710,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",710,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",710,[[["self"],["variantflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",710,[[["self"],["variantflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",710,[[["self"],["variantflags"]]]],[11,"remove","","Removes the specified flags in-place.",710,[[["self"],["variantflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",710,[[["self"],["variantflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",710,[[["self"],["variantflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",710,[[["self"],["variantflags"]],["variantflags"]]],[11,"bitor_assign","","Adds the set of flags.",710,[[["self"],["variantflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",710,[[["self"],["variantflags"]],["variantflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",710,[[["self"],["variantflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",710,[[["self"],["variantflags"]],["variantflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",710,[[["self"],["variantflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",710,[[["self"],["variantflags"]],["variantflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",710,[[["self"],["variantflags"]]]],[11,"not","","Returns the complement of this set of flags.",710,[[["self"]],["variantflags"]]],[11,"extend","","",710,[[["self"],["t"]]]],[11,"from_iter","","",710,[[["t"]],["variantflags"]]],[11,"fmt","","",711,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `VariantDef`.",711,[[["tyctxt"],["defid"],["name"],["variantdiscr"],["vec",["fielddef"]],["adtkind"],["ctorkind"]],["self"]]],[11,"is_field_list_non_exhaustive","","",711,[[["self"]],["bool"]]],[11,"hash_stable","","",711,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",734,[[["self"]],["variantdiscr"]]],[11,"fmt","","",734,[[["self"],["formatter"]],["result"]]],[11,"eq","","",734,[[["self"],["variantdiscr"]],["bool"]]],[11,"ne","","",734,[[["self"],["variantdiscr"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",734,N],[11,"encode","","",734,[[["self"],["__s"]],["result"]]],[11,"decode","","",734,[[["__d"]],["result",["variantdiscr"]]]],[11,"fmt","","",712,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",713,[[["self"],["adtdef"]],["option",["ordering"]]]],[11,"cmp","","",713,[[["self"],["adtdef"]],["ordering"]]],[11,"eq","","",713,[[["self"],["self"]],["bool"]]],[11,"hash","","",713,[[["self"],["h"]]]],[11,"hash_stable","","",713,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",735,[[["self"]],["adtkind"]]],[11,"fmt","","",735,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",735,N],[11,"eq","","",735,[[["self"],["adtkind"]],["bool"]]],[11,"hash","","",735,N],[11,"into","","",735,[[["self"]],["datatypekind"]]],[11,"eq","","",714,[[["self"],["reprflags"]],["bool"]]],[11,"ne","","",714,[[["self"],["reprflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",714,N],[11,"clone","","",714,[[["self"]],["reprflags"]]],[11,"partial_cmp","","",714,[[["self"],["reprflags"]],["option",["ordering"]]]],[11,"lt","","",714,[[["self"],["reprflags"]],["bool"]]],[11,"le","","",714,[[["self"],["reprflags"]],["bool"]]],[11,"gt","","",714,[[["self"],["reprflags"]],["bool"]]],[11,"ge","","",714,[[["self"],["reprflags"]],["bool"]]],[11,"cmp","","",714,[[["self"],["reprflags"]],["ordering"]]],[11,"hash","","",714,N],[11,"encode","","",714,[[["self"],["__s"]],["result"]]],[11,"decode","","",714,[[["__d"]],["result",["reprflags"]]]],[11,"default","","",714,[[],["reprflags"]]],[11,"fmt","","",714,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",714,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",714,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",714,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",714,[[["self"],["formatter"]],["result"]]],[18,"IS_C","","",714,N],[18,"IS_SIMD","","",714,N],[18,"IS_TRANSPARENT","","",714,N],[18,"IS_LINEAR","","",714,N],[18,"IS_UNOPTIMISABLE","","",714,N],[11,"empty","","Returns an empty set of flags.",714,[[],["reprflags"]]],[11,"all","","Returns the set containing all flags.",714,[[],["reprflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",714,[[["self"]],["u8"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",714,[[["u8"]],["option",["reprflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",714,[[["u8"]],["reprflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",714,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",714,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",714,[[["self"],["reprflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",714,[[["self"],["reprflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",714,[[["self"],["reprflags"]]]],[11,"remove","","Removes the specified flags in-place.",714,[[["self"],["reprflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",714,[[["self"],["reprflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",714,[[["self"],["reprflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",714,[[["self"],["reprflags"]],["reprflags"]]],[11,"bitor_assign","","Adds the set of flags.",714,[[["self"],["reprflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",714,[[["self"],["reprflags"]],["reprflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",714,[[["self"],["reprflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",714,[[["self"],["reprflags"]],["reprflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",714,[[["self"],["reprflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",714,[[["self"],["reprflags"]],["reprflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",714,[[["self"],["reprflags"]]]],[11,"not","","Returns the complement of this set of flags.",714,[[["self"]],["reprflags"]]],[11,"extend","","",714,[[["self"],["t"]]]],[11,"from_iter","","",714,[[["t"]],["reprflags"]]],[11,"hash_stable","","",714,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",715,[[["self"]],["reproptions"]]],[11,"fmt","","",715,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",715,N],[11,"eq","","",715,[[["self"],["reproptions"]],["bool"]]],[11,"ne","","",715,[[["self"],["reproptions"]],["bool"]]],[11,"encode","","",715,[[["self"],["__s"]],["result"]]],[11,"decode","","",715,[[["__d"]],["result",["reproptions"]]]],[11,"default","","",715,[[],["reproptions"]]],[11,"hash_stable","","",715,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",715,[[["tyctxt"],["defid"]],["reproptions"]]],[11,"simd","","",715,[[["self"]],["bool"]]],[11,"c","","",715,[[["self"]],["bool"]]],[11,"packed","","",715,[[["self"]],["bool"]]],[11,"transparent","","",715,[[["self"]],["bool"]]],[11,"linear","","",715,[[["self"]],["bool"]]],[11,"discr_type","","",715,[[["self"]],["inttype"]]],[11,"inhibit_enum_layout_opt","","Returns true if this `#[repr()]` should inhabit \"smart enum layout\" optimizations, such as representing `Foo<&T>` as a single pointer.",715,[[["self"]],["bool"]]],[11,"inhibit_struct_field_reordering_opt","","Returns true if this `#[repr()]` should inhibit struct field reordering optimizations, such as with repr(C) or repr(packed(1)).",715,[[["self"]],["bool"]]],[11,"new","","",713,[[["tyctxt"],["defid"],["adtkind"],["vec",["variantdef"]],["reproptions"]],["self"]]],[11,"is_struct","","",713,[[["self"]],["bool"]]],[11,"is_union","","",713,[[["self"]],["bool"]]],[11,"is_enum","","",713,[[["self"]],["bool"]]],[11,"is_variant_list_non_exhaustive","","",713,[[["self"]],["bool"]]],[11,"adt_kind","","Returns the kind of the ADT - Struct or Enum.",713,[[["self"]],["adtkind"]]],[11,"descr","","",713,[[["self"]],["str"]]],[11,"variant_descr","","",713,[[["self"]],["str"]]],[11,"is_fundamental","","Returns whether this type is #[fundamental] for the purposes of coherence checking.",713,[[["self"]],["bool"]]],[11,"is_phantom_data","","Returns true if this is PhantomData.",713,[[["self"]],["bool"]]],[11,"is_box","","Returns true if this is Box.",713,[[["self"]],["bool"]]],[11,"has_dtor","","Returns whether this type has a destructor.",713,[[["self"],["tyctxt"]],["bool"]]],[11,"non_enum_variant","","Asserts this is a struct or union and returns its unique variant.",713,[[["self"]],["variantdef"]]],[11,"predicates","","",713,[[["self"],["tyctxt"]],["genericpredicates"]]],[11,"all_fields","","Returns an iterator over all fields contained by this ADT.",713,N],[11,"is_payloadfree","","",713,[[["self"]],["bool"]]],[11,"variant_with_id","","",713,[[["self"],["defid"]],["variantdef"]]],[11,"variant_index_with_id","","",713,[[["self"],["defid"]],["usize"]]],[11,"variant_of_def","","",713,[[["self"],["def"]],["variantdef"]]],[11,"eval_explicit_discr","","",713,[[["self"],["tyctxt"],["defid"]],["option",["discr"]]]],[11,"discriminants","","",713,N],[11,"discriminant_for_variant","","Compute the discriminant value used by a specific variant. Unlike `discriminants`, this is (amortized) constant-time, only doing at most one query for evaluating an explicit discriminant (the last one before the requested variant), assuming there are no constant-evaluation errors there.",713,[[["self"],["tyctxt"],["usize"]],["discr"]]],[11,"discriminant_def_for_variant","","Yields a DefId for the discriminant and an offset to add to it Alternatively, if there is no explicit discriminant, returns the inferred discriminant directly",713,N],[11,"destructor","","",713,[[["self"],["tyctxt"]],["option",["destructor"]]]],[11,"sized_constraint","","Returns a list of types such that `Self: Sized` if and only if that type is Sized, or `TyErr` if this type is recursive.",713,N],[11,"sized_constraint_for_ty","","",713,[[["self"],["tyctxt"],["ty"]],["vec",["ty"]]]],[11,"ty","","",712,[[["self"],["tyctxt"],["substs"]],["ty"]]],[11,"clone","","",736,[[["self"]],["closurekind"]]],[11,"partial_cmp","","",736,[[["self"],["closurekind"]],["option",["ordering"]]]],[11,"cmp","","",736,[[["self"],["closurekind"]],["ordering"]]],[11,"eq","","",736,[[["self"],["closurekind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",736,N],[11,"hash","","",736,N],[11,"fmt","","",736,[[["self"],["formatter"]],["result"]]],[11,"encode","","",736,[[["self"],["__s"]],["result"]]],[11,"decode","","",736,[[["__d"]],["result",["closurekind"]]]],[18,"LATTICE_BOTTOM","","",736,N],[11,"trait_did","","",736,[[["self"],["tyctxt"]],["defid"]]],[11,"extends","","True if this a type that impls this closure kind must also implement `other`.",736,[[["self"],["closurekind"]],["bool"]]],[11,"to_ty","","Returns the representative scalar type for this closure kind. See `TyS::to_opt_closure_kind` for more details.",736,[[["self"],["tyctxt"]],["ty"]]],[11,"walk","","Iterator that walks `self` and any types reachable from `self`, in depth-first order. Note that just walks the types that appear in `self`, it does not descend into the fields of structs or variants. For example:",689,[[["self"]],["typewalker"]]],[11,"walk_shallow","","Iterator that walks the immediate children of `self`.  Hence `Foo<Bar<i32>, u32>` yields the sequence `[Bar<i32>, u32]` (but not `i32`, like `walk`).",689,[[["self"]],["intoiter",["typewalkerarray"]]]],[11,"maybe_walk","","Walks `ty` and any types appearing within `ty`, invoking the callback `f` on each type. If the callback returns false, then the children of the current type are ignored.",689,[[["self"],["f"]]]],[11,"from_mutbl","","",729,[[["mutability"]],["borrowkind"]]],[11,"to_mutbl_lossy","","Returns a mutability `m` such that an `&m T` pointer could be used to obtain this borrow kind. Because borrow kinds are richer than mutabilities, we sometimes have to pick a mutability that is stronger than necessary so that it at least would permit the borrow in question.",729,[[["self"]],["mutability"]]],[11,"to_user_str","","",729,[[["self"]],["str"]]],[11,"fmt","","",737,[[["self"],["formatter"]],["result"]]],[11,"clone","","",737,[[["self"]],["attributes"]]],[11,"deref","","",737,N],[11,"body_tables","","",677,[[["self"],["bodyid"]],["typecktables"]]],[11,"body_owners","","Returns an iterator of the def-ids for all body-owners in this crate. If you would prefer to iterate over the bodies themselves, you can do `self.hir.krate().body_ids.iter()`.",677,N],[11,"par_body_owners","","",677,[[["self"],["f"]]]],[11,"expr_span","","",677,[[["self"],["nodeid"]],["span"]]],[11,"provided_trait_methods","","",677,[[["self"],["defid"]],["vec",["associateditem"]]]],[11,"trait_relevant_for_never","","",677,[[["self"],["defid"]],["bool"]]],[11,"opt_associated_item","","",677,[[["self"],["defid"]],["option",["associateditem"]]]],[11,"associated_item_from_trait_item_ref","","",677,[[["self"],["defid"],["visibility"],["traititemref"]],["associateditem"]]],[11,"associated_item_from_impl_item_ref","","",677,[[["self"],["defid"],["implitemref"]],["associateditem"]]],[11,"field_index","","",677,[[["self"],["nodeid"],["typecktables"]],["usize"]]],[11,"find_field_index","","",677,[[["self"],["ident"],["variantdef"]],["option",["usize"]]]],[11,"associated_items","","",677,N],[11,"impls_are_allowed_to_overlap","","Returns true if the impls are the same polarity and are implementing a trait which contains no items",677,[[["self"],["defid"],["defid"]],["bool"]]],[11,"expect_variant_def","","",677,[[["self"],["def"]],["variantdef"]]],[11,"adt_def_id_of_variant","","Given a `VariantDef`, returns the def-id of the `AdtDef` of which it is a part.",677,[[["self"],["variantdef"]],["defid"]]],[11,"item_name","","",677,[[["self"],["defid"]],["internedstring"]]],[11,"instance_mir","","Return the possibly-auto-generated MIR of a (DefId, Subst) pair.",677,[[["self"],["instancedef"]],["mir"]]],[11,"maybe_optimized_mir","","Given the DefId of an item, returns its MIR, borrowed immutably. Returns None if there is no MIR for the DefId",677,[[["self"],["defid"]],["option",["mir"]]]],[11,"get_attrs","","Get the attributes of a definition.",677,[[["self"],["defid"]],["attributes"]]],[11,"has_attr","","Determine whether an item is annotated with an attribute",677,[[["self"],["defid"],["str"]],["bool"]]],[11,"trait_is_auto","","Returns true if this is an `auto trait`.",677,[[["self"],["defid"]],["bool"]]],[11,"generator_layout","","",677,[[["self"],["defid"]],["generatorlayout"]]],[11,"trait_id_of_impl","","Given the def_id of an impl, return the def_id of the trait it implements. If it implements no trait, return `None`.",677,[[["self"],["defid"]],["option",["defid"]]]],[11,"impl_of_method","","If the given def ID describes a method belonging to an impl, return the ID of the impl that the method belongs to. Otherwise, return `None`.",677,[[["self"],["defid"]],["option",["defid"]]]],[11,"span_of_impl","","Looks up the span of `impl_did` if the impl is local; otherwise returns `Err` with the name of the crate containing the impl.",677,[[["self"],["defid"]],["result",["span","symbol"]]]],[11,"hygienic_eq","","",677,[[["self"],["ident"],["ident"],["defid"]],["bool"]]],[11,"adjust_ident","","",677,N],[11,"with_freevars","","",677,[[["self"],["nodeid"],["f"]],["t"]]],[11,"clone","","",716,[[["self"]],["crateinherentimpls"]]],[11,"fmt","","",716,[[["self"],["formatter"]],["result"]]],[11,"clone","","",717,[[["self"]],["symbolname"]]],[11,"eq","","",717,[[["self"],["symbolname"]],["bool"]]],[11,"ne","","",717,[[["self"],["symbolname"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",717,N],[11,"partial_cmp","","",717,[[["self"],["symbolname"]],["option",["ordering"]]]],[11,"lt","","",717,[[["self"],["symbolname"]],["bool"]]],[11,"le","","",717,[[["self"],["symbolname"]],["bool"]]],[11,"gt","","",717,[[["self"],["symbolname"]],["bool"]]],[11,"ge","","",717,[[["self"],["symbolname"]],["bool"]]],[11,"cmp","","",717,[[["self"],["symbolname"]],["ordering"]]],[11,"encode","","",717,[[["self"],["__s"]],["result"]]],[11,"decode","","",717,[[["__d"]],["result",["symbolname"]]]],[11,"hash_stable","","",717,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",717,[[["str"]],["symbolname"]]],[11,"as_str","","",717,[[["self"]],["localinternedstring"]]],[11,"fmt","","",717,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",717,[[["self"],["formatter"]],["result"]]],[0,"util","rustc","",N,N],[0,"captures","rustc::util","",N,N],[8,"Captures","rustc::util::captures","\"Signaling\" trait used in impl trait to tag lifetimes that you may need to capture but don't really need for other reasons. Basically a workaround; see [this comment] for details.",N,N],[0,"common","rustc::util","",N,N],[3,"ErrorReported","rustc::util::common","",N,N],[3,"DEFAULT_HOOK","","",N,N],[12,"__private_field","","",1039,N],[3,"ProfQDumpParams","","Parameters to the `Dump` variant of type `ProfileQueriesMsg`.",N,N],[12,"path","","A base path for the files we will dump",1040,N],[12,"ack","","To ensure that the compiler waits for us to finish our dumps",1040,N],[12,"dump_profq_msg_log","","toggle dumping a log file with every `ProfileQueriesMsg`",1040,N],[3,"QueryMsg","","",N,N],[12,"query","","",1041,N],[12,"msg","","",1041,N],[3,"Indenter","","",N,N],[12,"_cannot_construct_outside_of_this_module","","",1042,N],[4,"ProfileQueriesMsg","","A sequence of these messages induce a trace of query-based incremental compilation. FIXME(matthewhammer): Determine whether we should include cycle detection here or not.",N,N],[13,"TimeBegin","","begin a timed pass",1043,N],[13,"TimeEnd","","end a timed pass",1043,N],[13,"TaskBegin","","begin a task (see dep_graph::graph::with_task)",1043,N],[13,"TaskEnd","","end a task",1043,N],[13,"QueryBegin","","begin a new query can't use `Span` because queries are sent to other thread",1043,N],[13,"CacheHit","","query is satisfied by using an already-known value for the given key",1043,N],[13,"ProviderBegin","","query requires running a provider; providers may nest, permitting queries to nest.",1043,N],[13,"ProviderEnd","","query is satisfied by a provider terminating with a value",1043,N],[13,"Dump","","dump a record of the queries to the given path",1043,N],[13,"Halt","","halt the profiling/monitoring background thread",1043,N],[5,"panic_hook","","",N,[[["panicinfo"]]]],[5,"install_panic_hook","","",N,[[]]],[5,"profq_msg","","If enabled, send a message to the profile-queries thread",N,[[["session"],["profilequeriesmsg"]]]],[5,"profq_set_chan","","Set channel for profile queries channel",N,[[["session"],["sender",["profilequeriesmsg"]]],["bool"]]],[5,"time_depth","","Read the current depth of `time()` calls. This is used to encourage indentation across threads.",N,[[],["usize"]]],[5,"set_time_depth","","Set the current depth of `time()` calls. The idea is to call `set_time_depth()` with the result from `time_depth()` in the parent thread.",N,[[["usize"]]]],[5,"time","","",N,[[["session"],["str"],["f"]],["t"]]],[5,"time_ext","","",N,[[["bool"],["option",["session"]],["str"],["f"]],["t"]]],[5,"print_time_passes_entry","","",N,[[["bool"],["str"],["duration"]]]],[5,"print_time_passes_entry_internal","","",N,[[["str"],["duration"]]]],[5,"duration_to_secs_str","","",N,[[["duration"]],["string"]]],[5,"to_readable_str","","",N,[[["usize"]],["string"]]],[5,"record_time","","",N,[[["lock"],["f"]],["t"]]],[5,"get_resident","","",N,[[],["option",["usize"]]]],[5,"indent","","",N,[[["f"]],["r"]]],[5,"indenter","","",N,[[],["indenter"]]],[7,"DEFAULT_HOOK","","",N,N],[17,"FN_OUTPUT_NAME","","",N,N],[17,"TIME_DEPTH","","",N,N],[8,"MemoizationMap","","",N,N],[16,"Key","","",1044,N],[16,"Value","","",1044,N],[10,"memoize","","If `key` is present in the map, return the value, otherwise invoke `op` and store the value in the map.",1044,N],[11,"clone","","",1045,[[["self"]],["errorreported"]]],[11,"fmt","","",1045,[[["self"],["formatter"]],["result"]]],[11,"encode","","",1045,[[["self"],["__s"]],["result"]]],[11,"decode","","",1045,[[["__d"]],["result",["errorreported"]]]],[11,"deref","","",1039,[[["self"]],["box"]]],[11,"initialize","","",1039,[[["self"]]]],[11,"clone","","",1040,[[["self"]],["profqdumpparams"]]],[11,"fmt","","",1040,[[["self"],["formatter"]],["result"]]],[11,"clone","","",1041,[[["self"]],["querymsg"]]],[11,"fmt","","",1041,[[["self"],["formatter"]],["result"]]],[11,"eq","","",1041,[[["self"],["querymsg"]],["bool"]]],[11,"ne","","",1041,[[["self"],["querymsg"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1041,N],[11,"clone","","",1043,[[["self"]],["profilequeriesmsg"]]],[11,"fmt","","",1043,[[["self"],["formatter"]],["result"]]],[11,"drop","","",1042,[[["self"]]]],[0,"ppaux","rustc::util","",N,N],[3,"LateBoundRegionNameCollector","rustc::util::ppaux","",N,N],[12,"0","","",1046,N],[3,"PrintContext","","",N,N],[12,"is_debug","","",1047,N],[12,"is_verbose","","",1047,N],[12,"identify_regions","","",1047,N],[12,"used_region_names","","",1047,N],[12,"region_index","","",1047,N],[12,"binder_depth","","",1047,N],[5,"verbose","","",N,[[],["bool"]]],[5,"identify_regions","","",N,[[],["bool"]]],[5,"parameterized","","",N,N],[5,"get_highlight_region","","",N,[[],["option"]]],[5,"with_highlight_region","","",N,N],[17,"HIGHLIGHT_REGION","","Mechanism for highlighting of specific regions for display in NLL region inference errors. Contains region to highlight and counter for number to use when highlighting.",N,N],[8,"Print","","",N,N],[10,"print","","",1048,[[["self"],["f"],["printcontext"]],["result"]]],[11,"print_to_string","","",1048,[[["self"],["printcontext"]],["string"]]],[11,"print_display","","",1048,[[["self"],["f"],["printcontext"]],["result"]]],[11,"print_display_to_string","","",1048,[[["self"],["printcontext"]],["string"]]],[11,"print_debug","","",1048,[[["self"],["f"],["printcontext"]],["result"]]],[11,"print_debug_to_string","","",1048,[[["self"],["printcontext"]],["string"]]],[11,"visit_region","","",1046,[[["self"],["region"]],["bool"]]],[11,"fmt","","",1047,[[["self"],["formatter"]],["result"]]],[11,"new","","",1047,[[],["self"]]],[11,"prepare_late_bound_region_info","","",1047,[[["self"],["binder"]]]],[11,"fn_sig","","",1047,N],[11,"parameterized","","",1047,N],[11,"in_binder","","",1047,[[["self"],["f"],["tyctxt"],["binder"],["option",["binder"]]],["result"]]],[11,"is_name_used","","",1047,[[["self"],["internedstring"]],["bool"]]],[11,"fmt","rustc::ty","",695,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustc::ty::trait_def","",1005,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustc::ty","",713,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",693,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",691,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",692,[[["self"],["formatter"]],["result"]]],[11,"print","","",666,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",666,[[["self"],["formatter"]],["result"]]],[11,"print","","",668,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",668,[[["self"],["formatter"]],["result"]]],[11,"print","rustc::ty::adjustment","",739,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",739,[[["self"],["formatter"]],["result"]]],[11,"print","rustc::ty","",722,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",722,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",722,[[["self"],["formatter"]],["result"]]],[11,"print","","",723,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",723,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",723,[[["self"],["formatter"]],["result"]]],[11,"print","","",672,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",672,[[["self"],["formatter"]],["result"]]],[11,"print","","",728,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",728,[[["self"],["formatter"]],["result"]]],[11,"print","","",698,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",698,[[["self"],["formatter"]],["result"]]],[11,"print","","",704,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",704,[[["self"],["formatter"]],["result"]]],[11,"print","","",660,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",660,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",660,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",673,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",674,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",675,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",676,[[["self"],["formatter"]],["result"]]],[11,"print","","",718,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",718,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",718,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",731,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",694,[[["self"],["formatter"]],["result"]]],[11,"print","","",657,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",657,[[["self"],["formatter"]],["result"]]],[11,"print","","",657,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",657,[[["self"],["formatter"]],["result"]]],[11,"print","","",657,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",657,[[["self"],["formatter"]],["result"]]],[11,"print","","",657,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",657,[[["self"],["formatter"]],["result"]]],[11,"print","","",657,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",657,[[["self"],["formatter"]],["result"]]],[11,"print","","",657,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",657,[[["self"],["formatter"]],["result"]]],[11,"print","","",657,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",657,[[["self"],["formatter"]],["result"]]],[11,"print","","",657,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",657,[[["self"],["formatter"]],["result"]]],[11,"print","","",667,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",667,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",667,[[["self"],["formatter"]],["result"]]],[11,"print","","",721,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",721,[[["self"],["formatter"]],["result"]]],[11,"print","","",689,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",689,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",689,[[["self"],["formatter"]],["result"]]],[11,"print","","",662,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",662,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",662,[[["self"],["formatter"]],["result"]]],[11,"print","","",701,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",701,[[["self"],["formatter"]],["result"]]],[11,"print","","",702,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",702,[[["self"],["formatter"]],["result"]]],[11,"print","","",700,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",700,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",700,[[["self"],["formatter"]],["result"]]],[11,"print","","",703,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",703,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",703,[[["self"],["formatter"]],["result"]]],[11,"print","","",663,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",663,[[["self"],["formatter"]],["result"]]],[11,"print","","",736,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",736,[[["self"],["formatter"]],["result"]]],[11,"print","","",733,[[["self"],["f"],["printcontext"]],["result"]]],[11,"fmt","","",733,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",733,[[["self"],["formatter"]],["result"]]],[0,"nodemap","rustc::util","An efficient hash map for node IDs",N,N],[6,"FxHashMap","rustc::util::nodemap","Type alias for a hashmap using the `fx` hash algorithm.",N,N],[5,"FxHashMap","","",N,[[],["hashmap",["buildhasherdefault"]]]],[6,"FxHashSet","","Type alias for a hashmap using the `fx` hash algorithm.",N,N],[5,"FxHashSet","","",N,[[],["hashset",["buildhasherdefault"]]]],[5,"NodeMap","","",N,[[],["nodemap"]]],[5,"NodeSet","","",N,[[],["nodeset"]]],[5,"DefIdMap","","",N,[[],["defidmap"]]],[5,"DefIdSet","","",N,[[],["defidset"]]],[5,"HirIdMap","","",N,[[],["hiridmap"]]],[5,"HirIdSet","","",N,[[],["hiridset"]]],[5,"ItemLocalMap","","",N,[[],["itemlocalmap"]]],[5,"ItemLocalSet","","",N,[[],["itemlocalset"]]],[6,"NodeMap","","",N,N],[6,"NodeSet","","",N,N],[6,"DefIdMap","","",N,N],[6,"DefIdSet","","",N,N],[6,"HirIdMap","","",N,N],[6,"HirIdSet","","",N,N],[6,"ItemLocalMap","","",N,N],[6,"ItemLocalSet","","",N,N],[0,"time_graph","rustc::util","",N,N],[3,"Timing","rustc::util::time_graph","",N,N],[12,"start","","",1049,N],[12,"end","","",1049,N],[12,"work_package_kind","","",1049,N],[12,"name","","",1049,N],[12,"events","","",1049,N],[3,"TimelineId","","",N,N],[12,"0","","",1050,N],[3,"PerThread","","",N,N],[12,"timings","","",1051,N],[12,"open_work_package","","",1051,N],[3,"TimeGraph","","",N,N],[12,"data","","",1052,N],[3,"WorkPackageKind","","",N,N],[12,"0","","",1053,N],[3,"Timeline","","",N,N],[12,"token","","",1054,N],[3,"RaiiToken","","",N,N],[12,"graph","","",1055,N],[12,"timeline","","",1055,N],[12,"events","","",1055,N],[12,"_marker","","",1055,N],[5,"distance","","",N,[[["instant"],["instant"]],["u64"]]],[5,"normalize","","",N,[[["u64"],["u64"],["u64"]],["u64"]]],[17,"OUTPUT_WIDTH_IN_PX","","",N,N],[17,"TIME_LINE_HEIGHT_IN_PX","","",N,N],[17,"TIME_LINE_HEIGHT_STRIDE_IN_PX","","",N,N],[11,"clone","","",1049,[[["self"]],["timing"]]],[11,"clone","","",1050,[[["self"]],["timelineid"]]],[11,"hash","","",1050,N],[11,"assert_receiver_is_total_eq","","",1050,N],[11,"eq","","",1050,[[["self"],["timelineid"]],["bool"]]],[11,"ne","","",1050,[[["self"],["timelineid"]],["bool"]]],[11,"fmt","","",1050,[[["self"],["formatter"]],["result"]]],[11,"clone","","",1051,[[["self"]],["perthread"]]],[11,"clone","","",1052,[[["self"]],["timegraph"]]],[11,"clone","","",1053,[[["self"]],["workpackagekind"]]],[11,"drop","","",1055,[[["self"]]]],[11,"new","","",1052,[[],["timegraph"]]],[11,"start","","",1052,[[["self"],["timelineid"],["workpackagekind"],["str"]],["timeline"]]],[11,"end","","",1052,[[["self"],["timelineid"],["vec"]]]],[11,"dump","","",1052,[[["self"],["str"]]]],[11,"noop","","",1054,[[],["timeline"]]],[11,"record","","Record an event which happened at this moment on this timeline.",1054,[[["self"],["str"]]]],[0,"profiling","rustc::util","",N,N],[3,"Categories","rustc::util::profiling","",N,N],[12,"Parsing","","",1056,N],[12,"Expansion","","",1056,N],[12,"TypeChecking","","",1056,N],[12,"BorrowChecking","","",1056,N],[12,"Codegen","","",1056,N],[12,"Linking","","",1056,N],[12,"Other","","",1056,N],[3,"CategoryData","","",N,N],[12,"times","","",1057,N],[12,"query_counts","","",1057,N],[3,"SelfProfiler","","",N,N],[12,"timer_stack","","",1058,N],[12,"data","","",1058,N],[12,"current_timer","","",1058,N],[4,"ProfileCategory","","",N,N],[13,"Parsing","","",1059,N],[13,"Expansion","","",1059,N],[13,"TypeChecking","","",1059,N],[13,"BorrowChecking","","",1059,N],[13,"Codegen","","",1059,N],[13,"Linking","","",1059,N],[13,"Other","","",1059,N],[11,"clone","","",1059,[[["self"]],["profilecategory"]]],[11,"fmt","","",1059,[[["self"],["formatter"]],["result"]]],[11,"eq","","",1059,[[["self"],["profilecategory"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1059,N],[11,"new","","",1056,[[],["categories"]]],[11,"get","","",1056,[[["self"],["profilecategory"]],["t"]]],[11,"set","","",1056,[[["self"],["profilecategory"],["t"]]]],[11,"new","","",1057,[[],["categorydata"]]],[11,"print","","",1057,[[["self"],["stdoutlock"]]]],[11,"json","","",1057,[[["self"]],["string"]]],[11,"new","","",1058,[[],["selfprofiler"]]],[11,"start_activity","","",1058,[[["self"],["profilecategory"]]]],[11,"record_query","","",1058,[[["self"],["profilecategory"]]]],[11,"record_query_hit","","",1058,[[["self"],["profilecategory"]]]],[11,"end_activity","","",1058,[[["self"],["profilecategory"]]]],[11,"stop_timer","","",1058,[[["self"]],["u64"]]],[11,"print_results","","",1058,[[["self"],["options"]]]],[11,"save_results","","",1058,[[["self"],["options"]]]],[0,"bug","rustc::util","",N,N],[5,"bug_fmt","rustc::util::bug","",N,N],[5,"span_bug_fmt","","",N,N],[5,"opt_span_bug_fmt","","",N,N],[0,"rustc","rustc","",N,N],[17,"DIAGNOSTICS","","",N,N],[14,"bug","","",N,N],[14,"span_bug","","",N,N],[14,"__impl_stable_hash_field","","",N,N],[14,"impl_stable_hash_for","","",N,N],[14,"impl_stable_hash_for_spanned","","",N,N],[14,"CloneLiftImpls","","",N,N],[14,"CloneTypeFoldableImpls","","Used for types that are `Copy` and which do not care arena allocated data (i.e., don't need to be folded).",N,N],[14,"CloneTypeFoldableAndLiftImpls","","",N,N],[14,"BraceStructLiftImpl","","",N,N],[14,"EnumLiftImpl","","",N,N],[14,"BraceStructTypeFoldableImpl","","",N,N],[14,"TupleStructTypeFoldableImpl","","",N,N],[14,"EnumTypeFoldableImpl","","",N,N],[14,"declare_lint","","Declare a static item of type `&'static Lint`.",N,N],[14,"declare_tool_lint","","",N,N],[14,"lint_array","","Declare a static `LintArray` and return it as an expression.",N,N],[14,"late_lint_methods","","",N,N],[14,"expand_combined_late_lint_pass_method","","",N,N],[14,"expand_combined_late_lint_pass_methods","","",N,N],[14,"declare_combined_late_lint_pass","","",N,N],[14,"err","","",N,N],[14,"__impl_decoder_methods","","",N,N],[14,"implement_ty_decoder","","",N,N],[11,"from_ok","rustc::cfg","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::cfg::construct","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::cfg::graphviz","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::dep_graph","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"encode","","",9,[[["self"],["e"]],["result"]]],[11,"decode","","",9,[[["d"]],["result"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"encode","","",10,[[["self"],["e"]],["result"]]],[11,"decode","","",10,[[["d"]],["result"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]],[11,"to_owned","","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]],[11,"to_owned","","",12,[[["self"]],["t"]]],[11,"clone_into","","",12,N],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"encode","","",12,[[["self"],["e"]],["result"]]],[11,"decode","","",12,[[["d"]],["result"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",13,[[["t"]],["t"]]],[11,"map_same","","",13,[[["self"],["f"]],["t"]]],[11,"to_owned","","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"encode","","",13,[[["self"],["e"]],["result"]]],[11,"decode","","",13,[[["d"]],["result"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from_ok","","",14,[[["t"]],["t"]]],[11,"map_same","","",14,[[["self"],["f"]],["t"]]],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"encode","","",14,[[["self"],["e"]],["result"]]],[11,"decode","","",14,[[["d"]],["result"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from_ok","","",15,[[["t"]],["t"]]],[11,"map_same","","",15,[[["self"],["f"]],["t"]]],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from_ok","","",16,[[["t"]],["t"]]],[11,"map_same","","",16,[[["self"],["f"]],["t"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from_ok","","",17,[[["t"]],["t"]]],[11,"map_same","","",17,[[["self"],["f"]],["t"]]],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"encode","","",17,[[["self"],["e"]],["result"]]],[11,"decode","","",17,[[["d"]],["result"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from_ok","","",18,[[["t"]],["t"]]],[11,"map_same","","",18,[[["self"],["f"]],["t"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"encode","","",18,[[["self"],["e"]],["result"]]],[11,"decode","","",18,[[["d"]],["result"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from_ok","","",19,[[["t"]],["t"]]],[11,"map_same","","",19,[[["self"],["f"]],["t"]]],[11,"to_owned","","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"encode","","",19,[[["self"],["e"]],["result"]]],[11,"decode","","",19,[[["d"]],["result"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"from_ok","","",20,[[["t"]],["t"]]],[11,"map_same","","",20,[[["self"],["f"]],["t"]]],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from_ok","","",21,[[["t"]],["t"]]],[11,"map_same","","",21,[[["self"],["f"]],["t"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from_ok","","",22,[[["t"]],["t"]]],[11,"map_same","","",22,[[["self"],["f"]],["t"]]],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from_ok","","",23,[[["t"]],["t"]]],[11,"map_same","","",23,[[["self"],["f"]],["t"]]],[11,"to_owned","","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"encode","","",23,[[["self"],["e"]],["result"]]],[11,"decode","","",23,[[["d"]],["result"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::dep_graph::debug","",24,[[["t"]],["t"]]],[11,"map_same","","",24,[[["self"],["f"]],["t"]]],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"from_ok","","",25,[[["t"]],["t"]]],[11,"map_same","","",25,[[["self"],["f"]],["t"]]],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"to_dep_node","rustc::hir::map::definitions","",189,[[["self"],["depkind"]],["depnode"]]],[11,"to_dep_node","rustc::hir::def_id","",150,[[["self"],["tyctxt"],["depkind"]],["depnode"]]],[11,"to_fingerprint","","",150,[[["self"],["tyctxt"]],["fingerprint"]]],[11,"to_debug_str","","",150,[[["self"],["tyctxt"]],["string"]]],[11,"to_fingerprint","","",149,[[["self"],["tyctxt"]],["fingerprint"]]],[11,"to_debug_str","","",149,[[["self"],["tyctxt"]],["string"]]],[11,"to_fingerprint","","",152,[[["self"],["tyctxt"]],["fingerprint"]]],[11,"to_debug_str","","",152,[[["self"],["tyctxt"]],["string"]]],[11,"to_fingerprint","rustc::hir","",33,[[["self"],["tyctxt"]],["fingerprint"]]],[11,"from_ok","rustc::dep_graph::graph","",28,[[["t"]],["t"]]],[11,"map_same","","",28,[[["self"],["f"]],["t"]]],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from_ok","","",29,[[["t"]],["t"]]],[11,"map_same","","",29,[[["self"],["f"]],["t"]]],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from_ok","","",30,[[["t"]],["t"]]],[11,"map_same","","",30,[[["self"],["f"]],["t"]]],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"from_ok","","",31,[[["t"]],["t"]]],[11,"map_same","","",31,[[["self"],["f"]],["t"]]],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"from_ok","","",32,[[["t"]],["t"]]],[11,"map_same","","",32,[[["self"],["f"]],["t"]]],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir","",33,[[["t"]],["t"]]],[11,"map_same","","",33,[[["self"],["f"]],["t"]]],[11,"to_owned","","",33,[[["self"]],["t"]]],[11,"clone_into","","",33,N],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"encode","","",33,[[["self"],["e"]],["result"]]],[11,"decode","","",33,[[["d"]],["result"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from_ok","","",34,[[["t"]],["t"]]],[11,"map_same","","",34,[[["self"],["f"]],["t"]]],[11,"to_owned","","",34,[[["self"]],["t"]]],[11,"clone_into","","",34,N],[11,"from","","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"encode","","",34,[[["self"],["e"]],["result"]]],[11,"decode","","",34,[[["d"]],["result"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"from_ok","","",35,[[["t"]],["t"]]],[11,"map_same","","",35,[[["self"],["f"]],["t"]]],[11,"to_owned","","",35,[[["self"]],["t"]]],[11,"clone_into","","",35,N],[11,"from","","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"encode","","",35,[[["self"],["e"]],["result"]]],[11,"decode","","",35,[[["d"]],["result"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"from_ok","","",36,[[["t"]],["t"]]],[11,"map_same","","",36,[[["self"],["f"]],["t"]]],[11,"to_owned","","",36,[[["self"]],["t"]]],[11,"clone_into","","",36,N],[11,"from","","",36,[[["t"]],["t"]]],[11,"to_string","","",36,[[["self"]],["string"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"encode","","",36,[[["self"],["e"]],["result"]]],[11,"decode","","",36,[[["d"]],["result"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"from_ok","","",37,[[["t"]],["t"]]],[11,"map_same","","",37,[[["self"],["f"]],["t"]]],[11,"to_owned","","",37,[[["self"]],["t"]]],[11,"clone_into","","",37,N],[11,"from","","",37,[[["t"]],["t"]]],[11,"to_string","","",37,[[["self"]],["string"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"encode","","",37,[[["self"],["e"]],["result"]]],[11,"decode","","",37,[[["d"]],["result"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"from_ok","","",38,[[["t"]],["t"]]],[11,"map_same","","",38,[[["self"],["f"]],["t"]]],[11,"to_owned","","",38,[[["self"]],["t"]]],[11,"clone_into","","",38,N],[11,"from","","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"encode","","",38,[[["self"],["e"]],["result"]]],[11,"decode","","",38,[[["d"]],["result"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"from_ok","","",39,[[["t"]],["t"]]],[11,"map_same","","",39,[[["self"],["f"]],["t"]]],[11,"to_owned","","",39,[[["self"]],["t"]]],[11,"clone_into","","",39,N],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"encode","","",39,[[["self"],["e"]],["result"]]],[11,"decode","","",39,[[["d"]],["result"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"from_ok","","",40,[[["t"]],["t"]]],[11,"map_same","","",40,[[["self"],["f"]],["t"]]],[11,"to_owned","","",40,[[["self"]],["t"]]],[11,"clone_into","","",40,N],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"encode","","",40,[[["self"],["e"]],["result"]]],[11,"decode","","",40,[[["d"]],["result"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from_ok","","",41,[[["t"]],["t"]]],[11,"map_same","","",41,[[["self"],["f"]],["t"]]],[11,"from","","",41,[[["t"]],["t"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"not_found","","",41,[[["str"],["str"]],["e"]]],[11,"from_ok","","",42,[[["t"]],["t"]]],[11,"map_same","","",42,[[["self"],["f"]],["t"]]],[11,"to_owned","","",42,[[["self"]],["t"]]],[11,"clone_into","","",42,N],[11,"from","","",42,[[["t"]],["t"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"encode","","",42,[[["self"],["e"]],["result"]]],[11,"decode","","",42,[[["d"]],["result"]]],[11,"not_found","","",42,[[["str"],["str"]],["e"]]],[11,"from_ok","","",43,[[["t"]],["t"]]],[11,"map_same","","",43,[[["self"],["f"]],["t"]]],[11,"to_owned","","",43,[[["self"]],["t"]]],[11,"clone_into","","",43,N],[11,"from","","",43,[[["t"]],["t"]]],[11,"into","","",43,[[["self"]],["u"]]],[11,"try_from","","",43,[[["u"]],["result"]]],[11,"borrow","","",43,[[["self"]],["t"]]],[11,"try_into","","",43,[[["self"]],["result"]]],[11,"borrow_mut","","",43,[[["self"]],["t"]]],[11,"get_type_id","","",43,[[["self"]],["typeid"]]],[11,"encode","","",43,[[["self"],["e"]],["result"]]],[11,"decode","","",43,[[["d"]],["result"]]],[11,"not_found","","",43,[[["str"],["str"]],["e"]]],[11,"from_ok","","",44,[[["t"]],["t"]]],[11,"map_same","","",44,[[["self"],["f"]],["t"]]],[11,"to_owned","","",44,[[["self"]],["t"]]],[11,"clone_into","","",44,N],[11,"from","","",44,[[["t"]],["t"]]],[11,"into","","",44,[[["self"]],["u"]]],[11,"try_from","","",44,[[["u"]],["result"]]],[11,"borrow","","",44,[[["self"]],["t"]]],[11,"try_into","","",44,[[["self"]],["result"]]],[11,"borrow_mut","","",44,[[["self"]],["t"]]],[11,"get_type_id","","",44,[[["self"]],["typeid"]]],[11,"encode","","",44,[[["self"],["e"]],["result"]]],[11,"decode","","",44,[[["d"]],["result"]]],[11,"not_found","","",44,[[["str"],["str"]],["e"]]],[11,"from_ok","","",45,[[["t"]],["t"]]],[11,"map_same","","",45,[[["self"],["f"]],["t"]]],[11,"to_owned","","",45,[[["self"]],["t"]]],[11,"clone_into","","",45,N],[11,"from","","",45,[[["t"]],["t"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"encode","","",45,[[["self"],["e"]],["result"]]],[11,"decode","","",45,[[["d"]],["result"]]],[11,"not_found","","",45,[[["str"],["str"]],["e"]]],[11,"from_ok","","",46,[[["t"]],["t"]]],[11,"map_same","","",46,[[["self"],["f"]],["t"]]],[11,"to_owned","","",46,[[["self"]],["t"]]],[11,"clone_into","","",46,N],[11,"from","","",46,[[["t"]],["t"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"encode","","",46,[[["self"],["e"]],["result"]]],[11,"decode","","",46,[[["d"]],["result"]]],[11,"not_found","","",46,[[["str"],["str"]],["e"]]],[11,"from_ok","","",47,[[["t"]],["t"]]],[11,"map_same","","",47,[[["self"],["f"]],["t"]]],[11,"to_owned","","",47,[[["self"]],["t"]]],[11,"clone_into","","",47,N],[11,"from","","",47,[[["t"]],["t"]]],[11,"into","","",47,[[["self"]],["u"]]],[11,"try_from","","",47,[[["u"]],["result"]]],[11,"borrow","","",47,[[["self"]],["t"]]],[11,"try_into","","",47,[[["self"]],["result"]]],[11,"borrow_mut","","",47,[[["self"]],["t"]]],[11,"get_type_id","","",47,[[["self"]],["typeid"]]],[11,"encode","","",47,[[["self"],["e"]],["result"]]],[11,"decode","","",47,[[["d"]],["result"]]],[11,"not_found","","",47,[[["str"],["str"]],["e"]]],[11,"from_ok","","",48,[[["t"]],["t"]]],[11,"map_same","","",48,[[["self"],["f"]],["t"]]],[11,"to_owned","","",48,[[["self"]],["t"]]],[11,"clone_into","","",48,N],[11,"from","","",48,[[["t"]],["t"]]],[11,"into","","",48,[[["self"]],["u"]]],[11,"try_from","","",48,[[["u"]],["result"]]],[11,"borrow","","",48,[[["self"]],["t"]]],[11,"try_into","","",48,[[["self"]],["result"]]],[11,"borrow_mut","","",48,[[["self"]],["t"]]],[11,"get_type_id","","",48,[[["self"]],["typeid"]]],[11,"encode","","",48,[[["self"],["e"]],["result"]]],[11,"decode","","",48,[[["d"]],["result"]]],[11,"not_found","","",48,[[["str"],["str"]],["e"]]],[11,"from_ok","","",49,[[["t"]],["t"]]],[11,"map_same","","",49,[[["self"],["f"]],["t"]]],[11,"to_owned","","",49,[[["self"]],["t"]]],[11,"clone_into","","",49,N],[11,"from","","",49,[[["t"]],["t"]]],[11,"into","","",49,[[["self"]],["u"]]],[11,"try_from","","",49,[[["u"]],["result"]]],[11,"borrow","","",49,[[["self"]],["t"]]],[11,"try_into","","",49,[[["self"]],["result"]]],[11,"borrow_mut","","",49,[[["self"]],["t"]]],[11,"get_type_id","","",49,[[["self"]],["typeid"]]],[11,"encode","","",49,[[["self"],["e"]],["result"]]],[11,"decode","","",49,[[["d"]],["result"]]],[11,"not_found","","",49,[[["str"],["str"]],["e"]]],[11,"from_ok","","",50,[[["t"]],["t"]]],[11,"map_same","","",50,[[["self"],["f"]],["t"]]],[11,"to_owned","","",50,[[["self"]],["t"]]],[11,"clone_into","","",50,N],[11,"from","","",50,[[["t"]],["t"]]],[11,"into","","",50,[[["self"]],["u"]]],[11,"try_from","","",50,[[["u"]],["result"]]],[11,"borrow","","",50,[[["self"]],["t"]]],[11,"try_into","","",50,[[["self"]],["result"]]],[11,"borrow_mut","","",50,[[["self"]],["t"]]],[11,"get_type_id","","",50,[[["self"]],["typeid"]]],[11,"encode","","",50,[[["self"],["e"]],["result"]]],[11,"decode","","",50,[[["d"]],["result"]]],[11,"not_found","","",50,[[["str"],["str"]],["e"]]],[11,"from_ok","","",51,[[["t"]],["t"]]],[11,"map_same","","",51,[[["self"],["f"]],["t"]]],[11,"to_owned","","",51,[[["self"]],["t"]]],[11,"clone_into","","",51,N],[11,"from","","",51,[[["t"]],["t"]]],[11,"into","","",51,[[["self"]],["u"]]],[11,"try_from","","",51,[[["u"]],["result"]]],[11,"borrow","","",51,[[["self"]],["t"]]],[11,"try_into","","",51,[[["self"]],["result"]]],[11,"borrow_mut","","",51,[[["self"]],["t"]]],[11,"get_type_id","","",51,[[["self"]],["typeid"]]],[11,"encode","","",51,[[["self"],["e"]],["result"]]],[11,"decode","","",51,[[["d"]],["result"]]],[11,"not_found","","",51,[[["str"],["str"]],["e"]]],[11,"from_ok","","",52,[[["t"]],["t"]]],[11,"map_same","","",52,[[["self"],["f"]],["t"]]],[11,"to_owned","","",52,[[["self"]],["t"]]],[11,"clone_into","","",52,N],[11,"from","","",52,[[["t"]],["t"]]],[11,"into","","",52,[[["self"]],["u"]]],[11,"try_from","","",52,[[["u"]],["result"]]],[11,"borrow","","",52,[[["self"]],["t"]]],[11,"try_into","","",52,[[["self"]],["result"]]],[11,"borrow_mut","","",52,[[["self"]],["t"]]],[11,"get_type_id","","",52,[[["self"]],["typeid"]]],[11,"encode","","",52,[[["self"],["e"]],["result"]]],[11,"decode","","",52,[[["d"]],["result"]]],[11,"not_found","","",52,[[["str"],["str"]],["e"]]],[11,"from_ok","","",53,[[["t"]],["t"]]],[11,"map_same","","",53,[[["self"],["f"]],["t"]]],[11,"to_owned","","",53,[[["self"]],["t"]]],[11,"clone_into","","",53,N],[11,"from","","",53,[[["t"]],["t"]]],[11,"into","","",53,[[["self"]],["u"]]],[11,"try_from","","",53,[[["u"]],["result"]]],[11,"borrow","","",53,[[["self"]],["t"]]],[11,"try_into","","",53,[[["self"]],["result"]]],[11,"borrow_mut","","",53,[[["self"]],["t"]]],[11,"get_type_id","","",53,[[["self"]],["typeid"]]],[11,"encode","","",53,[[["self"],["e"]],["result"]]],[11,"decode","","",53,[[["d"]],["result"]]],[11,"not_found","","",53,[[["str"],["str"]],["e"]]],[11,"from_ok","","",54,[[["t"]],["t"]]],[11,"map_same","","",54,[[["self"],["f"]],["t"]]],[11,"to_owned","","",54,[[["self"]],["t"]]],[11,"clone_into","","",54,N],[11,"from","","",54,[[["t"]],["t"]]],[11,"into","","",54,[[["self"]],["u"]]],[11,"try_from","","",54,[[["u"]],["result"]]],[11,"borrow","","",54,[[["self"]],["t"]]],[11,"try_into","","",54,[[["self"]],["result"]]],[11,"borrow_mut","","",54,[[["self"]],["t"]]],[11,"get_type_id","","",54,[[["self"]],["typeid"]]],[11,"encode","","",54,[[["self"],["e"]],["result"]]],[11,"decode","","",54,[[["d"]],["result"]]],[11,"not_found","","",54,[[["str"],["str"]],["e"]]],[11,"from_ok","","",55,[[["t"]],["t"]]],[11,"map_same","","",55,[[["self"],["f"]],["t"]]],[11,"to_owned","","",55,[[["self"]],["t"]]],[11,"clone_into","","",55,N],[11,"from","","",55,[[["t"]],["t"]]],[11,"into","","",55,[[["self"]],["u"]]],[11,"try_from","","",55,[[["u"]],["result"]]],[11,"borrow","","",55,[[["self"]],["t"]]],[11,"try_into","","",55,[[["self"]],["result"]]],[11,"borrow_mut","","",55,[[["self"]],["t"]]],[11,"get_type_id","","",55,[[["self"]],["typeid"]]],[11,"encode","","",55,[[["self"],["e"]],["result"]]],[11,"decode","","",55,[[["d"]],["result"]]],[11,"not_found","","",55,[[["str"],["str"]],["e"]]],[11,"from_ok","","",56,[[["t"]],["t"]]],[11,"map_same","","",56,[[["self"],["f"]],["t"]]],[11,"to_owned","","",56,[[["self"]],["t"]]],[11,"clone_into","","",56,N],[11,"from","","",56,[[["t"]],["t"]]],[11,"into","","",56,[[["self"]],["u"]]],[11,"try_from","","",56,[[["u"]],["result"]]],[11,"borrow","","",56,[[["self"]],["t"]]],[11,"try_into","","",56,[[["self"]],["result"]]],[11,"borrow_mut","","",56,[[["self"]],["t"]]],[11,"get_type_id","","",56,[[["self"]],["typeid"]]],[11,"encode","","",56,[[["self"],["e"]],["result"]]],[11,"decode","","",56,[[["d"]],["result"]]],[11,"not_found","","",56,[[["str"],["str"]],["e"]]],[11,"from_ok","","",57,[[["t"]],["t"]]],[11,"map_same","","",57,[[["self"],["f"]],["t"]]],[11,"to_owned","","",57,[[["self"]],["t"]]],[11,"clone_into","","",57,N],[11,"from","","",57,[[["t"]],["t"]]],[11,"into","","",57,[[["self"]],["u"]]],[11,"try_from","","",57,[[["u"]],["result"]]],[11,"borrow","","",57,[[["self"]],["t"]]],[11,"try_into","","",57,[[["self"]],["result"]]],[11,"borrow_mut","","",57,[[["self"]],["t"]]],[11,"get_type_id","","",57,[[["self"]],["typeid"]]],[11,"encode","","",57,[[["self"],["e"]],["result"]]],[11,"decode","","",57,[[["d"]],["result"]]],[11,"not_found","","",57,[[["str"],["str"]],["e"]]],[11,"from_ok","","",58,[[["t"]],["t"]]],[11,"map_same","","",58,[[["self"],["f"]],["t"]]],[11,"to_owned","","",58,[[["self"]],["t"]]],[11,"clone_into","","",58,N],[11,"from","","",58,[[["t"]],["t"]]],[11,"into","","",58,[[["self"]],["u"]]],[11,"try_from","","",58,[[["u"]],["result"]]],[11,"borrow","","",58,[[["self"]],["t"]]],[11,"try_into","","",58,[[["self"]],["result"]]],[11,"borrow_mut","","",58,[[["self"]],["t"]]],[11,"get_type_id","","",58,[[["self"]],["typeid"]]],[11,"encode","","",58,[[["self"],["e"]],["result"]]],[11,"decode","","",58,[[["d"]],["result"]]],[11,"not_found","","",58,[[["str"],["str"]],["e"]]],[11,"from_ok","","",59,[[["t"]],["t"]]],[11,"map_same","","",59,[[["self"],["f"]],["t"]]],[11,"to_owned","","",59,[[["self"]],["t"]]],[11,"clone_into","","",59,N],[11,"from","","",59,[[["t"]],["t"]]],[11,"into","","",59,[[["self"]],["u"]]],[11,"try_from","","",59,[[["u"]],["result"]]],[11,"borrow","","",59,[[["self"]],["t"]]],[11,"try_into","","",59,[[["self"]],["result"]]],[11,"borrow_mut","","",59,[[["self"]],["t"]]],[11,"get_type_id","","",59,[[["self"]],["typeid"]]],[11,"encode","","",59,[[["self"],["e"]],["result"]]],[11,"decode","","",59,[[["d"]],["result"]]],[11,"not_found","","",59,[[["str"],["str"]],["e"]]],[11,"from_ok","","",60,[[["t"]],["t"]]],[11,"map_same","","",60,[[["self"],["f"]],["t"]]],[11,"to_owned","","",60,[[["self"]],["t"]]],[11,"clone_into","","",60,N],[11,"from","","",60,[[["t"]],["t"]]],[11,"into","","",60,[[["self"]],["u"]]],[11,"try_from","","",60,[[["u"]],["result"]]],[11,"borrow","","",60,[[["self"]],["t"]]],[11,"try_into","","",60,[[["self"]],["result"]]],[11,"borrow_mut","","",60,[[["self"]],["t"]]],[11,"get_type_id","","",60,[[["self"]],["typeid"]]],[11,"encode","","",60,[[["self"],["e"]],["result"]]],[11,"decode","","",60,[[["d"]],["result"]]],[11,"not_found","","",60,[[["str"],["str"]],["e"]]],[11,"from_ok","","",61,[[["t"]],["t"]]],[11,"map_same","","",61,[[["self"],["f"]],["t"]]],[11,"to_owned","","",61,[[["self"]],["t"]]],[11,"clone_into","","",61,N],[11,"from","","",61,[[["t"]],["t"]]],[11,"into","","",61,[[["self"]],["u"]]],[11,"try_from","","",61,[[["u"]],["result"]]],[11,"borrow","","",61,[[["self"]],["t"]]],[11,"try_into","","",61,[[["self"]],["result"]]],[11,"borrow_mut","","",61,[[["self"]],["t"]]],[11,"get_type_id","","",61,[[["self"]],["typeid"]]],[11,"encode","","",61,[[["self"],["e"]],["result"]]],[11,"decode","","",61,[[["d"]],["result"]]],[11,"not_found","","",61,[[["str"],["str"]],["e"]]],[11,"from_ok","","",62,[[["t"]],["t"]]],[11,"map_same","","",62,[[["self"],["f"]],["t"]]],[11,"to_owned","","",62,[[["self"]],["t"]]],[11,"clone_into","","",62,N],[11,"from","","",62,[[["t"]],["t"]]],[11,"into","","",62,[[["self"]],["u"]]],[11,"try_from","","",62,[[["u"]],["result"]]],[11,"borrow","","",62,[[["self"]],["t"]]],[11,"try_into","","",62,[[["self"]],["result"]]],[11,"borrow_mut","","",62,[[["self"]],["t"]]],[11,"get_type_id","","",62,[[["self"]],["typeid"]]],[11,"encode","","",62,[[["self"],["e"]],["result"]]],[11,"decode","","",62,[[["d"]],["result"]]],[11,"not_found","","",62,[[["str"],["str"]],["e"]]],[11,"from_ok","","",63,[[["t"]],["t"]]],[11,"map_same","","",63,[[["self"],["f"]],["t"]]],[11,"to_owned","","",63,[[["self"]],["t"]]],[11,"clone_into","","",63,N],[11,"from","","",63,[[["t"]],["t"]]],[11,"into","","",63,[[["self"]],["u"]]],[11,"try_from","","",63,[[["u"]],["result"]]],[11,"borrow","","",63,[[["self"]],["t"]]],[11,"try_into","","",63,[[["self"]],["result"]]],[11,"borrow_mut","","",63,[[["self"]],["t"]]],[11,"get_type_id","","",63,[[["self"]],["typeid"]]],[11,"encode","","",63,[[["self"],["e"]],["result"]]],[11,"decode","","",63,[[["d"]],["result"]]],[11,"not_found","","",63,[[["str"],["str"]],["e"]]],[11,"from_ok","","",64,[[["t"]],["t"]]],[11,"map_same","","",64,[[["self"],["f"]],["t"]]],[11,"to_owned","","",64,[[["self"]],["t"]]],[11,"clone_into","","",64,N],[11,"from","","",64,[[["t"]],["t"]]],[11,"into","","",64,[[["self"]],["u"]]],[11,"try_from","","",64,[[["u"]],["result"]]],[11,"borrow","","",64,[[["self"]],["t"]]],[11,"try_into","","",64,[[["self"]],["result"]]],[11,"borrow_mut","","",64,[[["self"]],["t"]]],[11,"get_type_id","","",64,[[["self"]],["typeid"]]],[11,"encode","","",64,[[["self"],["e"]],["result"]]],[11,"decode","","",64,[[["d"]],["result"]]],[11,"not_found","","",64,[[["str"],["str"]],["e"]]],[11,"from_ok","","",65,[[["t"]],["t"]]],[11,"map_same","","",65,[[["self"],["f"]],["t"]]],[11,"to_owned","","",65,[[["self"]],["t"]]],[11,"clone_into","","",65,N],[11,"from","","",65,[[["t"]],["t"]]],[11,"into","","",65,[[["self"]],["u"]]],[11,"try_from","","",65,[[["u"]],["result"]]],[11,"borrow","","",65,[[["self"]],["t"]]],[11,"try_into","","",65,[[["self"]],["result"]]],[11,"borrow_mut","","",65,[[["self"]],["t"]]],[11,"get_type_id","","",65,[[["self"]],["typeid"]]],[11,"encode","","",65,[[["self"],["e"]],["result"]]],[11,"decode","","",65,[[["d"]],["result"]]],[11,"not_found","","",65,[[["str"],["str"]],["e"]]],[11,"from_ok","","",66,[[["t"]],["t"]]],[11,"map_same","","",66,[[["self"],["f"]],["t"]]],[11,"to_owned","","",66,[[["self"]],["t"]]],[11,"clone_into","","",66,N],[11,"from","","",66,[[["t"]],["t"]]],[11,"into","","",66,[[["self"]],["u"]]],[11,"try_from","","",66,[[["u"]],["result"]]],[11,"borrow","","",66,[[["self"]],["t"]]],[11,"try_into","","",66,[[["self"]],["result"]]],[11,"borrow_mut","","",66,[[["self"]],["t"]]],[11,"get_type_id","","",66,[[["self"]],["typeid"]]],[11,"encode","","",66,[[["self"],["e"]],["result"]]],[11,"decode","","",66,[[["d"]],["result"]]],[11,"not_found","","",66,[[["str"],["str"]],["e"]]],[11,"from_ok","","",67,[[["t"]],["t"]]],[11,"map_same","","",67,[[["self"],["f"]],["t"]]],[11,"to_owned","","",67,[[["self"]],["t"]]],[11,"clone_into","","",67,N],[11,"from","","",67,[[["t"]],["t"]]],[11,"into","","",67,[[["self"]],["u"]]],[11,"try_from","","",67,[[["u"]],["result"]]],[11,"borrow","","",67,[[["self"]],["t"]]],[11,"try_into","","",67,[[["self"]],["result"]]],[11,"borrow_mut","","",67,[[["self"]],["t"]]],[11,"get_type_id","","",67,[[["self"]],["typeid"]]],[11,"encode","","",67,[[["self"],["e"]],["result"]]],[11,"decode","","",67,[[["d"]],["result"]]],[11,"not_found","","",67,[[["str"],["str"]],["e"]]],[11,"from_ok","","",68,[[["t"]],["t"]]],[11,"map_same","","",68,[[["self"],["f"]],["t"]]],[11,"to_owned","","",68,[[["self"]],["t"]]],[11,"clone_into","","",68,N],[11,"from","","",68,[[["t"]],["t"]]],[11,"into","","",68,[[["self"]],["u"]]],[11,"try_from","","",68,[[["u"]],["result"]]],[11,"borrow","","",68,[[["self"]],["t"]]],[11,"try_into","","",68,[[["self"]],["result"]]],[11,"borrow_mut","","",68,[[["self"]],["t"]]],[11,"get_type_id","","",68,[[["self"]],["typeid"]]],[11,"encode","","",68,[[["self"],["e"]],["result"]]],[11,"decode","","",68,[[["d"]],["result"]]],[11,"not_found","","",68,[[["str"],["str"]],["e"]]],[11,"from_ok","","",69,[[["t"]],["t"]]],[11,"map_same","","",69,[[["self"],["f"]],["t"]]],[11,"to_owned","","",69,[[["self"]],["t"]]],[11,"clone_into","","",69,N],[11,"from","","",69,[[["t"]],["t"]]],[11,"into","","",69,[[["self"]],["u"]]],[11,"try_from","","",69,[[["u"]],["result"]]],[11,"borrow","","",69,[[["self"]],["t"]]],[11,"try_into","","",69,[[["self"]],["result"]]],[11,"borrow_mut","","",69,[[["self"]],["t"]]],[11,"get_type_id","","",69,[[["self"]],["typeid"]]],[11,"encode","","",69,[[["self"],["e"]],["result"]]],[11,"decode","","",69,[[["d"]],["result"]]],[11,"not_found","","",69,[[["str"],["str"]],["e"]]],[11,"from_ok","","",70,[[["t"]],["t"]]],[11,"map_same","","",70,[[["self"],["f"]],["t"]]],[11,"to_owned","","",70,[[["self"]],["t"]]],[11,"clone_into","","",70,N],[11,"from","","",70,[[["t"]],["t"]]],[11,"into","","",70,[[["self"]],["u"]]],[11,"try_from","","",70,[[["u"]],["result"]]],[11,"borrow","","",70,[[["self"]],["t"]]],[11,"try_into","","",70,[[["self"]],["result"]]],[11,"borrow_mut","","",70,[[["self"]],["t"]]],[11,"get_type_id","","",70,[[["self"]],["typeid"]]],[11,"encode","","",70,[[["self"],["e"]],["result"]]],[11,"decode","","",70,[[["d"]],["result"]]],[11,"not_found","","",70,[[["str"],["str"]],["e"]]],[11,"from_ok","","",71,[[["t"]],["t"]]],[11,"map_same","","",71,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",71,N],[11,"to_owned","","",71,[[["self"]],["t"]]],[11,"clone_into","","",71,N],[11,"from","","",71,[[["t"]],["t"]]],[11,"into","","",71,[[["self"]],["u"]]],[11,"try_from","","",71,[[["u"]],["result"]]],[11,"borrow","","",71,[[["self"]],["t"]]],[11,"try_into","","",71,[[["self"]],["result"]]],[11,"borrow_mut","","",71,[[["self"]],["t"]]],[11,"get_type_id","","",71,[[["self"]],["typeid"]]],[11,"encode","","",71,[[["self"],["e"]],["result"]]],[11,"decode","","",71,[[["d"]],["result"]]],[11,"not_found","","",71,[[["str"],["str"]],["e"]]],[11,"from_ok","","",72,[[["t"]],["t"]]],[11,"map_same","","",72,[[["self"],["f"]],["t"]]],[11,"to_owned","","",72,[[["self"]],["t"]]],[11,"clone_into","","",72,N],[11,"from","","",72,[[["t"]],["t"]]],[11,"into","","",72,[[["self"]],["u"]]],[11,"try_from","","",72,[[["u"]],["result"]]],[11,"borrow","","",72,[[["self"]],["t"]]],[11,"try_into","","",72,[[["self"]],["result"]]],[11,"borrow_mut","","",72,[[["self"]],["t"]]],[11,"get_type_id","","",72,[[["self"]],["typeid"]]],[11,"encode","","",72,[[["self"],["e"]],["result"]]],[11,"decode","","",72,[[["d"]],["result"]]],[11,"not_found","","",72,[[["str"],["str"]],["e"]]],[11,"from_ok","","",73,[[["t"]],["t"]]],[11,"map_same","","",73,[[["self"],["f"]],["t"]]],[11,"to_owned","","",73,[[["self"]],["t"]]],[11,"clone_into","","",73,N],[11,"from","","",73,[[["t"]],["t"]]],[11,"into","","",73,[[["self"]],["u"]]],[11,"try_from","","",73,[[["u"]],["result"]]],[11,"borrow","","",73,[[["self"]],["t"]]],[11,"try_into","","",73,[[["self"]],["result"]]],[11,"borrow_mut","","",73,[[["self"]],["t"]]],[11,"get_type_id","","",73,[[["self"]],["typeid"]]],[11,"encode","","",73,[[["self"],["e"]],["result"]]],[11,"decode","","",73,[[["d"]],["result"]]],[11,"not_found","","",73,[[["str"],["str"]],["e"]]],[11,"from_ok","","",74,[[["t"]],["t"]]],[11,"map_same","","",74,[[["self"],["f"]],["t"]]],[11,"to_owned","","",74,[[["self"]],["t"]]],[11,"clone_into","","",74,N],[11,"from","","",74,[[["t"]],["t"]]],[11,"into","","",74,[[["self"]],["u"]]],[11,"try_from","","",74,[[["u"]],["result"]]],[11,"borrow","","",74,[[["self"]],["t"]]],[11,"try_into","","",74,[[["self"]],["result"]]],[11,"borrow_mut","","",74,[[["self"]],["t"]]],[11,"get_type_id","","",74,[[["self"]],["typeid"]]],[11,"encode","","",74,[[["self"],["e"]],["result"]]],[11,"decode","","",74,[[["d"]],["result"]]],[11,"not_found","","",74,[[["str"],["str"]],["e"]]],[11,"from_ok","","",75,[[["t"]],["t"]]],[11,"map_same","","",75,[[["self"],["f"]],["t"]]],[11,"to_owned","","",75,[[["self"]],["t"]]],[11,"clone_into","","",75,N],[11,"from","","",75,[[["t"]],["t"]]],[11,"into","","",75,[[["self"]],["u"]]],[11,"try_from","","",75,[[["u"]],["result"]]],[11,"borrow","","",75,[[["self"]],["t"]]],[11,"try_into","","",75,[[["self"]],["result"]]],[11,"borrow_mut","","",75,[[["self"]],["t"]]],[11,"get_type_id","","",75,[[["self"]],["typeid"]]],[11,"encode","","",75,[[["self"],["e"]],["result"]]],[11,"decode","","",75,[[["d"]],["result"]]],[11,"not_found","","",75,[[["str"],["str"]],["e"]]],[11,"from_ok","","",76,[[["t"]],["t"]]],[11,"map_same","","",76,[[["self"],["f"]],["t"]]],[11,"to_owned","","",76,[[["self"]],["t"]]],[11,"clone_into","","",76,N],[11,"from","","",76,[[["t"]],["t"]]],[11,"into","","",76,[[["self"]],["u"]]],[11,"try_from","","",76,[[["u"]],["result"]]],[11,"borrow","","",76,[[["self"]],["t"]]],[11,"try_into","","",76,[[["self"]],["result"]]],[11,"borrow_mut","","",76,[[["self"]],["t"]]],[11,"get_type_id","","",76,[[["self"]],["typeid"]]],[11,"encode","","",76,[[["self"],["e"]],["result"]]],[11,"decode","","",76,[[["d"]],["result"]]],[11,"not_found","","",76,[[["str"],["str"]],["e"]]],[11,"from_ok","","",77,[[["t"]],["t"]]],[11,"map_same","","",77,[[["self"],["f"]],["t"]]],[11,"to_owned","","",77,[[["self"]],["t"]]],[11,"clone_into","","",77,N],[11,"from","","",77,[[["t"]],["t"]]],[11,"into","","",77,[[["self"]],["u"]]],[11,"try_from","","",77,[[["u"]],["result"]]],[11,"borrow","","",77,[[["self"]],["t"]]],[11,"try_into","","",77,[[["self"]],["result"]]],[11,"borrow_mut","","",77,[[["self"]],["t"]]],[11,"get_type_id","","",77,[[["self"]],["typeid"]]],[11,"encode","","",77,[[["self"],["e"]],["result"]]],[11,"decode","","",77,[[["d"]],["result"]]],[11,"not_found","","",77,[[["str"],["str"]],["e"]]],[11,"from_ok","","",78,[[["t"]],["t"]]],[11,"map_same","","",78,[[["self"],["f"]],["t"]]],[11,"to_owned","","",78,[[["self"]],["t"]]],[11,"clone_into","","",78,N],[11,"from","","",78,[[["t"]],["t"]]],[11,"into","","",78,[[["self"]],["u"]]],[11,"try_from","","",78,[[["u"]],["result"]]],[11,"borrow","","",78,[[["self"]],["t"]]],[11,"try_into","","",78,[[["self"]],["result"]]],[11,"borrow_mut","","",78,[[["self"]],["t"]]],[11,"get_type_id","","",78,[[["self"]],["typeid"]]],[11,"encode","","",78,[[["self"],["e"]],["result"]]],[11,"decode","","",78,[[["d"]],["result"]]],[11,"not_found","","",78,[[["str"],["str"]],["e"]]],[11,"from_ok","","",79,[[["t"]],["t"]]],[11,"map_same","","",79,[[["self"],["f"]],["t"]]],[11,"to_owned","","",79,[[["self"]],["t"]]],[11,"clone_into","","",79,N],[11,"from","","",79,[[["t"]],["t"]]],[11,"into","","",79,[[["self"]],["u"]]],[11,"try_from","","",79,[[["u"]],["result"]]],[11,"borrow","","",79,[[["self"]],["t"]]],[11,"try_into","","",79,[[["self"]],["result"]]],[11,"borrow_mut","","",79,[[["self"]],["t"]]],[11,"get_type_id","","",79,[[["self"]],["typeid"]]],[11,"encode","","",79,[[["self"],["e"]],["result"]]],[11,"decode","","",79,[[["d"]],["result"]]],[11,"not_found","","",79,[[["str"],["str"]],["e"]]],[11,"from_ok","","",80,[[["t"]],["t"]]],[11,"map_same","","",80,[[["self"],["f"]],["t"]]],[11,"to_owned","","",80,[[["self"]],["t"]]],[11,"clone_into","","",80,N],[11,"from","","",80,[[["t"]],["t"]]],[11,"into","","",80,[[["self"]],["u"]]],[11,"try_from","","",80,[[["u"]],["result"]]],[11,"borrow","","",80,[[["self"]],["t"]]],[11,"try_into","","",80,[[["self"]],["result"]]],[11,"borrow_mut","","",80,[[["self"]],["t"]]],[11,"get_type_id","","",80,[[["self"]],["typeid"]]],[11,"encode","","",80,[[["self"],["e"]],["result"]]],[11,"decode","","",80,[[["d"]],["result"]]],[11,"not_found","","",80,[[["str"],["str"]],["e"]]],[11,"from_ok","","",81,[[["t"]],["t"]]],[11,"map_same","","",81,[[["self"],["f"]],["t"]]],[11,"to_owned","","",81,[[["self"]],["t"]]],[11,"clone_into","","",81,N],[11,"from","","",81,[[["t"]],["t"]]],[11,"into","","",81,[[["self"]],["u"]]],[11,"try_from","","",81,[[["u"]],["result"]]],[11,"borrow","","",81,[[["self"]],["t"]]],[11,"try_into","","",81,[[["self"]],["result"]]],[11,"borrow_mut","","",81,[[["self"]],["t"]]],[11,"get_type_id","","",81,[[["self"]],["typeid"]]],[11,"encode","","",81,[[["self"],["e"]],["result"]]],[11,"decode","","",81,[[["d"]],["result"]]],[11,"not_found","","",81,[[["str"],["str"]],["e"]]],[11,"from_ok","","",82,[[["t"]],["t"]]],[11,"map_same","","",82,[[["self"],["f"]],["t"]]],[11,"to_owned","","",82,[[["self"]],["t"]]],[11,"clone_into","","",82,N],[11,"from","","",82,[[["t"]],["t"]]],[11,"into","","",82,[[["self"]],["u"]]],[11,"try_from","","",82,[[["u"]],["result"]]],[11,"borrow","","",82,[[["self"]],["t"]]],[11,"try_into","","",82,[[["self"]],["result"]]],[11,"borrow_mut","","",82,[[["self"]],["t"]]],[11,"get_type_id","","",82,[[["self"]],["typeid"]]],[11,"encode","","",82,[[["self"],["e"]],["result"]]],[11,"decode","","",82,[[["d"]],["result"]]],[11,"not_found","","",82,[[["str"],["str"]],["e"]]],[11,"from_ok","","",83,[[["t"]],["t"]]],[11,"map_same","","",83,[[["self"],["f"]],["t"]]],[11,"to_owned","","",83,[[["self"]],["t"]]],[11,"clone_into","","",83,N],[11,"from","","",83,[[["t"]],["t"]]],[11,"into","","",83,[[["self"]],["u"]]],[11,"try_from","","",83,[[["u"]],["result"]]],[11,"borrow","","",83,[[["self"]],["t"]]],[11,"try_into","","",83,[[["self"]],["result"]]],[11,"borrow_mut","","",83,[[["self"]],["t"]]],[11,"get_type_id","","",83,[[["self"]],["typeid"]]],[11,"encode","","",83,[[["self"],["e"]],["result"]]],[11,"decode","","",83,[[["d"]],["result"]]],[11,"not_found","","",83,[[["str"],["str"]],["e"]]],[11,"from_ok","","",84,[[["t"]],["t"]]],[11,"map_same","","",84,[[["self"],["f"]],["t"]]],[11,"to_owned","","",84,[[["self"]],["t"]]],[11,"clone_into","","",84,N],[11,"from","","",84,[[["t"]],["t"]]],[11,"into","","",84,[[["self"]],["u"]]],[11,"try_from","","",84,[[["u"]],["result"]]],[11,"borrow","","",84,[[["self"]],["t"]]],[11,"try_into","","",84,[[["self"]],["result"]]],[11,"borrow_mut","","",84,[[["self"]],["t"]]],[11,"get_type_id","","",84,[[["self"]],["typeid"]]],[11,"encode","","",84,[[["self"],["e"]],["result"]]],[11,"decode","","",84,[[["d"]],["result"]]],[11,"not_found","","",84,[[["str"],["str"]],["e"]]],[11,"from_ok","","",85,[[["t"]],["t"]]],[11,"map_same","","",85,[[["self"],["f"]],["t"]]],[11,"to_owned","","",85,[[["self"]],["t"]]],[11,"clone_into","","",85,N],[11,"from","","",85,[[["t"]],["t"]]],[11,"into","","",85,[[["self"]],["u"]]],[11,"try_from","","",85,[[["u"]],["result"]]],[11,"borrow","","",85,[[["self"]],["t"]]],[11,"try_into","","",85,[[["self"]],["result"]]],[11,"borrow_mut","","",85,[[["self"]],["t"]]],[11,"get_type_id","","",85,[[["self"]],["typeid"]]],[11,"encode","","",85,[[["self"],["e"]],["result"]]],[11,"decode","","",85,[[["d"]],["result"]]],[11,"not_found","","",85,[[["str"],["str"]],["e"]]],[11,"from_ok","","",86,[[["t"]],["t"]]],[11,"map_same","","",86,[[["self"],["f"]],["t"]]],[11,"to_owned","","",86,[[["self"]],["t"]]],[11,"clone_into","","",86,N],[11,"from","","",86,[[["t"]],["t"]]],[11,"into","","",86,[[["self"]],["u"]]],[11,"try_from","","",86,[[["u"]],["result"]]],[11,"borrow","","",86,[[["self"]],["t"]]],[11,"try_into","","",86,[[["self"]],["result"]]],[11,"borrow_mut","","",86,[[["self"]],["t"]]],[11,"get_type_id","","",86,[[["self"]],["typeid"]]],[11,"encode","","",86,[[["self"],["e"]],["result"]]],[11,"decode","","",86,[[["d"]],["result"]]],[11,"not_found","","",86,[[["str"],["str"]],["e"]]],[11,"from_ok","","",87,[[["t"]],["t"]]],[11,"map_same","","",87,[[["self"],["f"]],["t"]]],[11,"to_owned","","",87,[[["self"]],["t"]]],[11,"clone_into","","",87,N],[11,"from","","",87,[[["t"]],["t"]]],[11,"into","","",87,[[["self"]],["u"]]],[11,"try_from","","",87,[[["u"]],["result"]]],[11,"borrow","","",87,[[["self"]],["t"]]],[11,"try_into","","",87,[[["self"]],["result"]]],[11,"borrow_mut","","",87,[[["self"]],["t"]]],[11,"get_type_id","","",87,[[["self"]],["typeid"]]],[11,"encode","","",87,[[["self"],["e"]],["result"]]],[11,"decode","","",87,[[["d"]],["result"]]],[11,"not_found","","",87,[[["str"],["str"]],["e"]]],[11,"from_ok","","",88,[[["t"]],["t"]]],[11,"map_same","","",88,[[["self"],["f"]],["t"]]],[11,"to_owned","","",88,[[["self"]],["t"]]],[11,"clone_into","","",88,N],[11,"from","","",88,[[["t"]],["t"]]],[11,"into","","",88,[[["self"]],["u"]]],[11,"try_from","","",88,[[["u"]],["result"]]],[11,"borrow","","",88,[[["self"]],["t"]]],[11,"try_into","","",88,[[["self"]],["result"]]],[11,"borrow_mut","","",88,[[["self"]],["t"]]],[11,"get_type_id","","",88,[[["self"]],["typeid"]]],[11,"encode","","",88,[[["self"],["e"]],["result"]]],[11,"decode","","",88,[[["d"]],["result"]]],[11,"not_found","","",88,[[["str"],["str"]],["e"]]],[11,"from_ok","","",89,[[["t"]],["t"]]],[11,"map_same","","",89,[[["self"],["f"]],["t"]]],[11,"to_owned","","",89,[[["self"]],["t"]]],[11,"clone_into","","",89,N],[11,"from","","",89,[[["t"]],["t"]]],[11,"into","","",89,[[["self"]],["u"]]],[11,"try_from","","",89,[[["u"]],["result"]]],[11,"borrow","","",89,[[["self"]],["t"]]],[11,"try_into","","",89,[[["self"]],["result"]]],[11,"borrow_mut","","",89,[[["self"]],["t"]]],[11,"get_type_id","","",89,[[["self"]],["typeid"]]],[11,"not_found","","",89,[[["str"],["str"]],["e"]]],[11,"from_ok","","",90,[[["t"]],["t"]]],[11,"map_same","","",90,[[["self"],["f"]],["t"]]],[11,"to_owned","","",90,[[["self"]],["t"]]],[11,"clone_into","","",90,N],[11,"from","","",90,[[["t"]],["t"]]],[11,"into","","",90,[[["self"]],["u"]]],[11,"try_from","","",90,[[["u"]],["result"]]],[11,"borrow","","",90,[[["self"]],["t"]]],[11,"try_into","","",90,[[["self"]],["result"]]],[11,"borrow_mut","","",90,[[["self"]],["t"]]],[11,"get_type_id","","",90,[[["self"]],["typeid"]]],[11,"encode","","",90,[[["self"],["e"]],["result"]]],[11,"decode","","",90,[[["d"]],["result"]]],[11,"not_found","","",90,[[["str"],["str"]],["e"]]],[11,"from_ok","","",91,[[["t"]],["t"]]],[11,"map_same","","",91,[[["self"],["f"]],["t"]]],[11,"to_owned","","",91,[[["self"]],["t"]]],[11,"clone_into","","",91,N],[11,"from","","",91,[[["t"]],["t"]]],[11,"into","","",91,[[["self"]],["u"]]],[11,"try_from","","",91,[[["u"]],["result"]]],[11,"borrow","","",91,[[["self"]],["t"]]],[11,"try_into","","",91,[[["self"]],["result"]]],[11,"borrow_mut","","",91,[[["self"]],["t"]]],[11,"get_type_id","","",91,[[["self"]],["typeid"]]],[11,"encode","","",91,[[["self"],["e"]],["result"]]],[11,"decode","","",91,[[["d"]],["result"]]],[11,"not_found","","",91,[[["str"],["str"]],["e"]]],[11,"from_ok","","",92,[[["t"]],["t"]]],[11,"map_same","","",92,[[["self"],["f"]],["t"]]],[11,"to_owned","","",92,[[["self"]],["t"]]],[11,"clone_into","","",92,N],[11,"from","","",92,[[["t"]],["t"]]],[11,"into","","",92,[[["self"]],["u"]]],[11,"try_from","","",92,[[["u"]],["result"]]],[11,"borrow","","",92,[[["self"]],["t"]]],[11,"try_into","","",92,[[["self"]],["result"]]],[11,"borrow_mut","","",92,[[["self"]],["t"]]],[11,"get_type_id","","",92,[[["self"]],["typeid"]]],[11,"encode","","",92,[[["self"],["e"]],["result"]]],[11,"decode","","",92,[[["d"]],["result"]]],[11,"not_found","","",92,[[["str"],["str"]],["e"]]],[11,"from_ok","","",93,[[["t"]],["t"]]],[11,"map_same","","",93,[[["self"],["f"]],["t"]]],[11,"to_owned","","",93,[[["self"]],["t"]]],[11,"clone_into","","",93,N],[11,"from","","",93,[[["t"]],["t"]]],[11,"into","","",93,[[["self"]],["u"]]],[11,"try_from","","",93,[[["u"]],["result"]]],[11,"borrow","","",93,[[["self"]],["t"]]],[11,"try_into","","",93,[[["self"]],["result"]]],[11,"borrow_mut","","",93,[[["self"]],["t"]]],[11,"get_type_id","","",93,[[["self"]],["typeid"]]],[11,"encode","","",93,[[["self"],["e"]],["result"]]],[11,"decode","","",93,[[["d"]],["result"]]],[11,"not_found","","",93,[[["str"],["str"]],["e"]]],[11,"from_ok","","",94,[[["t"]],["t"]]],[11,"map_same","","",94,[[["self"],["f"]],["t"]]],[11,"to_owned","","",94,[[["self"]],["t"]]],[11,"clone_into","","",94,N],[11,"from","","",94,[[["t"]],["t"]]],[11,"into","","",94,[[["self"]],["u"]]],[11,"try_from","","",94,[[["u"]],["result"]]],[11,"borrow","","",94,[[["self"]],["t"]]],[11,"try_into","","",94,[[["self"]],["result"]]],[11,"borrow_mut","","",94,[[["self"]],["t"]]],[11,"get_type_id","","",94,[[["self"]],["typeid"]]],[11,"encode","","",94,[[["self"],["e"]],["result"]]],[11,"decode","","",94,[[["d"]],["result"]]],[11,"not_found","","",94,[[["str"],["str"]],["e"]]],[11,"from_ok","","",95,[[["t"]],["t"]]],[11,"map_same","","",95,[[["self"],["f"]],["t"]]],[11,"to_owned","","",95,[[["self"]],["t"]]],[11,"clone_into","","",95,N],[11,"from","","",95,[[["t"]],["t"]]],[11,"into","","",95,[[["self"]],["u"]]],[11,"try_from","","",95,[[["u"]],["result"]]],[11,"borrow","","",95,[[["self"]],["t"]]],[11,"try_into","","",95,[[["self"]],["result"]]],[11,"borrow_mut","","",95,[[["self"]],["t"]]],[11,"get_type_id","","",95,[[["self"]],["typeid"]]],[11,"encode","","",95,[[["self"],["e"]],["result"]]],[11,"decode","","",95,[[["d"]],["result"]]],[11,"not_found","","",95,[[["str"],["str"]],["e"]]],[11,"from_ok","","",96,[[["t"]],["t"]]],[11,"map_same","","",96,[[["self"],["f"]],["t"]]],[11,"to_owned","","",96,[[["self"]],["t"]]],[11,"clone_into","","",96,N],[11,"from","","",96,[[["t"]],["t"]]],[11,"into","","",96,[[["self"]],["u"]]],[11,"try_from","","",96,[[["u"]],["result"]]],[11,"borrow","","",96,[[["self"]],["t"]]],[11,"try_into","","",96,[[["self"]],["result"]]],[11,"borrow_mut","","",96,[[["self"]],["t"]]],[11,"get_type_id","","",96,[[["self"]],["typeid"]]],[11,"encode","","",96,[[["self"],["e"]],["result"]]],[11,"decode","","",96,[[["d"]],["result"]]],[11,"not_found","","",96,[[["str"],["str"]],["e"]]],[11,"from_ok","","",97,[[["t"]],["t"]]],[11,"map_same","","",97,[[["self"],["f"]],["t"]]],[11,"to_owned","","",97,[[["self"]],["t"]]],[11,"clone_into","","",97,N],[11,"from","","",97,[[["t"]],["t"]]],[11,"into","","",97,[[["self"]],["u"]]],[11,"try_from","","",97,[[["u"]],["result"]]],[11,"borrow","","",97,[[["self"]],["t"]]],[11,"try_into","","",97,[[["self"]],["result"]]],[11,"borrow_mut","","",97,[[["self"]],["t"]]],[11,"get_type_id","","",97,[[["self"]],["typeid"]]],[11,"encode","","",97,[[["self"],["e"]],["result"]]],[11,"decode","","",97,[[["d"]],["result"]]],[11,"not_found","","",97,[[["str"],["str"]],["e"]]],[11,"from_ok","","",98,[[["t"]],["t"]]],[11,"map_same","","",98,[[["self"],["f"]],["t"]]],[11,"to_owned","","",98,[[["self"]],["t"]]],[11,"clone_into","","",98,N],[11,"from","","",98,[[["t"]],["t"]]],[11,"into","","",98,[[["self"]],["u"]]],[11,"try_from","","",98,[[["u"]],["result"]]],[11,"borrow","","",98,[[["self"]],["t"]]],[11,"try_into","","",98,[[["self"]],["result"]]],[11,"borrow_mut","","",98,[[["self"]],["t"]]],[11,"get_type_id","","",98,[[["self"]],["typeid"]]],[11,"encode","","",98,[[["self"],["e"]],["result"]]],[11,"decode","","",98,[[["d"]],["result"]]],[11,"not_found","","",98,[[["str"],["str"]],["e"]]],[11,"from_ok","","",99,[[["t"]],["t"]]],[11,"map_same","","",99,[[["self"],["f"]],["t"]]],[11,"to_owned","","",99,[[["self"]],["t"]]],[11,"clone_into","","",99,N],[11,"from","","",99,[[["t"]],["t"]]],[11,"into","","",99,[[["self"]],["u"]]],[11,"try_from","","",99,[[["u"]],["result"]]],[11,"borrow","","",99,[[["self"]],["t"]]],[11,"try_into","","",99,[[["self"]],["result"]]],[11,"borrow_mut","","",99,[[["self"]],["t"]]],[11,"get_type_id","","",99,[[["self"]],["typeid"]]],[11,"encode","","",99,[[["self"],["e"]],["result"]]],[11,"decode","","",99,[[["d"]],["result"]]],[11,"not_found","","",99,[[["str"],["str"]],["e"]]],[11,"from_ok","","",100,[[["t"]],["t"]]],[11,"map_same","","",100,[[["self"],["f"]],["t"]]],[11,"to_owned","","",100,[[["self"]],["t"]]],[11,"clone_into","","",100,N],[11,"from","","",100,[[["t"]],["t"]]],[11,"into","","",100,[[["self"]],["u"]]],[11,"try_from","","",100,[[["u"]],["result"]]],[11,"borrow","","",100,[[["self"]],["t"]]],[11,"try_into","","",100,[[["self"]],["result"]]],[11,"borrow_mut","","",100,[[["self"]],["t"]]],[11,"get_type_id","","",100,[[["self"]],["typeid"]]],[11,"encode","","",100,[[["self"],["e"]],["result"]]],[11,"decode","","",100,[[["d"]],["result"]]],[11,"not_found","","",100,[[["str"],["str"]],["e"]]],[11,"from_ok","","",101,[[["t"]],["t"]]],[11,"map_same","","",101,[[["self"],["f"]],["t"]]],[11,"to_owned","","",101,[[["self"]],["t"]]],[11,"clone_into","","",101,N],[11,"from","","",101,[[["t"]],["t"]]],[11,"into","","",101,[[["self"]],["u"]]],[11,"try_from","","",101,[[["u"]],["result"]]],[11,"borrow","","",101,[[["self"]],["t"]]],[11,"try_into","","",101,[[["self"]],["result"]]],[11,"borrow_mut","","",101,[[["self"]],["t"]]],[11,"get_type_id","","",101,[[["self"]],["typeid"]]],[11,"encode","","",101,[[["self"],["e"]],["result"]]],[11,"decode","","",101,[[["d"]],["result"]]],[11,"not_found","","",101,[[["str"],["str"]],["e"]]],[11,"from_ok","","",102,[[["t"]],["t"]]],[11,"map_same","","",102,[[["self"],["f"]],["t"]]],[11,"to_owned","","",102,[[["self"]],["t"]]],[11,"clone_into","","",102,N],[11,"from","","",102,[[["t"]],["t"]]],[11,"into","","",102,[[["self"]],["u"]]],[11,"try_from","","",102,[[["u"]],["result"]]],[11,"borrow","","",102,[[["self"]],["t"]]],[11,"try_into","","",102,[[["self"]],["result"]]],[11,"borrow_mut","","",102,[[["self"]],["t"]]],[11,"get_type_id","","",102,[[["self"]],["typeid"]]],[11,"encode","","",102,[[["self"],["e"]],["result"]]],[11,"decode","","",102,[[["d"]],["result"]]],[11,"not_found","","",102,[[["str"],["str"]],["e"]]],[11,"from_ok","","",103,[[["t"]],["t"]]],[11,"map_same","","",103,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",103,N],[11,"to_owned","","",103,[[["self"]],["t"]]],[11,"clone_into","","",103,N],[11,"from","","",103,[[["t"]],["t"]]],[11,"into","","",103,[[["self"]],["u"]]],[11,"try_from","","",103,[[["u"]],["result"]]],[11,"borrow","","",103,[[["self"]],["t"]]],[11,"try_into","","",103,[[["self"]],["result"]]],[11,"borrow_mut","","",103,[[["self"]],["t"]]],[11,"get_type_id","","",103,[[["self"]],["typeid"]]],[11,"encode","","",103,[[["self"],["e"]],["result"]]],[11,"decode","","",103,[[["d"]],["result"]]],[11,"not_found","","",103,[[["str"],["str"]],["e"]]],[11,"from_ok","","",104,[[["t"]],["t"]]],[11,"map_same","","",104,[[["self"],["f"]],["t"]]],[11,"to_owned","","",104,[[["self"]],["t"]]],[11,"clone_into","","",104,N],[11,"from","","",104,[[["t"]],["t"]]],[11,"into","","",104,[[["self"]],["u"]]],[11,"try_from","","",104,[[["u"]],["result"]]],[11,"borrow","","",104,[[["self"]],["t"]]],[11,"try_into","","",104,[[["self"]],["result"]]],[11,"borrow_mut","","",104,[[["self"]],["t"]]],[11,"get_type_id","","",104,[[["self"]],["typeid"]]],[11,"encode","","",104,[[["self"],["e"]],["result"]]],[11,"decode","","",104,[[["d"]],["result"]]],[11,"not_found","","",104,[[["str"],["str"]],["e"]]],[11,"from_ok","","",105,[[["t"]],["t"]]],[11,"map_same","","",105,[[["self"],["f"]],["t"]]],[11,"to_owned","","",105,[[["self"]],["t"]]],[11,"clone_into","","",105,N],[11,"from","","",105,[[["t"]],["t"]]],[11,"into","","",105,[[["self"]],["u"]]],[11,"try_from","","",105,[[["u"]],["result"]]],[11,"borrow","","",105,[[["self"]],["t"]]],[11,"try_into","","",105,[[["self"]],["result"]]],[11,"borrow_mut","","",105,[[["self"]],["t"]]],[11,"get_type_id","","",105,[[["self"]],["typeid"]]],[11,"encode","","",105,[[["self"],["e"]],["result"]]],[11,"decode","","",105,[[["d"]],["result"]]],[11,"not_found","","",105,[[["str"],["str"]],["e"]]],[11,"from_ok","","",106,[[["t"]],["t"]]],[11,"map_same","","",106,[[["self"],["f"]],["t"]]],[11,"to_owned","","",106,[[["self"]],["t"]]],[11,"clone_into","","",106,N],[11,"from","","",106,[[["t"]],["t"]]],[11,"into","","",106,[[["self"]],["u"]]],[11,"try_from","","",106,[[["u"]],["result"]]],[11,"borrow","","",106,[[["self"]],["t"]]],[11,"try_into","","",106,[[["self"]],["result"]]],[11,"borrow_mut","","",106,[[["self"]],["t"]]],[11,"get_type_id","","",106,[[["self"]],["typeid"]]],[11,"encode","","",106,[[["self"],["e"]],["result"]]],[11,"decode","","",106,[[["d"]],["result"]]],[11,"not_found","","",106,[[["str"],["str"]],["e"]]],[11,"from_ok","","",107,[[["t"]],["t"]]],[11,"map_same","","",107,[[["self"],["f"]],["t"]]],[11,"to_owned","","",107,[[["self"]],["t"]]],[11,"clone_into","","",107,N],[11,"from","","",107,[[["t"]],["t"]]],[11,"into","","",107,[[["self"]],["u"]]],[11,"try_from","","",107,[[["u"]],["result"]]],[11,"borrow","","",107,[[["self"]],["t"]]],[11,"try_into","","",107,[[["self"]],["result"]]],[11,"borrow_mut","","",107,[[["self"]],["t"]]],[11,"get_type_id","","",107,[[["self"]],["typeid"]]],[11,"encode","","",107,[[["self"],["e"]],["result"]]],[11,"decode","","",107,[[["d"]],["result"]]],[11,"not_found","","",107,[[["str"],["str"]],["e"]]],[11,"from_ok","","",108,[[["t"]],["t"]]],[11,"map_same","","",108,[[["self"],["f"]],["t"]]],[11,"to_owned","","",108,[[["self"]],["t"]]],[11,"clone_into","","",108,N],[11,"from","","",108,[[["t"]],["t"]]],[11,"into","","",108,[[["self"]],["u"]]],[11,"try_from","","",108,[[["u"]],["result"]]],[11,"borrow","","",108,[[["self"]],["t"]]],[11,"try_into","","",108,[[["self"]],["result"]]],[11,"borrow_mut","","",108,[[["self"]],["t"]]],[11,"get_type_id","","",108,[[["self"]],["typeid"]]],[11,"encode","","",108,[[["self"],["e"]],["result"]]],[11,"decode","","",108,[[["d"]],["result"]]],[11,"not_found","","",108,[[["str"],["str"]],["e"]]],[11,"from_ok","","",109,[[["t"]],["t"]]],[11,"map_same","","",109,[[["self"],["f"]],["t"]]],[11,"to_owned","","",109,[[["self"]],["t"]]],[11,"clone_into","","",109,N],[11,"from","","",109,[[["t"]],["t"]]],[11,"into","","",109,[[["self"]],["u"]]],[11,"try_from","","",109,[[["u"]],["result"]]],[11,"borrow","","",109,[[["self"]],["t"]]],[11,"try_into","","",109,[[["self"]],["result"]]],[11,"borrow_mut","","",109,[[["self"]],["t"]]],[11,"get_type_id","","",109,[[["self"]],["typeid"]]],[11,"encode","","",109,[[["self"],["e"]],["result"]]],[11,"decode","","",109,[[["d"]],["result"]]],[11,"not_found","","",109,[[["str"],["str"]],["e"]]],[11,"from_ok","","",110,[[["t"]],["t"]]],[11,"map_same","","",110,[[["self"],["f"]],["t"]]],[11,"to_owned","","",110,[[["self"]],["t"]]],[11,"clone_into","","",110,N],[11,"from","","",110,[[["t"]],["t"]]],[11,"into","","",110,[[["self"]],["u"]]],[11,"try_from","","",110,[[["u"]],["result"]]],[11,"borrow","","",110,[[["self"]],["t"]]],[11,"try_into","","",110,[[["self"]],["result"]]],[11,"borrow_mut","","",110,[[["self"]],["t"]]],[11,"get_type_id","","",110,[[["self"]],["typeid"]]],[11,"encode","","",110,[[["self"],["e"]],["result"]]],[11,"decode","","",110,[[["d"]],["result"]]],[11,"not_found","","",110,[[["str"],["str"]],["e"]]],[11,"from_ok","","",111,[[["t"]],["t"]]],[11,"map_same","","",111,[[["self"],["f"]],["t"]]],[11,"to_owned","","",111,[[["self"]],["t"]]],[11,"clone_into","","",111,N],[11,"from","","",111,[[["t"]],["t"]]],[11,"into","","",111,[[["self"]],["u"]]],[11,"try_from","","",111,[[["u"]],["result"]]],[11,"borrow","","",111,[[["self"]],["t"]]],[11,"try_into","","",111,[[["self"]],["result"]]],[11,"borrow_mut","","",111,[[["self"]],["t"]]],[11,"get_type_id","","",111,[[["self"]],["typeid"]]],[11,"not_found","","",111,[[["str"],["str"]],["e"]]],[11,"from_ok","","",112,[[["t"]],["t"]]],[11,"map_same","","",112,[[["self"],["f"]],["t"]]],[11,"to_owned","","",112,[[["self"]],["t"]]],[11,"clone_into","","",112,N],[11,"from","","",112,[[["t"]],["t"]]],[11,"into","","",112,[[["self"]],["u"]]],[11,"try_from","","",112,[[["u"]],["result"]]],[11,"borrow","","",112,[[["self"]],["t"]]],[11,"try_into","","",112,[[["self"]],["result"]]],[11,"borrow_mut","","",112,[[["self"]],["t"]]],[11,"get_type_id","","",112,[[["self"]],["typeid"]]],[11,"encode","","",112,[[["self"],["e"]],["result"]]],[11,"decode","","",112,[[["d"]],["result"]]],[11,"not_found","","",112,[[["str"],["str"]],["e"]]],[11,"from_ok","","",113,[[["t"]],["t"]]],[11,"map_same","","",113,[[["self"],["f"]],["t"]]],[11,"to_owned","","",113,[[["self"]],["t"]]],[11,"clone_into","","",113,N],[11,"from","","",113,[[["t"]],["t"]]],[11,"into","","",113,[[["self"]],["u"]]],[11,"try_from","","",113,[[["u"]],["result"]]],[11,"borrow","","",113,[[["self"]],["t"]]],[11,"try_into","","",113,[[["self"]],["result"]]],[11,"borrow_mut","","",113,[[["self"]],["t"]]],[11,"get_type_id","","",113,[[["self"]],["typeid"]]],[11,"encode","","",113,[[["self"],["e"]],["result"]]],[11,"decode","","",113,[[["d"]],["result"]]],[11,"not_found","","",113,[[["str"],["str"]],["e"]]],[11,"from_ok","","",114,[[["t"]],["t"]]],[11,"map_same","","",114,[[["self"],["f"]],["t"]]],[11,"to_owned","","",114,[[["self"]],["t"]]],[11,"clone_into","","",114,N],[11,"from","","",114,[[["t"]],["t"]]],[11,"into","","",114,[[["self"]],["u"]]],[11,"try_from","","",114,[[["u"]],["result"]]],[11,"borrow","","",114,[[["self"]],["t"]]],[11,"try_into","","",114,[[["self"]],["result"]]],[11,"borrow_mut","","",114,[[["self"]],["t"]]],[11,"get_type_id","","",114,[[["self"]],["typeid"]]],[11,"encode","","",114,[[["self"],["e"]],["result"]]],[11,"decode","","",114,[[["d"]],["result"]]],[11,"not_found","","",114,[[["str"],["str"]],["e"]]],[11,"from_ok","","",115,[[["t"]],["t"]]],[11,"map_same","","",115,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",115,N],[11,"to_owned","","",115,[[["self"]],["t"]]],[11,"clone_into","","",115,N],[11,"from","","",115,[[["t"]],["t"]]],[11,"into","","",115,[[["self"]],["u"]]],[11,"try_from","","",115,[[["u"]],["result"]]],[11,"borrow","","",115,[[["self"]],["t"]]],[11,"try_into","","",115,[[["self"]],["result"]]],[11,"borrow_mut","","",115,[[["self"]],["t"]]],[11,"get_type_id","","",115,[[["self"]],["typeid"]]],[11,"encode","","",115,[[["self"],["e"]],["result"]]],[11,"decode","","",115,[[["d"]],["result"]]],[11,"not_found","","",115,[[["str"],["str"]],["e"]]],[11,"from_ok","","",116,[[["t"]],["t"]]],[11,"map_same","","",116,[[["self"],["f"]],["t"]]],[11,"to_owned","","",116,[[["self"]],["t"]]],[11,"clone_into","","",116,N],[11,"from","","",116,[[["t"]],["t"]]],[11,"into","","",116,[[["self"]],["u"]]],[11,"try_from","","",116,[[["u"]],["result"]]],[11,"borrow","","",116,[[["self"]],["t"]]],[11,"try_into","","",116,[[["self"]],["result"]]],[11,"borrow_mut","","",116,[[["self"]],["t"]]],[11,"get_type_id","","",116,[[["self"]],["typeid"]]],[11,"encode","","",116,[[["self"],["e"]],["result"]]],[11,"decode","","",116,[[["d"]],["result"]]],[11,"not_found","","",116,[[["str"],["str"]],["e"]]],[11,"from_ok","","",117,[[["t"]],["t"]]],[11,"map_same","","",117,[[["self"],["f"]],["t"]]],[11,"to_owned","","",117,[[["self"]],["t"]]],[11,"clone_into","","",117,N],[11,"from","","",117,[[["t"]],["t"]]],[11,"to_string","","",117,[[["self"]],["string"]]],[11,"into","","",117,[[["self"]],["u"]]],[11,"try_from","","",117,[[["u"]],["result"]]],[11,"borrow","","",117,[[["self"]],["t"]]],[11,"try_into","","",117,[[["self"]],["result"]]],[11,"borrow_mut","","",117,[[["self"]],["t"]]],[11,"get_type_id","","",117,[[["self"]],["typeid"]]],[11,"encode","","",117,[[["self"],["e"]],["result"]]],[11,"decode","","",117,[[["d"]],["result"]]],[11,"not_found","","",117,[[["str"],["str"]],["e"]]],[11,"from_ok","","",118,[[["t"]],["t"]]],[11,"map_same","","",118,[[["self"],["f"]],["t"]]],[11,"to_owned","","",118,[[["self"]],["t"]]],[11,"clone_into","","",118,N],[11,"from","","",118,[[["t"]],["t"]]],[11,"into","","",118,[[["self"]],["u"]]],[11,"try_from","","",118,[[["u"]],["result"]]],[11,"borrow","","",118,[[["self"]],["t"]]],[11,"try_into","","",118,[[["self"]],["result"]]],[11,"borrow_mut","","",118,[[["self"]],["t"]]],[11,"get_type_id","","",118,[[["self"]],["typeid"]]],[11,"encode","","",118,[[["self"],["e"]],["result"]]],[11,"decode","","",118,[[["d"]],["result"]]],[11,"not_found","","",118,[[["str"],["str"]],["e"]]],[11,"from_ok","","",119,[[["t"]],["t"]]],[11,"map_same","","",119,[[["self"],["f"]],["t"]]],[11,"to_owned","","",119,[[["self"]],["t"]]],[11,"clone_into","","",119,N],[11,"from","","",119,[[["t"]],["t"]]],[11,"into","","",119,[[["self"]],["u"]]],[11,"try_from","","",119,[[["u"]],["result"]]],[11,"borrow","","",119,[[["self"]],["t"]]],[11,"try_into","","",119,[[["self"]],["result"]]],[11,"borrow_mut","","",119,[[["self"]],["t"]]],[11,"get_type_id","","",119,[[["self"]],["typeid"]]],[11,"encode","","",119,[[["self"],["e"]],["result"]]],[11,"decode","","",119,[[["d"]],["result"]]],[11,"not_found","","",119,[[["str"],["str"]],["e"]]],[11,"from_ok","","",120,[[["t"]],["t"]]],[11,"map_same","","",120,[[["self"],["f"]],["t"]]],[11,"to_owned","","",120,[[["self"]],["t"]]],[11,"clone_into","","",120,N],[11,"from","","",120,[[["t"]],["t"]]],[11,"into","","",120,[[["self"]],["u"]]],[11,"try_from","","",120,[[["u"]],["result"]]],[11,"borrow","","",120,[[["self"]],["t"]]],[11,"try_into","","",120,[[["self"]],["result"]]],[11,"borrow_mut","","",120,[[["self"]],["t"]]],[11,"get_type_id","","",120,[[["self"]],["typeid"]]],[11,"encode","","",120,[[["self"],["e"]],["result"]]],[11,"decode","","",120,[[["d"]],["result"]]],[11,"not_found","","",120,[[["str"],["str"]],["e"]]],[11,"from_ok","","",121,[[["t"]],["t"]]],[11,"map_same","","",121,[[["self"],["f"]],["t"]]],[11,"to_owned","","",121,[[["self"]],["t"]]],[11,"clone_into","","",121,N],[11,"from","","",121,[[["t"]],["t"]]],[11,"into","","",121,[[["self"]],["u"]]],[11,"try_from","","",121,[[["u"]],["result"]]],[11,"borrow","","",121,[[["self"]],["t"]]],[11,"try_into","","",121,[[["self"]],["result"]]],[11,"borrow_mut","","",121,[[["self"]],["t"]]],[11,"get_type_id","","",121,[[["self"]],["typeid"]]],[11,"encode","","",121,[[["self"],["e"]],["result"]]],[11,"decode","","",121,[[["d"]],["result"]]],[11,"not_found","","",121,[[["str"],["str"]],["e"]]],[11,"from_ok","","",122,[[["t"]],["t"]]],[11,"map_same","","",122,[[["self"],["f"]],["t"]]],[11,"to_owned","","",122,[[["self"]],["t"]]],[11,"clone_into","","",122,N],[11,"from","","",122,[[["t"]],["t"]]],[11,"into","","",122,[[["self"]],["u"]]],[11,"try_from","","",122,[[["u"]],["result"]]],[11,"borrow","","",122,[[["self"]],["t"]]],[11,"try_into","","",122,[[["self"]],["result"]]],[11,"borrow_mut","","",122,[[["self"]],["t"]]],[11,"get_type_id","","",122,[[["self"]],["typeid"]]],[11,"encode","","",122,[[["self"],["e"]],["result"]]],[11,"decode","","",122,[[["d"]],["result"]]],[11,"not_found","","",122,[[["str"],["str"]],["e"]]],[11,"from_ok","","",123,[[["t"]],["t"]]],[11,"map_same","","",123,[[["self"],["f"]],["t"]]],[11,"to_owned","","",123,[[["self"]],["t"]]],[11,"clone_into","","",123,N],[11,"from","","",123,[[["t"]],["t"]]],[11,"into","","",123,[[["self"]],["u"]]],[11,"try_from","","",123,[[["u"]],["result"]]],[11,"borrow","","",123,[[["self"]],["t"]]],[11,"try_into","","",123,[[["self"]],["result"]]],[11,"borrow_mut","","",123,[[["self"]],["t"]]],[11,"get_type_id","","",123,[[["self"]],["typeid"]]],[11,"encode","","",123,[[["self"],["e"]],["result"]]],[11,"decode","","",123,[[["d"]],["result"]]],[11,"not_found","","",123,[[["str"],["str"]],["e"]]],[11,"from_ok","","",124,[[["t"]],["t"]]],[11,"map_same","","",124,[[["self"],["f"]],["t"]]],[11,"to_owned","","",124,[[["self"]],["t"]]],[11,"clone_into","","",124,N],[11,"from","","",124,[[["t"]],["t"]]],[11,"into","","",124,[[["self"]],["u"]]],[11,"try_from","","",124,[[["u"]],["result"]]],[11,"borrow","","",124,[[["self"]],["t"]]],[11,"try_into","","",124,[[["self"]],["result"]]],[11,"borrow_mut","","",124,[[["self"]],["t"]]],[11,"get_type_id","","",124,[[["self"]],["typeid"]]],[11,"encode","","",124,[[["self"],["e"]],["result"]]],[11,"decode","","",124,[[["d"]],["result"]]],[11,"not_found","","",124,[[["str"],["str"]],["e"]]],[11,"from_ok","","",125,[[["t"]],["t"]]],[11,"map_same","","",125,[[["self"],["f"]],["t"]]],[11,"to_owned","","",125,[[["self"]],["t"]]],[11,"clone_into","","",125,N],[11,"from","","",125,[[["t"]],["t"]]],[11,"into","","",125,[[["self"]],["u"]]],[11,"try_from","","",125,[[["u"]],["result"]]],[11,"borrow","","",125,[[["self"]],["t"]]],[11,"try_into","","",125,[[["self"]],["result"]]],[11,"borrow_mut","","",125,[[["self"]],["t"]]],[11,"get_type_id","","",125,[[["self"]],["typeid"]]],[11,"encode","","",125,[[["self"],["e"]],["result"]]],[11,"decode","","",125,[[["d"]],["result"]]],[11,"not_found","","",125,[[["str"],["str"]],["e"]]],[11,"from_ok","","",126,[[["t"]],["t"]]],[11,"map_same","","",126,[[["self"],["f"]],["t"]]],[11,"to_owned","","",126,[[["self"]],["t"]]],[11,"clone_into","","",126,N],[11,"from","","",126,[[["t"]],["t"]]],[11,"into","","",126,[[["self"]],["u"]]],[11,"try_from","","",126,[[["u"]],["result"]]],[11,"borrow","","",126,[[["self"]],["t"]]],[11,"try_into","","",126,[[["self"]],["result"]]],[11,"borrow_mut","","",126,[[["self"]],["t"]]],[11,"get_type_id","","",126,[[["self"]],["typeid"]]],[11,"encode","","",126,[[["self"],["e"]],["result"]]],[11,"decode","","",126,[[["d"]],["result"]]],[11,"not_found","","",126,[[["str"],["str"]],["e"]]],[11,"from_ok","","",127,[[["t"]],["t"]]],[11,"map_same","","",127,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",127,N],[11,"to_owned","","",127,[[["self"]],["t"]]],[11,"clone_into","","",127,N],[11,"from","","",127,[[["t"]],["t"]]],[11,"to_string","","",127,[[["self"]],["string"]]],[11,"into","","",127,[[["self"]],["u"]]],[11,"try_from","","",127,[[["u"]],["result"]]],[11,"borrow","","",127,[[["self"]],["t"]]],[11,"try_into","","",127,[[["self"]],["result"]]],[11,"borrow_mut","","",127,[[["self"]],["t"]]],[11,"get_type_id","","",127,[[["self"]],["typeid"]]],[11,"encode","","",127,[[["self"],["e"]],["result"]]],[11,"decode","","",127,[[["d"]],["result"]]],[11,"not_found","","",127,[[["str"],["str"]],["e"]]],[11,"from_ok","","",128,[[["t"]],["t"]]],[11,"map_same","","",128,[[["self"],["f"]],["t"]]],[11,"to_owned","","",128,[[["self"]],["t"]]],[11,"clone_into","","",128,N],[11,"from","","",128,[[["t"]],["t"]]],[11,"into","","",128,[[["self"]],["u"]]],[11,"try_from","","",128,[[["u"]],["result"]]],[11,"borrow","","",128,[[["self"]],["t"]]],[11,"try_into","","",128,[[["self"]],["result"]]],[11,"borrow_mut","","",128,[[["self"]],["t"]]],[11,"get_type_id","","",128,[[["self"]],["typeid"]]],[11,"encode","","",128,[[["self"],["e"]],["result"]]],[11,"decode","","",128,[[["d"]],["result"]]],[11,"not_found","","",128,[[["str"],["str"]],["e"]]],[11,"from_ok","","",129,[[["t"]],["t"]]],[11,"map_same","","",129,[[["self"],["f"]],["t"]]],[11,"to_owned","","",129,[[["self"]],["t"]]],[11,"clone_into","","",129,N],[11,"from","","",129,[[["t"]],["t"]]],[11,"into","","",129,[[["self"]],["u"]]],[11,"try_from","","",129,[[["u"]],["result"]]],[11,"borrow","","",129,[[["self"]],["t"]]],[11,"try_into","","",129,[[["self"]],["result"]]],[11,"borrow_mut","","",129,[[["self"]],["t"]]],[11,"get_type_id","","",129,[[["self"]],["typeid"]]],[11,"encode","","",129,[[["self"],["e"]],["result"]]],[11,"decode","","",129,[[["d"]],["result"]]],[11,"not_found","","",129,[[["str"],["str"]],["e"]]],[11,"from_ok","","",130,[[["t"]],["t"]]],[11,"map_same","","",130,[[["self"],["f"]],["t"]]],[11,"to_owned","","",130,[[["self"]],["t"]]],[11,"clone_into","","",130,N],[11,"from","","",130,[[["t"]],["t"]]],[11,"into","","",130,[[["self"]],["u"]]],[11,"try_from","","",130,[[["u"]],["result"]]],[11,"borrow","","",130,[[["self"]],["t"]]],[11,"try_into","","",130,[[["self"]],["result"]]],[11,"borrow_mut","","",130,[[["self"]],["t"]]],[11,"get_type_id","","",130,[[["self"]],["typeid"]]],[11,"encode","","",130,[[["self"],["e"]],["result"]]],[11,"decode","","",130,[[["d"]],["result"]]],[11,"not_found","","",130,[[["str"],["str"]],["e"]]],[11,"from_ok","","",131,[[["t"]],["t"]]],[11,"map_same","","",131,[[["self"],["f"]],["t"]]],[11,"to_owned","","",131,[[["self"]],["t"]]],[11,"clone_into","","",131,N],[11,"from","","",131,[[["t"]],["t"]]],[11,"into","","",131,[[["self"]],["u"]]],[11,"try_from","","",131,[[["u"]],["result"]]],[11,"borrow","","",131,[[["self"]],["t"]]],[11,"try_into","","",131,[[["self"]],["result"]]],[11,"borrow_mut","","",131,[[["self"]],["t"]]],[11,"get_type_id","","",131,[[["self"]],["typeid"]]],[11,"encode","","",131,[[["self"],["e"]],["result"]]],[11,"decode","","",131,[[["d"]],["result"]]],[11,"not_found","","",131,[[["str"],["str"]],["e"]]],[11,"from_ok","","",132,[[["t"]],["t"]]],[11,"map_same","","",132,[[["self"],["f"]],["t"]]],[11,"to_owned","","",132,[[["self"]],["t"]]],[11,"clone_into","","",132,N],[11,"from","","",132,[[["t"]],["t"]]],[11,"into","","",132,[[["self"]],["u"]]],[11,"try_from","","",132,[[["u"]],["result"]]],[11,"borrow","","",132,[[["self"]],["t"]]],[11,"try_into","","",132,[[["self"]],["result"]]],[11,"borrow_mut","","",132,[[["self"]],["t"]]],[11,"get_type_id","","",132,[[["self"]],["typeid"]]],[11,"encode","","",132,[[["self"],["e"]],["result"]]],[11,"decode","","",132,[[["d"]],["result"]]],[11,"not_found","","",132,[[["str"],["str"]],["e"]]],[11,"from_ok","","",133,[[["t"]],["t"]]],[11,"map_same","","",133,[[["self"],["f"]],["t"]]],[11,"to_owned","","",133,[[["self"]],["t"]]],[11,"clone_into","","",133,N],[11,"from","","",133,[[["t"]],["t"]]],[11,"into","","",133,[[["self"]],["u"]]],[11,"try_from","","",133,[[["u"]],["result"]]],[11,"borrow","","",133,[[["self"]],["t"]]],[11,"try_into","","",133,[[["self"]],["result"]]],[11,"borrow_mut","","",133,[[["self"]],["t"]]],[11,"get_type_id","","",133,[[["self"]],["typeid"]]],[11,"encode","","",133,[[["self"],["e"]],["result"]]],[11,"decode","","",133,[[["d"]],["result"]]],[11,"not_found","","",133,[[["str"],["str"]],["e"]]],[11,"from_ok","","",134,[[["t"]],["t"]]],[11,"map_same","","",134,[[["self"],["f"]],["t"]]],[11,"to_owned","","",134,[[["self"]],["t"]]],[11,"clone_into","","",134,N],[11,"from","","",134,[[["t"]],["t"]]],[11,"into","","",134,[[["self"]],["u"]]],[11,"try_from","","",134,[[["u"]],["result"]]],[11,"borrow","","",134,[[["self"]],["t"]]],[11,"try_into","","",134,[[["self"]],["result"]]],[11,"borrow_mut","","",134,[[["self"]],["t"]]],[11,"get_type_id","","",134,[[["self"]],["typeid"]]],[11,"encode","","",134,[[["self"],["e"]],["result"]]],[11,"decode","","",134,[[["d"]],["result"]]],[11,"not_found","","",134,[[["str"],["str"]],["e"]]],[11,"from_ok","","",135,[[["t"]],["t"]]],[11,"map_same","","",135,[[["self"],["f"]],["t"]]],[11,"to_owned","","",135,[[["self"]],["t"]]],[11,"clone_into","","",135,N],[11,"from","","",135,[[["t"]],["t"]]],[11,"into","","",135,[[["self"]],["u"]]],[11,"try_from","","",135,[[["u"]],["result"]]],[11,"borrow","","",135,[[["self"]],["t"]]],[11,"try_into","","",135,[[["self"]],["result"]]],[11,"borrow_mut","","",135,[[["self"]],["t"]]],[11,"get_type_id","","",135,[[["self"]],["typeid"]]],[11,"encode","","",135,[[["self"],["e"]],["result"]]],[11,"decode","","",135,[[["d"]],["result"]]],[11,"not_found","","",135,[[["str"],["str"]],["e"]]],[11,"from_ok","","",136,[[["t"]],["t"]]],[11,"map_same","","",136,[[["self"],["f"]],["t"]]],[11,"to_owned","","",136,[[["self"]],["t"]]],[11,"clone_into","","",136,N],[11,"from","","",136,[[["t"]],["t"]]],[11,"into","","",136,[[["self"]],["u"]]],[11,"try_from","","",136,[[["u"]],["result"]]],[11,"borrow","","",136,[[["self"]],["t"]]],[11,"try_into","","",136,[[["self"]],["result"]]],[11,"borrow_mut","","",136,[[["self"]],["t"]]],[11,"get_type_id","","",136,[[["self"]],["typeid"]]],[11,"encode","","",136,[[["self"],["e"]],["result"]]],[11,"decode","","",136,[[["d"]],["result"]]],[11,"not_found","","",136,[[["str"],["str"]],["e"]]],[11,"from_ok","","",137,[[["t"]],["t"]]],[11,"map_same","","",137,[[["self"],["f"]],["t"]]],[11,"to_owned","","",137,[[["self"]],["t"]]],[11,"clone_into","","",137,N],[11,"from","","",137,[[["t"]],["t"]]],[11,"into","","",137,[[["self"]],["u"]]],[11,"try_from","","",137,[[["u"]],["result"]]],[11,"borrow","","",137,[[["self"]],["t"]]],[11,"try_into","","",137,[[["self"]],["result"]]],[11,"borrow_mut","","",137,[[["self"]],["t"]]],[11,"get_type_id","","",137,[[["self"]],["typeid"]]],[11,"encode","","",137,[[["self"],["e"]],["result"]]],[11,"decode","","",137,[[["d"]],["result"]]],[11,"not_found","","",137,[[["str"],["str"]],["e"]]],[11,"from_ok","","",138,[[["t"]],["t"]]],[11,"map_same","","",138,[[["self"],["f"]],["t"]]],[11,"to_owned","","",138,[[["self"]],["t"]]],[11,"clone_into","","",138,N],[11,"from","","",138,[[["t"]],["t"]]],[11,"into","","",138,[[["self"]],["u"]]],[11,"try_from","","",138,[[["u"]],["result"]]],[11,"borrow","","",138,[[["self"]],["t"]]],[11,"try_into","","",138,[[["self"]],["result"]]],[11,"borrow_mut","","",138,[[["self"]],["t"]]],[11,"get_type_id","","",138,[[["self"]],["typeid"]]],[11,"not_found","","",138,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::check_attr","",139,[[["t"]],["t"]]],[11,"map_same","","",139,[[["self"],["f"]],["t"]]],[11,"from","","",139,[[["t"]],["t"]]],[11,"into","","",139,[[["self"]],["u"]]],[11,"try_from","","",139,[[["u"]],["result"]]],[11,"borrow","","",139,[[["self"]],["t"]]],[11,"try_into","","",139,[[["self"]],["result"]]],[11,"borrow_mut","","",139,[[["self"]],["t"]]],[11,"get_type_id","","",139,[[["self"]],["typeid"]]],[11,"not_found","","",139,[[["str"],["str"]],["e"]]],[11,"from_ok","","",140,[[["t"]],["t"]]],[11,"map_same","","",140,[[["self"],["f"]],["t"]]],[11,"to_owned","","",140,[[["self"]],["t"]]],[11,"clone_into","","",140,N],[11,"from","","",140,[[["t"]],["t"]]],[11,"into","","",140,[[["self"]],["u"]]],[11,"try_from","","",140,[[["u"]],["result"]]],[11,"borrow","","",140,[[["self"]],["t"]]],[11,"try_into","","",140,[[["self"]],["result"]]],[11,"borrow_mut","","",140,[[["self"]],["t"]]],[11,"get_type_id","","",140,[[["self"]],["typeid"]]],[11,"not_found","","",140,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::def","",141,[[["t"]],["t"]]],[11,"map_same","","",141,[[["self"],["f"]],["t"]]],[11,"to_owned","","",141,[[["self"]],["t"]]],[11,"clone_into","","",141,N],[11,"from","","",141,[[["t"]],["t"]]],[11,"into","","",141,[[["self"]],["u"]]],[11,"try_from","","",141,[[["u"]],["result"]]],[11,"borrow","","",141,[[["self"]],["t"]]],[11,"try_into","","",141,[[["self"]],["result"]]],[11,"borrow_mut","","",141,[[["self"]],["t"]]],[11,"get_type_id","","",141,[[["self"]],["typeid"]]],[11,"not_found","","",141,[[["str"],["str"]],["e"]]],[11,"from_ok","","",142,[[["t"]],["t"]]],[11,"map_same","","",142,[[["self"],["f"]],["t"]]],[11,"to_owned","","",142,[[["self"]],["t"]]],[11,"clone_into","","",142,N],[11,"from","","",142,[[["t"]],["t"]]],[11,"into","","",142,[[["self"]],["u"]]],[11,"try_from","","",142,[[["u"]],["result"]]],[11,"borrow","","",142,[[["self"]],["t"]]],[11,"try_into","","",142,[[["self"]],["result"]]],[11,"borrow_mut","","",142,[[["self"]],["t"]]],[11,"get_type_id","","",142,[[["self"]],["typeid"]]],[11,"not_found","","",142,[[["str"],["str"]],["e"]]],[11,"from_ok","","",143,[[["t"]],["t"]]],[11,"map_same","","",143,[[["self"],["f"]],["t"]]],[11,"to_owned","","",143,[[["self"]],["t"]]],[11,"clone_into","","",143,N],[11,"from","","",143,[[["t"]],["t"]]],[11,"into","","",143,[[["self"]],["u"]]],[11,"try_from","","",143,[[["u"]],["result"]]],[11,"borrow","","",143,[[["self"]],["t"]]],[11,"try_into","","",143,[[["self"]],["result"]]],[11,"borrow_mut","","",143,[[["self"]],["t"]]],[11,"get_type_id","","",143,[[["self"]],["typeid"]]],[11,"encode","","",143,[[["self"],["e"]],["result"]]],[11,"decode","","",143,[[["d"]],["result"]]],[11,"not_found","","",143,[[["str"],["str"]],["e"]]],[11,"from_ok","","",144,[[["t"]],["t"]]],[11,"map_same","","",144,[[["self"],["f"]],["t"]]],[11,"to_owned","","",144,[[["self"]],["t"]]],[11,"clone_into","","",144,N],[11,"from","","",144,[[["t"]],["t"]]],[11,"into","","",144,[[["self"]],["u"]]],[11,"try_from","","",144,[[["u"]],["result"]]],[11,"borrow","","",144,[[["self"]],["t"]]],[11,"try_into","","",144,[[["self"]],["result"]]],[11,"borrow_mut","","",144,[[["self"]],["t"]]],[11,"get_type_id","","",144,[[["self"]],["typeid"]]],[11,"encode","","",144,[[["self"],["e"]],["result"]]],[11,"decode","","",144,[[["d"]],["result"]]],[11,"not_found","","",144,[[["str"],["str"]],["e"]]],[11,"from_ok","","",145,[[["t"]],["t"]]],[11,"map_same","","",145,[[["self"],["f"]],["t"]]],[11,"to_owned","","",145,[[["self"]],["t"]]],[11,"clone_into","","",145,N],[11,"from","","",145,[[["t"]],["t"]]],[11,"into","","",145,[[["self"]],["u"]]],[11,"try_from","","",145,[[["u"]],["result"]]],[11,"borrow","","",145,[[["self"]],["t"]]],[11,"try_into","","",145,[[["self"]],["result"]]],[11,"borrow_mut","","",145,[[["self"]],["t"]]],[11,"get_type_id","","",145,[[["self"]],["typeid"]]],[11,"encode","","",145,[[["self"],["e"]],["result"]]],[11,"decode","","",145,[[["d"]],["result"]]],[11,"not_found","","",145,[[["str"],["str"]],["e"]]],[11,"from_ok","","",146,[[["t"]],["t"]]],[11,"map_same","","",146,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",146,N],[11,"to_owned","","",146,[[["self"]],["t"]]],[11,"clone_into","","",146,N],[11,"from","","",146,[[["t"]],["t"]]],[11,"into","","",146,[[["self"]],["u"]]],[11,"try_from","","",146,[[["u"]],["result"]]],[11,"borrow","","",146,[[["self"]],["t"]]],[11,"try_into","","",146,[[["self"]],["result"]]],[11,"borrow_mut","","",146,[[["self"]],["t"]]],[11,"get_type_id","","",146,[[["self"]],["typeid"]]],[11,"encode","","",146,[[["self"],["e"]],["result"]]],[11,"decode","","",146,[[["d"]],["result"]]],[11,"not_found","","",146,[[["str"],["str"]],["e"]]],[11,"from_ok","","",147,[[["t"]],["t"]]],[11,"map_same","","",147,[[["self"],["f"]],["t"]]],[11,"to_owned","","",147,[[["self"]],["t"]]],[11,"clone_into","","",147,N],[11,"from","","",147,[[["t"]],["t"]]],[11,"into","","",147,[[["self"]],["u"]]],[11,"try_from","","",147,[[["u"]],["result"]]],[11,"borrow","","",147,[[["self"]],["t"]]],[11,"try_into","","",147,[[["self"]],["result"]]],[11,"borrow_mut","","",147,[[["self"]],["t"]]],[11,"get_type_id","","",147,[[["self"]],["typeid"]]],[11,"not_found","","",147,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::def_id","",148,[[["t"]],["t"]]],[11,"map_same","","",148,[[["self"],["f"]],["t"]]],[11,"to_owned","","",148,[[["self"]],["t"]]],[11,"clone_into","","",148,N],[11,"from","","",148,[[["t"]],["t"]]],[11,"into","","",148,[[["self"]],["u"]]],[11,"try_from","","",148,[[["u"]],["result"]]],[11,"borrow","","",148,[[["self"]],["t"]]],[11,"try_into","","",148,[[["self"]],["result"]]],[11,"borrow_mut","","",148,[[["self"]],["t"]]],[11,"get_type_id","","",148,[[["self"]],["typeid"]]],[11,"not_found","","",148,[[["str"],["str"]],["e"]]],[11,"from_ok","","",149,[[["t"]],["t"]]],[11,"map_same","","",149,[[["self"],["f"]],["t"]]],[11,"to_owned","","",149,[[["self"]],["t"]]],[11,"clone_into","","",149,N],[11,"from","","",149,[[["t"]],["t"]]],[11,"into","","",149,[[["self"]],["u"]]],[11,"try_from","","",149,[[["u"]],["result"]]],[11,"borrow","","",149,[[["self"]],["t"]]],[11,"try_into","","",149,[[["self"]],["result"]]],[11,"borrow_mut","","",149,[[["self"]],["t"]]],[11,"get_type_id","","",149,[[["self"]],["typeid"]]],[11,"encode","","",149,[[["self"],["e"]],["result"]]],[11,"decode","","",149,[[["d"]],["result"]]],[11,"not_found","","",149,[[["str"],["str"]],["e"]]],[11,"from_ok","","",150,[[["t"]],["t"]]],[11,"map_same","","",150,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",150,N],[11,"to_owned","","",150,[[["self"]],["t"]]],[11,"clone_into","","",150,N],[11,"from","","",150,[[["t"]],["t"]]],[11,"into","","",150,[[["self"]],["u"]]],[11,"try_from","","",150,[[["u"]],["result"]]],[11,"borrow","","",150,[[["self"]],["t"]]],[11,"try_into","","",150,[[["self"]],["result"]]],[11,"borrow_mut","","",150,[[["self"]],["t"]]],[11,"get_type_id","","",150,[[["self"]],["typeid"]]],[11,"encode","","",150,[[["self"],["e"]],["result"]]],[11,"decode","","",150,[[["d"]],["result"]]],[11,"not_found","","",150,[[["str"],["str"]],["e"]]],[11,"from_ok","","",151,[[["t"]],["t"]]],[11,"map_same","","",151,[[["self"],["f"]],["t"]]],[11,"to_owned","","",151,[[["self"]],["t"]]],[11,"clone_into","","",151,N],[11,"from","","",151,[[["t"]],["t"]]],[11,"into","","",151,[[["self"]],["u"]]],[11,"try_from","","",151,[[["u"]],["result"]]],[11,"borrow","","",151,[[["self"]],["t"]]],[11,"try_into","","",151,[[["self"]],["result"]]],[11,"borrow_mut","","",151,[[["self"]],["t"]]],[11,"get_type_id","","",151,[[["self"]],["typeid"]]],[11,"encode","","",151,[[["self"],["e"]],["result"]]],[11,"decode","","",151,[[["d"]],["result"]]],[11,"not_found","","",151,[[["str"],["str"]],["e"]]],[11,"from_ok","","",152,[[["t"]],["t"]]],[11,"map_same","","",152,[[["self"],["f"]],["t"]]],[11,"to_owned","","",152,[[["self"]],["t"]]],[11,"clone_into","","",152,N],[11,"from","","",152,[[["t"]],["t"]]],[11,"to_string","","",152,[[["self"]],["string"]]],[11,"into","","",152,[[["self"]],["u"]]],[11,"try_from","","",152,[[["u"]],["result"]]],[11,"borrow","","",152,[[["self"]],["t"]]],[11,"try_into","","",152,[[["self"]],["result"]]],[11,"borrow_mut","","",152,[[["self"]],["t"]]],[11,"get_type_id","","",152,[[["self"]],["typeid"]]],[11,"encode","","",152,[[["self"],["e"]],["result"]]],[11,"decode","","",152,[[["d"]],["result"]]],[11,"not_found","","",152,[[["str"],["str"]],["e"]]],[11,"from_ok","","",153,[[["t"]],["t"]]],[11,"map_same","","",153,[[["self"],["f"]],["t"]]],[11,"to_owned","","",153,[[["self"]],["t"]]],[11,"clone_into","","",153,N],[11,"from","","",153,[[["t"]],["t"]]],[11,"into","","",153,[[["self"]],["u"]]],[11,"try_from","","",153,[[["u"]],["result"]]],[11,"borrow","","",153,[[["self"]],["t"]]],[11,"try_into","","",153,[[["self"]],["result"]]],[11,"borrow_mut","","",153,[[["self"]],["t"]]],[11,"get_type_id","","",153,[[["self"]],["typeid"]]],[11,"not_found","","",153,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::intravisit","",154,[[["t"]],["t"]]],[11,"map_same","","",154,[[["self"],["f"]],["t"]]],[11,"to_owned","","",154,[[["self"]],["t"]]],[11,"clone_into","","",154,N],[11,"from","","",154,[[["t"]],["t"]]],[11,"into","","",154,[[["self"]],["u"]]],[11,"try_from","","",154,[[["u"]],["result"]]],[11,"borrow","","",154,[[["self"]],["t"]]],[11,"try_into","","",154,[[["self"]],["result"]]],[11,"borrow_mut","","",154,[[["self"]],["t"]]],[11,"get_type_id","","",154,[[["self"]],["typeid"]]],[11,"encode","","",154,[[["self"],["e"]],["result"]]],[11,"decode","","",154,[[["d"]],["result"]]],[11,"not_found","","",154,[[["str"],["str"]],["e"]]],[11,"from_ok","","",155,[[["t"]],["t"]]],[11,"map_same","","",155,[[["self"],["f"]],["t"]]],[11,"from","","",155,[[["t"]],["t"]]],[11,"into","","",155,[[["self"]],["u"]]],[11,"try_from","","",155,[[["u"]],["result"]]],[11,"borrow","","",155,[[["self"]],["t"]]],[11,"try_into","","",155,[[["self"]],["result"]]],[11,"borrow_mut","","",155,[[["self"]],["t"]]],[11,"get_type_id","","",155,[[["self"]],["typeid"]]],[11,"not_found","","",155,[[["str"],["str"]],["e"]]],[11,"from_ok","","",156,[[["t"]],["t"]]],[11,"map_same","","",156,[[["self"],["f"]],["t"]]],[11,"to_owned","","",156,[[["self"]],["t"]]],[11,"clone_into","","",156,N],[11,"from","","",156,[[["t"]],["t"]]],[11,"into","","",156,[[["self"]],["u"]]],[11,"try_from","","",156,[[["u"]],["result"]]],[11,"borrow","","",156,[[["self"]],["t"]]],[11,"try_into","","",156,[[["self"]],["result"]]],[11,"borrow_mut","","",156,[[["self"]],["t"]]],[11,"get_type_id","","",156,[[["self"]],["typeid"]]],[11,"not_found","","",156,[[["str"],["str"]],["e"]]],[11,"from_ok","","",157,[[["t"]],["t"]]],[11,"map_same","","",157,[[["self"],["f"]],["t"]]],[11,"from","","",157,[[["t"]],["t"]]],[11,"into","","",157,[[["self"]],["u"]]],[11,"try_from","","",157,[[["u"]],["result"]]],[11,"borrow","","",157,[[["self"]],["t"]]],[11,"try_into","","",157,[[["self"]],["result"]]],[11,"borrow_mut","","",157,[[["self"]],["t"]]],[11,"get_type_id","","",157,[[["self"]],["typeid"]]],[11,"not_found","","",157,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::itemlikevisit","",159,[[["t"]],["t"]]],[11,"map_same","","",159,[[["self"],["f"]],["t"]]],[11,"from","","",159,[[["t"]],["t"]]],[11,"into","","",159,[[["self"]],["u"]]],[11,"try_from","","",159,[[["u"]],["result"]]],[11,"borrow","","",159,[[["self"]],["t"]]],[11,"try_into","","",159,[[["self"]],["result"]]],[11,"borrow_mut","","",159,[[["self"]],["t"]]],[11,"get_type_id","","",159,[[["self"]],["typeid"]]],[11,"not_found","","",159,[[["str"],["str"]],["e"]]],[11,"from_ok","","",160,[[["t"]],["t"]]],[11,"map_same","","",160,[[["self"],["f"]],["t"]]],[11,"from","","",160,[[["t"]],["t"]]],[11,"into","","",160,[[["self"]],["u"]]],[11,"try_from","","",160,[[["u"]],["result"]]],[11,"borrow","","",160,[[["self"]],["t"]]],[11,"try_into","","",160,[[["self"]],["result"]]],[11,"borrow_mut","","",160,[[["self"]],["t"]]],[11,"get_type_id","","",160,[[["self"]],["typeid"]]],[11,"not_found","","",160,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::lowering","",164,[[["t"]],["t"]]],[11,"map_same","","",164,[[["self"],["f"]],["t"]]],[11,"from","","",164,[[["t"]],["t"]]],[11,"into","","",164,[[["self"]],["u"]]],[11,"try_from","","",164,[[["u"]],["result"]]],[11,"borrow","","",164,[[["self"]],["t"]]],[11,"try_into","","",164,[[["self"]],["result"]]],[11,"borrow_mut","","",164,[[["self"]],["t"]]],[11,"get_type_id","","",164,[[["self"]],["typeid"]]],[11,"not_found","","",164,[[["str"],["str"]],["e"]]],[11,"from_ok","","",165,[[["t"]],["t"]]],[11,"map_same","","",165,[[["self"],["f"]],["t"]]],[11,"from","","",165,[[["t"]],["t"]]],[11,"into","","",165,[[["self"]],["u"]]],[11,"try_from","","",165,[[["u"]],["result"]]],[11,"borrow","","",165,[[["self"]],["t"]]],[11,"try_into","","",165,[[["self"]],["result"]]],[11,"borrow_mut","","",165,[[["self"]],["t"]]],[11,"get_type_id","","",165,[[["self"]],["typeid"]]],[11,"not_found","","",165,[[["str"],["str"]],["e"]]],[11,"from_ok","","",166,[[["t"]],["t"]]],[11,"map_same","","",166,[[["self"],["f"]],["t"]]],[11,"from","","",166,[[["t"]],["t"]]],[11,"into","","",166,[[["self"]],["u"]]],[11,"try_from","","",166,[[["u"]],["result"]]],[11,"borrow","","",166,[[["self"]],["t"]]],[11,"try_into","","",166,[[["self"]],["result"]]],[11,"borrow_mut","","",166,[[["self"]],["t"]]],[11,"get_type_id","","",166,[[["self"]],["typeid"]]],[11,"not_found","","",166,[[["str"],["str"]],["e"]]],[11,"from_ok","","",167,[[["t"]],["t"]]],[11,"map_same","","",167,[[["self"],["f"]],["t"]]],[11,"to_owned","","",167,[[["self"]],["t"]]],[11,"clone_into","","",167,N],[11,"from","","",167,[[["t"]],["t"]]],[11,"into","","",167,[[["self"]],["u"]]],[11,"try_from","","",167,[[["u"]],["result"]]],[11,"borrow","","",167,[[["self"]],["t"]]],[11,"try_into","","",167,[[["self"]],["result"]]],[11,"borrow_mut","","",167,[[["self"]],["t"]]],[11,"get_type_id","","",167,[[["self"]],["typeid"]]],[11,"not_found","","",167,[[["str"],["str"]],["e"]]],[11,"from_ok","","",168,[[["t"]],["t"]]],[11,"map_same","","",168,[[["self"],["f"]],["t"]]],[11,"from","","",168,[[["t"]],["t"]]],[11,"into","","",168,[[["self"]],["u"]]],[11,"try_from","","",168,[[["u"]],["result"]]],[11,"borrow","","",168,[[["self"]],["t"]]],[11,"try_into","","",168,[[["self"]],["result"]]],[11,"borrow_mut","","",168,[[["self"]],["t"]]],[11,"get_type_id","","",168,[[["self"]],["typeid"]]],[11,"not_found","","",168,[[["str"],["str"]],["e"]]],[11,"from_ok","","",169,[[["t"]],["t"]]],[11,"map_same","","",169,[[["self"],["f"]],["t"]]],[11,"to_owned","","",169,[[["self"]],["t"]]],[11,"clone_into","","",169,N],[11,"from","","",169,[[["t"]],["t"]]],[11,"into","","",169,[[["self"]],["u"]]],[11,"try_from","","",169,[[["u"]],["result"]]],[11,"borrow","","",169,[[["self"]],["t"]]],[11,"try_into","","",169,[[["self"]],["result"]]],[11,"borrow_mut","","",169,[[["self"]],["t"]]],[11,"get_type_id","","",169,[[["self"]],["typeid"]]],[11,"not_found","","",169,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::map","",171,[[["t"]],["t"]]],[11,"map_same","","",171,[[["self"],["f"]],["t"]]],[11,"from","","",171,[[["t"]],["t"]]],[11,"into","","",171,[[["self"]],["u"]]],[11,"try_from","","",171,[[["u"]],["result"]]],[11,"borrow","","",171,[[["self"]],["t"]]],[11,"try_into","","",171,[[["self"]],["result"]]],[11,"borrow_mut","","",171,[[["self"]],["t"]]],[11,"get_type_id","","",171,[[["self"]],["typeid"]]],[11,"not_found","","",171,[[["str"],["str"]],["e"]]],[11,"from_ok","","",172,[[["t"]],["t"]]],[11,"map_same","","",172,[[["self"],["f"]],["t"]]],[11,"from","","",172,[[["t"]],["t"]]],[11,"into","","",172,[[["self"]],["u"]]],[11,"try_from","","",172,[[["u"]],["result"]]],[11,"borrow","","",172,[[["self"]],["t"]]],[11,"try_into","","",172,[[["self"]],["result"]]],[11,"borrow_mut","","",172,[[["self"]],["t"]]],[11,"get_type_id","","",172,[[["self"]],["typeid"]]],[11,"not_found","","",172,[[["str"],["str"]],["e"]]],[11,"from_ok","","",173,[[["t"]],["t"]]],[11,"map_same","","",173,[[["self"],["f"]],["t"]]],[11,"to_owned","","",173,[[["self"]],["t"]]],[11,"clone_into","","",173,N],[11,"from","","",173,[[["t"]],["t"]]],[11,"into","","",173,[[["self"]],["u"]]],[11,"try_from","","",173,[[["u"]],["result"]]],[11,"borrow","","",173,[[["self"]],["t"]]],[11,"try_into","","",173,[[["self"]],["result"]]],[11,"borrow_mut","","",173,[[["self"]],["t"]]],[11,"get_type_id","","",173,[[["self"]],["typeid"]]],[11,"not_found","","",173,[[["str"],["str"]],["e"]]],[11,"from_ok","","",174,[[["t"]],["t"]]],[11,"map_same","","",174,[[["self"],["f"]],["t"]]],[11,"from","","",174,[[["t"]],["t"]]],[11,"into","","",174,[[["self"]],["u"]]],[11,"try_from","","",174,[[["u"]],["result"]]],[11,"borrow","","",174,[[["self"]],["t"]]],[11,"try_into","","",174,[[["self"]],["result"]]],[11,"borrow_mut","","",174,[[["self"]],["t"]]],[11,"get_type_id","","",174,[[["self"]],["typeid"]]],[11,"not_found","","",174,[[["str"],["str"]],["e"]]],[11,"from_ok","","",175,[[["t"]],["t"]]],[11,"map_same","","",175,[[["self"],["f"]],["t"]]],[11,"to_owned","","",175,[[["self"]],["t"]]],[11,"clone_into","","",175,N],[11,"from","","",175,[[["t"]],["t"]]],[11,"into","","",175,[[["self"]],["u"]]],[11,"try_from","","",175,[[["u"]],["result"]]],[11,"borrow","","",175,[[["self"]],["t"]]],[11,"try_into","","",175,[[["self"]],["result"]]],[11,"borrow_mut","","",175,[[["self"]],["t"]]],[11,"get_type_id","","",175,[[["self"]],["typeid"]]],[11,"not_found","","",175,[[["str"],["str"]],["e"]]],[11,"from_ok","","",176,[[["t"]],["t"]]],[11,"map_same","","",176,[[["self"],["f"]],["t"]]],[11,"from","","",176,[[["t"]],["t"]]],[11,"into_iter","","",176,[[["self"]],["i"]]],[11,"into","","",176,[[["self"]],["u"]]],[11,"try_from","","",176,[[["u"]],["result"]]],[11,"borrow","","",176,[[["self"]],["t"]]],[11,"try_into","","",176,[[["self"]],["result"]]],[11,"borrow_mut","","",176,[[["self"]],["t"]]],[11,"get_type_id","","",176,[[["self"]],["typeid"]]],[11,"not_found","","",176,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::map::blocks","",177,[[["t"]],["t"]]],[11,"map_same","","",177,[[["self"],["f"]],["t"]]],[11,"to_owned","","",177,[[["self"]],["t"]]],[11,"clone_into","","",177,N],[11,"from","","",177,[[["t"]],["t"]]],[11,"into","","",177,[[["self"]],["u"]]],[11,"try_from","","",177,[[["u"]],["result"]]],[11,"borrow","","",177,[[["self"]],["t"]]],[11,"try_into","","",177,[[["self"]],["result"]]],[11,"borrow_mut","","",177,[[["self"]],["t"]]],[11,"get_type_id","","",177,[[["self"]],["typeid"]]],[11,"not_found","","",177,[[["str"],["str"]],["e"]]],[11,"from_ok","","",178,[[["t"]],["t"]]],[11,"map_same","","",178,[[["self"],["f"]],["t"]]],[11,"from","","",178,[[["t"]],["t"]]],[11,"into","","",178,[[["self"]],["u"]]],[11,"try_from","","",178,[[["u"]],["result"]]],[11,"borrow","","",178,[[["self"]],["t"]]],[11,"try_into","","",178,[[["self"]],["result"]]],[11,"borrow_mut","","",178,[[["self"]],["t"]]],[11,"get_type_id","","",178,[[["self"]],["typeid"]]],[11,"not_found","","",178,[[["str"],["str"]],["e"]]],[11,"from_ok","","",179,[[["t"]],["t"]]],[11,"map_same","","",179,[[["self"],["f"]],["t"]]],[11,"from","","",179,[[["t"]],["t"]]],[11,"into","","",179,[[["self"]],["u"]]],[11,"try_from","","",179,[[["u"]],["result"]]],[11,"borrow","","",179,[[["self"]],["t"]]],[11,"try_into","","",179,[[["self"]],["result"]]],[11,"borrow_mut","","",179,[[["self"]],["t"]]],[11,"get_type_id","","",179,[[["self"]],["typeid"]]],[11,"not_found","","",179,[[["str"],["str"]],["e"]]],[11,"from_ok","","",180,[[["t"]],["t"]]],[11,"map_same","","",180,[[["self"],["f"]],["t"]]],[11,"to_owned","","",180,[[["self"]],["t"]]],[11,"clone_into","","",180,N],[11,"from","","",180,[[["t"]],["t"]]],[11,"into","","",180,[[["self"]],["u"]]],[11,"try_from","","",180,[[["u"]],["result"]]],[11,"borrow","","",180,[[["self"]],["t"]]],[11,"try_into","","",180,[[["self"]],["result"]]],[11,"borrow_mut","","",180,[[["self"]],["t"]]],[11,"get_type_id","","",180,[[["self"]],["typeid"]]],[11,"not_found","","",180,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::map::collector","",182,[[["t"]],["t"]]],[11,"map_same","","",182,[[["self"],["f"]],["t"]]],[11,"from","","",182,[[["t"]],["t"]]],[11,"into","","",182,[[["self"]],["u"]]],[11,"try_from","","",182,[[["u"]],["result"]]],[11,"borrow","","",182,[[["self"]],["t"]]],[11,"try_into","","",182,[[["self"]],["result"]]],[11,"borrow_mut","","",182,[[["self"]],["t"]]],[11,"get_type_id","","",182,[[["self"]],["typeid"]]],[11,"not_found","","",182,[[["str"],["str"]],["e"]]],[11,"from_ok","","",183,[[["t"]],["t"]]],[11,"map_same","","",183,[[["self"],["f"]],["t"]]],[11,"from","","",183,[[["t"]],["t"]]],[11,"into","","",183,[[["self"]],["u"]]],[11,"try_from","","",183,[[["u"]],["result"]]],[11,"borrow","","",183,[[["self"]],["t"]]],[11,"try_into","","",183,[[["self"]],["result"]]],[11,"borrow_mut","","",183,[[["self"]],["t"]]],[11,"get_type_id","","",183,[[["self"]],["typeid"]]],[11,"not_found","","",183,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::map::definitions","",184,[[["t"]],["t"]]],[11,"map_same","","",184,[[["self"],["f"]],["t"]]],[11,"to_owned","","",184,[[["self"]],["t"]]],[11,"clone_into","","",184,N],[11,"from","","",184,[[["t"]],["t"]]],[11,"into","","",184,[[["self"]],["u"]]],[11,"try_from","","",184,[[["u"]],["result"]]],[11,"borrow","","",184,[[["self"]],["t"]]],[11,"try_into","","",184,[[["self"]],["result"]]],[11,"borrow_mut","","",184,[[["self"]],["t"]]],[11,"get_type_id","","",184,[[["self"]],["typeid"]]],[11,"encode","","",184,[[["self"],["e"]],["result"]]],[11,"decode","","",184,[[["d"]],["result"]]],[11,"not_found","","",184,[[["str"],["str"]],["e"]]],[11,"from_ok","","",185,[[["t"]],["t"]]],[11,"map_same","","",185,[[["self"],["f"]],["t"]]],[11,"to_owned","","",185,[[["self"]],["t"]]],[11,"clone_into","","",185,N],[11,"from","","",185,[[["t"]],["t"]]],[11,"into","","",185,[[["self"]],["u"]]],[11,"try_from","","",185,[[["u"]],["result"]]],[11,"borrow","","",185,[[["self"]],["t"]]],[11,"try_into","","",185,[[["self"]],["result"]]],[11,"borrow_mut","","",185,[[["self"]],["t"]]],[11,"get_type_id","","",185,[[["self"]],["typeid"]]],[11,"not_found","","",185,[[["str"],["str"]],["e"]]],[11,"from_ok","","",186,[[["t"]],["t"]]],[11,"map_same","","",186,[[["self"],["f"]],["t"]]],[11,"to_owned","","",186,[[["self"]],["t"]]],[11,"clone_into","","",186,N],[11,"from","","",186,[[["t"]],["t"]]],[11,"into","","",186,[[["self"]],["u"]]],[11,"try_from","","",186,[[["u"]],["result"]]],[11,"borrow","","",186,[[["self"]],["t"]]],[11,"try_into","","",186,[[["self"]],["result"]]],[11,"borrow_mut","","",186,[[["self"]],["t"]]],[11,"get_type_id","","",186,[[["self"]],["typeid"]]],[11,"encode","","",186,[[["self"],["e"]],["result"]]],[11,"decode","","",186,[[["d"]],["result"]]],[11,"not_found","","",186,[[["str"],["str"]],["e"]]],[11,"from_ok","","",187,[[["t"]],["t"]]],[11,"map_same","","",187,[[["self"],["f"]],["t"]]],[11,"to_owned","","",187,[[["self"]],["t"]]],[11,"clone_into","","",187,N],[11,"from","","",187,[[["t"]],["t"]]],[11,"into","","",187,[[["self"]],["u"]]],[11,"try_from","","",187,[[["u"]],["result"]]],[11,"borrow","","",187,[[["self"]],["t"]]],[11,"try_into","","",187,[[["self"]],["result"]]],[11,"borrow_mut","","",187,[[["self"]],["t"]]],[11,"get_type_id","","",187,[[["self"]],["typeid"]]],[11,"encode","","",187,[[["self"],["e"]],["result"]]],[11,"decode","","",187,[[["d"]],["result"]]],[11,"not_found","","",187,[[["str"],["str"]],["e"]]],[11,"from_ok","","",188,[[["t"]],["t"]]],[11,"map_same","","",188,[[["self"],["f"]],["t"]]],[11,"to_owned","","",188,[[["self"]],["t"]]],[11,"clone_into","","",188,N],[11,"from","","",188,[[["t"]],["t"]]],[11,"into","","",188,[[["self"]],["u"]]],[11,"try_from","","",188,[[["u"]],["result"]]],[11,"borrow","","",188,[[["self"]],["t"]]],[11,"try_into","","",188,[[["self"]],["result"]]],[11,"borrow_mut","","",188,[[["self"]],["t"]]],[11,"get_type_id","","",188,[[["self"]],["typeid"]]],[11,"encode","","",188,[[["self"],["e"]],["result"]]],[11,"decode","","",188,[[["d"]],["result"]]],[11,"not_found","","",188,[[["str"],["str"]],["e"]]],[11,"from_ok","","",189,[[["t"]],["t"]]],[11,"map_same","","",189,[[["self"],["f"]],["t"]]],[11,"to_owned","","",189,[[["self"]],["t"]]],[11,"clone_into","","",189,N],[11,"from","","",189,[[["t"]],["t"]]],[11,"into","","",189,[[["self"]],["u"]]],[11,"try_from","","",189,[[["u"]],["result"]]],[11,"borrow","","",189,[[["self"]],["t"]]],[11,"try_into","","",189,[[["self"]],["result"]]],[11,"borrow_mut","","",189,[[["self"]],["t"]]],[11,"get_type_id","","",189,[[["self"]],["typeid"]]],[11,"encode","","",189,[[["self"],["e"]],["result"]]],[11,"decode","","",189,[[["d"]],["result"]]],[11,"not_found","","",189,[[["str"],["str"]],["e"]]],[11,"from_ok","","",190,[[["t"]],["t"]]],[11,"map_same","","",190,[[["self"],["f"]],["t"]]],[11,"to_owned","","",190,[[["self"]],["t"]]],[11,"clone_into","","",190,N],[11,"from","","",190,[[["t"]],["t"]]],[11,"into","","",190,[[["self"]],["u"]]],[11,"try_from","","",190,[[["u"]],["result"]]],[11,"borrow","","",190,[[["self"]],["t"]]],[11,"try_into","","",190,[[["self"]],["result"]]],[11,"borrow_mut","","",190,[[["self"]],["t"]]],[11,"get_type_id","","",190,[[["self"]],["typeid"]]],[11,"encode","","",190,[[["self"],["e"]],["result"]]],[11,"decode","","",190,[[["d"]],["result"]]],[11,"not_found","","",190,[[["str"],["str"]],["e"]]],[11,"from_ok","","",191,[[["t"]],["t"]]],[11,"map_same","","",191,[[["self"],["f"]],["t"]]],[11,"to_owned","","",191,[[["self"]],["t"]]],[11,"clone_into","","",191,N],[11,"from","","",191,[[["t"]],["t"]]],[11,"into","","",191,[[["self"]],["u"]]],[11,"try_from","","",191,[[["u"]],["result"]]],[11,"borrow","","",191,[[["self"]],["t"]]],[11,"try_into","","",191,[[["self"]],["result"]]],[11,"borrow_mut","","",191,[[["self"]],["t"]]],[11,"get_type_id","","",191,[[["self"]],["typeid"]]],[11,"encode","","",191,[[["self"],["e"]],["result"]]],[11,"decode","","",191,[[["d"]],["result"]]],[11,"not_found","","",191,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::map::hir_id_validator","",192,[[["t"]],["t"]]],[11,"map_same","","",192,[[["self"],["f"]],["t"]]],[11,"from","","",192,[[["t"]],["t"]]],[11,"into","","",192,[[["self"]],["u"]]],[11,"try_from","","",192,[[["u"]],["result"]]],[11,"borrow","","",192,[[["self"]],["t"]]],[11,"try_into","","",192,[[["self"]],["result"]]],[11,"borrow_mut","","",192,[[["self"]],["t"]]],[11,"get_type_id","","",192,[[["self"]],["typeid"]]],[11,"not_found","","",192,[[["str"],["str"]],["e"]]],[11,"from_ok","","",193,[[["t"]],["t"]]],[11,"map_same","","",193,[[["self"],["f"]],["t"]]],[11,"from","","",193,[[["t"]],["t"]]],[11,"into","","",193,[[["self"]],["u"]]],[11,"try_from","","",193,[[["u"]],["result"]]],[11,"borrow","","",193,[[["self"]],["t"]]],[11,"try_into","","",193,[[["self"]],["result"]]],[11,"borrow_mut","","",193,[[["self"]],["t"]]],[11,"get_type_id","","",193,[[["self"]],["typeid"]]],[11,"not_found","","",193,[[["str"],["str"]],["e"]]],[11,"print_node","rustc::hir::print","",197,[[["self"],["node"]],["result"]]],[11,"from_ok","rustc::hir::pat_util","",195,[[["t"]],["t"]]],[11,"map_same","","",195,[[["self"],["f"]],["t"]]],[11,"from","","",195,[[["t"]],["t"]]],[11,"into_iter","","",195,[[["self"]],["i"]]],[11,"into","","",195,[[["self"]],["u"]]],[11,"try_from","","",195,[[["u"]],["result"]]],[11,"borrow","","",195,[[["self"]],["t"]]],[11,"try_into","","",195,[[["self"]],["result"]]],[11,"borrow_mut","","",195,[[["self"]],["t"]]],[11,"get_type_id","","",195,[[["self"]],["typeid"]]],[11,"not_found","","",195,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::hir::print","",1060,[[["t"]],["t"]]],[11,"map_same","","",1060,[[["self"],["f"]],["t"]]],[11,"from","","",1060,[[["t"]],["t"]]],[11,"into","","",1060,[[["self"]],["u"]]],[11,"try_from","","",1060,[[["u"]],["result"]]],[11,"borrow","","",1060,[[["self"]],["t"]]],[11,"try_into","","",1060,[[["self"]],["result"]]],[11,"borrow_mut","","",1060,[[["self"]],["t"]]],[11,"get_type_id","","",1060,[[["self"]],["typeid"]]],[11,"not_found","","",1060,[[["str"],["str"]],["e"]]],[11,"from_ok","","",197,[[["t"]],["t"]]],[11,"map_same","","",197,[[["self"],["f"]],["t"]]],[11,"from","","",197,[[["t"]],["t"]]],[11,"into","","",197,[[["self"]],["u"]]],[11,"try_from","","",197,[[["u"]],["result"]]],[11,"borrow","","",197,[[["self"]],["t"]]],[11,"try_into","","",197,[[["self"]],["result"]]],[11,"borrow_mut","","",197,[[["self"]],["t"]]],[11,"get_type_id","","",197,[[["self"]],["typeid"]]],[11,"not_found","","",197,[[["str"],["str"]],["e"]]],[11,"from_ok","","",198,[[["t"]],["t"]]],[11,"map_same","","",198,[[["self"],["f"]],["t"]]],[11,"from","","",198,[[["t"]],["t"]]],[11,"into","","",198,[[["self"]],["u"]]],[11,"try_from","","",198,[[["u"]],["result"]]],[11,"borrow","","",198,[[["self"]],["t"]]],[11,"try_into","","",198,[[["self"]],["result"]]],[11,"borrow_mut","","",198,[[["self"]],["t"]]],[11,"get_type_id","","",198,[[["self"]],["typeid"]]],[11,"not_found","","",198,[[["str"],["str"]],["e"]]],[11,"from_ok","","",199,[[["t"]],["t"]]],[11,"map_same","","",199,[[["self"],["f"]],["t"]]],[11,"from","","",199,[[["t"]],["t"]]],[11,"into","","",199,[[["self"]],["u"]]],[11,"try_from","","",199,[[["u"]],["result"]]],[11,"borrow","","",199,[[["self"]],["t"]]],[11,"try_into","","",199,[[["self"]],["result"]]],[11,"borrow_mut","","",199,[[["self"]],["t"]]],[11,"get_type_id","","",199,[[["self"]],["typeid"]]],[11,"not_found","","",199,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ich","",201,[[["t"]],["t"]]],[11,"map_same","","",201,[[["self"],["f"]],["t"]]],[11,"to_owned","","",201,[[["self"]],["t"]]],[11,"clone_into","","",201,N],[11,"from","","",201,[[["t"]],["t"]]],[11,"into","","",201,[[["self"]],["u"]]],[11,"try_from","","",201,[[["u"]],["result"]]],[11,"borrow","","",201,[[["self"]],["t"]]],[11,"try_into","","",201,[[["self"]],["result"]]],[11,"borrow_mut","","",201,[[["self"]],["t"]]],[11,"get_type_id","","",201,[[["self"]],["typeid"]]],[11,"not_found","","",201,[[["str"],["str"]],["e"]]],[11,"from_ok","","",202,[[["t"]],["t"]]],[11,"map_same","","",202,[[["self"],["f"]],["t"]]],[11,"to_owned","","",202,[[["self"]],["t"]]],[11,"clone_into","","",202,N],[11,"from","","",202,[[["t"]],["t"]]],[11,"into","","",202,[[["self"]],["u"]]],[11,"try_from","","",202,[[["u"]],["result"]]],[11,"borrow","","",202,[[["self"]],["t"]]],[11,"try_into","","",202,[[["self"]],["result"]]],[11,"borrow_mut","","",202,[[["self"]],["t"]]],[11,"get_type_id","","",202,[[["self"]],["typeid"]]],[11,"not_found","","",202,[[["str"],["str"]],["e"]]],[11,"from_ok","","",203,[[["t"]],["t"]]],[11,"map_same","","",203,[[["self"],["f"]],["t"]]],[11,"to_owned","","",203,[[["self"]],["t"]]],[11,"clone_into","","",203,N],[11,"from","","",203,[[["t"]],["t"]]],[11,"into","","",203,[[["self"]],["u"]]],[11,"try_from","","",203,[[["u"]],["result"]]],[11,"borrow","","",203,[[["self"]],["t"]]],[11,"try_into","","",203,[[["self"]],["result"]]],[11,"borrow_mut","","",203,[[["self"]],["t"]]],[11,"get_type_id","","",203,[[["self"]],["typeid"]]],[11,"not_found","","",203,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ich::caching_codemap_view","",204,[[["t"]],["t"]]],[11,"map_same","","",204,[[["self"],["f"]],["t"]]],[11,"to_owned","","",204,[[["self"]],["t"]]],[11,"clone_into","","",204,N],[11,"from","","",204,[[["t"]],["t"]]],[11,"into","","",204,[[["self"]],["u"]]],[11,"try_from","","",204,[[["u"]],["result"]]],[11,"borrow","","",204,[[["self"]],["t"]]],[11,"try_into","","",204,[[["self"]],["result"]]],[11,"borrow_mut","","",204,[[["self"]],["t"]]],[11,"get_type_id","","",204,[[["self"]],["typeid"]]],[11,"not_found","","",204,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ich::hcx","",205,[[["t"]],["t"]]],[11,"map_same","","",205,[[["self"],["f"]],["t"]]],[11,"to_owned","","",205,[[["self"]],["t"]]],[11,"clone_into","","",205,N],[11,"from","","",205,[[["t"]],["t"]]],[11,"into","","",205,[[["self"]],["u"]]],[11,"try_from","","",205,[[["u"]],["result"]]],[11,"borrow","","",205,[[["self"]],["t"]]],[11,"try_into","","",205,[[["self"]],["result"]]],[11,"borrow_mut","","",205,[[["self"]],["t"]]],[11,"get_type_id","","",205,[[["self"]],["typeid"]]],[11,"not_found","","",205,[[["str"],["str"]],["e"]]],[11,"get_stable_hashing_context","rustc::ty","",677,[[["self"]],["stablehashingcontext"]]],[11,"hash_stable","rustc::middle::cstore","",340,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",343,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",336,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",337,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",342,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",338,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",344,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",335,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::lib_features","",357,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::lang_items","",361,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",359,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::mir","",443,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",422,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",449,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",451,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",425,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",426,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",428,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",441,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",442,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",450,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",465,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",429,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",448,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",423,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",427,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",434,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",435,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",439,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",453,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",430,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",454,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",431,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",455,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",456,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",433,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",457,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",436,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",437,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",447,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",458,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",459,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",460,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",461,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",462,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",464,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",463,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",438,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",440,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",444,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",445,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",446,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",466,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::mir::interpret","",472,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::session::search_paths","",549,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::subst","",999,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",1001,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",723,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",676,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",658,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::adjustment","",745,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",742,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",739,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",740,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",692,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::adjustment","",743,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",744,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",691,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",729,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",730,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",661,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",660,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",657,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",736,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",727,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",667,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",700,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",702,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",701,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",703,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",663,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",733,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",709,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",710,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",734,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",712,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::mir::interpret","",483,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",484,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",473,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",474,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",489,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",478,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",482,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",670,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::mir::interpret","",469,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",470,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",664,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",665,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",698,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::mir::interpret","",468,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",481,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",485,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",471,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",486,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",728,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::adjustment","",746,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",697,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",695,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",732,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::resolve_lifetime","",408,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",405,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",407,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::cast","",750,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::region","",392,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",398,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"to_stable_hash_key","","",392,[[["self"],["stablehashingcontext"]],["scope"]]],[11,"hash_stable","rustc::ty::adjustment","",741,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",672,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",722,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",721,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",718,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",673,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",674,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",675,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",662,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",666,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",719,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",668,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",669,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",681,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",724,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::trait_def","",1005,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",708,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",686,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",699,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",685,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",726,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",725,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::steal","",998,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",706,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::traits","",578,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::privacy","",388,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",387,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty","",716,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::session","",518,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::util::common","",1045,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::middle::reachable","",391,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::traits","",595,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",570,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",573,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",575,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",574,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",572,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",576,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",571,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::infer::canonical","",227,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",228,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",229,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",231,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",232,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",230,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",233,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::traits","",586,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",587,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",588,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",589,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",591,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",568,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",592,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","","",590,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"hash_stable","rustc::ty::layout","",788,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"from_ok","rustc::infer","",207,[[["t"]],["t"]]],[11,"map_same","","",207,[[["self"],["f"]],["t"]]],[11,"from","","",207,[[["t"]],["t"]]],[11,"into","","",207,[[["self"]],["u"]]],[11,"try_from","","",207,[[["u"]],["result"]]],[11,"borrow","","",207,[[["self"]],["t"]]],[11,"try_into","","",207,[[["self"]],["result"]]],[11,"borrow_mut","","",207,[[["self"]],["t"]]],[11,"get_type_id","","",207,[[["self"]],["typeid"]]],[11,"not_found","","",207,[[["str"],["str"]],["e"]]],[11,"from_ok","","",208,[[["t"]],["t"]]],[11,"map_same","","",208,[[["self"],["f"]],["t"]]],[11,"from","","",208,[[["t"]],["t"]]],[11,"into","","",208,[[["self"]],["u"]]],[11,"try_from","","",208,[[["u"]],["result"]]],[11,"borrow","","",208,[[["self"]],["t"]]],[11,"try_into","","",208,[[["self"]],["result"]]],[11,"borrow_mut","","",208,[[["self"]],["t"]]],[11,"get_type_id","","",208,[[["self"]],["typeid"]]],[11,"not_found","","",208,[[["str"],["str"]],["e"]]],[11,"from_ok","","",209,[[["t"]],["t"]]],[11,"map_same","","",209,[[["self"],["f"]],["t"]]],[11,"from","","",209,[[["t"]],["t"]]],[11,"into","","",209,[[["self"]],["u"]]],[11,"try_from","","",209,[[["u"]],["result"]]],[11,"borrow","","",209,[[["self"]],["t"]]],[11,"try_into","","",209,[[["self"]],["result"]]],[11,"borrow_mut","","",209,[[["self"]],["t"]]],[11,"get_type_id","","",209,[[["self"]],["typeid"]]],[11,"not_found","","",209,[[["str"],["str"]],["e"]]],[11,"from_ok","","",210,[[["t"]],["t"]]],[11,"map_same","","",210,[[["self"],["f"]],["t"]]],[11,"to_owned","","",210,[[["self"]],["t"]]],[11,"clone_into","","",210,N],[11,"from","","",210,[[["t"]],["t"]]],[11,"into","","",210,[[["self"]],["u"]]],[11,"try_from","","",210,[[["u"]],["result"]]],[11,"borrow","","",210,[[["self"]],["t"]]],[11,"try_into","","",210,[[["self"]],["result"]]],[11,"borrow_mut","","",210,[[["self"]],["t"]]],[11,"get_type_id","","",210,[[["self"]],["typeid"]]],[11,"not_found","","",210,[[["str"],["str"]],["e"]]],[11,"from_ok","","",211,[[["t"]],["t"]]],[11,"map_same","","",211,[[["self"],["f"]],["t"]]],[11,"to_owned","","",211,[[["self"]],["t"]]],[11,"clone_into","","",211,N],[11,"from","","",211,[[["t"]],["t"]]],[11,"into","","",211,[[["self"]],["u"]]],[11,"try_from","","",211,[[["u"]],["result"]]],[11,"borrow","","",211,[[["self"]],["t"]]],[11,"try_into","","",211,[[["self"]],["result"]]],[11,"borrow_mut","","",211,[[["self"]],["t"]]],[11,"get_type_id","","",211,[[["self"]],["typeid"]]],[11,"not_found","","",211,[[["str"],["str"]],["e"]]],[11,"from_ok","","",212,[[["t"]],["t"]]],[11,"map_same","","",212,[[["self"],["f"]],["t"]]],[11,"from","","",212,[[["t"]],["t"]]],[11,"into","","",212,[[["self"]],["u"]]],[11,"try_from","","",212,[[["u"]],["result"]]],[11,"borrow","","",212,[[["self"]],["t"]]],[11,"try_into","","",212,[[["self"]],["result"]]],[11,"borrow_mut","","",212,[[["self"]],["t"]]],[11,"get_type_id","","",212,[[["self"]],["typeid"]]],[11,"not_found","","",212,[[["str"],["str"]],["e"]]],[11,"from_ok","","",213,[[["t"]],["t"]]],[11,"map_same","","",213,[[["self"],["f"]],["t"]]],[11,"from","","",213,[[["t"]],["t"]]],[11,"into","","",213,[[["self"]],["u"]]],[11,"try_from","","",213,[[["u"]],["result"]]],[11,"borrow","","",213,[[["self"]],["t"]]],[11,"try_into","","",213,[[["self"]],["result"]]],[11,"borrow_mut","","",213,[[["self"]],["t"]]],[11,"get_type_id","","",213,[[["self"]],["typeid"]]],[11,"not_found","","",213,[[["str"],["str"]],["e"]]],[11,"from_ok","","",214,[[["t"]],["t"]]],[11,"map_same","","",214,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",214,N],[11,"to_owned","","",214,[[["self"]],["t"]]],[11,"clone_into","","",214,N],[11,"from","","",214,[[["t"]],["t"]]],[11,"into","","",214,[[["self"]],["u"]]],[11,"try_from","","",214,[[["u"]],["result"]]],[11,"borrow","","",214,[[["self"]],["t"]]],[11,"try_into","","",214,[[["self"]],["result"]]],[11,"borrow_mut","","",214,[[["self"]],["t"]]],[11,"get_type_id","","",214,[[["self"]],["typeid"]]],[11,"not_found","","",214,[[["str"],["str"]],["e"]]],[11,"from_ok","","",215,[[["t"]],["t"]]],[11,"map_same","","",215,[[["self"],["f"]],["t"]]],[11,"to_owned","","",215,[[["self"]],["t"]]],[11,"clone_into","","",215,N],[11,"from","","",215,[[["t"]],["t"]]],[11,"into","","",215,[[["self"]],["u"]]],[11,"try_from","","",215,[[["u"]],["result"]]],[11,"borrow","","",215,[[["self"]],["t"]]],[11,"try_into","","",215,[[["self"]],["result"]]],[11,"borrow_mut","","",215,[[["self"]],["t"]]],[11,"get_type_id","","",215,[[["self"]],["typeid"]]],[11,"not_found","","",215,[[["str"],["str"]],["e"]]],[11,"from_ok","","",216,[[["t"]],["t"]]],[11,"map_same","","",216,[[["self"],["f"]],["t"]]],[11,"to_owned","","",216,[[["self"]],["t"]]],[11,"clone_into","","",216,N],[11,"from","","",216,[[["t"]],["t"]]],[11,"into","","",216,[[["self"]],["u"]]],[11,"try_from","","",216,[[["u"]],["result"]]],[11,"borrow","","",216,[[["self"]],["t"]]],[11,"try_into","","",216,[[["self"]],["result"]]],[11,"borrow_mut","","",216,[[["self"]],["t"]]],[11,"get_type_id","","",216,[[["self"]],["typeid"]]],[11,"not_found","","",216,[[["str"],["str"]],["e"]]],[11,"from_ok","","",217,[[["t"]],["t"]]],[11,"map_same","","",217,[[["self"],["f"]],["t"]]],[11,"to_owned","","",217,[[["self"]],["t"]]],[11,"clone_into","","",217,N],[11,"from","","",217,[[["t"]],["t"]]],[11,"into","","",217,[[["self"]],["u"]]],[11,"try_from","","",217,[[["u"]],["result"]]],[11,"borrow","","",217,[[["self"]],["t"]]],[11,"try_into","","",217,[[["self"]],["result"]]],[11,"borrow_mut","","",217,[[["self"]],["t"]]],[11,"get_type_id","","",217,[[["self"]],["typeid"]]],[11,"not_found","","",217,[[["str"],["str"]],["e"]]],[11,"from_ok","","",218,[[["t"]],["t"]]],[11,"map_same","","",218,[[["self"],["f"]],["t"]]],[11,"to_owned","","",218,[[["self"]],["t"]]],[11,"clone_into","","",218,N],[11,"from","","",218,[[["t"]],["t"]]],[11,"into","","",218,[[["self"]],["u"]]],[11,"try_from","","",218,[[["u"]],["result"]]],[11,"borrow","","",218,[[["self"]],["t"]]],[11,"try_into","","",218,[[["self"]],["result"]]],[11,"borrow_mut","","",218,[[["self"]],["t"]]],[11,"get_type_id","","",218,[[["self"]],["typeid"]]],[11,"not_found","","",218,[[["str"],["str"]],["e"]]],[11,"from_ok","","",219,[[["t"]],["t"]]],[11,"map_same","","",219,[[["self"],["f"]],["t"]]],[11,"to_owned","","",219,[[["self"]],["t"]]],[11,"clone_into","","",219,N],[11,"from","","",219,[[["t"]],["t"]]],[11,"into","","",219,[[["self"]],["u"]]],[11,"try_from","","",219,[[["u"]],["result"]]],[11,"borrow","","",219,[[["self"]],["t"]]],[11,"try_into","","",219,[[["self"]],["result"]]],[11,"borrow_mut","","",219,[[["self"]],["t"]]],[11,"get_type_id","","",219,[[["self"]],["typeid"]]],[11,"not_found","","",219,[[["str"],["str"]],["e"]]],[11,"from_ok","","",220,[[["t"]],["t"]]],[11,"map_same","","",220,[[["self"],["f"]],["t"]]],[11,"to_owned","","",220,[[["self"]],["t"]]],[11,"clone_into","","",220,N],[11,"from","","",220,[[["t"]],["t"]]],[11,"to_string","","",220,[[["self"]],["string"]]],[11,"into","","",220,[[["self"]],["u"]]],[11,"try_from","","",220,[[["u"]],["result"]]],[11,"borrow","","",220,[[["self"]],["t"]]],[11,"try_into","","",220,[[["self"]],["result"]]],[11,"borrow_mut","","",220,[[["self"]],["t"]]],[11,"get_type_id","","",220,[[["self"]],["typeid"]]],[11,"not_found","","",220,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::opaque_types","",221,[[["t"]],["t"]]],[11,"map_same","","",221,[[["self"],["f"]],["t"]]],[11,"to_owned","","",221,[[["self"]],["t"]]],[11,"clone_into","","",221,N],[11,"from","","",221,[[["t"]],["t"]]],[11,"into","","",221,[[["self"]],["u"]]],[11,"try_from","","",221,[[["u"]],["result"]]],[11,"borrow","","",221,[[["self"]],["t"]]],[11,"try_into","","",221,[[["self"]],["result"]]],[11,"borrow_mut","","",221,[[["self"]],["t"]]],[11,"get_type_id","","",221,[[["self"]],["typeid"]]],[11,"not_found","","",221,[[["str"],["str"]],["e"]]],[11,"from_ok","","",222,[[["t"]],["t"]]],[11,"map_same","","",222,[[["self"],["f"]],["t"]]],[11,"from","","",222,[[["t"]],["t"]]],[11,"into","","",222,[[["self"]],["u"]]],[11,"try_from","","",222,[[["u"]],["result"]]],[11,"borrow","","",222,[[["self"]],["t"]]],[11,"try_into","","",222,[[["self"]],["result"]]],[11,"borrow_mut","","",222,[[["self"]],["t"]]],[11,"get_type_id","","",222,[[["self"]],["typeid"]]],[11,"not_found","","",222,[[["str"],["str"]],["e"]]],[11,"from_ok","","",223,[[["t"]],["t"]]],[11,"map_same","","",223,[[["self"],["f"]],["t"]]],[11,"from","","",223,[[["t"]],["t"]]],[11,"into","","",223,[[["self"]],["u"]]],[11,"try_from","","",223,[[["u"]],["result"]]],[11,"borrow","","",223,[[["self"]],["t"]]],[11,"try_into","","",223,[[["self"]],["result"]]],[11,"borrow_mut","","",223,[[["self"]],["t"]]],[11,"get_type_id","","",223,[[["self"]],["typeid"]]],[11,"not_found","","",223,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::at","",224,[[["t"]],["t"]]],[11,"map_same","","",224,[[["self"],["f"]],["t"]]],[11,"from","","",224,[[["t"]],["t"]]],[11,"into","","",224,[[["self"]],["u"]]],[11,"try_from","","",224,[[["u"]],["result"]]],[11,"borrow","","",224,[[["self"]],["t"]]],[11,"try_into","","",224,[[["self"]],["result"]]],[11,"borrow_mut","","",224,[[["self"]],["t"]]],[11,"get_type_id","","",224,[[["self"]],["typeid"]]],[11,"not_found","","",224,[[["str"],["str"]],["e"]]],[11,"from_ok","","",225,[[["t"]],["t"]]],[11,"map_same","","",225,[[["self"],["f"]],["t"]]],[11,"from","","",225,[[["t"]],["t"]]],[11,"into","","",225,[[["self"]],["u"]]],[11,"try_from","","",225,[[["u"]],["result"]]],[11,"borrow","","",225,[[["self"]],["t"]]],[11,"try_into","","",225,[[["self"]],["result"]]],[11,"borrow_mut","","",225,[[["self"]],["t"]]],[11,"get_type_id","","",225,[[["self"]],["typeid"]]],[11,"not_found","","",225,[[["str"],["str"]],["e"]]],[11,"to_trace","rustc::ty","",1061,[[["obligationcause"],["bool"],["self"],["self"]],["typetrace"]]],[11,"to_trace","rustc::ty::sty","",1062,[[["obligationcause"],["bool"],["self"],["self"]],["typetrace"]]],[11,"to_trace","rustc::ty","",667,[[["obligationcause"],["bool"],["self"],["self"]],["typetrace"]]],[11,"to_trace","rustc::ty::sty","",1027,[[["obligationcause"],["bool"],["self"],["self"]],["typetrace"]]],[11,"from_ok","rustc::infer::canonical","",227,[[["t"]],["t"]]],[11,"map_same","","",227,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",227,N],[11,"to_owned","","",227,[[["self"]],["t"]]],[11,"clone_into","","",227,N],[11,"from","","",227,[[["t"]],["t"]]],[11,"into","","",227,[[["self"]],["u"]]],[11,"try_from","","",227,[[["u"]],["result"]]],[11,"borrow","","",227,[[["self"]],["t"]]],[11,"try_into","","",227,[[["self"]],["result"]]],[11,"borrow_mut","","",227,[[["self"]],["t"]]],[11,"get_type_id","","",227,[[["self"]],["typeid"]]],[11,"encode","","",227,[[["self"],["e"]],["result"]]],[11,"decode","","",227,[[["d"]],["result"]]],[11,"not_found","","",227,[[["str"],["str"]],["e"]]],[11,"from_ok","","",228,[[["t"]],["t"]]],[11,"map_same","","",228,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",228,N],[11,"to_owned","","",228,[[["self"]],["t"]]],[11,"clone_into","","",228,N],[11,"from","","",228,[[["t"]],["t"]]],[11,"into","","",228,[[["self"]],["u"]]],[11,"try_from","","",228,[[["u"]],["result"]]],[11,"borrow","","",228,[[["self"]],["t"]]],[11,"try_into","","",228,[[["self"]],["result"]]],[11,"borrow_mut","","",228,[[["self"]],["t"]]],[11,"get_type_id","","",228,[[["self"]],["typeid"]]],[11,"encode","","",228,[[["self"],["e"]],["result"]]],[11,"decode","","",228,[[["d"]],["result"]]],[11,"not_found","","",228,[[["str"],["str"]],["e"]]],[11,"from_ok","","",229,[[["t"]],["t"]]],[11,"map_same","","",229,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",229,N],[11,"to_owned","","",229,[[["self"]],["t"]]],[11,"clone_into","","",229,N],[11,"from","","",229,[[["t"]],["t"]]],[11,"into","","",229,[[["self"]],["u"]]],[11,"try_from","","",229,[[["u"]],["result"]]],[11,"borrow","","",229,[[["self"]],["t"]]],[11,"try_into","","",229,[[["self"]],["result"]]],[11,"borrow_mut","","",229,[[["self"]],["t"]]],[11,"get_type_id","","",229,[[["self"]],["typeid"]]],[11,"encode","","",229,[[["self"],["e"]],["result"]]],[11,"decode","","",229,[[["d"]],["result"]]],[11,"not_found","","",229,[[["str"],["str"]],["e"]]],[11,"from_ok","","",230,[[["t"]],["t"]]],[11,"map_same","","",230,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",230,N],[11,"to_owned","","",230,[[["self"]],["t"]]],[11,"clone_into","","",230,N],[11,"from","","",230,[[["t"]],["t"]]],[11,"into","","",230,[[["self"]],["u"]]],[11,"try_from","","",230,[[["u"]],["result"]]],[11,"borrow","","",230,[[["self"]],["t"]]],[11,"try_into","","",230,[[["self"]],["result"]]],[11,"borrow_mut","","",230,[[["self"]],["t"]]],[11,"get_type_id","","",230,[[["self"]],["typeid"]]],[11,"not_found","","",230,[[["str"],["str"]],["e"]]],[11,"from_ok","","",231,[[["t"]],["t"]]],[11,"map_same","","",231,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",231,N],[11,"to_owned","","",231,[[["self"]],["t"]]],[11,"clone_into","","",231,N],[11,"from","","",231,[[["t"]],["t"]]],[11,"into","","",231,[[["self"]],["u"]]],[11,"try_from","","",231,[[["u"]],["result"]]],[11,"borrow","","",231,[[["self"]],["t"]]],[11,"try_into","","",231,[[["self"]],["result"]]],[11,"borrow_mut","","",231,[[["self"]],["t"]]],[11,"get_type_id","","",231,[[["self"]],["typeid"]]],[11,"encode","","",231,[[["self"],["e"]],["result"]]],[11,"decode","","",231,[[["d"]],["result"]]],[11,"not_found","","",231,[[["str"],["str"]],["e"]]],[11,"from_ok","","",232,[[["t"]],["t"]]],[11,"map_same","","",232,[[["self"],["f"]],["t"]]],[11,"to_owned","","",232,[[["self"]],["t"]]],[11,"clone_into","","",232,N],[11,"from","","",232,[[["t"]],["t"]]],[11,"into","","",232,[[["self"]],["u"]]],[11,"try_from","","",232,[[["u"]],["result"]]],[11,"borrow","","",232,[[["self"]],["t"]]],[11,"try_into","","",232,[[["self"]],["result"]]],[11,"borrow_mut","","",232,[[["self"]],["t"]]],[11,"get_type_id","","",232,[[["self"]],["typeid"]]],[11,"encode","","",232,[[["self"],["e"]],["result"]]],[11,"decode","","",232,[[["d"]],["result"]]],[11,"not_found","","",232,[[["str"],["str"]],["e"]]],[11,"from_ok","","",233,[[["t"]],["t"]]],[11,"map_same","","",233,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",233,N],[11,"to_owned","","",233,[[["self"]],["t"]]],[11,"clone_into","","",233,N],[11,"from","","",233,[[["t"]],["t"]]],[11,"into","","",233,[[["self"]],["u"]]],[11,"try_from","","",233,[[["u"]],["result"]]],[11,"borrow","","",233,[[["self"]],["t"]]],[11,"try_into","","",233,[[["self"]],["result"]]],[11,"borrow_mut","","",233,[[["self"]],["t"]]],[11,"get_type_id","","",233,[[["self"]],["typeid"]]],[11,"not_found","","",233,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::canonical::canonicalizer","",234,[[["t"]],["t"]]],[11,"map_same","","",234,[[["self"],["f"]],["t"]]],[11,"from","","",234,[[["t"]],["t"]]],[11,"into","","",234,[[["self"]],["u"]]],[11,"try_from","","",234,[[["u"]],["result"]]],[11,"borrow","","",234,[[["self"]],["t"]]],[11,"try_into","","",234,[[["self"]],["result"]]],[11,"borrow_mut","","",234,[[["self"]],["t"]]],[11,"get_type_id","","",234,[[["self"]],["typeid"]]],[11,"not_found","","",234,[[["str"],["str"]],["e"]]],[11,"from_ok","","",235,[[["t"]],["t"]]],[11,"map_same","","",235,[[["self"],["f"]],["t"]]],[11,"from","","",235,[[["t"]],["t"]]],[11,"into","","",235,[[["self"]],["u"]]],[11,"try_from","","",235,[[["u"]],["result"]]],[11,"borrow","","",235,[[["self"]],["t"]]],[11,"try_into","","",235,[[["self"]],["result"]]],[11,"borrow_mut","","",235,[[["self"]],["t"]]],[11,"get_type_id","","",235,[[["self"]],["typeid"]]],[11,"not_found","","",235,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::canonical::substitute","",236,[[["t"]],["t"]]],[11,"map_same","","",236,[[["self"],["f"]],["t"]]],[11,"from","","",236,[[["t"]],["t"]]],[11,"into","","",236,[[["self"]],["u"]]],[11,"try_from","","",236,[[["u"]],["result"]]],[11,"borrow","","",236,[[["self"]],["t"]]],[11,"try_into","","",236,[[["self"]],["result"]]],[11,"borrow_mut","","",236,[[["self"]],["t"]]],[11,"get_type_id","","",236,[[["self"]],["typeid"]]],[11,"not_found","","",236,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::combine","",238,[[["t"]],["t"]]],[11,"map_same","","",238,[[["self"],["f"]],["t"]]],[11,"to_owned","","",238,[[["self"]],["t"]]],[11,"clone_into","","",238,N],[11,"from","","",238,[[["t"]],["t"]]],[11,"into","","",238,[[["self"]],["u"]]],[11,"try_from","","",238,[[["u"]],["result"]]],[11,"borrow","","",238,[[["self"]],["t"]]],[11,"try_into","","",238,[[["self"]],["result"]]],[11,"borrow_mut","","",238,[[["self"]],["t"]]],[11,"get_type_id","","",238,[[["self"]],["typeid"]]],[11,"not_found","","",238,[[["str"],["str"]],["e"]]],[11,"from_ok","","",239,[[["t"]],["t"]]],[11,"map_same","","",239,[[["self"],["f"]],["t"]]],[11,"from","","",239,[[["t"]],["t"]]],[11,"into","","",239,[[["self"]],["u"]]],[11,"try_from","","",239,[[["u"]],["result"]]],[11,"borrow","","",239,[[["self"]],["t"]]],[11,"try_into","","",239,[[["self"]],["result"]]],[11,"borrow_mut","","",239,[[["self"]],["t"]]],[11,"get_type_id","","",239,[[["self"]],["typeid"]]],[11,"not_found","","",239,[[["str"],["str"]],["e"]]],[11,"from_ok","","",240,[[["t"]],["t"]]],[11,"map_same","","",240,[[["self"],["f"]],["t"]]],[11,"from","","",240,[[["t"]],["t"]]],[11,"into","","",240,[[["self"]],["u"]]],[11,"try_from","","",240,[[["u"]],["result"]]],[11,"borrow","","",240,[[["self"]],["t"]]],[11,"try_into","","",240,[[["self"]],["result"]]],[11,"borrow_mut","","",240,[[["self"]],["t"]]],[11,"get_type_id","","",240,[[["self"]],["typeid"]]],[11,"not_found","","",240,[[["str"],["str"]],["e"]]],[11,"from_ok","","",241,[[["t"]],["t"]]],[11,"map_same","","",241,[[["self"],["f"]],["t"]]],[11,"to_owned","","",241,[[["self"]],["t"]]],[11,"clone_into","","",241,N],[11,"from","","",241,[[["t"]],["t"]]],[11,"into","","",241,[[["self"]],["u"]]],[11,"try_from","","",241,[[["u"]],["result"]]],[11,"borrow","","",241,[[["self"]],["t"]]],[11,"try_into","","",241,[[["self"]],["result"]]],[11,"borrow_mut","","",241,[[["self"]],["t"]]],[11,"get_type_id","","",241,[[["self"]],["typeid"]]],[11,"not_found","","",241,[[["str"],["str"]],["e"]]],[11,"compare","rustc::ty::relate","",1063,[[["self"],["t"],["f"]],["relateresult"]]],[11,"from_ok","rustc::infer::equate","",243,[[["t"]],["t"]]],[11,"map_same","","",243,[[["self"],["f"]],["t"]]],[11,"from","","",243,[[["t"]],["t"]]],[11,"into","","",243,[[["self"]],["u"]]],[11,"try_from","","",243,[[["u"]],["result"]]],[11,"borrow","","",243,[[["self"]],["t"]]],[11,"try_into","","",243,[[["self"]],["result"]]],[11,"borrow_mut","","",243,[[["self"]],["t"]]],[11,"get_type_id","","",243,[[["self"]],["typeid"]]],[11,"not_found","","",243,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::error_reporting","",244,[[["t"]],["t"]]],[11,"map_same","","",244,[[["self"],["f"]],["t"]]],[11,"from","","",244,[[["t"]],["t"]]],[11,"into","","",244,[[["self"]],["u"]]],[11,"try_from","","",244,[[["u"]],["result"]]],[11,"borrow","","",244,[[["self"]],["t"]]],[11,"try_into","","",244,[[["self"]],["result"]]],[11,"borrow_mut","","",244,[[["self"]],["t"]]],[11,"get_type_id","","",244,[[["self"]],["typeid"]]],[11,"not_found","","",244,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::error_reporting::need_type_info","",245,[[["t"]],["t"]]],[11,"map_same","","",245,[[["self"],["f"]],["t"]]],[11,"from","","",245,[[["t"]],["t"]]],[11,"into","","",245,[[["self"]],["u"]]],[11,"try_from","","",245,[[["u"]],["result"]]],[11,"borrow","","",245,[[["self"]],["t"]]],[11,"try_into","","",245,[[["self"]],["result"]]],[11,"borrow_mut","","",245,[[["self"]],["t"]]],[11,"get_type_id","","",245,[[["self"]],["typeid"]]],[11,"not_found","","",245,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::error_reporting::nice_region_error","",246,[[["t"]],["t"]]],[11,"map_same","","",246,[[["self"],["f"]],["t"]]],[11,"from","","",246,[[["t"]],["t"]]],[11,"into","","",246,[[["self"]],["u"]]],[11,"try_from","","",246,[[["u"]],["result"]]],[11,"borrow","","",246,[[["self"]],["t"]]],[11,"try_into","","",246,[[["self"]],["result"]]],[11,"borrow_mut","","",246,[[["self"]],["t"]]],[11,"get_type_id","","",246,[[["self"]],["typeid"]]],[11,"not_found","","",246,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::error_reporting::nice_region_error::find_anon_type","",247,[[["t"]],["t"]]],[11,"map_same","","",247,[[["self"],["f"]],["t"]]],[11,"from","","",247,[[["t"]],["t"]]],[11,"into","","",247,[[["self"]],["u"]]],[11,"try_from","","",247,[[["u"]],["result"]]],[11,"borrow","","",247,[[["self"]],["t"]]],[11,"try_into","","",247,[[["self"]],["result"]]],[11,"borrow_mut","","",247,[[["self"]],["t"]]],[11,"get_type_id","","",247,[[["self"]],["typeid"]]],[11,"not_found","","",247,[[["str"],["str"]],["e"]]],[11,"from_ok","","",248,[[["t"]],["t"]]],[11,"map_same","","",248,[[["self"],["f"]],["t"]]],[11,"from","","",248,[[["t"]],["t"]]],[11,"into","","",248,[[["self"]],["u"]]],[11,"try_from","","",248,[[["u"]],["result"]]],[11,"borrow","","",248,[[["self"]],["t"]]],[11,"try_into","","",248,[[["self"]],["result"]]],[11,"borrow_mut","","",248,[[["self"]],["t"]]],[11,"get_type_id","","",248,[[["self"]],["typeid"]]],[11,"not_found","","",248,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::error_reporting::nice_region_error::util","",249,[[["t"]],["t"]]],[11,"map_same","","",249,[[["self"],["f"]],["t"]]],[11,"from","","",249,[[["t"]],["t"]]],[11,"into","","",249,[[["self"]],["u"]]],[11,"try_from","","",249,[[["u"]],["result"]]],[11,"borrow","","",249,[[["self"]],["t"]]],[11,"try_into","","",249,[[["self"]],["result"]]],[11,"borrow_mut","","",249,[[["self"]],["t"]]],[11,"get_type_id","","",249,[[["self"]],["typeid"]]],[11,"not_found","","",249,[[["str"],["str"]],["e"]]],[11,"from_ok","","",250,[[["t"]],["t"]]],[11,"map_same","","",250,[[["self"],["f"]],["t"]]],[11,"from","","",250,[[["t"]],["t"]]],[11,"into","","",250,[[["self"]],["u"]]],[11,"try_from","","",250,[[["u"]],["result"]]],[11,"borrow","","",250,[[["self"]],["t"]]],[11,"try_into","","",250,[[["self"]],["result"]]],[11,"borrow_mut","","",250,[[["self"]],["t"]]],[11,"get_type_id","","",250,[[["self"]],["typeid"]]],[11,"not_found","","",250,[[["str"],["str"]],["e"]]],[11,"note_and_explain_region","rustc::ty","",677,[[["self"],["scopetree"],["diagnosticbuilder"],["str"],["region"],["str"]]]],[11,"note_and_explain_free_region","","",677,[[["self"],["diagnosticbuilder"],["str"],["region"],["str"]]]],[11,"msg_span_from_free_region","","",677,N],[11,"msg_span_from_early_bound_and_free_regions","","",677,N],[11,"emit_msg_span","","",677,[[["diagnosticbuilder"],["str"],["string"],["option",["span"]],["str"]]]],[11,"item_scope_tag","","",677,[[["item"]],["str"]]],[11,"trait_item_scope_tag","","",677,[[["traititem"]],["str"]]],[11,"impl_item_scope_tag","","",677,[[["implitem"]],["str"]]],[11,"explain_span","","",677,N],[11,"as_failure_code","rustc::traits","",566,[[["self"],["typeerror"]],["failurecode"]]],[11,"as_requirement_str","","",566,[[["self"]],["str"]]],[11,"from_ok","rustc::infer::fudge","",251,[[["t"]],["t"]]],[11,"map_same","","",251,[[["self"],["f"]],["t"]]],[11,"from","","",251,[[["t"]],["t"]]],[11,"into","","",251,[[["self"]],["u"]]],[11,"try_from","","",251,[[["u"]],["result"]]],[11,"borrow","","",251,[[["self"]],["t"]]],[11,"try_into","","",251,[[["self"]],["result"]]],[11,"borrow_mut","","",251,[[["self"]],["t"]]],[11,"get_type_id","","",251,[[["self"]],["typeid"]]],[11,"not_found","","",251,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::glb","",252,[[["t"]],["t"]]],[11,"map_same","","",252,[[["self"],["f"]],["t"]]],[11,"from","","",252,[[["t"]],["t"]]],[11,"into","","",252,[[["self"]],["u"]]],[11,"try_from","","",252,[[["u"]],["result"]]],[11,"borrow","","",252,[[["self"]],["t"]]],[11,"try_into","","",252,[[["self"]],["result"]]],[11,"borrow_mut","","",252,[[["self"]],["t"]]],[11,"get_type_id","","",252,[[["self"]],["typeid"]]],[11,"not_found","","",252,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::higher_ranked","",253,[[["t"]],["t"]]],[11,"map_same","","",253,[[["self"],["f"]],["t"]]],[11,"from","","",253,[[["t"]],["t"]]],[11,"into","","",253,[[["self"]],["u"]]],[11,"try_from","","",253,[[["u"]],["result"]]],[11,"borrow","","",253,[[["self"]],["t"]]],[11,"try_into","","",253,[[["self"]],["result"]]],[11,"borrow_mut","","",253,[[["self"]],["t"]]],[11,"get_type_id","","",253,[[["self"]],["typeid"]]],[11,"not_found","","",253,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::lexical_region_resolve","",255,[[["t"]],["t"]]],[11,"map_same","","",255,[[["self"],["f"]],["t"]]],[11,"from","","",255,[[["t"]],["t"]]],[11,"into","","",255,[[["self"]],["u"]]],[11,"try_from","","",255,[[["u"]],["result"]]],[11,"borrow","","",255,[[["self"]],["t"]]],[11,"try_into","","",255,[[["self"]],["result"]]],[11,"borrow_mut","","",255,[[["self"]],["t"]]],[11,"get_type_id","","",255,[[["self"]],["typeid"]]],[11,"not_found","","",255,[[["str"],["str"]],["e"]]],[11,"from_ok","","",256,[[["t"]],["t"]]],[11,"map_same","","",256,[[["self"],["f"]],["t"]]],[11,"from","","",256,[[["t"]],["t"]]],[11,"into","","",256,[[["self"]],["u"]]],[11,"try_from","","",256,[[["u"]],["result"]]],[11,"borrow","","",256,[[["self"]],["t"]]],[11,"try_into","","",256,[[["self"]],["result"]]],[11,"borrow_mut","","",256,[[["self"]],["t"]]],[11,"get_type_id","","",256,[[["self"]],["typeid"]]],[11,"not_found","","",256,[[["str"],["str"]],["e"]]],[11,"from_ok","","",257,[[["t"]],["t"]]],[11,"map_same","","",257,[[["self"],["f"]],["t"]]],[11,"from","","",257,[[["t"]],["t"]]],[11,"into","","",257,[[["self"]],["u"]]],[11,"try_from","","",257,[[["u"]],["result"]]],[11,"borrow","","",257,[[["self"]],["t"]]],[11,"try_into","","",257,[[["self"]],["result"]]],[11,"borrow_mut","","",257,[[["self"]],["t"]]],[11,"get_type_id","","",257,[[["self"]],["typeid"]]],[11,"not_found","","",257,[[["str"],["str"]],["e"]]],[11,"from_ok","","",258,[[["t"]],["t"]]],[11,"map_same","","",258,[[["self"],["f"]],["t"]]],[11,"to_owned","","",258,[[["self"]],["t"]]],[11,"clone_into","","",258,N],[11,"from","","",258,[[["t"]],["t"]]],[11,"into","","",258,[[["self"]],["u"]]],[11,"try_from","","",258,[[["u"]],["result"]]],[11,"borrow","","",258,[[["self"]],["t"]]],[11,"try_into","","",258,[[["self"]],["result"]]],[11,"borrow_mut","","",258,[[["self"]],["t"]]],[11,"get_type_id","","",258,[[["self"]],["typeid"]]],[11,"not_found","","",258,[[["str"],["str"]],["e"]]],[11,"from_ok","","",259,[[["t"]],["t"]]],[11,"map_same","","",259,[[["self"],["f"]],["t"]]],[11,"to_owned","","",259,[[["self"]],["t"]]],[11,"clone_into","","",259,N],[11,"from","","",259,[[["t"]],["t"]]],[11,"into","","",259,[[["self"]],["u"]]],[11,"try_from","","",259,[[["u"]],["result"]]],[11,"borrow","","",259,[[["self"]],["t"]]],[11,"try_into","","",259,[[["self"]],["result"]]],[11,"borrow_mut","","",259,[[["self"]],["t"]]],[11,"get_type_id","","",259,[[["self"]],["typeid"]]],[11,"not_found","","",259,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::lexical_region_resolve::graphviz","",260,[[["t"]],["t"]]],[11,"map_same","","",260,[[["self"],["f"]],["t"]]],[11,"from","","",260,[[["t"]],["t"]]],[11,"into","","",260,[[["self"]],["u"]]],[11,"try_from","","",260,[[["u"]],["result"]]],[11,"borrow","","",260,[[["self"]],["t"]]],[11,"try_into","","",260,[[["self"]],["result"]]],[11,"borrow_mut","","",260,[[["self"]],["t"]]],[11,"get_type_id","","",260,[[["self"]],["typeid"]]],[11,"not_found","","",260,[[["str"],["str"]],["e"]]],[11,"from_ok","","",261,[[["t"]],["t"]]],[11,"map_same","","",261,[[["self"],["f"]],["t"]]],[11,"to_owned","","",261,[[["self"]],["t"]]],[11,"clone_into","","",261,N],[11,"from","","",261,[[["t"]],["t"]]],[11,"into","","",261,[[["self"]],["u"]]],[11,"try_from","","",261,[[["u"]],["result"]]],[11,"borrow","","",261,[[["self"]],["t"]]],[11,"try_into","","",261,[[["self"]],["result"]]],[11,"borrow_mut","","",261,[[["self"]],["t"]]],[11,"get_type_id","","",261,[[["self"]],["typeid"]]],[11,"not_found","","",261,[[["str"],["str"]],["e"]]],[11,"from_ok","","",262,[[["t"]],["t"]]],[11,"map_same","","",262,[[["self"],["f"]],["t"]]],[11,"to_owned","","",262,[[["self"]],["t"]]],[11,"clone_into","","",262,N],[11,"from","","",262,[[["t"]],["t"]]],[11,"into","","",262,[[["self"]],["u"]]],[11,"try_from","","",262,[[["u"]],["result"]]],[11,"borrow","","",262,[[["self"]],["t"]]],[11,"try_into","","",262,[[["self"]],["result"]]],[11,"borrow_mut","","",262,[[["self"]],["t"]]],[11,"get_type_id","","",262,[[["self"]],["typeid"]]],[11,"not_found","","",262,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::lub","",263,[[["t"]],["t"]]],[11,"map_same","","",263,[[["self"],["f"]],["t"]]],[11,"from","","",263,[[["t"]],["t"]]],[11,"into","","",263,[[["self"]],["u"]]],[11,"try_from","","",263,[[["u"]],["result"]]],[11,"borrow","","",263,[[["self"]],["t"]]],[11,"try_into","","",263,[[["self"]],["result"]]],[11,"borrow_mut","","",263,[[["self"]],["t"]]],[11,"get_type_id","","",263,[[["self"]],["typeid"]]],[11,"not_found","","",263,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::outlives::env","",264,[[["t"]],["t"]]],[11,"map_same","","",264,[[["self"],["f"]],["t"]]],[11,"to_owned","","",264,[[["self"]],["t"]]],[11,"clone_into","","",264,N],[11,"from","","",264,[[["t"]],["t"]]],[11,"into","","",264,[[["self"]],["u"]]],[11,"try_from","","",264,[[["u"]],["result"]]],[11,"borrow","","",264,[[["self"]],["t"]]],[11,"try_into","","",264,[[["self"]],["result"]]],[11,"borrow_mut","","",264,[[["self"]],["t"]]],[11,"get_type_id","","",264,[[["self"]],["typeid"]]],[11,"not_found","","",264,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::outlives::free_region_map","",265,[[["t"]],["t"]]],[11,"map_same","","",265,[[["self"],["f"]],["t"]]],[11,"to_owned","","",265,[[["self"]],["t"]]],[11,"clone_into","","",265,N],[11,"from","","",265,[[["t"]],["t"]]],[11,"into","","",265,[[["self"]],["u"]]],[11,"try_from","","",265,[[["u"]],["result"]]],[11,"borrow","","",265,[[["self"]],["t"]]],[11,"try_into","","",265,[[["self"]],["result"]]],[11,"borrow_mut","","",265,[[["self"]],["t"]]],[11,"get_type_id","","",265,[[["self"]],["typeid"]]],[11,"encode","","",265,[[["self"],["e"]],["result"]]],[11,"decode","","",265,[[["d"]],["result"]]],[11,"not_found","","",265,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::outlives::obligations","",267,[[["t"]],["t"]]],[11,"map_same","","",267,[[["self"],["f"]],["t"]]],[11,"from","","",267,[[["t"]],["t"]]],[11,"into","","",267,[[["self"]],["u"]]],[11,"try_from","","",267,[[["u"]],["result"]]],[11,"borrow","","",267,[[["self"]],["t"]]],[11,"try_into","","",267,[[["self"]],["result"]]],[11,"borrow_mut","","",267,[[["self"]],["t"]]],[11,"get_type_id","","",267,[[["self"]],["typeid"]]],[11,"not_found","","",267,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::region_constraints","",269,[[["t"]],["t"]]],[11,"map_same","","",269,[[["self"],["f"]],["t"]]],[11,"from","","",269,[[["t"]],["t"]]],[11,"into","","",269,[[["self"]],["u"]]],[11,"try_from","","",269,[[["u"]],["result"]]],[11,"borrow","","",269,[[["self"]],["t"]]],[11,"try_into","","",269,[[["self"]],["result"]]],[11,"borrow_mut","","",269,[[["self"]],["t"]]],[11,"get_type_id","","",269,[[["self"]],["typeid"]]],[11,"not_found","","",269,[[["str"],["str"]],["e"]]],[11,"from_ok","","",270,[[["t"]],["t"]]],[11,"map_same","","",270,[[["self"],["f"]],["t"]]],[11,"to_owned","","",270,[[["self"]],["t"]]],[11,"clone_into","","",270,N],[11,"from","","",270,[[["t"]],["t"]]],[11,"into","","",270,[[["self"]],["u"]]],[11,"try_from","","",270,[[["u"]],["result"]]],[11,"borrow","","",270,[[["self"]],["t"]]],[11,"try_into","","",270,[[["self"]],["result"]]],[11,"borrow_mut","","",270,[[["self"]],["t"]]],[11,"get_type_id","","",270,[[["self"]],["typeid"]]],[11,"not_found","","",270,[[["str"],["str"]],["e"]]],[11,"from_ok","","",271,[[["t"]],["t"]]],[11,"map_same","","",271,[[["self"],["f"]],["t"]]],[11,"to_owned","","",271,[[["self"]],["t"]]],[11,"clone_into","","",271,N],[11,"from","","",271,[[["t"]],["t"]]],[11,"into","","",271,[[["self"]],["u"]]],[11,"try_from","","",271,[[["u"]],["result"]]],[11,"borrow","","",271,[[["self"]],["t"]]],[11,"try_into","","",271,[[["self"]],["result"]]],[11,"borrow_mut","","",271,[[["self"]],["t"]]],[11,"get_type_id","","",271,[[["self"]],["typeid"]]],[11,"not_found","","",271,[[["str"],["str"]],["e"]]],[11,"from_ok","","",272,[[["t"]],["t"]]],[11,"map_same","","",272,[[["self"],["f"]],["t"]]],[11,"to_owned","","",272,[[["self"]],["t"]]],[11,"clone_into","","",272,N],[11,"from","","",272,[[["t"]],["t"]]],[11,"into","","",272,[[["self"]],["u"]]],[11,"try_from","","",272,[[["u"]],["result"]]],[11,"borrow","","",272,[[["self"]],["t"]]],[11,"try_into","","",272,[[["self"]],["result"]]],[11,"borrow_mut","","",272,[[["self"]],["t"]]],[11,"get_type_id","","",272,[[["self"]],["typeid"]]],[11,"not_found","","",272,[[["str"],["str"]],["e"]]],[11,"from_ok","","",273,[[["t"]],["t"]]],[11,"map_same","","",273,[[["self"],["f"]],["t"]]],[11,"to_owned","","",273,[[["self"]],["t"]]],[11,"clone_into","","",273,N],[11,"from","","",273,[[["t"]],["t"]]],[11,"into","","",273,[[["self"]],["u"]]],[11,"try_from","","",273,[[["u"]],["result"]]],[11,"borrow","","",273,[[["self"]],["t"]]],[11,"try_into","","",273,[[["self"]],["result"]]],[11,"borrow_mut","","",273,[[["self"]],["t"]]],[11,"get_type_id","","",273,[[["self"]],["typeid"]]],[11,"not_found","","",273,[[["str"],["str"]],["e"]]],[11,"from_ok","","",274,[[["t"]],["t"]]],[11,"map_same","","",274,[[["self"],["f"]],["t"]]],[11,"from","","",274,[[["t"]],["t"]]],[11,"into","","",274,[[["self"]],["u"]]],[11,"try_from","","",274,[[["u"]],["result"]]],[11,"borrow","","",274,[[["self"]],["t"]]],[11,"try_into","","",274,[[["self"]],["result"]]],[11,"borrow_mut","","",274,[[["self"]],["t"]]],[11,"get_type_id","","",274,[[["self"]],["typeid"]]],[11,"not_found","","",274,[[["str"],["str"]],["e"]]],[11,"from_ok","","",275,[[["t"]],["t"]]],[11,"map_same","","",275,[[["self"],["f"]],["t"]]],[11,"from","","",275,[[["t"]],["t"]]],[11,"into","","",275,[[["self"]],["u"]]],[11,"try_from","","",275,[[["u"]],["result"]]],[11,"borrow","","",275,[[["self"]],["t"]]],[11,"try_into","","",275,[[["self"]],["result"]]],[11,"borrow_mut","","",275,[[["self"]],["t"]]],[11,"get_type_id","","",275,[[["self"]],["typeid"]]],[11,"not_found","","",275,[[["str"],["str"]],["e"]]],[11,"from_ok","","",276,[[["t"]],["t"]]],[11,"map_same","","",276,[[["self"],["f"]],["t"]]],[11,"to_owned","","",276,[[["self"]],["t"]]],[11,"clone_into","","",276,N],[11,"from","","",276,[[["t"]],["t"]]],[11,"into","","",276,[[["self"]],["u"]]],[11,"try_from","","",276,[[["u"]],["result"]]],[11,"borrow","","",276,[[["self"]],["t"]]],[11,"try_into","","",276,[[["self"]],["result"]]],[11,"borrow_mut","","",276,[[["self"]],["t"]]],[11,"get_type_id","","",276,[[["self"]],["typeid"]]],[11,"not_found","","",276,[[["str"],["str"]],["e"]]],[11,"from_ok","","",277,[[["t"]],["t"]]],[11,"map_same","","",277,[[["self"],["f"]],["t"]]],[11,"to_owned","","",277,[[["self"]],["t"]]],[11,"clone_into","","",277,N],[11,"from","","",277,[[["t"]],["t"]]],[11,"to_string","","",277,[[["self"]],["string"]]],[11,"into","","",277,[[["self"]],["u"]]],[11,"try_from","","",277,[[["u"]],["result"]]],[11,"borrow","","",277,[[["self"]],["t"]]],[11,"try_into","","",277,[[["self"]],["result"]]],[11,"borrow_mut","","",277,[[["self"]],["t"]]],[11,"get_type_id","","",277,[[["self"]],["typeid"]]],[11,"not_found","","",277,[[["str"],["str"]],["e"]]],[11,"from_ok","","",278,[[["t"]],["t"]]],[11,"map_same","","",278,[[["self"],["f"]],["t"]]],[11,"to_owned","","",278,[[["self"]],["t"]]],[11,"clone_into","","",278,N],[11,"from","","",278,[[["t"]],["t"]]],[11,"into","","",278,[[["self"]],["u"]]],[11,"try_from","","",278,[[["u"]],["result"]]],[11,"borrow","","",278,[[["self"]],["t"]]],[11,"try_into","","",278,[[["self"]],["result"]]],[11,"borrow_mut","","",278,[[["self"]],["t"]]],[11,"get_type_id","","",278,[[["self"]],["typeid"]]],[11,"not_found","","",278,[[["str"],["str"]],["e"]]],[11,"from_ok","","",279,[[["t"]],["t"]]],[11,"map_same","","",279,[[["self"],["f"]],["t"]]],[11,"to_owned","","",279,[[["self"]],["t"]]],[11,"clone_into","","",279,N],[11,"from","","",279,[[["t"]],["t"]]],[11,"into","","",279,[[["self"]],["u"]]],[11,"try_from","","",279,[[["u"]],["result"]]],[11,"borrow","","",279,[[["self"]],["t"]]],[11,"try_into","","",279,[[["self"]],["result"]]],[11,"borrow_mut","","",279,[[["self"]],["t"]]],[11,"get_type_id","","",279,[[["self"]],["typeid"]]],[11,"not_found","","",279,[[["str"],["str"]],["e"]]],[11,"from_ok","","",280,[[["t"]],["t"]]],[11,"map_same","","",280,[[["self"],["f"]],["t"]]],[11,"to_owned","","",280,[[["self"]],["t"]]],[11,"clone_into","","",280,N],[11,"from","","",280,[[["t"]],["t"]]],[11,"into","","",280,[[["self"]],["u"]]],[11,"try_from","","",280,[[["u"]],["result"]]],[11,"borrow","","",280,[[["self"]],["t"]]],[11,"try_into","","",280,[[["self"]],["result"]]],[11,"borrow_mut","","",280,[[["self"]],["t"]]],[11,"get_type_id","","",280,[[["self"]],["typeid"]]],[11,"not_found","","",280,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::region_constraints::taint","",281,[[["t"]],["t"]]],[11,"map_same","","",281,[[["self"],["f"]],["t"]]],[11,"from","","",281,[[["t"]],["t"]]],[11,"into","","",281,[[["self"]],["u"]]],[11,"try_from","","",281,[[["u"]],["result"]]],[11,"borrow","","",281,[[["self"]],["t"]]],[11,"try_into","","",281,[[["self"]],["result"]]],[11,"borrow_mut","","",281,[[["self"]],["t"]]],[11,"get_type_id","","",281,[[["self"]],["typeid"]]],[11,"not_found","","",281,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::resolve","",282,[[["t"]],["t"]]],[11,"map_same","","",282,[[["self"],["f"]],["t"]]],[11,"from","","",282,[[["t"]],["t"]]],[11,"into","","",282,[[["self"]],["u"]]],[11,"try_from","","",282,[[["u"]],["result"]]],[11,"borrow","","",282,[[["self"]],["t"]]],[11,"try_into","","",282,[[["self"]],["result"]]],[11,"borrow_mut","","",282,[[["self"]],["t"]]],[11,"get_type_id","","",282,[[["self"]],["typeid"]]],[11,"not_found","","",282,[[["str"],["str"]],["e"]]],[11,"from_ok","","",283,[[["t"]],["t"]]],[11,"map_same","","",283,[[["self"],["f"]],["t"]]],[11,"from","","",283,[[["t"]],["t"]]],[11,"into","","",283,[[["self"]],["u"]]],[11,"try_from","","",283,[[["u"]],["result"]]],[11,"borrow","","",283,[[["self"]],["t"]]],[11,"try_into","","",283,[[["self"]],["result"]]],[11,"borrow_mut","","",283,[[["self"]],["t"]]],[11,"get_type_id","","",283,[[["self"]],["typeid"]]],[11,"not_found","","",283,[[["str"],["str"]],["e"]]],[11,"from_ok","","",284,[[["t"]],["t"]]],[11,"map_same","","",284,[[["self"],["f"]],["t"]]],[11,"from","","",284,[[["t"]],["t"]]],[11,"into","","",284,[[["self"]],["u"]]],[11,"try_from","","",284,[[["u"]],["result"]]],[11,"borrow","","",284,[[["self"]],["t"]]],[11,"try_into","","",284,[[["self"]],["result"]]],[11,"borrow_mut","","",284,[[["self"]],["t"]]],[11,"get_type_id","","",284,[[["self"]],["typeid"]]],[11,"not_found","","",284,[[["str"],["str"]],["e"]]],[11,"from_ok","","",285,[[["t"]],["t"]]],[11,"map_same","","",285,[[["self"],["f"]],["t"]]],[11,"from","","",285,[[["t"]],["t"]]],[11,"into","","",285,[[["self"]],["u"]]],[11,"try_from","","",285,[[["u"]],["result"]]],[11,"borrow","","",285,[[["self"]],["t"]]],[11,"try_into","","",285,[[["self"]],["result"]]],[11,"borrow_mut","","",285,[[["self"]],["t"]]],[11,"get_type_id","","",285,[[["self"]],["typeid"]]],[11,"not_found","","",285,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::sub","",286,[[["t"]],["t"]]],[11,"map_same","","",286,[[["self"],["f"]],["t"]]],[11,"from","","",286,[[["t"]],["t"]]],[11,"into","","",286,[[["self"]],["u"]]],[11,"try_from","","",286,[[["u"]],["result"]]],[11,"borrow","","",286,[[["self"]],["t"]]],[11,"try_into","","",286,[[["self"]],["result"]]],[11,"borrow_mut","","",286,[[["self"]],["t"]]],[11,"get_type_id","","",286,[[["self"]],["typeid"]]],[11,"not_found","","",286,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::infer::type_variable","",287,[[["t"]],["t"]]],[11,"map_same","","",287,[[["self"],["f"]],["t"]]],[11,"from","","",287,[[["t"]],["t"]]],[11,"into","","",287,[[["self"]],["u"]]],[11,"try_from","","",287,[[["u"]],["result"]]],[11,"borrow","","",287,[[["self"]],["t"]]],[11,"try_into","","",287,[[["self"]],["result"]]],[11,"borrow_mut","","",287,[[["self"]],["t"]]],[11,"get_type_id","","",287,[[["self"]],["typeid"]]],[11,"not_found","","",287,[[["str"],["str"]],["e"]]],[11,"from_ok","","",288,[[["t"]],["t"]]],[11,"map_same","","",288,[[["self"],["f"]],["t"]]],[11,"from","","",288,[[["t"]],["t"]]],[11,"into","","",288,[[["self"]],["u"]]],[11,"try_from","","",288,[[["u"]],["result"]]],[11,"borrow","","",288,[[["self"]],["t"]]],[11,"try_into","","",288,[[["self"]],["result"]]],[11,"borrow_mut","","",288,[[["self"]],["t"]]],[11,"get_type_id","","",288,[[["self"]],["typeid"]]],[11,"not_found","","",288,[[["str"],["str"]],["e"]]],[11,"from_ok","","",289,[[["t"]],["t"]]],[11,"map_same","","",289,[[["self"],["f"]],["t"]]],[11,"from","","",289,[[["t"]],["t"]]],[11,"into","","",289,[[["self"]],["u"]]],[11,"try_from","","",289,[[["u"]],["result"]]],[11,"borrow","","",289,[[["self"]],["t"]]],[11,"try_into","","",289,[[["self"]],["result"]]],[11,"borrow_mut","","",289,[[["self"]],["t"]]],[11,"get_type_id","","",289,[[["self"]],["typeid"]]],[11,"not_found","","",289,[[["str"],["str"]],["e"]]],[11,"from_ok","","",290,[[["t"]],["t"]]],[11,"map_same","","",290,[[["self"],["f"]],["t"]]],[11,"from","","",290,[[["t"]],["t"]]],[11,"into","","",290,[[["self"]],["u"]]],[11,"try_from","","",290,[[["u"]],["result"]]],[11,"borrow","","",290,[[["self"]],["t"]]],[11,"try_into","","",290,[[["self"]],["result"]]],[11,"borrow_mut","","",290,[[["self"]],["t"]]],[11,"get_type_id","","",290,[[["self"]],["typeid"]]],[11,"not_found","","",290,[[["str"],["str"]],["e"]]],[11,"from_ok","","",294,[[["t"]],["t"]]],[11,"map_same","","",294,[[["self"],["f"]],["t"]]],[11,"from","","",294,[[["t"]],["t"]]],[11,"into","","",294,[[["self"]],["u"]]],[11,"try_from","","",294,[[["u"]],["result"]]],[11,"borrow","","",294,[[["self"]],["t"]]],[11,"try_into","","",294,[[["self"]],["result"]]],[11,"borrow_mut","","",294,[[["self"]],["t"]]],[11,"get_type_id","","",294,[[["self"]],["typeid"]]],[11,"not_found","","",294,[[["str"],["str"]],["e"]]],[11,"from_ok","","",291,[[["t"]],["t"]]],[11,"map_same","","",291,[[["self"],["f"]],["t"]]],[11,"to_owned","","",291,[[["self"]],["t"]]],[11,"clone_into","","",291,N],[11,"from","","",291,[[["t"]],["t"]]],[11,"into","","",291,[[["self"]],["u"]]],[11,"try_from","","",291,[[["u"]],["result"]]],[11,"borrow","","",291,[[["self"]],["t"]]],[11,"try_into","","",291,[[["self"]],["result"]]],[11,"borrow_mut","","",291,[[["self"]],["t"]]],[11,"get_type_id","","",291,[[["self"]],["typeid"]]],[11,"not_found","","",291,[[["str"],["str"]],["e"]]],[11,"from_ok","","",292,[[["t"]],["t"]]],[11,"map_same","","",292,[[["self"],["f"]],["t"]]],[11,"to_owned","","",292,[[["self"]],["t"]]],[11,"clone_into","","",292,N],[11,"from","","",292,[[["t"]],["t"]]],[11,"into","","",292,[[["self"]],["u"]]],[11,"try_from","","",292,[[["u"]],["result"]]],[11,"borrow","","",292,[[["self"]],["t"]]],[11,"try_into","","",292,[[["self"]],["result"]]],[11,"borrow_mut","","",292,[[["self"]],["t"]]],[11,"get_type_id","","",292,[[["self"]],["typeid"]]],[11,"not_found","","",292,[[["str"],["str"]],["e"]]],[11,"from_ok","","",293,[[["t"]],["t"]]],[11,"map_same","","",293,[[["self"],["f"]],["t"]]],[11,"to_owned","","",293,[[["self"]],["t"]]],[11,"clone_into","","",293,N],[11,"from","","",293,[[["t"]],["t"]]],[11,"into","","",293,[[["self"]],["u"]]],[11,"try_from","","",293,[[["u"]],["result"]]],[11,"borrow","","",293,[[["self"]],["t"]]],[11,"try_into","","",293,[[["self"]],["result"]]],[11,"borrow_mut","","",293,[[["self"]],["t"]]],[11,"get_type_id","","",293,[[["self"]],["typeid"]]],[11,"not_found","","",293,[[["str"],["str"]],["e"]]],[11,"unify_values","","",293,[[["t"],["t"]],["result"]]],[11,"index","rustc::ty","",673,[[["self"]],["u32"]]],[11,"from_index","","",673,[[["u32"]],["tyvid"]]],[11,"tag","","",673,[[],["str"]]],[11,"from_ok","rustc::infer::unify_key","",295,[[["t"]],["t"]]],[11,"map_same","","",295,[[["self"],["f"]],["t"]]],[11,"to_owned","","",295,[[["self"]],["t"]]],[11,"clone_into","","",295,N],[11,"from","","",295,[[["t"]],["t"]]],[11,"into","","",295,[[["self"]],["u"]]],[11,"try_from","","",295,[[["u"]],["result"]]],[11,"borrow","","",295,[[["self"]],["t"]]],[11,"try_into","","",295,[[["self"]],["result"]]],[11,"borrow_mut","","",295,[[["self"]],["t"]]],[11,"get_type_id","","",295,[[["self"]],["typeid"]]],[11,"not_found","","",295,[[["str"],["str"]],["e"]]],[11,"unify_values","","",295,[[["t"],["t"]],["result"]]],[11,"index","rustc::ty","",674,[[["self"]],["u32"]]],[11,"from_index","","",674,[[["u32"]],["intvid"]]],[11,"tag","","",674,[[],["str"]]],[11,"index","","",676,[[["self"]],["u32"]]],[11,"from_index","","",676,[[["u32"]],["regionvid"]]],[11,"tag","","",676,[[],["str"]]],[11,"to_type","","",731,[[["self"],["tyctxt"]],["ty"]]],[11,"index","","",675,[[["self"]],["u32"]]],[11,"from_index","","",675,[[["u32"]],["floatvid"]]],[11,"tag","","",675,[[],["str"]]],[11,"to_type","","",694,[[["self"],["tyctxt"]],["ty"]]],[11,"infer_ctxt","","",677,[[["self"]],["inferctxtbuilder"]]],[11,"new","rustc::ty::error","",754,[[["bool"],["t"],["t"]],["self"]]],[11,"from_ok","rustc::lint","",297,[[["t"]],["t"]]],[11,"map_same","","",297,[[["self"],["f"]],["t"]]],[11,"from","","",297,[[["t"]],["t"]]],[11,"into","","",297,[[["self"]],["u"]]],[11,"try_from","","",297,[[["u"]],["result"]]],[11,"borrow","","",297,[[["self"]],["t"]]],[11,"try_into","","",297,[[["self"]],["result"]]],[11,"borrow_mut","","",297,[[["self"]],["t"]]],[11,"get_type_id","","",297,[[["self"]],["typeid"]]],[11,"not_found","","",297,[[["str"],["str"]],["e"]]],[11,"from_ok","","",298,[[["t"]],["t"]]],[11,"map_same","","",298,[[["self"],["f"]],["t"]]],[11,"from","","",298,[[["t"]],["t"]]],[11,"into","","",298,[[["self"]],["u"]]],[11,"try_from","","",298,[[["u"]],["result"]]],[11,"borrow","","",298,[[["self"]],["t"]]],[11,"try_into","","",298,[[["self"]],["result"]]],[11,"borrow_mut","","",298,[[["self"]],["t"]]],[11,"get_type_id","","",298,[[["self"]],["typeid"]]],[11,"not_found","","",298,[[["str"],["str"]],["e"]]],[11,"from_ok","","",299,[[["t"]],["t"]]],[11,"map_same","","",299,[[["self"],["f"]],["t"]]],[11,"from","","",299,[[["t"]],["t"]]],[11,"into","","",299,[[["self"]],["u"]]],[11,"try_from","","",299,[[["u"]],["result"]]],[11,"borrow","","",299,[[["self"]],["t"]]],[11,"try_into","","",299,[[["self"]],["result"]]],[11,"borrow_mut","","",299,[[["self"]],["t"]]],[11,"get_type_id","","",299,[[["self"]],["typeid"]]],[11,"not_found","","",299,[[["str"],["str"]],["e"]]],[11,"from_ok","","",300,[[["t"]],["t"]]],[11,"map_same","","",300,[[["self"],["f"]],["t"]]],[11,"from","","",300,[[["t"]],["t"]]],[11,"into","","",300,[[["self"]],["u"]]],[11,"try_from","","",300,[[["u"]],["result"]]],[11,"borrow","","",300,[[["self"]],["t"]]],[11,"try_into","","",300,[[["self"]],["result"]]],[11,"borrow_mut","","",300,[[["self"]],["t"]]],[11,"get_type_id","","",300,[[["self"]],["typeid"]]],[11,"not_found","","",300,[[["str"],["str"]],["e"]]],[11,"from_ok","","",301,[[["t"]],["t"]]],[11,"map_same","","",301,[[["self"],["f"]],["t"]]],[11,"from","","",301,[[["t"]],["t"]]],[11,"into","","",301,[[["self"]],["u"]]],[11,"try_from","","",301,[[["u"]],["result"]]],[11,"borrow","","",301,[[["self"]],["t"]]],[11,"try_into","","",301,[[["self"]],["result"]]],[11,"borrow_mut","","",301,[[["self"]],["t"]]],[11,"get_type_id","","",301,[[["self"]],["typeid"]]],[11,"encode","","",301,[[["self"],["e"]],["result"]]],[11,"decode","","",301,[[["d"]],["result"]]],[11,"not_found","","",301,[[["str"],["str"]],["e"]]],[11,"from_ok","","",302,[[["t"]],["t"]]],[11,"map_same","","",302,[[["self"],["f"]],["t"]]],[11,"to_owned","","",302,[[["self"]],["t"]]],[11,"clone_into","","",302,N],[11,"from","","",302,[[["t"]],["t"]]],[11,"into","","",302,[[["self"]],["u"]]],[11,"try_from","","",302,[[["u"]],["result"]]],[11,"borrow","","",302,[[["self"]],["t"]]],[11,"try_into","","",302,[[["self"]],["result"]]],[11,"borrow_mut","","",302,[[["self"]],["t"]]],[11,"get_type_id","","",302,[[["self"]],["typeid"]]],[11,"not_found","","",302,[[["str"],["str"]],["e"]]],[11,"from_ok","","",303,[[["t"]],["t"]]],[11,"map_same","","",303,[[["self"],["f"]],["t"]]],[11,"to_owned","","",303,[[["self"]],["t"]]],[11,"clone_into","","",303,N],[11,"from","","",303,[[["t"]],["t"]]],[11,"into","","",303,[[["self"]],["u"]]],[11,"try_from","","",303,[[["u"]],["result"]]],[11,"borrow","","",303,[[["self"]],["t"]]],[11,"try_into","","",303,[[["self"]],["result"]]],[11,"borrow_mut","","",303,[[["self"]],["t"]]],[11,"get_type_id","","",303,[[["self"]],["typeid"]]],[11,"encode","","",303,[[["self"],["e"]],["result"]]],[11,"decode","","",303,[[["d"]],["result"]]],[11,"not_found","","",303,[[["str"],["str"]],["e"]]],[11,"from_ok","","",304,[[["t"]],["t"]]],[11,"map_same","","",304,[[["self"],["f"]],["t"]]],[11,"from","","",304,[[["t"]],["t"]]],[11,"into","","",304,[[["self"]],["u"]]],[11,"try_from","","",304,[[["u"]],["result"]]],[11,"borrow","","",304,[[["self"]],["t"]]],[11,"try_into","","",304,[[["self"]],["result"]]],[11,"borrow_mut","","",304,[[["self"]],["t"]]],[11,"get_type_id","","",304,[[["self"]],["typeid"]]],[11,"not_found","","",304,[[["str"],["str"]],["e"]]],[11,"from_ok","","",305,[[["t"]],["t"]]],[11,"map_same","","",305,[[["self"],["f"]],["t"]]],[11,"from","","",305,[[["t"]],["t"]]],[11,"into","","",305,[[["self"]],["u"]]],[11,"try_from","","",305,[[["u"]],["result"]]],[11,"borrow","","",305,[[["self"]],["t"]]],[11,"try_into","","",305,[[["self"]],["result"]]],[11,"borrow_mut","","",305,[[["self"]],["t"]]],[11,"get_type_id","","",305,[[["self"]],["typeid"]]],[11,"not_found","","",305,[[["str"],["str"]],["e"]]],[11,"from_ok","","",306,[[["t"]],["t"]]],[11,"map_same","","",306,[[["self"],["f"]],["t"]]],[11,"from","","",306,[[["t"]],["t"]]],[11,"into","","",306,[[["self"]],["u"]]],[11,"try_from","","",306,[[["u"]],["result"]]],[11,"borrow","","",306,[[["self"]],["t"]]],[11,"try_into","","",306,[[["self"]],["result"]]],[11,"borrow_mut","","",306,[[["self"]],["t"]]],[11,"get_type_id","","",306,[[["self"]],["typeid"]]],[11,"not_found","","",306,[[["str"],["str"]],["e"]]],[11,"from_ok","","",307,[[["t"]],["t"]]],[11,"map_same","","",307,[[["self"],["f"]],["t"]]],[11,"from","","",307,[[["t"]],["t"]]],[11,"into","","",307,[[["self"]],["u"]]],[11,"try_from","","",307,[[["u"]],["result"]]],[11,"borrow","","",307,[[["self"]],["t"]]],[11,"try_into","","",307,[[["self"]],["result"]]],[11,"borrow_mut","","",307,[[["self"]],["t"]]],[11,"get_type_id","","",307,[[["self"]],["typeid"]]],[11,"not_found","","",307,[[["str"],["str"]],["e"]]],[11,"from_ok","","",308,[[["t"]],["t"]]],[11,"map_same","","",308,[[["self"],["f"]],["t"]]],[11,"from","","",308,[[["t"]],["t"]]],[11,"into","","",308,[[["self"]],["u"]]],[11,"try_from","","",308,[[["u"]],["result"]]],[11,"borrow","","",308,[[["self"]],["t"]]],[11,"try_into","","",308,[[["self"]],["result"]]],[11,"borrow_mut","","",308,[[["self"]],["t"]]],[11,"get_type_id","","",308,[[["self"]],["typeid"]]],[11,"not_found","","",308,[[["str"],["str"]],["e"]]],[11,"from_ok","","",309,[[["t"]],["t"]]],[11,"map_same","","",309,[[["self"],["f"]],["t"]]],[11,"to_owned","","",309,[[["self"]],["t"]]],[11,"clone_into","","",309,N],[11,"from","","",309,[[["t"]],["t"]]],[11,"into","","",309,[[["self"]],["u"]]],[11,"try_from","","",309,[[["u"]],["result"]]],[11,"borrow","","",309,[[["self"]],["t"]]],[11,"try_into","","",309,[[["self"]],["result"]]],[11,"borrow_mut","","",309,[[["self"]],["t"]]],[11,"get_type_id","","",309,[[["self"]],["typeid"]]],[11,"not_found","","",309,[[["str"],["str"]],["e"]]],[11,"from_ok","","",310,[[["t"]],["t"]]],[11,"map_same","","",310,[[["self"],["f"]],["t"]]],[11,"to_owned","","",310,[[["self"]],["t"]]],[11,"clone_into","","",310,N],[11,"from","","",310,[[["t"]],["t"]]],[11,"into","","",310,[[["self"]],["u"]]],[11,"try_from","","",310,[[["u"]],["result"]]],[11,"borrow","","",310,[[["self"]],["t"]]],[11,"try_into","","",310,[[["self"]],["result"]]],[11,"borrow_mut","","",310,[[["self"]],["t"]]],[11,"get_type_id","","",310,[[["self"]],["typeid"]]],[11,"not_found","","",310,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::lint::builtin","",312,[[["t"]],["t"]]],[11,"map_same","","",312,[[["self"],["f"]],["t"]]],[11,"to_owned","","",312,[[["self"]],["t"]]],[11,"clone_into","","",312,N],[11,"from","","",312,[[["t"]],["t"]]],[11,"into","","",312,[[["self"]],["u"]]],[11,"try_from","","",312,[[["u"]],["result"]]],[11,"borrow","","",312,[[["self"]],["t"]]],[11,"try_into","","",312,[[["self"]],["result"]]],[11,"borrow_mut","","",312,[[["self"]],["t"]]],[11,"get_type_id","","",312,[[["self"]],["typeid"]]],[11,"not_found","","",312,[[["str"],["str"]],["e"]]],[11,"from_ok","","",311,[[["t"]],["t"]]],[11,"map_same","","",311,[[["self"],["f"]],["t"]]],[11,"from","","",311,[[["t"]],["t"]]],[11,"into","","",311,[[["self"]],["u"]]],[11,"try_from","","",311,[[["u"]],["result"]]],[11,"borrow","","",311,[[["self"]],["t"]]],[11,"try_into","","",311,[[["self"]],["result"]]],[11,"borrow_mut","","",311,[[["self"]],["t"]]],[11,"get_type_id","","",311,[[["self"]],["typeid"]]],[11,"encode","","",311,[[["self"],["e"]],["result"]]],[11,"decode","","",311,[[["d"]],["result"]]],[11,"not_found","","",311,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::lint::context","",313,[[["t"]],["t"]]],[11,"map_same","","",313,[[["self"],["f"]],["t"]]],[11,"from","","",313,[[["t"]],["t"]]],[11,"into","","",313,[[["self"]],["u"]]],[11,"try_from","","",313,[[["u"]],["result"]]],[11,"borrow","","",313,[[["self"]],["t"]]],[11,"try_into","","",313,[[["self"]],["result"]]],[11,"borrow_mut","","",313,[[["self"]],["t"]]],[11,"get_type_id","","",313,[[["self"]],["typeid"]]],[11,"not_found","","",313,[[["str"],["str"]],["e"]]],[11,"from_ok","","",314,[[["t"]],["t"]]],[11,"map_same","","",314,[[["self"],["f"]],["t"]]],[11,"from","","",314,[[["t"]],["t"]]],[11,"into","","",314,[[["self"]],["u"]]],[11,"try_from","","",314,[[["u"]],["result"]]],[11,"borrow","","",314,[[["self"]],["t"]]],[11,"try_into","","",314,[[["self"]],["result"]]],[11,"borrow_mut","","",314,[[["self"]],["t"]]],[11,"get_type_id","","",314,[[["self"]],["typeid"]]],[11,"not_found","","",314,[[["str"],["str"]],["e"]]],[11,"from_ok","","",315,[[["t"]],["t"]]],[11,"map_same","","",315,[[["self"],["f"]],["t"]]],[11,"from","","",315,[[["t"]],["t"]]],[11,"into","","",315,[[["self"]],["u"]]],[11,"try_from","","",315,[[["u"]],["result"]]],[11,"borrow","","",315,[[["self"]],["t"]]],[11,"try_into","","",315,[[["self"]],["result"]]],[11,"borrow_mut","","",315,[[["self"]],["t"]]],[11,"get_type_id","","",315,[[["self"]],["typeid"]]],[11,"not_found","","",315,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::lint::levels","",317,[[["t"]],["t"]]],[11,"map_same","","",317,[[["self"],["f"]],["t"]]],[11,"from","","",317,[[["t"]],["t"]]],[11,"into","","",317,[[["self"]],["u"]]],[11,"try_from","","",317,[[["u"]],["result"]]],[11,"borrow","","",317,[[["self"]],["t"]]],[11,"try_into","","",317,[[["self"]],["result"]]],[11,"borrow_mut","","",317,[[["self"]],["t"]]],[11,"get_type_id","","",317,[[["self"]],["typeid"]]],[11,"not_found","","",317,[[["str"],["str"]],["e"]]],[11,"from_ok","","",318,[[["t"]],["t"]]],[11,"map_same","","",318,[[["self"],["f"]],["t"]]],[11,"from","","",318,[[["t"]],["t"]]],[11,"into","","",318,[[["self"]],["u"]]],[11,"try_from","","",318,[[["u"]],["result"]]],[11,"borrow","","",318,[[["self"]],["t"]]],[11,"try_into","","",318,[[["self"]],["result"]]],[11,"borrow_mut","","",318,[[["self"]],["t"]]],[11,"get_type_id","","",318,[[["self"]],["typeid"]]],[11,"not_found","","",318,[[["str"],["str"]],["e"]]],[11,"from_ok","","",319,[[["t"]],["t"]]],[11,"map_same","","",319,[[["self"],["f"]],["t"]]],[11,"from","","",319,[[["t"]],["t"]]],[11,"into","","",319,[[["self"]],["u"]]],[11,"try_from","","",319,[[["u"]],["result"]]],[11,"borrow","","",319,[[["self"]],["t"]]],[11,"try_into","","",319,[[["self"]],["result"]]],[11,"borrow_mut","","",319,[[["self"]],["t"]]],[11,"get_type_id","","",319,[[["self"]],["typeid"]]],[11,"not_found","","",319,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::allocator","",323,[[["t"]],["t"]]],[11,"map_same","","",323,[[["self"],["f"]],["t"]]],[11,"to_owned","","",323,[[["self"]],["t"]]],[11,"clone_into","","",323,N],[11,"from","","",323,[[["t"]],["t"]]],[11,"into","","",323,[[["self"]],["u"]]],[11,"try_from","","",323,[[["u"]],["result"]]],[11,"borrow","","",323,[[["self"]],["t"]]],[11,"try_into","","",323,[[["self"]],["result"]]],[11,"borrow_mut","","",323,[[["self"]],["t"]]],[11,"get_type_id","","",323,[[["self"]],["typeid"]]],[11,"not_found","","",323,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::borrowck","",324,[[["t"]],["t"]]],[11,"map_same","","",324,[[["self"],["f"]],["t"]]],[11,"from","","",324,[[["t"]],["t"]]],[11,"into","","",324,[[["self"]],["u"]]],[11,"try_from","","",324,[[["u"]],["result"]]],[11,"borrow","","",324,[[["self"]],["t"]]],[11,"try_into","","",324,[[["self"]],["result"]]],[11,"borrow_mut","","",324,[[["self"]],["t"]]],[11,"get_type_id","","",324,[[["self"]],["typeid"]]],[11,"encode","","",324,[[["self"],["e"]],["result"]]],[11,"decode","","",324,[[["d"]],["result"]]],[11,"not_found","","",324,[[["str"],["str"]],["e"]]],[11,"from_ok","","",325,[[["t"]],["t"]]],[11,"map_same","","",325,[[["self"],["f"]],["t"]]],[11,"to_owned","","",325,[[["self"]],["t"]]],[11,"clone_into","","",325,N],[11,"from","","",325,[[["t"]],["t"]]],[11,"into","","",325,[[["self"]],["u"]]],[11,"try_from","","",325,[[["u"]],["result"]]],[11,"borrow","","",325,[[["self"]],["t"]]],[11,"try_into","","",325,[[["self"]],["result"]]],[11,"borrow_mut","","",325,[[["self"]],["t"]]],[11,"get_type_id","","",325,[[["self"]],["typeid"]]],[11,"encode","","",325,[[["self"],["e"]],["result"]]],[11,"decode","","",325,[[["d"]],["result"]]],[11,"not_found","","",325,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::expr_use_visitor","",326,[[["t"]],["t"]]],[11,"map_same","","",326,[[["self"],["f"]],["t"]]],[11,"from","","",326,[[["t"]],["t"]]],[11,"into","","",326,[[["self"]],["u"]]],[11,"try_from","","",326,[[["u"]],["result"]]],[11,"borrow","","",326,[[["self"]],["t"]]],[11,"try_into","","",326,[[["self"]],["result"]]],[11,"borrow_mut","","",326,[[["self"]],["t"]]],[11,"get_type_id","","",326,[[["self"]],["typeid"]]],[11,"not_found","","",326,[[["str"],["str"]],["e"]]],[11,"from_ok","","",327,[[["t"]],["t"]]],[11,"map_same","","",327,[[["self"],["f"]],["t"]]],[11,"to_owned","","",327,[[["self"]],["t"]]],[11,"clone_into","","",327,N],[11,"from","","",327,[[["t"]],["t"]]],[11,"into","","",327,[[["self"]],["u"]]],[11,"try_from","","",327,[[["u"]],["result"]]],[11,"borrow","","",327,[[["self"]],["t"]]],[11,"try_into","","",327,[[["self"]],["result"]]],[11,"borrow_mut","","",327,[[["self"]],["t"]]],[11,"get_type_id","","",327,[[["self"]],["typeid"]]],[11,"not_found","","",327,[[["str"],["str"]],["e"]]],[11,"from_ok","","",328,[[["t"]],["t"]]],[11,"map_same","","",328,[[["self"],["f"]],["t"]]],[11,"to_owned","","",328,[[["self"]],["t"]]],[11,"clone_into","","",328,N],[11,"from","","",328,[[["t"]],["t"]]],[11,"into","","",328,[[["self"]],["u"]]],[11,"try_from","","",328,[[["u"]],["result"]]],[11,"borrow","","",328,[[["self"]],["t"]]],[11,"try_into","","",328,[[["self"]],["result"]]],[11,"borrow_mut","","",328,[[["self"]],["t"]]],[11,"get_type_id","","",328,[[["self"]],["typeid"]]],[11,"not_found","","",328,[[["str"],["str"]],["e"]]],[11,"from_ok","","",329,[[["t"]],["t"]]],[11,"map_same","","",329,[[["self"],["f"]],["t"]]],[11,"to_owned","","",329,[[["self"]],["t"]]],[11,"clone_into","","",329,N],[11,"from","","",329,[[["t"]],["t"]]],[11,"into","","",329,[[["self"]],["u"]]],[11,"try_from","","",329,[[["u"]],["result"]]],[11,"borrow","","",329,[[["self"]],["t"]]],[11,"try_into","","",329,[[["self"]],["result"]]],[11,"borrow_mut","","",329,[[["self"]],["t"]]],[11,"get_type_id","","",329,[[["self"]],["typeid"]]],[11,"not_found","","",329,[[["str"],["str"]],["e"]]],[11,"from_ok","","",330,[[["t"]],["t"]]],[11,"map_same","","",330,[[["self"],["f"]],["t"]]],[11,"to_owned","","",330,[[["self"]],["t"]]],[11,"clone_into","","",330,N],[11,"from","","",330,[[["t"]],["t"]]],[11,"into","","",330,[[["self"]],["u"]]],[11,"try_from","","",330,[[["u"]],["result"]]],[11,"borrow","","",330,[[["self"]],["t"]]],[11,"try_into","","",330,[[["self"]],["result"]]],[11,"borrow_mut","","",330,[[["self"]],["t"]]],[11,"get_type_id","","",330,[[["self"]],["typeid"]]],[11,"not_found","","",330,[[["str"],["str"]],["e"]]],[11,"from_ok","","",331,[[["t"]],["t"]]],[11,"map_same","","",331,[[["self"],["f"]],["t"]]],[11,"to_owned","","",331,[[["self"]],["t"]]],[11,"clone_into","","",331,N],[11,"from","","",331,[[["t"]],["t"]]],[11,"into","","",331,[[["self"]],["u"]]],[11,"try_from","","",331,[[["u"]],["result"]]],[11,"borrow","","",331,[[["self"]],["t"]]],[11,"try_into","","",331,[[["self"]],["result"]]],[11,"borrow_mut","","",331,[[["self"]],["t"]]],[11,"get_type_id","","",331,[[["self"]],["typeid"]]],[11,"not_found","","",331,[[["str"],["str"]],["e"]]],[11,"from_ok","","",332,[[["t"]],["t"]]],[11,"map_same","","",332,[[["self"],["f"]],["t"]]],[11,"to_owned","","",332,[[["self"]],["t"]]],[11,"clone_into","","",332,N],[11,"from","","",332,[[["t"]],["t"]]],[11,"into","","",332,[[["self"]],["u"]]],[11,"try_from","","",332,[[["u"]],["result"]]],[11,"borrow","","",332,[[["self"]],["t"]]],[11,"try_into","","",332,[[["self"]],["result"]]],[11,"borrow_mut","","",332,[[["self"]],["t"]]],[11,"get_type_id","","",332,[[["self"]],["typeid"]]],[11,"not_found","","",332,[[["str"],["str"]],["e"]]],[11,"from_ok","","",333,[[["t"]],["t"]]],[11,"map_same","","",333,[[["self"],["f"]],["t"]]],[11,"to_owned","","",333,[[["self"]],["t"]]],[11,"clone_into","","",333,N],[11,"from","","",333,[[["t"]],["t"]]],[11,"into","","",333,[[["self"]],["u"]]],[11,"try_from","","",333,[[["u"]],["result"]]],[11,"borrow","","",333,[[["self"]],["t"]]],[11,"try_into","","",333,[[["self"]],["result"]]],[11,"borrow_mut","","",333,[[["self"]],["t"]]],[11,"get_type_id","","",333,[[["self"]],["typeid"]]],[11,"not_found","","",333,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::cstore","",335,[[["t"]],["t"]]],[11,"map_same","","",335,[[["self"],["f"]],["t"]]],[11,"to_owned","","",335,[[["self"]],["t"]]],[11,"clone_into","","",335,N],[11,"from","","",335,[[["t"]],["t"]]],[11,"into","","",335,[[["self"]],["u"]]],[11,"try_from","","",335,[[["u"]],["result"]]],[11,"borrow","","",335,[[["self"]],["t"]]],[11,"try_into","","",335,[[["self"]],["result"]]],[11,"borrow_mut","","",335,[[["self"]],["t"]]],[11,"get_type_id","","",335,[[["self"]],["typeid"]]],[11,"not_found","","",335,[[["str"],["str"]],["e"]]],[11,"from_ok","","",336,[[["t"]],["t"]]],[11,"map_same","","",336,[[["self"],["f"]],["t"]]],[11,"to_owned","","",336,[[["self"]],["t"]]],[11,"clone_into","","",336,N],[11,"from","","",336,[[["t"]],["t"]]],[11,"into","","",336,[[["self"]],["u"]]],[11,"try_from","","",336,[[["u"]],["result"]]],[11,"borrow","","",336,[[["self"]],["t"]]],[11,"try_into","","",336,[[["self"]],["result"]]],[11,"borrow_mut","","",336,[[["self"]],["t"]]],[11,"get_type_id","","",336,[[["self"]],["typeid"]]],[11,"encode","","",336,[[["self"],["e"]],["result"]]],[11,"decode","","",336,[[["d"]],["result"]]],[11,"not_found","","",336,[[["str"],["str"]],["e"]]],[11,"from_ok","","",337,[[["t"]],["t"]]],[11,"map_same","","",337,[[["self"],["f"]],["t"]]],[11,"to_owned","","",337,[[["self"]],["t"]]],[11,"clone_into","","",337,N],[11,"from","","",337,[[["t"]],["t"]]],[11,"into","","",337,[[["self"]],["u"]]],[11,"try_from","","",337,[[["u"]],["result"]]],[11,"borrow","","",337,[[["self"]],["t"]]],[11,"try_into","","",337,[[["self"]],["result"]]],[11,"borrow_mut","","",337,[[["self"]],["t"]]],[11,"get_type_id","","",337,[[["self"]],["typeid"]]],[11,"encode","","",337,[[["self"],["e"]],["result"]]],[11,"decode","","",337,[[["d"]],["result"]]],[11,"not_found","","",337,[[["str"],["str"]],["e"]]],[11,"from_ok","","",338,[[["t"]],["t"]]],[11,"map_same","","",338,[[["self"],["f"]],["t"]]],[11,"to_owned","","",338,[[["self"]],["t"]]],[11,"clone_into","","",338,N],[11,"from","","",338,[[["t"]],["t"]]],[11,"into","","",338,[[["self"]],["u"]]],[11,"try_from","","",338,[[["u"]],["result"]]],[11,"borrow","","",338,[[["self"]],["t"]]],[11,"try_into","","",338,[[["self"]],["result"]]],[11,"borrow_mut","","",338,[[["self"]],["t"]]],[11,"get_type_id","","",338,[[["self"]],["typeid"]]],[11,"not_found","","",338,[[["str"],["str"]],["e"]]],[11,"from_ok","","",339,[[["t"]],["t"]]],[11,"map_same","","",339,[[["self"],["f"]],["t"]]],[11,"from","","",339,[[["t"]],["t"]]],[11,"into","","",339,[[["self"]],["u"]]],[11,"try_from","","",339,[[["u"]],["result"]]],[11,"borrow","","",339,[[["self"]],["t"]]],[11,"try_into","","",339,[[["self"]],["result"]]],[11,"borrow_mut","","",339,[[["self"]],["t"]]],[11,"get_type_id","","",339,[[["self"]],["typeid"]]],[11,"not_found","","",339,[[["str"],["str"]],["e"]]],[11,"from_ok","","",340,[[["t"]],["t"]]],[11,"map_same","","",340,[[["self"],["f"]],["t"]]],[11,"to_owned","","",340,[[["self"]],["t"]]],[11,"clone_into","","",340,N],[11,"from","","",340,[[["t"]],["t"]]],[11,"into","","",340,[[["self"]],["u"]]],[11,"try_from","","",340,[[["u"]],["result"]]],[11,"borrow","","",340,[[["self"]],["t"]]],[11,"try_into","","",340,[[["self"]],["result"]]],[11,"borrow_mut","","",340,[[["self"]],["t"]]],[11,"get_type_id","","",340,[[["self"]],["typeid"]]],[11,"encode","","",340,[[["self"],["e"]],["result"]]],[11,"decode","","",340,[[["d"]],["result"]]],[11,"not_found","","",340,[[["str"],["str"]],["e"]]],[11,"from_ok","","",341,[[["t"]],["t"]]],[11,"map_same","","",341,[[["self"],["f"]],["t"]]],[11,"to_owned","","",341,[[["self"]],["t"]]],[11,"clone_into","","",341,N],[11,"from","","",341,[[["t"]],["t"]]],[11,"into","","",341,[[["self"]],["u"]]],[11,"try_from","","",341,[[["u"]],["result"]]],[11,"borrow","","",341,[[["self"]],["t"]]],[11,"try_into","","",341,[[["self"]],["result"]]],[11,"borrow_mut","","",341,[[["self"]],["t"]]],[11,"get_type_id","","",341,[[["self"]],["typeid"]]],[11,"not_found","","",341,[[["str"],["str"]],["e"]]],[11,"from_ok","","",342,[[["t"]],["t"]]],[11,"map_same","","",342,[[["self"],["f"]],["t"]]],[11,"to_owned","","",342,[[["self"]],["t"]]],[11,"clone_into","","",342,N],[11,"from","","",342,[[["t"]],["t"]]],[11,"into","","",342,[[["self"]],["u"]]],[11,"try_from","","",342,[[["u"]],["result"]]],[11,"borrow","","",342,[[["self"]],["t"]]],[11,"try_into","","",342,[[["self"]],["result"]]],[11,"borrow_mut","","",342,[[["self"]],["t"]]],[11,"get_type_id","","",342,[[["self"]],["typeid"]]],[11,"encode","","",342,[[["self"],["e"]],["result"]]],[11,"decode","","",342,[[["d"]],["result"]]],[11,"not_found","","",342,[[["str"],["str"]],["e"]]],[11,"from_ok","","",343,[[["t"]],["t"]]],[11,"map_same","","",343,[[["self"],["f"]],["t"]]],[11,"to_owned","","",343,[[["self"]],["t"]]],[11,"clone_into","","",343,N],[11,"from","","",343,[[["t"]],["t"]]],[11,"into","","",343,[[["self"]],["u"]]],[11,"try_from","","",343,[[["u"]],["result"]]],[11,"borrow","","",343,[[["self"]],["t"]]],[11,"try_into","","",343,[[["self"]],["result"]]],[11,"borrow_mut","","",343,[[["self"]],["t"]]],[11,"get_type_id","","",343,[[["self"]],["typeid"]]],[11,"encode","","",343,[[["self"],["e"]],["result"]]],[11,"decode","","",343,[[["d"]],["result"]]],[11,"not_found","","",343,[[["str"],["str"]],["e"]]],[11,"from_ok","","",344,[[["t"]],["t"]]],[11,"map_same","","",344,[[["self"],["f"]],["t"]]],[11,"to_owned","","",344,[[["self"]],["t"]]],[11,"clone_into","","",344,N],[11,"from","","",344,[[["t"]],["t"]]],[11,"into","","",344,[[["self"]],["u"]]],[11,"try_from","","",344,[[["u"]],["result"]]],[11,"borrow","","",344,[[["self"]],["t"]]],[11,"try_into","","",344,[[["self"]],["result"]]],[11,"borrow_mut","","",344,[[["self"]],["t"]]],[11,"get_type_id","","",344,[[["self"]],["typeid"]]],[11,"not_found","","",344,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::dead","",347,[[["t"]],["t"]]],[11,"map_same","","",347,[[["self"],["f"]],["t"]]],[11,"from","","",347,[[["t"]],["t"]]],[11,"into","","",347,[[["self"]],["u"]]],[11,"try_from","","",347,[[["u"]],["result"]]],[11,"borrow","","",347,[[["self"]],["t"]]],[11,"try_into","","",347,[[["self"]],["result"]]],[11,"borrow_mut","","",347,[[["self"]],["t"]]],[11,"get_type_id","","",347,[[["self"]],["typeid"]]],[11,"not_found","","",347,[[["str"],["str"]],["e"]]],[11,"from_ok","","",348,[[["t"]],["t"]]],[11,"map_same","","",348,[[["self"],["f"]],["t"]]],[11,"from","","",348,[[["t"]],["t"]]],[11,"into","","",348,[[["self"]],["u"]]],[11,"try_from","","",348,[[["u"]],["result"]]],[11,"borrow","","",348,[[["self"]],["t"]]],[11,"try_into","","",348,[[["self"]],["result"]]],[11,"borrow_mut","","",348,[[["self"]],["t"]]],[11,"get_type_id","","",348,[[["self"]],["typeid"]]],[11,"not_found","","",348,[[["str"],["str"]],["e"]]],[11,"from_ok","","",349,[[["t"]],["t"]]],[11,"map_same","","",349,[[["self"],["f"]],["t"]]],[11,"from","","",349,[[["t"]],["t"]]],[11,"into","","",349,[[["self"]],["u"]]],[11,"try_from","","",349,[[["u"]],["result"]]],[11,"borrow","","",349,[[["self"]],["t"]]],[11,"try_into","","",349,[[["self"]],["result"]]],[11,"borrow_mut","","",349,[[["self"]],["t"]]],[11,"get_type_id","","",349,[[["self"]],["typeid"]]],[11,"not_found","","",349,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::dependency_format","",350,[[["t"]],["t"]]],[11,"map_same","","",350,[[["self"],["f"]],["t"]]],[11,"to_owned","","",350,[[["self"]],["t"]]],[11,"clone_into","","",350,N],[11,"from","","",350,[[["t"]],["t"]]],[11,"into","","",350,[[["self"]],["u"]]],[11,"try_from","","",350,[[["u"]],["result"]]],[11,"borrow","","",350,[[["self"]],["t"]]],[11,"try_into","","",350,[[["self"]],["result"]]],[11,"borrow_mut","","",350,[[["self"]],["t"]]],[11,"get_type_id","","",350,[[["self"]],["typeid"]]],[11,"not_found","","",350,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::entry","",351,[[["t"]],["t"]]],[11,"map_same","","",351,[[["self"],["f"]],["t"]]],[11,"from","","",351,[[["t"]],["t"]]],[11,"into","","",351,[[["self"]],["u"]]],[11,"try_from","","",351,[[["u"]],["result"]]],[11,"borrow","","",351,[[["self"]],["t"]]],[11,"try_into","","",351,[[["self"]],["result"]]],[11,"borrow_mut","","",351,[[["self"]],["t"]]],[11,"get_type_id","","",351,[[["self"]],["typeid"]]],[11,"not_found","","",351,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::exported_symbols","",352,[[["t"]],["t"]]],[11,"map_same","","",352,[[["self"],["f"]],["t"]]],[11,"to_owned","","",352,[[["self"]],["t"]]],[11,"clone_into","","",352,N],[11,"from","","",352,[[["t"]],["t"]]],[11,"into","","",352,[[["self"]],["u"]]],[11,"try_from","","",352,[[["u"]],["result"]]],[11,"borrow","","",352,[[["self"]],["t"]]],[11,"try_into","","",352,[[["self"]],["result"]]],[11,"borrow_mut","","",352,[[["self"]],["t"]]],[11,"get_type_id","","",352,[[["self"]],["typeid"]]],[11,"encode","","",352,[[["self"],["e"]],["result"]]],[11,"decode","","",352,[[["d"]],["result"]]],[11,"not_found","","",352,[[["str"],["str"]],["e"]]],[11,"from_ok","","",353,[[["t"]],["t"]]],[11,"map_same","","",353,[[["self"],["f"]],["t"]]],[11,"to_owned","","",353,[[["self"]],["t"]]],[11,"clone_into","","",353,N],[11,"from","","",353,[[["t"]],["t"]]],[11,"into","","",353,[[["self"]],["u"]]],[11,"try_from","","",353,[[["u"]],["result"]]],[11,"borrow","","",353,[[["self"]],["t"]]],[11,"try_into","","",353,[[["self"]],["result"]]],[11,"borrow_mut","","",353,[[["self"]],["t"]]],[11,"get_type_id","","",353,[[["self"]],["typeid"]]],[11,"encode","","",353,[[["self"],["e"]],["result"]]],[11,"decode","","",353,[[["d"]],["result"]]],[11,"not_found","","",353,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::free_region","",354,[[["t"]],["t"]]],[11,"map_same","","",354,[[["self"],["f"]],["t"]]],[11,"from","","",354,[[["t"]],["t"]]],[11,"into","","",354,[[["self"]],["u"]]],[11,"try_from","","",354,[[["u"]],["result"]]],[11,"borrow","","",354,[[["self"]],["t"]]],[11,"try_into","","",354,[[["self"]],["result"]]],[11,"borrow_mut","","",354,[[["self"]],["t"]]],[11,"get_type_id","","",354,[[["self"]],["typeid"]]],[11,"not_found","","",354,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::intrinsicck","",355,[[["t"]],["t"]]],[11,"map_same","","",355,[[["self"],["f"]],["t"]]],[11,"from","","",355,[[["t"]],["t"]]],[11,"into","","",355,[[["self"]],["u"]]],[11,"try_from","","",355,[[["u"]],["result"]]],[11,"borrow","","",355,[[["self"]],["t"]]],[11,"try_into","","",355,[[["self"]],["result"]]],[11,"borrow_mut","","",355,[[["self"]],["t"]]],[11,"get_type_id","","",355,[[["self"]],["typeid"]]],[11,"not_found","","",355,[[["str"],["str"]],["e"]]],[11,"from_ok","","",356,[[["t"]],["t"]]],[11,"map_same","","",356,[[["self"],["f"]],["t"]]],[11,"from","","",356,[[["t"]],["t"]]],[11,"into","","",356,[[["self"]],["u"]]],[11,"try_from","","",356,[[["u"]],["result"]]],[11,"borrow","","",356,[[["self"]],["t"]]],[11,"try_into","","",356,[[["self"]],["result"]]],[11,"borrow_mut","","",356,[[["self"]],["t"]]],[11,"get_type_id","","",356,[[["self"]],["typeid"]]],[11,"not_found","","",356,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::lib_features","",357,[[["t"]],["t"]]],[11,"map_same","","",357,[[["self"],["f"]],["t"]]],[11,"from","","",357,[[["t"]],["t"]]],[11,"into","","",357,[[["self"]],["u"]]],[11,"try_from","","",357,[[["u"]],["result"]]],[11,"borrow","","",357,[[["self"]],["t"]]],[11,"try_into","","",357,[[["self"]],["result"]]],[11,"borrow_mut","","",357,[[["self"]],["t"]]],[11,"get_type_id","","",357,[[["self"]],["typeid"]]],[11,"not_found","","",357,[[["str"],["str"]],["e"]]],[11,"from_ok","","",358,[[["t"]],["t"]]],[11,"map_same","","",358,[[["self"],["f"]],["t"]]],[11,"from","","",358,[[["t"]],["t"]]],[11,"into","","",358,[[["self"]],["u"]]],[11,"try_from","","",358,[[["u"]],["result"]]],[11,"borrow","","",358,[[["self"]],["t"]]],[11,"try_into","","",358,[[["self"]],["result"]]],[11,"borrow_mut","","",358,[[["self"]],["t"]]],[11,"get_type_id","","",358,[[["self"]],["typeid"]]],[11,"not_found","","",358,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::lang_items","",359,[[["t"]],["t"]]],[11,"map_same","","",359,[[["self"],["f"]],["t"]]],[11,"from","","",359,[[["t"]],["t"]]],[11,"into","","",359,[[["self"]],["u"]]],[11,"try_from","","",359,[[["u"]],["result"]]],[11,"borrow","","",359,[[["self"]],["t"]]],[11,"try_into","","",359,[[["self"]],["result"]]],[11,"borrow_mut","","",359,[[["self"]],["t"]]],[11,"get_type_id","","",359,[[["self"]],["typeid"]]],[11,"not_found","","",359,[[["str"],["str"]],["e"]]],[11,"from_ok","","",360,[[["t"]],["t"]]],[11,"map_same","","",360,[[["self"],["f"]],["t"]]],[11,"from","","",360,[[["t"]],["t"]]],[11,"into","","",360,[[["self"]],["u"]]],[11,"try_from","","",360,[[["u"]],["result"]]],[11,"borrow","","",360,[[["self"]],["t"]]],[11,"try_into","","",360,[[["self"]],["result"]]],[11,"borrow_mut","","",360,[[["self"]],["t"]]],[11,"get_type_id","","",360,[[["self"]],["typeid"]]],[11,"not_found","","",360,[[["str"],["str"]],["e"]]],[11,"from_ok","","",361,[[["t"]],["t"]]],[11,"map_same","","",361,[[["self"],["f"]],["t"]]],[11,"to_owned","","",361,[[["self"]],["t"]]],[11,"clone_into","","",361,N],[11,"from","","",361,[[["t"]],["t"]]],[11,"into","","",361,[[["self"]],["u"]]],[11,"try_from","","",361,[[["u"]],["result"]]],[11,"borrow","","",361,[[["self"]],["t"]]],[11,"try_into","","",361,[[["self"]],["result"]]],[11,"borrow_mut","","",361,[[["self"]],["t"]]],[11,"get_type_id","","",361,[[["self"]],["typeid"]]],[11,"encode","","",361,[[["self"],["e"]],["result"]]],[11,"decode","","",361,[[["d"]],["result"]]],[11,"not_found","","",361,[[["str"],["str"]],["e"]]],[11,"require_lang_item","rustc::ty","",677,[[["self"],["langitem"]],["defid"]]],[11,"from_ok","rustc::middle::liveness","",362,[[["t"]],["t"]]],[11,"map_same","","",362,[[["self"],["f"]],["t"]]],[11,"to_owned","","",362,[[["self"]],["t"]]],[11,"clone_into","","",362,N],[11,"from","","",362,[[["t"]],["t"]]],[11,"into","","",362,[[["self"]],["u"]]],[11,"try_from","","",362,[[["u"]],["result"]]],[11,"borrow","","",362,[[["self"]],["t"]]],[11,"try_into","","",362,[[["self"]],["result"]]],[11,"borrow_mut","","",362,[[["self"]],["t"]]],[11,"get_type_id","","",362,[[["self"]],["typeid"]]],[11,"not_found","","",362,[[["str"],["str"]],["e"]]],[11,"from_ok","","",363,[[["t"]],["t"]]],[11,"map_same","","",363,[[["self"],["f"]],["t"]]],[11,"to_owned","","",363,[[["self"]],["t"]]],[11,"clone_into","","",363,N],[11,"from","","",363,[[["t"]],["t"]]],[11,"into","","",363,[[["self"]],["u"]]],[11,"try_from","","",363,[[["u"]],["result"]]],[11,"borrow","","",363,[[["self"]],["t"]]],[11,"try_into","","",363,[[["self"]],["result"]]],[11,"borrow_mut","","",363,[[["self"]],["t"]]],[11,"get_type_id","","",363,[[["self"]],["typeid"]]],[11,"not_found","","",363,[[["str"],["str"]],["e"]]],[11,"from_ok","","",364,[[["t"]],["t"]]],[11,"map_same","","",364,[[["self"],["f"]],["t"]]],[11,"from","","",364,[[["t"]],["t"]]],[11,"into","","",364,[[["self"]],["u"]]],[11,"try_from","","",364,[[["u"]],["result"]]],[11,"borrow","","",364,[[["self"]],["t"]]],[11,"try_into","","",364,[[["self"]],["result"]]],[11,"borrow_mut","","",364,[[["self"]],["t"]]],[11,"get_type_id","","",364,[[["self"]],["typeid"]]],[11,"not_found","","",364,[[["str"],["str"]],["e"]]],[11,"from_ok","","",365,[[["t"]],["t"]]],[11,"map_same","","",365,[[["self"],["f"]],["t"]]],[11,"to_owned","","",365,[[["self"]],["t"]]],[11,"clone_into","","",365,N],[11,"from","","",365,[[["t"]],["t"]]],[11,"into","","",365,[[["self"]],["u"]]],[11,"try_from","","",365,[[["u"]],["result"]]],[11,"borrow","","",365,[[["self"]],["t"]]],[11,"try_into","","",365,[[["self"]],["result"]]],[11,"borrow_mut","","",365,[[["self"]],["t"]]],[11,"get_type_id","","",365,[[["self"]],["typeid"]]],[11,"not_found","","",365,[[["str"],["str"]],["e"]]],[11,"from_ok","","",366,[[["t"]],["t"]]],[11,"map_same","","",366,[[["self"],["f"]],["t"]]],[11,"from","","",366,[[["t"]],["t"]]],[11,"into","","",366,[[["self"]],["u"]]],[11,"try_from","","",366,[[["u"]],["result"]]],[11,"borrow","","",366,[[["self"]],["t"]]],[11,"try_into","","",366,[[["self"]],["result"]]],[11,"borrow_mut","","",366,[[["self"]],["t"]]],[11,"get_type_id","","",366,[[["self"]],["typeid"]]],[11,"not_found","","",366,[[["str"],["str"]],["e"]]],[11,"from_ok","","",367,[[["t"]],["t"]]],[11,"map_same","","",367,[[["self"],["f"]],["t"]]],[11,"to_owned","","",367,[[["self"]],["t"]]],[11,"clone_into","","",367,N],[11,"from","","",367,[[["t"]],["t"]]],[11,"into","","",367,[[["self"]],["u"]]],[11,"try_from","","",367,[[["u"]],["result"]]],[11,"borrow","","",367,[[["self"]],["t"]]],[11,"try_into","","",367,[[["self"]],["result"]]],[11,"borrow_mut","","",367,[[["self"]],["t"]]],[11,"get_type_id","","",367,[[["self"]],["typeid"]]],[11,"not_found","","",367,[[["str"],["str"]],["e"]]],[11,"from_ok","","",368,[[["t"]],["t"]]],[11,"map_same","","",368,[[["self"],["f"]],["t"]]],[11,"to_owned","","",368,[[["self"]],["t"]]],[11,"clone_into","","",368,N],[11,"from","","",368,[[["t"]],["t"]]],[11,"into","","",368,[[["self"]],["u"]]],[11,"try_from","","",368,[[["u"]],["result"]]],[11,"borrow","","",368,[[["self"]],["t"]]],[11,"try_into","","",368,[[["self"]],["result"]]],[11,"borrow_mut","","",368,[[["self"]],["t"]]],[11,"get_type_id","","",368,[[["self"]],["typeid"]]],[11,"not_found","","",368,[[["str"],["str"]],["e"]]],[11,"from_ok","","",369,[[["t"]],["t"]]],[11,"map_same","","",369,[[["self"],["f"]],["t"]]],[11,"from","","",369,[[["t"]],["t"]]],[11,"into","","",369,[[["self"]],["u"]]],[11,"try_from","","",369,[[["u"]],["result"]]],[11,"borrow","","",369,[[["self"]],["t"]]],[11,"try_into","","",369,[[["self"]],["result"]]],[11,"borrow_mut","","",369,[[["self"]],["t"]]],[11,"get_type_id","","",369,[[["self"]],["typeid"]]],[11,"not_found","","",369,[[["str"],["str"]],["e"]]],[11,"from_ok","","",370,[[["t"]],["t"]]],[11,"map_same","","",370,[[["self"],["f"]],["t"]]],[11,"from","","",370,[[["t"]],["t"]]],[11,"into","","",370,[[["self"]],["u"]]],[11,"try_from","","",370,[[["u"]],["result"]]],[11,"borrow","","",370,[[["self"]],["t"]]],[11,"try_into","","",370,[[["self"]],["result"]]],[11,"borrow_mut","","",370,[[["self"]],["t"]]],[11,"get_type_id","","",370,[[["self"]],["typeid"]]],[11,"not_found","","",370,[[["str"],["str"]],["e"]]],[11,"from_ok","","",371,[[["t"]],["t"]]],[11,"map_same","","",371,[[["self"],["f"]],["t"]]],[11,"to_owned","","",371,[[["self"]],["t"]]],[11,"clone_into","","",371,N],[11,"from","","",371,[[["t"]],["t"]]],[11,"into","","",371,[[["self"]],["u"]]],[11,"try_from","","",371,[[["u"]],["result"]]],[11,"borrow","","",371,[[["self"]],["t"]]],[11,"try_into","","",371,[[["self"]],["result"]]],[11,"borrow_mut","","",371,[[["self"]],["t"]]],[11,"get_type_id","","",371,[[["self"]],["typeid"]]],[11,"not_found","","",371,[[["str"],["str"]],["e"]]],[11,"from_ok","","",372,[[["t"]],["t"]]],[11,"map_same","","",372,[[["self"],["f"]],["t"]]],[11,"to_owned","","",372,[[["self"]],["t"]]],[11,"clone_into","","",372,N],[11,"from","","",372,[[["t"]],["t"]]],[11,"into","","",372,[[["self"]],["u"]]],[11,"try_from","","",372,[[["u"]],["result"]]],[11,"borrow","","",372,[[["self"]],["t"]]],[11,"try_into","","",372,[[["self"]],["result"]]],[11,"borrow_mut","","",372,[[["self"]],["t"]]],[11,"get_type_id","","",372,[[["self"]],["typeid"]]],[11,"not_found","","",372,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::mem_categorization","",373,[[["t"]],["t"]]],[11,"map_same","","",373,[[["self"],["f"]],["t"]]],[11,"to_owned","","",373,[[["self"]],["t"]]],[11,"clone_into","","",373,N],[11,"from","","",373,[[["t"]],["t"]]],[11,"to_string","","",373,[[["self"]],["string"]]],[11,"into","","",373,[[["self"]],["u"]]],[11,"try_from","","",373,[[["u"]],["result"]]],[11,"borrow","","",373,[[["self"]],["t"]]],[11,"try_into","","",373,[[["self"]],["result"]]],[11,"borrow_mut","","",373,[[["self"]],["t"]]],[11,"get_type_id","","",373,[[["self"]],["typeid"]]],[11,"not_found","","",373,[[["str"],["str"]],["e"]]],[11,"from_ok","","",374,[[["t"]],["t"]]],[11,"map_same","","",374,[[["self"],["f"]],["t"]]],[11,"to_owned","","",374,[[["self"]],["t"]]],[11,"clone_into","","",374,N],[11,"from","","",374,[[["t"]],["t"]]],[11,"into","","",374,[[["self"]],["u"]]],[11,"try_from","","",374,[[["u"]],["result"]]],[11,"borrow","","",374,[[["self"]],["t"]]],[11,"try_into","","",374,[[["self"]],["result"]]],[11,"borrow_mut","","",374,[[["self"]],["t"]]],[11,"get_type_id","","",374,[[["self"]],["typeid"]]],[11,"not_found","","",374,[[["str"],["str"]],["e"]]],[11,"from_ok","","",375,[[["t"]],["t"]]],[11,"map_same","","",375,[[["self"],["f"]],["t"]]],[11,"to_owned","","",375,[[["self"]],["t"]]],[11,"clone_into","","",375,N],[11,"from","","",375,[[["t"]],["t"]]],[11,"into","","",375,[[["self"]],["u"]]],[11,"try_from","","",375,[[["u"]],["result"]]],[11,"borrow","","",375,[[["self"]],["t"]]],[11,"try_into","","",375,[[["self"]],["result"]]],[11,"borrow_mut","","",375,[[["self"]],["t"]]],[11,"get_type_id","","",375,[[["self"]],["typeid"]]],[11,"not_found","","",375,[[["str"],["str"]],["e"]]],[11,"from_ok","","",376,[[["t"]],["t"]]],[11,"map_same","","",376,[[["self"],["f"]],["t"]]],[11,"to_owned","","",376,[[["self"]],["t"]]],[11,"clone_into","","",376,N],[11,"from","","",376,[[["t"]],["t"]]],[11,"into","","",376,[[["self"]],["u"]]],[11,"try_from","","",376,[[["u"]],["result"]]],[11,"borrow","","",376,[[["self"]],["t"]]],[11,"try_into","","",376,[[["self"]],["result"]]],[11,"borrow_mut","","",376,[[["self"]],["t"]]],[11,"get_type_id","","",376,[[["self"]],["typeid"]]],[11,"not_found","","",376,[[["str"],["str"]],["e"]]],[11,"from_ok","","",377,[[["t"]],["t"]]],[11,"map_same","","",377,[[["self"],["f"]],["t"]]],[11,"to_owned","","",377,[[["self"]],["t"]]],[11,"clone_into","","",377,N],[11,"from","","",377,[[["t"]],["t"]]],[11,"into","","",377,[[["self"]],["u"]]],[11,"try_from","","",377,[[["u"]],["result"]]],[11,"borrow","","",377,[[["self"]],["t"]]],[11,"try_into","","",377,[[["self"]],["result"]]],[11,"borrow_mut","","",377,[[["self"]],["t"]]],[11,"get_type_id","","",377,[[["self"]],["typeid"]]],[11,"not_found","","",377,[[["str"],["str"]],["e"]]],[11,"from_ok","","",378,[[["t"]],["t"]]],[11,"map_same","","",378,[[["self"],["f"]],["t"]]],[11,"to_owned","","",378,[[["self"]],["t"]]],[11,"clone_into","","",378,N],[11,"from","","",378,[[["t"]],["t"]]],[11,"into","","",378,[[["self"]],["u"]]],[11,"try_from","","",378,[[["u"]],["result"]]],[11,"borrow","","",378,[[["self"]],["t"]]],[11,"try_into","","",378,[[["self"]],["result"]]],[11,"borrow_mut","","",378,[[["self"]],["t"]]],[11,"get_type_id","","",378,[[["self"]],["typeid"]]],[11,"not_found","","",378,[[["str"],["str"]],["e"]]],[11,"from_ok","","",379,[[["t"]],["t"]]],[11,"map_same","","",379,[[["self"],["f"]],["t"]]],[11,"to_owned","","",379,[[["self"]],["t"]]],[11,"clone_into","","",379,N],[11,"from","","",379,[[["t"]],["t"]]],[11,"into","","",379,[[["self"]],["u"]]],[11,"try_from","","",379,[[["u"]],["result"]]],[11,"borrow","","",379,[[["self"]],["t"]]],[11,"try_into","","",379,[[["self"]],["result"]]],[11,"borrow_mut","","",379,[[["self"]],["t"]]],[11,"get_type_id","","",379,[[["self"]],["typeid"]]],[11,"not_found","","",379,[[["str"],["str"]],["e"]]],[11,"from_ok","","",380,[[["t"]],["t"]]],[11,"map_same","","",380,[[["self"],["f"]],["t"]]],[11,"to_owned","","",380,[[["self"]],["t"]]],[11,"clone_into","","",380,N],[11,"from","","",380,[[["t"]],["t"]]],[11,"into","","",380,[[["self"]],["u"]]],[11,"try_from","","",380,[[["u"]],["result"]]],[11,"borrow","","",380,[[["self"]],["t"]]],[11,"try_into","","",380,[[["self"]],["result"]]],[11,"borrow_mut","","",380,[[["self"]],["t"]]],[11,"get_type_id","","",380,[[["self"]],["typeid"]]],[11,"not_found","","",380,[[["str"],["str"]],["e"]]],[11,"from_ok","","",381,[[["t"]],["t"]]],[11,"map_same","","",381,[[["self"],["f"]],["t"]]],[11,"to_owned","","",381,[[["self"]],["t"]]],[11,"clone_into","","",381,N],[11,"from","","",381,[[["t"]],["t"]]],[11,"into","","",381,[[["self"]],["u"]]],[11,"try_from","","",381,[[["u"]],["result"]]],[11,"borrow","","",381,[[["self"]],["t"]]],[11,"try_into","","",381,[[["self"]],["result"]]],[11,"borrow_mut","","",381,[[["self"]],["t"]]],[11,"get_type_id","","",381,[[["self"]],["typeid"]]],[11,"not_found","","",381,[[["str"],["str"]],["e"]]],[11,"from_ok","","",382,[[["t"]],["t"]]],[11,"map_same","","",382,[[["self"],["f"]],["t"]]],[11,"to_owned","","",382,[[["self"]],["t"]]],[11,"clone_into","","",382,N],[11,"from","","",382,[[["t"]],["t"]]],[11,"into","","",382,[[["self"]],["u"]]],[11,"try_from","","",382,[[["u"]],["result"]]],[11,"borrow","","",382,[[["self"]],["t"]]],[11,"try_into","","",382,[[["self"]],["result"]]],[11,"borrow_mut","","",382,[[["self"]],["t"]]],[11,"get_type_id","","",382,[[["self"]],["typeid"]]],[11,"not_found","","",382,[[["str"],["str"]],["e"]]],[11,"from_ok","","",383,[[["t"]],["t"]]],[11,"map_same","","",383,[[["self"],["f"]],["t"]]],[11,"from","","",383,[[["t"]],["t"]]],[11,"into","","",383,[[["self"]],["u"]]],[11,"try_from","","",383,[[["u"]],["result"]]],[11,"borrow","","",383,[[["self"]],["t"]]],[11,"try_into","","",383,[[["self"]],["result"]]],[11,"borrow_mut","","",383,[[["self"]],["t"]]],[11,"get_type_id","","",383,[[["self"]],["typeid"]]],[11,"not_found","","",383,[[["str"],["str"]],["e"]]],[11,"from_ok","","",384,[[["t"]],["t"]]],[11,"map_same","","",384,[[["self"],["f"]],["t"]]],[11,"to_owned","","",384,[[["self"]],["t"]]],[11,"clone_into","","",384,N],[11,"from","","",384,[[["t"]],["t"]]],[11,"into","","",384,[[["self"]],["u"]]],[11,"try_from","","",384,[[["u"]],["result"]]],[11,"borrow","","",384,[[["self"]],["t"]]],[11,"try_into","","",384,[[["self"]],["result"]]],[11,"borrow_mut","","",384,[[["self"]],["t"]]],[11,"get_type_id","","",384,[[["self"]],["typeid"]]],[11,"not_found","","",384,[[["str"],["str"]],["e"]]],[11,"from_ok","","",385,[[["t"]],["t"]]],[11,"map_same","","",385,[[["self"],["f"]],["t"]]],[11,"to_owned","","",385,[[["self"]],["t"]]],[11,"clone_into","","",385,N],[11,"from","","",385,[[["t"]],["t"]]],[11,"into","","",385,[[["self"]],["u"]]],[11,"try_from","","",385,[[["u"]],["result"]]],[11,"borrow","","",385,[[["self"]],["t"]]],[11,"try_into","","",385,[[["self"]],["result"]]],[11,"borrow_mut","","",385,[[["self"]],["t"]]],[11,"get_type_id","","",385,[[["self"]],["typeid"]]],[11,"not_found","","",385,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::privacy","",387,[[["t"]],["t"]]],[11,"map_same","","",387,[[["self"],["f"]],["t"]]],[11,"to_owned","","",387,[[["self"]],["t"]]],[11,"clone_into","","",387,N],[11,"from","","",387,[[["t"]],["t"]]],[11,"into","","",387,[[["self"]],["u"]]],[11,"try_from","","",387,[[["u"]],["result"]]],[11,"borrow","","",387,[[["self"]],["t"]]],[11,"try_into","","",387,[[["self"]],["result"]]],[11,"borrow_mut","","",387,[[["self"]],["t"]]],[11,"get_type_id","","",387,[[["self"]],["typeid"]]],[11,"not_found","","",387,[[["str"],["str"]],["e"]]],[11,"from_ok","","",388,[[["t"]],["t"]]],[11,"map_same","","",388,[[["self"],["f"]],["t"]]],[11,"to_owned","","",388,[[["self"]],["t"]]],[11,"clone_into","","",388,N],[11,"from","","",388,[[["t"]],["t"]]],[11,"into","","",388,[[["self"]],["u"]]],[11,"try_from","","",388,[[["u"]],["result"]]],[11,"borrow","","",388,[[["self"]],["t"]]],[11,"try_into","","",388,[[["self"]],["result"]]],[11,"borrow_mut","","",388,[[["self"]],["t"]]],[11,"get_type_id","","",388,[[["self"]],["typeid"]]],[11,"not_found","","",388,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::reachable","",389,[[["t"]],["t"]]],[11,"map_same","","",389,[[["self"],["f"]],["t"]]],[11,"from","","",389,[[["t"]],["t"]]],[11,"into","","",389,[[["self"]],["u"]]],[11,"try_from","","",389,[[["u"]],["result"]]],[11,"borrow","","",389,[[["self"]],["t"]]],[11,"try_into","","",389,[[["self"]],["result"]]],[11,"borrow_mut","","",389,[[["self"]],["t"]]],[11,"get_type_id","","",389,[[["self"]],["typeid"]]],[11,"not_found","","",389,[[["str"],["str"]],["e"]]],[11,"from_ok","","",390,[[["t"]],["t"]]],[11,"map_same","","",390,[[["self"],["f"]],["t"]]],[11,"from","","",390,[[["t"]],["t"]]],[11,"into","","",390,[[["self"]],["u"]]],[11,"try_from","","",390,[[["u"]],["result"]]],[11,"borrow","","",390,[[["self"]],["t"]]],[11,"try_into","","",390,[[["self"]],["result"]]],[11,"borrow_mut","","",390,[[["self"]],["t"]]],[11,"get_type_id","","",390,[[["self"]],["typeid"]]],[11,"not_found","","",390,[[["str"],["str"]],["e"]]],[11,"from_ok","","",391,[[["t"]],["t"]]],[11,"map_same","","",391,[[["self"],["f"]],["t"]]],[11,"to_owned","","",391,[[["self"]],["t"]]],[11,"clone_into","","",391,N],[11,"from","","",391,[[["t"]],["t"]]],[11,"into","","",391,[[["self"]],["u"]]],[11,"try_from","","",391,[[["u"]],["result"]]],[11,"borrow","","",391,[[["self"]],["t"]]],[11,"try_into","","",391,[[["self"]],["result"]]],[11,"borrow_mut","","",391,[[["self"]],["t"]]],[11,"get_type_id","","",391,[[["self"]],["typeid"]]],[11,"not_found","","",391,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::region","",392,[[["t"]],["t"]]],[11,"map_same","","",392,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",392,N],[11,"to_owned","","",392,[[["self"]],["t"]]],[11,"clone_into","","",392,N],[11,"from","","",392,[[["t"]],["t"]]],[11,"into","","",392,[[["self"]],["u"]]],[11,"try_from","","",392,[[["u"]],["result"]]],[11,"borrow","","",392,[[["self"]],["t"]]],[11,"try_into","","",392,[[["self"]],["result"]]],[11,"borrow_mut","","",392,[[["self"]],["t"]]],[11,"get_type_id","","",392,[[["self"]],["typeid"]]],[11,"encode","","",392,[[["self"],["e"]],["result"]]],[11,"decode","","",392,[[["d"]],["result"]]],[11,"not_found","","",392,[[["str"],["str"]],["e"]]],[11,"from_ok","","",393,[[["t"]],["t"]]],[11,"map_same","","",393,[[["self"],["f"]],["t"]]],[11,"to_owned","","",393,[[["self"]],["t"]]],[11,"clone_into","","",393,N],[11,"from","","",393,[[["t"]],["t"]]],[11,"into","","",393,[[["self"]],["u"]]],[11,"try_from","","",393,[[["u"]],["result"]]],[11,"borrow","","",393,[[["self"]],["t"]]],[11,"try_into","","",393,[[["self"]],["result"]]],[11,"borrow_mut","","",393,[[["self"]],["t"]]],[11,"get_type_id","","",393,[[["self"]],["typeid"]]],[11,"encode","","",393,[[["self"],["e"]],["result"]]],[11,"decode","","",393,[[["d"]],["result"]]],[11,"not_found","","",393,[[["str"],["str"]],["e"]]],[11,"from_ok","","",394,[[["t"]],["t"]]],[11,"map_same","","",394,[[["self"],["f"]],["t"]]],[11,"from","","",394,[[["t"]],["t"]]],[11,"into","","",394,[[["self"]],["u"]]],[11,"try_from","","",394,[[["u"]],["result"]]],[11,"borrow","","",394,[[["self"]],["t"]]],[11,"try_into","","",394,[[["self"]],["result"]]],[11,"borrow_mut","","",394,[[["self"]],["t"]]],[11,"get_type_id","","",394,[[["self"]],["typeid"]]],[11,"not_found","","",394,[[["str"],["str"]],["e"]]],[11,"from_ok","","",395,[[["t"]],["t"]]],[11,"map_same","","",395,[[["self"],["f"]],["t"]]],[11,"to_owned","","",395,[[["self"]],["t"]]],[11,"clone_into","","",395,N],[11,"from","","",395,[[["t"]],["t"]]],[11,"into","","",395,[[["self"]],["u"]]],[11,"try_from","","",395,[[["u"]],["result"]]],[11,"borrow","","",395,[[["self"]],["t"]]],[11,"try_into","","",395,[[["self"]],["result"]]],[11,"borrow_mut","","",395,[[["self"]],["t"]]],[11,"get_type_id","","",395,[[["self"]],["typeid"]]],[11,"not_found","","",395,[[["str"],["str"]],["e"]]],[11,"from_ok","","",396,[[["t"]],["t"]]],[11,"map_same","","",396,[[["self"],["f"]],["t"]]],[11,"from","","",396,[[["t"]],["t"]]],[11,"into","","",396,[[["self"]],["u"]]],[11,"try_from","","",396,[[["u"]],["result"]]],[11,"borrow","","",396,[[["self"]],["t"]]],[11,"try_into","","",396,[[["self"]],["result"]]],[11,"borrow_mut","","",396,[[["self"]],["t"]]],[11,"get_type_id","","",396,[[["self"]],["typeid"]]],[11,"not_found","","",396,[[["str"],["str"]],["e"]]],[11,"from_ok","","",397,[[["t"]],["t"]]],[11,"map_same","","",397,[[["self"],["f"]],["t"]]],[11,"from","","",397,[[["t"]],["t"]]],[11,"into","","",397,[[["self"]],["u"]]],[11,"try_from","","",397,[[["u"]],["result"]]],[11,"borrow","","",397,[[["self"]],["t"]]],[11,"try_into","","",397,[[["self"]],["result"]]],[11,"borrow_mut","","",397,[[["self"]],["t"]]],[11,"get_type_id","","",397,[[["self"]],["typeid"]]],[11,"not_found","","",397,[[["str"],["str"]],["e"]]],[11,"from_ok","","",398,[[["t"]],["t"]]],[11,"map_same","","",398,[[["self"],["f"]],["t"]]],[11,"to_owned","","",398,[[["self"]],["t"]]],[11,"clone_into","","",398,N],[11,"from","","",398,[[["t"]],["t"]]],[11,"into","","",398,[[["self"]],["u"]]],[11,"try_from","","",398,[[["u"]],["result"]]],[11,"borrow","","",398,[[["self"]],["t"]]],[11,"try_into","","",398,[[["self"]],["result"]]],[11,"borrow_mut","","",398,[[["self"]],["t"]]],[11,"get_type_id","","",398,[[["self"]],["typeid"]]],[11,"encode","","",398,[[["self"],["e"]],["result"]]],[11,"decode","","",398,[[["d"]],["result"]]],[11,"not_found","","",398,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::resolve_lifetime","",399,[[["t"]],["t"]]],[11,"map_same","","",399,[[["self"],["f"]],["t"]]],[11,"from","","",399,[[["t"]],["t"]]],[11,"into","","",399,[[["self"]],["u"]]],[11,"try_from","","",399,[[["u"]],["result"]]],[11,"borrow","","",399,[[["self"]],["t"]]],[11,"try_into","","",399,[[["self"]],["result"]]],[11,"borrow_mut","","",399,[[["self"]],["t"]]],[11,"get_type_id","","",399,[[["self"]],["typeid"]]],[11,"not_found","","",399,[[["str"],["str"]],["e"]]],[11,"from_ok","","",400,[[["t"]],["t"]]],[11,"map_same","","",400,[[["self"],["f"]],["t"]]],[11,"from","","",400,[[["t"]],["t"]]],[11,"into","","",400,[[["self"]],["u"]]],[11,"try_from","","",400,[[["u"]],["result"]]],[11,"borrow","","",400,[[["self"]],["t"]]],[11,"try_into","","",400,[[["self"]],["result"]]],[11,"borrow_mut","","",400,[[["self"]],["t"]]],[11,"get_type_id","","",400,[[["self"]],["typeid"]]],[11,"not_found","","",400,[[["str"],["str"]],["e"]]],[11,"from_ok","","",401,[[["t"]],["t"]]],[11,"map_same","","",401,[[["self"],["f"]],["t"]]],[11,"from","","",401,[[["t"]],["t"]]],[11,"into","","",401,[[["self"]],["u"]]],[11,"try_from","","",401,[[["u"]],["result"]]],[11,"borrow","","",401,[[["self"]],["t"]]],[11,"try_into","","",401,[[["self"]],["result"]]],[11,"borrow_mut","","",401,[[["self"]],["t"]]],[11,"get_type_id","","",401,[[["self"]],["typeid"]]],[11,"not_found","","",401,[[["str"],["str"]],["e"]]],[11,"from_ok","","",402,[[["t"]],["t"]]],[11,"map_same","","",402,[[["self"],["f"]],["t"]]],[11,"to_owned","","",402,[[["self"]],["t"]]],[11,"clone_into","","",402,N],[11,"from","","",402,[[["t"]],["t"]]],[11,"into","","",402,[[["self"]],["u"]]],[11,"try_from","","",402,[[["u"]],["result"]]],[11,"borrow","","",402,[[["self"]],["t"]]],[11,"try_into","","",402,[[["self"]],["result"]]],[11,"borrow_mut","","",402,[[["self"]],["t"]]],[11,"get_type_id","","",402,[[["self"]],["typeid"]]],[11,"not_found","","",402,[[["str"],["str"]],["e"]]],[11,"from_ok","","",403,[[["t"]],["t"]]],[11,"map_same","","",403,[[["self"],["f"]],["t"]]],[11,"from","","",403,[[["t"]],["t"]]],[11,"into","","",403,[[["self"]],["u"]]],[11,"try_from","","",403,[[["u"]],["result"]]],[11,"borrow","","",403,[[["self"]],["t"]]],[11,"try_into","","",403,[[["self"]],["result"]]],[11,"borrow_mut","","",403,[[["self"]],["t"]]],[11,"get_type_id","","",403,[[["self"]],["typeid"]]],[11,"not_found","","",403,[[["str"],["str"]],["e"]]],[11,"from_ok","","",404,[[["t"]],["t"]]],[11,"map_same","","",404,[[["self"],["f"]],["t"]]],[11,"from","","",404,[[["t"]],["t"]]],[11,"into","","",404,[[["self"]],["u"]]],[11,"try_from","","",404,[[["u"]],["result"]]],[11,"borrow","","",404,[[["self"]],["t"]]],[11,"try_into","","",404,[[["self"]],["result"]]],[11,"borrow_mut","","",404,[[["self"]],["t"]]],[11,"get_type_id","","",404,[[["self"]],["typeid"]]],[11,"not_found","","",404,[[["str"],["str"]],["e"]]],[11,"from_ok","","",405,[[["t"]],["t"]]],[11,"map_same","","",405,[[["self"],["f"]],["t"]]],[11,"to_owned","","",405,[[["self"]],["t"]]],[11,"clone_into","","",405,N],[11,"from","","",405,[[["t"]],["t"]]],[11,"into","","",405,[[["self"]],["u"]]],[11,"try_from","","",405,[[["u"]],["result"]]],[11,"borrow","","",405,[[["self"]],["t"]]],[11,"try_into","","",405,[[["self"]],["result"]]],[11,"borrow_mut","","",405,[[["self"]],["t"]]],[11,"get_type_id","","",405,[[["self"]],["typeid"]]],[11,"encode","","",405,[[["self"],["e"]],["result"]]],[11,"decode","","",405,[[["d"]],["result"]]],[11,"not_found","","",405,[[["str"],["str"]],["e"]]],[11,"from_ok","","",406,[[["t"]],["t"]]],[11,"map_same","","",406,[[["self"],["f"]],["t"]]],[11,"to_owned","","",406,[[["self"]],["t"]]],[11,"clone_into","","",406,N],[11,"from","","",406,[[["t"]],["t"]]],[11,"into","","",406,[[["self"]],["u"]]],[11,"try_from","","",406,[[["u"]],["result"]]],[11,"borrow","","",406,[[["self"]],["t"]]],[11,"try_into","","",406,[[["self"]],["result"]]],[11,"borrow_mut","","",406,[[["self"]],["t"]]],[11,"get_type_id","","",406,[[["self"]],["typeid"]]],[11,"not_found","","",406,[[["str"],["str"]],["e"]]],[11,"from_ok","","",407,[[["t"]],["t"]]],[11,"map_same","","",407,[[["self"],["f"]],["t"]]],[11,"to_owned","","",407,[[["self"]],["t"]]],[11,"clone_into","","",407,N],[11,"from","","",407,[[["t"]],["t"]]],[11,"into","","",407,[[["self"]],["u"]]],[11,"try_from","","",407,[[["u"]],["result"]]],[11,"borrow","","",407,[[["self"]],["t"]]],[11,"try_into","","",407,[[["self"]],["result"]]],[11,"borrow_mut","","",407,[[["self"]],["t"]]],[11,"get_type_id","","",407,[[["self"]],["typeid"]]],[11,"encode","","",407,[[["self"],["e"]],["result"]]],[11,"decode","","",407,[[["d"]],["result"]]],[11,"not_found","","",407,[[["str"],["str"]],["e"]]],[11,"from_ok","","",408,[[["t"]],["t"]]],[11,"map_same","","",408,[[["self"],["f"]],["t"]]],[11,"to_owned","","",408,[[["self"]],["t"]]],[11,"clone_into","","",408,N],[11,"from","","",408,[[["t"]],["t"]]],[11,"into","","",408,[[["self"]],["u"]]],[11,"try_from","","",408,[[["u"]],["result"]]],[11,"borrow","","",408,[[["self"]],["t"]]],[11,"try_into","","",408,[[["self"]],["result"]]],[11,"borrow_mut","","",408,[[["self"]],["t"]]],[11,"get_type_id","","",408,[[["self"]],["typeid"]]],[11,"encode","","",408,[[["self"],["e"]],["result"]]],[11,"decode","","",408,[[["d"]],["result"]]],[11,"not_found","","",408,[[["str"],["str"]],["e"]]],[11,"from_ok","","",409,[[["t"]],["t"]]],[11,"map_same","","",409,[[["self"],["f"]],["t"]]],[11,"from","","",409,[[["t"]],["t"]]],[11,"into","","",409,[[["self"]],["u"]]],[11,"try_from","","",409,[[["u"]],["result"]]],[11,"borrow","","",409,[[["self"]],["t"]]],[11,"try_into","","",409,[[["self"]],["result"]]],[11,"borrow_mut","","",409,[[["self"]],["t"]]],[11,"get_type_id","","",409,[[["self"]],["typeid"]]],[11,"not_found","","",409,[[["str"],["str"]],["e"]]],[11,"from_ok","","",410,[[["t"]],["t"]]],[11,"map_same","","",410,[[["self"],["f"]],["t"]]],[11,"to_owned","","",410,[[["self"]],["t"]]],[11,"clone_into","","",410,N],[11,"from","","",410,[[["t"]],["t"]]],[11,"into","","",410,[[["self"]],["u"]]],[11,"try_from","","",410,[[["u"]],["result"]]],[11,"borrow","","",410,[[["self"]],["t"]]],[11,"try_into","","",410,[[["self"]],["result"]]],[11,"borrow_mut","","",410,[[["self"]],["t"]]],[11,"get_type_id","","",410,[[["self"]],["typeid"]]],[11,"not_found","","",410,[[["str"],["str"]],["e"]]],[11,"from_ok","","",411,[[["t"]],["t"]]],[11,"map_same","","",411,[[["self"],["f"]],["t"]]],[11,"to_owned","","",411,[[["self"]],["t"]]],[11,"clone_into","","",411,N],[11,"from","","",411,[[["t"]],["t"]]],[11,"into","","",411,[[["self"]],["u"]]],[11,"try_from","","",411,[[["u"]],["result"]]],[11,"borrow","","",411,[[["self"]],["t"]]],[11,"try_into","","",411,[[["self"]],["result"]]],[11,"borrow_mut","","",411,[[["self"]],["t"]]],[11,"get_type_id","","",411,[[["self"]],["typeid"]]],[11,"not_found","","",411,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::middle::stability","",412,[[["t"]],["t"]]],[11,"map_same","","",412,[[["self"],["f"]],["t"]]],[11,"to_owned","","",412,[[["self"]],["t"]]],[11,"clone_into","","",412,N],[11,"from","","",412,[[["t"]],["t"]]],[11,"into","","",412,[[["self"]],["u"]]],[11,"try_from","","",412,[[["u"]],["result"]]],[11,"borrow","","",412,[[["self"]],["t"]]],[11,"try_into","","",412,[[["self"]],["result"]]],[11,"borrow_mut","","",412,[[["self"]],["t"]]],[11,"get_type_id","","",412,[[["self"]],["typeid"]]],[11,"not_found","","",412,[[["str"],["str"]],["e"]]],[11,"from_ok","","",413,[[["t"]],["t"]]],[11,"map_same","","",413,[[["self"],["f"]],["t"]]],[11,"from","","",413,[[["t"]],["t"]]],[11,"into","","",413,[[["self"]],["u"]]],[11,"try_from","","",413,[[["u"]],["result"]]],[11,"borrow","","",413,[[["self"]],["t"]]],[11,"try_into","","",413,[[["self"]],["result"]]],[11,"borrow_mut","","",413,[[["self"]],["t"]]],[11,"get_type_id","","",413,[[["self"]],["typeid"]]],[11,"not_found","","",413,[[["str"],["str"]],["e"]]],[11,"from_ok","","",414,[[["t"]],["t"]]],[11,"map_same","","",414,[[["self"],["f"]],["t"]]],[11,"from","","",414,[[["t"]],["t"]]],[11,"into","","",414,[[["self"]],["u"]]],[11,"try_from","","",414,[[["u"]],["result"]]],[11,"borrow","","",414,[[["self"]],["t"]]],[11,"try_into","","",414,[[["self"]],["result"]]],[11,"borrow_mut","","",414,[[["self"]],["t"]]],[11,"get_type_id","","",414,[[["self"]],["typeid"]]],[11,"not_found","","",414,[[["str"],["str"]],["e"]]],[11,"from_ok","","",415,[[["t"]],["t"]]],[11,"map_same","","",415,[[["self"],["f"]],["t"]]],[11,"from","","",415,[[["t"]],["t"]]],[11,"into","","",415,[[["self"]],["u"]]],[11,"try_from","","",415,[[["u"]],["result"]]],[11,"borrow","","",415,[[["self"]],["t"]]],[11,"try_into","","",415,[[["self"]],["result"]]],[11,"borrow_mut","","",415,[[["self"]],["t"]]],[11,"get_type_id","","",415,[[["self"]],["typeid"]]],[11,"not_found","","",415,[[["str"],["str"]],["e"]]],[11,"from_ok","","",416,[[["t"]],["t"]]],[11,"map_same","","",416,[[["self"],["f"]],["t"]]],[11,"from","","",416,[[["t"]],["t"]]],[11,"into","","",416,[[["self"]],["u"]]],[11,"try_from","","",416,[[["u"]],["result"]]],[11,"borrow","","",416,[[["self"]],["t"]]],[11,"try_into","","",416,[[["self"]],["result"]]],[11,"borrow_mut","","",416,[[["self"]],["t"]]],[11,"get_type_id","","",416,[[["self"]],["typeid"]]],[11,"not_found","","",416,[[["str"],["str"]],["e"]]],[11,"from_ok","","",417,[[["t"]],["t"]]],[11,"map_same","","",417,[[["self"],["f"]],["t"]]],[11,"to_owned","","",417,[[["self"]],["t"]]],[11,"clone_into","","",417,N],[11,"from","","",417,[[["t"]],["t"]]],[11,"into","","",417,[[["self"]],["u"]]],[11,"try_from","","",417,[[["u"]],["result"]]],[11,"borrow","","",417,[[["self"]],["t"]]],[11,"try_into","","",417,[[["self"]],["result"]]],[11,"borrow_mut","","",417,[[["self"]],["t"]]],[11,"get_type_id","","",417,[[["self"]],["typeid"]]],[11,"encode","","",417,[[["self"],["e"]],["result"]]],[11,"decode","","",417,[[["d"]],["result"]]],[11,"not_found","","",417,[[["str"],["str"]],["e"]]],[11,"from_ok","","",418,[[["t"]],["t"]]],[11,"map_same","","",418,[[["self"],["f"]],["t"]]],[11,"from","","",418,[[["t"]],["t"]]],[11,"into","","",418,[[["self"]],["u"]]],[11,"try_from","","",418,[[["u"]],["result"]]],[11,"borrow","","",418,[[["self"]],["t"]]],[11,"try_into","","",418,[[["self"]],["result"]]],[11,"borrow_mut","","",418,[[["self"]],["t"]]],[11,"get_type_id","","",418,[[["self"]],["typeid"]]],[11,"not_found","","",418,[[["str"],["str"]],["e"]]],[11,"from_ok","","",419,[[["t"]],["t"]]],[11,"map_same","","",419,[[["self"],["f"]],["t"]]],[11,"from","","",419,[[["t"]],["t"]]],[11,"into","","",419,[[["self"]],["u"]]],[11,"try_from","","",419,[[["u"]],["result"]]],[11,"borrow","","",419,[[["self"]],["t"]]],[11,"try_into","","",419,[[["self"]],["result"]]],[11,"borrow_mut","","",419,[[["self"]],["t"]]],[11,"get_type_id","","",419,[[["self"]],["typeid"]]],[11,"not_found","","",419,[[["str"],["str"]],["e"]]],[11,"skip_stability_check_due_to_privacy","rustc::ty","",677,[[["self"],["defid"]],["bool"]]],[11,"eval_stability","","Evaluates the stability of an item.",677,[[["self"],["defid"],["option",["nodeid"]],["span"]],["evalresult"]]],[11,"check_stability","","Checks if an item is stable or error out.",677,[[["self"],["defid"],["option",["nodeid"]],["span"]]]],[11,"lookup_deprecation","","",677,[[["self"],["defid"]],["option",["deprecation"]]]],[11,"from_ok","rustc::middle::weak_lang_items","",420,[[["t"]],["t"]]],[11,"map_same","","",420,[[["self"],["f"]],["t"]]],[11,"from","","",420,[[["t"]],["t"]]],[11,"into","","",420,[[["self"]],["u"]]],[11,"try_from","","",420,[[["u"]],["result"]]],[11,"borrow","","",420,[[["self"]],["t"]]],[11,"try_into","","",420,[[["self"]],["result"]]],[11,"borrow_mut","","",420,[[["self"]],["t"]]],[11,"get_type_id","","",420,[[["self"]],["typeid"]]],[11,"not_found","","",420,[[["str"],["str"]],["e"]]],[11,"is_weak_lang_item","rustc::ty","",677,[[["self"],["defid"]],["bool"]]],[11,"from_ok","rustc::mir","",421,[[["t"]],["t"]]],[11,"map_same","","",421,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",421,N],[11,"to_owned","","",421,[[["self"]],["t"]]],[11,"clone_into","","",421,N],[11,"from","","",421,[[["t"]],["t"]]],[11,"into","","",421,[[["self"]],["u"]]],[11,"try_from","","",421,[[["u"]],["result"]]],[11,"borrow","","",421,[[["self"]],["t"]]],[11,"try_into","","",421,[[["self"]],["result"]]],[11,"borrow_mut","","",421,[[["self"]],["t"]]],[11,"get_type_id","","",421,[[["self"]],["typeid"]]],[11,"encode","","",421,[[["self"],["e"]],["result"]]],[11,"decode","","",421,[[["d"]],["result"]]],[11,"not_found","","",421,[[["str"],["str"]],["e"]]],[11,"from_ok","","",422,[[["t"]],["t"]]],[11,"map_same","","",422,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",422,N],[11,"to_owned","","",422,[[["self"]],["t"]]],[11,"clone_into","","",422,N],[11,"from","","",422,[[["t"]],["t"]]],[11,"into","","",422,[[["self"]],["u"]]],[11,"try_from","","",422,[[["u"]],["result"]]],[11,"borrow","","",422,[[["self"]],["t"]]],[11,"try_into","","",422,[[["self"]],["result"]]],[11,"borrow_mut","","",422,[[["self"]],["t"]]],[11,"get_type_id","","",422,[[["self"]],["typeid"]]],[11,"encode","","",422,[[["self"],["e"]],["result"]]],[11,"decode","","",422,[[["d"]],["result"]]],[11,"not_found","","",422,[[["str"],["str"]],["e"]]],[11,"from_ok","","",423,[[["t"]],["t"]]],[11,"map_same","","",423,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",423,N],[11,"to_owned","","",423,[[["self"]],["t"]]],[11,"clone_into","","",423,N],[11,"from","","",423,[[["t"]],["t"]]],[11,"into","","",423,[[["self"]],["u"]]],[11,"try_from","","",423,[[["u"]],["result"]]],[11,"borrow","","",423,[[["self"]],["t"]]],[11,"try_into","","",423,[[["self"]],["result"]]],[11,"borrow_mut","","",423,[[["self"]],["t"]]],[11,"get_type_id","","",423,[[["self"]],["typeid"]]],[11,"encode","","",423,[[["self"],["e"]],["result"]]],[11,"decode","","",423,[[["d"]],["result"]]],[11,"not_found","","",423,[[["str"],["str"]],["e"]]],[11,"from_ok","","",424,[[["t"]],["t"]]],[11,"map_same","","",424,[[["self"],["f"]],["t"]]],[11,"to_owned","","",424,[[["self"]],["t"]]],[11,"clone_into","","",424,N],[11,"from","","",424,[[["t"]],["t"]]],[11,"into","","",424,[[["self"]],["u"]]],[11,"try_from","","",424,[[["u"]],["result"]]],[11,"borrow","","",424,[[["self"]],["t"]]],[11,"try_into","","",424,[[["self"]],["result"]]],[11,"borrow_mut","","",424,[[["self"]],["t"]]],[11,"get_type_id","","",424,[[["self"]],["typeid"]]],[11,"encode","","",424,[[["self"],["e"]],["result"]]],[11,"decode","","",424,[[["d"]],["result"]]],[11,"not_found","","",424,[[["str"],["str"]],["e"]]],[11,"from_ok","","",425,[[["t"]],["t"]]],[11,"map_same","","",425,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",425,N],[11,"to_owned","","",425,[[["self"]],["t"]]],[11,"clone_into","","",425,N],[11,"from","","",425,[[["t"]],["t"]]],[11,"into","","",425,[[["self"]],["u"]]],[11,"try_from","","",425,[[["u"]],["result"]]],[11,"borrow","","",425,[[["self"]],["t"]]],[11,"try_into","","",425,[[["self"]],["result"]]],[11,"borrow_mut","","",425,[[["self"]],["t"]]],[11,"get_type_id","","",425,[[["self"]],["typeid"]]],[11,"encode","","",425,[[["self"],["e"]],["result"]]],[11,"decode","","",425,[[["d"]],["result"]]],[11,"not_found","","",425,[[["str"],["str"]],["e"]]],[11,"from_ok","","",426,[[["t"]],["t"]]],[11,"map_same","","",426,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",426,N],[11,"to_owned","","",426,[[["self"]],["t"]]],[11,"clone_into","","",426,N],[11,"from","","",426,[[["t"]],["t"]]],[11,"into","","",426,[[["self"]],["u"]]],[11,"try_from","","",426,[[["u"]],["result"]]],[11,"borrow","","",426,[[["self"]],["t"]]],[11,"try_into","","",426,[[["self"]],["result"]]],[11,"borrow_mut","","",426,[[["self"]],["t"]]],[11,"get_type_id","","",426,[[["self"]],["typeid"]]],[11,"encode","","",426,[[["self"],["e"]],["result"]]],[11,"decode","","",426,[[["d"]],["result"]]],[11,"not_found","","",426,[[["str"],["str"]],["e"]]],[11,"from_ok","","",427,[[["t"]],["t"]]],[11,"map_same","","",427,[[["self"],["f"]],["t"]]],[11,"to_owned","","",427,[[["self"]],["t"]]],[11,"clone_into","","",427,N],[11,"from","","",427,[[["t"]],["t"]]],[11,"into","","",427,[[["self"]],["u"]]],[11,"try_from","","",427,[[["u"]],["result"]]],[11,"borrow","","",427,[[["self"]],["t"]]],[11,"try_into","","",427,[[["self"]],["result"]]],[11,"borrow_mut","","",427,[[["self"]],["t"]]],[11,"get_type_id","","",427,[[["self"]],["typeid"]]],[11,"encode","","",427,[[["self"],["e"]],["result"]]],[11,"decode","","",427,[[["d"]],["result"]]],[11,"not_found","","",427,[[["str"],["str"]],["e"]]],[11,"from_ok","","",428,[[["t"]],["t"]]],[11,"map_same","","",428,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",428,N],[11,"to_owned","","",428,[[["self"]],["t"]]],[11,"clone_into","","",428,N],[11,"from","","",428,[[["t"]],["t"]]],[11,"into","","",428,[[["self"]],["u"]]],[11,"try_from","","",428,[[["u"]],["result"]]],[11,"borrow","","",428,[[["self"]],["t"]]],[11,"try_into","","",428,[[["self"]],["result"]]],[11,"borrow_mut","","",428,[[["self"]],["t"]]],[11,"get_type_id","","",428,[[["self"]],["typeid"]]],[11,"encode","","",428,[[["self"],["e"]],["result"]]],[11,"decode","","",428,[[["d"]],["result"]]],[11,"not_found","","",428,[[["str"],["str"]],["e"]]],[11,"from_ok","","",429,[[["t"]],["t"]]],[11,"map_same","","",429,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",429,N],[11,"to_owned","","",429,[[["self"]],["t"]]],[11,"clone_into","","",429,N],[11,"from","","",429,[[["t"]],["t"]]],[11,"into","","",429,[[["self"]],["u"]]],[11,"try_from","","",429,[[["u"]],["result"]]],[11,"borrow","","",429,[[["self"]],["t"]]],[11,"try_into","","",429,[[["self"]],["result"]]],[11,"borrow_mut","","",429,[[["self"]],["t"]]],[11,"get_type_id","","",429,[[["self"]],["typeid"]]],[11,"encode","","",429,[[["self"],["e"]],["result"]]],[11,"decode","","",429,[[["d"]],["result"]]],[11,"not_found","","",429,[[["str"],["str"]],["e"]]],[11,"from_ok","","",430,[[["t"]],["t"]]],[11,"map_same","","",430,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",430,N],[11,"to_owned","","",430,[[["self"]],["t"]]],[11,"clone_into","","",430,N],[11,"from","","",430,[[["t"]],["t"]]],[11,"into","","",430,[[["self"]],["u"]]],[11,"try_from","","",430,[[["u"]],["result"]]],[11,"borrow","","",430,[[["self"]],["t"]]],[11,"try_into","","",430,[[["self"]],["result"]]],[11,"borrow_mut","","",430,[[["self"]],["t"]]],[11,"get_type_id","","",430,[[["self"]],["typeid"]]],[11,"encode","","",430,[[["self"],["e"]],["result"]]],[11,"decode","","",430,[[["d"]],["result"]]],[11,"not_found","","",430,[[["str"],["str"]],["e"]]],[11,"from_ok","","",431,[[["t"]],["t"]]],[11,"map_same","","",431,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",431,N],[11,"to_owned","","",431,[[["self"]],["t"]]],[11,"clone_into","","",431,N],[11,"from","","",431,[[["t"]],["t"]]],[11,"into","","",431,[[["self"]],["u"]]],[11,"try_from","","",431,[[["u"]],["result"]]],[11,"borrow","","",431,[[["self"]],["t"]]],[11,"try_into","","",431,[[["self"]],["result"]]],[11,"borrow_mut","","",431,[[["self"]],["t"]]],[11,"get_type_id","","",431,[[["self"]],["typeid"]]],[11,"encode","","",431,[[["self"],["e"]],["result"]]],[11,"decode","","",431,[[["d"]],["result"]]],[11,"not_found","","",431,[[["str"],["str"]],["e"]]],[11,"from_ok","","",432,[[["t"]],["t"]]],[11,"map_same","","",432,[[["self"],["f"]],["t"]]],[11,"to_owned","","",432,[[["self"]],["t"]]],[11,"clone_into","","",432,N],[11,"from","","",432,[[["t"]],["t"]]],[11,"into","","",432,[[["self"]],["u"]]],[11,"try_from","","",432,[[["u"]],["result"]]],[11,"borrow","","",432,[[["self"]],["t"]]],[11,"try_into","","",432,[[["self"]],["result"]]],[11,"borrow_mut","","",432,[[["self"]],["t"]]],[11,"get_type_id","","",432,[[["self"]],["typeid"]]],[11,"encode","","",432,[[["self"],["e"]],["result"]]],[11,"decode","","",432,[[["d"]],["result"]]],[11,"not_found","","",432,[[["str"],["str"]],["e"]]],[11,"from_ok","","",433,[[["t"]],["t"]]],[11,"map_same","","",433,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",433,N],[11,"to_owned","","",433,[[["self"]],["t"]]],[11,"clone_into","","",433,N],[11,"from","","",433,[[["t"]],["t"]]],[11,"into","","",433,[[["self"]],["u"]]],[11,"try_from","","",433,[[["u"]],["result"]]],[11,"borrow","","",433,[[["self"]],["t"]]],[11,"try_into","","",433,[[["self"]],["result"]]],[11,"borrow_mut","","",433,[[["self"]],["t"]]],[11,"get_type_id","","",433,[[["self"]],["typeid"]]],[11,"encode","","",433,[[["self"],["e"]],["result"]]],[11,"decode","","",433,[[["d"]],["result"]]],[11,"not_found","","",433,[[["str"],["str"]],["e"]]],[11,"from_ok","","",434,[[["t"]],["t"]]],[11,"map_same","","",434,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",434,N],[11,"to_owned","","",434,[[["self"]],["t"]]],[11,"clone_into","","",434,N],[11,"from","","",434,[[["t"]],["t"]]],[11,"into","","",434,[[["self"]],["u"]]],[11,"try_from","","",434,[[["u"]],["result"]]],[11,"borrow","","",434,[[["self"]],["t"]]],[11,"try_into","","",434,[[["self"]],["result"]]],[11,"borrow_mut","","",434,[[["self"]],["t"]]],[11,"get_type_id","","",434,[[["self"]],["typeid"]]],[11,"encode","","",434,[[["self"],["e"]],["result"]]],[11,"decode","","",434,[[["d"]],["result"]]],[11,"not_found","","",434,[[["str"],["str"]],["e"]]],[11,"from_ok","","",435,[[["t"]],["t"]]],[11,"map_same","","",435,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",435,N],[11,"to_owned","","",435,[[["self"]],["t"]]],[11,"clone_into","","",435,N],[11,"from","","",435,[[["t"]],["t"]]],[11,"into","","",435,[[["self"]],["u"]]],[11,"try_from","","",435,[[["u"]],["result"]]],[11,"borrow","","",435,[[["self"]],["t"]]],[11,"try_into","","",435,[[["self"]],["result"]]],[11,"borrow_mut","","",435,[[["self"]],["t"]]],[11,"get_type_id","","",435,[[["self"]],["typeid"]]],[11,"encode","","",435,[[["self"],["e"]],["result"]]],[11,"decode","","",435,[[["d"]],["result"]]],[11,"not_found","","",435,[[["str"],["str"]],["e"]]],[11,"from_ok","","",436,[[["t"]],["t"]]],[11,"map_same","","",436,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",436,N],[11,"to_owned","","",436,[[["self"]],["t"]]],[11,"clone_into","","",436,N],[11,"from","","",436,[[["t"]],["t"]]],[11,"into","","",436,[[["self"]],["u"]]],[11,"try_from","","",436,[[["u"]],["result"]]],[11,"borrow","","",436,[[["self"]],["t"]]],[11,"try_into","","",436,[[["self"]],["result"]]],[11,"borrow_mut","","",436,[[["self"]],["t"]]],[11,"get_type_id","","",436,[[["self"]],["typeid"]]],[11,"encode","","",436,[[["self"],["e"]],["result"]]],[11,"decode","","",436,[[["d"]],["result"]]],[11,"not_found","","",436,[[["str"],["str"]],["e"]]],[11,"from_ok","","",437,[[["t"]],["t"]]],[11,"map_same","","",437,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",437,N],[11,"to_owned","","",437,[[["self"]],["t"]]],[11,"clone_into","","",437,N],[11,"from","","",437,[[["t"]],["t"]]],[11,"into","","",437,[[["self"]],["u"]]],[11,"try_from","","",437,[[["u"]],["result"]]],[11,"borrow","","",437,[[["self"]],["t"]]],[11,"try_into","","",437,[[["self"]],["result"]]],[11,"borrow_mut","","",437,[[["self"]],["t"]]],[11,"get_type_id","","",437,[[["self"]],["typeid"]]],[11,"encode","","",437,[[["self"],["e"]],["result"]]],[11,"decode","","",437,[[["d"]],["result"]]],[11,"not_found","","",437,[[["str"],["str"]],["e"]]],[11,"from_ok","","",438,[[["t"]],["t"]]],[11,"map_same","","",438,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",438,N],[11,"to_owned","","",438,[[["self"]],["t"]]],[11,"clone_into","","",438,N],[11,"from","","",438,[[["t"]],["t"]]],[11,"into","","",438,[[["self"]],["u"]]],[11,"try_from","","",438,[[["u"]],["result"]]],[11,"borrow","","",438,[[["self"]],["t"]]],[11,"try_into","","",438,[[["self"]],["result"]]],[11,"borrow_mut","","",438,[[["self"]],["t"]]],[11,"get_type_id","","",438,[[["self"]],["typeid"]]],[11,"encode","","",438,[[["self"],["e"]],["result"]]],[11,"decode","","",438,[[["d"]],["result"]]],[11,"not_found","","",438,[[["str"],["str"]],["e"]]],[11,"from_ok","","",439,[[["t"]],["t"]]],[11,"map_same","","",439,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",439,N],[11,"to_owned","","",439,[[["self"]],["t"]]],[11,"clone_into","","",439,N],[11,"from","","",439,[[["t"]],["t"]]],[11,"into","","",439,[[["self"]],["u"]]],[11,"try_from","","",439,[[["u"]],["result"]]],[11,"borrow","","",439,[[["self"]],["t"]]],[11,"try_into","","",439,[[["self"]],["result"]]],[11,"borrow_mut","","",439,[[["self"]],["t"]]],[11,"get_type_id","","",439,[[["self"]],["typeid"]]],[11,"encode","","",439,[[["self"],["e"]],["result"]]],[11,"decode","","",439,[[["d"]],["result"]]],[11,"not_found","","",439,[[["str"],["str"]],["e"]]],[11,"from_ok","","",440,[[["t"]],["t"]]],[11,"map_same","","",440,[[["self"],["f"]],["t"]]],[11,"to_owned","","",440,[[["self"]],["t"]]],[11,"clone_into","","",440,N],[11,"from","","",440,[[["t"]],["t"]]],[11,"into","","",440,[[["self"]],["u"]]],[11,"try_from","","",440,[[["u"]],["result"]]],[11,"borrow","","",440,[[["self"]],["t"]]],[11,"try_into","","",440,[[["self"]],["result"]]],[11,"borrow_mut","","",440,[[["self"]],["t"]]],[11,"get_type_id","","",440,[[["self"]],["typeid"]]],[11,"not_found","","",440,[[["str"],["str"]],["e"]]],[11,"from_ok","","",441,[[["t"]],["t"]]],[11,"map_same","","",441,[[["self"],["f"]],["t"]]],[11,"to_owned","","",441,[[["self"]],["t"]]],[11,"clone_into","","",441,N],[11,"from","","",441,[[["t"]],["t"]]],[11,"into","","",441,[[["self"]],["u"]]],[11,"try_from","","",441,[[["u"]],["result"]]],[11,"borrow","","",441,[[["self"]],["t"]]],[11,"try_into","","",441,[[["self"]],["result"]]],[11,"borrow_mut","","",441,[[["self"]],["t"]]],[11,"get_type_id","","",441,[[["self"]],["typeid"]]],[11,"encode","","",441,[[["self"],["e"]],["result"]]],[11,"decode","","",441,[[["d"]],["result"]]],[11,"not_found","","",441,[[["str"],["str"]],["e"]]],[11,"from_ok","","",442,[[["t"]],["t"]]],[11,"map_same","","",442,[[["self"],["f"]],["t"]]],[11,"to_owned","","",442,[[["self"]],["t"]]],[11,"clone_into","","",442,N],[11,"from","","",442,[[["t"]],["t"]]],[11,"into","","",442,[[["self"]],["u"]]],[11,"try_from","","",442,[[["u"]],["result"]]],[11,"borrow","","",442,[[["self"]],["t"]]],[11,"try_into","","",442,[[["self"]],["result"]]],[11,"borrow_mut","","",442,[[["self"]],["t"]]],[11,"get_type_id","","",442,[[["self"]],["typeid"]]],[11,"encode","","",442,[[["self"],["e"]],["result"]]],[11,"decode","","",442,[[["d"]],["result"]]],[11,"not_found","","",442,[[["str"],["str"]],["e"]]],[11,"from_ok","","",443,[[["t"]],["t"]]],[11,"map_same","","",443,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",443,N],[11,"to_owned","","",443,[[["self"]],["t"]]],[11,"clone_into","","",443,N],[11,"from","","",443,[[["t"]],["t"]]],[11,"into","","",443,[[["self"]],["u"]]],[11,"try_from","","",443,[[["u"]],["result"]]],[11,"borrow","","",443,[[["self"]],["t"]]],[11,"try_into","","",443,[[["self"]],["result"]]],[11,"borrow_mut","","",443,[[["self"]],["t"]]],[11,"get_type_id","","",443,[[["self"]],["typeid"]]],[11,"encode","","",443,[[["self"],["e"]],["result"]]],[11,"decode","","",443,[[["d"]],["result"]]],[11,"not_found","","",443,[[["str"],["str"]],["e"]]],[11,"from_ok","","",444,[[["t"]],["t"]]],[11,"map_same","","",444,[[["self"],["f"]],["t"]]],[11,"to_owned","","",444,[[["self"]],["t"]]],[11,"clone_into","","",444,N],[11,"from","","",444,[[["t"]],["t"]]],[11,"into","","",444,[[["self"]],["u"]]],[11,"try_from","","",444,[[["u"]],["result"]]],[11,"borrow","","",444,[[["self"]],["t"]]],[11,"try_into","","",444,[[["self"]],["result"]]],[11,"borrow_mut","","",444,[[["self"]],["t"]]],[11,"get_type_id","","",444,[[["self"]],["typeid"]]],[11,"encode","","",444,[[["self"],["e"]],["result"]]],[11,"decode","","",444,[[["d"]],["result"]]],[11,"not_found","","",444,[[["str"],["str"]],["e"]]],[11,"from_ok","","",445,[[["t"]],["t"]]],[11,"map_same","","",445,[[["self"],["f"]],["t"]]],[11,"to_owned","","",445,[[["self"]],["t"]]],[11,"clone_into","","",445,N],[11,"from","","",445,[[["t"]],["t"]]],[11,"into","","",445,[[["self"]],["u"]]],[11,"try_from","","",445,[[["u"]],["result"]]],[11,"borrow","","",445,[[["self"]],["t"]]],[11,"try_into","","",445,[[["self"]],["result"]]],[11,"borrow_mut","","",445,[[["self"]],["t"]]],[11,"get_type_id","","",445,[[["self"]],["typeid"]]],[11,"encode","","",445,[[["self"],["e"]],["result"]]],[11,"decode","","",445,[[["d"]],["result"]]],[11,"not_found","","",445,[[["str"],["str"]],["e"]]],[11,"from_ok","","",446,[[["t"]],["t"]]],[11,"map_same","","",446,[[["self"],["f"]],["t"]]],[11,"to_owned","","",446,[[["self"]],["t"]]],[11,"clone_into","","",446,N],[11,"from","","",446,[[["t"]],["t"]]],[11,"into","","",446,[[["self"]],["u"]]],[11,"try_from","","",446,[[["u"]],["result"]]],[11,"borrow","","",446,[[["self"]],["t"]]],[11,"try_into","","",446,[[["self"]],["result"]]],[11,"borrow_mut","","",446,[[["self"]],["t"]]],[11,"get_type_id","","",446,[[["self"]],["typeid"]]],[11,"encode","","",446,[[["self"],["e"]],["result"]]],[11,"decode","","",446,[[["d"]],["result"]]],[11,"not_found","","",446,[[["str"],["str"]],["e"]]],[11,"from_ok","","",447,[[["t"]],["t"]]],[11,"map_same","","",447,[[["self"],["f"]],["t"]]],[11,"to_owned","","",447,[[["self"]],["t"]]],[11,"clone_into","","",447,N],[11,"from","","",447,[[["t"]],["t"]]],[11,"into","","",447,[[["self"]],["u"]]],[11,"try_from","","",447,[[["u"]],["result"]]],[11,"borrow","","",447,[[["self"]],["t"]]],[11,"try_into","","",447,[[["self"]],["result"]]],[11,"borrow_mut","","",447,[[["self"]],["t"]]],[11,"get_type_id","","",447,[[["self"]],["typeid"]]],[11,"encode","","",447,[[["self"],["e"]],["result"]]],[11,"decode","","",447,[[["d"]],["result"]]],[11,"not_found","","",447,[[["str"],["str"]],["e"]]],[11,"from_ok","","",448,[[["t"]],["t"]]],[11,"map_same","","",448,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",448,N],[11,"to_owned","","",448,[[["self"]],["t"]]],[11,"clone_into","","",448,N],[11,"from","","",448,[[["t"]],["t"]]],[11,"into","","",448,[[["self"]],["u"]]],[11,"try_from","","",448,[[["u"]],["result"]]],[11,"borrow","","",448,[[["self"]],["t"]]],[11,"try_into","","",448,[[["self"]],["result"]]],[11,"borrow_mut","","",448,[[["self"]],["t"]]],[11,"get_type_id","","",448,[[["self"]],["typeid"]]],[11,"encode","","",448,[[["self"],["e"]],["result"]]],[11,"decode","","",448,[[["d"]],["result"]]],[11,"not_found","","",448,[[["str"],["str"]],["e"]]],[11,"from_ok","","",449,[[["t"]],["t"]]],[11,"map_same","","",449,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",449,N],[11,"to_owned","","",449,[[["self"]],["t"]]],[11,"clone_into","","",449,N],[11,"from","","",449,[[["t"]],["t"]]],[11,"into","","",449,[[["self"]],["u"]]],[11,"try_from","","",449,[[["u"]],["result"]]],[11,"borrow","","",449,[[["self"]],["t"]]],[11,"try_into","","",449,[[["self"]],["result"]]],[11,"borrow_mut","","",449,[[["self"]],["t"]]],[11,"get_type_id","","",449,[[["self"]],["typeid"]]],[11,"encode","","",449,[[["self"],["e"]],["result"]]],[11,"decode","","",449,[[["d"]],["result"]]],[11,"not_found","","",449,[[["str"],["str"]],["e"]]],[11,"from_ok","","",450,[[["t"]],["t"]]],[11,"map_same","","",450,[[["self"],["f"]],["t"]]],[11,"to_owned","","",450,[[["self"]],["t"]]],[11,"clone_into","","",450,N],[11,"from","","",450,[[["t"]],["t"]]],[11,"into","","",450,[[["self"]],["u"]]],[11,"try_from","","",450,[[["u"]],["result"]]],[11,"borrow","","",450,[[["self"]],["t"]]],[11,"try_into","","",450,[[["self"]],["result"]]],[11,"borrow_mut","","",450,[[["self"]],["t"]]],[11,"get_type_id","","",450,[[["self"]],["typeid"]]],[11,"encode","","",450,[[["self"],["e"]],["result"]]],[11,"decode","","",450,[[["d"]],["result"]]],[11,"not_found","","",450,[[["str"],["str"]],["e"]]],[11,"from_ok","","",451,[[["t"]],["t"]]],[11,"map_same","","",451,[[["self"],["f"]],["t"]]],[11,"from","","",451,[[["t"]],["t"]]],[11,"into","","",451,[[["self"]],["u"]]],[11,"try_from","","",451,[[["u"]],["result"]]],[11,"borrow","","",451,[[["self"]],["t"]]],[11,"try_into","","",451,[[["self"]],["result"]]],[11,"borrow_mut","","",451,[[["self"]],["t"]]],[11,"get_type_id","","",451,[[["self"]],["typeid"]]],[11,"not_found","","",451,[[["str"],["str"]],["e"]]],[11,"from_ok","","",452,[[["t"]],["t"]]],[11,"map_same","","",452,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",452,N],[11,"to_owned","","",452,[[["self"]],["t"]]],[11,"clone_into","","",452,N],[11,"from","","",452,[[["t"]],["t"]]],[11,"into","","",452,[[["self"]],["u"]]],[11,"try_from","","",452,[[["u"]],["result"]]],[11,"borrow","","",452,[[["self"]],["t"]]],[11,"try_into","","",452,[[["self"]],["result"]]],[11,"borrow_mut","","",452,[[["self"]],["t"]]],[11,"get_type_id","","",452,[[["self"]],["typeid"]]],[11,"encode","","",452,[[["self"],["e"]],["result"]]],[11,"decode","","",452,[[["d"]],["result"]]],[11,"not_found","","",452,[[["str"],["str"]],["e"]]],[11,"from_ok","","",453,[[["t"]],["t"]]],[11,"map_same","","",453,[[["self"],["f"]],["t"]]],[11,"to_owned","","",453,[[["self"]],["t"]]],[11,"clone_into","","",453,N],[11,"from","","",453,[[["t"]],["t"]]],[11,"into","","",453,[[["self"]],["u"]]],[11,"try_from","","",453,[[["u"]],["result"]]],[11,"borrow","","",453,[[["self"]],["t"]]],[11,"try_into","","",453,[[["self"]],["result"]]],[11,"borrow_mut","","",453,[[["self"]],["t"]]],[11,"get_type_id","","",453,[[["self"]],["typeid"]]],[11,"encode","","",453,[[["self"],["e"]],["result"]]],[11,"decode","","",453,[[["d"]],["result"]]],[11,"not_found","","",453,[[["str"],["str"]],["e"]]],[11,"from_ok","","",454,[[["t"]],["t"]]],[11,"map_same","","",454,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",454,N],[11,"to_owned","","",454,[[["self"]],["t"]]],[11,"clone_into","","",454,N],[11,"from","","",454,[[["t"]],["t"]]],[11,"into","","",454,[[["self"]],["u"]]],[11,"try_from","","",454,[[["u"]],["result"]]],[11,"borrow","","",454,[[["self"]],["t"]]],[11,"try_into","","",454,[[["self"]],["result"]]],[11,"borrow_mut","","",454,[[["self"]],["t"]]],[11,"get_type_id","","",454,[[["self"]],["typeid"]]],[11,"encode","","",454,[[["self"],["e"]],["result"]]],[11,"decode","","",454,[[["d"]],["result"]]],[11,"not_found","","",454,[[["str"],["str"]],["e"]]],[11,"from_ok","","",455,[[["t"]],["t"]]],[11,"map_same","","",455,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",455,N],[11,"to_owned","","",455,[[["self"]],["t"]]],[11,"clone_into","","",455,N],[11,"from","","",455,[[["t"]],["t"]]],[11,"into","","",455,[[["self"]],["u"]]],[11,"try_from","","",455,[[["u"]],["result"]]],[11,"borrow","","",455,[[["self"]],["t"]]],[11,"try_into","","",455,[[["self"]],["result"]]],[11,"borrow_mut","","",455,[[["self"]],["t"]]],[11,"get_type_id","","",455,[[["self"]],["typeid"]]],[11,"encode","","",455,[[["self"],["e"]],["result"]]],[11,"decode","","",455,[[["d"]],["result"]]],[11,"not_found","","",455,[[["str"],["str"]],["e"]]],[11,"from_ok","","",456,[[["t"]],["t"]]],[11,"map_same","","",456,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",456,N],[11,"to_owned","","",456,[[["self"]],["t"]]],[11,"clone_into","","",456,N],[11,"from","","",456,[[["t"]],["t"]]],[11,"into","","",456,[[["self"]],["u"]]],[11,"try_from","","",456,[[["u"]],["result"]]],[11,"borrow","","",456,[[["self"]],["t"]]],[11,"try_into","","",456,[[["self"]],["result"]]],[11,"borrow_mut","","",456,[[["self"]],["t"]]],[11,"get_type_id","","",456,[[["self"]],["typeid"]]],[11,"encode","","",456,[[["self"],["e"]],["result"]]],[11,"decode","","",456,[[["d"]],["result"]]],[11,"not_found","","",456,[[["str"],["str"]],["e"]]],[11,"from_ok","","",457,[[["t"]],["t"]]],[11,"map_same","","",457,[[["self"],["f"]],["t"]]],[11,"to_owned","","",457,[[["self"]],["t"]]],[11,"clone_into","","",457,N],[11,"from","","",457,[[["t"]],["t"]]],[11,"into","","",457,[[["self"]],["u"]]],[11,"try_from","","",457,[[["u"]],["result"]]],[11,"borrow","","",457,[[["self"]],["t"]]],[11,"try_into","","",457,[[["self"]],["result"]]],[11,"borrow_mut","","",457,[[["self"]],["t"]]],[11,"get_type_id","","",457,[[["self"]],["typeid"]]],[11,"encode","","",457,[[["self"],["e"]],["result"]]],[11,"decode","","",457,[[["d"]],["result"]]],[11,"not_found","","",457,[[["str"],["str"]],["e"]]],[11,"from_ok","","",458,[[["t"]],["t"]]],[11,"map_same","","",458,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",458,N],[11,"to_owned","","",458,[[["self"]],["t"]]],[11,"clone_into","","",458,N],[11,"from","","",458,[[["t"]],["t"]]],[11,"into","","",458,[[["self"]],["u"]]],[11,"try_from","","",458,[[["u"]],["result"]]],[11,"borrow","","",458,[[["self"]],["t"]]],[11,"try_into","","",458,[[["self"]],["result"]]],[11,"borrow_mut","","",458,[[["self"]],["t"]]],[11,"get_type_id","","",458,[[["self"]],["typeid"]]],[11,"encode","","",458,[[["self"],["e"]],["result"]]],[11,"decode","","",458,[[["d"]],["result"]]],[11,"not_found","","",458,[[["str"],["str"]],["e"]]],[11,"from_ok","","",459,[[["t"]],["t"]]],[11,"map_same","","",459,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",459,N],[11,"to_owned","","",459,[[["self"]],["t"]]],[11,"clone_into","","",459,N],[11,"from","","",459,[[["t"]],["t"]]],[11,"into","","",459,[[["self"]],["u"]]],[11,"try_from","","",459,[[["u"]],["result"]]],[11,"borrow","","",459,[[["self"]],["t"]]],[11,"try_into","","",459,[[["self"]],["result"]]],[11,"borrow_mut","","",459,[[["self"]],["t"]]],[11,"get_type_id","","",459,[[["self"]],["typeid"]]],[11,"encode","","",459,[[["self"],["e"]],["result"]]],[11,"decode","","",459,[[["d"]],["result"]]],[11,"not_found","","",459,[[["str"],["str"]],["e"]]],[11,"from_ok","","",460,[[["t"]],["t"]]],[11,"map_same","","",460,[[["self"],["f"]],["t"]]],[11,"to_owned","","",460,[[["self"]],["t"]]],[11,"clone_into","","",460,N],[11,"from","","",460,[[["t"]],["t"]]],[11,"into","","",460,[[["self"]],["u"]]],[11,"try_from","","",460,[[["u"]],["result"]]],[11,"borrow","","",460,[[["self"]],["t"]]],[11,"try_into","","",460,[[["self"]],["result"]]],[11,"borrow_mut","","",460,[[["self"]],["t"]]],[11,"get_type_id","","",460,[[["self"]],["typeid"]]],[11,"encode","","",460,[[["self"],["e"]],["result"]]],[11,"decode","","",460,[[["d"]],["result"]]],[11,"not_found","","",460,[[["str"],["str"]],["e"]]],[11,"from_ok","","",461,[[["t"]],["t"]]],[11,"map_same","","",461,[[["self"],["f"]],["t"]]],[11,"to_owned","","",461,[[["self"]],["t"]]],[11,"clone_into","","",461,N],[11,"from","","",461,[[["t"]],["t"]]],[11,"into","","",461,[[["self"]],["u"]]],[11,"try_from","","",461,[[["u"]],["result"]]],[11,"borrow","","",461,[[["self"]],["t"]]],[11,"try_into","","",461,[[["self"]],["result"]]],[11,"borrow_mut","","",461,[[["self"]],["t"]]],[11,"get_type_id","","",461,[[["self"]],["typeid"]]],[11,"encode","","",461,[[["self"],["e"]],["result"]]],[11,"decode","","",461,[[["d"]],["result"]]],[11,"not_found","","",461,[[["str"],["str"]],["e"]]],[11,"from_ok","","",462,[[["t"]],["t"]]],[11,"map_same","","",462,[[["self"],["f"]],["t"]]],[11,"to_owned","","",462,[[["self"]],["t"]]],[11,"clone_into","","",462,N],[11,"from","","",462,[[["t"]],["t"]]],[11,"into","","",462,[[["self"]],["u"]]],[11,"try_from","","",462,[[["u"]],["result"]]],[11,"borrow","","",462,[[["self"]],["t"]]],[11,"try_into","","",462,[[["self"]],["result"]]],[11,"borrow_mut","","",462,[[["self"]],["t"]]],[11,"get_type_id","","",462,[[["self"]],["typeid"]]],[11,"encode","","",462,[[["self"],["e"]],["result"]]],[11,"decode","","",462,[[["d"]],["result"]]],[11,"not_found","","",462,[[["str"],["str"]],["e"]]],[11,"from_ok","","",463,[[["t"]],["t"]]],[11,"map_same","","",463,[[["self"],["f"]],["t"]]],[11,"to_owned","","",463,[[["self"]],["t"]]],[11,"clone_into","","",463,N],[11,"from","","",463,[[["t"]],["t"]]],[11,"into","","",463,[[["self"]],["u"]]],[11,"try_from","","",463,[[["u"]],["result"]]],[11,"borrow","","",463,[[["self"]],["t"]]],[11,"try_into","","",463,[[["self"]],["result"]]],[11,"borrow_mut","","",463,[[["self"]],["t"]]],[11,"get_type_id","","",463,[[["self"]],["typeid"]]],[11,"encode","","",463,[[["self"],["e"]],["result"]]],[11,"decode","","",463,[[["d"]],["result"]]],[11,"not_found","","",463,[[["str"],["str"]],["e"]]],[11,"from_ok","","",464,[[["t"]],["t"]]],[11,"map_same","","",464,[[["self"],["f"]],["t"]]],[11,"to_owned","","",464,[[["self"]],["t"]]],[11,"clone_into","","",464,N],[11,"from","","",464,[[["t"]],["t"]]],[11,"into","","",464,[[["self"]],["u"]]],[11,"try_from","","",464,[[["u"]],["result"]]],[11,"borrow","","",464,[[["self"]],["t"]]],[11,"try_into","","",464,[[["self"]],["result"]]],[11,"borrow_mut","","",464,[[["self"]],["t"]]],[11,"get_type_id","","",464,[[["self"]],["typeid"]]],[11,"encode","","",464,[[["self"],["e"]],["result"]]],[11,"decode","","",464,[[["d"]],["result"]]],[11,"not_found","","",464,[[["str"],["str"]],["e"]]],[11,"from_ok","","",465,[[["t"]],["t"]]],[11,"map_same","","",465,[[["self"],["f"]],["t"]]],[11,"to_owned","","",465,[[["self"]],["t"]]],[11,"clone_into","","",465,N],[11,"from","","",465,[[["t"]],["t"]]],[11,"into","","",465,[[["self"]],["u"]]],[11,"try_from","","",465,[[["u"]],["result"]]],[11,"borrow","","",465,[[["self"]],["t"]]],[11,"try_into","","",465,[[["self"]],["result"]]],[11,"borrow_mut","","",465,[[["self"]],["t"]]],[11,"get_type_id","","",465,[[["self"]],["typeid"]]],[11,"encode","","",465,[[["self"],["e"]],["result"]]],[11,"decode","","",465,[[["d"]],["result"]]],[11,"not_found","","",465,[[["str"],["str"]],["e"]]],[11,"from_ok","","",466,[[["t"]],["t"]]],[11,"map_same","","",466,[[["self"],["f"]],["t"]]],[11,"to_owned","","",466,[[["self"]],["t"]]],[11,"clone_into","","",466,N],[11,"from","","",466,[[["t"]],["t"]]],[11,"into","","",466,[[["self"]],["u"]]],[11,"try_from","","",466,[[["u"]],["result"]]],[11,"borrow","","",466,[[["self"]],["t"]]],[11,"try_into","","",466,[[["self"]],["result"]]],[11,"borrow_mut","","",466,[[["self"]],["t"]]],[11,"get_type_id","","",466,[[["self"]],["typeid"]]],[11,"encode","","",466,[[["self"],["e"]],["result"]]],[11,"decode","","",466,[[["d"]],["result"]]],[11,"not_found","","",466,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::mir::cache","",467,[[["t"]],["t"]]],[11,"map_same","","",467,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",467,N],[11,"to_owned","","",467,[[["self"]],["t"]]],[11,"clone_into","","",467,N],[11,"from","","",467,[[["t"]],["t"]]],[11,"into","","",467,[[["self"]],["u"]]],[11,"try_from","","",467,[[["u"]],["result"]]],[11,"borrow","","",467,[[["self"]],["t"]]],[11,"try_into","","",467,[[["self"]],["result"]]],[11,"borrow_mut","","",467,[[["self"]],["t"]]],[11,"get_type_id","","",467,[[["self"]],["typeid"]]],[11,"encode","","",467,[[["self"],["e"]],["result"]]],[11,"decode","","",467,[[["d"]],["result"]]],[11,"not_found","","",467,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::mir::interpret","",468,[[["t"]],["t"]]],[11,"map_same","","",468,[[["self"],["f"]],["t"]]],[11,"to_owned","","",468,[[["self"]],["t"]]],[11,"clone_into","","",468,N],[11,"from","","",468,[[["t"]],["t"]]],[11,"to_string","","",468,[[["self"]],["string"]]],[11,"into","","",468,[[["self"]],["u"]]],[11,"try_from","","",468,[[["u"]],["result"]]],[11,"borrow","","",468,[[["self"]],["t"]]],[11,"try_into","","",468,[[["self"]],["result"]]],[11,"borrow_mut","","",468,[[["self"]],["t"]]],[11,"get_type_id","","",468,[[["self"]],["typeid"]]],[11,"encode","","",468,[[["self"],["e"]],["result"]]],[11,"decode","","",468,[[["d"]],["result"]]],[11,"not_found","","",468,[[["str"],["str"]],["e"]]],[11,"from_ok","","",469,[[["t"]],["t"]]],[11,"map_same","","",469,[[["self"],["f"]],["t"]]],[11,"to_owned","","",469,[[["self"]],["t"]]],[11,"clone_into","","",469,N],[11,"from","","",469,[[["t"]],["t"]]],[11,"into","","",469,[[["self"]],["u"]]],[11,"try_from","","",469,[[["u"]],["result"]]],[11,"borrow","","",469,[[["self"]],["t"]]],[11,"try_into","","",469,[[["self"]],["result"]]],[11,"borrow_mut","","",469,[[["self"]],["t"]]],[11,"get_type_id","","",469,[[["self"]],["typeid"]]],[11,"encode","","",469,[[["self"],["e"]],["result"]]],[11,"decode","","",469,[[["d"]],["result"]]],[11,"not_found","","",469,[[["str"],["str"]],["e"]]],[11,"from_ok","","",470,[[["t"]],["t"]]],[11,"map_same","","",470,[[["self"],["f"]],["t"]]],[11,"to_owned","","",470,[[["self"]],["t"]]],[11,"clone_into","","",470,N],[11,"from","","",470,[[["t"]],["t"]]],[11,"into","","",470,[[["self"]],["u"]]],[11,"try_from","","",470,[[["u"]],["result"]]],[11,"borrow","","",470,[[["self"]],["t"]]],[11,"try_into","","",470,[[["self"]],["result"]]],[11,"borrow_mut","","",470,[[["self"]],["t"]]],[11,"get_type_id","","",470,[[["self"]],["typeid"]]],[11,"encode","","",470,[[["self"],["e"]],["result"]]],[11,"decode","","",470,[[["d"]],["result"]]],[11,"not_found","","",470,[[["str"],["str"]],["e"]]],[11,"from_ok","","",471,[[["t"]],["t"]]],[11,"map_same","","",471,[[["self"],["f"]],["t"]]],[11,"to_owned","","",471,[[["self"]],["t"]]],[11,"clone_into","","",471,N],[11,"from","","",471,[[["t"]],["t"]]],[11,"into","","",471,[[["self"]],["u"]]],[11,"try_from","","",471,[[["u"]],["result"]]],[11,"borrow","","",471,[[["self"]],["t"]]],[11,"try_into","","",471,[[["self"]],["result"]]],[11,"borrow_mut","","",471,[[["self"]],["t"]]],[11,"get_type_id","","",471,[[["self"]],["typeid"]]],[11,"encode","","",471,[[["self"],["e"]],["result"]]],[11,"decode","","",471,[[["d"]],["result"]]],[11,"not_found","","",471,[[["str"],["str"]],["e"]]],[11,"from_ok","","",472,[[["t"]],["t"]]],[11,"map_same","","",472,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",472,N],[11,"to_owned","","",472,[[["self"]],["t"]]],[11,"clone_into","","",472,N],[11,"from","","",472,[[["t"]],["t"]]],[11,"into","","",472,[[["self"]],["u"]]],[11,"try_from","","",472,[[["u"]],["result"]]],[11,"borrow","","",472,[[["self"]],["t"]]],[11,"try_into","","",472,[[["self"]],["result"]]],[11,"borrow_mut","","",472,[[["self"]],["t"]]],[11,"get_type_id","","",472,[[["self"]],["typeid"]]],[11,"encode","","",472,[[["self"],["e"]],["result"]]],[11,"decode","","",472,[[["d"]],["result"]]],[11,"not_found","","",472,[[["str"],["str"]],["e"]]],[11,"from_ok","","",473,[[["t"]],["t"]]],[11,"map_same","","",473,[[["self"],["f"]],["t"]]],[11,"to_owned","","",473,[[["self"]],["t"]]],[11,"clone_into","","",473,N],[11,"from","","",473,[[["t"]],["t"]]],[11,"into","","",473,[[["self"]],["u"]]],[11,"try_from","","",473,[[["u"]],["result"]]],[11,"borrow","","",473,[[["self"]],["t"]]],[11,"try_into","","",473,[[["self"]],["result"]]],[11,"borrow_mut","","",473,[[["self"]],["t"]]],[11,"get_type_id","","",473,[[["self"]],["typeid"]]],[11,"encode","","",473,[[["self"],["e"]],["result"]]],[11,"decode","","",473,[[["d"]],["result"]]],[11,"not_found","","",473,[[["str"],["str"]],["e"]]],[11,"from_ok","","",474,[[["t"]],["t"]]],[11,"map_same","","",474,[[["self"],["f"]],["t"]]],[11,"to_owned","","",474,[[["self"]],["t"]]],[11,"clone_into","","",474,N],[11,"from","","",474,[[["t"]],["t"]]],[11,"to_string","","",474,[[["self"]],["string"]]],[11,"into","","",474,[[["self"]],["u"]]],[11,"try_from","","",474,[[["u"]],["result"]]],[11,"borrow","","",474,[[["self"]],["t"]]],[11,"try_into","","",474,[[["self"]],["result"]]],[11,"borrow_mut","","",474,[[["self"]],["t"]]],[11,"get_type_id","","",474,[[["self"]],["typeid"]]],[11,"encode","","",474,[[["self"],["e"]],["result"]]],[11,"decode","","",474,[[["d"]],["result"]]],[11,"not_found","","",474,[[["str"],["str"]],["e"]]],[11,"from_ok","","",475,[[["t"]],["t"]]],[11,"map_same","","",475,[[["self"],["f"]],["t"]]],[11,"from","","",475,[[["t"]],["t"]]],[11,"into","","",475,[[["self"]],["u"]]],[11,"try_from","","",475,[[["u"]],["result"]]],[11,"borrow","","",475,[[["self"]],["t"]]],[11,"try_into","","",475,[[["self"]],["result"]]],[11,"borrow_mut","","",475,[[["self"]],["t"]]],[11,"get_type_id","","",475,[[["self"]],["typeid"]]],[11,"not_found","","",475,[[["str"],["str"]],["e"]]],[11,"from_ok","","",476,[[["t"]],["t"]]],[11,"map_same","","",476,[[["self"],["f"]],["t"]]],[11,"to_owned","","",476,[[["self"]],["t"]]],[11,"clone_into","","",476,N],[11,"from","","",476,[[["t"]],["t"]]],[11,"into","","",476,[[["self"]],["u"]]],[11,"try_from","","",476,[[["u"]],["result"]]],[11,"borrow","","",476,[[["self"]],["t"]]],[11,"try_into","","",476,[[["self"]],["result"]]],[11,"borrow_mut","","",476,[[["self"]],["t"]]],[11,"get_type_id","","",476,[[["self"]],["typeid"]]],[11,"not_found","","",476,[[["str"],["str"]],["e"]]],[11,"from_ok","","",477,[[["t"]],["t"]]],[11,"map_same","","",477,[[["self"],["f"]],["t"]]],[11,"from","","",477,[[["t"]],["t"]]],[11,"into","","",477,[[["self"]],["u"]]],[11,"try_from","","",477,[[["u"]],["result"]]],[11,"borrow","","",477,[[["self"]],["t"]]],[11,"try_into","","",477,[[["self"]],["result"]]],[11,"borrow_mut","","",477,[[["self"]],["t"]]],[11,"get_type_id","","",477,[[["self"]],["typeid"]]],[11,"not_found","","",477,[[["str"],["str"]],["e"]]],[11,"from_ok","","",478,[[["t"]],["t"]]],[11,"map_same","","",478,[[["self"],["f"]],["t"]]],[11,"to_owned","","",478,[[["self"]],["t"]]],[11,"clone_into","","",478,N],[11,"from","","",478,[[["t"]],["t"]]],[11,"into","","",478,[[["self"]],["u"]]],[11,"try_from","","",478,[[["u"]],["result"]]],[11,"borrow","","",478,[[["self"]],["t"]]],[11,"try_into","","",478,[[["self"]],["result"]]],[11,"borrow_mut","","",478,[[["self"]],["t"]]],[11,"get_type_id","","",478,[[["self"]],["typeid"]]],[11,"encode","","",478,[[["self"],["e"]],["result"]]],[11,"decode","","",478,[[["d"]],["result"]]],[11,"not_found","","",478,[[["str"],["str"]],["e"]]],[11,"from_ok","","",479,[[["t"]],["t"]]],[11,"map_same","","",479,[[["self"],["f"]],["t"]]],[11,"to_owned","","",479,[[["self"]],["t"]]],[11,"clone_into","","",479,N],[11,"from","","",479,[[["t"]],["t"]]],[11,"into","","",479,[[["self"]],["u"]]],[11,"try_from","","",479,[[["u"]],["result"]]],[11,"borrow","","",479,[[["self"]],["t"]]],[11,"try_into","","",479,[[["self"]],["result"]]],[11,"borrow_mut","","",479,[[["self"]],["t"]]],[11,"get_type_id","","",479,[[["self"]],["typeid"]]],[11,"encode","","",479,[[["self"],["e"]],["result"]]],[11,"decode","","",479,[[["d"]],["result"]]],[11,"not_found","","",479,[[["str"],["str"]],["e"]]],[11,"from_ok","","",480,[[["t"]],["t"]]],[11,"map_same","","",480,[[["self"],["f"]],["t"]]],[11,"to_owned","","",480,[[["self"]],["t"]]],[11,"clone_into","","",480,N],[11,"from","","",480,[[["t"]],["t"]]],[11,"into","","",480,[[["self"]],["u"]]],[11,"try_from","","",480,[[["u"]],["result"]]],[11,"borrow","","",480,[[["self"]],["t"]]],[11,"try_into","","",480,[[["self"]],["result"]]],[11,"borrow_mut","","",480,[[["self"]],["t"]]],[11,"get_type_id","","",480,[[["self"]],["typeid"]]],[11,"encode","","",480,[[["self"],["e"]],["result"]]],[11,"decode","","",480,[[["d"]],["result"]]],[11,"not_found","","",480,[[["str"],["str"]],["e"]]],[11,"from_ok","","",481,[[["t"]],["t"]]],[11,"map_same","","",481,[[["self"],["f"]],["t"]]],[11,"to_owned","","",481,[[["self"]],["t"]]],[11,"clone_into","","",481,N],[11,"from","","",481,[[["t"]],["t"]]],[11,"into","","",481,[[["self"]],["u"]]],[11,"try_from","","",481,[[["u"]],["result"]]],[11,"borrow","","",481,[[["self"]],["t"]]],[11,"try_into","","",481,[[["self"]],["result"]]],[11,"borrow_mut","","",481,[[["self"]],["t"]]],[11,"get_type_id","","",481,[[["self"]],["typeid"]]],[11,"encode","","",481,[[["self"],["e"]],["result"]]],[11,"decode","","",481,[[["d"]],["result"]]],[11,"not_found","","",481,[[["str"],["str"]],["e"]]],[11,"from_ok","","",482,[[["t"]],["t"]]],[11,"map_same","","",482,[[["self"],["f"]],["t"]]],[11,"to_owned","","",482,[[["self"]],["t"]]],[11,"clone_into","","",482,N],[11,"from","","",482,[[["t"]],["t"]]],[11,"into","","",482,[[["self"]],["u"]]],[11,"try_from","","",482,[[["u"]],["result"]]],[11,"borrow","","",482,[[["self"]],["t"]]],[11,"try_into","","",482,[[["self"]],["result"]]],[11,"borrow_mut","","",482,[[["self"]],["t"]]],[11,"get_type_id","","",482,[[["self"]],["typeid"]]],[11,"encode","","",482,[[["self"],["e"]],["result"]]],[11,"decode","","",482,[[["d"]],["result"]]],[11,"not_found","","",482,[[["str"],["str"]],["e"]]],[11,"from_ok","","",483,[[["t"]],["t"]]],[11,"map_same","","",483,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",483,N],[11,"to_owned","","",483,[[["self"]],["t"]]],[11,"clone_into","","",483,N],[11,"from","","",483,[[["t"]],["t"]]],[11,"into","","",483,[[["self"]],["u"]]],[11,"try_from","","",483,[[["u"]],["result"]]],[11,"borrow","","",483,[[["self"]],["t"]]],[11,"try_into","","",483,[[["self"]],["result"]]],[11,"borrow_mut","","",483,[[["self"]],["t"]]],[11,"get_type_id","","",483,[[["self"]],["typeid"]]],[11,"encode","","",483,[[["self"],["e"]],["result"]]],[11,"decode","","",483,[[["d"]],["result"]]],[11,"not_found","","",483,[[["str"],["str"]],["e"]]],[11,"from_ok","","",484,[[["t"]],["t"]]],[11,"map_same","","",484,[[["self"],["f"]],["t"]]],[11,"to_owned","","",484,[[["self"]],["t"]]],[11,"clone_into","","",484,N],[11,"from","","",484,[[["t"]],["t"]]],[11,"into","","",484,[[["self"]],["u"]]],[11,"try_from","","",484,[[["u"]],["result"]]],[11,"borrow","","",484,[[["self"]],["t"]]],[11,"try_into","","",484,[[["self"]],["result"]]],[11,"borrow_mut","","",484,[[["self"]],["t"]]],[11,"get_type_id","","",484,[[["self"]],["typeid"]]],[11,"encode","","",484,[[["self"],["e"]],["result"]]],[11,"decode","","",484,[[["d"]],["result"]]],[11,"not_found","","",484,[[["str"],["str"]],["e"]]],[11,"from_ok","","",485,[[["t"]],["t"]]],[11,"map_same","","",485,[[["self"],["f"]],["t"]]],[11,"to_owned","","",485,[[["self"]],["t"]]],[11,"clone_into","","",485,N],[11,"from","","",485,[[["t"]],["t"]]],[11,"into","","",485,[[["self"]],["u"]]],[11,"try_from","","",485,[[["u"]],["result"]]],[11,"borrow","","",485,[[["self"]],["t"]]],[11,"try_into","","",485,[[["self"]],["result"]]],[11,"borrow_mut","","",485,[[["self"]],["t"]]],[11,"get_type_id","","",485,[[["self"]],["typeid"]]],[11,"encode","","",485,[[["self"],["e"]],["result"]]],[11,"decode","","",485,[[["d"]],["result"]]],[11,"not_found","","",485,[[["str"],["str"]],["e"]]],[11,"from_ok","","",486,[[["t"]],["t"]]],[11,"map_same","","",486,[[["self"],["f"]],["t"]]],[11,"to_owned","","",486,[[["self"]],["t"]]],[11,"clone_into","","",486,N],[11,"from","","",486,[[["t"]],["t"]]],[11,"into","","",486,[[["self"]],["u"]]],[11,"try_from","","",486,[[["u"]],["result"]]],[11,"borrow","","",486,[[["self"]],["t"]]],[11,"try_into","","",486,[[["self"]],["result"]]],[11,"borrow_mut","","",486,[[["self"]],["t"]]],[11,"get_type_id","","",486,[[["self"]],["typeid"]]],[11,"encode","","",486,[[["self"],["e"]],["result"]]],[11,"decode","","",486,[[["d"]],["result"]]],[11,"not_found","","",486,[[["str"],["str"]],["e"]]],[11,"from_ok","","",487,[[["t"]],["t"]]],[11,"map_same","","",487,[[["self"],["f"]],["t"]]],[11,"from","","",487,[[["t"]],["t"]]],[11,"into","","",487,[[["self"]],["u"]]],[11,"try_from","","",487,[[["u"]],["result"]]],[11,"borrow","","",487,[[["self"]],["t"]]],[11,"try_into","","",487,[[["self"]],["result"]]],[11,"borrow_mut","","",487,[[["self"]],["t"]]],[11,"get_type_id","","",487,[[["self"]],["typeid"]]],[11,"encode","","",487,[[["self"],["e"]],["result"]]],[11,"decode","","",487,[[["d"]],["result"]]],[11,"not_found","","",487,[[["str"],["str"]],["e"]]],[11,"from_ok","","",488,[[["t"]],["t"]]],[11,"map_same","","",488,[[["self"],["f"]],["t"]]],[11,"to_owned","","",488,[[["self"]],["t"]]],[11,"clone_into","","",488,N],[11,"from","","",488,[[["t"]],["t"]]],[11,"into","","",488,[[["self"]],["u"]]],[11,"try_from","","",488,[[["u"]],["result"]]],[11,"borrow","","",488,[[["self"]],["t"]]],[11,"try_into","","",488,[[["self"]],["result"]]],[11,"borrow_mut","","",488,[[["self"]],["t"]]],[11,"get_type_id","","",488,[[["self"]],["typeid"]]],[11,"not_found","","",488,[[["str"],["str"]],["e"]]],[11,"from_ok","","",489,[[["t"]],["t"]]],[11,"map_same","","",489,[[["self"],["f"]],["t"]]],[11,"to_owned","","",489,[[["self"]],["t"]]],[11,"clone_into","","",489,N],[11,"from","","",489,[[["t"]],["t"]]],[11,"into","","",489,[[["self"]],["u"]]],[11,"try_from","","",489,[[["u"]],["result"]]],[11,"borrow","","",489,[[["self"]],["t"]]],[11,"try_into","","",489,[[["self"]],["result"]]],[11,"borrow_mut","","",489,[[["self"]],["t"]]],[11,"get_type_id","","",489,[[["self"]],["typeid"]]],[11,"encode","","",489,[[["self"],["e"]],["result"]]],[11,"decode","","",489,[[["d"]],["result"]]],[11,"not_found","","",489,[[["str"],["str"]],["e"]]],[11,"assert_receiver_is_total_eq","rustc::ty::layout::call","",781,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout","",791,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout::call","",775,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout","",785,N],[11,"assert_receiver_is_total_eq","","",794,N],[11,"assert_receiver_is_total_eq","","",788,N],[11,"assert_receiver_is_total_eq","","",786,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout::call","",777,N],[11,"assert_receiver_is_total_eq","","",773,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout","",792,N],[11,"assert_receiver_is_total_eq","","",793,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout::call","",774,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout","",790,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout::call","",776,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout","",787,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout::call","",772,N],[11,"assert_receiver_is_total_eq","rustc::ty::layout","",789,N],[11,"fmt","rustc::ty::layout::call","",781,[[["self"],["formatter"]],["result",["error"]]]],[11,"mul","rustc::ty::layout","",785,[[["self"],["u64"]],["size"]]],[11,"bitor_assign","rustc::ty::layout::call","Adds the set of flags.",781,N],[11,"bitand_assign","","Disables all flags disabled in the set.",781,N],[11,"not","","Returns the complement of this set of flags.",781,[[["self"]],["argattribute"]]],[11,"bitxor_assign","","Toggles the set of flags.",781,N],[11,"from","","",776,[[["reg"]],["uniform"]]],[11,"from","","",777,[[["uniform"]],["casttarget"]]],[11,"from","","",777,[[["reg"]],["casttarget"]]],[11,"partial_cmp","rustc::ty::layout","",788,[[["self"],["floatty"]],["option",["ordering"]]]],[11,"partial_cmp","rustc::ty::layout::call","",781,[[["self"],["argattribute"]],["option",["ordering"]]]],[11,"lt","","",781,[[["self"],["argattribute"]],["bool"]]],[11,"le","","",781,[[["self"],["argattribute"]],["bool"]]],[11,"gt","","",781,[[["self"],["argattribute"]],["bool"]]],[11,"ge","","",781,[[["self"],["argattribute"]],["bool"]]],[11,"partial_cmp","rustc::ty::layout","",785,[[["self"],["size"]],["option",["ordering"]]]],[11,"lt","","",785,[[["self"],["size"]],["bool"]]],[11,"le","","",785,[[["self"],["size"]],["bool"]]],[11,"gt","","",785,[[["self"],["size"]],["bool"]]],[11,"ge","","",785,[[["self"],["size"]],["bool"]]],[11,"partial_cmp","","",786,[[["self"],["align"]],["option",["ordering"]]]],[11,"lt","","",786,[[["self"],["align"]],["bool"]]],[11,"le","","",786,[[["self"],["align"]],["bool"]]],[11,"gt","","",786,[[["self"],["align"]],["bool"]]],[11,"ge","","",786,[[["self"],["align"]],["bool"]]],[11,"partial_cmp","","",787,[[["self"],["integer"]],["option",["ordering"]]]],[11,"fmt","","",788,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",781,[[["self"],["formatter"]],["result",["error"]]]],[11,"from_iter","","",781,[[["t"]],["argattribute"]]],[11,"add","rustc::ty::layout","",785,[[["self"],["size"]],["size"]]],[11,"default","rustc::ty::layout::call","",781,[[],["argattribute"]]],[11,"default","rustc::ty::layout","Creates an instance of `TargetDataLayout`.",782,[[],["targetdatalayout"]]],[11,"fmt","rustc::ty::layout::call","",781,[[["self"],["formatter"]],["result",["error"]]]],[11,"sub","rustc::ty::layout","",785,[[["self"],["size"]],["size"]]],[11,"sub","rustc::ty::layout::call","Returns the set difference of the two sets of flags.",781,[[["self"],["argattribute"]],["argattribute"]]],[11,"cmp","","",781,[[["self"],["argattribute"]],["ordering"]]],[11,"cmp","rustc::ty::layout","",786,[[["self"],["align"]],["ordering"]]],[11,"cmp","","",787,[[["self"],["integer"]],["ordering"]]],[11,"cmp","","",785,[[["self"],["size"]],["ordering"]]],[11,"cmp","","",788,[[["self"],["floatty"]],["ordering"]]],[11,"decode","","",788,[[["__d"]],["result",["floatty"]]]],[11,"decode","","",786,[[["__d"]],["result",["align"]]]],[11,"decode","","",785,[[["__d"]],["result",["size"]]]],[11,"eq","rustc::ty::layout::call","",773,[[["self"],["argattributes"]],["bool"]]],[11,"ne","","",773,[[["self"],["argattributes"]],["bool"]]],[11,"eq","rustc::ty::layout","",789,[[["self"],["primitive"]],["bool"]]],[11,"ne","","",789,[[["self"],["primitive"]],["bool"]]],[11,"eq","","",790,[[["self"],["scalar"]],["bool"]]],[11,"ne","","",790,[[["self"],["scalar"]],["bool"]]],[11,"eq","rustc::ty::layout::call","",775,[[["self"],["reg"]],["bool"]]],[11,"ne","","",775,[[["self"],["reg"]],["bool"]]],[11,"eq","","",777,[[["self"],["casttarget"]],["bool"]]],[11,"ne","","",777,[[["self"],["casttarget"]],["bool"]]],[11,"eq","rustc::ty::layout","",788,[[["self"],["floatty"]],["bool"]]],[11,"eq","rustc::ty::layout::call","",774,[[["self"],["regkind"]],["bool"]]],[11,"eq","","",779,[[["self"],["conv"]],["bool"]]],[11,"eq","rustc::ty::layout","",792,[[["self"],["abi"]],["bool"]]],[11,"ne","","",792,[[["self"],["abi"]],["bool"]]],[11,"eq","","",787,[[["self"],["integer"]],["bool"]]],[11,"eq","","",785,[[["self"],["size"]],["bool"]]],[11,"ne","","",785,[[["self"],["size"]],["bool"]]],[11,"eq","","",793,[[["self"],["variants"]],["bool"]]],[11,"ne","","",793,[[["self"],["variants"]],["bool"]]],[11,"eq","","",791,[[["self"],["fieldplacement"]],["bool"]]],[11,"ne","","",791,[[["self"],["fieldplacement"]],["bool"]]],[11,"eq","","",794,[[["self"],["layoutdetails"]],["bool"]]],[11,"ne","","",794,[[["self"],["layoutdetails"]],["bool"]]],[11,"eq","rustc::ty::layout::call","",781,[[["self"],["argattribute"]],["bool"]]],[11,"ne","","",781,[[["self"],["argattribute"]],["bool"]]],[11,"eq","rustc::ty::layout","",786,[[["self"],["align"]],["bool"]]],[11,"ne","","",786,[[["self"],["align"]],["bool"]]],[11,"eq","rustc::ty::layout::call","",772,[[["self"],["passmode"]],["bool"]]],[11,"ne","","",772,[[["self"],["passmode"]],["bool"]]],[11,"eq","","",776,[[["self"],["uniform"]],["bool"]]],[11,"ne","","",776,[[["self"],["uniform"]],["bool"]]],[11,"fmt","","",772,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",774,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",787,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",789,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",785,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",779,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",795,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",793,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",773,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",788,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",778,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",794,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",790,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",775,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",791,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",780,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",781,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout","",792,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",786,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc::ty::layout::call","",776,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",777,[[["self"],["formatter"]],["result",["error"]]]],[11,"deref","rustc::ty::layout","",795,[[["self"]],["layoutdetails"]]],[11,"bitxor","rustc::ty::layout::call","Returns the left flags, but with all the right flags toggled.",781,[[["self"],["argattribute"]],["argattribute"]]],[11,"hash","rustc::ty::layout","",793,N],[11,"hash","","",789,N],[11,"hash","","",792,N],[11,"hash","","",794,N],[11,"hash","","",788,N],[11,"hash","","",786,N],[11,"hash","rustc::ty::layout::call","",781,N],[11,"hash","rustc::ty::layout","",790,N],[11,"hash","","",785,N],[11,"hash","","",787,N],[11,"hash","","",791,N],[11,"sub_assign","rustc::ty::layout::call","Disables all flags enabled in the set.",781,N],[11,"encode","rustc::ty::layout","",785,[[["self"],["__s"]],["result"]]],[11,"encode","","",788,[[["self"],["__s"]],["result"]]],[11,"encode","","",786,[[["self"],["__s"]],["result"]]],[11,"fmt","rustc::ty::layout::call","",781,[[["self"],["formatter"]],["result",["error"]]]],[11,"add_assign","rustc::ty::layout","",785,N],[11,"extend","rustc::ty::layout::call","",781,N],[11,"clone","","",781,[[["self"]],["argattribute"]]],[11,"clone","rustc::ty::layout","",785,[[["self"]],["size"]]],[11,"clone","","",786,[[["self"]],["align"]]],[11,"clone","","",788,[[["self"]],["floatty"]]],[11,"clone","rustc::ty::layout::call","",773,[[["self"]],["argattributes"]]],[11,"clone","","",779,[[["self"]],["conv"]]],[11,"clone","","",774,[[["self"]],["regkind"]]],[11,"clone","","",776,[[["self"]],["uniform"]]],[11,"clone","rustc::ty::layout","",795,[[["self"]],["tylayout"]]],[11,"clone","rustc::ty::layout::call","",777,[[["self"]],["casttarget"]]],[11,"clone","rustc::ty::layout","",787,[[["self"]],["integer"]]],[11,"clone","","",790,[[["self"]],["scalar"]]],[11,"clone","","",792,[[["self"]],["abi"]]],[11,"clone","rustc::ty::layout::call","",775,[[["self"]],["reg"]]],[11,"clone","rustc::ty::layout","",784,[[["self"]],["endian"]]],[11,"clone","","",789,[[["self"]],["primitive"]]],[11,"clone","rustc::ty::layout::call","",772,[[["self"]],["passmode"]]],[11,"bitand","","Returns the intersection between the two sets of flags.",781,[[["self"],["argattribute"]],["argattribute"]]],[11,"bitor","","Returns the union of the two sets of flags.",781,[[["self"],["argattribute"]],["argattribute"]]],[11,"from_ok","rustc::mir::mono","",491,[[["t"]],["t"]]],[11,"map_same","","",491,[[["self"],["f"]],["t"]]],[11,"from","","",491,[[["t"]],["t"]]],[11,"into","","",491,[[["self"]],["u"]]],[11,"try_from","","",491,[[["u"]],["result"]]],[11,"borrow","","",491,[[["self"]],["t"]]],[11,"try_into","","",491,[[["self"]],["result"]]],[11,"borrow_mut","","",491,[[["self"]],["t"]]],[11,"get_type_id","","",491,[[["self"]],["typeid"]]],[11,"not_found","","",491,[[["str"],["str"]],["e"]]],[11,"from_ok","","",492,[[["t"]],["t"]]],[11,"map_same","","",492,[[["self"],["f"]],["t"]]],[11,"to_owned","","",492,[[["self"]],["t"]]],[11,"clone_into","","",492,N],[11,"from","","",492,[[["t"]],["t"]]],[11,"into","","",492,[[["self"]],["u"]]],[11,"try_from","","",492,[[["u"]],["result"]]],[11,"borrow","","",492,[[["self"]],["t"]]],[11,"try_into","","",492,[[["self"]],["result"]]],[11,"borrow_mut","","",492,[[["self"]],["t"]]],[11,"get_type_id","","",492,[[["self"]],["typeid"]]],[11,"not_found","","",492,[[["str"],["str"]],["e"]]],[11,"from_ok","","",493,[[["t"]],["t"]]],[11,"map_same","","",493,[[["self"],["f"]],["t"]]],[11,"from","","",493,[[["t"]],["t"]]],[11,"into","","",493,[[["self"]],["u"]]],[11,"try_from","","",493,[[["u"]],["result"]]],[11,"borrow","","",493,[[["self"]],["t"]]],[11,"try_into","","",493,[[["self"]],["result"]]],[11,"borrow_mut","","",493,[[["self"]],["t"]]],[11,"get_type_id","","",493,[[["self"]],["typeid"]]],[11,"not_found","","",493,[[["str"],["str"]],["e"]]],[11,"from_ok","","",494,[[["t"]],["t"]]],[11,"map_same","","",494,[[["self"],["f"]],["t"]]],[11,"to_owned","","",494,[[["self"]],["t"]]],[11,"clone_into","","",494,N],[11,"from","","",494,[[["t"]],["t"]]],[11,"into","","",494,[[["self"]],["u"]]],[11,"try_from","","",494,[[["u"]],["result"]]],[11,"borrow","","",494,[[["self"]],["t"]]],[11,"try_into","","",494,[[["self"]],["result"]]],[11,"borrow_mut","","",494,[[["self"]],["t"]]],[11,"get_type_id","","",494,[[["self"]],["typeid"]]],[11,"not_found","","",494,[[["str"],["str"]],["e"]]],[11,"from_ok","","",495,[[["t"]],["t"]]],[11,"map_same","","",495,[[["self"],["f"]],["t"]]],[11,"to_owned","","",495,[[["self"]],["t"]]],[11,"clone_into","","",495,N],[11,"from","","",495,[[["t"]],["t"]]],[11,"into","","",495,[[["self"]],["u"]]],[11,"try_from","","",495,[[["u"]],["result"]]],[11,"borrow","","",495,[[["self"]],["t"]]],[11,"try_into","","",495,[[["self"]],["result"]]],[11,"borrow_mut","","",495,[[["self"]],["t"]]],[11,"get_type_id","","",495,[[["self"]],["typeid"]]],[11,"encode","","",495,[[["self"],["e"]],["result"]]],[11,"decode","","",495,[[["d"]],["result"]]],[11,"not_found","","",495,[[["str"],["str"]],["e"]]],[11,"from_ok","","",496,[[["t"]],["t"]]],[11,"map_same","","",496,[[["self"],["f"]],["t"]]],[11,"to_owned","","",496,[[["self"]],["t"]]],[11,"clone_into","","",496,N],[11,"from","","",496,[[["t"]],["t"]]],[11,"into","","",496,[[["self"]],["u"]]],[11,"try_from","","",496,[[["u"]],["result"]]],[11,"borrow","","",496,[[["self"]],["t"]]],[11,"try_into","","",496,[[["self"]],["result"]]],[11,"borrow_mut","","",496,[[["self"]],["t"]]],[11,"get_type_id","","",496,[[["self"]],["typeid"]]],[11,"not_found","","",496,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::mir::tcx","",497,[[["t"]],["t"]]],[11,"map_same","","",497,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",497,N],[11,"to_owned","","",497,[[["self"]],["t"]]],[11,"clone_into","","",497,N],[11,"from","","",497,[[["t"]],["t"]]],[11,"into","","",497,[[["self"]],["u"]]],[11,"try_from","","",497,[[["u"]],["result"]]],[11,"borrow","","",497,[[["self"]],["t"]]],[11,"try_into","","",497,[[["self"]],["result"]]],[11,"borrow_mut","","",497,[[["self"]],["t"]]],[11,"get_type_id","","",497,[[["self"]],["typeid"]]],[11,"not_found","","",497,[[["str"],["str"]],["e"]]],[11,"from_ok","","",498,[[["t"]],["t"]]],[11,"map_same","","",498,[[["self"],["f"]],["t"]]],[11,"from","","",498,[[["t"]],["t"]]],[11,"into","","",498,[[["self"]],["u"]]],[11,"try_from","","",498,[[["u"]],["result"]]],[11,"borrow","","",498,[[["self"]],["t"]]],[11,"try_into","","",498,[[["self"]],["result"]]],[11,"borrow_mut","","",498,[[["self"]],["t"]]],[11,"get_type_id","","",498,[[["self"]],["typeid"]]],[11,"not_found","","",498,[[["str"],["str"]],["e"]]],[11,"enumerate_and_adjust","rustc::mir::traversal","",499,[[["self"],["usize"],["option",["usize"]]],["enumerateandadjust"]]],[11,"from_ok","","",499,[[["t"]],["t"]]],[11,"map_same","","",499,[[["self"],["f"]],["t"]]],[11,"to_owned","","",499,[[["self"]],["t"]]],[11,"clone_into","","",499,N],[11,"from","","",499,[[["t"]],["t"]]],[11,"into_iter","","",499,[[["self"]],["i"]]],[11,"into","","",499,[[["self"]],["u"]]],[11,"try_from","","",499,[[["u"]],["result"]]],[11,"borrow","","",499,[[["self"]],["t"]]],[11,"try_into","","",499,[[["self"]],["result"]]],[11,"borrow_mut","","",499,[[["self"]],["t"]]],[11,"get_type_id","","",499,[[["self"]],["typeid"]]],[11,"not_found","","",499,[[["str"],["str"]],["e"]]],[11,"enumerate_and_adjust","","",500,[[["self"],["usize"],["option",["usize"]]],["enumerateandadjust"]]],[11,"from_ok","","",500,[[["t"]],["t"]]],[11,"map_same","","",500,[[["self"],["f"]],["t"]]],[11,"from","","",500,[[["t"]],["t"]]],[11,"into_iter","","",500,[[["self"]],["i"]]],[11,"into","","",500,[[["self"]],["u"]]],[11,"try_from","","",500,[[["u"]],["result"]]],[11,"borrow","","",500,[[["self"]],["t"]]],[11,"try_into","","",500,[[["self"]],["result"]]],[11,"borrow_mut","","",500,[[["self"]],["t"]]],[11,"get_type_id","","",500,[[["self"]],["typeid"]]],[11,"not_found","","",500,[[["str"],["str"]],["e"]]],[11,"enumerate_and_adjust","","",501,[[["self"],["usize"],["option",["usize"]]],["enumerateandadjust"]]],[11,"from_ok","","",501,[[["t"]],["t"]]],[11,"map_same","","",501,[[["self"],["f"]],["t"]]],[11,"to_owned","","",501,[[["self"]],["t"]]],[11,"clone_into","","",501,N],[11,"from","","",501,[[["t"]],["t"]]],[11,"into_iter","","",501,[[["self"]],["i"]]],[11,"into","","",501,[[["self"]],["u"]]],[11,"try_from","","",501,[[["u"]],["result"]]],[11,"borrow","","",501,[[["self"]],["t"]]],[11,"try_into","","",501,[[["self"]],["result"]]],[11,"borrow_mut","","",501,[[["self"]],["t"]]],[11,"get_type_id","","",501,[[["self"]],["typeid"]]],[11,"not_found","","",501,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::mir::visit","",502,[[["t"]],["t"]]],[11,"map_same","","",502,[[["self"],["f"]],["t"]]],[11,"to_owned","","",502,[[["self"]],["t"]]],[11,"clone_into","","",502,N],[11,"from","","",502,[[["t"]],["t"]]],[11,"into","","",502,[[["self"]],["u"]]],[11,"try_from","","",502,[[["u"]],["result"]]],[11,"borrow","","",502,[[["self"]],["t"]]],[11,"try_into","","",502,[[["self"]],["result"]]],[11,"borrow_mut","","",502,[[["self"]],["t"]]],[11,"get_type_id","","",502,[[["self"]],["typeid"]]],[11,"not_found","","",502,[[["str"],["str"]],["e"]]],[11,"from_ok","","",503,[[["t"]],["t"]]],[11,"map_same","","",503,[[["self"],["f"]],["t"]]],[11,"to_owned","","",503,[[["self"]],["t"]]],[11,"clone_into","","",503,N],[11,"from","","",503,[[["t"]],["t"]]],[11,"into","","",503,[[["self"]],["u"]]],[11,"try_from","","",503,[[["u"]],["result"]]],[11,"borrow","","",503,[[["self"]],["t"]]],[11,"try_into","","",503,[[["self"]],["result"]]],[11,"borrow_mut","","",503,[[["self"]],["t"]]],[11,"get_type_id","","",503,[[["self"]],["typeid"]]],[11,"not_found","","",503,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::session","",508,[[["t"]],["t"]]],[11,"map_same","","",508,[[["self"],["f"]],["t"]]],[11,"to_owned","","",508,[[["self"]],["t"]]],[11,"clone_into","","",508,N],[11,"from","","",508,[[["t"]],["t"]]],[11,"into","","",508,[[["self"]],["u"]]],[11,"try_from","","",508,[[["u"]],["result"]]],[11,"borrow","","",508,[[["self"]],["t"]]],[11,"try_into","","",508,[[["self"]],["result"]]],[11,"borrow_mut","","",508,[[["self"]],["t"]]],[11,"get_type_id","","",508,[[["self"]],["typeid"]]],[11,"not_found","","",508,[[["str"],["str"]],["e"]]],[11,"from_ok","","",509,[[["t"]],["t"]]],[11,"map_same","","",509,[[["self"],["f"]],["t"]]],[11,"to_owned","","",509,[[["self"]],["t"]]],[11,"clone_into","","",509,N],[11,"from","","",509,[[["t"]],["t"]]],[11,"into","","",509,[[["self"]],["u"]]],[11,"try_from","","",509,[[["u"]],["result"]]],[11,"borrow","","",509,[[["self"]],["t"]]],[11,"try_into","","",509,[[["self"]],["result"]]],[11,"borrow_mut","","",509,[[["self"]],["t"]]],[11,"get_type_id","","",509,[[["self"]],["typeid"]]],[11,"not_found","","",509,[[["str"],["str"]],["e"]]],[11,"from_ok","","",510,[[["t"]],["t"]]],[11,"map_same","","",510,[[["self"],["f"]],["t"]]],[11,"from","","",510,[[["t"]],["t"]]],[11,"into","","",510,[[["self"]],["u"]]],[11,"try_from","","",510,[[["u"]],["result"]]],[11,"borrow","","",510,[[["self"]],["t"]]],[11,"try_into","","",510,[[["self"]],["result"]]],[11,"borrow_mut","","",510,[[["self"]],["t"]]],[11,"get_type_id","","",510,[[["self"]],["typeid"]]],[11,"not_found","","",510,[[["str"],["str"]],["e"]]],[11,"from_ok","","",511,[[["t"]],["t"]]],[11,"map_same","","",511,[[["self"],["f"]],["t"]]],[11,"from","","",511,[[["t"]],["t"]]],[11,"into","","",511,[[["self"]],["u"]]],[11,"try_from","","",511,[[["u"]],["result"]]],[11,"borrow","","",511,[[["self"]],["t"]]],[11,"try_into","","",511,[[["self"]],["result"]]],[11,"borrow_mut","","",511,[[["self"]],["t"]]],[11,"get_type_id","","",511,[[["self"]],["typeid"]]],[11,"not_found","","",511,[[["str"],["str"]],["e"]]],[11,"from_ok","","",512,[[["t"]],["t"]]],[11,"map_same","","",512,[[["self"],["f"]],["t"]]],[11,"to_owned","","",512,[[["self"]],["t"]]],[11,"clone_into","","",512,N],[11,"from","","",512,[[["t"]],["t"]]],[11,"to_string","","",512,[[["self"]],["string"]]],[11,"into","","",512,[[["self"]],["u"]]],[11,"try_from","","",512,[[["u"]],["result"]]],[11,"borrow","","",512,[[["self"]],["t"]]],[11,"try_into","","",512,[[["self"]],["result"]]],[11,"borrow_mut","","",512,[[["self"]],["t"]]],[11,"get_type_id","","",512,[[["self"]],["typeid"]]],[11,"encode","","",512,[[["self"],["e"]],["result"]]],[11,"decode","","",512,[[["d"]],["result"]]],[11,"not_found","","",512,[[["str"],["str"]],["e"]]],[11,"from_ok","","",513,[[["t"]],["t"]]],[11,"map_same","","",513,[[["self"],["f"]],["t"]]],[11,"to_owned","","",513,[[["self"]],["t"]]],[11,"clone_into","","",513,N],[11,"from","","",513,[[["t"]],["t"]]],[11,"into","","",513,[[["self"]],["u"]]],[11,"try_from","","",513,[[["u"]],["result"]]],[11,"borrow","","",513,[[["self"]],["t"]]],[11,"try_into","","",513,[[["self"]],["result"]]],[11,"borrow_mut","","",513,[[["self"]],["t"]]],[11,"get_type_id","","",513,[[["self"]],["typeid"]]],[11,"not_found","","",513,[[["str"],["str"]],["e"]]],[11,"from_ok","","",514,[[["t"]],["t"]]],[11,"map_same","","",514,[[["self"],["f"]],["t"]]],[11,"to_owned","","",514,[[["self"]],["t"]]],[11,"clone_into","","",514,N],[11,"from","","",514,[[["t"]],["t"]]],[11,"into","","",514,[[["self"]],["u"]]],[11,"try_from","","",514,[[["u"]],["result"]]],[11,"borrow","","",514,[[["self"]],["t"]]],[11,"try_into","","",514,[[["self"]],["result"]]],[11,"borrow_mut","","",514,[[["self"]],["t"]]],[11,"get_type_id","","",514,[[["self"]],["typeid"]]],[11,"not_found","","",514,[[["str"],["str"]],["e"]]],[11,"from_ok","","",515,[[["t"]],["t"]]],[11,"map_same","","",515,[[["self"],["f"]],["t"]]],[11,"from","","",515,[[["t"]],["t"]]],[11,"into","","",515,[[["self"]],["u"]]],[11,"try_from","","",515,[[["u"]],["result"]]],[11,"borrow","","",515,[[["self"]],["t"]]],[11,"try_into","","",515,[[["self"]],["result"]]],[11,"borrow_mut","","",515,[[["self"]],["t"]]],[11,"get_type_id","","",515,[[["self"]],["typeid"]]],[11,"not_found","","",515,[[["str"],["str"]],["e"]]],[11,"from_ok","","",516,[[["t"]],["t"]]],[11,"map_same","","",516,[[["self"],["f"]],["t"]]],[11,"to_owned","","",516,[[["self"]],["t"]]],[11,"clone_into","","",516,N],[11,"from","","",516,[[["t"]],["t"]]],[11,"into","","",516,[[["self"]],["u"]]],[11,"try_from","","",516,[[["u"]],["result"]]],[11,"borrow","","",516,[[["self"]],["t"]]],[11,"try_into","","",516,[[["self"]],["result"]]],[11,"borrow_mut","","",516,[[["self"]],["t"]]],[11,"get_type_id","","",516,[[["self"]],["typeid"]]],[11,"not_found","","",516,[[["str"],["str"]],["e"]]],[11,"from_ok","","",517,[[["t"]],["t"]]],[11,"map_same","","",517,[[["self"],["f"]],["t"]]],[11,"from","","",517,[[["t"]],["t"]]],[11,"into","","",517,[[["self"]],["u"]]],[11,"try_from","","",517,[[["u"]],["result"]]],[11,"borrow","","",517,[[["self"]],["t"]]],[11,"try_into","","",517,[[["self"]],["result"]]],[11,"borrow_mut","","",517,[[["self"]],["t"]]],[11,"get_type_id","","",517,[[["self"]],["typeid"]]],[11,"not_found","","",517,[[["str"],["str"]],["e"]]],[11,"from_ok","","",518,[[["t"]],["t"]]],[11,"map_same","","",518,[[["self"],["f"]],["t"]]],[11,"to_owned","","",518,[[["self"]],["t"]]],[11,"clone_into","","",518,N],[11,"from","","",518,[[["t"]],["t"]]],[11,"into","","",518,[[["self"]],["u"]]],[11,"try_from","","",518,[[["u"]],["result"]]],[11,"borrow","","",518,[[["self"]],["t"]]],[11,"try_into","","",518,[[["self"]],["result"]]],[11,"borrow_mut","","",518,[[["self"]],["t"]]],[11,"get_type_id","","",518,[[["self"]],["typeid"]]],[11,"not_found","","",518,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::session::code_stats","",519,[[["t"]],["t"]]],[11,"map_same","","",519,[[["self"],["f"]],["t"]]],[11,"from","","",519,[[["t"]],["t"]]],[11,"into","","",519,[[["self"]],["u"]]],[11,"try_from","","",519,[[["u"]],["result"]]],[11,"borrow","","",519,[[["self"]],["t"]]],[11,"try_into","","",519,[[["self"]],["result"]]],[11,"borrow_mut","","",519,[[["self"]],["t"]]],[11,"get_type_id","","",519,[[["self"]],["typeid"]]],[11,"not_found","","",519,[[["str"],["str"]],["e"]]],[11,"from_ok","","",520,[[["t"]],["t"]]],[11,"map_same","","",520,[[["self"],["f"]],["t"]]],[11,"from","","",520,[[["t"]],["t"]]],[11,"into","","",520,[[["self"]],["u"]]],[11,"try_from","","",520,[[["u"]],["result"]]],[11,"borrow","","",520,[[["self"]],["t"]]],[11,"try_into","","",520,[[["self"]],["result"]]],[11,"borrow_mut","","",520,[[["self"]],["t"]]],[11,"get_type_id","","",520,[[["self"]],["typeid"]]],[11,"not_found","","",520,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::session::config","",521,[[["t"]],["t"]]],[11,"map_same","","",521,[[["self"],["f"]],["t"]]],[11,"from","","",521,[[["t"]],["t"]]],[11,"into","","",521,[[["self"]],["u"]]],[11,"try_from","","",521,[[["u"]],["result"]]],[11,"borrow","","",521,[[["self"]],["t"]]],[11,"try_into","","",521,[[["self"]],["result"]]],[11,"borrow_mut","","",521,[[["self"]],["t"]]],[11,"get_type_id","","",521,[[["self"]],["typeid"]]],[11,"not_found","","",521,[[["str"],["str"]],["e"]]],[11,"from_ok","","",522,[[["t"]],["t"]]],[11,"map_same","","",522,[[["self"],["f"]],["t"]]],[11,"to_owned","","",522,[[["self"]],["t"]]],[11,"clone_into","","",522,N],[11,"from","","",522,[[["t"]],["t"]]],[11,"into","","",522,[[["self"]],["u"]]],[11,"try_from","","",522,[[["u"]],["result"]]],[11,"borrow","","",522,[[["self"]],["t"]]],[11,"try_into","","",522,[[["self"]],["result"]]],[11,"borrow_mut","","",522,[[["self"]],["t"]]],[11,"get_type_id","","",522,[[["self"]],["typeid"]]],[11,"not_found","","",522,[[["str"],["str"]],["e"]]],[11,"from_ok","","",523,[[["t"]],["t"]]],[11,"map_same","","",523,[[["self"],["f"]],["t"]]],[11,"to_owned","","",523,[[["self"]],["t"]]],[11,"clone_into","","",523,N],[11,"from","","",523,[[["t"]],["t"]]],[11,"into","","",523,[[["self"]],["u"]]],[11,"try_from","","",523,[[["u"]],["result"]]],[11,"borrow","","",523,[[["self"]],["t"]]],[11,"try_into","","",523,[[["self"]],["result"]]],[11,"borrow_mut","","",523,[[["self"]],["t"]]],[11,"get_type_id","","",523,[[["self"]],["typeid"]]],[11,"not_found","","",523,[[["str"],["str"]],["e"]]],[11,"from_ok","","",524,[[["t"]],["t"]]],[11,"map_same","","",524,[[["self"],["f"]],["t"]]],[11,"to_owned","","",524,[[["self"]],["t"]]],[11,"clone_into","","",524,N],[11,"from","","",524,[[["t"]],["t"]]],[11,"into","","",524,[[["self"]],["u"]]],[11,"try_from","","",524,[[["u"]],["result"]]],[11,"borrow","","",524,[[["self"]],["t"]]],[11,"try_into","","",524,[[["self"]],["result"]]],[11,"borrow_mut","","",524,[[["self"]],["t"]]],[11,"get_type_id","","",524,[[["self"]],["typeid"]]],[11,"not_found","","",524,[[["str"],["str"]],["e"]]],[11,"from_ok","","",525,[[["t"]],["t"]]],[11,"map_same","","",525,[[["self"],["f"]],["t"]]],[11,"to_owned","","",525,[[["self"]],["t"]]],[11,"clone_into","","",525,N],[11,"from","","",525,[[["t"]],["t"]]],[11,"into","","",525,[[["self"]],["u"]]],[11,"try_from","","",525,[[["u"]],["result"]]],[11,"borrow","","",525,[[["self"]],["t"]]],[11,"try_into","","",525,[[["self"]],["result"]]],[11,"borrow_mut","","",525,[[["self"]],["t"]]],[11,"get_type_id","","",525,[[["self"]],["typeid"]]],[11,"not_found","","",525,[[["str"],["str"]],["e"]]],[11,"from_ok","","",526,[[["t"]],["t"]]],[11,"map_same","","",526,[[["self"],["f"]],["t"]]],[11,"to_owned","","",526,[[["self"]],["t"]]],[11,"clone_into","","",526,N],[11,"from","","",526,[[["t"]],["t"]]],[11,"into","","",526,[[["self"]],["u"]]],[11,"try_from","","",526,[[["u"]],["result"]]],[11,"borrow","","",526,[[["self"]],["t"]]],[11,"try_into","","",526,[[["self"]],["result"]]],[11,"borrow_mut","","",526,[[["self"]],["t"]]],[11,"get_type_id","","",526,[[["self"]],["typeid"]]],[11,"not_found","","",526,[[["str"],["str"]],["e"]]],[11,"from_ok","","",527,[[["t"]],["t"]]],[11,"map_same","","",527,[[["self"],["f"]],["t"]]],[11,"to_owned","","",527,[[["self"]],["t"]]],[11,"clone_into","","",527,N],[11,"from","","",527,[[["t"]],["t"]]],[11,"into","","",527,[[["self"]],["u"]]],[11,"try_from","","",527,[[["u"]],["result"]]],[11,"borrow","","",527,[[["self"]],["t"]]],[11,"try_into","","",527,[[["self"]],["result"]]],[11,"borrow_mut","","",527,[[["self"]],["t"]]],[11,"get_type_id","","",527,[[["self"]],["typeid"]]],[11,"not_found","","",527,[[["str"],["str"]],["e"]]],[11,"from_ok","","",528,[[["t"]],["t"]]],[11,"map_same","","",528,[[["self"],["f"]],["t"]]],[11,"from","","",528,[[["t"]],["t"]]],[11,"into","","",528,[[["self"]],["u"]]],[11,"try_from","","",528,[[["u"]],["result"]]],[11,"borrow","","",528,[[["self"]],["t"]]],[11,"try_into","","",528,[[["self"]],["result"]]],[11,"borrow_mut","","",528,[[["self"]],["t"]]],[11,"get_type_id","","",528,[[["self"]],["typeid"]]],[11,"not_found","","",528,[[["str"],["str"]],["e"]]],[11,"from_ok","","",529,[[["t"]],["t"]]],[11,"map_same","","",529,[[["self"],["f"]],["t"]]],[11,"to_owned","","",529,[[["self"]],["t"]]],[11,"clone_into","","",529,N],[11,"from","","",529,[[["t"]],["t"]]],[11,"into","","",529,[[["self"]],["u"]]],[11,"try_from","","",529,[[["u"]],["result"]]],[11,"borrow","","",529,[[["self"]],["t"]]],[11,"try_into","","",529,[[["self"]],["result"]]],[11,"borrow_mut","","",529,[[["self"]],["t"]]],[11,"get_type_id","","",529,[[["self"]],["typeid"]]],[11,"not_found","","",529,[[["str"],["str"]],["e"]]],[11,"from_ok","","",530,[[["t"]],["t"]]],[11,"map_same","","",530,[[["self"],["f"]],["t"]]],[11,"to_owned","","",530,[[["self"]],["t"]]],[11,"clone_into","","",530,N],[11,"from","","",530,[[["t"]],["t"]]],[11,"into","","",530,[[["self"]],["u"]]],[11,"try_from","","",530,[[["u"]],["result"]]],[11,"borrow","","",530,[[["self"]],["t"]]],[11,"try_into","","",530,[[["self"]],["result"]]],[11,"borrow_mut","","",530,[[["self"]],["t"]]],[11,"get_type_id","","",530,[[["self"]],["typeid"]]],[11,"not_found","","",530,[[["str"],["str"]],["e"]]],[11,"from_ok","","",531,[[["t"]],["t"]]],[11,"map_same","","",531,[[["self"],["f"]],["t"]]],[11,"to_owned","","",531,[[["self"]],["t"]]],[11,"clone_into","","",531,N],[11,"from","","",531,[[["t"]],["t"]]],[11,"into","","",531,[[["self"]],["u"]]],[11,"try_from","","",531,[[["u"]],["result"]]],[11,"borrow","","",531,[[["self"]],["t"]]],[11,"try_into","","",531,[[["self"]],["result"]]],[11,"borrow_mut","","",531,[[["self"]],["t"]]],[11,"get_type_id","","",531,[[["self"]],["typeid"]]],[11,"not_found","","",531,[[["str"],["str"]],["e"]]],[11,"from_ok","","",532,[[["t"]],["t"]]],[11,"map_same","","",532,[[["self"],["f"]],["t"]]],[11,"to_owned","","",532,[[["self"]],["t"]]],[11,"clone_into","","",532,N],[11,"from","","",532,[[["t"]],["t"]]],[11,"into","","",532,[[["self"]],["u"]]],[11,"try_from","","",532,[[["u"]],["result"]]],[11,"borrow","","",532,[[["self"]],["t"]]],[11,"try_into","","",532,[[["self"]],["result"]]],[11,"borrow_mut","","",532,[[["self"]],["t"]]],[11,"get_type_id","","",532,[[["self"]],["typeid"]]],[11,"not_found","","",532,[[["str"],["str"]],["e"]]],[11,"from_ok","","",533,[[["t"]],["t"]]],[11,"map_same","","",533,[[["self"],["f"]],["t"]]],[11,"to_owned","","",533,[[["self"]],["t"]]],[11,"clone_into","","",533,N],[11,"from","","",533,[[["t"]],["t"]]],[11,"into","","",533,[[["self"]],["u"]]],[11,"try_from","","",533,[[["u"]],["result"]]],[11,"borrow","","",533,[[["self"]],["t"]]],[11,"try_into","","",533,[[["self"]],["result"]]],[11,"borrow_mut","","",533,[[["self"]],["t"]]],[11,"get_type_id","","",533,[[["self"]],["typeid"]]],[11,"not_found","","",533,[[["str"],["str"]],["e"]]],[11,"from_ok","","",534,[[["t"]],["t"]]],[11,"map_same","","",534,[[["self"],["f"]],["t"]]],[11,"to_owned","","",534,[[["self"]],["t"]]],[11,"clone_into","","",534,N],[11,"from","","",534,[[["t"]],["t"]]],[11,"into","","",534,[[["self"]],["u"]]],[11,"try_from","","",534,[[["u"]],["result"]]],[11,"borrow","","",534,[[["self"]],["t"]]],[11,"try_into","","",534,[[["self"]],["result"]]],[11,"borrow_mut","","",534,[[["self"]],["t"]]],[11,"get_type_id","","",534,[[["self"]],["typeid"]]],[11,"not_found","","",534,[[["str"],["str"]],["e"]]],[11,"from_ok","","",535,[[["t"]],["t"]]],[11,"map_same","","",535,[[["self"],["f"]],["t"]]],[11,"to_owned","","",535,[[["self"]],["t"]]],[11,"clone_into","","",535,N],[11,"from","","",535,[[["t"]],["t"]]],[11,"into","","",535,[[["self"]],["u"]]],[11,"try_from","","",535,[[["u"]],["result"]]],[11,"borrow","","",535,[[["self"]],["t"]]],[11,"try_into","","",535,[[["self"]],["result"]]],[11,"borrow_mut","","",535,[[["self"]],["t"]]],[11,"get_type_id","","",535,[[["self"]],["typeid"]]],[11,"encode","","",535,[[["self"],["e"]],["result"]]],[11,"decode","","",535,[[["d"]],["result"]]],[11,"not_found","","",535,[[["str"],["str"]],["e"]]],[11,"from_ok","","",536,[[["t"]],["t"]]],[11,"map_same","","",536,[[["self"],["f"]],["t"]]],[11,"to_owned","","",536,[[["self"]],["t"]]],[11,"clone_into","","",536,N],[11,"from","","",536,[[["t"]],["t"]]],[11,"into","","",536,[[["self"]],["u"]]],[11,"try_from","","",536,[[["u"]],["result"]]],[11,"borrow","","",536,[[["self"]],["t"]]],[11,"try_into","","",536,[[["self"]],["result"]]],[11,"borrow_mut","","",536,[[["self"]],["t"]]],[11,"get_type_id","","",536,[[["self"]],["typeid"]]],[11,"not_found","","",536,[[["str"],["str"]],["e"]]],[11,"from_ok","","",537,[[["t"]],["t"]]],[11,"map_same","","",537,[[["self"],["f"]],["t"]]],[11,"to_owned","","",537,[[["self"]],["t"]]],[11,"clone_into","","",537,N],[11,"from","","",537,[[["t"]],["t"]]],[11,"into","","",537,[[["self"]],["u"]]],[11,"try_from","","",537,[[["u"]],["result"]]],[11,"borrow","","",537,[[["self"]],["t"]]],[11,"try_into","","",537,[[["self"]],["result"]]],[11,"borrow_mut","","",537,[[["self"]],["t"]]],[11,"get_type_id","","",537,[[["self"]],["typeid"]]],[11,"not_found","","",537,[[["str"],["str"]],["e"]]],[11,"from_ok","","",538,[[["t"]],["t"]]],[11,"map_same","","",538,[[["self"],["f"]],["t"]]],[11,"to_owned","","",538,[[["self"]],["t"]]],[11,"clone_into","","",538,N],[11,"from","","",538,[[["t"]],["t"]]],[11,"into","","",538,[[["self"]],["u"]]],[11,"try_from","","",538,[[["u"]],["result"]]],[11,"borrow","","",538,[[["self"]],["t"]]],[11,"try_into","","",538,[[["self"]],["result"]]],[11,"borrow_mut","","",538,[[["self"]],["t"]]],[11,"get_type_id","","",538,[[["self"]],["typeid"]]],[11,"not_found","","",538,[[["str"],["str"]],["e"]]],[11,"from_ok","","",539,[[["t"]],["t"]]],[11,"map_same","","",539,[[["self"],["f"]],["t"]]],[11,"from","","",539,[[["t"]],["t"]]],[11,"into","","",539,[[["self"]],["u"]]],[11,"try_from","","",539,[[["u"]],["result"]]],[11,"borrow","","",539,[[["self"]],["t"]]],[11,"try_into","","",539,[[["self"]],["result"]]],[11,"borrow_mut","","",539,[[["self"]],["t"]]],[11,"get_type_id","","",539,[[["self"]],["typeid"]]],[11,"not_found","","",539,[[["str"],["str"]],["e"]]],[11,"from_ok","","",540,[[["t"]],["t"]]],[11,"map_same","","",540,[[["self"],["f"]],["t"]]],[11,"to_owned","","",540,[[["self"]],["t"]]],[11,"clone_into","","",540,N],[11,"from","","",540,[[["t"]],["t"]]],[11,"into","","",540,[[["self"]],["u"]]],[11,"try_from","","",540,[[["u"]],["result"]]],[11,"borrow","","",540,[[["self"]],["t"]]],[11,"try_into","","",540,[[["self"]],["result"]]],[11,"borrow_mut","","",540,[[["self"]],["t"]]],[11,"get_type_id","","",540,[[["self"]],["typeid"]]],[11,"not_found","","",540,[[["str"],["str"]],["e"]]],[11,"from_ok","","",541,[[["t"]],["t"]]],[11,"map_same","","",541,[[["self"],["f"]],["t"]]],[11,"to_owned","","",541,[[["self"]],["t"]]],[11,"clone_into","","",541,N],[11,"from","","",541,[[["t"]],["t"]]],[11,"to_string","","",541,[[["self"]],["string"]]],[11,"into","","",541,[[["self"]],["u"]]],[11,"try_from","","",541,[[["u"]],["result"]]],[11,"borrow","","",541,[[["self"]],["t"]]],[11,"try_into","","",541,[[["self"]],["result"]]],[11,"borrow_mut","","",541,[[["self"]],["t"]]],[11,"get_type_id","","",541,[[["self"]],["typeid"]]],[11,"not_found","","",541,[[["str"],["str"]],["e"]]],[11,"from_ok","","",542,[[["t"]],["t"]]],[11,"map_same","","",542,[[["self"],["f"]],["t"]]],[11,"to_owned","","",542,[[["self"]],["t"]]],[11,"clone_into","","",542,N],[11,"from","","",542,[[["t"]],["t"]]],[11,"into","","",542,[[["self"]],["u"]]],[11,"try_from","","",542,[[["u"]],["result"]]],[11,"borrow","","",542,[[["self"]],["t"]]],[11,"try_into","","",542,[[["self"]],["result"]]],[11,"borrow_mut","","",542,[[["self"]],["t"]]],[11,"get_type_id","","",542,[[["self"]],["typeid"]]],[11,"not_found","","",542,[[["str"],["str"]],["e"]]],[11,"from_ok","","",543,[[["t"]],["t"]]],[11,"map_same","","",543,[[["self"],["f"]],["t"]]],[11,"to_owned","","",543,[[["self"]],["t"]]],[11,"clone_into","","",543,N],[11,"from","","",543,[[["t"]],["t"]]],[11,"into","","",543,[[["self"]],["u"]]],[11,"try_from","","",543,[[["u"]],["result"]]],[11,"borrow","","",543,[[["self"]],["t"]]],[11,"try_into","","",543,[[["self"]],["result"]]],[11,"borrow_mut","","",543,[[["self"]],["t"]]],[11,"get_type_id","","",543,[[["self"]],["typeid"]]],[11,"not_found","","",543,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::session::filesearch","",545,[[["t"]],["t"]]],[11,"map_same","","",545,[[["self"],["f"]],["t"]]],[11,"from","","",545,[[["t"]],["t"]]],[11,"into","","",545,[[["self"]],["u"]]],[11,"try_from","","",545,[[["u"]],["result"]]],[11,"borrow","","",545,[[["self"]],["t"]]],[11,"try_into","","",545,[[["self"]],["result"]]],[11,"borrow_mut","","",545,[[["self"]],["t"]]],[11,"get_type_id","","",545,[[["self"]],["typeid"]]],[11,"not_found","","",545,[[["str"],["str"]],["e"]]],[11,"from_ok","","",546,[[["t"]],["t"]]],[11,"map_same","","",546,[[["self"],["f"]],["t"]]],[11,"to_owned","","",546,[[["self"]],["t"]]],[11,"clone_into","","",546,N],[11,"from","","",546,[[["t"]],["t"]]],[11,"into","","",546,[[["self"]],["u"]]],[11,"try_from","","",546,[[["u"]],["result"]]],[11,"borrow","","",546,[[["self"]],["t"]]],[11,"try_into","","",546,[[["self"]],["result"]]],[11,"borrow_mut","","",546,[[["self"]],["t"]]],[11,"get_type_id","","",546,[[["self"]],["typeid"]]],[11,"not_found","","",546,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::session::search_paths","",547,[[["t"]],["t"]]],[11,"map_same","","",547,[[["self"],["f"]],["t"]]],[11,"to_owned","","",547,[[["self"]],["t"]]],[11,"clone_into","","",547,N],[11,"from","","",547,[[["t"]],["t"]]],[11,"into","","",547,[[["self"]],["u"]]],[11,"try_from","","",547,[[["u"]],["result"]]],[11,"borrow","","",547,[[["self"]],["t"]]],[11,"try_into","","",547,[[["self"]],["result"]]],[11,"borrow_mut","","",547,[[["self"]],["t"]]],[11,"get_type_id","","",547,[[["self"]],["typeid"]]],[11,"not_found","","",547,[[["str"],["str"]],["e"]]],[11,"from_ok","","",548,[[["t"]],["t"]]],[11,"map_same","","",548,[[["self"],["f"]],["t"]]],[11,"from","","",548,[[["t"]],["t"]]],[11,"into_iter","","",548,[[["self"]],["i"]]],[11,"into","","",548,[[["self"]],["u"]]],[11,"try_from","","",548,[[["u"]],["result"]]],[11,"borrow","","",548,[[["self"]],["t"]]],[11,"try_into","","",548,[[["self"]],["result"]]],[11,"borrow_mut","","",548,[[["self"]],["t"]]],[11,"get_type_id","","",548,[[["self"]],["typeid"]]],[11,"not_found","","",548,[[["str"],["str"]],["e"]]],[11,"from_ok","","",549,[[["t"]],["t"]]],[11,"map_same","","",549,[[["self"],["f"]],["t"]]],[11,"to_owned","","",549,[[["self"]],["t"]]],[11,"clone_into","","",549,N],[11,"from","","",549,[[["t"]],["t"]]],[11,"into","","",549,[[["self"]],["u"]]],[11,"try_from","","",549,[[["u"]],["result"]]],[11,"borrow","","",549,[[["self"]],["t"]]],[11,"try_into","","",549,[[["self"]],["result"]]],[11,"borrow_mut","","",549,[[["self"]],["t"]]],[11,"get_type_id","","",549,[[["self"]],["typeid"]]],[11,"not_found","","",549,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits","",550,[[["t"]],["t"]]],[11,"map_same","","",550,[[["self"],["f"]],["t"]]],[11,"from","","",550,[[["t"]],["t"]]],[11,"into","","",550,[[["self"]],["u"]]],[11,"try_from","","",550,[[["u"]],["result"]]],[11,"borrow","","",550,[[["self"]],["t"]]],[11,"try_into","","",550,[[["self"]],["result"]]],[11,"borrow_mut","","",550,[[["self"]],["t"]]],[11,"get_type_id","","",550,[[["self"]],["typeid"]]],[11,"not_found","","",550,[[["str"],["str"]],["e"]]],[11,"from_ok","","",551,[[["t"]],["t"]]],[11,"map_same","","",551,[[["self"],["f"]],["t"]]],[11,"from","","",551,[[["t"]],["t"]]],[11,"into","","",551,[[["self"]],["u"]]],[11,"try_from","","",551,[[["u"]],["result"]]],[11,"borrow","","",551,[[["self"]],["t"]]],[11,"try_into","","",551,[[["self"]],["result"]]],[11,"borrow_mut","","",551,[[["self"]],["t"]]],[11,"get_type_id","","",551,[[["self"]],["typeid"]]],[11,"not_found","","",551,[[["str"],["str"]],["e"]]],[11,"from_ok","","",552,[[["t"]],["t"]]],[11,"map_same","","",552,[[["self"],["f"]],["t"]]],[11,"to_owned","","",552,[[["self"]],["t"]]],[11,"clone_into","","",552,N],[11,"from","","",552,[[["t"]],["t"]]],[11,"into","","",552,[[["self"]],["u"]]],[11,"try_from","","",552,[[["u"]],["result"]]],[11,"borrow","","",552,[[["self"]],["t"]]],[11,"try_into","","",552,[[["self"]],["result"]]],[11,"borrow_mut","","",552,[[["self"]],["t"]]],[11,"get_type_id","","",552,[[["self"]],["typeid"]]],[11,"not_found","","",552,[[["str"],["str"]],["e"]]],[11,"from_ok","","",553,[[["t"]],["t"]]],[11,"map_same","","",553,[[["self"],["f"]],["t"]]],[11,"to_owned","","",553,[[["self"]],["t"]]],[11,"clone_into","","",553,N],[11,"from","","",553,[[["t"]],["t"]]],[11,"into","","",553,[[["self"]],["u"]]],[11,"try_from","","",553,[[["u"]],["result"]]],[11,"borrow","","",553,[[["self"]],["t"]]],[11,"try_into","","",553,[[["self"]],["result"]]],[11,"borrow_mut","","",553,[[["self"]],["t"]]],[11,"get_type_id","","",553,[[["self"]],["typeid"]]],[11,"not_found","","",553,[[["str"],["str"]],["e"]]],[11,"from_ok","","",554,[[["t"]],["t"]]],[11,"map_same","","",554,[[["self"],["f"]],["t"]]],[11,"from","","",554,[[["t"]],["t"]]],[11,"into","","",554,[[["self"]],["u"]]],[11,"try_from","","",554,[[["u"]],["result"]]],[11,"borrow","","",554,[[["self"]],["t"]]],[11,"try_into","","",554,[[["self"]],["result"]]],[11,"borrow_mut","","",554,[[["self"]],["t"]]],[11,"get_type_id","","",554,[[["self"]],["typeid"]]],[11,"not_found","","",554,[[["str"],["str"]],["e"]]],[11,"from_ok","","",555,[[["t"]],["t"]]],[11,"map_same","","",555,[[["self"],["f"]],["t"]]],[11,"from","","",555,[[["t"]],["t"]]],[11,"into","","",555,[[["self"]],["u"]]],[11,"try_from","","",555,[[["u"]],["result"]]],[11,"borrow","","",555,[[["self"]],["t"]]],[11,"try_into","","",555,[[["self"]],["result"]]],[11,"borrow_mut","","",555,[[["self"]],["t"]]],[11,"get_type_id","","",555,[[["self"]],["typeid"]]],[11,"not_found","","",555,[[["str"],["str"]],["e"]]],[11,"from_ok","","",556,[[["t"]],["t"]]],[11,"map_same","","",556,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",556,N],[11,"to_owned","","",556,[[["self"]],["t"]]],[11,"clone_into","","",556,N],[11,"from","","",556,[[["t"]],["t"]]],[11,"into","","",556,[[["self"]],["u"]]],[11,"try_from","","",556,[[["u"]],["result"]]],[11,"borrow","","",556,[[["self"]],["t"]]],[11,"try_into","","",556,[[["self"]],["result"]]],[11,"borrow_mut","","",556,[[["self"]],["t"]]],[11,"get_type_id","","",556,[[["self"]],["typeid"]]],[11,"not_found","","",556,[[["str"],["str"]],["e"]]],[11,"from_ok","","",557,[[["t"]],["t"]]],[11,"map_same","","",557,[[["self"],["f"]],["t"]]],[11,"from","","",557,[[["t"]],["t"]]],[11,"into","","",557,[[["self"]],["u"]]],[11,"try_from","","",557,[[["u"]],["result"]]],[11,"borrow","","",557,[[["self"]],["t"]]],[11,"try_into","","",557,[[["self"]],["result"]]],[11,"borrow_mut","","",557,[[["self"]],["t"]]],[11,"get_type_id","","",557,[[["self"]],["typeid"]]],[11,"not_found","","",557,[[["str"],["str"]],["e"]]],[11,"from_ok","","",558,[[["t"]],["t"]]],[11,"map_same","","",558,[[["self"],["f"]],["t"]]],[11,"from","","",558,[[["t"]],["t"]]],[11,"into","","",558,[[["self"]],["u"]]],[11,"try_from","","",558,[[["u"]],["result"]]],[11,"borrow","","",558,[[["self"]],["t"]]],[11,"try_into","","",558,[[["self"]],["result"]]],[11,"borrow_mut","","",558,[[["self"]],["t"]]],[11,"get_type_id","","",558,[[["self"]],["typeid"]]],[11,"not_found","","",558,[[["str"],["str"]],["e"]]],[11,"from_ok","","",559,[[["t"]],["t"]]],[11,"map_same","","",559,[[["self"],["f"]],["t"]]],[11,"to_owned","","",559,[[["self"]],["t"]]],[11,"clone_into","","",559,N],[11,"from","","",559,[[["t"]],["t"]]],[11,"into","","",559,[[["self"]],["u"]]],[11,"try_from","","",559,[[["u"]],["result"]]],[11,"borrow","","",559,[[["self"]],["t"]]],[11,"try_into","","",559,[[["self"]],["result"]]],[11,"borrow_mut","","",559,[[["self"]],["t"]]],[11,"get_type_id","","",559,[[["self"]],["typeid"]]],[11,"not_found","","",559,[[["str"],["str"]],["e"]]],[11,"from_ok","","",560,[[["t"]],["t"]]],[11,"map_same","","",560,[[["self"],["f"]],["t"]]],[11,"from","","",560,[[["t"]],["t"]]],[11,"into","","",560,[[["self"]],["u"]]],[11,"try_from","","",560,[[["u"]],["result"]]],[11,"borrow","","",560,[[["self"]],["t"]]],[11,"try_into","","",560,[[["self"]],["result"]]],[11,"borrow_mut","","",560,[[["self"]],["t"]]],[11,"get_type_id","","",560,[[["self"]],["typeid"]]],[11,"not_found","","",560,[[["str"],["str"]],["e"]]],[11,"from_ok","","",561,[[["t"]],["t"]]],[11,"map_same","","",561,[[["self"],["f"]],["t"]]],[11,"to_owned","","",561,[[["self"]],["t"]]],[11,"clone_into","","",561,N],[11,"from","","",561,[[["t"]],["t"]]],[11,"into","","",561,[[["self"]],["u"]]],[11,"try_from","","",561,[[["u"]],["result"]]],[11,"borrow","","",561,[[["self"]],["t"]]],[11,"try_into","","",561,[[["self"]],["result"]]],[11,"borrow_mut","","",561,[[["self"]],["t"]]],[11,"get_type_id","","",561,[[["self"]],["typeid"]]],[11,"not_found","","",561,[[["str"],["str"]],["e"]]],[11,"from_ok","","",628,[[["t"]],["t"]]],[11,"map_same","","",628,[[["self"],["f"]],["t"]]],[11,"to_owned","","",628,[[["self"]],["t"]]],[11,"clone_into","","",628,N],[11,"from","","",628,[[["t"]],["t"]]],[11,"into","","",628,[[["self"]],["u"]]],[11,"try_from","","",628,[[["u"]],["result"]]],[11,"borrow","","",628,[[["self"]],["t"]]],[11,"try_into","","",628,[[["self"]],["result"]]],[11,"borrow_mut","","",628,[[["self"]],["t"]]],[11,"get_type_id","","",628,[[["self"]],["typeid"]]],[11,"not_found","","",628,[[["str"],["str"]],["e"]]],[11,"from_ok","","",562,[[["t"]],["t"]]],[11,"map_same","","",562,[[["self"],["f"]],["t"]]],[11,"from","","",562,[[["t"]],["t"]]],[11,"into","","",562,[[["self"]],["u"]]],[11,"try_from","","",562,[[["u"]],["result"]]],[11,"borrow","","",562,[[["self"]],["t"]]],[11,"try_into","","",562,[[["self"]],["result"]]],[11,"borrow_mut","","",562,[[["self"]],["t"]]],[11,"get_type_id","","",562,[[["self"]],["typeid"]]],[11,"not_found","","",562,[[["str"],["str"]],["e"]]],[11,"from_ok","","",563,[[["t"]],["t"]]],[11,"map_same","","",563,[[["self"],["f"]],["t"]]],[11,"from","","",563,[[["t"]],["t"]]],[11,"into","","",563,[[["self"]],["u"]]],[11,"try_from","","",563,[[["u"]],["result"]]],[11,"borrow","","",563,[[["self"]],["t"]]],[11,"try_into","","",563,[[["self"]],["result"]]],[11,"borrow_mut","","",563,[[["self"]],["t"]]],[11,"get_type_id","","",563,[[["self"]],["typeid"]]],[11,"not_found","","",563,[[["str"],["str"]],["e"]]],[11,"from_ok","","",564,[[["t"]],["t"]]],[11,"map_same","","",564,[[["self"],["f"]],["t"]]],[11,"from","","",564,[[["t"]],["t"]]],[11,"into_iter","","",564,[[["self"]],["i"]]],[11,"into","","",564,[[["self"]],["u"]]],[11,"try_from","","",564,[[["u"]],["result"]]],[11,"borrow","","",564,[[["self"]],["t"]]],[11,"try_into","","",564,[[["self"]],["result"]]],[11,"borrow_mut","","",564,[[["self"]],["t"]]],[11,"get_type_id","","",564,[[["self"]],["typeid"]]],[11,"not_found","","",564,[[["str"],["str"]],["e"]]],[11,"from_ok","","",565,[[["t"]],["t"]]],[11,"map_same","","",565,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",565,N],[11,"to_owned","","",565,[[["self"]],["t"]]],[11,"clone_into","","",565,N],[11,"from","","",565,[[["t"]],["t"]]],[11,"into","","",565,[[["self"]],["u"]]],[11,"try_from","","",565,[[["u"]],["result"]]],[11,"borrow","","",565,[[["self"]],["t"]]],[11,"try_into","","",565,[[["self"]],["result"]]],[11,"borrow_mut","","",565,[[["self"]],["t"]]],[11,"get_type_id","","",565,[[["self"]],["typeid"]]],[11,"not_found","","",565,[[["str"],["str"]],["e"]]],[11,"from_ok","","",566,[[["t"]],["t"]]],[11,"map_same","","",566,[[["self"],["f"]],["t"]]],[11,"to_owned","","",566,[[["self"]],["t"]]],[11,"clone_into","","",566,N],[11,"from","","",566,[[["t"]],["t"]]],[11,"into","","",566,[[["self"]],["u"]]],[11,"try_from","","",566,[[["u"]],["result"]]],[11,"borrow","","",566,[[["self"]],["t"]]],[11,"try_into","","",566,[[["self"]],["result"]]],[11,"borrow_mut","","",566,[[["self"]],["t"]]],[11,"get_type_id","","",566,[[["self"]],["typeid"]]],[11,"not_found","","",566,[[["str"],["str"]],["e"]]],[11,"from_ok","","",567,[[["t"]],["t"]]],[11,"map_same","","",567,[[["self"],["f"]],["t"]]],[11,"to_owned","","",567,[[["self"]],["t"]]],[11,"clone_into","","",567,N],[11,"from","","",567,[[["t"]],["t"]]],[11,"into","","",567,[[["self"]],["u"]]],[11,"try_from","","",567,[[["u"]],["result"]]],[11,"borrow","","",567,[[["self"]],["t"]]],[11,"try_into","","",567,[[["self"]],["result"]]],[11,"borrow_mut","","",567,[[["self"]],["t"]]],[11,"get_type_id","","",567,[[["self"]],["typeid"]]],[11,"not_found","","",567,[[["str"],["str"]],["e"]]],[11,"from_ok","","",568,[[["t"]],["t"]]],[11,"map_same","","",568,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",568,N],[11,"to_owned","","",568,[[["self"]],["t"]]],[11,"clone_into","","",568,N],[11,"from","","",568,[[["t"]],["t"]]],[11,"to_string","","",568,[[["self"]],["string"]]],[11,"into","","",568,[[["self"]],["u"]]],[11,"try_from","","",568,[[["u"]],["result"]]],[11,"borrow","","",568,[[["self"]],["t"]]],[11,"try_into","","",568,[[["self"]],["result"]]],[11,"borrow_mut","","",568,[[["self"]],["t"]]],[11,"get_type_id","","",568,[[["self"]],["typeid"]]],[11,"not_found","","",568,[[["str"],["str"]],["e"]]],[11,"from_ok","","",569,[[["t"]],["t"]]],[11,"map_same","","",569,[[["self"],["f"]],["t"]]],[11,"from","","",569,[[["t"]],["t"]]],[11,"into","","",569,[[["self"]],["u"]]],[11,"try_from","","",569,[[["u"]],["result"]]],[11,"borrow","","",569,[[["self"]],["t"]]],[11,"try_into","","",569,[[["self"]],["result"]]],[11,"borrow_mut","","",569,[[["self"]],["t"]]],[11,"get_type_id","","",569,[[["self"]],["typeid"]]],[11,"not_found","","",569,[[["str"],["str"]],["e"]]],[11,"from_ok","","",570,[[["t"]],["t"]]],[11,"map_same","","",570,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",570,N],[11,"to_owned","","",570,[[["self"]],["t"]]],[11,"clone_into","","",570,N],[11,"from","","",570,[[["t"]],["t"]]],[11,"into","","",570,[[["self"]],["u"]]],[11,"try_from","","",570,[[["u"]],["result"]]],[11,"borrow","","",570,[[["self"]],["t"]]],[11,"try_into","","",570,[[["self"]],["result"]]],[11,"borrow_mut","","",570,[[["self"]],["t"]]],[11,"get_type_id","","",570,[[["self"]],["typeid"]]],[11,"encode","","",570,[[["self"],["e"]],["result"]]],[11,"decode","","",570,[[["d"]],["result"]]],[11,"not_found","","",570,[[["str"],["str"]],["e"]]],[11,"from_ok","","",571,[[["t"]],["t"]]],[11,"map_same","","",571,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",571,N],[11,"to_owned","","",571,[[["self"]],["t"]]],[11,"clone_into","","",571,N],[11,"from","","",571,[[["t"]],["t"]]],[11,"into","","",571,[[["self"]],["u"]]],[11,"try_from","","",571,[[["u"]],["result"]]],[11,"borrow","","",571,[[["self"]],["t"]]],[11,"try_into","","",571,[[["self"]],["result"]]],[11,"borrow_mut","","",571,[[["self"]],["t"]]],[11,"get_type_id","","",571,[[["self"]],["typeid"]]],[11,"encode","","",571,[[["self"],["e"]],["result"]]],[11,"decode","","",571,[[["d"]],["result"]]],[11,"not_found","","",571,[[["str"],["str"]],["e"]]],[11,"from_ok","","",572,[[["t"]],["t"]]],[11,"map_same","","",572,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",572,N],[11,"to_owned","","",572,[[["self"]],["t"]]],[11,"clone_into","","",572,N],[11,"from","","",572,[[["t"]],["t"]]],[11,"into","","",572,[[["self"]],["u"]]],[11,"try_from","","",572,[[["u"]],["result"]]],[11,"borrow","","",572,[[["self"]],["t"]]],[11,"try_into","","",572,[[["self"]],["result"]]],[11,"borrow_mut","","",572,[[["self"]],["t"]]],[11,"get_type_id","","",572,[[["self"]],["typeid"]]],[11,"encode","","",572,[[["self"],["e"]],["result"]]],[11,"decode","","",572,[[["d"]],["result"]]],[11,"not_found","","",572,[[["str"],["str"]],["e"]]],[11,"from_ok","","",573,[[["t"]],["t"]]],[11,"map_same","","",573,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",573,N],[11,"to_owned","","",573,[[["self"]],["t"]]],[11,"clone_into","","",573,N],[11,"from","","",573,[[["t"]],["t"]]],[11,"into","","",573,[[["self"]],["u"]]],[11,"try_from","","",573,[[["u"]],["result"]]],[11,"borrow","","",573,[[["self"]],["t"]]],[11,"try_into","","",573,[[["self"]],["result"]]],[11,"borrow_mut","","",573,[[["self"]],["t"]]],[11,"get_type_id","","",573,[[["self"]],["typeid"]]],[11,"encode","","",573,[[["self"],["e"]],["result"]]],[11,"decode","","",573,[[["d"]],["result"]]],[11,"not_found","","",573,[[["str"],["str"]],["e"]]],[11,"from_ok","","",574,[[["t"]],["t"]]],[11,"map_same","","",574,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",574,N],[11,"to_owned","","",574,[[["self"]],["t"]]],[11,"clone_into","","",574,N],[11,"from","","",574,[[["t"]],["t"]]],[11,"into","","",574,[[["self"]],["u"]]],[11,"try_from","","",574,[[["u"]],["result"]]],[11,"borrow","","",574,[[["self"]],["t"]]],[11,"try_into","","",574,[[["self"]],["result"]]],[11,"borrow_mut","","",574,[[["self"]],["t"]]],[11,"get_type_id","","",574,[[["self"]],["typeid"]]],[11,"encode","","",574,[[["self"],["e"]],["result"]]],[11,"decode","","",574,[[["d"]],["result"]]],[11,"not_found","","",574,[[["str"],["str"]],["e"]]],[11,"from_ok","","",575,[[["t"]],["t"]]],[11,"map_same","","",575,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",575,N],[11,"to_owned","","",575,[[["self"]],["t"]]],[11,"clone_into","","",575,N],[11,"from","","",575,[[["t"]],["t"]]],[11,"into","","",575,[[["self"]],["u"]]],[11,"try_from","","",575,[[["u"]],["result"]]],[11,"borrow","","",575,[[["self"]],["t"]]],[11,"try_into","","",575,[[["self"]],["result"]]],[11,"borrow_mut","","",575,[[["self"]],["t"]]],[11,"get_type_id","","",575,[[["self"]],["typeid"]]],[11,"encode","","",575,[[["self"],["e"]],["result"]]],[11,"decode","","",575,[[["d"]],["result"]]],[11,"not_found","","",575,[[["str"],["str"]],["e"]]],[11,"from_ok","","",576,[[["t"]],["t"]]],[11,"map_same","","",576,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",576,N],[11,"to_owned","","",576,[[["self"]],["t"]]],[11,"clone_into","","",576,N],[11,"from","","",576,[[["t"]],["t"]]],[11,"into","","",576,[[["self"]],["u"]]],[11,"try_from","","",576,[[["u"]],["result"]]],[11,"borrow","","",576,[[["self"]],["t"]]],[11,"try_into","","",576,[[["self"]],["result"]]],[11,"borrow_mut","","",576,[[["self"]],["t"]]],[11,"get_type_id","","",576,[[["self"]],["typeid"]]],[11,"encode","","",576,[[["self"],["e"]],["result"]]],[11,"decode","","",576,[[["d"]],["result"]]],[11,"not_found","","",576,[[["str"],["str"]],["e"]]],[11,"from_ok","","",577,[[["t"]],["t"]]],[11,"map_same","","",577,[[["self"],["f"]],["t"]]],[11,"from","","",577,[[["t"]],["t"]]],[11,"into","","",577,[[["self"]],["u"]]],[11,"try_from","","",577,[[["u"]],["result"]]],[11,"borrow","","",577,[[["self"]],["t"]]],[11,"try_into","","",577,[[["self"]],["result"]]],[11,"borrow_mut","","",577,[[["self"]],["t"]]],[11,"get_type_id","","",577,[[["self"]],["typeid"]]],[11,"not_found","","",577,[[["str"],["str"]],["e"]]],[11,"from_ok","","",578,[[["t"]],["t"]]],[11,"map_same","","",578,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",578,N],[11,"to_owned","","",578,[[["self"]],["t"]]],[11,"clone_into","","",578,N],[11,"from","","",578,[[["t"]],["t"]]],[11,"into","","",578,[[["self"]],["u"]]],[11,"try_from","","",578,[[["u"]],["result"]]],[11,"borrow","","",578,[[["self"]],["t"]]],[11,"try_into","","",578,[[["self"]],["result"]]],[11,"borrow_mut","","",578,[[["self"]],["t"]]],[11,"get_type_id","","",578,[[["self"]],["typeid"]]],[11,"not_found","","",578,[[["str"],["str"]],["e"]]],[11,"from_ok","","",579,[[["t"]],["t"]]],[11,"map_same","","",579,[[["self"],["f"]],["t"]]],[11,"to_owned","","",579,[[["self"]],["t"]]],[11,"clone_into","","",579,N],[11,"from","","",579,[[["t"]],["t"]]],[11,"into","","",579,[[["self"]],["u"]]],[11,"try_from","","",579,[[["u"]],["result"]]],[11,"borrow","","",579,[[["self"]],["t"]]],[11,"try_into","","",579,[[["self"]],["result"]]],[11,"borrow_mut","","",579,[[["self"]],["t"]]],[11,"get_type_id","","",579,[[["self"]],["typeid"]]],[11,"not_found","","",579,[[["str"],["str"]],["e"]]],[11,"from_ok","","",580,[[["t"]],["t"]]],[11,"map_same","","",580,[[["self"],["f"]],["t"]]],[11,"to_owned","","",580,[[["self"]],["t"]]],[11,"clone_into","","",580,N],[11,"from","","",580,[[["t"]],["t"]]],[11,"into","","",580,[[["self"]],["u"]]],[11,"try_from","","",580,[[["u"]],["result"]]],[11,"borrow","","",580,[[["self"]],["t"]]],[11,"try_into","","",580,[[["self"]],["result"]]],[11,"borrow_mut","","",580,[[["self"]],["t"]]],[11,"get_type_id","","",580,[[["self"]],["typeid"]]],[11,"not_found","","",580,[[["str"],["str"]],["e"]]],[11,"from_ok","","",581,[[["t"]],["t"]]],[11,"map_same","","",581,[[["self"],["f"]],["t"]]],[11,"to_owned","","",581,[[["self"]],["t"]]],[11,"clone_into","","",581,N],[11,"from","","",581,[[["t"]],["t"]]],[11,"into","","",581,[[["self"]],["u"]]],[11,"try_from","","",581,[[["u"]],["result"]]],[11,"borrow","","",581,[[["self"]],["t"]]],[11,"try_into","","",581,[[["self"]],["result"]]],[11,"borrow_mut","","",581,[[["self"]],["t"]]],[11,"get_type_id","","",581,[[["self"]],["typeid"]]],[11,"not_found","","",581,[[["str"],["str"]],["e"]]],[11,"from_ok","","",582,[[["t"]],["t"]]],[11,"map_same","","",582,[[["self"],["f"]],["t"]]],[11,"to_owned","","",582,[[["self"]],["t"]]],[11,"clone_into","","",582,N],[11,"from","","",582,[[["t"]],["t"]]],[11,"into","","",582,[[["self"]],["u"]]],[11,"try_from","","",582,[[["u"]],["result"]]],[11,"borrow","","",582,[[["self"]],["t"]]],[11,"try_into","","",582,[[["self"]],["result"]]],[11,"borrow_mut","","",582,[[["self"]],["t"]]],[11,"get_type_id","","",582,[[["self"]],["typeid"]]],[11,"not_found","","",582,[[["str"],["str"]],["e"]]],[11,"from_ok","","",583,[[["t"]],["t"]]],[11,"map_same","","",583,[[["self"],["f"]],["t"]]],[11,"to_owned","","",583,[[["self"]],["t"]]],[11,"clone_into","","",583,N],[11,"from","","",583,[[["t"]],["t"]]],[11,"into","","",583,[[["self"]],["u"]]],[11,"try_from","","",583,[[["u"]],["result"]]],[11,"borrow","","",583,[[["self"]],["t"]]],[11,"try_into","","",583,[[["self"]],["result"]]],[11,"borrow_mut","","",583,[[["self"]],["t"]]],[11,"get_type_id","","",583,[[["self"]],["typeid"]]],[11,"not_found","","",583,[[["str"],["str"]],["e"]]],[11,"from_ok","","",584,[[["t"]],["t"]]],[11,"map_same","","",584,[[["self"],["f"]],["t"]]],[11,"to_owned","","",584,[[["self"]],["t"]]],[11,"clone_into","","",584,N],[11,"from","","",584,[[["t"]],["t"]]],[11,"into","","",584,[[["self"]],["u"]]],[11,"try_from","","",584,[[["u"]],["result"]]],[11,"borrow","","",584,[[["self"]],["t"]]],[11,"try_into","","",584,[[["self"]],["result"]]],[11,"borrow_mut","","",584,[[["self"]],["t"]]],[11,"get_type_id","","",584,[[["self"]],["typeid"]]],[11,"not_found","","",584,[[["str"],["str"]],["e"]]],[11,"from_ok","","",585,[[["t"]],["t"]]],[11,"map_same","","",585,[[["self"],["f"]],["t"]]],[11,"to_owned","","",585,[[["self"]],["t"]]],[11,"clone_into","","",585,N],[11,"from","","",585,[[["t"]],["t"]]],[11,"into","","",585,[[["self"]],["u"]]],[11,"try_from","","",585,[[["u"]],["result"]]],[11,"borrow","","",585,[[["self"]],["t"]]],[11,"try_into","","",585,[[["self"]],["result"]]],[11,"borrow_mut","","",585,[[["self"]],["t"]]],[11,"get_type_id","","",585,[[["self"]],["typeid"]]],[11,"not_found","","",585,[[["str"],["str"]],["e"]]],[11,"from_ok","","",586,[[["t"]],["t"]]],[11,"map_same","","",586,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",586,N],[11,"to_owned","","",586,[[["self"]],["t"]]],[11,"clone_into","","",586,N],[11,"from","","",586,[[["t"]],["t"]]],[11,"to_string","","",586,[[["self"]],["string"]]],[11,"into","","",586,[[["self"]],["u"]]],[11,"try_from","","",586,[[["u"]],["result"]]],[11,"borrow","","",586,[[["self"]],["t"]]],[11,"try_into","","",586,[[["self"]],["result"]]],[11,"borrow_mut","","",586,[[["self"]],["t"]]],[11,"get_type_id","","",586,[[["self"]],["typeid"]]],[11,"not_found","","",586,[[["str"],["str"]],["e"]]],[11,"from_ok","","",587,[[["t"]],["t"]]],[11,"map_same","","",587,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",587,N],[11,"to_owned","","",587,[[["self"]],["t"]]],[11,"clone_into","","",587,N],[11,"from","","",587,[[["t"]],["t"]]],[11,"to_string","","",587,[[["self"]],["string"]]],[11,"into","","",587,[[["self"]],["u"]]],[11,"try_from","","",587,[[["u"]],["result"]]],[11,"borrow","","",587,[[["self"]],["t"]]],[11,"try_into","","",587,[[["self"]],["result"]]],[11,"borrow_mut","","",587,[[["self"]],["t"]]],[11,"get_type_id","","",587,[[["self"]],["typeid"]]],[11,"not_found","","",587,[[["str"],["str"]],["e"]]],[11,"from_ok","","",588,[[["t"]],["t"]]],[11,"map_same","","",588,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",588,N],[11,"to_owned","","",588,[[["self"]],["t"]]],[11,"clone_into","","",588,N],[11,"from","","",588,[[["t"]],["t"]]],[11,"to_string","","",588,[[["self"]],["string"]]],[11,"into","","",588,[[["self"]],["u"]]],[11,"try_from","","",588,[[["u"]],["result"]]],[11,"borrow","","",588,[[["self"]],["t"]]],[11,"try_into","","",588,[[["self"]],["result"]]],[11,"borrow_mut","","",588,[[["self"]],["t"]]],[11,"get_type_id","","",588,[[["self"]],["typeid"]]],[11,"not_found","","",588,[[["str"],["str"]],["e"]]],[11,"from_ok","","",589,[[["t"]],["t"]]],[11,"map_same","","",589,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",589,N],[11,"to_owned","","",589,[[["self"]],["t"]]],[11,"clone_into","","",589,N],[11,"from","","",589,[[["t"]],["t"]]],[11,"to_string","","",589,[[["self"]],["string"]]],[11,"into","","",589,[[["self"]],["u"]]],[11,"try_from","","",589,[[["u"]],["result"]]],[11,"borrow","","",589,[[["self"]],["t"]]],[11,"try_into","","",589,[[["self"]],["result"]]],[11,"borrow_mut","","",589,[[["self"]],["t"]]],[11,"get_type_id","","",589,[[["self"]],["typeid"]]],[11,"not_found","","",589,[[["str"],["str"]],["e"]]],[11,"from_ok","","",590,[[["t"]],["t"]]],[11,"map_same","","",590,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",590,N],[11,"to_owned","","",590,[[["self"]],["t"]]],[11,"clone_into","","",590,N],[11,"from","","",590,[[["t"]],["t"]]],[11,"to_string","","",590,[[["self"]],["string"]]],[11,"into","","",590,[[["self"]],["u"]]],[11,"try_from","","",590,[[["u"]],["result"]]],[11,"borrow","","",590,[[["self"]],["t"]]],[11,"try_into","","",590,[[["self"]],["result"]]],[11,"borrow_mut","","",590,[[["self"]],["t"]]],[11,"get_type_id","","",590,[[["self"]],["typeid"]]],[11,"not_found","","",590,[[["str"],["str"]],["e"]]],[11,"from_ok","","",591,[[["t"]],["t"]]],[11,"map_same","","",591,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",591,N],[11,"to_owned","","",591,[[["self"]],["t"]]],[11,"clone_into","","",591,N],[11,"from","","",591,[[["t"]],["t"]]],[11,"to_string","","",591,[[["self"]],["string"]]],[11,"into","","",591,[[["self"]],["u"]]],[11,"try_from","","",591,[[["u"]],["result"]]],[11,"borrow","","",591,[[["self"]],["t"]]],[11,"try_into","","",591,[[["self"]],["result"]]],[11,"borrow_mut","","",591,[[["self"]],["t"]]],[11,"get_type_id","","",591,[[["self"]],["typeid"]]],[11,"not_found","","",591,[[["str"],["str"]],["e"]]],[11,"from_ok","","",592,[[["t"]],["t"]]],[11,"map_same","","",592,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",592,N],[11,"to_owned","","",592,[[["self"]],["t"]]],[11,"clone_into","","",592,N],[11,"from","","",592,[[["t"]],["t"]]],[11,"to_string","","",592,[[["self"]],["string"]]],[11,"into","","",592,[[["self"]],["u"]]],[11,"try_from","","",592,[[["u"]],["result"]]],[11,"borrow","","",592,[[["self"]],["t"]]],[11,"try_into","","",592,[[["self"]],["result"]]],[11,"borrow_mut","","",592,[[["self"]],["t"]]],[11,"get_type_id","","",592,[[["self"]],["typeid"]]],[11,"not_found","","",592,[[["str"],["str"]],["e"]]],[11,"from_ok","","",593,[[["t"]],["t"]]],[11,"map_same","","",593,[[["self"],["f"]],["t"]]],[11,"to_owned","","",593,[[["self"]],["t"]]],[11,"clone_into","","",593,N],[11,"from","","",593,[[["t"]],["t"]]],[11,"into","","",593,[[["self"]],["u"]]],[11,"try_from","","",593,[[["u"]],["result"]]],[11,"borrow","","",593,[[["self"]],["t"]]],[11,"try_into","","",593,[[["self"]],["result"]]],[11,"borrow_mut","","",593,[[["self"]],["t"]]],[11,"get_type_id","","",593,[[["self"]],["typeid"]]],[11,"not_found","","",593,[[["str"],["str"]],["e"]]],[11,"from_ok","","",594,[[["t"]],["t"]]],[11,"map_same","","",594,[[["self"],["f"]],["t"]]],[11,"to_owned","","",594,[[["self"]],["t"]]],[11,"clone_into","","",594,N],[11,"from","","",594,[[["t"]],["t"]]],[11,"into","","",594,[[["self"]],["u"]]],[11,"try_from","","",594,[[["u"]],["result"]]],[11,"borrow","","",594,[[["self"]],["t"]]],[11,"try_into","","",594,[[["self"]],["result"]]],[11,"borrow_mut","","",594,[[["self"]],["t"]]],[11,"get_type_id","","",594,[[["self"]],["typeid"]]],[11,"not_found","","",594,[[["str"],["str"]],["e"]]],[11,"from_ok","","",595,[[["t"]],["t"]]],[11,"map_same","","",595,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",595,N],[11,"to_owned","","",595,[[["self"]],["t"]]],[11,"clone_into","","",595,N],[11,"from","","",595,[[["t"]],["t"]]],[11,"into","","",595,[[["self"]],["u"]]],[11,"try_from","","",595,[[["u"]],["result"]]],[11,"borrow","","",595,[[["self"]],["t"]]],[11,"try_into","","",595,[[["self"]],["result"]]],[11,"borrow_mut","","",595,[[["self"]],["t"]]],[11,"get_type_id","","",595,[[["self"]],["typeid"]]],[11,"encode","","",595,[[["self"],["e"]],["result"]]],[11,"decode","","",595,[[["d"]],["result"]]],[11,"not_found","","",595,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::specialization_graph","",596,[[["t"]],["t"]]],[11,"map_same","","",596,[[["self"],["f"]],["t"]]],[11,"from","","",596,[[["t"]],["t"]]],[11,"into","","",596,[[["self"]],["u"]]],[11,"try_from","","",596,[[["u"]],["result"]]],[11,"borrow","","",596,[[["self"]],["t"]]],[11,"try_into","","",596,[[["self"]],["result"]]],[11,"borrow_mut","","",596,[[["self"]],["t"]]],[11,"get_type_id","","",596,[[["self"]],["typeid"]]],[11,"encode","","",596,[[["self"],["e"]],["result"]]],[11,"decode","","",596,[[["d"]],["result"]]],[11,"not_found","","",596,[[["str"],["str"]],["e"]]],[11,"from_ok","","",597,[[["t"]],["t"]]],[11,"map_same","","",597,[[["self"],["f"]],["t"]]],[11,"from","","",597,[[["t"]],["t"]]],[11,"into_iter","","",597,[[["self"]],["i"]]],[11,"into","","",597,[[["self"]],["u"]]],[11,"try_from","","",597,[[["u"]],["result"]]],[11,"borrow","","",597,[[["self"]],["t"]]],[11,"try_into","","",597,[[["self"]],["result"]]],[11,"borrow_mut","","",597,[[["self"]],["t"]]],[11,"get_type_id","","",597,[[["self"]],["typeid"]]],[11,"not_found","","",597,[[["str"],["str"]],["e"]]],[11,"from_ok","","",598,[[["t"]],["t"]]],[11,"map_same","","",598,[[["self"],["f"]],["t"]]],[11,"from","","",598,[[["t"]],["t"]]],[11,"into","","",598,[[["self"]],["u"]]],[11,"try_from","","",598,[[["u"]],["result"]]],[11,"borrow","","",598,[[["self"]],["t"]]],[11,"try_into","","",598,[[["self"]],["result"]]],[11,"borrow_mut","","",598,[[["self"]],["t"]]],[11,"get_type_id","","",598,[[["self"]],["typeid"]]],[11,"not_found","","",598,[[["str"],["str"]],["e"]]],[11,"from_ok","","",599,[[["t"]],["t"]]],[11,"map_same","","",599,[[["self"],["f"]],["t"]]],[11,"to_owned","","",599,[[["self"]],["t"]]],[11,"clone_into","","",599,N],[11,"from","","",599,[[["t"]],["t"]]],[11,"into","","",599,[[["self"]],["u"]]],[11,"try_from","","",599,[[["u"]],["result"]]],[11,"borrow","","",599,[[["self"]],["t"]]],[11,"try_into","","",599,[[["self"]],["result"]]],[11,"borrow_mut","","",599,[[["self"]],["t"]]],[11,"get_type_id","","",599,[[["self"]],["typeid"]]],[11,"not_found","","",599,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::auto_trait","",600,[[["t"]],["t"]]],[11,"map_same","","",600,[[["self"],["f"]],["t"]]],[11,"to_owned","","",600,[[["self"]],["t"]]],[11,"clone_into","","",600,N],[11,"from","","",600,[[["t"]],["t"]]],[11,"into","","",600,[[["self"]],["u"]]],[11,"try_from","","",600,[[["u"]],["result"]]],[11,"borrow","","",600,[[["self"]],["t"]]],[11,"try_into","","",600,[[["self"]],["result"]]],[11,"borrow_mut","","",600,[[["self"]],["t"]]],[11,"get_type_id","","",600,[[["self"]],["typeid"]]],[11,"not_found","","",600,[[["str"],["str"]],["e"]]],[11,"from_ok","","",601,[[["t"]],["t"]]],[11,"map_same","","",601,[[["self"],["f"]],["t"]]],[11,"from","","",601,[[["t"]],["t"]]],[11,"into","","",601,[[["self"]],["u"]]],[11,"try_from","","",601,[[["u"]],["result"]]],[11,"borrow","","",601,[[["self"]],["t"]]],[11,"try_into","","",601,[[["self"]],["result"]]],[11,"borrow_mut","","",601,[[["self"]],["t"]]],[11,"get_type_id","","",601,[[["self"]],["typeid"]]],[11,"not_found","","",601,[[["str"],["str"]],["e"]]],[11,"from_ok","","",602,[[["t"]],["t"]]],[11,"map_same","","",602,[[["self"],["f"]],["t"]]],[11,"from","","",602,[[["t"]],["t"]]],[11,"into","","",602,[[["self"]],["u"]]],[11,"try_from","","",602,[[["u"]],["result"]]],[11,"borrow","","",602,[[["self"]],["t"]]],[11,"try_into","","",602,[[["self"]],["result"]]],[11,"borrow_mut","","",602,[[["self"]],["t"]]],[11,"get_type_id","","",602,[[["self"]],["typeid"]]],[11,"not_found","","",602,[[["str"],["str"]],["e"]]],[11,"from_ok","","",603,[[["t"]],["t"]]],[11,"map_same","","",603,[[["self"],["f"]],["t"]]],[11,"from","","",603,[[["t"]],["t"]]],[11,"into","","",603,[[["self"]],["u"]]],[11,"try_from","","",603,[[["u"]],["result"]]],[11,"borrow","","",603,[[["self"]],["t"]]],[11,"try_into","","",603,[[["self"]],["result"]]],[11,"borrow_mut","","",603,[[["self"]],["t"]]],[11,"get_type_id","","",603,[[["self"]],["typeid"]]],[11,"not_found","","",603,[[["str"],["str"]],["e"]]],[11,"from_ok","","",604,[[["t"]],["t"]]],[11,"map_same","","",604,[[["self"],["f"]],["t"]]],[11,"to_owned","","",604,[[["self"]],["t"]]],[11,"clone_into","","",604,N],[11,"from","","",604,[[["t"]],["t"]]],[11,"into","","",604,[[["self"]],["u"]]],[11,"try_from","","",604,[[["u"]],["result"]]],[11,"borrow","","",604,[[["self"]],["t"]]],[11,"try_into","","",604,[[["self"]],["result"]]],[11,"borrow_mut","","",604,[[["self"]],["t"]]],[11,"get_type_id","","",604,[[["self"]],["typeid"]]],[11,"not_found","","",604,[[["str"],["str"]],["e"]]],[11,"from_ok","","",605,[[["t"]],["t"]]],[11,"map_same","","",605,[[["self"],["f"]],["t"]]],[11,"from","","",605,[[["t"]],["t"]]],[11,"into","","",605,[[["self"]],["u"]]],[11,"try_from","","",605,[[["u"]],["result"]]],[11,"borrow","","",605,[[["self"]],["t"]]],[11,"try_into","","",605,[[["self"]],["result"]]],[11,"borrow_mut","","",605,[[["self"]],["t"]]],[11,"get_type_id","","",605,[[["self"]],["typeid"]]],[11,"not_found","","",605,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::coherence","",606,[[["t"]],["t"]]],[11,"map_same","","",606,[[["self"],["f"]],["t"]]],[11,"to_owned","","",606,[[["self"]],["t"]]],[11,"clone_into","","",606,N],[11,"from","","",606,[[["t"]],["t"]]],[11,"into","","",606,[[["self"]],["u"]]],[11,"try_from","","",606,[[["u"]],["result"]]],[11,"borrow","","",606,[[["self"]],["t"]]],[11,"try_into","","",606,[[["self"]],["result"]]],[11,"borrow_mut","","",606,[[["self"]],["t"]]],[11,"get_type_id","","",606,[[["self"]],["typeid"]]],[11,"not_found","","",606,[[["str"],["str"]],["e"]]],[11,"from_ok","","",607,[[["t"]],["t"]]],[11,"map_same","","",607,[[["self"],["f"]],["t"]]],[11,"to_owned","","",607,[[["self"]],["t"]]],[11,"clone_into","","",607,N],[11,"from","","",607,[[["t"]],["t"]]],[11,"into","","",607,[[["self"]],["u"]]],[11,"try_from","","",607,[[["u"]],["result"]]],[11,"borrow","","",607,[[["self"]],["t"]]],[11,"try_into","","",607,[[["self"]],["result"]]],[11,"borrow_mut","","",607,[[["self"]],["t"]]],[11,"get_type_id","","",607,[[["self"]],["typeid"]]],[11,"not_found","","",607,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::error_reporting","",608,[[["t"]],["t"]]],[11,"map_same","","",608,[[["self"],["f"]],["t"]]],[11,"from","","",608,[[["t"]],["t"]]],[11,"into","","",608,[[["self"]],["u"]]],[11,"try_from","","",608,[[["u"]],["result"]]],[11,"borrow","","",608,[[["self"]],["t"]]],[11,"try_into","","",608,[[["self"]],["result"]]],[11,"borrow_mut","","",608,[[["self"]],["t"]]],[11,"get_type_id","","",608,[[["self"]],["typeid"]]],[11,"not_found","","",608,[[["str"],["str"]],["e"]]],[11,"recursive_type_with_infinite_size_error","rustc::ty","",677,[[["self"],["defid"]],["diagnosticbuilder"]]],[11,"report_object_safety_error","","",677,[[["self"],["span"],["defid"],["vec",["objectsafetyviolation"]]],["diagnosticbuilder"]]],[11,"from_ok","rustc::traits::fulfill","",611,[[["t"]],["t"]]],[11,"map_same","","",611,[[["self"],["f"]],["t"]]],[11,"from","","",611,[[["t"]],["t"]]],[11,"into","","",611,[[["self"]],["u"]]],[11,"try_from","","",611,[[["u"]],["result"]]],[11,"borrow","","",611,[[["self"]],["t"]]],[11,"try_into","","",611,[[["self"]],["result"]]],[11,"borrow_mut","","",611,[[["self"]],["t"]]],[11,"get_type_id","","",611,[[["self"]],["typeid"]]],[11,"not_found","","",611,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::project","",612,[[["t"]],["t"]]],[11,"map_same","","",612,[[["self"],["f"]],["t"]]],[11,"from","","",612,[[["t"]],["t"]]],[11,"into","","",612,[[["self"]],["u"]]],[11,"try_from","","",612,[[["u"]],["result"]]],[11,"borrow","","",612,[[["self"]],["t"]]],[11,"try_into","","",612,[[["self"]],["result"]]],[11,"borrow_mut","","",612,[[["self"]],["t"]]],[11,"get_type_id","","",612,[[["self"]],["typeid"]]],[11,"not_found","","",612,[[["str"],["str"]],["e"]]],[11,"from_ok","","",613,[[["t"]],["t"]]],[11,"map_same","","",613,[[["self"],["f"]],["t"]]],[11,"from","","",613,[[["t"]],["t"]]],[11,"into","","",613,[[["self"]],["u"]]],[11,"try_from","","",613,[[["u"]],["result"]]],[11,"borrow","","",613,[[["self"]],["t"]]],[11,"try_into","","",613,[[["self"]],["result"]]],[11,"borrow_mut","","",613,[[["self"]],["t"]]],[11,"get_type_id","","",613,[[["self"]],["typeid"]]],[11,"not_found","","",613,[[["str"],["str"]],["e"]]],[11,"from_ok","","",614,[[["t"]],["t"]]],[11,"map_same","","",614,[[["self"],["f"]],["t"]]],[11,"to_owned","","",614,[[["self"]],["t"]]],[11,"clone_into","","",614,N],[11,"from","","",614,[[["t"]],["t"]]],[11,"into","","",614,[[["self"]],["u"]]],[11,"try_from","","",614,[[["u"]],["result"]]],[11,"borrow","","",614,[[["self"]],["t"]]],[11,"try_into","","",614,[[["self"]],["result"]]],[11,"borrow_mut","","",614,[[["self"]],["t"]]],[11,"get_type_id","","",614,[[["self"]],["typeid"]]],[11,"not_found","","",614,[[["str"],["str"]],["e"]]],[11,"from_ok","","",615,[[["t"]],["t"]]],[11,"map_same","","",615,[[["self"],["f"]],["t"]]],[11,"from","","",615,[[["t"]],["t"]]],[11,"into","","",615,[[["self"]],["u"]]],[11,"try_from","","",615,[[["u"]],["result"]]],[11,"borrow","","",615,[[["self"]],["t"]]],[11,"try_into","","",615,[[["self"]],["result"]]],[11,"borrow_mut","","",615,[[["self"]],["t"]]],[11,"get_type_id","","",615,[[["self"]],["typeid"]]],[11,"not_found","","",615,[[["str"],["str"]],["e"]]],[11,"from_ok","","",616,[[["t"]],["t"]]],[11,"map_same","","",616,[[["self"],["f"]],["t"]]],[11,"from","","",616,[[["t"]],["t"]]],[11,"into","","",616,[[["self"]],["u"]]],[11,"try_from","","",616,[[["u"]],["result"]]],[11,"borrow","","",616,[[["self"]],["t"]]],[11,"try_into","","",616,[[["self"]],["result"]]],[11,"borrow_mut","","",616,[[["self"]],["t"]]],[11,"get_type_id","","",616,[[["self"]],["typeid"]]],[11,"not_found","","",616,[[["str"],["str"]],["e"]]],[11,"from_ok","","",617,[[["t"]],["t"]]],[11,"map_same","","",617,[[["self"],["f"]],["t"]]],[11,"from","","",617,[[["t"]],["t"]]],[11,"into","","",617,[[["self"]],["u"]]],[11,"try_from","","",617,[[["u"]],["result"]]],[11,"borrow","","",617,[[["self"]],["t"]]],[11,"try_into","","",617,[[["self"]],["result"]]],[11,"borrow_mut","","",617,[[["self"]],["t"]]],[11,"get_type_id","","",617,[[["self"]],["typeid"]]],[11,"not_found","","",617,[[["str"],["str"]],["e"]]],[11,"from_ok","","",618,[[["t"]],["t"]]],[11,"map_same","","",618,[[["self"],["f"]],["t"]]],[11,"from","","",618,[[["t"]],["t"]]],[11,"into","","",618,[[["self"]],["u"]]],[11,"try_from","","",618,[[["u"]],["result"]]],[11,"borrow","","",618,[[["self"]],["t"]]],[11,"try_into","","",618,[[["self"]],["result"]]],[11,"borrow_mut","","",618,[[["self"]],["t"]]],[11,"get_type_id","","",618,[[["self"]],["typeid"]]],[11,"not_found","","",618,[[["str"],["str"]],["e"]]],[11,"from_ok","","",619,[[["t"]],["t"]]],[11,"map_same","","",619,[[["self"],["f"]],["t"]]],[11,"to_owned","","",619,[[["self"]],["t"]]],[11,"clone_into","","",619,N],[11,"from","","",619,[[["t"]],["t"]]],[11,"into","","",619,[[["self"]],["u"]]],[11,"try_from","","",619,[[["u"]],["result"]]],[11,"borrow","","",619,[[["self"]],["t"]]],[11,"try_into","","",619,[[["self"]],["result"]]],[11,"borrow_mut","","",619,[[["self"]],["t"]]],[11,"get_type_id","","",619,[[["self"]],["typeid"]]],[11,"not_found","","",619,[[["str"],["str"]],["e"]]],[11,"astconv_object_safety_violations","rustc::ty","Returns the object safety violations that affect astconv - currently, Self in supertraits. This is needed because `object_safety_violations` can't be used during type collection.",677,[[["self"],["defid"]],["vec",["objectsafetyviolation"]]]],[11,"object_safety_violations","","",677,[[["self"],["defid"]],["vec",["objectsafetyviolation"]]]],[11,"object_safety_violations_for_trait","","",677,[[["self"],["defid"]],["vec",["objectsafetyviolation"]]]],[11,"predicates_reference_self","","",677,[[["self"],["defid"],["bool"]],["bool"]]],[11,"trait_has_sized_self","","",677,[[["self"],["defid"]],["bool"]]],[11,"generics_require_sized_self","","",677,[[["self"],["defid"]],["bool"]]],[11,"object_safety_violation_for_method","","Returns `Some(_)` if this method makes the containing trait not object safe.",677,[[["self"],["defid"],["associateditem"]],["option",["methodviolationcode"]]]],[11,"is_vtable_safe_method","","We say a method is vtable safe if it can be invoked on a trait object.  Note that object-safe traits can have some non-vtable-safe methods, so long as they require `Self:Sized` or otherwise ensure that they cannot be used when `Self=Trait`.",677,[[["self"],["defid"],["associateditem"]],["bool"]]],[11,"virtual_call_violation_for_method","","Returns `Some(_)` if this method cannot be called on a trait object; this does not necessarily imply that the enclosing trait is not object safe, because the method might have a where clause `Self:Sized`.",677,[[["self"],["defid"],["associateditem"]],["option",["methodviolationcode"]]]],[11,"contains_illegal_self_type_reference","","",677,[[["self"],["defid"],["ty"]],["bool"]]],[11,"from_ok","rustc::traits::on_unimplemented","",620,[[["t"]],["t"]]],[11,"map_same","","",620,[[["self"],["f"]],["t"]]],[11,"to_owned","","",620,[[["self"]],["t"]]],[11,"clone_into","","",620,N],[11,"from","","",620,[[["t"]],["t"]]],[11,"into","","",620,[[["self"]],["u"]]],[11,"try_from","","",620,[[["u"]],["result"]]],[11,"borrow","","",620,[[["self"]],["t"]]],[11,"try_into","","",620,[[["self"]],["result"]]],[11,"borrow_mut","","",620,[[["self"]],["t"]]],[11,"get_type_id","","",620,[[["self"]],["typeid"]]],[11,"not_found","","",620,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::select","",621,[[["t"]],["t"]]],[11,"map_same","","",621,[[["self"],["f"]],["t"]]],[11,"from","","",621,[[["t"]],["t"]]],[11,"into","","",621,[[["self"]],["u"]]],[11,"try_from","","",621,[[["u"]],["result"]]],[11,"borrow","","",621,[[["self"]],["t"]]],[11,"try_into","","",621,[[["self"]],["result"]]],[11,"borrow_mut","","",621,[[["self"]],["t"]]],[11,"get_type_id","","",621,[[["self"]],["typeid"]]],[11,"not_found","","",621,[[["str"],["str"]],["e"]]],[11,"from_ok","","",622,[[["t"]],["t"]]],[11,"map_same","","",622,[[["self"],["f"]],["t"]]],[11,"from","","",622,[[["t"]],["t"]]],[11,"into","","",622,[[["self"]],["u"]]],[11,"try_from","","",622,[[["u"]],["result"]]],[11,"borrow","","",622,[[["self"]],["t"]]],[11,"try_into","","",622,[[["self"]],["result"]]],[11,"borrow_mut","","",622,[[["self"]],["t"]]],[11,"get_type_id","","",622,[[["self"]],["typeid"]]],[11,"not_found","","",622,[[["str"],["str"]],["e"]]],[11,"from_ok","","",623,[[["t"]],["t"]]],[11,"map_same","","",623,[[["self"],["f"]],["t"]]],[11,"to_owned","","",623,[[["self"]],["t"]]],[11,"clone_into","","",623,N],[11,"from","","",623,[[["t"]],["t"]]],[11,"into","","",623,[[["self"]],["u"]]],[11,"try_from","","",623,[[["u"]],["result"]]],[11,"borrow","","",623,[[["self"]],["t"]]],[11,"try_into","","",623,[[["self"]],["result"]]],[11,"borrow_mut","","",623,[[["self"]],["t"]]],[11,"get_type_id","","",623,[[["self"]],["typeid"]]],[11,"not_found","","",623,[[["str"],["str"]],["e"]]],[11,"from_ok","","",624,[[["t"]],["t"]]],[11,"map_same","","",624,[[["self"],["f"]],["t"]]],[11,"to_owned","","",624,[[["self"]],["t"]]],[11,"clone_into","","",624,N],[11,"from","","",624,[[["t"]],["t"]]],[11,"into_iter","","",624,[[["self"]],["i"]]],[11,"into","","",624,[[["self"]],["u"]]],[11,"try_from","","",624,[[["u"]],["result"]]],[11,"borrow","","",624,[[["self"]],["t"]]],[11,"try_into","","",624,[[["self"]],["result"]]],[11,"borrow_mut","","",624,[[["self"]],["t"]]],[11,"get_type_id","","",624,[[["self"]],["typeid"]]],[11,"not_found","","",624,[[["str"],["str"]],["e"]]],[11,"from_ok","","",625,[[["t"]],["t"]]],[11,"map_same","","",625,[[["self"],["f"]],["t"]]],[11,"to_owned","","",625,[[["self"]],["t"]]],[11,"clone_into","","",625,N],[11,"from","","",625,[[["t"]],["t"]]],[11,"into","","",625,[[["self"]],["u"]]],[11,"try_from","","",625,[[["u"]],["result"]]],[11,"borrow","","",625,[[["self"]],["t"]]],[11,"try_into","","",625,[[["self"]],["result"]]],[11,"borrow_mut","","",625,[[["self"]],["t"]]],[11,"get_type_id","","",625,[[["self"]],["typeid"]]],[11,"not_found","","",625,[[["str"],["str"]],["e"]]],[11,"from_ok","","",626,[[["t"]],["t"]]],[11,"map_same","","",626,[[["self"],["f"]],["t"]]],[11,"to_owned","","",626,[[["self"]],["t"]]],[11,"clone_into","","",626,N],[11,"from","","",626,[[["t"]],["t"]]],[11,"into","","",626,[[["self"]],["u"]]],[11,"try_from","","",626,[[["u"]],["result"]]],[11,"borrow","","",626,[[["self"]],["t"]]],[11,"try_into","","",626,[[["self"]],["result"]]],[11,"borrow_mut","","",626,[[["self"]],["t"]]],[11,"get_type_id","","",626,[[["self"]],["typeid"]]],[11,"not_found","","",626,[[["str"],["str"]],["e"]]],[11,"from_ok","","",627,[[["t"]],["t"]]],[11,"map_same","","",627,[[["self"],["f"]],["t"]]],[11,"from","","",627,[[["t"]],["t"]]],[11,"into","","",627,[[["self"]],["u"]]],[11,"try_from","","",627,[[["u"]],["result"]]],[11,"borrow","","",627,[[["self"]],["t"]]],[11,"try_into","","",627,[[["self"]],["result"]]],[11,"borrow_mut","","",627,[[["self"]],["t"]]],[11,"get_type_id","","",627,[[["self"]],["typeid"]]],[11,"not_found","","",627,[[["str"],["str"]],["e"]]],[11,"derived_cause","rustc::traits","Creates a cause for obligations that are derived from `obligation` by a recursive search (e.g., for a builtin bound, or eventually a `auto trait Foo`). If `obligation` is itself a derived obligation, this is just a clone, but otherwise we create a \"derived obligation\" cause so as to keep track of the original root obligation for error reporting.",656,N],[11,"from_ok","rustc::traits::specialize::specialization_graph","",629,[[["t"]],["t"]]],[11,"map_same","","",629,[[["self"],["f"]],["t"]]],[11,"from","","",629,[[["t"]],["t"]]],[11,"into","","",629,[[["self"]],["u"]]],[11,"try_from","","",629,[[["u"]],["result"]]],[11,"borrow","","",629,[[["self"]],["t"]]],[11,"try_into","","",629,[[["self"]],["result"]]],[11,"borrow_mut","","",629,[[["self"]],["t"]]],[11,"get_type_id","","",629,[[["self"]],["typeid"]]],[11,"encode","","",629,[[["self"],["e"]],["result"]]],[11,"decode","","",629,[[["d"]],["result"]]],[11,"not_found","","",629,[[["str"],["str"]],["e"]]],[11,"from_ok","","",630,[[["t"]],["t"]]],[11,"map_same","","",630,[[["self"],["f"]],["t"]]],[11,"from","","",630,[[["t"]],["t"]]],[11,"into","","",630,[[["self"]],["u"]]],[11,"try_from","","",630,[[["u"]],["result"]]],[11,"borrow","","",630,[[["self"]],["t"]]],[11,"try_into","","",630,[[["self"]],["result"]]],[11,"borrow_mut","","",630,[[["self"]],["t"]]],[11,"get_type_id","","",630,[[["self"]],["typeid"]]],[11,"not_found","","",630,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::codegen","",631,[[["t"]],["t"]]],[11,"map_same","","",631,[[["self"],["f"]],["t"]]],[11,"from","","",631,[[["t"]],["t"]]],[11,"into","","",631,[[["self"]],["u"]]],[11,"try_from","","",631,[[["u"]],["result"]]],[11,"borrow","","",631,[[["self"]],["t"]]],[11,"try_into","","",631,[[["self"]],["result"]]],[11,"borrow_mut","","",631,[[["self"]],["t"]]],[11,"get_type_id","","",631,[[["self"]],["typeid"]]],[11,"not_found","","",631,[[["str"],["str"]],["e"]]],[11,"from_ok","","",632,[[["t"]],["t"]]],[11,"map_same","","",632,[[["self"],["f"]],["t"]]],[11,"from","","",632,[[["t"]],["t"]]],[11,"into","","",632,[[["self"]],["u"]]],[11,"try_from","","",632,[[["u"]],["result"]]],[11,"borrow","","",632,[[["self"]],["t"]]],[11,"try_into","","",632,[[["self"]],["result"]]],[11,"borrow_mut","","",632,[[["self"]],["t"]]],[11,"get_type_id","","",632,[[["self"]],["typeid"]]],[11,"not_found","","",632,[[["str"],["str"]],["e"]]],[11,"subst_and_normalize_erasing_regions","rustc::ty","Monomorphizes a type from the AST by first applying the in-scope substitutions and then normalizing any associated types.",677,[[["self"],["substs"],["paramenv"],["t"]],["t"]]],[11,"from_ok","rustc::traits::util","",633,[[["t"]],["t"]]],[11,"map_same","","",633,[[["self"],["f"]],["t"]]],[11,"from","","",633,[[["t"]],["t"]]],[11,"into","","",633,[[["self"]],["u"]]],[11,"try_from","","",633,[[["u"]],["result"]]],[11,"borrow","","",633,[[["self"]],["t"]]],[11,"try_into","","",633,[[["self"]],["result"]]],[11,"borrow_mut","","",633,[[["self"]],["t"]]],[11,"get_type_id","","",633,[[["self"]],["typeid"]]],[11,"not_found","","",633,[[["str"],["str"]],["e"]]],[11,"from_ok","","",634,[[["t"]],["t"]]],[11,"map_same","","",634,[[["self"],["f"]],["t"]]],[11,"from","","",634,[[["t"]],["t"]]],[11,"into_iter","","",634,[[["self"]],["i"]]],[11,"into","","",634,[[["self"]],["u"]]],[11,"try_from","","",634,[[["u"]],["result"]]],[11,"borrow","","",634,[[["self"]],["t"]]],[11,"try_into","","",634,[[["self"]],["result"]]],[11,"borrow_mut","","",634,[[["self"]],["t"]]],[11,"get_type_id","","",634,[[["self"]],["typeid"]]],[11,"not_found","","",634,[[["str"],["str"]],["e"]]],[11,"from_ok","","",635,[[["t"]],["t"]]],[11,"map_same","","",635,[[["self"],["f"]],["t"]]],[11,"from","","",635,[[["t"]],["t"]]],[11,"into_iter","","",635,[[["self"]],["i"]]],[11,"into","","",635,[[["self"]],["u"]]],[11,"try_from","","",635,[[["u"]],["result"]]],[11,"borrow","","",635,[[["self"]],["t"]]],[11,"try_into","","",635,[[["self"]],["result"]]],[11,"borrow_mut","","",635,[[["self"]],["t"]]],[11,"get_type_id","","",635,[[["self"]],["typeid"]]],[11,"not_found","","",635,[[["str"],["str"]],["e"]]],[11,"from_ok","","",636,[[["t"]],["t"]]],[11,"map_same","","",636,[[["self"],["f"]],["t"]]],[11,"from","","",636,[[["t"]],["t"]]],[11,"into","","",636,[[["self"]],["u"]]],[11,"try_from","","",636,[[["u"]],["result"]]],[11,"borrow","","",636,[[["self"]],["t"]]],[11,"try_into","","",636,[[["self"]],["result"]]],[11,"borrow_mut","","",636,[[["self"]],["t"]]],[11,"get_type_id","","",636,[[["self"]],["typeid"]]],[11,"not_found","","",636,[[["str"],["str"]],["e"]]],[11,"predicate_for_trait_def","rustc::ty","",677,N],[11,"upcast_choices","","Cast a trait reference into a reference to one of its super traits; returns `None` if `target_trait_def_id` is not a supertrait.",677,[[["self"],["polytraitref"],["defid"]],["vec",["polytraitref"]]]],[11,"count_own_vtable_entries","","Given a trait `trait_ref`, returns the number of vtable entries that come from `trait_ref`, excluding its supertraits. Used in computing the vtable base for an upcast trait of a trait object.",677,[[["self"],["polytraitref"]],["usize"]]],[11,"get_vtable_index_of_object_method","","Given an upcast trait object described by `object`, returns the index of the method `method_def_id` (which should be part of `object.upcast_trait_ref`) within the vtable for `object`.",677,[[["self"],["vtableobjectdata"],["defid"]],["usize"]]],[11,"closure_trait_ref_and_return_type","","",677,[[["self"],["defid"],["ty"],["polyfnsig"],["tupleargumentsflag"]],["binder"]]],[11,"generator_trait_ref_and_outputs","","",677,[[["self"],["defid"],["ty"],["polygensig"]],["binder"]]],[11,"impl_is_default","","",677,[[["self"],["defid"]],["bool"]]],[11,"impl_item_is_final","","",677,[[["self"],["nodeitem"]],["bool"]]],[11,"from_ok","rustc::traits::query","",653,[[["t"]],["t"]]],[11,"map_same","","",653,[[["self"],["f"]],["t"]]],[11,"to_owned","","",653,[[["self"]],["t"]]],[11,"clone_into","","",653,N],[11,"from","","",653,[[["t"]],["t"]]],[11,"into","","",653,[[["self"]],["u"]]],[11,"try_from","","",653,[[["u"]],["result"]]],[11,"borrow","","",653,[[["self"]],["t"]]],[11,"try_into","","",653,[[["self"]],["result"]]],[11,"borrow_mut","","",653,[[["self"]],["t"]]],[11,"get_type_id","","",653,[[["self"]],["typeid"]]],[11,"not_found","","",653,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::query::dropck_outlives","",637,[[["t"]],["t"]]],[11,"map_same","","",637,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",637,N],[11,"to_owned","","",637,[[["self"]],["t"]]],[11,"clone_into","","",637,N],[11,"from","","",637,[[["t"]],["t"]]],[11,"into","","",637,[[["self"]],["u"]]],[11,"try_from","","",637,[[["u"]],["result"]]],[11,"borrow","","",637,[[["self"]],["t"]]],[11,"try_into","","",637,[[["self"]],["result"]]],[11,"borrow_mut","","",637,[[["self"]],["t"]]],[11,"get_type_id","","",637,[[["self"]],["typeid"]]],[11,"not_found","","",637,[[["str"],["str"]],["e"]]],[11,"from_ok","","",638,[[["t"]],["t"]]],[11,"map_same","","",638,[[["self"],["f"]],["t"]]],[11,"to_owned","","",638,[[["self"]],["t"]]],[11,"clone_into","","",638,N],[11,"from","","",638,[[["t"]],["t"]]],[11,"into","","",638,[[["self"]],["u"]]],[11,"try_from","","",638,[[["u"]],["result"]]],[11,"borrow","","",638,[[["self"]],["t"]]],[11,"try_into","","",638,[[["self"]],["result"]]],[11,"borrow_mut","","",638,[[["self"]],["t"]]],[11,"get_type_id","","",638,[[["self"]],["typeid"]]],[11,"not_found","","",638,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::query::normalize","",639,[[["t"]],["t"]]],[11,"map_same","","",639,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",639,N],[11,"to_owned","","",639,[[["self"]],["t"]]],[11,"clone_into","","",639,N],[11,"from","","",639,[[["t"]],["t"]]],[11,"into","","",639,[[["self"]],["u"]]],[11,"try_from","","",639,[[["u"]],["result"]]],[11,"borrow","","",639,[[["self"]],["t"]]],[11,"try_into","","",639,[[["self"]],["result"]]],[11,"borrow_mut","","",639,[[["self"]],["t"]]],[11,"get_type_id","","",639,[[["self"]],["typeid"]]],[11,"not_found","","",639,[[["str"],["str"]],["e"]]],[11,"from_ok","","",640,[[["t"]],["t"]]],[11,"map_same","","",640,[[["self"],["f"]],["t"]]],[11,"from","","",640,[[["t"]],["t"]]],[11,"into","","",640,[[["self"]],["u"]]],[11,"try_from","","",640,[[["u"]],["result"]]],[11,"borrow","","",640,[[["self"]],["t"]]],[11,"try_into","","",640,[[["self"]],["result"]]],[11,"borrow_mut","","",640,[[["self"]],["t"]]],[11,"get_type_id","","",640,[[["self"]],["typeid"]]],[11,"not_found","","",640,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::query::normalize_erasing_regions","",641,[[["t"]],["t"]]],[11,"map_same","","",641,[[["self"],["f"]],["t"]]],[11,"from","","",641,[[["t"]],["t"]]],[11,"into","","",641,[[["self"]],["u"]]],[11,"try_from","","",641,[[["u"]],["result"]]],[11,"borrow","","",641,[[["self"]],["t"]]],[11,"try_into","","",641,[[["self"]],["result"]]],[11,"borrow_mut","","",641,[[["self"]],["t"]]],[11,"get_type_id","","",641,[[["self"]],["typeid"]]],[11,"not_found","","",641,[[["str"],["str"]],["e"]]],[11,"normalize_erasing_regions","rustc::ty","Erase the regions in `value` and then fully normalize all the types found within. The result will also have regions erased.",677,[[["self"],["paramenv"],["t"]],["t"]]],[11,"normalize_erasing_late_bound_regions","","If you have a `Binder<T>`, you can do this to strip out the late-bound regions and then normalize the result, yielding up a `T` (with regions erased). This is appropriate when the binder is being instantiated at the call site.",677,[[["self"],["paramenv"],["binder"]],["t"]]],[11,"from_ok","rustc::traits::query::outlives_bounds","",642,[[["t"]],["t"]]],[11,"map_same","","",642,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",642,N],[11,"to_owned","","",642,[[["self"]],["t"]]],[11,"clone_into","","",642,N],[11,"from","","",642,[[["t"]],["t"]]],[11,"into","","",642,[[["self"]],["u"]]],[11,"try_from","","",642,[[["u"]],["result"]]],[11,"borrow","","",642,[[["self"]],["t"]]],[11,"try_into","","",642,[[["self"]],["result"]]],[11,"borrow_mut","","",642,[[["self"]],["t"]]],[11,"get_type_id","","",642,[[["self"]],["typeid"]]],[11,"not_found","","",642,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::query::type_op::custom","",643,[[["t"]],["t"]]],[11,"map_same","","",643,[[["self"],["f"]],["t"]]],[11,"from","","",643,[[["t"]],["t"]]],[11,"into","","",643,[[["self"]],["u"]]],[11,"try_from","","",643,[[["u"]],["result"]]],[11,"borrow","","",643,[[["self"]],["t"]]],[11,"try_into","","",643,[[["self"]],["result"]]],[11,"borrow_mut","","",643,[[["self"]],["t"]]],[11,"get_type_id","","",643,[[["self"]],["typeid"]]],[11,"not_found","","",643,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::query::type_op::eq","",644,[[["t"]],["t"]]],[11,"map_same","","",644,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",644,N],[11,"to_owned","","",644,[[["self"]],["t"]]],[11,"clone_into","","",644,N],[11,"from","","",644,[[["t"]],["t"]]],[11,"into","","",644,[[["self"]],["u"]]],[11,"try_from","","",644,[[["u"]],["result"]]],[11,"borrow","","",644,[[["self"]],["t"]]],[11,"try_into","","",644,[[["self"]],["result"]]],[11,"borrow_mut","","",644,[[["self"]],["t"]]],[11,"get_type_id","","",644,[[["self"]],["typeid"]]],[11,"not_found","","",644,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::query::type_op::implied_outlives_bounds","",645,[[["t"]],["t"]]],[11,"map_same","","",645,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",645,N],[11,"to_owned","","",645,[[["self"]],["t"]]],[11,"clone_into","","",645,N],[11,"from","","",645,[[["t"]],["t"]]],[11,"into","","",645,[[["self"]],["u"]]],[11,"try_from","","",645,[[["u"]],["result"]]],[11,"borrow","","",645,[[["self"]],["t"]]],[11,"try_into","","",645,[[["self"]],["result"]]],[11,"borrow_mut","","",645,[[["self"]],["t"]]],[11,"get_type_id","","",645,[[["self"]],["typeid"]]],[11,"not_found","","",645,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::query::type_op::normalize","",646,[[["t"]],["t"]]],[11,"map_same","","",646,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",646,N],[11,"to_owned","","",646,[[["self"]],["t"]]],[11,"clone_into","","",646,N],[11,"from","","",646,[[["t"]],["t"]]],[11,"into","","",646,[[["self"]],["u"]]],[11,"try_from","","",646,[[["u"]],["result"]]],[11,"borrow","","",646,[[["self"]],["t"]]],[11,"try_into","","",646,[[["self"]],["result"]]],[11,"borrow_mut","","",646,[[["self"]],["t"]]],[11,"get_type_id","","",646,[[["self"]],["typeid"]]],[11,"not_found","","",646,[[["str"],["str"]],["e"]]],[11,"type_op_method","rustc::ty","",1061,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",1061,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"type_op_method","","",733,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",733,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"type_op_method","rustc::ty::sty","",1030,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",1030,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"type_op_method","rustc::ty","",660,[[["tyctxt"],["canonicalized",["paramenvand"]]],["fallible",["canonicalizedqueryresult"]]]],[11,"shrink_to_tcx_lifetime","","",660,[[["canonicalizedqueryresult"]],["canonical"]]],[11,"from_ok","rustc::traits::query::type_op::outlives","",648,[[["t"]],["t"]]],[11,"map_same","","",648,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",648,N],[11,"to_owned","","",648,[[["self"]],["t"]]],[11,"clone_into","","",648,N],[11,"from","","",648,[[["t"]],["t"]]],[11,"into","","",648,[[["self"]],["u"]]],[11,"try_from","","",648,[[["u"]],["result"]]],[11,"borrow","","",648,[[["self"]],["t"]]],[11,"try_into","","",648,[[["self"]],["result"]]],[11,"borrow_mut","","",648,[[["self"]],["t"]]],[11,"get_type_id","","",648,[[["self"]],["typeid"]]],[11,"not_found","","",648,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::query::type_op::prove_predicate","",649,[[["t"]],["t"]]],[11,"map_same","","",649,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",649,N],[11,"to_owned","","",649,[[["self"]],["t"]]],[11,"clone_into","","",649,N],[11,"from","","",649,[[["t"]],["t"]]],[11,"into","","",649,[[["self"]],["u"]]],[11,"try_from","","",649,[[["u"]],["result"]]],[11,"borrow","","",649,[[["self"]],["t"]]],[11,"try_into","","",649,[[["self"]],["result"]]],[11,"borrow_mut","","",649,[[["self"]],["t"]]],[11,"get_type_id","","",649,[[["self"]],["typeid"]]],[11,"not_found","","",649,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::traits::query::type_op::subtype","",650,[[["t"]],["t"]]],[11,"map_same","","",650,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",650,N],[11,"to_owned","","",650,[[["self"]],["t"]]],[11,"clone_into","","",650,N],[11,"from","","",650,[[["t"]],["t"]]],[11,"into","","",650,[[["self"]],["u"]]],[11,"try_from","","",650,[[["u"]],["result"]]],[11,"borrow","","",650,[[["self"]],["t"]]],[11,"try_into","","",650,[[["self"]],["result"]]],[11,"borrow_mut","","",650,[[["self"]],["t"]]],[11,"get_type_id","","",650,[[["self"]],["typeid"]]],[11,"not_found","","",650,[[["str"],["str"]],["e"]]],[11,"fully_perform","rustc::ty","",707,[[["self"],["inferctxt"]],["fallible"]]],[11,"from_ok","","",657,[[["t"]],["t"]]],[11,"map_same","","",657,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",657,N],[11,"to_owned","","",657,[[["self"]],["t"]]],[11,"clone_into","","",657,N],[11,"from","","",657,[[["t"]],["t"]]],[11,"to_string","","",657,[[["self"]],["string"]]],[11,"into","","",657,[[["self"]],["u"]]],[11,"try_from","","",657,[[["u"]],["result"]]],[11,"borrow","","",657,[[["self"]],["t"]]],[11,"try_into","","",657,[[["self"]],["result"]]],[11,"borrow_mut","","",657,[[["self"]],["t"]]],[11,"get_type_id","","",657,[[["self"]],["typeid"]]],[11,"encode","","",657,[[["self"],["e"]],["result"]]],[11,"decode","","",657,[[["d"]],["result"]]],[11,"not_found","","",657,[[["str"],["str"]],["e"]]],[11,"from_ok","","",658,[[["t"]],["t"]]],[11,"map_same","","",658,[[["self"],["f"]],["t"]]],[11,"to_owned","","",658,[[["self"]],["t"]]],[11,"clone_into","","",658,N],[11,"from","","",658,[[["t"]],["t"]]],[11,"into","","",658,[[["self"]],["u"]]],[11,"try_from","","",658,[[["u"]],["result"]]],[11,"borrow","","",658,[[["self"]],["t"]]],[11,"try_into","","",658,[[["self"]],["result"]]],[11,"borrow_mut","","",658,[[["self"]],["t"]]],[11,"get_type_id","","",658,[[["self"]],["typeid"]]],[11,"encode","","",658,[[["self"],["e"]],["result"]]],[11,"decode","","",658,[[["d"]],["result"]]],[11,"not_found","","",658,[[["str"],["str"]],["e"]]],[11,"from_ok","","",659,[[["t"]],["t"]]],[11,"map_same","","",659,[[["self"],["f"]],["t"]]],[11,"to_owned","","",659,[[["self"]],["t"]]],[11,"clone_into","","",659,N],[11,"from","","",659,[[["t"]],["t"]]],[11,"into","","",659,[[["self"]],["u"]]],[11,"try_from","","",659,[[["u"]],["result"]]],[11,"borrow","","",659,[[["self"]],["t"]]],[11,"try_into","","",659,[[["self"]],["result"]]],[11,"borrow_mut","","",659,[[["self"]],["t"]]],[11,"get_type_id","","",659,[[["self"]],["typeid"]]],[11,"encode","","",659,[[["self"],["e"]],["result"]]],[11,"decode","","",659,[[["d"]],["result"]]],[11,"not_found","","",659,[[["str"],["str"]],["e"]]],[11,"from_ok","","",660,[[["t"]],["t"]]],[11,"map_same","","",660,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",660,N],[11,"to_owned","","",660,[[["self"]],["t"]]],[11,"clone_into","","",660,N],[11,"from","","",660,[[["t"]],["t"]]],[11,"to_string","","",660,[[["self"]],["string"]]],[11,"into","","",660,[[["self"]],["u"]]],[11,"try_from","","",660,[[["u"]],["result"]]],[11,"borrow","","",660,[[["self"]],["t"]]],[11,"try_into","","",660,[[["self"]],["result"]]],[11,"borrow_mut","","",660,[[["self"]],["t"]]],[11,"get_type_id","","",660,[[["self"]],["typeid"]]],[11,"encode","","",660,[[["self"],["e"]],["result"]]],[11,"decode","","",660,[[["d"]],["result"]]],[11,"not_found","","",660,[[["str"],["str"]],["e"]]],[11,"from_ok","","",661,[[["t"]],["t"]]],[11,"map_same","","",661,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",661,N],[11,"to_owned","","",661,[[["self"]],["t"]]],[11,"clone_into","","",661,N],[11,"from","","",661,[[["t"]],["t"]]],[11,"into","","",661,[[["self"]],["u"]]],[11,"try_from","","",661,[[["u"]],["result"]]],[11,"borrow","","",661,[[["self"]],["t"]]],[11,"try_into","","",661,[[["self"]],["result"]]],[11,"borrow_mut","","",661,[[["self"]],["t"]]],[11,"get_type_id","","",661,[[["self"]],["typeid"]]],[11,"encode","","",661,[[["self"],["e"]],["result"]]],[11,"decode","","",661,[[["d"]],["result"]]],[11,"not_found","","",661,[[["str"],["str"]],["e"]]],[11,"from_ok","","",662,[[["t"]],["t"]]],[11,"map_same","","",662,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",662,N],[11,"to_owned","","",662,[[["self"]],["t"]]],[11,"clone_into","","",662,N],[11,"from","","",662,[[["t"]],["t"]]],[11,"to_string","","",662,[[["self"]],["string"]]],[11,"into","","",662,[[["self"]],["u"]]],[11,"try_from","","",662,[[["u"]],["result"]]],[11,"borrow","","",662,[[["self"]],["t"]]],[11,"try_into","","",662,[[["self"]],["result"]]],[11,"borrow_mut","","",662,[[["self"]],["t"]]],[11,"get_type_id","","",662,[[["self"]],["typeid"]]],[11,"encode","","",662,[[["self"],["e"]],["result"]]],[11,"decode","","",662,[[["d"]],["result"]]],[11,"not_found","","",662,[[["str"],["str"]],["e"]]],[11,"from_ok","","",663,[[["t"]],["t"]]],[11,"map_same","","",663,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",663,N],[11,"to_owned","","",663,[[["self"]],["t"]]],[11,"clone_into","","",663,N],[11,"from","","",663,[[["t"]],["t"]]],[11,"to_string","","",663,[[["self"]],["string"]]],[11,"into","","",663,[[["self"]],["u"]]],[11,"try_from","","",663,[[["u"]],["result"]]],[11,"borrow","","",663,[[["self"]],["t"]]],[11,"try_into","","",663,[[["self"]],["result"]]],[11,"borrow_mut","","",663,[[["self"]],["t"]]],[11,"get_type_id","","",663,[[["self"]],["typeid"]]],[11,"encode","","",663,[[["self"],["e"]],["result"]]],[11,"decode","","",663,[[["d"]],["result"]]],[11,"not_found","","",663,[[["str"],["str"]],["e"]]],[11,"from_ok","","",664,[[["t"]],["t"]]],[11,"map_same","","",664,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",664,N],[11,"to_owned","","",664,[[["self"]],["t"]]],[11,"clone_into","","",664,N],[11,"from","","",664,[[["t"]],["t"]]],[11,"into","","",664,[[["self"]],["u"]]],[11,"try_from","","",664,[[["u"]],["result"]]],[11,"borrow","","",664,[[["self"]],["t"]]],[11,"try_into","","",664,[[["self"]],["result"]]],[11,"borrow_mut","","",664,[[["self"]],["t"]]],[11,"get_type_id","","",664,[[["self"]],["typeid"]]],[11,"encode","","",664,[[["self"],["e"]],["result"]]],[11,"decode","","",664,[[["d"]],["result"]]],[11,"not_found","","",664,[[["str"],["str"]],["e"]]],[11,"from_ok","","",665,[[["t"]],["t"]]],[11,"map_same","","",665,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",665,N],[11,"to_owned","","",665,[[["self"]],["t"]]],[11,"clone_into","","",665,N],[11,"from","","",665,[[["t"]],["t"]]],[11,"into","","",665,[[["self"]],["u"]]],[11,"try_from","","",665,[[["u"]],["result"]]],[11,"borrow","","",665,[[["self"]],["t"]]],[11,"try_into","","",665,[[["self"]],["result"]]],[11,"borrow_mut","","",665,[[["self"]],["t"]]],[11,"get_type_id","","",665,[[["self"]],["typeid"]]],[11,"encode","","",665,[[["self"],["e"]],["result"]]],[11,"decode","","",665,[[["d"]],["result"]]],[11,"not_found","","",665,[[["str"],["str"]],["e"]]],[11,"from_ok","","",666,[[["t"]],["t"]]],[11,"map_same","","",666,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",666,N],[11,"to_owned","","",666,[[["self"]],["t"]]],[11,"clone_into","","",666,N],[11,"from","","",666,[[["t"]],["t"]]],[11,"to_string","","",666,[[["self"]],["string"]]],[11,"into","","",666,[[["self"]],["u"]]],[11,"try_from","","",666,[[["u"]],["result"]]],[11,"borrow","","",666,[[["self"]],["t"]]],[11,"try_into","","",666,[[["self"]],["result"]]],[11,"borrow_mut","","",666,[[["self"]],["t"]]],[11,"get_type_id","","",666,[[["self"]],["typeid"]]],[11,"encode","","",666,[[["self"],["e"]],["result"]]],[11,"decode","","",666,[[["d"]],["result"]]],[11,"not_found","","",666,[[["str"],["str"]],["e"]]],[11,"from_ok","","",667,[[["t"]],["t"]]],[11,"map_same","","",667,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",667,N],[11,"to_owned","","",667,[[["self"]],["t"]]],[11,"clone_into","","",667,N],[11,"from","","",667,[[["t"]],["t"]]],[11,"to_string","","",667,[[["self"]],["string"]]],[11,"into","","",667,[[["self"]],["u"]]],[11,"try_from","","",667,[[["u"]],["result"]]],[11,"borrow","","",667,[[["self"]],["t"]]],[11,"try_into","","",667,[[["self"]],["result"]]],[11,"borrow_mut","","",667,[[["self"]],["t"]]],[11,"get_type_id","","",667,[[["self"]],["typeid"]]],[11,"encode","","",667,[[["self"],["e"]],["result"]]],[11,"decode","","",667,[[["d"]],["result"]]],[11,"not_found","","",667,[[["str"],["str"]],["e"]]],[11,"from_ok","","",668,[[["t"]],["t"]]],[11,"map_same","","",668,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",668,N],[11,"to_owned","","",668,[[["self"]],["t"]]],[11,"clone_into","","",668,N],[11,"from","","",668,[[["t"]],["t"]]],[11,"into","","",668,[[["self"]],["u"]]],[11,"try_from","","",668,[[["u"]],["result"]]],[11,"borrow","","",668,[[["self"]],["t"]]],[11,"try_into","","",668,[[["self"]],["result"]]],[11,"borrow_mut","","",668,[[["self"]],["t"]]],[11,"get_type_id","","",668,[[["self"]],["typeid"]]],[11,"encode","","",668,[[["self"],["e"]],["result"]]],[11,"decode","","",668,[[["d"]],["result"]]],[11,"not_found","","",668,[[["str"],["str"]],["e"]]],[11,"from_ok","","",669,[[["t"]],["t"]]],[11,"map_same","","",669,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",669,N],[11,"to_owned","","",669,[[["self"]],["t"]]],[11,"clone_into","","",669,N],[11,"from","","",669,[[["t"]],["t"]]],[11,"into","","",669,[[["self"]],["u"]]],[11,"try_from","","",669,[[["u"]],["result"]]],[11,"borrow","","",669,[[["self"]],["t"]]],[11,"try_into","","",669,[[["self"]],["result"]]],[11,"borrow_mut","","",669,[[["self"]],["t"]]],[11,"get_type_id","","",669,[[["self"]],["typeid"]]],[11,"encode","","",669,[[["self"],["e"]],["result"]]],[11,"decode","","",669,[[["d"]],["result"]]],[11,"not_found","","",669,[[["str"],["str"]],["e"]]],[11,"from_ok","","",670,[[["t"]],["t"]]],[11,"map_same","","",670,[[["self"],["f"]],["t"]]],[11,"to_owned","","",670,[[["self"]],["t"]]],[11,"clone_into","","",670,N],[11,"from","","",670,[[["t"]],["t"]]],[11,"into","","",670,[[["self"]],["u"]]],[11,"try_from","","",670,[[["u"]],["result"]]],[11,"borrow","","",670,[[["self"]],["t"]]],[11,"try_into","","",670,[[["self"]],["result"]]],[11,"borrow_mut","","",670,[[["self"]],["t"]]],[11,"get_type_id","","",670,[[["self"]],["typeid"]]],[11,"encode","","",670,[[["self"],["e"]],["result"]]],[11,"decode","","",670,[[["d"]],["result"]]],[11,"not_found","","",670,[[["str"],["str"]],["e"]]],[11,"from_ok","","",671,[[["t"]],["t"]]],[11,"map_same","","",671,[[["self"],["f"]],["t"]]],[11,"to_owned","","",671,[[["self"]],["t"]]],[11,"clone_into","","",671,N],[11,"from","","",671,[[["t"]],["t"]]],[11,"into","","",671,[[["self"]],["u"]]],[11,"try_from","","",671,[[["u"]],["result"]]],[11,"borrow","","",671,[[["self"]],["t"]]],[11,"try_into","","",671,[[["self"]],["result"]]],[11,"borrow_mut","","",671,[[["self"]],["t"]]],[11,"get_type_id","","",671,[[["self"]],["typeid"]]],[11,"encode","","",671,[[["self"],["e"]],["result"]]],[11,"decode","","",671,[[["d"]],["result"]]],[11,"not_found","","",671,[[["str"],["str"]],["e"]]],[11,"from_ok","","",672,[[["t"]],["t"]]],[11,"map_same","","",672,[[["self"],["f"]],["t"]]],[11,"to_owned","","",672,[[["self"]],["t"]]],[11,"clone_into","","",672,N],[11,"from","","",672,[[["t"]],["t"]]],[11,"into","","",672,[[["self"]],["u"]]],[11,"try_from","","",672,[[["u"]],["result"]]],[11,"borrow","","",672,[[["self"]],["t"]]],[11,"try_into","","",672,[[["self"]],["result"]]],[11,"borrow_mut","","",672,[[["self"]],["t"]]],[11,"get_type_id","","",672,[[["self"]],["typeid"]]],[11,"encode","","",672,[[["self"],["e"]],["result"]]],[11,"decode","","",672,[[["d"]],["result"]]],[11,"not_found","","",672,[[["str"],["str"]],["e"]]],[11,"from_ok","","",673,[[["t"]],["t"]]],[11,"map_same","","",673,[[["self"],["f"]],["t"]]],[11,"to_owned","","",673,[[["self"]],["t"]]],[11,"clone_into","","",673,N],[11,"from","","",673,[[["t"]],["t"]]],[11,"into","","",673,[[["self"]],["u"]]],[11,"try_from","","",673,[[["u"]],["result"]]],[11,"borrow","","",673,[[["self"]],["t"]]],[11,"try_into","","",673,[[["self"]],["result"]]],[11,"borrow_mut","","",673,[[["self"]],["t"]]],[11,"get_type_id","","",673,[[["self"]],["typeid"]]],[11,"encode","","",673,[[["self"],["e"]],["result"]]],[11,"decode","","",673,[[["d"]],["result"]]],[11,"not_found","","",673,[[["str"],["str"]],["e"]]],[11,"from_ok","","",674,[[["t"]],["t"]]],[11,"map_same","","",674,[[["self"],["f"]],["t"]]],[11,"to_owned","","",674,[[["self"]],["t"]]],[11,"clone_into","","",674,N],[11,"from","","",674,[[["t"]],["t"]]],[11,"into","","",674,[[["self"]],["u"]]],[11,"try_from","","",674,[[["u"]],["result"]]],[11,"borrow","","",674,[[["self"]],["t"]]],[11,"try_into","","",674,[[["self"]],["result"]]],[11,"borrow_mut","","",674,[[["self"]],["t"]]],[11,"get_type_id","","",674,[[["self"]],["typeid"]]],[11,"encode","","",674,[[["self"],["e"]],["result"]]],[11,"decode","","",674,[[["d"]],["result"]]],[11,"not_found","","",674,[[["str"],["str"]],["e"]]],[11,"from_ok","","",675,[[["t"]],["t"]]],[11,"map_same","","",675,[[["self"],["f"]],["t"]]],[11,"to_owned","","",675,[[["self"]],["t"]]],[11,"clone_into","","",675,N],[11,"from","","",675,[[["t"]],["t"]]],[11,"into","","",675,[[["self"]],["u"]]],[11,"try_from","","",675,[[["u"]],["result"]]],[11,"borrow","","",675,[[["self"]],["t"]]],[11,"try_into","","",675,[[["self"]],["result"]]],[11,"borrow_mut","","",675,[[["self"]],["t"]]],[11,"get_type_id","","",675,[[["self"]],["typeid"]]],[11,"encode","","",675,[[["self"],["e"]],["result"]]],[11,"decode","","",675,[[["d"]],["result"]]],[11,"not_found","","",675,[[["str"],["str"]],["e"]]],[11,"from_ok","","",676,[[["t"]],["t"]]],[11,"map_same","","",676,[[["self"],["f"]],["t"]]],[11,"to_owned","","",676,[[["self"]],["t"]]],[11,"clone_into","","",676,N],[11,"from","","",676,[[["t"]],["t"]]],[11,"into","","",676,[[["self"]],["u"]]],[11,"try_from","","",676,[[["u"]],["result"]]],[11,"borrow","","",676,[[["self"]],["t"]]],[11,"try_into","","",676,[[["self"]],["result"]]],[11,"borrow_mut","","",676,[[["self"]],["t"]]],[11,"get_type_id","","",676,[[["self"]],["typeid"]]],[11,"encode","","",676,[[["self"],["e"]],["result"]]],[11,"decode","","",676,[[["d"]],["result"]]],[11,"not_found","","",676,[[["str"],["str"]],["e"]]],[11,"from_ok","","",677,[[["t"]],["t"]]],[11,"map_same","","",677,[[["self"],["f"]],["t"]]],[11,"to_owned","","",677,[[["self"]],["t"]]],[11,"clone_into","","",677,N],[11,"from","","",677,[[["t"]],["t"]]],[11,"into","","",677,[[["self"]],["u"]]],[11,"try_from","","",677,[[["u"]],["result"]]],[11,"borrow","","",677,[[["self"]],["t"]]],[11,"try_into","","",677,[[["self"]],["result"]]],[11,"borrow_mut","","",677,[[["self"]],["t"]]],[11,"get_type_id","","",677,[[["self"]],["typeid"]]],[11,"not_found","","",677,[[["str"],["str"]],["e"]]],[11,"from_ok","","",678,[[["t"]],["t"]]],[11,"map_same","","",678,[[["self"],["f"]],["t"]]],[11,"from","","",678,[[["t"]],["t"]]],[11,"into","","",678,[[["self"]],["u"]]],[11,"try_from","","",678,[[["u"]],["result"]]],[11,"borrow","","",678,[[["self"]],["t"]]],[11,"try_into","","",678,[[["self"]],["result"]]],[11,"borrow_mut","","",678,[[["self"]],["t"]]],[11,"get_type_id","","",678,[[["self"]],["typeid"]]],[11,"not_found","","",678,[[["str"],["str"]],["e"]]],[11,"from_ok","","",679,[[["t"]],["t"]]],[11,"map_same","","",679,[[["self"],["f"]],["t"]]],[11,"from","","",679,[[["t"]],["t"]]],[11,"into","","",679,[[["self"]],["u"]]],[11,"try_from","","",679,[[["u"]],["result"]]],[11,"borrow","","",679,[[["self"]],["t"]]],[11,"try_into","","",679,[[["self"]],["result"]]],[11,"borrow_mut","","",679,[[["self"]],["t"]]],[11,"get_type_id","","",679,[[["self"]],["typeid"]]],[11,"not_found","","",679,[[["str"],["str"]],["e"]]],[11,"from_ok","","",680,[[["t"]],["t"]]],[11,"map_same","","",680,[[["self"],["f"]],["t"]]],[11,"from","","",680,[[["t"]],["t"]]],[11,"into","","",680,[[["self"]],["u"]]],[11,"try_from","","",680,[[["u"]],["result"]]],[11,"borrow","","",680,[[["self"]],["t"]]],[11,"try_into","","",680,[[["self"]],["result"]]],[11,"borrow_mut","","",680,[[["self"]],["t"]]],[11,"get_type_id","","",680,[[["self"]],["typeid"]]],[11,"encode","","",680,[[["self"],["e"]],["result"]]],[11,"decode","","",680,[[["d"]],["result"]]],[11,"not_found","","",680,[[["str"],["str"]],["e"]]],[11,"from_ok","","",681,[[["t"]],["t"]]],[11,"map_same","","",681,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",681,N],[11,"to_owned","","",681,[[["self"]],["t"]]],[11,"clone_into","","",681,N],[11,"from","","",681,[[["t"]],["t"]]],[11,"to_string","","",681,[[["self"]],["string"]]],[11,"into","","",681,[[["self"]],["u"]]],[11,"try_from","","",681,[[["u"]],["result"]]],[11,"borrow","","",681,[[["self"]],["t"]]],[11,"try_into","","",681,[[["self"]],["result"]]],[11,"borrow_mut","","",681,[[["self"]],["t"]]],[11,"get_type_id","","",681,[[["self"]],["typeid"]]],[11,"encode","","",681,[[["self"],["e"]],["result"]]],[11,"decode","","",681,[[["d"]],["result"]]],[11,"not_found","","",681,[[["str"],["str"]],["e"]]],[11,"from_ok","","",682,[[["t"]],["t"]]],[11,"map_same","","",682,[[["self"],["f"]],["t"]]],[11,"to_owned","","",682,[[["self"]],["t"]]],[11,"clone_into","","",682,N],[11,"from","","",682,[[["t"]],["t"]]],[11,"into","","",682,[[["self"]],["u"]]],[11,"try_from","","",682,[[["u"]],["result"]]],[11,"borrow","","",682,[[["self"]],["t"]]],[11,"try_into","","",682,[[["self"]],["result"]]],[11,"borrow_mut","","",682,[[["self"]],["t"]]],[11,"get_type_id","","",682,[[["self"]],["typeid"]]],[11,"not_found","","",682,[[["str"],["str"]],["e"]]],[11,"from_ok","","",683,[[["t"]],["t"]]],[11,"map_same","","",683,[[["self"],["f"]],["t"]]],[11,"to_owned","","",683,[[["self"]],["t"]]],[11,"clone_into","","",683,N],[11,"from","","",683,[[["t"]],["t"]]],[11,"into","","",683,[[["self"]],["u"]]],[11,"try_from","","",683,[[["u"]],["result"]]],[11,"borrow","","",683,[[["self"]],["t"]]],[11,"try_into","","",683,[[["self"]],["result"]]],[11,"borrow_mut","","",683,[[["self"]],["t"]]],[11,"get_type_id","","",683,[[["self"]],["typeid"]]],[11,"not_found","","",683,[[["str"],["str"]],["e"]]],[11,"from_ok","","",684,[[["t"]],["t"]]],[11,"map_same","","",684,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",684,N],[11,"to_owned","","",684,[[["self"]],["t"]]],[11,"clone_into","","",684,N],[11,"from","","",684,[[["t"]],["t"]]],[11,"into","","",684,[[["self"]],["u"]]],[11,"try_from","","",684,[[["u"]],["result"]]],[11,"borrow","","",684,[[["self"]],["t"]]],[11,"try_into","","",684,[[["self"]],["result"]]],[11,"borrow_mut","","",684,[[["self"]],["t"]]],[11,"get_type_id","","",684,[[["self"]],["typeid"]]],[11,"not_found","","",684,[[["str"],["str"]],["e"]]],[11,"from_ok","","",685,[[["t"]],["t"]]],[11,"map_same","","",685,[[["self"],["f"]],["t"]]],[11,"to_owned","","",685,[[["self"]],["t"]]],[11,"clone_into","","",685,N],[11,"from","","",685,[[["t"]],["t"]]],[11,"into","","",685,[[["self"]],["u"]]],[11,"try_from","","",685,[[["u"]],["result"]]],[11,"borrow","","",685,[[["self"]],["t"]]],[11,"try_into","","",685,[[["self"]],["result"]]],[11,"borrow_mut","","",685,[[["self"]],["t"]]],[11,"get_type_id","","",685,[[["self"]],["typeid"]]],[11,"not_found","","",685,[[["str"],["str"]],["e"]]],[11,"from_ok","","",686,[[["t"]],["t"]]],[11,"map_same","","",686,[[["self"],["f"]],["t"]]],[11,"from","","",686,[[["t"]],["t"]]],[11,"into","","",686,[[["self"]],["u"]]],[11,"try_from","","",686,[[["u"]],["result"]]],[11,"borrow","","",686,[[["self"]],["t"]]],[11,"try_into","","",686,[[["self"]],["result"]]],[11,"borrow_mut","","",686,[[["self"]],["t"]]],[11,"get_type_id","","",686,[[["self"]],["typeid"]]],[11,"not_found","","",686,[[["str"],["str"]],["e"]]],[11,"from_ok","","",687,[[["t"]],["t"]]],[11,"map_same","","",687,[[["self"],["f"]],["t"]]],[11,"to_owned","","",687,[[["self"]],["t"]]],[11,"clone_into","","",687,N],[11,"from","","",687,[[["t"]],["t"]]],[11,"into","","",687,[[["self"]],["u"]]],[11,"try_from","","",687,[[["u"]],["result"]]],[11,"borrow","","",687,[[["self"]],["t"]]],[11,"try_into","","",687,[[["self"]],["result"]]],[11,"borrow_mut","","",687,[[["self"]],["t"]]],[11,"get_type_id","","",687,[[["self"]],["typeid"]]],[11,"not_found","","",687,[[["str"],["str"]],["e"]]],[11,"from_ok","","",688,[[["t"]],["t"]]],[11,"map_same","","",688,[[["self"],["f"]],["t"]]],[11,"to_owned","","",688,[[["self"]],["t"]]],[11,"clone_into","","",688,N],[11,"from","","",688,[[["t"]],["t"]]],[11,"into","","",688,[[["self"]],["u"]]],[11,"try_from","","",688,[[["u"]],["result"]]],[11,"borrow","","",688,[[["self"]],["t"]]],[11,"try_into","","",688,[[["self"]],["result"]]],[11,"borrow_mut","","",688,[[["self"]],["t"]]],[11,"get_type_id","","",688,[[["self"]],["typeid"]]],[11,"not_found","","",688,[[["str"],["str"]],["e"]]],[11,"from_ok","","",689,[[["t"]],["t"]]],[11,"map_same","","",689,[[["self"],["f"]],["t"]]],[11,"from","","",689,[[["t"]],["t"]]],[11,"to_string","","",689,[[["self"]],["string"]]],[11,"into","","",689,[[["self"]],["u"]]],[11,"try_from","","",689,[[["u"]],["result"]]],[11,"borrow","","",689,[[["self"]],["t"]]],[11,"try_into","","",689,[[["self"]],["result"]]],[11,"borrow_mut","","",689,[[["self"]],["t"]]],[11,"get_type_id","","",689,[[["self"]],["typeid"]]],[11,"not_found","","",689,[[["str"],["str"]],["e"]]],[11,"from_ok","","",690,[[["t"]],["t"]]],[11,"map_same","","",690,[[["self"],["f"]],["t"]]],[11,"from","","",690,[[["t"]],["t"]]],[11,"into","","",690,[[["self"]],["u"]]],[11,"try_from","","",690,[[["u"]],["result"]]],[11,"borrow","","",690,[[["self"]],["t"]]],[11,"try_into","","",690,[[["self"]],["result"]]],[11,"borrow_mut","","",690,[[["self"]],["t"]]],[11,"get_type_id","","",690,[[["self"]],["typeid"]]],[11,"encode","","",690,[[["self"],["e"]],["result"]]],[11,"not_found","","",690,[[["str"],["str"]],["e"]]],[11,"from_ok","","",691,[[["t"]],["t"]]],[11,"map_same","","",691,[[["self"],["f"]],["t"]]],[11,"to_owned","","",691,[[["self"]],["t"]]],[11,"clone_into","","",691,N],[11,"from","","",691,[[["t"]],["t"]]],[11,"into","","",691,[[["self"]],["u"]]],[11,"try_from","","",691,[[["u"]],["result"]]],[11,"borrow","","",691,[[["self"]],["t"]]],[11,"try_into","","",691,[[["self"]],["result"]]],[11,"borrow_mut","","",691,[[["self"]],["t"]]],[11,"get_type_id","","",691,[[["self"]],["typeid"]]],[11,"encode","","",691,[[["self"],["e"]],["result"]]],[11,"decode","","",691,[[["d"]],["result"]]],[11,"not_found","","",691,[[["str"],["str"]],["e"]]],[11,"from_ok","","",692,[[["t"]],["t"]]],[11,"map_same","","",692,[[["self"],["f"]],["t"]]],[11,"to_owned","","",692,[[["self"]],["t"]]],[11,"clone_into","","",692,N],[11,"from","","",692,[[["t"]],["t"]]],[11,"into","","",692,[[["self"]],["u"]]],[11,"try_from","","",692,[[["u"]],["result"]]],[11,"borrow","","",692,[[["self"]],["t"]]],[11,"try_into","","",692,[[["self"]],["result"]]],[11,"borrow_mut","","",692,[[["self"]],["t"]]],[11,"get_type_id","","",692,[[["self"]],["typeid"]]],[11,"encode","","",692,[[["self"],["e"]],["result"]]],[11,"decode","","",692,[[["d"]],["result"]]],[11,"not_found","","",692,[[["str"],["str"]],["e"]]],[11,"from_ok","","",693,[[["t"]],["t"]]],[11,"map_same","","",693,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",693,N],[11,"to_owned","","",693,[[["self"]],["t"]]],[11,"clone_into","","",693,N],[11,"from","","",693,[[["t"]],["t"]]],[11,"into","","",693,[[["self"]],["u"]]],[11,"try_from","","",693,[[["u"]],["result"]]],[11,"borrow","","",693,[[["self"]],["t"]]],[11,"try_into","","",693,[[["self"]],["result"]]],[11,"borrow_mut","","",693,[[["self"]],["t"]]],[11,"get_type_id","","",693,[[["self"]],["typeid"]]],[11,"not_found","","",693,[[["str"],["str"]],["e"]]],[11,"from_ok","","",694,[[["t"]],["t"]]],[11,"map_same","","",694,[[["self"],["f"]],["t"]]],[11,"to_owned","","",694,[[["self"]],["t"]]],[11,"clone_into","","",694,N],[11,"from","","",694,[[["t"]],["t"]]],[11,"into","","",694,[[["self"]],["u"]]],[11,"try_from","","",694,[[["u"]],["result"]]],[11,"borrow","","",694,[[["self"]],["t"]]],[11,"try_into","","",694,[[["self"]],["result"]]],[11,"borrow_mut","","",694,[[["self"]],["t"]]],[11,"get_type_id","","",694,[[["self"]],["typeid"]]],[11,"not_found","","",694,[[["str"],["str"]],["e"]]],[11,"unify_values","","",694,[[["t"],["t"]],["result"]]],[11,"from_ok","","",695,[[["t"]],["t"]]],[11,"map_same","","",695,[[["self"],["f"]],["t"]]],[11,"to_owned","","",695,[[["self"]],["t"]]],[11,"clone_into","","",695,N],[11,"from","","",695,[[["t"]],["t"]]],[11,"into","","",695,[[["self"]],["u"]]],[11,"try_from","","",695,[[["u"]],["result"]]],[11,"borrow","","",695,[[["self"]],["t"]]],[11,"try_into","","",695,[[["self"]],["result"]]],[11,"borrow_mut","","",695,[[["self"]],["t"]]],[11,"get_type_id","","",695,[[["self"]],["typeid"]]],[11,"encode","","",695,[[["self"],["e"]],["result"]]],[11,"decode","","",695,[[["d"]],["result"]]],[11,"not_found","","",695,[[["str"],["str"]],["e"]]],[11,"from_ok","","",696,[[["t"]],["t"]]],[11,"map_same","","",696,[[["self"],["f"]],["t"]]],[11,"from","","",696,[[["t"]],["t"]]],[11,"into","","",696,[[["self"]],["u"]]],[11,"try_from","","",696,[[["u"]],["result"]]],[11,"borrow","","",696,[[["self"]],["t"]]],[11,"try_into","","",696,[[["self"]],["result"]]],[11,"borrow_mut","","",696,[[["self"]],["t"]]],[11,"get_type_id","","",696,[[["self"]],["typeid"]]],[11,"not_found","","",696,[[["str"],["str"]],["e"]]],[11,"from_ok","","",697,[[["t"]],["t"]]],[11,"map_same","","",697,[[["self"],["f"]],["t"]]],[11,"to_owned","","",697,[[["self"]],["t"]]],[11,"clone_into","","",697,N],[11,"from","","",697,[[["t"]],["t"]]],[11,"into","","",697,[[["self"]],["u"]]],[11,"try_from","","",697,[[["u"]],["result"]]],[11,"borrow","","",697,[[["self"]],["t"]]],[11,"try_into","","",697,[[["self"]],["result"]]],[11,"borrow_mut","","",697,[[["self"]],["t"]]],[11,"get_type_id","","",697,[[["self"]],["typeid"]]],[11,"encode","","",697,[[["self"],["e"]],["result"]]],[11,"decode","","",697,[[["d"]],["result"]]],[11,"not_found","","",697,[[["str"],["str"]],["e"]]],[11,"from_ok","","",698,[[["t"]],["t"]]],[11,"map_same","","",698,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",698,N],[11,"to_owned","","",698,[[["self"]],["t"]]],[11,"clone_into","","",698,N],[11,"from","","",698,[[["t"]],["t"]]],[11,"into","","",698,[[["self"]],["u"]]],[11,"try_from","","",698,[[["u"]],["result"]]],[11,"borrow","","",698,[[["self"]],["t"]]],[11,"try_into","","",698,[[["self"]],["result"]]],[11,"borrow_mut","","",698,[[["self"]],["t"]]],[11,"get_type_id","","",698,[[["self"]],["typeid"]]],[11,"encode","","",698,[[["self"],["e"]],["result"]]],[11,"decode","","",698,[[["d"]],["result"]]],[11,"not_found","","",698,[[["str"],["str"]],["e"]]],[11,"from_ok","","",699,[[["t"]],["t"]]],[11,"map_same","","",699,[[["self"],["f"]],["t"]]],[11,"from","","",699,[[["t"]],["t"]]],[11,"into","","",699,[[["self"]],["u"]]],[11,"try_from","","",699,[[["u"]],["result"]]],[11,"borrow","","",699,[[["self"]],["t"]]],[11,"try_into","","",699,[[["self"]],["result"]]],[11,"borrow_mut","","",699,[[["self"]],["t"]]],[11,"get_type_id","","",699,[[["self"]],["typeid"]]],[11,"not_found","","",699,[[["str"],["str"]],["e"]]],[11,"from_ok","","",700,[[["t"]],["t"]]],[11,"map_same","","",700,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",700,N],[11,"to_owned","","",700,[[["self"]],["t"]]],[11,"clone_into","","",700,N],[11,"from","","",700,[[["t"]],["t"]]],[11,"to_string","","",700,[[["self"]],["string"]]],[11,"into","","",700,[[["self"]],["u"]]],[11,"try_from","","",700,[[["u"]],["result"]]],[11,"borrow","","",700,[[["self"]],["t"]]],[11,"try_into","","",700,[[["self"]],["result"]]],[11,"borrow_mut","","",700,[[["self"]],["t"]]],[11,"get_type_id","","",700,[[["self"]],["typeid"]]],[11,"encode","","",700,[[["self"],["e"]],["result"]]],[11,"decode","","",700,[[["d"]],["result"]]],[11,"not_found","","",700,[[["str"],["str"]],["e"]]],[11,"from_ok","","",701,[[["t"]],["t"]]],[11,"map_same","","",701,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",701,N],[11,"to_owned","","",701,[[["self"]],["t"]]],[11,"clone_into","","",701,N],[11,"from","","",701,[[["t"]],["t"]]],[11,"to_string","","",701,[[["self"]],["string"]]],[11,"into","","",701,[[["self"]],["u"]]],[11,"try_from","","",701,[[["u"]],["result"]]],[11,"borrow","","",701,[[["self"]],["t"]]],[11,"try_into","","",701,[[["self"]],["result"]]],[11,"borrow_mut","","",701,[[["self"]],["t"]]],[11,"get_type_id","","",701,[[["self"]],["typeid"]]],[11,"encode","","",701,[[["self"],["e"]],["result"]]],[11,"decode","","",701,[[["d"]],["result"]]],[11,"not_found","","",701,[[["str"],["str"]],["e"]]],[11,"from_ok","","",702,[[["t"]],["t"]]],[11,"map_same","","",702,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",702,N],[11,"to_owned","","",702,[[["self"]],["t"]]],[11,"clone_into","","",702,N],[11,"from","","",702,[[["t"]],["t"]]],[11,"to_string","","",702,[[["self"]],["string"]]],[11,"into","","",702,[[["self"]],["u"]]],[11,"try_from","","",702,[[["u"]],["result"]]],[11,"borrow","","",702,[[["self"]],["t"]]],[11,"try_into","","",702,[[["self"]],["result"]]],[11,"borrow_mut","","",702,[[["self"]],["t"]]],[11,"get_type_id","","",702,[[["self"]],["typeid"]]],[11,"encode","","",702,[[["self"],["e"]],["result"]]],[11,"decode","","",702,[[["d"]],["result"]]],[11,"not_found","","",702,[[["str"],["str"]],["e"]]],[11,"from_ok","","",703,[[["t"]],["t"]]],[11,"map_same","","",703,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",703,N],[11,"to_owned","","",703,[[["self"]],["t"]]],[11,"clone_into","","",703,N],[11,"from","","",703,[[["t"]],["t"]]],[11,"to_string","","",703,[[["self"]],["string"]]],[11,"into","","",703,[[["self"]],["u"]]],[11,"try_from","","",703,[[["u"]],["result"]]],[11,"borrow","","",703,[[["self"]],["t"]]],[11,"try_into","","",703,[[["self"]],["result"]]],[11,"borrow_mut","","",703,[[["self"]],["t"]]],[11,"get_type_id","","",703,[[["self"]],["typeid"]]],[11,"encode","","",703,[[["self"],["e"]],["result"]]],[11,"decode","","",703,[[["d"]],["result"]]],[11,"not_found","","",703,[[["str"],["str"]],["e"]]],[11,"from_ok","","",704,[[["t"]],["t"]]],[11,"map_same","","",704,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",704,N],[11,"to_owned","","",704,[[["self"]],["t"]]],[11,"clone_into","","",704,N],[11,"from","","",704,[[["t"]],["t"]]],[11,"into","","",704,[[["self"]],["u"]]],[11,"try_from","","",704,[[["u"]],["result"]]],[11,"borrow","","",704,[[["self"]],["t"]]],[11,"try_into","","",704,[[["self"]],["result"]]],[11,"borrow_mut","","",704,[[["self"]],["t"]]],[11,"get_type_id","","",704,[[["self"]],["typeid"]]],[11,"not_found","","",704,[[["str"],["str"]],["e"]]],[11,"from_ok","","",705,[[["t"]],["t"]]],[11,"map_same","","",705,[[["self"],["f"]],["t"]]],[11,"to_owned","","",705,[[["self"]],["t"]]],[11,"clone_into","","",705,N],[11,"from","","",705,[[["t"]],["t"]]],[11,"into","","",705,[[["self"]],["u"]]],[11,"try_from","","",705,[[["u"]],["result"]]],[11,"borrow","","",705,[[["self"]],["t"]]],[11,"try_into","","",705,[[["self"]],["result"]]],[11,"borrow_mut","","",705,[[["self"]],["t"]]],[11,"get_type_id","","",705,[[["self"]],["typeid"]]],[11,"encode","","",705,[[["self"],["e"]],["result"]]],[11,"decode","","",705,[[["d"]],["result"]]],[11,"not_found","","",705,[[["str"],["str"]],["e"]]],[11,"from_ok","","",706,[[["t"]],["t"]]],[11,"map_same","","",706,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",706,N],[11,"to_owned","","",706,[[["self"]],["t"]]],[11,"clone_into","","",706,N],[11,"from","","",706,[[["t"]],["t"]]],[11,"into","","",706,[[["self"]],["u"]]],[11,"try_from","","",706,[[["u"]],["result"]]],[11,"borrow","","",706,[[["self"]],["t"]]],[11,"try_into","","",706,[[["self"]],["result"]]],[11,"borrow_mut","","",706,[[["self"]],["t"]]],[11,"get_type_id","","",706,[[["self"]],["typeid"]]],[11,"not_found","","",706,[[["str"],["str"]],["e"]]],[11,"from_ok","","",707,[[["t"]],["t"]]],[11,"map_same","","",707,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",707,N],[11,"to_owned","","",707,[[["self"]],["t"]]],[11,"clone_into","","",707,N],[11,"from","","",707,[[["t"]],["t"]]],[11,"into","","",707,[[["self"]],["u"]]],[11,"try_from","","",707,[[["u"]],["result"]]],[11,"borrow","","",707,[[["self"]],["t"]]],[11,"try_into","","",707,[[["self"]],["result"]]],[11,"borrow_mut","","",707,[[["self"]],["t"]]],[11,"get_type_id","","",707,[[["self"]],["typeid"]]],[11,"not_found","","",707,[[["str"],["str"]],["e"]]],[11,"from_ok","","",708,[[["t"]],["t"]]],[11,"map_same","","",708,[[["self"],["f"]],["t"]]],[11,"to_owned","","",708,[[["self"]],["t"]]],[11,"clone_into","","",708,N],[11,"from","","",708,[[["t"]],["t"]]],[11,"into","","",708,[[["self"]],["u"]]],[11,"try_from","","",708,[[["u"]],["result"]]],[11,"borrow","","",708,[[["self"]],["t"]]],[11,"try_into","","",708,[[["self"]],["result"]]],[11,"borrow_mut","","",708,[[["self"]],["t"]]],[11,"get_type_id","","",708,[[["self"]],["typeid"]]],[11,"not_found","","",708,[[["str"],["str"]],["e"]]],[11,"from_ok","","",709,[[["t"]],["t"]]],[11,"map_same","","",709,[[["self"],["f"]],["t"]]],[11,"to_owned","","",709,[[["self"]],["t"]]],[11,"clone_into","","",709,N],[11,"from","","",709,[[["t"]],["t"]]],[11,"into","","",709,[[["self"]],["u"]]],[11,"try_from","","",709,[[["u"]],["result"]]],[11,"borrow","","",709,[[["self"]],["t"]]],[11,"try_into","","",709,[[["self"]],["result"]]],[11,"borrow_mut","","",709,[[["self"]],["t"]]],[11,"get_type_id","","",709,[[["self"]],["typeid"]]],[11,"not_found","","",709,[[["str"],["str"]],["e"]]],[11,"from_ok","","",710,[[["t"]],["t"]]],[11,"map_same","","",710,[[["self"],["f"]],["t"]]],[11,"to_owned","","",710,[[["self"]],["t"]]],[11,"clone_into","","",710,N],[11,"from","","",710,[[["t"]],["t"]]],[11,"into","","",710,[[["self"]],["u"]]],[11,"try_from","","",710,[[["u"]],["result"]]],[11,"borrow","","",710,[[["self"]],["t"]]],[11,"try_into","","",710,[[["self"]],["result"]]],[11,"borrow_mut","","",710,[[["self"]],["t"]]],[11,"get_type_id","","",710,[[["self"]],["typeid"]]],[11,"not_found","","",710,[[["str"],["str"]],["e"]]],[11,"from_ok","","",711,[[["t"]],["t"]]],[11,"map_same","","",711,[[["self"],["f"]],["t"]]],[11,"from","","",711,[[["t"]],["t"]]],[11,"into","","",711,[[["self"]],["u"]]],[11,"try_from","","",711,[[["u"]],["result"]]],[11,"borrow","","",711,[[["self"]],["t"]]],[11,"try_into","","",711,[[["self"]],["result"]]],[11,"borrow_mut","","",711,[[["self"]],["t"]]],[11,"get_type_id","","",711,[[["self"]],["typeid"]]],[11,"not_found","","",711,[[["str"],["str"]],["e"]]],[11,"from_ok","","",712,[[["t"]],["t"]]],[11,"map_same","","",712,[[["self"],["f"]],["t"]]],[11,"from","","",712,[[["t"]],["t"]]],[11,"into","","",712,[[["self"]],["u"]]],[11,"try_from","","",712,[[["u"]],["result"]]],[11,"borrow","","",712,[[["self"]],["t"]]],[11,"try_into","","",712,[[["self"]],["result"]]],[11,"borrow_mut","","",712,[[["self"]],["t"]]],[11,"get_type_id","","",712,[[["self"]],["typeid"]]],[11,"not_found","","",712,[[["str"],["str"]],["e"]]],[11,"from_ok","","",713,[[["t"]],["t"]]],[11,"map_same","","",713,[[["self"],["f"]],["t"]]],[11,"from","","",713,[[["t"]],["t"]]],[11,"into","","",713,[[["self"]],["u"]]],[11,"try_from","","",713,[[["u"]],["result"]]],[11,"borrow","","",713,[[["self"]],["t"]]],[11,"try_into","","",713,[[["self"]],["result"]]],[11,"borrow_mut","","",713,[[["self"]],["t"]]],[11,"get_type_id","","",713,[[["self"]],["typeid"]]],[11,"not_found","","",713,[[["str"],["str"]],["e"]]],[11,"from_ok","","",714,[[["t"]],["t"]]],[11,"map_same","","",714,[[["self"],["f"]],["t"]]],[11,"to_owned","","",714,[[["self"]],["t"]]],[11,"clone_into","","",714,N],[11,"from","","",714,[[["t"]],["t"]]],[11,"into","","",714,[[["self"]],["u"]]],[11,"try_from","","",714,[[["u"]],["result"]]],[11,"borrow","","",714,[[["self"]],["t"]]],[11,"try_into","","",714,[[["self"]],["result"]]],[11,"borrow_mut","","",714,[[["self"]],["t"]]],[11,"get_type_id","","",714,[[["self"]],["typeid"]]],[11,"encode","","",714,[[["self"],["e"]],["result"]]],[11,"decode","","",714,[[["d"]],["result"]]],[11,"not_found","","",714,[[["str"],["str"]],["e"]]],[11,"from_ok","","",715,[[["t"]],["t"]]],[11,"map_same","","",715,[[["self"],["f"]],["t"]]],[11,"to_owned","","",715,[[["self"]],["t"]]],[11,"clone_into","","",715,N],[11,"from","","",715,[[["t"]],["t"]]],[11,"into","","",715,[[["self"]],["u"]]],[11,"try_from","","",715,[[["u"]],["result"]]],[11,"borrow","","",715,[[["self"]],["t"]]],[11,"try_into","","",715,[[["self"]],["result"]]],[11,"borrow_mut","","",715,[[["self"]],["t"]]],[11,"get_type_id","","",715,[[["self"]],["typeid"]]],[11,"encode","","",715,[[["self"],["e"]],["result"]]],[11,"decode","","",715,[[["d"]],["result"]]],[11,"not_found","","",715,[[["str"],["str"]],["e"]]],[11,"from_ok","","",716,[[["t"]],["t"]]],[11,"map_same","","",716,[[["self"],["f"]],["t"]]],[11,"to_owned","","",716,[[["self"]],["t"]]],[11,"clone_into","","",716,N],[11,"from","","",716,[[["t"]],["t"]]],[11,"into","","",716,[[["self"]],["u"]]],[11,"try_from","","",716,[[["u"]],["result"]]],[11,"borrow","","",716,[[["self"]],["t"]]],[11,"try_into","","",716,[[["self"]],["result"]]],[11,"borrow_mut","","",716,[[["self"]],["t"]]],[11,"get_type_id","","",716,[[["self"]],["typeid"]]],[11,"not_found","","",716,[[["str"],["str"]],["e"]]],[11,"from_ok","","",717,[[["t"]],["t"]]],[11,"map_same","","",717,[[["self"],["f"]],["t"]]],[11,"to_owned","","",717,[[["self"]],["t"]]],[11,"clone_into","","",717,N],[11,"from","","",717,[[["t"]],["t"]]],[11,"to_string","","",717,[[["self"]],["string"]]],[11,"into","","",717,[[["self"]],["u"]]],[11,"try_from","","",717,[[["u"]],["result"]]],[11,"borrow","","",717,[[["self"]],["t"]]],[11,"try_into","","",717,[[["self"]],["result"]]],[11,"borrow_mut","","",717,[[["self"]],["t"]]],[11,"get_type_id","","",717,[[["self"]],["typeid"]]],[11,"encode","","",717,[[["self"],["e"]],["result"]]],[11,"decode","","",717,[[["d"]],["result"]]],[11,"not_found","","",717,[[["str"],["str"]],["e"]]],[11,"from_ok","","",718,[[["t"]],["t"]]],[11,"map_same","","",718,[[["self"],["f"]],["t"]]],[11,"to_owned","","",718,[[["self"]],["t"]]],[11,"clone_into","","",718,N],[11,"from","","",718,[[["t"]],["t"]]],[11,"to_string","","",718,[[["self"]],["string"]]],[11,"into","","",718,[[["self"]],["u"]]],[11,"try_from","","",718,[[["u"]],["result"]]],[11,"borrow","","",718,[[["self"]],["t"]]],[11,"try_into","","",718,[[["self"]],["result"]]],[11,"borrow_mut","","",718,[[["self"]],["t"]]],[11,"get_type_id","","",718,[[["self"]],["typeid"]]],[11,"encode","","",718,[[["self"],["e"]],["result"]]],[11,"decode","","",718,[[["d"]],["result"]]],[11,"not_found","","",718,[[["str"],["str"]],["e"]]],[11,"from_ok","","",719,[[["t"]],["t"]]],[11,"map_same","","",719,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",719,N],[11,"to_owned","","",719,[[["self"]],["t"]]],[11,"clone_into","","",719,N],[11,"from","","",719,[[["t"]],["t"]]],[11,"into","","",719,[[["self"]],["u"]]],[11,"try_from","","",719,[[["u"]],["result"]]],[11,"borrow","","",719,[[["self"]],["t"]]],[11,"try_into","","",719,[[["self"]],["result"]]],[11,"borrow_mut","","",719,[[["self"]],["t"]]],[11,"get_type_id","","",719,[[["self"]],["typeid"]]],[11,"encode","","",719,[[["self"],["e"]],["result"]]],[11,"decode","","",719,[[["d"]],["result"]]],[11,"not_found","","",719,[[["str"],["str"]],["e"]]],[11,"from_ok","","",720,[[["t"]],["t"]]],[11,"map_same","","",720,[[["self"],["f"]],["t"]]],[11,"to_owned","","",720,[[["self"]],["t"]]],[11,"clone_into","","",720,N],[11,"from","","",720,[[["t"]],["t"]]],[11,"into","","",720,[[["self"]],["u"]]],[11,"try_from","","",720,[[["u"]],["result"]]],[11,"borrow","","",720,[[["self"]],["t"]]],[11,"try_into","","",720,[[["self"]],["result"]]],[11,"borrow_mut","","",720,[[["self"]],["t"]]],[11,"get_type_id","","",720,[[["self"]],["typeid"]]],[11,"not_found","","",720,[[["str"],["str"]],["e"]]],[11,"from_ok","","",721,[[["t"]],["t"]]],[11,"map_same","","",721,[[["self"],["f"]],["t"]]],[11,"to_owned","","",721,[[["self"]],["t"]]],[11,"clone_into","","",721,N],[11,"from","","",721,[[["t"]],["t"]]],[11,"to_string","","",721,[[["self"]],["string"]]],[11,"into","","",721,[[["self"]],["u"]]],[11,"try_from","","",721,[[["u"]],["result"]]],[11,"borrow","","",721,[[["self"]],["t"]]],[11,"try_into","","",721,[[["self"]],["result"]]],[11,"borrow_mut","","",721,[[["self"]],["t"]]],[11,"get_type_id","","",721,[[["self"]],["typeid"]]],[11,"encode","","",721,[[["self"],["e"]],["result"]]],[11,"decode","","",721,[[["d"]],["result"]]],[11,"not_found","","",721,[[["str"],["str"]],["e"]]],[11,"from_ok","","",722,[[["t"]],["t"]]],[11,"map_same","","",722,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",722,N],[11,"to_owned","","",722,[[["self"]],["t"]]],[11,"clone_into","","",722,N],[11,"from","","",722,[[["t"]],["t"]]],[11,"to_string","","",722,[[["self"]],["string"]]],[11,"into","","",722,[[["self"]],["u"]]],[11,"try_from","","",722,[[["u"]],["result"]]],[11,"borrow","","",722,[[["self"]],["t"]]],[11,"try_into","","",722,[[["self"]],["result"]]],[11,"borrow_mut","","",722,[[["self"]],["t"]]],[11,"get_type_id","","",722,[[["self"]],["typeid"]]],[11,"encode","","",722,[[["self"],["e"]],["result"]]],[11,"decode","","",722,[[["d"]],["result"]]],[11,"not_found","","",722,[[["str"],["str"]],["e"]]],[11,"from_ok","","",723,[[["t"]],["t"]]],[11,"map_same","","",723,[[["self"],["f"]],["t"]]],[11,"to_owned","","",723,[[["self"]],["t"]]],[11,"clone_into","","",723,N],[11,"from","","",723,[[["t"]],["t"]]],[11,"to_string","","",723,[[["self"]],["string"]]],[11,"into","","",723,[[["self"]],["u"]]],[11,"try_from","","",723,[[["u"]],["result"]]],[11,"borrow","","",723,[[["self"]],["t"]]],[11,"try_into","","",723,[[["self"]],["result"]]],[11,"borrow_mut","","",723,[[["self"]],["t"]]],[11,"get_type_id","","",723,[[["self"]],["typeid"]]],[11,"encode","","",723,[[["self"],["e"]],["result"]]],[11,"decode","","",723,[[["d"]],["result"]]],[11,"not_found","","",723,[[["str"],["str"]],["e"]]],[11,"from_ok","","",724,[[["t"]],["t"]]],[11,"map_same","","",724,[[["self"],["f"]],["t"]]],[11,"to_owned","","",724,[[["self"]],["t"]]],[11,"clone_into","","",724,N],[11,"from","","",724,[[["t"]],["t"]]],[11,"into","","",724,[[["self"]],["u"]]],[11,"try_from","","",724,[[["u"]],["result"]]],[11,"borrow","","",724,[[["self"]],["t"]]],[11,"try_into","","",724,[[["self"]],["result"]]],[11,"borrow_mut","","",724,[[["self"]],["t"]]],[11,"get_type_id","","",724,[[["self"]],["typeid"]]],[11,"encode","","",724,[[["self"],["e"]],["result"]]],[11,"decode","","",724,[[["d"]],["result"]]],[11,"not_found","","",724,[[["str"],["str"]],["e"]]],[11,"from_ok","","",725,[[["t"]],["t"]]],[11,"map_same","","",725,[[["self"],["f"]],["t"]]],[11,"to_owned","","",725,[[["self"]],["t"]]],[11,"clone_into","","",725,N],[11,"from","","",725,[[["t"]],["t"]]],[11,"into","","",725,[[["self"]],["u"]]],[11,"try_from","","",725,[[["u"]],["result"]]],[11,"borrow","","",725,[[["self"]],["t"]]],[11,"try_into","","",725,[[["self"]],["result"]]],[11,"borrow_mut","","",725,[[["self"]],["t"]]],[11,"get_type_id","","",725,[[["self"]],["typeid"]]],[11,"not_found","","",725,[[["str"],["str"]],["e"]]],[11,"from_ok","","",726,[[["t"]],["t"]]],[11,"map_same","","",726,[[["self"],["f"]],["t"]]],[11,"to_owned","","",726,[[["self"]],["t"]]],[11,"clone_into","","",726,N],[11,"from","","",726,[[["t"]],["t"]]],[11,"into","","",726,[[["self"]],["u"]]],[11,"try_from","","",726,[[["u"]],["result"]]],[11,"borrow","","",726,[[["self"]],["t"]]],[11,"try_into","","",726,[[["self"]],["result"]]],[11,"borrow_mut","","",726,[[["self"]],["t"]]],[11,"get_type_id","","",726,[[["self"]],["typeid"]]],[11,"encode","","",726,[[["self"],["e"]],["result"]]],[11,"decode","","",726,[[["d"]],["result"]]],[11,"not_found","","",726,[[["str"],["str"]],["e"]]],[11,"from_ok","","",727,[[["t"]],["t"]]],[11,"map_same","","",727,[[["self"],["f"]],["t"]]],[11,"to_owned","","",727,[[["self"]],["t"]]],[11,"clone_into","","",727,N],[11,"from","","",727,[[["t"]],["t"]]],[11,"into","","",727,[[["self"]],["u"]]],[11,"try_from","","",727,[[["u"]],["result"]]],[11,"borrow","","",727,[[["self"]],["t"]]],[11,"try_into","","",727,[[["self"]],["result"]]],[11,"borrow_mut","","",727,[[["self"]],["t"]]],[11,"get_type_id","","",727,[[["self"]],["typeid"]]],[11,"encode","","",727,[[["self"],["e"]],["result"]]],[11,"decode","","",727,[[["d"]],["result"]]],[11,"not_found","","",727,[[["str"],["str"]],["e"]]],[11,"from_ok","","",728,[[["t"]],["t"]]],[11,"map_same","","",728,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",728,N],[11,"to_owned","","",728,[[["self"]],["t"]]],[11,"clone_into","","",728,N],[11,"from","","",728,[[["t"]],["t"]]],[11,"into","","",728,[[["self"]],["u"]]],[11,"try_from","","",728,[[["u"]],["result"]]],[11,"borrow","","",728,[[["self"]],["t"]]],[11,"try_into","","",728,[[["self"]],["result"]]],[11,"borrow_mut","","",728,[[["self"]],["t"]]],[11,"get_type_id","","",728,[[["self"]],["typeid"]]],[11,"encode","","",728,[[["self"],["e"]],["result"]]],[11,"decode","","",728,[[["d"]],["result"]]],[11,"not_found","","",728,[[["str"],["str"]],["e"]]],[11,"from_ok","","",729,[[["t"]],["t"]]],[11,"map_same","","",729,[[["self"],["f"]],["t"]]],[11,"to_owned","","",729,[[["self"]],["t"]]],[11,"clone_into","","",729,N],[11,"from","","",729,[[["t"]],["t"]]],[11,"into","","",729,[[["self"]],["u"]]],[11,"try_from","","",729,[[["u"]],["result"]]],[11,"borrow","","",729,[[["self"]],["t"]]],[11,"try_into","","",729,[[["self"]],["result"]]],[11,"borrow_mut","","",729,[[["self"]],["t"]]],[11,"get_type_id","","",729,[[["self"]],["typeid"]]],[11,"encode","","",729,[[["self"],["e"]],["result"]]],[11,"decode","","",729,[[["d"]],["result"]]],[11,"not_found","","",729,[[["str"],["str"]],["e"]]],[11,"from_ok","","",730,[[["t"]],["t"]]],[11,"map_same","","",730,[[["self"],["f"]],["t"]]],[11,"to_owned","","",730,[[["self"]],["t"]]],[11,"clone_into","","",730,N],[11,"from","","",730,[[["t"]],["t"]]],[11,"into","","",730,[[["self"]],["u"]]],[11,"try_from","","",730,[[["u"]],["result"]]],[11,"borrow","","",730,[[["self"]],["t"]]],[11,"try_into","","",730,[[["self"]],["result"]]],[11,"borrow_mut","","",730,[[["self"]],["t"]]],[11,"get_type_id","","",730,[[["self"]],["typeid"]]],[11,"encode","","",730,[[["self"],["e"]],["result"]]],[11,"decode","","",730,[[["d"]],["result"]]],[11,"not_found","","",730,[[["str"],["str"]],["e"]]],[11,"from_ok","","",731,[[["t"]],["t"]]],[11,"map_same","","",731,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",731,N],[11,"to_owned","","",731,[[["self"]],["t"]]],[11,"clone_into","","",731,N],[11,"from","","",731,[[["t"]],["t"]]],[11,"into","","",731,[[["self"]],["u"]]],[11,"try_from","","",731,[[["u"]],["result"]]],[11,"borrow","","",731,[[["self"]],["t"]]],[11,"try_into","","",731,[[["self"]],["result"]]],[11,"borrow_mut","","",731,[[["self"]],["t"]]],[11,"get_type_id","","",731,[[["self"]],["typeid"]]],[11,"not_found","","",731,[[["str"],["str"]],["e"]]],[11,"unify_values","","",731,[[["t"],["t"]],["result"]]],[11,"from_ok","","",732,[[["t"]],["t"]]],[11,"map_same","","",732,[[["self"],["f"]],["t"]]],[11,"to_owned","","",732,[[["self"]],["t"]]],[11,"clone_into","","",732,N],[11,"from","","",732,[[["t"]],["t"]]],[11,"into","","",732,[[["self"]],["u"]]],[11,"try_from","","",732,[[["u"]],["result"]]],[11,"borrow","","",732,[[["self"]],["t"]]],[11,"try_into","","",732,[[["self"]],["result"]]],[11,"borrow_mut","","",732,[[["self"]],["t"]]],[11,"get_type_id","","",732,[[["self"]],["typeid"]]],[11,"encode","","",732,[[["self"],["e"]],["result"]]],[11,"decode","","",732,[[["d"]],["result"]]],[11,"not_found","","",732,[[["str"],["str"]],["e"]]],[11,"from_ok","","",733,[[["t"]],["t"]]],[11,"map_same","","",733,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",733,N],[11,"to_owned","","",733,[[["self"]],["t"]]],[11,"clone_into","","",733,N],[11,"from","","",733,[[["t"]],["t"]]],[11,"to_string","","",733,[[["self"]],["string"]]],[11,"into","","",733,[[["self"]],["u"]]],[11,"try_from","","",733,[[["u"]],["result"]]],[11,"borrow","","",733,[[["self"]],["t"]]],[11,"try_into","","",733,[[["self"]],["result"]]],[11,"borrow_mut","","",733,[[["self"]],["t"]]],[11,"get_type_id","","",733,[[["self"]],["typeid"]]],[11,"encode","","",733,[[["self"],["e"]],["result"]]],[11,"decode","","",733,[[["d"]],["result"]]],[11,"not_found","","",733,[[["str"],["str"]],["e"]]],[11,"from_ok","","",734,[[["t"]],["t"]]],[11,"map_same","","",734,[[["self"],["f"]],["t"]]],[11,"to_owned","","",734,[[["self"]],["t"]]],[11,"clone_into","","",734,N],[11,"from","","",734,[[["t"]],["t"]]],[11,"into","","",734,[[["self"]],["u"]]],[11,"try_from","","",734,[[["u"]],["result"]]],[11,"borrow","","",734,[[["self"]],["t"]]],[11,"try_into","","",734,[[["self"]],["result"]]],[11,"borrow_mut","","",734,[[["self"]],["t"]]],[11,"get_type_id","","",734,[[["self"]],["typeid"]]],[11,"encode","","",734,[[["self"],["e"]],["result"]]],[11,"decode","","",734,[[["d"]],["result"]]],[11,"not_found","","",734,[[["str"],["str"]],["e"]]],[11,"from_ok","","",735,[[["t"]],["t"]]],[11,"map_same","","",735,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",735,N],[11,"to_owned","","",735,[[["self"]],["t"]]],[11,"clone_into","","",735,N],[11,"from","","",735,[[["t"]],["t"]]],[11,"into","","",735,[[["self"]],["u"]]],[11,"try_from","","",735,[[["u"]],["result"]]],[11,"borrow","","",735,[[["self"]],["t"]]],[11,"try_into","","",735,[[["self"]],["result"]]],[11,"borrow_mut","","",735,[[["self"]],["t"]]],[11,"get_type_id","","",735,[[["self"]],["typeid"]]],[11,"not_found","","",735,[[["str"],["str"]],["e"]]],[11,"from_ok","","",736,[[["t"]],["t"]]],[11,"map_same","","",736,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",736,N],[11,"to_owned","","",736,[[["self"]],["t"]]],[11,"clone_into","","",736,N],[11,"from","","",736,[[["t"]],["t"]]],[11,"to_string","","",736,[[["self"]],["string"]]],[11,"into","","",736,[[["self"]],["u"]]],[11,"try_from","","",736,[[["u"]],["result"]]],[11,"borrow","","",736,[[["self"]],["t"]]],[11,"try_into","","",736,[[["self"]],["result"]]],[11,"borrow_mut","","",736,[[["self"]],["t"]]],[11,"get_type_id","","",736,[[["self"]],["typeid"]]],[11,"encode","","",736,[[["self"],["e"]],["result"]]],[11,"decode","","",736,[[["d"]],["result"]]],[11,"not_found","","",736,[[["str"],["str"]],["e"]]],[11,"from_ok","","",737,[[["t"]],["t"]]],[11,"map_same","","",737,[[["self"],["f"]],["t"]]],[11,"to_owned","","",737,[[["self"]],["t"]]],[11,"clone_into","","",737,N],[11,"from","","",737,[[["t"]],["t"]]],[11,"into","","",737,[[["self"]],["u"]]],[11,"try_from","","",737,[[["u"]],["result"]]],[11,"borrow","","",737,[[["self"]],["t"]]],[11,"try_into","","",737,[[["self"]],["result"]]],[11,"borrow_mut","","",737,[[["self"]],["t"]]],[11,"get_type_id","","",737,[[["self"]],["typeid"]]],[11,"not_found","","",737,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::tls","",738,[[["t"]],["t"]]],[11,"map_same","","",738,[[["self"],["f"]],["t"]]],[11,"to_owned","","",738,[[["self"]],["t"]]],[11,"clone_into","","",738,N],[11,"from","","",738,[[["t"]],["t"]]],[11,"into","","",738,[[["self"]],["u"]]],[11,"try_from","","",738,[[["u"]],["result"]]],[11,"borrow","","",738,[[["self"]],["t"]]],[11,"try_into","","",738,[[["self"]],["result"]]],[11,"borrow_mut","","",738,[[["self"]],["t"]]],[11,"get_type_id","","",738,[[["self"]],["typeid"]]],[11,"not_found","","",738,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::adjustment","",739,[[["t"]],["t"]]],[11,"map_same","","",739,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",739,N],[11,"to_owned","","",739,[[["self"]],["t"]]],[11,"clone_into","","",739,N],[11,"from","","",739,[[["t"]],["t"]]],[11,"into","","",739,[[["self"]],["u"]]],[11,"try_from","","",739,[[["u"]],["result"]]],[11,"borrow","","",739,[[["self"]],["t"]]],[11,"try_into","","",739,[[["self"]],["result"]]],[11,"borrow_mut","","",739,[[["self"]],["t"]]],[11,"get_type_id","","",739,[[["self"]],["typeid"]]],[11,"encode","","",739,[[["self"],["e"]],["result"]]],[11,"decode","","",739,[[["d"]],["result"]]],[11,"not_found","","",739,[[["str"],["str"]],["e"]]],[11,"from_ok","","",740,[[["t"]],["t"]]],[11,"map_same","","",740,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",740,N],[11,"to_owned","","",740,[[["self"]],["t"]]],[11,"clone_into","","",740,N],[11,"from","","",740,[[["t"]],["t"]]],[11,"into","","",740,[[["self"]],["u"]]],[11,"try_from","","",740,[[["u"]],["result"]]],[11,"borrow","","",740,[[["self"]],["t"]]],[11,"try_into","","",740,[[["self"]],["result"]]],[11,"borrow_mut","","",740,[[["self"]],["t"]]],[11,"get_type_id","","",740,[[["self"]],["typeid"]]],[11,"encode","","",740,[[["self"],["e"]],["result"]]],[11,"decode","","",740,[[["d"]],["result"]]],[11,"not_found","","",740,[[["str"],["str"]],["e"]]],[11,"from_ok","","",741,[[["t"]],["t"]]],[11,"map_same","","",741,[[["self"],["f"]],["t"]]],[11,"to_owned","","",741,[[["self"]],["t"]]],[11,"clone_into","","",741,N],[11,"from","","",741,[[["t"]],["t"]]],[11,"into","","",741,[[["self"]],["u"]]],[11,"try_from","","",741,[[["u"]],["result"]]],[11,"borrow","","",741,[[["self"]],["t"]]],[11,"try_into","","",741,[[["self"]],["result"]]],[11,"borrow_mut","","",741,[[["self"]],["t"]]],[11,"get_type_id","","",741,[[["self"]],["typeid"]]],[11,"encode","","",741,[[["self"],["e"]],["result"]]],[11,"decode","","",741,[[["d"]],["result"]]],[11,"not_found","","",741,[[["str"],["str"]],["e"]]],[11,"from_ok","","",742,[[["t"]],["t"]]],[11,"map_same","","",742,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",742,N],[11,"to_owned","","",742,[[["self"]],["t"]]],[11,"clone_into","","",742,N],[11,"from","","",742,[[["t"]],["t"]]],[11,"into","","",742,[[["self"]],["u"]]],[11,"try_from","","",742,[[["u"]],["result"]]],[11,"borrow","","",742,[[["self"]],["t"]]],[11,"try_into","","",742,[[["self"]],["result"]]],[11,"borrow_mut","","",742,[[["self"]],["t"]]],[11,"get_type_id","","",742,[[["self"]],["typeid"]]],[11,"encode","","",742,[[["self"],["e"]],["result"]]],[11,"decode","","",742,[[["d"]],["result"]]],[11,"not_found","","",742,[[["str"],["str"]],["e"]]],[11,"from_ok","","",743,[[["t"]],["t"]]],[11,"map_same","","",743,[[["self"],["f"]],["t"]]],[11,"to_owned","","",743,[[["self"]],["t"]]],[11,"clone_into","","",743,N],[11,"from","","",743,[[["t"]],["t"]]],[11,"into","","",743,[[["self"]],["u"]]],[11,"try_from","","",743,[[["u"]],["result"]]],[11,"borrow","","",743,[[["self"]],["t"]]],[11,"try_into","","",743,[[["self"]],["result"]]],[11,"borrow_mut","","",743,[[["self"]],["t"]]],[11,"get_type_id","","",743,[[["self"]],["typeid"]]],[11,"encode","","",743,[[["self"],["e"]],["result"]]],[11,"decode","","",743,[[["d"]],["result"]]],[11,"not_found","","",743,[[["str"],["str"]],["e"]]],[11,"from_ok","","",744,[[["t"]],["t"]]],[11,"map_same","","",744,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",744,N],[11,"to_owned","","",744,[[["self"]],["t"]]],[11,"clone_into","","",744,N],[11,"from","","",744,[[["t"]],["t"]]],[11,"into","","",744,[[["self"]],["u"]]],[11,"try_from","","",744,[[["u"]],["result"]]],[11,"borrow","","",744,[[["self"]],["t"]]],[11,"try_into","","",744,[[["self"]],["result"]]],[11,"borrow_mut","","",744,[[["self"]],["t"]]],[11,"get_type_id","","",744,[[["self"]],["typeid"]]],[11,"encode","","",744,[[["self"],["e"]],["result"]]],[11,"decode","","",744,[[["d"]],["result"]]],[11,"not_found","","",744,[[["str"],["str"]],["e"]]],[11,"from_ok","","",745,[[["t"]],["t"]]],[11,"map_same","","",745,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",745,N],[11,"to_owned","","",745,[[["self"]],["t"]]],[11,"clone_into","","",745,N],[11,"from","","",745,[[["t"]],["t"]]],[11,"into","","",745,[[["self"]],["u"]]],[11,"try_from","","",745,[[["u"]],["result"]]],[11,"borrow","","",745,[[["self"]],["t"]]],[11,"try_into","","",745,[[["self"]],["result"]]],[11,"borrow_mut","","",745,[[["self"]],["t"]]],[11,"get_type_id","","",745,[[["self"]],["typeid"]]],[11,"encode","","",745,[[["self"],["e"]],["result"]]],[11,"decode","","",745,[[["d"]],["result"]]],[11,"not_found","","",745,[[["str"],["str"]],["e"]]],[11,"from_ok","","",746,[[["t"]],["t"]]],[11,"map_same","","",746,[[["self"],["f"]],["t"]]],[11,"to_owned","","",746,[[["self"]],["t"]]],[11,"clone_into","","",746,N],[11,"from","","",746,[[["t"]],["t"]]],[11,"into","","",746,[[["self"]],["u"]]],[11,"try_from","","",746,[[["u"]],["result"]]],[11,"borrow","","",746,[[["self"]],["t"]]],[11,"try_into","","",746,[[["self"]],["result"]]],[11,"borrow_mut","","",746,[[["self"]],["t"]]],[11,"get_type_id","","",746,[[["self"]],["typeid"]]],[11,"encode","","",746,[[["self"],["e"]],["result"]]],[11,"decode","","",746,[[["d"]],["result"]]],[11,"not_found","","",746,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::binding","",747,[[["t"]],["t"]]],[11,"map_same","","",747,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",747,N],[11,"to_owned","","",747,[[["self"]],["t"]]],[11,"clone_into","","",747,N],[11,"from","","",747,[[["t"]],["t"]]],[11,"into","","",747,[[["self"]],["u"]]],[11,"try_from","","",747,[[["u"]],["result"]]],[11,"borrow","","",747,[[["self"]],["t"]]],[11,"try_into","","",747,[[["self"]],["result"]]],[11,"borrow_mut","","",747,[[["self"]],["t"]]],[11,"get_type_id","","",747,[[["self"]],["typeid"]]],[11,"encode","","",747,[[["self"],["e"]],["result"]]],[11,"decode","","",747,[[["d"]],["result"]]],[11,"not_found","","",747,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::cast","",748,[[["t"]],["t"]]],[11,"map_same","","",748,[[["self"],["f"]],["t"]]],[11,"to_owned","","",748,[[["self"]],["t"]]],[11,"clone_into","","",748,N],[11,"from","","",748,[[["t"]],["t"]]],[11,"into","","",748,[[["self"]],["u"]]],[11,"try_from","","",748,[[["u"]],["result"]]],[11,"borrow","","",748,[[["self"]],["t"]]],[11,"try_into","","",748,[[["self"]],["result"]]],[11,"borrow_mut","","",748,[[["self"]],["t"]]],[11,"get_type_id","","",748,[[["self"]],["typeid"]]],[11,"not_found","","",748,[[["str"],["str"]],["e"]]],[11,"from_ok","","",749,[[["t"]],["t"]]],[11,"map_same","","",749,[[["self"],["f"]],["t"]]],[11,"to_owned","","",749,[[["self"]],["t"]]],[11,"clone_into","","",749,N],[11,"from","","",749,[[["t"]],["t"]]],[11,"into","","",749,[[["self"]],["u"]]],[11,"try_from","","",749,[[["u"]],["result"]]],[11,"borrow","","",749,[[["self"]],["t"]]],[11,"try_into","","",749,[[["self"]],["result"]]],[11,"borrow_mut","","",749,[[["self"]],["t"]]],[11,"get_type_id","","",749,[[["self"]],["typeid"]]],[11,"not_found","","",749,[[["str"],["str"]],["e"]]],[11,"from_ok","","",750,[[["t"]],["t"]]],[11,"map_same","","",750,[[["self"],["f"]],["t"]]],[11,"to_owned","","",750,[[["self"]],["t"]]],[11,"clone_into","","",750,N],[11,"from","","",750,[[["t"]],["t"]]],[11,"into","","",750,[[["self"]],["u"]]],[11,"try_from","","",750,[[["u"]],["result"]]],[11,"borrow","","",750,[[["self"]],["t"]]],[11,"try_into","","",750,[[["self"]],["result"]]],[11,"borrow_mut","","",750,[[["self"]],["t"]]],[11,"get_type_id","","",750,[[["self"]],["typeid"]]],[11,"encode","","",750,[[["self"],["e"]],["result"]]],[11,"decode","","",750,[[["d"]],["result"]]],[11,"not_found","","",750,[[["str"],["str"]],["e"]]],[11,"variant","rustc::ty","",1061,N],[11,"from_ok","rustc::ty::error","",754,[[["t"]],["t"]]],[11,"map_same","","",754,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",754,N],[11,"to_owned","","",754,[[["self"]],["t"]]],[11,"clone_into","","",754,N],[11,"from","","",754,[[["t"]],["t"]]],[11,"into","","",754,[[["self"]],["u"]]],[11,"try_from","","",754,[[["u"]],["result"]]],[11,"borrow","","",754,[[["self"]],["t"]]],[11,"try_into","","",754,[[["self"]],["result"]]],[11,"borrow_mut","","",754,[[["self"]],["t"]]],[11,"get_type_id","","",754,[[["self"]],["typeid"]]],[11,"not_found","","",754,[[["str"],["str"]],["e"]]],[11,"from_ok","","",755,[[["t"]],["t"]]],[11,"map_same","","",755,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",755,N],[11,"to_owned","","",755,[[["self"]],["t"]]],[11,"clone_into","","",755,N],[11,"from","","",755,[[["t"]],["t"]]],[11,"to_string","","",755,[[["self"]],["string"]]],[11,"into","","",755,[[["self"]],["u"]]],[11,"try_from","","",755,[[["u"]],["result"]]],[11,"borrow","","",755,[[["self"]],["t"]]],[11,"try_into","","",755,[[["self"]],["result"]]],[11,"borrow_mut","","",755,[[["self"]],["t"]]],[11,"get_type_id","","",755,[[["self"]],["typeid"]]],[11,"not_found","","",755,[[["str"],["str"]],["e"]]],[11,"from_ok","","",756,[[["t"]],["t"]]],[11,"map_same","","",756,[[["self"],["f"]],["t"]]],[11,"to_owned","","",756,[[["self"]],["t"]]],[11,"clone_into","","",756,N],[11,"from","","",756,[[["t"]],["t"]]],[11,"into","","",756,[[["self"]],["u"]]],[11,"try_from","","",756,[[["u"]],["result"]]],[11,"borrow","","",756,[[["self"]],["t"]]],[11,"try_into","","",756,[[["self"]],["result"]]],[11,"borrow_mut","","",756,[[["self"]],["t"]]],[11,"get_type_id","","",756,[[["self"]],["typeid"]]],[11,"encode","","",756,[[["self"],["e"]],["result"]]],[11,"decode","","",756,[[["d"]],["result"]]],[11,"not_found","","",756,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::erase_regions","",757,[[["t"]],["t"]]],[11,"map_same","","",757,[[["self"],["f"]],["t"]]],[11,"from","","",757,[[["t"]],["t"]]],[11,"into","","",757,[[["self"]],["u"]]],[11,"try_from","","",757,[[["u"]],["result"]]],[11,"borrow","","",757,[[["self"]],["t"]]],[11,"try_into","","",757,[[["self"]],["result"]]],[11,"borrow_mut","","",757,[[["self"]],["t"]]],[11,"get_type_id","","",757,[[["self"]],["typeid"]]],[11,"not_found","","",757,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::fast_reject","",758,[[["t"]],["t"]]],[11,"map_same","","",758,[[["self"],["f"]],["t"]]],[11,"to_owned","","",758,[[["self"]],["t"]]],[11,"clone_into","","",758,N],[11,"from","","",758,[[["t"]],["t"]]],[11,"into","","",758,[[["self"]],["u"]]],[11,"try_from","","",758,[[["u"]],["result"]]],[11,"borrow","","",758,[[["self"]],["t"]]],[11,"try_into","","",758,[[["self"]],["result"]]],[11,"borrow_mut","","",758,[[["self"]],["t"]]],[11,"get_type_id","","",758,[[["self"]],["typeid"]]],[11,"encode","","",758,[[["self"],["e"]],["result"]]],[11,"decode","","",758,[[["d"]],["result"]]],[11,"not_found","","",758,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::fold","",759,[[["t"]],["t"]]],[11,"map_same","","",759,[[["self"],["f"]],["t"]]],[11,"from","","",759,[[["t"]],["t"]]],[11,"into","","",759,[[["self"]],["u"]]],[11,"try_from","","",759,[[["u"]],["result"]]],[11,"borrow","","",759,[[["self"]],["t"]]],[11,"try_into","","",759,[[["self"]],["result"]]],[11,"borrow_mut","","",759,[[["self"]],["t"]]],[11,"get_type_id","","",759,[[["self"]],["typeid"]]],[11,"not_found","","",759,[[["str"],["str"]],["e"]]],[11,"from_ok","","",760,[[["t"]],["t"]]],[11,"map_same","","",760,[[["self"],["f"]],["t"]]],[11,"from","","",760,[[["t"]],["t"]]],[11,"into","","",760,[[["self"]],["u"]]],[11,"try_from","","",760,[[["u"]],["result"]]],[11,"borrow","","",760,[[["self"]],["t"]]],[11,"try_into","","",760,[[["self"]],["result"]]],[11,"borrow_mut","","",760,[[["self"]],["t"]]],[11,"get_type_id","","",760,[[["self"]],["typeid"]]],[11,"not_found","","",760,[[["str"],["str"]],["e"]]],[11,"from_ok","","",761,[[["t"]],["t"]]],[11,"map_same","","",761,[[["self"],["f"]],["t"]]],[11,"from","","",761,[[["t"]],["t"]]],[11,"into","","",761,[[["self"]],["u"]]],[11,"try_from","","",761,[[["u"]],["result"]]],[11,"borrow","","",761,[[["self"]],["t"]]],[11,"try_into","","",761,[[["self"]],["result"]]],[11,"borrow_mut","","",761,[[["self"]],["t"]]],[11,"get_type_id","","",761,[[["self"]],["typeid"]]],[11,"not_found","","",761,[[["str"],["str"]],["e"]]],[11,"from_ok","","",762,[[["t"]],["t"]]],[11,"map_same","","",762,[[["self"],["f"]],["t"]]],[11,"from","","",762,[[["t"]],["t"]]],[11,"into","","",762,[[["self"]],["u"]]],[11,"try_from","","",762,[[["u"]],["result"]]],[11,"borrow","","",762,[[["self"]],["t"]]],[11,"try_into","","",762,[[["self"]],["result"]]],[11,"borrow_mut","","",762,[[["self"]],["t"]]],[11,"get_type_id","","",762,[[["self"]],["typeid"]]],[11,"not_found","","",762,[[["str"],["str"]],["e"]]],[11,"from_ok","","",763,[[["t"]],["t"]]],[11,"map_same","","",763,[[["self"],["f"]],["t"]]],[11,"from","","",763,[[["t"]],["t"]]],[11,"into","","",763,[[["self"]],["u"]]],[11,"try_from","","",763,[[["u"]],["result"]]],[11,"borrow","","",763,[[["self"]],["t"]]],[11,"try_into","","",763,[[["self"]],["result"]]],[11,"borrow_mut","","",763,[[["self"]],["t"]]],[11,"get_type_id","","",763,[[["self"]],["typeid"]]],[11,"not_found","","",763,[[["str"],["str"]],["e"]]],[11,"from_ok","","",764,[[["t"]],["t"]]],[11,"map_same","","",764,[[["self"],["f"]],["t"]]],[11,"from","","",764,[[["t"]],["t"]]],[11,"into","","",764,[[["self"]],["u"]]],[11,"try_from","","",764,[[["u"]],["result"]]],[11,"borrow","","",764,[[["self"]],["t"]]],[11,"try_into","","",764,[[["self"]],["result"]]],[11,"borrow_mut","","",764,[[["self"]],["t"]]],[11,"get_type_id","","",764,[[["self"]],["typeid"]]],[11,"not_found","","",764,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::inhabitedness","",768,[[["t"]],["t"]]],[11,"map_same","","",768,[[["self"],["f"]],["t"]]],[11,"to_owned","","",768,[[["self"]],["t"]]],[11,"clone_into","","",768,N],[11,"from","","",768,[[["t"]],["t"]]],[11,"into","","",768,[[["self"]],["u"]]],[11,"try_from","","",768,[[["u"]],["result"]]],[11,"borrow","","",768,[[["self"]],["t"]]],[11,"try_into","","",768,[[["self"]],["result"]]],[11,"borrow_mut","","",768,[[["self"]],["t"]]],[11,"get_type_id","","",768,[[["self"]],["typeid"]]],[11,"not_found","","",768,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::item_path","",769,[[["t"]],["t"]]],[11,"map_same","","",769,[[["self"],["f"]],["t"]]],[11,"from","","",769,[[["t"]],["t"]]],[11,"into","","",769,[[["self"]],["u"]]],[11,"try_from","","",769,[[["u"]],["result"]]],[11,"borrow","","",769,[[["self"]],["t"]]],[11,"try_into","","",769,[[["self"]],["result"]]],[11,"borrow_mut","","",769,[[["self"]],["t"]]],[11,"get_type_id","","",769,[[["self"]],["typeid"]]],[11,"not_found","","",769,[[["str"],["str"]],["e"]]],[11,"from_ok","","",770,[[["t"]],["t"]]],[11,"map_same","","",770,[[["self"],["f"]],["t"]]],[11,"from","","",770,[[["t"]],["t"]]],[11,"into","","",770,[[["self"]],["u"]]],[11,"try_from","","",770,[[["u"]],["result"]]],[11,"borrow","","",770,[[["self"]],["t"]]],[11,"try_into","","",770,[[["self"]],["result"]]],[11,"borrow_mut","","",770,[[["self"]],["t"]]],[11,"get_type_id","","",770,[[["self"]],["typeid"]]],[11,"not_found","","",770,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::layout::call","",772,[[["t"]],["t"]]],[11,"map_same","","",772,[[["self"],["f"]],["t"]]],[11,"to_owned","","",772,[[["self"]],["t"]]],[11,"clone_into","","",772,N],[11,"from","","",772,[[["t"]],["t"]]],[11,"into","","",772,[[["self"]],["u"]]],[11,"try_from","","",772,[[["u"]],["result"]]],[11,"borrow","","",772,[[["self"]],["t"]]],[11,"try_into","","",772,[[["self"]],["result"]]],[11,"borrow_mut","","",772,[[["self"]],["t"]]],[11,"get_type_id","","",772,[[["self"]],["typeid"]]],[11,"not_found","","",772,[[["str"],["str"]],["e"]]],[11,"new","","",773,[[],["argattributes"]]],[11,"set","","",773,[[["self"],["argattribute"]],["argattributes"]]],[11,"contains","","",773,[[["self"],["argattribute"]],["bool"]]],[11,"from_ok","","",773,[[["t"]],["t"]]],[11,"map_same","","",773,[[["self"],["f"]],["t"]]],[11,"to_owned","","",773,[[["self"]],["t"]]],[11,"clone_into","","",773,N],[11,"from","","",773,[[["t"]],["t"]]],[11,"into","","",773,[[["self"]],["u"]]],[11,"try_from","","",773,[[["u"]],["result"]]],[11,"borrow","","",773,[[["self"]],["t"]]],[11,"try_into","","",773,[[["self"]],["result"]]],[11,"borrow_mut","","",773,[[["self"]],["t"]]],[11,"get_type_id","","",773,[[["self"]],["typeid"]]],[11,"not_found","","",773,[[["str"],["str"]],["e"]]],[11,"from_ok","","",774,[[["t"]],["t"]]],[11,"map_same","","",774,[[["self"],["f"]],["t"]]],[11,"to_owned","","",774,[[["self"]],["t"]]],[11,"clone_into","","",774,N],[11,"from","","",774,[[["t"]],["t"]]],[11,"into","","",774,[[["self"]],["u"]]],[11,"try_from","","",774,[[["u"]],["result"]]],[11,"borrow","","",774,[[["self"]],["t"]]],[11,"try_into","","",774,[[["self"]],["result"]]],[11,"borrow_mut","","",774,[[["self"]],["t"]]],[11,"get_type_id","","",774,[[["self"]],["typeid"]]],[11,"not_found","","",774,[[["str"],["str"]],["e"]]],[11,"i8","","",775,[[],["reg"]]],[11,"i16","","",775,[[],["reg"]]],[11,"i32","","",775,[[],["reg"]]],[11,"i64","","",775,[[],["reg"]]],[11,"f32","","",775,[[],["reg"]]],[11,"f64","","",775,[[],["reg"]]],[11,"align","","",775,[[["self"],["c"]],["align"]]],[11,"from_ok","","",775,[[["t"]],["t"]]],[11,"map_same","","",775,[[["self"],["f"]],["t"]]],[11,"to_owned","","",775,[[["self"]],["t"]]],[11,"clone_into","","",775,N],[11,"from","","",775,[[["t"]],["t"]]],[11,"into","","",775,[[["self"]],["u"]]],[11,"try_from","","",775,[[["u"]],["result"]]],[11,"borrow","","",775,[[["self"]],["t"]]],[11,"try_into","","",775,[[["self"]],["result"]]],[11,"borrow_mut","","",775,[[["self"]],["t"]]],[11,"get_type_id","","",775,[[["self"]],["typeid"]]],[11,"not_found","","",775,[[["str"],["str"]],["e"]]],[11,"align","","",776,[[["self"],["c"]],["align"]]],[11,"from_ok","","",776,[[["t"]],["t"]]],[11,"map_same","","",776,[[["self"],["f"]],["t"]]],[11,"to_owned","","",776,[[["self"]],["t"]]],[11,"clone_into","","",776,N],[11,"from","","",776,[[["t"]],["t"]]],[11,"into","","",776,[[["self"]],["u"]]],[11,"try_from","","",776,[[["u"]],["result"]]],[11,"borrow","","",776,[[["self"]],["t"]]],[11,"try_into","","",776,[[["self"]],["result"]]],[11,"borrow_mut","","",776,[[["self"]],["t"]]],[11,"get_type_id","","",776,[[["self"]],["typeid"]]],[11,"not_found","","",776,[[["str"],["str"]],["e"]]],[11,"pair","","",777,[[["reg"],["reg"]],["casttarget"]]],[11,"size","","",777,[[["self"],["c"]],["size"]]],[11,"align","","",777,[[["self"],["c"]],["align"]]],[11,"from_ok","","",777,[[["t"]],["t"]]],[11,"map_same","","",777,[[["self"],["f"]],["t"]]],[11,"to_owned","","",777,[[["self"]],["t"]]],[11,"clone_into","","",777,N],[11,"from","","",777,[[["t"]],["t"]]],[11,"into","","",777,[[["self"]],["u"]]],[11,"try_from","","",777,[[["u"]],["result"]]],[11,"borrow","","",777,[[["self"]],["t"]]],[11,"try_into","","",777,[[["self"]],["result"]]],[11,"borrow_mut","","",777,[[["self"]],["t"]]],[11,"get_type_id","","",777,[[["self"]],["typeid"]]],[11,"not_found","","",777,[[["str"],["str"]],["e"]]],[11,"new","","",778,[[["tylayout"]],["argtype"]]],[11,"make_indirect","","",778,N],[11,"make_indirect_byval","","",778,N],[11,"extend_integer_width_to","","",778,N],[11,"cast_to","","",778,N],[11,"pad_with","","",778,N],[11,"is_indirect","","",778,[[["self"]],["bool"]]],[11,"is_sized_indirect","","",778,[[["self"]],["bool"]]],[11,"is_unsized_indirect","","",778,[[["self"]],["bool"]]],[11,"is_ignore","","",778,[[["self"]],["bool"]]],[11,"from_ok","","",778,[[["t"]],["t"]]],[11,"map_same","","",778,[[["self"],["f"]],["t"]]],[11,"from","","",778,[[["t"]],["t"]]],[11,"into","","",778,[[["self"]],["u"]]],[11,"try_from","","",778,[[["u"]],["result"]]],[11,"borrow","","",778,[[["self"]],["t"]]],[11,"try_into","","",778,[[["self"]],["result"]]],[11,"borrow_mut","","",778,[[["self"]],["t"]]],[11,"get_type_id","","",778,[[["self"]],["typeid"]]],[11,"not_found","","",778,[[["str"],["str"]],["e"]]],[11,"from_ok","","",779,[[["t"]],["t"]]],[11,"map_same","","",779,[[["self"],["f"]],["t"]]],[11,"to_owned","","",779,[[["self"]],["t"]]],[11,"clone_into","","",779,N],[11,"from","","",779,[[["t"]],["t"]]],[11,"into","","",779,[[["self"]],["u"]]],[11,"try_from","","",779,[[["u"]],["result"]]],[11,"borrow","","",779,[[["self"]],["t"]]],[11,"try_into","","",779,[[["self"]],["result"]]],[11,"borrow_mut","","",779,[[["self"]],["t"]]],[11,"get_type_id","","",779,[[["self"]],["typeid"]]],[11,"not_found","","",779,[[["str"],["str"]],["e"]]],[11,"adjust_for_cabi","","",780,[[["self"],["c"],["abi"]],["result",["string"]]]],[11,"from_ok","","",780,[[["t"]],["t"]]],[11,"map_same","","",780,[[["self"],["f"]],["t"]]],[11,"from","","",780,[[["t"]],["t"]]],[11,"into","","",780,[[["self"]],["u"]]],[11,"try_from","","",780,[[["u"]],["result"]]],[11,"borrow","","",780,[[["self"]],["t"]]],[11,"try_into","","",780,[[["self"]],["result"]]],[11,"borrow_mut","","",780,[[["self"]],["t"]]],[11,"get_type_id","","",780,[[["self"]],["typeid"]]],[11,"not_found","","",780,[[["str"],["str"]],["e"]]],[18,"ByVal","","",781,N],[18,"NoAlias","","",781,N],[18,"NoCapture","","",781,N],[18,"NonNull","","",781,N],[18,"ReadOnly","","",781,N],[18,"SExt","","",781,N],[18,"StructRet","","",781,N],[18,"ZExt","","",781,N],[18,"InReg","","",781,N],[11,"empty","","Returns an empty set of flags.",781,[[],["argattribute"]]],[11,"all","","Returns the set containing all flags.",781,[[],["argattribute"]]],[11,"bits","","Returns the raw value of the flags currently stored.",781,[[["self"]],["u16"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",781,[[["u16"]],["option",["argattribute"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",781,[[["u16"]],["argattribute"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",781,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",781,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",781,[[["self"],["argattribute"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",781,[[["self"],["argattribute"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",781,N],[11,"remove","","Removes the specified flags in-place.",781,N],[11,"toggle","","Toggles the specified flags in-place.",781,N],[11,"set","","Inserts or removes the specified flags depending on the passed value.",781,N],[11,"from_ok","","",781,[[["t"]],["t"]]],[11,"map_same","","",781,[[["self"],["f"]],["t"]]],[11,"to_owned","","",781,[[["self"]],["t"]]],[11,"clone_into","","",781,N],[11,"from","","",781,[[["t"]],["t"]]],[11,"into","","",781,[[["self"]],["u"]]],[11,"try_from","","",781,[[["u"]],["result"]]],[11,"borrow","","",781,[[["self"]],["t"]]],[11,"try_into","","",781,[[["self"]],["result"]]],[11,"borrow_mut","","",781,[[["self"]],["t"]]],[11,"get_type_id","","",781,[[["self"]],["typeid"]]],[11,"not_found","","",781,[[["str"],["str"]],["e"]]],[11,"parse","rustc::ty::layout","",782,[[["target"]],["result",["targetdatalayout","string"]]]],[11,"obj_size_bound","","Return exclusive upper bound on object size.",782,[[["self"]],["u64"]]],[11,"ptr_sized_integer","","",782,[[["self"]],["integer"]]],[11,"vector_align","","",782,[[["self"],["size"]],["align"]]],[11,"from_ok","","",782,[[["t"]],["t"]]],[11,"map_same","","",782,[[["self"],["f"]],["t"]]],[11,"from","","",782,[[["t"]],["t"]]],[11,"into","","",782,[[["self"]],["u"]]],[11,"try_from","","",782,[[["u"]],["result"]]],[11,"borrow","","",782,[[["self"]],["t"]]],[11,"try_into","","",782,[[["self"]],["result"]]],[11,"borrow_mut","","",782,[[["self"]],["t"]]],[11,"get_type_id","","",782,[[["self"]],["typeid"]]],[11,"not_found","","",782,[[["str"],["str"]],["e"]]],[11,"from_ok","","",784,[[["t"]],["t"]]],[11,"map_same","","",784,[[["self"],["f"]],["t"]]],[11,"to_owned","","",784,[[["self"]],["t"]]],[11,"clone_into","","",784,N],[11,"from","","",784,[[["t"]],["t"]]],[11,"into","","",784,[[["self"]],["u"]]],[11,"try_from","","",784,[[["u"]],["result"]]],[11,"borrow","","",784,[[["self"]],["t"]]],[11,"try_into","","",784,[[["self"]],["result"]]],[11,"borrow_mut","","",784,[[["self"]],["t"]]],[11,"get_type_id","","",784,[[["self"]],["typeid"]]],[11,"not_found","","",784,[[["str"],["str"]],["e"]]],[18,"ZERO","","",785,N],[11,"from_bits","","",785,[[["u64"]],["size"]]],[11,"from_bytes","","",785,[[["u64"]],["size"]]],[11,"bytes","","",785,[[["self"]],["u64"]]],[11,"bits","","",785,[[["self"]],["u64"]]],[11,"abi_align","","",785,[[["self"],["align"]],["size"]]],[11,"is_abi_aligned","","",785,[[["self"],["align"]],["bool"]]],[11,"checked_add","","",785,[[["self"],["size"],["c"]],["option",["size"]]]],[11,"checked_mul","","",785,[[["self"],["u64"],["c"]],["option",["size"]]]],[11,"from_ok","","",785,[[["t"]],["t"]]],[11,"map_same","","",785,[[["self"],["f"]],["t"]]],[11,"to_owned","","",785,[[["self"]],["t"]]],[11,"clone_into","","",785,N],[11,"from","","",785,[[["t"]],["t"]]],[11,"into","","",785,[[["self"]],["u"]]],[11,"try_from","","",785,[[["u"]],["result"]]],[11,"borrow","","",785,[[["self"]],["t"]]],[11,"try_into","","",785,[[["self"]],["result"]]],[11,"borrow_mut","","",785,[[["self"]],["t"]]],[11,"get_type_id","","",785,[[["self"]],["typeid"]]],[11,"encode","","",785,[[["self"],["e"]],["result"]]],[11,"decode","","",785,[[["d"]],["result"]]],[11,"not_found","","",785,[[["str"],["str"]],["e"]]],[11,"from_bits","","",786,[[["u64"],["u64"]],["result",["align","string"]]]],[11,"from_bytes","","",786,[[["u64"],["u64"]],["result",["align","string"]]]],[11,"abi","","",786,[[["self"]],["u64"]]],[11,"pref","","",786,[[["self"]],["u64"]]],[11,"abi_bits","","",786,[[["self"]],["u64"]]],[11,"pref_bits","","",786,[[["self"]],["u64"]]],[11,"min","","",786,[[["self"],["align"]],["align"]]],[11,"max","","",786,[[["self"],["align"]],["align"]]],[11,"max_for_offset","","Compute the best alignment possible for the given offset (the largest power of two that the offset is a multiple of).",786,[[["size"]],["align"]]],[11,"restrict_for_offset","","Lower the alignment, if necessary, such that the given offset is aligned to it (the offset is a multiple of the aligment).",786,[[["self"],["size"]],["align"]]],[11,"from_ok","","",786,[[["t"]],["t"]]],[11,"map_same","","",786,[[["self"],["f"]],["t"]]],[11,"to_owned","","",786,[[["self"]],["t"]]],[11,"clone_into","","",786,N],[11,"from","","",786,[[["t"]],["t"]]],[11,"into","","",786,[[["self"]],["u"]]],[11,"try_from","","",786,[[["u"]],["result"]]],[11,"borrow","","",786,[[["self"]],["t"]]],[11,"try_into","","",786,[[["self"]],["result"]]],[11,"borrow_mut","","",786,[[["self"]],["t"]]],[11,"get_type_id","","",786,[[["self"]],["typeid"]]],[11,"encode","","",786,[[["self"],["e"]],["result"]]],[11,"decode","","",786,[[["d"]],["result"]]],[11,"not_found","","",786,[[["str"],["str"]],["e"]]],[11,"size","","",787,[[["self"]],["size"]]],[11,"align","","",787,[[["self"],["c"]],["align"]]],[11,"fit_signed","","Find the smallest Integer type which can represent the signed value.",787,[[["i128"]],["integer"]]],[11,"fit_unsigned","","Find the smallest Integer type which can represent the unsigned value.",787,[[["u128"]],["integer"]]],[11,"for_abi_align","","Find the smallest integer with the given alignment.",787,[[["c"],["align"]],["option",["integer"]]]],[11,"approximate_abi_align","","Find the largest integer with the given alignment or less.",787,[[["c"],["align"]],["integer"]]],[11,"from_ok","","",787,[[["t"]],["t"]]],[11,"map_same","","",787,[[["self"],["f"]],["t"]]],[11,"to_owned","","",787,[[["self"]],["t"]]],[11,"clone_into","","",787,N],[11,"from","","",787,[[["t"]],["t"]]],[11,"into","","",787,[[["self"]],["u"]]],[11,"try_from","","",787,[[["u"]],["result"]]],[11,"borrow","","",787,[[["self"]],["t"]]],[11,"try_into","","",787,[[["self"]],["result"]]],[11,"borrow_mut","","",787,[[["self"]],["t"]]],[11,"get_type_id","","",787,[[["self"]],["typeid"]]],[11,"not_found","","",787,[[["str"],["str"]],["e"]]],[11,"ty_to_string","","",788,[[["self"]],["str"]]],[11,"bit_width","","",788,[[["self"]],["usize"]]],[11,"from_ok","","",788,[[["t"]],["t"]]],[11,"map_same","","",788,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",788,N],[11,"to_owned","","",788,[[["self"]],["t"]]],[11,"clone_into","","",788,N],[11,"from","","",788,[[["t"]],["t"]]],[11,"to_string","","",788,[[["self"]],["string"]]],[11,"into","","",788,[[["self"]],["u"]]],[11,"try_from","","",788,[[["u"]],["result"]]],[11,"borrow","","",788,[[["self"]],["t"]]],[11,"try_into","","",788,[[["self"]],["result"]]],[11,"borrow_mut","","",788,[[["self"]],["t"]]],[11,"get_type_id","","",788,[[["self"]],["typeid"]]],[11,"encode","","",788,[[["self"],["e"]],["result"]]],[11,"decode","","",788,[[["d"]],["result"]]],[11,"not_found","","",788,[[["str"],["str"]],["e"]]],[11,"size","","",789,[[["self"],["c"]],["size"]]],[11,"align","","",789,[[["self"],["c"]],["align"]]],[11,"is_float","","",789,[[["self"]],["bool"]]],[11,"is_int","","",789,[[["self"]],["bool"]]],[11,"from_ok","","",789,[[["t"]],["t"]]],[11,"map_same","","",789,[[["self"],["f"]],["t"]]],[11,"to_owned","","",789,[[["self"]],["t"]]],[11,"clone_into","","",789,N],[11,"from","","",789,[[["t"]],["t"]]],[11,"into","","",789,[[["self"]],["u"]]],[11,"try_from","","",789,[[["u"]],["result"]]],[11,"borrow","","",789,[[["self"]],["t"]]],[11,"try_into","","",789,[[["self"]],["result"]]],[11,"borrow_mut","","",789,[[["self"]],["t"]]],[11,"get_type_id","","",789,[[["self"]],["typeid"]]],[11,"not_found","","",789,[[["str"],["str"]],["e"]]],[11,"is_bool","","",790,[[["self"]],["bool"]]],[11,"valid_range_exclusive","","Returns the valid range as a `x..y` range.",790,[[["self"],["c"]],["range",["u128"]]]],[11,"from_ok","","",790,[[["t"]],["t"]]],[11,"map_same","","",790,[[["self"],["f"]],["t"]]],[11,"to_owned","","",790,[[["self"]],["t"]]],[11,"clone_into","","",790,N],[11,"from","","",790,[[["t"]],["t"]]],[11,"into","","",790,[[["self"]],["u"]]],[11,"try_from","","",790,[[["u"]],["result"]]],[11,"borrow","","",790,[[["self"]],["t"]]],[11,"try_into","","",790,[[["self"]],["result"]]],[11,"borrow_mut","","",790,[[["self"]],["t"]]],[11,"get_type_id","","",790,[[["self"]],["typeid"]]],[11,"not_found","","",790,[[["str"],["str"]],["e"]]],[11,"count","","",791,[[["self"]],["usize"]]],[11,"offset","","",791,[[["self"],["usize"]],["size"]]],[11,"memory_index","","",791,[[["self"],["usize"]],["usize"]]],[11,"index_by_increasing_offset","","Get source indices of the fields by increasing offsets.",791,N],[11,"from_ok","","",791,[[["t"]],["t"]]],[11,"map_same","","",791,[[["self"],["f"]],["t"]]],[11,"from","","",791,[[["t"]],["t"]]],[11,"into","","",791,[[["self"]],["u"]]],[11,"try_from","","",791,[[["u"]],["result"]]],[11,"borrow","","",791,[[["self"]],["t"]]],[11,"try_into","","",791,[[["self"]],["result"]]],[11,"borrow_mut","","",791,[[["self"]],["t"]]],[11,"get_type_id","","",791,[[["self"]],["typeid"]]],[11,"not_found","","",791,[[["str"],["str"]],["e"]]],[11,"is_unsized","","Returns true if the layout corresponds to an unsized type.",792,[[["self"]],["bool"]]],[11,"is_signed","","Returns true if this is a single signed integer scalar",792,[[["self"]],["bool"]]],[11,"from_ok","","",792,[[["t"]],["t"]]],[11,"map_same","","",792,[[["self"],["f"]],["t"]]],[11,"to_owned","","",792,[[["self"]],["t"]]],[11,"clone_into","","",792,N],[11,"from","","",792,[[["t"]],["t"]]],[11,"into","","",792,[[["self"]],["u"]]],[11,"try_from","","",792,[[["u"]],["result"]]],[11,"borrow","","",792,[[["self"]],["t"]]],[11,"try_into","","",792,[[["self"]],["result"]]],[11,"borrow_mut","","",792,[[["self"]],["t"]]],[11,"get_type_id","","",792,[[["self"]],["typeid"]]],[11,"not_found","","",792,[[["str"],["str"]],["e"]]],[11,"from_ok","","",793,[[["t"]],["t"]]],[11,"map_same","","",793,[[["self"],["f"]],["t"]]],[11,"from","","",793,[[["t"]],["t"]]],[11,"into","","",793,[[["self"]],["u"]]],[11,"try_from","","",793,[[["u"]],["result"]]],[11,"borrow","","",793,[[["self"]],["t"]]],[11,"try_into","","",793,[[["self"]],["result"]]],[11,"borrow_mut","","",793,[[["self"]],["t"]]],[11,"get_type_id","","",793,[[["self"]],["typeid"]]],[11,"not_found","","",793,[[["str"],["str"]],["e"]]],[11,"scalar","","",794,[[["c"],["scalar"]],["layoutdetails"]]],[11,"from_ok","","",794,[[["t"]],["t"]]],[11,"map_same","","",794,[[["self"],["f"]],["t"]]],[11,"from","","",794,[[["t"]],["t"]]],[11,"into","","",794,[[["self"]],["u"]]],[11,"try_from","","",794,[[["u"]],["result"]]],[11,"borrow","","",794,[[["self"]],["t"]]],[11,"try_into","","",794,[[["self"]],["result"]]],[11,"borrow_mut","","",794,[[["self"]],["t"]]],[11,"get_type_id","","",794,[[["self"]],["typeid"]]],[11,"not_found","","",794,[[["str"],["str"]],["e"]]],[11,"for_variant","","",795,[[["self"],["c"],["usize"]],["tylayout"]]],[11,"field","","",795,N],[11,"is_unsized","","Returns true if the layout corresponds to an unsized type.",795,[[["self"]],["bool"]]],[11,"is_zst","","Returns true if the type is a ZST and not unsized.",795,[[["self"]],["bool"]]],[11,"size_and_align","","",795,N],[11,"from_ok","","",795,[[["t"]],["t"]]],[11,"map_same","","",795,[[["self"],["f"]],["t"]]],[11,"to_owned","","",795,[[["self"]],["t"]]],[11,"clone_into","","",795,N],[11,"from","","",795,[[["t"]],["t"]]],[11,"into","","",795,[[["self"]],["u"]]],[11,"try_from","","",795,[[["u"]],["result"]]],[11,"borrow","","",795,[[["self"]],["t"]]],[11,"try_into","","",795,[[["self"]],["result"]]],[11,"borrow_mut","","",795,[[["self"]],["t"]]],[11,"get_type_id","","",795,[[["self"]],["typeid"]]],[11,"not_found","","",795,[[["str"],["str"]],["e"]]],[11,"from_ok","","",798,[[["t"]],["t"]]],[11,"map_same","","",798,[[["self"],["f"]],["t"]]],[11,"to_owned","","",798,[[["self"]],["t"]]],[11,"clone_into","","",798,N],[11,"from","","",798,[[["t"]],["t"]]],[11,"into","","",798,[[["self"]],["u"]]],[11,"try_from","","",798,[[["u"]],["result"]]],[11,"borrow","","",798,[[["self"]],["t"]]],[11,"try_into","","",798,[[["self"]],["result"]]],[11,"borrow_mut","","",798,[[["self"]],["t"]]],[11,"get_type_id","","",798,[[["self"]],["typeid"]]],[11,"not_found","","",798,[[["str"],["str"]],["e"]]],[11,"from_ok","","",799,[[["t"]],["t"]]],[11,"map_same","","",799,[[["self"],["f"]],["t"]]],[11,"from","","",799,[[["t"]],["t"]]],[11,"into","","",799,[[["self"]],["u"]]],[11,"try_from","","",799,[[["u"]],["result"]]],[11,"borrow","","",799,[[["self"]],["t"]]],[11,"try_into","","",799,[[["self"]],["result"]]],[11,"borrow_mut","","",799,[[["self"]],["t"]]],[11,"get_type_id","","",799,[[["self"]],["typeid"]]],[11,"not_found","","",799,[[["str"],["str"]],["e"]]],[11,"from_ok","","",800,[[["t"]],["t"]]],[11,"map_same","","",800,[[["self"],["f"]],["t"]]],[11,"to_owned","","",800,[[["self"]],["t"]]],[11,"clone_into","","",800,N],[11,"from","","",800,[[["t"]],["t"]]],[11,"to_string","","",800,[[["self"]],["string"]]],[11,"into","","",800,[[["self"]],["u"]]],[11,"try_from","","",800,[[["u"]],["result"]]],[11,"borrow","","",800,[[["self"]],["t"]]],[11,"try_into","","",800,[[["self"]],["result"]]],[11,"borrow_mut","","",800,[[["self"]],["t"]]],[11,"get_type_id","","",800,[[["self"]],["typeid"]]],[11,"encode","","",800,[[["self"],["e"]],["result"]]],[11,"decode","","",800,[[["d"]],["result"]]],[11,"not_found","","",800,[[["str"],["str"]],["e"]]],[11,"from_ok","","",801,[[["t"]],["t"]]],[11,"map_same","","",801,[[["self"],["f"]],["t"]]],[11,"to_owned","","",801,[[["self"]],["t"]]],[11,"clone_into","","",801,N],[11,"from","","",801,[[["t"]],["t"]]],[11,"into","","",801,[[["self"]],["u"]]],[11,"try_from","","",801,[[["u"]],["result"]]],[11,"borrow","","",801,[[["self"]],["t"]]],[11,"try_into","","",801,[[["self"]],["result"]]],[11,"borrow_mut","","",801,[[["self"]],["t"]]],[11,"get_type_id","","",801,[[["self"]],["typeid"]]],[11,"not_found","","",801,[[["str"],["str"]],["e"]]],[11,"layout_of","rustc::ty::query","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",813,[[["self"],["paramenvand",["ty"]]],["result",["tylayout","layouterror"]]]],[11,"for_variant","rustc::ty","",1061,[[["tylayout"],["c"],["usize"]],["tylayout"]]],[11,"field","","",1061,N],[11,"from_ok","rustc::ty::_match","",806,[[["t"]],["t"]]],[11,"map_same","","",806,[[["self"],["f"]],["t"]]],[11,"from","","",806,[[["t"]],["t"]]],[11,"into","","",806,[[["self"]],["u"]]],[11,"try_from","","",806,[[["u"]],["result"]]],[11,"borrow","","",806,[[["self"]],["t"]]],[11,"try_into","","",806,[[["self"]],["result"]]],[11,"borrow_mut","","",806,[[["self"]],["t"]]],[11,"get_type_id","","",806,[[["self"]],["typeid"]]],[11,"not_found","","",806,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::outlives","",807,[[["t"]],["t"]]],[11,"map_same","","",807,[[["self"],["f"]],["t"]]],[11,"from","","",807,[[["t"]],["t"]]],[11,"into","","",807,[[["self"]],["u"]]],[11,"try_from","","",807,[[["u"]],["result"]]],[11,"borrow","","",807,[[["self"]],["t"]]],[11,"try_into","","",807,[[["self"]],["result"]]],[11,"borrow_mut","","",807,[[["self"]],["t"]]],[11,"get_type_id","","",807,[[["self"]],["typeid"]]],[11,"not_found","","",807,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::query","",808,[[["t"]],["t"]]],[11,"map_same","","",808,[[["self"],["f"]],["t"]]],[11,"to_owned","","",808,[[["self"]],["t"]]],[11,"clone_into","","",808,N],[11,"from","","",808,[[["t"]],["t"]]],[11,"into","","",808,[[["self"]],["u"]]],[11,"try_from","","",808,[[["u"]],["result"]]],[11,"borrow","","",808,[[["self"]],["t"]]],[11,"try_into","","",808,[[["self"]],["result"]]],[11,"borrow_mut","","",808,[[["self"]],["t"]]],[11,"get_type_id","","",808,[[["self"]],["typeid"]]],[11,"not_found","","",808,[[["str"],["str"]],["e"]]],[11,"from_ok","","",809,[[["t"]],["t"]]],[11,"map_same","","",809,[[["self"],["f"]],["t"]]],[11,"from","","",809,[[["t"]],["t"]]],[11,"into","","",809,[[["self"]],["u"]]],[11,"try_from","","",809,[[["u"]],["result"]]],[11,"borrow","","",809,[[["self"]],["t"]]],[11,"try_into","","",809,[[["self"]],["result"]]],[11,"borrow_mut","","",809,[[["self"]],["t"]]],[11,"get_type_id","","",809,[[["self"]],["typeid"]]],[11,"not_found","","",809,[[["str"],["str"]],["e"]]],[11,"from_ok","","",810,[[["t"]],["t"]]],[11,"map_same","","",810,[[["self"],["f"]],["t"]]],[11,"to_owned","","",810,[[["self"]],["t"]]],[11,"clone_into","","",810,N],[11,"from","","",810,[[["t"]],["t"]]],[11,"into","","",810,[[["self"]],["u"]]],[11,"try_from","","",810,[[["u"]],["result"]]],[11,"borrow","","",810,[[["self"]],["t"]]],[11,"try_into","","",810,[[["self"]],["result"]]],[11,"borrow_mut","","",810,[[["self"]],["t"]]],[11,"get_type_id","","",810,[[["self"]],["typeid"]]],[11,"not_found","","",810,[[["str"],["str"]],["e"]]],[11,"from_ok","","",811,[[["t"]],["t"]]],[11,"map_same","","",811,[[["self"],["f"]],["t"]]],[11,"from","","",811,[[["t"]],["t"]]],[11,"into","","",811,[[["self"]],["u"]]],[11,"try_from","","",811,[[["u"]],["result"]]],[11,"borrow","","",811,[[["self"]],["t"]]],[11,"try_into","","",811,[[["self"]],["result"]]],[11,"borrow_mut","","",811,[[["self"]],["t"]]],[11,"get_type_id","","",811,[[["self"]],["typeid"]]],[11,"not_found","","",811,[[["str"],["str"]],["e"]]],[11,"from_ok","","",812,[[["t"]],["t"]]],[11,"map_same","","",812,[[["self"],["f"]],["t"]]],[11,"from","","",812,[[["t"]],["t"]]],[11,"into","","",812,[[["self"]],["u"]]],[11,"try_from","","",812,[[["u"]],["result"]]],[11,"borrow","","",812,[[["self"]],["t"]]],[11,"try_into","","",812,[[["self"]],["result"]]],[11,"borrow_mut","","",812,[[["self"]],["t"]]],[11,"get_type_id","","",812,[[["self"]],["typeid"]]],[11,"not_found","","",812,[[["str"],["str"]],["e"]]],[11,"from_ok","","",813,[[["t"]],["t"]]],[11,"map_same","","",813,[[["self"],["f"]],["t"]]],[11,"to_owned","","",813,[[["self"]],["t"]]],[11,"clone_into","","",813,N],[11,"from","","",813,[[["t"]],["t"]]],[11,"into","","",813,[[["self"]],["u"]]],[11,"try_from","","",813,[[["u"]],["result"]]],[11,"borrow","","",813,[[["self"]],["t"]]],[11,"try_into","","",813,[[["self"]],["result"]]],[11,"borrow_mut","","",813,[[["self"]],["t"]]],[11,"get_type_id","","",813,[[["self"]],["typeid"]]],[11,"not_found","","",813,[[["str"],["str"]],["e"]]],[11,"from_ok","","",814,[[["t"]],["t"]]],[11,"map_same","","",814,[[["self"],["f"]],["t"]]],[11,"to_owned","","",814,[[["self"]],["t"]]],[11,"clone_into","","",814,N],[11,"from","","",814,[[["t"]],["t"]]],[11,"into","","",814,[[["self"]],["u"]]],[11,"try_from","","",814,[[["u"]],["result"]]],[11,"borrow","","",814,[[["self"]],["t"]]],[11,"try_into","","",814,[[["self"]],["result"]]],[11,"borrow_mut","","",814,[[["self"]],["t"]]],[11,"get_type_id","","",814,[[["self"]],["typeid"]]],[11,"not_found","","",814,[[["str"],["str"]],["e"]]],[11,"from_ok","","",815,[[["t"]],["t"]]],[11,"map_same","","",815,[[["self"],["f"]],["t"]]],[11,"to_owned","","",815,[[["self"]],["t"]]],[11,"clone_into","","",815,N],[11,"from","","",815,[[["t"]],["t"]]],[11,"into","","",815,[[["self"]],["u"]]],[11,"try_from","","",815,[[["u"]],["result"]]],[11,"borrow","","",815,[[["self"]],["t"]]],[11,"try_into","","",815,[[["self"]],["result"]]],[11,"borrow_mut","","",815,[[["self"]],["t"]]],[11,"get_type_id","","",815,[[["self"]],["typeid"]]],[11,"not_found","","",815,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::query::plumbing","",816,[[["t"]],["t"]]],[11,"map_same","","",816,[[["self"],["f"]],["t"]]],[11,"from","","",816,[[["t"]],["t"]]],[11,"into","","",816,[[["self"]],["u"]]],[11,"try_from","","",816,[[["u"]],["result"]]],[11,"borrow","","",816,[[["self"]],["t"]]],[11,"try_into","","",816,[[["self"]],["result"]]],[11,"borrow_mut","","",816,[[["self"]],["t"]]],[11,"get_type_id","","",816,[[["self"]],["typeid"]]],[11,"not_found","","",816,[[["str"],["str"]],["e"]]],[11,"from_ok","","",817,[[["t"]],["t"]]],[11,"map_same","","",817,[[["self"],["f"]],["t"]]],[11,"from","","",817,[[["t"]],["t"]]],[11,"into","","",817,[[["self"]],["u"]]],[11,"try_from","","",817,[[["u"]],["result"]]],[11,"borrow","","",817,[[["self"]],["t"]]],[11,"try_into","","",817,[[["self"]],["result"]]],[11,"borrow_mut","","",817,[[["self"]],["t"]]],[11,"get_type_id","","",817,[[["self"]],["typeid"]]],[11,"not_found","","",817,[[["str"],["str"]],["e"]]],[11,"from_ok","","",818,[[["t"]],["t"]]],[11,"map_same","","",818,[[["self"],["f"]],["t"]]],[11,"from","","",818,[[["t"]],["t"]]],[11,"into","","",818,[[["self"]],["u"]]],[11,"try_from","","",818,[[["u"]],["result"]]],[11,"borrow","","",818,[[["self"]],["t"]]],[11,"try_into","","",818,[[["self"]],["result"]]],[11,"borrow_mut","","",818,[[["self"]],["t"]]],[11,"get_type_id","","",818,[[["self"]],["typeid"]]],[11,"not_found","","",818,[[["str"],["str"]],["e"]]],[11,"from_ok","","",819,[[["t"]],["t"]]],[11,"map_same","","",819,[[["self"],["f"]],["t"]]],[11,"from","","",819,[[["t"]],["t"]]],[11,"into","","",819,[[["self"]],["u"]]],[11,"try_from","","",819,[[["u"]],["result"]]],[11,"borrow","","",819,[[["self"]],["t"]]],[11,"try_into","","",819,[[["self"]],["result"]]],[11,"borrow_mut","","",819,[[["self"]],["t"]]],[11,"get_type_id","","",819,[[["self"]],["typeid"]]],[11,"not_found","","",819,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::query::job","",820,[[["t"]],["t"]]],[11,"map_same","","",820,[[["self"],["f"]],["t"]]],[11,"from","","",820,[[["t"]],["t"]]],[11,"into","","",820,[[["self"]],["u"]]],[11,"try_from","","",820,[[["u"]],["result"]]],[11,"borrow","","",820,[[["self"]],["t"]]],[11,"try_into","","",820,[[["self"]],["result"]]],[11,"borrow_mut","","",820,[[["self"]],["t"]]],[11,"get_type_id","","",820,[[["self"]],["typeid"]]],[11,"not_found","","",820,[[["str"],["str"]],["e"]]],[11,"query_crate","rustc::ty::sty","",1027,[[["self"]],["cratenum"]]],[11,"default_span","","",1027,[[["self"],["tyctxt"]],["span"]]],[11,"query_crate","rustc::ty","",1061,[[["self"]],["cratenum"]]],[11,"default_span","","",1061,[[["self"],["tyctxt"]],["span"]]],[11,"from_cycle_error","","",1061,[[["tyctxt"]],["ty"]]],[11,"describe","rustc::ty::query::queries","",975,[[["tyctxt"],["canonicalprojectiongoal"]],["string"]]],[11,"describe","","",977,[[["tyctxt"],["canonicaltygoal"]],["string"]]],[11,"describe","","",978,[[["tyctxt"],["canonicaltygoal"]],["string"]]],[11,"describe","","",976,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",979,[[["tyctxt"],["canonicalpredicategoal"]],["string"]]],[11,"describe","","",980,[[["tyctxt"],["canonicaltypeopeqgoal"]],["string"]]],[11,"describe","","",981,[[["tyctxt"],["canonicaltypeopsubtypegoal"]],["string"]]],[11,"describe","","",982,[[["tyctxt"],["canonicaltypeopprovepredicategoal"]],["string"]]],[11,"describe","","",983,[[["tyctxt"],["canonicaltypeopnormalizegoal",["ty"]]],["string"]]],[11,"describe","","",984,[[["tyctxt"],["canonicaltypeopnormalizegoal",["predicate"]]],["string"]]],[11,"describe","","",985,[[["tyctxt"],["canonicaltypeopnormalizegoal",["polyfnsig"]]],["string"]]],[11,"describe","","",986,[[["tyctxt"],["canonicaltypeopnormalizegoal",["fnsig"]]],["string"]]],[11,"describe","","",902,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",903,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",904,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",905,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",906,[[["tyctxt"],["paramenvand",["ty"]]],["string"]]],[11,"describe","","",839,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",974,[[["tyctxt"],["ty"]],["string"]]],[11,"describe","","",840,N],[11,"describe","","",870,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",928,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",873,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",874,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",848,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",850,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",880,[[["tyctxt"],["instancedef"]],["string"]]],[11,"describe","","",877,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",866,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",878,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",875,[[["tyctxt"],["paramenvand",["globalid"]]],["string"]]],[11,"cache_on_disk","","",875,N],[11,"try_load_from_disk","","",875,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",856,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",882,[[["tyctxt"],["instance"]],["string"]]],[11,"cache_on_disk","","",882,N],[11,"try_load_from_disk","","",882,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",883,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",884,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",885,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",886,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",887,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",926,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",889,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",891,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",892,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",893,[[["tyctxt"],["defid"]],["string"]]],[11,"cache_on_disk","","",893,N],[11,"try_load_from_disk","","",893,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",894,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",895,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",897,N],[11,"cache_on_disk","","",897,N],[11,"try_load_from_disk","","",897,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",898,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",900,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",846,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",907,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",908,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",909,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",910,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",911,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",916,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",920,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",917,N],[11,"describe","","",918,[[["tyctxt"],["defindex"]],["string"]]],[11,"describe","","",915,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",914,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",913,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",912,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",925,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",930,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",931,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",932,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",933,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",934,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",935,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",936,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",937,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",938,N],[11,"describe","","",939,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",944,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",945,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",946,[[["tyctxt"],["defindex"]],["string"]]],[11,"describe","","",947,[[["tyctxt"],["defindex"]],["string"]]],[11,"describe","","",948,[[["tyctxt"],["defindex"]],["string"]]],[11,"describe","","",950,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",951,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",954,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",955,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",956,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",957,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",958,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",959,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",960,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",961,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",962,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",965,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",966,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",968,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",967,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",969,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",970,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",972,[[["tyctxt"],["internedstring"]],["string"]]],[11,"describe","","",973,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",896,[[["tyctxt"],["polytraitref"]],["string"]]],[11,"describe","","",990,[[["tyctxt"],["cratenum"]],["string"]]],[11,"cache_on_disk","","",867,N],[11,"try_load_from_disk","","",867,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",861,N],[11,"try_load_from_disk","","",861,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",987,N],[11,"describe","","",988,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",989,[[["tyctxt"],["instancedef"]],["string"]]],[11,"cache_on_disk","","",834,N],[11,"try_load_from_disk","","",834,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"describe","","",991,[[["tyctxt"],["defid"]],["string"]]],[11,"describe","","",992,[[["tyctxt"],["paramenv"]],["string"]]],[11,"describe","","",993,[[["tyctxt"],["cratenum"]],["string"]]],[11,"describe","","",940,[[["tyctxt"],["cratenum"]],["string"]]],[11,"cache_on_disk","","",862,N],[11,"try_load_from_disk","","",862,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",871,N],[11,"try_load_from_disk","","",871,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",872,N],[11,"try_load_from_disk","","",872,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",857,N],[11,"try_load_from_disk","","",857,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",876,N],[11,"try_load_from_disk","","",876,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",881,N],[11,"try_load_from_disk","","",881,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",833,N],[11,"try_load_from_disk","","",833,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",835,N],[11,"try_load_from_disk","","",835,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",868,N],[11,"try_load_from_disk","","",868,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",888,N],[11,"try_load_from_disk","","",888,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"cache_on_disk","","",899,N],[11,"try_load_from_disk","","",899,[[["tyctxt"],["serializeddepnodeindex"]],["option"]]],[11,"from_ok","rustc::ty::query::on_disk_cache","",826,[[["t"]],["t"]]],[11,"map_same","","",826,[[["self"],["f"]],["t"]]],[11,"from","","",826,[[["t"]],["t"]]],[11,"into","","",826,[[["self"]],["u"]]],[11,"try_from","","",826,[[["u"]],["result"]]],[11,"borrow","","",826,[[["self"]],["t"]]],[11,"try_into","","",826,[[["self"]],["result"]]],[11,"borrow_mut","","",826,[[["self"]],["t"]]],[11,"get_type_id","","",826,[[["self"]],["typeid"]]],[11,"encode","","",826,[[["self"],["e"]],["result"]]],[11,"decode","","",826,[[["d"]],["result"]]],[11,"not_found","","",826,[[["str"],["str"]],["e"]]],[11,"from_ok","","",827,[[["t"]],["t"]]],[11,"map_same","","",827,[[["self"],["f"]],["t"]]],[11,"to_owned","","",827,[[["self"]],["t"]]],[11,"clone_into","","",827,N],[11,"from","","",827,[[["t"]],["t"]]],[11,"into","","",827,[[["self"]],["u"]]],[11,"try_from","","",827,[[["u"]],["result"]]],[11,"borrow","","",827,[[["self"]],["t"]]],[11,"try_into","","",827,[[["self"]],["result"]]],[11,"borrow_mut","","",827,[[["self"]],["t"]]],[11,"get_type_id","","",827,[[["self"]],["typeid"]]],[11,"encode","","",827,[[["self"],["e"]],["result"]]],[11,"decode","","",827,[[["d"]],["result"]]],[11,"not_found","","",827,[[["str"],["str"]],["e"]]],[11,"from_ok","","",828,[[["t"]],["t"]]],[11,"map_same","","",828,[[["self"],["f"]],["t"]]],[11,"to_owned","","",828,[[["self"]],["t"]]],[11,"clone_into","","",828,N],[11,"from","","",828,[[["t"]],["t"]]],[11,"into","","",828,[[["self"]],["u"]]],[11,"try_from","","",828,[[["u"]],["result"]]],[11,"borrow","","",828,[[["self"]],["t"]]],[11,"try_into","","",828,[[["self"]],["result"]]],[11,"borrow_mut","","",828,[[["self"]],["t"]]],[11,"get_type_id","","",828,[[["self"]],["typeid"]]],[11,"encode","","",828,[[["self"],["e"]],["result"]]],[11,"decode","","",828,[[["d"]],["result"]]],[11,"not_found","","",828,[[["str"],["str"]],["e"]]],[11,"from_ok","","",829,[[["t"]],["t"]]],[11,"map_same","","",829,[[["self"],["f"]],["t"]]],[11,"from","","",829,[[["t"]],["t"]]],[11,"into","","",829,[[["self"]],["u"]]],[11,"try_from","","",829,[[["u"]],["result"]]],[11,"borrow","","",829,[[["self"]],["t"]]],[11,"try_into","","",829,[[["self"]],["result"]]],[11,"borrow_mut","","",829,[[["self"]],["t"]]],[11,"get_type_id","","",829,[[["self"]],["typeid"]]],[11,"not_found","","",829,[[["str"],["str"]],["e"]]],[11,"specialized_decode","","",829,[[["self"]],["result"]]],[11,"from_ok","","",830,[[["t"]],["t"]]],[11,"map_same","","",830,[[["self"],["f"]],["t"]]],[11,"from","","",830,[[["t"]],["t"]]],[11,"into","","",830,[[["self"]],["u"]]],[11,"try_from","","",830,[[["u"]],["result"]]],[11,"borrow","","",830,[[["self"]],["t"]]],[11,"try_into","","",830,[[["self"]],["result"]]],[11,"borrow_mut","","",830,[[["self"]],["t"]]],[11,"get_type_id","","",830,[[["self"]],["typeid"]]],[11,"not_found","","",830,[[["str"],["str"]],["e"]]],[11,"specialized_encode","","",830,[[["self"],["t"]],["result"]]],[11,"from_ok","","",831,[[["t"]],["t"]]],[11,"map_same","","",831,[[["self"],["f"]],["t"]]],[11,"from","","",831,[[["t"]],["t"]]],[11,"into","","",831,[[["self"]],["u"]]],[11,"try_from","","",831,[[["u"]],["result"]]],[11,"borrow","","",831,[[["self"]],["t"]]],[11,"try_into","","",831,[[["self"]],["result"]]],[11,"borrow_mut","","",831,[[["self"]],["t"]]],[11,"get_type_id","","",831,[[["self"]],["typeid"]]],[11,"encode","","",831,[[["self"],["e"]],["result"]]],[11,"decode","","",831,[[["d"]],["result"]]],[11,"not_found","","",831,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::query::queries","",833,[[["t"]],["t"]]],[11,"map_same","","",833,[[["self"],["f"]],["t"]]],[11,"from","","",833,[[["t"]],["t"]]],[11,"into","","",833,[[["self"]],["u"]]],[11,"try_from","","",833,[[["u"]],["result"]]],[11,"borrow","","",833,[[["self"]],["t"]]],[11,"try_into","","",833,[[["self"]],["result"]]],[11,"borrow_mut","","",833,[[["self"]],["t"]]],[11,"get_type_id","","",833,[[["self"]],["typeid"]]],[11,"not_found","","",833,[[["str"],["str"]],["e"]]],[11,"from_ok","","",834,[[["t"]],["t"]]],[11,"map_same","","",834,[[["self"],["f"]],["t"]]],[11,"from","","",834,[[["t"]],["t"]]],[11,"into","","",834,[[["self"]],["u"]]],[11,"try_from","","",834,[[["u"]],["result"]]],[11,"borrow","","",834,[[["self"]],["t"]]],[11,"try_into","","",834,[[["self"]],["result"]]],[11,"borrow_mut","","",834,[[["self"]],["t"]]],[11,"get_type_id","","",834,[[["self"]],["typeid"]]],[11,"not_found","","",834,[[["str"],["str"]],["e"]]],[11,"from_ok","","",835,[[["t"]],["t"]]],[11,"map_same","","",835,[[["self"],["f"]],["t"]]],[11,"from","","",835,[[["t"]],["t"]]],[11,"into","","",835,[[["self"]],["u"]]],[11,"try_from","","",835,[[["u"]],["result"]]],[11,"borrow","","",835,[[["self"]],["t"]]],[11,"try_into","","",835,[[["self"]],["result"]]],[11,"borrow_mut","","",835,[[["self"]],["t"]]],[11,"get_type_id","","",835,[[["self"]],["typeid"]]],[11,"not_found","","",835,[[["str"],["str"]],["e"]]],[11,"from_ok","","",836,[[["t"]],["t"]]],[11,"map_same","","",836,[[["self"],["f"]],["t"]]],[11,"from","","",836,[[["t"]],["t"]]],[11,"into","","",836,[[["self"]],["u"]]],[11,"try_from","","",836,[[["u"]],["result"]]],[11,"borrow","","",836,[[["self"]],["t"]]],[11,"try_into","","",836,[[["self"]],["result"]]],[11,"borrow_mut","","",836,[[["self"]],["t"]]],[11,"get_type_id","","",836,[[["self"]],["typeid"]]],[11,"not_found","","",836,[[["str"],["str"]],["e"]]],[11,"from_ok","","",837,[[["t"]],["t"]]],[11,"map_same","","",837,[[["self"],["f"]],["t"]]],[11,"from","","",837,[[["t"]],["t"]]],[11,"into","","",837,[[["self"]],["u"]]],[11,"try_from","","",837,[[["u"]],["result"]]],[11,"borrow","","",837,[[["self"]],["t"]]],[11,"try_into","","",837,[[["self"]],["result"]]],[11,"borrow_mut","","",837,[[["self"]],["t"]]],[11,"get_type_id","","",837,[[["self"]],["typeid"]]],[11,"not_found","","",837,[[["str"],["str"]],["e"]]],[11,"from_ok","","",838,[[["t"]],["t"]]],[11,"map_same","","",838,[[["self"],["f"]],["t"]]],[11,"from","","",838,[[["t"]],["t"]]],[11,"into","","",838,[[["self"]],["u"]]],[11,"try_from","","",838,[[["u"]],["result"]]],[11,"borrow","","",838,[[["self"]],["t"]]],[11,"try_into","","",838,[[["self"]],["result"]]],[11,"borrow_mut","","",838,[[["self"]],["t"]]],[11,"get_type_id","","",838,[[["self"]],["typeid"]]],[11,"not_found","","",838,[[["str"],["str"]],["e"]]],[11,"from_ok","","",839,[[["t"]],["t"]]],[11,"map_same","","",839,[[["self"],["f"]],["t"]]],[11,"from","","",839,[[["t"]],["t"]]],[11,"into","","",839,[[["self"]],["u"]]],[11,"try_from","","",839,[[["u"]],["result"]]],[11,"borrow","","",839,[[["self"]],["t"]]],[11,"try_into","","",839,[[["self"]],["result"]]],[11,"borrow_mut","","",839,[[["self"]],["t"]]],[11,"get_type_id","","",839,[[["self"]],["typeid"]]],[11,"not_found","","",839,[[["str"],["str"]],["e"]]],[11,"from_ok","","",840,[[["t"]],["t"]]],[11,"map_same","","",840,[[["self"],["f"]],["t"]]],[11,"from","","",840,[[["t"]],["t"]]],[11,"into","","",840,[[["self"]],["u"]]],[11,"try_from","","",840,[[["u"]],["result"]]],[11,"borrow","","",840,[[["self"]],["t"]]],[11,"try_into","","",840,[[["self"]],["result"]]],[11,"borrow_mut","","",840,[[["self"]],["t"]]],[11,"get_type_id","","",840,[[["self"]],["typeid"]]],[11,"not_found","","",840,[[["str"],["str"]],["e"]]],[11,"from_ok","","",841,[[["t"]],["t"]]],[11,"map_same","","",841,[[["self"],["f"]],["t"]]],[11,"from","","",841,[[["t"]],["t"]]],[11,"into","","",841,[[["self"]],["u"]]],[11,"try_from","","",841,[[["u"]],["result"]]],[11,"borrow","","",841,[[["self"]],["t"]]],[11,"try_into","","",841,[[["self"]],["result"]]],[11,"borrow_mut","","",841,[[["self"]],["t"]]],[11,"get_type_id","","",841,[[["self"]],["typeid"]]],[11,"not_found","","",841,[[["str"],["str"]],["e"]]],[11,"from_ok","","",842,[[["t"]],["t"]]],[11,"map_same","","",842,[[["self"],["f"]],["t"]]],[11,"from","","",842,[[["t"]],["t"]]],[11,"into","","",842,[[["self"]],["u"]]],[11,"try_from","","",842,[[["u"]],["result"]]],[11,"borrow","","",842,[[["self"]],["t"]]],[11,"try_into","","",842,[[["self"]],["result"]]],[11,"borrow_mut","","",842,[[["self"]],["t"]]],[11,"get_type_id","","",842,[[["self"]],["typeid"]]],[11,"not_found","","",842,[[["str"],["str"]],["e"]]],[11,"from_ok","","",843,[[["t"]],["t"]]],[11,"map_same","","",843,[[["self"],["f"]],["t"]]],[11,"from","","",843,[[["t"]],["t"]]],[11,"into","","",843,[[["self"]],["u"]]],[11,"try_from","","",843,[[["u"]],["result"]]],[11,"borrow","","",843,[[["self"]],["t"]]],[11,"try_into","","",843,[[["self"]],["result"]]],[11,"borrow_mut","","",843,[[["self"]],["t"]]],[11,"get_type_id","","",843,[[["self"]],["typeid"]]],[11,"not_found","","",843,[[["str"],["str"]],["e"]]],[11,"from_ok","","",844,[[["t"]],["t"]]],[11,"map_same","","",844,[[["self"],["f"]],["t"]]],[11,"from","","",844,[[["t"]],["t"]]],[11,"into","","",844,[[["self"]],["u"]]],[11,"try_from","","",844,[[["u"]],["result"]]],[11,"borrow","","",844,[[["self"]],["t"]]],[11,"try_into","","",844,[[["self"]],["result"]]],[11,"borrow_mut","","",844,[[["self"]],["t"]]],[11,"get_type_id","","",844,[[["self"]],["typeid"]]],[11,"not_found","","",844,[[["str"],["str"]],["e"]]],[11,"from_ok","","",845,[[["t"]],["t"]]],[11,"map_same","","",845,[[["self"],["f"]],["t"]]],[11,"from","","",845,[[["t"]],["t"]]],[11,"into","","",845,[[["self"]],["u"]]],[11,"try_from","","",845,[[["u"]],["result"]]],[11,"borrow","","",845,[[["self"]],["t"]]],[11,"try_into","","",845,[[["self"]],["result"]]],[11,"borrow_mut","","",845,[[["self"]],["t"]]],[11,"get_type_id","","",845,[[["self"]],["typeid"]]],[11,"not_found","","",845,[[["str"],["str"]],["e"]]],[11,"from_ok","","",846,[[["t"]],["t"]]],[11,"map_same","","",846,[[["self"],["f"]],["t"]]],[11,"from","","",846,[[["t"]],["t"]]],[11,"into","","",846,[[["self"]],["u"]]],[11,"try_from","","",846,[[["u"]],["result"]]],[11,"borrow","","",846,[[["self"]],["t"]]],[11,"try_into","","",846,[[["self"]],["result"]]],[11,"borrow_mut","","",846,[[["self"]],["t"]]],[11,"get_type_id","","",846,[[["self"]],["typeid"]]],[11,"not_found","","",846,[[["str"],["str"]],["e"]]],[11,"from_ok","","",847,[[["t"]],["t"]]],[11,"map_same","","",847,[[["self"],["f"]],["t"]]],[11,"from","","",847,[[["t"]],["t"]]],[11,"into","","",847,[[["self"]],["u"]]],[11,"try_from","","",847,[[["u"]],["result"]]],[11,"borrow","","",847,[[["self"]],["t"]]],[11,"try_into","","",847,[[["self"]],["result"]]],[11,"borrow_mut","","",847,[[["self"]],["t"]]],[11,"get_type_id","","",847,[[["self"]],["typeid"]]],[11,"not_found","","",847,[[["str"],["str"]],["e"]]],[11,"from_ok","","",848,[[["t"]],["t"]]],[11,"map_same","","",848,[[["self"],["f"]],["t"]]],[11,"from","","",848,[[["t"]],["t"]]],[11,"into","","",848,[[["self"]],["u"]]],[11,"try_from","","",848,[[["u"]],["result"]]],[11,"borrow","","",848,[[["self"]],["t"]]],[11,"try_into","","",848,[[["self"]],["result"]]],[11,"borrow_mut","","",848,[[["self"]],["t"]]],[11,"get_type_id","","",848,[[["self"]],["typeid"]]],[11,"not_found","","",848,[[["str"],["str"]],["e"]]],[11,"from_ok","","",849,[[["t"]],["t"]]],[11,"map_same","","",849,[[["self"],["f"]],["t"]]],[11,"from","","",849,[[["t"]],["t"]]],[11,"into","","",849,[[["self"]],["u"]]],[11,"try_from","","",849,[[["u"]],["result"]]],[11,"borrow","","",849,[[["self"]],["t"]]],[11,"try_into","","",849,[[["self"]],["result"]]],[11,"borrow_mut","","",849,[[["self"]],["t"]]],[11,"get_type_id","","",849,[[["self"]],["typeid"]]],[11,"not_found","","",849,[[["str"],["str"]],["e"]]],[11,"from_ok","","",850,[[["t"]],["t"]]],[11,"map_same","","",850,[[["self"],["f"]],["t"]]],[11,"from","","",850,[[["t"]],["t"]]],[11,"into","","",850,[[["self"]],["u"]]],[11,"try_from","","",850,[[["u"]],["result"]]],[11,"borrow","","",850,[[["self"]],["t"]]],[11,"try_into","","",850,[[["self"]],["result"]]],[11,"borrow_mut","","",850,[[["self"]],["t"]]],[11,"get_type_id","","",850,[[["self"]],["typeid"]]],[11,"not_found","","",850,[[["str"],["str"]],["e"]]],[11,"from_ok","","",851,[[["t"]],["t"]]],[11,"map_same","","",851,[[["self"],["f"]],["t"]]],[11,"from","","",851,[[["t"]],["t"]]],[11,"into","","",851,[[["self"]],["u"]]],[11,"try_from","","",851,[[["u"]],["result"]]],[11,"borrow","","",851,[[["self"]],["t"]]],[11,"try_into","","",851,[[["self"]],["result"]]],[11,"borrow_mut","","",851,[[["self"]],["t"]]],[11,"get_type_id","","",851,[[["self"]],["typeid"]]],[11,"not_found","","",851,[[["str"],["str"]],["e"]]],[11,"from_ok","","",852,[[["t"]],["t"]]],[11,"map_same","","",852,[[["self"],["f"]],["t"]]],[11,"from","","",852,[[["t"]],["t"]]],[11,"into","","",852,[[["self"]],["u"]]],[11,"try_from","","",852,[[["u"]],["result"]]],[11,"borrow","","",852,[[["self"]],["t"]]],[11,"try_into","","",852,[[["self"]],["result"]]],[11,"borrow_mut","","",852,[[["self"]],["t"]]],[11,"get_type_id","","",852,[[["self"]],["typeid"]]],[11,"not_found","","",852,[[["str"],["str"]],["e"]]],[11,"from_ok","","",853,[[["t"]],["t"]]],[11,"map_same","","",853,[[["self"],["f"]],["t"]]],[11,"from","","",853,[[["t"]],["t"]]],[11,"into","","",853,[[["self"]],["u"]]],[11,"try_from","","",853,[[["u"]],["result"]]],[11,"borrow","","",853,[[["self"]],["t"]]],[11,"try_into","","",853,[[["self"]],["result"]]],[11,"borrow_mut","","",853,[[["self"]],["t"]]],[11,"get_type_id","","",853,[[["self"]],["typeid"]]],[11,"not_found","","",853,[[["str"],["str"]],["e"]]],[11,"from_ok","","",854,[[["t"]],["t"]]],[11,"map_same","","",854,[[["self"],["f"]],["t"]]],[11,"from","","",854,[[["t"]],["t"]]],[11,"into","","",854,[[["self"]],["u"]]],[11,"try_from","","",854,[[["u"]],["result"]]],[11,"borrow","","",854,[[["self"]],["t"]]],[11,"try_into","","",854,[[["self"]],["result"]]],[11,"borrow_mut","","",854,[[["self"]],["t"]]],[11,"get_type_id","","",854,[[["self"]],["typeid"]]],[11,"not_found","","",854,[[["str"],["str"]],["e"]]],[11,"from_ok","","",855,[[["t"]],["t"]]],[11,"map_same","","",855,[[["self"],["f"]],["t"]]],[11,"from","","",855,[[["t"]],["t"]]],[11,"into","","",855,[[["self"]],["u"]]],[11,"try_from","","",855,[[["u"]],["result"]]],[11,"borrow","","",855,[[["self"]],["t"]]],[11,"try_into","","",855,[[["self"]],["result"]]],[11,"borrow_mut","","",855,[[["self"]],["t"]]],[11,"get_type_id","","",855,[[["self"]],["typeid"]]],[11,"not_found","","",855,[[["str"],["str"]],["e"]]],[11,"from_ok","","",856,[[["t"]],["t"]]],[11,"map_same","","",856,[[["self"],["f"]],["t"]]],[11,"from","","",856,[[["t"]],["t"]]],[11,"into","","",856,[[["self"]],["u"]]],[11,"try_from","","",856,[[["u"]],["result"]]],[11,"borrow","","",856,[[["self"]],["t"]]],[11,"try_into","","",856,[[["self"]],["result"]]],[11,"borrow_mut","","",856,[[["self"]],["t"]]],[11,"get_type_id","","",856,[[["self"]],["typeid"]]],[11,"not_found","","",856,[[["str"],["str"]],["e"]]],[11,"from_ok","","",857,[[["t"]],["t"]]],[11,"map_same","","",857,[[["self"],["f"]],["t"]]],[11,"from","","",857,[[["t"]],["t"]]],[11,"into","","",857,[[["self"]],["u"]]],[11,"try_from","","",857,[[["u"]],["result"]]],[11,"borrow","","",857,[[["self"]],["t"]]],[11,"try_into","","",857,[[["self"]],["result"]]],[11,"borrow_mut","","",857,[[["self"]],["t"]]],[11,"get_type_id","","",857,[[["self"]],["typeid"]]],[11,"not_found","","",857,[[["str"],["str"]],["e"]]],[11,"from_ok","","",858,[[["t"]],["t"]]],[11,"map_same","","",858,[[["self"],["f"]],["t"]]],[11,"from","","",858,[[["t"]],["t"]]],[11,"into","","",858,[[["self"]],["u"]]],[11,"try_from","","",858,[[["u"]],["result"]]],[11,"borrow","","",858,[[["self"]],["t"]]],[11,"try_into","","",858,[[["self"]],["result"]]],[11,"borrow_mut","","",858,[[["self"]],["t"]]],[11,"get_type_id","","",858,[[["self"]],["typeid"]]],[11,"not_found","","",858,[[["str"],["str"]],["e"]]],[11,"from_ok","","",859,[[["t"]],["t"]]],[11,"map_same","","",859,[[["self"],["f"]],["t"]]],[11,"from","","",859,[[["t"]],["t"]]],[11,"into","","",859,[[["self"]],["u"]]],[11,"try_from","","",859,[[["u"]],["result"]]],[11,"borrow","","",859,[[["self"]],["t"]]],[11,"try_into","","",859,[[["self"]],["result"]]],[11,"borrow_mut","","",859,[[["self"]],["t"]]],[11,"get_type_id","","",859,[[["self"]],["typeid"]]],[11,"not_found","","",859,[[["str"],["str"]],["e"]]],[11,"from_ok","","",860,[[["t"]],["t"]]],[11,"map_same","","",860,[[["self"],["f"]],["t"]]],[11,"from","","",860,[[["t"]],["t"]]],[11,"into","","",860,[[["self"]],["u"]]],[11,"try_from","","",860,[[["u"]],["result"]]],[11,"borrow","","",860,[[["self"]],["t"]]],[11,"try_into","","",860,[[["self"]],["result"]]],[11,"borrow_mut","","",860,[[["self"]],["t"]]],[11,"get_type_id","","",860,[[["self"]],["typeid"]]],[11,"not_found","","",860,[[["str"],["str"]],["e"]]],[11,"from_ok","","",861,[[["t"]],["t"]]],[11,"map_same","","",861,[[["self"],["f"]],["t"]]],[11,"from","","",861,[[["t"]],["t"]]],[11,"into","","",861,[[["self"]],["u"]]],[11,"try_from","","",861,[[["u"]],["result"]]],[11,"borrow","","",861,[[["self"]],["t"]]],[11,"try_into","","",861,[[["self"]],["result"]]],[11,"borrow_mut","","",861,[[["self"]],["t"]]],[11,"get_type_id","","",861,[[["self"]],["typeid"]]],[11,"not_found","","",861,[[["str"],["str"]],["e"]]],[11,"from_ok","","",862,[[["t"]],["t"]]],[11,"map_same","","",862,[[["self"],["f"]],["t"]]],[11,"from","","",862,[[["t"]],["t"]]],[11,"into","","",862,[[["self"]],["u"]]],[11,"try_from","","",862,[[["u"]],["result"]]],[11,"borrow","","",862,[[["self"]],["t"]]],[11,"try_into","","",862,[[["self"]],["result"]]],[11,"borrow_mut","","",862,[[["self"]],["t"]]],[11,"get_type_id","","",862,[[["self"]],["typeid"]]],[11,"not_found","","",862,[[["str"],["str"]],["e"]]],[11,"from_ok","","",863,[[["t"]],["t"]]],[11,"map_same","","",863,[[["self"],["f"]],["t"]]],[11,"from","","",863,[[["t"]],["t"]]],[11,"into","","",863,[[["self"]],["u"]]],[11,"try_from","","",863,[[["u"]],["result"]]],[11,"borrow","","",863,[[["self"]],["t"]]],[11,"try_into","","",863,[[["self"]],["result"]]],[11,"borrow_mut","","",863,[[["self"]],["t"]]],[11,"get_type_id","","",863,[[["self"]],["typeid"]]],[11,"not_found","","",863,[[["str"],["str"]],["e"]]],[11,"from_ok","","",864,[[["t"]],["t"]]],[11,"map_same","","",864,[[["self"],["f"]],["t"]]],[11,"from","","",864,[[["t"]],["t"]]],[11,"into","","",864,[[["self"]],["u"]]],[11,"try_from","","",864,[[["u"]],["result"]]],[11,"borrow","","",864,[[["self"]],["t"]]],[11,"try_into","","",864,[[["self"]],["result"]]],[11,"borrow_mut","","",864,[[["self"]],["t"]]],[11,"get_type_id","","",864,[[["self"]],["typeid"]]],[11,"not_found","","",864,[[["str"],["str"]],["e"]]],[11,"from_ok","","",865,[[["t"]],["t"]]],[11,"map_same","","",865,[[["self"],["f"]],["t"]]],[11,"from","","",865,[[["t"]],["t"]]],[11,"into","","",865,[[["self"]],["u"]]],[11,"try_from","","",865,[[["u"]],["result"]]],[11,"borrow","","",865,[[["self"]],["t"]]],[11,"try_into","","",865,[[["self"]],["result"]]],[11,"borrow_mut","","",865,[[["self"]],["t"]]],[11,"get_type_id","","",865,[[["self"]],["typeid"]]],[11,"not_found","","",865,[[["str"],["str"]],["e"]]],[11,"from_ok","","",866,[[["t"]],["t"]]],[11,"map_same","","",866,[[["self"],["f"]],["t"]]],[11,"from","","",866,[[["t"]],["t"]]],[11,"into","","",866,[[["self"]],["u"]]],[11,"try_from","","",866,[[["u"]],["result"]]],[11,"borrow","","",866,[[["self"]],["t"]]],[11,"try_into","","",866,[[["self"]],["result"]]],[11,"borrow_mut","","",866,[[["self"]],["t"]]],[11,"get_type_id","","",866,[[["self"]],["typeid"]]],[11,"not_found","","",866,[[["str"],["str"]],["e"]]],[11,"from_ok","","",867,[[["t"]],["t"]]],[11,"map_same","","",867,[[["self"],["f"]],["t"]]],[11,"from","","",867,[[["t"]],["t"]]],[11,"into","","",867,[[["self"]],["u"]]],[11,"try_from","","",867,[[["u"]],["result"]]],[11,"borrow","","",867,[[["self"]],["t"]]],[11,"try_into","","",867,[[["self"]],["result"]]],[11,"borrow_mut","","",867,[[["self"]],["t"]]],[11,"get_type_id","","",867,[[["self"]],["typeid"]]],[11,"not_found","","",867,[[["str"],["str"]],["e"]]],[11,"from_ok","","",868,[[["t"]],["t"]]],[11,"map_same","","",868,[[["self"],["f"]],["t"]]],[11,"from","","",868,[[["t"]],["t"]]],[11,"into","","",868,[[["self"]],["u"]]],[11,"try_from","","",868,[[["u"]],["result"]]],[11,"borrow","","",868,[[["self"]],["t"]]],[11,"try_into","","",868,[[["self"]],["result"]]],[11,"borrow_mut","","",868,[[["self"]],["t"]]],[11,"get_type_id","","",868,[[["self"]],["typeid"]]],[11,"not_found","","",868,[[["str"],["str"]],["e"]]],[11,"from_ok","","",869,[[["t"]],["t"]]],[11,"map_same","","",869,[[["self"],["f"]],["t"]]],[11,"from","","",869,[[["t"]],["t"]]],[11,"into","","",869,[[["self"]],["u"]]],[11,"try_from","","",869,[[["u"]],["result"]]],[11,"borrow","","",869,[[["self"]],["t"]]],[11,"try_into","","",869,[[["self"]],["result"]]],[11,"borrow_mut","","",869,[[["self"]],["t"]]],[11,"get_type_id","","",869,[[["self"]],["typeid"]]],[11,"not_found","","",869,[[["str"],["str"]],["e"]]],[11,"from_ok","","",870,[[["t"]],["t"]]],[11,"map_same","","",870,[[["self"],["f"]],["t"]]],[11,"from","","",870,[[["t"]],["t"]]],[11,"into","","",870,[[["self"]],["u"]]],[11,"try_from","","",870,[[["u"]],["result"]]],[11,"borrow","","",870,[[["self"]],["t"]]],[11,"try_into","","",870,[[["self"]],["result"]]],[11,"borrow_mut","","",870,[[["self"]],["t"]]],[11,"get_type_id","","",870,[[["self"]],["typeid"]]],[11,"not_found","","",870,[[["str"],["str"]],["e"]]],[11,"from_ok","","",871,[[["t"]],["t"]]],[11,"map_same","","",871,[[["self"],["f"]],["t"]]],[11,"from","","",871,[[["t"]],["t"]]],[11,"into","","",871,[[["self"]],["u"]]],[11,"try_from","","",871,[[["u"]],["result"]]],[11,"borrow","","",871,[[["self"]],["t"]]],[11,"try_into","","",871,[[["self"]],["result"]]],[11,"borrow_mut","","",871,[[["self"]],["t"]]],[11,"get_type_id","","",871,[[["self"]],["typeid"]]],[11,"not_found","","",871,[[["str"],["str"]],["e"]]],[11,"from_ok","","",872,[[["t"]],["t"]]],[11,"map_same","","",872,[[["self"],["f"]],["t"]]],[11,"from","","",872,[[["t"]],["t"]]],[11,"into","","",872,[[["self"]],["u"]]],[11,"try_from","","",872,[[["u"]],["result"]]],[11,"borrow","","",872,[[["self"]],["t"]]],[11,"try_into","","",872,[[["self"]],["result"]]],[11,"borrow_mut","","",872,[[["self"]],["t"]]],[11,"get_type_id","","",872,[[["self"]],["typeid"]]],[11,"not_found","","",872,[[["str"],["str"]],["e"]]],[11,"from_ok","","",873,[[["t"]],["t"]]],[11,"map_same","","",873,[[["self"],["f"]],["t"]]],[11,"from","","",873,[[["t"]],["t"]]],[11,"into","","",873,[[["self"]],["u"]]],[11,"try_from","","",873,[[["u"]],["result"]]],[11,"borrow","","",873,[[["self"]],["t"]]],[11,"try_into","","",873,[[["self"]],["result"]]],[11,"borrow_mut","","",873,[[["self"]],["t"]]],[11,"get_type_id","","",873,[[["self"]],["typeid"]]],[11,"not_found","","",873,[[["str"],["str"]],["e"]]],[11,"from_ok","","",874,[[["t"]],["t"]]],[11,"map_same","","",874,[[["self"],["f"]],["t"]]],[11,"from","","",874,[[["t"]],["t"]]],[11,"into","","",874,[[["self"]],["u"]]],[11,"try_from","","",874,[[["u"]],["result"]]],[11,"borrow","","",874,[[["self"]],["t"]]],[11,"try_into","","",874,[[["self"]],["result"]]],[11,"borrow_mut","","",874,[[["self"]],["t"]]],[11,"get_type_id","","",874,[[["self"]],["typeid"]]],[11,"not_found","","",874,[[["str"],["str"]],["e"]]],[11,"from_ok","","",875,[[["t"]],["t"]]],[11,"map_same","","",875,[[["self"],["f"]],["t"]]],[11,"from","","",875,[[["t"]],["t"]]],[11,"into","","",875,[[["self"]],["u"]]],[11,"try_from","","",875,[[["u"]],["result"]]],[11,"borrow","","",875,[[["self"]],["t"]]],[11,"try_into","","",875,[[["self"]],["result"]]],[11,"borrow_mut","","",875,[[["self"]],["t"]]],[11,"get_type_id","","",875,[[["self"]],["typeid"]]],[11,"not_found","","",875,[[["str"],["str"]],["e"]]],[11,"from_ok","","",876,[[["t"]],["t"]]],[11,"map_same","","",876,[[["self"],["f"]],["t"]]],[11,"from","","",876,[[["t"]],["t"]]],[11,"into","","",876,[[["self"]],["u"]]],[11,"try_from","","",876,[[["u"]],["result"]]],[11,"borrow","","",876,[[["self"]],["t"]]],[11,"try_into","","",876,[[["self"]],["result"]]],[11,"borrow_mut","","",876,[[["self"]],["t"]]],[11,"get_type_id","","",876,[[["self"]],["typeid"]]],[11,"not_found","","",876,[[["str"],["str"]],["e"]]],[11,"from_ok","","",877,[[["t"]],["t"]]],[11,"map_same","","",877,[[["self"],["f"]],["t"]]],[11,"from","","",877,[[["t"]],["t"]]],[11,"into","","",877,[[["self"]],["u"]]],[11,"try_from","","",877,[[["u"]],["result"]]],[11,"borrow","","",877,[[["self"]],["t"]]],[11,"try_into","","",877,[[["self"]],["result"]]],[11,"borrow_mut","","",877,[[["self"]],["t"]]],[11,"get_type_id","","",877,[[["self"]],["typeid"]]],[11,"not_found","","",877,[[["str"],["str"]],["e"]]],[11,"from_ok","","",878,[[["t"]],["t"]]],[11,"map_same","","",878,[[["self"],["f"]],["t"]]],[11,"from","","",878,[[["t"]],["t"]]],[11,"into","","",878,[[["self"]],["u"]]],[11,"try_from","","",878,[[["u"]],["result"]]],[11,"borrow","","",878,[[["self"]],["t"]]],[11,"try_into","","",878,[[["self"]],["result"]]],[11,"borrow_mut","","",878,[[["self"]],["t"]]],[11,"get_type_id","","",878,[[["self"]],["typeid"]]],[11,"not_found","","",878,[[["str"],["str"]],["e"]]],[11,"from_ok","","",879,[[["t"]],["t"]]],[11,"map_same","","",879,[[["self"],["f"]],["t"]]],[11,"from","","",879,[[["t"]],["t"]]],[11,"into","","",879,[[["self"]],["u"]]],[11,"try_from","","",879,[[["u"]],["result"]]],[11,"borrow","","",879,[[["self"]],["t"]]],[11,"try_into","","",879,[[["self"]],["result"]]],[11,"borrow_mut","","",879,[[["self"]],["t"]]],[11,"get_type_id","","",879,[[["self"]],["typeid"]]],[11,"not_found","","",879,[[["str"],["str"]],["e"]]],[11,"from_ok","","",880,[[["t"]],["t"]]],[11,"map_same","","",880,[[["self"],["f"]],["t"]]],[11,"from","","",880,[[["t"]],["t"]]],[11,"into","","",880,[[["self"]],["u"]]],[11,"try_from","","",880,[[["u"]],["result"]]],[11,"borrow","","",880,[[["self"]],["t"]]],[11,"try_into","","",880,[[["self"]],["result"]]],[11,"borrow_mut","","",880,[[["self"]],["t"]]],[11,"get_type_id","","",880,[[["self"]],["typeid"]]],[11,"not_found","","",880,[[["str"],["str"]],["e"]]],[11,"from_ok","","",881,[[["t"]],["t"]]],[11,"map_same","","",881,[[["self"],["f"]],["t"]]],[11,"from","","",881,[[["t"]],["t"]]],[11,"into","","",881,[[["self"]],["u"]]],[11,"try_from","","",881,[[["u"]],["result"]]],[11,"borrow","","",881,[[["self"]],["t"]]],[11,"try_into","","",881,[[["self"]],["result"]]],[11,"borrow_mut","","",881,[[["self"]],["t"]]],[11,"get_type_id","","",881,[[["self"]],["typeid"]]],[11,"not_found","","",881,[[["str"],["str"]],["e"]]],[11,"from_ok","","",882,[[["t"]],["t"]]],[11,"map_same","","",882,[[["self"],["f"]],["t"]]],[11,"from","","",882,[[["t"]],["t"]]],[11,"into","","",882,[[["self"]],["u"]]],[11,"try_from","","",882,[[["u"]],["result"]]],[11,"borrow","","",882,[[["self"]],["t"]]],[11,"try_into","","",882,[[["self"]],["result"]]],[11,"borrow_mut","","",882,[[["self"]],["t"]]],[11,"get_type_id","","",882,[[["self"]],["typeid"]]],[11,"not_found","","",882,[[["str"],["str"]],["e"]]],[11,"from_ok","","",883,[[["t"]],["t"]]],[11,"map_same","","",883,[[["self"],["f"]],["t"]]],[11,"from","","",883,[[["t"]],["t"]]],[11,"into","","",883,[[["self"]],["u"]]],[11,"try_from","","",883,[[["u"]],["result"]]],[11,"borrow","","",883,[[["self"]],["t"]]],[11,"try_into","","",883,[[["self"]],["result"]]],[11,"borrow_mut","","",883,[[["self"]],["t"]]],[11,"get_type_id","","",883,[[["self"]],["typeid"]]],[11,"not_found","","",883,[[["str"],["str"]],["e"]]],[11,"from_ok","","",884,[[["t"]],["t"]]],[11,"map_same","","",884,[[["self"],["f"]],["t"]]],[11,"from","","",884,[[["t"]],["t"]]],[11,"into","","",884,[[["self"]],["u"]]],[11,"try_from","","",884,[[["u"]],["result"]]],[11,"borrow","","",884,[[["self"]],["t"]]],[11,"try_into","","",884,[[["self"]],["result"]]],[11,"borrow_mut","","",884,[[["self"]],["t"]]],[11,"get_type_id","","",884,[[["self"]],["typeid"]]],[11,"not_found","","",884,[[["str"],["str"]],["e"]]],[11,"from_ok","","",885,[[["t"]],["t"]]],[11,"map_same","","",885,[[["self"],["f"]],["t"]]],[11,"from","","",885,[[["t"]],["t"]]],[11,"into","","",885,[[["self"]],["u"]]],[11,"try_from","","",885,[[["u"]],["result"]]],[11,"borrow","","",885,[[["self"]],["t"]]],[11,"try_into","","",885,[[["self"]],["result"]]],[11,"borrow_mut","","",885,[[["self"]],["t"]]],[11,"get_type_id","","",885,[[["self"]],["typeid"]]],[11,"not_found","","",885,[[["str"],["str"]],["e"]]],[11,"from_ok","","",886,[[["t"]],["t"]]],[11,"map_same","","",886,[[["self"],["f"]],["t"]]],[11,"from","","",886,[[["t"]],["t"]]],[11,"into","","",886,[[["self"]],["u"]]],[11,"try_from","","",886,[[["u"]],["result"]]],[11,"borrow","","",886,[[["self"]],["t"]]],[11,"try_into","","",886,[[["self"]],["result"]]],[11,"borrow_mut","","",886,[[["self"]],["t"]]],[11,"get_type_id","","",886,[[["self"]],["typeid"]]],[11,"not_found","","",886,[[["str"],["str"]],["e"]]],[11,"from_ok","","",887,[[["t"]],["t"]]],[11,"map_same","","",887,[[["self"],["f"]],["t"]]],[11,"from","","",887,[[["t"]],["t"]]],[11,"into","","",887,[[["self"]],["u"]]],[11,"try_from","","",887,[[["u"]],["result"]]],[11,"borrow","","",887,[[["self"]],["t"]]],[11,"try_into","","",887,[[["self"]],["result"]]],[11,"borrow_mut","","",887,[[["self"]],["t"]]],[11,"get_type_id","","",887,[[["self"]],["typeid"]]],[11,"not_found","","",887,[[["str"],["str"]],["e"]]],[11,"from_ok","","",888,[[["t"]],["t"]]],[11,"map_same","","",888,[[["self"],["f"]],["t"]]],[11,"from","","",888,[[["t"]],["t"]]],[11,"into","","",888,[[["self"]],["u"]]],[11,"try_from","","",888,[[["u"]],["result"]]],[11,"borrow","","",888,[[["self"]],["t"]]],[11,"try_into","","",888,[[["self"]],["result"]]],[11,"borrow_mut","","",888,[[["self"]],["t"]]],[11,"get_type_id","","",888,[[["self"]],["typeid"]]],[11,"not_found","","",888,[[["str"],["str"]],["e"]]],[11,"from_ok","","",889,[[["t"]],["t"]]],[11,"map_same","","",889,[[["self"],["f"]],["t"]]],[11,"from","","",889,[[["t"]],["t"]]],[11,"into","","",889,[[["self"]],["u"]]],[11,"try_from","","",889,[[["u"]],["result"]]],[11,"borrow","","",889,[[["self"]],["t"]]],[11,"try_into","","",889,[[["self"]],["result"]]],[11,"borrow_mut","","",889,[[["self"]],["t"]]],[11,"get_type_id","","",889,[[["self"]],["typeid"]]],[11,"not_found","","",889,[[["str"],["str"]],["e"]]],[11,"from_ok","","",890,[[["t"]],["t"]]],[11,"map_same","","",890,[[["self"],["f"]],["t"]]],[11,"from","","",890,[[["t"]],["t"]]],[11,"into","","",890,[[["self"]],["u"]]],[11,"try_from","","",890,[[["u"]],["result"]]],[11,"borrow","","",890,[[["self"]],["t"]]],[11,"try_into","","",890,[[["self"]],["result"]]],[11,"borrow_mut","","",890,[[["self"]],["t"]]],[11,"get_type_id","","",890,[[["self"]],["typeid"]]],[11,"not_found","","",890,[[["str"],["str"]],["e"]]],[11,"from_ok","","",891,[[["t"]],["t"]]],[11,"map_same","","",891,[[["self"],["f"]],["t"]]],[11,"from","","",891,[[["t"]],["t"]]],[11,"into","","",891,[[["self"]],["u"]]],[11,"try_from","","",891,[[["u"]],["result"]]],[11,"borrow","","",891,[[["self"]],["t"]]],[11,"try_into","","",891,[[["self"]],["result"]]],[11,"borrow_mut","","",891,[[["self"]],["t"]]],[11,"get_type_id","","",891,[[["self"]],["typeid"]]],[11,"not_found","","",891,[[["str"],["str"]],["e"]]],[11,"from_ok","","",892,[[["t"]],["t"]]],[11,"map_same","","",892,[[["self"],["f"]],["t"]]],[11,"from","","",892,[[["t"]],["t"]]],[11,"into","","",892,[[["self"]],["u"]]],[11,"try_from","","",892,[[["u"]],["result"]]],[11,"borrow","","",892,[[["self"]],["t"]]],[11,"try_into","","",892,[[["self"]],["result"]]],[11,"borrow_mut","","",892,[[["self"]],["t"]]],[11,"get_type_id","","",892,[[["self"]],["typeid"]]],[11,"not_found","","",892,[[["str"],["str"]],["e"]]],[11,"from_ok","","",893,[[["t"]],["t"]]],[11,"map_same","","",893,[[["self"],["f"]],["t"]]],[11,"from","","",893,[[["t"]],["t"]]],[11,"into","","",893,[[["self"]],["u"]]],[11,"try_from","","",893,[[["u"]],["result"]]],[11,"borrow","","",893,[[["self"]],["t"]]],[11,"try_into","","",893,[[["self"]],["result"]]],[11,"borrow_mut","","",893,[[["self"]],["t"]]],[11,"get_type_id","","",893,[[["self"]],["typeid"]]],[11,"not_found","","",893,[[["str"],["str"]],["e"]]],[11,"from_ok","","",894,[[["t"]],["t"]]],[11,"map_same","","",894,[[["self"],["f"]],["t"]]],[11,"from","","",894,[[["t"]],["t"]]],[11,"into","","",894,[[["self"]],["u"]]],[11,"try_from","","",894,[[["u"]],["result"]]],[11,"borrow","","",894,[[["self"]],["t"]]],[11,"try_into","","",894,[[["self"]],["result"]]],[11,"borrow_mut","","",894,[[["self"]],["t"]]],[11,"get_type_id","","",894,[[["self"]],["typeid"]]],[11,"not_found","","",894,[[["str"],["str"]],["e"]]],[11,"from_ok","","",895,[[["t"]],["t"]]],[11,"map_same","","",895,[[["self"],["f"]],["t"]]],[11,"from","","",895,[[["t"]],["t"]]],[11,"into","","",895,[[["self"]],["u"]]],[11,"try_from","","",895,[[["u"]],["result"]]],[11,"borrow","","",895,[[["self"]],["t"]]],[11,"try_into","","",895,[[["self"]],["result"]]],[11,"borrow_mut","","",895,[[["self"]],["t"]]],[11,"get_type_id","","",895,[[["self"]],["typeid"]]],[11,"not_found","","",895,[[["str"],["str"]],["e"]]],[11,"from_ok","","",896,[[["t"]],["t"]]],[11,"map_same","","",896,[[["self"],["f"]],["t"]]],[11,"from","","",896,[[["t"]],["t"]]],[11,"into","","",896,[[["self"]],["u"]]],[11,"try_from","","",896,[[["u"]],["result"]]],[11,"borrow","","",896,[[["self"]],["t"]]],[11,"try_into","","",896,[[["self"]],["result"]]],[11,"borrow_mut","","",896,[[["self"]],["t"]]],[11,"get_type_id","","",896,[[["self"]],["typeid"]]],[11,"not_found","","",896,[[["str"],["str"]],["e"]]],[11,"from_ok","","",897,[[["t"]],["t"]]],[11,"map_same","","",897,[[["self"],["f"]],["t"]]],[11,"from","","",897,[[["t"]],["t"]]],[11,"into","","",897,[[["self"]],["u"]]],[11,"try_from","","",897,[[["u"]],["result"]]],[11,"borrow","","",897,[[["self"]],["t"]]],[11,"try_into","","",897,[[["self"]],["result"]]],[11,"borrow_mut","","",897,[[["self"]],["t"]]],[11,"get_type_id","","",897,[[["self"]],["typeid"]]],[11,"not_found","","",897,[[["str"],["str"]],["e"]]],[11,"from_ok","","",898,[[["t"]],["t"]]],[11,"map_same","","",898,[[["self"],["f"]],["t"]]],[11,"from","","",898,[[["t"]],["t"]]],[11,"into","","",898,[[["self"]],["u"]]],[11,"try_from","","",898,[[["u"]],["result"]]],[11,"borrow","","",898,[[["self"]],["t"]]],[11,"try_into","","",898,[[["self"]],["result"]]],[11,"borrow_mut","","",898,[[["self"]],["t"]]],[11,"get_type_id","","",898,[[["self"]],["typeid"]]],[11,"not_found","","",898,[[["str"],["str"]],["e"]]],[11,"from_ok","","",899,[[["t"]],["t"]]],[11,"map_same","","",899,[[["self"],["f"]],["t"]]],[11,"from","","",899,[[["t"]],["t"]]],[11,"into","","",899,[[["self"]],["u"]]],[11,"try_from","","",899,[[["u"]],["result"]]],[11,"borrow","","",899,[[["self"]],["t"]]],[11,"try_into","","",899,[[["self"]],["result"]]],[11,"borrow_mut","","",899,[[["self"]],["t"]]],[11,"get_type_id","","",899,[[["self"]],["typeid"]]],[11,"not_found","","",899,[[["str"],["str"]],["e"]]],[11,"from_ok","","",900,[[["t"]],["t"]]],[11,"map_same","","",900,[[["self"],["f"]],["t"]]],[11,"from","","",900,[[["t"]],["t"]]],[11,"into","","",900,[[["self"]],["u"]]],[11,"try_from","","",900,[[["u"]],["result"]]],[11,"borrow","","",900,[[["self"]],["t"]]],[11,"try_into","","",900,[[["self"]],["result"]]],[11,"borrow_mut","","",900,[[["self"]],["t"]]],[11,"get_type_id","","",900,[[["self"]],["typeid"]]],[11,"not_found","","",900,[[["str"],["str"]],["e"]]],[11,"from_ok","","",901,[[["t"]],["t"]]],[11,"map_same","","",901,[[["self"],["f"]],["t"]]],[11,"from","","",901,[[["t"]],["t"]]],[11,"into","","",901,[[["self"]],["u"]]],[11,"try_from","","",901,[[["u"]],["result"]]],[11,"borrow","","",901,[[["self"]],["t"]]],[11,"try_into","","",901,[[["self"]],["result"]]],[11,"borrow_mut","","",901,[[["self"]],["t"]]],[11,"get_type_id","","",901,[[["self"]],["typeid"]]],[11,"not_found","","",901,[[["str"],["str"]],["e"]]],[11,"from_ok","","",902,[[["t"]],["t"]]],[11,"map_same","","",902,[[["self"],["f"]],["t"]]],[11,"from","","",902,[[["t"]],["t"]]],[11,"into","","",902,[[["self"]],["u"]]],[11,"try_from","","",902,[[["u"]],["result"]]],[11,"borrow","","",902,[[["self"]],["t"]]],[11,"try_into","","",902,[[["self"]],["result"]]],[11,"borrow_mut","","",902,[[["self"]],["t"]]],[11,"get_type_id","","",902,[[["self"]],["typeid"]]],[11,"not_found","","",902,[[["str"],["str"]],["e"]]],[11,"from_ok","","",903,[[["t"]],["t"]]],[11,"map_same","","",903,[[["self"],["f"]],["t"]]],[11,"from","","",903,[[["t"]],["t"]]],[11,"into","","",903,[[["self"]],["u"]]],[11,"try_from","","",903,[[["u"]],["result"]]],[11,"borrow","","",903,[[["self"]],["t"]]],[11,"try_into","","",903,[[["self"]],["result"]]],[11,"borrow_mut","","",903,[[["self"]],["t"]]],[11,"get_type_id","","",903,[[["self"]],["typeid"]]],[11,"not_found","","",903,[[["str"],["str"]],["e"]]],[11,"from_ok","","",904,[[["t"]],["t"]]],[11,"map_same","","",904,[[["self"],["f"]],["t"]]],[11,"from","","",904,[[["t"]],["t"]]],[11,"into","","",904,[[["self"]],["u"]]],[11,"try_from","","",904,[[["u"]],["result"]]],[11,"borrow","","",904,[[["self"]],["t"]]],[11,"try_into","","",904,[[["self"]],["result"]]],[11,"borrow_mut","","",904,[[["self"]],["t"]]],[11,"get_type_id","","",904,[[["self"]],["typeid"]]],[11,"not_found","","",904,[[["str"],["str"]],["e"]]],[11,"from_ok","","",905,[[["t"]],["t"]]],[11,"map_same","","",905,[[["self"],["f"]],["t"]]],[11,"from","","",905,[[["t"]],["t"]]],[11,"into","","",905,[[["self"]],["u"]]],[11,"try_from","","",905,[[["u"]],["result"]]],[11,"borrow","","",905,[[["self"]],["t"]]],[11,"try_into","","",905,[[["self"]],["result"]]],[11,"borrow_mut","","",905,[[["self"]],["t"]]],[11,"get_type_id","","",905,[[["self"]],["typeid"]]],[11,"not_found","","",905,[[["str"],["str"]],["e"]]],[11,"from_ok","","",906,[[["t"]],["t"]]],[11,"map_same","","",906,[[["self"],["f"]],["t"]]],[11,"from","","",906,[[["t"]],["t"]]],[11,"into","","",906,[[["self"]],["u"]]],[11,"try_from","","",906,[[["u"]],["result"]]],[11,"borrow","","",906,[[["self"]],["t"]]],[11,"try_into","","",906,[[["self"]],["result"]]],[11,"borrow_mut","","",906,[[["self"]],["t"]]],[11,"get_type_id","","",906,[[["self"]],["typeid"]]],[11,"not_found","","",906,[[["str"],["str"]],["e"]]],[11,"from_ok","","",907,[[["t"]],["t"]]],[11,"map_same","","",907,[[["self"],["f"]],["t"]]],[11,"from","","",907,[[["t"]],["t"]]],[11,"into","","",907,[[["self"]],["u"]]],[11,"try_from","","",907,[[["u"]],["result"]]],[11,"borrow","","",907,[[["self"]],["t"]]],[11,"try_into","","",907,[[["self"]],["result"]]],[11,"borrow_mut","","",907,[[["self"]],["t"]]],[11,"get_type_id","","",907,[[["self"]],["typeid"]]],[11,"not_found","","",907,[[["str"],["str"]],["e"]]],[11,"from_ok","","",908,[[["t"]],["t"]]],[11,"map_same","","",908,[[["self"],["f"]],["t"]]],[11,"from","","",908,[[["t"]],["t"]]],[11,"into","","",908,[[["self"]],["u"]]],[11,"try_from","","",908,[[["u"]],["result"]]],[11,"borrow","","",908,[[["self"]],["t"]]],[11,"try_into","","",908,[[["self"]],["result"]]],[11,"borrow_mut","","",908,[[["self"]],["t"]]],[11,"get_type_id","","",908,[[["self"]],["typeid"]]],[11,"not_found","","",908,[[["str"],["str"]],["e"]]],[11,"from_ok","","",909,[[["t"]],["t"]]],[11,"map_same","","",909,[[["self"],["f"]],["t"]]],[11,"from","","",909,[[["t"]],["t"]]],[11,"into","","",909,[[["self"]],["u"]]],[11,"try_from","","",909,[[["u"]],["result"]]],[11,"borrow","","",909,[[["self"]],["t"]]],[11,"try_into","","",909,[[["self"]],["result"]]],[11,"borrow_mut","","",909,[[["self"]],["t"]]],[11,"get_type_id","","",909,[[["self"]],["typeid"]]],[11,"not_found","","",909,[[["str"],["str"]],["e"]]],[11,"from_ok","","",910,[[["t"]],["t"]]],[11,"map_same","","",910,[[["self"],["f"]],["t"]]],[11,"from","","",910,[[["t"]],["t"]]],[11,"into","","",910,[[["self"]],["u"]]],[11,"try_from","","",910,[[["u"]],["result"]]],[11,"borrow","","",910,[[["self"]],["t"]]],[11,"try_into","","",910,[[["self"]],["result"]]],[11,"borrow_mut","","",910,[[["self"]],["t"]]],[11,"get_type_id","","",910,[[["self"]],["typeid"]]],[11,"not_found","","",910,[[["str"],["str"]],["e"]]],[11,"from_ok","","",911,[[["t"]],["t"]]],[11,"map_same","","",911,[[["self"],["f"]],["t"]]],[11,"from","","",911,[[["t"]],["t"]]],[11,"into","","",911,[[["self"]],["u"]]],[11,"try_from","","",911,[[["u"]],["result"]]],[11,"borrow","","",911,[[["self"]],["t"]]],[11,"try_into","","",911,[[["self"]],["result"]]],[11,"borrow_mut","","",911,[[["self"]],["t"]]],[11,"get_type_id","","",911,[[["self"]],["typeid"]]],[11,"not_found","","",911,[[["str"],["str"]],["e"]]],[11,"from_ok","","",912,[[["t"]],["t"]]],[11,"map_same","","",912,[[["self"],["f"]],["t"]]],[11,"from","","",912,[[["t"]],["t"]]],[11,"into","","",912,[[["self"]],["u"]]],[11,"try_from","","",912,[[["u"]],["result"]]],[11,"borrow","","",912,[[["self"]],["t"]]],[11,"try_into","","",912,[[["self"]],["result"]]],[11,"borrow_mut","","",912,[[["self"]],["t"]]],[11,"get_type_id","","",912,[[["self"]],["typeid"]]],[11,"not_found","","",912,[[["str"],["str"]],["e"]]],[11,"from_ok","","",913,[[["t"]],["t"]]],[11,"map_same","","",913,[[["self"],["f"]],["t"]]],[11,"from","","",913,[[["t"]],["t"]]],[11,"into","","",913,[[["self"]],["u"]]],[11,"try_from","","",913,[[["u"]],["result"]]],[11,"borrow","","",913,[[["self"]],["t"]]],[11,"try_into","","",913,[[["self"]],["result"]]],[11,"borrow_mut","","",913,[[["self"]],["t"]]],[11,"get_type_id","","",913,[[["self"]],["typeid"]]],[11,"not_found","","",913,[[["str"],["str"]],["e"]]],[11,"from_ok","","",914,[[["t"]],["t"]]],[11,"map_same","","",914,[[["self"],["f"]],["t"]]],[11,"from","","",914,[[["t"]],["t"]]],[11,"into","","",914,[[["self"]],["u"]]],[11,"try_from","","",914,[[["u"]],["result"]]],[11,"borrow","","",914,[[["self"]],["t"]]],[11,"try_into","","",914,[[["self"]],["result"]]],[11,"borrow_mut","","",914,[[["self"]],["t"]]],[11,"get_type_id","","",914,[[["self"]],["typeid"]]],[11,"not_found","","",914,[[["str"],["str"]],["e"]]],[11,"from_ok","","",915,[[["t"]],["t"]]],[11,"map_same","","",915,[[["self"],["f"]],["t"]]],[11,"from","","",915,[[["t"]],["t"]]],[11,"into","","",915,[[["self"]],["u"]]],[11,"try_from","","",915,[[["u"]],["result"]]],[11,"borrow","","",915,[[["self"]],["t"]]],[11,"try_into","","",915,[[["self"]],["result"]]],[11,"borrow_mut","","",915,[[["self"]],["t"]]],[11,"get_type_id","","",915,[[["self"]],["typeid"]]],[11,"not_found","","",915,[[["str"],["str"]],["e"]]],[11,"from_ok","","",916,[[["t"]],["t"]]],[11,"map_same","","",916,[[["self"],["f"]],["t"]]],[11,"from","","",916,[[["t"]],["t"]]],[11,"into","","",916,[[["self"]],["u"]]],[11,"try_from","","",916,[[["u"]],["result"]]],[11,"borrow","","",916,[[["self"]],["t"]]],[11,"try_into","","",916,[[["self"]],["result"]]],[11,"borrow_mut","","",916,[[["self"]],["t"]]],[11,"get_type_id","","",916,[[["self"]],["typeid"]]],[11,"not_found","","",916,[[["str"],["str"]],["e"]]],[11,"from_ok","","",917,[[["t"]],["t"]]],[11,"map_same","","",917,[[["self"],["f"]],["t"]]],[11,"from","","",917,[[["t"]],["t"]]],[11,"into","","",917,[[["self"]],["u"]]],[11,"try_from","","",917,[[["u"]],["result"]]],[11,"borrow","","",917,[[["self"]],["t"]]],[11,"try_into","","",917,[[["self"]],["result"]]],[11,"borrow_mut","","",917,[[["self"]],["t"]]],[11,"get_type_id","","",917,[[["self"]],["typeid"]]],[11,"not_found","","",917,[[["str"],["str"]],["e"]]],[11,"from_ok","","",918,[[["t"]],["t"]]],[11,"map_same","","",918,[[["self"],["f"]],["t"]]],[11,"from","","",918,[[["t"]],["t"]]],[11,"into","","",918,[[["self"]],["u"]]],[11,"try_from","","",918,[[["u"]],["result"]]],[11,"borrow","","",918,[[["self"]],["t"]]],[11,"try_into","","",918,[[["self"]],["result"]]],[11,"borrow_mut","","",918,[[["self"]],["t"]]],[11,"get_type_id","","",918,[[["self"]],["typeid"]]],[11,"not_found","","",918,[[["str"],["str"]],["e"]]],[11,"from_ok","","",919,[[["t"]],["t"]]],[11,"map_same","","",919,[[["self"],["f"]],["t"]]],[11,"from","","",919,[[["t"]],["t"]]],[11,"into","","",919,[[["self"]],["u"]]],[11,"try_from","","",919,[[["u"]],["result"]]],[11,"borrow","","",919,[[["self"]],["t"]]],[11,"try_into","","",919,[[["self"]],["result"]]],[11,"borrow_mut","","",919,[[["self"]],["t"]]],[11,"get_type_id","","",919,[[["self"]],["typeid"]]],[11,"not_found","","",919,[[["str"],["str"]],["e"]]],[11,"from_ok","","",920,[[["t"]],["t"]]],[11,"map_same","","",920,[[["self"],["f"]],["t"]]],[11,"from","","",920,[[["t"]],["t"]]],[11,"into","","",920,[[["self"]],["u"]]],[11,"try_from","","",920,[[["u"]],["result"]]],[11,"borrow","","",920,[[["self"]],["t"]]],[11,"try_into","","",920,[[["self"]],["result"]]],[11,"borrow_mut","","",920,[[["self"]],["t"]]],[11,"get_type_id","","",920,[[["self"]],["typeid"]]],[11,"not_found","","",920,[[["str"],["str"]],["e"]]],[11,"from_ok","","",921,[[["t"]],["t"]]],[11,"map_same","","",921,[[["self"],["f"]],["t"]]],[11,"from","","",921,[[["t"]],["t"]]],[11,"into","","",921,[[["self"]],["u"]]],[11,"try_from","","",921,[[["u"]],["result"]]],[11,"borrow","","",921,[[["self"]],["t"]]],[11,"try_into","","",921,[[["self"]],["result"]]],[11,"borrow_mut","","",921,[[["self"]],["t"]]],[11,"get_type_id","","",921,[[["self"]],["typeid"]]],[11,"not_found","","",921,[[["str"],["str"]],["e"]]],[11,"from_ok","","",922,[[["t"]],["t"]]],[11,"map_same","","",922,[[["self"],["f"]],["t"]]],[11,"from","","",922,[[["t"]],["t"]]],[11,"into","","",922,[[["self"]],["u"]]],[11,"try_from","","",922,[[["u"]],["result"]]],[11,"borrow","","",922,[[["self"]],["t"]]],[11,"try_into","","",922,[[["self"]],["result"]]],[11,"borrow_mut","","",922,[[["self"]],["t"]]],[11,"get_type_id","","",922,[[["self"]],["typeid"]]],[11,"not_found","","",922,[[["str"],["str"]],["e"]]],[11,"from_ok","","",923,[[["t"]],["t"]]],[11,"map_same","","",923,[[["self"],["f"]],["t"]]],[11,"from","","",923,[[["t"]],["t"]]],[11,"into","","",923,[[["self"]],["u"]]],[11,"try_from","","",923,[[["u"]],["result"]]],[11,"borrow","","",923,[[["self"]],["t"]]],[11,"try_into","","",923,[[["self"]],["result"]]],[11,"borrow_mut","","",923,[[["self"]],["t"]]],[11,"get_type_id","","",923,[[["self"]],["typeid"]]],[11,"not_found","","",923,[[["str"],["str"]],["e"]]],[11,"from_ok","","",924,[[["t"]],["t"]]],[11,"map_same","","",924,[[["self"],["f"]],["t"]]],[11,"from","","",924,[[["t"]],["t"]]],[11,"into","","",924,[[["self"]],["u"]]],[11,"try_from","","",924,[[["u"]],["result"]]],[11,"borrow","","",924,[[["self"]],["t"]]],[11,"try_into","","",924,[[["self"]],["result"]]],[11,"borrow_mut","","",924,[[["self"]],["t"]]],[11,"get_type_id","","",924,[[["self"]],["typeid"]]],[11,"not_found","","",924,[[["str"],["str"]],["e"]]],[11,"from_ok","","",925,[[["t"]],["t"]]],[11,"map_same","","",925,[[["self"],["f"]],["t"]]],[11,"from","","",925,[[["t"]],["t"]]],[11,"into","","",925,[[["self"]],["u"]]],[11,"try_from","","",925,[[["u"]],["result"]]],[11,"borrow","","",925,[[["self"]],["t"]]],[11,"try_into","","",925,[[["self"]],["result"]]],[11,"borrow_mut","","",925,[[["self"]],["t"]]],[11,"get_type_id","","",925,[[["self"]],["typeid"]]],[11,"not_found","","",925,[[["str"],["str"]],["e"]]],[11,"from_ok","","",926,[[["t"]],["t"]]],[11,"map_same","","",926,[[["self"],["f"]],["t"]]],[11,"from","","",926,[[["t"]],["t"]]],[11,"into","","",926,[[["self"]],["u"]]],[11,"try_from","","",926,[[["u"]],["result"]]],[11,"borrow","","",926,[[["self"]],["t"]]],[11,"try_into","","",926,[[["self"]],["result"]]],[11,"borrow_mut","","",926,[[["self"]],["t"]]],[11,"get_type_id","","",926,[[["self"]],["typeid"]]],[11,"not_found","","",926,[[["str"],["str"]],["e"]]],[11,"from_ok","","",927,[[["t"]],["t"]]],[11,"map_same","","",927,[[["self"],["f"]],["t"]]],[11,"from","","",927,[[["t"]],["t"]]],[11,"into","","",927,[[["self"]],["u"]]],[11,"try_from","","",927,[[["u"]],["result"]]],[11,"borrow","","",927,[[["self"]],["t"]]],[11,"try_into","","",927,[[["self"]],["result"]]],[11,"borrow_mut","","",927,[[["self"]],["t"]]],[11,"get_type_id","","",927,[[["self"]],["typeid"]]],[11,"not_found","","",927,[[["str"],["str"]],["e"]]],[11,"from_ok","","",928,[[["t"]],["t"]]],[11,"map_same","","",928,[[["self"],["f"]],["t"]]],[11,"from","","",928,[[["t"]],["t"]]],[11,"into","","",928,[[["self"]],["u"]]],[11,"try_from","","",928,[[["u"]],["result"]]],[11,"borrow","","",928,[[["self"]],["t"]]],[11,"try_into","","",928,[[["self"]],["result"]]],[11,"borrow_mut","","",928,[[["self"]],["t"]]],[11,"get_type_id","","",928,[[["self"]],["typeid"]]],[11,"not_found","","",928,[[["str"],["str"]],["e"]]],[11,"from_ok","","",929,[[["t"]],["t"]]],[11,"map_same","","",929,[[["self"],["f"]],["t"]]],[11,"from","","",929,[[["t"]],["t"]]],[11,"into","","",929,[[["self"]],["u"]]],[11,"try_from","","",929,[[["u"]],["result"]]],[11,"borrow","","",929,[[["self"]],["t"]]],[11,"try_into","","",929,[[["self"]],["result"]]],[11,"borrow_mut","","",929,[[["self"]],["t"]]],[11,"get_type_id","","",929,[[["self"]],["typeid"]]],[11,"not_found","","",929,[[["str"],["str"]],["e"]]],[11,"from_ok","","",930,[[["t"]],["t"]]],[11,"map_same","","",930,[[["self"],["f"]],["t"]]],[11,"from","","",930,[[["t"]],["t"]]],[11,"into","","",930,[[["self"]],["u"]]],[11,"try_from","","",930,[[["u"]],["result"]]],[11,"borrow","","",930,[[["self"]],["t"]]],[11,"try_into","","",930,[[["self"]],["result"]]],[11,"borrow_mut","","",930,[[["self"]],["t"]]],[11,"get_type_id","","",930,[[["self"]],["typeid"]]],[11,"not_found","","",930,[[["str"],["str"]],["e"]]],[11,"from_ok","","",931,[[["t"]],["t"]]],[11,"map_same","","",931,[[["self"],["f"]],["t"]]],[11,"from","","",931,[[["t"]],["t"]]],[11,"into","","",931,[[["self"]],["u"]]],[11,"try_from","","",931,[[["u"]],["result"]]],[11,"borrow","","",931,[[["self"]],["t"]]],[11,"try_into","","",931,[[["self"]],["result"]]],[11,"borrow_mut","","",931,[[["self"]],["t"]]],[11,"get_type_id","","",931,[[["self"]],["typeid"]]],[11,"not_found","","",931,[[["str"],["str"]],["e"]]],[11,"from_ok","","",932,[[["t"]],["t"]]],[11,"map_same","","",932,[[["self"],["f"]],["t"]]],[11,"from","","",932,[[["t"]],["t"]]],[11,"into","","",932,[[["self"]],["u"]]],[11,"try_from","","",932,[[["u"]],["result"]]],[11,"borrow","","",932,[[["self"]],["t"]]],[11,"try_into","","",932,[[["self"]],["result"]]],[11,"borrow_mut","","",932,[[["self"]],["t"]]],[11,"get_type_id","","",932,[[["self"]],["typeid"]]],[11,"not_found","","",932,[[["str"],["str"]],["e"]]],[11,"from_ok","","",933,[[["t"]],["t"]]],[11,"map_same","","",933,[[["self"],["f"]],["t"]]],[11,"from","","",933,[[["t"]],["t"]]],[11,"into","","",933,[[["self"]],["u"]]],[11,"try_from","","",933,[[["u"]],["result"]]],[11,"borrow","","",933,[[["self"]],["t"]]],[11,"try_into","","",933,[[["self"]],["result"]]],[11,"borrow_mut","","",933,[[["self"]],["t"]]],[11,"get_type_id","","",933,[[["self"]],["typeid"]]],[11,"not_found","","",933,[[["str"],["str"]],["e"]]],[11,"from_ok","","",934,[[["t"]],["t"]]],[11,"map_same","","",934,[[["self"],["f"]],["t"]]],[11,"from","","",934,[[["t"]],["t"]]],[11,"into","","",934,[[["self"]],["u"]]],[11,"try_from","","",934,[[["u"]],["result"]]],[11,"borrow","","",934,[[["self"]],["t"]]],[11,"try_into","","",934,[[["self"]],["result"]]],[11,"borrow_mut","","",934,[[["self"]],["t"]]],[11,"get_type_id","","",934,[[["self"]],["typeid"]]],[11,"not_found","","",934,[[["str"],["str"]],["e"]]],[11,"from_ok","","",935,[[["t"]],["t"]]],[11,"map_same","","",935,[[["self"],["f"]],["t"]]],[11,"from","","",935,[[["t"]],["t"]]],[11,"into","","",935,[[["self"]],["u"]]],[11,"try_from","","",935,[[["u"]],["result"]]],[11,"borrow","","",935,[[["self"]],["t"]]],[11,"try_into","","",935,[[["self"]],["result"]]],[11,"borrow_mut","","",935,[[["self"]],["t"]]],[11,"get_type_id","","",935,[[["self"]],["typeid"]]],[11,"not_found","","",935,[[["str"],["str"]],["e"]]],[11,"from_ok","","",936,[[["t"]],["t"]]],[11,"map_same","","",936,[[["self"],["f"]],["t"]]],[11,"from","","",936,[[["t"]],["t"]]],[11,"into","","",936,[[["self"]],["u"]]],[11,"try_from","","",936,[[["u"]],["result"]]],[11,"borrow","","",936,[[["self"]],["t"]]],[11,"try_into","","",936,[[["self"]],["result"]]],[11,"borrow_mut","","",936,[[["self"]],["t"]]],[11,"get_type_id","","",936,[[["self"]],["typeid"]]],[11,"not_found","","",936,[[["str"],["str"]],["e"]]],[11,"from_ok","","",937,[[["t"]],["t"]]],[11,"map_same","","",937,[[["self"],["f"]],["t"]]],[11,"from","","",937,[[["t"]],["t"]]],[11,"into","","",937,[[["self"]],["u"]]],[11,"try_from","","",937,[[["u"]],["result"]]],[11,"borrow","","",937,[[["self"]],["t"]]],[11,"try_into","","",937,[[["self"]],["result"]]],[11,"borrow_mut","","",937,[[["self"]],["t"]]],[11,"get_type_id","","",937,[[["self"]],["typeid"]]],[11,"not_found","","",937,[[["str"],["str"]],["e"]]],[11,"from_ok","","",938,[[["t"]],["t"]]],[11,"map_same","","",938,[[["self"],["f"]],["t"]]],[11,"from","","",938,[[["t"]],["t"]]],[11,"into","","",938,[[["self"]],["u"]]],[11,"try_from","","",938,[[["u"]],["result"]]],[11,"borrow","","",938,[[["self"]],["t"]]],[11,"try_into","","",938,[[["self"]],["result"]]],[11,"borrow_mut","","",938,[[["self"]],["t"]]],[11,"get_type_id","","",938,[[["self"]],["typeid"]]],[11,"not_found","","",938,[[["str"],["str"]],["e"]]],[11,"from_ok","","",939,[[["t"]],["t"]]],[11,"map_same","","",939,[[["self"],["f"]],["t"]]],[11,"from","","",939,[[["t"]],["t"]]],[11,"into","","",939,[[["self"]],["u"]]],[11,"try_from","","",939,[[["u"]],["result"]]],[11,"borrow","","",939,[[["self"]],["t"]]],[11,"try_into","","",939,[[["self"]],["result"]]],[11,"borrow_mut","","",939,[[["self"]],["t"]]],[11,"get_type_id","","",939,[[["self"]],["typeid"]]],[11,"not_found","","",939,[[["str"],["str"]],["e"]]],[11,"from_ok","","",940,[[["t"]],["t"]]],[11,"map_same","","",940,[[["self"],["f"]],["t"]]],[11,"from","","",940,[[["t"]],["t"]]],[11,"into","","",940,[[["self"]],["u"]]],[11,"try_from","","",940,[[["u"]],["result"]]],[11,"borrow","","",940,[[["self"]],["t"]]],[11,"try_into","","",940,[[["self"]],["result"]]],[11,"borrow_mut","","",940,[[["self"]],["t"]]],[11,"get_type_id","","",940,[[["self"]],["typeid"]]],[11,"not_found","","",940,[[["str"],["str"]],["e"]]],[11,"from_ok","","",941,[[["t"]],["t"]]],[11,"map_same","","",941,[[["self"],["f"]],["t"]]],[11,"from","","",941,[[["t"]],["t"]]],[11,"into","","",941,[[["self"]],["u"]]],[11,"try_from","","",941,[[["u"]],["result"]]],[11,"borrow","","",941,[[["self"]],["t"]]],[11,"try_into","","",941,[[["self"]],["result"]]],[11,"borrow_mut","","",941,[[["self"]],["t"]]],[11,"get_type_id","","",941,[[["self"]],["typeid"]]],[11,"not_found","","",941,[[["str"],["str"]],["e"]]],[11,"from_ok","","",942,[[["t"]],["t"]]],[11,"map_same","","",942,[[["self"],["f"]],["t"]]],[11,"from","","",942,[[["t"]],["t"]]],[11,"into","","",942,[[["self"]],["u"]]],[11,"try_from","","",942,[[["u"]],["result"]]],[11,"borrow","","",942,[[["self"]],["t"]]],[11,"try_into","","",942,[[["self"]],["result"]]],[11,"borrow_mut","","",942,[[["self"]],["t"]]],[11,"get_type_id","","",942,[[["self"]],["typeid"]]],[11,"not_found","","",942,[[["str"],["str"]],["e"]]],[11,"from_ok","","",943,[[["t"]],["t"]]],[11,"map_same","","",943,[[["self"],["f"]],["t"]]],[11,"from","","",943,[[["t"]],["t"]]],[11,"into","","",943,[[["self"]],["u"]]],[11,"try_from","","",943,[[["u"]],["result"]]],[11,"borrow","","",943,[[["self"]],["t"]]],[11,"try_into","","",943,[[["self"]],["result"]]],[11,"borrow_mut","","",943,[[["self"]],["t"]]],[11,"get_type_id","","",943,[[["self"]],["typeid"]]],[11,"not_found","","",943,[[["str"],["str"]],["e"]]],[11,"from_ok","","",944,[[["t"]],["t"]]],[11,"map_same","","",944,[[["self"],["f"]],["t"]]],[11,"from","","",944,[[["t"]],["t"]]],[11,"into","","",944,[[["self"]],["u"]]],[11,"try_from","","",944,[[["u"]],["result"]]],[11,"borrow","","",944,[[["self"]],["t"]]],[11,"try_into","","",944,[[["self"]],["result"]]],[11,"borrow_mut","","",944,[[["self"]],["t"]]],[11,"get_type_id","","",944,[[["self"]],["typeid"]]],[11,"not_found","","",944,[[["str"],["str"]],["e"]]],[11,"from_ok","","",945,[[["t"]],["t"]]],[11,"map_same","","",945,[[["self"],["f"]],["t"]]],[11,"from","","",945,[[["t"]],["t"]]],[11,"into","","",945,[[["self"]],["u"]]],[11,"try_from","","",945,[[["u"]],["result"]]],[11,"borrow","","",945,[[["self"]],["t"]]],[11,"try_into","","",945,[[["self"]],["result"]]],[11,"borrow_mut","","",945,[[["self"]],["t"]]],[11,"get_type_id","","",945,[[["self"]],["typeid"]]],[11,"not_found","","",945,[[["str"],["str"]],["e"]]],[11,"from_ok","","",946,[[["t"]],["t"]]],[11,"map_same","","",946,[[["self"],["f"]],["t"]]],[11,"from","","",946,[[["t"]],["t"]]],[11,"into","","",946,[[["self"]],["u"]]],[11,"try_from","","",946,[[["u"]],["result"]]],[11,"borrow","","",946,[[["self"]],["t"]]],[11,"try_into","","",946,[[["self"]],["result"]]],[11,"borrow_mut","","",946,[[["self"]],["t"]]],[11,"get_type_id","","",946,[[["self"]],["typeid"]]],[11,"not_found","","",946,[[["str"],["str"]],["e"]]],[11,"from_ok","","",947,[[["t"]],["t"]]],[11,"map_same","","",947,[[["self"],["f"]],["t"]]],[11,"from","","",947,[[["t"]],["t"]]],[11,"into","","",947,[[["self"]],["u"]]],[11,"try_from","","",947,[[["u"]],["result"]]],[11,"borrow","","",947,[[["self"]],["t"]]],[11,"try_into","","",947,[[["self"]],["result"]]],[11,"borrow_mut","","",947,[[["self"]],["t"]]],[11,"get_type_id","","",947,[[["self"]],["typeid"]]],[11,"not_found","","",947,[[["str"],["str"]],["e"]]],[11,"from_ok","","",948,[[["t"]],["t"]]],[11,"map_same","","",948,[[["self"],["f"]],["t"]]],[11,"from","","",948,[[["t"]],["t"]]],[11,"into","","",948,[[["self"]],["u"]]],[11,"try_from","","",948,[[["u"]],["result"]]],[11,"borrow","","",948,[[["self"]],["t"]]],[11,"try_into","","",948,[[["self"]],["result"]]],[11,"borrow_mut","","",948,[[["self"]],["t"]]],[11,"get_type_id","","",948,[[["self"]],["typeid"]]],[11,"not_found","","",948,[[["str"],["str"]],["e"]]],[11,"from_ok","","",949,[[["t"]],["t"]]],[11,"map_same","","",949,[[["self"],["f"]],["t"]]],[11,"from","","",949,[[["t"]],["t"]]],[11,"into","","",949,[[["self"]],["u"]]],[11,"try_from","","",949,[[["u"]],["result"]]],[11,"borrow","","",949,[[["self"]],["t"]]],[11,"try_into","","",949,[[["self"]],["result"]]],[11,"borrow_mut","","",949,[[["self"]],["t"]]],[11,"get_type_id","","",949,[[["self"]],["typeid"]]],[11,"not_found","","",949,[[["str"],["str"]],["e"]]],[11,"from_ok","","",950,[[["t"]],["t"]]],[11,"map_same","","",950,[[["self"],["f"]],["t"]]],[11,"from","","",950,[[["t"]],["t"]]],[11,"into","","",950,[[["self"]],["u"]]],[11,"try_from","","",950,[[["u"]],["result"]]],[11,"borrow","","",950,[[["self"]],["t"]]],[11,"try_into","","",950,[[["self"]],["result"]]],[11,"borrow_mut","","",950,[[["self"]],["t"]]],[11,"get_type_id","","",950,[[["self"]],["typeid"]]],[11,"not_found","","",950,[[["str"],["str"]],["e"]]],[11,"from_ok","","",951,[[["t"]],["t"]]],[11,"map_same","","",951,[[["self"],["f"]],["t"]]],[11,"from","","",951,[[["t"]],["t"]]],[11,"into","","",951,[[["self"]],["u"]]],[11,"try_from","","",951,[[["u"]],["result"]]],[11,"borrow","","",951,[[["self"]],["t"]]],[11,"try_into","","",951,[[["self"]],["result"]]],[11,"borrow_mut","","",951,[[["self"]],["t"]]],[11,"get_type_id","","",951,[[["self"]],["typeid"]]],[11,"not_found","","",951,[[["str"],["str"]],["e"]]],[11,"from_ok","","",952,[[["t"]],["t"]]],[11,"map_same","","",952,[[["self"],["f"]],["t"]]],[11,"from","","",952,[[["t"]],["t"]]],[11,"into","","",952,[[["self"]],["u"]]],[11,"try_from","","",952,[[["u"]],["result"]]],[11,"borrow","","",952,[[["self"]],["t"]]],[11,"try_into","","",952,[[["self"]],["result"]]],[11,"borrow_mut","","",952,[[["self"]],["t"]]],[11,"get_type_id","","",952,[[["self"]],["typeid"]]],[11,"not_found","","",952,[[["str"],["str"]],["e"]]],[11,"from_ok","","",953,[[["t"]],["t"]]],[11,"map_same","","",953,[[["self"],["f"]],["t"]]],[11,"from","","",953,[[["t"]],["t"]]],[11,"into","","",953,[[["self"]],["u"]]],[11,"try_from","","",953,[[["u"]],["result"]]],[11,"borrow","","",953,[[["self"]],["t"]]],[11,"try_into","","",953,[[["self"]],["result"]]],[11,"borrow_mut","","",953,[[["self"]],["t"]]],[11,"get_type_id","","",953,[[["self"]],["typeid"]]],[11,"not_found","","",953,[[["str"],["str"]],["e"]]],[11,"from_ok","","",954,[[["t"]],["t"]]],[11,"map_same","","",954,[[["self"],["f"]],["t"]]],[11,"from","","",954,[[["t"]],["t"]]],[11,"into","","",954,[[["self"]],["u"]]],[11,"try_from","","",954,[[["u"]],["result"]]],[11,"borrow","","",954,[[["self"]],["t"]]],[11,"try_into","","",954,[[["self"]],["result"]]],[11,"borrow_mut","","",954,[[["self"]],["t"]]],[11,"get_type_id","","",954,[[["self"]],["typeid"]]],[11,"not_found","","",954,[[["str"],["str"]],["e"]]],[11,"from_ok","","",955,[[["t"]],["t"]]],[11,"map_same","","",955,[[["self"],["f"]],["t"]]],[11,"from","","",955,[[["t"]],["t"]]],[11,"into","","",955,[[["self"]],["u"]]],[11,"try_from","","",955,[[["u"]],["result"]]],[11,"borrow","","",955,[[["self"]],["t"]]],[11,"try_into","","",955,[[["self"]],["result"]]],[11,"borrow_mut","","",955,[[["self"]],["t"]]],[11,"get_type_id","","",955,[[["self"]],["typeid"]]],[11,"not_found","","",955,[[["str"],["str"]],["e"]]],[11,"from_ok","","",956,[[["t"]],["t"]]],[11,"map_same","","",956,[[["self"],["f"]],["t"]]],[11,"from","","",956,[[["t"]],["t"]]],[11,"into","","",956,[[["self"]],["u"]]],[11,"try_from","","",956,[[["u"]],["result"]]],[11,"borrow","","",956,[[["self"]],["t"]]],[11,"try_into","","",956,[[["self"]],["result"]]],[11,"borrow_mut","","",956,[[["self"]],["t"]]],[11,"get_type_id","","",956,[[["self"]],["typeid"]]],[11,"not_found","","",956,[[["str"],["str"]],["e"]]],[11,"from_ok","","",957,[[["t"]],["t"]]],[11,"map_same","","",957,[[["self"],["f"]],["t"]]],[11,"from","","",957,[[["t"]],["t"]]],[11,"into","","",957,[[["self"]],["u"]]],[11,"try_from","","",957,[[["u"]],["result"]]],[11,"borrow","","",957,[[["self"]],["t"]]],[11,"try_into","","",957,[[["self"]],["result"]]],[11,"borrow_mut","","",957,[[["self"]],["t"]]],[11,"get_type_id","","",957,[[["self"]],["typeid"]]],[11,"not_found","","",957,[[["str"],["str"]],["e"]]],[11,"from_ok","","",958,[[["t"]],["t"]]],[11,"map_same","","",958,[[["self"],["f"]],["t"]]],[11,"from","","",958,[[["t"]],["t"]]],[11,"into","","",958,[[["self"]],["u"]]],[11,"try_from","","",958,[[["u"]],["result"]]],[11,"borrow","","",958,[[["self"]],["t"]]],[11,"try_into","","",958,[[["self"]],["result"]]],[11,"borrow_mut","","",958,[[["self"]],["t"]]],[11,"get_type_id","","",958,[[["self"]],["typeid"]]],[11,"not_found","","",958,[[["str"],["str"]],["e"]]],[11,"from_ok","","",959,[[["t"]],["t"]]],[11,"map_same","","",959,[[["self"],["f"]],["t"]]],[11,"from","","",959,[[["t"]],["t"]]],[11,"into","","",959,[[["self"]],["u"]]],[11,"try_from","","",959,[[["u"]],["result"]]],[11,"borrow","","",959,[[["self"]],["t"]]],[11,"try_into","","",959,[[["self"]],["result"]]],[11,"borrow_mut","","",959,[[["self"]],["t"]]],[11,"get_type_id","","",959,[[["self"]],["typeid"]]],[11,"not_found","","",959,[[["str"],["str"]],["e"]]],[11,"from_ok","","",960,[[["t"]],["t"]]],[11,"map_same","","",960,[[["self"],["f"]],["t"]]],[11,"from","","",960,[[["t"]],["t"]]],[11,"into","","",960,[[["self"]],["u"]]],[11,"try_from","","",960,[[["u"]],["result"]]],[11,"borrow","","",960,[[["self"]],["t"]]],[11,"try_into","","",960,[[["self"]],["result"]]],[11,"borrow_mut","","",960,[[["self"]],["t"]]],[11,"get_type_id","","",960,[[["self"]],["typeid"]]],[11,"not_found","","",960,[[["str"],["str"]],["e"]]],[11,"from_ok","","",961,[[["t"]],["t"]]],[11,"map_same","","",961,[[["self"],["f"]],["t"]]],[11,"from","","",961,[[["t"]],["t"]]],[11,"into","","",961,[[["self"]],["u"]]],[11,"try_from","","",961,[[["u"]],["result"]]],[11,"borrow","","",961,[[["self"]],["t"]]],[11,"try_into","","",961,[[["self"]],["result"]]],[11,"borrow_mut","","",961,[[["self"]],["t"]]],[11,"get_type_id","","",961,[[["self"]],["typeid"]]],[11,"not_found","","",961,[[["str"],["str"]],["e"]]],[11,"from_ok","","",962,[[["t"]],["t"]]],[11,"map_same","","",962,[[["self"],["f"]],["t"]]],[11,"from","","",962,[[["t"]],["t"]]],[11,"into","","",962,[[["self"]],["u"]]],[11,"try_from","","",962,[[["u"]],["result"]]],[11,"borrow","","",962,[[["self"]],["t"]]],[11,"try_into","","",962,[[["self"]],["result"]]],[11,"borrow_mut","","",962,[[["self"]],["t"]]],[11,"get_type_id","","",962,[[["self"]],["typeid"]]],[11,"not_found","","",962,[[["str"],["str"]],["e"]]],[11,"from_ok","","",963,[[["t"]],["t"]]],[11,"map_same","","",963,[[["self"],["f"]],["t"]]],[11,"from","","",963,[[["t"]],["t"]]],[11,"into","","",963,[[["self"]],["u"]]],[11,"try_from","","",963,[[["u"]],["result"]]],[11,"borrow","","",963,[[["self"]],["t"]]],[11,"try_into","","",963,[[["self"]],["result"]]],[11,"borrow_mut","","",963,[[["self"]],["t"]]],[11,"get_type_id","","",963,[[["self"]],["typeid"]]],[11,"not_found","","",963,[[["str"],["str"]],["e"]]],[11,"from_ok","","",964,[[["t"]],["t"]]],[11,"map_same","","",964,[[["self"],["f"]],["t"]]],[11,"from","","",964,[[["t"]],["t"]]],[11,"into","","",964,[[["self"]],["u"]]],[11,"try_from","","",964,[[["u"]],["result"]]],[11,"borrow","","",964,[[["self"]],["t"]]],[11,"try_into","","",964,[[["self"]],["result"]]],[11,"borrow_mut","","",964,[[["self"]],["t"]]],[11,"get_type_id","","",964,[[["self"]],["typeid"]]],[11,"not_found","","",964,[[["str"],["str"]],["e"]]],[11,"from_ok","","",965,[[["t"]],["t"]]],[11,"map_same","","",965,[[["self"],["f"]],["t"]]],[11,"from","","",965,[[["t"]],["t"]]],[11,"into","","",965,[[["self"]],["u"]]],[11,"try_from","","",965,[[["u"]],["result"]]],[11,"borrow","","",965,[[["self"]],["t"]]],[11,"try_into","","",965,[[["self"]],["result"]]],[11,"borrow_mut","","",965,[[["self"]],["t"]]],[11,"get_type_id","","",965,[[["self"]],["typeid"]]],[11,"not_found","","",965,[[["str"],["str"]],["e"]]],[11,"from_ok","","",966,[[["t"]],["t"]]],[11,"map_same","","",966,[[["self"],["f"]],["t"]]],[11,"from","","",966,[[["t"]],["t"]]],[11,"into","","",966,[[["self"]],["u"]]],[11,"try_from","","",966,[[["u"]],["result"]]],[11,"borrow","","",966,[[["self"]],["t"]]],[11,"try_into","","",966,[[["self"]],["result"]]],[11,"borrow_mut","","",966,[[["self"]],["t"]]],[11,"get_type_id","","",966,[[["self"]],["typeid"]]],[11,"not_found","","",966,[[["str"],["str"]],["e"]]],[11,"from_ok","","",967,[[["t"]],["t"]]],[11,"map_same","","",967,[[["self"],["f"]],["t"]]],[11,"from","","",967,[[["t"]],["t"]]],[11,"into","","",967,[[["self"]],["u"]]],[11,"try_from","","",967,[[["u"]],["result"]]],[11,"borrow","","",967,[[["self"]],["t"]]],[11,"try_into","","",967,[[["self"]],["result"]]],[11,"borrow_mut","","",967,[[["self"]],["t"]]],[11,"get_type_id","","",967,[[["self"]],["typeid"]]],[11,"not_found","","",967,[[["str"],["str"]],["e"]]],[11,"from_ok","","",968,[[["t"]],["t"]]],[11,"map_same","","",968,[[["self"],["f"]],["t"]]],[11,"from","","",968,[[["t"]],["t"]]],[11,"into","","",968,[[["self"]],["u"]]],[11,"try_from","","",968,[[["u"]],["result"]]],[11,"borrow","","",968,[[["self"]],["t"]]],[11,"try_into","","",968,[[["self"]],["result"]]],[11,"borrow_mut","","",968,[[["self"]],["t"]]],[11,"get_type_id","","",968,[[["self"]],["typeid"]]],[11,"not_found","","",968,[[["str"],["str"]],["e"]]],[11,"from_ok","","",969,[[["t"]],["t"]]],[11,"map_same","","",969,[[["self"],["f"]],["t"]]],[11,"from","","",969,[[["t"]],["t"]]],[11,"into","","",969,[[["self"]],["u"]]],[11,"try_from","","",969,[[["u"]],["result"]]],[11,"borrow","","",969,[[["self"]],["t"]]],[11,"try_into","","",969,[[["self"]],["result"]]],[11,"borrow_mut","","",969,[[["self"]],["t"]]],[11,"get_type_id","","",969,[[["self"]],["typeid"]]],[11,"not_found","","",969,[[["str"],["str"]],["e"]]],[11,"from_ok","","",970,[[["t"]],["t"]]],[11,"map_same","","",970,[[["self"],["f"]],["t"]]],[11,"from","","",970,[[["t"]],["t"]]],[11,"into","","",970,[[["self"]],["u"]]],[11,"try_from","","",970,[[["u"]],["result"]]],[11,"borrow","","",970,[[["self"]],["t"]]],[11,"try_into","","",970,[[["self"]],["result"]]],[11,"borrow_mut","","",970,[[["self"]],["t"]]],[11,"get_type_id","","",970,[[["self"]],["typeid"]]],[11,"not_found","","",970,[[["str"],["str"]],["e"]]],[11,"from_ok","","",971,[[["t"]],["t"]]],[11,"map_same","","",971,[[["self"],["f"]],["t"]]],[11,"from","","",971,[[["t"]],["t"]]],[11,"into","","",971,[[["self"]],["u"]]],[11,"try_from","","",971,[[["u"]],["result"]]],[11,"borrow","","",971,[[["self"]],["t"]]],[11,"try_into","","",971,[[["self"]],["result"]]],[11,"borrow_mut","","",971,[[["self"]],["t"]]],[11,"get_type_id","","",971,[[["self"]],["typeid"]]],[11,"not_found","","",971,[[["str"],["str"]],["e"]]],[11,"from_ok","","",972,[[["t"]],["t"]]],[11,"map_same","","",972,[[["self"],["f"]],["t"]]],[11,"from","","",972,[[["t"]],["t"]]],[11,"into","","",972,[[["self"]],["u"]]],[11,"try_from","","",972,[[["u"]],["result"]]],[11,"borrow","","",972,[[["self"]],["t"]]],[11,"try_into","","",972,[[["self"]],["result"]]],[11,"borrow_mut","","",972,[[["self"]],["t"]]],[11,"get_type_id","","",972,[[["self"]],["typeid"]]],[11,"not_found","","",972,[[["str"],["str"]],["e"]]],[11,"from_ok","","",973,[[["t"]],["t"]]],[11,"map_same","","",973,[[["self"],["f"]],["t"]]],[11,"from","","",973,[[["t"]],["t"]]],[11,"into","","",973,[[["self"]],["u"]]],[11,"try_from","","",973,[[["u"]],["result"]]],[11,"borrow","","",973,[[["self"]],["t"]]],[11,"try_into","","",973,[[["self"]],["result"]]],[11,"borrow_mut","","",973,[[["self"]],["t"]]],[11,"get_type_id","","",973,[[["self"]],["typeid"]]],[11,"not_found","","",973,[[["str"],["str"]],["e"]]],[11,"from_ok","","",974,[[["t"]],["t"]]],[11,"map_same","","",974,[[["self"],["f"]],["t"]]],[11,"from","","",974,[[["t"]],["t"]]],[11,"into","","",974,[[["self"]],["u"]]],[11,"try_from","","",974,[[["u"]],["result"]]],[11,"borrow","","",974,[[["self"]],["t"]]],[11,"try_into","","",974,[[["self"]],["result"]]],[11,"borrow_mut","","",974,[[["self"]],["t"]]],[11,"get_type_id","","",974,[[["self"]],["typeid"]]],[11,"not_found","","",974,[[["str"],["str"]],["e"]]],[11,"from_ok","","",975,[[["t"]],["t"]]],[11,"map_same","","",975,[[["self"],["f"]],["t"]]],[11,"from","","",975,[[["t"]],["t"]]],[11,"into","","",975,[[["self"]],["u"]]],[11,"try_from","","",975,[[["u"]],["result"]]],[11,"borrow","","",975,[[["self"]],["t"]]],[11,"try_into","","",975,[[["self"]],["result"]]],[11,"borrow_mut","","",975,[[["self"]],["t"]]],[11,"get_type_id","","",975,[[["self"]],["typeid"]]],[11,"not_found","","",975,[[["str"],["str"]],["e"]]],[11,"from_ok","","",976,[[["t"]],["t"]]],[11,"map_same","","",976,[[["self"],["f"]],["t"]]],[11,"from","","",976,[[["t"]],["t"]]],[11,"into","","",976,[[["self"]],["u"]]],[11,"try_from","","",976,[[["u"]],["result"]]],[11,"borrow","","",976,[[["self"]],["t"]]],[11,"try_into","","",976,[[["self"]],["result"]]],[11,"borrow_mut","","",976,[[["self"]],["t"]]],[11,"get_type_id","","",976,[[["self"]],["typeid"]]],[11,"not_found","","",976,[[["str"],["str"]],["e"]]],[11,"from_ok","","",977,[[["t"]],["t"]]],[11,"map_same","","",977,[[["self"],["f"]],["t"]]],[11,"from","","",977,[[["t"]],["t"]]],[11,"into","","",977,[[["self"]],["u"]]],[11,"try_from","","",977,[[["u"]],["result"]]],[11,"borrow","","",977,[[["self"]],["t"]]],[11,"try_into","","",977,[[["self"]],["result"]]],[11,"borrow_mut","","",977,[[["self"]],["t"]]],[11,"get_type_id","","",977,[[["self"]],["typeid"]]],[11,"not_found","","",977,[[["str"],["str"]],["e"]]],[11,"from_ok","","",978,[[["t"]],["t"]]],[11,"map_same","","",978,[[["self"],["f"]],["t"]]],[11,"from","","",978,[[["t"]],["t"]]],[11,"into","","",978,[[["self"]],["u"]]],[11,"try_from","","",978,[[["u"]],["result"]]],[11,"borrow","","",978,[[["self"]],["t"]]],[11,"try_into","","",978,[[["self"]],["result"]]],[11,"borrow_mut","","",978,[[["self"]],["t"]]],[11,"get_type_id","","",978,[[["self"]],["typeid"]]],[11,"not_found","","",978,[[["str"],["str"]],["e"]]],[11,"from_ok","","",979,[[["t"]],["t"]]],[11,"map_same","","",979,[[["self"],["f"]],["t"]]],[11,"from","","",979,[[["t"]],["t"]]],[11,"into","","",979,[[["self"]],["u"]]],[11,"try_from","","",979,[[["u"]],["result"]]],[11,"borrow","","",979,[[["self"]],["t"]]],[11,"try_into","","",979,[[["self"]],["result"]]],[11,"borrow_mut","","",979,[[["self"]],["t"]]],[11,"get_type_id","","",979,[[["self"]],["typeid"]]],[11,"not_found","","",979,[[["str"],["str"]],["e"]]],[11,"from_ok","","",980,[[["t"]],["t"]]],[11,"map_same","","",980,[[["self"],["f"]],["t"]]],[11,"from","","",980,[[["t"]],["t"]]],[11,"into","","",980,[[["self"]],["u"]]],[11,"try_from","","",980,[[["u"]],["result"]]],[11,"borrow","","",980,[[["self"]],["t"]]],[11,"try_into","","",980,[[["self"]],["result"]]],[11,"borrow_mut","","",980,[[["self"]],["t"]]],[11,"get_type_id","","",980,[[["self"]],["typeid"]]],[11,"not_found","","",980,[[["str"],["str"]],["e"]]],[11,"from_ok","","",981,[[["t"]],["t"]]],[11,"map_same","","",981,[[["self"],["f"]],["t"]]],[11,"from","","",981,[[["t"]],["t"]]],[11,"into","","",981,[[["self"]],["u"]]],[11,"try_from","","",981,[[["u"]],["result"]]],[11,"borrow","","",981,[[["self"]],["t"]]],[11,"try_into","","",981,[[["self"]],["result"]]],[11,"borrow_mut","","",981,[[["self"]],["t"]]],[11,"get_type_id","","",981,[[["self"]],["typeid"]]],[11,"not_found","","",981,[[["str"],["str"]],["e"]]],[11,"from_ok","","",982,[[["t"]],["t"]]],[11,"map_same","","",982,[[["self"],["f"]],["t"]]],[11,"from","","",982,[[["t"]],["t"]]],[11,"into","","",982,[[["self"]],["u"]]],[11,"try_from","","",982,[[["u"]],["result"]]],[11,"borrow","","",982,[[["self"]],["t"]]],[11,"try_into","","",982,[[["self"]],["result"]]],[11,"borrow_mut","","",982,[[["self"]],["t"]]],[11,"get_type_id","","",982,[[["self"]],["typeid"]]],[11,"not_found","","",982,[[["str"],["str"]],["e"]]],[11,"from_ok","","",983,[[["t"]],["t"]]],[11,"map_same","","",983,[[["self"],["f"]],["t"]]],[11,"from","","",983,[[["t"]],["t"]]],[11,"into","","",983,[[["self"]],["u"]]],[11,"try_from","","",983,[[["u"]],["result"]]],[11,"borrow","","",983,[[["self"]],["t"]]],[11,"try_into","","",983,[[["self"]],["result"]]],[11,"borrow_mut","","",983,[[["self"]],["t"]]],[11,"get_type_id","","",983,[[["self"]],["typeid"]]],[11,"not_found","","",983,[[["str"],["str"]],["e"]]],[11,"from_ok","","",984,[[["t"]],["t"]]],[11,"map_same","","",984,[[["self"],["f"]],["t"]]],[11,"from","","",984,[[["t"]],["t"]]],[11,"into","","",984,[[["self"]],["u"]]],[11,"try_from","","",984,[[["u"]],["result"]]],[11,"borrow","","",984,[[["self"]],["t"]]],[11,"try_into","","",984,[[["self"]],["result"]]],[11,"borrow_mut","","",984,[[["self"]],["t"]]],[11,"get_type_id","","",984,[[["self"]],["typeid"]]],[11,"not_found","","",984,[[["str"],["str"]],["e"]]],[11,"from_ok","","",985,[[["t"]],["t"]]],[11,"map_same","","",985,[[["self"],["f"]],["t"]]],[11,"from","","",985,[[["t"]],["t"]]],[11,"into","","",985,[[["self"]],["u"]]],[11,"try_from","","",985,[[["u"]],["result"]]],[11,"borrow","","",985,[[["self"]],["t"]]],[11,"try_into","","",985,[[["self"]],["result"]]],[11,"borrow_mut","","",985,[[["self"]],["t"]]],[11,"get_type_id","","",985,[[["self"]],["typeid"]]],[11,"not_found","","",985,[[["str"],["str"]],["e"]]],[11,"from_ok","","",986,[[["t"]],["t"]]],[11,"map_same","","",986,[[["self"],["f"]],["t"]]],[11,"from","","",986,[[["t"]],["t"]]],[11,"into","","",986,[[["self"]],["u"]]],[11,"try_from","","",986,[[["u"]],["result"]]],[11,"borrow","","",986,[[["self"]],["t"]]],[11,"try_into","","",986,[[["self"]],["result"]]],[11,"borrow_mut","","",986,[[["self"]],["t"]]],[11,"get_type_id","","",986,[[["self"]],["typeid"]]],[11,"not_found","","",986,[[["str"],["str"]],["e"]]],[11,"from_ok","","",987,[[["t"]],["t"]]],[11,"map_same","","",987,[[["self"],["f"]],["t"]]],[11,"from","","",987,[[["t"]],["t"]]],[11,"into","","",987,[[["self"]],["u"]]],[11,"try_from","","",987,[[["u"]],["result"]]],[11,"borrow","","",987,[[["self"]],["t"]]],[11,"try_into","","",987,[[["self"]],["result"]]],[11,"borrow_mut","","",987,[[["self"]],["t"]]],[11,"get_type_id","","",987,[[["self"]],["typeid"]]],[11,"not_found","","",987,[[["str"],["str"]],["e"]]],[11,"from_ok","","",988,[[["t"]],["t"]]],[11,"map_same","","",988,[[["self"],["f"]],["t"]]],[11,"from","","",988,[[["t"]],["t"]]],[11,"into","","",988,[[["self"]],["u"]]],[11,"try_from","","",988,[[["u"]],["result"]]],[11,"borrow","","",988,[[["self"]],["t"]]],[11,"try_into","","",988,[[["self"]],["result"]]],[11,"borrow_mut","","",988,[[["self"]],["t"]]],[11,"get_type_id","","",988,[[["self"]],["typeid"]]],[11,"not_found","","",988,[[["str"],["str"]],["e"]]],[11,"from_ok","","",989,[[["t"]],["t"]]],[11,"map_same","","",989,[[["self"],["f"]],["t"]]],[11,"from","","",989,[[["t"]],["t"]]],[11,"into","","",989,[[["self"]],["u"]]],[11,"try_from","","",989,[[["u"]],["result"]]],[11,"borrow","","",989,[[["self"]],["t"]]],[11,"try_into","","",989,[[["self"]],["result"]]],[11,"borrow_mut","","",989,[[["self"]],["t"]]],[11,"get_type_id","","",989,[[["self"]],["typeid"]]],[11,"not_found","","",989,[[["str"],["str"]],["e"]]],[11,"from_ok","","",990,[[["t"]],["t"]]],[11,"map_same","","",990,[[["self"],["f"]],["t"]]],[11,"from","","",990,[[["t"]],["t"]]],[11,"into","","",990,[[["self"]],["u"]]],[11,"try_from","","",990,[[["u"]],["result"]]],[11,"borrow","","",990,[[["self"]],["t"]]],[11,"try_into","","",990,[[["self"]],["result"]]],[11,"borrow_mut","","",990,[[["self"]],["t"]]],[11,"get_type_id","","",990,[[["self"]],["typeid"]]],[11,"not_found","","",990,[[["str"],["str"]],["e"]]],[11,"from_ok","","",991,[[["t"]],["t"]]],[11,"map_same","","",991,[[["self"],["f"]],["t"]]],[11,"from","","",991,[[["t"]],["t"]]],[11,"into","","",991,[[["self"]],["u"]]],[11,"try_from","","",991,[[["u"]],["result"]]],[11,"borrow","","",991,[[["self"]],["t"]]],[11,"try_into","","",991,[[["self"]],["result"]]],[11,"borrow_mut","","",991,[[["self"]],["t"]]],[11,"get_type_id","","",991,[[["self"]],["typeid"]]],[11,"not_found","","",991,[[["str"],["str"]],["e"]]],[11,"from_ok","","",992,[[["t"]],["t"]]],[11,"map_same","","",992,[[["self"],["f"]],["t"]]],[11,"from","","",992,[[["t"]],["t"]]],[11,"into","","",992,[[["self"]],["u"]]],[11,"try_from","","",992,[[["u"]],["result"]]],[11,"borrow","","",992,[[["self"]],["t"]]],[11,"try_into","","",992,[[["self"]],["result"]]],[11,"borrow_mut","","",992,[[["self"]],["t"]]],[11,"get_type_id","","",992,[[["self"]],["typeid"]]],[11,"not_found","","",992,[[["str"],["str"]],["e"]]],[11,"from_ok","","",993,[[["t"]],["t"]]],[11,"map_same","","",993,[[["self"],["f"]],["t"]]],[11,"from","","",993,[[["t"]],["t"]]],[11,"into","","",993,[[["self"]],["u"]]],[11,"try_from","","",993,[[["u"]],["result"]]],[11,"borrow","","",993,[[["self"]],["t"]]],[11,"try_into","","",993,[[["self"]],["result"]]],[11,"borrow_mut","","",993,[[["self"]],["t"]]],[11,"get_type_id","","",993,[[["self"]],["typeid"]]],[11,"not_found","","",993,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::relate","",994,[[["t"]],["t"]]],[11,"map_same","","",994,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",994,N],[11,"to_owned","","",994,[[["self"]],["t"]]],[11,"clone_into","","",994,N],[11,"from","","",994,[[["t"]],["t"]]],[11,"into","","",994,[[["self"]],["u"]]],[11,"try_from","","",994,[[["u"]],["result"]]],[11,"borrow","","",994,[[["self"]],["t"]]],[11,"try_into","","",994,[[["self"]],["result"]]],[11,"borrow_mut","","",994,[[["self"]],["t"]]],[11,"get_type_id","","",994,[[["self"]],["typeid"]]],[11,"not_found","","",994,[[["str"],["str"]],["e"]]],[11,"from_ok","","",995,[[["t"]],["t"]]],[11,"map_same","","",995,[[["self"],["f"]],["t"]]],[11,"to_owned","","",995,[[["self"]],["t"]]],[11,"clone_into","","",995,N],[11,"from","","",995,[[["t"]],["t"]]],[11,"into","","",995,[[["self"]],["u"]]],[11,"try_from","","",995,[[["u"]],["result"]]],[11,"borrow","","",995,[[["self"]],["t"]]],[11,"try_into","","",995,[[["self"]],["result"]]],[11,"borrow_mut","","",995,[[["self"]],["t"]]],[11,"get_type_id","","",995,[[["self"]],["typeid"]]],[11,"not_found","","",995,[[["str"],["str"]],["e"]]],[11,"relate","rustc::ty","",1061,[[["r"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"relate","rustc::ty::sty","",1062,[[["r"],["region"],["region"]],["relateresult",["region"]]]],[11,"relate","rustc::ty::subst","",999,[[["r"],["kind"],["kind"]],["relateresult",["kind"]]]],[11,"from_ok","rustc::ty::steal","",998,[[["t"]],["t"]]],[11,"map_same","","",998,[[["self"],["f"]],["t"]]],[11,"from","","",998,[[["t"]],["t"]]],[11,"into","","",998,[[["self"]],["u"]]],[11,"try_from","","",998,[[["u"]],["result"]]],[11,"borrow","","",998,[[["self"]],["t"]]],[11,"try_into","","",998,[[["self"]],["result"]]],[11,"borrow_mut","","",998,[[["self"]],["t"]]],[11,"get_type_id","","",998,[[["self"]],["typeid"]]],[11,"not_found","","",998,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::subst","",999,[[["t"]],["t"]]],[11,"map_same","","",999,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",999,N],[11,"to_owned","","",999,[[["self"]],["t"]]],[11,"clone_into","","",999,N],[11,"from","","",999,[[["t"]],["t"]]],[11,"to_string","","",999,[[["self"]],["string"]]],[11,"into","","",999,[[["self"]],["u"]]],[11,"try_from","","",999,[[["u"]],["result"]]],[11,"borrow","","",999,[[["self"]],["t"]]],[11,"try_into","","",999,[[["self"]],["result"]]],[11,"borrow_mut","","",999,[[["self"]],["t"]]],[11,"get_type_id","","",999,[[["self"]],["typeid"]]],[11,"encode","","",999,[[["self"],["e"]],["result"]]],[11,"decode","","",999,[[["d"]],["result"]]],[11,"not_found","","",999,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1000,[[["t"]],["t"]]],[11,"map_same","","",1000,[[["self"],["f"]],["t"]]],[11,"from","","",1000,[[["t"]],["t"]]],[11,"into","","",1000,[[["self"]],["u"]]],[11,"try_from","","",1000,[[["u"]],["result"]]],[11,"borrow","","",1000,[[["self"]],["t"]]],[11,"try_into","","",1000,[[["self"]],["result"]]],[11,"borrow_mut","","",1000,[[["self"]],["t"]]],[11,"get_type_id","","",1000,[[["self"]],["typeid"]]],[11,"not_found","","",1000,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1001,[[["t"]],["t"]]],[11,"map_same","","",1001,[[["self"],["f"]],["t"]]],[11,"from","","",1001,[[["t"]],["t"]]],[11,"into","","",1001,[[["self"]],["u"]]],[11,"try_from","","",1001,[[["u"]],["result"]]],[11,"borrow","","",1001,[[["self"]],["t"]]],[11,"try_into","","",1001,[[["self"]],["result"]]],[11,"borrow_mut","","",1001,[[["self"]],["t"]]],[11,"get_type_id","","",1001,[[["self"]],["typeid"]]],[11,"encode","","",1001,[[["self"],["e"]],["result"]]],[11,"decode","","",1001,[[["d"]],["result"]]],[11,"not_found","","",1001,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::trait_def","",1005,[[["t"]],["t"]]],[11,"map_same","","",1005,[[["self"],["f"]],["t"]]],[11,"from","","",1005,[[["t"]],["t"]]],[11,"into","","",1005,[[["self"]],["u"]]],[11,"try_from","","",1005,[[["u"]],["result"]]],[11,"borrow","","",1005,[[["self"]],["t"]]],[11,"try_into","","",1005,[[["self"]],["result"]]],[11,"borrow_mut","","",1005,[[["self"]],["t"]]],[11,"get_type_id","","",1005,[[["self"]],["typeid"]]],[11,"not_found","","",1005,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1006,[[["t"]],["t"]]],[11,"map_same","","",1006,[[["self"],["f"]],["t"]]],[11,"from","","",1006,[[["t"]],["t"]]],[11,"into","","",1006,[[["self"]],["u"]]],[11,"try_from","","",1006,[[["u"]],["result"]]],[11,"borrow","","",1006,[[["self"]],["t"]]],[11,"try_into","","",1006,[[["self"]],["result"]]],[11,"borrow_mut","","",1006,[[["self"]],["t"]]],[11,"get_type_id","","",1006,[[["self"]],["typeid"]]],[11,"not_found","","",1006,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::walk","",1007,[[["t"]],["t"]]],[11,"map_same","","",1007,[[["self"],["f"]],["t"]]],[11,"from","","",1007,[[["t"]],["t"]]],[11,"into_iter","","",1007,[[["self"]],["i"]]],[11,"into","","",1007,[[["self"]],["u"]]],[11,"try_from","","",1007,[[["u"]],["result"]]],[11,"borrow","","",1007,[[["self"]],["t"]]],[11,"try_into","","",1007,[[["self"]],["result"]]],[11,"borrow_mut","","",1007,[[["self"]],["t"]]],[11,"get_type_id","","",1007,[[["self"]],["typeid"]]],[11,"not_found","","",1007,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::wf","",1008,[[["t"]],["t"]]],[11,"map_same","","",1008,[[["self"],["f"]],["t"]]],[11,"from","","",1008,[[["t"]],["t"]]],[11,"into","","",1008,[[["self"]],["u"]]],[11,"try_from","","",1008,[[["u"]],["result"]]],[11,"borrow","","",1008,[[["self"]],["t"]]],[11,"try_into","","",1008,[[["self"]],["result"]]],[11,"borrow_mut","","",1008,[[["self"]],["t"]]],[11,"get_type_id","","",1008,[[["self"]],["typeid"]]],[11,"not_found","","",1008,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1009,[[["t"]],["t"]]],[11,"map_same","","",1009,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1009,[[["self"]],["t"]]],[11,"clone_into","","",1009,N],[11,"from","","",1009,[[["t"]],["t"]]],[11,"into","","",1009,[[["self"]],["u"]]],[11,"try_from","","",1009,[[["u"]],["result"]]],[11,"borrow","","",1009,[[["self"]],["t"]]],[11,"try_into","","",1009,[[["self"]],["result"]]],[11,"borrow_mut","","",1009,[[["self"]],["t"]]],[11,"get_type_id","","",1009,[[["self"]],["typeid"]]],[11,"not_found","","",1009,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::util","",1010,[[["t"]],["t"]]],[11,"map_same","","",1010,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1010,[[["self"]],["t"]]],[11,"clone_into","","",1010,N],[11,"from","","",1010,[[["t"]],["t"]]],[11,"to_string","","",1010,[[["self"]],["string"]]],[11,"into","","",1010,[[["self"]],["u"]]],[11,"try_from","","",1010,[[["u"]],["result"]]],[11,"borrow","","",1010,[[["self"]],["t"]]],[11,"try_into","","",1010,[[["self"]],["result"]]],[11,"borrow_mut","","",1010,[[["self"]],["t"]]],[11,"get_type_id","","",1010,[[["self"]],["typeid"]]],[11,"not_found","","",1010,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1011,[[["t"]],["t"]]],[11,"map_same","","",1011,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1011,[[["self"]],["t"]]],[11,"clone_into","","",1011,N],[11,"from","","",1011,[[["t"]],["t"]]],[11,"into","","",1011,[[["self"]],["u"]]],[11,"try_from","","",1011,[[["u"]],["result"]]],[11,"borrow","","",1011,[[["self"]],["t"]]],[11,"try_into","","",1011,[[["self"]],["result"]]],[11,"borrow_mut","","",1011,[[["self"]],["t"]]],[11,"get_type_id","","",1011,[[["self"]],["typeid"]]],[11,"not_found","","",1011,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1012,[[["t"]],["t"]]],[11,"map_same","","",1012,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1012,[[["self"]],["t"]]],[11,"clone_into","","",1012,N],[11,"from","","",1012,[[["t"]],["t"]]],[11,"into","","",1012,[[["self"]],["u"]]],[11,"try_from","","",1012,[[["u"]],["result"]]],[11,"borrow","","",1012,[[["self"]],["t"]]],[11,"try_into","","",1012,[[["self"]],["result"]]],[11,"borrow_mut","","",1012,[[["self"]],["t"]]],[11,"get_type_id","","",1012,[[["self"]],["typeid"]]],[11,"not_found","","",1012,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1013,[[["t"]],["t"]]],[11,"map_same","","",1013,[[["self"],["f"]],["t"]]],[11,"from","","",1013,[[["t"]],["t"]]],[11,"into","","",1013,[[["self"]],["u"]]],[11,"try_from","","",1013,[[["u"]],["result"]]],[11,"borrow","","",1013,[[["self"]],["t"]]],[11,"try_into","","",1013,[[["self"]],["result"]]],[11,"borrow_mut","","",1013,[[["self"]],["t"]]],[11,"get_type_id","","",1013,[[["self"]],["typeid"]]],[11,"not_found","","",1013,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::ty::context","",1015,[[["t"]],["t"]]],[11,"map_same","","",1015,[[["self"],["f"]],["t"]]],[11,"from","","",1015,[[["t"]],["t"]]],[11,"into","","",1015,[[["self"]],["u"]]],[11,"try_from","","",1015,[[["u"]],["result"]]],[11,"borrow","","",1015,[[["self"]],["t"]]],[11,"try_into","","",1015,[[["self"]],["result"]]],[11,"borrow_mut","","",1015,[[["self"]],["t"]]],[11,"get_type_id","","",1015,[[["self"]],["typeid"]]],[11,"not_found","","",1015,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1016,[[["t"]],["t"]]],[11,"map_same","","",1016,[[["self"],["f"]],["t"]]],[11,"from","","",1016,[[["t"]],["t"]]],[11,"into","","",1016,[[["self"]],["u"]]],[11,"try_from","","",1016,[[["u"]],["result"]]],[11,"borrow","","",1016,[[["self"]],["t"]]],[11,"try_into","","",1016,[[["self"]],["result"]]],[11,"borrow_mut","","",1016,[[["self"]],["t"]]],[11,"get_type_id","","",1016,[[["self"]],["typeid"]]],[11,"not_found","","",1016,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1017,[[["t"]],["t"]]],[11,"map_same","","",1017,[[["self"],["f"]],["t"]]],[11,"from","","",1017,[[["t"]],["t"]]],[11,"into","","",1017,[[["self"]],["u"]]],[11,"try_from","","",1017,[[["u"]],["result"]]],[11,"borrow","","",1017,[[["self"]],["t"]]],[11,"try_into","","",1017,[[["self"]],["result"]]],[11,"borrow_mut","","",1017,[[["self"]],["t"]]],[11,"get_type_id","","",1017,[[["self"]],["typeid"]]],[11,"not_found","","",1017,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1018,[[["t"]],["t"]]],[11,"map_same","","",1018,[[["self"],["f"]],["t"]]],[11,"from","","",1018,[[["t"]],["t"]]],[11,"into","","",1018,[[["self"]],["u"]]],[11,"try_from","","",1018,[[["u"]],["result"]]],[11,"borrow","","",1018,[[["self"]],["t"]]],[11,"try_into","","",1018,[[["self"]],["result"]]],[11,"borrow_mut","","",1018,[[["self"]],["t"]]],[11,"get_type_id","","",1018,[[["self"]],["typeid"]]],[11,"not_found","","",1018,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1019,[[["t"]],["t"]]],[11,"map_same","","",1019,[[["self"],["f"]],["t"]]],[11,"from","","",1019,[[["t"]],["t"]]],[11,"into","","",1019,[[["self"]],["u"]]],[11,"try_from","","",1019,[[["u"]],["result"]]],[11,"borrow","","",1019,[[["self"]],["t"]]],[11,"try_into","","",1019,[[["self"]],["result"]]],[11,"borrow_mut","","",1019,[[["self"]],["t"]]],[11,"get_type_id","","",1019,[[["self"]],["typeid"]]],[11,"not_found","","",1019,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1020,[[["t"]],["t"]]],[11,"map_same","","",1020,[[["self"],["f"]],["t"]]],[11,"from","","",1020,[[["t"]],["t"]]],[11,"into","","",1020,[[["self"]],["u"]]],[11,"try_from","","",1020,[[["u"]],["result"]]],[11,"borrow","","",1020,[[["self"]],["t"]]],[11,"try_into","","",1020,[[["self"]],["result"]]],[11,"borrow_mut","","",1020,[[["self"]],["t"]]],[11,"get_type_id","","",1020,[[["self"]],["typeid"]]],[11,"not_found","","",1020,[[["str"],["str"]],["e"]]],[11,"lift_to_tcx","rustc::ty","",1061,[[["self"],["tyctxt"]],["option",["ty"]]]],[11,"lift_to_tcx","rustc::ty::sty","",1062,[[["self"],["tyctxt"]],["option",["region"]]]],[11,"from_ok","rustc::ty::flags","",1024,[[["t"]],["t"]]],[11,"map_same","","",1024,[[["self"],["f"]],["t"]]],[11,"from","","",1024,[[["t"]],["t"]]],[11,"into","","",1024,[[["self"]],["u"]]],[11,"try_from","","",1024,[[["u"]],["result"]]],[11,"borrow","","",1024,[[["self"]],["t"]]],[11,"try_into","","",1024,[[["self"]],["result"]]],[11,"borrow_mut","","",1024,[[["self"]],["t"]]],[11,"get_type_id","","",1024,[[["self"]],["typeid"]]],[11,"not_found","","",1024,[[["str"],["str"]],["e"]]],[11,"super_fold_with","rustc::ty","",1061,[[["self"],["f"]],["self"]]],[11,"fold_with","","",1061,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",1061,[[["self"],["v"]],["bool"]]],[11,"visit_with","","",1061,[[["self"],["v"]],["bool"]]],[11,"super_fold_with","rustc::ty::sty","",1062,[[["self"],["f"]],["self"]]],[11,"fold_with","","",1062,[[["self"],["f"]],["self"]]],[11,"super_visit_with","","",1062,[[["self"],["v"]],["bool"]]],[11,"visit_with","","",1062,[[["self"],["v"]],["bool"]]],[11,"from_ok","","",1025,[[["t"]],["t"]]],[11,"map_same","","",1025,[[["self"],["f"]],["t"]]],[11,"from","","",1025,[[["t"]],["t"]]],[11,"into","","",1025,[[["self"]],["u"]]],[11,"try_from","","",1025,[[["u"]],["result"]]],[11,"borrow","","",1025,[[["self"]],["t"]]],[11,"try_into","","",1025,[[["self"]],["result"]]],[11,"borrow_mut","","",1025,[[["self"]],["t"]]],[11,"get_type_id","","",1025,[[["self"]],["typeid"]]],[11,"not_found","","",1025,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1026,[[["t"]],["t"]]],[11,"map_same","","",1026,[[["self"],["f"]],["t"]]],[11,"from","","",1026,[[["t"]],["t"]]],[11,"into","","",1026,[[["self"]],["u"]]],[11,"try_from","","",1026,[[["u"]],["result"]]],[11,"borrow","","",1026,[[["self"]],["t"]]],[11,"try_into","","",1026,[[["self"]],["result"]]],[11,"borrow_mut","","",1026,[[["self"]],["t"]]],[11,"get_type_id","","",1026,[[["self"]],["typeid"]]],[11,"not_found","","",1026,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::util::common","",1045,[[["t"]],["t"]]],[11,"map_same","","",1045,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1045,[[["self"]],["t"]]],[11,"clone_into","","",1045,N],[11,"from","","",1045,[[["t"]],["t"]]],[11,"into","","",1045,[[["self"]],["u"]]],[11,"try_from","","",1045,[[["u"]],["result"]]],[11,"borrow","","",1045,[[["self"]],["t"]]],[11,"try_into","","",1045,[[["self"]],["result"]]],[11,"borrow_mut","","",1045,[[["self"]],["t"]]],[11,"get_type_id","","",1045,[[["self"]],["typeid"]]],[11,"encode","","",1045,[[["self"],["e"]],["result"]]],[11,"decode","","",1045,[[["d"]],["result"]]],[11,"not_found","","",1045,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1039,[[["t"]],["t"]]],[11,"map_same","","",1039,[[["self"],["f"]],["t"]]],[11,"from","","",1039,[[["t"]],["t"]]],[11,"into","","",1039,[[["self"]],["u"]]],[11,"try_from","","",1039,[[["u"]],["result"]]],[11,"borrow","","",1039,[[["self"]],["t"]]],[11,"try_into","","",1039,[[["self"]],["result"]]],[11,"borrow_mut","","",1039,[[["self"]],["t"]]],[11,"get_type_id","","",1039,[[["self"]],["typeid"]]],[11,"not_found","","",1039,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1040,[[["t"]],["t"]]],[11,"map_same","","",1040,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1040,[[["self"]],["t"]]],[11,"clone_into","","",1040,N],[11,"from","","",1040,[[["t"]],["t"]]],[11,"into","","",1040,[[["self"]],["u"]]],[11,"try_from","","",1040,[[["u"]],["result"]]],[11,"borrow","","",1040,[[["self"]],["t"]]],[11,"try_into","","",1040,[[["self"]],["result"]]],[11,"borrow_mut","","",1040,[[["self"]],["t"]]],[11,"get_type_id","","",1040,[[["self"]],["typeid"]]],[11,"not_found","","",1040,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1041,[[["t"]],["t"]]],[11,"map_same","","",1041,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1041,[[["self"]],["t"]]],[11,"clone_into","","",1041,N],[11,"from","","",1041,[[["t"]],["t"]]],[11,"into","","",1041,[[["self"]],["u"]]],[11,"try_from","","",1041,[[["u"]],["result"]]],[11,"borrow","","",1041,[[["self"]],["t"]]],[11,"try_into","","",1041,[[["self"]],["result"]]],[11,"borrow_mut","","",1041,[[["self"]],["t"]]],[11,"get_type_id","","",1041,[[["self"]],["typeid"]]],[11,"not_found","","",1041,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1042,[[["t"]],["t"]]],[11,"map_same","","",1042,[[["self"],["f"]],["t"]]],[11,"from","","",1042,[[["t"]],["t"]]],[11,"into","","",1042,[[["self"]],["u"]]],[11,"try_from","","",1042,[[["u"]],["result"]]],[11,"borrow","","",1042,[[["self"]],["t"]]],[11,"try_into","","",1042,[[["self"]],["result"]]],[11,"borrow_mut","","",1042,[[["self"]],["t"]]],[11,"get_type_id","","",1042,[[["self"]],["typeid"]]],[11,"not_found","","",1042,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1043,[[["t"]],["t"]]],[11,"map_same","","",1043,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1043,[[["self"]],["t"]]],[11,"clone_into","","",1043,N],[11,"from","","",1043,[[["t"]],["t"]]],[11,"into","","",1043,[[["self"]],["u"]]],[11,"try_from","","",1043,[[["u"]],["result"]]],[11,"borrow","","",1043,[[["self"]],["t"]]],[11,"try_into","","",1043,[[["self"]],["result"]]],[11,"borrow_mut","","",1043,[[["self"]],["t"]]],[11,"get_type_id","","",1043,[[["self"]],["typeid"]]],[11,"not_found","","",1043,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::util::ppaux","",1046,[[["t"]],["t"]]],[11,"map_same","","",1046,[[["self"],["f"]],["t"]]],[11,"from","","",1046,[[["t"]],["t"]]],[11,"into","","",1046,[[["self"]],["u"]]],[11,"try_from","","",1046,[[["u"]],["result"]]],[11,"borrow","","",1046,[[["self"]],["t"]]],[11,"try_into","","",1046,[[["self"]],["result"]]],[11,"borrow_mut","","",1046,[[["self"]],["t"]]],[11,"get_type_id","","",1046,[[["self"]],["typeid"]]],[11,"not_found","","",1046,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1047,[[["t"]],["t"]]],[11,"map_same","","",1047,[[["self"],["f"]],["t"]]],[11,"from","","",1047,[[["t"]],["t"]]],[11,"into","","",1047,[[["self"]],["u"]]],[11,"try_from","","",1047,[[["u"]],["result"]]],[11,"borrow","","",1047,[[["self"]],["t"]]],[11,"try_into","","",1047,[[["self"]],["result"]]],[11,"borrow_mut","","",1047,[[["self"]],["t"]]],[11,"get_type_id","","",1047,[[["self"]],["typeid"]]],[11,"not_found","","",1047,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::util::time_graph","",1049,[[["t"]],["t"]]],[11,"map_same","","",1049,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1049,[[["self"]],["t"]]],[11,"clone_into","","",1049,N],[11,"from","","",1049,[[["t"]],["t"]]],[11,"into","","",1049,[[["self"]],["u"]]],[11,"try_from","","",1049,[[["u"]],["result"]]],[11,"borrow","","",1049,[[["self"]],["t"]]],[11,"try_into","","",1049,[[["self"]],["result"]]],[11,"borrow_mut","","",1049,[[["self"]],["t"]]],[11,"get_type_id","","",1049,[[["self"]],["typeid"]]],[11,"not_found","","",1049,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1050,[[["t"]],["t"]]],[11,"map_same","","",1050,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1050,[[["self"]],["t"]]],[11,"clone_into","","",1050,N],[11,"from","","",1050,[[["t"]],["t"]]],[11,"into","","",1050,[[["self"]],["u"]]],[11,"try_from","","",1050,[[["u"]],["result"]]],[11,"borrow","","",1050,[[["self"]],["t"]]],[11,"try_into","","",1050,[[["self"]],["result"]]],[11,"borrow_mut","","",1050,[[["self"]],["t"]]],[11,"get_type_id","","",1050,[[["self"]],["typeid"]]],[11,"not_found","","",1050,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1051,[[["t"]],["t"]]],[11,"map_same","","",1051,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1051,[[["self"]],["t"]]],[11,"clone_into","","",1051,N],[11,"from","","",1051,[[["t"]],["t"]]],[11,"into","","",1051,[[["self"]],["u"]]],[11,"try_from","","",1051,[[["u"]],["result"]]],[11,"borrow","","",1051,[[["self"]],["t"]]],[11,"try_into","","",1051,[[["self"]],["result"]]],[11,"borrow_mut","","",1051,[[["self"]],["t"]]],[11,"get_type_id","","",1051,[[["self"]],["typeid"]]],[11,"not_found","","",1051,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1052,[[["t"]],["t"]]],[11,"map_same","","",1052,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1052,[[["self"]],["t"]]],[11,"clone_into","","",1052,N],[11,"from","","",1052,[[["t"]],["t"]]],[11,"into","","",1052,[[["self"]],["u"]]],[11,"try_from","","",1052,[[["u"]],["result"]]],[11,"borrow","","",1052,[[["self"]],["t"]]],[11,"try_into","","",1052,[[["self"]],["result"]]],[11,"borrow_mut","","",1052,[[["self"]],["t"]]],[11,"get_type_id","","",1052,[[["self"]],["typeid"]]],[11,"not_found","","",1052,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1053,[[["t"]],["t"]]],[11,"map_same","","",1053,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1053,[[["self"]],["t"]]],[11,"clone_into","","",1053,N],[11,"from","","",1053,[[["t"]],["t"]]],[11,"into","","",1053,[[["self"]],["u"]]],[11,"try_from","","",1053,[[["u"]],["result"]]],[11,"borrow","","",1053,[[["self"]],["t"]]],[11,"try_into","","",1053,[[["self"]],["result"]]],[11,"borrow_mut","","",1053,[[["self"]],["t"]]],[11,"get_type_id","","",1053,[[["self"]],["typeid"]]],[11,"not_found","","",1053,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1054,[[["t"]],["t"]]],[11,"map_same","","",1054,[[["self"],["f"]],["t"]]],[11,"from","","",1054,[[["t"]],["t"]]],[11,"into","","",1054,[[["self"]],["u"]]],[11,"try_from","","",1054,[[["u"]],["result"]]],[11,"borrow","","",1054,[[["self"]],["t"]]],[11,"try_into","","",1054,[[["self"]],["result"]]],[11,"borrow_mut","","",1054,[[["self"]],["t"]]],[11,"get_type_id","","",1054,[[["self"]],["typeid"]]],[11,"not_found","","",1054,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1055,[[["t"]],["t"]]],[11,"map_same","","",1055,[[["self"],["f"]],["t"]]],[11,"from","","",1055,[[["t"]],["t"]]],[11,"into","","",1055,[[["self"]],["u"]]],[11,"try_from","","",1055,[[["u"]],["result"]]],[11,"borrow","","",1055,[[["self"]],["t"]]],[11,"try_into","","",1055,[[["self"]],["result"]]],[11,"borrow_mut","","",1055,[[["self"]],["t"]]],[11,"get_type_id","","",1055,[[["self"]],["typeid"]]],[11,"not_found","","",1055,[[["str"],["str"]],["e"]]],[11,"from_ok","rustc::util::profiling","",1056,[[["t"]],["t"]]],[11,"map_same","","",1056,[[["self"],["f"]],["t"]]],[11,"from","","",1056,[[["t"]],["t"]]],[11,"into","","",1056,[[["self"]],["u"]]],[11,"try_from","","",1056,[[["u"]],["result"]]],[11,"borrow","","",1056,[[["self"]],["t"]]],[11,"try_into","","",1056,[[["self"]],["result"]]],[11,"borrow_mut","","",1056,[[["self"]],["t"]]],[11,"get_type_id","","",1056,[[["self"]],["typeid"]]],[11,"not_found","","",1056,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1057,[[["t"]],["t"]]],[11,"map_same","","",1057,[[["self"],["f"]],["t"]]],[11,"from","","",1057,[[["t"]],["t"]]],[11,"into","","",1057,[[["self"]],["u"]]],[11,"try_from","","",1057,[[["u"]],["result"]]],[11,"borrow","","",1057,[[["self"]],["t"]]],[11,"try_into","","",1057,[[["self"]],["result"]]],[11,"borrow_mut","","",1057,[[["self"]],["t"]]],[11,"get_type_id","","",1057,[[["self"]],["typeid"]]],[11,"not_found","","",1057,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1058,[[["t"]],["t"]]],[11,"map_same","","",1058,[[["self"],["f"]],["t"]]],[11,"from","","",1058,[[["t"]],["t"]]],[11,"into","","",1058,[[["self"]],["u"]]],[11,"try_from","","",1058,[[["u"]],["result"]]],[11,"borrow","","",1058,[[["self"]],["t"]]],[11,"try_into","","",1058,[[["self"]],["result"]]],[11,"borrow_mut","","",1058,[[["self"]],["t"]]],[11,"get_type_id","","",1058,[[["self"]],["typeid"]]],[11,"not_found","","",1058,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1059,[[["t"]],["t"]]],[11,"map_same","","",1059,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1059,[[["self"]],["t"]]],[11,"clone_into","","",1059,N],[11,"from","","",1059,[[["t"]],["t"]]],[11,"into","","",1059,[[["self"]],["u"]]],[11,"try_from","","",1059,[[["u"]],["result"]]],[11,"borrow","","",1059,[[["self"]],["t"]]],[11,"try_into","","",1059,[[["self"]],["result"]]],[11,"borrow_mut","","",1059,[[["self"]],["t"]]],[11,"get_type_id","","",1059,[[["self"]],["typeid"]]],[11,"not_found","","",1059,[[["str"],["str"]],["e"]]]],"paths":[[3,"CFG"],[3,"CFGEdgeData"],[4,"CFGNodeData"],[3,"CFGBuilder"],[3,"BlockScope"],[3,"LoopScope"],[4,"ScopeCfKind"],[3,"LabelledCFG"],[3,"DepTrackingMap"],[3,"DepNode"],[3,"WorkProductId"],[3,"DepGraph"],[3,"WorkProduct"],[3,"DepNodeIndex"],[3,"PreviousDepGraph"],[3,"DepGraphQuery"],[3,"AssertDepGraphSafe"],[3,"SerializedDepGraph"],[3,"SerializedDepNodeIndex"],[4,"DepKind"],[4,"DepConstructor"],[4,"DepNodeColor"],[4,"OpenTask"],[4,"WorkProductFileKind"],[3,"DepNodeFilter"],[3,"EdgeFilter"],[8,"DepNodeParams"],[8,"DepTrackingMapConfig"],[3,"DepGraphData"],[3,"CurrentDepGraph"],[3,"RegularOpenTask"],[3,"AnonOpenTask"],[3,"DepNodeColorMap"],[3,"HirId"],[3,"ItemLocalId"],[3,"Label"],[3,"Lifetime"],[3,"Path"],[3,"PathSegment"],[3,"GenericArgs"],[3,"GenericParam"],[3,"GenericParamCount"],[3,"Generics"],[3,"WhereClause"],[3,"WhereBoundPredicate"],[3,"WhereRegionPredicate"],[3,"WhereEqPredicate"],[3,"Crate"],[3,"MacroDef"],[3,"Block"],[3,"Pat"],[3,"FieldPat"],[3,"Local"],[3,"Arm"],[3,"Field"],[3,"BodyId"],[3,"Body"],[3,"AnonConst"],[3,"Expr"],[3,"Destination"],[3,"MutTy"],[3,"MethodSig"],[3,"TraitItemId"],[3,"TraitItem"],[3,"ImplItemId"],[3,"ImplItem"],[3,"TypeBinding"],[3,"Ty"],[3,"BareFnTy"],[3,"ExistTy"],[3,"InlineAsmOutput"],[3,"InlineAsm"],[3,"Arg"],[3,"FnDecl"],[3,"Mod"],[3,"ForeignMod"],[3,"GlobalAsm"],[3,"EnumDef"],[3,"VariantKind"],[3,"TraitRef"],[3,"PolyTraitRef"],[3,"StructField"],[3,"ItemId"],[3,"Item"],[3,"FnHeader"],[3,"TraitItemRef"],[3,"ImplItemRef"],[3,"ForeignItem"],[3,"Freevar"],[3,"TraitCandidate"],[3,"CodegenFnAttrs"],[3,"CodegenFnAttrFlags"],[4,"ParamName"],[4,"LifetimeName"],[4,"GenericArg"],[4,"TraitBoundModifier"],[4,"GenericBound"],[4,"GenericParamKind"],[4,"SyntheticTyParamKind"],[4,"WherePredicate"],[4,"BindingAnnotation"],[4,"RangeEnd"],[4,"PatKind"],[4,"Mutability"],[4,"BinOpKind"],[4,"UnOp"],[4,"StmtKind"],[4,"DeclKind"],[4,"Guard"],[4,"BlockCheckMode"],[4,"UnsafeSource"],[4,"BodyOwnerKind"],[4,"ExprKind"],[4,"QPath"],[4,"LocalSource"],[4,"MatchSource"],[4,"LoopSource"],[4,"LoopIdError"],[4,"GeneratorMovability"],[4,"CaptureClause"],[4,"TraitMethod"],[4,"TraitItemKind"],[4,"ImplItemKind"],[4,"PrimTy"],[4,"TyKind"],[4,"IsAuto"],[4,"IsAsync"],[4,"Unsafety"],[4,"Constness"],[4,"Defaultness"],[4,"ImplPolarity"],[4,"FunctionRetTy"],[4,"UseKind"],[4,"VisibilityKind"],[4,"VariantData"],[4,"ItemKind"],[4,"AssociatedItemKind"],[4,"ForeignItemKind"],[4,"Node"],[3,"CheckAttrVisitor"],[4,"Target"],[3,"PathResolution"],[3,"PerNS"],[3,"Export"],[4,"CtorKind"],[4,"NonMacroAttrKind"],[4,"Def"],[4,"Namespace"],[3,"CrateId"],[3,"DefIndex"],[3,"DefId"],[3,"LocalDefId"],[4,"CrateNum"],[4,"DefIndexAddressSpace"],[3,"IdRange"],[3,"IdRangeComputingVisitor"],[4,"FnKind"],[4,"NestedVisitorMap"],[8,"Visitor"],[3,"DeepVisitor"],[3,"ParDeepVisitor"],[8,"ItemLikeVisitor"],[8,"ParItemLikeVisitor"],[8,"IntoVisitor"],[3,"LoweringContext"],[3,"LoweredNodeId"],[4,"ImplTraitContext"],[4,"ParamMode"],[4,"ParenthesizedGenericArgs"],[4,"AnonymousLifetimeMode"],[8,"Resolver"],[3,"DefCollector"],[3,"MacroInvocationData"],[3,"Entry"],[3,"Forest"],[3,"Map"],[3,"NodesMatchingSuffix"],[3,"FnLikeNode"],[3,"ItemFnParts"],[3,"ClosureParts"],[4,"Code"],[8,"MaybeFnLike"],[3,"NodeCollector"],[3,"HirItemLike"],[3,"DefPathTable"],[3,"Definitions"],[3,"DefKey"],[3,"DisambiguatedDefPathData"],[3,"DefPath"],[3,"DefPathHash"],[4,"DefPathData"],[4,"GlobalMetaDataKind"],[3,"HirIdValidator"],[3,"OuterVisitor"],[8,"Named"],[3,"EnumerateAndAdjust"],[8,"EnumerateAndAdjustIterator"],[3,"State"],[4,"AnnNode"],[4,"Nested"],[8,"PpAnn"],[3,"CachingSourceMapView"],[3,"StableHashingContext"],[4,"NodeIdHashingMode"],[3,"CacheEntry"],[3,"BodyResolver"],[8,"StableHashingContextProvider"],[3,"TypeFreshener"],[3,"InferOk"],[3,"InferCtxt"],[3,"TypeTrace"],[3,"RegionObligation"],[3,"InferCtxtBuilder"],[3,"CombinedSnapshot"],[4,"ValuePairs"],[4,"SubregionOrigin"],[4,"ParameterOrigin"],[4,"LateBoundRegionConversionTime"],[4,"RegionVariableOrigin"],[4,"NLLRegionVariableOrigin"],[4,"FixupError"],[3,"OpaqueTypeDecl"],[3,"ReverseMapper"],[3,"Instantiator"],[3,"At"],[3,"Trace"],[8,"ToTrace"],[3,"Canonical"],[3,"CanonicalVarValues"],[3,"CanonicalVarInfo"],[3,"QueryResult"],[4,"CanonicalVarKind"],[4,"CanonicalTyVarKind"],[4,"Certainty"],[3,"CanonicalizeRegionMode"],[3,"Canonicalizer"],[3,"CanonicalVarValuesSubst"],[6,"CanonicalVarInfos"],[3,"CombineFields"],[3,"Generalizer"],[3,"Generalization"],[4,"RelationDir"],[8,"RelateResultCompare"],[3,"Equate"],[4,"FailureCode"],[3,"FindLocalByTypeVisitor"],[3,"NiceRegionError"],[3,"FindNestedTypeVisitor"],[3,"TyPathVisitor"],[3,"AnonymousArgInfo"],[3,"FreeRegionInfo"],[3,"RegionFudger"],[3,"Glb"],[3,"HrMatchResult"],[8,"LatticeDir"],[3,"LexicalRegionResolutions"],[3,"RegionAndOrigin"],[3,"LexicalResolver"],[4,"VarValue"],[4,"RegionResolutionError"],[3,"ConstraintGraph"],[4,"Node"],[4,"Edge"],[3,"Lub"],[3,"OutlivesEnvironment"],[3,"FreeRegionMap"],[8,"FreeRegionRelations"],[3,"TypeOutlives"],[8,"TypeOutlivesDelegate"],[3,"RegionConstraintCollector"],[3,"RegionConstraintData"],[3,"Verify"],[3,"TwoRegions"],[3,"RegionVariableInfo"],[3,"RegionSnapshot"],[3,"TaintDirections"],[4,"Constraint"],[4,"GenericKind"],[4,"VerifyBound"],[4,"UndoLogEntry"],[4,"CombineMapType"],[3,"TaintSet"],[3,"OpportunisticTypeResolver"],[3,"OpportunisticTypeAndRegionResolver"],[3,"UnresolvedTypeFinder"],[3,"FullTypeResolver"],[3,"Sub"],[3,"TypeVariableTable"],[3,"TypeVariableData"],[3,"Snapshot"],[3,"Instantiate"],[3,"TyVidEqKey"],[4,"TypeVariableOrigin"],[4,"TypeVariableValue"],[3,"Delegate"],[3,"RegionVidKey"],[8,"ToType"],[3,"LateContext"],[3,"EarlyContext"],[3,"LintStore"],[3,"FutureIncompatibleInfo"],[3,"BufferedEarlyLint"],[3,"Lint"],[3,"LintId"],[3,"LintLevelSets"],[3,"LintLevelMap"],[3,"LintBuffer"],[3,"LintLevelMapBuilder"],[4,"CheckLintNameResult"],[4,"Level"],[4,"LintSource"],[4,"BuiltinLintDiagnostics"],[3,"HardwiredLints"],[3,"LintSession"],[4,"TargetLint"],[4,"FindLintError"],[8,"LintContext"],[3,"LintLevelsBuilder"],[3,"BuilderPush"],[4,"LintSet"],[8,"LintPass"],[8,"LateLintPass"],[8,"EarlyLintPass"],[4,"AllocatorKind"],[3,"BorrowCheckResult"],[4,"SignalledError"],[3,"ExprUseVisitor"],[4,"LoanCause"],[4,"ConsumeMode"],[4,"MoveReason"],[4,"MatchMode"],[4,"TrackMatchMode"],[4,"MutateMode"],[4,"OverloadedCallType"],[8,"Delegate"],[3,"CrateSource"],[3,"NativeLibrary"],[3,"ForeignModule"],[3,"ExternCrate"],[3,"EncodedMetadata"],[4,"DepKind"],[4,"LibSource"],[4,"LinkagePreference"],[4,"NativeLibraryKind"],[4,"ExternCrateSource"],[8,"MetadataLoader"],[8,"CrateStore"],[3,"MarkSymbolVisitor"],[3,"LifeSeeder"],[3,"DeadVisitor"],[4,"Linkage"],[3,"EntryContext"],[4,"SymbolExportLevel"],[4,"ExportedSymbol"],[3,"RegionRelations"],[3,"ItemVisitor"],[3,"ExprVisitor"],[3,"LibFeatures"],[3,"LibFeatureCollector"],[3,"LanguageItems"],[3,"LanguageItemCollector"],[4,"LangItem"],[3,"Variable"],[3,"LiveNode"],[3,"CaptureInfo"],[3,"LocalInfo"],[3,"IrMaps"],[3,"Users"],[3,"Specials"],[3,"Liveness"],[4,"LoopKind"],[4,"LiveNodeKind"],[4,"VarKind"],[3,"Upvar"],[3,"FieldIndex"],[3,"cmt_"],[3,"MemCategorizationContext"],[4,"Categorization"],[4,"PointerKind"],[4,"InteriorKind"],[4,"InteriorOffsetKind"],[4,"MutabilityCategory"],[4,"Note"],[4,"ImmutabilityBlame"],[4,"Aliasability"],[4,"AliasableReason"],[8,"HirNode"],[3,"AccessLevels"],[4,"AccessLevel"],[3,"ReachableContext"],[3,"CollectPrivateImplItemsVisitor"],[3,"ReachableSet"],[3,"Scope"],[3,"FirstStatementIndex"],[3,"ScopeTree"],[3,"Context"],[3,"RegionResolutionVisitor"],[3,"ExprLocatorVisitor"],[4,"ScopeData"],[3,"NamedRegionMap"],[3,"ResolveLifetimes"],[3,"LifetimeContext"],[3,"ElisionFailureInfo"],[3,"Original"],[3,"Shadower"],[4,"LifetimeDefOrigin"],[4,"LifetimeUseSet"],[4,"Region"],[4,"Set1"],[4,"Scope"],[4,"Elide"],[4,"ShadowKind"],[3,"DeprecationEntry"],[3,"Index"],[3,"Annotator"],[3,"MissingStabilityAnnotations"],[3,"Checker"],[4,"StabilityLevel"],[4,"AnnotationKind"],[4,"EvalResult"],[3,"Context"],[3,"Mir"],[3,"SourceInfo"],[3,"Local"],[3,"VarBindingForm"],[3,"LocalDecl"],[3,"UpvarDecl"],[3,"BasicBlock"],[3,"BasicBlockData"],[3,"Terminator"],[3,"Statement"],[3,"ValidationOperand"],[3,"Static"],[3,"Projection"],[3,"Field"],[3,"SourceScope"],[3,"SourceScopeData"],[3,"SourceScopeLocalData"],[3,"Constant"],[3,"Promoted"],[3,"Location"],[3,"UnsafetyViolation"],[3,"UnsafetyCheckResult"],[3,"GeneratorLayout"],[3,"BorrowCheckResult"],[3,"ClosureRegionRequirements"],[3,"ClosureOutlivesRequirement"],[4,"Safety"],[4,"ClearCrossCrate"],[4,"Mutability"],[4,"BorrowKind"],[4,"LocalKind"],[4,"BindingForm"],[4,"TerminatorKind"],[4,"StatementKind"],[4,"ValidationOp"],[4,"Place"],[4,"ProjectionElem"],[4,"Operand"],[4,"Rvalue"],[4,"CastKind"],[4,"AggregateKind"],[4,"BinOp"],[4,"NullOp"],[4,"UnOp"],[4,"UnsafetyViolationKind"],[4,"ClosureOutlivesSubject"],[3,"Cache"],[3,"EvalError"],[3,"ConstEvalErr"],[3,"FrameInfo"],[3,"DynamicLifetime"],[3,"GlobalId"],[3,"Pointer"],[3,"AllocId"],[3,"AllocDecodingState"],[3,"AllocDecodingSession"],[3,"AllocMap"],[3,"Allocation"],[3,"Relocations"],[3,"UndefMask"],[4,"EvalErrorKind"],[4,"Scalar"],[4,"ConstValue"],[4,"ScalarMaybeUndef"],[4,"Lock"],[4,"AccessKind"],[4,"AllocKind"],[4,"State"],[4,"AllocType"],[8,"PointerArithmetic"],[3,"CodegenUnit"],[3,"Stats"],[3,"CodegenUnitNameBuilder"],[4,"MonoItem"],[4,"Linkage"],[4,"Visibility"],[4,"PlaceTy"],[4,"RvalueInitializationState"],[3,"Preorder"],[3,"Postorder"],[3,"ReversePostorder"],[4,"TyContext"],[4,"PlaceContext"],[8,"Visitor"],[8,"MutVisitor"],[8,"MirVisitable"],[8,"HasLocalDecls"],[3,"FieldInfo"],[3,"VariantInfo"],[3,"Session"],[3,"PerfStats"],[3,"CrateDisambiguator"],[4,"DataTypeKind"],[4,"SizeKind"],[4,"DiagnosticBuilderMethod"],[4,"DiagnosticMessageId"],[4,"IncrCompSession"],[4,"CompileIncomplete"],[3,"TypeSizeInfo"],[3,"CodeStats"],[3,"Config"],[3,"OutputTypes"],[3,"Externs"],[3,"Options"],[3,"OutputFilenames"],[3,"CodegenOptions"],[3,"DebuggingOptions"],[3,"RustcOptGroup"],[4,"Sanitizer"],[4,"OptLevel"],[4,"Lto"],[4,"LtoCli"],[4,"CrossLangLto"],[4,"DebugInfo"],[4,"OutputType"],[4,"ErrorOutputType"],[4,"PrintRequest"],[4,"BorrowckMode"],[4,"Input"],[4,"EntryFnType"],[4,"CrateType"],[4,"Passes"],[4,"OptionStability"],[8,"DepTrackingHash"],[3,"FileSearch"],[4,"FileMatch"],[3,"SearchPaths"],[3,"Iter"],[4,"PathKind"],[3,"OverlapResult"],[3,"FulfillmentContext"],[3,"PendingPredicateObligation"],[3,"MismatchedProjectionTypes"],[3,"ProjectionCache"],[3,"ProjectionCacheSnapshot"],[3,"Normalized"],[3,"OnUnimplementedDirective"],[3,"OnUnimplementedNote"],[3,"EvaluationCache"],[3,"SelectionContext"],[3,"SelectionCache"],[3,"OverlapError"],[3,"SpecializesCache"],[3,"SupertraitDefIds"],[3,"Obligation"],[3,"ObligationCause"],[3,"DerivedObligationCause"],[3,"ProgramClause"],[3,"FulfillmentError"],[3,"VtableImplData"],[3,"VtableGeneratorData"],[3,"VtableClosureData"],[3,"VtableAutoImplData"],[3,"VtableBuiltinData"],[3,"VtableObjectData"],[3,"VtableFnPointerData"],[4,"OrphanCheckErr"],[4,"Reveal"],[4,"ObjectSafetyViolation"],[4,"MethodViolationCode"],[4,"EvaluationResult"],[4,"IntercrateAmbiguityCause"],[4,"IntercrateMode"],[4,"TraitQueryMode"],[4,"ObligationCauseCode"],[4,"WhereClause"],[4,"WellFormed"],[4,"FromEnv"],[4,"DomainGoal"],[4,"QuantifierKind"],[4,"Goal"],[4,"Clause"],[4,"SelectionError"],[4,"FulfillmentErrorCode"],[4,"Vtable"],[3,"Graph"],[3,"Ancestors"],[3,"NodeItem"],[4,"Node"],[3,"RegionDeps"],[3,"AutoTraitInfo"],[3,"AutoTraitFinder"],[3,"RegionReplacer"],[4,"RegionTarget"],[4,"AutoTraitResult"],[4,"InCrate"],[4,"Conflict"],[4,"ArgKind"],[8,"TraitEngine"],[8,"TraitEngineExt"],[3,"FulfillProcessor"],[3,"AssociatedTypeNormalizer"],[3,"Progress"],[3,"ProjectionCacheKey"],[4,"ProjectionTyError"],[4,"ProjectionTyCandidate"],[4,"ProjectionTyCandidateSet"],[4,"ProjectedTy"],[4,"ProjectionCacheEntry"],[3,"OnUnimplementedFormatString"],[3,"TraitObligationStack"],[3,"SelectionCandidateSet"],[3,"EvaluatedCandidate"],[3,"TraitObligationStackList"],[3,"WithDepNode"],[4,"SelectionCandidate"],[4,"BuiltinImplConditions"],[3,"OverflowError"],[3,"Children"],[4,"Inserted"],[3,"TraitSelectionCache"],[3,"ProjectionCache"],[3,"PredicateSet"],[3,"Elaborator"],[3,"FilterToTraits"],[4,"TupleArgumentsFlag"],[3,"DropckOutlivesResult"],[3,"DtorckConstraint"],[3,"NormalizationResult"],[3,"QueryNormalizer"],[3,"NormalizeAfterErasingRegionsFolder"],[4,"OutlivesBound"],[3,"CustomTypeOp"],[3,"Eq"],[3,"ImpliedOutlivesBounds"],[3,"Normalize"],[8,"Normalizable"],[3,"DropckOutlives"],[3,"ProvePredicate"],[3,"Subtype"],[8,"TypeOp"],[8,"QueryTypeOp"],[3,"NoSolution"],[8,"ExClauseFold"],[8,"ExClauseLift"],[6,"TraitObligation"],[3,"Binder"],[3,"CanonicalVar"],[3,"DebruijnIndex"],[3,"FnSig"],[3,"GenSig"],[3,"ParamTy"],[3,"ProjectionTy"],[3,"ClosureSubsts"],[3,"GeneratorSubsts"],[3,"TypeAndMut"],[3,"TraitRef"],[3,"ExistentialTraitRef"],[3,"ExistentialProjection"],[3,"Const"],[3,"EarlyBoundRegion"],[3,"FreeRegion"],[3,"TyVid"],[3,"IntVid"],[3,"FloatVid"],[3,"RegionVid"],[3,"TyCtxt"],[3,"GlobalArenas"],[3,"AllArenas"],[3,"TypeckTables"],[3,"Instance"],[3,"CrateAnalysis"],[3,"Resolutions"],[3,"ImplHeader"],[3,"AssociatedItem"],[3,"CrateVariancesMap"],[3,"CReaderCacheKey"],[3,"TypeFlags"],[3,"TyS"],[3,"List"],[3,"UpvarId"],[3,"UpvarBorrow"],[3,"ClosureUpvar"],[3,"FloatVarValue"],[3,"GenericParamDef"],[3,"GenericParamCount"],[3,"Generics"],[3,"GenericPredicates"],[3,"CratePredicatesMap"],[3,"TraitPredicate"],[3,"OutlivesPredicate"],[3,"SubtypePredicate"],[3,"ProjectionPredicate"],[3,"InstantiatedPredicates"],[3,"UniverseIndex"],[3,"ParamEnv"],[3,"ParamEnvAnd"],[3,"Destructor"],[3,"AdtFlags"],[3,"VariantFlags"],[3,"VariantDef"],[3,"FieldDef"],[3,"AdtDef"],[3,"ReprFlags"],[3,"ReprOptions"],[3,"CrateInherentImpls"],[3,"SymbolName"],[4,"InferTy"],[4,"ExistentialPredicate"],[4,"UpvarSubsts"],[4,"TyKind"],[4,"BoundRegion"],[4,"RegionKind"],[4,"InstanceDef"],[4,"AssociatedItemContainer"],[4,"AssociatedKind"],[4,"Visibility"],[4,"Variance"],[4,"BorrowKind"],[4,"UpvarCapture"],[4,"IntVarValue"],[4,"GenericParamDefKind"],[4,"Predicate"],[4,"VariantDiscr"],[4,"AdtKind"],[4,"ClosureKind"],[4,"Attributes"],[3,"ImplicitCtxt"],[3,"Adjustment"],[3,"OverloadedDeref"],[3,"CoerceUnsizedInfo"],[4,"Adjust"],[4,"AllowTwoPhase"],[4,"AutoBorrowMutability"],[4,"AutoBorrow"],[4,"CustomCoerceUnsized"],[4,"BindingMode"],[4,"IntTy"],[4,"CastTy"],[4,"CastKind"],[8,"EncodableWithShorthand"],[8,"TyEncoder"],[8,"TyDecoder"],[3,"ExpectedFound"],[4,"TypeError"],[4,"UnconstrainedNumeric"],[3,"RegionEraserVisitor"],[4,"SimplifiedTypeGen"],[3,"BottomUpFolder"],[3,"RegionFolder"],[3,"RegionReplacer"],[3,"HasEscapingRegionsVisitor"],[3,"HasTypeFlagsVisitor"],[3,"LateBoundRegionsCollector"],[8,"TypeFoldable"],[8,"TypeFolder"],[8,"TypeVisitor"],[3,"DefIdForest"],[3,"LocalPathBuffer"],[4,"RootMode"],[8,"ItemPathBuffer"],[4,"PassMode"],[3,"ArgAttributes"],[4,"RegKind"],[3,"Reg"],[3,"Uniform"],[3,"CastTarget"],[3,"ArgType"],[4,"Conv"],[3,"FnType"],[3,"ArgAttribute"],[3,"TargetDataLayout"],[8,"HasDataLayout"],[4,"Endian"],[3,"Size"],[3,"Align"],[4,"Integer"],[4,"FloatTy"],[4,"Primitive"],[3,"Scalar"],[4,"FieldPlacement"],[4,"Abi"],[4,"Variants"],[3,"LayoutDetails"],[3,"TyLayout"],[8,"LayoutOf"],[8,"TyLayoutMethods"],[3,"LayoutCx"],[3,"Niche"],[4,"LayoutError"],[4,"SizeSkeleton"],[8,"IntegerExt"],[8,"PrimitiveExt"],[8,"HasTyCtxt"],[8,"MaybeResult"],[3,"Match"],[4,"Component"],[3,"CycleError"],[3,"QueryJob"],[3,"QueryInfo"],[3,"OnDiskCache"],[3,"Queries"],[3,"TyCtxtAt"],[3,"Providers"],[4,"Query"],[3,"QueryCache"],[3,"QueryValue"],[3,"JobOwner"],[4,"TryGetJob"],[4,"QueryResult"],[8,"Key"],[8,"Value"],[8,"QueryConfig"],[8,"QueryAccessors"],[8,"QueryDescription"],[3,"Footer"],[3,"SourceFileIndex"],[3,"AbsoluteBytePos"],[3,"CacheDecoder"],[3,"CacheEncoder"],[3,"IntEncodedWithFixedSize"],[8,"DecoderWithPosition"],[3,"type_of"],[3,"generics_of"],[3,"predicates_of"],[3,"predicates_defined_on"],[3,"explicit_predicates_of"],[3,"inferred_outlives_of"],[3,"super_predicates_of"],[3,"type_param_predicates"],[3,"trait_def"],[3,"adt_def"],[3,"adt_destructor"],[3,"adt_sized_constraint"],[3,"adt_dtorck_constraint"],[3,"is_const_fn"],[3,"is_foreign_item"],[3,"crate_variances"],[3,"variances_of"],[3,"inferred_outlives_crate"],[3,"associated_item_def_ids"],[3,"associated_item"],[3,"impl_trait_ref"],[3,"impl_polarity"],[3,"inherent_impls"],[3,"mir_keys"],[3,"mir_const_qualif"],[3,"mir_built"],[3,"mir_const"],[3,"mir_validated"],[3,"optimized_mir"],[3,"unsafety_check_result"],[3,"unsafe_derive_on_repr_packed"],[3,"fn_sig"],[3,"coerce_unsized_info"],[3,"typeck_item_bodies"],[3,"typeck_tables_of"],[3,"used_trait_imports"],[3,"has_typeck_tables"],[3,"coherent_trait"],[3,"borrowck"],[3,"mir_borrowck"],[3,"crate_inherent_impls"],[3,"crate_inherent_impls_overlap_check"],[3,"const_eval"],[3,"check_match"],[3,"privacy_access_levels"],[3,"reachable_set"],[3,"region_scope_tree"],[3,"mir_shims"],[3,"def_symbol_name"],[3,"symbol_name"],[3,"describe_def"],[3,"def_span"],[3,"lookup_stability"],[3,"lookup_deprecation_entry"],[3,"item_attrs"],[3,"codegen_fn_attrs"],[3,"fn_arg_names"],[3,"rendered_const"],[3,"impl_parent"],[3,"trait_of_item"],[3,"const_is_rvalue_promotable_to_static"],[3,"rvalue_promotable_map"],[3,"is_mir_available"],[3,"vtable_methods"],[3,"codegen_fulfill_obligation"],[3,"trait_impls_of"],[3,"specialization_graph_of"],[3,"is_object_safe"],[3,"param_env"],[3,"is_copy_raw"],[3,"is_sized_raw"],[3,"is_freeze_raw"],[3,"needs_drop_raw"],[3,"layout_raw"],[3,"dylib_dependency_formats"],[3,"is_panic_runtime"],[3,"is_compiler_builtins"],[3,"has_global_allocator"],[3,"has_panic_handler"],[3,"is_sanitizer_runtime"],[3,"is_profiler_runtime"],[3,"panic_strategy"],[3,"is_no_builtins"],[3,"extern_crate"],[3,"specializes"],[3,"in_scope_traits_map"],[3,"module_exports"],[3,"lint_levels"],[3,"impl_defaultness"],[3,"check_item_well_formed"],[3,"check_trait_item_well_formed"],[3,"check_impl_item_well_formed"],[3,"reachable_non_generics"],[3,"is_reachable_non_generic"],[3,"is_unreachable_local_definition"],[3,"upstream_monomorphizations"],[3,"upstream_monomorphizations_for"],[3,"native_libraries"],[3,"foreign_modules"],[3,"plugin_registrar_fn"],[3,"derive_registrar_fn"],[3,"crate_disambiguator"],[3,"crate_hash"],[3,"original_crate_name"],[3,"extra_filename"],[3,"implementations_of_trait"],[3,"all_trait_implementations"],[3,"dllimport_foreign_items"],[3,"is_dllimport_foreign_item"],[3,"is_statically_included_foreign_item"],[3,"native_library_kind"],[3,"link_args"],[3,"resolve_lifetimes"],[3,"named_region_map"],[3,"is_late_bound_map"],[3,"object_lifetime_defaults_map"],[3,"visibility"],[3,"dep_kind"],[3,"crate_name"],[3,"item_children"],[3,"extern_mod_stmt_cnum"],[3,"get_lib_features"],[3,"defined_lib_features"],[3,"get_lang_items"],[3,"defined_lang_items"],[3,"missing_lang_items"],[3,"visible_parent_map"],[3,"missing_extern_crate_item"],[3,"used_crate_source"],[3,"postorder_cnums"],[3,"freevars"],[3,"maybe_unused_trait_import"],[3,"maybe_unused_extern_crates"],[3,"stability_index"],[3,"all_crate_nums"],[3,"all_traits"],[3,"exported_symbols"],[3,"collect_and_partition_mono_items"],[3,"is_codegened_item"],[3,"codegen_unit"],[3,"output_filenames"],[3,"erase_regions_ty"],[3,"normalize_projection_ty"],[3,"normalize_ty_after_erasing_regions"],[3,"implied_outlives_bounds"],[3,"dropck_outlives"],[3,"evaluate_obligation"],[3,"type_op_eq"],[3,"type_op_subtype"],[3,"type_op_prove_predicate"],[3,"type_op_normalize_ty"],[3,"type_op_normalize_predicate"],[3,"type_op_normalize_poly_fn_sig"],[3,"type_op_normalize_fn_sig"],[3,"substitute_normalize_and_test_predicates"],[3,"target_features_whitelist"],[3,"instance_def_size_estimate"],[3,"features_query"],[3,"program_clauses_for"],[3,"program_clauses_for_env"],[3,"wasm_import_module_map"],[3,"GeneratorWitness"],[4,"Cause"],[8,"TypeRelation"],[8,"Relate"],[3,"Steal"],[3,"Kind"],[3,"SubstFolder"],[4,"UnpackedKind"],[8,"Subst"],[6,"Substs"],[6,"CanonicalSubsts"],[3,"TraitDef"],[3,"TraitImpls"],[3,"TypeWalker"],[3,"WfPredicates"],[4,"Elaborate"],[3,"Discr"],[4,"CopyImplementationError"],[4,"Representability"],[4,"ExplicitSelf"],[8,"IntTypeExt"],[3,"CtxtInterners"],[3,"CommonTypes"],[3,"LocalTableInContext"],[3,"LocalTableInContextMut"],[3,"GlobalCtxt"],[3,"Interned"],[8,"Lift"],[8,"InternAs"],[8,"InternIteratorElement"],[3,"FlagComputation"],[3,"SplitClosureSubsts"],[3,"SplitGeneratorSubsts"],[6,"PolyTraitRef"],[6,"PolyExistentialTraitRef"],[6,"PolyGenSig"],[6,"PolyFnSig"],[6,"PolyExistentialProjection"],[8,"DefIdTree"],[8,"ToPolyTraitRef"],[8,"ToPredicate"],[6,"PolyTraitPredicate"],[6,"PolyProjectionPredicate"],[6,"PolyRegionOutlivesPredicate"],[6,"PolyTypeOutlivesPredicate"],[3,"DEFAULT_HOOK"],[3,"ProfQDumpParams"],[3,"QueryMsg"],[3,"Indenter"],[4,"ProfileQueriesMsg"],[8,"MemoizationMap"],[3,"ErrorReported"],[3,"LateBoundRegionNameCollector"],[3,"PrintContext"],[8,"Print"],[3,"Timing"],[3,"TimelineId"],[3,"PerThread"],[3,"TimeGraph"],[3,"WorkPackageKind"],[3,"Timeline"],[3,"RaiiToken"],[3,"Categories"],[3,"CategoryData"],[3,"SelfProfiler"],[4,"ProfileCategory"],[3,"NoAnn"],[6,"Ty"],[6,"Region"],[6,"RelateResult"]]};
searchIndex["rustc_allocator"]={"doc":"","items":[[3,"AllocatorMethod","rustc_allocator","",N,N],[12,"name","","",0,N],[12,"inputs","","",0,N],[12,"output","","",0,N],[4,"AllocatorTy","","",N,N],[13,"Layout","","",1,N],[13,"Ptr","","",1,N],[13,"ResultPtr","","",1,N],[13,"Unit","","",1,N],[13,"Usize","","",1,N],[0,"expand","","",N,N],[3,"ExpandAllocatorDirectives","rustc_allocator::expand","",N,N],[12,"found","","",2,N],[12,"handler","","",2,N],[12,"sess","","",2,N],[12,"resolver","","",2,N],[12,"crate_name","","",2,N],[12,"in_submod","","",2,N],[3,"AllocFnFactory","","",N,N],[12,"span","","",3,N],[12,"kind","","",3,N],[12,"global","","",3,N],[12,"core","","",3,N],[12,"cx","","",3,N],[5,"modify","","",N,[[["parsesess"],["resolver"],["crate"],["string"],["handler"]],["crate"]]],[11,"fold_item","","",2,[[["self"],["p",["item"]]],["onevector",["p"]]]],[11,"fold_mod","","",2,[[["self"],["mod"]],["mod"]]],[11,"fold_mac","","",2,[[["self"],["mac"]],["mac"]]],[11,"allocator_fn","","",3,[[["self"],["allocatormethod"]],["p",["item"]]]],[11,"call_allocator","","",3,[[["self"],["str"],["vec",["p"]]],["p",["expr"]]]],[11,"attrs","","",3,[[["self"]],["vec",["attribute"]]]],[11,"arg_ty","","",3,[[["self"],["allocatorty"],["vec"],["fnmut"]],["p",["expr"]]]],[11,"ret_ty","","",3,N],[11,"usize","","",3,[[["self"]],["p",["ty"]]]],[11,"ptr_u8","","",3,[[["self"]],["p",["ty"]]]],[7,"ALLOCATOR_METHODS","rustc_allocator","",N,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","rustc_allocator::expand","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]]],"paths":[[3,"AllocatorMethod"],[4,"AllocatorTy"],[3,"ExpandAllocatorDirectives"],[3,"AllocFnFactory"]]};
searchIndex["rustc_apfloat"]={"doc":"Port of LLVM's APFloat software floating-point implementation from the following C++ sources (please update commit hash when backporting): https://github.com/llvm-mirror/llvm/tree/23efab2bbd424ed13495a420ad8641cb2c6c28f9","items":[[3,"Status","rustc_apfloat","IEEE-754R 7: Default exception handling.",N,N],[12,"bits","","",0,N],[3,"StatusAnd","","",N,N],[12,"status","","",1,N],[12,"value","","",1,N],[3,"ParseError","","",N,N],[12,"0","","",2,N],[4,"Category","","Category of internally-represented number.",N,N],[13,"Infinity","","",3,N],[13,"NaN","","",3,N],[13,"Normal","","",3,N],[13,"Zero","","",3,N],[4,"Round","","IEEE-754R 4.3: Rounding-direction attributes.",N,N],[13,"NearestTiesToEven","","",4,N],[13,"TowardPositive","","",4,N],[13,"TowardNegative","","",4,N],[13,"TowardZero","","",4,N],[13,"NearestTiesToAway","","",4,N],[0,"ieee","","",N,N],[3,"IeeeFloat","rustc_apfloat::ieee","",N,N],[12,"sig","","Absolute significand value (including the integer bit).",5,N],[12,"exp","","The signed unbiased exponent of the value.",5,N],[12,"category","","What kind of floating point number this is.",5,N],[12,"sign","","Sign bit of the number.",5,N],[12,"marker","","",5,N],[3,"HalfS","","",N,N],[3,"SingleS","","",N,N],[3,"DoubleS","","",N,N],[3,"QuadS","","",N,N],[3,"X87DoubleExtendedS","","",N,N],[4,"Loss","","Enum that represents what fraction of the LSB truncated bits of an fp number represent.",N,N],[13,"ExactlyZero","","",6,N],[13,"LessThanHalf","","",6,N],[13,"ExactlyHalf","","",6,N],[13,"MoreThanHalf","","",6,N],[5,"limbs_for_bits","","",N,[[["usize"]],["usize"]]],[0,"sig","","Implementation details of IeeeFloat significands, such as big integer arithmetic. As a rule of thumb, no functions in this module should dynamically allocate.",N,N],[5,"is_all_zeros","rustc_apfloat::ieee::sig","",N,N],[5,"olsb","","One, not zero, based LSB. That is, returns 0 for a zeroed significand.",N,N],[5,"omsb","","One, not zero, based MSB. That is, returns 0 for a zeroed significand.",N,N],[5,"cmp","","Comparison (unsigned) of two significands.",N,N],[5,"get_bit","","Extract the given bit.",N,N],[5,"set_bit","","Set the given bit.",N,N],[5,"clear_bit","","Clear the given bit.",N,N],[5,"shift_left","","Shift `dst` left `bits` bits, subtract `bits` from its exponent.",N,N],[5,"shift_right","","Shift `dst` right `bits` bits noting lost fraction.",N,N],[5,"extract","","Copy the bit vector of width `src_bits` from `src`, starting at bit SRC_LSB, to `dst`, such that the bit SRC_LSB becomes the least significant bit of `dst`. All high bits above `src_bits` in `dst` are zero-filled.",N,N],[5,"from_limbs","","We want the most significant PRECISION bits of `src`. There may not be that many; extract what we can.",N,N],[5,"each_chunk","","For every consecutive chunk of `bits` bits from `limbs`, going from most significant to the least significant bits, call `f` to transform those bits and store the result back.",N,N],[5,"increment","","Increment in-place, return the carry flag.",N,N],[5,"decrement","","Decrement in-place, return the borrow flag.",N,N],[5,"add","","`a += b + c` where `c` is zero or one. Returns the carry flag.",N,N],[5,"sub","","`a -= b + c` where `c` is zero or one. Returns the borrow flag.",N,N],[5,"add_or_sub","","`a += b` or `a -= b`. Does not preserve `b`.",N,N],[5,"widening_mul","","`[low, high] = a * b`.",N,N],[5,"mul","","`dst = a * b` (for normal `a` and `b`). Returns the lost fraction.",N,N],[5,"div","","`quotient = dividend / divisor`. Returns the lost fraction. Does not preserve `dividend` or `divisor`.",N,N],[6,"Limb","rustc_apfloat::ieee","Fundamental unit of big integer arithmetic, but also large to store the largest significands by itself.",N,N],[6,"Half","","",N,N],[6,"Single","","",N,N],[6,"Double","","",N,N],[6,"Quad","","",N,N],[6,"X87DoubleExtended","","",N,N],[17,"LIMB_BITS","","",N,N],[8,"Semantics","","Represents floating point arithmetic semantics.",N,N],[18,"BITS","","Total number of bits in the in-memory format.",7,N],[18,"PRECISION","","Number of bits in the significand. This includes the integer bit.",7,N],[18,"MAX_EXP","","The largest E such that 2E is representable; this matches the definition of IEEE 754.",7,N],[18,"MIN_EXP","","The smallest E such that 2E is a normalized number; this matches the definition of IEEE 754.",7,N],[18,"QNAN_BIT","","The significand bit that marks NaN as quiet.",7,N],[18,"QNAN_SIGNIFICAND","","The significand bitpattern to mark a NaN as quiet. NOTE: for X87DoubleExtended we need to set two bits instead of 2.",7,N],[11,"from_bits","","",7,[[["u128"]],["ieeefloat"]]],[11,"to_bits","","",7,[[["ieeefloat"]],["u128"]]],[11,"clone","","",6,[[["self"]],["loss"]]],[11,"eq","","",6,[[["self"],["loss"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",6,N],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"clone","","",5,[[["self"]],["self"]]],[11,"from_bits","","Integer bit is explicit in this format. Intel hardware (387 and later) does not support these bit patterns:  exponent = all 1's, integer bit 0, significand 0 (\"pseudoinfinity\")  exponent = all 1's, integer bit 0, significand nonzero (\"pseudoNaN\")  exponent = 0, integer bit 1 (\"pseudodenormal\")  exponent!=0 nor all 1's, integer bit 0 (\"unnormal\") At the moment, the first two are treated as NaNs, the second two as Normal.",8,[[["u128"]],["ieeefloat"]]],[11,"to_bits","","",8,[[["ieeefloat"]],["u128"]]],[11,"default","","",5,[[],["self"]]],[11,"from_str","","",5,[[["str"]],["result",["parseerror"]]]],[11,"add","","",5,[[["self"],["self"]],["statusand"]]],[11,"sub","","",5,[[["self"],["self"]],["statusand"]]],[11,"mul","","",5,[[["self"],["self"]],["statusand"]]],[11,"div","","",5,[[["self"],["self"]],["statusand"]]],[11,"rem","","",5,[[["self"],["self"]],["statusand"]]],[11,"add_assign","","",5,[[["self"],["self"]]]],[11,"sub_assign","","",5,[[["self"],["self"]]]],[11,"mul_assign","","",5,[[["self"],["self"]]]],[11,"div_assign","","",5,[[["self"],["self"]]]],[11,"rem_assign","","",5,[[["self"],["self"]]]],[11,"eq","","",5,[[["self"],["self"]],["bool"]]],[11,"partial_cmp","","",5,[[["self"],["self"]],["option",["ordering"]]]],[11,"neg","","",5,[[["self"]],["self"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"qnan","","",5,[[["option",["u128"]]],["self"]]],[11,"snan","","",5,[[["option",["u128"]]],["self"]]],[11,"largest","","",5,[[],["self"]]],[11,"smallest_normalized","","",5,[[],["self"]]],[11,"add_r","","",5,[[["self"],["self"],["round"]],["statusand"]]],[11,"mul_r","","",5,[[["self"],["self"],["round"]],["statusand"]]],[11,"mul_add_r","","",5,[[["self"],["self"],["self"],["round"]],["statusand"]]],[11,"div_r","","",5,[[["self"],["self"],["round"]],["statusand"]]],[11,"c_fmod","","",5,[[["self"],["self"]],["statusand"]]],[11,"round_to_integral","","",5,[[["self"],["round"]],["statusand"]]],[11,"next_up","","",5,[[["self"]],["statusand"]]],[11,"from_bits","","",5,[[["u128"]],["self"]]],[11,"from_u128_r","","",5,[[["u128"],["round"]],["statusand"]]],[11,"from_str_r","","",5,[[["str"],["round"]],["result",["statusand","parseerror"]]]],[11,"to_bits","","",5,[[["self"]],["u128"]]],[11,"to_u128_r","","",5,[[["self"],["usize"],["round"],["bool"]],["statusand",["u128"]]]],[11,"cmp_abs_normal","","",5,[[["self"],["self"]],["ordering"]]],[11,"bitwise_eq","","",5,[[["self"],["self"]],["bool"]]],[11,"is_negative","","",5,[[["self"]],["bool"]]],[11,"is_denormal","","",5,[[["self"]],["bool"]]],[11,"is_signaling","","",5,[[["self"]],["bool"]]],[11,"category","","",5,[[["self"]],["category"]]],[11,"get_exact_inverse","","",5,[[["self"]],["option"]]],[11,"ilogb","","",5,[[["self"]],["expint"]]],[11,"scalbn_r","","",5,[[["self"],["expint"],["round"]],["self"]]],[11,"frexp_r","","",5,[[["self"],["expint"],["round"]],["self"]]],[11,"convert_r","","",5,[[["self"],["round"],["bool"]],["statusand",["ieeefloat"]]]],[11,"overflow_result","","Handle positive overflow. We either return infinity or the largest finite number. For negative overflow, negate the `round` argument before calling.",5,[[["round"]],["statusand"]]],[11,"round_away_from_zero","","Returns TRUE if, when truncating the current number, with BIT the new LSB, with the given lost fraction and rounding mode, the result would need to be rounded away from zero (i.e., by increasing the signficand). This routine must work for Category::Zero of both signs, and Category::Normal numbers.",5,[[["self"],["round"],["loss"],["usize"]],["bool"]]],[11,"normalize","","",5,[[["self"],["round"],["loss"]],["statusand"]]],[11,"from_hexadecimal_string","","",5,[[["str"],["round"]],["result",["statusand","parseerror"]]]],[11,"from_decimal_string","","",5,[[["str"],["round"]],["result",["statusand","parseerror"]]]],[11,"combine","","Combine the effect of two lost fractions.",6,[[["self"],["loss"]],["loss"]]],[11,"through_truncation","","Return the fraction lost were a bignum truncated losing the least significant `bits` bits.",6,N],[0,"ppc","rustc_apfloat","",N,N],[3,"DoubleFloat","rustc_apfloat::ppc","",N,N],[12,"0","","",9,N],[12,"1","","",9,N],[3,"FallbackS","","",N,N],[12,"0","","",10,N],[3,"FallbackExtendedS","","",N,N],[12,"0","","",11,N],[6,"DoubleDouble","","",N,N],[6,"Fallback","","",N,N],[6,"FallbackExtended","","",N,N],[11,"clone","","",9,[[["self"]],["doublefloat"]]],[11,"eq","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"ne","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"partial_cmp","","",9,[[["self"],["doublefloat"]],["option",["ordering"]]]],[11,"lt","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"le","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"gt","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"ge","","",9,[[["self"],["doublefloat"]],["bool"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"from","","",9,[[["ieeefloat",["fallbacks"]]],["self"]]],[11,"from","rustc_apfloat::ieee","",5,[[["doublefloat"]],["self"]]],[11,"default","rustc_apfloat::ppc","",9,[[],["self"]]],[11,"from_str","","",9,[[["str"]],["result",["parseerror"]]]],[11,"add","","",9,[[["self"],["self"]],["statusand"]]],[11,"sub","","",9,[[["self"],["self"]],["statusand"]]],[11,"mul","","",9,[[["self"],["self"]],["statusand"]]],[11,"div","","",9,[[["self"],["self"]],["statusand"]]],[11,"rem","","",9,[[["self"],["self"]],["statusand"]]],[11,"add_assign","","",9,[[["self"],["self"]]]],[11,"sub_assign","","",9,[[["self"],["self"]]]],[11,"mul_assign","","",9,[[["self"],["self"]]]],[11,"div_assign","","",9,[[["self"],["self"]]]],[11,"rem_assign","","",9,[[["self"],["self"]]]],[11,"neg","","",9,[[["self"]],["self"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"qnan","","",9,[[["option",["u128"]]],["self"]]],[11,"snan","","",9,[[["option",["u128"]]],["self"]]],[11,"largest","","",9,[[],["self"]]],[11,"smallest_normalized","","",9,[[],["self"]]],[11,"add_r","","",9,[[["self"],["self"],["round"]],["statusand"]]],[11,"mul_r","","",9,[[["self"],["self"],["round"]],["statusand"]]],[11,"mul_add_r","","",9,[[["self"],["self"],["self"],["round"]],["statusand"]]],[11,"div_r","","",9,[[["self"],["self"],["round"]],["statusand"]]],[11,"c_fmod","","",9,[[["self"],["self"]],["statusand"]]],[11,"round_to_integral","","",9,[[["self"],["round"]],["statusand"]]],[11,"next_up","","",9,[[["self"]],["statusand"]]],[11,"from_bits","","",9,[[["u128"]],["self"]]],[11,"from_u128_r","","",9,[[["u128"],["round"]],["statusand"]]],[11,"from_str_r","","",9,[[["str"],["round"]],["result",["statusand","parseerror"]]]],[11,"to_bits","","",9,[[["self"]],["u128"]]],[11,"to_u128_r","","",9,[[["self"],["usize"],["round"],["bool"]],["statusand",["u128"]]]],[11,"cmp_abs_normal","","",9,[[["self"],["self"]],["ordering"]]],[11,"bitwise_eq","","",9,[[["self"],["self"]],["bool"]]],[11,"is_negative","","",9,[[["self"]],["bool"]]],[11,"is_denormal","","",9,[[["self"]],["bool"]]],[11,"is_signaling","","",9,[[["self"]],["bool"]]],[11,"category","","",9,[[["self"]],["category"]]],[11,"get_exact_inverse","","",9,[[["self"]],["option"]]],[11,"ilogb","","",9,[[["self"]],["expint"]]],[11,"scalbn_r","","",9,[[["self"],["expint"],["round"]],["self"]]],[11,"frexp_r","","",9,[[["self"],["expint"],["round"]],["self"]]],[6,"ExpInt","rustc_apfloat","A signed type to represent a floating point number's unbiased exponent.",N,N],[17,"IEK_INF","","",N,N],[17,"IEK_NAN","","",N,N],[17,"IEK_ZERO","","",N,N],[8,"Float","","A self-contained host- and target-independent arbitrary-precision floating-point software implementation.",N,N],[18,"BITS","","Total number of bits in the in-memory format.",12,N],[18,"PRECISION","","Number of bits in the significand. This includes the integer bit.",12,N],[18,"MAX_EXP","","The largest E such that 2E is representable; this matches the definition of IEEE 754.",12,N],[18,"MIN_EXP","","The smallest E such that 2E is a normalized number; this matches the definition of IEEE 754.",12,N],[18,"ZERO","","Positive Zero.",12,N],[18,"INFINITY","","Positive Infinity.",12,N],[18,"NAN","","NaN (Not a Number).",12,N],[10,"qnan","","Factory for QNaN values.",12,[[["option",["u128"]]],["self"]]],[10,"snan","","Factory for SNaN values.",12,[[["option",["u128"]]],["self"]]],[10,"largest","","Largest finite number.",12,[[],["self"]]],[18,"SMALLEST","","Smallest (by magnitude) finite number. Might be denormalized, which implies a relative loss of precision.",12,N],[10,"smallest_normalized","","Smallest (by magnitude) normalized finite number.",12,[[],["self"]]],[10,"add_r","","",12,[[["self"],["self"],["round"]],["statusand"]]],[11,"sub_r","","",12,[[["self"],["self"],["round"]],["statusand"]]],[10,"mul_r","","",12,[[["self"],["self"],["round"]],["statusand"]]],[10,"mul_add_r","","",12,[[["self"],["self"],["self"],["round"]],["statusand"]]],[11,"mul_add","","",12,[[["self"],["self"],["self"]],["statusand"]]],[10,"div_r","","",12,[[["self"],["self"],["round"]],["statusand"]]],[11,"ieee_rem","","IEEE remainder.",12,[[["self"],["self"]],["statusand"]]],[10,"c_fmod","","C fmod, or llvm frem.",12,[[["self"],["self"]],["statusand"]]],[10,"round_to_integral","","",12,[[["self"],["round"]],["statusand"]]],[10,"next_up","","IEEE-754R 2008 5.3.1: nextUp.",12,[[["self"]],["statusand"]]],[11,"next_down","","IEEE-754R 2008 5.3.1: nextDown.",12,[[["self"]],["statusand"]]],[11,"abs","","",12,[[["self"]],["self"]]],[11,"copy_sign","","",12,[[["self"],["self"]],["self"]]],[10,"from_bits","","",12,[[["u128"]],["self"]]],[11,"from_i128_r","","",12,[[["i128"],["round"]],["statusand"]]],[11,"from_i128","","",12,[[["i128"]],["statusand"]]],[10,"from_u128_r","","",12,[[["u128"],["round"]],["statusand"]]],[11,"from_u128","","",12,[[["u128"]],["statusand"]]],[10,"from_str_r","","",12,[[["str"],["round"]],["result",["statusand","parseerror"]]]],[10,"to_bits","","",12,[[["self"]],["u128"]]],[11,"to_i128_r","","Convert a floating point number to an integer according to the rounding mode. In case of an invalid operation exception, deterministic values are returned, namely zero for NaNs and the minimal or maximal value respectively for underflow or overflow. If the rounded value is in range but the floating point number is not the exact integer, the C standard doesn't require an inexact exception to be raised. IEEE-854 does require it so we do that.",12,[[["self"],["usize"],["round"],["bool"]],["statusand",["i128"]]]],[11,"to_i128","","",12,[[["self"],["usize"]],["statusand",["i128"]]]],[10,"to_u128_r","","",12,[[["self"],["usize"],["round"],["bool"]],["statusand",["u128"]]]],[11,"to_u128","","",12,[[["self"],["usize"]],["statusand",["u128"]]]],[10,"cmp_abs_normal","","",12,[[["self"],["self"]],["ordering"]]],[10,"bitwise_eq","","Bitwise comparison for equality (QNaNs compare equal, 0!=-0).",12,[[["self"],["self"]],["bool"]]],[11,"min","","Implements IEEE minNum semantics. Returns the smaller of the 2 arguments if both are not NaN. If either argument is a NaN, returns the other argument.",12,[[["self"],["self"]],["self"]]],[11,"max","","Implements IEEE maxNum semantics. Returns the larger of the 2 arguments if both are not NaN. If either argument is a NaN, returns the other argument.",12,[[["self"],["self"]],["self"]]],[10,"is_negative","","IEEE-754R isSignMinus: Returns true if and only if the current value is negative.",12,[[["self"]],["bool"]]],[11,"is_normal","","IEEE-754R isNormal: Returns true if and only if the current value is normal.",12,[[["self"]],["bool"]]],[11,"is_finite","","Returns true if and only if the current value is zero, subnormal, or normal.",12,[[["self"]],["bool"]]],[11,"is_zero","","Returns true if and only if the float is plus or minus zero.",12,[[["self"]],["bool"]]],[10,"is_denormal","","IEEE-754R isSubnormal(): Returns true if and only if the float is a denormal.",12,[[["self"]],["bool"]]],[11,"is_infinite","","IEEE-754R isInfinite(): Returns true if and only if the float is infinity.",12,[[["self"]],["bool"]]],[11,"is_nan","","Returns true if and only if the float is a quiet or signaling NaN.",12,[[["self"]],["bool"]]],[10,"is_signaling","","Returns true if and only if the float is a signaling NaN.",12,[[["self"]],["bool"]]],[10,"category","","",12,[[["self"]],["category"]]],[11,"is_non_zero","","",12,[[["self"]],["bool"]]],[11,"is_finite_non_zero","","",12,[[["self"]],["bool"]]],[11,"is_pos_zero","","",12,[[["self"]],["bool"]]],[11,"is_neg_zero","","",12,[[["self"]],["bool"]]],[11,"is_smallest","","Returns true if and only if the number has the smallest possible non-zero magnitude in the current semantics.",12,[[["self"]],["bool"]]],[11,"is_largest","","Returns true if and only if the number has the largest possible finite magnitude in the current semantics.",12,[[["self"]],["bool"]]],[11,"is_integer","","Returns true if and only if the number is an exact integer.",12,[[["self"]],["bool"]]],[10,"get_exact_inverse","","If this value has an exact multiplicative inverse, return it.",12,[[["self"]],["option"]]],[10,"ilogb","","Returns the exponent of the internal representation of the Float.",12,[[["self"]],["expint"]]],[10,"scalbn_r","","Returns: self * 2exp for integral exponents.",12,[[["self"],["expint"],["round"]],["self"]]],[11,"scalbn","","",12,[[["self"],["expint"]],["self"]]],[10,"frexp_r","","Equivalent of C standard library function.",12,[[["self"],["expint"],["round"]],["self"]]],[11,"frexp","","",12,[[["self"],["expint"]],["self"]]],[8,"FloatConvert","","",N,N],[10,"convert_r","","Convert a value of one floating point type to another. The return value corresponds to the IEEE754 exceptions. *loses_info records whether the transformation lost information, i.e. whether converting the result back to the original type will produce the original value (this is almost the same as return value==Status::OK, but there are edge cases where this is not so).",13,[[["self"],["round"],["bool"]],["statusand"]]],[11,"convert","","",13,[[["self"],["bool"]],["statusand"]]],[11,"eq","","",0,[[["self"],["status"]],["bool"]]],[11,"ne","","",0,[[["self"],["status"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"clone","","",0,[[["self"]],["status"]]],[11,"partial_cmp","","",0,[[["self"],["status"]],["option",["ordering"]]]],[11,"lt","","",0,[[["self"],["status"]],["bool"]]],[11,"le","","",0,[[["self"],["status"]],["bool"]]],[11,"gt","","",0,[[["self"],["status"]],["bool"]]],[11,"ge","","",0,[[["self"],["status"]],["bool"]]],[11,"cmp","","",0,[[["self"],["status"]],["ordering"]]],[11,"hash","","",0,N],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[18,"OK","","",0,N],[18,"INVALID_OP","","",0,N],[18,"DIV_BY_ZERO","","",0,N],[18,"OVERFLOW","","",0,N],[18,"UNDERFLOW","","",0,N],[18,"INEXACT","","",0,N],[11,"empty","","Returns an empty set of flags.",0,[[],["status"]]],[11,"all","","Returns the set containing all flags.",0,[[],["status"]]],[11,"bits","","Returns the raw value of the flags currently stored.",0,[[["self"]],["u8"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",0,[[["u8"]],["option",["status"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",0,[[["u8"]],["status"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",0,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",0,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",0,[[["self"],["status"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",0,[[["self"],["status"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",0,[[["self"],["status"]]]],[11,"remove","","Removes the specified flags in-place.",0,[[["self"],["status"]]]],[11,"toggle","","Toggles the specified flags in-place.",0,[[["self"],["status"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",0,[[["self"],["status"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",0,[[["self"],["status"]],["status"]]],[11,"bitor_assign","","Adds the set of flags.",0,[[["self"],["status"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",0,[[["self"],["status"]],["status"]]],[11,"bitxor_assign","","Toggles the set of flags.",0,[[["self"],["status"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",0,[[["self"],["status"]],["status"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",0,[[["self"],["status"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",0,[[["self"],["status"]],["status"]]],[11,"sub_assign","","Disables all flags enabled in the set.",0,[[["self"],["status"]]]],[11,"not","","Returns the complement of this set of flags.",0,[[["self"]],["status"]]],[11,"extend","","",0,[[["self"],["t"]]]],[11,"from_iter","","",0,[[["t"]],["status"]]],[11,"clone","","",1,[[["self"]],["statusand"]]],[11,"eq","","",1,[[["self"],["statusand"]],["bool"]]],[11,"ne","","",1,[[["self"],["statusand"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1,N],[11,"partial_cmp","","",1,[[["self"],["statusand"]],["option",["ordering"]]]],[11,"lt","","",1,[[["self"],["statusand"]],["bool"]]],[11,"le","","",1,[[["self"],["statusand"]],["bool"]]],[11,"gt","","",1,[[["self"],["statusand"]],["bool"]]],[11,"ge","","",1,[[["self"],["statusand"]],["bool"]]],[11,"cmp","","",1,[[["self"],["statusand"]],["ordering"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"and","","",0,[[["self"],["t"]],["statusand"]]],[11,"map","","",1,[[["self"],["f"]],["statusand"]]],[11,"clone","","",3,[[["self"]],["category"]]],[11,"eq","","",3,[[["self"],["category"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",4,[[["self"]],["round"]]],[11,"eq","","",4,[[["self"],["round"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"neg","","",4,[[["self"]],["round"]]],[11,"clone","","",2,[[["self"]],["parseerror"]]],[11,"eq","","",2,[[["self"],["parseerror"]],["bool"]]],[11,"ne","","",2,[[["self"],["parseerror"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[14,"unpack","","",N,N],[11,"to_owned","","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"to_owned","rustc_apfloat::ieee","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"to_string","","",5,[[["self"]],["string"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"to_owned","rustc_apfloat::ppc","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"to_string","","",9,[[["self"]],["string"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]]],"paths":[[3,"Status"],[3,"StatusAnd"],[3,"ParseError"],[4,"Category"],[4,"Round"],[3,"IeeeFloat"],[4,"Loss"],[8,"Semantics"],[3,"X87DoubleExtendedS"],[3,"DoubleFloat"],[3,"FallbackS"],[3,"FallbackExtendedS"],[8,"Float"],[8,"FloatConvert"],[3,"HalfS"],[3,"SingleS"],[3,"DoubleS"],[3,"QuadS"]]};
searchIndex["rustc_borrowck"]={"doc":"","items":[[5,"check_crate","rustc_borrowck","",N,[[["tyctxt"]]]],[5,"build_borrowck_dataflow_data_for_fn","","Accessor for introspective clients inspecting `AnalysisData` and the `BorrowckCtxt` itself , e.g. the flowgraph visualizer.",N,N],[5,"provide","","",N,[[["providers"]]]],[0,"borrowck","","See The Book chapter on the borrow checker for more details.",N,N],[3,"LoanDataFlowOperator","rustc_borrowck::borrowck","",N,N],[3,"AnalysisData","","Collection of conclusions determined via borrow checker analyses.",N,N],[12,"all_loans","","",0,N],[12,"loans","","",0,N],[12,"move_data","","",0,N],[3,"BorrowckCtxt","","",N,N],[12,"tcx","","",1,N],[12,"tables","","",1,N],[12,"region_scope_tree","","",1,N],[12,"owner_def_id","","",1,N],[12,"body","","",1,N],[12,"used_mut_nodes","","",1,N],[12,"signalled_any_error","","",1,N],[3,"Loan","","Record of a loan that was issued.",N,N],[12,"index","","",2,N],[12,"loan_path","","",2,N],[12,"kind","","",2,N],[12,"restricted_paths","","",2,N],[12,"gen_scope","","gen_scope indicates where loan is introduced. Typically the loan is introduced at the point of the borrow, but in some cases, notably method arguments, the loan may be introduced only later, once it comes into scope.  See also `GatherLoanCtxt::compute_gen_scope`.",2,N],[12,"kill_scope","","kill_scope indicates when the loan goes out of scope.  This is either when the lifetime expires or when the local variable which roots the loan-path goes out of scope, whichever happens faster. See also `GatherLoanCtxt::compute_kill_scope`.",2,N],[12,"span","","",2,N],[12,"cause","","",2,N],[3,"LoanPath","","",N,N],[12,"kind","","",3,N],[12,"ty","","",3,N],[3,"BckError","","",N,N],[12,"span","","",4,N],[12,"cause","","",4,N],[12,"cmt","","",4,N],[12,"code","","",4,N],[4,"LoanPathKind","","",N,N],[13,"LpVar","","",5,N],[13,"LpUpvar","","",5,N],[13,"LpDowncast","","",5,N],[13,"LpExtend","","",5,N],[4,"InteriorKind","","",N,N],[13,"InteriorField","","",6,N],[13,"InteriorElement","","",6,N],[4,"LoanPathElem","","",N,N],[13,"LpDeref","","",7,N],[13,"LpInterior","","",7,N],[4,"bckerr_code","","",N,N],[13,"err_mutbl","","",8,N],[13,"err_out_of_scope","","superscope, subscope, loan cause",8,N],[13,"err_borrowed_pointer_too_short","","",8,N],[4,"AliasableViolationKind","","",N,N],[13,"MutabilityViolation","","",9,N],[13,"BorrowViolation","","",9,N],[4,"MovedValueUseKind","","",N,N],[13,"MovedInUse","","",10,N],[13,"MovedInCapture","","",10,N],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"borrowck","","",N,[[["tyctxt"],["defid"]],["lrc",["borrowcheckresult"]]]],[5,"build_borrowck_dataflow_data","","",N,[[["borrowckctxt"],["bool"],["bodyid"],["f"]],["option",["analysisdata"]]]],[5,"build_borrowck_dataflow_data_for_fn","","Accessor for introspective clients inspecting `AnalysisData` and the `BorrowckCtxt` itself , e.g. the flowgraph visualizer.",N,N],[5,"closure_to_block","","",N,[[["localdefid"],["tyctxt"]],["nodeid"]]],[5,"opt_loan_path_is_field","","",N,N],[5,"opt_loan_path","","Computes the `LoanPath` (if any) for a `cmt`. Note that this logic is somewhat duplicated in the method `compute()` found in `gather_loans::restrictions`, which allows it to share common loan path pieces as it traverses the CMT.",N,[[["cmt_"]],["option",["rc"]]]],[0,"check_loans","","",N,N],[3,"CheckLoanCtxt","rustc_borrowck::borrowck::check_loans","",N,N],[12,"bccx","","",11,N],[12,"dfcx_loans","","",11,N],[12,"move_data","","",11,N],[12,"all_loans","","",11,N],[12,"movable_generator","","",11,N],[4,"UseError","","",N,N],[13,"UseOk","","",12,N],[13,"UseWhileBorrowed","","",12,N],[5,"owned_ptr_base_path","","Returns the base of the leftmost dereference of an Unique in `loan_path`. If there is no dereference of an Unique in `loan_path`, then it just returns `loan_path` itself.",N,[[["loanpath"]],["loanpath"]]],[5,"owned_ptr_base_path_rc","","The equivalent of `owned_ptr_base_path` for an &Rc rather than a &LoanPath.",N,[[["rc"]],["rc",["loanpath"]]]],[5,"check_loans","","",N,N],[5,"compatible_borrow_kinds","","",N,[[["borrowkind"],["borrowkind"]],["bool"]]],[11,"consume","","",11,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[11,"matched_pat","","",11,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[11,"consume_pat","","",11,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[11,"borrow","","",11,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[11,"mutate","","",11,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"decl_without_init","","",11,[[["self"],["nodeid"],["span"]]]],[11,"eq","","",12,[[["self"],["useerror"]],["bool"]]],[11,"ne","","",12,[[["self"],["useerror"]],["bool"]]],[11,"tcx","","",11,[[["self"]],["tyctxt"]]],[11,"each_issued_loan","","Iterates over each loan that has been issued on entrance to `node`, regardless of whether it is actually in scope at that point.  Sometimes loans are issued for future scopes and thus they may have been issued but not yet be in effect.",11,[[["self"],["itemlocalid"],["f"]],["bool"]]],[11,"each_in_scope_loan","","Like `each_issued_loan()`, but only considers loans that are currently in scope.",11,[[["self"],["scope"],["f"]],["bool"]]],[11,"each_in_scope_loan_affecting_path","","Iterates through all of the in-scope loans affecting `loan_path`, calling `op`, and ceasing iteration if `false` is returned.",11,[[["self"],["scope"],["loanpath"],["f"]],["bool"]]],[11,"loans_generated_by","","Returns a vector of the loans that are generated as we enter `node`.",11,[[["self"],["itemlocalid"]],["vec",["usize"]]]],[11,"check_for_loans_across_yields","","",11,[[["self"],["cmt_"],["region"],["span"]]]],[11,"check_for_conflicting_loans","","Checks to see whether any of the loans that are issued on entrance to `node` conflict with loans that have already been issued when we enter `node` (for example, we do not permit two `&mut` borrows of the same variable).",11,[[["self"],["itemlocalid"]]]],[11,"report_error_if_loans_conflict","","Checks whether `old_loan` and `new_loan` can safely be issued simultaneously.",11,[[["self"],["loan"],["loan"]],["bool"]]],[11,"report_error_if_loan_conflicts_with_restriction","","Checks whether the restrictions introduced by `loan1` would prohibit `loan2`. Returns false if an error is reported.",11,[[["self"],["loan"],["loan"],["loan"],["loan"]],["result",["diagnosticbuilder"]]]],[11,"consume_common","","",11,[[["self"],["itemlocalid"],["span"],["cmt_"],["consumemode"]]]],[11,"check_for_copy_of_frozen_path","","",11,[[["self"],["itemlocalid"],["span"],["loanpath"]]]],[11,"check_for_move_of_borrowed_path","","",11,[[["self"],["itemlocalid"],["span"],["loanpath"],["movekind"]]]],[11,"analyze_restrictions_on_use","","",11,[[["self"],["itemlocalid"],["loanpath"],["borrowkind"]],["useerror"]]],[11,"check_if_path_is_moved","","Reports an error if `expr` (which should be a path) is using a moved/uninitialized value",11,[[["self"],["itemlocalid"],["span"],["movedvalueusekind"],["rc"]]]],[11,"check_if_assigned_path_is_moved","","Reports an error if assigning to `lp` will use a moved/uninitialized value. Mainly this is concerned with detecting derefs of uninitialized pointers.",11,[[["self"],["itemlocalid"],["span"],["movedvalueusekind"],["rc"]]]],[11,"check_assignment","","",11,[[["self"],["itemlocalid"],["span"],["cmt_"]]]],[11,"report_illegal_mutation","","",11,[[["self"],["span"],["loanpath"],["loan"]]]],[0,"gather_loans","rustc_borrowck::borrowck","",N,N],[3,"GatherLoanCtxt","rustc_borrowck::borrowck::gather_loans","",N,N],[12,"bccx","","",13,N],[12,"move_data","","",13,N],[12,"move_error_collector","","",13,N],[12,"all_loans","","",13,N],[12,"item_ub","","`item_ub` is used as an upper-bound on the lifetime whenever we ask for the scope of an expression categorized as an upvar.",13,N],[5,"gather_loans_in_fn","","",N,N],[5,"check_aliasability","","Implements the A-* rules in README.md.",N,[[["borrowckctxt"],["span"],["aliasableviolationkind"],["cmt_"],["borrowkind"]],["result"]]],[5,"check_mutability","","Implements the M-* rules in README.md.",N,[[["borrowckctxt"],["span"],["aliasableviolationkind"],["cmt_"],["borrowkind"]],["result"]]],[0,"lifetime","","This module implements the check that the lifetime of a borrow does not exceed the lifetime of the value being borrowed.",N,N],[3,"GuaranteeLifetimeContext","rustc_borrowck::borrowck::gather_loans::lifetime","",N,N],[12,"bccx","","",14,N],[12,"item_scope","","",14,N],[12,"span","","",14,N],[12,"cause","","",14,N],[12,"loan_region","","",14,N],[12,"cmt_original","","",14,N],[5,"guarantee_lifetime","","Reports error if `loan_region` is larger than S where S is `item_scope` if `cmt` is an upvar, and is scope of `cmt` otherwise.",N,[[["borrowckctxt"],["scope"],["span"],["loancause"],["cmt_"],["region"]],["result"]]],[6,"R","","",N,N],[11,"check","","Main routine. Walks down `cmt` until we find the \"guarantor\".  Reports an error if `self.loan_region` is larger than scope of `cmt`.",14,[[["self"],["cmt_"],["option",["nodeid"]]],["result"]]],[11,"check_scope","","Reports an error if `loan_region` is larger than `max_scope`",14,[[["self"],["region"]],["result"]]],[11,"scope","","Returns the maximal region scope for the which the place `cmt` is guaranteed to be valid without any rooting etc, and presuming `cmt` is not mutated.",14,[[["self"],["cmt_"]],["region"]]],[11,"report_error","","",14,[[["self"],["bckerr_code"]]]],[0,"restrictions","rustc_borrowck::borrowck::gather_loans","Computes the restrictions that result from a borrow.",N,N],[3,"RestrictionsContext","rustc_borrowck::borrowck::gather_loans::restrictions","",N,N],[12,"bccx","","",15,N],[12,"span","","",15,N],[12,"loan_region","","",15,N],[12,"cause","","",15,N],[4,"RestrictionResult","","",N,N],[13,"Safe","","",16,N],[13,"SafeIf","","",16,N],[5,"compute_restrictions","","",N,[[["borrowckctxt"],["span"],["loancause"],["cmt_"],["region"]],["restrictionresult"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"restrict","","",15,[[["self"],["cmt_"]],["restrictionresult"]]],[11,"extend","","",15,[[["self"],["restrictionresult"],["cmt_"],["loanpathelem"]],["restrictionresult"]]],[0,"gather_moves","rustc_borrowck::borrowck::gather_loans","Computes moves.",N,N],[3,"GatherMoveInfo","rustc_borrowck::borrowck::gather_loans::gather_moves","",N,N],[12,"id","","",17,N],[12,"kind","","",17,N],[12,"cmt","","",17,N],[12,"span_path_opt","","",17,N],[4,"PatternSource","","Represents the kind of pattern",N,N],[13,"MatchExpr","","",18,N],[13,"LetDecl","","",18,N],[13,"Other","","",18,N],[5,"get_pattern_source","","Analyzes the context where the pattern appears to determine the kind of hint we want to give. In particular, if the pattern is in a `match` or nested within other patterns, we want to suggest a `ref` binding:",N,[[["tyctxt"],["pat"]],["patternsource"]]],[5,"gather_decl","","",N,[[["borrowckctxt"],["movedata"],["nodeid"],["ty"]]]],[5,"gather_move_from_expr","","",N,[[["borrowckctxt"],["movedata"],["moveerrorcollector"],["itemlocalid"],["cmt_"],["movereason"]]]],[5,"gather_move_from_pat","","",N,[[["borrowckctxt"],["movedata"],["moveerrorcollector"],["pat"],["cmt_"]]]],[5,"gather_move","","",N,[[["borrowckctxt"],["movedata"],["moveerrorcollector"],["gathermoveinfo"]]]],[5,"gather_assignment","","",N,[[["borrowckctxt"],["movedata"],["itemlocalid"],["span"],["rc",["loanpath"]]]]],[5,"check_and_get_illegal_move_origin","","",N,[[["borrowckctxt"],["cmt_"]],["option",["cmt_"]]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"clone","","",18,[[["self"]],["patternsource"]]],[0,"move_error","rustc_borrowck::borrowck::gather_loans","",N,N],[3,"MoveErrorCollector","rustc_borrowck::borrowck::gather_loans::move_error","",N,N],[12,"errors","","",19,N],[3,"MoveError","","",N,N],[12,"move_from","","",20,N],[12,"move_to","","",20,N],[3,"MovePlace","","",N,N],[12,"span","","",21,N],[12,"name","","",21,N],[12,"pat_source","","",21,N],[3,"GroupedMoveErrors","","",N,N],[12,"move_from","","",22,N],[12,"move_to_places","","",22,N],[5,"report_move_errors","","",N,N],[5,"group_errors_with_same_origin","","",N,N],[5,"report_cannot_move_out_of","","",N,[[["borrowckctxt"],["cmt"]],["diagnosticbuilder"]]],[5,"note_move_destination","","",N,[[["diagnosticbuilder"],["span"],["name"],["bool"]],["diagnosticbuilder"]]],[11,"new","","",19,[[],["moveerrorcollector"]]],[11,"add_error","","",19,[[["self"],["moveerror"]]]],[11,"report_potential_errors","","",19,[[["self"],["borrowckctxt"]]]],[11,"with_move_info","","",20,[[["cmt"],["option",["moveplace"]]],["moveerror"]]],[11,"clone","","",21,[[["self"]],["moveplace"]]],[11,"consume","rustc_borrowck::borrowck::gather_loans","",13,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[11,"matched_pat","","",13,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[11,"consume_pat","","",13,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[11,"borrow","","",13,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[11,"mutate","","",13,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"decl_without_init","","",13,[[["self"],["nodeid"],["span"]]]],[11,"tcx","","",13,[[["self"]],["tyctxt"]]],[11,"guarantee_assignment_valid","","Guarantees that `cmt` is assignable, or reports an error.",13,[[["self"],["nodeid"],["span"],["cmt_"]]]],[11,"guarantee_valid","","Guarantees that `addr_of(cmt)` will be valid for the duration of `static_scope_r`, or reports an error.  This may entail taking out loans, which will be added to the `req_loan_map`.",13,[[["self"],["itemlocalid"],["span"],["cmt_"],["borrowkind"],["region"],["loancause"]]]],[11,"mark_loan_path_as_mutated","","For mutable loans of content whose mutability derives from a local variable, mark the mutability decl as necessary.",13,[[["self"],["loanpath"]]]],[11,"compute_gen_scope","","Determine when to introduce the loan. Typically the loan is introduced at the point of the borrow, but in some cases, notably method arguments, the loan may be introduced only later, once it comes into scope.",13,[[["self"],["scope"],["scope"]],["scope"]]],[11,"compute_kill_scope","","Determine when the loan restrictions go out of scope. This is either when the lifetime expires or when the local variable which roots the loan-path goes out of scope, whichever happens faster.",13,[[["self"],["scope"],["loanpath"]],["scope"]]],[11,"report_potential_errors","","",13,[[["self"]]]],[0,"move_data","rustc_borrowck::borrowck","Data structures used for tracking moves. Please see the extensive comments in the section \"Moves and initialization\" in `README.md`.",N,N],[3,"MoveData","rustc_borrowck::borrowck::move_data","",N,N],[12,"paths","","Move paths. See section \"Move paths\" in `README.md`.",23,N],[12,"path_map","","Cache of loan path to move path index, for easy lookup.",23,N],[12,"moves","","Each move or uninitialized variable gets an entry here.",23,N],[12,"var_assignments","","Assignments to a variable, like `x = foo`. These are assigned bits for dataflow, since we must track them to ensure that immutable variables are assigned at most once along each path.",23,N],[12,"path_assignments","","Assignments to a path, like `x.f = foo`. These are not assigned dataflow bits, but we track them because they still kill move bits.",23,N],[3,"FlowedMoveData","","",N,N],[12,"move_data","","",24,N],[12,"dfcx_moves","","",24,N],[12,"dfcx_assign","","",24,N],[3,"MovePathIndex","","Index into `MoveData.paths`, used like a pointer",N,N],[12,"0","","",25,N],[3,"MoveIndex","","Index into `MoveData.moves`, used like a pointer",N,N],[12,"0","","",26,N],[3,"MovePath","","",N,N],[12,"loan_path","","Loan path corresponding to this move path",27,N],[12,"parent","","Parent pointer, `InvalidMovePathIndex` if root",27,N],[12,"first_move","","Head of linked list of moves to this path, `InvalidMoveIndex` if not moved",27,N],[12,"first_child","","First node in linked list of children, `InvalidMovePathIndex` if leaf",27,N],[12,"next_sibling","","Next node in linked list of parent's children (siblings), `InvalidMovePathIndex` if none.",27,N],[3,"Move","","",N,N],[12,"path","","Path being moved.",28,N],[12,"id","","id of node that is doing the move.",28,N],[12,"kind","","Kind of move, for error messages.",28,N],[12,"next_move","","Next node in linked list of moves from `path`, or `InvalidMoveIndex`",28,N],[3,"Assignment","","",N,N],[12,"path","","Path being assigned.",29,N],[12,"id","","id where assignment occurs",29,N],[12,"span","","span of node where assignment occurs",29,N],[3,"MoveDataFlowOperator","","",N,N],[3,"AssignDataFlowOperator","","",N,N],[4,"MoveKind","","",N,N],[13,"Declared","","",30,N],[13,"MoveExpr","","",30,N],[13,"MovePat","","",30,N],[13,"Captured","","",30,N],[5,"loan_path_is_precise","","",N,[[["loanpath"]],["bool"]]],[6,"MoveDataFlow","","",N,N],[6,"AssignDataFlow","","",N,N],[17,"InvalidMovePathIndex","","",N,N],[17,"InvalidMoveIndex","","",N,N],[11,"default","","",23,[[],["movedata"]]],[11,"eq","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"ne","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",25,N],[11,"partial_cmp","","",25,[[["self"],["movepathindex"]],["option",["ordering"]]]],[11,"lt","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"le","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"gt","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"ge","","",25,[[["self"],["movepathindex"]],["bool"]]],[11,"cmp","","",25,[[["self"],["movepathindex"]],["ordering"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"get","","",25,[[["self"]],["usize"]]],[11,"clone","","",25,[[["self"]],["movepathindex"]]],[11,"clone","","",26,[[["self"]],["moveindex"]]],[11,"eq","","",26,[[["self"],["moveindex"]],["bool"]]],[11,"ne","","",26,[[["self"],["moveindex"]],["bool"]]],[11,"get","","",26,[[["self"]],["usize"]]],[11,"clone","","",30,[[["self"]],["movekind"]]],[11,"eq","","",30,[[["self"],["movekind"]],["bool"]]],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"clone","","",28,[[["self"]],["move"]]],[11,"clone","","",29,[[["self"]],["assignment"]]],[11,"clone","","",31,[[["self"]],["movedataflowoperator"]]],[11,"clone","","",32,[[["self"]],["assigndataflowoperator"]]],[11,"is_empty","","return true if there are no trackable assignments or moves in this move data - that means that there is nothing that could cause a borrow error.",23,[[["self"]],["bool"]]],[11,"path_loan_path","","",23,[[["self"],["movepathindex"]],["rc",["loanpath"]]]],[11,"path_parent","","",23,[[["self"],["movepathindex"]],["movepathindex"]]],[11,"path_first_move","","",23,[[["self"],["movepathindex"]],["moveindex"]]],[11,"path_first_child","","Returns the index of first child, or `InvalidMovePathIndex` if `index` is leaf.",23,[[["self"],["movepathindex"]],["movepathindex"]]],[11,"path_next_sibling","","",23,[[["self"],["movepathindex"]],["movepathindex"]]],[11,"set_path_first_move","","",23,[[["self"],["movepathindex"],["moveindex"]]]],[11,"set_path_first_child","","",23,[[["self"],["movepathindex"],["movepathindex"]]]],[11,"move_next_move","","Type safe indexing operator",23,[[["self"],["moveindex"]],["moveindex"]]],[11,"is_var_path","","True if `index` refers to a variable",23,[[["self"],["movepathindex"]],["bool"]]],[11,"move_path","","Returns the existing move path index for `lp`, if any, and otherwise adds a new index for `lp` and any of its base paths that do not yet have an index.",23,[[["self"],["tyctxt"],["rc",["loanpath"]]],["movepathindex"]]],[11,"existing_move_path","","",23,[[["self"],["rc"]],["option",["movepathindex"]]]],[11,"existing_base_paths","","",23,[[["self"],["rc"]],["vec",["movepathindex"]]]],[11,"add_existing_base_paths","","Adds any existing move path indices for `lp` and any base paths of `lp` to `result`, but does not add new move paths",23,[[["self"],["rc"],["vec"]]]],[11,"add_move","","Adds a new move entry for a move of `lp` that occurs at location `id` with kind `kind`.",23,[[["self"],["tyctxt"],["rc",["loanpath"]],["itemlocalid"],["movekind"]]]],[11,"add_move_helper","","",23,[[["self"],["tyctxt"],["rc",["loanpath"]],["itemlocalid"],["movekind"]]]],[11,"add_assignment","","Adds a new record for an assignment to `lp` that occurs at location `id` with the given `span`.",23,[[["self"],["tyctxt"],["rc",["loanpath"]],["itemlocalid"],["span"]]]],[11,"add_assignment_helper","","",23,[[["self"],["tyctxt"],["rc",["loanpath"]],["itemlocalid"],["span"]]]],[11,"add_gen_kills","","Adds the gen/kills for the various moves and assignments into the provided data flow contexts. Moves are generated by moves and killed by assignments and scoping. Assignments are generated by assignment to variables and killed by scoping. See `README.md` for more details.",23,[[["self"],["borrowckctxt"],["dataflowcontext"],["dataflowcontext"]]]],[11,"each_base_path","","",23,[[["self"],["movepathindex"],["f"]],["bool"]]],[11,"each_extending_path_","","",23,[[["self"],["movepathindex"],["f"]],["bool"]]],[11,"each_extending_path","","",23,[[["self"],["movepathindex"],["f"]],["bool"]]],[11,"each_applicable_move","","",23,[[["self"],["movepathindex"],["f"]],["bool"]]],[11,"kill_moves","","",23,[[["self"],["movepathindex"],["itemlocalid"],["killfrom"],["dataflowcontext"]]]],[11,"new","","",24,[[["movedata"],["borrowckctxt"],["cfg"],["idrange"],["body"]],["flowedmovedata"]]],[11,"kind_of_move_of_path","","Returns the kind of a move of `loan_path` by `id`, if one exists.",24,[[["self"],["itemlocalid"],["rc"]],["option",["movekind"]]]],[11,"each_move_of","","Iterates through each move of `loan_path` (or some base path of `loan_path`) that may have occurred on entry to `id` without an intervening assignment. In other words, any moves that would invalidate a reference to `loan_path` at location `id`.",24,[[["self"],["itemlocalid"],["rc"],["f"]],["bool"]]],[11,"each_assignment_of","","Iterates through every assignment to `loan_path` that may have occurred on entry to `id`. `loan_path` must be a single variable.",24,[[["self"],["itemlocalid"],["rc"],["f"]],["bool"]]],[11,"join","","",31,[[["self"],["usize"],["usize"]],["usize"]]],[11,"initial_value","","",31,[[["self"]],["bool"]]],[11,"join","","",32,[[["self"],["usize"],["usize"]],["usize"]]],[11,"initial_value","","",32,[[["self"]],["bool"]]],[0,"unused","rustc_borrowck::borrowck","",N,N],[3,"UsedMutFinder","rustc_borrowck::borrowck::unused","",N,N],[12,"bccx","","",33,N],[12,"set","","",33,N],[3,"UnusedMutCx","","",N,N],[12,"bccx","","",34,N],[12,"used_mut","","",34,N],[5,"check","","",N,[[["borrowckctxt"],["body"]]]],[11,"check_unused_mut_pat","","",34,N],[11,"nested_visit_map","","",34,[[["self"]],["nestedvisitormap"]]],[11,"visit_arm","","",34,[[["self"],["arm"]]]],[11,"visit_local","","",34,[[["self"],["local"]]]],[11,"nested_visit_map","","",33,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",33,[[["self"],["bodyid"]]]],[6,"LoanDataFlow","rustc_borrowck::borrowck","",N,N],[17,"DOWNCAST_PRINTED_OPERATOR","","",N,N],[8,"ToInteriorKind","","",N,N],[10,"cleaned","","",35,[[["self"]],["interiorkind"]]],[11,"clone","","",36,[[["self"]],["loandataflowoperator"]]],[11,"signal_error","","",1,[[["self"]]]],[11,"loan_path","","",2,[[["self"]],["rc",["loanpath"]]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"eq","","",3,[[["self"],["loanpath"]],["bool"]]],[11,"hash","","",3,[[["self"],["h"]]]],[11,"eq","","",5,[[["self"],["loanpathkind"]],["bool"]]],[11,"ne","","",5,[[["self"],["loanpathkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",5,N],[11,"hash","","",5,N],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"new","","",3,[[["loanpathkind"],["ty"]],["loanpath"]]],[11,"to_type","","",3,[[["self"]],["ty"]]],[11,"has_downcast","","",3,[[["self"]],["bool"]]],[11,"clone","","",6,[[["self"]],["interiorkind"]]],[11,"eq","","",6,[[["self"],["interiorkind"]],["bool"]]],[11,"ne","","",6,[[["self"],["interiorkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",6,N],[11,"hash","","",6,N],[11,"clone","","",7,[[["self"]],["loanpathelem"]]],[11,"eq","","",7,[[["self"],["loanpathelem"]],["bool"]]],[11,"ne","","",7,[[["self"],["loanpathelem"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"hash","","",7,N],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"kill_scope","","",3,[[["self"],["borrowckctxt"]],["scope"]]],[11,"has_fork","","",3,[[["self"],["loanpath"]],["bool"]]],[11,"depth","","",3,[[["self"]],["usize"]]],[11,"common","","",3,[[["self"],["loanpath"]],["option",["loanpath"]]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"eq","","",8,[[["self"],["bckerr_code"]],["bool"]]],[11,"ne","","",8,[[["self"],["bckerr_code"]],["bool"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["bckerror"]],["bool"]]],[11,"ne","","",4,[[["self"],["bckerror"]],["bool"]]],[11,"clone","","",9,[[["self"]],["aliasableviolationkind"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"eq","","",9,[[["self"],["aliasableviolationkind"]],["bool"]]],[11,"ne","","",9,[[["self"],["aliasableviolationkind"]],["bool"]]],[11,"clone","","",10,[[["self"]],["movedvalueusekind"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"is_subregion_of","","",1,[[["self"],["region"],["region"]],["bool"]]],[11,"report","","",1,[[["self"],["bckerror"]]]],[11,"report_use_of_moved_value","","",1,[[["self"],["span"],["movedvalueusekind"],["loanpath"],["move"],["loanpath"]]]],[11,"report_partial_reinitialization_of_uninitialized_structure","","",1,[[["self"],["span"],["loanpath"]]]],[11,"report_reassigned_immutable_variable","","",1,[[["self"],["span"],["loanpath"],["assignment"]]]],[11,"report_bckerr","","",1,[[["self"],["bckerror"]]]],[11,"report_aliasability_violation","","",1,[[["self"],["span"],["aliasableviolationkind"],["aliasablereason"],["cmt_"]]]],[11,"suggest_mut_for_immutable","","Given a type, if it is an immutable reference, return a suggestion to make it mutable",1,[[["self"],["ty"],["bool"]],["option",["string"]]]],[11,"local_binding_mode","","",1,[[["self"],["nodeid"]],["bindingmode"]]],[11,"local_ty","","",1,N],[11,"note_immutability_blame","","",1,[[["self"],["diagnosticbuilder"],["option",["immutabilityblame"]],["nodeid"]]]],[11,"note_immutable_local","","",1,[[["self"],["diagnosticbuilder"],["nodeid"],["nodeid"]]]],[11,"report_out_of_scope_escaping_closure_capture","","",1,[[["self"],["bckerror"],["span"]]]],[11,"region_end_span","","",1,[[["self"],["region"]],["option",["span"]]]],[11,"note_and_explain_mutbl_error","","",1,[[["self"],["diagnosticbuilder"],["bckerror"],["span"]]]],[11,"append_loan_path_to_string","","",1,[[["self"],["loanpath"],["string"]]]],[11,"append_autoderefd_loan_path_to_string","","",1,[[["self"],["loanpath"],["string"]]]],[11,"loan_path_to_string","","",1,[[["self"],["loanpath"]],["string"]]],[11,"cmt_to_string","","",1,[[["self"],["cmt_"]],["string"]]],[11,"cmt_to_path_or_string","","",1,[[["self"],["cmt_"]],["string"]]],[11,"join","","",36,[[["self"],["usize"],["usize"]],["usize"]]],[11,"initial_value","","",36,[[["self"]],["bool"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[0,"graphviz","rustc_borrowck","This module provides linkage between rustc::middle::graph and libgraphviz traits, specialized to attaching borrowck analysis data to rendered labels.",N,N],[6,"Node","rustc_borrowck::graphviz","",N,N],[6,"Edge","","",N,N],[3,"DataflowLabeller","","",N,N],[12,"inner","","",37,N],[12,"variants","","",37,N],[12,"borrowck_ctxt","","",37,N],[12,"analysis_data","","",37,N],[4,"Variant","","",N,N],[13,"Loans","","",38,N],[13,"Moves","","",38,N],[13,"Assigns","","",38,N],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"clone","","",38,[[["self"]],["variant"]]],[11,"short_name","","",38,[[["self"]],["str"]]],[11,"dataflow_for","","",37,[[["self"],["entryorexit"],["node"]],["string"]]],[11,"dataflow_for_variant","","",37,[[["self"],["entryorexit"],["node"],["variant"]],["string"]]],[11,"build_set","","",37,[[["self"],["entryorexit"],["cfgindex"],["dataflowcontext"],["f"]],["string"]]],[11,"dataflow_loans_for","","",37,[[["self"],["entryorexit"],["cfgindex"]],["string"]]],[11,"dataflow_moves_for","","",37,[[["self"],["entryorexit"],["cfgindex"]],["string"]]],[11,"dataflow_assigns_for","","",37,[[["self"],["entryorexit"],["cfgindex"]],["string"]]],[11,"graph_id","","",37,[[["self"]],["id"]]],[11,"node_id","","",37,[[["self"],["node"]],["id"]]],[11,"node_label","","",37,[[["self"],["node"]],["labeltext"]]],[11,"edge_label","","",37,[[["self"],["edge"]],["labeltext"]]],[11,"nodes","","",37,[[["self"]],["nodes",["node"]]]],[11,"edges","","",37,[[["self"]],["edges",["edge"]]]],[11,"source","","",37,[[["self"],["edge"]],["node"]]],[11,"target","","",37,[[["self"],["edge"]],["node"]]],[0,"dataflow","rustc_borrowck","A module for propagating forward dataflow information. The analysis assumes that the items to be propagated can be represented as bits and thus uses bitvectors. Your job is simply to specify the so-called GEN and KILL bits for each expression.",N,N],[3,"DataFlowContext","rustc_borrowck::dataflow","",N,N],[12,"tcx","","",39,N],[12,"analysis_name","","a name for the analysis using this dataflow instance",39,N],[12,"oper","","the data flow operator",39,N],[12,"bits_per_id","","number of bits to propagate per id",39,N],[12,"words_per_id","","number of words we will use to store bits_per_id. equal to bits_per_id/usize::BITS rounded up.",39,N],[12,"local_id_to_index","","",39,N],[12,"gens","","bits generated as we exit the cfg node. Updated by `add_gen()`.",39,N],[12,"scope_kills","","bits killed as we exit the cfg node, or non-locally jump over it. Updated by `add_kill(KillFrom::ScopeEnd)`.",39,N],[12,"action_kills","","bits killed as we exit the cfg node directly; if it is jumped over, e.g. via `break`, the kills are not reflected in the jump's effects. Updated by `add_kill(KillFrom::Execution)`.",39,N],[12,"on_entry","","bits that are valid on entry to the cfg node. Updated by `propagate()`.",39,N],[3,"PropagationContext","","",N,N],[12,"dfcx","","",40,N],[12,"changed","","",40,N],[3,"Union","","",N,N],[3,"Subtract","","",N,N],[4,"EntryOrExit","","",N,N],[13,"Entry","","",41,N],[13,"Exit","","",41,N],[4,"KillFrom","","Flag used by `add_kill` to indicate whether the provided kill takes effect only when control flows directly through the node in question, or if the kill's effect is associated with any control-flow directly through or indirectly over the node.",N,N],[13,"ScopeEnd","","A `ScopeEnd` kill is one that takes effect when any control flow goes over the node. A kill associated with the end of the scope of a variable declaration `let x;` is an example of a `ScopeEnd` kill.",42,N],[13,"Execution","","An `Execution` kill is one that takes effect only when control flow goes through the node to completion. A kill associated with an assignment statement `x = expr;` is an example of an `Execution` kill.",42,N],[5,"get_cfg_indices","","",N,N],[5,"build_local_id_to_index","","",N,[[["option",["body"]],["cfg"]],["fxhashmap",["itemlocalid","vec"]]]],[5,"mut_bits_to_string","","",N,N],[5,"bits_to_string","","",N,N],[5,"bitwise","","",N,N],[5,"set_bit","","",N,N],[5,"bit_str","","",N,[[["usize"]],["string"]]],[8,"BitwiseOperator","","",N,N],[10,"join","","Joins two predecessor bits together, typically either `|` or `&`",43,[[["self"],["usize"],["usize"]],["usize"]]],[8,"DataFlowOperator","","Parameterization for the precise form of data flow that is used.",N,N],[10,"initial_value","","Specifies the initial value for each bit in the `on_entry` set",44,[[["self"]],["bool"]]],[11,"clone","","",41,[[["self"]],["entryorexit"]]],[11,"fmt","","",41,[[["self"],["formatter"]],["result"]]],[11,"clone","","",39,[[["self"]],["dataflowcontext"]]],[11,"has_bitset_for_local_id","","",39,[[["self"],["itemlocalid"]],["bool"]]],[11,"nested","","",39,[[["self"],["state"],["nested"]],["result"]]],[11,"pre","","",39,[[["self"],["state"],["annnode"]],["result"]]],[11,"clone","","",42,[[["self"]],["killfrom"]]],[11,"eq","","",42,[[["self"],["killfrom"]],["bool"]]],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"new","","",39,[[["tyctxt"],["str"],["option",["body"]],["cfg"],["o"],["idrange"],["usize"]],["dataflowcontext"]]],[11,"add_gen","","Indicates that `id` generates `bit`",39,[[["self"],["itemlocalid"],["usize"]]]],[11,"add_kill","","Indicates that `id` kills `bit`",39,[[["self"],["killfrom"],["itemlocalid"],["usize"]]]],[11,"apply_gen_kill","","Applies the gen and kill sets for `cfgidx` to `bits`",39,N],[11,"compute_id_range","","",39,N],[11,"each_bit_on_entry","","Iterates through each bit that is set on entry to `id`. Only useful after `propagate()` has been called.",39,[[["self"],["itemlocalid"],["f"]],["bool"]]],[11,"each_bit_for_node","","Iterates through each bit that is set on entry/exit to `cfgidx`. Only useful after `propagate()` has been called.",39,[[["self"],["entryorexit"],["cfgindex"],["f"]],["bool"]]],[11,"each_gen_bit","","Iterates through each bit in the gen set for `id`.",39,[[["self"],["itemlocalid"],["f"]],["bool"]]],[11,"each_bit","","Helper for iterating over the bits in a bit set. Returns false on the first call to `f` that returns false; if all calls to `f` return true, then returns true.",39,N],[11,"add_kills_from_flow_exits","","Whenever you have a `break` or `continue` statement, flow exits through any number of enclosing scopes on its way to the new destination. This function infers the kill bits of those control operators based on the kill bits associated with those scopes.",39,[[["self"],["cfg"]]]],[11,"propagate","","Performs the data flow analysis.",39,[[["self"],["cfg"],["body"]]]],[11,"walk_cfg","","",40,N],[11,"reset","","",40,N],[11,"propagate_bits_into_graph_successors_of","","",40,N],[11,"propagate_bits_into_entry_set_for","","",40,N],[11,"join","","",45,[[["self"],["usize"],["usize"]],["usize"]]],[11,"join","","",46,[[["self"],["usize"],["usize"]],["usize"]]],[11,"to_owned","rustc_borrowck::borrowck","",36,[[["self"]],["t"]]],[11,"clone_into","","",36,N],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"from_ok","","",36,[[["t"]],["t"]]],[11,"map_same","","",36,[[["self"],["f"]],["t"]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"to_string","","",3,[[["self"]],["string"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"from","rustc_borrowck::borrowck::check_loans","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]],[11,"from","rustc_borrowck::borrowck::gather_loans","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from_ok","","",13,[[["t"]],["t"]]],[11,"map_same","","",13,[[["self"],["f"]],["t"]]],[11,"from","rustc_borrowck::borrowck::gather_loans::lifetime","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from_ok","","",14,[[["t"]],["t"]]],[11,"map_same","","",14,[[["self"],["f"]],["t"]]],[11,"from","rustc_borrowck::borrowck::gather_loans::restrictions","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from_ok","","",15,[[["t"]],["t"]]],[11,"map_same","","",15,[[["self"],["f"]],["t"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from_ok","","",16,[[["t"]],["t"]]],[11,"map_same","","",16,[[["self"],["f"]],["t"]]],[11,"from","rustc_borrowck::borrowck::gather_loans::gather_moves","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from_ok","","",17,[[["t"]],["t"]]],[11,"map_same","","",17,[[["self"],["f"]],["t"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from_ok","","",18,[[["t"]],["t"]]],[11,"map_same","","",18,[[["self"],["f"]],["t"]]],[11,"from","rustc_borrowck::borrowck::gather_loans::move_error","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"from_ok","","",19,[[["t"]],["t"]]],[11,"map_same","","",19,[[["self"],["f"]],["t"]]],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from_ok","","",20,[[["t"]],["t"]]],[11,"map_same","","",20,[[["self"],["f"]],["t"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from_ok","","",21,[[["t"]],["t"]]],[11,"map_same","","",21,[[["self"],["f"]],["t"]]],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from_ok","","",22,[[["t"]],["t"]]],[11,"map_same","","",22,[[["self"],["f"]],["t"]]],[11,"from","rustc_borrowck::borrowck::move_data","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from_ok","","",23,[[["t"]],["t"]]],[11,"map_same","","",23,[[["self"],["f"]],["t"]]],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"from_ok","","",24,[[["t"]],["t"]]],[11,"map_same","","",24,[[["self"],["f"]],["t"]]],[11,"to_owned","","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from_ok","","",25,[[["t"]],["t"]]],[11,"map_same","","",25,[[["self"],["f"]],["t"]]],[11,"to_owned","","",26,[[["self"]],["t"]]],[11,"clone_into","","",26,N],[11,"from","","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"from_ok","","",26,[[["t"]],["t"]]],[11,"map_same","","",26,[[["self"],["f"]],["t"]]],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from_ok","","",27,[[["t"]],["t"]]],[11,"map_same","","",27,[[["self"],["f"]],["t"]]],[11,"to_owned","","",28,[[["self"]],["t"]]],[11,"clone_into","","",28,N],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from_ok","","",28,[[["t"]],["t"]]],[11,"map_same","","",28,[[["self"],["f"]],["t"]]],[11,"to_owned","","",29,[[["self"]],["t"]]],[11,"clone_into","","",29,N],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from_ok","","",29,[[["t"]],["t"]]],[11,"map_same","","",29,[[["self"],["f"]],["t"]]],[11,"to_owned","","",31,[[["self"]],["t"]]],[11,"clone_into","","",31,N],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"from_ok","","",31,[[["t"]],["t"]]],[11,"map_same","","",31,[[["self"],["f"]],["t"]]],[11,"to_owned","","",32,[[["self"]],["t"]]],[11,"clone_into","","",32,N],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from_ok","","",32,[[["t"]],["t"]]],[11,"map_same","","",32,[[["self"],["f"]],["t"]]],[11,"to_owned","","",30,[[["self"]],["t"]]],[11,"clone_into","","",30,N],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"from_ok","","",30,[[["t"]],["t"]]],[11,"map_same","","",30,[[["self"],["f"]],["t"]]],[11,"from","rustc_borrowck::borrowck::unused","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from_ok","","",33,[[["t"]],["t"]]],[11,"map_same","","",33,[[["self"],["f"]],["t"]]],[11,"from","","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"from_ok","","",34,[[["t"]],["t"]]],[11,"map_same","","",34,[[["self"],["f"]],["t"]]],[11,"from","rustc_borrowck::graphviz","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"from_ok","","",37,[[["t"]],["t"]]],[11,"map_same","","",37,[[["self"],["f"]],["t"]]],[11,"to_owned","","",38,[[["self"]],["t"]]],[11,"clone_into","","",38,N],[11,"from","","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"from_ok","","",38,[[["t"]],["t"]]],[11,"map_same","","",38,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_borrowck::dataflow","",39,[[["self"]],["t"]]],[11,"clone_into","","",39,N],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"from_ok","","",39,[[["t"]],["t"]]],[11,"map_same","","",39,[[["self"],["f"]],["t"]]],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from_ok","","",40,[[["t"]],["t"]]],[11,"map_same","","",40,[[["self"],["f"]],["t"]]],[11,"from","","",45,[[["t"]],["t"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"not_found","","",45,[[["str"],["str"]],["e"]]],[11,"from_ok","","",45,[[["t"]],["t"]]],[11,"map_same","","",45,[[["self"],["f"]],["t"]]],[11,"from","","",46,[[["t"]],["t"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"not_found","","",46,[[["str"],["str"]],["e"]]],[11,"from_ok","","",46,[[["t"]],["t"]]],[11,"map_same","","",46,[[["self"],["f"]],["t"]]],[11,"to_owned","","",41,[[["self"]],["t"]]],[11,"clone_into","","",41,N],[11,"from","","",41,[[["t"]],["t"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"not_found","","",41,[[["str"],["str"]],["e"]]],[11,"from_ok","","",41,[[["t"]],["t"]]],[11,"map_same","","",41,[[["self"],["f"]],["t"]]],[11,"to_owned","","",42,[[["self"]],["t"]]],[11,"clone_into","","",42,N],[11,"from","","",42,[[["t"]],["t"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"not_found","","",42,[[["str"],["str"]],["e"]]],[11,"from_ok","","",42,[[["t"]],["t"]]],[11,"map_same","","",42,[[["self"],["f"]],["t"]]]],"paths":[[3,"AnalysisData"],[3,"BorrowckCtxt"],[3,"Loan"],[3,"LoanPath"],[3,"BckError"],[4,"LoanPathKind"],[4,"InteriorKind"],[4,"LoanPathElem"],[4,"bckerr_code"],[4,"AliasableViolationKind"],[4,"MovedValueUseKind"],[3,"CheckLoanCtxt"],[4,"UseError"],[3,"GatherLoanCtxt"],[3,"GuaranteeLifetimeContext"],[3,"RestrictionsContext"],[4,"RestrictionResult"],[3,"GatherMoveInfo"],[4,"PatternSource"],[3,"MoveErrorCollector"],[3,"MoveError"],[3,"MovePlace"],[3,"GroupedMoveErrors"],[3,"MoveData"],[3,"FlowedMoveData"],[3,"MovePathIndex"],[3,"MoveIndex"],[3,"MovePath"],[3,"Move"],[3,"Assignment"],[4,"MoveKind"],[3,"MoveDataFlowOperator"],[3,"AssignDataFlowOperator"],[3,"UsedMutFinder"],[3,"UnusedMutCx"],[8,"ToInteriorKind"],[3,"LoanDataFlowOperator"],[3,"DataflowLabeller"],[4,"Variant"],[3,"DataFlowContext"],[3,"PropagationContext"],[4,"EntryOrExit"],[4,"KillFrom"],[8,"BitwiseOperator"],[8,"DataFlowOperator"],[3,"Union"],[3,"Subtract"]]};
searchIndex["rustc_codegen_llvm"]={"doc":"The Rust compiler.","items":[[3,"LlvmCodegenBackend","rustc_codegen_llvm","",N,N],[12,"0","","",0,N],[3,"ModuleCodegen","","",N,N],[12,"name","","The name of the module. When the crate may be saved between compilations, incremental compilation requires that name be unique amongst all crates.  Therefore, it should contain something unique to this crate (e.g., a module path) as well as the crate name and disambiguator. We currently generate these names via CodegenUnit::build_cgu_name().",1,N],[12,"module_llvm","","",1,N],[12,"kind","","",1,N],[3,"CachedModuleCodegen","","",N,N],[12,"name","","",2,N],[12,"source","","",2,N],[3,"CompiledModule","","",N,N],[12,"name","","",3,N],[12,"kind","","",3,N],[12,"object","","",3,N],[12,"bytecode","","",3,N],[12,"bytecode_compressed","","",3,N],[3,"ModuleLlvm","","",N,N],[12,"llcx","","",4,N],[12,"llmod_raw","","",4,N],[12,"tm","","",4,N],[3,"CodegenResults","","",N,N],[12,"crate_name","","",5,N],[12,"modules","","",5,N],[12,"allocator_module","","",5,N],[12,"metadata_module","","",5,N],[12,"crate_hash","","",5,N],[12,"metadata","","",5,N],[12,"windows_subsystem","","",5,N],[12,"linker_info","","",5,N],[12,"crate_info","","",5,N],[3,"CrateInfo","","Misc info we load from metadata to persist beyond the tcx",N,N],[12,"panic_runtime","","",6,N],[12,"compiler_builtins","","",6,N],[12,"profiler_runtime","","",6,N],[12,"sanitizer_runtime","","",6,N],[12,"is_no_builtins","","",6,N],[12,"native_libraries","","",6,N],[12,"crate_name","","",6,N],[12,"used_libraries","","",6,N],[12,"link_args","","",6,N],[12,"used_crate_source","","",6,N],[12,"used_crates_static","","",6,N],[12,"used_crates_dynamic","","",6,N],[12,"wasm_imports","","",6,N],[12,"lang_item_to_crate","","",6,N],[12,"missing_lang_items","","",6,N],[4,"ModuleKind","","",N,N],[13,"Regular","","",7,N],[13,"Metadata","","",7,N],[13,"Allocator","","",7,N],[5,"target_features","","",N,[[["session"]],["vec",["symbol"]]]],[5,"__rustc_codegen_backend","","This is the entrypoint for a hot plugged rustc_codegen_llvm",N,[[],["box",["codegenbackend"]]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0511","rustc_codegen_llvm::diagnostics","",N,N],[0,"back","rustc_codegen_llvm","",N,N],[0,"symbol_names","rustc_codegen_llvm::back","The Rust Linkage Model and Symbol Names =======================================",N,N],[5,"provide","rustc_codegen_llvm::back::symbol_names","",N,N],[5,"sanitize","","",N,[[["string"],["str"]],["bool"]]],[0,"archive","rustc_codegen_llvm::back","A helper class for dealing with static archives",N,N],[3,"ArchiveConfig","rustc_codegen_llvm::back::archive","",N,N],[12,"sess","","",8,N],[12,"dst","","",8,N],[12,"src","","",8,N],[12,"lib_search_paths","","",8,N],[3,"ArchiveBuilder","","Helper for adding many files to an archive.",N,N],[12,"config","","",9,N],[12,"removals","","",9,N],[12,"additions","","",9,N],[12,"should_update_symbols","","",9,N],[12,"src_archive","","",9,N],[4,"Addition","","",N,N],[13,"File","","",10,N],[12,"path","rustc_codegen_llvm::back::archive::Addition","",10,N],[12,"name_in_archive","","",10,N],[13,"Archive","rustc_codegen_llvm::back::archive","",10,N],[12,"archive","rustc_codegen_llvm::back::archive::Addition","",10,N],[12,"skip","","",10,N],[5,"find_library","rustc_codegen_llvm::back::archive","",N,N],[5,"is_relevant_child","","",N,[[["child"]],["bool"]]],[5,"string_to_io_error","","",N,[[["string"]],["error"]]],[11,"new","","Create a new static archive, ready for modifying the archive specified by `config`.",9,[[["archiveconfig"]],["archivebuilder"]]],[11,"remove_file","","Removes a file from this archive",9,[[["self"],["str"]]]],[11,"src_files","","Lists all files in an archive",9,[[["self"]],["vec",["string"]]]],[11,"src_archive","","",9,[[["self"]],["option",["archivero"]]]],[11,"add_native_library","","Adds all of the contents of a native library to this archive. This will search in the relevant locations for a library named `name`.",9,[[["self"],["str"]]]],[11,"add_rlib","","Adds all of the contents of the rlib at the specified path to this archive.",9,[[["self"],["path"],["str"],["bool"],["bool"]],["result"]]],[11,"add_archive","","",9,[[["self"],["path"],["f"]],["result"]]],[11,"add_file","","Adds an arbitrary file to this archive",9,[[["self"],["path"]]]],[11,"update_symbols","","Indicate that the next call to `build` should update all symbols in the archive (equivalent to running 'ar s' over it).",9,[[["self"]]]],[11,"build","","Combine the provided files, rlibs, and native libraries into a single `Archive`.",9,[[["self"]]]],[11,"llvm_archive_kind","","",9,[[["self"]],["result",["archivekind","str"]]]],[11,"build_with_llvm","","",9,[[["self"],["archivekind"]],["result"]]],[0,"bytecode","rustc_codegen_llvm::back","Management of the encoding of LLVM bytecode into rlibs",N,N],[3,"DecodedBytecode","rustc_codegen_llvm::back::bytecode","",N,N],[12,"identifier","","",11,N],[12,"encoded_bytecode","","",11,N],[5,"encode","","",N,N],[17,"RLIB_BYTECODE_OBJECT_MAGIC","","",N,N],[17,"RLIB_BYTECODE_OBJECT_VERSION","","",N,N],[17,"RLIB_BYTECODE_EXTENSION","","",N,N],[11,"new","","",11,N],[11,"bytecode","","",11,[[["self"]],["vec",["u8"]]]],[11,"identifier","","",11,[[["self"]],["str"]]],[0,"command","rustc_codegen_llvm::back","A thin wrapper around `Command` in the standard library which allows us to read the arguments that are built up.",N,N],[3,"Command","rustc_codegen_llvm::back::command","",N,N],[12,"program","","",12,N],[12,"args","","",12,N],[12,"env","","",12,N],[4,"Program","","",N,N],[13,"Normal","","",13,N],[13,"CmdBatScript","","",13,N],[13,"Lld","","",13,N],[11,"clone","","",12,[[["self"]],["command"]]],[11,"clone","","",13,[[["self"]],["program"]]],[11,"new","","",12,[[["p"]],["command"]]],[11,"bat_script","","",12,[[["p"]],["command"]]],[11,"lld","","",12,[[["p"],["lldflavor"]],["command"]]],[11,"_new","","",12,[[["program"]],["command"]]],[11,"arg","","",12,[[["self"],["p"]],["command"]]],[11,"args","","",12,[[["self"],["i"]],["command"]]],[11,"_arg","","",12,[[["self"],["osstr"]]]],[11,"env","","",12,[[["self"],["k"],["v"]],["command"]]],[11,"_env","","",12,[[["self"],["osstr"],["osstr"]]]],[11,"output","","",12,[[["self"]],["result",["output"]]]],[11,"command","","",12,[[["self"]],["command"]]],[11,"get_args","","",12,N],[11,"take_args","","",12,[[["self"]],["vec",["osstring"]]]],[11,"very_likely_to_exceed_some_spawn_limit","","Returns a `true` if we're pretty sure that this'll blow OS spawn limits, or `false` if we should attempt to spawn and see what the OS says.",12,[[["self"]],["bool"]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[0,"linker","rustc_codegen_llvm::back","",N,N],[3,"LinkerInfo","rustc_codegen_llvm::back::linker","For all the linkers we support, and information they might need out of the shared crate context before we get rid of it.",N,N],[12,"exports","","",14,N],[3,"GccLinker","","",N,N],[12,"cmd","","",15,N],[12,"sess","","",15,N],[12,"info","","",15,N],[12,"hinted_static","","",15,N],[12,"is_ld","","",15,N],[3,"MsvcLinker","","",N,N],[12,"cmd","","",16,N],[12,"sess","","",16,N],[12,"info","","",16,N],[3,"EmLinker","","",N,N],[12,"cmd","","",17,N],[12,"sess","","",17,N],[12,"info","","",17,N],[3,"WasmLd","","",N,N],[12,"cmd","","",18,N],[12,"sess","","",18,N],[5,"exported_symbols","","",N,[[["tyctxt"],["cratetype"]],["vec",["string"]]]],[8,"Linker","","Linker abstraction used by back::link to build up the command to invoke a linker.",N,N],[10,"link_dylib","","",19,[[["self"],["str"]]]],[10,"link_rust_dylib","","",19,[[["self"],["str"],["path"]]]],[10,"link_framework","","",19,[[["self"],["str"]]]],[10,"link_staticlib","","",19,[[["self"],["str"]]]],[10,"link_rlib","","",19,[[["self"],["path"]]]],[10,"link_whole_rlib","","",19,[[["self"],["path"]]]],[10,"link_whole_staticlib","","",19,N],[10,"include_path","","",19,[[["self"],["path"]]]],[10,"framework_path","","",19,[[["self"],["path"]]]],[10,"output_filename","","",19,[[["self"],["path"]]]],[10,"add_object","","",19,[[["self"],["path"]]]],[10,"gc_sections","","",19,[[["self"],["bool"]]]],[10,"position_independent_executable","","",19,[[["self"]]]],[10,"no_position_independent_executable","","",19,[[["self"]]]],[10,"full_relro","","",19,[[["self"]]]],[10,"partial_relro","","",19,[[["self"]]]],[10,"no_relro","","",19,[[["self"]]]],[10,"optimize","","",19,[[["self"]]]],[10,"pgo_gen","","",19,[[["self"]]]],[10,"debuginfo","","",19,[[["self"]]]],[10,"no_default_libraries","","",19,[[["self"]]]],[10,"build_dylib","","",19,[[["self"],["path"]]]],[10,"build_static_executable","","",19,[[["self"]]]],[10,"args","","",19,N],[10,"export_symbols","","",19,[[["self"],["path"],["cratetype"]]]],[10,"subsystem","","",19,[[["self"],["str"]]]],[10,"group_start","","",19,[[["self"]]]],[10,"group_end","","",19,[[["self"]]]],[10,"cross_lang_lto","","",19,[[["self"]]]],[10,"finalize","","",19,[[["self"]],["command"]]],[11,"new","","",14,[[["tyctxt"]],["linkerinfo"]]],[11,"to_linker","","",14,[[["self"],["command"],["session"],["linkerflavor"]],["box",["linker"]]]],[11,"linker_arg","","Argument that must be passed directly to the linker",15,[[["self"],["s"]],["self"]]],[11,"takes_hints","","",15,[[["self"]],["bool"]]],[11,"hint_static","","",15,[[["self"]]]],[11,"hint_dynamic","","",15,[[["self"]]]],[11,"push_cross_lang_lto_args","","",15,[[["self"],["option",["osstr"]]]]],[11,"link_dylib","","",15,[[["self"],["str"]]]],[11,"link_staticlib","","",15,[[["self"],["str"]]]],[11,"link_rlib","","",15,[[["self"],["path"]]]],[11,"include_path","","",15,[[["self"],["path"]]]],[11,"framework_path","","",15,[[["self"],["path"]]]],[11,"output_filename","","",15,[[["self"],["path"]]]],[11,"add_object","","",15,[[["self"],["path"]]]],[11,"position_independent_executable","","",15,[[["self"]]]],[11,"no_position_independent_executable","","",15,[[["self"]]]],[11,"full_relro","","",15,[[["self"]]]],[11,"partial_relro","","",15,[[["self"]]]],[11,"no_relro","","",15,[[["self"]]]],[11,"build_static_executable","","",15,[[["self"]]]],[11,"args","","",15,N],[11,"link_rust_dylib","","",15,[[["self"],["str"],["path"]]]],[11,"link_framework","","",15,[[["self"],["str"]]]],[11,"link_whole_staticlib","","",15,N],[11,"link_whole_rlib","","",15,[[["self"],["path"]]]],[11,"gc_sections","","",15,[[["self"],["bool"]]]],[11,"optimize","","",15,[[["self"]]]],[11,"pgo_gen","","",15,[[["self"]]]],[11,"debuginfo","","",15,[[["self"]]]],[11,"no_default_libraries","","",15,[[["self"]]]],[11,"build_dylib","","",15,[[["self"],["path"]]]],[11,"export_symbols","","",15,[[["self"],["path"],["cratetype"]]]],[11,"subsystem","","",15,[[["self"],["str"]]]],[11,"finalize","","",15,[[["self"]],["command"]]],[11,"group_start","","",15,[[["self"]]]],[11,"group_end","","",15,[[["self"]]]],[11,"cross_lang_lto","","",15,[[["self"]]]],[11,"link_rlib","","",16,[[["self"],["path"]]]],[11,"add_object","","",16,[[["self"],["path"]]]],[11,"args","","",16,N],[11,"build_dylib","","",16,[[["self"],["path"]]]],[11,"build_static_executable","","",16,[[["self"]]]],[11,"gc_sections","","",16,[[["self"],["bool"]]]],[11,"link_dylib","","",16,[[["self"],["str"]]]],[11,"link_rust_dylib","","",16,[[["self"],["str"],["path"]]]],[11,"link_staticlib","","",16,[[["self"],["str"]]]],[11,"position_independent_executable","","",16,[[["self"]]]],[11,"no_position_independent_executable","","",16,[[["self"]]]],[11,"full_relro","","",16,[[["self"]]]],[11,"partial_relro","","",16,[[["self"]]]],[11,"no_relro","","",16,[[["self"]]]],[11,"no_default_libraries","","",16,[[["self"]]]],[11,"include_path","","",16,[[["self"],["path"]]]],[11,"output_filename","","",16,[[["self"],["path"]]]],[11,"framework_path","","",16,[[["self"],["path"]]]],[11,"link_framework","","",16,[[["self"],["str"]]]],[11,"link_whole_staticlib","","",16,N],[11,"link_whole_rlib","","",16,[[["self"],["path"]]]],[11,"optimize","","",16,[[["self"]]]],[11,"pgo_gen","","",16,[[["self"]]]],[11,"debuginfo","","",16,[[["self"]]]],[11,"export_symbols","","",16,[[["self"],["path"],["cratetype"]]]],[11,"subsystem","","",16,[[["self"],["str"]]]],[11,"finalize","","",16,[[["self"]],["command"]]],[11,"group_start","","",16,[[["self"]]]],[11,"group_end","","",16,[[["self"]]]],[11,"cross_lang_lto","","",16,[[["self"]]]],[11,"include_path","","",17,[[["self"],["path"]]]],[11,"link_staticlib","","",17,[[["self"],["str"]]]],[11,"output_filename","","",17,[[["self"],["path"]]]],[11,"add_object","","",17,[[["self"],["path"]]]],[11,"link_dylib","","",17,[[["self"],["str"]]]],[11,"link_whole_staticlib","","",17,N],[11,"link_whole_rlib","","",17,[[["self"],["path"]]]],[11,"link_rust_dylib","","",17,[[["self"],["str"],["path"]]]],[11,"link_rlib","","",17,[[["self"],["path"]]]],[11,"position_independent_executable","","",17,[[["self"]]]],[11,"no_position_independent_executable","","",17,[[["self"]]]],[11,"full_relro","","",17,[[["self"]]]],[11,"partial_relro","","",17,[[["self"]]]],[11,"no_relro","","",17,[[["self"]]]],[11,"args","","",17,N],[11,"framework_path","","",17,[[["self"],["path"]]]],[11,"link_framework","","",17,[[["self"],["str"]]]],[11,"gc_sections","","",17,[[["self"],["bool"]]]],[11,"optimize","","",17,[[["self"]]]],[11,"pgo_gen","","",17,[[["self"]]]],[11,"debuginfo","","",17,[[["self"]]]],[11,"no_default_libraries","","",17,[[["self"]]]],[11,"build_dylib","","",17,[[["self"],["path"]]]],[11,"build_static_executable","","",17,[[["self"]]]],[11,"export_symbols","","",17,[[["self"],["path"],["cratetype"]]]],[11,"subsystem","","",17,[[["self"],["str"]]]],[11,"finalize","","",17,[[["self"]],["command"]]],[11,"group_start","","",17,[[["self"]]]],[11,"group_end","","",17,[[["self"]]]],[11,"cross_lang_lto","","",17,[[["self"]]]],[11,"link_dylib","","",18,[[["self"],["str"]]]],[11,"link_staticlib","","",18,[[["self"],["str"]]]],[11,"link_rlib","","",18,[[["self"],["path"]]]],[11,"include_path","","",18,[[["self"],["path"]]]],[11,"framework_path","","",18,[[["self"],["path"]]]],[11,"output_filename","","",18,[[["self"],["path"]]]],[11,"add_object","","",18,[[["self"],["path"]]]],[11,"position_independent_executable","","",18,[[["self"]]]],[11,"full_relro","","",18,[[["self"]]]],[11,"partial_relro","","",18,[[["self"]]]],[11,"no_relro","","",18,[[["self"]]]],[11,"build_static_executable","","",18,[[["self"]]]],[11,"args","","",18,N],[11,"link_rust_dylib","","",18,[[["self"],["str"],["path"]]]],[11,"link_framework","","",18,[[["self"],["str"]]]],[11,"link_whole_staticlib","","",18,N],[11,"link_whole_rlib","","",18,[[["self"],["path"]]]],[11,"gc_sections","","",18,[[["self"],["bool"]]]],[11,"optimize","","",18,[[["self"]]]],[11,"pgo_gen","","",18,[[["self"]]]],[11,"debuginfo","","",18,[[["self"]]]],[11,"no_default_libraries","","",18,[[["self"]]]],[11,"build_dylib","","",18,[[["self"],["path"]]]],[11,"export_symbols","","",18,[[["self"],["path"],["cratetype"]]]],[11,"subsystem","","",18,[[["self"],["str"]]]],[11,"no_position_independent_executable","","",18,[[["self"]]]],[11,"finalize","","",18,[[["self"]],["command"]]],[11,"group_start","","",18,[[["self"]]]],[11,"group_end","","",18,[[["self"]]]],[11,"cross_lang_lto","","",18,[[["self"]]]],[0,"link","rustc_codegen_llvm::back","",N,N],[5,"find_crate_name","rustc_codegen_llvm::back::link","",N,N],[5,"filename_for_input","","",N,[[["session"],["cratetype"],["str"],["outputfilenames"]],["pathbuf"]]],[5,"default_output_for_target","","Returns default crate type for target",N,[[["session"]],["cratetype"]]],[5,"invalid_output_for_target","","Checks if target supports crate_type as output",N,[[["session"],["cratetype"]],["bool"]]],[5,"out_filename","","",N,[[["session"],["cratetype"],["outputfilenames"],["str"]],["pathbuf"]]],[5,"check_file_is_writeable","","",N,N],[4,"RlibFlavor","","",N,N],[13,"Normal","","",20,N],[13,"StaticlibBase","","",20,N],[5,"get_linker","","",N,N],[5,"remove","","",N,[[["session"],["path"]]]],[5,"link_binary","","Perform the linkage portion of the compilation phase. This will generate all of the requested outputs for this compilation session.",N,[[["session"],["codegenresults"],["outputfilenames"],["str"]],["vec",["pathbuf"]]]],[5,"preserve_objects_for_their_debuginfo","","Returns a boolean indicating whether we should preserve the object files on the filesystem for their debug information. This is often useful with split-dwarf like schemes.",N,[[["session"]],["bool"]]],[5,"filename_for_metadata","","",N,[[["session"],["str"],["outputfilenames"]],["pathbuf"]]],[5,"each_linked_rlib","","",N,[[["session"],["crateinfo"],["fnmut"]],["result",["string"]]]],[5,"ignored_for_lto","","Returns a boolean indicating whether the specified crate should be ignored during LTO.",N,[[["session"],["crateinfo"],["cratenum"]],["bool"]]],[5,"link_binary_output","","",N,[[["session"],["codegenresults"],["cratetype"],["outputfilenames"],["str"]],["vec",["pathbuf"]]]],[5,"archive_search_paths","","",N,[[["session"]],["vec",["pathbuf"]]]],[5,"archive_config","","",N,[[["session"],["path"],["option",["path"]]],["archiveconfig"]]],[5,"emit_metadata","","We use a temp directory here to avoid races between concurrent rustc processes, such as builds in the same directory using the same filename for metadata while building an `.rlib` (stomping over one another), or writing an `.rmeta` into a directory being searched for `extern crate` (observing an incomplete file). The returned path is the temporary file containing the complete metadata.",N,[[["session"],["codegenresults"],["tempdir"]],["pathbuf"]]],[5,"link_rlib","","",N,[[["session"],["codegenresults"],["rlibflavor"],["path"],["tempdir"]],["archivebuilder"]]],[5,"link_staticlib","","",N,[[["session"],["codegenresults"],["path"],["tempdir"]]]],[5,"print_native_static_libs","","",N,N],[5,"linker_and_flavor","","",N,N],[5,"link_natively","","",N,[[["session"],["cratetype"],["path"],["codegenresults"],["path"]]]],[5,"exec_linker","","",N,[[["session"],["command"],["path"],["path"]],["result",["output"]]]],[5,"link_args","","",N,[[["linker"],["linkerflavor"],["session"],["cratetype"],["path"],["path"],["codegenresults"]]]],[5,"add_local_native_libraries","","",N,[[["linker"],["session"],["codegenresults"]]]],[5,"add_upstream_rust_crates","","",N,[[["linker"],["session"],["codegenresults"],["cratetype"],["path"]]]],[5,"add_upstream_native_libraries","","",N,[[["linker"],["session"],["codegenresults"],["cratetype"]]]],[5,"relevant_lib","","",N,[[["session"],["nativelibrary"]],["bool"]]],[5,"are_upstream_rust_objects_already_included","","",N,[[["session"]],["bool"]]],[0,"lto","rustc_codegen_llvm::back","",N,N],[3,"Linker","rustc_codegen_llvm::back::lto","",N,N],[12,"0","","",21,N],[3,"ModuleBuffer","","",N,N],[12,"0","","",22,N],[3,"ThinModule","","",N,N],[12,"shared","","",23,N],[12,"idx","","",23,N],[3,"ThinShared","","",N,N],[12,"data","","",24,N],[12,"thin_buffers","","",24,N],[12,"serialized_modules","","",24,N],[12,"module_names","","",24,N],[3,"ThinData","","",N,N],[12,"0","","",25,N],[3,"ThinBuffer","","",N,N],[12,"0","","",26,N],[3,"ThinLTOImports","","",N,N],[12,"imports","","",27,N],[4,"LtoModuleCodegen","","",N,N],[13,"Fat","","",28,N],[12,"module","rustc_codegen_llvm::back::lto::LtoModuleCodegen","",28,N],[12,"_serialized_bitcode","","",28,N],[13,"Thin","rustc_codegen_llvm::back::lto","",28,N],[4,"SerializedModule","","",N,N],[13,"Local","","",29,N],[13,"FromRlib","","",29,N],[13,"FromUncompressedFile","","",29,N],[5,"crate_type_allows_lto","","",N,[[["cratetype"]],["bool"]]],[5,"run","","Performs LTO, which in the case of full LTO means merging all modules into a single one and returning it for further optimizing. For ThinLTO, it will do the global analysis necessary and return two lists, one of the modules the need optimization and another for modules that can simply be copied over from the incr. comp. cache.",N,[[["codegencontext"],["vec",["modulecodegen"]],["vec"],["timeline"]],["result",["fatalerror"]]]],[5,"fat_lto","","",N,N],[5,"thin_lto","","Prepare \"thin\" LTO to get run on these modules.",N,N],[5,"run_pass_manager","","",N,[[["codegencontext"],["targetmachine"],["module"],["moduleconfig"],["bool"]]]],[5,"module_name_to_str","","",N,[[["cstr"]],["str"]]],[11,"name","","",28,[[["self"]],["str"]]],[11,"optimize","","Optimize this module within the given codegen context.",28,[[["self"],["codegencontext"],["timeline"]],["result",["modulecodegen","fatalerror"]]]],[11,"cost","","A \"gauge\" of how costly it is to optimize this module, used to sort biggest modules first.",28,[[["self"]],["u64"]]],[11,"new","","",21,[[["module"]],["self"]]],[11,"add","","",21,N],[11,"drop","","",21,[[["self"]]]],[11,"data","","",29,N],[11,"new","","",22,[[["module"]],["modulebuffer"]]],[11,"data","","",22,N],[11,"drop","","",22,[[["self"]]]],[11,"drop","","",25,[[["self"]]]],[11,"new","","",26,[[["module"]],["thinbuffer"]]],[11,"data","","",26,N],[11,"drop","","",26,[[["self"]]]],[11,"name","","",23,[[["self"]],["str"]]],[11,"cost","","",23,[[["self"]],["u64"]]],[11,"data","","",23,N],[11,"optimize","","",23,[[["self"],["codegencontext"],["timeline"]],["result",["modulecodegen","fatalerror"]]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"new","","",27,[[],["thinltoimports"]]],[11,"modules_imported_by","","",27,N],[11,"from_thin_lto_data","","Load the ThinLTO import map from ThinLTOData.",27,N],[0,"symbol_export","rustc_codegen_llvm::back","",N,N],[5,"threshold","rustc_codegen_llvm::back::symbol_export","",N,[[["tyctxt"]],["symbolexportlevel"]]],[5,"crate_export_threshold","","",N,[[["cratetype"]],["symbolexportlevel"]]],[5,"crates_export_threshold","","",N,N],[5,"reachable_non_generics_provider","","",N,[[["tyctxt"],["cratenum"]],["lrc",["defidmap"]]]],[5,"is_reachable_non_generic_provider_local","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"is_reachable_non_generic_provider_extern","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"exported_symbols_provider_local","","",N,[[["tyctxt"],["cratenum"]],["arc",["vec"]]]],[5,"upstream_monomorphizations_provider","","",N,[[["tyctxt"],["cratenum"]],["lrc",["defidmap"]]]],[5,"upstream_monomorphizations_for_provider","","",N,[[["tyctxt"],["defid"]],["option",["lrc"]]]],[5,"is_unreachable_local_definition_provider","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"provide","","",N,[[["providers"]]]],[5,"provide_extern","","",N,[[["providers"]]]],[5,"symbol_export_level","","",N,[[["tyctxt"],["defid"]],["symbolexportlevel"]]],[6,"ExportedSymbols","","",N,N],[0,"write","rustc_codegen_llvm::back","",N,N],[3,"ModuleConfig","rustc_codegen_llvm::back::write","Module-specific configuration for `optimize_and_codegen`.",N,N],[12,"passes","","Names of additional optimization passes to run.",30,N],[12,"opt_level","","Some(level) to optimize at a certain level, or None to run absolutely no optimizations (used for the metadata module).",30,N],[12,"opt_size","","Some(level) to optimize binary size, or None to not affect program size.",30,N],[12,"pgo_gen","","",30,N],[12,"pgo_use","","",30,N],[12,"emit_pre_thin_lto_bc","","",30,N],[12,"emit_no_opt_bc","","",30,N],[12,"emit_bc","","",30,N],[12,"emit_bc_compressed","","",30,N],[12,"emit_lto_bc","","",30,N],[12,"emit_ir","","",30,N],[12,"emit_asm","","",30,N],[12,"emit_obj","","",30,N],[12,"verify_llvm_ir","","",30,N],[12,"no_prepopulate_passes","","",30,N],[12,"no_builtins","","",30,N],[12,"time_passes","","",30,N],[12,"vectorize_loop","","",30,N],[12,"vectorize_slp","","",30,N],[12,"merge_functions","","",30,N],[12,"inline_threshold","","",30,N],[12,"obj_is_bitcode","","",30,N],[12,"no_integrated_as","","",30,N],[12,"embed_bitcode","","",30,N],[12,"embed_bitcode_marker","","",30,N],[3,"AssemblerCommand","","Assembler name and command used by codegen when no_integrated_as is enabled",N,N],[12,"name","","",31,N],[12,"cmd","","",31,N],[3,"CodegenContext","","Additional resources used by optimize_and_codegen (not module specific)",N,N],[12,"time_passes","","",32,N],[12,"lto","","",32,N],[12,"no_landing_pads","","",32,N],[12,"save_temps","","",32,N],[12,"fewer_names","","",32,N],[12,"exported_symbols","","",32,N],[12,"opts","","",32,N],[12,"crate_types","","",32,N],[12,"each_linked_rlib_for_lto","","",32,N],[12,"output_filenames","","",32,N],[12,"regular_module_config","","",32,N],[12,"metadata_module_config","","",32,N],[12,"allocator_module_config","","",32,N],[12,"tm_factory","","",32,N],[12,"msvc_imps_needed","","",32,N],[12,"target_pointer_width","","",32,N],[12,"debuginfo","","",32,N],[12,"total_cgus","","",32,N],[12,"diag_emitter","","",32,N],[12,"plugin_passes","","",32,N],[12,"remark","","",32,N],[12,"worker","","",32,N],[12,"incr_comp_session_dir","","",32,N],[12,"coordinator_send","","",32,N],[12,"time_graph","","",32,N],[12,"assembler_cmd","","",32,N],[3,"DiagnosticHandlers","","",N,N],[12,"data","","",33,N],[12,"llcx","","",33,N],[3,"CompiledModules","","",N,N],[12,"modules","","",34,N],[12,"metadata_module","","",34,N],[12,"allocator_module","","",34,N],[3,"Diagnostic","","",N,N],[12,"msg","","",35,N],[12,"code","","",35,N],[12,"lvl","","",35,N],[3,"SharedEmitter","","",N,N],[12,"sender","","",36,N],[3,"SharedEmitterMain","","",N,N],[12,"receiver","","",37,N],[3,"OngoingCodegen","","",N,N],[12,"crate_name","","",38,N],[12,"crate_hash","","",38,N],[12,"metadata","","",38,N],[12,"windows_subsystem","","",38,N],[12,"linker_info","","",38,N],[12,"crate_info","","",38,N],[12,"time_graph","","",38,N],[12,"coordinator_send","","",38,N],[12,"codegen_worker_receive","","",38,N],[12,"shared_emitter_main","","",38,N],[12,"future","","",38,N],[12,"output_filenames","","",38,N],[4,"WorkItem","","",N,N],[13,"Optimize","","Optimize a newly codegened, totally unoptimized module.",39,N],[13,"CopyPostLtoArtifacts","","Copy the post-LTO artifacts from the incremental cache to the output directory.",39,N],[13,"LTO","","Perform (Thin)LTO on the given module.",39,N],[4,"WorkItemResult","","",N,N],[13,"Compiled","","",40,N],[13,"NeedsLTO","","",40,N],[4,"Message","","",N,N],[13,"Token","","",41,N],[13,"NeedsLTO","","",41,N],[12,"result","rustc_codegen_llvm::back::write::Message","",41,N],[12,"worker_id","","",41,N],[13,"Done","rustc_codegen_llvm::back::write","",41,N],[12,"result","rustc_codegen_llvm::back::write::Message","",41,N],[12,"worker_id","","",41,N],[13,"CodegenDone","rustc_codegen_llvm::back::write","",41,N],[12,"llvm_work_item","rustc_codegen_llvm::back::write::Message","",41,N],[12,"cost","","",41,N],[13,"AddImportOnlyModule","rustc_codegen_llvm::back::write","",41,N],[12,"module_data","rustc_codegen_llvm::back::write::Message","",41,N],[12,"work_product","","",41,N],[13,"CodegenComplete","rustc_codegen_llvm::back::write","",41,N],[13,"CodegenItem","","",41,N],[4,"MainThreadWorkerState","","",N,N],[13,"Idle","","",42,N],[13,"Codegenning","","",42,N],[13,"LLVMing","","",42,N],[4,"SharedEmitterMessage","","",N,N],[13,"Diagnostic","","",43,N],[13,"InlineAsmError","","",43,N],[13,"AbortIfErrors","","",43,N],[13,"Fatal","","",43,N],[5,"llvm_err","","",N,[[["handler"],["string"]],["fatalerror"]]],[5,"write_output_file","","",N,[[["handler"],["targetmachine"],["passmanager"],["module"],["path"],["filetype"]],["result",["fatalerror"]]]],[5,"get_llvm_opt_level","","",N,[[["optlevel"]],["codegenoptlevel"]]],[5,"get_llvm_opt_size","","",N,[[["optlevel"]],["codegenoptsize"]]],[5,"create_target_machine","","",N,[[["session"],["bool"]],["targetmachine"]]],[5,"target_machine_factory","","",N,[[["session"],["bool"]],["arc",["fn"]]]],[5,"report_inline_asm","","",N,[[["codegencontext"],["str"],["c_uint"]]]],[5,"inline_asm_handler","","",N,N],[5,"diagnostic_handler","","",N,N],[5,"optimize","","",N,[[["codegencontext"],["handler"],["modulecodegen"],["moduleconfig"],["timeline"]],["result",["fatalerror"]]]],[5,"generate_lto_work","","",N,[[["codegencontext"],["vec",["modulecodegen"]],["vec"]],["vec"]]],[5,"codegen","","",N,[[["codegencontext"],["handler"],["modulecodegen"],["moduleconfig"],["timeline"]],["result",["compiledmodule","fatalerror"]]]],[5,"embed_bitcode","","Embed the bitcode of an LLVM module in the LLVM module itself.",N,[[["codegencontext"],["context"],["module"],["option"]]]],[5,"need_crate_bitcode_for_rlib","","",N,[[["session"]],["bool"]]],[5,"need_pre_thin_lto_bitcode_for_incr_comp","","",N,[[["session"]],["bool"]]],[5,"start_async_codegen","","",N,[[["tyctxt"],["option",["timegraph"]],["encodedmetadata"],["receiver",["box"]],["usize"]],["ongoingcodegen"]]],[5,"copy_all_cgu_workproducts_to_incr_comp_cache_dir","","",N,[[["session"],["compiledmodules"]],["fxhashmap",["workproductid","workproduct"]]]],[5,"produce_final_output_artifacts","","",N,[[["session"],["compiledmodules"],["outputfilenames"]]]],[5,"dump_incremental_data","","",N,[[["codegenresults"]]]],[5,"execute_work_item","","",N,[[["codegencontext"],["workitem"],["timeline"]],["result",["workitemresult","fatalerror"]]]],[5,"execute_optimize_work_item","","",N,[[["codegencontext"],["modulecodegen"],["moduleconfig"],["timeline"]],["result",["workitemresult","fatalerror"]]]],[5,"execute_copy_from_cache_work_item","","",N,[[["codegencontext"],["cachedmodulecodegen"],["moduleconfig"],["timeline"]],["result",["workitemresult","fatalerror"]]]],[5,"execute_lto_work_item","","",N,[[["codegencontext"],["ltomodulecodegen"],["moduleconfig"],["timeline"]],["result",["workitemresult","fatalerror"]]]],[5,"start_executing_work","","",N,[[["tyctxt"],["crateinfo"],["sharedemitter"],["sender",["message"]],["receiver",["box"]],["usize"],["client"],["option",["timegraph"]],["arc",["moduleconfig"]],["arc",["moduleconfig"]],["arc",["moduleconfig"]]],["joinhandle",["result"]]]],[5,"spawn_work","","",N,[[["codegencontext"],["workitem"]]]],[5,"run_assembler","","",N,[[["codegencontext"],["handler"],["path"],["path"]]]],[5,"with_llvm_pmb","","",N,[[["module"],["moduleconfig"],["codegenoptlevel"],["bool"],["fnmut"]]]],[5,"submit_codegened_module_to_llvm","","",N,[[["tyctxt"],["modulecodegen"],["u64"]]]],[5,"submit_post_lto_module_to_llvm","","",N,[[["tyctxt"],["cachedmodulecodegen"]]]],[5,"submit_pre_lto_module_to_llvm","","",N,[[["tyctxt"],["cachedmodulecodegen"]]]],[5,"pre_lto_bitcode_filename","","",N,[[["str"]],["string"]]],[5,"msvc_imps_needed","","",N,[[["tyctxt"]],["bool"]]],[5,"create_msvc_imps","","",N,[[["codegencontext"],["context"],["module"]]]],[17,"RELOC_MODEL_ARGS","","",N,N],[17,"CODE_GEN_MODEL_ARGS","","",N,N],[17,"TLS_MODEL_ARGS","","",N,N],[17,"PRE_THIN_LTO_BC_EXT","","",N,N],[17,"CODEGEN_WORKER_ID","","",N,N],[17,"CODEGEN_WORKER_TIMELINE","","",N,N],[17,"CODEGEN_WORK_PACKAGE_KIND","","",N,N],[17,"LLVM_WORK_PACKAGE_KIND","","",N,N],[11,"new","","",30,[[["vec",["string"]]],["moduleconfig"]]],[11,"set_flags","","",30,[[["self"],["session"],["bool"]]]],[11,"clone","","",32,[[["self"]],["codegencontext"]]],[11,"create_diag_handler","","",32,[[["self"]],["handler"]]],[11,"config","","",32,[[["self"],["modulekind"]],["moduleconfig"]]],[11,"save_temp_bitcode","","",32,[[["self"],["modulecodegen"],["str"]]]],[11,"new","","",33,[[["codegencontext"],["handler"],["context"]],["self"]]],[11,"drop","","",33,[[["self"]]]],[11,"module_kind","","",39,[[["self"]],["modulekind"]]],[11,"name","","",39,[[["self"]],["string"]]],[11,"eq","","",42,[[["self"],["mainthreadworkerstate"]],["bool"]]],[11,"clone","","",42,[[["self"]],["mainthreadworkerstate"]]],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"clone","","",36,[[["self"]],["sharedemitter"]]],[11,"new","","",36,N],[11,"inline_asm_error","","",36,[[["self"],["u32"],["string"]]]],[11,"fatal","","",36,[[["self"],["str"]]]],[11,"emit","","",36,[[["self"],["diagnosticbuilder"]]]],[11,"check","","",37,[[["self"],["session"],["bool"]]]],[11,"join","","",38,N],[11,"submit_pre_codegened_module_to_llvm","","",38,[[["self"],["tyctxt"],["modulecodegen"]]]],[11,"codegen_finished","","",38,[[["self"],["tyctxt"]]]],[11,"check_for_errors","","",38,[[["self"],["session"]]]],[11,"wait_for_signal_to_codegen_item","","",38,[[["self"]]]],[0,"rpath","rustc_codegen_llvm::back","",N,N],[3,"RPathConfig","rustc_codegen_llvm::back::rpath","",N,N],[12,"used_crates","","",44,N],[12,"out_filename","","",44,N],[12,"is_like_osx","","",44,N],[12,"has_rpath","","",44,N],[12,"linker_is_gnu","","",44,N],[12,"get_install_prefix_lib_path","","",44,N],[5,"get_rpath_flags","","",N,[[["rpathconfig"]],["vec",["string"]]]],[5,"rpaths_to_flags","","",N,N],[5,"get_rpaths","","",N,N],[5,"get_rpaths_relative_to_output","","",N,N],[5,"get_rpath_relative_to_output","","",N,[[["rpathconfig"],["path"]],["string"]]],[5,"path_relative_from","","",N,[[["path"],["path"]],["option",["pathbuf"]]]],[5,"get_install_prefix_rpath","","",N,[[["rpathconfig"]],["string"]]],[5,"minimize_rpaths","","",N,N],[0,"wasm","rustc_codegen_llvm::back","",N,N],[3,"WasmSections","rustc_codegen_llvm::back::wasm","",N,N],[12,"0","","",45,N],[3,"WasmDecoder","","",N,N],[12,"data","","",46,N],[3,"WasmEncoder","","",N,N],[12,"data","","",47,N],[5,"rewrite_imports","","Rewrite the module imports are listed from in a wasm module given the field name to module name mapping in `import_map`.",N,[[["path"],["fxhashmap"]]]],[17,"WASM_IMPORT_SECTION_ID","","",N,N],[17,"WASM_EXTERNAL_KIND_FUNCTION","","",N,N],[17,"WASM_EXTERNAL_KIND_TABLE","","",N,N],[17,"WASM_EXTERNAL_KIND_MEMORY","","",N,N],[17,"WASM_EXTERNAL_KIND_GLOBAL","","",N,N],[11,"next","","",45,[[["self"]],["option"]]],[11,"new","","",46,N],[11,"byte","","",46,[[["self"]],["u8"]]],[11,"u32","","",46,[[["self"]],["u32"]]],[11,"skip","","",46,N],[11,"str","","",46,[[["self"]],["str"]]],[11,"bool","","",46,[[["self"]],["bool"]]],[11,"limits","","",46,N],[11,"new","","",47,[[],["wasmencoder"]]],[11,"u32","","",47,[[["self"],["u32"]]]],[11,"byte","","",47,[[["self"],["u8"]]]],[11,"bytes","","",47,N],[11,"str","","",47,[[["self"],["str"]]]],[11,"bool","","",47,[[["self"],["bool"]]]],[11,"limits","","",47,N],[0,"abi","rustc_codegen_llvm","",N,N],[4,"Abi","rustc_codegen_llvm::abi","",N,N],[13,"Cdecl","","",48,N],[13,"Stdcall","","",48,N],[13,"Fastcall","","",48,N],[13,"Vectorcall","","",48,N],[13,"Thiscall","","",48,N],[13,"Aapcs","","",48,N],[13,"Win64","","",48,N],[13,"SysV64","","",48,N],[13,"PtxKernel","","",48,N],[13,"Msp430Interrupt","","",48,N],[13,"X86Interrupt","","",48,N],[13,"AmdGpuKernel","","",48,N],[13,"Rust","","",48,N],[13,"C","","",48,N],[13,"System","","",48,N],[13,"RustIntrinsic","","",48,N],[13,"RustCall","","",48,N],[13,"PlatformIntrinsic","","",48,N],[13,"Unadjusted","","",48,N],[17,"FAT_PTR_ADDR","","The first half of a fat pointer.",N,N],[17,"FAT_PTR_EXTRA","","The second half of a fat pointer.",N,N],[4,"PassMode","","",N,N],[13,"Ignore","","Ignore the argument (useful for empty struct).",49,N],[13,"Direct","","Pass the argument directly.",49,N],[13,"Pair","","Pass a pair's elements directly in two arguments.",49,N],[13,"Cast","","Pass the argument after casting it, to either a single uniform or a pair of registers.",49,N],[13,"Indirect","","Pass the argument indirectly via a hidden pointer. The second value, if any, is for the extra data (vtable or length) which indicates that it refers to an unsized rvalue.",49,N],[3,"ArgAttributes","","A compact representation of LLVM attributes (at least those relevant for this module) that can be manipulated without interacting with LLVM's Attribute machinery.",N,N],[12,"regular","","",50,N],[12,"pointee_size","","",50,N],[12,"pointee_align","","",50,N],[4,"RegKind","","",N,N],[13,"Integer","","",51,N],[13,"Float","","",51,N],[13,"Vector","","",51,N],[3,"Reg","","",N,N],[12,"kind","","",52,N],[12,"size","","",52,N],[3,"Uniform","","An argument passed entirely registers with the same kind (e.g. HFA / HVA on PPC64 and AArch64).",N,N],[12,"unit","","",53,N],[12,"total","","The total size of the argument, which can be: * equal to `unit.size` (one scalar/vector) * a multiple of `unit.size` (an array of scalar/vectors) * if `unit.kind` is `Integer`, the last element   can be shorter, i.e. `{ i64, i64, i32 }` for   64-bit integers with a total size of 20 bytes",53,N],[3,"CastTarget","","",N,N],[12,"prefix","","",54,N],[12,"prefix_chunk","","",54,N],[12,"rest","","",54,N],[3,"ArgType","","Information about how to pass an argument to, or return a value from, a function, under some ABI.",N,N],[12,"layout","","",55,N],[12,"pad","","Dummy argument, which is emitted before the real argument.",55,N],[12,"mode","","",55,N],[4,"Conv","","",N,N],[13,"C","","",56,N],[13,"ArmAapcs","","",56,N],[13,"Msp430Intr","","",56,N],[13,"PtxKernel","","",56,N],[13,"X86Fastcall","","",56,N],[13,"X86Intr","","",56,N],[13,"X86Stdcall","","",56,N],[13,"X86ThisCall","","",56,N],[13,"X86VectorCall","","",56,N],[13,"X86_64SysV","","",56,N],[13,"X86_64Win64","","",56,N],[13,"AmdGpuKernel","","",56,N],[3,"FnType","","Metadata describing how the arguments to a native function should be passed in order to respect the native ABI.",N,N],[12,"args","","The LLVM types of each argument.",57,N],[12,"ret","","LLVM return type.",57,N],[12,"variadic","","",57,N],[12,"conv","","",57,N],[3,"ArgAttribute","","",N,N],[12,"bits","","",58,N],[8,"ArgAttributeExt","","",N,N],[10,"for_each_kind","","",59,[[["self"],["f"]]]],[8,"ArgAttributesExt","","",N,N],[10,"apply_llfn","","",60,[[["self"],["attributeplace"],["value"]]]],[10,"apply_callsite","","",60,[[["self"],["attributeplace"],["value"]]]],[8,"LlvmType","","",N,N],[10,"llvm_type","","",61,[[["self"],["codegencx"]],["type"]]],[8,"ArgTypeExt","","",N,N],[10,"memory_ty","","",62,[[["self"],["codegencx"]],["type"]]],[10,"store","","",62,[[["self"],["builder"],["value"],["placeref"]]]],[10,"store_fn_arg","","",62,[[["self"],["builder"],["usize"],["placeref"]]]],[8,"FnTypeExt","","",N,N],[10,"of_instance","","",63,[[["codegencx"],["instance"]],["self"]]],[10,"new","","",63,N],[10,"new_vtable","","",63,N],[10,"new_internal","","",63,N],[10,"adjust_for_abi","","",63,[[["self"],["codegencx"],["abi"]]]],[10,"llvm_type","","",63,[[["self"],["codegencx"]],["type"]]],[10,"llvm_cconv","","",63,[[["self"]],["callconv"]]],[10,"apply_attrs_llfn","","",63,[[["self"],["value"]]]],[10,"apply_attrs_callsite","","",63,[[["self"],["builder"],["value"]]]],[11,"for_each_kind","","",58,[[["self"],["f"]]]],[11,"apply_llfn","","",50,[[["self"],["attributeplace"],["value"]]]],[11,"apply_callsite","","",50,[[["self"],["attributeplace"],["value"]]]],[11,"llvm_type","","",52,[[["self"],["codegencx"]],["type"]]],[11,"llvm_type","","",54,[[["self"],["codegencx"]],["type"]]],[11,"memory_ty","","Get the LLVM type for a place of the original Rust type of this argument/return, i.e. the result of `type_of::type_of`.",55,[[["self"],["codegencx"]],["type"]]],[11,"store","","Store a direct/indirect value described by this ArgType into a place for the original Rust type of this argument/return. Can be used for both storing formal arguments into Rust variables or results of call/invoke instructions into their destinations.",55,[[["self"],["builder"],["value"],["placeref"]]]],[11,"store_fn_arg","","",55,[[["self"],["builder"],["usize"],["placeref"]]]],[11,"of_instance","","",57,[[["codegencx"],["instance"]],["self"]]],[11,"new","","",57,N],[11,"new_vtable","","",57,N],[11,"new_internal","","",57,N],[11,"adjust_for_abi","","",57,[[["self"],["codegencx"],["abi"]]]],[11,"llvm_type","","",57,[[["self"],["codegencx"]],["type"]]],[11,"llvm_cconv","","",57,[[["self"]],["callconv"]]],[11,"apply_attrs_llfn","","",57,[[["self"],["value"]]]],[11,"apply_attrs_callsite","","",57,[[["self"],["builder"],["value"]]]],[0,"allocator","rustc_codegen_llvm","",N,N],[5,"codegen","rustc_codegen_llvm::allocator","",N,[[["tyctxt"],["modulellvm"],["allocatorkind"]]]],[0,"asm","rustc_codegen_llvm","",N,N],[5,"codegen_inline_asm","rustc_codegen_llvm::asm","",N,[[["builder"],["inlineasm"],["vec",["placeref"]],["vec",["value"]]]]],[5,"codegen_global_asm","","",N,[[["codegencx"],["globalasm"]]]],[0,"attributes","rustc_codegen_llvm","Set and unset common attributes on LLVM values.",N,N],[0,"attr","rustc_codegen_llvm::attributes","Functions dealing with attributes and meta items",N,N],[5,"mark_used","rustc_codegen_llvm::attributes::attr","",N,N],[5,"is_used","","",N,[[["attribute"]],["bool"]]],[5,"mark_known","","",N,N],[5,"is_known","","",N,[[["attribute"]],["bool"]]],[5,"is_known_lint_tool","","",N,[[["ident"]],["bool"]]],[5,"mk_name_value_item_str","","",N,[[["ident"],["spanned",["symbol"]]],["metaitem"]]],[5,"mk_name_value_item","","",N,[[["span"],["ident"],["spanned",["litkind"]]],["metaitem"]]],[5,"mk_list_item","","",N,[[["span"],["ident"],["vec",["spanned"]]],["metaitem"]]],[5,"mk_word_item","","",N,[[["ident"]],["metaitem"]]],[5,"mk_nested_word_item","","",N,[[["ident"]],["spanned",["nestedmetaitemkind"]]]],[5,"mk_attr_id","","",N,[[],["attrid"]]],[5,"mk_attr_inner","","Returns an inner attribute with the given value.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_spanned_attr_inner","","Returns an inner attribute with the given value and span.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_attr_outer","","Returns an outer attribute with the given value.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_spanned_attr_outer","","Returns an outer attribute with the given value and span.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_sugared_doc_attr","","",N,[[["attrid"],["symbol"],["span"]],["attribute"]]],[5,"list_contains_name","","",N,N],[5,"contains_name","","",N,N],[5,"find_by_name","","",N,N],[5,"first_attr_value_str_by_name","","",N,N],[8,"HasAttrs","","",N,N],[10,"attrs","","",64,N],[10,"map_attrs","","",64,[[["self"],["f"]],["self"]]],[5,"inject","","",N,N],[3,"Stability","","Represents the #[stable], #[unstable], #[rustc_{deprecated,const_unstable}] attributes.",N,N],[12,"level","","",65,N],[12,"feature","","",65,N],[12,"rustc_depr","","",65,N],[12,"const_stability","","`None` means the function is stable but needs to be allowed by the `min_const_fn` feature `Some` contains the feature gate required to be able to use the function as const fn",65,N],[5,"find_repr_attrs","","Parse #[repr(...)] forms.",N,[[["handler"],["attribute"]],["vec",["reprattr"]]]],[4,"StabilityLevel","","The available stability levels.",N,N],[13,"Unstable","","",66,N],[12,"reason","rustc_codegen_llvm::attributes::attr::StabilityLevel","",66,N],[12,"issue","","",66,N],[13,"Stable","rustc_codegen_llvm::attributes::attr","",66,N],[12,"since","rustc_codegen_llvm::attributes::attr::StabilityLevel","",66,N],[4,"InlineAttr","rustc_codegen_llvm::attributes::attr","",N,N],[13,"None","","",67,N],[13,"Hint","","",67,N],[13,"Always","","",67,N],[13,"Never","","",67,N],[5,"contains_feature_attr","","Check if `attrs` contains an attribute like `#![feature(feature_name)]`. This will not perform any \"sanity checks\" on the form of the attributes.",N,N],[4,"IntType","","",N,N],[13,"SignedInt","","",68,N],[13,"UnsignedInt","","",68,N],[5,"find_stability","","Find the first stability attribute. `None` if none exists.",N,N],[5,"eval_condition","","Evaluate a cfg-like condition (with `any` and `all`), using `eval` to evaluate individual items.",N,[[["metaitem"],["parsesess"],["f"]],["bool"]]],[4,"ReprAttr","","",N,N],[13,"ReprInt","","",69,N],[13,"ReprC","","",69,N],[13,"ReprPacked","","",69,N],[13,"ReprSimd","","",69,N],[13,"ReprTransparent","","",69,N],[13,"ReprAlign","","",69,N],[5,"find_deprecation","","Find the deprecation attribute. `None` if none exists.",N,N],[3,"RustcDeprecation","","",N,N],[12,"since","","",70,N],[12,"reason","","",70,N],[5,"cfg_matches","","Tests if a cfg-pattern matches the cfg set",N,[[["metaitem"],["parsesess"],["option",["features"]]],["bool"]]],[5,"find_crate_name","","",N,N],[3,"Deprecation","","",N,N],[12,"since","","",71,N],[12,"note","","",71,N],[4,"UnwindAttr","","",N,N],[13,"Allowed","","",72,N],[13,"Aborts","","",72,N],[5,"find_unwind_attr","","Determine what `#[unwind]` attribute is present in `attrs`, if any.",N,N],[4,"InlineAttr","rustc_codegen_llvm::attributes","",N,N],[13,"None","","",67,N],[13,"Hint","","",67,N],[13,"Always","","",67,N],[13,"Never","","",67,N],[5,"inline","","Mark LLVM function to use provided inline heuristic.",N,[[["codegencx"],["value"],["inlineattr"]]]],[5,"emit_uwtable","","Tell LLVM to emit or not emit the information necessary to unwind the stack for the function.",N,[[["value"],["bool"]]]],[5,"unwind","","Tell LLVM whether the function can or cannot unwind.",N,[[["value"],["bool"]]]],[5,"set_optimize_for_size","","Tell LLVM whether it should optimize function for size.",N,[[["value"],["bool"]]]],[5,"naked","","Tell LLVM if this function should be 'naked', i.e. skip the epilogue and prologue.",N,[[["value"],["bool"]]]],[5,"set_frame_pointer_elimination","","",N,[[["codegencx"],["value"]]]],[5,"set_probestack","","",N,[[["codegencx"],["value"]]]],[5,"llvm_target_features","","",N,N],[5,"apply_target_cpu_attr","","",N,[[["codegencx"],["value"]]]],[5,"from_fn_attrs","","Composite function which sets LLVM attributes for function depending on its AST (#[attribute]) attributes.",N,[[["codegencx"],["value"],["option",["defid"]]]]],[5,"provide","","",N,[[["providers"]]]],[5,"provide_extern","","",N,[[["providers"]]]],[5,"wasm_import_module","","",N,[[["tyctxt"],["defid"]],["option",["cstring"]]]],[22,"","","",N,N],[0,"base","rustc_codegen_llvm","Codegen the completed AST to the LLVM IR.",N,N],[3,"StatRecorder","rustc_codegen_llvm::base","",N,N],[12,"cx","","",73,N],[12,"name","","",73,N],[12,"istart","","",73,N],[3,"ValueIter","","",N,N],[12,"cur","","",74,N],[12,"step","","",74,N],[4,"CguReUsable","","",N,N],[13,"PreLto","","",75,N],[13,"PostLto","","",75,N],[13,"No","","",75,N],[5,"bin_op_to_icmp_predicate","","",N,[[["binopkind"],["bool"]],["intpredicate"]]],[5,"bin_op_to_fcmp_predicate","","",N,[[["binopkind"]],["realpredicate"]]],[5,"compare_simd_types","","",N,[[["builder"],["value"],["value"],["ty"],["type"],["binopkind"]],["value"]]],[5,"unsized_info","","Retrieve the information we are losing (making dynamic) in an unsizing adjustment.",N,[[["codegencx"],["ty"],["ty"],["option",["value"]]],["value"]]],[5,"unsize_thin_ptr","","Coerce `src` to `dst_ty`. `src_ty` must be a thin pointer.",N,N],[5,"coerce_unsized_into","","Coerce `src`, which is a reference to a value of type `src_ty`, to a value of type `dst_ty` and store the result in `dst`",N,[[["builder"],["placeref"],["placeref"]]]],[5,"cast_shift_expr_rhs","","",N,[[["builder"],["binopkind"],["value"],["value"]],["value"]]],[5,"cast_shift_rhs","","",N,[[["binopkind"],["value"],["value"],["f"],["g"]],["value"]]],[5,"wants_msvc_seh","","Returns whether this session's target will use SEH-based unwinding.",N,[[["session"]],["bool"]]],[5,"call_assume","","",N,[[["builder"],["value"]]]],[5,"from_immediate","","",N,[[["builder"],["value"]],["value"]]],[5,"to_immediate","","",N,[[["builder"],["value"],["tylayout"]],["value"]]],[5,"to_immediate_scalar","","",N,[[["builder"],["value"],["scalar"]],["value"]]],[5,"call_memcpy","","",N,[[["builder"],["value"],["value"],["value"],["align"],["memflags"]]]],[5,"memcpy_ty","","",N,[[["builder"],["value"],["value"],["tylayout"],["align"],["memflags"]]]],[5,"call_memset","","",N,[[["builder"],["value"],["value"],["value"],["value"],["bool"]],["value"]]],[5,"codegen_instance","","",N,[[["codegencx"],["instance"]]]],[5,"set_link_section","","",N,[[["value"],["codegenfnattrs"]]]],[5,"maybe_create_entry_wrapper","","Create the `main` function which will initialize the rust runtime and call users main function.",N,[[["codegencx"]]]],[5,"write_metadata","","",N,[[["tyctxt"],["modulellvm"]],["encodedmetadata"]]],[5,"iter_globals","","",N,[[["module"]],["valueiter"]]],[5,"determine_cgu_reuse","","",N,[[["tyctxt"],["codegenunit"]],["cgureusable"]]],[5,"codegen_crate","","",N,[[["tyctxt"],["receiver",["box"]]],["ongoingcodegen"]]],[5,"assert_and_save_dep_graph","","",N,[[["tyctxt"]]]],[5,"collect_and_partition_mono_items","","",N,N],[5,"is_codegened_item","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"compile_codegen_unit","","",N,[[["tyctxt"],["internedstring"]],["stats"]]],[5,"provide","","",N,[[["providers"]]]],[5,"provide_extern","","",N,[[["providers"]]]],[5,"linkage_to_llvm","","",N,[[["linkage"]],["linkage"]]],[5,"visibility_to_llvm","","",N,[[["visibility"]],["visibility"]]],[0,"temp_stable_hash_impls","","",N,N],[11,"hash_stable","rustc_codegen_llvm","",1,[[["self"],["hcx"],["stablehasher"]]]],[11,"new","rustc_codegen_llvm::base","",73,[[["codegencx"],["string"]],["self"]]],[11,"drop","","",73,[[["self"]]]],[11,"next","","",74,[[["self"]],["option",["value"]]]],[11,"fmt","","",75,[[["self"],["formatter"]],["result"]]],[11,"new","rustc_codegen_llvm","",6,[[["tyctxt"]],["crateinfo"]]],[11,"load_wasm_imports","","",6,[[["self"],["tyctxt"],["cratenum"]]]],[0,"builder","","",N,N],[3,"Builder","rustc_codegen_llvm::builder","",N,N],[12,"llbuilder","","",76,N],[12,"cx","","",76,N],[3,"MemFlags","","",N,N],[12,"bits","","",77,N],[5,"noname","","",N,N],[11,"drop","","",76,[[["self"]]]],[11,"eq","","",77,[[["self"],["memflags"]],["bool"]]],[11,"ne","","",77,[[["self"],["memflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",77,N],[11,"clone","","",77,[[["self"]],["memflags"]]],[11,"partial_cmp","","",77,[[["self"],["memflags"]],["option",["ordering"]]]],[11,"lt","","",77,[[["self"],["memflags"]],["bool"]]],[11,"le","","",77,[[["self"],["memflags"]],["bool"]]],[11,"gt","","",77,[[["self"],["memflags"]],["bool"]]],[11,"ge","","",77,[[["self"],["memflags"]],["bool"]]],[11,"cmp","","",77,[[["self"],["memflags"]],["ordering"]]],[11,"hash","","",77,N],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[18,"VOLATILE","","",77,N],[18,"NONTEMPORAL","","",77,N],[18,"UNALIGNED","","",77,N],[11,"empty","","Returns an empty set of flags.",77,[[],["memflags"]]],[11,"all","","Returns the set containing all flags.",77,[[],["memflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",77,[[["self"]],["u8"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",77,[[["u8"]],["option",["memflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",77,[[["u8"]],["memflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",77,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",77,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",77,[[["self"],["memflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",77,[[["self"],["memflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",77,[[["self"],["memflags"]]]],[11,"remove","","Removes the specified flags in-place.",77,[[["self"],["memflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",77,[[["self"],["memflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",77,[[["self"],["memflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",77,[[["self"],["memflags"]],["memflags"]]],[11,"bitor_assign","","Adds the set of flags.",77,[[["self"],["memflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",77,[[["self"],["memflags"]],["memflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",77,[[["self"],["memflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",77,[[["self"],["memflags"]],["memflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",77,[[["self"],["memflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",77,[[["self"],["memflags"]],["memflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",77,[[["self"],["memflags"]]]],[11,"not","","Returns the complement of this set of flags.",77,[[["self"]],["memflags"]]],[11,"extend","","",77,[[["self"],["t"]]]],[11,"from_iter","","",77,[[["t"]],["memflags"]]],[11,"new_block","","",76,[[["codegencx"],["value"],["str"]],["self"]]],[11,"with_cx","","",76,[[["codegencx"]],["self"]]],[11,"build_sibling_block","","",76,[[["self"],["str"]],["builder"]]],[11,"sess","","",76,[[["self"]],["session"]]],[11,"tcx","","",76,[[["self"]],["tyctxt"]]],[11,"llfn","","",76,[[["self"]],["value"]]],[11,"llbb","","",76,[[["self"]],["basicblock"]]],[11,"count_insn","","",76,[[["self"],["str"]]]],[11,"set_value_name","","",76,[[["self"],["value"],["str"]]]],[11,"position_at_end","","",76,[[["self"],["basicblock"]]]],[11,"position_at_start","","",76,[[["self"],["basicblock"]]]],[11,"ret_void","","",76,[[["self"]]]],[11,"ret","","",76,[[["self"],["value"]]]],[11,"br","","",76,[[["self"],["basicblock"]]]],[11,"cond_br","","",76,[[["self"],["value"],["basicblock"],["basicblock"]]]],[11,"switch","","",76,[[["self"],["value"],["basicblock"],["usize"]],["value"]]],[11,"invoke","","",76,N],[11,"unreachable","","",76,[[["self"]]]],[11,"add","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"fadd","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"fadd_fast","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"sub","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"fsub","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"fsub_fast","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"mul","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"fmul","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"fmul_fast","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"udiv","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"exactudiv","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"sdiv","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"exactsdiv","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"fdiv","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"fdiv_fast","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"urem","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"srem","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"frem","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"frem_fast","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"shl","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"lshr","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"ashr","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"and","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"or","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"xor","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"neg","","",76,[[["self"],["value"]],["value"]]],[11,"fneg","","",76,[[["self"],["value"]],["value"]]],[11,"not","","",76,[[["self"],["value"]],["value"]]],[11,"alloca","","",76,[[["self"],["type"],["str"],["align"]],["value"]]],[11,"dynamic_alloca","","",76,[[["self"],["type"],["str"],["align"]],["value"]]],[11,"array_alloca","","",76,[[["self"],["type"],["value"],["str"],["align"]],["value"]]],[11,"load","","",76,[[["self"],["value"],["align"]],["value"]]],[11,"volatile_load","","",76,[[["self"],["value"]],["value"]]],[11,"atomic_load","","",76,[[["self"],["value"],["atomicordering"],["align"]],["value"]]],[11,"range_metadata","","",76,[[["self"],["value"],["range",["u128"]]]]],[11,"nonnull_metadata","","",76,[[["self"],["value"]]]],[11,"store","","",76,[[["self"],["value"],["value"],["align"]],["value"]]],[11,"store_with_flags","","",76,[[["self"],["value"],["value"],["align"],["memflags"]],["value"]]],[11,"atomic_store","","",76,[[["self"],["value"],["value"],["atomicordering"],["align"]]]],[11,"gep","","",76,N],[11,"inbounds_gep","","",76,N],[11,"struct_gep","","",76,[[["self"],["value"],["u64"]],["value"]]],[11,"trunc","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"zext","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"sext","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"fptoui","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"fptosi","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"uitofp","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"sitofp","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"fptrunc","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"fpext","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"ptrtoint","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"inttoptr","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"bitcast","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"pointercast","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"intcast","","",76,[[["self"],["value"],["type"],["bool"]],["value"]]],[11,"icmp","","",76,[[["self"],["intpredicate"],["value"],["value"]],["value"]]],[11,"fcmp","","",76,[[["self"],["realpredicate"],["value"],["value"]],["value"]]],[11,"empty_phi","","",76,[[["self"],["type"]],["value"]]],[11,"phi","","",76,N],[11,"inline_asm_call","","",76,N],[11,"call","","",76,N],[11,"minnum","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"maxnum","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"select","","",76,[[["self"],["value"],["value"],["value"]],["value"]]],[11,"va_arg","","",76,[[["self"],["value"],["type"]],["value"]]],[11,"extract_element","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"insert_element","","",76,[[["self"],["value"],["value"],["value"]],["value"]]],[11,"shuffle_vector","","",76,[[["self"],["value"],["value"],["value"]],["value"]]],[11,"vector_splat","","",76,[[["self"],["usize"],["value"]],["value"]]],[11,"vector_reduce_fadd_fast","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"vector_reduce_fmul_fast","","",76,[[["self"],["value"],["value"]],["value"]]],[11,"vector_reduce_add","","",76,[[["self"],["value"]],["value"]]],[11,"vector_reduce_mul","","",76,[[["self"],["value"]],["value"]]],[11,"vector_reduce_and","","",76,[[["self"],["value"]],["value"]]],[11,"vector_reduce_or","","",76,[[["self"],["value"]],["value"]]],[11,"vector_reduce_xor","","",76,[[["self"],["value"]],["value"]]],[11,"vector_reduce_fmin","","",76,[[["self"],["value"]],["value"]]],[11,"vector_reduce_fmax","","",76,[[["self"],["value"]],["value"]]],[11,"vector_reduce_fmin_fast","","",76,[[["self"],["value"]],["value"]]],[11,"vector_reduce_fmax_fast","","",76,[[["self"],["value"]],["value"]]],[11,"vector_reduce_min","","",76,[[["self"],["value"],["bool"]],["value"]]],[11,"vector_reduce_max","","",76,[[["self"],["value"],["bool"]],["value"]]],[11,"extract_value","","",76,[[["self"],["value"],["u64"]],["value"]]],[11,"insert_value","","",76,[[["self"],["value"],["value"],["u64"]],["value"]]],[11,"landing_pad","","",76,[[["self"],["type"],["value"],["usize"]],["value"]]],[11,"add_clause","","",76,[[["self"],["value"],["value"]]]],[11,"set_cleanup","","",76,[[["self"],["value"]]]],[11,"resume","","",76,[[["self"],["value"]],["value"]]],[11,"cleanup_pad","","",76,N],[11,"cleanup_ret","","",76,[[["self"],["value"],["option",["basicblock"]]],["value"]]],[11,"catch_pad","","",76,N],[11,"catch_ret","","",76,[[["self"],["value"],["basicblock"]],["value"]]],[11,"catch_switch","","",76,[[["self"],["option",["value"]],["option",["basicblock"]],["usize"]],["value"]]],[11,"add_handler","","",76,[[["self"],["value"],["basicblock"]]]],[11,"set_personality_fn","","",76,[[["self"],["value"]]]],[11,"atomic_cmpxchg","","",76,[[["self"],["value"],["value"],["value"],["atomicordering"],["atomicordering"],["bool"]],["value"]]],[11,"atomic_rmw","","",76,[[["self"],["atomicrmwbinop"],["value"],["value"],["atomicordering"]],["value"]]],[11,"atomic_fence","","",76,[[["self"],["atomicordering"],["synchronizationscope"]]]],[11,"add_case","","",76,[[["self"],["value"],["value"],["basicblock"]]]],[11,"add_incoming_to_phi","","",76,[[["self"],["value"],["value"],["basicblock"]]]],[11,"set_invariant_load","","",76,[[["self"],["value"]]]],[11,"check_store","","Returns the ptr value that should be used for storing `val`.",76,[[["self"],["value"],["value"]],["value"]]],[11,"check_call","","Returns the args that should be used for a call to `llfn`.",76,N],[11,"lifetime_start","","",76,[[["self"],["value"],["size"]]]],[11,"lifetime_end","","",76,[[["self"],["value"],["size"]]]],[11,"call_lifetime_intrinsic","","If LLVM lifetime intrinsic support is enabled (i.e. optimizations on), and `ptr` is nonzero-sized, then extracts the size of `ptr` and the intrinsic for `lt` and passes them to `emit`, which is in charge of generating code to call the passed intrinsic on whatever block of generated code is targeted for the intrinsic.",76,[[["self"],["str"],["value"],["size"]]]],[0,"callee","rustc_codegen_llvm","Handles codegen of callees as well as other call-related things.  Callees are a superset of normal rust values and sometimes have different representations.  In particular, top-level fn items and methods are represented as just a fn ptr and not a full closure.",N,N],[5,"get_fn","rustc_codegen_llvm::callee","Codegens a reference to a fn/method item, monomorphizing and inlining as it goes.",N,[[["codegencx"],["instance"]],["value"]]],[5,"resolve_and_get_fn","","",N,[[["codegencx"],["defid"],["substs"]],["value"]]],[0,"common","rustc_codegen_llvm","Code that is useful in various codegen modules.",N,N],[3,"Funclet","rustc_codegen_llvm::common","A structure representing an active landing pad for the duration of a basic block.",N,N],[12,"cleanuppad","","",78,N],[12,"operand","","",78,N],[5,"type_needs_drop","","",N,[[["tyctxt"],["ty"]],["bool"]]],[5,"type_is_sized","","",N,[[["tyctxt"],["ty"]],["bool"]]],[5,"type_is_freeze","","",N,[[["tyctxt"],["ty"]],["bool"]]],[5,"val_ty","","",N,[[["value"]],["type"]]],[5,"C_null","","",N,[[["type"]],["value"]]],[5,"C_undef","","",N,[[["type"]],["value"]]],[5,"C_int","","",N,[[["type"],["i64"]],["value"]]],[5,"C_uint","","",N,[[["type"],["u64"]],["value"]]],[5,"C_uint_big","","",N,[[["type"],["u128"]],["value"]]],[5,"C_bool","","",N,[[["codegencx"],["bool"]],["value"]]],[5,"C_i32","","",N,[[["codegencx"],["i32"]],["value"]]],[5,"C_u32","","",N,[[["codegencx"],["u32"]],["value"]]],[5,"C_u64","","",N,[[["codegencx"],["u64"]],["value"]]],[5,"C_usize","","",N,[[["codegencx"],["u64"]],["value"]]],[5,"C_u8","","",N,[[["codegencx"],["u8"]],["value"]]],[5,"C_cstr","","",N,[[["codegencx"],["localinternedstring"],["bool"]],["value"]]],[5,"C_str_slice","","",N,[[["codegencx"],["localinternedstring"]],["value"]]],[5,"C_fat_ptr","","",N,[[["codegencx"],["value"],["value"]],["value"]]],[5,"C_struct","","",N,N],[5,"C_struct_in_context","","",N,N],[5,"C_array","","",N,N],[5,"C_vector","","",N,N],[5,"C_bytes","","",N,N],[5,"C_bytes_in_context","","",N,N],[5,"const_get_elt","","",N,[[["value"],["u64"]],["value"]]],[5,"const_get_real","","",N,[[["value"]],["option"]]],[5,"const_to_uint","","",N,[[["value"]],["u64"]]],[5,"is_const_integral","","",N,[[["value"]],["bool"]]],[5,"is_const_real","","",N,[[["value"]],["bool"]]],[5,"hi_lo_to_u128","","",N,[[["u64"],["u64"]],["u128"]]],[5,"const_to_opt_u128","","",N,[[["value"],["bool"]],["option",["u128"]]]],[5,"langcall","","",N,[[["tyctxt"],["option",["span"]],["str"],["langitem"]],["defid"]]],[5,"build_unchecked_lshift","","",N,[[["builder"],["value"],["value"]],["value"]]],[5,"build_unchecked_rshift","","",N,[[["builder"],["ty"],["value"],["value"]],["value"]]],[5,"shift_mask_rhs","","",N,[[["builder"],["value"]],["value"]]],[5,"shift_mask_val","","",N,[[["builder"],["type"],["type"],["bool"]],["value"]]],[5,"ty_fn_sig","","",N,[[["codegencx"],["ty"]],["polyfnsig"]]],[11,"new","","",78,[[["value"]],["self"]]],[11,"cleanuppad","","",78,[[["self"]],["value"]]],[11,"bundle","","",78,[[["self"]],["operandbundledef"]]],[0,"consts","rustc_codegen_llvm","",N,N],[5,"ptrcast","rustc_codegen_llvm::consts","",N,[[["value"],["type"]],["value"]]],[5,"bitcast","","",N,[[["value"],["type"]],["value"]]],[5,"set_global_alignment","","",N,[[["codegencx"],["value"],["align"]]]],[5,"addr_of_mut","","",N,[[["codegencx"],["value"],["align"],["option",["str"]]],["value"]]],[5,"addr_of","","",N,[[["codegencx"],["value"],["align"],["option",["str"]]],["value"]]],[5,"get_static","","",N,[[["codegencx"],["defid"]],["value"]]],[5,"check_and_apply_linkage","","",N,[[["codegencx"],["codegenfnattrs"],["ty"],["localinternedstring"],["option",["span"]]],["value"]]],[5,"codegen_static","","",N,[[["codegencx"],["defid"],["bool"]]]],[0,"context","rustc_codegen_llvm","",N,N],[3,"CodegenCx","rustc_codegen_llvm::context","There is one `CodegenCx` per compilation unit. Each one has its own LLVM `llvm::Context` so that several compilation units may be optimized in parallel. All other LLVM data structures in the `CodegenCx` are tied to that `llvm::Context`.",N,N],[12,"tcx","","",79,N],[12,"check_overflow","","",79,N],[12,"use_dll_storage_attrs","","",79,N],[12,"tls_model","","",79,N],[12,"llmod","","",79,N],[12,"llcx","","",79,N],[12,"stats","","",79,N],[12,"codegen_unit","","",79,N],[12,"instances","","Cache instances of monomorphic and polymorphic items",79,N],[12,"vtables","","Cache generated vtables",79,N],[12,"const_cstr_cache","","Cache of constant strings,",79,N],[12,"const_unsized","","Reverse-direction for const ptrs cast from globals. Key is a Value holding a *T, Val is a Value holding a *[T].",79,N],[12,"const_globals","","Cache of emitted const globals (value -> global)",79,N],[12,"statics_to_rauw","","List of globals for static variables which need to be passed to the LLVM function ReplaceAllUsesWith (RAUW) when codegen is complete. (We have to make sure we don't invalidate any Values referring to constants.)",79,N],[12,"used_statics","","Statics that will be placed in the llvm.used variable See http://llvm.org/docs/LangRef.html#the-llvm-used-global-variable for details",79,N],[12,"lltypes","","",79,N],[12,"scalar_lltypes","","",79,N],[12,"pointee_infos","","",79,N],[12,"isize_ty","","",79,N],[12,"dbg_cx","","",79,N],[12,"eh_personality","","",79,N],[12,"eh_unwind_resume","","",79,N],[12,"rust_try_fn","","",79,N],[12,"intrinsics","","",79,N],[12,"local_gen_sym_counter","","A counter that is used for generating local symbol names",79,N],[5,"get_reloc_model","","",N,[[["session"]],["relocmode"]]],[5,"get_tls_model","","",N,[[["session"]],["threadlocalmode"]]],[5,"is_any_library","","",N,[[["session"]],["bool"]]],[5,"is_pie_binary","","",N,[[["session"]],["bool"]]],[5,"create_module","","",N,[[["session"],["context"],["str"]],["module"]]],[5,"declare_intrinsic","","Declare any llvm intrinsics that you might need",N,[[["codegencx"],["str"]],["option",["value"]]]],[11,"new","","",79,[[["tyctxt"],["arc",["codegenunit"]],["modulellvm"]],["codegencx"]]],[11,"sess","","",79,[[["self"]],["session"]]],[11,"get_intrinsic","","",79,[[["self"],["str"]],["value"]]],[11,"generate_local_symbol_name","","Generate a new symbol name with the given prefix. This symbol name must only be used for definitions with `internal` or `private` linkage.",79,[[["self"],["str"]],["string"]]],[11,"eh_personality","","",79,[[["self"]],["value"]]],[11,"eh_unwind_resume","","",79,[[["self"]],["value"]]],[11,"type_needs_drop","","",79,[[["self"],["ty"]],["bool"]]],[11,"type_is_sized","","",79,[[["self"],["ty"]],["bool"]]],[11,"type_is_freeze","","",79,[[["self"],["ty"]],["bool"]]],[11,"type_has_metadata","","",79,[[["self"],["ty"]],["bool"]]],[0,"debuginfo","rustc_codegen_llvm","",N,N],[3,"CrateDebugContext","rustc_codegen_llvm::debuginfo","A context object for maintaining all state needed by the debuginfo module.",N,N],[12,"llcontext","","",80,N],[12,"llmod","","",80,N],[12,"builder","","",80,N],[12,"created_files","","",80,N],[12,"created_enum_disr_types","","",80,N],[12,"type_map","","",80,N],[12,"namespace_map","","",80,N],[12,"composite_types_completed","","",80,N],[3,"FunctionDebugContextData","","",N,N],[12,"fn_metadata","","",81,N],[12,"source_locations_enabled","","",81,N],[12,"defining_crate","","",81,N],[4,"FunctionDebugContext","","",N,N],[13,"RegularContext","","",82,N],[13,"DebugInfoDisabled","","",82,N],[13,"FunctionWithoutDebugInfo","","",82,N],[4,"VariableAccess","","",N,N],[13,"DirectVariable","","",83,N],[12,"alloca","rustc_codegen_llvm::debuginfo::VariableAccess","",83,N],[13,"IndirectVariable","rustc_codegen_llvm::debuginfo","",83,N],[12,"alloca","rustc_codegen_llvm::debuginfo::VariableAccess","",83,N],[12,"address_operations","","",83,N],[4,"VariableKind","rustc_codegen_llvm::debuginfo","",N,N],[13,"ArgumentVariable","","",84,N],[13,"LocalVariable","","",84,N],[5,"finalize","","Create any deferred debug metadata nodes",N,[[["codegencx"]]]],[5,"create_function_debug_context","","Creates the function-specific debug context.",N,[[["codegencx"],["instance"],["fnsig"],["value"],["mir"]],["functiondebugcontext"]]],[5,"declare_local","","",N,[[["builder"],["functiondebugcontext"],["name"],["ty"],["discope"],["variableaccess"],["variablekind"],["span"]]]],[0,"doc","","Debug Info Module",N,N],[0,"gdb","","",N,N],[5,"insert_reference_to_gdb_debug_scripts_section_global","rustc_codegen_llvm::debuginfo::gdb","Inserts a side-effect free instruction sequence that makes sure that the .debug_gdb_scripts global is referenced, so it isn't removed by the linker.",N,[[["builder"]]]],[5,"get_or_insert_gdb_debug_scripts_section_global","","Allocates the global variable responsible for the .debug_gdb_scripts binary section.",N,[[["codegencx"]],["value"]]],[5,"needs_gdb_debug_scripts_section","","",N,[[["codegencx"]],["bool"]]],[0,"utils","rustc_codegen_llvm::debuginfo","",N,N],[5,"is_node_local_to_unit","rustc_codegen_llvm::debuginfo::utils","",N,[[["codegencx"],["defid"]],["bool"]]],[5,"create_DIArray","","",N,N],[5,"span_start","","Return syntax_pos::Loc corresponding to the beginning of the span",N,[[["codegencx"],["span"]],["loc"]]],[5,"debug_context","","",N,[[["codegencx"]],["cratedebugcontext"]]],[5,"DIB","","",N,[[["codegencx"]],["dibuilder"]]],[5,"get_namespace_for_item","","",N,[[["codegencx"],["defid"]],["discope"]]],[0,"namespace","rustc_codegen_llvm::debuginfo","",N,N],[5,"mangled_name_of_instance","rustc_codegen_llvm::debuginfo::namespace","",N,[[["codegencx"],["instance"]],["symbolname"]]],[5,"item_namespace","","",N,[[["codegencx"],["defid"]],["discope"]]],[0,"type_names","rustc_codegen_llvm::debuginfo","",N,N],[5,"compute_debuginfo_type_name","rustc_codegen_llvm::debuginfo::type_names","",N,[[["codegencx"],["ty"],["bool"]],["string"]]],[5,"push_debuginfo_type_name","","",N,[[["codegencx"],["ty"],["bool"],["string"]]]],[0,"metadata","rustc_codegen_llvm::debuginfo","",N,N],[3,"UniqueTypeId","rustc_codegen_llvm::debuginfo::metadata","",N,N],[12,"0","","",85,N],[3,"TypeMap","","",N,N],[12,"unique_id_interner","","",86,N],[12,"unique_id_to_metadata","","",86,N],[12,"type_to_metadata","","",86,N],[12,"type_to_unique_id","","",86,N],[3,"MetadataCreationResult","","",N,N],[12,"metadata","","",87,N],[12,"already_stored_in_typemap","","",87,N],[3,"MemberDescription","","",N,N],[12,"name","","",88,N],[12,"type_metadata","","",88,N],[12,"offset","","",88,N],[12,"size","","",88,N],[12,"align","","",88,N],[12,"flags","","",88,N],[3,"StructMemberDescriptionFactory","","",N,N],[12,"ty","","",89,N],[12,"variant","","",89,N],[12,"span","","",89,N],[3,"TupleMemberDescriptionFactory","","",N,N],[12,"ty","","",90,N],[12,"component_types","","",90,N],[12,"span","","",90,N],[3,"UnionMemberDescriptionFactory","","",N,N],[12,"layout","","",91,N],[12,"variant","","",91,N],[12,"span","","",91,N],[3,"EnumMemberDescriptionFactory","","",N,N],[12,"enum_type","","",92,N],[12,"layout","","",92,N],[12,"discriminant_type_metadata","","",92,N],[12,"containing_scope","","",92,N],[12,"span","","",92,N],[3,"VariantMemberDescriptionFactory","","",N,N],[12,"offsets","","",93,N],[12,"args","","",93,N],[12,"discriminant_type_metadata","","",93,N],[12,"span","","",93,N],[4,"RecursiveTypeDescription","","",N,N],[13,"UnfinishedMetadata","","",94,N],[12,"unfinished_type","rustc_codegen_llvm::debuginfo::metadata::RecursiveTypeDescription","",94,N],[12,"unique_type_id","","",94,N],[12,"metadata_stub","","",94,N],[12,"member_description_factory","","",94,N],[13,"FinalMetadata","rustc_codegen_llvm::debuginfo::metadata","",94,N],[4,"MemberDescriptionFactory","","",N,N],[13,"StructMDF","","",95,N],[13,"TupleMDF","","",95,N],[13,"EnumMDF","","",95,N],[13,"UnionMDF","","",95,N],[13,"VariantMDF","","",95,N],[4,"EnumDiscriminantInfo","","",N,N],[13,"RegularDiscriminant","","",96,N],[13,"OptimizedDiscriminant","","",96,N],[13,"NoDiscriminant","","",96,N],[5,"create_and_register_recursive_type_forward_declaration","","",N,[[["codegencx"],["ty"],["uniquetypeid"],["dicompositetype"],["memberdescriptionfactory"]],["recursivetypedescription"]]],[5,"fixed_vec_metadata","","",N,[[["codegencx"],["uniquetypeid"],["ty"],["ty"],["span"]],["metadatacreationresult"]]],[5,"vec_slice_metadata","","",N,[[["codegencx"],["ty"],["ty"],["uniquetypeid"],["span"]],["metadatacreationresult"]]],[5,"subroutine_type_metadata","","",N,[[["codegencx"],["uniquetypeid"],["polyfnsig"],["span"]],["metadatacreationresult"]]],[5,"trait_pointer_metadata","","",N,[[["codegencx"],["ty"],["option",["ty"]],["uniquetypeid"]],["ditype"]]],[5,"type_metadata","","",N,[[["codegencx"],["ty"],["span"]],["ditype"]]],[5,"file_metadata","","",N,[[["codegencx"],["filename"],["cratenum"]],["difile"]]],[5,"unknown_file_metadata","","",N,[[["codegencx"]],["difile"]]],[5,"file_metadata_raw","","",N,[[["codegencx"],["str"],["str"]],["difile"]]],[5,"basic_type_metadata","","",N,[[["codegencx"],["ty"]],["ditype"]]],[5,"foreign_type_metadata","","",N,[[["codegencx"],["ty"],["uniquetypeid"]],["ditype"]]],[5,"pointer_type_metadata","","",N,[[["codegencx"],["ty"],["ditype"]],["ditype"]]],[5,"compile_unit_metadata","","",N,[[["tyctxt"],["str"],["cratedebugcontext"]],["didescriptor"]]],[5,"prepare_struct_metadata","","",N,[[["codegencx"],["ty"],["uniquetypeid"],["span"]],["recursivetypedescription"]]],[5,"prepare_tuple_metadata","","",N,N],[5,"prepare_union_metadata","","",N,[[["codegencx"],["ty"],["uniquetypeid"],["span"]],["recursivetypedescription"]]],[5,"describe_enum_variant","","",N,N],[5,"prepare_enum_metadata","","",N,[[["codegencx"],["ty"],["defid"],["uniquetypeid"],["span"]],["recursivetypedescription"]]],[5,"composite_type_metadata","","Creates debug information for a composite type, that is, anything that results in a LLVM struct.",N,[[["codegencx"],["ty"],["str"],["uniquetypeid"],["vec",["memberdescription"]],["option",["discope"]],["difile"],["span"]],["dicompositetype"]]],[5,"set_members_of_composite_type","","",N,[[["codegencx"],["dicompositetype"],["vec",["memberdescription"]]]]],[5,"create_struct_stub","","",N,[[["codegencx"],["ty"],["str"],["uniquetypeid"],["option",["discope"]]],["dicompositetype"]]],[5,"create_union_stub","","",N,[[["codegencx"],["ty"],["str"],["uniquetypeid"],["discope"]],["dicompositetype"]]],[5,"create_global_var_metadata","","Creates debug information for the given global variable.",N,[[["codegencx"],["defid"],["value"]]]],[5,"extend_scope_to_file","","",N,[[["codegencx"],["discope"],["sourcefile"],["cratenum"]],["dilexicalblock"]]],[5,"create_vtable_metadata","","Creates debug information for the given vtable, which is for the given type.",N,[[["codegencx"],["ty"],["value"]]]],[17,"DW_LANG_RUST","","",N,N],[17,"DW_ATE_boolean","","",N,N],[17,"DW_ATE_float","","",N,N],[17,"DW_ATE_signed","","",N,N],[17,"DW_ATE_unsigned","","",N,N],[17,"DW_ATE_unsigned_char","","",N,N],[17,"UNKNOWN_LINE_NUMBER","","",N,N],[17,"UNKNOWN_COLUMN_NUMBER","","",N,N],[17,"NO_SCOPE_METADATA","","",N,N],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"hash","","",85,N],[11,"assert_receiver_is_total_eq","","",85,N],[11,"eq","","",85,[[["self"],["uniquetypeid"]],["bool"]]],[11,"ne","","",85,[[["self"],["uniquetypeid"]],["bool"]]],[11,"clone","","",85,[[["self"]],["uniquetypeid"]]],[11,"new","","",86,[[],["self"]]],[11,"register_type_with_metadata","","",86,[[["self"],["ty"],["ditype"]]]],[11,"register_unique_id_with_metadata","","",86,[[["self"],["uniquetypeid"],["ditype"]]]],[11,"find_metadata_for_type","","",86,[[["self"],["ty"]],["option",["ditype"]]]],[11,"find_metadata_for_unique_id","","",86,[[["self"],["uniquetypeid"]],["option",["ditype"]]]],[11,"get_unique_type_id_as_string","","",86,[[["self"],["uniquetypeid"]],["str"]]],[11,"get_unique_type_id_of_type","","",86,[[["self"],["codegencx"],["ty"]],["uniquetypeid"]]],[11,"get_unique_type_id_of_enum_variant","","",86,[[["self"],["codegencx"],["ty"],["str"]],["uniquetypeid"]]],[11,"finalize","","",94,[[["self"],["codegencx"]],["metadatacreationresult"]]],[11,"new","","",87,[[["ditype"],["bool"]],["self"]]],[11,"fmt","","",88,[[["self"],["formatter"]],["result"]]],[11,"create_member_descriptions","","",95,[[["self"],["codegencx"]],["vec",["memberdescription"]]]],[11,"create_member_descriptions","","",89,[[["self"],["codegencx"]],["vec",["memberdescription"]]]],[11,"create_member_descriptions","","",90,[[["self"],["codegencx"]],["vec",["memberdescription"]]]],[11,"create_member_descriptions","","",91,[[["self"],["codegencx"]],["vec",["memberdescription"]]]],[11,"create_member_descriptions","","",92,[[["self"],["codegencx"]],["vec",["memberdescription"]]]],[11,"create_member_descriptions","","",93,[[["self"],["codegencx"]],["vec",["memberdescription"]]]],[11,"clone","","",96,[[["self"]],["enumdiscriminantinfo"]]],[0,"create_scope_map","rustc_codegen_llvm::debuginfo","",N,N],[3,"MirDebugScope","rustc_codegen_llvm::debuginfo::create_scope_map","",N,N],[12,"scope_metadata","","",97,N],[12,"file_start_pos","","",97,N],[12,"file_end_pos","","",97,N],[5,"create_mir_scopes","","Produce DIScope DIEs for each MIR Scope which has variables defined in it. If debuginfo is disabled, the returned vector is empty.",N,[[["codegencx"],["mir"],["functiondebugcontext"]],["indexvec",["sourcescope","mirdebugscope"]]]],[5,"make_mir_scope","","",N,[[["codegencx"],["mir"],["bitarray"],["functiondebugcontextdata"],["sourcescope"],["indexvec"]]]],[11,"clone","","",97,[[["self"]],["mirdebugscope"]]],[11,"fmt","","",97,[[["self"],["formatter"]],["result"]]],[11,"is_valid","","",97,[[["self"]],["bool"]]],[0,"source_loc","rustc_codegen_llvm::debuginfo","",N,N],[4,"InternalDebugLocation","rustc_codegen_llvm::debuginfo::source_loc","",N,N],[13,"KnownLocation","","",98,N],[12,"scope","rustc_codegen_llvm::debuginfo::source_loc::InternalDebugLocation","",98,N],[12,"line","","",98,N],[12,"col","","",98,N],[13,"UnknownLocation","rustc_codegen_llvm::debuginfo::source_loc","",98,N],[5,"set_source_location","","Sets the current debug location at the beginning of the span.",N,[[["functiondebugcontext"],["builder"],["option",["discope"]],["span"]]]],[5,"start_emitting_source_locations","","Enables emitting source locations for the given functions.",N,[[["functiondebugcontext"]]]],[5,"set_debug_location","","",N,[[["builder"],["internaldebuglocation"]]]],[11,"clone","","",98,[[["self"]],["internaldebuglocation"]]],[11,"eq","","",98,[[["self"],["internaldebuglocation"]],["bool"]]],[11,"ne","","",98,[[["self"],["internaldebuglocation"]],["bool"]]],[11,"new","","",98,[[["discope"],["usize"],["usize"]],["self"]]],[17,"DW_TAG_auto_variable","rustc_codegen_llvm::debuginfo","",N,N],[17,"DW_TAG_arg_variable","","",N,N],[11,"drop","","",80,[[["self"]]]],[11,"new","","",80,[[["module"]],["self"]]],[11,"get_ref","","",82,[[["self"],["span"]],["functiondebugcontextdata"]]],[11,"debuginfo_disabled_message","","",82,[[],["str"]]],[11,"should_be_ignored_message","","",82,[[],["str"]]],[0,"declare","rustc_codegen_llvm","Declare various LLVM values.",N,N],[5,"declare_global","rustc_codegen_llvm::declare","Declare a global value.",N,[[["codegencx"],["str"],["type"]],["value"]]],[5,"declare_raw_fn","","Declare a function.",N,[[["codegencx"],["str"],["callconv"],["type"]],["value"]]],[5,"declare_cfn","","Declare a C ABI function.",N,[[["codegencx"],["str"],["type"]],["value"]]],[5,"declare_fn","","Declare a Rust function.",N,[[["codegencx"],["str"],["ty"]],["value"]]],[5,"define_global","","Declare a global with an intention to define it.",N,[[["codegencx"],["str"],["type"]],["option",["value"]]]],[5,"define_private_global","","Declare a private global",N,[[["codegencx"],["type"]],["value"]]],[5,"define_fn","","Declare a Rust function with an intention to define it.",N,[[["codegencx"],["str"],["ty"]],["value"]]],[5,"define_internal_fn","","Declare a Rust function with an intention to define it.",N,[[["codegencx"],["str"],["ty"]],["value"]]],[5,"get_declared_value","","Get declared value by name.",N,[[["codegencx"],["str"]],["option",["value"]]]],[5,"get_defined_value","","Get defined or externally defined (AvailableExternally linkage) value by name.",N,[[["codegencx"],["str"]],["option",["value"]]]],[0,"glue","rustc_codegen_llvm","",N,N],[5,"size_and_align_of_dst","rustc_codegen_llvm::glue","",N,N],[0,"intrinsic","rustc_codegen_llvm","",N,N],[5,"get_simple_intrinsic","rustc_codegen_llvm::intrinsic","",N,[[["codegencx"],["str"]],["option",["value"]]]],[5,"codegen_intrinsic_call","","Remember to add all intrinsics here, in librustc_typeck/check/mod.rs, and in libcore/intrinsics.rs; if you need access to any llvm intrinsics, add them to librustc_codegen_llvm/context.rs",N,N],[5,"copy_intrinsic","","",N,[[["builder"],["bool"],["bool"],["ty"],["value"],["value"],["value"]],["value"]]],[5,"memset_intrinsic","","",N,[[["builder"],["bool"],["ty"],["value"],["value"],["value"]],["value"]]],[5,"try_intrinsic","","",N,[[["builder"],["codegencx"],["value"],["value"],["value"],["value"]]]],[5,"codegen_msvc_try","","",N,[[["builder"],["codegencx"],["value"],["value"],["value"],["value"]]]],[5,"codegen_gnu_try","","",N,[[["builder"],["codegencx"],["value"],["value"],["value"],["value"]]]],[5,"gen_fn","","",N,[[["codegencx"],["str"],["vec",["ty"]],["ty"],["fnmut"]],["value"]]],[5,"get_rust_try_fn","","",N,[[["codegencx"],["fnmut"]],["value"]]],[5,"span_invalid_monomorphization_error","","",N,[[["session"],["span"],["str"]]]],[5,"generic_simd_intrinsic","","",N,N],[5,"int_type_width_signed","","",N,[[["ty"],["codegencx"]],["option"]]],[5,"float_type_width","","",N,[[["tykind"]],["option",["u64"]]]],[0,"llvm","rustc_codegen_llvm","",N,N],[3,"ThinLTOModule","rustc_codegen_llvm::llvm","LLVMRustThinLTOModule",N,N],[12,"identifier","","",99,N],[12,"data","","",99,N],[12,"len","","",99,N],[3,"Builder","","",N,N],[12,"0","","",100,N],[3,"PassManager","","",N,N],[12,"0","","",101,N],[3,"SectionIterator","","",N,N],[12,"0","","",102,N],[3,"ArchiveIterator","","",N,N],[12,"0","","",103,N],[3,"ArchiveChild","","",N,N],[12,"0","","",104,N],[3,"RustArchiveMember","","",N,N],[12,"0","","",105,N],[3,"OperandBundleDef","","",N,N],[12,"0","","",106,N],[3,"Linker","","",N,N],[12,"0","","",107,N],[3,"RustString","","",N,N],[12,"bytes","","",108,N],[3,"ObjectFile","","",N,N],[12,"llof","","",109,N],[3,"SectionIter","","",N,N],[12,"llsi","","",110,N],[3,"OperandBundleDef","","",N,N],[12,"raw","","",111,N],[4,"LLVMRustResult","","",N,N],[13,"Success","","",112,N],[13,"Failure","","",112,N],[4,"CallConv","","LLVM CallingConv::ID. Should we wrap this?",N,N],[13,"CCallConv","","",113,N],[13,"FastCallConv","","",113,N],[13,"ColdCallConv","","",113,N],[13,"X86StdcallCallConv","","",113,N],[13,"X86FastcallCallConv","","",113,N],[13,"ArmAapcsCallConv","","",113,N],[13,"Msp430Intr","","",113,N],[13,"X86_ThisCall","","",113,N],[13,"PtxKernel","","",113,N],[13,"X86_64_SysV","","",113,N],[13,"X86_64_Win64","","",113,N],[13,"X86_VectorCall","","",113,N],[13,"X86_Intr","","",113,N],[13,"AmdGpuKernel","","",113,N],[4,"Linkage","","LLVMRustLinkage",N,N],[13,"ExternalLinkage","","",114,N],[13,"AvailableExternallyLinkage","","",114,N],[13,"LinkOnceAnyLinkage","","",114,N],[13,"LinkOnceODRLinkage","","",114,N],[13,"WeakAnyLinkage","","",114,N],[13,"WeakODRLinkage","","",114,N],[13,"AppendingLinkage","","",114,N],[13,"InternalLinkage","","",114,N],[13,"PrivateLinkage","","",114,N],[13,"ExternalWeakLinkage","","",114,N],[13,"CommonLinkage","","",114,N],[4,"Visibility","","",N,N],[13,"Default","","",115,N],[13,"Hidden","","",115,N],[13,"Protected","","",115,N],[4,"DLLStorageClass","","LLVMDLLStorageClass",N,N],[13,"Default","","",116,N],[13,"DllImport","","",116,N],[13,"DllExport","","",116,N],[4,"Attribute","","Matches LLVMRustAttribute in rustllvm.h Semantically a subset of the C++ enum llvm::Attribute::AttrKind, though it is not ABI compatible (since it's a C++ enum)",N,N],[13,"AlwaysInline","","",117,N],[13,"ByVal","","",117,N],[13,"Cold","","",117,N],[13,"InlineHint","","",117,N],[13,"MinSize","","",117,N],[13,"Naked","","",117,N],[13,"NoAlias","","",117,N],[13,"NoCapture","","",117,N],[13,"NoInline","","",117,N],[13,"NonNull","","",117,N],[13,"NoRedZone","","",117,N],[13,"NoReturn","","",117,N],[13,"NoUnwind","","",117,N],[13,"OptimizeForSize","","",117,N],[13,"ReadOnly","","",117,N],[13,"SExt","","",117,N],[13,"StructRet","","",117,N],[13,"UWTable","","",117,N],[13,"ZExt","","",117,N],[13,"InReg","","",117,N],[13,"SanitizeThread","","",117,N],[13,"SanitizeAddress","","",117,N],[13,"SanitizeMemory","","",117,N],[4,"IntPredicate","","LLVMIntPredicate",N,N],[13,"IntEQ","","",118,N],[13,"IntNE","","",118,N],[13,"IntUGT","","",118,N],[13,"IntUGE","","",118,N],[13,"IntULT","","",118,N],[13,"IntULE","","",118,N],[13,"IntSGT","","",118,N],[13,"IntSGE","","",118,N],[13,"IntSLT","","",118,N],[13,"IntSLE","","",118,N],[4,"RealPredicate","","LLVMRealPredicate",N,N],[13,"RealPredicateFalse","","",119,N],[13,"RealOEQ","","",119,N],[13,"RealOGT","","",119,N],[13,"RealOGE","","",119,N],[13,"RealOLT","","",119,N],[13,"RealOLE","","",119,N],[13,"RealONE","","",119,N],[13,"RealORD","","",119,N],[13,"RealUNO","","",119,N],[13,"RealUEQ","","",119,N],[13,"RealUGT","","",119,N],[13,"RealUGE","","",119,N],[13,"RealULT","","",119,N],[13,"RealULE","","",119,N],[13,"RealUNE","","",119,N],[13,"RealPredicateTrue","","",119,N],[4,"TypeKind","","LLVMTypeKind",N,N],[13,"Void","","",120,N],[13,"Half","","",120,N],[13,"Float","","",120,N],[13,"Double","","",120,N],[13,"X86_FP80","","",120,N],[13,"FP128","","",120,N],[13,"PPC_FP128","","",120,N],[13,"Label","","",120,N],[13,"Integer","","",120,N],[13,"Function","","",120,N],[13,"Struct","","",120,N],[13,"Array","","",120,N],[13,"Pointer","","",120,N],[13,"Vector","","",120,N],[13,"Metadata","","",120,N],[13,"X86_MMX","","",120,N],[13,"Token","","",120,N],[4,"AtomicRmwBinOp","","LLVMAtomicRmwBinOp",N,N],[13,"AtomicXchg","","",121,N],[13,"AtomicAdd","","",121,N],[13,"AtomicSub","","",121,N],[13,"AtomicAnd","","",121,N],[13,"AtomicNand","","",121,N],[13,"AtomicOr","","",121,N],[13,"AtomicXor","","",121,N],[13,"AtomicMax","","",121,N],[13,"AtomicMin","","",121,N],[13,"AtomicUMax","","",121,N],[13,"AtomicUMin","","",121,N],[4,"AtomicOrdering","","LLVMAtomicOrdering",N,N],[13,"NotAtomic","","",122,N],[13,"Unordered","","",122,N],[13,"Monotonic","","",122,N],[13,"Acquire","","",122,N],[13,"Release","","",122,N],[13,"AcquireRelease","","",122,N],[13,"SequentiallyConsistent","","",122,N],[4,"SynchronizationScope","","LLVMRustSynchronizationScope",N,N],[13,"Other","","",123,N],[13,"SingleThread","","",123,N],[13,"CrossThread","","",123,N],[4,"FileType","","LLVMRustFileType",N,N],[13,"Other","","",124,N],[13,"AssemblyFile","","",124,N],[13,"ObjectFile","","",124,N],[4,"MetadataType","","LLVMMetadataType",N,N],[13,"MD_dbg","","",125,N],[13,"MD_tbaa","","",125,N],[13,"MD_prof","","",125,N],[13,"MD_fpmath","","",125,N],[13,"MD_range","","",125,N],[13,"MD_tbaa_struct","","",125,N],[13,"MD_invariant_load","","",125,N],[13,"MD_alias_scope","","",125,N],[13,"MD_noalias","","",125,N],[13,"MD_nontemporal","","",125,N],[13,"MD_mem_parallel_loop_access","","",125,N],[13,"MD_nonnull","","",125,N],[4,"AsmDialect","","LLVMRustAsmDialect",N,N],[13,"Other","","",126,N],[13,"Att","","",126,N],[13,"Intel","","",126,N],[4,"CodeGenOptLevel","","LLVMRustCodeGenOptLevel",N,N],[13,"Other","","",127,N],[13,"None","","",127,N],[13,"Less","","",127,N],[13,"Default","","",127,N],[13,"Aggressive","","",127,N],[4,"RelocMode","","LLVMRelocMode",N,N],[13,"Default","","",128,N],[13,"Static","","",128,N],[13,"PIC","","",128,N],[13,"DynamicNoPic","","",128,N],[13,"ROPI","","",128,N],[13,"RWPI","","",128,N],[13,"ROPI_RWPI","","",128,N],[4,"CodeModel","","LLVMRustCodeModel",N,N],[13,"Other","","",129,N],[13,"Small","","",129,N],[13,"Kernel","","",129,N],[13,"Medium","","",129,N],[13,"Large","","",129,N],[13,"None","","",129,N],[4,"DiagnosticKind","","LLVMRustDiagnosticKind",N,N],[13,"Other","","",130,N],[13,"InlineAsm","","",130,N],[13,"StackSize","","",130,N],[13,"DebugMetadataVersion","","",130,N],[13,"SampleProfile","","",130,N],[13,"OptimizationRemark","","",130,N],[13,"OptimizationRemarkMissed","","",130,N],[13,"OptimizationRemarkAnalysis","","",130,N],[13,"OptimizationRemarkAnalysisFPCommute","","",130,N],[13,"OptimizationRemarkAnalysisAliasing","","",130,N],[13,"OptimizationRemarkOther","","",130,N],[13,"OptimizationFailure","","",130,N],[13,"PGOProfile","","",130,N],[13,"Linker","","",130,N],[4,"ArchiveKind","","LLVMRustArchiveKind",N,N],[13,"Other","","",131,N],[13,"K_GNU","","",131,N],[13,"K_BSD","","",131,N],[13,"K_COFF","","",131,N],[4,"PassKind","","LLVMRustPassKind",N,N],[13,"Other","","",132,N],[13,"Function","","",132,N],[13,"Module","","",132,N],[4,"ThreadLocalMode","","LLVMThreadLocalMode",N,N],[13,"NotThreadLocal","","",133,N],[13,"GeneralDynamic","","",133,N],[13,"LocalDynamic","","",133,N],[13,"InitialExec","","",133,N],[13,"LocalExec","","",133,N],[4,"AttributePlace","","",N,N],[13,"ReturnValue","","",134,N],[13,"Argument","","",134,N],[13,"Function","","",134,N],[4,"CodeGenOptSize","","",N,N],[13,"CodeGenOptSizeNone","","",135,N],[13,"CodeGenOptSizeDefault","","",135,N],[13,"CodeGenOptSizeAggressive","","",135,N],[5,"AddFunctionAttrStringValue","","",N,[[["value"],["attributeplace"],["cstr"],["cstr"]]]],[5,"LLVMRustStringWriteImpl","","Appending to a Rust string -- used by RawRustStringOstream.",N,N],[5,"SetInstructionCallConv","","",N,[[["value"],["callconv"]]]],[5,"SetFunctionCallConv","","",N,[[["value"],["callconv"]]]],[5,"SetUniqueComdat","","",N,[[["module"],["value"]]]],[5,"UnsetComdat","","",N,[[["value"]]]],[5,"SetUnnamedAddr","","",N,[[["value"],["bool"]]]],[5,"set_thread_local","","",N,[[["value"],["bool"]]]],[5,"set_thread_local_mode","","",N,[[["value"],["threadlocalmode"]]]],[5,"mk_section_iter","","",N,[[["objectfile"]],["sectioniter"]]],[5,"get_param","","Safe wrapper around `LLVMGetParam`, because segfaults are no fun.",N,[[["value"],["c_uint"]],["value"]]],[5,"build_string","","",N,N],[5,"twine_to_string","","",N,[[["twine"]],["string"]]],[5,"last_error","","",N,[[],["option",["string"]]]],[20,"ThinLTOData","","",N,N],[20,"ThinLTOBuffer","","",N,N],[20,"Module","","",N,N],[20,"Context","","",N,N],[20,"Type","","",N,N],[20,"Value","","",N,N],[20,"Metadata","","",N,N],[20,"BasicBlock","","",N,N],[20,"MemoryBuffer","","",N,N],[20,"PassManagerBuilder","","",N,N],[20,"ObjectFile","","",N,N],[20,"Pass","","",N,N],[20,"TargetMachine","","",N,N],[20,"Archive","","",N,N],[20,"Twine","","",N,N],[20,"DiagnosticInfo","","",N,N],[20,"SMDiagnostic","","",N,N],[20,"ModuleBuffer","","",N,N],[5,"LLVMRustContextCreate","","",N,N],[5,"LLVMContextDispose","","",N,N],[5,"LLVMGetMDKindIDInContext","","",N,N],[5,"LLVMModuleCreateWithNameInContext","","",N,N],[5,"LLVMGetModuleContext","","",N,N],[5,"LLVMCloneModule","","",N,N],[5,"LLVMGetDataLayout","","Data layout. See Module::getDataLayout.",N,N],[5,"LLVMSetDataLayout","","",N,N],[5,"LLVMSetModuleInlineAsm","","See Module::setModuleInlineAsm.",N,N],[5,"LLVMRustAppendModuleInlineAsm","","",N,N],[5,"LLVMRustGetTypeKind","","See llvm::LLVMTypeKind::getTypeID.",N,N],[5,"LLVMInt1TypeInContext","","",N,N],[5,"LLVMInt8TypeInContext","","",N,N],[5,"LLVMInt16TypeInContext","","",N,N],[5,"LLVMInt32TypeInContext","","",N,N],[5,"LLVMInt64TypeInContext","","",N,N],[5,"LLVMIntTypeInContext","","",N,N],[5,"LLVMGetIntTypeWidth","","",N,N],[5,"LLVMFloatTypeInContext","","",N,N],[5,"LLVMDoubleTypeInContext","","",N,N],[5,"LLVMFunctionType","","",N,N],[5,"LLVMCountParamTypes","","",N,N],[5,"LLVMGetParamTypes","","",N,N],[5,"LLVMStructTypeInContext","","",N,N],[5,"LLVMRustArrayType","","",N,N],[5,"LLVMPointerType","","",N,N],[5,"LLVMVectorType","","",N,N],[5,"LLVMGetElementType","","",N,N],[5,"LLVMGetVectorSize","","",N,N],[5,"LLVMVoidTypeInContext","","",N,N],[5,"LLVMX86MMXTypeInContext","","",N,N],[5,"LLVMRustMetadataTypeInContext","","",N,N],[5,"LLVMTypeOf","","",N,N],[5,"LLVMGetValueName","","",N,N],[5,"LLVMSetValueName","","",N,N],[5,"LLVMReplaceAllUsesWith","","",N,N],[5,"LLVMSetMetadata","","",N,N],[5,"LLVMConstNull","","",N,N],[5,"LLVMGetUndef","","",N,N],[5,"LLVMMDStringInContext","","",N,N],[5,"LLVMMDNodeInContext","","",N,N],[5,"LLVMAddNamedMetadataOperand","","",N,N],[5,"LLVMConstInt","","",N,N],[5,"LLVMConstIntOfArbitraryPrecision","","",N,N],[5,"LLVMConstIntGetZExtValue","","",N,N],[5,"LLVMRustConstInt128Get","","",N,N],[5,"LLVMConstRealGetDouble","","",N,N],[5,"LLVMConstStringInContext","","",N,N],[5,"LLVMConstStructInContext","","",N,N],[5,"LLVMConstArray","","",N,N],[5,"LLVMConstVector","","",N,N],[5,"LLVMConstInBoundsGEP","","",N,N],[5,"LLVMConstZExt","","",N,N],[5,"LLVMConstPtrToInt","","",N,N],[5,"LLVMConstIntToPtr","","",N,N],[5,"LLVMConstBitCast","","",N,N],[5,"LLVMConstPointerCast","","",N,N],[5,"LLVMConstExtractValue","","",N,N],[5,"LLVMIsDeclaration","","",N,N],[5,"LLVMRustGetLinkage","","",N,N],[5,"LLVMRustSetLinkage","","",N,N],[5,"LLVMSetSection","","",N,N],[5,"LLVMRustGetVisibility","","",N,N],[5,"LLVMRustSetVisibility","","",N,N],[5,"LLVMGetAlignment","","",N,N],[5,"LLVMSetAlignment","","",N,N],[5,"LLVMSetDLLStorageClass","","",N,N],[5,"LLVMIsAGlobalVariable","","",N,N],[5,"LLVMAddGlobal","","",N,N],[5,"LLVMGetNamedGlobal","","",N,N],[5,"LLVMRustGetOrInsertGlobal","","",N,N],[5,"LLVMRustInsertPrivateGlobal","","",N,N],[5,"LLVMGetFirstGlobal","","",N,N],[5,"LLVMGetNextGlobal","","",N,N],[5,"LLVMDeleteGlobal","","",N,N],[5,"LLVMGetInitializer","","",N,N],[5,"LLVMSetInitializer","","",N,N],[5,"LLVMSetThreadLocal","","",N,N],[5,"LLVMSetThreadLocalMode","","",N,N],[5,"LLVMIsGlobalConstant","","",N,N],[5,"LLVMSetGlobalConstant","","",N,N],[5,"LLVMRustGetNamedValue","","",N,N],[5,"LLVMSetTailCall","","",N,N],[5,"LLVMRustGetOrInsertFunction","","",N,N],[5,"LLVMSetFunctionCallConv","","",N,N],[5,"LLVMRustAddAlignmentAttr","","",N,N],[5,"LLVMRustAddDereferenceableAttr","","",N,N],[5,"LLVMRustAddDereferenceableOrNullAttr","","",N,N],[5,"LLVMRustAddFunctionAttribute","","",N,N],[5,"LLVMRustAddFunctionAttrStringValue","","",N,N],[5,"LLVMRustRemoveFunctionAttributes","","",N,N],[5,"LLVMCountParams","","",N,N],[5,"LLVMGetParam","","",N,N],[5,"LLVMGetBasicBlockParent","","",N,N],[5,"LLVMAppendBasicBlockInContext","","",N,N],[5,"LLVMDeleteBasicBlock","","",N,N],[5,"LLVMGetFirstBasicBlock","","",N,N],[5,"LLVMSetInstructionCallConv","","",N,N],[5,"LLVMRustAddCallSiteAttribute","","",N,N],[5,"LLVMRustAddAlignmentCallSiteAttr","","",N,N],[5,"LLVMRustAddDereferenceableCallSiteAttr","","",N,N],[5,"LLVMRustAddDereferenceableOrNullCallSiteAttr","","",N,N],[5,"LLVMSetVolatile","","",N,N],[5,"LLVMAddIncoming","","",N,N],[5,"LLVMCreateBuilderInContext","","",N,N],[5,"LLVMPositionBuilderAtEnd","","",N,N],[5,"LLVMGetInsertBlock","","",N,N],[5,"LLVMDisposeBuilder","","",N,N],[5,"LLVMSetCurrentDebugLocation","","",N,N],[5,"LLVMGetCurrentDebugLocation","","",N,N],[5,"LLVMSetInstDebugLocation","","",N,N],[5,"LLVMBuildRetVoid","","",N,N],[5,"LLVMBuildRet","","",N,N],[5,"LLVMBuildBr","","",N,N],[5,"LLVMBuildCondBr","","",N,N],[5,"LLVMBuildSwitch","","",N,N],[5,"LLVMRustBuildInvoke","","",N,N],[5,"LLVMBuildLandingPad","","",N,N],[5,"LLVMBuildResume","","",N,N],[5,"LLVMBuildUnreachable","","",N,N],[5,"LLVMRustBuildCleanupPad","","",N,N],[5,"LLVMRustBuildCleanupRet","","",N,N],[5,"LLVMRustBuildCatchPad","","",N,N],[5,"LLVMRustBuildCatchRet","","",N,N],[5,"LLVMRustBuildCatchSwitch","","",N,N],[5,"LLVMRustAddHandler","","",N,N],[5,"LLVMSetPersonalityFn","","",N,N],[5,"LLVMAddCase","","",N,N],[5,"LLVMAddClause","","",N,N],[5,"LLVMSetCleanup","","",N,N],[5,"LLVMBuildAdd","","",N,N],[5,"LLVMBuildFAdd","","",N,N],[5,"LLVMBuildSub","","",N,N],[5,"LLVMBuildFSub","","",N,N],[5,"LLVMBuildMul","","",N,N],[5,"LLVMBuildFMul","","",N,N],[5,"LLVMBuildUDiv","","",N,N],[5,"LLVMBuildExactUDiv","","",N,N],[5,"LLVMBuildSDiv","","",N,N],[5,"LLVMBuildExactSDiv","","",N,N],[5,"LLVMBuildFDiv","","",N,N],[5,"LLVMBuildURem","","",N,N],[5,"LLVMBuildSRem","","",N,N],[5,"LLVMBuildFRem","","",N,N],[5,"LLVMBuildShl","","",N,N],[5,"LLVMBuildLShr","","",N,N],[5,"LLVMBuildAShr","","",N,N],[5,"LLVMBuildAnd","","",N,N],[5,"LLVMBuildOr","","",N,N],[5,"LLVMBuildXor","","",N,N],[5,"LLVMBuildNeg","","",N,N],[5,"LLVMBuildFNeg","","",N,N],[5,"LLVMBuildNot","","",N,N],[5,"LLVMRustSetHasUnsafeAlgebra","","",N,N],[5,"LLVMBuildAlloca","","",N,N],[5,"LLVMBuildArrayAlloca","","",N,N],[5,"LLVMBuildLoad","","",N,N],[5,"LLVMBuildStore","","",N,N],[5,"LLVMBuildGEP","","",N,N],[5,"LLVMBuildInBoundsGEP","","",N,N],[5,"LLVMBuildStructGEP","","",N,N],[5,"LLVMBuildTrunc","","",N,N],[5,"LLVMBuildZExt","","",N,N],[5,"LLVMBuildSExt","","",N,N],[5,"LLVMBuildFPToUI","","",N,N],[5,"LLVMBuildFPToSI","","",N,N],[5,"LLVMBuildUIToFP","","",N,N],[5,"LLVMBuildSIToFP","","",N,N],[5,"LLVMBuildFPTrunc","","",N,N],[5,"LLVMBuildFPExt","","",N,N],[5,"LLVMBuildPtrToInt","","",N,N],[5,"LLVMBuildIntToPtr","","",N,N],[5,"LLVMBuildBitCast","","",N,N],[5,"LLVMBuildPointerCast","","",N,N],[5,"LLVMRustBuildIntCast","","",N,N],[5,"LLVMBuildICmp","","",N,N],[5,"LLVMBuildFCmp","","",N,N],[5,"LLVMBuildPhi","","",N,N],[5,"LLVMRustBuildCall","","",N,N],[5,"LLVMBuildSelect","","",N,N],[5,"LLVMBuildVAArg","","",N,N],[5,"LLVMBuildExtractElement","","",N,N],[5,"LLVMBuildInsertElement","","",N,N],[5,"LLVMBuildShuffleVector","","",N,N],[5,"LLVMBuildExtractValue","","",N,N],[5,"LLVMBuildInsertValue","","",N,N],[5,"LLVMRustBuildVectorReduceFAdd","","",N,N],[5,"LLVMRustBuildVectorReduceFMul","","",N,N],[5,"LLVMRustBuildVectorReduceAdd","","",N,N],[5,"LLVMRustBuildVectorReduceMul","","",N,N],[5,"LLVMRustBuildVectorReduceAnd","","",N,N],[5,"LLVMRustBuildVectorReduceOr","","",N,N],[5,"LLVMRustBuildVectorReduceXor","","",N,N],[5,"LLVMRustBuildVectorReduceMin","","",N,N],[5,"LLVMRustBuildVectorReduceMax","","",N,N],[5,"LLVMRustBuildVectorReduceFMin","","",N,N],[5,"LLVMRustBuildVectorReduceFMax","","",N,N],[5,"LLVMRustBuildMinNum","","",N,N],[5,"LLVMRustBuildMaxNum","","",N,N],[5,"LLVMRustBuildAtomicLoad","","",N,N],[5,"LLVMRustBuildAtomicStore","","",N,N],[5,"LLVMRustBuildAtomicCmpXchg","","",N,N],[5,"LLVMBuildAtomicRMW","","",N,N],[5,"LLVMRustBuildAtomicFence","","",N,N],[5,"LLVMWriteBitcodeToFile","","Writes a module to the specified path. Returns 0 on success.",N,N],[5,"LLVMCreatePassManager","","Creates a pass manager.",N,N],[5,"LLVMCreateFunctionPassManagerForModule","","Creates a function-by-function pass manager",N,N],[5,"LLVMDisposePassManager","","Disposes a pass manager.",N,N],[5,"LLVMRunPassManager","","Runs a pass manager on a module.",N,N],[5,"LLVMInitializePasses","","",N,N],[5,"LLVMPassManagerBuilderCreate","","",N,N],[5,"LLVMPassManagerBuilderDispose","","",N,N],[5,"LLVMPassManagerBuilderSetSizeLevel","","",N,N],[5,"LLVMPassManagerBuilderSetDisableUnrollLoops","","",N,N],[5,"LLVMPassManagerBuilderUseInlinerWithThreshold","","",N,N],[5,"LLVMPassManagerBuilderPopulateModulePassManager","","",N,N],[5,"LLVMPassManagerBuilderPopulateFunctionPassManager","","",N,N],[5,"LLVMPassManagerBuilderPopulateLTOPassManager","","",N,N],[5,"LLVMRustPassManagerBuilderPopulateThinLTOPassManager","","",N,N],[5,"LLVMCreateObjectFile","","Opens an object file.",N,N],[5,"LLVMDisposeObjectFile","","Closes an object file.",N,N],[5,"LLVMGetSections","","Enumerates the sections in an object file.",N,N],[5,"LLVMDisposeSectionIterator","","Destroys a section iterator.",N,N],[5,"LLVMIsSectionIteratorAtEnd","","Returns true if the section iterator is at the end of the section list:",N,N],[5,"LLVMMoveToNextSection","","Moves the section iterator to point to the next section.",N,N],[5,"LLVMGetSectionSize","","Returns the current section size.",N,N],[5,"LLVMGetSectionContents","","Returns the current section contents as a string buffer.",N,N],[5,"LLVMRustCreateMemoryBufferWithContentsOfFile","","Reads the given file and returns it as a memory buffer. Use LLVMDisposeMemoryBuffer() to get rid of it.",N,N],[5,"LLVMStartMultithreaded","","",N,N],[5,"LLVMRustGetLastError","","Returns a string describing the last error caused by an LLVMRust* call.",N,N],[5,"LLVMRustPrintPassTimings","","Print the pass timings since static dtors aren't picking them up.",N,N],[5,"LLVMStructCreateNamed","","",N,N],[5,"LLVMStructSetBody","","",N,N],[5,"LLVMRustInlineAsm","","Prepares inline assembly.",N,N],[5,"LLVMRustDebugMetadataVersion","","",N,N],[5,"LLVMRustVersionMajor","","",N,N],[5,"LLVMRustVersionMinor","","",N,N],[5,"LLVMRustAddModuleFlag","","",N,N],[5,"LLVMRustMetadataAsValue","","",N,N],[5,"LLVMRustDIBuilderCreate","","",N,N],[5,"LLVMRustDIBuilderDispose","","",N,N],[5,"LLVMRustDIBuilderFinalize","","",N,N],[5,"LLVMRustDIBuilderCreateCompileUnit","","",N,N],[5,"LLVMRustDIBuilderCreateFile","","",N,N],[5,"LLVMRustDIBuilderCreateSubroutineType","","",N,N],[5,"LLVMRustDIBuilderCreateFunction","","",N,N],[5,"LLVMRustDIBuilderCreateBasicType","","",N,N],[5,"LLVMRustDIBuilderCreatePointerType","","",N,N],[5,"LLVMRustDIBuilderCreateStructType","","",N,N],[5,"LLVMRustDIBuilderCreateMemberType","","",N,N],[5,"LLVMRustDIBuilderCreateLexicalBlock","","",N,N],[5,"LLVMRustDIBuilderCreateLexicalBlockFile","","",N,N],[5,"LLVMRustDIBuilderCreateStaticVariable","","",N,N],[5,"LLVMRustDIBuilderCreateVariable","","",N,N],[5,"LLVMRustDIBuilderCreateArrayType","","",N,N],[5,"LLVMRustDIBuilderGetOrCreateSubrange","","",N,N],[5,"LLVMRustDIBuilderGetOrCreateArray","","",N,N],[5,"LLVMRustDIBuilderInsertDeclareAtEnd","","",N,N],[5,"LLVMRustDIBuilderCreateEnumerator","","",N,N],[5,"LLVMRustDIBuilderCreateEnumerationType","","",N,N],[5,"LLVMRustDIBuilderCreateUnionType","","",N,N],[5,"LLVMSetUnnamedAddr","","",N,N],[5,"LLVMRustDIBuilderCreateTemplateTypeParameter","","",N,N],[5,"LLVMRustDIBuilderCreateNameSpace","","",N,N],[5,"LLVMRustDICompositeTypeSetTypeArray","","",N,N],[5,"LLVMRustDIBuilderCreateDebugLocation","","",N,N],[5,"LLVMRustDIBuilderCreateOpDeref","","",N,N],[5,"LLVMRustDIBuilderCreateOpPlusUconst","","",N,N],[5,"LLVMRustWriteTypeToString","","",N,N],[5,"LLVMRustWriteValueToString","","",N,N],[5,"LLVMIsAConstantInt","","",N,N],[5,"LLVMIsAConstantFP","","",N,N],[5,"LLVMRustPassKind","","",N,N],[5,"LLVMRustFindAndCreatePass","","",N,N],[5,"LLVMRustAddPass","","",N,N],[5,"LLVMRustHasFeature","","",N,N],[5,"LLVMRustPrintTargetCPUs","","",N,N],[5,"LLVMRustPrintTargetFeatures","","",N,N],[5,"LLVMRustGetHostCPUName","","",N,N],[5,"LLVMRustCreateTargetMachine","","",N,N],[5,"LLVMRustDisposeTargetMachine","","",N,N],[5,"LLVMRustAddAnalysisPasses","","",N,N],[5,"LLVMRustAddBuilderLibraryInfo","","",N,N],[5,"LLVMRustConfigurePassManagerBuilder","","",N,N],[5,"LLVMRustAddLibraryInfo","","",N,N],[5,"LLVMRustRunFunctionPassManager","","",N,N],[5,"LLVMRustWriteOutputFile","","",N,N],[5,"LLVMRustPrintModule","","",N,N],[5,"LLVMRustSetLLVMOptions","","",N,N],[5,"LLVMRustPrintPasses","","",N,N],[5,"LLVMRustSetNormalizedTarget","","",N,N],[5,"LLVMRustAddAlwaysInlinePass","","",N,N],[5,"LLVMRustRunRestrictionPass","","",N,N],[5,"LLVMRustMarkAllFunctionsNounwind","","",N,N],[5,"LLVMRustOpenArchive","","",N,N],[5,"LLVMRustArchiveIteratorNew","","",N,N],[5,"LLVMRustArchiveIteratorNext","","",N,N],[5,"LLVMRustArchiveChildName","","",N,N],[5,"LLVMRustArchiveChildData","","",N,N],[5,"LLVMRustArchiveChildFree","","",N,N],[5,"LLVMRustArchiveIteratorFree","","",N,N],[5,"LLVMRustDestroyArchive","","",N,N],[5,"LLVMRustGetSectionName","","",N,N],[5,"LLVMRustWriteTwineToString","","",N,N],[5,"LLVMContextSetDiagnosticHandler","","",N,N],[5,"LLVMRustUnpackOptimizationDiagnostic","","",N,N],[5,"LLVMRustUnpackInlineAsmDiagnostic","","",N,N],[5,"LLVMRustWriteDiagnosticInfoToString","","",N,N],[5,"LLVMRustGetDiagInfoKind","","",N,N],[5,"LLVMRustSetInlineAsmDiagnosticHandler","","",N,N],[5,"LLVMRustWriteSMDiagnosticToString","","",N,N],[5,"LLVMRustWriteArchive","","",N,N],[5,"LLVMRustArchiveMemberNew","","",N,N],[5,"LLVMRustArchiveMemberFree","","",N,N],[5,"LLVMRustSetDataLayoutFromTargetMachine","","",N,N],[5,"LLVMRustBuildOperandBundleDef","","",N,N],[5,"LLVMRustFreeOperandBundleDef","","",N,N],[5,"LLVMRustPositionBuilderAtStart","","",N,N],[5,"LLVMRustSetComdat","","",N,N],[5,"LLVMRustUnsetComdat","","",N,N],[5,"LLVMRustSetModulePIELevel","","",N,N],[5,"LLVMRustModuleBufferCreate","","",N,N],[5,"LLVMRustModuleBufferPtr","","",N,N],[5,"LLVMRustModuleBufferLen","","",N,N],[5,"LLVMRustModuleBufferFree","","",N,N],[5,"LLVMRustModuleCost","","",N,N],[5,"LLVMRustThinLTOAvailable","","",N,N],[5,"LLVMRustPGOAvailable","","",N,N],[5,"LLVMRustThinLTOBufferCreate","","",N,N],[5,"LLVMRustThinLTOBufferFree","","",N,N],[5,"LLVMRustThinLTOBufferPtr","","",N,N],[5,"LLVMRustThinLTOBufferLen","","",N,N],[5,"LLVMRustCreateThinLTOData","","",N,N],[5,"LLVMRustPrepareThinLTORename","","",N,N],[5,"LLVMRustPrepareThinLTOResolveWeak","","",N,N],[5,"LLVMRustPrepareThinLTOInternalize","","",N,N],[5,"LLVMRustPrepareThinLTOImport","","",N,N],[5,"LLVMRustGetThinLTOModuleImports","","",N,N],[5,"LLVMRustFreeThinLTOData","","",N,N],[5,"LLVMRustParseBitcodeForThinLTO","","",N,N],[5,"LLVMRustThinLTOGetDICompileUnit","","",N,N],[5,"LLVMRustThinLTOPatchDICompileUnit","","",N,N],[5,"LLVMRustLinkerNew","","",N,N],[5,"LLVMRustLinkerAdd","","",N,N],[5,"LLVMRustLinkerFree","","",N,N],[0,"archive_ro","","A wrapper around LLVM's archive (.a) code",N,N],[3,"ArchiveRO","rustc_codegen_llvm::llvm::archive_ro","",N,N],[12,"raw","","",136,N],[3,"Iter","","",N,N],[12,"raw","","",137,N],[3,"Child","","",N,N],[12,"raw","","",138,N],[11,"open","","Opens a static archive for read-only purposes. This is more optimized than the `open` method because it uses LLVM's internal `Archive` class rather than shelling out to `ar` for everything.",136,[[["path"]],["result",["archivero","string"]]]],[11,"iter","","",136,[[["self"]],["iter"]]],[11,"drop","","",136,[[["self"]]]],[11,"next","","",137,[[["self"]],["option",["result"]]]],[11,"drop","","",137,[[["self"]]]],[11,"name","","",138,[[["self"]],["option",["str"]]]],[11,"data","","",138,N],[11,"drop","","",138,[[["self"]]]],[0,"diagnostic","rustc_codegen_llvm::llvm","LLVM diagnostic reports.",N,N],[3,"OptimizationDiagnostic","rustc_codegen_llvm::llvm::diagnostic","",N,N],[12,"kind","","",139,N],[12,"pass_name","","",139,N],[12,"function","","",139,N],[12,"line","","",139,N],[12,"column","","",139,N],[12,"filename","","",139,N],[12,"message","","",139,N],[3,"InlineAsmDiagnostic","","",N,N],[12,"cookie","","",140,N],[12,"message","","",140,N],[12,"instruction","","",140,N],[4,"OptimizationDiagnosticKind","","",N,N],[13,"OptimizationRemark","","",141,N],[13,"OptimizationMissed","","",141,N],[13,"OptimizationAnalysis","","",141,N],[13,"OptimizationAnalysisFPCommute","","",141,N],[13,"OptimizationAnalysisAliasing","","",141,N],[13,"OptimizationFailure","","",141,N],[13,"OptimizationRemarkOther","","",141,N],[4,"Diagnostic","","",N,N],[13,"Optimization","","",142,N],[13,"InlineAsm","","",142,N],[13,"PGO","","",142,N],[13,"Linker","","",142,N],[13,"UnknownDiagnostic","","LLVM has other types that we do not wrap here.",142,N],[11,"clone","","",141,[[["self"]],["optimizationdiagnostickind"]]],[11,"describe","","",141,[[["self"]],["str"]]],[11,"unpack","","",139,[[["optimizationdiagnostickind"],["diagnosticinfo"]],["self"]]],[11,"clone","","",140,[[["self"]],["inlineasmdiagnostic"]]],[11,"unpack","","",140,[[["diagnosticinfo"]],["self"]]],[11,"unpack","","",142,[[["diagnosticinfo"]],["self"]]],[0,"ffi","rustc_codegen_llvm::llvm","",N,N],[3,"ThinLTOModule","rustc_codegen_llvm::llvm::ffi","LLVMRustThinLTOModule",N,N],[12,"identifier","","",99,N],[12,"data","","",99,N],[12,"len","","",99,N],[3,"InvariantOpaque","","",N,N],[12,"_marker","","",143,N],[12,"_opaque","","",143,N],[3,"Builder","","",N,N],[12,"0","","",100,N],[3,"PassManager","","",N,N],[12,"0","","",101,N],[3,"SectionIterator","","",N,N],[12,"0","","",102,N],[3,"ArchiveIterator","","",N,N],[12,"0","","",103,N],[3,"ArchiveChild","","",N,N],[12,"0","","",104,N],[3,"RustArchiveMember","","",N,N],[12,"0","","",105,N],[3,"OperandBundleDef","","",N,N],[12,"0","","",106,N],[3,"Linker","","",N,N],[12,"0","","",107,N],[4,"LLVMRustResult","","",N,N],[13,"Success","","",112,N],[13,"Failure","","",112,N],[4,"CallConv","","LLVM CallingConv::ID. Should we wrap this?",N,N],[13,"CCallConv","","",113,N],[13,"FastCallConv","","",113,N],[13,"ColdCallConv","","",113,N],[13,"X86StdcallCallConv","","",113,N],[13,"X86FastcallCallConv","","",113,N],[13,"ArmAapcsCallConv","","",113,N],[13,"Msp430Intr","","",113,N],[13,"X86_ThisCall","","",113,N],[13,"PtxKernel","","",113,N],[13,"X86_64_SysV","","",113,N],[13,"X86_64_Win64","","",113,N],[13,"X86_VectorCall","","",113,N],[13,"X86_Intr","","",113,N],[13,"AmdGpuKernel","","",113,N],[4,"Linkage","","LLVMRustLinkage",N,N],[13,"ExternalLinkage","","",114,N],[13,"AvailableExternallyLinkage","","",114,N],[13,"LinkOnceAnyLinkage","","",114,N],[13,"LinkOnceODRLinkage","","",114,N],[13,"WeakAnyLinkage","","",114,N],[13,"WeakODRLinkage","","",114,N],[13,"AppendingLinkage","","",114,N],[13,"InternalLinkage","","",114,N],[13,"PrivateLinkage","","",114,N],[13,"ExternalWeakLinkage","","",114,N],[13,"CommonLinkage","","",114,N],[4,"Visibility","","",N,N],[13,"Default","","",115,N],[13,"Hidden","","",115,N],[13,"Protected","","",115,N],[4,"DLLStorageClass","","LLVMDLLStorageClass",N,N],[13,"Default","","",116,N],[13,"DllImport","","",116,N],[13,"DllExport","","",116,N],[4,"Attribute","","Matches LLVMRustAttribute in rustllvm.h Semantically a subset of the C++ enum llvm::Attribute::AttrKind, though it is not ABI compatible (since it's a C++ enum)",N,N],[13,"AlwaysInline","","",117,N],[13,"ByVal","","",117,N],[13,"Cold","","",117,N],[13,"InlineHint","","",117,N],[13,"MinSize","","",117,N],[13,"Naked","","",117,N],[13,"NoAlias","","",117,N],[13,"NoCapture","","",117,N],[13,"NoInline","","",117,N],[13,"NonNull","","",117,N],[13,"NoRedZone","","",117,N],[13,"NoReturn","","",117,N],[13,"NoUnwind","","",117,N],[13,"OptimizeForSize","","",117,N],[13,"ReadOnly","","",117,N],[13,"SExt","","",117,N],[13,"StructRet","","",117,N],[13,"UWTable","","",117,N],[13,"ZExt","","",117,N],[13,"InReg","","",117,N],[13,"SanitizeThread","","",117,N],[13,"SanitizeAddress","","",117,N],[13,"SanitizeMemory","","",117,N],[4,"IntPredicate","","LLVMIntPredicate",N,N],[13,"IntEQ","","",118,N],[13,"IntNE","","",118,N],[13,"IntUGT","","",118,N],[13,"IntUGE","","",118,N],[13,"IntULT","","",118,N],[13,"IntULE","","",118,N],[13,"IntSGT","","",118,N],[13,"IntSGE","","",118,N],[13,"IntSLT","","",118,N],[13,"IntSLE","","",118,N],[4,"RealPredicate","","LLVMRealPredicate",N,N],[13,"RealPredicateFalse","","",119,N],[13,"RealOEQ","","",119,N],[13,"RealOGT","","",119,N],[13,"RealOGE","","",119,N],[13,"RealOLT","","",119,N],[13,"RealOLE","","",119,N],[13,"RealONE","","",119,N],[13,"RealORD","","",119,N],[13,"RealUNO","","",119,N],[13,"RealUEQ","","",119,N],[13,"RealUGT","","",119,N],[13,"RealUGE","","",119,N],[13,"RealULT","","",119,N],[13,"RealULE","","",119,N],[13,"RealUNE","","",119,N],[13,"RealPredicateTrue","","",119,N],[4,"TypeKind","","LLVMTypeKind",N,N],[13,"Void","","",120,N],[13,"Half","","",120,N],[13,"Float","","",120,N],[13,"Double","","",120,N],[13,"X86_FP80","","",120,N],[13,"FP128","","",120,N],[13,"PPC_FP128","","",120,N],[13,"Label","","",120,N],[13,"Integer","","",120,N],[13,"Function","","",120,N],[13,"Struct","","",120,N],[13,"Array","","",120,N],[13,"Pointer","","",120,N],[13,"Vector","","",120,N],[13,"Metadata","","",120,N],[13,"X86_MMX","","",120,N],[13,"Token","","",120,N],[4,"AtomicRmwBinOp","","LLVMAtomicRmwBinOp",N,N],[13,"AtomicXchg","","",121,N],[13,"AtomicAdd","","",121,N],[13,"AtomicSub","","",121,N],[13,"AtomicAnd","","",121,N],[13,"AtomicNand","","",121,N],[13,"AtomicOr","","",121,N],[13,"AtomicXor","","",121,N],[13,"AtomicMax","","",121,N],[13,"AtomicMin","","",121,N],[13,"AtomicUMax","","",121,N],[13,"AtomicUMin","","",121,N],[4,"AtomicOrdering","","LLVMAtomicOrdering",N,N],[13,"NotAtomic","","",122,N],[13,"Unordered","","",122,N],[13,"Monotonic","","",122,N],[13,"Acquire","","",122,N],[13,"Release","","",122,N],[13,"AcquireRelease","","",122,N],[13,"SequentiallyConsistent","","",122,N],[4,"SynchronizationScope","","LLVMRustSynchronizationScope",N,N],[13,"Other","","",123,N],[13,"SingleThread","","",123,N],[13,"CrossThread","","",123,N],[4,"FileType","","LLVMRustFileType",N,N],[13,"Other","","",124,N],[13,"AssemblyFile","","",124,N],[13,"ObjectFile","","",124,N],[4,"MetadataType","","LLVMMetadataType",N,N],[13,"MD_dbg","","",125,N],[13,"MD_tbaa","","",125,N],[13,"MD_prof","","",125,N],[13,"MD_fpmath","","",125,N],[13,"MD_range","","",125,N],[13,"MD_tbaa_struct","","",125,N],[13,"MD_invariant_load","","",125,N],[13,"MD_alias_scope","","",125,N],[13,"MD_noalias","","",125,N],[13,"MD_nontemporal","","",125,N],[13,"MD_mem_parallel_loop_access","","",125,N],[13,"MD_nonnull","","",125,N],[4,"AsmDialect","","LLVMRustAsmDialect",N,N],[13,"Other","","",126,N],[13,"Att","","",126,N],[13,"Intel","","",126,N],[4,"CodeGenOptLevel","","LLVMRustCodeGenOptLevel",N,N],[13,"Other","","",127,N],[13,"None","","",127,N],[13,"Less","","",127,N],[13,"Default","","",127,N],[13,"Aggressive","","",127,N],[4,"RelocMode","","LLVMRelocMode",N,N],[13,"Default","","",128,N],[13,"Static","","",128,N],[13,"PIC","","",128,N],[13,"DynamicNoPic","","",128,N],[13,"ROPI","","",128,N],[13,"RWPI","","",128,N],[13,"ROPI_RWPI","","",128,N],[4,"CodeModel","","LLVMRustCodeModel",N,N],[13,"Other","","",129,N],[13,"Small","","",129,N],[13,"Kernel","","",129,N],[13,"Medium","","",129,N],[13,"Large","","",129,N],[13,"None","","",129,N],[4,"DiagnosticKind","","LLVMRustDiagnosticKind",N,N],[13,"Other","","",130,N],[13,"InlineAsm","","",130,N],[13,"StackSize","","",130,N],[13,"DebugMetadataVersion","","",130,N],[13,"SampleProfile","","",130,N],[13,"OptimizationRemark","","",130,N],[13,"OptimizationRemarkMissed","","",130,N],[13,"OptimizationRemarkAnalysis","","",130,N],[13,"OptimizationRemarkAnalysisFPCommute","","",130,N],[13,"OptimizationRemarkAnalysisAliasing","","",130,N],[13,"OptimizationRemarkOther","","",130,N],[13,"OptimizationFailure","","",130,N],[13,"PGOProfile","","",130,N],[13,"Linker","","",130,N],[4,"ArchiveKind","","LLVMRustArchiveKind",N,N],[13,"Other","","",131,N],[13,"K_GNU","","",131,N],[13,"K_BSD","","",131,N],[13,"K_COFF","","",131,N],[4,"PassKind","","LLVMRustPassKind",N,N],[13,"Other","","",132,N],[13,"Function","","",132,N],[13,"Module","","",132,N],[4,"ThreadLocalMode","","LLVMThreadLocalMode",N,N],[13,"NotThreadLocal","","",133,N],[13,"GeneralDynamic","","",133,N],[13,"LocalDynamic","","",133,N],[13,"InitialExec","","",133,N],[13,"LocalExec","","",133,N],[20,"ThinLTOData","","",N,N],[20,"ThinLTOBuffer","","",N,N],[20,"Opaque","","",N,N],[20,"Module","","",N,N],[20,"Context","","",N,N],[20,"Type","","",N,N],[20,"Value","","",N,N],[20,"Metadata","","",N,N],[20,"BasicBlock","","",N,N],[20,"MemoryBuffer","","",N,N],[20,"PassManagerBuilder","","",N,N],[20,"ObjectFile","","",N,N],[20,"Pass","","",N,N],[20,"TargetMachine","","",N,N],[20,"Archive","","",N,N],[20,"Twine","","",N,N],[20,"DiagnosticInfo","","",N,N],[20,"SMDiagnostic","","",N,N],[20,"ModuleBuffer","","",N,N],[5,"LLVMRustContextCreate","","",N,N],[5,"LLVMContextDispose","","",N,N],[5,"LLVMGetMDKindIDInContext","","",N,N],[5,"LLVMModuleCreateWithNameInContext","","",N,N],[5,"LLVMGetModuleContext","","",N,N],[5,"LLVMCloneModule","","",N,N],[5,"LLVMGetDataLayout","","Data layout. See Module::getDataLayout.",N,N],[5,"LLVMSetDataLayout","","",N,N],[5,"LLVMSetModuleInlineAsm","","See Module::setModuleInlineAsm.",N,N],[5,"LLVMRustAppendModuleInlineAsm","","",N,N],[5,"LLVMRustGetTypeKind","","See llvm::LLVMTypeKind::getTypeID.",N,N],[5,"LLVMInt1TypeInContext","","",N,N],[5,"LLVMInt8TypeInContext","","",N,N],[5,"LLVMInt16TypeInContext","","",N,N],[5,"LLVMInt32TypeInContext","","",N,N],[5,"LLVMInt64TypeInContext","","",N,N],[5,"LLVMIntTypeInContext","","",N,N],[5,"LLVMGetIntTypeWidth","","",N,N],[5,"LLVMFloatTypeInContext","","",N,N],[5,"LLVMDoubleTypeInContext","","",N,N],[5,"LLVMFunctionType","","",N,N],[5,"LLVMCountParamTypes","","",N,N],[5,"LLVMGetParamTypes","","",N,N],[5,"LLVMStructTypeInContext","","",N,N],[5,"LLVMRustArrayType","","",N,N],[5,"LLVMPointerType","","",N,N],[5,"LLVMVectorType","","",N,N],[5,"LLVMGetElementType","","",N,N],[5,"LLVMGetVectorSize","","",N,N],[5,"LLVMVoidTypeInContext","","",N,N],[5,"LLVMX86MMXTypeInContext","","",N,N],[5,"LLVMRustMetadataTypeInContext","","",N,N],[5,"LLVMTypeOf","","",N,N],[5,"LLVMGetValueName","","",N,N],[5,"LLVMSetValueName","","",N,N],[5,"LLVMReplaceAllUsesWith","","",N,N],[5,"LLVMSetMetadata","","",N,N],[5,"LLVMConstNull","","",N,N],[5,"LLVMGetUndef","","",N,N],[5,"LLVMMDStringInContext","","",N,N],[5,"LLVMMDNodeInContext","","",N,N],[5,"LLVMAddNamedMetadataOperand","","",N,N],[5,"LLVMConstInt","","",N,N],[5,"LLVMConstIntOfArbitraryPrecision","","",N,N],[5,"LLVMConstIntGetZExtValue","","",N,N],[5,"LLVMRustConstInt128Get","","",N,N],[5,"LLVMConstRealGetDouble","","",N,N],[5,"LLVMConstStringInContext","","",N,N],[5,"LLVMConstStructInContext","","",N,N],[5,"LLVMConstArray","","",N,N],[5,"LLVMConstVector","","",N,N],[5,"LLVMConstInBoundsGEP","","",N,N],[5,"LLVMConstZExt","","",N,N],[5,"LLVMConstPtrToInt","","",N,N],[5,"LLVMConstIntToPtr","","",N,N],[5,"LLVMConstBitCast","","",N,N],[5,"LLVMConstPointerCast","","",N,N],[5,"LLVMConstExtractValue","","",N,N],[5,"LLVMIsDeclaration","","",N,N],[5,"LLVMRustGetLinkage","","",N,N],[5,"LLVMRustSetLinkage","","",N,N],[5,"LLVMSetSection","","",N,N],[5,"LLVMRustGetVisibility","","",N,N],[5,"LLVMRustSetVisibility","","",N,N],[5,"LLVMGetAlignment","","",N,N],[5,"LLVMSetAlignment","","",N,N],[5,"LLVMSetDLLStorageClass","","",N,N],[5,"LLVMIsAGlobalVariable","","",N,N],[5,"LLVMAddGlobal","","",N,N],[5,"LLVMGetNamedGlobal","","",N,N],[5,"LLVMRustGetOrInsertGlobal","","",N,N],[5,"LLVMRustInsertPrivateGlobal","","",N,N],[5,"LLVMGetFirstGlobal","","",N,N],[5,"LLVMGetNextGlobal","","",N,N],[5,"LLVMDeleteGlobal","","",N,N],[5,"LLVMGetInitializer","","",N,N],[5,"LLVMSetInitializer","","",N,N],[5,"LLVMSetThreadLocal","","",N,N],[5,"LLVMSetThreadLocalMode","","",N,N],[5,"LLVMIsGlobalConstant","","",N,N],[5,"LLVMSetGlobalConstant","","",N,N],[5,"LLVMRustGetNamedValue","","",N,N],[5,"LLVMSetTailCall","","",N,N],[5,"LLVMRustGetOrInsertFunction","","",N,N],[5,"LLVMSetFunctionCallConv","","",N,N],[5,"LLVMRustAddAlignmentAttr","","",N,N],[5,"LLVMRustAddDereferenceableAttr","","",N,N],[5,"LLVMRustAddDereferenceableOrNullAttr","","",N,N],[5,"LLVMRustAddFunctionAttribute","","",N,N],[5,"LLVMRustAddFunctionAttrStringValue","","",N,N],[5,"LLVMRustRemoveFunctionAttributes","","",N,N],[5,"LLVMCountParams","","",N,N],[5,"LLVMGetParam","","",N,N],[5,"LLVMGetBasicBlockParent","","",N,N],[5,"LLVMAppendBasicBlockInContext","","",N,N],[5,"LLVMDeleteBasicBlock","","",N,N],[5,"LLVMGetFirstBasicBlock","","",N,N],[5,"LLVMSetInstructionCallConv","","",N,N],[5,"LLVMRustAddCallSiteAttribute","","",N,N],[5,"LLVMRustAddAlignmentCallSiteAttr","","",N,N],[5,"LLVMRustAddDereferenceableCallSiteAttr","","",N,N],[5,"LLVMRustAddDereferenceableOrNullCallSiteAttr","","",N,N],[5,"LLVMSetVolatile","","",N,N],[5,"LLVMAddIncoming","","",N,N],[5,"LLVMCreateBuilderInContext","","",N,N],[5,"LLVMPositionBuilderAtEnd","","",N,N],[5,"LLVMGetInsertBlock","","",N,N],[5,"LLVMDisposeBuilder","","",N,N],[5,"LLVMSetCurrentDebugLocation","","",N,N],[5,"LLVMGetCurrentDebugLocation","","",N,N],[5,"LLVMSetInstDebugLocation","","",N,N],[5,"LLVMBuildRetVoid","","",N,N],[5,"LLVMBuildRet","","",N,N],[5,"LLVMBuildBr","","",N,N],[5,"LLVMBuildCondBr","","",N,N],[5,"LLVMBuildSwitch","","",N,N],[5,"LLVMRustBuildInvoke","","",N,N],[5,"LLVMBuildLandingPad","","",N,N],[5,"LLVMBuildResume","","",N,N],[5,"LLVMBuildUnreachable","","",N,N],[5,"LLVMRustBuildCleanupPad","","",N,N],[5,"LLVMRustBuildCleanupRet","","",N,N],[5,"LLVMRustBuildCatchPad","","",N,N],[5,"LLVMRustBuildCatchRet","","",N,N],[5,"LLVMRustBuildCatchSwitch","","",N,N],[5,"LLVMRustAddHandler","","",N,N],[5,"LLVMSetPersonalityFn","","",N,N],[5,"LLVMAddCase","","",N,N],[5,"LLVMAddClause","","",N,N],[5,"LLVMSetCleanup","","",N,N],[5,"LLVMBuildAdd","","",N,N],[5,"LLVMBuildFAdd","","",N,N],[5,"LLVMBuildSub","","",N,N],[5,"LLVMBuildFSub","","",N,N],[5,"LLVMBuildMul","","",N,N],[5,"LLVMBuildFMul","","",N,N],[5,"LLVMBuildUDiv","","",N,N],[5,"LLVMBuildExactUDiv","","",N,N],[5,"LLVMBuildSDiv","","",N,N],[5,"LLVMBuildExactSDiv","","",N,N],[5,"LLVMBuildFDiv","","",N,N],[5,"LLVMBuildURem","","",N,N],[5,"LLVMBuildSRem","","",N,N],[5,"LLVMBuildFRem","","",N,N],[5,"LLVMBuildShl","","",N,N],[5,"LLVMBuildLShr","","",N,N],[5,"LLVMBuildAShr","","",N,N],[5,"LLVMBuildAnd","","",N,N],[5,"LLVMBuildOr","","",N,N],[5,"LLVMBuildXor","","",N,N],[5,"LLVMBuildNeg","","",N,N],[5,"LLVMBuildFNeg","","",N,N],[5,"LLVMBuildNot","","",N,N],[5,"LLVMRustSetHasUnsafeAlgebra","","",N,N],[5,"LLVMBuildAlloca","","",N,N],[5,"LLVMBuildArrayAlloca","","",N,N],[5,"LLVMBuildLoad","","",N,N],[5,"LLVMBuildStore","","",N,N],[5,"LLVMBuildGEP","","",N,N],[5,"LLVMBuildInBoundsGEP","","",N,N],[5,"LLVMBuildStructGEP","","",N,N],[5,"LLVMBuildTrunc","","",N,N],[5,"LLVMBuildZExt","","",N,N],[5,"LLVMBuildSExt","","",N,N],[5,"LLVMBuildFPToUI","","",N,N],[5,"LLVMBuildFPToSI","","",N,N],[5,"LLVMBuildUIToFP","","",N,N],[5,"LLVMBuildSIToFP","","",N,N],[5,"LLVMBuildFPTrunc","","",N,N],[5,"LLVMBuildFPExt","","",N,N],[5,"LLVMBuildPtrToInt","","",N,N],[5,"LLVMBuildIntToPtr","","",N,N],[5,"LLVMBuildBitCast","","",N,N],[5,"LLVMBuildPointerCast","","",N,N],[5,"LLVMRustBuildIntCast","","",N,N],[5,"LLVMBuildICmp","","",N,N],[5,"LLVMBuildFCmp","","",N,N],[5,"LLVMBuildPhi","","",N,N],[5,"LLVMRustBuildCall","","",N,N],[5,"LLVMBuildSelect","","",N,N],[5,"LLVMBuildVAArg","","",N,N],[5,"LLVMBuildExtractElement","","",N,N],[5,"LLVMBuildInsertElement","","",N,N],[5,"LLVMBuildShuffleVector","","",N,N],[5,"LLVMBuildExtractValue","","",N,N],[5,"LLVMBuildInsertValue","","",N,N],[5,"LLVMRustBuildVectorReduceFAdd","","",N,N],[5,"LLVMRustBuildVectorReduceFMul","","",N,N],[5,"LLVMRustBuildVectorReduceAdd","","",N,N],[5,"LLVMRustBuildVectorReduceMul","","",N,N],[5,"LLVMRustBuildVectorReduceAnd","","",N,N],[5,"LLVMRustBuildVectorReduceOr","","",N,N],[5,"LLVMRustBuildVectorReduceXor","","",N,N],[5,"LLVMRustBuildVectorReduceMin","","",N,N],[5,"LLVMRustBuildVectorReduceMax","","",N,N],[5,"LLVMRustBuildVectorReduceFMin","","",N,N],[5,"LLVMRustBuildVectorReduceFMax","","",N,N],[5,"LLVMRustBuildMinNum","","",N,N],[5,"LLVMRustBuildMaxNum","","",N,N],[5,"LLVMRustBuildAtomicLoad","","",N,N],[5,"LLVMRustBuildAtomicStore","","",N,N],[5,"LLVMRustBuildAtomicCmpXchg","","",N,N],[5,"LLVMBuildAtomicRMW","","",N,N],[5,"LLVMRustBuildAtomicFence","","",N,N],[5,"LLVMWriteBitcodeToFile","","Writes a module to the specified path. Returns 0 on success.",N,N],[5,"LLVMCreatePassManager","","Creates a pass manager.",N,N],[5,"LLVMCreateFunctionPassManagerForModule","","Creates a function-by-function pass manager",N,N],[5,"LLVMDisposePassManager","","Disposes a pass manager.",N,N],[5,"LLVMRunPassManager","","Runs a pass manager on a module.",N,N],[5,"LLVMInitializePasses","","",N,N],[5,"LLVMPassManagerBuilderCreate","","",N,N],[5,"LLVMPassManagerBuilderDispose","","",N,N],[5,"LLVMPassManagerBuilderSetSizeLevel","","",N,N],[5,"LLVMPassManagerBuilderSetDisableUnrollLoops","","",N,N],[5,"LLVMPassManagerBuilderUseInlinerWithThreshold","","",N,N],[5,"LLVMPassManagerBuilderPopulateModulePassManager","","",N,N],[5,"LLVMPassManagerBuilderPopulateFunctionPassManager","","",N,N],[5,"LLVMPassManagerBuilderPopulateLTOPassManager","","",N,N],[5,"LLVMRustPassManagerBuilderPopulateThinLTOPassManager","","",N,N],[5,"LLVMCreateObjectFile","","Opens an object file.",N,N],[5,"LLVMDisposeObjectFile","","Closes an object file.",N,N],[5,"LLVMGetSections","","Enumerates the sections in an object file.",N,N],[5,"LLVMDisposeSectionIterator","","Destroys a section iterator.",N,N],[5,"LLVMIsSectionIteratorAtEnd","","Returns true if the section iterator is at the end of the section list:",N,N],[5,"LLVMMoveToNextSection","","Moves the section iterator to point to the next section.",N,N],[5,"LLVMGetSectionSize","","Returns the current section size.",N,N],[5,"LLVMGetSectionContents","","Returns the current section contents as a string buffer.",N,N],[5,"LLVMRustCreateMemoryBufferWithContentsOfFile","","Reads the given file and returns it as a memory buffer. Use LLVMDisposeMemoryBuffer() to get rid of it.",N,N],[5,"LLVMStartMultithreaded","","",N,N],[5,"LLVMRustGetLastError","","Returns a string describing the last error caused by an LLVMRust* call.",N,N],[5,"LLVMRustPrintPassTimings","","Print the pass timings since static dtors aren't picking them up.",N,N],[5,"LLVMStructCreateNamed","","",N,N],[5,"LLVMStructSetBody","","",N,N],[5,"LLVMRustInlineAsm","","Prepares inline assembly.",N,N],[5,"LLVMRustDebugMetadataVersion","","",N,N],[5,"LLVMRustVersionMajor","","",N,N],[5,"LLVMRustVersionMinor","","",N,N],[5,"LLVMRustAddModuleFlag","","",N,N],[5,"LLVMRustMetadataAsValue","","",N,N],[5,"LLVMRustDIBuilderCreate","","",N,N],[5,"LLVMRustDIBuilderDispose","","",N,N],[5,"LLVMRustDIBuilderFinalize","","",N,N],[5,"LLVMRustDIBuilderCreateCompileUnit","","",N,N],[5,"LLVMRustDIBuilderCreateFile","","",N,N],[5,"LLVMRustDIBuilderCreateSubroutineType","","",N,N],[5,"LLVMRustDIBuilderCreateFunction","","",N,N],[5,"LLVMRustDIBuilderCreateBasicType","","",N,N],[5,"LLVMRustDIBuilderCreatePointerType","","",N,N],[5,"LLVMRustDIBuilderCreateStructType","","",N,N],[5,"LLVMRustDIBuilderCreateMemberType","","",N,N],[5,"LLVMRustDIBuilderCreateLexicalBlock","","",N,N],[5,"LLVMRustDIBuilderCreateLexicalBlockFile","","",N,N],[5,"LLVMRustDIBuilderCreateStaticVariable","","",N,N],[5,"LLVMRustDIBuilderCreateVariable","","",N,N],[5,"LLVMRustDIBuilderCreateArrayType","","",N,N],[5,"LLVMRustDIBuilderGetOrCreateSubrange","","",N,N],[5,"LLVMRustDIBuilderGetOrCreateArray","","",N,N],[5,"LLVMRustDIBuilderInsertDeclareAtEnd","","",N,N],[5,"LLVMRustDIBuilderCreateEnumerator","","",N,N],[5,"LLVMRustDIBuilderCreateEnumerationType","","",N,N],[5,"LLVMRustDIBuilderCreateUnionType","","",N,N],[5,"LLVMSetUnnamedAddr","","",N,N],[5,"LLVMRustDIBuilderCreateTemplateTypeParameter","","",N,N],[5,"LLVMRustDIBuilderCreateNameSpace","","",N,N],[5,"LLVMRustDICompositeTypeSetTypeArray","","",N,N],[5,"LLVMRustDIBuilderCreateDebugLocation","","",N,N],[5,"LLVMRustDIBuilderCreateOpDeref","","",N,N],[5,"LLVMRustDIBuilderCreateOpPlusUconst","","",N,N],[5,"LLVMRustWriteTypeToString","","",N,N],[5,"LLVMRustWriteValueToString","","",N,N],[5,"LLVMIsAConstantInt","","",N,N],[5,"LLVMIsAConstantFP","","",N,N],[5,"LLVMRustPassKind","","",N,N],[5,"LLVMRustFindAndCreatePass","","",N,N],[5,"LLVMRustAddPass","","",N,N],[5,"LLVMRustHasFeature","","",N,N],[5,"LLVMRustPrintTargetCPUs","","",N,N],[5,"LLVMRustPrintTargetFeatures","","",N,N],[5,"LLVMRustGetHostCPUName","","",N,N],[5,"LLVMRustCreateTargetMachine","","",N,N],[5,"LLVMRustDisposeTargetMachine","","",N,N],[5,"LLVMRustAddAnalysisPasses","","",N,N],[5,"LLVMRustAddBuilderLibraryInfo","","",N,N],[5,"LLVMRustConfigurePassManagerBuilder","","",N,N],[5,"LLVMRustAddLibraryInfo","","",N,N],[5,"LLVMRustRunFunctionPassManager","","",N,N],[5,"LLVMRustWriteOutputFile","","",N,N],[5,"LLVMRustPrintModule","","",N,N],[5,"LLVMRustSetLLVMOptions","","",N,N],[5,"LLVMRustPrintPasses","","",N,N],[5,"LLVMRustSetNormalizedTarget","","",N,N],[5,"LLVMRustAddAlwaysInlinePass","","",N,N],[5,"LLVMRustRunRestrictionPass","","",N,N],[5,"LLVMRustMarkAllFunctionsNounwind","","",N,N],[5,"LLVMRustOpenArchive","","",N,N],[5,"LLVMRustArchiveIteratorNew","","",N,N],[5,"LLVMRustArchiveIteratorNext","","",N,N],[5,"LLVMRustArchiveChildName","","",N,N],[5,"LLVMRustArchiveChildData","","",N,N],[5,"LLVMRustArchiveChildFree","","",N,N],[5,"LLVMRustArchiveIteratorFree","","",N,N],[5,"LLVMRustDestroyArchive","","",N,N],[5,"LLVMRustGetSectionName","","",N,N],[5,"LLVMRustWriteTwineToString","","",N,N],[5,"LLVMContextSetDiagnosticHandler","","",N,N],[5,"LLVMRustUnpackOptimizationDiagnostic","","",N,N],[5,"LLVMRustUnpackInlineAsmDiagnostic","","",N,N],[5,"LLVMRustWriteDiagnosticInfoToString","","",N,N],[5,"LLVMRustGetDiagInfoKind","","",N,N],[5,"LLVMRustSetInlineAsmDiagnosticHandler","","",N,N],[5,"LLVMRustWriteSMDiagnosticToString","","",N,N],[5,"LLVMRustWriteArchive","","",N,N],[5,"LLVMRustArchiveMemberNew","","",N,N],[5,"LLVMRustArchiveMemberFree","","",N,N],[5,"LLVMRustSetDataLayoutFromTargetMachine","","",N,N],[5,"LLVMRustBuildOperandBundleDef","","",N,N],[5,"LLVMRustFreeOperandBundleDef","","",N,N],[5,"LLVMRustPositionBuilderAtStart","","",N,N],[5,"LLVMRustSetComdat","","",N,N],[5,"LLVMRustUnsetComdat","","",N,N],[5,"LLVMRustSetModulePIELevel","","",N,N],[5,"LLVMRustModuleBufferCreate","","",N,N],[5,"LLVMRustModuleBufferPtr","","",N,N],[5,"LLVMRustModuleBufferLen","","",N,N],[5,"LLVMRustModuleBufferFree","","",N,N],[5,"LLVMRustModuleCost","","",N,N],[5,"LLVMRustThinLTOAvailable","","",N,N],[5,"LLVMRustPGOAvailable","","",N,N],[5,"LLVMRustThinLTOBufferCreate","","",N,N],[5,"LLVMRustThinLTOBufferFree","","",N,N],[5,"LLVMRustThinLTOBufferPtr","","",N,N],[5,"LLVMRustThinLTOBufferLen","","",N,N],[5,"LLVMRustCreateThinLTOData","","",N,N],[5,"LLVMRustPrepareThinLTORename","","",N,N],[5,"LLVMRustPrepareThinLTOResolveWeak","","",N,N],[5,"LLVMRustPrepareThinLTOInternalize","","",N,N],[5,"LLVMRustPrepareThinLTOImport","","",N,N],[5,"LLVMRustGetThinLTOModuleImports","","",N,N],[5,"LLVMRustFreeThinLTOData","","",N,N],[5,"LLVMRustParseBitcodeForThinLTO","","",N,N],[5,"LLVMRustThinLTOGetDICompileUnit","","",N,N],[5,"LLVMRustThinLTOPatchDICompileUnit","","",N,N],[5,"LLVMRustLinkerNew","","",N,N],[5,"LLVMRustLinkerAdd","","",N,N],[5,"LLVMRustLinkerFree","","",N,N],[0,"debuginfo","","",N,N],[3,"DIBuilder","rustc_codegen_llvm::llvm::ffi::debuginfo","",N,N],[12,"0","","",144,N],[3,"DIFlags","","",N,N],[12,"bits","","",145,N],[6,"DIDescriptor","","",N,N],[6,"DIScope","","",N,N],[6,"DIFile","","",N,N],[6,"DILexicalBlock","","",N,N],[6,"DISubprogram","","",N,N],[6,"DINameSpace","","",N,N],[6,"DIType","","",N,N],[6,"DIBasicType","","",N,N],[6,"DIDerivedType","","",N,N],[6,"DICompositeType","","",N,N],[6,"DIVariable","","",N,N],[6,"DIGlobalVariable","","",N,N],[6,"DIArray","","",N,N],[6,"DISubrange","","",N,N],[6,"DIEnumerator","","",N,N],[6,"DITemplateTypeParameter","","",N,N],[11,"eq","","",145,[[["self"],["diflags"]],["bool"]]],[11,"ne","","",145,[[["self"],["diflags"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",145,N],[11,"clone","","",145,[[["self"]],["diflags"]]],[11,"partial_cmp","","",145,[[["self"],["diflags"]],["option",["ordering"]]]],[11,"lt","","",145,[[["self"],["diflags"]],["bool"]]],[11,"le","","",145,[[["self"],["diflags"]],["bool"]]],[11,"gt","","",145,[[["self"],["diflags"]],["bool"]]],[11,"ge","","",145,[[["self"],["diflags"]],["bool"]]],[11,"cmp","","",145,[[["self"],["diflags"]],["ordering"]]],[11,"hash","","",145,N],[11,"default","","",145,[[],["diflags"]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[18,"FlagZero","","",145,N],[18,"FlagPrivate","","",145,N],[18,"FlagProtected","","",145,N],[18,"FlagPublic","","",145,N],[18,"FlagFwdDecl","","",145,N],[18,"FlagAppleBlock","","",145,N],[18,"FlagBlockByrefStruct","","",145,N],[18,"FlagVirtual","","",145,N],[18,"FlagArtificial","","",145,N],[18,"FlagExplicit","","",145,N],[18,"FlagPrototyped","","",145,N],[18,"FlagObjcClassComplete","","",145,N],[18,"FlagObjectPointer","","",145,N],[18,"FlagVector","","",145,N],[18,"FlagStaticMember","","",145,N],[18,"FlagLValueReference","","",145,N],[18,"FlagRValueReference","","",145,N],[18,"FlagExternalTypeRef","","",145,N],[18,"FlagIntroducedVirtual","","",145,N],[18,"FlagBitField","","",145,N],[18,"FlagNoReturn","","",145,N],[18,"FlagMainSubprogram","","",145,N],[11,"empty","","Returns an empty set of flags.",145,[[],["diflags"]]],[11,"all","","Returns the set containing all flags.",145,[[],["diflags"]]],[11,"bits","","Returns the raw value of the flags currently stored.",145,[[["self"]],["uint32_t"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",145,[[["uint32_t"]],["option",["diflags"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",145,[[["uint32_t"]],["diflags"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",145,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",145,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",145,[[["self"],["diflags"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",145,[[["self"],["diflags"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",145,[[["self"],["diflags"]]]],[11,"remove","","Removes the specified flags in-place.",145,[[["self"],["diflags"]]]],[11,"toggle","","Toggles the specified flags in-place.",145,[[["self"],["diflags"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",145,[[["self"],["diflags"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",145,[[["self"],["diflags"]],["diflags"]]],[11,"bitor_assign","","Adds the set of flags.",145,[[["self"],["diflags"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",145,[[["self"],["diflags"]],["diflags"]]],[11,"bitxor_assign","","Toggles the set of flags.",145,[[["self"],["diflags"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",145,[[["self"],["diflags"]],["diflags"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",145,[[["self"],["diflags"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",145,[[["self"],["diflags"]],["diflags"]]],[11,"sub_assign","","Disables all flags enabled in the set.",145,[[["self"],["diflags"]]]],[11,"not","","Returns the complement of this set of flags.",145,[[["self"]],["diflags"]]],[11,"extend","","",145,[[["self"],["t"]]]],[11,"from_iter","","",145,[[["t"]],["diflags"]]],[6,"Bool","rustc_codegen_llvm::llvm::ffi","",N,N],[6,"ThinLTOModuleNameCallback","","",N,N],[6,"DiagnosticHandler","","",N,N],[6,"InlineAsmDiagHandler","","",N,N],[17,"True","","",N,N],[17,"False","","",N,N],[11,"clone","rustc_codegen_llvm::llvm","",112,[[["self"]],["llvmrustresult"]]],[11,"eq","","",112,[[["self"],["llvmrustresult"]],["bool"]]],[11,"clone","","",113,[[["self"]],["callconv"]]],[11,"eq","","",113,[[["self"],["callconv"]],["bool"]]],[11,"fmt","","",113,[[["self"],["formatter"]],["result"]]],[11,"clone","","",114,[[["self"]],["linkage"]]],[11,"eq","","",114,[[["self"],["linkage"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",114,N],[11,"hash","","",114,N],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"clone","","",115,[[["self"]],["visibility"]]],[11,"eq","","",115,[[["self"],["visibility"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",115,N],[11,"hash","","",115,N],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"clone","","",116,[[["self"]],["dllstorageclass"]]],[11,"clone","","",117,[[["self"]],["attribute"]]],[11,"fmt","","",117,[[["self"],["formatter"]],["result"]]],[11,"clone","","",118,[[["self"]],["intpredicate"]]],[11,"clone","","",119,[[["self"]],["realpredicate"]]],[11,"clone","","",120,[[["self"]],["typekind"]]],[11,"eq","","",120,[[["self"],["typekind"]],["bool"]]],[11,"fmt","","",120,[[["self"],["formatter"]],["result"]]],[11,"clone","","",121,[[["self"]],["atomicrmwbinop"]]],[11,"clone","","",122,[[["self"]],["atomicordering"]]],[11,"clone","","",123,[[["self"]],["synchronizationscope"]]],[11,"clone","","",124,[[["self"]],["filetype"]]],[11,"clone","","",125,[[["self"]],["metadatatype"]]],[11,"clone","","",126,[[["self"]],["asmdialect"]]],[11,"clone","","",127,[[["self"]],["codegenoptlevel"]]],[11,"eq","","",127,[[["self"],["codegenoptlevel"]],["bool"]]],[11,"clone","","",128,[[["self"]],["relocmode"]]],[11,"eq","","",128,[[["self"],["relocmode"]],["bool"]]],[11,"clone","","",129,[[["self"]],["codemodel"]]],[11,"clone","","",130,[[["self"]],["diagnostickind"]]],[11,"clone","","",131,[[["self"]],["archivekind"]]],[11,"clone","","",132,[[["self"]],["passkind"]]],[11,"eq","","",132,[[["self"],["passkind"]],["bool"]]],[11,"fmt","","",132,[[["self"],["formatter"]],["result"]]],[11,"clone","","",133,[[["self"]],["threadlocalmode"]]],[0,"debuginfo","","",N,N],[3,"DIBuilder","rustc_codegen_llvm::llvm::debuginfo","",N,N],[12,"0","","",144,N],[3,"DIFlags","","",N,N],[12,"bits","","",145,N],[6,"DIDescriptor","","",N,N],[6,"DIScope","","",N,N],[6,"DIFile","","",N,N],[6,"DILexicalBlock","","",N,N],[6,"DISubprogram","","",N,N],[6,"DINameSpace","","",N,N],[6,"DIType","","",N,N],[6,"DIBasicType","","",N,N],[6,"DIDerivedType","","",N,N],[6,"DICompositeType","","",N,N],[6,"DIVariable","","",N,N],[6,"DIGlobalVariable","","",N,N],[6,"DIArray","","",N,N],[6,"DISubrange","","",N,N],[6,"DIEnumerator","","",N,N],[6,"DITemplateTypeParameter","","",N,N],[6,"Bool","rustc_codegen_llvm::llvm","",N,N],[6,"ThinLTOModuleNameCallback","","",N,N],[6,"DiagnosticHandler","","",N,N],[6,"InlineAsmDiagHandler","","",N,N],[17,"True","","",N,N],[17,"False","","",N,N],[11,"into_result","","",112,[[["self"]],["result"]]],[11,"clone","","",134,[[["self"]],["attributeplace"]]],[11,"as_uint","","",134,[[["self"]],["c_uint"]]],[11,"clone","","",135,[[["self"]],["codegenoptsize"]]],[11,"eq","","",135,[[["self"],["codegenoptsize"]],["bool"]]],[11,"from_str","","",131,[[["str"]],["result"]]],[11,"apply_llfn","","",117,[[["self"],["attributeplace"],["value"]]]],[11,"apply_callsite","","",117,[[["self"],["attributeplace"],["value"]]]],[11,"unapply_llfn","","",117,[[["self"],["attributeplace"],["value"]]]],[11,"toggle_llfn","","",117,[[["self"],["attributeplace"],["value"],["bool"]]]],[11,"new","","",109,[[["memorybuffer"]],["option",["objectfile"]]]],[11,"drop","","",109,[[["self"]]]],[11,"drop","","",110,[[["self"]]]],[11,"new","","",111,N],[11,"drop","","",111,[[["self"]]]],[0,"llvm_util","rustc_codegen_llvm","",N,N],[5,"init","rustc_codegen_llvm::llvm_util","",N,[[["session"]]]],[5,"require_inited","","",N,[[]]],[5,"configure_llvm","","",N,[[["session"]]]],[5,"all_known_features","","When rustdoc is running, provide a list of all known features so that all their respective primtives may be documented.",N,N],[5,"to_llvm_feature","","",N,[[["session"],["str"]],["str"]]],[5,"target_features","","",N,[[["session"]],["vec",["symbol"]]]],[5,"target_feature_whitelist","","",N,N],[5,"print_version","","",N,[[]]],[5,"print_passes","","",N,[[]]],[5,"print","","",N,[[["printrequest"],["session"]]]],[5,"target_cpu","","",N,[[["session"]],["str"]]],[22,"","","",N,N],[7,"POISONED","","",N,N],[7,"INIT","","",N,N],[17,"ARM_WHITELIST","","",N,N],[17,"AARCH64_WHITELIST","","",N,N],[17,"X86_WHITELIST","","",N,N],[17,"HEXAGON_WHITELIST","","",N,N],[17,"POWERPC_WHITELIST","","",N,N],[17,"MIPS_WHITELIST","","",N,N],[17,"WASM_WHITELIST","","",N,N],[0,"metadata","rustc_codegen_llvm","",N,N],[6,"MetadataRef","rustc_codegen_llvm::metadata","",N,N],[3,"LlvmMetadataLoader","","",N,N],[5,"search_meta_section","","",N,[[["objectfile"],["target"],["path"]],["result",["string"]]]],[5,"metadata_section_name","","",N,[[["target"]],["str"]]],[5,"read_metadata_section_name","","",N,[[["target"]],["str"]]],[17,"METADATA_FILENAME","","",N,N],[11,"get_rlib_metadata","","",146,[[["self"],["target"],["path"]],["result",["metadataref","string"]]]],[11,"get_dylib_metadata","","",146,[[["self"],["target"],["path"]],["result",["metadataref","string"]]]],[0,"meth","rustc_codegen_llvm","",N,N],[3,"VirtualIndex","rustc_codegen_llvm::meth","",N,N],[12,"0","","",147,N],[5,"get_vtable","","Creates a dynamic vtable for the given type and vtable origin. This is used only for objects.",N,[[["codegencx"],["ty"],["option",["polyexistentialtraitref"]]],["value"]]],[17,"DESTRUCTOR","","",N,N],[17,"SIZE","","",N,N],[17,"ALIGN","","",N,N],[11,"clone","","",147,[[["self"]],["virtualindex"]]],[11,"fmt","","",147,[[["self"],["formatter"]],["result"]]],[11,"from_index","","",147,[[["usize"]],["self"]]],[11,"get_fn","","",147,[[["self"],["builder"],["value"],["fntype"]],["value"]]],[11,"get_usize","","",147,[[["self"],["builder"],["value"]],["value"]]],[0,"mir","rustc_codegen_llvm","",N,N],[3,"FunctionCx","rustc_codegen_llvm::mir","Master context for codegenning from MIR.",N,N],[12,"instance","","",148,N],[12,"mir","","",148,N],[12,"debug_context","","",148,N],[12,"llfn","","",148,N],[12,"cx","","",148,N],[12,"fn_ty","","",148,N],[12,"personality_slot","","When unwinding is initiated, we have to store this personality value somewhere so that we can load it and re-use it in the resume instruction. The personality is (afaik) some kind of value used for C++ unwinding, which must filter by type: we don't really care about it very much. Anyway, this value contains an alloca into which the personality is stored and then later loaded when generating the DIVERGE_BLOCK.",148,N],[12,"blocks","","A `Block` for each MIR `BasicBlock`",148,N],[12,"cleanup_kinds","","The funclet status of each basic block",148,N],[12,"funclets","","When targeting MSVC, this stores the cleanup info for each funclet BB. This is initialized as we compute the funclets' head block in RPO.",148,N],[12,"landing_pads","","This stores the landing-pad block for a given BB, computed lazily on GNU and eagerly on MSVC.",148,N],[12,"unreachable_block","","Cached unreachable block",148,N],[12,"locals","","The location where each MIR arg/var/tmp/ret is stored. This is usually an `PlaceRef` representing an alloca, but not always: sometimes we can skip the alloca and just store the value directly using an `OperandRef`, which makes for tighter LLVM IR. The conditions for using an `OperandRef` are as follows:",148,N],[12,"scopes","","Debug information for MIR scopes.",148,N],[12,"param_substs","","If this function is being monomorphized, this contains the type substitutions used.",148,N],[4,"LocalRef","","",N,N],[13,"Place","","",149,N],[13,"UnsizedPlace","","`UnsizedPlace(p)`: `p` itself is a thin pointer (indirect place). `*p` is the fat pointer that references the actual unsized place. Every time it is initialized, we have to reallocate the place and update the fat pointer. That's the reason why it is indirect.",149,N],[13,"Operand","","",149,N],[5,"codegen_mir","","",N,[[["codegencx"],["value"],["mir"],["instance"],["fnsig"]]]],[5,"create_funclets","","",N,N],[5,"arg_local_refs","","Produce, for each argument, a `Value` pointing at the argument's value. As arguments are places, these are always indirect.",N,[[["builder"],["functioncx"],["indexvec"],["bitarray"]],["vec",["localref"]]]],[0,"analyze","","An analysis to determine which locals require allocas and which do not.",N,N],[3,"LocalAnalyzer","rustc_codegen_llvm::mir::analyze","",N,N],[12,"fx","","",150,N],[12,"dominators","","",150,N],[12,"non_ssa_locals","","",150,N],[12,"first_assignment","","",150,N],[4,"CleanupKind","","",N,N],[13,"NotCleanup","","",151,N],[13,"Funclet","","",151,N],[13,"Internal","","",151,N],[12,"funclet","rustc_codegen_llvm::mir::analyze::CleanupKind","",151,N],[5,"non_ssa_locals","rustc_codegen_llvm::mir::analyze","",N,[[["functioncx"]],["bitarray",["local"]]]],[5,"cleanup_kinds","","",N,[[["mir"]],["indexvec",["basicblock","cleanupkind"]]]],[11,"new","","",150,[[["functioncx"]],["self"]]],[11,"first_assignment","","",150,[[["self"],["local"]],["option",["location"]]]],[11,"not_ssa","","",150,[[["self"],["local"]]]],[11,"assign","","",150,[[["self"],["local"],["location"]]]],[11,"visit_assign","","",150,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_terminator_kind","","",150,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_place","","",150,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_local","","",150,[[["self"],["local"],["placecontext"],["location"]]]],[11,"clone","","",151,[[["self"]],["cleanupkind"]]],[11,"fmt","","",151,[[["self"],["formatter"]],["result"]]],[11,"eq","","",151,[[["self"],["cleanupkind"]],["bool"]]],[11,"ne","","",151,[[["self"],["cleanupkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",151,N],[11,"funclet_bb","","",151,[[["self"],["basicblock"]],["option",["basicblock"]]]],[0,"block","rustc_codegen_llvm::mir","",N,N],[4,"ReturnDest","rustc_codegen_llvm::mir::block","",N,N],[13,"Nothing","","",152,N],[13,"Store","","",152,N],[13,"IndirectOperand","","",152,N],[13,"DirectOperand","","",152,N],[11,"codegen_block","rustc_codegen_llvm::mir","",148,[[["self"],["basicblock"]]]],[11,"codegen_terminator","","",148,[[["self"],["builder"],["basicblock"],["terminator"]]]],[11,"codegen_argument","","",148,[[["self"],["builder"],["operandref"],["vec"],["argtype"]]]],[11,"codegen_arguments_untupled","","",148,N],[11,"get_personality_slot","","",148,[[["self"],["builder"]],["placeref"]]],[11,"landing_pad_to","","Return the landingpad wrapper around the given basic block",148,[[["self"],["basicblock"]],["basicblock"]]],[11,"landing_pad_uncached","","",148,[[["self"],["basicblock"]],["basicblock"]]],[11,"landing_pad_type","","",148,[[["self"]],["type"]]],[11,"unreachable_block","","",148,[[["self"]],["basicblock"]]],[11,"new_block","","",148,[[["self"],["str"]],["builder"]]],[11,"build_block","","",148,[[["self"],["basicblock"]],["builder"]]],[11,"make_return_dest","","",148,[[["self"],["builder"],["place"],["argtype"],["vec"],["bool"]],["returndest"]]],[11,"codegen_transmute","","",148,[[["self"],["builder"],["operand"],["place"]]]],[11,"codegen_transmute_into","","",148,[[["self"],["builder"],["operand"],["placeref"]]]],[11,"store_return","","",148,[[["self"],["builder"],["returndest"],["argtype"],["value"]]]],[0,"constant","","",N,N],[5,"scalar_to_llvm","rustc_codegen_llvm::mir::constant","",N,[[["codegencx"],["scalar"],["scalar"],["type"]],["value"]]],[5,"const_alloc_to_llvm","","",N,[[["codegencx"],["allocation"]],["value"]]],[5,"codegen_static_initializer","","",N,[[["codegencx"],["defid"]],["result",["lrc"]]]],[11,"fully_evaluate","rustc_codegen_llvm::mir","",148,[[["self"],["builder"],["const"]],["result",["const","lrc"]]]],[11,"eval_mir_constant","","",148,[[["self"],["builder"],["constant"]],["result",["const","lrc"]]]],[11,"simd_shuffle_indices","","process constant containing SIMD shuffle indices",148,N],[0,"place","","",N,N],[3,"PlaceRef","rustc_codegen_llvm::mir::place","",N,N],[12,"llval","","Pointer to the contents of the place",153,N],[12,"llextra","","This place's extra data if it is unsized, or null",153,N],[12,"layout","","Monomorphized type of this place, including variant information",153,N],[12,"align","","What alignment we know for this place",153,N],[11,"clone","","",153,[[["self"]],["placeref"]]],[11,"fmt","","",153,[[["self"],["formatter"]],["result"]]],[11,"new_sized","","",153,[[["value"],["tylayout"],["align"]],["placeref"]]],[11,"from_const_alloc","","",153,[[["builder"],["tylayout"],["allocation"],["size"]],["placeref"]]],[11,"alloca","","",153,[[["builder"],["tylayout"],["str"]],["placeref"]]],[11,"alloca_unsized_indirect","","Returns a place for an indirect reference to an unsized place.",153,[[["builder"],["tylayout"],["str"]],["placeref"]]],[11,"len","","",153,[[["self"],["codegencx"]],["value"]]],[11,"load","","",153,[[["self"],["builder"]],["operandref"]]],[11,"project_field","","Access a field, at a point when the value's case is known.",153,[[["self"],["builder"],["usize"]],["placeref"]]],[11,"codegen_get_discr","","Obtain the actual discriminant of a value.",153,[[["self"],["builder"],["ty"]],["value"]]],[11,"codegen_set_discr","","Set the discriminant for a new value of the given case of the given representation.",153,[[["self"],["builder"],["usize"]]]],[11,"project_index","","",153,[[["self"],["builder"],["value"]],["placeref"]]],[11,"project_downcast","","",153,[[["self"],["builder"],["usize"]],["placeref"]]],[11,"storage_live","","",153,[[["self"],["builder"]]]],[11,"storage_dead","","",153,[[["self"],["builder"]]]],[11,"codegen_place","rustc_codegen_llvm::mir","",148,[[["self"],["builder"],["place"]],["placeref"]]],[11,"monomorphized_place_ty","","",148,[[["self"],["place"]],["ty"]]],[0,"operand","","",N,N],[3,"OperandRef","rustc_codegen_llvm::mir::operand","An `OperandRef` is an \"SSA\" reference to a Rust value, along with its type.",N,N],[12,"val","","",154,N],[12,"layout","","",154,N],[4,"OperandValue","","The representation of a Rust value. The enum variant is in fact uniquely determined by the value's type, but is kept as a safety check.",N,N],[13,"Ref","","A reference to the actual operand. The data is guaranteed to be valid for the operand's lifetime. The second value, if any, is the extra data (vtable or length) which indicates that it refers to an unsized rvalue.",155,N],[13,"Immediate","","A single LLVM value.",155,N],[13,"Pair","","A pair of immediate LLVM values. Used by fat pointers too.",155,N],[11,"clone","","",155,[[["self"]],["operandvalue"]]],[11,"fmt","","",155,[[["self"],["formatter"]],["result"]]],[11,"clone","","",154,[[["self"]],["operandref"]]],[11,"fmt","","",154,[[["self"],["formatter"]],["result"]]],[11,"new_zst","","",154,[[["codegencx"],["tylayout"]],["operandref"]]],[11,"from_const","","",154,[[["builder"],["const"]],["result",["operandref","lrc"]]]],[11,"immediate","","Asserts that this operand refers to a scalar and returns a reference to its value.",154,[[["self"]],["value"]]],[11,"deref","","",154,[[["self"],["codegencx"]],["placeref"]]],[11,"immediate_or_packed_pair","","If this operand is a `Pair`, we return an aggregate with the two values. For other cases, see `immediate`.",154,[[["self"],["builder"]],["value"]]],[11,"from_immediate_or_packed_pair","","If the type is a pair, we return a `Pair`, otherwise, an `Immediate`.",154,[[["builder"],["value"],["tylayout"]],["operandref"]]],[11,"extract_field","","",154,[[["self"],["builder"],["usize"]],["operandref"]]],[11,"store","","",155,[[["self"],["builder"],["placeref"]]]],[11,"volatile_store","","",155,[[["self"],["builder"],["placeref"]]]],[11,"unaligned_volatile_store","","",155,[[["self"],["builder"],["placeref"]]]],[11,"nontemporal_store","","",155,[[["self"],["builder"],["placeref"]]]],[11,"store_with_flags","","",155,[[["self"],["builder"],["placeref"],["memflags"]]]],[11,"store_unsized","","",155,[[["self"],["builder"],["placeref"]]]],[11,"maybe_codegen_consume_direct","rustc_codegen_llvm::mir","",148,[[["self"],["builder"],["place"]],["option",["operandref"]]]],[11,"codegen_consume","","",148,[[["self"],["builder"],["place"]],["operandref"]]],[11,"codegen_operand","","",148,[[["self"],["builder"],["operand"]],["operandref"]]],[0,"rvalue","","",N,N],[4,"OverflowOp","rustc_codegen_llvm::mir::rvalue","",N,N],[13,"Add","","",156,N],[13,"Sub","","",156,N],[13,"Mul","","",156,N],[5,"get_overflow_intrinsic","","",N,[[["overflowop"],["builder"],["ty"]],["value"]]],[5,"cast_int_to_float","","",N,[[["builder"],["bool"],["value"],["type"],["type"]],["value"]]],[5,"cast_float_to_int","","",N,[[["builder"],["bool"],["value"],["type"],["type"]],["value"]]],[11,"codegen_rvalue","rustc_codegen_llvm::mir","",148,[[["self"],["builder"],["placeref"],["rvalue"]],["builder"]]],[11,"codegen_rvalue_unsized","","",148,[[["self"],["builder"],["placeref"],["rvalue"]],["builder"]]],[11,"codegen_rvalue_operand","","",148,N],[11,"evaluate_array_len","","",148,[[["self"],["builder"],["place"]],["value"]]],[11,"codegen_scalar_binop","","",148,[[["self"],["builder"],["binop"],["value"],["value"],["ty"]],["value"]]],[11,"codegen_fat_ptr_binop","","",148,[[["self"],["builder"],["binop"],["value"],["value"],["value"],["value"],["ty"]],["value"]]],[11,"codegen_scalar_checked_binop","","",148,[[["self"],["builder"],["binop"],["value"],["value"],["ty"]],["operandvalue"]]],[11,"rvalue_creates_operand","","",148,[[["self"],["rvalue"]],["bool"]]],[11,"clone","rustc_codegen_llvm::mir::rvalue","",156,[[["self"]],["overflowop"]]],[0,"statement","rustc_codegen_llvm::mir","",N,N],[11,"codegen_statement","","",148,[[["self"],["builder"],["statement"]],["builder"]]],[11,"monomorphize","","",148,[[["self"],["t"]],["t"]]],[11,"set_debug_loc","","",148,[[["self"],["builder"],["sourceinfo"]]]],[11,"debug_loc","","",148,N],[11,"scope_metadata_for_loc","","",148,[[["self"],["sourcescope"],["bytepos"]],["option",["discope"]]]],[11,"new_operand","","",149,[[["codegencx"],["tylayout"]],["localref"]]],[0,"mono_item","rustc_codegen_llvm","Walks the crate looking for items/impl-items/trait-items that have either a `rustc_symbol_name` or `rustc_item_path` attribute and generates an error giving, respectively, the symbol name or item-path. This is used for unit testing the code that generates paths etc in all kinds of annoying scenarios.",N,N],[4,"MonoItem","rustc_codegen_llvm::mono_item","",N,N],[13,"Fn","","",157,N],[13,"Static","","",157,N],[13,"GlobalAsm","","",157,N],[8,"BaseMonoItemExt","","",N,N],[10,"as_mono_item","","",158,[[["self"]],["monoitem"]]],[11,"is_generic_fn","","",158,[[["self"]],["bool"]]],[11,"symbol_name","","",158,[[["self"],["tyctxt"]],["symbolname"]]],[11,"instantiation_mode","","",158,[[["self"],["tyctxt"]],["instantiationmode"]]],[11,"explicit_linkage","","",158,[[["self"],["tyctxt"]],["option",["linkage"]]]],[11,"is_instantiable","","Returns whether this instance is instantiable - whether it has no unsatisfied predicates.",158,[[["self"],["tyctxt"]],["bool"]]],[11,"to_string","","",158,[[["self"],["tyctxt"]],["string"]]],[11,"local_span","","",158,[[["self"],["tyctxt"]],["option",["span"]]]],[5,"predefine_static","","",N,[[["codegencx"],["defid"],["linkage"],["visibility"],["str"]]]],[5,"predefine_fn","","",N,[[["codegencx"],["instance"],["linkage"],["visibility"],["str"]]]],[8,"MonoItemExt","","",N,N],[11,"define","","",159,[[["self"],["codegencx"]]]],[11,"predefine","","",159,[[["self"],["codegencx"],["linkage"],["visibility"]]]],[11,"to_raw_string","","",159,[[["self"]],["string"]]],[0,"type_","rustc_codegen_llvm","",N,N],[11,"eq","rustc_codegen_llvm::type_","",160,[[["self"],["self"]],["bool"]]],[11,"fmt","","",160,[[["self"],["formatter"]],["result"]]],[11,"void","","",160,[[["codegencx"]],["type"]]],[11,"metadata","","",160,[[["codegencx"]],["type"]]],[11,"i1","","",160,[[["codegencx"]],["type"]]],[11,"i8","","",160,[[["codegencx"]],["type"]]],[11,"i8_llcx","","",160,[[["context"]],["type"]]],[11,"i16","","",160,[[["codegencx"]],["type"]]],[11,"i32","","",160,[[["codegencx"]],["type"]]],[11,"i64","","",160,[[["codegencx"]],["type"]]],[11,"i128","","",160,[[["codegencx"]],["type"]]],[11,"ix","","",160,[[["codegencx"],["u64"]],["type"]]],[11,"ix_llcx","","",160,[[["context"],["u64"]],["type"]]],[11,"f32","","",160,[[["codegencx"]],["type"]]],[11,"f64","","",160,[[["codegencx"]],["type"]]],[11,"bool","","",160,[[["codegencx"]],["type"]]],[11,"char","","",160,[[["codegencx"]],["type"]]],[11,"i8p","","",160,[[["codegencx"]],["type"]]],[11,"i8p_llcx","","",160,[[["context"]],["type"]]],[11,"isize","","",160,[[["codegencx"]],["type"]]],[11,"c_int","","",160,[[["codegencx"]],["type"]]],[11,"int_from_ty","","",160,[[["codegencx"],["intty"]],["type"]]],[11,"uint_from_ty","","",160,[[["codegencx"],["uintty"]],["type"]]],[11,"float_from_ty","","",160,[[["codegencx"],["floatty"]],["type"]]],[11,"func","","",160,N],[11,"variadic_func","","",160,N],[11,"struct_","","",160,N],[11,"named_struct","","",160,[[["codegencx"],["str"]],["type"]]],[11,"array","","",160,[[["type"],["u64"]],["type"]]],[11,"vector","","",160,[[["type"],["u64"]],["type"]]],[11,"kind","","",160,[[["self"]],["typekind"]]],[11,"set_struct_body","","",160,N],[11,"ptr_to","","",160,[[["self"]],["type"]]],[11,"element_type","","",160,[[["self"]],["type"]]],[11,"vector_length","","Return the number of elements in `self` if it is a LLVM vector type.",160,[[["self"]],["usize"]]],[11,"func_params","","",160,[[["self"]],["vec",["type"]]]],[11,"float_width","","",160,[[["self"]],["usize"]]],[11,"int_width","","Retrieve the bit width of the integer type `self`.",160,[[["self"]],["u64"]]],[11,"from_integer","","",160,[[["codegencx"],["integer"]],["type"]]],[11,"pointee_for_abi_align","","Return a LLVM type that has at most the required alignment, as a conservative approximation for unknown pointee types.",160,[[["codegencx"],["align"]],["type"]]],[11,"padding_filler","","Return a LLVM type that has at most the required alignment, and exactly the required size, as a best-effort padding array.",160,[[["codegencx"],["size"],["align"]],["type"]]],[11,"x86_mmx","","",160,[[["codegencx"]],["type"]]],[0,"type_of","rustc_codegen_llvm","",N,N],[3,"PointeeInfo","rustc_codegen_llvm::type_of","",N,N],[12,"size","","",161,N],[12,"align","","",161,N],[12,"safe","","",161,N],[4,"PointerKind","","",N,N],[13,"Shared","","Most general case, we know no restrictions to tell LLVM.",162,N],[13,"Frozen","","`&T` where `T` contains no `UnsafeCell`, is `noalias` and `readonly`.",162,N],[13,"UniqueBorrowed","","`&mut T`, when we know `noalias` is safe for LLVM.",162,N],[13,"UniqueOwned","","`Box<T>`, unlike `UniqueBorrowed`, it also has `noalias` on returns.",162,N],[5,"uncached_llvm_type","","",N,[[["codegencx"],["tylayout"],["option"]],["type"]]],[5,"struct_llfields","","",N,N],[8,"LayoutLlvmExt","","",N,N],[10,"is_llvm_immediate","","",163,[[["self"]],["bool"]]],[10,"is_llvm_scalar_pair","","",163,[[["self"]],["bool"]]],[10,"llvm_type","","",163,[[["self"],["codegencx"]],["type"]]],[10,"immediate_llvm_type","","",163,[[["self"],["codegencx"]],["type"]]],[10,"scalar_llvm_type_at","","",163,[[["self"],["codegencx"],["scalar"],["size"]],["type"]]],[10,"scalar_pair_element_llvm_type","","",163,[[["self"],["codegencx"],["usize"],["bool"]],["type"]]],[10,"llvm_field_index","","",163,[[["self"],["usize"]],["u64"]]],[10,"pointee_info_at","","",163,[[["self"],["codegencx"],["size"]],["option",["pointeeinfo"]]]],[11,"align_of","rustc_codegen_llvm::context","",79,[[["self"],["ty"]],["align"]]],[11,"size_of","","",79,[[["self"],["ty"]],["size"]]],[11,"size_and_align_of","","",79,N],[11,"clone","rustc_codegen_llvm::type_of","",162,[[["self"]],["pointerkind"]]],[11,"eq","","",162,[[["self"],["pointerkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",162,N],[11,"clone","","",161,[[["self"]],["pointeeinfo"]]],[0,"value","rustc_codegen_llvm","",N,N],[11,"eq","rustc_codegen_llvm::value","",164,[[["self"],["self"]],["bool"]]],[11,"hash","","",164,[[["self"],["h"]]]],[11,"fmt","","",164,[[["self"],["formatter"]],["result"]]],[17,"DIAGNOSTICS","rustc_codegen_llvm","",N,N],[11,"new","","",0,[[],["box",["codegenbackend"]]]],[11,"init","","",0,[[["self"],["session"]]]],[11,"print","","",0,[[["self"],["printrequest"],["session"]]]],[11,"print_passes","","",0,[[["self"]]]],[11,"print_version","","",0,[[["self"]]]],[11,"diagnostics","","",0,N],[11,"target_features","","",0,[[["self"],["session"]],["vec",["symbol"]]]],[11,"metadata_loader","","",0,[[["self"]],["box",["metadataloader"]]]],[11,"provide","","",0,[[["self"],["providers"]]]],[11,"provide_extern","","",0,[[["self"],["providers"]]]],[11,"codegen_crate","","",0,[[["self"],["tyctxt"],["receiver",["box"]]],["box",["any"]]]],[11,"join_codegen_and_link","","",0,[[["self"],["box",["any"]],["session"],["depgraph"],["outputfilenames"]],["result",["compileincomplete"]]]],[11,"clone","","",7,[[["self"]],["modulekind"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"eq","","",7,[[["self"],["modulekind"]],["bool"]]],[11,"into_compiled_module","","",1,[[["self"],["bool"],["bool"],["bool"],["outputfilenames"]],["compiledmodule"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"new","","",4,[[["session"],["str"]],["self"]]],[11,"llmod","","",4,[[["self"]],["module"]]],[11,"drop","","",4,[[["self"]]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::back::archive","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::back::bytecode","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_codegen_llvm::back::command","",12,[[["self"]],["t"]]],[11,"clone_into","","",12,N],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]],[11,"to_owned","","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from_ok","","",13,[[["t"]],["t"]]],[11,"map_same","","",13,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::back::linker","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from_ok","","",14,[[["t"]],["t"]]],[11,"map_same","","",14,[[["self"],["f"]],["t"]]],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from_ok","","",15,[[["t"]],["t"]]],[11,"map_same","","",15,[[["self"],["f"]],["t"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from_ok","","",16,[[["t"]],["t"]]],[11,"map_same","","",16,[[["self"],["f"]],["t"]]],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from_ok","","",17,[[["t"]],["t"]]],[11,"map_same","","",17,[[["self"],["f"]],["t"]]],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from_ok","","",18,[[["t"]],["t"]]],[11,"map_same","","",18,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::back::link","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from_ok","","",20,[[["t"]],["t"]]],[11,"map_same","","",20,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::back::lto","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from_ok","","",21,[[["t"]],["t"]]],[11,"map_same","","",21,[[["self"],["f"]],["t"]]],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from_ok","","",22,[[["t"]],["t"]]],[11,"map_same","","",22,[[["self"],["f"]],["t"]]],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from_ok","","",23,[[["t"]],["t"]]],[11,"map_same","","",23,[[["self"],["f"]],["t"]]],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"from_ok","","",24,[[["t"]],["t"]]],[11,"map_same","","",24,[[["self"],["f"]],["t"]]],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from_ok","","",25,[[["t"]],["t"]]],[11,"map_same","","",25,[[["self"],["f"]],["t"]]],[11,"from","","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"from_ok","","",26,[[["t"]],["t"]]],[11,"map_same","","",26,[[["self"],["f"]],["t"]]],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from_ok","","",27,[[["t"]],["t"]]],[11,"map_same","","",27,[[["self"],["f"]],["t"]]],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from_ok","","",28,[[["t"]],["t"]]],[11,"map_same","","",28,[[["self"],["f"]],["t"]]],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from_ok","","",29,[[["t"]],["t"]]],[11,"map_same","","",29,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::back::write","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"from_ok","","",30,[[["t"]],["t"]]],[11,"map_same","","",30,[[["self"],["f"]],["t"]]],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"from_ok","","",31,[[["t"]],["t"]]],[11,"map_same","","",31,[[["self"],["f"]],["t"]]],[11,"to_owned","","",32,[[["self"]],["t"]]],[11,"clone_into","","",32,N],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from_ok","","",32,[[["t"]],["t"]]],[11,"map_same","","",32,[[["self"],["f"]],["t"]]],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from_ok","","",33,[[["t"]],["t"]]],[11,"map_same","","",33,[[["self"],["f"]],["t"]]],[11,"from","","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"from_ok","","",34,[[["t"]],["t"]]],[11,"map_same","","",34,[[["self"],["f"]],["t"]]],[11,"from","","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"from_ok","","",35,[[["t"]],["t"]]],[11,"map_same","","",35,[[["self"],["f"]],["t"]]],[11,"to_owned","","",36,[[["self"]],["t"]]],[11,"clone_into","","",36,N],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"from_ok","","",36,[[["t"]],["t"]]],[11,"map_same","","",36,[[["self"],["f"]],["t"]]],[11,"from","","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"from_ok","","",37,[[["t"]],["t"]]],[11,"map_same","","",37,[[["self"],["f"]],["t"]]],[11,"from","","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"from_ok","","",38,[[["t"]],["t"]]],[11,"map_same","","",38,[[["self"],["f"]],["t"]]],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"from_ok","","",39,[[["t"]],["t"]]],[11,"map_same","","",39,[[["self"],["f"]],["t"]]],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from_ok","","",40,[[["t"]],["t"]]],[11,"map_same","","",40,[[["self"],["f"]],["t"]]],[11,"from","","",41,[[["t"]],["t"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"not_found","","",41,[[["str"],["str"]],["e"]]],[11,"from_ok","","",41,[[["t"]],["t"]]],[11,"map_same","","",41,[[["self"],["f"]],["t"]]],[11,"to_owned","","",42,[[["self"]],["t"]]],[11,"clone_into","","",42,N],[11,"from","","",42,[[["t"]],["t"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"not_found","","",42,[[["str"],["str"]],["e"]]],[11,"from_ok","","",42,[[["t"]],["t"]]],[11,"map_same","","",42,[[["self"],["f"]],["t"]]],[11,"from","","",43,[[["t"]],["t"]]],[11,"into","","",43,[[["self"]],["u"]]],[11,"try_from","","",43,[[["u"]],["result"]]],[11,"borrow","","",43,[[["self"]],["t"]]],[11,"try_into","","",43,[[["self"]],["result"]]],[11,"borrow_mut","","",43,[[["self"]],["t"]]],[11,"get_type_id","","",43,[[["self"]],["typeid"]]],[11,"not_found","","",43,[[["str"],["str"]],["e"]]],[11,"from_ok","","",43,[[["t"]],["t"]]],[11,"map_same","","",43,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::back::rpath","",44,[[["t"]],["t"]]],[11,"into","","",44,[[["self"]],["u"]]],[11,"try_from","","",44,[[["u"]],["result"]]],[11,"borrow","","",44,[[["self"]],["t"]]],[11,"try_into","","",44,[[["self"]],["result"]]],[11,"borrow_mut","","",44,[[["self"]],["t"]]],[11,"get_type_id","","",44,[[["self"]],["typeid"]]],[11,"not_found","","",44,[[["str"],["str"]],["e"]]],[11,"from_ok","","",44,[[["t"]],["t"]]],[11,"map_same","","",44,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::back::wasm","",45,[[["t"]],["t"]]],[11,"into_iter","","",45,[[["self"]],["i"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"not_found","","",45,[[["str"],["str"]],["e"]]],[11,"from_ok","","",45,[[["t"]],["t"]]],[11,"map_same","","",45,[[["self"],["f"]],["t"]]],[11,"from","","",46,[[["t"]],["t"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"not_found","","",46,[[["str"],["str"]],["e"]]],[11,"from_ok","","",46,[[["t"]],["t"]]],[11,"map_same","","",46,[[["self"],["f"]],["t"]]],[11,"from","","",47,[[["t"]],["t"]]],[11,"into","","",47,[[["self"]],["u"]]],[11,"try_from","","",47,[[["u"]],["result"]]],[11,"borrow","","",47,[[["self"]],["t"]]],[11,"try_into","","",47,[[["self"]],["result"]]],[11,"borrow_mut","","",47,[[["self"]],["t"]]],[11,"get_type_id","","",47,[[["self"]],["typeid"]]],[11,"not_found","","",47,[[["str"],["str"]],["e"]]],[11,"from_ok","","",47,[[["t"]],["t"]]],[11,"map_same","","",47,[[["self"],["f"]],["t"]]],[11,"index","rustc_codegen_llvm::abi","",48,[[["self"]],["usize"]]],[11,"data","","",48,[[["self"]],["abidata"]]],[11,"name","","",48,[[["self"]],["str"]]],[11,"generic","","",48,[[["self"]],["bool"]]],[11,"to_owned","","",48,[[["self"]],["t"]]],[11,"clone_into","","",48,N],[11,"from","","",48,[[["t"]],["t"]]],[11,"to_string","","",48,[[["self"]],["string"]]],[11,"into","","",48,[[["self"]],["u"]]],[11,"try_from","","",48,[[["u"]],["result"]]],[11,"borrow","","",48,[[["self"]],["t"]]],[11,"try_into","","",48,[[["self"]],["result"]]],[11,"borrow_mut","","",48,[[["self"]],["t"]]],[11,"get_type_id","","",48,[[["self"]],["typeid"]]],[11,"decode","","",48,[[["d"]],["result"]]],[11,"encode","","",48,[[["self"],["e"]],["result"]]],[11,"not_found","","",48,[[["str"],["str"]],["e"]]],[11,"from_ok","","",48,[[["t"]],["t"]]],[11,"map_same","","",48,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",48,N],[11,"relate","","",48,[[["r"],["abi"],["abi"]],["result",["abi","typeerror"]]]],[11,"hash_stable","rustc_codegen_llvm::mono_item","",157,N],[11,"hash_stable","rustc_codegen_llvm::abi","",48,N],[11,"hash_stable","rustc_codegen_llvm::attributes::attr","",71,N],[11,"hash_stable","","",65,N],[11,"hash_stable","","",68,N],[11,"hash_stable","rustc_codegen_llvm::attributes","",67,N],[11,"hash_stable","rustc_codegen_llvm::attributes::attr","",66,N],[11,"hash_stable","","",70,N],[11,"super_fold_with","rustc_codegen_llvm::abi","",48,[[["self"],["f"]],["abi"]]],[11,"super_visit_with","","",48,[[["self"],["f"]],["bool"]]],[11,"assert_receiver_is_total_eq","rustc_codegen_llvm::mono_item","",157,N],[11,"to_ty","rustc_codegen_llvm::attributes::attr","",68,[[["self"],["tyctxt"]],["tys"]]],[11,"initial_discriminant","","",68,[[["self"],["tyctxt"]],["discr"]]],[11,"disr_incr","","",68,[[["self"],["tyctxt"],["option",["discr"]]],["option",["discr"]]]],[11,"eq","rustc_codegen_llvm::mono_item","",157,[[["self"],["monoitem"]],["bool"]]],[11,"ne","","",157,[[["self"],["monoitem"]],["bool"]]],[11,"hash","","",157,N],[11,"lift_to_tcx","rustc_codegen_llvm::abi","",48,[[["self"],["tyctxt"]],["option",["abi"]]]],[11,"fmt","rustc_codegen_llvm::mono_item","",157,[[["self"],["formatter"]],["result",["error"]]]],[11,"clone","","",157,[[["self"]],["monoitem"]]],[11,"assert_receiver_is_total_eq","rustc_codegen_llvm::abi","",51,N],[11,"assert_receiver_is_total_eq","","",52,N],[11,"assert_receiver_is_total_eq","","",49,N],[11,"assert_receiver_is_total_eq","","",50,N],[11,"assert_receiver_is_total_eq","","",53,N],[11,"assert_receiver_is_total_eq","","",48,N],[11,"assert_receiver_is_total_eq","","",54,N],[11,"assert_receiver_is_total_eq","","",58,N],[11,"fmt","","",58,[[["self"],["formatter"]],["result",["error"]]]],[11,"bitor_assign","","Adds the set of flags.",58,N],[11,"bitand_assign","","Disables all flags disabled in the set.",58,N],[11,"not","","Returns the complement of this set of flags.",58,[[["self"]],["argattribute"]]],[11,"bitxor_assign","","Toggles the set of flags.",58,N],[11,"from","","",54,[[["uniform"]],["casttarget"]]],[11,"from","","",53,[[["reg"]],["uniform"]]],[11,"from","","",54,[[["reg"]],["casttarget"]]],[11,"partial_cmp","","",48,[[["self"],["abi"]],["option",["ordering"]]]],[11,"partial_cmp","","",58,[[["self"],["argattribute"]],["option",["ordering"]]]],[11,"lt","","",58,[[["self"],["argattribute"]],["bool"]]],[11,"le","","",58,[[["self"],["argattribute"]],["bool"]]],[11,"gt","","",58,[[["self"],["argattribute"]],["bool"]]],[11,"ge","","",58,[[["self"],["argattribute"]],["bool"]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result",["error"]]]],[11,"from_iter","","",58,[[["t"]],["argattribute"]]],[11,"default","","",58,[[],["argattribute"]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result",["error"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",58,[[["self"],["argattribute"]],["argattribute"]]],[11,"cmp","","",58,[[["self"],["argattribute"]],["ordering"]]],[11,"cmp","","",48,[[["self"],["abi"]],["ordering"]]],[11,"decode","","",48,[[["__d"]],["result",["abi"]]]],[11,"eq","","",56,[[["self"],["conv"]],["bool"]]],[11,"eq","","",52,[[["self"],["reg"]],["bool"]]],[11,"ne","","",52,[[["self"],["reg"]],["bool"]]],[11,"eq","","",58,[[["self"],["argattribute"]],["bool"]]],[11,"ne","","",58,[[["self"],["argattribute"]],["bool"]]],[11,"eq","","",49,[[["self"],["passmode"]],["bool"]]],[11,"ne","","",49,[[["self"],["passmode"]],["bool"]]],[11,"eq","","",53,[[["self"],["uniform"]],["bool"]]],[11,"ne","","",53,[[["self"],["uniform"]],["bool"]]],[11,"eq","","",48,[[["self"],["abi"]],["bool"]]],[11,"eq","","",54,[[["self"],["casttarget"]],["bool"]]],[11,"ne","","",54,[[["self"],["casttarget"]],["bool"]]],[11,"eq","","",51,[[["self"],["regkind"]],["bool"]]],[11,"eq","","",50,[[["self"],["argattributes"]],["bool"]]],[11,"ne","","",50,[[["self"],["argattributes"]],["bool"]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",54,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",52,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",55,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",49,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result",["error"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",58,[[["self"],["argattribute"]],["argattribute"]]],[11,"hash","","",58,N],[11,"hash","","",48,N],[11,"sub_assign","","Disables all flags enabled in the set.",58,N],[11,"encode","","",48,[[["self"],["__s"]],["result"]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result",["error"]]]],[11,"extend","","",58,N],[11,"clone","","",52,[[["self"]],["reg"]]],[11,"clone","","",58,[[["self"]],["argattribute"]]],[11,"clone","","",48,[[["self"]],["abi"]]],[11,"clone","","",51,[[["self"]],["regkind"]]],[11,"clone","","",50,[[["self"]],["argattributes"]]],[11,"clone","","",56,[[["self"]],["conv"]]],[11,"clone","","",49,[[["self"]],["passmode"]]],[11,"clone","","",53,[[["self"]],["uniform"]]],[11,"clone","","",54,[[["self"]],["casttarget"]]],[11,"bitand","","Returns the intersection between the two sets of flags.",58,[[["self"],["argattribute"]],["argattribute"]]],[11,"bitor","","Returns the union of the two sets of flags.",58,[[["self"],["argattribute"]],["argattribute"]]],[11,"decode","rustc_codegen_llvm::attributes::attr","",71,[[["__d"]],["result",["deprecation"]]]],[11,"decode","","",68,[[["__d"]],["result",["inttype"]]]],[11,"decode","rustc_codegen_llvm::attributes","",67,[[["__d"]],["result",["inlineattr"]]]],[11,"decode","rustc_codegen_llvm::attributes::attr","",65,[[["__d"]],["result",["stability"]]]],[11,"decode","","",70,[[["__d"]],["result",["rustcdeprecation"]]]],[11,"decode","","",69,[[["__d"]],["result",["reprattr"]]]],[11,"decode","","",66,[[["__d"]],["result",["stabilitylevel"]]]],[11,"assert_receiver_is_total_eq","","",68,N],[11,"assert_receiver_is_total_eq","","",70,N],[11,"assert_receiver_is_total_eq","","",65,N],[11,"assert_receiver_is_total_eq","","",71,N],[11,"assert_receiver_is_total_eq","","",66,N],[11,"partial_cmp","","",66,[[["self"],["stabilitylevel"]],["option",["ordering"]]]],[11,"lt","","",66,[[["self"],["stabilitylevel"]],["bool"]]],[11,"le","","",66,[[["self"],["stabilitylevel"]],["bool"]]],[11,"gt","","",66,[[["self"],["stabilitylevel"]],["bool"]]],[11,"ge","","",66,[[["self"],["stabilitylevel"]],["bool"]]],[11,"partial_cmp","","",71,[[["self"],["deprecation"]],["option",["ordering"]]]],[11,"lt","","",71,[[["self"],["deprecation"]],["bool"]]],[11,"le","","",71,[[["self"],["deprecation"]],["bool"]]],[11,"gt","","",71,[[["self"],["deprecation"]],["bool"]]],[11,"ge","","",71,[[["self"],["deprecation"]],["bool"]]],[11,"partial_cmp","","",70,[[["self"],["rustcdeprecation"]],["option",["ordering"]]]],[11,"lt","","",70,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"le","","",70,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"gt","","",70,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"ge","","",70,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"eq","","",68,[[["self"],["inttype"]],["bool"]]],[11,"ne","","",68,[[["self"],["inttype"]],["bool"]]],[11,"eq","rustc_codegen_llvm::attributes","",67,[[["self"],["inlineattr"]],["bool"]]],[11,"eq","rustc_codegen_llvm::attributes::attr","",66,[[["self"],["stabilitylevel"]],["bool"]]],[11,"ne","","",66,[[["self"],["stabilitylevel"]],["bool"]]],[11,"eq","","",72,[[["self"],["unwindattr"]],["bool"]]],[11,"eq","","",71,[[["self"],["deprecation"]],["bool"]]],[11,"ne","","",71,[[["self"],["deprecation"]],["bool"]]],[11,"eq","","",70,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"ne","","",70,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"eq","","",69,[[["self"],["reprattr"]],["bool"]]],[11,"ne","","",69,[[["self"],["reprattr"]],["bool"]]],[11,"eq","","",65,[[["self"],["stability"]],["bool"]]],[11,"ne","","",65,[[["self"],["stability"]],["bool"]]],[11,"fmt","","",65,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",69,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",66,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",70,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",68,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",71,[[["self"],["formatter"]],["result",["error"]]]],[11,"hash","","",65,N],[11,"hash","","",71,N],[11,"hash","","",70,N],[11,"hash","rustc_codegen_llvm::attributes","",67,N],[11,"hash","rustc_codegen_llvm::attributes::attr","",68,N],[11,"hash","","",66,N],[11,"encode","rustc_codegen_llvm::attributes","",67,[[["self"],["__s"]],["result"]]],[11,"encode","rustc_codegen_llvm::attributes::attr","",69,[[["self"],["__s"]],["result"]]],[11,"encode","","",66,[[["self"],["__s"]],["result"]]],[11,"encode","","",68,[[["self"],["__s"]],["result"]]],[11,"encode","","",70,[[["self"],["__s"]],["result"]]],[11,"encode","","",71,[[["self"],["__s"]],["result"]]],[11,"encode","","",65,[[["self"],["__s"]],["result"]]],[11,"clone","","",71,[[["self"]],["deprecation"]]],[11,"clone","","",70,[[["self"]],["rustcdeprecation"]]],[11,"clone","","",69,[[["self"]],["reprattr"]]],[11,"clone","rustc_codegen_llvm::attributes","",67,[[["self"]],["inlineattr"]]],[11,"clone","rustc_codegen_llvm::attributes::attr","",66,[[["self"]],["stabilitylevel"]]],[11,"clone","","",68,[[["self"]],["inttype"]]],[11,"clone","","",72,[[["self"]],["unwindattr"]]],[11,"clone","","",65,[[["self"]],["stability"]]],[11,"as_mono_item","rustc_codegen_llvm::mono_item","",157,[[["self"]],["monoitem"]]],[11,"to_owned","rustc_codegen_llvm::abi","",49,[[["self"]],["t"]]],[11,"clone_into","","",49,N],[11,"from","","",49,[[["t"]],["t"]]],[11,"into","","",49,[[["self"]],["u"]]],[11,"try_from","","",49,[[["u"]],["result"]]],[11,"borrow","","",49,[[["self"]],["t"]]],[11,"try_into","","",49,[[["self"]],["result"]]],[11,"borrow_mut","","",49,[[["self"]],["t"]]],[11,"get_type_id","","",49,[[["self"]],["typeid"]]],[11,"not_found","","",49,[[["str"],["str"]],["e"]]],[11,"from_ok","","",49,[[["t"]],["t"]]],[11,"map_same","","",49,[[["self"],["f"]],["t"]]],[11,"new","","",50,[[],["argattributes"]]],[11,"set","","",50,[[["self"],["argattribute"]],["argattributes"]]],[11,"contains","","",50,[[["self"],["argattribute"]],["bool"]]],[11,"to_owned","","",50,[[["self"]],["t"]]],[11,"clone_into","","",50,N],[11,"from","","",50,[[["t"]],["t"]]],[11,"into","","",50,[[["self"]],["u"]]],[11,"try_from","","",50,[[["u"]],["result"]]],[11,"borrow","","",50,[[["self"]],["t"]]],[11,"try_into","","",50,[[["self"]],["result"]]],[11,"borrow_mut","","",50,[[["self"]],["t"]]],[11,"get_type_id","","",50,[[["self"]],["typeid"]]],[11,"not_found","","",50,[[["str"],["str"]],["e"]]],[11,"from_ok","","",50,[[["t"]],["t"]]],[11,"map_same","","",50,[[["self"],["f"]],["t"]]],[11,"to_owned","","",51,[[["self"]],["t"]]],[11,"clone_into","","",51,N],[11,"from","","",51,[[["t"]],["t"]]],[11,"into","","",51,[[["self"]],["u"]]],[11,"try_from","","",51,[[["u"]],["result"]]],[11,"borrow","","",51,[[["self"]],["t"]]],[11,"try_into","","",51,[[["self"]],["result"]]],[11,"borrow_mut","","",51,[[["self"]],["t"]]],[11,"get_type_id","","",51,[[["self"]],["typeid"]]],[11,"not_found","","",51,[[["str"],["str"]],["e"]]],[11,"from_ok","","",51,[[["t"]],["t"]]],[11,"map_same","","",51,[[["self"],["f"]],["t"]]],[11,"i8","","",52,[[],["reg"]]],[11,"i16","","",52,[[],["reg"]]],[11,"i32","","",52,[[],["reg"]]],[11,"i64","","",52,[[],["reg"]]],[11,"f32","","",52,[[],["reg"]]],[11,"f64","","",52,[[],["reg"]]],[11,"align","","",52,[[["self"],["c"]],["align"]]],[11,"to_owned","","",52,[[["self"]],["t"]]],[11,"clone_into","","",52,N],[11,"from","","",52,[[["t"]],["t"]]],[11,"into","","",52,[[["self"]],["u"]]],[11,"try_from","","",52,[[["u"]],["result"]]],[11,"borrow","","",52,[[["self"]],["t"]]],[11,"try_into","","",52,[[["self"]],["result"]]],[11,"borrow_mut","","",52,[[["self"]],["t"]]],[11,"get_type_id","","",52,[[["self"]],["typeid"]]],[11,"not_found","","",52,[[["str"],["str"]],["e"]]],[11,"from_ok","","",52,[[["t"]],["t"]]],[11,"map_same","","",52,[[["self"],["f"]],["t"]]],[11,"align","","",53,[[["self"],["c"]],["align"]]],[11,"to_owned","","",53,[[["self"]],["t"]]],[11,"clone_into","","",53,N],[11,"from","","",53,[[["t"]],["t"]]],[11,"into","","",53,[[["self"]],["u"]]],[11,"try_from","","",53,[[["u"]],["result"]]],[11,"borrow","","",53,[[["self"]],["t"]]],[11,"try_into","","",53,[[["self"]],["result"]]],[11,"borrow_mut","","",53,[[["self"]],["t"]]],[11,"get_type_id","","",53,[[["self"]],["typeid"]]],[11,"not_found","","",53,[[["str"],["str"]],["e"]]],[11,"from_ok","","",53,[[["t"]],["t"]]],[11,"map_same","","",53,[[["self"],["f"]],["t"]]],[11,"pair","","",54,[[["reg"],["reg"]],["casttarget"]]],[11,"size","","",54,[[["self"],["c"]],["size"]]],[11,"align","","",54,[[["self"],["c"]],["align"]]],[11,"to_owned","","",54,[[["self"]],["t"]]],[11,"clone_into","","",54,N],[11,"from","","",54,[[["t"]],["t"]]],[11,"into","","",54,[[["self"]],["u"]]],[11,"try_from","","",54,[[["u"]],["result"]]],[11,"borrow","","",54,[[["self"]],["t"]]],[11,"try_into","","",54,[[["self"]],["result"]]],[11,"borrow_mut","","",54,[[["self"]],["t"]]],[11,"get_type_id","","",54,[[["self"]],["typeid"]]],[11,"not_found","","",54,[[["str"],["str"]],["e"]]],[11,"from_ok","","",54,[[["t"]],["t"]]],[11,"map_same","","",54,[[["self"],["f"]],["t"]]],[11,"new","","",55,[[["tylayout"]],["argtype"]]],[11,"make_indirect","","",55,N],[11,"make_indirect_byval","","",55,N],[11,"extend_integer_width_to","","",55,N],[11,"cast_to","","",55,N],[11,"pad_with","","",55,N],[11,"is_indirect","","",55,[[["self"]],["bool"]]],[11,"is_sized_indirect","","",55,[[["self"]],["bool"]]],[11,"is_unsized_indirect","","",55,[[["self"]],["bool"]]],[11,"is_ignore","","",55,[[["self"]],["bool"]]],[11,"from","","",55,[[["t"]],["t"]]],[11,"into","","",55,[[["self"]],["u"]]],[11,"try_from","","",55,[[["u"]],["result"]]],[11,"borrow","","",55,[[["self"]],["t"]]],[11,"try_into","","",55,[[["self"]],["result"]]],[11,"borrow_mut","","",55,[[["self"]],["t"]]],[11,"get_type_id","","",55,[[["self"]],["typeid"]]],[11,"not_found","","",55,[[["str"],["str"]],["e"]]],[11,"from_ok","","",55,[[["t"]],["t"]]],[11,"map_same","","",55,[[["self"],["f"]],["t"]]],[11,"to_owned","","",56,[[["self"]],["t"]]],[11,"clone_into","","",56,N],[11,"from","","",56,[[["t"]],["t"]]],[11,"into","","",56,[[["self"]],["u"]]],[11,"try_from","","",56,[[["u"]],["result"]]],[11,"borrow","","",56,[[["self"]],["t"]]],[11,"try_into","","",56,[[["self"]],["result"]]],[11,"borrow_mut","","",56,[[["self"]],["t"]]],[11,"get_type_id","","",56,[[["self"]],["typeid"]]],[11,"not_found","","",56,[[["str"],["str"]],["e"]]],[11,"from_ok","","",56,[[["t"]],["t"]]],[11,"map_same","","",56,[[["self"],["f"]],["t"]]],[11,"adjust_for_cabi","","",57,[[["self"],["c"],["abi"]],["result",["string"]]]],[11,"from","","",57,[[["t"]],["t"]]],[11,"into","","",57,[[["self"]],["u"]]],[11,"try_from","","",57,[[["u"]],["result"]]],[11,"borrow","","",57,[[["self"]],["t"]]],[11,"try_into","","",57,[[["self"]],["result"]]],[11,"borrow_mut","","",57,[[["self"]],["t"]]],[11,"get_type_id","","",57,[[["self"]],["typeid"]]],[11,"not_found","","",57,[[["str"],["str"]],["e"]]],[11,"from_ok","","",57,[[["t"]],["t"]]],[11,"map_same","","",57,[[["self"],["f"]],["t"]]],[18,"ByVal","","",58,N],[18,"NoAlias","","",58,N],[18,"NoCapture","","",58,N],[18,"NonNull","","",58,N],[18,"ReadOnly","","",58,N],[18,"SExt","","",58,N],[18,"StructRet","","",58,N],[18,"ZExt","","",58,N],[18,"InReg","","",58,N],[11,"empty","","Returns an empty set of flags.",58,[[],["argattribute"]]],[11,"all","","Returns the set containing all flags.",58,[[],["argattribute"]]],[11,"bits","","Returns the raw value of the flags currently stored.",58,[[["self"]],["u16"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",58,[[["u16"]],["option",["argattribute"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",58,[[["u16"]],["argattribute"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",58,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",58,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",58,[[["self"],["argattribute"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",58,[[["self"],["argattribute"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",58,N],[11,"remove","","Removes the specified flags in-place.",58,N],[11,"toggle","","Toggles the specified flags in-place.",58,N],[11,"set","","Inserts or removes the specified flags depending on the passed value.",58,N],[11,"to_owned","","",58,[[["self"]],["t"]]],[11,"clone_into","","",58,N],[11,"from","","",58,[[["t"]],["t"]]],[11,"into","","",58,[[["self"]],["u"]]],[11,"try_from","","",58,[[["u"]],["result"]]],[11,"borrow","","",58,[[["self"]],["t"]]],[11,"try_into","","",58,[[["self"]],["result"]]],[11,"borrow_mut","","",58,[[["self"]],["t"]]],[11,"get_type_id","","",58,[[["self"]],["typeid"]]],[11,"not_found","","",58,[[["str"],["str"]],["e"]]],[11,"from_ok","","",58,[[["t"]],["t"]]],[11,"map_same","","",58,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_codegen_llvm::attributes::attr","",65,[[["self"]],["t"]]],[11,"clone_into","","",65,N],[11,"from","","",65,[[["t"]],["t"]]],[11,"into","","",65,[[["self"]],["u"]]],[11,"try_from","","",65,[[["u"]],["result"]]],[11,"borrow","","",65,[[["self"]],["t"]]],[11,"try_into","","",65,[[["self"]],["result"]]],[11,"borrow_mut","","",65,[[["self"]],["t"]]],[11,"get_type_id","","",65,[[["self"]],["typeid"]]],[11,"decode","","",65,[[["d"]],["result"]]],[11,"encode","","",65,[[["self"],["e"]],["result"]]],[11,"not_found","","",65,[[["str"],["str"]],["e"]]],[11,"from_ok","","",65,[[["t"]],["t"]]],[11,"map_same","","",65,[[["self"],["f"]],["t"]]],[11,"is_unstable","","",66,[[["self"]],["bool"]]],[11,"is_stable","","",66,[[["self"]],["bool"]]],[11,"to_owned","","",66,[[["self"]],["t"]]],[11,"clone_into","","",66,N],[11,"from","","",66,[[["t"]],["t"]]],[11,"into","","",66,[[["self"]],["u"]]],[11,"try_from","","",66,[[["u"]],["result"]]],[11,"borrow","","",66,[[["self"]],["t"]]],[11,"try_into","","",66,[[["self"]],["result"]]],[11,"borrow_mut","","",66,[[["self"]],["t"]]],[11,"get_type_id","","",66,[[["self"]],["typeid"]]],[11,"decode","","",66,[[["d"]],["result"]]],[11,"encode","","",66,[[["self"],["e"]],["result"]]],[11,"not_found","","",66,[[["str"],["str"]],["e"]]],[11,"from_ok","","",66,[[["t"]],["t"]]],[11,"map_same","","",66,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_codegen_llvm::attributes","",67,[[["self"]],["t"]]],[11,"clone_into","","",67,N],[11,"from","","",67,[[["t"]],["t"]]],[11,"into","","",67,[[["self"]],["u"]]],[11,"try_from","","",67,[[["u"]],["result"]]],[11,"borrow","","",67,[[["self"]],["t"]]],[11,"try_into","","",67,[[["self"]],["result"]]],[11,"borrow_mut","","",67,[[["self"]],["t"]]],[11,"get_type_id","","",67,[[["self"]],["typeid"]]],[11,"decode","","",67,[[["d"]],["result"]]],[11,"encode","","",67,[[["self"],["e"]],["result"]]],[11,"not_found","","",67,[[["str"],["str"]],["e"]]],[11,"from_ok","","",67,[[["t"]],["t"]]],[11,"map_same","","",67,[[["self"],["f"]],["t"]]],[11,"is_signed","rustc_codegen_llvm::attributes::attr","",68,[[["self"]],["bool"]]],[11,"to_owned","","",68,[[["self"]],["t"]]],[11,"clone_into","","",68,N],[11,"from","","",68,[[["t"]],["t"]]],[11,"into","","",68,[[["self"]],["u"]]],[11,"try_from","","",68,[[["u"]],["result"]]],[11,"borrow","","",68,[[["self"]],["t"]]],[11,"try_into","","",68,[[["self"]],["result"]]],[11,"borrow_mut","","",68,[[["self"]],["t"]]],[11,"get_type_id","","",68,[[["self"]],["typeid"]]],[11,"decode","","",68,[[["d"]],["result"]]],[11,"encode","","",68,[[["self"],["e"]],["result"]]],[11,"not_found","","",68,[[["str"],["str"]],["e"]]],[11,"from_ok","","",68,[[["t"]],["t"]]],[11,"map_same","","",68,[[["self"],["f"]],["t"]]],[11,"to_owned","","",69,[[["self"]],["t"]]],[11,"clone_into","","",69,N],[11,"from","","",69,[[["t"]],["t"]]],[11,"into","","",69,[[["self"]],["u"]]],[11,"try_from","","",69,[[["u"]],["result"]]],[11,"borrow","","",69,[[["self"]],["t"]]],[11,"try_into","","",69,[[["self"]],["result"]]],[11,"borrow_mut","","",69,[[["self"]],["t"]]],[11,"get_type_id","","",69,[[["self"]],["typeid"]]],[11,"decode","","",69,[[["d"]],["result"]]],[11,"encode","","",69,[[["self"],["e"]],["result"]]],[11,"not_found","","",69,[[["str"],["str"]],["e"]]],[11,"from_ok","","",69,[[["t"]],["t"]]],[11,"map_same","","",69,[[["self"],["f"]],["t"]]],[11,"to_owned","","",70,[[["self"]],["t"]]],[11,"clone_into","","",70,N],[11,"from","","",70,[[["t"]],["t"]]],[11,"into","","",70,[[["self"]],["u"]]],[11,"try_from","","",70,[[["u"]],["result"]]],[11,"borrow","","",70,[[["self"]],["t"]]],[11,"try_into","","",70,[[["self"]],["result"]]],[11,"borrow_mut","","",70,[[["self"]],["t"]]],[11,"get_type_id","","",70,[[["self"]],["typeid"]]],[11,"decode","","",70,[[["d"]],["result"]]],[11,"encode","","",70,[[["self"],["e"]],["result"]]],[11,"not_found","","",70,[[["str"],["str"]],["e"]]],[11,"from_ok","","",70,[[["t"]],["t"]]],[11,"map_same","","",70,[[["self"],["f"]],["t"]]],[11,"to_owned","","",71,[[["self"]],["t"]]],[11,"clone_into","","",71,N],[11,"from","","",71,[[["t"]],["t"]]],[11,"into","","",71,[[["self"]],["u"]]],[11,"try_from","","",71,[[["u"]],["result"]]],[11,"borrow","","",71,[[["self"]],["t"]]],[11,"try_into","","",71,[[["self"]],["result"]]],[11,"borrow_mut","","",71,[[["self"]],["t"]]],[11,"get_type_id","","",71,[[["self"]],["typeid"]]],[11,"decode","","",71,[[["d"]],["result"]]],[11,"encode","","",71,[[["self"],["e"]],["result"]]],[11,"not_found","","",71,[[["str"],["str"]],["e"]]],[11,"from_ok","","",71,[[["t"]],["t"]]],[11,"map_same","","",71,[[["self"],["f"]],["t"]]],[11,"to_owned","","",72,[[["self"]],["t"]]],[11,"clone_into","","",72,N],[11,"from","","",72,[[["t"]],["t"]]],[11,"into","","",72,[[["self"]],["u"]]],[11,"try_from","","",72,[[["u"]],["result"]]],[11,"borrow","","",72,[[["self"]],["t"]]],[11,"try_into","","",72,[[["self"]],["result"]]],[11,"borrow_mut","","",72,[[["self"]],["t"]]],[11,"get_type_id","","",72,[[["self"]],["typeid"]]],[11,"not_found","","",72,[[["str"],["str"]],["e"]]],[11,"from_ok","","",72,[[["t"]],["t"]]],[11,"map_same","","",72,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::base","",73,[[["t"]],["t"]]],[11,"into","","",73,[[["self"]],["u"]]],[11,"try_from","","",73,[[["u"]],["result"]]],[11,"borrow","","",73,[[["self"]],["t"]]],[11,"try_into","","",73,[[["self"]],["result"]]],[11,"borrow_mut","","",73,[[["self"]],["t"]]],[11,"get_type_id","","",73,[[["self"]],["typeid"]]],[11,"not_found","","",73,[[["str"],["str"]],["e"]]],[11,"from_ok","","",73,[[["t"]],["t"]]],[11,"map_same","","",73,[[["self"],["f"]],["t"]]],[11,"from","","",74,[[["t"]],["t"]]],[11,"into_iter","","",74,[[["self"]],["i"]]],[11,"into","","",74,[[["self"]],["u"]]],[11,"try_from","","",74,[[["u"]],["result"]]],[11,"borrow","","",74,[[["self"]],["t"]]],[11,"try_into","","",74,[[["self"]],["result"]]],[11,"borrow_mut","","",74,[[["self"]],["t"]]],[11,"get_type_id","","",74,[[["self"]],["typeid"]]],[11,"not_found","","",74,[[["str"],["str"]],["e"]]],[11,"from_ok","","",74,[[["t"]],["t"]]],[11,"map_same","","",74,[[["self"],["f"]],["t"]]],[11,"from","","",75,[[["t"]],["t"]]],[11,"into","","",75,[[["self"]],["u"]]],[11,"try_from","","",75,[[["u"]],["result"]]],[11,"borrow","","",75,[[["self"]],["t"]]],[11,"try_into","","",75,[[["self"]],["result"]]],[11,"borrow_mut","","",75,[[["self"]],["t"]]],[11,"get_type_id","","",75,[[["self"]],["typeid"]]],[11,"not_found","","",75,[[["str"],["str"]],["e"]]],[11,"from_ok","","",75,[[["t"]],["t"]]],[11,"map_same","","",75,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::builder","",76,[[["t"]],["t"]]],[11,"into","","",76,[[["self"]],["u"]]],[11,"try_from","","",76,[[["u"]],["result"]]],[11,"borrow","","",76,[[["self"]],["t"]]],[11,"try_into","","",76,[[["self"]],["result"]]],[11,"borrow_mut","","",76,[[["self"]],["t"]]],[11,"get_type_id","","",76,[[["self"]],["typeid"]]],[11,"not_found","","",76,[[["str"],["str"]],["e"]]],[11,"from_ok","","",76,[[["t"]],["t"]]],[11,"map_same","","",76,[[["self"],["f"]],["t"]]],[11,"to_owned","","",77,[[["self"]],["t"]]],[11,"clone_into","","",77,N],[11,"from","","",77,[[["t"]],["t"]]],[11,"into","","",77,[[["self"]],["u"]]],[11,"try_from","","",77,[[["u"]],["result"]]],[11,"borrow","","",77,[[["self"]],["t"]]],[11,"try_into","","",77,[[["self"]],["result"]]],[11,"borrow_mut","","",77,[[["self"]],["t"]]],[11,"get_type_id","","",77,[[["self"]],["typeid"]]],[11,"not_found","","",77,[[["str"],["str"]],["e"]]],[11,"from_ok","","",77,[[["t"]],["t"]]],[11,"map_same","","",77,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::common","",78,[[["t"]],["t"]]],[11,"into","","",78,[[["self"]],["u"]]],[11,"try_from","","",78,[[["u"]],["result"]]],[11,"borrow","","",78,[[["self"]],["t"]]],[11,"try_into","","",78,[[["self"]],["result"]]],[11,"borrow_mut","","",78,[[["self"]],["t"]]],[11,"get_type_id","","",78,[[["self"]],["typeid"]]],[11,"not_found","","",78,[[["str"],["str"]],["e"]]],[11,"from_ok","","",78,[[["t"]],["t"]]],[11,"map_same","","",78,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::context","",79,[[["t"]],["t"]]],[11,"into","","",79,[[["self"]],["u"]]],[11,"try_from","","",79,[[["u"]],["result"]]],[11,"borrow","","",79,[[["self"]],["t"]]],[11,"try_into","","",79,[[["self"]],["result"]]],[11,"borrow_mut","","",79,[[["self"]],["t"]]],[11,"get_type_id","","",79,[[["self"]],["typeid"]]],[11,"not_found","","",79,[[["str"],["str"]],["e"]]],[11,"from_ok","","",79,[[["t"]],["t"]]],[11,"map_same","","",79,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::debuginfo","",80,[[["t"]],["t"]]],[11,"into","","",80,[[["self"]],["u"]]],[11,"try_from","","",80,[[["u"]],["result"]]],[11,"borrow","","",80,[[["self"]],["t"]]],[11,"try_into","","",80,[[["self"]],["result"]]],[11,"borrow_mut","","",80,[[["self"]],["t"]]],[11,"get_type_id","","",80,[[["self"]],["typeid"]]],[11,"not_found","","",80,[[["str"],["str"]],["e"]]],[11,"from_ok","","",80,[[["t"]],["t"]]],[11,"map_same","","",80,[[["self"],["f"]],["t"]]],[11,"from","","",81,[[["t"]],["t"]]],[11,"into","","",81,[[["self"]],["u"]]],[11,"try_from","","",81,[[["u"]],["result"]]],[11,"borrow","","",81,[[["self"]],["t"]]],[11,"try_into","","",81,[[["self"]],["result"]]],[11,"borrow_mut","","",81,[[["self"]],["t"]]],[11,"get_type_id","","",81,[[["self"]],["typeid"]]],[11,"not_found","","",81,[[["str"],["str"]],["e"]]],[11,"from_ok","","",81,[[["t"]],["t"]]],[11,"map_same","","",81,[[["self"],["f"]],["t"]]],[11,"from","","",82,[[["t"]],["t"]]],[11,"into","","",82,[[["self"]],["u"]]],[11,"try_from","","",82,[[["u"]],["result"]]],[11,"borrow","","",82,[[["self"]],["t"]]],[11,"try_into","","",82,[[["self"]],["result"]]],[11,"borrow_mut","","",82,[[["self"]],["t"]]],[11,"get_type_id","","",82,[[["self"]],["typeid"]]],[11,"not_found","","",82,[[["str"],["str"]],["e"]]],[11,"from_ok","","",82,[[["t"]],["t"]]],[11,"map_same","","",82,[[["self"],["f"]],["t"]]],[11,"from","","",83,[[["t"]],["t"]]],[11,"into","","",83,[[["self"]],["u"]]],[11,"try_from","","",83,[[["u"]],["result"]]],[11,"borrow","","",83,[[["self"]],["t"]]],[11,"try_into","","",83,[[["self"]],["result"]]],[11,"borrow_mut","","",83,[[["self"]],["t"]]],[11,"get_type_id","","",83,[[["self"]],["typeid"]]],[11,"not_found","","",83,[[["str"],["str"]],["e"]]],[11,"from_ok","","",83,[[["t"]],["t"]]],[11,"map_same","","",83,[[["self"],["f"]],["t"]]],[11,"from","","",84,[[["t"]],["t"]]],[11,"into","","",84,[[["self"]],["u"]]],[11,"try_from","","",84,[[["u"]],["result"]]],[11,"borrow","","",84,[[["self"]],["t"]]],[11,"try_into","","",84,[[["self"]],["result"]]],[11,"borrow_mut","","",84,[[["self"]],["t"]]],[11,"get_type_id","","",84,[[["self"]],["typeid"]]],[11,"not_found","","",84,[[["str"],["str"]],["e"]]],[11,"from_ok","","",84,[[["t"]],["t"]]],[11,"map_same","","",84,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_codegen_llvm::debuginfo::metadata","",85,[[["self"]],["t"]]],[11,"clone_into","","",85,N],[11,"from","","",85,[[["t"]],["t"]]],[11,"into","","",85,[[["self"]],["u"]]],[11,"try_from","","",85,[[["u"]],["result"]]],[11,"borrow","","",85,[[["self"]],["t"]]],[11,"try_into","","",85,[[["self"]],["result"]]],[11,"borrow_mut","","",85,[[["self"]],["t"]]],[11,"get_type_id","","",85,[[["self"]],["typeid"]]],[11,"not_found","","",85,[[["str"],["str"]],["e"]]],[11,"from_ok","","",85,[[["t"]],["t"]]],[11,"map_same","","",85,[[["self"],["f"]],["t"]]],[11,"from","","",86,[[["t"]],["t"]]],[11,"into","","",86,[[["self"]],["u"]]],[11,"try_from","","",86,[[["u"]],["result"]]],[11,"borrow","","",86,[[["self"]],["t"]]],[11,"try_into","","",86,[[["self"]],["result"]]],[11,"borrow_mut","","",86,[[["self"]],["t"]]],[11,"get_type_id","","",86,[[["self"]],["typeid"]]],[11,"not_found","","",86,[[["str"],["str"]],["e"]]],[11,"from_ok","","",86,[[["t"]],["t"]]],[11,"map_same","","",86,[[["self"],["f"]],["t"]]],[11,"from","","",87,[[["t"]],["t"]]],[11,"into","","",87,[[["self"]],["u"]]],[11,"try_from","","",87,[[["u"]],["result"]]],[11,"borrow","","",87,[[["self"]],["t"]]],[11,"try_into","","",87,[[["self"]],["result"]]],[11,"borrow_mut","","",87,[[["self"]],["t"]]],[11,"get_type_id","","",87,[[["self"]],["typeid"]]],[11,"not_found","","",87,[[["str"],["str"]],["e"]]],[11,"from_ok","","",87,[[["t"]],["t"]]],[11,"map_same","","",87,[[["self"],["f"]],["t"]]],[11,"from","","",88,[[["t"]],["t"]]],[11,"into","","",88,[[["self"]],["u"]]],[11,"try_from","","",88,[[["u"]],["result"]]],[11,"borrow","","",88,[[["self"]],["t"]]],[11,"try_into","","",88,[[["self"]],["result"]]],[11,"borrow_mut","","",88,[[["self"]],["t"]]],[11,"get_type_id","","",88,[[["self"]],["typeid"]]],[11,"not_found","","",88,[[["str"],["str"]],["e"]]],[11,"from_ok","","",88,[[["t"]],["t"]]],[11,"map_same","","",88,[[["self"],["f"]],["t"]]],[11,"from","","",89,[[["t"]],["t"]]],[11,"into","","",89,[[["self"]],["u"]]],[11,"try_from","","",89,[[["u"]],["result"]]],[11,"borrow","","",89,[[["self"]],["t"]]],[11,"try_into","","",89,[[["self"]],["result"]]],[11,"borrow_mut","","",89,[[["self"]],["t"]]],[11,"get_type_id","","",89,[[["self"]],["typeid"]]],[11,"not_found","","",89,[[["str"],["str"]],["e"]]],[11,"from_ok","","",89,[[["t"]],["t"]]],[11,"map_same","","",89,[[["self"],["f"]],["t"]]],[11,"from","","",90,[[["t"]],["t"]]],[11,"into","","",90,[[["self"]],["u"]]],[11,"try_from","","",90,[[["u"]],["result"]]],[11,"borrow","","",90,[[["self"]],["t"]]],[11,"try_into","","",90,[[["self"]],["result"]]],[11,"borrow_mut","","",90,[[["self"]],["t"]]],[11,"get_type_id","","",90,[[["self"]],["typeid"]]],[11,"not_found","","",90,[[["str"],["str"]],["e"]]],[11,"from_ok","","",90,[[["t"]],["t"]]],[11,"map_same","","",90,[[["self"],["f"]],["t"]]],[11,"from","","",91,[[["t"]],["t"]]],[11,"into","","",91,[[["self"]],["u"]]],[11,"try_from","","",91,[[["u"]],["result"]]],[11,"borrow","","",91,[[["self"]],["t"]]],[11,"try_into","","",91,[[["self"]],["result"]]],[11,"borrow_mut","","",91,[[["self"]],["t"]]],[11,"get_type_id","","",91,[[["self"]],["typeid"]]],[11,"not_found","","",91,[[["str"],["str"]],["e"]]],[11,"from_ok","","",91,[[["t"]],["t"]]],[11,"map_same","","",91,[[["self"],["f"]],["t"]]],[11,"from","","",92,[[["t"]],["t"]]],[11,"into","","",92,[[["self"]],["u"]]],[11,"try_from","","",92,[[["u"]],["result"]]],[11,"borrow","","",92,[[["self"]],["t"]]],[11,"try_into","","",92,[[["self"]],["result"]]],[11,"borrow_mut","","",92,[[["self"]],["t"]]],[11,"get_type_id","","",92,[[["self"]],["typeid"]]],[11,"not_found","","",92,[[["str"],["str"]],["e"]]],[11,"from_ok","","",92,[[["t"]],["t"]]],[11,"map_same","","",92,[[["self"],["f"]],["t"]]],[11,"from","","",93,[[["t"]],["t"]]],[11,"into","","",93,[[["self"]],["u"]]],[11,"try_from","","",93,[[["u"]],["result"]]],[11,"borrow","","",93,[[["self"]],["t"]]],[11,"try_into","","",93,[[["self"]],["result"]]],[11,"borrow_mut","","",93,[[["self"]],["t"]]],[11,"get_type_id","","",93,[[["self"]],["typeid"]]],[11,"not_found","","",93,[[["str"],["str"]],["e"]]],[11,"from_ok","","",93,[[["t"]],["t"]]],[11,"map_same","","",93,[[["self"],["f"]],["t"]]],[11,"from","","",94,[[["t"]],["t"]]],[11,"into","","",94,[[["self"]],["u"]]],[11,"try_from","","",94,[[["u"]],["result"]]],[11,"borrow","","",94,[[["self"]],["t"]]],[11,"try_into","","",94,[[["self"]],["result"]]],[11,"borrow_mut","","",94,[[["self"]],["t"]]],[11,"get_type_id","","",94,[[["self"]],["typeid"]]],[11,"not_found","","",94,[[["str"],["str"]],["e"]]],[11,"from_ok","","",94,[[["t"]],["t"]]],[11,"map_same","","",94,[[["self"],["f"]],["t"]]],[11,"from","","",95,[[["t"]],["t"]]],[11,"into","","",95,[[["self"]],["u"]]],[11,"try_from","","",95,[[["u"]],["result"]]],[11,"borrow","","",95,[[["self"]],["t"]]],[11,"try_into","","",95,[[["self"]],["result"]]],[11,"borrow_mut","","",95,[[["self"]],["t"]]],[11,"get_type_id","","",95,[[["self"]],["typeid"]]],[11,"not_found","","",95,[[["str"],["str"]],["e"]]],[11,"from_ok","","",95,[[["t"]],["t"]]],[11,"map_same","","",95,[[["self"],["f"]],["t"]]],[11,"to_owned","","",96,[[["self"]],["t"]]],[11,"clone_into","","",96,N],[11,"from","","",96,[[["t"]],["t"]]],[11,"into","","",96,[[["self"]],["u"]]],[11,"try_from","","",96,[[["u"]],["result"]]],[11,"borrow","","",96,[[["self"]],["t"]]],[11,"try_into","","",96,[[["self"]],["result"]]],[11,"borrow_mut","","",96,[[["self"]],["t"]]],[11,"get_type_id","","",96,[[["self"]],["typeid"]]],[11,"not_found","","",96,[[["str"],["str"]],["e"]]],[11,"from_ok","","",96,[[["t"]],["t"]]],[11,"map_same","","",96,[[["self"],["f"]],["t"]]],[11,"eq","rustc_codegen_llvm::llvm","",165,[[["self"],["self"]],["bool"]]],[11,"hash","","",165,[[["self"],["h"]]]],[11,"fmt","","",165,[[["self"],["formatter"]],["result"]]],[11,"to_owned","rustc_codegen_llvm::debuginfo::create_scope_map","",97,[[["self"]],["t"]]],[11,"clone_into","","",97,N],[11,"from","","",97,[[["t"]],["t"]]],[11,"into","","",97,[[["self"]],["u"]]],[11,"try_from","","",97,[[["u"]],["result"]]],[11,"borrow","","",97,[[["self"]],["t"]]],[11,"try_into","","",97,[[["self"]],["result"]]],[11,"borrow_mut","","",97,[[["self"]],["t"]]],[11,"get_type_id","","",97,[[["self"]],["typeid"]]],[11,"not_found","","",97,[[["str"],["str"]],["e"]]],[11,"from_ok","","",97,[[["t"]],["t"]]],[11,"map_same","","",97,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_codegen_llvm::debuginfo::source_loc","",98,[[["self"]],["t"]]],[11,"clone_into","","",98,N],[11,"from","","",98,[[["t"]],["t"]]],[11,"into","","",98,[[["self"]],["u"]]],[11,"try_from","","",98,[[["u"]],["result"]]],[11,"borrow","","",98,[[["self"]],["t"]]],[11,"try_into","","",98,[[["self"]],["result"]]],[11,"borrow_mut","","",98,[[["self"]],["t"]]],[11,"get_type_id","","",98,[[["self"]],["typeid"]]],[11,"not_found","","",98,[[["str"],["str"]],["e"]]],[11,"from_ok","","",98,[[["t"]],["t"]]],[11,"map_same","","",98,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::llvm","",99,[[["t"]],["t"]]],[11,"into","","",99,[[["self"]],["u"]]],[11,"try_from","","",99,[[["u"]],["result"]]],[11,"borrow","","",99,[[["self"]],["t"]]],[11,"try_into","","",99,[[["self"]],["result"]]],[11,"borrow_mut","","",99,[[["self"]],["t"]]],[11,"get_type_id","","",99,[[["self"]],["typeid"]]],[11,"not_found","","",99,[[["str"],["str"]],["e"]]],[11,"from_ok","","",99,[[["t"]],["t"]]],[11,"map_same","","",99,[[["self"],["f"]],["t"]]],[11,"borrow","","",100,[[["self"]],["t"]]],[11,"borrow_mut","","",100,[[["self"]],["t"]]],[11,"get_type_id","","",100,[[["self"]],["typeid"]]],[11,"borrow","","",101,[[["self"]],["t"]]],[11,"borrow_mut","","",101,[[["self"]],["t"]]],[11,"get_type_id","","",101,[[["self"]],["typeid"]]],[11,"borrow","","",102,[[["self"]],["t"]]],[11,"borrow_mut","","",102,[[["self"]],["t"]]],[11,"get_type_id","","",102,[[["self"]],["typeid"]]],[11,"borrow","","",103,[[["self"]],["t"]]],[11,"borrow_mut","","",103,[[["self"]],["t"]]],[11,"get_type_id","","",103,[[["self"]],["typeid"]]],[11,"borrow","","",104,[[["self"]],["t"]]],[11,"borrow_mut","","",104,[[["self"]],["t"]]],[11,"get_type_id","","",104,[[["self"]],["typeid"]]],[11,"borrow","","",105,[[["self"]],["t"]]],[11,"borrow_mut","","",105,[[["self"]],["t"]]],[11,"get_type_id","","",105,[[["self"]],["typeid"]]],[11,"borrow","","",106,[[["self"]],["t"]]],[11,"borrow_mut","","",106,[[["self"]],["t"]]],[11,"get_type_id","","",106,[[["self"]],["typeid"]]],[11,"borrow","","",107,[[["self"]],["t"]]],[11,"borrow_mut","","",107,[[["self"]],["t"]]],[11,"get_type_id","","",107,[[["self"]],["typeid"]]],[11,"from","","",108,[[["t"]],["t"]]],[11,"into","","",108,[[["self"]],["u"]]],[11,"try_from","","",108,[[["u"]],["result"]]],[11,"borrow","","",108,[[["self"]],["t"]]],[11,"try_into","","",108,[[["self"]],["result"]]],[11,"borrow_mut","","",108,[[["self"]],["t"]]],[11,"get_type_id","","",108,[[["self"]],["typeid"]]],[11,"not_found","","",108,[[["str"],["str"]],["e"]]],[11,"from_ok","","",108,[[["t"]],["t"]]],[11,"map_same","","",108,[[["self"],["f"]],["t"]]],[11,"from","","",109,[[["t"]],["t"]]],[11,"into","","",109,[[["self"]],["u"]]],[11,"try_from","","",109,[[["u"]],["result"]]],[11,"borrow","","",109,[[["self"]],["t"]]],[11,"try_into","","",109,[[["self"]],["result"]]],[11,"borrow_mut","","",109,[[["self"]],["t"]]],[11,"get_type_id","","",109,[[["self"]],["typeid"]]],[11,"not_found","","",109,[[["str"],["str"]],["e"]]],[11,"from_ok","","",109,[[["t"]],["t"]]],[11,"map_same","","",109,[[["self"],["f"]],["t"]]],[11,"from","","",110,[[["t"]],["t"]]],[11,"into","","",110,[[["self"]],["u"]]],[11,"try_from","","",110,[[["u"]],["result"]]],[11,"borrow","","",110,[[["self"]],["t"]]],[11,"try_into","","",110,[[["self"]],["result"]]],[11,"borrow_mut","","",110,[[["self"]],["t"]]],[11,"get_type_id","","",110,[[["self"]],["typeid"]]],[11,"not_found","","",110,[[["str"],["str"]],["e"]]],[11,"from_ok","","",110,[[["t"]],["t"]]],[11,"map_same","","",110,[[["self"],["f"]],["t"]]],[11,"from","","",111,[[["t"]],["t"]]],[11,"into","","",111,[[["self"]],["u"]]],[11,"try_from","","",111,[[["u"]],["result"]]],[11,"borrow","","",111,[[["self"]],["t"]]],[11,"try_into","","",111,[[["self"]],["result"]]],[11,"borrow_mut","","",111,[[["self"]],["t"]]],[11,"get_type_id","","",111,[[["self"]],["typeid"]]],[11,"not_found","","",111,[[["str"],["str"]],["e"]]],[11,"from_ok","","",111,[[["t"]],["t"]]],[11,"map_same","","",111,[[["self"],["f"]],["t"]]],[11,"to_owned","","",112,[[["self"]],["t"]]],[11,"clone_into","","",112,N],[11,"from","","",112,[[["t"]],["t"]]],[11,"into","","",112,[[["self"]],["u"]]],[11,"try_from","","",112,[[["u"]],["result"]]],[11,"borrow","","",112,[[["self"]],["t"]]],[11,"try_into","","",112,[[["self"]],["result"]]],[11,"borrow_mut","","",112,[[["self"]],["t"]]],[11,"get_type_id","","",112,[[["self"]],["typeid"]]],[11,"not_found","","",112,[[["str"],["str"]],["e"]]],[11,"from_ok","","",112,[[["t"]],["t"]]],[11,"map_same","","",112,[[["self"],["f"]],["t"]]],[11,"to_owned","","",113,[[["self"]],["t"]]],[11,"clone_into","","",113,N],[11,"from","","",113,[[["t"]],["t"]]],[11,"into","","",113,[[["self"]],["u"]]],[11,"try_from","","",113,[[["u"]],["result"]]],[11,"borrow","","",113,[[["self"]],["t"]]],[11,"try_into","","",113,[[["self"]],["result"]]],[11,"borrow_mut","","",113,[[["self"]],["t"]]],[11,"get_type_id","","",113,[[["self"]],["typeid"]]],[11,"not_found","","",113,[[["str"],["str"]],["e"]]],[11,"from_ok","","",113,[[["t"]],["t"]]],[11,"map_same","","",113,[[["self"],["f"]],["t"]]],[11,"to_owned","","",114,[[["self"]],["t"]]],[11,"clone_into","","",114,N],[11,"from","","",114,[[["t"]],["t"]]],[11,"into","","",114,[[["self"]],["u"]]],[11,"try_from","","",114,[[["u"]],["result"]]],[11,"borrow","","",114,[[["self"]],["t"]]],[11,"try_into","","",114,[[["self"]],["result"]]],[11,"borrow_mut","","",114,[[["self"]],["t"]]],[11,"get_type_id","","",114,[[["self"]],["typeid"]]],[11,"not_found","","",114,[[["str"],["str"]],["e"]]],[11,"from_ok","","",114,[[["t"]],["t"]]],[11,"map_same","","",114,[[["self"],["f"]],["t"]]],[11,"to_owned","","",115,[[["self"]],["t"]]],[11,"clone_into","","",115,N],[11,"from","","",115,[[["t"]],["t"]]],[11,"into","","",115,[[["self"]],["u"]]],[11,"try_from","","",115,[[["u"]],["result"]]],[11,"borrow","","",115,[[["self"]],["t"]]],[11,"try_into","","",115,[[["self"]],["result"]]],[11,"borrow_mut","","",115,[[["self"]],["t"]]],[11,"get_type_id","","",115,[[["self"]],["typeid"]]],[11,"not_found","","",115,[[["str"],["str"]],["e"]]],[11,"from_ok","","",115,[[["t"]],["t"]]],[11,"map_same","","",115,[[["self"],["f"]],["t"]]],[11,"to_owned","","",116,[[["self"]],["t"]]],[11,"clone_into","","",116,N],[11,"from","","",116,[[["t"]],["t"]]],[11,"into","","",116,[[["self"]],["u"]]],[11,"try_from","","",116,[[["u"]],["result"]]],[11,"borrow","","",116,[[["self"]],["t"]]],[11,"try_into","","",116,[[["self"]],["result"]]],[11,"borrow_mut","","",116,[[["self"]],["t"]]],[11,"get_type_id","","",116,[[["self"]],["typeid"]]],[11,"not_found","","",116,[[["str"],["str"]],["e"]]],[11,"from_ok","","",116,[[["t"]],["t"]]],[11,"map_same","","",116,[[["self"],["f"]],["t"]]],[11,"to_owned","","",117,[[["self"]],["t"]]],[11,"clone_into","","",117,N],[11,"from","","",117,[[["t"]],["t"]]],[11,"into","","",117,[[["self"]],["u"]]],[11,"try_from","","",117,[[["u"]],["result"]]],[11,"borrow","","",117,[[["self"]],["t"]]],[11,"try_into","","",117,[[["self"]],["result"]]],[11,"borrow_mut","","",117,[[["self"]],["t"]]],[11,"get_type_id","","",117,[[["self"]],["typeid"]]],[11,"not_found","","",117,[[["str"],["str"]],["e"]]],[11,"from_ok","","",117,[[["t"]],["t"]]],[11,"map_same","","",117,[[["self"],["f"]],["t"]]],[11,"to_owned","","",118,[[["self"]],["t"]]],[11,"clone_into","","",118,N],[11,"from","","",118,[[["t"]],["t"]]],[11,"into","","",118,[[["self"]],["u"]]],[11,"try_from","","",118,[[["u"]],["result"]]],[11,"borrow","","",118,[[["self"]],["t"]]],[11,"try_into","","",118,[[["self"]],["result"]]],[11,"borrow_mut","","",118,[[["self"]],["t"]]],[11,"get_type_id","","",118,[[["self"]],["typeid"]]],[11,"not_found","","",118,[[["str"],["str"]],["e"]]],[11,"from_ok","","",118,[[["t"]],["t"]]],[11,"map_same","","",118,[[["self"],["f"]],["t"]]],[11,"to_owned","","",119,[[["self"]],["t"]]],[11,"clone_into","","",119,N],[11,"from","","",119,[[["t"]],["t"]]],[11,"into","","",119,[[["self"]],["u"]]],[11,"try_from","","",119,[[["u"]],["result"]]],[11,"borrow","","",119,[[["self"]],["t"]]],[11,"try_into","","",119,[[["self"]],["result"]]],[11,"borrow_mut","","",119,[[["self"]],["t"]]],[11,"get_type_id","","",119,[[["self"]],["typeid"]]],[11,"not_found","","",119,[[["str"],["str"]],["e"]]],[11,"from_ok","","",119,[[["t"]],["t"]]],[11,"map_same","","",119,[[["self"],["f"]],["t"]]],[11,"to_owned","","",120,[[["self"]],["t"]]],[11,"clone_into","","",120,N],[11,"from","","",120,[[["t"]],["t"]]],[11,"into","","",120,[[["self"]],["u"]]],[11,"try_from","","",120,[[["u"]],["result"]]],[11,"borrow","","",120,[[["self"]],["t"]]],[11,"try_into","","",120,[[["self"]],["result"]]],[11,"borrow_mut","","",120,[[["self"]],["t"]]],[11,"get_type_id","","",120,[[["self"]],["typeid"]]],[11,"not_found","","",120,[[["str"],["str"]],["e"]]],[11,"from_ok","","",120,[[["t"]],["t"]]],[11,"map_same","","",120,[[["self"],["f"]],["t"]]],[11,"to_owned","","",121,[[["self"]],["t"]]],[11,"clone_into","","",121,N],[11,"from","","",121,[[["t"]],["t"]]],[11,"into","","",121,[[["self"]],["u"]]],[11,"try_from","","",121,[[["u"]],["result"]]],[11,"borrow","","",121,[[["self"]],["t"]]],[11,"try_into","","",121,[[["self"]],["result"]]],[11,"borrow_mut","","",121,[[["self"]],["t"]]],[11,"get_type_id","","",121,[[["self"]],["typeid"]]],[11,"not_found","","",121,[[["str"],["str"]],["e"]]],[11,"from_ok","","",121,[[["t"]],["t"]]],[11,"map_same","","",121,[[["self"],["f"]],["t"]]],[11,"to_owned","","",122,[[["self"]],["t"]]],[11,"clone_into","","",122,N],[11,"from","","",122,[[["t"]],["t"]]],[11,"into","","",122,[[["self"]],["u"]]],[11,"try_from","","",122,[[["u"]],["result"]]],[11,"borrow","","",122,[[["self"]],["t"]]],[11,"try_into","","",122,[[["self"]],["result"]]],[11,"borrow_mut","","",122,[[["self"]],["t"]]],[11,"get_type_id","","",122,[[["self"]],["typeid"]]],[11,"not_found","","",122,[[["str"],["str"]],["e"]]],[11,"from_ok","","",122,[[["t"]],["t"]]],[11,"map_same","","",122,[[["self"],["f"]],["t"]]],[11,"to_owned","","",123,[[["self"]],["t"]]],[11,"clone_into","","",123,N],[11,"from","","",123,[[["t"]],["t"]]],[11,"into","","",123,[[["self"]],["u"]]],[11,"try_from","","",123,[[["u"]],["result"]]],[11,"borrow","","",123,[[["self"]],["t"]]],[11,"try_into","","",123,[[["self"]],["result"]]],[11,"borrow_mut","","",123,[[["self"]],["t"]]],[11,"get_type_id","","",123,[[["self"]],["typeid"]]],[11,"not_found","","",123,[[["str"],["str"]],["e"]]],[11,"from_ok","","",123,[[["t"]],["t"]]],[11,"map_same","","",123,[[["self"],["f"]],["t"]]],[11,"to_owned","","",124,[[["self"]],["t"]]],[11,"clone_into","","",124,N],[11,"from","","",124,[[["t"]],["t"]]],[11,"into","","",124,[[["self"]],["u"]]],[11,"try_from","","",124,[[["u"]],["result"]]],[11,"borrow","","",124,[[["self"]],["t"]]],[11,"try_into","","",124,[[["self"]],["result"]]],[11,"borrow_mut","","",124,[[["self"]],["t"]]],[11,"get_type_id","","",124,[[["self"]],["typeid"]]],[11,"not_found","","",124,[[["str"],["str"]],["e"]]],[11,"from_ok","","",124,[[["t"]],["t"]]],[11,"map_same","","",124,[[["self"],["f"]],["t"]]],[11,"to_owned","","",125,[[["self"]],["t"]]],[11,"clone_into","","",125,N],[11,"from","","",125,[[["t"]],["t"]]],[11,"into","","",125,[[["self"]],["u"]]],[11,"try_from","","",125,[[["u"]],["result"]]],[11,"borrow","","",125,[[["self"]],["t"]]],[11,"try_into","","",125,[[["self"]],["result"]]],[11,"borrow_mut","","",125,[[["self"]],["t"]]],[11,"get_type_id","","",125,[[["self"]],["typeid"]]],[11,"not_found","","",125,[[["str"],["str"]],["e"]]],[11,"from_ok","","",125,[[["t"]],["t"]]],[11,"map_same","","",125,[[["self"],["f"]],["t"]]],[11,"to_owned","","",126,[[["self"]],["t"]]],[11,"clone_into","","",126,N],[11,"from","","",126,[[["t"]],["t"]]],[11,"into","","",126,[[["self"]],["u"]]],[11,"try_from","","",126,[[["u"]],["result"]]],[11,"borrow","","",126,[[["self"]],["t"]]],[11,"try_into","","",126,[[["self"]],["result"]]],[11,"borrow_mut","","",126,[[["self"]],["t"]]],[11,"get_type_id","","",126,[[["self"]],["typeid"]]],[11,"not_found","","",126,[[["str"],["str"]],["e"]]],[11,"from_ok","","",126,[[["t"]],["t"]]],[11,"map_same","","",126,[[["self"],["f"]],["t"]]],[11,"to_owned","","",127,[[["self"]],["t"]]],[11,"clone_into","","",127,N],[11,"from","","",127,[[["t"]],["t"]]],[11,"into","","",127,[[["self"]],["u"]]],[11,"try_from","","",127,[[["u"]],["result"]]],[11,"borrow","","",127,[[["self"]],["t"]]],[11,"try_into","","",127,[[["self"]],["result"]]],[11,"borrow_mut","","",127,[[["self"]],["t"]]],[11,"get_type_id","","",127,[[["self"]],["typeid"]]],[11,"not_found","","",127,[[["str"],["str"]],["e"]]],[11,"from_ok","","",127,[[["t"]],["t"]]],[11,"map_same","","",127,[[["self"],["f"]],["t"]]],[11,"to_owned","","",128,[[["self"]],["t"]]],[11,"clone_into","","",128,N],[11,"from","","",128,[[["t"]],["t"]]],[11,"into","","",128,[[["self"]],["u"]]],[11,"try_from","","",128,[[["u"]],["result"]]],[11,"borrow","","",128,[[["self"]],["t"]]],[11,"try_into","","",128,[[["self"]],["result"]]],[11,"borrow_mut","","",128,[[["self"]],["t"]]],[11,"get_type_id","","",128,[[["self"]],["typeid"]]],[11,"not_found","","",128,[[["str"],["str"]],["e"]]],[11,"from_ok","","",128,[[["t"]],["t"]]],[11,"map_same","","",128,[[["self"],["f"]],["t"]]],[11,"to_owned","","",129,[[["self"]],["t"]]],[11,"clone_into","","",129,N],[11,"from","","",129,[[["t"]],["t"]]],[11,"into","","",129,[[["self"]],["u"]]],[11,"try_from","","",129,[[["u"]],["result"]]],[11,"borrow","","",129,[[["self"]],["t"]]],[11,"try_into","","",129,[[["self"]],["result"]]],[11,"borrow_mut","","",129,[[["self"]],["t"]]],[11,"get_type_id","","",129,[[["self"]],["typeid"]]],[11,"not_found","","",129,[[["str"],["str"]],["e"]]],[11,"from_ok","","",129,[[["t"]],["t"]]],[11,"map_same","","",129,[[["self"],["f"]],["t"]]],[11,"to_owned","","",130,[[["self"]],["t"]]],[11,"clone_into","","",130,N],[11,"from","","",130,[[["t"]],["t"]]],[11,"into","","",130,[[["self"]],["u"]]],[11,"try_from","","",130,[[["u"]],["result"]]],[11,"borrow","","",130,[[["self"]],["t"]]],[11,"try_into","","",130,[[["self"]],["result"]]],[11,"borrow_mut","","",130,[[["self"]],["t"]]],[11,"get_type_id","","",130,[[["self"]],["typeid"]]],[11,"not_found","","",130,[[["str"],["str"]],["e"]]],[11,"from_ok","","",130,[[["t"]],["t"]]],[11,"map_same","","",130,[[["self"],["f"]],["t"]]],[11,"to_owned","","",131,[[["self"]],["t"]]],[11,"clone_into","","",131,N],[11,"from","","",131,[[["t"]],["t"]]],[11,"into","","",131,[[["self"]],["u"]]],[11,"try_from","","",131,[[["u"]],["result"]]],[11,"borrow","","",131,[[["self"]],["t"]]],[11,"try_into","","",131,[[["self"]],["result"]]],[11,"borrow_mut","","",131,[[["self"]],["t"]]],[11,"get_type_id","","",131,[[["self"]],["typeid"]]],[11,"not_found","","",131,[[["str"],["str"]],["e"]]],[11,"from_ok","","",131,[[["t"]],["t"]]],[11,"map_same","","",131,[[["self"],["f"]],["t"]]],[11,"to_owned","","",132,[[["self"]],["t"]]],[11,"clone_into","","",132,N],[11,"from","","",132,[[["t"]],["t"]]],[11,"into","","",132,[[["self"]],["u"]]],[11,"try_from","","",132,[[["u"]],["result"]]],[11,"borrow","","",132,[[["self"]],["t"]]],[11,"try_into","","",132,[[["self"]],["result"]]],[11,"borrow_mut","","",132,[[["self"]],["t"]]],[11,"get_type_id","","",132,[[["self"]],["typeid"]]],[11,"not_found","","",132,[[["str"],["str"]],["e"]]],[11,"from_ok","","",132,[[["t"]],["t"]]],[11,"map_same","","",132,[[["self"],["f"]],["t"]]],[11,"to_owned","","",133,[[["self"]],["t"]]],[11,"clone_into","","",133,N],[11,"from","","",133,[[["t"]],["t"]]],[11,"into","","",133,[[["self"]],["u"]]],[11,"try_from","","",133,[[["u"]],["result"]]],[11,"borrow","","",133,[[["self"]],["t"]]],[11,"try_into","","",133,[[["self"]],["result"]]],[11,"borrow_mut","","",133,[[["self"]],["t"]]],[11,"get_type_id","","",133,[[["self"]],["typeid"]]],[11,"not_found","","",133,[[["str"],["str"]],["e"]]],[11,"from_ok","","",133,[[["t"]],["t"]]],[11,"map_same","","",133,[[["self"],["f"]],["t"]]],[11,"to_owned","","",134,[[["self"]],["t"]]],[11,"clone_into","","",134,N],[11,"from","","",134,[[["t"]],["t"]]],[11,"into","","",134,[[["self"]],["u"]]],[11,"try_from","","",134,[[["u"]],["result"]]],[11,"borrow","","",134,[[["self"]],["t"]]],[11,"try_into","","",134,[[["self"]],["result"]]],[11,"borrow_mut","","",134,[[["self"]],["t"]]],[11,"get_type_id","","",134,[[["self"]],["typeid"]]],[11,"not_found","","",134,[[["str"],["str"]],["e"]]],[11,"from_ok","","",134,[[["t"]],["t"]]],[11,"map_same","","",134,[[["self"],["f"]],["t"]]],[11,"to_owned","","",135,[[["self"]],["t"]]],[11,"clone_into","","",135,N],[11,"from","","",135,[[["t"]],["t"]]],[11,"into","","",135,[[["self"]],["u"]]],[11,"try_from","","",135,[[["u"]],["result"]]],[11,"borrow","","",135,[[["self"]],["t"]]],[11,"try_into","","",135,[[["self"]],["result"]]],[11,"borrow_mut","","",135,[[["self"]],["t"]]],[11,"get_type_id","","",135,[[["self"]],["typeid"]]],[11,"not_found","","",135,[[["str"],["str"]],["e"]]],[11,"from_ok","","",135,[[["t"]],["t"]]],[11,"map_same","","",135,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::llvm::archive_ro","",136,[[["t"]],["t"]]],[11,"into","","",136,[[["self"]],["u"]]],[11,"try_from","","",136,[[["u"]],["result"]]],[11,"borrow","","",136,[[["self"]],["t"]]],[11,"try_into","","",136,[[["self"]],["result"]]],[11,"borrow_mut","","",136,[[["self"]],["t"]]],[11,"get_type_id","","",136,[[["self"]],["typeid"]]],[11,"not_found","","",136,[[["str"],["str"]],["e"]]],[11,"from_ok","","",136,[[["t"]],["t"]]],[11,"map_same","","",136,[[["self"],["f"]],["t"]]],[11,"from","","",137,[[["t"]],["t"]]],[11,"into_iter","","",137,[[["self"]],["i"]]],[11,"into","","",137,[[["self"]],["u"]]],[11,"try_from","","",137,[[["u"]],["result"]]],[11,"borrow","","",137,[[["self"]],["t"]]],[11,"try_into","","",137,[[["self"]],["result"]]],[11,"borrow_mut","","",137,[[["self"]],["t"]]],[11,"get_type_id","","",137,[[["self"]],["typeid"]]],[11,"not_found","","",137,[[["str"],["str"]],["e"]]],[11,"from_ok","","",137,[[["t"]],["t"]]],[11,"map_same","","",137,[[["self"],["f"]],["t"]]],[11,"from","","",138,[[["t"]],["t"]]],[11,"into","","",138,[[["self"]],["u"]]],[11,"try_from","","",138,[[["u"]],["result"]]],[11,"borrow","","",138,[[["self"]],["t"]]],[11,"try_into","","",138,[[["self"]],["result"]]],[11,"borrow_mut","","",138,[[["self"]],["t"]]],[11,"get_type_id","","",138,[[["self"]],["typeid"]]],[11,"not_found","","",138,[[["str"],["str"]],["e"]]],[11,"from_ok","","",138,[[["t"]],["t"]]],[11,"map_same","","",138,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::llvm::diagnostic","",139,[[["t"]],["t"]]],[11,"into","","",139,[[["self"]],["u"]]],[11,"try_from","","",139,[[["u"]],["result"]]],[11,"borrow","","",139,[[["self"]],["t"]]],[11,"try_into","","",139,[[["self"]],["result"]]],[11,"borrow_mut","","",139,[[["self"]],["t"]]],[11,"get_type_id","","",139,[[["self"]],["typeid"]]],[11,"not_found","","",139,[[["str"],["str"]],["e"]]],[11,"from_ok","","",139,[[["t"]],["t"]]],[11,"map_same","","",139,[[["self"],["f"]],["t"]]],[11,"to_owned","","",140,[[["self"]],["t"]]],[11,"clone_into","","",140,N],[11,"from","","",140,[[["t"]],["t"]]],[11,"into","","",140,[[["self"]],["u"]]],[11,"try_from","","",140,[[["u"]],["result"]]],[11,"borrow","","",140,[[["self"]],["t"]]],[11,"try_into","","",140,[[["self"]],["result"]]],[11,"borrow_mut","","",140,[[["self"]],["t"]]],[11,"get_type_id","","",140,[[["self"]],["typeid"]]],[11,"not_found","","",140,[[["str"],["str"]],["e"]]],[11,"from_ok","","",140,[[["t"]],["t"]]],[11,"map_same","","",140,[[["self"],["f"]],["t"]]],[11,"to_owned","","",141,[[["self"]],["t"]]],[11,"clone_into","","",141,N],[11,"from","","",141,[[["t"]],["t"]]],[11,"into","","",141,[[["self"]],["u"]]],[11,"try_from","","",141,[[["u"]],["result"]]],[11,"borrow","","",141,[[["self"]],["t"]]],[11,"try_into","","",141,[[["self"]],["result"]]],[11,"borrow_mut","","",141,[[["self"]],["t"]]],[11,"get_type_id","","",141,[[["self"]],["typeid"]]],[11,"not_found","","",141,[[["str"],["str"]],["e"]]],[11,"from_ok","","",141,[[["t"]],["t"]]],[11,"map_same","","",141,[[["self"],["f"]],["t"]]],[11,"from","","",142,[[["t"]],["t"]]],[11,"into","","",142,[[["self"]],["u"]]],[11,"try_from","","",142,[[["u"]],["result"]]],[11,"borrow","","",142,[[["self"]],["t"]]],[11,"try_into","","",142,[[["self"]],["result"]]],[11,"borrow_mut","","",142,[[["self"]],["t"]]],[11,"get_type_id","","",142,[[["self"]],["typeid"]]],[11,"not_found","","",142,[[["str"],["str"]],["e"]]],[11,"from_ok","","",142,[[["t"]],["t"]]],[11,"map_same","","",142,[[["self"],["f"]],["t"]]],[11,"borrow","rustc_codegen_llvm::llvm::ffi","",143,[[["self"]],["t"]]],[11,"borrow_mut","","",143,[[["self"]],["t"]]],[11,"get_type_id","","",143,[[["self"]],["typeid"]]],[11,"borrow","rustc_codegen_llvm::llvm::ffi::debuginfo","",144,[[["self"]],["t"]]],[11,"borrow_mut","","",144,[[["self"]],["t"]]],[11,"get_type_id","","",144,[[["self"]],["typeid"]]],[11,"to_owned","","",145,[[["self"]],["t"]]],[11,"clone_into","","",145,N],[11,"from","","",145,[[["t"]],["t"]]],[11,"into","","",145,[[["self"]],["u"]]],[11,"try_from","","",145,[[["u"]],["result"]]],[11,"borrow","","",145,[[["self"]],["t"]]],[11,"try_into","","",145,[[["self"]],["result"]]],[11,"borrow_mut","","",145,[[["self"]],["t"]]],[11,"get_type_id","","",145,[[["self"]],["typeid"]]],[11,"not_found","","",145,[[["str"],["str"]],["e"]]],[11,"from_ok","","",145,[[["t"]],["t"]]],[11,"map_same","","",145,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::metadata","",146,[[["t"]],["t"]]],[11,"into","","",146,[[["self"]],["u"]]],[11,"try_from","","",146,[[["u"]],["result"]]],[11,"borrow","","",146,[[["self"]],["t"]]],[11,"try_into","","",146,[[["self"]],["result"]]],[11,"borrow_mut","","",146,[[["self"]],["t"]]],[11,"get_type_id","","",146,[[["self"]],["typeid"]]],[11,"not_found","","",146,[[["str"],["str"]],["e"]]],[11,"from_ok","","",146,[[["t"]],["t"]]],[11,"map_same","","",146,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_codegen_llvm::meth","",147,[[["self"]],["t"]]],[11,"clone_into","","",147,N],[11,"from","","",147,[[["t"]],["t"]]],[11,"into","","",147,[[["self"]],["u"]]],[11,"try_from","","",147,[[["u"]],["result"]]],[11,"borrow","","",147,[[["self"]],["t"]]],[11,"try_into","","",147,[[["self"]],["result"]]],[11,"borrow_mut","","",147,[[["self"]],["t"]]],[11,"get_type_id","","",147,[[["self"]],["typeid"]]],[11,"not_found","","",147,[[["str"],["str"]],["e"]]],[11,"from_ok","","",147,[[["t"]],["t"]]],[11,"map_same","","",147,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::mir","",148,[[["t"]],["t"]]],[11,"into","","",148,[[["self"]],["u"]]],[11,"try_from","","",148,[[["u"]],["result"]]],[11,"borrow","","",148,[[["self"]],["t"]]],[11,"try_into","","",148,[[["self"]],["result"]]],[11,"borrow_mut","","",148,[[["self"]],["t"]]],[11,"get_type_id","","",148,[[["self"]],["typeid"]]],[11,"not_found","","",148,[[["str"],["str"]],["e"]]],[11,"from_ok","","",148,[[["t"]],["t"]]],[11,"map_same","","",148,[[["self"],["f"]],["t"]]],[11,"from","","",149,[[["t"]],["t"]]],[11,"into","","",149,[[["self"]],["u"]]],[11,"try_from","","",149,[[["u"]],["result"]]],[11,"borrow","","",149,[[["self"]],["t"]]],[11,"try_into","","",149,[[["self"]],["result"]]],[11,"borrow_mut","","",149,[[["self"]],["t"]]],[11,"get_type_id","","",149,[[["self"]],["typeid"]]],[11,"not_found","","",149,[[["str"],["str"]],["e"]]],[11,"from_ok","","",149,[[["t"]],["t"]]],[11,"map_same","","",149,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::mir::analyze","",150,[[["t"]],["t"]]],[11,"into","","",150,[[["self"]],["u"]]],[11,"try_from","","",150,[[["u"]],["result"]]],[11,"borrow","","",150,[[["self"]],["t"]]],[11,"try_into","","",150,[[["self"]],["result"]]],[11,"borrow_mut","","",150,[[["self"]],["t"]]],[11,"get_type_id","","",150,[[["self"]],["typeid"]]],[11,"not_found","","",150,[[["str"],["str"]],["e"]]],[11,"from_ok","","",150,[[["t"]],["t"]]],[11,"map_same","","",150,[[["self"],["f"]],["t"]]],[11,"to_owned","","",151,[[["self"]],["t"]]],[11,"clone_into","","",151,N],[11,"from","","",151,[[["t"]],["t"]]],[11,"into","","",151,[[["self"]],["u"]]],[11,"try_from","","",151,[[["u"]],["result"]]],[11,"borrow","","",151,[[["self"]],["t"]]],[11,"try_into","","",151,[[["self"]],["result"]]],[11,"borrow_mut","","",151,[[["self"]],["t"]]],[11,"get_type_id","","",151,[[["self"]],["typeid"]]],[11,"not_found","","",151,[[["str"],["str"]],["e"]]],[11,"from_ok","","",151,[[["t"]],["t"]]],[11,"map_same","","",151,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_llvm::mir::block","",152,[[["t"]],["t"]]],[11,"into","","",152,[[["self"]],["u"]]],[11,"try_from","","",152,[[["u"]],["result"]]],[11,"borrow","","",152,[[["self"]],["t"]]],[11,"try_into","","",152,[[["self"]],["result"]]],[11,"borrow_mut","","",152,[[["self"]],["t"]]],[11,"get_type_id","","",152,[[["self"]],["typeid"]]],[11,"not_found","","",152,[[["str"],["str"]],["e"]]],[11,"from_ok","","",152,[[["t"]],["t"]]],[11,"map_same","","",152,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_codegen_llvm::mir::place","",153,[[["self"]],["t"]]],[11,"clone_into","","",153,N],[11,"from","","",153,[[["t"]],["t"]]],[11,"into","","",153,[[["self"]],["u"]]],[11,"try_from","","",153,[[["u"]],["result"]]],[11,"borrow","","",153,[[["self"]],["t"]]],[11,"try_into","","",153,[[["self"]],["result"]]],[11,"borrow_mut","","",153,[[["self"]],["t"]]],[11,"get_type_id","","",153,[[["self"]],["typeid"]]],[11,"not_found","","",153,[[["str"],["str"]],["e"]]],[11,"from_ok","","",153,[[["t"]],["t"]]],[11,"map_same","","",153,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_codegen_llvm::mir::operand","",154,[[["self"]],["t"]]],[11,"clone_into","","",154,N],[11,"from","","",154,[[["t"]],["t"]]],[11,"into","","",154,[[["self"]],["u"]]],[11,"try_from","","",154,[[["u"]],["result"]]],[11,"borrow","","",154,[[["self"]],["t"]]],[11,"try_into","","",154,[[["self"]],["result"]]],[11,"borrow_mut","","",154,[[["self"]],["t"]]],[11,"get_type_id","","",154,[[["self"]],["typeid"]]],[11,"not_found","","",154,[[["str"],["str"]],["e"]]],[11,"from_ok","","",154,[[["t"]],["t"]]],[11,"map_same","","",154,[[["self"],["f"]],["t"]]],[11,"to_owned","","",155,[[["self"]],["t"]]],[11,"clone_into","","",155,N],[11,"from","","",155,[[["t"]],["t"]]],[11,"into","","",155,[[["self"]],["u"]]],[11,"try_from","","",155,[[["u"]],["result"]]],[11,"borrow","","",155,[[["self"]],["t"]]],[11,"try_into","","",155,[[["self"]],["result"]]],[11,"borrow_mut","","",155,[[["self"]],["t"]]],[11,"get_type_id","","",155,[[["self"]],["typeid"]]],[11,"not_found","","",155,[[["str"],["str"]],["e"]]],[11,"from_ok","","",155,[[["t"]],["t"]]],[11,"map_same","","",155,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_codegen_llvm::mir::rvalue","",156,[[["self"]],["t"]]],[11,"clone_into","","",156,N],[11,"from","","",156,[[["t"]],["t"]]],[11,"into","","",156,[[["self"]],["u"]]],[11,"try_from","","",156,[[["u"]],["result"]]],[11,"borrow","","",156,[[["self"]],["t"]]],[11,"try_into","","",156,[[["self"]],["result"]]],[11,"borrow_mut","","",156,[[["self"]],["t"]]],[11,"get_type_id","","",156,[[["self"]],["typeid"]]],[11,"not_found","","",156,[[["str"],["str"]],["e"]]],[11,"from_ok","","",156,[[["t"]],["t"]]],[11,"map_same","","",156,[[["self"],["f"]],["t"]]],[11,"size_estimate","rustc_codegen_llvm::mono_item","",157,[[["self"],["tyctxt"]],["usize"]]],[11,"to_owned","","",157,[[["self"]],["t"]]],[11,"clone_into","","",157,N],[11,"from","","",157,[[["t"]],["t"]]],[11,"into","","",157,[[["self"]],["u"]]],[11,"try_from","","",157,[[["u"]],["result"]]],[11,"borrow","","",157,[[["self"]],["t"]]],[11,"try_into","","",157,[[["self"]],["result"]]],[11,"borrow_mut","","",157,[[["self"]],["t"]]],[11,"get_type_id","","",157,[[["self"]],["typeid"]]],[11,"not_found","","",157,[[["str"],["str"]],["e"]]],[11,"from_ok","","",157,[[["t"]],["t"]]],[11,"map_same","","",157,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_codegen_llvm::type_of","",161,[[["self"]],["t"]]],[11,"clone_into","","",161,N],[11,"from","","",161,[[["t"]],["t"]]],[11,"into","","",161,[[["self"]],["u"]]],[11,"try_from","","",161,[[["u"]],["result"]]],[11,"borrow","","",161,[[["self"]],["t"]]],[11,"try_into","","",161,[[["self"]],["result"]]],[11,"borrow_mut","","",161,[[["self"]],["t"]]],[11,"get_type_id","","",161,[[["self"]],["typeid"]]],[11,"not_found","","",161,[[["str"],["str"]],["e"]]],[11,"from_ok","","",161,[[["t"]],["t"]]],[11,"map_same","","",161,[[["self"],["f"]],["t"]]],[11,"to_owned","","",162,[[["self"]],["t"]]],[11,"clone_into","","",162,N],[11,"from","","",162,[[["t"]],["t"]]],[11,"into","","",162,[[["self"]],["u"]]],[11,"try_from","","",162,[[["u"]],["result"]]],[11,"borrow","","",162,[[["self"]],["t"]]],[11,"try_into","","",162,[[["self"]],["result"]]],[11,"borrow_mut","","",162,[[["self"]],["t"]]],[11,"get_type_id","","",162,[[["self"]],["typeid"]]],[11,"not_found","","",162,[[["str"],["str"]],["e"]]],[11,"from_ok","","",162,[[["t"]],["t"]]],[11,"map_same","","",162,[[["self"],["f"]],["t"]]]],"paths":[[3,"LlvmCodegenBackend"],[3,"ModuleCodegen"],[3,"CachedModuleCodegen"],[3,"CompiledModule"],[3,"ModuleLlvm"],[3,"CodegenResults"],[3,"CrateInfo"],[4,"ModuleKind"],[3,"ArchiveConfig"],[3,"ArchiveBuilder"],[4,"Addition"],[3,"DecodedBytecode"],[3,"Command"],[4,"Program"],[3,"LinkerInfo"],[3,"GccLinker"],[3,"MsvcLinker"],[3,"EmLinker"],[3,"WasmLd"],[8,"Linker"],[4,"RlibFlavor"],[3,"Linker"],[3,"ModuleBuffer"],[3,"ThinModule"],[3,"ThinShared"],[3,"ThinData"],[3,"ThinBuffer"],[3,"ThinLTOImports"],[4,"LtoModuleCodegen"],[4,"SerializedModule"],[3,"ModuleConfig"],[3,"AssemblerCommand"],[3,"CodegenContext"],[3,"DiagnosticHandlers"],[3,"CompiledModules"],[3,"Diagnostic"],[3,"SharedEmitter"],[3,"SharedEmitterMain"],[3,"OngoingCodegen"],[4,"WorkItem"],[4,"WorkItemResult"],[4,"Message"],[4,"MainThreadWorkerState"],[4,"SharedEmitterMessage"],[3,"RPathConfig"],[3,"WasmSections"],[3,"WasmDecoder"],[3,"WasmEncoder"],[4,"Abi"],[4,"PassMode"],[3,"ArgAttributes"],[4,"RegKind"],[3,"Reg"],[3,"Uniform"],[3,"CastTarget"],[3,"ArgType"],[4,"Conv"],[3,"FnType"],[3,"ArgAttribute"],[8,"ArgAttributeExt"],[8,"ArgAttributesExt"],[8,"LlvmType"],[8,"ArgTypeExt"],[8,"FnTypeExt"],[8,"HasAttrs"],[3,"Stability"],[4,"StabilityLevel"],[4,"InlineAttr"],[4,"IntType"],[4,"ReprAttr"],[3,"RustcDeprecation"],[3,"Deprecation"],[4,"UnwindAttr"],[3,"StatRecorder"],[3,"ValueIter"],[4,"CguReUsable"],[3,"Builder"],[3,"MemFlags"],[3,"Funclet"],[3,"CodegenCx"],[3,"CrateDebugContext"],[3,"FunctionDebugContextData"],[4,"FunctionDebugContext"],[4,"VariableAccess"],[4,"VariableKind"],[3,"UniqueTypeId"],[3,"TypeMap"],[3,"MetadataCreationResult"],[3,"MemberDescription"],[3,"StructMemberDescriptionFactory"],[3,"TupleMemberDescriptionFactory"],[3,"UnionMemberDescriptionFactory"],[3,"EnumMemberDescriptionFactory"],[3,"VariantMemberDescriptionFactory"],[4,"RecursiveTypeDescription"],[4,"MemberDescriptionFactory"],[4,"EnumDiscriminantInfo"],[3,"MirDebugScope"],[4,"InternalDebugLocation"],[3,"ThinLTOModule"],[3,"Builder"],[3,"PassManager"],[3,"SectionIterator"],[3,"ArchiveIterator"],[3,"ArchiveChild"],[3,"RustArchiveMember"],[3,"OperandBundleDef"],[3,"Linker"],[3,"RustString"],[3,"ObjectFile"],[3,"SectionIter"],[3,"OperandBundleDef"],[4,"LLVMRustResult"],[4,"CallConv"],[4,"Linkage"],[4,"Visibility"],[4,"DLLStorageClass"],[4,"Attribute"],[4,"IntPredicate"],[4,"RealPredicate"],[4,"TypeKind"],[4,"AtomicRmwBinOp"],[4,"AtomicOrdering"],[4,"SynchronizationScope"],[4,"FileType"],[4,"MetadataType"],[4,"AsmDialect"],[4,"CodeGenOptLevel"],[4,"RelocMode"],[4,"CodeModel"],[4,"DiagnosticKind"],[4,"ArchiveKind"],[4,"PassKind"],[4,"ThreadLocalMode"],[4,"AttributePlace"],[4,"CodeGenOptSize"],[3,"ArchiveRO"],[3,"Iter"],[3,"Child"],[3,"OptimizationDiagnostic"],[3,"InlineAsmDiagnostic"],[4,"OptimizationDiagnosticKind"],[4,"Diagnostic"],[3,"InvariantOpaque"],[3,"DIBuilder"],[3,"DIFlags"],[3,"LlvmMetadataLoader"],[3,"VirtualIndex"],[3,"FunctionCx"],[4,"LocalRef"],[3,"LocalAnalyzer"],[4,"CleanupKind"],[4,"ReturnDest"],[3,"PlaceRef"],[3,"OperandRef"],[4,"OperandValue"],[4,"OverflowOp"],[4,"MonoItem"],[8,"BaseMonoItemExt"],[8,"MonoItemExt"],[20,"Type"],[3,"PointeeInfo"],[4,"PointerKind"],[8,"LayoutLlvmExt"],[20,"Value"],[20,"Metadata"]]};
searchIndex["rustc_codegen_utils"]={"doc":"Note","items":[[5,"check_for_rustc_errors_attr","rustc_codegen_utils","check for the #[rustc_error] annotation, which forces an error in codegen. This is used to write compile-fail tests that actually test that compilation succeeds without reporting an error.",N,[[["tyctxt"]]]],[0,"link","","",N,N],[5,"out_filename","rustc_codegen_utils::link","",N,[[["session"],["cratetype"],["outputfilenames"],["str"]],["pathbuf"]]],[5,"check_file_is_writeable","","",N,[[["path"],["session"]]]],[5,"is_writeable","","",N,[[["path"]],["bool"]]],[5,"find_crate_name","","",N,N],[5,"filename_for_input","","",N,[[["session"],["cratetype"],["str"],["outputfilenames"]],["pathbuf"]]],[5,"default_output_for_target","","Returns default crate type for target",N,[[["session"]],["cratetype"]]],[5,"invalid_output_for_target","","Checks if target supports crate_type as output",N,[[["session"],["cratetype"]],["bool"]]],[0,"codegen_backend","rustc_codegen_utils","The Rust compiler.",N,N],[6,"MetadataRef","rustc_codegen_utils::codegen_backend","",N,N],[3,"NoLlvmMetadataLoader","","",N,N],[3,"MetadataOnlyCodegenBackend","","",N,N],[12,"0","","",0,N],[3,"OngoingCodegen","","",N,N],[12,"metadata","","",1,N],[12,"metadata_version","","",1,N],[12,"crate_name","","",1,N],[8,"CodegenBackend","","",N,N],[11,"init","","",2,[[["self"],["session"]]]],[11,"print","","",2,[[["self"],["printrequest"],["session"]]]],[11,"target_features","","",2,[[["self"],["session"]],["vec",["symbol"]]]],[11,"print_passes","","",2,[[["self"]]]],[11,"print_version","","",2,[[["self"]]]],[11,"diagnostics","","",2,N],[10,"metadata_loader","","",2,[[["self"]],["box",["metadataloader"]]]],[10,"provide","","",2,[[["self"],["providers"]]]],[10,"provide_extern","","",2,[[["self"],["providers"]]]],[10,"codegen_crate","","",2,[[["self"],["tyctxt"],["receiver",["box"]]],["box",["any"]]]],[10,"join_codegen_and_link","","This is called on the returned `Box<dyn Any>` from `codegen_backend`",2,[[["self"],["box",["any"]],["session"],["depgraph"],["outputfilenames"]],["result",["compileincomplete"]]]],[11,"get_rlib_metadata","","",3,[[["self"],["target"],["path"]],["result",["metadataref","string"]]]],[11,"get_dylib_metadata","","",3,[[["self"],["target"],["path"]],["result",["metadataref","string"]]]],[11,"new","","",0,[[],["box",["codegenbackend"]]]],[11,"init","","",0,[[["self"],["session"]]]],[11,"metadata_loader","","",0,[[["self"]],["box",["metadataloader"]]]],[11,"provide","","",0,[[["self"],["providers"]]]],[11,"provide_extern","","",0,[[["self"],["providers"]]]],[11,"codegen_crate","","",0,[[["self"],["tyctxt"],["receiver",["box"]]],["box",["any"]]]],[11,"join_codegen_and_link","","",0,[[["self"],["box",["any"]],["session"],["depgraph"],["outputfilenames"]],["result",["compileincomplete"]]]],[0,"symbol_names","rustc_codegen_utils","The Rust Linkage Model and Symbol Names =======================================",N,N],[3,"SymbolPathBuffer","rustc_codegen_utils::symbol_names","",N,N],[12,"result","","",4,N],[12,"temp_buf","","",4,N],[5,"provide","","",N,[[["providers"]]]],[5,"get_symbol_hash","","",N,[[["tyctxt"],["defid"],["instance"],["ty"],["substs"]],["u64"]]],[5,"def_symbol_name","","",N,[[["tyctxt"],["defid"]],["symbolname"]]],[5,"symbol_name","","",N,[[["tyctxt"],["instance"]],["symbolname"]]],[5,"compute_symbol_name","","",N,[[["tyctxt"],["instance"]],["string"]]],[5,"sanitize","","",N,[[["string"],["str"]],["bool"]]],[11,"new","","",4,[[],["self"]]],[11,"from_interned","","",4,[[["symbolname"]],["self"]]],[11,"into_interned","","",4,[[["self"]],["symbolname"]]],[11,"finish","","",4,[[["self"],["u64"]],["string"]]],[11,"root_mode","","",4,[[["self"]],["rootmode"]]],[11,"push","","",4,[[["self"],["str"]]]],[0,"symbol_names_test","rustc_codegen_utils","Walks the crate looking for items/impl-items/trait-items that have either a `rustc_symbol_name` or `rustc_item_path` attribute and generates an error giving, respectively, the symbol name or item-path. This is used for unit testing the code that generates paths etc in all kinds of annoying scenarios.",N,N],[3,"SymbolNamesTest","rustc_codegen_utils::symbol_names_test","",N,N],[12,"tcx","","",5,N],[5,"report_symbol_names","","",N,[[["tyctxt"]]]],[17,"SYMBOL_NAME","","",N,N],[17,"ITEM_PATH","","",N,N],[11,"process_attrs","","",5,[[["self"],["nodeid"]]]],[11,"visit_item","","",5,[[["self"],["item"]]]],[11,"visit_trait_item","","",5,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",5,[[["self"],["implitem"]]]],[17,"DIAGNOSTICS","rustc_codegen_utils","",N,N],[11,"from","rustc_codegen_utils::codegen_backend","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_utils::symbol_names","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"from","rustc_codegen_utils::symbol_names_test","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]]],"paths":[[3,"MetadataOnlyCodegenBackend"],[3,"OngoingCodegen"],[8,"CodegenBackend"],[3,"NoLlvmMetadataLoader"],[3,"SymbolPathBuffer"],[3,"SymbolNamesTest"]]};
searchIndex["rustc_data_structures"]={"doc":"Various data structures used by the Rust compiler. The intention is that code in here should be not be specific to rustc, so that it can be easily unit tested and so forth.","items":[[8,"ToHex","rustc_data_structures","A trait for converting a value to hexadecimal encoding",N,N],[10,"to_hex","","Converts the value of `self` to a hex value, returning the owned string.",0,[[["self"]],["string"]]],[0,"snapshot_vec","","A utility class for implementing \"snapshottable\" things; a snapshottable data structure permits you to take a snapshot (via `start_snapshot`) and then, after making some changes, elect either to rollback to the start of the snapshot or commit those changes.",N,N],[4,"UndoLog","rustc_data_structures::snapshot_vec","",N,N],[13,"OpenSnapshot","","Indicates where a snapshot started.",1,N],[13,"CommittedSnapshot","","Indicates a snapshot that has been committed.",1,N],[13,"NewElem","","New variable with given index was created.",1,N],[13,"SetElem","","Variable with given index was changed from the given value.",1,N],[13,"Other","","Extensible set of actions",1,N],[3,"SnapshotVec","","",N,N],[12,"values","","",2,N],[12,"undo_log","","",2,N],[3,"Snapshot","","",N,N],[12,"length","","",3,N],[8,"SnapshotVecDelegate","","",N,N],[16,"Value","","",4,N],[16,"Undo","","",4,N],[10,"reverse","","",4,N],[0,"unify","rustc_data_structures","Union-find implementation. The main type is `UnificationTable`.",N,N],[8,"UnifyKey","rustc_data_structures::unify","This trait is implemented by any type that can serve as a type variable. We call such variables unification keys. For example, this trait is implemented by `IntVid`, which represents integral variables.",N,N],[16,"Value","","",5,N],[10,"index","","",5,[[["self"]],["u32"]]],[10,"from_index","","",5,[[["u32"]],["self"]]],[10,"tag","","",5,[[],["str"]]],[11,"order_roots","","If true, then `self` should be preferred as root to `other`. Note that we assume a consistent partial ordering, so returning true implies that `other.prefer_as_root_to(self)` would return false.  If there is no ordering between two keys (i.e., `a.prefer_as_root_to(b)` and `b.prefer_as_root_to(a)` both return false) then the rank will be used to determine the root in an optimal way.",5,N],[8,"UnifyValue","","Trait implemented for values associated with a unification key. This trait defines how to merge the values from two keys that are unioned together. This merging can be fallible. If you attempt to union two keys whose values cannot be merged, then the error is propagated up and the two keys are not unioned.",N,N],[16,"Error","","Defines the type to return when merging of two values fails. If merging is infallible, use the special struct `NoError` found in this crate, which unlocks various more convenient methods on the unification table.",6,N],[10,"unify_values","","Given two values, produce a new value that combines them. If that is not possible, produce an error.",6,[[["self"],["self"]],["result"]]],[8,"EqUnifyValue","","A convenient helper for unification values which must be equal or else an error occurs. For example, if you are unifying types in a simple functional language, this may be appropriate, since (e.g.) you can't unify a type variable bound to `int` with one bound to `float` (but you can unify two type variables both bound to `int`).",N,N],[3,"NoError","","A struct which can never be instantiated. Used for the error type for infallible cases.",N,N],[12,"_dummy","","",7,N],[3,"VarValue","","Value of a unification key. We implement Tarjan's union-find algorithm: when two keys are unified, one of them is converted into a \"redirect\" pointing at the other. These redirects form a DAG: the roots of the DAG (nodes that are not redirected) are each associated with a value of type `V` and a rank. The rank is used to keep the DAG relatively balanced, which helps keep the running time of the algorithm under control. For more information, see http://en.wikipedia.org/wiki/Disjoint-set_data_structure.",N,N],[12,"parent","","",8,N],[12,"value","","",8,N],[12,"rank","","",8,N],[3,"UnificationTable","","Table of unification keys and their values. You must define a key type K that implements the `UnifyKey` trait. Unification tables can be used in two-modes:",N,N],[12,"values","","Indicates the current value of each key.",9,N],[6,"InPlaceUnificationTable","","A unification table that uses an \"in-place\" vector.",N,N],[3,"Snapshot","","At any time, users may snapshot a unification table.  The changes made during the snapshot may either be committed or rolled back.",N,N],[12,"marker","","",10,N],[12,"snapshot","","",10,N],[8,"UnificationStore","","Largely internal trait implemented by the unification table backing store types. The most common such type is `InPlace`, which indicates a standard, mutable unification table.",N,N],[16,"Key","","",11,N],[16,"Value","","",11,N],[16,"Snapshot","","",11,N],[10,"new","","",11,[[],["self"]]],[10,"start_snapshot","","",11,N],[10,"rollback_to","","",11,N],[10,"commit","","",11,N],[10,"reset_unifications","","",11,N],[10,"len","","",11,[[["self"]],["usize"]]],[10,"push","","",11,N],[10,"reserve","","",11,N],[10,"update","","",11,N],[11,"tag","","",11,[[],["str"]]],[3,"InPlace","","Backing store for an in-place unification table. Not typically used directly.",N,N],[12,"values","","",12,N],[3,"OnDrop","rustc_data_structures","",N,N],[12,"0","","",13,N],[5,"__noop_fix_for_27438","","",N,[[]]],[0,"svh","","Calculation and management of a Strict Version Hash for crates",N,N],[3,"Svh","rustc_data_structures::svh","",N,N],[12,"hash","","",14,N],[11,"clone","","",14,[[["self"]],["svh"]]],[11,"eq","","",14,[[["self"],["svh"]],["bool"]]],[11,"ne","","",14,[[["self"],["svh"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",14,N],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `Svh` given the hash. If you actually want to compute the SVH from some HIR, you want the `calculate_svh` function found in `librustc_incremental`.",14,[[["u64"]],["svh"]]],[11,"as_u64","","",14,[[["self"]],["u64"]]],[11,"to_string","","",14,[[["self"]],["string"]]],[11,"hash","","",14,[[["self"],["h"]]]],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"encode","","",14,[[["self"],["s"]],["result"]]],[11,"decode","","",14,[[["d"]],["result",["svh"]]]],[11,"hash_stable","","",14,[[["self"],["t"],["stablehasher"]]]],[0,"array_vec","rustc_data_structures","A stack-allocated vector, allowing storage of N elements on the stack.",N,N],[3,"ArrayVec","rustc_data_structures::array_vec","",N,N],[12,"count","","",15,N],[12,"values","","",15,N],[3,"Iter","","",N,N],[12,"indices","","",16,N],[12,"store","","",16,N],[3,"Drain","","",N,N],[12,"tail_start","","",17,N],[12,"tail_len","","",17,N],[12,"iter","","",17,N],[12,"array_vec","","",17,N],[8,"Array","","",N,N],[16,"Element","","",18,N],[16,"PartialStorage","","",18,N],[18,"LEN","","",18,N],[11,"hash","","",15,[[["self"],["h"]]]],[11,"clone","","",15,[[["self"]],["self"]]],[11,"new","","",15,[[],["self"]]],[11,"len","","",15,[[["self"]],["usize"]]],[11,"set_len","","",15,[[["self"],["usize"]]]],[11,"push","","Panics when the stack vector is full.",15,N],[11,"pop","","",15,[[["self"]],["option"]]],[11,"drain","","",15,[[["self"],["r"]],["drain"]]],[11,"default","","",15,[[],["self"]]],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"deref","","",15,N],[11,"deref_mut","","",15,N],[11,"drop","","",15,[[["self"]]]],[11,"extend","","",15,[[["self"],["i"]]]],[11,"drop","","",16,[[["self"]]]],[11,"next","","",16,[[["self"]],["option"]]],[11,"size_hint","","",16,N],[11,"next","","",17,[[["self"]],["option"]]],[11,"size_hint","","",17,N],[11,"drop","","",17,[[["self"]]]],[11,"into_iter","","",15,N],[0,"base_n","rustc_data_structures","",N,N],[5,"push_str","rustc_data_structures::base_n","",N,[[["u128"],["usize"],["string"]]]],[5,"encode","","",N,[[["u128"],["usize"]],["string"]]],[17,"MAX_BASE","","",N,N],[17,"ALPHANUMERIC_ONLY","","",N,N],[17,"CASE_INSENSITIVE","","",N,N],[17,"BASE_64","","",N,N],[0,"bitvec","rustc_data_structures","",N,N],[3,"BitArray","rustc_data_structures::bitvec","A very simple BitArray type.",N,N],[12,"data","","",19,N],[12,"marker","","",19,N],[3,"BitIter","","",N,N],[12,"cur","","",20,N],[12,"iter","","",20,N],[12,"marker","","",20,N],[3,"Intersect","","",N,N],[3,"Union","","",N,N],[3,"Subtract","","",N,N],[3,"BitVector","","A resizable BitVector type.",N,N],[12,"data","","",21,N],[3,"BitMatrix","","A \"bit matrix\" is basically a matrix of booleans represented as one gigantic bitvector. In other words, it is as if you have `rows` bitvectors, each of length `columns`.",N,N],[12,"columns","","",22,N],[12,"vector","","",22,N],[12,"phantom","","",22,N],[3,"SparseBitMatrix","","A moderately sparse bit matrix, in which rows are instantiated lazily.",N,N],[12,"num_columns","","",23,N],[12,"rows","","",23,N],[5,"bitwise","","",N,N],[5,"bits_to_string","","",N,N],[5,"num_words","","",N,[[["c"]],["usize"]]],[5,"word_mask","","",N,N],[6,"Word","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"WORD_BYTES","","",N,N],[17,"WORD_BITS","","",N,N],[8,"BitwiseOperator","","",N,N],[10,"join","","Applies some bit-operation pointwise to each of the bits in the two inputs.",24,[[["self"],["word"],["word"]],["word"]]],[11,"clone","","",19,[[["self"]],["bitarray"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"eq","","",19,[[["self"],["bitarray"]],["bool"]]],[11,"ne","","",19,[[["self"],["bitarray"]],["bool"]]],[11,"grow","","",19,[[["self"],["c"]]]],[11,"new","","",19,[[["usize"]],["bitarray"]]],[11,"new_empty","","",19,[[["usize"]],["bitarray"]]],[11,"new_filled","","",19,[[["usize"]],["bitarray"]]],[11,"clear","","",19,[[["self"]]]],[11,"set_up_to","","Sets all elements up to `num_bits`.",19,[[["self"],["usize"]]]],[11,"clear_above","","Clear all elements above `num_bits`.",19,[[["self"],["usize"]]]],[11,"count","","",19,[[["self"]],["usize"]]],[11,"contains","","True if `self` contains the bit `bit`.",19,[[["self"],["c"]],["bool"]]],[11,"contains_all","","True if `self` contains all the bits in `other`.",19,[[["self"],["bitarray"]],["bool"]]],[11,"is_empty","","",19,[[["self"]],["bool"]]],[11,"insert","","Returns true if the bit has changed.",19,[[["self"],["c"]],["bool"]]],[11,"insert_all","","Sets all bits to true.",19,[[["self"]]]],[11,"remove","","Returns true if the bit has changed.",19,[[["self"],["c"]],["bool"]]],[11,"merge","","",19,[[["self"],["bitarray"]],["bool"]]],[11,"words","","",19,N],[11,"words_mut","","",19,N],[11,"iter","","Iterates over indexes of set bits in a sorted order",19,[[["self"]],["bititer"]]],[11,"encode","","",19,[[["self"],["e"]],["result"]]],[11,"decode","","",19,[[["d"]],["result",["bitarray"]]]],[11,"next","","",20,[[["self"]],["option"]]],[11,"join","","",25,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",26,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",27,[[["self"],["word"],["word"]],["word"]]],[11,"clone","","",21,[[["self"]],["bitvector"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"eq","","",21,[[["self"],["bitvector"]],["bool"]]],[11,"ne","","",21,[[["self"],["bitvector"]],["bool"]]],[11,"grow","","",21,[[["self"],["c"]]]],[11,"new","","",21,[[],["bitvector"]]],[11,"with_capacity","","",21,[[["usize"]],["bitvector"]]],[11,"insert","","Returns true if the bit has changed.",21,[[["self"],["c"]],["bool"]]],[11,"contains","","",21,[[["self"],["c"]],["bool"]]],[11,"clone","","",22,[[["self"]],["bitmatrix"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new `rows x columns` matrix, initially empty.",22,[[["usize"],["usize"]],["bitmatrix"]]],[11,"range","","The range of bits for a given row.",22,N],[11,"add","","Sets the cell at `(row, column)` to true. Put another way, add `column` to the bitset for `row`.",22,[[["self"],["r"],["r"]],["bool"]]],[11,"contains","","Do the bits from `row` contain `column`? Put another way, is the matrix cell at `(row, column)` true?  Put yet another way, if the matrix represents (transitive) reachability, can `row` reach `column`?",22,[[["self"],["r"],["r"]],["bool"]]],[11,"intersection","","Returns those indices that are true in rows `a` and `b`.  This is an O(n) operation where `n` is the number of elements (somewhat independent from the actual size of the intersection, in particular).",22,[[["self"],["r"],["r"]],["vec"]]],[11,"merge","","Add the bits from row `read` to the bits from row `write`, return true if anything changed.",22,[[["self"],["r"],["r"]],["bool"]]],[11,"iter","","Iterates through all the columns set to true in a given row of the matrix.",22,[[["self"],["r"]],["bititer"]]],[11,"clone","","",23,[[["self"]],["sparsebitmatrix"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"new","","Create a new empty sparse bit matrix with no rows or columns.",23,[[["usize"]],["self"]]],[11,"ensure_row","","",23,[[["self"],["r"]],["bitarray"]]],[11,"add","","Sets the cell at `(row, column)` to true. Put another way, insert `column` to the bitset for `row`.",23,[[["self"],["r"],["c"]],["bool"]]],[11,"contains","","Do the bits from `row` contain `column`? Put another way, is the matrix cell at `(row, column)` true?  Put yet another way, if the matrix represents (transitive) reachability, can `row` reach `column`?",23,[[["self"],["r"],["c"]],["bool"]]],[11,"merge","","Add the bits from row `read` to the bits from row `write`, return true if anything changed.",23,[[["self"],["r"],["r"]],["bool"]]],[11,"merge_into","","Merge a row, `from`, into the `into` row.",23,[[["self"],["r"],["bitarray"]],["bool"]]],[11,"add_all","","Add all bits to the given row.",23,[[["self"],["r"]]]],[11,"rows","","",23,N],[11,"iter","","Iterates through all the columns set to true in a given row of the matrix.",23,N],[11,"row","","",23,[[["self"],["r"]],["option",["bitarray"]]]],[0,"const_cstr","rustc_data_structures","",N,N],[0,"flock","","Simple file-locking apis for each OS.",N,N],[3,"Lock","rustc_data_structures::flock","",N,N],[12,"fd","","",28,N],[0,"os","","",N,N],[3,"flock","rustc_data_structures::flock::os","",N,N],[12,"l_type","","",29,N],[12,"l_whence","","",29,N],[12,"l_start","","",29,N],[12,"l_len","","",29,N],[12,"l_pid","","",29,N],[12,"l_sysid","","",29,N],[17,"F_RDLCK","","",N,N],[17,"F_WRLCK","","",N,N],[17,"F_UNLCK","","",N,N],[17,"F_SETLK","","",N,N],[17,"F_SETLKW","","",N,N],[11,"fmt","rustc_data_structures::flock","",28,[[["self"],["formatter"]],["result"]]],[11,"new","","",28,[[["path"],["bool"],["bool"],["bool"]],["result",["lock"]]]],[11,"drop","","",28,[[["self"]]]],[11,"panicking_new","","",28,[[["path"],["bool"],["bool"],["bool"]],["lock"]]],[0,"fx","rustc_data_structures","",N,N],[6,"FxHashMap","rustc_data_structures::fx","Type alias for a hashmap using the `fx` hash algorithm.",N,N],[6,"FxHashSet","","Type alias for a hashmap using the `fx` hash algorithm.",N,N],[3,"FxHasher","","A speedy hash algorithm for use within rustc. The hashmap in liballoc by default uses SipHash which isn't quite as speedy as we want. In the compiler we're not really worried about DOS attempts, so we use a fast non-cryptographic hash.",N,N],[12,"hash","","",30,N],[5,"FxHashMap","","",N,[[],["fxhashmap"]]],[5,"FxHashSet","","",N,[[],["fxhashset"]]],[0,"graph","rustc_data_structures","",N,N],[0,"dominators","rustc_data_structures::graph","Algorithm citation: A Simple, Fast Dominance Algorithm. Keith D. Cooper, Timothy J. Harvey, and Ken Kennedy Rice Computer Science TS-06-33870 https://www.cs.rice.edu/~keith/EMBED/dom.pdf",N,N],[3,"Dominators","rustc_data_structures::graph::dominators","",N,N],[12,"post_order_rank","","",31,N],[12,"immediate_dominators","","",31,N],[3,"Iter","","",N,N],[12,"dominators","","",32,N],[12,"node","","",32,N],[3,"DominatorTree","","",N,N],[12,"root","","",33,N],[12,"children","","",33,N],[3,"DominatorTreeNode","","",N,N],[12,"tree","","",34,N],[12,"node","","",34,N],[5,"dominators","","",N,[[["g"]],["dominators"]]],[5,"dominators_given_rpo","","",N,N],[5,"intersect_opt","","",N,[[["indexvec"],["indexvec"],["option"],["option"]],["option"]]],[5,"intersect","","",N,[[["indexvec"],["indexvec"],["node"],["node"]],["node"]]],[11,"clone","","",31,[[["self"]],["dominators"]]],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"is_reachable","","",31,[[["self"],["node"]],["bool"]]],[11,"immediate_dominator","","",31,[[["self"],["node"]],["node"]]],[11,"dominators","","",31,[[["self"],["node"]],["iter"]]],[11,"is_dominated_by","","",31,[[["self"],["node"],["node"]],["bool"]]],[11,"next","","",32,[[["self"]],["option"]]],[11,"children","","",33,N],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[0,"implementation","rustc_data_structures::graph","A graph module for use in dataflow, region resolution, and elsewhere.",N,N],[3,"Graph","rustc_data_structures::graph::implementation","",N,N],[12,"nodes","","",35,N],[12,"edges","","",35,N],[3,"Node","","",N,N],[12,"first_edge","","",36,N],[12,"data","","",36,N],[3,"Edge","","",N,N],[12,"next_edge","","",37,N],[12,"source","","",37,N],[12,"target","","",37,N],[12,"data","","",37,N],[3,"NodeIndex","","",N,N],[12,"0","","",38,N],[3,"EdgeIndex","","",N,N],[12,"0","","",39,N],[3,"Direction","","",N,N],[12,"repr","","",40,N],[3,"AdjacentEdges","","",N,N],[12,"graph","","",41,N],[12,"direction","","",41,N],[12,"next","","",41,N],[3,"DepthFirstTraversal","","",N,N],[12,"graph","","",42,N],[12,"stack","","",42,N],[12,"visited","","",42,N],[12,"direction","","",42,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"INVALID_EDGE_INDEX","","",N,N],[17,"OUTGOING","","",N,N],[17,"INCOMING","","",N,N],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"reverse","","",36,N],[11,"reverse","","",37,N],[11,"clone","","",38,[[["self"]],["nodeindex"]]],[11,"eq","","",38,[[["self"],["nodeindex"]],["bool"]]],[11,"ne","","",38,[[["self"],["nodeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",38,N],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"hash","","",38,N],[11,"clone","","",39,[[["self"]],["edgeindex"]]],[11,"eq","","",39,[[["self"],["edgeindex"]],["bool"]]],[11,"ne","","",39,[[["self"],["edgeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",39,N],[11,"fmt","","",39,[[["self"],["formatter"]],["result"]]],[11,"hash","","",39,N],[11,"clone","","",40,[[["self"]],["direction"]]],[11,"fmt","","",40,[[["self"],["formatter"]],["result"]]],[11,"eq","","",40,[[["self"],["direction"]],["bool"]]],[11,"ne","","",40,[[["self"],["direction"]],["bool"]]],[11,"node_id","","Returns unique id (unique with respect to the graph holding associated node).",38,[[["self"]],["usize"]]],[11,"new","","",35,[[],["graph"]]],[11,"with_capacity","","",35,[[["usize"],["usize"]],["graph"]]],[11,"all_nodes","","",35,N],[11,"len_nodes","","",35,[[["self"]],["usize"]]],[11,"all_edges","","",35,N],[11,"len_edges","","",35,[[["self"]],["usize"]]],[11,"next_node_index","","",35,[[["self"]],["nodeindex"]]],[11,"add_node","","",35,[[["self"],["n"]],["nodeindex"]]],[11,"mut_node_data","","",35,[[["self"],["nodeindex"]],["n"]]],[11,"node_data","","",35,[[["self"],["nodeindex"]],["n"]]],[11,"node","","",35,[[["self"],["nodeindex"]],["node"]]],[11,"next_edge_index","","",35,[[["self"]],["edgeindex"]]],[11,"add_edge","","",35,[[["self"],["nodeindex"],["nodeindex"],["e"]],["edgeindex"]]],[11,"edge","","",35,[[["self"],["edgeindex"]],["edge"]]],[11,"enumerated_nodes","","",35,N],[11,"enumerated_edges","","",35,N],[11,"each_node","","Iterates over all edges defined in the graph.",35,N],[11,"each_edge","","Iterates over all edges defined in the graph",35,N],[11,"outgoing_edges","","",35,[[["self"],["nodeindex"]],["adjacentedges"]]],[11,"incoming_edges","","",35,[[["self"],["nodeindex"]],["adjacentedges"]]],[11,"adjacent_edges","","",35,[[["self"],["nodeindex"],["direction"]],["adjacentedges"]]],[11,"successor_nodes","","",35,N],[11,"predecessor_nodes","","",35,N],[11,"depth_traverse","","",35,[[["self"],["nodeindex"],["direction"]],["depthfirsttraversal"]]],[11,"nodes_in_postorder","","",35,[[["self"],["direction"],["nodeindex"]],["vec",["nodeindex"]]]],[11,"targets","","",41,N],[11,"sources","","",41,N],[11,"next","","",41,[[["self"]],["option"]]],[11,"size_hint","","",41,N],[11,"with_start_node","","",42,[[["graph"],["nodeindex"],["direction"]],["self"]]],[11,"visit","","",42,[[["self"],["nodeindex"]]]],[11,"next","","",42,[[["self"]],["option",["nodeindex"]]]],[11,"size_hint","","",42,N],[11,"source","","",37,[[["self"]],["nodeindex"]]],[11,"target","","",37,[[["self"]],["nodeindex"]]],[11,"source_or_target","","",37,[[["self"],["direction"]],["nodeindex"]]],[0,"iterate","rustc_data_structures::graph","",N,N],[5,"post_order_from","rustc_data_structures::graph::iterate","",N,N],[5,"post_order_from_to","","",N,N],[5,"post_order_walk","","",N,N],[5,"reverse_post_order","","",N,N],[0,"reference","rustc_data_structures::graph","",N,N],[0,"scc","","Routine to compute the strongly connected components (SCCs) of a graph, as well as the resulting DAG if each SCC is replaced with a node in the graph. This uses Tarjan's algorithm that completes in O(n) time.",N,N],[3,"Sccs","rustc_data_structures::graph::scc","Strongly connected components (SCC) of a graph. The type `N` is the index type for the graph nodes and `S` is the index type for the SCCs. We can map from each node to the SCC that it participates in, and we also have the successors of each SCC.",N,N],[12,"scc_indices","","For each node, what is the SCC index of the SCC to which it belongs.",43,N],[12,"scc_data","","Data about each SCC.",43,N],[3,"SccData","","",N,N],[12,"ranges","","For each SCC, the range of `all_successors` where its successors can be found.",44,N],[12,"all_successors","","Contains the succcessors for all the Sccs, concatenated. The range of indices corresponding to a given SCC is found in its SccData.",44,N],[3,"SccsConstruction","","",N,N],[12,"graph","","",45,N],[12,"node_states","","The state of each node; used during walk to record the stack and after walk to record what cycle each node ended up being in.",45,N],[12,"node_stack","","The stack of nodes that we are visiting as part of the DFS.",45,N],[12,"successors_stack","","The stack of successors: as we visit a node, we mark our position in this stack, and when we encounter a successor SCC, we push it on the stack. When we complete an SCC, we can pop everything off the stack that was found along the way.",45,N],[12,"duplicate_set","","A set used to strip duplicates. As we accumulate successors into the successors_stack, we sometimes get duplicate entries. We use this set to remove those -- we also keep its storage around between successors to amortize memory allocation costs.",45,N],[12,"scc_data","","",45,N],[4,"NodeState","","",N,N],[13,"NotVisited","","This node has not yet been visited as part of the DFS.",46,N],[13,"BeingVisited","","This node is currently being walk as part of our DFS. It is on the stack at the depth `depth`.",46,N],[12,"depth","rustc_data_structures::graph::scc::NodeState","",46,N],[13,"InCycle","rustc_data_structures::graph::scc","Indicates that this node is a member of the given cycle.",46,N],[12,"scc_index","rustc_data_structures::graph::scc::NodeState","",46,N],[13,"InCycleWith","rustc_data_structures::graph::scc","Indicates that this node is a member of whatever cycle `parent` is a member of. This state is transient: whenever we see it, we try to overwrite it with the current state of `parent` (this is the \"path compression\" step of a union-find algorithm).",46,N],[12,"parent","rustc_data_structures::graph::scc::NodeState","",46,N],[4,"WalkReturn","rustc_data_structures::graph::scc","",N,N],[13,"Cycle","","",47,N],[12,"min_depth","rustc_data_structures::graph::scc::WalkReturn","",47,N],[13,"Complete","rustc_data_structures::graph::scc","",47,N],[12,"scc_index","rustc_data_structures::graph::scc::WalkReturn","",47,N],[22,"","rustc_data_structures::graph::scc","",N,N],[11,"new","","",43,N],[11,"num_sccs","","Returns the number of SCCs in the graph.",43,[[["self"]],["usize"]]],[11,"all_sccs","","Returns an iterator over the SCCs in the graph.",43,N],[11,"scc","","Returns the SCC to which a node `r` belongs.",43,[[["self"],["n"]],["s"]]],[11,"successors","","Returns the successors of the given SCC.",43,N],[11,"len","","Number of SCCs,",44,[[["self"]],["usize"]]],[11,"successors","","Returns the successors of the given SCC.",44,N],[11,"create_scc","","Creates a new SCC with `successors` as its successors and returns the resulting index.",44,N],[11,"clone","","",46,[[["self"]],["nodestate"]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"clone","","",47,[[["self"]],["walkreturn"]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"construct","","Identifies SCCs in the graph `G` and computes the resulting DAG. This uses a variant of [Tarjan's algorithm][wikipedia]. The high-level summary of the algorithm is that we do a depth-first search. Along the way, we keep a stack of each node whose successors are being visited. We track the depth of each node on this stack (there is no depth if the node is not on the stack). When we find that some node N with depth D can reach some other node N' with lower depth D' (i.e., D' < D), we know that N, N', and all nodes in between them on the stack are part of an SCC.",45,[[["g"]],["sccs"]]],[11,"walk_node","","Visit a node during the DFS. We first examine its current state -- if it is not yet visited (`NotVisited`), we can push it onto the stack and start walking its successors.",45,N],[11,"find_state","","Fetches the state of the node `r`. If `r` is recorded as being in a cycle with some other node `r2`, then fetches the state of `r2` (and updates `r` to reflect current result). This is basically the \"find\" part of a standard union-find algorithm (with path compression).",45,N],[11,"walk_unvisited_node","","Walks a node that has never been visited before.",45,N],[8,"DirectedGraph","rustc_data_structures::graph","",N,N],[16,"Node","","",48,N],[8,"WithNumNodes","","",N,N],[10,"num_nodes","","",49,[[["self"]],["usize"]]],[8,"WithSuccessors","","",N,N],[10,"successors","","",50,N],[8,"GraphSuccessors","","",N,N],[16,"Item","","",51,N],[16,"Iter","","",51,N],[8,"WithPredecessors","","",N,N],[10,"predecessors","","",52,N],[8,"GraphPredecessors","","",N,N],[16,"Item","","",53,N],[16,"Iter","","",53,N],[8,"WithStartNode","","",N,N],[10,"start_node","","",54,N],[8,"ControlFlowGraph","","",N,N],[0,"indexed_set","rustc_data_structures","",N,N],[3,"IdxSet","rustc_data_structures::indexed_set","Represents a set of some element type E, where each E is identified by some unique index type `T`.",N,N],[12,"0","","",55,N],[3,"SparseIdxSet","","A sparse index set with a maximum of SPARSE_MAX elements. Used by HybridIdxSet; do not use directly.",N,N],[12,"0","","",56,N],[4,"HybridIdxSet","","Like IdxSet, but with a hybrid representation: sparse when there are few elements in the set, but dense when there are many. It's especially efficient for sets that typically have a small number of elements, but a large `domain_size`, and are cleared frequently.",N,N],[13,"Sparse","","",57,N],[13,"Dense","","",57,N],[4,"HybridIter","","",N,N],[13,"Sparse","","",58,N],[13,"Dense","","",58,N],[17,"SPARSE_MAX","","",N,N],[8,"UnionIntoIdxSet","","This is implemented by all the index sets so that IdxSet::union() can be passed any type of index set.",N,N],[10,"union_into","","",59,[[["self"],["idxset"]],["bool"]]],[8,"SubtractFromIdxSet","","This is implemented by all the index sets so that IdxSet::subtract() can be passed any type of index set.",N,N],[10,"subtract_from","","",60,[[["self"],["idxset"]],["bool"]]],[11,"clone","","",55,[[["self"]],["idxset"]]],[11,"assert_receiver_is_total_eq","","",55,N],[11,"eq","","",55,[[["self"],["idxset"]],["bool"]]],[11,"ne","","",55,[[["self"],["idxset"]],["bool"]]],[11,"encode","","",55,[[["self"],["e"]],["result"]]],[11,"decode","","",55,[[["d"]],["result",["idxset"]]]],[11,"fmt","","",55,[[["self"],["formatter"]],["result"]]],[11,"new_empty","","Creates set holding no elements.",55,[[["usize"]],["self"]]],[11,"new_filled","","Creates set holding every element whose index falls in range 0..domain_size.",55,[[["usize"]],["self"]]],[11,"to_hybrid","","Duplicates as a hybrid set.",55,[[["self"]],["hybrididxset"]]],[11,"clear","","Removes all elements",55,[[["self"]]]],[11,"set_up_to","","Sets all elements up to `domain_size`",55,[[["self"],["usize"]]]],[11,"remove","","Removes `elem` from the set `self`; returns true iff this changed `self`.",55,[[["self"],["t"]],["bool"]]],[11,"add","","Adds `elem` to the set `self`; returns true iff this changed `self`.",55,[[["self"],["t"]],["bool"]]],[11,"contains","","Returns true iff set `self` contains `elem`.",55,[[["self"],["t"]],["bool"]]],[11,"words","","",55,N],[11,"words_mut","","",55,N],[11,"overwrite","","Efficiently overwrite `self` with `other`. Panics if `self` and `other` don't have the same length.",55,[[["self"],["idxset"]]]],[11,"union","","Set `self = self | other` and return true if `self` changed (i.e., if new bits were added).",55,N],[11,"subtract","","Set `self = self - other` and return true if `self` changed. (i.e., if any bits were removed).",55,N],[11,"intersect","","Set `self = self & other` and return true if `self` changed. (i.e., if any bits were removed).",55,[[["self"],["idxset"]],["bool"]]],[11,"iter","","",55,[[["self"]],["bititer"]]],[11,"union_into","","",55,[[["self"],["idxset"]],["bool"]]],[11,"subtract_from","","",55,[[["self"],["idxset"]],["bool"]]],[11,"clone","","",56,[[["self"]],["sparseidxset"]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"new","","",56,[[],["self"]]],[11,"len","","",56,[[["self"]],["usize"]]],[11,"contains","","",56,[[["self"],["t"]],["bool"]]],[11,"add","","",56,[[["self"],["t"]],["bool"]]],[11,"remove","","",56,[[["self"],["t"]],["bool"]]],[11,"to_dense","","",56,[[["self"],["usize"]],["idxset"]]],[11,"iter","","",56,[[["self"]],["iter"]]],[11,"union_into","","",56,[[["self"],["idxset"]],["bool"]]],[11,"subtract_from","","",56,[[["self"],["idxset"]],["bool"]]],[11,"clone","","",57,[[["self"]],["hybrididxset"]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"new_empty","","",57,[[["usize"]],["self"]]],[11,"clear","","",57,[[["self"]]]],[11,"contains","","Returns true iff set `self` contains `elem`.",57,[[["self"],["t"]],["bool"]]],[11,"add","","Adds `elem` to the set `self`.",57,[[["self"],["t"]],["bool"]]],[11,"remove","","Removes `elem` from the set `self`.",57,[[["self"],["t"]],["bool"]]],[11,"to_dense","","Converts to a dense set, consuming itself in the process.",57,[[["self"]],["idxset"]]],[11,"iter","","Iteration order is unspecified.",57,[[["self"]],["hybriditer"]]],[11,"union_into","","",57,[[["self"],["idxset"]],["bool"]]],[11,"subtract_from","","",57,[[["self"],["idxset"]],["bool"]]],[11,"next","","",58,[[["self"]],["option"]]],[0,"indexed_vec","rustc_data_structures","",N,N],[3,"IndexVec","rustc_data_structures::indexed_vec","",N,N],[12,"raw","","",61,N],[12,"_marker","","",61,N],[3,"IntoIdx","","",N,N],[12,"_marker","","",62,N],[6,"Enumerated","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[8,"Idx","","Represents some newtyped `usize` wrapper.",N,N],[10,"new","","",63,[[["usize"]],["self"]]],[10,"index","","",63,[[["self"]],["usize"]]],[11,"increment_by","","",63,[[["self"],["usize"]]]],[11,"clone","","",61,[[["self"]],["indexvec"]]],[11,"eq","","",61,[[["self"],["indexvec"]],["bool"]]],[11,"ne","","",61,[[["self"],["indexvec"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",61,N],[11,"hash","","",61,N],[11,"encode","","",61,[[["self"],["s"]],["result"]]],[11,"decode","","",61,[[["d"]],["result"]]],[11,"fmt","","",61,[[["self"],["formatter"]],["result"]]],[11,"new","","",61,[[],["self"]]],[11,"from_raw","","",61,[[["vec"]],["self"]]],[11,"with_capacity","","",61,[[["usize"]],["self"]]],[11,"from_elem","","",61,[[["t"],["indexvec"]],["self"]]],[11,"from_elem_n","","",61,[[["t"],["usize"]],["self"]]],[11,"push","","",61,[[["self"],["t"]],["i"]]],[11,"pop","","",61,[[["self"]],["option"]]],[11,"len","","",61,[[["self"]],["usize"]]],[11,"is_empty","","",61,[[["self"]],["bool"]]],[11,"into_iter","","",61,[[["self"]],["intoiter"]]],[11,"into_iter_enumerated","","",61,[[["self"]],["enumerated",["intoiter"]]]],[11,"iter","","",61,[[["self"]],["iter"]]],[11,"iter_enumerated","","",61,[[["self"]],["enumerated",["iter"]]]],[11,"indices","","",61,[[["self"]],["map",["range","intoidx"]]]],[11,"iter_mut","","",61,[[["self"]],["itermut"]]],[11,"iter_enumerated_mut","","",61,[[["self"]],["enumerated",["itermut"]]]],[11,"drain","","",61,N],[11,"drain_enumerated","","",61,N],[11,"last","","",61,[[["self"]],["option"]]],[11,"shrink_to_fit","","",61,[[["self"]]]],[11,"swap","","",61,[[["self"],["i"],["i"]]]],[11,"truncate","","",61,[[["self"],["usize"]]]],[11,"get","","",61,[[["self"],["i"]],["option"]]],[11,"get_mut","","",61,[[["self"],["i"]],["option"]]],[11,"pick2_mut","","Return mutable references to two distinct elements, a and b. Panics if a == b.",61,N],[11,"convert_index_type","","",61,[[["self"]],["indexvec"]]],[11,"ensure_contains_elem","","Grows the index vector so that it contains an entry for `elem`; if that is already true, then has no effect. Otherwise, inserts new values as needed by invoking `fill_value`.",61,N],[11,"resize","","",61,[[["self"],["usize"],["t"]]]],[11,"resize_to_elem","","",61,N],[11,"binary_search","","",61,[[["self"],["t"]],["result"]]],[11,"index","","",61,[[["self"],["i"]],["t"]]],[11,"index_mut","","",61,[[["self"],["i"]],["t"]]],[11,"default","","",61,[[],["self"]]],[11,"extend","","",61,[[["self"],["j"]]]],[11,"from_iter","","",61,[[["j"]],["self"]]],[11,"into_iter","","",61,[[["self"]],["intoiter"]]],[11,"call_once","","",62,N],[11,"call_mut","","",62,N],[11,"call_once","","",62,N],[11,"call_mut","","",62,N],[0,"obligation_forest","rustc_data_structures","The `ObligationForest` is a utility data structure used in trait matching to track the set of outstanding obligations (those not yet resolved to success or error). It also tracks the \"backtrace\" of each pending obligation (why we are trying to figure this out in the first place). See README.md for a general overview of how to use this class.",N,N],[3,"ObligationForest","rustc_data_structures::obligation_forest","",N,N],[12,"nodes","","The list of obligations. In between calls to `process_obligations`, this list only contains nodes in the `Pending` or `Success` state (with a non-zero number of incomplete children). During processing, some of those nodes may be changed to the error state, or we may find that they are completed (That is, `num_incomplete_children` drops to 0). At the end of processing, those nodes will be removed by a call to `compress`.",64,N],[12,"done_cache","","A cache of predicates that have been successfully completed.",64,N],[12,"waiting_cache","","An cache of the nodes in `nodes`, indexed by predicate.",64,N],[12,"scratch","","",64,N],[3,"Node","","",N,N],[12,"obligation","","",65,N],[12,"state","","",65,N],[12,"parent","","The parent of a node - the original obligation of which it is a subobligation. Except for error reporting, it is just like any member of `dependents`.",65,N],[12,"dependents","","Obligations that depend on this obligation for their completion. They must all be in a non-pending state.",65,N],[3,"Outcome","","",N,N],[12,"completed","","Obligations that were completely evaluated, including all (transitive) subobligations.",66,N],[12,"errors","","Backtrace of obligations that were found to be in error.",66,N],[12,"stalled","","If true, then we saw no successful obligations, which means there is no point in further iteration. This is based on the assumption that when trait matching returns `Error` or `Unchanged`, those results do not affect environmental inference state. (Note that if we invoke `process_obligations` with no pending obligations, stalled will be true.)",66,N],[3,"Error","","",N,N],[12,"error","","",67,N],[12,"backtrace","","",67,N],[3,"GetObligation","","",N,N],[12,"0","","",68,N],[4,"ProcessResult","","The result type used by `process_obligation`.",N,N],[13,"Unchanged","","",69,N],[13,"Changed","","",69,N],[13,"Error","","",69,N],[4,"NodeState","","The state of one node in some tree within the forest. This represents the current state of processing for the obligation (of type `O`) associated with this node.",N,N],[13,"Pending","","Obligations for which selection had not yet returned a non-ambiguous result.",70,N],[13,"Success","","This obligation was selected successfully, but may or may not have subobligations.",70,N],[13,"Waiting","","This obligation was selected successfully, but it has a pending subobligation.",70,N],[13,"Done","","This obligation, along with its subobligations, are complete, and will be removed in the next collection.",70,N],[13,"Error","","This obligation was resolved to an error. Error nodes are removed from the vector by the compression step.",70,N],[13,"OnDfsStack","","This is a temporary state used in DFS loops to detect cycles, it should not exist outside of these DFSes.",70,N],[0,"node_index","","",N,N],[3,"NodeIndex","rustc_data_structures::obligation_forest::node_index","",N,N],[12,"index","","",71,N],[11,"clone","","",71,[[["self"]],["nodeindex"]]],[11,"fmt","","",71,[[["self"],["formatter"]],["result"]]],[11,"eq","","",71,[[["self"],["nodeindex"]],["bool"]]],[11,"ne","","",71,[[["self"],["nodeindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",71,N],[11,"new","","",71,[[["usize"]],["nodeindex"]]],[11,"get","","",71,[[["self"]],["usize"]]],[8,"ForestObligation","rustc_data_structures::obligation_forest","",N,N],[16,"Predicate","","",72,N],[10,"as_predicate","","",72,N],[8,"ObligationProcessor","","",N,N],[16,"Obligation","","",73,N],[16,"Error","","",73,N],[10,"process_obligation","","",73,N],[10,"process_backedge","","As we do the cycle check, we invoke this callback when we encounter an actual cycle. `cycle` is an iterator that starts at the start of the cycle in the stack and walks toward the top.",73,[[["self"],["i"],["phantomdata"]]]],[11,"fmt","","",69,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",65,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",70,[[["self"],["formatter"]],["result"]]],[11,"clone","","",70,[[["self"]],["nodestate"]]],[11,"eq","","",70,[[["self"],["nodestate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",70,N],[11,"fmt","","",66,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",67,[[["self"],["formatter"]],["result"]]],[11,"eq","","",67,[[["self"],["error"]],["bool"]]],[11,"ne","","",67,[[["self"],["error"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",67,N],[11,"new","","",64,[[],["obligationforest"]]],[11,"len","","Return the total number of nodes in the forest that have not yet been fully resolved.",64,[[["self"]],["usize"]]],[11,"register_obligation","","Registers an obligation",64,[[["self"],["o"]]]],[11,"register_obligation_at","","",64,[[["self"],["o"],["option",["nodeindex"]]],["result"]]],[11,"to_errors","","Convert all remaining obligations to the given error.",64,[[["self"],["e"]],["vec",["error"]]]],[11,"map_pending_obligations","","Returns the set of obligations that are in a pending state.",64,[[["self"],["f"]],["vec"]]],[11,"process_obligations","","Perform a pass through the obligation list. This must be called in a loop until `outcome.stalled` is false.",64,[[["self"],["p"]],["outcome"]]],[11,"process_cycles","","Mark all NodeState::Success nodes as NodeState::Done and report all cycles between them. This should be called after `mark_as_waiting` marks all nodes with pending subobligations as NodeState::Waiting.",64,[[["self"],["p"]]]],[11,"find_cycles_from_node","","",64,[[["self"],["vec"],["p"],["usize"]]]],[11,"error_at","","Returns a vector of obligations for `p` and all of its ancestors, putting them into the error state in the process.",64,[[["self"],["usize"]],["vec"]]],[11,"mark_neighbors_as_waiting_from","","",64,[[["self"],["node"]]]],[11,"mark_as_waiting","","Marks all nodes that depend on a pending node as NodeState::Waiting.",64,[[["self"]]]],[11,"mark_as_waiting_from","","",64,[[["self"],["node"]]]],[11,"compress","","Compresses the vector, removing all popped nodes. This adjusts the indices and hence invalidates any outstanding indices. Cannot be used during a transaction.",64,[[["self"]],["vec"]]],[11,"apply_rewrites","","",64,N],[11,"new","","",65,[[["option",["nodeindex"]],["o"]],["node"]]],[11,"clone","","",68,[[["self"]],["getobligation"]]],[11,"call_once","","",68,N],[11,"call_mut","","",68,N],[0,"owning_ref","rustc_data_structures","An owning reference.",N,N],[8,"StableAddress","rustc_data_structures::owning_ref","An unsafe marker trait for types that deref to a stable address, even when moved. For example, this is implemented by Box, Vec, Rc, Arc and String, among others. Even when a Box is moved, the underlying storage remains at a fixed location.",N,N],[8,"CloneStableAddress","","An unsafe marker trait for types where clones deref to the same address. This has all the requirements of StableDeref, and additionally requires that after calling clone(), both the old and new value deref to the same address. For example, Rc and Arc implement CloneStableDeref, but Box and Vec do not.",N,N],[3,"OwningRef","","An owning reference.",N,N],[12,"owner","","",74,N],[12,"reference","","",74,N],[3,"OwningRefMut","","An mutable owning reference.",N,N],[12,"owner","","",75,N],[12,"reference","","",75,N],[3,"OwningHandle","","`OwningHandle` is a complement to `OwningRef`. Where `OwningRef` allows consumers to pass around an owned object and a dependent reference, `OwningHandle` contains an owned object and a dependent object.",N,N],[12,"handle","","",76,N],[12,"_owner","","",76,N],[6,"BoxRef","","Typedef of a owning reference that uses a `Box` as the owner.",N,N],[6,"VecRef","","Typedef of a owning reference that uses a `Vec` as the owner.",N,N],[6,"StringRef","","Typedef of a owning reference that uses a `String` as the owner.",N,N],[6,"RcRef","","Typedef of a owning reference that uses a `Rc` as the owner.",N,N],[6,"ArcRef","","Typedef of a owning reference that uses a `Arc` as the owner.",N,N],[6,"RefRef","","Typedef of a owning reference that uses a `Ref` as the owner.",N,N],[6,"RefMutRef","","Typedef of a owning reference that uses a `RefMut` as the owner.",N,N],[6,"MutexGuardRef","","Typedef of a owning reference that uses a `MutexGuard` as the owner.",N,N],[6,"RwLockReadGuardRef","","Typedef of a owning reference that uses a `RwLockReadGuard` as the owner.",N,N],[6,"RwLockWriteGuardRef","","Typedef of a owning reference that uses a `RwLockWriteGuard` as the owner.",N,N],[6,"BoxRefMut","","Typedef of a mutable owning reference that uses a `Box` as the owner.",N,N],[6,"VecRefMut","","Typedef of a mutable owning reference that uses a `Vec` as the owner.",N,N],[6,"StringRefMut","","Typedef of a mutable owning reference that uses a `String` as the owner.",N,N],[6,"RefMutRefMut","","Typedef of a mutable owning reference that uses a `RefMut` as the owner.",N,N],[6,"MutexGuardRefMut","","Typedef of a mutable owning reference that uses a `MutexGuard` as the owner.",N,N],[6,"RwLockWriteGuardRefMut","","Typedef of a mutable owning reference that uses a `RwLockWriteGuard` as the owner.",N,N],[6,"ErasedBoxRef","","Typedef of a owning reference that uses an erased `Box` as the owner.",N,N],[6,"ErasedRcRef","","Typedef of a owning reference that uses an erased `Rc` as the owner.",N,N],[6,"ErasedArcRef","","Typedef of a owning reference that uses an erased `Arc` as the owner.",N,N],[6,"ErasedBoxRefMut","","Typedef of a mutable owning reference that uses an erased `Box` as the owner.",N,N],[8,"Erased","","Helper trait for an erased concrete type an owner dereferences to. This is used in form of a trait object for keeping something around to (virtually) call the destructor.",N,N],[8,"IntoErased","","Helper trait for erasing the concrete type of what an owner dereferences to, for example `Box<T> -> Box<Erased>`. This would be unneeded with higher kinded types support in the language.",N,N],[16,"Erased","","Owner with the dereference type substituted to `Erased`.",77,N],[10,"into_erased","","Perform the type erasure.",77,N],[8,"IntoErasedSend","","Helper trait for erasing the concrete type of what an owner dereferences to, for example `Box<T> -> Box<Erased + Send>`. This would be unneeded with higher kinded types support in the language.",N,N],[16,"Erased","","Owner with the dereference type substituted to `Erased + Send`.",78,N],[10,"into_erased_send","","Perform the type erasure.",78,N],[8,"IntoErasedSendSync","","Helper trait for erasing the concrete type of what an owner dereferences to, for example `Box<T> -> Box<Erased + Send + Sync>`. This would be unneeded with higher kinded types support in the language.",N,N],[16,"Erased","","Owner with the dereference type substituted to `Erased + Send + Sync`.",79,N],[10,"into_erased_send_sync","","Perform the type erasure.",79,N],[8,"ToHandle","","Trait to implement the conversion of owner to handle for common types.",N,N],[16,"Handle","","The type of handle to be encapsulated by the OwningHandle.",80,N],[10,"to_handle","","Given an appropriately-long-lived pointer to ourselves, create a handle to be encapsulated by the `OwningHandle`.",80,N],[8,"ToHandleMut","","Trait to implement the conversion of owner to mutable handle for common types.",N,N],[16,"HandleMut","","The type of handle to be encapsulated by the OwningHandle.",81,N],[10,"to_handle_mut","","Given an appropriately-long-lived pointer to ourselves, create a mutable handle to be encapsulated by the `OwningHandle`.",81,N],[11,"new","","Creates a new owning reference from a owner initialized to the direct dereference of it.",74,[[["o"]],["self"]]],[11,"new_assert_stable_address","","Like `new`, but doesn’t require `O` to implement the `StableAddress` trait. Instead, the caller is responsible to make the same promises as implementing the trait.",74,[[["o"]],["self"]]],[11,"map","","Converts `self` into a new owning reference that points at something reachable from the previous one.",74,[[["self"],["f"]],["owningref"]]],[11,"try_map","","Tries to convert `self` into a new owning reference that points at something reachable from the previous one.",74,[[["self"],["f"]],["result",["owningref"]]]],[11,"map_owner","","Converts `self` into a new owning reference with a different owner type.",74,[[["self"],["f"]],["owningref"]]],[11,"map_owner_box","","Converts `self` into a new owning reference where the owner is wrapped in an additional `Box<O>`.",74,[[["self"]],["owningref",["box"]]]],[11,"erase_owner","","Erases the concrete base type of the owner with a trait object.",74,[[["self"]],["owningref"]]],[11,"erase_send_owner","","Erases the concrete base type of the owner with a trait object which implements `Send`.",74,[[["self"]],["owningref"]]],[11,"erase_send_sync_owner","","Erases the concrete base type of the owner with a trait object which implements `Send` and `Sync`.",74,[[["self"]],["owningref"]]],[11,"owner","","A getter for the underlying owner.",74,[[["self"]],["o"]]],[11,"into_inner","","Discards the reference and retrieves the owner.",74,[[["self"]],["o"]]],[11,"new","","Creates a new owning reference from a owner initialized to the direct dereference of it.",75,[[["o"]],["self"]]],[11,"new_assert_stable_address","","Like `new`, but doesn’t require `O` to implement the `StableAddress` trait. Instead, the caller is responsible to make the same promises as implementing the trait.",75,[[["o"]],["self"]]],[11,"map","","Converts `self` into a new shared owning reference that points at something reachable from the previous one.",75,[[["self"],["f"]],["owningref"]]],[11,"map_mut","","Converts `self` into a new mutable owning reference that points at something reachable from the previous one.",75,[[["self"],["f"]],["owningrefmut"]]],[11,"try_map","","Tries to convert `self` into a new shared owning reference that points at something reachable from the previous one.",75,[[["self"],["f"]],["result",["owningref"]]]],[11,"try_map_mut","","Tries to convert `self` into a new mutable owning reference that points at something reachable from the previous one.",75,[[["self"],["f"]],["result",["owningrefmut"]]]],[11,"map_owner","","Converts `self` into a new owning reference with a different owner type.",75,[[["self"],["f"]],["owningrefmut"]]],[11,"map_owner_box","","Converts `self` into a new owning reference where the owner is wrapped in an additional `Box<O>`.",75,[[["self"]],["owningrefmut",["box"]]]],[11,"erase_owner","","Erases the concrete base type of the owner with a trait object.",75,[[["self"]],["owningrefmut"]]],[11,"owner","","A getter for the underlying owner.",75,[[["self"]],["o"]]],[11,"into_inner","","Discards the reference and retrieves the owner.",75,[[["self"]],["o"]]],[11,"deref","","",76,N],[11,"deref_mut","","",76,N],[11,"new","","Create a new `OwningHandle` for a type that implements `ToHandle`. For types that don't implement `ToHandle`, callers may invoke `new_with_fn`, which accepts a callback to perform the conversion.",76,[[["o"]],["self"]]],[11,"new_mut","","Create a new mutable `OwningHandle` for a type that implements `ToHandleMut`.",76,[[["o"]],["self"]]],[11,"new_with_fn","","Create a new OwningHandle. The provided callback will be invoked with a pointer to the object owned by `o`, and the returned value is stored as the object to which this `OwningHandle` will forward `Deref` and `DerefMut`.",76,[[["o"],["f"]],["self"]]],[11,"try_new","","Create a new OwningHandle. The provided callback will be invoked with a pointer to the object owned by `o`, and the returned value is stored as the object to which this `OwningHandle` will forward `Deref` and `DerefMut`.",76,[[["o"],["f"]],["result"]]],[11,"deref","","",74,[[["self"]],["t"]]],[11,"deref","","",75,[[["self"]],["t"]]],[11,"deref_mut","","",75,[[["self"]],["t"]]],[11,"as_ref","","",74,[[["self"]],["t"]]],[11,"as_ref","","",75,[[["self"]],["t"]]],[11,"as_mut","","",75,[[["self"]],["t"]]],[11,"borrow","","",74,[[["self"]],["t"]]],[11,"from","","",74,[[["o"]],["self"]]],[11,"from","","",75,[[["o"]],["self"]]],[11,"from","","",74,[[["owningrefmut"]],["self"]]],[11,"fmt","","",74,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",75,[[["self"],["formatter"]],["result"]]],[11,"clone","","",74,[[["self"]],["self"]]],[11,"fmt","","",82,[[["self"],["formatter"]],["result"]]],[11,"eq","","",74,[[["self"],["self"]],["bool"]]],[11,"partial_cmp","","",74,[[["self"],["self"]],["option",["ordering"]]]],[11,"cmp","","",74,[[["self"],["self"]],["ordering"]]],[11,"hash","","",74,[[["self"],["h"]]]],[11,"eq","","",75,[[["self"],["self"]],["bool"]]],[11,"partial_cmp","","",75,[[["self"],["self"]],["option",["ordering"]]]],[11,"cmp","","",75,[[["self"],["self"]],["ordering"]]],[11,"hash","","",75,[[["self"],["h"]]]],[0,"ptr_key","rustc_data_structures","",N,N],[3,"PtrKey","rustc_data_structures::ptr_key","A wrapper around reference that compares and hashes like a pointer. Can be used as a key in sets/maps indexed by pointers to avoid `unsafe`.",N,N],[12,"0","","",83,N],[11,"fmt","","",83,[[["self"],["formatter"]],["result"]]],[11,"clone","","",83,[[["self"]],["self"]]],[11,"eq","","",83,[[["self"],["self"]],["bool"]]],[11,"hash","","",83,[[["self"],["h"]]]],[11,"deref","","",83,N],[0,"sip128","rustc_data_structures","This is a copy of `core::hash::sip` adapted to providing 128 bit hashes.",N,N],[3,"SipHasher128","rustc_data_structures::sip128","",N,N],[12,"k0","","",84,N],[12,"k1","","",84,N],[12,"length","","",84,N],[12,"state","","",84,N],[12,"tail","","",84,N],[12,"ntail","","",84,N],[3,"State","","",N,N],[12,"v0","","",85,N],[12,"v2","","",85,N],[12,"v1","","",85,N],[12,"v3","","",85,N],[3,"Sip24Rounds","","",N,N],[5,"u8to64_le","","Load an u64 using up to 7 bytes of a byte slice.",N,N],[11,"fmt","","",84,[[["self"],["formatter"]],["result"]]],[11,"clone","","",84,[[["self"]],["siphasher128"]]],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"clone","","",85,[[["self"]],["state"]]],[11,"new_with_keys","","",84,[[["u64"],["u64"]],["siphasher128"]]],[11,"reset","","",84,[[["self"]]]],[11,"short_write","","",84,N],[11,"short_write_gen","","",84,[[["self"],["t"]]]],[11,"finish128","","",84,N],[11,"write_u8","","",84,[[["self"],["u8"]]]],[11,"write_u16","","",84,[[["self"],["u16"]]]],[11,"write_u32","","",84,[[["self"],["u32"]]]],[11,"write_u64","","",84,[[["self"],["u64"]]]],[11,"write_usize","","",84,[[["self"],["usize"]]]],[11,"write_i8","","",84,[[["self"],["i8"]]]],[11,"write_i16","","",84,[[["self"],["i16"]]]],[11,"write_i32","","",84,[[["self"],["i32"]]]],[11,"write_i64","","",84,[[["self"],["i64"]]]],[11,"write_isize","","",84,[[["self"],["isize"]]]],[11,"write","","",84,N],[11,"finish","","",84,[[["self"]],["u64"]]],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[11,"clone","","",86,[[["self"]],["sip24rounds"]]],[11,"default","","",86,[[],["sip24rounds"]]],[11,"c_rounds","","",86,[[["state"]]]],[11,"d_rounds","","",86,[[["state"]]]],[0,"small_c_str","rustc_data_structures","",N,N],[3,"SmallCStr","rustc_data_structures::small_c_str","Like SmallVec but for C strings.",N,N],[12,"data","","",87,N],[17,"SIZE","","",N,N],[11,"clone","","",87,[[["self"]],["smallcstr"]]],[11,"new","","",87,[[["str"]],["smallcstr"]]],[11,"new_with_nul","","",87,[[["str"]],["smallcstr"]]],[11,"as_c_str","","",87,[[["self"]],["cstr"]]],[11,"len_with_nul","","",87,[[["self"]],["usize"]]],[11,"spilled","","",87,[[["self"]],["bool"]]],[11,"deref","","",87,[[["self"]],["cstr"]]],[0,"small_vec","rustc_data_structures","A vector type intended to be used for small vectors.",N,N],[6,"OneVector","rustc_data_structures::small_vec","",N,N],[8,"ExpectOne","","",N,N],[10,"expect_one","","",88,N],[0,"snapshot_map","rustc_data_structures","",N,N],[3,"SnapshotMap","rustc_data_structures::snapshot_map","",N,N],[12,"map","","",89,N],[12,"undo_log","","",89,N],[3,"Snapshot","","",N,N],[12,"len","","",90,N],[4,"UndoLog","","",N,N],[13,"OpenSnapshot","","",91,N],[13,"CommittedSnapshot","","",91,N],[13,"Inserted","","",91,N],[13,"Overwrite","","",91,N],[13,"Noop","","",91,N],[11,"new","","",89,[[],["self"]]],[11,"clear","","",89,[[["self"]]]],[11,"insert","","",89,[[["self"],["k"],["v"]],["bool"]]],[11,"insert_noop","","",89,[[["self"]]]],[11,"remove","","",89,[[["self"],["k"]],["bool"]]],[11,"get","","",89,[[["self"],["k"]],["option"]]],[11,"snapshot","","",89,[[["self"]],["snapshot"]]],[11,"assert_open_snapshot","","",89,[[["self"],["snapshot"]]]],[11,"commit","","",89,[[["self"],["snapshot"]]]],[11,"partial_rollback","","",89,[[["self"],["snapshot"],["f"]]]],[11,"rollback_to","","",89,[[["self"],["snapshot"]]]],[11,"reverse","","",89,[[["self"],["undolog"]]]],[11,"index","","",89,[[["self"],["k"]],["v"]]],[0,"sorted_map","rustc_data_structures","",N,N],[3,"SortedMap","rustc_data_structures::sorted_map","`SortedMap` is a data structure with similar characteristics as BTreeMap but slightly different trade-offs: lookup, inseration, and removal are O(log(N)) and elements can be iterated in order cheaply.",N,N],[12,"data","","",92,N],[22,"","","",N,N],[22,"","","",N,N],[11,"clone","","",92,[[["self"]],["sortedmap"]]],[11,"eq","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"ne","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",92,N],[11,"partial_cmp","","",92,[[["self"],["sortedmap"]],["option",["ordering"]]]],[11,"lt","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"le","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"gt","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"ge","","",92,[[["self"],["sortedmap"]],["bool"]]],[11,"cmp","","",92,[[["self"],["sortedmap"]],["ordering"]]],[11,"hash","","",92,N],[11,"default","","",92,[[],["sortedmap"]]],[11,"fmt","","",92,[[["self"],["formatter"]],["result"]]],[11,"encode","","",92,[[["self"],["__skv"]],["result"]]],[11,"decode","","",92,[[["__dkv"]],["result",["sortedmap"]]]],[11,"new","","",92,[[],["sortedmap"]]],[11,"from_presorted_elements","","Construct a `SortedMap` from a presorted set of elements. This is faster than creating an empty map and then inserting the elements individually.",92,[[["vec"]],["sortedmap"]]],[11,"insert","","",92,[[["self"],["k"],["v"]],["option"]]],[11,"remove","","",92,[[["self"],["k"]],["option"]]],[11,"get","","",92,[[["self"],["k"]],["option"]]],[11,"get_mut","","",92,[[["self"],["k"]],["option"]]],[11,"clear","","",92,[[["self"]]]],[11,"iter","","Iterate over elements, sorted by key",92,[[["self"]],["iter"]]],[11,"keys","","Iterate over the keys, sorted",92,N],[11,"values","","Iterate over values, sorted by key",92,N],[11,"len","","",92,[[["self"]],["usize"]]],[11,"range","","",92,N],[11,"remove_range","","",92,[[["self"],["r"]]]],[11,"offset_keys","","Mutate all keys with the given function `f`. This mutation must not change the sort-order of keys.",92,[[["self"],["f"]]]],[11,"insert_presorted","","Inserts a presorted range of elements into the map. If the range can be inserted as a whole in between to existing elements of the map, this will be faster than inserting the elements individually.",92,[[["self"],["vec"]]]],[11,"lookup_index_for","","Looks up the key in `self.data` via `slice::binary_search()`.",92,[[["self"],["k"]],["result",["usize","usize"]]]],[11,"range_slice_indices","","",92,N],[11,"into_iter","","",92,N],[11,"index","","",92,N],[11,"index_mut","","",92,N],[11,"from","","",92,[[["i"]],["self"]]],[0,"stable_hasher","rustc_data_structures","",N,N],[3,"StableHasher","rustc_data_structures::stable_hasher","When hashing something that ends up affecting properties like symbol names, we want these symbol names to be calculated independently of other factors like what architecture you're compiling from.",N,N],[12,"state","","",93,N],[12,"bytes_hashed","","",93,N],[12,"width","","",93,N],[3,"StableVec","","A vector container that makes sure that its items are hashed in a stable order.",N,N],[12,"0","","",94,N],[5,"hash_stable_hashmap","","",N,[[["hcx"],["stablehasher"],["hashmap"],["f"]]]],[8,"StableHasherResult","","",N,N],[10,"finish","","",95,[[["stablehasher"]],["self"]]],[8,"HashStable","","Something that implements `HashStable<CTX>` can be hashed in a way that is stable across multiple compilation sessions.",N,N],[10,"hash_stable","","",96,[[["self"],["ctx"],["stablehasher"]]]],[8,"ToStableHashKey","","Implement this for types that can be turned into stable keys like, for example, for DefId that can be converted to a DefPathHash. This is used for bringing maps into a predictable order before hashing them.",N,N],[16,"KeyType","","",97,N],[10,"to_stable_hash_key","","",97,N],[11,"fmt","","",93,[[["self"],["formatter"]],["result"]]],[11,"new","","",93,[[],["self"]]],[11,"finish","","",93,[[["self"]],["w"]]],[11,"finalize","","",93,N],[11,"bytes_hashed","","",93,[[["self"]],["u64"]]],[11,"finish","","",93,[[["self"]],["u64"]]],[11,"write","","",93,N],[11,"write_u8","","",93,[[["self"],["u8"]]]],[11,"write_u16","","",93,[[["self"],["u16"]]]],[11,"write_u32","","",93,[[["self"],["u32"]]]],[11,"write_u64","","",93,[[["self"],["u64"]]]],[11,"write_u128","","",93,[[["self"],["u128"]]]],[11,"write_usize","","",93,[[["self"],["usize"]]]],[11,"write_i8","","",93,[[["self"],["i8"]]]],[11,"write_i16","","",93,[[["self"],["i16"]]]],[11,"write_i32","","",93,[[["self"],["i32"]]]],[11,"write_i64","","",93,[[["self"],["i64"]]]],[11,"write_i128","","",93,[[["self"],["i128"]]]],[11,"write_isize","","",93,[[["self"],["isize"]]]],[11,"hash_stable","rustc_data_structures::indexed_vec","",61,[[["self"],["ctx"],["stablehasher"]]]],[11,"hash_stable","rustc_data_structures::indexed_set","",55,[[["self"],["ctx"],["stablehasher"]]]],[11,"new","rustc_data_structures::stable_hasher","",94,[[["vec"]],["self"]]],[11,"deref","","",94,[[["self"]],["vec"]]],[11,"hash_stable","","",94,[[["self"],["hcx"],["stablehasher"]]]],[0,"sync","rustc_data_structures","This module defines types which are thread safe if cfg!(parallel_queries) is true.",N,N],[8,"ParallelIterator","rustc_data_structures::sync","An interface for dealing with iterators.",N,N],[16,"Item","","The type of the elements being iterated over.",98,N],[10,"next","","Advances the iterator and returns the next value.",98,[[["self"]],["option"]]],[11,"size_hint","","Returns the bounds on the remaining length of the iterator.",98,N],[11,"count","","Consumes the iterator, counting the number of iterations and returning it.",98,[[["self"]],["usize"]]],[11,"last","","Consumes the iterator, returning the last element.",98,[[["self"]],["option"]]],[11,"nth","","Returns the `n`th element of the iterator.",98,[[["self"],["usize"]],["option"]]],[11,"step_by","","Creates an iterator starting at the same point, but stepping by the given amount at each iteration.",98,[[["self"],["usize"]],["stepby"]]],[11,"chain","","Takes two iterators and creates a new iterator over both in sequence.",98,[[["self"],["u"]],["chain"]]],[11,"zip","","'Zips up' two iterators into a single iterator of pairs.",98,[[["self"],["u"]],["zip"]]],[11,"map","","Takes a closure and creates an iterator which calls that closure on each element.",98,[[["self"],["f"]],["map"]]],[11,"for_each","","Calls a closure on each element of an iterator.",98,N],[11,"filter","","Creates an iterator which uses a closure to determine if an element should be yielded.",98,[[["self"],["p"]],["filter"]]],[11,"filter_map","","Creates an iterator that both filters and maps.",98,[[["self"],["f"]],["filtermap"]]],[11,"enumerate","","Creates an iterator which gives the current iteration count as well as the next value.",98,[[["self"]],["enumerate"]]],[11,"peekable","","Creates an iterator which can use `peek` to look at the next element of the iterator without consuming it.",98,[[["self"]],["peekable"]]],[11,"skip_while","","Creates an iterator that [`skip`]s elements based on a predicate.",98,[[["self"],["p"]],["skipwhile"]]],[11,"take_while","","Creates an iterator that yields elements based on a predicate.",98,[[["self"],["p"]],["takewhile"]]],[11,"skip","","Creates an iterator that skips the first `n` elements.",98,[[["self"],["usize"]],["skip"]]],[11,"take","","Creates an iterator that yields its first `n` elements.",98,[[["self"],["usize"]],["take"]]],[11,"scan","","An iterator adaptor similar to [`fold`] that holds internal state and produces a new iterator.",98,[[["self"],["st"],["f"]],["scan"]]],[11,"flat_map","","Creates an iterator that works like map, but flattens nested structure.",98,[[["self"],["f"]],["flatmap"]]],[11,"flatten","","Creates an iterator that flattens nested structure.",98,[[["self"]],["flatten"]]],[11,"fuse","","Creates an iterator which ends after the first [`None`].",98,[[["self"]],["fuse"]]],[11,"inspect","","Do something with each element of an iterator, passing the value on.",98,[[["self"],["f"]],["inspect"]]],[11,"by_ref","","Borrows an iterator, rather than consuming it.",98,[[["self"]],["self"]]],[11,"collect","","Transforms an iterator into a collection.",98,[[["self"]],["b"]]],[11,"partition","","Consumes an iterator, creating two collections from it.",98,N],[11,"try_fold","","An iterator method that applies a function as long as it returns successfully, producing a single, final value.",98,[[["self"],["b"],["f"]],["r"]]],[11,"try_for_each","","An iterator method that applies a fallible function to each item in the iterator, stopping at the first error and returning that error.",98,[[["self"],["f"]],["r"]]],[11,"fold","","An iterator method that applies a function, producing a single, final value.",98,[[["self"],["b"],["f"]],["b"]]],[11,"all","","Tests if every element of the iterator matches a predicate.",98,[[["self"],["f"]],["bool"]]],[11,"any","","Tests if any element of the iterator matches a predicate.",98,[[["self"],["f"]],["bool"]]],[11,"find","","Searches for an element of an iterator that satisfies a predicate.",98,[[["self"],["p"]],["option"]]],[11,"find_map","","Applies function to the elements of iterator and returns the first non-none result.",98,[[["self"],["f"]],["option"]]],[11,"position","","Searches for an element in an iterator, returning its index.",98,[[["self"],["p"]],["option",["usize"]]]],[11,"rposition","","Searches for an element in an iterator from the right, returning its index.",98,[[["self"],["p"]],["option",["usize"]]]],[11,"max","","Returns the maximum element of an iterator.",98,[[["self"]],["option"]]],[11,"min","","Returns the minimum element of an iterator.",98,[[["self"]],["option"]]],[11,"max_by_key","","Returns the element that gives the maximum value from the specified function.",98,[[["self"],["f"]],["option"]]],[11,"max_by","","Returns the element that gives the maximum value with respect to the specified comparison function.",98,[[["self"],["f"]],["option"]]],[11,"min_by_key","","Returns the element that gives the minimum value from the specified function.",98,[[["self"],["f"]],["option"]]],[11,"min_by","","Returns the element that gives the minimum value with respect to the specified comparison function.",98,[[["self"],["f"]],["option"]]],[11,"rev","","Reverses an iterator's direction.",98,[[["self"]],["rev"]]],[11,"unzip","","Converts an iterator of pairs into a pair of containers.",98,N],[11,"cloned","","Creates an iterator which [`clone`]s all of its elements.",98,[[["self"]],["cloned"]]],[11,"cycle","","Repeats an iterator endlessly.",98,[[["self"]],["cycle"]]],[11,"sum","","Sums the elements of an iterator.",98,[[["self"]],["s"]]],[11,"product","","Iterates over the entire iterator, multiplying all the elements",98,[[["self"]],["p"]]],[11,"cmp","","Lexicographically compares the elements of this `Iterator` with those of another.",98,[[["self"],["i"]],["ordering"]]],[11,"partial_cmp","","Lexicographically compares the elements of this `Iterator` with those of another.",98,[[["self"],["i"]],["option",["ordering"]]]],[11,"eq","","Determines if the elements of this `Iterator` are equal to those of another.",98,[[["self"],["i"]],["bool"]]],[11,"ne","","Determines if the elements of this `Iterator` are unequal to those of another.",98,[[["self"],["i"]],["bool"]]],[11,"lt","","Determines if the elements of this `Iterator` are lexicographically less than those of another.",98,[[["self"],["i"]],["bool"]]],[11,"le","","Determines if the elements of this `Iterator` are lexicographically less or equal to those of another.",98,[[["self"],["i"]],["bool"]]],[11,"gt","","Determines if the elements of this `Iterator` are lexicographically greater than those of another.",98,[[["self"],["i"]],["bool"]]],[11,"ge","","Determines if the elements of this `Iterator` are lexicographically greater than or equal to those of another.",98,[[["self"],["i"]],["bool"]]],[3,"Lrc","","A single-threaded reference-counting pointer. 'Rc' stands for 'Reference Counted'.",N,N],[12,"ptr","","",99,N],[12,"phantom","","",99,N],[3,"Weak","","`Weak` is a version of [`Rc`] that holds a non-owning reference to the managed value. The value is accessed by calling [`upgrade`] on the `Weak` pointer, which returns an [`Option`]`<`[`Rc`]`<T>>`.",N,N],[12,"ptr","","",100,N],[3,"ReadGuard","","Wraps a borrowed reference to a value in a `RefCell` box. A wrapper type for an immutably borrowed value from a `RefCell<T>`.",N,N],[12,"value","","",101,N],[12,"borrow","","",101,N],[3,"MappedReadGuard","","Wraps a borrowed reference to a value in a `RefCell` box. A wrapper type for an immutably borrowed value from a `RefCell<T>`.",N,N],[12,"value","","",101,N],[12,"borrow","","",101,N],[3,"WriteGuard","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",N,N],[12,"value","","",102,N],[12,"borrow","","",102,N],[3,"MappedWriteGuard","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",N,N],[12,"value","","",102,N],[12,"borrow","","",102,N],[3,"LockGuard","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",N,N],[12,"value","","",102,N],[12,"borrow","","",102,N],[3,"MappedLockGuard","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",N,N],[12,"value","","",102,N],[12,"borrow","","",102,N],[3,"SerialScope","","",N,N],[3,"WorkerLocal","","",N,N],[12,"0","","",103,N],[3,"MTLock","","",N,N],[12,"0","","",104,N],[3,"LockCell","","",N,N],[12,"0","","",105,N],[3,"Once","","A type whose inner value can be written once and then will stay read-only",N,N],[12,"0","","",106,N],[12,"1","","",106,N],[3,"Lock","","",N,N],[12,"0","","",107,N],[3,"RwLock","","",N,N],[12,"0","","",108,N],[3,"OneThread","","A type which only allows its inner value to be used in one thread. It will panic if it is used on multiple threads.",N,N],[12,"inner","","",109,N],[5,"serial_join","","",N,N],[5,"serial_scope","","",N,[[["f"]],["r"]]],[5,"par_iter","","",N,N],[5,"assert_sync","","",N,[[]]],[5,"assert_send_val","","",N,[[["t"]]]],[5,"assert_send_sync_val","","",N,[[["t"]]]],[6,"MetadataRef","","",N,N],[6,"MTRef","","",N,N],[8,"Send","","",N,N],[8,"Sync","","",N,N],[8,"HashMapExt","","",N,N],[10,"insert_same","","Same as HashMap::insert, but it may panic if there's already an entry for `key` with a value not equal to `value`",110,[[["self"],["k"],["v"]]]],[11,"spawn","","",111,[[["self"],["f"]]]],[11,"fmt","","",103,[[["self"],["formatter"]],["result"]]],[11,"new","","Creates a new worker local where the `initial` closure computes the value this worker local should take for each thread in the thread pool.",103,[[["f"]],["workerlocal"]]],[11,"into_inner","","Returns the worker-local value for each thread",103,[[["self"]],["vec"]]],[11,"deref","","",103,[[["self"]],["t"]]],[11,"fmt","","",104,[[["self"],["formatter"]],["result"]]],[11,"new","","",104,[[["t"]],["self"]]],[11,"into_inner","","",104,[[["self"]],["t"]]],[11,"get_mut","","",104,[[["self"]],["t"]]],[11,"lock","","",104,[[["self"]],["t"]]],[11,"lock_mut","","",104,[[["self"]],["t"]]],[11,"clone","","",104,[[["self"]],["self"]]],[11,"new","","",105,[[["t"]],["self"]]],[11,"into_inner","","",105,[[["self"]],["t"]]],[11,"set","","",105,[[["self"],["t"]]]],[11,"get","","",105,[[["self"]],["t"]]],[11,"set_mut","","",105,[[["self"],["t"]]]],[11,"get_mut","","",105,[[["self"]],["t"]]],[11,"take","","",105,[[["self"]],["option"]]],[11,"new","","Creates an Once value which is uninitialized",106,[[],["self"]]],[11,"into_inner","","Consumes the value and returns Some(T) if it was initialized",106,[[["self"]],["option"]]],[11,"try_set","","Tries to initialize the inner value to `value`. Returns `None` if the inner value was uninitialized and `value` was consumed setting it otherwise if the inner value was already set it returns `value` back to the caller",106,[[["self"],["t"]],["option"]]],[11,"try_set_same","","Tries to initialize the inner value to `value`. Returns `None` if the inner value was uninitialized and `value` was consumed setting it otherwise if the inner value was already set it asserts that `value` is equal to the inner value and then returns `value` back to the caller",106,[[["self"],["t"]],["option"]]],[11,"set","","Tries to initialize the inner value to `value` and panics if it was already initialized",106,[[["self"],["t"]]]],[11,"init_locking","","Tries to initialize the inner value by calling the closure while ensuring that no-one else can access the value in the mean time by holding a lock for the duration of the closure. If the value was already initialized the closure is not called and `false` is returned, otherwise if the value from the closure initializes the inner value, `true` is returned",106,[[["self"],["f"]],["bool"]]],[11,"init_nonlocking","","Tries to initialize the inner value by calling the closure without ensuring that no-one else can access it. This mean when this is called from multiple threads, multiple closures may concurrently be computing a value which the inner value should take. Only one of these closures are used to actually initialize the value. If some other closure already set the value, we return the value our closure computed wrapped in a `Option`. If our closure set the value, `None` is returned. If the value is already initialized, the closure is not called and `None` is returned.",106,[[["self"],["f"]],["option"]]],[11,"init_nonlocking_same","","Tries to initialize the inner value by calling the closure without ensuring that no-one else can access it. This mean when this is called from multiple threads, multiple closures may concurrently be computing a value which the inner value should take. Only one of these closures are used to actually initialize the value. If some other closure already set the value, we assert that it our closure computed a value equal to the value already set and then we return the value our closure computed wrapped in a `Option`. If our closure set the value, `None` is returned. If the value is already initialized, the closure is not called and `None` is returned.",106,[[["self"],["f"]],["option"]]],[11,"try_get","","Tries to get a reference to the inner value, returns `None` if it is not yet initialized",106,[[["self"]],["option"]]],[11,"get","","Gets reference to the inner value, panics if it is not yet initialized",106,[[["self"]],["t"]]],[11,"borrow","","Gets reference to the inner value, panics if it is not yet initialized",106,[[["self"]],["t"]]],[11,"fmt","","",105,[[["self"],["formatter"]],["result"]]],[11,"default","","Creates a `LockCell<T>`, with the `Default` value for T.",105,[[],["lockcell"]]],[11,"eq","","",105,[[["self"],["lockcell"]],["bool"]]],[11,"partial_cmp","","",105,[[["self"],["lockcell"]],["option",["ordering"]]]],[11,"lt","","",105,[[["self"],["lockcell"]],["bool"]]],[11,"le","","",105,[[["self"],["lockcell"]],["bool"]]],[11,"gt","","",105,[[["self"],["lockcell"]],["bool"]]],[11,"ge","","",105,[[["self"],["lockcell"]],["bool"]]],[11,"cmp","","",105,[[["self"],["lockcell"]],["ordering"]]],[11,"fmt","","",107,[[["self"],["formatter"]],["result"]]],[11,"new","","",107,[[["t"]],["self"]]],[11,"into_inner","","",107,[[["self"]],["t"]]],[11,"get_mut","","",107,[[["self"]],["t"]]],[11,"try_lock","","",107,[[["self"]],["option",["lockguard"]]]],[11,"lock","","",107,[[["self"]],["lockguard"]]],[11,"with_lock","","",107,[[["self"],["f"]],["r"]]],[11,"borrow","","",107,[[["self"]],["lockguard"]]],[11,"borrow_mut","","",107,[[["self"]],["lockguard"]]],[11,"default","","",107,[[],["self"]]],[11,"clone","","",107,[[["self"]],["self"]]],[11,"fmt","","",108,[[["self"],["formatter"]],["result"]]],[11,"new","","",108,[[["t"]],["self"]]],[11,"into_inner","","",108,[[["self"]],["t"]]],[11,"get_mut","","",108,[[["self"]],["t"]]],[11,"read","","",108,[[["self"]],["readguard"]]],[11,"with_read_lock","","",108,[[["self"],["f"]],["r"]]],[11,"try_write","","",108,[[["self"]],["result",["writeguard"]]]],[11,"write","","",108,[[["self"]],["writeguard"]]],[11,"with_write_lock","","",108,[[["self"],["f"]],["r"]]],[11,"borrow","","",108,[[["self"]],["readguard"]]],[11,"borrow_mut","","",108,[[["self"]],["writeguard"]]],[11,"clone","","",108,[[["self"]],["self"]]],[11,"clone","","",109,[[["self"]],["onethread"]]],[11,"hash","","",109,N],[11,"fmt","","",109,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",109,N],[11,"eq","","",109,[[["self"],["onethread"]],["bool"]]],[11,"ne","","",109,[[["self"],["onethread"]],["bool"]]],[11,"check","","",109,[[["self"]]]],[11,"new","","",109,[[["t"]],["self"]]],[11,"into_inner","","",109,[[["self"]],["t"]]],[11,"deref","","",109,[[["self"]],["t"]]],[11,"deref_mut","","",109,[[["self"]],["t"]]],[0,"tiny_list","rustc_data_structures","A singly-linked list.",N,N],[3,"TinyList","rustc_data_structures::tiny_list","",N,N],[12,"head","","",112,N],[3,"Element","","",N,N],[12,"data","","",113,N],[12,"next","","",113,N],[11,"clone","","",112,[[["self"]],["tinylist"]]],[11,"hash","","",112,N],[11,"fmt","","",112,[[["self"],["formatter"]],["result"]]],[11,"eq","","",112,[[["self"],["tinylist"]],["bool"]]],[11,"ne","","",112,[[["self"],["tinylist"]],["bool"]]],[11,"new","","",112,[[],["tinylist"]]],[11,"new_single","","",112,[[["t"]],["tinylist"]]],[11,"insert","","",112,[[["self"],["t"]]]],[11,"remove","","",112,[[["self"],["t"]],["bool"]]],[11,"contains","","",112,[[["self"],["t"]],["bool"]]],[11,"len","","",112,[[["self"]],["usize"]]],[11,"clone","","",113,[[["self"]],["element"]]],[11,"hash","","",113,N],[11,"fmt","","",113,[[["self"],["formatter"]],["result"]]],[11,"eq","","",113,[[["self"],["element"]],["bool"]]],[11,"ne","","",113,[[["self"],["element"]],["bool"]]],[11,"remove_next","","",113,[[["self"],["t"]],["bool"]]],[11,"len","","",113,[[["self"]],["usize"]]],[11,"contains","","",113,[[["self"],["t"]],["bool"]]],[0,"thin_vec","rustc_data_structures","",N,N],[3,"ThinVec","rustc_data_structures::thin_vec","A vector type optimized for cases where this size is usually 0 (c.f. `SmallVector`). The `Option<Box<..>>` wrapping allows us to represent a zero sized vector with `None`, which uses only a single (null) pointer.",N,N],[12,"0","","",114,N],[11,"clone","","",114,[[["self"]],["thinvec"]]],[11,"eq","","",114,[[["self"],["thinvec"]],["bool"]]],[11,"ne","","",114,[[["self"],["thinvec"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",114,N],[11,"encode","","",114,[[["self"],["__st"]],["result"]]],[11,"decode","","",114,[[["__dt"]],["result",["thinvec"]]]],[11,"hash","","",114,N],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"new","","",114,[[],["self"]]],[11,"from","","",114,[[["vec"]],["self"]]],[11,"into","","",114,[[["self"]],["vec"]]],[11,"deref","","",114,N],[11,"extend","","",114,[[["self"],["i"]]]],[0,"transitive_relation","rustc_data_structures","",N,N],[3,"TransitiveRelation","rustc_data_structures::transitive_relation","",N,N],[12,"elements","","",115,N],[12,"map","","",115,N],[12,"edges","","",115,N],[12,"closure","","",115,N],[3,"Index","","",N,N],[12,"0","","",116,N],[3,"Edge","","",N,N],[12,"source","","",117,N],[12,"target","","",117,N],[5,"pare_down","","Pare down is used as a step in the LUB computation. It edits the candidates array in place by removing any element j for which there exists an earlier element i<j such that i -> j. That is, after you run `pare_down`, you know that for all elements that remain in candidates, they cannot reach any of the elements that come after them.",N,[[["vec"],["bitmatrix"]]]],[11,"clone","","",115,[[["self"]],["transitiverelation"]]],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"clone","","",116,[[["self"]],["index"]]],[11,"eq","","",116,[[["self"],["index"]],["bool"]]],[11,"ne","","",116,[[["self"],["index"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",116,N],[11,"partial_cmp","","",116,[[["self"],["index"]],["option",["ordering"]]]],[11,"lt","","",116,[[["self"],["index"]],["bool"]]],[11,"le","","",116,[[["self"],["index"]],["bool"]]],[11,"gt","","",116,[[["self"],["index"]],["bool"]]],[11,"ge","","",116,[[["self"],["index"]],["bool"]]],[11,"cmp","","",116,[[["self"],["index"]],["ordering"]]],[11,"hash","","",116,N],[11,"encode","","",116,[[["self"],["__s"]],["result"]]],[11,"decode","","",116,[[["__d"]],["result",["index"]]]],[11,"fmt","","",116,[[["self"],["formatter"]],["result"]]],[11,"clone","","",117,[[["self"]],["edge"]]],[11,"eq","","",117,[[["self"],["edge"]],["bool"]]],[11,"ne","","",117,[[["self"],["edge"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",117,N],[11,"encode","","",117,[[["self"],["__s"]],["result"]]],[11,"decode","","",117,[[["__d"]],["result",["edge"]]]],[11,"fmt","","",117,[[["self"],["formatter"]],["result"]]],[11,"new","","",115,[[],["transitiverelation"]]],[11,"is_empty","","",115,[[["self"]],["bool"]]],[11,"index","","",115,[[["self"],["t"]],["option",["index"]]]],[11,"add_index","","",115,[[["self"],["t"]],["index"]]],[11,"maybe_map","","Applies the (partial) function to each edge and returns a new relation.  If `f` returns `None` for any end-point, returns `None`.",115,[[["self"],["f"]],["option",["transitiverelation"]]]],[11,"add","","Indicate that `a < b` (where `<` is this relation)",115,[[["self"],["t"],["t"]]]],[11,"contains","","Check whether `a < target` (transitively)",115,[[["self"],["t"],["t"]],["bool"]]],[11,"reachable_from","","Thinking of `x R y` as an edge `x -> y` in a graph, this returns all things reachable from `a`.",115,[[["self"],["t"]],["vec"]]],[11,"postdom_upper_bound","","Picks what I am referring to as the \"postdominating\" upper-bound for `a` and `b`. This is usually the least upper bound, but in cases where there is no single least upper bound, it is the \"mutual immediate postdominator\", if you imagine a graph where `a < b` means `a -> b`.",115,[[["self"],["t"],["t"]],["option"]]],[11,"mutual_immediate_postdominator","","Viewing the relation as a graph, computes the \"mutual immediate postdominator\" of a set of points (if one exists). See `postdom_upper_bound` for details.",115,[[["self"],["vec"]],["option"]]],[11,"minimal_upper_bounds","","Returns the set of bounds `X` such that:",115,[[["self"],["t"],["t"]],["vec"]]],[11,"parents","","Given an element A, returns the maximal set {B} of elements B such that",115,[[["self"],["t"]],["vec"]]],[11,"postdom_parent","","A \"best\" parent in some sense. See `parents` and `postdom_upper_bound` for more details.",115,[[["self"],["t"]],["option"]]],[11,"with_closure","","",115,[[["self"],["op"]],["r"]]],[11,"compute_closure","","",115,[[["self"]],["bitmatrix",["usize","usize"]]]],[11,"encode","","",115,[[["self"],["e"]],["result"]]],[11,"decode","","",115,[[["d"]],["result"]]],[11,"hash_stable","","",115,[[["self"],["ctx"],["stablehasher"]]]],[11,"hash_stable","","",117,[[["self"],["ctx"],["stablehasher"]]]],[11,"hash_stable","","",116,[[["self"],["ctx"],["stablehasher"]]]],[0,"tuple_slice","rustc_data_structures","",N,N],[8,"TupleSlice","rustc_data_structures::tuple_slice","Allows to view uniform tuples as slices",N,N],[10,"as_slice","","",118,N],[10,"as_mut_slice","","",118,N],[0,"vec_linked_list","rustc_data_structures","",N,N],[3,"VecLinkedListIterator","rustc_data_structures::vec_linked_list","",N,N],[12,"links","","",119,N],[12,"current","","",119,N],[5,"iter","","",N,N],[22,"","","",N,N],[8,"Links","","",N,N],[16,"LinkIndex","","",120,N],[10,"next","","",120,N],[8,"LinkElem","","",N,N],[16,"LinkIndex","","",121,N],[10,"next","","",121,[[["self"]],["option"]]],[11,"next","","",119,[[["self"]],["option"]]],[11,"next","rustc_data_structures::indexed_vec","",61,[[["self"],["l"]],["option"]]],[0,"work_queue","rustc_data_structures","",N,N],[3,"WorkQueue","rustc_data_structures::work_queue","A work queue is a handy data structure for tracking work left to do. (For example, basic blocks left to process.) It is basically a de-duplicating queue; so attempting to insert X if X is already enqueued has no effect. This implementation assumes that the elements are dense indices, so it can allocate the queue to size and also use a bit set to track occupancy.",N,N],[12,"deque","","",122,N],[12,"set","","",122,N],[11,"with_all","","Create a new work queue with all the elements from (0..len).",122,[[["usize"]],["self"]]],[11,"with_none","","Create a new work queue that starts empty, where elements range from (0..len).",122,[[["usize"]],["self"]]],[11,"insert","","Attempt to enqueue `element` in the work queue. Returns false if it was already present.",122,[[["self"],["t"]],["bool"]]],[11,"pop","","Attempt to enqueue `element` in the work queue. Returns false if it was already present.",122,[[["self"]],["option"]]],[11,"is_empty","","True if nothing is enqueued.",122,[[["self"]],["bool"]]],[0,"fingerprint","rustc_data_structures","",N,N],[3,"Fingerprint","rustc_data_structures::fingerprint","",N,N],[12,"0","","",123,N],[12,"1","","",123,N],[11,"assert_receiver_is_total_eq","","",123,N],[11,"eq","","",123,[[["self"],["fingerprint"]],["bool"]]],[11,"ne","","",123,[[["self"],["fingerprint"]],["bool"]]],[11,"cmp","","",123,[[["self"],["fingerprint"]],["ordering"]]],[11,"partial_cmp","","",123,[[["self"],["fingerprint"]],["option",["ordering"]]]],[11,"lt","","",123,[[["self"],["fingerprint"]],["bool"]]],[11,"le","","",123,[[["self"],["fingerprint"]],["bool"]]],[11,"gt","","",123,[[["self"],["fingerprint"]],["bool"]]],[11,"ge","","",123,[[["self"],["fingerprint"]],["bool"]]],[11,"hash","","",123,N],[11,"fmt","","",123,[[["self"],["formatter"]],["result"]]],[11,"clone","","",123,[[["self"]],["fingerprint"]]],[18,"ZERO","","",123,N],[11,"from_smaller_hash","","",123,[[["u64"]],["fingerprint"]]],[11,"to_smaller_hash","","",123,[[["self"]],["u64"]]],[11,"as_value","","",123,N],[11,"combine","","",123,[[["self"],["fingerprint"]],["fingerprint"]]],[11,"combine_commutative","","",123,[[["self"],["fingerprint"]],["fingerprint"]]],[11,"to_hex","","",123,[[["self"]],["string"]]],[11,"encode_opaque","","",123,[[["self"],["encoder"]],["encoderesult"]]],[11,"decode_opaque","","",123,[[["decoder"]],["result",["fingerprint","string"]]]],[11,"fmt","","",123,[[["self"],["formatter"]],["result"]]],[11,"finish","","",123,[[["stablehasher"]],["self"]]],[11,"hash_stable","","",123,[[["self"],["ctx"],["stablehasher"]]]],[11,"disable","rustc_data_structures","Forgets the function which prevents it from running. Ensure that the function owns no memory, otherwise it will be leaked.",13,[[["self"]]]],[11,"drop","","",13,[[["self"]]]],[14,"const_cstr","","This macro creates a zero-overhead &CStr by adding a NUL terminator to the string literal passed into it at compile-time. Use it like:",N,N],[14,"newtype_index","","Creates a struct type `S` that can be used as an index with `IndexVec` and so on.",N,N],[14,"impl_stable_hash_via_hash","","",N,N],[14,"rustc_erase_owner","","",N,N],[11,"from","rustc_data_structures::sync","",99,[[["cstr"]],["rc",["cstr"]]]],[11,"from","","Converts a [`CString`] into a [`Rc`]`<CStr>` without copying or allocating.",99,[[["cstring"]],["rc",["cstr"]]]],[11,"from","","",99,[[["pathbuf"]],["rc",["path"]]]],[11,"from","","",99,[[["path"]],["rc",["path"]]]],[11,"from","","Converts a [`OsString`] into a [`Rc`]`<OsStr>` without copying or allocating.",99,[[["osstring"]],["rc",["osstr"]]]],[11,"from","","",99,[[["osstr"]],["rc",["osstr"]]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result",["error"]]]],[11,"deref_mut","","",102,[[["self"]],["t"]]],[11,"deref","","",102,[[["self"]],["t"]]],[11,"deref","","",101,[[["self"]],["t"]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result",["error"]]]],[11,"partial_cmp","","Partial comparison for two `Rc`s.",99,[[["self"],["rc"]],["option",["ordering"]]]],[11,"lt","","Less-than comparison for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"le","","'Less than or equal to' comparison for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"gt","","Greater-than comparison for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"ge","","'Greater than or equal to' comparison for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"drop","","Drops the `Rc`.",99,N],[11,"drop","","Drops the `Weak` pointer.",100,N],[11,"as_ref","","",99,[[["self"]],["t"]]],[11,"deref","","",99,[[["self"]],["t"]]],[11,"borrow","","",99,[[["self"]],["t"]]],[11,"default","","Constructs a new `Weak<T>`, allocating memory for `T` without initializing it. Calling [`upgrade`][Weak::upgrade] on the return value always gives [`None`].",100,[[],["weak"]]],[11,"default","","Creates a new `Rc<T>`, with the `Default` value for `T`.",99,[[],["rc"]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result",["error"]]]],[11,"from","","",99,[[["str"]],["rc",["str"]]]],[11,"from","","",99,[[["vec"]],["rc"]]],[11,"from","","",99,N],[11,"from","","",99,[[["string"]],["rc",["str"]]]],[11,"from","","",99,[[["box"]],["rc"]]],[11,"from","","",99,[[["t"]],["rc"]]],[11,"clone","","Makes a clone of the `Rc` pointer.",99,[[["self"]],["rc"]]],[11,"clone","","Makes a clone of the `Weak` pointer that points to the same value.",100,[[["self"]],["weak"]]],[11,"hash","","",99,N],[11,"fmt","","",99,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",100,[[["self"],["formatter"]],["result",["error"]]]],[11,"eq","","Equality for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"ne","","Inequality for two `Rc`s.",99,[[["self"],["rc"]],["bool"]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result",["error"]]]],[11,"cmp","","Comparison for two `Rc`s.",99,[[["self"],["rc"]],["ordering"]]],[11,"eq","rustc_data_structures::unify","",8,[[["self"],["varvalue"]],["bool"]]],[11,"ne","","",8,[[["self"],["varvalue"]],["bool"]]],[11,"fmt","rustc_data_structures::snapshot_vec","",2,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc_data_structures::unify","",9,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc_data_structures::snapshot_vec","",1,[[["self"],["formatter"]],["result",["error"]]]],[11,"deref","","",2,N],[11,"index_mut","","",2,N],[11,"extend","","",2,N],[11,"new","rustc_data_structures::unify","",12,[[],["inplace"]]],[11,"start_snapshot","","",12,N],[11,"rollback_to","","",12,N],[11,"commit","","",12,N],[11,"reset_unifications","","",12,N],[11,"len","","",12,[[["self"]],["usize"]]],[11,"push","","",12,N],[11,"reserve","","",12,N],[11,"update","","",12,N],[11,"clone","","",12,[[["self"]],["inplace"]]],[11,"clone","rustc_data_structures::snapshot_vec","",1,[[["self"]],["undolog"]]],[11,"clone","","",2,[[["self"]],["snapshotvec"]]],[11,"clone","rustc_data_structures::unify","",8,[[["self"]],["varvalue"]]],[11,"clone","","",9,[[["self"]],["unificationtable"]]],[11,"deref_mut","rustc_data_structures::snapshot_vec","",2,N],[11,"index","","",2,N],[11,"index","rustc_data_structures::unify","",12,[[["self"],["usize"]],["varvalue"]]],[11,"decode","rustc_data_structures::sync","",99,[[["d"]],["result",["rc"]]]],[11,"decode","","",99,[[["d"]],["result",["rc"]]]],[11,"encode","","",99,[[["self"],["e"]],["result"]]],[11,"encode","","",99,[[["self"],["s"]],["result"]]],[11,"into_erased","","",99,N],[11,"write","rustc_data_structures::fx","",30,N],[11,"write_u8","","",30,N],[11,"write_u16","","",30,N],[11,"write_u32","","",30,N],[11,"write_u64","","",30,N],[11,"write_usize","","",30,N],[11,"finish","","",30,[[["self"]],["u64"]]],[11,"default","","",30,[[],["fxhasher"]]],[11,"to_owned","rustc_data_structures::snapshot_vec","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"new","","",2,[[],["snapshotvec"]]],[11,"with_capacity","","",2,[[["usize"]],["snapshotvec"]]],[11,"record","","",2,N],[11,"len","","",2,[[["self"]],["usize"]]],[11,"push","","",2,N],[11,"get","","",2,N],[11,"reserve","","Reserve space for new values, just like an ordinary vec.",2,N],[11,"get_mut","","Returns a mutable pointer into the vec; whatever changes you make here cannot be undone automatically, so you should be sure call `record()` with some sort of suitable undo action.",2,N],[11,"set","","Updates the element at the given index. The old value will saved (and perhaps restored) if a snapshot is active.",2,N],[11,"set_all","","Updates all elements. Potentially more efficient -- but otherwise equivalent to -- invoking `set` for each element.",2,N],[11,"update","","",2,N],[11,"start_snapshot","","",2,[[["self"]],["snapshot"]]],[11,"actions_since_snapshot","","",2,N],[11,"rollback_to","","",2,N],[11,"commit","","Commits all changes since the last snapshot. Of course, they can still be undone if there is a snapshot further out.",2,N],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::unify","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"new","","",9,[[],["unificationtable"]]],[11,"snapshot","","Starts a new snapshot. Each snapshot must be either rolled back or committed in a \"LIFO\" (stack) order.",9,[[["self"]],["snapshot"]]],[11,"rollback_to","","Reverses all changes since the last snapshot. Also removes any keys that have been created since then.",9,N],[11,"commit","","Commits all changes since the last snapshot. Of course, they can still be undone if there is a snapshot further out.",9,N],[11,"new_key","","Creates a fresh key with the given value.",9,N],[11,"reserve","","Reserve memory for `num_new_keys` to be created. Does not actually create the new keys; you must then invoke `new_key`.",9,N],[11,"reset_unifications","","Clears all unifications that have been performed, resetting to the initial state. The values of each variable are given by the closure.",9,N],[11,"len","","Returns the number of keys created so far.",9,[[["self"]],["usize"]]],[11,"union","","Unions two keys without the possibility of failure; only applicable when unify values use `NoError` as their error type.",9,N],[11,"union_value","","Unions a key and a value without the possibility of failure; only applicable when unify values use `NoError` as their error type.",9,N],[11,"unioned","","Given two keys, indicates whether they have been unioned together.",9,[[["self"],["k1"],["k2"]],["bool"]]],[11,"find","","Given a key, returns the (current) root key.",9,[[["self"],["k1"]],["k"]]],[11,"unify_var_var","","Unions together two variables, merging their values. If merging the values fails, the error is propagated and this method has no effect.",9,[[["self"],["k1"],["k2"]],["result"]]],[11,"unify_var_value","","Sets the value of the key `a_id` to `b`, attempting to merge with the previous value.",9,[[["self"],["k1"],["v"]],["result"]]],[11,"probe_value","","Returns the current value for the given key. If the key has been union'd, this will give the value from the current root.",9,[[["self"],["k1"]],["v"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"to_owned","","",12,[[["self"]],["t"]]],[11,"clone_into","","",12,N],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::svh","",14,[[["self"]],["t"]]],[11,"clone_into","","",14,N],[11,"from","","",14,[[["t"]],["t"]]],[11,"to_string","","",14,[[["self"]],["string"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"encode","","",14,[[["self"],["e"]],["result"]]],[11,"decode","","",14,[[["d"]],["result"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::array_vec","",15,[[["self"]],["t"]]],[11,"clone_into","","",15,N],[11,"from","","",15,[[["t"]],["t"]]],[11,"into_iter","","",15,[[["self"]],["i"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into_iter","","",16,[[["self"]],["i"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from","","",17,[[["t"]],["t"]]],[11,"into_iter","","",17,[[["self"]],["i"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::bitvec","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"encode","","",19,[[["self"],["e"]],["result"]]],[11,"decode","","",19,[[["d"]],["result"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"from","","",20,[[["t"]],["t"]]],[11,"into_iter","","",20,[[["self"]],["i"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from","","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"to_owned","","",22,[[["self"]],["t"]]],[11,"clone_into","","",22,N],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"to_owned","","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::flock","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::flock::os","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::fx","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::graph::dominators","",31,[[["self"]],["t"]]],[11,"clone_into","","",31,N],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"from","","",32,[[["t"]],["t"]]],[11,"into_iter","","",32,[[["self"]],["i"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from","","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::graph::implementation","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"from","","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"to_owned","","",38,[[["self"]],["t"]]],[11,"clone_into","","",38,N],[11,"from","","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"to_owned","","",39,[[["self"]],["t"]]],[11,"clone_into","","",39,N],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"to_owned","","",40,[[["self"]],["t"]]],[11,"clone_into","","",40,N],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from","","",41,[[["t"]],["t"]]],[11,"into_iter","","",41,[[["self"]],["i"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"not_found","","",41,[[["str"],["str"]],["e"]]],[11,"from","","",42,[[["t"]],["t"]]],[11,"into_iter","","",42,[[["self"]],["i"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"not_found","","",42,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::graph::scc","",43,[[["t"]],["t"]]],[11,"into","","",43,[[["self"]],["u"]]],[11,"try_from","","",43,[[["u"]],["result"]]],[11,"borrow","","",43,[[["self"]],["t"]]],[11,"try_into","","",43,[[["self"]],["result"]]],[11,"borrow_mut","","",43,[[["self"]],["t"]]],[11,"get_type_id","","",43,[[["self"]],["typeid"]]],[11,"not_found","","",43,[[["str"],["str"]],["e"]]],[11,"from","","",44,[[["t"]],["t"]]],[11,"into","","",44,[[["self"]],["u"]]],[11,"try_from","","",44,[[["u"]],["result"]]],[11,"borrow","","",44,[[["self"]],["t"]]],[11,"try_into","","",44,[[["self"]],["result"]]],[11,"borrow_mut","","",44,[[["self"]],["t"]]],[11,"get_type_id","","",44,[[["self"]],["typeid"]]],[11,"not_found","","",44,[[["str"],["str"]],["e"]]],[11,"from","","",45,[[["t"]],["t"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"not_found","","",45,[[["str"],["str"]],["e"]]],[11,"to_owned","","",46,[[["self"]],["t"]]],[11,"clone_into","","",46,N],[11,"from","","",46,[[["t"]],["t"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"not_found","","",46,[[["str"],["str"]],["e"]]],[11,"to_owned","","",47,[[["self"]],["t"]]],[11,"clone_into","","",47,N],[11,"from","","",47,[[["t"]],["t"]]],[11,"into","","",47,[[["self"]],["u"]]],[11,"try_from","","",47,[[["u"]],["result"]]],[11,"borrow","","",47,[[["self"]],["t"]]],[11,"try_into","","",47,[[["self"]],["result"]]],[11,"borrow_mut","","",47,[[["self"]],["t"]]],[11,"get_type_id","","",47,[[["self"]],["typeid"]]],[11,"not_found","","",47,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::indexed_set","",55,[[["self"]],["t"]]],[11,"clone_into","","",55,N],[11,"from","","",55,[[["t"]],["t"]]],[11,"into","","",55,[[["self"]],["u"]]],[11,"try_from","","",55,[[["u"]],["result"]]],[11,"borrow","","",55,[[["self"]],["t"]]],[11,"try_into","","",55,[[["self"]],["result"]]],[11,"borrow_mut","","",55,[[["self"]],["t"]]],[11,"get_type_id","","",55,[[["self"]],["typeid"]]],[11,"encode","","",55,[[["self"],["e"]],["result"]]],[11,"decode","","",55,[[["d"]],["result"]]],[11,"not_found","","",55,[[["str"],["str"]],["e"]]],[11,"to_owned","","",56,[[["self"]],["t"]]],[11,"clone_into","","",56,N],[11,"from","","",56,[[["t"]],["t"]]],[11,"into","","",56,[[["self"]],["u"]]],[11,"try_from","","",56,[[["u"]],["result"]]],[11,"borrow","","",56,[[["self"]],["t"]]],[11,"try_into","","",56,[[["self"]],["result"]]],[11,"borrow_mut","","",56,[[["self"]],["t"]]],[11,"get_type_id","","",56,[[["self"]],["typeid"]]],[11,"not_found","","",56,[[["str"],["str"]],["e"]]],[11,"to_owned","","",57,[[["self"]],["t"]]],[11,"clone_into","","",57,N],[11,"from","","",57,[[["t"]],["t"]]],[11,"into","","",57,[[["self"]],["u"]]],[11,"try_from","","",57,[[["u"]],["result"]]],[11,"borrow","","",57,[[["self"]],["t"]]],[11,"try_into","","",57,[[["self"]],["result"]]],[11,"borrow_mut","","",57,[[["self"]],["t"]]],[11,"get_type_id","","",57,[[["self"]],["typeid"]]],[11,"not_found","","",57,[[["str"],["str"]],["e"]]],[11,"from","","",58,[[["t"]],["t"]]],[11,"into_iter","","",58,[[["self"]],["i"]]],[11,"into","","",58,[[["self"]],["u"]]],[11,"try_from","","",58,[[["u"]],["result"]]],[11,"borrow","","",58,[[["self"]],["t"]]],[11,"try_into","","",58,[[["self"]],["result"]]],[11,"borrow_mut","","",58,[[["self"]],["t"]]],[11,"get_type_id","","",58,[[["self"]],["typeid"]]],[11,"not_found","","",58,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::indexed_vec","",61,[[["self"]],["t"]]],[11,"clone_into","","",61,N],[11,"from","","",61,[[["t"]],["t"]]],[11,"into_iter","","",61,[[["self"]],["i"]]],[11,"into","","",61,[[["self"]],["u"]]],[11,"try_from","","",61,[[["u"]],["result"]]],[11,"borrow","","",61,[[["self"]],["t"]]],[11,"try_into","","",61,[[["self"]],["result"]]],[11,"borrow_mut","","",61,[[["self"]],["t"]]],[11,"get_type_id","","",61,[[["self"]],["typeid"]]],[11,"encode","","",61,[[["self"],["e"]],["result"]]],[11,"decode","","",61,[[["d"]],["result"]]],[11,"not_found","","",61,[[["str"],["str"]],["e"]]],[11,"from","","",62,[[["t"]],["t"]]],[11,"into","","",62,[[["self"]],["u"]]],[11,"try_from","","",62,[[["u"]],["result"]]],[11,"borrow","","",62,[[["self"]],["t"]]],[11,"try_into","","",62,[[["self"]],["result"]]],[11,"borrow_mut","","",62,[[["self"]],["t"]]],[11,"get_type_id","","",62,[[["self"]],["typeid"]]],[11,"call_box","","",62,N],[11,"not_found","","",62,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::obligation_forest","",64,[[["t"]],["t"]]],[11,"into","","",64,[[["self"]],["u"]]],[11,"try_from","","",64,[[["u"]],["result"]]],[11,"borrow","","",64,[[["self"]],["t"]]],[11,"try_into","","",64,[[["self"]],["result"]]],[11,"borrow_mut","","",64,[[["self"]],["t"]]],[11,"get_type_id","","",64,[[["self"]],["typeid"]]],[11,"not_found","","",64,[[["str"],["str"]],["e"]]],[11,"from","","",65,[[["t"]],["t"]]],[11,"into","","",65,[[["self"]],["u"]]],[11,"try_from","","",65,[[["u"]],["result"]]],[11,"borrow","","",65,[[["self"]],["t"]]],[11,"try_into","","",65,[[["self"]],["result"]]],[11,"borrow_mut","","",65,[[["self"]],["t"]]],[11,"get_type_id","","",65,[[["self"]],["typeid"]]],[11,"not_found","","",65,[[["str"],["str"]],["e"]]],[11,"from","","",66,[[["t"]],["t"]]],[11,"into","","",66,[[["self"]],["u"]]],[11,"try_from","","",66,[[["u"]],["result"]]],[11,"borrow","","",66,[[["self"]],["t"]]],[11,"try_into","","",66,[[["self"]],["result"]]],[11,"borrow_mut","","",66,[[["self"]],["t"]]],[11,"get_type_id","","",66,[[["self"]],["typeid"]]],[11,"not_found","","",66,[[["str"],["str"]],["e"]]],[11,"from","","",67,[[["t"]],["t"]]],[11,"into","","",67,[[["self"]],["u"]]],[11,"try_from","","",67,[[["u"]],["result"]]],[11,"borrow","","",67,[[["self"]],["t"]]],[11,"try_into","","",67,[[["self"]],["result"]]],[11,"borrow_mut","","",67,[[["self"]],["t"]]],[11,"get_type_id","","",67,[[["self"]],["typeid"]]],[11,"not_found","","",67,[[["str"],["str"]],["e"]]],[11,"to_owned","","",68,[[["self"]],["t"]]],[11,"clone_into","","",68,N],[11,"from","","",68,[[["t"]],["t"]]],[11,"into","","",68,[[["self"]],["u"]]],[11,"try_from","","",68,[[["u"]],["result"]]],[11,"borrow","","",68,[[["self"]],["t"]]],[11,"try_into","","",68,[[["self"]],["result"]]],[11,"borrow_mut","","",68,[[["self"]],["t"]]],[11,"get_type_id","","",68,[[["self"]],["typeid"]]],[11,"call_box","","",68,N],[11,"not_found","","",68,[[["str"],["str"]],["e"]]],[11,"from","","",69,[[["t"]],["t"]]],[11,"into","","",69,[[["self"]],["u"]]],[11,"try_from","","",69,[[["u"]],["result"]]],[11,"borrow","","",69,[[["self"]],["t"]]],[11,"try_into","","",69,[[["self"]],["result"]]],[11,"borrow_mut","","",69,[[["self"]],["t"]]],[11,"get_type_id","","",69,[[["self"]],["typeid"]]],[11,"not_found","","",69,[[["str"],["str"]],["e"]]],[11,"to_owned","","",70,[[["self"]],["t"]]],[11,"clone_into","","",70,N],[11,"from","","",70,[[["t"]],["t"]]],[11,"into","","",70,[[["self"]],["u"]]],[11,"try_from","","",70,[[["u"]],["result"]]],[11,"borrow","","",70,[[["self"]],["t"]]],[11,"try_into","","",70,[[["self"]],["result"]]],[11,"borrow_mut","","",70,[[["self"]],["t"]]],[11,"get_type_id","","",70,[[["self"]],["typeid"]]],[11,"not_found","","",70,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::obligation_forest::node_index","",71,[[["self"]],["t"]]],[11,"clone_into","","",71,N],[11,"from","","",71,[[["t"]],["t"]]],[11,"into","","",71,[[["self"]],["u"]]],[11,"try_from","","",71,[[["u"]],["result"]]],[11,"borrow","","",71,[[["self"]],["t"]]],[11,"try_into","","",71,[[["self"]],["result"]]],[11,"borrow_mut","","",71,[[["self"]],["t"]]],[11,"get_type_id","","",71,[[["self"]],["typeid"]]],[11,"not_found","","",71,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::owning_ref","",74,[[["self"]],["t"]]],[11,"clone_into","","",74,N],[11,"from","","",74,[[["t"]],["t"]]],[11,"into","","",74,[[["self"]],["u"]]],[11,"try_from","","",74,[[["u"]],["result"]]],[11,"borrow","","",74,[[["self"]],["t"]]],[11,"try_into","","",74,[[["self"]],["result"]]],[11,"borrow_mut","","",74,[[["self"]],["t"]]],[11,"get_type_id","","",74,[[["self"]],["typeid"]]],[11,"not_found","","",74,[[["str"],["str"]],["e"]]],[11,"from","","",75,[[["t"]],["t"]]],[11,"into","","",75,[[["self"]],["u"]]],[11,"try_from","","",75,[[["u"]],["result"]]],[11,"borrow","","",75,[[["self"]],["t"]]],[11,"try_into","","",75,[[["self"]],["result"]]],[11,"borrow_mut","","",75,[[["self"]],["t"]]],[11,"get_type_id","","",75,[[["self"]],["typeid"]]],[11,"not_found","","",75,[[["str"],["str"]],["e"]]],[11,"from","","",76,[[["t"]],["t"]]],[11,"into","","",76,[[["self"]],["u"]]],[11,"try_from","","",76,[[["u"]],["result"]]],[11,"borrow","","",76,[[["self"]],["t"]]],[11,"try_into","","",76,[[["self"]],["result"]]],[11,"borrow_mut","","",76,[[["self"]],["t"]]],[11,"get_type_id","","",76,[[["self"]],["typeid"]]],[11,"not_found","","",76,[[["str"],["str"]],["e"]]],[11,"into_erased","rustc_data_structures::sync","",99,N],[11,"to_owned","rustc_data_structures::ptr_key","",83,[[["self"]],["t"]]],[11,"clone_into","","",83,N],[11,"from","","",83,[[["t"]],["t"]]],[11,"into","","",83,[[["self"]],["u"]]],[11,"try_from","","",83,[[["u"]],["result"]]],[11,"borrow","","",83,[[["self"]],["t"]]],[11,"try_into","","",83,[[["self"]],["result"]]],[11,"borrow_mut","","",83,[[["self"]],["t"]]],[11,"get_type_id","","",83,[[["self"]],["typeid"]]],[11,"not_found","","",83,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::sip128","",84,[[["self"]],["t"]]],[11,"clone_into","","",84,N],[11,"from","","",84,[[["t"]],["t"]]],[11,"into","","",84,[[["self"]],["u"]]],[11,"try_from","","",84,[[["u"]],["result"]]],[11,"borrow","","",84,[[["self"]],["t"]]],[11,"try_into","","",84,[[["self"]],["result"]]],[11,"borrow_mut","","",84,[[["self"]],["t"]]],[11,"get_type_id","","",84,[[["self"]],["typeid"]]],[11,"not_found","","",84,[[["str"],["str"]],["e"]]],[11,"to_owned","","",85,[[["self"]],["t"]]],[11,"clone_into","","",85,N],[11,"from","","",85,[[["t"]],["t"]]],[11,"into","","",85,[[["self"]],["u"]]],[11,"try_from","","",85,[[["u"]],["result"]]],[11,"borrow","","",85,[[["self"]],["t"]]],[11,"try_into","","",85,[[["self"]],["result"]]],[11,"borrow_mut","","",85,[[["self"]],["t"]]],[11,"get_type_id","","",85,[[["self"]],["typeid"]]],[11,"not_found","","",85,[[["str"],["str"]],["e"]]],[11,"to_owned","","",86,[[["self"]],["t"]]],[11,"clone_into","","",86,N],[11,"from","","",86,[[["t"]],["t"]]],[11,"into","","",86,[[["self"]],["u"]]],[11,"try_from","","",86,[[["u"]],["result"]]],[11,"borrow","","",86,[[["self"]],["t"]]],[11,"try_into","","",86,[[["self"]],["result"]]],[11,"borrow_mut","","",86,[[["self"]],["t"]]],[11,"get_type_id","","",86,[[["self"]],["typeid"]]],[11,"not_found","","",86,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::small_c_str","",87,[[["self"]],["t"]]],[11,"clone_into","","",87,N],[11,"from","","",87,[[["t"]],["t"]]],[11,"into","","",87,[[["self"]],["u"]]],[11,"try_from","","",87,[[["u"]],["result"]]],[11,"borrow","","",87,[[["self"]],["t"]]],[11,"try_into","","",87,[[["self"]],["result"]]],[11,"borrow_mut","","",87,[[["self"]],["t"]]],[11,"get_type_id","","",87,[[["self"]],["typeid"]]],[11,"not_found","","",87,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::snapshot_map","",89,[[["t"]],["t"]]],[11,"into","","",89,[[["self"]],["u"]]],[11,"try_from","","",89,[[["u"]],["result"]]],[11,"borrow","","",89,[[["self"]],["t"]]],[11,"try_into","","",89,[[["self"]],["result"]]],[11,"borrow_mut","","",89,[[["self"]],["t"]]],[11,"get_type_id","","",89,[[["self"]],["typeid"]]],[11,"not_found","","",89,[[["str"],["str"]],["e"]]],[11,"from","","",90,[[["t"]],["t"]]],[11,"into","","",90,[[["self"]],["u"]]],[11,"try_from","","",90,[[["u"]],["result"]]],[11,"borrow","","",90,[[["self"]],["t"]]],[11,"try_into","","",90,[[["self"]],["result"]]],[11,"borrow_mut","","",90,[[["self"]],["t"]]],[11,"get_type_id","","",90,[[["self"]],["typeid"]]],[11,"not_found","","",90,[[["str"],["str"]],["e"]]],[11,"from","","",91,[[["t"]],["t"]]],[11,"into","","",91,[[["self"]],["u"]]],[11,"try_from","","",91,[[["u"]],["result"]]],[11,"borrow","","",91,[[["self"]],["t"]]],[11,"try_into","","",91,[[["self"]],["result"]]],[11,"borrow_mut","","",91,[[["self"]],["t"]]],[11,"get_type_id","","",91,[[["self"]],["typeid"]]],[11,"not_found","","",91,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::sorted_map","",92,[[["self"]],["t"]]],[11,"clone_into","","",92,N],[11,"from","","",92,[[["t"]],["t"]]],[11,"into_iter","","",92,[[["self"]],["i"]]],[11,"into","","",92,[[["self"]],["u"]]],[11,"try_from","","",92,[[["u"]],["result"]]],[11,"borrow","","",92,[[["self"]],["t"]]],[11,"try_into","","",92,[[["self"]],["result"]]],[11,"borrow_mut","","",92,[[["self"]],["t"]]],[11,"get_type_id","","",92,[[["self"]],["typeid"]]],[11,"encode","","",92,[[["self"],["e"]],["result"]]],[11,"decode","","",92,[[["d"]],["result"]]],[11,"not_found","","",92,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::stable_hasher","",93,[[["t"]],["t"]]],[11,"into","","",93,[[["self"]],["u"]]],[11,"try_from","","",93,[[["u"]],["result"]]],[11,"borrow","","",93,[[["self"]],["t"]]],[11,"try_into","","",93,[[["self"]],["result"]]],[11,"borrow_mut","","",93,[[["self"]],["t"]]],[11,"get_type_id","","",93,[[["self"]],["typeid"]]],[11,"not_found","","",93,[[["str"],["str"]],["e"]]],[11,"from","","",94,[[["t"]],["t"]]],[11,"into","","",94,[[["self"]],["u"]]],[11,"try_from","","",94,[[["u"]],["result"]]],[11,"borrow","","",94,[[["self"]],["t"]]],[11,"try_into","","",94,[[["self"]],["result"]]],[11,"borrow_mut","","",94,[[["self"]],["t"]]],[11,"get_type_id","","",94,[[["self"]],["typeid"]]],[11,"not_found","","",94,[[["str"],["str"]],["e"]]],[11,"hash_stable","rustc_data_structures::sync","",99,[[["self"],["ctx"],["stablehasher"]]]],[11,"new","","Constructs a new `Rc<T>`.",99,[[["t"]],["rc"]]],[11,"try_unwrap","","Returns the contained value, if the `Rc` has exactly one strong reference.",99,[[["rc"]],["result",["rc"]]]],[11,"into_raw","","Consumes the `Rc`, returning the wrapped pointer.",99,N],[11,"from_raw","","Constructs an `Rc` from a raw pointer.",99,N],[11,"downgrade","","Creates a new [`Weak`][weak] pointer to this value.",99,[[["rc"]],["weak"]]],[11,"weak_count","","Gets the number of [`Weak`][weak] pointers to this value.",99,[[["rc"]],["usize"]]],[11,"strong_count","","Gets the number of strong (`Rc`) pointers to this value.",99,[[["rc"]],["usize"]]],[11,"get_mut","","Returns a mutable reference to the inner value, if there are no other `Rc` or [`Weak`][weak] pointers to the same value.",99,[[["rc"]],["option"]]],[11,"ptr_eq","","Returns true if the two `Rc`s point to the same value (not just values that compare as equal).",99,[[["rc"],["rc"]],["bool"]]],[11,"make_mut","","Makes a mutable reference into the given `Rc`.",99,[[["rc"]],["t"]]],[11,"downcast","","Attempt to downcast the `Rc<Any>` to a concrete type.",99,[[["self"]],["result",["rc","rc"]]]],[11,"to_owned","","",99,[[["self"]],["t"]]],[11,"clone_into","","",99,N],[11,"from","","",99,[[["t"]],["t"]]],[11,"to_string","","",99,[[["self"]],["string"]]],[11,"into","","",99,[[["self"]],["u"]]],[11,"try_from","","",99,[[["u"]],["result"]]],[11,"borrow","","",99,[[["self"]],["t"]]],[11,"try_into","","",99,[[["self"]],["result"]]],[11,"borrow_mut","","",99,[[["self"]],["t"]]],[11,"get_type_id","","",99,[[["self"]],["typeid"]]],[11,"encode","","",99,[[["self"],["e"]],["result"]]],[11,"decode","","",99,[[["d"]],["result"]]],[11,"not_found","","",99,[[["str"],["str"]],["e"]]],[11,"new","","Constructs a new `Weak<T>`, without allocating any memory. Calling [`upgrade`][Weak::upgrade] on the return value always gives [`None`].",100,[[],["weak"]]],[11,"upgrade","","Attempts to upgrade the `Weak` pointer to an [`Rc`], extending the lifetime of the value if successful.",100,[[["self"]],["option",["rc"]]]],[11,"to_owned","","",100,[[["self"]],["t"]]],[11,"clone_into","","",100,N],[11,"from","","",100,[[["t"]],["t"]]],[11,"into","","",100,[[["self"]],["u"]]],[11,"try_from","","",100,[[["u"]],["result"]]],[11,"borrow","","",100,[[["self"]],["t"]]],[11,"try_into","","",100,[[["self"]],["result"]]],[11,"borrow_mut","","",100,[[["self"]],["t"]]],[11,"get_type_id","","",100,[[["self"]],["typeid"]]],[11,"not_found","","",100,[[["str"],["str"]],["e"]]],[11,"clone","","Copies a `Ref`.",101,[[["ref"]],["ref"]]],[11,"map","","Make a new `Ref` for a component of the borrowed data.",101,[[["ref"],["f"]],["ref"]]],[11,"map_split","","Split a `Ref` into multiple `Ref`s for different components of the borrowed data.",101,N],[11,"from","","",101,[[["t"]],["t"]]],[11,"to_string","","",101,[[["self"]],["string"]]],[11,"into","","",101,[[["self"]],["u"]]],[11,"try_from","","",101,[[["u"]],["result"]]],[11,"borrow","","",101,[[["self"]],["t"]]],[11,"try_into","","",101,[[["self"]],["result"]]],[11,"borrow_mut","","",101,[[["self"]],["t"]]],[11,"get_type_id","","",101,[[["self"]],["typeid"]]],[11,"not_found","","",101,[[["str"],["str"]],["e"]]],[11,"map","","Make a new `RefMut` for a component of the borrowed data, e.g. an enum variant.",102,[[["refmut"],["f"]],["refmut"]]],[11,"map_split","","Split a `RefMut` into multiple `RefMut`s for different components of the borrowed data.",102,N],[11,"from","","",102,[[["t"]],["t"]]],[11,"to_string","","",102,[[["self"]],["string"]]],[11,"into","","",102,[[["self"]],["u"]]],[11,"try_from","","",102,[[["u"]],["result"]]],[11,"borrow","","",102,[[["self"]],["t"]]],[11,"try_into","","",102,[[["self"]],["result"]]],[11,"borrow_mut","","",102,[[["self"]],["t"]]],[11,"get_type_id","","",102,[[["self"]],["typeid"]]],[11,"not_found","","",102,[[["str"],["str"]],["e"]]],[11,"from","","",111,[[["t"]],["t"]]],[11,"into","","",111,[[["self"]],["u"]]],[11,"try_from","","",111,[[["u"]],["result"]]],[11,"borrow","","",111,[[["self"]],["t"]]],[11,"try_into","","",111,[[["self"]],["result"]]],[11,"borrow_mut","","",111,[[["self"]],["t"]]],[11,"get_type_id","","",111,[[["self"]],["typeid"]]],[11,"not_found","","",111,[[["str"],["str"]],["e"]]],[11,"from","","",103,[[["t"]],["t"]]],[11,"into","","",103,[[["self"]],["u"]]],[11,"try_from","","",103,[[["u"]],["result"]]],[11,"borrow","","",103,[[["self"]],["t"]]],[11,"try_into","","",103,[[["self"]],["result"]]],[11,"borrow_mut","","",103,[[["self"]],["t"]]],[11,"get_type_id","","",103,[[["self"]],["typeid"]]],[11,"not_found","","",103,[[["str"],["str"]],["e"]]],[11,"to_owned","","",104,[[["self"]],["t"]]],[11,"clone_into","","",104,N],[11,"from","","",104,[[["t"]],["t"]]],[11,"into","","",104,[[["self"]],["u"]]],[11,"try_from","","",104,[[["u"]],["result"]]],[11,"borrow","","",104,[[["self"]],["t"]]],[11,"try_into","","",104,[[["self"]],["result"]]],[11,"borrow_mut","","",104,[[["self"]],["t"]]],[11,"get_type_id","","",104,[[["self"]],["typeid"]]],[11,"not_found","","",104,[[["str"],["str"]],["e"]]],[11,"from","","",105,[[["t"]],["t"]]],[11,"into","","",105,[[["self"]],["u"]]],[11,"try_from","","",105,[[["u"]],["result"]]],[11,"borrow","","",105,[[["self"]],["t"]]],[11,"try_into","","",105,[[["self"]],["result"]]],[11,"borrow_mut","","",105,[[["self"]],["t"]]],[11,"get_type_id","","",105,[[["self"]],["typeid"]]],[11,"not_found","","",105,[[["str"],["str"]],["e"]]],[11,"from","","",106,[[["t"]],["t"]]],[11,"into","","",106,[[["self"]],["u"]]],[11,"try_from","","",106,[[["u"]],["result"]]],[11,"borrow","","",106,[[["self"]],["t"]]],[11,"try_into","","",106,[[["self"]],["result"]]],[11,"borrow_mut","","",106,[[["self"]],["t"]]],[11,"get_type_id","","",106,[[["self"]],["typeid"]]],[11,"not_found","","",106,[[["str"],["str"]],["e"]]],[11,"to_owned","","",107,[[["self"]],["t"]]],[11,"clone_into","","",107,N],[11,"from","","",107,[[["t"]],["t"]]],[11,"into","","",107,[[["self"]],["u"]]],[11,"try_from","","",107,[[["u"]],["result"]]],[11,"borrow","","",107,[[["self"]],["t"]]],[11,"try_into","","",107,[[["self"]],["result"]]],[11,"borrow_mut","","",107,[[["self"]],["t"]]],[11,"get_type_id","","",107,[[["self"]],["typeid"]]],[11,"not_found","","",107,[[["str"],["str"]],["e"]]],[11,"to_owned","","",108,[[["self"]],["t"]]],[11,"clone_into","","",108,N],[11,"from","","",108,[[["t"]],["t"]]],[11,"into","","",108,[[["self"]],["u"]]],[11,"try_from","","",108,[[["u"]],["result"]]],[11,"borrow","","",108,[[["self"]],["t"]]],[11,"try_into","","",108,[[["self"]],["result"]]],[11,"borrow_mut","","",108,[[["self"]],["t"]]],[11,"get_type_id","","",108,[[["self"]],["typeid"]]],[11,"not_found","","",108,[[["str"],["str"]],["e"]]],[11,"to_owned","","",109,[[["self"]],["t"]]],[11,"clone_into","","",109,N],[11,"from","","",109,[[["t"]],["t"]]],[11,"into","","",109,[[["self"]],["u"]]],[11,"try_from","","",109,[[["u"]],["result"]]],[11,"borrow","","",109,[[["self"]],["t"]]],[11,"try_into","","",109,[[["self"]],["result"]]],[11,"borrow_mut","","",109,[[["self"]],["t"]]],[11,"get_type_id","","",109,[[["self"]],["typeid"]]],[11,"not_found","","",109,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::tiny_list","",112,[[["self"]],["t"]]],[11,"clone_into","","",112,N],[11,"from","","",112,[[["t"]],["t"]]],[11,"into","","",112,[[["self"]],["u"]]],[11,"try_from","","",112,[[["u"]],["result"]]],[11,"borrow","","",112,[[["self"]],["t"]]],[11,"try_into","","",112,[[["self"]],["result"]]],[11,"borrow_mut","","",112,[[["self"]],["t"]]],[11,"get_type_id","","",112,[[["self"]],["typeid"]]],[11,"not_found","","",112,[[["str"],["str"]],["e"]]],[11,"to_owned","","",113,[[["self"]],["t"]]],[11,"clone_into","","",113,N],[11,"from","","",113,[[["t"]],["t"]]],[11,"into","","",113,[[["self"]],["u"]]],[11,"try_from","","",113,[[["u"]],["result"]]],[11,"borrow","","",113,[[["self"]],["t"]]],[11,"try_into","","",113,[[["self"]],["result"]]],[11,"borrow_mut","","",113,[[["self"]],["t"]]],[11,"get_type_id","","",113,[[["self"]],["typeid"]]],[11,"not_found","","",113,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::thin_vec","",114,[[["self"]],["t"]]],[11,"clone_into","","",114,N],[11,"from","","",114,[[["t"]],["t"]]],[11,"into","","",114,[[["self"]],["u"]]],[11,"try_from","","",114,[[["u"]],["result"]]],[11,"borrow","","",114,[[["self"]],["t"]]],[11,"try_into","","",114,[[["self"]],["result"]]],[11,"borrow_mut","","",114,[[["self"]],["t"]]],[11,"get_type_id","","",114,[[["self"]],["typeid"]]],[11,"encode","","",114,[[["self"],["e"]],["result"]]],[11,"decode","","",114,[[["d"]],["result"]]],[11,"not_found","","",114,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::transitive_relation","",115,[[["self"]],["t"]]],[11,"clone_into","","",115,N],[11,"from","","",115,[[["t"]],["t"]]],[11,"into","","",115,[[["self"]],["u"]]],[11,"try_from","","",115,[[["u"]],["result"]]],[11,"borrow","","",115,[[["self"]],["t"]]],[11,"try_into","","",115,[[["self"]],["result"]]],[11,"borrow_mut","","",115,[[["self"]],["t"]]],[11,"get_type_id","","",115,[[["self"]],["typeid"]]],[11,"encode","","",115,[[["self"],["e"]],["result"]]],[11,"decode","","",115,[[["d"]],["result"]]],[11,"not_found","","",115,[[["str"],["str"]],["e"]]],[11,"to_owned","","",116,[[["self"]],["t"]]],[11,"clone_into","","",116,N],[11,"from","","",116,[[["t"]],["t"]]],[11,"into","","",116,[[["self"]],["u"]]],[11,"try_from","","",116,[[["u"]],["result"]]],[11,"borrow","","",116,[[["self"]],["t"]]],[11,"try_into","","",116,[[["self"]],["result"]]],[11,"borrow_mut","","",116,[[["self"]],["t"]]],[11,"get_type_id","","",116,[[["self"]],["typeid"]]],[11,"encode","","",116,[[["self"],["e"]],["result"]]],[11,"decode","","",116,[[["d"]],["result"]]],[11,"not_found","","",116,[[["str"],["str"]],["e"]]],[11,"to_owned","","",117,[[["self"]],["t"]]],[11,"clone_into","","",117,N],[11,"from","","",117,[[["t"]],["t"]]],[11,"into","","",117,[[["self"]],["u"]]],[11,"try_from","","",117,[[["u"]],["result"]]],[11,"borrow","","",117,[[["self"]],["t"]]],[11,"try_into","","",117,[[["self"]],["result"]]],[11,"borrow_mut","","",117,[[["self"]],["t"]]],[11,"get_type_id","","",117,[[["self"]],["typeid"]]],[11,"encode","","",117,[[["self"],["e"]],["result"]]],[11,"decode","","",117,[[["d"]],["result"]]],[11,"not_found","","",117,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::vec_linked_list","",119,[[["t"]],["t"]]],[11,"into_iter","","",119,[[["self"]],["i"]]],[11,"into","","",119,[[["self"]],["u"]]],[11,"try_from","","",119,[[["u"]],["result"]]],[11,"borrow","","",119,[[["self"]],["t"]]],[11,"try_into","","",119,[[["self"]],["result"]]],[11,"borrow_mut","","",119,[[["self"]],["t"]]],[11,"get_type_id","","",119,[[["self"]],["typeid"]]],[11,"not_found","","",119,[[["str"],["str"]],["e"]]],[11,"from","rustc_data_structures::work_queue","",122,[[["t"]],["t"]]],[11,"into","","",122,[[["self"]],["u"]]],[11,"try_from","","",122,[[["u"]],["result"]]],[11,"borrow","","",122,[[["self"]],["t"]]],[11,"try_into","","",122,[[["self"]],["result"]]],[11,"borrow_mut","","",122,[[["self"]],["t"]]],[11,"get_type_id","","",122,[[["self"]],["typeid"]]],[11,"not_found","","",122,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_data_structures::fingerprint","",123,[[["self"]],["t"]]],[11,"clone_into","","",123,N],[11,"from","","",123,[[["t"]],["t"]]],[11,"to_string","","",123,[[["self"]],["string"]]],[11,"into","","",123,[[["self"]],["u"]]],[11,"try_from","","",123,[[["u"]],["result"]]],[11,"borrow","","",123,[[["self"]],["t"]]],[11,"try_into","","",123,[[["self"]],["result"]]],[11,"borrow_mut","","",123,[[["self"]],["t"]]],[11,"get_type_id","","",123,[[["self"]],["typeid"]]],[11,"encode","","",123,[[["self"],["e"]],["result"]]],[11,"decode","","",123,[[["d"]],["result"]]],[11,"not_found","","",123,[[["str"],["str"]],["e"]]]],"paths":[[8,"ToHex"],[4,"UndoLog"],[3,"SnapshotVec"],[3,"Snapshot"],[8,"SnapshotVecDelegate"],[8,"UnifyKey"],[8,"UnifyValue"],[3,"NoError"],[3,"VarValue"],[3,"UnificationTable"],[3,"Snapshot"],[8,"UnificationStore"],[3,"InPlace"],[3,"OnDrop"],[3,"Svh"],[3,"ArrayVec"],[3,"Iter"],[3,"Drain"],[8,"Array"],[3,"BitArray"],[3,"BitIter"],[3,"BitVector"],[3,"BitMatrix"],[3,"SparseBitMatrix"],[8,"BitwiseOperator"],[3,"Intersect"],[3,"Union"],[3,"Subtract"],[3,"Lock"],[3,"flock"],[3,"FxHasher"],[3,"Dominators"],[3,"Iter"],[3,"DominatorTree"],[3,"DominatorTreeNode"],[3,"Graph"],[3,"Node"],[3,"Edge"],[3,"NodeIndex"],[3,"EdgeIndex"],[3,"Direction"],[3,"AdjacentEdges"],[3,"DepthFirstTraversal"],[3,"Sccs"],[3,"SccData"],[3,"SccsConstruction"],[4,"NodeState"],[4,"WalkReturn"],[8,"DirectedGraph"],[8,"WithNumNodes"],[8,"WithSuccessors"],[8,"GraphSuccessors"],[8,"WithPredecessors"],[8,"GraphPredecessors"],[8,"WithStartNode"],[3,"IdxSet"],[3,"SparseIdxSet"],[4,"HybridIdxSet"],[4,"HybridIter"],[8,"UnionIntoIdxSet"],[8,"SubtractFromIdxSet"],[3,"IndexVec"],[3,"IntoIdx"],[8,"Idx"],[3,"ObligationForest"],[3,"Node"],[3,"Outcome"],[3,"Error"],[3,"GetObligation"],[4,"ProcessResult"],[4,"NodeState"],[3,"NodeIndex"],[8,"ForestObligation"],[8,"ObligationProcessor"],[3,"OwningRef"],[3,"OwningRefMut"],[3,"OwningHandle"],[8,"IntoErased"],[8,"IntoErasedSend"],[8,"IntoErasedSendSync"],[8,"ToHandle"],[8,"ToHandleMut"],[8,"Erased"],[3,"PtrKey"],[3,"SipHasher128"],[3,"State"],[3,"Sip24Rounds"],[3,"SmallCStr"],[8,"ExpectOne"],[3,"SnapshotMap"],[3,"Snapshot"],[4,"UndoLog"],[3,"SortedMap"],[3,"StableHasher"],[3,"StableVec"],[8,"StableHasherResult"],[8,"HashStable"],[8,"ToStableHashKey"],[8,"ParallelIterator"],[3,"Lrc"],[3,"Weak"],[3,"MappedReadGuard"],[3,"MappedLockGuard"],[3,"WorkerLocal"],[3,"MTLock"],[3,"LockCell"],[3,"Once"],[3,"Lock"],[3,"RwLock"],[3,"OneThread"],[8,"HashMapExt"],[3,"SerialScope"],[3,"TinyList"],[3,"Element"],[3,"ThinVec"],[3,"TransitiveRelation"],[3,"Index"],[3,"Edge"],[8,"TupleSlice"],[3,"VecLinkedListIterator"],[8,"Links"],[8,"LinkElem"],[3,"WorkQueue"],[3,"Fingerprint"]]};
searchIndex["rustc_driver"]={"doc":"The Rust compiler.","items":[[3,"RustcDefaultCalls","rustc_driver","CompilerCalls instance for a regular rustc build.",N,N],[3,"CompilationFailure","","",N,N],[4,"Compilation","","",N,N],[13,"Stop","","",0,N],[13,"Continue","","",0,N],[5,"abort_on_err","","",N,[[["result",["compileincomplete"]],["session"]],["t"]]],[5,"run","","",N,[[["f"]],["isize"]]],[5,"load_backend_from_dylib","","",N,N],[5,"get_codegen_backend","","",N,[[["session"]],["box",["codegenbackend"]]]],[5,"get_codegen_sysroot","","",N,N],[5,"run_compiler","","",N,N],[5,"run_compiler_with_pool","","",N,N],[5,"set_sigpipe_handler","","",N,[[]]],[5,"make_output","","",N,N],[5,"make_input","","",N,N],[5,"parse_pretty","","",N,[[["session"],["matches"]],["option"]]],[5,"stdout_isatty","","",N,[[],["bool"]]],[5,"handle_explain","","",N,[[["str"],["registry"],["erroroutputtype"]]]],[5,"show_content_with_pager","","",N,[[["string"]]]],[5,"enable_save_analysis","","",N,[[["compilecontroller"]]]],[5,"release_str","","Returns a version string such as \"0.12.0-dev\".",N,[[],["option",["str"]]]],[5,"commit_hash_str","","Returns the full SHA1 hash of HEAD of the Git repo from which rustc was built.",N,[[],["option",["str"]]]],[5,"commit_date_str","","Returns the \"commit date\" of HEAD of the Git repo from which rustc was built as a static string.",N,[[],["option",["str"]]]],[5,"version","","Prints version information",N,[[["str"],["matches"]]]],[5,"usage","","",N,[[["bool"],["bool"]]]],[5,"print_wall_help","","",N,[[]]],[5,"describe_lints","","",N,[[["session"],["lintstore"],["bool"]]]],[5,"describe_debug_flags","","",N,[[]]],[5,"describe_codegen_flags","","",N,[[]]],[5,"print_flag_list","","",N,N],[5,"handle_options","","Process command line options. Emits messages as appropriate. If compilation should continue, returns a getopts::Matches object parsed from args, otherwise returns None.",N,N],[5,"parse_crate_attrs","","",N,[[["session"],["input"]],["presult",["vec"]]]],[5,"in_named_rustc_thread","","Runs `f` in a suitable thread for running `rustc`; returns a `Result` with either the return value of `f` or -- if a panic occurs -- the panic value.",N,[[["string"],["f"]],["result",["box"]]]],[5,"in_rustc_thread","","Runs `f` in a suitable thread for running `rustc`; returns a `Result` with either the return value of `f` or -- if a panic occurs -- the panic value.",N,[[["f"]],["result",["box"]]]],[5,"extra_compiler_flags","","Get a list of extra command-line flags provided by the user, as strings.",N,[[],["option"]]],[5,"monitor","","Run a procedure which will detect panics in the compiler and print nicer error messages rather than just failing the test.",N,[[["f"]],["result",["compilationfailure"]]]],[5,"diagnostics_registry","","",N,[[],["registry"]]],[5,"init_rustc_env_logger","","This allows tools to enable rust logging without having to magically match rustc's log crate version",N,[[]]],[5,"main","","",N,[[]]],[0,"profile","","",N,N],[3,"StackFrame","rustc_driver::profile","",N,N],[12,"parse_st","","",1,N],[12,"traces","","",1,N],[4,"ParseState","","",N,N],[13,"Clear","","",2,N],[13,"HaveQuery","","",2,N],[13,"HaveTimeBegin","","",2,N],[13,"HaveTaskBegin","","",2,N],[5,"begin","","begin a profile thread, if not already running",N,[[["session"]]]],[5,"dump","","dump files with profiling information to the given base path, and wait for this dump to complete.",N,[[["session"],["string"]]]],[5,"total_duration","","",N,N],[5,"profile_queries_thread","","",N,[[["receiver",["profilequeriesmsg"]]]]],[0,"trace","","",N,N],[3,"Query","rustc_driver::profile::trace","",N,N],[12,"span","","",3,N],[12,"msg","","",3,N],[3,"Rec","","Recursive trace structure",N,N],[12,"effect","","",4,N],[12,"start","","",4,N],[12,"dur_self","","",4,N],[12,"dur_total","","",4,N],[12,"extent","","",4,N],[3,"QueryMetric","","",N,N],[12,"count","","",5,N],[12,"dur_self","","",5,N],[12,"dur_total","","",5,N],[4,"Effect","","",N,N],[13,"QueryBegin","","",6,N],[13,"TimeBegin","","",6,N],[13,"TaskBegin","","",6,N],[4,"CacheCase","","",N,N],[13,"Hit","","",7,N],[13,"Miss","","",7,N],[5,"cons_of_query_msg","","",N,[[["query"]],["string"]]],[5,"cons_of_key","","",N,[[["depnode"]],["string"]]],[5,"html_of_effect","","",N,N],[5,"html_of_duration","","",N,N],[5,"html_of_fraction","","",N,N],[5,"total_duration","","",N,N],[5,"duration_div","","",N,[[["duration"],["duration"]],["f64"]]],[5,"write_traces_rec","","",N,N],[5,"compute_counts_rec","","",N,N],[5,"write_counts","","",N,[[["file"],["fxhashmap"]]]],[5,"write_traces","","",N,N],[5,"write_style","","",N,[[["file"]]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",3,[[["self"]],["query"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"eq","","",3,[[["self"],["query"]],["bool"]]],[11,"ne","","",3,[[["self"],["query"]],["bool"]]],[11,"clone","rustc_driver::profile","",2,[[["self"]],["parsestate"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"eq","","",2,[[["self"],["parsestate"]],["bool"]]],[11,"ne","","",2,[[["self"],["parsestate"]],["bool"]]],[0,"driver","rustc_driver","",N,N],[3,"CompileController","rustc_driver::driver","CompileController is used to customize compilation, it allows compilation to be stopped and/or to call arbitrary code at various points in compilation. It also allows for various flags to be set to influence what information gets collected during compilation.",N,N],[12,"after_parse","","",8,N],[12,"after_expand","","",8,N],[12,"after_hir_lowering","","",8,N],[12,"after_analysis","","",8,N],[12,"compilation_done","","",8,N],[12,"make_glob_map","","",8,N],[12,"keep_ast","","",8,N],[12,"continue_parse_after_error","","",8,N],[12,"provide","","Allows overriding default rustc query providers, after `default_provide` has installed them.",8,N],[12,"provide_extern","","Same as `provide`, but only for non-local crates, applied after `default_provide_extern`.",8,N],[3,"PhaseController","","",N,N],[12,"stop","","",9,N],[12,"run_callback_on_error","","",9,N],[12,"callback","","",9,N],[3,"CompileState","","State that is passed to a callback. What state is available depends on when during compilation the callback is made. See the various constructor methods (`state_*`) in the impl to see which data is provided for any given entry point.",N,N],[12,"input","","",10,N],[12,"session","","",10,N],[12,"krate","","",10,N],[12,"registry","","",10,N],[12,"cstore","","",10,N],[12,"crate_name","","",10,N],[12,"output_filenames","","",10,N],[12,"out_dir","","",10,N],[12,"out_file","","",10,N],[12,"arenas","","",10,N],[12,"expanded_crate","","",10,N],[12,"hir_crate","","",10,N],[12,"hir_map","","",10,N],[12,"resolutions","","",10,N],[12,"analysis","","",10,N],[12,"tcx","","",10,N],[3,"ExpansionResult","","",N,N],[12,"expanded_crate","","",11,N],[12,"defs","","",11,N],[12,"analysis","","",11,N],[12,"resolutions","","",11,N],[12,"hir_forest","","",11,N],[3,"InnerExpansionResult","","",N,N],[12,"expanded_crate","","",12,N],[12,"resolver","","",12,N],[12,"hir_forest","","",12,N],[5,"spawn_thread_pool","","",N,[[["options"],["f"]],["r"]]],[5,"compile_input","","",N,[[["box",["codegenbackend"]],["session"],["cstore"],["option"],["input"],["option"],["option"],["option",["vec"]],["compilecontroller"]],["compileresult"]]],[5,"source_name","","",N,[[["input"]],["filename"]]],[5,"phase_1_parse_input","","",N,[[["compilecontroller"],["session"],["input"]],["presult",["crate"]]]],[5,"count_nodes","","",N,[[["crate"]],["usize"]]],[5,"phase_2_configure_and_expand","","Run the \"early phases\" of the compiler: initial `cfg` processing, loading compiler plugins (including those from `addl_plugins`), syntax expansion, secondary `cfg` expansion, synthesis of a test harness if one is to be provided, injection of a dependency on the standard library and prelude, and name resolution.",N,[[["session"],["cstore"],["crate"],["option",["registry"]],["str"],["option",["vec"]],["makeglobmap"],["f"]],["result",["expansionresult","compileincomplete"]]]],[5,"phase_2_configure_and_expand_inner","","Same as phase_2_configure_and_expand, but doesn't let you keep the resolver around",N,[[["session"],["cstore"],["crate"],["option",["registry"]],["str"],["option",["vec"]],["makeglobmap"],["resolverarenas"],["crateloader"],["f"]],["result",["innerexpansionresult","compileincomplete"]]]],[5,"default_provide","","",N,[[["providers"]]]],[5,"default_provide_extern","","",N,[[["providers"]]]],[5,"phase_3_run_analysis_passes","","Run the resolution, typechecking, region checking and other miscellaneous analysis passes on the crate. Return various structures carrying the results of the analysis.",N,[[["codegenbackend"],["compilecontroller"],["session"],["cstore"],["map"],["crateanalysis"],["resolutions"],["allarenas"],["str"],["outputfilenames"],["f"]],["result",["compileincomplete"]]]],[5,"phase_4_codegen","","Run the codegen backend, after which the AST and analysis can be discarded.",N,[[["codegenbackend"],["tyctxt"],["receiver",["box"]]],["box",["any"]]]],[5,"escape_dep_filename","","",N,[[["filename"]],["string"]]],[5,"generated_output_paths","","",N,[[["session"],["outputfilenames"],["bool"],["str"]],["vec",["pathbuf"]]]],[5,"check_output","","",N,N],[5,"output_contains_path","","",N,N],[5,"output_conflicts_with_dir","","",N,N],[5,"write_out_deps","","",N,N],[5,"collect_crate_types","","",N,N],[5,"compute_crate_disambiguator","","",N,[[["session"]],["cratedisambiguator"]]],[5,"build_output_filenames","","",N,N],[11,"basic","","",8,[[],["compilecontroller"]]],[11,"early_callback","","",8,[[["self"],["matches"],["options"],["crateconfig"],["registry"],["erroroutputtype"]],["compilation"]]],[11,"no_input","","",8,[[["self"],["matches"],["options"],["crateconfig"],["option"],["option"],["registry"]],["option"]]],[11,"late_callback","","",8,[[["self"],["codegenbackend"],["matches"],["session"],["cstore"],["input"],["option"],["option"]],["compilation"]]],[11,"build_controller","","",8,[[["box"],["session"],["matches"]],["compilecontroller"]]],[11,"basic","","",9,[[],["phasecontroller"]]],[11,"empty","","",10,[[["input"],["session"],["option"]],["self"]]],[11,"state_after_parse","","",10,[[["input"],["session"],["option"],["option"],["crate"],["cstore"]],["self"]]],[11,"state_after_expand","","",10,[[["input"],["session"],["option"],["option"],["cstore"],["crate"],["str"]],["self"]]],[11,"state_after_hir_lowering","","",10,[[["input"],["session"],["option"],["option"],["allarenas"],["cstore"],["map"],["crateanalysis"],["resolutions"],["crate"],["crate"],["outputfilenames"],["str"]],["self"]]],[11,"state_after_analysis","","",10,[[["input"],["session"],["option"],["option"],["option",["crate"]],["crate"],["crateanalysis"],["tyctxt"],["str"]],["self"]]],[11,"state_when_compilation_done","","",10,[[["input"],["session"],["option"],["option"]],["self"]]],[0,"pretty","rustc_driver","The various pretty print routines.",N,N],[3,"NoAnn","rustc_driver::pretty","",N,N],[12,"sess","","",13,N],[12,"hir_map","","",13,N],[3,"IdentifiedAnnotation","","",N,N],[12,"sess","","",14,N],[12,"hir_map","","",14,N],[3,"HygieneAnnotation","","",N,N],[12,"sess","","",15,N],[3,"TypedAnnotation","","",N,N],[12,"tcx","","",16,N],[12,"tables","","",16,N],[3,"ReplaceBodyWithLoop","","",N,N],[12,"within_static_or_const","","",17,N],[12,"nested_blocks","","",17,N],[12,"sess","","",17,N],[4,"PpSourceMode","","",N,N],[13,"PpmNormal","","",18,N],[13,"PpmEveryBodyLoops","","",18,N],[13,"PpmExpanded","","",18,N],[13,"PpmIdentified","","",18,N],[13,"PpmExpandedIdentified","","",18,N],[13,"PpmExpandedHygiene","","",18,N],[13,"PpmTyped","","",18,N],[4,"PpFlowGraphMode","","",N,N],[13,"Default","","",19,N],[13,"UnlabelledEdges","","Drops the labels from the edges in the flowgraph output. This is mostly for use in the -Z unpretty flowgraph run-make tests, since the labels are largely uninteresting in those cases and have become a pain to maintain.",19,N],[4,"PpMode","","",N,N],[13,"PpmSource","","",20,N],[13,"PpmHir","","",20,N],[13,"PpmHirTree","","",20,N],[13,"PpmFlowGraph","","",20,N],[13,"PpmMir","","",20,N],[13,"PpmMirCFG","","",20,N],[4,"UserIdentifiedItem","","",N,N],[13,"ItemViaNode","","",21,N],[13,"ItemViaPath","","",21,N],[4,"NodesMatchingUII","","",N,N],[13,"NodesMatchingDirect","","",22,N],[13,"NodesMatchingSuffix","","",22,N],[5,"parse_pretty","","",N,N],[5,"gather_flowgraph_variants","","",N,[[["session"]],["vec",["variant"]]]],[5,"print_flowgraph","","",N,[[["vec",["variant"]],["tyctxt"],["code"],["ppflowgraphmode"],["w"]],["result"]]],[5,"fold_crate","","",N,[[["session"],["crate"],["ppmode"]],["crate"]]],[5,"get_source","","",N,N],[5,"write_output","","",N,[[["vec",["u8"]],["option",["path"]]]]],[5,"print_after_parsing","","",N,[[["session"],["input"],["crate"],["ppmode"],["option",["path"]]]]],[5,"print_after_hir_lowering","","",N,[[["session"],["cstore"],["map"],["crateanalysis"],["resolutions"],["input"],["crate"],["str"],["ppmode"],["allarenas"],["outputfilenames"],["option",["useridentifieditem"]],["option",["path"]]]]],[5,"print_with_analysis","","",N,[[["session"],["cstore"],["map"],["crateanalysis"],["resolutions"],["str"],["allarenas"],["outputfilenames"],["ppmode"],["option",["useridentifieditem"]],["option",["path"]]]]],[8,"PrinterSupport","","",N,N],[10,"sess","","Provides a uniform interface for re-extracting a reference to a `Session` from a value that now owns it.",23,[[["self"]],["session"]]],[10,"pp_ann","","Produces the pretty-print annotation object.",23,[[["self"]],["ppann"]]],[8,"HirPrinterSupport","","",N,N],[10,"sess","","Provides a uniform interface for re-extracting a reference to a `Session` from a value that now owns it.",24,[[["self"]],["session"]]],[10,"hir_map","","Provides a uniform interface for re-extracting a reference to an `hir_map::Map` from a value that now owns it.",24,[[["self"]],["option",["map"]]]],[10,"pp_ann","","Produces the pretty-print annotation object.",24,[[["self"]],["ppann"]]],[11,"node_path","","Computes an user-readable representation of a path, if possible.",24,[[["self"],["nodeid"]],["option",["string"]]]],[11,"clone","","",18,[[["self"]],["ppsourcemode"]]],[11,"eq","","",18,[[["self"],["ppsourcemode"]],["bool"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"clone","","",19,[[["self"]],["ppflowgraphmode"]]],[11,"eq","","",19,[[["self"],["ppflowgraphmode"]],["bool"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"clone","","",20,[[["self"]],["ppmode"]]],[11,"eq","","",20,[[["self"],["ppmode"]],["bool"]]],[11,"ne","","",20,[[["self"],["ppmode"]],["bool"]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"needs_ast_map","","",20,[[["self"],["option"]],["bool"]]],[11,"needs_analysis","","",20,[[["self"]],["bool"]]],[11,"call_with_pp_support","","Constructs a `PrinterSupport` object and passes it to `f`.",18,[[["self"],["session"],["option",["map"]],["f"]],["a"]]],[11,"call_with_pp_support_hir","","",18,[[["self"],["session"],["cstore"],["map"],["crateanalysis"],["resolutions"],["allarenas"],["outputfilenames"],["str"],["f"]],["a"]]],[11,"sess","","",13,[[["self"]],["session"]]],[11,"pp_ann","","",13,[[["self"]],["ppann"]]],[11,"sess","","",13,[[["self"]],["session"]]],[11,"hir_map","","",13,[[["self"]],["option",["map"]]]],[11,"pp_ann","","",13,[[["self"]],["ppann"]]],[11,"nested","","",13,[[["self"],["state"],["nested"]],["result"]]],[11,"sess","","",14,[[["self"]],["session"]]],[11,"pp_ann","","",14,[[["self"]],["ppann"]]],[11,"pre","","",14,[[["self"],["state"],["annnode"]],["result"]]],[11,"post","","",14,[[["self"],["state"],["annnode"]],["result"]]],[11,"sess","","",14,[[["self"]],["session"]]],[11,"hir_map","","",14,[[["self"]],["option",["map"]]]],[11,"pp_ann","","",14,[[["self"]],["ppann"]]],[11,"nested","","",14,[[["self"],["state"],["nested"]],["result"]]],[11,"pre","","",14,[[["self"],["state"],["annnode"]],["result"]]],[11,"post","","",14,[[["self"],["state"],["annnode"]],["result"]]],[11,"sess","","",15,[[["self"]],["session"]]],[11,"pp_ann","","",15,[[["self"]],["ppann"]]],[11,"post","","",15,[[["self"],["state"],["annnode"]],["result"]]],[11,"sess","","",16,[[["self"]],["session"]]],[11,"hir_map","","",16,[[["self"]],["option",["map"]]]],[11,"pp_ann","","",16,[[["self"]],["ppann"]]],[11,"node_path","","",16,[[["self"],["nodeid"]],["option",["string"]]]],[11,"nested","","",16,[[["self"],["state"],["nested"]],["result"]]],[11,"pre","","",16,[[["self"],["state"],["annnode"]],["result"]]],[11,"post","","",16,[[["self"],["state"],["annnode"]],["result"]]],[11,"clone","","",21,[[["self"]],["useridentifieditem"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"from_str","","",21,[[["str"]],["result",["useridentifieditem"]]]],[11,"next","","",22,[[["self"]],["option",["nodeid"]]]],[11,"size_hint","","",22,N],[11,"reconstructed_input","","",21,[[["self"]],["string"]]],[11,"all_matching_node_ids","","",21,[[["self"],["map"]],["nodesmatchinguii"]]],[11,"to_one_node_id","","",21,[[["self"],["str"],["session"],["map"]],["nodeid"]]],[11,"new","","",17,[[["session"]],["replacebodywithloop"]]],[11,"run","","",17,[[["self"],["bool"],["f"]],["r"]]],[11,"should_ignore_fn","","",17,[[["fndecl"]],["bool"]]],[11,"fold_item_kind","","",17,[[["self"],["itemkind"]],["itemkind"]]],[11,"fold_trait_item","","",17,[[["self"],["traititem"]],["onevector",["traititem"]]]],[11,"fold_impl_item","","",17,[[["self"],["implitem"]],["onevector",["implitem"]]]],[11,"fold_anon_const","","",17,[[["self"],["anonconst"]],["anonconst"]]],[11,"fold_block","","",17,[[["self"],["p",["block"]]],["p",["block"]]]],[11,"fold_mac","","",17,[[["self"],["mac"]],["mac"]]],[0,"derive_registrar","rustc_driver","",N,N],[3,"Finder","rustc_driver::derive_registrar","",N,N],[12,"registrar","","",25,N],[5,"find","","",N,[[["map"]],["option",["nodeid"]]]],[11,"visit_item","","",25,[[["self"],["item"]]]],[11,"visit_trait_item","","",25,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",25,[[["self"],["implitem"]]]],[0,"target_features","rustc_driver","",N,N],[5,"add_configuration","rustc_driver::target_features","Add `target_feature = \"...\"` cfgs for a variety of platform specific features (SSE, NEON etc.).",N,[[["crateconfig"],["session"],["codegenbackend"]]]],[17,"EXIT_SUCCESS","rustc_driver","Exit status code used for successful compilation and help output.",N,N],[17,"EXIT_FAILURE","","Exit status code used for compilation failures and  invalid flags.",N,N],[17,"BUG_REPORT_URL","","",N,N],[17,"ICE_REPORT_COMPILER_FLAGS","","",N,N],[17,"ICE_REPORT_COMPILER_FLAGS_EXCLUDE","","",N,N],[17,"ICE_REPORT_COMPILER_FLAGS_STRIP_VALUE","","",N,N],[8,"CompilerCalls","","A trait for customising the compilation process. Offers a number of hooks for executing custom code or customising input.",N,N],[11,"early_callback","","Hook for a callback early in the process of handling arguments. This will be called straight after options have been parsed but before anything else (e.g., selecting input and output).",26,[[["self"],["matches"],["options"],["crateconfig"],["registry"],["erroroutputtype"]],["compilation"]]],[11,"late_callback","","Hook for a callback late in the process of handling arguments. This will be called just before actual compilation starts (and before build_controller is called), after all arguments etc. have been completely handled.",26,[[["self"],["codegenbackend"],["matches"],["session"],["cstore"],["input"],["option"],["option"]],["compilation"]]],[11,"some_input","","Called after we extract the input from the arguments. Gives the implementer an opportunity to change the inputs or to add some custom input handling. The default behaviour is to simply pass through the inputs.",26,N],[11,"no_input","","Called after we extract the input from the arguments if there is no valid input. Gives the implementer an opportunity to supply alternate input (by returning a Some value) or to add custom behaviour for this error such as emitting error messages. Returning None will cause compilation to stop at this point.",26,[[["self"],["matches"],["options"],["crateconfig"],["option"],["option"],["registry"]],["option"]]],[10,"build_controller","","",26,[[["box"],["session"],["matches"]],["compilecontroller"]]],[11,"clone","","",0,[[["self"]],["compilation"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"eq","","",0,[[["self"],["compilation"]],["bool"]]],[11,"and_then","","",0,[[["self"],["f"]],["compilation"]]],[11,"clone","","",27,[[["self"]],["rustcdefaultcalls"]]],[11,"early_callback","","",27,[[["self"],["matches"],["options"],["crateconfig"],["registry"],["erroroutputtype"]],["compilation"]]],[11,"no_input","","",27,[[["self"],["matches"],["options"],["crateconfig"],["option"],["option"],["registry"]],["option"]]],[11,"late_callback","","",27,[[["self"],["codegenbackend"],["matches"],["session"],["cstore"],["input"],["option"],["option"]],["compilation"]]],[11,"build_controller","","",27,[[["box"],["session"],["matches"]],["compilecontroller"]]],[11,"list_metadata","","",27,[[["session"],["cstore"],["matches"],["input"]],["compilation"]]],[11,"print_crate_info","","",27,[[["codegenbackend"],["session"],["option",["input"]],["option"],["option"]],["compilation"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"to_owned","","",27,[[["self"]],["t"]]],[11,"clone_into","","",27,N],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from_ok","","",27,[[["t"]],["t"]]],[11,"map_same","","",27,[[["self"],["f"]],["t"]]],[11,"from","","",28,[[["t"]],["t"]]],[11,"to_string","","",28,[[["self"]],["string"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from_ok","","",28,[[["t"]],["t"]]],[11,"map_same","","",28,[[["self"],["f"]],["t"]]],[11,"to_owned","","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","rustc_driver::profile","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_driver::profile::trace","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"from","rustc_driver::driver","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]],[11,"from","rustc_driver::pretty","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from_ok","","",13,[[["t"]],["t"]]],[11,"map_same","","",13,[[["self"],["f"]],["t"]]],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from_ok","","",14,[[["t"]],["t"]]],[11,"map_same","","",14,[[["self"],["f"]],["t"]]],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from_ok","","",15,[[["t"]],["t"]]],[11,"map_same","","",15,[[["self"],["f"]],["t"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from_ok","","",16,[[["t"]],["t"]]],[11,"map_same","","",16,[[["self"],["f"]],["t"]]],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from_ok","","",17,[[["t"]],["t"]]],[11,"map_same","","",17,[[["self"],["f"]],["t"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from_ok","","",18,[[["t"]],["t"]]],[11,"map_same","","",18,[[["self"],["f"]],["t"]]],[11,"to_owned","","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"from_ok","","",19,[[["t"]],["t"]]],[11,"map_same","","",19,[[["self"],["f"]],["t"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from_ok","","",20,[[["t"]],["t"]]],[11,"map_same","","",20,[[["self"],["f"]],["t"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from_ok","","",21,[[["t"]],["t"]]],[11,"map_same","","",21,[[["self"],["f"]],["t"]]],[11,"from","","",22,[[["t"]],["t"]]],[11,"into_iter","","",22,[[["self"]],["i"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from_ok","","",22,[[["t"]],["t"]]],[11,"map_same","","",22,[[["self"],["f"]],["t"]]],[11,"from","rustc_driver::derive_registrar","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from_ok","","",25,[[["t"]],["t"]]],[11,"map_same","","",25,[[["self"],["f"]],["t"]]]],"paths":[[4,"Compilation"],[3,"StackFrame"],[4,"ParseState"],[3,"Query"],[3,"Rec"],[3,"QueryMetric"],[4,"Effect"],[4,"CacheCase"],[3,"CompileController"],[3,"PhaseController"],[3,"CompileState"],[3,"ExpansionResult"],[3,"InnerExpansionResult"],[3,"NoAnn"],[3,"IdentifiedAnnotation"],[3,"HygieneAnnotation"],[3,"TypedAnnotation"],[3,"ReplaceBodyWithLoop"],[4,"PpSourceMode"],[4,"PpFlowGraphMode"],[4,"PpMode"],[4,"UserIdentifiedItem"],[4,"NodesMatchingUII"],[8,"PrinterSupport"],[8,"HirPrinterSupport"],[3,"Finder"],[8,"CompilerCalls"],[3,"RustcDefaultCalls"],[3,"CompilationFailure"]]};
searchIndex["rustc_errors"]={"doc":"","items":[[3,"CodeSuggestion","rustc_errors","",N,N],[12,"substitutions","","Each substitute can have multiple variants due to multiple applicable suggestions",0,N],[12,"msg","","",0,N],[12,"show_code_when_inline","","",0,N],[12,"applicability","","Whether or not the suggestion is approximate",0,N],[3,"Substitution","","See the docs on `CodeSuggestion::substitutions`",N,N],[12,"parts","","",1,N],[3,"SubstitutionPart","","",N,N],[12,"span","","",2,N],[12,"snippet","","",2,N],[3,"FatalError","","Used as a return value to signify a fatal error occurred. (It is also used as the argument to panic at the moment, but that will eventually not be true.)",N,N],[3,"FatalErrorMarker","","",N,N],[3,"ExplicitBug","","Signifies that the compiler died with an explicit call to `.bug` or `.span_bug` rather than a failed assertion, etc.",N,N],[3,"Diagnostic","","",N,N],[12,"level","","",3,N],[12,"message","","",3,N],[12,"code","","",3,N],[12,"span","","",3,N],[12,"children","","",3,N],[12,"suggestions","","",3,N],[3,"SubDiagnostic","","For example a note attached to an error.",N,N],[12,"level","","",4,N],[12,"message","","",4,N],[12,"span","","",4,N],[12,"render_span","","",4,N],[3,"DiagnosticStyledString","","",N,N],[12,"0","","",5,N],[3,"DiagnosticBuilder","","Used for emitting structured error messages and other diagnostic information.",N,N],[12,"handler","","",6,N],[12,"diagnostic","","",6,N],[12,"allow_suggestions","","",6,N],[3,"Handler","","A handler deals with errors; certain errors (fatal, bug, unimpl) may cause immediate exit, others log errors for later reporting.",N,N],[12,"flags","","",7,N],[12,"err_count","","",7,N],[12,"emitter","","",7,N],[12,"continue_after_error","","",7,N],[12,"delayed_span_bugs","","",7,N],[12,"taught_diagnostics","","",7,N],[12,"emitted_diagnostic_codes","","Used to suggest rustc --explain ",7,N],[12,"emitted_diagnostics","","",7,N],[3,"HandlerFlags","","",N,N],[12,"can_emit_warnings","","",8,N],[12,"treat_err_as_bug","","",8,N],[12,"report_delayed_bugs","","",8,N],[12,"external_macro_backtrace","","",8,N],[4,"Applicability","","",N,N],[13,"MachineApplicable","","",9,N],[13,"HasPlaceholders","","",9,N],[13,"MaybeIncorrect","","",9,N],[13,"Unspecified","","",9,N],[4,"DiagnosticId","","",N,N],[13,"Error","","",10,N],[13,"Lint","","",10,N],[4,"Level","","",N,N],[13,"Bug","","",11,N],[13,"Fatal","","",11,N],[13,"PhaseFatal","","",11,N],[13,"Error","","",11,N],[13,"Warning","","",11,N],[13,"Note","","",11,N],[13,"Help","","",11,N],[13,"Cancelled","","",11,N],[13,"FailureNote","","",11,N],[5,"default_track_diagnostic","","",N,[[["diagnostic"]]]],[0,"diagnostic","","",N,N],[3,"Diagnostic","rustc_errors::diagnostic","",N,N],[12,"level","","",3,N],[12,"message","","",3,N],[12,"code","","",3,N],[12,"span","","",3,N],[12,"children","","",3,N],[12,"suggestions","","",3,N],[3,"SubDiagnostic","","For example a note attached to an error.",N,N],[12,"level","","",4,N],[12,"message","","",4,N],[12,"span","","",4,N],[12,"render_span","","",4,N],[3,"DiagnosticStyledString","","",N,N],[12,"0","","",5,N],[4,"DiagnosticId","","",N,N],[13,"Error","","",10,N],[13,"Lint","","",10,N],[4,"StringPart","","",N,N],[13,"Normal","","",12,N],[13,"Highlighted","","",12,N],[11,"clone","rustc_errors","",3,[[["self"]],["diagnostic"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"eq","","",3,[[["self"],["diagnostic"]],["bool"]]],[11,"ne","","",3,[[["self"],["diagnostic"]],["bool"]]],[11,"hash","","",3,N],[11,"encode","","",3,[[["self"],["__s"]],["result"]]],[11,"decode","","",3,[[["__d"]],["result",["diagnostic"]]]],[11,"clone","","",10,[[["self"]],["diagnosticid"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"eq","","",10,[[["self"],["diagnosticid"]],["bool"]]],[11,"ne","","",10,[[["self"],["diagnosticid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"hash","","",10,N],[11,"encode","","",10,[[["self"],["__s"]],["result"]]],[11,"decode","","",10,[[["__d"]],["result",["diagnosticid"]]]],[11,"clone","","",4,[[["self"]],["subdiagnostic"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["subdiagnostic"]],["bool"]]],[11,"ne","","",4,[[["self"],["subdiagnostic"]],["bool"]]],[11,"hash","","",4,N],[11,"encode","","",4,[[["self"],["__s"]],["result"]]],[11,"decode","","",4,[[["__d"]],["result",["subdiagnostic"]]]],[11,"eq","","",5,[[["self"],["diagnosticstyledstring"]],["bool"]]],[11,"ne","","",5,[[["self"],["diagnosticstyledstring"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",5,N],[11,"new","","",5,[[],["diagnosticstyledstring"]]],[11,"push_normal","","",5,[[["self"],["s"]]]],[11,"push_highlighted","","",5,[[["self"],["s"]]]],[11,"normal","","",5,[[["s"]],["diagnosticstyledstring"]]],[11,"highlighted","","",5,[[["s"]],["diagnosticstyledstring"]]],[11,"content","","",5,[[["self"]],["string"]]],[11,"eq","rustc_errors::diagnostic","",12,[[["self"],["stringpart"]],["bool"]]],[11,"ne","","",12,[[["self"],["stringpart"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",12,N],[11,"content","","",12,[[["self"]],["string"]]],[11,"new","rustc_errors","",3,[[["level"],["str"]],["self"]]],[11,"new_with_code","","",3,[[["level"],["option",["diagnosticid"]],["str"]],["self"]]],[11,"is_error","","",3,[[["self"]],["bool"]]],[11,"cancel","","Cancel the diagnostic (a structured diagnostic must either be emitted or canceled or it will panic when dropped).",3,[[["self"]]]],[11,"cancelled","","",3,[[["self"]],["bool"]]],[11,"span_label","","Add a span/label to be included in the resulting snippet. This is pushed onto the `MultiSpan` that was created when the diagnostic was first built. If you don't call this function at all, and you just supplied a `Span` to create the diagnostic, then the snippet will just include that `Span`, which is called the primary span.",3,[[["self"],["span"],["t"]],["self"]]],[11,"note_expected_found","","",3,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"]],["self"]]],[11,"note_expected_found_extra","","",3,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"],["display"],["display"]],["self"]]],[11,"note_trait_signature","","",3,[[["self"],["string"],["string"]],["self"]]],[11,"note","","",3,[[["self"],["str"]],["self"]]],[11,"highlighted_note","","",3,[[["self"],["vec"]],["self"]]],[11,"span_note","","",3,[[["self"],["s"],["str"]],["self"]]],[11,"warn","","",3,[[["self"],["str"]],["self"]]],[11,"span_warn","","",3,[[["self"],["s"],["str"]],["self"]]],[11,"help","","",3,[[["self"],["str"]],["self"]]],[11,"span_help","","",3,[[["self"],["s"],["str"]],["self"]]],[11,"span_suggestion_short","","Prints out a message with a suggested edit of the code. If the suggestion is presented inline it will only show the text message and not the text.",3,[[["self"],["span"],["str"],["string"]],["self"]]],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",3,[[["self"],["span"],["str"],["string"]],["self"]]],[11,"multipart_suggestion","","",3,[[["self"],["str"],["vec"]],["self"]]],[11,"span_suggestions","","Prints out a message with multiple suggested edits of the code.",3,[[["self"],["span"],["str"],["vec",["string"]]],["self"]]],[11,"span_suggestion_with_applicability","","This is a suggestion that may contain mistakes or fillers and should be read and understood by a human.",3,[[["self"],["span"],["str"],["string"],["applicability"]],["self"]]],[11,"span_suggestions_with_applicability","","",3,[[["self"],["span"],["str"],["vec",["string"]],["applicability"]],["self"]]],[11,"span_suggestion_short_with_applicability","","",3,[[["self"],["span"],["str"],["string"],["applicability"]],["self"]]],[11,"set_span","","",3,[[["self"],["s"]],["self"]]],[11,"code","","",3,[[["self"],["diagnosticid"]],["self"]]],[11,"get_code","","",3,[[["self"]],["option",["diagnosticid"]]]],[11,"message","","",3,[[["self"]],["string"]]],[11,"styled_message","","",3,[[["self"]],["vec"]]],[11,"copy_details_not_message","","Used by a lint. Copies over all details but the \"main message\".",3,[[["self"],["diagnostic"]]]],[11,"sub","","Convenience function for internal use, clients should use one of the public methods above.",3,[[["self"],["level"],["str"],["multispan"],["option",["multispan"]]]]],[11,"sub_with_highlights","","Convenience function for internal use, clients should use one of the public methods above.",3,[[["self"],["level"],["vec"],["multispan"],["option",["multispan"]]]]],[11,"message","","",4,[[["self"]],["string"]]],[11,"styled_message","","",4,[[["self"]],["vec"]]],[0,"diagnostic_builder","","",N,N],[3,"DiagnosticBuilder","rustc_errors::diagnostic_builder","Used for emitting structured error messages and other diagnostic information.",N,N],[12,"handler","","",6,N],[12,"diagnostic","","",6,N],[12,"allow_suggestions","","",6,N],[11,"clone","rustc_errors","",6,[[["self"]],["diagnosticbuilder"]]],[11,"deref","","",6,[[["self"]],["diagnostic"]]],[11,"deref_mut","","",6,[[["self"]],["diagnostic"]]],[11,"emit","","Emit the diagnostic.",6,[[["self"]]]],[11,"buffer","","Buffers the diagnostic for later emission.",6,[[["self"],["vec"]]]],[11,"sub","","Convenience function for internal use, clients should use one of the span_* methods instead.",6,[[["self"],["level"],["str"],["option"]],["self"]]],[11,"delay_as_bug","","Delay emission of this diagnostic as a bug.",6,[[["self"]]]],[11,"span_label","","Add a span/label to be included in the resulting snippet. This is pushed onto the `MultiSpan` that was created when the diagnostic was first built. If you don't call this function at all, and you just supplied a `Span` to create the diagnostic, then the snippet will just include that `Span`, which is called the primary span.",6,[[["self"],["span"],["t"]],["self"]]],[11,"note_expected_found","","",6,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"]],["self"]]],[11,"note_expected_found_extra","","",6,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"],["display"],["display"]],["self"]]],[11,"note","","",6,[[["self"],["str"]],["self"]]],[11,"span_note","","",6,[[["self"],["s"],["str"]],["self"]]],[11,"warn","","",6,[[["self"],["str"]],["self"]]],[11,"span_warn","","",6,[[["self"],["s"],["str"]],["self"]]],[11,"help","","",6,[[["self"],["str"]],["self"]]],[11,"span_help","","",6,[[["self"],["s"],["str"]],["self"]]],[11,"span_suggestion_short","","",6,[[["self"],["span"],["str"],["string"]],["self"]]],[11,"multipart_suggestion","","",6,[[["self"],["str"],["vec"]],["self"]]],[11,"span_suggestion","","",6,[[["self"],["span"],["str"],["string"]],["self"]]],[11,"span_suggestions","","",6,[[["self"],["span"],["str"],["vec",["string"]]],["self"]]],[11,"span_suggestion_with_applicability","","",6,[[["self"],["span"],["str"],["string"],["applicability"]],["self"]]],[11,"span_suggestions_with_applicability","","",6,[[["self"],["span"],["str"],["vec",["string"]],["applicability"]],["self"]]],[11,"span_suggestion_short_with_applicability","","",6,[[["self"],["span"],["str"],["string"],["applicability"]],["self"]]],[11,"set_span","","",6,[[["self"],["s"]],["self"]]],[11,"code","","",6,[[["self"],["diagnosticid"]],["self"]]],[11,"allow_suggestions","","",6,[[["self"],["bool"]],["self"]]],[11,"new","","Convenience function for internal use, clients should use one of the struct_* methods on Handler.",6,[[["handler"],["level"],["str"]],["diagnosticbuilder"]]],[11,"new_with_code","","Convenience function for internal use, clients should use one of the struct_* methods on Handler.",6,[[["handler"],["level"],["option",["diagnosticid"]],["str"]],["diagnosticbuilder"]]],[11,"new_diagnostic","","Creates a new `DiagnosticBuilder` with an already constructed diagnostic.",6,[[["handler"],["diagnostic"]],["diagnosticbuilder"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"drop","","",6,[[["self"]]]],[0,"emitter","","",N,N],[3,"EmitterWriter","rustc_errors::emitter","",N,N],[12,"dst","","",13,N],[12,"cm","","",13,N],[12,"short_message","","",13,N],[12,"teach","","",13,N],[12,"ui_testing","","",13,N],[3,"FileWithAnnotatedLines","","",N,N],[12,"file","","",14,N],[12,"lines","","",14,N],[12,"multiline_depth","","",14,N],[4,"ColorConfig","","",N,N],[13,"Auto","","",15,N],[13,"Always","","",15,N],[13,"Never","","",15,N],[4,"Destination","","",N,N],[13,"Terminal","","",16,N],[13,"Buffered","","",16,N],[13,"Raw","","",16,N],[4,"WritableDst","","",N,N],[13,"Terminal","","",17,N],[13,"Buffered","","",17,N],[13,"Raw","","",17,N],[5,"draw_col_separator","","",N,[[["styledbuffer"],["usize"],["usize"]]]],[5,"draw_col_separator_no_space","","",N,[[["styledbuffer"],["usize"],["usize"]]]],[5,"draw_col_separator_no_space_with_style","","",N,[[["styledbuffer"],["usize"],["usize"],["style"]]]],[5,"draw_range","","",N,[[["styledbuffer"],["char"],["usize"],["usize"],["usize"],["style"]]]],[5,"draw_note_separator","","",N,[[["styledbuffer"],["usize"],["usize"]]]],[5,"draw_multiline_line","","",N,[[["styledbuffer"],["usize"],["usize"],["usize"],["style"]]]],[5,"num_overlap","","",N,[[["usize"],["usize"],["usize"],["usize"],["bool"]],["bool"]]],[5,"overlaps","","",N,[[["annotation"],["annotation"],["usize"]],["bool"]]],[5,"emit_to_destination","","",N,N],[17,"ANONYMIZED_LINE_NUM","","",N,N],[17,"MAX_HIGHLIGHT_LINES","","maximum number of lines we will print for each error; arbitrary.",N,N],[17,"MAX_SUGGESTIONS","","maximum number of suggestions to be shown",N,N],[8,"Emitter","","Emitter trait for emitting errors.",N,N],[10,"emit","","Emit a structured diagnostic.",18,[[["self"],["diagnosticbuilder"]]]],[11,"should_show_explain","","Check if should show explanations about \"rustc --explain\"",18,[[["self"]],["bool"]]],[11,"emit","","",13,[[["self"],["diagnosticbuilder"]]]],[11,"should_show_explain","","",13,[[["self"]],["bool"]]],[11,"clone","","",15,[[["self"]],["colorconfig"]]],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"eq","","",15,[[["self"],["colorconfig"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",15,N],[11,"to_color_choice","","",15,[[["self"]],["colorchoice"]]],[11,"stderr","","",13,[[["colorconfig"],["option",["lrc"]],["bool"],["bool"]],["emitterwriter"]]],[11,"new","","",13,[[["box",["write"]],["option",["lrc"]],["bool"],["bool"]],["emitterwriter"]]],[11,"ui_testing","","",13,[[["self"],["bool"]],["self"]]],[11,"maybe_anonymized","","",13,[[["self"],["usize"]],["string"]]],[11,"preprocess_annotations","","",13,[[["self"],["multispan"]],["vec",["filewithannotatedlines"]]]],[11,"render_source_line","","",13,[[["self"],["styledbuffer"],["lrc",["sourcefile"]],["line"],["usize"],["usize"]],["vec"]]],[11,"get_multispan_max_line_num","","",13,[[["self"],["multispan"]],["usize"]]],[11,"get_max_line_num","","",13,N],[11,"fix_multispan_in_std_macros","","",13,[[["self"],["multispan"],["bool"]],["bool"]]],[11,"fix_multispans_in_std_macros","","",13,[[["self"],["multispan"],["vec"],["bool"]]]],[11,"msg_to_buffer","","Add a left margin to every line but the first, given a padding length and the label being displayed, keeping the provided highlighting.",13,N],[11,"emit_message_default","","",13,N],[11,"emit_suggestion_default","","",13,[[["self"],["codesuggestion"],["level"],["usize"]],["result"]]],[11,"emit_messages_default","","",13,N],[11,"from_stderr","","",16,[[["colorconfig"]],["destination"]]],[11,"writable","","",16,[[["self"]],["writabledst"]]],[11,"apply_style","","",17,[[["self"],["level"],["style"]],["result"]]],[11,"set_color","","",17,[[["self"],["colorspec"]],["result"]]],[11,"reset","","",17,[[["self"]],["result"]]],[11,"write","","",17,N],[11,"flush","","",17,[[["self"]],["result"]]],[11,"drop","","",17,[[["self"]]]],[0,"snippet","rustc_errors","",N,N],[3,"Line","rustc_errors::snippet","",N,N],[12,"line_index","","",19,N],[12,"annotations","","",19,N],[3,"MultilineAnnotation","","",N,N],[12,"depth","","",20,N],[12,"line_start","","",20,N],[12,"line_end","","",20,N],[12,"start_col","","",20,N],[12,"end_col","","",20,N],[12,"is_primary","","",20,N],[12,"label","","",20,N],[3,"Annotation","","",N,N],[12,"start_col","","Start column, 0-based indexing -- counting characters, not utf-8 bytes. Note that it is important that this field goes first, so that when we sort, we sort orderings by start column.",21,N],[12,"end_col","","End column within the line (exclusive)",21,N],[12,"is_primary","","Is this annotation derived from primary span",21,N],[12,"label","","Optional label to display adjacent to the annotation.",21,N],[12,"annotation_type","","Is this a single line, multiline or multiline span minimized down to a smaller span.",21,N],[3,"StyledString","","",N,N],[12,"text","","",22,N],[12,"style","","",22,N],[4,"AnnotationType","","",N,N],[13,"Singleline","","Annotation under a single line of code",23,N],[13,"Multiline","","Annotation enclosing the first and last character of a multiline span",23,N],[13,"MultilineStart","","Annotation marking the first character of a fully shown multiline span",23,N],[13,"MultilineEnd","","Annotation marking the last character of a fully shown multiline span",23,N],[13,"MultilineLine","","Line at the left enclosing the lines of a fully shown multiline span",23,N],[4,"Style","","",N,N],[13,"MainHeaderMsg","","",24,N],[13,"HeaderMsg","","",24,N],[13,"LineAndColumn","","",24,N],[13,"LineNumber","","",24,N],[13,"Quotation","","",24,N],[13,"UnderlinePrimary","","",24,N],[13,"UnderlineSecondary","","",24,N],[13,"LabelPrimary","","",24,N],[13,"LabelSecondary","","",24,N],[13,"OldSchoolNoteText","","",24,N],[13,"NoStyle","","",24,N],[13,"Level","","",24,N],[13,"Highlight","","",24,N],[11,"clone","","",19,[[["self"]],["line"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",19,[[["self"],["line"]],["option",["ordering"]]]],[11,"lt","","",19,[[["self"],["line"]],["bool"]]],[11,"le","","",19,[[["self"],["line"]],["bool"]]],[11,"gt","","",19,[[["self"],["line"]],["bool"]]],[11,"ge","","",19,[[["self"],["line"]],["bool"]]],[11,"cmp","","",19,[[["self"],["line"]],["ordering"]]],[11,"eq","","",19,[[["self"],["line"]],["bool"]]],[11,"ne","","",19,[[["self"],["line"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"clone","","",20,[[["self"]],["multilineannotation"]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",20,[[["self"],["multilineannotation"]],["option",["ordering"]]]],[11,"lt","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"le","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"gt","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"ge","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"cmp","","",20,[[["self"],["multilineannotation"]],["ordering"]]],[11,"eq","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"ne","","",20,[[["self"],["multilineannotation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",20,N],[11,"increase_depth","","",20,[[["self"]]]],[11,"as_start","","",20,[[["self"]],["annotation"]]],[11,"as_end","","",20,[[["self"]],["annotation"]]],[11,"as_line","","",20,[[["self"]],["annotation"]]],[11,"clone","","",23,[[["self"]],["annotationtype"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",23,[[["self"],["annotationtype"]],["option",["ordering"]]]],[11,"lt","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"le","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"gt","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"ge","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"cmp","","",23,[[["self"],["annotationtype"]],["ordering"]]],[11,"eq","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"ne","","",23,[[["self"],["annotationtype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",23,N],[11,"clone","","",21,[[["self"]],["annotation"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",21,[[["self"],["annotation"]],["option",["ordering"]]]],[11,"lt","","",21,[[["self"],["annotation"]],["bool"]]],[11,"le","","",21,[[["self"],["annotation"]],["bool"]]],[11,"gt","","",21,[[["self"],["annotation"]],["bool"]]],[11,"ge","","",21,[[["self"],["annotation"]],["bool"]]],[11,"cmp","","",21,[[["self"],["annotation"]],["ordering"]]],[11,"eq","","",21,[[["self"],["annotation"]],["bool"]]],[11,"ne","","",21,[[["self"],["annotation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"is_line","","Whether this annotation is a vertical line placeholder.",21,[[["self"]],["bool"]]],[11,"is_multiline","","",21,[[["self"]],["bool"]]],[11,"len","","",21,[[["self"]],["usize"]]],[11,"has_label","","",21,[[["self"]],["bool"]]],[11,"takes_space","","",21,[[["self"]],["bool"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"clone","","",24,[[["self"]],["style"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"eq","","",24,[[["self"],["style"]],["bool"]]],[11,"ne","","",24,[[["self"],["style"]],["bool"]]],[11,"hash","","",24,N],[11,"encode","","",24,[[["self"],["__s"]],["result"]]],[11,"decode","","",24,[[["__d"]],["result",["style"]]]],[0,"registry","rustc_errors","",N,N],[3,"Registry","rustc_errors::registry","",N,N],[12,"descriptions","","",25,N],[11,"clone","","",25,[[["self"]],["registry"]]],[11,"new","","",25,N],[11,"find_description","","",25,[[["self"],["str"]],["option",["str"]]]],[0,"styled_buffer","rustc_errors","",N,N],[3,"StyledBuffer","rustc_errors::styled_buffer","",N,N],[12,"text","","",26,N],[12,"styles","","",26,N],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"new","","",26,[[],["styledbuffer"]]],[11,"replace_tabs","","",26,[[["self"]]]],[11,"render","","",26,[[["self"]],["vec",["vec"]]]],[11,"ensure_lines","","",26,[[["self"],["usize"]]]],[11,"putc","","",26,[[["self"],["usize"],["usize"],["char"],["style"]]]],[11,"puts","","",26,[[["self"],["usize"],["usize"],["str"],["style"]]]],[11,"prepend","","",26,[[["self"],["usize"],["str"],["style"]]]],[11,"append","","",26,[[["self"],["usize"],["str"],["style"]]]],[11,"num_lines","","",26,[[["self"]],["usize"]]],[11,"set_style_range","","",26,[[["self"],["usize"],["usize"],["usize"],["style"],["bool"]]]],[11,"set_style","","",26,[[["self"],["usize"],["usize"],["style"],["bool"]]]],[0,"lock","rustc_errors","Bindings to acquire a global named lock.",N,N],[5,"acquire_global_lock","rustc_errors::lock","",N,[[["str"]],["box",["any"]]]],[6,"SourceMapperDyn","rustc_errors","",N,N],[17,"TRACK_DIAGNOSTICS","","",N,N],[8,"SourceMapper","","",N,N],[10,"lookup_char_pos","","",27,[[["self"],["bytepos"]],["loc"]]],[10,"span_to_lines","","",27,[[["self"],["span"]],["filelinesresult"]]],[10,"span_to_string","","",27,[[["self"],["span"]],["string"]]],[10,"span_to_filename","","",27,[[["self"],["span"]],["filename"]]],[10,"merge_spans","","",27,[[["self"],["span"],["span"]],["option",["span"]]]],[10,"call_span_if_macro","","",27,[[["self"],["span"]],["span"]]],[10,"ensure_source_file_source_present","","",27,[[["self"],["lrc",["sourcefile"]]],["bool"]]],[10,"doctest_offset_line","","",27,[[["self"],["usize"]],["usize"]]],[11,"clone","","",9,[[["self"]],["applicability"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"eq","","",9,[[["self"],["applicability"]],["bool"]]],[11,"hash","","",9,N],[11,"encode","","",9,[[["self"],["__s"]],["result"]]],[11,"decode","","",9,[[["__d"]],["result",["applicability"]]]],[11,"clone","","",0,[[["self"]],["codesuggestion"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"eq","","",0,[[["self"],["codesuggestion"]],["bool"]]],[11,"ne","","",0,[[["self"],["codesuggestion"]],["bool"]]],[11,"hash","","",0,N],[11,"encode","","",0,[[["self"],["__s"]],["result"]]],[11,"decode","","",0,[[["__d"]],["result",["codesuggestion"]]]],[11,"clone","","",1,[[["self"]],["substitution"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"eq","","",1,[[["self"],["substitution"]],["bool"]]],[11,"ne","","",1,[[["self"],["substitution"]],["bool"]]],[11,"hash","","",1,N],[11,"encode","","",1,[[["self"],["__s"]],["result"]]],[11,"decode","","",1,[[["__d"]],["result",["substitution"]]]],[11,"clone","","",2,[[["self"]],["substitutionpart"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"eq","","",2,[[["self"],["substitutionpart"]],["bool"]]],[11,"ne","","",2,[[["self"],["substitutionpart"]],["bool"]]],[11,"hash","","",2,N],[11,"encode","","",2,[[["self"],["__s"]],["result"]]],[11,"decode","","",2,[[["__d"]],["result",["substitutionpart"]]]],[11,"splice_lines","","Returns the assembled code suggestions and whether they should be shown with an underline.",0,[[["self"],["sourcemapperdyn"]],["vec"]]],[11,"clone","","",28,[[["self"]],["fatalerror"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"raise","","",28,N],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"description","","",28,[[["self"]],["str"]]],[11,"clone","","",29,[[["self"]],["explicitbug"]]],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"description","","",29,[[["self"]],["str"]]],[11,"default","","",8,[[],["handlerflags"]]],[11,"drop","","",7,[[["self"]]]],[11,"with_tty_emitter","","",7,[[["colorconfig"],["bool"],["bool"],["option",["lrc"]]],["handler"]]],[11,"with_tty_emitter_and_flags","","",7,[[["colorconfig"],["option",["lrc"]],["handlerflags"]],["handler"]]],[11,"with_emitter","","",7,[[["bool"],["bool"],["box",["emitter"]]],["handler"]]],[11,"with_emitter_and_flags","","",7,[[["box",["emitter"]],["handlerflags"]],["handler"]]],[11,"set_continue_after_error","","",7,[[["self"],["bool"]]]],[11,"reset_err_count","","Resets the diagnostic error count as well as the cached emitted diagnostics.",7,[[["self"]]]],[11,"struct_dummy","","",7,[[["self"]],["diagnosticbuilder"]]],[11,"struct_span_warn","","",7,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_warn_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_warn","","",7,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err","","",7,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_err","","",7,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_err_with_code","","",7,[[["self"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_span_fatal","","",7,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_fatal_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_fatal","","",7,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"cancel","","",7,[[["self"],["diagnosticbuilder"]]]],[11,"panic_if_treat_err_as_bug","","",7,[[["self"]]]],[11,"span_fatal","","",7,[[["self"],["s"],["str"]],["fatalerror"]]],[11,"span_fatal_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]],["fatalerror"]]],[11,"span_err","","",7,[[["self"],["s"],["str"]]]],[11,"mut_span_err","","",7,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_err_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"span_warn","","",7,[[["self"],["s"],["str"]]]],[11,"span_warn_with_code","","",7,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"span_bug","","",7,N],[11,"delay_span_bug","","",7,[[["self"],["s"],["str"]]]],[11,"delay_as_bug","","",7,[[["self"],["diagnostic"]]]],[11,"span_bug_no_panic","","",7,[[["self"],["s"],["str"]]]],[11,"span_note_without_error","","",7,[[["self"],["s"],["str"]]]],[11,"span_note_diag","","",7,[[["self"],["span"],["str"]],["diagnosticbuilder"]]],[11,"span_unimpl","","",7,N],[11,"failure","","",7,[[["self"],["str"]]]],[11,"fatal","","",7,[[["self"],["str"]],["fatalerror"]]],[11,"err","","",7,[[["self"],["str"]]]],[11,"warn","","",7,[[["self"],["str"]]]],[11,"note_without_error","","",7,[[["self"],["str"]]]],[11,"bug","","",7,N],[11,"unimpl","","",7,N],[11,"bump_err_count","","",7,[[["self"]]]],[11,"err_count","","",7,[[["self"]],["usize"]]],[11,"has_errors","","",7,[[["self"]],["bool"]]],[11,"print_error_count","","",7,[[["self"]]]],[11,"abort_if_errors","","",7,[[["self"]]]],[11,"emit","","",7,[[["self"],["multispan"],["str"],["level"]]]],[11,"emit_with_code","","",7,[[["self"],["multispan"],["str"],["diagnosticid"],["level"]]]],[11,"must_teach","","`true` if we haven't taught a diagnostic with this code already. The caller must then teach the user about such a diagnostic.",7,[[["self"],["diagnosticid"]],["bool"]]],[11,"force_print_db","","",7,[[["self"],["diagnosticbuilder"]]]],[11,"emit_db","","",7,[[["self"],["diagnosticbuilder"]]]],[11,"eq","","",11,[[["self"],["level"]],["bool"]]],[11,"clone","","",11,[[["self"]],["level"]]],[11,"hash","","",11,N],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"encode","","",11,[[["self"],["__s"]],["result"]]],[11,"decode","","",11,[[["__d"]],["result",["level"]]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"color","","",11,[[["self"]],["colorspec"]]],[11,"to_str","","",11,[[["self"]],["str"]]],[11,"is_failure_note","","",11,[[["self"]],["bool"]]],[11,"to_owned","","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"encode","","",0,[[["self"],["e"]],["result"]]],[11,"decode","","",0,[[["d"]],["result"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"encode","","",1,[[["self"],["e"]],["result"]]],[11,"decode","","",1,[[["d"]],["result"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"encode","","",2,[[["self"],["e"]],["result"]]],[11,"decode","","",2,[[["d"]],["result"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"to_owned","","",28,[[["self"]],["t"]]],[11,"clone_into","","",28,N],[11,"from","","",28,[[["t"]],["t"]]],[11,"to_string","","",28,[[["self"]],["string"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"to_owned","","",29,[[["self"]],["t"]]],[11,"clone_into","","",29,N],[11,"from","","",29,[[["t"]],["t"]]],[11,"to_string","","",29,[[["self"]],["string"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"encode","","",3,[[["self"],["e"]],["result"]]],[11,"decode","","",3,[[["d"]],["result"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"encode","","",4,[[["self"],["e"]],["result"]]],[11,"decode","","",4,[[["d"]],["result"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"encode","","",9,[[["self"],["e"]],["result"]]],[11,"decode","","",9,[[["d"]],["result"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"encode","","",10,[[["self"],["e"]],["result"]]],[11,"decode","","",10,[[["d"]],["result"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"to_owned","","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"to_string","","",11,[[["self"]],["string"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"encode","","",11,[[["self"],["e"]],["result"]]],[11,"decode","","",11,[[["d"]],["result"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from","rustc_errors::diagnostic","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from","rustc_errors::emitter","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"to_owned","","",15,[[["self"]],["t"]]],[11,"clone_into","","",15,N],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_errors::snippet","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"to_owned","","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"to_owned","","",24,[[["self"]],["t"]]],[11,"clone_into","","",24,N],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"encode","","",24,[[["self"],["e"]],["result"]]],[11,"decode","","",24,[[["d"]],["result"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_errors::registry","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from","rustc_errors::styled_buffer","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]]],"paths":[[3,"CodeSuggestion"],[3,"Substitution"],[3,"SubstitutionPart"],[3,"Diagnostic"],[3,"SubDiagnostic"],[3,"DiagnosticStyledString"],[3,"DiagnosticBuilder"],[3,"Handler"],[3,"HandlerFlags"],[4,"Applicability"],[4,"DiagnosticId"],[4,"Level"],[4,"StringPart"],[3,"EmitterWriter"],[3,"FileWithAnnotatedLines"],[4,"ColorConfig"],[4,"Destination"],[4,"WritableDst"],[8,"Emitter"],[3,"Line"],[3,"MultilineAnnotation"],[3,"Annotation"],[3,"StyledString"],[4,"AnnotationType"],[4,"Style"],[3,"Registry"],[3,"StyledBuffer"],[8,"SourceMapper"],[3,"FatalError"],[3,"ExplicitBug"],[3,"FatalErrorMarker"]]};
searchIndex["rustc_fs_util"]={"doc":"","items":[[4,"LinkOrCopy","rustc_fs_util","",N,N],[13,"Link","","",0,N],[13,"Copy","","",0,N],[4,"RenameOrCopyRemove","","",N,N],[13,"Rename","","",1,N],[13,"CopyRemove","","",1,N],[5,"fix_windows_verbatim_for_gcc","","",N,[[["path"]],["pathbuf"]]],[5,"link_or_copy","","Copy `p` into `q`, preferring to use hard-linking if possible. If `q` already exists, it is removed first. The result indicates which of the two operations has been performed.",N,[[["p"],["q"]],["result",["linkorcopy"]]]],[5,"rename_or_copy_remove","","Rename `p` into `q`, preferring to use `rename` if possible. If `rename` fails (rename may fail for reasons such as crossing filesystem), fallback to copy & remove",N,[[["p"],["q"]],["result",["renameorcopyremove"]]]],[5,"path2cstr","","",N,[[["path"]],["cstring"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]]],"paths":[[4,"LinkOrCopy"],[4,"RenameOrCopyRemove"]]};
searchIndex["rustc_incremental"]={"doc":"Support for serializing the dep-graph and reloading it.","items":[[4,"LoadResult","rustc_incremental","",N,N],[13,"Ok","","",0,N],[12,"data","rustc_incremental::LoadResult","",0,N],[13,"DataOutOfDate","rustc_incremental","",0,N],[13,"Error","","",0,N],[12,"message","rustc_incremental::LoadResult","",0,N],[5,"assert_dep_graph","rustc_incremental","",N,[[["tyctxt"]]]],[5,"dep_graph_tcx_init","","",N,[[["tyctxt"]]]],[5,"load_dep_graph","","Launch a thread and load the dependency graph in the background.",N,[[["session"]],["maybeasync",["loadresult"]]]],[5,"load_query_result_cache","","",N,[[["session"]],["ondiskcache"]]],[5,"copy_cgu_workproducts_to_incr_comp_cache_dir","","",N,N],[5,"save_dep_graph","","",N,[[["tyctxt"]]]],[5,"save_work_product_index","","",N,[[["session"],["depgraph"],["fxhashmap",["workproductid","workproduct"]]]]],[5,"in_incr_comp_dir","","",N,[[["path"],["str"]],["pathbuf"]]],[5,"in_incr_comp_dir_sess","","",N,[[["session"],["str"]],["pathbuf"]]],[5,"prepare_session_directory","","Allocates the private session directory. The boolean in the Ok() result indicates whether we should try loading a dep graph from the successfully initialized directory, or not. The post-condition of this fn is that we have a valid incremental compilation session directory, if the result is `Ok`. A valid session directory is one that contains a locked lock file. It may or may not contain a dep-graph and work products from a previous session. If the call fails, the fn may leave behind an invalid session directory. The garbage collection will take care of it.",N,[[["session"],["str"],["cratedisambiguator"]]]],[5,"finalize_session_directory","","This function finalizes and thus 'publishes' the session directory by renaming it to `s-{timestamp}-{svh}` and releasing the file lock. If there have been compilation errors, however, this function will just delete the presumably invalid session directory.",N,[[["session"],["svh"]]]],[5,"delete_workproduct_files","","",N,[[["session"],["workproduct"]]]],[5,"garbage_collect_session_directories","","",N,[[["session"]],["result"]]],[0,"assert_dep_graph","","This pass is only used for the UNIT TESTS and DEBUGGING NEEDS around dependency graph construction. It serves two purposes; it will dump graphs in graphviz form to disk, and it searches for `#[rustc_if_this_changed]` and `#[rustc_then_this_would_need]` annotations. These annotations can be used to test whether paths exist in the graph. These checks run after codegen, so they view the the final state of the dependency graph. Note that there are similar assertions found in `persist::dirty_clean` which check the initial state of the dependency graph, just after it has been loaded from disk.",N,N],[3,"IfThisChanged","rustc_incremental::assert_dep_graph","",N,N],[12,"tcx","","",1,N],[12,"if_this_changed","","",1,N],[12,"then_this_would_need","","",1,N],[3,"GraphvizDepGraph","","",N,N],[12,"0","","",2,N],[12,"1","","",2,N],[5,"assert_dep_graph","","",N,[[["tyctxt"]]]],[5,"check_paths","","",N,[[["tyctxt"],["vec"],["vec"]]]],[5,"dump_graph","","",N,[[["tyctxt"]]]],[5,"node_set","","",N,[[["depgraphquery"],["depnodefilter"]],["option",["fxhashset"]]]],[5,"filter_nodes","","",N,[[["depgraphquery"],["option"],["option"]],["fxhashset",["depnode"]]]],[5,"walk_nodes","","",N,[[["depgraphquery"],["fxhashset"],["direction"]],["fxhashset",["depnode"]]]],[5,"walk_between","","",N,[[["depgraphquery"],["fxhashset"],["fxhashset"]],["fxhashset",["depnode"]]]],[5,"filter_edges","","",N,[[["depgraphquery"],["fxhashset"]],["vec"]]],[6,"Sources","","",N,N],[6,"Targets","","",N,N],[11,"argument","","",1,[[["self"],["attribute"]],["option",["name"]]]],[11,"process_attrs","","",1,N],[11,"nested_visit_map","","",1,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",1,[[["self"],["item"]]]],[11,"visit_trait_item","","",1,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",1,[[["self"],["implitem"]]]],[11,"visit_struct_field","","",1,[[["self"],["structfield"]]]],[11,"nodes","","",2,[[["self"]],["nodes",["depnode"]]]],[11,"edges","","",2,[[["self"]],["edges"]]],[11,"source","","",2,N],[11,"target","","",2,N],[11,"graph_id","","",2,[[["self"]],["id"]]],[11,"node_id","","",2,[[["self"],["depnode"]],["id"]]],[11,"node_label","","",2,[[["self"],["depnode"]],["labeltext"]]],[0,"assert_module_sources","rustc_incremental","This pass is only used for UNIT TESTS related to incremental compilation. It tests whether a particular `.o` file will be re-used from a previous compilation or whether it must be regenerated.",N,N],[3,"AssertModuleSource","rustc_incremental::assert_module_sources","",N,N],[12,"tcx","","",3,N],[4,"Disposition","","",N,N],[13,"Reused","","",4,N],[13,"Codegened","","",4,N],[5,"assert_module_sources","","",N,[[["tyctxt"]]]],[17,"MODULE","","",N,N],[17,"CFG","","",N,N],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["disposition"]],["bool"]]],[11,"clone","","",4,[[["self"]],["disposition"]]],[11,"check_attr","","",3,[[["self"],["attribute"]]]],[11,"field","","",3,[[["self"],["attribute"],["str"]],["name"]]],[11,"check_config","","Scan for a `cfg=\"foo\"` attribute and check whether we have a cfg flag called `foo`.",3,[[["self"],["attribute"]],["bool"]]],[0,"persist","rustc_incremental","When in incremental mode, this pass dumps out the dependency graph into the given directory. At the same time, it also hashes the various HIR nodes.",N,N],[0,"data","rustc_incremental::persist","The data that we will serialize and deserialize.",N,N],[3,"SerializedWorkProduct","rustc_incremental::persist::data","",N,N],[12,"id","","node that produced the work-product",5,N],[12,"work_product","","work-product data itself",5,N],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"encode","","",5,[[["self"],["__s"]],["result"]]],[11,"decode","","",5,[[["__d"]],["result",["serializedworkproduct"]]]],[0,"dirty_clean","rustc_incremental::persist","Debugging code to test fingerprints computed for query results. For each node marked with `#[rustc_clean]` or `#[rustc_dirty]`, we will compare the fingerprint from the current and from the previous compilation session as appropriate:",N,N],[3,"Assertion","rustc_incremental::persist::dirty_clean","Represents the requested configuration by rustc_clean/dirty",N,N],[12,"clean","","",6,N],[12,"dirty","","",6,N],[3,"DirtyCleanVisitor","","",N,N],[12,"tcx","","",7,N],[12,"checked_attrs","","",7,N],[3,"FindAllAttrs","","",N,N],[12,"tcx","","",8,N],[12,"attr_names","","",8,N],[12,"found_attrs","","",8,N],[5,"check_dirty_clean_annotations","","",N,[[["tyctxt"]]]],[5,"check_config","","Given a `#[rustc_dirty]` or `#[rustc_clean]` attribute, scan for a `cfg=\"foo\"` attribute and check whether we have a cfg flag called `foo`.",N,[[["tyctxt"],["attribute"]],["bool"]]],[5,"expect_associated_value","","",N,[[["tyctxt"],["nestedmetaitem"]],["name"]]],[6,"Labels","","",N,N],[22,"","","",N,N],[17,"EXCEPT","","",N,N],[17,"LABEL","","",N,N],[17,"CFG","","",N,N],[17,"BASE_CONST","","For typedef, constants, and statics",N,N],[17,"BASE_FN","","DepNodes for functions + methods",N,N],[17,"BASE_HIR","","DepNodes for Hir, which is pretty much everything",N,N],[17,"BASE_IMPL","","`impl` implementation of struct/trait",N,N],[17,"BASE_MIR","","DepNodes for MirValidated/Optimized, which is relevant in \"executable\" code, i.e. functions+methods",N,N],[17,"BASE_STRUCT","","Struct, Enum and Union DepNodes",N,N],[17,"BASE_TRAIT_DEF","","Trait Definition DepNodes",N,N],[17,"EXTRA_ASSOCIATED","","extra DepNodes for methods (+fn)",N,N],[17,"EXTRA_TRAIT","","",N,N],[17,"LABELS_CONST","","",N,N],[17,"LABELS_CONST_IN_IMPL","","Constant/Typedef in an impl",N,N],[17,"LABELS_CONST_IN_TRAIT","","Trait-Const/Typedef DepNodes",N,N],[17,"LABELS_FN","","Function DepNode",N,N],[17,"LABELS_FN_IN_IMPL","","Method DepNodes",N,N],[17,"LABELS_FN_IN_TRAIT","","Trait-Method DepNodes",N,N],[17,"LABELS_HIR_ONLY","","For generic cases like inline-assemply/mod/etc",N,N],[17,"LABELS_IMPL","","Impl DepNodes",N,N],[17,"LABELS_ADT","","Abstract Data Type (Struct, Enum, Unions) DepNodes",N,N],[17,"LABELS_TRAIT","","Trait Definition DepNodes",N,N],[11,"from_clean_labels","","",6,[[["fxhashset",["string"]]],["assertion"]]],[11,"from_dirty_labels","","",6,[[["fxhashset",["string"]]],["assertion"]]],[11,"assertion_maybe","","Possibly \"deserialize\" the attribute into a clean/dirty assertion",7,[[["self"],["nodeid"],["attribute"]],["option",["assertion"]]]],[11,"assertion_auto","","Get the \"auto\" assertion on pre-validated attr, along with the `except` labels",7,[[["self"],["nodeid"],["attribute"],["bool"]],["assertion"]]],[11,"labels","","",7,[[["self"],["attribute"]],["option",["fxhashset"]]]],[11,"except","","`except=` attribute value",7,[[["self"],["attribute"]],["fxhashset",["string"]]]],[11,"auto_labels","","Return all DepNode labels that should be asserted for this item. index=0 is the \"name\" used for error messages",7,N],[11,"resolve_labels","","",7,[[["self"],["nestedmetaitem"],["str"]],["fxhashset",["string"]]]],[11,"dep_nodes","","",7,N],[11,"dep_node_str","","",7,[[["self"],["depnode"]],["string"]]],[11,"assert_dirty","","",7,[[["self"],["span"],["depnode"]]]],[11,"assert_clean","","",7,[[["self"],["span"],["depnode"]]]],[11,"check_item","","",7,[[["self"],["nodeid"],["span"]]]],[11,"visit_item","","",7,[[["self"],["item"]]]],[11,"visit_trait_item","","",7,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",7,[[["self"],["implitem"]]]],[11,"is_active_attr","","",8,[[["self"],["attribute"]],["bool"]]],[11,"report_unchecked_attrs","","",8,[[["self"],["fxhashset"]]]],[11,"nested_visit_map","","",8,[[["self"]],["nestedvisitormap"]]],[11,"visit_attribute","","",8,[[["self"],["attribute"]]]],[0,"fs","rustc_incremental::persist","This module manages how the incremental compilation cache is represented in the file system.",N,N],[5,"dep_graph_path","rustc_incremental::persist::fs","",N,[[["session"]],["pathbuf"]]],[5,"dep_graph_path_from","","",N,[[["path"]],["pathbuf"]]],[5,"work_products_path","","",N,[[["session"]],["pathbuf"]]],[5,"query_cache_path","","",N,[[["session"]],["pathbuf"]]],[5,"lock_file_path","","",N,[[["path"]],["pathbuf"]]],[5,"in_incr_comp_dir_sess","","",N,[[["session"],["str"]],["pathbuf"]]],[5,"in_incr_comp_dir","","",N,[[["path"],["str"]],["pathbuf"]]],[5,"prepare_session_directory","","Allocates the private session directory. The boolean in the Ok() result indicates whether we should try loading a dep graph from the successfully initialized directory, or not. The post-condition of this fn is that we have a valid incremental compilation session directory, if the result is `Ok`. A valid session directory is one that contains a locked lock file. It may or may not contain a dep-graph and work products from a previous session. If the call fails, the fn may leave behind an invalid session directory. The garbage collection will take care of it.",N,[[["session"],["str"],["cratedisambiguator"]]]],[5,"finalize_session_directory","","This function finalizes and thus 'publishes' the session directory by renaming it to `s-{timestamp}-{svh}` and releasing the file lock. If there have been compilation errors, however, this function will just delete the presumably invalid session directory.",N,[[["session"],["svh"]]]],[5,"delete_all_session_dir_contents","","",N,[[["session"]],["result"]]],[5,"copy_files","","",N,[[["session"],["path"],["path"]],["result",["bool"]]]],[5,"generate_session_dir_path","","Generate unique directory path of the form: {crate_dir}/s-{timestamp}-{random-number}-working",N,[[["path"]],["pathbuf"]]],[5,"create_dir","","",N,[[["session"],["path"],["str"]],["result"]]],[5,"lock_directory","","Allocate a the lock-file and lock it.",N,[[["session"],["path"]],["result"]]],[5,"delete_session_dir_lock_file","","",N,[[["session"],["path"]]]],[5,"find_source_directory","","Find the most recent published session directory that is not in the ignore-list.",N,[[["path"],["fxhashset"]],["option",["pathbuf"]]]],[5,"find_source_directory_in_iter","","",N,[[["i"],["fxhashset"]],["option",["pathbuf"]]]],[5,"is_finalized","","",N,[[["str"]],["bool"]]],[5,"is_session_directory","","",N,[[["str"]],["bool"]]],[5,"is_session_directory_lock_file","","",N,[[["str"]],["bool"]]],[5,"extract_timestamp_from_session_dir","","",N,[[["str"]],["result",["systemtime"]]]],[5,"timestamp_to_string","","",N,[[["systemtime"]],["string"]]],[5,"string_to_timestamp","","",N,[[["str"]],["result",["systemtime"]]]],[5,"crate_path","","",N,[[["session"],["str"],["cratedisambiguator"]],["pathbuf"]]],[5,"assert_no_characters_lost","","",N,[[["str"]]]],[5,"is_old_enough_to_be_collected","","",N,[[["systemtime"]],["bool"]]],[5,"garbage_collect_session_directories","","",N,[[["session"]],["result"]]],[5,"all_except_most_recent","","",N,[[["vec"]],["fxhashmap",["pathbuf","option"]]]],[5,"safe_remove_dir_all","","Since paths of artifacts within session directories can get quite long, we need to support deleting files with very long paths. The regular WinApi functions only support paths up to 260 characters, however. In order to circumvent this limitation, we canonicalize the path of the directory before passing it to std::fs::remove_dir_all(). This will convert the path into the '\\?' format, which supports much longer paths.",N,[[["path"]],["result"]]],[5,"safe_remove_file","","",N,[[["path"]],["result"]]],[17,"LOCK_FILE_EXT","","",N,N],[17,"DEP_GRAPH_FILENAME","","",N,N],[17,"WORK_PRODUCTS_FILENAME","","",N,N],[17,"QUERY_CACHE_FILENAME","","",N,N],[17,"INT_ENCODE_BASE","","",N,N],[0,"load","rustc_incremental::persist","Code to save/load the dep-graph from files.",N,N],[4,"LoadResult","rustc_incremental::persist::load","",N,N],[13,"Ok","","",0,N],[12,"data","rustc_incremental::persist::load::LoadResult","",0,N],[13,"DataOutOfDate","rustc_incremental::persist::load","",0,N],[13,"Error","","",0,N],[12,"message","rustc_incremental::persist::load::LoadResult","",0,N],[4,"MaybeAsync","rustc_incremental::persist::load","Either a result that has already be computed or a handle that will let us wait until it is computed by a background thread.",N,N],[13,"Sync","","",9,N],[13,"Async","","",9,N],[5,"dep_graph_tcx_init","","",N,[[["tyctxt"]]]],[5,"load_data","","",N,[[["bool"],["path"]],["loadresult"]]],[5,"delete_dirty_work_product","","",N,[[["session"],["serializedworkproduct"]]]],[5,"load_dep_graph","","Launch a thread and load the dependency graph in the background.",N,[[["session"]],["maybeasync",["loadresult"]]]],[5,"load_query_result_cache","","",N,[[["session"]],["ondiskcache"]]],[6,"WorkProductMap","","",N,N],[11,"open","rustc_incremental","",0,N],[11,"open","rustc_incremental::persist::load","",9,[[["self"]],["result"]]],[0,"save","rustc_incremental::persist","",N,N],[5,"save_dep_graph","rustc_incremental::persist::save","",N,[[["tyctxt"]]]],[5,"save_work_product_index","","",N,[[["session"],["depgraph"],["fxhashmap",["workproductid","workproduct"]]]]],[5,"save_in","","",N,[[["session"],["pathbuf"],["f"]]]],[5,"encode_dep_graph","","",N,[[["tyctxt"],["encoder"]]]],[5,"encode_work_product_index","","",N,[[["fxhashmap"],["encoder"]]]],[5,"encode_query_cache","","",N,[[["tyctxt"],["encoder"]]]],[0,"work_product","rustc_incremental::persist","This module contains files for saving intermediate work-products.",N,N],[5,"copy_cgu_workproducts_to_incr_comp_cache_dir","rustc_incremental::persist::work_product","",N,N],[5,"delete_workproduct_files","","",N,[[["session"],["workproduct"]]]],[0,"file_format","rustc_incremental::persist","This module defines a generic file format that allows to check if a given file generated by incremental compilation was generated by a compatible compiler version. This file format is used for the on-disk version of the dependency graph and the exported metadata hashes.",N,N],[5,"write_file_header","rustc_incremental::persist::file_format","",N,[[["encoder"]]]],[5,"read_file","","Reads the contents of a file with a file header as defined in this module.",N,[[["bool"],["path"]],["result",["option"]]]],[5,"report_format_mismatch","","",N,[[["bool"],["path"],["str"]]]],[5,"rustc_version","","",N,[[],["string"]]],[17,"FILE_MAGIC","","The first few bytes of files generated by incremental compilation",N,N],[17,"HEADER_FORMAT_VERSION","","Change this if the header format changes",N,N],[17,"RUSTC_VERSION","","A version string that hopefully is always different for compiler versions with different encodings of incremental compilation artifacts. Contains the git commit hash.",N,N],[11,"from","rustc_incremental","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","rustc_incremental::assert_dep_graph","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","rustc_incremental::assert_module_sources","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"from","rustc_incremental::persist::data","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"decode","","",5,[[["d"]],["result"]]],[11,"encode","","",5,[[["self"],["e"]],["result"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"from","rustc_incremental::persist::dirty_clean","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"from","rustc_incremental::persist::load","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]]],"paths":[[4,"LoadResult"],[3,"IfThisChanged"],[3,"GraphvizDepGraph"],[3,"AssertModuleSource"],[4,"Disposition"],[3,"SerializedWorkProduct"],[3,"Assertion"],[3,"DirtyCleanVisitor"],[3,"FindAllAttrs"],[4,"MaybeAsync"]]};
searchIndex["rustc_lint"]={"doc":"Lints in the Rust compiler.","items":[[5,"register_builtins","rustc_lint","Tell the `LintStore` about all the built-in lints (the ones defined in this crate and the ones defined in `rustc::lint::builtin`).",N,[[["lintstore"],["option",["session"]]]]],[0,"nonstandard_style","","",N,N],[3,"NonCamelCaseTypes","rustc_lint::nonstandard_style","",N,N],[3,"NonSnakeCase","","",N,N],[3,"NonUpperCaseGlobals","","",N,N],[4,"MethodLateContext","","",N,N],[13,"TraitAutoImpl","","",0,N],[13,"TraitImpl","","",0,N],[13,"PlainImpl","","",0,N],[5,"method_context","","",N,[[["latecontext"],["nodeid"]],["methodlatecontext"]]],[7,"NON_CAMEL_CASE_TYPES","","",N,N],[7,"NON_SNAKE_CASE","","",N,N],[7,"NON_UPPER_CASE_GLOBALS","","",N,N],[11,"eq","","",0,[[["self"],["methodlatecontext"]],["bool"]]],[11,"clone","","",1,[[["self"]],["noncamelcasetypes"]]],[11,"check_case","","",1,[[["self"],["latecontext"],["str"],["name"],["span"]]]],[11,"get_lints","","",1,[[["self"]],["lintarray"]]],[11,"check_item","","",1,[[["self"],["latecontext"],["item"]]]],[11,"check_variant","","",1,[[["self"],["latecontext"],["variant"],["generics"]]]],[11,"check_generic_param","","",1,[[["self"],["latecontext"],["genericparam"]]]],[11,"clone","","",2,[[["self"]],["nonsnakecase"]]],[11,"to_snake_case","","",2,[[["str"]],["string"]]],[11,"check_snake_case","","",2,[[["self"],["latecontext"],["str"],["str"],["option",["span"]]]]],[11,"get_lints","","",2,[[["self"]],["lintarray"]]],[11,"check_crate","","",2,[[["self"],["latecontext"],["crate"]]]],[11,"check_generic_param","","",2,[[["self"],["latecontext"],["genericparam"]]]],[11,"check_fn","","",2,[[["self"],["latecontext"],["fnkind"],["fndecl"],["body"],["span"],["nodeid"]]]],[11,"check_item","","",2,[[["self"],["latecontext"],["item"]]]],[11,"check_trait_item","","",2,[[["self"],["latecontext"],["traititem"]]]],[11,"check_pat","","",2,[[["self"],["latecontext"],["pat"]]]],[11,"check_struct_def","","",2,[[["self"],["latecontext"],["variantdata"],["name"],["generics"],["nodeid"]]]],[11,"clone","","",3,[[["self"]],["nonuppercaseglobals"]]],[11,"check_upper_case","","",3,[[["latecontext"],["str"],["name"],["span"]]]],[11,"get_lints","","",3,[[["self"]],["lintarray"]]],[11,"check_item","","",3,[[["self"],["latecontext"],["item"]]]],[11,"check_trait_item","","",3,[[["self"],["latecontext"],["traititem"]]]],[11,"check_impl_item","","",3,[[["self"],["latecontext"],["implitem"]]]],[11,"check_pat","","",3,[[["self"],["latecontext"],["pat"]]]],[0,"builtin","rustc_lint","Lints in the Rust compiler.",N,N],[7,"EXCEEDING_BITSHIFTS","rustc_lint::builtin","",N,N],[7,"CONST_ERR","","",N,N],[7,"UNUSED_IMPORTS","","",N,N],[7,"UNUSED_EXTERN_CRATES","","",N,N],[7,"UNUSED_QUALIFICATIONS","","",N,N],[7,"UNKNOWN_LINTS","","",N,N],[7,"UNUSED_VARIABLES","","",N,N],[7,"UNUSED_ASSIGNMENTS","","",N,N],[7,"DEAD_CODE","","",N,N],[7,"UNREACHABLE_CODE","","",N,N],[7,"UNREACHABLE_PATTERNS","","",N,N],[7,"UNUSED_MACROS","","",N,N],[7,"WARNINGS","","",N,N],[7,"UNUSED_FEATURES","","",N,N],[7,"STABLE_FEATURES","","",N,N],[7,"UNKNOWN_CRATE_TYPES","","",N,N],[7,"TRIVIAL_CASTS","","",N,N],[7,"TRIVIAL_NUMERIC_CASTS","","",N,N],[7,"PRIVATE_IN_PUBLIC","","",N,N],[7,"PUB_USE_OF_PRIVATE_EXTERN_CRATE","","",N,N],[7,"INVALID_TYPE_PARAM_DEFAULT","","",N,N],[7,"RENAMED_AND_REMOVED_LINTS","","",N,N],[7,"SAFE_EXTERN_STATICS","","",N,N],[7,"SAFE_PACKED_BORROWS","","",N,N],[7,"PATTERNS_IN_FNS_WITHOUT_BODY","","",N,N],[7,"LEGACY_DIRECTORY_OWNERSHIP","","",N,N],[7,"LEGACY_CONSTRUCTOR_VISIBILITY","","",N,N],[7,"MISSING_FRAGMENT_SPECIFIER","","",N,N],[7,"PARENTHESIZED_PARAMS_IN_TYPES_AND_MODULES","","",N,N],[7,"LATE_BOUND_LIFETIME_ARGUMENTS","","",N,N],[7,"INCOHERENT_FUNDAMENTAL_IMPLS","","",N,N],[7,"BAD_REPR","","",N,N],[7,"DEPRECATED","","",N,N],[7,"UNUSED_UNSAFE","","",N,N],[7,"UNUSED_MUT","","",N,N],[7,"SINGLE_USE_LIFETIMES","","",N,N],[7,"UNUSED_LIFETIMES","","",N,N],[7,"TYVAR_BEHIND_RAW_POINTER","","",N,N],[7,"ELIDED_LIFETIMES_IN_PATHS","","",N,N],[7,"BARE_TRAIT_OBJECTS","","",N,N],[7,"ABSOLUTE_PATHS_NOT_STARTING_WITH_CRATE","","",N,N],[7,"ILLEGAL_FLOATING_POINT_LITERAL_PATTERN","","",N,N],[7,"UNSTABLE_NAME_COLLISIONS","","",N,N],[7,"IRREFUTABLE_LET_PATTERNS","","",N,N],[7,"UNUSED_LABELS","","",N,N],[7,"DUPLICATE_ASSOCIATED_TYPE_BINDINGS","","",N,N],[7,"DUPLICATE_MACRO_EXPORTS","","",N,N],[7,"INTRA_DOC_LINK_RESOLUTION_FAILURE","","",N,N],[7,"WHERE_CLAUSES_OBJECT_SAFETY","","",N,N],[7,"PROC_MACRO_DERIVE_RESOLUTION_FALLBACK","","",N,N],[7,"MACRO_USE_EXTERN_CRATE","","",N,N],[7,"MACRO_EXPANDED_MACRO_EXPORTS_ACCESSED_BY_ABSOLUTE_PATHS","","",N,N],[0,"parser","","Some lints that are buffered from `libsyntax`. See `syntax::early_buffered_lints`.",N,N],[7,"QUESTION_MARK_MACRO_SEP","rustc_lint::builtin::parser","",N,N],[3,"HardwiredLints","rustc_lint::builtin","Does nothing as a lint pass, but registers some `Lint`s which are used by other parts of the compiler.",N,N],[4,"BuiltinLintDiagnostics","","",N,N],[13,"Normal","","",4,N],[13,"BareTraitObject","","",4,N],[13,"AbsPathWithModule","","",4,N],[13,"DuplicatedMacroExports","","",4,N],[13,"ProcMacroDeriveResolutionFallback","","",4,N],[13,"MacroExpandedMacroExportsAccessedByAbsolutePaths","","",4,N],[13,"ElidedLifetimesInPaths","","",4,N],[13,"UnknownCrateTypes","","",4,N],[3,"WhileTrue","","",N,N],[3,"BoxPointers","","",N,N],[3,"NonShorthandFieldPatterns","","",N,N],[3,"UnsafeCode","","",N,N],[3,"MissingDoc","","",N,N],[12,"doc_hidden_stack","","Stack of whether #[doc(hidden)] is set at each level which has lint attributes.",5,N],[12,"private_traits","","Private traits or trait items that leaked through. Don't check their methods.",5,N],[3,"MissingCopyImplementations","","",N,N],[3,"MissingDebugImplementations","","",N,N],[12,"impling_types","","",6,N],[3,"AnonymousParameters","","Checks for use of anonymous parameters (RFC 1685)",N,N],[3,"BadRepr","","Checks for incorrect use use of `repr` attributes.",N,N],[3,"DeprecatedAttr","","Checks for use of attributes which have been deprecated.",N,N],[12,"depr_attrs","","",7,N],[3,"UnusedDocComment","","",N,N],[3,"UnconditionalRecursion","","",N,N],[3,"PluginAsLibrary","","",N,N],[3,"InvalidNoMangleItems","","",N,N],[3,"MutableTransmutes","","",N,N],[3,"UnstableFeatures","","Forbids using the `#[feature(...)]` attribute",N,N],[3,"UnionsWithDropFields","","Lint for unions that contain fields with possibly non-trivial destructors.",N,N],[3,"UnreachablePub","","Lint for items marked `pub` that aren't reachable from other crates",N,N],[3,"TypeAliasBounds","","Lint for trait and lifetime bounds in type aliases being mostly ignored: They are relevant when using associated types, but otherwise neither checked at definition site nor enforced at use site.",N,N],[3,"UnusedBrokenConst","","Lint constants that are erroneous. Without this lint, we might not get any diagnostic if the constant is unused within this crate, even though downstream crates can't use it without producing an error.",N,N],[3,"UnusedBrokenConstVisitor","","",N,N],[12,"0","","",8,N],[3,"TrivialConstraints","","Lint for trait and lifetime bounds that don't depend on type parameters which either do nothing, or stop the item from being used.",N,N],[3,"SoftLints","","Does nothing as a lint pass, but registers some `Lint`s which are used by other parts of the compiler.",N,N],[3,"EllipsisInclusiveRangePatterns","","",N,N],[3,"UnnameableTestItems","","",N,N],[12,"boundary","","",9,N],[12,"items_nameable","","",9,N],[3,"KeywordIdents","","Checks for uses of edtion keywords used as an identifier",N,N],[5,"validate_const","","",N,[[["tyctxt"],["const"],["paramenv"],["globalid"],["str"]]]],[5,"check_const","","",N,[[["latecontext"],["bodyid"],["str"]]]],[7,"WHILE_TRUE","","",N,N],[7,"BOX_POINTERS","","",N,N],[7,"NON_SHORTHAND_FIELD_PATTERNS","","",N,N],[7,"UNSAFE_CODE","","",N,N],[7,"MISSING_DOCS","","",N,N],[7,"MISSING_COPY_IMPLEMENTATIONS","","",N,N],[7,"MISSING_DEBUG_IMPLEMENTATIONS","","",N,N],[7,"ANONYMOUS_PARAMETERS","","",N,N],[7,"UNUSED_DOC_COMMENTS","","",N,N],[7,"UNCONDITIONAL_RECURSION","","",N,N],[7,"PLUGIN_AS_LIBRARY","","",N,N],[7,"PRIVATE_NO_MANGLE_FNS","","",N,N],[7,"PRIVATE_NO_MANGLE_STATICS","","",N,N],[7,"NO_MANGLE_CONST_ITEMS","","",N,N],[7,"NO_MANGLE_GENERIC_ITEMS","","",N,N],[7,"MUTABLE_TRANSMUTES","","",N,N],[7,"UNSTABLE_FEATURES","","",N,N],[7,"UNIONS_WITH_DROP_FIELDS","","",N,N],[7,"UNREACHABLE_PUB","","",N,N],[7,"TYPE_ALIAS_BOUNDS","","",N,N],[7,"TRIVIAL_BOUNDS","","",N,N],[7,"ELLIPSIS_INCLUSIVE_RANGE_PATTERNS","","",N,N],[7,"UNNAMEABLE_TEST_ITEMS","","",N,N],[7,"KEYWORD_IDENTS","","",N,N],[11,"clone","","",10,[[["self"]],["whiletrue"]]],[11,"get_lints","","",10,[[["self"]],["lintarray"]]],[11,"check_expr","","",10,[[["self"],["latecontext"],["expr"]]]],[11,"clone","","",11,[[["self"]],["boxpointers"]]],[11,"check_heap_type","","",11,[[["self"],["latecontext"],["span"],["ty"]]]],[11,"get_lints","","",11,[[["self"]],["lintarray"]]],[11,"check_item","","",11,[[["self"],["latecontext"],["item"]]]],[11,"check_expr","","",11,[[["self"],["latecontext"],["expr"]]]],[11,"clone","","",12,[[["self"]],["nonshorthandfieldpatterns"]]],[11,"get_lints","","",12,[[["self"]],["lintarray"]]],[11,"check_pat","","",12,[[["self"],["latecontext"],["pat"]]]],[11,"clone","","",13,[[["self"]],["unsafecode"]]],[11,"get_lints","","",13,[[["self"]],["lintarray"]]],[11,"report_unsafe","","",13,[[["self"],["latecontext"],["span"],["str"]]]],[11,"check_expr","","",13,[[["self"],["latecontext"],["expr"]]]],[11,"check_item","","",13,[[["self"],["latecontext"],["item"]]]],[11,"check_fn","","",13,[[["self"],["latecontext"],["fnkind"],["fndecl"],["body"],["span"],["nodeid"]]]],[11,"check_trait_item","","",13,[[["self"],["latecontext"],["traititem"]]]],[11,"new","","",5,[[],["missingdoc"]]],[11,"doc_hidden","","",5,[[["self"]],["bool"]]],[11,"check_missing_docs_attrs","","",5,N],[11,"get_lints","","",5,[[["self"]],["lintarray"]]],[11,"enter_lint_attrs","","",5,N],[11,"exit_lint_attrs","","",5,N],[11,"check_crate","","",5,[[["self"],["latecontext"],["crate"]]]],[11,"check_item","","",5,[[["self"],["latecontext"],["item"]]]],[11,"check_trait_item","","",5,[[["self"],["latecontext"],["traititem"]]]],[11,"check_impl_item","","",5,[[["self"],["latecontext"],["implitem"]]]],[11,"check_struct_field","","",5,[[["self"],["latecontext"],["structfield"]]]],[11,"check_variant","","",5,[[["self"],["latecontext"],["variant"],["generics"]]]],[11,"clone","","",14,[[["self"]],["missingcopyimplementations"]]],[11,"get_lints","","",14,[[["self"]],["lintarray"]]],[11,"check_item","","",14,[[["self"],["latecontext"],["item"]]]],[11,"new","","",6,[[],["missingdebugimplementations"]]],[11,"get_lints","","",6,[[["self"]],["lintarray"]]],[11,"check_item","","",6,[[["self"],["latecontext"],["item"]]]],[11,"clone","","",15,[[["self"]],["anonymousparameters"]]],[11,"get_lints","","",15,[[["self"]],["lintarray"]]],[11,"check_trait_item","","",15,[[["self"],["earlycontext"],["traititem"]]]],[11,"clone","","",16,[[["self"]],["badrepr"]]],[11,"get_lints","","",16,[[["self"]],["lintarray"]]],[11,"check_attribute","","",16,[[["self"],["earlycontext"],["attribute"]]]],[11,"clone","","",7,[[["self"]],["deprecatedattr"]]],[11,"new","","",7,[[],["deprecatedattr"]]],[11,"get_lints","","",7,[[["self"]],["lintarray"]]],[11,"check_attribute","","",7,[[["self"],["earlycontext"],["attribute"]]]],[11,"clone","","",17,[[["self"]],["unuseddoccomment"]]],[11,"get_lints","","",17,[[["self"]],["lintarray"]]],[11,"warn_if_doc","","",17,[[["self"],["i"],["c"]]]],[11,"check_local","","",17,[[["self"],["earlycontext"],["local"]]]],[11,"check_arm","","",17,[[["self"],["earlycontext"],["arm"]]]],[11,"check_expr","","",17,[[["self"],["earlycontext"],["expr"]]]],[11,"clone","","",18,[[["self"]],["unconditionalrecursion"]]],[11,"get_lints","","",18,[[["self"]],["lintarray"]]],[11,"check_fn","","",18,[[["self"],["latecontext"],["fnkind"],["fndecl"],["body"],["span"],["nodeid"]]]],[11,"clone","","",19,[[["self"]],["pluginaslibrary"]]],[11,"get_lints","","",19,[[["self"]],["lintarray"]]],[11,"check_item","","",19,[[["self"],["latecontext"],["item"]]]],[11,"clone","","",20,[[["self"]],["invalidnomangleitems"]]],[11,"get_lints","","",20,[[["self"]],["lintarray"]]],[11,"check_item","","",20,[[["self"],["latecontext"],["item"]]]],[11,"clone","","",21,[[["self"]],["mutabletransmutes"]]],[11,"get_lints","","",21,[[["self"]],["lintarray"]]],[11,"check_expr","","",21,[[["self"],["latecontext"],["expr"]]]],[11,"clone","","",22,[[["self"]],["unstablefeatures"]]],[11,"get_lints","","",22,[[["self"]],["lintarray"]]],[11,"check_attribute","","",22,[[["self"],["latecontext"],["attribute"]]]],[11,"get_lints","","",23,[[["self"]],["lintarray"]]],[11,"check_item","","",23,[[["self"],["latecontext"],["item"]]]],[11,"get_lints","","",24,[[["self"]],["lintarray"]]],[11,"perform_lint","","",24,[[["self"],["latecontext"],["str"],["nodeid"],["visibility"],["span"],["bool"]]]],[11,"check_item","","",24,[[["self"],["latecontext"],["item"]]]],[11,"check_foreign_item","","",24,[[["self"],["latecontext"],["foreignitem"]]]],[11,"check_struct_field","","",24,[[["self"],["latecontext"],["structfield"]]]],[11,"check_impl_item","","",24,[[["self"],["latecontext"],["implitem"]]]],[11,"get_lints","","",25,[[["self"]],["lintarray"]]],[11,"is_type_variable_assoc","","",25,[[["qpath"]],["bool"]]],[11,"suggest_changing_assoc_types","","",25,[[["ty"],["diagnosticbuilder"]]]],[11,"check_item","","",25,[[["self"],["latecontext"],["item"]]]],[11,"get_lints","","",26,[[["self"]],["lintarray"]]],[11,"visit_nested_body","","",8,[[["self"],["bodyid"]]]],[11,"nested_visit_map","","",8,[[["self"]],["nestedvisitormap"]]],[11,"check_item","","",26,[[["self"],["latecontext"],["item"]]]],[11,"get_lints","","",27,[[["self"]],["lintarray"]]],[11,"check_item","","",27,[[["self"],["latecontext"],["item"]]]],[11,"clone","","",28,[[["self"]],["softlints"]]],[11,"get_lints","","",28,[[["self"]],["lintarray"]]],[11,"get_lints","","",29,[[["self"]],["lintarray"]]],[11,"check_pat","","",29,[[["self"],["earlycontext"],["pat"]]]],[11,"new","","",9,[[],["self"]]],[11,"get_lints","","",9,[[["self"]],["lintarray"]]],[11,"check_item","","",9,[[["self"],["latecontext"],["item"]]]],[11,"check_item_post","","",9,[[["self"],["latecontext"],["item"]]]],[11,"clone","","",30,[[["self"]],["keywordidents"]]],[11,"get_lints","","",30,[[["self"]],["lintarray"]]],[11,"check_tokens","","",30,[[["self"],["earlycontext"],["tokenstream"]]]],[11,"check_mac_def","","",30,[[["self"],["earlycontext"],["macrodef"],["nodeid"]]]],[11,"check_mac","","",30,[[["self"],["earlycontext"],["mac"]]]],[11,"check_ident","","",30,[[["self"],["earlycontext"],["ident"]]]],[0,"types","rustc_lint","",N,N],[3,"TypeLimits","rustc_lint::types","",N,N],[12,"negated_expr_id","","Id of the last visited negated expression",31,N],[3,"ImproperCTypesVisitor","","",N,N],[12,"cx","","",32,N],[3,"ImproperCTypes","","",N,N],[3,"VariantSizeDifferences","","",N,N],[4,"FfiResult","","",N,N],[13,"FfiSafe","","",33,N],[13,"FfiPhantom","","",33,N],[13,"FfiUnsafe","","",33,N],[12,"ty","rustc_lint::types::FfiResult","",33,N],[12,"reason","","",33,N],[12,"help","","",33,N],[5,"is_repr_nullable_ptr","rustc_lint::types","Check if this enum can be safely exported based on the \"nullable pointer optimization\". Currently restricted to function pointers and references, but could be expanded to cover NonZero raw pointers and newtypes. FIXME: This duplicates code in codegen.",N,[[["tyctxt"],["adtdef"],["substs"]],["bool"]]],[7,"UNUSED_COMPARISONS","","",N,N],[7,"OVERFLOWING_LITERALS","","",N,N],[7,"VARIANT_SIZE_DIFFERENCES","","",N,N],[7,"IMPROPER_CTYPES","","",N,N],[11,"clone","","",31,[[["self"]],["typelimits"]]],[11,"new","","",31,[[],["typelimits"]]],[11,"get_lints","","",31,[[["self"]],["lintarray"]]],[11,"check_expr","","",31,[[["self"],["latecontext"],["expr"]]]],[11,"check_type_for_ffi","","Check if the given type is \"ffi-safe\" (has a stable, well-defined representation which can be exported to C code).",32,[[["self"],["fxhashset"],["ty"]],["ffiresult"]]],[11,"check_type_for_ffi_and_report_errors","","",32,[[["self"],["span"],["ty"]]]],[11,"check_foreign_fn","","",32,[[["self"],["nodeid"],["fndecl"]]]],[11,"check_foreign_static","","",32,[[["self"],["nodeid"],["span"]]]],[11,"clone","","",34,[[["self"]],["improperctypes"]]],[11,"get_lints","","",34,[[["self"]],["lintarray"]]],[11,"check_foreign_item","","",34,[[["self"],["latecontext"],["foreignitem"]]]],[11,"get_lints","","",35,[[["self"]],["lintarray"]]],[11,"check_item","","",35,[[["self"],["latecontext"],["item"]]]],[0,"unused","rustc_lint","",N,N],[3,"UnusedResults","rustc_lint::unused","",N,N],[3,"PathStatements","","",N,N],[3,"UnusedAttributes","","",N,N],[3,"UnusedParens","","",N,N],[3,"UnusedImportBraces","","",N,N],[3,"UnusedAllocation","","",N,N],[7,"UNUSED_MUST_USE","","",N,N],[7,"UNUSED_RESULTS","","",N,N],[7,"PATH_STATEMENTS","","",N,N],[7,"UNUSED_ATTRIBUTES","","",N,N],[7,"UNUSED_PARENS","","",N,N],[7,"UNUSED_IMPORT_BRACES","","",N,N],[7,"UNUSED_ALLOCATION","","",N,N],[11,"clone","","",36,[[["self"]],["unusedresults"]]],[11,"get_lints","","",36,[[["self"]],["lintarray"]]],[11,"check_stmt","","",36,[[["self"],["latecontext"],["stmt"]]]],[11,"clone","","",37,[[["self"]],["pathstatements"]]],[11,"get_lints","","",37,[[["self"]],["lintarray"]]],[11,"check_stmt","","",37,[[["self"],["latecontext"],["stmt"]]]],[11,"clone","","",38,[[["self"]],["unusedattributes"]]],[11,"get_lints","","",38,[[["self"]],["lintarray"]]],[11,"check_attribute","","",38,[[["self"],["latecontext"],["attribute"]]]],[11,"clone","","",39,[[["self"]],["unusedparens"]]],[11,"check_unused_parens_core","","",39,[[["self"],["earlycontext"],["expr"],["str"],["bool"]]]],[11,"get_lints","","",39,[[["self"]],["lintarray"]]],[11,"check_expr","","",39,[[["self"],["earlycontext"],["expr"]]]],[11,"check_stmt","","",39,[[["self"],["earlycontext"],["stmt"]]]],[11,"clone","","",40,[[["self"]],["unusedimportbraces"]]],[11,"check_use_tree","","",40,[[["self"],["earlycontext"],["usetree"],["item"]]]],[11,"get_lints","","",40,[[["self"]],["lintarray"]]],[11,"check_item","","",40,[[["self"],["earlycontext"],["item"]]]],[11,"clone","","",41,[[["self"]],["unusedallocation"]]],[11,"get_lints","","",41,[[["self"]],["lintarray"]]],[11,"check_expr","","",41,[[["self"],["latecontext"],["expr"]]]],[11,"to_owned","rustc_lint::nonstandard_style","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_lint::builtin","",42,[[["self"]],["t"]]],[11,"clone_into","","",42,N],[11,"from","","",42,[[["t"]],["t"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"not_found","","",42,[[["str"],["str"]],["e"]]],[11,"from_ok","","",42,[[["t"]],["t"]]],[11,"map_same","","",42,[[["self"],["f"]],["t"]]],[11,"get_lints","","",42,[[["self"]],["vec",["lint"]]]],[11,"eq","","",4,[[["self"],["builtinlintdiagnostics"]],["bool"]]],[11,"ne","","",4,[[["self"],["builtinlintdiagnostics"]],["bool"]]],[11,"encode","","",4,[[["self"],["__s"]],["result"]]],[11,"decode","","",4,[[["__d"]],["result",["builtinlintdiagnostics"]]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result",["error"]]]],[11,"clone","","",42,[[["self"]],["hardwiredlints"]]],[11,"run","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"encode","","",4,[[["self"],["e"]],["result"]]],[11,"decode","","",4,[[["d"]],["result"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"to_owned","","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]],[11,"to_owned","","",12,[[["self"]],["t"]]],[11,"clone_into","","",12,N],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]],[11,"to_owned","","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from_ok","","",13,[[["t"]],["t"]]],[11,"map_same","","",13,[[["self"],["f"]],["t"]]],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"to_owned","","",14,[[["self"]],["t"]]],[11,"clone_into","","",14,N],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from_ok","","",14,[[["t"]],["t"]]],[11,"map_same","","",14,[[["self"],["f"]],["t"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"to_owned","","",15,[[["self"]],["t"]]],[11,"clone_into","","",15,N],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from_ok","","",15,[[["t"]],["t"]]],[11,"map_same","","",15,[[["self"],["f"]],["t"]]],[11,"to_owned","","",16,[[["self"]],["t"]]],[11,"clone_into","","",16,N],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from_ok","","",16,[[["t"]],["t"]]],[11,"map_same","","",16,[[["self"],["f"]],["t"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"to_owned","","",17,[[["self"]],["t"]]],[11,"clone_into","","",17,N],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from_ok","","",17,[[["t"]],["t"]]],[11,"map_same","","",17,[[["self"],["f"]],["t"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from_ok","","",18,[[["t"]],["t"]]],[11,"map_same","","",18,[[["self"],["f"]],["t"]]],[11,"to_owned","","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"from_ok","","",19,[[["t"]],["t"]]],[11,"map_same","","",19,[[["self"],["f"]],["t"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from_ok","","",20,[[["t"]],["t"]]],[11,"map_same","","",20,[[["self"],["f"]],["t"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from_ok","","",21,[[["t"]],["t"]]],[11,"map_same","","",21,[[["self"],["f"]],["t"]]],[11,"to_owned","","",22,[[["self"]],["t"]]],[11,"clone_into","","",22,N],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from_ok","","",22,[[["t"]],["t"]]],[11,"map_same","","",22,[[["self"],["f"]],["t"]]],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from_ok","","",23,[[["t"]],["t"]]],[11,"map_same","","",23,[[["self"],["f"]],["t"]]],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"from_ok","","",24,[[["t"]],["t"]]],[11,"map_same","","",24,[[["self"],["f"]],["t"]]],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from_ok","","",25,[[["t"]],["t"]]],[11,"map_same","","",25,[[["self"],["f"]],["t"]]],[11,"from","","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"from_ok","","",26,[[["t"]],["t"]]],[11,"map_same","","",26,[[["self"],["f"]],["t"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from_ok","","",27,[[["t"]],["t"]]],[11,"map_same","","",27,[[["self"],["f"]],["t"]]],[11,"to_owned","","",28,[[["self"]],["t"]]],[11,"clone_into","","",28,N],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from_ok","","",28,[[["t"]],["t"]]],[11,"map_same","","",28,[[["self"],["f"]],["t"]]],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from_ok","","",29,[[["t"]],["t"]]],[11,"map_same","","",29,[[["self"],["f"]],["t"]]],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"to_owned","","",30,[[["self"]],["t"]]],[11,"clone_into","","",30,N],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"from_ok","","",30,[[["t"]],["t"]]],[11,"map_same","","",30,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_lint::types","",31,[[["self"]],["t"]]],[11,"clone_into","","",31,N],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"from_ok","","",31,[[["t"]],["t"]]],[11,"map_same","","",31,[[["self"],["f"]],["t"]]],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from_ok","","",32,[[["t"]],["t"]]],[11,"map_same","","",32,[[["self"],["f"]],["t"]]],[11,"to_owned","","",34,[[["self"]],["t"]]],[11,"clone_into","","",34,N],[11,"from","","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"from_ok","","",34,[[["t"]],["t"]]],[11,"map_same","","",34,[[["self"],["f"]],["t"]]],[11,"from","","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"from_ok","","",35,[[["t"]],["t"]]],[11,"map_same","","",35,[[["self"],["f"]],["t"]]],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from_ok","","",33,[[["t"]],["t"]]],[11,"map_same","","",33,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_lint::unused","",36,[[["self"]],["t"]]],[11,"clone_into","","",36,N],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"from_ok","","",36,[[["t"]],["t"]]],[11,"map_same","","",36,[[["self"],["f"]],["t"]]],[11,"to_owned","","",37,[[["self"]],["t"]]],[11,"clone_into","","",37,N],[11,"from","","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"from_ok","","",37,[[["t"]],["t"]]],[11,"map_same","","",37,[[["self"],["f"]],["t"]]],[11,"to_owned","","",38,[[["self"]],["t"]]],[11,"clone_into","","",38,N],[11,"from","","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"from_ok","","",38,[[["t"]],["t"]]],[11,"map_same","","",38,[[["self"],["f"]],["t"]]],[11,"to_owned","","",39,[[["self"]],["t"]]],[11,"clone_into","","",39,N],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"from_ok","","",39,[[["t"]],["t"]]],[11,"map_same","","",39,[[["self"],["f"]],["t"]]],[11,"to_owned","","",40,[[["self"]],["t"]]],[11,"clone_into","","",40,N],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from_ok","","",40,[[["t"]],["t"]]],[11,"map_same","","",40,[[["self"],["f"]],["t"]]],[11,"to_owned","","",41,[[["self"]],["t"]]],[11,"clone_into","","",41,N],[11,"from","","",41,[[["t"]],["t"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"not_found","","",41,[[["str"],["str"]],["e"]]],[11,"from_ok","","",41,[[["t"]],["t"]]],[11,"map_same","","",41,[[["self"],["f"]],["t"]]]],"paths":[[4,"MethodLateContext"],[3,"NonCamelCaseTypes"],[3,"NonSnakeCase"],[3,"NonUpperCaseGlobals"],[4,"BuiltinLintDiagnostics"],[3,"MissingDoc"],[3,"MissingDebugImplementations"],[3,"DeprecatedAttr"],[3,"UnusedBrokenConstVisitor"],[3,"UnnameableTestItems"],[3,"WhileTrue"],[3,"BoxPointers"],[3,"NonShorthandFieldPatterns"],[3,"UnsafeCode"],[3,"MissingCopyImplementations"],[3,"AnonymousParameters"],[3,"BadRepr"],[3,"UnusedDocComment"],[3,"UnconditionalRecursion"],[3,"PluginAsLibrary"],[3,"InvalidNoMangleItems"],[3,"MutableTransmutes"],[3,"UnstableFeatures"],[3,"UnionsWithDropFields"],[3,"UnreachablePub"],[3,"TypeAliasBounds"],[3,"UnusedBrokenConst"],[3,"TrivialConstraints"],[3,"SoftLints"],[3,"EllipsisInclusiveRangePatterns"],[3,"KeywordIdents"],[3,"TypeLimits"],[3,"ImproperCTypesVisitor"],[4,"FfiResult"],[3,"ImproperCTypes"],[3,"VariantSizeDifferences"],[3,"UnusedResults"],[3,"PathStatements"],[3,"UnusedAttributes"],[3,"UnusedParens"],[3,"UnusedImportBraces"],[3,"UnusedAllocation"],[3,"HardwiredLints"]]};
searchIndex["rustc_llvm"]={"doc":"","items":[[5,"initialize_available_targets","rustc_llvm","Initialize targets enabled by the build script via `cfg(llvm_component = \"...\")`. NB: this function can't be moved to `rustc_codegen_llvm` because of the `cfg`s.",N,[[]]]],"paths":[]};
searchIndex["rustc_metadata"]={"doc":"","items":[[0,"diagnostics","rustc_metadata","",N,N],[0,"__register_diagnostic_E0454","rustc_metadata::diagnostics","",N,N],[0,"__register_diagnostic_E0455","","",N,N],[0,"__register_diagnostic_E0458","","",N,N],[0,"__register_diagnostic_E0459","","",N,N],[0,"__register_diagnostic_E0463","","",N,N],[0,"__register_diagnostic_E0456","","",N,N],[0,"__register_diagnostic_E0457","","",N,N],[0,"__register_diagnostic_E0514","","",N,N],[0,"__register_diagnostic_E0460","","",N,N],[0,"__register_diagnostic_E0461","","",N,N],[0,"__register_diagnostic_E0462","","",N,N],[0,"__register_diagnostic_E0464","","",N,N],[0,"__register_diagnostic_E0465","","",N,N],[0,"__register_diagnostic_E0519","","",N,N],[0,"__register_diagnostic_E0523","","",N,N],[0,"index_builder","rustc_metadata","Builder types for generating the \"item data\" section of the metadata. This section winds up looking like this:",N,N],[3,"IndexBuilder","rustc_metadata::index_builder","Builder that can encode new items, adding them into the index. Item encoding cannot be nested.",N,N],[12,"items","","",0,N],[12,"ecx","","",0,N],[3,"Untracked","","Leaks access to a value of type T without any tracking. This is suitable for ambiguous types like `usize`, which could represent tracked data (e.g., if you read it out of a HIR node) or might not (e.g., if it's an index). Adding in an `Untracked` is an assertion, essentially, that the data does not need to be tracked (or that read edges will be added by some other way).",N,N],[12,"0","","",1,N],[3,"FromId","","Newtype that can be used to package up misc data extracted from a HIR node that doesn't carry its own id. This will allow an arbitrary `T` to be passed in, but register a read on the given node-id.",N,N],[12,"0","","",2,N],[12,"1","","",2,N],[8,"DepGraphRead","","Trait used for data that can be passed from outside a dep-graph task.  The data must either be of some safe type, such as a `DefId` index, or implement the `read` method so that it can add a read of whatever dep-graph nodes are appropriate.",N,N],[10,"read","","",3,[[["self"],["tyctxt"]]]],[11,"deref","","",0,N],[11,"deref_mut","","",0,N],[11,"new","","",0,[[["encodecontext"]],["self"]]],[11,"record","","Emit the data for a def-id to the metadata. The function to emit the data is `op`, and it will be given `data` as arguments. This `record` function will call `op` to generate the `Entry` (which may point to other encoded information) and will then record the `Lazy<Entry>` for use in the index.",0,N],[11,"into_items","","",0,[[["self"]],["index"]]],[11,"read","","",1,[[["self"],["tyctxt"]]]],[11,"read","","",2,[[["self"],["tyctxt"]]]],[0,"index","rustc_metadata","",N,N],[3,"Index","rustc_metadata::index","While we are generating the metadata, we also track the position of each DefIndex. It is not required that all definitions appear in the metadata, nor that they are serialized in order, and therefore we first allocate the vector here and fill it with `u32::MAX`. Whenever an index is visited, we fill in the appropriate spot by calling `record_position`. We should never visit the same index twice.",N,N],[12,"positions","","",4,N],[3,"Unaligned","","",N,N],[12,"0","","",5,N],[5,"bytes_to_words","","",N,N],[5,"words_to_bytes","","",N,N],[11,"new","","",4,N],[11,"record","","",4,[[["self"],["defid"],["lazy",["entry"]]]]],[11,"record_index","","",4,[[["self"],["defindex"],["lazy",["entry"]]]]],[11,"write_index","","",4,[[["self"],["encoder"]],["lazyseq",["index"]]]],[11,"clone","","",5,[[["self"]],["self"]]],[11,"get","","",5,[[["self"]],["t"]]],[0,"encoder","rustc_metadata","",N,N],[3,"EncodeContext","rustc_metadata::encoder","",N,N],[12,"opaque","","",6,N],[12,"tcx","","",6,N],[12,"lazy_state","","",6,N],[12,"type_shorthands","","",6,N],[12,"predicate_shorthands","","",6,N],[12,"interpret_allocs","","",6,N],[12,"interpret_allocs_inverse","","",6,N],[12,"source_file_cache","","",6,N],[3,"EncodeVisitor","","",N,N],[12,"index","","",7,N],[3,"ImplVisitor","","",N,N],[12,"tcx","","",8,N],[12,"impls","","",8,N],[5,"encode_metadata","","",N,[[["tyctxt"]],["encodedmetadata"]]],[5,"get_repr_options","","",N,[[["tyctxt"],["defid"]],["reproptions"]]],[11,"emit_unit","","",6,[[["self"]],["result"]]],[11,"emit_usize","","",6,[[["self"],["usize"]],["result"]]],[11,"emit_u128","","",6,[[["self"],["u128"]],["result"]]],[11,"emit_u64","","",6,[[["self"],["u64"]],["result"]]],[11,"emit_u32","","",6,[[["self"],["u32"]],["result"]]],[11,"emit_u16","","",6,[[["self"],["u16"]],["result"]]],[11,"emit_u8","","",6,[[["self"],["u8"]],["result"]]],[11,"emit_isize","","",6,[[["self"],["isize"]],["result"]]],[11,"emit_i128","","",6,[[["self"],["i128"]],["result"]]],[11,"emit_i64","","",6,[[["self"],["i64"]],["result"]]],[11,"emit_i32","","",6,[[["self"],["i32"]],["result"]]],[11,"emit_i16","","",6,[[["self"],["i16"]],["result"]]],[11,"emit_i8","","",6,[[["self"],["i8"]],["result"]]],[11,"emit_bool","","",6,[[["self"],["bool"]],["result"]]],[11,"emit_f64","","",6,[[["self"],["f64"]],["result"]]],[11,"emit_f32","","",6,[[["self"],["f32"]],["result"]]],[11,"emit_char","","",6,[[["self"],["char"]],["result"]]],[11,"emit_str","","",6,[[["self"],["str"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["lazy"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["lazyseq"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["cratenum"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["defid"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["defindex"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["span"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["localdefid"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["ty"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["allocid"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["genericpredicates"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["fingerprint"]],["result"]]],[11,"specialized_encode","","",6,[[["self"],["clearcrosscrate"]],["result"]]],[11,"position","","",6,[[["self"]],["usize"]]],[11,"emit_node","","",6,[[["self"],["f"]],["r"]]],[11,"emit_lazy_distance","","",6,[[["self"],["usize"],["usize"]],["result"]]],[11,"lazy","","",6,[[["self"],["t"]],["lazy"]]],[11,"lazy_seq","","",6,[[["self"],["i"]],["lazyseq"]]],[11,"lazy_seq_ref","","",6,[[["self"],["i"]],["lazyseq"]]],[11,"tracked","","",6,N],[11,"encode_info_for_items","","",6,[[["self"]],["index"]]],[11,"encode_def_path_table","","",6,[[["self"]],["lazy",["defpathtable"]]]],[11,"encode_source_map","","",6,[[["self"]],["lazyseq",["sourcefile"]]]],[11,"encode_crate_root","","",6,[[["self"]],["lazy",["crateroot"]]]],[11,"nested_visit_map","","",7,[[["self"]],["nestedvisitormap"]]],[11,"visit_expr","","",7,[[["self"],["expr"]]]],[11,"visit_item","","",7,[[["self"],["item"]]]],[11,"visit_foreign_item","","",7,[[["self"],["foreignitem"]]]],[11,"visit_variant","","",7,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_generics","","",7,[[["self"],["generics"]]]],[11,"visit_ty","","",7,[[["self"],["ty"]]]],[11,"visit_macro_def","","",7,[[["self"],["macrodef"]]]],[11,"encode_fields","rustc_metadata::index_builder","",0,[[["self"],["defid"]]]],[11,"encode_info_for_generics","","",0,[[["self"],["generics"]]]],[11,"encode_info_for_ty","","",0,[[["self"],["ty"]]]],[11,"encode_info_for_expr","","",0,[[["self"],["expr"]]]],[11,"encode_addl_info_for_item","","In some cases, along with the item itself, we also encode some sub-items. Usually we want some info from the item so it's easier to do that here then to wait until we would encounter normally in the visitor walk.",0,[[["self"],["item"]]]],[11,"visit_item","rustc_metadata::encoder","",8,[[["self"],["item"]]]],[11,"visit_trait_item","","",8,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",8,[[["self"],["implitem"]]]],[0,"decoder","rustc_metadata","",N,N],[3,"DecodeContext","rustc_metadata::decoder","",N,N],[12,"opaque","","",9,N],[12,"cdata","","",9,N],[12,"sess","","",9,N],[12,"tcx","","",9,N],[12,"last_source_file_index","","",9,N],[12,"lazy_state","","",9,N],[12,"alloc_decoding_session","","",9,N],[5,"proc_macro_def_path_table","","Create the \"fake\" DefPathTable for a given proc macro crate.",N,N],[0,"__ty_decoder_impl","","",N,N],[11,"read_nil","","",9,[[["self"]],["result"]]],[11,"read_u128","","",9,[[["self"]],["result",["u128"]]]],[11,"read_u64","","",9,[[["self"]],["result",["u64"]]]],[11,"read_u32","","",9,[[["self"]],["result",["u32"]]]],[11,"read_u16","","",9,[[["self"]],["result",["u16"]]]],[11,"read_u8","","",9,[[["self"]],["result",["u8"]]]],[11,"read_usize","","",9,[[["self"]],["result",["usize"]]]],[11,"read_i128","","",9,[[["self"]],["result",["i128"]]]],[11,"read_i64","","",9,[[["self"]],["result",["i64"]]]],[11,"read_i32","","",9,[[["self"]],["result",["i32"]]]],[11,"read_i16","","",9,[[["self"]],["result",["i16"]]]],[11,"read_i8","","",9,[[["self"]],["result",["i8"]]]],[11,"read_isize","","",9,[[["self"]],["result",["isize"]]]],[11,"read_bool","","",9,[[["self"]],["result",["bool"]]]],[11,"read_f64","","",9,[[["self"]],["result",["f64"]]]],[11,"read_f32","","",9,[[["self"]],["result",["f32"]]]],[11,"read_char","","",9,[[["self"]],["result",["char"]]]],[11,"read_str","","",9,[[["self"]],["result",["cow"]]]],[11,"error","","",9,N],[11,"specialized_decode","","",9,[[["self"]],["result",["cratenum"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["ty"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["genericpredicates"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["substs"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["region"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["list"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["adtdef"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["list"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["canonicalvarinfos"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["const"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["allocation"]]]],[22,"","","",N,N],[8,"Metadata","","Abstract over the various ways one can create metadata decoders.",N,N],[10,"raw_bytes","","",10,N],[11,"cdata","","",10,[[["self"]],["option",["cratemetadata"]]]],[11,"sess","","",10,[[["self"]],["option",["session"]]]],[11,"tcx","","",10,[[["self"]],["option",["tyctxt"]]]],[11,"decoder","","",10,[[["self"],["usize"]],["decodecontext"]]],[11,"tcx","","",9,[[["self"]],["tyctxt"]]],[11,"cdata","","",9,[[["self"]],["cratemetadata"]]],[11,"read_lazy_distance","","",9,[[["self"],["usize"]],["result",["usize"]]]],[11,"tcx","","",9,[[["self"]],["tyctxt"]]],[11,"peek_byte","","",9,[[["self"]],["u8"]]],[11,"position","","",9,[[["self"]],["usize"]]],[11,"cached_ty_for_shorthand","","",9,[[["self"],["usize"],["f"]],["result",["ty"]]]],[11,"with_position","","",9,[[["self"],["usize"],["f"]],["r"]]],[11,"map_encoded_cnum_to_current","","",9,[[["self"],["cratenum"]],["cratenum"]]],[11,"specialized_decode","","",9,[[["self"]],["result",["lazy"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["lazyseq"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["defid"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["defindex"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["localdefid"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["allocid"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["span"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["fingerprint"]]]],[11,"specialized_decode","","",9,[[["self"]],["result",["clearcrosscrate"]]]],[0,"cstore_impl","rustc_metadata","",N,N],[5,"provide_extern","rustc_metadata::cstore_impl","",N,[[["providers"]]]],[5,"provide","","",N,[[["providers"]]]],[8,"IntoArgs","","",N,N],[10,"into_args","","",11,N],[0,"isolated_encoder","rustc_metadata","",N,N],[3,"IsolatedEncoder","rustc_metadata::isolated_encoder","The IsolatedEncoder provides facilities to write to crate metadata while making sure that anything going through it is also feed into an ICH hasher.",N,N],[12,"tcx","","",12,N],[12,"ecx","","",12,N],[11,"new","","",12,[[["encodecontext"]],["self"]]],[11,"lazy","","",12,[[["self"],["t"]],["lazy"]]],[11,"lazy_seq","","",12,[[["self"],["i"]],["lazyseq"]]],[11,"lazy_seq_ref","","",12,[[["self"],["i"]],["lazyseq"]]],[11,"lazy_seq_from_slice","","",12,N],[0,"schema","rustc_metadata","",N,N],[3,"Lazy","rustc_metadata::schema","A value of type T referred to by its absolute position in the metadata, and which can be decoded lazily.",N,N],[12,"position","","",13,N],[12,"_marker","","",13,N],[3,"LazySeq","","A sequence of type T referred to by its absolute position in the metadata and length, and which can be decoded lazily. The sequence is a single node for the purposes of `Lazy`.",N,N],[12,"len","","",14,N],[12,"position","","",14,N],[12,"_marker","","",14,N],[3,"CrateRoot","","",N,N],[12,"name","","",15,N],[12,"triple","","",15,N],[12,"extra_filename","","",15,N],[12,"hash","","",15,N],[12,"disambiguator","","",15,N],[12,"panic_strategy","","",15,N],[12,"edition","","",15,N],[12,"has_global_allocator","","",15,N],[12,"has_panic_handler","","",15,N],[12,"has_default_lib_allocator","","",15,N],[12,"plugin_registrar_fn","","",15,N],[12,"macro_derive_registrar","","",15,N],[12,"crate_deps","","",15,N],[12,"dylib_dependency_formats","","",15,N],[12,"lib_features","","",15,N],[12,"lang_items","","",15,N],[12,"lang_items_missing","","",15,N],[12,"native_libraries","","",15,N],[12,"foreign_modules","","",15,N],[12,"source_map","","",15,N],[12,"def_path_table","","",15,N],[12,"impls","","",15,N],[12,"exported_symbols","","",15,N],[12,"interpret_alloc_index","","",15,N],[12,"index","","",15,N],[12,"compiler_builtins","","",15,N],[12,"needs_allocator","","",15,N],[12,"needs_panic_runtime","","",15,N],[12,"no_builtins","","",15,N],[12,"panic_runtime","","",15,N],[12,"profiler_runtime","","",15,N],[12,"sanitizer_runtime","","",15,N],[3,"CrateDep","","",N,N],[12,"name","","",16,N],[12,"hash","","",16,N],[12,"kind","","",16,N],[12,"extra_filename","","",16,N],[3,"TraitImpls","","",N,N],[12,"trait_id","","",17,N],[12,"impls","","",17,N],[3,"Entry","","",N,N],[12,"kind","","",18,N],[12,"visibility","","",18,N],[12,"span","","",18,N],[12,"attributes","","",18,N],[12,"children","","",18,N],[12,"stability","","",18,N],[12,"deprecation","","",18,N],[12,"ty","","",18,N],[12,"inherent_impls","","",18,N],[12,"variances","","",18,N],[12,"generics","","",18,N],[12,"predicates","","",18,N],[12,"predicates_defined_on","","",18,N],[12,"mir","","",18,N],[3,"ConstQualif","","Additional data for EntryKind::Const and EntryKind::AssociatedConst",N,N],[12,"mir","","",19,N],[12,"ast_promotable","","",19,N],[3,"RenderedConst","","Contains a constant which has been rendered to a String. Used by rustdoc.",N,N],[12,"0","","",20,N],[3,"ModData","","",N,N],[12,"reexports","","",21,N],[3,"MacroDef","","",N,N],[12,"body","","",22,N],[12,"legacy","","",22,N],[3,"FnData","","",N,N],[12,"constness","","",23,N],[12,"arg_names","","",23,N],[12,"sig","","",23,N],[3,"VariantData","","",N,N],[12,"ctor_kind","","",24,N],[12,"discr","","",24,N],[12,"struct_ctor","","If this is a struct's only variant, this is the index of the \"struct ctor\" item.",24,N],[12,"ctor_sig","","If this is a tuple struct or variant ctor, this is its \"function\" signature.",24,N],[3,"TraitData","","",N,N],[12,"unsafety","","",25,N],[12,"paren_sugar","","",25,N],[12,"has_auto_impl","","",25,N],[12,"super_predicates","","",25,N],[3,"ImplData","","",N,N],[12,"polarity","","",26,N],[12,"defaultness","","",26,N],[12,"parent_impl","","",26,N],[12,"coerce_unsized_info","","This is `Some` only for impls of `CoerceUnsized`.",26,N],[12,"trait_ref","","",26,N],[3,"MethodData","","",N,N],[12,"fn_data","","",27,N],[12,"container","","",27,N],[12,"has_self","","",27,N],[3,"ClosureData","","",N,N],[12,"sig","","",28,N],[3,"GeneratorData","","",N,N],[12,"layout","","",29,N],[3,"EncodedExportedSymbols","","",N,N],[12,"position","","",30,N],[12,"len","","",30,N],[4,"LazyState","","Encoding / decoding state for `Lazy` and `LazySeq`.",N,N],[13,"NoNode","","Outside of a metadata node.",31,N],[13,"NodeStart","","Inside a metadata node, and before any `Lazy` or `LazySeq`. The position is that of the node itself.",31,N],[13,"Previous","","Inside a metadata node, with a previous `Lazy` or `LazySeq`. The position is a conservative estimate of where that previous `Lazy` / `LazySeq` would end (see their comments).",31,N],[4,"EntryKind","","",N,N],[13,"Const","","",32,N],[13,"ImmStatic","","",32,N],[13,"MutStatic","","",32,N],[13,"ForeignImmStatic","","",32,N],[13,"ForeignMutStatic","","",32,N],[13,"ForeignMod","","",32,N],[13,"ForeignType","","",32,N],[13,"GlobalAsm","","",32,N],[13,"Type","","",32,N],[13,"Existential","","",32,N],[13,"Enum","","",32,N],[13,"Field","","",32,N],[13,"Variant","","",32,N],[13,"Struct","","",32,N],[13,"Union","","",32,N],[13,"Fn","","",32,N],[13,"ForeignFn","","",32,N],[13,"Mod","","",32,N],[13,"MacroDef","","",32,N],[13,"Closure","","",32,N],[13,"Generator","","",32,N],[13,"Trait","","",32,N],[13,"Impl","","",32,N],[13,"Method","","",32,N],[13,"AssociatedType","","",32,N],[13,"AssociatedExistential","","",32,N],[13,"AssociatedConst","","",32,N],[4,"AssociatedContainer","","Describes whether the container of an associated item is a trait or an impl and whether, in a trait, it has a default, or an in impl, whether it's marked \"default\".",N,N],[13,"TraitRequired","","",33,N],[13,"TraitWithDefault","","",33,N],[13,"ImplDefault","","",33,N],[13,"ImplFinal","","",33,N],[5,"rustc_version","","",N,[[],["string"]]],[17,"METADATA_VERSION","","Metadata encoding version. NB: increment this if you change the format of metadata such that the rustc version can't be found to compare with `rustc_version()`.",N,N],[17,"METADATA_HEADER","","Metadata header which includes `METADATA_VERSION`. To get older versions of rustc to ignore this metadata, there are 4 zero bytes at the start, which are treated as a length of 0 by old compilers.",N,N],[17,"TAG_VALID_SPAN","","",N,N],[17,"TAG_INVALID_SPAN","","",N,N],[11,"with_position","","",13,[[["usize"]],["lazy"]]],[11,"min_size","","Returns the minimum encoded size of a value of type `T`.",13,[[],["usize"]]],[11,"clone","","",13,[[["self"]],["self"]]],[11,"hash_stable","","",13,[[["self"],["ctx"],["stablehasher"]]]],[11,"empty","","",14,[[],["lazyseq"]]],[11,"with_position_and_length","","",14,[[["usize"],["usize"]],["lazyseq"]]],[11,"min_size","","Returns the minimum encoded size of `length` values of type `T`.",14,[[["usize"]],["usize"]]],[11,"clone","","",14,[[["self"]],["self"]]],[11,"hash_stable","","",14,[[["self"],["ctx"],["stablehasher"]]]],[11,"clone","","",31,[[["self"]],["lazystate"]]],[11,"eq","","",31,[[["self"],["lazystate"]],["bool"]]],[11,"ne","","",31,[[["self"],["lazystate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",31,N],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"encode","","",15,[[["self"],["__s"]],["result"]]],[11,"decode","","",15,[[["__d"]],["result",["crateroot"]]]],[11,"encode","","",16,[[["self"],["__s"]],["result"]]],[11,"decode","","",16,[[["__d"]],["result",["cratedep"]]]],[11,"hash_stable","","",16,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",17,[[["self"],["__s"]],["result"]]],[11,"decode","","",17,[[["__d"]],["result",["traitimpls"]]]],[11,"hash_stable","","",17,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",18,[[["self"],["__s"]],["result"]]],[11,"decode","","",18,[[["__d"]],["result",["entry"]]]],[11,"hash_stable","","",18,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",32,[[["self"]],["entrykind"]]],[11,"encode","","",32,[[["self"],["__s"]],["result"]]],[11,"decode","","",32,[[["__d"]],["result",["entrykind"]]]],[11,"hash_stable","","",32,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",19,[[["self"]],["constqualif"]]],[11,"encode","","",19,[[["self"],["__s"]],["result"]]],[11,"decode","","",19,[[["__d"]],["result",["constqualif"]]]],[11,"hash_stable","","",19,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",20,[[["self"],["__s"]],["result"]]],[11,"decode","","",20,[[["__d"]],["result",["renderedconst"]]]],[11,"hash_stable","","",20,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",21,[[["self"],["__s"]],["result"]]],[11,"decode","","",21,[[["__d"]],["result",["moddata"]]]],[11,"hash_stable","","",21,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",22,[[["self"],["__s"]],["result"]]],[11,"decode","","",22,[[["__d"]],["result",["macrodef"]]]],[11,"hash_stable","","",22,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",23,[[["self"],["__s"]],["result"]]],[11,"decode","","",23,[[["__d"]],["result",["fndata"]]]],[11,"hash_stable","","",23,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",24,[[["self"],["__s"]],["result"]]],[11,"decode","","",24,[[["__d"]],["result",["variantdata"]]]],[11,"hash_stable","","",24,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",25,[[["self"],["__s"]],["result"]]],[11,"decode","","",25,[[["__d"]],["result",["traitdata"]]]],[11,"hash_stable","","",25,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",26,[[["self"],["__s"]],["result"]]],[11,"decode","","",26,[[["__d"]],["result",["impldata"]]]],[11,"hash_stable","","",26,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",33,[[["self"]],["associatedcontainer"]]],[11,"encode","","",33,[[["self"],["__s"]],["result"]]],[11,"decode","","",33,[[["__d"]],["result",["associatedcontainer"]]]],[11,"hash_stable","","",33,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"with_def_id","","",33,[[["self"],["defid"]],["associateditemcontainer"]]],[11,"defaultness","","",33,[[["self"]],["defaultness"]]],[11,"encode","","",27,[[["self"],["__s"]],["result"]]],[11,"decode","","",27,[[["__d"]],["result",["methoddata"]]]],[11,"hash_stable","","",27,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",28,[[["self"],["__s"]],["result"]]],[11,"decode","","",28,[[["__d"]],["result",["closuredata"]]]],[11,"hash_stable","","",28,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",29,[[["self"],["__s"]],["result"]]],[11,"decode","","",29,[[["__d"]],["result",["generatordata"]]]],[11,"hash_stable","","",29,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"encode","","",30,[[["self"],["__s"]],["result"]]],[11,"decode","","",30,[[["__d"]],["result",["encodedexportedsymbols"]]]],[0,"native_libs","rustc_metadata","",N,N],[3,"Collector","rustc_metadata::native_libs","",N,N],[12,"tcx","","",34,N],[12,"libs","","",34,N],[5,"collect","","",N,[[["tyctxt"]],["vec",["nativelibrary"]]]],[5,"relevant_lib","","",N,[[["session"],["nativelibrary"]],["bool"]]],[11,"visit_item","","",34,[[["self"],["item"]]]],[11,"visit_trait_item","","",34,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",34,[[["self"],["implitem"]]]],[11,"register_native_lib","","",34,[[["self"],["option",["span"]],["nativelibrary"]]]],[11,"process_command_line","","",34,[[["self"]]]],[0,"link_args","rustc_metadata","",N,N],[3,"Collector","rustc_metadata::link_args","",N,N],[12,"args","","",35,N],[5,"collect","","",N,[[["tyctxt"]],["vec",["string"]]]],[11,"visit_item","","",35,[[["self"],["item"]]]],[11,"visit_trait_item","","",35,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",35,[[["self"],["implitem"]]]],[11,"add_link_args","","",35,[[["self"],["str"]]]],[0,"foreign_modules","rustc_metadata","",N,N],[3,"Collector","rustc_metadata::foreign_modules","",N,N],[12,"tcx","","",36,N],[12,"modules","","",36,N],[5,"collect","","",N,[[["tyctxt"]],["vec",["foreignmodule"]]]],[11,"visit_item","","",36,[[["self"],["item"]]]],[11,"visit_trait_item","","",36,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",36,[[["self"],["implitem"]]]],[0,"creader","rustc_metadata","Validates all used crates and extern libraries and loads their metadata",N,N],[3,"Library","rustc_metadata::creader","",N,N],[12,"dylib","","",37,N],[12,"rlib","","",37,N],[12,"rmeta","","",37,N],[12,"metadata","","",37,N],[3,"CrateLoader","","",N,N],[12,"sess","","",38,N],[12,"cstore","","",38,N],[12,"local_crate_name","","",38,N],[3,"ExtensionCrate","","",N,N],[12,"metadata","","",39,N],[12,"dylib","","",39,N],[12,"target_only","","",39,N],[4,"PMDSource","","",N,N],[13,"Registered","","",40,N],[13,"Owned","","",40,N],[4,"LoadResult","","",N,N],[13,"Previous","","",41,N],[13,"Loaded","","",41,N],[4,"LoadError","","",N,N],[13,"LocatorError","","",42,N],[5,"dump_crates","","",N,[[["cstore"]]]],[11,"deref","","",40,[[["self"]],["metadatablob"]]],[11,"report","","",42,N],[11,"new","","",38,[[["session"],["cstore"],["str"]],["self"]]],[11,"existing_match","","",38,[[["self"],["symbol"],["option",["svh"]],["pathkind"]],["option",["cratenum"]]]],[11,"verify_no_symbol_conflicts","","",38,[[["self"],["span"],["crateroot"]]]],[11,"register_crate","","",38,N],[11,"resolve_crate","","",38,[[["self"],["option"],["symbol"],["symbol"],["option",["svh"]],["option",["str"]],["span"],["pathkind"],["depkind"]],["result",["loaderror"]]]],[11,"load","","",38,[[["self"],["context"]],["option",["loadresult"]]]],[11,"update_extern_crate","","",38,[[["self"],["cratenum"],["externcrate"],["fxhashset"]]]],[11,"resolve_crate_deps","","",38,[[["self"],["option"],["crateroot"],["metadatablob"],["cratenum"],["span"],["depkind"]],["cratenummap"]]],[11,"read_extension_crate","","",38,[[["self"],["span"],["symbol"],["symbol"]],["extensioncrate"]]],[11,"load_derive_macros","","Load custom derive macros.",38,[[["self"],["crateroot"],["option",["pathbuf"]],["span"]],["vec"]]],[11,"find_plugin_registrar","","Look for a plugin registrar. Returns library path, crate SVH and DefIndex of the registrar function.",38,[[["self"],["span"],["str"]],["option"]]],[11,"inject_panic_runtime","","",38,[[["self"],["crate"]]]],[11,"inject_sanitizer_runtime","","",38,[[["self"]]]],[11,"inject_profiler_runtime","","",38,[[["self"]]]],[11,"inject_allocator_crate","","",38,[[["self"],["crate"]]]],[11,"inject_dependency_if","","",38,[[["self"],["cratenum"],["str"],["fn"]]]],[11,"postprocess","","",38,[[["self"],["crate"]]]],[11,"process_extern_crate","","",38,[[["self"],["item"],["definitions"]],["cratenum"]]],[11,"process_path_extern","","",38,[[["self"],["symbol"],["span"]],["cratenum"]]],[11,"maybe_process_path_extern","","",38,[[["self"],["symbol"],["span"]],["option",["cratenum"]]]],[0,"cstore","rustc_metadata","",N,N],[3,"NativeLibrary","rustc_metadata::cstore","",N,N],[12,"kind","","",43,N],[12,"name","","",43,N],[12,"cfg","","",43,N],[12,"foreign_module","","",43,N],[12,"wasm_import_module","","",43,N],[4,"NativeLibraryKind","","",N,N],[13,"NativeStatic","","native static library (.a archive)",44,N],[13,"NativeStaticNobundle","","native static library, which doesn't get bundled into .rlibs",44,N],[13,"NativeFramework","","macOS-specific",44,N],[13,"NativeUnknown","","default way to specify a dynamic library",44,N],[4,"LinkagePreference","","",N,N],[13,"RequireDynamic","","",45,N],[13,"RequireStatic","","",45,N],[3,"CrateSource","","Where a crate came from on the local filesystem. One of these three options must be non-None.",N,N],[12,"dylib","","",46,N],[12,"rlib","","",46,N],[12,"rmeta","","",46,N],[4,"LibSource","","",N,N],[13,"Some","","",47,N],[13,"MetadataOnly","","",47,N],[13,"None","","",47,N],[3,"ForeignModule","","",N,N],[12,"foreign_items","","",48,N],[12,"def_id","","",48,N],[6,"MetadataRef","","",N,N],[3,"MetadataBlob","","",N,N],[12,"0","","",49,N],[3,"ImportedSourceFile","","Holds information about a syntax_pos::SourceFile imported from another crate. See `imported_source_files()` for more information.",N,N],[12,"original_start_pos","","This SourceFile's byte-offset within the source_map of its original crate",50,N],[12,"original_end_pos","","The end of this SourceFile within the source_map of its original crate",50,N],[12,"translated_source_file","","The imported SourceFile's representation within the local source_map",50,N],[3,"CrateMetadata","","",N,N],[12,"name","","Original name of the crate.",51,N],[12,"imported_name","","Name of the crate as imported.  I.e. if imported with `extern crate foo as bar;` this will be `bar`.",51,N],[12,"extern_crate","","Information about the extern crate that caused this crate to be loaded. If this is `None`, then the crate was injected (e.g., by the allocator)",51,N],[12,"blob","","",51,N],[12,"cnum_map","","",51,N],[12,"cnum","","",51,N],[12,"dependencies","","",51,N],[12,"source_map_import_info","","",51,N],[12,"alloc_decoding_state","","Used for decoding interpret::AllocIds in a cached & thread-safe manner.",51,N],[12,"root","","",51,N],[12,"def_path_table","","For each public item in this crate, we encode a key.  When the crate is loaded, we read all the keys and put them in this hashmap, which gives the reverse mapping.  This allows us to quickly retrace a `DefPath`, which is needed for incremental compilation support.",51,N],[12,"trait_impls","","",51,N],[12,"dep_kind","","",51,N],[12,"source","","",51,N],[12,"proc_macros","","",51,N],[3,"CStore","","",N,N],[12,"metas","","",52,N],[12,"extern_mod_crate_map","","Map from NodeId's of local extern crate statements to crate numbers",52,N],[12,"metadata_loader","","",52,N],[4,"LoadedMacro","","",N,N],[13,"MacroDef","","",53,N],[13,"ProcMacro","","",53,N],[5,"provide","","",N,[[["providers"]]]],[5,"provide_extern","","",N,[[["providers"]]]],[6,"CrateNumMap","","",N,N],[11,"new","","",52,[[["box",["metadataloader"]]],["cstore"]]],[11,"alloc_new_crate_num","","",52,[[["self"]],["cratenum"]]],[11,"get_crate_data","","",52,[[["self"],["cratenum"]],["lrc",["cratemetadata"]]]],[11,"set_crate_data","","",52,[[["self"],["cratenum"],["lrc",["cratemetadata"]]]]],[11,"iter_crate_data","","",52,[[["self"],["i"]]]],[11,"crate_dependencies_in_rpo","","",52,[[["self"],["cratenum"]],["vec",["cratenum"]]]],[11,"push_dependencies_in_postorder","","",52,[[["self"],["vec"],["cratenum"]]]],[11,"do_postorder_cnums_untracked","","",52,[[["self"]],["vec",["cratenum"]]]],[11,"add_extern_mod_stmt_cnum","","",52,[[["self"],["nodeid"],["cratenum"]]]],[11,"do_extern_mod_stmt_cnum","","",52,[[["self"],["nodeid"]],["option",["cratenum"]]]],[0,"dynamic_lib","rustc_metadata","Dynamic library facilities.",N,N],[3,"DynamicLibrary","rustc_metadata::dynamic_lib","",N,N],[12,"handle","","",54,N],[0,"dl","","",N,N],[5,"open","rustc_metadata::dynamic_lib::dl","",N,[[["option",["osstr"]]],["result",["string"]]]],[5,"open_global_now","","",N,[[["osstr"]],["result",["string"]]]],[5,"open_external","","",N,N],[5,"open_internal","","",N,N],[5,"check_for_errors_in","","",N,[[["f"]],["result",["string"]]]],[5,"symbol","","",N,N],[5,"close","","",N,N],[11,"drop","rustc_metadata::dynamic_lib","",54,[[["self"]]]],[11,"open","","Lazily open a dynamic library. When passed None it gives a handle to the calling process",54,[[["option",["path"]]],["result",["dynamiclibrary","string"]]]],[11,"open_global_now","","Load a dynamic library into the global namespace (RTLD_GLOBAL on Unix) and do it now (don't use RTLD_LAZY on Unix).",54,[[["path"]],["result",["dynamiclibrary","string"]]]],[11,"envvar","","Returns the environment variable for this process's dynamic library search path",54,[[],["str"]]],[11,"symbol","","Accesses the value at the symbol of the dynamic library.",54,[[["self"],["str"]],["result",["string"]]]],[0,"locator","rustc_metadata","Finds crate binaries and loads their metadata",N,N],[3,"CrateMismatch","rustc_metadata::locator","",N,N],[12,"path","","",55,N],[12,"got","","",55,N],[3,"Context","","",N,N],[12,"sess","","",56,N],[12,"span","","",56,N],[12,"ident","","",56,N],[12,"crate_name","","",56,N],[12,"hash","","",56,N],[12,"extra_filename","","",56,N],[12,"target","","",56,N],[12,"triple","","",56,N],[12,"filesearch","","",56,N],[12,"root","","",56,N],[12,"rejected_via_hash","","",56,N],[12,"rejected_via_triple","","",56,N],[12,"rejected_via_kind","","",56,N],[12,"rejected_via_version","","",56,N],[12,"rejected_via_filename","","",56,N],[12,"should_match_name","","",56,N],[12,"is_proc_macro","","",56,N],[12,"metadata_loader","","",56,N],[3,"CratePaths","","",N,N],[12,"ident","","",57,N],[12,"dylib","","",57,N],[12,"rlib","","",57,N],[12,"rmeta","","",57,N],[4,"CrateFlavor","","",N,N],[13,"Rlib","","",58,N],[13,"Rmeta","","",58,N],[13,"Dylib","","",58,N],[5,"get_metadata_section","","",N,[[["target"],["crateflavor"],["path"],["metadataloader"]],["result",["metadatablob","string"]]]],[5,"get_metadata_section_imp","","",N,[[["target"],["crateflavor"],["path"],["metadataloader"]],["result",["metadatablob","string"]]]],[5,"list_file_metadata","","",N,[[["target"],["path"],["metadataloader"],["write"]],["result"]]],[11,"clone","","",58,[[["self"]],["crateflavor"]]],[11,"eq","","",58,[[["self"],["crateflavor"]],["bool"]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result"]]],[11,"paths","","",57,[[["self"]],["vec",["pathbuf"]]]],[11,"maybe_load_library_crate","","",56,[[["self"]],["option",["library"]]]],[11,"report_errs","","",56,N],[11,"find_library_crate","","",56,[[["self"],["str"],["fxhashset"]],["option",["library"]]]],[11,"extract_one","","",56,[[["self"],["fxhashmap",["pathbuf","pathkind"]],["crateflavor"],["option"]],["option"]]],[11,"crate_matches","","",56,[[["self"],["metadatablob"],["path"]],["option",["svh"]]]],[11,"dylibname","","",56,N],[11,"staticlibname","","",56,N],[11,"find_commandline_library","","",56,[[["self"],["locs"]],["option",["library"]]]],[17,"DIAGNOSTICS","rustc_metadata","",N,N],[11,"from","rustc_metadata::index_builder","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","rustc_metadata::index","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"lookup","rustc_metadata::schema","Given the metadata, extract out the offset of a particular DefIndex (if any).",14,N],[11,"from","rustc_metadata::encoder","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"specialized_encode","","",6,[[["self"],["t"]],["result"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"encode_variances_of","rustc_metadata::isolated_encoder","",12,[[["self"],["defid"]],["lazyseq",["variance"]]]],[11,"encode_item_type","","",12,[[["self"],["defid"]],["lazy",["ty"]]]],[11,"encode_enum_variant_info","","Encode data for the given variant of the given ADT. The index of the variant is untracked: this is ok because we will have to lookup the adt-def by its id, and that gives us the right to access any information in the adt-def (including, e.g., the length of the various vectors).",12,N],[11,"encode_info_for_mod","","",12,[[["self"],["fromid"]],["entry"]]],[11,"encode_field","","Encode data for the given field of the given variant of the given ADT. The indices of the variant/field are untracked: this is ok because we will have to lookup the adt-def by its id, and that gives us the right to access any information in the adt-def (including, e.g., the length of the various vectors).",12,N],[11,"encode_struct_ctor","","",12,N],[11,"encode_generics","","",12,[[["self"],["defid"]],["lazy",["generics"]]]],[11,"encode_predicates","","",12,[[["self"],["defid"]],["lazy",["genericpredicates"]]]],[11,"encode_predicates_defined_on","","",12,[[["self"],["defid"]],["lazy",["genericpredicates"]]]],[11,"encode_info_for_trait_item","","",12,[[["self"],["defid"]],["entry"]]],[11,"metadata_output_only","","",12,[[["self"]],["bool"]]],[11,"const_qualif","","",12,[[["self"],["u8"],["bodyid"]],["constqualif"]]],[11,"encode_info_for_impl_item","","",12,[[["self"],["defid"]],["entry"]]],[11,"encode_fn_arg_names_for_body","","",12,[[["self"],["bodyid"]],["lazyseq",["name"]]]],[11,"encode_fn_arg_names","","",12,N],[11,"encode_optimized_mir","","",12,[[["self"],["defid"]],["option",["lazy"]]]],[11,"encode_inherent_implementations","","",12,[[["self"],["defid"]],["lazyseq",["defindex"]]]],[11,"encode_stability","","",12,[[["self"],["defid"]],["option",["lazy"]]]],[11,"encode_deprecation","","",12,[[["self"],["defid"]],["option",["lazy"]]]],[11,"encode_rendered_const_for_body","","",12,[[["self"],["bodyid"]],["lazy",["renderedconst"]]]],[11,"encode_info_for_item","","",12,N],[11,"encode_info_for_macro_def","","Serialize the text of exported macros",12,[[["self"],["macrodef"]],["entry"]]],[11,"encode_info_for_ty_param","","",12,N],[11,"encode_info_for_closure","","",12,[[["self"],["defid"]],["entry"]]],[11,"encode_info_for_anon_const","","",12,[[["self"],["defid"]],["entry"]]],[11,"encode_attributes","","",12,N],[11,"encode_native_libraries","","",12,N],[11,"encode_foreign_modules","","",12,N],[11,"encode_crate_deps","","",12,N],[11,"encode_lib_features","","",12,N],[11,"encode_lang_items","","",12,N],[11,"encode_lang_items_missing","","",12,N],[11,"encode_impls","","Encodes an index, mapping each trait to its (local) implementations.",12,N],[11,"encode_exported_symbols","","",12,N],[11,"encode_dylib_dependency_formats","","",12,N],[11,"encode_info_for_foreign_item","","",12,N],[11,"from","rustc_metadata::decoder","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"specialized_decode","","",9,[[["self"]],["result"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"decode","rustc_metadata::schema","",13,[[["self"],["m"]],["t"]]],[11,"decode","","",14,N],[11,"is_compatible","rustc_metadata::cstore","",49,[[["self"]],["bool"]]],[11,"get_rustc_version","","",49,[[["self"]],["string"]]],[11,"get_root","","",49,[[["self"]],["crateroot"]]],[11,"list_crate_metadata","","",49,[[["self"],["write"]],["result"]]],[11,"to_def","rustc_metadata::schema","",32,[[["self"],["defid"]],["option",["def"]]]],[11,"is_proc_macro","rustc_metadata::cstore","",51,[[["self"],["defindex"]],["bool"]]],[11,"maybe_entry","","",51,[[["self"],["defindex"]],["option",["lazy"]]]],[11,"entry","","",51,[[["self"],["defindex"]],["entry"]]],[11,"local_def_id","","",51,[[["self"],["defindex"]],["defid"]]],[11,"item_name","","",51,[[["self"],["defindex"]],["internedstring"]]],[11,"get_def","","",51,[[["self"],["defindex"]],["option",["def"]]]],[11,"get_span","","",51,[[["self"],["defindex"],["session"]],["span"]]],[11,"get_trait_def","","",51,[[["self"],["defindex"],["session"]],["traitdef"]]],[11,"get_variant","","",51,[[["self"],["tyctxt"],["entry"],["defindex"],["adtkind"]],["variantdef"]]],[11,"get_adt_def","","",51,[[["self"],["defindex"],["tyctxt"]],["adtdef"]]],[11,"get_predicates","","",51,[[["self"],["defindex"],["tyctxt"]],["genericpredicates"]]],[11,"get_predicates_defined_on","","",51,[[["self"],["defindex"],["tyctxt"]],["genericpredicates"]]],[11,"get_super_predicates","","",51,[[["self"],["defindex"],["tyctxt"]],["genericpredicates"]]],[11,"get_generics","","",51,[[["self"],["defindex"],["session"]],["generics"]]],[11,"get_type","","",51,[[["self"],["defindex"],["tyctxt"]],["ty"]]],[11,"get_stability","","",51,[[["self"],["defindex"]],["option",["stability"]]]],[11,"get_deprecation","","",51,[[["self"],["defindex"]],["option",["deprecation"]]]],[11,"get_visibility","","",51,[[["self"],["defindex"]],["visibility"]]],[11,"get_impl_data","","",51,[[["self"],["defindex"]],["impldata"]]],[11,"get_parent_impl","","",51,[[["self"],["defindex"]],["option",["defid"]]]],[11,"get_impl_polarity","","",51,[[["self"],["defindex"]],["implpolarity"]]],[11,"get_impl_defaultness","","",51,[[["self"],["defindex"]],["defaultness"]]],[11,"get_coerce_unsized_info","","",51,[[["self"],["defindex"]],["option",["coerceunsizedinfo"]]]],[11,"get_impl_trait","","",51,[[["self"],["defindex"],["tyctxt"]],["option",["traitref"]]]],[11,"get_lib_features","","Iterates over all the stability attributes in the given crate.",51,[[["self"]],["vec"]]],[11,"get_lang_items","","Iterates over the language items in the given crate.",51,[[["self"]],["vec"]]],[11,"each_child_of_item","","Iterates over each child of the given item.",51,[[["self"],["defindex"],["f"],["session"]]]],[11,"const_is_rvalue_promotable_to_static","","",51,[[["self"],["defindex"]],["bool"]]],[11,"is_item_mir_available","","",51,[[["self"],["defindex"]],["bool"]]],[11,"maybe_get_optimized_mir","","",51,[[["self"],["tyctxt"],["defindex"]],["option",["mir"]]]],[11,"mir_const_qualif","","",51,[[["self"],["defindex"]],["u8"]]],[11,"get_associated_item","","",51,[[["self"],["defindex"]],["associateditem"]]],[11,"get_item_variances","","",51,[[["self"],["defindex"]],["vec",["variance"]]]],[11,"get_ctor_kind","","",51,[[["self"],["defindex"]],["ctorkind"]]],[11,"get_struct_ctor_def_id","","",51,[[["self"],["defindex"]],["option",["defid"]]]],[11,"get_item_attrs","","",51,[[["self"],["defindex"],["session"]],["lrc"]]],[11,"get_struct_field_names","","",51,[[["self"],["defindex"]],["vec",["name"]]]],[11,"get_attributes","","",51,[[["self"],["entry"],["session"]],["vec",["attribute"]]]],[11,"reverse_translate_def_id","","",51,[[["self"],["defid"]],["option",["defid"]]]],[11,"get_inherent_implementations_for_type","","",51,[[["self"],["defindex"]],["vec",["defid"]]]],[11,"get_implementations_for_trait","","",51,[[["self"],["option",["defid"]],["vec"]]]],[11,"get_trait_of_item","","",51,[[["self"],["defindex"]],["option",["defid"]]]],[11,"get_native_libraries","","",51,[[["self"],["session"]],["vec",["nativelibrary"]]]],[11,"get_foreign_modules","","",51,[[["self"],["session"]],["vec",["foreignmodule"]]]],[11,"get_dylib_dependency_formats","","",51,[[["self"]],["vec"]]],[11,"get_missing_lang_items","","",51,[[["self"]],["vec",["langitem"]]]],[11,"get_fn_arg_names","","",51,[[["self"],["defindex"]],["vec",["name"]]]],[11,"exported_symbols","","",51,[[["self"],["tyctxt"]],["vec"]]],[11,"get_rendered_const","","",51,[[["self"],["defindex"]],["string"]]],[11,"get_macro","","",51,[[["self"],["defindex"]],["macrodef"]]],[11,"is_const_fn","","",51,[[["self"],["defindex"]],["bool"]]],[11,"is_foreign_item","","",51,[[["self"],["defindex"]],["bool"]]],[11,"fn_sig","","",51,[[["self"],["defindex"],["tyctxt"]],["polyfnsig"]]],[11,"def_key","","",51,[[["self"],["defindex"]],["defkey"]]],[11,"def_path","","",51,[[["self"],["defindex"]],["defpath"]]],[11,"def_path_hash","","",51,[[["self"],["defindex"]],["defpathhash"]]],[11,"imported_source_files","","Imports the source_map from an external crate into the source_map of the crate currently being compiled (the \"local crate\").",51,[[["self"],["sourcemap"]],["readguard",["vec"]]]],[11,"export_macros_untracked","","",52,[[["self"],["cratenum"]]]],[11,"dep_kind_untracked","","",52,[[["self"],["cratenum"]],["depkind"]]],[11,"crate_edition_untracked","","",52,[[["self"],["cratenum"]],["edition"]]],[11,"struct_field_names_untracked","","",52,[[["self"],["defid"]],["vec",["name"]]]],[11,"item_children_untracked","","",52,[[["self"],["defid"],["session"]],["vec",["export"]]]],[11,"load_macro_untracked","","",52,[[["self"],["defid"],["session"]],["loadedmacro"]]],[11,"associated_item_cloned_untracked","","",52,[[["self"],["defid"]],["associateditem"]]],[11,"crate_data_as_rc_any","","",52,[[["self"],["cratenum"]],["lrc",["any"]]]],[11,"item_generics_cloned_untracked","","",52,[[["self"],["defid"],["session"]],["generics"]]],[11,"crate_name_untracked","","",52,[[["self"],["cratenum"]],["symbol"]]],[11,"crate_disambiguator_untracked","","",52,[[["self"],["cratenum"]],["cratedisambiguator"]]],[11,"crate_hash_untracked","","",52,[[["self"],["cratenum"]],["svh"]]],[11,"def_key","","Returns the `DefKey` for a given `DefId`. This indicates the parent `DefId` as well as some idea of what kind of data the `DefId` refers to.",52,[[["self"],["defid"]],["defkey"]]],[11,"def_path","","",52,[[["self"],["defid"]],["defpath"]]],[11,"def_path_hash","","",52,[[["self"],["defid"]],["defpathhash"]]],[11,"def_path_table","","",52,[[["self"],["cratenum"]],["lrc",["defpathtable"]]]],[11,"crates_untracked","","",52,[[["self"]],["vec",["cratenum"]]]],[11,"extern_mod_stmt_cnum_untracked","","",52,[[["self"],["nodeid"]],["option",["cratenum"]]]],[11,"postorder_cnums_untracked","","",52,[[["self"]],["vec",["cratenum"]]]],[11,"encode_metadata","","",52,[[["self"],["tyctxt"]],["encodedmetadata"]]],[11,"metadata_encoding_version","","",52,N],[11,"from","rustc_metadata::isolated_encoder","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_metadata::schema","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"encode","","",13,[[["self"],["e"]],["result"]]],[11,"decode","","",13,[[["d"]],["result"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from_ok","","",13,[[["t"]],["t"]]],[11,"map_same","","",13,[[["self"],["f"]],["t"]]],[11,"to_owned","","",14,[[["self"]],["t"]]],[11,"clone_into","","",14,N],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"encode","","",14,[[["self"],["e"]],["result"]]],[11,"decode","","",14,[[["d"]],["result"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from_ok","","",14,[[["t"]],["t"]]],[11,"map_same","","",14,[[["self"],["f"]],["t"]]],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"encode","","",15,[[["self"],["e"]],["result"]]],[11,"decode","","",15,[[["d"]],["result"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from_ok","","",15,[[["t"]],["t"]]],[11,"map_same","","",15,[[["self"],["f"]],["t"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"encode","","",16,[[["self"],["e"]],["result"]]],[11,"decode","","",16,[[["d"]],["result"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from_ok","","",16,[[["t"]],["t"]]],[11,"map_same","","",16,[[["self"],["f"]],["t"]]],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"encode","","",17,[[["self"],["e"]],["result"]]],[11,"decode","","",17,[[["d"]],["result"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from_ok","","",17,[[["t"]],["t"]]],[11,"map_same","","",17,[[["self"],["f"]],["t"]]],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"encode","","",18,[[["self"],["e"]],["result"]]],[11,"decode","","",18,[[["d"]],["result"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from_ok","","",18,[[["t"]],["t"]]],[11,"map_same","","",18,[[["self"],["f"]],["t"]]],[11,"to_owned","","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"encode","","",19,[[["self"],["e"]],["result"]]],[11,"decode","","",19,[[["d"]],["result"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"from_ok","","",19,[[["t"]],["t"]]],[11,"map_same","","",19,[[["self"],["f"]],["t"]]],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"encode","","",20,[[["self"],["e"]],["result"]]],[11,"decode","","",20,[[["d"]],["result"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from_ok","","",20,[[["t"]],["t"]]],[11,"map_same","","",20,[[["self"],["f"]],["t"]]],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"encode","","",21,[[["self"],["e"]],["result"]]],[11,"decode","","",21,[[["d"]],["result"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from_ok","","",21,[[["t"]],["t"]]],[11,"map_same","","",21,[[["self"],["f"]],["t"]]],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"encode","","",22,[[["self"],["e"]],["result"]]],[11,"decode","","",22,[[["d"]],["result"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from_ok","","",22,[[["t"]],["t"]]],[11,"map_same","","",22,[[["self"],["f"]],["t"]]],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"encode","","",23,[[["self"],["e"]],["result"]]],[11,"decode","","",23,[[["d"]],["result"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from_ok","","",23,[[["t"]],["t"]]],[11,"map_same","","",23,[[["self"],["f"]],["t"]]],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"encode","","",24,[[["self"],["e"]],["result"]]],[11,"decode","","",24,[[["d"]],["result"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"from_ok","","",24,[[["t"]],["t"]]],[11,"map_same","","",24,[[["self"],["f"]],["t"]]],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"encode","","",25,[[["self"],["e"]],["result"]]],[11,"decode","","",25,[[["d"]],["result"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from_ok","","",25,[[["t"]],["t"]]],[11,"map_same","","",25,[[["self"],["f"]],["t"]]],[11,"from","","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"encode","","",26,[[["self"],["e"]],["result"]]],[11,"decode","","",26,[[["d"]],["result"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"from_ok","","",26,[[["t"]],["t"]]],[11,"map_same","","",26,[[["self"],["f"]],["t"]]],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"encode","","",27,[[["self"],["e"]],["result"]]],[11,"decode","","",27,[[["d"]],["result"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from_ok","","",27,[[["t"]],["t"]]],[11,"map_same","","",27,[[["self"],["f"]],["t"]]],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"encode","","",28,[[["self"],["e"]],["result"]]],[11,"decode","","",28,[[["d"]],["result"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from_ok","","",28,[[["t"]],["t"]]],[11,"map_same","","",28,[[["self"],["f"]],["t"]]],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"encode","","",29,[[["self"],["e"]],["result"]]],[11,"decode","","",29,[[["d"]],["result"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from_ok","","",29,[[["t"]],["t"]]],[11,"map_same","","",29,[[["self"],["f"]],["t"]]],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"encode","","",30,[[["self"],["e"]],["result"]]],[11,"decode","","",30,[[["d"]],["result"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"from_ok","","",30,[[["t"]],["t"]]],[11,"map_same","","",30,[[["self"],["f"]],["t"]]],[11,"to_owned","","",31,[[["self"]],["t"]]],[11,"clone_into","","",31,N],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"from_ok","","",31,[[["t"]],["t"]]],[11,"map_same","","",31,[[["self"],["f"]],["t"]]],[11,"to_owned","","",32,[[["self"]],["t"]]],[11,"clone_into","","",32,N],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"encode","","",32,[[["self"],["e"]],["result"]]],[11,"decode","","",32,[[["d"]],["result"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from_ok","","",32,[[["t"]],["t"]]],[11,"map_same","","",32,[[["self"],["f"]],["t"]]],[11,"to_owned","","",33,[[["self"]],["t"]]],[11,"clone_into","","",33,N],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"encode","","",33,[[["self"],["e"]],["result"]]],[11,"decode","","",33,[[["d"]],["result"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from_ok","","",33,[[["t"]],["t"]]],[11,"map_same","","",33,[[["self"],["f"]],["t"]]],[11,"from","rustc_metadata::native_libs","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"from_ok","","",34,[[["t"]],["t"]]],[11,"map_same","","",34,[[["self"],["f"]],["t"]]],[11,"from","rustc_metadata::link_args","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"from_ok","","",35,[[["t"]],["t"]]],[11,"map_same","","",35,[[["self"],["f"]],["t"]]],[11,"from","rustc_metadata::foreign_modules","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"from_ok","","",36,[[["t"]],["t"]]],[11,"map_same","","",36,[[["self"],["f"]],["t"]]],[11,"from","rustc_metadata::creader","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"from_ok","","",37,[[["t"]],["t"]]],[11,"map_same","","",37,[[["self"],["f"]],["t"]]],[11,"from","","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"from_ok","","",38,[[["t"]],["t"]]],[11,"map_same","","",38,[[["self"],["f"]],["t"]]],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"from_ok","","",39,[[["t"]],["t"]]],[11,"map_same","","",39,[[["self"],["f"]],["t"]]],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from_ok","","",40,[[["t"]],["t"]]],[11,"map_same","","",40,[[["self"],["f"]],["t"]]],[11,"from","","",41,[[["t"]],["t"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"not_found","","",41,[[["str"],["str"]],["e"]]],[11,"from_ok","","",41,[[["t"]],["t"]]],[11,"map_same","","",41,[[["self"],["f"]],["t"]]],[11,"from","","",42,[[["t"]],["t"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"not_found","","",42,[[["str"],["str"]],["e"]]],[11,"from_ok","","",42,[[["t"]],["t"]]],[11,"map_same","","",42,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_metadata::cstore","",43,[[["self"]],["t"]]],[11,"clone_into","","",43,N],[11,"from","","",43,[[["t"]],["t"]]],[11,"into","","",43,[[["self"]],["u"]]],[11,"try_from","","",43,[[["u"]],["result"]]],[11,"borrow","","",43,[[["self"]],["t"]]],[11,"try_into","","",43,[[["self"]],["result"]]],[11,"borrow_mut","","",43,[[["self"]],["t"]]],[11,"get_type_id","","",43,[[["self"]],["typeid"]]],[11,"encode","","",43,[[["self"],["e"]],["result"]]],[11,"decode","","",43,[[["d"]],["result"]]],[11,"not_found","","",43,[[["str"],["str"]],["e"]]],[11,"from_ok","","",43,[[["t"]],["t"]]],[11,"map_same","","",43,[[["self"],["f"]],["t"]]],[11,"hash_stable","","",45,N],[11,"hash_stable","","",43,N],[11,"hash_stable","","",46,N],[11,"hash_stable","","",44,N],[11,"hash_stable","","",48,N],[11,"assert_receiver_is_total_eq","","",44,N],[11,"partial_cmp","","",44,[[["self"],["nativelibrarykind"]],["option",["ordering"]]]],[11,"cmp","","",44,[[["self"],["nativelibrarykind"]],["ordering"]]],[11,"eq","","",46,[[["self"],["cratesource"]],["bool"]]],[11,"ne","","",46,[[["self"],["cratesource"]],["bool"]]],[11,"eq","","",47,[[["self"],["libsource"]],["bool"]]],[11,"ne","","",47,[[["self"],["libsource"]],["bool"]]],[11,"eq","","",44,[[["self"],["nativelibrarykind"]],["bool"]]],[11,"eq","","",45,[[["self"],["linkagepreference"]],["bool"]]],[11,"hash","","",44,N],[11,"hash","","",48,N],[11,"encode","","",48,[[["self"],["__s"]],["result"]]],[11,"encode","","",45,[[["self"],["__s"]],["result"]]],[11,"encode","","",44,[[["self"],["__s"]],["result"]]],[11,"encode","","",43,[[["self"],["__s"]],["result"]]],[11,"decode","","",48,[[["__d"]],["result",["foreignmodule"]]]],[11,"decode","","",43,[[["__d"]],["result",["nativelibrary"]]]],[11,"decode","","",45,[[["__d"]],["result",["linkagepreference"]]]],[11,"decode","","",44,[[["__d"]],["result",["nativelibrarykind"]]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result",["error"]]]],[11,"clone","","",48,[[["self"]],["foreignmodule"]]],[11,"clone","","",46,[[["self"]],["cratesource"]]],[11,"clone","","",47,[[["self"]],["libsource"]]],[11,"clone","","",45,[[["self"]],["linkagepreference"]]],[11,"clone","","",44,[[["self"]],["nativelibrarykind"]]],[11,"clone","","",43,[[["self"]],["nativelibrary"]]],[11,"to_owned","","",44,[[["self"]],["t"]]],[11,"clone_into","","",44,N],[11,"from","","",44,[[["t"]],["t"]]],[11,"into","","",44,[[["self"]],["u"]]],[11,"try_from","","",44,[[["u"]],["result"]]],[11,"borrow","","",44,[[["self"]],["t"]]],[11,"try_into","","",44,[[["self"]],["result"]]],[11,"borrow_mut","","",44,[[["self"]],["t"]]],[11,"get_type_id","","",44,[[["self"]],["typeid"]]],[11,"encode","","",44,[[["self"],["e"]],["result"]]],[11,"decode","","",44,[[["d"]],["result"]]],[11,"not_found","","",44,[[["str"],["str"]],["e"]]],[11,"from_ok","","",44,[[["t"]],["t"]]],[11,"map_same","","",44,[[["self"],["f"]],["t"]]],[11,"to_owned","","",45,[[["self"]],["t"]]],[11,"clone_into","","",45,N],[11,"from","","",45,[[["t"]],["t"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"encode","","",45,[[["self"],["e"]],["result"]]],[11,"decode","","",45,[[["d"]],["result"]]],[11,"not_found","","",45,[[["str"],["str"]],["e"]]],[11,"from_ok","","",45,[[["t"]],["t"]]],[11,"map_same","","",45,[[["self"],["f"]],["t"]]],[11,"to_owned","","",46,[[["self"]],["t"]]],[11,"clone_into","","",46,N],[11,"from","","",46,[[["t"]],["t"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"not_found","","",46,[[["str"],["str"]],["e"]]],[11,"from_ok","","",46,[[["t"]],["t"]]],[11,"map_same","","",46,[[["self"],["f"]],["t"]]],[11,"is_some","","",47,[[["self"]],["bool"]]],[11,"option","","",47,[[["self"]],["option",["pathbuf"]]]],[11,"to_owned","","",47,[[["self"]],["t"]]],[11,"clone_into","","",47,N],[11,"from","","",47,[[["t"]],["t"]]],[11,"into","","",47,[[["self"]],["u"]]],[11,"try_from","","",47,[[["u"]],["result"]]],[11,"borrow","","",47,[[["self"]],["t"]]],[11,"try_into","","",47,[[["self"]],["result"]]],[11,"borrow_mut","","",47,[[["self"]],["t"]]],[11,"get_type_id","","",47,[[["self"]],["typeid"]]],[11,"not_found","","",47,[[["str"],["str"]],["e"]]],[11,"from_ok","","",47,[[["t"]],["t"]]],[11,"map_same","","",47,[[["self"],["f"]],["t"]]],[11,"to_owned","","",48,[[["self"]],["t"]]],[11,"clone_into","","",48,N],[11,"from","","",48,[[["t"]],["t"]]],[11,"into","","",48,[[["self"]],["u"]]],[11,"try_from","","",48,[[["u"]],["result"]]],[11,"borrow","","",48,[[["self"]],["t"]]],[11,"try_into","","",48,[[["self"]],["result"]]],[11,"borrow_mut","","",48,[[["self"]],["t"]]],[11,"get_type_id","","",48,[[["self"]],["typeid"]]],[11,"encode","","",48,[[["self"],["e"]],["result"]]],[11,"decode","","",48,[[["d"]],["result"]]],[11,"not_found","","",48,[[["str"],["str"]],["e"]]],[11,"from_ok","","",48,[[["t"]],["t"]]],[11,"map_same","","",48,[[["self"],["f"]],["t"]]],[11,"from","","",49,[[["t"]],["t"]]],[11,"into","","",49,[[["self"]],["u"]]],[11,"try_from","","",49,[[["u"]],["result"]]],[11,"borrow","","",49,[[["self"]],["t"]]],[11,"try_into","","",49,[[["self"]],["result"]]],[11,"borrow_mut","","",49,[[["self"]],["t"]]],[11,"get_type_id","","",49,[[["self"]],["typeid"]]],[11,"not_found","","",49,[[["str"],["str"]],["e"]]],[11,"from_ok","","",49,[[["t"]],["t"]]],[11,"map_same","","",49,[[["self"],["f"]],["t"]]],[11,"from","","",50,[[["t"]],["t"]]],[11,"into","","",50,[[["self"]],["u"]]],[11,"try_from","","",50,[[["u"]],["result"]]],[11,"borrow","","",50,[[["self"]],["t"]]],[11,"try_into","","",50,[[["self"]],["result"]]],[11,"borrow_mut","","",50,[[["self"]],["t"]]],[11,"get_type_id","","",50,[[["self"]],["typeid"]]],[11,"not_found","","",50,[[["str"],["str"]],["e"]]],[11,"from_ok","","",50,[[["t"]],["t"]]],[11,"map_same","","",50,[[["self"],["f"]],["t"]]],[11,"from","","",51,[[["t"]],["t"]]],[11,"into","","",51,[[["self"]],["u"]]],[11,"try_from","","",51,[[["u"]],["result"]]],[11,"borrow","","",51,[[["self"]],["t"]]],[11,"try_into","","",51,[[["self"]],["result"]]],[11,"borrow_mut","","",51,[[["self"]],["t"]]],[11,"get_type_id","","",51,[[["self"]],["typeid"]]],[11,"not_found","","",51,[[["str"],["str"]],["e"]]],[11,"from_ok","","",51,[[["t"]],["t"]]],[11,"map_same","","",51,[[["self"],["f"]],["t"]]],[11,"from","","",52,[[["t"]],["t"]]],[11,"into","","",52,[[["self"]],["u"]]],[11,"try_from","","",52,[[["u"]],["result"]]],[11,"borrow","","",52,[[["self"]],["t"]]],[11,"try_into","","",52,[[["self"]],["result"]]],[11,"borrow_mut","","",52,[[["self"]],["t"]]],[11,"get_type_id","","",52,[[["self"]],["typeid"]]],[11,"not_found","","",52,[[["str"],["str"]],["e"]]],[11,"from_ok","","",52,[[["t"]],["t"]]],[11,"map_same","","",52,[[["self"],["f"]],["t"]]],[11,"from","","",53,[[["t"]],["t"]]],[11,"into","","",53,[[["self"]],["u"]]],[11,"try_from","","",53,[[["u"]],["result"]]],[11,"borrow","","",53,[[["self"]],["t"]]],[11,"try_into","","",53,[[["self"]],["result"]]],[11,"borrow_mut","","",53,[[["self"]],["t"]]],[11,"get_type_id","","",53,[[["self"]],["typeid"]]],[11,"not_found","","",53,[[["str"],["str"]],["e"]]],[11,"from_ok","","",53,[[["t"]],["t"]]],[11,"map_same","","",53,[[["self"],["f"]],["t"]]],[11,"from","rustc_metadata::dynamic_lib","",54,[[["t"]],["t"]]],[11,"into","","",54,[[["self"]],["u"]]],[11,"try_from","","",54,[[["u"]],["result"]]],[11,"borrow","","",54,[[["self"]],["t"]]],[11,"try_into","","",54,[[["self"]],["result"]]],[11,"borrow_mut","","",54,[[["self"]],["t"]]],[11,"get_type_id","","",54,[[["self"]],["typeid"]]],[11,"not_found","","",54,[[["str"],["str"]],["e"]]],[11,"from_ok","","",54,[[["t"]],["t"]]],[11,"map_same","","",54,[[["self"],["f"]],["t"]]],[11,"from","rustc_metadata::locator","",55,[[["t"]],["t"]]],[11,"into","","",55,[[["self"]],["u"]]],[11,"try_from","","",55,[[["u"]],["result"]]],[11,"borrow","","",55,[[["self"]],["t"]]],[11,"try_into","","",55,[[["self"]],["result"]]],[11,"borrow_mut","","",55,[[["self"]],["t"]]],[11,"get_type_id","","",55,[[["self"]],["typeid"]]],[11,"not_found","","",55,[[["str"],["str"]],["e"]]],[11,"from_ok","","",55,[[["t"]],["t"]]],[11,"map_same","","",55,[[["self"],["f"]],["t"]]],[11,"from","","",56,[[["t"]],["t"]]],[11,"into","","",56,[[["self"]],["u"]]],[11,"try_from","","",56,[[["u"]],["result"]]],[11,"borrow","","",56,[[["self"]],["t"]]],[11,"try_into","","",56,[[["self"]],["result"]]],[11,"borrow_mut","","",56,[[["self"]],["t"]]],[11,"get_type_id","","",56,[[["self"]],["typeid"]]],[11,"not_found","","",56,[[["str"],["str"]],["e"]]],[11,"from_ok","","",56,[[["t"]],["t"]]],[11,"map_same","","",56,[[["self"],["f"]],["t"]]],[11,"from","","",57,[[["t"]],["t"]]],[11,"into","","",57,[[["self"]],["u"]]],[11,"try_from","","",57,[[["u"]],["result"]]],[11,"borrow","","",57,[[["self"]],["t"]]],[11,"try_into","","",57,[[["self"]],["result"]]],[11,"borrow_mut","","",57,[[["self"]],["t"]]],[11,"get_type_id","","",57,[[["self"]],["typeid"]]],[11,"not_found","","",57,[[["str"],["str"]],["e"]]],[11,"from_ok","","",57,[[["t"]],["t"]]],[11,"map_same","","",57,[[["self"],["f"]],["t"]]],[11,"to_owned","","",58,[[["self"]],["t"]]],[11,"clone_into","","",58,N],[11,"from","","",58,[[["t"]],["t"]]],[11,"to_string","","",58,[[["self"]],["string"]]],[11,"into","","",58,[[["self"]],["u"]]],[11,"try_from","","",58,[[["u"]],["result"]]],[11,"borrow","","",58,[[["self"]],["t"]]],[11,"try_into","","",58,[[["self"]],["result"]]],[11,"borrow_mut","","",58,[[["self"]],["t"]]],[11,"get_type_id","","",58,[[["self"]],["typeid"]]],[11,"not_found","","",58,[[["str"],["str"]],["e"]]],[11,"from_ok","","",58,[[["t"]],["t"]]],[11,"map_same","","",58,[[["self"],["f"]],["t"]]]],"paths":[[3,"IndexBuilder"],[3,"Untracked"],[3,"FromId"],[8,"DepGraphRead"],[3,"Index"],[3,"Unaligned"],[3,"EncodeContext"],[3,"EncodeVisitor"],[3,"ImplVisitor"],[3,"DecodeContext"],[8,"Metadata"],[8,"IntoArgs"],[3,"IsolatedEncoder"],[3,"Lazy"],[3,"LazySeq"],[3,"CrateRoot"],[3,"CrateDep"],[3,"TraitImpls"],[3,"Entry"],[3,"ConstQualif"],[3,"RenderedConst"],[3,"ModData"],[3,"MacroDef"],[3,"FnData"],[3,"VariantData"],[3,"TraitData"],[3,"ImplData"],[3,"MethodData"],[3,"ClosureData"],[3,"GeneratorData"],[3,"EncodedExportedSymbols"],[4,"LazyState"],[4,"EntryKind"],[4,"AssociatedContainer"],[3,"Collector"],[3,"Collector"],[3,"Collector"],[3,"Library"],[3,"CrateLoader"],[3,"ExtensionCrate"],[4,"PMDSource"],[4,"LoadResult"],[4,"LoadError"],[3,"NativeLibrary"],[4,"NativeLibraryKind"],[4,"LinkagePreference"],[3,"CrateSource"],[4,"LibSource"],[3,"ForeignModule"],[3,"MetadataBlob"],[3,"ImportedSourceFile"],[3,"CrateMetadata"],[3,"CStore"],[4,"LoadedMacro"],[3,"DynamicLibrary"],[3,"CrateMismatch"],[3,"Context"],[3,"CratePaths"],[4,"CrateFlavor"]]};
searchIndex["rustc_metadata_utils"]={"doc":"","items":[[5,"validate_crate_name","rustc_metadata_utils","",N,[[["option",["session"]],["str"],["option",["span"]]]]]],"paths":[]};
searchIndex["rustc_mir"]={"doc":"Rust MIR: a lowered representation of Rust. Also: an experiment!","items":[[5,"provide","rustc_mir","",N,[[["providers"]]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0001","rustc_mir::diagnostics","",N,N],[0,"__register_diagnostic_E0002","","",N,N],[0,"__register_diagnostic_E0004","","",N,N],[0,"__register_diagnostic_E0005","","",N,N],[0,"__register_diagnostic_E0007","","",N,N],[0,"__register_diagnostic_E0008","","",N,N],[0,"__register_diagnostic_E0009","","",N,N],[0,"__register_diagnostic_E0030","","",N,N],[0,"__register_diagnostic_E0158","","",N,N],[0,"__register_diagnostic_E0162","","",N,N],[0,"__register_diagnostic_E0165","","",N,N],[0,"__register_diagnostic_E0170","","",N,N],[0,"__register_diagnostic_E0297","","",N,N],[0,"__register_diagnostic_E0301","","",N,N],[0,"__register_diagnostic_E0302","","",N,N],[0,"__register_diagnostic_E0303","","",N,N],[0,"__register_diagnostic_E0010","","",N,N],[0,"__register_diagnostic_E0013","","",N,N],[0,"__register_diagnostic_E0015","","",N,N],[0,"__register_diagnostic_E0017","","",N,N],[0,"__register_diagnostic_E0019","","",N,N],[0,"__register_diagnostic_E0022","","",N,N],[0,"__register_diagnostic_E0133","","",N,N],[0,"__register_diagnostic_E0373","","",N,N],[0,"__register_diagnostic_E0381","","",N,N],[0,"__register_diagnostic_E0382","","",N,N],[0,"__register_diagnostic_E0383","","",N,N],[0,"__register_diagnostic_E0384","","",N,N],[0,"__register_diagnostic_E0387","","",N,N],[0,"__register_diagnostic_E0388","","",N,N],[0,"__register_diagnostic_E0389","","",N,N],[0,"__register_diagnostic_E0161","","",N,N],[0,"__register_diagnostic_E0492","","",N,N],[0,"__register_diagnostic_E0499","","",N,N],[0,"__register_diagnostic_E0500","","",N,N],[0,"__register_diagnostic_E0501","","",N,N],[0,"__register_diagnostic_E0502","","",N,N],[0,"__register_diagnostic_E0503","","",N,N],[0,"__register_diagnostic_E0504","","",N,N],[0,"__register_diagnostic_E0505","","",N,N],[0,"__register_diagnostic_E0506","","",N,N],[0,"__register_diagnostic_E0507","","",N,N],[0,"__register_diagnostic_E0508","","",N,N],[0,"__register_diagnostic_E0509","","",N,N],[0,"__register_diagnostic_E0579","","",N,N],[0,"__register_diagnostic_E0595","","",N,N],[0,"__register_diagnostic_E0596","","",N,N],[0,"__register_diagnostic_E0597","","",N,N],[0,"__register_diagnostic_E0626","","",N,N],[0,"__register_diagnostic_E0712","","",N,N],[0,"__register_diagnostic_E0493","","",N,N],[0,"__register_diagnostic_E0524","","",N,N],[0,"__register_diagnostic_E0526","","",N,N],[0,"__register_diagnostic_E0594","","",N,N],[0,"__register_diagnostic_E0598","","",N,N],[0,"__register_diagnostic_E0625","","",N,N],[0,"borrow_check","rustc_mir","This query borrow-checks the MIR to (further) ensure it is not broken.",N,N],[3,"MirBorrowckCtxt","rustc_mir::borrow_check","",N,N],[12,"tcx","","",0,N],[12,"mir","","",0,N],[12,"mir_def_id","","",0,N],[12,"move_data","","",0,N],[12,"location_table","","Map from MIR `Location` to `LocationIndex`; created when MIR borrowck begins.",0,N],[12,"param_env","","",0,N],[12,"movable_generator","","",0,N],[12,"locals_are_invalidated_at_exit","","This keeps track of whether local variables are free-ed when the function exits even without a `StorageDead`, which appears to be the case for constants.",0,N],[12,"access_place_error_reported","","This field keeps track of when borrow errors are reported in the access_place function so that there is no duplicate reporting. This field cannot also be used for the conflicting borrow errors that is handled by the `reservation_error_reported` field as the inclusion of the `Span` type (while required to mute some errors) stops the muting of the reservation errors.",0,N],[12,"reservation_error_reported","","This field keeps track of when borrow conflict errors are reported for reservations, so that we don't report seemingly duplicate errors for corresponding activations",0,N],[12,"moved_error_reported","","This field keeps track of errors reported in the checking of moved variables, so that we don't report seemingly duplicate errors.",0,N],[12,"errors_buffer","","Errors to be reported buffer",0,N],[12,"used_mut","","This field keeps track of all the local variables that are declared mut and are mutated. Used for the warning issued by an unused mutable local variable.",0,N],[12,"used_mut_upvars","","If the function we're checking is a closure, then we'll need to report back the list of mutable upvars that have been used. This field keeps track of them.",0,N],[12,"nonlexical_regioncx","","Non-lexical region inference context, if NLL is enabled.  This contains the results from region inference and lets us e.g. find out which CFG points are contained in each borrow region.",0,N],[12,"borrow_set","","The set of borrows extracted from the MIR",0,N],[12,"dominators","","Dominators for MIR",0,N],[3,"RootPlace","","",N,N],[12,"place","","",1,N],[12,"is_local_mutation_allowed","","",1,N],[3,"SeenTy","","A simple linked-list threaded up the stack of recursive calls in `visit_terminator_drop`.",N,N],[12,"0","","",2,N],[3,"Context","","",N,N],[12,"kind","","",3,N],[12,"loc","","",3,N],[4,"MutateMode","","",N,N],[13,"JustWrite","","",4,N],[13,"WriteAndRead","","",4,N],[4,"ArtificialField","","",N,N],[13,"Discriminant","","",5,N],[13,"ArrayLength","","",5,N],[4,"ShallowOrDeep","","",N,N],[13,"Shallow","","From the RFC: \"A shallow access means that the immediate fields reached at P are accessed, but references or pointers found within are not dereferenced. Right now, the only access that is shallow is an assignment like `x = ...;`, which would be a shallow write of `x`.\"",6,N],[13,"Deep","","From the RFC: \"A deep access means that all data reachable through the given place may be invalidated or accesses by this action.\"",6,N],[4,"ReadOrWrite","","Kind of access to a value: read or write (For informational purposes only)",N,N],[13,"Read","","From the RFC: \"A read means that the existing data may be read, but will not be changed.\"",7,N],[13,"Write","","From the RFC: \"A write means that the data may be mutated to new values or otherwise invalidated (for example, it could be de-initialized, as in a move operation).",7,N],[13,"Reservation","","For two-phase borrows, we distinguish a reservation (which is treated like a Read) from an activation (which is treated like a write), and each of those is furthermore distinguished from Reads/Writes above.",7,N],[13,"Activation","","",7,N],[4,"ReadKind","","Kind of read access to a value (For informational purposes only)",N,N],[13,"Borrow","","",8,N],[13,"Copy","","",8,N],[4,"WriteKind","","Kind of write access to a value (For informational purposes only)",N,N],[13,"StorageDeadOrDrop","","",9,N],[13,"MutableBorrow","","",9,N],[13,"Mutate","","",9,N],[13,"Move","","",9,N],[4,"LocalMutationIsAllowed","","When checking permissions for a place access, this flag is used to indicate that an immutable local place can be mutated.",N,N],[13,"Yes","","",10,N],[13,"ExceptUpvars","","We want use of immutable upvars to cause a \"write to immutable upvar\" error, not an \"reassignment\" error.",10,N],[13,"No","","",10,N],[4,"InitializationRequiringAction","","",N,N],[13,"Update","","",11,N],[13,"Borrow","","",11,N],[13,"Use","","",11,N],[13,"Assignment","","",11,N],[4,"NoMovePathFound","","",N,N],[13,"ReachedStatic","","",12,N],[4,"Overlap","","The degree of overlap between 2 places for borrow-checking.",N,N],[13,"Arbitrary","","The places might partially overlap - in this case, we give up and say that they might conflict. This occurs when different fields of a union are borrowed. For example, if `u` is a union, we have no way of telling how disjoint `u.a.x` and `a.b.y` are.",13,N],[13,"EqualOrDisjoint","","The places have the same type, and are either completely disjoint or equal - i.e. they can't \"partially\" overlap as can occur with unions. This is the \"base case\" on which we recur for extensions of the place.",13,N],[13,"Disjoint","","The places are disjoint, so we know all extensions of them will also be disjoint.",13,N],[4,"ContextKind","","",N,N],[13,"Activation","","",14,N],[13,"AssignLhs","","",14,N],[13,"AssignRhs","","",14,N],[13,"SetDiscrim","","",14,N],[13,"InlineAsm","","",14,N],[13,"SwitchInt","","",14,N],[13,"Drop","","",14,N],[13,"DropAndReplace","","",14,N],[13,"CallOperator","","",14,N],[13,"CallOperand","","",14,N],[13,"CallDest","","",14,N],[13,"Assert","","",14,N],[13,"Yield","","",14,N],[13,"ReadForMatch","","",14,N],[13,"StorageDead","","",14,N],[5,"provide","","",N,[[["providers"]]]],[5,"mir_borrowck","","",N,[[["tyctxt"],["defid"]],["borrowcheckresult"]]],[5,"do_mir_borrowck","","",N,[[["inferctxt"],["mir"],["defid"]],["borrowcheckresult"]]],[0,"borrow_set","","",N,N],[3,"BorrowSet","rustc_mir::borrow_check::borrow_set","",N,N],[12,"borrows","","The fundamental map relating bitvector indexes to the borrows in the MIR.",15,N],[12,"location_map","","Each borrow is also uniquely identified in the MIR by the `Location` of the assignment statement in which it appears on the right hand side; we map each such location to the corresponding `BorrowIndex`.",15,N],[12,"activation_map","","Locations which activate borrows. NOTE: A given location may activate more than one borrow in the future when more general two-phase borrow support is introduced, but for now we only need to store one borrow index",15,N],[12,"region_map","","Every borrow has a region; this maps each such regions back to its borrow-indexes.",15,N],[12,"local_map","","Map from local to all the borrows on that local",15,N],[12,"locals_state_at_exit","","",15,N],[3,"BorrowData","","",N,N],[12,"reserve_location","","Location where the borrow reservation starts. In many cases, this will be equal to the activation location but not always.",16,N],[12,"activation_location","","Location where the borrow is activated.",16,N],[12,"kind","","What kind of borrow this is",16,N],[12,"region","","The region for which this borrow is live",16,N],[12,"borrowed_place","","Place from which we are borrowing",16,N],[12,"assigned_place","","Place to which the borrow was stored",16,N],[3,"GatherBorrows","","",N,N],[12,"tcx","","",17,N],[12,"mir","","",17,N],[12,"idx_vec","","",17,N],[12,"location_map","","",17,N],[12,"activation_map","","",17,N],[12,"region_map","","",17,N],[12,"local_map","","",17,N],[12,"pending_activations","","When we encounter a 2-phase borrow statement, it will always be assigning into a temporary TEMP:",17,N],[12,"locals_state_at_exit","","",17,N],[4,"TwoPhaseActivation","","Location where a two phase borrow is activated, if a borrow is in fact a two phase borrow.",N,N],[13,"NotTwoPhase","","",18,N],[13,"NotActivated","","",18,N],[13,"ActivatedAt","","",18,N],[4,"LocalsStateAtExit","","",N,N],[13,"AllAreInvalidated","","",19,N],[13,"SomeAreInvalidated","","",19,N],[12,"has_storage_dead_or_moved","rustc_mir::borrow_check::borrow_set::LocalsStateAtExit","",19,N],[11,"index","rustc_mir::borrow_check::borrow_set","",15,[[["self"],["borrowindex"]],["borrowdata"]]],[11,"clone","","",18,[[["self"]],["twophaseactivation"]]],[11,"eq","","",18,[[["self"],["twophaseactivation"]],["bool"]]],[11,"ne","","",18,[[["self"],["twophaseactivation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",18,N],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"build","","",19,[[["bool"],["mir"],["movedata"]],["self"]]],[11,"build","","",15,[[["tyctxt"],["mir"],["bool"],["movedata"]],["self"]]],[11,"activations_at_location","","",15,N],[11,"visit_assign","","",17,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_place","","",17,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_rvalue","","",17,[[["self"],["rvalue"],["location"]]]],[11,"visit_statement","","",17,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"allow_two_phase_borrow","","Returns true if the borrow represented by `kind` is allowed to be split into separate Reservation and Activation phases.",17,[[["self"],["borrowkind"]],["bool"]]],[11,"insert_as_pending_if_two_phase","","If this is a two-phase borrow, then we will record it as \"pending\" until we find the activating use.",17,[[["self"],["location"],["place"],["region"],["borrowkind"],["borrowindex"]]]],[0,"error_reporting","rustc_mir::borrow_check","",N,N],[3,"IncludingDowncast","rustc_mir::borrow_check::error_reporting","",N,N],[12,"0","","",20,N],[4,"UseSpans","","",N,N],[13,"ClosureUse","","",21,N],[12,"args_span","rustc_mir::borrow_check::error_reporting::UseSpans","",21,N],[12,"var_span","","",21,N],[13,"OtherUse","rustc_mir::borrow_check::error_reporting","",21,N],[11,"report_use_of_moved_or_uninitialized","rustc_mir::borrow_check","",0,N],[11,"report_move_out_while_borrowed","","",0,N],[11,"report_use_while_mutably_borrowed","","",0,N],[11,"report_conflicting_borrow","","",0,N],[11,"report_borrowed_value_does_not_live_long_enough","","",0,N],[11,"report_local_value_does_not_live_long_enough","","",0,[[["self"],["context"],["string"],["lrc"],["borrowdata"],["borrowcontainspointreason"],["span"],["span"],["option"]],["diagnosticbuilder"]]],[11,"report_thread_local_value_does_not_live_long_enough","","",0,[[["self"],["span"],["span"]],["diagnosticbuilder"]]],[11,"report_temporary_value_does_not_live_long_enough","","",0,[[["self"],["context"],["lrc"],["borrowdata"],["borrowcontainspointreason"],["span"],["span"]],["diagnosticbuilder"]]],[11,"get_moved_indexes","","",0,[[["self"],["context"],["movepathindex"]],["vec",["moveoutindex"]]]],[11,"report_illegal_mutation_of_borrowed","","",0,N],[11,"report_illegal_reassignment","","Reports an illegal reassignment; for example, an assignment to (part of) a non-`mut` local that occurs potentially after that local has already been initialized. `place` is the path being assigned; `err_place` is a place providing a reason why `place` is not mutable (e.g. the non-`mut` local `x` in an assignment to `x.f`).",0,N],[11,"describe_place","","",0,[[["self"],["place"]],["option",["string"]]]],[11,"describe_place_with_options","","",0,[[["self"],["place"],["includingdowncast"]],["option",["string"]]]],[11,"append_place_to_string","","",0,[[["self"],["place"],["string"],["bool"],["includingdowncast"]],["result"]]],[11,"append_local_to_string","","",0,[[["self"],["local"],["string"]],["result"]]],[11,"describe_field","","",0,[[["self"],["place"],["field"]],["string"]]],[11,"describe_field_from_ty","","",0,[[["self"],["ty"],["field"]],["string"]]],[11,"retrieve_type_for_place","","",0,[[["self"],["place"]],["option",["ty"]]]],[11,"is_place_thread_local","","Check if a place is a thread-local static.",0,[[["self"],["place"]],["bool"]]],[11,"clone","rustc_mir::borrow_check::error_reporting","",21,[[["self"]],["usespans"]]],[11,"eq","","",21,[[["self"],["usespans"]],["bool"]]],[11,"ne","","",21,[[["self"],["usespans"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"args_or_use","","",21,[[["self"]],["span"]]],[11,"var_or_use","","",21,[[["self"]],["span"]]],[11,"args_span_label","","",21,N],[11,"var_span_label","","",21,N],[11,"for_closure","","",21,[[["self"]],["bool"]]],[11,"or_else","","",21,[[["self"],["f"]],["self"]]],[11,"move_spans","rustc_mir::borrow_check","Finds the spans associated to a move or copy of move_place at location.",0,[[["self"],["place"],["location"]],["usespans"]]],[11,"borrow_spans","","Finds the span of arguments of a closure (within `maybe_closure_span`) and its usage of the local assigned at `location`. This is done by searching in statements succeeding `location` and originating from `maybe_closure_span`.",0,[[["self"],["span"],["location"]],["usespans"]]],[11,"retrieve_borrow_spans","","Helper to retrieve span(s) of given borrow from the current MIR representation",0,[[["self"],["borrowdata"]],["usespans"]]],[0,"flows","","Manages the dataflow bits required for borrowck.",N,N],[3,"Flows","rustc_mir::borrow_check::flows","",N,N],[12,"borrows","","",22,N],[12,"uninits","","",22,N],[12,"ever_inits","","",22,N],[12,"polonius_output","","Polonius Output",22,N],[22,"","","",N,N],[11,"new","","",22,[[["flowatlocation",["borrows"]],["flowatlocation",["maybeuninitializedplaces"]],["flowatlocation",["everinitializedplaces"]],["option",["rc"]]],["self"]]],[11,"borrows_in_scope","","",22,N],[11,"with_outgoing_borrows","","",22,N],[11,"reset_to_entry_of","","",22,[[["self"],["basicblock"]]]],[11,"reset_to_exit_of","","",22,[[["self"],["basicblock"]]]],[11,"reconstruct_statement_effect","","",22,[[["self"],["location"]]]],[11,"reconstruct_terminator_effect","","",22,[[["self"],["location"]]]],[11,"apply_local_effect","","",22,[[["self"],["location"]]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[0,"location","rustc_mir::borrow_check","",N,N],[3,"LocationTable","rustc_mir::borrow_check::location","Maps between a MIR Location, which identifies the a particular statement within a basic block, to a \"rich location\", which identifies at a finer granularity. In particular, we distinguish the start of a statement and the mid-point. The mid-point is the point just before the statement takes effect; in particular, for an assignment `A = B`, it is the point where B is about to be written into A. This mid-point is a kind of hack to work around our inability to track the position information at sufficient granularity through outlives relations; however, the rich location table serves another purpose: it compresses locations from multiple words into a single u32.",N,N],[12,"num_points","","",23,N],[12,"statements_before_block","","",23,N],[3,"LocationIndex","","",N,N],[12,"private","","",24,N],[4,"RichLocation","","",N,N],[13,"Start","","",25,N],[13,"Mid","","",25,N],[22,"","","",N,N],[11,"clone","","",24,[[["self"]],["locationindex"]]],[11,"eq","","",24,[[["self"],["locationindex"]],["bool"]]],[11,"ne","","",24,[[["self"],["locationindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",24,N],[11,"hash","","",24,N],[11,"partial_cmp","","",24,[[["self"],["locationindex"]],["option",["ordering"]]]],[11,"lt","","",24,[[["self"],["locationindex"]],["bool"]]],[11,"le","","",24,[[["self"],["locationindex"]],["bool"]]],[11,"gt","","",24,[[["self"],["locationindex"]],["bool"]]],[11,"ge","","",24,[[["self"],["locationindex"]],["bool"]]],[11,"cmp","","",24,[[["self"],["locationindex"]],["ordering"]]],[11,"decode","","",24,[[["__d"]],["result",["locationindex"]]]],[11,"encode","","",24,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",24,N],[18,"MAX","","",24,N],[11,"from_usize","","",24,[[["usize"]],["self"]]],[11,"from_u32","","",24,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",24,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",24,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",24,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",24,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",24,[[["self"]],["usize"]]],[11,"new","","",24,[[["usize"]],["self"]]],[11,"index","","",24,[[["self"]],["usize"]]],[11,"steps_between","","",24,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",24,[[["self"]],["self"]]],[11,"replace_zero","","",24,[[["self"]],["self"]]],[11,"add_one","","",24,[[["self"]],["self"]]],[11,"sub_one","","",24,[[["self"]],["self"]]],[11,"add_usize","","",24,[[["self"],["usize"]],["option"]]],[11,"from","","",24,[[["usize"]],["self"]]],[11,"from","","",24,[[["u32"]],["self"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"clone","","",25,[[["self"]],["richlocation"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"new","","",23,[[["mir"]],["self"]]],[11,"all_points","","",23,N],[11,"start_index","","",23,[[["self"],["location"]],["locationindex"]]],[11,"mid_index","","",23,[[["self"],["location"]],["locationindex"]]],[11,"to_location","","",23,[[["self"],["locationindex"]],["richlocation"]]],[11,"is_start","","",24,[[["self"]],["bool"]]],[0,"move_errors","rustc_mir::borrow_check","",N,N],[4,"GroupedMoveError","rustc_mir::borrow_check::move_errors","",N,N],[13,"MovesFromPlace","","",26,N],[12,"original_path","rustc_mir::borrow_check::move_errors::GroupedMoveError","",26,N],[12,"span","","",26,N],[12,"move_from","","",26,N],[12,"kind","","",26,N],[12,"binds_to","","",26,N],[13,"MovesFromValue","rustc_mir::borrow_check::move_errors","",26,N],[12,"original_path","rustc_mir::borrow_check::move_errors::GroupedMoveError","",26,N],[12,"span","","",26,N],[12,"move_from","","",26,N],[12,"kind","","",26,N],[12,"binds_to","","",26,N],[13,"OtherIllegalMove","rustc_mir::borrow_check::move_errors","",26,N],[12,"original_path","rustc_mir::borrow_check::move_errors::GroupedMoveError","",26,N],[12,"span","","",26,N],[12,"kind","","",26,N],[11,"fmt","rustc_mir::borrow_check::move_errors","",26,[[["self"],["formatter"]],["result"]]],[11,"report_move_errors","rustc_mir::borrow_check","",0,[[["self"],["vec"]]]],[11,"group_move_errors","","",0,[[["self"],["vec"]],["vec",["groupedmoveerror"]]]],[11,"append_to_grouped_errors","","",0,[[["self"],["vec"],["place"],["moveerror"]]]],[11,"append_binding_error","","",0,[[["self"],["vec"],["illegalmoveoriginkind"],["place"],["place"],["local"],["option"],["span"],["span"]]]],[11,"report","","",0,[[["self"],["groupedmoveerror"]]]],[11,"add_move_hints","","",0,[[["self"],["groupedmoveerror"],["diagnosticbuilder"],["span"]]]],[11,"add_move_error_suggestions","","",0,N],[11,"add_move_error_details","","",0,N],[0,"mutability_errors","","",N,N],[4,"AccessKind","rustc_mir::borrow_check::mutability_errors","",N,N],[13,"MutableBorrow","","",27,N],[13,"Mutate","","",27,N],[13,"Move","","",27,N],[5,"suggest_ampmut_self","","",N,N],[5,"suggest_ampmut","","",N,N],[5,"is_closure_or_generator","","",N,[[["ty"]],["bool"]]],[11,"clone","","",27,[[["self"]],["accesskind"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",27,N],[11,"eq","","",27,[[["self"],["accesskind"]],["bool"]]],[11,"report_mutability_error","rustc_mir::borrow_check","",0,[[["self"],["place"],["span"],["place"],["accesskind"],["location"]]]],[0,"path_utils","","",N,N],[4,"Control","rustc_mir::borrow_check::path_utils","Control for the path borrow checking code",N,N],[13,"Continue","","",28,N],[13,"Break","","",28,N],[5,"allow_two_phase_borrow","","Returns true if the borrow represented by `kind` is allowed to be split into separate Reservation and Activation phases.",N,[[["tyctxt"],["borrowkind"]],["bool"]]],[5,"each_borrow_involving_path","","Encapsulates the idea of iterating over every borrow that involves a particular path",N,N],[5,"is_active","","",N,[[["dominators"],["borrowdata"],["location"]],["bool"]]],[5,"borrow_of_local_data","","Determines if a given borrow is borrowing local data This is called for all Yield statements on movable generators",N,[[["place"]],["bool"]]],[11,"clone","","",28,[[["self"]],["control"]]],[11,"eq","","",28,[[["self"],["control"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",28,N],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[0,"place_ext","rustc_mir::borrow_check","",N,N],[8,"PlaceExt","rustc_mir::borrow_check::place_ext","Extension methods for the `Place` type.",N,N],[10,"ignore_borrow","","Returns true if we can safely ignore borrows of this place. This is true whenever there is no action that the user can do to the place `self` that would invalidate the borrow. This is true for borrows of raw pointer dereferents as well as shared references.",29,[[["self"],["tyctxt"],["mir"],["localsstateatexit"]],["bool"]]],[10,"root_local","","If this is a place like `x.f.g`, returns the local `x`. Returns `None` if this is based in a static.",29,[[["self"]],["option",["local"]]]],[0,"places_conflict","rustc_mir::borrow_check","",N,N],[3,"PlaceComponents","rustc_mir::borrow_check::places_conflict","A linked list of places running up the stack; begins with the innermost place and extends to projections (e.g., `a.b` would have the place `a` with a \"next\" pointer to `a.b`).  Created by `unroll_place`.",N,N],[12,"component","","",30,N],[12,"next","","",30,N],[3,"PlaceComponentsIter","","Iterator over components; see `PlaceComponents::iter` for more information.",N,N],[12,"value","","",31,N],[5,"places_conflict","","",N,[[["tyctxt"],["mir"],["place"],["place"],["shallowordeep"]],["bool"]]],[5,"place_components_conflict","","",N,[[["tyctxt"],["mir"],["placecomponentsiter"],["placecomponentsiter"],["shallowordeep"]],["bool"]]],[5,"unroll_place","","Recursively \"unroll\" a place into a `PlaceComponents` list, invoking `op` with a `PlaceComponentsIter`.",N,N],[5,"place_element_conflict","","",N,[[["tyctxt"],["mir"],["place"],["place"]],["overlap"]]],[11,"iter","","Converts a list of `Place` components into an iterator; this iterator yields up a never-ending stream of `Option<&Place>`. These begin with the \"innermst\" place and then with each projection therefrom. So given a place like `a.b.c` it would yield up:",30,[[["self"]],["placecomponentsiter"]]],[11,"next","","",31,[[["self"]],["option",["place"]]]],[0,"prefixes","rustc_mir::borrow_check","From the NLL RFC: \"The deep [aka 'supporting'] prefixes for an place are formed by stripping away fields and derefs, except that we stop when we reach the deref of a shared reference. [...] \"",N,N],[3,"Prefixes","rustc_mir::borrow_check::prefixes","",N,N],[12,"mir","","",32,N],[12,"tcx","","",32,N],[12,"kind","","",32,N],[12,"next","","",32,N],[4,"PrefixSet","","",N,N],[13,"All","","Doesn't stop until it returns the base case (a Local or Static prefix).",33,N],[13,"Shallow","","Stops at any dereference.",33,N],[13,"Supporting","","Stops at the deref of a shared reference.",33,N],[8,"IsPrefixOf","","",N,N],[10,"is_prefix_of","","",34,[[["self"],["place"]],["bool"]]],[11,"clone","","",33,[[["self"]],["prefixset"]]],[11,"eq","","",33,[[["self"],["prefixset"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",33,N],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"prefixes","rustc_mir::borrow_check","Returns an iterator over the prefixes of `place` (inclusive) from longest to smallest, potentially terminating the iteration early based on `kind`.",0,[[["self"],["place"],["prefixset"]],["prefixes"]]],[11,"next","rustc_mir::borrow_check::prefixes","",32,[[["self"]],["option"]]],[0,"used_muts","rustc_mir::borrow_check","",N,N],[3,"GatherUsedMutsVisitor","rustc_mir::borrow_check::used_muts","MIR visitor gathering the assignments to a set of locals, in a single walk. 'visit = the duration of the MIR walk",N,N],[12,"needles","","",35,N],[12,"mbcx","","",35,N],[11,"gather_used_muts","rustc_mir::borrow_check","Walks the MIR looking for assignments to a set of locals, as part of the unused mutable local variables lint, to update the context's `used_mut` in a single walk.",0,[[["self"],["fxhashset",["local"]]]]],[11,"visit_local","rustc_mir::borrow_check::used_muts","",35,[[["self"],["local"],["placecontext"],["location"]]]],[0,"nll","rustc_mir::borrow_check","",N,N],[5,"replace_regions_in_mir","rustc_mir::borrow_check::nll","Rewrites the regions in the MIR to use NLL variables, also scraping out the set of universal regions (e.g., region parameters) declared on the function. That set will need to be given to `compute_regions`.",N,[[["inferctxt"],["defid"],["paramenv"],["mir"]],["universalregions"]]],[5,"compute_regions","","Computes the (non-lexical) regions from the input MIR.",N,N],[5,"dump_mir_results","","",N,[[["inferctxt"],["mirsource"],["mir"],["regioninferencecontext"],["option"]]]],[5,"dump_annotation","","",N,[[["inferctxt"],["mir"],["defid"],["regioninferencecontext"],["option"],["vec"]]]],[5,"for_each_region_constraint","","",N,[[["closureregionrequirements"],["fnmut"]],["result"]]],[0,"constraint_generation","","",N,N],[3,"ConstraintGeneration","rustc_mir::borrow_check::nll::constraint_generation","'cg = the duration of the constraint generation process itself.",N,N],[12,"infcx","","",36,N],[12,"all_facts","","",36,N],[12,"location_table","","",36,N],[12,"liveness_constraints","","",36,N],[12,"borrow_set","","",36,N],[5,"generate_constraints","","",N,[[["inferctxt"],["livenessvalues"],["option"],["locationtable"],["mir"],["borrowset"]]]],[11,"visit_basic_block_data","","",36,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_substs","","We sometimes have `substs` within an rvalue, or within a call. Make them live at the location where they appear.",36,[[["self"],["substs"],["location"]]]],[11,"visit_region","","We sometimes have `region` within an rvalue, or within a call. Make them live at the location where they appear.",36,[[["self"],["region"],["location"]]]],[11,"visit_ty","","We sometimes have `ty` within an rvalue, or within a call. Make them live at the location where they appear.",36,[[["self"],["ty"],["tycontext"]]]],[11,"visit_generator_substs","","We sometimes have `generator_substs` within an rvalue, or within a call. Make them live at the location where they appear.",36,[[["self"],["generatorsubsts"],["location"]]]],[11,"visit_closure_substs","","We sometimes have `closure_substs` within an rvalue, or within a call. Make them live at the location where they appear.",36,[[["self"],["closuresubsts"],["location"]]]],[11,"visit_statement","","",36,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_assign","","",36,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_terminator","","",36,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_ascribe_user_ty","","",36,[[["self"],["place"],["variance"],["canonicalty"],["location"]]]],[11,"add_regular_live_constraint","","Some variable with type `live_ty` is \"regular live\" at `location` -- i.e., it may be used later. This means that all regions appearing in the type `live_ty` must be live at `location`.",36,[[["self"],["t"],["location"]]]],[0,"explain_borrow","rustc_mir::borrow_check::nll","",N,N],[4,"BorrowContainsPointReason","rustc_mir::borrow_check::nll::explain_borrow","",N,N],[13,"Liveness","","",37,N],[12,"local","rustc_mir::borrow_check::nll::explain_borrow::BorrowContainsPointReason","",37,N],[12,"location","","",37,N],[12,"in_loop","","",37,N],[13,"DropLiveness","rustc_mir::borrow_check::nll::explain_borrow","",37,N],[12,"local","rustc_mir::borrow_check::nll::explain_borrow::BorrowContainsPointReason","",37,N],[12,"location","","",37,N],[13,"OutlivesFreeRegion","rustc_mir::borrow_check::nll::explain_borrow","",37,N],[12,"outlived_region","rustc_mir::borrow_check::nll::explain_borrow::BorrowContainsPointReason","",37,N],[0,"find_use","rustc_mir::borrow_check::nll::explain_borrow","",N,N],[3,"UseFinder","rustc_mir::borrow_check::nll::explain_borrow::find_use","",N,N],[12,"mir","","",38,N],[12,"regioncx","","",38,N],[12,"tcx","","",38,N],[12,"region_vid","","",38,N],[12,"start_point","","",38,N],[3,"DefUseVisitor","","",N,N],[12,"mir","","",39,N],[12,"tcx","","",39,N],[12,"region_vid","","",39,N],[12,"def_use_result","","",39,N],[4,"DefUseResult","","",N,N],[13,"Def","","",40,N],[13,"UseLive","","",40,N],[12,"local","rustc_mir::borrow_check::nll::explain_borrow::find_use::DefUseResult","",40,N],[13,"UseDrop","rustc_mir::borrow_check::nll::explain_borrow::find_use","",40,N],[12,"local","rustc_mir::borrow_check::nll::explain_borrow::find_use::DefUseResult","",40,N],[5,"find","rustc_mir::borrow_check::nll::explain_borrow::find_use","",N,[[["mir"],["rc"],["tyctxt"],["regionvid"],["location"]],["option",["cause"]]]],[11,"find","","",38,[[["self"]],["option",["cause"]]]],[11,"def_use","","",38,[[["self"],["location"],["mirvisitable"]],["option",["defuseresult"]]]],[11,"visit_local","","",39,[[["self"],["local"],["placecontext"],["location"]]]],[11,"clone","rustc_mir::borrow_check::nll::explain_borrow","",37,[[["self"]],["borrowcontainspointreason"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"explain_why_borrow_contains_point","rustc_mir::borrow_check","Adds annotations to `err` explaining why the borrow contains the point from `context`. This is key for the \"3-point errors\" [described in the NLL RFC][d].",0,[[["self"],["context"],["borrowdata"],["option"],["diagnosticbuilder"]]]],[11,"find_why_borrow_contains_point","","Finds the reason that [explain_why_borrow_contains_point] will report but doesn't add it to any message. This is a separate function in case the caller wants to change the error they report based on the reason that will be reported.",0,[[["self"],["context"],["borrowdata"]],["borrowcontainspointreason"]]],[11,"report_why_borrow_contains_point","","Adds annotations to `err` for the explanation `reason`. This is a separate method so that the caller can change their error message based on the reason that is going to be reported.",0,[[["self"],["diagnosticbuilder"],["borrowcontainspointreason"],["option"]]]],[11,"is_borrow_location_in_loop","","Check if a borrow location is within a loop.",0,[[["self"],["location"]],["bool"]]],[0,"facts","rustc_mir::borrow_check::nll","",N,N],[3,"FactWriter","rustc_mir::borrow_check::nll::facts","",N,N],[12,"location_table","","",41,N],[12,"dir","","",41,N],[5,"write_row","","",N,N],[6,"AllFacts","","",N,N],[8,"AllFactsExt","","",N,N],[10,"enabled","","Returns true if there is a need to gather `AllFacts` given the current `-Z` flags.",42,[[["tyctxt"]],["bool"]]],[10,"write_to_dir","","",42,N],[8,"FactRow","","",N,N],[10,"write","","",43,[[["self"],["file"],["locationtable"]],["result",["box"]]]],[8,"FactCell","","",N,N],[10,"to_string","","",44,[[["self"],["locationtable"]],["string"]]],[11,"index","rustc_mir::borrow_check::location","",24,[[["self"]],["usize"]]],[11,"write_facts_to_path","rustc_mir::borrow_check::nll::facts","",41,N],[11,"to_string","rustc_mir::borrow_check::location","",24,[[["self"],["locationtable"]],["string"]]],[0,"invalidation","rustc_mir::borrow_check::nll","",N,N],[3,"InvalidationGenerator","rustc_mir::borrow_check::nll::invalidation","'cg = the duration of the constraint generation process itself.",N,N],[12,"infcx","","",45,N],[12,"all_facts","","",45,N],[12,"location_table","","",45,N],[12,"mir","","",45,N],[12,"dominators","","",45,N],[12,"borrow_set","","",45,N],[12,"param_env","","",45,N],[5,"generate_invalidates","","",N,[[["inferctxt"],["option"],["locationtable"],["mir"],["defid"],["borrowset"]]]],[11,"visit_statement","","",45,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_terminator","","",45,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_terminator_drop","","Simulates dropping of a variable",45,[[["self"],["location"],["terminator"],["place"],["ty"]]]],[11,"mutate_place","","Simulates mutation of a place",45,[[["self"],["context"],["place"],["shallowordeep"],["mutatemode"]]]],[11,"consume_operand","","Simulates consumption of an operand",45,[[["self"],["context"],["operand"]]]],[11,"consume_rvalue","","",45,[[["self"],["context"],["rvalue"]]]],[11,"access_place","","Simulates an access to a place",45,N],[11,"check_access_for_conflict","","",45,[[["self"],["context"],["place"],["shallowordeep"],["readorwrite"]]]],[11,"generate_invalidates","","Generate a new invalidates(L, B) fact",45,[[["self"],["borrowindex"],["location"]]]],[0,"region_infer","rustc_mir::borrow_check::nll","",N,N],[3,"RegionInferenceContext","rustc_mir::borrow_check::nll::region_infer","",N,N],[12,"definitions","","Contains the definition for every region variable.  Region variables are identified by their index (`RegionVid`). The definition contains information about where the region came from as well as its final inferred value.",46,N],[12,"liveness_constraints","","The liveness constraints added to each region. For most regions, these start out empty and steadily grow, though for each universally quantified region R they start out containing the entire CFG and `end(R)`.",46,N],[12,"constraints","","The outlives constraints computed by the type-check.",46,N],[12,"constraint_graph","","The constraint-set, but in graph form, making it easy to traverse the constraints adjacent to a particular region. Used to construct the SCC (see `constraint_sccs`) and for error reporting.",46,N],[12,"constraint_sccs","","The SCC computed from `constraints` and the constraint graph. Used to compute the values of each region.",46,N],[12,"scc_universes","","Contains the minimum universe of any variable within the same SCC. We will ensure that no SCC contains values that are not visible from this index.",46,N],[12,"scc_values","","The final inferred values of the region variables; we compute one value per SCC. To get the value for any given region, you first find which scc it is a part of.",46,N],[12,"type_tests","","Type constraints that we check after solving.",46,N],[12,"universal_regions","","Information about the universally quantified regions in scope on this function.",46,N],[12,"universal_region_relations","","Information about how the universally quantified regions in scope on this function relate to one another.",46,N],[3,"RegionDefinition","","",N,N],[12,"origin","","What kind of variable is this -- a free region? existential variable? etc. (See the `NLLRegionVariableOrigin` for more info.)",47,N],[12,"universe","","Which universe is this region variable defined in? This is most often `ty::UniverseIndex::ROOT`, but when we encounter forall-quantifiers like `for<'a> { 'a = 'b }`, we would create the variable for `'a` in a subuniverse.",47,N],[12,"external_name","","If this is 'static or an early-bound region, then this is `Some(X)` where `X` is the name of the region.",47,N],[3,"TypeTest","","A \"type test\" corresponds to an outlives constraint between a type and a lifetime, like `T: 'x` or `<T as Foo>::Bar: 'x`.  They are translated from the `Verify` region constraints in the ordinary inference context.",N,N],[12,"generic_kind","","The type `T` that must outlive the region.",48,N],[12,"lower_bound","","The region `'x` that the type must outlive.",48,N],[12,"locations","","Where did this constraint arise and why?",48,N],[12,"test","","A test which, if met by the region `'x`, proves that this type constraint is satisfied.",48,N],[4,"Cause","","NB: The variants in `Cause` are intentionally ordered. Lower values are preferred when it comes to error messages. Do not reorder willy nilly.",N,N],[13,"LiveVar","","point inserted because Local was live at the given Location",49,N],[13,"DropVar","","point inserted because Local was dropped at the given Location",49,N],[4,"RegionTest","","A \"test\" that can be applied to some \"subject region\" `'x`. These are used to describe type constraints. Tests do not presently affect the region values that get inferred for each variable; they only examine the results after inference.  This means they can conveniently include disjuction (\"a or b must be true\").",N,N],[13,"IsOutlivedByAnyRegionIn","","The subject region `'x` must by outlived by some region in the given set of regions.",50,N],[13,"IsOutlivedByAllRegionsIn","","The subject region `'x` must by outlived by all regions in the given set of regions.",50,N],[13,"Any","","Any of the given tests are true.",50,N],[13,"All","","All of the given tests are true.",50,N],[0,"dump_mir","","As part of generating the regions, if you enable `-Zdump-mir=nll`, we will generate an annotated copy of the MIR that includes the state of region inference. This code handles emitting the region context internal state.",N,N],[17,"REGION_WIDTH","rustc_mir::borrow_check::nll::region_infer::dump_mir","",N,N],[11,"dump_mir","rustc_mir::borrow_check::nll::region_infer","Write out our state into the `.mir` files.",46,[[["self"],["write"]],["result"]]],[11,"for_each_constraint","","Debugging aid: Invokes the `with_msg` callback repeatedly with our internal region constraints.  These are dumped into the -Zdump-mir file so that we can figure out why the region inference resulted in the values that it did when debugging.",46,[[["self"],["fnmut"]],["result"]]],[0,"error_reporting","","",N,N],[4,"ConstraintCategory","rustc_mir::borrow_check::nll::region_infer::error_reporting","Constraints that are considered interesting can be categorized to determine why they are interesting. Order of variants indicates sort order of the category, thereby influencing diagnostic output.",N,N],[13,"Cast","","",51,N],[13,"Assignment","","",51,N],[13,"Return","","",51,N],[13,"CallArgument","","",51,N],[13,"Other","","",51,N],[13,"Boring","","",51,N],[4,"Trace","","",N,N],[13,"StartRegion","","",52,N],[13,"FromOutlivesConstraint","","",52,N],[13,"NotVisited","","",52,N],[0,"region_name","","",N,N],[11,"give_region_a_name","rustc_mir::borrow_check::nll::region_infer","Maps from an internal MIR region vid to something that we can report to the user. In some cases, the region vids will map directly to lifetimes that the user has a name for (e.g., `'static`). But frequently they will not, in which case we have to find some way to identify the lifetime to the user. To that end, this function takes a \"diagnostic\" so that it can create auxiliary notes as needed.",46,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["usize"],["diagnosticbuilder"]],["internedstring"]]],[11,"give_name_from_error_region","","Check for the case where `fr` maps to something that the user has a name for. In that case, we'll be able to map `fr` to a `Region<'tcx>`, and that region will be one of named variants.",46,[[["self"],["tyctxt"],["defid"],["regionvid"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"highlight_named_span","","Highlight a named span to provide context for error messages that mention that span, for example:",46,[[["self"],["tyctxt"],["regionkind"],["internedstring"],["diagnosticbuilder"]]]],[11,"give_name_if_anonymous_region_appears_in_arguments","","Find an argument that contains `fr` and label it with a fully elaborated type, returning something like `'1`. Result looks like:",46,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"give_name_if_we_can_match_hir_ty_from_argument","","",46,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["ty"],["usize"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"give_name_if_we_cannot_match_hir_ty","","Attempts to highlight the specific part of a type in an argument that has no type annotation. For example, we might produce an annotation like this:",46,[[["self"],["inferctxt"],["mir"],["regionvid"],["ty"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"give_name_if_we_can_match_hir_ty","","Attempts to highlight the specific part of a type annotation that contains the anonymous reference we want to give a name to. For example, we might produce an annotation like this:",46,[[["self"],["tyctxt"],["regionvid"],["ty"],["ty"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"match_adt_and_segment","","We've found an enum/struct/union type with the substitutions `substs` and -- in the HIR -- a path type with the final segment `last_segment`. Try to find a `'_` to highlight in the generic args (or, if not, to produce new zipped pairs of types+hir to search through).",46,[[["self"],["substs"],["regionvid"],["pathsegment"],["usize"],["diagnosticbuilder"],["vec"]],["option",["internedstring"]]]],[11,"try_match_adt_and_generic_args","","We've found an enum/struct/union type with the substitutions `substs` and -- in the HIR -- a path with the generic arguments `args`. If `needle_fr` appears in the args, return the `hir::Lifetime` that corresponds to it. If not, push onto `search_stack` the types+hir to search through.",46,[[["self"],["substs"],["regionvid"],["genericargs"],["vec"]],["option",["lifetime"]]]],[11,"give_name_if_anonymous_region_appears_in_upvars","","Find a closure upvar that contains `fr` and label it with a fully elaborated type, returning something like `'1`. Result looks like:",46,[[["self"],["tyctxt"],["mir"],["regionvid"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"give_name_if_anonymous_region_appears_in_output","","Check for arguments appearing in the (closure) return type. It must be a closure since, in a free fn, such an argument would have to either also appear in an argument (if using elision) or be early bound (named, not in argument).",46,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["usize"],["diagnosticbuilder"]],["option",["internedstring"]]]],[11,"synthesize_region_name","","Create a synthetic region named `'1`, incrementing the counter.",46,[[["self"],["usize"]],["internedstring"]]],[0,"var_name","rustc_mir::borrow_check::nll::region_infer::error_reporting","",N,N],[11,"get_var_name_and_span_for_region","rustc_mir::borrow_check::nll::region_infer","",46,[[["self"],["tyctxt"],["mir"],["regionvid"]],["option"]]],[11,"get_upvar_index_for_region","","Search the upvars (if any) to find one that references fr. Return its index.",46,[[["self"],["tyctxt"],["regionvid"]],["option",["usize"]]]],[11,"get_upvar_name_and_span_for_region","","Given the index of an upvar, finds its name and the span from where it was declared.",46,N],[11,"get_argument_index_for_region","","Search the argument types for one that references fr (which should be a free region). Returns Some(_) with the index of the input if one is found.",46,[[["self"],["tyctxt"],["regionvid"]],["option",["usize"]]]],[11,"get_argument_name_and_span_for_region","","Given the index of an argument, finds its name (if any) and the span from where it was declared.",46,N],[11,"clone","rustc_mir::borrow_check::nll::region_infer::error_reporting","",51,[[["self"]],["constraintcategory"]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",51,N],[11,"eq","","",51,[[["self"],["constraintcategory"]],["bool"]]],[11,"partial_cmp","","",51,[[["self"],["constraintcategory"]],["option",["ordering"]]]],[11,"cmp","","",51,[[["self"],["constraintcategory"]],["ordering"]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"clone","","",52,[[["self"]],["trace"]]],[11,"eq","","",52,[[["self"],["trace"]],["bool"]]],[11,"ne","","",52,[[["self"],["trace"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",52,N],[11,"best_blame_constraint","rustc_mir::borrow_check::nll::region_infer","Tries to find the best constraint to blame for the fact that `R: from_region`, where `R` is some region that meets `target_test`. This works by following the constraint graph, creating a constraint path that forces `R` to outlive `from_region`, and then finding the best choices within that path to blame.",46,N],[11,"find_constraint_paths_between_regions","","Walks the graph of constraints (where `'a: 'b` is considered an edge `'a -> 'b`) to find all paths from `from_region` to `to_region`. The paths are accumulated into the vector `results`. The paths are stored as a series of `ConstraintIndex` values -- in other words, a list of edges.",46,N],[11,"constraint_is_interesting","","This function will return true if a constraint is interesting and false if a constraint is not. It is useful in filtering constraint paths to only interesting points.",46,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"classify_constraint","","This function classifies a constraint from a location.",46,N],[11,"report_error","","Report an error because the universal region `fr` was required to outlive `outlived_fr` but it is not known to do so. For example:",46,[[["self"],["mir"],["inferctxt"],["defid"],["regionvid"],["regionvid"],["vec"]]]],[11,"report_escaping_data_error","","",46,[[["self"],["mir"],["inferctxt"],["defid"],["regionvid"],["regionvid"],["constraintcategory"],["span"],["vec"]]]],[11,"report_general_error","","",46,[[["self"],["mir"],["inferctxt"],["defid"],["regionvid"],["bool"],["regionvid"],["bool"],["constraintcategory"],["span"],["vec"]]]],[11,"find_sub_region_live_at","","",46,[[["self"],["regionvid"],["location"]],["regionvid"]]],[11,"find_outlives_blame_span","","",46,[[["self"],["mir"],["tyctxt"],["regionvid"],["regionvid"]],["span"]]],[0,"graphviz","","This module provides linkage between RegionInferenceContext and libgraphviz traits, specialized to attaching borrowck analysis data to rendered labels.",N,N],[3,"RawConstraints","rustc_mir::borrow_check::nll::region_infer::graphviz","",N,N],[12,"regioncx","","",53,N],[3,"SccConstraints","","",N,N],[12,"regioncx","","",54,N],[12,"nodes_per_scc","","",54,N],[11,"dump_graphviz_raw_constraints","rustc_mir::borrow_check::nll::region_infer","Write out the region constraint graph.",46,[[["self"],["write"]],["result"]]],[11,"dump_graphviz_scc_constraints","","Write out the region constraint graph.",46,[[["self"],["write"]],["result"]]],[11,"graph_id","rustc_mir::borrow_check::nll::region_infer::graphviz","",53,[[["self"]],["id"]]],[11,"node_id","","",53,[[["self"],["regionvid"]],["id"]]],[11,"node_shape","","",53,[[["self"],["regionvid"]],["option",["labeltext"]]]],[11,"node_label","","",53,[[["self"],["regionvid"]],["labeltext"]]],[11,"edge_label","","",53,[[["self"],["outlivesconstraint"]],["labeltext"]]],[11,"nodes","","",53,[[["self"]],["nodes",["regionvid"]]]],[11,"edges","","",53,[[["self"]],["edges",["outlivesconstraint"]]]],[11,"source","","",53,[[["self"],["outlivesconstraint"]],["regionvid"]]],[11,"target","","",53,[[["self"],["outlivesconstraint"]],["regionvid"]]],[11,"graph_id","","",54,[[["self"]],["id"]]],[11,"node_id","","",54,[[["self"],["constraintsccindex"]],["id"]]],[11,"node_shape","","",54,[[["self"],["constraintsccindex"]],["option",["labeltext"]]]],[11,"node_label","","",54,[[["self"],["constraintsccindex"]],["labeltext"]]],[11,"nodes","","",54,[[["self"]],["nodes",["constraintsccindex"]]]],[11,"edges","","",54,[[["self"]],["edges"]]],[11,"source","","",54,N],[11,"target","","",54,N],[0,"values","rustc_mir::borrow_check::nll::region_infer","",N,N],[3,"RegionValueElements","rustc_mir::borrow_check::nll::region_infer::values","Maps between a `Location` and a `PointIndex` (and vice versa).",N,N],[12,"statements_before_block","","For each basic block, how many points are contained within?",55,N],[12,"basic_blocks","","Map backward from each point to the basic block that it belongs to.",55,N],[12,"num_points","","",55,N],[3,"PointIndex","","",N,N],[12,"private","","",56,N],[3,"PlaceholderIndex","","",N,N],[12,"private","","",57,N],[3,"LivenessValues","","When we initially compute liveness, we use a bit matrix storing points for each region-vid.",N,N],[12,"elements","","",58,N],[12,"points","","",58,N],[3,"RegionValues","","Stores the full values for a set of regions (in contrast to `LivenessValues`, which only stores those points in the where a region is live). The full value for a region may contain points in the CFG, but also free regions as well as bound universe placeholders.",N,N],[12,"elements","","",59,N],[12,"points","","",59,N],[12,"free_regions","","",59,N],[12,"placeholders","","Placeholders represent bound regions -- so something like `'a` in for<'a> fn(&'a u32)`.",59,N],[4,"RegionElement","","An individual element in a region value -- the value of a particular region variable consists of a set of these elements.",N,N],[13,"Location","","A point in the control-flow graph.",60,N],[13,"RootUniversalRegion","","A universally quantified region from the root universe (e.g., a lifetime parameter).",60,N],[13,"SubUniversalRegion","","A subuniverse from a subuniverse (e.g., instantiated from a `for<'a> fn(&'a u32)` type).",60,N],[5,"location_set_str","","",N,N],[5,"region_value_str","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[8,"ToElementIndex","","",N,N],[10,"add_to_row","","",61,[[["self"],["regionvalues"],["n"]],["bool"]]],[10,"contained_in_row","","",61,[[["self"],["regionvalues"],["n"]],["bool"]]],[11,"new","","",55,[[["mir"]],["self"]]],[11,"num_points","","Total number of point indices",55,[[["self"]],["usize"]]],[11,"point_from_location","","Converts a `Location` into a `PointIndex`. O(1).",55,[[["self"],["location"]],["pointindex"]]],[11,"entry_point","","Converts a `Location` into a `PointIndex`. O(1).",55,[[["self"],["basicblock"]],["pointindex"]]],[11,"to_location","","Converts a `PointIndex` back to a location. O(1).",55,[[["self"],["pointindex"]],["location"]]],[11,"point_in_range","","Sometimes we get point-indices back from bitsets that may be out of range (because they round up to the nearest 2^N number of bits). Use this function to filter such points out if you like.",55,[[["self"],["pointindex"]],["bool"]]],[11,"push_predecessors","","Pushes all predecessors of `index` onto `stack`.",55,[[["self"],["mir"],["pointindex"],["vec"]]]],[11,"clone","","",56,[[["self"]],["pointindex"]]],[11,"eq","","",56,[[["self"],["pointindex"]],["bool"]]],[11,"ne","","",56,[[["self"],["pointindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",56,N],[11,"hash","","",56,N],[11,"partial_cmp","","",56,[[["self"],["pointindex"]],["option",["ordering"]]]],[11,"lt","","",56,[[["self"],["pointindex"]],["bool"]]],[11,"le","","",56,[[["self"],["pointindex"]],["bool"]]],[11,"gt","","",56,[[["self"],["pointindex"]],["bool"]]],[11,"ge","","",56,[[["self"],["pointindex"]],["bool"]]],[11,"cmp","","",56,[[["self"],["pointindex"]],["ordering"]]],[11,"decode","","",56,[[["__d"]],["result",["pointindex"]]]],[11,"encode","","",56,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",56,N],[18,"MAX","","",56,N],[11,"from_usize","","",56,[[["usize"]],["self"]]],[11,"from_u32","","",56,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",56,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",56,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",56,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",56,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",56,[[["self"]],["usize"]]],[11,"new","","",56,[[["usize"]],["self"]]],[11,"index","","",56,[[["self"]],["usize"]]],[11,"steps_between","","",56,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",56,[[["self"]],["self"]]],[11,"replace_zero","","",56,[[["self"]],["self"]]],[11,"add_one","","",56,[[["self"]],["self"]]],[11,"sub_one","","",56,[[["self"]],["self"]]],[11,"add_usize","","",56,[[["self"],["usize"]],["option"]]],[11,"from","","",56,[[["usize"]],["self"]]],[11,"from","","",56,[[["u32"]],["self"]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"clone","","",57,[[["self"]],["placeholderindex"]]],[11,"eq","","",57,[[["self"],["placeholderindex"]],["bool"]]],[11,"ne","","",57,[[["self"],["placeholderindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",57,N],[11,"hash","","",57,N],[11,"partial_cmp","","",57,[[["self"],["placeholderindex"]],["option",["ordering"]]]],[11,"lt","","",57,[[["self"],["placeholderindex"]],["bool"]]],[11,"le","","",57,[[["self"],["placeholderindex"]],["bool"]]],[11,"gt","","",57,[[["self"],["placeholderindex"]],["bool"]]],[11,"ge","","",57,[[["self"],["placeholderindex"]],["bool"]]],[11,"cmp","","",57,[[["self"],["placeholderindex"]],["ordering"]]],[11,"decode","","",57,[[["__d"]],["result",["placeholderindex"]]]],[11,"encode","","",57,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",57,N],[18,"MAX","","",57,N],[11,"from_usize","","",57,[[["usize"]],["self"]]],[11,"from_u32","","",57,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",57,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",57,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",57,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",57,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",57,[[["self"]],["usize"]]],[11,"new","","",57,[[["usize"]],["self"]]],[11,"index","","",57,[[["self"]],["usize"]]],[11,"steps_between","","",57,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",57,[[["self"]],["self"]]],[11,"replace_zero","","",57,[[["self"]],["self"]]],[11,"add_one","","",57,[[["self"]],["self"]]],[11,"sub_one","","",57,[[["self"]],["self"]]],[11,"add_usize","","",57,[[["self"],["usize"]],["option"]]],[11,"from","","",57,[[["usize"]],["self"]]],[11,"from","","",57,[[["u32"]],["self"]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"clone","","",60,[[["self"]],["regionelement"]]],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"eq","","",60,[[["self"],["regionelement"]],["bool"]]],[11,"ne","","",60,[[["self"],["regionelement"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",60,N],[11,"hash","","",60,N],[11,"new","","Creates a new set of \"region values\" that tracks causal information. Each of the regions in num_region_variables will be initialized with an empty set of points and no causal information.",58,[[["rc"]],["self"]]],[11,"rows","","Iterate through each region that has a value in this set.",58,N],[11,"add_element","","Adds the given element to the value for the given region. Returns true if the element is newly added (i.e., was not already present).",58,[[["self"],["n"],["location"]],["bool"]]],[11,"add_elements","","Adds all the elements in the given bit array into the given region. Returns true if any of them are newly added.",58,[[["self"],["n"],["bitarray"]],["bool"]]],[11,"add_all_points","","Adds all the control-flow points to the values for `r`.",58,[[["self"],["n"]]]],[11,"contains","","True if the region `r` contains the given element.",58,[[["self"],["n"],["location"]],["bool"]]],[11,"region_value_str","","Returns a \"pretty\" string value of the region. Meant for debugging.",58,[[["self"],["n"]],["string"]]],[11,"clone","","",59,[[["self"]],["regionvalues"]]],[11,"new","","Creates a new set of \"region values\" that tracks causal information. Each of the regions in num_region_variables will be initialized with an empty set of points and no causal information.",59,[[["rc"],["usize"],["universeindex"]],["self"]]],[11,"add_element","","Adds the given element to the value for the given region. Returns true if the element is newly added (i.e., was not already present).",59,N],[11,"add_all_points","","Adds all the control-flow points to the values for `r`.",59,[[["self"],["n"]]]],[11,"add_region","","Add all elements in `r_from` to `r_to` (because e.g. `r_to: r_from`).",59,[[["self"],["n"],["n"]],["bool"]]],[11,"contains","","True if the region `r` contains the given element.",59,N],[11,"merge_liveness","","`self[to] |= values[from]`, essentially: that is, take all the elements for the region `from` from `values` and add them to the region `to` in `self`.",59,[[["self"],["n"],["m"],["livenessvalues"]]]],[11,"contains_points","","True if `sup_region` contains all the CFG points that `sub_region` contains. Ignores universal regions.",59,[[["self"],["n"],["n"]],["bool"]]],[11,"locations_outlived_by","","Returns the locations contained within a given region `r`.",59,N],[11,"universal_regions_outlived_by","","Returns just the universal regions that are contained in a given region's value.",59,N],[11,"subuniverses_contained_in","","Returns all the elements contained in a given region's value.",59,N],[11,"elements_contained_in","","Returns all the elements contained in a given region's value.",59,N],[11,"region_value_str","","Returns a \"pretty\" string value of the region. Meant for debugging.",59,[[["self"],["n"]],["string"]]],[22,"","rustc_mir::borrow_check::nll::region_infer","",N,N],[8,"ClosureRegionRequirementsExt","","",N,N],[10,"apply_requirements","","",62,[[["self"],["tyctxt"],["location"],["defid"],["closuresubsts"]],["vec",["queryregionconstraint"]]]],[10,"subst_closure_mapping","","",62,[[["self"],["tyctxt"],["indexvec"],["t"]],["t"]]],[11,"clone","","",49,[[["self"]],["cause"]]],[11,"fmt","","",49,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",49,[[["self"],["cause"]],["option",["ordering"]]]],[11,"lt","","",49,[[["self"],["cause"]],["bool"]]],[11,"le","","",49,[[["self"],["cause"]],["bool"]]],[11,"gt","","",49,[[["self"],["cause"]],["bool"]]],[11,"ge","","",49,[[["self"],["cause"]],["bool"]]],[11,"cmp","","",49,[[["self"],["cause"]],["ordering"]]],[11,"eq","","",49,[[["self"],["cause"]],["bool"]]],[11,"ne","","",49,[[["self"],["cause"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",49,N],[11,"clone","","",48,[[["self"]],["typetest"]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"clone","","",50,[[["self"]],["regiontest"]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"new","","Creates a new region inference context with a total of `num_region_variables` valid inference variables; the first N of those will be constant regions representing the free regions defined in `universal_regions`.",46,[[["varinfos"],["rc",["universalregions"]],["rc",["universalregionrelations"]],["mir"],["constraintset"],["vec",["typetest"]],["livenessvalues",["regionvid"]],["rc"]],["self"]]],[11,"compute_scc_universes","","Each SCC is the combination of many region variables which have been equated. Therefore, we can associate a universe with each SCC which is minimum of all the universes of its constituent regions -- this is because whatever value the SCC takes on must be a value that each of the regions within the SCC could have as well. This implies that the SCC must have the minimum, or narrowest, universe.",46,[[["sccs"],["indexvec"]],["indexvec",["constraintsccindex","universeindex"]]]],[11,"init_free_and_bound_regions","","Initializes the region variables for each universally quantified region (lifetime parameter). The first N variables always correspond to the regions appearing in the function signature (both named and anonymous) and where clauses. This function iterates over those regions and initializes them with minimum values.",46,[[["self"]]]],[11,"regions","","Returns an iterator over all the region indices.",46,N],[11,"to_region_vid","","Given a universal region in scope on the MIR, returns the corresponding index.",46,[[["self"],["region"]],["regionvid"]]],[11,"annotate","","Add annotations for `#[rustc_regions]`; see `UniversalRegions::annotate`.",46,[[["self"],["tyctxt"],["diagnosticbuilder"]]]],[11,"region_contains","","Returns true if the region `r` contains the point `p`.",46,N],[11,"region_value_str","","Returns access to the value of `r` for debugging purposes.",46,[[["self"],["regionvid"]],["string"]]],[11,"region_universe","","Returns access to the value of `r` for debugging purposes.",46,[[["self"],["regionvid"]],["universeindex"]]],[11,"solve","","Perform region inference and report errors if we see any unsatisfiable constraints. If this is a closure, returns the region requirements to propagate to our creator, if any.",46,[[["self"],["inferctxt"],["mir"],["defid"],["vec"]],["option",["closureregionrequirements"]]]],[11,"solve_inner","","",46,[[["self"],["inferctxt"],["mir"],["defid"],["vec"]],["option",["closureregionrequirements"]]]],[11,"propagate_constraints","","Propagate the region constraints: this will grow the values for each region variable until all the constraints are satisfied. Note that some values may grow too large to be feasible, but we check this later.",46,[[["self"],["mir"]]]],[11,"propagate_constraint_sccs_if_new","","",46,[[["self"],["constraintsccindex"],["idxset"]]]],[11,"propagate_constraint_sccs_new","","",46,[[["self"],["constraintsccindex"],["idxset"]]]],[11,"universe_compatible","","True if all the elements in the value of `scc_b` are nameable in `scc_a`. Used during constraint propagation, and only once the value of `scc_b` has been computed.",46,[[["self"],["constraintsccindex"],["constraintsccindex"]],["bool"]]],[11,"add_incompatible_universe","","Extend `scc` so that it can outlive some placeholder region from a universe it can't name; at present, the only way for this to be true is if `scc` outlives `'static`. This is actually stricter than necessary: ideally, we'd support bounds like `for<'a: 'b`>`that might then allow us to approximate`'a`with`'b`and not`'static`. But it will have to do for now.",46,[[["self"],["constraintsccindex"]]]],[11,"check_type_tests","","Once regions have been propagated, this method is used to see whether the \"type tests\" produced by typeck were satisfied; type tests encode type-outlives relationships like `T: 'a`. See `TypeTest` for more details.",46,[[["self"],["inferctxt"],["mir"],["defid"],["option",["vec"]],["vec"]]]],[11,"to_error_region","","Converts a region inference variable into a `ty::Region` that we can use for error reporting. If `r` is universally bound, then we use the name that we have on record for it. If `r` is existentially bound, then we check its inferred value and try to find a good name from that. Returns `None` if we can't find one (e.g., this is just some random part of the CFG).",46,[[["self"],["regionvid"]],["option",["region"]]]],[11,"try_promote_type_test","","Invoked when we have some type-test (e.g., `T: 'X`) that we cannot prove to be satisfied. If this is a closure, we will attempt to \"promote\" this type-test into our `ClosureRegionRequirements` and hence pass it up the creator. To do this, we have to phrase the type-test in terms of external free regions, as local free regions are not nameable by the closure's creator.",46,[[["self"],["inferctxt"],["mir"],["typetest"],["vec"]],["bool"]]],[11,"try_promote_type_test_subject","","When we promote a type test `T: 'r`, we have to convert the type `T` into something we can store in a query result (so something allocated for `'gcx`). This is problematic if `ty` contains regions. During the course of NLL region checking, we will have replaced all of those regions with fresh inference variables. To create a test subject, we want to replace those inference variables with some region from the closure signature -- this is not always possible, so this is a fallible process. Presuming we do find a suitable region, we will represent it with a `ReClosureBound`, which is a `RegionKind` variant that can be allocated in the gcx.",46,[[["self"],["inferctxt"],["ty"]],["option",["closureoutlivessubject"]]]],[11,"non_local_universal_upper_bound","","Given some universal or existential region `r`, finds a non-local, universal region `r+` that outlives `r` at entry to (and exit from) the closure. In the worst case, this will be `'static`.",46,[[["self"],["regionvid"]],["regionvid"]]],[11,"universal_upper_bound","","Returns a universally quantified region that outlives the value of `r` (`r` may be existentially or universally quantified).",46,[[["self"],["regionvid"]],["regionvid"]]],[11,"eval_region_test","","Test if `test` is true when applied to `lower_bound` at `point`, and returns true or false.",46,[[["self"],["mir"],["regionvid"],["regiontest"]],["bool"]]],[11,"eval_outlives","","",46,[[["self"],["mir"],["regionvid"],["regionvid"]],["bool"]]],[11,"check_universal_regions","","Once regions have been propagated, this method is used to see whether any of the constraints were too strong. In particular, we want to check for a case where a universally quantified region exceeded its bounds.  Consider:",46,[[["self"],["inferctxt"],["mir"],["defid"],["option",["vec"]],["vec"]]]],[11,"check_universal_region","","Check the final value for the free region `fr` to see if it grew too large. In particular, examine what `end(X)` points wound up in `fr`'s final value; for each `end(X)` where `X != fr`, we want to check that `fr: X`. If not, that's either an error, or something we have to propagate to our creator.",46,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["option"],["vec"]]]],[11,"check_bound_universal_region","","",46,[[["self"],["inferctxt"],["mir"],["defid"],["regionvid"],["universeindex"]]]],[11,"new","","",47,[[["universeindex"],["regionvariableorigin"]],["self"]]],[0,"renumber","rustc_mir::borrow_check::nll","",N,N],[3,"NLLVisitor","rustc_mir::borrow_check::nll::renumber","",N,N],[12,"infcx","","",63,N],[5,"renumber_mir","","Replaces all free regions appearing in the MIR with fresh inference variables, returning the number of variables created.",N,[[["inferctxt"],["mir"]]]],[5,"renumber_regions","","Replaces all regions appearing in `value` with fresh inference variables.",N,[[["inferctxt"],["t"]],["t"]]],[11,"renumber_regions","","",63,[[["self"],["t"]],["t"]]],[11,"visit_ty","","",63,[[["self"],["ty"],["tycontext"]]]],[11,"visit_substs","","",63,[[["self"],["substs"],["location"]]]],[11,"visit_region","","",63,[[["self"],["region"],["location"]]]],[11,"visit_const","","",63,[[["self"],["const"],["location"]]]],[11,"visit_generator_substs","","",63,[[["self"],["generatorsubsts"],["location"]]]],[11,"visit_closure_substs","","",63,[[["self"],["closuresubsts"],["location"]]]],[11,"visit_ascribe_user_ty","","",63,[[["self"],["place"],["variance"],["canonicalty"],["location"]]]],[11,"visit_statement","","",63,[[["self"],["basicblock"],["statement"],["location"]]]],[0,"type_check","rustc_mir::borrow_check::nll","This pass type-checks the MIR to ensure it is not broken.",N,N],[3,"TypeVerifier","rustc_mir::borrow_check::nll::type_check","Verifies that MIR types are sane to not crash further checks.",N,N],[12,"cx","","",64,N],[12,"mir","","",64,N],[12,"last_span","","",64,N],[12,"mir_def_id","","",64,N],[12,"errors_reported","","",64,N],[3,"TypeChecker","","The MIR type checker. Visits the MIR and enforces all the constraints needed for it to be valid and well-typed. Along the way, it accrues region constraints -- these can later be used by NLL region checking.",N,N],[12,"infcx","","",65,N],[12,"param_env","","",65,N],[12,"last_span","","",65,N],[12,"mir","","",65,N],[12,"mir_def_id","","",65,N],[12,"region_bound_pairs","","",65,N],[12,"implicit_region_bound","","",65,N],[12,"reported_errors","","",65,N],[12,"borrowck_context","","",65,N],[3,"BorrowCheckContext","","",N,N],[12,"universal_regions","","",66,N],[12,"location_table","","",66,N],[12,"all_facts","","",66,N],[12,"borrow_set","","",66,N],[12,"constraints","","",66,N],[3,"MirTypeckResults","","",N,N],[12,"constraints","","",67,N],[12,"universal_region_relations","","",67,N],[3,"MirTypeckRegionConstraints","","A collection of region constraints that must be satisfied for the program to be considered well-typed.",N,N],[12,"liveness_constraints","","In general, the type-checker is not responsible for enforcing liveness constraints; this job falls to the region inferencer, which performs a liveness analysis. However, in some limited cases, the MIR type-checker creates temporary regions that do not otherwise appear in the MIR -- in particular, the late-bound regions that it instantiates at call-sites -- and hence it must report on their liveness constraints.",68,N],[12,"outlives_constraints","","",68,N],[12,"type_tests","","",68,N],[3,"TypeckMir","","",N,N],[4,"FieldAccessError","","",N,N],[13,"OutOfRange","","",69,N],[12,"field_count","rustc_mir::borrow_check::nll::type_check::FieldAccessError","",69,N],[4,"Locations","rustc_mir::borrow_check::nll::type_check","The `Locations` type summarizes where region constraints are required to hold. Normally, this is at a particular point which created the obligation, but for constraints that the user gave, we want the constraint to hold at all points.",N,N],[13,"All","","Indicates that a type constraint should always be true. This is particularly important in the new borrowck analysis for things like the type of the return slot. Consider this example:",70,N],[13,"Boring","","A \"boring\" constraint (caused by the given location) is one that the user probably doesn't want to see described in diagnostics, because it is kind of an artifact of the type system setup.",70,N],[13,"Interesting","","An important outlives constraint (caused by the given location) is one that would be useful to highlight in diagnostics, because it represents a point where references flow from one spot to another (e.g., `x = y`)",70,N],[5,"type_check","","Type checks the given `mir` in the context of the inference context `infcx`. Returns any region constraints that have yet to be proven. This result is includes liveness constraints that ensure that regions appearing in the types of all local variables are live at all points where that local variable may later be used.",N,[[["inferctxt"],["paramenv"],["mir"],["defid"],["rc"],["locationtable"],["borrowset"],["option"],["flowatlocation"],["movedata"],["rc"]],["mirtypeckresults"]]],[5,"type_check_internal","","",N,N],[5,"mirbug","","",N,[[["tyctxt"],["span"],["str"]]]],[0,"constraint_conversion","","",N,N],[3,"ConstraintConversion","rustc_mir::borrow_check::nll::type_check::constraint_conversion","",N,N],[12,"tcx","","",71,N],[12,"universal_regions","","",71,N],[12,"location_table","","",71,N],[12,"region_bound_pairs","","",71,N],[12,"implicit_region_bound","","",71,N],[12,"param_env","","",71,N],[12,"locations","","",71,N],[12,"outlives_constraints","","",71,N],[12,"type_tests","","",71,N],[12,"all_facts","","",71,N],[11,"new","","",71,N],[11,"convert_all","","",71,N],[11,"convert","","",71,[[["self"],["queryregionconstraint"]]]],[11,"verify_to_type_test","","",71,[[["self"],["generickind"],["region"],["verifybound"]],["typetest"]]],[11,"verify_bound_to_region_test","","",71,[[["self"],["verifybound"]],["regiontest"]]],[11,"to_region_vid","","",71,[[["self"],["region"]],["regionvid"]]],[11,"add_outlives","","",71,[[["self"],["regionvid"],["regionvid"]]]],[11,"add_type_test","","",71,[[["self"],["typetest"]]]],[0,"free_region_relations","rustc_mir::borrow_check::nll::type_check","",N,N],[3,"UniversalRegionRelations","rustc_mir::borrow_check::nll::type_check::free_region_relations","",N,N],[12,"universal_regions","","",72,N],[12,"outlives","","Stores the outlives relations that are known to hold from the implied bounds, in-scope where clauses, and that sort of thing.",72,N],[12,"inverse_outlives","","This is the `<=` relation; that is, if `a: b`, then `b <= a`, and we store that here. This is useful when figuring out how to express some local region in terms of external regions our caller will understand.",72,N],[3,"CreateResult","","",N,N],[12,"universal_region_relations","","",73,N],[12,"region_bound_pairs","","",73,N],[12,"normalized_inputs_and_output","","",73,N],[3,"UniversalRegionRelationsBuilder","","",N,N],[12,"infcx","","",74,N],[12,"param_env","","",74,N],[12,"location_table","","",74,N],[12,"universal_regions","","",74,N],[12,"implicit_region_bound","","",74,N],[12,"constraints","","",74,N],[12,"all_facts","","",74,N],[12,"relations","","",74,N],[12,"region_bound_pairs","","",74,N],[5,"create","","",N,[[["inferctxt"],["paramenv"],["locationtable"],["option",["region"]],["rc"],["mirtypeckregionconstraints"],["option"]],["createresult"]]],[6,"RegionBoundPairs","","Each RBP `('a, GK)` indicates that `GK: 'a` can be assumed to be true. These encode relationships like `T: 'a` that are added via implicit bounds.",N,N],[6,"NormalizedInputsAndOutput","","As part of computing the free region relations, we also have to normalize the input-output types, which we then need later. So we return those.  This vector consists of first the input types and then the output type as the last element.",N,N],[11,"fmt","","",72,[[["self"],["formatter"]],["result"]]],[11,"relate_universal_regions","","Records in the `outlives_relation` (and `inverse_outlives_relation`) that `fr_a: fr_b`. Invoked by the builder below.",72,[[["self"],["regionvid"],["regionvid"]]]],[11,"postdom_upper_bound","","Given two universal regions, returns the postdominating upper-bound (effectively the least upper bound).",72,[[["self"],["regionvid"],["regionvid"]],["regionvid"]]],[11,"non_local_upper_bound","","Finds an \"upper bound\" for `fr` that is not local. In other words, returns the smallest (*) known region `fr1` that (a) outlives `fr` and (b) is not local. This cannot fail, because we will always find `'static` at worst.",72,[[["self"],["regionvid"]],["regionvid"]]],[11,"non_local_lower_bound","","Finds a \"lower bound\" for `fr` that is not local. In other words, returns the largest (*) known region `fr1` that (a) is outlived by `fr` and (b) is not local. This cannot fail, because we will always find `'static` at worst.",72,[[["self"],["regionvid"]],["option",["regionvid"]]]],[11,"non_local_bound","","Helper for `non_local_upper_bound` and `non_local_lower_bound`.  Repeatedly invokes `postdom_parent` until we find something that is not local. Returns None if we never do so.",72,[[["self"],["transitiverelation"],["regionvid"]],["option",["regionvid"]]]],[11,"outlives","","True if fr1 is known to outlive fr2.",72,[[["self"],["regionvid"],["regionvid"]],["bool"]]],[11,"regions_outlived_by","","Returns a vector of free regions `x` such that `fr1: x` is known to hold.",72,[[["self"],["regionvid"]],["vec",["regionvid"]]]],[11,"create","","",74,[[["self"]],["createresult"]]],[11,"add_implied_bounds","","Update the type of a single local, which should represent either the return type of the MIR or one of its arguments. At the same time, compute and add any implied bounds that come from this local.",74,[[["self"],["ty"]],["option",["rc"]]]],[11,"add_outlives_bounds","","Registers the `OutlivesBound` items from `outlives_bounds` in the outlives relation as well as the region-bound pairs listing.",74,[[["self"],["i"]]]],[11,"sub_free_regions","","",72,[[["self"],["region"],["region"]],["bool"]]],[0,"input_output","rustc_mir::borrow_check::nll::type_check","This module contains code to equate the input/output types appearing in the MIR with the expected input/output types from the function signature. This requires a bit of processing, as the expected types are supplied to us before normalization and may contain existential `impl Trait` instances. In contrast, the input/output types found in the MIR (specifically, in the special local variables for the `RETURN_PLACE` the MIR arguments) are always fully normalize (and contain revealed `impl Trait` values).",N,N],[3,"ObligationAccumulator","rustc_mir::borrow_check::nll::type_check::input_output","",N,N],[12,"obligations","","",75,N],[11,"equate_inputs_and_outputs","rustc_mir::borrow_check::nll::type_check","",65,N],[11,"equate_normalized_input_or_output","","",65,[[["self"],["ty"],["ty"]]]],[11,"fmt","rustc_mir::borrow_check::nll::type_check::input_output","",75,[[["self"],["formatter"]],["result"]]],[11,"default","","",75,[[],["obligationaccumulator"]]],[11,"add","","",75,[[["self"],["inferok"]],["t"]]],[11,"into_vec","","",75,[[["self"]],["predicateobligations"]]],[0,"liveness","rustc_mir::borrow_check::nll::type_check","",N,N],[5,"generate","rustc_mir::borrow_check::nll::type_check::liveness","Combines liveness analysis with initialization analysis to determine which variables are live at which points, both due to ordinary uses and drops. Returns a set of (ty, location) pairs that indicate which types must be live at which point in the CFG. This vector is consumed by `constraint_generation`.",N,[[["typechecker"],["mir"],["rc"],["flowatlocation"],["movedata"]]]],[5,"regions_that_outlive_free_regions","","Compute all regions that are (currently) known to outlive free regions. For these regions, we do not need to compute liveness, since the outlives constraints will ensure that they are live over the whole fn body anyhow.",N,[[["usize"],["universalregions"],["constraintset"]],["fxhashset",["regionvid"]]]],[0,"liveness_map","","For the NLL computation, we need to compute liveness, but only for those local variables whose types contain regions. The others are not of interest to us. This file defines a new index type (LiveVar) that indexes into a list of \"variables whose type contain regions\". It also defines a map from Local to LiveVar and vice versa -- this map can be given to the liveness code so that it only operates over variables with regions in their types, instead of all variables.",N,N],[3,"NllLivenessMap","rustc_mir::borrow_check::nll::type_check::liveness::liveness_map","Map between Local and LiveVar indices: the purpose of this map is to define the subset of local variables for which we need to do a liveness computation. We only need to compute whether a variable `X` is live if that variable contains some region `R` in its type where `R` is not known to outlive a free region (i.e., where `R` may be valid for just a subset of the fn body).",N,N],[12,"from_local","","For each local variable, contains `Some(i)` if liveness is needed for this variable.",76,N],[12,"to_local","","For each `LiveVar`, maps back to the original `Local` index.",76,N],[3,"LiveVar","","",N,N],[12,"private","","",77,N],[11,"from_local","","",76,[[["self"],["local"]],["option"]]],[11,"from_live_var","","",76,N],[11,"num_variables","","",76,[[["self"]],["usize"]]],[11,"compute","","",76,[[["tyctxt"],["fxhashset"],["mir"]],["self"]]],[11,"is_empty","","True if there are no local variables that need liveness computation.",76,[[["self"]],["bool"]]],[11,"clone","","",77,[[["self"]],["livevar"]]],[11,"eq","","",77,[[["self"],["livevar"]],["bool"]]],[11,"ne","","",77,[[["self"],["livevar"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",77,N],[11,"hash","","",77,N],[11,"partial_cmp","","",77,[[["self"],["livevar"]],["option",["ordering"]]]],[11,"lt","","",77,[[["self"],["livevar"]],["bool"]]],[11,"le","","",77,[[["self"],["livevar"]],["bool"]]],[11,"gt","","",77,[[["self"],["livevar"]],["bool"]]],[11,"ge","","",77,[[["self"],["livevar"]],["bool"]]],[11,"cmp","","",77,[[["self"],["livevar"]],["ordering"]]],[11,"decode","","",77,[[["__d"]],["result",["livevar"]]]],[11,"encode","","",77,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",77,N],[18,"MAX","","",77,N],[11,"from_usize","","",77,[[["usize"]],["self"]]],[11,"from_u32","","",77,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",77,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",77,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",77,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",77,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",77,[[["self"]],["usize"]]],[11,"new","","",77,[[["usize"]],["self"]]],[11,"index","","",77,[[["self"]],["usize"]]],[11,"steps_between","","",77,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",77,[[["self"]],["self"]]],[11,"replace_zero","","",77,[[["self"]],["self"]]],[11,"add_one","","",77,[[["self"]],["self"]]],[11,"sub_one","","",77,[[["self"]],["self"]]],[11,"add_usize","","",77,[[["self"],["usize"]],["option"]]],[11,"from","","",77,[[["usize"]],["self"]]],[11,"from","","",77,[[["u32"]],["self"]]],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[0,"local_use_map","rustc_mir::borrow_check::nll::type_check::liveness","",N,N],[3,"LocalUseMap","rustc_mir::borrow_check::nll::type_check::liveness::local_use_map","A map that cross references each local with the locations where it is defined (assigned), used, or dropped. Used during liveness computation.",N,N],[12,"liveness_map","","",78,N],[12,"first_def_at","","Head of a linked list of definitions of each variable -- definition in this context means assignment, e.g. `x` is defined in `x = y` but not `y`; that first def is the head of a linked list that lets you enumerate all places the variable is assigned.",78,N],[12,"first_use_at","","Head of a linked list of uses of each variable -- use in this context means that the existing value of the variable is read or modified. e.g., `y` is used in `x = y` but not `x`. Note that `DROP(x)` terminators are excluded from this list.",78,N],[12,"first_drop_at","","Head of a linked list of drops of each variable -- these are a special category of uses corresponding to the drop that we add for each local variable.",78,N],[12,"appearances","","",78,N],[3,"Appearance","","",N,N],[12,"point_index","","",79,N],[12,"next","","",79,N],[3,"AppearanceIndex","","",N,N],[12,"private","","",80,N],[3,"LocalUseMapBuild","","",N,N],[12,"local_use_map","","",81,N],[12,"elements","","",81,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[11,"clone","","",80,[[["self"]],["appearanceindex"]]],[11,"eq","","",80,[[["self"],["appearanceindex"]],["bool"]]],[11,"ne","","",80,[[["self"],["appearanceindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",80,N],[11,"hash","","",80,N],[11,"partial_cmp","","",80,[[["self"],["appearanceindex"]],["option",["ordering"]]]],[11,"lt","","",80,[[["self"],["appearanceindex"]],["bool"]]],[11,"le","","",80,[[["self"],["appearanceindex"]],["bool"]]],[11,"gt","","",80,[[["self"],["appearanceindex"]],["bool"]]],[11,"ge","","",80,[[["self"],["appearanceindex"]],["bool"]]],[11,"cmp","","",80,[[["self"],["appearanceindex"]],["ordering"]]],[11,"decode","","",80,[[["__d"]],["result",["appearanceindex"]]]],[11,"encode","","",80,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",80,N],[18,"MAX","","",80,N],[11,"from_usize","","",80,[[["usize"]],["self"]]],[11,"from_u32","","",80,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",80,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",80,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",80,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",80,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",80,[[["self"]],["usize"]]],[11,"new","","",80,[[["usize"]],["self"]]],[11,"index","","",80,[[["self"]],["usize"]]],[11,"steps_between","","",80,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",80,[[["self"]],["self"]]],[11,"replace_zero","","",80,[[["self"]],["self"]]],[11,"add_one","","",80,[[["self"]],["self"]]],[11,"sub_one","","",80,[[["self"]],["self"]]],[11,"add_usize","","",80,[[["self"],["usize"]],["option"]]],[11,"from","","",80,[[["usize"]],["self"]]],[11,"from","","",80,[[["u32"]],["self"]]],[11,"fmt","","",80,[[["self"],["formatter"]],["result"]]],[11,"next","","",79,[[["self"]],["option",["appearanceindex"]]]],[11,"build","","",78,[[["nlllivenessmap"],["regionvalueelements"],["mir"]],["self"]]],[11,"defs","","",78,N],[11,"uses","","",78,N],[11,"drops","","",78,N],[11,"insert_def","","",81,[[["self"],["livevar"],["location"]]]],[11,"insert_use","","",81,[[["self"],["livevar"],["location"]]]],[11,"insert_drop","","",81,[[["self"],["livevar"],["location"]]]],[11,"insert","","",81,[[["regionvalueelements"],["option"],["indexvec"],["location"]]]],[11,"visit_local","","",81,[[["self"],["local"],["placecontext"],["location"]]]],[0,"trace","rustc_mir::borrow_check::nll::type_check::liveness","",N,N],[3,"LivenessContext","rustc_mir::borrow_check::nll::type_check::liveness::trace","Contextual state for the type-liveness generator.",N,N],[12,"typeck","","Current type-checker, giving us our inference context etc.",82,N],[12,"elements","","Defines the `PointIndex` mapping",82,N],[12,"mir","","MIR we are analyzing.",82,N],[12,"move_data","","Mapping to/from the various indices used for initialization tracking.",82,N],[12,"drop_data","","Cache for the results of `dropck_outlives` query.",82,N],[12,"flow_inits","","Results of dataflow tracking which variables (and paths) have been initialized.",82,N],[12,"local_use_map","","Index indicating where each variable is assigned, used, or dropped.",82,N],[12,"liveness_map","","Map tracking which variables need liveness computation.",82,N],[3,"DropData","","",N,N],[12,"dropck_result","","",83,N],[12,"region_constraint_data","","",83,N],[3,"LivenessResults","","",N,N],[12,"cx","","",84,N],[12,"defs","","Set of points that define the current local.",84,N],[12,"use_live_at","","Points where the current variable is \"use live\" -- meaning that there is a future \"full use\" that may use its value.",84,N],[12,"drop_live_at","","Points where the current variable is \"drop live\" -- meaning that there is no future \"full use\" that may use its value, but there is a future drop.",84,N],[12,"drop_locations","","Locations where drops may occur.",84,N],[12,"stack","","Stack used when doing (reverse) DFS.",84,N],[5,"trace","","This is the heart of the liveness computation. For each variable X that requires a liveness computation, it walks over all the uses of X and does a reverse depth-first search (\"trace\") through the MIR. This search stops when we find a definition of that variable. The points visited in this search is the USE-LIVE set for the variable; of those points is added to all the regions that appear in the variable's type.",N,[[["typechecker"],["mir"],["rc"],["flowatlocation"],["movedata"],["nlllivenessmap"]]]],[11,"new","","",84,[[["livenesscontext"]],["self"]]],[11,"compute_for_all_locals","","",84,[[["self"]]]],[11,"reset_local_state","","Clear the value of fields that are \"per local variable\".",84,[[["self"]]]],[11,"add_defs_for","","Adds the definitions of `local` into `self.defs`.",84,[[["self"],["livevar"]]]],[11,"compute_use_live_points_for","","Compute all points where local is \"use live\" -- meaning its current value may be used later (except by a drop). This is done by walking backwards from each use of `live_local` until we find a `def` of local.",84,[[["self"],["livevar"]]]],[11,"compute_drop_live_points_for","","Compute all points where local is \"drop live\" -- meaning its current value may be dropped later (but not used). This is done by iterating over the drops of `local` where `local` (or some subpart of `local`) is initialized. For each such drop, we walk backwards until we find a point where `local` is either defined or use-live.",84,[[["self"],["livevar"]]]],[11,"compute_drop_live_points_for_block","","Executes one iteration of the drop-live analysis loop.",84,[[["self"],["movepathindex"],["pointindex"]]]],[11,"initialized_at_terminator","","True if the local variable (or some part of it) is initialized in the terminator of `block`. We need to check this to determine if a DROP of some local variable will have an effect -- note that drops, as they may unwind, are always terminators.",82,[[["self"],["basicblock"],["movepathindex"]],["bool"]]],[11,"initialized_at_exit","","True if the path `mpi` (or some part of it) is initialized at the exit of `block`.",82,[[["self"],["basicblock"],["movepathindex"]],["bool"]]],[11,"add_use_live_facts_for","","Store the result that all regions in `value` are live for the points `live_at`.",82,N],[11,"add_drop_live_facts_for","","Some variable with type `live_ty` is \"drop live\" at `location` -- i.e., it may be dropped later. This means that some of the regions in its type must be live at `location`. The precise set will depend on the dropck constraints, and in particular this takes `#[may_dangle]` into account.",82,N],[11,"make_all_regions_live","","",82,N],[11,"compute_drop_data","","",82,[[["typechecker"],["ty"]],["dropdata"]]],[0,"relate_tys","rustc_mir::borrow_check::nll::type_check","",N,N],[3,"TypeRelating","rustc_mir::borrow_check::nll::type_check::relate_tys","",N,N],[12,"infcx","","",85,N],[12,"ambient_variance","","How are we relating `a` and `b`?",85,N],[12,"a_scopes","","When we pass through a set of binders (e.g., when looking into a `fn` type), we push a new bound region scope onto here.  This will contain the instantiated region for each region in those binders. When we then encounter a `ReLateBound(d, br)`, we can use the debruijn index `d` to find the right scope, and then bound region name `br` to find the specific instantiation from within that scope. See `replace_bound_region`.",85,N],[12,"b_scopes","","Same as `a_scopes`, but for the `b` type.",85,N],[12,"locations","","Where (and why) is this relation taking place?",85,N],[12,"borrowck_context","","This will be `Some` when we are running the type check as part of NLL, and `None` if we are running a \"sanity check\".",85,N],[12,"canonical_var_values","","As we execute, the type on the LHS may come from a canonical source. In that case, we will sometimes find a constraint like `?0 = B`, where `B` is a type from the RHS. The first time we find that, we simply record `B` (and the list of scopes that tells us how to interpret `B`). The next time we encounter `?0`, then, we can read this value out and use it.",85,N],[3,"ScopesAndKind","","",N,N],[12,"scopes","","",86,N],[12,"kind","","",86,N],[3,"BoundRegionScope","","",N,N],[12,"map","","",87,N],[3,"UniversallyQuantified","","",N,N],[12,"0","","",88,N],[3,"ScopeInstantiator","","When we encounter a binder like `for<..> fn(..)`, we actually have to walk the `fn` value to find all the values bound by the `for` (these are not explicitly present in the ty representation right now). This visitor handles that: it descends the type, tracking binder depth, and finds late-bound regions targeting the `for<..`>.  For each of those, it creates an entry in `bound_region_scope`.",N,N],[12,"infcx","","",89,N],[12,"target_index","","",89,N],[12,"universally_quantified","","",89,N],[12,"bound_region_scope","","",89,N],[3,"TypeGeneralizer","","The \"type generalize\" is used when handling inference variables.",N,N],[12,"type_rel","","",90,N],[12,"ambient_variance","","After we generalize this type, we are going to relative it to some other type. What will be the variance at this point?",90,N],[12,"first_free_index","","",90,N],[12,"universe","","",90,N],[5,"sub_types","","Adds sufficient constraints to ensure that `a <: b`.",N,[[["inferctxt"],["ty"],["ty"],["locations"],["option",["borrowcheckcontext"]]],["fallible"]]],[5,"eq_types","","Adds sufficient constraints to ensure that `a == b`.",N,[[["inferctxt"],["ty"],["ty"],["locations"],["option",["borrowcheckcontext"]]],["fallible"]]],[5,"relate_type_and_user_type","","Adds sufficient constraints to ensure that `a <: b`, where `b` is a user-given type (which means it may have canonical variables encoding things like `_`).",N,[[["inferctxt"],["ty"],["variance"],["canonicalty"],["locations"],["option",["borrowcheckcontext"]]],["fallible"]]],[11,"clone","","",86,[[["self"]],["scopesandkind"]]],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[11,"clone","","",87,[[["self"]],["boundregionscope"]]],[11,"fmt","","",87,[[["self"],["formatter"]],["result"]]],[11,"default","","",87,[[],["boundregionscope"]]],[11,"clone","","",88,[[["self"]],["universallyquantified"]]],[11,"new","","",85,[[["inferctxt"],["variance"],["locations"],["option",["borrowcheckcontext"]],["canonicalvarinfos"]],["self"]]],[11,"ambient_covariance","","",85,[[["self"]],["bool"]]],[11,"ambient_contravariance","","",85,[[["self"]],["bool"]]],[11,"create_scope","","",85,[[["self"],["binder"],["universallyquantified"]],["boundregionscope"]]],[11,"lookup_bound_region","","When we encounter binders during the type traversal, we record the value to substitute for each of the things contained in that binder. (This will be either a universal placeholder or an existential inference variable.) Given the debruijn index `debruijn` (and name `br`) of some binder we have now encountered, this routine finds the value that we instantiated the region with; to do so, it indexes backwards into the list of ambient scopes `scopes`.",85,N],[11,"replace_bound_region","","If `r` is a bound region, find the scope in which it is bound (from `scopes`) and return the value that we instantiated it with. Otherwise just return `r`.",85,N],[11,"push_outlives","","Push a new outlives requirement into our output set of constraints.",85,[[["self"],["regionvid"],["regionvid"]]]],[11,"relate_var","","When we encounter a canonical variable `var` in the output, equate it with `kind`. If the variable has been previously equated, then equate it again.",85,[[["self"],["canonicalvar"],["kind"]],["relateresult",["kind"]]]],[11,"generalize_value","","",85,[[["self"],["kind"]],["kind"]]],[11,"tcx","","",85,[[["self"]],["tyctxt"]]],[11,"tag","","",85,[[["self"]],["str"]]],[11,"a_is_expected","","",85,[[["self"]],["bool"]]],[11,"relate_with_variance","","",85,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",85,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",85,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",85,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[11,"visit_binder","","",89,[[["self"],["binder"]],["bool"]]],[11,"visit_region","","",89,[[["self"],["region"]],["bool"]]],[11,"tcx","","",90,[[["self"]],["tyctxt"]]],[11,"tag","","",90,[[["self"]],["str"]]],[11,"a_is_expected","","",90,[[["self"]],["bool"]]],[11,"relate_with_variance","","",90,[[["self"],["variance"],["t"],["t"]],["relateresult"]]],[11,"tys","","",90,[[["self"],["ty"],["ty"]],["relateresult",["ty"]]]],[11,"regions","","",90,[[["self"],["region"],["region"]],["relateresult",["region"]]]],[11,"binders","","",90,[[["self"],["binder"],["binder"]],["relateresult",["binder"]]]],[8,"AtLocation","rustc_mir::borrow_check::nll::type_check","",N,N],[10,"boring","","Indicates a \"boring\" constraint that the user probably woudln't want to see highlights.",91,[[["self"]],["locations"]]],[10,"interesting","","Indicates an \"interesting\" edge, which is of significance only for diagnostics.",91,[[["self"]],["locations"]]],[8,"NormalizeLocation","","",N,N],[10,"to_locations","","",92,[[["self"]],["locations"]]],[11,"visit_span","","",64,[[["self"],["span"]]]],[11,"visit_place","","",64,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_constant","","",64,[[["self"],["constant"],["location"]]]],[11,"visit_rvalue","","",64,[[["self"],["rvalue"],["location"]]]],[11,"visit_local_decl","","",64,[[["self"],["local"],["localdecl"]]]],[11,"visit_mir","","",64,[[["self"],["mir"]]]],[11,"new","","",64,[[["typechecker"],["mir"]],["self"]]],[11,"tcx","","",64,[[["self"]],["tyctxt"]]],[11,"sanitize_type","","",64,[[["self"],["debug"],["ty"]],["ty"]]],[11,"sanitize_constant","","Checks that the constant's `ty` field matches up with what would be expected from its literal.",64,[[["self"],["constant"],["location"]]]],[11,"sanitize_place","","Checks that the types internal to the `place` match up with what would be expected.",64,[[["self"],["place"],["location"],["placecontext"]],["placety"]]],[11,"sanitize_projection","","",64,[[["self"],["placety"],["placeelem"],["place"],["location"]],["placety"]]],[11,"error","","",64,[[["self"]],["ty"]]],[11,"field_ty","","",64,[[["self"],["debug"],["placety"],["field"],["location"]],["result",["ty","fieldaccesserror"]]]],[11,"clone","","",70,[[["self"]],["locations"]]],[11,"eq","","",70,[[["self"],["locations"]],["bool"]]],[11,"ne","","",70,[[["self"],["locations"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",70,N],[11,"partial_cmp","","",70,[[["self"],["locations"]],["option",["ordering"]]]],[11,"lt","","",70,[[["self"],["locations"]],["bool"]]],[11,"le","","",70,[[["self"],["locations"]],["bool"]]],[11,"gt","","",70,[[["self"],["locations"]],["bool"]]],[11,"ge","","",70,[[["self"],["locations"]],["bool"]]],[11,"cmp","","",70,[[["self"],["locations"]],["ordering"]]],[11,"hash","","",70,N],[11,"fmt","","",70,[[["self"],["formatter"]],["result"]]],[11,"from_location","","",70,[[["self"]],["option",["location"]]]],[11,"span","","Gets a span representing the location.",70,[[["self"],["mir"]],["span"]]],[11,"new","","",65,N],[11,"fully_perform_op","","Given some operation `op` that manipulates types, proves predicates, or otherwise uses the inference context, executes `op` and then executes all the further obligations that `op` returns. This will yield a set of outlives constraints amongst regions which are extracted and stored as having occurred at `locations`.",65,N],[11,"push_region_constraints","","",65,N],[11,"sub_types","","",65,[[["self"],["ty"],["ty"],["locations"]],["fallible"]]],[11,"eq_types","","",65,[[["self"],["ty"],["ty"],["locations"]],["fallible"]]],[11,"relate_type_and_user_type","","",65,[[["self"],["ty"],["variance"],["canonicalty"],["locations"]],["fallible"]]],[11,"tcx","","",65,[[["self"]],["tyctxt"]]],[11,"check_stmt","","",65,[[["self"],["mir"],["statement"],["location"]]]],[11,"check_terminator","","",65,[[["self"],["mir"],["terminator"],["location"]]]],[11,"check_call_dest","","",65,[[["self"],["mir"],["terminator"],["fnsig"],["option"],["location"]]]],[11,"check_call_inputs","","",65,N],[11,"check_iscleanup","","",65,[[["self"],["mir"],["basicblockdata"]]]],[11,"assert_iscleanup","","",65,[[["self"],["mir"],["debug"],["basicblock"],["bool"]]]],[11,"check_local","","",65,[[["self"],["mir"],["local"],["localdecl"]]]],[11,"ensure_place_sized","","",65,[[["self"],["ty"],["span"]]]],[11,"aggregate_field_ty","","",65,[[["self"],["aggregatekind"],["usize"],["location"]],["result",["ty","fieldaccesserror"]]]],[11,"check_rvalue","","",65,[[["self"],["mir"],["rvalue"],["location"]]]],[11,"rvalue_user_ty","","If this rvalue supports a user-given type annotation, then extract and return it. This represents the final type of the rvalue and will be unified with the inferred type.",65,[[["self"],["rvalue"]],["option",["canonicalty"]]]],[11,"check_aggregate_rvalue","","",65,N],[11,"add_reborrow_constraint","","Add the constraints that arise from a borrow expression `&'a P` at the location `L`.",65,[[["self"],["location"],["region"],["place"]]]],[11,"prove_aggregate_predicates","","",65,[[["self"],["aggregatekind"],["location"]]]],[11,"prove_trait_ref","","",65,[[["self"],["traitref"],["locations"]]]],[11,"normalize_and_prove_instantiated_predicates","","",65,[[["self"],["instantiatedpredicates"],["locations"]]]],[11,"prove_predicates","","",65,N],[11,"prove_predicate","","",65,[[["self"],["predicate"],["locations"]]]],[11,"typeck_mir","","",65,[[["self"],["mir"]]]],[11,"normalize","","",65,N],[11,"run_pass","","",93,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"to_locations","","",70,[[["self"]],["locations"]]],[0,"universal_regions","rustc_mir::borrow_check::nll","Code to extract the universally quantified regions declared on a function and the relationships between them. For example:",N,N],[3,"UniversalRegions","rustc_mir::borrow_check::nll::universal_regions","",N,N],[12,"indices","","",94,N],[12,"fr_static","","The vid assigned to `'static`",94,N],[12,"fr_fn_body","","A special region vid created to represent the current MIR fn body.  It will outlive the entire CFG but it will not outlive any other universal regions.",94,N],[12,"first_extern_index","","We create region variables such that they are ordered by their `RegionClassification`. The first block are globals, then externals, then locals. So things from: - `FIRST_GLOBAL_INDEX..first_extern_index` are global; - `first_extern_index..first_local_index` are external; and - `first_local_index..num_universals` are local.",94,N],[12,"first_local_index","","See `first_extern_index`.",94,N],[12,"num_universals","","The total number of universal region variables instantiated.",94,N],[12,"defining_ty","","The \"defining\" type for this function, with all universal regions instantiated.  For a closure or generator, this is the closure type, but for a top-level function it's the `FnDef`.",94,N],[12,"unnormalized_output_ty","","The return type of this function, with all regions replaced by their universal `RegionVid` equivalents.",94,N],[12,"unnormalized_input_tys","","The fully liberated input types of this function, with all regions replaced by their universal `RegionVid` equivalents.",94,N],[12,"yield_ty","","",94,N],[3,"UniversalRegionIndices","","",N,N],[12,"indices","","For those regions that may appear in the parameter environment ('static and early-bound regions), we maintain a map from the `ty::Region` to the internal `RegionVid` we are using. This is used because trait matching and type-checking will feed us region constraints that reference those regions and we need to be able to map them our internal `RegionVid`. This is basically equivalent to a `Substs`, except that it also contains an entry for `ReStatic` -- it might be nice to just use a substs, and then handle `ReStatic` another way.",95,N],[3,"UniversalRegionsBuilder","","",N,N],[12,"infcx","","",96,N],[12,"mir_def_id","","",96,N],[12,"mir_hir_id","","",96,N],[12,"mir_node_id","","",96,N],[12,"param_env","","",96,N],[4,"DefiningTy","","The \"defining type\" for this MIR. The key feature of the \"defining type\" is that it contains the information needed to derive all the universal regions that are in scope as well as the types of the inputs/output from the MIR. In general, early-bound universal regions appear free in the defining type and late-bound regions appear bound in the signature.",N,N],[13,"Closure","","The MIR is a closure. The signature is found via `ClosureSubsts::closure_sig_ty`.",97,N],[13,"Generator","","The MIR is a generator. The signature is that generators take no parameters and return the result of `ClosureSubsts::generator_return_ty`.",97,N],[13,"FnDef","","The MIR is a fn item with the given def-id and substs. The signature of the function can be bound then with the `fn_sig` query.",97,N],[13,"Const","","The MIR represents some form of constant. The signature then is that it has no inputs and a single return value, which is the value of the constant.",97,N],[4,"RegionClassification","","",N,N],[13,"Global","","A global region is one that can be named from anywhere. There is only one, `'static`.",98,N],[13,"External","","An external region is only relevant for closures. In that case, it refers to regions that are free in the closure type -- basically, something bound in the surrounding context.",98,N],[13,"Local","","A local lifetime is one about which we know the full set of relevant constraints (that is, relationships to other named regions).  For a closure, this includes any region bound in the closure's signature.  For a fn item, this includes all regions other than global ones.",98,N],[5,"for_each_late_bound_region_defined_on","","Iterates over the late-bound regions defined on fn_def_id and invokes `f` with the liberated form of each one.",N,N],[22,"","","",N,N],[22,"","","",N,N],[22,"","","",N,N],[17,"FIRST_GLOBAL_INDEX","","",N,N],[17,"FR","","",N,N],[8,"InferCtxtExt","","",N,N],[10,"replace_free_regions_with_nll_infer_vars","","",99,[[["self"],["nllregionvariableorigin"],["t"]],["t"]]],[10,"replace_bound_regions_with_nll_infer_vars","","",99,[[["self"],["nllregionvariableorigin"],["defid"],["binder"],["universalregionindices"]],["t"]]],[10,"replace_late_bound_regions_with_nll_infer_vars","","",99,[[["self"],["defid"],["universalregionindices"]]]],[11,"fmt","","",94,[[["self"],["formatter"]],["result"]]],[11,"clone","","",97,[[["self"]],["definingty"]]],[11,"fmt","","",97,[[["self"],["formatter"]],["result"]]],[11,"upvar_tys","","Returns a list of all the upvar types for this MIR. If this is not a closure or generator, there are no upvars, and hence it will be an empty list. The order of types in this list will match up with the `upvar_decls` field of `Mir`.",97,N],[11,"implicit_inputs","","Number of implicit inputs -- notably the \"environment\" parameter for closures -- that appear in MIR but not in the user's code.",97,[[["self"]],["usize"]]],[11,"fmt","","",95,[[["self"],["formatter"]],["result"]]],[11,"clone","","",98,[[["self"]],["regionclassification"]]],[11,"fmt","","",98,[[["self"],["formatter"]],["result"]]],[11,"eq","","",98,[[["self"],["regionclassification"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",98,N],[11,"hash","","",98,N],[11,"new","","Creates a new and fully initialized `UniversalRegions` that contains indices for all the free regions found in the given MIR -- that is, all the regions that appear in the function's signature. This will also compute the relationships that are known between those regions.",94,[[["inferctxt"],["defid"],["paramenv"]],["self"]]],[11,"closure_mapping","","Given a reference to a closure type, extracts all the values from its free regions and returns a vector with them. This is used when the closure's creator checks that the `ClosureRegionRequirements` are met. The requirements from `ClosureRegionRequirements` are expressed in terms of `RegionVid` entries that map into the returned vector `V`: so if the `ClosureRegionRequirements` contains something like `'1: '2`, then the caller would impose the constraint that `V[1]: V[2]`.",94,[[["tyctxt"],["ty"],["usize"],["defid"]],["indexvec",["regionvid","region"]]]],[11,"is_universal_region","","True if `r` is a member of this set of universal regions.",94,[[["self"],["regionvid"]],["bool"]]],[11,"region_classification","","Classifies `r` as a universal region, returning `None` if this is not a member of this set of universal regions.",94,[[["self"],["regionvid"]],["option",["regionclassification"]]]],[11,"universal_regions","","Returns an iterator over all the RegionVids corresponding to universally quantified free regions.",94,N],[11,"is_local_free_region","","True if `r` is classified as an local region.",94,[[["self"],["regionvid"]],["bool"]]],[11,"len","","Returns the number of universal regions created in any category.",94,[[["self"]],["usize"]]],[11,"num_global_and_external_regions","","Returns the number of global plus external universal regions. For closures, these are the regions that appear free in the closure type (versus those bound in the closure signature). They are therefore the regions between which the closure may impose constraints that its creator must verify.",94,[[["self"]],["usize"]]],[11,"named_universal_regions","","Get an iterator over all the early-bound regions that have names.",94,N],[11,"to_region_vid","","See `UniversalRegionIndices::to_region_vid`.",94,[[["self"],["region"]],["regionvid"]]],[11,"annotate","","As part of the NLL unit tests, you can annotate a function with `#[rustc_regions]`, and we will emit information about the region inference context and -- in particular -- the external constraints that this region imposes on others. The methods in this file handle the part about dumping the inference context internal state.",94,[[["self"],["tyctxt"],["diagnosticbuilder"]]]],[11,"build","","",96,[[["self"]],["universalregions"]]],[11,"defining_ty","","Returns the \"defining type\" of the current MIR; see `DefiningTy` for details.",96,[[["self"]],["definingty"]]],[11,"compute_indices","","Builds a hashmap that maps from the universal regions that are in scope (as a `ty::Region<'tcx>`) to their indices (as a `RegionVid`). The map returned by this function contains only the early-bound regions.",96,[[["self"],["regionvid"],["definingty"]],["universalregionindices"]]],[11,"compute_inputs_and_output","","",96,[[["self"],["universalregionindices"],["definingty"]],["binder",["list"]]]],[11,"insert_late_bound_region","","Initially, the `UniversalRegionIndices` map contains only the early-bound regions in scope. Once that is all setup, we come in later and instantiate the late-bound regions, and then we insert the `ReFree` version of those into the map as well. These are used for error reporting.",95,[[["self"],["region"],["regionvid"]]]],[11,"to_region_vid","","Converts `r` into a local inference variable: `r` can either by a `ReVar` (i.e., already a reference to an inference variable) or it can be `'static` or some early-bound region. This is useful when taking the results from type-checking and trait-matching, which may sometimes reference those regions from the `ParamEnv`. It is also used during initialization. Relies on the `indices` map having been fully initialized.",95,[[["self"],["region"]],["regionvid"]]],[11,"fold_to_region_vids","","Replace all free regions in `value` with region vids, as returned by `to_region_vid`.",95,[[["self"],["tyctxt"],["t"]],["t"]]],[0,"constraints","rustc_mir::borrow_check::nll","",N,N],[3,"ConstraintSet","rustc_mir::borrow_check::nll::constraints","",N,N],[12,"constraints","","",100,N],[3,"OutlivesConstraint","","",N,N],[12,"sup","","The region SUP must outlive SUB...",101,N],[12,"sub","","Region that must be outlived.",101,N],[12,"locations","","Where did this constraint arise?",101,N],[3,"ConstraintIndex","","",N,N],[12,"private","","",102,N],[3,"ConstraintSccIndex","","",N,N],[12,"private","","",103,N],[0,"graph","","",N,N],[3,"ConstraintGraph","rustc_mir::borrow_check::nll::constraints::graph","The construct graph organizes the constraints by their end-points. It can be used to view a `R1: R2` constraint as either an edge `R1 -> R2` or `R2 -> R1` depending on the direction type `D`.",N,N],[12,"_direction","","",104,N],[12,"first_constraints","","",104,N],[12,"next_constraints","","",104,N],[3,"Normal","","In normal mode, a `R1: R2` constraint results in an edge `R1 -> R2`. This is what we use when constructing the SCCs for inference. This is because we compute the value of R1 by union'ing all the things that it relies on.",N,N],[3,"Reverse","","In reverse mode, a `R1: R2` constraint results in an edge `R2 -> R1`. We use this for optimizing liveness computation, because then we wish to iterate from a region (e.g., R2) to all the regions that will outlive it (e.g., R1).",N,N],[3,"Edges","","",N,N],[12,"graph","","",105,N],[12,"constraints","","",105,N],[12,"pointer","","",105,N],[12,"next_static_idx","","",105,N],[12,"static_region","","",105,N],[3,"RegionGraph","","This struct brings together a constraint set and a (normal, not reverse) constraint graph. It implements the graph traits and is usd for doing the SCC computation.",N,N],[12,"set","","",106,N],[12,"constraint_graph","","",106,N],[12,"static_region","","",106,N],[3,"Successors","","",N,N],[12,"edges","","",107,N],[6,"NormalConstraintGraph","","",N,N],[6,"ReverseConstraintGraph","","",N,N],[8,"ConstraintGraphDirecton","","Marker trait that controls whether a `R1: R2` constraint represents an edge `R1 -> R2` or `R2 -> R1`.",N,N],[10,"start_region","","",108,[[["outlivesconstraint"]],["regionvid"]]],[10,"end_region","","",108,[[["outlivesconstraint"]],["regionvid"]]],[10,"is_normal","","",108,[[],["bool"]]],[11,"clone","","",109,[[["self"]],["normal"]]],[11,"fmt","","",109,[[["self"],["formatter"]],["result"]]],[11,"start_region","","",109,[[["outlivesconstraint"]],["regionvid"]]],[11,"end_region","","",109,[[["outlivesconstraint"]],["regionvid"]]],[11,"is_normal","","",109,[[],["bool"]]],[11,"clone","","",110,[[["self"]],["reverse"]]],[11,"fmt","","",110,[[["self"],["formatter"]],["result"]]],[11,"start_region","","",110,[[["outlivesconstraint"]],["regionvid"]]],[11,"end_region","","",110,[[["outlivesconstraint"]],["regionvid"]]],[11,"is_normal","","",110,[[],["bool"]]],[11,"new","","Create a \"dependency graph\" where each region constraint `R1: R2` is treated as an edge `R1 -> R2`. We use this graph to construct SCCs for region inference but also for error reporting.",104,[[["d"],["constraintset"],["usize"]],["self"]]],[11,"region_graph","","Given the constraint set from which this graph was built creates a region graph so that you can iterate over regions and not constraints.",104,[[["self"],["constraintset"],["regionvid"]],["regiongraph"]]],[11,"outgoing_edges","","Given a region `R`, iterate over all constraints `R: R1`.",104,[[["self"],["regionvid"],["constraintset"],["regionvid"]],["edges"]]],[11,"next","","",105,[[["self"]],["option"]]],[11,"new","","Create a \"dependency graph\" where each region constraint `R1: R2` is treated as an edge `R1 -> R2`. We use this graph to construct SCCs for region inference but also for error reporting.",106,[[["constraintset"],["constraintgraph"],["regionvid"]],["self"]]],[11,"outgoing_regions","","Given a region `R`, iterate over all regions `R1` such that there exists a constraint `R: R1`.",106,[[["self"],["regionvid"]],["successors"]]],[11,"next","","",107,[[["self"]],["option"]]],[11,"num_nodes","","",106,[[["self"]],["usize"]]],[11,"successors","","",106,N],[11,"clone","rustc_mir::borrow_check::nll::constraints","",100,[[["self"]],["constraintset"]]],[11,"default","","",100,[[],["constraintset"]]],[11,"push","","",100,[[["self"],["outlivesconstraint"]]]],[11,"graph","","Constructs a \"normal\" graph from the constraint set; the graph makes it easy to find the constraints affecting a particular region.",100,[[["self"],["usize"]],["constraintgraph",["normal"]]]],[11,"reverse_graph","","Like `graph`, but constraints a reverse graph where `R1: R2` represents an edge `R2 -> R1`.",100,[[["self"],["usize"]],["constraintgraph",["reverse"]]]],[11,"compute_sccs","","Compute cycles (SCCs) in the graph of regions. In particular, find all regions R1, R2 such that R1: R2 and R2: R1 and group them into an SCC, and find the relationships between SCCs.",100,[[["self"],["constraintgraph"],["regionvid"]],["sccs",["regionvid","constraintsccindex"]]]],[11,"deref","","",100,N],[11,"clone","","",101,[[["self"]],["outlivesconstraint"]]],[11,"eq","","",101,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"ne","","",101,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",101,N],[11,"partial_cmp","","",101,[[["self"],["outlivesconstraint"]],["option",["ordering"]]]],[11,"lt","","",101,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"le","","",101,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"gt","","",101,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"ge","","",101,[[["self"],["outlivesconstraint"]],["bool"]]],[11,"cmp","","",101,[[["self"],["outlivesconstraint"]],["ordering"]]],[11,"hash","","",101,N],[11,"fmt","","",101,[[["self"],["formatter"]],["result"]]],[11,"clone","","",102,[[["self"]],["constraintindex"]]],[11,"eq","","",102,[[["self"],["constraintindex"]],["bool"]]],[11,"ne","","",102,[[["self"],["constraintindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",102,N],[11,"hash","","",102,N],[11,"partial_cmp","","",102,[[["self"],["constraintindex"]],["option",["ordering"]]]],[11,"lt","","",102,[[["self"],["constraintindex"]],["bool"]]],[11,"le","","",102,[[["self"],["constraintindex"]],["bool"]]],[11,"gt","","",102,[[["self"],["constraintindex"]],["bool"]]],[11,"ge","","",102,[[["self"],["constraintindex"]],["bool"]]],[11,"cmp","","",102,[[["self"],["constraintindex"]],["ordering"]]],[11,"decode","","",102,[[["__d"]],["result",["constraintindex"]]]],[11,"encode","","",102,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",102,N],[18,"MAX","","",102,N],[11,"from_usize","","",102,[[["usize"]],["self"]]],[11,"from_u32","","",102,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",102,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",102,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",102,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",102,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",102,[[["self"]],["usize"]]],[11,"new","","",102,[[["usize"]],["self"]]],[11,"index","","",102,[[["self"]],["usize"]]],[11,"steps_between","","",102,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",102,[[["self"]],["self"]]],[11,"replace_zero","","",102,[[["self"]],["self"]]],[11,"add_one","","",102,[[["self"]],["self"]]],[11,"sub_one","","",102,[[["self"]],["self"]]],[11,"add_usize","","",102,[[["self"],["usize"]],["option"]]],[11,"from","","",102,[[["usize"]],["self"]]],[11,"from","","",102,[[["u32"]],["self"]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result"]]],[11,"clone","","",103,[[["self"]],["constraintsccindex"]]],[11,"eq","","",103,[[["self"],["constraintsccindex"]],["bool"]]],[11,"ne","","",103,[[["self"],["constraintsccindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",103,N],[11,"hash","","",103,N],[11,"partial_cmp","","",103,[[["self"],["constraintsccindex"]],["option",["ordering"]]]],[11,"lt","","",103,[[["self"],["constraintsccindex"]],["bool"]]],[11,"le","","",103,[[["self"],["constraintsccindex"]],["bool"]]],[11,"gt","","",103,[[["self"],["constraintsccindex"]],["bool"]]],[11,"ge","","",103,[[["self"],["constraintsccindex"]],["bool"]]],[11,"cmp","","",103,[[["self"],["constraintsccindex"]],["ordering"]]],[11,"decode","","",103,[[["__d"]],["result",["constraintsccindex"]]]],[11,"encode","","",103,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",103,N],[18,"MAX","","",103,N],[11,"from_usize","","",103,[[["usize"]],["self"]]],[11,"from_u32","","",103,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",103,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",103,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",103,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",103,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",103,[[["self"]],["usize"]]],[11,"new","","",103,[[["usize"]],["self"]]],[11,"index","","",103,[[["self"]],["usize"]]],[11,"steps_between","","",103,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",103,[[["self"]],["self"]]],[11,"replace_zero","","",103,[[["self"]],["self"]]],[11,"add_one","","",103,[[["self"]],["self"]]],[11,"sub_one","","",103,[[["self"]],["self"]]],[11,"add_usize","","",103,[[["self"],["usize"]],["option"]]],[11,"from","","",103,[[["usize"]],["self"]]],[11,"from","","",103,[[["u32"]],["self"]]],[11,"fmt","","",103,[[["self"],["formatter"]],["result"]]],[8,"ToRegionVid","rustc_mir::borrow_check::nll","Right now, we piggy back on the `ReVar` to store our NLL inference regions. These are indexed with `RegionVid`. This method will assert that the region is a `ReVar` and extract its internal index. This is reasonable because in our MIR we replace all universal regions with inference variables.",N,N],[10,"to_region_vid","","",111,[[["self"]],["regionvid"]]],[11,"mir","rustc_mir::borrow_check","",0,[[["self"]],["mir"]]],[11,"visit_block_entry","","",0,N],[11,"visit_statement_entry","","",0,N],[11,"visit_terminator_entry","","",0,N],[11,"clone","","",4,[[["self"]],["mutatemode"]]],[11,"eq","","",4,[[["self"],["mutatemode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",5,[[["self"]],["artificialfield"]]],[11,"eq","","",5,[[["self"],["artificialfield"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",5,N],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"clone","","",6,[[["self"]],["shallowordeep"]]],[11,"eq","","",6,[[["self"],["shallowordeep"]],["bool"]]],[11,"ne","","",6,[[["self"],["shallowordeep"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",6,N],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"clone","","",7,[[["self"]],["readorwrite"]]],[11,"eq","","",7,[[["self"],["readorwrite"]],["bool"]]],[11,"ne","","",7,[[["self"],["readorwrite"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"clone","","",8,[[["self"]],["readkind"]]],[11,"eq","","",8,[[["self"],["readkind"]],["bool"]]],[11,"ne","","",8,[[["self"],["readkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",8,N],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"clone","","",9,[[["self"]],["writekind"]]],[11,"eq","","",9,[[["self"],["writekind"]],["bool"]]],[11,"ne","","",9,[[["self"],["writekind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"clone","","",10,[[["self"]],["localmutationisallowed"]]],[11,"eq","","",10,[[["self"],["localmutationisallowed"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"clone","","",11,[[["self"]],["initializationrequiringaction"]]],[11,"as_noun","","",11,[[["self"]],["str"]]],[11,"as_verb_in_past_tense","","",11,[[["self"]],["str"]]],[11,"clone","","",2,[[["self"]],["seenty"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"cons","","Return a new list with `ty` prepended to the front of `self`.",2,[[["self"],["ty"]],["self"]]],[11,"have_seen","","True if and only if `ty` occurs on the linked list `self`.",2,[[["self"],["ty"]],["bool"]]],[11,"visit_terminator_drop","","Invokes `access_place` as appropriate for dropping the value at `drop_place`. Note that the actual `Drop` in the MIR is always for a variable (e.g., `Drop(x)`) -- but we recursively break this variable down into subpaths (e.g., `Drop(x.foo)`) to indicate more precisely which fields might actually be accessed by a destructor.",0,[[["self"],["location"],["terminator"],["flows"],["place"],["ty"],["span"],["seenty"]]]],[11,"access_place","","Checks an access to the given place to see if it is allowed. Examines the set of borrows that are in scope, as well as which paths have been initialized, to ensure that (a) the place is initialized and (b) it is not borrowed in some way that would prevent this access.",0,N],[11,"check_access_for_conflict","","",0,N],[11,"mutate_place","","",0,N],[11,"consume_rvalue","","",0,N],[11,"consume_operand","","",0,N],[11,"check_for_invalidation_at_exit","","Returns whether a borrow of this place is invalidated when the function exits",0,[[["self"],["context"],["borrowdata"],["span"]]]],[11,"check_for_local_borrow","","Reports an error if this is a borrow of local data. This is called for all Yield statements on movable generators",0,[[["self"],["borrowdata"],["span"]]]],[11,"check_activations","","",0,[[["self"],["location"],["span"],["flows"]]]],[11,"check_if_reassignment_to_immutable_state","","",0,N],[11,"check_if_full_path_is_moved","","",0,N],[11,"check_if_path_or_subpath_is_moved","","",0,N],[11,"move_path_closest_to","","Currently MoveData does not store entries for all places in the input MIR. For example it will currently filter out places that are Copy; thus we do not track places of shared reference type. This routine will walk up a place along its prefixes, searching for a foundational place that is tracked in the MoveData.",0,[[["self"],["place"]],["result",["movepathindex","nomovepathfound"]]]],[11,"move_path_for_place","","",0,[[["self"],["place"]],["option",["movepathindex"]]]],[11,"check_if_assigned_path_is_moved","","",0,N],[11,"check_access_permissions","","Check the permissions for the given place and read or write kind",0,N],[11,"add_used_mut","","Adds the place into the used mutable variables set",0,[[["self"],["rootplace"],["flows"]]]],[11,"is_mutable","","Whether this value be written or borrowed mutably. Returns the root place if the place passed in is a projection.",0,[[["self"],["place"],["localmutationisallowed"]],["result",["rootplace","place"]]]],[11,"clone","","",12,[[["self"]],["nomovepathfound"]]],[11,"eq","","",12,[[["self"],["nomovepathfound"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",12,N],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"clone","","",3,[[["self"]],["context"]]],[11,"eq","","",3,[[["self"],["context"]],["bool"]]],[11,"ne","","",3,[[["self"],["context"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",14,[[["self"]],["contextkind"]]],[11,"eq","","",14,[[["self"],["contextkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",14,N],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"new","","",14,[[["self"],["location"]],["context"]]],[0,"build","rustc_mir","",N,N],[3,"GlobalizeMir","rustc_mir::build","A pass to lift all the types and substitutions in a Mir to the global tcx. Sadly, we don't have a \"folder\" that can change 'tcx so we have to transmute afterwards.",N,N],[12,"tcx","","",112,N],[12,"span","","",112,N],[3,"Builder","","",N,N],[12,"hir","","",113,N],[12,"cfg","","",113,N],[12,"fn_span","","",113,N],[12,"arg_count","","",113,N],[12,"scopes","","the current set of scopes, updated as we traverse; see the `scope` module for more details",113,N],[12,"unpushed_unsafe","","The current unsafe block in scope, even if it is hidden by a PushUnsafeBlock",113,N],[12,"push_unsafe_count","","The number of `push_unsafe_block` levels in scope",113,N],[12,"breakable_scopes","","the current set of breakables; see the `scope` module for more details",113,N],[12,"source_scopes","","the vector of all scopes that we have created thus far; we track this for debuginfo later",113,N],[12,"source_scope_local_data","","",113,N],[12,"source_scope","","",113,N],[12,"guard_context","","the guard-context: each time we build the guard expression for a match arm, we push onto this stack, and then pop when we finish building it.",113,N],[12,"var_indices","","Maps node ids of variable bindings to the `Local`s created for them. (A match binding can have two locals; the 2nd is for the arm's guard.)",113,N],[12,"local_decls","","",113,N],[12,"upvar_decls","","",113,N],[12,"unit_temp","","",113,N],[12,"cached_resume_block","","cached block with the RESUME terminator; this is created when first set of cleanups are built.",113,N],[12,"cached_return_block","","cached block with the RETURN terminator",113,N],[12,"cached_unreachable_block","","cached block with the UNREACHABLE terminator",113,N],[3,"GuardFrameLocal","","",N,N],[12,"id","","",114,N],[3,"GuardFrame","","",N,N],[12,"locals","","These are the id's of names that are bound by patterns of the arm of this guard.",115,N],[3,"CFG","","",N,N],[12,"basic_blocks","","",116,N],[3,"ScopeId","","",N,N],[12,"private","","",117,N],[3,"BlockAnd","","The `BlockAnd` \"monad\" packages up the new basic block along with a produced value (sometimes just unit, of course). The `unpack!` macro (and methods below) makes working with `BlockAnd` much more convenient.",N,N],[12,"0","","",118,N],[12,"1","","",118,N],[3,"ImplicitSelfBinding","","the main entry point for building MIR for a function",N,N],[3,"ArgInfo","","",N,N],[12,"0","","",119,N],[12,"1","","",119,N],[12,"2","","",119,N],[12,"3","","",119,N],[4,"LocalsForNode","","",N,N],[13,"One","","In the usual case, a node-id for an identifier maps to at most one Local declaration.",120,N],[13,"ForGuard","","The exceptional case is identifiers in a match arm's pattern that are referenced in a guard of that match arm. For these, we can have `2+k` Locals, where `k` is the number of candidate patterns (separated by `|`) in the arm.",120,N],[12,"vals_for_guard","rustc_mir::build::LocalsForNode","",120,N],[12,"ref_for_guard","","",120,N],[12,"for_arm_body","","",120,N],[4,"ForGuard","rustc_mir::build","ForGuard indicates whether we are talking about: 1. the temp for a local binding used solely within guard expressions, 2. the temp that holds reference to (1.), which is actually what the    guard expressions see, or 3. the temp for use outside of guard expressions.",N,N],[13,"ValWithinGuard","","The `usize` identifies for which candidate pattern we want the local binding. We keep a temp per-candidate to accommodate two-phase borrows (see `LocalsForNode` documentation).",121,N],[13,"RefWithinGuard","","",121,N],[13,"OutsideGuard","","",121,N],[5,"mir_build","","Construct the MIR for a given def-id.",N,[[["tyctxt"],["defid"]],["mir"]]],[5,"create_constructor_shim","","",N,[[["tyctxt"],["nodeid"],["variantdata"]],["mir"]]],[5,"liberated_closure_env_ty","","",N,[[["tyctxt"],["nodeid"],["bodyid"]],["ty"]]],[5,"should_abort_on_panic","","",N,[[["tyctxt"],["defid"],["abi"]],["bool"]]],[5,"construct_fn","","",N,[[["cx"],["nodeid"],["a"],["safety"],["abi"],["ty"],["option",["ty"]],["body"]],["mir"]]],[5,"construct_const","","",N,[[["cx"],["bodyid"]],["mir"]]],[5,"construct_error","","",N,[[["cx"],["bodyid"]],["mir"]]],[0,"block","","",N,N],[11,"ast_block","","",113,[[["self"],["place"],["basicblock"],["block"],["sourceinfo"]],["blockand"]]],[11,"ast_block_stmts","","",113,[[["self"],["place"],["basicblock"],["span"],["vec",["stmtref"]],["option",["exprref"]],["blocksafety"]],["blockand"]]],[11,"update_source_scope_for_safety_mode","","If we are changing the safety mode, create a new source scope",113,[[["self"],["span"],["blocksafety"]]]],[0,"cfg","","Routines for manipulating the control-flow graph.",N,N],[11,"block_data","","",116,[[["self"],["basicblock"]],["basicblockdata"]]],[11,"block_data_mut","","",116,[[["self"],["basicblock"]],["basicblockdata"]]],[11,"start_new_block","","",116,[[["self"]],["basicblock"]]],[11,"start_new_cleanup_block","","",116,[[["self"]],["basicblock"]]],[11,"push","","",116,[[["self"],["basicblock"],["statement"]]]],[11,"push_end_region","","",116,[[["self"],["tyctxt"],["basicblock"],["sourceinfo"],["scope"]]]],[11,"push_assign","","",116,[[["self"],["basicblock"],["sourceinfo"],["place"],["rvalue"]]]],[11,"push_assign_constant","","",116,[[["self"],["basicblock"],["sourceinfo"],["place"],["constant"]]]],[11,"push_assign_unit","","",116,[[["self"],["basicblock"],["sourceinfo"],["place"]]]],[11,"terminate","","",116,[[["self"],["basicblock"],["sourceinfo"],["terminatorkind"]]]],[0,"expr","","Builds MIR from expressions. As a caller into this module, you have many options, but the first thing you have to decide is whether you are evaluating this expression for its value, its location, or as a constant.",N,N],[0,"as_constant","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"as_constant","rustc_mir::build","Compile `expr`, yielding a compile-time constant. Assumes that `expr` is a valid compile-time constant!",113,[[["self"],["m"]],["constant"]]],[11,"expr_as_constant","","",113,[[["self"],["expr"]],["constant"]]],[0,"as_operand","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"as_local_operand","rustc_mir::build","Returns an operand suitable for use until the end of the current scope expression.",113,[[["self"],["basicblock"],["m"]],["blockand",["operand"]]]],[11,"as_operand","","Compile `expr` into a value that can be used as an operand. If `expr` is a place like `x`, this will introduce a temporary `tmp = x`, so that we capture the value of `x` at this time.",113,[[["self"],["basicblock"],["option",["scope"]],["m"]],["blockand",["operand"]]]],[11,"expr_as_operand","","",113,[[["self"],["basicblock"],["option",["scope"]],["expr"]],["blockand",["operand"]]]],[0,"as_place","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"as_place","rustc_mir::build","Compile `expr`, yielding a place that we can move from etc.",113,[[["self"],["basicblock"],["m"]],["blockand",["place"]]]],[11,"as_read_only_place","","Compile `expr`, yielding a place that we can move from etc. Mutability note: The caller of this method promises only to read from the resulting place. The place itself may or may not be mutable: * If this expr is a place expr like a.b, then we will return that place. * Otherwise, a temporary is created: in that event, it will be an immutable temporary.",113,[[["self"],["basicblock"],["m"]],["blockand",["place"]]]],[11,"expr_as_place","","",113,[[["self"],["basicblock"],["expr"],["mutability"]],["blockand",["place"]]]],[0,"as_rvalue","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"as_local_rvalue","rustc_mir::build","See comment on `as_local_operand`",113,[[["self"],["basicblock"],["m"]],["blockand",["rvalue"]]]],[11,"as_rvalue","","Compile `expr`, yielding an rvalue.",113,[[["self"],["basicblock"],["option",["scope"]],["m"]],["blockand",["rvalue"]]]],[11,"expr_as_rvalue","","",113,[[["self"],["basicblock"],["option",["scope"]],["expr"]],["blockand",["rvalue"]]]],[11,"build_binary_op","","",113,[[["self"],["basicblock"],["binop"],["span"],["ty"],["operand"],["operand"]],["blockand",["rvalue"]]]],[11,"limit_capture_mutability","","",113,[[["self"],["span"],["ty"],["option",["scope"]],["basicblock"],["exprref"],["regionkind"]],["blockand",["operand"]]]],[11,"neg_1_literal","","",113,[[["self"],["span"],["ty"]],["operand"]]],[11,"minval_literal","","",113,[[["self"],["span"],["ty"]],["operand"]]],[0,"as_temp","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"as_temp","rustc_mir::build","Compile `expr` into a fresh temporary. This is used when building up rvalues so as to freeze the value that will be consumed.",113,[[["self"],["basicblock"],["option",["scope"]],["m"],["mutability"]],["blockand",["local"]]]],[11,"expr_as_temp","","",113,[[["self"],["basicblock"],["option",["scope"]],["expr"],["mutability"]],["blockand",["local"]]]],[0,"category","rustc_mir::build::expr","",N,N],[4,"Category","rustc_mir::build::expr::category","",N,N],[13,"Place","","",122,N],[13,"Constant","","",122,N],[13,"Rvalue","","",122,N],[4,"RvalueFunc","","",N,N],[13,"Into","","",123,N],[13,"AsRvalue","","",123,N],[11,"fmt","","",122,[[["self"],["formatter"]],["result"]]],[11,"eq","","",122,[[["self"],["category"]],["bool"]]],[11,"ne","","",122,[[["self"],["category"]],["bool"]]],[11,"fmt","","",123,[[["self"],["formatter"]],["result"]]],[11,"eq","","",123,[[["self"],["rvaluefunc"]],["bool"]]],[11,"of","","",122,[[["exprkind"]],["option",["category"]]]],[0,"into","rustc_mir::build::expr","See docs in build/expr/mod.rs",N,N],[11,"into_expr","rustc_mir::build","Compile `expr`, storing the result into `destination`, which is assumed to be uninitialized.",113,[[["self"],["place"],["basicblock"],["expr"]],["blockand"]]],[0,"stmt","rustc_mir::build::expr","",N,N],[11,"stmt_expr","rustc_mir::build","",113,[[["self"],["basicblock"],["expr"]],["blockand"]]],[0,"into","","In general, there are a number of things for which it's convenient to just call `builder.into` and have it emit its result into a given location. This is basically for expressions or things that can be wrapped up as expressions (e.g. blocks). To make this ergonomic, we use this latter `EvalInto` trait.",N,N],[8,"EvalInto","rustc_mir::build::into","",N,N],[10,"eval_into","","",124,[[["self"],["builder"],["place"],["basicblock"]],["blockand"]]],[11,"into","rustc_mir::build","",113,[[["self"],["place"],["basicblock"],["e"]],["blockand"]]],[0,"matches","","Code related to match expressions. These are sufficiently complex to warrant their own module and submodules. :) This main module includes the high-level algorithm, the submodules contain the details.",N,N],[3,"ArmHasGuard","rustc_mir::build::matches","ArmHasGuard is isomorphic to a boolean flag. It indicates whether a match arm has a guard expression attached to it.",N,N],[12,"0","","",125,N],[3,"ArmBlocks","","List of blocks for each arm (and potentially other metadata in the future).",N,N],[12,"blocks","","",126,N],[3,"Candidate","","",N,N],[12,"span","","",127,N],[12,"match_pairs","","",127,N],[12,"bindings","","",127,N],[12,"ascriptions","","",127,N],[12,"guard","","",127,N],[12,"arm_index","","",127,N],[12,"pre_binding_block","","",127,N],[12,"next_candidate_pre_binding_block","","",127,N],[12,"pat_index","","",127,N],[3,"Binding","","",N,N],[12,"span","","",128,N],[12,"source","","",128,N],[12,"name","","",128,N],[12,"var_id","","",128,N],[12,"var_ty","","",128,N],[12,"mutability","","",128,N],[12,"binding_mode","","",128,N],[3,"Ascription","","Indicates that the type of `source` must be a subtype of the user-given type `user_ty`; this is basically a no-op but can influence region inference.",N,N],[12,"span","","",129,N],[12,"source","","",129,N],[12,"user_ty","","",129,N],[3,"MatchPair","","",N,N],[12,"place","","",130,N],[12,"pattern","","",130,N],[12,"slice_len_checked","","",130,N],[3,"Test","","",N,N],[12,"span","","",131,N],[12,"kind","","",131,N],[4,"TestKind","","",N,N],[13,"Switch","","",132,N],[12,"adt_def","rustc_mir::build::matches::TestKind","",132,N],[12,"variants","","",132,N],[13,"SwitchInt","rustc_mir::build::matches","",132,N],[12,"switch_ty","rustc_mir::build::matches::TestKind","",132,N],[12,"options","","",132,N],[12,"indices","","",132,N],[13,"Eq","rustc_mir::build::matches","",132,N],[12,"value","rustc_mir::build::matches::TestKind","",132,N],[12,"ty","","",132,N],[13,"Range","rustc_mir::build::matches","",132,N],[12,"lo","rustc_mir::build::matches::TestKind","",132,N],[12,"hi","","",132,N],[12,"ty","","",132,N],[12,"end","","",132,N],[13,"Len","rustc_mir::build::matches","",132,N],[12,"len","rustc_mir::build::matches::TestKind","",132,N],[12,"op","","",132,N],[0,"simplify","rustc_mir::build::matches","Simplifying Candidates",N,N],[11,"simplify_candidate","rustc_mir::build","",113,[[["self"],["basicblock"],["candidate"]],["blockand"]]],[11,"simplify_match_pair","","Tries to simplify `match_pair`, returning true if successful. If successful, new match pairs and bindings will have been pushed into the candidate. If no simplification is possible, Err is returned and no changes are made to candidate.",113,[[["self"],["matchpair"],["candidate"]],["result",["matchpair"]]]],[0,"test","rustc_mir::build::matches","",N,N],[5,"is_switch_ty","rustc_mir::build::matches::test","",N,[[["ty"]],["bool"]]],[11,"test","rustc_mir::build","Identifies what test is needed to decide if `match_pair` is applicable.",113,[[["self"],["matchpair"]],["test"]]],[11,"add_cases_to_switch","","",113,[[["self"],["place"],["candidate"],["ty"],["vec"],["fxhashmap"]],["bool"]]],[11,"add_variants_to_switch","","",113,[[["self"],["place"],["candidate"],["bitarray"]],["bool"]]],[11,"perform_test","","Generates the code to perform a test.",113,[[["self"],["basicblock"],["place"],["test"]],["vec",["basicblock"]]]],[11,"compare","","",113,[[["self"],["basicblock"],["basicblock"],["span"],["binop"],["operand"],["operand"]],["basicblock"]]],[11,"sort_candidate","","Given that we are performing `test` against `test_place`, this job sorts out what the status of `candidate` will be after the test. The `resulting_candidates` vector stores, for each possible outcome of `test`, a vector of the candidates that will result. This fn should add a (possibly modified) clone of candidate into `resulting_candidates` wherever appropriate.",113,N],[11,"candidate_without_match_pair","","",113,[[["self"],["usize"],["candidate"]],["candidate"]]],[11,"candidate_after_slice_test","","",113,N],[11,"candidate_after_variant_switch","","",113,N],[11,"error_simplifyable","","",113,N],[0,"util","rustc_mir::build::matches","",N,N],[11,"field_match_pairs","rustc_mir::build","",113,N],[11,"prefix_slice_suffix","","",113,N],[11,"new","rustc_mir::build::matches","",130,[[["place"],["pattern"]],["matchpair"]]],[11,"clone","","",125,[[["self"]],["armhasguard"]]],[11,"fmt","","",125,[[["self"],["formatter"]],["result"]]],[11,"match_expr","rustc_mir::build","",113,[[["self"],["place"],["span"],["basicblock"],["exprref"],["vec",["arm"]]],["blockand"]]],[11,"expr_into_pattern","","",113,[[["self"],["basicblock"],["pattern"],["exprref"]],["blockand"]]],[11,"place_into_pattern","","",113,[[["self"],["basicblock"],["pattern"],["place"],["bool"]],["blockand"]]],[11,"declare_bindings","","Declares the bindings of the given patterns and returns the visibility scope for the bindings in these patterns, if such a scope had to be created. NOTE: Declaring the bindings should always be done in their drop scope.",113,N],[11,"storage_live_binding","","",113,[[["self"],["basicblock"],["nodeid"],["span"],["forguard"]],["place"]]],[11,"schedule_drop_for_binding","","",113,[[["self"],["nodeid"],["span"],["forguard"]]]],[11,"visit_bindings","","",113,N],[11,"clone","rustc_mir::build::matches","",127,[[["self"]],["candidate"]]],[11,"fmt","","",127,[[["self"],["formatter"]],["result"]]],[11,"clone","","",128,[[["self"]],["binding"]]],[11,"fmt","","",128,[[["self"],["formatter"]],["result"]]],[11,"clone","","",129,[[["self"]],["ascription"]]],[11,"fmt","","",129,[[["self"],["formatter"]],["result"]]],[11,"clone","","",130,[[["self"]],["matchpair"]]],[11,"fmt","","",130,[[["self"],["formatter"]],["result"]]],[11,"clone","","",132,[[["self"]],["testkind"]]],[11,"fmt","","",132,[[["self"],["formatter"]],["result"]]],[11,"eq","","",132,[[["self"],["testkind"]],["bool"]]],[11,"ne","","",132,[[["self"],["testkind"]],["bool"]]],[11,"fmt","","",131,[[["self"],["formatter"]],["result"]]],[11,"match_candidates","rustc_mir::build","The main match algorithm. It begins with a set of candidates `candidates` and has the job of generating code to determine which of these candidates, if any, is the correct one. The candidates are sorted such that the first item in the list has the highest priority. When a candidate is found to match the value, we will generate a branch to the appropriate block found in `arm_blocks`.",113,[[["self"],["span"],["armblocks"],["vec",["candidate"]],["basicblock"]],["vec",["basicblock"]]]],[11,"join_otherwise_blocks","","",113,[[["self"],["span"],["vec",["basicblock"]]],["basicblock"]]],[11,"test_candidates","","This is the most subtle part of the matching algorithm.  At this point, the input candidates have been fully simplified, and so we know that all remaining match-pairs require some sort of test. To decide what test to do, we take the highest priority candidate (last one in the list) and extract the first match-pair from the list. From this we decide what kind of test is needed using `test`, defined in the `test` module.",113,N],[11,"bind_and_guard_matched_candidate","","Initializes each of the bindings from the candidate by moving/copying/ref'ing the source as appropriate. Tests the guard, if any, and then branches to the arm. Returns the block for the case where the guard fails.",113,[[["self"],["basicblock"],["armblocks"],["candidate"]],["option",["basicblock"]]]],[11,"ascribe_types","","Append `AscribeUserType` statements onto the end of `block` for each ascription",113,N],[11,"bind_matched_candidate_for_guard","","",113,N],[11,"bind_matched_candidate_for_arm_body","","",113,N],[11,"declare_binding","","Each binding (`ref mut var`/`ref var`/`mut var`/`var`, where the bound `var` has type `T` in the arm body) in a pattern maps to `2+N` locals. The first local is a binding for occurrences of `var` in the guard, which will all have type `&T`. The N locals are bindings for the `T` that is referenced by the first local; they are not used outside of the guard. The last local is a binding for occurrences of `var` in the arm body, which will have type `T`.",113,[[["self"],["sourceinfo"],["sourcescope"],["mutability"],["name"],["bindingmode"],["usize"],["nodeid"],["ty"],["option",["canonicalty"]],["armhasguard"],["option"],["span"]]]],[0,"misc","","Miscellaneous builder routines that are not specific to building any particular kind of thing.",N,N],[11,"temp","","Add a new temporary value of type `ty` storing the result of evaluating `expr`.",113,[[["self"],["ty"],["span"]],["place"]]],[11,"literal_operand","","Convenience function for creating a literal operand, one without any user type annotation.",113,[[["self"],["span"],["ty"],["const"]],["operand"]]],[11,"unit_rvalue","","",113,[[["self"]],["rvalue"]]],[11,"zero_literal","","",113,[[["self"],["span"],["ty"]],["operand"]]],[11,"push_usize","","",113,[[["self"],["basicblock"],["sourceinfo"],["u64"]],["place"]]],[11,"consume_by_copy_or_move","","",113,[[["self"],["place"]],["operand"]]],[0,"scope","","Managing the scope stack. The scopes are tied to lexical scopes, so as we descend the HAIR, we push a scope on the stack, build its contents, and then pop it off. Every scope is named by a `region::Scope`.",N,N],[3,"Scope","rustc_mir::build::scope","",N,N],[12,"source_scope","","The source scope this scope was created in.",133,N],[12,"region_scope","","the region span of this scope within source code.",133,N],[12,"region_scope_span","","the span of that region_scope",133,N],[12,"needs_cleanup","","Whether there's anything to do for the cleanup path, that is, when unwinding through this scope. This includes destructors, but not StorageDead statements, which don't get emitted at all for unwinding, for several reasons:  * clang doesn't emit llvm.lifetime.end for C++ unwinding  * LLVM's memory dependency analysis can't handle it atm  * polluting the cleanup MIR with StorageDead creates    landing pads even though there's no actual destructors  * freeing up stack space has no effect during unwinding",133,N],[12,"drops","","set of places to drop when exiting this scope. This starts out empty but grows as variables are declared during the building process. This is a stack, so we always drop from the end of the vector (top of the stack) first.",133,N],[12,"cached_exits","","The cache for drop chain on “normal” exit into a particular BasicBlock.",133,N],[12,"cached_generator_drop","","The cache for drop chain on \"generator drop\" exit.",133,N],[12,"cached_unwind","","The cache for drop chain on \"unwind\" exit.",133,N],[3,"DropData","","",N,N],[12,"span","","span where drop obligation was incurred (typically where place was declared)",134,N],[12,"location","","place to drop",134,N],[12,"kind","","Whether this is a value Drop or a StorageDead.",134,N],[3,"CachedBlock","","",N,N],[12,"unwind","","The cached block for the cleanups-on-diverge path. This block contains code to run the current drop and all the preceding drops (i.e. those having lower index in Drop’s Scope drop array)",135,N],[12,"generator_drop","","The cached block for unwinds during cleanups-on-generator-drop path",135,N],[3,"BreakableScope","","",N,N],[12,"region_scope","","Region scope of the loop",136,N],[12,"continue_block","","Where the body of the loop begins. `None` if block",136,N],[12,"break_block","","Block to branch into when the loop or block terminates (either by being `break`-en out from, or by having its condition to become false)",136,N],[12,"break_destination","","The destination of the loop/block expression itself (i.e. where to put the result of a `break` expression)",136,N],[4,"DropKind","","",N,N],[13,"Value","","",137,N],[12,"cached_block","rustc_mir::build::scope::DropKind","",137,N],[13,"Storage","rustc_mir::build::scope","",137,N],[5,"build_scope_drops","","Builds drops for pop_scope and exit_scope.",N,N],[5,"build_diverge_scope","","",N,[[["tyctxt"],["cfg"],["span"],["scope"],["basicblock"],["bool"]],["basicblock"]]],[11,"fmt","","",133,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",134,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",135,[[["self"],["formatter"]],["result"]]],[11,"default","","",135,[[],["cachedblock"]]],[11,"clone","","",135,[[["self"]],["cachedblock"]]],[11,"fmt","","",137,[[["self"],["formatter"]],["result"]]],[11,"clone","","",136,[[["self"]],["breakablescope"]]],[11,"fmt","","",136,[[["self"],["formatter"]],["result"]]],[11,"invalidate","","",135,[[["self"]]]],[11,"get","","",135,[[["self"],["bool"]],["option",["basicblock"]]]],[11,"ref_mut","","",135,[[["self"],["bool"]],["option"]]],[11,"may_panic","","",137,[[["self"]],["bool"]]],[11,"invalidate_cache","","Invalidate all the cached blocks in the scope.",133,[[["self"],["bool"],["bool"]]]],[11,"source_info","","Given a span and this scope's source scope, make a SourceInfo.",133,[[["self"],["span"]],["sourceinfo"]]],[11,"in_breakable_scope","rustc_mir::build","Start a breakable scope, which tracks where `continue` and `break` should branch to. See module comment for more details.",113,[[["self"],["option",["basicblock"]],["basicblock"],["place"],["f"]],["r"]]],[11,"in_opt_scope","","",113,[[["self"],["option"],["basicblock"],["f"]],["blockand"]]],[11,"in_scope","","Convenience wrapper that pushes a scope and then executes `f` to build its contents, popping the scope afterwards.",113,N],[11,"push_scope","","Push a scope onto the stack. You can then build code in this scope and call `pop_scope` afterwards. Note that these two calls must be paired; using `in_scope` as a convenience wrapper maybe preferable.",113,N],[11,"pop_scope","","Pops a scope, which should have region scope `region_scope`, adding any drops onto the end of `block` that are needed. This must match 1-to-1 with `push_scope`.",113,N],[11,"exit_scope","","Branch out of `block` to `target`, exiting all scopes up to and including `region_scope`.  This will insert whatever drops are needed, as well as tracking this exit for the SEME region. See module comment for details.",113,N],[11,"generator_drop_cleanup","","Creates a path that performs all required cleanup for dropping a generator.",113,[[["self"]],["option",["basicblock"]]]],[11,"new_source_scope","","Creates a new source scope, nested in the current one.",113,[[["self"],["span"],["lintlevel"],["option",["safety"]]],["sourcescope"]]],[11,"find_breakable_scope","","Finds the breakable scope for a given label. This is used for resolving `break` and `continue`.",113,[[["self"],["span"],["scope"]],["breakablescope"]]],[11,"source_info","","Given a span and the current source scope, make a SourceInfo.",113,[[["self"],["span"]],["sourceinfo"]]],[11,"region_scope_of_return_scope","","Returns the `region::Scope` of the scope which should be exited by a return.",113,[[["self"]],["scope"]]],[11,"topmost_scope","","Returns the topmost active scope, which is known to be alive until the next scope expression.",113,[[["self"]],["scope"]]],[11,"local_scope","","Returns the scope that we should use as the lifetime of an operand. Basically, an operand must live until it is consumed. This is similar to, but not quite the same as, the temporary scope (which can be larger or smaller).",113,[[["self"]],["option",["scope"]]]],[11,"schedule_abort","","",113,[[["self"]],["basicblock"]]],[11,"schedule_drop_storage_and_value","","",113,[[["self"],["span"],["scope"],["place"],["ty"]]]],[11,"schedule_drop","","Indicates that `place` should be dropped on exit from `region_scope`.",113,[[["self"],["span"],["scope"],["place"],["ty"],["dropkind"]]]],[11,"diverge_cleanup","","Creates a path that performs all required cleanup for unwinding.",113,[[["self"]],["basicblock"]]],[11,"resume_block","","",113,[[["self"]],["basicblock"]]],[11,"diverge_cleanup_gen","","",113,[[["self"],["bool"]],["basicblock"]]],[11,"build_drop","","Utility function for non-scope code to build their own drops",113,[[["self"],["basicblock"],["span"],["place"],["ty"]],["blockand"]]],[11,"build_drop_and_replace","","Utility function for non-scope code to build their own drops",113,[[["self"],["basicblock"],["span"],["place"],["operand"]],["blockand"]]],[11,"assert","","Create an Assert terminator and return the success block. If the boolean condition operand is not the expected value, a runtime panic will be caused with the given message.",113,[[["self"],["basicblock"],["operand"],["bool"],["assertmessage"],["span"]],["basicblock"]]],[8,"BlockAndExtension","","",N,N],[10,"and","","",138,[[["self"],["t"]],["blockand"]]],[10,"unit","","",138,[[["self"]],["blockand"]]],[11,"visit_ty","","",112,[[["self"],["ty"],["tycontext"]]]],[11,"visit_region","","",112,[[["self"],["region"],["location"]]]],[11,"visit_const","","",112,[[["self"],["const"],["location"]]]],[11,"visit_substs","","",112,[[["self"],["substs"],["location"]]]],[11,"is_bound_var_in_guard","","",113,[[["self"],["nodeid"]],["bool"]]],[11,"var_local_id","","",113,[[["self"],["nodeid"],["forguard"]],["local"]]],[11,"fmt","","",120,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"new","","",114,[[["nodeid"],["bindingmode"]],["self"]]],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"clone","","",121,[[["self"]],["forguard"]]],[11,"fmt","","",121,[[["self"],["formatter"]],["result"]]],[11,"eq","","",121,[[["self"],["forguard"]],["bool"]]],[11,"ne","","",121,[[["self"],["forguard"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",121,N],[11,"local_id","","",120,[[["self"],["forguard"]],["local"]]],[11,"clone","","",117,[[["self"]],["scopeid"]]],[11,"eq","","",117,[[["self"],["scopeid"]],["bool"]]],[11,"ne","","",117,[[["self"],["scopeid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",117,N],[11,"hash","","",117,N],[11,"partial_cmp","","",117,[[["self"],["scopeid"]],["option",["ordering"]]]],[11,"lt","","",117,[[["self"],["scopeid"]],["bool"]]],[11,"le","","",117,[[["self"],["scopeid"]],["bool"]]],[11,"gt","","",117,[[["self"],["scopeid"]],["bool"]]],[11,"ge","","",117,[[["self"],["scopeid"]],["bool"]]],[11,"cmp","","",117,[[["self"],["scopeid"]],["ordering"]]],[11,"decode","","",117,[[["__d"]],["result",["scopeid"]]]],[11,"encode","","",117,[[["self"],["__s"]],["result"]]],[18,"MAX_AS_U32","","",117,N],[18,"MAX","","",117,N],[11,"from_usize","","",117,[[["usize"]],["self"]]],[11,"from_u32","","",117,[[["u32"]],["self"]]],[11,"from_u32_const","","Hacky variant of `from_u32` for use in constants. This version checks the \"max\" constraint by using an invalid array dereference.",117,[[["u32"]],["self"]]],[11,"from_u32_unchecked","","",117,[[["u32"]],["self"]]],[11,"index","","Extract value of this index as an integer.",117,[[["self"]],["usize"]]],[11,"as_u32","","Extract value of this index as a usize.",117,[[["self"]],["u32"]]],[11,"as_usize","","Extract value of this index as a u32.",117,[[["self"]],["usize"]]],[11,"new","","",117,[[["usize"]],["self"]]],[11,"index","","",117,[[["self"]],["usize"]]],[11,"steps_between","","",117,[[["self"],["self"]],["option",["usize"]]]],[11,"replace_one","","",117,[[["self"]],["self"]]],[11,"replace_zero","","",117,[[["self"]],["self"]]],[11,"add_one","","",117,[[["self"]],["self"]]],[11,"sub_one","","",117,[[["self"]],["self"]]],[11,"add_usize","","",117,[[["self"],["usize"]],["option"]]],[11,"from","","",117,[[["usize"]],["self"]]],[11,"from","","",117,[[["u32"]],["self"]]],[11,"fmt","","",117,[[["self"],["formatter"]],["result"]]],[11,"new","","",113,[[["cx"],["span"],["usize"],["safety"],["ty"],["vec",["upvardecl"]]],["builder"]]],[11,"finish","","",113,[[["self"],["option",["ty"]]],["mir"]]],[11,"args_and_body","","",113,N],[11,"get_unit_temp","","",113,[[["self"]],["place"]]],[11,"return_block","","",113,[[["self"]],["basicblock"]]],[11,"unreachable_block","","",113,[[["self"]],["basicblock"]]],[0,"dataflow","rustc_mir","",N,N],[3,"DataflowBuilder","rustc_mir::dataflow","",N,N],[12,"node_id","","",139,N],[12,"flow_state","","",139,N],[12,"print_preflow_to","","",139,N],[12,"print_postflow_to","","",139,N],[3,"DebugFormatted","","`DebugFormatted` encapsulates the \"{:?}\" rendering of some arbitrary value. This way: you pay cost of allocating an extra string (as well as that of rendering up-front); in exchange, you don't have to hand over ownership of your value or deal with borrowing it.",N,N],[12,"0","","",140,N],[3,"MoveDataParamEnv","","",N,N],[12,"move_data","","",141,N],[12,"param_env","","",141,N],[3,"PropagationContext","","",N,N],[12,"builder","","",142,N],[3,"DataflowAnalysis","","",N,N],[12,"flow_state","","",143,N],[12,"dead_unwinds","","",143,N],[12,"mir","","",143,N],[3,"DataflowResults","","",N,N],[12,"0","","",144,N],[3,"DataflowState","","State of a dataflow analysis; couples a collection of bit sets with operator used to initialize and merge bits during analysis.",N,N],[12,"sets","","All the sets for the analysis. (Factored into its own structure so that we can borrow it mutably on its own separate from other fields.)",145,N],[12,"operator","","operator used to initialize, combine, and interpret bits.",145,N],[3,"AllSets","","",N,N],[12,"bits_per_block","","Analysis bitwidth for each block.",146,N],[12,"on_entry_sets","","For each block, bits valid on entry to the block.",146,N],[12,"gen_sets","","For each block, bits generated by executing the statements + terminator in the block -- with one caveat. In particular, for call terminators, the effect of storing the destination is not included, since that only takes effect on the success edge (and not the unwind edge).",146,N],[12,"kill_sets","","For each block, bits killed by executing the statements + terminator in the block -- with one caveat. In particular, for call terminators, the effect of storing the destination is not included, since that only takes effect on the success edge (and not the unwind edge).",146,N],[3,"BlockSets","","Triple of sets associated with a given block.",N,N],[12,"on_entry","","Dataflow state immediately before control flow enters the given block.",147,N],[12,"gen_set","","Bits that are set to 1 by the time we exit the given block. Hybrid because it usually contains only 0 or 1 elements.",147,N],[12,"kill_set","","Bits that are set to 0 by the time we exit the given block. Hybrid because it usually contains only 0 or 1 elements.",147,N],[5,"has_rustc_mir_with","","",N,N],[5,"do_dataflow","","",N,N],[5,"dataflow_path","","",N,[[["str"],["str"]],["pathbuf"]]],[5,"state_for_location","","",N,[[["location"],["t"],["dataflowresults"],["mir"]],["idxset"]]],[0,"at_location","","A nice wrapper to consume dataflow results at several CFG locations.",N,N],[3,"FlowAtLocation","rustc_mir::dataflow::at_location","Represents the state of dataflow at a particular CFG location, both before and after it is executed.",N,N],[12,"base_results","","",148,N],[12,"curr_state","","",148,N],[12,"stmt_gen","","",148,N],[12,"stmt_kill","","",148,N],[8,"FlowsAtLocation","","A trait for \"cartesian products\" of multiple FlowAtLocation.",N,N],[10,"reset_to_entry_of","","Reset the state bitvector to represent the entry to block `bb`.",149,[[["self"],["basicblock"]]]],[10,"reset_to_exit_of","","Reset the state bitvector to represent the exit of the terminator of block `bb`.",149,[[["self"],["basicblock"]]]],[10,"reconstruct_statement_effect","","Build gen + kill sets for statement at `loc`.",149,[[["self"],["location"]]]],[10,"reconstruct_terminator_effect","","Build gen + kill sets for terminator for `loc`.",149,[[["self"],["location"]]]],[10,"apply_local_effect","","Apply current gen + kill sets to `flow_state`.",149,[[["self"],["location"]]]],[11,"each_state_bit","","Iterate over each bit set in the current state.",148,[[["self"],["f"]]]],[11,"each_gen_bit","","Iterate over each `gen` bit in the current effect (invoke `reconstruct_statement_effect` or `reconstruct_terminator_effect` first).",148,[[["self"],["f"]]]],[11,"new","","",148,[[["dataflowresults"]],["self"]]],[11,"operator","","Access the underlying operator.",148,[[["self"]],["bd"]]],[11,"contains","","",148,N],[11,"iter_incoming","","Returns an iterator over the elements present in the current state.",148,[[["self"]],["peekable",["bititer"]]]],[11,"with_iter_outgoing","","Creates a clone of the current state and applies the local effects to the clone (leaving the state of self intact). Invokes `f` with an iterator over the resulting state.",148,[[["self"],["f"]]]],[11,"reset_to_entry_of","","",148,[[["self"],["basicblock"]]]],[11,"reset_to_exit_of","","",148,[[["self"],["basicblock"]]]],[11,"reconstruct_statement_effect","","",148,[[["self"],["location"]]]],[11,"reconstruct_terminator_effect","","",148,[[["self"],["location"]]]],[11,"apply_local_effect","","",148,[[["self"],["location"]]]],[11,"has_any_child_of","","",148,N],[0,"drop_flag_effects","rustc_mir::dataflow","",N,N],[5,"move_path_children_matching","rustc_mir::dataflow::drop_flag_effects","",N,[[["movedata"],["movepathindex"],["f"]],["option",["movepathindex"]]]],[5,"place_contents_drop_state_cannot_differ","","When enumerating the child fragments of a path, don't recurse into paths (1.) past arrays, slices, and pointers, nor (2.) into a type that implements `Drop`.",N,[[["tyctxt"],["mir"],["place"]],["bool"]]],[5,"on_lookup_result_bits","","",N,[[["tyctxt"],["mir"],["movedata"],["lookupresult"],["f"]]]],[5,"on_all_children_bits","","",N,[[["tyctxt"],["mir"],["movedata"],["movepathindex"],["f"]]]],[5,"on_all_drop_children_bits","","",N,[[["tyctxt"],["mir"],["movedataparamenv"],["movepathindex"],["f"]]]],[5,"drop_flag_effects_for_function_entry","","",N,[[["tyctxt"],["mir"],["movedataparamenv"],["f"]]]],[5,"drop_flag_effects_for_location","","",N,[[["tyctxt"],["mir"],["movedataparamenv"],["location"],["f"]]]],[5,"for_location_inits","","",N,[[["tyctxt"],["mir"],["movedata"],["location"],["f"]]]],[0,"graphviz","rustc_mir::dataflow","Hook into libgraphviz for rendering dataflow graphs for MIR.",N,N],[3,"Graph","rustc_mir::dataflow::graphviz","",N,N],[12,"mbcx","","",150,N],[12,"phantom","","",150,N],[12,"render_idx","","",150,N],[3,"Edge","","",N,N],[12,"source","","",151,N],[12,"index","","",151,N],[5,"print_borrowck_graph_to","","",N,[[["dataflowbuilder"],["path"],["p"]],["result"]]],[5,"outgoing","","",N,[[["mir"],["basicblock"]],["vec",["edge"]]]],[6,"Node","","",N,N],[8,"MirWithFlowState","","",N,N],[16,"BD","","",152,N],[10,"node_id","","",152,[[["self"]],["nodeid"]]],[10,"mir","","",152,[[["self"]],["mir"]]],[10,"flow_state","","",152,[[["self"]],["dataflowstate"]]],[11,"node_id","rustc_mir::dataflow","",139,[[["self"]],["nodeid"]]],[11,"mir","","",139,[[["self"]],["mir"]]],[11,"flow_state","","",139,[[["self"]],["dataflowstate"]]],[11,"clone","rustc_mir::dataflow::graphviz","",151,[[["self"]],["edge"]]],[11,"eq","","",151,[[["self"],["edge"]],["bool"]]],[11,"ne","","",151,[[["self"],["edge"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",151,N],[11,"fmt","","",151,[[["self"],["formatter"]],["result"]]],[11,"graph_id","","",150,[[["self"]],["id"]]],[11,"node_id","","",150,[[["self"],["basicblock"]],["id"]]],[11,"node_label","","",150,[[["self"],["basicblock"]],["labeltext"]]],[11,"node_shape","","",150,[[["self"],["basicblock"]],["option",["labeltext"]]]],[11,"edge_label","","",150,[[["self"],["edge"]],["labeltext"]]],[11,"node_label_internal","","Generate the node label",150,[[["self"],["basicblock"],["w"],["basicblock"],["mir"]],["result"]]],[11,"node_label_verbose_row","","Build the verbose row: full MIR data, and detailed gen/kill/entry sets",150,[[["self"],["basicblock"],["w"],["basicblock"],["mir"]],["result"]]],[11,"node_label_final_row","","Build the summary row: terminator, gen/kill/entry bit sets",150,[[["self"],["basicblock"],["w"],["basicblock"],["mir"]],["result"]]],[11,"nodes","","",150,[[["self"]],["nodes",["basicblock"]]]],[11,"edges","","",150,[[["self"]],["edges",["edge"]]]],[11,"source","","",150,[[["self"],["edge"]],["basicblock"]]],[11,"target","","",150,[[["self"],["edge"]],["basicblock"]]],[0,"impls","rustc_mir::dataflow","Dataflow analyses are built upon some interpretation of the bitvectors attached to each basic block, represented via a zero-sized structure.",N,N],[3,"MaybeInitializedPlaces","rustc_mir::dataflow::impls","`MaybeInitializedPlaces` tracks all places that might be initialized upon reaching a particular point in the control flow for a function.",N,N],[12,"tcx","","",153,N],[12,"mir","","",153,N],[12,"mdpe","","",153,N],[3,"MaybeUninitializedPlaces","","`MaybeUninitializedPlaces` tracks all places that might be uninitialized upon reaching a particular point in the control flow for a function.",N,N],[12,"tcx","","",154,N],[12,"mir","","",154,N],[12,"mdpe","","",154,N],[3,"DefinitelyInitializedPlaces","","`DefinitelyInitializedPlaces` tracks all places that are definitely initialized upon reaching a particular point in the control flow for a function.",N,N],[12,"tcx","","",155,N],[12,"mir","","",155,N],[12,"mdpe","","",155,N],[3,"EverInitializedPlaces","","`EverInitializedPlaces` tracks all places that might have ever been initialized upon reaching a particular point in the control flow for a function, without an intervening `Storage Dead`.",N,N],[12,"tcx","","",156,N],[12,"mir","","",156,N],[12,"mdpe","","",156,N],[0,"storage_liveness","","",N,N],[3,"MaybeStorageLive","rustc_mir::dataflow::impls::storage_liveness","",N,N],[12,"mir","","",157,N],[11,"clone","","",157,[[["self"]],["maybestoragelive"]]],[11,"new","","",157,[[["mir"]],["self"]]],[11,"mir","","",157,[[["self"]],["mir"]]],[11,"name","","",157,[[],["str"]]],[11,"bits_per_block","","",157,[[["self"]],["usize"]]],[11,"start_block_effect","","",157,[[["self"],["idxset"]]]],[11,"statement_effect","","",157,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",157,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",157,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"join","","",157,[[["self"],["word"],["word"]],["word"]]],[11,"bottom_value","","",157,[[],["bool"]]],[0,"borrowed_locals","rustc_mir::dataflow::impls","",N,N],[3,"HaveBeenBorrowedLocals","rustc_mir::dataflow::impls::borrowed_locals","This calculates if any part of a MIR local could have previously been borrowed. This means that once a local has been borrowed, its bit will be set from that point and onwards, until we see a StorageDead statement for the local, at which points there is no memory associated with the local, so it cannot be borrowed. This is used to compute which locals are live during a yield expression for immovable generators.",N,N],[12,"mir","","",158,N],[3,"BorrowedLocalsVisitor","","",N,N],[12,"sets","","",159,N],[5,"find_local","","",N,[[["place"]],["option",["local"]]]],[11,"clone","","",158,[[["self"]],["havebeenborrowedlocals"]]],[11,"new","","",158,[[["mir"]],["self"]]],[11,"mir","","",158,[[["self"]],["mir"]]],[11,"name","","",158,[[],["str"]]],[11,"bits_per_block","","",158,[[["self"]],["usize"]]],[11,"start_block_effect","","",158,[[["self"],["idxset"]]]],[11,"statement_effect","","",158,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",158,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",158,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"join","","",158,[[["self"],["word"],["word"]],["word"]]],[11,"bottom_value","","",158,[[],["bool"]]],[11,"visit_rvalue","","",159,[[["self"],["rvalue"],["location"]]]],[0,"borrows","rustc_mir::dataflow::impls","",N,N],[3,"Borrows","rustc_mir::dataflow::impls::borrows","`Borrows` stores the data used in the analyses that track the flow of borrows.",N,N],[12,"tcx","","",160,N],[12,"mir","","",160,N],[12,"scope_tree","","",160,N],[12,"root_scope","","",160,N],[12,"borrow_set","","",160,N],[12,"borrows_out_of_scope_at_location","","",160,N],[12,"_nonlexical_regioncx","","NLL region inference context with which NLL queries should be resolved",160,N],[3,"StackEntry","","",N,N],[12,"bb","","",161,N],[12,"lo","","",161,N],[12,"hi","","",161,N],[12,"first_part_only","","",161,N],[5,"precompute_borrows_out_of_scope","","",N,[[["mir"],["rc"],["fxhashmap"],["borrowindex"],["regionvid"],["location"]]]],[11,"new","","",160,[[["tyctxt"],["mir"],["rc",["regioninferencecontext"]],["defid"],["option",["bodyid"]],["rc"]],["self"]]],[11,"borrows","","",160,[[["self"]],["indexvec"]]],[11,"scope_tree","","",160,[[["self"]],["lrc"]]],[11,"location","","",160,[[["self"],["borrowindex"]],["location"]]],[11,"kill_loans_out_of_scope_at_location","","Add all borrows to the kill set, if those borrows are out of scope at `location`. That means either they went out of either a nonlexical scope, if we care about those at the moment, or the location represents a lexical EndRegion",160,[[["self"],["blocksets"],["location"]]]],[11,"kill_borrows_on_local","","",160,[[["self"],["blocksets"],["local"]]]],[11,"name","","",160,[[],["str"]]],[11,"bits_per_block","","",160,[[["self"]],["usize"]]],[11,"start_block_effect","","",160,[[["self"],["idxset"]]]],[11,"before_statement_effect","","",160,[[["self"],["blocksets"],["location"]]]],[11,"statement_effect","","",160,[[["self"],["blocksets"],["location"]]]],[11,"before_terminator_effect","","",160,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",160,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",160,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"join","","",160,[[["self"],["word"],["word"]],["word"]]],[11,"bottom_value","","",160,[[],["bool"]]],[11,"new","rustc_mir::dataflow::impls","",153,[[["tyctxt"],["mir"],["movedataparamenv"]],["self"]]],[11,"move_data","","",153,[[["self"]],["movedata"]]],[11,"new","","",154,[[["tyctxt"],["mir"],["movedataparamenv"]],["self"]]],[11,"move_data","","",154,[[["self"]],["movedata"]]],[11,"new","","",155,[[["tyctxt"],["mir"],["movedataparamenv"]],["self"]]],[11,"move_data","","",155,[[["self"]],["movedata"]]],[11,"new","","",156,[[["tyctxt"],["mir"],["movedataparamenv"]],["self"]]],[11,"move_data","","",156,[[["self"]],["movedata"]]],[11,"update_bits","","",153,[[["blocksets"],["movepathindex"],["dropflagstate"]]]],[11,"update_bits","","",154,[[["blocksets"],["movepathindex"],["dropflagstate"]]]],[11,"update_bits","","",155,[[["blocksets"],["movepathindex"],["dropflagstate"]]]],[11,"name","","",153,[[],["str"]]],[11,"bits_per_block","","",153,[[["self"]],["usize"]]],[11,"start_block_effect","","",153,[[["self"],["idxset"]]]],[11,"statement_effect","","",153,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",153,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",153,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"name","","",154,[[],["str"]]],[11,"bits_per_block","","",154,[[["self"]],["usize"]]],[11,"start_block_effect","","",154,[[["self"],["idxset"]]]],[11,"statement_effect","","",154,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",154,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",154,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"name","","",155,[[],["str"]]],[11,"bits_per_block","","",155,[[["self"]],["usize"]]],[11,"start_block_effect","","",155,[[["self"],["idxset"]]]],[11,"statement_effect","","",155,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",155,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",155,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"name","","",156,[[],["str"]]],[11,"bits_per_block","","",156,[[["self"]],["usize"]]],[11,"start_block_effect","","",156,[[["self"],["idxset"]]]],[11,"statement_effect","","",156,[[["self"],["blocksets"],["location"]]]],[11,"terminator_effect","","",156,[[["self"],["blocksets"],["location"]]]],[11,"propagate_call_return","","",156,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"join","","",153,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",154,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",155,[[["self"],["word"],["word"]],["word"]]],[11,"join","","",156,[[["self"],["word"],["word"]],["word"]]],[11,"bottom_value","","",153,[[],["bool"]]],[11,"bottom_value","","",154,[[],["bool"]]],[11,"bottom_value","","",155,[[],["bool"]]],[11,"bottom_value","","",156,[[],["bool"]]],[0,"move_paths","rustc_mir::dataflow","",N,N],[3,"MovePath","rustc_mir::dataflow::move_paths","`MovePath` is a canonicalized representation of a path that is moved or assigned to.",N,N],[12,"next_sibling","","",162,N],[12,"first_child","","",162,N],[12,"parent","","",162,N],[12,"place","","",162,N],[3,"MoveData","","",N,N],[12,"move_paths","","",163,N],[12,"moves","","",163,N],[12,"loc_map","","Each Location `l` is mapped to the MoveOut's that are effects of executing the code at `l`. (There can be multiple MoveOut's for a given `l` because each MoveOut is associated with one particular path being moved.)",163,N],[12,"path_map","","",163,N],[12,"rev_lookup","","",163,N],[12,"inits","","",163,N],[12,"init_loc_map","","Each Location `l` is mapped to the Inits that are effects of executing the code at `l`.",163,N],[12,"init_path_map","","",163,N],[3,"LocationMap","","",N,N],[12,"map","","Location-indexed (BasicBlock for outer index, index within BB for inner index) map.",164,N],[3,"MoveOut","","`MoveOut` represents a point in a program that moves out of some L-value; i.e., \"creates\" uninitialized memory.",N,N],[12,"path","","path being moved",165,N],[12,"source","","location of move",165,N],[3,"Init","","`Init` represents a point in a program that initializes some L-value;",N,N],[12,"path","","path being initialized",166,N],[12,"location","","location of initialization",166,N],[12,"kind","","Extra information about this initialization",166,N],[3,"MovePathLookup","","Tables mapping from a place to its MovePathIndex.",N,N],[12,"locals","","",167,N],[12,"projections","","projections are made from a base-place and a projection elem. The base-place will have a unique MovePathIndex; we use the latter as the index into the outer vector (narrowing subsequent search so that it is solely relative to that base-place). For the remaining lookup, we map the projection elem to the associated MovePathIndex.",167,N],[3,"IllegalMoveOrigin","","",N,N],[12,"location","","",168,N],[12,"kind","","",168,N],[4,"InitLocation","","Initializations can be from an argument or from a statement. Arguments do not have locations, in those cases the `Local` is kept..",N,N],[13,"Argument","","",169,N],[13,"Statement","","",169,N],[4,"InitKind","","Additional information about the initialization.",N,N],[13,"Deep","","Deep init, even on panic",170,N],[13,"Shallow","","Only does a shallow init",170,N],[13,"NonPanicPathOnly","","This doesn't initialize the variable on panic (and a panic is possible).",170,N],[4,"LookupResult","","",N,N],[13,"Exact","","",171,N],[13,"Parent","","",171,N],[4,"IllegalMoveOriginKind","","",N,N],[13,"Static","","Illegal move due to attempt to move from `static` variable.",172,N],[13,"BorrowedContent","","Illegal move due to attempt to move from behind a reference.",172,N],[12,"target_place","rustc_mir::dataflow::move_paths::IllegalMoveOriginKind","The place the reference refers to: if erroneous code was trying to move from `(*x).f` this will be `*x`.",172,N],[13,"InteriorOfTypeWithDestructor","rustc_mir::dataflow::move_paths","Illegal move due to attempt to move from field of an ADT that implements `Drop`. Rust maintains invariant that all `Drop` ADT's remain fully-initialized so that user-defined destructor can safely read from all of the ADT's fields.",172,N],[12,"container_ty","rustc_mir::dataflow::move_paths::IllegalMoveOriginKind","",172,N],[13,"InteriorOfSliceOrArray","rustc_mir::dataflow::move_paths","Illegal move due to attempt to move out of a slice or array.",172,N],[12,"ty","rustc_mir::dataflow::move_paths::IllegalMoveOriginKind","",172,N],[12,"is_index","","",172,N],[4,"MoveError","rustc_mir::dataflow::move_paths","",N,N],[13,"IllegalMove","","",173,N],[12,"cannot_move_out_of","rustc_mir::dataflow::move_paths::MoveError","",173,N],[13,"UnionMove","rustc_mir::dataflow::move_paths","",173,N],[12,"path","rustc_mir::dataflow::move_paths::MoveError","",173,N],[0,"abs_domain","rustc_mir::dataflow::move_paths","The move-analysis portion of borrowck needs to work in an abstract domain of lifted Places.  Most of the Place variants fall into a one-to-one mapping between the concrete and abstract (e.g. a field-deref on a local-variable, `x.field`, has the same meaning in both domains). Indexed-Projections are the exception: `a[x]` needs to be treated as mapping to the same move path as `a[y]` as well as `a[13]`, et cetera.",N,N],[3,"AbstractOperand","rustc_mir::dataflow::move_paths::abs_domain","",N,N],[3,"AbstractType","","",N,N],[6,"AbstractElem","","",N,N],[8,"Lift","","",N,N],[16,"Abstract","","",174,N],[10,"lift","","",174,N],[11,"clone","","",175,[[["self"]],["abstractoperand"]]],[11,"eq","","",175,[[["self"],["abstractoperand"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",175,N],[11,"hash","","",175,N],[11,"fmt","","",175,[[["self"],["formatter"]],["result"]]],[11,"clone","","",176,[[["self"]],["abstracttype"]]],[11,"eq","","",176,[[["self"],["abstracttype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",176,N],[11,"hash","","",176,N],[11,"fmt","","",176,[[["self"],["formatter"]],["result"]]],[0,"indexes","rustc_mir::dataflow::move_paths","",N,N],[3,"MovePathIndex","rustc_mir::dataflow::move_paths::indexes","",N,N],[12,"0","","",177,N],[3,"MoveOutIndex","","",N,N],[12,"0","","",178,N],[3,"InitIndex","","",N,N],[12,"0","","",179,N],[3,"BorrowIndex","","",N,N],[12,"0","","",180,N],[11,"clone","","",177,[[["self"]],["movepathindex"]]],[11,"eq","","",177,[[["self"],["movepathindex"]],["bool"]]],[11,"ne","","",177,[[["self"],["movepathindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",177,N],[11,"hash","","",177,N],[11,"partial_cmp","","",177,[[["self"],["movepathindex"]],["option",["ordering"]]]],[11,"lt","","",177,[[["self"],["movepathindex"]],["bool"]]],[11,"le","","",177,[[["self"],["movepathindex"]],["bool"]]],[11,"gt","","",177,[[["self"],["movepathindex"]],["bool"]]],[11,"ge","","",177,[[["self"],["movepathindex"]],["bool"]]],[11,"cmp","","",177,[[["self"],["movepathindex"]],["ordering"]]],[11,"new","","",177,[[["usize"]],["self"]]],[11,"index","","",177,[[["self"]],["usize"]]],[11,"fmt","","",177,[[["self"],["formatter"]],["result"]]],[11,"clone","","",178,[[["self"]],["moveoutindex"]]],[11,"eq","","",178,[[["self"],["moveoutindex"]],["bool"]]],[11,"ne","","",178,[[["self"],["moveoutindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",178,N],[11,"hash","","",178,N],[11,"partial_cmp","","",178,[[["self"],["moveoutindex"]],["option",["ordering"]]]],[11,"lt","","",178,[[["self"],["moveoutindex"]],["bool"]]],[11,"le","","",178,[[["self"],["moveoutindex"]],["bool"]]],[11,"gt","","",178,[[["self"],["moveoutindex"]],["bool"]]],[11,"ge","","",178,[[["self"],["moveoutindex"]],["bool"]]],[11,"cmp","","",178,[[["self"],["moveoutindex"]],["ordering"]]],[11,"new","","",178,[[["usize"]],["self"]]],[11,"index","","",178,[[["self"]],["usize"]]],[11,"fmt","","",178,[[["self"],["formatter"]],["result"]]],[11,"clone","","",179,[[["self"]],["initindex"]]],[11,"eq","","",179,[[["self"],["initindex"]],["bool"]]],[11,"ne","","",179,[[["self"],["initindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",179,N],[11,"hash","","",179,N],[11,"partial_cmp","","",179,[[["self"],["initindex"]],["option",["ordering"]]]],[11,"lt","","",179,[[["self"],["initindex"]],["bool"]]],[11,"le","","",179,[[["self"],["initindex"]],["bool"]]],[11,"gt","","",179,[[["self"],["initindex"]],["bool"]]],[11,"ge","","",179,[[["self"],["initindex"]],["bool"]]],[11,"cmp","","",179,[[["self"],["initindex"]],["ordering"]]],[11,"new","","",179,[[["usize"]],["self"]]],[11,"index","","",179,[[["self"]],["usize"]]],[11,"fmt","","",179,[[["self"],["formatter"]],["result"]]],[11,"clone","","",180,[[["self"]],["borrowindex"]]],[11,"eq","","",180,[[["self"],["borrowindex"]],["bool"]]],[11,"ne","","",180,[[["self"],["borrowindex"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",180,N],[11,"hash","","",180,N],[11,"partial_cmp","","",180,[[["self"],["borrowindex"]],["option",["ordering"]]]],[11,"lt","","",180,[[["self"],["borrowindex"]],["bool"]]],[11,"le","","",180,[[["self"],["borrowindex"]],["bool"]]],[11,"gt","","",180,[[["self"],["borrowindex"]],["bool"]]],[11,"ge","","",180,[[["self"],["borrowindex"]],["bool"]]],[11,"cmp","","",180,[[["self"],["borrowindex"]],["ordering"]]],[11,"new","","",180,[[["usize"]],["self"]]],[11,"index","","",180,[[["self"]],["usize"]]],[11,"fmt","","",180,[[["self"],["formatter"]],["result"]]],[0,"builder","rustc_mir::dataflow::move_paths","",N,N],[3,"MoveDataBuilder","rustc_mir::dataflow::move_paths::builder","",N,N],[12,"mir","","",181,N],[12,"tcx","","",181,N],[12,"data","","",181,N],[12,"errors","","",181,N],[3,"Gatherer","","",N,N],[12,"builder","","",182,N],[12,"loc","","",182,N],[5,"gather_moves","","",N,[[["mir"],["tyctxt"]],["result",["movedata"]]]],[11,"new","","",181,[[["mir"],["tyctxt"]],["self"]]],[11,"new_move_path","","",181,[[["indexvec"],["indexvec"],["indexvec"],["option",["movepathindex"]],["place"]],["movepathindex"]]],[11,"move_path_for","","This creates a MovePath for a given place, returning an `MovePathError` if that place can't be moved from.",182,[[["self"],["place"]],["result",["movepathindex","moveerror"]]]],[11,"create_move_path","","",182,[[["self"],["place"]]]],[11,"move_path_for_projection","","",182,[[["self"],["place"],["placeprojection"]],["result",["movepathindex","moveerror"]]]],[11,"finalize","","",181,[[["self"]],["result",["movedata"]]]],[11,"gather_args","","",181,[[["self"]]]],[11,"gather_statement","","",181,[[["self"],["location"],["statement"]]]],[11,"gather_terminator","","",181,[[["self"],["location"],["terminator"]]]],[11,"gather_statement","","",182,[[["self"],["statement"]]]],[11,"gather_rvalue","","",182,[[["self"],["rvalue"]]]],[11,"gather_terminator","","",182,[[["self"],["terminator"]]]],[11,"gather_operand","","",182,[[["self"],["operand"]]]],[11,"gather_move","","",182,[[["self"],["place"]]]],[11,"gather_init","","",182,[[["self"],["place"],["initkind"]]]],[8,"HasMoveData","rustc_mir::dataflow::move_paths","",N,N],[10,"move_data","","",183,[[["self"]],["movedata"]]],[11,"move_path_index","rustc_mir::dataflow::move_paths::indexes","",178,[[["self"],["movedata"]],["movepathindex"]]],[11,"clone","rustc_mir::dataflow::move_paths","",162,[[["self"]],["movepath"]]],[11,"fmt","","",162,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",162,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",163,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",164,[[["self"],["formatter"]],["result"]]],[11,"index","","",164,N],[11,"index_mut","","",164,N],[11,"new","","",164,[[["mir"]],["self"]]],[11,"clone","","",165,[[["self"]],["moveout"]]],[11,"fmt","","",165,[[["self"],["formatter"]],["result"]]],[11,"clone","","",166,[[["self"]],["init"]]],[11,"clone","","",169,[[["self"]],["initlocation"]]],[11,"fmt","","",169,[[["self"],["formatter"]],["result"]]],[11,"eq","","",169,[[["self"],["initlocation"]],["bool"]]],[11,"ne","","",169,[[["self"],["initlocation"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",169,N],[11,"clone","","",170,[[["self"]],["initkind"]]],[11,"fmt","","",170,[[["self"],["formatter"]],["result"]]],[11,"eq","","",170,[[["self"],["initkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",170,N],[11,"fmt","","",166,[[["self"],["formatter"]],["result"]]],[11,"span","","",166,[[["self"],["mir"]],["span"]]],[11,"fmt","","",167,[[["self"],["formatter"]],["result"]]],[11,"clone","","",171,[[["self"]],["lookupresult"]]],[11,"fmt","","",171,[[["self"],["formatter"]],["result"]]],[11,"find","","",167,[[["self"],["place"]],["lookupresult"]]],[11,"find_local","","",167,[[["self"],["local"]],["movepathindex"]]],[11,"fmt","","",168,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",172,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",173,[[["self"],["formatter"]],["result"]]],[11,"cannot_move_out_of","","",173,[[["location"],["illegalmoveoriginkind"]],["self"]]],[11,"gather_moves","","",163,[[["mir"],["tyctxt"]],["result"]]],[11,"base_local","","For the move path `mpi`, returns the root local variable (if any) that starts the path. (e.g., for a path like `a.b.c` returns `Some(a)`)",163,[[["self"],["movepathindex"]],["option",["local"]]]],[8,"Dataflow","rustc_mir::dataflow","",N,N],[11,"dataflow","","Sets up and runs the dataflow problem, using `p` to render results if implementation so chooses.",184,[[["self"],["p"]]]],[10,"build_sets","","Sets up the entry, gen, and kill sets for this instance of a dataflow problem.",184,[[["self"]]]],[10,"propagate","","Finds a fixed-point solution to this instance of a dataflow problem.",184,[[["self"]]]],[8,"DataflowResultsConsumer","","DataflowResultsConsumer abstracts over walking the MIR with some already constructed dataflow results.",N,N],[16,"FlowState","","",185,N],[11,"visit_block_entry","","",185,N],[11,"visit_statement_entry","","",185,N],[11,"visit_terminator_entry","","",185,N],[11,"analyze_results","","",185,N],[11,"process_basic_block","","",185,N],[10,"mir","","",185,[[["self"]],["mir"]]],[8,"InitialFlow","","Parameterization for the precise form of data flow that is used. `InitialFlow` handles initializing the bitvectors before any code is inspected by the analysis. Analyses that need more nuanced initialization (e.g. they need to consult the results of some other dataflow analysis to set up the initial bitvectors) should not implement this.",N,N],[10,"bottom_value","","Specifies the initial value for each bit in the `on_entry` set",186,[[],["bool"]]],[8,"BitDenotation","","",N,N],[16,"Idx","","Specifies what index type is used to access the bitvector.",187,N],[11,"accumulates_intrablock_state","","Some analyses want to accumulate knowledge within a block when analyzing its statements for building the gen/kill sets. Override this method to return true in such cases.",187,[[],["bool"]]],[10,"name","","A name describing the dataflow analysis that this BitDenotation is supporting.  The name should be something suitable for plugging in as part of a filename e.g. avoid space-characters or other things that tend to look bad on a file system, like slashes or periods. It is also better for the name to be reasonably short, again because it will be plugged into a filename.",187,[[],["str"]]],[10,"bits_per_block","","Size of each bitvector allocated for each block in the analysis.",187,[[["self"]],["usize"]]],[10,"start_block_effect","","Mutates the entry set according to the effects that have been established prior to entering the start block. This can't access the gen/kill sets, because these won't be accounted for correctly.",187,[[["self"],["idxset"]]]],[11,"before_statement_effect","","Similar to `statement_effect`, except it applies just before the statement rather than just after it.",187,[[["self"],["blocksets"],["location"]]]],[10,"statement_effect","","Mutates the block-sets (the flow sets for the given basic block) according to the effects of evaluating statement.",187,[[["self"],["blocksets"],["location"]]]],[11,"before_terminator_effect","","Similar to `terminator_effect`, except it applies just before the terminator rather than just after it.",187,[[["self"],["blocksets"],["location"]]]],[10,"terminator_effect","","Mutates the block-sets (the flow sets for the given basic block) according to the effects of evaluating the terminator.",187,[[["self"],["blocksets"],["location"]]]],[10,"propagate_call_return","","Mutates the block-sets according to the (flow-dependent) effect of a successful return from a Call terminator.",187,[[["self"],["idxset"],["basicblock"],["basicblock"],["place"]]]],[11,"new","","",140,[[["debug"]],["debugformatted"]]],[11,"fmt","","",140,[[["self"],["formatter"]],["result"]]],[11,"dataflow","","",139,[[["self"],["p"]]]],[11,"build_sets","","",139,[[["self"]]]],[11,"propagate","","",139,[[["self"]]]],[11,"run","","",143,N],[11,"propagate","","",143,[[["self"]]]],[11,"build_sets","","",143,[[["self"]]]],[11,"walk_cfg","","",142,[[["self"],["idxset"]]]],[11,"pre_dataflow_instrumentation","","",139,[[["self"],["p"]],["result"]]],[11,"post_dataflow_instrumentation","","",139,[[["self"],["p"]],["result"]]],[11,"results","","",143,[[["self"]],["dataflowresults"]]],[11,"mir","","",143,[[["self"]],["mir"]]],[11,"sets","","",144,[[["self"]],["allsets"]]],[11,"operator","","",144,[[["self"]],["o"]]],[11,"interpret_set","","",145,[[["self"],["o"],["idxset"],["p"]],["vec",["debugformatted"]]]],[11,"interpret_hybrid_set","","",145,[[["self"],["o"],["hybrididxset"],["p"]],["vec",["debugformatted"]]]],[11,"fmt","","",146,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",147,[[["self"],["formatter"]],["result"]]],[11,"gen","","",147,[[["self"],["e"]]]],[11,"gen_all","","",147,[[["self"],["i"]]]],[11,"kill","","",147,[[["self"],["e"]]]],[11,"kill_all","","",147,[[["self"],["i"]]]],[11,"apply_local_effect","","",147,[[["self"]]]],[11,"bits_per_block","","",146,[[["self"]],["usize"]]],[11,"for_block","","",146,[[["self"],["usize"]],["blocksets"]]],[11,"on_entry_set_for","","",146,[[["self"],["usize"]],["idxset"]]],[11,"gen_set_for","","",146,[[["self"],["usize"]],["hybrididxset"]]],[11,"kill_set_for","","",146,[[["self"],["usize"]],["hybrididxset"]]],[11,"new","","",143,[[["mir"],["idxset"],["d"]],["self"]]],[11,"new_from_sets","","",143,[[["mir"],["idxset"],["allsets"],["d"]],["self"]]],[11,"propagate_bits_into_graph_successors_of","","Propagates the bits of `in_out` into all the successors of `bb`, using bitwise operator denoted by `self.operator`.",143,N],[11,"propagate_bits_into_entry_set_for","","",143,[[["self"],["idxset"],["basicblock"],["workqueue"]]]],[0,"hair","rustc_mir","The MIR is built from some high-level abstract IR (HAIR). This section defines the HAIR along with a trait for accessing it. The intention is to allow MIR construction to be unit-tested and separated from the Rust source and compiler data structures.",N,N],[3,"Block","rustc_mir::hair","",N,N],[12,"targeted_by_break","","",188,N],[12,"region_scope","","",188,N],[12,"opt_destruction_scope","","",188,N],[12,"span","","",188,N],[12,"stmts","","",188,N],[12,"expr","","",188,N],[12,"safety_mode","","",188,N],[3,"Stmt","","",N,N],[12,"kind","","",189,N],[12,"opt_destruction_scope","","",189,N],[3,"Expr","","The Hair trait implementor lowers their expressions (`&'tcx H::Expr`) into instances of this `Expr` enum. This lowering can be done basically as lazily or as eagerly as desired: every recursive reference to an expression in this enum is an `ExprRef<'tcx>`, which may in turn be another instance of this enum (boxed), or else an unlowered `&'tcx H::Expr`. Note that instances of `Expr` are very shortlived. They are created by `Hair::to_expr`, analyzed and converted into MIR, and then discarded.",N,N],[12,"ty","","type of this expression",190,N],[12,"temp_lifetime","","lifetime of this expression if it should be spilled into a temporary; should be None only if in a constant context",190,N],[12,"span","","span of the expression in the source",190,N],[12,"kind","","kind of expression",190,N],[3,"FieldExprRef","","",N,N],[12,"name","","",191,N],[12,"expr","","",191,N],[3,"FruInfo","","",N,N],[12,"base","","",192,N],[12,"field_types","","",192,N],[3,"Arm","","",N,N],[12,"patterns","","",193,N],[12,"guard","","",193,N],[12,"body","","",193,N],[12,"lint_level","","",193,N],[4,"LintLevel","","",N,N],[13,"Inherited","","",194,N],[13,"Explicit","","",194,N],[4,"BlockSafety","","",N,N],[13,"Safe","","",195,N],[13,"ExplicitUnsafe","","",195,N],[13,"PushUnsafe","","",195,N],[13,"PopUnsafe","","",195,N],[4,"StmtRef","","",N,N],[13,"Mirror","","",196,N],[4,"StmtKind","","",N,N],[13,"Expr","","",197,N],[12,"scope","rustc_mir::hair::StmtKind","scope for this statement; may be used as lifetime of temporaries",197,N],[12,"expr","","expression being evaluated in this statement",197,N],[13,"Let","rustc_mir::hair","",197,N],[12,"remainder_scope","rustc_mir::hair::StmtKind","scope for variables bound in this let; covers this and remaining statements in block",197,N],[12,"init_scope","","scope for the initialization itself; might be used as lifetime of temporaries",197,N],[12,"pattern","","`let <PAT> = ...`",197,N],[12,"initializer","","let pat: ty =  ...",197,N],[12,"lint_level","","the lint level for this let-statement",197,N],[4,"ExprKind","rustc_mir::hair","",N,N],[13,"Scope","","",198,N],[12,"region_scope","rustc_mir::hair::ExprKind","",198,N],[12,"lint_level","","",198,N],[12,"value","","",198,N],[13,"Box","rustc_mir::hair","",198,N],[12,"value","rustc_mir::hair::ExprKind","",198,N],[13,"Call","rustc_mir::hair","",198,N],[12,"ty","rustc_mir::hair::ExprKind","",198,N],[12,"fun","","",198,N],[12,"args","","",198,N],[13,"Deref","rustc_mir::hair","",198,N],[12,"arg","rustc_mir::hair::ExprKind","",198,N],[13,"Binary","rustc_mir::hair","",198,N],[12,"op","rustc_mir::hair::ExprKind","",198,N],[12,"lhs","","",198,N],[12,"rhs","","",198,N],[13,"LogicalOp","rustc_mir::hair","",198,N],[12,"op","rustc_mir::hair::ExprKind","",198,N],[12,"lhs","","",198,N],[12,"rhs","","",198,N],[13,"Unary","rustc_mir::hair","",198,N],[12,"op","rustc_mir::hair::ExprKind","",198,N],[12,"arg","","",198,N],[13,"Cast","rustc_mir::hair","",198,N],[12,"source","rustc_mir::hair::ExprKind","",198,N],[13,"Use","rustc_mir::hair","",198,N],[12,"source","rustc_mir::hair::ExprKind","",198,N],[13,"NeverToAny","rustc_mir::hair","",198,N],[12,"source","rustc_mir::hair::ExprKind","",198,N],[13,"ReifyFnPointer","rustc_mir::hair","",198,N],[12,"source","rustc_mir::hair::ExprKind","",198,N],[13,"ClosureFnPointer","rustc_mir::hair","",198,N],[12,"source","rustc_mir::hair::ExprKind","",198,N],[13,"UnsafeFnPointer","rustc_mir::hair","",198,N],[12,"source","rustc_mir::hair::ExprKind","",198,N],[13,"Unsize","rustc_mir::hair","",198,N],[12,"source","rustc_mir::hair::ExprKind","",198,N],[13,"If","rustc_mir::hair","",198,N],[12,"condition","rustc_mir::hair::ExprKind","",198,N],[12,"then","","",198,N],[12,"otherwise","","",198,N],[13,"Loop","rustc_mir::hair","",198,N],[12,"condition","rustc_mir::hair::ExprKind","",198,N],[12,"body","","",198,N],[13,"Match","rustc_mir::hair","",198,N],[12,"discriminant","rustc_mir::hair::ExprKind","",198,N],[12,"arms","","",198,N],[13,"Block","rustc_mir::hair","",198,N],[12,"body","rustc_mir::hair::ExprKind","",198,N],[13,"Assign","rustc_mir::hair","",198,N],[12,"lhs","rustc_mir::hair::ExprKind","",198,N],[12,"rhs","","",198,N],[13,"AssignOp","rustc_mir::hair","",198,N],[12,"op","rustc_mir::hair::ExprKind","",198,N],[12,"lhs","","",198,N],[12,"rhs","","",198,N],[13,"Field","rustc_mir::hair","",198,N],[12,"lhs","rustc_mir::hair::ExprKind","",198,N],[12,"name","","",198,N],[13,"Index","rustc_mir::hair","",198,N],[12,"lhs","rustc_mir::hair::ExprKind","",198,N],[12,"index","","",198,N],[13,"VarRef","rustc_mir::hair","",198,N],[12,"id","rustc_mir::hair::ExprKind","",198,N],[13,"SelfRef","rustc_mir::hair","first argument, used for self in a closure",198,N],[13,"StaticRef","","",198,N],[12,"id","rustc_mir::hair::ExprKind","",198,N],[13,"Borrow","rustc_mir::hair","",198,N],[12,"region","rustc_mir::hair::ExprKind","",198,N],[12,"borrow_kind","","",198,N],[12,"arg","","",198,N],[13,"Break","rustc_mir::hair","",198,N],[12,"label","rustc_mir::hair::ExprKind","",198,N],[12,"value","","",198,N],[13,"Continue","rustc_mir::hair","",198,N],[12,"label","rustc_mir::hair::ExprKind","",198,N],[13,"Return","rustc_mir::hair","",198,N],[12,"value","rustc_mir::hair::ExprKind","",198,N],[13,"Repeat","rustc_mir::hair","",198,N],[12,"value","rustc_mir::hair::ExprKind","",198,N],[12,"count","","",198,N],[13,"Array","rustc_mir::hair","",198,N],[12,"fields","rustc_mir::hair::ExprKind","",198,N],[13,"Tuple","rustc_mir::hair","",198,N],[12,"fields","rustc_mir::hair::ExprKind","",198,N],[13,"Adt","rustc_mir::hair","",198,N],[12,"adt_def","rustc_mir::hair::ExprKind","",198,N],[12,"variant_index","","",198,N],[12,"substs","","",198,N],[12,"user_ty","","Optional user-given substs: for something like `let x = Bar::<T> { ... }`.",198,N],[12,"fields","","",198,N],[12,"base","","",198,N],[13,"Closure","rustc_mir::hair","",198,N],[12,"closure_id","rustc_mir::hair::ExprKind","",198,N],[12,"substs","","",198,N],[12,"upvars","","",198,N],[12,"movability","","",198,N],[13,"Literal","rustc_mir::hair","",198,N],[12,"literal","rustc_mir::hair::ExprKind","",198,N],[12,"user_ty","","Optional user-given type: for something like `collect::<Vec<_>>`, this would be present and would indicate that `Vec<_>` was explicitly specified.",198,N],[13,"InlineAsm","rustc_mir::hair","",198,N],[12,"asm","rustc_mir::hair::ExprKind","",198,N],[12,"outputs","","",198,N],[12,"inputs","","",198,N],[13,"Yield","rustc_mir::hair","",198,N],[12,"value","rustc_mir::hair::ExprKind","",198,N],[4,"ExprRef","rustc_mir::hair","",N,N],[13,"Hair","","",199,N],[13,"Mirror","","",199,N],[4,"Guard","","",N,N],[13,"If","","",200,N],[4,"LogicalOp","","",N,N],[13,"And","","",201,N],[13,"Or","","",201,N],[0,"cx","","This module contains the code to convert from the wacky tcx data structures into the hair. The `builder` is generally ignorant of the tcx etc, and instead goes through the `Cx` for most of its work.",N,N],[3,"Cx","rustc_mir::hair::cx","",N,N],[12,"tcx","","",202,N],[12,"infcx","","",202,N],[12,"root_lint_level","","",202,N],[12,"param_env","","",202,N],[12,"identity_substs","","Identity `Substs` for use with const-evaluation.",202,N],[12,"region_scope_tree","","",202,N],[12,"tables","","",202,N],[12,"constness","","This is `Constness::Const` if we are compiling a `static`, `const`, or the body of a `const fn`.",202,N],[12,"body_owner_kind","","What kind of body is being compiled.",202,N],[12,"check_overflow","","True if this constant/function needs overflow checks.",202,N],[5,"lint_level_for_hir_id","","",N,[[["tyctxt"],["nodeid"]],["nodeid"]]],[0,"block","","",N,N],[5,"mirror_stmts","rustc_mir::hair::cx::block","",N,N],[5,"to_expr_ref","","",N,[[["cx"],["block"]],["exprref"]]],[0,"expr","rustc_mir::hair::cx","",N,N],[5,"apply_adjustment","rustc_mir::hair::cx::expr","",N,[[["cx"],["expr"],["expr"],["adjustment"]],["expr"]]],[5,"make_mirror_unadjusted","","",N,[[["cx"],["expr"]],["expr"]]],[5,"user_annotated_ty_for_def","","",N,[[["cx"],["hirid"],["def"]],["option",["canonicalty"]]]],[5,"user_annotated_ty_for_adt","","",N,[[["cx"],["hirid"],["adtdef"]],["option",["canonicalty"]]]],[5,"method_callee","","",N,[[["cx"],["expr"],["option"]],["expr"]]],[5,"convert_arm","","",N,[[["cx"],["arm"]],["arm"]]],[5,"convert_path_expr","","",N,[[["cx"],["expr"],["def"]],["exprkind"]]],[5,"convert_var","","",N,[[["cx"],["expr"],["def"]],["exprkind"]]],[5,"bin_op","","",N,[[["binopkind"]],["binop"]]],[5,"overloaded_operator","","",N,[[["cx"],["expr"],["vec",["exprref"]]],["exprkind"]]],[5,"overloaded_place","","",N,[[["cx"],["expr"],["ty"],["option"],["vec",["exprref"]]],["exprkind"]]],[5,"capture_freevar","","",N,[[["cx"],["expr"],["freevar"],["ty"]],["exprref"]]],[5,"field_refs","","Converts a list of named fields (i.e. for struct-like struct/enum ADTs) into FieldExprRef.",N,N],[8,"ToBorrowKind","","",N,N],[10,"to_borrow_kind","","",203,[[["self"]],["borrowkind"]]],[0,"to_ref","rustc_mir::hair::cx","",N,N],[8,"ToRef","rustc_mir::hair::cx::to_ref","",N,N],[16,"Output","","",204,N],[10,"to_ref","","",204,N],[11,"to_ref","rustc_mir::hair","",190,[[["self"]],["exprref"]]],[11,"clone","rustc_mir::hair::cx","",202,[[["self"]],["cx"]]],[11,"new","","",202,[[["inferctxt"],["nodeid"]],["cx"]]],[11,"mirror","","Normalizes `ast` into the appropriate `mirror` type.",202,N],[11,"usize_ty","","",202,[[["self"]],["ty"]]],[11,"usize_literal","","",202,[[["self"],["u64"]],["const"]]],[11,"bool_ty","","",202,[[["self"]],["ty"]]],[11,"unit_ty","","",202,[[["self"]],["ty"]]],[11,"true_literal","","",202,[[["self"]],["const"]]],[11,"false_literal","","",202,[[["self"]],["const"]]],[11,"const_eval_literal","","",202,[[["self"],["litkind"],["ty"],["span"],["bool"]],["const"]]],[11,"pattern_from_hir","","",202,[[["self"],["pat"]],["pattern"]]],[11,"trait_method","","",202,N],[11,"all_fields","","",202,[[["self"],["adtdef"],["usize"]],["vec",["field"]]]],[11,"needs_drop","","",202,[[["self"],["ty"]],["bool"]]],[11,"lint_level_of","","",202,[[["self"],["nodeid"]],["lintlevel"]]],[11,"tcx","","",202,[[["self"]],["tyctxt"]]],[11,"tables","","",202,[[["self"]],["typecktables"]]],[11,"check_overflow","","",202,[[["self"]],["bool"]]],[11,"type_moves_by_default","","",202,[[["self"],["ty"],["span"]],["bool"]]],[0,"pattern","rustc_mir::hair","Code to validate patterns/matches",N,N],[3,"FieldPattern","rustc_mir::hair::pattern","",N,N],[12,"field","","",205,N],[12,"pattern","","",205,N],[3,"Pattern","","",N,N],[12,"ty","","",206,N],[12,"span","","",206,N],[12,"kind","","",206,N],[3,"PatternContext","","",N,N],[12,"tcx","","",207,N],[12,"param_env","","",207,N],[12,"tables","","",207,N],[12,"substs","","",207,N],[12,"errors","","",207,N],[4,"PatternError","","",N,N],[13,"AssociatedConstInPattern","","",208,N],[13,"StaticInPattern","","",208,N],[13,"FloatBug","","",208,N],[13,"NonConstPath","","",208,N],[4,"BindingMode","","",N,N],[13,"ByValue","","",209,N],[13,"ByRef","","",209,N],[4,"PatternKind","","",N,N],[13,"Wild","","",210,N],[13,"AscribeUserType","","",210,N],[12,"user_ty","rustc_mir::hair::pattern::PatternKind","",210,N],[12,"subpattern","","",210,N],[13,"Binding","rustc_mir::hair::pattern","x, ref x, x @ P, etc",210,N],[12,"mutability","rustc_mir::hair::pattern::PatternKind","",210,N],[12,"name","","",210,N],[12,"mode","","",210,N],[12,"var","","",210,N],[12,"ty","","",210,N],[12,"subpattern","","",210,N],[13,"Variant","rustc_mir::hair::pattern","Foo(...) or Foo{...} or Foo, where `Foo` is a variant name from an adt with >1 variants",210,N],[12,"adt_def","rustc_mir::hair::pattern::PatternKind","",210,N],[12,"substs","","",210,N],[12,"variant_index","","",210,N],[12,"subpatterns","","",210,N],[13,"Leaf","rustc_mir::hair::pattern","(...), Foo(...), Foo{...}, or Foo, where `Foo` is a variant name from an adt with 1 variant",210,N],[12,"subpatterns","rustc_mir::hair::pattern::PatternKind","",210,N],[13,"Deref","rustc_mir::hair::pattern","box P, &P, &mut P, etc",210,N],[12,"subpattern","rustc_mir::hair::pattern::PatternKind","",210,N],[13,"Constant","rustc_mir::hair::pattern","",210,N],[12,"value","rustc_mir::hair::pattern::PatternKind","",210,N],[13,"Range","rustc_mir::hair::pattern","",210,N],[12,"lo","rustc_mir::hair::pattern::PatternKind","",210,N],[12,"hi","","",210,N],[12,"ty","","",210,N],[12,"end","","",210,N],[13,"Slice","rustc_mir::hair::pattern","matches against a slice, checking the length and extracting elements. irrefutable when there is a slice pattern and both `prefix` and `suffix` are empty. e.g. `&[ref xs..]`.",210,N],[12,"prefix","rustc_mir::hair::pattern::PatternKind","",210,N],[12,"slice","","",210,N],[12,"suffix","","",210,N],[13,"Array","rustc_mir::hair::pattern","fixed match against an array, irrefutable",210,N],[12,"prefix","rustc_mir::hair::pattern::PatternKind","",210,N],[12,"slice","","",210,N],[12,"suffix","","",210,N],[4,"LitToConstError","rustc_mir::hair::pattern","",N,N],[13,"UnparseableFloat","","",211,N],[13,"Propagated","","",211,N],[5,"compare_const_vals","","",N,[[["tyctxt"],["const"],["const"],["paramenvand",["ty"]]],["option",["ordering"]]]],[5,"lit_to_const","","",N,[[["litkind"],["tyctxt"],["ty"],["bool"]],["result",["const","littoconsterror"]]]],[5,"parse_float","","",N,[[["symbol"],["floatty"],["bool"]],["result",["constvalue"]]]],[0,"_match","","",N,N],[3,"LiteralExpander","rustc_mir::hair::pattern::_match","",N,N],[3,"Matrix","","",N,N],[12,"0","","",212,N],[3,"MatchCheckCtxt","","",N,N],[12,"tcx","","",213,N],[12,"module","","The module in which the match occurs. This is necessary for checking inhabited-ness of types because whether a type is (visibly) inhabited can depend on whether it was defined in the current module or not. eg. `struct Foo { _private: ! }` cannot be seen to be empty outside it's module and should not be matchable with an empty match statement.",213,N],[12,"pattern_arena","","",213,N],[12,"byte_array_map","","",213,N],[3,"PatternContext","","",N,N],[12,"ty","","",214,N],[12,"max_slice_length","","",214,N],[3,"Witness","","A witness of non-exhaustiveness for error reporting, represented as a list of patterns (in reverse order of construction) with wildcards inside to represent elements that can take any inhabitant of the type as a value.",N,N],[12,"0","","",215,N],[3,"IntRange","","An inclusive interval, used for precise integer exhaustiveness checking. `IntRange`s always store a contiguous range. This means that values are encoded such that `0` encodes the minimum value for the integer, regardless of the signedness. For example, the pattern `-128...127i8` is encoded as `0..=255`. This makes comparisons and arithmetic on interval endpoints much more straightforward. See `signed_bias` for details.",N,N],[12,"range","","",216,N],[12,"ty","","",216,N],[4,"Constructor","","",N,N],[13,"Single","","The constructor of all patterns that don't vary by constructor, e.g. struct patterns and fixed-length arrays.",217,N],[13,"Variant","","Enum variants.",217,N],[13,"ConstantValue","","Literal values.",217,N],[13,"ConstantRange","","Ranges of literal values (`2...5` and `2..5`).",217,N],[13,"Slice","","Array patterns of length n.",217,N],[4,"Usefulness","","",N,N],[13,"Useful","","",218,N],[13,"UsefulWithWitness","","",218,N],[13,"NotUseful","","",218,N],[4,"WitnessPreference","","",N,N],[13,"ConstructWitness","","",219,N],[13,"LeaveOutWitness","","",219,N],[5,"expand_pattern","","",N,[[["matchcheckctxt"],["pattern"]],["pattern"]]],[5,"all_constructors","","This determines the set of all possible constructors of a pattern matching values of type `left_ty`. For vectors, this would normally be an infinite set but is instead bounded by the maximum fixed length of slice patterns in the column of patterns being analyzed.",N,[[["matchcheckctxt"],["patterncontext"]],["vec",["constructor"]]]],[5,"max_slice_length","","",N,[[["matchcheckctxt"],["i"]],["u64"]]],[5,"compute_missing_ctors","","",N,[[["tyctxt"],["vec"],["vec"]],["vec",["constructor"]]]],[5,"is_useful","","Algorithm from http://moscova.inria.fr/~maranget/papers/warn/index.html The algorithm from the paper has been modified to correctly handle empty types. The changes are:   (0) We don't exit early if the pattern matrix has zero rows. We just       continue to recurse over columns.   (1) all_constructors will only return constructors that are statically       possible. eg. it will only return Ok for Result<T, !>",N,N],[5,"is_useful_specialized","","A shorthand for the `U(S(c, P), S(c, q))` operation from the paper. I.e. `is_useful` applied to the specialised version of both the pattern matrix `P` and the new pattern `q`.",N,N],[5,"pat_constructors","","Determines the constructors that the given pattern can be specialized to.",N,[[["matchcheckctxt"],["pattern"],["patterncontext"]],["option",["vec"]]]],[5,"constructor_arity","","This computes the arity of a constructor. The arity of a constructor is how many subpattern patterns of that constructor should be expanded to.",N,[[["matchcheckctxt"],["constructor"],["ty"]],["u64"]]],[5,"constructor_sub_pattern_tys","","This computes the types of the sub patterns that a constructor should be expanded to.",N,[[["matchcheckctxt"],["constructor"],["ty"]],["vec",["ty"]]]],[5,"slice_pat_covered_by_constructor","","",N,N],[5,"should_treat_range_exhaustively","","",N,[[["tyctxt"],["constructor"]],["bool"]]],[5,"split_grouped_constructors","","For exhaustive integer matching, some constructors are grouped within other constructors (namely integer typed values are grouped within ranges). However, when specialising these constructors, we want to be specialising for the underlying constructors (the integers), not the groups (the ranges). Thus we need to split the groups up. Splitting them up naïvely would mean creating a separate constructor for every single value in the range, which is clearly impractical. However, observe that for some ranges of integers, the specialisation will be identical across all values in that range (i.e. there are equivalence classes of ranges of constructors based on their `is_useful_specialised` outcome). These classes are grouped by the patterns that apply to them (in the matrix `P`). We can split the range whenever the patterns that apply to that range (specifically: the patterns that intersect with that range) change. Our solution, therefore, is to split the range constructor into subranges at every single point the group of intersecting patterns changes (using the method described below). And voilà! We're testing precisely those ranges that we need to, without any exhaustive matching on actual integers. The nice thing about this is that the number of subranges is linear in the number of rows in the matrix (i.e. the number of cases in the `match` statement), so we don't need to be worried about matching over gargantuan ranges.",N,[[["tyctxt"],["vec",["constructor"]],["matrix"],["ty"]],["vec",["constructor"]]]],[5,"constructor_intersects_pattern","","Check whether there exists any shared value in either `ctor` or `pat` by intersecting them.",N,[[["tyctxt"],["constructor"],["pattern"]],["option",["vec"]]]],[5,"constructor_covered_by_range","","",N,[[["tyctxt"],["constructor"],["pattern"]],["result",["bool","errorreported"]]]],[5,"patterns_for_variant","","",N,N],[5,"specialize","","This is the main specialization step. It expands the first pattern in the given row into `arity` patterns based on the constructor. For most patterns, the step is trivial, for instance tuple patterns are flattened and box patterns expand into their inner pattern.",N,N],[11,"fold_pattern","","",220,[[["self"],["pattern"]],["pattern"]]],[11,"is_wildcard","rustc_mir::hair::pattern","",206,[[["self"]],["bool"]]],[11,"empty","rustc_mir::hair::pattern::_match","",212,[[],["self"]]],[11,"push","","",212,[[["self"],["vec",["pattern"]]]]],[11,"fmt","","",212,[[["self"],["formatter"]],["result"]]],[11,"from_iter","","",212,[[["t"]],["self"]]],[11,"create_and_enter","","",213,[[["tyctxt"],["defid"],["f"]],["r"]]],[11,"lower_byte_str_pattern","","",213,[[["self"],["pattern"]],["vec",["pattern"]]]],[11,"is_uninhabited","","",213,[[["self"],["ty"]],["bool"]]],[11,"is_non_exhaustive_enum","","",213,[[["self"],["ty"]],["bool"]]],[11,"is_local","","",213,[[["self"],["ty"]],["bool"]]],[11,"is_variant_uninhabited","","",213,[[["self"],["variantdef"],["substs"]],["bool"]]],[11,"clone","","",217,[[["self"]],["constructor"]]],[11,"fmt","","",217,[[["self"],["formatter"]],["result"]]],[11,"eq","","",217,[[["self"],["constructor"]],["bool"]]],[11,"ne","","",217,[[["self"],["constructor"]],["bool"]]],[11,"variant_index_for_adt","","",217,[[["self"],["adtdef"]],["usize"]]],[11,"clone","","",218,[[["self"]],["usefulness"]]],[11,"fmt","","",218,[[["self"],["formatter"]],["result"]]],[11,"is_useful","","",218,[[["self"]],["bool"]]],[11,"clone","","",219,[[["self"]],["witnesspreference"]]],[11,"fmt","","",219,[[["self"],["formatter"]],["result"]]],[11,"clone","","",214,[[["self"]],["patterncontext"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"clone","","",215,[[["self"]],["witness"]]],[11,"fmt","","",215,[[["self"],["formatter"]],["result"]]],[11,"single_pattern","","",215,[[["self"]],["pattern"]]],[11,"push_wild_constructor","","",215,[[["self"],["matchcheckctxt"],["constructor"],["ty"]],["self"]]],[11,"apply_constructor","","Constructs a partial witness for a pattern given a list of patterns expanded by the specialization step.",215,[[["self"],["matchcheckctxt"],["constructor"],["ty"]],["self"]]],[11,"clone","","",216,[[["self"]],["intrange"]]],[11,"from_ctor","","",216,[[["tyctxt"],["constructor"]],["option",["intrange"]]]],[11,"from_pat","","",216,[[["tyctxt"],["pattern"]],["option",["intrange"]]]],[11,"signed_bias","","",216,[[["tyctxt"],["ty"]],["u128"]]],[11,"range_to_ctor","","Convert a `RangeInclusive` to a `ConstantValue` or inclusive `ConstantRange`.",216,[[["tyctxt"],["ty"],["rangeinclusive",["u128"]]],["constructor"]]],[11,"subtract_from","","Return a collection of ranges that spans the values covered by `ranges`, subtracted by the values covered by `self`: i.e. `ranges \\ self` (in set notation).",216,[[["self"],["tyctxt"],["vec",["constructor"]]],["vec",["constructor"]]]],[11,"intersection","","",216,[[["self"],["self"]],["option"]]],[0,"check_match","rustc_mir::hair::pattern","",N,N],[3,"OuterVisitor","rustc_mir::hair::pattern::check_match","",N,N],[12,"tcx","","",221,N],[3,"MatchVisitor","","",N,N],[12,"tcx","","",222,N],[12,"tables","","",222,N],[12,"param_env","","",222,N],[12,"identity_substs","","",222,N],[12,"region_scope_tree","","",222,N],[3,"MutationChecker","","",N,N],[12,"cx","","",223,N],[3,"AtBindingPatternVisitor","","",N,N],[12,"cx","","",224,N],[12,"bindings_allowed","","",224,N],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"check_match","","",N,[[["tyctxt"],["defid"]],["result",["errorreported"]]]],[5,"create_e0004","","",N,[[["session"],["span"],["string"]],["diagnosticbuilder"]]],[5,"check_for_bindings_named_the_same_as_variants","","",N,[[["matchvisitor"],["pat"]]]],[5,"pat_is_catchall","","Checks for common cases of \"catchall\" patterns that may not be intended as such.",N,[[["pat"]],["bool"]]],[5,"check_arms","","",N,N],[5,"check_exhaustive","","",N,[[["matchcheckctxt"],["ty"],["span"],["matrix"]]]],[5,"check_legality_of_move_bindings","","",N,N],[5,"check_for_mutation_in_guard","","Ensures that a pattern guard doesn't borrow by mutable reference or assign.",N,[[["matchvisitor"],["guard"]]]],[5,"check_legality_of_bindings_in_at_patterns","","Forbids bindings in `@` patterns. This is necessary for memory safety, because of the way rvalues are handled in the borrow check. (See issue #14587.)",N,[[["matchvisitor"],["pat"]]]],[11,"nested_visit_map","","",221,[[["self"]],["nestedvisitormap"]]],[11,"visit_body","","",221,[[["self"],["body"]]]],[11,"nested_visit_map","","",222,[[["self"]],["nestedvisitormap"]]],[11,"visit_expr","","",222,[[["self"],["expr"]]]],[11,"visit_local","","",222,[[["self"],["local"]]]],[11,"visit_body","","",222,[[["self"],["body"]]]],[11,"report_inlining_errors","rustc_mir::hair::pattern","",207,[[["self"],["span"]]]],[11,"span_e0158","","",207,[[["self"],["span"],["str"]]]],[11,"check_patterns","rustc_mir::hair::pattern::check_match","",222,N],[11,"check_match","","",222,N],[11,"conservative_is_uninhabited","","",222,[[["self"],["ty"]],["bool"]]],[11,"check_irrefutable","","",222,[[["self"],["pat"],["str"]]]],[11,"matched_pat","","",223,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[11,"consume","","",223,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[11,"consume_pat","","",223,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[11,"borrow","","",223,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[11,"decl_without_init","","",223,[[["self"],["nodeid"],["span"]]]],[11,"mutate","","",223,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"nested_visit_map","","",224,[[["self"]],["nestedvisitormap"]]],[11,"visit_pat","","",224,[[["self"],["pat"]]]],[8,"PatternFoldable","rustc_mir::hair::pattern","",N,N],[11,"fold_with","","",225,[[["self"],["f"]],["self"]]],[10,"super_fold_with","","",225,[[["self"],["f"]],["self"]]],[8,"PatternFolder","","",N,N],[11,"fold_pattern","","",226,[[["self"],["pattern"]],["pattern"]]],[11,"fold_pattern_kind","","",226,[[["self"],["patternkind"]],["patternkind"]]],[11,"clone","","",208,[[["self"]],["patternerror"]]],[11,"fmt","","",208,[[["self"],["formatter"]],["result"]]],[11,"clone","","",209,[[["self"]],["bindingmode"]]],[11,"fmt","","",209,[[["self"],["formatter"]],["result"]]],[11,"clone","","",205,[[["self"]],["fieldpattern"]]],[11,"fmt","","",205,[[["self"],["formatter"]],["result"]]],[11,"clone","","",206,[[["self"]],["pattern"]]],[11,"fmt","","",206,[[["self"],["formatter"]],["result"]]],[11,"clone","","",210,[[["self"]],["patternkind"]]],[11,"fmt","","",210,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",206,[[["self"],["formatter"]],["result"]]],[11,"from_hir","","",206,[[["tyctxt"],["paramenvand",["substs"]],["typecktables"],["pat"]],["self"]]],[11,"new","","",207,[[["tyctxt"],["paramenvand",["substs"]],["typecktables"]],["self"]]],[11,"lower_pattern","","",207,[[["self"],["pat"]],["pattern"]]],[11,"lower_pattern_unadjusted","","",207,[[["self"],["pat"]],["pattern"]]],[11,"lower_patterns","","",207,N],[11,"lower_opt_pattern","","",207,[[["self"],["option"]],["option",["pattern"]]]],[11,"flatten_nested_slice_patterns","","",207,N],[11,"slice_or_array_pattern","","",207,N],[11,"lower_variant_or_leaf","","",207,[[["self"],["def"],["span"],["ty"],["vec",["fieldpattern"]]],["patternkind"]]],[11,"lower_path","","Takes a HIR Path. If the path is a constant, evaluates it and feeds it to `const_to_pat`. Any other path (like enum variants without fields) is converted to the corresponding pattern via `lower_variant_or_leaf`",207,[[["self"],["qpath"],["hirid"],["span"]],["pattern"]]],[11,"lower_lit","","Converts literals, paths and negation of literals to patterns. The special case for negation exists to allow things like -128i8 which would overflow if we tried to evaluate 128i8 and then negate afterwards.",207,[[["self"],["expr"]],["patternkind"]]],[11,"const_to_pat","","Converts an evaluated constant to a pattern (if possible). This means aggregate values (like structs and enums) are converted to a pattern that matches the value (as if you'd compare via eq).",207,[[["self"],["instance"],["const"],["hirid"],["span"]],["pattern"]]],[11,"super_fold_with","","",209,[[["self"],["f"]],["self"]]],[11,"super_fold_with","","",205,[[["self"],["f"]],["self"]]],[11,"fold_with","","",206,[[["self"],["f"]],["self"]]],[11,"super_fold_with","","",206,[[["self"],["f"]],["self"]]],[11,"fold_with","","",210,[[["self"],["f"]],["self"]]],[11,"super_fold_with","","",210,[[["self"],["f"]],["self"]]],[11,"eq","","",211,[[["self"],["littoconsterror"]],["bool"]]],[8,"Mirror","rustc_mir::hair","\"Mirroring\" is the process of converting from a HIR type into one of the HAIR types defined in this file. This is basically a \"on the fly\" desugaring step that hides a lot of the messiness in the tcx. For example, the mirror of a `&'tcx hir::Expr` is an `Expr<'tcx>`.",N,N],[16,"Output","","",227,N],[10,"make_mirror","","",227,N],[11,"clone","","",194,[[["self"]],["lintlevel"]]],[11,"fmt","","",194,[[["self"],["formatter"]],["result"]]],[11,"is_explicit","","",194,[[["self"]],["bool"]]],[11,"clone","","",188,[[["self"]],["block"]]],[11,"fmt","","",188,[[["self"],["formatter"]],["result"]]],[11,"clone","","",195,[[["self"]],["blocksafety"]]],[11,"fmt","","",195,[[["self"],["formatter"]],["result"]]],[11,"clone","","",196,[[["self"]],["stmtref"]]],[11,"fmt","","",196,[[["self"],["formatter"]],["result"]]],[11,"clone","","",189,[[["self"]],["stmt"]]],[11,"fmt","","",189,[[["self"],["formatter"]],["result"]]],[11,"clone","","",197,[[["self"]],["stmtkind"]]],[11,"fmt","","",197,[[["self"],["formatter"]],["result"]]],[11,"clone","","",190,[[["self"]],["expr"]]],[11,"fmt","","",190,[[["self"],["formatter"]],["result"]]],[11,"clone","","",198,[[["self"]],["exprkind"]]],[11,"fmt","","",198,[[["self"],["formatter"]],["result"]]],[11,"clone","","",199,[[["self"]],["exprref"]]],[11,"fmt","","",199,[[["self"],["formatter"]],["result"]]],[11,"clone","","",191,[[["self"]],["fieldexprref"]]],[11,"fmt","","",191,[[["self"],["formatter"]],["result"]]],[11,"clone","","",192,[[["self"]],["fruinfo"]]],[11,"fmt","","",192,[[["self"],["formatter"]],["result"]]],[11,"clone","","",193,[[["self"]],["arm"]]],[11,"fmt","","",193,[[["self"],["formatter"]],["result"]]],[11,"clone","","",200,[[["self"]],["guard"]]],[11,"fmt","","",200,[[["self"],["formatter"]],["result"]]],[11,"clone","","",201,[[["self"]],["logicalop"]]],[11,"fmt","","",201,[[["self"],["formatter"]],["result"]]],[11,"span","","",199,[[["self"]],["span"]]],[11,"make_mirror","","",190,[[["self"],["cx"]],["expr"]]],[11,"make_mirror","","",199,[[["self"],["cx"]],["expr"]]],[11,"make_mirror","","",189,[[["self"],["cx"]],["stmt"]]],[11,"make_mirror","","",196,[[["self"],["cx"]],["stmt"]]],[11,"make_mirror","","",188,[[["self"],["cx"]],["block"]]],[0,"shim","rustc_mir","",N,N],[3,"DropShimElaborator","rustc_mir::shim","",N,N],[12,"mir","","",228,N],[12,"patch","","",228,N],[12,"tcx","","",228,N],[12,"param_env","","",228,N],[3,"CloneShimBuilder","","",N,N],[12,"tcx","","",229,N],[12,"def_id","","",229,N],[12,"local_decls","","",229,N],[12,"blocks","","",229,N],[12,"span","","",229,N],[12,"sig","","",229,N],[4,"Adjustment","","",N,N],[13,"Identity","","",230,N],[13,"Deref","","",230,N],[13,"RefMut","","",230,N],[4,"CallKind","","",N,N],[13,"Indirect","","",231,N],[13,"Direct","","",231,N],[5,"provide","","",N,[[["providers"]]]],[5,"make_shim","","",N,[[["tyctxt"],["instancedef"]],["mir"]]],[5,"temp_decl","","",N,[[["mutability"],["ty"],["span"]],["localdecl"]]],[5,"local_decls_for_sig","","",N,[[["fnsig"],["span"]],["indexvec",["local","localdecl"]]]],[5,"build_drop_shim","","",N,[[["tyctxt"],["defid"],["option",["ty"]]],["mir"]]],[5,"build_clone_shim","","Build a `Clone::clone` shim for `self_ty`. Here, `def_id` is `Clone::clone`.",N,[[["tyctxt"],["defid"],["ty"]],["mir"]]],[5,"build_call_shim","","Build a \"call\" shim for `def_id`. The shim calls the function specified by `call_kind`, first adjusting its first argument according to `rcvr_adjustment`.",N,[[["tyctxt"],["defid"],["adjustment"],["callkind"],["option"]],["mir"]]],[5,"build_adt_ctor","","",N,N],[11,"clone","","",230,[[["self"]],["adjustment"]]],[11,"fmt","","",230,[[["self"],["formatter"]],["result"]]],[11,"eq","","",230,[[["self"],["adjustment"]],["bool"]]],[11,"clone","","",231,[[["self"]],["callkind"]]],[11,"fmt","","",231,[[["self"],["formatter"]],["result"]]],[11,"eq","","",231,[[["self"],["callkind"]],["bool"]]],[11,"ne","","",231,[[["self"],["callkind"]],["bool"]]],[11,"fmt","","",228,[[["self"],["formatter"]],["result",["error"]]]],[11,"patch","","",228,[[["self"]],["mirpatch"]]],[11,"mir","","",228,[[["self"]],["mir"]]],[11,"tcx","","",228,[[["self"]],["tyctxt"]]],[11,"param_env","","",228,[[["self"]],["paramenv"]]],[11,"drop_style","","",228,N],[11,"get_drop_flag","","",228,N],[11,"clear_drop_flag","","",228,N],[11,"field_subpath","","",228,N],[11,"deref_subpath","","",228,N],[11,"downcast_subpath","","",228,N],[11,"array_subpath","","",228,N],[11,"new","","",229,[[["tyctxt"],["defid"],["ty"]],["self"]]],[11,"into_mir","","",229,[[["self"]],["mir"]]],[11,"source_info","","",229,[[["self"]],["sourceinfo"]]],[11,"block","","",229,[[["self"],["vec",["statement"]],["terminatorkind"],["bool"]],["basicblock"]]],[11,"block_index_offset","","Gives the index of an upcoming BasicBlock, with an offset. offset=0 will give you the index of the next BasicBlock, offset=1 will give the index of the next-to-next block, offset=-1 will give you the index of the last-created block",229,[[["self"],["usize"]],["basicblock"]]],[11,"make_statement","","",229,[[["self"],["statementkind"]],["statement"]]],[11,"copy_shim","","",229,[[["self"]]]],[11,"make_place","","",229,[[["self"],["mutability"],["ty"]],["place"]]],[11,"make_clone_call","","",229,[[["self"],["place"],["place"],["ty"],["basicblock"],["basicblock"]]]],[11,"loop_header","","",229,[[["self"],["place"],["place"],["basicblock"],["basicblock"],["bool"]]]],[11,"make_usize","","",229,[[["self"],["u64"]],["box",["constant"]]]],[11,"array_shim","","",229,[[["self"],["place"],["place"],["ty"],["u64"]]]],[11,"tuple_like_shim","","",229,[[["self"],["place"],["place"],["i"]]]],[0,"transform","rustc_mir","",N,N],[3,"MirSource","rustc_mir::transform","Where a specific Mir comes from.",N,N],[12,"def_id","","",232,N],[12,"promoted","","If `Some`, this is a promoted rvalue within the parent function.",232,N],[5,"provide","","",N,[[["providers"]]]],[5,"is_mir_available","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"mir_keys","","Finds the full set of def-ids within the current crate that have MIR associated with them.",N,[[["tyctxt"],["cratenum"]],["lrc",["defidset"]]]],[5,"mir_built","","",N,[[["tyctxt"],["defid"]],["steal"]]],[5,"default_name","","Generates a default name for the pass based on the name of the type `T`.",N,[[],["cow",["str"]]]],[5,"mir_const","","",N,[[["tyctxt"],["defid"]],["steal"]]],[5,"mir_validated","","",N,[[["tyctxt"],["defid"]],["steal"]]],[5,"optimized_mir","","",N,[[["tyctxt"],["defid"]],["mir"]]],[0,"add_validation","","This pass adds validation calls (AcquireValid, ReleaseValid) where appropriate. It has to be run really early, before transformations like inlining, because introducing these calls adds UB -- so, conceptually, this pass is actually part of MIR building, and only after this pass we think of the program has having the normal MIR semantics.",N,N],[3,"AddValidation","rustc_mir::transform::add_validation","",N,N],[5,"place_context","","Determine the \"context\" of the place: Mutability and region.",N,N],[5,"fn_contains_unsafe","","Check if this function contains an unsafe block or is an unsafe function.",N,[[["tyctxt"],["mirsource"]],["bool"]]],[11,"run_pass","","",233,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"add_moves_for_packed_drops","rustc_mir::transform","",N,N],[3,"AddMovesForPackedDrops","rustc_mir::transform::add_moves_for_packed_drops","",N,N],[5,"add_moves_for_packed_drops","","",N,[[["tyctxt"],["mir"],["defid"]]]],[5,"add_moves_for_packed_drops_patch","","",N,[[["tyctxt"],["mir"],["defid"]],["mirpatch"]]],[5,"add_move_for_packed_drop","","",N,[[["tyctxt"],["mir"],["mirpatch"],["terminator"],["location"],["bool"]]]],[11,"run_pass","","",234,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"cleanup_post_borrowck","rustc_mir::transform","This module provides two passes:",N,N],[3,"CleanEndRegions","rustc_mir::transform::cleanup_post_borrowck","",N,N],[3,"GatherBorrowedRegions","","",N,N],[12,"seen_regions","","",235,N],[3,"DeleteTrivialEndRegions","","",N,N],[12,"seen_regions","","",236,N],[3,"CleanAscribeUserType","","",N,N],[3,"DeleteAscribeUserType","","",N,N],[11,"run_pass","","",237,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_rvalue","","",235,[[["self"],["rvalue"],["location"]]]],[11,"visit_ty","","",235,[[["self"],["ty"],["tycontext"]]]],[11,"visit_statement","","",236,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"run_pass","","",238,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_statement","","",239,[[["self"],["basicblock"],["statement"],["location"]]]],[0,"check_unsafety","rustc_mir::transform","",N,N],[3,"UnsafetyChecker","rustc_mir::transform::check_unsafety","",N,N],[12,"mir","","",240,N],[12,"min_const_fn","","",240,N],[12,"source_scope_local_data","","",240,N],[12,"violations","","",240,N],[12,"source_info","","",240,N],[12,"tcx","","",240,N],[12,"param_env","","",240,N],[12,"used_unsafe","","",240,N],[12,"inherited_blocks","","",240,N],[3,"UnusedUnsafeVisitor","","",N,N],[12,"used_unsafe","","",241,N],[12,"unsafe_blocks","","",241,N],[5,"provide","","",N,[[["providers"]]]],[5,"check_unused_unsafe","","",N,[[["tyctxt"],["defid"],["fxhashset"],["vec"]]]],[5,"unsafety_check_result","","",N,[[["tyctxt"],["defid"]],["unsafetycheckresult"]]],[5,"unsafe_derive_on_repr_packed","","",N,[[["tyctxt"],["defid"]]]],[5,"is_enclosed","","Return the NodeId for an enclosing scope that is also `unsafe`",N,[[["tyctxt"],["fxhashset"],["nodeid"]],["option"]]],[5,"report_unused_unsafe","","",N,[[["tyctxt"],["fxhashset"],["nodeid"]]]],[5,"builtin_derive_def_id","","",N,[[["tyctxt"],["defid"]],["option",["defid"]]]],[5,"check_unsafety","","",N,[[["tyctxt"],["defid"]]]],[11,"new","","",240,[[["bool"],["mir"],["indexvec"],["tyctxt"],["paramenv"]],["self"]]],[11,"visit_terminator","","",240,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_statement","","",240,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_rvalue","","",240,[[["self"],["rvalue"],["location"]]]],[11,"visit_place","","",240,[[["self"],["place"],["placecontext"],["location"]]]],[11,"require_unsafe","","",240,[[["self"],["str"],["str"]]]],[11,"register_violations","","",240,N],[11,"nested_visit_map","","",241,[[["self"]],["nestedvisitormap"]]],[11,"visit_block","","",241,[[["self"],["block"]]]],[0,"simplify_branches","rustc_mir::transform","A pass that simplifies branches when their condition is known.",N,N],[3,"SimplifyBranches","rustc_mir::transform::simplify_branches","",N,N],[12,"label","","",242,N],[11,"new","","",242,[[["str"]],["self"]]],[11,"name","","",242,[[["self"]],["cow",["str"]]]],[11,"run_pass","","",242,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"simplify","rustc_mir::transform","A number of passes which remove various redundancies in the CFG.",N,N],[3,"SimplifyCfg","rustc_mir::transform::simplify","",N,N],[12,"label","","",243,N],[3,"CfgSimplifier","","",N,N],[12,"basic_blocks","","",244,N],[12,"pred_count","","",244,N],[3,"SimplifyLocals","","",N,N],[3,"DeclMarker","","",N,N],[12,"locals","","",245,N],[3,"LocalUpdater","","",N,N],[12,"map","","",246,N],[5,"simplify_cfg","","",N,[[["mir"]]]],[5,"remove_dead_blocks","","",N,[[["mir"]]]],[5,"make_local_map","","Construct the mapping while swapping out unused stuff out from the `vec`.",N,[[["indexvec"],["bitarray",["local"]]],["indexvec",["local","option"]]]],[11,"new","","",243,[[["str"]],["self"]]],[11,"name","","",243,[[["self"]],["cow",["str"]]]],[11,"run_pass","","",243,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"new","","",244,[[["mir"]],["self"]]],[11,"simplify","","",244,[[["self"]]]],[11,"collapse_goto_chain","","",244,[[["self"],["basicblock"],["bool"]]]],[11,"merge_successor","","",244,[[["self"],["vec"],["terminator"]],["bool"]]],[11,"simplify_branch","","",244,[[["self"],["terminator"]],["bool"]]],[11,"strip_nops","","",244,[[["self"]]]],[11,"run_pass","","",247,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_local","","",245,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_basic_block_data","","",246,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_local","","",246,[[["self"],["local"],["placecontext"],["location"]]]],[0,"erase_regions","rustc_mir::transform","This pass erases all early-bound regions from the types occurring in the MIR. We want to do this once just before codegen, so codegen does not have to take care erasing regions all over the place. NOTE:  We do NOT erase regions of statements that are relevant for \"types-as-contracts\"-validation, namely, AcquireValid, ReleaseValid, and EndRegion.",N,N],[3,"EraseRegionsVisitor","rustc_mir::transform::erase_regions","",N,N],[12,"tcx","","",248,N],[12,"in_validation_statement","","",248,N],[3,"EraseRegions","","",N,N],[11,"new","","",248,[[["tyctxt"]],["self"]]],[11,"visit_ty","","",248,[[["self"],["ty"],["tycontext"]]]],[11,"visit_region","","",248,[[["self"],["region"],["location"]]]],[11,"visit_const","","",248,[[["self"],["const"],["location"]]]],[11,"visit_substs","","",248,[[["self"],["substs"],["location"]]]],[11,"visit_statement","","",248,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"run_pass","","",249,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"no_landing_pads","rustc_mir::transform","This pass removes the unwind branch of all the terminators when the no-landing-pads option is specified.",N,N],[3,"NoLandingPads","rustc_mir::transform::no_landing_pads","",N,N],[5,"no_landing_pads","","",N,[[["tyctxt"],["mir"]]]],[11,"run_pass","","",250,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_terminator","","",250,[[["self"],["basicblock"],["terminator"],["location"]]]],[0,"rustc_peek","rustc_mir::transform","",N,N],[3,"SanityCheck","rustc_mir::transform::rustc_peek","",N,N],[5,"sanity_check_via_rustc_peek","","This function scans `mir` for all calls to the intrinsic `rustc_peek` that have the expression form `rustc_peek(&expr)`.",N,N],[5,"each_block","","",N,[[["tyctxt"],["mir"],["dataflowresults"],["basicblock"]]]],[5,"is_rustc_peek","","",N,[[["tyctxt"],["option"]],["option"]]],[11,"run_pass","","",251,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"elaborate_drops","rustc_mir::transform","",N,N],[3,"ElaborateDrops","rustc_mir::transform::elaborate_drops","",N,N],[3,"InitializationData","","",N,N],[12,"live","","",252,N],[12,"dead","","",252,N],[3,"Elaborator","","",N,N],[12,"init_data","","",253,N],[12,"ctxt","","",253,N],[3,"ElaborateDropsCtxt","","",N,N],[12,"tcx","","",254,N],[12,"mir","","",254,N],[12,"env","","",254,N],[12,"flow_inits","","",254,N],[12,"flow_uninits","","",254,N],[12,"drop_flags","","",254,N],[12,"patch","","",254,N],[5,"find_dead_unwinds","","Return the set of basic blocks whose unwind edges are known to not be reachable, because they are `drop` terminators that can't drop anything.",N,[[["tyctxt"],["mir"],["nodeid"],["movedataparamenv"]],["idxset",["basicblock"]]]],[11,"run_pass","","",255,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"apply_location","","",252,[[["self"],["tyctxt"],["mir"],["movedataparamenv"],["location"]]]],[11,"state","","",252,N],[11,"fmt","","",253,[[["self"],["formatter"]],["result"]]],[11,"patch","","",253,[[["self"]],["mirpatch"]]],[11,"mir","","",253,[[["self"]],["mir"]]],[11,"tcx","","",253,[[["self"]],["tyctxt"]]],[11,"param_env","","",253,[[["self"]],["paramenv"]]],[11,"drop_style","","",253,N],[11,"clear_drop_flag","","",253,N],[11,"field_subpath","","",253,N],[11,"array_subpath","","",253,N],[11,"deref_subpath","","",253,N],[11,"downcast_subpath","","",253,N],[11,"get_drop_flag","","",253,N],[11,"move_data","","",254,[[["self"]],["movedata"]]],[11,"param_env","","",254,[[["self"]],["paramenv"]]],[11,"initialization_data_at","","",254,[[["self"],["location"]],["initializationdata"]]],[11,"create_drop_flag","","",254,[[["self"],["movepathindex"],["span"]]]],[11,"drop_flag","","",254,[[["self"],["movepathindex"]],["option",["place"]]]],[11,"elaborate","","create a patch that elaborates all drops in the input MIR.",254,[[["self"]],["mirpatch"]]],[11,"collect_drop_flags","","",254,[[["self"]]]],[11,"elaborate_drops","","",254,[[["self"]]]],[11,"elaborate_replace","","Elaborate a MIR `replace` terminator. This instruction is not directly handled by codegen, and therefore must be desugared.",254,[[["self"],["location"],["place"],["operand"],["basicblock"],["option",["basicblock"]]]]],[11,"constant_bool","","",254,[[["self"],["span"],["bool"]],["rvalue"]]],[11,"set_drop_flag","","",254,[[["self"],["location"],["movepathindex"],["dropflagstate"]]]],[11,"drop_flags_on_init","","",254,[[["self"]]]],[11,"drop_flags_for_fn_rets","","",254,[[["self"]]]],[11,"drop_flags_for_args","","",254,[[["self"]]]],[11,"drop_flags_for_locs","","",254,[[["self"]]]],[0,"add_call_guards","rustc_mir::transform","",N,N],[4,"AddCallGuards","rustc_mir::transform::add_call_guards","",N,N],[13,"AllCallEdges","","",256,N],[13,"CriticalCallEdges","","",256,N],[11,"eq","","",256,[[["self"],["addcallguards"]],["bool"]]],[11,"run_pass","","",256,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"add_call_guards","","",256,[[["self"],["mir"]]]],[0,"promote_consts","rustc_mir::transform","A pass that promotes borrows of constant rvalues.",N,N],[3,"TempCollector","rustc_mir::transform::promote_consts","",N,N],[12,"temps","","",257,N],[12,"span","","",257,N],[12,"mir","","",257,N],[3,"Promoter","","",N,N],[12,"tcx","","",258,N],[12,"source","","",258,N],[12,"promoted","","",258,N],[12,"temps","","",258,N],[12,"keep_original","","If true, all nested temps are also kept in the source MIR, not moved to the promoted MIR.",258,N],[4,"TempState","","State of a temporary during collection and promotion.",N,N],[13,"Undefined","","No references to this temp.",259,N],[13,"Defined","","One direct assignment and any number of direct uses. A borrow of this temp is promotable if the assigned value is qualified as constant.",259,N],[12,"location","rustc_mir::transform::promote_consts::TempState","",259,N],[12,"uses","","",259,N],[13,"Unpromotable","rustc_mir::transform::promote_consts","Any other combination of assignments/uses.",259,N],[13,"PromotedOut","","This temp was part of an rvalue which got extracted during promotion and needs cleanup.",259,N],[4,"Candidate","","A \"root candidate\" for promotion, which will become the returned value in a promoted MIR, unless it's a subset of a larger candidate.",N,N],[13,"Ref","","Borrow of a constant temporary.",260,N],[13,"Argument","","Currently applied to function calls where the callee has the unstable `#[rustc_args_required_const]` attribute as well as the SIMD shuffle intrinsic. The intrinsic requires the arguments are indeed constant and the attribute currently provides the semantic requirement that arguments must be constant.",260,N],[12,"bb","rustc_mir::transform::promote_consts::Candidate","",260,N],[12,"index","","",260,N],[5,"collect_temps","rustc_mir::transform::promote_consts","",N,[[["mir"],["reversepostorder"]],["indexvec",["local","tempstate"]]]],[5,"promote_candidates","","",N,[[["mir"],["tyctxt"],["indexvec",["local","tempstate"]],["vec",["candidate"]]]]],[11,"clone","","",259,[[["self"]],["tempstate"]]],[11,"eq","","",259,[[["self"],["tempstate"]],["bool"]]],[11,"ne","","",259,[[["self"],["tempstate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",259,N],[11,"fmt","","",259,[[["self"],["formatter"]],["result"]]],[11,"is_promotable","","",259,[[["self"]],["bool"]]],[11,"fmt","","",260,[[["self"],["formatter"]],["result"]]],[11,"visit_local","","",257,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_source_info","","",257,[[["self"],["sourceinfo"]]]],[11,"new_block","","",258,[[["self"]],["basicblock"]]],[11,"assign","","",258,[[["self"],["local"],["rvalue"],["span"]]]],[11,"promote_temp","","Copy the initialization of this temp to the promoted MIR, recursing through temps.",258,[[["self"],["local"]],["local"]]],[11,"promote_candidate","","",258,[[["self"],["candidate"]]]],[11,"visit_local","","",258,[[["self"],["local"],["placecontext"],["location"]]]],[0,"qualify_consts","rustc_mir::transform","A pass that qualifies constness of temporaries in constants, static initializers and functions and also drives promotion.",N,N],[3,"Qualif","rustc_mir::transform::qualify_consts","",N,N],[12,"bits","","",261,N],[3,"Qualifier","","",N,N],[12,"mode","","",262,N],[12,"span","","",262,N],[12,"def_id","","",262,N],[12,"mir","","",262,N],[12,"rpo","","",262,N],[12,"tcx","","",262,N],[12,"param_env","","",262,N],[12,"local_qualif","","",262,N],[12,"qualif","","",262,N],[12,"const_fn_arg_vars","","",262,N],[12,"temp_promotion_state","","",262,N],[12,"promotion_candidates","","",262,N],[3,"QualifyAndPromoteConstants","","",N,N],[4,"Mode","","What kind of item we are in.",N,N],[13,"Const","","",263,N],[13,"Static","","",263,N],[13,"StaticMut","","",263,N],[13,"ConstFn","","",263,N],[13,"Fn","","",263,N],[5,"provide","","",N,[[["providers"]]]],[5,"mir_const_qualif","","",N,N],[5,"args_required_const","","",N,[[["tyctxt"],["defid"]],["option",["fxhashset"]]]],[11,"eq","","",261,[[["self"],["qualif"]],["bool"]]],[11,"ne","","",261,[[["self"],["qualif"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",261,N],[11,"clone","","",261,[[["self"]],["qualif"]]],[11,"partial_cmp","","",261,[[["self"],["qualif"]],["option",["ordering"]]]],[11,"lt","","",261,[[["self"],["qualif"]],["bool"]]],[11,"le","","",261,[[["self"],["qualif"]],["bool"]]],[11,"gt","","",261,[[["self"],["qualif"]],["bool"]]],[11,"ge","","",261,[[["self"],["qualif"]],["bool"]]],[11,"cmp","","",261,[[["self"],["qualif"]],["ordering"]]],[11,"hash","","",261,N],[11,"fmt","","",261,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",261,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",261,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",261,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",261,[[["self"],["formatter"]],["result"]]],[18,"MUTABLE_INTERIOR","","",261,N],[18,"NEEDS_DROP","","",261,N],[18,"FN_ARGUMENT","","",261,N],[18,"NOT_CONST","","",261,N],[18,"NOT_PROMOTABLE","","",261,N],[18,"CONST_ERROR","","",261,N],[11,"empty","","Returns an empty set of flags.",261,[[],["qualif"]]],[11,"all","","Returns the set containing all flags.",261,[[],["qualif"]]],[11,"bits","","Returns the raw value of the flags currently stored.",261,[[["self"]],["u8"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",261,[[["u8"]],["option",["qualif"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",261,[[["u8"]],["qualif"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",261,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",261,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",261,[[["self"],["qualif"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",261,[[["self"],["qualif"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",261,[[["self"],["qualif"]]]],[11,"remove","","Removes the specified flags in-place.",261,[[["self"],["qualif"]]]],[11,"toggle","","Toggles the specified flags in-place.",261,[[["self"],["qualif"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",261,[[["self"],["qualif"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",261,[[["self"],["qualif"]],["qualif"]]],[11,"bitor_assign","","Adds the set of flags.",261,[[["self"],["qualif"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",261,[[["self"],["qualif"]],["qualif"]]],[11,"bitxor_assign","","Toggles the set of flags.",261,[[["self"],["qualif"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",261,[[["self"],["qualif"]],["qualif"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",261,[[["self"],["qualif"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",261,[[["self"],["qualif"]],["qualif"]]],[11,"sub_assign","","Disables all flags enabled in the set.",261,[[["self"],["qualif"]]]],[11,"not","","Returns the complement of this set of flags.",261,[[["self"]],["qualif"]]],[11,"extend","","",261,[[["self"],["t"]]]],[11,"from_iter","","",261,[[["t"]],["qualif"]]],[11,"restrict","","Remove flags which are impossible for the given type.",261,[[["self"],["ty"],["tyctxt"],["paramenv"]]]],[11,"clone","","",263,[[["self"]],["mode"]]],[11,"eq","","",263,[[["self"],["mode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",263,N],[11,"fmt","","",263,[[["self"],["formatter"]],["result"]]],[11,"new","","",262,[[["tyctxt"],["defid"],["mir"],["mode"]],["qualifier"]]],[11,"not_const","","",262,[[["self"]]]],[11,"statement_like","","Error about extra statements in a constant.",262,[[["self"]]]],[11,"add","","Add the given qualification to self.qualif.",262,[[["self"],["qualif"]]]],[11,"add_type","","Add the given type's qualification to self.qualif.",262,[[["self"],["ty"]]]],[11,"nest","","Within the provided closure, self.qualif will start out empty, and its value after the closure returns will be combined with the value before the call to nest.",262,[[["self"],["f"]]]],[11,"assign","","Assign the current qualification to the given destination.",262,[[["self"],["place"],["location"]]]],[11,"qualify_const","","Qualify a whole const, static initializer or const fn.",262,N],[11,"is_const_panic_fn","","",262,[[["self"],["defid"]],["bool"]]],[11,"visit_local","","",262,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_place","","",262,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_operand","","",262,[[["self"],["operand"],["location"]]]],[11,"visit_rvalue","","",262,[[["self"],["rvalue"],["location"]]]],[11,"visit_terminator_kind","","",262,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_assign","","",262,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_source_info","","",262,[[["self"],["sourceinfo"]]]],[11,"visit_statement","","",262,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_terminator","","",262,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"run_pass","","",264,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"qualify_min_const_fn","rustc_mir::transform","",N,N],[4,"PlaceMode","rustc_mir::transform::qualify_min_const_fn","",N,N],[13,"Assign","","",265,N],[13,"Read","","",265,N],[5,"is_min_const_fn","","",N,[[["tyctxt"],["defid"],["mir"]],["result"]]],[5,"check_ty","","",N,[[["tyctxt"],["ty"],["span"]],["result"]]],[5,"check_rvalue","","",N,[[["tyctxt"],["mir"],["rvalue"],["span"]],["result"]]],[5,"check_statement","","",N,[[["tyctxt"],["mir"],["statement"]],["result"]]],[5,"check_operand","","",N,[[["tyctxt"],["mir"],["operand"],["span"]],["result"]]],[5,"check_place","","",N,[[["tyctxt"],["mir"],["place"],["span"],["placemode"]],["result"]]],[5,"check_terminator","","",N,[[["tyctxt"],["mir"],["terminator"]],["result"]]],[6,"McfResult","","",N,N],[0,"remove_noop_landing_pads","rustc_mir::transform","",N,N],[3,"RemoveNoopLandingPads","rustc_mir::transform::remove_noop_landing_pads","A pass that removes no-op landing pads and replaces jumps to them with `None`. This is important because otherwise LLVM generates terrible code for these.",N,N],[5,"remove_noop_landing_pads","","",N,[[["tyctxt"],["mir"]]]],[11,"run_pass","","",266,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"is_nop_landing_pad","","",266,[[["self"],["basicblock"],["mir"],["bitarray"]],["bool"]]],[11,"remove_nop_landing_pads","","",266,[[["self"],["mir"]]]],[0,"dump_mir","rustc_mir::transform","This pass just dumps MIR at a specified point.",N,N],[3,"Marker","rustc_mir::transform::dump_mir","",N,N],[12,"0","","",267,N],[3,"Disambiguator","","",N,N],[12,"is_after","","",268,N],[5,"on_mir_pass","","",N,[[["tyctxt"],["display"],["str"],["mirsource"],["mir"],["bool"]]]],[5,"emit_mir","","",N,[[["tyctxt"],["outputfilenames"]],["result"]]],[11,"name","","",267,[[["self"]],["cow",["str"]]]],[11,"run_pass","","",267,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"fmt","","",268,[[["self"],["formatter"]],["result"]]],[0,"deaggregator","rustc_mir::transform","",N,N],[3,"Deaggregator","rustc_mir::transform::deaggregator","",N,N],[11,"run_pass","","",269,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"instcombine","rustc_mir::transform","Performs various peephole optimizations.",N,N],[3,"InstCombine","rustc_mir::transform::instcombine","",N,N],[3,"InstCombineVisitor","","",N,N],[12,"optimizations","","",270,N],[3,"OptimizationFinder","","Finds optimization opportunities on the MIR.",N,N],[12,"mir","","",271,N],[12,"tcx","","",271,N],[12,"optimizations","","",271,N],[3,"OptimizationList","","",N,N],[12,"and_stars","","",272,N],[12,"arrays_lengths","","",272,N],[11,"run_pass","","",273,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_rvalue","","",270,[[["self"],["rvalue"],["location"]]]],[11,"new","","",271,[[["mir"],["tyctxt"]],["optimizationfinder"]]],[11,"visit_rvalue","","",271,[[["self"],["rvalue"],["location"]]]],[11,"default","","",272,[[],["optimizationlist"]]],[0,"copy_prop","rustc_mir::transform","Trivial copy propagation pass.",N,N],[3,"CopyPropagation","rustc_mir::transform::copy_prop","",N,N],[3,"ConstantPropagationVisitor","","",N,N],[12,"dest_local","","",274,N],[12,"constant","","",274,N],[12,"uses_replaced","","",274,N],[4,"Action","","",N,N],[13,"PropagateLocalCopy","","",275,N],[13,"PropagateConstant","","",275,N],[5,"eliminate_self_assignments","","",N,[[["mir"],["defuseanalysis"]],["bool"]]],[11,"run_pass","","",276,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"local_copy","","",275,[[["mir"],["defuseanalysis"],["place"]],["option",["action"]]]],[11,"constant","","",275,[[["constant"]],["option",["action"]]]],[11,"perform","","",275,[[["self"],["mir"],["defuseanalysis"],["local"],["location"]],["bool"]]],[11,"new","","",274,[[["local"],["constant"]],["constantpropagationvisitor"]]],[11,"visit_operand","","",274,[[["self"],["operand"],["location"]]]],[0,"const_prop","rustc_mir::transform","Propagates constants for early reporting of statically known assertion failures",N,N],[3,"ConstProp","rustc_mir::transform::const_prop","",N,N],[3,"ConstPropagator","","Finds optimization opportunities on the MIR.",N,N],[12,"ecx","","",277,N],[12,"mir","","",277,N],[12,"tcx","","",277,N],[12,"source","","",277,N],[12,"places","","",277,N],[12,"can_const_prop","","",277,N],[12,"param_env","","",277,N],[3,"CanConstProp","","",N,N],[12,"can_const_prop","","",278,N],[12,"found_assignment","","",278,N],[5,"type_size_of","","",N,[[["tyctxt"],["paramenv"],["ty"]],["option",["u64"]]]],[6,"Const","","",N,N],[11,"run_pass","","",279,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"new","","",277,[[["mir"],["tyctxt"],["mirsource"]],["constpropagator"]]],[11,"use_ecx","","",277,[[["self"],["sourceinfo"],["f"]],["option"]]],[11,"eval_constant","","",277,[[["self"],["constant"],["sourceinfo"]],["option"]]],[11,"eval_place","","",277,[[["self"],["place"],["sourceinfo"]],["option"]]],[11,"eval_operand","","",277,[[["self"],["operand"],["sourceinfo"]],["option"]]],[11,"const_prop","","",277,[[["self"],["rvalue"],["tylayout"],["sourceinfo"]],["option"]]],[11,"check","","returns true if `local` can be propagated",278,[[["mir"]],["indexvec",["local","bool"]]]],[11,"visit_local","","",278,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_constant","","",277,[[["self"],["constant"],["location"]]]],[11,"visit_statement","","",277,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_terminator_kind","","",277,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[0,"generator","rustc_mir::transform","This is the implementation of the pass which transforms generators into state machines.",N,N],[3,"StateTransform","rustc_mir::transform::generator","",N,N],[3,"RenameLocalVisitor","","",N,N],[12,"from","","",280,N],[12,"to","","",280,N],[3,"DerefArgVisitor","","",N,N],[3,"SuspensionPoint","","",N,N],[12,"state","","",281,N],[12,"resume","","",281,N],[12,"drop","","",281,N],[12,"storage_liveness","","",281,N],[3,"TransformVisitor","","",N,N],[12,"tcx","","",282,N],[12,"state_adt_ref","","",282,N],[12,"state_substs","","",282,N],[12,"state_field","","",282,N],[12,"remap","","",282,N],[12,"storage_liveness","","",282,N],[12,"suspension_points","","",282,N],[12,"new_ret_local","","",282,N],[3,"StorageIgnored","","",N,N],[12,"0","","",283,N],[3,"BorrowedLocals","","",N,N],[12,"0","","",284,N],[5,"self_arg","","",N,[[],["local"]]],[5,"make_generator_state_argument_indirect","","",N,[[["tyctxt"],["defid"],["mir"]]]],[5,"replace_result_variable","","",N,[[["ty"],["mir"]],["local"]]],[5,"mark_as_borrowed","","",N,[[["place"],["borrowedlocals"]]]],[5,"locals_live_across_suspend_points","","",N,N],[5,"compute_layout","","",N,N],[5,"insert_switch","","",N,[[["tyctxt"],["mir"],["vec"],["transformvisitor"],["terminatorkind"]]]],[5,"elaborate_generator_drops","","",N,[[["tyctxt"],["defid"],["mir"]]]],[5,"create_generator_drop_shim","","",N,[[["tyctxt"],["transformvisitor"],["defid"],["mirsource"],["ty"],["mir"],["basicblock"]],["mir"]]],[5,"insert_term_block","","",N,[[["mir"],["terminatorkind"]],["basicblock"]]],[5,"insert_panic_block","","",N,[[["tyctxt"],["mir"],["assertmessage"]],["basicblock"]]],[5,"create_generator_resume_function","","",N,[[["tyctxt"],["transformvisitor"],["defid"],["mirsource"],["mir"]]]],[5,"source_info","","",N,[[["mir"]],["sourceinfo"]]],[5,"insert_clean_drop","","",N,[[["mir"]],["basicblock"]]],[5,"create_cases","","",N,[[["mir"],["transformvisitor"],["f"]],["vec"]]],[11,"visit_local","","",280,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_local","","",285,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_place","","",285,[[["self"],["place"],["placecontext"],["location"]]]],[11,"make_state","","",282,[[["self"],["usize"],["operand"]],["rvalue"]]],[11,"make_field","","",282,[[["self"],["usize"],["ty"]],["place"]]],[11,"set_state","","",282,[[["self"],["u32"],["sourceinfo"]],["statement"]]],[11,"visit_local","","",282,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_place","","",282,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_basic_block_data","","",282,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_statement","","",283,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_rvalue","","",284,[[["self"],["rvalue"],["location"]]]],[11,"run_pass","","",286,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[0,"inline","rustc_mir::transform","Inlining pass for MIR functions",N,N],[3,"Inline","rustc_mir::transform::inline","",N,N],[3,"CallSite","","",N,N],[12,"callee","","",287,N],[12,"substs","","",287,N],[12,"bb","","",287,N],[12,"location","","",287,N],[3,"Inliner","","",N,N],[12,"tcx","","",288,N],[12,"source","","",288,N],[3,"Integrator","","Integrator.",N,N],[12,"block_idx","","",289,N],[12,"args","","",289,N],[12,"local_map","","",289,N],[12,"scope_map","","",289,N],[12,"promoted_map","","",289,N],[12,"_callsite","","",289,N],[12,"destination","","",289,N],[12,"return_block","","",289,N],[12,"cleanup_block","","",289,N],[12,"in_cleanup_block","","",289,N],[5,"type_size_of","","",N,[[["tyctxt"],["paramenv"],["ty"]],["option",["u64"]]]],[17,"DEFAULT_THRESHOLD","","",N,N],[17,"HINT_THRESHOLD","","",N,N],[17,"INSTR_COST","","",N,N],[17,"CALL_PENALTY","","",N,N],[17,"UNKNOWN_SIZE_COST","","",N,N],[11,"clone","","",287,[[["self"]],["callsite"]]],[11,"fmt","","",287,[[["self"],["formatter"]],["result"]]],[11,"run_pass","","",290,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"run_pass","","",288,[[["self"],["mir"]]]],[11,"should_inline","","",288,[[["self"],["callsite"],["mir"]],["bool"]]],[11,"inline_call","","",288,[[["self"],["callsite"],["mir"],["mir"]],["bool"]]],[11,"make_call_args","","",288,[[["self"],["vec",["operand"]],["callsite"],["mir"]],["vec",["local"]]]],[11,"create_temp_if_necessary","","If `arg` is already a temporary, returns it. Otherwise, introduces a fresh temporary `T` and an instruction `T = arg`, and returns `T`.",288,[[["self"],["operand"],["callsite"],["mir"]],["local"]]],[11,"update_target","","",289,[[["self"],["basicblock"]],["basicblock"]]],[11,"visit_local","","",289,[[["self"],["local"],["placecontext"],["location"]]]],[11,"visit_place","","",289,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_basic_block_data","","",289,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_terminator_kind","","",289,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_source_scope","","",289,[[["self"],["sourcescope"]]]],[0,"lower_128bit","rustc_mir::transform","Replaces 128-bit operators with lang item calls",N,N],[3,"Lower128Bit","rustc_mir::transform::lower_128bit","",N,N],[4,"RhsKind","","",N,N],[13,"Unchanged","","",291,N],[13,"ForceU128","","",291,N],[13,"ForceU32","","",291,N],[5,"check_lang_item_type","","",N,[[["langitem"],["place"],["operand"],["operand"],["d"],["tyctxt"]],["defid"]]],[5,"lower_to","","",N,[[["statement"],["d"],["tyctxt"]],["option"]]],[5,"sign_of_128bit","","",N,[[["ty"]],["option",["bool"]]]],[5,"item_for_op","","",N,[[["binop"],["bool"]],["option"]]],[5,"item_for_checked_op","","",N,[[["binop"],["bool"]],["option"]]],[11,"run_pass","","",292,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"lower_128bit_ops","","",292,[[["self"],["tyctxt"],["mir"]]]],[11,"clone","","",291,[[["self"]],["rhskind"]]],[11,"ty","","",291,[[["self"],["tyctxt"]],["option",["ty"]]]],[0,"uniform_array_move_out","rustc_mir::transform","",N,N],[3,"UniformArrayMoveOut","rustc_mir::transform::uniform_array_move_out","",N,N],[3,"UniformArrayMoveOutVisitor","","",N,N],[12,"mir","","",293,N],[12,"patch","","",293,N],[12,"tcx","","",293,N],[3,"RestoreSubsliceArrayMoveOut","","",N,N],[3,"LocalUse","","",N,N],[12,"alive","","",294,N],[12,"dead","","",294,N],[12,"use_count","","",294,N],[12,"first_use","","",294,N],[3,"RestoreDataCollector","","",N,N],[12,"locals_use","","",295,N],[12,"candidates","","",295,N],[11,"run_pass","","",296,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"visit_assign","","",293,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"uniform","","",293,[[["self"],["location"],["place"],["placeprojection"],["tys"],["u32"]]]],[11,"run_pass","","",297,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"check_and_patch","","",297,N],[11,"try_get_item_source","","",297,[[["localuse"],["mir"]],["option"]]],[11,"clone","","",294,[[["self"]],["localuse"]]],[11,"fmt","","",294,[[["self"],["formatter"]],["result"]]],[11,"new","","",294,[[],["self"]]],[11,"visit_assign","","",295,[[["self"],["basicblock"],["place"],["rvalue"],["location"]]]],[11,"visit_local","","",295,[[["self"],["local"],["placecontext"],["location"]]]],[8,"MirPass","rustc_mir::transform","A streamlined trait that you can implement to create a pass; the pass will be named after the type, and it will consist of a main loop that goes over each available MIR and applies `run_pass`.",N,N],[11,"name","","",298,[[["self"]],["cow",["str"]]]],[10,"run_pass","","",298,[[["self"],["tyctxt"],["mirsource"],["mir"]]]],[11,"fmt","","",232,[[["self"],["formatter"]],["result"]]],[11,"clone","","",232,[[["self"]],["mirsource"]]],[11,"item","","",232,[[["defid"]],["self"]]],[0,"util","rustc_mir","",N,N],[4,"PassWhere","rustc_mir::util","An indication of where we are in the control flow graph. Used for printing extra information in `dump_mir`",N,N],[13,"BeforeCFG","","We have not started dumping the control flow graph, but we are about to.",299,N],[13,"AfterCFG","","We just finished dumping the control flow graph. This is right before EOF",299,N],[13,"BeforeBlock","","We are about to start dumping the given basic block.",299,N],[13,"BeforeLocation","","We are just about to dump the given statement or terminator.",299,N],[13,"AfterLocation","","We just dumped the given statement or terminator.",299,N],[13,"AfterTerminator","","We just dumped the terminator for a block but not the closing `}`.",299,N],[5,"is_disaligned","","Return `true` if this place is allowed to be less aligned than its containing struct (because it is within a packed struct).",N,[[["tyctxt"],["l"],["paramenv"],["place"]],["bool"]]],[5,"dump_enabled","","",N,[[["tyctxt"],["str"],["mirsource"]],["bool"]]],[5,"dump_mir","","If the session is properly configured, dumps a human-readable representation of the mir into:",N,[[["tyctxt"],["option",["display"]],["str"],["display"],["mirsource"],["mir"],["f"]]]],[5,"write_mir_pretty","","Write out a human-readable textual representation for the given MIR.",N,[[["tyctxt"],["option",["defid"]],["write"]],["result"]]],[5,"write_mir_graphviz","","Write a graphviz DOT graph of a list of MIRs.",N,[[["tyctxt"],["option",["defid"]],["w"]],["result"]]],[5,"write_graphviz_node_label","","Write a graphviz HTML-styled label for the given basic block, with all necessary escaping already performed. (This is suitable for emitting directly, as is done in this module, or for use with the LabelText::HtmlStr from libgraphviz.)",N,[[["basicblock"],["mir"],["w"],["u32"],["init"],["fini"]],["result"]]],[5,"suggest_ref_mut","","If possible, suggest replacing `ref` with `ref mut`.",N,[[["tyctxt"],["span"]],["option",["string"]]]],[0,"borrowck_errors","","",N,N],[4,"Origin","rustc_mir::util::borrowck_errors","",N,N],[13,"Ast","","",300,N],[13,"Mir","","",300,N],[8,"BorrowckErrors","","",N,N],[10,"struct_span_err_with_code","","",301,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[10,"struct_span_err","","",301,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[10,"cancel_if_wrong_origin","","Cancels the given error if we shouldn't emit errors for a given origin in the current mode.",301,[[["self"],["diagnosticbuilder"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_move_when_borrowed","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_use_when_mutably_borrowed","","",301,[[["self"],["span"],["str"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_act_on_uninitialized_variable","","",301,[[["self"],["span"],["str"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_mutably_borrow_multiply","","",301,[[["self"],["span"],["str"],["str"],["span"],["str"],["option",["span"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_uniquely_borrow_by_two_closures","","",301,[[["self"],["span"],["str"],["span"],["option",["span"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_uniquely_borrow_by_one_closure","","",301,[[["self"],["span"],["str"],["str"],["span"],["str"],["str"],["option",["span"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_reborrow_already_uniquely_borrowed","","",301,[[["self"],["span"],["str"],["str"],["str"],["span"],["str"],["option",["span"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_reborrow_already_borrowed","","",301,[[["self"],["span"],["str"],["str"],["str"],["span"],["str"],["str"],["str"],["option",["span"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_assign_to_borrowed","","",301,[[["self"],["span"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_move_into_closure","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_reassign_immutable","","",301,[[["self"],["span"],["str"],["bool"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_assign","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_assign_static","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_move_out_of","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_move_out_of_interior_noncopy","","Signal an error due to an attempt to move out of the interior of an array or slice. `is_index` is None when error origin didn't capture whether there was an indexing operation or not.",301,[[["self"],["span"],["ty"],["option",["bool"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_move_out_of_interior_of_drop","","",301,[[["self"],["span"],["ty"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_act_on_moved_value","","",301,[[["self"],["span"],["str"],["str"],["option",["string"]],["origin"]],["diagnosticbuilder"]]],[11,"cannot_partially_reinit_an_uninit_struct","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"closure_cannot_assign_to_borrowed","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_borrow_path_as_mutable_because","","",301,[[["self"],["span"],["str"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_borrow_path_as_mutable","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_borrow_across_generator_yield","","",301,[[["self"],["span"],["span"],["origin"]],["diagnosticbuilder"]]],[11,"path_does_not_live_long_enough","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"lifetime_too_short_for_reborrow","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_act_on_capture_in_sharable_fn","","",301,N],[11,"cannot_assign_into_immutable_reference","","",301,[[["self"],["span"],["str"],["origin"]],["diagnosticbuilder"]]],[11,"cannot_capture_in_long_lived_closure","","",301,[[["self"],["span"],["str"],["span"],["origin"]],["diagnosticbuilder"]]],[11,"thread_local_value_does_not_live_long_enough","","",301,[[["self"],["span"],["origin"]],["diagnosticbuilder"]]],[11,"clone","","",300,[[["self"]],["origin"]]],[11,"eq","","",300,[[["self"],["origin"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",300,N],[11,"fmt","","",300,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",300,[[["self"],["formatter"]],["result"]]],[11,"should_emit_errors","","Whether we should emit errors for the origin in the given mode",300,[[["self"],["borrowckmode"]],["bool"]]],[0,"elaborate_drops","rustc_mir::util","",N,N],[3,"DropCtxt","rustc_mir::util::elaborate_drops","",N,N],[12,"elaborator","","",302,N],[12,"source_info","","",302,N],[12,"place","","",302,N],[12,"path","","",302,N],[12,"succ","","",302,N],[12,"unwind","","",302,N],[4,"DropFlagState","","",N,N],[13,"Present","","",303,N],[13,"Absent","","",303,N],[4,"DropStyle","","",N,N],[13,"Dead","","",304,N],[13,"Static","","",304,N],[13,"Conditional","","",304,N],[13,"Open","","",304,N],[4,"DropFlagMode","","",N,N],[13,"Shallow","","",305,N],[13,"Deep","","",305,N],[4,"Unwind","","",N,N],[13,"To","","",306,N],[13,"InCleanup","","",306,N],[5,"elaborate_drop","","",N,N],[8,"DropElaborator","","",N,N],[16,"Path","","",307,N],[10,"patch","","",307,[[["self"]],["mirpatch"]]],[10,"mir","","",307,[[["self"]],["mir"]]],[10,"tcx","","",307,[[["self"]],["tyctxt"]]],[10,"param_env","","",307,[[["self"]],["paramenv"]]],[10,"drop_style","","",307,N],[10,"get_drop_flag","","",307,N],[10,"clear_drop_flag","","",307,N],[10,"field_subpath","","",307,N],[10,"deref_subpath","","",307,N],[10,"downcast_subpath","","",307,N],[10,"array_subpath","","",307,N],[11,"fmt","","",303,[[["self"],["formatter"]],["result"]]],[11,"eq","","",303,[[["self"],["dropflagstate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",303,N],[11,"clone","","",303,[[["self"]],["dropflagstate"]]],[11,"value","","",303,[[["self"]],["bool"]]],[11,"fmt","","",304,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",305,[[["self"],["formatter"]],["result"]]],[11,"clone","","",306,[[["self"]],["unwind"]]],[11,"fmt","","",306,[[["self"],["formatter"]],["result"]]],[11,"is_cleanup","","",306,[[["self"]],["bool"]]],[11,"into_option","","",306,[[["self"]],["option",["basicblock"]]]],[11,"map","","",306,[[["self"],["f"]],["self"]]],[11,"fmt","","",302,[[["self"],["formatter"]],["result"]]],[11,"place_ty","","",302,[[["self"],["place"]],["ty"]]],[11,"tcx","","",302,[[["self"]],["tyctxt"]]],[11,"elaborate_drop","","This elaborates a single drop instruction, located at `bb`, and patches over it.",302,[[["self"],["basicblock"]]]],[11,"move_paths_for_fields","","Return the place and move path for each field of `variant`, (the move path is `None` if the field is a rest field).",302,N],[11,"drop_subpath","","",302,[[["self"],["place"],["option"],["basicblock"],["unwind"]],["basicblock"]]],[11,"drop_halfladder","","Create one-half of the drop ladder for a list of fields, and return the list of steps in it in reverse order, with the first step dropping 0 fields and so on.",302,N],[11,"drop_ladder_bottom","","",302,N],[11,"drop_ladder","","Create a full drop ladder, consisting of 2 connected half-drop-ladders",302,N],[11,"open_drop_for_tuple","","",302,N],[11,"open_drop_for_box","","",302,[[["self"],["adtdef"],["substs"]],["basicblock"]]],[11,"open_drop_for_adt","","",302,[[["self"],["adtdef"],["substs"]],["basicblock"]]],[11,"open_drop_for_adt_contents","","",302,N],[11,"open_drop_for_multivariant","","",302,N],[11,"adt_switch_block","","",302,N],[11,"destructor_call_block","","",302,N],[11,"drop_loop","","create a loop that drops an array:",302,[[["self"],["basicblock"],["local"],["place"],["ty"],["unwind"],["bool"]],["basicblock"]]],[11,"open_drop_for_array","","",302,[[["self"],["ty"],["option",["u64"]]],["basicblock"]]],[11,"drop_loop_pair","","",302,[[["self"],["ty"],["bool"]],["basicblock"]]],[11,"open_drop","","The slow-path - create an \"open\", elaborated drop for a type which is moved-out-of only partially, and patch `bb` to a jump to it. This must not be called on ADTs with a destructor, as these can't be moved-out-of, except for `Box<T>`, which is special-cased.",302,[[["self"]],["basicblock"]]],[11,"complete_drop","","Return a basic block that drop a place using the context and path in `c`. If `mode` is something, also clear `c` according to it.",302,[[["self"],["option",["dropflagmode"]],["basicblock"],["unwind"]],["basicblock"]]],[11,"drop_flag_reset_block","","",302,[[["self"],["dropflagmode"],["basicblock"],["unwind"]],["basicblock"]]],[11,"elaborated_drop_block","","",302,[[["self"]],["basicblock"]]],[11,"box_free_block","","",302,[[["self"],["adtdef"],["substs"],["basicblock"],["unwind"]],["basicblock"]]],[11,"unelaborated_free_block","","",302,[[["self"],["adtdef"],["substs"],["basicblock"],["unwind"]],["basicblock"]]],[11,"drop_block","","",302,[[["self"],["basicblock"],["unwind"]],["basicblock"]]],[11,"drop_flag_test_block","","",302,[[["self"],["basicblock"],["basicblock"],["unwind"]],["basicblock"]]],[11,"new_block","","",302,[[["self"],["unwind"],["terminatorkind"]],["basicblock"]]],[11,"new_temp","","",302,[[["self"],["ty"]],["local"]]],[11,"terminator_loc","","",302,[[["self"],["basicblock"]],["location"]]],[11,"constant_usize","","",302,[[["self"],["u16"]],["operand"]]],[11,"assign","","",302,[[["self"],["place"],["rvalue"]],["statement"]]],[0,"def_use","rustc_mir::util","Def-use analysis.",N,N],[3,"DefUseAnalysis","rustc_mir::util::def_use","",N,N],[12,"info","","",308,N],[3,"Info","","",N,N],[12,"defs_and_uses","","",309,N],[3,"Use","","",N,N],[12,"context","","",310,N],[12,"location","","",310,N],[3,"DefUseFinder","","",N,N],[12,"info","","",311,N],[3,"MutateUseVisitor","","",N,N],[12,"query","","",312,N],[12,"callback","","",312,N],[12,"phantom","","",312,N],[11,"clone","","",309,[[["self"]],["info"]]],[11,"clone","","",310,[[["self"]],["use"]]],[11,"new","","",308,[[["mir"]],["defuseanalysis"]]],[11,"analyze","","",308,[[["self"],["mir"]]]],[11,"clear","","",308,[[["self"]]]],[11,"local_info","","",308,[[["self"],["local"]],["info"]]],[11,"mutate_defs_and_uses","","",308,[[["self"],["local"],["mir"],["f"]]]],[11,"replace_all_defs_and_uses_with","","FIXME(pcwalton): This should update the def-use chains.",308,[[["self"],["local"],["mir"],["local"]]]],[11,"visit_local","","",311,[[["self"],["local"],["placecontext"],["location"]]]],[11,"new","","",309,[[],["info"]]],[11,"clear","","",309,[[["self"]]]],[11,"def_count","","",309,[[["self"]],["usize"]]],[11,"def_count_not_including_drop","","",309,[[["self"]],["usize"]]],[11,"defs_not_including_drop","","",309,[[["self"]],["filter",["iter"]]]],[11,"use_count","","",309,[[["self"]],["usize"]]],[11,"new","","",312,[[["local"],["f"],["mir"]],["mutateusevisitor"]]],[11,"visit_local","","",312,[[["self"],["local"],["placecontext"],["location"]]]],[0,"patch","rustc_mir::util","",N,N],[3,"MirPatch","rustc_mir::util::patch","This struct represents a patch to MIR, which can add new statements and basic blocks and patch over block terminators.",N,N],[12,"patch_map","","",313,N],[12,"new_blocks","","",313,N],[12,"new_statements","","",313,N],[12,"new_locals","","",313,N],[12,"resume_block","","",313,N],[12,"next_local","","",313,N],[12,"make_nop","","",313,N],[11,"new","","",313,[[["mir"]],["self"]]],[11,"resume_block","","",313,[[["self"]],["basicblock"]]],[11,"is_patched","","",313,[[["self"],["basicblock"]],["bool"]]],[11,"terminator_loc","","",313,[[["self"],["mir"],["basicblock"]],["location"]]],[11,"new_temp","","",313,[[["self"],["ty"],["span"]],["local"]]],[11,"new_internal","","",313,[[["self"],["ty"],["span"]],["local"]]],[11,"new_block","","",313,[[["self"],["basicblockdata"]],["basicblock"]]],[11,"patch_terminator","","",313,[[["self"],["basicblock"],["terminatorkind"]]]],[11,"add_statement","","",313,[[["self"],["location"],["statementkind"]]]],[11,"add_assign","","",313,[[["self"],["location"],["place"],["rvalue"]]]],[11,"make_nop","","",313,[[["self"],["location"]]]],[11,"apply","","",313,[[["self"],["mir"]]]],[11,"source_info_for_index","","",313,[[["basicblockdata"],["location"]],["sourceinfo"]]],[11,"source_info_for_location","","",313,[[["self"],["mir"],["location"]],["sourceinfo"]]],[0,"alignment","rustc_mir::util","",N,N],[5,"is_disaligned","rustc_mir::util::alignment","Return `true` if this place is allowed to be less aligned than its containing struct (because it is within a packed struct).",N,[[["tyctxt"],["l"],["paramenv"],["place"]],["bool"]]],[5,"is_within_packed","","",N,[[["tyctxt"],["l"],["place"]],["bool"]]],[0,"graphviz","rustc_mir::util","",N,N],[5,"write_mir_graphviz","rustc_mir::util::graphviz","Write a graphviz DOT graph of a list of MIRs.",N,[[["tyctxt"],["option",["defid"]],["w"]],["result"]]],[5,"write_mir_fn_graphviz","","Write a graphviz DOT graph of the MIR.",N,[[["tyctxt"],["defid"],["mir"],["w"]],["result"]]],[5,"write_node_label","","Write a graphviz HTML-styled label for the given basic block, with all necessary escaping already performed. (This is suitable for emitting directly, as is done in this module, or for use with the LabelText::HtmlStr from libgraphviz.)",N,[[["basicblock"],["mir"],["w"],["u32"],["init"],["fini"]],["result"]]],[5,"write_node","","Write a graphviz DOT node for the given basic block.",N,[[["basicblock"],["mir"],["w"]],["result"]]],[5,"write_edges","","Write graphviz DOT edges with labels between the given basic block and all of its successors.",N,[[["basicblock"],["mir"],["w"]],["result"]]],[5,"write_graph_label","","Write the graphviz DOT label for the overall graph. This is essentially a block of text that will appear below the graph, showing the type of the `fn` this MIR represents and the types of all the variables and temporaries.",N,[[["tyctxt"],["defid"],["mir"],["w"]],["result"]]],[5,"node","","",N,[[["basicblock"]],["string"]]],[5,"escape","","",N,[[["t"]],["string"]]],[0,"pretty","rustc_mir::util","",N,N],[3,"ExtraComments","rustc_mir::util::pretty","",N,N],[12,"_tcx","","",314,N],[12,"comments","","",314,N],[4,"PassWhere","","An indication of where we are in the control flow graph. Used for printing extra information in `dump_mir`",N,N],[13,"BeforeCFG","","We have not started dumping the control flow graph, but we are about to.",299,N],[13,"AfterCFG","","We just finished dumping the control flow graph. This is right before EOF",299,N],[13,"BeforeBlock","","We are about to start dumping the given basic block.",299,N],[13,"BeforeLocation","","We are just about to dump the given statement or terminator.",299,N],[13,"AfterLocation","","We just dumped the given statement or terminator.",299,N],[13,"AfterTerminator","","We just dumped the terminator for a block but not the closing `}`.",299,N],[5,"dump_mir","","If the session is properly configured, dumps a human-readable representation of the mir into:",N,[[["tyctxt"],["option",["display"]],["str"],["display"],["mirsource"],["mir"],["f"]]]],[5,"dump_enabled","","",N,[[["tyctxt"],["str"],["mirsource"]],["bool"]]],[5,"dump_matched_mir_node","","",N,[[["tyctxt"],["option",["display"]],["str"],["str"],["display"],["mirsource"],["mir"],["f"]]]],[5,"dump_path","","Returns the path to the filename where we should dump a given MIR. Also used by other bits of code (e.g., NLL inference) that dump graphviz data or other things.",N,[[["tyctxt"],["str"],["option",["display"]],["str"],["display"],["mirsource"]],["pathbuf"]]],[5,"create_dump_file","","Attempts to open a file where we should dump a given MIR or other bit of MIR-related data. Used by `mir-dump`, but also by other bits of code (e.g., NLL inference) that dump graphviz data or other things, and hence takes the extension as an argument.",N,[[["tyctxt"],["str"],["option",["display"]],["str"],["display"],["mirsource"]],["result",["file"]]]],[5,"write_mir_pretty","","Write out a human-readable textual representation for the given MIR.",N,[[["tyctxt"],["option",["defid"]],["write"]],["result"]]],[5,"write_mir_fn","","",N,[[["tyctxt"],["mirsource"],["mir"],["f"],["write"]],["result"]]],[5,"write_basic_block","","Write out a human-readable textual representation for the given basic block.",N,[[["tyctxt"],["basicblock"],["mir"],["f"],["write"]],["result"]]],[5,"write_extra","","After we print the main statement, we sometimes dump extra information. There's often a lot of little things \"nuzzled up\" in a statement.",N,[[["tyctxt"],["write"],["f"]],["result"]]],[5,"comment","","",N,[[["tyctxt"],["sourceinfo"]],["string"]]],[5,"write_scope_tree","","Prints user-defined variables in a scope tree.",N,[[["tyctxt"],["mir"],["fxhashmap"],["write"],["sourcescope"],["usize"]],["result"]]],[5,"write_mir_intro","","Write out a human-readable textual representation of the MIR's `fn` type and the types of its local variables (both user-defined bindings and compiler temporaries).",N,[[["tyctxt"],["mirsource"],["mir"],["write"]],["result"]]],[5,"write_mir_sig","","",N,[[["tyctxt"],["mirsource"],["mir"],["write"]],["result"]]],[5,"write_temp_decls","","",N,[[["mir"],["write"]],["result"]]],[5,"dump_mir_def_ids","","",N,[[["tyctxt"],["option",["defid"]]],["vec",["defid"]]]],[17,"INDENT","","",N,N],[17,"ALIGN","","Alignment for lining up comments following MIR statements",N,N],[11,"push","","",314,[[["self"],["str"]]]],[11,"visit_constant","","",314,[[["self"],["constant"],["location"]]]],[11,"visit_const","","",314,[[["self"],["const"],["location"]]]],[11,"visit_rvalue","","",314,[[["self"],["rvalue"],["location"]]]],[0,"liveness","rustc_mir::util","Liveness analysis which computes liveness of MIR local variables at the boundary of basic blocks",N,N],[3,"LivenessResult","rustc_mir::util::liveness","This gives the result of the liveness analysis at the boundary of basic blocks.",N,N],[12,"outs","","Live variables on exit to each basic block. This is equal to the union of the `ins` for each successor.",315,N],[3,"IdentityMap","","",N,N],[12,"mir","","",316,N],[3,"DefsUsesVisitor","","",N,N],[12,"map","","",317,N],[12,"defs_uses","","",317,N],[3,"DefsUses","","",N,N],[12,"defs","","",318,N],[12,"uses","","",318,N],[4,"DefUse","","",N,N],[13,"Def","","",319,N],[13,"Use","","",319,N],[13,"Drop","","",319,N],[5,"liveness_of_locals","","Compute which local variables are live within the given function `mir`. The liveness mode `mode` determines what sorts of uses are considered to make a variable live (e.g., do drops count?).",N,N],[5,"categorize","","",N,[[["placecontext"]],["option",["defuse"]]]],[5,"block","","",N,N],[5,"dump_mir","","",N,N],[5,"dump_matched_mir_node","","",N,[[["tyctxt"],["str"],["str"],["mirsource"],["mir"],["livevariablemap"],["livenessresult"]]]],[5,"write_mir_fn","","",N,[[["tyctxt"],["mirsource"],["mir"],["livevariablemap"],["write"],["livenessresult"]],["result"]]],[6,"LiveVarSet","","",N,N],[8,"LiveVariableMap","","Defines the mapping to/from the MIR local variables (`Local`) to the \"live variable indices\" we are using in a particular computation.",N,N],[16,"LiveVar","","",320,N],[10,"from_local","","",320,[[["self"],["local"]],["option"]]],[10,"from_live_var","","",320,N],[10,"num_variables","","",320,[[["self"]],["usize"]]],[11,"fmt","","",316,[[["self"],["formatter"]],["result"]]],[11,"new","","",316,[[["mir"]],["self"]]],[11,"from_local","","",316,[[["self"],["local"]],["option"]]],[11,"from_live_var","","",316,N],[11,"num_variables","","",316,[[["self"]],["usize"]]],[11,"assert_receiver_is_total_eq","","",319,N],[11,"eq","","",319,[[["self"],["defuse"]],["bool"]]],[11,"clone","","",319,[[["self"]],["defuse"]]],[11,"assert_receiver_is_total_eq","","",318,N],[11,"eq","","",318,[[["self"],["defsuses"]],["bool"]]],[11,"ne","","",318,[[["self"],["defsuses"]],["bool"]]],[11,"clone","","",318,[[["self"]],["defsuses"]]],[11,"apply","","",318,[[["self"],["livevarset"]],["bool"]]],[11,"add_def","","",318,[[["self"],["v"]]]],[11,"add_use","","",318,[[["self"],["v"]]]],[11,"visit_local","","",317,[[["self"],["local"],["placecontext"],["location"]]]],[0,"collect_writes","rustc_mir::util","",N,N],[3,"FindLocalAssignmentVisitor","rustc_mir::util::collect_writes","",N,N],[12,"needle","","",321,N],[12,"locations","","",321,N],[5,"is_place_assignment","","Returns true if this place context represents an assignment statement",N,[[["placecontext"]],["bool"]]],[8,"FindAssignments","","",N,N],[10,"find_assignments","","",322,[[["self"],["local"]],["vec",["location"]]]],[11,"visit_local","","",321,[[["self"],["local"],["placecontext"],["location"]]]],[0,"interpret","rustc_mir","An interpreter for MIR used in CTFE and by miri",N,N],[3,"EvalContext","rustc_mir::interpret","",N,N],[12,"machine","","Stores the `Machine` instance.",323,N],[12,"tcx","","The results of the type checker, from rustc.",323,N],[12,"param_env","","Bounds in scope for polymorphic evaluations.",323,N],[12,"memory","","The virtual memory system.",323,N],[12,"stack","","The virtual call stack.",323,N],[12,"stack_limit","","The maximum number of stack frames allowed",323,N],[12,"steps_since_detector_enabled","","When this value is negative, it indicates the number of interpreter steps until the loop detector is enabled. When it is positive, it is the number of steps after the detector has been enabled modulo the loop detector period.",323,N],[12,"loop_detector","","Extra state to detect loops. FIXME: Move this to the CTFE machine's state, out of the general miri engine.",323,N],[3,"Frame","","A stack frame.",N,N],[12,"mir","","The MIR for the function called on this frame.",324,N],[12,"instance","","The def_id and substs of the current function",324,N],[12,"span","","The span of the call site.",324,N],[12,"return_to_block","","Work to perform when returning from this function",324,N],[12,"return_place","","The location where the result of the current stack frame should be written to.",324,N],[12,"locals","","The list of locals for this stack frame, stored in order as `[return_ptr, arguments..., variables..., temporaries...]`. The locals are stored as `Option<Value>`s. `None` represents a local that is currently dead, while a live local can either directly contain `Scalar` or refer to some part of an `Allocation`.",324,N],[12,"block","","The block that is currently executed (or will be executed after the above call stacks return).",324,N],[12,"stmt","","The index of the currently evaluated statement.",324,N],[3,"PlaceTy","","",N,N],[12,"place","","",325,N],[12,"layout","","",325,N],[3,"MemPlace","","",N,N],[12,"ptr","","A place may have an integral pointer for ZSTs, and since it might be turned back into a reference before ever being dereferenced. However, it may never be undef.",326,N],[12,"align","","",326,N],[12,"extra","","Metadata for unsized places.  Interpretation is up to the type. Must not be present for sized types, but can be missing for unsized types (e.g. `extern type`).",326,N],[3,"MPlaceTy","","A MemPlace with its layout. Constructing it is only possible in this module.",N,N],[12,"mplace","","",327,N],[12,"layout","","",327,N],[3,"Memory","","",N,N],[12,"data","","Additional data required by the Machine",328,N],[12,"alloc_map","","Allocations local to this instance of the miri engine.  The kind helps ensure that the same mechanism is used for allocation and deallocation.  When an allocation is not found here, it is a static and looked up in the `tcx` for read access.  Writing to a static creates a copy here, in the machine.",328,N],[12,"dead_alloc_map","","To be able to compare pointers with NULL, and to check alignment for accesses to ZSTs (where pointers may dangle), we keep track of the size even for allocations that do not exist any more.",328,N],[12,"tcx","","",328,N],[3,"ValTy","","",N,N],[12,"value","","",329,N],[12,"layout","","",329,N],[3,"OpTy","","",N,N],[12,"op","","",330,N],[12,"layout","","",330,N],[4,"StackPopCleanup","","",N,N],[13,"Goto","","Jump to the next block in the caller, or cause UB if None (that's a function that may never return).",331,N],[13,"None","","Just do nohing: Used by Main and for the box_alloc hook in miri. `cleanup` says whether locals are deallocated.  Static computation wants them leaked to intern what they need (and just throw away the entire `ecx` when it is done).",331,N],[12,"cleanup","rustc_mir::interpret::StackPopCleanup","",331,N],[4,"LocalValue","rustc_mir::interpret","",N,N],[13,"Dead","","",332,N],[13,"Live","","",332,N],[4,"Place","","",N,N],[13,"Ptr","","A place referring to a value allocated in the `Memory` system.",333,N],[13,"Local","","To support alloc-free locals, we are able to write directly to a local. (Without that optimization, we'd just always be a `MemPlace`.)",333,N],[12,"frame","rustc_mir::interpret::Place","",333,N],[12,"local","","",333,N],[4,"MemoryKind","rustc_mir::interpret","",N,N],[13,"Stack","","Error if deallocated except during a stack pop",334,N],[13,"Machine","","Additional memory kinds a machine wishes to distinguish from the builtin ones",334,N],[4,"Value","","A `Value` represents a single immediate self-contained Rust value.",N,N],[13,"Scalar","","",335,N],[13,"ScalarPair","","",335,N],[4,"Operand","","An `Operand` is the result of computing a `mir::Operand`. It can be immediate, or still in memory.  The latter is an optimization, to delay reading that chunk of memory and to avoid having to store arbitrary-sized data here.",N,N],[13,"Immediate","","",336,N],[13,"Indirect","","",336,N],[0,"cast","","",N,N],[11,"type_is_fat_ptr","","",323,[[["self"],["ty"]],["bool"]]],[11,"cast","","",323,[[["self"],["opty"],["castkind"],["placety"]],["evalresult"]]],[11,"cast_scalar","","",323,[[["self"],["scalar"],["tylayout"],["tylayout"]],["evalresult",["scalar"]]]],[11,"cast_from_int","","",323,[[["self"],["u128"],["tylayout"],["tylayout"]],["evalresult",["scalar"]]]],[11,"cast_from_float","","",323,[[["self"],["u128"],["floatty"],["ty"]],["evalresult",["scalar"]]]],[11,"cast_from_ptr","","",323,[[["self"],["pointer"],["ty"]],["evalresult",["scalar"]]]],[11,"unsize_into_ptr","","",323,[[["self"],["opty"],["placety"],["ty"],["ty"]],["evalresult"]]],[11,"unsize_into","","",323,[[["self"],["opty"],["placety"]],["evalresult"]]],[0,"eval_context","","",N,N],[3,"EvalContext","rustc_mir::interpret::eval_context","",N,N],[12,"machine","","Stores the `Machine` instance.",323,N],[12,"tcx","","The results of the type checker, from rustc.",323,N],[12,"param_env","","Bounds in scope for polymorphic evaluations.",323,N],[12,"memory","","The virtual memory system.",323,N],[12,"stack","","The virtual call stack.",323,N],[12,"stack_limit","","The maximum number of stack frames allowed",323,N],[12,"steps_since_detector_enabled","","When this value is negative, it indicates the number of interpreter steps until the loop detector is enabled. When it is positive, it is the number of steps after the detector has been enabled modulo the loop detector period.",323,N],[12,"loop_detector","","Extra state to detect loops. FIXME: Move this to the CTFE machine's state, out of the general miri engine.",323,N],[3,"Frame","","A stack frame.",N,N],[12,"mir","","The MIR for the function called on this frame.",324,N],[12,"instance","","The def_id and substs of the current function",324,N],[12,"span","","The span of the call site.",324,N],[12,"return_to_block","","Work to perform when returning from this function",324,N],[12,"return_place","","The location where the result of the current stack frame should be written to.",324,N],[12,"locals","","The list of locals for this stack frame, stored in order as `[return_ptr, arguments..., variables..., temporaries...]`. The locals are stored as `Option<Value>`s. `None` represents a local that is currently dead, while a live local can either directly contain `Scalar` or refer to some part of an `Allocation`.",324,N],[12,"block","","The block that is currently executed (or will be executed after the above call stacks return).",324,N],[12,"stmt","","The index of the currently evaluated statement.",324,N],[4,"StackPopCleanup","","",N,N],[13,"Goto","","Jump to the next block in the caller, or cause UB if None (that's a function that may never return).",331,N],[13,"None","","Just do nohing: Used by Main and for the box_alloc hook in miri. `cleanup` says whether locals are deallocated.  Static computation wants them leaked to intern what they need (and just throw away the entire `ecx` when it is done).",331,N],[12,"cleanup","rustc_mir::interpret::eval_context::StackPopCleanup","",331,N],[4,"LocalValue","rustc_mir::interpret::eval_context","",N,N],[13,"Dead","","",332,N],[13,"Live","","",332,N],[17,"STEPS_UNTIL_DETECTOR_ENABLED","","",N,N],[11,"clone","rustc_mir::interpret","",324,[[["self"]],["frame"]]],[11,"hash_stable","","",324,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",331,[[["self"]],["stackpopcleanup"]]],[11,"fmt","","",331,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",331,N],[11,"eq","","",331,[[["self"],["stackpopcleanup"]],["bool"]]],[11,"ne","","",331,[[["self"],["stackpopcleanup"]],["bool"]]],[11,"hash","","",331,N],[11,"hash_stable","","",331,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",332,[[["self"]],["localvalue"]]],[11,"eq","","",332,[[["self"],["localvalue"]],["bool"]]],[11,"ne","","",332,[[["self"],["localvalue"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",332,N],[11,"hash","","",332,N],[11,"access","","",332,[[["self"]],["evalresult",["operand"]]]],[11,"access_mut","","",332,[[["self"]],["evalresult",["operand"]]]],[11,"hash_stable","","",332,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"new","","",323,N],[11,"with_fresh_body","","",323,[[["self"],["f"]],["r"]]],[11,"memory","","",323,[[["self"]],["memory"]]],[11,"memory_mut","","",323,[[["self"]],["memory"]]],[11,"stack","","",323,N],[11,"cur_frame","","",323,[[["self"]],["usize"]]],[11,"storage_live","","Mark a storage as live, killing the previous content and returning it. Remember to deallocate that!",323,[[["self"],["local"]],["evalresult",["localvalue"]]]],[11,"storage_dead","","Returns the old value of the local. Remember to deallocate that!",323,[[["self"],["local"]],["localvalue"]]],[11,"str_to_value","","",323,[[["self"],["str"]],["evalresult",["value"]]]],[11,"resolve","","",323,[[["self"],["defid"],["substs"]],["evalresult",["instance"]]]],[11,"type_is_sized","","",323,[[["self"],["ty"]],["bool"]]],[11,"load_mir","","",323,[[["self"],["instancedef"]],["evalresult",["mir"]]]],[11,"monomorphize","","",323,[[["self"],["t"],["substs"]],["t"]]],[11,"layout_of_local","","",323,[[["self"],["usize"],["local"]],["evalresult",["tylayout"]]]],[11,"size_and_align_of","","Return the actual dynamic size and alignment of the place at the given type. Only the \"extra\" (metadata) part of the place matters.",323,[[["self"],["option",["scalar"]],["tylayout"]],["evalresult"]]],[11,"size_and_align_of_mplace","","",323,[[["self"],["mplacety"]],["evalresult"]]],[11,"push_stack_frame","","",323,[[["self"],["instance"],["span"],["mir"],["place"],["stackpopcleanup"]],["evalresult"]]],[11,"pop_stack_frame","","",323,[[["self"]],["evalresult"]]],[11,"deallocate_local","","",323,[[["self"],["localvalue"]],["evalresult"]]],[11,"const_eval","","",323,[[["self"],["globalid"]],["evalresult",["const"]]]],[11,"frame","","",323,[[["self"]],["frame"]]],[11,"frame_mut","","",323,[[["self"]],["frame"]]],[11,"mir","","",323,[[["self"]],["mir"]]],[11,"substs","","",323,[[["self"]],["substs"]]],[11,"dump_place","","",323,[[["self"],["place"]]]],[11,"generate_stacktrace","","",323,N],[11,"sign_extend","","",323,[[["self"],["u128"],["tylayout"]],["u128"]]],[11,"truncate","","",323,[[["self"],["u128"],["tylayout"]],["u128"]]],[0,"place","","Computations on places -- field projections, going from mir::Place, and writing into a place. All high-level functions to write to memory work on places as destinations.",N,N],[3,"MemPlace","rustc_mir::interpret::place","",N,N],[12,"ptr","","A place may have an integral pointer for ZSTs, and since it might be turned back into a reference before ever being dereferenced. However, it may never be undef.",326,N],[12,"align","","",326,N],[12,"extra","","Metadata for unsized places.  Interpretation is up to the type. Must not be present for sized types, but can be missing for unsized types (e.g. `extern type`).",326,N],[3,"PlaceTy","","",N,N],[12,"place","","",325,N],[12,"layout","","",325,N],[3,"MPlaceTy","","A MemPlace with its layout. Constructing it is only possible in this module.",N,N],[12,"mplace","","",327,N],[12,"layout","","",327,N],[4,"Place","","",N,N],[13,"Ptr","","A place referring to a value allocated in the `Memory` system.",333,N],[13,"Local","","To support alloc-free locals, we are able to write directly to a local. (Without that optimization, we'd just always be a `MemPlace`.)",333,N],[12,"frame","rustc_mir::interpret::place::Place","",333,N],[12,"local","","",333,N],[22,"","rustc_mir::interpret::place","",N,N],[11,"clone","rustc_mir::interpret","",326,[[["self"]],["memplace"]]],[11,"fmt","","",326,[[["self"],["formatter"]],["result"]]],[11,"hash","","",326,N],[11,"eq","","",326,[[["self"],["memplace"]],["bool"]]],[11,"ne","","",326,[[["self"],["memplace"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",326,N],[11,"hash_stable","","",326,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",333,[[["self"]],["place"]]],[11,"fmt","","",333,[[["self"],["formatter"]],["result"]]],[11,"hash","","",333,N],[11,"eq","","",333,[[["self"],["place"]],["bool"]]],[11,"ne","","",333,[[["self"],["place"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",333,N],[11,"hash_stable","","",333,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",325,[[["self"]],["placety"]]],[11,"fmt","","",325,[[["self"],["formatter"]],["result"]]],[11,"deref","","",325,[[["self"]],["place"]]],[11,"clone","","",327,[[["self"]],["mplacety"]]],[11,"fmt","","",327,[[["self"],["formatter"]],["result"]]],[11,"deref","","",327,[[["self"]],["memplace"]]],[11,"from","","",325,[[["mplacety"]],["self"]]],[11,"from_scalar_ptr","","",326,[[["scalar"],["align"]],["self"]]],[11,"from_ptr","","",326,[[["pointer"],["align"]],["self"]]],[11,"to_scalar_ptr_align","","",326,N],[11,"to_ptr","","Extract the ptr part of the mplace",326,[[["self"]],["evalresult",["pointer"]]]],[11,"to_ref","","Turn a mplace into a (thin or fat) pointer, as a reference, pointing to the same space. This is the inverse of `ref_to_mplace`.",326,[[["self"]],["value"]]],[11,"from_aligned_ptr","","",327,[[["pointer"],["tylayout"]],["self"]]],[11,"len","","",327,N],[11,"vtable","","",327,[[["self"]],["evalresult",["pointer"]]]],[11,"try_as_mplace","","",330,[[["self"]],["result",["mplacety","value"]]]],[11,"to_mem_place","","",330,[[["self"]],["mplacety"]]],[11,"null","","Produces a Place that will error if attempted to be read from or written to",333,N],[11,"from_scalar_ptr","","",333,[[["scalar"],["align"]],["self"]]],[11,"from_ptr","","",333,[[["pointer"],["align"]],["self"]]],[11,"to_mem_place","","",333,[[["self"]],["memplace"]]],[11,"to_scalar_ptr_align","","",333,N],[11,"to_ptr","","",333,[[["self"]],["evalresult",["pointer"]]]],[11,"null","","Produces a Place that will error if attempted to be read from or written to",325,N],[11,"to_mem_place","","",325,[[["self"]],["mplacety"]]],[11,"ref_to_mplace","","Take a value, which represents a (thin or fat) reference, and make it a place. Alignment is just based on the type.  This is the inverse of `MemPlace::to_ref`.",323,[[["self"],["valty"]],["evalresult",["mplacety"]]]],[11,"mplace_field","","Offset a pointer to project to a field. Unlike place_field, this is always possible without allocating, so it can take &self. Also return the field's layout. This supports both struct and array fields.",323,[[["self"],["mplacety"],["u64"]],["evalresult",["mplacety"]]]],[11,"mplace_array_fields","","",323,[[["self"],["mplacety"]],["evalresult"]]],[11,"mplace_subslice","","",323,[[["self"],["mplacety"],["u64"],["u64"]],["evalresult",["mplacety"]]]],[11,"mplace_downcast","","",323,[[["self"],["mplacety"],["usize"]],["evalresult",["mplacety"]]]],[11,"mplace_projection","","Project into an mplace",323,[[["self"],["mplacety"],["placeelem"]],["evalresult",["mplacety"]]]],[11,"place_field","","Get the place of a field inside the place, and also the field's type. Just a convenience function, but used quite a bit.",323,[[["self"],["placety"],["u64"]],["evalresult",["placety"]]]],[11,"place_downcast","","",323,[[["self"],["placety"],["usize"]],["evalresult",["placety"]]]],[11,"place_projection","","Project into a place",323,[[["self"],["placety"],["projectionelem"]],["evalresult",["placety"]]]],[11,"eval_place_to_mplace","","Evaluate statics and promoteds to an `MPlace`.  Used to share some code between `eval_place` and `eval_place_to_op`.",323,[[["self"],["place"]],["evalresult",["mplacety"]]]],[11,"eval_place","","Compute a place.  You should only use this if you intend to write into this place; for reading, a more efficient alternative is `eval_place_for_read`.",323,[[["self"],["place"]],["evalresult",["placety"]]]],[11,"write_scalar","","Write a scalar to a place",323,N],[11,"write_value","","Write a value to a place",323,[[["self"],["value"],["placety"]],["evalresult"]]],[11,"write_value_to_mplace","","Write a value to memory",323,[[["self"],["value"],["mplacety"]],["evalresult"]]],[11,"copy_op","","Copy the data from an operand to a place",323,[[["self"],["opty"],["placety"]],["evalresult"]]],[11,"force_allocation","","Make sure that a place is in memory, and return where it is. This is essentially `force_to_memplace`.",323,[[["self"],["placety"]],["evalresult",["mplacety"]]]],[11,"allocate","","",323,[[["self"],["tylayout"],["memorykind"]],["evalresult",["mplacety"]]]],[11,"write_discriminant_index","","",323,[[["self"],["usize"],["placety"]],["evalresult"]]],[11,"place_to_op","","Every place can be read from, so we can turm them into an operand",323,[[["self"],["placety"]],["evalresult",["opty"]]]],[11,"unpack_dyn_trait","","Turn a place with a `dyn Trait` type into a place with the actual dynamic type. Also return some more information so drop doesn't have to run the same code twice.",323,[[["self"],["mplacety"]],["evalresult"]]],[0,"operand","","Functions concerning immediate values and operands, and reading from operands. All high-level functions to read from memory work on operands as sources.",N,N],[3,"ValTy","rustc_mir::interpret::operand","",N,N],[12,"value","","",329,N],[12,"layout","","",329,N],[3,"OpTy","","",N,N],[12,"op","","",330,N],[12,"layout","","",330,N],[4,"Value","","A `Value` represents a single immediate self-contained Rust value.",N,N],[13,"Scalar","","",335,N],[13,"ScalarPair","","",335,N],[4,"Operand","","An `Operand` is the result of computing a `mir::Operand`. It can be immediate, or still in memory.  The latter is an optimization, to delay reading that chunk of memory and to avoid having to store arbitrary-sized data here.",N,N],[13,"Immediate","","",336,N],[13,"Indirect","","",336,N],[5,"from_known_layout","","",N,N],[11,"clone","rustc_mir::interpret","",335,[[["self"]],["value"]]],[11,"fmt","","",335,[[["self"],["formatter"]],["result"]]],[11,"hash","","",335,N],[11,"eq","","",335,[[["self"],["value"]],["bool"]]],[11,"ne","","",335,[[["self"],["value"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",335,N],[11,"new_slice","","",335,N],[11,"new_dyn_trait","","",335,[[["scalar"],["pointer"]],["self"]]],[11,"to_scalar_or_undef","","",335,[[["self"]],["scalarmaybeundef"]]],[11,"to_scalar","","",335,[[["self"]],["evalresult",["scalar"]]]],[11,"to_scalar_pair","","",335,[[["self"]],["evalresult"]]],[11,"to_scalar_ptr","","Convert the value into a pointer (or a pointer-sized integer). Throws away the second half of a ScalarPair!",335,[[["self"]],["evalresult",["scalar"]]]],[11,"hash_stable","","",335,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",329,[[["self"]],["valty"]]],[11,"fmt","","",329,[[["self"],["formatter"]],["result"]]],[11,"deref","","",329,[[["self"]],["value"]]],[11,"clone","","",336,[[["self"]],["operand"]]],[11,"fmt","","",336,[[["self"],["formatter"]],["result"]]],[11,"hash","","",336,N],[11,"eq","","",336,[[["self"],["operand"]],["bool"]]],[11,"ne","","",336,[[["self"],["operand"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",336,N],[11,"to_mem_place","","",336,[[["self"]],["memplace"]]],[11,"to_immediate","","",336,[[["self"]],["value"]]],[11,"hash_stable","","",336,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",330,[[["self"]],["opty"]]],[11,"fmt","","",330,[[["self"],["formatter"]],["result"]]],[11,"deref","","",330,[[["self"]],["operand"]]],[11,"from","","",330,[[["mplacety"]],["self"]]],[11,"from","","",330,[[["valty"]],["self"]]],[11,"hash","","",330,[[["self"],["h"]]]],[11,"eq","","",330,[[["self"],["self"]],["bool"]]],[11,"try_read_value_from_mplace","","Try reading a value in memory; this is interesting particularily for ScalarPair. Return None if the layout does not permit loading this as a value.",323,[[["self"],["mplacety"]],["evalresult",["option"]]]],[11,"try_read_value","","Try returning an immediate value for the operand. If the layout does not permit loading this as a value, return where in memory we can find the data. Note that for a given layout, this operation will either always fail or always succeed!  Whether it succeeds depends on whether the layout can be represented in a `Value`, not on which data is stored there currently.",323,[[["self"],["opty"]],["evalresult",["result"]]]],[11,"read_value","","Read a value from a place, asserting that that is possible with the given layout.",323,[[["self"],["opty"]],["evalresult",["valty"]]]],[11,"read_scalar","","Read a scalar from a place",323,[[["self"],["opty"]],["evalresult",["scalarmaybeundef"]]]],[11,"read_str","","",323,[[["self"],["mplacety"]],["evalresult",["str"]]]],[11,"uninit_operand","","",323,[[["self"],["tylayout"]],["evalresult",["operand"]]]],[11,"operand_field","","Projection functions",323,[[["self"],["opty"],["u64"]],["evalresult",["opty"]]]],[11,"operand_downcast","","",323,[[["self"],["opty"],["usize"]],["evalresult",["opty"]]]],[11,"deref_operand","","",323,[[["self"],["opty"]],["evalresult",["mplacety"]]]],[11,"operand_projection","","",323,[[["self"],["opty"],["placeelem"]],["evalresult",["opty"]]]],[11,"eval_place_to_op","","",323,[[["self"],["place"],["option",["tylayout"]]],["evalresult",["opty"]]]],[11,"eval_operand","","Evaluate the operand, returning a place where you can then find the data. if you already know the layout, you can save two some table lookups by passing it in here.",323,[[["self"],["operand"],["option",["tylayout"]]],["evalresult",["opty"]]]],[11,"eval_operands","","Evaluate a bunch of operands at once",323,N],[11,"const_value_to_op","","",323,[[["self"],["constvalue"]],["evalresult",["operand"]]]],[11,"const_to_op","","",323,[[["self"],["const"]],["evalresult",["opty"]]]],[11,"global_to_op","","",323,[[["self"],["globalid"]],["evalresult",["operand"]]]],[11,"read_discriminant","","Read discriminant, return the runtime value as well as the variant index.",323,[[["self"],["opty"]],["evalresult"]]],[0,"machine","","This module contains everything needed to instantiate an interpreter. This separation exists to ensure that no fancy miri features like interpreting common C functions leak into CTFE.",N,N],[8,"Machine","rustc_mir::interpret::machine","Methods of this trait signifies a point where CTFE evaluation would fail and some use case dependent behaviour can instead be applied",N,N],[16,"MemoryData","","Additional data that can be accessed via the Memory",337,N],[16,"MemoryKinds","","Additional memory kinds a machine wishes to distinguish from the builtin ones",337,N],[18,"MUT_STATIC_KIND","","The memory kind to use for mutated statics -- or None if those are not supported.",337,N],[18,"DETECT_LOOPS","","Whether to attempt to detect infinite loops (any kind of infinite execution, really).",337,N],[10,"find_fn","","Entry point to all function calls.",337,N],[10,"call_intrinsic","","Directly process an intrinsic without pushing a stack frame. If this returns successfully, the engine will take care of jumping to the next block.",337,N],[10,"find_foreign_static","","Called for read access to a foreign static item. This can be called multiple times for the same static item and should return consistent results.  Once the item is written the first time, as usual for statics a copy is made and this function is not called again.",337,[[["tyctxtat"],["defid"]],["evalresult",["allocation"]]]],[10,"ptr_op","","Called for all binary operations on integer(-like) types when one operand is a pointer value, and for the `Offset` operation that is inherently about pointers.",337,[[["evalcontext"],["binop"],["scalar"],["tylayout"],["scalar"],["tylayout"]],["evalresult"]]],[10,"box_alloc","","Heap allocations via the `box` keyword",337,[[["evalcontext"],["placety"]],["evalresult"]]],[11,"validation_op","","Execute a validation operation",337,[[["evalcontext"],["validationop"],["validationoperand"]],["evalresult"]]],[0,"memory","rustc_mir::interpret","The memory subsystem.",N,N],[5,"write_target_uint","rustc_mir::interpret::memory","",N,N],[5,"read_target_uint","","",N,N],[3,"Memory","","",N,N],[12,"data","","Additional data required by the Machine",328,N],[12,"alloc_map","","Allocations local to this instance of the miri engine.  The kind helps ensure that the same mechanism is used for allocation and deallocation.  When an allocation is not found here, it is a static and looked up in the `tcx` for read access.  Writing to a static creates a copy here, in the machine.",328,N],[12,"dead_alloc_map","","To be able to compare pointers with NULL, and to check alignment for accesses to ZSTs (where pointers may dangle), we keep track of the size even for allocations that do not exist any more.",328,N],[12,"tcx","","",328,N],[4,"MemoryKind","","",N,N],[13,"Stack","","Error if deallocated except during a stack pop",334,N],[13,"Machine","","Additional memory kinds a machine wishes to distinguish from the builtin ones",334,N],[11,"fmt","rustc_mir::interpret","",334,[[["self"],["formatter"]],["result"]]],[11,"eq","","",334,[[["self"],["memorykind"]],["bool"]]],[11,"ne","","",334,[[["self"],["memorykind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",334,N],[11,"clone","","",334,[[["self"]],["memorykind"]]],[11,"hash","","",334,N],[11,"clone","","",328,[[["self"]],["memory"]]],[11,"new","","",328,N],[11,"create_fn_alloc","","",328,[[["self"],["instance"]],["pointer"]]],[11,"allocate_static_bytes","","",328,N],[11,"allocate_with","","",328,[[["self"],["allocation"],["memorykind"]],["evalresult",["allocid"]]]],[11,"allocate","","",328,[[["self"],["size"],["align"],["memorykind"]],["evalresult",["pointer"]]]],[11,"reallocate","","",328,[[["self"],["pointer"],["size"],["align"],["size"],["align"],["memorykind"]],["evalresult",["pointer"]]]],[11,"deallocate_local","","Deallocate a local, or do nothing if that local has been made into a static",328,[[["self"],["pointer"]],["evalresult"]]],[11,"deallocate","","",328,[[["self"],["pointer"],["option"],["memorykind"]],["evalresult"]]],[11,"check_align","","Check that the pointer is aligned AND non-NULL. This supports ZSTs in two ways: You can pass a scalar, and a `Pointer` does not have to actually still be allocated.",328,[[["self"],["scalar"],["align"]],["evalresult"]]],[11,"check_bounds","","Check if the pointer is \"in-bounds\". Notice that a pointer pointing at the end of an allocation (i.e., at the first inaccessible location) is considered in-bounds!  This follows C's/LLVM's rules.  The `access` boolean is just used for the error message. If you want to check bounds before doing a memory access, be sure to check the pointer one past the end of your access, then everything will work out exactly.",328,[[["self"],["pointer"],["bool"]],["evalresult"]]],[11,"get_static_alloc","","Helper function to obtain the global (tcx) allocation for a static",328,[[["tyctxtat"],["allocid"]],["evalresult",["allocation"]]]],[11,"get","","",328,[[["self"],["allocid"]],["evalresult",["allocation"]]]],[11,"get_size_and_align","","",328,[[["self"],["allocid"]],["evalresult"]]],[11,"get_mut","","",328,[[["self"],["allocid"]],["evalresult",["allocation"]]]],[11,"get_fn","","",328,[[["self"],["pointer"]],["evalresult",["instance"]]]],[11,"dump_alloc","","For debugging, print an allocation and all allocations it points to, recursively.",328,[[["self"],["allocid"]]]],[11,"dump_allocs","","For debugging, print a list of allocations and all allocations they point to, recursively.",328,[[["self"],["vec",["allocid"]]]]],[11,"leak_report","","",328,[[["self"]],["usize"]]],[11,"get_bytes_internal","","The last argument controls whether we error out when there are undefined or pointer bytes.  You should never call this, call `get_bytes` or `get_bytes_with_undef_and_ptr` instead,",328,[[["self"],["pointer"],["size"],["align"],["bool"]],["evalresult"]]],[11,"get_bytes","","",328,[[["self"],["pointer"],["size"],["align"]],["evalresult"]]],[11,"get_bytes_with_undef_and_ptr","","It is the caller's responsibility to handle undefined and pointer bytes. However, this still checks that there are no relocations on the egdes.",328,[[["self"],["pointer"],["size"],["align"]],["evalresult"]]],[11,"get_bytes_mut","","Just calling this already marks everything as defined and removes relocations, so be sure to actually put data there!",328,[[["self"],["pointer"],["size"],["align"]],["evalresult"]]],[11,"intern_static","","mark an allocation as static and initialized, either mutable or not",328,[[["self"],["allocid"],["mutability"]],["evalresult"]]],[11,"deep_copy_static","","The alloc_id must refer to a (mutable) static; a deep copy of that static is made into this memory.",328,[[["self"],["allocid"],["memorykind"]],["evalresult"]]],[11,"copy","","",328,[[["self"],["scalar"],["align"],["scalar"],["align"],["size"],["bool"]],["evalresult"]]],[11,"copy_repeatedly","","",328,[[["self"],["scalar"],["align"],["scalar"],["align"],["size"],["u64"],["bool"]],["evalresult"]]],[11,"read_c_str","","",328,[[["self"],["pointer"]],["evalresult"]]],[11,"read_bytes","","",328,[[["self"],["scalar"],["size"]],["evalresult"]]],[11,"write_bytes","","",328,N],[11,"write_repeat","","",328,[[["self"],["scalar"],["u8"],["size"]],["evalresult"]]],[11,"read_scalar","","Read a non-ZST scalar",328,[[["self"],["pointer"],["align"],["size"]],["evalresult",["scalarmaybeundef"]]]],[11,"read_ptr_sized","","",328,[[["self"],["pointer"],["align"]],["evalresult",["scalarmaybeundef"]]]],[11,"write_scalar","","Write a non-ZST scalar",328,[[["self"],["pointer"],["align"],["scalarmaybeundef"],["size"]],["evalresult"]]],[11,"write_ptr_sized","","",328,[[["self"],["pointer"],["align"],["scalarmaybeundef"]],["evalresult"]]],[11,"int_align","","",328,[[["self"],["size"]],["align"]]],[11,"relocations","","Return all relocations overlapping with the given ptr-offset pair.",328,[[["self"],["pointer"],["size"]],["evalresult"]]],[11,"check_relocations","","Check that there ar eno relocations overlapping with the given range.",328,[[["self"],["pointer"],["size"]],["evalresult"]]],[11,"clear_relocations","","Remove all relocations inside the given range. If there are relocations overlapping with the edges, they are removed as well and the bytes they cover are marked as uninitialized.  This is a somewhat odd \"spooky action at a distance\", but it allows strictly more code to run than if we would just error immediately in that case.",328,[[["self"],["pointer"],["size"]],["evalresult"]]],[11,"check_relocation_edges","","Error if there are relocations overlapping with the egdes of the given memory range.",328,[[["self"],["pointer"],["size"]],["evalresult"]]],[11,"copy_undef_mask","","",328,[[["self"],["pointer"],["pointer"],["size"],["u64"]],["evalresult"]]],[11,"check_defined","","Checks that a range of bytes is defined. If not, returns the `ReadUndefBytes` error which will report the first byte which is undefined.",328,[[["self"],["pointer"],["size"]],["evalresult"]]],[11,"mark_definedness","","",328,[[["self"],["pointer"],["size"],["bool"]],["evalresult"]]],[0,"operator","","",N,N],[11,"binop_with_overflow","","Applies the binary operation `op` to the two operands and writes a tuple of the result and a boolean signifying the potential overflow to the destination.",323,[[["self"],["binop"],["valty"],["valty"],["placety"]],["evalresult"]]],[11,"binop_ignore_overflow","","Applies the binary operation `op` to the arguments and writes the result to the destination.",323,[[["self"],["binop"],["valty"],["valty"],["placety"]],["evalresult"]]],[11,"binary_char_op","","",323,[[["self"],["binop"],["char"],["char"]],["evalresult"]]],[11,"binary_bool_op","","",323,[[["self"],["binop"],["bool"],["bool"]],["evalresult"]]],[11,"binary_float_op","","",323,[[["self"],["binop"],["floatty"],["u128"],["u128"]],["evalresult"]]],[11,"binary_int_op","","",323,[[["self"],["binop"],["u128"],["tylayout"],["u128"],["tylayout"]],["evalresult"]]],[11,"binary_op_val","","Convenience wrapper that's useful when keeping the layout together with the value.",323,[[["self"],["binop"],["valty"],["valty"]],["evalresult"]]],[11,"binary_op","","Returns the result of the specified operation and whether it overflowed.",323,[[["self"],["binop"],["scalar"],["tylayout"],["scalar"],["tylayout"]],["evalresult"]]],[11,"unary_op","","",323,[[["self"],["unop"],["scalar"],["tylayout"]],["evalresult",["scalar"]]]],[0,"snapshot","","This module contains the machinery necessary to detect infinite loops during const-evaluation by taking snapshots of the state of the interpreter at regular intervals.",N,N],[3,"InfiniteLoopDetector","rustc_mir::interpret::snapshot","",N,N],[12,"hashes","","The set of all `EvalSnapshot` hashes observed by this detector.",338,N],[12,"snapshots","","The set of all `EvalSnapshot`s observed by this detector.",338,N],[3,"AllocIdSnapshot","","",N,N],[12,"0","","",339,N],[3,"AllocationSnapshot","","",N,N],[12,"bytes","","",340,N],[12,"relocations","","",340,N],[12,"undef_mask","","",340,N],[12,"align","","",340,N],[12,"mutability","","",340,N],[3,"FrameSnapshot","","",N,N],[12,"instance","","",341,N],[12,"span","","",341,N],[12,"return_to_block","","",341,N],[12,"return_place","","",341,N],[12,"locals","","",341,N],[12,"block","","",341,N],[12,"stmt","","",341,N],[3,"MemorySnapshot","","",N,N],[12,"data","","",342,N],[3,"EvalSnapshot","","The virtual machine state during const-evaluation at a given point in time.",N,N],[12,"memory","","",343,N],[12,"stack","","",343,N],[8,"SnapshotContext","","",N,N],[10,"resolve","","",344,[[["self"],["allocid"]],["option",["allocation"]]]],[8,"Snapshot","","Taking a snapshot of the evaluation context produces a view of the state of the interpreter that is invariant to `AllocId`s.",N,N],[16,"Item","","",345,N],[10,"snapshot","","",345,N],[11,"default","","",338,[[],["self"]]],[11,"is_empty","","Returns `true` if the loop detector has not yet observed a snapshot.",338,[[["self"]],["bool"]]],[11,"observe_and_analyze","","",338,N],[11,"assert_receiver_is_total_eq","","",339,N],[11,"eq","","",339,[[["self"],["allocidsnapshot"]],["bool"]]],[11,"ne","","",339,[[["self"],["allocidsnapshot"]],["bool"]]],[11,"snapshot","rustc_mir::interpret","",326,N],[11,"snapshot","","",333,N],[11,"snapshot","","",335,N],[11,"snapshot","","",336,N],[11,"snapshot","","",332,N],[11,"assert_receiver_is_total_eq","rustc_mir::interpret::snapshot","",340,N],[11,"eq","","",340,[[["self"],["allocationsnapshot"]],["bool"]]],[11,"ne","","",340,[[["self"],["allocationsnapshot"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",341,N],[11,"eq","","",341,[[["self"],["framesnapshot"]],["bool"]]],[11,"ne","","",341,[[["self"],["framesnapshot"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",342,N],[11,"eq","","",342,[[["self"],["memorysnapshot"]],["bool"]]],[11,"ne","","",342,[[["self"],["memorysnapshot"]],["bool"]]],[11,"snapshot","rustc_mir::interpret","",328,[[["self"]],["memorysnapshot"]]],[11,"resolve","","",328,[[["self"],["allocid"]],["option",["allocation"]]]],[11,"new","rustc_mir::interpret::snapshot","",343,N],[11,"snapshot","","",343,N],[11,"hash","","",343,[[["self"],["h"]]]],[11,"hash_stable","","",343,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"eq","","",343,[[["self"],["self"]],["bool"]]],[0,"step","rustc_mir::interpret","This module contains the `EvalContext` methods for executing a single step of the interpreter.",N,N],[5,"binop_left_homogeneous","rustc_mir::interpret::step","Classify whether an operator is \"left-homogeneous\", i.e. the LHS has the same type as the result.",N,[[["binop"]],["bool"]]],[5,"binop_right_homogeneous","","Classify whether an operator is \"right-homogeneous\", i.e. the RHS has the same type as the LHS.",N,[[["binop"]],["bool"]]],[11,"inc_step_counter_and_detect_loops","rustc_mir::interpret","",323,[[["self"]],["evalresult"]]],[11,"run","","",323,[[["self"]],["evalresult"]]],[11,"step","","Returns true as long as there are more things to do.",323,[[["self"]],["evalresult",["bool"]]]],[11,"statement","","",323,[[["self"],["statement"]],["evalresult"]]],[11,"eval_rvalue_into_place","","Evaluate an assignment statement.",323,[[["self"],["rvalue"],["place"]],["evalresult"]]],[11,"terminator","","",323,[[["self"],["terminator"]],["evalresult"]]],[0,"terminator","","",N,N],[11,"goto_block","","",323,[[["self"],["option",["basicblock"]]],["evalresult"]]],[11,"eval_terminator","","",323,[[["self"],["terminator"]],["evalresult"]]],[11,"check_argument_compat","","",323,[[["tylayout"],["tylayout"]],["bool"]]],[11,"pass_argument","","Pass a single argument, checking the types for compatibility.",323,N],[11,"eval_fn_call","","Call this function -- pushing the stack frame and initializing the arguments.",323,N],[11,"drop_in_place","","",323,[[["self"],["placety"],["instance"],["span"],["basicblock"]],["evalresult"]]],[0,"traits","","",N,N],[11,"get_vtable","","Creates a dynamic vtable for the given type and vtable origin. This is used only for objects.",323,[[["self"],["ty"],["polytraitref"]],["evalresult",["pointer"]]]],[11,"read_drop_type_from_vtable","","Return the drop fn instance as well as the actual dynamic type",323,[[["self"],["pointer"]],["evalresult"]]],[11,"read_size_and_align_from_vtable","","",323,[[["self"],["pointer"]],["evalresult"]]],[0,"validity","","",N,N],[4,"PathElem","rustc_mir::interpret::validity","We want to show a nice path to the invalid field for diagnotsics, but avoid string operations in the happy case where no error happens. So we track a `Vec<PathElem>` where `PathElem` contains all the data we need to later print something for the user.",N,N],[13,"Field","","",346,N],[13,"ClosureVar","","",346,N],[13,"ArrayElem","","",346,N],[13,"TupleElem","","",346,N],[13,"Deref","","",346,N],[13,"Tag","","",346,N],[5,"path_clone_and_deref","","",N,[[["vec"]],["vec",["pathelem"]]]],[5,"path_format","","Format a path",N,[[["vec"]],["string"]]],[11,"clone","","",346,[[["self"]],["pathelem"]]],[11,"fmt","","",346,[[["self"],["formatter"]],["result"]]],[11,"validate_scalar","rustc_mir::interpret","",323,[[["self"],["scalarmaybeundef"],["size"],["scalar"],["vec"],["ty"]],["evalresult"]]],[11,"validate_operand","","This function checks the data at `op`. It will error if the bits at the destination do not match the ones described by the layout. The `path` may be pushed to, but the part that is present when the function starts must not be changed!",323,[[["self"],["opty"],["vec"],["fxhashset"],["vec"]],["evalresult"]]],[11,"aggregate_field_path_elem","","",323,[[["self"],["ty"],["usize"],["usize"]],["pathelem"]]],[0,"intrinsics","","Intrinsics and other functions that the miri engine executes without looking at their MIR.  Intrinsics/functions supported here are shared by CTFE and miri.",N,N],[5,"numeric_intrinsic","rustc_mir::interpret::intrinsics","",N,[[["str"],["u128"],["primitive"]],["evalresult",["scalar"]]]],[11,"emulate_intrinsic","rustc_mir::interpret","Returns whether emulation happened.",323,N],[11,"hook_fn","","\"Intercept\" a function call because we have something special to do for it. Returns whether an intercept happened.",323,N],[8,"Machine","","Methods of this trait signifies a point where CTFE evaluation would fail and some use case dependent behaviour can instead be applied",N,N],[16,"MemoryData","","Additional data that can be accessed via the Memory",337,N],[16,"MemoryKinds","","Additional memory kinds a machine wishes to distinguish from the builtin ones",337,N],[18,"MUT_STATIC_KIND","rustc_mir::interpret::machine","The memory kind to use for mutated statics -- or None if those are not supported.",337,N],[18,"DETECT_LOOPS","","Whether to attempt to detect infinite loops (any kind of infinite execution, really).",337,N],[10,"find_fn","rustc_mir::interpret","Entry point to all function calls.",337,N],[10,"call_intrinsic","","Directly process an intrinsic without pushing a stack frame. If this returns successfully, the engine will take care of jumping to the next block.",337,N],[10,"find_foreign_static","","Called for read access to a foreign static item. This can be called multiple times for the same static item and should return consistent results.  Once the item is written the first time, as usual for statics a copy is made and this function is not called again.",337,[[["tyctxtat"],["defid"]],["evalresult",["allocation"]]]],[10,"ptr_op","","Called for all binary operations on integer(-like) types when one operand is a pointer value, and for the `Offset` operation that is inherently about pointers.",337,[[["evalcontext"],["binop"],["scalar"],["tylayout"],["scalar"],["tylayout"]],["evalresult"]]],[10,"box_alloc","","Heap allocations via the `box` keyword",337,[[["evalcontext"],["placety"]],["evalresult"]]],[11,"validation_op","rustc_mir::interpret::machine","Execute a validation operation",337,[[["evalcontext"],["validationop"],["validationoperand"]],["evalresult"]]],[0,"monomorphize","rustc_mir","",N,N],[3,"Instance","rustc_mir::monomorphize","",N,N],[12,"def","","",347,N],[12,"substs","","",347,N],[4,"MonoItem","","",N,N],[13,"Fn","","",348,N],[13,"Static","","",348,N],[13,"GlobalAsm","","",348,N],[5,"assert_symbols_are_distinct","","",N,[[["tyctxt"],["i"]]]],[5,"fn_once_adapter_instance","","",N,[[["tyctxt"],["defid"],["closuresubsts"]],["instance"]]],[5,"needs_fn_once_adapter_shim","","",N,[[["closurekind"],["closurekind"]],["result",["bool"]]]],[5,"resolve_closure","","",N,[[["tyctxt"],["defid"],["closuresubsts"],["closurekind"]],["instance"]]],[5,"resolve_drop_in_place","","",N,[[["tyctxt"],["ty"]],["instance"]]],[5,"custom_coerce_unsize_info","","",N,[[["tyctxt"],["ty"],["ty"]],["customcoerceunsized"]]],[0,"collector","","Mono Item Collection ===========================",N,N],[3,"InliningMap","rustc_mir::monomorphize::collector","Maps every mono item to all mono items it references in its body.",N,N],[12,"index","","",349,N],[12,"targets","","",349,N],[12,"inlines","","",349,N],[3,"MirNeighborCollector","","",N,N],[12,"tcx","","",350,N],[12,"mir","","",350,N],[12,"output","","",350,N],[12,"param_substs","","",350,N],[3,"RootCollector","","",N,N],[12,"tcx","","",351,N],[12,"mode","","",351,N],[12,"output","","",351,N],[12,"entry_fn","","",351,N],[4,"MonoItemCollectionMode","","",N,N],[13,"Eager","","",352,N],[13,"Lazy","","",352,N],[5,"collect_crate_mono_items","","",N,N],[5,"collect_roots","","",N,[[["tyctxt"],["monoitemcollectionmode"]],["vec",["monoitem"]]]],[5,"collect_items_rec","","",N,[[["tyctxt"],["monoitem"],["mtref",["mtlock"]],["defidmap"],["mtref",["mtlock"]]]]],[5,"record_accesses","","",N,N],[5,"check_recursion_limit","","",N,N],[5,"check_type_length_limit","","",N,[[["tyctxt"],["instance"]]]],[5,"visit_drop_use","","",N,[[["tyctxt"],["ty"],["bool"],["vec"]]]],[5,"visit_fn_use","","",N,[[["tyctxt"],["ty"],["bool"],["vec"]]]],[5,"visit_instance_use","","",N,[[["tyctxt"],["instance"],["bool"],["vec"]]]],[5,"should_monomorphize_locally","","",N,[[["tyctxt"],["instance"]],["bool"]]],[5,"find_vtable_types_for_unsizing","","For given pair of source and target type that occur in an unsizing coercion, this function finds the pair of types that determines the vtable linking them.",N,N],[5,"create_fn_mono_item","","",N,[[["instance"]],["monoitem"]]],[5,"create_mono_items_for_vtable_methods","","Creates a `MonoItem` for each method that is referenced by the vtable for the given trait/impl pair.",N,[[["tyctxt"],["ty"],["ty"],["vec"]]]],[5,"item_has_type_parameters","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"create_mono_items_for_default_impls","","",N,[[["tyctxt"],["item"],["vec"]]]],[5,"collect_miri","","Scan the miri alloc in order to find function calls, closures, and drop-glue",N,[[["tyctxt"],["allocid"],["vec"]]]],[5,"collect_neighbours","","Scan the MIR in order to find function calls, closures, and drop-glue",N,[[["tyctxt"],["instance"],["vec"]]]],[5,"def_id_to_string","","",N,[[["tyctxt"],["defid"]],["string"]]],[5,"collect_const","","",N,[[["tyctxt"],["const"],["substs"],["vec"]]]],[11,"eq","","",352,[[["self"],["monoitemcollectionmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",352,N],[11,"hash","","",352,N],[11,"clone","","",352,[[["self"]],["monoitemcollectionmode"]]],[11,"fmt","","",352,[[["self"],["formatter"]],["result"]]],[11,"new","","",349,[[],["inliningmap"]]],[11,"record_accesses","","",349,[[["self"],["monoitem"],["i"]]]],[11,"with_inlining_candidates","","",349,[[["self"],["monoitem"],["f"]]]],[11,"iter_accesses","","",349,[[["self"],["f"]]]],[11,"visit_rvalue","","",350,[[["self"],["rvalue"],["location"]]]],[11,"visit_const","","",350,[[["self"],["const"],["location"]]]],[11,"visit_terminator_kind","","",350,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_static","","",350,[[["self"],["static"],["placecontext"],["location"]]]],[11,"visit_item","","",351,[[["self"],["item"]]]],[11,"visit_trait_item","","",351,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",351,[[["self"],["implitem"]]]],[11,"is_root","","",351,[[["self"],["defid"]],["bool"]]],[11,"push_if_root","","If `def_id` represents a root, then push it onto the list of outputs. (Note that all roots must be monomorphic.)",351,[[["self"],["defid"]]]],[11,"push_extra_entry_roots","","As a special case, when/if we encounter the `main()` function, we also have to generate a monomorphized copy of the start lang item based on the return type of `main`. This is not needed when the user writes their own `start` manually.",351,[[["self"]]]],[0,"item","rustc_mir::monomorphize","Walks the crate looking for items/impl-items/trait-items that have either a `rustc_symbol_name` or `rustc_item_path` attribute and generates an error giving, respectively, the symbol name or item-path. This is used for unit testing the code that generates paths etc in all kinds of annoying scenarios.",N,N],[4,"MonoItem","rustc_mir::monomorphize::item","",N,N],[13,"Fn","","",348,N],[13,"Static","","",348,N],[13,"GlobalAsm","","",348,N],[3,"DefPathBasedNames","","Same as `unique_type_name()` but with the result pushed onto the given `output` parameter.",N,N],[12,"tcx","","",353,N],[12,"omit_disambiguators","","",353,N],[12,"omit_local_crate_name","","",353,N],[4,"InstantiationMode","","Describes how a monomorphization will be instantiated in object files.",N,N],[13,"GloballyShared","","There will be exactly one instance of the given MonoItem. It will have external linkage so that it can be linked to from other codegen units.",354,N],[12,"may_conflict","rustc_mir::monomorphize::item::InstantiationMode","In some compilation scenarios we may decide to take functions that are typically `LocalCopy` and instead move them to `GloballyShared` to avoid codegenning them a bunch of times. In this situation, however, our local copy may conflict with other crates also inlining the same function.",354,N],[13,"LocalCopy","rustc_mir::monomorphize::item","Each codegen unit containing a reference to the given MonoItem will have its own private copy of the function (with internal linkage).",354,N],[8,"MonoItemExt","","",N,N],[10,"as_mono_item","","",355,[[["self"]],["monoitem"]]],[11,"is_generic_fn","","",355,[[["self"]],["bool"]]],[11,"symbol_name","","",355,[[["self"],["tyctxt"]],["symbolname"]]],[11,"instantiation_mode","","",355,[[["self"],["tyctxt"]],["instantiationmode"]]],[11,"explicit_linkage","","",355,[[["self"],["tyctxt"]],["option",["linkage"]]]],[11,"is_instantiable","","Returns whether this instance is instantiable - whether it has no unsatisfied predicates.",355,[[["self"],["tyctxt"]],["bool"]]],[11,"to_string","","",355,[[["self"],["tyctxt"]],["string"]]],[11,"local_span","","",355,[[["self"],["tyctxt"]],["option",["span"]]]],[11,"eq","","",354,[[["self"],["instantiationmode"]],["bool"]]],[11,"ne","","",354,[[["self"],["instantiationmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",354,N],[11,"clone","","",354,[[["self"]],["instantiationmode"]]],[11,"fmt","","",354,[[["self"],["formatter"]],["result"]]],[11,"hash","","",354,N],[11,"as_mono_item","","",348,[[["self"]],["monoitem"]]],[11,"new","","",353,[[["tyctxt"],["bool"],["bool"]],["self"]]],[11,"push_type_name","","",353,[[["self"],["ty"],["string"]]]],[11,"push_def_path","","",353,[[["self"],["defid"],["string"]]]],[11,"push_type_params","","",353,[[["self"],["substs"],["i"],["string"]]]],[11,"push_instance_as_string","","",353,[[["self"],["instance"],["string"]]]],[0,"partitioning","rustc_mir::monomorphize","Partitioning Codegen Units for Incremental Compilation ======================================================",N,N],[3,"CodegenUnit","rustc_mir::monomorphize::partitioning","",N,N],[12,"name","","A name for this CGU. Incremental compilation requires that name be unique amongst all crates.  Therefore, it should contain something unique to this crate (e.g., a module path) as well as the crate name and disambiguator.",356,N],[12,"items","","",356,N],[12,"size_estimate","","",356,N],[3,"PreInliningPartitioning","","",N,N],[12,"codegen_units","","",357,N],[12,"roots","","",357,N],[12,"internalization_candidates","","",357,N],[3,"PostInliningPartitioning","","",N,N],[12,"codegen_units","","",358,N],[12,"mono_item_placements","","",358,N],[12,"internalization_candidates","","",358,N],[4,"PartitioningStrategy","","",N,N],[13,"PerModule","","Generate one codegen unit per source-level module.",359,N],[13,"FixedUnitCount","","Partition the whole crate into a fixed number of codegen units.",359,N],[4,"MonoItemPlacement","","For symbol internalization, we need to know whether a symbol/mono-item is accessed from outside the codegen unit it is defined in. This type is used to keep track of that.",N,N],[13,"SingleCgu","","",360,N],[12,"cgu_name","rustc_mir::monomorphize::partitioning::MonoItemPlacement","",360,N],[13,"MultipleCgus","rustc_mir::monomorphize::partitioning","",360,N],[5,"fallback_cgu_name","","",N,[[["codegenunitnamebuilder"]],["internedstring"]]],[5,"partition","","",N,[[["tyctxt"],["i"],["partitioningstrategy"],["inliningmap"]],["vec",["codegenunit"]]]],[5,"place_root_mono_items","","",N,[[["tyctxt"],["i"]],["preinliningpartitioning"]]],[5,"mono_item_linkage_and_visibility","","",N,N],[5,"mono_item_visibility","","",N,[[["tyctxt"],["monoitem"],["bool"],["bool"]],["visibility"]]],[5,"default_visibility","","",N,[[["tyctxt"],["defid"],["bool"]],["visibility"]]],[5,"merge_codegen_units","","",N,[[["tyctxt"],["preinliningpartitioning"],["usize"]]]],[5,"place_inlined_mono_items","","",N,[[["preinliningpartitioning"],["inliningmap"]],["postinliningpartitioning"]]],[5,"internalize_symbols","","",N,[[["tyctxt"],["postinliningpartitioning"],["inliningmap"]]]],[5,"characteristic_def_id_of_mono_item","","",N,[[["tyctxt"],["monoitem"]],["option",["defid"]]]],[5,"compute_codegen_unit_name","","",N,[[["tyctxt"],["codegenunitnamebuilder"],["defid"],["bool"],["fxhashmap"]],["internedstring"]]],[5,"numbered_codegen_unit_name","","",N,[[["codegenunitnamebuilder"],["usize"]],["internedstring"]]],[5,"debug_dump","","",N,[[["tyctxt"],["str"],["i"]]]],[6,"CguNameCache","","",N,N],[8,"CodegenUnitExt","","",N,N],[10,"as_codegen_unit","","",361,[[["self"]],["codegenunit"]]],[11,"contains_item","","",361,[[["self"],["monoitem"]],["bool"]]],[11,"name","","",361,[[["self"]],["internedstring"]]],[11,"items","","",361,[[["self"]],["fxhashmap"]]],[11,"work_product_id","","",361,[[["self"]],["workproductid"]]],[11,"work_product","","",361,[[["self"],["tyctxt"]],["workproduct"]]],[11,"items_in_deterministic_order","","",361,[[["self"],["tyctxt"]],["vec"]]],[11,"codegen_dep_node","","",361,[[["self"],["tyctxt"]],["depnode"]]],[11,"as_codegen_unit","","",356,[[["self"]],["codegenunit"]]],[11,"clone","","",360,[[["self"]],["monoitemplacement"]]],[11,"eq","","",360,[[["self"],["monoitemplacement"]],["bool"]]],[11,"ne","","",360,[[["self"],["monoitemplacement"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",360,N],[11,"fmt","","",360,[[["self"],["formatter"]],["result"]]],[0,"const_eval","rustc_mir","",N,N],[3,"CompileTimeEvaluator","rustc_mir::const_eval","",N,N],[4,"ConstEvalError","","",N,N],[13,"NeedsRfc","","",362,N],[13,"NotConst","","",362,N],[5,"mk_borrowck_eval_cx","","",N,[[["tyctxt"],["instance"],["mir"],["span"]],["evalresult",["evalcontext"]]]],[5,"mk_eval_cx","","",N,[[["tyctxt"],["instance"],["paramenv"]],["evalresult",["evalcontext"]]]],[5,"eval_promoted","","",N,[[["evalcontext"],["globalid"],["mir"],["paramenv"]],["evalresult",["opty"]]]],[5,"op_to_const","","",N,[[["evalcontext"],["opty"],["bool"]],["evalresult",["const"]]]],[5,"eval_body_and_ecx","","",N,N],[5,"eval_body_using_ecx","","",N,[[["evalcontext"],["globalid"],["option",["mir"]],["paramenv"]],["evalresult",["opty"]]]],[5,"const_field","","Project to a field of a (variant of a) const",N,[[["tyctxt"],["paramenv"],["instance"],["option",["usize"]],["field"],["const"]],["constevalresult"]]],[5,"const_variant_index","","",N,[[["tyctxt"],["paramenv"],["instance"],["const"]],["evalresult",["usize"]]]],[5,"const_to_allocation_provider","","",N,[[["tyctxt"],["const"]],["allocation"]]],[5,"const_eval_provider","","",N,[[["tyctxt"],["paramenvand",["globalid"]]],["constevalresult"]]],[11,"fmt","","",363,[[["self"],["formatter"]],["result"]]],[11,"clone","","",363,[[["self"]],["compiletimeevaluator"]]],[11,"assert_receiver_is_total_eq","","",363,N],[11,"eq","","",363,[[["self"],["compiletimeevaluator"]],["bool"]]],[11,"hash","","",363,N],[11,"into","","",362,[[["self"]],["evalerror"]]],[11,"hash_stable","","",363,[[["self"],["stablehashingcontext"],["stablehasher"]]]],[11,"clone","","",362,[[["self"]],["constevalerror"]]],[11,"fmt","","",362,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",362,[[["self"],["formatter"]],["result"]]],[11,"description","","",362,[[["self"]],["str"]]],[11,"cause","","",362,[[["self"]],["option",["error"]]]],[11,"find_fn","","",363,N],[11,"call_intrinsic","","",363,N],[11,"ptr_op","","",363,[[["evalcontext"],["binop"],["scalar"],["tylayout"],["scalar"],["tylayout"]],["evalresult"]]],[11,"find_foreign_static","","",363,[[["tyctxtat"],["defid"]],["evalresult",["allocation"]]]],[11,"box_alloc","","",363,[[["evalcontext"],["placety"]],["evalresult"]]],[17,"DIAGNOSTICS","rustc_mir","",N,N],[14,"run_passes","","",N,N],[11,"from","rustc_mir::borrow_check","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"to_owned","","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]],[11,"to_owned","","",12,[[["self"]],["t"]]],[11,"clone_into","","",12,N],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from_ok","","",13,[[["t"]],["t"]]],[11,"map_same","","",13,[[["self"],["f"]],["t"]]],[11,"to_owned","","",14,[[["self"]],["t"]]],[11,"clone_into","","",14,N],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from_ok","","",14,[[["t"]],["t"]]],[11,"map_same","","",14,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::borrow_set","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from_ok","","",15,[[["t"]],["t"]]],[11,"map_same","","",15,[[["self"],["f"]],["t"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"to_string","","",16,[[["self"]],["string"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from_ok","","",16,[[["t"]],["t"]]],[11,"map_same","","",16,[[["self"],["f"]],["t"]]],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from_ok","","",17,[[["t"]],["t"]]],[11,"map_same","","",17,[[["self"],["f"]],["t"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from_ok","","",18,[[["t"]],["t"]]],[11,"map_same","","",18,[[["self"],["f"]],["t"]]],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"from_ok","","",19,[[["t"]],["t"]]],[11,"map_same","","",19,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::error_reporting","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from_ok","","",20,[[["t"]],["t"]]],[11,"map_same","","",20,[[["self"],["f"]],["t"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from_ok","","",21,[[["t"]],["t"]]],[11,"map_same","","",21,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::flows","",22,[[["t"]],["t"]]],[11,"to_string","","",22,[[["self"]],["string"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from_ok","","",22,[[["t"]],["t"]]],[11,"map_same","","",22,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::location","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from_ok","","",23,[[["t"]],["t"]]],[11,"map_same","","",23,[[["self"],["f"]],["t"]]],[11,"to_owned","","",24,[[["self"]],["t"]]],[11,"clone_into","","",24,N],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"encode","","",24,[[["self"],["e"]],["result"]]],[11,"decode","","",24,[[["d"]],["result"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"from_ok","","",24,[[["t"]],["t"]]],[11,"map_same","","",24,[[["self"],["f"]],["t"]]],[11,"to_owned","","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from_ok","","",25,[[["t"]],["t"]]],[11,"map_same","","",25,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::move_errors","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"from_ok","","",26,[[["t"]],["t"]]],[11,"map_same","","",26,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::borrow_check::mutability_errors","",27,[[["self"]],["t"]]],[11,"clone_into","","",27,N],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from_ok","","",27,[[["t"]],["t"]]],[11,"map_same","","",27,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::borrow_check::path_utils","",28,[[["self"]],["t"]]],[11,"clone_into","","",28,N],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from_ok","","",28,[[["t"]],["t"]]],[11,"map_same","","",28,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::places_conflict","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"from_ok","","",30,[[["t"]],["t"]]],[11,"map_same","","",30,[[["self"],["f"]],["t"]]],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"from_ok","","",31,[[["t"]],["t"]]],[11,"map_same","","",31,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::prefixes","",32,[[["t"]],["t"]]],[11,"into_iter","","",32,[[["self"]],["i"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from_ok","","",32,[[["t"]],["t"]]],[11,"map_same","","",32,[[["self"],["f"]],["t"]]],[11,"to_owned","","",33,[[["self"]],["t"]]],[11,"clone_into","","",33,N],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from_ok","","",33,[[["t"]],["t"]]],[11,"map_same","","",33,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::used_muts","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"from_ok","","",35,[[["t"]],["t"]]],[11,"map_same","","",35,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::constraint_generation","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"from_ok","","",36,[[["t"]],["t"]]],[11,"map_same","","",36,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::borrow_check::nll::explain_borrow","",37,[[["self"]],["t"]]],[11,"clone_into","","",37,N],[11,"from","","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"from_ok","","",37,[[["t"]],["t"]]],[11,"map_same","","",37,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::explain_borrow::find_use","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"from_ok","","",38,[[["t"]],["t"]]],[11,"map_same","","",38,[[["self"],["f"]],["t"]]],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"from_ok","","",39,[[["t"]],["t"]]],[11,"map_same","","",39,[[["self"],["f"]],["t"]]],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from_ok","","",40,[[["t"]],["t"]]],[11,"map_same","","",40,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::facts","",41,[[["t"]],["t"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"not_found","","",41,[[["str"],["str"]],["e"]]],[11,"from_ok","","",41,[[["t"]],["t"]]],[11,"map_same","","",41,[[["self"],["f"]],["t"]]],[11,"index","rustc_mir::dataflow::move_paths::indexes","",180,[[["self"]],["usize"]]],[11,"from","","",180,[[["usize"]],["borrowindex"]]],[11,"from","rustc_mir::borrow_check::nll::invalidation","",45,[[["t"]],["t"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"not_found","","",45,[[["str"],["str"]],["e"]]],[11,"from_ok","","",45,[[["t"]],["t"]]],[11,"map_same","","",45,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::region_infer","",46,[[["t"]],["t"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"not_found","","",46,[[["str"],["str"]],["e"]]],[11,"from_ok","","",46,[[["t"]],["t"]]],[11,"map_same","","",46,[[["self"],["f"]],["t"]]],[11,"from","","",47,[[["t"]],["t"]]],[11,"into","","",47,[[["self"]],["u"]]],[11,"try_from","","",47,[[["u"]],["result"]]],[11,"borrow","","",47,[[["self"]],["t"]]],[11,"try_into","","",47,[[["self"]],["result"]]],[11,"borrow_mut","","",47,[[["self"]],["t"]]],[11,"get_type_id","","",47,[[["self"]],["typeid"]]],[11,"not_found","","",47,[[["str"],["str"]],["e"]]],[11,"from_ok","","",47,[[["t"]],["t"]]],[11,"map_same","","",47,[[["self"],["f"]],["t"]]],[11,"to_owned","","",48,[[["self"]],["t"]]],[11,"clone_into","","",48,N],[11,"from","","",48,[[["t"]],["t"]]],[11,"into","","",48,[[["self"]],["u"]]],[11,"try_from","","",48,[[["u"]],["result"]]],[11,"borrow","","",48,[[["self"]],["t"]]],[11,"try_into","","",48,[[["self"]],["result"]]],[11,"borrow_mut","","",48,[[["self"]],["t"]]],[11,"get_type_id","","",48,[[["self"]],["typeid"]]],[11,"not_found","","",48,[[["str"],["str"]],["e"]]],[11,"from_ok","","",48,[[["t"]],["t"]]],[11,"map_same","","",48,[[["self"],["f"]],["t"]]],[11,"to_owned","","",49,[[["self"]],["t"]]],[11,"clone_into","","",49,N],[11,"from","","",49,[[["t"]],["t"]]],[11,"into","","",49,[[["self"]],["u"]]],[11,"try_from","","",49,[[["u"]],["result"]]],[11,"borrow","","",49,[[["self"]],["t"]]],[11,"try_into","","",49,[[["self"]],["result"]]],[11,"borrow_mut","","",49,[[["self"]],["t"]]],[11,"get_type_id","","",49,[[["self"]],["typeid"]]],[11,"not_found","","",49,[[["str"],["str"]],["e"]]],[11,"from_ok","","",49,[[["t"]],["t"]]],[11,"map_same","","",49,[[["self"],["f"]],["t"]]],[11,"to_owned","","",50,[[["self"]],["t"]]],[11,"clone_into","","",50,N],[11,"from","","",50,[[["t"]],["t"]]],[11,"into","","",50,[[["self"]],["u"]]],[11,"try_from","","",50,[[["u"]],["result"]]],[11,"borrow","","",50,[[["self"]],["t"]]],[11,"try_into","","",50,[[["self"]],["result"]]],[11,"borrow_mut","","",50,[[["self"]],["t"]]],[11,"get_type_id","","",50,[[["self"]],["typeid"]]],[11,"not_found","","",50,[[["str"],["str"]],["e"]]],[11,"from_ok","","",50,[[["t"]],["t"]]],[11,"map_same","","",50,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::borrow_check::nll::region_infer::error_reporting","",51,[[["self"]],["t"]]],[11,"clone_into","","",51,N],[11,"from","","",51,[[["t"]],["t"]]],[11,"to_string","","",51,[[["self"]],["string"]]],[11,"into","","",51,[[["self"]],["u"]]],[11,"try_from","","",51,[[["u"]],["result"]]],[11,"borrow","","",51,[[["self"]],["t"]]],[11,"try_into","","",51,[[["self"]],["result"]]],[11,"borrow_mut","","",51,[[["self"]],["t"]]],[11,"get_type_id","","",51,[[["self"]],["typeid"]]],[11,"not_found","","",51,[[["str"],["str"]],["e"]]],[11,"from_ok","","",51,[[["t"]],["t"]]],[11,"map_same","","",51,[[["self"],["f"]],["t"]]],[11,"to_owned","","",52,[[["self"]],["t"]]],[11,"clone_into","","",52,N],[11,"from","","",52,[[["t"]],["t"]]],[11,"into","","",52,[[["self"]],["u"]]],[11,"try_from","","",52,[[["u"]],["result"]]],[11,"borrow","","",52,[[["self"]],["t"]]],[11,"try_into","","",52,[[["self"]],["result"]]],[11,"borrow_mut","","",52,[[["self"]],["t"]]],[11,"get_type_id","","",52,[[["self"]],["typeid"]]],[11,"not_found","","",52,[[["str"],["str"]],["e"]]],[11,"from_ok","","",52,[[["t"]],["t"]]],[11,"map_same","","",52,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::region_infer::graphviz","",53,[[["t"]],["t"]]],[11,"into","","",53,[[["self"]],["u"]]],[11,"try_from","","",53,[[["u"]],["result"]]],[11,"borrow","","",53,[[["self"]],["t"]]],[11,"try_into","","",53,[[["self"]],["result"]]],[11,"borrow_mut","","",53,[[["self"]],["t"]]],[11,"get_type_id","","",53,[[["self"]],["typeid"]]],[11,"not_found","","",53,[[["str"],["str"]],["e"]]],[11,"from_ok","","",53,[[["t"]],["t"]]],[11,"map_same","","",53,[[["self"],["f"]],["t"]]],[11,"from","","",54,[[["t"]],["t"]]],[11,"into","","",54,[[["self"]],["u"]]],[11,"try_from","","",54,[[["u"]],["result"]]],[11,"borrow","","",54,[[["self"]],["t"]]],[11,"try_into","","",54,[[["self"]],["result"]]],[11,"borrow_mut","","",54,[[["self"]],["t"]]],[11,"get_type_id","","",54,[[["self"]],["typeid"]]],[11,"not_found","","",54,[[["str"],["str"]],["e"]]],[11,"from_ok","","",54,[[["t"]],["t"]]],[11,"map_same","","",54,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::region_infer::values","",55,[[["t"]],["t"]]],[11,"into","","",55,[[["self"]],["u"]]],[11,"try_from","","",55,[[["u"]],["result"]]],[11,"borrow","","",55,[[["self"]],["t"]]],[11,"try_into","","",55,[[["self"]],["result"]]],[11,"borrow_mut","","",55,[[["self"]],["t"]]],[11,"get_type_id","","",55,[[["self"]],["typeid"]]],[11,"not_found","","",55,[[["str"],["str"]],["e"]]],[11,"from_ok","","",55,[[["t"]],["t"]]],[11,"map_same","","",55,[[["self"],["f"]],["t"]]],[11,"to_owned","","",56,[[["self"]],["t"]]],[11,"clone_into","","",56,N],[11,"from","","",56,[[["t"]],["t"]]],[11,"into","","",56,[[["self"]],["u"]]],[11,"try_from","","",56,[[["u"]],["result"]]],[11,"borrow","","",56,[[["self"]],["t"]]],[11,"try_into","","",56,[[["self"]],["result"]]],[11,"borrow_mut","","",56,[[["self"]],["t"]]],[11,"get_type_id","","",56,[[["self"]],["typeid"]]],[11,"encode","","",56,[[["self"],["e"]],["result"]]],[11,"decode","","",56,[[["d"]],["result"]]],[11,"not_found","","",56,[[["str"],["str"]],["e"]]],[11,"from_ok","","",56,[[["t"]],["t"]]],[11,"map_same","","",56,[[["self"],["f"]],["t"]]],[11,"to_owned","","",57,[[["self"]],["t"]]],[11,"clone_into","","",57,N],[11,"from","","",57,[[["t"]],["t"]]],[11,"into","","",57,[[["self"]],["u"]]],[11,"try_from","","",57,[[["u"]],["result"]]],[11,"borrow","","",57,[[["self"]],["t"]]],[11,"try_into","","",57,[[["self"]],["result"]]],[11,"borrow_mut","","",57,[[["self"]],["t"]]],[11,"get_type_id","","",57,[[["self"]],["typeid"]]],[11,"encode","","",57,[[["self"],["e"]],["result"]]],[11,"decode","","",57,[[["d"]],["result"]]],[11,"not_found","","",57,[[["str"],["str"]],["e"]]],[11,"from_ok","","",57,[[["t"]],["t"]]],[11,"map_same","","",57,[[["self"],["f"]],["t"]]],[11,"from","","",58,[[["t"]],["t"]]],[11,"into","","",58,[[["self"]],["u"]]],[11,"try_from","","",58,[[["u"]],["result"]]],[11,"borrow","","",58,[[["self"]],["t"]]],[11,"try_into","","",58,[[["self"]],["result"]]],[11,"borrow_mut","","",58,[[["self"]],["t"]]],[11,"get_type_id","","",58,[[["self"]],["typeid"]]],[11,"not_found","","",58,[[["str"],["str"]],["e"]]],[11,"from_ok","","",58,[[["t"]],["t"]]],[11,"map_same","","",58,[[["self"],["f"]],["t"]]],[11,"to_owned","","",59,[[["self"]],["t"]]],[11,"clone_into","","",59,N],[11,"from","","",59,[[["t"]],["t"]]],[11,"into","","",59,[[["self"]],["u"]]],[11,"try_from","","",59,[[["u"]],["result"]]],[11,"borrow","","",59,[[["self"]],["t"]]],[11,"try_into","","",59,[[["self"]],["result"]]],[11,"borrow_mut","","",59,[[["self"]],["t"]]],[11,"get_type_id","","",59,[[["self"]],["typeid"]]],[11,"not_found","","",59,[[["str"],["str"]],["e"]]],[11,"from_ok","","",59,[[["t"]],["t"]]],[11,"map_same","","",59,[[["self"],["f"]],["t"]]],[11,"to_owned","","",60,[[["self"]],["t"]]],[11,"clone_into","","",60,N],[11,"from","","",60,[[["t"]],["t"]]],[11,"into","","",60,[[["self"]],["u"]]],[11,"try_from","","",60,[[["u"]],["result"]]],[11,"borrow","","",60,[[["self"]],["t"]]],[11,"try_into","","",60,[[["self"]],["result"]]],[11,"borrow_mut","","",60,[[["self"]],["t"]]],[11,"get_type_id","","",60,[[["self"]],["typeid"]]],[11,"not_found","","",60,[[["str"],["str"]],["e"]]],[11,"from_ok","","",60,[[["t"]],["t"]]],[11,"map_same","","",60,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::renumber","",63,[[["t"]],["t"]]],[11,"into","","",63,[[["self"]],["u"]]],[11,"try_from","","",63,[[["u"]],["result"]]],[11,"borrow","","",63,[[["self"]],["t"]]],[11,"try_into","","",63,[[["self"]],["result"]]],[11,"borrow_mut","","",63,[[["self"]],["t"]]],[11,"get_type_id","","",63,[[["self"]],["typeid"]]],[11,"not_found","","",63,[[["str"],["str"]],["e"]]],[11,"from_ok","","",63,[[["t"]],["t"]]],[11,"map_same","","",63,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::type_check","",64,[[["t"]],["t"]]],[11,"into","","",64,[[["self"]],["u"]]],[11,"try_from","","",64,[[["u"]],["result"]]],[11,"borrow","","",64,[[["self"]],["t"]]],[11,"try_into","","",64,[[["self"]],["result"]]],[11,"borrow_mut","","",64,[[["self"]],["t"]]],[11,"get_type_id","","",64,[[["self"]],["typeid"]]],[11,"not_found","","",64,[[["str"],["str"]],["e"]]],[11,"from_ok","","",64,[[["t"]],["t"]]],[11,"map_same","","",64,[[["self"],["f"]],["t"]]],[11,"from","","",65,[[["t"]],["t"]]],[11,"into","","",65,[[["self"]],["u"]]],[11,"try_from","","",65,[[["u"]],["result"]]],[11,"borrow","","",65,[[["self"]],["t"]]],[11,"try_into","","",65,[[["self"]],["result"]]],[11,"borrow_mut","","",65,[[["self"]],["t"]]],[11,"get_type_id","","",65,[[["self"]],["typeid"]]],[11,"not_found","","",65,[[["str"],["str"]],["e"]]],[11,"from_ok","","",65,[[["t"]],["t"]]],[11,"map_same","","",65,[[["self"],["f"]],["t"]]],[11,"from","","",66,[[["t"]],["t"]]],[11,"into","","",66,[[["self"]],["u"]]],[11,"try_from","","",66,[[["u"]],["result"]]],[11,"borrow","","",66,[[["self"]],["t"]]],[11,"try_into","","",66,[[["self"]],["result"]]],[11,"borrow_mut","","",66,[[["self"]],["t"]]],[11,"get_type_id","","",66,[[["self"]],["typeid"]]],[11,"not_found","","",66,[[["str"],["str"]],["e"]]],[11,"from_ok","","",66,[[["t"]],["t"]]],[11,"map_same","","",66,[[["self"],["f"]],["t"]]],[11,"from","","",67,[[["t"]],["t"]]],[11,"into","","",67,[[["self"]],["u"]]],[11,"try_from","","",67,[[["u"]],["result"]]],[11,"borrow","","",67,[[["self"]],["t"]]],[11,"try_into","","",67,[[["self"]],["result"]]],[11,"borrow_mut","","",67,[[["self"]],["t"]]],[11,"get_type_id","","",67,[[["self"]],["typeid"]]],[11,"not_found","","",67,[[["str"],["str"]],["e"]]],[11,"from_ok","","",67,[[["t"]],["t"]]],[11,"map_same","","",67,[[["self"],["f"]],["t"]]],[11,"from","","",68,[[["t"]],["t"]]],[11,"into","","",68,[[["self"]],["u"]]],[11,"try_from","","",68,[[["u"]],["result"]]],[11,"borrow","","",68,[[["self"]],["t"]]],[11,"try_into","","",68,[[["self"]],["result"]]],[11,"borrow_mut","","",68,[[["self"]],["t"]]],[11,"get_type_id","","",68,[[["self"]],["typeid"]]],[11,"not_found","","",68,[[["str"],["str"]],["e"]]],[11,"from_ok","","",68,[[["t"]],["t"]]],[11,"map_same","","",68,[[["self"],["f"]],["t"]]],[11,"from","","",93,[[["t"]],["t"]]],[11,"into","","",93,[[["self"]],["u"]]],[11,"try_from","","",93,[[["u"]],["result"]]],[11,"borrow","","",93,[[["self"]],["t"]]],[11,"try_into","","",93,[[["self"]],["result"]]],[11,"borrow_mut","","",93,[[["self"]],["t"]]],[11,"get_type_id","","",93,[[["self"]],["typeid"]]],[11,"not_found","","",93,[[["str"],["str"]],["e"]]],[11,"from_ok","","",93,[[["t"]],["t"]]],[11,"map_same","","",93,[[["self"],["f"]],["t"]]],[11,"from","","",69,[[["t"]],["t"]]],[11,"into","","",69,[[["self"]],["u"]]],[11,"try_from","","",69,[[["u"]],["result"]]],[11,"borrow","","",69,[[["self"]],["t"]]],[11,"try_into","","",69,[[["self"]],["result"]]],[11,"borrow_mut","","",69,[[["self"]],["t"]]],[11,"get_type_id","","",69,[[["self"]],["typeid"]]],[11,"not_found","","",69,[[["str"],["str"]],["e"]]],[11,"from_ok","","",69,[[["t"]],["t"]]],[11,"map_same","","",69,[[["self"],["f"]],["t"]]],[11,"to_owned","","",70,[[["self"]],["t"]]],[11,"clone_into","","",70,N],[11,"from","","",70,[[["t"]],["t"]]],[11,"into","","",70,[[["self"]],["u"]]],[11,"try_from","","",70,[[["u"]],["result"]]],[11,"borrow","","",70,[[["self"]],["t"]]],[11,"try_into","","",70,[[["self"]],["result"]]],[11,"borrow_mut","","",70,[[["self"]],["t"]]],[11,"get_type_id","","",70,[[["self"]],["typeid"]]],[11,"not_found","","",70,[[["str"],["str"]],["e"]]],[11,"from_ok","","",70,[[["t"]],["t"]]],[11,"map_same","","",70,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::type_check::constraint_conversion","",71,[[["t"]],["t"]]],[11,"into","","",71,[[["self"]],["u"]]],[11,"try_from","","",71,[[["u"]],["result"]]],[11,"borrow","","",71,[[["self"]],["t"]]],[11,"try_into","","",71,[[["self"]],["result"]]],[11,"borrow_mut","","",71,[[["self"]],["t"]]],[11,"get_type_id","","",71,[[["self"]],["typeid"]]],[11,"not_found","","",71,[[["str"],["str"]],["e"]]],[11,"from_ok","","",71,[[["t"]],["t"]]],[11,"map_same","","",71,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::type_check::free_region_relations","",72,[[["t"]],["t"]]],[11,"into","","",72,[[["self"]],["u"]]],[11,"try_from","","",72,[[["u"]],["result"]]],[11,"borrow","","",72,[[["self"]],["t"]]],[11,"try_into","","",72,[[["self"]],["result"]]],[11,"borrow_mut","","",72,[[["self"]],["t"]]],[11,"get_type_id","","",72,[[["self"]],["typeid"]]],[11,"not_found","","",72,[[["str"],["str"]],["e"]]],[11,"from_ok","","",72,[[["t"]],["t"]]],[11,"map_same","","",72,[[["self"],["f"]],["t"]]],[11,"from","","",73,[[["t"]],["t"]]],[11,"into","","",73,[[["self"]],["u"]]],[11,"try_from","","",73,[[["u"]],["result"]]],[11,"borrow","","",73,[[["self"]],["t"]]],[11,"try_into","","",73,[[["self"]],["result"]]],[11,"borrow_mut","","",73,[[["self"]],["t"]]],[11,"get_type_id","","",73,[[["self"]],["typeid"]]],[11,"not_found","","",73,[[["str"],["str"]],["e"]]],[11,"from_ok","","",73,[[["t"]],["t"]]],[11,"map_same","","",73,[[["self"],["f"]],["t"]]],[11,"from","","",74,[[["t"]],["t"]]],[11,"into","","",74,[[["self"]],["u"]]],[11,"try_from","","",74,[[["u"]],["result"]]],[11,"borrow","","",74,[[["self"]],["t"]]],[11,"try_into","","",74,[[["self"]],["result"]]],[11,"borrow_mut","","",74,[[["self"]],["t"]]],[11,"get_type_id","","",74,[[["self"]],["typeid"]]],[11,"not_found","","",74,[[["str"],["str"]],["e"]]],[11,"from_ok","","",74,[[["t"]],["t"]]],[11,"map_same","","",74,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::type_check::input_output","",75,[[["t"]],["t"]]],[11,"into","","",75,[[["self"]],["u"]]],[11,"try_from","","",75,[[["u"]],["result"]]],[11,"borrow","","",75,[[["self"]],["t"]]],[11,"try_into","","",75,[[["self"]],["result"]]],[11,"borrow_mut","","",75,[[["self"]],["t"]]],[11,"get_type_id","","",75,[[["self"]],["typeid"]]],[11,"not_found","","",75,[[["str"],["str"]],["e"]]],[11,"from_ok","","",75,[[["t"]],["t"]]],[11,"map_same","","",75,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::type_check::liveness::liveness_map","",76,[[["t"]],["t"]]],[11,"into","","",76,[[["self"]],["u"]]],[11,"try_from","","",76,[[["u"]],["result"]]],[11,"borrow","","",76,[[["self"]],["t"]]],[11,"try_into","","",76,[[["self"]],["result"]]],[11,"borrow_mut","","",76,[[["self"]],["t"]]],[11,"get_type_id","","",76,[[["self"]],["typeid"]]],[11,"not_found","","",76,[[["str"],["str"]],["e"]]],[11,"from_ok","","",76,[[["t"]],["t"]]],[11,"map_same","","",76,[[["self"],["f"]],["t"]]],[11,"to_owned","","",77,[[["self"]],["t"]]],[11,"clone_into","","",77,N],[11,"from","","",77,[[["t"]],["t"]]],[11,"into","","",77,[[["self"]],["u"]]],[11,"try_from","","",77,[[["u"]],["result"]]],[11,"borrow","","",77,[[["self"]],["t"]]],[11,"try_into","","",77,[[["self"]],["result"]]],[11,"borrow_mut","","",77,[[["self"]],["t"]]],[11,"get_type_id","","",77,[[["self"]],["typeid"]]],[11,"encode","","",77,[[["self"],["e"]],["result"]]],[11,"decode","","",77,[[["d"]],["result"]]],[11,"not_found","","",77,[[["str"],["str"]],["e"]]],[11,"from_ok","","",77,[[["t"]],["t"]]],[11,"map_same","","",77,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::type_check::liveness::local_use_map","",78,[[["t"]],["t"]]],[11,"into","","",78,[[["self"]],["u"]]],[11,"try_from","","",78,[[["u"]],["result"]]],[11,"borrow","","",78,[[["self"]],["t"]]],[11,"try_into","","",78,[[["self"]],["result"]]],[11,"borrow_mut","","",78,[[["self"]],["t"]]],[11,"get_type_id","","",78,[[["self"]],["typeid"]]],[11,"not_found","","",78,[[["str"],["str"]],["e"]]],[11,"from_ok","","",78,[[["t"]],["t"]]],[11,"map_same","","",78,[[["self"],["f"]],["t"]]],[11,"from","","",79,[[["t"]],["t"]]],[11,"into","","",79,[[["self"]],["u"]]],[11,"try_from","","",79,[[["u"]],["result"]]],[11,"borrow","","",79,[[["self"]],["t"]]],[11,"try_into","","",79,[[["self"]],["result"]]],[11,"borrow_mut","","",79,[[["self"]],["t"]]],[11,"get_type_id","","",79,[[["self"]],["typeid"]]],[11,"not_found","","",79,[[["str"],["str"]],["e"]]],[11,"from_ok","","",79,[[["t"]],["t"]]],[11,"map_same","","",79,[[["self"],["f"]],["t"]]],[11,"to_owned","","",80,[[["self"]],["t"]]],[11,"clone_into","","",80,N],[11,"from","","",80,[[["t"]],["t"]]],[11,"into","","",80,[[["self"]],["u"]]],[11,"try_from","","",80,[[["u"]],["result"]]],[11,"borrow","","",80,[[["self"]],["t"]]],[11,"try_into","","",80,[[["self"]],["result"]]],[11,"borrow_mut","","",80,[[["self"]],["t"]]],[11,"get_type_id","","",80,[[["self"]],["typeid"]]],[11,"encode","","",80,[[["self"],["e"]],["result"]]],[11,"decode","","",80,[[["d"]],["result"]]],[11,"not_found","","",80,[[["str"],["str"]],["e"]]],[11,"from_ok","","",80,[[["t"]],["t"]]],[11,"map_same","","",80,[[["self"],["f"]],["t"]]],[11,"from","","",81,[[["t"]],["t"]]],[11,"into","","",81,[[["self"]],["u"]]],[11,"try_from","","",81,[[["u"]],["result"]]],[11,"borrow","","",81,[[["self"]],["t"]]],[11,"try_into","","",81,[[["self"]],["result"]]],[11,"borrow_mut","","",81,[[["self"]],["t"]]],[11,"get_type_id","","",81,[[["self"]],["typeid"]]],[11,"not_found","","",81,[[["str"],["str"]],["e"]]],[11,"from_ok","","",81,[[["t"]],["t"]]],[11,"map_same","","",81,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::type_check::liveness::trace","",82,[[["t"]],["t"]]],[11,"into","","",82,[[["self"]],["u"]]],[11,"try_from","","",82,[[["u"]],["result"]]],[11,"borrow","","",82,[[["self"]],["t"]]],[11,"try_into","","",82,[[["self"]],["result"]]],[11,"borrow_mut","","",82,[[["self"]],["t"]]],[11,"get_type_id","","",82,[[["self"]],["typeid"]]],[11,"not_found","","",82,[[["str"],["str"]],["e"]]],[11,"from_ok","","",82,[[["t"]],["t"]]],[11,"map_same","","",82,[[["self"],["f"]],["t"]]],[11,"from","","",83,[[["t"]],["t"]]],[11,"into","","",83,[[["self"]],["u"]]],[11,"try_from","","",83,[[["u"]],["result"]]],[11,"borrow","","",83,[[["self"]],["t"]]],[11,"try_into","","",83,[[["self"]],["result"]]],[11,"borrow_mut","","",83,[[["self"]],["t"]]],[11,"get_type_id","","",83,[[["self"]],["typeid"]]],[11,"not_found","","",83,[[["str"],["str"]],["e"]]],[11,"from_ok","","",83,[[["t"]],["t"]]],[11,"map_same","","",83,[[["self"],["f"]],["t"]]],[11,"from","","",84,[[["t"]],["t"]]],[11,"into","","",84,[[["self"]],["u"]]],[11,"try_from","","",84,[[["u"]],["result"]]],[11,"borrow","","",84,[[["self"]],["t"]]],[11,"try_into","","",84,[[["self"]],["result"]]],[11,"borrow_mut","","",84,[[["self"]],["t"]]],[11,"get_type_id","","",84,[[["self"]],["typeid"]]],[11,"not_found","","",84,[[["str"],["str"]],["e"]]],[11,"from_ok","","",84,[[["t"]],["t"]]],[11,"map_same","","",84,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::type_check::relate_tys","",85,[[["t"]],["t"]]],[11,"into","","",85,[[["self"]],["u"]]],[11,"try_from","","",85,[[["u"]],["result"]]],[11,"borrow","","",85,[[["self"]],["t"]]],[11,"try_into","","",85,[[["self"]],["result"]]],[11,"borrow_mut","","",85,[[["self"]],["t"]]],[11,"get_type_id","","",85,[[["self"]],["typeid"]]],[11,"not_found","","",85,[[["str"],["str"]],["e"]]],[11,"from_ok","","",85,[[["t"]],["t"]]],[11,"map_same","","",85,[[["self"],["f"]],["t"]]],[11,"to_owned","","",86,[[["self"]],["t"]]],[11,"clone_into","","",86,N],[11,"from","","",86,[[["t"]],["t"]]],[11,"into","","",86,[[["self"]],["u"]]],[11,"try_from","","",86,[[["u"]],["result"]]],[11,"borrow","","",86,[[["self"]],["t"]]],[11,"try_into","","",86,[[["self"]],["result"]]],[11,"borrow_mut","","",86,[[["self"]],["t"]]],[11,"get_type_id","","",86,[[["self"]],["typeid"]]],[11,"not_found","","",86,[[["str"],["str"]],["e"]]],[11,"from_ok","","",86,[[["t"]],["t"]]],[11,"map_same","","",86,[[["self"],["f"]],["t"]]],[11,"to_owned","","",87,[[["self"]],["t"]]],[11,"clone_into","","",87,N],[11,"from","","",87,[[["t"]],["t"]]],[11,"into","","",87,[[["self"]],["u"]]],[11,"try_from","","",87,[[["u"]],["result"]]],[11,"borrow","","",87,[[["self"]],["t"]]],[11,"try_into","","",87,[[["self"]],["result"]]],[11,"borrow_mut","","",87,[[["self"]],["t"]]],[11,"get_type_id","","",87,[[["self"]],["typeid"]]],[11,"not_found","","",87,[[["str"],["str"]],["e"]]],[11,"from_ok","","",87,[[["t"]],["t"]]],[11,"map_same","","",87,[[["self"],["f"]],["t"]]],[11,"to_owned","","",88,[[["self"]],["t"]]],[11,"clone_into","","",88,N],[11,"from","","",88,[[["t"]],["t"]]],[11,"into","","",88,[[["self"]],["u"]]],[11,"try_from","","",88,[[["u"]],["result"]]],[11,"borrow","","",88,[[["self"]],["t"]]],[11,"try_into","","",88,[[["self"]],["result"]]],[11,"borrow_mut","","",88,[[["self"]],["t"]]],[11,"get_type_id","","",88,[[["self"]],["typeid"]]],[11,"not_found","","",88,[[["str"],["str"]],["e"]]],[11,"from_ok","","",88,[[["t"]],["t"]]],[11,"map_same","","",88,[[["self"],["f"]],["t"]]],[11,"from","","",89,[[["t"]],["t"]]],[11,"into","","",89,[[["self"]],["u"]]],[11,"try_from","","",89,[[["u"]],["result"]]],[11,"borrow","","",89,[[["self"]],["t"]]],[11,"try_into","","",89,[[["self"]],["result"]]],[11,"borrow_mut","","",89,[[["self"]],["t"]]],[11,"get_type_id","","",89,[[["self"]],["typeid"]]],[11,"not_found","","",89,[[["str"],["str"]],["e"]]],[11,"from_ok","","",89,[[["t"]],["t"]]],[11,"map_same","","",89,[[["self"],["f"]],["t"]]],[11,"from","","",90,[[["t"]],["t"]]],[11,"into","","",90,[[["self"]],["u"]]],[11,"try_from","","",90,[[["u"]],["result"]]],[11,"borrow","","",90,[[["self"]],["t"]]],[11,"try_into","","",90,[[["self"]],["result"]]],[11,"borrow_mut","","",90,[[["self"]],["t"]]],[11,"get_type_id","","",90,[[["self"]],["typeid"]]],[11,"not_found","","",90,[[["str"],["str"]],["e"]]],[11,"from_ok","","",90,[[["t"]],["t"]]],[11,"map_same","","",90,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::universal_regions","",94,[[["t"]],["t"]]],[11,"into","","",94,[[["self"]],["u"]]],[11,"try_from","","",94,[[["u"]],["result"]]],[11,"borrow","","",94,[[["self"]],["t"]]],[11,"try_into","","",94,[[["self"]],["result"]]],[11,"borrow_mut","","",94,[[["self"]],["t"]]],[11,"get_type_id","","",94,[[["self"]],["typeid"]]],[11,"not_found","","",94,[[["str"],["str"]],["e"]]],[11,"from_ok","","",94,[[["t"]],["t"]]],[11,"map_same","","",94,[[["self"],["f"]],["t"]]],[11,"from","","",95,[[["t"]],["t"]]],[11,"into","","",95,[[["self"]],["u"]]],[11,"try_from","","",95,[[["u"]],["result"]]],[11,"borrow","","",95,[[["self"]],["t"]]],[11,"try_into","","",95,[[["self"]],["result"]]],[11,"borrow_mut","","",95,[[["self"]],["t"]]],[11,"get_type_id","","",95,[[["self"]],["typeid"]]],[11,"not_found","","",95,[[["str"],["str"]],["e"]]],[11,"from_ok","","",95,[[["t"]],["t"]]],[11,"map_same","","",95,[[["self"],["f"]],["t"]]],[11,"from","","",96,[[["t"]],["t"]]],[11,"into","","",96,[[["self"]],["u"]]],[11,"try_from","","",96,[[["u"]],["result"]]],[11,"borrow","","",96,[[["self"]],["t"]]],[11,"try_into","","",96,[[["self"]],["result"]]],[11,"borrow_mut","","",96,[[["self"]],["t"]]],[11,"get_type_id","","",96,[[["self"]],["typeid"]]],[11,"not_found","","",96,[[["str"],["str"]],["e"]]],[11,"from_ok","","",96,[[["t"]],["t"]]],[11,"map_same","","",96,[[["self"],["f"]],["t"]]],[11,"to_owned","","",97,[[["self"]],["t"]]],[11,"clone_into","","",97,N],[11,"from","","",97,[[["t"]],["t"]]],[11,"into","","",97,[[["self"]],["u"]]],[11,"try_from","","",97,[[["u"]],["result"]]],[11,"borrow","","",97,[[["self"]],["t"]]],[11,"try_into","","",97,[[["self"]],["result"]]],[11,"borrow_mut","","",97,[[["self"]],["t"]]],[11,"get_type_id","","",97,[[["self"]],["typeid"]]],[11,"not_found","","",97,[[["str"],["str"]],["e"]]],[11,"from_ok","","",97,[[["t"]],["t"]]],[11,"map_same","","",97,[[["self"],["f"]],["t"]]],[11,"to_owned","","",98,[[["self"]],["t"]]],[11,"clone_into","","",98,N],[11,"from","","",98,[[["t"]],["t"]]],[11,"into","","",98,[[["self"]],["u"]]],[11,"try_from","","",98,[[["u"]],["result"]]],[11,"borrow","","",98,[[["self"]],["t"]]],[11,"try_into","","",98,[[["self"]],["result"]]],[11,"borrow_mut","","",98,[[["self"]],["t"]]],[11,"get_type_id","","",98,[[["self"]],["typeid"]]],[11,"not_found","","",98,[[["str"],["str"]],["e"]]],[11,"from_ok","","",98,[[["t"]],["t"]]],[11,"map_same","","",98,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::borrow_check::nll::constraints","",100,[[["self"]],["t"]]],[11,"clone_into","","",100,N],[11,"from","","",100,[[["t"]],["t"]]],[11,"into","","",100,[[["self"]],["u"]]],[11,"try_from","","",100,[[["u"]],["result"]]],[11,"borrow","","",100,[[["self"]],["t"]]],[11,"try_into","","",100,[[["self"]],["result"]]],[11,"borrow_mut","","",100,[[["self"]],["t"]]],[11,"get_type_id","","",100,[[["self"]],["typeid"]]],[11,"not_found","","",100,[[["str"],["str"]],["e"]]],[11,"from_ok","","",100,[[["t"]],["t"]]],[11,"map_same","","",100,[[["self"],["f"]],["t"]]],[11,"to_owned","","",101,[[["self"]],["t"]]],[11,"clone_into","","",101,N],[11,"from","","",101,[[["t"]],["t"]]],[11,"into","","",101,[[["self"]],["u"]]],[11,"try_from","","",101,[[["u"]],["result"]]],[11,"borrow","","",101,[[["self"]],["t"]]],[11,"try_into","","",101,[[["self"]],["result"]]],[11,"borrow_mut","","",101,[[["self"]],["t"]]],[11,"get_type_id","","",101,[[["self"]],["typeid"]]],[11,"not_found","","",101,[[["str"],["str"]],["e"]]],[11,"from_ok","","",101,[[["t"]],["t"]]],[11,"map_same","","",101,[[["self"],["f"]],["t"]]],[11,"to_owned","","",102,[[["self"]],["t"]]],[11,"clone_into","","",102,N],[11,"from","","",102,[[["t"]],["t"]]],[11,"into","","",102,[[["self"]],["u"]]],[11,"try_from","","",102,[[["u"]],["result"]]],[11,"borrow","","",102,[[["self"]],["t"]]],[11,"try_into","","",102,[[["self"]],["result"]]],[11,"borrow_mut","","",102,[[["self"]],["t"]]],[11,"get_type_id","","",102,[[["self"]],["typeid"]]],[11,"encode","","",102,[[["self"],["e"]],["result"]]],[11,"decode","","",102,[[["d"]],["result"]]],[11,"not_found","","",102,[[["str"],["str"]],["e"]]],[11,"from_ok","","",102,[[["t"]],["t"]]],[11,"map_same","","",102,[[["self"],["f"]],["t"]]],[11,"to_owned","","",103,[[["self"]],["t"]]],[11,"clone_into","","",103,N],[11,"from","","",103,[[["t"]],["t"]]],[11,"into","","",103,[[["self"]],["u"]]],[11,"try_from","","",103,[[["u"]],["result"]]],[11,"borrow","","",103,[[["self"]],["t"]]],[11,"try_into","","",103,[[["self"]],["result"]]],[11,"borrow_mut","","",103,[[["self"]],["t"]]],[11,"get_type_id","","",103,[[["self"]],["typeid"]]],[11,"encode","","",103,[[["self"],["e"]],["result"]]],[11,"decode","","",103,[[["d"]],["result"]]],[11,"not_found","","",103,[[["str"],["str"]],["e"]]],[11,"from_ok","","",103,[[["t"]],["t"]]],[11,"map_same","","",103,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::borrow_check::nll::constraints::graph","",104,[[["t"]],["t"]]],[11,"into","","",104,[[["self"]],["u"]]],[11,"try_from","","",104,[[["u"]],["result"]]],[11,"borrow","","",104,[[["self"]],["t"]]],[11,"try_into","","",104,[[["self"]],["result"]]],[11,"borrow_mut","","",104,[[["self"]],["t"]]],[11,"get_type_id","","",104,[[["self"]],["typeid"]]],[11,"not_found","","",104,[[["str"],["str"]],["e"]]],[11,"from_ok","","",104,[[["t"]],["t"]]],[11,"map_same","","",104,[[["self"],["f"]],["t"]]],[11,"to_owned","","",109,[[["self"]],["t"]]],[11,"clone_into","","",109,N],[11,"from","","",109,[[["t"]],["t"]]],[11,"into","","",109,[[["self"]],["u"]]],[11,"try_from","","",109,[[["u"]],["result"]]],[11,"borrow","","",109,[[["self"]],["t"]]],[11,"try_into","","",109,[[["self"]],["result"]]],[11,"borrow_mut","","",109,[[["self"]],["t"]]],[11,"get_type_id","","",109,[[["self"]],["typeid"]]],[11,"not_found","","",109,[[["str"],["str"]],["e"]]],[11,"from_ok","","",109,[[["t"]],["t"]]],[11,"map_same","","",109,[[["self"],["f"]],["t"]]],[11,"to_owned","","",110,[[["self"]],["t"]]],[11,"clone_into","","",110,N],[11,"from","","",110,[[["t"]],["t"]]],[11,"into","","",110,[[["self"]],["u"]]],[11,"try_from","","",110,[[["u"]],["result"]]],[11,"borrow","","",110,[[["self"]],["t"]]],[11,"try_into","","",110,[[["self"]],["result"]]],[11,"borrow_mut","","",110,[[["self"]],["t"]]],[11,"get_type_id","","",110,[[["self"]],["typeid"]]],[11,"not_found","","",110,[[["str"],["str"]],["e"]]],[11,"from_ok","","",110,[[["t"]],["t"]]],[11,"map_same","","",110,[[["self"],["f"]],["t"]]],[11,"from","","",105,[[["t"]],["t"]]],[11,"into_iter","","",105,[[["self"]],["i"]]],[11,"into","","",105,[[["self"]],["u"]]],[11,"try_from","","",105,[[["u"]],["result"]]],[11,"borrow","","",105,[[["self"]],["t"]]],[11,"try_into","","",105,[[["self"]],["result"]]],[11,"borrow_mut","","",105,[[["self"]],["t"]]],[11,"get_type_id","","",105,[[["self"]],["typeid"]]],[11,"not_found","","",105,[[["str"],["str"]],["e"]]],[11,"from_ok","","",105,[[["t"]],["t"]]],[11,"map_same","","",105,[[["self"],["f"]],["t"]]],[11,"from","","",106,[[["t"]],["t"]]],[11,"into","","",106,[[["self"]],["u"]]],[11,"try_from","","",106,[[["u"]],["result"]]],[11,"borrow","","",106,[[["self"]],["t"]]],[11,"try_into","","",106,[[["self"]],["result"]]],[11,"borrow_mut","","",106,[[["self"]],["t"]]],[11,"get_type_id","","",106,[[["self"]],["typeid"]]],[11,"not_found","","",106,[[["str"],["str"]],["e"]]],[11,"from_ok","","",106,[[["t"]],["t"]]],[11,"map_same","","",106,[[["self"],["f"]],["t"]]],[11,"from","","",107,[[["t"]],["t"]]],[11,"into_iter","","",107,[[["self"]],["i"]]],[11,"into","","",107,[[["self"]],["u"]]],[11,"try_from","","",107,[[["u"]],["result"]]],[11,"borrow","","",107,[[["self"]],["t"]]],[11,"try_into","","",107,[[["self"]],["result"]]],[11,"borrow_mut","","",107,[[["self"]],["t"]]],[11,"get_type_id","","",107,[[["self"]],["typeid"]]],[11,"not_found","","",107,[[["str"],["str"]],["e"]]],[11,"from_ok","","",107,[[["t"]],["t"]]],[11,"map_same","","",107,[[["self"],["f"]],["t"]]],[11,"hash_stable","rustc_mir::monomorphize","",347,N],[11,"hash_stable","rustc_mir::monomorphize::partitioning","",356,N],[11,"hash_stable","rustc_mir::monomorphize::item","",348,N],[11,"super_fold_with","rustc_mir::monomorphize","",347,[[["self"],["f"]],["instance"]]],[11,"super_visit_with","","",347,[[["self"],["v"]],["bool"]]],[11,"assert_receiver_is_total_eq","rustc_mir::monomorphize::item","",348,N],[11,"assert_receiver_is_total_eq","rustc_mir::monomorphize","",347,N],[11,"eq","","",347,[[["self"],["instance"]],["bool"]]],[11,"ne","","",347,[[["self"],["instance"]],["bool"]]],[11,"eq","rustc_mir::monomorphize::item","",348,[[["self"],["monoitem"]],["bool"]]],[11,"ne","","",348,[[["self"],["monoitem"]],["bool"]]],[11,"hash","rustc_mir::monomorphize","",347,N],[11,"hash","rustc_mir::monomorphize::item","",348,N],[11,"lift_to_tcx","rustc_mir::monomorphize","",347,[[["self"],["tyctxt"]],["option",["instance"]]]],[11,"fmt","","",347,[[["self"],["formatter"]],["result",["error"]]]],[11,"encode","","",347,[[["self"],["__s"]],["result"]]],[11,"decode","","",347,[[["__d"]],["result",["instance"]]]],[11,"fmt","rustc_mir::monomorphize::item","",348,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","rustc_mir::monomorphize","",347,[[["self"],["formatter"]],["result",["error"]]]],[11,"clone","rustc_mir::monomorphize::item","",348,[[["self"]],["monoitem"]]],[11,"clone","rustc_mir::monomorphize","",347,[[["self"]],["instance"]]],[11,"from","rustc_mir::build","",112,[[["t"]],["t"]]],[11,"into","","",112,[[["self"]],["u"]]],[11,"try_from","","",112,[[["u"]],["result"]]],[11,"borrow","","",112,[[["self"]],["t"]]],[11,"try_into","","",112,[[["self"]],["result"]]],[11,"borrow_mut","","",112,[[["self"]],["t"]]],[11,"get_type_id","","",112,[[["self"]],["typeid"]]],[11,"not_found","","",112,[[["str"],["str"]],["e"]]],[11,"from_ok","","",112,[[["t"]],["t"]]],[11,"map_same","","",112,[[["self"],["f"]],["t"]]],[11,"from","","",113,[[["t"]],["t"]]],[11,"into","","",113,[[["self"]],["u"]]],[11,"try_from","","",113,[[["u"]],["result"]]],[11,"borrow","","",113,[[["self"]],["t"]]],[11,"try_into","","",113,[[["self"]],["result"]]],[11,"borrow_mut","","",113,[[["self"]],["t"]]],[11,"get_type_id","","",113,[[["self"]],["typeid"]]],[11,"not_found","","",113,[[["str"],["str"]],["e"]]],[11,"from_ok","","",113,[[["t"]],["t"]]],[11,"map_same","","",113,[[["self"],["f"]],["t"]]],[11,"from","","",114,[[["t"]],["t"]]],[11,"into","","",114,[[["self"]],["u"]]],[11,"try_from","","",114,[[["u"]],["result"]]],[11,"borrow","","",114,[[["self"]],["t"]]],[11,"try_into","","",114,[[["self"]],["result"]]],[11,"borrow_mut","","",114,[[["self"]],["t"]]],[11,"get_type_id","","",114,[[["self"]],["typeid"]]],[11,"not_found","","",114,[[["str"],["str"]],["e"]]],[11,"from_ok","","",114,[[["t"]],["t"]]],[11,"map_same","","",114,[[["self"],["f"]],["t"]]],[11,"from","","",115,[[["t"]],["t"]]],[11,"into","","",115,[[["self"]],["u"]]],[11,"try_from","","",115,[[["u"]],["result"]]],[11,"borrow","","",115,[[["self"]],["t"]]],[11,"try_into","","",115,[[["self"]],["result"]]],[11,"borrow_mut","","",115,[[["self"]],["t"]]],[11,"get_type_id","","",115,[[["self"]],["typeid"]]],[11,"not_found","","",115,[[["str"],["str"]],["e"]]],[11,"from_ok","","",115,[[["t"]],["t"]]],[11,"map_same","","",115,[[["self"],["f"]],["t"]]],[11,"from","","",116,[[["t"]],["t"]]],[11,"into","","",116,[[["self"]],["u"]]],[11,"try_from","","",116,[[["u"]],["result"]]],[11,"borrow","","",116,[[["self"]],["t"]]],[11,"try_into","","",116,[[["self"]],["result"]]],[11,"borrow_mut","","",116,[[["self"]],["t"]]],[11,"get_type_id","","",116,[[["self"]],["typeid"]]],[11,"not_found","","",116,[[["str"],["str"]],["e"]]],[11,"from_ok","","",116,[[["t"]],["t"]]],[11,"map_same","","",116,[[["self"],["f"]],["t"]]],[11,"to_owned","","",117,[[["self"]],["t"]]],[11,"clone_into","","",117,N],[11,"from","","",117,[[["t"]],["t"]]],[11,"into","","",117,[[["self"]],["u"]]],[11,"try_from","","",117,[[["u"]],["result"]]],[11,"borrow","","",117,[[["self"]],["t"]]],[11,"try_into","","",117,[[["self"]],["result"]]],[11,"borrow_mut","","",117,[[["self"]],["t"]]],[11,"get_type_id","","",117,[[["self"]],["typeid"]]],[11,"encode","","",117,[[["self"],["e"]],["result"]]],[11,"decode","","",117,[[["d"]],["result"]]],[11,"not_found","","",117,[[["str"],["str"]],["e"]]],[11,"from_ok","","",117,[[["t"]],["t"]]],[11,"map_same","","",117,[[["self"],["f"]],["t"]]],[11,"from","","",118,[[["t"]],["t"]]],[11,"into","","",118,[[["self"]],["u"]]],[11,"try_from","","",118,[[["u"]],["result"]]],[11,"borrow","","",118,[[["self"]],["t"]]],[11,"try_into","","",118,[[["self"]],["result"]]],[11,"borrow_mut","","",118,[[["self"]],["t"]]],[11,"get_type_id","","",118,[[["self"]],["typeid"]]],[11,"not_found","","",118,[[["str"],["str"]],["e"]]],[11,"from_ok","","",118,[[["t"]],["t"]]],[11,"map_same","","",118,[[["self"],["f"]],["t"]]],[11,"from","","",364,[[["t"]],["t"]]],[11,"into","","",364,[[["self"]],["u"]]],[11,"try_from","","",364,[[["u"]],["result"]]],[11,"borrow","","",364,[[["self"]],["t"]]],[11,"try_into","","",364,[[["self"]],["result"]]],[11,"borrow_mut","","",364,[[["self"]],["t"]]],[11,"get_type_id","","",364,[[["self"]],["typeid"]]],[11,"not_found","","",364,[[["str"],["str"]],["e"]]],[11,"from_ok","","",364,[[["t"]],["t"]]],[11,"map_same","","",364,[[["self"],["f"]],["t"]]],[11,"from","","",119,[[["t"]],["t"]]],[11,"into","","",119,[[["self"]],["u"]]],[11,"try_from","","",119,[[["u"]],["result"]]],[11,"borrow","","",119,[[["self"]],["t"]]],[11,"try_into","","",119,[[["self"]],["result"]]],[11,"borrow_mut","","",119,[[["self"]],["t"]]],[11,"get_type_id","","",119,[[["self"]],["typeid"]]],[11,"not_found","","",119,[[["str"],["str"]],["e"]]],[11,"from_ok","","",119,[[["t"]],["t"]]],[11,"map_same","","",119,[[["self"],["f"]],["t"]]],[11,"from","","",120,[[["t"]],["t"]]],[11,"into","","",120,[[["self"]],["u"]]],[11,"try_from","","",120,[[["u"]],["result"]]],[11,"borrow","","",120,[[["self"]],["t"]]],[11,"try_into","","",120,[[["self"]],["result"]]],[11,"borrow_mut","","",120,[[["self"]],["t"]]],[11,"get_type_id","","",120,[[["self"]],["typeid"]]],[11,"not_found","","",120,[[["str"],["str"]],["e"]]],[11,"from_ok","","",120,[[["t"]],["t"]]],[11,"map_same","","",120,[[["self"],["f"]],["t"]]],[11,"to_owned","","",121,[[["self"]],["t"]]],[11,"clone_into","","",121,N],[11,"from","","",121,[[["t"]],["t"]]],[11,"into","","",121,[[["self"]],["u"]]],[11,"try_from","","",121,[[["u"]],["result"]]],[11,"borrow","","",121,[[["self"]],["t"]]],[11,"try_into","","",121,[[["self"]],["result"]]],[11,"borrow_mut","","",121,[[["self"]],["t"]]],[11,"get_type_id","","",121,[[["self"]],["typeid"]]],[11,"not_found","","",121,[[["str"],["str"]],["e"]]],[11,"from_ok","","",121,[[["t"]],["t"]]],[11,"map_same","","",121,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::build::expr::category","",122,[[["t"]],["t"]]],[11,"into","","",122,[[["self"]],["u"]]],[11,"try_from","","",122,[[["u"]],["result"]]],[11,"borrow","","",122,[[["self"]],["t"]]],[11,"try_into","","",122,[[["self"]],["result"]]],[11,"borrow_mut","","",122,[[["self"]],["t"]]],[11,"get_type_id","","",122,[[["self"]],["typeid"]]],[11,"not_found","","",122,[[["str"],["str"]],["e"]]],[11,"from_ok","","",122,[[["t"]],["t"]]],[11,"map_same","","",122,[[["self"],["f"]],["t"]]],[11,"from","","",123,[[["t"]],["t"]]],[11,"into","","",123,[[["self"]],["u"]]],[11,"try_from","","",123,[[["u"]],["result"]]],[11,"borrow","","",123,[[["self"]],["t"]]],[11,"try_into","","",123,[[["self"]],["result"]]],[11,"borrow_mut","","",123,[[["self"]],["t"]]],[11,"get_type_id","","",123,[[["self"]],["typeid"]]],[11,"not_found","","",123,[[["str"],["str"]],["e"]]],[11,"from_ok","","",123,[[["t"]],["t"]]],[11,"map_same","","",123,[[["self"],["f"]],["t"]]],[11,"eval_into","rustc_mir::hair","",199,[[["self"],["builder"],["place"],["basicblock"]],["blockand"]]],[11,"eval_into","","",190,[[["self"],["builder"],["place"],["basicblock"]],["blockand"]]],[11,"to_owned","rustc_mir::build::matches","",125,[[["self"]],["t"]]],[11,"clone_into","","",125,N],[11,"from","","",125,[[["t"]],["t"]]],[11,"into","","",125,[[["self"]],["u"]]],[11,"try_from","","",125,[[["u"]],["result"]]],[11,"borrow","","",125,[[["self"]],["t"]]],[11,"try_into","","",125,[[["self"]],["result"]]],[11,"borrow_mut","","",125,[[["self"]],["t"]]],[11,"get_type_id","","",125,[[["self"]],["typeid"]]],[11,"not_found","","",125,[[["str"],["str"]],["e"]]],[11,"from_ok","","",125,[[["t"]],["t"]]],[11,"map_same","","",125,[[["self"],["f"]],["t"]]],[11,"from","","",126,[[["t"]],["t"]]],[11,"into","","",126,[[["self"]],["u"]]],[11,"try_from","","",126,[[["u"]],["result"]]],[11,"borrow","","",126,[[["self"]],["t"]]],[11,"try_into","","",126,[[["self"]],["result"]]],[11,"borrow_mut","","",126,[[["self"]],["t"]]],[11,"get_type_id","","",126,[[["self"]],["typeid"]]],[11,"not_found","","",126,[[["str"],["str"]],["e"]]],[11,"from_ok","","",126,[[["t"]],["t"]]],[11,"map_same","","",126,[[["self"],["f"]],["t"]]],[11,"to_owned","","",127,[[["self"]],["t"]]],[11,"clone_into","","",127,N],[11,"from","","",127,[[["t"]],["t"]]],[11,"into","","",127,[[["self"]],["u"]]],[11,"try_from","","",127,[[["u"]],["result"]]],[11,"borrow","","",127,[[["self"]],["t"]]],[11,"try_into","","",127,[[["self"]],["result"]]],[11,"borrow_mut","","",127,[[["self"]],["t"]]],[11,"get_type_id","","",127,[[["self"]],["typeid"]]],[11,"not_found","","",127,[[["str"],["str"]],["e"]]],[11,"from_ok","","",127,[[["t"]],["t"]]],[11,"map_same","","",127,[[["self"],["f"]],["t"]]],[11,"to_owned","","",128,[[["self"]],["t"]]],[11,"clone_into","","",128,N],[11,"from","","",128,[[["t"]],["t"]]],[11,"into","","",128,[[["self"]],["u"]]],[11,"try_from","","",128,[[["u"]],["result"]]],[11,"borrow","","",128,[[["self"]],["t"]]],[11,"try_into","","",128,[[["self"]],["result"]]],[11,"borrow_mut","","",128,[[["self"]],["t"]]],[11,"get_type_id","","",128,[[["self"]],["typeid"]]],[11,"not_found","","",128,[[["str"],["str"]],["e"]]],[11,"from_ok","","",128,[[["t"]],["t"]]],[11,"map_same","","",128,[[["self"],["f"]],["t"]]],[11,"to_owned","","",129,[[["self"]],["t"]]],[11,"clone_into","","",129,N],[11,"from","","",129,[[["t"]],["t"]]],[11,"into","","",129,[[["self"]],["u"]]],[11,"try_from","","",129,[[["u"]],["result"]]],[11,"borrow","","",129,[[["self"]],["t"]]],[11,"try_into","","",129,[[["self"]],["result"]]],[11,"borrow_mut","","",129,[[["self"]],["t"]]],[11,"get_type_id","","",129,[[["self"]],["typeid"]]],[11,"not_found","","",129,[[["str"],["str"]],["e"]]],[11,"from_ok","","",129,[[["t"]],["t"]]],[11,"map_same","","",129,[[["self"],["f"]],["t"]]],[11,"to_owned","","",130,[[["self"]],["t"]]],[11,"clone_into","","",130,N],[11,"from","","",130,[[["t"]],["t"]]],[11,"into","","",130,[[["self"]],["u"]]],[11,"try_from","","",130,[[["u"]],["result"]]],[11,"borrow","","",130,[[["self"]],["t"]]],[11,"try_into","","",130,[[["self"]],["result"]]],[11,"borrow_mut","","",130,[[["self"]],["t"]]],[11,"get_type_id","","",130,[[["self"]],["typeid"]]],[11,"not_found","","",130,[[["str"],["str"]],["e"]]],[11,"from_ok","","",130,[[["t"]],["t"]]],[11,"map_same","","",130,[[["self"],["f"]],["t"]]],[11,"from","","",131,[[["t"]],["t"]]],[11,"into","","",131,[[["self"]],["u"]]],[11,"try_from","","",131,[[["u"]],["result"]]],[11,"borrow","","",131,[[["self"]],["t"]]],[11,"try_into","","",131,[[["self"]],["result"]]],[11,"borrow_mut","","",131,[[["self"]],["t"]]],[11,"get_type_id","","",131,[[["self"]],["typeid"]]],[11,"not_found","","",131,[[["str"],["str"]],["e"]]],[11,"from_ok","","",131,[[["t"]],["t"]]],[11,"map_same","","",131,[[["self"],["f"]],["t"]]],[11,"to_owned","","",132,[[["self"]],["t"]]],[11,"clone_into","","",132,N],[11,"from","","",132,[[["t"]],["t"]]],[11,"into","","",132,[[["self"]],["u"]]],[11,"try_from","","",132,[[["u"]],["result"]]],[11,"borrow","","",132,[[["self"]],["t"]]],[11,"try_into","","",132,[[["self"]],["result"]]],[11,"borrow_mut","","",132,[[["self"]],["t"]]],[11,"get_type_id","","",132,[[["self"]],["typeid"]]],[11,"not_found","","",132,[[["str"],["str"]],["e"]]],[11,"from_ok","","",132,[[["t"]],["t"]]],[11,"map_same","","",132,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::build::scope","",133,[[["t"]],["t"]]],[11,"into","","",133,[[["self"]],["u"]]],[11,"try_from","","",133,[[["u"]],["result"]]],[11,"borrow","","",133,[[["self"]],["t"]]],[11,"try_into","","",133,[[["self"]],["result"]]],[11,"borrow_mut","","",133,[[["self"]],["t"]]],[11,"get_type_id","","",133,[[["self"]],["typeid"]]],[11,"not_found","","",133,[[["str"],["str"]],["e"]]],[11,"from_ok","","",133,[[["t"]],["t"]]],[11,"map_same","","",133,[[["self"],["f"]],["t"]]],[11,"from","","",134,[[["t"]],["t"]]],[11,"into","","",134,[[["self"]],["u"]]],[11,"try_from","","",134,[[["u"]],["result"]]],[11,"borrow","","",134,[[["self"]],["t"]]],[11,"try_into","","",134,[[["self"]],["result"]]],[11,"borrow_mut","","",134,[[["self"]],["t"]]],[11,"get_type_id","","",134,[[["self"]],["typeid"]]],[11,"not_found","","",134,[[["str"],["str"]],["e"]]],[11,"from_ok","","",134,[[["t"]],["t"]]],[11,"map_same","","",134,[[["self"],["f"]],["t"]]],[11,"to_owned","","",135,[[["self"]],["t"]]],[11,"clone_into","","",135,N],[11,"from","","",135,[[["t"]],["t"]]],[11,"into","","",135,[[["self"]],["u"]]],[11,"try_from","","",135,[[["u"]],["result"]]],[11,"borrow","","",135,[[["self"]],["t"]]],[11,"try_into","","",135,[[["self"]],["result"]]],[11,"borrow_mut","","",135,[[["self"]],["t"]]],[11,"get_type_id","","",135,[[["self"]],["typeid"]]],[11,"not_found","","",135,[[["str"],["str"]],["e"]]],[11,"from_ok","","",135,[[["t"]],["t"]]],[11,"map_same","","",135,[[["self"],["f"]],["t"]]],[11,"to_owned","","",136,[[["self"]],["t"]]],[11,"clone_into","","",136,N],[11,"from","","",136,[[["t"]],["t"]]],[11,"into","","",136,[[["self"]],["u"]]],[11,"try_from","","",136,[[["u"]],["result"]]],[11,"borrow","","",136,[[["self"]],["t"]]],[11,"try_into","","",136,[[["self"]],["result"]]],[11,"borrow_mut","","",136,[[["self"]],["t"]]],[11,"get_type_id","","",136,[[["self"]],["typeid"]]],[11,"not_found","","",136,[[["str"],["str"]],["e"]]],[11,"from_ok","","",136,[[["t"]],["t"]]],[11,"map_same","","",136,[[["self"],["f"]],["t"]]],[11,"from","","",137,[[["t"]],["t"]]],[11,"into","","",137,[[["self"]],["u"]]],[11,"try_from","","",137,[[["u"]],["result"]]],[11,"borrow","","",137,[[["self"]],["t"]]],[11,"try_into","","",137,[[["self"]],["result"]]],[11,"borrow_mut","","",137,[[["self"]],["t"]]],[11,"get_type_id","","",137,[[["self"]],["typeid"]]],[11,"not_found","","",137,[[["str"],["str"]],["e"]]],[11,"from_ok","","",137,[[["t"]],["t"]]],[11,"map_same","","",137,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::dataflow","",139,[[["t"]],["t"]]],[11,"into","","",139,[[["self"]],["u"]]],[11,"try_from","","",139,[[["u"]],["result"]]],[11,"borrow","","",139,[[["self"]],["t"]]],[11,"try_into","","",139,[[["self"]],["result"]]],[11,"borrow_mut","","",139,[[["self"]],["t"]]],[11,"get_type_id","","",139,[[["self"]],["typeid"]]],[11,"not_found","","",139,[[["str"],["str"]],["e"]]],[11,"from_ok","","",139,[[["t"]],["t"]]],[11,"map_same","","",139,[[["self"],["f"]],["t"]]],[11,"from","","",140,[[["t"]],["t"]]],[11,"into","","",140,[[["self"]],["u"]]],[11,"try_from","","",140,[[["u"]],["result"]]],[11,"borrow","","",140,[[["self"]],["t"]]],[11,"try_into","","",140,[[["self"]],["result"]]],[11,"borrow_mut","","",140,[[["self"]],["t"]]],[11,"get_type_id","","",140,[[["self"]],["typeid"]]],[11,"not_found","","",140,[[["str"],["str"]],["e"]]],[11,"from_ok","","",140,[[["t"]],["t"]]],[11,"map_same","","",140,[[["self"],["f"]],["t"]]],[11,"from","","",141,[[["t"]],["t"]]],[11,"into","","",141,[[["self"]],["u"]]],[11,"try_from","","",141,[[["u"]],["result"]]],[11,"borrow","","",141,[[["self"]],["t"]]],[11,"try_into","","",141,[[["self"]],["result"]]],[11,"borrow_mut","","",141,[[["self"]],["t"]]],[11,"get_type_id","","",141,[[["self"]],["typeid"]]],[11,"not_found","","",141,[[["str"],["str"]],["e"]]],[11,"from_ok","","",141,[[["t"]],["t"]]],[11,"map_same","","",141,[[["self"],["f"]],["t"]]],[11,"from","","",142,[[["t"]],["t"]]],[11,"into","","",142,[[["self"]],["u"]]],[11,"try_from","","",142,[[["u"]],["result"]]],[11,"borrow","","",142,[[["self"]],["t"]]],[11,"try_into","","",142,[[["self"]],["result"]]],[11,"borrow_mut","","",142,[[["self"]],["t"]]],[11,"get_type_id","","",142,[[["self"]],["typeid"]]],[11,"not_found","","",142,[[["str"],["str"]],["e"]]],[11,"from_ok","","",142,[[["t"]],["t"]]],[11,"map_same","","",142,[[["self"],["f"]],["t"]]],[11,"from","","",143,[[["t"]],["t"]]],[11,"into","","",143,[[["self"]],["u"]]],[11,"try_from","","",143,[[["u"]],["result"]]],[11,"borrow","","",143,[[["self"]],["t"]]],[11,"try_into","","",143,[[["self"]],["result"]]],[11,"borrow_mut","","",143,[[["self"]],["t"]]],[11,"get_type_id","","",143,[[["self"]],["typeid"]]],[11,"not_found","","",143,[[["str"],["str"]],["e"]]],[11,"from_ok","","",143,[[["t"]],["t"]]],[11,"map_same","","",143,[[["self"],["f"]],["t"]]],[11,"from","","",144,[[["t"]],["t"]]],[11,"into","","",144,[[["self"]],["u"]]],[11,"try_from","","",144,[[["u"]],["result"]]],[11,"borrow","","",144,[[["self"]],["t"]]],[11,"try_into","","",144,[[["self"]],["result"]]],[11,"borrow_mut","","",144,[[["self"]],["t"]]],[11,"get_type_id","","",144,[[["self"]],["typeid"]]],[11,"not_found","","",144,[[["str"],["str"]],["e"]]],[11,"from_ok","","",144,[[["t"]],["t"]]],[11,"map_same","","",144,[[["self"],["f"]],["t"]]],[11,"from","","",145,[[["t"]],["t"]]],[11,"into","","",145,[[["self"]],["u"]]],[11,"try_from","","",145,[[["u"]],["result"]]],[11,"borrow","","",145,[[["self"]],["t"]]],[11,"try_into","","",145,[[["self"]],["result"]]],[11,"borrow_mut","","",145,[[["self"]],["t"]]],[11,"get_type_id","","",145,[[["self"]],["typeid"]]],[11,"not_found","","",145,[[["str"],["str"]],["e"]]],[11,"from_ok","","",145,[[["t"]],["t"]]],[11,"map_same","","",145,[[["self"],["f"]],["t"]]],[11,"from","","",146,[[["t"]],["t"]]],[11,"into","","",146,[[["self"]],["u"]]],[11,"try_from","","",146,[[["u"]],["result"]]],[11,"borrow","","",146,[[["self"]],["t"]]],[11,"try_into","","",146,[[["self"]],["result"]]],[11,"borrow_mut","","",146,[[["self"]],["t"]]],[11,"get_type_id","","",146,[[["self"]],["typeid"]]],[11,"not_found","","",146,[[["str"],["str"]],["e"]]],[11,"from_ok","","",146,[[["t"]],["t"]]],[11,"map_same","","",146,[[["self"],["f"]],["t"]]],[11,"from","","",147,[[["t"]],["t"]]],[11,"into","","",147,[[["self"]],["u"]]],[11,"try_from","","",147,[[["u"]],["result"]]],[11,"borrow","","",147,[[["self"]],["t"]]],[11,"try_into","","",147,[[["self"]],["result"]]],[11,"borrow_mut","","",147,[[["self"]],["t"]]],[11,"get_type_id","","",147,[[["self"]],["typeid"]]],[11,"not_found","","",147,[[["str"],["str"]],["e"]]],[11,"from_ok","","",147,[[["t"]],["t"]]],[11,"map_same","","",147,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::dataflow::at_location","",148,[[["t"]],["t"]]],[11,"into","","",148,[[["self"]],["u"]]],[11,"try_from","","",148,[[["u"]],["result"]]],[11,"borrow","","",148,[[["self"]],["t"]]],[11,"try_into","","",148,[[["self"]],["result"]]],[11,"borrow_mut","","",148,[[["self"]],["t"]]],[11,"get_type_id","","",148,[[["self"]],["typeid"]]],[11,"not_found","","",148,[[["str"],["str"]],["e"]]],[11,"from_ok","","",148,[[["t"]],["t"]]],[11,"map_same","","",148,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::dataflow::graphviz","",150,[[["t"]],["t"]]],[11,"into","","",150,[[["self"]],["u"]]],[11,"try_from","","",150,[[["u"]],["result"]]],[11,"borrow","","",150,[[["self"]],["t"]]],[11,"try_into","","",150,[[["self"]],["result"]]],[11,"borrow_mut","","",150,[[["self"]],["t"]]],[11,"get_type_id","","",150,[[["self"]],["typeid"]]],[11,"not_found","","",150,[[["str"],["str"]],["e"]]],[11,"from_ok","","",150,[[["t"]],["t"]]],[11,"map_same","","",150,[[["self"],["f"]],["t"]]],[11,"to_owned","","",151,[[["self"]],["t"]]],[11,"clone_into","","",151,N],[11,"from","","",151,[[["t"]],["t"]]],[11,"into","","",151,[[["self"]],["u"]]],[11,"try_from","","",151,[[["u"]],["result"]]],[11,"borrow","","",151,[[["self"]],["t"]]],[11,"try_into","","",151,[[["self"]],["result"]]],[11,"borrow_mut","","",151,[[["self"]],["t"]]],[11,"get_type_id","","",151,[[["self"]],["typeid"]]],[11,"not_found","","",151,[[["str"],["str"]],["e"]]],[11,"from_ok","","",151,[[["t"]],["t"]]],[11,"map_same","","",151,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::dataflow::impls","",153,[[["t"]],["t"]]],[11,"into","","",153,[[["self"]],["u"]]],[11,"try_from","","",153,[[["u"]],["result"]]],[11,"borrow","","",153,[[["self"]],["t"]]],[11,"try_into","","",153,[[["self"]],["result"]]],[11,"borrow_mut","","",153,[[["self"]],["t"]]],[11,"get_type_id","","",153,[[["self"]],["typeid"]]],[11,"not_found","","",153,[[["str"],["str"]],["e"]]],[11,"from_ok","","",153,[[["t"]],["t"]]],[11,"map_same","","",153,[[["self"],["f"]],["t"]]],[11,"from","","",154,[[["t"]],["t"]]],[11,"into","","",154,[[["self"]],["u"]]],[11,"try_from","","",154,[[["u"]],["result"]]],[11,"borrow","","",154,[[["self"]],["t"]]],[11,"try_into","","",154,[[["self"]],["result"]]],[11,"borrow_mut","","",154,[[["self"]],["t"]]],[11,"get_type_id","","",154,[[["self"]],["typeid"]]],[11,"not_found","","",154,[[["str"],["str"]],["e"]]],[11,"from_ok","","",154,[[["t"]],["t"]]],[11,"map_same","","",154,[[["self"],["f"]],["t"]]],[11,"from","","",155,[[["t"]],["t"]]],[11,"into","","",155,[[["self"]],["u"]]],[11,"try_from","","",155,[[["u"]],["result"]]],[11,"borrow","","",155,[[["self"]],["t"]]],[11,"try_into","","",155,[[["self"]],["result"]]],[11,"borrow_mut","","",155,[[["self"]],["t"]]],[11,"get_type_id","","",155,[[["self"]],["typeid"]]],[11,"not_found","","",155,[[["str"],["str"]],["e"]]],[11,"from_ok","","",155,[[["t"]],["t"]]],[11,"map_same","","",155,[[["self"],["f"]],["t"]]],[11,"from","","",156,[[["t"]],["t"]]],[11,"into","","",156,[[["self"]],["u"]]],[11,"try_from","","",156,[[["u"]],["result"]]],[11,"borrow","","",156,[[["self"]],["t"]]],[11,"try_into","","",156,[[["self"]],["result"]]],[11,"borrow_mut","","",156,[[["self"]],["t"]]],[11,"get_type_id","","",156,[[["self"]],["typeid"]]],[11,"not_found","","",156,[[["str"],["str"]],["e"]]],[11,"from_ok","","",156,[[["t"]],["t"]]],[11,"map_same","","",156,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::dataflow::impls::storage_liveness","",157,[[["self"]],["t"]]],[11,"clone_into","","",157,N],[11,"from","","",157,[[["t"]],["t"]]],[11,"into","","",157,[[["self"]],["u"]]],[11,"try_from","","",157,[[["u"]],["result"]]],[11,"borrow","","",157,[[["self"]],["t"]]],[11,"try_into","","",157,[[["self"]],["result"]]],[11,"borrow_mut","","",157,[[["self"]],["t"]]],[11,"get_type_id","","",157,[[["self"]],["typeid"]]],[11,"not_found","","",157,[[["str"],["str"]],["e"]]],[11,"from_ok","","",157,[[["t"]],["t"]]],[11,"map_same","","",157,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::dataflow::impls::borrowed_locals","",158,[[["self"]],["t"]]],[11,"clone_into","","",158,N],[11,"from","","",158,[[["t"]],["t"]]],[11,"into","","",158,[[["self"]],["u"]]],[11,"try_from","","",158,[[["u"]],["result"]]],[11,"borrow","","",158,[[["self"]],["t"]]],[11,"try_into","","",158,[[["self"]],["result"]]],[11,"borrow_mut","","",158,[[["self"]],["t"]]],[11,"get_type_id","","",158,[[["self"]],["typeid"]]],[11,"not_found","","",158,[[["str"],["str"]],["e"]]],[11,"from_ok","","",158,[[["t"]],["t"]]],[11,"map_same","","",158,[[["self"],["f"]],["t"]]],[11,"from","","",159,[[["t"]],["t"]]],[11,"into","","",159,[[["self"]],["u"]]],[11,"try_from","","",159,[[["u"]],["result"]]],[11,"borrow","","",159,[[["self"]],["t"]]],[11,"try_into","","",159,[[["self"]],["result"]]],[11,"borrow_mut","","",159,[[["self"]],["t"]]],[11,"get_type_id","","",159,[[["self"]],["typeid"]]],[11,"not_found","","",159,[[["str"],["str"]],["e"]]],[11,"from_ok","","",159,[[["t"]],["t"]]],[11,"map_same","","",159,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::dataflow::impls::borrows","",160,[[["t"]],["t"]]],[11,"into","","",160,[[["self"]],["u"]]],[11,"try_from","","",160,[[["u"]],["result"]]],[11,"borrow","","",160,[[["self"]],["t"]]],[11,"try_into","","",160,[[["self"]],["result"]]],[11,"borrow_mut","","",160,[[["self"]],["t"]]],[11,"get_type_id","","",160,[[["self"]],["typeid"]]],[11,"not_found","","",160,[[["str"],["str"]],["e"]]],[11,"from_ok","","",160,[[["t"]],["t"]]],[11,"map_same","","",160,[[["self"],["f"]],["t"]]],[11,"from","","",161,[[["t"]],["t"]]],[11,"into","","",161,[[["self"]],["u"]]],[11,"try_from","","",161,[[["u"]],["result"]]],[11,"borrow","","",161,[[["self"]],["t"]]],[11,"try_into","","",161,[[["self"]],["result"]]],[11,"borrow_mut","","",161,[[["self"]],["t"]]],[11,"get_type_id","","",161,[[["self"]],["typeid"]]],[11,"not_found","","",161,[[["str"],["str"]],["e"]]],[11,"from_ok","","",161,[[["t"]],["t"]]],[11,"map_same","","",161,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::dataflow::move_paths","",162,[[["self"]],["t"]]],[11,"clone_into","","",162,N],[11,"from","","",162,[[["t"]],["t"]]],[11,"to_string","","",162,[[["self"]],["string"]]],[11,"into","","",162,[[["self"]],["u"]]],[11,"try_from","","",162,[[["u"]],["result"]]],[11,"borrow","","",162,[[["self"]],["t"]]],[11,"try_into","","",162,[[["self"]],["result"]]],[11,"borrow_mut","","",162,[[["self"]],["t"]]],[11,"get_type_id","","",162,[[["self"]],["typeid"]]],[11,"not_found","","",162,[[["str"],["str"]],["e"]]],[11,"from_ok","","",162,[[["t"]],["t"]]],[11,"map_same","","",162,[[["self"],["f"]],["t"]]],[11,"from","","",163,[[["t"]],["t"]]],[11,"into","","",163,[[["self"]],["u"]]],[11,"try_from","","",163,[[["u"]],["result"]]],[11,"borrow","","",163,[[["self"]],["t"]]],[11,"try_into","","",163,[[["self"]],["result"]]],[11,"borrow_mut","","",163,[[["self"]],["t"]]],[11,"get_type_id","","",163,[[["self"]],["typeid"]]],[11,"not_found","","",163,[[["str"],["str"]],["e"]]],[11,"from_ok","","",163,[[["t"]],["t"]]],[11,"map_same","","",163,[[["self"],["f"]],["t"]]],[11,"from","","",164,[[["t"]],["t"]]],[11,"into","","",164,[[["self"]],["u"]]],[11,"try_from","","",164,[[["u"]],["result"]]],[11,"borrow","","",164,[[["self"]],["t"]]],[11,"try_into","","",164,[[["self"]],["result"]]],[11,"borrow_mut","","",164,[[["self"]],["t"]]],[11,"get_type_id","","",164,[[["self"]],["typeid"]]],[11,"not_found","","",164,[[["str"],["str"]],["e"]]],[11,"from_ok","","",164,[[["t"]],["t"]]],[11,"map_same","","",164,[[["self"],["f"]],["t"]]],[11,"to_owned","","",165,[[["self"]],["t"]]],[11,"clone_into","","",165,N],[11,"from","","",165,[[["t"]],["t"]]],[11,"into","","",165,[[["self"]],["u"]]],[11,"try_from","","",165,[[["u"]],["result"]]],[11,"borrow","","",165,[[["self"]],["t"]]],[11,"try_into","","",165,[[["self"]],["result"]]],[11,"borrow_mut","","",165,[[["self"]],["t"]]],[11,"get_type_id","","",165,[[["self"]],["typeid"]]],[11,"not_found","","",165,[[["str"],["str"]],["e"]]],[11,"from_ok","","",165,[[["t"]],["t"]]],[11,"map_same","","",165,[[["self"],["f"]],["t"]]],[11,"to_owned","","",166,[[["self"]],["t"]]],[11,"clone_into","","",166,N],[11,"from","","",166,[[["t"]],["t"]]],[11,"into","","",166,[[["self"]],["u"]]],[11,"try_from","","",166,[[["u"]],["result"]]],[11,"borrow","","",166,[[["self"]],["t"]]],[11,"try_into","","",166,[[["self"]],["result"]]],[11,"borrow_mut","","",166,[[["self"]],["t"]]],[11,"get_type_id","","",166,[[["self"]],["typeid"]]],[11,"not_found","","",166,[[["str"],["str"]],["e"]]],[11,"from_ok","","",166,[[["t"]],["t"]]],[11,"map_same","","",166,[[["self"],["f"]],["t"]]],[11,"from","","",167,[[["t"]],["t"]]],[11,"into","","",167,[[["self"]],["u"]]],[11,"try_from","","",167,[[["u"]],["result"]]],[11,"borrow","","",167,[[["self"]],["t"]]],[11,"try_into","","",167,[[["self"]],["result"]]],[11,"borrow_mut","","",167,[[["self"]],["t"]]],[11,"get_type_id","","",167,[[["self"]],["typeid"]]],[11,"not_found","","",167,[[["str"],["str"]],["e"]]],[11,"from_ok","","",167,[[["t"]],["t"]]],[11,"map_same","","",167,[[["self"],["f"]],["t"]]],[11,"from","","",168,[[["t"]],["t"]]],[11,"into","","",168,[[["self"]],["u"]]],[11,"try_from","","",168,[[["u"]],["result"]]],[11,"borrow","","",168,[[["self"]],["t"]]],[11,"try_into","","",168,[[["self"]],["result"]]],[11,"borrow_mut","","",168,[[["self"]],["t"]]],[11,"get_type_id","","",168,[[["self"]],["typeid"]]],[11,"not_found","","",168,[[["str"],["str"]],["e"]]],[11,"from_ok","","",168,[[["t"]],["t"]]],[11,"map_same","","",168,[[["self"],["f"]],["t"]]],[11,"to_owned","","",169,[[["self"]],["t"]]],[11,"clone_into","","",169,N],[11,"from","","",169,[[["t"]],["t"]]],[11,"into","","",169,[[["self"]],["u"]]],[11,"try_from","","",169,[[["u"]],["result"]]],[11,"borrow","","",169,[[["self"]],["t"]]],[11,"try_into","","",169,[[["self"]],["result"]]],[11,"borrow_mut","","",169,[[["self"]],["t"]]],[11,"get_type_id","","",169,[[["self"]],["typeid"]]],[11,"not_found","","",169,[[["str"],["str"]],["e"]]],[11,"from_ok","","",169,[[["t"]],["t"]]],[11,"map_same","","",169,[[["self"],["f"]],["t"]]],[11,"to_owned","","",170,[[["self"]],["t"]]],[11,"clone_into","","",170,N],[11,"from","","",170,[[["t"]],["t"]]],[11,"into","","",170,[[["self"]],["u"]]],[11,"try_from","","",170,[[["u"]],["result"]]],[11,"borrow","","",170,[[["self"]],["t"]]],[11,"try_into","","",170,[[["self"]],["result"]]],[11,"borrow_mut","","",170,[[["self"]],["t"]]],[11,"get_type_id","","",170,[[["self"]],["typeid"]]],[11,"not_found","","",170,[[["str"],["str"]],["e"]]],[11,"from_ok","","",170,[[["t"]],["t"]]],[11,"map_same","","",170,[[["self"],["f"]],["t"]]],[11,"to_owned","","",171,[[["self"]],["t"]]],[11,"clone_into","","",171,N],[11,"from","","",171,[[["t"]],["t"]]],[11,"into","","",171,[[["self"]],["u"]]],[11,"try_from","","",171,[[["u"]],["result"]]],[11,"borrow","","",171,[[["self"]],["t"]]],[11,"try_into","","",171,[[["self"]],["result"]]],[11,"borrow_mut","","",171,[[["self"]],["t"]]],[11,"get_type_id","","",171,[[["self"]],["typeid"]]],[11,"not_found","","",171,[[["str"],["str"]],["e"]]],[11,"from_ok","","",171,[[["t"]],["t"]]],[11,"map_same","","",171,[[["self"],["f"]],["t"]]],[11,"from","","",172,[[["t"]],["t"]]],[11,"into","","",172,[[["self"]],["u"]]],[11,"try_from","","",172,[[["u"]],["result"]]],[11,"borrow","","",172,[[["self"]],["t"]]],[11,"try_into","","",172,[[["self"]],["result"]]],[11,"borrow_mut","","",172,[[["self"]],["t"]]],[11,"get_type_id","","",172,[[["self"]],["typeid"]]],[11,"not_found","","",172,[[["str"],["str"]],["e"]]],[11,"from_ok","","",172,[[["t"]],["t"]]],[11,"map_same","","",172,[[["self"],["f"]],["t"]]],[11,"from","","",173,[[["t"]],["t"]]],[11,"into","","",173,[[["self"]],["u"]]],[11,"try_from","","",173,[[["u"]],["result"]]],[11,"borrow","","",173,[[["self"]],["t"]]],[11,"try_into","","",173,[[["self"]],["result"]]],[11,"borrow_mut","","",173,[[["self"]],["t"]]],[11,"get_type_id","","",173,[[["self"]],["typeid"]]],[11,"not_found","","",173,[[["str"],["str"]],["e"]]],[11,"from_ok","","",173,[[["t"]],["t"]]],[11,"map_same","","",173,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::dataflow::move_paths::abs_domain","",175,[[["self"]],["t"]]],[11,"clone_into","","",175,N],[11,"from","","",175,[[["t"]],["t"]]],[11,"into","","",175,[[["self"]],["u"]]],[11,"try_from","","",175,[[["u"]],["result"]]],[11,"borrow","","",175,[[["self"]],["t"]]],[11,"try_into","","",175,[[["self"]],["result"]]],[11,"borrow_mut","","",175,[[["self"]],["t"]]],[11,"get_type_id","","",175,[[["self"]],["typeid"]]],[11,"not_found","","",175,[[["str"],["str"]],["e"]]],[11,"from_ok","","",175,[[["t"]],["t"]]],[11,"map_same","","",175,[[["self"],["f"]],["t"]]],[11,"to_owned","","",176,[[["self"]],["t"]]],[11,"clone_into","","",176,N],[11,"from","","",176,[[["t"]],["t"]]],[11,"into","","",176,[[["self"]],["u"]]],[11,"try_from","","",176,[[["u"]],["result"]]],[11,"borrow","","",176,[[["self"]],["t"]]],[11,"try_into","","",176,[[["self"]],["result"]]],[11,"borrow_mut","","",176,[[["self"]],["t"]]],[11,"get_type_id","","",176,[[["self"]],["typeid"]]],[11,"not_found","","",176,[[["str"],["str"]],["e"]]],[11,"from_ok","","",176,[[["t"]],["t"]]],[11,"map_same","","",176,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::dataflow::move_paths::indexes","",177,[[["self"]],["t"]]],[11,"clone_into","","",177,N],[11,"from","","",177,[[["t"]],["t"]]],[11,"into","","",177,[[["self"]],["u"]]],[11,"try_from","","",177,[[["u"]],["result"]]],[11,"borrow","","",177,[[["self"]],["t"]]],[11,"try_into","","",177,[[["self"]],["result"]]],[11,"borrow_mut","","",177,[[["self"]],["t"]]],[11,"get_type_id","","",177,[[["self"]],["typeid"]]],[11,"not_found","","",177,[[["str"],["str"]],["e"]]],[11,"from_ok","","",177,[[["t"]],["t"]]],[11,"map_same","","",177,[[["self"],["f"]],["t"]]],[11,"to_owned","","",178,[[["self"]],["t"]]],[11,"clone_into","","",178,N],[11,"from","","",178,[[["t"]],["t"]]],[11,"into","","",178,[[["self"]],["u"]]],[11,"try_from","","",178,[[["u"]],["result"]]],[11,"borrow","","",178,[[["self"]],["t"]]],[11,"try_into","","",178,[[["self"]],["result"]]],[11,"borrow_mut","","",178,[[["self"]],["t"]]],[11,"get_type_id","","",178,[[["self"]],["typeid"]]],[11,"not_found","","",178,[[["str"],["str"]],["e"]]],[11,"from_ok","","",178,[[["t"]],["t"]]],[11,"map_same","","",178,[[["self"],["f"]],["t"]]],[11,"to_owned","","",179,[[["self"]],["t"]]],[11,"clone_into","","",179,N],[11,"from","","",179,[[["t"]],["t"]]],[11,"into","","",179,[[["self"]],["u"]]],[11,"try_from","","",179,[[["u"]],["result"]]],[11,"borrow","","",179,[[["self"]],["t"]]],[11,"try_into","","",179,[[["self"]],["result"]]],[11,"borrow_mut","","",179,[[["self"]],["t"]]],[11,"get_type_id","","",179,[[["self"]],["typeid"]]],[11,"not_found","","",179,[[["str"],["str"]],["e"]]],[11,"from_ok","","",179,[[["t"]],["t"]]],[11,"map_same","","",179,[[["self"],["f"]],["t"]]],[11,"to_owned","","",180,[[["self"]],["t"]]],[11,"clone_into","","",180,N],[11,"from","","",180,[[["t"]],["t"]]],[11,"into","","",180,[[["self"]],["u"]]],[11,"try_from","","",180,[[["u"]],["result"]]],[11,"borrow","","",180,[[["self"]],["t"]]],[11,"try_into","","",180,[[["self"]],["result"]]],[11,"borrow_mut","","",180,[[["self"]],["t"]]],[11,"get_type_id","","",180,[[["self"]],["typeid"]]],[11,"not_found","","",180,[[["str"],["str"]],["e"]]],[11,"from_ok","","",180,[[["t"]],["t"]]],[11,"map_same","","",180,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::dataflow::move_paths::builder","",181,[[["t"]],["t"]]],[11,"into","","",181,[[["self"]],["u"]]],[11,"try_from","","",181,[[["u"]],["result"]]],[11,"borrow","","",181,[[["self"]],["t"]]],[11,"try_into","","",181,[[["self"]],["result"]]],[11,"borrow_mut","","",181,[[["self"]],["t"]]],[11,"get_type_id","","",181,[[["self"]],["typeid"]]],[11,"not_found","","",181,[[["str"],["str"]],["e"]]],[11,"from_ok","","",181,[[["t"]],["t"]]],[11,"map_same","","",181,[[["self"],["f"]],["t"]]],[11,"from","","",182,[[["t"]],["t"]]],[11,"into","","",182,[[["self"]],["u"]]],[11,"try_from","","",182,[[["u"]],["result"]]],[11,"borrow","","",182,[[["self"]],["t"]]],[11,"try_into","","",182,[[["self"]],["result"]]],[11,"borrow_mut","","",182,[[["self"]],["t"]]],[11,"get_type_id","","",182,[[["self"]],["typeid"]]],[11,"not_found","","",182,[[["str"],["str"]],["e"]]],[11,"from_ok","","",182,[[["t"]],["t"]]],[11,"map_same","","",182,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::hair","",188,[[["self"]],["t"]]],[11,"clone_into","","",188,N],[11,"from","","",188,[[["t"]],["t"]]],[11,"into","","",188,[[["self"]],["u"]]],[11,"try_from","","",188,[[["u"]],["result"]]],[11,"borrow","","",188,[[["self"]],["t"]]],[11,"try_into","","",188,[[["self"]],["result"]]],[11,"borrow_mut","","",188,[[["self"]],["t"]]],[11,"get_type_id","","",188,[[["self"]],["typeid"]]],[11,"not_found","","",188,[[["str"],["str"]],["e"]]],[11,"from_ok","","",188,[[["t"]],["t"]]],[11,"map_same","","",188,[[["self"],["f"]],["t"]]],[11,"to_owned","","",189,[[["self"]],["t"]]],[11,"clone_into","","",189,N],[11,"from","","",189,[[["t"]],["t"]]],[11,"into","","",189,[[["self"]],["u"]]],[11,"try_from","","",189,[[["u"]],["result"]]],[11,"borrow","","",189,[[["self"]],["t"]]],[11,"try_into","","",189,[[["self"]],["result"]]],[11,"borrow_mut","","",189,[[["self"]],["t"]]],[11,"get_type_id","","",189,[[["self"]],["typeid"]]],[11,"not_found","","",189,[[["str"],["str"]],["e"]]],[11,"from_ok","","",189,[[["t"]],["t"]]],[11,"map_same","","",189,[[["self"],["f"]],["t"]]],[11,"to_owned","","",190,[[["self"]],["t"]]],[11,"clone_into","","",190,N],[11,"from","","",190,[[["t"]],["t"]]],[11,"into","","",190,[[["self"]],["u"]]],[11,"try_from","","",190,[[["u"]],["result"]]],[11,"borrow","","",190,[[["self"]],["t"]]],[11,"try_into","","",190,[[["self"]],["result"]]],[11,"borrow_mut","","",190,[[["self"]],["t"]]],[11,"get_type_id","","",190,[[["self"]],["typeid"]]],[11,"not_found","","",190,[[["str"],["str"]],["e"]]],[11,"from_ok","","",190,[[["t"]],["t"]]],[11,"map_same","","",190,[[["self"],["f"]],["t"]]],[11,"to_owned","","",191,[[["self"]],["t"]]],[11,"clone_into","","",191,N],[11,"from","","",191,[[["t"]],["t"]]],[11,"into","","",191,[[["self"]],["u"]]],[11,"try_from","","",191,[[["u"]],["result"]]],[11,"borrow","","",191,[[["self"]],["t"]]],[11,"try_into","","",191,[[["self"]],["result"]]],[11,"borrow_mut","","",191,[[["self"]],["t"]]],[11,"get_type_id","","",191,[[["self"]],["typeid"]]],[11,"not_found","","",191,[[["str"],["str"]],["e"]]],[11,"from_ok","","",191,[[["t"]],["t"]]],[11,"map_same","","",191,[[["self"],["f"]],["t"]]],[11,"to_owned","","",192,[[["self"]],["t"]]],[11,"clone_into","","",192,N],[11,"from","","",192,[[["t"]],["t"]]],[11,"into","","",192,[[["self"]],["u"]]],[11,"try_from","","",192,[[["u"]],["result"]]],[11,"borrow","","",192,[[["self"]],["t"]]],[11,"try_into","","",192,[[["self"]],["result"]]],[11,"borrow_mut","","",192,[[["self"]],["t"]]],[11,"get_type_id","","",192,[[["self"]],["typeid"]]],[11,"not_found","","",192,[[["str"],["str"]],["e"]]],[11,"from_ok","","",192,[[["t"]],["t"]]],[11,"map_same","","",192,[[["self"],["f"]],["t"]]],[11,"to_owned","","",193,[[["self"]],["t"]]],[11,"clone_into","","",193,N],[11,"from","","",193,[[["t"]],["t"]]],[11,"into","","",193,[[["self"]],["u"]]],[11,"try_from","","",193,[[["u"]],["result"]]],[11,"borrow","","",193,[[["self"]],["t"]]],[11,"try_into","","",193,[[["self"]],["result"]]],[11,"borrow_mut","","",193,[[["self"]],["t"]]],[11,"get_type_id","","",193,[[["self"]],["typeid"]]],[11,"not_found","","",193,[[["str"],["str"]],["e"]]],[11,"from_ok","","",193,[[["t"]],["t"]]],[11,"map_same","","",193,[[["self"],["f"]],["t"]]],[11,"to_owned","","",194,[[["self"]],["t"]]],[11,"clone_into","","",194,N],[11,"from","","",194,[[["t"]],["t"]]],[11,"into","","",194,[[["self"]],["u"]]],[11,"try_from","","",194,[[["u"]],["result"]]],[11,"borrow","","",194,[[["self"]],["t"]]],[11,"try_into","","",194,[[["self"]],["result"]]],[11,"borrow_mut","","",194,[[["self"]],["t"]]],[11,"get_type_id","","",194,[[["self"]],["typeid"]]],[11,"not_found","","",194,[[["str"],["str"]],["e"]]],[11,"from_ok","","",194,[[["t"]],["t"]]],[11,"map_same","","",194,[[["self"],["f"]],["t"]]],[11,"to_owned","","",195,[[["self"]],["t"]]],[11,"clone_into","","",195,N],[11,"from","","",195,[[["t"]],["t"]]],[11,"into","","",195,[[["self"]],["u"]]],[11,"try_from","","",195,[[["u"]],["result"]]],[11,"borrow","","",195,[[["self"]],["t"]]],[11,"try_into","","",195,[[["self"]],["result"]]],[11,"borrow_mut","","",195,[[["self"]],["t"]]],[11,"get_type_id","","",195,[[["self"]],["typeid"]]],[11,"not_found","","",195,[[["str"],["str"]],["e"]]],[11,"from_ok","","",195,[[["t"]],["t"]]],[11,"map_same","","",195,[[["self"],["f"]],["t"]]],[11,"to_owned","","",196,[[["self"]],["t"]]],[11,"clone_into","","",196,N],[11,"from","","",196,[[["t"]],["t"]]],[11,"into","","",196,[[["self"]],["u"]]],[11,"try_from","","",196,[[["u"]],["result"]]],[11,"borrow","","",196,[[["self"]],["t"]]],[11,"try_into","","",196,[[["self"]],["result"]]],[11,"borrow_mut","","",196,[[["self"]],["t"]]],[11,"get_type_id","","",196,[[["self"]],["typeid"]]],[11,"not_found","","",196,[[["str"],["str"]],["e"]]],[11,"from_ok","","",196,[[["t"]],["t"]]],[11,"map_same","","",196,[[["self"],["f"]],["t"]]],[11,"to_owned","","",197,[[["self"]],["t"]]],[11,"clone_into","","",197,N],[11,"from","","",197,[[["t"]],["t"]]],[11,"into","","",197,[[["self"]],["u"]]],[11,"try_from","","",197,[[["u"]],["result"]]],[11,"borrow","","",197,[[["self"]],["t"]]],[11,"try_into","","",197,[[["self"]],["result"]]],[11,"borrow_mut","","",197,[[["self"]],["t"]]],[11,"get_type_id","","",197,[[["self"]],["typeid"]]],[11,"not_found","","",197,[[["str"],["str"]],["e"]]],[11,"from_ok","","",197,[[["t"]],["t"]]],[11,"map_same","","",197,[[["self"],["f"]],["t"]]],[11,"to_owned","","",198,[[["self"]],["t"]]],[11,"clone_into","","",198,N],[11,"from","","",198,[[["t"]],["t"]]],[11,"into","","",198,[[["self"]],["u"]]],[11,"try_from","","",198,[[["u"]],["result"]]],[11,"borrow","","",198,[[["self"]],["t"]]],[11,"try_into","","",198,[[["self"]],["result"]]],[11,"borrow_mut","","",198,[[["self"]],["t"]]],[11,"get_type_id","","",198,[[["self"]],["typeid"]]],[11,"not_found","","",198,[[["str"],["str"]],["e"]]],[11,"from_ok","","",198,[[["t"]],["t"]]],[11,"map_same","","",198,[[["self"],["f"]],["t"]]],[11,"to_owned","","",199,[[["self"]],["t"]]],[11,"clone_into","","",199,N],[11,"from","","",199,[[["t"]],["t"]]],[11,"into","","",199,[[["self"]],["u"]]],[11,"try_from","","",199,[[["u"]],["result"]]],[11,"borrow","","",199,[[["self"]],["t"]]],[11,"try_into","","",199,[[["self"]],["result"]]],[11,"borrow_mut","","",199,[[["self"]],["t"]]],[11,"get_type_id","","",199,[[["self"]],["typeid"]]],[11,"not_found","","",199,[[["str"],["str"]],["e"]]],[11,"from_ok","","",199,[[["t"]],["t"]]],[11,"map_same","","",199,[[["self"],["f"]],["t"]]],[11,"to_owned","","",200,[[["self"]],["t"]]],[11,"clone_into","","",200,N],[11,"from","","",200,[[["t"]],["t"]]],[11,"into","","",200,[[["self"]],["u"]]],[11,"try_from","","",200,[[["u"]],["result"]]],[11,"borrow","","",200,[[["self"]],["t"]]],[11,"try_into","","",200,[[["self"]],["result"]]],[11,"borrow_mut","","",200,[[["self"]],["t"]]],[11,"get_type_id","","",200,[[["self"]],["typeid"]]],[11,"not_found","","",200,[[["str"],["str"]],["e"]]],[11,"from_ok","","",200,[[["t"]],["t"]]],[11,"map_same","","",200,[[["self"],["f"]],["t"]]],[11,"to_owned","","",201,[[["self"]],["t"]]],[11,"clone_into","","",201,N],[11,"from","","",201,[[["t"]],["t"]]],[11,"into","","",201,[[["self"]],["u"]]],[11,"try_from","","",201,[[["u"]],["result"]]],[11,"borrow","","",201,[[["self"]],["t"]]],[11,"try_into","","",201,[[["self"]],["result"]]],[11,"borrow_mut","","",201,[[["self"]],["t"]]],[11,"get_type_id","","",201,[[["self"]],["typeid"]]],[11,"not_found","","",201,[[["str"],["str"]],["e"]]],[11,"from_ok","","",201,[[["t"]],["t"]]],[11,"map_same","","",201,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::hair::cx","",202,[[["self"]],["t"]]],[11,"clone_into","","",202,N],[11,"from","","",202,[[["t"]],["t"]]],[11,"into","","",202,[[["self"]],["u"]]],[11,"try_from","","",202,[[["u"]],["result"]]],[11,"borrow","","",202,[[["self"]],["t"]]],[11,"try_into","","",202,[[["self"]],["result"]]],[11,"borrow_mut","","",202,[[["self"]],["t"]]],[11,"get_type_id","","",202,[[["self"]],["typeid"]]],[11,"not_found","","",202,[[["str"],["str"]],["e"]]],[11,"from_ok","","",202,[[["t"]],["t"]]],[11,"map_same","","",202,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::hair::pattern","",205,[[["self"]],["t"]]],[11,"clone_into","","",205,N],[11,"from","","",205,[[["t"]],["t"]]],[11,"into","","",205,[[["self"]],["u"]]],[11,"try_from","","",205,[[["u"]],["result"]]],[11,"borrow","","",205,[[["self"]],["t"]]],[11,"try_into","","",205,[[["self"]],["result"]]],[11,"borrow_mut","","",205,[[["self"]],["t"]]],[11,"get_type_id","","",205,[[["self"]],["typeid"]]],[11,"not_found","","",205,[[["str"],["str"]],["e"]]],[11,"from_ok","","",205,[[["t"]],["t"]]],[11,"map_same","","",205,[[["self"],["f"]],["t"]]],[11,"to_owned","","",206,[[["self"]],["t"]]],[11,"clone_into","","",206,N],[11,"from","","",206,[[["t"]],["t"]]],[11,"to_string","","",206,[[["self"]],["string"]]],[11,"into","","",206,[[["self"]],["u"]]],[11,"try_from","","",206,[[["u"]],["result"]]],[11,"borrow","","",206,[[["self"]],["t"]]],[11,"try_into","","",206,[[["self"]],["result"]]],[11,"borrow_mut","","",206,[[["self"]],["t"]]],[11,"get_type_id","","",206,[[["self"]],["typeid"]]],[11,"not_found","","",206,[[["str"],["str"]],["e"]]],[11,"from_ok","","",206,[[["t"]],["t"]]],[11,"map_same","","",206,[[["self"],["f"]],["t"]]],[11,"from","","",207,[[["t"]],["t"]]],[11,"into","","",207,[[["self"]],["u"]]],[11,"try_from","","",207,[[["u"]],["result"]]],[11,"borrow","","",207,[[["self"]],["t"]]],[11,"try_into","","",207,[[["self"]],["result"]]],[11,"borrow_mut","","",207,[[["self"]],["t"]]],[11,"get_type_id","","",207,[[["self"]],["typeid"]]],[11,"not_found","","",207,[[["str"],["str"]],["e"]]],[11,"from_ok","","",207,[[["t"]],["t"]]],[11,"map_same","","",207,[[["self"],["f"]],["t"]]],[11,"to_owned","","",208,[[["self"]],["t"]]],[11,"clone_into","","",208,N],[11,"from","","",208,[[["t"]],["t"]]],[11,"into","","",208,[[["self"]],["u"]]],[11,"try_from","","",208,[[["u"]],["result"]]],[11,"borrow","","",208,[[["self"]],["t"]]],[11,"try_into","","",208,[[["self"]],["result"]]],[11,"borrow_mut","","",208,[[["self"]],["t"]]],[11,"get_type_id","","",208,[[["self"]],["typeid"]]],[11,"not_found","","",208,[[["str"],["str"]],["e"]]],[11,"from_ok","","",208,[[["t"]],["t"]]],[11,"map_same","","",208,[[["self"],["f"]],["t"]]],[11,"to_owned","","",209,[[["self"]],["t"]]],[11,"clone_into","","",209,N],[11,"from","","",209,[[["t"]],["t"]]],[11,"into","","",209,[[["self"]],["u"]]],[11,"try_from","","",209,[[["u"]],["result"]]],[11,"borrow","","",209,[[["self"]],["t"]]],[11,"try_into","","",209,[[["self"]],["result"]]],[11,"borrow_mut","","",209,[[["self"]],["t"]]],[11,"get_type_id","","",209,[[["self"]],["typeid"]]],[11,"not_found","","",209,[[["str"],["str"]],["e"]]],[11,"from_ok","","",209,[[["t"]],["t"]]],[11,"map_same","","",209,[[["self"],["f"]],["t"]]],[11,"to_owned","","",210,[[["self"]],["t"]]],[11,"clone_into","","",210,N],[11,"from","","",210,[[["t"]],["t"]]],[11,"into","","",210,[[["self"]],["u"]]],[11,"try_from","","",210,[[["u"]],["result"]]],[11,"borrow","","",210,[[["self"]],["t"]]],[11,"try_into","","",210,[[["self"]],["result"]]],[11,"borrow_mut","","",210,[[["self"]],["t"]]],[11,"get_type_id","","",210,[[["self"]],["typeid"]]],[11,"not_found","","",210,[[["str"],["str"]],["e"]]],[11,"from_ok","","",210,[[["t"]],["t"]]],[11,"map_same","","",210,[[["self"],["f"]],["t"]]],[11,"from","","",211,[[["t"]],["t"]]],[11,"into","","",211,[[["self"]],["u"]]],[11,"try_from","","",211,[[["u"]],["result"]]],[11,"borrow","","",211,[[["self"]],["t"]]],[11,"try_into","","",211,[[["self"]],["result"]]],[11,"borrow_mut","","",211,[[["self"]],["t"]]],[11,"get_type_id","","",211,[[["self"]],["typeid"]]],[11,"not_found","","",211,[[["str"],["str"]],["e"]]],[11,"from_ok","","",211,[[["t"]],["t"]]],[11,"map_same","","",211,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::hair::pattern::_match","",220,[[["t"]],["t"]]],[11,"into","","",220,[[["self"]],["u"]]],[11,"try_from","","",220,[[["u"]],["result"]]],[11,"borrow","","",220,[[["self"]],["t"]]],[11,"try_into","","",220,[[["self"]],["result"]]],[11,"borrow_mut","","",220,[[["self"]],["t"]]],[11,"get_type_id","","",220,[[["self"]],["typeid"]]],[11,"not_found","","",220,[[["str"],["str"]],["e"]]],[11,"from_ok","","",220,[[["t"]],["t"]]],[11,"map_same","","",220,[[["self"],["f"]],["t"]]],[11,"from","","",212,[[["t"]],["t"]]],[11,"into","","",212,[[["self"]],["u"]]],[11,"try_from","","",212,[[["u"]],["result"]]],[11,"borrow","","",212,[[["self"]],["t"]]],[11,"try_into","","",212,[[["self"]],["result"]]],[11,"borrow_mut","","",212,[[["self"]],["t"]]],[11,"get_type_id","","",212,[[["self"]],["typeid"]]],[11,"not_found","","",212,[[["str"],["str"]],["e"]]],[11,"from_ok","","",212,[[["t"]],["t"]]],[11,"map_same","","",212,[[["self"],["f"]],["t"]]],[11,"from","","",213,[[["t"]],["t"]]],[11,"into","","",213,[[["self"]],["u"]]],[11,"try_from","","",213,[[["u"]],["result"]]],[11,"borrow","","",213,[[["self"]],["t"]]],[11,"try_into","","",213,[[["self"]],["result"]]],[11,"borrow_mut","","",213,[[["self"]],["t"]]],[11,"get_type_id","","",213,[[["self"]],["typeid"]]],[11,"not_found","","",213,[[["str"],["str"]],["e"]]],[11,"from_ok","","",213,[[["t"]],["t"]]],[11,"map_same","","",213,[[["self"],["f"]],["t"]]],[11,"to_owned","","",214,[[["self"]],["t"]]],[11,"clone_into","","",214,N],[11,"from","","",214,[[["t"]],["t"]]],[11,"into","","",214,[[["self"]],["u"]]],[11,"try_from","","",214,[[["u"]],["result"]]],[11,"borrow","","",214,[[["self"]],["t"]]],[11,"try_into","","",214,[[["self"]],["result"]]],[11,"borrow_mut","","",214,[[["self"]],["t"]]],[11,"get_type_id","","",214,[[["self"]],["typeid"]]],[11,"not_found","","",214,[[["str"],["str"]],["e"]]],[11,"from_ok","","",214,[[["t"]],["t"]]],[11,"map_same","","",214,[[["self"],["f"]],["t"]]],[11,"to_owned","","",215,[[["self"]],["t"]]],[11,"clone_into","","",215,N],[11,"from","","",215,[[["t"]],["t"]]],[11,"into","","",215,[[["self"]],["u"]]],[11,"try_from","","",215,[[["u"]],["result"]]],[11,"borrow","","",215,[[["self"]],["t"]]],[11,"try_into","","",215,[[["self"]],["result"]]],[11,"borrow_mut","","",215,[[["self"]],["t"]]],[11,"get_type_id","","",215,[[["self"]],["typeid"]]],[11,"not_found","","",215,[[["str"],["str"]],["e"]]],[11,"from_ok","","",215,[[["t"]],["t"]]],[11,"map_same","","",215,[[["self"],["f"]],["t"]]],[11,"to_owned","","",216,[[["self"]],["t"]]],[11,"clone_into","","",216,N],[11,"from","","",216,[[["t"]],["t"]]],[11,"into","","",216,[[["self"]],["u"]]],[11,"try_from","","",216,[[["u"]],["result"]]],[11,"borrow","","",216,[[["self"]],["t"]]],[11,"try_into","","",216,[[["self"]],["result"]]],[11,"borrow_mut","","",216,[[["self"]],["t"]]],[11,"get_type_id","","",216,[[["self"]],["typeid"]]],[11,"not_found","","",216,[[["str"],["str"]],["e"]]],[11,"from_ok","","",216,[[["t"]],["t"]]],[11,"map_same","","",216,[[["self"],["f"]],["t"]]],[11,"to_owned","","",217,[[["self"]],["t"]]],[11,"clone_into","","",217,N],[11,"from","","",217,[[["t"]],["t"]]],[11,"into","","",217,[[["self"]],["u"]]],[11,"try_from","","",217,[[["u"]],["result"]]],[11,"borrow","","",217,[[["self"]],["t"]]],[11,"try_into","","",217,[[["self"]],["result"]]],[11,"borrow_mut","","",217,[[["self"]],["t"]]],[11,"get_type_id","","",217,[[["self"]],["typeid"]]],[11,"not_found","","",217,[[["str"],["str"]],["e"]]],[11,"from_ok","","",217,[[["t"]],["t"]]],[11,"map_same","","",217,[[["self"],["f"]],["t"]]],[11,"to_owned","","",218,[[["self"]],["t"]]],[11,"clone_into","","",218,N],[11,"from","","",218,[[["t"]],["t"]]],[11,"into","","",218,[[["self"]],["u"]]],[11,"try_from","","",218,[[["u"]],["result"]]],[11,"borrow","","",218,[[["self"]],["t"]]],[11,"try_into","","",218,[[["self"]],["result"]]],[11,"borrow_mut","","",218,[[["self"]],["t"]]],[11,"get_type_id","","",218,[[["self"]],["typeid"]]],[11,"not_found","","",218,[[["str"],["str"]],["e"]]],[11,"from_ok","","",218,[[["t"]],["t"]]],[11,"map_same","","",218,[[["self"],["f"]],["t"]]],[11,"to_owned","","",219,[[["self"]],["t"]]],[11,"clone_into","","",219,N],[11,"from","","",219,[[["t"]],["t"]]],[11,"into","","",219,[[["self"]],["u"]]],[11,"try_from","","",219,[[["u"]],["result"]]],[11,"borrow","","",219,[[["self"]],["t"]]],[11,"try_into","","",219,[[["self"]],["result"]]],[11,"borrow_mut","","",219,[[["self"]],["t"]]],[11,"get_type_id","","",219,[[["self"]],["typeid"]]],[11,"not_found","","",219,[[["str"],["str"]],["e"]]],[11,"from_ok","","",219,[[["t"]],["t"]]],[11,"map_same","","",219,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::hair::pattern::check_match","",221,[[["t"]],["t"]]],[11,"into","","",221,[[["self"]],["u"]]],[11,"try_from","","",221,[[["u"]],["result"]]],[11,"borrow","","",221,[[["self"]],["t"]]],[11,"try_into","","",221,[[["self"]],["result"]]],[11,"borrow_mut","","",221,[[["self"]],["t"]]],[11,"get_type_id","","",221,[[["self"]],["typeid"]]],[11,"not_found","","",221,[[["str"],["str"]],["e"]]],[11,"from_ok","","",221,[[["t"]],["t"]]],[11,"map_same","","",221,[[["self"],["f"]],["t"]]],[11,"from","","",222,[[["t"]],["t"]]],[11,"into","","",222,[[["self"]],["u"]]],[11,"try_from","","",222,[[["u"]],["result"]]],[11,"borrow","","",222,[[["self"]],["t"]]],[11,"try_into","","",222,[[["self"]],["result"]]],[11,"borrow_mut","","",222,[[["self"]],["t"]]],[11,"get_type_id","","",222,[[["self"]],["typeid"]]],[11,"not_found","","",222,[[["str"],["str"]],["e"]]],[11,"from_ok","","",222,[[["t"]],["t"]]],[11,"map_same","","",222,[[["self"],["f"]],["t"]]],[11,"from","","",223,[[["t"]],["t"]]],[11,"into","","",223,[[["self"]],["u"]]],[11,"try_from","","",223,[[["u"]],["result"]]],[11,"borrow","","",223,[[["self"]],["t"]]],[11,"try_into","","",223,[[["self"]],["result"]]],[11,"borrow_mut","","",223,[[["self"]],["t"]]],[11,"get_type_id","","",223,[[["self"]],["typeid"]]],[11,"not_found","","",223,[[["str"],["str"]],["e"]]],[11,"from_ok","","",223,[[["t"]],["t"]]],[11,"map_same","","",223,[[["self"],["f"]],["t"]]],[11,"from","","",224,[[["t"]],["t"]]],[11,"into","","",224,[[["self"]],["u"]]],[11,"try_from","","",224,[[["u"]],["result"]]],[11,"borrow","","",224,[[["self"]],["t"]]],[11,"try_into","","",224,[[["self"]],["result"]]],[11,"borrow_mut","","",224,[[["self"]],["t"]]],[11,"get_type_id","","",224,[[["self"]],["typeid"]]],[11,"not_found","","",224,[[["str"],["str"]],["e"]]],[11,"from_ok","","",224,[[["t"]],["t"]]],[11,"map_same","","",224,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::shim","",228,[[["t"]],["t"]]],[11,"into","","",228,[[["self"]],["u"]]],[11,"try_from","","",228,[[["u"]],["result"]]],[11,"borrow","","",228,[[["self"]],["t"]]],[11,"try_into","","",228,[[["self"]],["result"]]],[11,"borrow_mut","","",228,[[["self"]],["t"]]],[11,"get_type_id","","",228,[[["self"]],["typeid"]]],[11,"not_found","","",228,[[["str"],["str"]],["e"]]],[11,"from_ok","","",228,[[["t"]],["t"]]],[11,"map_same","","",228,[[["self"],["f"]],["t"]]],[11,"from","","",229,[[["t"]],["t"]]],[11,"into","","",229,[[["self"]],["u"]]],[11,"try_from","","",229,[[["u"]],["result"]]],[11,"borrow","","",229,[[["self"]],["t"]]],[11,"try_into","","",229,[[["self"]],["result"]]],[11,"borrow_mut","","",229,[[["self"]],["t"]]],[11,"get_type_id","","",229,[[["self"]],["typeid"]]],[11,"not_found","","",229,[[["str"],["str"]],["e"]]],[11,"from_ok","","",229,[[["t"]],["t"]]],[11,"map_same","","",229,[[["self"],["f"]],["t"]]],[11,"to_owned","","",230,[[["self"]],["t"]]],[11,"clone_into","","",230,N],[11,"from","","",230,[[["t"]],["t"]]],[11,"into","","",230,[[["self"]],["u"]]],[11,"try_from","","",230,[[["u"]],["result"]]],[11,"borrow","","",230,[[["self"]],["t"]]],[11,"try_into","","",230,[[["self"]],["result"]]],[11,"borrow_mut","","",230,[[["self"]],["t"]]],[11,"get_type_id","","",230,[[["self"]],["typeid"]]],[11,"not_found","","",230,[[["str"],["str"]],["e"]]],[11,"from_ok","","",230,[[["t"]],["t"]]],[11,"map_same","","",230,[[["self"],["f"]],["t"]]],[11,"to_owned","","",231,[[["self"]],["t"]]],[11,"clone_into","","",231,N],[11,"from","","",231,[[["t"]],["t"]]],[11,"into","","",231,[[["self"]],["u"]]],[11,"try_from","","",231,[[["u"]],["result"]]],[11,"borrow","","",231,[[["self"]],["t"]]],[11,"try_into","","",231,[[["self"]],["result"]]],[11,"borrow_mut","","",231,[[["self"]],["t"]]],[11,"get_type_id","","",231,[[["self"]],["typeid"]]],[11,"not_found","","",231,[[["str"],["str"]],["e"]]],[11,"from_ok","","",231,[[["t"]],["t"]]],[11,"map_same","","",231,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::transform","",232,[[["self"]],["t"]]],[11,"clone_into","","",232,N],[11,"from","","",232,[[["t"]],["t"]]],[11,"into","","",232,[[["self"]],["u"]]],[11,"try_from","","",232,[[["u"]],["result"]]],[11,"borrow","","",232,[[["self"]],["t"]]],[11,"try_into","","",232,[[["self"]],["result"]]],[11,"borrow_mut","","",232,[[["self"]],["t"]]],[11,"get_type_id","","",232,[[["self"]],["typeid"]]],[11,"not_found","","",232,[[["str"],["str"]],["e"]]],[11,"from_ok","","",232,[[["t"]],["t"]]],[11,"map_same","","",232,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::add_validation","",233,[[["t"]],["t"]]],[11,"into","","",233,[[["self"]],["u"]]],[11,"try_from","","",233,[[["u"]],["result"]]],[11,"borrow","","",233,[[["self"]],["t"]]],[11,"try_into","","",233,[[["self"]],["result"]]],[11,"borrow_mut","","",233,[[["self"]],["t"]]],[11,"get_type_id","","",233,[[["self"]],["typeid"]]],[11,"not_found","","",233,[[["str"],["str"]],["e"]]],[11,"from_ok","","",233,[[["t"]],["t"]]],[11,"map_same","","",233,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::add_moves_for_packed_drops","",234,[[["t"]],["t"]]],[11,"into","","",234,[[["self"]],["u"]]],[11,"try_from","","",234,[[["u"]],["result"]]],[11,"borrow","","",234,[[["self"]],["t"]]],[11,"try_into","","",234,[[["self"]],["result"]]],[11,"borrow_mut","","",234,[[["self"]],["t"]]],[11,"get_type_id","","",234,[[["self"]],["typeid"]]],[11,"not_found","","",234,[[["str"],["str"]],["e"]]],[11,"from_ok","","",234,[[["t"]],["t"]]],[11,"map_same","","",234,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::cleanup_post_borrowck","",237,[[["t"]],["t"]]],[11,"into","","",237,[[["self"]],["u"]]],[11,"try_from","","",237,[[["u"]],["result"]]],[11,"borrow","","",237,[[["self"]],["t"]]],[11,"try_into","","",237,[[["self"]],["result"]]],[11,"borrow_mut","","",237,[[["self"]],["t"]]],[11,"get_type_id","","",237,[[["self"]],["typeid"]]],[11,"not_found","","",237,[[["str"],["str"]],["e"]]],[11,"from_ok","","",237,[[["t"]],["t"]]],[11,"map_same","","",237,[[["self"],["f"]],["t"]]],[11,"from","","",235,[[["t"]],["t"]]],[11,"into","","",235,[[["self"]],["u"]]],[11,"try_from","","",235,[[["u"]],["result"]]],[11,"borrow","","",235,[[["self"]],["t"]]],[11,"try_into","","",235,[[["self"]],["result"]]],[11,"borrow_mut","","",235,[[["self"]],["t"]]],[11,"get_type_id","","",235,[[["self"]],["typeid"]]],[11,"not_found","","",235,[[["str"],["str"]],["e"]]],[11,"from_ok","","",235,[[["t"]],["t"]]],[11,"map_same","","",235,[[["self"],["f"]],["t"]]],[11,"from","","",236,[[["t"]],["t"]]],[11,"into","","",236,[[["self"]],["u"]]],[11,"try_from","","",236,[[["u"]],["result"]]],[11,"borrow","","",236,[[["self"]],["t"]]],[11,"try_into","","",236,[[["self"]],["result"]]],[11,"borrow_mut","","",236,[[["self"]],["t"]]],[11,"get_type_id","","",236,[[["self"]],["typeid"]]],[11,"not_found","","",236,[[["str"],["str"]],["e"]]],[11,"from_ok","","",236,[[["t"]],["t"]]],[11,"map_same","","",236,[[["self"],["f"]],["t"]]],[11,"from","","",238,[[["t"]],["t"]]],[11,"into","","",238,[[["self"]],["u"]]],[11,"try_from","","",238,[[["u"]],["result"]]],[11,"borrow","","",238,[[["self"]],["t"]]],[11,"try_into","","",238,[[["self"]],["result"]]],[11,"borrow_mut","","",238,[[["self"]],["t"]]],[11,"get_type_id","","",238,[[["self"]],["typeid"]]],[11,"not_found","","",238,[[["str"],["str"]],["e"]]],[11,"from_ok","","",238,[[["t"]],["t"]]],[11,"map_same","","",238,[[["self"],["f"]],["t"]]],[11,"from","","",239,[[["t"]],["t"]]],[11,"into","","",239,[[["self"]],["u"]]],[11,"try_from","","",239,[[["u"]],["result"]]],[11,"borrow","","",239,[[["self"]],["t"]]],[11,"try_into","","",239,[[["self"]],["result"]]],[11,"borrow_mut","","",239,[[["self"]],["t"]]],[11,"get_type_id","","",239,[[["self"]],["typeid"]]],[11,"not_found","","",239,[[["str"],["str"]],["e"]]],[11,"from_ok","","",239,[[["t"]],["t"]]],[11,"map_same","","",239,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::check_unsafety","",240,[[["t"]],["t"]]],[11,"into","","",240,[[["self"]],["u"]]],[11,"try_from","","",240,[[["u"]],["result"]]],[11,"borrow","","",240,[[["self"]],["t"]]],[11,"try_into","","",240,[[["self"]],["result"]]],[11,"borrow_mut","","",240,[[["self"]],["t"]]],[11,"get_type_id","","",240,[[["self"]],["typeid"]]],[11,"not_found","","",240,[[["str"],["str"]],["e"]]],[11,"from_ok","","",240,[[["t"]],["t"]]],[11,"map_same","","",240,[[["self"],["f"]],["t"]]],[11,"from","","",241,[[["t"]],["t"]]],[11,"into","","",241,[[["self"]],["u"]]],[11,"try_from","","",241,[[["u"]],["result"]]],[11,"borrow","","",241,[[["self"]],["t"]]],[11,"try_into","","",241,[[["self"]],["result"]]],[11,"borrow_mut","","",241,[[["self"]],["t"]]],[11,"get_type_id","","",241,[[["self"]],["typeid"]]],[11,"not_found","","",241,[[["str"],["str"]],["e"]]],[11,"from_ok","","",241,[[["t"]],["t"]]],[11,"map_same","","",241,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::simplify_branches","",242,[[["t"]],["t"]]],[11,"into","","",242,[[["self"]],["u"]]],[11,"try_from","","",242,[[["u"]],["result"]]],[11,"borrow","","",242,[[["self"]],["t"]]],[11,"try_into","","",242,[[["self"]],["result"]]],[11,"borrow_mut","","",242,[[["self"]],["t"]]],[11,"get_type_id","","",242,[[["self"]],["typeid"]]],[11,"not_found","","",242,[[["str"],["str"]],["e"]]],[11,"from_ok","","",242,[[["t"]],["t"]]],[11,"map_same","","",242,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::simplify","",243,[[["t"]],["t"]]],[11,"into","","",243,[[["self"]],["u"]]],[11,"try_from","","",243,[[["u"]],["result"]]],[11,"borrow","","",243,[[["self"]],["t"]]],[11,"try_into","","",243,[[["self"]],["result"]]],[11,"borrow_mut","","",243,[[["self"]],["t"]]],[11,"get_type_id","","",243,[[["self"]],["typeid"]]],[11,"not_found","","",243,[[["str"],["str"]],["e"]]],[11,"from_ok","","",243,[[["t"]],["t"]]],[11,"map_same","","",243,[[["self"],["f"]],["t"]]],[11,"from","","",244,[[["t"]],["t"]]],[11,"into","","",244,[[["self"]],["u"]]],[11,"try_from","","",244,[[["u"]],["result"]]],[11,"borrow","","",244,[[["self"]],["t"]]],[11,"try_into","","",244,[[["self"]],["result"]]],[11,"borrow_mut","","",244,[[["self"]],["t"]]],[11,"get_type_id","","",244,[[["self"]],["typeid"]]],[11,"not_found","","",244,[[["str"],["str"]],["e"]]],[11,"from_ok","","",244,[[["t"]],["t"]]],[11,"map_same","","",244,[[["self"],["f"]],["t"]]],[11,"from","","",247,[[["t"]],["t"]]],[11,"into","","",247,[[["self"]],["u"]]],[11,"try_from","","",247,[[["u"]],["result"]]],[11,"borrow","","",247,[[["self"]],["t"]]],[11,"try_into","","",247,[[["self"]],["result"]]],[11,"borrow_mut","","",247,[[["self"]],["t"]]],[11,"get_type_id","","",247,[[["self"]],["typeid"]]],[11,"not_found","","",247,[[["str"],["str"]],["e"]]],[11,"from_ok","","",247,[[["t"]],["t"]]],[11,"map_same","","",247,[[["self"],["f"]],["t"]]],[11,"from","","",245,[[["t"]],["t"]]],[11,"into","","",245,[[["self"]],["u"]]],[11,"try_from","","",245,[[["u"]],["result"]]],[11,"borrow","","",245,[[["self"]],["t"]]],[11,"try_into","","",245,[[["self"]],["result"]]],[11,"borrow_mut","","",245,[[["self"]],["t"]]],[11,"get_type_id","","",245,[[["self"]],["typeid"]]],[11,"not_found","","",245,[[["str"],["str"]],["e"]]],[11,"from_ok","","",245,[[["t"]],["t"]]],[11,"map_same","","",245,[[["self"],["f"]],["t"]]],[11,"from","","",246,[[["t"]],["t"]]],[11,"into","","",246,[[["self"]],["u"]]],[11,"try_from","","",246,[[["u"]],["result"]]],[11,"borrow","","",246,[[["self"]],["t"]]],[11,"try_into","","",246,[[["self"]],["result"]]],[11,"borrow_mut","","",246,[[["self"]],["t"]]],[11,"get_type_id","","",246,[[["self"]],["typeid"]]],[11,"not_found","","",246,[[["str"],["str"]],["e"]]],[11,"from_ok","","",246,[[["t"]],["t"]]],[11,"map_same","","",246,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::erase_regions","",248,[[["t"]],["t"]]],[11,"into","","",248,[[["self"]],["u"]]],[11,"try_from","","",248,[[["u"]],["result"]]],[11,"borrow","","",248,[[["self"]],["t"]]],[11,"try_into","","",248,[[["self"]],["result"]]],[11,"borrow_mut","","",248,[[["self"]],["t"]]],[11,"get_type_id","","",248,[[["self"]],["typeid"]]],[11,"not_found","","",248,[[["str"],["str"]],["e"]]],[11,"from_ok","","",248,[[["t"]],["t"]]],[11,"map_same","","",248,[[["self"],["f"]],["t"]]],[11,"from","","",249,[[["t"]],["t"]]],[11,"into","","",249,[[["self"]],["u"]]],[11,"try_from","","",249,[[["u"]],["result"]]],[11,"borrow","","",249,[[["self"]],["t"]]],[11,"try_into","","",249,[[["self"]],["result"]]],[11,"borrow_mut","","",249,[[["self"]],["t"]]],[11,"get_type_id","","",249,[[["self"]],["typeid"]]],[11,"not_found","","",249,[[["str"],["str"]],["e"]]],[11,"from_ok","","",249,[[["t"]],["t"]]],[11,"map_same","","",249,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::no_landing_pads","",250,[[["t"]],["t"]]],[11,"into","","",250,[[["self"]],["u"]]],[11,"try_from","","",250,[[["u"]],["result"]]],[11,"borrow","","",250,[[["self"]],["t"]]],[11,"try_into","","",250,[[["self"]],["result"]]],[11,"borrow_mut","","",250,[[["self"]],["t"]]],[11,"get_type_id","","",250,[[["self"]],["typeid"]]],[11,"not_found","","",250,[[["str"],["str"]],["e"]]],[11,"from_ok","","",250,[[["t"]],["t"]]],[11,"map_same","","",250,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::rustc_peek","",251,[[["t"]],["t"]]],[11,"into","","",251,[[["self"]],["u"]]],[11,"try_from","","",251,[[["u"]],["result"]]],[11,"borrow","","",251,[[["self"]],["t"]]],[11,"try_into","","",251,[[["self"]],["result"]]],[11,"borrow_mut","","",251,[[["self"]],["t"]]],[11,"get_type_id","","",251,[[["self"]],["typeid"]]],[11,"not_found","","",251,[[["str"],["str"]],["e"]]],[11,"from_ok","","",251,[[["t"]],["t"]]],[11,"map_same","","",251,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::elaborate_drops","",255,[[["t"]],["t"]]],[11,"into","","",255,[[["self"]],["u"]]],[11,"try_from","","",255,[[["u"]],["result"]]],[11,"borrow","","",255,[[["self"]],["t"]]],[11,"try_into","","",255,[[["self"]],["result"]]],[11,"borrow_mut","","",255,[[["self"]],["t"]]],[11,"get_type_id","","",255,[[["self"]],["typeid"]]],[11,"not_found","","",255,[[["str"],["str"]],["e"]]],[11,"from_ok","","",255,[[["t"]],["t"]]],[11,"map_same","","",255,[[["self"],["f"]],["t"]]],[11,"from","","",252,[[["t"]],["t"]]],[11,"into","","",252,[[["self"]],["u"]]],[11,"try_from","","",252,[[["u"]],["result"]]],[11,"borrow","","",252,[[["self"]],["t"]]],[11,"try_into","","",252,[[["self"]],["result"]]],[11,"borrow_mut","","",252,[[["self"]],["t"]]],[11,"get_type_id","","",252,[[["self"]],["typeid"]]],[11,"not_found","","",252,[[["str"],["str"]],["e"]]],[11,"from_ok","","",252,[[["t"]],["t"]]],[11,"map_same","","",252,[[["self"],["f"]],["t"]]],[11,"from","","",253,[[["t"]],["t"]]],[11,"into","","",253,[[["self"]],["u"]]],[11,"try_from","","",253,[[["u"]],["result"]]],[11,"borrow","","",253,[[["self"]],["t"]]],[11,"try_into","","",253,[[["self"]],["result"]]],[11,"borrow_mut","","",253,[[["self"]],["t"]]],[11,"get_type_id","","",253,[[["self"]],["typeid"]]],[11,"not_found","","",253,[[["str"],["str"]],["e"]]],[11,"from_ok","","",253,[[["t"]],["t"]]],[11,"map_same","","",253,[[["self"],["f"]],["t"]]],[11,"from","","",254,[[["t"]],["t"]]],[11,"into","","",254,[[["self"]],["u"]]],[11,"try_from","","",254,[[["u"]],["result"]]],[11,"borrow","","",254,[[["self"]],["t"]]],[11,"try_into","","",254,[[["self"]],["result"]]],[11,"borrow_mut","","",254,[[["self"]],["t"]]],[11,"get_type_id","","",254,[[["self"]],["typeid"]]],[11,"not_found","","",254,[[["str"],["str"]],["e"]]],[11,"from_ok","","",254,[[["t"]],["t"]]],[11,"map_same","","",254,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::add_call_guards","",256,[[["t"]],["t"]]],[11,"into","","",256,[[["self"]],["u"]]],[11,"try_from","","",256,[[["u"]],["result"]]],[11,"borrow","","",256,[[["self"]],["t"]]],[11,"try_into","","",256,[[["self"]],["result"]]],[11,"borrow_mut","","",256,[[["self"]],["t"]]],[11,"get_type_id","","",256,[[["self"]],["typeid"]]],[11,"not_found","","",256,[[["str"],["str"]],["e"]]],[11,"from_ok","","",256,[[["t"]],["t"]]],[11,"map_same","","",256,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::promote_consts","",257,[[["t"]],["t"]]],[11,"into","","",257,[[["self"]],["u"]]],[11,"try_from","","",257,[[["u"]],["result"]]],[11,"borrow","","",257,[[["self"]],["t"]]],[11,"try_into","","",257,[[["self"]],["result"]]],[11,"borrow_mut","","",257,[[["self"]],["t"]]],[11,"get_type_id","","",257,[[["self"]],["typeid"]]],[11,"not_found","","",257,[[["str"],["str"]],["e"]]],[11,"from_ok","","",257,[[["t"]],["t"]]],[11,"map_same","","",257,[[["self"],["f"]],["t"]]],[11,"from","","",258,[[["t"]],["t"]]],[11,"into","","",258,[[["self"]],["u"]]],[11,"try_from","","",258,[[["u"]],["result"]]],[11,"borrow","","",258,[[["self"]],["t"]]],[11,"try_into","","",258,[[["self"]],["result"]]],[11,"borrow_mut","","",258,[[["self"]],["t"]]],[11,"get_type_id","","",258,[[["self"]],["typeid"]]],[11,"not_found","","",258,[[["str"],["str"]],["e"]]],[11,"from_ok","","",258,[[["t"]],["t"]]],[11,"map_same","","",258,[[["self"],["f"]],["t"]]],[11,"to_owned","","",259,[[["self"]],["t"]]],[11,"clone_into","","",259,N],[11,"from","","",259,[[["t"]],["t"]]],[11,"into","","",259,[[["self"]],["u"]]],[11,"try_from","","",259,[[["u"]],["result"]]],[11,"borrow","","",259,[[["self"]],["t"]]],[11,"try_into","","",259,[[["self"]],["result"]]],[11,"borrow_mut","","",259,[[["self"]],["t"]]],[11,"get_type_id","","",259,[[["self"]],["typeid"]]],[11,"not_found","","",259,[[["str"],["str"]],["e"]]],[11,"from_ok","","",259,[[["t"]],["t"]]],[11,"map_same","","",259,[[["self"],["f"]],["t"]]],[11,"from","","",260,[[["t"]],["t"]]],[11,"into","","",260,[[["self"]],["u"]]],[11,"try_from","","",260,[[["u"]],["result"]]],[11,"borrow","","",260,[[["self"]],["t"]]],[11,"try_into","","",260,[[["self"]],["result"]]],[11,"borrow_mut","","",260,[[["self"]],["t"]]],[11,"get_type_id","","",260,[[["self"]],["typeid"]]],[11,"not_found","","",260,[[["str"],["str"]],["e"]]],[11,"from_ok","","",260,[[["t"]],["t"]]],[11,"map_same","","",260,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::transform::qualify_consts","",261,[[["self"]],["t"]]],[11,"clone_into","","",261,N],[11,"from","","",261,[[["t"]],["t"]]],[11,"into","","",261,[[["self"]],["u"]]],[11,"try_from","","",261,[[["u"]],["result"]]],[11,"borrow","","",261,[[["self"]],["t"]]],[11,"try_into","","",261,[[["self"]],["result"]]],[11,"borrow_mut","","",261,[[["self"]],["t"]]],[11,"get_type_id","","",261,[[["self"]],["typeid"]]],[11,"not_found","","",261,[[["str"],["str"]],["e"]]],[11,"from_ok","","",261,[[["t"]],["t"]]],[11,"map_same","","",261,[[["self"],["f"]],["t"]]],[11,"from","","",262,[[["t"]],["t"]]],[11,"into","","",262,[[["self"]],["u"]]],[11,"try_from","","",262,[[["u"]],["result"]]],[11,"borrow","","",262,[[["self"]],["t"]]],[11,"try_into","","",262,[[["self"]],["result"]]],[11,"borrow_mut","","",262,[[["self"]],["t"]]],[11,"get_type_id","","",262,[[["self"]],["typeid"]]],[11,"not_found","","",262,[[["str"],["str"]],["e"]]],[11,"from_ok","","",262,[[["t"]],["t"]]],[11,"map_same","","",262,[[["self"],["f"]],["t"]]],[11,"from","","",264,[[["t"]],["t"]]],[11,"into","","",264,[[["self"]],["u"]]],[11,"try_from","","",264,[[["u"]],["result"]]],[11,"borrow","","",264,[[["self"]],["t"]]],[11,"try_into","","",264,[[["self"]],["result"]]],[11,"borrow_mut","","",264,[[["self"]],["t"]]],[11,"get_type_id","","",264,[[["self"]],["typeid"]]],[11,"not_found","","",264,[[["str"],["str"]],["e"]]],[11,"from_ok","","",264,[[["t"]],["t"]]],[11,"map_same","","",264,[[["self"],["f"]],["t"]]],[11,"to_owned","","",263,[[["self"]],["t"]]],[11,"clone_into","","",263,N],[11,"from","","",263,[[["t"]],["t"]]],[11,"to_string","","",263,[[["self"]],["string"]]],[11,"into","","",263,[[["self"]],["u"]]],[11,"try_from","","",263,[[["u"]],["result"]]],[11,"borrow","","",263,[[["self"]],["t"]]],[11,"try_into","","",263,[[["self"]],["result"]]],[11,"borrow_mut","","",263,[[["self"]],["t"]]],[11,"get_type_id","","",263,[[["self"]],["typeid"]]],[11,"not_found","","",263,[[["str"],["str"]],["e"]]],[11,"from_ok","","",263,[[["t"]],["t"]]],[11,"map_same","","",263,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::qualify_min_const_fn","",265,[[["t"]],["t"]]],[11,"into","","",265,[[["self"]],["u"]]],[11,"try_from","","",265,[[["u"]],["result"]]],[11,"borrow","","",265,[[["self"]],["t"]]],[11,"try_into","","",265,[[["self"]],["result"]]],[11,"borrow_mut","","",265,[[["self"]],["t"]]],[11,"get_type_id","","",265,[[["self"]],["typeid"]]],[11,"not_found","","",265,[[["str"],["str"]],["e"]]],[11,"from_ok","","",265,[[["t"]],["t"]]],[11,"map_same","","",265,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::remove_noop_landing_pads","",266,[[["t"]],["t"]]],[11,"into","","",266,[[["self"]],["u"]]],[11,"try_from","","",266,[[["u"]],["result"]]],[11,"borrow","","",266,[[["self"]],["t"]]],[11,"try_into","","",266,[[["self"]],["result"]]],[11,"borrow_mut","","",266,[[["self"]],["t"]]],[11,"get_type_id","","",266,[[["self"]],["typeid"]]],[11,"not_found","","",266,[[["str"],["str"]],["e"]]],[11,"from_ok","","",266,[[["t"]],["t"]]],[11,"map_same","","",266,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::dump_mir","",267,[[["t"]],["t"]]],[11,"into","","",267,[[["self"]],["u"]]],[11,"try_from","","",267,[[["u"]],["result"]]],[11,"borrow","","",267,[[["self"]],["t"]]],[11,"try_into","","",267,[[["self"]],["result"]]],[11,"borrow_mut","","",267,[[["self"]],["t"]]],[11,"get_type_id","","",267,[[["self"]],["typeid"]]],[11,"not_found","","",267,[[["str"],["str"]],["e"]]],[11,"from_ok","","",267,[[["t"]],["t"]]],[11,"map_same","","",267,[[["self"],["f"]],["t"]]],[11,"from","","",268,[[["t"]],["t"]]],[11,"to_string","","",268,[[["self"]],["string"]]],[11,"into","","",268,[[["self"]],["u"]]],[11,"try_from","","",268,[[["u"]],["result"]]],[11,"borrow","","",268,[[["self"]],["t"]]],[11,"try_into","","",268,[[["self"]],["result"]]],[11,"borrow_mut","","",268,[[["self"]],["t"]]],[11,"get_type_id","","",268,[[["self"]],["typeid"]]],[11,"not_found","","",268,[[["str"],["str"]],["e"]]],[11,"from_ok","","",268,[[["t"]],["t"]]],[11,"map_same","","",268,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::deaggregator","",269,[[["t"]],["t"]]],[11,"into","","",269,[[["self"]],["u"]]],[11,"try_from","","",269,[[["u"]],["result"]]],[11,"borrow","","",269,[[["self"]],["t"]]],[11,"try_into","","",269,[[["self"]],["result"]]],[11,"borrow_mut","","",269,[[["self"]],["t"]]],[11,"get_type_id","","",269,[[["self"]],["typeid"]]],[11,"not_found","","",269,[[["str"],["str"]],["e"]]],[11,"from_ok","","",269,[[["t"]],["t"]]],[11,"map_same","","",269,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::instcombine","",273,[[["t"]],["t"]]],[11,"into","","",273,[[["self"]],["u"]]],[11,"try_from","","",273,[[["u"]],["result"]]],[11,"borrow","","",273,[[["self"]],["t"]]],[11,"try_into","","",273,[[["self"]],["result"]]],[11,"borrow_mut","","",273,[[["self"]],["t"]]],[11,"get_type_id","","",273,[[["self"]],["typeid"]]],[11,"not_found","","",273,[[["str"],["str"]],["e"]]],[11,"from_ok","","",273,[[["t"]],["t"]]],[11,"map_same","","",273,[[["self"],["f"]],["t"]]],[11,"from","","",270,[[["t"]],["t"]]],[11,"into","","",270,[[["self"]],["u"]]],[11,"try_from","","",270,[[["u"]],["result"]]],[11,"borrow","","",270,[[["self"]],["t"]]],[11,"try_into","","",270,[[["self"]],["result"]]],[11,"borrow_mut","","",270,[[["self"]],["t"]]],[11,"get_type_id","","",270,[[["self"]],["typeid"]]],[11,"not_found","","",270,[[["str"],["str"]],["e"]]],[11,"from_ok","","",270,[[["t"]],["t"]]],[11,"map_same","","",270,[[["self"],["f"]],["t"]]],[11,"from","","",271,[[["t"]],["t"]]],[11,"into","","",271,[[["self"]],["u"]]],[11,"try_from","","",271,[[["u"]],["result"]]],[11,"borrow","","",271,[[["self"]],["t"]]],[11,"try_into","","",271,[[["self"]],["result"]]],[11,"borrow_mut","","",271,[[["self"]],["t"]]],[11,"get_type_id","","",271,[[["self"]],["typeid"]]],[11,"not_found","","",271,[[["str"],["str"]],["e"]]],[11,"from_ok","","",271,[[["t"]],["t"]]],[11,"map_same","","",271,[[["self"],["f"]],["t"]]],[11,"from","","",272,[[["t"]],["t"]]],[11,"into","","",272,[[["self"]],["u"]]],[11,"try_from","","",272,[[["u"]],["result"]]],[11,"borrow","","",272,[[["self"]],["t"]]],[11,"try_into","","",272,[[["self"]],["result"]]],[11,"borrow_mut","","",272,[[["self"]],["t"]]],[11,"get_type_id","","",272,[[["self"]],["typeid"]]],[11,"not_found","","",272,[[["str"],["str"]],["e"]]],[11,"from_ok","","",272,[[["t"]],["t"]]],[11,"map_same","","",272,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::copy_prop","",276,[[["t"]],["t"]]],[11,"into","","",276,[[["self"]],["u"]]],[11,"try_from","","",276,[[["u"]],["result"]]],[11,"borrow","","",276,[[["self"]],["t"]]],[11,"try_into","","",276,[[["self"]],["result"]]],[11,"borrow_mut","","",276,[[["self"]],["t"]]],[11,"get_type_id","","",276,[[["self"]],["typeid"]]],[11,"not_found","","",276,[[["str"],["str"]],["e"]]],[11,"from_ok","","",276,[[["t"]],["t"]]],[11,"map_same","","",276,[[["self"],["f"]],["t"]]],[11,"from","","",274,[[["t"]],["t"]]],[11,"into","","",274,[[["self"]],["u"]]],[11,"try_from","","",274,[[["u"]],["result"]]],[11,"borrow","","",274,[[["self"]],["t"]]],[11,"try_into","","",274,[[["self"]],["result"]]],[11,"borrow_mut","","",274,[[["self"]],["t"]]],[11,"get_type_id","","",274,[[["self"]],["typeid"]]],[11,"not_found","","",274,[[["str"],["str"]],["e"]]],[11,"from_ok","","",274,[[["t"]],["t"]]],[11,"map_same","","",274,[[["self"],["f"]],["t"]]],[11,"from","","",275,[[["t"]],["t"]]],[11,"into","","",275,[[["self"]],["u"]]],[11,"try_from","","",275,[[["u"]],["result"]]],[11,"borrow","","",275,[[["self"]],["t"]]],[11,"try_into","","",275,[[["self"]],["result"]]],[11,"borrow_mut","","",275,[[["self"]],["t"]]],[11,"get_type_id","","",275,[[["self"]],["typeid"]]],[11,"not_found","","",275,[[["str"],["str"]],["e"]]],[11,"from_ok","","",275,[[["t"]],["t"]]],[11,"map_same","","",275,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::const_prop","",279,[[["t"]],["t"]]],[11,"into","","",279,[[["self"]],["u"]]],[11,"try_from","","",279,[[["u"]],["result"]]],[11,"borrow","","",279,[[["self"]],["t"]]],[11,"try_into","","",279,[[["self"]],["result"]]],[11,"borrow_mut","","",279,[[["self"]],["t"]]],[11,"get_type_id","","",279,[[["self"]],["typeid"]]],[11,"not_found","","",279,[[["str"],["str"]],["e"]]],[11,"from_ok","","",279,[[["t"]],["t"]]],[11,"map_same","","",279,[[["self"],["f"]],["t"]]],[11,"from","","",277,[[["t"]],["t"]]],[11,"into","","",277,[[["self"]],["u"]]],[11,"try_from","","",277,[[["u"]],["result"]]],[11,"borrow","","",277,[[["self"]],["t"]]],[11,"try_into","","",277,[[["self"]],["result"]]],[11,"borrow_mut","","",277,[[["self"]],["t"]]],[11,"get_type_id","","",277,[[["self"]],["typeid"]]],[11,"not_found","","",277,[[["str"],["str"]],["e"]]],[11,"from_ok","","",277,[[["t"]],["t"]]],[11,"map_same","","",277,[[["self"],["f"]],["t"]]],[11,"from","","",278,[[["t"]],["t"]]],[11,"into","","",278,[[["self"]],["u"]]],[11,"try_from","","",278,[[["u"]],["result"]]],[11,"borrow","","",278,[[["self"]],["t"]]],[11,"try_into","","",278,[[["self"]],["result"]]],[11,"borrow_mut","","",278,[[["self"]],["t"]]],[11,"get_type_id","","",278,[[["self"]],["typeid"]]],[11,"not_found","","",278,[[["str"],["str"]],["e"]]],[11,"from_ok","","",278,[[["t"]],["t"]]],[11,"map_same","","",278,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::generator","",286,[[["t"]],["t"]]],[11,"into","","",286,[[["self"]],["u"]]],[11,"try_from","","",286,[[["u"]],["result"]]],[11,"borrow","","",286,[[["self"]],["t"]]],[11,"try_into","","",286,[[["self"]],["result"]]],[11,"borrow_mut","","",286,[[["self"]],["t"]]],[11,"get_type_id","","",286,[[["self"]],["typeid"]]],[11,"not_found","","",286,[[["str"],["str"]],["e"]]],[11,"from_ok","","",286,[[["t"]],["t"]]],[11,"map_same","","",286,[[["self"],["f"]],["t"]]],[11,"from","","",280,[[["t"]],["t"]]],[11,"into","","",280,[[["self"]],["u"]]],[11,"try_from","","",280,[[["u"]],["result"]]],[11,"borrow","","",280,[[["self"]],["t"]]],[11,"try_into","","",280,[[["self"]],["result"]]],[11,"borrow_mut","","",280,[[["self"]],["t"]]],[11,"get_type_id","","",280,[[["self"]],["typeid"]]],[11,"not_found","","",280,[[["str"],["str"]],["e"]]],[11,"from_ok","","",280,[[["t"]],["t"]]],[11,"map_same","","",280,[[["self"],["f"]],["t"]]],[11,"from","","",285,[[["t"]],["t"]]],[11,"into","","",285,[[["self"]],["u"]]],[11,"try_from","","",285,[[["u"]],["result"]]],[11,"borrow","","",285,[[["self"]],["t"]]],[11,"try_into","","",285,[[["self"]],["result"]]],[11,"borrow_mut","","",285,[[["self"]],["t"]]],[11,"get_type_id","","",285,[[["self"]],["typeid"]]],[11,"not_found","","",285,[[["str"],["str"]],["e"]]],[11,"from_ok","","",285,[[["t"]],["t"]]],[11,"map_same","","",285,[[["self"],["f"]],["t"]]],[11,"from","","",281,[[["t"]],["t"]]],[11,"into","","",281,[[["self"]],["u"]]],[11,"try_from","","",281,[[["u"]],["result"]]],[11,"borrow","","",281,[[["self"]],["t"]]],[11,"try_into","","",281,[[["self"]],["result"]]],[11,"borrow_mut","","",281,[[["self"]],["t"]]],[11,"get_type_id","","",281,[[["self"]],["typeid"]]],[11,"not_found","","",281,[[["str"],["str"]],["e"]]],[11,"from_ok","","",281,[[["t"]],["t"]]],[11,"map_same","","",281,[[["self"],["f"]],["t"]]],[11,"from","","",282,[[["t"]],["t"]]],[11,"into","","",282,[[["self"]],["u"]]],[11,"try_from","","",282,[[["u"]],["result"]]],[11,"borrow","","",282,[[["self"]],["t"]]],[11,"try_into","","",282,[[["self"]],["result"]]],[11,"borrow_mut","","",282,[[["self"]],["t"]]],[11,"get_type_id","","",282,[[["self"]],["typeid"]]],[11,"not_found","","",282,[[["str"],["str"]],["e"]]],[11,"from_ok","","",282,[[["t"]],["t"]]],[11,"map_same","","",282,[[["self"],["f"]],["t"]]],[11,"from","","",283,[[["t"]],["t"]]],[11,"into","","",283,[[["self"]],["u"]]],[11,"try_from","","",283,[[["u"]],["result"]]],[11,"borrow","","",283,[[["self"]],["t"]]],[11,"try_into","","",283,[[["self"]],["result"]]],[11,"borrow_mut","","",283,[[["self"]],["t"]]],[11,"get_type_id","","",283,[[["self"]],["typeid"]]],[11,"not_found","","",283,[[["str"],["str"]],["e"]]],[11,"from_ok","","",283,[[["t"]],["t"]]],[11,"map_same","","",283,[[["self"],["f"]],["t"]]],[11,"from","","",284,[[["t"]],["t"]]],[11,"into","","",284,[[["self"]],["u"]]],[11,"try_from","","",284,[[["u"]],["result"]]],[11,"borrow","","",284,[[["self"]],["t"]]],[11,"try_into","","",284,[[["self"]],["result"]]],[11,"borrow_mut","","",284,[[["self"]],["t"]]],[11,"get_type_id","","",284,[[["self"]],["typeid"]]],[11,"not_found","","",284,[[["str"],["str"]],["e"]]],[11,"from_ok","","",284,[[["t"]],["t"]]],[11,"map_same","","",284,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::inline","",290,[[["t"]],["t"]]],[11,"into","","",290,[[["self"]],["u"]]],[11,"try_from","","",290,[[["u"]],["result"]]],[11,"borrow","","",290,[[["self"]],["t"]]],[11,"try_into","","",290,[[["self"]],["result"]]],[11,"borrow_mut","","",290,[[["self"]],["t"]]],[11,"get_type_id","","",290,[[["self"]],["typeid"]]],[11,"not_found","","",290,[[["str"],["str"]],["e"]]],[11,"from_ok","","",290,[[["t"]],["t"]]],[11,"map_same","","",290,[[["self"],["f"]],["t"]]],[11,"to_owned","","",287,[[["self"]],["t"]]],[11,"clone_into","","",287,N],[11,"from","","",287,[[["t"]],["t"]]],[11,"into","","",287,[[["self"]],["u"]]],[11,"try_from","","",287,[[["u"]],["result"]]],[11,"borrow","","",287,[[["self"]],["t"]]],[11,"try_into","","",287,[[["self"]],["result"]]],[11,"borrow_mut","","",287,[[["self"]],["t"]]],[11,"get_type_id","","",287,[[["self"]],["typeid"]]],[11,"not_found","","",287,[[["str"],["str"]],["e"]]],[11,"from_ok","","",287,[[["t"]],["t"]]],[11,"map_same","","",287,[[["self"],["f"]],["t"]]],[11,"from","","",288,[[["t"]],["t"]]],[11,"into","","",288,[[["self"]],["u"]]],[11,"try_from","","",288,[[["u"]],["result"]]],[11,"borrow","","",288,[[["self"]],["t"]]],[11,"try_into","","",288,[[["self"]],["result"]]],[11,"borrow_mut","","",288,[[["self"]],["t"]]],[11,"get_type_id","","",288,[[["self"]],["typeid"]]],[11,"not_found","","",288,[[["str"],["str"]],["e"]]],[11,"from_ok","","",288,[[["t"]],["t"]]],[11,"map_same","","",288,[[["self"],["f"]],["t"]]],[11,"from","","",289,[[["t"]],["t"]]],[11,"into","","",289,[[["self"]],["u"]]],[11,"try_from","","",289,[[["u"]],["result"]]],[11,"borrow","","",289,[[["self"]],["t"]]],[11,"try_into","","",289,[[["self"]],["result"]]],[11,"borrow_mut","","",289,[[["self"]],["t"]]],[11,"get_type_id","","",289,[[["self"]],["typeid"]]],[11,"not_found","","",289,[[["str"],["str"]],["e"]]],[11,"from_ok","","",289,[[["t"]],["t"]]],[11,"map_same","","",289,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::lower_128bit","",292,[[["t"]],["t"]]],[11,"into","","",292,[[["self"]],["u"]]],[11,"try_from","","",292,[[["u"]],["result"]]],[11,"borrow","","",292,[[["self"]],["t"]]],[11,"try_into","","",292,[[["self"]],["result"]]],[11,"borrow_mut","","",292,[[["self"]],["t"]]],[11,"get_type_id","","",292,[[["self"]],["typeid"]]],[11,"not_found","","",292,[[["str"],["str"]],["e"]]],[11,"from_ok","","",292,[[["t"]],["t"]]],[11,"map_same","","",292,[[["self"],["f"]],["t"]]],[11,"to_owned","","",291,[[["self"]],["t"]]],[11,"clone_into","","",291,N],[11,"from","","",291,[[["t"]],["t"]]],[11,"into","","",291,[[["self"]],["u"]]],[11,"try_from","","",291,[[["u"]],["result"]]],[11,"borrow","","",291,[[["self"]],["t"]]],[11,"try_into","","",291,[[["self"]],["result"]]],[11,"borrow_mut","","",291,[[["self"]],["t"]]],[11,"get_type_id","","",291,[[["self"]],["typeid"]]],[11,"not_found","","",291,[[["str"],["str"]],["e"]]],[11,"from_ok","","",291,[[["t"]],["t"]]],[11,"map_same","","",291,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::transform::uniform_array_move_out","",296,[[["t"]],["t"]]],[11,"into","","",296,[[["self"]],["u"]]],[11,"try_from","","",296,[[["u"]],["result"]]],[11,"borrow","","",296,[[["self"]],["t"]]],[11,"try_into","","",296,[[["self"]],["result"]]],[11,"borrow_mut","","",296,[[["self"]],["t"]]],[11,"get_type_id","","",296,[[["self"]],["typeid"]]],[11,"not_found","","",296,[[["str"],["str"]],["e"]]],[11,"from_ok","","",296,[[["t"]],["t"]]],[11,"map_same","","",296,[[["self"],["f"]],["t"]]],[11,"from","","",293,[[["t"]],["t"]]],[11,"into","","",293,[[["self"]],["u"]]],[11,"try_from","","",293,[[["u"]],["result"]]],[11,"borrow","","",293,[[["self"]],["t"]]],[11,"try_into","","",293,[[["self"]],["result"]]],[11,"borrow_mut","","",293,[[["self"]],["t"]]],[11,"get_type_id","","",293,[[["self"]],["typeid"]]],[11,"not_found","","",293,[[["str"],["str"]],["e"]]],[11,"from_ok","","",293,[[["t"]],["t"]]],[11,"map_same","","",293,[[["self"],["f"]],["t"]]],[11,"from","","",297,[[["t"]],["t"]]],[11,"into","","",297,[[["self"]],["u"]]],[11,"try_from","","",297,[[["u"]],["result"]]],[11,"borrow","","",297,[[["self"]],["t"]]],[11,"try_into","","",297,[[["self"]],["result"]]],[11,"borrow_mut","","",297,[[["self"]],["t"]]],[11,"get_type_id","","",297,[[["self"]],["typeid"]]],[11,"not_found","","",297,[[["str"],["str"]],["e"]]],[11,"from_ok","","",297,[[["t"]],["t"]]],[11,"map_same","","",297,[[["self"],["f"]],["t"]]],[11,"to_owned","","",294,[[["self"]],["t"]]],[11,"clone_into","","",294,N],[11,"from","","",294,[[["t"]],["t"]]],[11,"into","","",294,[[["self"]],["u"]]],[11,"try_from","","",294,[[["u"]],["result"]]],[11,"borrow","","",294,[[["self"]],["t"]]],[11,"try_into","","",294,[[["self"]],["result"]]],[11,"borrow_mut","","",294,[[["self"]],["t"]]],[11,"get_type_id","","",294,[[["self"]],["typeid"]]],[11,"not_found","","",294,[[["str"],["str"]],["e"]]],[11,"from_ok","","",294,[[["t"]],["t"]]],[11,"map_same","","",294,[[["self"],["f"]],["t"]]],[11,"from","","",295,[[["t"]],["t"]]],[11,"into","","",295,[[["self"]],["u"]]],[11,"try_from","","",295,[[["u"]],["result"]]],[11,"borrow","","",295,[[["self"]],["t"]]],[11,"try_into","","",295,[[["self"]],["result"]]],[11,"borrow_mut","","",295,[[["self"]],["t"]]],[11,"get_type_id","","",295,[[["self"]],["typeid"]]],[11,"not_found","","",295,[[["str"],["str"]],["e"]]],[11,"from_ok","","",295,[[["t"]],["t"]]],[11,"map_same","","",295,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::util","",299,[[["t"]],["t"]]],[11,"into","","",299,[[["self"]],["u"]]],[11,"try_from","","",299,[[["u"]],["result"]]],[11,"borrow","","",299,[[["self"]],["t"]]],[11,"try_into","","",299,[[["self"]],["result"]]],[11,"borrow_mut","","",299,[[["self"]],["t"]]],[11,"get_type_id","","",299,[[["self"]],["typeid"]]],[11,"not_found","","",299,[[["str"],["str"]],["e"]]],[11,"from_ok","","",299,[[["t"]],["t"]]],[11,"map_same","","",299,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::util::borrowck_errors","",300,[[["self"]],["t"]]],[11,"clone_into","","",300,N],[11,"from","","",300,[[["t"]],["t"]]],[11,"to_string","","",300,[[["self"]],["string"]]],[11,"into","","",300,[[["self"]],["u"]]],[11,"try_from","","",300,[[["u"]],["result"]]],[11,"borrow","","",300,[[["self"]],["t"]]],[11,"try_into","","",300,[[["self"]],["result"]]],[11,"borrow_mut","","",300,[[["self"]],["t"]]],[11,"get_type_id","","",300,[[["self"]],["typeid"]]],[11,"not_found","","",300,[[["str"],["str"]],["e"]]],[11,"from_ok","","",300,[[["t"]],["t"]]],[11,"map_same","","",300,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::util::elaborate_drops","",302,[[["t"]],["t"]]],[11,"into","","",302,[[["self"]],["u"]]],[11,"try_from","","",302,[[["u"]],["result"]]],[11,"borrow","","",302,[[["self"]],["t"]]],[11,"try_into","","",302,[[["self"]],["result"]]],[11,"borrow_mut","","",302,[[["self"]],["t"]]],[11,"get_type_id","","",302,[[["self"]],["typeid"]]],[11,"not_found","","",302,[[["str"],["str"]],["e"]]],[11,"from_ok","","",302,[[["t"]],["t"]]],[11,"map_same","","",302,[[["self"],["f"]],["t"]]],[11,"to_owned","","",303,[[["self"]],["t"]]],[11,"clone_into","","",303,N],[11,"from","","",303,[[["t"]],["t"]]],[11,"into","","",303,[[["self"]],["u"]]],[11,"try_from","","",303,[[["u"]],["result"]]],[11,"borrow","","",303,[[["self"]],["t"]]],[11,"try_into","","",303,[[["self"]],["result"]]],[11,"borrow_mut","","",303,[[["self"]],["t"]]],[11,"get_type_id","","",303,[[["self"]],["typeid"]]],[11,"not_found","","",303,[[["str"],["str"]],["e"]]],[11,"from_ok","","",303,[[["t"]],["t"]]],[11,"map_same","","",303,[[["self"],["f"]],["t"]]],[11,"from","","",304,[[["t"]],["t"]]],[11,"into","","",304,[[["self"]],["u"]]],[11,"try_from","","",304,[[["u"]],["result"]]],[11,"borrow","","",304,[[["self"]],["t"]]],[11,"try_into","","",304,[[["self"]],["result"]]],[11,"borrow_mut","","",304,[[["self"]],["t"]]],[11,"get_type_id","","",304,[[["self"]],["typeid"]]],[11,"not_found","","",304,[[["str"],["str"]],["e"]]],[11,"from_ok","","",304,[[["t"]],["t"]]],[11,"map_same","","",304,[[["self"],["f"]],["t"]]],[11,"from","","",305,[[["t"]],["t"]]],[11,"into","","",305,[[["self"]],["u"]]],[11,"try_from","","",305,[[["u"]],["result"]]],[11,"borrow","","",305,[[["self"]],["t"]]],[11,"try_into","","",305,[[["self"]],["result"]]],[11,"borrow_mut","","",305,[[["self"]],["t"]]],[11,"get_type_id","","",305,[[["self"]],["typeid"]]],[11,"not_found","","",305,[[["str"],["str"]],["e"]]],[11,"from_ok","","",305,[[["t"]],["t"]]],[11,"map_same","","",305,[[["self"],["f"]],["t"]]],[11,"to_owned","","",306,[[["self"]],["t"]]],[11,"clone_into","","",306,N],[11,"from","","",306,[[["t"]],["t"]]],[11,"into","","",306,[[["self"]],["u"]]],[11,"try_from","","",306,[[["u"]],["result"]]],[11,"borrow","","",306,[[["self"]],["t"]]],[11,"try_into","","",306,[[["self"]],["result"]]],[11,"borrow_mut","","",306,[[["self"]],["t"]]],[11,"get_type_id","","",306,[[["self"]],["typeid"]]],[11,"not_found","","",306,[[["str"],["str"]],["e"]]],[11,"from_ok","","",306,[[["t"]],["t"]]],[11,"map_same","","",306,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::util::def_use","",308,[[["t"]],["t"]]],[11,"into","","",308,[[["self"]],["u"]]],[11,"try_from","","",308,[[["u"]],["result"]]],[11,"borrow","","",308,[[["self"]],["t"]]],[11,"try_into","","",308,[[["self"]],["result"]]],[11,"borrow_mut","","",308,[[["self"]],["t"]]],[11,"get_type_id","","",308,[[["self"]],["typeid"]]],[11,"not_found","","",308,[[["str"],["str"]],["e"]]],[11,"from_ok","","",308,[[["t"]],["t"]]],[11,"map_same","","",308,[[["self"],["f"]],["t"]]],[11,"to_owned","","",309,[[["self"]],["t"]]],[11,"clone_into","","",309,N],[11,"from","","",309,[[["t"]],["t"]]],[11,"into","","",309,[[["self"]],["u"]]],[11,"try_from","","",309,[[["u"]],["result"]]],[11,"borrow","","",309,[[["self"]],["t"]]],[11,"try_into","","",309,[[["self"]],["result"]]],[11,"borrow_mut","","",309,[[["self"]],["t"]]],[11,"get_type_id","","",309,[[["self"]],["typeid"]]],[11,"not_found","","",309,[[["str"],["str"]],["e"]]],[11,"from_ok","","",309,[[["t"]],["t"]]],[11,"map_same","","",309,[[["self"],["f"]],["t"]]],[11,"to_owned","","",310,[[["self"]],["t"]]],[11,"clone_into","","",310,N],[11,"from","","",310,[[["t"]],["t"]]],[11,"into","","",310,[[["self"]],["u"]]],[11,"try_from","","",310,[[["u"]],["result"]]],[11,"borrow","","",310,[[["self"]],["t"]]],[11,"try_into","","",310,[[["self"]],["result"]]],[11,"borrow_mut","","",310,[[["self"]],["t"]]],[11,"get_type_id","","",310,[[["self"]],["typeid"]]],[11,"not_found","","",310,[[["str"],["str"]],["e"]]],[11,"from_ok","","",310,[[["t"]],["t"]]],[11,"map_same","","",310,[[["self"],["f"]],["t"]]],[11,"from","","",311,[[["t"]],["t"]]],[11,"into","","",311,[[["self"]],["u"]]],[11,"try_from","","",311,[[["u"]],["result"]]],[11,"borrow","","",311,[[["self"]],["t"]]],[11,"try_into","","",311,[[["self"]],["result"]]],[11,"borrow_mut","","",311,[[["self"]],["t"]]],[11,"get_type_id","","",311,[[["self"]],["typeid"]]],[11,"not_found","","",311,[[["str"],["str"]],["e"]]],[11,"from_ok","","",311,[[["t"]],["t"]]],[11,"map_same","","",311,[[["self"],["f"]],["t"]]],[11,"from","","",312,[[["t"]],["t"]]],[11,"into","","",312,[[["self"]],["u"]]],[11,"try_from","","",312,[[["u"]],["result"]]],[11,"borrow","","",312,[[["self"]],["t"]]],[11,"try_into","","",312,[[["self"]],["result"]]],[11,"borrow_mut","","",312,[[["self"]],["t"]]],[11,"get_type_id","","",312,[[["self"]],["typeid"]]],[11,"not_found","","",312,[[["str"],["str"]],["e"]]],[11,"from_ok","","",312,[[["t"]],["t"]]],[11,"map_same","","",312,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::util::patch","",313,[[["t"]],["t"]]],[11,"into","","",313,[[["self"]],["u"]]],[11,"try_from","","",313,[[["u"]],["result"]]],[11,"borrow","","",313,[[["self"]],["t"]]],[11,"try_into","","",313,[[["self"]],["result"]]],[11,"borrow_mut","","",313,[[["self"]],["t"]]],[11,"get_type_id","","",313,[[["self"]],["typeid"]]],[11,"not_found","","",313,[[["str"],["str"]],["e"]]],[11,"from_ok","","",313,[[["t"]],["t"]]],[11,"map_same","","",313,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::util::pretty","",314,[[["t"]],["t"]]],[11,"into","","",314,[[["self"]],["u"]]],[11,"try_from","","",314,[[["u"]],["result"]]],[11,"borrow","","",314,[[["self"]],["t"]]],[11,"try_into","","",314,[[["self"]],["result"]]],[11,"borrow_mut","","",314,[[["self"]],["t"]]],[11,"get_type_id","","",314,[[["self"]],["typeid"]]],[11,"not_found","","",314,[[["str"],["str"]],["e"]]],[11,"from_ok","","",314,[[["t"]],["t"]]],[11,"map_same","","",314,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::util::liveness","",315,[[["t"]],["t"]]],[11,"into","","",315,[[["self"]],["u"]]],[11,"try_from","","",315,[[["u"]],["result"]]],[11,"borrow","","",315,[[["self"]],["t"]]],[11,"try_into","","",315,[[["self"]],["result"]]],[11,"borrow_mut","","",315,[[["self"]],["t"]]],[11,"get_type_id","","",315,[[["self"]],["typeid"]]],[11,"not_found","","",315,[[["str"],["str"]],["e"]]],[11,"from_ok","","",315,[[["t"]],["t"]]],[11,"map_same","","",315,[[["self"],["f"]],["t"]]],[11,"from","","",316,[[["t"]],["t"]]],[11,"into","","",316,[[["self"]],["u"]]],[11,"try_from","","",316,[[["u"]],["result"]]],[11,"borrow","","",316,[[["self"]],["t"]]],[11,"try_into","","",316,[[["self"]],["result"]]],[11,"borrow_mut","","",316,[[["self"]],["t"]]],[11,"get_type_id","","",316,[[["self"]],["typeid"]]],[11,"not_found","","",316,[[["str"],["str"]],["e"]]],[11,"from_ok","","",316,[[["t"]],["t"]]],[11,"map_same","","",316,[[["self"],["f"]],["t"]]],[11,"from","","",317,[[["t"]],["t"]]],[11,"into","","",317,[[["self"]],["u"]]],[11,"try_from","","",317,[[["u"]],["result"]]],[11,"borrow","","",317,[[["self"]],["t"]]],[11,"try_into","","",317,[[["self"]],["result"]]],[11,"borrow_mut","","",317,[[["self"]],["t"]]],[11,"get_type_id","","",317,[[["self"]],["typeid"]]],[11,"not_found","","",317,[[["str"],["str"]],["e"]]],[11,"from_ok","","",317,[[["t"]],["t"]]],[11,"map_same","","",317,[[["self"],["f"]],["t"]]],[11,"to_owned","","",318,[[["self"]],["t"]]],[11,"clone_into","","",318,N],[11,"from","","",318,[[["t"]],["t"]]],[11,"into","","",318,[[["self"]],["u"]]],[11,"try_from","","",318,[[["u"]],["result"]]],[11,"borrow","","",318,[[["self"]],["t"]]],[11,"try_into","","",318,[[["self"]],["result"]]],[11,"borrow_mut","","",318,[[["self"]],["t"]]],[11,"get_type_id","","",318,[[["self"]],["typeid"]]],[11,"not_found","","",318,[[["str"],["str"]],["e"]]],[11,"from_ok","","",318,[[["t"]],["t"]]],[11,"map_same","","",318,[[["self"],["f"]],["t"]]],[11,"to_owned","","",319,[[["self"]],["t"]]],[11,"clone_into","","",319,N],[11,"from","","",319,[[["t"]],["t"]]],[11,"into","","",319,[[["self"]],["u"]]],[11,"try_from","","",319,[[["u"]],["result"]]],[11,"borrow","","",319,[[["self"]],["t"]]],[11,"try_into","","",319,[[["self"]],["result"]]],[11,"borrow_mut","","",319,[[["self"]],["t"]]],[11,"get_type_id","","",319,[[["self"]],["typeid"]]],[11,"not_found","","",319,[[["str"],["str"]],["e"]]],[11,"from_ok","","",319,[[["t"]],["t"]]],[11,"map_same","","",319,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::util::collect_writes","",321,[[["t"]],["t"]]],[11,"into","","",321,[[["self"]],["u"]]],[11,"try_from","","",321,[[["u"]],["result"]]],[11,"borrow","","",321,[[["self"]],["t"]]],[11,"try_into","","",321,[[["self"]],["result"]]],[11,"borrow_mut","","",321,[[["self"]],["t"]]],[11,"get_type_id","","",321,[[["self"]],["typeid"]]],[11,"not_found","","",321,[[["str"],["str"]],["e"]]],[11,"from_ok","","",321,[[["t"]],["t"]]],[11,"map_same","","",321,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::interpret","",323,[[["t"]],["t"]]],[11,"into","","",323,[[["self"]],["u"]]],[11,"try_from","","",323,[[["u"]],["result"]]],[11,"borrow","","",323,[[["self"]],["t"]]],[11,"try_into","","",323,[[["self"]],["result"]]],[11,"borrow_mut","","",323,[[["self"]],["t"]]],[11,"get_type_id","","",323,[[["self"]],["typeid"]]],[11,"not_found","","",323,[[["str"],["str"]],["e"]]],[11,"from_ok","","",323,[[["t"]],["t"]]],[11,"map_same","","",323,[[["self"],["f"]],["t"]]],[11,"to_owned","","",324,[[["self"]],["t"]]],[11,"clone_into","","",324,N],[11,"from","","",324,[[["t"]],["t"]]],[11,"into","","",324,[[["self"]],["u"]]],[11,"try_from","","",324,[[["u"]],["result"]]],[11,"borrow","","",324,[[["self"]],["t"]]],[11,"try_into","","",324,[[["self"]],["result"]]],[11,"borrow_mut","","",324,[[["self"]],["t"]]],[11,"get_type_id","","",324,[[["self"]],["typeid"]]],[11,"not_found","","",324,[[["str"],["str"]],["e"]]],[11,"from_ok","","",324,[[["t"]],["t"]]],[11,"map_same","","",324,[[["self"],["f"]],["t"]]],[11,"to_owned","","",325,[[["self"]],["t"]]],[11,"clone_into","","",325,N],[11,"from","","",325,[[["t"]],["t"]]],[11,"into","","",325,[[["self"]],["u"]]],[11,"try_from","","",325,[[["u"]],["result"]]],[11,"borrow","","",325,[[["self"]],["t"]]],[11,"try_into","","",325,[[["self"]],["result"]]],[11,"borrow_mut","","",325,[[["self"]],["t"]]],[11,"get_type_id","","",325,[[["self"]],["typeid"]]],[11,"not_found","","",325,[[["str"],["str"]],["e"]]],[11,"from_ok","","",325,[[["t"]],["t"]]],[11,"map_same","","",325,[[["self"],["f"]],["t"]]],[11,"to_owned","","",326,[[["self"]],["t"]]],[11,"clone_into","","",326,N],[11,"from","","",326,[[["t"]],["t"]]],[11,"into","","",326,[[["self"]],["u"]]],[11,"try_from","","",326,[[["u"]],["result"]]],[11,"borrow","","",326,[[["self"]],["t"]]],[11,"try_into","","",326,[[["self"]],["result"]]],[11,"borrow_mut","","",326,[[["self"]],["t"]]],[11,"get_type_id","","",326,[[["self"]],["typeid"]]],[11,"not_found","","",326,[[["str"],["str"]],["e"]]],[11,"from_ok","","",326,[[["t"]],["t"]]],[11,"map_same","","",326,[[["self"],["f"]],["t"]]],[11,"to_owned","","",327,[[["self"]],["t"]]],[11,"clone_into","","",327,N],[11,"from","","",327,[[["t"]],["t"]]],[11,"into","","",327,[[["self"]],["u"]]],[11,"try_from","","",327,[[["u"]],["result"]]],[11,"borrow","","",327,[[["self"]],["t"]]],[11,"try_into","","",327,[[["self"]],["result"]]],[11,"borrow_mut","","",327,[[["self"]],["t"]]],[11,"get_type_id","","",327,[[["self"]],["typeid"]]],[11,"not_found","","",327,[[["str"],["str"]],["e"]]],[11,"from_ok","","",327,[[["t"]],["t"]]],[11,"map_same","","",327,[[["self"],["f"]],["t"]]],[11,"to_owned","","",328,[[["self"]],["t"]]],[11,"clone_into","","",328,N],[11,"from","","",328,[[["t"]],["t"]]],[11,"into","","",328,[[["self"]],["u"]]],[11,"try_from","","",328,[[["u"]],["result"]]],[11,"borrow","","",328,[[["self"]],["t"]]],[11,"try_into","","",328,[[["self"]],["result"]]],[11,"borrow_mut","","",328,[[["self"]],["t"]]],[11,"get_type_id","","",328,[[["self"]],["typeid"]]],[11,"not_found","","",328,[[["str"],["str"]],["e"]]],[11,"from_ok","","",328,[[["t"]],["t"]]],[11,"map_same","","",328,[[["self"],["f"]],["t"]]],[11,"to_owned","","",329,[[["self"]],["t"]]],[11,"clone_into","","",329,N],[11,"from","","",329,[[["t"]],["t"]]],[11,"into","","",329,[[["self"]],["u"]]],[11,"try_from","","",329,[[["u"]],["result"]]],[11,"borrow","","",329,[[["self"]],["t"]]],[11,"try_into","","",329,[[["self"]],["result"]]],[11,"borrow_mut","","",329,[[["self"]],["t"]]],[11,"get_type_id","","",329,[[["self"]],["typeid"]]],[11,"not_found","","",329,[[["str"],["str"]],["e"]]],[11,"from_ok","","",329,[[["t"]],["t"]]],[11,"map_same","","",329,[[["self"],["f"]],["t"]]],[11,"to_owned","","",330,[[["self"]],["t"]]],[11,"clone_into","","",330,N],[11,"from","","",330,[[["t"]],["t"]]],[11,"into","","",330,[[["self"]],["u"]]],[11,"try_from","","",330,[[["u"]],["result"]]],[11,"borrow","","",330,[[["self"]],["t"]]],[11,"try_into","","",330,[[["self"]],["result"]]],[11,"borrow_mut","","",330,[[["self"]],["t"]]],[11,"get_type_id","","",330,[[["self"]],["typeid"]]],[11,"not_found","","",330,[[["str"],["str"]],["e"]]],[11,"from_ok","","",330,[[["t"]],["t"]]],[11,"map_same","","",330,[[["self"],["f"]],["t"]]],[11,"to_owned","","",331,[[["self"]],["t"]]],[11,"clone_into","","",331,N],[11,"from","","",331,[[["t"]],["t"]]],[11,"into","","",331,[[["self"]],["u"]]],[11,"try_from","","",331,[[["u"]],["result"]]],[11,"borrow","","",331,[[["self"]],["t"]]],[11,"try_into","","",331,[[["self"]],["result"]]],[11,"borrow_mut","","",331,[[["self"]],["t"]]],[11,"get_type_id","","",331,[[["self"]],["typeid"]]],[11,"not_found","","",331,[[["str"],["str"]],["e"]]],[11,"from_ok","","",331,[[["t"]],["t"]]],[11,"map_same","","",331,[[["self"],["f"]],["t"]]],[11,"to_owned","","",332,[[["self"]],["t"]]],[11,"clone_into","","",332,N],[11,"from","","",332,[[["t"]],["t"]]],[11,"into","","",332,[[["self"]],["u"]]],[11,"try_from","","",332,[[["u"]],["result"]]],[11,"borrow","","",332,[[["self"]],["t"]]],[11,"try_into","","",332,[[["self"]],["result"]]],[11,"borrow_mut","","",332,[[["self"]],["t"]]],[11,"get_type_id","","",332,[[["self"]],["typeid"]]],[11,"not_found","","",332,[[["str"],["str"]],["e"]]],[11,"from_ok","","",332,[[["t"]],["t"]]],[11,"map_same","","",332,[[["self"],["f"]],["t"]]],[11,"to_owned","","",333,[[["self"]],["t"]]],[11,"clone_into","","",333,N],[11,"from","","",333,[[["t"]],["t"]]],[11,"into","","",333,[[["self"]],["u"]]],[11,"try_from","","",333,[[["u"]],["result"]]],[11,"borrow","","",333,[[["self"]],["t"]]],[11,"try_into","","",333,[[["self"]],["result"]]],[11,"borrow_mut","","",333,[[["self"]],["t"]]],[11,"get_type_id","","",333,[[["self"]],["typeid"]]],[11,"not_found","","",333,[[["str"],["str"]],["e"]]],[11,"from_ok","","",333,[[["t"]],["t"]]],[11,"map_same","","",333,[[["self"],["f"]],["t"]]],[11,"to_owned","","",334,[[["self"]],["t"]]],[11,"clone_into","","",334,N],[11,"from","","",334,[[["t"]],["t"]]],[11,"into","","",334,[[["self"]],["u"]]],[11,"try_from","","",334,[[["u"]],["result"]]],[11,"borrow","","",334,[[["self"]],["t"]]],[11,"try_into","","",334,[[["self"]],["result"]]],[11,"borrow_mut","","",334,[[["self"]],["t"]]],[11,"get_type_id","","",334,[[["self"]],["typeid"]]],[11,"not_found","","",334,[[["str"],["str"]],["e"]]],[11,"from_ok","","",334,[[["t"]],["t"]]],[11,"map_same","","",334,[[["self"],["f"]],["t"]]],[11,"to_owned","","",335,[[["self"]],["t"]]],[11,"clone_into","","",335,N],[11,"from","","",335,[[["t"]],["t"]]],[11,"into","","",335,[[["self"]],["u"]]],[11,"try_from","","",335,[[["u"]],["result"]]],[11,"borrow","","",335,[[["self"]],["t"]]],[11,"try_into","","",335,[[["self"]],["result"]]],[11,"borrow_mut","","",335,[[["self"]],["t"]]],[11,"get_type_id","","",335,[[["self"]],["typeid"]]],[11,"not_found","","",335,[[["str"],["str"]],["e"]]],[11,"from_ok","","",335,[[["t"]],["t"]]],[11,"map_same","","",335,[[["self"],["f"]],["t"]]],[11,"to_owned","","",336,[[["self"]],["t"]]],[11,"clone_into","","",336,N],[11,"from","","",336,[[["t"]],["t"]]],[11,"into","","",336,[[["self"]],["u"]]],[11,"try_from","","",336,[[["u"]],["result"]]],[11,"borrow","","",336,[[["self"]],["t"]]],[11,"try_into","","",336,[[["self"]],["result"]]],[11,"borrow_mut","","",336,[[["self"]],["t"]]],[11,"get_type_id","","",336,[[["self"]],["typeid"]]],[11,"not_found","","",336,[[["str"],["str"]],["e"]]],[11,"from_ok","","",336,[[["t"]],["t"]]],[11,"map_same","","",336,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::interpret::snapshot","",338,[[["t"]],["t"]]],[11,"into","","",338,[[["self"]],["u"]]],[11,"try_from","","",338,[[["u"]],["result"]]],[11,"borrow","","",338,[[["self"]],["t"]]],[11,"try_into","","",338,[[["self"]],["result"]]],[11,"borrow_mut","","",338,[[["self"]],["t"]]],[11,"get_type_id","","",338,[[["self"]],["typeid"]]],[11,"not_found","","",338,[[["str"],["str"]],["e"]]],[11,"from_ok","","",338,[[["t"]],["t"]]],[11,"map_same","","",338,[[["self"],["f"]],["t"]]],[11,"from","","",339,[[["t"]],["t"]]],[11,"into","","",339,[[["self"]],["u"]]],[11,"try_from","","",339,[[["u"]],["result"]]],[11,"borrow","","",339,[[["self"]],["t"]]],[11,"try_into","","",339,[[["self"]],["result"]]],[11,"borrow_mut","","",339,[[["self"]],["t"]]],[11,"get_type_id","","",339,[[["self"]],["typeid"]]],[11,"not_found","","",339,[[["str"],["str"]],["e"]]],[11,"from_ok","","",339,[[["t"]],["t"]]],[11,"map_same","","",339,[[["self"],["f"]],["t"]]],[11,"from","","",340,[[["t"]],["t"]]],[11,"into","","",340,[[["self"]],["u"]]],[11,"try_from","","",340,[[["u"]],["result"]]],[11,"borrow","","",340,[[["self"]],["t"]]],[11,"try_into","","",340,[[["self"]],["result"]]],[11,"borrow_mut","","",340,[[["self"]],["t"]]],[11,"get_type_id","","",340,[[["self"]],["typeid"]]],[11,"not_found","","",340,[[["str"],["str"]],["e"]]],[11,"from_ok","","",340,[[["t"]],["t"]]],[11,"map_same","","",340,[[["self"],["f"]],["t"]]],[11,"from","","",341,[[["t"]],["t"]]],[11,"into","","",341,[[["self"]],["u"]]],[11,"try_from","","",341,[[["u"]],["result"]]],[11,"borrow","","",341,[[["self"]],["t"]]],[11,"try_into","","",341,[[["self"]],["result"]]],[11,"borrow_mut","","",341,[[["self"]],["t"]]],[11,"get_type_id","","",341,[[["self"]],["typeid"]]],[11,"not_found","","",341,[[["str"],["str"]],["e"]]],[11,"from_ok","","",341,[[["t"]],["t"]]],[11,"map_same","","",341,[[["self"],["f"]],["t"]]],[11,"from","","",342,[[["t"]],["t"]]],[11,"into","","",342,[[["self"]],["u"]]],[11,"try_from","","",342,[[["u"]],["result"]]],[11,"borrow","","",342,[[["self"]],["t"]]],[11,"try_into","","",342,[[["self"]],["result"]]],[11,"borrow_mut","","",342,[[["self"]],["t"]]],[11,"get_type_id","","",342,[[["self"]],["typeid"]]],[11,"not_found","","",342,[[["str"],["str"]],["e"]]],[11,"from_ok","","",342,[[["t"]],["t"]]],[11,"map_same","","",342,[[["self"],["f"]],["t"]]],[11,"from","","",343,[[["t"]],["t"]]],[11,"into","","",343,[[["self"]],["u"]]],[11,"try_from","","",343,[[["u"]],["result"]]],[11,"borrow","","",343,[[["self"]],["t"]]],[11,"try_into","","",343,[[["self"]],["result"]]],[11,"borrow_mut","","",343,[[["self"]],["t"]]],[11,"get_type_id","","",343,[[["self"]],["typeid"]]],[11,"not_found","","",343,[[["str"],["str"]],["e"]]],[11,"from_ok","","",343,[[["t"]],["t"]]],[11,"map_same","","",343,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::interpret::validity","",346,[[["self"]],["t"]]],[11,"clone_into","","",346,N],[11,"from","","",346,[[["t"]],["t"]]],[11,"into","","",346,[[["self"]],["u"]]],[11,"try_from","","",346,[[["u"]],["result"]]],[11,"borrow","","",346,[[["self"]],["t"]]],[11,"try_into","","",346,[[["self"]],["result"]]],[11,"borrow_mut","","",346,[[["self"]],["t"]]],[11,"get_type_id","","",346,[[["self"]],["typeid"]]],[11,"not_found","","",346,[[["str"],["str"]],["e"]]],[11,"from_ok","","",346,[[["t"]],["t"]]],[11,"map_same","","",346,[[["self"],["f"]],["t"]]],[11,"ty","rustc_mir::monomorphize","",347,[[["self"],["tyctxt"]],["tys"]]],[11,"new","","",347,[[["defid"],["list"]],["instance"]]],[11,"mono","","",347,[[["tyctxt"],["defid"]],["instance"]]],[11,"def_id","","",347,[[["self"]],["defid"]]],[11,"resolve","","Resolve a (def_id, substs) pair to an (optional) instance -- most commonly, this is used to find the precise code that will run for a trait method invocation, if known.",347,[[["tyctxt"],["paramenv"],["defid"],["list"]],["option",["instance"]]]],[11,"resolve_closure","","",347,[[["tyctxt"],["defid"],["closuresubsts"],["closurekind"]],["instance"]]],[11,"to_owned","","",347,[[["self"]],["t"]]],[11,"clone_into","","",347,N],[11,"from","","",347,[[["t"]],["t"]]],[11,"to_string","","",347,[[["self"]],["string"]]],[11,"into","","",347,[[["self"]],["u"]]],[11,"try_from","","",347,[[["u"]],["result"]]],[11,"borrow","","",347,[[["self"]],["t"]]],[11,"try_into","","",347,[[["self"]],["result"]]],[11,"borrow_mut","","",347,[[["self"]],["t"]]],[11,"get_type_id","","",347,[[["self"]],["typeid"]]],[11,"encode","","",347,[[["self"],["e"]],["result"]]],[11,"decode","","",347,[[["d"]],["result"]]],[11,"not_found","","",347,[[["str"],["str"]],["e"]]],[11,"from_ok","","",347,[[["t"]],["t"]]],[11,"map_same","","",347,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",347,N],[11,"size_estimate","rustc_mir::monomorphize::item","",348,[[["self"],["tyctxt"]],["usize"]]],[11,"to_owned","","",348,[[["self"]],["t"]]],[11,"clone_into","","",348,N],[11,"from","","",348,[[["t"]],["t"]]],[11,"into","","",348,[[["self"]],["u"]]],[11,"try_from","","",348,[[["u"]],["result"]]],[11,"borrow","","",348,[[["self"]],["t"]]],[11,"try_into","","",348,[[["self"]],["result"]]],[11,"borrow_mut","","",348,[[["self"]],["t"]]],[11,"get_type_id","","",348,[[["self"]],["typeid"]]],[11,"not_found","","",348,[[["str"],["str"]],["e"]]],[11,"from_ok","","",348,[[["t"]],["t"]]],[11,"map_same","","",348,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::monomorphize::collector","",349,[[["t"]],["t"]]],[11,"into","","",349,[[["self"]],["u"]]],[11,"try_from","","",349,[[["u"]],["result"]]],[11,"borrow","","",349,[[["self"]],["t"]]],[11,"try_into","","",349,[[["self"]],["result"]]],[11,"borrow_mut","","",349,[[["self"]],["t"]]],[11,"get_type_id","","",349,[[["self"]],["typeid"]]],[11,"not_found","","",349,[[["str"],["str"]],["e"]]],[11,"from_ok","","",349,[[["t"]],["t"]]],[11,"map_same","","",349,[[["self"],["f"]],["t"]]],[11,"from","","",350,[[["t"]],["t"]]],[11,"into","","",350,[[["self"]],["u"]]],[11,"try_from","","",350,[[["u"]],["result"]]],[11,"borrow","","",350,[[["self"]],["t"]]],[11,"try_into","","",350,[[["self"]],["result"]]],[11,"borrow_mut","","",350,[[["self"]],["t"]]],[11,"get_type_id","","",350,[[["self"]],["typeid"]]],[11,"not_found","","",350,[[["str"],["str"]],["e"]]],[11,"from_ok","","",350,[[["t"]],["t"]]],[11,"map_same","","",350,[[["self"],["f"]],["t"]]],[11,"from","","",351,[[["t"]],["t"]]],[11,"into","","",351,[[["self"]],["u"]]],[11,"try_from","","",351,[[["u"]],["result"]]],[11,"borrow","","",351,[[["self"]],["t"]]],[11,"try_into","","",351,[[["self"]],["result"]]],[11,"borrow_mut","","",351,[[["self"]],["t"]]],[11,"get_type_id","","",351,[[["self"]],["typeid"]]],[11,"not_found","","",351,[[["str"],["str"]],["e"]]],[11,"from_ok","","",351,[[["t"]],["t"]]],[11,"map_same","","",351,[[["self"],["f"]],["t"]]],[11,"to_owned","","",352,[[["self"]],["t"]]],[11,"clone_into","","",352,N],[11,"from","","",352,[[["t"]],["t"]]],[11,"into","","",352,[[["self"]],["u"]]],[11,"try_from","","",352,[[["u"]],["result"]]],[11,"borrow","","",352,[[["self"]],["t"]]],[11,"try_into","","",352,[[["self"]],["result"]]],[11,"borrow_mut","","",352,[[["self"]],["t"]]],[11,"get_type_id","","",352,[[["self"]],["typeid"]]],[11,"not_found","","",352,[[["str"],["str"]],["e"]]],[11,"from_ok","","",352,[[["t"]],["t"]]],[11,"map_same","","",352,[[["self"],["f"]],["t"]]],[11,"from","rustc_mir::monomorphize::item","",353,[[["t"]],["t"]]],[11,"into","","",353,[[["self"]],["u"]]],[11,"try_from","","",353,[[["u"]],["result"]]],[11,"borrow","","",353,[[["self"]],["t"]]],[11,"try_into","","",353,[[["self"]],["result"]]],[11,"borrow_mut","","",353,[[["self"]],["t"]]],[11,"get_type_id","","",353,[[["self"]],["typeid"]]],[11,"not_found","","",353,[[["str"],["str"]],["e"]]],[11,"from_ok","","",353,[[["t"]],["t"]]],[11,"map_same","","",353,[[["self"],["f"]],["t"]]],[11,"to_owned","","",354,[[["self"]],["t"]]],[11,"clone_into","","",354,N],[11,"from","","",354,[[["t"]],["t"]]],[11,"into","","",354,[[["self"]],["u"]]],[11,"try_from","","",354,[[["u"]],["result"]]],[11,"borrow","","",354,[[["self"]],["t"]]],[11,"try_into","","",354,[[["self"]],["result"]]],[11,"borrow_mut","","",354,[[["self"]],["t"]]],[11,"get_type_id","","",354,[[["self"]],["typeid"]]],[11,"not_found","","",354,[[["str"],["str"]],["e"]]],[11,"from_ok","","",354,[[["t"]],["t"]]],[11,"map_same","","",354,[[["self"],["f"]],["t"]]],[11,"new","rustc_mir::monomorphize::partitioning","",356,[[["internedstring"]],["codegenunit"]]],[11,"name","","",356,[[["self"]],["internedstring"]]],[11,"set_name","","",356,N],[11,"items","","",356,[[["self"]],["hashmap"]]],[11,"items_mut","","",356,[[["self"]],["hashmap"]]],[11,"mangle_name","","",356,[[["str"]],["string"]]],[11,"estimate_size","","",356,N],[11,"size_estimate","","",356,[[["self"]],["usize"]]],[11,"modify_size_estimate","","",356,N],[11,"from","","",356,[[["t"]],["t"]]],[11,"into","","",356,[[["self"]],["u"]]],[11,"try_from","","",356,[[["u"]],["result"]]],[11,"borrow","","",356,[[["self"]],["t"]]],[11,"try_into","","",356,[[["self"]],["result"]]],[11,"borrow_mut","","",356,[[["self"]],["t"]]],[11,"get_type_id","","",356,[[["self"]],["typeid"]]],[11,"not_found","","",356,[[["str"],["str"]],["e"]]],[11,"from_ok","","",356,[[["t"]],["t"]]],[11,"map_same","","",356,[[["self"],["f"]],["t"]]],[11,"from","","",357,[[["t"]],["t"]]],[11,"into","","",357,[[["self"]],["u"]]],[11,"try_from","","",357,[[["u"]],["result"]]],[11,"borrow","","",357,[[["self"]],["t"]]],[11,"try_into","","",357,[[["self"]],["result"]]],[11,"borrow_mut","","",357,[[["self"]],["t"]]],[11,"get_type_id","","",357,[[["self"]],["typeid"]]],[11,"not_found","","",357,[[["str"],["str"]],["e"]]],[11,"from_ok","","",357,[[["t"]],["t"]]],[11,"map_same","","",357,[[["self"],["f"]],["t"]]],[11,"from","","",358,[[["t"]],["t"]]],[11,"into","","",358,[[["self"]],["u"]]],[11,"try_from","","",358,[[["u"]],["result"]]],[11,"borrow","","",358,[[["self"]],["t"]]],[11,"try_into","","",358,[[["self"]],["result"]]],[11,"borrow_mut","","",358,[[["self"]],["t"]]],[11,"get_type_id","","",358,[[["self"]],["typeid"]]],[11,"not_found","","",358,[[["str"],["str"]],["e"]]],[11,"from_ok","","",358,[[["t"]],["t"]]],[11,"map_same","","",358,[[["self"],["f"]],["t"]]],[11,"from","","",359,[[["t"]],["t"]]],[11,"into","","",359,[[["self"]],["u"]]],[11,"try_from","","",359,[[["u"]],["result"]]],[11,"borrow","","",359,[[["self"]],["t"]]],[11,"try_into","","",359,[[["self"]],["result"]]],[11,"borrow_mut","","",359,[[["self"]],["t"]]],[11,"get_type_id","","",359,[[["self"]],["typeid"]]],[11,"not_found","","",359,[[["str"],["str"]],["e"]]],[11,"from_ok","","",359,[[["t"]],["t"]]],[11,"map_same","","",359,[[["self"],["f"]],["t"]]],[11,"to_owned","","",360,[[["self"]],["t"]]],[11,"clone_into","","",360,N],[11,"from","","",360,[[["t"]],["t"]]],[11,"into","","",360,[[["self"]],["u"]]],[11,"try_from","","",360,[[["u"]],["result"]]],[11,"borrow","","",360,[[["self"]],["t"]]],[11,"try_into","","",360,[[["self"]],["result"]]],[11,"borrow_mut","","",360,[[["self"]],["t"]]],[11,"get_type_id","","",360,[[["self"]],["typeid"]]],[11,"not_found","","",360,[[["str"],["str"]],["e"]]],[11,"from_ok","","",360,[[["t"]],["t"]]],[11,"map_same","","",360,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_mir::const_eval","",363,[[["self"]],["t"]]],[11,"clone_into","","",363,N],[11,"from","","",363,[[["t"]],["t"]]],[11,"into","","",363,[[["self"]],["u"]]],[11,"try_from","","",363,[[["u"]],["result"]]],[11,"borrow","","",363,[[["self"]],["t"]]],[11,"try_into","","",363,[[["self"]],["result"]]],[11,"borrow_mut","","",363,[[["self"]],["t"]]],[11,"get_type_id","","",363,[[["self"]],["typeid"]]],[11,"not_found","","",363,[[["str"],["str"]],["e"]]],[11,"from_ok","","",363,[[["t"]],["t"]]],[11,"map_same","","",363,[[["self"],["f"]],["t"]]],[11,"to_owned","","",362,[[["self"]],["t"]]],[11,"clone_into","","",362,N],[11,"from","","",362,[[["t"]],["t"]]],[11,"to_string","","",362,[[["self"]],["string"]]],[11,"into","","",362,[[["self"]],["u"]]],[11,"try_from","","",362,[[["u"]],["result"]]],[11,"borrow","","",362,[[["self"]],["t"]]],[11,"try_into","","",362,[[["self"]],["result"]]],[11,"borrow_mut","","",362,[[["self"]],["t"]]],[11,"get_type_id","","",362,[[["self"]],["typeid"]]],[11,"not_found","","",362,[[["str"],["str"]],["e"]]],[11,"from_ok","","",362,[[["t"]],["t"]]],[11,"map_same","","",362,[[["self"],["f"]],["t"]]]],"paths":[[3,"MirBorrowckCtxt"],[3,"RootPlace"],[3,"SeenTy"],[3,"Context"],[4,"MutateMode"],[4,"ArtificialField"],[4,"ShallowOrDeep"],[4,"ReadOrWrite"],[4,"ReadKind"],[4,"WriteKind"],[4,"LocalMutationIsAllowed"],[4,"InitializationRequiringAction"],[4,"NoMovePathFound"],[4,"Overlap"],[4,"ContextKind"],[3,"BorrowSet"],[3,"BorrowData"],[3,"GatherBorrows"],[4,"TwoPhaseActivation"],[4,"LocalsStateAtExit"],[3,"IncludingDowncast"],[4,"UseSpans"],[3,"Flows"],[3,"LocationTable"],[3,"LocationIndex"],[4,"RichLocation"],[4,"GroupedMoveError"],[4,"AccessKind"],[4,"Control"],[8,"PlaceExt"],[3,"PlaceComponents"],[3,"PlaceComponentsIter"],[3,"Prefixes"],[4,"PrefixSet"],[8,"IsPrefixOf"],[3,"GatherUsedMutsVisitor"],[3,"ConstraintGeneration"],[4,"BorrowContainsPointReason"],[3,"UseFinder"],[3,"DefUseVisitor"],[4,"DefUseResult"],[3,"FactWriter"],[8,"AllFactsExt"],[8,"FactRow"],[8,"FactCell"],[3,"InvalidationGenerator"],[3,"RegionInferenceContext"],[3,"RegionDefinition"],[3,"TypeTest"],[4,"Cause"],[4,"RegionTest"],[4,"ConstraintCategory"],[4,"Trace"],[3,"RawConstraints"],[3,"SccConstraints"],[3,"RegionValueElements"],[3,"PointIndex"],[3,"PlaceholderIndex"],[3,"LivenessValues"],[3,"RegionValues"],[4,"RegionElement"],[8,"ToElementIndex"],[8,"ClosureRegionRequirementsExt"],[3,"NLLVisitor"],[3,"TypeVerifier"],[3,"TypeChecker"],[3,"BorrowCheckContext"],[3,"MirTypeckResults"],[3,"MirTypeckRegionConstraints"],[4,"FieldAccessError"],[4,"Locations"],[3,"ConstraintConversion"],[3,"UniversalRegionRelations"],[3,"CreateResult"],[3,"UniversalRegionRelationsBuilder"],[3,"ObligationAccumulator"],[3,"NllLivenessMap"],[3,"LiveVar"],[3,"LocalUseMap"],[3,"Appearance"],[3,"AppearanceIndex"],[3,"LocalUseMapBuild"],[3,"LivenessContext"],[3,"DropData"],[3,"LivenessResults"],[3,"TypeRelating"],[3,"ScopesAndKind"],[3,"BoundRegionScope"],[3,"UniversallyQuantified"],[3,"ScopeInstantiator"],[3,"TypeGeneralizer"],[8,"AtLocation"],[8,"NormalizeLocation"],[3,"TypeckMir"],[3,"UniversalRegions"],[3,"UniversalRegionIndices"],[3,"UniversalRegionsBuilder"],[4,"DefiningTy"],[4,"RegionClassification"],[8,"InferCtxtExt"],[3,"ConstraintSet"],[3,"OutlivesConstraint"],[3,"ConstraintIndex"],[3,"ConstraintSccIndex"],[3,"ConstraintGraph"],[3,"Edges"],[3,"RegionGraph"],[3,"Successors"],[8,"ConstraintGraphDirecton"],[3,"Normal"],[3,"Reverse"],[8,"ToRegionVid"],[3,"GlobalizeMir"],[3,"Builder"],[3,"GuardFrameLocal"],[3,"GuardFrame"],[3,"CFG"],[3,"ScopeId"],[3,"BlockAnd"],[3,"ArgInfo"],[4,"LocalsForNode"],[4,"ForGuard"],[4,"Category"],[4,"RvalueFunc"],[8,"EvalInto"],[3,"ArmHasGuard"],[3,"ArmBlocks"],[3,"Candidate"],[3,"Binding"],[3,"Ascription"],[3,"MatchPair"],[3,"Test"],[4,"TestKind"],[3,"Scope"],[3,"DropData"],[3,"CachedBlock"],[3,"BreakableScope"],[4,"DropKind"],[8,"BlockAndExtension"],[3,"DataflowBuilder"],[3,"DebugFormatted"],[3,"MoveDataParamEnv"],[3,"PropagationContext"],[3,"DataflowAnalysis"],[3,"DataflowResults"],[3,"DataflowState"],[3,"AllSets"],[3,"BlockSets"],[3,"FlowAtLocation"],[8,"FlowsAtLocation"],[3,"Graph"],[3,"Edge"],[8,"MirWithFlowState"],[3,"MaybeInitializedPlaces"],[3,"MaybeUninitializedPlaces"],[3,"DefinitelyInitializedPlaces"],[3,"EverInitializedPlaces"],[3,"MaybeStorageLive"],[3,"HaveBeenBorrowedLocals"],[3,"BorrowedLocalsVisitor"],[3,"Borrows"],[3,"StackEntry"],[3,"MovePath"],[3,"MoveData"],[3,"LocationMap"],[3,"MoveOut"],[3,"Init"],[3,"MovePathLookup"],[3,"IllegalMoveOrigin"],[4,"InitLocation"],[4,"InitKind"],[4,"LookupResult"],[4,"IllegalMoveOriginKind"],[4,"MoveError"],[8,"Lift"],[3,"AbstractOperand"],[3,"AbstractType"],[3,"MovePathIndex"],[3,"MoveOutIndex"],[3,"InitIndex"],[3,"BorrowIndex"],[3,"MoveDataBuilder"],[3,"Gatherer"],[8,"HasMoveData"],[8,"Dataflow"],[8,"DataflowResultsConsumer"],[8,"InitialFlow"],[8,"BitDenotation"],[3,"Block"],[3,"Stmt"],[3,"Expr"],[3,"FieldExprRef"],[3,"FruInfo"],[3,"Arm"],[4,"LintLevel"],[4,"BlockSafety"],[4,"StmtRef"],[4,"StmtKind"],[4,"ExprKind"],[4,"ExprRef"],[4,"Guard"],[4,"LogicalOp"],[3,"Cx"],[8,"ToBorrowKind"],[8,"ToRef"],[3,"FieldPattern"],[3,"Pattern"],[3,"PatternContext"],[4,"PatternError"],[4,"BindingMode"],[4,"PatternKind"],[4,"LitToConstError"],[3,"Matrix"],[3,"MatchCheckCtxt"],[3,"PatternContext"],[3,"Witness"],[3,"IntRange"],[4,"Constructor"],[4,"Usefulness"],[4,"WitnessPreference"],[3,"LiteralExpander"],[3,"OuterVisitor"],[3,"MatchVisitor"],[3,"MutationChecker"],[3,"AtBindingPatternVisitor"],[8,"PatternFoldable"],[8,"PatternFolder"],[8,"Mirror"],[3,"DropShimElaborator"],[3,"CloneShimBuilder"],[4,"Adjustment"],[4,"CallKind"],[3,"MirSource"],[3,"AddValidation"],[3,"AddMovesForPackedDrops"],[3,"GatherBorrowedRegions"],[3,"DeleteTrivialEndRegions"],[3,"CleanEndRegions"],[3,"CleanAscribeUserType"],[3,"DeleteAscribeUserType"],[3,"UnsafetyChecker"],[3,"UnusedUnsafeVisitor"],[3,"SimplifyBranches"],[3,"SimplifyCfg"],[3,"CfgSimplifier"],[3,"DeclMarker"],[3,"LocalUpdater"],[3,"SimplifyLocals"],[3,"EraseRegionsVisitor"],[3,"EraseRegions"],[3,"NoLandingPads"],[3,"SanityCheck"],[3,"InitializationData"],[3,"Elaborator"],[3,"ElaborateDropsCtxt"],[3,"ElaborateDrops"],[4,"AddCallGuards"],[3,"TempCollector"],[3,"Promoter"],[4,"TempState"],[4,"Candidate"],[3,"Qualif"],[3,"Qualifier"],[4,"Mode"],[3,"QualifyAndPromoteConstants"],[4,"PlaceMode"],[3,"RemoveNoopLandingPads"],[3,"Marker"],[3,"Disambiguator"],[3,"Deaggregator"],[3,"InstCombineVisitor"],[3,"OptimizationFinder"],[3,"OptimizationList"],[3,"InstCombine"],[3,"ConstantPropagationVisitor"],[4,"Action"],[3,"CopyPropagation"],[3,"ConstPropagator"],[3,"CanConstProp"],[3,"ConstProp"],[3,"RenameLocalVisitor"],[3,"SuspensionPoint"],[3,"TransformVisitor"],[3,"StorageIgnored"],[3,"BorrowedLocals"],[3,"DerefArgVisitor"],[3,"StateTransform"],[3,"CallSite"],[3,"Inliner"],[3,"Integrator"],[3,"Inline"],[4,"RhsKind"],[3,"Lower128Bit"],[3,"UniformArrayMoveOutVisitor"],[3,"LocalUse"],[3,"RestoreDataCollector"],[3,"UniformArrayMoveOut"],[3,"RestoreSubsliceArrayMoveOut"],[8,"MirPass"],[4,"PassWhere"],[4,"Origin"],[8,"BorrowckErrors"],[3,"DropCtxt"],[4,"DropFlagState"],[4,"DropStyle"],[4,"DropFlagMode"],[4,"Unwind"],[8,"DropElaborator"],[3,"DefUseAnalysis"],[3,"Info"],[3,"Use"],[3,"DefUseFinder"],[3,"MutateUseVisitor"],[3,"MirPatch"],[3,"ExtraComments"],[3,"LivenessResult"],[3,"IdentityMap"],[3,"DefsUsesVisitor"],[3,"DefsUses"],[4,"DefUse"],[8,"LiveVariableMap"],[3,"FindLocalAssignmentVisitor"],[8,"FindAssignments"],[3,"EvalContext"],[3,"Frame"],[3,"PlaceTy"],[3,"MemPlace"],[3,"MPlaceTy"],[3,"Memory"],[3,"ValTy"],[3,"OpTy"],[4,"StackPopCleanup"],[4,"LocalValue"],[4,"Place"],[4,"MemoryKind"],[4,"Value"],[4,"Operand"],[8,"Machine"],[3,"InfiniteLoopDetector"],[3,"AllocIdSnapshot"],[3,"AllocationSnapshot"],[3,"FrameSnapshot"],[3,"MemorySnapshot"],[3,"EvalSnapshot"],[8,"SnapshotContext"],[8,"Snapshot"],[4,"PathElem"],[3,"Instance"],[4,"MonoItem"],[3,"InliningMap"],[3,"MirNeighborCollector"],[3,"RootCollector"],[4,"MonoItemCollectionMode"],[3,"DefPathBasedNames"],[4,"InstantiationMode"],[8,"MonoItemExt"],[3,"CodegenUnit"],[3,"PreInliningPartitioning"],[3,"PostInliningPartitioning"],[4,"PartitioningStrategy"],[4,"MonoItemPlacement"],[8,"CodegenUnitExt"],[4,"ConstEvalError"],[3,"CompileTimeEvaluator"],[3,"ImplicitSelfBinding"]]};
searchIndex["rustc_passes"]={"doc":"Various checks","items":[[5,"provide","rustc_passes","",N,[[["providers"]]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0130","rustc_passes::diagnostics","",N,N],[0,"__register_diagnostic_E0197","","",N,N],[0,"__register_diagnostic_E0198","","",N,N],[0,"__register_diagnostic_E0267","","",N,N],[0,"__register_diagnostic_E0268","","",N,N],[0,"__register_diagnostic_E0379","","",N,N],[0,"__register_diagnostic_E0380","","",N,N],[0,"__register_diagnostic_E0449","","",N,N],[0,"__register_diagnostic_E0590","","",N,N],[0,"__register_diagnostic_E0571","","",N,N],[0,"__register_diagnostic_E0642","","",N,N],[0,"__register_diagnostic_E0695","","",N,N],[0,"__register_diagnostic_E0226","","",N,N],[0,"__register_diagnostic_E0472","","",N,N],[0,"__register_diagnostic_E0561","","",N,N],[0,"__register_diagnostic_E0567","","",N,N],[0,"__register_diagnostic_E0568","","",N,N],[0,"__register_diagnostic_E0666","","",N,N],[0,"__register_diagnostic_E0667","","",N,N],[0,"__register_diagnostic_E0696","","",N,N],[0,"__register_diagnostic_E0706","","",N,N],[0,"ast_validation","rustc_passes","",N,N],[3,"AstValidator","rustc_passes::ast_validation","",N,N],[12,"session","","",0,N],[3,"NestedImplTraitVisitor","","",N,N],[12,"session","","",1,N],[12,"outer_impl_trait","","",1,N],[3,"ImplTraitProjectionVisitor","","",N,N],[12,"session","","",2,N],[12,"is_banned","","",2,N],[5,"check_crate","","",N,[[["session"],["crate"]]]],[11,"err_handler","","",0,[[["self"]],["handler"]]],[11,"check_lifetime","","",0,[[["self"],["ident"]]]],[11,"check_label","","",0,[[["self"],["ident"]]]],[11,"invalid_non_exhaustive_attribute","","",0,[[["self"],["variant"]]]],[11,"invalid_visibility","","",0,[[["self"],["visibility"],["option",["str"]]]]],[11,"check_decl_no_pat","","",0,[[["self"],["fndecl"],["reportfn"]]]],[11,"check_trait_fn_not_async","","",0,[[["self"],["span"],["isasync"]]]],[11,"check_trait_fn_not_const","","",0,[[["self"],["spanned",["constness"]]]]],[11,"no_questions_in_bounds","","",0,[[["self"],["genericbounds"],["str"],["bool"]]]],[11,"check_expr_within_pat","","matches '-' lit | lit (cf. parser::Parser::parse_literal_maybe_minus), or path for ranges.",0,[[["self"],["expr"],["bool"]]]],[11,"check_late_bound_lifetime_defs","","",0,N],[11,"while_if_let_ambiguity","","With eRFC 2497, we need to check whether an expression is ambigious and warn or error depending on the edition, this function handles that.",0,[[["self"],["p"]]]],[11,"while_if_let_expr_ambiguity","","With eRFC 2497 adding if-let chains, there is a requirement that the parsing of `&&` and `||` in a if-let statement be unambigious. This function returns a span and a `BinOpKind` (either `&&` or `||` depending on what was ambigious) if it is determined that the current expression parsed is ambigious and will break in future.",0,[[["self"],["p"]],["option"]]],[11,"visit_expr","","",0,[[["self"],["expr"]]]],[11,"visit_ty","","",0,[[["self"],["ty"]]]],[11,"visit_use_tree","","",0,[[["self"],["usetree"],["nodeid"],["bool"]]]],[11,"visit_label","","",0,[[["self"],["label"]]]],[11,"visit_lifetime","","",0,[[["self"],["lifetime"]]]],[11,"visit_item","","",0,[[["self"],["item"]]]],[11,"visit_foreign_item","","",0,[[["self"],["foreignitem"]]]],[11,"visit_vis","","",0,[[["self"],["visibility"]]]],[11,"visit_generics","","",0,[[["self"],["generics"]]]],[11,"visit_generic_param","","",0,[[["self"],["genericparam"]]]],[11,"visit_pat","","",0,[[["self"],["pat"]]]],[11,"visit_where_predicate","","",0,[[["self"],["wherepredicate"]]]],[11,"visit_poly_trait_ref","","",0,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_mac","","",0,[[["self"],["spanned"]]]],[11,"with_impl_trait","","",1,[[["self"],["option",["span"]],["f"]]]],[11,"visit_ty","","",1,[[["self"],["ty"]]]],[11,"visit_generic_args","","",1,[[["self"],["span"],["genericargs"]]]],[11,"visit_mac","","",1,[[["self"],["spanned"]]]],[11,"with_ban","","",2,[[["self"],["f"]]]],[11,"visit_ty","","",2,[[["self"],["ty"]]]],[11,"visit_mac","","",2,[[["self"],["spanned"]]]],[0,"rvalue_promotion","rustc_passes","",N,N],[3,"CheckCrateVisitor","rustc_passes::rvalue_promotion","",N,N],[12,"tcx","","",3,N],[12,"in_fn","","",3,N],[12,"in_static","","",3,N],[12,"mut_rvalue_borrows","","",3,N],[12,"param_env","","",3,N],[12,"identity_substs","","",3,N],[12,"tables","","",3,N],[12,"result","","",3,N],[4,"Promotability","","",N,N],[13,"Promotable","","",4,N],[13,"NotPromotable","","",4,N],[5,"provide","","",N,[[["providers"]]]],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"const_is_rvalue_promotable_to_static","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"rvalue_promotable_map","","",N,[[["tyctxt"],["defid"]],["lrc",["itemlocalset"]]]],[5,"check_expr_kind","","This function is used to enforce the constraints on const/static items. It walks through the value of the item walking down the expression and evaluating every nested expression. If the expression is not part of a const/static item, it is qualified for promotion instead of producing errors.",N,[[["checkcratevisitor"],["expr"],["ty"]],["promotability"]]],[5,"check_adjustments","","Check the adjustments of an expression",N,[[["checkcratevisitor"],["expr"]],["promotability"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",4,[[["self"]],["promotability"]]],[11,"eq","","",4,[[["self"],["promotability"]],["bool"]]],[11,"bitand","","",4,[[["self"],["self"]],["self"]]],[11,"bitand_assign","","",4,[[["self"],["self"]]]],[11,"bitor","","",4,[[["self"],["self"]],["self"]]],[11,"type_promotability","","",3,[[["self"],["ty"]],["promotability"]]],[11,"handle_const_fn_call","","",3,[[["self"],["defid"],["ty"],["span"]],["promotability"]]],[11,"remove_mut_rvalue_borrow","","While the `ExprUseVisitor` walks, we will identify which expressions are borrowed, and insert their ids into this table. Actually, we insert the \"borrow-id\", which is normally the id of the expession being borrowed: but in the case of `ref mut` borrows, the `id` of the pattern is inserted. Therefore later we remove that entry from the table and transfer it over to the value being matched. This will then prevent said value from being promoted.",3,[[["self"],["pat"]],["bool"]]],[11,"check_nested_body","","",3,[[["self"],["bodyid"]],["promotability"]]],[11,"check_stmt","","",3,[[["self"],["stmt"]],["promotability"]]],[11,"check_expr","","",3,[[["self"],["expr"]],["promotability"]]],[11,"check_block","","",3,[[["self"],["block"]],["promotability"]]],[11,"consume","","",3,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[11,"borrow","","",3,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[11,"decl_without_init","","",3,[[["self"],["nodeid"],["span"]]]],[11,"mutate","","",3,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[11,"matched_pat","","",3,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[11,"consume_pat","","",3,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[0,"hir_stats","rustc_passes","",N,N],[3,"NodeData","rustc_passes::hir_stats","",N,N],[12,"count","","",5,N],[12,"size","","",5,N],[3,"StatCollector","","",N,N],[12,"krate","","",6,N],[12,"data","","",6,N],[12,"seen","","",6,N],[4,"Id","","",N,N],[13,"Node","","",7,N],[13,"Attr","","",7,N],[13,"None","","",7,N],[5,"print_hir_stats","","",N,[[["crate"]]]],[5,"print_ast_stats","","",N,[[["crate"],["str"]]]],[11,"clone","","",7,[[["self"]],["id"]]],[11,"eq","","",7,[[["self"],["id"]],["bool"]]],[11,"ne","","",7,[[["self"],["id"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"hash","","",7,N],[11,"record","","",6,[[["self"],["str"],["id"],["t"]]]],[11,"print","","",6,[[["self"],["str"]]]],[11,"nested_visit_map","","",6,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_item","","",6,[[["self"],["itemid"]]]],[11,"visit_nested_trait_item","","",6,[[["self"],["traititemid"]]]],[11,"visit_nested_impl_item","","",6,[[["self"],["implitemid"]]]],[11,"visit_nested_body","","",6,[[["self"],["bodyid"]]]],[11,"visit_item","","",6,[[["self"],["item"]]]],[11,"visit_mod","","",6,[[["self"],["mod"],["span"],["nodeid"]]]],[11,"visit_foreign_item","","",6,[[["self"],["foreignitem"]]]],[11,"visit_local","","",6,[[["self"],["local"]]]],[11,"visit_block","","",6,[[["self"],["block"]]]],[11,"visit_stmt","","",6,[[["self"],["stmt"]]]],[11,"visit_arm","","",6,[[["self"],["arm"]]]],[11,"visit_pat","","",6,[[["self"],["pat"]]]],[11,"visit_decl","","",6,[[["self"],["decl"]]]],[11,"visit_expr","","",6,[[["self"],["expr"]]]],[11,"visit_ty","","",6,[[["self"],["ty"]]]],[11,"visit_fn","","",6,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_where_predicate","","",6,[[["self"],["wherepredicate"]]]],[11,"visit_trait_item","","",6,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",6,[[["self"],["implitem"]]]],[11,"visit_param_bound","","",6,[[["self"],["genericbound"]]]],[11,"visit_struct_field","","",6,[[["self"],["structfield"]]]],[11,"visit_variant","","",6,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_lifetime","","",6,[[["self"],["lifetime"]]]],[11,"visit_qpath","","",6,[[["self"],["qpath"],["hirid"],["span"]]]],[11,"visit_path","","",6,[[["self"],["path"],["hirid"]]]],[11,"visit_path_segment","","",6,[[["self"],["span"],["pathsegment"]]]],[11,"visit_assoc_type_binding","","",6,[[["self"],["typebinding"]]]],[11,"visit_attribute","","",6,[[["self"],["attribute"]]]],[11,"visit_macro_def","","",6,[[["self"],["macrodef"]]]],[11,"visit_mod","","",6,N],[11,"visit_foreign_item","","",6,[[["self"],["foreignitem"]]]],[11,"visit_item","","",6,[[["self"],["item"]]]],[11,"visit_local","","",6,[[["self"],["local"]]]],[11,"visit_block","","",6,[[["self"],["block"]]]],[11,"visit_stmt","","",6,[[["self"],["stmt"]]]],[11,"visit_arm","","",6,[[["self"],["arm"]]]],[11,"visit_pat","","",6,[[["self"],["pat"]]]],[11,"visit_expr","","",6,[[["self"],["expr"]]]],[11,"visit_ty","","",6,[[["self"],["ty"]]]],[11,"visit_fn","","",6,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_trait_item","","",6,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",6,[[["self"],["implitem"]]]],[11,"visit_param_bound","","",6,[[["self"],["genericbound"]]]],[11,"visit_struct_field","","",6,[[["self"],["structfield"]]]],[11,"visit_variant","","",6,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_lifetime","","",6,[[["self"],["lifetime"]]]],[11,"visit_mac","","",6,[[["self"],["mac"]]]],[11,"visit_path_segment","","",6,[[["self"],["span"],["pathsegment"]]]],[11,"visit_assoc_type_binding","","",6,[[["self"],["typebinding"]]]],[11,"visit_attribute","","",6,[[["self"],["attribute"]]]],[0,"loops","rustc_passes","",N,N],[3,"CheckLoopVisitor","rustc_passes::loops","",N,N],[12,"sess","","",8,N],[12,"hir_map","","",8,N],[12,"cx","","",8,N],[4,"LoopKind","","",N,N],[13,"Loop","","",9,N],[13,"WhileLoop","","",9,N],[4,"Context","","",N,N],[13,"Normal","","",10,N],[13,"Loop","","",10,N],[13,"Closure","","",10,N],[13,"LabeledBlock","","",10,N],[13,"AnonConst","","",10,N],[5,"check_crate","","",N,[[["session"],["map"]]]],[11,"clone","","",9,[[["self"]],["loopkind"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"eq","","",9,[[["self"],["loopkind"]],["bool"]]],[11,"ne","","",9,[[["self"],["loopkind"]],["bool"]]],[11,"name","","",9,[[["self"]],["str"]]],[11,"clone","","",10,[[["self"]],["context"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"eq","","",10,[[["self"],["context"]],["bool"]]],[11,"ne","","",10,[[["self"],["context"]],["bool"]]],[11,"clone","","",8,[[["self"]],["checkloopvisitor"]]],[11,"nested_visit_map","","",8,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",8,[[["self"],["item"]]]],[11,"visit_impl_item","","",8,[[["self"],["implitem"]]]],[11,"visit_anon_const","","",8,[[["self"],["anonconst"]]]],[11,"visit_expr","","",8,[[["self"],["expr"]]]],[11,"with_context","","",8,[[["self"],["context"],["f"]]]],[11,"require_break_cx","","",8,[[["self"],["str"],["span"]]]],[11,"require_label_in_labeled_block","","",8,[[["self"],["span"],["destination"],["str"]],["bool"]]],[11,"emit_unlabled_cf_in_while_condition","","",8,[[["self"],["span"],["str"]]]],[0,"mir_stats","rustc_passes","",N,N],[3,"NodeData","rustc_passes::mir_stats","",N,N],[12,"count","","",11,N],[12,"size","","",11,N],[3,"StatCollector","","",N,N],[12,"_tcx","","",12,N],[12,"data","","",12,N],[11,"record_with_size","","",12,[[["self"],["str"],["usize"]]]],[11,"record","","",12,[[["self"],["str"],["t"]]]],[11,"visit_mir","","",12,[[["self"],["mir"]]]],[11,"visit_basic_block_data","","",12,[[["self"],["basicblock"],["basicblockdata"]]]],[11,"visit_source_scope_data","","",12,[[["self"],["sourcescopedata"]]]],[11,"visit_statement","","",12,[[["self"],["basicblock"],["statement"],["location"]]]],[11,"visit_terminator","","",12,[[["self"],["basicblock"],["terminator"],["location"]]]],[11,"visit_terminator_kind","","",12,[[["self"],["basicblock"],["terminatorkind"],["location"]]]],[11,"visit_assert_message","","",12,[[["self"],["assertmessage"],["location"]]]],[11,"visit_rvalue","","",12,[[["self"],["rvalue"],["location"]]]],[11,"visit_operand","","",12,[[["self"],["operand"],["location"]]]],[11,"visit_place","","",12,[[["self"],["place"],["placecontext"],["location"]]]],[11,"visit_projection","","",12,[[["self"],["placeprojection"],["placecontext"],["location"]]]],[11,"visit_projection_elem","","",12,[[["self"],["placeelem"],["placecontext"],["location"]]]],[11,"visit_constant","","",12,[[["self"],["constant"],["location"]]]],[11,"visit_source_info","","",12,[[["self"],["sourceinfo"]]]],[11,"visit_closure_substs","","",12,[[["self"],["closuresubsts"],["location"]]]],[11,"visit_const","","",12,[[["self"],["const"],["location"]]]],[11,"visit_local_decl","","",12,[[["self"],["local"],["localdecl"]]]],[11,"visit_source_scope","","",12,[[["self"],["sourcescope"]]]],[17,"DIAGNOSTICS","rustc_passes","",N,N],[11,"from","rustc_passes::ast_validation","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","rustc_passes::rvalue_promotion","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"from","rustc_passes::hir_stats","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_passes::loops","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"from","rustc_passes::mir_stats","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]]],"paths":[[3,"AstValidator"],[3,"NestedImplTraitVisitor"],[3,"ImplTraitProjectionVisitor"],[3,"CheckCrateVisitor"],[4,"Promotability"],[3,"NodeData"],[3,"StatCollector"],[4,"Id"],[3,"CheckLoopVisitor"],[4,"LoopKind"],[4,"Context"],[3,"NodeData"],[3,"StatCollector"]]};
searchIndex["rustc_platform_intrinsics"]={"doc":"","items":[[3,"Intrinsic","rustc_platform_intrinsics","",N,N],[12,"inputs","","",0,N],[12,"output","","",0,N],[12,"definition","","",0,N],[4,"Type","","",N,N],[13,"Void","","",1,N],[13,"Integer","","",1,N],[13,"Float","","",1,N],[13,"Pointer","","",1,N],[13,"Vector","","",1,N],[13,"Aggregate","","",1,N],[4,"IntrinsicDef","","",N,N],[13,"Named","","",2,N],[0,"x86","","",N,N],[5,"find","rustc_platform_intrinsics::x86","",N,[[["str"]],["option",["intrinsic"]]]],[0,"arm","rustc_platform_intrinsics","",N,N],[5,"find","rustc_platform_intrinsics::arm","",N,[[["str"]],["option",["intrinsic"]]]],[0,"aarch64","rustc_platform_intrinsics","",N,N],[5,"find","rustc_platform_intrinsics::aarch64","",N,[[["str"]],["option",["intrinsic"]]]],[0,"nvptx","rustc_platform_intrinsics","",N,N],[5,"find","rustc_platform_intrinsics::nvptx","",N,[[["str"]],["option",["intrinsic"]]]],[0,"hexagon","rustc_platform_intrinsics","",N,N],[5,"find","rustc_platform_intrinsics::hexagon","",N,[[["str"]],["option",["intrinsic"]]]],[0,"powerpc","rustc_platform_intrinsics","",N,N],[5,"find","rustc_platform_intrinsics::powerpc","",N,[[["str"]],["option",["intrinsic"]]]],[7,"I8","rustc_platform_intrinsics","",N,N],[7,"I16","","",N,N],[7,"I32","","",N,N],[7,"I64","","",N,N],[7,"U8","","",N,N],[7,"U16","","",N,N],[7,"U32","","",N,N],[7,"U64","","",N,N],[7,"F32","","",N,N],[7,"F64","","",N,N],[7,"I32_8","","",N,N],[7,"I8x8","","",N,N],[7,"U8x8","","",N,N],[7,"I8x16","","",N,N],[7,"U8x16","","",N,N],[7,"I8x32","","",N,N],[7,"U8x32","","",N,N],[7,"I8x64","","",N,N],[7,"U8x64","","",N,N],[7,"I8x128","","",N,N],[7,"U8x128","","",N,N],[7,"I8x256","","",N,N],[7,"U8x256","","",N,N],[7,"I16x4","","",N,N],[7,"U16x4","","",N,N],[7,"I16x8","","",N,N],[7,"U16x8","","",N,N],[7,"I16x16","","",N,N],[7,"U16x16","","",N,N],[7,"I16x32","","",N,N],[7,"U16x32","","",N,N],[7,"I16x64","","",N,N],[7,"U16x64","","",N,N],[7,"I16x128","","",N,N],[7,"U16x128","","",N,N],[7,"I32x2","","",N,N],[7,"U32x2","","",N,N],[7,"I32x4","","",N,N],[7,"U32x4","","",N,N],[7,"I32x8","","",N,N],[7,"U32x8","","",N,N],[7,"I32x16","","",N,N],[7,"U32x16","","",N,N],[7,"I32x32","","",N,N],[7,"U32x32","","",N,N],[7,"I32x64","","",N,N],[7,"U32x64","","",N,N],[7,"I64x1","","",N,N],[7,"U64x1","","",N,N],[7,"I64x2","","",N,N],[7,"U64x2","","",N,N],[7,"I64x4","","",N,N],[7,"U64x4","","",N,N],[7,"F32x2","","",N,N],[7,"F32x4","","",N,N],[7,"F32x8","","",N,N],[7,"F64x1","","",N,N],[7,"F64x2","","",N,N],[7,"F64x4","","",N,N],[7,"I32x4_F32","","",N,N],[7,"I32x8_F32","","",N,N],[7,"I64x2_F64","","",N,N],[7,"I64x4_F64","","",N,N],[7,"VOID","","",N,N],[11,"clone","","",1,[[["self"]],["type"]]],[11,"hash","","",1,N],[11,"assert_receiver_is_total_eq","","",1,N],[11,"eq","","",1,[[["self"],["type"]],["bool"]]],[11,"ne","","",1,[[["self"],["type"]],["bool"]]],[11,"find","","",0,[[["str"]],["option",["intrinsic"]]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]]],"paths":[[3,"Intrinsic"],[4,"Type"],[4,"IntrinsicDef"]]};
searchIndex["rustc_plugin"]={"doc":"Infrastructure for compiler plugins.","items":[[0,"diagnostics","rustc_plugin","",N,N],[0,"__register_diagnostic_E0498","rustc_plugin::diagnostics","",N,N],[0,"registry","rustc_plugin","Used by plugin crates to tell `rustc` about the plugins they provide.",N,N],[3,"Registry","rustc_plugin::registry","Structure used to register plugins.",N,N],[12,"sess","","Compiler session. Useful if you want to emit diagnostic messages from the plugin registrar.",0,N],[12,"args_hidden","","",0,N],[12,"krate_span","","",0,N],[12,"syntax_exts","","",0,N],[12,"early_lint_passes","","",0,N],[12,"late_lint_passes","","",0,N],[12,"lint_groups","","",0,N],[12,"llvm_passes","","",0,N],[12,"attributes","","",0,N],[12,"whitelisted_custom_derives","","",0,N],[11,"new","","",0,[[["session"],["span"]],["registry"]]],[11,"args","","Get the plugin's arguments, if any.",0,N],[11,"register_syntax_extension","","Register a syntax extension of any kind.",0,[[["self"],["name"],["syntaxextension"]]]],[11,"register_custom_derive","","This can be used in place of `register_syntax_extension` to register legacy custom derives (i.e. attribute syntax extensions whose name begins with `derive_`). Legacy custom derives defined by this function do not trigger deprecation warnings when used.",0,[[["self"],["name"],["syntaxextension"]]]],[11,"take_whitelisted_custom_derives","","",0,[[["self"]],["vec",["name"]]]],[11,"register_macro","","Register a macro of the usual kind.",0,[[["self"],["str"],["macroexpanderfn"]]]],[11,"register_early_lint_pass","","Register a compiler lint pass.",0,[[["self"],["earlylintpassobject"]]]],[11,"register_late_lint_pass","","Register a compiler lint pass.",0,[[["self"],["latelintpassobject"]]]],[11,"register_lint_group","","Register a lint group.",0,[[["self"],["str"],["option",["str"]],["vec",["lint"]]]]],[11,"register_llvm_pass","","Register an LLVM pass.",0,[[["self"],["str"]]]],[11,"register_attribute","","Register an attribute with an attribute type.",0,[[["self"],["string"],["attributetype"]]]],[0,"load","rustc_plugin","Used by `rustc` when loading a plugin.",N,N],[3,"PluginRegistrar","rustc_plugin::load","",N,N],[12,"fun","","",1,N],[12,"args","","",1,N],[3,"PluginLoader","","",N,N],[12,"sess","","",2,N],[12,"reader","","",2,N],[12,"plugins","","",2,N],[5,"call_malformed_plugin_attribute","","",N,[[["session"],["span"]]]],[5,"load_plugins","","Read plugin metadata and dynamically load registrar functions.",N,[[["session"],["cstore"],["crate"],["str"],["option",["vec"]]],["vec",["pluginregistrar"]]]],[6,"PluginRegistrarFun","","Pointer to a registrar function.",N,N],[11,"new","","",2,[[["session"],["cstore"],["str"]],["self"]]],[11,"load_plugin","","",2,[[["self"],["span"],["str"],["vec",["nestedmetaitem"]]]]],[11,"dylink_registrar","","",2,[[["self"],["span"],["pathbuf"],["string"]],["pluginregistrarfun"]]],[0,"build","rustc_plugin","Used by `rustc` when compiling a plugin crate.",N,N],[3,"RegistrarFinder","rustc_plugin::build","",N,N],[12,"registrars","","",3,N],[5,"find_plugin_registrar","","Find the function marked with `#[plugin_registrar]`, if any.",N,[[["handler"],["map"]],["option",["nodeid"]]]],[11,"visit_item","","",3,[[["self"],["item"]]]],[11,"visit_trait_item","","",3,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",3,[[["self"],["implitem"]]]],[17,"DIAGNOSTICS","rustc_plugin","",N,N],[11,"from","rustc_plugin::registry","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","rustc_plugin::load","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","rustc_plugin::build","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]]],"paths":[[3,"Registry"],[3,"PluginRegistrar"],[3,"PluginLoader"],[3,"RegistrarFinder"]]};
searchIndex["rustc_privacy"]={"doc":"","items":[[3,"PubRestrictedVisitor","rustc_privacy","Visitor used to determine if pub(restricted) is used anywhere in the crate.",N,N],[12,"tcx","","",0,N],[12,"has_pub_restricted","","",0,N],[3,"EmbargoVisitor","","The embargo visitor, used to determine the exports of the ast",N,N],[12,"tcx","","",1,N],[12,"access_levels","","",1,N],[12,"prev_level","","",1,N],[12,"changed","","",1,N],[3,"ReachEverythingInTheInterfaceVisitor","","",N,N],[12,"access_level","","",2,N],[12,"item_def_id","","",2,N],[12,"ev","","",2,N],[3,"NamePrivacyVisitor","","Name privacy visitor, checks privacy and reports violations. Most of name privacy checks are performed during the main resolution phase, or later in type checking when field accesses and associated items are resolved. This pass performs remaining checks for fields in struct expressions and patterns.",N,N],[12,"tcx","","",3,N],[12,"tables","","",3,N],[12,"current_item","","",3,N],[12,"empty_tables","","",3,N],[3,"TypePrivacyVisitor","","Type privacy visitor, checks types for privacy and reports violations. Both explicitly written types and inferred types of expressions and patters are checked. Checks are performed on \"semantic\" types regardless of names and their hygiene.",N,N],[12,"tcx","","",4,N],[12,"tables","","",4,N],[12,"current_item","","",4,N],[12,"in_body","","",4,N],[12,"span","","",4,N],[12,"empty_tables","","",4,N],[12,"visited_opaque_tys","","",4,N],[3,"ObsoleteVisiblePrivateTypesVisitor","","Obsolete visitors for checking for private items in public interfaces. These visitors are supposed to be kept in frozen state and produce an \"old error node set\". For backward compatibility the new visitor reports warnings instead of hard errors when the erroneous node is not in this old set.",N,N],[12,"tcx","","",5,N],[12,"access_levels","","",5,N],[12,"in_variant","","",5,N],[12,"old_error_set","","",5,N],[3,"ObsoleteCheckTypeForPrivatenessVisitor","","",N,N],[12,"inner","","",6,N],[12,"contains_private","","whether the type refers to private types.",6,N],[12,"at_outer_type","","whether we've recurred at all (i.e. if we're pointing at the first type on which visit_ty was called).",6,N],[12,"outer_type_is_public_path","","",6,N],[3,"SearchInterfaceForPrivateItemsVisitor","","SearchInterfaceForPrivateItemsVisitor traverses an item's interface and finds any private components in it. PrivateItemsInPublicInterfacesVisitor ensures there are no private types and traits in public interfaces.",N,N],[12,"tcx","","",7,N],[12,"item_def_id","","",7,N],[12,"span","","",7,N],[12,"required_visibility","","The visitor checks that each component type is at least this visible",7,N],[12,"min_visibility","","The visibility of the least visible component that has been visited",7,N],[12,"has_pub_restricted","","",7,N],[12,"has_old_errors","","",7,N],[12,"in_assoc_ty","","",7,N],[3,"PrivateItemsInPublicInterfacesVisitor","","",N,N],[12,"tcx","","",8,N],[12,"has_pub_restricted","","",8,N],[12,"old_error_set","","",8,N],[12,"inner_visibility","","",8,N],[5,"update_tables","","",N,[[["tyctxt"],["nodeid"],["typecktables"],["typecktables"]],["typecktables"]]],[5,"provide","","",N,[[["providers"]]]],[5,"check_crate","","",N,[[["tyctxt"]],["lrc",["accesslevels"]]]],[5,"privacy_access_levels","","",N,[[["tyctxt"],["cratenum"]],["lrc",["accesslevels"]]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0445","rustc_privacy::diagnostics","",N,N],[0,"__register_diagnostic_E0446","","",N,N],[0,"__register_diagnostic_E0447","","",N,N],[0,"__register_diagnostic_E0448","","",N,N],[0,"__register_diagnostic_E0451","","",N,N],[17,"DIAGNOSTICS","rustc_privacy","",N,N],[11,"nested_visit_map","","",0,[[["self"]],["nestedvisitormap"]]],[11,"visit_vis","","",0,[[["self"],["visibility"]]]],[11,"item_ty_level","","",1,[[["self"],["defid"]],["option",["accesslevel"]]]],[11,"impl_trait_level","","",1,[[["self"],["defid"]],["option",["accesslevel"]]]],[11,"get","","",1,[[["self"],["nodeid"]],["option",["accesslevel"]]]],[11,"update","","",1,[[["self"],["nodeid"],["option",["accesslevel"]]],["option",["accesslevel"]]]],[11,"reach","","",1,[[["self"],["nodeid"]],["reacheverythingintheinterfacevisitor"]]],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",1,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",1,[[["self"],["item"]]]],[11,"visit_block","","",1,[[["self"],["block"]]]],[11,"visit_mod","","",1,[[["self"],["mod"],["span"],["nodeid"]]]],[11,"visit_macro_def","","",1,[[["self"],["macrodef"]]]],[11,"generics","","",2,[[["self"]],["self"]]],[11,"predicates","","",2,[[["self"]],["self"]]],[11,"ty","","",2,[[["self"]],["self"]]],[11,"impl_trait_ref","","",2,[[["self"]],["self"]]],[11,"check_trait_ref","","",2,[[["self"],["traitref"]]]],[11,"visit_ty","","",2,[[["self"],["ty"]],["bool"]]],[11,"check_field","","",3,[[["self"],["span"],["span"],["adtdef"],["fielddef"]]]],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",3,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",3,[[["self"],["bodyid"]]]],[11,"visit_item","","",3,[[["self"],["item"]]]],[11,"visit_trait_item","","",3,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",3,[[["self"],["implitem"]]]],[11,"visit_expr","","",3,[[["self"],["expr"]]]],[11,"visit_pat","","",3,[[["self"],["pat"]]]],[11,"def_id_visibility","","",4,[[["self"],["defid"]],["visibility"]]],[11,"item_is_accessible","","",4,[[["self"],["defid"]],["bool"]]],[11,"check_expr_pat_type","","",4,[[["self"],["hirid"],["span"]],["bool"]]],[11,"check_trait_ref","","",4,[[["self"],["traitref"]],["bool"]]],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",4,[[["self"]],["nestedvisitormap"]]],[11,"visit_nested_body","","",4,[[["self"],["bodyid"]]]],[11,"visit_ty","","",4,[[["self"],["ty"]]]],[11,"visit_trait_ref","","",4,[[["self"],["traitref"]]]],[11,"visit_expr","","",4,[[["self"],["expr"]]]],[11,"visit_qpath","","",4,[[["self"],["qpath"],["hirid"],["span"]]]],[11,"visit_pat","","",4,[[["self"],["pat"]]]],[11,"visit_local","","",4,[[["self"],["local"]]]],[11,"visit_item","","",4,[[["self"],["item"]]]],[11,"visit_trait_item","","",4,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",4,[[["self"],["implitem"]]]],[11,"visit_ty","","",4,[[["self"],["ty"]],["bool"]]],[11,"path_is_private_type","","",5,[[["self"],["path"]],["bool"]]],[11,"trait_is_public","","",5,[[["self"],["nodeid"]],["bool"]]],[11,"check_generic_bound","","",5,[[["self"],["genericbound"]]]],[11,"item_is_public","","",5,[[["self"],["nodeid"],["visibility"]],["bool"]]],[11,"nested_visit_map","","",6,[[["self"]],["nestedvisitormap"]]],[11,"visit_ty","","",6,[[["self"],["ty"]]]],[11,"visit_expr","","",6,[[["self"],["expr"]]]],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",5,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",5,[[["self"],["item"]]]],[11,"visit_generics","","",5,[[["self"],["generics"]]]],[11,"visit_foreign_item","","",5,[[["self"],["foreignitem"]]]],[11,"visit_ty","","",5,[[["self"],["ty"]]]],[11,"visit_variant","","",5,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_struct_field","","",5,[[["self"],["structfield"]]]],[11,"visit_block","","",5,[[["self"],["block"]]]],[11,"visit_expr","","",5,[[["self"],["expr"]]]],[11,"generics","","",7,[[["self"]],["self"]]],[11,"predicates","","",7,[[["self"]],["self"]]],[11,"ty","","",7,[[["self"]],["self"]]],[11,"impl_trait_ref","","",7,[[["self"]],["self"]]],[11,"check_trait_ref","","",7,[[["self"],["traitref"]]]],[11,"visit_ty","","",7,[[["self"],["ty"]],["bool"]]],[11,"check","","",8,[[["self"],["nodeid"],["visibility"]],["searchinterfaceforprivateitemsvisitor"]]],[11,"nested_visit_map","","",8,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",8,[[["self"],["item"]]]],[11,"visit_impl_item","","",8,[[["self"],["implitem"]]]],[11,"visit_expr","","",8,[[["self"],["expr"]]]],[11,"visit_pat","","",8,[[["self"],["pat"]]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]]],"paths":[[3,"PubRestrictedVisitor"],[3,"EmbargoVisitor"],[3,"ReachEverythingInTheInterfaceVisitor"],[3,"NamePrivacyVisitor"],[3,"TypePrivacyVisitor"],[3,"ObsoleteVisiblePrivateTypesVisitor"],[3,"ObsoleteCheckTypeForPrivatenessVisitor"],[3,"SearchInterfaceForPrivateItemsVisitor"],[3,"PrivateItemsInPublicInterfacesVisitor"]]};
searchIndex["rustc_resolve"]={"doc":"","items":[[4,"Namespace","rustc_resolve","Different kinds of symbols don't influence each other.",N,N],[13,"TypeNS","","",0,N],[13,"ValueNS","","",0,N],[13,"MacroNS","","",0,N],[3,"PerNS","","Just a helper ‒ separate structure for each namespace.",N,N],[12,"value_ns","","",1,N],[12,"type_ns","","",1,N],[12,"macro_ns","","",1,N],[3,"ImportSuggestion","","A free importable items suggested in case of resolution failure.",N,N],[12,"path","","",2,N],[3,"BindingError","","",N,N],[12,"name","","",3,N],[12,"origin","","",3,N],[12,"target","","",3,N],[3,"BindingInfo","","",N,N],[12,"span","","",4,N],[12,"binding_mode","","",4,N],[3,"UsePlacementFinder","","",N,N],[12,"target_module","","",5,N],[12,"span","","",5,N],[12,"found_use","","",5,N],[3,"Rib","","One local scope.",N,N],[12,"bindings","","",6,N],[12,"kind","","",6,N],[3,"ModuleData","","One node in the tree of modules.",N,N],[12,"parent","","",7,N],[12,"kind","","",7,N],[12,"normal_ancestor_id","","",7,N],[12,"resolutions","","",7,N],[12,"legacy_macro_resolutions","","",7,N],[12,"macro_resolutions","","",7,N],[12,"builtin_attrs","","",7,N],[12,"unresolved_invocations","","",7,N],[12,"no_implicit_prelude","","",7,N],[12,"glob_importers","","",7,N],[12,"globs","","",7,N],[12,"traits","","",7,N],[12,"populated","","",7,N],[12,"span","","Span of the module itself. Used for error reporting.",7,N],[12,"expansion","","",7,N],[3,"NameBinding","","Records a possibly-private value, type, or module definition.",N,N],[12,"kind","","",8,N],[12,"expansion","","",8,N],[12,"span","","",8,N],[12,"vis","","",8,N],[3,"PrivacyError","","",N,N],[12,"0","","",9,N],[12,"1","","",9,N],[12,"2","","",9,N],[3,"UseError","","",N,N],[12,"err","","",10,N],[12,"candidates","","Attach `use` statements for these candidates",10,N],[12,"node_id","","The node id of the module to place the use statements in",10,N],[12,"better","","Whether the diagnostic should state that it's \"better\"",10,N],[3,"AmbiguityError","","",N,N],[12,"ident","","",11,N],[12,"b1","","",11,N],[12,"b2","","",11,N],[3,"PrimitiveTypeTable","","Interns the names of the primitive types.",N,N],[12,"primitive_types","","",12,N],[3,"Resolver","","The main resolver class.",N,N],[12,"session","","",13,N],[12,"cstore","","",13,N],[12,"definitions","","",13,N],[12,"graph_root","","",13,N],[12,"prelude","","",13,N],[12,"extern_prelude","","",13,N],[12,"has_self","","n.b. This is used only for better diagnostics, not name resolution itself.",13,N],[12,"field_names","","Names of fields of an item `DefId` accessible with dot syntax. Used for hints during error reporting.",13,N],[12,"determined_imports","","All imports known to succeed or fail.",13,N],[12,"indeterminate_imports","","All non-determined imports.",13,N],[12,"current_module","","The module that represents the current item scope.",13,N],[12,"ribs","","The current set of local scopes for types and values. FIXME #4948: Reuse ribs to avoid allocation.",13,N],[12,"label_ribs","","The current set of local scopes, for labels.",13,N],[12,"current_trait_ref","","The trait that the current context can refer to.",13,N],[12,"current_self_type","","The current self type if inside an impl (used for better errors).",13,N],[12,"primitive_type_table","","The idents for the primitive types.",13,N],[12,"def_map","","",13,N],[12,"import_map","","",13,N],[12,"freevars","","",13,N],[12,"freevars_seen","","",13,N],[12,"export_map","","",13,N],[12,"trait_map","","",13,N],[12,"block_map","","A map from nodes to anonymous modules. Anonymous modules are pseudo-modules that are implicitly created around items contained within blocks.",13,N],[12,"module_map","","",13,N],[12,"extern_module_map","","",13,N],[12,"binding_parent_modules","","",13,N],[12,"make_glob_map","","",13,N],[12,"glob_map","","Maps imports to the names of items actually imported (this actually maps all imports, but only glob imports are actually interesting).",13,N],[12,"used_imports","","",13,N],[12,"maybe_unused_trait_imports","","",13,N],[12,"maybe_unused_extern_crates","","",13,N],[12,"unused_labels","","A list of labels as of yet unused. Labels will be removed from this map when they are used (in a `break` or `continue` statement)",13,N],[12,"privacy_errors","","privacy errors are delayed until the end in order to deduplicate them",13,N],[12,"ambiguity_errors","","ambiguity errors are delayed for deduplication",13,N],[12,"use_injections","","`use` injections are delayed for better placement and deduplication",13,N],[12,"macro_expanded_macro_export_errors","","crate-local macro expanded `macro_export` referred to by a module-relative path",13,N],[12,"arenas","","",13,N],[12,"dummy_binding","","",13,N],[12,"crate_loader","","",13,N],[12,"macro_names","","",13,N],[12,"builtin_macros","","",13,N],[12,"macro_use_prelude","","",13,N],[12,"all_macros","","",13,N],[12,"macro_map","","",13,N],[12,"macro_defs","","",13,N],[12,"local_macro_def_scopes","","",13,N],[12,"whitelisted_legacy_custom_derives","","",13,N],[12,"found_unresolved_macro","","",13,N],[12,"unused_macros","","List of crate local macros that we need to warn about as being unused. Right now this only includes macro_rules! macros, and macros 2.0.",13,N],[12,"invocations","","Maps the `Mark` of an expansion to its containing module or block.",13,N],[12,"name_already_seen","","Avoid duplicated errors for \"name already defined\".",13,N],[12,"potentially_unused_imports","","",13,N],[12,"struct_constructors","","This table maps struct IDs into struct constructor IDs, it's not used during normal resolution, only for better error reporting.",13,N],[12,"current_type_ascription","","Only used for better errors on `fn(): fn()`",13,N],[12,"injected_crate","","",13,N],[3,"ResolverArenas","","Nothing really interesting here, it just provides memory for the rest of the crate.",N,N],[12,"modules","","",14,N],[12,"local_modules","","",14,N],[12,"name_bindings","","",14,N],[12,"import_directives","","",14,N],[12,"name_resolutions","","",14,N],[12,"invocation_data","","",14,N],[12,"legacy_bindings","","",14,N],[4,"AssocSuggestion","","A field or associated item from self type suggested in case of resolution failure.",N,N],[13,"Field","","",15,N],[13,"MethodWithSelf","","",15,N],[13,"AssocItem","","",15,N],[4,"ResolutionError","","",N,N],[13,"TypeParametersFromOuterFunction","","error E0401: can't use type parameters from outer function",16,N],[13,"NameAlreadyUsedInTypeParameterList","","error E0403: the name is already used for a type parameter in this type parameter list",16,N],[13,"MethodNotMemberOfTrait","","error E0407: method is not a member of trait",16,N],[13,"TypeNotMemberOfTrait","","error E0437: type is not a member of trait",16,N],[13,"ConstNotMemberOfTrait","","error E0438: const is not a member of trait",16,N],[13,"VariableNotBoundInPattern","","error E0408: variable `{}` is not bound in all patterns",16,N],[13,"VariableBoundWithDifferentMode","","error E0409: variable `{}` is bound in inconsistent ways within the same match arm",16,N],[13,"IdentifierBoundMoreThanOnceInParameterList","","error E0415: identifier is bound more than once in this parameter list",16,N],[13,"IdentifierBoundMoreThanOnceInSamePattern","","error E0416: identifier is bound more than once in the same pattern",16,N],[13,"UndeclaredLabel","","error E0426: use of undeclared label",16,N],[13,"SelfImportsOnlyAllowedWithin","","error E0429: `self` imports are only allowed within a { } list",16,N],[13,"SelfImportCanOnlyAppearOnceInTheList","","error E0430: `self` import can only appear once in the list",16,N],[13,"SelfImportOnlyInImportListWithNonEmptyPrefix","","error E0431: `self` import can only appear in an import list with a non-empty prefix",16,N],[13,"FailedToResolve","","error E0433: failed to resolve",16,N],[13,"CannotCaptureDynamicEnvironmentInFnItem","","error E0434: can't capture dynamic environment in a fn item",16,N],[13,"AttemptToUseNonConstantValueInConstant","","error E0435: attempt to use a non-constant value in a constant",16,N],[13,"BindingShadowsSomethingUnacceptable","","error E0530: X bindings cannot shadow Ys",16,N],[13,"ForwardDeclaredTyParam","","error E0128: type parameters with a default cannot use forward declared identifiers",16,N],[4,"PatternSource","","",N,N],[13,"Match","","",17,N],[13,"IfLet","","",17,N],[13,"WhileLet","","",17,N],[13,"Let","","",17,N],[13,"For","","",17,N],[13,"FnParam","","",17,N],[4,"AliasPossibility","","",N,N],[13,"No","","",18,N],[13,"Maybe","","",18,N],[4,"PathSource","","",N,N],[13,"Type","","",19,N],[13,"Trait","","",19,N],[13,"Expr","","",19,N],[13,"Pat","","",19,N],[13,"Struct","","",19,N],[13,"TupleStruct","","",19,N],[13,"TraitItem","","",19,N],[13,"Visibility","","",19,N],[13,"ImportPrefix","","",19,N],[4,"TypeParameters","","",N,N],[13,"NoTypeParameters","","",20,N],[13,"HasTypeParameters","","",20,N],[4,"RibKind","","The rib kind controls the translation of local definitions (`Def::Local`) to upvars (`Def::Upvar`).",N,N],[13,"NormalRibKind","","No translation needs to be applied.",21,N],[13,"ClosureRibKind","","We passed through a closure scope at the given node ID. Translate upvars as appropriate.",21,N],[13,"TraitOrImplItemRibKind","","We passed through an impl or trait and are now in one of its methods or associated types. Allow references to ty params that impl or trait binds. Disallow any other upvars (including other ty params that are upvars).",21,N],[13,"ItemRibKind","","We passed through an item scope. Disallow upvars.",21,N],[13,"ConstantItemRibKind","","We're in a constant item. Can't refer to dynamic stuff.",21,N],[13,"ModuleRibKind","","We passed through a module.",21,N],[13,"MacroDefinition","","We passed through a `macro_rules!` statement",21,N],[13,"ForwardTyParamBanRibKind","","All bindings in this rib are type parameters that can't be used from the default of a type parameter because they're not declared before said type parameter. Also see the `visit_generics` override.",21,N],[4,"LexicalScopeBinding","","An intermediate resolution result.",N,N],[13,"Item","","",22,N],[13,"Def","","",22,N],[4,"ModuleOrUniformRoot","","",N,N],[13,"Module","","Regular module.",23,N],[13,"UniformRoot","","The `{{root}}` (`CrateRoot` aka \"global\") / `extern` initial segment in which external crates resolve, and also `crate` (only in `{{root}}`, but not `extern`), in the Rust 2018 edition.",23,N],[4,"PathResult","","",N,N],[13,"Module","","",24,N],[13,"NonModule","","",24,N],[13,"Indeterminate","","",24,N],[13,"Failed","","",24,N],[4,"ModuleKind","","",N,N],[13,"Block","","An anonymous module, eg. just a block.",25,N],[13,"Def","","Any module with a name.",25,N],[4,"NameBindingKind","","",N,N],[13,"Def","","",26,N],[13,"Module","","",26,N],[13,"Import","","",26,N],[12,"binding","rustc_resolve::NameBindingKind","",26,N],[12,"directive","","",26,N],[12,"used","","",26,N],[13,"Ambiguity","rustc_resolve","",26,N],[12,"b1","rustc_resolve::NameBindingKind","",26,N],[12,"b2","","",26,N],[4,"MakeGlobMap","rustc_resolve","",N,N],[13,"Yes","","",27,N],[13,"No","","",27,N],[4,"CrateLint","","",N,N],[13,"No","","Do not issue the lint",28,N],[13,"SimplePath","","This lint applies to some random path like `impl ::foo::Bar` or whatever. In this case, we can take the span of that path.",28,N],[13,"UsePath","","This lint comes from a `use` statement. In this case, what we care about really is the root `use` statement; e.g., if we have nested things like `use a::{b, c}`, we care about the `use a` part.",28,N],[12,"root_id","rustc_resolve::CrateLint","",28,N],[12,"root_span","","",28,N],[13,"QPathTrait","rustc_resolve","This is the \"trait item\" from a fully qualified path. For example, we might be resolving  `X::Y::Z` from a path like `<T as X::Y>::Z`. The `path_span` is the span of the to the trait itself (`X::Y`).",28,N],[12,"qpath_id","rustc_resolve::CrateLint","",28,N],[12,"qpath_span","","",28,N],[5,"is_known_tool","rustc_resolve","",N,[[["name"]],["bool"]]],[5,"resolve_error","","Combines an error with provided span and emits it",N,[[["resolver"],["span"],["resolutionerror"]]]],[5,"resolve_struct_error","","",N,[[["resolver"],["span"],["resolutionerror"]],["diagnosticbuilder"]]],[5,"reduce_impl_span_to_impl_keyword","","Adjust the impl span so that just the `impl` keyword is taken by removing everything after `<` (`\"impl<T> Iterator for A<T> {}\" -> \"impl\"`) and everything after the first whitespace (`\"impl Iterator for A\" -> \"impl\"`)",N,[[["sourcemap"],["span"]],["span"]]],[5,"is_self_type","","",N,N],[5,"is_self_value","","",N,N],[5,"names_to_string","","",N,N],[5,"path_names_to_string","","",N,[[["path"]],["string"]]],[5,"import_candidate_to_paths","","Get the path for an enum and the variant from an `ImportSuggestion` for an enum variant.",N,N],[5,"show_candidates","","When an entity with a given name is not available in scope, we search for entities with that name in all crates. This method allows outputting the results of this search in a programmer-friendly way",N,N],[5,"module_to_string","","A somewhat inefficient routine to obtain the name of a module.",N,[[["moduledata"]],["option",["string"]]]],[5,"err_path_resolution","","",N,[[],["pathresolution"]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0128","rustc_resolve::diagnostics","",N,N],[0,"__register_diagnostic_E0154","","",N,N],[0,"__register_diagnostic_E0251","","",N,N],[0,"__register_diagnostic_E0252","","",N,N],[0,"__register_diagnostic_E0253","","",N,N],[0,"__register_diagnostic_E0254","","",N,N],[0,"__register_diagnostic_E0255","","",N,N],[0,"__register_diagnostic_E0256","","",N,N],[0,"__register_diagnostic_E0259","","",N,N],[0,"__register_diagnostic_E0260","","",N,N],[0,"__register_diagnostic_E0364","","",N,N],[0,"__register_diagnostic_E0365","","",N,N],[0,"__register_diagnostic_E0401","","",N,N],[0,"__register_diagnostic_E0403","","",N,N],[0,"__register_diagnostic_E0404","","",N,N],[0,"__register_diagnostic_E0405","","",N,N],[0,"__register_diagnostic_E0407","","",N,N],[0,"__register_diagnostic_E0408","","",N,N],[0,"__register_diagnostic_E0409","","",N,N],[0,"__register_diagnostic_E0411","","",N,N],[0,"__register_diagnostic_E0412","","",N,N],[0,"__register_diagnostic_E0415","","",N,N],[0,"__register_diagnostic_E0416","","",N,N],[0,"__register_diagnostic_E0422","","",N,N],[0,"__register_diagnostic_E0423","","",N,N],[0,"__register_diagnostic_E0424","","",N,N],[0,"__register_diagnostic_E0425","","",N,N],[0,"__register_diagnostic_E0426","","",N,N],[0,"__register_diagnostic_E0428","","",N,N],[0,"__register_diagnostic_E0429","","",N,N],[0,"__register_diagnostic_E0430","","",N,N],[0,"__register_diagnostic_E0431","","",N,N],[0,"__register_diagnostic_E0432","","",N,N],[0,"__register_diagnostic_E0433","","",N,N],[0,"__register_diagnostic_E0434","","",N,N],[0,"__register_diagnostic_E0435","","",N,N],[0,"__register_diagnostic_E0437","","",N,N],[0,"__register_diagnostic_E0438","","",N,N],[0,"__register_diagnostic_E0466","","",N,N],[0,"__register_diagnostic_E0468","","",N,N],[0,"__register_diagnostic_E0469","","",N,N],[0,"__register_diagnostic_E0530","","",N,N],[0,"__register_diagnostic_E0532","","",N,N],[0,"__register_diagnostic_E0603","","",N,N],[0,"__register_diagnostic_E0659","","",N,N],[0,"__register_diagnostic_E0531","","",N,N],[0,"__register_diagnostic_E0573","","",N,N],[0,"__register_diagnostic_E0574","","",N,N],[0,"__register_diagnostic_E0575","","",N,N],[0,"__register_diagnostic_E0576","","",N,N],[0,"__register_diagnostic_E0577","","",N,N],[0,"__register_diagnostic_E0578","","",N,N],[0,"macros","rustc_resolve","",N,N],[3,"FromPrelude","rustc_resolve::macros","",N,N],[12,"0","","",29,N],[3,"InvocationData","","",N,N],[12,"def_index","","",30,N],[12,"module","","Module in which the macro was invoked.",30,N],[12,"parent_legacy_scope","","Legacy scope in which the macro was invoked. The invocation path is resolved in this scope.",30,N],[12,"output_legacy_scope","","Legacy scope produced by expanding this macro invocation, includes all the macro_rules items, other invocations, etc generated by it. Set to the parent scope if the macro is not expanded yet (as if the macro produced nothing).",30,N],[3,"LegacyBinding","","Binding produced by a `macro_rules` item. Not modularized, can shadow previous legacy bindings, etc.",N,N],[12,"binding","","",31,N],[12,"parent_legacy_scope","","Legacy scope into which the `macro_rules` item was planted.",31,N],[12,"ident","","",31,N],[3,"ParentScope","","Everything you need to resolve a macro path.",N,N],[12,"module","","",32,N],[12,"expansion","","",32,N],[12,"legacy","","",32,N],[12,"derives","","",32,N],[4,"LegacyScope","","Scope introduced by a `macro_rules!` macro. Starts at the macro's definition and ends at the end of the macro's parent module (named or unnamed), or even further if it escapes with `#[macro_use]`. Some macro invocations need to introduce legacy scopes too because they potentially can expand into macro definitions.",N,N],[13,"Uninitialized","","Created when invocation data is allocated in the arena, must be replaced with a proper scope later.",33,N],[13,"Empty","","Empty \"root\" scope at the crate start containing no names.",33,N],[13,"Binding","","Scope introduced by a `macro_rules!` macro definition.",33,N],[13,"Invocation","","Scope introduced by a macro invocation that can potentially create a `macro_rules!` macro definition.",33,N],[5,"sub_namespace_mismatch","","",N,[[["option",["macrokind"]],["option",["macrokind"]]],["bool"]]],[11,"clone","","",29,[[["self"]],["fromprelude"]]],[11,"clone","","",30,[[["self"]],["invocationdata"]]],[11,"root","","",30,[[["moduledata"]],["self"]]],[11,"clone","","",33,[[["self"]],["legacyscope"]]],[11,"clone","","",32,[[["self"]],["parentscope"]]],[11,"next_node_id","rustc_resolve","",13,[[["self"]],["nodeid"]]],[11,"get_module_scope","","",13,[[["self"],["nodeid"]],["mark"]]],[11,"eliminate_crate_var","","",13,[[["self"],["p",["item"]]],["p",["item"]]]],[11,"is_whitelisted_legacy_custom_derive","","",13,[[["self"],["name"]],["bool"]]],[11,"visit_ast_fragment_with_placeholders","","",13,N],[11,"add_builtin","","",13,[[["self"],["ident"],["lrc",["syntaxextension"]]]]],[11,"resolve_imports","","",13,[[["self"]]]],[11,"find_legacy_attr_invoc","","",13,[[["self"],["vec"],["bool"]],["option",["attribute"]]]],[11,"resolve_macro_invocation","","",13,[[["self"],["invocation"],["mark"],["bool"]],["result",["option","determinacy"]]]],[11,"resolve_macro_path","","",13,[[["self"],["path"],["macrokind"],["mark"],["vec",["path"]],["bool"]],["result",["lrc","determinacy"]]]],[11,"check_unused_macros","","",13,[[["self"]]]],[11,"dummy_parent_scope","","",13,[[["self"]],["parentscope"]]],[11,"invoc_parent_scope","","",13,[[["self"],["mark"],["vec",["path"]]],["parentscope"]]],[11,"resolve_macro_to_def","","",13,[[["self"],["path"],["macrokind"],["parentscope"],["bool"]],["result",["determinacy"]]]],[11,"resolve_macro_to_def_inner","","",13,[[["self"],["path"],["macrokind"],["parentscope"],["bool"]],["result",["def","determinacy"]]]],[11,"resolve_lexical_macro_path_segment","","",13,[[["self"],["ident"],["namespace"],["option",["macrokind"]],["parentscope"],["bool"],["bool"],["span"]],["result",["determinacy"]]]],[11,"resolve_legacy_scope","","",13,[[["self"],["ident"],["option",["macrokind"]],["parentscope"],["bool"]],["option",["namebinding"]]]],[11,"finalize_current_module_macro_resolutions","","",13,[[["self"]]]],[11,"suggest_macro_name","","",13,[[["self"],["str"],["macrokind"],["diagnosticbuilder"],["span"]]]],[11,"collect_def_ids","","",13,[[["self"],["mark"],["invocationdata"],["astfragment"]]]],[11,"define_macro","","",13,[[["self"],["item"],["mark"],["legacyscope"]]]],[11,"gate_legacy_custom_derive","","",13,[[["self"],["symbol"],["span"]]]],[0,"check_unused","","",N,N],[3,"UnusedImportCheckVisitor","rustc_resolve::check_unused","",N,N],[12,"resolver","","",34,N],[12,"unused_imports","","All the (so far) unused imports, grouped path list",34,N],[12,"base_id","","",34,N],[12,"item_span","","",34,N],[5,"check_crate","","",N,[[["resolver"],["crate"]]]],[11,"deref","","",34,[[["self"]],["resolver"]]],[11,"deref_mut","","",34,[[["self"]],["resolver"]]],[11,"check_import","","",34,[[["self"],["nodeid"],["nodeid"],["span"]]]],[11,"visit_item","","",34,[[["self"],["item"]]]],[11,"visit_use_tree","","",34,[[["self"],["usetree"],["nodeid"],["bool"]]]],[0,"build_reduced_graph","rustc_resolve","Reduced graph building",N,N],[3,"IsMacroExport","rustc_resolve::build_reduced_graph","",N,N],[3,"LegacyMacroImports","","",N,N],[12,"import_all","","",35,N],[12,"imports","","",35,N],[3,"BuildReducedGraphVisitor","","",N,N],[12,"resolver","","",36,N],[12,"current_legacy_scope","","",36,N],[12,"expansion","","",36,N],[11,"default","","",35,[[],["legacymacroimports"]]],[11,"eq","","",35,[[["self"],["legacymacroimports"]],["bool"]]],[11,"ne","","",35,[[["self"],["legacymacroimports"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",35,N],[11,"define","rustc_resolve","Defines `name` in namespace `ns` of module `parent` to be `def` if it is not yet defined; otherwise, reports an error.",13,[[["self"],["moduledata"],["ident"],["namespace"],["t"]]]],[11,"block_needs_anonymous_module","","",13,[[["self"],["block"]],["bool"]]],[11,"insert_field_names","","",13,[[["self"],["defid"],["vec",["name"]]]]],[11,"build_reduced_graph_for_use_tree","","",13,N],[11,"build_reduced_graph_for_item","","Constructs the reduced graph for one item.",13,[[["self"],["item"],["mark"]]]],[11,"build_reduced_graph_for_variant","","",13,[[["self"],["variant"],["moduledata"],["visibility"],["mark"]]]],[11,"build_reduced_graph_for_foreign_item","","Constructs the reduced graph for one foreign item.",13,[[["self"],["foreignitem"],["mark"]]]],[11,"build_reduced_graph_for_block","","",13,[[["self"],["block"],["mark"]]]],[11,"build_reduced_graph_for_external_crate_def","","Builds the reduced graph for a single item in an external crate.",13,[[["self"],["moduledata"],["export"]]]],[11,"get_module","","",13,[[["self"],["defid"]],["moduledata"]]],[11,"macro_def_scope","","",13,[[["self"],["mark"]],["moduledata"]]],[11,"get_macro","","",13,[[["self"],["def"]],["lrc",["syntaxextension"]]]],[11,"populate_module_if_necessary","","Ensures that the reduced graph rooted at the given external module is built, building it if it is not.",13,[[["self"],["moduledata"]]]],[11,"legacy_import_macro","","",13,[[["self"],["name"],["namebinding"],["span"],["bool"]]]],[11,"process_legacy_macro_imports","","",13,[[["self"],["item"],["moduledata"],["mark"]],["bool"]]],[11,"contains_macro_use","","",13,N],[11,"legacy_macro_imports","","",13,N],[11,"visit_invoc","rustc_resolve::build_reduced_graph","",36,[[["self"],["nodeid"]],["invocationdata"]]],[11,"visit_impl_item","","",36,[[["self"],["implitem"]]]],[11,"visit_expr","","",36,[[["self"],["expr"]]]],[11,"visit_pat","","",36,[[["self"],["pat"]]]],[11,"visit_ty","","",36,[[["self"],["ty"]]]],[11,"visit_item","","",36,[[["self"],["item"]]]],[11,"visit_stmt","","",36,[[["self"],["stmt"]]]],[11,"visit_foreign_item","","",36,[[["self"],["foreignitem"]]]],[11,"visit_block","","",36,[[["self"],["block"]]]],[11,"visit_trait_item","","",36,[[["self"],["traititem"]]]],[11,"visit_token","","",36,[[["self"],["token"]]]],[11,"visit_attribute","","",36,[[["self"],["attribute"]]]],[0,"resolve_imports","rustc_resolve","",N,N],[3,"ImportDirective","rustc_resolve::resolve_imports","One import directive.",N,N],[12,"id","","The id of the `extern crate`, `UseTree` etc that imported this `ImportDirective`.",37,N],[12,"root_id","","The `id` of the \"root\" use-kind -- this is always the same as `id` except in the case of \"nested\" use trees, in which case it will be the `id` of the root use tree. e.g., in the example from `id`, this would be the id of the `use foo::bar` `UseTree` node.",37,N],[12,"span","","Span of this use tree.",37,N],[12,"root_span","","Span of the root use tree (see `root_id`).",37,N],[12,"parent","","",37,N],[12,"module_path","","",37,N],[12,"imported_module","","The resolution of `module_path`.",37,N],[12,"subclass","","",37,N],[12,"vis","","",37,N],[12,"expansion","","",37,N],[12,"used","","",37,N],[12,"is_uniform_paths_canary","","Whether this import is a \"canary\" for the `uniform_paths` feature, i.e. `use x::...;` results in an `use self::x as _;` canary. This flag affects diagnostics: an error is reported if and only if the import resolves successfully and an external crate with the same name (`x` above) also exists; any resolution failures are ignored.",37,N],[3,"NameResolution","","Records information about the resolution of a name in a namespace of a module.",N,N],[12,"single_imports","","Single imports that may define the name in the namespace. Import directives are arena-allocated, so it's ok to use pointers as keys.",38,N],[12,"binding","","The least shadowable known binding for this name, or None if there are no known bindings.",38,N],[12,"shadowed_glob","","",38,N],[3,"ImportResolver","","",N,N],[12,"resolver","","",39,N],[4,"ImportDirectiveSubclass","","Contains data for specific types of import directives.",N,N],[13,"SingleImport","","",40,N],[12,"target","rustc_resolve::resolve_imports::ImportDirectiveSubclass","",40,N],[12,"source","","",40,N],[12,"result","","",40,N],[12,"type_ns_only","","",40,N],[13,"GlobImport","rustc_resolve::resolve_imports","",40,N],[12,"is_prelude","rustc_resolve::resolve_imports::ImportDirectiveSubclass","",40,N],[12,"max_vis","","",40,N],[13,"ExternCrate","rustc_resolve::resolve_imports","",40,N],[13,"MacroUse","","",40,N],[5,"import_path_to_string","","",N,N],[5,"import_directive_subclass_to_string","","",N,[[["importdirectivesubclass"]],["string"]]],[11,"clone","","",40,[[["self"]],["importdirectivesubclass"]]],[11,"fmt","","",40,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"clone","","",37,[[["self"]],["importdirective"]]],[11,"is_glob","","",37,[[["self"]],["bool"]]],[11,"crate_lint","","",37,[[["self"]],["cratelint"]]],[11,"clone","","",38,[[["self"]],["nameresolution"]]],[11,"default","","",38,[[],["nameresolution"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"binding","","",38,[[["self"]],["option",["namebinding"]]]],[11,"resolution","rustc_resolve","",13,[[["self"],["moduledata"],["ident"],["namespace"]],["refcell"]]],[11,"resolve_ident_in_module_unadjusted","","Attempts to resolve `ident` in namespaces `ns` of `module`. Invariant: if `record_used` is `Some`, expansion and import resolution must be complete.",13,[[["self"],["moduleoruniformroot"],["ident"],["namespace"],["bool"],["bool"],["span"]],["result",["namebinding","determinacy"]]]],[11,"add_import_directive","","",13,[[["self"],["vec",["ident"]],["importdirectivesubclass"],["span"],["nodeid"],["span"],["nodeid"],["visibility"],["mark"],["bool"]]]],[11,"import","","",13,[[["self"],["namebinding"],["importdirective"]],["namebinding"]]],[11,"check_reserved_macro_name","","",13,[[["self"],["ident"],["namespace"]]]],[11,"try_define","","",13,[[["self"],["moduledata"],["ident"],["namespace"],["namebinding"]],["result",["namebinding"]]]],[11,"ambiguity","","",13,[[["self"],["namebinding"],["namebinding"]],["namebinding"]]],[11,"update_resolution","","",13,[[["self"],["moduledata"],["ident"],["namespace"],["f"]],["t"]]],[11,"import_dummy_binding","","",13,[[["self"],["importdirective"]]]],[11,"deref","rustc_resolve::resolve_imports","",39,[[["self"]],["resolver"]]],[11,"deref_mut","","",39,[[["self"]],["resolver"]]],[11,"resolve_imports","","Resolves all imports for the crate. This method performs the fixed- point iteration.",39,[[["self"]]]],[11,"finalize_imports","","",39,[[["self"]]]],[11,"throw_unresolved_import_error","","",39,[[["self"],["vec"],["option",["multispan"]]]]],[11,"resolve_import","","Attempts to resolve the given import, returning true if its resolution is determined. If successful, the resolved bindings are written into the module.",39,[[["self"],["importdirective"]],["bool"]]],[11,"finalize_import","","",39,[[["self"],["importdirective"]],["option"]]],[11,"resolve_glob_import","","",39,[[["self"],["importdirective"]]]],[11,"finalize_resolutions_in","","",39,[[["self"],["moduledata"]]]],[6,"BindingMap","rustc_resolve","Map from the name in a pattern to its binding mode.",N,N],[6,"Module","","",N,N],[17,"DIAGNOSTICS","","",N,N],[8,"ToNameBinding","","",N,N],[10,"to_name_binding","","",41,[[["self"],["resolverarenas"]],["namebinding"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"partial_cmp","","",3,[[["self"],["bindingerror"]],["option",["ordering"]]]],[11,"eq","","",3,[[["self"],["bindingerror"]],["bool"]]],[11,"cmp","","",3,[[["self"],["bindingerror"]],["ordering"]]],[11,"clone","","",4,[[["self"]],["bindinginfo"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",17,[[["self"]],["patternsource"]]],[11,"eq","","",17,[[["self"],["patternsource"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",17,N],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"descr","","",17,[[["self"]],["str"]]],[11,"clone","","",18,[[["self"]],["aliaspossibility"]]],[11,"eq","","",18,[[["self"],["aliaspossibility"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",18,N],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"clone","","",19,[[["self"]],["pathsource"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"namespace","","",19,[[["self"]],["namespace"]]],[11,"global_by_default","","",19,[[["self"]],["bool"]]],[11,"defer_to_typeck","","",19,[[["self"]],["bool"]]],[11,"descr_expected","","",19,[[["self"]],["str"]]],[11,"is_expected","","",19,[[["self"],["def"]],["bool"]]],[11,"error_code","","",19,[[["self"],["bool"]],["str"]]],[11,"check","","",5,N],[11,"visit_mod","","",5,N],[11,"visit_item","","",13,[[["self"],["item"]]]],[11,"visit_arm","","",13,[[["self"],["arm"]]]],[11,"visit_block","","",13,[[["self"],["block"]]]],[11,"visit_anon_const","","",13,[[["self"],["anonconst"]]]],[11,"visit_expr","","",13,[[["self"],["expr"]]]],[11,"visit_local","","",13,[[["self"],["local"]]]],[11,"visit_ty","","",13,[[["self"],["ty"]]]],[11,"visit_poly_trait_ref","","",13,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_foreign_item","","",13,[[["self"],["foreignitem"]]]],[11,"visit_fn","","",13,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_generics","","",13,[[["self"],["generics"]]]],[11,"clone","","",20,[[["self"]],["typeparameters"]]],[11,"clone","","",21,[[["self"]],["ribkind"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"new","","",6,[[["ribkind"]],["rib"]]],[11,"item","","",22,[[["self"]],["option",["namebinding"]]]],[11,"def","","",22,[[["self"]],["def"]]],[11,"clone","","",23,[[["self"]],["moduleoruniformroot"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"clone","","",24,[[["self"]],["pathresult"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"new","","",7,[[["option",["moduledata"]],["modulekind"],["defid"],["mark"],["span"]],["self"]]],[11,"for_each_child","","",7,[[["self"],["f"]]]],[11,"for_each_child_stable","","",7,[[["self"],["f"]]]],[11,"def","","",7,[[["self"]],["option",["def"]]]],[11,"def_id","","",7,[[["self"]],["option",["defid"]]]],[11,"is_normal","","",7,[[["self"]],["bool"]]],[11,"is_trait","","",7,[[["self"]],["bool"]]],[11,"is_local","","",7,[[["self"]],["bool"]]],[11,"nearest_item_scope","","",7,[[["self"]],["moduledata"]]],[11,"is_ancestor_of","","",7,[[["self"],["self"]],["bool"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"clone","","",8,[[["self"]],["namebinding"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"clone","","",26,[[["self"]],["namebindingkind"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"module","","",8,[[["self"]],["option",["moduledata"]]]],[11,"def","","",8,[[["self"]],["def"]]],[11,"def_ignoring_ambiguity","","",8,[[["self"]],["def"]]],[11,"get_macro","","",8,[[["self"],["resolver"]],["lrc",["syntaxextension"]]]],[11,"pseudo_vis","","",8,[[["self"]],["visibility"]]],[11,"is_variant","","",8,[[["self"]],["bool"]]],[11,"is_extern_crate","","",8,[[["self"]],["bool"]]],[11,"is_import","","",8,[[["self"]],["bool"]]],[11,"is_renamed_extern_crate","","",8,[[["self"]],["bool"]]],[11,"is_glob_import","","",8,[[["self"]],["bool"]]],[11,"is_importable","","",8,[[["self"]],["bool"]]],[11,"is_macro_def","","",8,[[["self"]],["bool"]]],[11,"macro_kind","","",8,[[["self"]],["option",["macrokind"]]]],[11,"descr","","",8,[[["self"]],["str"]]],[11,"may_appear_after","","",8,[[["self"],["mark"],["namebinding"]],["bool"]]],[11,"new","","",12,[[],["primitivetypetable"]]],[11,"intern","","",12,[[["self"],["str"],["primty"]]]],[11,"alloc_module","","",14,[[["self"],["moduledata"]],["moduledata"]]],[11,"local_modules","","",14,[[["self"]],["ref",["vec"]]]],[11,"alloc_name_binding","","",14,[[["self"],["namebinding"]],["namebinding"]]],[11,"alloc_import_directive","","",14,[[["self"],["importdirective"]],["importdirective"]]],[11,"alloc_name_resolution","","",14,[[["self"]],["refcell"]]],[11,"alloc_invocation_data","","",14,[[["self"],["invocationdata"]],["invocationdata"]]],[11,"alloc_legacy_binding","","",14,[[["self"],["legacybinding"]],["legacybinding"]]],[11,"resolve_hir_path","","",13,[[["self"],["path"],["bool"]]]],[11,"resolve_str_path","","",13,N],[11,"get_resolution","","",13,[[["self"],["nodeid"]],["option",["pathresolution"]]]],[11,"get_import","","",13,[[["self"],["nodeid"]],["perns",["option"]]]],[11,"definitions","","",13,[[["self"]],["definitions"]]],[11,"resolve_str_path_error","","Rustdoc uses this to resolve things in a recoverable way. ResolutionError<'a> isn't something that can be returned because it can't be made to live that long, and also it's a private type. Fortunately rustdoc doesn't need to know the error, just that an error occurred.",13,[[["self"],["span"],["str"],["bool"]],["result",["path"]]]],[11,"resolve_hir_path_cb","","resolve_hir_path, but takes a callback in case there was an error",13,[[["self"],["path"],["bool"],["f"]]]],[11,"new","","",13,[[["session"],["cstore"],["crate"],["str"],["makeglobmap"],["crateloader"],["resolverarenas"]],["resolver"]]],[11,"arenas","","",13,[[],["resolverarenas"]]],[11,"per_ns","","Runs the function on each namespace.",13,[[["self"],["f"]]]],[11,"macro_def","","",13,[[["self"],["syntaxcontext"]],["defid"]]],[11,"resolve_crate","","Entry point to crate resolution.",13,[[["self"],["crate"]]]],[11,"new_module","","",13,[[["self"],["moduledata"],["modulekind"],["defid"],["mark"],["span"]],["moduledata"]]],[11,"record_use","","",13,[[["self"],["ident"],["namespace"],["namebinding"]],["bool"]]],[11,"add_to_glob_map","","",13,[[["self"],["nodeid"],["ident"]]]],[11,"resolve_ident_in_lexical_scope","","This resolves the identifier `ident` in the namespace `ns` in the current lexical scope. More specifically, we proceed up the hierarchy of scopes and return the binding for `ident` in the first scope that defines it (or None if no scopes define it).",13,[[["self"],["ident"],["namespace"],["option",["nodeid"]],["span"]],["option",["lexicalscopebinding"]]]],[11,"hygienic_lexical_parent","","",13,[[["self"],["moduledata"],["span"]],["option",["moduledata"]]]],[11,"hygienic_lexical_parent_with_compatibility_fallback","","",13,[[["self"],["moduledata"],["span"],["nodeid"],["option"]],["option",["moduledata"]]]],[11,"resolve_ident_in_module","","",13,[[["self"],["moduleoruniformroot"],["ident"],["namespace"],["bool"],["span"]],["result",["namebinding","determinacy"]]]],[11,"resolve_crate_root","","",13,[[["self"],["ident"]],["moduledata"]]],[11,"resolve_self","","",13,[[["self"],["syntaxcontext"],["moduledata"]],["moduledata"]]],[11,"with_scope","","",13,[[["self"],["nodeid"],["f"]],["t"]]],[11,"search_label","","Searches the current set of local scopes for labels. Returns the first non-None label that is returned by the given predicate function",13,[[["self"],["ident"],["p"]],["option"]]],[11,"resolve_adt","","",13,[[["self"],["item"],["generics"]]]],[11,"resolve_item","","",13,[[["self"],["item"]]]],[11,"resolve_use_tree","","For the most part, use trees are desugared into `ImportDirective` instances when building the reduced graph (see `build_reduced_graph_for_use_tree`). But there is one special case we handle here: an empty nested import like `a::{b::{}}`, which desugares into...no import directives.",13,[[["self"],["nodeid"],["span"],["nodeid"],["usetree"],["path"]]]],[11,"with_type_parameter_rib","","",13,[[["self"],["typeparameters"],["f"]]]],[11,"with_label_rib","","",13,[[["self"],["f"]]]],[11,"with_item_rib","","",13,[[["self"],["f"]]]],[11,"with_constant_rib","","",13,[[["self"],["f"]]]],[11,"with_current_self_type","","",13,[[["self"],["ty"],["f"]],["t"]]],[11,"with_optional_trait_ref","","This is called to resolve a trait reference from an `impl` (i.e. `impl Trait for Foo`)",13,[[["self"],["option",["traitref"]],["f"]],["t"]]],[11,"with_self_rib","","",13,[[["self"],["def"],["f"]]]],[11,"with_self_struct_ctor_rib","","",13,[[["self"],["defid"],["f"]]]],[11,"resolve_implementation","","",13,N],[11,"check_trait_item","","",13,[[["self"],["ident"],["namespace"],["span"],["f"]]]],[11,"resolve_local","","",13,[[["self"],["local"]]]],[11,"binding_mode_map","","",13,[[["self"],["pat"]],["fxhashmap",["ident","bindinginfo"]]]],[11,"check_consistent_bindings","","",13,N],[11,"resolve_arm","","",13,[[["self"],["arm"]]]],[11,"resolve_block","","",13,[[["self"],["block"]]]],[11,"fresh_binding","","",13,[[["self"],["ident"],["nodeid"],["nodeid"],["patternsource"],["fxhashmap"]],["pathresolution"]]],[11,"resolve_pattern","","",13,[[["self"],["pat"],["patternsource"],["fxhashmap"]]]],[11,"smart_resolve_path","","",13,[[["self"],["nodeid"],["option",["qself"]],["path"],["pathsource"]],["pathresolution"]]],[11,"smart_resolve_path_with_crate_lint","","A variant of `smart_resolve_path` where you also specify extra information about where the path came from; this extra info is sometimes needed for the lint that recommends rewriting absolute paths to `crate`, so that it knows how to frame the suggestion. If you are just resolving a path like `foo::bar` that appears...somewhere, though, then you just want `CrateLint::SimplePath`, which is what `smart_resolve_path` already provides.",13,[[["self"],["nodeid"],["option",["qself"]],["path"],["pathsource"],["cratelint"]],["pathresolution"]]],[11,"smart_resolve_path_fragment","","",13,N],[11,"type_ascription_suggestion","","",13,[[["self"],["diagnosticbuilder"],["span"]]]],[11,"self_type_is_available","","",13,[[["self"],["span"]],["bool"]]],[11,"self_value_is_available","","",13,[[["self"],["span"],["span"]],["bool"]]],[11,"resolve_qpath_anywhere","","",13,N],[11,"resolve_qpath","","Handles paths that may refer to associated items.",13,N],[11,"resolve_path","","",13,N],[11,"resolve_path_with_parent_scope","","",13,N],[11,"lint_if_path_starts_with_module","","",13,N],[11,"adjust_local_def","","",13,[[["self"],["namespace"],["usize"],["def"],["bool"],["span"]],["def"]]],[11,"lookup_assoc_candidate","","",13,[[["self"],["ident"],["namespace"],["filterfn"]],["option",["assocsuggestion"]]]],[11,"lookup_typo_candidate","","",13,N],[11,"with_resolved_label","","",13,[[["self"],["option",["label"]],["nodeid"],["f"]]]],[11,"resolve_labeled_block","","",13,[[["self"],["option",["label"]],["nodeid"],["block"]]]],[11,"resolve_expr","","",13,[[["self"],["expr"],["option",["expr"]]]]],[11,"record_candidate_traits_for_expr_if_necessary","","",13,[[["self"],["expr"]]]],[11,"get_traits_containing_item","","",13,[[["self"],["ident"],["namespace"]],["vec",["traitcandidate"]]]],[11,"get_traits_in_module_containing_item","","",13,[[["self"],["ident"],["namespace"],["moduledata"],["vec"]]]],[11,"lookup_import_candidates_from_module","","",13,[[["self"],["name"],["namespace"],["moduledata"],["ident"],["filterfn"]],["vec",["importsuggestion"]]]],[11,"lookup_import_candidates","","When name resolution fails, this method can be used to look up candidate entities with the expected name. It allows filtering them using the supplied predicate (which should be used to only accept the types of definitions expected e.g. traits). The lookup spans across all crates.",13,[[["self"],["name"],["namespace"],["filterfn"]],["vec",["importsuggestion"]]]],[11,"find_module","","",13,[[["self"],["def"]],["option"]]],[11,"collect_enum_variants","","",13,[[["self"],["def"]],["option",["vec"]]]],[11,"record_def","","",13,[[["self"],["nodeid"],["pathresolution"]]]],[11,"resolve_visibility","","",13,[[["self"],["visibility"]],["visibility"]]],[11,"is_accessible","","",13,[[["self"],["visibility"]],["bool"]]],[11,"is_accessible_from","","",13,[[["self"],["visibility"],["moduledata"]],["bool"]]],[11,"set_binding_parent_module","","",13,[[["self"],["namebinding"],["moduledata"]]]],[11,"disambiguate_legacy_vs_modern","","",13,[[["self"],["namebinding"],["namebinding"]],["bool"]]],[11,"report_ambiguity_error","","",13,[[["self"],["ident"],["namebinding"],["namebinding"]]]],[11,"report_errors","","",13,[[["self"],["crate"]]]],[11,"report_with_use_injections","","",13,[[["self"],["crate"]]]],[11,"report_conflict","","",13,[[["self"],["moduledata"],["ident"],["namespace"],["namebinding"],["namebinding"]]]],[11,"eq","","",27,[[["self"],["makeglobmap"]],["bool"]]],[11,"clone","","",27,[[["self"]],["makeglobmap"]]],[11,"clone","","",28,[[["self"]],["cratelint"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"node_id","","",28,[[["self"]],["option",["nodeid"]]]],[11,"descr","","",0,[[["self"]],["str"]]],[11,"to_owned","","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"default","","",1,[[],["perns"]]],[11,"index_mut","","",1,[[["self"],["namespace"]],["t"]]],[11,"assert_receiver_is_total_eq","","",0,N],[11,"partial_cmp","","",0,[[["self"],["namespace"]],["option",["ordering"]]]],[11,"index","","",1,[[["self"],["namespace"]],["t"]]],[11,"cmp","","",0,[[["self"],["namespace"]],["ordering"]]],[11,"eq","","",0,[[["self"],["namespace"]],["bool"]]],[11,"hash","","",0,N],[11,"fmt","","",0,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result",["error"]]]],[11,"clone","","",0,[[["self"]],["namespace"]]],[11,"clone","","",1,[[["self"]],["perns"]]],[11,"map","","",1,[[["self"],["f"]],["perns"]]],[11,"is_empty","","Returns whether all the items in this collection are `None`.",1,[[["self"]],["bool"]]],[11,"present_items","","Returns an iterator over the items which are `Some`.",1,N],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from_ok","","",13,[[["t"]],["t"]]],[11,"map_same","","",13,[[["self"],["f"]],["t"]]],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from_ok","","",14,[[["t"]],["t"]]],[11,"map_same","","",14,[[["self"],["f"]],["t"]]],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from_ok","","",15,[[["t"]],["t"]]],[11,"map_same","","",15,[[["self"],["f"]],["t"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from_ok","","",16,[[["t"]],["t"]]],[11,"map_same","","",16,[[["self"],["f"]],["t"]]],[11,"to_owned","","",17,[[["self"]],["t"]]],[11,"clone_into","","",17,N],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from_ok","","",17,[[["t"]],["t"]]],[11,"map_same","","",17,[[["self"],["f"]],["t"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from_ok","","",18,[[["t"]],["t"]]],[11,"map_same","","",18,[[["self"],["f"]],["t"]]],[11,"to_owned","","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"from_ok","","",19,[[["t"]],["t"]]],[11,"map_same","","",19,[[["self"],["f"]],["t"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from_ok","","",20,[[["t"]],["t"]]],[11,"map_same","","",20,[[["self"],["f"]],["t"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from_ok","","",21,[[["t"]],["t"]]],[11,"map_same","","",21,[[["self"],["f"]],["t"]]],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from_ok","","",22,[[["t"]],["t"]]],[11,"map_same","","",22,[[["self"],["f"]],["t"]]],[11,"to_owned","","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from_ok","","",23,[[["t"]],["t"]]],[11,"map_same","","",23,[[["self"],["f"]],["t"]]],[11,"to_owned","","",24,[[["self"]],["t"]]],[11,"clone_into","","",24,N],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"from_ok","","",24,[[["t"]],["t"]]],[11,"map_same","","",24,[[["self"],["f"]],["t"]]],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from_ok","","",25,[[["t"]],["t"]]],[11,"map_same","","",25,[[["self"],["f"]],["t"]]],[11,"to_owned","","",26,[[["self"]],["t"]]],[11,"clone_into","","",26,N],[11,"from","","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"from_ok","","",26,[[["t"]],["t"]]],[11,"map_same","","",26,[[["self"],["f"]],["t"]]],[11,"to_owned","","",27,[[["self"]],["t"]]],[11,"clone_into","","",27,N],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from_ok","","",27,[[["t"]],["t"]]],[11,"map_same","","",27,[[["self"],["f"]],["t"]]],[11,"to_owned","","",28,[[["self"]],["t"]]],[11,"clone_into","","",28,N],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from_ok","","",28,[[["t"]],["t"]]],[11,"map_same","","",28,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_resolve::macros","",29,[[["self"]],["t"]]],[11,"clone_into","","",29,N],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from_ok","","",29,[[["t"]],["t"]]],[11,"map_same","","",29,[[["self"],["f"]],["t"]]],[11,"to_owned","","",30,[[["self"]],["t"]]],[11,"clone_into","","",30,N],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"from_ok","","",30,[[["t"]],["t"]]],[11,"map_same","","",30,[[["self"],["f"]],["t"]]],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"from_ok","","",31,[[["t"]],["t"]]],[11,"map_same","","",31,[[["self"],["f"]],["t"]]],[11,"to_owned","","",32,[[["self"]],["t"]]],[11,"clone_into","","",32,N],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from_ok","","",32,[[["t"]],["t"]]],[11,"map_same","","",32,[[["self"],["f"]],["t"]]],[11,"to_owned","","",33,[[["self"]],["t"]]],[11,"clone_into","","",33,N],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from_ok","","",33,[[["t"]],["t"]]],[11,"map_same","","",33,[[["self"],["f"]],["t"]]],[11,"from","rustc_resolve::check_unused","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"from_ok","","",34,[[["t"]],["t"]]],[11,"map_same","","",34,[[["self"],["f"]],["t"]]],[11,"from","rustc_resolve::build_reduced_graph","",42,[[["t"]],["t"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"not_found","","",42,[[["str"],["str"]],["e"]]],[11,"from_ok","","",42,[[["t"]],["t"]]],[11,"map_same","","",42,[[["self"],["f"]],["t"]]],[11,"from","","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"from_ok","","",35,[[["t"]],["t"]]],[11,"map_same","","",35,[[["self"],["f"]],["t"]]],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"from_ok","","",36,[[["t"]],["t"]]],[11,"map_same","","",36,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_resolve::resolve_imports","",37,[[["self"]],["t"]]],[11,"clone_into","","",37,N],[11,"from","","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"from_ok","","",37,[[["t"]],["t"]]],[11,"map_same","","",37,[[["self"],["f"]],["t"]]],[11,"to_owned","","",38,[[["self"]],["t"]]],[11,"clone_into","","",38,N],[11,"from","","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"from_ok","","",38,[[["t"]],["t"]]],[11,"map_same","","",38,[[["self"],["f"]],["t"]]],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"from_ok","","",39,[[["t"]],["t"]]],[11,"map_same","","",39,[[["self"],["f"]],["t"]]],[11,"to_owned","","",40,[[["self"]],["t"]]],[11,"clone_into","","",40,N],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from_ok","","",40,[[["t"]],["t"]]],[11,"map_same","","",40,[[["self"],["f"]],["t"]]]],"paths":[[4,"Namespace"],[3,"PerNS"],[3,"ImportSuggestion"],[3,"BindingError"],[3,"BindingInfo"],[3,"UsePlacementFinder"],[3,"Rib"],[3,"ModuleData"],[3,"NameBinding"],[3,"PrivacyError"],[3,"UseError"],[3,"AmbiguityError"],[3,"PrimitiveTypeTable"],[3,"Resolver"],[3,"ResolverArenas"],[4,"AssocSuggestion"],[4,"ResolutionError"],[4,"PatternSource"],[4,"AliasPossibility"],[4,"PathSource"],[4,"TypeParameters"],[4,"RibKind"],[4,"LexicalScopeBinding"],[4,"ModuleOrUniformRoot"],[4,"PathResult"],[4,"ModuleKind"],[4,"NameBindingKind"],[4,"MakeGlobMap"],[4,"CrateLint"],[3,"FromPrelude"],[3,"InvocationData"],[3,"LegacyBinding"],[3,"ParentScope"],[4,"LegacyScope"],[3,"UnusedImportCheckVisitor"],[3,"LegacyMacroImports"],[3,"BuildReducedGraphVisitor"],[3,"ImportDirective"],[3,"NameResolution"],[3,"ImportResolver"],[4,"ImportDirectiveSubclass"],[8,"ToNameBinding"],[3,"IsMacroExport"]]};
searchIndex["rustc_save_analysis"]={"doc":"","items":[[3,"SaveContext","rustc_save_analysis","",N,N],[12,"tcx","","",0,N],[12,"tables","","",0,N],[12,"analysis","","",0,N],[12,"span_utils","","",0,N],[12,"config","","",0,N],[12,"impl_counter","","",0,N],[3,"PathCollector","","",N,N],[12,"collected_paths","","",1,N],[12,"collected_idents","","",1,N],[3,"DumpHandler","","Dump the save-analysis results to a file.",N,N],[12,"odir","","",2,N],[12,"cratename","","",2,N],[3,"CallbackHandler","","Call a callback with the results of save-analysis.",N,N],[12,"callback","","",3,N],[4,"Data","","",N,N],[13,"RefData","","",4,N],[13,"DefData","","",4,N],[13,"RelationData","","",4,N],[5,"make_signature","","",N,[[["fndecl"],["generics"]],["string"]]],[5,"process_crate","","",N,[[["tyctxt"],["crate"],["crateanalysis"],["str"],["option",["config"]],["h"]]]],[5,"find_config","","",N,[[["option",["config"]]],["config"]]],[5,"escape","","",N,[[["string"]],["string"]]],[5,"generated_code","","",N,[[["span"]],["bool"]]],[5,"id_from_def_id","","",N,[[["defid"]],["id"]]],[5,"id_from_node_id","","",N,[[["nodeid"],["savecontext"]],["id"]]],[5,"null_id","","",N,[[],["id"]]],[5,"lower_attributes","","",N,[[["vec",["attribute"]],["savecontext"]],["vec",["attribute"]]]],[0,"json_dumper","","",N,N],[3,"Access","rustc_save_analysis::json_dumper","",N,N],[12,"reachable","","",5,N],[12,"public","","",5,N],[3,"JsonDumper","","",N,N],[12,"result","","",6,N],[12,"config","","",6,N],[12,"output","","",6,N],[3,"WriteOutput","","",N,N],[12,"output","","",7,N],[3,"CallbackOutput","","",N,N],[12,"callback","","",8,N],[8,"DumpOutput","","",N,N],[10,"dump","","",9,[[["self"],["analysis"]]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"dump","","",7,[[["self"],["analysis"]]]],[11,"dump","","",8,[[["self"],["analysis"]]]],[11,"new","","",6,[[["w"],["config"]],["jsondumper",["writeoutput"]]]],[11,"with_callback","","",6,[[["fnmut"],["config"]],["jsondumper",["callbackoutput"]]]],[11,"drop","","",6,[[["self"]]]],[11,"crate_prelude","","",6,[[["self"],["cratepreludedata"]]]],[11,"macro_use","","",6,[[["self"],["macroref"]]]],[11,"import","","",6,[[["self"],["access"],["import"]]]],[11,"dump_ref","","",6,[[["self"],["ref"]]]],[11,"dump_def","","",6,[[["self"],["access"],["def"]]]],[11,"dump_relation","","",6,[[["self"],["relation"]]]],[11,"dump_impl","","",6,[[["self"],["impl"]]]],[0,"dump_visitor","rustc_save_analysis","Write the output of rustc's analysis to an implementor of Dump.",N,N],[3,"DumpVisitor","rustc_save_analysis::dump_visitor","",N,N],[12,"save_ctxt","","",10,N],[12,"tcx","","",10,N],[12,"dumper","","",10,N],[12,"span","","",10,N],[12,"cur_scope","","",10,N],[12,"macro_calls","","",10,N],[11,"new","","",10,[[["savecontext"],["jsondumper"]],["dumpvisitor"]]],[11,"nest_scope","","",10,[[["self"],["nodeid"],["f"]]]],[11,"nest_tables","","",10,[[["self"],["nodeid"],["f"]]]],[11,"span_from_span","","",10,[[["self"],["span"]],["spandata"]]],[11,"dump_crate_info","","",10,[[["self"],["str"],["crate"]]]],[11,"process_path_prefixes","","",10,[[["self"],["path"]],["vec"]]],[11,"write_sub_paths","","",10,[[["self"],["path"]]]],[11,"write_sub_paths_truncated","","",10,[[["self"],["path"]]]],[11,"write_sub_path_trait_truncated","","",10,[[["self"],["path"]]]],[11,"lookup_def_id","","",10,[[["self"],["nodeid"]],["option",["defid"]]]],[11,"process_formals","","",10,N],[11,"process_method","","",10,[[["self"],["methodsig"],["option",["block"]],["nodeid"],["ident"],["generics"],["visibility"],["span"]]]],[11,"process_struct_field_def","","",10,[[["self"],["structfield"],["nodeid"]]]],[11,"process_generic_params","","",10,[[["self"],["generics"],["span"],["str"],["nodeid"]]]],[11,"process_fn","","",10,[[["self"],["item"],["fndecl"],["generics"],["block"]]]],[11,"process_static_or_const_item","","",10,[[["self"],["item"],["ty"],["expr"]]]],[11,"process_assoc_const","","",10,N],[11,"process_struct","","",10,[[["self"],["item"],["variantdata"],["generics"]]]],[11,"process_enum","","",10,[[["self"],["item"],["enumdef"],["generics"]]]],[11,"process_impl","","",10,N],[11,"process_trait","","",10,N],[11,"process_mod","","",10,[[["self"],["item"]]]],[11,"dump_path_ref","","",10,[[["self"],["nodeid"],["path"]]]],[11,"process_path","","",10,[[["self"],["nodeid"],["path"]]]],[11,"process_struct_lit","","",10,N],[11,"process_method_call","","",10,N],[11,"process_pat","","",10,[[["self"],["pat"]]]],[11,"process_var_decl_multi","","",10,N],[11,"process_var_decl","","",10,[[["self"],["pat"],["string"]]]],[11,"process_macro_use","","Extract macro use and definition information from the AST node defined by the given NodeId, using the expansion information from the node's span.",10,[[["self"],["span"]]]],[11,"process_trait_item","","",10,[[["self"],["traititem"],["defid"]]]],[11,"process_impl_item","","",10,[[["self"],["implitem"],["defid"]]]],[11,"process_use_tree","","Dumps imports in a use tree recursively.",10,[[["self"],["usetree"],["nodeid"],["item"],["path"]]]],[11,"process_bounds","","",10,[[["self"],["genericbounds"]]]],[11,"visit_mod","","",10,N],[11,"visit_item","","",10,[[["self"],["item"]]]],[11,"visit_generics","","",10,[[["self"],["generics"]]]],[11,"visit_ty","","",10,[[["self"],["ty"]]]],[11,"visit_expr","","",10,[[["self"],["expr"]]]],[11,"visit_mac","","",10,[[["self"],["mac"]]]],[11,"visit_pat","","",10,[[["self"],["pat"]]]],[11,"visit_arm","","",10,[[["self"],["arm"]]]],[11,"visit_path","","",10,[[["self"],["path"],["nodeid"]]]],[11,"visit_stmt","","",10,[[["self"],["stmt"]]]],[11,"visit_local","","",10,[[["self"],["local"]]]],[11,"visit_foreign_item","","",10,[[["self"],["foreignitem"]]]],[0,"span_utils","rustc_save_analysis","",N,N],[3,"SpanUtils","rustc_save_analysis::span_utils","",N,N],[12,"sess","","",11,N],[12,"err_count","","",11,N],[11,"clone","","",11,[[["self"]],["spanutils"]]],[11,"new","","",11,[[["session"]],["spanutils"]]],[11,"make_path_string","","",11,[[["self"],["filename"]],["string"]]],[11,"snippet","","",11,[[["self"],["span"]],["string"]]],[11,"retokenise_span","","",11,[[["self"],["span"]],["stringreader"]]],[11,"span_for_last_ident","","",11,[[["self"],["span"]],["option",["span"]]]],[11,"span_for_first_ident","","",11,[[["self"],["span"]],["option",["span"]]]],[11,"sub_span_for_type_name","","",11,[[["self"],["span"]],["option",["span"]]]],[11,"sub_span_before_token","","",11,[[["self"],["span"],["token"]],["option",["span"]]]],[11,"sub_span_of_token","","",11,[[["self"],["span"],["token"]],["option",["span"]]]],[11,"sub_span_after_keyword","","",11,[[["self"],["span"],["keyword"]],["option",["span"]]]],[11,"sub_span_after","","",11,[[["self"],["span"],["f"]],["option",["span"]]]],[11,"filter_generated","","Return true if the span is generated code, and it is not a subspan of the root callsite.",11,[[["self"],["option",["span"]],["span"]],["bool"]]],[0,"sig","rustc_save_analysis","",N,N],[5,"item_signature","rustc_save_analysis::sig","",N,[[["item"],["savecontext"]],["option",["signature"]]]],[5,"foreign_item_signature","","",N,[[["foreignitem"],["savecontext"]],["option",["signature"]]]],[5,"field_signature","","Signature for a struct or tuple field declaration. Does not include a trailing comma.",N,[[["structfield"],["savecontext"]],["option",["signature"]]]],[5,"variant_signature","","Does not include a trailing comma.",N,[[["variant"],["savecontext"]],["option",["signature"]]]],[5,"method_signature","","",N,[[["nodeid"],["ident"],["generics"],["methodsig"],["savecontext"]],["option",["signature"]]]],[5,"assoc_const_signature","","",N,[[["nodeid"],["name"],["ty"],["option",["expr"]],["savecontext"]],["option",["signature"]]]],[5,"assoc_type_signature","","",N,[[["nodeid"],["ident"],["option",["genericbounds"]],["option",["ty"]],["savecontext"]],["option",["signature"]]]],[5,"extend_sig","","",N,[[["signature"],["string"],["vec",["sigelement"]],["vec",["sigelement"]]],["signature"]]],[5,"replace_text","","",N,[[["signature"],["string"]],["signature"]]],[5,"merge_sigs","","",N,[[["string"],["vec",["signature"]]],["signature"]]],[5,"text_sig","","",N,[[["string"]],["signature"]]],[5,"name_and_generics","","",N,[[["string"],["usize"],["generics"],["nodeid"],["ident"],["savecontext"]],["result",["signature","str"]]]],[5,"make_assoc_type_signature","","",N,[[["nodeid"],["ident"],["option",["genericbounds"]],["option",["ty"]],["savecontext"]],["result",["signature","str"]]]],[5,"make_assoc_const_signature","","",N,[[["nodeid"],["name"],["ty"],["option",["expr"]],["savecontext"]],["result",["signature","str"]]]],[5,"make_method_signature","","",N,[[["nodeid"],["ident"],["generics"],["methodsig"],["savecontext"]],["result",["signature","str"]]]],[6,"Result","","",N,N],[8,"Sig","","",N,N],[10,"make","","",12,[[["self"],["usize"],["option",["nodeid"]],["savecontext"]],["result",["signature","str"]]]],[8,"SaveHandler","rustc_save_analysis","Defines what to do with the results of saving the analysis.",N,N],[10,"save","","",13,[[["self"],["savecontext"],["crate"],["str"]]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"span_from_span","","",0,[[["self"],["span"]],["spandata"]]],[11,"get_external_crates","","",0,[[["self"]],["vec",["externalcratedata"]]]],[11,"get_extern_item_data","","",0,[[["self"],["foreignitem"]],["option",["data"]]]],[11,"get_item_data","","",0,[[["self"],["item"]],["option",["data"]]]],[11,"get_field_data","","",0,[[["self"],["structfield"],["nodeid"]],["option",["def"]]]],[11,"get_method_data","","",0,[[["self"],["nodeid"],["name"],["span"]],["option",["def"]]]],[11,"get_trait_ref_data","","",0,[[["self"],["traitref"]],["option",["ref"]]]],[11,"get_expr_data","","",0,[[["self"],["expr"]],["option",["data"]]]],[11,"get_path_def","","",0,[[["self"],["nodeid"]],["hirdef"]]],[11,"get_path_data","","",0,[[["self"],["nodeid"],["path"]],["option",["ref"]]]],[11,"get_field_ref_data","","",0,[[["self"],["field"],["variantdef"]],["option",["ref"]]]],[11,"get_macro_use_data","","Attempt to return MacroRef for any AST node.",0,[[["self"],["span"]],["option",["macroref"]]]],[11,"lookup_ref_id","","",0,[[["self"],["nodeid"]],["option",["defid"]]]],[11,"docs_for_attrs","","",0,N],[11,"next_impl_id","","",0,[[["self"]],["u32"]]],[11,"new","","",1,[[],["pathcollector"]]],[11,"visit_pat","","",1,[[["self"],["pat"]]]],[11,"new","","",2,[[["option",["path"]],["str"]],["dumphandler"]]],[11,"output_file","","",2,[[["self"],["savecontext"]],["file"]]],[11,"save","","",2,[[["self"],["savecontext"],["crate"],["str"]]]],[11,"save","","",3,[[["self"],["savecontext"],["crate"],["str"]]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"from","rustc_save_analysis::json_dumper","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"from","rustc_save_analysis::dump_visitor","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_save_analysis::span_utils","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]]],"paths":[[3,"SaveContext"],[3,"PathCollector"],[3,"DumpHandler"],[3,"CallbackHandler"],[4,"Data"],[3,"Access"],[3,"JsonDumper"],[3,"WriteOutput"],[3,"CallbackOutput"],[8,"DumpOutput"],[3,"DumpVisitor"],[3,"SpanUtils"],[8,"Sig"],[8,"SaveHandler"]]};
searchIndex["rustc_target"]={"doc":"Some stuff used by rustc that doesn't have many dependencies","items":[[0,"abi","rustc_target","",N,N],[3,"TargetDataLayout","rustc_target::abi","Parsed Data layout for a target, which contains everything needed to compute layouts.",N,N],[12,"endian","","",0,N],[12,"i1_align","","",0,N],[12,"i8_align","","",0,N],[12,"i16_align","","",0,N],[12,"i32_align","","",0,N],[12,"i64_align","","",0,N],[12,"i128_align","","",0,N],[12,"f32_align","","",0,N],[12,"f64_align","","",0,N],[12,"pointer_size","","",0,N],[12,"pointer_align","","",0,N],[12,"aggregate_align","","",0,N],[12,"vector_align","","Alignments for vector types.",0,N],[3,"Size","","Size of a type in bytes.",N,N],[12,"raw","","",1,N],[3,"Align","","Alignment of a type in bytes, both ABI-mandated and preferred. Each field is a power of two, giving the alignment a maximum value of 2(28 - 1), which is limited by LLVM to a maximum capacity of 229 or 536870912.",N,N],[12,"abi_pow2","","",2,N],[12,"pref_pow2","","",2,N],[3,"Scalar","","Information about one scalar component of a Rust type.",N,N],[12,"value","","",3,N],[12,"valid_range","","Inclusive wrap-around range of valid values, that is, if start > end, it represents `start..=max_value()`, followed by `0..=end`.",3,N],[3,"LayoutDetails","","",N,N],[12,"variants","","",4,N],[12,"fields","","",4,N],[12,"abi","","",4,N],[12,"align","","",4,N],[12,"size","","",4,N],[3,"TyLayout","","The details of the layout of a type, alongside the type itself. Provides various type traversal APIs (e.g. recursing into fields).",N,N],[12,"ty","","",5,N],[12,"details","","",5,N],[4,"Endian","","Endianness of the target, which must match cfg(target-endian).",N,N],[13,"Little","","",6,N],[13,"Big","","",6,N],[4,"Integer","","Integers, also used for enum discriminants.",N,N],[13,"I8","","",7,N],[13,"I16","","",7,N],[13,"I32","","",7,N],[13,"I64","","",7,N],[13,"I128","","",7,N],[4,"FloatTy","","",N,N],[13,"F32","","",8,N],[13,"F64","","",8,N],[4,"Primitive","","Fundamental unit of memory access and layout.",N,N],[13,"Int","","The `bool` is the signedness of the `Integer` type.",9,N],[13,"Float","","",9,N],[13,"Pointer","","",9,N],[4,"FieldPlacement","","Describes how the fields of a type are located in memory.",N,N],[13,"Union","","All fields start at no offset. The `usize` is the field count.",10,N],[13,"Array","","Array/vector-like placement, with all fields of identical types.",10,N],[12,"stride","rustc_target::abi::FieldPlacement","",10,N],[12,"count","","",10,N],[13,"Arbitrary","rustc_target::abi","Struct-like placement, with precomputed offsets.",10,N],[12,"offsets","rustc_target::abi::FieldPlacement","Offsets for the first byte of each field, ordered to match the source definition order. This vector does not go in increasing order.",10,N],[12,"memory_index","","Maps source order field indices to memory order indices, depending how fields were permuted.",10,N],[4,"Abi","rustc_target::abi","Describes how values of the type are passed by target ABIs, in terms of categories of C types there are ABI rules for.",N,N],[13,"Uninhabited","","",11,N],[13,"Scalar","","",11,N],[13,"ScalarPair","","",11,N],[13,"Vector","","",11,N],[12,"element","rustc_target::abi::Abi","",11,N],[12,"count","","",11,N],[13,"Aggregate","rustc_target::abi","",11,N],[12,"sized","rustc_target::abi::Abi","If true, the size is exact, otherwise it's only a lower bound.",11,N],[4,"Variants","rustc_target::abi","",N,N],[13,"Single","","Single enum variants, structs/tuples, unions, and all non-ADTs.",12,N],[12,"index","rustc_target::abi::Variants","",12,N],[13,"Tagged","rustc_target::abi","General-case enums: for each case there is a struct, and they all have all space reserved for the tag, and their first field starts at a non-0 offset, after where the tag would go.",12,N],[12,"tag","rustc_target::abi::Variants","",12,N],[12,"variants","","",12,N],[13,"NicheFilling","rustc_target::abi","Multiple cases distinguished by a niche (values invalid for a type): the variant `dataful_variant` contains a niche at an arbitrary offset (field 0 of the enum), which for a variant with discriminant `d` is set to `(d - niche_variants.start).wrapping_add(niche_start)`.",12,N],[12,"dataful_variant","rustc_target::abi::Variants","",12,N],[12,"niche_variants","","",12,N],[12,"niche","","",12,N],[12,"niche_start","","",12,N],[12,"variants","","",12,N],[0,"call","rustc_target::abi","",N,N],[3,"ArgAttribute","rustc_target::abi::call","",N,N],[12,"bits","","",13,N],[3,"ArgAttributes","","A compact representation of LLVM attributes (at least those relevant for this module) that can be manipulated without interacting with LLVM's Attribute machinery.",N,N],[12,"regular","","",14,N],[12,"pointee_size","","",14,N],[12,"pointee_align","","",14,N],[3,"Reg","","",N,N],[12,"kind","","",15,N],[12,"size","","",15,N],[3,"Uniform","","An argument passed entirely registers with the same kind (e.g. HFA / HVA on PPC64 and AArch64).",N,N],[12,"unit","","",16,N],[12,"total","","The total size of the argument, which can be: * equal to `unit.size` (one scalar/vector) * a multiple of `unit.size` (an array of scalar/vectors) * if `unit.kind` is `Integer`, the last element   can be shorter, i.e. `{ i64, i64, i32 }` for   64-bit integers with a total size of 20 bytes",16,N],[3,"CastTarget","","",N,N],[12,"prefix","","",17,N],[12,"prefix_chunk","","",17,N],[12,"rest","","",17,N],[3,"ArgType","","Information about how to pass an argument to, or return a value from, a function, under some ABI.",N,N],[12,"layout","","",18,N],[12,"pad","","Dummy argument, which is emitted before the real argument.",18,N],[12,"mode","","",18,N],[3,"FnType","","Metadata describing how the arguments to a native function should be passed in order to respect the native ABI.",N,N],[12,"args","","The LLVM types of each argument.",19,N],[12,"ret","","LLVM return type.",19,N],[12,"variadic","","",19,N],[12,"conv","","",19,N],[4,"PassMode","","",N,N],[13,"Ignore","","Ignore the argument (useful for empty struct).",20,N],[13,"Direct","","Pass the argument directly.",20,N],[13,"Pair","","Pass a pair's elements directly in two arguments.",20,N],[13,"Cast","","Pass the argument after casting it, to either a single uniform or a pair of registers.",20,N],[13,"Indirect","","Pass the argument indirectly via a hidden pointer. The second value, if any, is for the extra data (vtable or length) which indicates that it refers to an unsized rvalue.",20,N],[4,"RegKind","","",N,N],[13,"Integer","","",21,N],[13,"Float","","",21,N],[13,"Vector","","",21,N],[4,"Conv","","",N,N],[13,"C","","",22,N],[13,"ArmAapcs","","",22,N],[13,"Msp430Intr","","",22,N],[13,"PtxKernel","","",22,N],[13,"X86Fastcall","","",22,N],[13,"X86Intr","","",22,N],[13,"X86Stdcall","","",22,N],[13,"X86ThisCall","","",22,N],[13,"X86VectorCall","","",22,N],[13,"X86_64SysV","","",22,N],[13,"X86_64Win64","","",22,N],[13,"AmdGpuKernel","","",22,N],[0,"aarch64","","",N,N],[5,"is_homogeneous_aggregate","rustc_target::abi::call::aarch64","",N,[[["c"],["argtype"]],["option",["uniform"]]]],[5,"classify_ret_ty","","",N,[[["c"],["argtype"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"amdgpu","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::amdgpu","",N,[[["c"],["argtype"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"arm","rustc_target::abi::call","",N,N],[5,"is_homogeneous_aggregate","rustc_target::abi::call::arm","",N,[[["c"],["argtype"]],["option",["uniform"]]]],[5,"classify_ret_ty","","",N,[[["c"],["argtype"],["bool"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"],["bool"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"asmjs","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::asmjs","",N,[[["c"],["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"hexagon","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::hexagon","",N,[[["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["fntype"]]]],[0,"mips","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::mips","",N,[[["c"],["argtype"],["size"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"],["size"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"mips64","rustc_target::abi::call","",N,N],[5,"extend_integer_width_mips","rustc_target::abi::call::mips64","",N,[[["argtype"],["u64"]]]],[5,"float_reg","","",N,[[["c"],["argtype"],["usize"]],["option",["reg"]]]],[5,"classify_ret_ty","","",N,[[["c"],["argtype"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"msp430","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::msp430","",N,[[["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["fntype"]]]],[0,"nvptx","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::nvptx","",N,[[["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["fntype"]]]],[0,"nvptx64","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::nvptx64","",N,[[["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["fntype"]]]],[0,"powerpc","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::powerpc","",N,[[["c"],["argtype"],["size"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"],["size"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"powerpc64","rustc_target::abi::call","",N,N],[4,"ABI","rustc_target::abi::call::powerpc64","",N,N],[13,"ELFv1","","",23,N],[13,"ELFv2","","",23,N],[5,"is_homogeneous_aggregate","","",N,[[["c"],["argtype"],["abi"]],["option",["uniform"]]]],[5,"classify_ret_ty","","",N,[[["c"],["argtype"],["abi"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"],["abi"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"clone","","",23,[[["self"]],["abi"]]],[11,"eq","","",23,[[["self"],["abi"]],["bool"]]],[0,"riscv","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::riscv","",N,[[["argtype"],["u64"]]]],[5,"classify_arg_ty","","",N,[[["argtype"],["u64"]]]],[5,"compute_abi_info","","",N,[[["fntype"],["u64"]]]],[0,"s390x","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::s390x","",N,[[["argtype"]]]],[5,"is_single_fp_element","","",N,[[["c"],["tylayout"]],["bool"]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"sparc","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::sparc","",N,[[["c"],["argtype"],["size"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"],["size"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"sparc64","rustc_target::abi::call","",N,N],[5,"is_homogeneous_aggregate","rustc_target::abi::call::sparc64","",N,[[["c"],["argtype"]],["option",["uniform"]]]],[5,"classify_ret_ty","","",N,[[["c"],["argtype"]]]],[5,"classify_arg_ty","","",N,[[["c"],["argtype"]]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[0,"x86","rustc_target::abi::call","",N,N],[4,"Flavor","rustc_target::abi::call::x86","",N,N],[13,"General","","",24,N],[13,"Fastcall","","",24,N],[5,"is_single_fp_element","","",N,[[["c"],["tylayout"]],["bool"]]],[5,"compute_abi_info","","",N,[[["c"],["fntype"],["flavor"]]]],[11,"eq","","",24,[[["self"],["flavor"]],["bool"]]],[0,"x86_64","rustc_target::abi::call","",N,N],[3,"Memory","rustc_target::abi::call::x86_64","",N,N],[4,"Class","","Classification of \"eightbyte\" components.",N,N],[13,"Int","","",25,N],[13,"Sse","","",25,N],[13,"SseUp","","",25,N],[5,"classify_arg","","",N,[[["c"],["argtype"]],["result",["memory"]]]],[5,"reg_component","","",N,N],[5,"cast_target","","",N,N],[5,"compute_abi_info","","",N,[[["c"],["fntype"]]]],[17,"LARGEST_VECTOR_SIZE","","",N,N],[17,"MAX_EIGHTBYTES","","",N,N],[11,"clone","","",25,[[["self"]],["class"]]],[11,"eq","","",25,[[["self"],["class"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",25,N],[11,"partial_cmp","","",25,[[["self"],["class"]],["option",["ordering"]]]],[11,"cmp","","",25,[[["self"],["class"]],["ordering"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"clone","","",26,[[["self"]],["memory"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[0,"x86_win64","rustc_target::abi::call","",N,N],[5,"compute_abi_info","rustc_target::abi::call::x86_win64","",N,[[["fntype"]]]],[0,"wasm32","rustc_target::abi::call","",N,N],[5,"classify_ret_ty","rustc_target::abi::call::wasm32","",N,[[["argtype"]]]],[5,"classify_arg_ty","","",N,[[["argtype"]]]],[5,"compute_abi_info","","",N,[[["fntype"]]]],[0,"attr_impl","rustc_target::abi::call","",N,N],[3,"ArgAttribute","rustc_target::abi::call::attr_impl","",N,N],[12,"bits","","",13,N],[11,"eq","rustc_target::abi::call","",13,[[["self"],["argattribute"]],["bool"]]],[11,"ne","","",13,[[["self"],["argattribute"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",13,N],[11,"clone","","",13,[[["self"]],["argattribute"]]],[11,"partial_cmp","","",13,[[["self"],["argattribute"]],["option",["ordering"]]]],[11,"lt","","",13,[[["self"],["argattribute"]],["bool"]]],[11,"le","","",13,[[["self"],["argattribute"]],["bool"]]],[11,"gt","","",13,[[["self"],["argattribute"]],["bool"]]],[11,"ge","","",13,[[["self"],["argattribute"]],["bool"]]],[11,"cmp","","",13,[[["self"],["argattribute"]],["ordering"]]],[11,"hash","","",13,N],[11,"default","","",13,[[],["argattribute"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[18,"ByVal","","",13,N],[18,"NoAlias","","",13,N],[18,"NoCapture","","",13,N],[18,"NonNull","","",13,N],[18,"ReadOnly","","",13,N],[18,"SExt","","",13,N],[18,"StructRet","","",13,N],[18,"ZExt","","",13,N],[18,"InReg","","",13,N],[11,"empty","","Returns an empty set of flags.",13,[[],["argattribute"]]],[11,"all","","Returns the set containing all flags.",13,[[],["argattribute"]]],[11,"bits","","Returns the raw value of the flags currently stored.",13,[[["self"]],["u16"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",13,[[["u16"]],["option",["argattribute"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",13,[[["u16"]],["argattribute"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",13,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",13,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",13,[[["self"],["argattribute"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",13,[[["self"],["argattribute"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",13,[[["self"],["argattribute"]]]],[11,"remove","","Removes the specified flags in-place.",13,[[["self"],["argattribute"]]]],[11,"toggle","","Toggles the specified flags in-place.",13,[[["self"],["argattribute"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",13,[[["self"],["argattribute"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",13,[[["self"],["argattribute"]],["argattribute"]]],[11,"bitor_assign","","Adds the set of flags.",13,[[["self"],["argattribute"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",13,[[["self"],["argattribute"]],["argattribute"]]],[11,"bitxor_assign","","Toggles the set of flags.",13,[[["self"],["argattribute"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",13,[[["self"],["argattribute"]],["argattribute"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",13,[[["self"],["argattribute"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",13,[[["self"],["argattribute"]],["argattribute"]]],[11,"sub_assign","","Disables all flags enabled in the set.",13,[[["self"],["argattribute"]]]],[11,"not","","Returns the complement of this set of flags.",13,[[["self"]],["argattribute"]]],[11,"extend","","",13,[[["self"],["t"]]]],[11,"from_iter","","",13,[[["t"]],["argattribute"]]],[11,"clone","","",20,[[["self"]],["passmode"]]],[11,"eq","","",20,[[["self"],["passmode"]],["bool"]]],[11,"ne","","",20,[[["self"],["passmode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",20,N],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"clone","","",14,[[["self"]],["argattributes"]]],[11,"eq","","",14,[[["self"],["argattributes"]],["bool"]]],[11,"ne","","",14,[[["self"],["argattributes"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",14,N],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"new","","",14,[[],["self"]]],[11,"set","","",14,[[["self"],["argattribute"]],["self"]]],[11,"contains","","",14,[[["self"],["argattribute"]],["bool"]]],[11,"clone","","",21,[[["self"]],["regkind"]]],[11,"eq","","",21,[[["self"],["regkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"clone","","",15,[[["self"]],["reg"]]],[11,"eq","","",15,[[["self"],["reg"]],["bool"]]],[11,"ne","","",15,[[["self"],["reg"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",15,N],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"i8","","",15,[[],["reg"]]],[11,"i16","","",15,[[],["reg"]]],[11,"i32","","",15,[[],["reg"]]],[11,"i64","","",15,[[],["reg"]]],[11,"f32","","",15,[[],["reg"]]],[11,"f64","","",15,[[],["reg"]]],[11,"align","","",15,[[["self"],["c"]],["align"]]],[11,"clone","","",16,[[["self"]],["uniform"]]],[11,"eq","","",16,[[["self"],["uniform"]],["bool"]]],[11,"ne","","",16,[[["self"],["uniform"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",16,N],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"from","","",16,[[["reg"]],["uniform"]]],[11,"align","","",16,[[["self"],["c"]],["align"]]],[11,"clone","","",17,[[["self"]],["casttarget"]]],[11,"eq","","",17,[[["self"],["casttarget"]],["bool"]]],[11,"ne","","",17,[[["self"],["casttarget"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",17,N],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"from","","",17,[[["reg"]],["casttarget"]]],[11,"from","","",17,[[["uniform"]],["casttarget"]]],[11,"pair","","",17,[[["reg"],["reg"]],["casttarget"]]],[11,"size","","",17,[[["self"],["c"]],["size"]]],[11,"align","","",17,[[["self"],["c"]],["align"]]],[11,"is_aggregate","rustc_target::abi","",5,[[["self"]],["bool"]]],[11,"homogeneous_aggregate","","",5,[[["self"],["c"]],["option",["reg"]]]],[11,"fmt","rustc_target::abi::call","",18,[[["self"],["formatter"]],["result"]]],[11,"new","","",18,[[["tylayout"]],["self"]]],[11,"make_indirect","","",18,[[["self"]]]],[11,"make_indirect_byval","","",18,[[["self"]]]],[11,"extend_integer_width_to","","",18,[[["self"],["u64"]]]],[11,"cast_to","","",18,[[["self"],["t"]]]],[11,"pad_with","","",18,[[["self"],["reg"]]]],[11,"is_indirect","","",18,[[["self"]],["bool"]]],[11,"is_sized_indirect","","",18,[[["self"]],["bool"]]],[11,"is_unsized_indirect","","",18,[[["self"]],["bool"]]],[11,"is_ignore","","",18,[[["self"]],["bool"]]],[11,"clone","","",22,[[["self"]],["conv"]]],[11,"eq","","",22,[[["self"],["conv"]],["bool"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"adjust_for_cabi","","",19,[[["self"],["c"],["abi"]],["result",["string"]]]],[22,"","rustc_target::abi","",N,N],[8,"HasDataLayout","","",N,N],[10,"data_layout","","",27,[[["self"]],["targetdatalayout"]]],[8,"LayoutOf","","",N,N],[16,"Ty","","",28,N],[16,"TyLayout","","",28,N],[10,"layout_of","","",28,N],[8,"TyLayoutMethods","","",N,N],[10,"for_variant","","",29,[[["tylayout"],["c"],["usize"]],["tylayout"]]],[10,"field","","",29,N],[11,"default","","Creates an instance of `TargetDataLayout`.",0,[[],["targetdatalayout"]]],[11,"parse","","",0,[[["target"]],["result",["targetdatalayout","string"]]]],[11,"obj_size_bound","","Return exclusive upper bound on object size.",0,[[["self"]],["u64"]]],[11,"ptr_sized_integer","","",0,[[["self"]],["integer"]]],[11,"vector_align","","",0,[[["self"],["size"]],["align"]]],[11,"clone","","",6,[[["self"]],["endian"]]],[11,"clone","","",1,[[["self"]],["size"]]],[11,"eq","","",1,[[["self"],["size"]],["bool"]]],[11,"ne","","",1,[[["self"],["size"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",1,N],[11,"partial_cmp","","",1,[[["self"],["size"]],["option",["ordering"]]]],[11,"lt","","",1,[[["self"],["size"]],["bool"]]],[11,"le","","",1,[[["self"],["size"]],["bool"]]],[11,"gt","","",1,[[["self"],["size"]],["bool"]]],[11,"ge","","",1,[[["self"],["size"]],["bool"]]],[11,"cmp","","",1,[[["self"],["size"]],["ordering"]]],[11,"hash","","",1,N],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"encode","","",1,[[["self"],["__s"]],["result"]]],[11,"decode","","",1,[[["__d"]],["result",["size"]]]],[18,"ZERO","","",1,N],[11,"from_bits","","",1,[[["u64"]],["size"]]],[11,"from_bytes","","",1,[[["u64"]],["size"]]],[11,"bytes","","",1,[[["self"]],["u64"]]],[11,"bits","","",1,[[["self"]],["u64"]]],[11,"abi_align","","",1,[[["self"],["align"]],["size"]]],[11,"is_abi_aligned","","",1,[[["self"],["align"]],["bool"]]],[11,"checked_add","","",1,[[["self"],["size"],["c"]],["option",["size"]]]],[11,"checked_mul","","",1,[[["self"],["u64"],["c"]],["option",["size"]]]],[11,"add","","",1,[[["self"],["size"]],["size"]]],[11,"sub","","",1,[[["self"],["size"]],["size"]]],[11,"mul","","",1,[[["self"],["u64"]],["size"]]],[11,"add_assign","","",1,[[["self"],["size"]]]],[11,"clone","","",2,[[["self"]],["align"]]],[11,"eq","","",2,[[["self"],["align"]],["bool"]]],[11,"ne","","",2,[[["self"],["align"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"cmp","","",2,[[["self"],["align"]],["ordering"]]],[11,"partial_cmp","","",2,[[["self"],["align"]],["option",["ordering"]]]],[11,"lt","","",2,[[["self"],["align"]],["bool"]]],[11,"le","","",2,[[["self"],["align"]],["bool"]]],[11,"gt","","",2,[[["self"],["align"]],["bool"]]],[11,"ge","","",2,[[["self"],["align"]],["bool"]]],[11,"hash","","",2,N],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"encode","","",2,[[["self"],["__s"]],["result"]]],[11,"decode","","",2,[[["__d"]],["result",["align"]]]],[11,"from_bits","","",2,[[["u64"],["u64"]],["result",["align","string"]]]],[11,"from_bytes","","",2,[[["u64"],["u64"]],["result",["align","string"]]]],[11,"abi","","",2,[[["self"]],["u64"]]],[11,"pref","","",2,[[["self"]],["u64"]]],[11,"abi_bits","","",2,[[["self"]],["u64"]]],[11,"pref_bits","","",2,[[["self"]],["u64"]]],[11,"min","","",2,[[["self"],["align"]],["align"]]],[11,"max","","",2,[[["self"],["align"]],["align"]]],[11,"max_for_offset","","Compute the best alignment possible for the given offset (the largest power of two that the offset is a multiple of).",2,[[["size"]],["align"]]],[11,"restrict_for_offset","","Lower the alignment, if necessary, such that the given offset is aligned to it (the offset is a multiple of the aligment).",2,[[["self"],["size"]],["align"]]],[11,"clone","","",7,[[["self"]],["integer"]]],[11,"eq","","",7,[[["self"],["integer"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"partial_cmp","","",7,[[["self"],["integer"]],["option",["ordering"]]]],[11,"cmp","","",7,[[["self"],["integer"]],["ordering"]]],[11,"hash","","",7,N],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"size","","",7,[[["self"]],["size"]]],[11,"align","","",7,[[["self"],["c"]],["align"]]],[11,"fit_signed","","Find the smallest Integer type which can represent the signed value.",7,[[["i128"]],["integer"]]],[11,"fit_unsigned","","Find the smallest Integer type which can represent the unsigned value.",7,[[["u128"]],["integer"]]],[11,"for_abi_align","","Find the smallest integer with the given alignment.",7,[[["c"],["align"]],["option",["integer"]]]],[11,"approximate_abi_align","","Find the largest integer with the given alignment or less.",7,[[["c"],["align"]],["integer"]]],[11,"clone","","",8,[[["self"]],["floatty"]]],[11,"eq","","",8,[[["self"],["floatty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",8,N],[11,"encode","","",8,[[["self"],["__s"]],["result"]]],[11,"decode","","",8,[[["__d"]],["result",["floatty"]]]],[11,"hash","","",8,N],[11,"partial_cmp","","",8,[[["self"],["floatty"]],["option",["ordering"]]]],[11,"cmp","","",8,[[["self"],["floatty"]],["ordering"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"ty_to_string","","",8,[[["self"]],["str"]]],[11,"bit_width","","",8,[[["self"]],["usize"]]],[11,"clone","","",9,[[["self"]],["primitive"]]],[11,"eq","","",9,[[["self"],["primitive"]],["bool"]]],[11,"ne","","",9,[[["self"],["primitive"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"hash","","",9,N],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"size","","",9,[[["self"],["c"]],["size"]]],[11,"align","","",9,[[["self"],["c"]],["align"]]],[11,"is_float","","",9,[[["self"]],["bool"]]],[11,"is_int","","",9,[[["self"]],["bool"]]],[11,"clone","","",3,[[["self"]],["scalar"]]],[11,"eq","","",3,[[["self"],["scalar"]],["bool"]]],[11,"ne","","",3,[[["self"],["scalar"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"hash","","",3,N],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"is_bool","","",3,[[["self"]],["bool"]]],[11,"valid_range_exclusive","","Returns the valid range as a `x..y` range.",3,[[["self"],["c"]],["range",["u128"]]]],[11,"eq","","",10,[[["self"],["fieldplacement"]],["bool"]]],[11,"ne","","",10,[[["self"],["fieldplacement"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"hash","","",10,N],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"count","","",10,[[["self"]],["usize"]]],[11,"offset","","",10,[[["self"],["usize"]],["size"]]],[11,"memory_index","","",10,[[["self"],["usize"]],["usize"]]],[11,"index_by_increasing_offset","","Get source indices of the fields by increasing offsets.",10,N],[11,"clone","","",11,[[["self"]],["abi"]]],[11,"eq","","",11,[[["self"],["abi"]],["bool"]]],[11,"ne","","",11,[[["self"],["abi"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",11,N],[11,"hash","","",11,N],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"is_unsized","","Returns true if the layout corresponds to an unsized type.",11,[[["self"]],["bool"]]],[11,"is_signed","","Returns true if this is a single signed integer scalar",11,[[["self"]],["bool"]]],[11,"eq","","",12,[[["self"],["variants"]],["bool"]]],[11,"ne","","",12,[[["self"],["variants"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",12,N],[11,"hash","","",12,N],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"eq","","",4,[[["self"],["layoutdetails"]],["bool"]]],[11,"ne","","",4,[[["self"],["layoutdetails"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"hash","","",4,N],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"scalar","","",4,[[["c"],["scalar"]],["self"]]],[11,"clone","","",5,[[["self"]],["tylayout"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"deref","","",5,[[["self"]],["layoutdetails"]]],[11,"for_variant","","",5,[[["self"],["c"],["usize"]],["self"]]],[11,"field","","",5,N],[11,"is_unsized","","Returns true if the layout corresponds to an unsized type.",5,[[["self"]],["bool"]]],[11,"is_zst","","Returns true if the type is a ZST and not unsized.",5,[[["self"]],["bool"]]],[11,"size_and_align","","",5,N],[0,"spec","rustc_target","Flexible target specification.",N,N],[3,"Target","rustc_target::spec","Everything `rustc` knows about how to compile for a specific target.",N,N],[12,"llvm_target","","Target triple to pass to LLVM.",30,N],[12,"target_endian","","String to use as the `target_endian` `cfg` variable.",30,N],[12,"target_pointer_width","","String to use as the `target_pointer_width` `cfg` variable.",30,N],[12,"target_c_int_width","","Width of c_int type",30,N],[12,"target_os","","OS name to use for conditional compilation.",30,N],[12,"target_env","","Environment name to use for conditional compilation.",30,N],[12,"target_vendor","","Vendor name to use for conditional compilation.",30,N],[12,"arch","","Architecture to use for ABI considerations. Valid options: \"x86\", \"x86_64\", \"arm\", \"aarch64\", \"mips\", \"powerpc\", and \"powerpc64\".",30,N],[12,"data_layout","","Data layout to pass to LLVM.",30,N],[12,"linker_flavor","","Linker flavor",30,N],[12,"options","","Optional settings with defaults.",30,N],[3,"TargetOptions","","Optional aspects of a target specification.",N,N],[12,"is_builtin","","Whether the target is built-in or loaded from a custom target specification.",31,N],[12,"linker","","Linker to invoke",31,N],[12,"lld_flavor","","LLD flavor",31,N],[12,"pre_link_args","","Linker arguments that are passed before any user-defined libraries.",31,N],[12,"pre_link_args_crt","","",31,N],[12,"pre_link_objects_exe","","Objects to link before all others, always found within the sysroot folder.",31,N],[12,"pre_link_objects_exe_crt","","",31,N],[12,"pre_link_objects_dll","","",31,N],[12,"late_link_args","","Linker arguments that are unconditionally passed after any user-defined but before post_link_objects.  Standard platform libraries that should be always be linked to, usually go here.",31,N],[12,"post_link_objects","","Objects to link after all others, always found within the sysroot folder.",31,N],[12,"post_link_objects_crt","","",31,N],[12,"post_link_args","","Linker arguments that are unconditionally passed after any user-defined libraries.",31,N],[12,"link_env","","Environment variables to be set before invoking the linker.",31,N],[12,"asm_args","","Extra arguments to pass to the external assembler (when used)",31,N],[12,"cpu","","Default CPU to pass to LLVM. Corresponds to `llc -mcpu=$cpu`. Defaults to \"generic\".",31,N],[12,"features","","Default target features to pass to LLVM. These features will always be passed, and cannot be disabled even via `-C`. Corresponds to `llc -mattr=$features`.",31,N],[12,"dynamic_linking","","Whether dynamic linking is available on this target. Defaults to false.",31,N],[12,"only_cdylib","","If dynamic linking is available, whether only cdylibs are supported.",31,N],[12,"executables","","Whether executables are available on this target. iOS, for example, only allows static libraries. Defaults to false.",31,N],[12,"relocation_model","","Relocation model to use in object file. Corresponds to `llc -relocation-model=$relocation_model`. Defaults to \"pic\".",31,N],[12,"code_model","","Code model to use. Corresponds to `llc -code-model=$code_model`.",31,N],[12,"tls_model","","TLS model to use. Options are \"global-dynamic\" (default), \"local-dynamic\", \"initial-exec\" and \"local-exec\". This is similar to the -ftls-model option in GCC/Clang.",31,N],[12,"disable_redzone","","Do not emit code that uses the \"red zone\", if the ABI has one. Defaults to false.",31,N],[12,"eliminate_frame_pointer","","Eliminate frame pointers from stack frames if possible. Defaults to true.",31,N],[12,"function_sections","","Emit each function in its own section. Defaults to true.",31,N],[12,"dll_prefix","","String to prepend to the name of every dynamic library. Defaults to \"lib\".",31,N],[12,"dll_suffix","","String to append to the name of every dynamic library. Defaults to \".so\".",31,N],[12,"exe_suffix","","String to append to the name of every executable.",31,N],[12,"staticlib_prefix","","String to prepend to the name of every static library. Defaults to \"lib\".",31,N],[12,"staticlib_suffix","","String to append to the name of every static library. Defaults to \".a\".",31,N],[12,"target_family","","OS family to use for conditional compilation. Valid options: \"unix\", \"windows\".",31,N],[12,"abi_return_struct_as_int","","Whether the target toolchain's ABI supports returning small structs as an integer.",31,N],[12,"is_like_osx","","Whether the target toolchain is like macOS's. Only useful for compiling against iOS/macOS, in particular running dsymutil and some other stuff like `-dead_strip`. Defaults to false.",31,N],[12,"is_like_solaris","","Whether the target toolchain is like Solaris's. Only useful for compiling against Illumos/Solaris, as they have a different set of linker flags. Defaults to false.",31,N],[12,"is_like_windows","","Whether the target toolchain is like Windows'. Only useful for compiling against Windows, only really used for figuring out how to find libraries, since Windows uses its own library naming convention. Defaults to false.",31,N],[12,"is_like_msvc","","",31,N],[12,"is_like_android","","Whether the target toolchain is like Android's. Only useful for compiling against Android. Defaults to false.",31,N],[12,"is_like_emscripten","","Whether the target toolchain is like Emscripten's. Only useful for compiling with Emscripten toolchain. Defaults to false.",31,N],[12,"linker_is_gnu","","Whether the linker support GNU-like arguments such as -O. Defaults to false.",31,N],[12,"allows_weak_linkage","","The MinGW toolchain has a known issue that prevents it from correctly handling COFF object files with more than 215 sections. Since each weak symbol needs its own COMDAT section, weak linkage implies a large number sections that easily exceeds the given limit for larger codebases. Consequently we want a way to disallow weak linkage on some platforms.",31,N],[12,"has_rpath","","Whether the linker support rpaths or not. Defaults to false.",31,N],[12,"no_default_libraries","","Whether to disable linking to the default libraries, typically corresponds to `-nodefaultlibs`. Defaults to true.",31,N],[12,"position_independent_executables","","Dynamically linked executables can be compiled as position independent if the default relocation model of position independent code is not changed. This is a requirement to take advantage of ASLR, as otherwise the functions in the executable are not randomized and can be used during an exploit of a vulnerability in any code.",31,N],[12,"relro_level","","Either partial, full, or off. Full RELRO makes the dynamic linker resolve all symbols at startup and marks the GOT read-only before starting the program, preventing overwriting the GOT.",31,N],[12,"archive_format","","Format that archives should be emitted in. This affects whether we use LLVM to assemble an archive or fall back to the system linker, and currently only \"gnu\" is used to fall into LLVM. Unknown strings cause the system linker to be used.",31,N],[12,"allow_asm","","Is asm!() allowed? Defaults to true.",31,N],[12,"custom_unwind_resume","","Whether the target uses a custom unwind resumption routine. By default LLVM lowers `resume` instructions into calls to `_Unwind_Resume` defined in libgcc.  If this option is enabled, the target must provide `eh_unwind_resume` lang item.",31,N],[12,"exe_allocation_crate","","If necessary, a different crate to link exe allocators by default",31,N],[12,"has_elf_tls","","Flag indicating whether ELF TLS (e.g. #[thread_local]) is available for this target.",31,N],[12,"obj_is_bitcode","","",31,N],[12,"no_integrated_as","","",31,N],[12,"min_atomic_width","","Don't use this field; instead use the `.min_atomic_width()` method.",31,N],[12,"max_atomic_width","","Don't use this field; instead use the `.max_atomic_width()` method.",31,N],[12,"atomic_cas","","Whether the target supports atomic CAS operations natively",31,N],[12,"panic_strategy","","Panic strategy: \"unwind\" or \"abort\"",31,N],[12,"abi_blacklist","","A blacklist of ABIs unsupported by the current target. Note that generic ABIs are considered to be supported on all platforms and cannot be blacklisted.",31,N],[12,"crt_static_allows_dylibs","","Whether or not linking dylibs to a static CRT is allowed.",31,N],[12,"crt_static_default","","Whether or not the CRT is statically linked by default.",31,N],[12,"crt_static_respected","","Whether or not crt-static is respected by the compiler (or is a no-op).",31,N],[12,"stack_probes","","Whether or not stack probes (__rust_probestack) are enabled",31,N],[12,"min_global_align","","The minimum alignment for global symbols.",31,N],[12,"default_codegen_units","","Default number of codegen units to use in debug mode",31,N],[12,"trap_unreachable","","Whether to generate trap instructions in places where optimization would otherwise produce control flow that falls through into unrelated memory.",31,N],[12,"requires_lto","","This target requires everything to be compiled with LTO to emit a final executable, aka there is no native linker for this target.",31,N],[12,"singlethread","","This target has no support for threads.",31,N],[12,"no_builtins","","Whether library functions call lowering/optimization is disabled in LLVM for this target unconditionally.",31,N],[12,"i128_lowering","","Whether to lower 128-bit operations to compiler_builtins calls.  Use if your backend only supports 64-bit and smaller math.",31,N],[12,"codegen_backend","","The codegen backend to use for this target, typically \"llvm\"",31,N],[12,"default_hidden_visibility","","The default visibility for symbols in this target should be \"hidden\" rather than \"default\"",31,N],[12,"embed_bitcode","","Whether or not bitcode is embedded in object files",31,N],[12,"emit_debug_gdb_scripts","","Whether a .debug_gdb_scripts section will be added to the output object file",31,N],[12,"requires_uwtable","","Whether or not to unconditionally `uwtable` attributes on functions, typically because the platform needs to unwind for things like stack unwinders.",31,N],[4,"LinkerFlavor","","",N,N],[13,"Em","","",32,N],[13,"Gcc","","",32,N],[13,"Ld","","",32,N],[13,"Msvc","","",32,N],[13,"Lld","","",32,N],[4,"LldFlavor","","",N,N],[13,"Wasm","","",33,N],[13,"Ld64","","",33,N],[13,"Ld","","",33,N],[13,"Link","","",33,N],[4,"PanicStrategy","","",N,N],[13,"Unwind","","",34,N],[13,"Abort","","",34,N],[4,"RelroLevel","","",N,N],[13,"Full","","",35,N],[13,"Partial","","",35,N],[13,"Off","","",35,N],[13,"None","","",35,N],[4,"TargetTriple","","Either a target triple string or a path to a JSON file.",N,N],[13,"TargetTriple","","",36,N],[13,"TargetPath","","",36,N],[5,"load_specific","","",N,[[["str"]],["targetresult"]]],[5,"get_targets","","",N,[[],["box",["iterator"]]]],[5,"maybe_jemalloc","","",N,[[],["option",["string"]]]],[0,"abi","","",N,N],[3,"AbiData","rustc_target::spec::abi","",N,N],[12,"abi","","",37,N],[12,"name","","Name of this ABI as we like it called.",37,N],[12,"generic","","A generic ABI is supported on all platforms.",37,N],[4,"Abi","","",N,N],[13,"Cdecl","","",38,N],[13,"Stdcall","","",38,N],[13,"Fastcall","","",38,N],[13,"Vectorcall","","",38,N],[13,"Thiscall","","",38,N],[13,"Aapcs","","",38,N],[13,"Win64","","",38,N],[13,"SysV64","","",38,N],[13,"PtxKernel","","",38,N],[13,"Msp430Interrupt","","",38,N],[13,"X86Interrupt","","",38,N],[13,"AmdGpuKernel","","",38,N],[13,"Rust","","",38,N],[13,"C","","",38,N],[13,"System","","",38,N],[13,"RustIntrinsic","","",38,N],[13,"RustCall","","",38,N],[13,"PlatformIntrinsic","","",38,N],[13,"Unadjusted","","",38,N],[5,"lookup","","Returns the ABI with the given name (if any).",N,[[["str"]],["option",["abi"]]]],[5,"all_names","","",N,[[],["vec",["str"]]]],[17,"AbiDatas","","",N,N],[11,"eq","","",38,[[["self"],["abi"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",38,N],[11,"partial_cmp","","",38,[[["self"],["abi"]],["option",["ordering"]]]],[11,"cmp","","",38,[[["self"],["abi"]],["ordering"]]],[11,"hash","","",38,N],[11,"encode","","",38,[[["self"],["__s"]],["result"]]],[11,"decode","","",38,[[["__d"]],["result",["abi"]]]],[11,"clone","","",38,[[["self"]],["abi"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"clone","","",37,[[["self"]],["abidata"]]],[11,"index","","",38,[[["self"]],["usize"]]],[11,"data","","",38,[[["self"]],["abidata"]]],[11,"name","","",38,[[["self"]],["str"]]],[11,"generic","","",38,[[["self"]],["bool"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[0,"android_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::android_base","",N,[[],["targetoptions"]]],[0,"apple_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::apple_base","",N,[[],["targetoptions"]]],[0,"apple_ios_base","rustc_target::spec","",N,N],[4,"Arch","rustc_target::spec::apple_ios_base","",N,N],[13,"Armv7","","",39,N],[13,"Armv7s","","",39,N],[13,"Arm64","","",39,N],[13,"I386","","",39,N],[13,"X86_64","","",39,N],[5,"get_sdk_root","","",N,[[["str"]],["result",["string","string"]]]],[5,"build_pre_link_args","","",N,[[["arch"]],["result",["linkargs","string"]]]],[5,"target_cpu","","",N,[[["arch"]],["string"]]],[5,"opts","","",N,[[["arch"]],["result",["targetoptions","string"]]]],[11,"clone","","",39,[[["self"]],["arch"]]],[11,"to_string","","",39,[[["self"]],["str"]]],[0,"arm_base","rustc_target::spec","",N,N],[5,"abi_blacklist","rustc_target::spec::arm_base","",N,[[],["vec",["abi"]]]],[0,"bitrig_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::bitrig_base","",N,[[],["targetoptions"]]],[0,"cloudabi_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::cloudabi_base","",N,[[],["targetoptions"]]],[0,"dragonfly_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::dragonfly_base","",N,[[],["targetoptions"]]],[0,"freebsd_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::freebsd_base","",N,[[],["targetoptions"]]],[0,"haiku_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::haiku_base","",N,[[],["targetoptions"]]],[0,"hermit_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::hermit_base","",N,[[],["targetoptions"]]],[0,"linux_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::linux_base","",N,[[],["targetoptions"]]],[0,"linux_musl_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::linux_musl_base","",N,[[],["targetoptions"]]],[0,"openbsd_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::openbsd_base","",N,[[],["targetoptions"]]],[0,"netbsd_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::netbsd_base","",N,[[],["targetoptions"]]],[0,"solaris_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::solaris_base","",N,[[],["targetoptions"]]],[0,"windows_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::windows_base","",N,[[],["targetoptions"]]],[0,"windows_msvc_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::windows_msvc_base","",N,[[],["targetoptions"]]],[0,"thumb_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::thumb_base","",N,[[],["targetoptions"]]],[0,"l4re_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::l4re_base","",N,[[],["targetoptions"]]],[0,"fuchsia_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::fuchsia_base","",N,[[],["targetoptions"]]],[0,"redox_base","rustc_target::spec","",N,N],[5,"opts","rustc_target::spec::redox_base","",N,[[],["targetoptions"]]],[0,"riscv_base","rustc_target::spec","",N,N],[5,"abi_blacklist","rustc_target::spec::riscv_base","",N,[[],["vec",["abi"]]]],[0,"x86_64_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"x86_64_unknown_linux_gnux32","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_linux_gnux32","",N,[[],["targetresult"]]],[0,"i686_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"i586_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i586_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"mips_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mips_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"mips64_unknown_linux_gnuabi64","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mips64_unknown_linux_gnuabi64","",N,[[],["targetresult"]]],[0,"mips64el_unknown_linux_gnuabi64","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mips64el_unknown_linux_gnuabi64","",N,[[],["targetresult"]]],[0,"mipsel_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mipsel_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"powerpc_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"powerpc_unknown_linux_gnuspe","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc_unknown_linux_gnuspe","",N,[[],["targetresult"]]],[0,"powerpc64_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc64_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"powerpc64le_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc64le_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"powerpc64le_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc64le_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"s390x_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::s390x_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"sparc_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::sparc_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"sparc64_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::sparc64_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"arm_unknown_linux_gnueabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::arm_unknown_linux_gnueabi","",N,[[],["targetresult"]]],[0,"arm_unknown_linux_gnueabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::arm_unknown_linux_gnueabihf","",N,[[],["targetresult"]]],[0,"arm_unknown_linux_musleabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::arm_unknown_linux_musleabi","",N,[[],["targetresult"]]],[0,"arm_unknown_linux_musleabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::arm_unknown_linux_musleabihf","",N,[[],["targetresult"]]],[0,"armv4t_unknown_linux_gnueabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv4t_unknown_linux_gnueabi","",N,[[],["targetresult"]]],[0,"armv5te_unknown_linux_gnueabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv5te_unknown_linux_gnueabi","",N,[[],["targetresult"]]],[0,"armv5te_unknown_linux_musleabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv5te_unknown_linux_musleabi","",N,[[],["targetresult"]]],[0,"armv7_unknown_linux_gnueabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_unknown_linux_gnueabihf","",N,[[],["targetresult"]]],[0,"armv7_unknown_linux_musleabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_unknown_linux_musleabihf","",N,[[],["targetresult"]]],[0,"aarch64_unknown_linux_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_linux_gnu","",N,[[],["targetresult"]]],[0,"aarch64_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"x86_64_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"i686_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"i586_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i586_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"mips_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mips_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"mipsel_unknown_linux_musl","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mipsel_unknown_linux_musl","",N,[[],["targetresult"]]],[0,"mips_unknown_linux_uclibc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mips_unknown_linux_uclibc","",N,[[],["targetresult"]]],[0,"mipsel_unknown_linux_uclibc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::mipsel_unknown_linux_uclibc","",N,[[],["targetresult"]]],[0,"i686_linux_android","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_linux_android","",N,[[],["targetresult"]]],[0,"x86_64_linux_android","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_linux_android","",N,[[],["targetresult"]]],[0,"arm_linux_androideabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::arm_linux_androideabi","",N,[[],["targetresult"]]],[0,"armv7_linux_androideabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_linux_androideabi","",N,[[],["targetresult"]]],[0,"aarch64_linux_android","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_linux_android","",N,[[],["targetresult"]]],[0,"aarch64_unknown_freebsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_freebsd","",N,[[],["targetresult"]]],[0,"i686_unknown_freebsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_freebsd","",N,[[],["targetresult"]]],[0,"x86_64_unknown_freebsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_freebsd","",N,[[],["targetresult"]]],[0,"i686_unknown_dragonfly","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_dragonfly","",N,[[],["targetresult"]]],[0,"x86_64_unknown_dragonfly","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_dragonfly","",N,[[],["targetresult"]]],[0,"x86_64_unknown_bitrig","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_bitrig","",N,[[],["targetresult"]]],[0,"aarch64_unknown_openbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_openbsd","",N,[[],["targetresult"]]],[0,"i686_unknown_openbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_openbsd","",N,[[],["targetresult"]]],[0,"x86_64_unknown_openbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_openbsd","",N,[[],["targetresult"]]],[0,"aarch64_unknown_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_netbsd","",N,[[],["targetresult"]]],[0,"armv6_unknown_netbsd_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv6_unknown_netbsd_eabihf","",N,[[],["targetresult"]]],[0,"armv7_unknown_netbsd_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_unknown_netbsd_eabihf","",N,[[],["targetresult"]]],[0,"i686_unknown_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_netbsd","",N,[[],["targetresult"]]],[0,"powerpc_unknown_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::powerpc_unknown_netbsd","",N,[[],["targetresult"]]],[0,"sparc64_unknown_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::sparc64_unknown_netbsd","",N,[[],["targetresult"]]],[0,"x86_64_unknown_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_netbsd","",N,[[],["targetresult"]]],[0,"x86_64_rumprun_netbsd","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_rumprun_netbsd","",N,[[],["targetresult"]]],[0,"i686_unknown_haiku","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_haiku","",N,[[],["targetresult"]]],[0,"x86_64_unknown_haiku","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_haiku","",N,[[],["targetresult"]]],[0,"x86_64_apple_darwin","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_apple_darwin","",N,[[],["targetresult"]]],[0,"i686_apple_darwin","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_apple_darwin","",N,[[],["targetresult"]]],[0,"aarch64_fuchsia","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_fuchsia","",N,[[],["targetresult"]]],[0,"x86_64_fuchsia","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_fuchsia","",N,[[],["targetresult"]]],[0,"x86_64_unknown_l4re_uclibc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_l4re_uclibc","",N,[[],["targetresult"]]],[0,"x86_64_unknown_redox","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_redox","",N,[[],["targetresult"]]],[0,"i386_apple_ios","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i386_apple_ios","",N,[[],["targetresult"]]],[0,"x86_64_apple_ios","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_apple_ios","",N,[[],["targetresult"]]],[0,"aarch64_apple_ios","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_apple_ios","",N,[[],["targetresult"]]],[0,"armv7_apple_ios","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_apple_ios","",N,[[],["targetresult"]]],[0,"armv7s_apple_ios","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7s_apple_ios","",N,[[],["targetresult"]]],[0,"armebv7r_none_eabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armebv7r_none_eabi","",N,[[],["targetresult"]]],[0,"armebv7r_none_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armebv7r_none_eabihf","",N,[[],["targetresult"]]],[0,"armv7r_none_eabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7r_none_eabi","",N,[[],["targetresult"]]],[0,"armv7r_none_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7r_none_eabihf","",N,[[],["targetresult"]]],[0,"x86_64_sun_solaris","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_sun_solaris","",N,[[],["targetresult"]]],[0,"sparcv9_sun_solaris","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::sparcv9_sun_solaris","",N,[[],["targetresult"]]],[0,"x86_64_pc_windows_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_pc_windows_gnu","",N,[[],["targetresult"]]],[0,"i686_pc_windows_gnu","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_pc_windows_gnu","",N,[[],["targetresult"]]],[0,"aarch64_pc_windows_msvc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_pc_windows_msvc","",N,[[],["targetresult"]]],[0,"x86_64_pc_windows_msvc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_pc_windows_msvc","",N,[[],["targetresult"]]],[0,"i686_pc_windows_msvc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_pc_windows_msvc","",N,[[],["targetresult"]]],[0,"i586_pc_windows_msvc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i586_pc_windows_msvc","",N,[[],["targetresult"]]],[0,"thumbv7a_pc_windows_msvc","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::thumbv7a_pc_windows_msvc","",N,[[],["targetresult"]]],[0,"asmjs_unknown_emscripten","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::asmjs_unknown_emscripten","",N,[[],["result",["target","string"]]]],[0,"wasm32_unknown_emscripten","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::wasm32_unknown_emscripten","",N,[[],["result",["target","string"]]]],[0,"wasm32_unknown_unknown","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::wasm32_unknown_unknown","",N,[[],["result",["target","string"]]]],[0,"wasm32_experimental_emscripten","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::wasm32_experimental_emscripten","",N,[[],["result",["target","string"]]]],[0,"thumbv6m_none_eabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::thumbv6m_none_eabi","",N,[[],["targetresult"]]],[0,"thumbv7m_none_eabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::thumbv7m_none_eabi","",N,[[],["targetresult"]]],[0,"thumbv7em_none_eabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::thumbv7em_none_eabi","",N,[[],["targetresult"]]],[0,"thumbv7em_none_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::thumbv7em_none_eabihf","",N,[[],["targetresult"]]],[0,"msp430_none_elf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::msp430_none_elf","",N,[[],["targetresult"]]],[0,"aarch64_unknown_cloudabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_cloudabi","",N,[[],["targetresult"]]],[0,"armv7_unknown_cloudabi_eabihf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::armv7_unknown_cloudabi_eabihf","",N,[[],["targetresult"]]],[0,"i686_unknown_cloudabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::i686_unknown_cloudabi","",N,[[],["targetresult"]]],[0,"x86_64_unknown_cloudabi","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_cloudabi","",N,[[],["targetresult"]]],[0,"aarch64_unknown_hermit","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_hermit","",N,[[],["targetresult"]]],[0,"x86_64_unknown_hermit","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::x86_64_unknown_hermit","",N,[[],["targetresult"]]],[0,"riscv32imc_unknown_none_elf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::riscv32imc_unknown_none_elf","",N,[[],["targetresult"]]],[0,"riscv32imac_unknown_none_elf","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::riscv32imac_unknown_none_elf","",N,[[],["targetresult"]]],[0,"aarch64_unknown_none","rustc_target::spec","",N,N],[5,"target","rustc_target::spec::aarch64_unknown_none","",N,[[],["result",["target","string"]]]],[6,"LinkArgs","rustc_target::spec","",N,N],[6,"TargetResult","","",N,N],[17,"TARGETS","","List of supported targets",N,N],[8,"HasTargetSpec","","",N,N],[10,"target_spec","","",40,[[["self"]],["target"]]],[11,"clone","","",32,[[["self"]],["linkerflavor"]]],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",32,N],[11,"cmp","","",32,[[["self"],["linkerflavor"]],["ordering"]]],[11,"eq","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"ne","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"partial_cmp","","",32,[[["self"],["linkerflavor"]],["option",["ordering"]]]],[11,"lt","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"le","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"gt","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"ge","","",32,[[["self"],["linkerflavor"]],["bool"]]],[11,"hash","","",32,N],[11,"encode","","",32,[[["self"],["__s"]],["result"]]],[11,"decode","","",32,[[["__d"]],["result",["linkerflavor"]]]],[11,"clone","","",33,[[["self"]],["lldflavor"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",33,N],[11,"cmp","","",33,[[["self"],["lldflavor"]],["ordering"]]],[11,"eq","","",33,[[["self"],["lldflavor"]],["bool"]]],[11,"partial_cmp","","",33,[[["self"],["lldflavor"]],["option",["ordering"]]]],[11,"hash","","",33,N],[11,"encode","","",33,[[["self"],["__s"]],["result"]]],[11,"decode","","",33,[[["__d"]],["result",["lldflavor"]]]],[11,"from_str","","",33,[[["str"]],["option"]]],[11,"to_json","","",33,[[["self"]],["json"]]],[11,"to_json","","",32,[[["self"]],["json"]]],[11,"one_of","","",32,[[],["str"]]],[11,"from_str","","",32,[[["str"]],["option"]]],[11,"desc","","",32,[[["self"]],["str"]]],[11,"clone","","",34,[[["self"]],["panicstrategy"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"eq","","",34,[[["self"],["panicstrategy"]],["bool"]]],[11,"hash","","",34,N],[11,"encode","","",34,[[["self"],["__s"]],["result"]]],[11,"decode","","",34,[[["__d"]],["result",["panicstrategy"]]]],[11,"desc","","",34,[[["self"]],["str"]]],[11,"to_json","","",34,[[["self"]],["json"]]],[11,"clone","","",35,[[["self"]],["relrolevel"]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"eq","","",35,[[["self"],["relrolevel"]],["bool"]]],[11,"hash","","",35,N],[11,"encode","","",35,[[["self"],["__s"]],["result"]]],[11,"decode","","",35,[[["__d"]],["result",["relrolevel"]]]],[11,"desc","","",35,[[["self"]],["str"]]],[11,"from_str","","",35,[[["str"]],["result",["relrolevel"]]]],[11,"to_json","","",35,[[["self"]],["json"]]],[11,"eq","","",30,[[["self"],["target"]],["bool"]]],[11,"ne","","",30,[[["self"],["target"]],["bool"]]],[11,"clone","","",30,[[["self"]],["target"]]],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"eq","","",31,[[["self"],["targetoptions"]],["bool"]]],[11,"ne","","",31,[[["self"],["targetoptions"]],["bool"]]],[11,"clone","","",31,[[["self"]],["targetoptions"]]],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"default","","Create a set of \"sane defaults\" for any target. This is still incomplete, and if used for compilation, will certainly not work.",31,[[],["targetoptions"]]],[11,"adjust_abi","","Given a function ABI, turn \"System\" into the correct ABI for this target.",30,[[["self"],["abi"]],["abi"]]],[11,"min_atomic_width","","Minimum integer size in bits that this target can perform atomic operations on.",30,[[["self"]],["u64"]]],[11,"max_atomic_width","","Maximum integer size in bits that this target can perform atomic operations on.",30,[[["self"]],["u64"]]],[11,"is_abi_supported","","",30,[[["self"],["abi"]],["bool"]]],[11,"from_json","","Load a target descriptor from a JSON object.",30,[[["json"]],["targetresult"]]],[11,"search","","Search RUST_TARGET_PATH for a JSON file specifying the given target triple. Note that it could also just be a bare filename already, so also check for that. If one of the hardcoded targets we know about, just return it directly.",30,[[["targettriple"]],["result",["target","string"]]]],[11,"to_json","","",30,[[["self"]],["json"]]],[11,"eq","","",36,[[["self"],["targettriple"]],["bool"]]],[11,"ne","","",36,[[["self"],["targettriple"]],["bool"]]],[11,"clone","","",36,[[["self"]],["targettriple"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"hash","","",36,N],[11,"encode","","",36,[[["self"],["__s"]],["result"]]],[11,"decode","","",36,[[["__d"]],["result",["targettriple"]]]],[11,"from_triple","","Creates a target triple from the passed target triple string.",36,[[["str"]],["self"]]],[11,"from_path","","Creates a target triple from the passed target path.",36,[[["path"]],["result",["error"]]]],[11,"triple","","Returns a string triple for this target.",36,[[["self"]],["str"]]],[11,"debug_triple","","Returns an extended string triple for this target.",36,[[["self"]],["string"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"from","rustc_target::abi","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"encode","","",1,[[["self"],["e"]],["result"]]],[11,"decode","","",1,[[["d"]],["result"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"encode","","",2,[[["self"],["e"]],["result"]]],[11,"decode","","",2,[[["d"]],["result"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"to_string","","",8,[[["self"]],["string"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"encode","","",8,[[["self"],["e"]],["result"]]],[11,"decode","","",8,[[["d"]],["result"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"to_owned","","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_target::abi::call","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"to_owned","","",14,[[["self"]],["t"]]],[11,"clone_into","","",14,N],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"to_owned","","",15,[[["self"]],["t"]]],[11,"clone_into","","",15,N],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"to_owned","","",16,[[["self"]],["t"]]],[11,"clone_into","","",16,N],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"to_owned","","",17,[[["self"]],["t"]]],[11,"clone_into","","",17,N],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"to_owned","","",22,[[["self"]],["t"]]],[11,"clone_into","","",22,N],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_target::abi::call::powerpc64","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from","rustc_target::abi::call::x86","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_target::abi::call::x86_64","",26,[[["self"]],["t"]]],[11,"clone_into","","",26,N],[11,"from","","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"to_owned","","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_target::spec","",30,[[["self"]],["t"]]],[11,"clone_into","","",30,N],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"to_owned","","",31,[[["self"]],["t"]]],[11,"clone_into","","",31,N],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"to_owned","","",32,[[["self"]],["t"]]],[11,"clone_into","","",32,N],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"encode","","",32,[[["self"],["e"]],["result"]]],[11,"decode","","",32,[[["d"]],["result"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"to_owned","","",33,[[["self"]],["t"]]],[11,"clone_into","","",33,N],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"encode","","",33,[[["self"],["e"]],["result"]]],[11,"decode","","",33,[[["d"]],["result"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"to_owned","","",34,[[["self"]],["t"]]],[11,"clone_into","","",34,N],[11,"from","","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"encode","","",34,[[["self"],["e"]],["result"]]],[11,"decode","","",34,[[["d"]],["result"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"to_owned","","",35,[[["self"]],["t"]]],[11,"clone_into","","",35,N],[11,"from","","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"encode","","",35,[[["self"],["e"]],["result"]]],[11,"decode","","",35,[[["d"]],["result"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"to_owned","","",36,[[["self"]],["t"]]],[11,"clone_into","","",36,N],[11,"from","","",36,[[["t"]],["t"]]],[11,"to_string","","",36,[[["self"]],["string"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"encode","","",36,[[["self"],["e"]],["result"]]],[11,"decode","","",36,[[["d"]],["result"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_target::spec::abi","",37,[[["self"]],["t"]]],[11,"clone_into","","",37,N],[11,"from","","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"to_owned","","",38,[[["self"]],["t"]]],[11,"clone_into","","",38,N],[11,"from","","",38,[[["t"]],["t"]]],[11,"to_string","","",38,[[["self"]],["string"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"encode","","",38,[[["self"],["e"]],["result"]]],[11,"decode","","",38,[[["d"]],["result"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"to_owned","rustc_target::spec::apple_ios_base","",39,[[["self"]],["t"]]],[11,"clone_into","","",39,N],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]]],"paths":[[3,"TargetDataLayout"],[3,"Size"],[3,"Align"],[3,"Scalar"],[3,"LayoutDetails"],[3,"TyLayout"],[4,"Endian"],[4,"Integer"],[4,"FloatTy"],[4,"Primitive"],[4,"FieldPlacement"],[4,"Abi"],[4,"Variants"],[3,"ArgAttribute"],[3,"ArgAttributes"],[3,"Reg"],[3,"Uniform"],[3,"CastTarget"],[3,"ArgType"],[3,"FnType"],[4,"PassMode"],[4,"RegKind"],[4,"Conv"],[4,"ABI"],[4,"Flavor"],[4,"Class"],[3,"Memory"],[8,"HasDataLayout"],[8,"LayoutOf"],[8,"TyLayoutMethods"],[3,"Target"],[3,"TargetOptions"],[4,"LinkerFlavor"],[4,"LldFlavor"],[4,"PanicStrategy"],[4,"RelroLevel"],[4,"TargetTriple"],[3,"AbiData"],[4,"Abi"],[4,"Arch"],[8,"HasTargetSpec"]]};
searchIndex["rustc_traits"]={"doc":"New recursive solver modeled on Chalk's recursive solver. Most of the guts are broken up into modules; see the comments in those modules.","items":[[5,"provide","rustc_traits","",N,[[["providers"]]]],[0,"chalk_context","","",N,N],[3,"ChalkArenas","rustc_traits::chalk_context","",N,N],[12,"_phantom","","",0,N],[3,"ChalkContext","","",N,N],[12,"_arenas","","",1,N],[12,"_tcx","","",1,N],[3,"ChalkInferenceContext","","",N,N],[12,"infcx","","",2,N],[3,"UniverseMap","","",N,N],[3,"ConstrainedSubst","","",N,N],[12,"subst","","",3,N],[12,"constraints","","",3,N],[6,"ChalkHhGoal","","",N,N],[6,"ChalkExClause","","",N,N],[11,"clone","","",0,[[["self"]],["chalkarenas"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"clone","","",1,[[["self"]],["chalkcontext"]]],[11,"clone","","",2,[[["self"]],["chalkinferencecontext"]]],[11,"clone","","",4,[[["self"]],["universemap"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",3,[[["self"]],["constrainedsubst"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"eq","","",3,[[["self"],["constrainedsubst"]],["bool"]]],[11,"ne","","",3,[[["self"],["constrainedsubst"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"hash","","",3,N],[11,"super_fold_with","","",3,[[["self"],["v"]],["self"]]],[11,"super_visit_with","","",3,[[["self"],["v"]],["bool"]]],[11,"into_goal","","",0,[[["domaingoal"]],["goal"]]],[11,"cannot_prove","","",0,[[],["goal"]]],[11,"goal_in_environment","","",0,[[["paramenv"],["goal"]],["paramenvand",["goal"]]]],[11,"make_solution","","",1,N],[11,"is_coinductive","","True if this is a coinductive goal -- e.g., proving an auto trait.",1,[[["self"],["canonical"]],["bool"]]],[11,"instantiate_ucanonical_goal","","Create an inference table for processing a new goal and instantiate that goal in that context, returning \"all the pieces\".",1,N],[11,"instantiate_ex_clause","","",1,N],[11,"empty_constraints","","True if this solution has no region constraints.",1,[[["canonical"]],["bool"]]],[11,"inference_normalized_subst_from_ex_clause","","",1,[[["canonical"]],["canonicalvarvalues"]]],[11,"inference_normalized_subst_from_subst","","",1,[[["canonical"]],["canonicalvarvalues"]]],[11,"canonical","","",1,[[["canonical"]],["canonical"]]],[11,"is_trivial_substitution","","",1,[[["canonical"],["canonical"]],["bool"]]],[11,"num_universes","","",1,[[["canonical"]],["usize"]]],[11,"map_goal_from_canonical","","Convert a goal G from the canonical universes into our local universes. This will yield a goal G' that is the same but for the universes of universally quantified names.",1,[[["universemap"],["canonical"]],["canonical",["paramenvand"]]]],[11,"map_subst_from_canonical","","",1,[[["universemap"],["canonical"]],["canonical",["constrainedsubst"]]]],[11,"into_hh_goal","","",2,[[["self"],["goal"]],["hhgoal",["chalkarenas"]]]],[11,"add_clauses","","",2,[[["self"],["paramenv"],["vec",["programclause"]]],["paramenv"]]],[11,"resolvent_clause","","",2,[[["self"],["paramenv"],["domaingoal"],["canonicalvarvalues"],["programclause"]],["fallible",["canonical"]]]],[11,"apply_answer_subst","","",2,[[["self"],["exclause",["chalkarenas"]],["paramenvand"],["canonical"],["canonical"]],["fallible",["exclause"]]]],[11,"truncate_goal","","",2,[[["self"],["paramenvand"]],["option",["paramenvand"]]]],[11,"truncate_answer","","",2,[[["self"],["canonicalvarvalues"]],["option",["canonicalvarvalues"]]]],[11,"program_clauses","","",2,[[["self"],["paramenv"],["domaingoal"]],["vec",["programclause"]]]],[11,"instantiate_binders_universally","","",2,[[["self"],["binder"]],["goal"]]],[11,"instantiate_binders_existentially","","",2,[[["self"],["binder"]],["goal"]]],[11,"debug_ex_clause","","",2,[[["self"],["exclause"]],["box",["debug"]]]],[11,"canonicalize_goal","","",2,[[["self"],["paramenvand"]],["canonical",["paramenvand"]]]],[11,"canonicalize_ex_clause","","",2,[[["self"],["exclause"]],["canonical",["exclause"]]]],[11,"canonicalize_constrained_subst","","",2,[[["self"],["canonicalvarvalues"],["vec",["queryregionconstraint"]]],["canonical",["constrainedsubst"]]]],[11,"u_canonicalize_goal","","",2,N],[11,"invert_goal","","",2,[[["self"],["paramenvand"]],["option",["paramenvand"]]]],[11,"unify_parameters","","",2,[[["self"],["paramenv"],["kind"],["kind"]],["chalkenginefallible",["inferok"]]]],[11,"sink_answer_subset","","",2,[[["self"],["canonical"]],["canonical",["constrainedsubst"]]]],[11,"lift_delayed_literal","","",2,[[["self"],["delayedliteral",["chalkarenas"]]],["delayedliteral",["chalkarenas"]]]],[11,"into_ex_clause","","",2,[[["self"],["inferok"],["exclause"]]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"lift_ex_clause_to_tcx","","",0,[[["exclause"],["tyctxt"]],["option"]]],[11,"fold_ex_clause_with","","",0,[[["exclause"],["f"]],["exclause",["chalkarenas"]]]],[11,"visit_ex_clause_with","","",0,[[["exclause"],["v"]],["bool"]]],[11,"lift_to_tcx","","",3,[[["self"],["tyctxt"]],["option",["constrainedsubst"]]]],[0,"dropck_outlives","rustc_traits","",N,N],[5,"provide","rustc_traits::dropck_outlives","",N,[[["providers"]]]],[5,"dropck_outlives","","",N,[[["tyctxt"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[5,"dtorck_constraint_for_ty","","Return a set of constraints that needs to be satisfied in order for `ty` to be valid for destruction.",N,[[["tyctxt"],["span"],["ty"],["usize"],["ty"]],["result",["dtorckconstraint","nosolution"]]]],[5,"adt_dtorck_constraint","","Calculates the dtorck constraint for a type.",N,[[["tyctxt"],["defid"]],["result",["dtorckconstraint","nosolution"]]]],[5,"dedup_dtorck_constraint","","",N,[[["dtorckconstraint"]]]],[0,"evaluate_obligation","rustc_traits","",N,N],[5,"provide","rustc_traits::evaluate_obligation","",N,[[["providers"]]]],[5,"evaluate_obligation","","",N,[[["tyctxt"],["canonicalpredicategoal"]],["result",["evaluationresult","overflowerror"]]]],[0,"implied_outlives_bounds","rustc_traits","Provider for the `implied_outlives_bounds` query. Do not call this query directory. See [`rustc::traits::query::implied_outlives_bounds`].",N,N],[5,"provide","rustc_traits::implied_outlives_bounds","",N,[[["providers"]]]],[5,"implied_outlives_bounds","","",N,[[["tyctxt"],["canonicaltygoal"]],["result",["lrc","nosolution"]]]],[5,"compute_implied_outlives_bounds","","",N,[[["inferctxt"],["paramenv"],["ty"]],["fallible",["vec"]]]],[5,"implied_bounds_from_components","","When we have an implied bound that `T: 'a`, we can further break this down to determine what relationships would have to hold for `T: 'a` to hold. We get to assume that the caller has validated those relationships.",N,[[["region"],["vec",["component"]]],["vec",["outlivesbound"]]]],[0,"normalize_projection_ty","rustc_traits","",N,N],[5,"provide","rustc_traits::normalize_projection_ty","",N,[[["providers"]]]],[5,"normalize_projection_ty","","",N,[[["tyctxt"],["canonicalprojectiongoal"]],["result",["lrc","nosolution"]]]],[0,"normalize_erasing_regions","rustc_traits","",N,N],[5,"provide","rustc_traits::normalize_erasing_regions","",N,[[["providers"]]]],[5,"normalize_ty_after_erasing_regions","","",N,[[["tyctxt"],["paramenvand",["ty"]]],["ty"]]],[5,"not_outlives_predicate","","",N,[[["predicate"]],["bool"]]],[0,"lowering","rustc_traits","",N,N],[3,"ClauseDumper","rustc_traits::lowering","",N,N],[12,"tcx","","",5,N],[5,"provide","","",N,[[["providers"]]]],[5,"program_clauses_for","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"program_clauses_for_env","","",N,[[["tyctxt"],["paramenv"]],["clauses"]]],[5,"program_clauses_for_trait","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"program_clauses_for_impl","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"program_clauses_for_type_def","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"program_clauses_for_associated_type_def","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"program_clauses_for_associated_type_value","","",N,[[["tyctxt"],["defid"]],["clauses"]]],[5,"dump_program_clauses","","",N,[[["tyctxt"]]]],[8,"Lower","","",N,N],[10,"lower","","Lower a rustc construct (e.g. `ty::TraitPredicate`) to a chalk-like type.",6,[[["self"]],["t"]]],[8,"IntoFromEnvGoal","","Used for implied bounds related rules (see rustc guide).",N,N],[10,"into_from_env_goal","","Transforms an existing goal into a `FromEnv` goal.",7,[[["self"]],["self"]]],[8,"IntoWellFormedGoal","","Used for well-formedness related rules (see rustc guide).",N,N],[10,"into_well_formed_goal","","Transforms an existing goal into a `WellFormed` goal.",8,[[["self"]],["self"]]],[11,"process_attrs","","",5,N],[11,"nested_visit_map","","",5,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",5,[[["self"],["item"]]]],[11,"visit_trait_item","","",5,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",5,[[["self"],["implitem"]]]],[11,"visit_struct_field","","",5,[[["self"],["structfield"]]]],[0,"type_op","rustc_traits","",N,N],[5,"provide","rustc_traits::type_op","",N,[[["providers"]]]],[5,"type_op_eq","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_normalize","","",N,[[["inferctxt"],["fulfillmentcontext"],["paramenvand",["normalize"]]],["fallible"]]],[5,"type_op_normalize_ty","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_normalize_predicate","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_normalize_fn_sig","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_normalize_poly_fn_sig","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_subtype","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[5,"type_op_prove_predicate","","",N,[[["tyctxt"],["canonical",["paramenvand"]]],["result",["lrc","nosolution"]]]],[11,"to_owned","rustc_traits::chalk_context","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"subst_spanned","","",3,N],[11,"from","rustc_traits::lowering","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]]],"paths":[[3,"ChalkArenas"],[3,"ChalkContext"],[3,"ChalkInferenceContext"],[3,"ConstrainedSubst"],[3,"UniverseMap"],[3,"ClauseDumper"],[8,"Lower"],[8,"IntoFromEnvGoal"],[8,"IntoWellFormedGoal"]]};
searchIndex["rustc_typeck"]={"doc":"typeck.rs, an introduction","items":[[3,"TypeAndSubsts","rustc_typeck","",N,N],[12,"substs","","",0,N],[12,"ty","","",0,N],[5,"require_c_abi_if_variadic","","",N,[[["tyctxt"],["fndecl"],["abi"],["span"]]]],[5,"require_same_types","","",N,[[["tyctxt"],["obligationcause"],["ty"],["ty"]],["bool"]]],[5,"check_main_fn_ty","","",N,[[["tyctxt"],["nodeid"],["span"]]]],[5,"check_start_fn_ty","","",N,[[["tyctxt"],["nodeid"],["span"]]]],[5,"check_for_entry_fn","","",N,[[["tyctxt"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"check_crate","","",N,[[["tyctxt"]],["result",["compileincomplete"]]]],[5,"hir_ty_to_ty","","A quasi-deprecated helper used in rustdoc and save-analysis to get the type from a HIR node.",N,[[["tyctxt"],["ty"]],["ty"]]],[5,"hir_trait_to_predicates","","",N,N],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0023","rustc_typeck::diagnostics","",N,N],[0,"__register_diagnostic_E0025","","",N,N],[0,"__register_diagnostic_E0026","","",N,N],[0,"__register_diagnostic_E0027","","",N,N],[0,"__register_diagnostic_E0029","","",N,N],[0,"__register_diagnostic_E0033","","",N,N],[0,"__register_diagnostic_E0034","","",N,N],[0,"__register_diagnostic_E0040","","",N,N],[0,"__register_diagnostic_E0044","","",N,N],[0,"__register_diagnostic_E0045","","",N,N],[0,"__register_diagnostic_E0046","","",N,N],[0,"__register_diagnostic_E0049","","",N,N],[0,"__register_diagnostic_E0050","","",N,N],[0,"__register_diagnostic_E0053","","",N,N],[0,"__register_diagnostic_E0054","","",N,N],[0,"__register_diagnostic_E0055","","",N,N],[0,"__register_diagnostic_E0057","","",N,N],[0,"__register_diagnostic_E0059","","",N,N],[0,"__register_diagnostic_E0060","","",N,N],[0,"__register_diagnostic_E0061","","",N,N],[0,"__register_diagnostic_E0062","","",N,N],[0,"__register_diagnostic_E0063","","",N,N],[0,"__register_diagnostic_E0067","","",N,N],[0,"__register_diagnostic_E0069","","",N,N],[0,"__register_diagnostic_E0070","","",N,N],[0,"__register_diagnostic_E0071","","",N,N],[0,"__register_diagnostic_E0073","","",N,N],[0,"__register_diagnostic_E0074","","",N,N],[0,"__register_diagnostic_E0075","","",N,N],[0,"__register_diagnostic_E0076","","",N,N],[0,"__register_diagnostic_E0077","","",N,N],[0,"__register_diagnostic_E0081","","",N,N],[0,"__register_diagnostic_E0084","","",N,N],[0,"__register_diagnostic_E0087","","",N,N],[0,"__register_diagnostic_E0088","","",N,N],[0,"__register_diagnostic_E0089","","",N,N],[0,"__register_diagnostic_E0090","","",N,N],[0,"__register_diagnostic_E0091","","",N,N],[0,"__register_diagnostic_E0092","","",N,N],[0,"__register_diagnostic_E0093","","",N,N],[0,"__register_diagnostic_E0094","","",N,N],[0,"__register_diagnostic_E0107","","",N,N],[0,"__register_diagnostic_E0109","","",N,N],[0,"__register_diagnostic_E0110","","",N,N],[0,"__register_diagnostic_E0116","","",N,N],[0,"__register_diagnostic_E0117","","",N,N],[0,"__register_diagnostic_E0118","","",N,N],[0,"__register_diagnostic_E0120","","",N,N],[0,"__register_diagnostic_E0121","","",N,N],[0,"__register_diagnostic_E0124","","",N,N],[0,"__register_diagnostic_E0131","","",N,N],[0,"__register_diagnostic_E0132","","",N,N],[0,"__register_diagnostic_E0164","","",N,N],[0,"__register_diagnostic_E0184","","",N,N],[0,"__register_diagnostic_E0185","","",N,N],[0,"__register_diagnostic_E0186","","",N,N],[0,"__register_diagnostic_E0191","","",N,N],[0,"__register_diagnostic_E0192","","",N,N],[0,"__register_diagnostic_E0193","","",N,N],[0,"__register_diagnostic_E0194","","",N,N],[0,"__register_diagnostic_E0195","","",N,N],[0,"__register_diagnostic_E0199","","",N,N],[0,"__register_diagnostic_E0200","","",N,N],[0,"__register_diagnostic_E0201","","",N,N],[0,"__register_diagnostic_E0202","","",N,N],[0,"__register_diagnostic_E0204","","",N,N],[0,"__register_diagnostic_E0206","","",N,N],[0,"__register_diagnostic_E0207","","",N,N],[0,"__register_diagnostic_E0210","","",N,N],[0,"__register_diagnostic_E0220","","",N,N],[0,"__register_diagnostic_E0221","","",N,N],[0,"__register_diagnostic_E0223","","",N,N],[0,"__register_diagnostic_E0225","","",N,N],[0,"__register_diagnostic_E0229","","",N,N],[0,"__register_diagnostic_E0243","","",N,N],[0,"__register_diagnostic_E0244","","",N,N],[0,"__register_diagnostic_E0321","","",N,N],[0,"__register_diagnostic_E0322","","",N,N],[0,"__register_diagnostic_E0323","","",N,N],[0,"__register_diagnostic_E0324","","",N,N],[0,"__register_diagnostic_E0325","","",N,N],[0,"__register_diagnostic_E0326","","",N,N],[0,"__register_diagnostic_E0328","","",N,N],[0,"__register_diagnostic_E0366","","",N,N],[0,"__register_diagnostic_E0367","","",N,N],[0,"__register_diagnostic_E0368","","",N,N],[0,"__register_diagnostic_E0369","","",N,N],[0,"__register_diagnostic_E0370","","",N,N],[0,"__register_diagnostic_E0371","","",N,N],[0,"__register_diagnostic_E0374","","",N,N],[0,"__register_diagnostic_E0375","","",N,N],[0,"__register_diagnostic_E0376","","",N,N],[0,"__register_diagnostic_E0390","","",N,N],[0,"__register_diagnostic_E0392","","",N,N],[0,"__register_diagnostic_E0393","","",N,N],[0,"__register_diagnostic_E0399","","",N,N],[0,"__register_diagnostic_E0436","","",N,N],[0,"__register_diagnostic_E0439","","",N,N],[0,"__register_diagnostic_E0440","","",N,N],[0,"__register_diagnostic_E0441","","",N,N],[0,"__register_diagnostic_E0442","","",N,N],[0,"__register_diagnostic_E0443","","",N,N],[0,"__register_diagnostic_E0444","","",N,N],[0,"__register_diagnostic_E0516","","",N,N],[0,"__register_diagnostic_E0520","","",N,N],[0,"__register_diagnostic_E0527","","",N,N],[0,"__register_diagnostic_E0528","","",N,N],[0,"__register_diagnostic_E0529","","",N,N],[0,"__register_diagnostic_E0534","","",N,N],[0,"__register_diagnostic_E0535","","",N,N],[0,"__register_diagnostic_E0558","","",N,N],[0,"__register_diagnostic_E0559","","",N,N],[0,"__register_diagnostic_E0560","","",N,N],[0,"__register_diagnostic_E0569","","",N,N],[0,"__register_diagnostic_E0570","","",N,N],[0,"__register_diagnostic_E0572","","",N,N],[0,"__register_diagnostic_E0581","","",N,N],[0,"__register_diagnostic_E0582","","",N,N],[0,"__register_diagnostic_E0599","","",N,N],[0,"__register_diagnostic_E0600","","",N,N],[0,"__register_diagnostic_E0608","","",N,N],[0,"__register_diagnostic_E0604","","",N,N],[0,"__register_diagnostic_E0605","","",N,N],[0,"__register_diagnostic_E0606","","",N,N],[0,"__register_diagnostic_E0607","","",N,N],[0,"__register_diagnostic_E0609","","",N,N],[0,"__register_diagnostic_E0610","","",N,N],[0,"__register_diagnostic_E0614","","",N,N],[0,"__register_diagnostic_E0615","","",N,N],[0,"__register_diagnostic_E0616","","",N,N],[0,"__register_diagnostic_E0617","","",N,N],[0,"__register_diagnostic_E0618","","",N,N],[0,"__register_diagnostic_E0619","","",N,N],[0,"__register_diagnostic_E0620","","",N,N],[0,"__register_diagnostic_E0622","","",N,N],[0,"__register_diagnostic_E0624","","",N,N],[0,"__register_diagnostic_E0638","","",N,N],[0,"__register_diagnostic_E0639","","",N,N],[0,"__register_diagnostic_E0643","","",N,N],[0,"__register_diagnostic_E0646","","",N,N],[0,"__register_diagnostic_E0647","","",N,N],[0,"__register_diagnostic_E0648","","",N,N],[0,"__register_diagnostic_E0689","","",N,N],[0,"__register_diagnostic_E0690","","",N,N],[0,"__register_diagnostic_E0691","","",N,N],[0,"__register_diagnostic_E0699","","",N,N],[0,"__register_diagnostic_E0183","","",N,N],[0,"__register_diagnostic_E0203","","",N,N],[0,"__register_diagnostic_E0208","","",N,N],[0,"__register_diagnostic_E0212","","",N,N],[0,"__register_diagnostic_E0224","","",N,N],[0,"__register_diagnostic_E0227","","",N,N],[0,"__register_diagnostic_E0228","","",N,N],[0,"__register_diagnostic_E0307","","",N,N],[0,"__register_diagnostic_E0377","","",N,N],[0,"__register_diagnostic_E0533","","",N,N],[0,"__register_diagnostic_E0564","","",N,N],[0,"__register_diagnostic_E0587","","",N,N],[0,"__register_diagnostic_E0588","","",N,N],[0,"__register_diagnostic_E0592","","",N,N],[0,"__register_diagnostic_E0627","","",N,N],[0,"__register_diagnostic_E0632","","",N,N],[0,"__register_diagnostic_E0634","","",N,N],[0,"__register_diagnostic_E0640","","",N,N],[0,"__register_diagnostic_E0641","","",N,N],[0,"__register_diagnostic_E0645","","",N,N],[0,"__register_diagnostic_E0698","","",N,N],[0,"astconv","rustc_typeck","Conversion from AST representation of types to the ty.rs representation.  The main routine here is `ast_ty_to_ty()`: each use is parameterized by an instance of `AstConv`.",N,N],[3,"ConvertedBinding","rustc_typeck::astconv","",N,N],[12,"item_name","","",1,N],[12,"ty","","",1,N],[12,"span","","",1,N],[3,"Bounds","","",N,N],[12,"region_bounds","","",2,N],[12,"implicitly_sized","","",2,N],[12,"trait_bounds","","",2,N],[12,"projection_bounds","","",2,N],[4,"GenericArgPosition","","",N,N],[13,"Type","","",3,N],[13,"Value","","",3,N],[13,"MethodCall","","",3,N],[5,"split_auto_traits","","Divides a list of general trait bounds into two groups: auto traits (e.g. Sync and Send) and the remaining general trait bounds.",N,N],[17,"TRAIT_OBJECT_DUMMY_SELF","","Dummy type used for the `Self` of a `TraitRef` created for converting a trait object, and which gets removed in `ExistentialTraitRef`. This type must not appear anywhere in other converted types.",N,N],[8,"AstConv","","",N,N],[10,"tcx","","",4,[[["self"]],["tyctxt"]]],[10,"get_type_parameter_bounds","","Returns the set of bounds in scope for the type parameter with the given id.",4,[[["self"],["span"],["defid"]],["genericpredicates"]]],[10,"re_infer","","What lifetime should we use when a lifetime is omitted (and not elided)?",4,[[["self"],["span"],["option",["genericparamdef"]]],["option",["region"]]]],[10,"ty_infer","","What type should we use when a type is omitted?",4,[[["self"],["span"]],["ty"]]],[11,"ty_infer_for_def","","Same as ty_infer, but with a known type parameter definition.",4,[[["self"],["genericparamdef"],["span"]],["ty"]]],[10,"projected_ty_from_poly_trait_ref","","Projecting an associated type from a (potentially) higher-ranked trait reference is more complicated, because of the possibility of late-bound regions appearing in the associated type binding. This is not legal in function signatures for that reason. In a function body, we can always handle it because we can use inference variables to remove the late-bound regions.",4,[[["self"],["span"],["defid"],["polytraitref"]],["ty"]]],[10,"normalize_ty","","Normalize an associated type coming from the user.",4,[[["self"],["span"],["ty"]],["ty"]]],[10,"set_tainted_by_errors","","Invoked when we encounter an error from some prior pass (e.g. resolve) that is translated into a ty-error. This is used to help suppress derived errors typeck might otherwise report.",4,[[["self"]]]],[10,"record_ty","","",4,[[["self"],["hirid"],["ty"],["span"]]]],[11,"eq","","",3,[[["self"],["genericargposition"]],["bool"]]],[11,"ast_region_to_region","","",4,[[["self"],["lifetime"],["option",["genericparamdef"]]],["region"]]],[11,"ast_path_substs_for_ty","","Given a path `path` that refers to an item `I` with the declared generics `decl_generics`, returns an appropriate set of substitutions for this particular reference to `I`.",4,[[["self"],["span"],["defid"],["pathsegment"]],["substs"]]],[11,"check_impl_trait","","Report error if there is an explicit type parameter when using `impl Trait`.",4,[[["tyctxt"],["span"],["pathsegment"],["generics"]],["bool"]]],[11,"check_generic_arg_count_for_call","","Check that the correct number of generic arguments have been provided. Used specifically for function calls.",4,[[["tyctxt"],["span"],["generics"],["pathsegment"],["bool"]],["bool"]]],[11,"check_generic_arg_count","","Check that the correct number of generic arguments have been provided. This is used both for datatypes and function calls.",4,[[["tyctxt"],["span"],["generics"],["genericargs"],["genericargposition"],["bool"],["bool"]],["bool"]]],[11,"create_substs_for_generic_args","","Creates the relevant generic argument substitutions corresponding to a set of generic parameters.",4,N],[11,"create_substs_for_ast_path","","Given the type/region arguments provided to some path (along with an implicit Self, if this is a trait reference) returns the complete set of substitutions. This may involve applying defaulted type parameters.",4,N],[11,"instantiate_mono_trait_ref","","Instantiates the path for the given trait reference, assuming that it's bound to a valid trait type. Returns the def_id for the defining trait. The type cannot be a type other than a trait type.",4,[[["self"],["traitref"],["ty"]],["traitref"]]],[11,"trait_def_id","","Get the DefId of the given trait ref. It must actually be a trait.",4,[[["self"],["traitref"]],["defid"]]],[11,"instantiate_poly_trait_ref_inner","","The given `trait_ref` must actually be trait.",4,[[["self"],["traitref"],["ty"],["vec"],["bool"]],["polytraitref"]]],[11,"instantiate_poly_trait_ref","","",4,[[["self"],["polytraitref"],["ty"],["vec"]],["polytraitref"]]],[11,"ast_path_to_mono_trait_ref","","",4,[[["self"],["span"],["defid"],["ty"],["pathsegment"]],["traitref"]]],[11,"create_substs_for_ast_trait_ref","","",4,N],[11,"trait_defines_associated_type_named","","",4,[[["self"],["defid"],["ident"]],["bool"]]],[11,"ast_type_binding_to_poly_projection_predicate","","",4,[[["self"],["nodeid"],["polytraitref"],["convertedbinding"],["bool"],["fxhashmap"]],["result",["polyprojectionpredicate","errorreported"]]]],[11,"ast_path_to_ty","","",4,[[["self"],["span"],["defid"],["pathsegment"]],["ty"]]],[11,"trait_ref_to_existential","","Transform a PolyTraitRef into a PolyExistentialTraitRef by removing the dummy Self type (TRAIT_OBJECT_DUMMY_SELF).",4,[[["self"],["traitref"]],["existentialtraitref"]]],[11,"conv_object_ty_poly_trait_ref","","",4,N],[11,"report_ambiguous_associated_type","","",4,[[["self"],["span"],["str"],["str"],["str"]]]],[11,"find_bound_for_assoc_item","","",4,[[["self"],["defid"],["ident"],["span"]],["result",["polytraitref","errorreported"]]]],[11,"one_bound_for_assoc_type","","",4,[[["self"],["i"],["str"],["ident"],["span"]],["result",["polytraitref","errorreported"]]]],[11,"associated_path_def_to_ty","","",4,N],[11,"qpath_to_ty","","",4,[[["self"],["span"],["option",["ty"]],["defid"],["pathsegment"],["pathsegment"]],["ty"]]],[11,"prohibit_generics","","",4,[[["self"],["t"]]]],[11,"prohibit_assoc_ty_binding","","",4,[[["tyctxt"],["span"]]]],[11,"def_to_ty","","",4,[[["self"],["option",["ty"]],["path"],["bool"]],["ty"]]],[11,"ast_ty_to_ty","","Parses the programmer's textual representation of a type into our internal notion of a type.",4,[[["self"],["ty"]],["ty"]]],[11,"impl_trait_ty_to_ty","","",4,N],[11,"ty_of_arg","","",4,[[["self"],["ty"],["option",["ty"]]],["ty"]]],[11,"ty_of_fn","","",4,[[["self"],["unsafety"],["abi"],["fndecl"]],["polyfnsig"]]],[11,"compute_object_lifetime_bound","","Given the bounds on an object, determines what single region bound (if any) we can use to summarize this type. The basic idea is that we will use the bound the user provided, if they provided one, and otherwise search the supertypes of trait bounds for region bounds. It may be that we can derive no bound at all, in which case we return `None`.",4,[[["self"],["span"],["binder",["list"]]],["option",["region"]]]],[11,"eq","","",2,[[["self"],["bounds"]],["bool"]]],[11,"ne","","",2,[[["self"],["bounds"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"clone","","",2,[[["self"]],["bounds"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"predicates","","",2,[[["self"],["tyctxt"],["ty"]],["vec",["predicate"]]]],[0,"check","rustc_typeck","",N,N],[3,"MaybeInProgressTables","rustc_typeck::check","A wrapper for InferCtxt's `in_progress_tables` field.",N,N],[12,"maybe_tables","","",5,N],[3,"Inherited","","closures defined within the function.  For example:",N,N],[12,"infcx","","",6,N],[12,"tables","","",6,N],[12,"locals","","",6,N],[12,"fulfillment_cx","","",6,N],[12,"deferred_call_resolutions","","",6,N],[12,"deferred_cast_checks","","",6,N],[12,"deferred_generator_interiors","","",6,N],[12,"opaque_types","","",6,N],[12,"implicit_region_bound","","Each type parameter has an implicit region bound that indicates it must outlive at least the function body (the user may specify stronger requirements). This field indicates the region of the callee. If it is `None`, then the parameter environment is for an item or something where the \"callee\" is not clear.",6,N],[12,"body_id","","",6,N],[3,"UnsafetyState","","",N,N],[12,"def","","",7,N],[12,"unsafety","","",7,N],[12,"unsafe_push_count","","",7,N],[12,"from_fn","","",7,N],[3,"BreakableCtxt","","",N,N],[12,"may_break","","",8,N],[12,"coerce","","",8,N],[3,"EnclosingBreakables","","",N,N],[12,"stack","","",9,N],[12,"by_id","","",9,N],[3,"PathSeg","","",N,N],[12,"0","","",10,N],[12,"1","","",10,N],[3,"FnCtxt","","",N,N],[12,"body_id","","",11,N],[12,"param_env","","The parameter environment used for proving trait obligations in this function. This can change when we descend into closures (as they bring new things into scope), hence it is not part of `Inherited` (as of the time of this writing, closures do not yet change the environment, but they will eventually).",11,N],[12,"err_count_on_creation","","",11,N],[12,"ret_coercion","","",11,N],[12,"yield_ty","","",11,N],[12,"ps","","",11,N],[12,"diverges","","Whether the last checked node generates a divergence (e.g., `return` will set this to Always). In general, when entering an expression or other node in the tree, the initial value indicates whether prior parts of the containing expression may have diverged. It is then typically set to `Maybe` (and the old value remembered) for processing the subparts of the current expression. As each subpart is processed, they may set the flag to `Always` etc.  Finally, at the end, we take the result and \"union\" it with the original value, so that when we return the flag indicates if any subpart of the the parent expression (up to and including this part) has diverged.  So, if you read it after evaluating a subexpression `X`, the value you get indicates whether any subexpression that was evaluating up to and including `X` diverged.",11,N],[12,"has_errors","","Whether any child nodes have any type errors.",11,N],[12,"enclosing_breakables","","",11,N],[12,"inh","","",11,N],[3,"InheritedBuilder","","Helper type of a temporary returned by Inherited::build(...). Necessary because we can't write the following bound: F: for<'b, 'tcx> where 'gcx: 'tcx FnOnce(Inherited<'b, 'gcx, 'tcx>).",N,N],[12,"infcx","","",12,N],[12,"def_id","","",12,N],[3,"CheckItemTypesVisitor","","",N,N],[12,"tcx","","",13,N],[3,"GatherLocalsVisitor","","",N,N],[12,"fcx","","",14,N],[3,"GeneratorTypes","","When `check_fn` is invoked on a generator (i.e., a body that includes yield), it returns back some information about the yield points.",N,N],[12,"yield_ty","","Type of value that is yielded.",15,N],[12,"interior","","Types that are captured (see `GeneratorInterior` for more).",15,N],[12,"movability","","Indicates if the generator is movable or static (immovable)",15,N],[4,"Expectation","","When type-checking an expression, we propagate downward whatever type hint we are able in the form of an `Expectation`.",N,N],[13,"NoExpectation","","We know nothing about what type this expression should have.",16,N],[13,"ExpectIfCondition","","This expression is an `if` condition, it must resolve to `bool`.",16,N],[13,"ExpectHasType","","This expression should have the type given (or some subtype)",16,N],[13,"ExpectCastableToType","","This expression will be cast to the `Ty`",16,N],[13,"ExpectRvalueLikeUnsized","","This rvalue expression will be wrapped in `&` or `Box` and coerced to `&Ty` or `Box<Ty>`, respectively. `Ty` is `[A]` or `Trait`.",16,N],[4,"Needs","","",N,N],[13,"MutPlace","","",17,N],[13,"None","","",17,N],[4,"PlaceOp","","",N,N],[13,"Deref","","",18,N],[13,"Index","","",18,N],[4,"Diverges","","Tracks whether executing a node may exit normally (versus return/break/panic, which \"diverge\", leaving dead code in their wake). Tracked semi-automatically (through type variables marked as diverging), with some manual adjustments for control-flow primitives (approximating a CFG).",N,N],[13,"Maybe","","Potentially unknown, some cases converge, others require a CFG to determine them.",19,N],[13,"Always","","Definitely known to diverge and therefore not reach the next sibling or its parent.",19,N],[13,"WarnedAlways","","Same as `Always` but with a reachability warning already emitted",19,N],[4,"TupleArgumentsFlag","","Controls whether the arguments are tupled. This is used for the call operator.",N,N],[13,"DontTupleArguments","","",20,N],[13,"TupleArguments","","",20,N],[5,"check_wf_new","","",N,[[["tyctxt"]],["result",["errorreported"]]]],[5,"check_item_types","","",N,[[["tyctxt"]],["result",["errorreported"]]]],[5,"check_item_bodies","","",N,[[["tyctxt"]],["result",["compileincomplete"]]]],[5,"typeck_item_bodies","","",N,[[["tyctxt"],["cratenum"]],["result",["compileincomplete"]]]],[5,"check_item_well_formed","","",N,[[["tyctxt"],["defid"]]]],[5,"check_trait_item_well_formed","","",N,[[["tyctxt"],["defid"]]]],[5,"check_impl_item_well_formed","","",N,[[["tyctxt"],["defid"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"adt_destructor","","",N,[[["tyctxt"],["defid"]],["option",["destructor"]]]],[5,"primary_body_of","","If this def-id is a \"primary tables entry\", returns `Some((body_id, decl))` with information about it's body-id and fn-decl (if any). Otherwise, returns `None`.",N,[[["tyctxt"],["nodeid"]],["option"]]],[5,"has_typeck_tables","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"used_trait_imports","","",N,[[["tyctxt"],["defid"]],["lrc",["defidset"]]]],[5,"typeck_tables_of","","",N,[[["tyctxt"],["defid"]],["typecktables"]]],[5,"check_abi","","",N,[[["tyctxt"],["span"],["abi"]]]],[5,"check_fn","","Helper used for fns and closures. Does the grungy work of checking a function body and returns the function context used for that purpose, since in the case of a fn item there is still a bit more to do.",N,N],[5,"check_struct","","",N,[[["tyctxt"],["nodeid"],["span"]]]],[5,"check_union","","",N,[[["tyctxt"],["nodeid"],["span"]]]],[5,"check_item_type","","",N,[[["tyctxt"],["item"]]]],[5,"maybe_check_static_with_link_section","","",N,[[["tyctxt"],["defid"],["span"]]]],[5,"check_on_unimplemented","","",N,[[["tyctxt"],["defid"],["item"]]]],[5,"report_forbidden_specialization","","",N,[[["tyctxt"],["implitem"],["defid"]]]],[5,"check_specialization_validity","","",N,[[["tyctxt"],["traitdef"],["associateditem"],["defid"],["implitem"]]]],[5,"check_impl_items_against_trait","","",N,N],[5,"check_representable","","Checks whether a type can be represented in memory. In particular, it identifies types that contain themselves without indirection through a pointer, which would mean their size is unbounded.",N,[[["tyctxt"],["span"],["defid"]],["bool"]]],[5,"check_simd","","",N,[[["tyctxt"],["span"],["defid"]]]],[5,"check_packed","","",N,[[["tyctxt"],["span"],["defid"]]]],[5,"check_packed_inner","","",N,[[["tyctxt"],["defid"],["vec"]],["bool"]]],[5,"check_transparent","","",N,[[["tyctxt"],["span"],["defid"]]]],[5,"check_enum","","",N,N],[5,"check_bounds_are_used","","",N,[[["tyctxt"],["generics"],["ty"]]]],[5,"fatally_break_rust","","",N,[[["session"]]]],[0,"autoderef","","",N,N],[3,"Autoderef","rustc_typeck::check::autoderef","",N,N],[12,"fcx","","",21,N],[12,"steps","","",21,N],[12,"cur_ty","","",21,N],[12,"obligations","","",21,N],[12,"at_start","","",21,N],[12,"include_raw_pointers","","",21,N],[12,"span","","",21,N],[4,"AutoderefKind","","",N,N],[13,"Builtin","","",22,N],[13,"Overloaded","","",22,N],[11,"clone","","",22,[[["self"]],["autoderefkind"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"next","","",21,[[["self"]],["option"]]],[11,"overloaded_deref_ty","","",21,[[["self"],["ty"]],["option",["ty"]]]],[11,"unambiguous_final_ty","","Returns the final type, generating an error if it is an unresolved inference variable.",21,[[["self"]],["ty"]]],[11,"maybe_ambiguous_final_ty","","Returns the final type we ended up with, which may well be an inference variable (we will resolve it first, if possible).",21,[[["self"]],["ty"]]],[11,"step_count","","",21,[[["self"]],["usize"]]],[11,"adjust_steps","","Returns the adjustment steps.",21,[[["self"],["needs"]],["vec",["adjustment"]]]],[11,"adjust_steps_as_infer_ok","","",21,[[["self"],["needs"]],["inferok",["vec"]]]],[11,"include_raw_pointers","","also dereference through raw pointer types e.g. assuming ptr_to_Foo is the type `*const Foo` fcx.autoderef(span, ptr_to_Foo)  => [*const Foo] fcx.autoderef(span, ptr_to_Foo).include_raw_ptrs() => [*const Foo, Foo]",21,[[["self"]],["self"]]],[11,"finalize","","",21,[[["self"]]]],[11,"into_obligations","","",21,[[["self"]],["vec",["predicateobligation"]]]],[11,"autoderef","rustc_typeck::check","",11,[[["self"],["span"],["ty"]],["autoderef"]]],[11,"try_overloaded_deref","","",11,[[["self"],["span"],["ty"],["needs"]],["option",["inferok"]]]],[0,"dropck","","",N,N],[5,"check_drop_impl","rustc_typeck::check::dropck","check_drop_impl confirms that the Drop implementation identified by `drop_impl_did` is not any more specialized than the type it is attached to (Issue #8142).",N,[[["tyctxt"],["defid"]],["result",["errorreported"]]]],[5,"ensure_drop_params_and_item_params_correspond","","",N,[[["tyctxt"],["defid"],["ty"],["defid"]],["result",["errorreported"]]]],[5,"ensure_drop_predicates_are_implied_by_item_defn","","Confirms that every predicate imposed by dtor_predicates is implied by assuming the predicates attached to self_type_did.",N,[[["tyctxt"],["defid"],["genericpredicates"],["defid"],["substs"]],["result",["errorreported"]]]],[5,"check_safety_of_destructor_if_necessary","","check_safety_of_destructor_if_necessary confirms that the type expression `typ` conforms to the \"Drop Check Rule\" from the Sound Generic Drop (RFC 769).",N,[[["regionctxt"],["ty"],["span"],["nodeid"],["scope"]],["result",["errorreported"]]]],[0,"_match","rustc_typeck::check","",N,N],[11,"check_pat_walk","","The `is_arg` argument indicates whether this pattern is the outermost pattern in an argument (e.g., in `fn foo(&x: &u32)`, it is true for the `&x` pattern but not `x`). This is used to tailor error reporting.",11,[[["self"],["pat"],["ty"],["bindingmode"],["bool"]]]],[11,"check_dereferencable","","",11,[[["self"],["span"],["ty"],["pat"]],["bool"]]],[11,"check_match","","",11,N],[11,"check_pat_struct","","",11,N],[11,"check_pat_path","","",11,[[["self"],["pat"],["qpath"],["ty"]],["ty"]]],[11,"check_pat_tuple_struct","","",11,N],[11,"check_struct_pat_fields","","",11,N],[0,"writeback","","",N,N],[3,"WritebackCx","rustc_typeck::check::writeback","",N,N],[12,"fcx","","",23,N],[12,"tables","","",23,N],[12,"body","","",23,N],[12,"rustc_dump_user_substs","","",23,N],[3,"Resolver","","",N,N],[12,"tcx","","",24,N],[12,"infcx","","",24,N],[12,"span","","",24,N],[12,"body","","",24,N],[8,"Locatable","","",N,N],[10,"to_span","","",25,[[["self"],["tyctxt"]],["span"]]],[11,"resolve_type_vars_in_body","rustc_typeck::check","",11,[[["self"],["body"]],["typecktables"]]],[11,"new","rustc_typeck::check::writeback","",23,[[["fnctxt"],["body"],["bool"]],["writebackcx"]]],[11,"tcx","","",23,[[["self"]],["tyctxt"]]],[11,"write_ty_to_tables","","",23,[[["self"],["hirid"],["ty"]]]],[11,"fix_scalar_builtin_expr","","",23,[[["self"],["expr"]]]],[11,"fix_index_builtin_expr","","",23,[[["self"],["expr"]]]],[11,"nested_visit_map","","",23,[[["self"]],["nestedvisitormap"]]],[11,"visit_expr","","",23,[[["self"],["expr"]]]],[11,"visit_block","","",23,[[["self"],["block"]]]],[11,"visit_pat","","",23,[[["self"],["pat"]]]],[11,"visit_local","","",23,[[["self"],["local"]]]],[11,"visit_ty","","",23,[[["self"],["ty"]]]],[11,"visit_upvar_borrow_map","","",23,[[["self"]]]],[11,"visit_closures","","",23,[[["self"]]]],[11,"visit_cast_types","","",23,[[["self"]]]],[11,"visit_free_region_map","","",23,[[["self"]]]],[11,"visit_user_provided_tys","","",23,[[["self"]]]],[11,"visit_opaque_types","","",23,[[["self"],["span"]]]],[11,"visit_field_id","","",23,[[["self"],["nodeid"]]]],[11,"visit_node_id","","",23,[[["self"],["span"],["hirid"]]]],[11,"visit_adjustments","","",23,[[["self"],["span"],["hirid"]]]],[11,"visit_pat_adjustments","","",23,[[["self"],["span"],["hirid"]]]],[11,"visit_liberated_fn_sigs","","",23,[[["self"]]]],[11,"visit_fru_field_types","","",23,[[["self"]]]],[11,"resolve","","",23,N],[11,"new","","",24,[[["fnctxt"],["locatable"],["body"]],["resolver"]]],[11,"report_error","","",24,[[["self"],["ty"]]]],[11,"tcx","","",24,[[["self"]],["tyctxt"]]],[11,"fold_ty","","",24,[[["self"],["ty"]],["ty"]]],[11,"fold_region","","",24,[[["self"],["region"]],["region"]]],[0,"regionck","rustc_typeck::check","The region check is a final pass that runs over the AST after we have inferred the type constraints but before we have actually finalized the types.  Its purpose is to embed a variety of region constraints. Inserting these constraints as a separate pass is good because (1) it localizes the code that has to do with region inference and (2) often we cannot know what constraints are needed until the basic types have been inferred.",N,N],[3,"RegionCtxt","rustc_typeck::check::regionck","",N,N],[12,"fcx","","",26,N],[12,"region_scope_tree","","",26,N],[12,"outlives_environment","","",26,N],[12,"body_id","","",26,N],[12,"call_site_scope","","",26,N],[12,"repeating_scope","","",26,N],[12,"subject_def_id","","",26,N],[3,"RepeatingScope","","",N,N],[12,"0","","",27,N],[3,"Subject","","",N,N],[12,"0","","",28,N],[11,"regionck_expr","rustc_typeck::check","",11,[[["self"],["body"]]]],[11,"regionck_item","","Region checking during the WF phase for items. `wf_tys` are the types from which we should derive implied bounds, if any.",11,N],[11,"regionck_fn","","Region check a function body. Not invoked on closures, but only on the \"root\" fn item (in which closures may be embedded). Walks the function body and adds various add'l constraints that are needed for region inference. This is separated both to isolate \"pure\" region constraints from the rest of type check and because sometimes we need type inference to have completed before we can determine which constraints to add.",11,[[["self"],["nodeid"],["body"]]]],[11,"deref","rustc_typeck::check::regionck","",26,N],[11,"new","","",26,[[["fnctxt"],["repeatingscope"],["nodeid"],["subject"],["paramenv"]],["regionctxt"]]],[11,"set_repeating_scope","","",26,[[["self"],["nodeid"]],["nodeid"]]],[11,"resolve_type","","Try to resolve the type for the given node, returning t_err if an error results.  Note that we never care about the details of the error, the same error will be detected and reported in the writeback phase.",26,[[["self"],["ty"]],["ty"]]],[11,"resolve_node_type","","Try to resolve the type for the given node.",26,[[["self"],["hirid"]],["ty"]]],[11,"resolve_expr_type_adjusted","","Try to resolve the type for the given node.",26,[[["self"],["expr"]],["ty"]]],[11,"visit_fn_body","","This is the \"main\" function when region-checking a function item or a closure within a function item. It begins by updating various fields (e.g., `call_site_scope` and `outlives_environment`) to be appropriate to the function and then adds constraints derived from the function body.",26,[[["self"],["nodeid"],["body"],["span"]]]],[11,"visit_region_obligations","","",26,[[["self"],["nodeid"]]]],[11,"resolve_regions_and_report_errors","","",26,[[["self"]]]],[11,"resolve_regions_and_report_errors_unless_nll","","",26,[[["self"]]]],[11,"constrain_bindings_in_pat","","",26,[[["self"],["pat"]]]],[11,"nested_visit_map","","",26,[[["self"]],["nestedvisitormap"]]],[11,"visit_fn","","",26,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"visit_arm","","",26,[[["self"],["arm"]]]],[11,"visit_local","","",26,[[["self"],["local"]]]],[11,"visit_expr","","",26,[[["self"],["expr"]]]],[11,"constrain_cast","","",26,[[["self"],["expr"],["expr"]]]],[11,"walk_cast","","",26,[[["self"],["expr"],["ty"],["ty"]]]],[11,"check_expr_fn_block","","",26,[[["self"],["expr"],["bodyid"]]]],[11,"constrain_callee","","",26,[[["self"],["expr"]]]],[11,"constrain_call","","Invoked on every call site (i.e., normal calls, method calls, and overloaded operators). Constrains the regions which appear in the type of the function. Also constrains the regions that appear in the arguments appropriately.",26,[[["self"],["expr"],["option",["expr"]],["i"]]]],[11,"with_mc","","Create a temporary `MemCategorizationContext` and pass it to the closure.",26,[[["self"],["f"]],["r"]]],[11,"constrain_adjustments","","Invoked on any adjustments that occur. Checks that if this is a region pointer being dereferenced, the lifetime of the pointer includes the deref expr.",26,[[["self"],["expr"]],["mcresult",["cmt_"]]]],[11,"mk_subregion_due_to_dereference","","",26,[[["self"],["span"],["region"],["region"]]]],[11,"check_safety_of_rvalue_destructor_if_necessary","","",26,[[["self"],["cmt_"],["span"]]]],[11,"constrain_index","","Invoked on any index expression that occurs. Checks that if this is a slice being indexed, the lifetime of the pointer includes the deref expr.",26,[[["self"],["expr"],["ty"]]]],[11,"type_of_node_must_outlive","","Guarantees that any lifetimes which appear in the type of the node `id` (after applying adjustments) are valid for at least `minimum_lifetime`",26,[[["self"],["subregionorigin"],["hirid"],["region"]]]],[11,"type_must_outlive","","Adds constraints to inference such that `T: 'a` holds (or reports an error if it cannot).",26,[[["self"],["subregionorigin"],["ty"],["region"]]]],[11,"link_addr_of","","Computes the guarantor for an expression `&base` and then ensures that the lifetime of the resulting pointer is linked to the lifetime of its guarantor (if any).",26,[[["self"],["expr"],["mutability"],["expr"]]]],[11,"link_local","","Computes the guarantors for any ref bindings in a `let` and then ensures that the lifetime of the resulting pointer is linked to the lifetime of the initialization expression.",26,[[["self"],["local"]]]],[11,"link_match","","Computes the guarantors for any ref bindings in a match and then ensures that the lifetime of the resulting pointer is linked to the lifetime of its guarantor (if any).",26,N],[11,"link_fn_args","","Computes the guarantors for any ref bindings in a match and then ensures that the lifetime of the resulting pointer is linked to the lifetime of its guarantor (if any).",26,N],[11,"link_pattern","","Link lifetimes of any ref bindings in `root_pat` to the pointers found in the discriminant, if needed.",26,[[["self"],["cmt"],["pat"]]]],[11,"link_autoref","","Link lifetime of borrowed pointer resulting from autoref to lifetimes in the value being autoref'd.",26,[[["self"],["expr"],["cmt_"],["autoborrow"]]]],[11,"link_region_from_node_type","","Like `link_region()`, except that the region is extracted from the type of `id`, which must be some reference (`&T`, `&str`, etc).",26,[[["self"],["span"],["hirid"],["mutability"],["cmt_"]]]],[11,"link_region","","Informs the inference engine that `borrow_cmt` is being borrowed with kind `borrow_kind` and lifetime `borrow_region`. In order to ensure borrowck is satisfied, this may create constraints between regions, as explained in `link_reborrowed_region()`.",26,[[["self"],["span"],["region"],["borrowkind"],["cmt_"]]]],[11,"link_reborrowed_region","","This is the most complicated case: the path being borrowed is itself the referent of a borrowed pointer. Let me give an example fragment of code to make clear(er) the situation:",26,[[["self"],["span"],["region"],["borrowkind"],["cmt"],["region"],["borrowkind"],["note"]],["option"]]],[11,"substs_wf_in_scope","","Checks that the values provided for type/region arguments in a given expression are well-formed and in-scope.",26,[[["self"],["parameterorigin"],["substs"],["span"],["region"]]]],[0,"coercion","rustc_typeck::check","Type Coercion",N,N],[3,"Coerce","rustc_typeck::check::coercion","",N,N],[12,"fcx","","",29,N],[12,"cause","","",29,N],[12,"use_lub","","",29,N],[12,"allow_two_phase","","Determines whether or not allow_two_phase_borrow is set on any autoref adjustments we create while coercing. We don't want to allow deref coercions to create two-phase borrows, at least initially, but we do need two-phase borrows for function argument reborrows. See #47489 and #48598 See docs on the \"AllowTwoPhase\" type for a more detailed discussion",29,N],[3,"CoerceMany","","CoerceMany encapsulates the pattern you should use when you have many expressions that are all getting coerced to a common type. This arises, for example, when you have a match (the result of each arm is coerced to a common type). It also arises in less obvious places, such as when you have many `break foo` expressions that target the same loop, or the various `return` expressions in a function.",N,N],[12,"expected_ty","","",30,N],[12,"final_ty","","",30,N],[12,"expressions","","",30,N],[12,"pushed","","",30,N],[4,"Expressions","","",N,N],[13,"Dynamic","","",31,N],[13,"UpFront","","",31,N],[5,"coerce_mutbls","","",N,[[["mutability"],["mutability"]],["relateresult"]]],[5,"identity","","",N,[[["ty"]],["vec",["adjustment"]]]],[5,"simple","","",N,N],[5,"success","","",N,[[["vec",["adjustment"]],["ty"],["predicateobligations"]],["inferresult"]]],[6,"CoerceResult","","",N,N],[6,"DynamicCoerceMany","","The type of a `CoerceMany` that is storing up the expressions into a buffer. We use this in `check/mod.rs` for things like `break`.",N,N],[22,"","","",N,N],[8,"AsCoercionSite","","Something that can be converted into an expression to which we can apply a coercion.",N,N],[10,"as_coercion_site","","",32,[[["self"]],["expr"]]],[11,"deref","","",29,N],[11,"new","","",29,[[["fnctxt"],["obligationcause"],["allowtwophase"]],["self"]]],[11,"unify","","",29,[[["self"],["ty"],["ty"]],["inferresult",["ty"]]]],[11,"unify_and","","Unify two types (using sub or lub) and produce a specific coercion.",29,[[["self"],["ty"],["ty"],["f"]],["inferresult"]]],[11,"coerce","","",29,[[["self"],["ty"],["ty"]],["inferresult"]]],[11,"coerce_borrowed_pointer","","Reborrows `&mut A` to `&mut B` and `&(mut) A` to `&B`. To match `A` with `B`, autoderef will be performed, calling `deref`/`deref_mut` where necessary.",29,[[["self"],["ty"],["ty"],["region"],["typeandmut"]],["inferresult"]]],[11,"coerce_unsized","","",29,[[["self"],["ty"],["ty"]],["inferresult"]]],[11,"coerce_from_safe_fn","","",29,[[["self"],["ty"],["polyfnsig"],["ty"],["f"],["g"]],["inferresult"]]],[11,"coerce_from_fn_pointer","","Attempts to coerce from the type of a Rust function item into a closure or a `proc`.",29,[[["self"],["ty"],["polyfnsig"],["ty"]],["inferresult"]]],[11,"coerce_from_fn_item","","Attempts to coerce from the type of a Rust function item into a closure or a `proc`.",29,[[["self"],["ty"],["ty"]],["inferresult"]]],[11,"coerce_closure_to_fn","","Attempts to coerce from the type of a non-capturing closure into a function pointer.",29,[[["self"],["ty"],["defid"],["closuresubsts"],["ty"]],["inferresult"]]],[11,"coerce_unsafe_ptr","","",29,[[["self"],["ty"],["ty"],["mutability"]],["inferresult"]]],[11,"try_coerce","rustc_typeck::check","Attempt to coerce an expression to a type, and return the adjusted type of the expression, if successful. Adjustments are only recorded if the coercion succeeded. The expressions must not have any pre-existing adjustments.",11,[[["self"],["expr"],["ty"],["ty"],["allowtwophase"]],["relateresult",["ty"]]]],[11,"can_coerce","","Same as `try_coerce()`, but without side-effects.",11,[[["self"],["ty"],["ty"]],["bool"]]],[11,"try_find_coercion_lub","","Given some expressions, their known unified type and another expression, tries to unify the types, potentially inserting coercions on any of the provided expressions and returns their LUB (aka \"common supertype\").",11,N],[11,"new","rustc_typeck::check::coercion","The usual case; collect the set of expressions dynamically. If the full set of coercion sites is known before hand, consider `with_coercion_sites()` instead to avoid allocation.",30,[[["ty"]],["self"]]],[11,"with_coercion_sites","","As an optimization, you can create a `CoerceMany` with a pre-existing slice of expressions. In this case, you are expected to pass each element in the slice to `coerce(...)` in order. This is used with arrays in particular to avoid needlessly cloning the slice.",30,N],[11,"make","","",30,[[["ty"],["expressions"]],["self"]]],[11,"expected_ty","","Return the \"expected type\" with which this coercion was constructed.  This represents the \"downward propagated\" type that was given to us at the start of typing whatever construct we are typing (e.g., the match expression).",30,[[["self"]],["ty"]]],[11,"merged_ty","","Returns the current \"merged type\", representing our best-guess at the LUB of the expressions we've seen so far (if any). This isn't final until you call `self.final()`, which will return the merged type.",30,[[["self"]],["ty"]]],[11,"coerce","","Indicates that the value generated by `expression`, which is of type `expression_ty`, is one of the possibility that we could coerce from. This will record `expression` and later calls to `coerce` may come back and add adjustments and things if necessary.",30,[[["self"],["fnctxt"],["obligationcause"],["expr"],["ty"]]]],[11,"coerce_forced_unit","","Indicates that one of the inputs is a \"forced unit\". This occurs in a case like `if foo { ... };`, where the missing else generates a \"forced unit\". Another example is a `loop { break; }`, where the `break` has no argument expression. We treat these cases slightly differently for error-reporting purposes. Note that these tend to correspond to cases where the `()` expression is implicit in the source, and hence we do not take an expression argument.",30,[[["self"],["fnctxt"],["obligationcause"],["fnmut"],["bool"]]]],[11,"coerce_inner","","The inner coercion \"engine\". If `expression` is `None`, this is a forced-unit case, and hence `expression_ty` must be `Nil`.",30,[[["self"],["fnctxt"],["obligationcause"],["option",["expr"]],["ty"],["option",["fnmut"]],["bool"]]]],[11,"complete","","",30,[[["self"],["fnctxt"]],["ty"]]],[0,"demand","rustc_typeck::check","",N,N],[11,"demand_suptype","","",11,[[["self"],["span"],["ty"],["ty"]]]],[11,"demand_suptype_diag","","",11,[[["self"],["span"],["ty"],["ty"]],["option",["diagnosticbuilder"]]]],[11,"demand_eqtype","","",11,[[["self"],["span"],["ty"],["ty"]]]],[11,"demand_eqtype_diag","","",11,[[["self"],["span"],["ty"],["ty"]],["option",["diagnosticbuilder"]]]],[11,"demand_eqtype_with_origin","","",11,[[["self"],["obligationcause"],["ty"],["ty"]],["option",["diagnosticbuilder"]]]],[11,"demand_coerce","","",11,[[["self"],["expr"],["ty"],["ty"],["allowtwophase"]],["ty"]]],[11,"demand_coerce_diag","","",11,N],[11,"get_conversion_methods","","",11,[[["self"],["span"],["ty"],["ty"]],["vec",["associateditem"]]]],[11,"has_no_input_arg","","",11,[[["self"],["associateditem"]],["bool"]]],[11,"can_use_as_ref","","Identify some cases where `as_ref()` would be appropriate and suggest it.",11,[[["self"],["expr"]],["option"]]],[11,"check_ref","","This function is used to determine potential \"simple\" improvements or users' errors and provide them useful help. For example:",11,[[["self"],["expr"],["ty"],["ty"]],["option"]]],[11,"check_for_cast","","",11,[[["self"],["diagnosticbuilder"],["expr"],["ty"],["ty"]],["bool"]]],[0,"method","","Method lookup: the secret sauce of Rust. See the [rustc guide] chapter.",N,N],[3,"MethodCallee","rustc_typeck::check::method","",N,N],[12,"def_id","","Impl method ID, for inherent methods, or trait method ID, otherwise.",33,N],[12,"substs","","",33,N],[12,"sig","","Instantiated method signature, i.e. it has been substituted, normalized, and has had late-bound lifetimes replaced with inference variables.",33,N],[3,"NoMatchData","","",N,N],[12,"static_candidates","","",34,N],[12,"unsatisfied_predicates","","",34,N],[12,"out_of_scope_traits","","",34,N],[12,"lev_candidate","","",34,N],[12,"mode","","",34,N],[4,"MethodError","","",N,N],[13,"NoMatch","","",35,N],[13,"Ambiguity","","",35,N],[13,"PrivateMatch","","",35,N],[13,"IllegalSizedBound","","",35,N],[13,"BadReturnType","","",35,N],[4,"CandidateSource","","",N,N],[13,"ImplSource","","",36,N],[13,"TraitSource","","",36,N],[5,"provide","","",N,[[["providers"]]]],[0,"confirm","","",N,N],[3,"ConfirmContext","rustc_typeck::check::method::confirm","",N,N],[12,"fcx","","",37,N],[12,"span","","",37,N],[12,"self_expr","","",37,N],[12,"call_expr","","",37,N],[3,"ConfirmResult","","",N,N],[12,"callee","","",38,N],[12,"illegal_sized_bound","","",38,N],[11,"deref","","",37,N],[11,"confirm_method","rustc_typeck::check","",11,[[["self"],["span"],["expr"],["expr"],["ty"],["pick"],["pathsegment"]],["confirmresult"]]],[11,"new","rustc_typeck::check::method::confirm","",37,[[["fnctxt"],["span"],["expr"],["expr"]],["confirmcontext"]]],[11,"confirm","","",37,[[["self"],["ty"],["pick"],["pathsegment"]],["confirmresult"]]],[11,"adjust_self_ty","","",37,[[["self"],["ty"],["pick"]],["ty"]]],[11,"fresh_receiver_substs","","Returns a set of substitutions for the method receiver where all type and region parameters are instantiated with fresh variables. This substitution does not include any parameters declared on the method itself.",37,[[["self"],["ty"],["pick"]],["substs"]]],[11,"extract_existential_trait_ref","","",37,[[["self"],["ty"],["f"]],["r"]]],[11,"instantiate_method_substs","","",37,[[["self"],["pick"],["pathsegment"],["substs"]],["substs"]]],[11,"unify_receivers","","",37,[[["self"],["ty"],["ty"]]]],[11,"instantiate_method_sig","","",37,N],[11,"add_obligations","","",37,[[["self"],["ty"],["substs"],["instantiatedpredicates"]]]],[11,"convert_place_derefs_to_mutable","","When we select a method with a mutable autoref, we have to go convert any auto-derefs, indices, etc from `Deref` and `Index` into `DerefMut` and `IndexMut` respectively.",37,[[["self"]]]],[11,"convert_place_op_to_mutable","","",37,N],[11,"predicates_require_illegal_sized_bound","","",37,[[["self"],["instantiatedpredicates"]],["bool"]]],[11,"enforce_illegal_method_limitations","","",37,[[["self"],["pick"]]]],[11,"upcast","","",37,[[["self"],["polytraitref"],["defid"]],["polytraitref"]]],[11,"replace_late_bound_regions_with_fresh_var","","",37,[[["self"],["binder"]],["t"]]],[0,"probe","rustc_typeck::check::method","",N,N],[3,"IsSuggestion","rustc_typeck::check::method::probe","Boolean flag used to indicate if this search is for a suggestion or not.  If true, we can allow ambiguity and so forth.",N,N],[12,"0","","",39,N],[3,"ProbeContext","","",N,N],[12,"fcx","","",40,N],[12,"span","","",40,N],[12,"mode","","",40,N],[12,"method_name","","",40,N],[12,"return_type","","",40,N],[12,"steps","","",40,N],[12,"inherent_candidates","","",40,N],[12,"extension_candidates","","",40,N],[12,"impl_dups","","",40,N],[12,"static_candidates","","Collects near misses when the candidate functions are missing a `self` keyword and is only used for error reporting",40,N],[12,"allow_similar_names","","When probing for names, include names that are close to the requested name (by Levensthein distance)",40,N],[12,"private_candidate","","Some(candidate) if there is a private candidate",40,N],[12,"unsatisfied_predicates","","Collects near misses when trait bounds for type parameters are unsatisfied and is only used for error reporting",40,N],[12,"is_suggestion","","",40,N],[3,"CandidateStep","","",N,N],[12,"self_ty","","",41,N],[12,"autoderefs","","",41,N],[12,"from_unsafe_deref","","",41,N],[12,"unsize","","",41,N],[3,"Candidate","","",N,N],[12,"xform_self_ty","","",42,N],[12,"xform_ret_ty","","",42,N],[12,"item","","",42,N],[12,"kind","","",42,N],[12,"import_id","","",42,N],[3,"Pick","","",N,N],[12,"item","","",43,N],[12,"kind","","",43,N],[12,"import_id","","",43,N],[12,"autoderefs","","",43,N],[12,"autoref","","",43,N],[12,"unsize","","",43,N],[4,"CandidateKind","","",N,N],[13,"InherentImplCandidate","","",44,N],[13,"ObjectCandidate","","",44,N],[13,"TraitCandidate","","",44,N],[13,"WhereClauseCandidate","","",44,N],[4,"ProbeResult","","",N,N],[13,"NoMatch","","",45,N],[13,"BadReturnType","","",45,N],[13,"Match","","",45,N],[4,"PickKind","","",N,N],[13,"InherentImplPick","","",46,N],[13,"ObjectPick","","",46,N],[13,"TraitPick","","",46,N],[13,"WhereClausePick","","",46,N],[4,"Mode","","",N,N],[13,"MethodCall","","",47,N],[13,"Path","","",47,N],[4,"ProbeScope","","",N,N],[13,"TraitsInScope","","",48,N],[13,"AllTraits","","",48,N],[6,"PickResult","","",N,N],[11,"clone","","",39,[[["self"]],["issuggestion"]]],[11,"deref","","",40,N],[11,"fmt","","",41,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",44,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"eq","","",45,[[["self"],["proberesult"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",45,N],[11,"clone","","",45,[[["self"]],["proberesult"]]],[11,"fmt","","",43,[[["self"],["formatter"]],["result"]]],[11,"eq","","",43,[[["self"],["pick"]],["bool"]]],[11,"ne","","",43,[[["self"],["pick"]],["bool"]]],[11,"clone","","",43,[[["self"]],["pick"]]],[11,"clone","","",46,[[["self"]],["pickkind"]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"eq","","",46,[[["self"],["pickkind"]],["bool"]]],[11,"ne","","",46,[[["self"],["pickkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",46,N],[11,"eq","","",47,[[["self"],["mode"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",47,N],[11,"clone","","",47,[[["self"]],["mode"]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"eq","","",48,[[["self"],["probescope"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",48,N],[11,"clone","","",48,[[["self"]],["probescope"]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"probe_for_return_type","rustc_typeck::check","This is used to offer suggestions to users. It returns methods that could have been called which have the desired return type. Some effort is made to rule out methods that, if called, would result in an error (basically, the same criteria we would use to decide if a method is a plausible fit for ambiguity purposes).",11,[[["self"],["span"],["mode"],["ty"],["ty"],["nodeid"]],["vec",["associateditem"]]]],[11,"probe_for_name","","",11,[[["self"],["span"],["mode"],["ident"],["issuggestion"],["ty"],["nodeid"],["probescope"]],["result",["pick","methoderror"]]]],[11,"probe_op","","",11,[[["self"],["span"],["mode"],["option",["ident"]],["option",["ty"]],["issuggestion"],["ty"],["nodeid"],["probescope"],["op"]],["result",["methoderror"]]]],[11,"create_steps","","",11,[[["self"],["span"],["nodeid"],["ty"],["issuggestion"]],["option",["vec"]]]],[11,"new","rustc_typeck::check::method::probe","",40,[[["fnctxt"],["span"],["mode"],["option",["ident"]],["option",["ty"]],["rc",["vec"]],["issuggestion"]],["probecontext"]]],[11,"reset","","",40,[[["self"]]]],[11,"push_candidate","","",40,[[["self"],["candidate"],["bool"]]]],[11,"assemble_inherent_candidates","","",40,[[["self"]]]],[11,"assemble_probe","","",40,[[["self"],["ty"]]]],[11,"assemble_inherent_impl_for_primitive","","",40,[[["self"],["option",["defid"]]]]],[11,"assemble_inherent_impl_candidates_for_type","","",40,[[["self"],["defid"]]]],[11,"assemble_inherent_impl_probe","","",40,[[["self"],["defid"]]]],[11,"assemble_inherent_candidates_from_object","","",40,[[["self"],["ty"],["polyexistentialtraitref"]]]],[11,"assemble_inherent_candidates_from_param","","",40,[[["self"],["ty"],["paramty"]]]],[11,"elaborate_bounds","","",40,N],[11,"assemble_extension_candidates_for_traits_in_scope","","",40,[[["self"],["nodeid"]],["result",["methoderror"]]]],[11,"assemble_extension_candidates_for_all_traits","","",40,[[["self"]],["result",["methoderror"]]]],[11,"matches_return_type","","",40,[[["self"],["associateditem"],["option",["ty"]],["ty"]],["bool"]]],[11,"assemble_extension_candidates_for_trait","","",40,[[["self"],["option",["nodeid"]],["defid"]],["result",["methoderror"]]]],[11,"candidate_method_names","","",40,[[["self"]],["vec",["ident"]]]],[11,"pick","","",40,[[["self"]],["result",["pick","methoderror"]]]],[11,"pick_core","","",40,[[["self"]],["option",["result"]]]],[11,"pick_by_value_method","","For each type `T` in the step list, this attempts to find a method where the (transformed) self type is exactly `T`. We do however do one transformation on the adjustment: if we are passing a region pointer in, we will potentially reborrow it to a shorter lifetime. This allows us to transparently pass `&mut` pointers, in particular, without consuming them for their entire lifetime.",40,[[["self"],["candidatestep"]],["option",["result"]]]],[11,"pick_autorefd_method","","",40,[[["self"],["candidatestep"],["mutability"]],["option",["result"]]]],[11,"pick_method","","",40,[[["self"],["ty"]],["option",["result"]]]],[11,"consider_candidates","","",40,[[["self"],["ty"],["probesiter"],["vec"],["option",["vec"]]],["option",["result"]]]],[11,"emit_unstable_name_collision_hint","","",40,N],[11,"select_trait_candidate","","",40,[[["self"],["traitref"]],["selectionresult",["selection"]]]],[11,"candidate_source","","",40,[[["self"],["candidate"],["ty"]],["candidatesource"]]],[11,"consider_probe","","",40,[[["self"],["ty"],["candidate"],["vec"]],["proberesult"]]],[11,"collapse_candidates_to_trait_pick","","Sometimes we get in a situation where we have multiple probes that are all impls of the same trait, but we don't know which impl to use. In this case, since in all cases the external interface of the method can be determined from the trait, it's ok not to decide. We can basically just collapse all of the probes for various impls into one where-clause probe. This will result in a pending obligation so when more type-info is available we can make the final decision.",40,N],[11,"probe_for_lev_candidate","","Similarly to `probe_for_return_type`, this method attempts to find the best matching candidate method where the method name may have been misspelt. Similarly to other Levenshtein based suggestions, we provide at most one such suggestion.",40,[[["self"]],["result",["option","methoderror"]]]],[11,"has_applicable_self","","",40,[[["self"],["associateditem"]],["bool"]]],[11,"record_static_candidate","","",40,[[["self"],["candidatesource"]]]],[11,"xform_self_ty","","",40,N],[11,"xform_method_sig","","",40,[[["self"],["defid"],["substs"]],["fnsig"]]],[11,"impl_ty_and_substs","","Get the type of an impl and generate substitutions with placeholders.",40,N],[11,"fresh_item_substs","","",40,[[["self"],["defid"]],["substs"]]],[11,"erase_late_bound_regions","","Replace late-bound-regions bound by `value` with `'static` using `ty::erase_late_bound_regions`.",40,[[["self"],["binder"]],["t"]]],[11,"impl_or_trait_item","","Find the method with the appropriate name (or return type, as the case may be). If `allow_similar_names` is set, find methods with close-matching names.",40,[[["self"],["defid"]],["vec",["associateditem"]]]],[11,"to_unadjusted_pick","","",42,[[["self"]],["pick"]]],[0,"suggest","rustc_typeck::check::method","Give useful errors and suggestions to users when an item can't be found or is otherwise invalid.",N,N],[3,"TraitInfo","rustc_typeck::check::method::suggest","",N,N],[12,"def_id","","",49,N],[3,"UsePlacementFinder","","",N,N],[12,"target_module","","",50,N],[12,"span","","",50,N],[12,"found_use","","",50,N],[12,"tcx","","",50,N],[5,"all_traits","","Retrieve all traits in this crate and any dependent crates.",N,[[["tyctxt"]],["vec",["traitinfo"]]]],[5,"compute_all_traits","","Compute all traits in this crate and any dependent crates.",N,[[["tyctxt"]],["vec",["defid"]]]],[5,"provide","","",N,[[["providers"]]]],[11,"is_fn_ty","rustc_typeck::check","",11,[[["self"],["ty"],["span"]],["bool"]]],[11,"report_method_error","","",11,[[["self"],["span"],["ty"],["ident"],["option",["expr"]],["methoderror"],["option"]]]],[11,"suggest_use_candidates","","",11,[[["self"],["diagnosticbuilder"],["string"],["vec",["defid"]]]]],[11,"suggest_valid_traits","","",11,[[["self"],["diagnosticbuilder"],["vec",["defid"]]],["bool"]]],[11,"suggest_traits_to_import","","",11,[[["self"],["diagnosticbuilder"],["span"],["ty"],["ident"],["option",["expr"]],["vec",["defid"]]]]],[11,"type_derefs_to_local","","Checks whether there is a local type somewhere in the chain of autoderefs of `rcvr_ty`.",11,[[["self"],["span"],["ty"],["option",["expr"]]],["bool"]]],[11,"clone","rustc_typeck::check::method::suggest","",49,[[["self"]],["traitinfo"]]],[11,"eq","","",49,[[["self"],["traitinfo"]],["bool"]]],[11,"partial_cmp","","",49,[[["self"],["traitinfo"]],["option",["ordering"]]]],[11,"cmp","","",49,[[["self"],["traitinfo"]],["ordering"]]],[11,"check","","",50,N],[11,"visit_mod","","",50,[[["self"],["mod"],["span"],["nodeid"]]]],[11,"nested_visit_map","","",50,[[["self"]],["nestedvisitormap"]]],[11,"clone","rustc_typeck::check::method","",33,[[["self"]],["methodcallee"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"new","","",34,[[["vec",["candidatesource"]],["vec",["traitref"]],["vec",["defid"]],["option",["associateditem"]],["mode"]],["self"]]],[11,"clone","","",36,[[["self"]],["candidatesource"]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",36,N],[11,"cmp","","",36,[[["self"],["candidatesource"]],["ordering"]]],[11,"eq","","",36,[[["self"],["candidatesource"]],["bool"]]],[11,"ne","","",36,[[["self"],["candidatesource"]],["bool"]]],[11,"partial_cmp","","",36,[[["self"],["candidatesource"]],["option",["ordering"]]]],[11,"lt","","",36,[[["self"],["candidatesource"]],["bool"]]],[11,"le","","",36,[[["self"],["candidatesource"]],["bool"]]],[11,"gt","","",36,[[["self"],["candidatesource"]],["bool"]]],[11,"ge","","",36,[[["self"],["candidatesource"]],["bool"]]],[11,"method_exists","rustc_typeck::check","Determines whether the type `self_ty` supports a method name `method_name` or not.",11,[[["self"],["ident"],["ty"],["nodeid"],["bool"]],["bool"]]],[11,"lookup_method","","Performs method lookup. If lookup is successful, it will return the callee and store an appropriate adjustment for the self-expr. In some cases it may report an error (e.g., invoking the `drop` method).",11,[[["self"],["ty"],["pathsegment"],["span"],["expr"],["expr"]],["result",["methodcallee","methoderror"]]]],[11,"lookup_probe","","",11,[[["self"],["span"],["ident"],["ty"],["expr"],["probescope"]],["result",["pick","methoderror"]]]],[11,"lookup_method_in_trait","","`lookup_method_in_trait` is used for overloaded operators. It does a very narrow slice of what the normal probe/confirm path does. In particular, it doesn't really do any probing: it simply constructs an obligation for a particular trait with the given self-type and checks whether that trait is implemented.",11,[[["self"],["span"],["ident"],["defid"],["ty"],["option"]],["option",["inferok"]]]],[11,"resolve_ufcs","","",11,[[["self"],["span"],["ident"],["ty"],["nodeid"]],["result",["def","methoderror"]]]],[11,"associated_item","","Find item with name `item_name` defined in impl/trait `def_id` and return it, or `None`, if no such item was defined there.",11,[[["self"],["defid"],["ident"],["namespace"]],["option",["associateditem"]]]],[0,"upvar","","Inferring borrow kinds for upvars",N,N],[3,"InferBorrowKindVisitor","rustc_typeck::check::upvar","",N,N],[12,"fcx","","",51,N],[3,"InferBorrowKind","","",N,N],[12,"fcx","","",52,N],[12,"closure_def_id","","",52,N],[12,"current_closure_kind","","",52,N],[12,"current_origin","","",52,N],[12,"adjust_upvar_captures","","",52,N],[5,"var_name","","",N,[[["tyctxt"],["hirid"]],["name"]]],[11,"closure_analyze","rustc_typeck::check","",11,[[["self"],["body"]]]],[11,"nested_visit_map","rustc_typeck::check::upvar","",51,[[["self"]],["nestedvisitormap"]]],[11,"visit_expr","","",51,[[["self"],["expr"]]]],[11,"analyze_closure","rustc_typeck::check","Analysis starting point.",11,[[["self"],["nodeid"],["hirid"],["span"],["body"],["captureclause"]]]],[11,"final_upvar_tys","","",11,[[["self"],["nodeid"]],["vec",["ty"]]]],[11,"adjust_upvar_borrow_kind_for_consume","rustc_typeck::check::upvar","",52,[[["self"],["cmt_"],["consumemode"]]]],[11,"adjust_upvar_borrow_kind_for_mut","","Indicates that `cmt` is being directly mutated (e.g., assigned to). If cmt contains any by-ref upvars, this implies that those upvars must be borrowed using an `&mut` borrow.",52,[[["self"],["cmt_"]]]],[11,"adjust_upvar_borrow_kind_for_unique","","",52,[[["self"],["cmt_"]]]],[11,"try_adjust_upvar_deref","","",52,[[["self"],["cmt_"],["borrowkind"]],["bool"]]],[11,"adjust_upvar_borrow_kind","","We infer the borrow_kind with which to borrow upvars in a stack closure. The borrow_kind basically follows a lattice of `imm < unique-imm < mut`, moving from left to right as needed (but never right to left). Here the argument `mutbl` is the borrow_kind that is required by some particular use.",52,[[["self"],["upvarid"],["borrowkind"]]]],[11,"adjust_closure_kind","","",52,[[["self"],["localdefid"],["closurekind"],["span"],["name"]]]],[11,"consume","","",52,[[["self"],["nodeid"],["span"],["cmt_"],["consumemode"]]]],[11,"matched_pat","","",52,[[["self"],["pat"],["cmt_"],["matchmode"]]]],[11,"consume_pat","","",52,[[["self"],["pat"],["cmt_"],["consumemode"]]]],[11,"borrow","","",52,[[["self"],["nodeid"],["span"],["cmt_"],["region"],["borrowkind"],["loancause"]]]],[11,"decl_without_init","","",52,[[["self"],["nodeid"],["span"]]]],[11,"mutate","","",52,[[["self"],["nodeid"],["span"],["cmt_"],["mutatemode"]]]],[0,"wfcheck","rustc_typeck::check","",N,N],[3,"CheckWfFcxBuilder","rustc_typeck::check::wfcheck","Helper type of a temporary returned by .for_item(...). Necessary because we can't write the following bound: F: for<'b, 'tcx> where 'gcx: 'tcx FnOnce(FnCtxt<'b, 'gcx, 'tcx>).",N,N],[12,"inherited","","",53,N],[12,"id","","",53,N],[12,"span","","",53,N],[12,"param_env","","",53,N],[3,"CheckTypeWellFormedVisitor","","",N,N],[12,"tcx","","",54,N],[3,"AdtVariant","","",N,N],[12,"fields","","",55,N],[3,"AdtField","","",N,N],[12,"ty","","",56,N],[12,"span","","",56,N],[5,"check_item_well_formed","","Checks that the field types (in a struct def'n) or argument types (in an enum def'n) are well-formed, meaning that they do not require any constraints not declared in the struct definition itself. For example, this definition would be illegal:",N,[[["tyctxt"],["defid"]]]],[5,"check_trait_item","","",N,[[["tyctxt"],["defid"]]]],[5,"check_impl_item","","",N,[[["tyctxt"],["defid"]]]],[5,"check_associated_item","","",N,[[["tyctxt"],["nodeid"],["span"],["option",["methodsig"]]]]],[5,"for_item","","",N,[[["tyctxt"],["item"]],["checkwffcxbuilder"]]],[5,"for_id","","",N,[[["tyctxt"],["nodeid"],["span"]],["checkwffcxbuilder"]]],[5,"check_type_defn","","In a type definition, we check that to ensure that the types of the fields are well-formed.",N,[[["tyctxt"],["item"],["bool"],["f"]]]],[5,"check_trait","","",N,[[["tyctxt"],["item"]]]],[5,"check_item_fn","","",N,[[["tyctxt"],["item"]]]],[5,"check_item_type","","",N,[[["tyctxt"],["item"]]]],[5,"check_impl","","",N,[[["tyctxt"],["item"],["ty"],["option"]]]],[5,"check_where_clauses","","Checks where clauses and inline bounds that are declared on def_id.",N,[[["tyctxt"],["fnctxt"],["span"],["defid"],["option",["ty"]]]]],[5,"check_fn_or_method","","",N,[[["tyctxt"],["fnctxt"],["span"],["polyfnsig"],["defid"],["vec"]]]],[5,"check_existential_types","","Checks \"defining uses\" of existential types to ensure that they meet the restrictions laid for \"higher-order pattern unification\". This ensures that inference is tractable. In particular, definitions of existential types can only use other generics as arguments, and they cannot repeat an argument. Example:",N,[[["tyctxt"],["fnctxt"],["defid"],["span"],["ty"]],["vec",["predicate"]]]],[5,"check_method_receiver","","",N,[[["fnctxt"],["methodsig"],["associateditem"],["ty"]]]],[5,"check_variances_for_type_defn","","",N,[[["tyctxt"],["item"],["generics"]]]],[5,"report_bivariance","","",N,[[["tyctxt"],["span"],["name"]]]],[5,"reject_shadowing_parameters","","",N,[[["tyctxt"],["defid"]]]],[5,"check_false_global_bounds","","Feature gates RFC 2056 - trivial bounds, checking for global bounds that aren't true.",N,[[["fnctxt"],["span"],["nodeid"]]]],[5,"error_392","","",N,[[["tyctxt"],["span"],["name"]],["diagnosticbuilder"]]],[5,"error_194","","",N,[[["tyctxt"],["span"],["span"],["str"]]]],[11,"with_fcx","","",53,[[["self"],["f"]]]],[11,"new","","",54,[[["tyctxt"]],["checktypewellformedvisitor"]]],[11,"nested_visit_map","","",54,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",54,[[["self"],["item"]]]],[11,"visit_trait_item","","",54,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",54,[[["self"],["implitem"]]]],[11,"non_enum_variant","rustc_typeck::check","",11,[[["self"],["variantdata"]],["adtvariant"]]],[11,"enum_variants","","",11,[[["self"],["enumdef"]],["vec",["adtvariant"]]]],[11,"impl_implied_bounds","","",11,[[["self"],["defid"],["span"]],["vec",["ty"]]]],[0,"cast","","Code for type-checking cast expressions.",N,N],[3,"CastCheck","rustc_typeck::check::cast","Reifies a cast check to be checked once we have full type information for a function context.",N,N],[12,"expr","","",57,N],[12,"expr_ty","","",57,N],[12,"cast_ty","","",57,N],[12,"cast_span","","",57,N],[12,"span","","",57,N],[4,"PointerKind","","The kind of pointer and associated metadata (thin, length or vtable) - we only allow casts between fat pointers if their metadata have the same kind.",N,N],[13,"Thin","","No metadata attached, ie pointer to sized type or foreign type",58,N],[13,"Vtable","","A trait object",58,N],[13,"Length","","Slice",58,N],[13,"OfProjection","","The unsize info of this projection",58,N],[13,"OfOpaque","","The unsize info of this opaque ty",58,N],[13,"OfParam","","The unsize info of this parameter",58,N],[4,"CastError","","",N,N],[13,"ErrorReported","","",59,N],[13,"CastToBool","","",59,N],[13,"CastToChar","","",59,N],[13,"DifferingKinds","","",59,N],[13,"SizedUnsizedCast","","Cast of thin to fat raw ptr (eg. `*const () as *const [u8]`)",59,N],[13,"IllegalCast","","",59,N],[13,"NeedDeref","","",59,N],[13,"NeedViaPtr","","",59,N],[13,"NeedViaThinPtr","","",59,N],[13,"NeedViaInt","","",59,N],[13,"NonScalar","","",59,N],[13,"UnknownExprPtrKind","","",59,N],[13,"UnknownCastPtrKind","","",59,N],[5,"make_invalid_casting_error","","",N,[[["session"],["span"],["ty"],["ty"],["fnctxt"]],["diagnosticbuilder"]]],[11,"clone","","",58,[[["self"]],["pointerkind"]]],[11,"eq","","",58,[[["self"],["pointerkind"]],["bool"]]],[11,"ne","","",58,[[["self"],["pointerkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",58,N],[11,"pointer_kind","rustc_typeck::check","Returns the kind of unsize information of t, or None if t is unknown.",11,[[["self"],["ty"],["span"]],["result",["option","errorreported"]]]],[11,"clone","rustc_typeck::check::cast","",59,[[["self"]],["casterror"]]],[11,"from","","",59,[[["errorreported"]],["self"]]],[11,"new","","",57,[[["fnctxt"],["expr"],["ty"],["ty"],["span"],["span"]],["result",["castcheck","errorreported"]]]],[11,"report_cast_error","","",57,[[["self"],["fnctxt"],["casterror"]]]],[11,"report_cast_to_unsized_type","","",57,[[["self"],["fnctxt"]]]],[11,"trivial_cast_lint","","",57,[[["self"],["fnctxt"]]]],[11,"check","","",57,[[["self"],["fnctxt"]]]],[11,"do_check","","Check a cast, and report an error if one exists. In some cases, this can return Ok and create type errors in the fcx rather than returning directly. coercion-cast is handled in check instead of here.",57,[[["self"],["fnctxt"]],["result",["castkind","casterror"]]]],[11,"check_ptr_ptr_cast","","",57,[[["self"],["fnctxt"],["typeandmut"],["typeandmut"]],["result",["castkind","casterror"]]]],[11,"check_fptr_ptr_cast","","",57,[[["self"],["fnctxt"],["typeandmut"]],["result",["castkind","casterror"]]]],[11,"check_ptr_addr_cast","","",57,[[["self"],["fnctxt"],["typeandmut"]],["result",["castkind","casterror"]]]],[11,"check_ref_cast","","",57,[[["self"],["fnctxt"],["typeandmut"],["typeandmut"]],["result",["castkind","casterror"]]]],[11,"check_addr_ptr_cast","","",57,[[["self"],["fnctxt"],["typeandmut"]],["result",["castkind","casterror"]]]],[11,"try_coercion_cast","","",57,[[["self"],["fnctxt"]],["bool"]]],[11,"type_is_known_to_be_sized","rustc_typeck::check","",11,[[["self"],["ty"],["span"]],["bool"]]],[0,"closure","","Code for type-checking closure expressions.",N,N],[3,"ExpectedSig","rustc_typeck::check::closure","What signature do we expect the closure to have from context?",N,N],[12,"cause_span","","Span that gave us this expectation, if we know that.",60,N],[12,"sig","","",60,N],[3,"ClosureSignatures","","",N,N],[12,"bound_sig","","",61,N],[12,"liberated_sig","","",61,N],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"check_expr_closure","rustc_typeck::check","",11,[[["self"],["expr"],["captureclause"],["fndecl"],["bodyid"],["option",["generatormovability"]],["expectation"]],["ty"]]],[11,"check_closure","","",11,[[["self"],["expr"],["option",["closurekind"]],["fndecl"],["body"],["option",["generatormovability"]],["option",["expectedsig"]]],["ty"]]],[11,"deduce_expectations_from_expected_type","","Given the expected type, figures out what it can about this closure we are about to type check:",11,N],[11,"deduce_expectations_from_obligations","","",11,N],[11,"deduce_sig_from_projection","","Given a projection like \"<F as Fn(X)>::Result == Y\", we can deduce everything we need to know about a closure.",11,[[["self"],["option",["span"]],["polyprojectionpredicate"]],["option",["expectedsig"]]]],[11,"self_type_matches_expected_vid","","",11,[[["self"],["polytraitref"],["tyvid"]],["option",["polytraitref"]]]],[11,"sig_of_closure","","",11,[[["self"],["defid"],["fndecl"],["body"],["option",["expectedsig"]]],["closuresignatures"]]],[11,"sig_of_closure_no_expectation","","If there is no expected signature, then we will convert the types that the user gave into a signature.",11,[[["self"],["defid"],["fndecl"],["body"]],["closuresignatures"]]],[11,"sig_of_closure_with_expectation","","Invoked to compute the signature of a closure expression. This combines any user-provided type annotations (e.g., `|x: u32| -> u32 { .. }`) with the expected signature.",11,[[["self"],["defid"],["fndecl"],["body"],["expectedsig"]],["closuresignatures"]]],[11,"sig_of_closure_with_mismatched_number_of_arguments","","",11,[[["self"],["defid"],["fndecl"],["body"],["expectedsig"]],["closuresignatures"]]],[11,"check_supplied_sig_against_expectation","","Enforce the user's types against the expectation.  See `sig_of_closure_with_expectation` for details on the overall strategy.",11,[[["self"],["fndecl"],["closuresignatures"]],["inferresult"]]],[11,"supplied_sig_of_closure","","If there is no expected signature, then we will convert the types that the user gave into a signature.",11,[[["self"],["fndecl"]],["polyfnsig"]]],[11,"error_sig_of_closure","","Converts the types that the user supplied, in case that doing so should yield an error, but returns back a signature where all parameters are of type `TyErr`.",11,[[["self"],["fndecl"]],["polyfnsig"]]],[11,"closure_sigs","","",11,[[["self"],["defid"],["body"],["polyfnsig"]],["closuresignatures"]]],[0,"callee","","",N,N],[3,"DeferredCallResolution","rustc_typeck::check::callee","",N,N],[12,"call_expr","","",62,N],[12,"callee_expr","","",62,N],[12,"adjusted_ty","","",62,N],[12,"adjustments","","",62,N],[12,"fn_sig","","",62,N],[12,"closure_def_id","","",62,N],[12,"closure_substs","","",62,N],[4,"CallStep","","",N,N],[13,"Builtin","","",63,N],[13,"DeferredClosure","","",63,N],[13,"Overloaded","","e.g. enum variant constructors",63,N],[5,"check_legal_trait_for_method_call","","Check that it is legal to call methods of the trait corresponding to `trait_id` (this only cares about the trait, not the specific method that is called)",N,[[["tyctxt"],["span"],["defid"]]]],[11,"check_call","rustc_typeck::check","",11,N],[11,"try_overloaded_call_step","","",11,[[["self"],["expr"],["expr"],["autoderef"]],["option",["callstep"]]]],[11,"try_overloaded_call_traits","","",11,[[["self"],["expr"],["ty"]],["option"]]],[11,"confirm_builtin_call","","",11,N],[11,"confirm_deferred_closure_call","","",11,N],[11,"confirm_overloaded_call","","",11,N],[11,"fmt","rustc_typeck::check::callee","",62,[[["self"],["formatter"]],["result"]]],[11,"resolve","","",62,[[["self"],["fnctxt"]]]],[0,"compare_method","rustc_typeck::check","",N,N],[5,"compare_impl_method","rustc_typeck::check::compare_method","Checks that a method from an impl conforms to the signature of the same method as declared in the trait.",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["traitref"],["option",["span"]]]]],[5,"compare_predicate_entailment","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["traitref"]],["result",["errorreported"]]]],[5,"check_region_bounds_on_impl_method","","",N,[[["tyctxt"],["span"],["associateditem"],["associateditem"],["generics"],["generics"],["substs"]],["result",["errorreported"]]]],[5,"extract_spans_for_error_reporting","","",N,N],[5,"compare_self_type","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["traitref"]],["result",["errorreported"]]]],[5,"compare_number_of_generics","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["option",["span"]]],["result",["errorreported"]]]],[5,"compare_number_of_method_arguments","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["option",["span"]]],["result",["errorreported"]]]],[5,"compare_synthetic_generics","","",N,[[["tyctxt"],["associateditem"],["associateditem"]],["result",["errorreported"]]]],[5,"compare_const_impl","","",N,[[["tyctxt"],["associateditem"],["span"],["associateditem"],["traitref"]]]],[0,"generator_interior","rustc_typeck::check","This calculates the types which has storage which lives across a suspension point in a generator from the perspective of typeck. The actual types used at runtime is calculated in `rustc_mir::transform::generator` and may be a subset of the types computed here.",N,N],[3,"InteriorVisitor","rustc_typeck::check::generator_interior","",N,N],[12,"fcx","","",64,N],[12,"types","","",64,N],[12,"region_scope_tree","","",64,N],[12,"expr_count","","",64,N],[5,"resolve_interior","","",N,[[["fnctxt"],["defid"],["bodyid"],["ty"]]]],[11,"record","","",64,[[["self"],["ty"],["option",["scope"]],["option",["expr"]],["span"]]]],[11,"nested_visit_map","","",64,[[["self"]],["nestedvisitormap"]]],[11,"visit_pat","","",64,[[["self"],["pat"]]]],[11,"visit_expr","","",64,[[["self"],["expr"]]]],[0,"intrinsic","rustc_typeck::check","Type-checking for the rust-intrinsic and platform-intrinsic intrinsics that the compiler exposes.",N,N],[5,"equate_intrinsic_type","rustc_typeck::check::intrinsic","",N,[[["tyctxt"],["foreignitem"],["usize"],["abi"],["unsafety"],["vec",["ty"]],["ty"]]]],[5,"check_intrinsic_type","","Remember to add all intrinsics here, in librustc_codegen_llvm/intrinsic.rs, and in libcore/intrinsics.rs",N,[[["tyctxt"],["foreignitem"]]]],[5,"check_platform_intrinsic_type","","Type-check `extern \"platform-intrinsic\" { ... }` functions.",N,[[["tyctxt"],["foreignitem"]]]],[5,"match_intrinsic_type_to_type","","",N,[[["tyctxt"],["str"],["span"],["fxhashmap"],["type"],["ty"]]]],[0,"op","rustc_typeck::check","Code related to processing overloaded binary and unary operators.",N,N],[4,"BinOpCategory","rustc_typeck::check::op","",N,N],[13,"Shortcircuit","","&&, || -- cannot be overridden",65,N],[13,"Shift","","<<, >> -- when shifting a single integer, rhs can be any integer type. For simd, types must match.",65,N],[13,"Math","","+, -, etc -- takes equal types, produces same type as input, applicable to ints/floats/simd",65,N],[13,"Bitwise","","&, |, ^ -- takes equal types, produces same type as input, applicable to ints/floats/simd/bool",65,N],[13,"Comparison","","==, !=, etc -- takes equal types, produces bools, except for simd, which produce the input type",65,N],[4,"IsAssign","","Whether the binary operation is an assignment (`a += b`), or not (`a + b`)",N,N],[13,"No","","",66,N],[13,"Yes","","",66,N],[4,"Op","","",N,N],[13,"Binary","","",67,N],[13,"Unary","","",67,N],[5,"is_builtin_binop","","Returns true if this is a built-in arithmetic operation (e.g. u32 + u32, i16x4 == i16x4) and false if these types would have to be overloaded to be legal. There are two reasons that we distinguish builtin operations from overloaded ones (vs trying to drive everything uniformly through the trait system and intrinsics or something like that):",N,[[["ty"],["ty"],["binop"]],["bool"]]],[11,"check_binop_assign","rustc_typeck::check","Check a `a <op>= b`",11,[[["self"],["expr"],["binop"],["expr"],["expr"]],["ty"]]],[11,"check_binop","","Check a potentially overloaded binary operator.",11,[[["self"],["expr"],["binop"],["expr"],["expr"]],["ty"]]],[11,"enforce_builtin_binop_types","","",11,[[["self"],["expr"],["ty"],["expr"],["ty"],["binop"]],["ty"]]],[11,"check_overloaded_binop","","",11,N],[11,"check_str_addition","","",11,[[["self"],["expr"],["expr"],["expr"],["ty"],["ty"],["diagnosticbuilder"],["bool"]],["bool"]]],[11,"check_user_unop","","",11,[[["self"],["expr"],["ty"],["unop"]],["ty"]]],[11,"lookup_op_method","","",11,N],[11,"from","rustc_typeck::check::op","",65,[[["binop"]],["binopcategory"]]],[11,"clone","","",66,[[["self"]],["isassign"]]],[11,"fmt","","",66,[[["self"],["formatter"]],["result"]]],[11,"eq","","",66,[[["self"],["isassign"]],["bool"]]],[11,"clone","","",67,[[["self"]],["op"]]],[11,"fmt","","",67,[[["self"],["formatter"]],["result"]]],[11,"clone","rustc_typeck::check","",5,[[["self"]],["maybeinprogresstables"]]],[11,"borrow","","",5,[[["self"]],["ref",["typecktables"]]]],[11,"borrow_mut","","",5,[[["self"]],["refmut",["typecktables"]]]],[11,"deref","","",6,N],[11,"clone","","",16,[[["self"]],["expectation"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"adjust_for_branches","","",16,[[["self"],["fnctxt"]],["expectation"]]],[11,"rvalue_hint","","Provide an expectation for an rvalue expression given an optional hint, which is not required for type safety (the resulting type might be checked higher up, as is the case with `&expr` and `box expr`), but is useful in determining the concrete type.",16,[[["fnctxt"],["ty"]],["expectation"]]],[11,"resolve","","",16,[[["self"],["fnctxt"]],["expectation"]]],[11,"to_option","","",16,[[["self"],["fnctxt"]],["option",["ty"]]]],[11,"only_has_type","","It sometimes happens that we want to turn an expectation into a hard constraint (i.e., something that must be satisfied for the program to type-check). `only_has_type` will return such a constraint, if it exists.",16,[[["self"],["fnctxt"]],["option",["ty"]]]],[11,"coercion_target_type","","Like `only_has_type`, but instead of returning `None` if no hard constraint exists, creates a fresh type variable.",16,[[["self"],["fnctxt"],["span"]],["ty"]]],[11,"clone","","",17,[[["self"]],["needs"]]],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"eq","","",17,[[["self"],["needs"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",17,N],[11,"maybe_mut_place","","",17,[[["mutability"]],["self"]]],[11,"clone","","",7,[[["self"]],["unsafetystate"]]],[11,"function","","",7,[[["unsafety"],["nodeid"]],["unsafetystate"]]],[11,"recurse","","",7,[[["self"],["block"]],["unsafetystate"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"clone","","",18,[[["self"]],["placeop"]]],[11,"clone","","",19,[[["self"]],["diverges"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"eq","","",19,[[["self"],["diverges"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"partial_cmp","","",19,[[["self"],["diverges"]],["option",["ordering"]]]],[11,"cmp","","",19,[[["self"],["diverges"]],["ordering"]]],[11,"bitand","","",19,[[["self"],["self"]],["self"]]],[11,"bitor","","",19,[[["self"],["self"]],["self"]]],[11,"bitand_assign","","",19,[[["self"],["self"]]]],[11,"bitor_assign","","",19,[[["self"],["self"]]]],[11,"always","","",19,[[["self"]],["bool"]]],[11,"find_breakable","","",9,[[["self"],["nodeid"]],["breakablectxt"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"deref","","",11,N],[11,"build","","",6,[[["tyctxt"],["defid"]],["inheritedbuilder"]]],[11,"enter","","",12,[[["self"],["f"]],["r"]]],[11,"new","","",6,[[["inferctxt"],["defid"]],["self"]]],[11,"register_predicate","","",6,[[["self"],["predicateobligation"]]]],[11,"register_predicates","","",6,[[["self"],["i"]]]],[11,"register_infer_ok_obligations","","",6,[[["self"],["inferok"]],["t"]]],[11,"normalize_associated_types_in","","",6,[[["self"],["span"],["nodeid"],["paramenv"],["t"]],["t"]]],[11,"visit_item","","",13,[[["self"],["item"]]]],[11,"visit_trait_item","","",13,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",13,[[["self"],["implitem"]]]],[11,"assign","","",14,[[["self"],["span"],["nodeid"],["option",["ty"]]],["ty"]]],[11,"nested_visit_map","","",14,[[["self"]],["nestedvisitormap"]]],[11,"visit_local","","",14,[[["self"],["local"]]]],[11,"visit_pat","","",14,[[["self"],["pat"]]]],[11,"visit_fn","","",14,[[["self"],["fnkind"],["fndecl"],["bodyid"],["span"],["nodeid"]]]],[11,"tcx","","",11,[[["self"]],["tyctxt"]]],[11,"get_type_parameter_bounds","","",11,[[["self"],["span"],["defid"]],["genericpredicates"]]],[11,"re_infer","","",11,[[["self"],["span"],["option",["genericparamdef"]]],["option",["region"]]]],[11,"ty_infer","","",11,[[["self"],["span"]],["ty"]]],[11,"ty_infer_for_def","","",11,[[["self"],["genericparamdef"],["span"]],["ty"]]],[11,"projected_ty_from_poly_trait_ref","","",11,[[["self"],["span"],["defid"],["polytraitref"]],["ty"]]],[11,"normalize_ty","","",11,[[["self"],["span"],["ty"]],["ty"]]],[11,"set_tainted_by_errors","","",11,[[["self"]]]],[11,"record_ty","","",11,[[["self"],["hirid"],["ty"],["span"]]]],[11,"clone","","",20,[[["self"]],["tupleargumentsflag"]]],[11,"assert_receiver_is_total_eq","","",20,N],[11,"eq","","",20,[[["self"],["tupleargumentsflag"]],["bool"]]],[11,"new","","",11,[[["inherited"],["paramenv"],["nodeid"]],["fnctxt"]]],[11,"sess","","",11,[[["self"]],["session"]]],[11,"err_count_since_creation","","",11,[[["self"]],["usize"]]],[11,"warn_if_unreachable","","Produce warning on the given node, if the current point in the function is unreachable, and there hasn't been another warning.",11,[[["self"],["nodeid"],["span"],["str"]]]],[11,"cause","","",11,[[["self"],["span"],["obligationcausecode"]],["obligationcause"]]],[11,"misc","","",11,[[["self"],["span"]],["obligationcause"]]],[11,"resolve_type_vars_with_obligations","","Resolves type variables in `ty` if possible. Unlike the infcx version (resolve_type_vars_if_possible), this version will also select obligations if it seems useful, in an effort to get more type information.",11,[[["self"],["ty"]],["ty"]]],[11,"record_deferred_call_resolution","","",11,[[["self"],["defid"],["deferredcallresolution"]]]],[11,"remove_deferred_call_resolutions","","",11,[[["self"],["defid"]],["vec",["deferredcallresolution"]]]],[11,"tag","","",11,[[["self"]],["string"]]],[11,"local_ty","","",11,[[["self"],["span"],["nodeid"]],["ty"]]],[11,"write_ty","","",11,[[["self"],["hirid"],["ty"]]]],[11,"write_field_index","","",11,[[["self"],["nodeid"],["usize"]]]],[11,"write_method_call","","",11,[[["self"],["hirid"],["methodcallee"]]]],[11,"write_substs","","",11,[[["self"],["hirid"],["substs"]]]],[11,"write_user_substs_from_substs","","Given the substs that we just converted from the HIR, try to canonicalize them and store them as user-given substitutions (i.e., substitutions that must be respected by the NLL check).",11,[[["self"],["hirid"],["substs"]]]],[11,"write_user_substs","","",11,[[["self"],["hirid"],["canonicalsubsts"]]]],[11,"apply_adjustments","","",11,[[["self"],["expr"],["vec",["adjustment"]]]]],[11,"instantiate_type_scheme","","Basically whenever we are converting from a type scheme into the fn body space, we always want to normalize associated types as well. This function combines the two.",11,[[["self"],["span"],["substs"],["t"]],["t"]]],[11,"instantiate_bounds","","As `instantiate_type_scheme`, but for the bounds found in a generic type scheme.",11,[[["self"],["span"],["defid"],["substs"]],["instantiatedpredicates"]]],[11,"instantiate_opaque_types_from_return_value","","Replace the opaque types from the return value of the function with type variables and records the `OpaqueTypeMap` for later use during writeback. See `InferCtxt::instantiate_opaque_types` for more details.",11,[[["self"],["nodeid"],["t"]],["t"]]],[11,"normalize_associated_types_in","","",11,[[["self"],["span"],["t"]],["t"]]],[11,"normalize_associated_types_in_as_infer_ok","","",11,[[["self"],["span"],["t"]],["inferok"]]],[11,"require_type_meets","","",11,[[["self"],["ty"],["span"],["obligationcausecode"],["defid"]]]],[11,"require_type_is_sized","","",11,[[["self"],["ty"],["span"],["obligationcausecode"]]]],[11,"register_bound","","",11,[[["self"],["ty"],["defid"],["obligationcause"]]]],[11,"to_ty","","",11,[[["self"],["ty"]],["ty"]]],[11,"node_ty","","",11,[[["self"],["hirid"]],["ty"]]],[11,"register_wf_obligation","","Registers an obligation for checking later, during regionck, that the type `ty` must outlive the region `r`.",11,[[["self"],["ty"],["span"],["obligationcausecode"]]]],[11,"add_wf_bounds","","Registers obligations that all types appearing in `substs` are well-formed.",11,[[["self"],["substs"],["expr"]]]],[11,"add_obligations_for_parameters","","Given a fully substituted set of bounds (`generic_bounds`), and the values with which each type/region parameter was instantiated (`substs`), creates and registers suitable trait/region obligations.",11,[[["self"],["obligationcause"],["instantiatedpredicates"]]]],[11,"field_ty","","",11,[[["self"],["span"],["fielddef"],["substs"]],["ty"]]],[11,"check_casts","","",11,[[["self"]]]],[11,"resolve_generator_interiors","","",11,[[["self"],["defid"]]]],[11,"fallback_if_possible","","",11,[[["self"],["ty"]],["bool"]]],[11,"select_all_obligations_or_error","","",11,[[["self"]]]],[11,"select_obligations_where_possible","","Select as many obligations as we can at present.",11,[[["self"],["bool"]]]],[11,"is_place_expr","","",11,[[["self"],["expr"]],["bool"]]],[11,"make_overloaded_place_return_type","","For the overloaded place expressions (`*x`, `x[3]`), the trait returns a type of `&T`, but the actual type we assign to the expression is `T`. So this function just peels off the return type by one layer to yield `T`.",11,[[["self"],["methodcallee"]],["typeandmut"]]],[11,"lookup_indexing","","",11,[[["self"],["expr"],["expr"],["ty"],["ty"],["needs"]],["option"]]],[11,"try_index_step","","To type-check `base_expr[index_expr]`, we progressively autoderef (and otherwise adjust) `base_expr`, looking for a type which either supports builtin indexing or overloaded indexing. This loop implements one step in that search; the autoderef loop is implemented by `lookup_indexing`.",11,[[["self"],["expr"],["expr"],["autoderef"],["needs"],["ty"]],["option"]]],[11,"resolve_place_op","","",11,N],[11,"try_overloaded_place_op","","",11,N],[11,"check_method_argument_types","","",11,N],[11,"check_argument_types","","Generic function that factors out common logic from function calls, method calls and overloaded operators.",11,N],[11,"err_args","","",11,[[["self"],["usize"]],["vec",["ty"]]]],[11,"check_lit","","",11,[[["self"],["lit"],["expectation"]],["ty"]]],[11,"check_expr_eq_type","","",11,[[["self"],["expr"],["ty"]]]],[11,"check_expr_has_type_or_error","","",11,[[["self"],["expr"],["ty"]],["ty"]]],[11,"check_expr_meets_expectation_or_error","","",11,[[["self"],["expr"],["expectation"]],["ty"]]],[11,"check_expr_coercable_to_type","","",11,[[["self"],["expr"],["ty"]],["ty"]]],[11,"check_expr_with_hint","","",11,[[["self"],["expr"],["ty"]],["ty"]]],[11,"check_expr_with_expectation","","",11,[[["self"],["expr"],["expectation"]],["ty"]]],[11,"check_expr","","",11,[[["self"],["expr"]],["ty"]]],[11,"check_expr_with_needs","","",11,[[["self"],["expr"],["needs"]],["ty"]]],[11,"impl_self_ty","","",11,[[["self"],["span"],["defid"]],["typeandsubsts"]]],[11,"expected_inputs_for_expected_output","","Unifies the output type with the expected type early, for more coercions and forward type information on the input expressions.",11,N],[11,"check_method_call","","",11,N],[11,"check_return_expr","","",11,[[["self"],["expr"]]]],[11,"check_then_else","","",11,[[["self"],["expr"],["expr"],["option",["expr"]],["span"],["expectation"]],["ty"]]],[11,"check_field","","",11,[[["self"],["expr"],["needs"],["expr"],["ident"]],["ty"]]],[11,"suggest_field_name","","",11,[[["variantdef"],["str"],["vec",["localinternedstring"]]],["option",["symbol"]]]],[11,"available_field_names","","",11,[[["self"],["variantdef"]],["vec",["name"]]]],[11,"name_series_display","","",11,[[["self"],["vec",["name"]]],["string"]]],[11,"no_such_field_err","","",11,[[["self"],["span"],["t"],["tys"]],["diagnosticbuilder"]]],[11,"report_unknown_field","","",11,N],[11,"check_expr_struct_fields","","",11,N],[11,"check_struct_fields_on_error","","",11,N],[11,"check_struct_path","","",11,[[["self"],["qpath"],["nodeid"]],["option"]]],[11,"check_expr_struct","","",11,N],[11,"check_expr_with_expectation_and_needs","","Invariant: If an expression has any sub-expressions that result in a type error, inspecting that expression's type with `ty.references_error()` will return true. Likewise, if an expression is known to diverge, inspecting its type with `ty::type_is_bot` will return true (n.b.: since Rust is strict, | can appear in the type of an expression that does not, itself, diverge: for example, fn() -> |.) Note that inspecting a type's structure directly may expose the fact that there are actually multiple representations for `Error`, so avoid that when err needs to be handled differently.",11,[[["self"],["expr"],["expectation"],["needs"]],["ty"]]],[11,"check_expr_kind","","",11,[[["self"],["expr"],["expectation"],["needs"]],["ty"]]],[11,"finish_resolving_struct_path","","",11,N],[11,"resolve_ty_and_def_ufcs","","",11,N],[11,"check_decl_initializer","","",11,[[["self"],["local"],["expr"]],["ty"]]],[11,"check_decl_local","","",11,[[["self"],["local"]]]],[11,"check_stmt","","",11,[[["self"],["stmt"]]]],[11,"check_block_no_value","","",11,[[["self"],["block"]]]],[11,"check_block_with_expected","","",11,[[["self"],["block"],["expectation"]],["ty"]]],[11,"get_fn_decl","","Given a `NodeId`, return the `FnDecl` of the method it is enclosed by and whether a suggestion can be made, `None` otherwise.",11,[[["self"],["nodeid"]],["option"]]],[11,"suggest_mismatched_types_on_tail","","On implicit return expressions with mismatched types, provide the following suggestions:",11,[[["self"],["diagnosticbuilder"],["expr"],["ty"],["ty"],["span"],["nodeid"]]]],[11,"suggest_ref_or_into","","",11,[[["self"],["diagnosticbuilder"],["expr"],["ty"],["ty"]]]],[11,"suggest_missing_semicolon","","A common error is to forget to add a semicolon at the end of a block:",11,[[["self"],["diagnosticbuilder"],["expr"],["ty"],["span"]]]],[11,"suggest_missing_return_type","","A possible error is to forget to add a return type that is needed:",11,[[["self"],["diagnosticbuilder"],["fndecl"],["ty"],["ty"],["bool"]]]],[11,"consider_hint_about_removing_semicolon","","A common error is to add an extra semicolon:",11,[[["self"],["block"],["ty"],["diagnosticbuilder"]]]],[11,"def_ids_for_path_segments","","",11,N],[11,"instantiate_value_path","","",11,N],[11,"check_rustc_args_require_const","","",11,[[["self"],["defid"],["nodeid"],["span"]]]],[11,"structurally_resolved_type","","",11,[[["self"],["span"],["ty"]],["ty"]]],[11,"with_breakable_ctxt","","",11,N],[0,"check_unused","rustc_typeck","",N,N],[3,"CheckVisitor","rustc_typeck::check_unused","",N,N],[12,"tcx","","",68,N],[12,"used_trait_imports","","",68,N],[3,"CollectExternCrateVisitor","","",N,N],[12,"tcx","","",69,N],[12,"crates_to_lint","","",69,N],[3,"ExternCrateToLint","","",N,N],[12,"def_id","","def-id of the extern crate",70,N],[12,"span","","span from the item",70,N],[12,"orig_name","","if `Some`, then this is renamed (`extern crate orig_name as crate_name`), and -- perhaps surprisingly -- this stores the original name (`item.name` will contain the new name)",70,N],[12,"warn_if_unused","","if `false`, the original name started with `_`, so we shouldn't lint about it going unused (but we should still emit idiom lints).",70,N],[5,"check_crate","","",N,[[["tyctxt"]]]],[5,"unused_crates_lint","","",N,[[["tyctxt"]]]],[11,"visit_item","","",68,[[["self"],["item"]]]],[11,"visit_trait_item","","",68,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",68,[[["self"],["implitem"]]]],[11,"check_import","","",68,[[["self"],["nodeid"],["span"]]]],[11,"visit_item","","",69,[[["self"],["item"]]]],[11,"visit_trait_item","","",69,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",69,[[["self"],["implitem"]]]],[0,"coherence","rustc_typeck","",N,N],[5,"check_impl","rustc_typeck::coherence","",N,[[["tyctxt"],["nodeid"]]]],[5,"enforce_trait_manually_implementable","","",N,[[["tyctxt"],["defid"],["defid"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"coherent_trait","","",N,[[["tyctxt"],["defid"]]]],[5,"check_coherence","","",N,[[["tyctxt"]]]],[5,"check_impl_overlap","","Overlap: No two impls for the same trait are implemented for the same type. Likewise, no two inherent impls for a given type constructor provide a method with the same name.",N,[[["tyctxt"],["nodeid"]]]],[0,"builtin","","Check properties that are required by built-in traits and set up data structures required by type-checking/codegen.",N,N],[3,"Checker","rustc_typeck::coherence::builtin","",N,N],[12,"tcx","","",71,N],[12,"trait_def_id","","",71,N],[5,"check_trait","","",N,[[["tyctxt"],["defid"]]]],[5,"visit_implementation_of_drop","","",N,[[["tyctxt"],["defid"]]]],[5,"visit_implementation_of_copy","","",N,[[["tyctxt"],["defid"]]]],[5,"visit_implementation_of_coerce_unsized","","",N,[[["tyctxt"],["defid"]]]],[5,"coerce_unsized_info","","",N,[[["tyctxt"],["defid"]],["coerceunsizedinfo"]]],[11,"check","","",71,[[["self"],["option",["defid"]],["f"]],["self"]]],[0,"inherent_impls","rustc_typeck::coherence","The code in this module gathers up all of the inherent impls in the current crate and organizes them in a map. It winds up touching the whole crate and thus must be recomputed completely for any change, but it is very cheap to compute. In practice, most code in the compiler never directly requests this map. Instead, it requests the inherent impls specific to some type (via `tcx.inherent_impls(def_id)`). That value, however, is computed by selecting an idea from this table.",N,N],[3,"InherentCollect","rustc_typeck::coherence::inherent_impls","",N,N],[12,"tcx","","",72,N],[12,"impls_map","","",72,N],[5,"crate_inherent_impls","","On-demand query: yields a map containing all types mapped to their inherent impls.",N,[[["tyctxt"],["cratenum"]],["crateinherentimpls"]]],[5,"inherent_impls","","On-demand query: yields a vector of the inherent impls for a specific type.",N,[[["tyctxt"],["defid"]],["lrc",["vec"]]]],[11,"visit_item","","",72,[[["self"],["item"]]]],[11,"visit_trait_item","","",72,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",72,[[["self"],["implitem"]]]],[11,"check_def_id","","",72,[[["self"],["item"],["defid"]]]],[11,"check_primitive_impl","","",72,[[["self"],["defid"],["option",["defid"]],["option",["defid"]],["str"],["str"],["span"]]]],[0,"inherent_impls_overlap","rustc_typeck::coherence","",N,N],[3,"InherentOverlapChecker","rustc_typeck::coherence::inherent_impls_overlap","",N,N],[12,"tcx","","",73,N],[5,"crate_inherent_impls_overlap_check","","",N,[[["tyctxt"],["cratenum"]]]],[11,"check_for_common_items_in_impls","","",73,[[["self"],["defid"],["defid"],["overlapresult"],["bool"]]]],[11,"check_for_overlapping_inherent_impls","","",73,[[["self"],["defid"]]]],[11,"visit_item","","",73,[[["self"],["item"]]]],[11,"visit_trait_item","","",73,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",73,[[["self"],["implitem"]]]],[0,"orphan","rustc_typeck::coherence","Orphan checker: every impl either implements a trait defined in this crate or pertains to a type defined in this crate.",N,N],[3,"OrphanChecker","rustc_typeck::coherence::orphan","",N,N],[12,"tcx","","",74,N],[5,"check","","",N,[[["tyctxt"]]]],[11,"visit_item","","Checks exactly one impl for orphan rules and other such restrictions.  In this fn, it can happen that multiple errors apply to a specific impl, so just return after reporting one to prevent inundating the user with a bunch of similar error reports.",74,[[["self"],["item"]]]],[11,"visit_trait_item","","",74,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",74,[[["self"],["implitem"]]]],[0,"unsafety","rustc_typeck::coherence","Unsafety checker: every impl either implements a trait defined in this crate or pertains to a type defined in this crate.",N,N],[3,"UnsafetyChecker","rustc_typeck::coherence::unsafety","",N,N],[12,"tcx","","",75,N],[5,"check","","",N,[[["tyctxt"]]]],[11,"check_unsafety_coherence","","",75,[[["self"],["item"],["option",["generics"]],["unsafety"],["implpolarity"]]]],[11,"visit_item","","",75,[[["self"],["item"]]]],[11,"visit_trait_item","","",75,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",75,[[["self"],["implitem"]]]],[0,"collect","rustc_typeck","\"Collection\" is the process of determining the type and other external details of each item in Rust. Collection is specifically concerned with interprocedural things -- for example, for a function definition, collection will figure out the type and signature of the function, but it will not visit the body of the function in any way, nor examine type annotations on local variables (that's the job of type checking).",N,N],[3,"ItemCtxt","rustc_typeck::collect","Context specific to some particular item. This is what implements AstConv. It has information about the predicates that are defined on the trait. Unfortunately, this predicate information is available in various different forms at various points in the process. So we can't just store a pointer to e.g. the AST or the parsed ty form, we have to be more flexible. To this end, the `ItemCtxt` is parameterized by a `DefId` that it uses to satisfy `get_type_parameter_bounds` requests, drawing the information from the AST (`hir::Generics`), recursively.",N,N],[12,"tcx","","",76,N],[12,"item_def_id","","",76,N],[3,"CollectItemTypesVisitor","","",N,N],[12,"tcx","","",77,N],[4,"SizedByDefault","","",N,N],[13,"Yes","","",78,N],[13,"No","","",78,N],[5,"collect_item_types","","",N,[[["tyctxt"]]]],[5,"provide","","",N,[[["providers"]]]],[5,"type_param_predicates","","",N,N],[5,"is_param","","Tests whether this is the AST for a reference to the type parameter with id `param_id`. We use this so as to avoid running `ast_ty_to_ty`, because we want to avoid triggering an all-out conversion of the type to avoid inducing unnecessary cycles.",N,[[["tyctxt"],["ty"],["nodeid"]],["bool"]]],[5,"convert_item","","",N,[[["tyctxt"],["nodeid"]]]],[5,"convert_trait_item","","",N,[[["tyctxt"],["nodeid"]]]],[5,"convert_impl_item","","",N,[[["tyctxt"],["nodeid"]]]],[5,"convert_variant_ctor","","",N,[[["tyctxt"],["nodeid"]]]],[5,"convert_enum_variant_types","","",N,N],[5,"convert_variant","","",N,[[["tyctxt"],["defid"],["name"],["variantdiscr"],["variantdata"],["adtkind"]],["variantdef"]]],[5,"adt_def","","",N,[[["tyctxt"],["defid"]],["adtdef"]]],[5,"super_predicates_of","","Ensures that the super-predicates of the trait with def-id trait_def_id are converted and stored. This also ensures that the transitive super-predicates are converted;",N,[[["tyctxt"],["defid"]],["genericpredicates"]]],[5,"trait_def","","",N,[[["tyctxt"],["defid"]],["traitdef"]]],[5,"has_late_bound_regions","","",N,[[["tyctxt"],["node"]],["option",["span"]]]],[5,"generics_of","","",N,[[["tyctxt"],["defid"]],["generics"]]],[5,"report_assoc_ty_on_inherent_impl","","",N,[[["tyctxt"],["span"]]]],[5,"type_of","","",N,[[["tyctxt"],["defid"]],["ty"]]],[5,"find_existential_constraints","","",N,[[["tyctxt"],["defid"]],["ty"]]],[5,"fn_sig","","",N,[[["tyctxt"],["defid"]],["polyfnsig"]]],[5,"impl_trait_ref","","",N,[[["tyctxt"],["defid"]],["option",["traitref"]]]],[5,"impl_polarity","","",N,[[["tyctxt"],["defid"]],["implpolarity"]]],[5,"is_unsized","","",N,N],[5,"early_bound_lifetimes_from_generics","","Returns the early-bound lifetimes declared in this generics listing.  For anything other than fns/methods, this is just all the lifetimes that are declared. For fns or methods, we have to screen out those that do not appear in any where-clauses etc using `resolve_lifetime::early_bound_lifetimes`.",N,N],[5,"predicates_defined_on","","",N,[[["tyctxt"],["defid"]],["genericpredicates"]]],[5,"predicates_of","","",N,[[["tyctxt"],["defid"]],["genericpredicates"]]],[5,"explicit_predicates_of","","",N,[[["tyctxt"],["defid"]],["genericpredicates"]]],[5,"compute_bounds","","Translate the AST's notion of ty param bounds (which are an enum consisting of a newtyped Ty or a region) to ty's notion of ty param bounds, which can either be user-defined traits, or the built-in trait (formerly known as kind): Send.",N,N],[5,"predicates_from_bound","","Converts a specific GenericBound from the AST into a set of predicates that apply to the self-type. A vector is returned because this can be anywhere from 0 predicates (`T:?Sized` adds no predicates) to 1 (`T:Foo`) to many (`T:Bar<X=i32>` adds `T:Bar` and `<T as Bar>::X == i32`).",N,[[["astconv"],["ty"],["genericbound"]],["vec",["predicate"]]]],[5,"compute_sig_of_foreign_fn_decl","","",N,[[["tyctxt"],["defid"],["fndecl"],["abi"]],["polyfnsig"]]],[5,"is_foreign_item","","",N,[[["tyctxt"],["defid"]],["bool"]]],[5,"from_target_feature","","",N,[[["tyctxt"],["defid"],["attribute"],["fxhashmap"],["vec"]]]],[5,"linkage_by_name","","",N,[[["tyctxt"],["defid"],["str"]],["linkage"]]],[5,"codegen_fn_attrs","","",N,[[["tyctxt"],["defid"]],["codegenfnattrs"]]],[22,"","","",N,N],[11,"nested_visit_map","","",77,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",77,[[["self"],["item"]]]],[11,"visit_generics","","",77,[[["self"],["generics"]]]],[11,"visit_expr","","",77,[[["self"],["expr"]]]],[11,"visit_trait_item","","",77,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",77,[[["self"],["implitem"]]]],[11,"new","","",76,[[["tyctxt"],["defid"]],["itemctxt"]]],[11,"to_ty","","",76,[[["self"],["ty"]],["ty"]]],[11,"tcx","","",76,[[["self"]],["tyctxt"]]],[11,"get_type_parameter_bounds","","",76,[[["self"],["span"],["defid"]],["genericpredicates"]]],[11,"re_infer","","",76,[[["self"],["span"],["option",["genericparamdef"]]],["option",["region"]]]],[11,"ty_infer","","",76,[[["self"],["span"]],["ty"]]],[11,"projected_ty_from_poly_trait_ref","","",76,[[["self"],["span"],["defid"],["polytraitref"]],["ty"]]],[11,"normalize_ty","","",76,[[["self"],["span"],["ty"]],["ty"]]],[11,"set_tainted_by_errors","","",76,[[["self"]]]],[11,"record_ty","","",76,[[["self"],["hirid"],["ty"],["span"]]]],[11,"type_parameter_bounds_in_generics","","Find bounds from hir::Generics. This requires scanning through the AST. We do this to avoid having to convert all the bounds, which would create artificial cycles. Instead we can only convert the bounds for a type parameter `X` if `X::Foo` is used.",76,[[["self"],["generics"],["nodeid"],["ty"]],["vec",["predicate"]]]],[0,"constrained_type_params","rustc_typeck","",N,N],[3,"Parameter","rustc_typeck::constrained_type_params","",N,N],[12,"0","","",79,N],[3,"ParameterCollector","","",N,N],[12,"parameters","","",80,N],[12,"include_nonconstraining","","",80,N],[5,"parameters_for_impl","","Return the set of parameters constrained by the impl header.",N,[[["ty"],["option",["traitref"]]],["fxhashset",["parameter"]]]],[5,"parameters_for","","If `include_projections` is false, returns the list of parameters that are constrained by `t` - i.e. the value of each parameter in the list is uniquely determined by `t` (see RFC 447). If it is true, return the list of parameters whose values are needed in order to constrain `ty` - these differ, with the latter being a superset, in the presence of projections.",N,[[["t"],["bool"]],["vec",["parameter"]]]],[5,"identify_constrained_type_params","","",N,N],[5,"setup_constraining_predicates","","Order the predicates in `predicates` such that each parameter is constrained before it is used, if that is possible, and add the parameters so constrained to `input_parameters`. For example, imagine the following impl:",N,N],[11,"clone","","",79,[[["self"]],["parameter"]]],[11,"eq","","",79,[[["self"],["parameter"]],["bool"]]],[11,"ne","","",79,[[["self"],["parameter"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",79,N],[11,"hash","","",79,N],[11,"fmt","","",79,[[["self"],["formatter"]],["result"]]],[11,"from","","",79,[[["paramty"]],["self"]]],[11,"from","","",79,[[["earlyboundregion"]],["self"]]],[11,"visit_ty","","",80,[[["self"],["ty"]],["bool"]]],[11,"visit_region","","",80,[[["self"],["region"]],["bool"]]],[0,"structured_errors","rustc_typeck","",N,N],[3,"VariadicError","rustc_typeck::structured_errors","",N,N],[12,"sess","","",81,N],[12,"span","","",81,N],[12,"t","","",81,N],[12,"cast_ty","","",81,N],[3,"SizedUnsizedCastError","","",N,N],[12,"sess","","",82,N],[12,"span","","",82,N],[12,"expr_ty","","",82,N],[12,"cast_ty","","",82,N],[8,"StructuredDiagnostic","","",N,N],[10,"session","","",83,[[["self"]],["session"]]],[10,"code","","",83,[[["self"]],["diagnosticid"]]],[10,"common","","",83,[[["self"]],["diagnosticbuilder"]]],[11,"diagnostic","","",83,[[["self"]],["diagnosticbuilder"]]],[11,"regular","","",83,[[["self"],["diagnosticbuilder"]],["diagnosticbuilder"]]],[11,"extended","","",83,[[["self"],["diagnosticbuilder"]],["diagnosticbuilder"]]],[11,"new","","",81,[[["session"],["span"],["ty"],["str"]],["variadicerror"]]],[11,"session","","",81,[[["self"]],["session"]]],[11,"code","","",81,[[["self"]],["diagnosticid"]]],[11,"common","","",81,[[["self"]],["diagnosticbuilder"]]],[11,"extended","","",81,[[["self"],["diagnosticbuilder"]],["diagnosticbuilder"]]],[11,"new","","",82,[[["session"],["span"],["ty"],["string"]],["sizedunsizedcasterror"]]],[11,"session","","",82,[[["self"]],["session"]]],[11,"code","","",82,[[["self"]],["diagnosticid"]]],[11,"common","","",82,[[["self"]],["diagnosticbuilder"]]],[11,"extended","","",82,[[["self"],["diagnosticbuilder"]],["diagnosticbuilder"]]],[0,"impl_wf_check","rustc_typeck","This pass enforces various \"well-formedness constraints\" on impls. Logically, it is part of wfcheck -- but we do it early so that we can stop compilation afterwards, since part of the trait matching infrastructure gets very grumpy if these conditions don't hold. In particular, if there are type parameters that are not part of the impl, then coherence will report strange inference ambiguity errors; if impls have duplicate items, we get misleading specialization errors. These things can (and probably should) be fixed, but for the moment it's easier to do these checks early.",N,N],[3,"ImplWfCheck","rustc_typeck::impl_wf_check","",N,N],[12,"tcx","","",84,N],[5,"impl_wf_check","","Checks that all the type/lifetime parameters on an impl also appear in the trait ref or self-type (or are constrained by a where-clause). These rules are needed to ensure that, given a trait ref like `<T as Trait<U>>`, we can derive the values of all parameters on the impl (which is needed to make specialization possible).",N,[[["tyctxt"]]]],[5,"enforce_impl_params_are_constrained","","",N,N],[5,"report_unused_parameter","","",N,[[["tyctxt"],["span"],["str"],["str"]]]],[5,"enforce_impl_items_are_distinct","","Enforce that we do not have two items in an impl with the same name.",N,N],[11,"visit_item","","",84,[[["self"],["item"]]]],[11,"visit_trait_item","","",84,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",84,[[["self"],["implitem"]]]],[0,"namespace","rustc_typeck","",N,N],[4,"Namespace","rustc_typeck::namespace","",N,N],[13,"Type","","",85,N],[13,"Value","","",85,N],[11,"clone","","",85,[[["self"]],["namespace"]]],[11,"eq","","",85,[[["self"],["namespace"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",85,N],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"from","","",85,[[["associatedkind"]],["self"]]],[11,"from","","",85,[[["implitemkind"]],["self"]]],[0,"outlives","rustc_typeck","",N,N],[5,"provide","rustc_typeck::outlives","",N,[[["providers"]]]],[5,"inferred_outlives_of","","",N,[[["tyctxt"],["defid"]],["lrc",["vec"]]]],[5,"inferred_outlives_crate","","",N,[[["tyctxt"],["cratenum"]],["lrc",["cratepredicatesmap"]]]],[0,"explicit","","",N,N],[3,"ExplicitPredicatesMap","rustc_typeck::outlives::explicit","",N,N],[12,"map","","",86,N],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[11,"new","","",86,[[],["explicitpredicatesmap"]]],[11,"explicit_predicates_of","","",86,[[["self"],["tyctxt"],["defid"]],["btreeset"]]],[0,"implicit_infer","rustc_typeck::outlives","",N,N],[3,"InferVisitor","rustc_typeck::outlives::implicit_infer","",N,N],[12,"tcx","","",87,N],[12,"global_inferred_outlives","","",87,N],[12,"predicates_added","","",87,N],[12,"explicit_map","","",87,N],[3,"IgnoreSelfTy","","",N,N],[12,"0","","",88,N],[5,"infer_predicates","","Infer predicates for the items in the crate.",N,[[["tyctxt"],["explicitpredicatesmap"]],["fxhashmap",["defid","btreeset"]]]],[5,"insert_required_predicates_to_be_wf","","",N,[[["tyctxt"],["ty"],["fxhashmap"],["btreeset"],["explicitpredicatesmap"]]]],[5,"check_explicit_predicates","","We also have to check the explicit predicates declared on the type.",N,N],[11,"visit_item","","",87,[[["self"],["item"]]]],[11,"visit_trait_item","","",87,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",87,[[["self"],["implitem"]]]],[0,"test","rustc_typeck::outlives","Code to write unit test for outlives.",N,N],[3,"OutlivesTest","rustc_typeck::outlives::test","",N,N],[12,"tcx","","",89,N],[5,"test_inferred_outlives","","",N,[[["tyctxt"]]]],[11,"visit_item","","",89,[[["self"],["item"]]]],[11,"visit_trait_item","","",89,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",89,[[["self"],["implitem"]]]],[0,"utils","rustc_typeck::outlives","",N,N],[5,"insert_outlives_predicate","rustc_typeck::outlives::utils","Given a requirement `T: 'a` or `'b: 'a`, deduce the outlives_component and add it to `required_predicates`",N,[[["tyctxt"],["kind"],["region"],["btreeset"]]]],[5,"is_free_region","","",N,[[["tyctxt"],["region"]],["bool"]]],[6,"RequiredPredicates","","Tracks the `T: 'a` or `'a: 'a` predicates that we have inferred must be added to the struct header.",N,N],[0,"variance","rustc_typeck","Module for inferring the variance of type and lifetime parameters. See the [rustc guide] chapter for more info.",N,N],[5,"provide","rustc_typeck::variance","",N,[[["providers"]]]],[5,"crate_variances","","",N,[[["tyctxt"],["cratenum"]],["lrc",["cratevariancesmap"]]]],[5,"variances_of","","",N,[[["tyctxt"],["defid"]],["lrc",["vec"]]]],[0,"terms","","Defines the `TermsContext` basically houses an arena where we can allocate terms.",N,N],[3,"InferredIndex","rustc_typeck::variance::terms","",N,N],[12,"0","","",90,N],[3,"TermsContext","","",N,N],[12,"tcx","","",91,N],[12,"arena","","",91,N],[12,"lang_items","","",91,N],[12,"inferred_starts","","",91,N],[12,"inferred_terms","","",91,N],[4,"VarianceTerm","","",N,N],[13,"ConstantTerm","","",92,N],[13,"TransformTerm","","",92,N],[13,"InferredTerm","","",92,N],[5,"determine_parameters_to_be_inferred","","",N,[[["tyctxt"],["typedarena"]],["termscontext"]]],[5,"lang_items","","",N,[[["tyctxt"]],["vec"]]],[6,"VarianceTermPtr","","",N,N],[11,"clone","","",90,[[["self"]],["inferredindex"]]],[11,"fmt","","",90,[[["self"],["formatter"]],["result"]]],[11,"clone","","",92,[[["self"]],["varianceterm"]]],[11,"fmt","","",92,[[["self"],["formatter"]],["result"]]],[11,"add_inferreds_for_item","","",91,[[["self"],["nodeid"]]]],[11,"visit_item","","",91,[[["self"],["item"]]]],[11,"visit_trait_item","","",91,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",91,[[["self"],["implitem"]]]],[0,"constraints","rustc_typeck::variance","Code to gather up constraints. Constraint construction and representation",N,N],[3,"ConstraintContext","rustc_typeck::variance::constraints","",N,N],[12,"terms_cx","","",93,N],[12,"covariant","","",93,N],[12,"contravariant","","",93,N],[12,"invariant","","",93,N],[12,"bivariant","","",93,N],[12,"constraints","","",93,N],[3,"Constraint","","Declares that the variable `decl_id` appears in a location with variance `variance`.",N,N],[12,"inferred","","",94,N],[12,"variance","","",94,N],[3,"CurrentItem","","To build constraints, we visit one item (type, trait) at a time and look at its contents. So e.g. if we have",N,N],[12,"inferred_start","","",95,N],[5,"add_constraints_from_crate","","",N,[[["termscontext"]],["constraintcontext"]]],[11,"clone","","",94,[[["self"]],["constraint"]]],[11,"visit_item","","",93,[[["self"],["item"]]]],[11,"visit_trait_item","","",93,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",93,[[["self"],["implitem"]]]],[11,"visit_node_helper","","",93,[[["self"],["nodeid"]]]],[11,"tcx","","",93,[[["self"]],["tyctxt"]]],[11,"build_constraints_for_item","","",93,[[["self"],["defid"]]]],[11,"add_constraint","","",93,[[["self"],["currentitem"],["u32"],["varianceterm"]]]],[11,"contravariant","","",93,[[["self"],["varianceterm"]],["varianceterm"]]],[11,"invariant","","",93,[[["self"],["varianceterm"]],["varianceterm"]]],[11,"constant_term","","",93,[[["self"],["variance"]],["varianceterm"]]],[11,"xform","","",93,[[["self"],["varianceterm"],["varianceterm"]],["varianceterm"]]],[11,"add_constraints_from_trait_ref","","",93,[[["self"],["currentitem"],["traitref"],["varianceterm"]]]],[11,"add_constraints_from_invariant_substs","","",93,[[["self"],["currentitem"],["substs"],["varianceterm"]]]],[11,"add_constraints_from_ty","","Adds constraints appropriate for an instance of `ty` appearing in a context with the generics defined in `generics` and ambient variance `variance`",93,[[["self"],["currentitem"],["ty"],["varianceterm"]]]],[11,"add_constraints_from_substs","","Adds constraints appropriate for a nominal type (enum, struct, object, etc) appearing in a context with ambient variance `variance`",93,[[["self"],["currentitem"],["defid"],["substs"],["varianceterm"]]]],[11,"add_constraints_from_sig","","Adds constraints appropriate for a function with signature `sig` appearing in a context with ambient variance `variance`",93,[[["self"],["currentitem"],["polyfnsig"],["varianceterm"]]]],[11,"add_constraints_from_region","","Adds constraints appropriate for a region appearing in a context with ambient variance `variance`",93,[[["self"],["currentitem"],["region"],["varianceterm"]]]],[11,"add_constraints_from_mt","","Adds constraints appropriate for a mutability-type pair appearing in a context with ambient variance `variance`",93,[[["self"],["currentitem"],["typeandmut"],["varianceterm"]]]],[0,"solve","rustc_typeck::variance","Code to solve constraints and write out the results. Constraint solving",N,N],[3,"SolveContext","rustc_typeck::variance::solve","",N,N],[12,"terms_cx","","",96,N],[12,"constraints","","",96,N],[12,"solutions","","",96,N],[5,"solve_constraints","","",N,[[["constraintcontext"]],["cratevariancesmap"]]],[11,"solve","","",96,[[["self"]]]],[11,"create_map","","",96,[[["self"]],["fxhashmap",["defid","lrc"]]]],[11,"evaluate","","",96,[[["self"],["varianceterm"]],["variance"]]],[0,"test","rustc_typeck::variance","Code to write unit tests of variance.",N,N],[3,"VarianceTest","rustc_typeck::variance::test","",N,N],[12,"tcx","","",97,N],[5,"test_variance","","",N,[[["tyctxt"]]]],[11,"visit_item","","",97,[[["self"],["item"]]]],[11,"visit_trait_item","","",97,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",97,[[["self"],["implitem"]]]],[0,"xform","rustc_typeck::variance","Code for transforming variances.",N,N],[5,"glb","rustc_typeck::variance::xform","",N,[[["variance"],["variance"]],["variance"]]],[17,"DIAGNOSTICS","rustc_typeck","",N,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::astconv","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_typeck::check","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from_ok","","",13,[[["t"]],["t"]]],[11,"map_same","","",13,[[["self"],["f"]],["t"]]],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from_ok","","",14,[[["t"]],["t"]]],[11,"map_same","","",14,[[["self"],["f"]],["t"]]],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from_ok","","",15,[[["t"]],["t"]]],[11,"map_same","","",15,[[["self"],["f"]],["t"]]],[11,"to_owned","","",16,[[["self"]],["t"]]],[11,"clone_into","","",16,N],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from_ok","","",16,[[["t"]],["t"]]],[11,"map_same","","",16,[[["self"],["f"]],["t"]]],[11,"to_owned","","",17,[[["self"]],["t"]]],[11,"clone_into","","",17,N],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from_ok","","",17,[[["t"]],["t"]]],[11,"map_same","","",17,[[["self"],["f"]],["t"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from_ok","","",18,[[["t"]],["t"]]],[11,"map_same","","",18,[[["self"],["f"]],["t"]]],[11,"to_owned","","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"from_ok","","",19,[[["t"]],["t"]]],[11,"map_same","","",19,[[["self"],["f"]],["t"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from_ok","","",20,[[["t"]],["t"]]],[11,"map_same","","",20,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::autoderef","",21,[[["t"]],["t"]]],[11,"into_iter","","",21,[[["self"]],["i"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from_ok","","",21,[[["t"]],["t"]]],[11,"map_same","","",21,[[["self"],["f"]],["t"]]],[11,"to_owned","","",22,[[["self"]],["t"]]],[11,"clone_into","","",22,N],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from_ok","","",22,[[["t"]],["t"]]],[11,"map_same","","",22,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::writeback","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from_ok","","",23,[[["t"]],["t"]]],[11,"map_same","","",23,[[["self"],["f"]],["t"]]],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"from_ok","","",24,[[["t"]],["t"]]],[11,"map_same","","",24,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::regionck","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"from_ok","","",26,[[["t"]],["t"]]],[11,"map_same","","",26,[[["self"],["f"]],["t"]]],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from_ok","","",27,[[["t"]],["t"]]],[11,"map_same","","",27,[[["self"],["f"]],["t"]]],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from_ok","","",28,[[["t"]],["t"]]],[11,"map_same","","",28,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::coercion","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from_ok","","",29,[[["t"]],["t"]]],[11,"map_same","","",29,[[["self"],["f"]],["t"]]],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"from_ok","","",30,[[["t"]],["t"]]],[11,"map_same","","",30,[[["self"],["f"]],["t"]]],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"from_ok","","",31,[[["t"]],["t"]]],[11,"map_same","","",31,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_typeck::check::method","",33,[[["self"]],["t"]]],[11,"clone_into","","",33,N],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from_ok","","",33,[[["t"]],["t"]]],[11,"map_same","","",33,[[["self"],["f"]],["t"]]],[11,"from","","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"from_ok","","",34,[[["t"]],["t"]]],[11,"map_same","","",34,[[["self"],["f"]],["t"]]],[11,"from","","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"from_ok","","",35,[[["t"]],["t"]]],[11,"map_same","","",35,[[["self"],["f"]],["t"]]],[11,"to_owned","","",36,[[["self"]],["t"]]],[11,"clone_into","","",36,N],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"from_ok","","",36,[[["t"]],["t"]]],[11,"map_same","","",36,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::method::confirm","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"from_ok","","",37,[[["t"]],["t"]]],[11,"map_same","","",37,[[["self"],["f"]],["t"]]],[11,"from","","",38,[[["t"]],["t"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"from_ok","","",38,[[["t"]],["t"]]],[11,"map_same","","",38,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_typeck::check::method::probe","",39,[[["self"]],["t"]]],[11,"clone_into","","",39,N],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"from_ok","","",39,[[["t"]],["t"]]],[11,"map_same","","",39,[[["self"],["f"]],["t"]]],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from_ok","","",40,[[["t"]],["t"]]],[11,"map_same","","",40,[[["self"],["f"]],["t"]]],[11,"from","","",41,[[["t"]],["t"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"not_found","","",41,[[["str"],["str"]],["e"]]],[11,"from_ok","","",41,[[["t"]],["t"]]],[11,"map_same","","",41,[[["self"],["f"]],["t"]]],[11,"from","","",42,[[["t"]],["t"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"not_found","","",42,[[["str"],["str"]],["e"]]],[11,"from_ok","","",42,[[["t"]],["t"]]],[11,"map_same","","",42,[[["self"],["f"]],["t"]]],[11,"to_owned","","",43,[[["self"]],["t"]]],[11,"clone_into","","",43,N],[11,"from","","",43,[[["t"]],["t"]]],[11,"into","","",43,[[["self"]],["u"]]],[11,"try_from","","",43,[[["u"]],["result"]]],[11,"borrow","","",43,[[["self"]],["t"]]],[11,"try_into","","",43,[[["self"]],["result"]]],[11,"borrow_mut","","",43,[[["self"]],["t"]]],[11,"get_type_id","","",43,[[["self"]],["typeid"]]],[11,"not_found","","",43,[[["str"],["str"]],["e"]]],[11,"from_ok","","",43,[[["t"]],["t"]]],[11,"map_same","","",43,[[["self"],["f"]],["t"]]],[11,"from","","",44,[[["t"]],["t"]]],[11,"into","","",44,[[["self"]],["u"]]],[11,"try_from","","",44,[[["u"]],["result"]]],[11,"borrow","","",44,[[["self"]],["t"]]],[11,"try_into","","",44,[[["self"]],["result"]]],[11,"borrow_mut","","",44,[[["self"]],["t"]]],[11,"get_type_id","","",44,[[["self"]],["typeid"]]],[11,"not_found","","",44,[[["str"],["str"]],["e"]]],[11,"from_ok","","",44,[[["t"]],["t"]]],[11,"map_same","","",44,[[["self"],["f"]],["t"]]],[11,"to_owned","","",45,[[["self"]],["t"]]],[11,"clone_into","","",45,N],[11,"from","","",45,[[["t"]],["t"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"not_found","","",45,[[["str"],["str"]],["e"]]],[11,"from_ok","","",45,[[["t"]],["t"]]],[11,"map_same","","",45,[[["self"],["f"]],["t"]]],[11,"to_owned","","",46,[[["self"]],["t"]]],[11,"clone_into","","",46,N],[11,"from","","",46,[[["t"]],["t"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"not_found","","",46,[[["str"],["str"]],["e"]]],[11,"from_ok","","",46,[[["t"]],["t"]]],[11,"map_same","","",46,[[["self"],["f"]],["t"]]],[11,"to_owned","","",47,[[["self"]],["t"]]],[11,"clone_into","","",47,N],[11,"from","","",47,[[["t"]],["t"]]],[11,"into","","",47,[[["self"]],["u"]]],[11,"try_from","","",47,[[["u"]],["result"]]],[11,"borrow","","",47,[[["self"]],["t"]]],[11,"try_into","","",47,[[["self"]],["result"]]],[11,"borrow_mut","","",47,[[["self"]],["t"]]],[11,"get_type_id","","",47,[[["self"]],["typeid"]]],[11,"not_found","","",47,[[["str"],["str"]],["e"]]],[11,"from_ok","","",47,[[["t"]],["t"]]],[11,"map_same","","",47,[[["self"],["f"]],["t"]]],[11,"to_owned","","",48,[[["self"]],["t"]]],[11,"clone_into","","",48,N],[11,"from","","",48,[[["t"]],["t"]]],[11,"into","","",48,[[["self"]],["u"]]],[11,"try_from","","",48,[[["u"]],["result"]]],[11,"borrow","","",48,[[["self"]],["t"]]],[11,"try_into","","",48,[[["self"]],["result"]]],[11,"borrow_mut","","",48,[[["self"]],["t"]]],[11,"get_type_id","","",48,[[["self"]],["typeid"]]],[11,"not_found","","",48,[[["str"],["str"]],["e"]]],[11,"from_ok","","",48,[[["t"]],["t"]]],[11,"map_same","","",48,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_typeck::check::method::suggest","",49,[[["self"]],["t"]]],[11,"clone_into","","",49,N],[11,"from","","",49,[[["t"]],["t"]]],[11,"into","","",49,[[["self"]],["u"]]],[11,"try_from","","",49,[[["u"]],["result"]]],[11,"borrow","","",49,[[["self"]],["t"]]],[11,"try_into","","",49,[[["self"]],["result"]]],[11,"borrow_mut","","",49,[[["self"]],["t"]]],[11,"get_type_id","","",49,[[["self"]],["typeid"]]],[11,"not_found","","",49,[[["str"],["str"]],["e"]]],[11,"from_ok","","",49,[[["t"]],["t"]]],[11,"map_same","","",49,[[["self"],["f"]],["t"]]],[11,"from","","",50,[[["t"]],["t"]]],[11,"into","","",50,[[["self"]],["u"]]],[11,"try_from","","",50,[[["u"]],["result"]]],[11,"borrow","","",50,[[["self"]],["t"]]],[11,"try_into","","",50,[[["self"]],["result"]]],[11,"borrow_mut","","",50,[[["self"]],["t"]]],[11,"get_type_id","","",50,[[["self"]],["typeid"]]],[11,"not_found","","",50,[[["str"],["str"]],["e"]]],[11,"from_ok","","",50,[[["t"]],["t"]]],[11,"map_same","","",50,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::upvar","",51,[[["t"]],["t"]]],[11,"into","","",51,[[["self"]],["u"]]],[11,"try_from","","",51,[[["u"]],["result"]]],[11,"borrow","","",51,[[["self"]],["t"]]],[11,"try_into","","",51,[[["self"]],["result"]]],[11,"borrow_mut","","",51,[[["self"]],["t"]]],[11,"get_type_id","","",51,[[["self"]],["typeid"]]],[11,"not_found","","",51,[[["str"],["str"]],["e"]]],[11,"from_ok","","",51,[[["t"]],["t"]]],[11,"map_same","","",51,[[["self"],["f"]],["t"]]],[11,"from","","",52,[[["t"]],["t"]]],[11,"into","","",52,[[["self"]],["u"]]],[11,"try_from","","",52,[[["u"]],["result"]]],[11,"borrow","","",52,[[["self"]],["t"]]],[11,"try_into","","",52,[[["self"]],["result"]]],[11,"borrow_mut","","",52,[[["self"]],["t"]]],[11,"get_type_id","","",52,[[["self"]],["typeid"]]],[11,"not_found","","",52,[[["str"],["str"]],["e"]]],[11,"from_ok","","",52,[[["t"]],["t"]]],[11,"map_same","","",52,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::wfcheck","",53,[[["t"]],["t"]]],[11,"into","","",53,[[["self"]],["u"]]],[11,"try_from","","",53,[[["u"]],["result"]]],[11,"borrow","","",53,[[["self"]],["t"]]],[11,"try_into","","",53,[[["self"]],["result"]]],[11,"borrow_mut","","",53,[[["self"]],["t"]]],[11,"get_type_id","","",53,[[["self"]],["typeid"]]],[11,"not_found","","",53,[[["str"],["str"]],["e"]]],[11,"from_ok","","",53,[[["t"]],["t"]]],[11,"map_same","","",53,[[["self"],["f"]],["t"]]],[11,"from","","",54,[[["t"]],["t"]]],[11,"into","","",54,[[["self"]],["u"]]],[11,"try_from","","",54,[[["u"]],["result"]]],[11,"borrow","","",54,[[["self"]],["t"]]],[11,"try_into","","",54,[[["self"]],["result"]]],[11,"borrow_mut","","",54,[[["self"]],["t"]]],[11,"get_type_id","","",54,[[["self"]],["typeid"]]],[11,"not_found","","",54,[[["str"],["str"]],["e"]]],[11,"from_ok","","",54,[[["t"]],["t"]]],[11,"map_same","","",54,[[["self"],["f"]],["t"]]],[11,"from","","",55,[[["t"]],["t"]]],[11,"into","","",55,[[["self"]],["u"]]],[11,"try_from","","",55,[[["u"]],["result"]]],[11,"borrow","","",55,[[["self"]],["t"]]],[11,"try_into","","",55,[[["self"]],["result"]]],[11,"borrow_mut","","",55,[[["self"]],["t"]]],[11,"get_type_id","","",55,[[["self"]],["typeid"]]],[11,"not_found","","",55,[[["str"],["str"]],["e"]]],[11,"from_ok","","",55,[[["t"]],["t"]]],[11,"map_same","","",55,[[["self"],["f"]],["t"]]],[11,"from","","",56,[[["t"]],["t"]]],[11,"into","","",56,[[["self"]],["u"]]],[11,"try_from","","",56,[[["u"]],["result"]]],[11,"borrow","","",56,[[["self"]],["t"]]],[11,"try_into","","",56,[[["self"]],["result"]]],[11,"borrow_mut","","",56,[[["self"]],["t"]]],[11,"get_type_id","","",56,[[["self"]],["typeid"]]],[11,"not_found","","",56,[[["str"],["str"]],["e"]]],[11,"from_ok","","",56,[[["t"]],["t"]]],[11,"map_same","","",56,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::cast","",57,[[["t"]],["t"]]],[11,"into","","",57,[[["self"]],["u"]]],[11,"try_from","","",57,[[["u"]],["result"]]],[11,"borrow","","",57,[[["self"]],["t"]]],[11,"try_into","","",57,[[["self"]],["result"]]],[11,"borrow_mut","","",57,[[["self"]],["t"]]],[11,"get_type_id","","",57,[[["self"]],["typeid"]]],[11,"not_found","","",57,[[["str"],["str"]],["e"]]],[11,"from_ok","","",57,[[["t"]],["t"]]],[11,"map_same","","",57,[[["self"],["f"]],["t"]]],[11,"to_owned","","",58,[[["self"]],["t"]]],[11,"clone_into","","",58,N],[11,"from","","",58,[[["t"]],["t"]]],[11,"into","","",58,[[["self"]],["u"]]],[11,"try_from","","",58,[[["u"]],["result"]]],[11,"borrow","","",58,[[["self"]],["t"]]],[11,"try_into","","",58,[[["self"]],["result"]]],[11,"borrow_mut","","",58,[[["self"]],["t"]]],[11,"get_type_id","","",58,[[["self"]],["typeid"]]],[11,"not_found","","",58,[[["str"],["str"]],["e"]]],[11,"from_ok","","",58,[[["t"]],["t"]]],[11,"map_same","","",58,[[["self"],["f"]],["t"]]],[11,"to_owned","","",59,[[["self"]],["t"]]],[11,"clone_into","","",59,N],[11,"from","","",59,[[["t"]],["t"]]],[11,"into","","",59,[[["self"]],["u"]]],[11,"try_from","","",59,[[["u"]],["result"]]],[11,"borrow","","",59,[[["self"]],["t"]]],[11,"try_into","","",59,[[["self"]],["result"]]],[11,"borrow_mut","","",59,[[["self"]],["t"]]],[11,"get_type_id","","",59,[[["self"]],["typeid"]]],[11,"not_found","","",59,[[["str"],["str"]],["e"]]],[11,"from_ok","","",59,[[["t"]],["t"]]],[11,"map_same","","",59,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::closure","",60,[[["t"]],["t"]]],[11,"into","","",60,[[["self"]],["u"]]],[11,"try_from","","",60,[[["u"]],["result"]]],[11,"borrow","","",60,[[["self"]],["t"]]],[11,"try_into","","",60,[[["self"]],["result"]]],[11,"borrow_mut","","",60,[[["self"]],["t"]]],[11,"get_type_id","","",60,[[["self"]],["typeid"]]],[11,"not_found","","",60,[[["str"],["str"]],["e"]]],[11,"from_ok","","",60,[[["t"]],["t"]]],[11,"map_same","","",60,[[["self"],["f"]],["t"]]],[11,"from","","",61,[[["t"]],["t"]]],[11,"into","","",61,[[["self"]],["u"]]],[11,"try_from","","",61,[[["u"]],["result"]]],[11,"borrow","","",61,[[["self"]],["t"]]],[11,"try_into","","",61,[[["self"]],["result"]]],[11,"borrow_mut","","",61,[[["self"]],["t"]]],[11,"get_type_id","","",61,[[["self"]],["typeid"]]],[11,"not_found","","",61,[[["str"],["str"]],["e"]]],[11,"from_ok","","",61,[[["t"]],["t"]]],[11,"map_same","","",61,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::callee","",62,[[["t"]],["t"]]],[11,"into","","",62,[[["self"]],["u"]]],[11,"try_from","","",62,[[["u"]],["result"]]],[11,"borrow","","",62,[[["self"]],["t"]]],[11,"try_into","","",62,[[["self"]],["result"]]],[11,"borrow_mut","","",62,[[["self"]],["t"]]],[11,"get_type_id","","",62,[[["self"]],["typeid"]]],[11,"not_found","","",62,[[["str"],["str"]],["e"]]],[11,"from_ok","","",62,[[["t"]],["t"]]],[11,"map_same","","",62,[[["self"],["f"]],["t"]]],[11,"from","","",63,[[["t"]],["t"]]],[11,"into","","",63,[[["self"]],["u"]]],[11,"try_from","","",63,[[["u"]],["result"]]],[11,"borrow","","",63,[[["self"]],["t"]]],[11,"try_into","","",63,[[["self"]],["result"]]],[11,"borrow_mut","","",63,[[["self"]],["t"]]],[11,"get_type_id","","",63,[[["self"]],["typeid"]]],[11,"not_found","","",63,[[["str"],["str"]],["e"]]],[11,"from_ok","","",63,[[["t"]],["t"]]],[11,"map_same","","",63,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::generator_interior","",64,[[["t"]],["t"]]],[11,"into","","",64,[[["self"]],["u"]]],[11,"try_from","","",64,[[["u"]],["result"]]],[11,"borrow","","",64,[[["self"]],["t"]]],[11,"try_into","","",64,[[["self"]],["result"]]],[11,"borrow_mut","","",64,[[["self"]],["t"]]],[11,"get_type_id","","",64,[[["self"]],["typeid"]]],[11,"not_found","","",64,[[["str"],["str"]],["e"]]],[11,"from_ok","","",64,[[["t"]],["t"]]],[11,"map_same","","",64,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check::op","",65,[[["t"]],["t"]]],[11,"into","","",65,[[["self"]],["u"]]],[11,"try_from","","",65,[[["u"]],["result"]]],[11,"borrow","","",65,[[["self"]],["t"]]],[11,"try_into","","",65,[[["self"]],["result"]]],[11,"borrow_mut","","",65,[[["self"]],["t"]]],[11,"get_type_id","","",65,[[["self"]],["typeid"]]],[11,"not_found","","",65,[[["str"],["str"]],["e"]]],[11,"from_ok","","",65,[[["t"]],["t"]]],[11,"map_same","","",65,[[["self"],["f"]],["t"]]],[11,"to_owned","","",66,[[["self"]],["t"]]],[11,"clone_into","","",66,N],[11,"from","","",66,[[["t"]],["t"]]],[11,"into","","",66,[[["self"]],["u"]]],[11,"try_from","","",66,[[["u"]],["result"]]],[11,"borrow","","",66,[[["self"]],["t"]]],[11,"try_into","","",66,[[["self"]],["result"]]],[11,"borrow_mut","","",66,[[["self"]],["t"]]],[11,"get_type_id","","",66,[[["self"]],["typeid"]]],[11,"not_found","","",66,[[["str"],["str"]],["e"]]],[11,"from_ok","","",66,[[["t"]],["t"]]],[11,"map_same","","",66,[[["self"],["f"]],["t"]]],[11,"to_owned","","",67,[[["self"]],["t"]]],[11,"clone_into","","",67,N],[11,"from","","",67,[[["t"]],["t"]]],[11,"into","","",67,[[["self"]],["u"]]],[11,"try_from","","",67,[[["u"]],["result"]]],[11,"borrow","","",67,[[["self"]],["t"]]],[11,"try_into","","",67,[[["self"]],["result"]]],[11,"borrow_mut","","",67,[[["self"]],["t"]]],[11,"get_type_id","","",67,[[["self"]],["typeid"]]],[11,"not_found","","",67,[[["str"],["str"]],["e"]]],[11,"from_ok","","",67,[[["t"]],["t"]]],[11,"map_same","","",67,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::check_unused","",68,[[["t"]],["t"]]],[11,"into","","",68,[[["self"]],["u"]]],[11,"try_from","","",68,[[["u"]],["result"]]],[11,"borrow","","",68,[[["self"]],["t"]]],[11,"try_into","","",68,[[["self"]],["result"]]],[11,"borrow_mut","","",68,[[["self"]],["t"]]],[11,"get_type_id","","",68,[[["self"]],["typeid"]]],[11,"not_found","","",68,[[["str"],["str"]],["e"]]],[11,"from_ok","","",68,[[["t"]],["t"]]],[11,"map_same","","",68,[[["self"],["f"]],["t"]]],[11,"from","","",69,[[["t"]],["t"]]],[11,"into","","",69,[[["self"]],["u"]]],[11,"try_from","","",69,[[["u"]],["result"]]],[11,"borrow","","",69,[[["self"]],["t"]]],[11,"try_into","","",69,[[["self"]],["result"]]],[11,"borrow_mut","","",69,[[["self"]],["t"]]],[11,"get_type_id","","",69,[[["self"]],["typeid"]]],[11,"not_found","","",69,[[["str"],["str"]],["e"]]],[11,"from_ok","","",69,[[["t"]],["t"]]],[11,"map_same","","",69,[[["self"],["f"]],["t"]]],[11,"from","","",70,[[["t"]],["t"]]],[11,"into","","",70,[[["self"]],["u"]]],[11,"try_from","","",70,[[["u"]],["result"]]],[11,"borrow","","",70,[[["self"]],["t"]]],[11,"try_into","","",70,[[["self"]],["result"]]],[11,"borrow_mut","","",70,[[["self"]],["t"]]],[11,"get_type_id","","",70,[[["self"]],["typeid"]]],[11,"not_found","","",70,[[["str"],["str"]],["e"]]],[11,"from_ok","","",70,[[["t"]],["t"]]],[11,"map_same","","",70,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::coherence::builtin","",71,[[["t"]],["t"]]],[11,"into","","",71,[[["self"]],["u"]]],[11,"try_from","","",71,[[["u"]],["result"]]],[11,"borrow","","",71,[[["self"]],["t"]]],[11,"try_into","","",71,[[["self"]],["result"]]],[11,"borrow_mut","","",71,[[["self"]],["t"]]],[11,"get_type_id","","",71,[[["self"]],["typeid"]]],[11,"not_found","","",71,[[["str"],["str"]],["e"]]],[11,"from_ok","","",71,[[["t"]],["t"]]],[11,"map_same","","",71,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::coherence::inherent_impls","",72,[[["t"]],["t"]]],[11,"into","","",72,[[["self"]],["u"]]],[11,"try_from","","",72,[[["u"]],["result"]]],[11,"borrow","","",72,[[["self"]],["t"]]],[11,"try_into","","",72,[[["self"]],["result"]]],[11,"borrow_mut","","",72,[[["self"]],["t"]]],[11,"get_type_id","","",72,[[["self"]],["typeid"]]],[11,"not_found","","",72,[[["str"],["str"]],["e"]]],[11,"from_ok","","",72,[[["t"]],["t"]]],[11,"map_same","","",72,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::coherence::inherent_impls_overlap","",73,[[["t"]],["t"]]],[11,"into","","",73,[[["self"]],["u"]]],[11,"try_from","","",73,[[["u"]],["result"]]],[11,"borrow","","",73,[[["self"]],["t"]]],[11,"try_into","","",73,[[["self"]],["result"]]],[11,"borrow_mut","","",73,[[["self"]],["t"]]],[11,"get_type_id","","",73,[[["self"]],["typeid"]]],[11,"not_found","","",73,[[["str"],["str"]],["e"]]],[11,"from_ok","","",73,[[["t"]],["t"]]],[11,"map_same","","",73,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::coherence::orphan","",74,[[["t"]],["t"]]],[11,"into","","",74,[[["self"]],["u"]]],[11,"try_from","","",74,[[["u"]],["result"]]],[11,"borrow","","",74,[[["self"]],["t"]]],[11,"try_into","","",74,[[["self"]],["result"]]],[11,"borrow_mut","","",74,[[["self"]],["t"]]],[11,"get_type_id","","",74,[[["self"]],["typeid"]]],[11,"not_found","","",74,[[["str"],["str"]],["e"]]],[11,"from_ok","","",74,[[["t"]],["t"]]],[11,"map_same","","",74,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::coherence::unsafety","",75,[[["t"]],["t"]]],[11,"into","","",75,[[["self"]],["u"]]],[11,"try_from","","",75,[[["u"]],["result"]]],[11,"borrow","","",75,[[["self"]],["t"]]],[11,"try_into","","",75,[[["self"]],["result"]]],[11,"borrow_mut","","",75,[[["self"]],["t"]]],[11,"get_type_id","","",75,[[["self"]],["typeid"]]],[11,"not_found","","",75,[[["str"],["str"]],["e"]]],[11,"from_ok","","",75,[[["t"]],["t"]]],[11,"map_same","","",75,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::collect","",76,[[["t"]],["t"]]],[11,"into","","",76,[[["self"]],["u"]]],[11,"try_from","","",76,[[["u"]],["result"]]],[11,"borrow","","",76,[[["self"]],["t"]]],[11,"try_into","","",76,[[["self"]],["result"]]],[11,"borrow_mut","","",76,[[["self"]],["t"]]],[11,"get_type_id","","",76,[[["self"]],["typeid"]]],[11,"not_found","","",76,[[["str"],["str"]],["e"]]],[11,"from_ok","","",76,[[["t"]],["t"]]],[11,"map_same","","",76,[[["self"],["f"]],["t"]]],[11,"from","","",77,[[["t"]],["t"]]],[11,"into","","",77,[[["self"]],["u"]]],[11,"try_from","","",77,[[["u"]],["result"]]],[11,"borrow","","",77,[[["self"]],["t"]]],[11,"try_into","","",77,[[["self"]],["result"]]],[11,"borrow_mut","","",77,[[["self"]],["t"]]],[11,"get_type_id","","",77,[[["self"]],["typeid"]]],[11,"not_found","","",77,[[["str"],["str"]],["e"]]],[11,"from_ok","","",77,[[["t"]],["t"]]],[11,"map_same","","",77,[[["self"],["f"]],["t"]]],[11,"from","","",78,[[["t"]],["t"]]],[11,"into","","",78,[[["self"]],["u"]]],[11,"try_from","","",78,[[["u"]],["result"]]],[11,"borrow","","",78,[[["self"]],["t"]]],[11,"try_into","","",78,[[["self"]],["result"]]],[11,"borrow_mut","","",78,[[["self"]],["t"]]],[11,"get_type_id","","",78,[[["self"]],["typeid"]]],[11,"not_found","","",78,[[["str"],["str"]],["e"]]],[11,"from_ok","","",78,[[["t"]],["t"]]],[11,"map_same","","",78,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_typeck::constrained_type_params","",79,[[["self"]],["t"]]],[11,"clone_into","","",79,N],[11,"from","","",79,[[["t"]],["t"]]],[11,"into","","",79,[[["self"]],["u"]]],[11,"try_from","","",79,[[["u"]],["result"]]],[11,"borrow","","",79,[[["self"]],["t"]]],[11,"try_into","","",79,[[["self"]],["result"]]],[11,"borrow_mut","","",79,[[["self"]],["t"]]],[11,"get_type_id","","",79,[[["self"]],["typeid"]]],[11,"not_found","","",79,[[["str"],["str"]],["e"]]],[11,"from_ok","","",79,[[["t"]],["t"]]],[11,"map_same","","",79,[[["self"],["f"]],["t"]]],[11,"from","","",80,[[["t"]],["t"]]],[11,"into","","",80,[[["self"]],["u"]]],[11,"try_from","","",80,[[["u"]],["result"]]],[11,"borrow","","",80,[[["self"]],["t"]]],[11,"try_into","","",80,[[["self"]],["result"]]],[11,"borrow_mut","","",80,[[["self"]],["t"]]],[11,"get_type_id","","",80,[[["self"]],["typeid"]]],[11,"not_found","","",80,[[["str"],["str"]],["e"]]],[11,"from_ok","","",80,[[["t"]],["t"]]],[11,"map_same","","",80,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::structured_errors","",81,[[["t"]],["t"]]],[11,"into","","",81,[[["self"]],["u"]]],[11,"try_from","","",81,[[["u"]],["result"]]],[11,"borrow","","",81,[[["self"]],["t"]]],[11,"try_into","","",81,[[["self"]],["result"]]],[11,"borrow_mut","","",81,[[["self"]],["t"]]],[11,"get_type_id","","",81,[[["self"]],["typeid"]]],[11,"not_found","","",81,[[["str"],["str"]],["e"]]],[11,"from_ok","","",81,[[["t"]],["t"]]],[11,"map_same","","",81,[[["self"],["f"]],["t"]]],[11,"from","","",82,[[["t"]],["t"]]],[11,"into","","",82,[[["self"]],["u"]]],[11,"try_from","","",82,[[["u"]],["result"]]],[11,"borrow","","",82,[[["self"]],["t"]]],[11,"try_into","","",82,[[["self"]],["result"]]],[11,"borrow_mut","","",82,[[["self"]],["t"]]],[11,"get_type_id","","",82,[[["self"]],["typeid"]]],[11,"not_found","","",82,[[["str"],["str"]],["e"]]],[11,"from_ok","","",82,[[["t"]],["t"]]],[11,"map_same","","",82,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::impl_wf_check","",84,[[["t"]],["t"]]],[11,"into","","",84,[[["self"]],["u"]]],[11,"try_from","","",84,[[["u"]],["result"]]],[11,"borrow","","",84,[[["self"]],["t"]]],[11,"try_into","","",84,[[["self"]],["result"]]],[11,"borrow_mut","","",84,[[["self"]],["t"]]],[11,"get_type_id","","",84,[[["self"]],["typeid"]]],[11,"not_found","","",84,[[["str"],["str"]],["e"]]],[11,"from_ok","","",84,[[["t"]],["t"]]],[11,"map_same","","",84,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_typeck::namespace","",85,[[["self"]],["t"]]],[11,"clone_into","","",85,N],[11,"from","","",85,[[["t"]],["t"]]],[11,"into","","",85,[[["self"]],["u"]]],[11,"try_from","","",85,[[["u"]],["result"]]],[11,"borrow","","",85,[[["self"]],["t"]]],[11,"try_into","","",85,[[["self"]],["result"]]],[11,"borrow_mut","","",85,[[["self"]],["t"]]],[11,"get_type_id","","",85,[[["self"]],["typeid"]]],[11,"not_found","","",85,[[["str"],["str"]],["e"]]],[11,"from_ok","","",85,[[["t"]],["t"]]],[11,"map_same","","",85,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::outlives::explicit","",86,[[["t"]],["t"]]],[11,"into","","",86,[[["self"]],["u"]]],[11,"try_from","","",86,[[["u"]],["result"]]],[11,"borrow","","",86,[[["self"]],["t"]]],[11,"try_into","","",86,[[["self"]],["result"]]],[11,"borrow_mut","","",86,[[["self"]],["t"]]],[11,"get_type_id","","",86,[[["self"]],["typeid"]]],[11,"not_found","","",86,[[["str"],["str"]],["e"]]],[11,"from_ok","","",86,[[["t"]],["t"]]],[11,"map_same","","",86,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::outlives::implicit_infer","",87,[[["t"]],["t"]]],[11,"into","","",87,[[["self"]],["u"]]],[11,"try_from","","",87,[[["u"]],["result"]]],[11,"borrow","","",87,[[["self"]],["t"]]],[11,"try_into","","",87,[[["self"]],["result"]]],[11,"borrow_mut","","",87,[[["self"]],["t"]]],[11,"get_type_id","","",87,[[["self"]],["typeid"]]],[11,"not_found","","",87,[[["str"],["str"]],["e"]]],[11,"from_ok","","",87,[[["t"]],["t"]]],[11,"map_same","","",87,[[["self"],["f"]],["t"]]],[11,"from","","",88,[[["t"]],["t"]]],[11,"into","","",88,[[["self"]],["u"]]],[11,"try_from","","",88,[[["u"]],["result"]]],[11,"borrow","","",88,[[["self"]],["t"]]],[11,"try_into","","",88,[[["self"]],["result"]]],[11,"borrow_mut","","",88,[[["self"]],["t"]]],[11,"get_type_id","","",88,[[["self"]],["typeid"]]],[11,"not_found","","",88,[[["str"],["str"]],["e"]]],[11,"from_ok","","",88,[[["t"]],["t"]]],[11,"map_same","","",88,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::outlives::test","",89,[[["t"]],["t"]]],[11,"into","","",89,[[["self"]],["u"]]],[11,"try_from","","",89,[[["u"]],["result"]]],[11,"borrow","","",89,[[["self"]],["t"]]],[11,"try_into","","",89,[[["self"]],["result"]]],[11,"borrow_mut","","",89,[[["self"]],["t"]]],[11,"get_type_id","","",89,[[["self"]],["typeid"]]],[11,"not_found","","",89,[[["str"],["str"]],["e"]]],[11,"from_ok","","",89,[[["t"]],["t"]]],[11,"map_same","","",89,[[["self"],["f"]],["t"]]],[11,"to_owned","rustc_typeck::variance::terms","",90,[[["self"]],["t"]]],[11,"clone_into","","",90,N],[11,"from","","",90,[[["t"]],["t"]]],[11,"into","","",90,[[["self"]],["u"]]],[11,"try_from","","",90,[[["u"]],["result"]]],[11,"borrow","","",90,[[["self"]],["t"]]],[11,"try_into","","",90,[[["self"]],["result"]]],[11,"borrow_mut","","",90,[[["self"]],["t"]]],[11,"get_type_id","","",90,[[["self"]],["typeid"]]],[11,"not_found","","",90,[[["str"],["str"]],["e"]]],[11,"from_ok","","",90,[[["t"]],["t"]]],[11,"map_same","","",90,[[["self"],["f"]],["t"]]],[11,"from","","",91,[[["t"]],["t"]]],[11,"into","","",91,[[["self"]],["u"]]],[11,"try_from","","",91,[[["u"]],["result"]]],[11,"borrow","","",91,[[["self"]],["t"]]],[11,"try_into","","",91,[[["self"]],["result"]]],[11,"borrow_mut","","",91,[[["self"]],["t"]]],[11,"get_type_id","","",91,[[["self"]],["typeid"]]],[11,"not_found","","",91,[[["str"],["str"]],["e"]]],[11,"from_ok","","",91,[[["t"]],["t"]]],[11,"map_same","","",91,[[["self"],["f"]],["t"]]],[11,"to_owned","","",92,[[["self"]],["t"]]],[11,"clone_into","","",92,N],[11,"from","","",92,[[["t"]],["t"]]],[11,"into","","",92,[[["self"]],["u"]]],[11,"try_from","","",92,[[["u"]],["result"]]],[11,"borrow","","",92,[[["self"]],["t"]]],[11,"try_into","","",92,[[["self"]],["result"]]],[11,"borrow_mut","","",92,[[["self"]],["t"]]],[11,"get_type_id","","",92,[[["self"]],["typeid"]]],[11,"not_found","","",92,[[["str"],["str"]],["e"]]],[11,"from_ok","","",92,[[["t"]],["t"]]],[11,"map_same","","",92,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::variance::constraints","",93,[[["t"]],["t"]]],[11,"into","","",93,[[["self"]],["u"]]],[11,"try_from","","",93,[[["u"]],["result"]]],[11,"borrow","","",93,[[["self"]],["t"]]],[11,"try_into","","",93,[[["self"]],["result"]]],[11,"borrow_mut","","",93,[[["self"]],["t"]]],[11,"get_type_id","","",93,[[["self"]],["typeid"]]],[11,"not_found","","",93,[[["str"],["str"]],["e"]]],[11,"from_ok","","",93,[[["t"]],["t"]]],[11,"map_same","","",93,[[["self"],["f"]],["t"]]],[11,"to_owned","","",94,[[["self"]],["t"]]],[11,"clone_into","","",94,N],[11,"from","","",94,[[["t"]],["t"]]],[11,"into","","",94,[[["self"]],["u"]]],[11,"try_from","","",94,[[["u"]],["result"]]],[11,"borrow","","",94,[[["self"]],["t"]]],[11,"try_into","","",94,[[["self"]],["result"]]],[11,"borrow_mut","","",94,[[["self"]],["t"]]],[11,"get_type_id","","",94,[[["self"]],["typeid"]]],[11,"not_found","","",94,[[["str"],["str"]],["e"]]],[11,"from_ok","","",94,[[["t"]],["t"]]],[11,"map_same","","",94,[[["self"],["f"]],["t"]]],[11,"from","","",95,[[["t"]],["t"]]],[11,"into","","",95,[[["self"]],["u"]]],[11,"try_from","","",95,[[["u"]],["result"]]],[11,"borrow","","",95,[[["self"]],["t"]]],[11,"try_into","","",95,[[["self"]],["result"]]],[11,"borrow_mut","","",95,[[["self"]],["t"]]],[11,"get_type_id","","",95,[[["self"]],["typeid"]]],[11,"not_found","","",95,[[["str"],["str"]],["e"]]],[11,"from_ok","","",95,[[["t"]],["t"]]],[11,"map_same","","",95,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::variance::solve","",96,[[["t"]],["t"]]],[11,"into","","",96,[[["self"]],["u"]]],[11,"try_from","","",96,[[["u"]],["result"]]],[11,"borrow","","",96,[[["self"]],["t"]]],[11,"try_into","","",96,[[["self"]],["result"]]],[11,"borrow_mut","","",96,[[["self"]],["t"]]],[11,"get_type_id","","",96,[[["self"]],["typeid"]]],[11,"not_found","","",96,[[["str"],["str"]],["e"]]],[11,"from_ok","","",96,[[["t"]],["t"]]],[11,"map_same","","",96,[[["self"],["f"]],["t"]]],[11,"from","rustc_typeck::variance::test","",97,[[["t"]],["t"]]],[11,"into","","",97,[[["self"]],["u"]]],[11,"try_from","","",97,[[["u"]],["result"]]],[11,"borrow","","",97,[[["self"]],["t"]]],[11,"try_into","","",97,[[["self"]],["result"]]],[11,"borrow_mut","","",97,[[["self"]],["t"]]],[11,"get_type_id","","",97,[[["self"]],["typeid"]]],[11,"not_found","","",97,[[["str"],["str"]],["e"]]],[11,"from_ok","","",97,[[["t"]],["t"]]],[11,"map_same","","",97,[[["self"],["f"]],["t"]]]],"paths":[[3,"TypeAndSubsts"],[3,"ConvertedBinding"],[3,"Bounds"],[4,"GenericArgPosition"],[8,"AstConv"],[3,"MaybeInProgressTables"],[3,"Inherited"],[3,"UnsafetyState"],[3,"BreakableCtxt"],[3,"EnclosingBreakables"],[3,"PathSeg"],[3,"FnCtxt"],[3,"InheritedBuilder"],[3,"CheckItemTypesVisitor"],[3,"GatherLocalsVisitor"],[3,"GeneratorTypes"],[4,"Expectation"],[4,"Needs"],[4,"PlaceOp"],[4,"Diverges"],[4,"TupleArgumentsFlag"],[3,"Autoderef"],[4,"AutoderefKind"],[3,"WritebackCx"],[3,"Resolver"],[8,"Locatable"],[3,"RegionCtxt"],[3,"RepeatingScope"],[3,"Subject"],[3,"Coerce"],[3,"CoerceMany"],[4,"Expressions"],[8,"AsCoercionSite"],[3,"MethodCallee"],[3,"NoMatchData"],[4,"MethodError"],[4,"CandidateSource"],[3,"ConfirmContext"],[3,"ConfirmResult"],[3,"IsSuggestion"],[3,"ProbeContext"],[3,"CandidateStep"],[3,"Candidate"],[3,"Pick"],[4,"CandidateKind"],[4,"ProbeResult"],[4,"PickKind"],[4,"Mode"],[4,"ProbeScope"],[3,"TraitInfo"],[3,"UsePlacementFinder"],[3,"InferBorrowKindVisitor"],[3,"InferBorrowKind"],[3,"CheckWfFcxBuilder"],[3,"CheckTypeWellFormedVisitor"],[3,"AdtVariant"],[3,"AdtField"],[3,"CastCheck"],[4,"PointerKind"],[4,"CastError"],[3,"ExpectedSig"],[3,"ClosureSignatures"],[3,"DeferredCallResolution"],[4,"CallStep"],[3,"InteriorVisitor"],[4,"BinOpCategory"],[4,"IsAssign"],[4,"Op"],[3,"CheckVisitor"],[3,"CollectExternCrateVisitor"],[3,"ExternCrateToLint"],[3,"Checker"],[3,"InherentCollect"],[3,"InherentOverlapChecker"],[3,"OrphanChecker"],[3,"UnsafetyChecker"],[3,"ItemCtxt"],[3,"CollectItemTypesVisitor"],[4,"SizedByDefault"],[3,"Parameter"],[3,"ParameterCollector"],[3,"VariadicError"],[3,"SizedUnsizedCastError"],[8,"StructuredDiagnostic"],[3,"ImplWfCheck"],[4,"Namespace"],[3,"ExplicitPredicatesMap"],[3,"InferVisitor"],[3,"IgnoreSelfTy"],[3,"OutlivesTest"],[3,"InferredIndex"],[3,"TermsContext"],[4,"VarianceTerm"],[3,"ConstraintContext"],[3,"Constraint"],[3,"CurrentItem"],[3,"SolveContext"],[3,"VarianceTest"]]};
searchIndex["rustdoc"]={"doc":"","items":[[3,"Output","rustdoc","",N,N],[12,"krate","","",0,N],[12,"renderinfo","","",0,N],[12,"passes","","",0,N],[5,"main","","",N,[[]]],[5,"get_args","","",N,[[],["option",["vec"]]]],[5,"stable","","",N,[[["str"],["f"]],["rustcoptgroup"]]],[5,"unstable","","",N,[[["str"],["f"]],["rustcoptgroup"]]],[5,"opts","","",N,[[],["vec",["rustcoptgroup"]]]],[5,"usage","","",N,[[["str"]]]],[5,"main_args","","",N,N],[5,"acquire_input","","Looks inside the command line arguments to extract the relevant input format and files and then generates the necessary rustdoc output for formatting.",N,[[["pathbuf"],["externs"],["edition"],["codegenoptions"],["matches"],["erroroutputtype"],["f"]],["result",["string"]]]],[5,"parse_externs","","Extracts `--extern CRATE=PATH` arguments from `matches` and returns a map mapping crate names to their paths or else an error message.",N,[[["matches"]],["result",["externs","string"]]]],[5,"parse_extern_html_roots","","Extracts `--extern-html-root-url` arguments from `matches` and returns a map of crate names to the given URLs. If an `--extern-html-root-url` argument was ill-formed, returns an error describing the issue.",N,[[["matches"]],["result",["btreemap","str"]]]],[5,"rust_input","","Interprets the input file as a rust source file, passing it through the compiler all the way through the analysis passes. The rustdoc output is then generated from the cleaned AST of the crate.",N,[[["pathbuf"],["externs"],["edition"],["codegenoptions"],["matches"],["erroroutputtype"],["f"]],["r"]]],[5,"check_deprecated_options","","Prints deprecation warnings for deprecated options",N,[[["matches"],["handler"]]]],[0,"externalfiles","","",N,N],[3,"ExternalHtml","rustdoc::externalfiles","",N,N],[12,"in_header","","Content that will be included inline in the  section of a rendered Markdown file or generated documentation",1,N],[12,"before_content","","Content that will be included inline between  and the content of a rendered Markdown file or generated documentation",1,N],[12,"after_content","","Content that will be included inline between the content and  of a rendered Markdown file or generated documentation",1,N],[4,"LoadStringError","","",N,N],[13,"ReadFail","","",2,N],[13,"BadUtf8","","",2,N],[5,"load_string","","",N,[[["p"],["handler"]],["result",["string","loadstringerror"]]]],[5,"load_external_files","","",N,N],[11,"clone","","",1,[[["self"]],["externalhtml"]]],[11,"load","","",1,N],[0,"clean","rustdoc","This module contains the \"cleaned\" pieces of the AST, and the functions that clean them.",N,N],[3,"Crate","rustdoc::clean","",N,N],[12,"name","","",3,N],[12,"version","","",3,N],[12,"src","","",3,N],[12,"module","","",3,N],[12,"externs","","",3,N],[12,"primitives","","",3,N],[12,"access_levels","","",3,N],[12,"external_traits","","",3,N],[12,"masked_crates","","",3,N],[3,"ExternalCrate","","",N,N],[12,"name","","",4,N],[12,"src","","",4,N],[12,"attrs","","",4,N],[12,"primitives","","",4,N],[12,"keywords","","",4,N],[3,"Item","","Anything with a source location and set of attributes and, optionally, a name. That is, anything that can be documented. This doesn't correspond directly to the AST's concept of an item; it's a strict superset.",N,N],[12,"source","","Stringified span",5,N],[12,"name","","Not everything has a name. E.g., impls",5,N],[12,"attrs","","",5,N],[12,"inner","","",5,N],[12,"visibility","","",5,N],[12,"def_id","","",5,N],[12,"stability","","",5,N],[12,"deprecation","","",5,N],[3,"Module","","",N,N],[12,"items","","",6,N],[12,"is_crate","","",6,N],[3,"ListAttributesIter","","",N,N],[12,"attrs","","",7,N],[12,"current_list","","",7,N],[12,"name","","",7,N],[3,"Attributes","","",N,N],[12,"doc_strings","","",8,N],[12,"other_attrs","","",8,N],[12,"cfg","","",8,N],[12,"span","","",8,N],[12,"links","","map from Rust paths to resolved defs and potential URL fragments",8,N],[12,"inner_docs","","",8,N],[3,"Lifetime","","",N,N],[12,"0","","",9,N],[3,"GenericParamDef","","",N,N],[12,"name","","",10,N],[12,"kind","","",10,N],[3,"Generics","","",N,N],[12,"params","","",11,N],[12,"where_predicates","","",11,N],[3,"Method","","",N,N],[12,"generics","","",12,N],[12,"decl","","",12,N],[12,"header","","",12,N],[3,"TyMethod","","",N,N],[12,"header","","",13,N],[12,"decl","","",13,N],[12,"generics","","",13,N],[3,"Function","","",N,N],[12,"decl","","",14,N],[12,"generics","","",14,N],[12,"header","","",14,N],[3,"FnDecl","","",N,N],[12,"inputs","","",15,N],[12,"output","","",15,N],[12,"variadic","","",15,N],[12,"attrs","","",15,N],[3,"Arguments","","",N,N],[12,"values","","",16,N],[3,"Argument","","",N,N],[12,"type_","","",17,N],[12,"name","","",17,N],[3,"Trait","","",N,N],[12,"auto","","",18,N],[12,"unsafety","","",18,N],[12,"items","","",18,N],[12,"generics","","",18,N],[12,"bounds","","",18,N],[12,"is_spotlight","","",18,N],[12,"is_auto","","",18,N],[3,"PolyTrait","","A trait reference, which may have higher ranked lifetimes.",N,N],[12,"trait_","","",19,N],[12,"generic_params","","",19,N],[3,"Struct","","",N,N],[12,"struct_type","","",20,N],[12,"generics","","",20,N],[12,"fields","","",20,N],[12,"fields_stripped","","",20,N],[3,"Union","","",N,N],[12,"struct_type","","",21,N],[12,"generics","","",21,N],[12,"fields","","",21,N],[12,"fields_stripped","","",21,N],[3,"VariantStruct","","This is a more limited form of the standard Struct, different in that it lacks the things most items have (name, id, parameterization). Found only as a variant in an enum.",N,N],[12,"struct_type","","",22,N],[12,"fields","","",22,N],[12,"fields_stripped","","",22,N],[3,"Enum","","",N,N],[12,"variants","","",23,N],[12,"generics","","",23,N],[12,"variants_stripped","","",23,N],[3,"Variant","","",N,N],[12,"kind","","",24,N],[3,"Span","","",N,N],[12,"filename","","",25,N],[12,"loline","","",25,N],[12,"locol","","",25,N],[12,"hiline","","",25,N],[12,"hicol","","",25,N],[3,"Path","","",N,N],[12,"global","","",26,N],[12,"def","","",26,N],[12,"segments","","",26,N],[3,"PathSegment","","",N,N],[12,"name","","",27,N],[12,"args","","",27,N],[3,"Typedef","","",N,N],[12,"type_","","",28,N],[12,"generics","","",28,N],[3,"Existential","","",N,N],[12,"bounds","","",29,N],[12,"generics","","",29,N],[3,"BareFunctionDecl","","",N,N],[12,"unsafety","","",30,N],[12,"generic_params","","",30,N],[12,"decl","","",30,N],[12,"abi","","",30,N],[3,"Static","","",N,N],[12,"type_","","",31,N],[12,"mutability","","",31,N],[12,"expr","","It's useful to have the value of a static documented, but I have no desire to represent expressions (that'd basically be all of the AST, which is huge!). So, have a string.",31,N],[3,"Constant","","",N,N],[12,"type_","","",32,N],[12,"expr","","",32,N],[3,"Impl","","",N,N],[12,"unsafety","","",33,N],[12,"generics","","",33,N],[12,"provided_trait_methods","","",33,N],[12,"trait_","","",33,N],[12,"for_","","",33,N],[12,"items","","",33,N],[12,"polarity","","",33,N],[12,"synthetic","","",33,N],[12,"blanket_impl","","",33,N],[3,"ImportSource","","",N,N],[12,"path","","",34,N],[12,"did","","",34,N],[3,"Macro","","",N,N],[12,"source","","",35,N],[12,"imported_from","","",35,N],[3,"Stability","","",N,N],[12,"level","","",36,N],[12,"feature","","",36,N],[12,"since","","",36,N],[12,"deprecated_since","","",36,N],[12,"deprecated_reason","","",36,N],[12,"unstable_reason","","",36,N],[12,"issue","","",36,N],[3,"Deprecation","","",N,N],[12,"since","","",37,N],[12,"note","","",37,N],[3,"TypeBinding","","An equality constraint on an associated type, e.g. `A=Bar` in `Foo<A=Bar>`",N,N],[12,"name","","",38,N],[12,"ty","","",38,N],[3,"RegionDeps","","",N,N],[12,"larger","","",39,N],[12,"smaller","","",39,N],[4,"ItemEnum","","",N,N],[13,"ExternCrateItem","","",40,N],[13,"ImportItem","","",40,N],[13,"StructItem","","",40,N],[13,"UnionItem","","",40,N],[13,"EnumItem","","",40,N],[13,"FunctionItem","","",40,N],[13,"ModuleItem","","",40,N],[13,"TypedefItem","","",40,N],[13,"ExistentialItem","","",40,N],[13,"StaticItem","","",40,N],[13,"ConstantItem","","",40,N],[13,"TraitItem","","",40,N],[13,"ImplItem","","",40,N],[13,"TyMethodItem","","A method signature only. Used for required methods in traits (ie, non-default-methods).",40,N],[13,"MethodItem","","A method with a body.",40,N],[13,"StructFieldItem","","",40,N],[13,"VariantItem","","",40,N],[13,"ForeignFunctionItem","","`fn`s from an extern block",40,N],[13,"ForeignStaticItem","","`static`s from an extern block",40,N],[13,"ForeignTypeItem","","`type`s from an extern block",40,N],[13,"MacroItem","","",40,N],[13,"PrimitiveItem","","",40,N],[13,"AssociatedConstItem","","",40,N],[13,"AssociatedTypeItem","","",40,N],[13,"StrippedItem","","An item that has been stripped by a rustdoc pass",40,N],[13,"KeywordItem","","",40,N],[4,"DocFragment","","A portion of documentation, extracted from a `#[doc]` attribute.",N,N],[13,"SugaredDoc","","A doc fragment created from a `///` or `//!` doc comment.",41,N],[13,"RawDoc","","A doc fragment created from a \"raw\" `#[doc=\"\"]` attribute.",41,N],[13,"Include","","A doc fragment created from a `#[doc(include=\"filename\")]` attribute. Contains both the given filename and the file contents.",41,N],[4,"GenericBound","","",N,N],[13,"TraitBound","","",42,N],[13,"Outlives","","",42,N],[4,"WherePredicate","","",N,N],[13,"BoundPredicate","","",43,N],[12,"ty","rustdoc::clean::WherePredicate","",43,N],[12,"bounds","","",43,N],[13,"RegionPredicate","rustdoc::clean","",43,N],[12,"lifetime","rustdoc::clean::WherePredicate","",43,N],[12,"bounds","","",43,N],[13,"EqPredicate","rustdoc::clean","",43,N],[12,"lhs","rustdoc::clean::WherePredicate","",43,N],[12,"rhs","","",43,N],[4,"GenericParamDefKind","rustdoc::clean","",N,N],[13,"Lifetime","","",44,N],[13,"Type","","",44,N],[12,"did","rustdoc::clean::GenericParamDefKind","",44,N],[12,"bounds","","",44,N],[12,"default","","",44,N],[12,"synthetic","","",44,N],[4,"SelfTy","rustdoc::clean","",N,N],[13,"SelfValue","","",45,N],[13,"SelfBorrowed","","",45,N],[13,"SelfExplicit","","",45,N],[4,"FunctionRetTy","","",N,N],[13,"Return","","",46,N],[13,"DefaultReturn","","",46,N],[4,"Type","","A representation of a Type suitable for hyperlinking purposes. Ideally one can get the original type out of the AST/TyCtxt given one of these, if more information is needed. Most importantly it does not preserve mutability or boxes.",N,N],[13,"ResolvedPath","","structs/enums/traits (most that'd be an hir::TyKind::Path)",47,N],[12,"path","rustdoc::clean::Type","",47,N],[12,"typarams","","",47,N],[12,"did","","",47,N],[12,"is_generic","","true if is a `T::Name` path for associated types",47,N],[13,"Generic","rustdoc::clean","For parameterized types, so the consumer of the JSON don't go looking for types which don't exist anywhere.",47,N],[13,"Primitive","","Primitives are the fixed-size numeric types (plus int/usize/float), char, arrays, slices, and tuples.",47,N],[13,"BareFunction","","extern \"ABI\" fn",47,N],[13,"Tuple","","",47,N],[13,"Slice","","",47,N],[13,"Array","","",47,N],[13,"Never","","",47,N],[13,"Unique","","",47,N],[13,"RawPointer","","",47,N],[13,"BorrowedRef","","",47,N],[12,"lifetime","rustdoc::clean::Type","",47,N],[12,"mutability","","",47,N],[12,"type_","","",47,N],[13,"QPath","rustdoc::clean","",47,N],[12,"name","rustdoc::clean::Type","",47,N],[12,"self_type","","",47,N],[12,"trait_","","",47,N],[13,"Infer","rustdoc::clean","",47,N],[13,"ImplTrait","","",47,N],[4,"PrimitiveType","","",N,N],[13,"Isize","","",48,N],[13,"I8","","",48,N],[13,"I16","","",48,N],[13,"I32","","",48,N],[13,"I64","","",48,N],[13,"I128","","",48,N],[13,"Usize","","",48,N],[13,"U8","","",48,N],[13,"U16","","",48,N],[13,"U32","","",48,N],[13,"U64","","",48,N],[13,"U128","","",48,N],[13,"F32","","",48,N],[13,"F64","","",48,N],[13,"Char","","",48,N],[13,"Bool","","",48,N],[13,"Str","","",48,N],[13,"Slice","","",48,N],[13,"Array","","",48,N],[13,"Tuple","","",48,N],[13,"Unit","","",48,N],[13,"RawPointer","","",48,N],[13,"Reference","","",48,N],[13,"Fn","","",48,N],[13,"Never","","",48,N],[4,"TypeKind","","",N,N],[13,"Enum","","",49,N],[13,"Function","","",49,N],[13,"Module","","",49,N],[13,"Const","","",49,N],[13,"Static","","",49,N],[13,"Struct","","",49,N],[13,"Union","","",49,N],[13,"Trait","","",49,N],[13,"Variant","","",49,N],[13,"Typedef","","",49,N],[13,"Foreign","","",49,N],[13,"Macro","","",49,N],[4,"Visibility","","",N,N],[13,"Public","","",50,N],[13,"Inherited","","",50,N],[13,"Crate","","",50,N],[13,"Restricted","","",50,N],[4,"VariantKind","","",N,N],[13,"CLike","","",51,N],[13,"Tuple","","",51,N],[13,"Struct","","",51,N],[4,"GenericArgs","","",N,N],[13,"AngleBracketed","","",52,N],[12,"lifetimes","rustdoc::clean::GenericArgs","",52,N],[12,"types","","",52,N],[12,"bindings","","",52,N],[13,"Parenthesized","rustdoc::clean","",52,N],[12,"inputs","rustdoc::clean::GenericArgs","",52,N],[12,"output","","",52,N],[4,"Mutability","rustdoc::clean","",N,N],[13,"Mutable","","",53,N],[13,"Immutable","","",53,N],[4,"ImplPolarity","","",N,N],[13,"Positive","","",54,N],[13,"Negative","","",54,N],[4,"Import","","",N,N],[13,"Simple","","",55,N],[13,"Glob","","",55,N],[4,"RegionTarget","","",N,N],[13,"Region","","",56,N],[13,"RegionVid","","",56,N],[4,"SimpleBound","","",N,N],[13,"TraitBound","","",57,N],[13,"Outlives","","",57,N],[4,"AutoTraitResult","","",N,N],[13,"ExplicitImpl","","",58,N],[13,"PositiveImpl","","",58,N],[13,"NegativeImpl","","",58,N],[5,"get_stability","","",N,[[["doccontext"],["defid"]],["option",["stability"]]]],[5,"get_deprecation","","",N,[[["doccontext"],["defid"]],["option",["deprecation"]]]],[5,"external_generic_args","","",N,[[["doccontext"],["option",["defid"]],["bool"],["vec",["typebinding"]],["substs"]],["genericargs"]]],[5,"external_path","","",N,[[["doccontext"],["str"],["option",["defid"]],["bool"],["vec",["typebinding"]],["substs"]],["path"]]],[5,"strip_type","","",N,[[["type"]],["type"]]],[5,"strip_path","","",N,[[["path"]],["path"]]],[5,"qpath_to_string","","",N,[[["qpath"]],["string"]]],[5,"get_auto_traits_with_node_id","","",N,[[["doccontext"],["nodeid"],["string"]],["vec",["item"]]]],[5,"get_auto_traits_with_def_id","","",N,[[["doccontext"],["defid"]],["vec",["item"]]]],[5,"get_blanket_impls_with_node_id","","",N,[[["doccontext"],["nodeid"],["string"]],["vec",["item"]]]],[5,"get_blanket_impls_with_def_id","","",N,[[["doccontext"],["defid"]],["vec",["item"]]]],[5,"build_deref_target_impls","","",N,N],[5,"name_from_pat","","",N,[[["pat"]],["string"]]],[5,"print_const","","",N,[[["doccontext"],["const"]],["string"]]],[5,"print_const_expr","","",N,[[["doccontext"],["bodyid"]],["string"]]],[5,"resolve_type","","Given a type Path, resolve it to a Type using the TyCtxt",N,[[["doccontext"],["path"],["nodeid"]],["type"]]],[5,"register_def","","",N,[[["doccontext"],["def"]],["defid"]]],[5,"resolve_use_source","","",N,[[["doccontext"],["path"]],["importsource"]]],[5,"def_id_to_path","","",N,[[["doccontext"],["defid"],["option",["string"]]],["vec",["string"]]]],[5,"enter_impl_trait","","",N,[[["doccontext"],["f"]],["r"]]],[5,"path_to_def_local","","",N,N],[5,"path_to_def","","",N,N],[5,"get_path_for_type","","",N,[[["tyctxt"],["defid"],["f"]],["path"]]],[0,"inline","","Support for inlining external documentation into the current AST.",N,N],[5,"try_inline","rustdoc::clean::inline","Attempt to inline a definition into this AST.",N,[[["doccontext"],["def"],["name"],["fxhashset"]],["option",["vec"]]]],[5,"try_inline_glob","","",N,[[["doccontext"],["def"],["fxhashset"]],["option",["vec"]]]],[5,"load_attrs","","",N,[[["doccontext"],["defid"]],["attributes"]]],[5,"record_extern_fqn","","Record an external fully qualified name in the external_paths cache.",N,[[["doccontext"],["defid"],["typekind"]]]],[5,"build_external_trait","","",N,[[["doccontext"],["defid"]],["trait"]]],[5,"build_external_function","","",N,[[["doccontext"],["defid"]],["function"]]],[5,"build_enum","","",N,[[["doccontext"],["defid"]],["enum"]]],[5,"build_struct","","",N,[[["doccontext"],["defid"]],["struct"]]],[5,"build_union","","",N,[[["doccontext"],["defid"]],["union"]]],[5,"build_type_alias","","",N,[[["doccontext"],["defid"]],["typedef"]]],[5,"build_impls","","",N,[[["doccontext"],["defid"],["bool"]],["vec",["item"]]]],[5,"build_impl","","",N,[[["doccontext"],["defid"],["vec"]]]],[5,"build_module","","",N,[[["doccontext"],["defid"],["fxhashset"]],["module"]]],[5,"print_inlined_const","","",N,[[["doccontext"],["defid"]],["string"]]],[5,"build_const","","",N,[[["doccontext"],["defid"]],["constant"]]],[5,"build_static","","",N,[[["doccontext"],["defid"],["bool"]],["static"]]],[5,"build_macro","","",N,[[["doccontext"],["defid"],["name"]],["option",["macro"]]]],[5,"filter_non_trait_generics","","A trait's generics clause actually contains all of the predicates for all of its associated types as well. We specifically move these clauses to the associated types instead when displaying, so when we're generating the generics for the trait itself we need to be sure to remove them. We also need to remove the implied \"recursive\" Self: Trait bound.",N,[[["defid"],["generics"]],["generics"]]],[5,"separate_supertrait_bounds","","Supertrait bounds for a trait are also listed in the generics coming from the metadata for a crate, so we want to separate those out and create a new list of explicit supertrait bounds to render nicely.",N,N],[5,"record_extern_trait","","",N,[[["doccontext"],["defid"]]]],[0,"cfg","rustdoc::clean","Representation of a `#[doc(cfg(...))]` attribute.",N,N],[3,"InvalidCfgError","rustdoc::clean::cfg","",N,N],[12,"msg","","",59,N],[12,"span","","",59,N],[3,"Html","","Pretty-print wrapper for a `Cfg`. Also indicates whether the \"short-form\" rendering should be used.",N,N],[12,"0","","",60,N],[12,"1","","",60,N],[4,"Cfg","","",N,N],[13,"True","","Accepts all configurations.",61,N],[13,"False","","Denies all configurations.",61,N],[13,"Cfg","","A generic configuration option, e.g. `test` or `target_os = \"linux\"`.",61,N],[13,"Not","","Negate a configuration requirement, i.e. `not(x)`.",61,N],[13,"Any","","Union of a list of configuration requirements, i.e. `any(...)`.",61,N],[13,"All","","Intersection of a list of configuration requirements, i.e. `all(...)`.",61,N],[5,"write_with_opt_paren","","",N,[[["formatter"],["bool"],["t"]],["result"]]],[11,"clone","","",61,[[["self"]],["cfg"]]],[11,"encode","","",61,[[["self"],["__s"]],["result"]]],[11,"decode","","",61,[[["__d"]],["result",["cfg"]]]],[11,"fmt","","",61,[[["self"],["formatter"]],["result"]]],[11,"eq","","",61,[[["self"],["cfg"]],["bool"]]],[11,"ne","","",61,[[["self"],["cfg"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",61,N],[11,"hash","","",61,N],[11,"eq","","",59,[[["self"],["invalidcfgerror"]],["bool"]]],[11,"ne","","",59,[[["self"],["invalidcfgerror"]],["bool"]]],[11,"fmt","","",59,[[["self"],["formatter"]],["result"]]],[11,"parse_nested","","Parses a `NestedMetaItem` into a `Cfg`.",61,[[["nestedmetaitem"]],["result",["cfg","invalidcfgerror"]]]],[11,"parse","","Parses a `MetaItem` into a `Cfg`.",61,[[["metaitem"]],["result",["cfg","invalidcfgerror"]]]],[11,"matches","","Checks whether the given configuration can be matched in the current session.",61,[[["self"],["parsesess"],["option",["features"]]],["bool"]]],[11,"is_simple","","Whether the configuration consists of just `Cfg` or `Not`.",61,[[["self"]],["bool"]]],[11,"is_all","","Whether the configuration consists of just `Cfg`, `Not` or `All`.",61,[[["self"]],["bool"]]],[11,"render_short_html","","Renders the configuration for human display, as a short HTML description.",61,[[["self"]],["string"]]],[11,"render_long_html","","Renders the configuration for long display, as a long HTML description.",61,[[["self"]],["string"]]],[11,"should_capitalize_first_letter","","",61,[[["self"]],["bool"]]],[11,"should_append_only_to_description","","",61,[[["self"]],["bool"]]],[11,"should_use_with_in_description","","",61,[[["self"]],["bool"]]],[11,"not","","",61,[[["self"]],["cfg"]]],[11,"bitand_assign","","",61,[[["self"],["cfg"]]]],[11,"bitand","","",61,[[["self"],["cfg"]],["cfg"]]],[11,"bitor_assign","","",61,[[["self"],["cfg"]]]],[11,"bitor","","",61,[[["self"],["cfg"]],["cfg"]]],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[0,"simplify","rustdoc::clean","Simplification of where clauses and parameter bounds into a prettier and more canonical form.",N,N],[5,"where_clauses","rustdoc::clean::simplify","",N,[[["doccontext"],["vec",["wp"]]],["vec",["wp"]]]],[5,"ty_params","","",N,[[["vec",["genericparamdef"]]],["vec",["genericparamdef"]]]],[5,"ty_bounds","","",N,[[["vec",["genericbound"]]],["vec",["genericbound"]]]],[5,"trait_is_same_or_supertrait","","",N,[[["doccontext"],["defid"],["defid"]],["bool"]]],[0,"auto_trait","rustdoc::clean","",N,N],[3,"AutoTraitFinder","rustdoc::clean::auto_trait","",N,N],[12,"cx","","",62,N],[12,"f","","",62,N],[3,"RegionReplacer","","",N,N],[12,"vid_to_region","","",63,N],[12,"tcx","","",63,N],[11,"new","","",62,[[["doccontext"]],["self"]]],[11,"get_with_def_id","","",62,[[["self"],["defid"]],["vec",["item"]]]],[11,"get_with_node_id","","",62,[[["self"],["nodeid"],["string"]],["vec",["item"]]]],[11,"get_auto_trait_impls","","",62,[[["self"],["defid"],["f"],["option",["string"]]],["vec",["item"]]]],[11,"get_auto_trait_impl_for","","",62,[[["self"],["defid"],["option",["string"]],["generics"],["f"],["defid"]],["option",["item"]]]],[11,"find_auto_trait_generics","","",62,[[["self"],["defid"],["defid"],["generics"]],["autotraitresult"]]],[11,"get_lifetime","","",62,[[["self"],["region"],["fxhashmap"]],["lifetime"]]],[11,"region_name","","",62,[[["self"],["region"]],["option",["string"]]]],[11,"handle_lifetimes","","",62,[[["self"],["regionconstraintdata"],["fxhashmap"]],["vec",["wherepredicate"]]]],[11,"extract_for_generics","","",62,[[["self"],["tyctxt"],["predicate"]],["fxhashset",["genericparamdef"]]]],[11,"make_final_bounds","","",62,[[["self"],["fxhashmap",["type","fxhashset"]],["fxhashmap",["type"]],["fxhashmap",["lifetime","fxhashset"]]],["vec",["wherepredicate"]]]],[11,"param_env_to_generics","","",62,[[["self"],["tyctxt"],["defid"],["paramenv"],["generics"],["vec",["wherepredicate"]],["fxhashmap",["regionvid","region"]]],["generics"]]],[11,"sort_where_predicates","","",62,[[["self"],["vec"]]]],[11,"sort_where_bounds","","",62,[[["self"],["vec"]]]],[11,"unstable_debug_sort","","",62,[[["self"],["vec"]]]],[11,"is_fn_ty","","",62,[[["self"],["tyctxt"],["type"]],["bool"]]],[11,"tcx","","",63,[[["self"]],["tyctxt"]]],[11,"fold_region","","",63,[[["self"],["region"]],["region"]]],[0,"blanket_impl","rustdoc::clean","",N,N],[3,"BlanketImplFinder","rustdoc::clean::blanket_impl","",N,N],[12,"cx","","",64,N],[11,"new","","",64,[[["doccontext"]],["self"]]],[11,"get_with_def_id","","",64,[[["self"],["defid"]],["vec",["item"]]]],[11,"get_with_node_id","","",64,[[["self"],["nodeid"],["string"]],["vec",["item"]]]],[11,"get_blanket_impls","","",64,[[["self"],["defid"],["f"],["option",["string"]]],["vec",["item"]]]],[0,"def_ctor","rustdoc::clean","",N,N],[5,"get_def_from_def_id","rustdoc::clean::def_ctor","",N,[[["doccontext"],["defid"],["f"]],["vec",["item"]]]],[5,"get_def_from_node_id","","",N,[[["doccontext"],["nodeid"],["string"],["f"]],["vec",["item"]]]],[17,"MAX_DEF_ID","rustdoc::clean","",N,N],[17,"FN_OUTPUT_NAME","","",N,N],[8,"Clean","","",N,N],[10,"clean","","",65,[[["self"],["doccontext"]],["t"]]],[8,"AttributesExt","","",N,N],[10,"lists","","Finds an attribute as List and returns the list of attributes nested inside.",66,[[["self"],["str"]],["listattributesiter"]]],[8,"NestedAttributesExt","","",N,N],[10,"has_word","","Returns whether the attribute list contains a specific `Word`",67,[[["self"],["str"]],["bool"]]],[8,"GetDefId","","",N,N],[10,"def_id","","",68,[[["self"]],["option",["defid"]]]],[8,"ToSource","","",N,N],[10,"to_src","","",69,[[["self"],["doccontext"]],["string"]]],[11,"clone","","",3,[[["self"]],["crate"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"clone","","",4,[[["self"]],["externalcrate"]]],[11,"encode","","",4,[[["self"],["__s"]],["result"]]],[11,"decode","","",4,[[["__d"]],["result",["externalcrate"]]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",5,[[["self"]],["item"]]],[11,"encode","","",5,[[["self"],["__s"]],["result"]]],[11,"decode","","",5,[[["__d"]],["result",["item"]]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"doc_value","","Finds the `doc` attribute as a NameValue and returns the corresponding value found.",5,[[["self"]],["option",["str"]]]],[11,"collapsed_doc_value","","Finds all `doc` attributes as NameValues and returns their corresponding values, joined with newlines.",5,[[["self"]],["option",["string"]]]],[11,"links","","",5,[[["self"]],["vec"]]],[11,"is_crate","","",5,[[["self"]],["bool"]]],[11,"is_mod","","",5,[[["self"]],["bool"]]],[11,"is_trait","","",5,[[["self"]],["bool"]]],[11,"is_struct","","",5,[[["self"]],["bool"]]],[11,"is_enum","","",5,[[["self"]],["bool"]]],[11,"is_associated_type","","",5,[[["self"]],["bool"]]],[11,"is_associated_const","","",5,[[["self"]],["bool"]]],[11,"is_method","","",5,[[["self"]],["bool"]]],[11,"is_ty_method","","",5,[[["self"]],["bool"]]],[11,"is_typedef","","",5,[[["self"]],["bool"]]],[11,"is_primitive","","",5,[[["self"]],["bool"]]],[11,"is_union","","",5,[[["self"]],["bool"]]],[11,"is_import","","",5,[[["self"]],["bool"]]],[11,"is_extern_crate","","",5,[[["self"]],["bool"]]],[11,"is_keyword","","",5,[[["self"]],["bool"]]],[11,"is_stripped","","",5,[[["self"]],["bool"]]],[11,"has_stripped_fields","","",5,[[["self"]],["option",["bool"]]]],[11,"stability_class","","",5,[[["self"]],["option",["string"]]]],[11,"stable_since","","",5,[[["self"]],["option",["str"]]]],[11,"is_non_exhaustive","","",5,[[["self"]],["bool"]]],[11,"type_","","Returns a documentation-level item type from the item.",5,[[["self"]],["itemtype"]]],[11,"clone","","",40,[[["self"]],["itemenum"]]],[11,"encode","","",40,[[["self"],["__s"]],["result"]]],[11,"decode","","",40,[[["__d"]],["result",["itemenum"]]]],[11,"fmt","","",40,[[["self"],["formatter"]],["result"]]],[11,"generics","","",40,[[["self"]],["option",["generics"]]]],[11,"clone","","",6,[[["self"]],["module"]]],[11,"encode","","",6,[[["self"],["__s"]],["result"]]],[11,"decode","","",6,[[["__d"]],["result",["module"]]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"next","","",7,[[["self"]],["option"]]],[11,"size_hint","","",7,N],[11,"clone","","",41,[[["self"]],["docfragment"]]],[11,"encode","","",41,[[["self"],["__s"]],["result"]]],[11,"decode","","",41,[[["__d"]],["result",["docfragment"]]]],[11,"eq","","",41,[[["self"],["docfragment"]],["bool"]]],[11,"ne","","",41,[[["self"],["docfragment"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",41,N],[11,"fmt","","",41,[[["self"],["formatter"]],["result"]]],[11,"hash","","",41,N],[11,"as_str","","",41,[[["self"]],["str"]]],[11,"span","","",41,[[["self"]],["span"]]],[11,"clone","","",8,[[["self"]],["attributes"]]],[11,"encode","","",8,[[["self"],["__s"]],["result"]]],[11,"decode","","",8,[[["__d"]],["result",["attributes"]]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"default","","",8,[[],["attributes"]]],[11,"extract_cfg","","Extracts the content from an attribute `#[doc(cfg(content))]`.",8,[[["metaitem"]],["option",["metaitem"]]]],[11,"extract_include","","Reads a `MetaItem` from within an attribute, looks for whether it is a `#[doc(include=\"file\")]`, and returns the filename and contents of the file as loaded from its expansion.",8,[[["metaitem"]],["option"]]],[11,"has_doc_flag","","",8,[[["self"],["str"]],["bool"]]],[11,"from_ast","","",8,N],[11,"doc_value","","Finds the `doc` attribute as a NameValue and returns the corresponding value found.",8,[[["self"]],["option",["str"]]]],[11,"collapsed_doc_value","","Finds all `doc` attributes as NameValues and returns their corresponding values, joined with newlines.",8,[[["self"]],["option",["string"]]]],[11,"links","","Get links as a vector",8,[[["self"],["cratenum"]],["vec"]]],[11,"eq","","",8,[[["self"],["self"]],["bool"]]],[11,"hash","","",8,[[["self"],["h"]]]],[11,"lists","","",8,[[["self"],["str"]],["listattributesiter"]]],[11,"clone","","",42,[[["self"]],["genericbound"]]],[11,"encode","","",42,[[["self"],["__s"]],["result"]]],[11,"decode","","",42,[[["__d"]],["result",["genericbound"]]]],[11,"eq","","",42,[[["self"],["genericbound"]],["bool"]]],[11,"ne","","",42,[[["self"],["genericbound"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",42,N],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"hash","","",42,N],[11,"maybe_sized","","",42,[[["doccontext"]],["genericbound"]]],[11,"is_sized_bound","","",42,[[["self"],["doccontext"]],["bool"]]],[11,"get_poly_trait","","",42,[[["self"]],["option",["polytrait"]]]],[11,"get_trait_type","","",42,[[["self"]],["option",["type"]]]],[11,"clone","","",9,[[["self"]],["lifetime"]]],[11,"encode","","",9,[[["self"],["__s"]],["result"]]],[11,"decode","","",9,[[["__d"]],["result",["lifetime"]]]],[11,"eq","","",9,[[["self"],["lifetime"]],["bool"]]],[11,"ne","","",9,[[["self"],["lifetime"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",9,N],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"hash","","",9,N],[11,"get_ref","","",9,[[["self"]],["str"]]],[11,"statik","","",9,[[],["lifetime"]]],[11,"clone","","",43,[[["self"]],["wherepredicate"]]],[11,"encode","","",43,[[["self"],["__s"]],["result"]]],[11,"decode","","",43,[[["__d"]],["result",["wherepredicate"]]]],[11,"eq","","",43,[[["self"],["wherepredicate"]],["bool"]]],[11,"ne","","",43,[[["self"],["wherepredicate"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",43,N],[11,"fmt","","",43,[[["self"],["formatter"]],["result"]]],[11,"hash","","",43,N],[11,"clone","","",44,[[["self"]],["genericparamdefkind"]]],[11,"encode","","",44,[[["self"],["__s"]],["result"]]],[11,"decode","","",44,[[["__d"]],["result",["genericparamdefkind"]]]],[11,"eq","","",44,[[["self"],["genericparamdefkind"]],["bool"]]],[11,"ne","","",44,[[["self"],["genericparamdefkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",44,N],[11,"fmt","","",44,[[["self"],["formatter"]],["result"]]],[11,"hash","","",44,N],[11,"clone","","",10,[[["self"]],["genericparamdef"]]],[11,"encode","","",10,[[["self"],["__s"]],["result"]]],[11,"decode","","",10,[[["__d"]],["result",["genericparamdef"]]]],[11,"eq","","",10,[[["self"],["genericparamdef"]],["bool"]]],[11,"ne","","",10,[[["self"],["genericparamdef"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",10,N],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"hash","","",10,N],[11,"is_synthetic_type_param","","",10,[[["self"]],["bool"]]],[11,"clone","","",11,[[["self"]],["generics"]]],[11,"encode","","",11,[[["self"],["__s"]],["result"]]],[11,"decode","","",11,[[["__d"]],["result",["generics"]]]],[11,"eq","","",11,[[["self"],["generics"]],["bool"]]],[11,"ne","","",11,[[["self"],["generics"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",11,N],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"default","","",11,[[],["generics"]]],[11,"hash","","",11,N],[11,"clone","","",12,[[["self"]],["method"]]],[11,"encode","","",12,[[["self"],["__s"]],["result"]]],[11,"decode","","",12,[[["__d"]],["result",["method"]]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"clone","","",13,[[["self"]],["tymethod"]]],[11,"encode","","",13,[[["self"],["__s"]],["result"]]],[11,"decode","","",13,[[["__d"]],["result",["tymethod"]]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"clone","","",14,[[["self"]],["function"]]],[11,"encode","","",14,[[["self"],["__s"]],["result"]]],[11,"decode","","",14,[[["__d"]],["result",["function"]]]],[11,"fmt","","",14,[[["self"],["formatter"]],["result"]]],[11,"clone","","",15,[[["self"]],["fndecl"]]],[11,"encode","","",15,[[["self"],["__s"]],["result"]]],[11,"decode","","",15,[[["__d"]],["result",["fndecl"]]]],[11,"eq","","",15,[[["self"],["fndecl"]],["bool"]]],[11,"ne","","",15,[[["self"],["fndecl"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",15,N],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"hash","","",15,N],[11,"self_type","","",15,[[["self"]],["option",["selfty"]]]],[11,"clone","","",16,[[["self"]],["arguments"]]],[11,"encode","","",16,[[["self"],["__s"]],["result"]]],[11,"decode","","",16,[[["__d"]],["result",["arguments"]]]],[11,"eq","","",16,[[["self"],["arguments"]],["bool"]]],[11,"ne","","",16,[[["self"],["arguments"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",16,N],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"hash","","",16,N],[11,"clone","","",17,[[["self"]],["argument"]]],[11,"encode","","",17,[[["self"],["__s"]],["result"]]],[11,"decode","","",17,[[["__d"]],["result",["argument"]]]],[11,"eq","","",17,[[["self"],["argument"]],["bool"]]],[11,"ne","","",17,[[["self"],["argument"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",17,N],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"hash","","",17,N],[11,"clone","","",45,[[["self"]],["selfty"]]],[11,"encode","","",45,[[["self"],["__s"]],["result"]]],[11,"decode","","",45,[[["__d"]],["result",["selfty"]]]],[11,"eq","","",45,[[["self"],["selfty"]],["bool"]]],[11,"ne","","",45,[[["self"],["selfty"]],["bool"]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result"]]],[11,"to_self","","",17,[[["self"]],["option",["selfty"]]]],[11,"clone","","",46,[[["self"]],["functionretty"]]],[11,"encode","","",46,[[["self"],["__s"]],["result"]]],[11,"decode","","",46,[[["__d"]],["result",["functionretty"]]]],[11,"eq","","",46,[[["self"],["functionretty"]],["bool"]]],[11,"ne","","",46,[[["self"],["functionretty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",46,N],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"hash","","",46,N],[11,"def_id","","",46,[[["self"]],["option",["defid"]]]],[11,"clone","","",18,[[["self"]],["trait"]]],[11,"encode","","",18,[[["self"],["__s"]],["result"]]],[11,"decode","","",18,[[["__d"]],["result",["trait"]]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"clone","","",19,[[["self"]],["polytrait"]]],[11,"encode","","",19,[[["self"],["__s"]],["result"]]],[11,"decode","","",19,[[["__d"]],["result",["polytrait"]]]],[11,"eq","","",19,[[["self"],["polytrait"]],["bool"]]],[11,"ne","","",19,[[["self"],["polytrait"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"hash","","",19,N],[11,"clone","","",47,[[["self"]],["type"]]],[11,"encode","","",47,[[["self"],["__s"]],["result"]]],[11,"decode","","",47,[[["__d"]],["result",["type"]]]],[11,"eq","","",47,[[["self"],["type"]],["bool"]]],[11,"ne","","",47,[[["self"],["type"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",47,N],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"hash","","",47,N],[11,"clone","","",48,[[["self"]],["primitivetype"]]],[11,"encode","","",48,[[["self"],["__s"]],["result"]]],[11,"decode","","",48,[[["__d"]],["result",["primitivetype"]]]],[11,"eq","","",48,[[["self"],["primitivetype"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",48,N],[11,"hash","","",48,N],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"clone","","",49,[[["self"]],["typekind"]]],[11,"encode","","",49,[[["self"],["__s"]],["result"]]],[11,"decode","","",49,[[["__d"]],["result",["typekind"]]]],[11,"fmt","","",49,[[["self"],["formatter"]],["result"]]],[11,"primitive_type","","",47,[[["self"]],["option",["primitivetype"]]]],[11,"is_generic","","",47,[[["self"]],["bool"]]],[11,"is_self_type","","",47,[[["self"]],["bool"]]],[11,"generics","","",47,[[["self"]],["option"]]],[11,"def_id","","",47,[[["self"]],["option",["defid"]]]],[11,"from_str","","",48,[[["str"]],["option",["primitivetype"]]]],[11,"as_str","","",48,[[["self"]],["str"]]],[11,"to_url_str","","",48,[[["self"]],["str"]]],[11,"from","","",48,[[["intty"]],["primitivetype"]]],[11,"from","","",48,[[["uintty"]],["primitivetype"]]],[11,"from","","",48,[[["floatty"]],["primitivetype"]]],[11,"clone","","",50,[[["self"]],["visibility"]]],[11,"eq","","",50,[[["self"],["visibility"]],["bool"]]],[11,"ne","","",50,[[["self"],["visibility"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",50,N],[11,"decode","","",50,[[["__d"]],["result",["visibility"]]]],[11,"encode","","",50,[[["self"],["__s"]],["result"]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"clone","","",20,[[["self"]],["struct"]]],[11,"encode","","",20,[[["self"],["__s"]],["result"]]],[11,"decode","","",20,[[["__d"]],["result",["struct"]]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"clone","","",21,[[["self"]],["union"]]],[11,"encode","","",21,[[["self"],["__s"]],["result"]]],[11,"decode","","",21,[[["__d"]],["result",["union"]]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"clone","","",22,[[["self"]],["variantstruct"]]],[11,"encode","","",22,[[["self"],["__s"]],["result"]]],[11,"decode","","",22,[[["__d"]],["result",["variantstruct"]]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"clone","","",23,[[["self"]],["enum"]]],[11,"encode","","",23,[[["self"],["__s"]],["result"]]],[11,"decode","","",23,[[["__d"]],["result",["enum"]]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"clone","","",24,[[["self"]],["variant"]]],[11,"encode","","",24,[[["self"],["__s"]],["result"]]],[11,"decode","","",24,[[["__d"]],["result",["variant"]]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"clone","","",51,[[["self"]],["variantkind"]]],[11,"encode","","",51,[[["self"],["__s"]],["result"]]],[11,"decode","","",51,[[["__d"]],["result",["variantkind"]]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"clone","","",25,[[["self"]],["span"]]],[11,"encode","","",25,[[["self"],["__s"]],["result"]]],[11,"decode","","",25,[[["__d"]],["result",["span"]]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"empty","","",25,[[],["span"]]],[11,"clone","","",26,[[["self"]],["path"]]],[11,"encode","","",26,[[["self"],["__s"]],["result"]]],[11,"decode","","",26,[[["__d"]],["result",["path"]]]],[11,"eq","","",26,[[["self"],["path"]],["bool"]]],[11,"ne","","",26,[[["self"],["path"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",26,N],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"hash","","",26,N],[11,"last_name","","",26,[[["self"]],["str"]]],[11,"clone","","",52,[[["self"]],["genericargs"]]],[11,"encode","","",52,[[["self"],["__s"]],["result"]]],[11,"decode","","",52,[[["__d"]],["result",["genericargs"]]]],[11,"eq","","",52,[[["self"],["genericargs"]],["bool"]]],[11,"ne","","",52,[[["self"],["genericargs"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",52,N],[11,"fmt","","",52,[[["self"],["formatter"]],["result"]]],[11,"hash","","",52,N],[11,"clone","","",27,[[["self"]],["pathsegment"]]],[11,"encode","","",27,[[["self"],["__s"]],["result"]]],[11,"decode","","",27,[[["__d"]],["result",["pathsegment"]]]],[11,"eq","","",27,[[["self"],["pathsegment"]],["bool"]]],[11,"ne","","",27,[[["self"],["pathsegment"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",27,N],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"hash","","",27,N],[11,"clone","","",28,[[["self"]],["typedef"]]],[11,"encode","","",28,[[["self"],["__s"]],["result"]]],[11,"decode","","",28,[[["__d"]],["result",["typedef"]]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"clone","","",29,[[["self"]],["existential"]]],[11,"encode","","",29,[[["self"],["__s"]],["result"]]],[11,"decode","","",29,[[["__d"]],["result",["existential"]]]],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"clone","","",30,[[["self"]],["barefunctiondecl"]]],[11,"encode","","",30,[[["self"],["__s"]],["result"]]],[11,"decode","","",30,[[["__d"]],["result",["barefunctiondecl"]]]],[11,"eq","","",30,[[["self"],["barefunctiondecl"]],["bool"]]],[11,"ne","","",30,[[["self"],["barefunctiondecl"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",30,N],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"hash","","",30,N],[11,"clone","","",31,[[["self"]],["static"]]],[11,"encode","","",31,[[["self"],["__s"]],["result"]]],[11,"decode","","",31,[[["__d"]],["result",["static"]]]],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"clone","","",32,[[["self"]],["constant"]]],[11,"encode","","",32,[[["self"],["__s"]],["result"]]],[11,"decode","","",32,[[["__d"]],["result",["constant"]]]],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"clone","","",53,[[["self"]],["mutability"]]],[11,"encode","","",53,[[["self"],["__s"]],["result"]]],[11,"decode","","",53,[[["__d"]],["result",["mutability"]]]],[11,"eq","","",53,[[["self"],["mutability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",53,N],[11,"hash","","",53,N],[11,"clone","","",54,[[["self"]],["implpolarity"]]],[11,"encode","","",54,[[["self"],["__s"]],["result"]]],[11,"decode","","",54,[[["__d"]],["result",["implpolarity"]]]],[11,"eq","","",54,[[["self"],["implpolarity"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",54,N],[11,"fmt","","",54,[[["self"],["formatter"]],["result"]]],[11,"hash","","",54,N],[11,"clone","","",33,[[["self"]],["impl"]]],[11,"encode","","",33,[[["self"],["__s"]],["result"]]],[11,"decode","","",33,[[["__d"]],["result",["impl"]]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"clone","","",55,[[["self"]],["import"]]],[11,"encode","","",55,[[["self"],["__s"]],["result"]]],[11,"decode","","",55,[[["__d"]],["result",["import"]]]],[11,"fmt","","",55,[[["self"],["formatter"]],["result"]]],[11,"clone","","",34,[[["self"]],["importsource"]]],[11,"encode","","",34,[[["self"],["__s"]],["result"]]],[11,"decode","","",34,[[["__d"]],["result",["importsource"]]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"clone","","",35,[[["self"]],["macro"]]],[11,"encode","","",35,[[["self"],["__s"]],["result"]]],[11,"decode","","",35,[[["__d"]],["result",["macro"]]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"clone","","",36,[[["self"]],["stability"]]],[11,"encode","","",36,[[["self"],["__s"]],["result"]]],[11,"decode","","",36,[[["__d"]],["result",["stability"]]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"clone","","",37,[[["self"]],["deprecation"]]],[11,"encode","","",37,[[["self"],["__s"]],["result"]]],[11,"decode","","",37,[[["__d"]],["result",["deprecation"]]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"clone","","",38,[[["self"]],["typebinding"]]],[11,"eq","","",38,[[["self"],["typebinding"]],["bool"]]],[11,"ne","","",38,[[["self"],["typebinding"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",38,N],[11,"decode","","",38,[[["__d"]],["result",["typebinding"]]]],[11,"encode","","",38,[[["self"],["__s"]],["result"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"hash","","",38,N],[11,"assert_receiver_is_total_eq","","",56,N],[11,"eq","","",56,[[["self"],["regiontarget"]],["bool"]]],[11,"ne","","",56,[[["self"],["regiontarget"]],["bool"]]],[11,"hash","","",56,N],[11,"clone","","",56,[[["self"]],["regiontarget"]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"default","","",39,[[],["regiondeps"]]],[11,"fmt","","",39,[[["self"],["formatter"]],["result"]]],[11,"clone","","",39,[[["self"]],["regiondeps"]]],[11,"assert_receiver_is_total_eq","","",57,N],[11,"eq","","",57,[[["self"],["simplebound"]],["bool"]]],[11,"ne","","",57,[[["self"],["simplebound"]],["bool"]]],[11,"hash","","",57,N],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"is_auto","","",58,[[["self"]],["bool"]]],[11,"from","","",57,[[["genericbound"]],["self"]]],[0,"core","rustdoc","",N,N],[4,"Input","rustdoc::core","",N,N],[13,"File","","Load source from file",70,N],[13,"Str","","",70,N],[12,"name","rustdoc::core::Input","String that is shown in place of a filename",70,N],[12,"input","","Anonymous source string",70,N],[3,"Options","rustdoc::core","",N,N],[12,"crate_types","","",71,N],[12,"optimize","","",71,N],[12,"debug_assertions","","",71,N],[12,"debuginfo","","",71,N],[12,"lint_opts","","",71,N],[12,"lint_cap","","",71,N],[12,"describe_lints","","",71,N],[12,"output_types","","",71,N],[12,"search_paths","","",71,N],[12,"libs","","",71,N],[12,"maybe_sysroot","","",71,N],[12,"target_triple","","",71,N],[12,"test","","",71,N],[12,"error_format","","",71,N],[12,"incremental","","",71,N],[12,"debugging_opts","","",71,N],[12,"prints","","",71,N],[12,"borrowck_mode","","",71,N],[12,"cg","","",71,N],[12,"externs","","",71,N],[12,"crate_name","","",71,N],[12,"alt_std_name","","",71,N],[12,"unstable_features","","",71,N],[12,"actually_rustdoc","","",71,N],[12,"cli_forced_codegen_units","","",71,N],[12,"cli_forced_thinlto_off","","",71,N],[12,"remap_path_prefix","","",71,N],[12,"edition","","",71,N],[3,"CodegenOptions","","",N,N],[12,"ar","","",72,N],[12,"linker","","",72,N],[12,"link_arg","","",72,N],[12,"link_args","","",72,N],[12,"link_dead_code","","",72,N],[12,"lto","","",72,N],[12,"target_cpu","","",72,N],[12,"target_feature","","",72,N],[12,"passes","","",72,N],[12,"llvm_args","","",72,N],[12,"save_temps","","",72,N],[12,"rpath","","",72,N],[12,"overflow_checks","","",72,N],[12,"no_prepopulate_passes","","",72,N],[12,"no_vectorize_loops","","",72,N],[12,"no_vectorize_slp","","",72,N],[12,"soft_float","","",72,N],[12,"prefer_dynamic","","",72,N],[12,"no_integrated_as","","",72,N],[12,"no_redzone","","",72,N],[12,"relocation_model","","",72,N],[12,"code_model","","",72,N],[12,"metadata","","",72,N],[12,"extra_filename","","",72,N],[12,"codegen_units","","",72,N],[12,"remark","","",72,N],[12,"no_stack_check","","",72,N],[12,"debuginfo","","",72,N],[12,"opt_level","","",72,N],[12,"force_frame_pointers","","",72,N],[12,"debug_assertions","","",72,N],[12,"inline_threshold","","",72,N],[12,"panic","","",72,N],[12,"incremental","","",72,N],[3,"SearchPaths","","",N,N],[12,"paths","","",73,N],[3,"DocContext","","",N,N],[12,"tcx","","",74,N],[12,"resolver","","",74,N],[12,"crate_name","","The stack of module NodeIds up till this point",74,N],[12,"cstore","","",74,N],[12,"populated_all_crate_impls","","",74,N],[12,"access_levels","","Later on moved into `clean::Crate`",74,N],[12,"renderinfo","","Later on moved into `html::render::CACHE_KEY`",74,N],[12,"external_traits","","Later on moved through `clean::Crate` into `html::render::CACHE_KEY`",74,N],[12,"active_extern_traits","","Used while populating `external_traits` to ensure we don't process the same trait twice at the same time.",74,N],[12,"ty_substs","","Table type parameter definition -> substituted type",74,N],[12,"lt_substs","","Table node id of lifetime parameter definition -> substituted lifetime",74,N],[12,"impl_trait_bounds","","Table DefId of `impl Trait` in argument position -> bounds",74,N],[12,"send_trait","","",74,N],[12,"fake_def_ids","","",74,N],[12,"all_fake_def_ids","","",74,N],[12,"generated_synthetics","","Maps (type_id, trait_id) -> auto trait impl",74,N],[12,"all_traits","","",74,N],[5,"new_handler","","Creates a new diagnostic `Handler` that can be used to emit warnings and errors.",N,[[["erroroutputtype"],["option",["lrc"]]],["handler"]]],[5,"run_core","","",N,N],[6,"ExternalPaths","","",N,N],[8,"DocAccessLevels","","",N,N],[10,"is_doc_reachable","","",75,[[["self"],["defid"]],["bool"]]],[11,"sess","","",74,[[["self"]],["session"]]],[11,"enter_alias","","Call the closure with the given parameters set as the substitutions for a type alias' RHS.",74,[[["self"],["fxhashmap",["def","type"]],["fxhashmap",["defid","lifetime"]],["f"]],["r"]]],[11,"next_def_id","","",74,[[["self"],["cratenum"]],["defid"]]],[11,"get_real_ty","","",74,[[["self"],["defid"],["f"],["option"],["generics"]],["ty"]]],[11,"generics_to_path_params","","",74,[[["self"],["generics"]],["genericargs"]]],[11,"ty_param_to_ty","","",74,[[["self"],["genericparamdef"]],["ty"]]],[0,"doctree","rustdoc","This module is used to store stuff from Rust's AST in a more convenient manner (and with prettier names) before cleaning.",N,N],[3,"Module","rustdoc::doctree","",N,N],[12,"name","","",76,N],[12,"attrs","","",76,N],[12,"where_outer","","",76,N],[12,"where_inner","","",76,N],[12,"extern_crates","","",76,N],[12,"imports","","",76,N],[12,"structs","","",76,N],[12,"unions","","",76,N],[12,"enums","","",76,N],[12,"fns","","",76,N],[12,"mods","","",76,N],[12,"id","","",76,N],[12,"typedefs","","",76,N],[12,"existentials","","",76,N],[12,"statics","","",76,N],[12,"constants","","",76,N],[12,"traits","","",76,N],[12,"vis","","",76,N],[12,"stab","","",76,N],[12,"depr","","",76,N],[12,"impls","","",76,N],[12,"foreigns","","",76,N],[12,"macros","","",76,N],[12,"is_crate","","",76,N],[3,"Struct","","",N,N],[12,"vis","","",77,N],[12,"stab","","",77,N],[12,"depr","","",77,N],[12,"id","","",77,N],[12,"struct_type","","",77,N],[12,"name","","",77,N],[12,"generics","","",77,N],[12,"attrs","","",77,N],[12,"fields","","",77,N],[12,"whence","","",77,N],[3,"Union","","",N,N],[12,"vis","","",78,N],[12,"stab","","",78,N],[12,"depr","","",78,N],[12,"id","","",78,N],[12,"struct_type","","",78,N],[12,"name","","",78,N],[12,"generics","","",78,N],[12,"attrs","","",78,N],[12,"fields","","",78,N],[12,"whence","","",78,N],[3,"Enum","","",N,N],[12,"vis","","",79,N],[12,"stab","","",79,N],[12,"depr","","",79,N],[12,"variants","","",79,N],[12,"generics","","",79,N],[12,"attrs","","",79,N],[12,"id","","",79,N],[12,"whence","","",79,N],[12,"name","","",79,N],[3,"Variant","","",N,N],[12,"name","","",80,N],[12,"attrs","","",80,N],[12,"def","","",80,N],[12,"stab","","",80,N],[12,"depr","","",80,N],[12,"whence","","",80,N],[3,"Function","","",N,N],[12,"decl","","",81,N],[12,"attrs","","",81,N],[12,"id","","",81,N],[12,"name","","",81,N],[12,"vis","","",81,N],[12,"stab","","",81,N],[12,"depr","","",81,N],[12,"header","","",81,N],[12,"whence","","",81,N],[12,"generics","","",81,N],[12,"body","","",81,N],[3,"Typedef","","",N,N],[12,"ty","","",82,N],[12,"gen","","",82,N],[12,"name","","",82,N],[12,"id","","",82,N],[12,"attrs","","",82,N],[12,"whence","","",82,N],[12,"vis","","",82,N],[12,"stab","","",82,N],[12,"depr","","",82,N],[3,"Existential","","",N,N],[12,"exist_ty","","",83,N],[12,"name","","",83,N],[12,"id","","",83,N],[12,"attrs","","",83,N],[12,"whence","","",83,N],[12,"vis","","",83,N],[12,"stab","","",83,N],[12,"depr","","",83,N],[3,"Static","","",N,N],[12,"type_","","",84,N],[12,"mutability","","",84,N],[12,"expr","","",84,N],[12,"name","","",84,N],[12,"attrs","","",84,N],[12,"vis","","",84,N],[12,"stab","","",84,N],[12,"depr","","",84,N],[12,"id","","",84,N],[12,"whence","","",84,N],[3,"Constant","","",N,N],[12,"type_","","",85,N],[12,"expr","","",85,N],[12,"name","","",85,N],[12,"attrs","","",85,N],[12,"vis","","",85,N],[12,"stab","","",85,N],[12,"depr","","",85,N],[12,"id","","",85,N],[12,"whence","","",85,N],[3,"Trait","","",N,N],[12,"is_auto","","",86,N],[12,"unsafety","","",86,N],[12,"name","","",86,N],[12,"items","","",86,N],[12,"generics","","",86,N],[12,"bounds","","",86,N],[12,"attrs","","",86,N],[12,"id","","",86,N],[12,"whence","","",86,N],[12,"vis","","",86,N],[12,"stab","","",86,N],[12,"depr","","",86,N],[3,"Impl","","",N,N],[12,"unsafety","","",87,N],[12,"polarity","","",87,N],[12,"defaultness","","",87,N],[12,"generics","","",87,N],[12,"trait_","","",87,N],[12,"for_","","",87,N],[12,"items","","",87,N],[12,"attrs","","",87,N],[12,"whence","","",87,N],[12,"vis","","",87,N],[12,"stab","","",87,N],[12,"depr","","",87,N],[12,"id","","",87,N],[3,"Macro","","",N,N],[12,"name","","",88,N],[12,"def_id","","",88,N],[12,"attrs","","",88,N],[12,"whence","","",88,N],[12,"matchers","","",88,N],[12,"stab","","",88,N],[12,"depr","","",88,N],[12,"imported_from","","",88,N],[3,"ExternCrate","","",N,N],[12,"name","","",89,N],[12,"cnum","","",89,N],[12,"path","","",89,N],[12,"vis","","",89,N],[12,"attrs","","",89,N],[12,"whence","","",89,N],[3,"Import","","",N,N],[12,"name","","",90,N],[12,"id","","",90,N],[12,"vis","","",90,N],[12,"attrs","","",90,N],[12,"path","","",90,N],[12,"glob","","",90,N],[12,"whence","","",90,N],[4,"StructType","","",N,N],[13,"Plain","","A braced struct",91,N],[13,"Tuple","","A tuple struct",91,N],[13,"Unit","","A unit struct",91,N],[5,"struct_type_from_def","","",N,[[["variantdata"]],["structtype"]]],[11,"new","","",76,[[["option",["name"]]],["module"]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"clone","","",91,[[["self"]],["structtype"]]],[11,"encode","","",91,[[["self"],["__s"]],["result"]]],[11,"decode","","",91,[[["__d"]],["result",["structtype"]]]],[11,"fmt","","",84,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",87,[[["self"],["formatter"]],["result"]]],[0,"fold","rustdoc","",N,N],[3,"StripItem","rustdoc::fold","",N,N],[12,"0","","",92,N],[8,"DocFolder","","",N,N],[11,"fold_item","","",93,[[["self"],["item"]],["option",["item"]]]],[11,"fold_inner_recur","","don't override!",93,[[["self"],["itemenum"]],["itemenum"]]],[11,"fold_item_recur","","don't override!",93,[[["self"],["item"]],["option",["item"]]]],[11,"fold_mod","","",93,[[["self"],["module"]],["module"]]],[11,"fold_crate","","",93,[[["self"],["crate"]],["crate"]]],[11,"strip","","",92,[[["self"]],["option",["item"]]]],[0,"html","rustdoc","",N,N],[0,"highlight","rustdoc::html","Basic syntax highlighting functionality.",N,N],[3,"Classifier","rustdoc::html::highlight","Processes a program (nested in the internal `lexer`), classifying strings of text by highlighting category (`Class`). Calls out to a `Writer` to write each span of text in sequence.",N,N],[12,"lexer","","",94,N],[12,"source_map","","",94,N],[12,"in_attribute","","",94,N],[12,"in_macro","","",94,N],[12,"in_macro_nonterminal","","",94,N],[4,"Class","","How a span of text is classified. Mostly corresponds to token kinds.",N,N],[13,"None","","",95,N],[13,"Comment","","",95,N],[13,"DocComment","","",95,N],[13,"Attribute","","",95,N],[13,"KeyWord","","",95,N],[13,"RefKeyWord","","",95,N],[13,"Self_","","",95,N],[13,"Op","","",95,N],[13,"Macro","","",95,N],[13,"MacroNonTerminal","","",95,N],[13,"String","","",95,N],[13,"Number","","",95,N],[13,"Bool","","",95,N],[13,"Ident","","",95,N],[13,"Lifetime","","",95,N],[13,"PreludeTy","","",95,N],[13,"PreludeVal","","",95,N],[13,"QuestionMark","","",95,N],[5,"render_with_highlighting","","Highlights `src`, returning the HTML output.",N,[[["str"],["option",["str"]],["option",["str"]],["option"]],["string"]]],[5,"write_header","","",N,[[["option",["str"]],["write"]],["result"]]],[5,"write_footer","","",N,[[["write"]],["result"]]],[8,"Writer","","Trait that controls writing the output of syntax highlighting. Users should implement this trait to customize writing output.",N,N],[10,"enter_span","","Called when we start processing a span of text that should be highlighted. The `Class` argument specifies how it should be highlighted.",96,[[["self"],["class"]],["result"]]],[10,"exit_span","","Called at the end of a span of highlighted text.",96,[[["self"]],["result"]]],[10,"string","","Called for a span of text.  If the text should be highlighted differently from the surrounding text, then the `Class` argument will be a value other than `None`.",96,[[["self"],["t"],["class"]],["result"]]],[11,"clone","","",95,[[["self"]],["class"]]],[11,"fmt","","",95,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",95,N],[11,"eq","","",95,[[["self"],["class"]],["bool"]]],[11,"new","","",94,[[["stringreader"],["sourcemap"]],["classifier"]]],[11,"try_next_token","","Gets the next token out of the lexer, emitting fatal errors if lexing fails.",94,[[["self"]],["result",["tokenandspan"]]]],[11,"write_source","","Exhausts the `lexer` writing the output into `out`.",94,[[["self"],["w"]],["result"]]],[11,"write_token","","",94,[[["self"],["w"],["tokenandspan"]],["result"]]],[11,"snip","","",94,[[["self"],["span"]],["string"]]],[11,"rustdoc_class","","Returns the css class expected by rustdoc for each `Class`.",95,[[["self"]],["str"]]],[0,"escape","rustdoc::html","HTML Escaping",N,N],[3,"Escape","rustdoc::html::escape","Wrapper struct which will emit the HTML-escaped version of the contained string when passed to a format string.",N,N],[12,"0","","",97,N],[11,"fmt","","",97,[[["self"],["formatter"]],["result"]]],[0,"item_type","rustdoc::html","Item types.",N,N],[4,"ItemType","rustdoc::html::item_type","Item type. Corresponds to `clean::ItemEnum` variants.",N,N],[13,"Module","","",98,N],[13,"ExternCrate","","",98,N],[13,"Import","","",98,N],[13,"Struct","","",98,N],[13,"Enum","","",98,N],[13,"Function","","",98,N],[13,"Typedef","","",98,N],[13,"Static","","",98,N],[13,"Trait","","",98,N],[13,"Impl","","",98,N],[13,"TyMethod","","",98,N],[13,"Method","","",98,N],[13,"StructField","","",98,N],[13,"Variant","","",98,N],[13,"Macro","","",98,N],[13,"Primitive","","",98,N],[13,"AssociatedType","","",98,N],[13,"Constant","","",98,N],[13,"AssociatedConst","","",98,N],[13,"Union","","",98,N],[13,"ForeignType","","",98,N],[13,"Keyword","","",98,N],[13,"Existential","","",98,N],[4,"NameSpace","","",N,N],[13,"Type","","",99,N],[13,"Value","","",99,N],[13,"Macro","","",99,N],[13,"Keyword","","",99,N],[17,"NAMESPACE_TYPE","","",N,N],[17,"NAMESPACE_VALUE","","",N,N],[17,"NAMESPACE_MACRO","","",N,N],[17,"NAMESPACE_KEYWORD","","",N,N],[11,"eq","","",98,[[["self"],["itemtype"]],["bool"]]],[11,"clone","","",98,[[["self"]],["itemtype"]]],[11,"fmt","","",98,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",99,N],[11,"eq","","",99,[[["self"],["namespace"]],["bool"]]],[11,"clone","","",99,[[["self"]],["namespace"]]],[11,"from","","",98,[[["item"]],["itemtype"]]],[11,"from","","",98,[[["typekind"]],["itemtype"]]],[11,"css_class","","",98,[[["self"]],["str"]]],[11,"name_space","","",98,[[["self"]],["namespace"]]],[11,"fmt","","",98,[[["self"],["formatter"]],["result"]]],[11,"to_static_str","","",99,[[["self"]],["str"]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result"]]],[0,"format","rustdoc::html","HTML formatting module",N,N],[3,"VisSpace","rustdoc::html::format","Helper to render an optional visibility with a space after it (if the visibility is preset)",N,N],[12,"0","","",100,N],[3,"UnsafetySpace","","Similarly to VisSpace, this structure is used to render a function style with a space after it.",N,N],[12,"0","","",101,N],[3,"ConstnessSpace","","Similarly to VisSpace, this structure is used to render a function constness with a space after it.",N,N],[12,"0","","",102,N],[3,"AsyncSpace","","Similarly to VisSpace, this structure is used to render a function asyncness with a space after it.",N,N],[12,"0","","",103,N],[3,"MutableSpace","","Similar to VisSpace, but used for mutability",N,N],[12,"0","","",104,N],[3,"RawMutableSpace","","Similar to VisSpace, but used for mutability",N,N],[12,"0","","",105,N],[3,"GenericBounds","","Wrapper struct for emitting type parameter bounds.",N,N],[12,"0","","",106,N],[3,"CommaSep","","Wrapper struct for emitting a comma-separated list of items",N,N],[12,"0","","",107,N],[3,"AbiSpace","","",N,N],[12,"0","","",108,N],[3,"Method","","Wrapper struct for properly emitting a method declaration.",N,N],[12,"decl","","The declaration to emit.",109,N],[12,"name_len","","The length of the function's \"name\", used to determine line-wrapping.",109,N],[12,"indent","","The number of spaces to indent each successive line with, if line-wrapping is necessary.",109,N],[3,"WhereClause","","Wrapper struct for emitting a where clause from Generics.",N,N],[12,"gens","","The Generics from which to emit a where clause.",110,N],[12,"indent","","The number of spaces to indent each line with.",110,N],[12,"end_newline","","Whether the where clause needs to add a comma and newline after the last bound.",110,N],[3,"HRef","","",N,N],[12,"did","","",111,N],[12,"text","","",111,N],[5,"href","","",N,[[["defid"]],["option"]]],[5,"resolved_path","","Used when rendering a `ResolvedPath` structure. This invokes the `path` rendering function with the necessary arguments for linking to a local path.",N,[[["formatter"],["defid"],["path"],["bool"],["bool"]],["result"]]],[5,"primitive_link","","",N,[[["formatter"],["primitivetype"],["str"]],["result"]]],[5,"tybounds","","Helper to render type parameters",N,[[["formatter"],["option"]],["result"]]],[5,"fmt_type","","",N,[[["type"],["formatter"],["bool"]],["result"]]],[5,"fmt_impl","","",N,[[["impl"],["formatter"],["bool"],["bool"]],["result"]]],[5,"fmt_impl_for_trait_page","","",N,[[["impl"],["formatter"],["bool"]],["result"]]],[11,"clone","","",100,[[["self"]],["visspace"]]],[11,"clone","","",101,[[["self"]],["unsafetyspace"]]],[11,"clone","","",102,[[["self"]],["constnessspace"]]],[11,"clone","","",103,[[["self"]],["asyncspace"]]],[11,"clone","","",104,[[["self"]],["mutablespace"]]],[11,"clone","","",105,[[["self"]],["rawmutablespace"]]],[11,"get","","",100,[[["self"]],["option"]]],[11,"get","","",101,[[["self"]],["unsafety"]]],[11,"get","","",102,[[["self"]],["constness"]]],[11,"fmt","","",107,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",106,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::clean","",10,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::html::format","",110,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::clean","",9,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",42,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",52,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"new","rustdoc::html::format","",111,[[["defid"],["str"]],["href"]]],[11,"fmt","","",111,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::clean","",47,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",33,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::html::format","",109,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",100,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",103,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::clean","",55,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"fmt","rustdoc::html::format","",104,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",105,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",108,[[["self"],["formatter"]],["result"]]],[0,"layout","rustdoc::html","",N,N],[3,"Layout","rustdoc::html::layout","",N,N],[12,"logo","","",112,N],[12,"favicon","","",112,N],[12,"external_html","","",112,N],[12,"krate","","",112,N],[3,"Page","","",N,N],[12,"title","","",113,N],[12,"css_class","","",113,N],[12,"root_path","","",113,N],[12,"description","","",113,N],[12,"keywords","","",113,N],[12,"resource_suffix","","",113,N],[5,"render","","",N,N],[5,"redirect","","",N,[[["write"],["str"]],["result"]]],[11,"clone","","",112,[[["self"]],["layout"]]],[0,"markdown","rustdoc::html","Markdown formatting for rustdoc",N,N],[3,"Markdown","rustdoc::html::markdown","A unit struct which has the `fmt::Display` trait implemented. When formatted, this struct will emit the HTML corresponding to the rendered version of the contained markdown string. The second parameter is a list of link replacements",N,N],[12,"0","","",114,N],[12,"1","","",114,N],[12,"2","","",114,N],[12,"3","","",114,N],[3,"MarkdownWithToc","","A unit struct like `Markdown`, that renders the markdown with a table of contents.",N,N],[12,"0","","",115,N],[12,"1","","",115,N],[12,"2","","",115,N],[3,"MarkdownHtml","","A unit struct like `Markdown`, that renders the markdown escaping HTML tags.",N,N],[12,"0","","",116,N],[12,"1","","",116,N],[12,"2","","",116,N],[3,"MarkdownSummaryLine","","A unit struct like `Markdown`, that renders only the first paragraph.",N,N],[12,"0","","",117,N],[12,"1","","",117,N],[3,"CodeBlocks","","Adds syntax highlighting and playground Run buttons to rust code blocks.",N,N],[12,"inner","","",118,N],[12,"check_error_codes","","",118,N],[3,"LinkReplacer","","Make headings links with anchor ids and build up TOC.",N,N],[12,"inner","","",119,N],[12,"links","","",119,N],[3,"HeadingLinks","","Make headings links with anchor ids and build up TOC.",N,N],[12,"inner","","",120,N],[12,"toc","","",120,N],[12,"buf","","",120,N],[12,"id_map","","",120,N],[3,"SummaryLine","","Extracts just the first paragraph.",N,N],[12,"inner","","",121,N],[12,"started","","",121,N],[12,"depth","","",121,N],[3,"Footnotes","","Moves all footnote definitions to the end and add back links to the references.",N,N],[12,"inner","","",122,N],[12,"footnotes","","",122,N],[3,"TestableCodeError","","",N,N],[12,"0","","",123,N],[3,"LangString","","",N,N],[12,"original","","",124,N],[12,"should_panic","","",124,N],[12,"no_run","","",124,N],[12,"ignore","","",124,N],[12,"rust","","",124,N],[12,"test_harness","","",124,N],[12,"compile_fail","","",124,N],[12,"error_codes","","",124,N],[12,"allow_fail","","",124,N],[3,"IdMap","","",N,N],[12,"map","","",125,N],[4,"ErrorCodes","","",N,N],[13,"Yes","","",126,N],[13,"No","","",126,N],[4,"Line","","Controls whether a line will be hidden or shown in HTML output.",N,N],[13,"Hidden","","",127,N],[13,"Shown","","",127,N],[5,"map_line","","",N,[[["str"]],["line"]]],[5,"slugify","","Convert chars from a title for an id.",N,[[["char"]],["option",["char"]]]],[5,"check_if_allowed_tag","","",N,[[["tag"]],["bool"]]],[5,"find_testable_code","","",N,[[["str"],["collector"],["errorcodes"]],["result",["testablecodeerror"]]]],[5,"plain_summary_line","","",N,[[["str"]],["string"]]],[5,"markdown_links","","",N,[[["str"]],["vec"]]],[17,"PLAYGROUND","","",N,N],[11,"clone","","",126,[[["self"]],["errorcodes"]]],[11,"eq","","",126,[[["self"],["errorcodes"]],["bool"]]],[11,"fmt","","",126,[[["self"],["formatter"]],["result"]]],[11,"from","","",126,[[["bool"]],["self"]]],[11,"as_bool","","",126,[[["self"]],["bool"]]],[11,"for_html","","",127,[[["self"]],["option",["cow"]]]],[11,"for_code","","",127,[[["self"]],["cow",["str"]]]],[11,"new","","",118,[[["i"],["errorcodes"]],["self"]]],[11,"next","","",118,[[["self"]],["option"]]],[11,"new","","",119,N],[11,"next","","",119,[[["self"]],["option"]]],[11,"new","","",120,[[["i"],["option",["tocbuilder"]],["idmap"]],["self"]]],[11,"next","","",120,[[["self"]],["option"]]],[11,"new","","",121,[[["i"]],["self"]]],[11,"next","","",121,[[["self"]],["option"]]],[11,"new","","",122,[[["i"]],["self"]]],[11,"get_entry","","",122,N],[11,"next","","",122,[[["self"]],["option"]]],[11,"fmt","","",123,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",124,N],[11,"eq","","",124,[[["self"],["langstring"]],["bool"]]],[11,"ne","","",124,[[["self"],["langstring"]],["bool"]]],[11,"clone","","",124,[[["self"]],["langstring"]]],[11,"fmt","","",124,[[["self"],["formatter"]],["result"]]],[11,"all_false","","",124,[[],["langstring"]]],[11,"parse","","",124,[[["str"],["errorcodes"]],["langstring"]]],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",116,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",117,[[["self"],["formatter"]],["result"]]],[11,"default","","",125,[[],["idmap"]]],[11,"new","","",125,[[],["self"]]],[11,"populate","","",125,[[["self"],["i"]]]],[11,"reset","","",125,[[["self"]]]],[11,"derive","","",125,[[["self"],["string"]],["string"]]],[0,"render","rustdoc::html","Rustdoc's HTML Rendering module",N,N],[3,"Context","rustdoc::html::render","Major driving force in all rustdoc rendering. This contains information about where in the tree-like hierarchy rendering is occurring and controls how the current page is being rendered.",N,N],[12,"current","","Current hierarchy of components leading down to what's currently being rendered",128,N],[12,"dst","","The current destination folder of where HTML artifacts should be placed. This changes as the context descends into the module hierarchy.",128,N],[12,"render_redirect_pages","","A flag, which when `true`, will render pages which redirect to the real location of an item. This is used to allow external links to publicly reused items to redirect to the right location.",128,N],[12,"codes","","",128,N],[12,"id_map","","The map used to ensure all generated 'id=' attributes are unique.",128,N],[12,"shared","","",128,N],[3,"SharedContext","","",N,N],[12,"src_root","","The path to the crate root source minus the file name. Used for simplifying paths to the highlighted source code files.",129,N],[12,"layout","","This describes the layout of each page, and is not modified after creation of the context (contains info like the favicon and added html).",129,N],[12,"include_sources","","This flag indicates whether `[src]` links should be generated or not. If the source files are present in the html rendering, then this will be `true`.",129,N],[12,"local_sources","","The local file sources we've emitted and their respective url-paths.",129,N],[12,"passes","","All the passes that were run on this crate.",129,N],[12,"issue_tracker_base_url","","The base-URL of the issue tracker for when an item has been tagged with an issue number.",129,N],[12,"css_file_extension","","The given user css file which allow to customize the generated documentation theme.",129,N],[12,"created_dirs","","The directories that have already been created in this doc run. Used to reduce the number of spurious `create_dir_all` calls.",129,N],[12,"sort_modules_alphabetically","","This flag indicates whether listings of modules (in the side bar and documentation itself) should be ordered alphabetically or in order of appearance (in the source code).",129,N],[12,"themes","","Additional themes to be added to the generated docs.",129,N],[12,"resource_suffix","","Suffix to be added on resource files (if suffix is \"-v2\" then \"light.css\" becomes \"light-v2.css\").",129,N],[3,"Impl","","Metadata about implementations for a type or trait.",N,N],[12,"impl_item","","",130,N],[3,"Error","","",N,N],[12,"file","","",131,N],[12,"error","","",131,N],[3,"Cache","","This cache is used to store information about the `clean::Crate` being rendered in order to provide more useful documentation. This contains information like all implementors of a trait, all traits a type implements, documentation for all known traits, etc.",N,N],[12,"typarams","","Mapping of typaram ids to the name of the type parameter. This is used when pretty-printing a type (so pretty printing doesn't have to painfully maintain a context like this)",132,N],[12,"impls","","Maps a type id to all known implementations for that type. This is only recognized for intra-crate `ResolvedPath` types, and is used to print out extra documentation on the page of an enum/struct.",132,N],[12,"paths","","Maintains a mapping of local crate node ids to the fully qualified name and \"short type description\" of that node. This is used when generating URLs when a type is being linked to. External paths are not located in this map because the `External` type itself has all the information necessary.",132,N],[12,"external_paths","","Similar to `paths`, but only holds external paths. This is only used for generating explicit hyperlinks to other crates.",132,N],[12,"exact_paths","","Maps local def ids of exported types to fully qualified paths. Unlike 'paths', this mapping ignores any renames that occur due to 'use' statements.",132,N],[12,"traits","","This map contains information about all known traits of this crate. Implementations of a crate should inherit the documentation of the parent trait if no extra documentation is specified, and default methods should show up in documentation about trait implementations.",132,N],[12,"implementors","","When rendering traits, it's often useful to be able to list all implementors of the trait, and this mapping is exactly, that: a mapping of trait ids to the list of known implementors of the trait",132,N],[12,"extern_locations","","Cache of where external crate documentation can be found.",132,N],[12,"primitive_locations","","Cache of where documentation for primitives can be found.",132,N],[12,"access_levels","","",132,N],[12,"crate_version","","The version of the crate being documented, if given from the `--crate-version` flag.",132,N],[12,"stack","","",132,N],[12,"parent_stack","","",132,N],[12,"parent_is_trait_impl","","",132,N],[12,"search_index","","",132,N],[12,"stripped_mod","","",132,N],[12,"deref_trait_did","","",132,N],[12,"deref_mut_trait_did","","",132,N],[12,"owned_box_did","","",132,N],[12,"masked_crates","","",132,N],[12,"orphan_impl_items","","",132,N],[12,"aliases","","Aliases added through `#[doc(alias = \"...\")]`. Since a few items can have the same alias, we need the alias element to have an array of items.",132,N],[3,"RenderInfo","","Temporary storage for data obtained during `RustdocVisitor::clean()`. Later on moved into `CACHE_KEY`.",N,N],[12,"inlined","","",133,N],[12,"external_paths","","",133,N],[12,"external_typarams","","",133,N],[12,"exact_paths","","",133,N],[12,"deref_trait_did","","",133,N],[12,"deref_mut_trait_did","","",133,N],[12,"owned_box_did","","",133,N],[3,"SourceCollector","","Helper struct to render all source code to HTML pages",N,N],[12,"scx","","",134,N],[12,"dst","","Root destination to place all HTML output into",134,N],[3,"Source","","Wrapper struct to render the source code of a file. This will do things like adding line numbers to the left-hand side.",N,N],[12,"0","","",135,N],[3,"Item","","",N,N],[12,"cx","","",136,N],[12,"item","","",136,N],[3,"Sidebar","","",N,N],[12,"cx","","",137,N],[12,"item","","",137,N],[3,"IndexItem","","Struct representing one entry in the JS search index. These are all emitted by hand to a large JS file at the end of cache-creation.",N,N],[12,"ty","","",138,N],[12,"name","","",138,N],[12,"path","","",138,N],[12,"desc","","",138,N],[12,"parent","","",138,N],[12,"parent_idx","","",138,N],[12,"search_type","","",138,N],[3,"Type","","A type used for the search index.",N,N],[12,"name","","",139,N],[12,"generics","","",139,N],[3,"IndexItemFunctionType","","Full type of functions/methods in the search index.",N,N],[12,"inputs","","",140,N],[12,"output","","",140,N],[3,"ItemEntry","","",N,N],[12,"url","","",141,N],[12,"name","","",141,N],[3,"AllTypes","","",N,N],[12,"structs","","",142,N],[12,"enums","","",142,N],[12,"unions","","",142,N],[12,"primitives","","",142,N],[12,"traits","","",142,N],[12,"macros","","",142,N],[12,"functions","","",142,N],[12,"typedefs","","",142,N],[12,"existentials","","",142,N],[12,"statics","","",142,N],[12,"constants","","",142,N],[12,"keywords","","",142,N],[3,"Settings","","",N,N],[12,"settings","","",143,N],[12,"root_path","","",143,N],[12,"suffix","","",143,N],[4,"ExternalLocation","","Indicates where an external crate can be found.",N,N],[13,"Remote","","Remote URL root of the external crate",144,N],[13,"Local","","This external crate can be found in the local doc/ folder",144,N],[13,"Unknown","","The external crate could not be found.",144,N],[4,"AssocItemLink","","",N,N],[13,"Anchor","","",145,N],[13,"GotoSource","","",145,N],[4,"AssocItemRender","","",N,N],[13,"All","","",146,N],[13,"DerefFor","","",146,N],[12,"trait_","rustdoc::html::render::AssocItemRender","",146,N],[12,"type_","","",146,N],[12,"deref_mut_","","",146,N],[4,"RenderMode","rustdoc::html::render","",N,N],[13,"Normal","","",147,N],[13,"ForDeref","","",147,N],[12,"mut_","rustdoc::html::render::RenderMode","",147,N],[5,"initial_ids","rustdoc::html::render","",N,[[],["vec",["string"]]]],[5,"run","","Generates the documentation for `crate` into the directory `dst`",N,[[["crate"],["btreemap",["string","string"]],["externalhtml"],["option",["string"]],["pathbuf"],["string"],["fxhashset",["string"]],["option",["pathbuf"]],["renderinfo"],["bool"],["vec",["pathbuf"]],["bool"],["idmap"]],["result",["error"]]]],[5,"build_index","","Build the search index from the collected metadata",N,[[["crate"],["cache"]],["string"]]],[5,"write_shared","","",N,[[["context"],["crate"],["cache"],["string"],["bool"]],["result",["error"]]]],[5,"render_sources","","",N,[[["path"],["sharedcontext"],["crate"]],["result",["crate","error"]]]],[5,"write","","Writes the entire contents of a string to a destination, not attempting to catch any errors.",N,N],[5,"write_minify","","",N,[[["pathbuf"],["str"],["bool"]],["result",["error"]]]],[5,"write_minify_replacer","","",N,N],[5,"clean_srcpath","","Takes a path to a source file and cleans the path to it. This canonicalizes things like \"..\" to components which preserve the \"top down\" hierarchy of a static HTML tree. Each component in the cleaned path will be passed as an argument to `f`. The very last component of the path (ie the file name) will be passed to `f` if `keep_filename` is true, and ignored otherwise.",N,[[["path"],["path"],["bool"],["f"]]]],[5,"extern_location","","Attempts to find where an external crate is located, given that we're rendering in to the specified source destination.",N,[[["externalcrate"],["option",["str"]],["path"]],["externallocation"]]],[5,"print_entries","","",N,[[["formatter"],["fxhashset"],["str"],["str"]],["result"]]],[5,"wrap_into_docblock","","",N,[[["formatter"],["f"]],["result"]]],[5,"item_path","","",N,[[["itemtype"],["str"]],["string"]]],[5,"full_path","","",N,[[["context"],["item"]],["string"]]],[5,"shorter","","",N,[[["option",["str"]]],["string"]]],[5,"plain_summary_line","","",N,[[["option",["str"]]],["string"]]],[5,"document","","",N,[[["formatter"],["context"],["item"]],["result"]]],[5,"render_markdown","","Render md_text as markdown.",N,[[["formatter"],["context"],["str"],["vec"],["str"]],["result"]]],[5,"document_short","","",N,[[["formatter"],["context"],["item"],["associtemlink"],["str"]],["result"]]],[5,"document_full","","",N,[[["formatter"],["item"],["context"],["str"]],["result"]]],[5,"document_stability","","",N,[[["formatter"],["context"],["item"]],["result"]]],[5,"document_non_exhaustive_header","","",N,[[["item"]],["str"]]],[5,"document_non_exhaustive","","",N,[[["formatter"],["item"]],["result"]]],[5,"name_key","","",N,N],[5,"item_module","","",N,N],[5,"short_stability","","",N,[[["item"],["context"],["bool"]],["vec",["string"]]]],[5,"item_constant","","",N,[[["formatter"],["context"],["item"],["constant"]],["result"]]],[5,"item_static","","",N,[[["formatter"],["context"],["item"],["static"]],["result"]]],[5,"item_function","","",N,[[["formatter"],["context"],["item"],["function"]],["result"]]],[5,"render_implementor","","",N,[[["context"],["impl"],["formatter"],["fxhashmap"]],["result"]]],[5,"render_impls","","",N,N],[5,"bounds","","",N,N],[5,"compare_impl","","",N,[[["impl"],["impl"]],["ordering"]]],[5,"item_trait","","",N,[[["formatter"],["context"],["item"],["trait"]],["result"]]],[5,"naive_assoc_href","","",N,[[["item"],["associtemlink"]],["string"]]],[5,"assoc_const","","",N,[[["formatter"],["item"],["type"],["option",["string"]],["associtemlink"]],["result"]]],[5,"assoc_type","","",N,N],[5,"render_stability_since_raw","","",N,[[["formatter"],["option",["str"]],["option",["str"]]],["result"]]],[5,"render_stability_since","","",N,[[["formatter"],["item"],["item"]],["result"]]],[5,"render_assoc_item","","",N,[[["formatter"],["item"],["associtemlink"],["itemtype"]],["result"]]],[5,"item_struct","","",N,[[["formatter"],["context"],["item"],["struct"]],["result"]]],[5,"item_union","","",N,[[["formatter"],["context"],["item"],["union"]],["result"]]],[5,"item_enum","","",N,[[["formatter"],["context"],["item"],["enum"]],["result"]]],[5,"render_attribute","","",N,[[["metaitem"]],["option",["string"]]]],[5,"render_attributes","","",N,[[["formatter"],["item"]],["result"]]],[5,"render_struct","","",N,N],[5,"render_union","","",N,N],[5,"render_assoc_items","","",N,[[["formatter"],["context"],["item"],["defid"],["associtemrender"]],["result"]]],[5,"render_deref_methods","","",N,[[["formatter"],["context"],["impl"],["item"],["bool"]],["result"]]],[5,"should_render_item","","",N,[[["item"],["bool"]],["bool"]]],[5,"render_spotlight_traits","","",N,[[["item"]],["result",["string","error"]]]],[5,"spotlight_decl","","",N,[[["fndecl"]],["result",["string","error"]]]],[5,"render_impl","","",N,[[["formatter"],["context"],["impl"],["associtemlink"],["rendermode"],["option",["str"]],["bool"],["option",["bool"]]],["result"]]],[5,"item_existential","","",N,[[["formatter"],["context"],["item"],["existential"]],["result"]]],[5,"item_typedef","","",N,[[["formatter"],["context"],["item"],["typedef"]],["result"]]],[5,"item_foreign_type","","",N,[[["formatter"],["context"],["item"]],["result"]]],[5,"get_methods","","",N,[[["impl"],["bool"]],["vec",["string"]]]],[5,"small_url_encode","","",N,[[["str"]],["string"]]],[5,"sidebar_assoc_items","","",N,[[["item"]],["string"]]],[5,"sidebar_struct","","",N,[[["formatter"],["item"],["struct"]],["result"]]],[5,"extract_for_impl_name","","",N,[[["item"]],["option"]]],[5,"is_negative_impl","","",N,[[["impl"]],["bool"]]],[5,"sidebar_trait","","",N,[[["formatter"],["item"],["trait"]],["result"]]],[5,"sidebar_primitive","","",N,[[["formatter"],["item"],["primitivetype"]],["result"]]],[5,"sidebar_typedef","","",N,[[["formatter"],["item"],["typedef"]],["result"]]],[5,"get_struct_fields_name","","",N,N],[5,"sidebar_union","","",N,[[["formatter"],["item"],["union"]],["result"]]],[5,"sidebar_enum","","",N,[[["formatter"],["item"],["enum"]],["result"]]],[5,"item_ty_to_strs","","",N,N],[5,"sidebar_module","","",N,N],[5,"sidebar_foreign_type","","",N,[[["formatter"],["item"]],["result"]]],[5,"item_macro","","",N,[[["formatter"],["context"],["item"],["macro"]],["result"]]],[5,"item_primitive","","",N,[[["formatter"],["context"],["item"],["primitivetype"]],["result"]]],[5,"item_keyword","","",N,[[["formatter"],["context"],["item"],["str"]],["result"]]],[5,"make_item_keywords","","",N,[[["item"]],["string"]]],[5,"get_index_search_type","","",N,[[["item"]],["option",["indexitemfunctiontype"]]]],[5,"get_index_type","","",N,[[["type"]],["type"]]],[5,"collect_paths_for_type","","Returns a list of all paths used in the type. This is used to help deduplicate imported impls for reexported types. If any of the contained types are re-exported, we don't use the corresponding entry from the js file, as inlining will have already picked up the impl",N,[[["type"]],["vec",["string"]]]],[5,"get_index_type_name","","",N,[[["type"],["bool"]],["option",["string"]]]],[5,"get_generics","","",N,[[["type"]],["option",["vec"]]]],[5,"cache","","",N,[[],["arc",["cache"]]]],[6,"NameDoc","","A pair of name and its optional document.",N,N],[17,"CACHE_KEY","","",N,N],[17,"CURRENT_LOCATION_KEY","","",N,N],[17,"ATTRIBUTE_WHITELIST","","",N,N],[17,"BASIC_KEYWORDS","","",N,N],[11,"clone","","",128,[[["self"]],["context"]]],[11,"ensure_dir","","",129,[[["self"],["path"]],["result"]]],[11,"was_collapsed","","Returns whether the `collapse-docs` pass was run on this crate.",129,[[["self"]],["bool"]]],[11,"maybe_collapsed_doc_value","","Based on whether the `collapse-docs` pass was run, return either the `doc_value` or the `collapsed_doc_value` of the given item.",129,[[["self"],["item"]],["option",["cow"]]]],[11,"clone","","",130,[[["self"]],["impl"]]],[11,"fmt","","",130,[[["self"],["formatter"]],["result"]]],[11,"inner_impl","","",130,[[["self"]],["impl"]]],[11,"trait_did","","",130,[[["self"]],["option",["defid"]]]],[11,"fmt","","",131,[[["self"],["formatter"]],["result"]]],[11,"description","","",131,[[["self"]],["str"]]],[11,"fmt","","",131,[[["self"],["formatter"]],["result"]]],[11,"new","","",131,[[["error"],["path"]],["error"]]],[11,"default","","",132,[[],["cache"]]],[11,"default","","",133,[[],["renderinfo"]]],[11,"clone","","",136,[[["self"]],["item"]]],[11,"fmt","","",138,[[["self"],["formatter"]],["result"]]],[11,"to_json","","",138,[[["self"]],["json"]]],[11,"fmt","","",139,[[["self"],["formatter"]],["result"]]],[11,"to_json","","",139,[[["self"]],["json"]]],[11,"fmt","","",140,[[["self"],["formatter"]],["result"]]],[11,"to_json","","",140,[[["self"]],["json"]]],[11,"fold_item","","",134,[[["self"],["item"]],["option",["item"]]]],[11,"emit_source","","Renders the given filename into its corresponding HTML source file.",134,[[["self"],["filename"]],["result"]]],[11,"fold_item","","",132,[[["self"],["item"]],["option",["item"]]]],[11,"generics","","",132,[[["self"],["generics"]]]],[11,"add_aliases","","",132,[[["self"],["item"]]]],[11,"fmt","","",141,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",141,N],[11,"eq","","",141,[[["self"],["itementry"]],["bool"]]],[11,"ne","","",141,[[["self"],["itementry"]],["bool"]]],[11,"hash","","",141,N],[11,"new","","",141,[[["string"],["string"]],["itementry"]]],[11,"fmt","","",141,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",141,[[["self"],["itementry"]],["option",["ordering"]]]],[11,"cmp","","",141,[[["self"],["itementry"]],["ordering"]]],[11,"fmt","","",142,[[["self"],["formatter"]],["result"]]],[11,"new","","",142,[[],["alltypes"]]],[11,"append","","",142,[[["self"],["string"],["itemtype"]]]],[11,"fmt","","",142,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",143,[[["self"],["formatter"]],["result"]]],[11,"new","","",143,[[["str"],["str"]],["settings"]]],[11,"fmt","","",143,[[["self"],["formatter"]],["result"]]],[11,"derive_id","","",128,[[["self"],["string"]],["string"]]],[11,"root_path","","String representation of how to get back to the root path of the 'doc/' folder in terms of a relative URL.",128,[[["self"]],["string"]]],[11,"recurse","","Recurse in the directory structure and change the \"root path\" to make sure it always points to the top (relatively).",128,[[["self"],["string"],["f"]],["t"]]],[11,"krate","","Main method for rendering a crate.",128,[[["self"],["crate"]],["result",["error"]]]],[11,"render_item","","",128,[[["self"],["write"],["item"],["bool"]],["result"]]],[11,"item","","Non-parallelized version of rendering an item. This will take the input item, render its contents, and then invoke the specified closure with all sub-items which need to be rendered.",128,[[["self"],["item"],["alltypes"],["f"]],["result",["error"]]]],[11,"build_sidebar_items","","",128,[[["self"],["module"]],["btreemap",["string","vec"]]]],[11,"src_href","","Generate a url appropriate for an `href` attribute back to the source of this item.",136,[[["self"]],["option",["string"]]]],[11,"fmt","","",136,[[["self"],["formatter"]],["result"]]],[11,"clone","","",145,[[["self"]],["associtemlink"]]],[11,"anchor","","",145,[[["self"],["string"]],["self"]]],[11,"clone","","",147,[[["self"]],["rendermode"]]],[11,"eq","","",147,[[["self"],["rendermode"]],["bool"]]],[11,"ne","","",147,[[["self"],["rendermode"]],["bool"]]],[11,"fmt","","",137,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",135,[[["self"],["formatter"]],["result"]]],[0,"toc","rustdoc::html","Table-of-contents creation.",N,N],[3,"Toc","rustdoc::html::toc","A (recursive) table of contents",N,N],[12,"entries","","The levels are strictly decreasing, i.e.",148,N],[3,"TocEntry","","",N,N],[12,"level","","",149,N],[12,"sec_number","","",149,N],[12,"name","","",149,N],[12,"id","","",149,N],[12,"children","","",149,N],[3,"TocBuilder","","Progressive construction of a table of contents.",N,N],[12,"top_level","","",150,N],[12,"chain","","The current hierarchy of parent headings, the levels are strictly increasing (i.e. chain[0].level < chain[1].level < ...) with each entry being the most recent occurrence of a heading with that level (it doesn't include the most recent occurrences of every level, just, if it is in `chain` then it is the most recent one).",150,N],[11,"eq","","",148,[[["self"],["toc"]],["bool"]]],[11,"ne","","",148,[[["self"],["toc"]],["bool"]]],[11,"count_entries_with_level","","",148,[[["self"],["u32"]],["usize"]]],[11,"eq","","",149,[[["self"],["tocentry"]],["bool"]]],[11,"ne","","",149,[[["self"],["tocentry"]],["bool"]]],[11,"eq","","",150,[[["self"],["tocbuilder"]],["bool"]]],[11,"ne","","",150,[[["self"],["tocbuilder"]],["bool"]]],[11,"new","","",150,[[],["tocbuilder"]]],[11,"into_toc","","Convert into a true `Toc` struct.",150,[[["self"]],["toc"]]],[11,"fold_until","","Collapse the chain until the first heading more important than `level` (i.e. lower level)",150,[[["self"],["u32"]]]],[11,"push","","Push a level `level` heading into the appropriate place in the hierarchy, returning a string containing the section number in `<num>.<num>.<num>` format.",150,[[["self"],["u32"],["string"],["string"]],["str"]]],[11,"fmt","","",148,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",148,[[["self"],["formatter"]],["result"]]],[0,"markdown","rustdoc","",N,N],[5,"extract_leading_metadata","rustdoc::markdown","Separate any lines at the start of the file that begin with `#` or `%`.",N,N],[5,"render","","Render `input` (e.g. \"foo.md\") into an HTML file in `output` (e.g. output = \"bar\" => \"bar/foo.html\").",N,[[["path"],["pathbuf"],["matches"],["externalhtml"],["bool"],["handler"]],["isize"]]],[5,"test","","Run any tests/code examples in the markdown file `input`.",N,[[["str"],["vec",["string"]],["searchpaths"],["externs"],["vec",["string"]],["option",["pathbuf"]],["bool"],["option",["pathbuf"]],["edition"],["codegenoptions"],["handler"]],["isize"]]],[0,"passes","rustdoc","Contains information about \"passes\", used to modify crate information during the documentation process.",N,N],[3,"Stripper","rustdoc::passes","",N,N],[12,"retained","","",151,N],[12,"access_levels","","",151,N],[12,"update_retained","","",151,N],[3,"ImplStripper","","",N,N],[12,"retained","","",152,N],[3,"ImportStripper","","",N,N],[4,"Pass","","Represents a single pass.",N,N],[13,"EarlyPass","","An \"early pass\" is run in the compiler context, and can gather information about types and traits and the like.",153,N],[12,"name","rustdoc::passes::Pass","",153,N],[12,"pass","","",153,N],[12,"description","","",153,N],[13,"LatePass","rustdoc::passes","A \"late pass\" is run between crate cleaning and page generation.",153,N],[12,"name","rustdoc::passes::Pass","",153,N],[12,"pass","","",153,N],[12,"description","","",153,N],[4,"DefaultPassOption","rustdoc::passes","A shorthand way to refer to which set of passes to use, based on the presence of `--no-defaults` or `--document-private-items`.",N,N],[13,"Default","","",154,N],[13,"Private","","",154,N],[13,"None","","",154,N],[5,"defaults","","Returns the given default set of passes.",N,N],[5,"find_pass","","If the given name matches a known pass, returns its information.",N,[[["str"]],["option",["pass"]]]],[0,"collapse_docs","","",N,N],[3,"Collapser","rustdoc::passes::collapse_docs","",N,N],[4,"DocFragmentKind","","",N,N],[13,"Sugared","","",155,N],[13,"Raw","","",155,N],[13,"Include","","",155,N],[5,"collapse_docs","","",N,[[["crate"]],["crate"]]],[5,"collapse","","",N,[[["vec"]]]],[17,"COLLAPSE_DOCS","","",N,N],[11,"clone","","",155,[[["self"]],["docfragmentkind"]]],[11,"fmt","","",155,[[["self"],["formatter"]],["result"]]],[11,"eq","","",155,[[["self"],["docfragmentkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",155,N],[11,"kind","rustdoc::clean","",41,[[["self"]],["docfragmentkind"]]],[11,"fold_item","rustdoc::passes::collapse_docs","",156,[[["self"],["item"]],["option",["item"]]]],[11,"collapse_doc_comments","rustdoc::clean","",8,[[["self"]]]],[0,"strip_hidden","rustdoc::passes","",N,N],[3,"Stripper","rustdoc::passes::strip_hidden","",N,N],[12,"retained","","",157,N],[12,"update_retained","","",157,N],[5,"strip_hidden","","Strip items marked `#[doc(hidden)]`",N,[[["crate"],["doccontext"]],["crate"]]],[17,"STRIP_HIDDEN","","",N,N],[11,"fold_item","","",157,[[["self"],["item"]],["option",["item"]]]],[0,"strip_private","rustdoc::passes","",N,N],[5,"strip_private","rustdoc::passes::strip_private","Strip private items from the point of view of a crate or externally from a crate, specified by the `xcrate` flag.",N,[[["crate"],["doccontext"]],["crate"]]],[17,"STRIP_PRIVATE","","",N,N],[0,"strip_priv_imports","rustdoc::passes","",N,N],[5,"strip_priv_imports","rustdoc::passes::strip_priv_imports","",N,[[["crate"],["doccontext"]],["crate"]]],[17,"STRIP_PRIV_IMPORTS","","",N,N],[0,"unindent_comments","rustdoc::passes","",N,N],[3,"CommentCleaner","rustdoc::passes::unindent_comments","",N,N],[5,"unindent_comments","","",N,[[["crate"]],["crate"]]],[5,"unindent_fragments","","",N,[[["vec"]]]],[5,"unindent","","",N,[[["str"]],["string"]]],[17,"UNINDENT_COMMENTS","","",N,N],[11,"fold_item","","",158,[[["self"],["item"]],["option",["item"]]]],[11,"unindent_doc_comments","rustdoc::clean","",8,[[["self"]]]],[0,"propagate_doc_cfg","rustdoc::passes","",N,N],[3,"CfgPropagator","rustdoc::passes::propagate_doc_cfg","",N,N],[12,"parent_cfg","","",159,N],[5,"propagate_doc_cfg","","",N,[[["crate"]],["crate"]]],[17,"PROPAGATE_DOC_CFG","","",N,N],[11,"fold_item","","",159,[[["self"],["item"]],["option",["item"]]]],[0,"collect_intra_doc_links","rustdoc::passes","",N,N],[3,"LinkCollector","rustdoc::passes::collect_intra_doc_links","",N,N],[12,"cx","","",160,N],[12,"mod_ids","","",160,N],[4,"PathKind","","",N,N],[13,"Unknown","","can be either value or type, not a macro",161,N],[13,"Macro","","macro",161,N],[13,"Value","","values, functions, consts, statics, everything in the value namespace",161,N],[13,"Type","","types, traits, everything in the type namespace",161,N],[5,"collect_intra_doc_links","","",N,[[["crate"],["doccontext"]],["crate"]]],[5,"macro_resolve","","Resolve a string as a macro",N,[[["doccontext"],["str"]],["option",["def"]]]],[5,"span_of_attrs","","",N,[[["attributes"]],["span"]]],[5,"resolution_failure","","",N,[[["doccontext"],["attributes"],["str"],["str"],["option",["range"]]]]],[5,"ambiguity_error","","",N,[[["doccontext"],["attributes"],["str"],["str"],["str"],["str"],["str"],["str"],["str"]]]],[5,"value_ns_kind","","Given a def, returns its name and disambiguator for a value namespace",N,[[["def"],["str"]],["option"]]],[5,"type_ns_kind","","Given a def, returns its name, the article to be used, and a disambiguator for the type namespace",N,N],[5,"handle_variant","","Given an enum variant's def, return the def of its enum and the associated fragment",N,[[["doccontext"],["def"]],["result"]]],[5,"is_primitive","","",N,[[["str"],["bool"]],["option",["def"]]]],[17,"COLLECT_INTRA_DOC_LINKS","","",N,N],[17,"PRIMITIVES","","",N,N],[11,"fmt","","",161,[[["self"],["formatter"]],["result"]]],[11,"new","","",160,[[["doccontext"]],["self"]]],[11,"resolve","","Resolve a given string as a path, along with whether or not it is in the value namespace. Also returns an optional URL fragment in the case of variants and methods",160,[[["self"],["str"],["bool"],["option"]],["result"]]],[11,"fold_item","","",160,[[["self"],["item"]],["option",["item"]]]],[17,"PASSES","rustdoc::passes","The full list of passes.",N,N],[17,"DEFAULT_PASSES","","The list of passes run by default.",N,N],[17,"DEFAULT_PRIVATE_PASSES","","The list of default passes run with `--document-private-items` is passed to rustdoc.",N,N],[11,"clone","","",153,[[["self"]],["pass"]]],[11,"fmt","","",153,[[["self"],["formatter"]],["result"]]],[11,"early","","Constructs a new early pass.",153,N],[11,"late","","Constructs a new late pass.",153,N],[11,"name","","Returns the name of this pass.",153,[[["self"]],["str"]]],[11,"description","","Returns the description of this pass.",153,[[["self"]],["str"]]],[11,"early_fn","","If this pass is an early pass, returns the pointer to its function.",153,[[["self"]],["option"]]],[11,"late_fn","","If this pass is a late pass, returns the pointer to its function.",153,[[["self"]],["option"]]],[11,"clone","","",154,[[["self"]],["defaultpassoption"]]],[11,"eq","","",154,[[["self"],["defaultpassoption"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",154,N],[11,"fmt","","",154,[[["self"],["formatter"]],["result"]]],[11,"fold_item","","",151,[[["self"],["item"]],["option",["item"]]]],[11,"fold_item","","",152,[[["self"],["item"]],["option",["item"]]]],[11,"fold_item","","",162,[[["self"],["item"]],["option",["item"]]]],[0,"visit_ast","rustdoc","Rust AST Visitor. Extracts useful information and massages it into a form usable for clean",N,N],[3,"RustdocVisitor","rustdoc::visit_ast","",N,N],[12,"module","","",163,N],[12,"attrs","","",163,N],[12,"cx","","",163,N],[12,"view_item_stack","","",163,N],[12,"inlining","","",163,N],[12,"inside_public_path","","Is the current module and all of its parents public?",163,N],[12,"exact_paths","","",163,N],[11,"new","","",163,[[["doccontext"]],["rustdocvisitor"]]],[11,"store_path","","",163,[[["self"],["defid"]]]],[11,"stability","","",163,[[["self"],["nodeid"]],["option",["stability"]]]],[11,"deprecation","","",163,[[["self"],["nodeid"]],["option",["deprecation"]]]],[11,"visit","","",163,[[["self"],["crate"]]]],[11,"visit_variant_data","","",163,[[["self"],["item"],["name"],["variantdata"],["generics"]],["struct"]]],[11,"visit_union_data","","",163,[[["self"],["item"],["name"],["variantdata"],["generics"]],["union"]]],[11,"visit_enum_def","","",163,[[["self"],["item"],["name"],["enumdef"],["generics"]],["enum"]]],[11,"visit_fn","","",163,[[["self"],["item"],["name"],["fndecl"],["fnheader"],["generics"],["bodyid"]],["function"]]],[11,"visit_mod_contents","","",163,[[["self"],["span"],["hirvec",["attribute"]],["visibility"],["nodeid"],["mod"],["option",["name"]]],["module"]]],[11,"maybe_inline_local","","Tries to resolve the target of a `pub use` statement and inlines the target if it is defined locally and would not be documented otherwise, or when it is specifically requested with `please_inline`. (the latter is the case when the import is marked `doc(inline)`)",163,[[["self"],["nodeid"],["def"],["option",["name"]],["bool"],["module"],["bool"]],["bool"]]],[11,"visit_item","","",163,[[["self"],["item"],["option",["name"]],["module"]]]],[11,"visit_local_macro","","",163,[[["self"],["macrodef"]],["macro"]]],[0,"visit_lib","rustdoc","",N,N],[3,"LibEmbargoVisitor","rustdoc::visit_lib","Similar to `librustc_privacy::EmbargoVisitor`, but also takes specific rustdoc annotations into account (i.e. `doc(hidden)`)",N,N],[12,"cx","","",164,N],[12,"access_levels","","",164,N],[12,"prev_level","","",164,N],[12,"visited_mods","","",164,N],[11,"new","","",164,[[["doccontext"]],["libembargovisitor"]]],[11,"visit_lib","","",164,[[["self"],["cratenum"]]]],[11,"update","","",164,[[["self"],["defid"],["option",["accesslevel"]]],["option",["accesslevel"]]]],[11,"visit_mod","","",164,[[["self"],["defid"]]]],[11,"visit_item","","",164,[[["self"],["def"]]]],[0,"test","rustdoc","",N,N],[3,"TestOptions","rustdoc::test","",N,N],[12,"no_crate_inject","","Whether to disable the default `extern crate my_crate;` when creating doctests.",165,N],[12,"display_warnings","","Whether to emit compilation warnings when compiling doctests. Setting this will suppress the default `#![allow(unused)]`.",165,N],[12,"attrs","","Additional crate-level attributes to add to doctests.",165,N],[3,"Collector","","",N,N],[12,"tests","","",166,N],[12,"names","","",166,N],[12,"cfgs","","",166,N],[12,"libs","","",166,N],[12,"cg","","",166,N],[12,"externs","","",166,N],[12,"use_headers","","",166,N],[12,"cratename","","",166,N],[12,"opts","","",166,N],[12,"maybe_sysroot","","",166,N],[12,"position","","",166,N],[12,"source_map","","",166,N],[12,"filename","","",166,N],[12,"linker","","",166,N],[12,"edition","","",166,N],[3,"HirCollector","","",N,N],[12,"sess","","",167,N],[12,"collector","","",167,N],[12,"map","","",167,N],[12,"codes","","",167,N],[5,"run","","",N,[[["path"],["vec",["string"]],["searchpaths"],["externs"],["vec",["string"]],["option",["string"]],["option",["pathbuf"]],["bool"],["option",["pathbuf"]],["edition"],["codegenoptions"]],["isize"]]],[5,"scrape_test_config","","",N,[[["crate"]],["testoptions"]]],[5,"run_test","","",N,[[["str"],["str"],["filename"],["usize"],["vec",["string"]],["searchpaths"],["codegenoptions"],["externs"],["bool"],["bool"],["bool"],["bool"],["vec",["string"]],["testoptions"],["option",["pathbuf"]],["option",["pathbuf"]],["edition"]]]],[5,"make_test","","Makes the test file. Also returns the number of lines before the code begins",N,N],[5,"partition_source","","",N,N],[11,"clone","","",165,[[["self"]],["testoptions"]]],[11,"default","","",165,[[],["testoptions"]]],[11,"new","","",166,[[["string"],["vec",["string"]],["searchpaths"],["codegenoptions"],["externs"],["bool"],["testoptions"],["option",["pathbuf"]],["option",["lrc"]],["option",["pathbuf"]],["option",["pathbuf"]],["edition"]],["collector"]]],[11,"generate_name","","",166,[[["self"],["usize"],["filename"]],["string"]]],[11,"add_test","","",166,[[["self"],["string"],["langstring"],["usize"]]]],[11,"get_line","","",166,[[["self"]],["usize"]]],[11,"set_position","","",166,[[["self"],["span"]]]],[11,"get_filename","","",166,[[["self"]],["filename"]]],[11,"register_header","","",166,[[["self"],["str"],["u32"]]]],[11,"visit_testable","","",167,N],[11,"nested_visit_map","","",167,[[["self"]],["nestedvisitormap"]]],[11,"visit_item","","",167,[[["self"],["item"]]]],[11,"visit_trait_item","","",167,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",167,[[["self"],["implitem"]]]],[11,"visit_foreign_item","","",167,[[["self"],["foreignitem"]]]],[11,"visit_variant","","",167,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_struct_field","","",167,[[["self"],["structfield"]]]],[11,"visit_macro_def","","",167,[[["self"],["macrodef"]]]],[0,"theme","rustdoc","",N,N],[3,"CssPath","rustdoc::theme","",N,N],[12,"name","","",168,N],[12,"children","","",168,N],[4,"Events","","All variants contain the position they occur.",N,N],[13,"StartLineComment","","",169,N],[13,"StartComment","","",169,N],[13,"EndComment","","",169,N],[13,"InBlock","","",169,N],[13,"OutBlock","","",169,N],[5,"previous_is_line_comment","","",N,N],[5,"is_line_comment","","",N,N],[5,"load_css_events","","",N,N],[5,"get_useful_next","","",N,N],[5,"get_previous_positions","","",N,N],[5,"build_rule","","",N,N],[5,"inner","","",N,N],[5,"load_css_paths","","",N,N],[5,"get_differences","","",N,[[["csspath"],["csspath"],["vec"]]]],[5,"test_theme_against","","",N,N],[11,"fmt","","",168,[[["self"],["formatter"]],["result"]]],[11,"clone","","",168,[[["self"]],["csspath"]]],[11,"assert_receiver_is_total_eq","","",168,N],[11,"eq","","",168,[[["self"],["csspath"]],["bool"]]],[11,"hash","","",168,[[["self"],["h"]]]],[11,"new","","",168,[[["string"]],["csspath"]]],[11,"fmt","","",169,[[["self"],["formatter"]],["result"]]],[11,"clone","","",169,[[["self"]],["events"]]],[11,"get_pos","","",169,[[["self"]],["usize"]]],[11,"is_comment","","",169,[[["self"]],["bool"]]],[11,"from","rustdoc","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from_ok","","",0,[[["t"]],["t"]]],[11,"map_same","","",0,[[["self"],["f"]],["t"]]],[11,"to_owned","rustdoc::externalfiles","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"from_ok","","",1,[[["t"]],["t"]]],[11,"map_same","","",1,[[["self"],["f"]],["t"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from_ok","","",2,[[["t"]],["t"]]],[11,"map_same","","",2,[[["self"],["f"]],["t"]]],[11,"to_owned","rustdoc::clean","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from_ok","","",3,[[["t"]],["t"]]],[11,"map_same","","",3,[[["self"],["f"]],["t"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"encode","","",4,[[["self"],["e"]],["result"]]],[11,"decode","","",4,[[["d"]],["result"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from_ok","","",4,[[["t"]],["t"]]],[11,"map_same","","",4,[[["self"],["f"]],["t"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"encode","","",5,[[["self"],["e"]],["result"]]],[11,"decode","","",5,[[["d"]],["result"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from_ok","","",5,[[["t"]],["t"]]],[11,"map_same","","",5,[[["self"],["f"]],["t"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"encode","","",6,[[["self"],["e"]],["result"]]],[11,"decode","","",6,[[["d"]],["result"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from_ok","","",6,[[["t"]],["t"]]],[11,"map_same","","",6,[[["self"],["f"]],["t"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"into_iter","","",7,[[["self"]],["i"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from_ok","","",7,[[["t"]],["t"]]],[11,"map_same","","",7,[[["self"],["f"]],["t"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"encode","","",8,[[["self"],["e"]],["result"]]],[11,"decode","","",8,[[["d"]],["result"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"from_ok","","",8,[[["t"]],["t"]]],[11,"map_same","","",8,[[["self"],["f"]],["t"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"to_string","","",9,[[["self"]],["string"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"encode","","",9,[[["self"],["e"]],["result"]]],[11,"decode","","",9,[[["d"]],["result"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from_ok","","",9,[[["t"]],["t"]]],[11,"map_same","","",9,[[["self"],["f"]],["t"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"to_string","","",10,[[["self"]],["string"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"encode","","",10,[[["self"],["e"]],["result"]]],[11,"decode","","",10,[[["d"]],["result"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from_ok","","",10,[[["t"]],["t"]]],[11,"map_same","","",10,[[["self"],["f"]],["t"]]],[11,"to_owned","","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"to_string","","",11,[[["self"]],["string"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"encode","","",11,[[["self"],["e"]],["result"]]],[11,"decode","","",11,[[["d"]],["result"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from_ok","","",11,[[["t"]],["t"]]],[11,"map_same","","",11,[[["self"],["f"]],["t"]]],[11,"to_owned","","",12,[[["self"]],["t"]]],[11,"clone_into","","",12,N],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"encode","","",12,[[["self"],["e"]],["result"]]],[11,"decode","","",12,[[["d"]],["result"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from_ok","","",12,[[["t"]],["t"]]],[11,"map_same","","",12,[[["self"],["f"]],["t"]]],[11,"to_owned","","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"encode","","",13,[[["self"],["e"]],["result"]]],[11,"decode","","",13,[[["d"]],["result"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from_ok","","",13,[[["t"]],["t"]]],[11,"map_same","","",13,[[["self"],["f"]],["t"]]],[11,"to_owned","","",14,[[["self"]],["t"]]],[11,"clone_into","","",14,N],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"encode","","",14,[[["self"],["e"]],["result"]]],[11,"decode","","",14,[[["d"]],["result"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from_ok","","",14,[[["t"]],["t"]]],[11,"map_same","","",14,[[["self"],["f"]],["t"]]],[11,"to_owned","","",15,[[["self"]],["t"]]],[11,"clone_into","","",15,N],[11,"from","","",15,[[["t"]],["t"]]],[11,"to_string","","",15,[[["self"]],["string"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"encode","","",15,[[["self"],["e"]],["result"]]],[11,"decode","","",15,[[["d"]],["result"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from_ok","","",15,[[["t"]],["t"]]],[11,"map_same","","",15,[[["self"],["f"]],["t"]]],[11,"to_owned","","",16,[[["self"]],["t"]]],[11,"clone_into","","",16,N],[11,"from","","",16,[[["t"]],["t"]]],[11,"to_string","","",16,[[["self"]],["string"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"encode","","",16,[[["self"],["e"]],["result"]]],[11,"decode","","",16,[[["d"]],["result"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from_ok","","",16,[[["t"]],["t"]]],[11,"map_same","","",16,[[["self"],["f"]],["t"]]],[11,"to_owned","","",17,[[["self"]],["t"]]],[11,"clone_into","","",17,N],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"encode","","",17,[[["self"],["e"]],["result"]]],[11,"decode","","",17,[[["d"]],["result"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"from_ok","","",17,[[["t"]],["t"]]],[11,"map_same","","",17,[[["self"],["f"]],["t"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"encode","","",18,[[["self"],["e"]],["result"]]],[11,"decode","","",18,[[["d"]],["result"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from_ok","","",18,[[["t"]],["t"]]],[11,"map_same","","",18,[[["self"],["f"]],["t"]]],[11,"to_owned","","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"to_string","","",19,[[["self"]],["string"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"encode","","",19,[[["self"],["e"]],["result"]]],[11,"decode","","",19,[[["d"]],["result"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"from_ok","","",19,[[["t"]],["t"]]],[11,"map_same","","",19,[[["self"],["f"]],["t"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"encode","","",20,[[["self"],["e"]],["result"]]],[11,"decode","","",20,[[["d"]],["result"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from_ok","","",20,[[["t"]],["t"]]],[11,"map_same","","",20,[[["self"],["f"]],["t"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"encode","","",21,[[["self"],["e"]],["result"]]],[11,"decode","","",21,[[["d"]],["result"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from_ok","","",21,[[["t"]],["t"]]],[11,"map_same","","",21,[[["self"],["f"]],["t"]]],[11,"to_owned","","",22,[[["self"]],["t"]]],[11,"clone_into","","",22,N],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"encode","","",22,[[["self"],["e"]],["result"]]],[11,"decode","","",22,[[["d"]],["result"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from_ok","","",22,[[["t"]],["t"]]],[11,"map_same","","",22,[[["self"],["f"]],["t"]]],[11,"to_owned","","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"encode","","",23,[[["self"],["e"]],["result"]]],[11,"decode","","",23,[[["d"]],["result"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"from_ok","","",23,[[["t"]],["t"]]],[11,"map_same","","",23,[[["self"],["f"]],["t"]]],[11,"to_owned","","",24,[[["self"]],["t"]]],[11,"clone_into","","",24,N],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"encode","","",24,[[["self"],["e"]],["result"]]],[11,"decode","","",24,[[["d"]],["result"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"from_ok","","",24,[[["t"]],["t"]]],[11,"map_same","","",24,[[["self"],["f"]],["t"]]],[11,"to_owned","","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"encode","","",25,[[["self"],["e"]],["result"]]],[11,"decode","","",25,[[["d"]],["result"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from_ok","","",25,[[["t"]],["t"]]],[11,"map_same","","",25,[[["self"],["f"]],["t"]]],[11,"to_owned","","",26,[[["self"]],["t"]]],[11,"clone_into","","",26,N],[11,"from","","",26,[[["t"]],["t"]]],[11,"to_string","","",26,[[["self"]],["string"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"encode","","",26,[[["self"],["e"]],["result"]]],[11,"decode","","",26,[[["d"]],["result"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"from_ok","","",26,[[["t"]],["t"]]],[11,"map_same","","",26,[[["self"],["f"]],["t"]]],[11,"to_owned","","",27,[[["self"]],["t"]]],[11,"clone_into","","",27,N],[11,"from","","",27,[[["t"]],["t"]]],[11,"to_string","","",27,[[["self"]],["string"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"encode","","",27,[[["self"],["e"]],["result"]]],[11,"decode","","",27,[[["d"]],["result"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from_ok","","",27,[[["t"]],["t"]]],[11,"map_same","","",27,[[["self"],["f"]],["t"]]],[11,"to_owned","","",28,[[["self"]],["t"]]],[11,"clone_into","","",28,N],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"encode","","",28,[[["self"],["e"]],["result"]]],[11,"decode","","",28,[[["d"]],["result"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from_ok","","",28,[[["t"]],["t"]]],[11,"map_same","","",28,[[["self"],["f"]],["t"]]],[11,"to_owned","","",29,[[["self"]],["t"]]],[11,"clone_into","","",29,N],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"encode","","",29,[[["self"],["e"]],["result"]]],[11,"decode","","",29,[[["d"]],["result"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from_ok","","",29,[[["t"]],["t"]]],[11,"map_same","","",29,[[["self"],["f"]],["t"]]],[11,"to_owned","","",30,[[["self"]],["t"]]],[11,"clone_into","","",30,N],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"encode","","",30,[[["self"],["e"]],["result"]]],[11,"decode","","",30,[[["d"]],["result"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"from_ok","","",30,[[["t"]],["t"]]],[11,"map_same","","",30,[[["self"],["f"]],["t"]]],[11,"to_owned","","",31,[[["self"]],["t"]]],[11,"clone_into","","",31,N],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"encode","","",31,[[["self"],["e"]],["result"]]],[11,"decode","","",31,[[["d"]],["result"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"from_ok","","",31,[[["t"]],["t"]]],[11,"map_same","","",31,[[["self"],["f"]],["t"]]],[11,"to_owned","","",32,[[["self"]],["t"]]],[11,"clone_into","","",32,N],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"encode","","",32,[[["self"],["e"]],["result"]]],[11,"decode","","",32,[[["d"]],["result"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from_ok","","",32,[[["t"]],["t"]]],[11,"map_same","","",32,[[["self"],["f"]],["t"]]],[11,"to_owned","","",33,[[["self"]],["t"]]],[11,"clone_into","","",33,N],[11,"from","","",33,[[["t"]],["t"]]],[11,"to_string","","",33,[[["self"]],["string"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"encode","","",33,[[["self"],["e"]],["result"]]],[11,"decode","","",33,[[["d"]],["result"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from_ok","","",33,[[["t"]],["t"]]],[11,"map_same","","",33,[[["self"],["f"]],["t"]]],[11,"to_owned","","",34,[[["self"]],["t"]]],[11,"clone_into","","",34,N],[11,"from","","",34,[[["t"]],["t"]]],[11,"to_string","","",34,[[["self"]],["string"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"encode","","",34,[[["self"],["e"]],["result"]]],[11,"decode","","",34,[[["d"]],["result"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"from_ok","","",34,[[["t"]],["t"]]],[11,"map_same","","",34,[[["self"],["f"]],["t"]]],[11,"to_owned","","",35,[[["self"]],["t"]]],[11,"clone_into","","",35,N],[11,"from","","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"encode","","",35,[[["self"],["e"]],["result"]]],[11,"decode","","",35,[[["d"]],["result"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"from_ok","","",35,[[["t"]],["t"]]],[11,"map_same","","",35,[[["self"],["f"]],["t"]]],[11,"to_owned","","",36,[[["self"]],["t"]]],[11,"clone_into","","",36,N],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"encode","","",36,[[["self"],["e"]],["result"]]],[11,"decode","","",36,[[["d"]],["result"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"from_ok","","",36,[[["t"]],["t"]]],[11,"map_same","","",36,[[["self"],["f"]],["t"]]],[11,"to_owned","","",37,[[["self"]],["t"]]],[11,"clone_into","","",37,N],[11,"from","","",37,[[["t"]],["t"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"encode","","",37,[[["self"],["e"]],["result"]]],[11,"decode","","",37,[[["d"]],["result"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"from_ok","","",37,[[["t"]],["t"]]],[11,"map_same","","",37,[[["self"],["f"]],["t"]]],[11,"to_owned","","",38,[[["self"]],["t"]]],[11,"clone_into","","",38,N],[11,"from","","",38,[[["t"]],["t"]]],[11,"to_string","","",38,[[["self"]],["string"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"encode","","",38,[[["self"],["e"]],["result"]]],[11,"decode","","",38,[[["d"]],["result"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"from_ok","","",38,[[["t"]],["t"]]],[11,"map_same","","",38,[[["self"],["f"]],["t"]]],[11,"to_owned","","",39,[[["self"]],["t"]]],[11,"clone_into","","",39,N],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"from_ok","","",39,[[["t"]],["t"]]],[11,"map_same","","",39,[[["self"],["f"]],["t"]]],[11,"to_owned","","",40,[[["self"]],["t"]]],[11,"clone_into","","",40,N],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"encode","","",40,[[["self"],["e"]],["result"]]],[11,"decode","","",40,[[["d"]],["result"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from_ok","","",40,[[["t"]],["t"]]],[11,"map_same","","",40,[[["self"],["f"]],["t"]]],[11,"to_owned","","",41,[[["self"]],["t"]]],[11,"clone_into","","",41,N],[11,"from","","",41,[[["t"]],["t"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"encode","","",41,[[["self"],["e"]],["result"]]],[11,"decode","","",41,[[["d"]],["result"]]],[11,"not_found","","",41,[[["str"],["str"]],["e"]]],[11,"from_ok","","",41,[[["t"]],["t"]]],[11,"map_same","","",41,[[["self"],["f"]],["t"]]],[11,"to_owned","","",42,[[["self"]],["t"]]],[11,"clone_into","","",42,N],[11,"from","","",42,[[["t"]],["t"]]],[11,"to_string","","",42,[[["self"]],["string"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"encode","","",42,[[["self"],["e"]],["result"]]],[11,"decode","","",42,[[["d"]],["result"]]],[11,"not_found","","",42,[[["str"],["str"]],["e"]]],[11,"from_ok","","",42,[[["t"]],["t"]]],[11,"map_same","","",42,[[["self"],["f"]],["t"]]],[11,"to_owned","","",43,[[["self"]],["t"]]],[11,"clone_into","","",43,N],[11,"from","","",43,[[["t"]],["t"]]],[11,"into","","",43,[[["self"]],["u"]]],[11,"try_from","","",43,[[["u"]],["result"]]],[11,"borrow","","",43,[[["self"]],["t"]]],[11,"try_into","","",43,[[["self"]],["result"]]],[11,"borrow_mut","","",43,[[["self"]],["t"]]],[11,"get_type_id","","",43,[[["self"]],["typeid"]]],[11,"encode","","",43,[[["self"],["e"]],["result"]]],[11,"decode","","",43,[[["d"]],["result"]]],[11,"not_found","","",43,[[["str"],["str"]],["e"]]],[11,"from_ok","","",43,[[["t"]],["t"]]],[11,"map_same","","",43,[[["self"],["f"]],["t"]]],[11,"to_owned","","",44,[[["self"]],["t"]]],[11,"clone_into","","",44,N],[11,"from","","",44,[[["t"]],["t"]]],[11,"into","","",44,[[["self"]],["u"]]],[11,"try_from","","",44,[[["u"]],["result"]]],[11,"borrow","","",44,[[["self"]],["t"]]],[11,"try_into","","",44,[[["self"]],["result"]]],[11,"borrow_mut","","",44,[[["self"]],["t"]]],[11,"get_type_id","","",44,[[["self"]],["typeid"]]],[11,"encode","","",44,[[["self"],["e"]],["result"]]],[11,"decode","","",44,[[["d"]],["result"]]],[11,"not_found","","",44,[[["str"],["str"]],["e"]]],[11,"from_ok","","",44,[[["t"]],["t"]]],[11,"map_same","","",44,[[["self"],["f"]],["t"]]],[11,"to_owned","","",45,[[["self"]],["t"]]],[11,"clone_into","","",45,N],[11,"from","","",45,[[["t"]],["t"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"encode","","",45,[[["self"],["e"]],["result"]]],[11,"decode","","",45,[[["d"]],["result"]]],[11,"not_found","","",45,[[["str"],["str"]],["e"]]],[11,"from_ok","","",45,[[["t"]],["t"]]],[11,"map_same","","",45,[[["self"],["f"]],["t"]]],[11,"to_owned","","",46,[[["self"]],["t"]]],[11,"clone_into","","",46,N],[11,"from","","",46,[[["t"]],["t"]]],[11,"to_string","","",46,[[["self"]],["string"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"encode","","",46,[[["self"],["e"]],["result"]]],[11,"decode","","",46,[[["d"]],["result"]]],[11,"not_found","","",46,[[["str"],["str"]],["e"]]],[11,"from_ok","","",46,[[["t"]],["t"]]],[11,"map_same","","",46,[[["self"],["f"]],["t"]]],[11,"to_owned","","",47,[[["self"]],["t"]]],[11,"clone_into","","",47,N],[11,"from","","",47,[[["t"]],["t"]]],[11,"to_string","","",47,[[["self"]],["string"]]],[11,"into","","",47,[[["self"]],["u"]]],[11,"try_from","","",47,[[["u"]],["result"]]],[11,"borrow","","",47,[[["self"]],["t"]]],[11,"try_into","","",47,[[["self"]],["result"]]],[11,"borrow_mut","","",47,[[["self"]],["t"]]],[11,"get_type_id","","",47,[[["self"]],["typeid"]]],[11,"encode","","",47,[[["self"],["e"]],["result"]]],[11,"decode","","",47,[[["d"]],["result"]]],[11,"not_found","","",47,[[["str"],["str"]],["e"]]],[11,"from_ok","","",47,[[["t"]],["t"]]],[11,"map_same","","",47,[[["self"],["f"]],["t"]]],[11,"to_owned","","",48,[[["self"]],["t"]]],[11,"clone_into","","",48,N],[11,"from","","",48,[[["t"]],["t"]]],[11,"into","","",48,[[["self"]],["u"]]],[11,"try_from","","",48,[[["u"]],["result"]]],[11,"borrow","","",48,[[["self"]],["t"]]],[11,"try_into","","",48,[[["self"]],["result"]]],[11,"borrow_mut","","",48,[[["self"]],["t"]]],[11,"get_type_id","","",48,[[["self"]],["typeid"]]],[11,"encode","","",48,[[["self"],["e"]],["result"]]],[11,"decode","","",48,[[["d"]],["result"]]],[11,"not_found","","",48,[[["str"],["str"]],["e"]]],[11,"from_ok","","",48,[[["t"]],["t"]]],[11,"map_same","","",48,[[["self"],["f"]],["t"]]],[11,"to_owned","","",49,[[["self"]],["t"]]],[11,"clone_into","","",49,N],[11,"from","","",49,[[["t"]],["t"]]],[11,"into","","",49,[[["self"]],["u"]]],[11,"try_from","","",49,[[["u"]],["result"]]],[11,"borrow","","",49,[[["self"]],["t"]]],[11,"try_into","","",49,[[["self"]],["result"]]],[11,"borrow_mut","","",49,[[["self"]],["t"]]],[11,"get_type_id","","",49,[[["self"]],["typeid"]]],[11,"encode","","",49,[[["self"],["e"]],["result"]]],[11,"decode","","",49,[[["d"]],["result"]]],[11,"not_found","","",49,[[["str"],["str"]],["e"]]],[11,"from_ok","","",49,[[["t"]],["t"]]],[11,"map_same","","",49,[[["self"],["f"]],["t"]]],[11,"to_owned","","",50,[[["self"]],["t"]]],[11,"clone_into","","",50,N],[11,"from","","",50,[[["t"]],["t"]]],[11,"into","","",50,[[["self"]],["u"]]],[11,"try_from","","",50,[[["u"]],["result"]]],[11,"borrow","","",50,[[["self"]],["t"]]],[11,"try_into","","",50,[[["self"]],["result"]]],[11,"borrow_mut","","",50,[[["self"]],["t"]]],[11,"get_type_id","","",50,[[["self"]],["typeid"]]],[11,"encode","","",50,[[["self"],["e"]],["result"]]],[11,"decode","","",50,[[["d"]],["result"]]],[11,"not_found","","",50,[[["str"],["str"]],["e"]]],[11,"from_ok","","",50,[[["t"]],["t"]]],[11,"map_same","","",50,[[["self"],["f"]],["t"]]],[11,"to_owned","","",51,[[["self"]],["t"]]],[11,"clone_into","","",51,N],[11,"from","","",51,[[["t"]],["t"]]],[11,"into","","",51,[[["self"]],["u"]]],[11,"try_from","","",51,[[["u"]],["result"]]],[11,"borrow","","",51,[[["self"]],["t"]]],[11,"try_into","","",51,[[["self"]],["result"]]],[11,"borrow_mut","","",51,[[["self"]],["t"]]],[11,"get_type_id","","",51,[[["self"]],["typeid"]]],[11,"encode","","",51,[[["self"],["e"]],["result"]]],[11,"decode","","",51,[[["d"]],["result"]]],[11,"not_found","","",51,[[["str"],["str"]],["e"]]],[11,"from_ok","","",51,[[["t"]],["t"]]],[11,"map_same","","",51,[[["self"],["f"]],["t"]]],[11,"to_owned","","",52,[[["self"]],["t"]]],[11,"clone_into","","",52,N],[11,"from","","",52,[[["t"]],["t"]]],[11,"to_string","","",52,[[["self"]],["string"]]],[11,"into","","",52,[[["self"]],["u"]]],[11,"try_from","","",52,[[["u"]],["result"]]],[11,"borrow","","",52,[[["self"]],["t"]]],[11,"try_into","","",52,[[["self"]],["result"]]],[11,"borrow_mut","","",52,[[["self"]],["t"]]],[11,"get_type_id","","",52,[[["self"]],["typeid"]]],[11,"encode","","",52,[[["self"],["e"]],["result"]]],[11,"decode","","",52,[[["d"]],["result"]]],[11,"not_found","","",52,[[["str"],["str"]],["e"]]],[11,"from_ok","","",52,[[["t"]],["t"]]],[11,"map_same","","",52,[[["self"],["f"]],["t"]]],[11,"to_owned","","",53,[[["self"]],["t"]]],[11,"clone_into","","",53,N],[11,"from","","",53,[[["t"]],["t"]]],[11,"into","","",53,[[["self"]],["u"]]],[11,"try_from","","",53,[[["u"]],["result"]]],[11,"borrow","","",53,[[["self"]],["t"]]],[11,"try_into","","",53,[[["self"]],["result"]]],[11,"borrow_mut","","",53,[[["self"]],["t"]]],[11,"get_type_id","","",53,[[["self"]],["typeid"]]],[11,"encode","","",53,[[["self"],["e"]],["result"]]],[11,"decode","","",53,[[["d"]],["result"]]],[11,"not_found","","",53,[[["str"],["str"]],["e"]]],[11,"from_ok","","",53,[[["t"]],["t"]]],[11,"map_same","","",53,[[["self"],["f"]],["t"]]],[11,"to_owned","","",54,[[["self"]],["t"]]],[11,"clone_into","","",54,N],[11,"from","","",54,[[["t"]],["t"]]],[11,"into","","",54,[[["self"]],["u"]]],[11,"try_from","","",54,[[["u"]],["result"]]],[11,"borrow","","",54,[[["self"]],["t"]]],[11,"try_into","","",54,[[["self"]],["result"]]],[11,"borrow_mut","","",54,[[["self"]],["t"]]],[11,"get_type_id","","",54,[[["self"]],["typeid"]]],[11,"encode","","",54,[[["self"],["e"]],["result"]]],[11,"decode","","",54,[[["d"]],["result"]]],[11,"not_found","","",54,[[["str"],["str"]],["e"]]],[11,"from_ok","","",54,[[["t"]],["t"]]],[11,"map_same","","",54,[[["self"],["f"]],["t"]]],[11,"to_owned","","",55,[[["self"]],["t"]]],[11,"clone_into","","",55,N],[11,"from","","",55,[[["t"]],["t"]]],[11,"to_string","","",55,[[["self"]],["string"]]],[11,"into","","",55,[[["self"]],["u"]]],[11,"try_from","","",55,[[["u"]],["result"]]],[11,"borrow","","",55,[[["self"]],["t"]]],[11,"try_into","","",55,[[["self"]],["result"]]],[11,"borrow_mut","","",55,[[["self"]],["t"]]],[11,"get_type_id","","",55,[[["self"]],["typeid"]]],[11,"encode","","",55,[[["self"],["e"]],["result"]]],[11,"decode","","",55,[[["d"]],["result"]]],[11,"not_found","","",55,[[["str"],["str"]],["e"]]],[11,"from_ok","","",55,[[["t"]],["t"]]],[11,"map_same","","",55,[[["self"],["f"]],["t"]]],[11,"to_owned","","",56,[[["self"]],["t"]]],[11,"clone_into","","",56,N],[11,"from","","",56,[[["t"]],["t"]]],[11,"into","","",56,[[["self"]],["u"]]],[11,"try_from","","",56,[[["u"]],["result"]]],[11,"borrow","","",56,[[["self"]],["t"]]],[11,"try_into","","",56,[[["self"]],["result"]]],[11,"borrow_mut","","",56,[[["self"]],["t"]]],[11,"get_type_id","","",56,[[["self"]],["typeid"]]],[11,"not_found","","",56,[[["str"],["str"]],["e"]]],[11,"from_ok","","",56,[[["t"]],["t"]]],[11,"map_same","","",56,[[["self"],["f"]],["t"]]],[11,"from","","",57,[[["t"]],["t"]]],[11,"into","","",57,[[["self"]],["u"]]],[11,"try_from","","",57,[[["u"]],["result"]]],[11,"borrow","","",57,[[["self"]],["t"]]],[11,"try_into","","",57,[[["self"]],["result"]]],[11,"borrow_mut","","",57,[[["self"]],["t"]]],[11,"get_type_id","","",57,[[["self"]],["typeid"]]],[11,"not_found","","",57,[[["str"],["str"]],["e"]]],[11,"from_ok","","",57,[[["t"]],["t"]]],[11,"map_same","","",57,[[["self"],["f"]],["t"]]],[11,"from","","",58,[[["t"]],["t"]]],[11,"into","","",58,[[["self"]],["u"]]],[11,"try_from","","",58,[[["u"]],["result"]]],[11,"borrow","","",58,[[["self"]],["t"]]],[11,"try_into","","",58,[[["self"]],["result"]]],[11,"borrow_mut","","",58,[[["self"]],["t"]]],[11,"get_type_id","","",58,[[["self"]],["typeid"]]],[11,"not_found","","",58,[[["str"],["str"]],["e"]]],[11,"from_ok","","",58,[[["t"]],["t"]]],[11,"map_same","","",58,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::clean::cfg","",59,[[["t"]],["t"]]],[11,"into","","",59,[[["self"]],["u"]]],[11,"try_from","","",59,[[["u"]],["result"]]],[11,"borrow","","",59,[[["self"]],["t"]]],[11,"try_into","","",59,[[["self"]],["result"]]],[11,"borrow_mut","","",59,[[["self"]],["t"]]],[11,"get_type_id","","",59,[[["self"]],["typeid"]]],[11,"not_found","","",59,[[["str"],["str"]],["e"]]],[11,"from_ok","","",59,[[["t"]],["t"]]],[11,"map_same","","",59,[[["self"],["f"]],["t"]]],[11,"from","","",60,[[["t"]],["t"]]],[11,"to_string","","",60,[[["self"]],["string"]]],[11,"into","","",60,[[["self"]],["u"]]],[11,"try_from","","",60,[[["u"]],["result"]]],[11,"borrow","","",60,[[["self"]],["t"]]],[11,"try_into","","",60,[[["self"]],["result"]]],[11,"borrow_mut","","",60,[[["self"]],["t"]]],[11,"get_type_id","","",60,[[["self"]],["typeid"]]],[11,"not_found","","",60,[[["str"],["str"]],["e"]]],[11,"from_ok","","",60,[[["t"]],["t"]]],[11,"map_same","","",60,[[["self"],["f"]],["t"]]],[11,"to_owned","","",61,[[["self"]],["t"]]],[11,"clone_into","","",61,N],[11,"from","","",61,[[["t"]],["t"]]],[11,"into","","",61,[[["self"]],["u"]]],[11,"try_from","","",61,[[["u"]],["result"]]],[11,"borrow","","",61,[[["self"]],["t"]]],[11,"try_into","","",61,[[["self"]],["result"]]],[11,"borrow_mut","","",61,[[["self"]],["t"]]],[11,"get_type_id","","",61,[[["self"]],["typeid"]]],[11,"encode","","",61,[[["self"],["e"]],["result"]]],[11,"decode","","",61,[[["d"]],["result"]]],[11,"not_found","","",61,[[["str"],["str"]],["e"]]],[11,"from_ok","","",61,[[["t"]],["t"]]],[11,"map_same","","",61,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::clean::auto_trait","",62,[[["t"]],["t"]]],[11,"into","","",62,[[["self"]],["u"]]],[11,"try_from","","",62,[[["u"]],["result"]]],[11,"borrow","","",62,[[["self"]],["t"]]],[11,"try_into","","",62,[[["self"]],["result"]]],[11,"borrow_mut","","",62,[[["self"]],["t"]]],[11,"get_type_id","","",62,[[["self"]],["typeid"]]],[11,"not_found","","",62,[[["str"],["str"]],["e"]]],[11,"from_ok","","",62,[[["t"]],["t"]]],[11,"map_same","","",62,[[["self"],["f"]],["t"]]],[11,"from","","",63,[[["t"]],["t"]]],[11,"into","","",63,[[["self"]],["u"]]],[11,"try_from","","",63,[[["u"]],["result"]]],[11,"borrow","","",63,[[["self"]],["t"]]],[11,"try_into","","",63,[[["self"]],["result"]]],[11,"borrow_mut","","",63,[[["self"]],["t"]]],[11,"get_type_id","","",63,[[["self"]],["typeid"]]],[11,"not_found","","",63,[[["str"],["str"]],["e"]]],[11,"from_ok","","",63,[[["t"]],["t"]]],[11,"map_same","","",63,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::clean::blanket_impl","",64,[[["t"]],["t"]]],[11,"into","","",64,[[["self"]],["u"]]],[11,"try_from","","",64,[[["u"]],["result"]]],[11,"borrow","","",64,[[["self"]],["t"]]],[11,"try_into","","",64,[[["self"]],["result"]]],[11,"borrow_mut","","",64,[[["self"]],["t"]]],[11,"get_type_id","","",64,[[["self"]],["typeid"]]],[11,"not_found","","",64,[[["str"],["str"]],["e"]]],[11,"from_ok","","",64,[[["t"]],["t"]]],[11,"map_same","","",64,[[["self"],["f"]],["t"]]],[11,"clean","rustdoc::visit_ast","",163,[[["self"],["doccontext"]],["crate"]]],[11,"clean","rustdoc::doctree","",76,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",81,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",86,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",77,[[["self"],["doccontext"]],["vec",["item"]]]],[11,"clean","","",78,[[["self"],["doccontext"]],["vec",["item"]]]],[11,"clean","","",79,[[["self"],["doccontext"]],["vec",["item"]]]],[11,"clean","","",80,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",82,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",83,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",84,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",85,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",87,[[["self"],["doccontext"]],["vec",["item"]]]],[11,"clean","","",89,[[["self"],["doccontext"]],["item"]]],[11,"clean","","",90,[[["self"],["doccontext"]],["vec",["item"]]]],[11,"clean","","",88,[[["self"],["doccontext"]],["item"]]],[11,"filestem","rustdoc::core","",70,[[["self"]],["string"]]],[11,"get_input","","",70,[[["self"]],["option",["string"]]]],[11,"from","","",70,[[["t"]],["t"]]],[11,"into","","",70,[[["self"]],["u"]]],[11,"try_from","","",70,[[["u"]],["result"]]],[11,"borrow","","",70,[[["self"]],["t"]]],[11,"try_into","","",70,[[["self"]],["result"]]],[11,"borrow_mut","","",70,[[["self"]],["t"]]],[11,"get_type_id","","",70,[[["self"]],["typeid"]]],[11,"not_found","","",70,[[["str"],["str"]],["e"]]],[11,"from_ok","","",70,[[["t"]],["t"]]],[11,"map_same","","",70,[[["self"],["f"]],["t"]]],[11,"default","","",71,[[],["options"]]],[11,"fmt","","",73,[[["self"],["formatter"]],["result",["error"]]]],[11,"clone","","",71,[[["self"]],["options"]]],[11,"clone","","",72,[[["self"]],["codegenoptions"]]],[11,"clone","","",73,[[["self"]],["searchpaths"]]],[11,"build_dep_graph","","True if there is a reason to build the dep graph.",71,[[["self"]],["bool"]]],[11,"enable_dep_node_debug_strs","","",71,[[["self"]],["bool"]]],[11,"file_path_mapping","","",71,[[["self"]],["filepathmapping"]]],[11,"will_create_output_file","","True if there will be an output file generated",71,[[["self"]],["bool"]]],[11,"share_generics","","",71,[[["self"]],["bool"]]],[11,"dep_tracking_hash","","",71,[[["self"]],["u64"]]],[11,"to_owned","","",71,[[["self"]],["t"]]],[11,"clone_into","","",71,N],[11,"from","","",71,[[["t"]],["t"]]],[11,"into","","",71,[[["self"]],["u"]]],[11,"try_from","","",71,[[["u"]],["result"]]],[11,"borrow","","",71,[[["self"]],["t"]]],[11,"try_into","","",71,[[["self"]],["result"]]],[11,"borrow_mut","","",71,[[["self"]],["t"]]],[11,"get_type_id","","",71,[[["self"]],["typeid"]]],[11,"not_found","","",71,[[["str"],["str"]],["e"]]],[11,"from_ok","","",71,[[["t"]],["t"]]],[11,"map_same","","",71,[[["self"],["f"]],["t"]]],[11,"to_owned","","",72,[[["self"]],["t"]]],[11,"clone_into","","",72,N],[11,"from","","",72,[[["t"]],["t"]]],[11,"into","","",72,[[["self"]],["u"]]],[11,"try_from","","",72,[[["u"]],["result"]]],[11,"borrow","","",72,[[["self"]],["t"]]],[11,"try_into","","",72,[[["self"]],["result"]]],[11,"borrow_mut","","",72,[[["self"]],["t"]]],[11,"get_type_id","","",72,[[["self"]],["typeid"]]],[11,"not_found","","",72,[[["str"],["str"]],["e"]]],[11,"from_ok","","",72,[[["t"]],["t"]]],[11,"map_same","","",72,[[["self"],["f"]],["t"]]],[11,"new","","",73,[[],["searchpaths"]]],[11,"add_path","","",73,N],[11,"iter","","",73,[[["self"],["pathkind"]],["iter"]]],[11,"to_owned","","",73,[[["self"]],["t"]]],[11,"clone_into","","",73,N],[11,"from","","",73,[[["t"]],["t"]]],[11,"into","","",73,[[["self"]],["u"]]],[11,"try_from","","",73,[[["u"]],["result"]]],[11,"borrow","","",73,[[["self"]],["t"]]],[11,"try_into","","",73,[[["self"]],["result"]]],[11,"borrow_mut","","",73,[[["self"]],["t"]]],[11,"get_type_id","","",73,[[["self"]],["typeid"]]],[11,"not_found","","",73,[[["str"],["str"]],["e"]]],[11,"from_ok","","",73,[[["t"]],["t"]]],[11,"map_same","","",73,[[["self"],["f"]],["t"]]],[11,"from","","",74,[[["t"]],["t"]]],[11,"into","","",74,[[["self"]],["u"]]],[11,"try_from","","",74,[[["u"]],["result"]]],[11,"borrow","","",74,[[["self"]],["t"]]],[11,"try_into","","",74,[[["self"]],["result"]]],[11,"borrow_mut","","",74,[[["self"]],["t"]]],[11,"get_type_id","","",74,[[["self"]],["typeid"]]],[11,"not_found","","",74,[[["str"],["str"]],["e"]]],[11,"from_ok","","",74,[[["t"]],["t"]]],[11,"map_same","","",74,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::doctree","",76,[[["t"]],["t"]]],[11,"into","","",76,[[["self"]],["u"]]],[11,"try_from","","",76,[[["u"]],["result"]]],[11,"borrow","","",76,[[["self"]],["t"]]],[11,"try_into","","",76,[[["self"]],["result"]]],[11,"borrow_mut","","",76,[[["self"]],["t"]]],[11,"get_type_id","","",76,[[["self"]],["typeid"]]],[11,"not_found","","",76,[[["str"],["str"]],["e"]]],[11,"from_ok","","",76,[[["t"]],["t"]]],[11,"map_same","","",76,[[["self"],["f"]],["t"]]],[11,"from","","",77,[[["t"]],["t"]]],[11,"into","","",77,[[["self"]],["u"]]],[11,"try_from","","",77,[[["u"]],["result"]]],[11,"borrow","","",77,[[["self"]],["t"]]],[11,"try_into","","",77,[[["self"]],["result"]]],[11,"borrow_mut","","",77,[[["self"]],["t"]]],[11,"get_type_id","","",77,[[["self"]],["typeid"]]],[11,"not_found","","",77,[[["str"],["str"]],["e"]]],[11,"from_ok","","",77,[[["t"]],["t"]]],[11,"map_same","","",77,[[["self"],["f"]],["t"]]],[11,"from","","",78,[[["t"]],["t"]]],[11,"into","","",78,[[["self"]],["u"]]],[11,"try_from","","",78,[[["u"]],["result"]]],[11,"borrow","","",78,[[["self"]],["t"]]],[11,"try_into","","",78,[[["self"]],["result"]]],[11,"borrow_mut","","",78,[[["self"]],["t"]]],[11,"get_type_id","","",78,[[["self"]],["typeid"]]],[11,"not_found","","",78,[[["str"],["str"]],["e"]]],[11,"from_ok","","",78,[[["t"]],["t"]]],[11,"map_same","","",78,[[["self"],["f"]],["t"]]],[11,"from","","",79,[[["t"]],["t"]]],[11,"into","","",79,[[["self"]],["u"]]],[11,"try_from","","",79,[[["u"]],["result"]]],[11,"borrow","","",79,[[["self"]],["t"]]],[11,"try_into","","",79,[[["self"]],["result"]]],[11,"borrow_mut","","",79,[[["self"]],["t"]]],[11,"get_type_id","","",79,[[["self"]],["typeid"]]],[11,"not_found","","",79,[[["str"],["str"]],["e"]]],[11,"from_ok","","",79,[[["t"]],["t"]]],[11,"map_same","","",79,[[["self"],["f"]],["t"]]],[11,"from","","",80,[[["t"]],["t"]]],[11,"into","","",80,[[["self"]],["u"]]],[11,"try_from","","",80,[[["u"]],["result"]]],[11,"borrow","","",80,[[["self"]],["t"]]],[11,"try_into","","",80,[[["self"]],["result"]]],[11,"borrow_mut","","",80,[[["self"]],["t"]]],[11,"get_type_id","","",80,[[["self"]],["typeid"]]],[11,"not_found","","",80,[[["str"],["str"]],["e"]]],[11,"from_ok","","",80,[[["t"]],["t"]]],[11,"map_same","","",80,[[["self"],["f"]],["t"]]],[11,"from","","",81,[[["t"]],["t"]]],[11,"into","","",81,[[["self"]],["u"]]],[11,"try_from","","",81,[[["u"]],["result"]]],[11,"borrow","","",81,[[["self"]],["t"]]],[11,"try_into","","",81,[[["self"]],["result"]]],[11,"borrow_mut","","",81,[[["self"]],["t"]]],[11,"get_type_id","","",81,[[["self"]],["typeid"]]],[11,"not_found","","",81,[[["str"],["str"]],["e"]]],[11,"from_ok","","",81,[[["t"]],["t"]]],[11,"map_same","","",81,[[["self"],["f"]],["t"]]],[11,"from","","",82,[[["t"]],["t"]]],[11,"into","","",82,[[["self"]],["u"]]],[11,"try_from","","",82,[[["u"]],["result"]]],[11,"borrow","","",82,[[["self"]],["t"]]],[11,"try_into","","",82,[[["self"]],["result"]]],[11,"borrow_mut","","",82,[[["self"]],["t"]]],[11,"get_type_id","","",82,[[["self"]],["typeid"]]],[11,"not_found","","",82,[[["str"],["str"]],["e"]]],[11,"from_ok","","",82,[[["t"]],["t"]]],[11,"map_same","","",82,[[["self"],["f"]],["t"]]],[11,"from","","",83,[[["t"]],["t"]]],[11,"into","","",83,[[["self"]],["u"]]],[11,"try_from","","",83,[[["u"]],["result"]]],[11,"borrow","","",83,[[["self"]],["t"]]],[11,"try_into","","",83,[[["self"]],["result"]]],[11,"borrow_mut","","",83,[[["self"]],["t"]]],[11,"get_type_id","","",83,[[["self"]],["typeid"]]],[11,"not_found","","",83,[[["str"],["str"]],["e"]]],[11,"from_ok","","",83,[[["t"]],["t"]]],[11,"map_same","","",83,[[["self"],["f"]],["t"]]],[11,"from","","",84,[[["t"]],["t"]]],[11,"into","","",84,[[["self"]],["u"]]],[11,"try_from","","",84,[[["u"]],["result"]]],[11,"borrow","","",84,[[["self"]],["t"]]],[11,"try_into","","",84,[[["self"]],["result"]]],[11,"borrow_mut","","",84,[[["self"]],["t"]]],[11,"get_type_id","","",84,[[["self"]],["typeid"]]],[11,"not_found","","",84,[[["str"],["str"]],["e"]]],[11,"from_ok","","",84,[[["t"]],["t"]]],[11,"map_same","","",84,[[["self"],["f"]],["t"]]],[11,"from","","",85,[[["t"]],["t"]]],[11,"into","","",85,[[["self"]],["u"]]],[11,"try_from","","",85,[[["u"]],["result"]]],[11,"borrow","","",85,[[["self"]],["t"]]],[11,"try_into","","",85,[[["self"]],["result"]]],[11,"borrow_mut","","",85,[[["self"]],["t"]]],[11,"get_type_id","","",85,[[["self"]],["typeid"]]],[11,"not_found","","",85,[[["str"],["str"]],["e"]]],[11,"from_ok","","",85,[[["t"]],["t"]]],[11,"map_same","","",85,[[["self"],["f"]],["t"]]],[11,"from","","",86,[[["t"]],["t"]]],[11,"into","","",86,[[["self"]],["u"]]],[11,"try_from","","",86,[[["u"]],["result"]]],[11,"borrow","","",86,[[["self"]],["t"]]],[11,"try_into","","",86,[[["self"]],["result"]]],[11,"borrow_mut","","",86,[[["self"]],["t"]]],[11,"get_type_id","","",86,[[["self"]],["typeid"]]],[11,"not_found","","",86,[[["str"],["str"]],["e"]]],[11,"from_ok","","",86,[[["t"]],["t"]]],[11,"map_same","","",86,[[["self"],["f"]],["t"]]],[11,"from","","",87,[[["t"]],["t"]]],[11,"into","","",87,[[["self"]],["u"]]],[11,"try_from","","",87,[[["u"]],["result"]]],[11,"borrow","","",87,[[["self"]],["t"]]],[11,"try_into","","",87,[[["self"]],["result"]]],[11,"borrow_mut","","",87,[[["self"]],["t"]]],[11,"get_type_id","","",87,[[["self"]],["typeid"]]],[11,"not_found","","",87,[[["str"],["str"]],["e"]]],[11,"from_ok","","",87,[[["t"]],["t"]]],[11,"map_same","","",87,[[["self"],["f"]],["t"]]],[11,"from","","",88,[[["t"]],["t"]]],[11,"into","","",88,[[["self"]],["u"]]],[11,"try_from","","",88,[[["u"]],["result"]]],[11,"borrow","","",88,[[["self"]],["t"]]],[11,"try_into","","",88,[[["self"]],["result"]]],[11,"borrow_mut","","",88,[[["self"]],["t"]]],[11,"get_type_id","","",88,[[["self"]],["typeid"]]],[11,"not_found","","",88,[[["str"],["str"]],["e"]]],[11,"from_ok","","",88,[[["t"]],["t"]]],[11,"map_same","","",88,[[["self"],["f"]],["t"]]],[11,"from","","",89,[[["t"]],["t"]]],[11,"into","","",89,[[["self"]],["u"]]],[11,"try_from","","",89,[[["u"]],["result"]]],[11,"borrow","","",89,[[["self"]],["t"]]],[11,"try_into","","",89,[[["self"]],["result"]]],[11,"borrow_mut","","",89,[[["self"]],["t"]]],[11,"get_type_id","","",89,[[["self"]],["typeid"]]],[11,"not_found","","",89,[[["str"],["str"]],["e"]]],[11,"from_ok","","",89,[[["t"]],["t"]]],[11,"map_same","","",89,[[["self"],["f"]],["t"]]],[11,"from","","",90,[[["t"]],["t"]]],[11,"into","","",90,[[["self"]],["u"]]],[11,"try_from","","",90,[[["u"]],["result"]]],[11,"borrow","","",90,[[["self"]],["t"]]],[11,"try_into","","",90,[[["self"]],["result"]]],[11,"borrow_mut","","",90,[[["self"]],["t"]]],[11,"get_type_id","","",90,[[["self"]],["typeid"]]],[11,"not_found","","",90,[[["str"],["str"]],["e"]]],[11,"from_ok","","",90,[[["t"]],["t"]]],[11,"map_same","","",90,[[["self"],["f"]],["t"]]],[11,"to_owned","","",91,[[["self"]],["t"]]],[11,"clone_into","","",91,N],[11,"from","","",91,[[["t"]],["t"]]],[11,"into","","",91,[[["self"]],["u"]]],[11,"try_from","","",91,[[["u"]],["result"]]],[11,"borrow","","",91,[[["self"]],["t"]]],[11,"try_into","","",91,[[["self"]],["result"]]],[11,"borrow_mut","","",91,[[["self"]],["t"]]],[11,"get_type_id","","",91,[[["self"]],["typeid"]]],[11,"encode","","",91,[[["self"],["e"]],["result"]]],[11,"decode","","",91,[[["d"]],["result"]]],[11,"not_found","","",91,[[["str"],["str"]],["e"]]],[11,"from_ok","","",91,[[["t"]],["t"]]],[11,"map_same","","",91,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::fold","",92,[[["t"]],["t"]]],[11,"into","","",92,[[["self"]],["u"]]],[11,"try_from","","",92,[[["u"]],["result"]]],[11,"borrow","","",92,[[["self"]],["t"]]],[11,"try_into","","",92,[[["self"]],["result"]]],[11,"borrow_mut","","",92,[[["self"]],["t"]]],[11,"get_type_id","","",92,[[["self"]],["typeid"]]],[11,"not_found","","",92,[[["str"],["str"]],["e"]]],[11,"from_ok","","",92,[[["t"]],["t"]]],[11,"map_same","","",92,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::html::highlight","",94,[[["t"]],["t"]]],[11,"into","","",94,[[["self"]],["u"]]],[11,"try_from","","",94,[[["u"]],["result"]]],[11,"borrow","","",94,[[["self"]],["t"]]],[11,"try_into","","",94,[[["self"]],["result"]]],[11,"borrow_mut","","",94,[[["self"]],["t"]]],[11,"get_type_id","","",94,[[["self"]],["typeid"]]],[11,"not_found","","",94,[[["str"],["str"]],["e"]]],[11,"from_ok","","",94,[[["t"]],["t"]]],[11,"map_same","","",94,[[["self"],["f"]],["t"]]],[11,"to_owned","","",95,[[["self"]],["t"]]],[11,"clone_into","","",95,N],[11,"from","","",95,[[["t"]],["t"]]],[11,"into","","",95,[[["self"]],["u"]]],[11,"try_from","","",95,[[["u"]],["result"]]],[11,"borrow","","",95,[[["self"]],["t"]]],[11,"try_into","","",95,[[["self"]],["result"]]],[11,"borrow_mut","","",95,[[["self"]],["t"]]],[11,"get_type_id","","",95,[[["self"]],["typeid"]]],[11,"not_found","","",95,[[["str"],["str"]],["e"]]],[11,"from_ok","","",95,[[["t"]],["t"]]],[11,"map_same","","",95,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::html::escape","",97,[[["t"]],["t"]]],[11,"to_string","","",97,[[["self"]],["string"]]],[11,"into","","",97,[[["self"]],["u"]]],[11,"try_from","","",97,[[["u"]],["result"]]],[11,"borrow","","",97,[[["self"]],["t"]]],[11,"try_into","","",97,[[["self"]],["result"]]],[11,"borrow_mut","","",97,[[["self"]],["t"]]],[11,"get_type_id","","",97,[[["self"]],["typeid"]]],[11,"not_found","","",97,[[["str"],["str"]],["e"]]],[11,"from_ok","","",97,[[["t"]],["t"]]],[11,"map_same","","",97,[[["self"],["f"]],["t"]]],[11,"to_owned","rustdoc::html::item_type","",98,[[["self"]],["t"]]],[11,"clone_into","","",98,N],[11,"from","","",98,[[["t"]],["t"]]],[11,"to_string","","",98,[[["self"]],["string"]]],[11,"into","","",98,[[["self"]],["u"]]],[11,"try_from","","",98,[[["u"]],["result"]]],[11,"borrow","","",98,[[["self"]],["t"]]],[11,"try_into","","",98,[[["self"]],["result"]]],[11,"borrow_mut","","",98,[[["self"]],["t"]]],[11,"get_type_id","","",98,[[["self"]],["typeid"]]],[11,"not_found","","",98,[[["str"],["str"]],["e"]]],[11,"from_ok","","",98,[[["t"]],["t"]]],[11,"map_same","","",98,[[["self"],["f"]],["t"]]],[11,"to_owned","","",99,[[["self"]],["t"]]],[11,"clone_into","","",99,N],[11,"from","","",99,[[["t"]],["t"]]],[11,"to_string","","",99,[[["self"]],["string"]]],[11,"into","","",99,[[["self"]],["u"]]],[11,"try_from","","",99,[[["u"]],["result"]]],[11,"borrow","","",99,[[["self"]],["t"]]],[11,"try_into","","",99,[[["self"]],["result"]]],[11,"borrow_mut","","",99,[[["self"]],["t"]]],[11,"get_type_id","","",99,[[["self"]],["typeid"]]],[11,"not_found","","",99,[[["str"],["str"]],["e"]]],[11,"from_ok","","",99,[[["t"]],["t"]]],[11,"map_same","","",99,[[["self"],["f"]],["t"]]],[11,"to_owned","rustdoc::html::format","",100,[[["self"]],["t"]]],[11,"clone_into","","",100,N],[11,"from","","",100,[[["t"]],["t"]]],[11,"to_string","","",100,[[["self"]],["string"]]],[11,"into","","",100,[[["self"]],["u"]]],[11,"try_from","","",100,[[["u"]],["result"]]],[11,"borrow","","",100,[[["self"]],["t"]]],[11,"try_into","","",100,[[["self"]],["result"]]],[11,"borrow_mut","","",100,[[["self"]],["t"]]],[11,"get_type_id","","",100,[[["self"]],["typeid"]]],[11,"not_found","","",100,[[["str"],["str"]],["e"]]],[11,"from_ok","","",100,[[["t"]],["t"]]],[11,"map_same","","",100,[[["self"],["f"]],["t"]]],[11,"to_owned","","",101,[[["self"]],["t"]]],[11,"clone_into","","",101,N],[11,"from","","",101,[[["t"]],["t"]]],[11,"to_string","","",101,[[["self"]],["string"]]],[11,"into","","",101,[[["self"]],["u"]]],[11,"try_from","","",101,[[["u"]],["result"]]],[11,"borrow","","",101,[[["self"]],["t"]]],[11,"try_into","","",101,[[["self"]],["result"]]],[11,"borrow_mut","","",101,[[["self"]],["t"]]],[11,"get_type_id","","",101,[[["self"]],["typeid"]]],[11,"not_found","","",101,[[["str"],["str"]],["e"]]],[11,"from_ok","","",101,[[["t"]],["t"]]],[11,"map_same","","",101,[[["self"],["f"]],["t"]]],[11,"to_owned","","",102,[[["self"]],["t"]]],[11,"clone_into","","",102,N],[11,"from","","",102,[[["t"]],["t"]]],[11,"to_string","","",102,[[["self"]],["string"]]],[11,"into","","",102,[[["self"]],["u"]]],[11,"try_from","","",102,[[["u"]],["result"]]],[11,"borrow","","",102,[[["self"]],["t"]]],[11,"try_into","","",102,[[["self"]],["result"]]],[11,"borrow_mut","","",102,[[["self"]],["t"]]],[11,"get_type_id","","",102,[[["self"]],["typeid"]]],[11,"not_found","","",102,[[["str"],["str"]],["e"]]],[11,"from_ok","","",102,[[["t"]],["t"]]],[11,"map_same","","",102,[[["self"],["f"]],["t"]]],[11,"to_owned","","",103,[[["self"]],["t"]]],[11,"clone_into","","",103,N],[11,"from","","",103,[[["t"]],["t"]]],[11,"to_string","","",103,[[["self"]],["string"]]],[11,"into","","",103,[[["self"]],["u"]]],[11,"try_from","","",103,[[["u"]],["result"]]],[11,"borrow","","",103,[[["self"]],["t"]]],[11,"try_into","","",103,[[["self"]],["result"]]],[11,"borrow_mut","","",103,[[["self"]],["t"]]],[11,"get_type_id","","",103,[[["self"]],["typeid"]]],[11,"not_found","","",103,[[["str"],["str"]],["e"]]],[11,"from_ok","","",103,[[["t"]],["t"]]],[11,"map_same","","",103,[[["self"],["f"]],["t"]]],[11,"to_owned","","",104,[[["self"]],["t"]]],[11,"clone_into","","",104,N],[11,"from","","",104,[[["t"]],["t"]]],[11,"to_string","","",104,[[["self"]],["string"]]],[11,"into","","",104,[[["self"]],["u"]]],[11,"try_from","","",104,[[["u"]],["result"]]],[11,"borrow","","",104,[[["self"]],["t"]]],[11,"try_into","","",104,[[["self"]],["result"]]],[11,"borrow_mut","","",104,[[["self"]],["t"]]],[11,"get_type_id","","",104,[[["self"]],["typeid"]]],[11,"not_found","","",104,[[["str"],["str"]],["e"]]],[11,"from_ok","","",104,[[["t"]],["t"]]],[11,"map_same","","",104,[[["self"],["f"]],["t"]]],[11,"to_owned","","",105,[[["self"]],["t"]]],[11,"clone_into","","",105,N],[11,"from","","",105,[[["t"]],["t"]]],[11,"to_string","","",105,[[["self"]],["string"]]],[11,"into","","",105,[[["self"]],["u"]]],[11,"try_from","","",105,[[["u"]],["result"]]],[11,"borrow","","",105,[[["self"]],["t"]]],[11,"try_into","","",105,[[["self"]],["result"]]],[11,"borrow_mut","","",105,[[["self"]],["t"]]],[11,"get_type_id","","",105,[[["self"]],["typeid"]]],[11,"not_found","","",105,[[["str"],["str"]],["e"]]],[11,"from_ok","","",105,[[["t"]],["t"]]],[11,"map_same","","",105,[[["self"],["f"]],["t"]]],[11,"from","","",106,[[["t"]],["t"]]],[11,"to_string","","",106,[[["self"]],["string"]]],[11,"into","","",106,[[["self"]],["u"]]],[11,"try_from","","",106,[[["u"]],["result"]]],[11,"borrow","","",106,[[["self"]],["t"]]],[11,"try_into","","",106,[[["self"]],["result"]]],[11,"borrow_mut","","",106,[[["self"]],["t"]]],[11,"get_type_id","","",106,[[["self"]],["typeid"]]],[11,"not_found","","",106,[[["str"],["str"]],["e"]]],[11,"from_ok","","",106,[[["t"]],["t"]]],[11,"map_same","","",106,[[["self"],["f"]],["t"]]],[11,"from","","",107,[[["t"]],["t"]]],[11,"to_string","","",107,[[["self"]],["string"]]],[11,"into","","",107,[[["self"]],["u"]]],[11,"try_from","","",107,[[["u"]],["result"]]],[11,"borrow","","",107,[[["self"]],["t"]]],[11,"try_into","","",107,[[["self"]],["result"]]],[11,"borrow_mut","","",107,[[["self"]],["t"]]],[11,"get_type_id","","",107,[[["self"]],["typeid"]]],[11,"not_found","","",107,[[["str"],["str"]],["e"]]],[11,"from_ok","","",107,[[["t"]],["t"]]],[11,"map_same","","",107,[[["self"],["f"]],["t"]]],[11,"from","","",108,[[["t"]],["t"]]],[11,"to_string","","",108,[[["self"]],["string"]]],[11,"into","","",108,[[["self"]],["u"]]],[11,"try_from","","",108,[[["u"]],["result"]]],[11,"borrow","","",108,[[["self"]],["t"]]],[11,"try_into","","",108,[[["self"]],["result"]]],[11,"borrow_mut","","",108,[[["self"]],["t"]]],[11,"get_type_id","","",108,[[["self"]],["typeid"]]],[11,"not_found","","",108,[[["str"],["str"]],["e"]]],[11,"from_ok","","",108,[[["t"]],["t"]]],[11,"map_same","","",108,[[["self"],["f"]],["t"]]],[11,"from","","",109,[[["t"]],["t"]]],[11,"to_string","","",109,[[["self"]],["string"]]],[11,"into","","",109,[[["self"]],["u"]]],[11,"try_from","","",109,[[["u"]],["result"]]],[11,"borrow","","",109,[[["self"]],["t"]]],[11,"try_into","","",109,[[["self"]],["result"]]],[11,"borrow_mut","","",109,[[["self"]],["t"]]],[11,"get_type_id","","",109,[[["self"]],["typeid"]]],[11,"not_found","","",109,[[["str"],["str"]],["e"]]],[11,"from_ok","","",109,[[["t"]],["t"]]],[11,"map_same","","",109,[[["self"],["f"]],["t"]]],[11,"from","","",110,[[["t"]],["t"]]],[11,"to_string","","",110,[[["self"]],["string"]]],[11,"into","","",110,[[["self"]],["u"]]],[11,"try_from","","",110,[[["u"]],["result"]]],[11,"borrow","","",110,[[["self"]],["t"]]],[11,"try_into","","",110,[[["self"]],["result"]]],[11,"borrow_mut","","",110,[[["self"]],["t"]]],[11,"get_type_id","","",110,[[["self"]],["typeid"]]],[11,"not_found","","",110,[[["str"],["str"]],["e"]]],[11,"from_ok","","",110,[[["t"]],["t"]]],[11,"map_same","","",110,[[["self"],["f"]],["t"]]],[11,"from","","",111,[[["t"]],["t"]]],[11,"to_string","","",111,[[["self"]],["string"]]],[11,"into","","",111,[[["self"]],["u"]]],[11,"try_from","","",111,[[["u"]],["result"]]],[11,"borrow","","",111,[[["self"]],["t"]]],[11,"try_into","","",111,[[["self"]],["result"]]],[11,"borrow_mut","","",111,[[["self"]],["t"]]],[11,"get_type_id","","",111,[[["self"]],["typeid"]]],[11,"not_found","","",111,[[["str"],["str"]],["e"]]],[11,"from_ok","","",111,[[["t"]],["t"]]],[11,"map_same","","",111,[[["self"],["f"]],["t"]]],[11,"to_owned","rustdoc::html::layout","",112,[[["self"]],["t"]]],[11,"clone_into","","",112,N],[11,"from","","",112,[[["t"]],["t"]]],[11,"into","","",112,[[["self"]],["u"]]],[11,"try_from","","",112,[[["u"]],["result"]]],[11,"borrow","","",112,[[["self"]],["t"]]],[11,"try_into","","",112,[[["self"]],["result"]]],[11,"borrow_mut","","",112,[[["self"]],["t"]]],[11,"get_type_id","","",112,[[["self"]],["typeid"]]],[11,"not_found","","",112,[[["str"],["str"]],["e"]]],[11,"from_ok","","",112,[[["t"]],["t"]]],[11,"map_same","","",112,[[["self"],["f"]],["t"]]],[11,"from","","",113,[[["t"]],["t"]]],[11,"into","","",113,[[["self"]],["u"]]],[11,"try_from","","",113,[[["u"]],["result"]]],[11,"borrow","","",113,[[["self"]],["t"]]],[11,"try_into","","",113,[[["self"]],["result"]]],[11,"borrow_mut","","",113,[[["self"]],["t"]]],[11,"get_type_id","","",113,[[["self"]],["typeid"]]],[11,"not_found","","",113,[[["str"],["str"]],["e"]]],[11,"from_ok","","",113,[[["t"]],["t"]]],[11,"map_same","","",113,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::html::markdown","",114,[[["t"]],["t"]]],[11,"to_string","","",114,[[["self"]],["string"]]],[11,"into","","",114,[[["self"]],["u"]]],[11,"try_from","","",114,[[["u"]],["result"]]],[11,"borrow","","",114,[[["self"]],["t"]]],[11,"try_into","","",114,[[["self"]],["result"]]],[11,"borrow_mut","","",114,[[["self"]],["t"]]],[11,"get_type_id","","",114,[[["self"]],["typeid"]]],[11,"not_found","","",114,[[["str"],["str"]],["e"]]],[11,"from_ok","","",114,[[["t"]],["t"]]],[11,"map_same","","",114,[[["self"],["f"]],["t"]]],[11,"from","","",115,[[["t"]],["t"]]],[11,"to_string","","",115,[[["self"]],["string"]]],[11,"into","","",115,[[["self"]],["u"]]],[11,"try_from","","",115,[[["u"]],["result"]]],[11,"borrow","","",115,[[["self"]],["t"]]],[11,"try_into","","",115,[[["self"]],["result"]]],[11,"borrow_mut","","",115,[[["self"]],["t"]]],[11,"get_type_id","","",115,[[["self"]],["typeid"]]],[11,"not_found","","",115,[[["str"],["str"]],["e"]]],[11,"from_ok","","",115,[[["t"]],["t"]]],[11,"map_same","","",115,[[["self"],["f"]],["t"]]],[11,"from","","",116,[[["t"]],["t"]]],[11,"to_string","","",116,[[["self"]],["string"]]],[11,"into","","",116,[[["self"]],["u"]]],[11,"try_from","","",116,[[["u"]],["result"]]],[11,"borrow","","",116,[[["self"]],["t"]]],[11,"try_into","","",116,[[["self"]],["result"]]],[11,"borrow_mut","","",116,[[["self"]],["t"]]],[11,"get_type_id","","",116,[[["self"]],["typeid"]]],[11,"not_found","","",116,[[["str"],["str"]],["e"]]],[11,"from_ok","","",116,[[["t"]],["t"]]],[11,"map_same","","",116,[[["self"],["f"]],["t"]]],[11,"from","","",117,[[["t"]],["t"]]],[11,"to_string","","",117,[[["self"]],["string"]]],[11,"into","","",117,[[["self"]],["u"]]],[11,"try_from","","",117,[[["u"]],["result"]]],[11,"borrow","","",117,[[["self"]],["t"]]],[11,"try_into","","",117,[[["self"]],["result"]]],[11,"borrow_mut","","",117,[[["self"]],["t"]]],[11,"get_type_id","","",117,[[["self"]],["typeid"]]],[11,"not_found","","",117,[[["str"],["str"]],["e"]]],[11,"from_ok","","",117,[[["t"]],["t"]]],[11,"map_same","","",117,[[["self"],["f"]],["t"]]],[11,"from","","",118,[[["t"]],["t"]]],[11,"into_iter","","",118,[[["self"]],["i"]]],[11,"into","","",118,[[["self"]],["u"]]],[11,"try_from","","",118,[[["u"]],["result"]]],[11,"borrow","","",118,[[["self"]],["t"]]],[11,"try_into","","",118,[[["self"]],["result"]]],[11,"borrow_mut","","",118,[[["self"]],["t"]]],[11,"get_type_id","","",118,[[["self"]],["typeid"]]],[11,"not_found","","",118,[[["str"],["str"]],["e"]]],[11,"from_ok","","",118,[[["t"]],["t"]]],[11,"map_same","","",118,[[["self"],["f"]],["t"]]],[11,"from","","",119,[[["t"]],["t"]]],[11,"into_iter","","",119,[[["self"]],["i"]]],[11,"into","","",119,[[["self"]],["u"]]],[11,"try_from","","",119,[[["u"]],["result"]]],[11,"borrow","","",119,[[["self"]],["t"]]],[11,"try_into","","",119,[[["self"]],["result"]]],[11,"borrow_mut","","",119,[[["self"]],["t"]]],[11,"get_type_id","","",119,[[["self"]],["typeid"]]],[11,"not_found","","",119,[[["str"],["str"]],["e"]]],[11,"from_ok","","",119,[[["t"]],["t"]]],[11,"map_same","","",119,[[["self"],["f"]],["t"]]],[11,"from","","",120,[[["t"]],["t"]]],[11,"into_iter","","",120,[[["self"]],["i"]]],[11,"into","","",120,[[["self"]],["u"]]],[11,"try_from","","",120,[[["u"]],["result"]]],[11,"borrow","","",120,[[["self"]],["t"]]],[11,"try_into","","",120,[[["self"]],["result"]]],[11,"borrow_mut","","",120,[[["self"]],["t"]]],[11,"get_type_id","","",120,[[["self"]],["typeid"]]],[11,"not_found","","",120,[[["str"],["str"]],["e"]]],[11,"from_ok","","",120,[[["t"]],["t"]]],[11,"map_same","","",120,[[["self"],["f"]],["t"]]],[11,"from","","",121,[[["t"]],["t"]]],[11,"into_iter","","",121,[[["self"]],["i"]]],[11,"into","","",121,[[["self"]],["u"]]],[11,"try_from","","",121,[[["u"]],["result"]]],[11,"borrow","","",121,[[["self"]],["t"]]],[11,"try_into","","",121,[[["self"]],["result"]]],[11,"borrow_mut","","",121,[[["self"]],["t"]]],[11,"get_type_id","","",121,[[["self"]],["typeid"]]],[11,"not_found","","",121,[[["str"],["str"]],["e"]]],[11,"from_ok","","",121,[[["t"]],["t"]]],[11,"map_same","","",121,[[["self"],["f"]],["t"]]],[11,"from","","",122,[[["t"]],["t"]]],[11,"into_iter","","",122,[[["self"]],["i"]]],[11,"into","","",122,[[["self"]],["u"]]],[11,"try_from","","",122,[[["u"]],["result"]]],[11,"borrow","","",122,[[["self"]],["t"]]],[11,"try_into","","",122,[[["self"]],["result"]]],[11,"borrow_mut","","",122,[[["self"]],["t"]]],[11,"get_type_id","","",122,[[["self"]],["typeid"]]],[11,"not_found","","",122,[[["str"],["str"]],["e"]]],[11,"from_ok","","",122,[[["t"]],["t"]]],[11,"map_same","","",122,[[["self"],["f"]],["t"]]],[11,"from","","",123,[[["t"]],["t"]]],[11,"to_string","","",123,[[["self"]],["string"]]],[11,"into","","",123,[[["self"]],["u"]]],[11,"try_from","","",123,[[["u"]],["result"]]],[11,"borrow","","",123,[[["self"]],["t"]]],[11,"try_into","","",123,[[["self"]],["result"]]],[11,"borrow_mut","","",123,[[["self"]],["t"]]],[11,"get_type_id","","",123,[[["self"]],["typeid"]]],[11,"not_found","","",123,[[["str"],["str"]],["e"]]],[11,"from_ok","","",123,[[["t"]],["t"]]],[11,"map_same","","",123,[[["self"],["f"]],["t"]]],[11,"to_owned","","",124,[[["self"]],["t"]]],[11,"clone_into","","",124,N],[11,"from","","",124,[[["t"]],["t"]]],[11,"into","","",124,[[["self"]],["u"]]],[11,"try_from","","",124,[[["u"]],["result"]]],[11,"borrow","","",124,[[["self"]],["t"]]],[11,"try_into","","",124,[[["self"]],["result"]]],[11,"borrow_mut","","",124,[[["self"]],["t"]]],[11,"get_type_id","","",124,[[["self"]],["typeid"]]],[11,"not_found","","",124,[[["str"],["str"]],["e"]]],[11,"from_ok","","",124,[[["t"]],["t"]]],[11,"map_same","","",124,[[["self"],["f"]],["t"]]],[11,"from","","",125,[[["t"]],["t"]]],[11,"into","","",125,[[["self"]],["u"]]],[11,"try_from","","",125,[[["u"]],["result"]]],[11,"borrow","","",125,[[["self"]],["t"]]],[11,"try_into","","",125,[[["self"]],["result"]]],[11,"borrow_mut","","",125,[[["self"]],["t"]]],[11,"get_type_id","","",125,[[["self"]],["typeid"]]],[11,"not_found","","",125,[[["str"],["str"]],["e"]]],[11,"from_ok","","",125,[[["t"]],["t"]]],[11,"map_same","","",125,[[["self"],["f"]],["t"]]],[11,"to_owned","","",126,[[["self"]],["t"]]],[11,"clone_into","","",126,N],[11,"from","","",126,[[["t"]],["t"]]],[11,"into","","",126,[[["self"]],["u"]]],[11,"try_from","","",126,[[["u"]],["result"]]],[11,"borrow","","",126,[[["self"]],["t"]]],[11,"try_into","","",126,[[["self"]],["result"]]],[11,"borrow_mut","","",126,[[["self"]],["t"]]],[11,"get_type_id","","",126,[[["self"]],["typeid"]]],[11,"not_found","","",126,[[["str"],["str"]],["e"]]],[11,"from_ok","","",126,[[["t"]],["t"]]],[11,"map_same","","",126,[[["self"],["f"]],["t"]]],[11,"from","","",127,[[["t"]],["t"]]],[11,"into","","",127,[[["self"]],["u"]]],[11,"try_from","","",127,[[["u"]],["result"]]],[11,"borrow","","",127,[[["self"]],["t"]]],[11,"try_into","","",127,[[["self"]],["result"]]],[11,"borrow_mut","","",127,[[["self"]],["t"]]],[11,"get_type_id","","",127,[[["self"]],["typeid"]]],[11,"not_found","","",127,[[["str"],["str"]],["e"]]],[11,"from_ok","","",127,[[["t"]],["t"]]],[11,"map_same","","",127,[[["self"],["f"]],["t"]]],[11,"to_owned","rustdoc::html::render","",128,[[["self"]],["t"]]],[11,"clone_into","","",128,N],[11,"from","","",128,[[["t"]],["t"]]],[11,"into","","",128,[[["self"]],["u"]]],[11,"try_from","","",128,[[["u"]],["result"]]],[11,"borrow","","",128,[[["self"]],["t"]]],[11,"try_into","","",128,[[["self"]],["result"]]],[11,"borrow_mut","","",128,[[["self"]],["t"]]],[11,"get_type_id","","",128,[[["self"]],["typeid"]]],[11,"not_found","","",128,[[["str"],["str"]],["e"]]],[11,"from_ok","","",128,[[["t"]],["t"]]],[11,"map_same","","",128,[[["self"],["f"]],["t"]]],[11,"from","","",129,[[["t"]],["t"]]],[11,"into","","",129,[[["self"]],["u"]]],[11,"try_from","","",129,[[["u"]],["result"]]],[11,"borrow","","",129,[[["self"]],["t"]]],[11,"try_into","","",129,[[["self"]],["result"]]],[11,"borrow_mut","","",129,[[["self"]],["t"]]],[11,"get_type_id","","",129,[[["self"]],["typeid"]]],[11,"not_found","","",129,[[["str"],["str"]],["e"]]],[11,"from_ok","","",129,[[["t"]],["t"]]],[11,"map_same","","",129,[[["self"],["f"]],["t"]]],[11,"to_owned","","",130,[[["self"]],["t"]]],[11,"clone_into","","",130,N],[11,"from","","",130,[[["t"]],["t"]]],[11,"into","","",130,[[["self"]],["u"]]],[11,"try_from","","",130,[[["u"]],["result"]]],[11,"borrow","","",130,[[["self"]],["t"]]],[11,"try_into","","",130,[[["self"]],["result"]]],[11,"borrow_mut","","",130,[[["self"]],["t"]]],[11,"get_type_id","","",130,[[["self"]],["typeid"]]],[11,"not_found","","",130,[[["str"],["str"]],["e"]]],[11,"from_ok","","",130,[[["t"]],["t"]]],[11,"map_same","","",130,[[["self"],["f"]],["t"]]],[11,"from","","",131,[[["t"]],["t"]]],[11,"to_string","","",131,[[["self"]],["string"]]],[11,"into","","",131,[[["self"]],["u"]]],[11,"try_from","","",131,[[["u"]],["result"]]],[11,"borrow","","",131,[[["self"]],["t"]]],[11,"try_into","","",131,[[["self"]],["result"]]],[11,"borrow_mut","","",131,[[["self"]],["t"]]],[11,"get_type_id","","",131,[[["self"]],["typeid"]]],[11,"not_found","","",131,[[["str"],["str"]],["e"]]],[11,"from_ok","","",131,[[["t"]],["t"]]],[11,"map_same","","",131,[[["self"],["f"]],["t"]]],[11,"from","","",132,[[["t"]],["t"]]],[11,"into","","",132,[[["self"]],["u"]]],[11,"try_from","","",132,[[["u"]],["result"]]],[11,"borrow","","",132,[[["self"]],["t"]]],[11,"try_into","","",132,[[["self"]],["result"]]],[11,"borrow_mut","","",132,[[["self"]],["t"]]],[11,"get_type_id","","",132,[[["self"]],["typeid"]]],[11,"not_found","","",132,[[["str"],["str"]],["e"]]],[11,"from_ok","","",132,[[["t"]],["t"]]],[11,"map_same","","",132,[[["self"],["f"]],["t"]]],[11,"from","","",133,[[["t"]],["t"]]],[11,"into","","",133,[[["self"]],["u"]]],[11,"try_from","","",133,[[["u"]],["result"]]],[11,"borrow","","",133,[[["self"]],["t"]]],[11,"try_into","","",133,[[["self"]],["result"]]],[11,"borrow_mut","","",133,[[["self"]],["t"]]],[11,"get_type_id","","",133,[[["self"]],["typeid"]]],[11,"not_found","","",133,[[["str"],["str"]],["e"]]],[11,"from_ok","","",133,[[["t"]],["t"]]],[11,"map_same","","",133,[[["self"],["f"]],["t"]]],[11,"from","","",134,[[["t"]],["t"]]],[11,"into","","",134,[[["self"]],["u"]]],[11,"try_from","","",134,[[["u"]],["result"]]],[11,"borrow","","",134,[[["self"]],["t"]]],[11,"try_into","","",134,[[["self"]],["result"]]],[11,"borrow_mut","","",134,[[["self"]],["t"]]],[11,"get_type_id","","",134,[[["self"]],["typeid"]]],[11,"not_found","","",134,[[["str"],["str"]],["e"]]],[11,"from_ok","","",134,[[["t"]],["t"]]],[11,"map_same","","",134,[[["self"],["f"]],["t"]]],[11,"from","","",135,[[["t"]],["t"]]],[11,"to_string","","",135,[[["self"]],["string"]]],[11,"into","","",135,[[["self"]],["u"]]],[11,"try_from","","",135,[[["u"]],["result"]]],[11,"borrow","","",135,[[["self"]],["t"]]],[11,"try_into","","",135,[[["self"]],["result"]]],[11,"borrow_mut","","",135,[[["self"]],["t"]]],[11,"get_type_id","","",135,[[["self"]],["typeid"]]],[11,"not_found","","",135,[[["str"],["str"]],["e"]]],[11,"from_ok","","",135,[[["t"]],["t"]]],[11,"map_same","","",135,[[["self"],["f"]],["t"]]],[11,"to_owned","","",136,[[["self"]],["t"]]],[11,"clone_into","","",136,N],[11,"from","","",136,[[["t"]],["t"]]],[11,"to_string","","",136,[[["self"]],["string"]]],[11,"into","","",136,[[["self"]],["u"]]],[11,"try_from","","",136,[[["u"]],["result"]]],[11,"borrow","","",136,[[["self"]],["t"]]],[11,"try_into","","",136,[[["self"]],["result"]]],[11,"borrow_mut","","",136,[[["self"]],["t"]]],[11,"get_type_id","","",136,[[["self"]],["typeid"]]],[11,"not_found","","",136,[[["str"],["str"]],["e"]]],[11,"from_ok","","",136,[[["t"]],["t"]]],[11,"map_same","","",136,[[["self"],["f"]],["t"]]],[11,"from","","",137,[[["t"]],["t"]]],[11,"to_string","","",137,[[["self"]],["string"]]],[11,"into","","",137,[[["self"]],["u"]]],[11,"try_from","","",137,[[["u"]],["result"]]],[11,"borrow","","",137,[[["self"]],["t"]]],[11,"try_into","","",137,[[["self"]],["result"]]],[11,"borrow_mut","","",137,[[["self"]],["t"]]],[11,"get_type_id","","",137,[[["self"]],["typeid"]]],[11,"not_found","","",137,[[["str"],["str"]],["e"]]],[11,"from_ok","","",137,[[["t"]],["t"]]],[11,"map_same","","",137,[[["self"],["f"]],["t"]]],[11,"from","","",138,[[["t"]],["t"]]],[11,"into","","",138,[[["self"]],["u"]]],[11,"try_from","","",138,[[["u"]],["result"]]],[11,"borrow","","",138,[[["self"]],["t"]]],[11,"try_into","","",138,[[["self"]],["result"]]],[11,"borrow_mut","","",138,[[["self"]],["t"]]],[11,"get_type_id","","",138,[[["self"]],["typeid"]]],[11,"not_found","","",138,[[["str"],["str"]],["e"]]],[11,"from_ok","","",138,[[["t"]],["t"]]],[11,"map_same","","",138,[[["self"],["f"]],["t"]]],[11,"from","","",139,[[["t"]],["t"]]],[11,"into","","",139,[[["self"]],["u"]]],[11,"try_from","","",139,[[["u"]],["result"]]],[11,"borrow","","",139,[[["self"]],["t"]]],[11,"try_into","","",139,[[["self"]],["result"]]],[11,"borrow_mut","","",139,[[["self"]],["t"]]],[11,"get_type_id","","",139,[[["self"]],["typeid"]]],[11,"not_found","","",139,[[["str"],["str"]],["e"]]],[11,"from_ok","","",139,[[["t"]],["t"]]],[11,"map_same","","",139,[[["self"],["f"]],["t"]]],[11,"from","","",140,[[["t"]],["t"]]],[11,"into","","",140,[[["self"]],["u"]]],[11,"try_from","","",140,[[["u"]],["result"]]],[11,"borrow","","",140,[[["self"]],["t"]]],[11,"try_into","","",140,[[["self"]],["result"]]],[11,"borrow_mut","","",140,[[["self"]],["t"]]],[11,"get_type_id","","",140,[[["self"]],["typeid"]]],[11,"not_found","","",140,[[["str"],["str"]],["e"]]],[11,"from_ok","","",140,[[["t"]],["t"]]],[11,"map_same","","",140,[[["self"],["f"]],["t"]]],[11,"from","","",141,[[["t"]],["t"]]],[11,"to_string","","",141,[[["self"]],["string"]]],[11,"into","","",141,[[["self"]],["u"]]],[11,"try_from","","",141,[[["u"]],["result"]]],[11,"borrow","","",141,[[["self"]],["t"]]],[11,"try_into","","",141,[[["self"]],["result"]]],[11,"borrow_mut","","",141,[[["self"]],["t"]]],[11,"get_type_id","","",141,[[["self"]],["typeid"]]],[11,"not_found","","",141,[[["str"],["str"]],["e"]]],[11,"from_ok","","",141,[[["t"]],["t"]]],[11,"map_same","","",141,[[["self"],["f"]],["t"]]],[11,"from","","",142,[[["t"]],["t"]]],[11,"to_string","","",142,[[["self"]],["string"]]],[11,"into","","",142,[[["self"]],["u"]]],[11,"try_from","","",142,[[["u"]],["result"]]],[11,"borrow","","",142,[[["self"]],["t"]]],[11,"try_into","","",142,[[["self"]],["result"]]],[11,"borrow_mut","","",142,[[["self"]],["t"]]],[11,"get_type_id","","",142,[[["self"]],["typeid"]]],[11,"not_found","","",142,[[["str"],["str"]],["e"]]],[11,"from_ok","","",142,[[["t"]],["t"]]],[11,"map_same","","",142,[[["self"],["f"]],["t"]]],[11,"from","","",143,[[["t"]],["t"]]],[11,"to_string","","",143,[[["self"]],["string"]]],[11,"into","","",143,[[["self"]],["u"]]],[11,"try_from","","",143,[[["u"]],["result"]]],[11,"borrow","","",143,[[["self"]],["t"]]],[11,"try_into","","",143,[[["self"]],["result"]]],[11,"borrow_mut","","",143,[[["self"]],["t"]]],[11,"get_type_id","","",143,[[["self"]],["typeid"]]],[11,"not_found","","",143,[[["str"],["str"]],["e"]]],[11,"from_ok","","",143,[[["t"]],["t"]]],[11,"map_same","","",143,[[["self"],["f"]],["t"]]],[11,"from","","",144,[[["t"]],["t"]]],[11,"into","","",144,[[["self"]],["u"]]],[11,"try_from","","",144,[[["u"]],["result"]]],[11,"borrow","","",144,[[["self"]],["t"]]],[11,"try_into","","",144,[[["self"]],["result"]]],[11,"borrow_mut","","",144,[[["self"]],["t"]]],[11,"get_type_id","","",144,[[["self"]],["typeid"]]],[11,"not_found","","",144,[[["str"],["str"]],["e"]]],[11,"from_ok","","",144,[[["t"]],["t"]]],[11,"map_same","","",144,[[["self"],["f"]],["t"]]],[11,"to_owned","","",145,[[["self"]],["t"]]],[11,"clone_into","","",145,N],[11,"from","","",145,[[["t"]],["t"]]],[11,"into","","",145,[[["self"]],["u"]]],[11,"try_from","","",145,[[["u"]],["result"]]],[11,"borrow","","",145,[[["self"]],["t"]]],[11,"try_into","","",145,[[["self"]],["result"]]],[11,"borrow_mut","","",145,[[["self"]],["t"]]],[11,"get_type_id","","",145,[[["self"]],["typeid"]]],[11,"not_found","","",145,[[["str"],["str"]],["e"]]],[11,"from_ok","","",145,[[["t"]],["t"]]],[11,"map_same","","",145,[[["self"],["f"]],["t"]]],[11,"from","","",146,[[["t"]],["t"]]],[11,"into","","",146,[[["self"]],["u"]]],[11,"try_from","","",146,[[["u"]],["result"]]],[11,"borrow","","",146,[[["self"]],["t"]]],[11,"try_into","","",146,[[["self"]],["result"]]],[11,"borrow_mut","","",146,[[["self"]],["t"]]],[11,"get_type_id","","",146,[[["self"]],["typeid"]]],[11,"not_found","","",146,[[["str"],["str"]],["e"]]],[11,"from_ok","","",146,[[["t"]],["t"]]],[11,"map_same","","",146,[[["self"],["f"]],["t"]]],[11,"to_owned","","",147,[[["self"]],["t"]]],[11,"clone_into","","",147,N],[11,"from","","",147,[[["t"]],["t"]]],[11,"into","","",147,[[["self"]],["u"]]],[11,"try_from","","",147,[[["u"]],["result"]]],[11,"borrow","","",147,[[["self"]],["t"]]],[11,"try_into","","",147,[[["self"]],["result"]]],[11,"borrow_mut","","",147,[[["self"]],["t"]]],[11,"get_type_id","","",147,[[["self"]],["typeid"]]],[11,"not_found","","",147,[[["str"],["str"]],["e"]]],[11,"from_ok","","",147,[[["t"]],["t"]]],[11,"map_same","","",147,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::html::toc","",148,[[["t"]],["t"]]],[11,"to_string","","",148,[[["self"]],["string"]]],[11,"into","","",148,[[["self"]],["u"]]],[11,"try_from","","",148,[[["u"]],["result"]]],[11,"borrow","","",148,[[["self"]],["t"]]],[11,"try_into","","",148,[[["self"]],["result"]]],[11,"borrow_mut","","",148,[[["self"]],["t"]]],[11,"get_type_id","","",148,[[["self"]],["typeid"]]],[11,"not_found","","",148,[[["str"],["str"]],["e"]]],[11,"from_ok","","",148,[[["t"]],["t"]]],[11,"map_same","","",148,[[["self"],["f"]],["t"]]],[11,"from","","",149,[[["t"]],["t"]]],[11,"into","","",149,[[["self"]],["u"]]],[11,"try_from","","",149,[[["u"]],["result"]]],[11,"borrow","","",149,[[["self"]],["t"]]],[11,"try_into","","",149,[[["self"]],["result"]]],[11,"borrow_mut","","",149,[[["self"]],["t"]]],[11,"get_type_id","","",149,[[["self"]],["typeid"]]],[11,"not_found","","",149,[[["str"],["str"]],["e"]]],[11,"from_ok","","",149,[[["t"]],["t"]]],[11,"map_same","","",149,[[["self"],["f"]],["t"]]],[11,"from","","",150,[[["t"]],["t"]]],[11,"into","","",150,[[["self"]],["u"]]],[11,"try_from","","",150,[[["u"]],["result"]]],[11,"borrow","","",150,[[["self"]],["t"]]],[11,"try_into","","",150,[[["self"]],["result"]]],[11,"borrow_mut","","",150,[[["self"]],["t"]]],[11,"get_type_id","","",150,[[["self"]],["typeid"]]],[11,"not_found","","",150,[[["str"],["str"]],["e"]]],[11,"from_ok","","",150,[[["t"]],["t"]]],[11,"map_same","","",150,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::passes","",151,[[["t"]],["t"]]],[11,"into","","",151,[[["self"]],["u"]]],[11,"try_from","","",151,[[["u"]],["result"]]],[11,"borrow","","",151,[[["self"]],["t"]]],[11,"try_into","","",151,[[["self"]],["result"]]],[11,"borrow_mut","","",151,[[["self"]],["t"]]],[11,"get_type_id","","",151,[[["self"]],["typeid"]]],[11,"not_found","","",151,[[["str"],["str"]],["e"]]],[11,"from_ok","","",151,[[["t"]],["t"]]],[11,"map_same","","",151,[[["self"],["f"]],["t"]]],[11,"from","","",152,[[["t"]],["t"]]],[11,"into","","",152,[[["self"]],["u"]]],[11,"try_from","","",152,[[["u"]],["result"]]],[11,"borrow","","",152,[[["self"]],["t"]]],[11,"try_into","","",152,[[["self"]],["result"]]],[11,"borrow_mut","","",152,[[["self"]],["t"]]],[11,"get_type_id","","",152,[[["self"]],["typeid"]]],[11,"not_found","","",152,[[["str"],["str"]],["e"]]],[11,"from_ok","","",152,[[["t"]],["t"]]],[11,"map_same","","",152,[[["self"],["f"]],["t"]]],[11,"from","","",162,[[["t"]],["t"]]],[11,"into","","",162,[[["self"]],["u"]]],[11,"try_from","","",162,[[["u"]],["result"]]],[11,"borrow","","",162,[[["self"]],["t"]]],[11,"try_into","","",162,[[["self"]],["result"]]],[11,"borrow_mut","","",162,[[["self"]],["t"]]],[11,"get_type_id","","",162,[[["self"]],["typeid"]]],[11,"not_found","","",162,[[["str"],["str"]],["e"]]],[11,"from_ok","","",162,[[["t"]],["t"]]],[11,"map_same","","",162,[[["self"],["f"]],["t"]]],[11,"to_owned","","",153,[[["self"]],["t"]]],[11,"clone_into","","",153,N],[11,"from","","",153,[[["t"]],["t"]]],[11,"into","","",153,[[["self"]],["u"]]],[11,"try_from","","",153,[[["u"]],["result"]]],[11,"borrow","","",153,[[["self"]],["t"]]],[11,"try_into","","",153,[[["self"]],["result"]]],[11,"borrow_mut","","",153,[[["self"]],["t"]]],[11,"get_type_id","","",153,[[["self"]],["typeid"]]],[11,"not_found","","",153,[[["str"],["str"]],["e"]]],[11,"from_ok","","",153,[[["t"]],["t"]]],[11,"map_same","","",153,[[["self"],["f"]],["t"]]],[11,"to_owned","","",154,[[["self"]],["t"]]],[11,"clone_into","","",154,N],[11,"from","","",154,[[["t"]],["t"]]],[11,"into","","",154,[[["self"]],["u"]]],[11,"try_from","","",154,[[["u"]],["result"]]],[11,"borrow","","",154,[[["self"]],["t"]]],[11,"try_into","","",154,[[["self"]],["result"]]],[11,"borrow_mut","","",154,[[["self"]],["t"]]],[11,"get_type_id","","",154,[[["self"]],["typeid"]]],[11,"not_found","","",154,[[["str"],["str"]],["e"]]],[11,"from_ok","","",154,[[["t"]],["t"]]],[11,"map_same","","",154,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::passes::collapse_docs","",156,[[["t"]],["t"]]],[11,"into","","",156,[[["self"]],["u"]]],[11,"try_from","","",156,[[["u"]],["result"]]],[11,"borrow","","",156,[[["self"]],["t"]]],[11,"try_into","","",156,[[["self"]],["result"]]],[11,"borrow_mut","","",156,[[["self"]],["t"]]],[11,"get_type_id","","",156,[[["self"]],["typeid"]]],[11,"not_found","","",156,[[["str"],["str"]],["e"]]],[11,"from_ok","","",156,[[["t"]],["t"]]],[11,"map_same","","",156,[[["self"],["f"]],["t"]]],[11,"to_owned","","",155,[[["self"]],["t"]]],[11,"clone_into","","",155,N],[11,"from","","",155,[[["t"]],["t"]]],[11,"into","","",155,[[["self"]],["u"]]],[11,"try_from","","",155,[[["u"]],["result"]]],[11,"borrow","","",155,[[["self"]],["t"]]],[11,"try_into","","",155,[[["self"]],["result"]]],[11,"borrow_mut","","",155,[[["self"]],["t"]]],[11,"get_type_id","","",155,[[["self"]],["typeid"]]],[11,"not_found","","",155,[[["str"],["str"]],["e"]]],[11,"from_ok","","",155,[[["t"]],["t"]]],[11,"map_same","","",155,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::passes::strip_hidden","",157,[[["t"]],["t"]]],[11,"into","","",157,[[["self"]],["u"]]],[11,"try_from","","",157,[[["u"]],["result"]]],[11,"borrow","","",157,[[["self"]],["t"]]],[11,"try_into","","",157,[[["self"]],["result"]]],[11,"borrow_mut","","",157,[[["self"]],["t"]]],[11,"get_type_id","","",157,[[["self"]],["typeid"]]],[11,"not_found","","",157,[[["str"],["str"]],["e"]]],[11,"from_ok","","",157,[[["t"]],["t"]]],[11,"map_same","","",157,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::passes::unindent_comments","",158,[[["t"]],["t"]]],[11,"into","","",158,[[["self"]],["u"]]],[11,"try_from","","",158,[[["u"]],["result"]]],[11,"borrow","","",158,[[["self"]],["t"]]],[11,"try_into","","",158,[[["self"]],["result"]]],[11,"borrow_mut","","",158,[[["self"]],["t"]]],[11,"get_type_id","","",158,[[["self"]],["typeid"]]],[11,"not_found","","",158,[[["str"],["str"]],["e"]]],[11,"from_ok","","",158,[[["t"]],["t"]]],[11,"map_same","","",158,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::passes::propagate_doc_cfg","",159,[[["t"]],["t"]]],[11,"into","","",159,[[["self"]],["u"]]],[11,"try_from","","",159,[[["u"]],["result"]]],[11,"borrow","","",159,[[["self"]],["t"]]],[11,"try_into","","",159,[[["self"]],["result"]]],[11,"borrow_mut","","",159,[[["self"]],["t"]]],[11,"get_type_id","","",159,[[["self"]],["typeid"]]],[11,"not_found","","",159,[[["str"],["str"]],["e"]]],[11,"from_ok","","",159,[[["t"]],["t"]]],[11,"map_same","","",159,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::passes::collect_intra_doc_links","",160,[[["t"]],["t"]]],[11,"into","","",160,[[["self"]],["u"]]],[11,"try_from","","",160,[[["u"]],["result"]]],[11,"borrow","","",160,[[["self"]],["t"]]],[11,"try_into","","",160,[[["self"]],["result"]]],[11,"borrow_mut","","",160,[[["self"]],["t"]]],[11,"get_type_id","","",160,[[["self"]],["typeid"]]],[11,"not_found","","",160,[[["str"],["str"]],["e"]]],[11,"from_ok","","",160,[[["t"]],["t"]]],[11,"map_same","","",160,[[["self"],["f"]],["t"]]],[11,"from","","",161,[[["t"]],["t"]]],[11,"into","","",161,[[["self"]],["u"]]],[11,"try_from","","",161,[[["u"]],["result"]]],[11,"borrow","","",161,[[["self"]],["t"]]],[11,"try_into","","",161,[[["self"]],["result"]]],[11,"borrow_mut","","",161,[[["self"]],["t"]]],[11,"get_type_id","","",161,[[["self"]],["typeid"]]],[11,"not_found","","",161,[[["str"],["str"]],["e"]]],[11,"from_ok","","",161,[[["t"]],["t"]]],[11,"map_same","","",161,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::visit_ast","",163,[[["t"]],["t"]]],[11,"into","","",163,[[["self"]],["u"]]],[11,"try_from","","",163,[[["u"]],["result"]]],[11,"borrow","","",163,[[["self"]],["t"]]],[11,"try_into","","",163,[[["self"]],["result"]]],[11,"borrow_mut","","",163,[[["self"]],["t"]]],[11,"get_type_id","","",163,[[["self"]],["typeid"]]],[11,"not_found","","",163,[[["str"],["str"]],["e"]]],[11,"from_ok","","",163,[[["t"]],["t"]]],[11,"map_same","","",163,[[["self"],["f"]],["t"]]],[11,"from","rustdoc::visit_lib","",164,[[["t"]],["t"]]],[11,"into","","",164,[[["self"]],["u"]]],[11,"try_from","","",164,[[["u"]],["result"]]],[11,"borrow","","",164,[[["self"]],["t"]]],[11,"try_into","","",164,[[["self"]],["result"]]],[11,"borrow_mut","","",164,[[["self"]],["t"]]],[11,"get_type_id","","",164,[[["self"]],["typeid"]]],[11,"not_found","","",164,[[["str"],["str"]],["e"]]],[11,"from_ok","","",164,[[["t"]],["t"]]],[11,"map_same","","",164,[[["self"],["f"]],["t"]]],[11,"to_owned","rustdoc::test","",165,[[["self"]],["t"]]],[11,"clone_into","","",165,N],[11,"from","","",165,[[["t"]],["t"]]],[11,"into","","",165,[[["self"]],["u"]]],[11,"try_from","","",165,[[["u"]],["result"]]],[11,"borrow","","",165,[[["self"]],["t"]]],[11,"try_into","","",165,[[["self"]],["result"]]],[11,"borrow_mut","","",165,[[["self"]],["t"]]],[11,"get_type_id","","",165,[[["self"]],["typeid"]]],[11,"not_found","","",165,[[["str"],["str"]],["e"]]],[11,"from_ok","","",165,[[["t"]],["t"]]],[11,"map_same","","",165,[[["self"],["f"]],["t"]]],[11,"from","","",166,[[["t"]],["t"]]],[11,"into","","",166,[[["self"]],["u"]]],[11,"try_from","","",166,[[["u"]],["result"]]],[11,"borrow","","",166,[[["self"]],["t"]]],[11,"try_into","","",166,[[["self"]],["result"]]],[11,"borrow_mut","","",166,[[["self"]],["t"]]],[11,"get_type_id","","",166,[[["self"]],["typeid"]]],[11,"not_found","","",166,[[["str"],["str"]],["e"]]],[11,"from_ok","","",166,[[["t"]],["t"]]],[11,"map_same","","",166,[[["self"],["f"]],["t"]]],[11,"from","","",167,[[["t"]],["t"]]],[11,"into","","",167,[[["self"]],["u"]]],[11,"try_from","","",167,[[["u"]],["result"]]],[11,"borrow","","",167,[[["self"]],["t"]]],[11,"try_into","","",167,[[["self"]],["result"]]],[11,"borrow_mut","","",167,[[["self"]],["t"]]],[11,"get_type_id","","",167,[[["self"]],["typeid"]]],[11,"not_found","","",167,[[["str"],["str"]],["e"]]],[11,"from_ok","","",167,[[["t"]],["t"]]],[11,"map_same","","",167,[[["self"],["f"]],["t"]]],[11,"to_owned","rustdoc::theme","",168,[[["self"]],["t"]]],[11,"clone_into","","",168,N],[11,"from","","",168,[[["t"]],["t"]]],[11,"into","","",168,[[["self"]],["u"]]],[11,"try_from","","",168,[[["u"]],["result"]]],[11,"borrow","","",168,[[["self"]],["t"]]],[11,"try_into","","",168,[[["self"]],["result"]]],[11,"borrow_mut","","",168,[[["self"]],["t"]]],[11,"get_type_id","","",168,[[["self"]],["typeid"]]],[11,"not_found","","",168,[[["str"],["str"]],["e"]]],[11,"from_ok","","",168,[[["t"]],["t"]]],[11,"map_same","","",168,[[["self"],["f"]],["t"]]],[11,"to_owned","","",169,[[["self"]],["t"]]],[11,"clone_into","","",169,N],[11,"from","","",169,[[["t"]],["t"]]],[11,"into","","",169,[[["self"]],["u"]]],[11,"try_from","","",169,[[["u"]],["result"]]],[11,"borrow","","",169,[[["self"]],["t"]]],[11,"try_into","","",169,[[["self"]],["result"]]],[11,"borrow_mut","","",169,[[["self"]],["t"]]],[11,"get_type_id","","",169,[[["self"]],["typeid"]]],[11,"not_found","","",169,[[["str"],["str"]],["e"]]],[11,"from_ok","","",169,[[["t"]],["t"]]],[11,"map_same","","",169,[[["self"],["f"]],["t"]]]],"paths":[[3,"Output"],[3,"ExternalHtml"],[4,"LoadStringError"],[3,"Crate"],[3,"ExternalCrate"],[3,"Item"],[3,"Module"],[3,"ListAttributesIter"],[3,"Attributes"],[3,"Lifetime"],[3,"GenericParamDef"],[3,"Generics"],[3,"Method"],[3,"TyMethod"],[3,"Function"],[3,"FnDecl"],[3,"Arguments"],[3,"Argument"],[3,"Trait"],[3,"PolyTrait"],[3,"Struct"],[3,"Union"],[3,"VariantStruct"],[3,"Enum"],[3,"Variant"],[3,"Span"],[3,"Path"],[3,"PathSegment"],[3,"Typedef"],[3,"Existential"],[3,"BareFunctionDecl"],[3,"Static"],[3,"Constant"],[3,"Impl"],[3,"ImportSource"],[3,"Macro"],[3,"Stability"],[3,"Deprecation"],[3,"TypeBinding"],[3,"RegionDeps"],[4,"ItemEnum"],[4,"DocFragment"],[4,"GenericBound"],[4,"WherePredicate"],[4,"GenericParamDefKind"],[4,"SelfTy"],[4,"FunctionRetTy"],[4,"Type"],[4,"PrimitiveType"],[4,"TypeKind"],[4,"Visibility"],[4,"VariantKind"],[4,"GenericArgs"],[4,"Mutability"],[4,"ImplPolarity"],[4,"Import"],[4,"RegionTarget"],[4,"SimpleBound"],[4,"AutoTraitResult"],[3,"InvalidCfgError"],[3,"Html"],[4,"Cfg"],[3,"AutoTraitFinder"],[3,"RegionReplacer"],[3,"BlanketImplFinder"],[8,"Clean"],[8,"AttributesExt"],[8,"NestedAttributesExt"],[8,"GetDefId"],[8,"ToSource"],[4,"Input"],[3,"Options"],[3,"CodegenOptions"],[3,"SearchPaths"],[3,"DocContext"],[8,"DocAccessLevels"],[3,"Module"],[3,"Struct"],[3,"Union"],[3,"Enum"],[3,"Variant"],[3,"Function"],[3,"Typedef"],[3,"Existential"],[3,"Static"],[3,"Constant"],[3,"Trait"],[3,"Impl"],[3,"Macro"],[3,"ExternCrate"],[3,"Import"],[4,"StructType"],[3,"StripItem"],[8,"DocFolder"],[3,"Classifier"],[4,"Class"],[8,"Writer"],[3,"Escape"],[4,"ItemType"],[4,"NameSpace"],[3,"VisSpace"],[3,"UnsafetySpace"],[3,"ConstnessSpace"],[3,"AsyncSpace"],[3,"MutableSpace"],[3,"RawMutableSpace"],[3,"GenericBounds"],[3,"CommaSep"],[3,"AbiSpace"],[3,"Method"],[3,"WhereClause"],[3,"HRef"],[3,"Layout"],[3,"Page"],[3,"Markdown"],[3,"MarkdownWithToc"],[3,"MarkdownHtml"],[3,"MarkdownSummaryLine"],[3,"CodeBlocks"],[3,"LinkReplacer"],[3,"HeadingLinks"],[3,"SummaryLine"],[3,"Footnotes"],[3,"TestableCodeError"],[3,"LangString"],[3,"IdMap"],[4,"ErrorCodes"],[4,"Line"],[3,"Context"],[3,"SharedContext"],[3,"Impl"],[3,"Error"],[3,"Cache"],[3,"RenderInfo"],[3,"SourceCollector"],[3,"Source"],[3,"Item"],[3,"Sidebar"],[3,"IndexItem"],[3,"Type"],[3,"IndexItemFunctionType"],[3,"ItemEntry"],[3,"AllTypes"],[3,"Settings"],[4,"ExternalLocation"],[4,"AssocItemLink"],[4,"AssocItemRender"],[4,"RenderMode"],[3,"Toc"],[3,"TocEntry"],[3,"TocBuilder"],[3,"Stripper"],[3,"ImplStripper"],[4,"Pass"],[4,"DefaultPassOption"],[4,"DocFragmentKind"],[3,"Collapser"],[3,"Stripper"],[3,"CommentCleaner"],[3,"CfgPropagator"],[3,"LinkCollector"],[4,"PathKind"],[3,"ImportStripper"],[3,"RustdocVisitor"],[3,"LibEmbargoVisitor"],[3,"TestOptions"],[3,"Collector"],[3,"HirCollector"],[3,"CssPath"],[4,"Events"]]};
searchIndex["rustdoc_tool_binary"]={"doc":"","items":[[5,"main","rustdoc_tool_binary","",N,[[]]]],"paths":[]};
searchIndex["serialize"]={"doc":"Support code for encoding and decoding types.","items":[[0,"serialize","serialize","Support code for encoding and decoding types.",N,N],[8,"Encoder","serialize::serialize","",N,N],[16,"Error","","",0,N],[10,"emit_unit","","",0,[[["self"]],["result"]]],[10,"emit_usize","","",0,[[["self"],["usize"]],["result"]]],[10,"emit_u128","","",0,[[["self"],["u128"]],["result"]]],[10,"emit_u64","","",0,[[["self"],["u64"]],["result"]]],[10,"emit_u32","","",0,[[["self"],["u32"]],["result"]]],[10,"emit_u16","","",0,[[["self"],["u16"]],["result"]]],[10,"emit_u8","","",0,[[["self"],["u8"]],["result"]]],[10,"emit_isize","","",0,[[["self"],["isize"]],["result"]]],[10,"emit_i128","","",0,[[["self"],["i128"]],["result"]]],[10,"emit_i64","","",0,[[["self"],["i64"]],["result"]]],[10,"emit_i32","","",0,[[["self"],["i32"]],["result"]]],[10,"emit_i16","","",0,[[["self"],["i16"]],["result"]]],[10,"emit_i8","","",0,[[["self"],["i8"]],["result"]]],[10,"emit_bool","","",0,[[["self"],["bool"]],["result"]]],[10,"emit_f64","","",0,[[["self"],["f64"]],["result"]]],[10,"emit_f32","","",0,[[["self"],["f32"]],["result"]]],[10,"emit_char","","",0,[[["self"],["char"]],["result"]]],[10,"emit_str","","",0,[[["self"],["str"]],["result"]]],[11,"emit_enum","","",0,[[["self"],["str"],["f"]],["result"]]],[11,"emit_enum_variant","","",0,[[["self"],["str"],["usize"],["usize"],["f"]],["result"]]],[11,"emit_enum_variant_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_enum_struct_variant","","",0,[[["self"],["str"],["usize"],["usize"],["f"]],["result"]]],[11,"emit_enum_struct_variant_field","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_struct","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_struct_field","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_tuple","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_tuple_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_tuple_struct","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_tuple_struct_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_option","","",0,[[["self"],["f"]],["result"]]],[11,"emit_option_none","","",0,[[["self"]],["result"]]],[11,"emit_option_some","","",0,[[["self"],["f"]],["result"]]],[11,"emit_seq","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_seq_elt","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map_elt_key","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map_elt_val","","",0,[[["self"],["usize"],["f"]],["result"]]],[8,"Decoder","","",N,N],[16,"Error","","",1,N],[10,"read_nil","","",1,[[["self"]],["result"]]],[10,"read_usize","","",1,[[["self"]],["result",["usize"]]]],[10,"read_u128","","",1,[[["self"]],["result",["u128"]]]],[10,"read_u64","","",1,[[["self"]],["result",["u64"]]]],[10,"read_u32","","",1,[[["self"]],["result",["u32"]]]],[10,"read_u16","","",1,[[["self"]],["result",["u16"]]]],[10,"read_u8","","",1,[[["self"]],["result",["u8"]]]],[10,"read_isize","","",1,[[["self"]],["result",["isize"]]]],[10,"read_i128","","",1,[[["self"]],["result",["i128"]]]],[10,"read_i64","","",1,[[["self"]],["result",["i64"]]]],[10,"read_i32","","",1,[[["self"]],["result",["i32"]]]],[10,"read_i16","","",1,[[["self"]],["result",["i16"]]]],[10,"read_i8","","",1,[[["self"]],["result",["i8"]]]],[10,"read_bool","","",1,[[["self"]],["result",["bool"]]]],[10,"read_f64","","",1,[[["self"]],["result",["f64"]]]],[10,"read_f32","","",1,[[["self"]],["result",["f32"]]]],[10,"read_char","","",1,[[["self"]],["result",["char"]]]],[10,"read_str","","",1,[[["self"]],["result",["cow"]]]],[11,"read_enum","","",1,[[["self"],["str"],["f"]],["result"]]],[11,"read_enum_variant","","",1,N],[11,"read_enum_variant_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_enum_struct_variant","","",1,N],[11,"read_enum_struct_variant_field","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_struct","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_struct_field","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_tuple","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_tuple_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_tuple_struct","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_tuple_struct_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_option","","",1,[[["self"],["f"]],["result"]]],[11,"read_seq","","",1,[[["self"],["f"]],["result"]]],[11,"read_seq_elt","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_map","","",1,[[["self"],["f"]],["result"]]],[11,"read_map_elt_key","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_map_elt_val","","",1,[[["self"],["usize"],["f"]],["result"]]],[10,"error","","",1,N],[8,"Encodable","","",N,N],[10,"encode","","",2,[[["self"],["s"]],["result"]]],[8,"Decodable","","",N,N],[10,"decode","","",3,[[["d"]],["result"]]],[8,"SpecializationError","","Implement this trait on your `{Encodable,Decodable}::Error` types to override the default panic behavior for missing specializations.",N,N],[10,"not_found","","Create an error for a missing method specialization. Defaults to panicking with type, trait & method names. `S` is the encoder/decoder state type, `T` is the type being encoded/decoded, and the arguments are the names of the trait and method that should've been overridden.",4,[[["str"],["str"]],["self"]]],[8,"SpecializedEncoder","","Implement this trait on encoders, with `T` being the type you want to encode (employing `UseSpecializedEncodable`), using a strategy specific to the encoder.",N,N],[10,"specialized_encode","","Encode the value in a manner specific to this encoder state.",5,[[["self"],["t"]],["result"]]],[8,"SpecializedDecoder","","Implement this trait on decoders, with `T` being the type you want to decode (employing `UseSpecializedDecodable`), using a strategy specific to the decoder.",N,N],[10,"specialized_decode","","Decode a value in a manner specific to this decoder state.",6,[[["self"]],["result"]]],[8,"UseSpecializedEncodable","","Implement this trait on your type to get an `Encodable` implementation which goes through `SpecializedEncoder`.",N,N],[11,"default_encode","","Defaults to returning an error (see `SpecializationError`).",7,[[["self"],["e"]],["result"]]],[8,"UseSpecializedDecodable","","Implement this trait on your type to get an `Decodable` implementation which goes through `SpecializedDecoder`.",N,N],[11,"default_decode","","Defaults to returning an error (see `SpecializationError`).",8,[[["d"]],["result"]]],[0,"collection_impls","serialize","Implementations of serialization for structures found in liballoc",N,N],[0,"hex","","Hex binary-to-text encoding",N,N],[4,"FromHexError","serialize::hex","Errors that can occur when decoding a hex encoded string",N,N],[13,"InvalidHexCharacter","","The input contained a character not part of the hex format",9,N],[13,"InvalidHexLength","","The input had an invalid length",9,N],[17,"CHARS","","",N,N],[8,"ToHex","","A trait for converting a value to hexadecimal encoding",N,N],[10,"to_hex","","Converts the value of `self` to a hex value, returning the owned string.",10,[[["self"]],["string"]]],[8,"FromHex","","A trait for converting hexadecimal encoded values",N,N],[10,"from_hex","","Converts the value of `self`, interpreted as hexadecimal encoded data, into an owned vector of bytes, returning the vector.",11,[[["self"]],["result",["vec","fromhexerror"]]]],[11,"clone","","",9,[[["self"]],["fromhexerror"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"description","","",9,[[["self"]],["str"]]],[0,"json","serialize","JSON parsing and serialization",N,N],[3,"PrettyJson","serialize::json","",N,N],[12,"inner","","",12,N],[3,"AsJson","","",N,N],[12,"inner","","",13,N],[3,"AsPrettyJson","","",N,N],[12,"inner","","",14,N],[12,"indent","","",14,N],[3,"Encoder","","A structure for implementing serialization to JSON.",N,N],[12,"writer","","",15,N],[12,"is_emitting_map_key","","",15,N],[3,"PrettyEncoder","","Another encoder for JSON, but prints out human-readable JSON instead of compact data",N,N],[12,"writer","","",16,N],[12,"curr_indent","","",16,N],[12,"indent","","",16,N],[12,"is_emitting_map_key","","",16,N],[3,"Stack","","A Stack represents the current position of the parser in the logical structure of the JSON stream. For example foo.bar[3].x",N,N],[12,"stack","","",17,N],[12,"str_buffer","","",17,N],[3,"Parser","","A streaming JSON parser implemented as an iterator of JsonEvent, consuming an iterator of char.",N,N],[12,"rdr","","",18,N],[12,"ch","","",18,N],[12,"line","","",18,N],[12,"col","","",18,N],[12,"stack","","",18,N],[12,"state","","",18,N],[3,"Builder","","A Builder consumes a json::Parser to create a generic Json structure.",N,N],[12,"parser","","",19,N],[12,"token","","",19,N],[3,"Decoder","","A structure to decode JSON to values in rust.",N,N],[12,"stack","","",20,N],[3,"FormatShim","","",N,N],[12,"inner","","",21,N],[4,"Json","","Represents a json value",N,N],[13,"I64","","",22,N],[13,"U64","","",22,N],[13,"F64","","",22,N],[13,"String","","",22,N],[13,"Boolean","","",22,N],[13,"Array","","",22,N],[13,"Object","","",22,N],[13,"Null","","",22,N],[4,"ErrorCode","","The errors that can arise while parsing a JSON stream.",N,N],[13,"InvalidSyntax","","",23,N],[13,"InvalidNumber","","",23,N],[13,"EOFWhileParsingObject","","",23,N],[13,"EOFWhileParsingArray","","",23,N],[13,"EOFWhileParsingValue","","",23,N],[13,"EOFWhileParsingString","","",23,N],[13,"KeyMustBeAString","","",23,N],[13,"ExpectedColon","","",23,N],[13,"TrailingCharacters","","",23,N],[13,"TrailingComma","","",23,N],[13,"InvalidEscape","","",23,N],[13,"InvalidUnicodeCodePoint","","",23,N],[13,"LoneLeadingSurrogateInHexEscape","","",23,N],[13,"UnexpectedEndOfHexEscape","","",23,N],[13,"UnrecognizedHex","","",23,N],[13,"NotFourDigit","","",23,N],[13,"NotUtf8","","",23,N],[4,"ParserError","","",N,N],[13,"SyntaxError","","msg, line, col",24,N],[13,"IoError","","",24,N],[4,"DecoderError","","",N,N],[13,"ParseError","","",25,N],[13,"ExpectedError","","",25,N],[13,"MissingFieldError","","",25,N],[13,"UnknownVariantError","","",25,N],[13,"ApplicationError","","",25,N],[4,"EncoderError","","",N,N],[13,"FmtError","","",26,N],[13,"BadHashmapKey","","",26,N],[4,"JsonEvent","","The output of the streaming parser.",N,N],[13,"ObjectStart","","",27,N],[13,"ObjectEnd","","",27,N],[13,"ArrayStart","","",27,N],[13,"ArrayEnd","","",27,N],[13,"BooleanValue","","",27,N],[13,"I64Value","","",27,N],[13,"U64Value","","",27,N],[13,"F64Value","","",27,N],[13,"StringValue","","",27,N],[13,"NullValue","","",27,N],[13,"Error","","",27,N],[4,"ParserState","","",N,N],[13,"ParseArray","","",28,N],[13,"ParseArrayComma","","",28,N],[13,"ParseObject","","",28,N],[13,"ParseObjectComma","","",28,N],[13,"ParseStart","","",28,N],[13,"ParseBeforeFinish","","",28,N],[13,"ParseFinished","","",28,N],[4,"StackElement","","StackElements compose a Stack. For example, StackElement::Key(\"foo\"), StackElement::Key(\"bar\"), StackElement::Index(3) and StackElement::Key(\"x\") are the StackElements compositing the stack that represents foo.bar[3].x",N,N],[13,"Index","","",29,N],[13,"Key","","",29,N],[4,"InternalStackElement","","",N,N],[13,"InternalIndex","","",30,N],[13,"InternalKey","","",30,N],[5,"error_str","","Returns a readable error string for a given error code.",N,[[["errorcode"]],["str"]]],[5,"decode","","Shortcut function to decode a JSON `&str` into an object",N,[[["str"]],["decoderesult"]]],[5,"encode","","Shortcut function to encode a `T` into a JSON `String`",N,[[["t"]],["result",["string","encodererror"]]]],[5,"io_error_to_error","","",N,[[["error"]],["parsererror"]]],[5,"escape_str","","",N,[[["write"],["str"]],["encoderesult"]]],[5,"escape_char","","",N,[[["write"],["char"]],["encoderesult"]]],[5,"spaces","","",N,[[["write"],["usize"]],["encoderesult"]]],[5,"fmt_number_or_null","","",N,[[["f64"]],["string"]]],[5,"as_json","","Create an `AsJson` wrapper which can be used to print a value as JSON on-the-fly via `write!`",N,[[["t"]],["asjson"]]],[5,"as_pretty_json","","Create an `AsPrettyJson` wrapper which can be used to print a value as JSON on-the-fly via `write!`",N,[[["t"]],["asprettyjson"]]],[5,"from_reader","","Decodes a json value from an `&mut io::Read`",N,[[["read"]],["result",["json","buildererror"]]]],[5,"from_str","","Decodes a json value from a string",N,[[["str"]],["result",["json","buildererror"]]]],[6,"Array","","",N,N],[6,"Object","","",N,N],[6,"BuilderError","","",N,N],[6,"EncodeResult","","",N,N],[6,"DecodeResult","","",N,N],[8,"ToJson","","A trait for converting values to JSON",N,N],[10,"to_json","","Converts the value of `self` to an instance of JSON",31,[[["self"]],["json"]]],[11,"clone","","",22,[[["self"]],["json"]]],[11,"eq","","",22,[[["self"],["json"]],["bool"]]],[11,"ne","","",22,[[["self"],["json"]],["bool"]]],[11,"partial_cmp","","",22,[[["self"],["json"]],["option",["ordering"]]]],[11,"lt","","",22,[[["self"],["json"]],["bool"]]],[11,"le","","",22,[[["self"],["json"]],["bool"]]],[11,"gt","","",22,[[["self"],["json"]],["bool"]]],[11,"ge","","",22,[[["self"],["json"]],["bool"]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"clone","","",23,[[["self"]],["errorcode"]]],[11,"eq","","",23,[[["self"],["errorcode"]],["bool"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"clone","","",24,[[["self"]],["parsererror"]]],[11,"eq","","",24,[[["self"],["parsererror"]],["bool"]]],[11,"ne","","",24,[[["self"],["parsererror"]],["bool"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"clone","","",25,[[["self"]],["decodererror"]]],[11,"eq","","",25,[[["self"],["decodererror"]],["bool"]]],[11,"ne","","",25,[[["self"],["decodererror"]],["bool"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"clone","","",26,[[["self"]],["encodererror"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"description","","",25,[[["self"]],["str"]]],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"description","","",26,[[["self"]],["str"]]],[11,"from","","Converts a [`fmt::Error`] into `EncoderError`",26,[[["error"]],["encodererror"]]],[11,"new","","Creates a new JSON encoder whose output will be written to the writer specified.",15,[[["write"]],["encoder"]]],[11,"emit_unit","","",15,[[["self"]],["encoderesult"]]],[11,"emit_usize","","",15,[[["self"],["usize"]],["encoderesult"]]],[11,"emit_u128","","",15,[[["self"],["u128"]],["encoderesult"]]],[11,"emit_u64","","",15,[[["self"],["u64"]],["encoderesult"]]],[11,"emit_u32","","",15,[[["self"],["u32"]],["encoderesult"]]],[11,"emit_u16","","",15,[[["self"],["u16"]],["encoderesult"]]],[11,"emit_u8","","",15,[[["self"],["u8"]],["encoderesult"]]],[11,"emit_isize","","",15,[[["self"],["isize"]],["encoderesult"]]],[11,"emit_i128","","",15,[[["self"],["i128"]],["encoderesult"]]],[11,"emit_i64","","",15,[[["self"],["i64"]],["encoderesult"]]],[11,"emit_i32","","",15,[[["self"],["i32"]],["encoderesult"]]],[11,"emit_i16","","",15,[[["self"],["i16"]],["encoderesult"]]],[11,"emit_i8","","",15,[[["self"],["i8"]],["encoderesult"]]],[11,"emit_bool","","",15,[[["self"],["bool"]],["encoderesult"]]],[11,"emit_f64","","",15,[[["self"],["f64"]],["encoderesult"]]],[11,"emit_f32","","",15,[[["self"],["f32"]],["encoderesult"]]],[11,"emit_char","","",15,[[["self"],["char"]],["encoderesult"]]],[11,"emit_str","","",15,[[["self"],["str"]],["encoderesult"]]],[11,"emit_enum","","",15,[[["self"],["str"],["f"]],["encoderesult"]]],[11,"emit_enum_variant","","",15,[[["self"],["str"],["usize"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_variant_arg","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_struct_variant","","",15,[[["self"],["str"],["usize"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_struct_variant_field","","",15,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_struct","","",15,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_struct_field","","",15,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_arg","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_struct","","",15,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_struct_arg","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_option","","",15,[[["self"],["f"]],["encoderesult"]]],[11,"emit_option_none","","",15,[[["self"]],["encoderesult"]]],[11,"emit_option_some","","",15,[[["self"],["f"]],["encoderesult"]]],[11,"emit_seq","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_seq_elt","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map_elt_key","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map_elt_val","","",15,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"new","","Creates a new encoder whose output will be written to the specified writer",16,[[["write"]],["prettyencoder"]]],[11,"set_indent","","Set the number of spaces to indent for each level. This is safe to set during encoding.",16,[[["self"],["usize"]]]],[11,"emit_unit","","",16,[[["self"]],["encoderesult"]]],[11,"emit_usize","","",16,[[["self"],["usize"]],["encoderesult"]]],[11,"emit_u128","","",16,[[["self"],["u128"]],["encoderesult"]]],[11,"emit_u64","","",16,[[["self"],["u64"]],["encoderesult"]]],[11,"emit_u32","","",16,[[["self"],["u32"]],["encoderesult"]]],[11,"emit_u16","","",16,[[["self"],["u16"]],["encoderesult"]]],[11,"emit_u8","","",16,[[["self"],["u8"]],["encoderesult"]]],[11,"emit_isize","","",16,[[["self"],["isize"]],["encoderesult"]]],[11,"emit_i128","","",16,[[["self"],["i128"]],["encoderesult"]]],[11,"emit_i64","","",16,[[["self"],["i64"]],["encoderesult"]]],[11,"emit_i32","","",16,[[["self"],["i32"]],["encoderesult"]]],[11,"emit_i16","","",16,[[["self"],["i16"]],["encoderesult"]]],[11,"emit_i8","","",16,[[["self"],["i8"]],["encoderesult"]]],[11,"emit_bool","","",16,[[["self"],["bool"]],["encoderesult"]]],[11,"emit_f64","","",16,[[["self"],["f64"]],["encoderesult"]]],[11,"emit_f32","","",16,[[["self"],["f32"]],["encoderesult"]]],[11,"emit_char","","",16,[[["self"],["char"]],["encoderesult"]]],[11,"emit_str","","",16,[[["self"],["str"]],["encoderesult"]]],[11,"emit_enum","","",16,[[["self"],["str"],["f"]],["encoderesult"]]],[11,"emit_enum_variant","","",16,[[["self"],["str"],["usize"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_variant_arg","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_struct_variant","","",16,[[["self"],["str"],["usize"],["usize"],["f"]],["encoderesult"]]],[11,"emit_enum_struct_variant_field","","",16,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_struct","","",16,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_struct_field","","",16,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_arg","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_struct","","",16,[[["self"],["str"],["usize"],["f"]],["encoderesult"]]],[11,"emit_tuple_struct_arg","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_option","","",16,[[["self"],["f"]],["encoderesult"]]],[11,"emit_option_none","","",16,[[["self"]],["encoderesult"]]],[11,"emit_option_some","","",16,[[["self"],["f"]],["encoderesult"]]],[11,"emit_seq","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_seq_elt","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map_elt_key","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"emit_map_elt_val","","",16,[[["self"],["usize"],["f"]],["encoderesult"]]],[11,"encode","","",22,[[["self"],["e"]],["result"]]],[11,"pretty","","Borrow this json object as a pretty object to generate a pretty representation for it via `Display`.",22,[[["self"]],["prettyjson"]]],[11,"find","","If the Json value is an Object, returns the value associated with the provided key. Otherwise, returns None.",22,[[["self"],["str"]],["option",["json"]]]],[11,"find_path","","Attempts to get a nested Json Object for each key in `keys`. If any key is found not to exist, find_path will return None. Otherwise, it will return the Json value associated with the final key.",22,N],[11,"search","","If the Json value is an Object, performs a depth-first search until a value associated with the provided key is found. If no value is found or the Json value is not an Object, returns None.",22,[[["self"],["str"]],["option",["json"]]]],[11,"is_object","","Returns true if the Json value is an Object. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_object","","If the Json value is an Object, returns the associated BTreeMap. Returns None otherwise.",22,[[["self"]],["option",["object"]]]],[11,"is_array","","Returns true if the Json value is an Array. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_array","","If the Json value is an Array, returns the associated vector. Returns None otherwise.",22,[[["self"]],["option",["array"]]]],[11,"is_string","","Returns true if the Json value is a String. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_string","","If the Json value is a String, returns the associated str. Returns None otherwise.",22,[[["self"]],["option",["str"]]]],[11,"is_number","","Returns true if the Json value is a Number. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"is_i64","","Returns true if the Json value is a i64. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"is_u64","","Returns true if the Json value is a u64. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"is_f64","","Returns true if the Json value is a f64. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_i64","","If the Json value is a number, return or cast it to a i64. Returns None otherwise.",22,[[["self"]],["option",["i64"]]]],[11,"as_u64","","If the Json value is a number, return or cast it to a u64. Returns None otherwise.",22,[[["self"]],["option",["u64"]]]],[11,"as_f64","","If the Json value is a number, return or cast it to a f64. Returns None otherwise.",22,[[["self"]],["option",["f64"]]]],[11,"is_boolean","","Returns true if the Json value is a Boolean. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_boolean","","If the Json value is a Boolean, returns the associated bool. Returns None otherwise.",22,[[["self"]],["option",["bool"]]]],[11,"is_null","","Returns true if the Json value is a Null. Returns false otherwise.",22,[[["self"]],["bool"]]],[11,"as_null","","If the Json value is a Null, returns (). Returns None otherwise.",22,[[["self"]],["option"]]],[11,"index","","",22,[[["self"],["str"]],["json"]]],[11,"index","","",22,[[["self"],["usize"]],["json"]]],[11,"eq","","",27,[[["self"],["jsonevent"]],["bool"]]],[11,"ne","","",27,[[["self"],["jsonevent"]],["bool"]]],[11,"clone","","",27,[[["self"]],["jsonevent"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"eq","","",28,[[["self"],["parserstate"]],["bool"]]],[11,"ne","","",28,[[["self"],["parserstate"]],["bool"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"eq","","",29,[[["self"],["stackelement"]],["bool"]]],[11,"ne","","",29,[[["self"],["stackelement"]],["bool"]]],[11,"clone","","",29,[[["self"]],["stackelement"]]],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"eq","","",30,[[["self"],["internalstackelement"]],["bool"]]],[11,"ne","","",30,[[["self"],["internalstackelement"]],["bool"]]],[11,"clone","","",30,[[["self"]],["internalstackelement"]]],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"new","","",17,[[],["stack"]]],[11,"len","","Returns The number of elements in the Stack.",17,[[["self"]],["usize"]]],[11,"is_empty","","Returns true if the stack is empty.",17,[[["self"]],["bool"]]],[11,"get","","Provides access to the StackElement at a given index. lower indices are at the bottom of the stack while higher indices are at the top.",17,[[["self"],["usize"]],["stackelement"]]],[11,"is_equal_to","","Compares this stack with an array of StackElements.",17,N],[11,"starts_with","","Returns true if the bottom-most elements of this stack are the same as the ones passed as parameter.",17,N],[11,"ends_with","","Returns true if the top-most elements of this stack are the same as the ones passed as parameter.",17,N],[11,"top","","Returns the top-most element (if any).",17,[[["self"]],["option",["stackelement"]]]],[11,"push_key","","",17,[[["self"],["string"]]]],[11,"push_index","","",17,[[["self"],["u32"]]]],[11,"pop","","",17,[[["self"]]]],[11,"last_is_index","","",17,[[["self"]],["bool"]]],[11,"bump_index","","",17,[[["self"]]]],[11,"next","","",18,[[["self"]],["option",["jsonevent"]]]],[11,"new","","Creates the JSON parser.",18,[[["t"]],["parser"]]],[11,"stack","","Provides access to the current position in the logical structure of the JSON stream.",18,[[["self"]],["stack"]]],[11,"eof","","",18,[[["self"]],["bool"]]],[11,"ch_or_null","","",18,[[["self"]],["char"]]],[11,"bump","","",18,[[["self"]]]],[11,"next_char","","",18,[[["self"]],["option",["char"]]]],[11,"ch_is","","",18,[[["self"],["char"]],["bool"]]],[11,"error","","",18,[[["self"],["errorcode"]],["result",["parsererror"]]]],[11,"parse_whitespace","","",18,[[["self"]]]],[11,"parse_number","","",18,[[["self"]],["jsonevent"]]],[11,"parse_u64","","",18,[[["self"]],["result",["u64","parsererror"]]]],[11,"parse_decimal","","",18,[[["self"],["f64"]],["result",["f64","parsererror"]]]],[11,"parse_exponent","","",18,[[["self"],["f64"]],["result",["f64","parsererror"]]]],[11,"decode_hex_escape","","",18,[[["self"]],["result",["u16","parsererror"]]]],[11,"parse_str","","",18,[[["self"]],["result",["string","parsererror"]]]],[11,"parse","","",18,[[["self"]],["jsonevent"]]],[11,"parse_start","","",18,[[["self"]],["jsonevent"]]],[11,"parse_array","","",18,[[["self"],["bool"]],["jsonevent"]]],[11,"parse_array_comma_or_end","","",18,[[["self"]],["option",["jsonevent"]]]],[11,"parse_object","","",18,[[["self"],["bool"]],["jsonevent"]]],[11,"parse_object_end","","",18,[[["self"]],["jsonevent"]]],[11,"parse_value","","",18,[[["self"]],["jsonevent"]]],[11,"parse_ident","","",18,[[["self"],["str"],["jsonevent"]],["jsonevent"]]],[11,"error_event","","",18,[[["self"],["errorcode"]],["jsonevent"]]],[11,"new","","Create a JSON Builder.",19,[[["t"]],["builder"]]],[11,"build","","",19,[[["self"]],["result",["json","buildererror"]]]],[11,"bump","","",19,[[["self"]]]],[11,"build_value","","",19,[[["self"]],["result",["json","buildererror"]]]],[11,"build_array","","",19,[[["self"]],["result",["json","buildererror"]]]],[11,"build_object","","",19,[[["self"]],["result",["json","buildererror"]]]],[11,"new","","Creates a new decoder instance for decoding the specified JSON value.",20,[[["json"]],["decoder"]]],[11,"pop","","",20,[[["self"]],["json"]]],[11,"read_nil","","",20,[[["self"]],["decoderesult"]]],[11,"read_usize","","",20,[[["self"]],["decoderesult",["usize"]]]],[11,"read_u8","","",20,[[["self"]],["decoderesult",["u8"]]]],[11,"read_u16","","",20,[[["self"]],["decoderesult",["u16"]]]],[11,"read_u32","","",20,[[["self"]],["decoderesult",["u32"]]]],[11,"read_u64","","",20,[[["self"]],["decoderesult",["u64"]]]],[11,"read_u128","","",20,[[["self"]],["decoderesult",["u128"]]]],[11,"read_isize","","",20,[[["self"]],["decoderesult",["isize"]]]],[11,"read_i8","","",20,[[["self"]],["decoderesult",["i8"]]]],[11,"read_i16","","",20,[[["self"]],["decoderesult",["i16"]]]],[11,"read_i32","","",20,[[["self"]],["decoderesult",["i32"]]]],[11,"read_i64","","",20,[[["self"]],["decoderesult",["i64"]]]],[11,"read_i128","","",20,[[["self"]],["decoderesult",["i128"]]]],[11,"read_f32","","",20,[[["self"]],["decoderesult",["f32"]]]],[11,"read_f64","","",20,[[["self"]],["decoderesult",["f64"]]]],[11,"read_bool","","",20,[[["self"]],["decoderesult",["bool"]]]],[11,"read_char","","",20,[[["self"]],["decoderesult",["char"]]]],[11,"read_str","","",20,[[["self"]],["decoderesult",["cow"]]]],[11,"read_enum","","",20,[[["self"],["str"],["f"]],["decoderesult"]]],[11,"read_enum_variant","","",20,N],[11,"read_enum_variant_arg","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_enum_struct_variant","","",20,N],[11,"read_enum_struct_variant_field","","",20,[[["self"],["str"],["usize"],["f"]],["decoderesult"]]],[11,"read_struct","","",20,[[["self"],["str"],["usize"],["f"]],["decoderesult"]]],[11,"read_struct_field","","",20,[[["self"],["str"],["usize"],["f"]],["decoderesult"]]],[11,"read_tuple","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_tuple_arg","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_tuple_struct","","",20,[[["self"],["str"],["usize"],["f"]],["decoderesult"]]],[11,"read_tuple_struct_arg","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_option","","",20,[[["self"],["f"]],["decoderesult"]]],[11,"read_seq","","",20,[[["self"],["f"]],["decoderesult"]]],[11,"read_seq_elt","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_map","","",20,[[["self"],["f"]],["decoderesult"]]],[11,"read_map_elt_key","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"read_map_elt_val","","",20,[[["self"],["usize"],["f"]],["decoderesult"]]],[11,"error","","",20,[[["self"],["str"]],["decodererror"]]],[11,"to_json","","",22,[[["self"]],["json"]]],[11,"write_str","","",21,[[["self"],["str"]],["result"]]],[11,"fmt","","Encodes a json value into a string",22,[[["self"],["formatter"]],["result"]]],[11,"fmt","","Encodes a json value into a string",12,[[["self"],["formatter"]],["result"]]],[11,"fmt","","Encodes a json value into a string",13,[[["self"],["formatter"]],["result"]]],[11,"indent","","Set the indentation level for the emitted JSON",14,[[["self"],["usize"]],["asprettyjson"]]],[11,"fmt","","Encodes a json value into a string",14,[[["self"],["formatter"]],["result"]]],[11,"from_str","","",22,[[["str"]],["result",["json","buildererror"]]]],[0,"opaque","serialize","",N,N],[3,"Encoder","serialize::opaque","",N,N],[12,"data","","",32,N],[3,"Decoder","","",N,N],[12,"data","","",33,N],[12,"position","","",33,N],[6,"EncodeResult","","",N,N],[11,"new","","",32,[[["vec",["u8"]]],["encoder"]]],[11,"into_inner","","",32,[[["self"]],["vec",["u8"]]]],[11,"emit_raw_bytes","","",32,N],[11,"emit_unit","","",32,[[["self"]],["encoderesult"]]],[11,"emit_usize","","",32,[[["self"],["usize"]],["encoderesult"]]],[11,"emit_u128","","",32,[[["self"],["u128"]],["encoderesult"]]],[11,"emit_u64","","",32,[[["self"],["u64"]],["encoderesult"]]],[11,"emit_u32","","",32,[[["self"],["u32"]],["encoderesult"]]],[11,"emit_u16","","",32,[[["self"],["u16"]],["encoderesult"]]],[11,"emit_u8","","",32,[[["self"],["u8"]],["encoderesult"]]],[11,"emit_isize","","",32,[[["self"],["isize"]],["encoderesult"]]],[11,"emit_i128","","",32,[[["self"],["i128"]],["encoderesult"]]],[11,"emit_i64","","",32,[[["self"],["i64"]],["encoderesult"]]],[11,"emit_i32","","",32,[[["self"],["i32"]],["encoderesult"]]],[11,"emit_i16","","",32,[[["self"],["i16"]],["encoderesult"]]],[11,"emit_i8","","",32,[[["self"],["i8"]],["encoderesult"]]],[11,"emit_bool","","",32,[[["self"],["bool"]],["encoderesult"]]],[11,"emit_f64","","",32,[[["self"],["f64"]],["encoderesult"]]],[11,"emit_f32","","",32,[[["self"],["f32"]],["encoderesult"]]],[11,"emit_char","","",32,[[["self"],["char"]],["encoderesult"]]],[11,"emit_str","","",32,[[["self"],["str"]],["encoderesult"]]],[11,"position","","",32,[[["self"]],["usize"]]],[11,"new","","",33,N],[11,"position","","",33,[[["self"]],["usize"]]],[11,"set_position","","",33,[[["self"],["usize"]]]],[11,"advance","","",33,[[["self"],["usize"]]]],[11,"read_raw_bytes","","",33,N],[11,"read_nil","","",33,[[["self"]],["result"]]],[11,"read_u128","","",33,[[["self"]],["result",["u128"]]]],[11,"read_u64","","",33,[[["self"]],["result",["u64"]]]],[11,"read_u32","","",33,[[["self"]],["result",["u32"]]]],[11,"read_u16","","",33,[[["self"]],["result",["u16"]]]],[11,"read_u8","","",33,[[["self"]],["result",["u8"]]]],[11,"read_usize","","",33,[[["self"]],["result",["usize"]]]],[11,"read_i128","","",33,[[["self"]],["result",["i128"]]]],[11,"read_i64","","",33,[[["self"]],["result",["i64"]]]],[11,"read_i32","","",33,[[["self"]],["result",["i32"]]]],[11,"read_i16","","",33,[[["self"]],["result",["i16"]]]],[11,"read_i8","","",33,[[["self"]],["result",["i8"]]]],[11,"read_isize","","",33,[[["self"]],["result",["isize"]]]],[11,"read_bool","","",33,[[["self"]],["result",["bool"]]]],[11,"read_f64","","",33,[[["self"]],["result",["f64"]]]],[11,"read_f32","","",33,[[["self"]],["result",["f32"]]]],[11,"read_char","","",33,[[["self"]],["result",["char"]]]],[11,"read_str","","",33,[[["self"]],["result",["cow"]]]],[11,"error","","",33,N],[0,"leb128","serialize","",N,N],[5,"write_to_vec","serialize::leb128","",N,[[["vec"],["u8"]]]],[5,"write_u16_leb128","","",N,[[["vec"],["u16"]]]],[5,"write_u32_leb128","","",N,[[["vec"],["u32"]]]],[5,"write_u64_leb128","","",N,[[["vec"],["u64"]]]],[5,"write_u128_leb128","","",N,[[["vec"],["u128"]]]],[5,"write_usize_leb128","","",N,[[["vec"],["usize"]]]],[5,"read_u16_leb128","","",N,N],[5,"read_u32_leb128","","",N,N],[5,"read_u64_leb128","","",N,N],[5,"read_u128_leb128","","",N,N],[5,"read_usize_leb128","","",N,N],[5,"write_signed_leb128_to","","encodes an integer using signed leb128 encoding and stores the result using a callback function.",N,[[["i128"],["w"]]]],[5,"write_signed_leb128","","",N,[[["vec"],["i128"]]]],[5,"read_signed_leb128","","",N,N],[17,"USIZE_LEB128_SIZE","","",N,N],[0,"rustc_serialize","serialize","",N,N],[8,"Decoder","","",N,N],[16,"Error","","",1,N],[10,"read_nil","","",1,[[["self"]],["result"]]],[10,"read_usize","","",1,[[["self"]],["result",["usize"]]]],[10,"read_u128","","",1,[[["self"]],["result",["u128"]]]],[10,"read_u64","","",1,[[["self"]],["result",["u64"]]]],[10,"read_u32","","",1,[[["self"]],["result",["u32"]]]],[10,"read_u16","","",1,[[["self"]],["result",["u16"]]]],[10,"read_u8","","",1,[[["self"]],["result",["u8"]]]],[10,"read_isize","","",1,[[["self"]],["result",["isize"]]]],[10,"read_i128","","",1,[[["self"]],["result",["i128"]]]],[10,"read_i64","","",1,[[["self"]],["result",["i64"]]]],[10,"read_i32","","",1,[[["self"]],["result",["i32"]]]],[10,"read_i16","","",1,[[["self"]],["result",["i16"]]]],[10,"read_i8","","",1,[[["self"]],["result",["i8"]]]],[10,"read_bool","","",1,[[["self"]],["result",["bool"]]]],[10,"read_f64","","",1,[[["self"]],["result",["f64"]]]],[10,"read_f32","","",1,[[["self"]],["result",["f32"]]]],[10,"read_char","","",1,[[["self"]],["result",["char"]]]],[10,"read_str","","",1,[[["self"]],["result",["cow"]]]],[11,"read_enum","serialize::serialize","",1,[[["self"],["str"],["f"]],["result"]]],[11,"read_enum_variant","","",1,N],[11,"read_enum_variant_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_enum_struct_variant","","",1,N],[11,"read_enum_struct_variant_field","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_struct","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_struct_field","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_tuple","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_tuple_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_tuple_struct","","",1,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"read_tuple_struct_arg","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_option","","",1,[[["self"],["f"]],["result"]]],[11,"read_seq","","",1,[[["self"],["f"]],["result"]]],[11,"read_seq_elt","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_map","","",1,[[["self"],["f"]],["result"]]],[11,"read_map_elt_key","","",1,[[["self"],["usize"],["f"]],["result"]]],[11,"read_map_elt_val","","",1,[[["self"],["usize"],["f"]],["result"]]],[10,"error","serialize","",1,N],[8,"Encoder","","",N,N],[16,"Error","","",0,N],[10,"emit_unit","","",0,[[["self"]],["result"]]],[10,"emit_usize","","",0,[[["self"],["usize"]],["result"]]],[10,"emit_u128","","",0,[[["self"],["u128"]],["result"]]],[10,"emit_u64","","",0,[[["self"],["u64"]],["result"]]],[10,"emit_u32","","",0,[[["self"],["u32"]],["result"]]],[10,"emit_u16","","",0,[[["self"],["u16"]],["result"]]],[10,"emit_u8","","",0,[[["self"],["u8"]],["result"]]],[10,"emit_isize","","",0,[[["self"],["isize"]],["result"]]],[10,"emit_i128","","",0,[[["self"],["i128"]],["result"]]],[10,"emit_i64","","",0,[[["self"],["i64"]],["result"]]],[10,"emit_i32","","",0,[[["self"],["i32"]],["result"]]],[10,"emit_i16","","",0,[[["self"],["i16"]],["result"]]],[10,"emit_i8","","",0,[[["self"],["i8"]],["result"]]],[10,"emit_bool","","",0,[[["self"],["bool"]],["result"]]],[10,"emit_f64","","",0,[[["self"],["f64"]],["result"]]],[10,"emit_f32","","",0,[[["self"],["f32"]],["result"]]],[10,"emit_char","","",0,[[["self"],["char"]],["result"]]],[10,"emit_str","","",0,[[["self"],["str"]],["result"]]],[11,"emit_enum","serialize::serialize","",0,[[["self"],["str"],["f"]],["result"]]],[11,"emit_enum_variant","","",0,[[["self"],["str"],["usize"],["usize"],["f"]],["result"]]],[11,"emit_enum_variant_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_enum_struct_variant","","",0,[[["self"],["str"],["usize"],["usize"],["f"]],["result"]]],[11,"emit_enum_struct_variant_field","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_struct","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_struct_field","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_tuple","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_tuple_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_tuple_struct","","",0,[[["self"],["str"],["usize"],["f"]],["result"]]],[11,"emit_tuple_struct_arg","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_option","","",0,[[["self"],["f"]],["result"]]],[11,"emit_option_none","","",0,[[["self"]],["result"]]],[11,"emit_option_some","","",0,[[["self"],["f"]],["result"]]],[11,"emit_seq","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_seq_elt","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map_elt_key","","",0,[[["self"],["usize"],["f"]],["result"]]],[11,"emit_map_elt_val","","",0,[[["self"],["usize"],["f"]],["result"]]],[8,"Decodable","serialize","",N,N],[10,"decode","","",3,[[["d"]],["result"]]],[8,"Encodable","","",N,N],[10,"encode","","",2,[[["self"],["s"]],["result"]]],[8,"SpecializationError","","Implement this trait on your `{Encodable,Decodable}::Error` types to override the default panic behavior for missing specializations.",N,N],[10,"not_found","","Create an error for a missing method specialization. Defaults to panicking with type, trait & method names. `S` is the encoder/decoder state type, `T` is the type being encoded/decoded, and the arguments are the names of the trait and method that should've been overridden.",4,[[["str"],["str"]],["self"]]],[8,"SpecializedEncoder","","Implement this trait on encoders, with `T` being the type you want to encode (employing `UseSpecializedEncodable`), using a strategy specific to the encoder.",N,N],[10,"specialized_encode","","Encode the value in a manner specific to this encoder state.",5,[[["self"],["t"]],["result"]]],[8,"SpecializedDecoder","","Implement this trait on decoders, with `T` being the type you want to decode (employing `UseSpecializedDecodable`), using a strategy specific to the decoder.",N,N],[10,"specialized_decode","","Decode a value in a manner specific to this decoder state.",6,[[["self"]],["result"]]],[8,"UseSpecializedEncodable","","Implement this trait on your type to get an `Encodable` implementation which goes through `SpecializedEncoder`.",N,N],[11,"default_encode","serialize::serialize","Defaults to returning an error (see `SpecializationError`).",7,[[["self"],["e"]],["result"]]],[8,"UseSpecializedDecodable","serialize","Implement this trait on your type to get an `Decodable` implementation which goes through `SpecializedDecoder`.",N,N],[11,"default_decode","serialize::serialize","Defaults to returning an error (see `SpecializationError`).",8,[[["d"]],["result"]]],[11,"to_owned","serialize::hex","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"to_string","","",9,[[["self"]],["string"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"from","serialize::json","",12,[[["t"]],["t"]]],[11,"to_string","","",12,[[["self"]],["string"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"from","","",13,[[["t"]],["t"]]],[11,"to_string","","",13,[[["self"]],["string"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"from","","",14,[[["t"]],["t"]]],[11,"to_string","","",14,[[["self"]],["string"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"from","","",18,[[["t"]],["t"]]],[11,"into_iter","","",18,[[["self"]],["i"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"to_owned","","",22,[[["self"]],["t"]]],[11,"clone_into","","",22,N],[11,"from","","",22,[[["t"]],["t"]]],[11,"to_string","","",22,[[["self"]],["string"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"to_owned","","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"to_string","","",23,[[["self"]],["string"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"to_owned","","",24,[[["self"]],["t"]]],[11,"clone_into","","",24,N],[11,"from","","",24,[[["t"]],["t"]]],[11,"to_string","","",24,[[["self"]],["string"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"to_owned","","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"to_string","","",25,[[["self"]],["string"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"to_owned","","",26,[[["self"]],["t"]]],[11,"clone_into","","",26,N],[11,"from","","",26,[[["t"]],["t"]]],[11,"to_string","","",26,[[["self"]],["string"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"to_owned","","",27,[[["self"]],["t"]]],[11,"clone_into","","",27,N],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"to_owned","","",29,[[["self"]],["t"]]],[11,"clone_into","","",29,N],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"to_owned","","",30,[[["self"]],["t"]]],[11,"clone_into","","",30,N],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"from","serialize::opaque","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"from","","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]]],"paths":[[8,"Encoder"],[8,"Decoder"],[8,"Encodable"],[8,"Decodable"],[8,"SpecializationError"],[8,"SpecializedEncoder"],[8,"SpecializedDecoder"],[8,"UseSpecializedEncodable"],[8,"UseSpecializedDecodable"],[4,"FromHexError"],[8,"ToHex"],[8,"FromHex"],[3,"PrettyJson"],[3,"AsJson"],[3,"AsPrettyJson"],[3,"Encoder"],[3,"PrettyEncoder"],[3,"Stack"],[3,"Parser"],[3,"Builder"],[3,"Decoder"],[3,"FormatShim"],[4,"Json"],[4,"ErrorCode"],[4,"ParserError"],[4,"DecoderError"],[4,"EncoderError"],[4,"JsonEvent"],[4,"ParserState"],[4,"StackElement"],[4,"InternalStackElement"],[8,"ToJson"],[3,"Encoder"],[3,"Decoder"]]};
searchIndex["syntax"]={"doc":"The Rust parser and macro expander.","items":[[6,"OneVector","syntax","",N,N],[3,"ThinVec","","A vector type optimized for cases where this size is usually 0 (c.f. `SmallVector`). The `Option<Box<..>>` wrapping allows us to represent a zero sized vector with `None`, which uses only a single (null) pointer.",N,N],[12,"0","","",0,N],[0,"edition","","",N,N],[4,"Edition","syntax::edition","The edition of the compiler (RFC 2052)",N,N],[13,"Edition2015","","The 2015 edition",1,N],[13,"Edition2018","","The 2018 edition",1,N],[17,"ALL_EDITIONS","","",N,N],[17,"EDITION_NAME_LIST","","",N,N],[17,"DEFAULT_EDITION","","",N,N],[0,"symbol","syntax","An \"interner\" is a data structure that associates values with usize tags and allows bidirectional lookup; i.e. given a value, one can easily find the type, and vice versa.",N,N],[3,"Ident","syntax::symbol","",N,N],[12,"name","","",2,N],[12,"span","","",2,N],[3,"Symbol","","A symbol is an interned or gensymed string.",N,N],[12,"0","","",3,N],[3,"Interner","","",N,N],[12,"arena","","",4,N],[12,"names","","",4,N],[12,"strings","","",4,N],[12,"gensyms","","",4,N],[0,"keywords","","",N,N],[3,"Keyword","syntax::symbol::keywords","",N,N],[12,"ident","","",5,N],[17,"Invalid","","",N,N],[17,"CrateRoot","","",N,N],[17,"DollarCrate","","",N,N],[17,"Underscore","","",N,N],[17,"As","","",N,N],[17,"Box","","",N,N],[17,"Break","","",N,N],[17,"Const","","",N,N],[17,"Continue","","",N,N],[17,"Crate","","",N,N],[17,"Else","","",N,N],[17,"Enum","","",N,N],[17,"Extern","","",N,N],[17,"False","","",N,N],[17,"Fn","","",N,N],[17,"For","","",N,N],[17,"If","","",N,N],[17,"Impl","","",N,N],[17,"In","","",N,N],[17,"Let","","",N,N],[17,"Loop","","",N,N],[17,"Match","","",N,N],[17,"Mod","","",N,N],[17,"Move","","",N,N],[17,"Mut","","",N,N],[17,"Pub","","",N,N],[17,"Ref","","",N,N],[17,"Return","","",N,N],[17,"SelfValue","","",N,N],[17,"SelfType","","",N,N],[17,"Static","","",N,N],[17,"Struct","","",N,N],[17,"Super","","",N,N],[17,"Trait","","",N,N],[17,"True","","",N,N],[17,"Type","","",N,N],[17,"Unsafe","","",N,N],[17,"Use","","",N,N],[17,"Where","","",N,N],[17,"While","","",N,N],[17,"Abstract","","",N,N],[17,"Become","","",N,N],[17,"Do","","",N,N],[17,"Final","","",N,N],[17,"Macro","","",N,N],[17,"Override","","",N,N],[17,"Priv","","",N,N],[17,"Typeof","","",N,N],[17,"Unsized","","",N,N],[17,"Virtual","","",N,N],[17,"Yield","","",N,N],[17,"Async","","",N,N],[17,"Try","","",N,N],[17,"UnderscoreLifetime","","",N,N],[17,"StaticLifetime","","",N,N],[17,"Auto","","",N,N],[17,"Catch","","",N,N],[17,"Default","","",N,N],[17,"Dyn","","",N,N],[17,"Union","","",N,N],[17,"Existential","","",N,N],[3,"LocalInternedString","syntax::symbol","Represents a string stored in the interner. Because the interner outlives any thread which uses this type, we can safely treat `string` which points to interner data, as an immortal string, as long as this type never crosses between threads.",N,N],[12,"string","","",6,N],[3,"InternedString","","Represents a string stored in the string interner",N,N],[12,"symbol","","",7,N],[3,"Globals","syntax","",N,N],[12,"used_attrs","","",8,N],[12,"known_attrs","","",8,N],[12,"syntax_pos_globals","","",8,N],[5,"with_globals","","",N,[[["f"]],["r"]]],[0,"diagnostics","","",N,N],[0,"macros","syntax::diagnostics","",N,N],[0,"plugin","","",N,N],[0,"emitter","syntax::diagnostics::plugin","",N,N],[8,"Emitter","syntax::diagnostics::plugin::emitter","Emitter trait for emitting errors.",N,N],[10,"emit","","Emit a structured diagnostic.",9,N],[11,"should_show_explain","","Check if should show explanations about \"rustc --explain\"",9,[[["self"]],["bool"]]],[17,"MAX_HIGHLIGHT_LINES","","maximum number of lines we will print for each error; arbitrary.",N,N],[17,"MAX_SUGGESTIONS","","maximum number of suggestions to be shown",N,N],[4,"ColorConfig","","",N,N],[13,"Auto","","",10,N],[13,"Always","","",10,N],[13,"Never","","",10,N],[3,"EmitterWriter","","",N,N],[12,"dst","","",11,N],[12,"cm","","",11,N],[12,"short_message","","",11,N],[12,"teach","","",11,N],[12,"ui_testing","","",11,N],[4,"Destination","","",N,N],[13,"Terminal","","",12,N],[13,"Buffered","","",12,N],[13,"Raw","","",12,N],[4,"WritableDst","","",N,N],[13,"Terminal","","",13,N],[13,"Buffered","","",13,N],[13,"Raw","","",13,N],[0,"registry","syntax::diagnostics::plugin","",N,N],[3,"Registry","syntax::diagnostics::plugin::registry","",N,N],[12,"descriptions","","",14,N],[4,"Applicability","syntax::diagnostics::plugin","",N,N],[13,"MachineApplicable","","",15,N],[13,"HasPlaceholders","","",15,N],[13,"MaybeIncorrect","","",15,N],[13,"Unspecified","","",15,N],[3,"CodeSuggestion","","",N,N],[12,"substitutions","","Each substitute can have multiple variants due to multiple applicable suggestions",16,N],[12,"msg","","",16,N],[12,"show_code_when_inline","","",16,N],[12,"applicability","","Whether or not the suggestion is approximate",16,N],[3,"Substitution","","See the docs on `CodeSuggestion::substitutions`",N,N],[12,"parts","","",17,N],[3,"SubstitutionPart","","",N,N],[12,"span","","",18,N],[12,"snippet","","",18,N],[6,"SourceMapperDyn","","",N,N],[8,"SourceMapper","","",N,N],[10,"lookup_char_pos","","",19,[[["self"],["bytepos"]],["loc"]]],[10,"span_to_lines","","",19,[[["self"],["span"]],["result",["filelines","spanlineserror"]]]],[10,"span_to_string","","",19,[[["self"],["span"]],["string"]]],[10,"span_to_filename","","",19,[[["self"],["span"]],["filename"]]],[10,"merge_spans","","",19,[[["self"],["span"],["span"]],["option",["span"]]]],[10,"call_span_if_macro","","",19,[[["self"],["span"]],["span"]]],[10,"ensure_source_file_source_present","","",19,[[["self"],["rc",["sourcefile"]]],["bool"]]],[10,"doctest_offset_line","","",19,[[["self"],["usize"]],["usize"]]],[3,"FatalError","","Used as a return value to signify a fatal error occurred. (It is also used as the argument to panic at the moment, but that will eventually not be true.)",N,N],[3,"FatalErrorMarker","","",N,N],[3,"ExplicitBug","","Signifies that the compiler died with an explicit call to `.bug` or `.span_bug` rather than a failed assertion, etc.",N,N],[3,"Handler","","A handler deals with errors; certain errors (fatal, bug, unimpl) may cause immediate exit, others log errors for later reporting.",N,N],[12,"flags","","",20,N],[12,"err_count","","",20,N],[12,"emitter","","",20,N],[12,"continue_after_error","","",20,N],[12,"delayed_span_bugs","","",20,N],[12,"taught_diagnostics","","",20,N],[12,"emitted_diagnostic_codes","","Used to suggest rustc --explain ",20,N],[12,"emitted_diagnostics","","",20,N],[17,"TRACK_DIAGNOSTICS","","",N,N],[3,"HandlerFlags","","",N,N],[12,"can_emit_warnings","","",21,N],[12,"treat_err_as_bug","","",21,N],[12,"report_delayed_bugs","","",21,N],[12,"external_macro_backtrace","","",21,N],[4,"Level","","",N,N],[13,"Bug","","",22,N],[13,"Fatal","","",22,N],[13,"PhaseFatal","","",22,N],[13,"Error","","",22,N],[13,"Warning","","",22,N],[13,"Note","","",22,N],[13,"Help","","",22,N],[13,"Cancelled","","",22,N],[13,"FailureNote","","",22,N],[3,"DiagnosticBuilder","","Used for emitting structured error messages and other diagnostic information.",N,N],[12,"handler","","",23,N],[12,"diagnostic","","",23,N],[12,"allow_suggestions","","",23,N],[3,"Diagnostic","","",N,N],[12,"level","","",24,N],[12,"message","","",24,N],[12,"code","","",24,N],[12,"span","","",24,N],[12,"children","","",24,N],[12,"suggestions","","",24,N],[4,"DiagnosticId","","",N,N],[13,"Error","","",25,N],[13,"Lint","","",25,N],[3,"DiagnosticStyledString","","",N,N],[12,"0","","",26,N],[3,"SubDiagnostic","","For example a note attached to an error.",N,N],[12,"level","","",27,N],[12,"message","","",27,N],[12,"span","","",27,N],[12,"render_span","","",27,N],[3,"ErrorInfo","","Error information type.",N,N],[12,"description","","",28,N],[12,"use_site","","",28,N],[5,"expand_diagnostic_used","","",N,N],[5,"expand_register_diagnostic","","",N,N],[5,"expand_build_diagnostic_array","","",N,N],[6,"ErrorMap","","Mapping from error codes to metadata.",N,N],[17,"MAX_DESCRIPTION_WIDTH","","",N,N],[0,"metadata","syntax::diagnostics","This module contains utilities for outputting metadata for diagnostic errors.",N,N],[3,"ErrorMetadata","syntax::diagnostics::metadata","JSON encodable/decodable version of `ErrorInfo`.",N,N],[12,"description","","",29,N],[12,"use_site","","",29,N],[3,"ErrorLocation","","JSON encodable error location type with filename and line number.",N,N],[12,"filename","","",30,N],[12,"line","","",30,N],[5,"get_metadata_dir","","Get the directory where metadata for a given `prefix` should be stored.",N,[[["str"]],["pathbuf"]]],[5,"get_metadata_path","","Map `name` to a path in the given directory: /.json",N,[[["pathbuf"],["str"]],["pathbuf"]]],[5,"output_metadata","","Write metadata for the errors in `err_map` to disk, to a file corresponding to `prefix/name`.",N,[[["extctxt"],["str"],["str"],["errormap"]],["result",["box"]]]],[6,"ErrorMetadataMap","","Mapping from error codes to metadata that can be (de)serialized.",N,N],[11,"eq","","",29,[[["self"],["errormetadata"]],["bool"]]],[11,"ne","","",29,[[["self"],["errormetadata"]],["bool"]]],[11,"decode","","",29,[[["__d"]],["result",["errormetadata"]]]],[11,"encode","","",29,[[["self"],["__s"]],["result"]]],[11,"eq","","",30,[[["self"],["errorlocation"]],["bool"]]],[11,"ne","","",30,[[["self"],["errorlocation"]],["bool"]]],[11,"decode","","",30,[[["__d"]],["result",["errorlocation"]]]],[11,"encode","","",30,[[["self"],["__s"]],["result"]]],[11,"from_span","","Create an error location from a span.",30,[[["extctxt"],["span"]],["errorlocation"]]],[0,"diagnostic_list","syntax","",N,N],[0,"__register_diagnostic_E0178","syntax::diagnostic_list","",N,N],[0,"__register_diagnostic_E0536","","",N,N],[0,"__register_diagnostic_E0537","","",N,N],[0,"__register_diagnostic_E0538","","",N,N],[0,"__register_diagnostic_E0541","","",N,N],[0,"__register_diagnostic_E0552","","",N,N],[0,"__register_diagnostic_E0554","","",N,N],[0,"__register_diagnostic_E0557","","",N,N],[0,"__register_diagnostic_E0565","","",N,N],[0,"__register_diagnostic_E0583","","",N,N],[0,"__register_diagnostic_E0585","","",N,N],[0,"__register_diagnostic_E0586","","",N,N],[0,"__register_diagnostic_E0589","","",N,N],[0,"__register_diagnostic_E0658","","",N,N],[0,"__register_diagnostic_E0633","","",N,N],[0,"__register_diagnostic_E0705","","",N,N],[0,"__register_diagnostic_E0539","","",N,N],[0,"__register_diagnostic_E0540","","",N,N],[0,"__register_diagnostic_E0542","","",N,N],[0,"__register_diagnostic_E0543","","",N,N],[0,"__register_diagnostic_E0544","","",N,N],[0,"__register_diagnostic_E0545","","",N,N],[0,"__register_diagnostic_E0546","","",N,N],[0,"__register_diagnostic_E0547","","",N,N],[0,"__register_diagnostic_E0548","","",N,N],[0,"__register_diagnostic_E0549","","",N,N],[0,"__register_diagnostic_E0550","","",N,N],[0,"__register_diagnostic_E0551","","",N,N],[0,"__register_diagnostic_E0553","","",N,N],[0,"__register_diagnostic_E0555","","",N,N],[0,"__register_diagnostic_E0556","","",N,N],[0,"__register_diagnostic_E0584","","",N,N],[0,"__register_diagnostic_E0629","","",N,N],[0,"__register_diagnostic_E0630","","",N,N],[0,"__register_diagnostic_E0693","","",N,N],[0,"__register_diagnostic_E0694","","",N,N],[0,"__register_diagnostic_E0703","","",N,N],[0,"__register_diagnostic_E0704","","",N,N],[0,"util","syntax","",N,N],[3,"RcSlice","syntax::util","",N,N],[12,"data","","",31,N],[12,"offset","","",31,N],[12,"len","","",31,N],[3,"RcVec","","",N,N],[12,"data","","",32,N],[12,"offset","","",32,N],[12,"len","","",32,N],[0,"lev_distance","","",N,N],[5,"lev_distance","syntax::util::lev_distance","Find the Levenshtein distance between two strings",N,[[["str"],["str"]],["usize"]]],[5,"find_best_match_for_name","","Find the best match for a given word in the given iterator",N,[[["t"],["str"],["option",["usize"]]],["option",["symbol"]]]],[0,"node_count","syntax::util","",N,N],[3,"NodeCounter","syntax::util::node_count","",N,N],[12,"count","","",33,N],[11,"new","","",33,[[],["nodecounter"]]],[11,"visit_ident","","",33,[[["self"],["ident"]]]],[11,"visit_mod","","",33,N],[11,"visit_foreign_item","","",33,[[["self"],["foreignitem"]]]],[11,"visit_item","","",33,[[["self"],["item"]]]],[11,"visit_local","","",33,[[["self"],["local"]]]],[11,"visit_block","","",33,[[["self"],["block"]]]],[11,"visit_stmt","","",33,[[["self"],["stmt"]]]],[11,"visit_arm","","",33,[[["self"],["arm"]]]],[11,"visit_pat","","",33,[[["self"],["pat"]]]],[11,"visit_expr","","",33,[[["self"],["expr"]]]],[11,"visit_ty","","",33,[[["self"],["ty"]]]],[11,"visit_generic_param","","",33,[[["self"],["genericparam"]]]],[11,"visit_generics","","",33,[[["self"],["generics"]]]],[11,"visit_fn","","",33,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_trait_item","","",33,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",33,[[["self"],["implitem"]]]],[11,"visit_trait_ref","","",33,[[["self"],["traitref"]]]],[11,"visit_param_bound","","",33,[[["self"],["genericbound"]]]],[11,"visit_poly_trait_ref","","",33,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_variant_data","","",33,[[["self"],["variantdata"],["ident"],["generics"],["nodeid"],["span"]]]],[11,"visit_struct_field","","",33,[[["self"],["structfield"]]]],[11,"visit_enum_def","","",33,[[["self"],["enumdef"],["generics"],["nodeid"],["span"]]]],[11,"visit_variant","","",33,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_lifetime","","",33,[[["self"],["lifetime"]]]],[11,"visit_mac","","",33,[[["self"],["mac"]]]],[11,"visit_path","","",33,[[["self"],["path"],["nodeid"]]]],[11,"visit_use_tree","","",33,[[["self"],["usetree"],["nodeid"],["bool"]]]],[11,"visit_generic_args","","",33,[[["self"],["span"],["genericargs"]]]],[11,"visit_assoc_type_binding","","",33,[[["self"],["typebinding"]]]],[11,"visit_attribute","","",33,[[["self"],["attribute"]]]],[0,"parser","syntax::util","",N,N],[4,"AssocOp","syntax::util::parser","Associative operator with precedence.",N,N],[13,"Add","","`+`",34,N],[13,"Subtract","","`-`",34,N],[13,"Multiply","","`*`",34,N],[13,"Divide","","`/`",34,N],[13,"Modulus","","`%`",34,N],[13,"LAnd","","`&&`",34,N],[13,"LOr","","`||`",34,N],[13,"BitXor","","`^`",34,N],[13,"BitAnd","","`&`",34,N],[13,"BitOr","","`|`",34,N],[13,"ShiftLeft","","`<<`",34,N],[13,"ShiftRight","","`>>`",34,N],[13,"Equal","","`==`",34,N],[13,"Less","","`<`",34,N],[13,"LessEqual","","`<=`",34,N],[13,"NotEqual","","`!=`",34,N],[13,"Greater","","`>`",34,N],[13,"GreaterEqual","","`>=`",34,N],[13,"Assign","","`=`",34,N],[13,"ObsoleteInPlace","","`<-`",34,N],[13,"AssignOp","","`?=` where ? is one of the BinOpToken",34,N],[13,"As","","`as`",34,N],[13,"DotDot","","`..` range",34,N],[13,"DotDotEq","","`..=` range",34,N],[13,"Colon","","`:`",34,N],[4,"Fixity","","",N,N],[13,"Left","","The operator is left-associative",35,N],[13,"Right","","The operator is right-associative",35,N],[13,"None","","The operator is not associative",35,N],[4,"ExprPrecedence","","",N,N],[13,"Closure","","",36,N],[13,"Break","","",36,N],[13,"Continue","","",36,N],[13,"Ret","","",36,N],[13,"Yield","","",36,N],[13,"Range","","",36,N],[13,"Binary","","",36,N],[13,"ObsoleteInPlace","","",36,N],[13,"Cast","","",36,N],[13,"Type","","",36,N],[13,"Assign","","",36,N],[13,"AssignOp","","",36,N],[13,"Box","","",36,N],[13,"AddrOf","","",36,N],[13,"Unary","","",36,N],[13,"Call","","",36,N],[13,"MethodCall","","",36,N],[13,"Field","","",36,N],[13,"Index","","",36,N],[13,"Try","","",36,N],[13,"InlineAsm","","",36,N],[13,"Mac","","",36,N],[13,"Array","","",36,N],[13,"Repeat","","",36,N],[13,"Tup","","",36,N],[13,"Lit","","",36,N],[13,"Path","","",36,N],[13,"Paren","","",36,N],[13,"If","","",36,N],[13,"IfLet","","",36,N],[13,"While","","",36,N],[13,"WhileLet","","",36,N],[13,"ForLoop","","",36,N],[13,"Loop","","",36,N],[13,"Match","","",36,N],[13,"Block","","",36,N],[13,"TryBlock","","",36,N],[13,"Struct","","",36,N],[13,"Async","","",36,N],[5,"contains_exterior_struct_lit","","Expressions that syntactically contain an \"exterior\" struct literal i.e. not surrounded by any parens or other delimiters, e.g. `X { y: 1 }`, `X { y: 1 }.method()`, `foo == X { y: 1 }` and `X { y: 1 } == foo` all do, but `(X { y: 1 }) == foo` does not.",N,[[["expr"]],["bool"]]],[17,"PREC_RESET","","",N,N],[17,"PREC_CLOSURE","","",N,N],[17,"PREC_JUMP","","",N,N],[17,"PREC_RANGE","","",N,N],[17,"PREC_PREFIX","","",N,N],[17,"PREC_POSTFIX","","",N,N],[17,"PREC_PAREN","","",N,N],[17,"PREC_FORCE_PAREN","","",N,N],[11,"eq","","",34,[[["self"],["assocop"]],["bool"]]],[11,"ne","","",34,[[["self"],["assocop"]],["bool"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"eq","","",35,[[["self"],["fixity"]],["bool"]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"from_token","","Create a new AssocOP from a token",34,[[["token"]],["option",["assocop"]]]],[11,"from_ast_binop","","Create a new AssocOp from ast::BinOpKind.",34,[[["binopkind"]],["self"]]],[11,"precedence","","Gets the precedence of this operator",34,[[["self"]],["usize"]]],[11,"fixity","","Gets the fixity of this operator",34,[[["self"]],["fixity"]]],[11,"is_comparison","","",34,[[["self"]],["bool"]]],[11,"is_assign_like","","",34,[[["self"]],["bool"]]],[11,"to_ast_binop","","",34,[[["self"]],["option",["binopkind"]]]],[11,"fmt","","",36,[[["self"],["formatter"]],["result"]]],[11,"clone","","",36,[[["self"]],["exprprecedence"]]],[11,"order","","",36,[[["self"]],["i8"]]],[0,"move_map","syntax::util","",N,N],[8,"MoveMap","syntax::util::move_map","",N,N],[11,"move_map","","",37,[[["self"],["f"]],["self"]]],[10,"move_flat_map","","",37,[[["self"],["f"]],["self"]]],[11,"move_flat_map","","",38,[[["self"],["f"]],["self"]]],[0,"rc_slice","syntax::util","",N,N],[3,"RcSlice","syntax::util::rc_slice","",N,N],[12,"data","","",31,N],[12,"offset","","",31,N],[12,"len","","",31,N],[11,"clone","syntax::util","",31,[[["self"]],["rcslice"]]],[11,"new","","",31,[[["vec"]],["self"]]],[11,"sub_slice","","",31,[[["self"],["range",["usize"]]],["self"]]],[11,"deref","","",31,N],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"hash_stable","","",31,[[["self"],["ctx"],["stablehasher"]]]],[0,"rc_vec","","",N,N],[3,"RcVec","syntax::util::rc_vec","",N,N],[12,"data","","",32,N],[12,"offset","","",32,N],[12,"len","","",32,N],[11,"clone","syntax::util","",32,[[["self"]],["rcvec"]]],[11,"new","","",32,[[["vec"]],["self"]]],[11,"new_preserving_capacity","","",32,[[["vec"]],["self"]]],[11,"sub_slice","","",32,[[["self"],["range",["usize"]]],["self"]]],[11,"try_unwrap","","If this RcVec has exactly one strong reference, returns ownership of the underlying vector. Otherwise returns self unmodified.",32,[[["self"]],["result",["vec"]]]],[11,"deref","","",32,N],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[11,"hash_stable","","",32,[[["self"],["ctx"],["stablehasher"]]]],[0,"json","syntax","A JSON emitter for errors.",N,N],[3,"JsonEmitter","syntax::json","",N,N],[12,"dst","","",39,N],[12,"registry","","",39,N],[12,"cm","","",39,N],[12,"pretty","","",39,N],[12,"ui_testing","","",39,N],[3,"Diagnostic","","",N,N],[12,"message","","The primary error message.",40,N],[12,"code","","",40,N],[12,"level","","\"error: internal compiler error\", \"error\", \"warning\", \"note\", \"help\".",40,N],[12,"spans","","",40,N],[12,"children","","Associated diagnostic messages.",40,N],[12,"rendered","","The message as rustc would render it.",40,N],[3,"DiagnosticSpan","","",N,N],[12,"file_name","","",41,N],[12,"byte_start","","",41,N],[12,"byte_end","","",41,N],[12,"line_start","","1-based.",41,N],[12,"line_end","","",41,N],[12,"column_start","","1-based, character offset.",41,N],[12,"column_end","","",41,N],[12,"is_primary","","Is this a \"primary\" span -- meaning the point, or one of the points, where the error occurred?",41,N],[12,"text","","Source text from the start of line_start to the end of line_end.",41,N],[12,"label","","Label that should be placed at this location (if any)",41,N],[12,"suggested_replacement","","If we are suggesting a replacement, this will contain text that should be sliced in atop this span.",41,N],[12,"suggestion_applicability","","If the suggestion is approximate",41,N],[12,"expansion","","Macro invocations that created the code at this span, if any.",41,N],[3,"DiagnosticSpanLine","","",N,N],[12,"text","","",42,N],[12,"highlight_start","","1-based, character offset in self.text.",42,N],[12,"highlight_end","","",42,N],[3,"DiagnosticSpanMacroExpansion","","",N,N],[12,"span","","span where macro was applied to generate this code; note that this may itself derive from a macro (if `span.expansion.is_some()`)",43,N],[12,"macro_decl_name","","name of macro that was applied (e.g., \"foo!\" or \"#[derive(Eq)]\")",43,N],[12,"def_site_span","","span where macro was defined (if known)",43,N],[3,"DiagnosticCode","","",N,N],[12,"code","","The code itself.",44,N],[12,"explanation","","An explanation for the code.",44,N],[11,"stderr","","",39,[[["option",["registry"]],["lrc",["sourcemap"]],["bool"]],["jsonemitter"]]],[11,"basic","","",39,[[["bool"]],["jsonemitter"]]],[11,"new","","",39,[[["box",["write"]],["option",["registry"]],["lrc",["sourcemap"]],["bool"]],["jsonemitter"]]],[11,"ui_testing","","",39,[[["self"],["bool"]],["self"]]],[11,"emit","","",39,[[["self"],["diagnosticbuilder"]]]],[11,"encode","","",40,[[["self"],["__s"]],["result"]]],[11,"encode","","",41,[[["self"],["__s"]],["result"]]],[11,"encode","","",42,[[["self"],["__s"]],["result"]]],[11,"encode","","",43,[[["self"],["__s"]],["result"]]],[11,"encode","","",44,[[["self"],["__s"]],["result"]]],[11,"from_diagnostic_builder","","",40,[[["diagnosticbuilder"],["jsonemitter"]],["diagnostic"]]],[11,"from_sub_diagnostic","","",40,[[["subdiagnostic"],["jsonemitter"]],["diagnostic"]]],[11,"from_span_label","","",41,[[["spanlabel"],["option"],["jsonemitter"]],["diagnosticspan"]]],[11,"from_span_etc","","",41,[[["span"],["bool"],["option",["string"]],["option"],["jsonemitter"]],["diagnosticspan"]]],[11,"from_span_full","","",41,[[["span"],["bool"],["option",["string"]],["option"],["intoiter",["macrobacktrace"]],["jsonemitter"]],["diagnosticspan"]]],[11,"from_multispan","","",41,[[["multispan"],["jsonemitter"]],["vec",["diagnosticspan"]]]],[11,"from_suggestion","","",41,[[["codesuggestion"],["jsonemitter"]],["vec",["diagnosticspan"]]]],[11,"line_from_source_file","","",42,[[["sourcefile"],["usize"],["usize"],["usize"]],["diagnosticspanline"]]],[11,"from_span","","Create a list of DiagnosticSpanLines from span - each line with any part of `span` gets a DiagnosticSpanLine, with the highlight indicating the `span` within the line.",42,[[["span"],["jsonemitter"]],["vec",["diagnosticspanline"]]]],[11,"map_opt_string","","",44,[[["option",["diagnosticid"]],["jsonemitter"]],["option",["diagnosticcode"]]]],[0,"syntax","syntax","",N,N],[0,"ast","","",N,N],[3,"Ident","syntax::ast","",N,N],[12,"name","","",2,N],[12,"span","","",2,N],[3,"Name","","A symbol is an interned or gensymed string.",N,N],[12,"0","","",3,N],[4,"FloatTy","","",N,N],[13,"F32","","",45,N],[13,"F64","","",45,N],[3,"Label","","",N,N],[12,"ident","","",46,N],[3,"Lifetime","","",N,N],[12,"id","","",47,N],[12,"ident","","",47,N],[3,"Path","","A \"Path\" is essentially Rust's notion of a name.",N,N],[12,"span","","",48,N],[12,"segments","","The segments in the path: the things separated by `::`. Global paths begin with `keywords::CrateRoot`.",48,N],[3,"PathSegment","","A segment of a path: an identifier, an optional lifetime, and a set of types.",N,N],[12,"ident","","The identifier portion of this path segment.",49,N],[12,"args","","Type/lifetime parameters attached to this path. They come in two flavors: `Path<A,B,C>` and `Path(A,B) -> C`. `None` means that no parameter list is supplied (`Path`), `Some` means that parameter list is supplied (`Path<X, Y>`) but it can be empty (`Path<>`). `P` is used as a size optimization for the common case with no parameters.",49,N],[3,"AngleBracketedArgs","","A path like `Foo<'a, T>`",N,N],[12,"span","","Overall span",50,N],[12,"args","","The arguments for this path segment.",50,N],[12,"bindings","","Bindings (equality constraints) on associated types, if present.",50,N],[3,"ParenthesisedArgs","","A path like `Foo(A,B) -> C`",N,N],[12,"span","","Overall span",51,N],[12,"inputs","","`(A,B)`",51,N],[12,"output","","`C`",51,N],[3,"NodeId","","",N,N],[12,"0","","",52,N],[3,"GenericParam","","",N,N],[12,"id","","",53,N],[12,"ident","","",53,N],[12,"attrs","","",53,N],[12,"bounds","","",53,N],[12,"kind","","",53,N],[3,"Generics","","Represents lifetime, type and const parameters attached to a declaration of a function, enum, trait, etc.",N,N],[12,"params","","",54,N],[12,"where_clause","","",54,N],[12,"span","","",54,N],[3,"WhereClause","","A `where` clause in a definition",N,N],[12,"id","","",55,N],[12,"predicates","","",55,N],[12,"span","","",55,N],[3,"WhereBoundPredicate","","A type bound.",N,N],[12,"span","","",56,N],[12,"bound_generic_params","","Any generics from a `for` binding",56,N],[12,"bounded_ty","","The type being bounded",56,N],[12,"bounds","","Trait and lifetime bounds (`Clone+Send+'static`)",56,N],[3,"WhereRegionPredicate","","A lifetime predicate.",N,N],[12,"span","","",57,N],[12,"lifetime","","",57,N],[12,"bounds","","",57,N],[3,"WhereEqPredicate","","An equality predicate (unsupported).",N,N],[12,"id","","",58,N],[12,"span","","",58,N],[12,"lhs_ty","","",58,N],[12,"rhs_ty","","",58,N],[3,"Crate","","",N,N],[12,"module","","",59,N],[12,"attrs","","",59,N],[12,"span","","",59,N],[3,"MetaItem","","A spanned compile-time attribute item.",N,N],[12,"ident","","",60,N],[12,"node","","",60,N],[12,"span","","",60,N],[3,"Block","","A Block (`{ .. }`).",N,N],[12,"stmts","","Statements in a block",61,N],[12,"id","","",61,N],[12,"rules","","Distinguishes between `unsafe { ... }` and `{ ... }`",61,N],[12,"span","","",61,N],[12,"recovered","","",61,N],[3,"Pat","","",N,N],[12,"id","","",62,N],[12,"node","","",62,N],[12,"span","","",62,N],[3,"FieldPat","","A single field in a struct pattern",N,N],[12,"ident","","The identifier for the field",63,N],[12,"pat","","The pattern the field is destructured to",63,N],[12,"is_shorthand","","",63,N],[12,"attrs","","",63,N],[3,"Stmt","","A statement",N,N],[12,"id","","",64,N],[12,"node","","",64,N],[12,"span","","",64,N],[3,"Local","","Local represents a `let` statement, e.g., `let <pat>:<ty> = <expr>;`",N,N],[12,"pat","","",65,N],[12,"ty","","",65,N],[12,"init","","Initializer expression to set the value, if any",65,N],[12,"id","","",65,N],[12,"span","","",65,N],[12,"attrs","","",65,N],[3,"Arm","","An arm of a 'match'.",N,N],[12,"attrs","","",66,N],[12,"pats","","",66,N],[12,"guard","","",66,N],[12,"body","","",66,N],[3,"Field","","",N,N],[12,"ident","","",67,N],[12,"expr","","",67,N],[12,"span","","",67,N],[12,"is_shorthand","","",67,N],[12,"attrs","","",67,N],[3,"AnonConst","","A constant (expression) that's not an item or associated item, but needs its own `DefId` for type-checking, const-eval, etc. These are usually found nested inside types (e.g. array lengths) or expressions (e.g. repeat counts), and also used to define explicit discriminant values for enum variants.",N,N],[12,"id","","",68,N],[12,"value","","",68,N],[3,"Expr","","An expression",N,N],[12,"id","","",69,N],[12,"node","","",69,N],[12,"span","","",69,N],[12,"attrs","","",69,N],[3,"QSelf","","The explicit Self type in a \"qualified path\". The actual path, including the trait and the associated item, is stored separately. `position` represents the index of the associated item qualified with this Self type.",N,N],[12,"ty","","",70,N],[12,"path_span","","The span of `a::b::Trait` in a path like `<Vec<T> as a::b::Trait>::AssociatedItem`; in the case where `position == 0`, this is an empty span.",70,N],[12,"position","","",70,N],[3,"Mac_","","Represents a macro invocation. The Path indicates which macro is being invoked, and the vector of token-trees contains the source of the macro invocation.",N,N],[12,"path","","",71,N],[12,"delim","","",71,N],[12,"tts","","",71,N],[3,"MacroDef","","",N,N],[12,"tokens","","",72,N],[12,"legacy","","",72,N],[3,"MutTy","","",N,N],[12,"ty","","",73,N],[12,"mutbl","","",73,N],[3,"MethodSig","","Represents a method's signature in a trait declaration, or in an implementation.",N,N],[12,"header","","",74,N],[12,"decl","","",74,N],[3,"TraitItem","","Represents an item declaration within a trait declaration, possibly including a default implementation. A trait item is either required (meaning it doesn't have an implementation, just a signature) or provided (meaning it has a default implementation).",N,N],[12,"id","","",75,N],[12,"ident","","",75,N],[12,"attrs","","",75,N],[12,"generics","","",75,N],[12,"node","","",75,N],[12,"span","","",75,N],[12,"tokens","","See `Item::tokens` for what this is",75,N],[3,"ImplItem","","",N,N],[12,"id","","",76,N],[12,"ident","","",76,N],[12,"vis","","",76,N],[12,"defaultness","","",76,N],[12,"attrs","","",76,N],[12,"generics","","",76,N],[12,"node","","",76,N],[12,"span","","",76,N],[12,"tokens","","See `Item::tokens` for what this is",76,N],[3,"TypeBinding","","",N,N],[12,"id","","",77,N],[12,"ident","","",77,N],[12,"ty","","",77,N],[12,"span","","",77,N],[3,"Ty","","",N,N],[12,"id","","",78,N],[12,"node","","",78,N],[12,"span","","",78,N],[3,"BareFnTy","","",N,N],[12,"unsafety","","",79,N],[12,"abi","","",79,N],[12,"generic_params","","",79,N],[12,"decl","","",79,N],[3,"InlineAsmOutput","","Inline assembly.",N,N],[12,"constraint","","",80,N],[12,"expr","","",80,N],[12,"is_rw","","",80,N],[12,"is_indirect","","",80,N],[3,"InlineAsm","","Inline assembly.",N,N],[12,"asm","","",81,N],[12,"asm_str_style","","",81,N],[12,"outputs","","",81,N],[12,"inputs","","",81,N],[12,"clobbers","","",81,N],[12,"volatile","","",81,N],[12,"alignstack","","",81,N],[12,"dialect","","",81,N],[12,"ctxt","","",81,N],[3,"Arg","","An argument in a function header.",N,N],[12,"ty","","",82,N],[12,"pat","","",82,N],[12,"id","","",82,N],[3,"FnDecl","","Header (not the body) of a function declaration.",N,N],[12,"inputs","","",83,N],[12,"output","","",83,N],[12,"variadic","","",83,N],[3,"Mod","","Module declaration.",N,N],[12,"inner","","A span from the first token past `{` to the last token until `}`. For `mod foo;`, the inner span ranges from the first token to the last token in the external file.",84,N],[12,"items","","",84,N],[3,"ForeignMod","","Foreign module declaration.",N,N],[12,"abi","","",85,N],[12,"items","","",85,N],[3,"GlobalAsm","","Global inline assembly",N,N],[12,"asm","","",86,N],[12,"ctxt","","",86,N],[3,"EnumDef","","",N,N],[12,"variants","","",87,N],[3,"Variant_","","",N,N],[12,"ident","","",88,N],[12,"attrs","","",88,N],[12,"data","","",88,N],[12,"disr_expr","","Explicit discriminant, e.g. `Foo = 1`",88,N],[3,"UseTree","","A tree of paths sharing common prefixes. Used in `use` items both at top-level and inside of braces in import groups.",N,N],[12,"prefix","","",89,N],[12,"kind","","",89,N],[12,"span","","",89,N],[3,"AttrId","","",N,N],[12,"0","","",90,N],[3,"Attribute","","Meta-data associated with an item Doc-comments are promoted to attributes that have is_sugared_doc = true",N,N],[12,"id","","",91,N],[12,"style","","",91,N],[12,"path","","",91,N],[12,"tokens","","",91,N],[12,"is_sugared_doc","","",91,N],[12,"span","","",91,N],[3,"TraitRef","","TraitRef's appear in impls.",N,N],[12,"path","","",92,N],[12,"ref_id","","",92,N],[3,"PolyTraitRef","","",N,N],[12,"bound_generic_params","","The `'a` in `<'a> Foo<&'a T>`",93,N],[12,"trait_ref","","The `Foo<&'a T>` in `<'a> Foo<&'a T>`",93,N],[12,"span","","",93,N],[3,"StructField","","Field of a struct.",N,N],[12,"span","","",94,N],[12,"ident","","",94,N],[12,"vis","","",94,N],[12,"id","","",94,N],[12,"ty","","",94,N],[12,"attrs","","",94,N],[3,"Item","","An item",N,N],[12,"ident","","",95,N],[12,"attrs","","",95,N],[12,"id","","",95,N],[12,"node","","",95,N],[12,"vis","","",95,N],[12,"span","","",95,N],[12,"tokens","","Original tokens this item was parsed from. This isn't necessarily available for all items, although over time more and more items should have this be `Some`. Right now this is primarily used for procedural macros, notably custom attributes.",95,N],[3,"FnHeader","","A function header",N,N],[12,"unsafety","","",96,N],[12,"asyncness","","",96,N],[12,"constness","","",96,N],[12,"abi","","",96,N],[3,"ForeignItem","","",N,N],[12,"ident","","",97,N],[12,"attrs","","",97,N],[12,"node","","",97,N],[12,"id","","",97,N],[12,"span","","",97,N],[12,"vis","","",97,N],[4,"GenericArgs","","Arguments of a path segment.",N,N],[13,"AngleBracketed","","The `<'a, A,B,C>` in `foo::bar::baz::<'a, A,B,C>`",98,N],[13,"Parenthesized","","The `(A,B)` and `C` in `Foo(A,B) -> C`",98,N],[4,"GenericArg","","",N,N],[13,"Lifetime","","",99,N],[13,"Type","","",99,N],[4,"TraitBoundModifier","","A modifier on a bound, currently this is only used for `?Sized`, where the modifier is `Maybe`. Negative bounds should also be handled here.",N,N],[13,"None","","",100,N],[13,"Maybe","","",100,N],[4,"GenericBound","","The AST represents all type param bounds as types. typeck::collect::compute_bounds matches these against the \"special\" built-in traits (see middle::lang_items) and detects Copy, Send and Sync.",N,N],[13,"Trait","","",101,N],[13,"Outlives","","",101,N],[4,"GenericParamKind","","",N,N],[13,"Lifetime","","A lifetime definition, e.g. `'a: 'b+'c+'d`.",102,N],[13,"Type","","",102,N],[12,"default","syntax::ast::GenericParamKind","",102,N],[4,"WherePredicate","syntax::ast","A single predicate in a `where` clause",N,N],[13,"BoundPredicate","","A type binding, e.g. `for<'c> Foo: Send+Clone+'c`",103,N],[13,"RegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",103,N],[13,"EqPredicate","","An equality predicate (unsupported)",103,N],[4,"NestedMetaItemKind","","Possible values inside of compile-time attribute lists.",N,N],[13,"MetaItem","","A full MetaItem, for recursive meta items.",104,N],[13,"Literal","","A literal.",104,N],[4,"MetaItemKind","","A compile-time attribute item.",N,N],[13,"Word","","Word meta item.",105,N],[13,"List","","List meta item.",105,N],[13,"NameValue","","Name value meta item.",105,N],[4,"BindingMode","","",N,N],[13,"ByRef","","",106,N],[13,"ByValue","","",106,N],[4,"RangeEnd","","",N,N],[13,"Included","","",107,N],[13,"Excluded","","",107,N],[4,"RangeSyntax","","",N,N],[13,"DotDotDot","","",108,N],[13,"DotDotEq","","",108,N],[4,"PatKind","","",N,N],[13,"Wild","","Represents a wildcard pattern (`_`)",109,N],[13,"Ident","","A `PatKind::Ident` may either be a new bound variable (`ref mut binding @ OPT_SUBPATTERN`), or a unit struct/variant pattern, or a const pattern (in the last two cases the third field must be `None`). Disambiguation cannot be done with parser alone, so it happens during name resolution.",109,N],[13,"Struct","","A struct or struct variant pattern, e.g. `Variant {x, y, ..}`. The `bool` is `true` in the presence of a `..`.",109,N],[13,"TupleStruct","","A tuple struct/variant pattern `Variant(x, y, .., z)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",109,N],[13,"Path","","A possibly qualified path pattern. Unqualified path patterns `A::B::C` can legally refer to variants, structs, constants or associated constants. Qualified path patterns `<A>::B::C`/`<A as Trait>::B::C` can only legally refer to associated constants.",109,N],[13,"Tuple","","A tuple pattern `(a, b)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",109,N],[13,"Box","","A `box` pattern",109,N],[13,"Ref","","A reference pattern, e.g. `&mut (a, b)`",109,N],[13,"Lit","","A literal",109,N],[13,"Range","","A range pattern, e.g. `1...2`, `1..=2` or `1..2`",109,N],[13,"Slice","","`[a, b, ..i, y, z]` is represented as: `PatKind::Slice(box [a, b], Some(i), box [y, z])`",109,N],[13,"Paren","","Parentheses in patters used for grouping, i.e. `(PAT)`.",109,N],[13,"Mac","","A macro pattern; pre-expansion",109,N],[4,"Mutability","","",N,N],[13,"Mutable","","",110,N],[13,"Immutable","","",110,N],[4,"BinOpKind","","",N,N],[13,"Add","","The `+` operator (addition)",111,N],[13,"Sub","","The `-` operator (subtraction)",111,N],[13,"Mul","","The `*` operator (multiplication)",111,N],[13,"Div","","The `/` operator (division)",111,N],[13,"Rem","","The `%` operator (modulus)",111,N],[13,"And","","The `&&` operator (logical and)",111,N],[13,"Or","","The `||` operator (logical or)",111,N],[13,"BitXor","","The `^` operator (bitwise xor)",111,N],[13,"BitAnd","","The `&` operator (bitwise and)",111,N],[13,"BitOr","","The `|` operator (bitwise or)",111,N],[13,"Shl","","The `<<` operator (shift left)",111,N],[13,"Shr","","The `>>` operator (shift right)",111,N],[13,"Eq","","The `==` operator (equality)",111,N],[13,"Lt","","The `<` operator (less than)",111,N],[13,"Le","","The `<=` operator (less than or equal to)",111,N],[13,"Ne","","The `!=` operator (not equal to)",111,N],[13,"Ge","","The `>=` operator (greater than or equal to)",111,N],[13,"Gt","","The `>` operator (greater than)",111,N],[4,"UnOp","","",N,N],[13,"Deref","","The `*` operator for dereferencing",112,N],[13,"Not","","The `!` operator for logical inversion",112,N],[13,"Neg","","The `-` operator for negation",112,N],[4,"StmtKind","","",N,N],[13,"Local","","A local (let) binding.",113,N],[13,"Item","","An item definition.",113,N],[13,"Expr","","Expr without trailing semi-colon.",113,N],[13,"Semi","","Expr with a trailing semi-colon.",113,N],[13,"Mac","","Macro.",113,N],[4,"MacStmtStyle","","",N,N],[13,"Semicolon","","The macro statement had a trailing semicolon, e.g. `foo! { ... };` `foo!(...);`, `foo![...];`",114,N],[13,"Braces","","The macro statement had braces; e.g. foo! { ... }",114,N],[13,"NoBraces","","The macro statement had parentheses or brackets and no semicolon; e.g. `foo!(...)`. All of these will end up being converted into macro expressions.",114,N],[4,"Guard","","",N,N],[13,"If","","",115,N],[4,"BlockCheckMode","","",N,N],[13,"Default","","",116,N],[13,"Unsafe","","",116,N],[4,"UnsafeSource","","",N,N],[13,"CompilerGenerated","","",117,N],[13,"UserProvided","","",117,N],[4,"RangeLimits","","Limit types of a range (inclusive or exclusive)",N,N],[13,"HalfOpen","","Inclusive at the beginning, exclusive at the end",118,N],[13,"Closed","","Inclusive at the beginning and end",118,N],[4,"ExprKind","","",N,N],[13,"Box","","A `box x` expression.",119,N],[13,"ObsoleteInPlace","","First expr is the place; second expr is the value.",119,N],[13,"Array","","An array (`[a, b, c, d]`)",119,N],[13,"Call","","A function call",119,N],[13,"MethodCall","","A method call (`x.foo::<'static, Bar, Baz>(a, b, c, d)`)",119,N],[13,"Tup","","A tuple (`(a, b, c ,d)`)",119,N],[13,"Binary","","A binary operation (For example: `a + b`, `a * b`)",119,N],[13,"Unary","","A unary operation (For example: `!x`, `*x`)",119,N],[13,"Lit","","A literal (For example: `1`, `\"foo\"`)",119,N],[13,"Cast","","A cast (`foo as f64`)",119,N],[13,"Type","","",119,N],[13,"If","","An `if` block, with an optional else block",119,N],[13,"IfLet","","An `if let` expression with an optional else block",119,N],[13,"While","","A while loop, with an optional label",119,N],[13,"WhileLet","","A while-let loop, with an optional label",119,N],[13,"ForLoop","","A for loop, with an optional label",119,N],[13,"Loop","","Conditionless loop (can be exited with break, continue, or return)",119,N],[13,"Match","","A `match` block.",119,N],[13,"Closure","","A closure (for example, `move |a, b, c| a + b + c`)",119,N],[13,"Block","","A block (`'label: { ... }`)",119,N],[13,"Async","","An async block (`async move { ... }`)",119,N],[13,"TryBlock","","A try block (`try { ... }`)",119,N],[13,"Assign","","An assignment (`a = foo()`)",119,N],[13,"AssignOp","","An assignment with an operator",119,N],[13,"Field","","Access of a named (`obj.foo`) or unnamed (`obj.0`) struct field",119,N],[13,"Index","","An indexing operation (`foo[2]`)",119,N],[13,"Range","","A range (`1..2`, `1..`, `..2`, `1...2`, `1...`, `...2`)",119,N],[13,"Path","","Variable reference, possibly containing `::` and/or type parameters, e.g. foo::bar::.",119,N],[13,"AddrOf","","A referencing operation (`&a` or `&mut a`)",119,N],[13,"Break","","A `break`, with an optional label to break, and an optional expression",119,N],[13,"Continue","","A `continue`, with an optional label",119,N],[13,"Ret","","A `return`, with an optional value to be returned",119,N],[13,"InlineAsm","","Output of the `asm!()` macro",119,N],[13,"Mac","","A macro invocation; pre-expansion",119,N],[13,"Struct","","A struct literal expression.",119,N],[13,"Repeat","","An array literal constructed from one repeated element.",119,N],[13,"Paren","","No-op: used solely so we can pretty-print faithfully",119,N],[13,"Try","","`expr?`",119,N],[13,"Yield","","A `yield`, with an optional value to be yielded",119,N],[4,"CaptureBy","","A capture clause",N,N],[13,"Value","","",120,N],[13,"Ref","","",120,N],[4,"Movability","","The movability of a generator / closure literal",N,N],[13,"Static","","",121,N],[13,"Movable","","",121,N],[4,"MacDelimiter","","",N,N],[13,"Parenthesis","","",122,N],[13,"Bracket","","",122,N],[13,"Brace","","",122,N],[4,"StrStyle","","",N,N],[13,"Cooked","","A regular string, like `\"foo\"`",123,N],[13,"Raw","","A raw string, like `r##\"foo\"##`",123,N],[4,"LitIntType","","",N,N],[13,"Signed","","",124,N],[13,"Unsigned","","",124,N],[13,"Unsuffixed","","",124,N],[4,"LitKind","","Literal kind.",N,N],[13,"Str","","A string literal (`\"foo\"`)",125,N],[13,"ByteStr","","A byte string (`b\"foo\"`)",125,N],[13,"Byte","","A byte char (`b'f'`)",125,N],[13,"Char","","A character literal (`'a'`)",125,N],[13,"Int","","An integer literal (`1`)",125,N],[13,"Float","","A float literal (`1f64` or `1E10f64`)",125,N],[13,"FloatUnsuffixed","","A float literal without a suffix (`1.0 or 1.0E10`)",125,N],[13,"Bool","","A boolean literal",125,N],[4,"TraitItemKind","","",N,N],[13,"Const","","",126,N],[13,"Method","","",126,N],[13,"Type","","",126,N],[13,"Macro","","",126,N],[4,"ImplItemKind","","",N,N],[13,"Const","","",127,N],[13,"Method","","",127,N],[13,"Type","","",127,N],[13,"Existential","","",127,N],[13,"Macro","","",127,N],[4,"IntTy","","",N,N],[13,"Isize","","",128,N],[13,"I8","","",128,N],[13,"I16","","",128,N],[13,"I32","","",128,N],[13,"I64","","",128,N],[13,"I128","","",128,N],[4,"UintTy","","",N,N],[13,"Usize","","",129,N],[13,"U8","","",129,N],[13,"U16","","",129,N],[13,"U32","","",129,N],[13,"U64","","",129,N],[13,"U128","","",129,N],[4,"TyKind","","The different kinds of types recognized by the compiler",N,N],[13,"Slice","","A variable-length slice (`[T]`)",130,N],[13,"Array","","A fixed length array (`[T; n]`)",130,N],[13,"Ptr","","A raw pointer (`*const T` or `*mut T`)",130,N],[13,"Rptr","","A reference (`&'a T` or `&'a mut T`)",130,N],[13,"BareFn","","A bare function (e.g. `fn(usize) -> bool`)",130,N],[13,"Never","","The never type (`!`)",130,N],[13,"Tup","","A tuple (`(A, B, C, D,...)`)",130,N],[13,"Path","","A path (`module::module::...::Type`), optionally \"qualified\", e.g. `<Vec<T> as SomeTrait>::SomeType`.",130,N],[13,"TraitObject","","A trait object type `Bound1 + Bound2 + Bound3` where `Bound` is a trait or a lifetime.",130,N],[13,"ImplTrait","","An `impl Bound1 + Bound2 + Bound3` type where `Bound` is a trait or a lifetime.",130,N],[13,"Paren","","No-op; kept solely so that we can pretty-print faithfully",130,N],[13,"Typeof","","Unused for now",130,N],[13,"Infer","","TyKind::Infer means the type should be inferred instead of it having been specified. This can appear anywhere in a type.",130,N],[13,"ImplicitSelf","","Inferred type of a `self` or `&self` argument in a method.",130,N],[13,"Mac","","",130,N],[13,"Err","","Placeholder for a kind that has failed to be defined.",130,N],[4,"TraitObjectSyntax","","Syntax used to declare a trait object.",N,N],[13,"Dyn","","",131,N],[13,"None","","",131,N],[4,"AsmDialect","","Inline assembly dialect.",N,N],[13,"Att","","",132,N],[13,"Intel","","",132,N],[4,"SelfKind","","Alternative representation for `Arg`s describing `self` parameter of methods.",N,N],[13,"Value","","`self`, `mut self`",133,N],[13,"Region","","`&'lt self`, `&'lt mut self`",133,N],[13,"Explicit","","`self: TYPE`, `mut self: TYPE`",133,N],[4,"IsAuto","","Is the trait definition an auto trait?",N,N],[13,"Yes","","",134,N],[13,"No","","",134,N],[4,"Unsafety","","",N,N],[13,"Unsafe","","",135,N],[13,"Normal","","",135,N],[4,"IsAsync","","",N,N],[13,"Async","","",136,N],[12,"closure_id","syntax::ast::IsAsync","",136,N],[12,"return_impl_trait_id","","",136,N],[13,"NotAsync","syntax::ast","",136,N],[4,"Constness","","",N,N],[13,"Const","","",137,N],[13,"NotConst","","",137,N],[4,"Defaultness","","",N,N],[13,"Default","","",138,N],[13,"Final","","",138,N],[4,"ImplPolarity","","",N,N],[13,"Positive","","`impl Trait for Type`",139,N],[13,"Negative","","`impl !Trait for Type`",139,N],[4,"FunctionRetTy","","",N,N],[13,"Default","","Return type is not specified.",140,N],[13,"Ty","","Everything else",140,N],[4,"UseTreeKind","","Part of `use` item to the right of its prefix.",N,N],[13,"Simple","","`use prefix` or `use prefix as rename`",141,N],[13,"Nested","","`use prefix::{...}`",141,N],[13,"Glob","","`use prefix::*`",141,N],[4,"AttrStyle","","Distinguishes between Attributes that decorate items and Attributes that are contained as statements within items. These two cases need to be distinguished for pretty-printing.",N,N],[13,"Outer","","",142,N],[13,"Inner","","",142,N],[4,"CrateSugar","","",N,N],[13,"PubCrate","","Source is `pub(crate)`",143,N],[13,"JustCrate","","Source is (just) `crate`",143,N],[4,"VisibilityKind","","",N,N],[13,"Public","","",144,N],[13,"Crate","","",144,N],[13,"Restricted","","",144,N],[12,"path","syntax::ast::VisibilityKind","",144,N],[12,"id","","",144,N],[13,"Inherited","syntax::ast","",144,N],[4,"VariantData","","Fields and Ids of enum variants and structs",N,N],[13,"Struct","","Struct variant.",145,N],[13,"Tuple","","Tuple variant.",145,N],[13,"Unit","","Unit variant.",145,N],[4,"ItemKind","","",N,N],[13,"ExternCrate","","An `extern crate` item, with optional original crate name if the crate was renamed.",146,N],[13,"Use","","A use declaration (`use` or `pub use`) item.",146,N],[13,"Static","","A static item (`static` or `pub static`).",146,N],[13,"Const","","A constant item (`const` or `pub const`).",146,N],[13,"Fn","","A function declaration (`fn` or `pub fn`).",146,N],[13,"Mod","","A module declaration (`mod` or `pub mod`).",146,N],[13,"ForeignMod","","An external module (`extern` or `pub extern`).",146,N],[13,"GlobalAsm","","Module-level inline assembly (from `global_asm!()`)",146,N],[13,"Ty","","A type alias (`type` or `pub type`).",146,N],[13,"Existential","","An existential type declaration (`existential type`).",146,N],[13,"Enum","","An enum definition (`enum` or `pub enum`).",146,N],[13,"Struct","","A struct definition (`struct` or `pub struct`).",146,N],[13,"Union","","A union definition (`union` or `pub union`).",146,N],[13,"Trait","","A Trait declaration (`trait` or `pub trait`).",146,N],[13,"TraitAlias","","Trait alias",146,N],[13,"Impl","","An implementation.",146,N],[13,"Mac","","A macro invocation.",146,N],[13,"MacroDef","","A macro definition.",146,N],[4,"ForeignItemKind","","An item within an `extern` block",N,N],[13,"Fn","","A foreign function",147,N],[13,"Static","","A foreign static item (`static ext: u8`), with optional mutability (the boolean is true when mutable)",147,N],[13,"Ty","","A foreign type",147,N],[13,"Macro","","A macro invocation",147,N],[6,"GenericBounds","","",N,N],[6,"CrateConfig","","The set of MetaItems that define the compilation environment of the crate, used to drive conditional compilation",N,N],[6,"NestedMetaItem","","A spanned compile-time attribute list item.",N,N],[6,"BinOp","","",N,N],[6,"SpannedIdent","","",N,N],[6,"Mac","","",N,N],[6,"Lit","","A literal",N,N],[6,"ExplicitSelf","","",N,N],[6,"Variant","","",N,N],[6,"Visibility","","",N,N],[17,"CRATE_NODE_ID","","Node id used to represent the root of the crate.",N,N],[17,"DUMMY_NODE_ID","","When parsing and doing expansions, we initially give all AST nodes this AST node value. Then later, in the renumber pass, we renumber them to have small, positive ids.",N,N],[11,"clone","","",46,[[["self"]],["label"]]],[11,"encode","","",46,[[["self"],["__s"]],["result"]]],[11,"decode","","",46,[[["__d"]],["result",["label"]]]],[11,"fmt","","",46,[[["self"],["formatter"]],["result"]]],[11,"clone","","",47,[[["self"]],["lifetime"]]],[11,"encode","","",47,[[["self"],["__s"]],["result"]]],[11,"decode","","",47,[[["__d"]],["result",["lifetime"]]]],[11,"fmt","","",47,[[["self"],["formatter"]],["result"]]],[11,"clone","","",48,[[["self"]],["path"]]],[11,"encode","","",48,[[["self"],["__s"]],["result"]]],[11,"decode","","",48,[[["__d"]],["result",["path"]]]],[11,"eq","","",48,[[["self"],["str"]],["bool"]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",48,[[["self"],["formatter"]],["result"]]],[11,"from_ident","","",48,[[["ident"]],["path"]]],[11,"make_root","","",48,[[["self"]],["option",["pathsegment"]]]],[11,"is_global","","",48,[[["self"]],["bool"]]],[11,"clone","","",49,[[["self"]],["pathsegment"]]],[11,"encode","","",49,[[["self"],["__s"]],["result"]]],[11,"decode","","",49,[[["__d"]],["result",["pathsegment"]]]],[11,"fmt","","",49,[[["self"],["formatter"]],["result"]]],[11,"from_ident","","",49,[[["ident"]],["self"]]],[11,"crate_root","","",49,[[["span"]],["self"]]],[11,"clone","","",98,[[["self"]],["genericargs"]]],[11,"encode","","",98,[[["self"],["__s"]],["result"]]],[11,"decode","","",98,[[["__d"]],["result",["genericargs"]]]],[11,"fmt","","",98,[[["self"],["formatter"]],["result"]]],[11,"span","","",98,[[["self"]],["span"]]],[11,"clone","","",99,[[["self"]],["genericarg"]]],[11,"encode","","",99,[[["self"],["__s"]],["result"]]],[11,"decode","","",99,[[["__d"]],["result",["genericarg"]]]],[11,"fmt","","",99,[[["self"],["formatter"]],["result"]]],[11,"clone","","",50,[[["self"]],["anglebracketedargs"]]],[11,"encode","","",50,[[["self"],["__s"]],["result"]]],[11,"decode","","",50,[[["__d"]],["result",["anglebracketedargs"]]]],[11,"fmt","","",50,[[["self"],["formatter"]],["result"]]],[11,"default","","",50,[[],["anglebracketedargs"]]],[11,"into","","",50,[[["self"]],["option",["p"]]]],[11,"into","","",51,[[["self"]],["option",["p"]]]],[11,"clone","","",51,[[["self"]],["parenthesisedargs"]]],[11,"encode","","",51,[[["self"],["__s"]],["result"]]],[11,"decode","","",51,[[["__d"]],["result",["parenthesisedargs"]]]],[11,"fmt","","",51,[[["self"],["formatter"]],["result"]]],[11,"clone","","",52,[[["self"]],["nodeid"]]],[11,"eq","","",52,[[["self"],["nodeid"]],["bool"]]],[11,"ne","","",52,[[["self"],["nodeid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",52,N],[11,"partial_cmp","","",52,[[["self"],["nodeid"]],["option",["ordering"]]]],[11,"lt","","",52,[[["self"],["nodeid"]],["bool"]]],[11,"le","","",52,[[["self"],["nodeid"]],["bool"]]],[11,"gt","","",52,[[["self"],["nodeid"]],["bool"]]],[11,"ge","","",52,[[["self"],["nodeid"]],["bool"]]],[11,"cmp","","",52,[[["self"],["nodeid"]],["ordering"]]],[11,"hash","","",52,N],[11,"fmt","","",52,[[["self"],["formatter"]],["result"]]],[11,"new","","",52,[[["usize"]],["nodeid"]]],[11,"from_u32","","",52,[[["u32"]],["nodeid"]]],[11,"as_usize","","",52,[[["self"]],["usize"]]],[11,"as_u32","","",52,[[["self"]],["u32"]]],[11,"placeholder_from_mark","","",52,[[["mark"]],["self"]]],[11,"placeholder_to_mark","","",52,[[["self"]],["mark"]]],[11,"fmt","","",52,[[["self"],["formatter"]],["result"]]],[11,"default_encode","","",52,[[["self"],["s"]],["result"]]],[11,"default_decode","","",52,[[["d"]],["result",["nodeid"]]]],[11,"new","","",52,[[["usize"]],["self"]]],[11,"index","","",52,[[["self"]],["usize"]]],[11,"clone","","",100,[[["self"]],["traitboundmodifier"]]],[11,"eq","","",100,[[["self"],["traitboundmodifier"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",100,N],[11,"encode","","",100,[[["self"],["__s"]],["result"]]],[11,"decode","","",100,[[["__d"]],["result",["traitboundmodifier"]]]],[11,"fmt","","",100,[[["self"],["formatter"]],["result"]]],[11,"clone","","",101,[[["self"]],["genericbound"]]],[11,"encode","","",101,[[["self"],["__s"]],["result"]]],[11,"decode","","",101,[[["__d"]],["result",["genericbound"]]]],[11,"fmt","","",101,[[["self"],["formatter"]],["result"]]],[11,"span","","",101,[[["self"]],["span"]]],[11,"clone","","",102,[[["self"]],["genericparamkind"]]],[11,"encode","","",102,[[["self"],["__s"]],["result"]]],[11,"decode","","",102,[[["__d"]],["result",["genericparamkind"]]]],[11,"fmt","","",102,[[["self"],["formatter"]],["result"]]],[11,"clone","","",53,[[["self"]],["genericparam"]]],[11,"encode","","",53,[[["self"],["__s"]],["result"]]],[11,"decode","","",53,[[["__d"]],["result",["genericparam"]]]],[11,"fmt","","",53,[[["self"],["formatter"]],["result"]]],[11,"clone","","",54,[[["self"]],["generics"]]],[11,"encode","","",54,[[["self"],["__s"]],["result"]]],[11,"decode","","",54,[[["__d"]],["result",["generics"]]]],[11,"fmt","","",54,[[["self"],["formatter"]],["result"]]],[11,"default","","Creates an instance of `Generics`.",54,[[],["generics"]]],[11,"clone","","",55,[[["self"]],["whereclause"]]],[11,"encode","","",55,[[["self"],["__s"]],["result"]]],[11,"decode","","",55,[[["__d"]],["result",["whereclause"]]]],[11,"fmt","","",55,[[["self"],["formatter"]],["result"]]],[11,"clone","","",103,[[["self"]],["wherepredicate"]]],[11,"encode","","",103,[[["self"],["__s"]],["result"]]],[11,"decode","","",103,[[["__d"]],["result",["wherepredicate"]]]],[11,"fmt","","",103,[[["self"],["formatter"]],["result"]]],[11,"span","","",103,[[["self"]],["span"]]],[11,"clone","","",56,[[["self"]],["whereboundpredicate"]]],[11,"encode","","",56,[[["self"],["__s"]],["result"]]],[11,"decode","","",56,[[["__d"]],["result",["whereboundpredicate"]]]],[11,"fmt","","",56,[[["self"],["formatter"]],["result"]]],[11,"clone","","",57,[[["self"]],["whereregionpredicate"]]],[11,"encode","","",57,[[["self"],["__s"]],["result"]]],[11,"decode","","",57,[[["__d"]],["result",["whereregionpredicate"]]]],[11,"fmt","","",57,[[["self"],["formatter"]],["result"]]],[11,"clone","","",58,[[["self"]],["whereeqpredicate"]]],[11,"encode","","",58,[[["self"],["__s"]],["result"]]],[11,"decode","","",58,[[["__d"]],["result",["whereeqpredicate"]]]],[11,"fmt","","",58,[[["self"],["formatter"]],["result"]]],[11,"clone","","",59,[[["self"]],["crate"]]],[11,"encode","","",59,[[["self"],["__s"]],["result"]]],[11,"decode","","",59,[[["__d"]],["result",["crate"]]]],[11,"fmt","","",59,[[["self"],["formatter"]],["result"]]],[11,"clone","","",104,[[["self"]],["nestedmetaitemkind"]]],[11,"encode","","",104,[[["self"],["__s"]],["result"]]],[11,"decode","","",104,[[["__d"]],["result",["nestedmetaitemkind"]]]],[11,"fmt","","",104,[[["self"],["formatter"]],["result"]]],[11,"clone","","",60,[[["self"]],["metaitem"]]],[11,"encode","","",60,[[["self"],["__s"]],["result"]]],[11,"decode","","",60,[[["__d"]],["result",["metaitem"]]]],[11,"fmt","","",60,[[["self"],["formatter"]],["result"]]],[11,"clone","","",105,[[["self"]],["metaitemkind"]]],[11,"encode","","",105,[[["self"],["__s"]],["result"]]],[11,"decode","","",105,[[["__d"]],["result",["metaitemkind"]]]],[11,"fmt","","",105,[[["self"],["formatter"]],["result"]]],[11,"clone","","",61,[[["self"]],["block"]]],[11,"encode","","",61,[[["self"],["__s"]],["result"]]],[11,"decode","","",61,[[["__d"]],["result",["block"]]]],[11,"fmt","","",61,[[["self"],["formatter"]],["result"]]],[11,"clone","","",62,[[["self"]],["pat"]]],[11,"encode","","",62,[[["self"],["__s"]],["result"]]],[11,"decode","","",62,[[["__d"]],["result",["pat"]]]],[11,"fmt","","",62,[[["self"],["formatter"]],["result"]]],[11,"to_ty","","",62,[[["self"]],["option",["p"]]]],[11,"walk","","",62,[[["self"],["f"]],["bool"]]],[11,"clone","","",63,[[["self"]],["fieldpat"]]],[11,"encode","","",63,[[["self"],["__s"]],["result"]]],[11,"decode","","",63,[[["__d"]],["result",["fieldpat"]]]],[11,"fmt","","",63,[[["self"],["formatter"]],["result"]]],[11,"clone","","",106,[[["self"]],["bindingmode"]]],[11,"eq","","",106,[[["self"],["bindingmode"]],["bool"]]],[11,"ne","","",106,[[["self"],["bindingmode"]],["bool"]]],[11,"encode","","",106,[[["self"],["__s"]],["result"]]],[11,"decode","","",106,[[["__d"]],["result",["bindingmode"]]]],[11,"fmt","","",106,[[["self"],["formatter"]],["result"]]],[11,"clone","","",107,[[["self"]],["rangeend"]]],[11,"encode","","",107,[[["self"],["__s"]],["result"]]],[11,"decode","","",107,[[["__d"]],["result",["rangeend"]]]],[11,"fmt","","",107,[[["self"],["formatter"]],["result"]]],[11,"clone","","",108,[[["self"]],["rangesyntax"]]],[11,"encode","","",108,[[["self"],["__s"]],["result"]]],[11,"decode","","",108,[[["__d"]],["result",["rangesyntax"]]]],[11,"fmt","","",108,[[["self"],["formatter"]],["result"]]],[11,"clone","","",109,[[["self"]],["patkind"]]],[11,"encode","","",109,[[["self"],["__s"]],["result"]]],[11,"decode","","",109,[[["__d"]],["result",["patkind"]]]],[11,"fmt","","",109,[[["self"],["formatter"]],["result"]]],[11,"clone","","",110,[[["self"]],["mutability"]]],[11,"eq","","",110,[[["self"],["mutability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",110,N],[11,"partial_cmp","","",110,[[["self"],["mutability"]],["option",["ordering"]]]],[11,"cmp","","",110,[[["self"],["mutability"]],["ordering"]]],[11,"hash","","",110,N],[11,"encode","","",110,[[["self"],["__s"]],["result"]]],[11,"decode","","",110,[[["__d"]],["result",["mutability"]]]],[11,"fmt","","",110,[[["self"],["formatter"]],["result"]]],[11,"clone","","",111,[[["self"]],["binopkind"]]],[11,"eq","","",111,[[["self"],["binopkind"]],["bool"]]],[11,"encode","","",111,[[["self"],["__s"]],["result"]]],[11,"decode","","",111,[[["__d"]],["result",["binopkind"]]]],[11,"fmt","","",111,[[["self"],["formatter"]],["result"]]],[11,"to_string","","",111,[[["self"]],["str"]]],[11,"lazy","","",111,[[["self"]],["bool"]]],[11,"is_shift","","",111,[[["self"]],["bool"]]],[11,"is_comparison","","",111,[[["self"]],["bool"]]],[11,"is_by_value","","Returns `true` if the binary operator takes its arguments by value",111,[[["self"]],["bool"]]],[11,"clone","","",112,[[["self"]],["unop"]]],[11,"encode","","",112,[[["self"],["__s"]],["result"]]],[11,"decode","","",112,[[["__d"]],["result",["unop"]]]],[11,"fmt","","",112,[[["self"],["formatter"]],["result"]]],[11,"is_by_value","","Returns `true` if the unary operator takes its argument by value",112,[[["unop"]],["bool"]]],[11,"to_string","","",112,[[["unop"]],["str"]]],[11,"clone","","",64,[[["self"]],["stmt"]]],[11,"encode","","",64,[[["self"],["__s"]],["result"]]],[11,"decode","","",64,[[["__d"]],["result",["stmt"]]]],[11,"add_trailing_semicolon","","",64,[[["self"]],["self"]]],[11,"is_item","","",64,[[["self"]],["bool"]]],[11,"is_expr","","",64,[[["self"]],["bool"]]],[11,"fmt","","",64,[[["self"],["formatter"]],["result"]]],[11,"clone","","",113,[[["self"]],["stmtkind"]]],[11,"encode","","",113,[[["self"],["__s"]],["result"]]],[11,"decode","","",113,[[["__d"]],["result",["stmtkind"]]]],[11,"clone","","",114,[[["self"]],["macstmtstyle"]]],[11,"eq","","",114,[[["self"],["macstmtstyle"]],["bool"]]],[11,"encode","","",114,[[["self"],["__s"]],["result"]]],[11,"decode","","",114,[[["__d"]],["result",["macstmtstyle"]]]],[11,"fmt","","",114,[[["self"],["formatter"]],["result"]]],[11,"clone","","",65,[[["self"]],["local"]]],[11,"encode","","",65,[[["self"],["__s"]],["result"]]],[11,"decode","","",65,[[["__d"]],["result",["local"]]]],[11,"fmt","","",65,[[["self"],["formatter"]],["result"]]],[11,"clone","","",66,[[["self"]],["arm"]]],[11,"encode","","",66,[[["self"],["__s"]],["result"]]],[11,"decode","","",66,[[["__d"]],["result",["arm"]]]],[11,"fmt","","",66,[[["self"],["formatter"]],["result"]]],[11,"clone","","",115,[[["self"]],["guard"]]],[11,"encode","","",115,[[["self"],["__s"]],["result"]]],[11,"decode","","",115,[[["__d"]],["result",["guard"]]]],[11,"fmt","","",115,[[["self"],["formatter"]],["result"]]],[11,"clone","","",67,[[["self"]],["field"]]],[11,"encode","","",67,[[["self"],["__s"]],["result"]]],[11,"decode","","",67,[[["__d"]],["result",["field"]]]],[11,"fmt","","",67,[[["self"],["formatter"]],["result"]]],[11,"clone","","",116,[[["self"]],["blockcheckmode"]]],[11,"encode","","",116,[[["self"],["__s"]],["result"]]],[11,"decode","","",116,[[["__d"]],["result",["blockcheckmode"]]]],[11,"fmt","","",116,[[["self"],["formatter"]],["result"]]],[11,"clone","","",117,[[["self"]],["unsafesource"]]],[11,"encode","","",117,[[["self"],["__s"]],["result"]]],[11,"decode","","",117,[[["__d"]],["result",["unsafesource"]]]],[11,"fmt","","",117,[[["self"],["formatter"]],["result"]]],[11,"clone","","",68,[[["self"]],["anonconst"]]],[11,"encode","","",68,[[["self"],["__s"]],["result"]]],[11,"decode","","",68,[[["__d"]],["result",["anonconst"]]]],[11,"fmt","","",68,[[["self"],["formatter"]],["result"]]],[11,"clone","","",69,[[["self"]],["expr"]]],[11,"encode","","",69,[[["self"],["__s"]],["result"]]],[11,"decode","","",69,[[["__d"]],["result",["expr"]]]],[11,"returns","","Whether this expression would be valid somewhere that expects a value, for example, an `if` condition.",69,[[["self"]],["bool"]]],[11,"to_bound","","",69,[[["self"]],["option",["genericbound"]]]],[11,"to_ty","","",69,[[["self"]],["option",["p"]]]],[11,"precedence","","",69,[[["self"]],["exprprecedence"]]],[11,"fmt","","",69,[[["self"],["formatter"]],["result"]]],[11,"clone","","",118,[[["self"]],["rangelimits"]]],[11,"eq","","",118,[[["self"],["rangelimits"]],["bool"]]],[11,"encode","","",118,[[["self"],["__s"]],["result"]]],[11,"decode","","",118,[[["__d"]],["result",["rangelimits"]]]],[11,"fmt","","",118,[[["self"],["formatter"]],["result"]]],[11,"clone","","",119,[[["self"]],["exprkind"]]],[11,"encode","","",119,[[["self"],["__s"]],["result"]]],[11,"decode","","",119,[[["__d"]],["result",["exprkind"]]]],[11,"fmt","","",119,[[["self"],["formatter"]],["result"]]],[11,"clone","","",70,[[["self"]],["qself"]]],[11,"encode","","",70,[[["self"],["__s"]],["result"]]],[11,"decode","","",70,[[["__d"]],["result",["qself"]]]],[11,"fmt","","",70,[[["self"],["formatter"]],["result"]]],[11,"clone","","",120,[[["self"]],["captureby"]]],[11,"eq","","",120,[[["self"],["captureby"]],["bool"]]],[11,"encode","","",120,[[["self"],["__s"]],["result"]]],[11,"decode","","",120,[[["__d"]],["result",["captureby"]]]],[11,"fmt","","",120,[[["self"],["formatter"]],["result"]]],[11,"clone","","",121,[[["self"]],["movability"]]],[11,"eq","","",121,[[["self"],["movability"]],["bool"]]],[11,"encode","","",121,[[["self"],["__s"]],["result"]]],[11,"decode","","",121,[[["__d"]],["result",["movability"]]]],[11,"fmt","","",121,[[["self"],["formatter"]],["result"]]],[11,"clone","","",71,[[["self"]],["mac_"]]],[11,"encode","","",71,[[["self"],["__s"]],["result"]]],[11,"decode","","",71,[[["__d"]],["result",["mac_"]]]],[11,"fmt","","",71,[[["self"],["formatter"]],["result"]]],[11,"clone","","",122,[[["self"]],["macdelimiter"]]],[11,"eq","","",122,[[["self"],["macdelimiter"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",122,N],[11,"encode","","",122,[[["self"],["__s"]],["result"]]],[11,"decode","","",122,[[["__d"]],["result",["macdelimiter"]]]],[11,"fmt","","",122,[[["self"],["formatter"]],["result"]]],[11,"stream","","",71,[[["self"]],["tokenstream"]]],[11,"clone","","",72,[[["self"]],["macrodef"]]],[11,"encode","","",72,[[["self"],["__s"]],["result"]]],[11,"decode","","",72,[[["__d"]],["result",["macrodef"]]]],[11,"fmt","","",72,[[["self"],["formatter"]],["result"]]],[11,"stream","","",72,[[["self"]],["tokenstream"]]],[11,"clone","","",123,[[["self"]],["strstyle"]]],[11,"encode","","",123,[[["self"],["__s"]],["result"]]],[11,"decode","","",123,[[["__d"]],["result",["strstyle"]]]],[11,"fmt","","",123,[[["self"],["formatter"]],["result"]]],[11,"hash","","",123,N],[11,"eq","","",123,[[["self"],["strstyle"]],["bool"]]],[11,"ne","","",123,[[["self"],["strstyle"]],["bool"]]],[11,"clone","","",124,[[["self"]],["litinttype"]]],[11,"encode","","",124,[[["self"],["__s"]],["result"]]],[11,"decode","","",124,[[["__d"]],["result",["litinttype"]]]],[11,"fmt","","",124,[[["self"],["formatter"]],["result"]]],[11,"hash","","",124,N],[11,"eq","","",124,[[["self"],["litinttype"]],["bool"]]],[11,"ne","","",124,[[["self"],["litinttype"]],["bool"]]],[11,"clone","","",125,[[["self"]],["litkind"]]],[11,"encode","","",125,[[["self"],["__s"]],["result"]]],[11,"decode","","",125,[[["__d"]],["result",["litkind"]]]],[11,"fmt","","",125,[[["self"],["formatter"]],["result"]]],[11,"hash","","",125,N],[11,"eq","","",125,[[["self"],["litkind"]],["bool"]]],[11,"ne","","",125,[[["self"],["litkind"]],["bool"]]],[11,"is_str","","Returns true if this literal is a string and false otherwise.",125,[[["self"]],["bool"]]],[11,"is_numeric","","Returns true if this is a numeric literal.",125,[[["self"]],["bool"]]],[11,"is_unsuffixed","","Returns true if this literal has no suffix. Note: this will return true for literals with prefixes such as raw strings and byte strings.",125,[[["self"]],["bool"]]],[11,"is_suffixed","","Returns true if this literal has a suffix.",125,[[["self"]],["bool"]]],[11,"clone","","",73,[[["self"]],["mutty"]]],[11,"encode","","",73,[[["self"],["__s"]],["result"]]],[11,"decode","","",73,[[["__d"]],["result",["mutty"]]]],[11,"fmt","","",73,[[["self"],["formatter"]],["result"]]],[11,"clone","","",74,[[["self"]],["methodsig"]]],[11,"encode","","",74,[[["self"],["__s"]],["result"]]],[11,"decode","","",74,[[["__d"]],["result",["methodsig"]]]],[11,"fmt","","",74,[[["self"],["formatter"]],["result"]]],[11,"clone","","",75,[[["self"]],["traititem"]]],[11,"encode","","",75,[[["self"],["__s"]],["result"]]],[11,"decode","","",75,[[["__d"]],["result",["traititem"]]]],[11,"fmt","","",75,[[["self"],["formatter"]],["result"]]],[11,"clone","","",126,[[["self"]],["traititemkind"]]],[11,"encode","","",126,[[["self"],["__s"]],["result"]]],[11,"decode","","",126,[[["__d"]],["result",["traititemkind"]]]],[11,"fmt","","",126,[[["self"],["formatter"]],["result"]]],[11,"clone","","",76,[[["self"]],["implitem"]]],[11,"encode","","",76,[[["self"],["__s"]],["result"]]],[11,"decode","","",76,[[["__d"]],["result",["implitem"]]]],[11,"fmt","","",76,[[["self"],["formatter"]],["result"]]],[11,"clone","","",127,[[["self"]],["implitemkind"]]],[11,"encode","","",127,[[["self"],["__s"]],["result"]]],[11,"decode","","",127,[[["__d"]],["result",["implitemkind"]]]],[11,"fmt","","",127,[[["self"],["formatter"]],["result"]]],[11,"clone","","",128,[[["self"]],["intty"]]],[11,"eq","","",128,[[["self"],["intty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",128,N],[11,"partial_cmp","","",128,[[["self"],["intty"]],["option",["ordering"]]]],[11,"cmp","","",128,[[["self"],["intty"]],["ordering"]]],[11,"hash","","",128,N],[11,"encode","","",128,[[["self"],["__s"]],["result"]]],[11,"decode","","",128,[[["__d"]],["result",["intty"]]]],[11,"fmt","","",128,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",128,[[["self"],["formatter"]],["result"]]],[11,"ty_to_string","","",128,[[["self"]],["str"]]],[11,"val_to_string","","",128,[[["self"],["i128"]],["string"]]],[11,"bit_width","","",128,[[["self"]],["option",["usize"]]]],[11,"clone","","",129,[[["self"]],["uintty"]]],[11,"eq","","",129,[[["self"],["uintty"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",129,N],[11,"partial_cmp","","",129,[[["self"],["uintty"]],["option",["ordering"]]]],[11,"cmp","","",129,[[["self"],["uintty"]],["ordering"]]],[11,"hash","","",129,N],[11,"encode","","",129,[[["self"],["__s"]],["result"]]],[11,"decode","","",129,[[["__d"]],["result",["uintty"]]]],[11,"ty_to_string","","",129,[[["self"]],["str"]]],[11,"val_to_string","","",129,[[["self"],["u128"]],["string"]]],[11,"bit_width","","",129,[[["self"]],["option",["usize"]]]],[11,"fmt","","",129,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",129,[[["self"],["formatter"]],["result"]]],[11,"clone","","",77,[[["self"]],["typebinding"]]],[11,"encode","","",77,[[["self"],["__s"]],["result"]]],[11,"decode","","",77,[[["__d"]],["result",["typebinding"]]]],[11,"fmt","","",77,[[["self"],["formatter"]],["result"]]],[11,"clone","","",78,[[["self"]],["ty"]]],[11,"encode","","",78,[[["self"],["__s"]],["result"]]],[11,"decode","","",78,[[["__d"]],["result",["ty"]]]],[11,"fmt","","",78,[[["self"],["formatter"]],["result"]]],[11,"clone","","",79,[[["self"]],["barefnty"]]],[11,"encode","","",79,[[["self"],["__s"]],["result"]]],[11,"decode","","",79,[[["__d"]],["result",["barefnty"]]]],[11,"fmt","","",79,[[["self"],["formatter"]],["result"]]],[11,"clone","","",130,[[["self"]],["tykind"]]],[11,"encode","","",130,[[["self"],["__s"]],["result"]]],[11,"decode","","",130,[[["__d"]],["result",["tykind"]]]],[11,"fmt","","",130,[[["self"],["formatter"]],["result"]]],[11,"is_implicit_self","","",130,[[["self"]],["bool"]]],[11,"is_unit","","",130,[[["self"]],["bool"]]],[11,"clone","","",131,[[["self"]],["traitobjectsyntax"]]],[11,"eq","","",131,[[["self"],["traitobjectsyntax"]],["bool"]]],[11,"encode","","",131,[[["self"],["__s"]],["result"]]],[11,"decode","","",131,[[["__d"]],["result",["traitobjectsyntax"]]]],[11,"fmt","","",131,[[["self"],["formatter"]],["result"]]],[11,"clone","","",132,[[["self"]],["asmdialect"]]],[11,"eq","","",132,[[["self"],["asmdialect"]],["bool"]]],[11,"encode","","",132,[[["self"],["__s"]],["result"]]],[11,"decode","","",132,[[["__d"]],["result",["asmdialect"]]]],[11,"fmt","","",132,[[["self"],["formatter"]],["result"]]],[11,"clone","","",80,[[["self"]],["inlineasmoutput"]]],[11,"encode","","",80,[[["self"],["__s"]],["result"]]],[11,"decode","","",80,[[["__d"]],["result",["inlineasmoutput"]]]],[11,"fmt","","",80,[[["self"],["formatter"]],["result"]]],[11,"clone","","",81,[[["self"]],["inlineasm"]]],[11,"encode","","",81,[[["self"],["__s"]],["result"]]],[11,"decode","","",81,[[["__d"]],["result",["inlineasm"]]]],[11,"fmt","","",81,[[["self"],["formatter"]],["result"]]],[11,"clone","","",82,[[["self"]],["arg"]]],[11,"encode","","",82,[[["self"],["__s"]],["result"]]],[11,"decode","","",82,[[["__d"]],["result",["arg"]]]],[11,"fmt","","",82,[[["self"],["formatter"]],["result"]]],[11,"clone","","",133,[[["self"]],["selfkind"]]],[11,"encode","","",133,[[["self"],["__s"]],["result"]]],[11,"decode","","",133,[[["__d"]],["result",["selfkind"]]]],[11,"fmt","","",133,[[["self"],["formatter"]],["result"]]],[11,"to_self","","",82,[[["self"]],["option",["explicitself"]]]],[11,"is_self","","",82,[[["self"]],["bool"]]],[11,"from_self","","",82,[[["explicitself"],["ident"]],["arg"]]],[11,"clone","","",83,[[["self"]],["fndecl"]]],[11,"encode","","",83,[[["self"],["__s"]],["result"]]],[11,"decode","","",83,[[["__d"]],["result",["fndecl"]]]],[11,"fmt","","",83,[[["self"],["formatter"]],["result"]]],[11,"get_self","","",83,[[["self"]],["option",["explicitself"]]]],[11,"has_self","","",83,[[["self"]],["bool"]]],[11,"clone","","",134,[[["self"]],["isauto"]]],[11,"eq","","",134,[[["self"],["isauto"]],["bool"]]],[11,"encode","","",134,[[["self"],["__s"]],["result"]]],[11,"decode","","",134,[[["__d"]],["result",["isauto"]]]],[11,"fmt","","",134,[[["self"],["formatter"]],["result"]]],[11,"clone","","",135,[[["self"]],["unsafety"]]],[11,"eq","","",135,[[["self"],["unsafety"]],["bool"]]],[11,"encode","","",135,[[["self"],["__s"]],["result"]]],[11,"decode","","",135,[[["__d"]],["result",["unsafety"]]]],[11,"fmt","","",135,[[["self"],["formatter"]],["result"]]],[11,"clone","","",136,[[["self"]],["isasync"]]],[11,"encode","","",136,[[["self"],["__s"]],["result"]]],[11,"decode","","",136,[[["__d"]],["result",["isasync"]]]],[11,"fmt","","",136,[[["self"],["formatter"]],["result"]]],[11,"is_async","","",136,[[["self"]],["bool"]]],[11,"opt_return_id","","In case this is an `Async` return the `NodeId` for the generated impl Trait item",136,[[["self"]],["option",["nodeid"]]]],[11,"clone","","",137,[[["self"]],["constness"]]],[11,"eq","","",137,[[["self"],["constness"]],["bool"]]],[11,"encode","","",137,[[["self"],["__s"]],["result"]]],[11,"decode","","",137,[[["__d"]],["result",["constness"]]]],[11,"fmt","","",137,[[["self"],["formatter"]],["result"]]],[11,"clone","","",138,[[["self"]],["defaultness"]]],[11,"eq","","",138,[[["self"],["defaultness"]],["bool"]]],[11,"encode","","",138,[[["self"],["__s"]],["result"]]],[11,"decode","","",138,[[["__d"]],["result",["defaultness"]]]],[11,"fmt","","",138,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",135,[[["self"],["formatter"]],["result"]]],[11,"clone","","",139,[[["self"]],["implpolarity"]]],[11,"eq","","",139,[[["self"],["implpolarity"]],["bool"]]],[11,"encode","","",139,[[["self"],["__s"]],["result"]]],[11,"decode","","",139,[[["__d"]],["result",["implpolarity"]]]],[11,"fmt","","",139,[[["self"],["formatter"]],["result"]]],[11,"clone","","",140,[[["self"]],["functionretty"]]],[11,"encode","","",140,[[["self"],["__s"]],["result"]]],[11,"decode","","",140,[[["__d"]],["result",["functionretty"]]]],[11,"fmt","","",140,[[["self"],["formatter"]],["result"]]],[11,"span","","",140,[[["self"]],["span"]]],[11,"clone","","",84,[[["self"]],["mod"]]],[11,"encode","","",84,[[["self"],["__s"]],["result"]]],[11,"decode","","",84,[[["__d"]],["result",["mod"]]]],[11,"fmt","","",84,[[["self"],["formatter"]],["result"]]],[11,"clone","","",85,[[["self"]],["foreignmod"]]],[11,"encode","","",85,[[["self"],["__s"]],["result"]]],[11,"decode","","",85,[[["__d"]],["result",["foreignmod"]]]],[11,"fmt","","",85,[[["self"],["formatter"]],["result"]]],[11,"clone","","",86,[[["self"]],["globalasm"]]],[11,"encode","","",86,[[["self"],["__s"]],["result"]]],[11,"decode","","",86,[[["__d"]],["result",["globalasm"]]]],[11,"fmt","","",86,[[["self"],["formatter"]],["result"]]],[11,"clone","","",87,[[["self"]],["enumdef"]]],[11,"encode","","",87,[[["self"],["__s"]],["result"]]],[11,"decode","","",87,[[["__d"]],["result",["enumdef"]]]],[11,"fmt","","",87,[[["self"],["formatter"]],["result"]]],[11,"clone","","",88,[[["self"]],["variant_"]]],[11,"encode","","",88,[[["self"],["__s"]],["result"]]],[11,"decode","","",88,[[["__d"]],["result",["variant_"]]]],[11,"fmt","","",88,[[["self"],["formatter"]],["result"]]],[11,"clone","","",141,[[["self"]],["usetreekind"]]],[11,"encode","","",141,[[["self"],["__s"]],["result"]]],[11,"decode","","",141,[[["__d"]],["result",["usetreekind"]]]],[11,"fmt","","",141,[[["self"],["formatter"]],["result"]]],[11,"clone","","",89,[[["self"]],["usetree"]]],[11,"encode","","",89,[[["self"],["__s"]],["result"]]],[11,"decode","","",89,[[["__d"]],["result",["usetree"]]]],[11,"fmt","","",89,[[["self"],["formatter"]],["result"]]],[11,"ident","","",89,[[["self"]],["ident"]]],[11,"clone","","",142,[[["self"]],["attrstyle"]]],[11,"eq","","",142,[[["self"],["attrstyle"]],["bool"]]],[11,"encode","","",142,[[["self"],["__s"]],["result"]]],[11,"decode","","",142,[[["__d"]],["result",["attrstyle"]]]],[11,"fmt","","",142,[[["self"],["formatter"]],["result"]]],[11,"clone","","",90,[[["self"]],["attrid"]]],[11,"eq","","",90,[[["self"],["attrid"]],["bool"]]],[11,"ne","","",90,[[["self"],["attrid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",90,N],[11,"encode","","",90,[[["self"],["__s"]],["result"]]],[11,"decode","","",90,[[["__d"]],["result",["attrid"]]]],[11,"hash","","",90,N],[11,"fmt","","",90,[[["self"],["formatter"]],["result"]]],[11,"partial_cmp","","",90,[[["self"],["attrid"]],["option",["ordering"]]]],[11,"lt","","",90,[[["self"],["attrid"]],["bool"]]],[11,"le","","",90,[[["self"],["attrid"]],["bool"]]],[11,"gt","","",90,[[["self"],["attrid"]],["bool"]]],[11,"ge","","",90,[[["self"],["attrid"]],["bool"]]],[11,"cmp","","",90,[[["self"],["attrid"]],["ordering"]]],[11,"new","","",90,[[["usize"]],["self"]]],[11,"index","","",90,[[["self"]],["usize"]]],[11,"clone","","",91,[[["self"]],["attribute"]]],[11,"encode","","",91,[[["self"],["__s"]],["result"]]],[11,"decode","","",91,[[["__d"]],["result",["attribute"]]]],[11,"fmt","","",91,[[["self"],["formatter"]],["result"]]],[11,"clone","","",92,[[["self"]],["traitref"]]],[11,"encode","","",92,[[["self"],["__s"]],["result"]]],[11,"decode","","",92,[[["__d"]],["result",["traitref"]]]],[11,"fmt","","",92,[[["self"],["formatter"]],["result"]]],[11,"clone","","",93,[[["self"]],["polytraitref"]]],[11,"encode","","",93,[[["self"],["__s"]],["result"]]],[11,"decode","","",93,[[["__d"]],["result",["polytraitref"]]]],[11,"fmt","","",93,[[["self"],["formatter"]],["result"]]],[11,"new","","",93,[[["vec",["genericparam"]],["path"],["span"]],["self"]]],[11,"clone","","",143,[[["self"]],["cratesugar"]]],[11,"encode","","",143,[[["self"],["__s"]],["result"]]],[11,"decode","","",143,[[["__d"]],["result",["cratesugar"]]]],[11,"fmt","","",143,[[["self"],["formatter"]],["result"]]],[11,"clone","","",144,[[["self"]],["visibilitykind"]]],[11,"encode","","",144,[[["self"],["__s"]],["result"]]],[11,"decode","","",144,[[["__d"]],["result",["visibilitykind"]]]],[11,"fmt","","",144,[[["self"],["formatter"]],["result"]]],[11,"is_pub","","",144,[[["self"]],["bool"]]],[11,"clone","","",94,[[["self"]],["structfield"]]],[11,"encode","","",94,[[["self"],["__s"]],["result"]]],[11,"decode","","",94,[[["__d"]],["result",["structfield"]]]],[11,"fmt","","",94,[[["self"],["formatter"]],["result"]]],[11,"clone","","",145,[[["self"]],["variantdata"]]],[11,"encode","","",145,[[["self"],["__s"]],["result"]]],[11,"decode","","",145,[[["__d"]],["result",["variantdata"]]]],[11,"fmt","","",145,[[["self"],["formatter"]],["result"]]],[11,"fields","","",145,N],[11,"id","","",145,[[["self"]],["nodeid"]]],[11,"is_struct","","",145,[[["self"]],["bool"]]],[11,"is_tuple","","",145,[[["self"]],["bool"]]],[11,"is_unit","","",145,[[["self"]],["bool"]]],[11,"clone","","",95,[[["self"]],["item"]]],[11,"encode","","",95,[[["self"],["__s"]],["result"]]],[11,"decode","","",95,[[["__d"]],["result",["item"]]]],[11,"fmt","","",95,[[["self"],["formatter"]],["result"]]],[11,"clone","","",96,[[["self"]],["fnheader"]]],[11,"encode","","",96,[[["self"],["__s"]],["result"]]],[11,"decode","","",96,[[["__d"]],["result",["fnheader"]]]],[11,"fmt","","",96,[[["self"],["formatter"]],["result"]]],[11,"default","","",96,[[],["fnheader"]]],[11,"clone","","",146,[[["self"]],["itemkind"]]],[11,"encode","","",146,[[["self"],["__s"]],["result"]]],[11,"decode","","",146,[[["__d"]],["result",["itemkind"]]]],[11,"fmt","","",146,[[["self"],["formatter"]],["result"]]],[11,"descriptive_variant","","",146,[[["self"]],["str"]]],[11,"clone","","",97,[[["self"]],["foreignitem"]]],[11,"encode","","",97,[[["self"],["__s"]],["result"]]],[11,"decode","","",97,[[["__d"]],["result",["foreignitem"]]]],[11,"fmt","","",97,[[["self"],["formatter"]],["result"]]],[11,"clone","","",147,[[["self"]],["foreignitemkind"]]],[11,"encode","","",147,[[["self"],["__s"]],["result"]]],[11,"decode","","",147,[[["__d"]],["result",["foreignitemkind"]]]],[11,"fmt","","",147,[[["self"],["formatter"]],["result"]]],[11,"descriptive_variant","","",147,[[["self"]],["str"]]],[0,"attr","syntax","Functions dealing with attributes and meta items",N,N],[3,"Deprecation","syntax::attr","",N,N],[12,"since","","",148,N],[12,"note","","",148,N],[3,"RustcDeprecation","","",N,N],[12,"since","","",149,N],[12,"reason","","",149,N],[3,"Stability","","Represents the #[stable], #[unstable], #[rustc_{deprecated,const_unstable}] attributes.",N,N],[12,"level","","",150,N],[12,"feature","","",150,N],[12,"rustc_depr","","",150,N],[12,"const_stability","","`None` means the function is stable but needs to be allowed by the `min_const_fn` feature `Some` contains the feature gate required to be able to use the function as const fn",150,N],[4,"InlineAttr","","",N,N],[13,"None","","",151,N],[13,"Hint","","",151,N],[13,"Always","","",151,N],[13,"Never","","",151,N],[4,"IntType","","",N,N],[13,"SignedInt","","",152,N],[13,"UnsignedInt","","",152,N],[4,"ReprAttr","","",N,N],[13,"ReprInt","","",153,N],[13,"ReprC","","",153,N],[13,"ReprPacked","","",153,N],[13,"ReprSimd","","",153,N],[13,"ReprTransparent","","",153,N],[13,"ReprAlign","","",153,N],[4,"StabilityLevel","","The available stability levels.",N,N],[13,"Unstable","","",154,N],[12,"reason","syntax::attr::StabilityLevel","",154,N],[12,"issue","","",154,N],[13,"Stable","syntax::attr","",154,N],[12,"since","syntax::attr::StabilityLevel","",154,N],[4,"UnwindAttr","syntax::attr","",N,N],[13,"Allowed","","",155,N],[13,"Aborts","","",155,N],[5,"cfg_matches","","Tests if a cfg-pattern matches the cfg set",N,[[["metaitem"],["parsesess"],["option",["features"]]],["bool"]]],[5,"contains_feature_attr","","Check if `attrs` contains an attribute like `#![feature(feature_name)]`. This will not perform any \"sanity checks\" on the form of the attributes.",N,N],[5,"eval_condition","","Evaluate a cfg-like condition (with `any` and `all`), using `eval` to evaluate individual items.",N,[[["metaitem"],["parsesess"],["f"]],["bool"]]],[5,"find_crate_name","","",N,N],[5,"find_deprecation","","Find the deprecation attribute. `None` if none exists.",N,N],[5,"find_repr_attrs","","Parse #[repr(...)] forms.",N,[[["handler"],["attribute"]],["vec",["reprattr"]]]],[5,"find_stability","","Find the first stability attribute. `None` if none exists.",N,N],[5,"find_unwind_attr","","Determine what `#[unwind]` attribute is present in `attrs`, if any.",N,N],[5,"mark_used","","",N,[[["attribute"]]]],[5,"is_used","","",N,[[["attribute"]],["bool"]]],[5,"mark_known","","",N,[[["attribute"]]]],[5,"is_known","","",N,[[["attribute"]],["bool"]]],[5,"is_known_lint_tool","","",N,[[["ident"]],["bool"]]],[5,"name_from_path","","",N,[[["path"]],["name"]]],[5,"mk_name_value_item_str","","",N,[[["ident"],["spanned",["symbol"]]],["metaitem"]]],[5,"mk_name_value_item","","",N,[[["span"],["ident"],["lit"]],["metaitem"]]],[5,"mk_list_item","","",N,[[["span"],["ident"],["vec",["nestedmetaitem"]]],["metaitem"]]],[5,"mk_word_item","","",N,[[["ident"]],["metaitem"]]],[5,"mk_nested_word_item","","",N,[[["ident"]],["nestedmetaitem"]]],[5,"mk_attr_id","","",N,[[],["attrid"]]],[5,"mk_attr_inner","","Returns an inner attribute with the given value.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_spanned_attr_inner","","Returns an inner attribute with the given value and span.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_attr_outer","","Returns an outer attribute with the given value.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_spanned_attr_outer","","Returns an outer attribute with the given value and span.",N,[[["span"],["attrid"],["metaitem"]],["attribute"]]],[5,"mk_sugared_doc_attr","","",N,[[["attrid"],["symbol"],["span"]],["attribute"]]],[5,"list_contains_name","","",N,N],[5,"contains_name","","",N,N],[5,"find_by_name","","",N,N],[5,"first_attr_value_str_by_name","","",N,N],[5,"inject","","",N,N],[0,"builtin","","Parsing and validation of builtin attributes",N,N],[3,"Stability","syntax::attr::builtin","Represents the #[stable], #[unstable], #[rustc_{deprecated,const_unstable}] attributes.",N,N],[12,"level","","",150,N],[12,"feature","","",150,N],[12,"rustc_depr","","",150,N],[12,"const_stability","","`None` means the function is stable but needs to be allowed by the `min_const_fn` feature `Some` contains the feature gate required to be able to use the function as const fn",150,N],[3,"RustcDeprecation","","",N,N],[12,"since","","",149,N],[12,"reason","","",149,N],[3,"Deprecation","","",N,N],[12,"since","","",148,N],[12,"note","","",148,N],[4,"AttrError","","",N,N],[13,"MultipleItem","","",156,N],[13,"UnknownMetaItem","","",156,N],[13,"MissingSince","","",156,N],[13,"MissingFeature","","",156,N],[13,"MultipleStabilityLevels","","",156,N],[13,"UnsupportedLiteral","","",156,N],[4,"InlineAttr","","",N,N],[13,"None","","",151,N],[13,"Hint","","",151,N],[13,"Always","","",151,N],[13,"Never","","",151,N],[4,"UnwindAttr","","",N,N],[13,"Allowed","","",155,N],[13,"Aborts","","",155,N],[4,"StabilityLevel","","The available stability levels.",N,N],[13,"Unstable","","",154,N],[12,"reason","syntax::attr::builtin::StabilityLevel","",154,N],[12,"issue","","",154,N],[13,"Stable","syntax::attr::builtin","",154,N],[12,"since","syntax::attr::builtin::StabilityLevel","",154,N],[4,"ReprAttr","syntax::attr::builtin","",N,N],[13,"ReprInt","","",153,N],[13,"ReprC","","",153,N],[13,"ReprPacked","","",153,N],[13,"ReprSimd","","",153,N],[13,"ReprTransparent","","",153,N],[13,"ReprAlign","","",153,N],[4,"IntType","","",N,N],[13,"SignedInt","","",152,N],[13,"UnsignedInt","","",152,N],[5,"handle_errors","","",N,[[["handler"],["span"],["attrerror"]]]],[5,"find_unwind_attr","","Determine what `#[unwind]` attribute is present in `attrs`, if any.",N,N],[5,"contains_feature_attr","","Check if `attrs` contains an attribute like `#![feature(feature_name)]`. This will not perform any \"sanity checks\" on the form of the attributes.",N,N],[5,"find_stability","","Find the first stability attribute. `None` if none exists.",N,N],[5,"find_stability_generic","","",N,[[["handler"],["i"],["span"]],["option",["stability"]]]],[5,"find_crate_name","","",N,N],[5,"cfg_matches","","Tests if a cfg-pattern matches the cfg set",N,[[["metaitem"],["parsesess"],["option",["features"]]],["bool"]]],[5,"eval_condition","","Evaluate a cfg-like condition (with `any` and `all`), using `eval` to evaluate individual items.",N,[[["metaitem"],["parsesess"],["f"]],["bool"]]],[5,"find_deprecation","","Find the deprecation attribute. `None` if none exists.",N,N],[5,"find_deprecation_generic","","",N,[[["handler"],["i"],["span"]],["option",["deprecation"]]]],[5,"find_repr_attrs","","Parse #[repr(...)] forms.",N,[[["handler"],["attribute"]],["vec",["reprattr"]]]],[5,"int_type_of_word","","",N,[[["str"]],["option",["inttype"]]]],[11,"clone","syntax::attr","",151,[[["self"]],["inlineattr"]]],[11,"hash","","",151,N],[11,"eq","","",151,[[["self"],["inlineattr"]],["bool"]]],[11,"encode","","",151,[[["self"],["__s"]],["result"]]],[11,"decode","","",151,[[["__d"]],["result",["inlineattr"]]]],[11,"clone","","",155,[[["self"]],["unwindattr"]]],[11,"eq","","",155,[[["self"],["unwindattr"]],["bool"]]],[11,"encode","","",150,[[["self"],["__s"]],["result"]]],[11,"decode","","",150,[[["__d"]],["result",["stability"]]]],[11,"clone","","",150,[[["self"]],["stability"]]],[11,"fmt","","",150,[[["self"],["formatter"]],["result"]]],[11,"eq","","",150,[[["self"],["stability"]],["bool"]]],[11,"ne","","",150,[[["self"],["stability"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",150,N],[11,"hash","","",150,N],[11,"encode","","",154,[[["self"],["__s"]],["result"]]],[11,"decode","","",154,[[["__d"]],["result",["stabilitylevel"]]]],[11,"eq","","",154,[[["self"],["stabilitylevel"]],["bool"]]],[11,"ne","","",154,[[["self"],["stabilitylevel"]],["bool"]]],[11,"partial_cmp","","",154,[[["self"],["stabilitylevel"]],["option",["ordering"]]]],[11,"lt","","",154,[[["self"],["stabilitylevel"]],["bool"]]],[11,"le","","",154,[[["self"],["stabilitylevel"]],["bool"]]],[11,"gt","","",154,[[["self"],["stabilitylevel"]],["bool"]]],[11,"ge","","",154,[[["self"],["stabilitylevel"]],["bool"]]],[11,"clone","","",154,[[["self"]],["stabilitylevel"]]],[11,"fmt","","",154,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",154,N],[11,"hash","","",154,N],[11,"is_unstable","","",154,[[["self"]],["bool"]]],[11,"is_stable","","",154,[[["self"]],["bool"]]],[11,"encode","","",149,[[["self"],["__s"]],["result"]]],[11,"decode","","",149,[[["__d"]],["result",["rustcdeprecation"]]]],[11,"eq","","",149,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"ne","","",149,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"partial_cmp","","",149,[[["self"],["rustcdeprecation"]],["option",["ordering"]]]],[11,"lt","","",149,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"le","","",149,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"gt","","",149,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"ge","","",149,[[["self"],["rustcdeprecation"]],["bool"]]],[11,"clone","","",149,[[["self"]],["rustcdeprecation"]]],[11,"fmt","","",149,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",149,N],[11,"hash","","",149,N],[11,"encode","","",148,[[["self"],["__s"]],["result"]]],[11,"decode","","",148,[[["__d"]],["result",["deprecation"]]]],[11,"eq","","",148,[[["self"],["deprecation"]],["bool"]]],[11,"ne","","",148,[[["self"],["deprecation"]],["bool"]]],[11,"partial_cmp","","",148,[[["self"],["deprecation"]],["option",["ordering"]]]],[11,"lt","","",148,[[["self"],["deprecation"]],["bool"]]],[11,"le","","",148,[[["self"],["deprecation"]],["bool"]]],[11,"gt","","",148,[[["self"],["deprecation"]],["bool"]]],[11,"ge","","",148,[[["self"],["deprecation"]],["bool"]]],[11,"clone","","",148,[[["self"]],["deprecation"]]],[11,"fmt","","",148,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",148,N],[11,"hash","","",148,N],[11,"eq","","",153,[[["self"],["reprattr"]],["bool"]]],[11,"ne","","",153,[[["self"],["reprattr"]],["bool"]]],[11,"fmt","","",153,[[["self"],["formatter"]],["result"]]],[11,"encode","","",153,[[["self"],["__s"]],["result"]]],[11,"decode","","",153,[[["__d"]],["result",["reprattr"]]]],[11,"clone","","",153,[[["self"]],["reprattr"]]],[11,"assert_receiver_is_total_eq","","",152,N],[11,"hash","","",152,N],[11,"eq","","",152,[[["self"],["inttype"]],["bool"]]],[11,"ne","","",152,[[["self"],["inttype"]],["bool"]]],[11,"fmt","","",152,[[["self"],["formatter"]],["result"]]],[11,"encode","","",152,[[["self"],["__s"]],["result"]]],[11,"decode","","",152,[[["__d"]],["result",["inttype"]]]],[11,"clone","","",152,[[["self"]],["inttype"]]],[11,"is_signed","","",152,[[["self"]],["bool"]]],[8,"HasAttrs","","",N,N],[10,"attrs","","",157,N],[10,"map_attrs","","",157,[[["self"],["f"]],["self"]]],[11,"meta_item","","Returns the MetaItem if self is a NestedMetaItemKind::MetaItem.",158,[[["self"]],["option",["metaitem"]]]],[11,"literal","","Returns the Lit if self is a NestedMetaItemKind::Literal.",158,[[["self"]],["option",["lit"]]]],[11,"span","","Returns the Span for `self`.",158,[[["self"]],["span"]]],[11,"check_name","","Returns true if this list item is a MetaItem with a name of `name`.",158,[[["self"],["str"]],["bool"]]],[11,"name","","Returns the name of the meta item, e.g. `foo` in `#[foo]`, `#[foo=\"bar\"]` and `#[foo(bar)]`, if self is a MetaItem",158,[[["self"]],["option",["name"]]]],[11,"value_str","","Gets the string value if self is a MetaItem and the MetaItem is a MetaItemKind::NameValue variant containing a string, otherwise None.",158,[[["self"]],["option",["symbol"]]]],[11,"name_value_literal","","Returns a name and single literal value tuple of the MetaItem.",158,[[["self"]],["option"]]],[11,"word","","Returns a MetaItem if self is a MetaItem with Kind Word.",158,[[["self"]],["option",["metaitem"]]]],[11,"meta_item_list","","Gets a list of inner meta items from a list MetaItem type.",158,[[["self"]],["option"]]],[11,"is_meta_item","","Returns `true` if the variant is MetaItem.",158,[[["self"]],["bool"]]],[11,"is_literal","","Returns `true` if the variant is Literal.",158,[[["self"]],["bool"]]],[11,"is_word","","Returns `true` if self is a MetaItem and the meta item is a word.",158,[[["self"]],["bool"]]],[11,"is_value_str","","Returns `true` if self is a MetaItem and the meta item is a ValueString.",158,[[["self"]],["bool"]]],[11,"is_meta_item_list","","Returns `true` if self is a MetaItem and the meta item is a list.",158,[[["self"]],["bool"]]],[11,"check_name","syntax::ast","",91,[[["self"],["str"]],["bool"]]],[11,"name","","Returns the last segment of the name of this attribute. E.g. `foo` for `#[foo]`, `skip` for `#[rustfmt::skip]`.",91,[[["self"]],["name"]]],[11,"value_str","","",91,[[["self"]],["option",["symbol"]]]],[11,"meta_item_list","","",91,[[["self"]],["option",["vec"]]]],[11,"is_word","","",91,[[["self"]],["bool"]]],[11,"span","","",91,[[["self"]],["span"]]],[11,"is_meta_item_list","","",91,[[["self"]],["bool"]]],[11,"is_value_str","","Indicates if the attribute is a Value String.",91,[[["self"]],["bool"]]],[11,"name","","",60,[[["self"]],["name"]]],[11,"value_str","","",60,[[["self"]],["option",["symbol"]]]],[11,"meta_item_list","","",60,[[["self"]],["option"]]],[11,"is_word","","",60,[[["self"]],["bool"]]],[11,"span","","",60,[[["self"]],["span"]]],[11,"check_name","","",60,[[["self"],["str"]],["bool"]]],[11,"is_value_str","","",60,[[["self"]],["bool"]]],[11,"is_meta_item_list","","",60,[[["self"]],["bool"]]],[11,"is_scoped","","",60,[[["self"]],["option",["ident"]]]],[11,"meta","","Extract the MetaItem from inside this Attribute.",91,[[["self"]],["option",["metaitem"]]]],[11,"parse","","",91,[[["self"],["parsesess"],["f"]],["presult"]]],[11,"parse_list","","",91,[[["self"],["parsesess"],["f"]],["presult",["vec"]]]],[11,"parse_meta","","",91,[[["self"],["parsesess"]],["presult",["metaitem"]]]],[11,"with_desugared_doc","","Convert self to a normal #[doc=\"foo\"] comment, if it is a comment like `///` or `/** */`. (Returns self unchanged for non-sugared doc attributes.)",91,[[["self"],["f"]],["t"]]],[11,"tokens","","",60,[[["self"]],["tokenstream"]]],[11,"from_tokens","","",60,[[["peekable"]],["option",["metaitem"]]]],[11,"tokens","","",105,[[["self"],["span"]],["tokenstream"]]],[11,"from_tokens","","",105,[[["peekable"]],["option",["metaitemkind"]]]],[11,"span","","",104,[[["self"]],["span"]]],[11,"tokens","","",104,[[["self"]],["tokenstream"]]],[11,"from_tokens","","",104,[[["peekable"]],["option",["nestedmetaitemkind"]]]],[11,"tokens","syntax::attr","",159,[[["self"]],["tokenstream"]]],[11,"token","syntax::ast","",125,[[["self"]],["token"]]],[11,"from_token","","",125,[[["token"]],["option",["litkind"]]]],[11,"attrs","syntax","",0,N],[11,"map_attrs","","",0,[[["self"],["f"]],["self"]]],[11,"attrs","syntax::ast","",113,N],[11,"map_attrs","","",113,[[["self"],["f"]],["self"]]],[11,"attrs","","",64,N],[11,"map_attrs","","",64,[[["self"],["f"]],["self"]]],[11,"attrs","","",53,N],[11,"map_attrs","","",53,[[["self"],["f"]],["self"]]],[11,"attrs","","",95,N],[11,"map_attrs","","",95,[[["self"],["f"]],["self"]]],[11,"attrs","","",69,N],[11,"map_attrs","","",69,[[["self"],["f"]],["self"]]],[11,"attrs","","",65,N],[11,"map_attrs","","",65,[[["self"],["f"]],["self"]]],[11,"attrs","","",97,N],[11,"map_attrs","","",97,[[["self"],["f"]],["self"]]],[11,"attrs","","",94,N],[11,"map_attrs","","",94,[[["self"],["f"]],["self"]]],[11,"attrs","","",76,N],[11,"map_attrs","","",76,[[["self"],["f"]],["self"]]],[11,"attrs","","",75,N],[11,"map_attrs","","",75,[[["self"],["f"]],["self"]]],[11,"attrs","","",66,N],[11,"map_attrs","","",66,[[["self"],["f"]],["self"]]],[11,"attrs","","",67,N],[11,"map_attrs","","",67,[[["self"],["f"]],["self"]]],[11,"attrs","","",63,N],[11,"map_attrs","","",63,[[["self"],["f"]],["self"]]],[11,"attrs","","",88,N],[11,"map_attrs","","",88,[[["self"],["f"]],["self"]]],[0,"source_map","syntax","The SourceMap tracks all the source code used within a single crate, mapping from integer byte positions to the original source code location. Each bit of source parsed during crate parsing (typically files, in-memory strings, or various bits of macro expansion) cover a continuous range of bytes in the SourceMap and are represented by SourceFiles. Byte positions are stored in `spans` and used pervasively in the compiler. They are absolute positions within the SourceMap, which upon request can be converted to line and column information, source code snippets, etc.",N,N],[0,"edition","syntax::source_map","",N,N],[4,"Edition","syntax::source_map::edition","The edition of the compiler (RFC 2052)",N,N],[13,"Edition2015","","The 2015 edition",1,N],[13,"Edition2018","","The 2018 edition",1,N],[17,"ALL_EDITIONS","","",N,N],[17,"EDITION_NAME_LIST","","",N,N],[17,"DEFAULT_EDITION","","",N,N],[0,"hygiene","syntax::source_map","Machinery for hygienic macros, inspired by the `MTWT[1]` paper.",N,N],[3,"SyntaxContext","syntax::source_map::hygiene","A SyntaxContext represents a chain of macro expansions (represented by marks).",N,N],[12,"0","","",160,N],[3,"Mark","","A mark is a unique id associated with a macro expansion.",N,N],[12,"0","","",161,N],[4,"Transparency","","A property of a macro expansion that determines how identifiers produced by that expansion are resolved.",N,N],[13,"Transparent","","Identifier produced by a transparent expansion is always resolved at call-site. Call-site spans in procedural macros, hygiene opt-out in `macro` should use this.",162,N],[13,"SemiTransparent","","Identifier produced by a semi-transparent expansion may be resolved either at call-site or at definition-site. If it's a local variable, label or `$crate` then it's resolved at def-site. Otherwise it's resolved at call-site. `macro_rules` macros behave like this, built-in macros currently behave like this too, but that's an implementation detail.",162,N],[13,"Opaque","","Identifier produced by an opaque expansion is always resolved at definition-site. Def-site spans in procedural macros, identifiers from `macro` by default use this.",162,N],[5,"default_edition","","",N,[[],["edition"]]],[5,"set_default_edition","","",N,N],[5,"clear_markings","","",N,N],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",N,N],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",163,N],[12,"def_site","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None. This span serves only informational purpose and is not used for resolution.",163,N],[12,"format","","The format with which the macro was invoked.",163,N],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",163,N],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",163,N],[12,"local_inner_macros","","Enables the macro helper hack (`ident!(...)` -> `$crate::ident!(...)`) for a given macro.",163,N],[12,"edition","","Edition of the crate in which the macro is defined.",163,N],[4,"ExpnFormat","","The source of expansion.",N,N],[13,"MacroAttribute","","e.g. #[derive(...)] ",164,N],[13,"MacroBang","","e.g. `format!()`",164,N],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",164,N],[4,"CompilerDesugaringKind","","The kind of compiler desugaring.",N,N],[13,"QuestionMark","","",165,N],[13,"TryBlock","","",165,N],[13,"ExistentialReturnType","","Desugaring of an `impl Trait` in return type position to an `existential type Foo: Trait;` + replacing the `impl Trait` with `Foo`.",165,N],[13,"Async","","",165,N],[13,"ForLoop","","",165,N],[0,"symbol","syntax::source_map","An \"interner\" is a data structure that associates values with usize tags and allows bidirectional lookup; i.e. given a value, one can easily find the type, and vice versa.",N,N],[3,"Ident","syntax::source_map::symbol","",N,N],[12,"name","","",2,N],[12,"span","","",2,N],[3,"Symbol","","A symbol is an interned or gensymed string.",N,N],[12,"0","","",3,N],[3,"Interner","","",N,N],[12,"arena","","",4,N],[12,"names","","",4,N],[12,"strings","","",4,N],[12,"gensyms","","",4,N],[0,"keywords","","",N,N],[3,"Keyword","syntax::source_map::symbol::keywords","",N,N],[12,"ident","","",5,N],[17,"Invalid","","",N,N],[17,"CrateRoot","","",N,N],[17,"DollarCrate","","",N,N],[17,"Underscore","","",N,N],[17,"As","","",N,N],[17,"Box","","",N,N],[17,"Break","","",N,N],[17,"Const","","",N,N],[17,"Continue","","",N,N],[17,"Crate","","",N,N],[17,"Else","","",N,N],[17,"Enum","","",N,N],[17,"Extern","","",N,N],[17,"False","","",N,N],[17,"Fn","","",N,N],[17,"For","","",N,N],[17,"If","","",N,N],[17,"Impl","","",N,N],[17,"In","","",N,N],[17,"Let","","",N,N],[17,"Loop","","",N,N],[17,"Match","","",N,N],[17,"Mod","","",N,N],[17,"Move","","",N,N],[17,"Mut","","",N,N],[17,"Pub","","",N,N],[17,"Ref","","",N,N],[17,"Return","","",N,N],[17,"SelfValue","","",N,N],[17,"SelfType","","",N,N],[17,"Static","","",N,N],[17,"Struct","","",N,N],[17,"Super","","",N,N],[17,"Trait","","",N,N],[17,"True","","",N,N],[17,"Type","","",N,N],[17,"Unsafe","","",N,N],[17,"Use","","",N,N],[17,"Where","","",N,N],[17,"While","","",N,N],[17,"Abstract","","",N,N],[17,"Become","","",N,N],[17,"Do","","",N,N],[17,"Final","","",N,N],[17,"Macro","","",N,N],[17,"Override","","",N,N],[17,"Priv","","",N,N],[17,"Typeof","","",N,N],[17,"Unsized","","",N,N],[17,"Virtual","","",N,N],[17,"Yield","","",N,N],[17,"Async","","",N,N],[17,"Try","","",N,N],[17,"UnderscoreLifetime","","",N,N],[17,"StaticLifetime","","",N,N],[17,"Auto","","",N,N],[17,"Catch","","",N,N],[17,"Default","","",N,N],[17,"Dyn","","",N,N],[17,"Union","","",N,N],[17,"Existential","","",N,N],[3,"LocalInternedString","syntax::source_map::symbol","Represents a string stored in the interner. Because the interner outlives any thread which uses this type, we can safely treat `string` which points to interner data, as an immortal string, as long as this type never crosses between threads.",N,N],[12,"string","","",6,N],[3,"InternedString","","Represents a string stored in the string interner",N,N],[12,"symbol","","",7,N],[3,"Globals","syntax::source_map","",N,N],[12,"symbol_interner","","",166,N],[12,"span_interner","","",166,N],[12,"hygiene_data","","",166,N],[7,"GLOBALS","","",N,N],[4,"FileName","","Differentiates between real files and common virtual files",N,N],[13,"Real","","",167,N],[13,"Macros","","A macro.  This includes the full name of the macro, so that there are no clashes.",167,N],[13,"QuoteExpansion","","call to `quote!`",167,N],[13,"Anon","","Command line",167,N],[13,"MacroExpansion","","Hack in src/libsyntax/parse.rs FIXME(jseyfried)",167,N],[13,"ProcMacroSourceCode","","",167,N],[13,"CfgSpec","","Strings provided as --cfg [cfgspec] stored in a crate_cfg",167,N],[13,"CliCrateAttr","","Strings provided as crate attributes in the CLI",167,N],[13,"Custom","","Custom sources for explicit parser calls from plugins and drivers",167,N],[3,"SpanData","","Spans represent a region of code, used for error reporting. Positions in spans are absolute positions from the beginning of the source_map, not positions relative to SourceFiles. Methods on the SourceMap can be used to relate spans back to the original source. You must be careful if the span crosses more than one file - you will not be able to use many of the functions on spans in source_map and you cannot assume that the length of the span = hi - lo; there may be space in the BytePos range between files.",N,N],[12,"lo","","",168,N],[12,"hi","","",168,N],[12,"ctxt","","Information about where the macro came from, if this piece of code was created by a macro expansion.",168,N],[3,"MultiSpan","","A collection of spans. Spans have two orthogonal attributes:",N,N],[12,"primary_spans","","",169,N],[12,"span_labels","","",169,N],[3,"SpanLabel","","",N,N],[12,"span","","The span we are going to include in the final snippet.",170,N],[12,"is_primary","","Is this a primary span? This is the \"locus\" of the message, and is indicated with a `^^^^` underline, versus `----`.",170,N],[12,"label","","What label should we attach to this span (if any)?",170,N],[17,"NO_EXPANSION","","",N,N],[3,"MultiByteChar","","Identifies an offset of a multi-byte character in a SourceFile",N,N],[12,"pos","","The absolute offset of the character in the SourceMap",171,N],[12,"bytes","","The number of bytes, >=2",171,N],[4,"NonNarrowChar","","Identifies an offset of a non-narrow character in a SourceFile",N,N],[13,"ZeroWidth","","Represents a zero-width character",172,N],[13,"Wide","","Represents a wide (fullwidth) character",172,N],[13,"Tab","","Represents a tab character, represented visually with a width of 4 characters",172,N],[4,"ExternalSource","","The state of the lazy external source loading mechanism of a SourceFile.",N,N],[13,"Present","","The external source has been loaded already.",173,N],[13,"AbsentOk","","No attempt has been made to load the external source.",173,N],[13,"AbsentErr","","A failed attempt has been made to load the external source.",173,N],[13,"Unneeded","","No external source has to be loaded, since the SourceFile represents a local crate.",173,N],[3,"SourceFile","","A single source in the SourceMap.",N,N],[12,"name","","The name of the file that the source came from, source that doesn't originate from files has names between angle brackets by convention, e.g. `<anon>`",174,N],[12,"name_was_remapped","","True if the `name` field above has been modified by --remap-path-prefix",174,N],[12,"unmapped_path","","The unmapped path of the file that the source came from. Set to `None` if the SourceFile was imported from an external crate.",174,N],[12,"crate_of_origin","","Indicates which crate this SourceFile was imported from.",174,N],[12,"src","","The complete source code",174,N],[12,"src_hash","","The source code's hash",174,N],[12,"external_src","","The external source code (used for external crates, which will have a `None` value as `self.src`.",174,N],[12,"start_pos","","The start position of this source in the SourceMap",174,N],[12,"end_pos","","The end position of this source in the SourceMap",174,N],[12,"lines","","Locations of lines beginnings in the source code",174,N],[12,"multibyte_chars","","Locations of multi-byte characters in the source code",174,N],[12,"non_narrow_chars","","Width of characters that are not narrow in the source code",174,N],[12,"name_hash","","A hash of the filename, used for speeding up the incr. comp. hashing.",174,N],[8,"Pos","","",N,N],[10,"from_usize","","",175,[[["usize"]],["self"]]],[10,"to_usize","","",175,[[["self"]],["usize"]]],[10,"from_u32","","",175,[[["u32"]],["self"]]],[10,"to_u32","","",175,[[["self"]],["u32"]]],[3,"BytePos","","A byte offset. Keep this small (currently 32-bits), as AST contains a lot of them.",N,N],[12,"0","","",176,N],[3,"CharPos","","A character offset. Because of multibyte utf8 characters, a byte offset is not equivalent to a character offset. The SourceMap will convert BytePos values to CharPos values as necessary.",N,N],[12,"0","","",177,N],[3,"Loc","","A source code location used for error reporting",N,N],[12,"file","","Information about the original source",178,N],[12,"line","","The (1-based) line number",178,N],[12,"col","","The (0-based) column offset",178,N],[12,"col_display","","The (0-based) column offset when displayed",178,N],[3,"LocWithOpt","","A source code location used as the result of lookup_char_pos_adj",N,N],[12,"filename","","",179,N],[12,"line","","",179,N],[12,"col","","",179,N],[12,"file","","",179,N],[3,"SourceFileAndLine","","",N,N],[12,"fm","","",180,N],[12,"line","","",180,N],[3,"SourceFileAndBytePos","","",N,N],[12,"fm","","",181,N],[12,"pos","","",181,N],[3,"LineInfo","","",N,N],[12,"line_index","","Index of line, starting from 0.",182,N],[12,"start_col","","Column in line where span begins, starting from 0.",182,N],[12,"end_col","","Column in line where span ends, starting from 0, exclusive.",182,N],[3,"FileLines","","",N,N],[12,"file","","",183,N],[12,"lines","","",183,N],[17,"SPAN_DEBUG","","",N,N],[3,"MacroBacktrace","","",N,N],[12,"call_site","","span where macro was applied to generate this code",184,N],[12,"macro_decl_name","","name of macro that was applied (e.g., \"foo!\" or \"#[derive(Eq)]\")",184,N],[12,"def_site_span","","span where macro was defined (if known)",184,N],[6,"FileLinesResult","","",N,N],[4,"SpanLinesError","","",N,N],[13,"IllFormedSpan","","",185,N],[13,"DistinctSources","","",185,N],[4,"SpanSnippetError","","",N,N],[13,"IllFormedSpan","","",186,N],[13,"DistinctSources","","",186,N],[13,"MalformedForCodemap","","",186,N],[13,"SourceNotAvailable","","",186,N],[12,"filename","syntax::source_map::SpanSnippetError","",186,N],[3,"DistinctSources","syntax::source_map","",N,N],[12,"begin","","",187,N],[12,"end","","",187,N],[3,"MalformedCodemapPositions","","",N,N],[12,"name","","",188,N],[12,"source_len","","",188,N],[12,"begin_pos","","",188,N],[12,"end_pos","","",188,N],[3,"Span","","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",N,N],[12,"0","","",189,N],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",N,N],[4,"ExpnFormat","","The source of expansion.",N,N],[13,"MacroAttribute","","e.g. #[derive(...)] ",164,N],[13,"MacroBang","","e.g. `format!()`",164,N],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",164,N],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",N,N],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",163,N],[12,"def_site","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None. This span serves only informational purpose and is not used for resolution.",163,N],[12,"format","","The format with which the macro was invoked.",163,N],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",163,N],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",163,N],[12,"local_inner_macros","","Enables the macro helper hack (`ident!(...)` -> `$crate::ident!(...)`) for a given macro.",163,N],[12,"edition","","Edition of the crate in which the macro is defined.",163,N],[3,"Spanned","","",N,N],[12,"node","","",190,N],[12,"span","","",190,N],[3,"RealFileLoader","","A FileLoader that uses std::fs to load real files.",N,N],[3,"StableFilemapId","","",N,N],[12,"0","","",191,N],[3,"SourceMapFiles","","",N,N],[12,"file_maps","","",192,N],[12,"stable_id_to_source_file","","",192,N],[3,"SourceMap","","",N,N],[12,"files","","",193,N],[12,"file_loader","","",193,N],[12,"path_mapping","","",193,N],[12,"doctest_offset","","In case we are in a doctest, replace all file names with the PathBuf, and add the given offsets to the line info",193,N],[3,"FilePathMapping","","",N,N],[12,"mapping","","",194,N],[5,"original_sp","","Return the span itself if it doesn't come from a macro expansion, otherwise return the call site span up to the `enclosing_sp` by following the `expn_info` chain.",N,[[["span"],["span"]],["span"]]],[5,"respan","","",N,[[["span"],["t"]],["spanned"]]],[5,"dummy_spanned","","",N,[[["t"]],["spanned"]]],[8,"FileLoader","","An abstraction over the fs operations used by the Parser.",N,N],[10,"file_exists","","Query the existence of a file.",195,[[["self"],["path"]],["bool"]]],[10,"abs_path","","Return an absolute path to a file, if possible.",195,[[["self"],["path"]],["option",["pathbuf"]]]],[10,"read_file","","Read the contents of an UTF-8 file into memory.",195,[[["self"],["path"]],["result",["string"]]]],[11,"clone","","",190,[[["self"]],["spanned"]]],[11,"eq","","",190,[[["self"],["spanned"]],["bool"]]],[11,"ne","","",190,[[["self"],["spanned"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",190,N],[11,"encode","","",190,[[["self"],["__st"]],["result"]]],[11,"decode","","",190,[[["__dt"]],["result",["spanned"]]]],[11,"hash","","",190,N],[11,"fmt","","",190,[[["self"],["formatter"]],["result"]]],[11,"file_exists","","",196,[[["self"],["path"]],["bool"]]],[11,"abs_path","","",196,[[["self"],["path"]],["option",["pathbuf"]]]],[11,"read_file","","",196,[[["self"],["path"]],["result",["string"]]]],[11,"clone","","",191,[[["self"]],["stablefilemapid"]]],[11,"eq","","",191,[[["self"],["stablefilemapid"]],["bool"]]],[11,"ne","","",191,[[["self"],["stablefilemapid"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",191,N],[11,"hash","","",191,N],[11,"encode","","",191,[[["self"],["__s"]],["result"]]],[11,"decode","","",191,[[["__d"]],["result",["stablefilemapid"]]]],[11,"fmt","","",191,[[["self"],["formatter"]],["result"]]],[11,"new","","",191,[[["sourcefile"]],["stablefilemapid"]]],[11,"new","","",193,[[["filepathmapping"]],["sourcemap"]]],[11,"new_doctest","","",193,[[["filepathmapping"],["filename"],["isize"]],["sourcemap"]]],[11,"with_file_loader","","",193,[[["box",["fileloader"]],["filepathmapping"]],["sourcemap"]]],[11,"path_mapping","","",193,[[["self"]],["filepathmapping"]]],[11,"file_exists","","",193,[[["self"],["path"]],["bool"]]],[11,"load_file","","",193,[[["self"],["path"]],["result",["lrc"]]]],[11,"files","","",193,[[["self"]],["mappedlockguard",["vec"]]]],[11,"source_file_by_stable_id","","",193,[[["self"],["stablefilemapid"]],["option",["lrc"]]]],[11,"next_start_pos","","",193,[[["self"]],["usize"]]],[11,"new_source_file","","Creates a new source_file. This does not ensure that only one SourceFile exists per file name.",193,[[["self"],["filename"],["string"]],["lrc",["sourcefile"]]]],[11,"new_imported_source_file","","Allocates a new SourceFile representing a source file from an external crate. The source code of such an \"imported source_file\" is not available, but we still know enough to generate accurate debuginfo location information for things inlined from other crates.",193,[[["self"],["filename"],["bool"],["u32"],["u128"],["u128"],["usize"],["vec",["bytepos"]],["vec",["multibytechar"]],["vec",["nonnarrowchar"]]],["lrc",["sourcefile"]]]],[11,"mk_substr_filename","","",193,[[["self"],["span"]],["string"]]],[11,"doctest_offset_line","","",193,[[["self"],["usize"]],["usize"]]],[11,"lookup_char_pos","","Lookup source information about a BytePos",193,[[["self"],["bytepos"]],["loc"]]],[11,"lookup_line","","",193,[[["self"],["bytepos"]],["result",["sourcefileandline","lrc"]]]],[11,"lookup_char_pos_adj","","",193,[[["self"],["bytepos"]],["locwithopt"]]],[11,"merge_spans","","Returns `Some(span)`, a union of the lhs and rhs span.  The lhs must precede the rhs. If there are gaps between lhs and rhs, the resulting union will cross these gaps. For this to work, the spans have to be:",193,[[["self"],["span"],["span"]],["option",["span"]]]],[11,"span_to_string","","",193,[[["self"],["span"]],["string"]]],[11,"span_to_filename","","",193,[[["self"],["span"]],["filename"]]],[11,"span_to_unmapped_path","","",193,[[["self"],["span"]],["filename"]]],[11,"is_multiline","","",193,[[["self"],["span"]],["bool"]]],[11,"span_to_lines","","",193,[[["self"],["span"]],["filelinesresult"]]],[11,"span_to_source","","Extract the source surrounding the given `Span` using the `extract_source` function. The extract function takes three arguments: a string slice containing the source, an index in the slice for the beginning of the span and an index in the slice for the end of the span.",193,[[["self"],["span"],["f"]],["result",["string","spansnippeterror"]]]],[11,"span_to_snippet","","Return the source snippet as `String` corresponding to the given `Span`",193,[[["self"],["span"]],["result",["string","spansnippeterror"]]]],[11,"span_to_margin","","",193,[[["self"],["span"]],["option",["usize"]]]],[11,"span_to_prev_source","","Return the source snippet as `String` before the given `Span`",193,[[["self"],["span"]],["result",["string","spansnippeterror"]]]],[11,"span_extend_to_prev_char","","Extend the given `Span` to just after the previous occurrence of `c`. Return the same span if no character could be found or if an error occurred while retrieving the code snippet.",193,[[["self"],["span"],["char"]],["span"]]],[11,"span_extend_to_prev_str","","Extend the given `Span` to just after the previous occurrence of `pat` when surrounded by whitespace. Return the same span if no character could be found or if an error occurred while retrieving the code snippet.",193,[[["self"],["span"],["str"],["bool"]],["span"]]],[11,"span_until_char","","Given a `Span`, try to get a shorter span ending before the first occurrence of `c` `char`",193,[[["self"],["span"],["char"]],["span"]]],[11,"span_through_char","","Given a `Span`, try to get a shorter span ending just after the first occurrence of `char` `c`.",193,[[["self"],["span"],["char"]],["span"]]],[11,"span_until_non_whitespace","","Given a `Span`, get a new `Span` covering the first token and all its trailing whitespace or the original `Span`.",193,[[["self"],["span"]],["span"]]],[11,"span_until_whitespace","","Given a `Span`, get a new `Span` covering the first token without its trailing whitespace or the original `Span` in case of error.",193,[[["self"],["span"]],["span"]]],[11,"span_take_while","","Given a `Span`, get a shorter one until `predicate` yields false.",193,[[["self"],["span"],["p"]],["span"]]],[11,"def_span","","",193,[[["self"],["span"]],["span"]]],[11,"start_point","","Returns a new span representing just the start-point of this span",193,[[["self"],["span"]],["span"]]],[11,"end_point","","Returns a new span representing just the end-point of this span",193,[[["self"],["span"]],["span"]]],[11,"next_point","","Returns a new span representing the next character after the end-point of this span",193,[[["self"],["span"]],["span"]]],[11,"find_width_of_character_at_span","","Finds the width of a character, either before or after the provided span.",193,[[["self"],["span"],["bool"]],["u32"]]],[11,"get_source_file","","",193,[[["self"],["filename"]],["option",["lrc"]]]],[11,"lookup_byte_offset","","For a global BytePos compute the local offset within the containing SourceFile",193,[[["self"],["bytepos"]],["sourcefileandbytepos"]]],[11,"bytepos_to_file_charpos","","Converts an absolute BytePos to a CharPos relative to the source_file.",193,[[["self"],["bytepos"]],["charpos"]]],[11,"lookup_source_file_idx","","",193,[[["self"],["bytepos"]],["usize"]]],[11,"count_lines","","",193,[[["self"]],["usize"]]],[11,"generate_fn_name_span","","",193,[[["self"],["span"]],["option",["span"]]]],[11,"generate_local_type_param_snippet","","Take the span of a type parameter in a function signature and try to generate a span for the function name (with generics) and a new snippet for this span with the pointed type parameter as a new local type parameter.",193,[[["self"],["span"]],["option"]]],[11,"lookup_char_pos","","",193,[[["self"],["bytepos"]],["loc"]]],[11,"span_to_lines","","",193,[[["self"],["span"]],["filelinesresult"]]],[11,"span_to_string","","",193,[[["self"],["span"]],["string"]]],[11,"span_to_filename","","",193,[[["self"],["span"]],["filename"]]],[11,"merge_spans","","",193,[[["self"],["span"],["span"]],["option",["span"]]]],[11,"call_span_if_macro","","",193,[[["self"],["span"]],["span"]]],[11,"ensure_source_file_source_present","","",193,[[["self"],["lrc",["sourcefile"]]],["bool"]]],[11,"doctest_offset_line","","",193,[[["self"],["usize"]],["usize"]]],[11,"clone","","",194,[[["self"]],["filepathmapping"]]],[11,"empty","","",194,[[],["filepathmapping"]]],[11,"new","","",194,[[["vec"]],["filepathmapping"]]],[11,"map_prefix","","Applies any path prefix substitution as defined by the mapping. The return value is the remapped path and a boolean indicating whether the path was affected by the mapping.",194,N],[0,"config","syntax","",N,N],[3,"StripUnconfigured","syntax::config","A folder that strips out items that do not belong in the current configuration.",N,N],[12,"sess","","",197,N],[12,"features","","",197,N],[5,"features","","",N,N],[5,"is_cfg","","",N,[[["attribute"]],["bool"]]],[11,"configure","","",197,[[["self"],["t"]],["option"]]],[11,"process_cfg_attrs","","",197,[[["self"],["t"]],["t"]]],[11,"process_cfg_attr","","",197,[[["self"],["attribute"]],["option",["attribute"]]]],[11,"in_cfg","","",197,N],[11,"visit_expr_attrs","","",197,N],[11,"maybe_emit_expr_attr_err","","If attributes are not allowed on expressions, emit an error for `attr`",197,[[["self"],["attribute"]]]],[11,"configure_foreign_mod","","",197,[[["self"],["foreignmod"]],["foreignmod"]]],[11,"configure_variant_data","","",197,[[["self"],["variantdata"]],["variantdata"]]],[11,"configure_item_kind","","",197,[[["self"],["itemkind"]],["itemkind"]]],[11,"configure_expr_kind","","",197,[[["self"],["exprkind"]],["exprkind"]]],[11,"configure_expr","","",197,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"configure_stmt","","",197,[[["self"],["stmt"]],["option",["stmt"]]]],[11,"configure_struct_expr_field","","",197,[[["self"],["field"]],["option",["field"]]]],[11,"configure_pat","","",197,[[["self"],["p",["pat"]]],["p",["pat"]]]],[11,"disallow_cfg_on_generic_param","","",197,[[["self"],["genericparam"]]]],[11,"fold_foreign_mod","","",197,[[["self"],["foreignmod"]],["foreignmod"]]],[11,"fold_item_kind","","",197,[[["self"],["itemkind"]],["itemkind"]]],[11,"fold_expr","","",197,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"fold_opt_expr","","",197,[[["self"],["p",["expr"]]],["option",["p"]]]],[11,"fold_stmt","","",197,[[["self"],["stmt"]],["onevector",["stmt"]]]],[11,"fold_item","","",197,[[["self"],["p",["item"]]],["onevector",["p"]]]],[11,"fold_impl_item","","",197,[[["self"],["implitem"]],["onevector",["implitem"]]]],[11,"fold_trait_item","","",197,[[["self"],["traititem"]],["onevector",["traititem"]]]],[11,"fold_mac","","",197,[[["self"],["mac"]],["mac"]]],[11,"fold_pat","","",197,[[["self"],["p",["pat"]]],["p",["pat"]]]],[0,"entry","syntax","",N,N],[4,"EntryPointType","syntax::entry","",N,N],[13,"None","","",198,N],[13,"MainNamed","","",198,N],[13,"MainAttr","","",198,N],[13,"Start","","",198,N],[13,"OtherMain","","",198,N],[5,"entry_point_type","","",N,[[["item"],["usize"]],["entrypointtype"]]],[0,"feature_gate","syntax","Feature gating",N,N],[3,"Features","syntax::feature_gate","A set of features to be used by later passes.",N,N],[12,"declared_lang_features","","`#![feature]` attrs for language features, for error reporting",199,N],[12,"declared_lib_features","","`#![feature]` attrs for non-language (library) features",199,N],[12,"asm","","",199,N],[12,"concat_idents","","",199,N],[12,"link_args","","",199,N],[12,"log_syntax","","",199,N],[12,"non_ascii_idents","","",199,N],[12,"plugin_registrar","","",199,N],[12,"thread_local","","",199,N],[12,"trace_macros","","",199,N],[12,"intrinsics","","",199,N],[12,"lang_items","","",199,N],[12,"format_args_nl","","",199,N],[12,"link_llvm_intrinsics","","",199,N],[12,"linkage","","",199,N],[12,"quote","","",199,N],[12,"rustc_diagnostic_macros","","",199,N],[12,"rustc_const_unstable","","",199,N],[12,"box_syntax","","",199,N],[12,"unboxed_closures","","",199,N],[12,"fundamental","","",199,N],[12,"main","","",199,N],[12,"needs_allocator","","",199,N],[12,"on_unimplemented","","",199,N],[12,"plugin","","",199,N],[12,"simd_ffi","","",199,N],[12,"start","","",199,N],[12,"structural_match","","",199,N],[12,"panic_runtime","","",199,N],[12,"needs_panic_runtime","","",199,N],[12,"optin_builtin_traits","","",199,N],[12,"staged_api","","",199,N],[12,"no_core","","",199,N],[12,"box_patterns","","",199,N],[12,"dropck_parametricity","","",199,N],[12,"dropck_eyepatch","","",199,N],[12,"custom_attribute","","",199,N],[12,"custom_derive","","",199,N],[12,"rustc_attrs","","",199,N],[12,"nll","","",199,N],[12,"allow_internal_unstable","","",199,N],[12,"allow_internal_unsafe","","",199,N],[12,"slice_patterns","","",199,N],[12,"const_fn","","",199,N],[12,"min_const_fn","","",199,N],[12,"const_let","","",199,N],[12,"const_fn_union","","",199,N],[12,"const_raw_ptr_to_usize_cast","","",199,N],[12,"const_raw_ptr_deref","","",199,N],[12,"const_transmute","","",199,N],[12,"const_compare_raw_pointers","","",199,N],[12,"const_panic","","",199,N],[12,"prelude_import","","",199,N],[12,"default_type_parameter_fallback","","",199,N],[12,"associated_type_defaults","","",199,N],[12,"repr_simd","","",199,N],[12,"platform_intrinsics","","",199,N],[12,"unwind_attributes","","",199,N],[12,"naked_functions","","",199,N],[12,"no_debug","","",199,N],[12,"omit_gdb_pretty_printer_section","","",199,N],[12,"cfg_target_vendor","","",199,N],[12,"stmt_expr_attributes","","",199,N],[12,"type_ascription","","",199,N],[12,"cfg_target_thread_local","","",199,N],[12,"abi_vectorcall","","",199,N],[12,"exclusive_range_pattern","","",199,N],[12,"specialization","","",199,N],[12,"cfg_target_has_atomic","","",199,N],[12,"never_type","","",199,N],[12,"exhaustive_patterns","","",199,N],[12,"untagged_unions","","",199,N],[12,"compiler_builtins","","",199,N],[12,"link_cfg","","",199,N],[12,"abi_ptx","","",199,N],[12,"repr128","","",199,N],[12,"abi_unadjusted","","",199,N],[12,"decl_macro","","",199,N],[12,"static_nobundle","","",199,N],[12,"abi_msp430_interrupt","","",199,N],[12,"sanitizer_runtime","","",199,N],[12,"profiler_runtime","","",199,N],[12,"abi_x86_interrupt","","",199,N],[12,"try_blocks","","",199,N],[12,"global_asm","","",199,N],[12,"overlapping_marker_traits","","",199,N],[12,"abi_thiscall","","",199,N],[12,"allow_fail","","",199,N],[12,"unsized_tuple_coercion","","",199,N],[12,"generators","","",199,N],[12,"trait_alias","","",199,N],[12,"allocator_internals","","",199,N],[12,"doc_cfg","","",199,N],[12,"doc_masked","","",199,N],[12,"doc_spotlight","","",199,N],[12,"external_doc","","",199,N],[12,"non_exhaustive","","",199,N],[12,"crate_visibility_modifier","","",199,N],[12,"extern_types","","",199,N],[12,"arbitrary_self_types","","",199,N],[12,"in_band_lifetimes","","",199,N],[12,"generic_associated_types","","",199,N],[12,"extern_in_paths","","",199,N],[12,"non_modrs_mods","","",199,N],[12,"macro_at_most_once_rep","","",199,N],[12,"infer_outlives_requirements","","",199,N],[12,"infer_static_outlives_requirements","","",199,N],[12,"if_while_or_patterns","","",199,N],[12,"pattern_parentheses","","",199,N],[12,"repr_packed","","",199,N],[12,"underscore_imports","","",199,N],[12,"macros_in_extern","","",199,N],[12,"existential_type","","",199,N],[12,"arm_target_feature","","",199,N],[12,"aarch64_target_feature","","",199,N],[12,"hexagon_target_feature","","",199,N],[12,"powerpc_target_feature","","",199,N],[12,"mips_target_feature","","",199,N],[12,"avx512_target_feature","","",199,N],[12,"mmx_target_feature","","",199,N],[12,"sse4a_target_feature","","",199,N],[12,"tbm_target_feature","","",199,N],[12,"wasm_target_feature","","",199,N],[12,"proc_macro_mod","","",199,N],[12,"proc_macro_expr","","",199,N],[12,"proc_macro_non_items","","",199,N],[12,"proc_macro_gen","","",199,N],[12,"doc_alias","","",199,N],[12,"tool_lints","","",199,N],[12,"irrefutable_let_patterns","","",199,N],[12,"macro_literal_matcher","","",199,N],[12,"trivial_bounds","","",199,N],[12,"label_break_value","","",199,N],[12,"exhaustive_integer_patterns","","",199,N],[12,"panic_implementation","","",199,N],[12,"doc_keyword","","",199,N],[12,"async_await","","",199,N],[12,"alloc_error_handler","","",199,N],[12,"abi_amdgpu_kernel","","",199,N],[12,"impl_header_lifetime_elision","","",199,N],[12,"unrestricted_attribute_tokens","","",199,N],[12,"uniform_paths","","",199,N],[12,"self_in_typedefs","","",199,N],[12,"unsized_locals","","",199,N],[12,"custom_test_frameworks","","",199,N],[12,"custom_inner_attributes","","",199,N],[12,"self_struct_ctor","","",199,N],[3,"GatedCfg","","",N,N],[12,"span","","",200,N],[12,"index","","",200,N],[3,"Context","","",N,N],[12,"features","","",201,N],[12,"parse_sess","","",201,N],[12,"plugin_attributes","","",201,N],[3,"PostExpansionVisitor","","",N,N],[12,"context","","",202,N],[4,"AttributeType","","",N,N],[13,"Normal","","Normal, builtin attribute that is consumed by the compiler before the unused_attribute check",203,N],[13,"Whitelisted","","Builtin attribute that may not be consumed by the compiler before the unused_attribute check. These attributes will be ignored by the unused_attribute lint",203,N],[13,"CrateLevel","","Builtin attribute that is only allowed at the crate level",203,N],[4,"AttributeGate","","",N,N],[13,"Gated","","Is gated by a given feature gate, reason and function to check if enabled",204,N],[13,"Ungated","","Ungated attribute, can be used on all release channels",204,N],[4,"Stability","","",N,N],[13,"Unstable","","",205,N],[13,"Deprecated","","",205,N],[4,"GateIssue","","",N,N],[13,"Language","","",206,N],[13,"Library","","",206,N],[4,"GateStrength","","",N,N],[13,"Hard","","A hard error. (Most feature gates should use this.)",207,N],[13,"Soft","","Only a warning. (Use this only as backwards-compatibility demands.)",207,N],[4,"UnstableFeatures","","",N,N],[13,"Disallow","","Hard errors for unstable features are active, as on beta/stable channels.",208,N],[13,"Allow","","Allow features to be activated, as on nightly.",208,N],[13,"Cheat","","Errors are bypassed for bootstrapping. This is required any time during the build that feature-related lints are set to warn or above because the build turns on warnings-as-errors and uses lots of unstable features. As a result, this is always required for building Rust itself.",208,N],[5,"deprecated_attributes","","",N,[[],["vec"]]],[5,"is_builtin_attr_name","","",N,[[["name"]],["bool"]]],[5,"is_builtin_attr","","",N,[[["attribute"]],["bool"]]],[5,"check_attribute","","",N,[[["attribute"],["parsesess"],["features"]]]],[5,"find_lang_feature_issue","","",N,[[["str"]],["option",["u32"]]]],[5,"emit_feature_err","","",N,[[["parsesess"],["str"],["span"],["gateissue"],["str"]]]],[5,"feature_err","","",N,[[["parsesess"],["str"],["span"],["gateissue"],["str"]],["diagnosticbuilder"]]],[5,"leveled_feature_err","","",N,[[["parsesess"],["str"],["span"],["gateissue"],["str"],["gatestrength"]],["diagnosticbuilder"]]],[5,"get_features","","",N,N],[5,"check_crate","","",N,N],[5,"maybe_stage_features","","",N,[[["handler"],["crate"],["unstablefeatures"]]]],[17,"ACTIVE_FEATURES","","Represents active features that are currently being implemented or currently being considered for addition/removal.",N,N],[17,"REMOVED_FEATURES","","Represents unstable features which have since been removed (it was once Active)",N,N],[17,"STABLE_REMOVED_FEATURES","","Represents stable features which have since been removed (it was once Accepted)",N,N],[17,"ACCEPTED_FEATURES","","Those language feature has since been Accepted (it was once Active)",N,N],[17,"BUILTIN_ATTRIBUTES","","",N,N],[17,"GATED_CFGS","","",N,N],[17,"EXPLAIN_BOX_SYNTAX","","",N,N],[17,"EXPLAIN_STMT_ATTR_SYNTAX","","",N,N],[17,"EXPLAIN_ASM","","",N,N],[17,"EXPLAIN_GLOBAL_ASM","","",N,N],[17,"EXPLAIN_CUSTOM_TEST_FRAMEWORKS","","",N,N],[17,"EXPLAIN_LOG_SYNTAX","","",N,N],[17,"EXPLAIN_CONCAT_IDENTS","","",N,N],[17,"EXPLAIN_FORMAT_ARGS_NL","","",N,N],[17,"EXPLAIN_TRACE_MACROS","","",N,N],[17,"EXPLAIN_ALLOW_INTERNAL_UNSTABLE","","",N,N],[17,"EXPLAIN_ALLOW_INTERNAL_UNSAFE","","",N,N],[17,"EXPLAIN_CUSTOM_DERIVE","","",N,N],[17,"EXPLAIN_DEPR_CUSTOM_DERIVE","","",N,N],[17,"EXPLAIN_DERIVE_UNDERSCORE","","",N,N],[17,"EXPLAIN_LITERAL_MATCHER","","",N,N],[17,"EXPLAIN_UNSIZED_TUPLE_COERCION","","",N,N],[17,"EXPLAIN_MACRO_AT_MOST_ONCE_REP","","",N,N],[11,"clone","","",199,[[["self"]],["features"]]],[11,"new","","",199,[[],["features"]]],[11,"walk_feature_fields","","",199,[[["self"],["f"]]]],[11,"clone","","",203,[[["self"]],["attributetype"]]],[11,"eq","","",203,[[["self"],["attributetype"]],["bool"]]],[11,"fmt","","",203,[[["self"],["formatter"]],["result"]]],[11,"is_deprecated","","",204,[[["self"]],["bool"]]],[11,"clone","","",205,[[["self"]],["stability"]]],[11,"fmt","","",205,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",204,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",200,[[["self"],["formatter"]],["result"]]],[11,"gate","","",200,[[["metaitem"]],["option",["gatedcfg"]]]],[11,"check_and_emit","","",200,[[["self"],["parsesess"],["features"]]]],[11,"check_attribute","","",201,[[["self"],["attribute"],["bool"]]]],[11,"fmt","","",207,[[["self"],["formatter"]],["result"]]],[11,"clone","","",207,[[["self"]],["gatestrength"]]],[11,"eq","","",207,[[["self"],["gatestrength"]],["bool"]]],[11,"check_abi","","",202,[[["self"],["abi"],["span"]]]],[11,"whole_crate_feature_gates","","",202,[[["self"],["crate"]]]],[11,"visit_attribute","","",202,[[["self"],["attribute"]]]],[11,"visit_name","","",202,[[["self"],["span"],["name"]]]],[11,"visit_use_tree","","",202,[[["self"],["usetree"],["nodeid"],["bool"]]]],[11,"visit_item","","",202,[[["self"],["item"]]]],[11,"visit_foreign_item","","",202,[[["self"],["foreignitem"]]]],[11,"visit_ty","","",202,[[["self"],["ty"]]]],[11,"visit_fn_ret_ty","","",202,[[["self"],["functionretty"]]]],[11,"visit_expr","","",202,[[["self"],["expr"]]]],[11,"visit_arm","","",202,[[["self"],["arm"]]]],[11,"visit_pat","","",202,[[["self"],["pat"]]]],[11,"visit_fn","","",202,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_trait_item","","",202,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",202,[[["self"],["implitem"]]]],[11,"visit_path","","",202,[[["self"],["path"],["nodeid"]]]],[11,"visit_vis","","",202,[[["self"],["visibility"]]]],[11,"clone","","",208,[[["self"]],["unstablefeatures"]]],[11,"hash","","",208,N],[11,"from_environment","","",208,[[],["unstablefeatures"]]],[11,"is_nightly_build","","",208,[[["self"]],["bool"]]],[0,"fold","syntax","A Folder represents an AST->AST fold; it accepts an AST piece, and returns a piece of the same type. So, for instance, macro expansion is a Folder that walks over an AST and produces another AST.",N,N],[5,"noop_fold_meta_items","syntax::fold","",N,[[["vec",["metaitem"]],["t"]],["vec",["metaitem"]]]],[5,"noop_fold_use_tree","","",N,[[["usetree"],["t"]],["usetree"]]],[5,"fold_attrs","","",N,[[["vec",["attribute"]],["t"]],["vec",["attribute"]]]],[5,"fold_thin_attrs","","",N,[[["thinvec",["attribute"]],["t"]],["thinvec",["attribute"]]]],[5,"noop_fold_arm","","",N,[[["arm"],["t"]],["arm"]]],[5,"noop_fold_guard","","",N,[[["guard"],["t"]],["guard"]]],[5,"noop_fold_ty_binding","","",N,[[["typebinding"],["t"]],["typebinding"]]],[5,"noop_fold_ty","","",N,[[["p",["ty"]],["t"]],["p",["ty"]]]],[5,"noop_fold_foreign_mod","","",N,[[["foreignmod"],["t"]],["foreignmod"]]],[5,"noop_fold_global_asm","","",N,[[["p",["globalasm"]],["t"]],["p",["globalasm"]]]],[5,"noop_fold_variant","","",N,[[["variant"],["t"]],["variant"]]],[5,"noop_fold_ident","","",N,[[["ident"],["t"]],["ident"]]],[5,"noop_fold_usize","","",N,[[["usize"],["t"]],["usize"]]],[5,"noop_fold_path","","",N,[[["path"],["t"]],["path"]]],[5,"noop_fold_qpath","","",N,N],[5,"noop_fold_generic_args","","",N,[[["genericargs"],["t"]],["genericargs"]]],[5,"noop_fold_angle_bracketed_parameter_data","","",N,[[["anglebracketedargs"],["t"]],["anglebracketedargs"]]],[5,"noop_fold_parenthesized_parameter_data","","",N,[[["parenthesisedargs"],["t"]],["parenthesisedargs"]]],[5,"noop_fold_local","","",N,[[["p",["local"]],["t"]],["p",["local"]]]],[5,"noop_fold_attribute","","",N,[[["attribute"],["t"]],["option",["attribute"]]]],[5,"noop_fold_mac","","",N,[[["mac"],["t"]],["mac"]]],[5,"noop_fold_macro_def","","",N,[[["macrodef"],["t"]],["macrodef"]]],[5,"noop_fold_meta_list_item","","",N,[[["nestedmetaitem"],["t"]],["nestedmetaitem"]]],[5,"noop_fold_meta_item","","",N,[[["metaitem"],["t"]],["metaitem"]]],[5,"noop_fold_arg","","",N,[[["arg"],["t"]],["arg"]]],[5,"noop_fold_tt","","",N,[[["tokentree"],["t"]],["tokentree"]]],[5,"noop_fold_tts","","",N,[[["tokenstream"],["t"]],["tokenstream"]]],[5,"noop_fold_token","","",N,[[["token"],["t"]],["token"]]],[5,"noop_fold_interpolated","","apply folder to elements of interpolated nodes",N,[[["nonterminal"],["t"]],["nonterminal"]]],[5,"noop_fold_asyncness","","",N,[[["isasync"],["t"]],["isasync"]]],[5,"noop_fold_fn_decl","","",N,[[["p",["fndecl"]],["t"]],["p",["fndecl"]]]],[5,"noop_fold_param_bound","","",N,[[["genericbound"],["t"]],["genericbound"]]],[5,"noop_fold_generic_param","","",N,[[["genericparam"],["t"]],["genericparam"]]],[5,"noop_fold_generic_params","","",N,[[["vec",["genericparam"]],["t"]],["vec",["genericparam"]]]],[5,"noop_fold_label","","",N,[[["label"],["t"]],["label"]]],[5,"noop_fold_lifetime","","",N,[[["lifetime"],["t"]],["lifetime"]]],[5,"noop_fold_generics","","",N,[[["generics"],["t"]],["generics"]]],[5,"noop_fold_where_clause","","",N,[[["whereclause"],["t"]],["whereclause"]]],[5,"noop_fold_where_predicate","","",N,[[["wherepredicate"],["t"]],["wherepredicate"]]],[5,"noop_fold_variant_data","","",N,[[["variantdata"],["t"]],["variantdata"]]],[5,"noop_fold_trait_ref","","",N,[[["traitref"],["t"]],["traitref"]]],[5,"noop_fold_poly_trait_ref","","",N,[[["polytraitref"],["t"]],["polytraitref"]]],[5,"noop_fold_struct_field","","",N,[[["structfield"],["t"]],["structfield"]]],[5,"noop_fold_field","","",N,[[["field"],["t"]],["field"]]],[5,"noop_fold_mt","","",N,[[["mutty"],["t"]],["mutty"]]],[5,"noop_fold_opt_bounds","","",N,[[["option",["genericbounds"]],["t"]],["option",["genericbounds"]]]],[5,"noop_fold_bounds","","",N,[[["genericbounds"],["t"]],["genericbounds"]]],[5,"noop_fold_block","","",N,[[["p",["block"]],["t"]],["p",["block"]]]],[5,"noop_fold_item_kind","","",N,[[["itemkind"],["t"]],["itemkind"]]],[5,"noop_fold_trait_item","","",N,[[["traititem"],["t"]],["onevector",["traititem"]]]],[5,"noop_fold_impl_item","","",N,[[["implitem"],["t"]],["onevector",["implitem"]]]],[5,"noop_fold_fn_header","","",N,[[["fnheader"],["t"]],["fnheader"]]],[5,"noop_fold_mod","","",N,[[["mod"],["t"]],["mod"]]],[5,"noop_fold_crate","","",N,[[["crate"],["t"]],["crate"]]],[5,"noop_fold_item","","",N,[[["p",["item"]],["t"]],["onevector",["p"]]]],[5,"noop_fold_item_simple","","",N,[[["item"],["t"]],["item"]]],[5,"noop_fold_foreign_item","","",N,[[["foreignitem"],["t"]],["onevector",["foreignitem"]]]],[5,"noop_fold_foreign_item_simple","","",N,[[["foreignitem"],["t"]],["foreignitem"]]],[5,"noop_fold_method_sig","","",N,[[["methodsig"],["t"]],["methodsig"]]],[5,"noop_fold_pat","","",N,[[["p",["pat"]],["t"]],["p",["pat"]]]],[5,"noop_fold_range_end","","",N,[[["rangeend"],["t"]],["rangeend"]]],[5,"noop_fold_anon_const","","",N,[[["anonconst"],["t"]],["anonconst"]]],[5,"noop_fold_expr","","",N,[[["expr"],["t"]],["expr"]]],[5,"noop_fold_opt_expr","","",N,[[["p",["expr"]],["t"]],["option",["p"]]]],[5,"noop_fold_exprs","","",N,[[["vec",["p"]],["t"]],["vec",["p"]]]],[5,"noop_fold_stmt","","",N,[[["stmt"],["t"]],["onevector",["stmt"]]]],[5,"noop_fold_stmt_kind","","",N,[[["stmtkind"],["t"]],["onevector",["stmtkind"]]]],[5,"noop_fold_vis","","",N,[[["visibility"],["t"]],["visibility"]]],[8,"Folder","","",N,N],[11,"fold_crate","","",209,[[["self"],["crate"]],["crate"]]],[11,"fold_meta_items","","",209,[[["self"],["vec",["metaitem"]]],["vec",["metaitem"]]]],[11,"fold_meta_list_item","","",209,[[["self"],["nestedmetaitem"]],["nestedmetaitem"]]],[11,"fold_meta_item","","",209,[[["self"],["metaitem"]],["metaitem"]]],[11,"fold_use_tree","","",209,[[["self"],["usetree"]],["usetree"]]],[11,"fold_foreign_item","","",209,[[["self"],["foreignitem"]],["onevector",["foreignitem"]]]],[11,"fold_foreign_item_simple","","",209,[[["self"],["foreignitem"]],["foreignitem"]]],[11,"fold_item","","",209,[[["self"],["p",["item"]]],["onevector",["p"]]]],[11,"fold_item_simple","","",209,[[["self"],["item"]],["item"]]],[11,"fold_fn_header","","",209,[[["self"],["fnheader"]],["fnheader"]]],[11,"fold_struct_field","","",209,[[["self"],["structfield"]],["structfield"]]],[11,"fold_item_kind","","",209,[[["self"],["itemkind"]],["itemkind"]]],[11,"fold_trait_item","","",209,[[["self"],["traititem"]],["onevector",["traititem"]]]],[11,"fold_impl_item","","",209,[[["self"],["implitem"]],["onevector",["implitem"]]]],[11,"fold_fn_decl","","",209,[[["self"],["p",["fndecl"]]],["p",["fndecl"]]]],[11,"fold_asyncness","","",209,[[["self"],["isasync"]],["isasync"]]],[11,"fold_block","","",209,[[["self"],["p",["block"]]],["p",["block"]]]],[11,"fold_stmt","","",209,[[["self"],["stmt"]],["onevector",["stmt"]]]],[11,"fold_arm","","",209,[[["self"],["arm"]],["arm"]]],[11,"fold_guard","","",209,[[["self"],["guard"]],["guard"]]],[11,"fold_pat","","",209,[[["self"],["p",["pat"]]],["p",["pat"]]]],[11,"fold_anon_const","","",209,[[["self"],["anonconst"]],["anonconst"]]],[11,"fold_expr","","",209,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"fold_range_end","","",209,[[["self"],["rangeend"]],["rangeend"]]],[11,"fold_opt_expr","","",209,[[["self"],["p",["expr"]]],["option",["p"]]]],[11,"fold_exprs","","",209,[[["self"],["vec",["p"]]],["vec",["p"]]]],[11,"fold_generic_arg","","",209,[[["self"],["genericarg"]],["genericarg"]]],[11,"fold_ty","","",209,[[["self"],["p",["ty"]]],["p",["ty"]]]],[11,"fold_lifetime","","",209,[[["self"],["lifetime"]],["lifetime"]]],[11,"fold_ty_binding","","",209,[[["self"],["typebinding"]],["typebinding"]]],[11,"fold_mod","","",209,[[["self"],["mod"]],["mod"]]],[11,"fold_foreign_mod","","",209,[[["self"],["foreignmod"]],["foreignmod"]]],[11,"fold_global_asm","","",209,[[["self"],["p",["globalasm"]]],["p",["globalasm"]]]],[11,"fold_variant","","",209,[[["self"],["variant"]],["variant"]]],[11,"fold_ident","","",209,[[["self"],["ident"]],["ident"]]],[11,"fold_usize","","",209,[[["self"],["usize"]],["usize"]]],[11,"fold_path","","",209,[[["self"],["path"]],["path"]]],[11,"fold_qpath","","",209,N],[11,"fold_generic_args","","",209,[[["self"],["genericargs"]],["genericargs"]]],[11,"fold_angle_bracketed_parameter_data","","",209,[[["self"],["anglebracketedargs"]],["anglebracketedargs"]]],[11,"fold_parenthesized_parameter_data","","",209,[[["self"],["parenthesisedargs"]],["parenthesisedargs"]]],[11,"fold_local","","",209,[[["self"],["p",["local"]]],["p",["local"]]]],[11,"fold_mac","","",209,[[["self"],["mac"]],["mac"]]],[11,"fold_macro_def","","",209,[[["self"],["macrodef"]],["macrodef"]]],[11,"fold_label","","",209,[[["self"],["label"]],["label"]]],[11,"fold_attribute","","",209,[[["self"],["attribute"]],["option",["attribute"]]]],[11,"fold_arg","","",209,[[["self"],["arg"]],["arg"]]],[11,"fold_generics","","",209,[[["self"],["generics"]],["generics"]]],[11,"fold_trait_ref","","",209,[[["self"],["traitref"]],["traitref"]]],[11,"fold_poly_trait_ref","","",209,[[["self"],["polytraitref"]],["polytraitref"]]],[11,"fold_variant_data","","",209,[[["self"],["variantdata"]],["variantdata"]]],[11,"fold_generic_param","","",209,[[["self"],["genericparam"]],["genericparam"]]],[11,"fold_generic_params","","",209,[[["self"],["vec",["genericparam"]]],["vec",["genericparam"]]]],[11,"fold_tt","","",209,[[["self"],["tokentree"]],["tokentree"]]],[11,"fold_tts","","",209,[[["self"],["tokenstream"]],["tokenstream"]]],[11,"fold_token","","",209,[[["self"],["token"]],["token"]]],[11,"fold_interpolated","","",209,[[["self"],["nonterminal"]],["nonterminal"]]],[11,"fold_opt_bounds","","",209,[[["self"],["option",["genericbounds"]]],["option",["genericbounds"]]]],[11,"fold_bounds","","",209,[[["self"],["genericbounds"]],["genericbounds"]]],[11,"fold_param_bound","","",209,[[["self"],["genericbound"]],["genericbound"]]],[11,"fold_mt","","",209,[[["self"],["mutty"]],["mutty"]]],[11,"fold_field","","",209,[[["self"],["field"]],["field"]]],[11,"fold_where_clause","","",209,[[["self"],["whereclause"]],["whereclause"]]],[11,"fold_where_predicate","","",209,[[["self"],["wherepredicate"]],["wherepredicate"]]],[11,"fold_vis","","",209,[[["self"],["visibility"]],["visibility"]]],[11,"new_id","","",209,[[["self"],["nodeid"]],["nodeid"]]],[11,"new_span","","",209,[[["self"],["span"]],["span"]]],[0,"parse","syntax","The main parser interface",N,N],[3,"ParseSess","syntax::parse","Info about a parsing session.",N,N],[12,"span_diagnostic","","",210,N],[12,"unstable_features","","",210,N],[12,"config","","",210,N],[12,"missing_fragment_specifiers","","",210,N],[12,"raw_identifier_spans","","Places where raw identifiers were used. This is used for feature gating raw identifiers",210,N],[12,"registered_diagnostics","","The registered diagnostics codes",210,N],[12,"non_modrs_mods","","",210,N],[12,"included_mod_stack","","Used to determine and report recursive mod inclusions",210,N],[12,"code_map","","",210,N],[12,"buffered_lints","","",210,N],[3,"Directory","","",N,N],[12,"path","","",211,N],[12,"ownership","","",211,N],[3,"SeqSep","","`SeqSep` : a sequence separator (token) and whether a trailing separator is allowed.",N,N],[12,"sep","","",212,N],[12,"trailing_sep_allowed","","",212,N],[4,"DirectoryOwnership","","",N,N],[13,"Owned","","",213,N],[12,"relative","syntax::parse::DirectoryOwnership","",213,N],[13,"UnownedViaBlock","syntax::parse","",213,N],[13,"UnownedViaMod","","",213,N],[5,"parse_crate_from_file","","",N,[[["path"],["parsesess"]],["presult",["crate"]]]],[5,"parse_crate_attrs_from_file","","",N,[[["path"],["parsesess"]],["presult",["vec"]]]],[5,"parse_crate_from_source_str","","",N,[[["filename"],["string"],["parsesess"]],["presult",["crate"]]]],[5,"parse_crate_attrs_from_source_str","","",N,[[["filename"],["string"],["parsesess"]],["presult",["vec"]]]],[5,"parse_expr_from_source_str","","",N,[[["filename"],["string"],["parsesess"]],["presult",["p"]]]],[5,"parse_item_from_source_str","","Parses an item.",N,[[["filename"],["string"],["parsesess"]],["presult",["option"]]]],[5,"parse_stmt_from_source_str","","",N,[[["filename"],["string"],["parsesess"]],["presult",["option"]]]],[5,"parse_stream_from_source_str","","",N,[[["filename"],["string"],["parsesess"],["option",["span"]]],["tokenstream"]]],[5,"new_parser_from_source_str","","",N,[[["parsesess"],["filename"],["string"]],["parser"]]],[5,"new_parser_from_file","","Create a new parser, handling errors as appropriate if the file doesn't exist",N,[[["parsesess"],["path"]],["parser"]]],[5,"new_sub_parser_from_file","","Given a session, a crate config, a path, and a span, add the file at the given path to the source_map, and return a parser. On an error, use the given span as the source of the problem.",N,[[["parsesess"],["path"],["directoryownership"],["option",["string"]],["span"]],["parser"]]],[5,"source_file_to_parser","","Given a source_file and config, return a parser",N,[[["parsesess"],["lrc",["sourcefile"]]],["parser"]]],[5,"new_parser_from_tts","","",N,[[["parsesess"],["vec",["tokentree"]]],["parser"]]],[5,"file_to_source_file","","Given a session and a path and an optional span (for error reporting), add the path to the session's source_map and return the new source_file.",N,[[["parsesess"],["path"],["option",["span"]]],["lrc",["sourcefile"]]]],[5,"source_file_to_stream","","Given a source_file, produce a sequence of token-trees",N,[[["parsesess"],["lrc",["sourcefile"]],["option",["span"]]],["tokenstream"]]],[5,"stream_to_parser","","Given stream and the `ParseSess`, produce a parser",N,[[["parsesess"],["tokenstream"]],["parser"]]],[5,"char_lit","","Parse a string representing a character literal into its final form. Rather than just accepting/rejecting a given literal, unescapes it as well. Can take any slice prefixed by a character escape. Returns the character and the number of characters consumed.",N,N],[5,"str_lit","","Parse a string representing a string literal into its final form. Does unescaping.",N,[[["str"],["option"]],["string"]]],[5,"raw_str_lit","","Parse a string representing a raw string literal into its final form. The only operation this does is convert embedded CRLF into a single LF.",N,[[["str"]],["string"]]],[5,"looks_like_width_suffix","","",N,N],[5,"lit_token","","",N,N],[5,"filtered_float_lit","","",N,[[["symbol"],["option",["symbol"]],["option"]],["option",["litkind"]]]],[5,"float_lit","","",N,[[["str"],["option",["symbol"]],["option"]],["option",["litkind"]]]],[5,"byte_lit","","Parse a string representing a byte literal into its final form. Similar to `char_lit`",N,N],[5,"byte_str_lit","","",N,[[["str"]],["lrc",["vec"]]]],[5,"integer_lit","","",N,[[["str"],["option",["symbol"]],["option"]],["option",["litkind"]]]],[0,"parser","","",N,N],[3,"Restrictions","syntax::parse::parser","",N,N],[12,"bits","","",214,N],[3,"Parser","","",N,N],[12,"sess","","",215,N],[12,"token","","the current token:",215,N],[12,"span","","the span of the current token:",215,N],[12,"meta_var_span","","the span of the previous token:",215,N],[12,"prev_span","","",215,N],[12,"prev_token_kind","","the previous token kind",215,N],[12,"restrictions","","",215,N],[12,"directory","","Used to determine the path to externally loaded source files",215,N],[12,"recurse_into_file_modules","","Whether to parse sub-modules in other files.",215,N],[12,"root_module_name","","Name of the root module this parser originated from. If `None`, then the name is not known. This does not change while the parser is descending into modules, and sub-parsers have new values for this name.",215,N],[12,"expected_tokens","","",215,N],[12,"token_cursor","","",215,N],[12,"desugar_doc_comments","","",215,N],[12,"cfg_mods","","Whether we should configure out of line modules as we parse.",215,N],[3,"TokenCursor","","",N,N],[12,"frame","","",216,N],[12,"stack","","",216,N],[3,"TokenCursorFrame","","",N,N],[12,"delim","","",217,N],[12,"span","","",217,N],[12,"open_delim","","",217,N],[12,"tree_cursor","","",217,N],[12,"close_delim","","",217,N],[12,"last_token","","",217,N],[3,"ModulePath","","Information about the path to a module.",N,N],[12,"name","","",218,N],[12,"path_exists","","",218,N],[12,"result","","",218,N],[3,"ModulePathSuccess","","",N,N],[12,"path","","",219,N],[12,"directory_ownership","","",219,N],[12,"warn","","",219,N],[4,"AliasKind","","Whether the type alias or associated type is a concrete type or an existential type",N,N],[13,"Weak","","Just a new name for the same type",220,N],[13,"Existential","","Only trait impls of the type will be usable, not the actual type itself",220,N],[4,"PathStyle","","How to parse a path.",N,N],[13,"Expr","","In some contexts, notably in expressions, paths with generic arguments are ambiguous with something else. For example, in expressions `segment < ....` can be interpreted as a comparison and `segment ( ....` can be interpreted as a function call. In all such contexts the non-path interpretation is preferred by default for practical reasons, but the path interpretation can be forced by the disambiguator `::`, e.g. `x<y>` - comparisons, `x::<y>` - unambiguously a path.",221,N],[13,"Type","","In other contexts, notably in types, no ambiguity exists and paths can be written without the disambiguator, e.g. `x<y>` - unambiguously a path. Paths with disambiguators are still accepted, `x::<Y>` - unambiguously a path too.",221,N],[13,"Mod","","A path with generic arguments disallowed, e.g. `foo::bar::Baz`, used in imports, visibilities or attributes. Technically, this variant is unnecessary and e.g. `Expr` can be used instead (paths in \"mod\" contexts have to be checked later for absence of generic arguments anyway, due to macros), but it is used to avoid weird suggestions about expected tokens when something goes wrong.",221,N],[4,"SemiColonMode","","",N,N],[13,"Break","","",222,N],[13,"Ignore","","",222,N],[4,"BlockMode","","",N,N],[13,"Break","","",223,N],[13,"Ignore","","",223,N],[4,"PrevTokenKind","","",N,N],[13,"DocComment","","",224,N],[13,"Comma","","",224,N],[13,"Plus","","",224,N],[13,"Interpolated","","",224,N],[13,"Eof","","",224,N],[13,"Ident","","",224,N],[13,"Other","","",224,N],[4,"LastToken","","This is used in `TokenCursorFrame` above to track tokens that are consumed by the parser, and then that's transitively used to record the tokens that each parse AST item is created with.",N,N],[13,"Collecting","","",225,N],[13,"Was","","",225,N],[4,"TokenType","","",N,N],[13,"Token","","",226,N],[13,"Keyword","","",226,N],[13,"Operator","","",226,N],[13,"Lifetime","","",226,N],[13,"Ident","","",226,N],[13,"Path","","",226,N],[13,"Type","","",226,N],[4,"Error","","",N,N],[13,"FileNotFoundForModule","","",227,N],[12,"mod_name","syntax::parse::parser::Error","",227,N],[12,"default_path","","",227,N],[12,"secondary_path","","",227,N],[12,"dir_path","","",227,N],[13,"DuplicatePaths","syntax::parse::parser","",227,N],[12,"mod_name","syntax::parse::parser::Error","",227,N],[12,"default_path","","",227,N],[12,"secondary_path","","",227,N],[13,"UselessDocComment","syntax::parse::parser","",227,N],[13,"InclusiveRangeWithNoEnd","","",227,N],[4,"LhsExpr","","",N,N],[13,"NotYetParsed","","",228,N],[13,"AttributesParsed","","",228,N],[13,"AlreadyParsed","","",228,N],[4,"TokenExpectType","","",N,N],[13,"Expect","","",229,N],[13,"NoExpect","","",229,N],[5,"maybe_append","","",N,[[["vec",["attribute"]],["option",["vec"]]],["vec",["attribute"]]]],[5,"can_continue_type_after_non_fn_ident","","Returns true if `IDENT t` can start a type - `IDENT::a::b`, `IDENT<u8, u8>`, `IDENT<<u8 as Trait>::AssocTy>`.",N,[[["token"]],["bool"]]],[5,"dummy_arg","","Create a placeholder argument.",N,[[["span"]],["arg"]]],[6,"ItemInfo","","",N,N],[8,"RecoverQPath","","",N,N],[18,"PATH_STYLE","","",230,N],[10,"to_ty","","",230,[[["self"]],["option",["p"]]]],[10,"to_recovered","","",230,[[["self"],["option",["qself"]],["path"]],["self"]]],[10,"to_string","","",230,[[["self"]],["string"]]],[11,"fmt","","",220,[[["self"],["formatter"]],["result"]]],[11,"eq","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"ne","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",214,N],[11,"clone","","",214,[[["self"]],["restrictions"]]],[11,"partial_cmp","","",214,[[["self"],["restrictions"]],["option",["ordering"]]]],[11,"lt","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"le","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"gt","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"ge","","",214,[[["self"],["restrictions"]],["bool"]]],[11,"cmp","","",214,[[["self"],["restrictions"]],["ordering"]]],[11,"hash","","",214,N],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",214,[[["self"],["formatter"]],["result"]]],[18,"STMT_EXPR","","",214,N],[18,"NO_STRUCT_LITERAL","","",214,N],[11,"empty","","Returns an empty set of flags.",214,[[],["restrictions"]]],[11,"all","","Returns the set containing all flags.",214,[[],["restrictions"]]],[11,"bits","","Returns the raw value of the flags currently stored.",214,[[["self"]],["u8"]]],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",214,[[["u8"]],["option",["restrictions"]]]],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",214,[[["u8"]],["restrictions"]]],[11,"is_empty","","Returns `true` if no flags are currently stored.",214,[[["self"]],["bool"]]],[11,"is_all","","Returns `true` if all flags are currently set.",214,[[["self"]],["bool"]]],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",214,[[["self"],["restrictions"]],["bool"]]],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",214,[[["self"],["restrictions"]],["bool"]]],[11,"insert","","Inserts the specified flags in-place.",214,[[["self"],["restrictions"]]]],[11,"remove","","Removes the specified flags in-place.",214,[[["self"],["restrictions"]]]],[11,"toggle","","Toggles the specified flags in-place.",214,[[["self"],["restrictions"]]]],[11,"set","","Inserts or removes the specified flags depending on the passed value.",214,[[["self"],["restrictions"],["bool"]]]],[11,"bitor","","Returns the union of the two sets of flags.",214,[[["self"],["restrictions"]],["restrictions"]]],[11,"bitor_assign","","Adds the set of flags.",214,[[["self"],["restrictions"]]]],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",214,[[["self"],["restrictions"]],["restrictions"]]],[11,"bitxor_assign","","Toggles the set of flags.",214,[[["self"],["restrictions"]]]],[11,"bitand","","Returns the intersection between the two sets of flags.",214,[[["self"],["restrictions"]],["restrictions"]]],[11,"bitand_assign","","Disables all flags disabled in the set.",214,[[["self"],["restrictions"]]]],[11,"sub","","Returns the set difference of the two sets of flags.",214,[[["self"],["restrictions"]],["restrictions"]]],[11,"sub_assign","","Disables all flags enabled in the set.",214,[[["self"],["restrictions"]]]],[11,"not","","Returns the complement of this set of flags.",214,[[["self"]],["restrictions"]]],[11,"extend","","",214,[[["self"],["t"]]]],[11,"from_iter","","",214,[[["t"]],["restrictions"]]],[11,"clone","","",221,[[["self"]],["pathstyle"]]],[11,"eq","","",221,[[["self"],["pathstyle"]],["bool"]]],[11,"clone","","",222,[[["self"]],["semicolonmode"]]],[11,"eq","","",222,[[["self"],["semicolonmode"]],["bool"]]],[11,"fmt","","",222,[[["self"],["formatter"]],["result"]]],[11,"clone","","",223,[[["self"]],["blockmode"]]],[11,"eq","","",223,[[["self"],["blockmode"]],["bool"]]],[11,"fmt","","",223,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",224,[[["self"],["formatter"]],["result"]]],[11,"clone","","",224,[[["self"]],["prevtokenkind"]]],[11,"eq","","",224,[[["self"],["prevtokenkind"]],["bool"]]],[11,"to_ty","syntax::ast","",78,[[["self"]],["option",["p"]]]],[11,"to_recovered","","",78,[[["self"],["option",["qself"]],["path"]],["self"]]],[11,"to_string","","",78,[[["self"]],["string"]]],[11,"to_ty","","",62,[[["self"]],["option",["p"]]]],[11,"to_recovered","","",62,[[["self"],["option",["qself"]],["path"]],["self"]]],[11,"to_string","","",62,[[["self"]],["string"]]],[11,"to_ty","","",69,[[["self"]],["option",["p"]]]],[11,"to_recovered","","",69,[[["self"],["option",["qself"]],["path"]],["self"]]],[11,"to_string","","",69,[[["self"]],["string"]]],[11,"clone","syntax::parse::parser","",215,[[["self"]],["parser"]]],[11,"clone","","",216,[[["self"]],["tokencursor"]]],[11,"clone","","",217,[[["self"]],["tokencursorframe"]]],[11,"clone","","",225,[[["self"]],["lasttoken"]]],[11,"new","","",217,[[["delimspan"],["delimited"]],["self"]]],[11,"next","","",216,[[["self"]],["tokenandspan"]]],[11,"next_desugared","","",216,[[["self"]],["tokenandspan"]]],[11,"clone","","",226,[[["self"]],["tokentype"]]],[11,"eq","","",226,[[["self"],["tokentype"]],["bool"]]],[11,"ne","","",226,[[["self"],["tokentype"]],["bool"]]],[11,"to_string","","",226,[[["self"]],["string"]]],[11,"span_err","","",227,[[["self"],["s"],["handler"]],["diagnosticbuilder"]]],[11,"fmt","","",228,[[["self"],["formatter"]],["result"]]],[11,"from","","",228,[[["option",["thinvec"]]],["self"]]],[11,"from","","",228,[[["p",["expr"]]],["self"]]],[11,"clone","","",229,[[["self"]],["tokenexpecttype"]]],[11,"fmt","","",229,[[["self"],["formatter"]],["result"]]],[11,"new","","",215,[[["parsesess"],["tokenstream"],["option",["directory"]],["bool"],["bool"]],["self"]]],[11,"next_tok","","",215,[[["self"]],["tokenandspan"]]],[11,"this_token_to_string","","Convert the current token to a string using self's reader",215,[[["self"]],["string"]]],[11,"token_descr","","",215,[[["self"]],["option",["str"]]]],[11,"this_token_descr","","",215,[[["self"]],["string"]]],[11,"unexpected_last","","",215,[[["self"],["token"]],["presult"]]],[11,"unexpected","","",215,[[["self"]],["presult"]]],[11,"expect","","Expect and consume the token t. Signal an error if the next token is not t.",215,[[["self"],["token"]],["presult"]]],[11,"expect_one_of","","Expect next token to be edible or inedible token.  If edible, then consume it; if inedible, then return without consuming anything.  Signal a fatal error if next token is unexpected.",215,N],[11,"interpolated_or_expr_span","","returns the span of expr, if it was not interpolated or the span of the interpolated token",215,[[["self"],["presult",["p"]]],["presult"]]],[11,"expected_ident_found","","",215,[[["self"]],["diagnosticbuilder"]]],[11,"parse_ident","","",215,[[["self"]],["presult",["ident"]]]],[11,"parse_ident_common","","",215,[[["self"],["bool"]],["presult",["ident"]]]],[11,"check","","Check if the next token is `tok`, and return `true` if so.",215,[[["self"],["token"]],["bool"]]],[11,"eat","","Consume token 'tok' if it exists. Returns true if the given token was present, false otherwise.",215,[[["self"],["token"]],["bool"]]],[11,"check_keyword","","",215,[[["self"],["keyword"]],["bool"]]],[11,"eat_keyword","","If the next token is the given keyword, eat it and return true. Otherwise, return false.",215,[[["self"],["keyword"]],["bool"]]],[11,"eat_keyword_noexpect","","",215,[[["self"],["keyword"]],["bool"]]],[11,"expect_keyword","","If the given word is not a keyword, signal an error. If the next token is not the given word, signal an error. Otherwise, eat it.",215,[[["self"],["keyword"]],["presult"]]],[11,"check_ident","","",215,[[["self"]],["bool"]]],[11,"check_path","","",215,[[["self"]],["bool"]]],[11,"check_type","","",215,[[["self"]],["bool"]]],[11,"eat_plus","","Expect and consume a `+`. if `+=` is seen, replace it with a `=` and continue. If a `+` is not seen, return false.",215,[[["self"]],["bool"]]],[11,"check_plus","","Checks to see if the next token is either `+` or `+=`. Otherwise returns false.",215,[[["self"]],["bool"]]],[11,"expect_and","","Expect and consume an `&`. If `&&` is seen, replace it with a single `&` and continue. If an `&` is not seen, signal an error.",215,[[["self"]],["presult"]]],[11,"expect_or","","Expect and consume an `|`. If `||` is seen, replace it with a single `|` and continue. If an `|` is not seen, signal an error.",215,[[["self"]],["presult"]]],[11,"expect_no_suffix","","",215,[[["self"],["span"],["str"],["option",["name"]]]]],[11,"eat_lt","","Attempt to consume a `<`. If `<<` is seen, replace it with a single `<` and continue. If a `<` is not seen, return false.",215,[[["self"]],["bool"]]],[11,"expect_lt","","",215,[[["self"]],["presult"]]],[11,"expect_gt","","Expect and consume a GT. if a >> is seen, replace it with a single > and continue. If a GT is not seen, signal an error.",215,[[["self"]],["presult"]]],[11,"eat_to_tokens","","Eat and discard tokens until one of `kets` is encountered. Respects token trees, passes through any errors encountered. Used for error recovery.",215,N],[11,"parse_seq_to_end","","Parse a sequence, including the closing delimiter. The function f must consume tokens until reaching the next separator or closing bracket.",215,[[["self"],["token"],["seqsep"],["f"]],["presult",["vec"]]]],[11,"parse_seq_to_before_end","","Parse a sequence, not including the closing delimiter. The function f must consume tokens until reaching the next separator or closing bracket.",215,[[["self"],["token"],["seqsep"],["f"]],["presult",["vec"]]]],[11,"parse_seq_to_before_tokens","","",215,N],[11,"parse_unspanned_seq","","Parse a sequence, including the closing delimiter. The function f must consume tokens until reaching the next separator or closing bracket.",215,[[["self"],["token"],["token"],["seqsep"],["f"]],["presult",["vec"]]]],[11,"bump","","Advance the parser by one token",215,[[["self"]]]],[11,"bump_with","","Advance the parser using provided token as a next one. Use this when consuming a part of a token. For example a single `<` from `<<`.",215,[[["self"],["token"],["span"]]]],[11,"look_ahead","","",215,[[["self"],["usize"],["f"]],["r"]]],[11,"look_ahead_span","","",215,[[["self"],["usize"]],["span"]]],[11,"fatal","","",215,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"span_fatal","","",215,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_fatal_err","","",215,[[["self"],["s"],["error"]],["diagnosticbuilder"]]],[11,"bug","","",215,N],[11,"span_err","","",215,[[["self"],["s"],["str"]]]],[11,"struct_span_err","","",215,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_bug","","",215,N],[11,"abort_if_errors","","",215,[[["self"]]]],[11,"cancel","","",215,[[["self"],["diagnosticbuilder"]]]],[11,"diagnostic","","",215,[[["self"]],["handler"]]],[11,"token_is_bare_fn_keyword","","Is the current token one of the keywords that signals a bare function type?",215,[[["self"]],["bool"]]],[11,"parse_ty_bare_fn","","parse a TyKind::BareFn type:",215,[[["self"],["vec",["genericparam"]]],["presult",["tykind"]]]],[11,"parse_asyncness","","Parse asyncness: `async` or nothing",215,[[["self"]],["isasync"]]],[11,"parse_unsafety","","Parse unsafety: `unsafe` or nothing.",215,[[["self"]],["unsafety"]]],[11,"parse_trait_item","","Parse the items in a trait declaration",215,[[["self"],["bool"]],["presult",["traititem"]]]],[11,"parse_trait_item_","","",215,[[["self"],["bool"],["vec",["attribute"]]],["presult",["traititem"]]]],[11,"parse_ret_ty","","Parse optional return type [ -> TY ] in function decl",215,[[["self"],["bool"]],["presult",["functionretty"]]]],[11,"parse_ty","","",215,[[["self"]],["presult",["p"]]]],[11,"parse_ty_no_plus","","Parse a type in restricted contexts where `+` is not permitted. Example 1: `&'a TYPE`     `+` is prohibited to maintain operator priority (P(+) < P(&)). Example 2: `value1 as TYPE + value2`     `+` is prohibited to avoid interactions with expression grammar.",215,[[["self"]],["presult",["p"]]]],[11,"parse_ty_common","","",215,[[["self"],["bool"],["bool"]],["presult",["p"]]]],[11,"parse_remaining_bounds","","",215,[[["self"],["vec",["genericparam"]],["path"],["span"],["bool"]],["presult",["tykind"]]]],[11,"maybe_report_ambiguous_plus","","",215,[[["self"],["bool"],["bool"],["ty"]]]],[11,"maybe_recover_from_bad_type_plus","","",215,[[["self"],["bool"],["ty"]],["presult"]]],[11,"maybe_recover_from_bad_qpath","","",215,[[["self"],["t"],["bool"]],["presult"]]],[11,"parse_borrowed_pointee","","",215,[[["self"]],["presult",["tykind"]]]],[11,"parse_ptr","","",215,[[["self"]],["presult",["mutty"]]]],[11,"is_named_argument","","",215,[[["self"]],["bool"]]],[11,"parse_arg_general","","This version of parse arg doesn't necessarily require identifier names.",215,[[["self"],["bool"]],["presult",["arg"]]]],[11,"parse_arg","","Parse a single function argument",215,[[["self"]],["presult",["arg"]]]],[11,"parse_fn_block_arg","","Parse an argument in a lambda header e.g. |arg, arg|",215,[[["self"]],["presult",["arg"]]]],[11,"maybe_parse_fixed_length_of_vec","","",215,[[["self"]],["presult",["option"]]]],[11,"parse_lit_token","","Matches token_lit = LIT_INTEGER | ...",215,[[["self"]],["presult",["litkind"]]]],[11,"parse_lit","","Matches lit = true | false | token_lit",215,[[["self"]],["presult",["lit"]]]],[11,"parse_literal_maybe_minus","","matches '-' lit | lit (cf. ast_validation::AstValidator::check_expr_within_pat)",215,[[["self"]],["presult",["p"]]]],[11,"parse_path_segment_ident","","",215,[[["self"]],["presult",["ident"]]]],[11,"parse_qpath","","Parses qualified path. Assumes that the leading `<` has been parsed already.",215,[[["self"],["pathstyle"]],["presult"]]],[11,"parse_path","","Parses simple paths.",215,[[["self"],["pathstyle"]],["presult",["path"]]]],[11,"parse_path_common","","",215,[[["self"],["pathstyle"],["bool"]],["presult",["path"]]]],[11,"parse_path_allowing_meta","","Like `parse_path`, but also supports parsing `Word` meta items into paths for back-compat. This is used when parsing derive macro paths in `#[derive]` attributes.",215,[[["self"],["pathstyle"]],["presult",["path"]]]],[11,"parse_path_segments","","",215,[[["self"],["vec"],["pathstyle"],["bool"]],["presult"]]],[11,"parse_path_segment","","",215,[[["self"],["pathstyle"],["bool"]],["presult",["pathsegment"]]]],[11,"check_lifetime","","",215,[[["self"]],["bool"]]],[11,"expect_lifetime","","Parse single lifetime 'a or panic.",215,[[["self"]],["lifetime"]]],[11,"eat_label","","",215,[[["self"]],["option",["label"]]]],[11,"parse_mutability","","Parse mutability (`mut` or nothing).",215,[[["self"]],["mutability"]]],[11,"parse_field_name","","",215,[[["self"]],["presult",["ident"]]]],[11,"parse_field","","Parse ident (COLON expr)?",215,[[["self"]],["presult",["field"]]]],[11,"mk_expr","","",215,[[["self"],["span"],["exprkind"],["thinvec",["attribute"]]],["p",["expr"]]]],[11,"mk_unary","","",215,[[["self"],["unop"],["p",["expr"]]],["exprkind"]]],[11,"mk_binary","","",215,[[["self"],["binop"],["p",["expr"]],["p",["expr"]]],["exprkind"]]],[11,"mk_call","","",215,[[["self"],["p",["expr"]],["vec",["p"]]],["exprkind"]]],[11,"mk_index","","",215,[[["self"],["p",["expr"]],["p",["expr"]]],["exprkind"]]],[11,"mk_range","","",215,[[["self"],["option",["p"]],["option",["p"]],["rangelimits"]],["presult",["exprkind"]]]],[11,"mk_assign_op","","",215,[[["self"],["binop"],["p",["expr"]],["p",["expr"]]],["exprkind"]]],[11,"mk_mac_expr","","",215,[[["self"],["span"],["mac_"],["thinvec",["attribute"]]],["p",["expr"]]]],[11,"expect_delimited_token_tree","","",215,[[["self"]],["presult"]]],[11,"parse_bottom_expr","","At the bottom (top?) of the precedence hierarchy, parse things like parenthesized exprs, macros, return, etc.",215,[[["self"]],["presult",["p"]]]],[11,"parse_struct_expr","","",215,[[["self"],["span"],["path"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_or_use_outer_attributes","","",215,[[["self"],["option",["thinvec"]]],["presult",["thinvec"]]]],[11,"parse_block_expr","","Parse a block or unsafe block",215,[[["self"],["option",["label"]],["span"],["blockcheckmode"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_dot_or_call_expr","","parse a.b or a(13) or a[4] or just a",215,[[["self"],["option",["thinvec"]]],["presult",["p"]]]],[11,"parse_dot_or_call_expr_with","","",215,[[["self"],["p",["expr"]],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_dot_suffix","","",215,[[["self"],["p",["expr"]],["span"]],["presult",["p"]]]],[11,"parse_dot_or_call_expr_with_","","",215,[[["self"],["p",["expr"]],["span"]],["presult",["p"]]]],[11,"process_potential_macro_variable","","",215,[[["self"]]]],[11,"parse_token_tree","","parse a single token tree from the input.",215,[[["self"]],["tokentree"]]],[11,"parse_all_token_trees","","",215,[[["self"]],["presult",["vec"]]]],[11,"parse_tokens","","",215,[[["self"]],["tokenstream"]]],[11,"parse_prefix_expr","","Parse a prefix-unary-operator expr",215,[[["self"],["option",["thinvec"]]],["presult",["p"]]]],[11,"parse_assoc_expr","","Parse an associative expression",215,[[["self"],["option",["thinvec"]]],["presult",["p"]]]],[11,"parse_assoc_expr_with","","Parse an associative expression with operators of at least `min_prec` precedence",215,[[["self"],["usize"],["lhsexpr"]],["presult",["p"]]]],[11,"parse_assoc_op_cast","","",215,N],[11,"check_no_chained_comparison","","Produce an error if comparison operators are chained (RFC #558). We only need to check lhs, not rhs, because all comparison ops have same precedence and are left-associative",215,[[["self"],["expr"],["assocop"]]]],[11,"parse_prefix_range_expr","","Parse prefix-forms of range notation: `..expr`, `..`, `..=expr`",215,[[["self"],["option",["thinvec"]]],["presult",["p"]]]],[11,"is_at_start_of_range_notation_rhs","","",215,[[["self"]],["bool"]]],[11,"parse_if_expr","","Parse an 'if' or 'if let' expression ('if' token already eaten)",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_if_let_expr","","Parse an 'if let' expression ('if' token already eaten)",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_lambda_expr","","",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_else_expr","","",215,[[["self"]],["presult",["p"]]]],[11,"parse_for_expr","","Parse a 'for' .. 'in' expression ('for' token already eaten)",215,[[["self"],["option",["label"]],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_while_expr","","Parse a 'while' or 'while let' expression ('while' token already eaten)",215,[[["self"],["option",["label"]],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_while_let_expr","","Parse a 'while let' expression ('while' token already eaten)",215,[[["self"],["option",["label"]],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_loop_expr","","",215,[[["self"],["option",["label"]],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_async_block","","Parse an `async move {...}` expression",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_try_block","","Parse a `try {...}` expression (`try` token already eaten)",215,[[["self"],["span"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_match_expr","","",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_arm","","",215,[[["self"]],["presult",["arm"]]]],[11,"parse_expr","","Parse an expression",215,[[["self"]],["presult",["p"]]]],[11,"with_res","","Evaluate the closure with restrictions in place.",215,[[["self"],["restrictions"],["f"]],["t"]]],[11,"parse_expr_res","","Parse an expression, subject to the given restrictions",215,[[["self"],["restrictions"],["option",["thinvec"]]],["presult",["p"]]]],[11,"parse_initializer","","Parse the RHS of a local variable declaration (e.g. '= 14;')",215,[[["self"],["bool"]],["presult",["option"]]]],[11,"parse_pats","","Parse patterns, separated by '|' s",215,[[["self"]],["presult",["vec"]]]],[11,"parse_parenthesized_pat_list","","",215,[[["self"]],["presult"]]],[11,"parse_pat_list","","",215,[[["self"]],["presult"]]],[11,"parse_pat_vec_elements","","",215,[[["self"]],["presult"]]],[11,"parse_pat_field","","",215,[[["self"],["span"],["vec",["attribute"]]],["presult",["spanned"]]]],[11,"parse_pat_fields","","Parse the fields of a struct-like pattern",215,[[["self"]],["presult"]]],[11,"parse_pat_range_end","","",215,[[["self"]],["presult",["p"]]]],[11,"parse_as_ident","","",215,[[["self"]],["bool"]]],[11,"parse_top_level_pat","","A wrapper around `parse_pat` with some special error handling for the \"top-level\" patterns in a match arm, `for` loop, `let`, &c. (in contrast to subpatterns within such).",215,[[["self"]],["presult",["p"]]]],[11,"parse_pat","","Parse a pattern.",215,[[["self"]],["presult",["p"]]]],[11,"parse_pat_with_range_pat","","Parse a pattern, with a setting whether modern range patterns e.g. `a..=b`, `a..b` are allowed.",215,[[["self"],["bool"]],["presult",["p"]]]],[11,"parse_pat_ident","","Parse ident or ident @ pat used by the copy foo and ref foo patterns to give a good error message when parsing mistakes like ref foo(a,b)",215,[[["self"],["bindingmode"]],["presult",["patkind"]]]],[11,"parse_local","","Parse a local variable declaration",215,[[["self"],["thinvec",["attribute"]]],["presult",["p"]]]],[11,"parse_name_and_ty","","Parse a structure field",215,[[["self"],["span"],["visibility"],["vec",["attribute"]]],["presult",["structfield"]]]],[11,"expected_item_err","","Emit an expected item after attributes error.",215,N],[11,"parse_stmt","","Parse a statement. This stops just before trailing semicolons on everything but items. e.g. a `StmtKind::Semi` parses to a `StmtKind::Expr`, leaving the trailing `;` unconsumed.",215,[[["self"]],["presult",["option"]]]],[11,"recover_stmt","","",215,[[["self"]]]],[11,"recover_stmt_","","",215,[[["self"],["semicolonmode"],["blockmode"]]]],[11,"parse_stmt_","","",215,[[["self"],["bool"]],["option",["stmt"]]]],[11,"is_async_block","","",215,[[["self"]],["bool"]]],[11,"is_do_catch_block","","",215,[[["self"]],["bool"]]],[11,"is_try_block","","",215,[[["self"]],["bool"]]],[11,"is_union_item","","",215,[[["self"]],["bool"]]],[11,"is_crate_vis","","",215,[[["self"]],["bool"]]],[11,"is_extern_non_path","","",215,[[["self"]],["bool"]]],[11,"is_existential_type_decl","","",215,[[["self"]],["bool"]]],[11,"is_auto_trait_item","","",215,[[["self"]],["bool"]]],[11,"eat_macro_def","","",215,N],[11,"parse_stmt_without_recovery","","",215,[[["self"],["bool"]],["presult",["option"]]]],[11,"expr_is_complete","","Is this expression a successfully-parsed statement?",215,[[["self"],["expr"]],["bool"]]],[11,"parse_block","","Parse a block. No inner attrs are allowed.",215,[[["self"]],["presult",["p"]]]],[11,"parse_inner_attrs_and_block","","Parse a block. Inner attrs are allowed.",215,[[["self"]],["presult"]]],[11,"parse_block_tail","","Parse the rest of a block expression or function body Precondition: already parsed the '{'.",215,[[["self"],["span"],["blockcheckmode"]],["presult",["p"]]]],[11,"parse_full_stmt","","Parse a statement, including the trailing semicolon.",215,[[["self"],["bool"]],["presult",["option"]]]],[11,"warn_missing_semicolon","","",215,[[["self"]]]],[11,"err_dotdotdot_syntax","","",215,[[["self"],["span"]]]],[11,"parse_generic_bounds_common","","",215,[[["self"],["bool"]],["presult",["genericbounds"]]]],[11,"parse_generic_bounds","","",215,[[["self"]],["presult",["genericbounds"]]]],[11,"parse_lt_param_bounds","","",215,[[["self"]],["genericbounds"]]],[11,"parse_ty_param","","Matches typaram = IDENT (`?` unbound)? optbounds ( EQ ty )?",215,[[["self"],["vec",["attribute"]]],["presult",["genericparam"]]]],[11,"parse_trait_item_assoc_ty","","Parses the following grammar: TraitItemAssocTy = Ident [\"<\"...\">\"] [\":\" [GenericBounds]] [\"where\" ...] [\"=\" Ty]",215,[[["self"]],["presult"]]],[11,"parse_generic_params","","Parses (possibly empty) list of lifetime and type parameters, possibly including trailing comma and erroneous trailing attributes.",215,[[["self"]],["presult",["vec"]]]],[11,"parse_generics","","Parse a set of optional generic type parameter declarations. Where clauses are not parsed here, and must be added later via `parse_where_clause()`.",215,[[["self"]],["presult",["generics"]]]],[11,"parse_generic_args","","Parses (possibly empty) list of lifetime and type arguments and associated type bindings, possibly including trailing comma.",215,[[["self"]],["presult"]]],[11,"parse_where_clause","","Parses an optional `where` clause and places it in `generics`.",215,[[["self"]],["presult",["whereclause"]]]],[11,"parse_fn_args","","",215,[[["self"],["bool"],["bool"]],["presult"]]],[11,"parse_fn_decl","","Parse the argument list and result type of a function declaration",215,[[["self"],["bool"]],["presult",["p"]]]],[11,"parse_self_arg","","Returns the parsed optional self argument and whether a self shortcut was used.",215,[[["self"]],["presult",["option"]]]],[11,"parse_fn_decl_with_self","","Parse the parameter list and result type of a function that may have a `self` parameter.",215,[[["self"],["f"]],["presult",["p"]]]],[11,"parse_fn_block_decl","","",215,[[["self"]],["presult",["p"]]]],[11,"parse_fn_header","","Parse the name and optional generic types of a function header.",215,[[["self"]],["presult"]]],[11,"mk_item","","",215,[[["self"],["span"],["ident"],["itemkind"],["visibility"],["vec",["attribute"]]],["p",["item"]]]],[11,"parse_item_fn","","Parse an item-position function declaration.",215,[[["self"],["unsafety"],["isasync"],["spanned",["constness"]],["abi"]],["presult"]]],[11,"is_const_item","","true if we are looking at `const ID`, false for things like `const fn` etc",215,[[["self"]],["bool"]]],[11,"parse_fn_front_matter","","parses all the \"front matter\" for a `fn` declaration, up to and including the `fn` keyword:",215,[[["self"]],["presult"]]],[11,"parse_impl_item","","Parse an impl item.",215,[[["self"],["bool"]],["presult",["implitem"]]]],[11,"parse_impl_item_","","",215,[[["self"],["bool"],["vec",["attribute"]]],["presult",["implitem"]]]],[11,"complain_if_pub_macro","","",215,[[["self"],["visibilitykind"],["span"]]]],[11,"complain_if_pub_macro_diag","","",215,[[["self"],["visibilitykind"],["span"]],["presult"]]],[11,"missing_assoc_item_kind_err","","",215,[[["self"],["str"],["span"]],["diagnosticbuilder"]]],[11,"parse_impl_method","","Parse a method or a macro invocation in a trait impl.",215,[[["self"],["visibility"],["bool"]],["presult"]]],[11,"parse_item_trait","","Parse `trait Foo { ... }` or `trait Foo = Bar;`",215,[[["self"],["isauto"],["unsafety"]],["presult"]]],[11,"choose_generics_over_qpath","","",215,[[["self"]],["bool"]]],[11,"parse_impl_body","","",215,[[["self"]],["presult"]]],[11,"parse_item_impl","","Parses an implementation item, `impl` keyword is already parsed.    impl<'a, T> TYPE { /* impl items / }    impl<'a, T> TRAIT for TYPE { / impl items / }    impl<'a, T> !TRAIT for TYPE { / impl items */ } We actually parse slightly more relaxed grammar for better error reporting and recovery.     `impl` GENERICS `!`? TYPE `for`? (TYPE | `..`) (`where` PREDICATES)? `{` BODY `}`     `impl` GENERICS `!`? TYPE (`where` PREDICATES)? `{` BODY `}`",215,[[["self"],["unsafety"],["defaultness"]],["presult"]]],[11,"parse_late_bound_lifetime_defs","","",215,[[["self"]],["presult",["vec"]]]],[11,"parse_item_struct","","Parse struct Foo { ... }",215,[[["self"]],["presult"]]],[11,"parse_item_union","","Parse union Foo { ... }",215,[[["self"]],["presult"]]],[11,"consume_block","","",215,[[["self"],["delimtoken"]]]],[11,"parse_record_struct_body","","",215,[[["self"]],["presult",["vec"]]]],[11,"parse_tuple_struct_body","","",215,[[["self"]],["presult",["vec"]]]],[11,"parse_single_struct_field","","Parse a structure field declaration",215,[[["self"],["span"],["visibility"],["vec",["attribute"]]],["presult",["structfield"]]]],[11,"parse_struct_decl_field","","Parse an element of a struct definition",215,[[["self"]],["presult",["structfield"]]]],[11,"parse_visibility","","Parse `pub`, `pub(crate)` and `pub(in path)` plus shortcuts `pub(self)` for `pub(in self)` and `pub(super)` for `pub(in super)`.  If the following element can't be a tuple (i.e. it's a function definition, it's not a tuple struct field) and the contents within the parens isn't valid, emit a proper diagnostic.",215,[[["self"],["bool"]],["presult",["visibility"]]]],[11,"parse_defaultness","","Parse defaultness: `default` or nothing.",215,[[["self"]],["defaultness"]]],[11,"parse_mod_items","","Given a termination token, parse all of the items in a module",215,[[["self"],["token"],["span"]],["presult",["mod"]]]],[11,"parse_item_const","","",215,[[["self"],["option",["mutability"]]],["presult"]]],[11,"parse_item_mod","","Parse a `mod <foo> { ... }` or `mod <foo>;` item",215,N],[11,"push_directory","","",215,N],[11,"submod_path_from_attr","","",215,N],[11,"default_submod_path","","Returns either a path to a module, or .",215,[[["ident"],["option",["ident"]],["path"],["sourcemap"]],["modulepath"]]],[11,"submod_path","","",215,N],[11,"eval_src_mod","","Read a module from a source file.",215,[[["self"],["pathbuf"],["directoryownership"],["string"],["span"]],["presult"]]],[11,"parse_item_foreign_fn","","Parse a function declaration from a foreign module",215,[[["self"],["visibility"],["span"],["vec",["attribute"]]],["presult",["foreignitem"]]]],[11,"parse_item_foreign_static","","Parse a static item from a foreign module. Assumes that the `static` keyword is already parsed.",215,[[["self"],["visibility"],["span"],["vec",["attribute"]]],["presult",["foreignitem"]]]],[11,"parse_item_foreign_type","","Parse a type from a foreign module",215,[[["self"],["visibility"],["span"],["vec",["attribute"]]],["presult",["foreignitem"]]]],[11,"parse_crate_name_with_dashes","","",215,[[["self"]],["presult",["ident"]]]],[11,"parse_item_extern_crate","","Parse extern crate links",215,[[["self"],["span"],["visibility"],["vec",["attribute"]]],["presult",["p"]]]],[11,"parse_item_foreign_mod","","Parse `extern` for foreign ABIs modules.",215,[[["self"],["span"],["option",["abi"]],["visibility"],["vec",["attribute"]]],["presult",["p"]]]],[11,"eat_type","","Parse type Foo = Bar; or existential type Foo: Bar; or return None without modifying the parser state",215,[[["self"]],["option",["presult"]]]],[11,"parse_existential_or_alias","","Parse type alias or existential type",215,[[["self"],["bool"]],["presult"]]],[11,"parse_enum_def","","Parse the part of an \"enum\" decl following the '{'",215,[[["self"],["generics"]],["presult",["enumdef"]]]],[11,"parse_item_enum","","Parse an \"enum\" declaration",215,[[["self"]],["presult"]]],[11,"parse_opt_abi","","Parses a string as an ABI spec on an extern type or module. Consumes the `extern` keyword, if one is found.",215,[[["self"]],["presult",["option"]]]],[11,"is_static_global","","",215,[[["self"]],["bool"]]],[11,"parse_item_","","",215,[[["self"],["vec",["attribute"]],["bool"],["bool"]],["presult",["option"]]]],[11,"parse_item_implementation","","Parse one of the items allowed by the flags.",215,[[["self"],["vec",["attribute"]],["bool"],["bool"]],["presult",["option"]]]],[11,"parse_foreign_item","","Parse a foreign item.",215,[[["self"]],["presult",["option"]]]],[11,"parse_macro_use_or_failure","","This is the fall-through for parsing items.",215,[[["self"],["vec",["attribute"]],["bool"],["bool"],["span"],["visibility"]],["presult",["option"]]]],[11,"parse_assoc_macro_invoc","","Parse a macro invocation inside a `trait`, `impl` or `extern` block",215,[[["self"],["str"],["option",["visibility"]],["bool"]],["presult",["option"]]]],[11,"collect_tokens","","",215,[[["self"],["f"]],["presult"]]],[11,"parse_item","","",215,[[["self"]],["presult",["option"]]]],[11,"is_import_coupler","","`::{` or `::*`",215,[[["self"]],["bool"]]],[11,"parse_use_tree","","Parse UseTree",215,[[["self"]],["presult",["usetree"]]]],[11,"parse_use_tree_list","","Parse UseTreeKind::Nested(list)",215,[[["self"]],["presult",["vec"]]]],[11,"parse_rename","","",215,[[["self"]],["presult",["option"]]]],[11,"parse_crate_mod","","Parses a source module as a crate. This is the main entry point for the parser.",215,[[["self"]],["presult",["crate"]]]],[11,"parse_optional_str","","",215,[[["self"]],["option"]]],[11,"parse_str","","",215,[[["self"]],["presult"]]],[0,"lexer","syntax::parse","",N,N],[3,"TokenAndSpan","syntax::parse::lexer","",N,N],[12,"tok","","",231,N],[12,"sp","","",231,N],[3,"StringReader","","",N,N],[12,"sess","","",232,N],[12,"next_pos","","The absolute offset within the source_map of the next character to read",232,N],[12,"pos","","The absolute offset within the source_map of the current character",232,N],[12,"ch","","The current character (which has been read from self.pos)",232,N],[12,"source_file","","",232,N],[12,"end_src_index","","Stop reading src at this index.",232,N],[12,"peek_tok","","",232,N],[12,"peek_span","","",232,N],[12,"peek_span_src_raw","","",232,N],[12,"fatal_errs","","",232,N],[12,"src","","",232,N],[12,"token","","Stack of open delimiters and their spans. Used for error message.",232,N],[12,"span","","",232,N],[12,"span_src_raw","","The raw source span which does not take `override_span` into account",232,N],[12,"open_braces","","",232,N],[12,"matching_delim_spans","","The type and spans for all braces",232,N],[12,"override_span","","",232,N],[12,"last_unclosed_found_span","","",232,N],[5,"is_pattern_whitespace","","",N,[[["option",["char"]]],["bool"]]],[5,"in_range","","",N,[[["option",["char"]],["char"],["char"]],["bool"]]],[5,"is_dec_digit","","",N,[[["option",["char"]]],["bool"]]],[5,"is_doc_comment","","",N,[[["str"]],["bool"]]],[5,"is_block_doc_comment","","",N,[[["str"]],["bool"]]],[5,"ident_start","","",N,[[["option",["char"]]],["bool"]]],[5,"ident_continue","","",N,[[["option",["char"]]],["bool"]]],[0,"comments","","",N,N],[3,"Comment","syntax::parse::lexer::comments","",N,N],[12,"style","","",233,N],[12,"lines","","",233,N],[12,"pos","","",233,N],[3,"Literal","","",N,N],[12,"lit","","",234,N],[12,"pos","","",234,N],[4,"CommentStyle","","",N,N],[13,"Isolated","","No code on either side of each line of the comment",235,N],[13,"Trailing","","Code exists to the left of the comment",235,N],[13,"Mixed","","Code before /* foo */ and after the comment",235,N],[13,"BlankLine","","Just a manual blank line \"\\n\\n\", for layout",235,N],[5,"is_doc_comment","","",N,[[["str"]],["bool"]]],[5,"doc_comment_style","","",N,[[["str"]],["attrstyle"]]],[5,"strip_doc_comment_decoration","","",N,[[["str"]],["string"]]],[5,"push_blank_line_comment","","",N,[[["stringreader"],["vec"]]]],[5,"consume_whitespace_counting_blank_lines","","",N,[[["stringreader"],["vec"]]]],[5,"read_shebang_comment","","",N,[[["stringreader"],["bool"],["vec"]]]],[5,"read_line_comments","","",N,[[["stringreader"],["bool"],["vec"]]]],[5,"all_whitespace","","Returns None if the first col chars of s contain a non-whitespace char. Otherwise returns Some(k) where k is first char offset after that leading whitespace.  Note k may be outside bounds of s.",N,[[["str"],["charpos"]],["option",["usize"]]]],[5,"trim_whitespace_prefix_and_push_line","","",N,[[["vec"],["string"],["charpos"]]]],[5,"read_block_comment","","",N,[[["stringreader"],["bool"],["vec"]]]],[5,"consume_comment","","",N,[[["stringreader"],["vec"],["bool"],["bool"]]]],[5,"gather_comments_and_literals","","",N,N],[11,"clone","","",235,[[["self"]],["commentstyle"]]],[11,"eq","","",235,[[["self"],["commentstyle"]],["bool"]]],[11,"fmt","","",235,[[["self"],["formatter"]],["result"]]],[11,"clone","","",233,[[["self"]],["comment"]]],[11,"clone","","",234,[[["self"]],["literal"]]],[0,"tokentrees","syntax::parse::lexer","",N,N],[11,"parse_all_token_trees","","",232,[[["self"]],["presult",["tokenstream"]]]],[11,"parse_token_trees_until_close_delim","","",232,[[["self"]],["tokenstream"]]],[11,"parse_token_tree","","",232,[[["self"]],["presult",["tokenstream"]]]],[0,"unicode_chars","","",N,N],[5,"check_for_substitution","syntax::parse::lexer::unicode_chars","",N,[[["stringreader"],["char"],["diagnosticbuilder"]],["bool"]]],[17,"UNICODE_ARRAY","","",N,N],[17,"ASCII_ARRAY","","",N,N],[11,"clone","syntax::parse::lexer","",231,[[["self"]],["tokenandspan"]]],[11,"fmt","","",231,[[["self"],["formatter"]],["result"]]],[11,"default","","",231,[[],["self"]]],[11,"mk_sp","","",232,[[["self"],["bytepos"],["bytepos"]],["span"]]],[11,"mk_sp_and_raw","","",232,N],[11,"mk_ident","","",232,[[["self"],["str"]],["ident"]]],[11,"unwrap_or_abort","","",232,[[["self"],["result",["tokenandspan"]]],["tokenandspan"]]],[11,"next_token","","",232,[[["self"]],["tokenandspan"]]],[11,"try_next_token","","Return the next token. EFFECT: advances the string_reader.",232,[[["self"]],["result",["tokenandspan"]]]],[11,"try_real_token","","",232,[[["self"]],["result",["tokenandspan"]]]],[11,"real_token","","",232,[[["self"]],["tokenandspan"]]],[11,"is_eof","","",232,[[["self"]],["bool"]]],[11,"fail_unterminated_raw_string","","",232,[[["self"],["bytepos"],["u16"]]]],[11,"fatal","","",232,[[["self"],["str"]],["fatalerror"]]],[11,"emit_fatal_errors","","",232,[[["self"]]]],[11,"peek","","",232,[[["self"]],["tokenandspan"]]],[11,"new_raw","","For comments.rs, which hackily pokes into next_pos and ch",232,[[["parsesess"],["lrc",["sourcefile"]],["option",["span"]]],["self"]]],[11,"new_raw_internal","","",232,[[["parsesess"],["lrc",["sourcefile"]],["option",["span"]]],["self"]]],[11,"new","","",232,[[["parsesess"],["lrc",["sourcefile"]],["option",["span"]]],["self"]]],[11,"retokenize","","",232,[[["parsesess"],["span"]],["self"]]],[11,"ch_is","","",232,[[["self"],["char"]],["bool"]]],[11,"fatal_span","","Report a fatal lexical error with a given span.",232,[[["self"],["span"],["str"]],["fatalerror"]]],[11,"err_span","","Report a lexical error with a given span.",232,[[["self"],["span"],["str"]]]],[11,"fatal_span_","","Report a fatal error spanning [`from_pos`, `to_pos`).",232,[[["self"],["bytepos"],["bytepos"],["str"]],["fatalerror"]]],[11,"err_span_","","Report a lexical error spanning [`from_pos`, `to_pos`).",232,[[["self"],["bytepos"],["bytepos"],["str"]]]],[11,"push_escaped_char_for_msg","","Pushes a character to a message string for error reporting",232,[[["string"],["char"]]]],[11,"fatal_span_char","","Report a lexical error spanning [`from_pos`, `to_pos`), appending an escaped character to the error message",232,[[["self"],["bytepos"],["bytepos"],["str"],["char"]],["fatalerror"]]],[11,"struct_span_fatal","","",232,[[["self"],["bytepos"],["bytepos"],["str"]],["diagnosticbuilder"]]],[11,"struct_fatal_span_char","","",232,[[["self"],["bytepos"],["bytepos"],["str"],["char"]],["diagnosticbuilder"]]],[11,"err_span_char","","Report a lexical error spanning [`from_pos`, `to_pos`), appending an escaped character to the error message",232,[[["self"],["bytepos"],["bytepos"],["str"],["char"]]]],[11,"struct_err_span_char","","",232,[[["self"],["bytepos"],["bytepos"],["str"],["char"]],["diagnosticbuilder"]]],[11,"fatal_span_verbose","","Report a lexical error spanning [`from_pos`, `to_pos`), appending the offending string to the error message",232,[[["self"],["bytepos"],["bytepos"],["string"]],["fatalerror"]]],[11,"advance_token","","Advance peek_tok and peek_span to refer to the next token, and possibly update the interner.",232,[[["self"]],["result"]]],[11,"src_index","","",232,[[["self"],["bytepos"]],["usize"]]],[11,"with_str_from","","Calls `f` with a string slice of the source text spanning from `start` up to but excluding `self.pos`, meaning the slice does not include the character `self.ch`.",232,[[["self"],["bytepos"],["f"]],["t"]]],[11,"name_from","","Create a Name from a given offset to the current offset, each adjusted 1 towards each other (assumes that on either side there is a single-byte delimiter).",232,[[["self"],["bytepos"]],["name"]]],[11,"name_from_to","","As name_from, with an explicit endpoint.",232,[[["self"],["bytepos"],["bytepos"]],["name"]]],[11,"with_str_from_to","","Calls `f` with a string slice of the source text spanning from `start` up to but excluding `end`.",232,[[["self"],["bytepos"],["bytepos"],["f"]],["t"]]],[11,"translate_crlf","","Converts CRLF to LF in the given string, raising an error on bare CR.",232,[[["self"],["bytepos"],["str"],["str"]],["cow",["str"]]]],[11,"bump","","Advance the StringReader by one character. If a newline is discovered, add it to the SourceFile's list of line start offsets.",232,[[["self"]]]],[11,"nextch","","",232,[[["self"]],["option",["char"]]]],[11,"nextch_is","","",232,[[["self"],["char"]],["bool"]]],[11,"nextnextch","","",232,[[["self"]],["option",["char"]]]],[11,"nextnextch_is","","",232,[[["self"],["char"]],["bool"]]],[11,"scan_optional_raw_name","","Eats <XID_start><XID_continue>*, if possible.",232,[[["self"]],["option",["name"]]]],[11,"scan_comment","","PRECONDITION: self.ch is not whitespace Eats any kind of comment.",232,[[["self"]],["option",["tokenandspan"]]]],[11,"scan_whitespace_or_comment","","If there is whitespace, shebang, or a comment, scan it. Otherwise, return None.",232,[[["self"]],["option",["tokenandspan"]]]],[11,"scan_block_comment","","Might return a sugared-doc-attr",232,[[["self"]],["option",["tokenandspan"]]]],[11,"scan_digits","","Scan through any digits (base `scan_radix`) or underscores, and return how many digits there were.",232,[[["self"],["u32"],["u32"]],["usize"]]],[11,"scan_number","","Lex a LIT_INTEGER or a LIT_FLOAT",232,[[["self"],["char"]],["lit"]]],[11,"scan_hex_digits","","Scan over `n_digits` hex digits, stopping at `delim`, reporting an error if too many or too few digits are encountered.",232,[[["self"],["usize"],["char"],["bool"]],["bool"]]],[11,"scan_char_or_byte","","Scan for a single (possibly escaped) byte or char in a byte, (non-raw) byte string, char, or (non-raw) string literal. `start` is the position of `first_source_char`, which is already consumed.",232,[[["self"],["bytepos"],["char"],["bool"],["char"]],["bool"]]],[11,"scan_unicode_escape","","Scan over a `\\u{...}` escape",232,[[["self"],["char"]],["bool"]]],[11,"scan_float_exponent","","Scan over a float exponent.",232,[[["self"]]]],[11,"check_float_base","","Check that a base is valid for a floating literal, emitting a nice error if it isn't.",232,[[["self"],["bytepos"],["bytepos"],["usize"]]]],[11,"binop","","",232,[[["self"],["binoptoken"]],["token"]]],[11,"next_token_inner","","Return the next token from the string, advances the input past that token, and updates the interner",232,[[["self"]],["result",["token"]]]],[11,"consume_whitespace","","",232,[[["self"]]]],[11,"read_to_eol","","",232,[[["self"]],["string"]]],[11,"read_one_line_comment","","",232,[[["self"]],["string"]]],[11,"consume_non_eol_whitespace","","",232,[[["self"]]]],[11,"peeking_at_comment","","",232,[[["self"]],["bool"]]],[11,"scan_byte","","",232,[[["self"]],["lit"]]],[11,"scan_byte_escape","","",232,[[["self"],["char"],["bool"]],["bool"]]],[11,"scan_byte_string","","",232,[[["self"]],["lit"]]],[11,"scan_raw_byte_string","","",232,[[["self"]],["lit"]]],[0,"token","syntax::parse","",N,N],[3,"LazyTokenStream","syntax::parse::token","",N,N],[12,"0","","",236,N],[4,"BinOpToken","","",N,N],[13,"Plus","","",237,N],[13,"Minus","","",237,N],[13,"Star","","",237,N],[13,"Slash","","",237,N],[13,"Percent","","",237,N],[13,"Caret","","",237,N],[13,"And","","",237,N],[13,"Or","","",237,N],[13,"Shl","","",237,N],[13,"Shr","","",237,N],[4,"DelimToken","","A delimiter token",N,N],[13,"Paren","","A round parenthesis: `(` or `)`",238,N],[13,"Bracket","","A square bracket: `[` or `]`",238,N],[13,"Brace","","A curly brace: `{` or `}`",238,N],[13,"NoDelim","","An empty delimiter",238,N],[4,"Lit","","",N,N],[13,"Byte","","",239,N],[13,"Char","","",239,N],[13,"Integer","","",239,N],[13,"Float","","",239,N],[13,"Str_","","",239,N],[13,"StrRaw","","",239,N],[13,"ByteStr","","",239,N],[13,"ByteStrRaw","","",239,N],[4,"Token","","",N,N],[13,"Eq","","",240,N],[13,"Lt","","",240,N],[13,"Le","","",240,N],[13,"EqEq","","",240,N],[13,"Ne","","",240,N],[13,"Ge","","",240,N],[13,"Gt","","",240,N],[13,"AndAnd","","",240,N],[13,"OrOr","","",240,N],[13,"Not","","",240,N],[13,"Tilde","","",240,N],[13,"BinOp","","",240,N],[13,"BinOpEq","","",240,N],[13,"At","","",240,N],[13,"Dot","","",240,N],[13,"DotDot","","",240,N],[13,"DotDotDot","","",240,N],[13,"DotDotEq","","",240,N],[13,"DotEq","","",240,N],[13,"Comma","","",240,N],[13,"Semi","","",240,N],[13,"Colon","","",240,N],[13,"ModSep","","",240,N],[13,"RArrow","","",240,N],[13,"LArrow","","",240,N],[13,"FatArrow","","",240,N],[13,"Pound","","",240,N],[13,"Dollar","","",240,N],[13,"Question","","",240,N],[13,"SingleQuote","","Used by proc macros for representing lifetimes, not generated by lexer right now.",240,N],[13,"OpenDelim","","An opening delimiter, eg. `{`",240,N],[13,"CloseDelim","","A closing delimiter, eg. `}`",240,N],[13,"Literal","","",240,N],[13,"Ident","","",240,N],[13,"Lifetime","","",240,N],[13,"Interpolated","","",240,N],[13,"DocComment","","Doc comment",240,N],[13,"Whitespace","","Whitespace",240,N],[13,"Comment","","Comment",240,N],[13,"Shebang","","",240,N],[13,"Eof","","",240,N],[4,"Nonterminal","","For interpolation during macro expansion.",N,N],[13,"NtItem","","",241,N],[13,"NtBlock","","",241,N],[13,"NtStmt","","",241,N],[13,"NtPat","","",241,N],[13,"NtExpr","","",241,N],[13,"NtTy","","",241,N],[13,"NtIdent","","",241,N],[13,"NtLifetime","","",241,N],[13,"NtLiteral","","",241,N],[13,"NtMeta","","Stuff inside brackets for attributes",241,N],[13,"NtPath","","",241,N],[13,"NtVis","","",241,N],[13,"NtTT","","",241,N],[13,"NtArm","","",241,N],[13,"NtImplItem","","",241,N],[13,"NtTraitItem","","",241,N],[13,"NtForeignItem","","",241,N],[13,"NtGenerics","","",241,N],[13,"NtWhereClause","","",241,N],[13,"NtArg","","",241,N],[5,"ident_can_begin_expr","","",N,[[["ident"],["bool"]],["bool"]]],[5,"ident_can_begin_type","","",N,[[["ident"],["bool"]],["bool"]]],[5,"is_op","","",N,[[["token"]],["bool"]]],[5,"prepend_attrs","","",N,N],[11,"clone","","",237,[[["self"]],["binoptoken"]]],[11,"eq","","",237,[[["self"],["binoptoken"]],["bool"]]],[11,"encode","","",237,[[["self"],["__s"]],["result"]]],[11,"decode","","",237,[[["__d"]],["result",["binoptoken"]]]],[11,"hash","","",237,N],[11,"fmt","","",237,[[["self"],["formatter"]],["result"]]],[11,"clone","","",238,[[["self"]],["delimtoken"]]],[11,"eq","","",238,[[["self"],["delimtoken"]],["bool"]]],[11,"encode","","",238,[[["self"],["__s"]],["result"]]],[11,"decode","","",238,[[["__d"]],["result",["delimtoken"]]]],[11,"hash","","",238,N],[11,"fmt","","",238,[[["self"],["formatter"]],["result"]]],[11,"len","","",238,[[["self"]],["usize"]]],[11,"is_empty","","",238,[[["self"]],["bool"]]],[11,"clone","","",239,[[["self"]],["lit"]]],[11,"eq","","",239,[[["self"],["lit"]],["bool"]]],[11,"ne","","",239,[[["self"],["lit"]],["bool"]]],[11,"encode","","",239,[[["self"],["__s"]],["result"]]],[11,"decode","","",239,[[["__d"]],["result",["lit"]]]],[11,"hash","","",239,N],[11,"fmt","","",239,[[["self"],["formatter"]],["result"]]],[11,"short_name","","",239,[[["self"]],["str"]]],[11,"probably_equal_for_proc_macro","","",239,[[["self"],["lit"]],["bool"]]],[11,"clone","","",240,[[["self"]],["token"]]],[11,"encode","","",240,[[["self"],["__s"]],["result"]]],[11,"decode","","",240,[[["__d"]],["result",["token"]]]],[11,"eq","","",240,[[["self"],["token"]],["bool"]]],[11,"ne","","",240,[[["self"],["token"]],["bool"]]],[11,"fmt","","",240,[[["self"],["formatter"]],["result"]]],[11,"interpolated","","",240,[[["nonterminal"]],["token"]]],[11,"from_ast_ident","","Recovers a `Token` from an `ast::Ident`. This creates a raw identifier if necessary.",240,[[["ident"]],["token"]]],[11,"is_like_plus","","",240,[[["self"]],["bool"]]],[11,"can_begin_expr","","Returns `true` if the token can appear at the start of an expression.",240,[[["self"]],["bool"]]],[11,"can_begin_type","","Returns `true` if the token can appear at the start of a type.",240,[[["self"]],["bool"]]],[11,"can_begin_bound","","Returns `true` if the token can appear at the start of a generic bound.",240,[[["self"]],["bool"]]],[11,"is_lit","","Returns `true` if the token is any literal",240,[[["self"]],["bool"]]],[11,"can_begin_literal_or_bool","","Returns `true` if the token is any literal, a minus (which can follow a literal, for example a '-42', or one of the boolean idents).",240,[[["self"]],["bool"]]],[11,"ident","","Returns an identifier if this token is an identifier.",240,[[["self"]],["option"]]],[11,"lifetime","","Returns a lifetime identifier if this token is a lifetime.",240,[[["self"]],["option",["ident"]]]],[11,"is_ident","","Returns `true` if the token is an identifier.",240,[[["self"]],["bool"]]],[11,"is_lifetime","","Returns `true` if the token is a lifetime.",240,[[["self"]],["bool"]]],[11,"is_ident_named","","Returns `true` if the token is a identifier whose name is the given string slice.",240,[[["self"],["str"]],["bool"]]],[11,"is_path","","Returns `true` if the token is an interpolated path.",240,[[["self"]],["bool"]]],[11,"is_mutability","","Returns `true` if the token is either the `mut` or `const` keyword.",240,[[["self"]],["bool"]]],[11,"is_qpath_start","","",240,[[["self"]],["bool"]]],[11,"is_path_start","","",240,[[["self"]],["bool"]]],[11,"is_keyword","","Returns `true` if the token is a given keyword, `kw`.",240,[[["self"],["keyword"]],["bool"]]],[11,"is_path_segment_keyword","","",240,[[["self"]],["bool"]]],[11,"is_special_ident","","",240,[[["self"]],["bool"]]],[11,"is_used_keyword","","Returns `true` if the token is a keyword used in the language.",240,[[["self"]],["bool"]]],[11,"is_unused_keyword","","Returns `true` if the token is a keyword reserved for possible future use.",240,[[["self"]],["bool"]]],[11,"is_reserved_ident","","Returns `true` if the token is either a special identifier or a keyword.",240,[[["self"]],["bool"]]],[11,"glue","","",240,[[["self"],["token"]],["option",["token"]]]],[11,"similar_tokens","","Returns tokens that are likely to be typed accidentally instead of the current token. Enables better error recovery when the wrong token is found.",240,[[["self"]],["option",["vec"]]]],[11,"interpolated_to_tokenstream","","",240,[[["self"],["parsesess"],["span"]],["tokenstream"]]],[11,"probably_equal_for_proc_macro","","",240,[[["self"],["token"]],["bool"]]],[11,"clone","","",241,[[["self"]],["nonterminal"]]],[11,"encode","","",241,[[["self"],["__s"]],["result"]]],[11,"decode","","",241,[[["__d"]],["result",["nonterminal"]]]],[11,"eq","","",241,[[["self"],["self"]],["bool"]]],[11,"fmt","","",241,[[["self"],["formatter"]],["result"]]],[11,"clone","","",236,[[["self"]],["lazytokenstream"]]],[11,"eq","","",236,[[["self"],["lazytokenstream"]],["bool"]]],[11,"fmt","","",236,[[["self"],["formatter"]],["result"]]],[11,"new","","",236,[[],["self"]]],[11,"force","","",236,[[["self"],["f"]],["tokenstream"]]],[11,"encode","","",236,[[["self"],["s"]],["result"]]],[11,"decode","","",236,[[["d"]],["result",["lazytokenstream"]]]],[11,"hash","","",236,[[["self"],["h"]]]],[0,"attr","syntax::parse","",N,N],[4,"InnerAttributeParsePolicy","syntax::parse::attr","",N,N],[13,"Permitted","","",242,N],[13,"NotPermitted","","",242,N],[12,"reason","syntax::parse::attr::InnerAttributeParsePolicy","",242,N],[17,"DEFAULT_UNEXPECTED_INNER_ATTR_ERR_MSG","syntax::parse::attr","",N,N],[11,"fmt","","",242,[[["self"],["formatter"]],["result"]]],[11,"parse_outer_attributes","syntax::parse::parser","Parse attributes that appear before an item",215,[[["self"]],["presult",["vec"]]]],[11,"parse_attribute","","Matches `attribute = # ! [ meta_item ]`",215,[[["self"],["bool"]],["presult",["attribute"]]]],[11,"parse_attribute_with_inner_parse_policy","","The same as `parse_attribute`, except it takes in an `InnerAttributeParsePolicy` that prescribes how to handle inner attributes.",215,[[["self"],["innerattributeparsepolicy"]],["presult",["attribute"]]]],[11,"parse_meta_item_unrestricted","","Parse an inner part of attribute - path and following tokens. The tokens must be either a delimited token stream, or empty token stream, or the \"legacy\" key-value form. PATH `(` TOKEN_STREAM `)` PATH `[` TOKEN_STREAM `]` PATH `{` TOKEN_STREAM `}` PATH PATH `=` TOKEN_TREE The delimiters or `=` are still put into the resulting token stream.",215,[[["self"]],["presult"]]],[11,"parse_inner_attributes","","Parse attributes that appear after the opening of an item. These should be preceded by an exclamation mark, but we accept and warn about one terminated by a semicolon. matches inner_attrs*",215,[[["self"]],["presult",["vec"]]]],[11,"parse_unsuffixed_lit","","",215,[[["self"]],["presult",["lit"]]]],[11,"parse_meta_item","","Per RFC#1559, matches the following grammar:",215,[[["self"]],["presult",["metaitem"]]]],[11,"parse_meta_item_kind","","",215,[[["self"]],["presult",["metaitemkind"]]]],[11,"parse_meta_item_inner","","matches meta_item_inner : (meta_item | UNSUFFIXED_LIT) ;",215,[[["self"]],["presult",["nestedmetaitem"]]]],[11,"parse_meta_seq","","matches meta_seq = ( COMMASEP(meta_item_inner) )",215,[[["self"]],["presult",["vec"]]]],[0,"classify","syntax::parse","Routines the parser uses to classify AST nodes",N,N],[5,"expr_requires_semi_to_be_stmt","syntax::parse::classify","Does this expression require a semicolon to be treated as a statement? The negation of this: 'can this expression be used as a statement without a semicolon' -- is used as an early-bail-out in the parser so that, for instance,     if true {...} else {...}      |x| 5 isn't parsed as (if true {...} else {...} | x) | 5",N,[[["expr"]],["bool"]]],[5,"stmt_ends_with_semi","","this statement requires a semicolon after it. note that in one case (`stmt_semi`), we've already seen the semicolon, and thus don't need another.",N,[[["stmtkind"]],["bool"]]],[6,"PResult","syntax::parse","",N,N],[11,"new","","",210,[[["filepathmapping"]],["self"]]],[11,"with_span_handler","","",210,[[["handler"],["lrc",["sourcemap"]]],["parsesess"]]],[11,"source_map","","",210,[[["self"]],["sourcemap"]]],[11,"buffer_lint","","",210,[[["self"],["bufferedearlylintid"],["s"],["nodeid"],["str"]]]],[11,"clone","","",211,[[["self"]],["directory"]]],[11,"clone","","",213,[[["self"]],["directoryownership"]]],[11,"trailing_allowed","","",212,[[["token"]],["seqsep"]]],[11,"none","","",212,[[],["seqsep"]]],[0,"ptr","syntax","The AST pointer",N,N],[3,"P","syntax::ptr","An owned smart pointer.",N,N],[12,"ptr","","",243,N],[5,"P","","Construct a `P<T>` from a `T` value.",N,[[["t"]],["p"]]],[11,"hash","","",243,N],[11,"eq","","",243,[[["self"],["p"]],["bool"]]],[11,"ne","","",243,[[["self"],["p"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",243,N],[11,"and_then","","Move out of the pointer. Intended for chaining transformations not covered by `map`.",243,[[["self"],["f"]],["u"]]],[11,"into_inner","","Equivalent to and_then(|x| x)",243,[[["self"]],["t"]]],[11,"map","","Transform the inner value, consuming `self` and producing a new `P<T>`.",243,[[["self"],["f"]],["p"]]],[11,"deref","","",243,[[["self"]],["t"]]],[11,"deref_mut","","",243,[[["self"]],["t"]]],[11,"clone","","",243,[[["self"]],["p"]]],[11,"fmt","","",243,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",243,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",243,[[["self"],["formatter"]],["result"]]],[11,"decode","","",243,[[["d"]],["result",["p"]]]],[11,"encode","","",243,[[["self"],["s"]],["result"]]],[11,"new","","",243,[[],["p"]]],[11,"from_vec","","",243,[[["vec"]],["p"]]],[11,"into_vec","","",243,[[["self"]],["vec"]]],[11,"default","","Creates an empty `P<[T]>`.",243,[[],["p"]]],[11,"clone","","",243,[[["self"]],["p"]]],[11,"from","","",243,[[["vec"]],["self"]]],[11,"into","","",243,[[["self"]],["vec"]]],[11,"from_iter","","",243,[[["i"]],["p"]]],[11,"into_iter","","",243,N],[11,"encode","","",243,[[["self"],["s"]],["result"]]],[11,"decode","","",243,[[["d"]],["result",["p"]]]],[11,"hash_stable","","",243,[[["self"],["ctx"],["stablehasher"]]]],[0,"show_span","syntax","Span debugger",N,N],[3,"ShowSpanVisitor","syntax::show_span","",N,N],[12,"span_diagnostic","","",244,N],[12,"mode","","",244,N],[4,"Mode","","",N,N],[13,"Expression","","",245,N],[13,"Pattern","","",245,N],[13,"Type","","",245,N],[5,"run","","",N,[[["handler"],["str"],["crate"]]]],[11,"from_str","","",245,[[["str"]],["result",["mode"]]]],[11,"visit_expr","","",244,[[["self"],["expr"]]]],[11,"visit_pat","","",244,[[["self"],["pat"]]]],[11,"visit_ty","","",244,[[["self"],["ty"]]]],[11,"visit_mac","","",244,[[["self"],["mac"]]]],[0,"std_inject","syntax","",N,N],[5,"ignored_span","syntax::std_inject","Craft a span that will be ignored by the stability lint's call to source_map's `is_internal` check. The expanded code uses the unstable `#[prelude_import]` attribute.",N,[[["span"]],["span"]]],[5,"injected_crate_name","","",N,[[],["option",["str"]]]],[5,"maybe_inject_crates_ref","","",N,[[["crate"],["option",["str"]],["edition"]],["crate"]]],[17,"INJECTED_CRATE_NAME","","",N,N],[0,"str","syntax","",N,N],[5,"char_at","syntax::str","",N,[[["str"],["usize"]],["char"]]],[0,"test","syntax","",N,N],[3,"Test","syntax::test","",N,N],[12,"span","","",246,N],[12,"path","","",246,N],[3,"TestCtxt","","",N,N],[12,"span_diagnostic","","",247,N],[12,"path","","",247,N],[12,"ext_cx","","",247,N],[12,"test_cases","","",247,N],[12,"reexport_test_harness_main","","",247,N],[12,"is_libtest","","",247,N],[12,"ctxt","","",247,N],[12,"features","","",247,N],[12,"test_runner","","",247,N],[12,"toplevel_reexport","","",247,N],[3,"TestHarnessGenerator","","",N,N],[12,"cx","","",248,N],[12,"tests","","",248,N],[12,"tested_submods","","",248,N],[3,"EntryPointCleaner","","A folder used to remove any entry points (like fn main) because the harness generator will provide its own",N,N],[12,"depth","","",249,N],[4,"HasTestSignature","","",N,N],[13,"Yes","","",250,N],[13,"No","","",250,N],[4,"BadTestSignature","","",N,N],[13,"NotEvenAFunction","","",251,N],[13,"WrongTypeSignature","","",251,N],[13,"NoArgumentsAllowed","","",251,N],[13,"ShouldPanicOnlyWithNoArgs","","",251,N],[5,"modify_for_testing","","",N,[[["parsesess"],["resolver"],["bool"],["crate"],["handler"],["features"]],["crate"]]],[5,"mk_reexport_mod","","Creates an item (specifically a module) that \"pub use\"s the tests passed in. Each tested submodule will contain a similar reexport module that we will export under the name of the original module. That is, `submod::__test_reexports` is reexported like so `pub use submod::__test_reexports as submod`.",N,N],[5,"generate_test_harness","","Crawl over the crate, inserting test reexports and the test main function",N,[[["parsesess"],["resolver"],["option",["symbol"]],["crate"],["handler"],["features"],["option",["path"]]],["crate"]]],[5,"ignored_span","","Craft a span that will be ignored by the stability lint's call to source_map's `is_internal` check. The expanded code calls some unstable functions in the test crate.",N,[[["testctxt"],["span"]],["span"]]],[5,"mk_main","","Creates a function item for use as the main function of a test build. This function will call the `test_runner` as specified by the crate attribute",N,[[["testctxt"]],["p",["item"]]]],[5,"path_name_i","","",N,N],[5,"mk_tests_slice","","Creates a slice containing every test like so: &[path::to::test1, path::to::test2]",N,[[["testctxt"]],["p",["expr"]]]],[5,"visible_path","","Creates a path from the top-level __test module to the test via __test_reexports",N,N],[5,"is_test_case","","",N,[[["item"]],["bool"]]],[5,"get_test_runner","","",N,[[["handler"],["crate"]],["option",["path"]]]],[11,"fold_crate","","",248,[[["self"],["crate"]],["crate"]]],[11,"fold_item","","",248,[[["self"],["p",["item"]]],["onevector",["p"]]]],[11,"fold_mac","","",248,[[["self"],["mac"]],["mac"]]],[11,"fold_item","","",249,[[["self"],["p",["item"]]],["onevector",["p"]]]],[11,"fold_mac","","",249,[[["self"],["mac"]],["mac"]]],[11,"eq","","",251,[[["self"],["badtestsignature"]],["bool"]]],[0,"tokenstream","syntax","Token Streams",N,N],[3,"Delimited","syntax::tokenstream","A delimited sequence of token trees",N,N],[12,"delim","","The type of delimiter",252,N],[12,"tts","","The delimited sequence of token trees",252,N],[3,"TokenStream","","Token Streams",N,N],[12,"kind","","",253,N],[3,"TokenStreamBuilder","","",N,N],[12,"0","","",254,N],[3,"Cursor","","",N,N],[12,"0","","",255,N],[3,"StreamCursor","","",N,N],[12,"stream","","",256,N],[12,"index","","",256,N],[12,"stack","","",256,N],[3,"ThinTokenStream","","The `TokenStream` type is large enough to represent a single `TokenTree` without allocation. `ThinTokenStream` is smaller, but needs to allocate to represent a single `TokenTree`. We must use `ThinTokenStream` in `TokenTree::Delimited` to avoid infinite size due to recursion.",N,N],[12,"0","","",257,N],[3,"DelimSpan","","",N,N],[12,"open","","",258,N],[12,"close","","",258,N],[4,"TokenTree","","When the main rust parser encounters a syntax-extension invocation, it parses the arguments to the invocation as a token-tree. This is a very loose structure, such that all sorts of different AST-fragments can be passed to syntax extensions using a uniform type.",N,N],[13,"Token","","A single token",259,N],[13,"Delimited","","A delimited sequence of token trees",259,N],[4,"TokenStreamKind","","",N,N],[13,"Empty","","",260,N],[13,"Tree","","",260,N],[13,"JointTree","","",260,N],[13,"Stream","","",260,N],[4,"CursorKind","","",N,N],[13,"Empty","","",261,N],[13,"Tree","","",261,N],[13,"JointTree","","",261,N],[13,"Stream","","",261,N],[11,"clone","","",252,[[["self"]],["delimited"]]],[11,"eq","","",252,[[["self"],["delimited"]],["bool"]]],[11,"ne","","",252,[[["self"],["delimited"]],["bool"]]],[11,"encode","","",252,[[["self"],["__s"]],["result"]]],[11,"decode","","",252,[[["__d"]],["result",["delimited"]]]],[11,"fmt","","",252,[[["self"],["formatter"]],["result"]]],[11,"open_token","","Returns the opening delimiter as a token.",252,[[["self"]],["token"]]],[11,"close_token","","Returns the closing delimiter as a token.",252,[[["self"]],["token"]]],[11,"open_tt","","Returns the opening delimiter as a token tree.",252,[[["self"],["span"]],["tokentree"]]],[11,"close_tt","","Returns the closing delimiter as a token tree.",252,[[["self"],["span"]],["tokentree"]]],[11,"stream","","Returns the token trees inside the delimiters.",252,[[["self"]],["tokenstream"]]],[11,"fmt","","",259,[[["self"],["formatter"]],["result"]]],[11,"clone","","",259,[[["self"]],["tokentree"]]],[11,"eq","","",259,[[["self"],["tokentree"]],["bool"]]],[11,"ne","","",259,[[["self"],["tokentree"]],["bool"]]],[11,"encode","","",259,[[["self"],["__s"]],["result"]]],[11,"decode","","",259,[[["__d"]],["result",["tokentree"]]]],[11,"parse","","Use this token tree as a matcher to parse given tts.",259,N],[11,"eq_unspanned","","Check if this TokenTree is equal to the other, regardless of span information.",259,[[["self"],["tokentree"]],["bool"]]],[11,"probably_equal_for_proc_macro","","",259,[[["self"],["tokentree"]],["bool"]]],[11,"span","","Retrieve the TokenTree's span.",259,[[["self"]],["span"]]],[11,"set_span","","Modify the `TokenTree`'s span inplace.",259,[[["self"],["span"]]]],[11,"eq_token","","Indicates if the stream is a token that is equal to the provided token.",259,[[["self"],["token"]],["bool"]]],[11,"joint","","",259,[[["self"]],["tokenstream"]]],[11,"clone","","",253,[[["self"]],["tokenstream"]]],[11,"fmt","","",253,[[["self"],["formatter"]],["result"]]],[11,"add_comma","","Given a `TokenStream` with a `Stream` of only two arguments, return a new `TokenStream` separating the two arguments with a comma for diagnostic suggestions.",253,[[["self"]],["option"]]],[11,"clone","","",260,[[["self"]],["tokenstreamkind"]]],[11,"fmt","","",260,[[["self"],["formatter"]],["result"]]],[11,"from","","",253,[[["tokentree"]],["tokenstream"]]],[11,"from","","",253,[[["token"]],["tokenstream"]]],[11,"from_iter","","",253,[[["i"]],["self"]]],[11,"extend","","",253,[[["self"],["i"]]]],[11,"eq","","",253,[[["self"],["tokenstream"]],["bool"]]],[11,"len","","",253,[[["self"]],["usize"]]],[11,"empty","","",253,[[],["tokenstream"]]],[11,"is_empty","","",253,[[["self"]],["bool"]]],[11,"concat","","",253,[[["vec",["tokenstream"]]],["tokenstream"]]],[11,"concat_rc_vec","","",253,[[["rcvec",["tokenstream"]]],["tokenstream"]]],[11,"trees","","",253,[[["self"]],["cursor"]]],[11,"into_trees","","",253,[[["self"]],["cursor"]]],[11,"eq_unspanned","","Compares two TokenStreams, checking equality without regarding span information.",253,[[["self"],["tokenstream"]],["bool"]]],[11,"probably_equal_for_proc_macro","","",253,[[["self"],["tokenstream"]],["bool"]]],[11,"as_tree","","Precondition: `self` consists of a single token tree. Returns true if the token tree is a joint operation w.r.t. `proc_macro::TokenNode`.",253,N],[11,"map_enumerated","","",253,[[["self"],["f"]],["tokenstream"]]],[11,"map","","",253,[[["self"],["f"]],["tokenstream"]]],[11,"first_tree_and_joint","","",253,[[["self"]],["option"]]],[11,"last_tree_if_joint","","",253,[[["self"]],["option",["tokentree"]]]],[11,"clone","","",254,[[["self"]],["tokenstreambuilder"]]],[11,"new","","",254,[[],["tokenstreambuilder"]]],[11,"push","","",254,[[["self"],["t"]]]],[11,"add","","",254,[[["self"],["t"]],["self"]]],[11,"build","","",254,[[["self"]],["tokenstream"]]],[11,"push_all_but_last_tree","","",254,[[["self"],["tokenstream"]]]],[11,"push_all_but_first_tree","","",254,[[["self"],["tokenstream"]]]],[11,"clone","","",255,[[["self"]],["cursor"]]],[11,"clone","","",261,[[["self"]],["cursorkind"]]],[11,"clone","","",256,[[["self"]],["streamcursor"]]],[11,"new","","",256,[[["rcvec",["tokenstream"]]],["self"]]],[11,"next_as_stream","","",256,[[["self"]],["option",["tokenstream"]]]],[11,"insert","","",256,[[["self"],["rcvec",["tokenstream"]]]]],[11,"next","","",255,[[["self"]],["option",["tokentree"]]]],[11,"new","","",255,[[["tokenstream"]],["self"]]],[11,"next_as_stream","","",255,[[["self"]],["option",["tokenstream"]]]],[11,"insert","","",255,[[["self"],["tokenstream"]]]],[11,"original_stream","","",255,[[["self"]],["tokenstream"]]],[11,"look_ahead","","",255,[[["self"],["usize"]],["option",["tokentree"]]]],[11,"fmt","","",257,[[["self"],["formatter"]],["result"]]],[11,"clone","","",257,[[["self"]],["thintokenstream"]]],[11,"from","","",257,[[["tokenstream"]],["thintokenstream"]]],[11,"from","","",253,[[["thintokenstream"]],["tokenstream"]]],[11,"eq","","",257,[[["self"],["thintokenstream"]],["bool"]]],[11,"fmt","","",253,[[["self"],["formatter"]],["result"]]],[11,"encode","","",253,[[["self"],["e"]],["result"]]],[11,"decode","","",253,[[["d"]],["result",["tokenstream"]]]],[11,"encode","","",257,[[["self"],["e"]],["result"]]],[11,"decode","","",257,[[["d"]],["result",["thintokenstream"]]]],[11,"fmt","","",258,[[["self"],["formatter"]],["result"]]],[11,"clone","","",258,[[["self"]],["delimspan"]]],[11,"eq","","",258,[[["self"],["delimspan"]],["bool"]]],[11,"ne","","",258,[[["self"],["delimspan"]],["bool"]]],[11,"encode","","",258,[[["self"],["__s"]],["result"]]],[11,"decode","","",258,[[["__d"]],["result",["delimspan"]]]],[11,"from_single","","",258,[[["span"]],["self"]]],[11,"from_pair","","",258,[[["span"],["span"]],["self"]]],[11,"dummy","","",258,[[],["self"]]],[11,"entire","","",258,[[["self"]],["span"]]],[11,"apply_mark","","",258,[[["self"],["mark"]],["self"]]],[0,"visit","syntax","AST walker. Each overridden visit method has full control over what happens with its node, it can do its own traversal of the node's children, call `visit::walk_*` to apply the default traversal algorithm, or prevent deeper traversal by doing nothing.",N,N],[4,"FnKind","syntax::visit","",N,N],[13,"ItemFn","","fn foo() or extern \"Abi\" fn foo()",262,N],[13,"Method","","fn foo(&self)",262,N],[13,"Closure","","|x, y| body",262,N],[5,"walk_ident","","",N,[[["v"],["ident"]]]],[5,"walk_crate","","",N,[[["v"],["crate"]]]],[5,"walk_mod","","",N,[[["v"],["mod"]]]],[5,"walk_local","","",N,[[["v"],["local"]]]],[5,"walk_label","","",N,[[["v"],["label"]]]],[5,"walk_lifetime","","",N,[[["v"],["lifetime"]]]],[5,"walk_poly_trait_ref","","",N,[[["v"],["polytraitref"],["traitboundmodifier"]]]],[5,"walk_trait_ref","","",N,[[["v"],["traitref"]]]],[5,"walk_item","","",N,[[["v"],["item"]]]],[5,"walk_enum_def","","",N,[[["v"],["enumdef"],["generics"],["nodeid"]]]],[5,"walk_variant","","",N,[[["v"],["variant"],["generics"],["nodeid"]]]],[5,"walk_ty","","",N,[[["v"],["ty"]]]],[5,"walk_path","","",N,[[["v"],["path"]]]],[5,"walk_use_tree","","",N,[[["v"],["usetree"],["nodeid"]]]],[5,"walk_path_segment","","",N,[[["v"],["span"],["pathsegment"]]]],[5,"walk_generic_args","","",N,[[["v"],["span"],["genericargs"]]]],[5,"walk_assoc_type_binding","","",N,[[["v"],["typebinding"]]]],[5,"walk_pat","","",N,[[["v"],["pat"]]]],[5,"walk_foreign_item","","",N,[[["v"],["foreignitem"]]]],[5,"walk_global_asm","","",N,[[["v"],["globalasm"]]]],[5,"walk_param_bound","","",N,[[["v"],["genericbound"]]]],[5,"walk_generic_param","","",N,[[["v"],["genericparam"]]]],[5,"walk_generics","","",N,[[["v"],["generics"]]]],[5,"walk_where_predicate","","",N,[[["v"],["wherepredicate"]]]],[5,"walk_fn_ret_ty","","",N,[[["v"],["functionretty"]]]],[5,"walk_fn_decl","","",N,[[["v"],["fndecl"]]]],[5,"walk_fn","","",N,[[["v"],["fnkind"],["fndecl"],["span"]]]],[5,"walk_trait_item","","",N,[[["v"],["traititem"]]]],[5,"walk_impl_item","","",N,[[["v"],["implitem"]]]],[5,"walk_struct_def","","",N,[[["v"],["variantdata"]]]],[5,"walk_struct_field","","",N,[[["v"],["structfield"]]]],[5,"walk_block","","",N,[[["v"],["block"]]]],[5,"walk_stmt","","",N,[[["v"],["stmt"]]]],[5,"walk_mac","","",N,[[["v"],["mac"]]]],[5,"walk_anon_const","","",N,[[["v"],["anonconst"]]]],[5,"walk_expr","","",N,[[["v"],["expr"]]]],[5,"walk_arm","","",N,[[["v"],["arm"]]]],[5,"walk_vis","","",N,[[["v"],["visibility"]]]],[5,"walk_attribute","","",N,[[["v"],["attribute"]]]],[5,"walk_tt","","",N,[[["v"],["tokentree"]]]],[5,"walk_tts","","",N,[[["v"],["tokenstream"]]]],[8,"Visitor","","Each method of the Visitor trait is a hook to be potentially overridden.  Each method's default implementation recursively visits the substructure of the input via the corresponding `walk` method; e.g. the `visit_mod` method by default calls `visit::walk_mod`.",N,N],[11,"visit_name","","",263,[[["self"],["span"],["name"]]]],[11,"visit_ident","","",263,[[["self"],["ident"]]]],[11,"visit_mod","","",263,N],[11,"visit_foreign_item","","",263,[[["self"],["foreignitem"]]]],[11,"visit_global_asm","","",263,[[["self"],["globalasm"]]]],[11,"visit_item","","",263,[[["self"],["item"]]]],[11,"visit_local","","",263,[[["self"],["local"]]]],[11,"visit_block","","",263,[[["self"],["block"]]]],[11,"visit_stmt","","",263,[[["self"],["stmt"]]]],[11,"visit_arm","","",263,[[["self"],["arm"]]]],[11,"visit_pat","","",263,[[["self"],["pat"]]]],[11,"visit_anon_const","","",263,[[["self"],["anonconst"]]]],[11,"visit_expr","","",263,[[["self"],["expr"]]]],[11,"visit_expr_post","","",263,[[["self"],["expr"]]]],[11,"visit_ty","","",263,[[["self"],["ty"]]]],[11,"visit_generic_param","","",263,[[["self"],["genericparam"]]]],[11,"visit_generics","","",263,[[["self"],["generics"]]]],[11,"visit_where_predicate","","",263,[[["self"],["wherepredicate"]]]],[11,"visit_fn","","",263,[[["self"],["fnkind"],["fndecl"],["span"],["nodeid"]]]],[11,"visit_trait_item","","",263,[[["self"],["traititem"]]]],[11,"visit_impl_item","","",263,[[["self"],["implitem"]]]],[11,"visit_trait_ref","","",263,[[["self"],["traitref"]]]],[11,"visit_param_bound","","",263,[[["self"],["genericbound"]]]],[11,"visit_poly_trait_ref","","",263,[[["self"],["polytraitref"],["traitboundmodifier"]]]],[11,"visit_variant_data","","",263,[[["self"],["variantdata"],["ident"],["generics"],["nodeid"],["span"]]]],[11,"visit_struct_field","","",263,[[["self"],["structfield"]]]],[11,"visit_enum_def","","",263,[[["self"],["enumdef"],["generics"],["nodeid"],["span"]]]],[11,"visit_variant","","",263,[[["self"],["variant"],["generics"],["nodeid"]]]],[11,"visit_label","","",263,[[["self"],["label"]]]],[11,"visit_lifetime","","",263,[[["self"],["lifetime"]]]],[11,"visit_mac","","",263,[[["self"],["mac"]]]],[11,"visit_mac_def","","",263,[[["self"],["macrodef"],["nodeid"]]]],[11,"visit_path","","",263,[[["self"],["path"],["nodeid"]]]],[11,"visit_use_tree","","",263,[[["self"],["usetree"],["nodeid"],["bool"]]]],[11,"visit_path_segment","","",263,[[["self"],["span"],["pathsegment"]]]],[11,"visit_generic_args","","",263,[[["self"],["span"],["genericargs"]]]],[11,"visit_generic_arg","","",263,[[["self"],["genericarg"]]]],[11,"visit_assoc_type_binding","","",263,[[["self"],["typebinding"]]]],[11,"visit_attribute","","",263,[[["self"],["attribute"]]]],[11,"visit_tt","","",263,[[["self"],["tokentree"]]]],[11,"visit_tts","","",263,[[["self"],["tokenstream"]]]],[11,"visit_token","","",263,[[["self"],["token"]]]],[11,"visit_vis","","",263,[[["self"],["visibility"]]]],[11,"visit_fn_ret_ty","","",263,[[["self"],["functionretty"]]]],[11,"clone","","",262,[[["self"]],["fnkind"]]],[0,"print","syntax","",N,N],[0,"pp","syntax::print","This pretty-printer is a direct reimplementation of Philip Karlton's Mesa pretty-printer, as described in appendix A of",N,N],[3,"BreakToken","syntax::print::pp","",N,N],[12,"offset","","",264,N],[12,"blank_space","","",264,N],[3,"BeginToken","","",N,N],[12,"offset","","",265,N],[12,"breaks","","",265,N],[3,"PrintStackElem","","",N,N],[12,"offset","","",266,N],[12,"pbreak","","",266,N],[3,"Printer","","",N,N],[12,"out","","",267,N],[12,"buf_max_len","","",267,N],[12,"margin","","Width of lines we're constrained to",267,N],[12,"space","","Number of spaces left on line",267,N],[12,"left","","Index of left side of input stream",267,N],[12,"right","","Index of right side of input stream",267,N],[12,"buf","","Ring-buffer of tokens and calculated sizes",267,N],[12,"left_total","","Running size of stream \"...left\"",267,N],[12,"right_total","","Running size of stream \"...right\"",267,N],[12,"scan_stack","","Pseudo-stack, really a ring too. Holds the primary-ring-buffers index of the Begin that started the current block, possibly with the most recent Break after that Begin (if there is any) on top of it. Stuff is flushed off the bottom as it becomes irrelevant due to the primary ring-buffer advancing.",267,N],[12,"print_stack","","Stack of blocks-in-progress being flushed by print",267,N],[12,"pending_indentation","","Buffered indentation to avoid writing trailing whitespace",267,N],[3,"BufEntry","","",N,N],[12,"token","","",268,N],[12,"size","","",268,N],[4,"Breaks","","How to break. Described in more detail in the module docs.",N,N],[13,"Consistent","","",269,N],[13,"Inconsistent","","",269,N],[4,"Token","","",N,N],[13,"String","","",270,N],[13,"Break","","",270,N],[13,"Begin","","",270,N],[13,"End","","",270,N],[13,"Eof","","",270,N],[4,"PrintStackBreak","","",N,N],[13,"Fits","","",271,N],[13,"Broken","","",271,N],[5,"buf_str","","",N,N],[5,"mk_printer","","",N,[[["box",["write"]],["usize"]],["printer"]]],[17,"SIZE_INFINITY","","",N,N],[11,"clone","","",269,[[["self"]],["breaks"]]],[11,"eq","","",269,[[["self"],["breaks"]],["bool"]]],[11,"clone","","",264,[[["self"]],["breaktoken"]]],[11,"clone","","",265,[[["self"]],["begintoken"]]],[11,"clone","","",270,[[["self"]],["token"]]],[11,"is_eof","","",270,[[["self"]],["bool"]]],[11,"is_hardbreak_tok","","",270,[[["self"]],["bool"]]],[11,"fmt","","",270,[[["self"],["formatter"]],["result"]]],[11,"clone","","",271,[[["self"]],["printstackbreak"]]],[11,"clone","","",266,[[["self"]],["printstackelem"]]],[11,"clone","","",268,[[["self"]],["bufentry"]]],[11,"default","","",268,[[],["self"]]],[11,"last_token","","",267,[[["self"]],["token"]]],[11,"replace_last_token","","be very careful with this!",267,[[["self"],["token"]]]],[11,"pretty_print","","",267,[[["self"],["token"]],["result"]]],[11,"check_stream","","",267,[[["self"]],["result"]]],[11,"scan_push","","",267,[[["self"],["usize"]]]],[11,"scan_pop","","",267,[[["self"]],["usize"]]],[11,"scan_top","","",267,[[["self"]],["usize"]]],[11,"scan_pop_bottom","","",267,[[["self"]],["usize"]]],[11,"advance_right","","",267,[[["self"]]]],[11,"advance_left","","",267,[[["self"]],["result"]]],[11,"check_stack","","",267,[[["self"],["isize"]]]],[11,"print_newline","","",267,[[["self"],["isize"]],["result"]]],[11,"indent","","",267,[[["self"],["isize"]]]],[11,"get_top","","",267,[[["self"]],["printstackelem"]]],[11,"print_str","","",267,[[["self"],["str"]],["result"]]],[11,"print","","",267,[[["self"],["token"],["isize"]],["result"]]],[11,"rbox","","\"raw box\"",267,[[["self"],["usize"],["breaks"]],["result"]]],[11,"ibox","","Inconsistent breaking box",267,[[["self"],["usize"]],["result"]]],[11,"cbox","","Consistent breaking box",267,[[["self"],["usize"]],["result"]]],[11,"break_offset","","",267,[[["self"],["usize"],["isize"]],["result"]]],[11,"end","","",267,[[["self"]],["result"]]],[11,"eof","","",267,[[["self"]],["result"]]],[11,"word","","",267,[[["self"],["str"]],["result"]]],[11,"huge_word","","",267,[[["self"],["str"]],["result"]]],[11,"zero_word","","",267,[[["self"],["str"]],["result"]]],[11,"spaces","","",267,[[["self"],["usize"]],["result"]]],[11,"zerobreak","","",267,[[["self"]],["result"]]],[11,"space","","",267,[[["self"]],["result"]]],[11,"hardbreak","","",267,[[["self"]],["result"]]],[11,"hardbreak_tok_offset","","",267,[[["isize"]],["token"]]],[11,"hardbreak_tok","","",267,[[],["token"]]],[0,"pprust","syntax::print","",N,N],[3,"NoAnn","syntax::print::pprust","",N,N],[3,"State","","",N,N],[12,"s","","",272,N],[12,"cm","","",272,N],[12,"comments","","",272,N],[12,"literals","","",272,N],[12,"cur_cmnt","","",272,N],[12,"boxes","","",272,N],[12,"ann","","",272,N],[4,"AnnNode","","",N,N],[13,"Ident","","",273,N],[13,"Name","","",273,N],[13,"Block","","",273,N],[13,"Item","","",273,N],[13,"SubItem","","",273,N],[13,"Expr","","",273,N],[13,"Pat","","",273,N],[5,"rust_printer","","",N,[[["box",["write"]],["ppann"]],["state"]]],[5,"print_crate","","Requires you to pass an input filename and reader so that it can scan the input text for comments and literals to copy forward.",N,[[["sourcemap"],["parsesess"],["crate"],["filename"],["read"],["box",["write"]],["ppann"],["bool"]],["result"]]],[5,"to_string","","",N,[[["f"]],["string"]]],[5,"binop_to_string","","",N,[[["binoptoken"]],["str"]]],[5,"token_to_string","","",N,[[["token"]],["string"]]],[5,"ty_to_string","","",N,[[["ty"]],["string"]]],[5,"bounds_to_string","","",N,N],[5,"pat_to_string","","",N,[[["pat"]],["string"]]],[5,"arm_to_string","","",N,[[["arm"]],["string"]]],[5,"expr_to_string","","",N,[[["expr"]],["string"]]],[5,"lifetime_to_string","","",N,[[["lifetime"]],["string"]]],[5,"tt_to_string","","",N,[[["tokentree"]],["string"]]],[5,"tts_to_string","","",N,N],[5,"tokens_to_string","","",N,[[["tokenstream"]],["string"]]],[5,"stmt_to_string","","",N,[[["stmt"]],["string"]]],[5,"attr_to_string","","",N,[[["attribute"]],["string"]]],[5,"item_to_string","","",N,[[["item"]],["string"]]],[5,"impl_item_to_string","","",N,[[["implitem"]],["string"]]],[5,"trait_item_to_string","","",N,[[["traititem"]],["string"]]],[5,"generic_params_to_string","","",N,N],[5,"where_clause_to_string","","",N,[[["whereclause"]],["string"]]],[5,"fn_block_to_string","","",N,[[["fndecl"]],["string"]]],[5,"path_to_string","","",N,[[["path"]],["string"]]],[5,"path_segment_to_string","","",N,[[["pathsegment"]],["string"]]],[5,"ident_to_string","","",N,[[["ident"]],["string"]]],[5,"vis_to_string","","",N,[[["visibility"]],["string"]]],[5,"fun_to_string","","",N,[[["fndecl"],["fnheader"],["ident"],["generics"]],["string"]]],[5,"block_to_string","","",N,[[["block"]],["string"]]],[5,"meta_list_item_to_string","","",N,[[["nestedmetaitem"]],["string"]]],[5,"meta_item_to_string","","",N,[[["metaitem"]],["string"]]],[5,"attribute_to_string","","",N,[[["attribute"]],["string"]]],[5,"lit_to_string","","",N,[[["lit"]],["string"]]],[5,"variant_to_string","","",N,[[["variant"]],["string"]]],[5,"arg_to_string","","",N,[[["arg"]],["string"]]],[5,"mac_to_string","","",N,[[["mac"]],["string"]]],[5,"foreign_item_to_string","","",N,[[["foreignitem"]],["string"]]],[5,"visibility_qualified","","",N,[[["visibility"],["str"]],["string"]]],[17,"INDENT_UNIT","","",N,N],[17,"DEFAULT_COLUMNS","","",N,N],[8,"PpAnn","","",N,N],[11,"pre","","",274,[[["self"],["state"],["annnode"]],["result"]]],[11,"post","","",274,[[["self"],["state"],["annnode"]],["result"]]],[8,"PrintState","","",N,N],[10,"writer","","",275,[[["self"]],["printer"]]],[10,"boxes","","",275,[[["self"]],["vec"]]],[10,"comments","","",275,[[["self"]],["option"]]],[10,"cur_cmnt","","",275,[[["self"]],["usize"]]],[10,"cur_lit","","",275,[[["self"]],["option",["literal"]]]],[10,"bump_lit","","",275,[[["self"]],["option",["literal"]]]],[11,"word_space","","",275,[[["self"],["str"]],["result"]]],[11,"popen","","",275,[[["self"]],["result"]]],[11,"pclose","","",275,[[["self"]],["result"]]],[11,"is_begin","","",275,[[["self"]],["bool"]]],[11,"is_end","","",275,[[["self"]],["bool"]]],[11,"is_bol","","",275,[[["self"]],["bool"]]],[11,"hardbreak_if_not_bol","","",275,[[["self"]],["result"]]],[11,"rbox","","",275,[[["self"],["usize"],["breaks"]],["result"]]],[11,"ibox","","",275,[[["self"],["usize"]],["result"]]],[11,"end","","",275,[[["self"]],["result"]]],[11,"commasep","","",275,N],[11,"next_lit","","",275,[[["self"],["bytepos"]],["option",["literal"]]]],[11,"maybe_print_comment","","",275,[[["self"],["bytepos"]],["result"]]],[11,"print_comment","","",275,[[["self"],["comment"]],["result"]]],[11,"next_comment","","",275,[[["self"]],["option",["comment"]]]],[11,"print_literal","","",275,[[["self"],["lit"]],["result"]]],[11,"print_string","","",275,[[["self"],["str"],["strstyle"]],["result"]]],[11,"print_inner_attributes","","",275,N],[11,"print_inner_attributes_no_trailing_hardbreak","","",275,N],[11,"print_outer_attributes","","",275,N],[11,"print_inner_attributes_inline","","",275,N],[11,"print_outer_attributes_inline","","",275,N],[11,"print_either_attributes","","",275,N],[11,"print_attribute_path","","",275,[[["self"],["path"]],["result"]]],[11,"print_attribute","","",275,[[["self"],["attribute"]],["result"]]],[11,"print_attribute_inline","","",275,[[["self"],["attribute"],["bool"]],["result"]]],[11,"print_meta_list_item","","",275,[[["self"],["nestedmetaitem"]],["result"]]],[11,"print_meta_item","","",275,[[["self"],["metaitem"]],["result"]]],[11,"print_tt","","This doesn't deserve to be called \"pretty\" printing, but it should be meaning-preserving. A quick hack that might help would be to look at the spans embedded in the TTs to decide where to put spaces and newlines. But it'd be better to parse these according to the grammar of the appropriate macro, transcribe back into the grammar we just parsed from, and then pretty-print the resulting AST nodes (so, e.g., we print expression arguments as expressions). It can be done! I think.",275,[[["self"],["tokentree"]],["result"]]],[11,"print_tts","","",275,[[["self"],["tokenstream"]],["result"]]],[11,"space_if_not_bol","","",275,[[["self"]],["result"]]],[11,"nbsp","","",275,[[["self"]],["result"]]],[11,"print_dollar_crate","","",275,[[["self"],["syntaxcontext"]],["result"]]],[11,"clone","","",276,[[["self"]],["noann"]]],[11,"new_from_input","","",272,[[["sourcemap"],["parsesess"],["filename"],["read"],["box",["write"]],["ppann"],["bool"]],["state"]]],[11,"new","","",272,[[["sourcemap"],["box",["write"]],["ppann"],["option",["vec"]],["option",["vec"]]],["state"]]],[11,"writer","","",272,[[["self"]],["printer"]]],[11,"boxes","","",272,[[["self"]],["vec"]]],[11,"comments","","",272,[[["self"]],["option"]]],[11,"cur_cmnt","","",272,[[["self"]],["usize"]]],[11,"cur_lit","","",272,[[["self"]],["option",["literal"]]]],[11,"bump_lit","","",272,[[["self"]],["option",["literal"]]]],[11,"cbox","","",272,[[["self"],["usize"]],["result"]]],[11,"word_nbsp","","",272,[[["self"],["str"]],["result"]]],[11,"head","","",272,[[["self"],["str"]],["result"]]],[11,"bopen","","",272,[[["self"]],["result"]]],[11,"bclose_","","",272,[[["self"],["span"],["usize"]],["result"]]],[11,"bclose_maybe_open","","",272,[[["self"],["span"],["usize"],["bool"]],["result"]]],[11,"bclose","","",272,[[["self"],["span"]],["result"]]],[11,"in_cbox","","",272,[[["self"]],["bool"]]],[11,"break_offset_if_not_bol","","",272,[[["self"],["usize"],["isize"]],["result"]]],[11,"synth_comment","","",272,[[["self"],["string"]],["result"]]],[11,"commasep_cmnt","","",272,N],[11,"commasep_exprs","","",272,N],[11,"print_mod","","",272,N],[11,"print_foreign_mod","","",272,N],[11,"print_opt_lifetime","","",272,[[["self"],["option"]],["result"]]],[11,"print_generic_arg","","",272,[[["self"],["genericarg"]],["result"]]],[11,"print_type","","",272,[[["self"],["ty"]],["result"]]],[11,"print_foreign_item","","",272,[[["self"],["foreignitem"]],["result"]]],[11,"print_associated_const","","",272,[[["self"],["ident"],["ty"],["option",["expr"]],["visibility"]],["result"]]],[11,"print_associated_type","","",272,[[["self"],["ident"],["option",["genericbounds"]],["option",["ty"]]],["result"]]],[11,"print_item","","Pretty-print an item",272,[[["self"],["item"]],["result"]]],[11,"print_trait_ref","","",272,[[["self"],["traitref"]],["result"]]],[11,"print_formal_generic_params","","",272,N],[11,"print_poly_trait_ref","","",272,[[["self"],["polytraitref"]],["result"]]],[11,"print_enum_def","","",272,[[["self"],["enumdef"],["generics"],["ident"],["span"],["visibility"]],["result"]]],[11,"print_variants","","",272,N],[11,"print_visibility","","",272,[[["self"],["visibility"]],["result"]]],[11,"print_defaultness","","",272,[[["self"],["defaultness"]],["result"]]],[11,"print_struct","","",272,[[["self"],["variantdata"],["generics"],["ident"],["span"],["bool"]],["result"]]],[11,"print_variant","","",272,[[["self"],["variant"]],["result"]]],[11,"print_method_sig","","",272,[[["self"],["ident"],["generics"],["methodsig"],["visibility"]],["result"]]],[11,"print_trait_item","","",272,[[["self"],["traititem"]],["result"]]],[11,"print_impl_item","","",272,[[["self"],["implitem"]],["result"]]],[11,"print_stmt","","",272,[[["self"],["stmt"]],["result"]]],[11,"print_block","","",272,[[["self"],["block"]],["result"]]],[11,"print_block_unclosed","","",272,[[["self"],["block"]],["result"]]],[11,"print_block_unclosed_with_attrs","","",272,N],[11,"print_block_unclosed_indent","","",272,[[["self"],["block"],["usize"]],["result"]]],[11,"print_block_with_attrs","","",272,N],[11,"print_block_maybe_unclosed","","",272,N],[11,"print_else","","",272,[[["self"],["option",["expr"]]],["result"]]],[11,"print_if","","",272,[[["self"],["expr"],["block"],["option",["expr"]]],["result"]]],[11,"print_if_let","","",272,N],[11,"print_mac","","",272,[[["self"],["mac"]],["result"]]],[11,"print_call_post","","",272,N],[11,"print_expr_maybe_paren","","",272,[[["self"],["expr"],["i8"]],["result"]]],[11,"print_expr_as_cond","","Print an expr using syntax that's acceptable in a condition position, such as the `cond` in `if cond { ... }`.",272,[[["self"],["expr"]],["result"]]],[11,"print_expr_vec","","",272,N],[11,"print_expr_repeat","","",272,N],[11,"print_expr_struct","","",272,N],[11,"print_expr_tup","","",272,N],[11,"print_expr_call","","",272,N],[11,"print_expr_method_call","","",272,N],[11,"print_expr_binary","","",272,[[["self"],["binop"],["expr"],["expr"]],["result"]]],[11,"print_expr_unary","","",272,[[["self"],["unop"],["expr"]],["result"]]],[11,"print_expr_addr_of","","",272,[[["self"],["mutability"],["expr"]],["result"]]],[11,"print_expr","","",272,[[["self"],["expr"]],["result"]]],[11,"print_expr_outer_attr_style","","",272,[[["self"],["expr"],["bool"]],["result"]]],[11,"print_local_decl","","",272,[[["self"],["local"]],["result"]]],[11,"print_ident","","",272,[[["self"],["ident"]],["result"]]],[11,"print_usize","","",272,[[["self"],["usize"]],["result"]]],[11,"print_name","","",272,[[["self"],["name"]],["result"]]],[11,"print_for_decl","","",272,[[["self"],["local"],["expr"]],["result"]]],[11,"print_path","","",272,[[["self"],["path"],["bool"],["usize"]],["result"]]],[11,"print_path_segment","","",272,[[["self"],["pathsegment"],["bool"]],["result"]]],[11,"print_qpath","","",272,[[["self"],["path"],["qself"],["bool"]],["result"]]],[11,"print_generic_args","","",272,[[["self"],["genericargs"],["bool"]],["result"]]],[11,"print_pat","","",272,[[["self"],["pat"]],["result"]]],[11,"print_pats","","",272,N],[11,"print_arm","","",272,[[["self"],["arm"]],["result"]]],[11,"print_explicit_self","","",272,[[["self"],["explicitself"]],["result"]]],[11,"print_fn","","",272,[[["self"],["fndecl"],["fnheader"],["option",["ident"]],["generics"],["visibility"]],["result"]]],[11,"print_fn_args_and_ret","","",272,[[["self"],["fndecl"]],["result"]]],[11,"print_fn_block_args","","",272,[[["self"],["fndecl"]],["result"]]],[11,"print_movability","","",272,[[["self"],["movability"]],["result"]]],[11,"print_asyncness","","",272,[[["self"],["isasync"]],["result"]]],[11,"print_capture_clause","","",272,[[["self"],["captureby"]],["result"]]],[11,"print_type_bounds","","",272,N],[11,"print_lifetime","","",272,[[["self"],["lifetime"]],["result"]]],[11,"print_lifetime_bounds","","",272,[[["self"],["lifetime"],["genericbounds"]],["result"]]],[11,"print_generic_params","","",272,N],[11,"print_where_clause","","",272,[[["self"],["whereclause"]],["result"]]],[11,"print_use_tree","","",272,[[["self"],["usetree"]],["result"]]],[11,"print_mutability","","",272,[[["self"],["mutability"]],["result"]]],[11,"print_mt","","",272,[[["self"],["mutty"]],["result"]]],[11,"print_arg","","",272,[[["self"],["arg"],["bool"]],["result"]]],[11,"print_fn_output","","",272,[[["self"],["fndecl"]],["result"]]],[11,"print_ty_fn","","",272,N],[11,"maybe_print_trailing_comment","","",272,[[["self"],["span"],["option",["bytepos"]]],["result"]]],[11,"print_remaining_comments","","",272,[[["self"]],["result"]]],[11,"print_opt_abi_and_extern_if_nondefault","","",272,[[["self"],["option",["abi"]]],["result"]]],[11,"print_extern_opt_abi","","",272,[[["self"],["option",["abi"]]],["result"]]],[11,"print_fn_header_info","","",272,[[["self"],["fnheader"],["visibility"]],["result"]]],[11,"print_unsafety","","",272,[[["self"],["unsafety"]],["result"]]],[11,"print_is_auto","","",272,[[["self"],["isauto"]],["result"]]],[0,"ext","syntax","",N,N],[0,"hygiene","syntax::ext","Machinery for hygienic macros, inspired by the `MTWT[1]` paper.",N,N],[3,"SyntaxContext","syntax::ext::hygiene","A SyntaxContext represents a chain of macro expansions (represented by marks).",N,N],[12,"0","","",160,N],[3,"Mark","","A mark is a unique id associated with a macro expansion.",N,N],[12,"0","","",161,N],[4,"Transparency","","A property of a macro expansion that determines how identifiers produced by that expansion are resolved.",N,N],[13,"Transparent","","Identifier produced by a transparent expansion is always resolved at call-site. Call-site spans in procedural macros, hygiene opt-out in `macro` should use this.",162,N],[13,"SemiTransparent","","Identifier produced by a semi-transparent expansion may be resolved either at call-site or at definition-site. If it's a local variable, label or `$crate` then it's resolved at def-site. Otherwise it's resolved at call-site. `macro_rules` macros behave like this, built-in macros currently behave like this too, but that's an implementation detail.",162,N],[13,"Opaque","","Identifier produced by an opaque expansion is always resolved at definition-site. Def-site spans in procedural macros, identifiers from `macro` by default use this.",162,N],[5,"default_edition","","",N,[[],["edition"]]],[5,"set_default_edition","","",N,N],[5,"clear_markings","","",N,N],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",N,N],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",163,N],[12,"def_site","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None. This span serves only informational purpose and is not used for resolution.",163,N],[12,"format","","The format with which the macro was invoked.",163,N],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",163,N],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",163,N],[12,"local_inner_macros","","Enables the macro helper hack (`ident!(...)` -> `$crate::ident!(...)`) for a given macro.",163,N],[12,"edition","","Edition of the crate in which the macro is defined.",163,N],[4,"ExpnFormat","","The source of expansion.",N,N],[13,"MacroAttribute","","e.g. #[derive(...)] ",164,N],[13,"MacroBang","","e.g. `format!()`",164,N],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",164,N],[4,"CompilerDesugaringKind","","The kind of compiler desugaring.",N,N],[13,"QuestionMark","","",165,N],[13,"TryBlock","","",165,N],[13,"ExistentialReturnType","","Desugaring of an `impl Trait` in return type position to an `existential type Foo: Trait;` + replacing the `impl Trait` with `Foo`.",165,N],[13,"Async","","",165,N],[13,"ForLoop","","",165,N],[0,"base","syntax::ext","",N,N],[3,"MacEager","syntax::ext::base","`MacResult` implementation for the common case where you've already built each form of AST that you might return.",N,N],[12,"expr","","",277,N],[12,"pat","","",277,N],[12,"items","","",277,N],[12,"impl_items","","",277,N],[12,"trait_items","","",277,N],[12,"foreign_items","","",277,N],[12,"stmts","","",277,N],[12,"ty","","",277,N],[3,"DummyResult","","Fill-in macro expansion result, to allow compilation to continue after hitting errors.",N,N],[12,"expr_only","","",278,N],[12,"span","","",278,N],[3,"DummyResolver","","",N,N],[3,"ModuleData","","",N,N],[12,"mod_path","","",279,N],[12,"directory","","",279,N],[3,"ExpansionData","","",N,N],[12,"mark","","",280,N],[12,"depth","","",280,N],[12,"module","","",280,N],[12,"directory_ownership","","",280,N],[12,"crate_span","","",280,N],[3,"ExtCtxt","","One of these is made during expansion and incrementally updated as we go; when a macro expansion occurs, the resulting nodes have the `backtrace() -> expn_info` of their expansion context stored into their span.",N,N],[12,"parse_sess","","",281,N],[12,"ecfg","","",281,N],[12,"root_path","","",281,N],[12,"resolver","","",281,N],[12,"resolve_err_count","","",281,N],[12,"current_expansion","","",281,N],[12,"expansions","","",281,N],[4,"Annotatable","","",N,N],[13,"Item","","",282,N],[13,"TraitItem","","",282,N],[13,"ImplItem","","",282,N],[13,"ForeignItem","","",282,N],[13,"Stmt","","",282,N],[13,"Expr","","",282,N],[4,"MacroKind","","Represents different kinds of macro invocations that can be resolved.",N,N],[13,"Bang","","A bang macro - foo!()",283,N],[13,"Attr","","An attribute macro - #[foo]",283,N],[13,"Derive","","A derive attribute macro - #[derive(Foo)]",283,N],[13,"ProcMacroStub","","A view of a procedural macro from the same crate that defines it.",283,N],[4,"SyntaxExtension","","An enum representing the different kinds of syntax extensions.",N,N],[13,"NonMacroAttr","","A trivial \"extension\" that does nothing, only keeps the attribute and marks it as known.",284,N],[12,"mark_used","syntax::ext::base::SyntaxExtension","",284,N],[13,"MultiDecorator","syntax::ext::base","A syntax extension that is attached to an item and creates new items based upon it.",284,N],[13,"MultiModifier","","A syntax extension that is attached to an item and modifies it in-place. Also allows decoration, i.e., creating new items.",284,N],[13,"ProcMacro","","A function-like procedural macro. TokenStream -> TokenStream.",284,N],[12,"expander","syntax::ext::base::SyntaxExtension","",284,N],[12,"allow_internal_unstable","","",284,N],[12,"edition","","",284,N],[13,"AttrProcMacro","syntax::ext::base","An attribute-like procedural macro. TokenStream, TokenStream -> TokenStream. The first TokenSteam is the attribute, the second is the annotated item. Allows modification of the input items and adding new items, similar to MultiModifier, but uses TokenStreams, rather than AST nodes.",284,N],[13,"NormalTT","","A normal, function-like syntax extension.",284,N],[12,"expander","syntax::ext::base::SyntaxExtension","",284,N],[12,"def_info","","",284,N],[12,"allow_internal_unstable","","Whether the contents of the macro can directly use `#[unstable]` things (true == yes).",284,N],[12,"allow_internal_unsafe","","Whether the contents of the macro can use `unsafe` without triggering the `unsafe_code` lint.",284,N],[12,"local_inner_macros","","Enables the macro helper hack (`ident!(...)` -> `$crate::ident!(...)`) for a given macro.",284,N],[12,"unstable_feature","","The macro's feature name if it is unstable, and the stability feature",284,N],[12,"edition","","Edition of the crate in which the macro is defined",284,N],[13,"IdentTT","syntax::ext::base","A function-like syntax extension that has an extra ident before the block.",284,N],[13,"ProcMacroDerive","","An attribute-like procedural macro. TokenStream -> TokenStream. The input is the annotated item. Allows generating code to implement a Trait for a given struct or enum item.",284,N],[13,"BuiltinDerive","","An attribute-like procedural macro that derives a builtin trait.",284,N],[13,"DeclMacro","","A declarative macro, e.g. `macro m() {}`.",284,N],[12,"expander","syntax::ext::base::SyntaxExtension","",284,N],[12,"def_info","","",284,N],[12,"is_transparent","","",284,N],[12,"edition","","",284,N],[4,"Determinacy","syntax::ext::base","",N,N],[13,"Determined","","",285,N],[13,"Undetermined","","",285,N],[5,"expr_to_spanned_string","","Extract a string literal from the macro expanded version of `expr`, emitting `err_msg` if `expr` is not a string literal. This does not stop compilation on error, merely emits a non-fatal error and returns None.",N,[[["extctxt"],["p",["expr"]],["str"]],["result",["spanned","diagnosticbuilder"]]]],[5,"expr_to_string","","",N,[[["extctxt"],["p",["expr"]],["str"]],["option"]]],[5,"check_zero_tts","","Non-fatally assert that `tts` is empty. Note that this function returns even when `tts` is non-empty, macros that need to stop compilation should call `cx.parse_sess.span_diagnostic.abort_if_errors()` (this should be done as rarely as possible).",N,N],[5,"get_single_str_from_tts","","Interpreting `tts` as a comma-separated sequence of expressions, expect exactly one string literal, or emit an error and return None.",N,N],[5,"get_exprs_from_tts","","Extract comma-separated expressions from `tts`. If there is a parsing error, emit a non-fatal error and return None.",N,N],[6,"MacroExpanderFn","","",N,N],[6,"IdentMacroExpanderFn","","",N,N],[6,"BuiltinDeriveFn","","",N,N],[6,"NamedSyntaxExtension","","",N,N],[8,"MultiItemDecorator","","",N,N],[10,"expand","","",286,[[["self"],["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[8,"MultiItemModifier","","",N,N],[10,"expand","","",287,[[["self"],["extctxt"],["span"],["metaitem"],["annotatable"]],["vec",["annotatable"]]]],[8,"ProcMacro","","",N,N],[10,"expand","","",288,[[["self"],["extctxt"],["span"],["tokenstream"]],["tokenstream"]]],[8,"AttrProcMacro","","",N,N],[10,"expand","","",289,[[["self"],["extctxt"],["span"],["tokenstream"],["tokenstream"]],["tokenstream"]]],[8,"TTMacroExpander","","Represents a thing that maps token trees to Macro Results",N,N],[10,"expand","","",290,[[["self"],["extctxt"],["span"],["tokenstream"]],["box",["macresult"]]]],[8,"IdentMacroExpander","","",N,N],[10,"expand","","",291,[[["self"],["extctxt"],["span"],["ident"],["vec",["tokentree"]]],["box",["macresult"]]]],[8,"MacResult","","The result of a macro expansion. The return values of the various methods are spliced into the AST at the callsite of the macro.",N,N],[11,"make_expr","","Create an expression.",292,[[["box"]],["option",["p"]]]],[11,"make_items","","Create zero or more items.",292,[[["box"]],["option",["onevector"]]]],[11,"make_impl_items","","Create zero or more impl items.",292,[[["box"]],["option",["onevector"]]]],[11,"make_trait_items","","Create zero or more trait items.",292,[[["box"]],["option",["onevector"]]]],[11,"make_foreign_items","","Create zero or more items in an `extern {}` block",292,[[["box"]],["option",["onevector"]]]],[11,"make_pat","","Create a pattern.",292,[[["box"]],["option",["p"]]]],[11,"make_stmts","","Create zero or more statements.",292,[[["box"]],["option",["onevector"]]]],[11,"make_ty","","",292,[[["box"]],["option",["p"]]]],[8,"Resolver","","",N,N],[10,"next_node_id","","",293,[[["self"]],["nodeid"]]],[10,"get_module_scope","","",293,[[["self"],["nodeid"]],["mark"]]],[10,"eliminate_crate_var","","",293,[[["self"],["p",["item"]]],["p",["item"]]]],[10,"is_whitelisted_legacy_custom_derive","","",293,[[["self"],["name"]],["bool"]]],[10,"visit_ast_fragment_with_placeholders","","",293,N],[10,"add_builtin","","",293,[[["self"],["ident"],["lrc",["syntaxextension"]]]]],[10,"resolve_imports","","",293,[[["self"]]]],[10,"find_legacy_attr_invoc","","",293,[[["self"],["vec"],["bool"]],["option",["attribute"]]]],[10,"resolve_macro_invocation","","",293,[[["self"],["invocation"],["mark"],["bool"]],["result",["option","determinacy"]]]],[10,"resolve_macro_path","","",293,[[["self"],["path"],["macrokind"],["mark"],["vec",["path"]],["bool"]],["result",["lrc","determinacy"]]]],[10,"check_unused_macros","","",293,[[["self"]]]],[11,"fmt","","",282,[[["self"],["formatter"]],["result"]]],[11,"clone","","",282,[[["self"]],["annotatable"]]],[11,"attrs","","",282,N],[11,"map_attrs","","",282,[[["self"],["f"]],["self"]]],[11,"span","","",282,[[["self"]],["span"]]],[11,"expect_item","","",282,[[["self"]],["p",["item"]]]],[11,"map_item_or","","",282,[[["self"],["f"],["g"]],["annotatable"]]],[11,"expect_trait_item","","",282,[[["self"]],["traititem"]]],[11,"expect_impl_item","","",282,[[["self"]],["implitem"]]],[11,"expect_foreign_item","","",282,[[["self"]],["foreignitem"]]],[11,"expect_stmt","","",282,[[["self"]],["stmt"]]],[11,"expect_expr","","",282,[[["self"]],["p",["expr"]]]],[11,"derive_allowed","","",282,[[["self"]],["bool"]]],[11,"into","","",282,[[["self"]],["vec",["annotatable"]]]],[11,"default","","",277,[[],["maceager"]]],[11,"expr","","",277,[[["p",["expr"]]],["box",["macresult"]]]],[11,"pat","","",277,[[["p",["pat"]]],["box",["macresult"]]]],[11,"items","","",277,[[["onevector",["p"]]],["box",["macresult"]]]],[11,"impl_items","","",277,[[["onevector",["implitem"]]],["box",["macresult"]]]],[11,"trait_items","","",277,[[["onevector",["traititem"]]],["box",["macresult"]]]],[11,"foreign_items","","",277,[[["onevector",["foreignitem"]]],["box",["macresult"]]]],[11,"stmts","","",277,[[["onevector",["stmt"]]],["box",["macresult"]]]],[11,"ty","","",277,[[["p",["ty"]]],["box",["macresult"]]]],[11,"make_expr","","",277,[[["box"]],["option",["p"]]]],[11,"make_items","","",277,[[["box"]],["option",["onevector"]]]],[11,"make_impl_items","","",277,[[["box"]],["option",["onevector"]]]],[11,"make_trait_items","","",277,[[["box"]],["option",["onevector"]]]],[11,"make_foreign_items","","",277,[[["box"]],["option",["onevector"]]]],[11,"make_stmts","","",277,[[["box"]],["option",["onevector"]]]],[11,"make_pat","","",277,[[["box"]],["option",["p"]]]],[11,"make_ty","","",277,[[["box"]],["option",["p"]]]],[11,"clone","","",278,[[["self"]],["dummyresult"]]],[11,"any","","Create a default MacResult that can be anything.",278,[[["span"]],["box",["macresult"]]]],[11,"expr","","Create a default MacResult that can only be an expression.",278,[[["span"]],["box",["macresult"]]]],[11,"raw_expr","","A plain dummy expression.",278,[[["span"]],["p",["expr"]]]],[11,"raw_pat","","A plain dummy pattern.",278,[[["span"]],["pat"]]],[11,"raw_ty","","",278,[[["span"]],["p",["ty"]]]],[11,"make_expr","","",278,[[["box",["dummyresult"]]],["option",["p"]]]],[11,"make_pat","","",278,[[["box",["dummyresult"]]],["option",["p"]]]],[11,"make_items","","",278,[[["box",["dummyresult"]]],["option",["onevector"]]]],[11,"make_impl_items","","",278,[[["box",["dummyresult"]]],["option",["onevector"]]]],[11,"make_trait_items","","",278,[[["box",["dummyresult"]]],["option",["onevector"]]]],[11,"make_foreign_items","","",278,[[["box"]],["option",["onevector"]]]],[11,"make_stmts","","",278,[[["box",["dummyresult"]]],["option",["onevector"]]]],[11,"make_ty","","",278,[[["box",["dummyresult"]]],["option",["p"]]]],[11,"clone","","",283,[[["self"]],["macrokind"]]],[11,"eq","","",283,[[["self"],["macrokind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",283,N],[11,"encode","","",283,[[["self"],["__s"]],["result"]]],[11,"decode","","",283,[[["__d"]],["result",["macrokind"]]]],[11,"hash","","",283,N],[11,"fmt","","",283,[[["self"],["formatter"]],["result"]]],[11,"descr","","",283,[[["self"]],["str"]]],[11,"kind","","Return which kind of macro calls this syntax extension.",284,[[["self"]],["macrokind"]]],[11,"default_transparency","","",284,[[["self"]],["transparency"]]],[11,"edition","","",284,[[["self"]],["edition"]]],[11,"clone","","",285,[[["self"]],["determinacy"]]],[11,"eq","","",285,[[["self"],["determinacy"]],["bool"]]],[11,"fmt","","",285,[[["self"],["formatter"]],["result"]]],[11,"determined","","",285,[[["bool"]],["determinacy"]]],[11,"next_node_id","","",294,[[["self"]],["nodeid"]]],[11,"get_module_scope","","",294,[[["self"],["nodeid"]],["mark"]]],[11,"eliminate_crate_var","","",294,[[["self"],["p",["item"]]],["p",["item"]]]],[11,"is_whitelisted_legacy_custom_derive","","",294,[[["self"],["name"]],["bool"]]],[11,"visit_ast_fragment_with_placeholders","","",294,N],[11,"add_builtin","","",294,[[["self"],["ident"],["lrc",["syntaxextension"]]]]],[11,"resolve_imports","","",294,[[["self"]]]],[11,"find_legacy_attr_invoc","","",294,[[["self"],["vec"],["bool"]],["option",["attribute"]]]],[11,"resolve_macro_invocation","","",294,[[["self"],["invocation"],["mark"],["bool"]],["result",["option","determinacy"]]]],[11,"resolve_macro_path","","",294,[[["self"],["path"],["macrokind"],["mark"],["vec",["path"]],["bool"]],["result",["lrc","determinacy"]]]],[11,"check_unused_macros","","",294,[[["self"]]]],[11,"clone","","",279,[[["self"]],["moduledata"]]],[11,"clone","","",280,[[["self"]],["expansiondata"]]],[11,"new","","",281,[[["parsesess"],["expansionconfig"],["resolver"]],["extctxt"]]],[11,"expander","","Returns a `Folder` for deeply expanding all macros in an AST node.",281,[[["self"]],["macroexpander"]]],[11,"monotonic_expander","","Returns a `Folder` that deeply expands all macros and assigns all node ids in an AST node. Once node ids are assigned, the node may not be expanded, removed, or otherwise modified.",281,[[["self"]],["macroexpander"]]],[11,"new_parser_from_tts","","",281,N],[11,"source_map","","",281,[[["self"]],["sourcemap"]]],[11,"parse_sess","","",281,[[["self"]],["parsesess"]]],[11,"cfg","","",281,[[["self"]],["crateconfig"]]],[11,"call_site","","",281,[[["self"]],["span"]]],[11,"backtrace","","",281,[[["self"]],["syntaxcontext"]]],[11,"expansion_cause","","Returns span for the macro which originally caused the current expansion to happen.",281,[[["self"]],["option",["span"]]]],[11,"struct_span_warn","","",281,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err","","",281,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_fatal","","",281,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_fatal","","Emit `msg` attached to `sp`, and stop compilation immediately.",281,N],[11,"span_err","","Emit `msg` attached to `sp`, without immediately stopping compilation.",281,[[["self"],["s"],["str"]]]],[11,"span_err_with_code","","",281,[[["self"],["s"],["str"],["diagnosticid"]]]],[11,"mut_span_err","","",281,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_warn","","",281,[[["self"],["s"],["str"]]]],[11,"span_unimpl","","",281,N],[11,"span_bug","","",281,N],[11,"trace_macros_diag","","",281,[[["self"]]]],[11,"bug","","",281,N],[11,"trace_macros","","",281,[[["self"]],["bool"]]],[11,"set_trace_macros","","",281,[[["self"],["bool"]]]],[11,"ident_of","","",281,[[["self"],["str"]],["ident"]]],[11,"std_path","","",281,N],[11,"name_of","","",281,[[["self"],["str"]],["name"]]],[11,"check_unused_macros","","",281,[[["self"]]]],[0,"build","syntax::ext","",N,N],[0,"syntax","syntax::ext::build","",N,N],[8,"AstBuilder","","",N,N],[10,"path","","",295,[[["self"],["span"],["vec",["ident"]]],["path"]]],[10,"path_ident","","",295,[[["self"],["span"],["ident"]],["path"]]],[10,"path_global","","",295,[[["self"],["span"],["vec",["ident"]]],["path"]]],[10,"path_all","","",295,[[["self"],["span"],["bool"],["vec",["ident"]],["vec",["genericarg"]],["vec",["typebinding"]]],["path"]]],[10,"qpath","","",295,N],[10,"qpath_all","","",295,N],[10,"ty_mt","","",295,[[["self"],["p",["ty"]],["mutability"]],["mutty"]]],[10,"ty","","",295,[[["self"],["span"],["tykind"]],["p",["ty"]]]],[10,"ty_path","","",295,[[["self"],["path"]],["p",["ty"]]]],[10,"ty_ident","","",295,[[["self"],["span"],["ident"]],["p",["ty"]]]],[10,"ty_rptr","","",295,[[["self"],["span"],["p",["ty"]],["option",["lifetime"]],["mutability"]],["p",["ty"]]]],[10,"ty_ptr","","",295,[[["self"],["span"],["p",["ty"]],["mutability"]],["p",["ty"]]]],[10,"ty_option","","",295,[[["self"],["p",["ty"]]],["p",["ty"]]]],[10,"ty_infer","","",295,[[["self"],["span"]],["p",["ty"]]]],[10,"typaram","","",295,[[["self"],["span"],["ident"],["vec",["attribute"]],["genericbounds"],["option",["p"]]],["genericparam"]]],[10,"trait_ref","","",295,[[["self"],["path"]],["traitref"]]],[10,"poly_trait_ref","","",295,[[["self"],["span"],["path"]],["polytraitref"]]],[10,"trait_bound","","",295,[[["self"],["path"]],["genericbound"]]],[10,"lifetime","","",295,[[["self"],["span"],["ident"]],["lifetime"]]],[10,"lifetime_def","","",295,[[["self"],["span"],["ident"],["vec",["attribute"]],["genericbounds"]],["genericparam"]]],[10,"stmt_expr","","",295,[[["self"],["p",["expr"]]],["stmt"]]],[10,"stmt_semi","","",295,[[["self"],["p",["expr"]]],["stmt"]]],[10,"stmt_let","","",295,[[["self"],["span"],["bool"],["ident"],["p",["expr"]]],["stmt"]]],[10,"stmt_let_typed","","",295,[[["self"],["span"],["bool"],["ident"],["p",["ty"]],["p",["expr"]]],["stmt"]]],[10,"stmt_let_type_only","","",295,[[["self"],["span"],["p",["ty"]]],["stmt"]]],[10,"stmt_item","","",295,[[["self"],["span"],["p",["item"]]],["stmt"]]],[10,"block","","",295,[[["self"],["span"],["vec",["stmt"]]],["p",["block"]]]],[10,"block_expr","","",295,[[["self"],["p",["expr"]]],["p",["block"]]]],[10,"expr","","",295,[[["self"],["span"],["exprkind"]],["p",["expr"]]]],[10,"expr_path","","",295,[[["self"],["path"]],["p",["expr"]]]],[10,"expr_qpath","","",295,[[["self"],["span"],["qself"],["path"]],["p",["expr"]]]],[10,"expr_ident","","",295,[[["self"],["span"],["ident"]],["p",["expr"]]]],[10,"expr_self","","",295,[[["self"],["span"]],["p",["expr"]]]],[10,"expr_binary","","",295,[[["self"],["span"],["binopkind"],["p",["expr"]],["p",["expr"]]],["p",["expr"]]]],[10,"expr_deref","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_unary","","",295,[[["self"],["span"],["unop"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_addr_of","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_mut_addr_of","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_field_access","","",295,[[["self"],["span"],["p",["expr"]],["ident"]],["p",["expr"]]]],[10,"expr_tup_field_access","","",295,[[["self"],["span"],["p",["expr"]],["usize"]],["p",["expr"]]]],[10,"expr_call","","",295,[[["self"],["span"],["p",["expr"]],["vec",["p"]]],["p",["expr"]]]],[10,"expr_call_ident","","",295,[[["self"],["span"],["ident"],["vec",["p"]]],["p",["expr"]]]],[10,"expr_call_global","","",295,[[["self"],["span"],["vec",["ident"]],["vec",["p"]]],["p",["expr"]]]],[10,"expr_method_call","","",295,[[["self"],["span"],["p",["expr"]],["ident"],["vec",["p"]]],["p",["expr"]]]],[10,"expr_block","","",295,[[["self"],["p",["block"]]],["p",["expr"]]]],[10,"expr_cast","","",295,[[["self"],["span"],["p",["expr"]],["p",["ty"]]],["p",["expr"]]]],[10,"field_imm","","",295,[[["self"],["span"],["ident"],["p",["expr"]]],["field"]]],[10,"expr_struct","","",295,[[["self"],["span"],["path"],["vec",["field"]]],["p",["expr"]]]],[10,"expr_struct_ident","","",295,[[["self"],["span"],["ident"],["vec",["field"]]],["p",["expr"]]]],[10,"expr_lit","","",295,[[["self"],["span"],["litkind"]],["p",["expr"]]]],[10,"expr_usize","","",295,[[["self"],["span"],["usize"]],["p",["expr"]]]],[10,"expr_isize","","",295,[[["self"],["span"],["isize"]],["p",["expr"]]]],[10,"expr_u8","","",295,[[["self"],["span"],["u8"]],["p",["expr"]]]],[10,"expr_u16","","",295,[[["self"],["span"],["u16"]],["p",["expr"]]]],[10,"expr_u32","","",295,[[["self"],["span"],["u32"]],["p",["expr"]]]],[10,"expr_bool","","",295,[[["self"],["span"],["bool"]],["p",["expr"]]]],[10,"expr_vec","","",295,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[10,"expr_vec_ng","","",295,[[["self"],["span"]],["p",["expr"]]]],[10,"expr_vec_slice","","",295,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[10,"expr_str","","",295,[[["self"],["span"],["symbol"]],["p",["expr"]]]],[10,"expr_some","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_none","","",295,[[["self"],["span"]],["p",["expr"]]]],[10,"expr_break","","",295,[[["self"],["span"]],["p",["expr"]]]],[10,"expr_tuple","","",295,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[10,"expr_fail","","",295,[[["self"],["span"],["symbol"]],["p",["expr"]]]],[10,"expr_unreachable","","",295,[[["self"],["span"]],["p",["expr"]]]],[10,"expr_ok","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_err","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"expr_try","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"pat","","",295,[[["self"],["span"],["patkind"]],["p",["pat"]]]],[10,"pat_wild","","",295,[[["self"],["span"]],["p",["pat"]]]],[10,"pat_lit","","",295,[[["self"],["span"],["p",["expr"]]],["p",["pat"]]]],[10,"pat_ident","","",295,[[["self"],["span"],["ident"]],["p",["pat"]]]],[10,"pat_ident_binding_mode","","",295,[[["self"],["span"],["ident"],["bindingmode"]],["p",["pat"]]]],[10,"pat_path","","",295,[[["self"],["span"],["path"]],["p",["pat"]]]],[10,"pat_tuple_struct","","",295,[[["self"],["span"],["path"],["vec",["p"]]],["p",["pat"]]]],[10,"pat_struct","","",295,[[["self"],["span"],["path"],["vec",["spanned"]]],["p",["pat"]]]],[10,"pat_tuple","","",295,[[["self"],["span"],["vec",["p"]]],["p",["pat"]]]],[10,"pat_some","","",295,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[10,"pat_none","","",295,[[["self"],["span"]],["p",["pat"]]]],[10,"pat_ok","","",295,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[10,"pat_err","","",295,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[10,"arm","","",295,[[["self"],["span"],["vec",["p"]],["p",["expr"]]],["arm"]]],[10,"arm_unreachable","","",295,[[["self"],["span"]],["arm"]]],[10,"expr_match","","",295,[[["self"],["span"],["p",["expr"]],["vec",["arm"]]],["p",["expr"]]]],[10,"expr_if","","",295,[[["self"],["span"],["p",["expr"]],["p",["expr"]],["option",["p"]]],["p",["expr"]]]],[10,"expr_loop","","",295,[[["self"],["span"],["p",["block"]]],["p",["expr"]]]],[10,"lambda_fn_decl","","",295,[[["self"],["span"],["p",["fndecl"]],["p",["expr"]],["span"]],["p",["expr"]]]],[10,"lambda","","",295,[[["self"],["span"],["vec",["ident"]],["p",["expr"]]],["p",["expr"]]]],[10,"lambda0","","",295,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[10,"lambda1","","",295,[[["self"],["span"],["p",["expr"]],["ident"]],["p",["expr"]]]],[10,"lambda_stmts","","",295,[[["self"],["span"],["vec",["ident"]],["vec",["stmt"]]],["p",["expr"]]]],[10,"lambda_stmts_0","","",295,[[["self"],["span"],["vec",["stmt"]]],["p",["expr"]]]],[10,"lambda_stmts_1","","",295,[[["self"],["span"],["vec",["stmt"]],["ident"]],["p",["expr"]]]],[10,"item","","",295,[[["self"],["span"],["ident"],["vec",["attribute"]],["itemkind"]],["p",["item"]]]],[10,"arg","","",295,[[["self"],["span"],["ident"],["p",["ty"]]],["arg"]]],[10,"fn_decl","","",295,[[["self"],["vec",["arg"]],["functionretty"]],["p",["fndecl"]]]],[10,"item_fn_poly","","",295,[[["self"],["span"],["ident"],["vec",["arg"]],["p",["ty"]],["generics"],["p",["block"]]],["p",["item"]]]],[10,"item_fn","","",295,[[["self"],["span"],["ident"],["vec",["arg"]],["p",["ty"]],["p",["block"]]],["p",["item"]]]],[10,"variant","","",295,[[["self"],["span"],["ident"],["vec",["p"]]],["variant"]]],[10,"item_enum_poly","","",295,[[["self"],["span"],["ident"],["enumdef"],["generics"]],["p",["item"]]]],[10,"item_enum","","",295,[[["self"],["span"],["ident"],["enumdef"]],["p",["item"]]]],[10,"item_struct_poly","","",295,[[["self"],["span"],["ident"],["variantdata"],["generics"]],["p",["item"]]]],[10,"item_struct","","",295,[[["self"],["span"],["ident"],["variantdata"]],["p",["item"]]]],[10,"item_mod","","",295,[[["self"],["span"],["span"],["ident"],["vec",["attribute"]],["vec",["p"]]],["p",["item"]]]],[10,"item_extern_crate","","",295,[[["self"],["span"],["ident"]],["p",["item"]]]],[10,"item_static","","",295,[[["self"],["span"],["ident"],["p",["ty"]],["mutability"],["p",["expr"]]],["p",["item"]]]],[10,"item_const","","",295,[[["self"],["span"],["ident"],["p",["ty"]],["p",["expr"]]],["p",["item"]]]],[10,"item_ty_poly","","",295,[[["self"],["span"],["ident"],["p",["ty"]],["generics"]],["p",["item"]]]],[10,"item_ty","","",295,[[["self"],["span"],["ident"],["p",["ty"]]],["p",["item"]]]],[10,"attribute","","",295,[[["self"],["span"],["metaitem"]],["attribute"]]],[10,"meta_word","","",295,[[["self"],["span"],["name"]],["metaitem"]]],[10,"meta_list_item_word","","",295,[[["self"],["span"],["name"]],["nestedmetaitem"]]],[10,"meta_list","","",295,[[["self"],["span"],["name"],["vec",["nestedmetaitem"]]],["metaitem"]]],[10,"meta_name_value","","",295,[[["self"],["span"],["name"],["litkind"]],["metaitem"]]],[10,"item_use","","",295,[[["self"],["span"],["visibility"],["p",["usetree"]]],["p",["item"]]]],[10,"item_use_simple","","",295,[[["self"],["span"],["visibility"],["path"]],["p",["item"]]]],[10,"item_use_simple_","","",295,[[["self"],["span"],["visibility"],["option",["ident"]],["path"]],["p",["item"]]]],[10,"item_use_list","","",295,N],[10,"item_use_glob","","",295,[[["self"],["span"],["visibility"],["vec",["ident"]]],["p",["item"]]]],[11,"path","syntax::ext::base","",281,[[["self"],["span"],["vec",["ident"]]],["path"]]],[11,"path_ident","","",281,[[["self"],["span"],["ident"]],["path"]]],[11,"path_global","","",281,[[["self"],["span"],["vec",["ident"]]],["path"]]],[11,"path_all","","",281,[[["self"],["span"],["bool"],["vec",["ident"]],["vec",["genericarg"]],["vec",["typebinding"]]],["path"]]],[11,"qpath","","Constructs a qualified path.",281,N],[11,"qpath_all","","Constructs a qualified path.",281,N],[11,"ty_mt","","",281,[[["self"],["p",["ty"]],["mutability"]],["mutty"]]],[11,"ty","","",281,[[["self"],["span"],["tykind"]],["p",["ty"]]]],[11,"ty_path","","",281,[[["self"],["path"]],["p",["ty"]]]],[11,"ty_ident","","",281,[[["self"],["span"],["ident"]],["p",["ty"]]]],[11,"ty_rptr","","",281,[[["self"],["span"],["p",["ty"]],["option",["lifetime"]],["mutability"]],["p",["ty"]]]],[11,"ty_ptr","","",281,[[["self"],["span"],["p",["ty"]],["mutability"]],["p",["ty"]]]],[11,"ty_option","","",281,[[["self"],["p",["ty"]]],["p",["ty"]]]],[11,"ty_infer","","",281,[[["self"],["span"]],["p",["ty"]]]],[11,"typaram","","",281,[[["self"],["span"],["ident"],["vec",["attribute"]],["genericbounds"],["option",["p"]]],["genericparam"]]],[11,"trait_ref","","",281,[[["self"],["path"]],["traitref"]]],[11,"poly_trait_ref","","",281,[[["self"],["span"],["path"]],["polytraitref"]]],[11,"trait_bound","","",281,[[["self"],["path"]],["genericbound"]]],[11,"lifetime","","",281,[[["self"],["span"],["ident"]],["lifetime"]]],[11,"lifetime_def","","",281,[[["self"],["span"],["ident"],["vec",["attribute"]],["genericbounds"]],["genericparam"]]],[11,"stmt_expr","","",281,[[["self"],["p",["expr"]]],["stmt"]]],[11,"stmt_semi","","",281,[[["self"],["p",["expr"]]],["stmt"]]],[11,"stmt_let","","",281,[[["self"],["span"],["bool"],["ident"],["p",["expr"]]],["stmt"]]],[11,"stmt_let_typed","","",281,[[["self"],["span"],["bool"],["ident"],["p",["ty"]],["p",["expr"]]],["stmt"]]],[11,"stmt_let_type_only","","",281,[[["self"],["span"],["p",["ty"]]],["stmt"]]],[11,"stmt_item","","",281,[[["self"],["span"],["p",["item"]]],["stmt"]]],[11,"block_expr","","",281,[[["self"],["p",["expr"]]],["p",["block"]]]],[11,"block","","",281,[[["self"],["span"],["vec",["stmt"]]],["p",["block"]]]],[11,"expr","","",281,[[["self"],["span"],["exprkind"]],["p",["expr"]]]],[11,"expr_path","","",281,[[["self"],["path"]],["p",["expr"]]]],[11,"expr_qpath","","Constructs a QPath expression.",281,[[["self"],["span"],["qself"],["path"]],["p",["expr"]]]],[11,"expr_ident","","",281,[[["self"],["span"],["ident"]],["p",["expr"]]]],[11,"expr_self","","",281,[[["self"],["span"]],["p",["expr"]]]],[11,"expr_binary","","",281,[[["self"],["span"],["binopkind"],["p",["expr"]],["p",["expr"]]],["p",["expr"]]]],[11,"expr_deref","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_unary","","",281,[[["self"],["span"],["unop"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_field_access","","",281,[[["self"],["span"],["p",["expr"]],["ident"]],["p",["expr"]]]],[11,"expr_tup_field_access","","",281,[[["self"],["span"],["p",["expr"]],["usize"]],["p",["expr"]]]],[11,"expr_addr_of","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_mut_addr_of","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_call","","",281,[[["self"],["span"],["p",["expr"]],["vec",["p"]]],["p",["expr"]]]],[11,"expr_call_ident","","",281,[[["self"],["span"],["ident"],["vec",["p"]]],["p",["expr"]]]],[11,"expr_call_global","","",281,[[["self"],["span"],["vec",["ident"]],["vec",["p"]]],["p",["expr"]]]],[11,"expr_method_call","","",281,[[["self"],["span"],["p",["expr"]],["ident"],["vec",["p"]]],["p",["expr"]]]],[11,"expr_block","","",281,[[["self"],["p",["block"]]],["p",["expr"]]]],[11,"field_imm","","",281,[[["self"],["span"],["ident"],["p",["expr"]]],["field"]]],[11,"expr_struct","","",281,[[["self"],["span"],["path"],["vec",["field"]]],["p",["expr"]]]],[11,"expr_struct_ident","","",281,[[["self"],["span"],["ident"],["vec",["field"]]],["p",["expr"]]]],[11,"expr_lit","","",281,[[["self"],["span"],["litkind"]],["p",["expr"]]]],[11,"expr_usize","","",281,[[["self"],["span"],["usize"]],["p",["expr"]]]],[11,"expr_isize","","",281,[[["self"],["span"],["isize"]],["p",["expr"]]]],[11,"expr_u32","","",281,[[["self"],["span"],["u32"]],["p",["expr"]]]],[11,"expr_u16","","",281,[[["self"],["span"],["u16"]],["p",["expr"]]]],[11,"expr_u8","","",281,[[["self"],["span"],["u8"]],["p",["expr"]]]],[11,"expr_bool","","",281,[[["self"],["span"],["bool"]],["p",["expr"]]]],[11,"expr_vec","","",281,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[11,"expr_vec_ng","","",281,[[["self"],["span"]],["p",["expr"]]]],[11,"expr_vec_slice","","",281,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[11,"expr_str","","",281,[[["self"],["span"],["symbol"]],["p",["expr"]]]],[11,"expr_cast","","",281,[[["self"],["span"],["p",["expr"]],["p",["ty"]]],["p",["expr"]]]],[11,"expr_some","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_none","","",281,[[["self"],["span"]],["p",["expr"]]]],[11,"expr_break","","",281,[[["self"],["span"]],["p",["expr"]]]],[11,"expr_tuple","","",281,[[["self"],["span"],["vec",["p"]]],["p",["expr"]]]],[11,"expr_fail","","",281,[[["self"],["span"],["symbol"]],["p",["expr"]]]],[11,"expr_unreachable","","",281,[[["self"],["span"]],["p",["expr"]]]],[11,"expr_ok","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_err","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"expr_try","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"pat","","",281,[[["self"],["span"],["patkind"]],["p",["pat"]]]],[11,"pat_wild","","",281,[[["self"],["span"]],["p",["pat"]]]],[11,"pat_lit","","",281,[[["self"],["span"],["p",["expr"]]],["p",["pat"]]]],[11,"pat_ident","","",281,[[["self"],["span"],["ident"]],["p",["pat"]]]],[11,"pat_ident_binding_mode","","",281,[[["self"],["span"],["ident"],["bindingmode"]],["p",["pat"]]]],[11,"pat_path","","",281,[[["self"],["span"],["path"]],["p",["pat"]]]],[11,"pat_tuple_struct","","",281,[[["self"],["span"],["path"],["vec",["p"]]],["p",["pat"]]]],[11,"pat_struct","","",281,[[["self"],["span"],["path"],["vec",["spanned"]]],["p",["pat"]]]],[11,"pat_tuple","","",281,[[["self"],["span"],["vec",["p"]]],["p",["pat"]]]],[11,"pat_some","","",281,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"pat_none","","",281,[[["self"],["span"]],["p",["pat"]]]],[11,"pat_ok","","",281,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"pat_err","","",281,[[["self"],["span"],["p",["pat"]]],["p",["pat"]]]],[11,"arm","","",281,[[["self"],["span"],["vec",["p"]],["p",["expr"]]],["arm"]]],[11,"arm_unreachable","","",281,[[["self"],["span"]],["arm"]]],[11,"expr_match","","",281,[[["self"],["span"],["p",["expr"]],["vec",["arm"]]],["p",["expr"]]]],[11,"expr_if","","",281,[[["self"],["span"],["p",["expr"]],["p",["expr"]],["option",["p"]]],["p",["expr"]]]],[11,"expr_loop","","",281,[[["self"],["span"],["p",["block"]]],["p",["expr"]]]],[11,"lambda_fn_decl","","",281,[[["self"],["span"],["p",["fndecl"]],["p",["expr"]],["span"]],["p",["expr"]]]],[11,"lambda","","",281,[[["self"],["span"],["vec",["ident"]],["p",["expr"]]],["p",["expr"]]]],[11,"lambda0","","",281,[[["self"],["span"],["p",["expr"]]],["p",["expr"]]]],[11,"lambda1","","",281,[[["self"],["span"],["p",["expr"]],["ident"]],["p",["expr"]]]],[11,"lambda_stmts","","",281,[[["self"],["span"],["vec",["ident"]],["vec",["stmt"]]],["p",["expr"]]]],[11,"lambda_stmts_0","","",281,[[["self"],["span"],["vec",["stmt"]]],["p",["expr"]]]],[11,"lambda_stmts_1","","",281,[[["self"],["span"],["vec",["stmt"]],["ident"]],["p",["expr"]]]],[11,"arg","","",281,[[["self"],["span"],["ident"],["p",["ty"]]],["arg"]]],[11,"fn_decl","","",281,[[["self"],["vec",["arg"]],["functionretty"]],["p",["fndecl"]]]],[11,"item","","",281,[[["self"],["span"],["ident"],["vec",["attribute"]],["itemkind"]],["p",["item"]]]],[11,"item_fn_poly","","",281,[[["self"],["span"],["ident"],["vec",["arg"]],["p",["ty"]],["generics"],["p",["block"]]],["p",["item"]]]],[11,"item_fn","","",281,[[["self"],["span"],["ident"],["vec",["arg"]],["p",["ty"]],["p",["block"]]],["p",["item"]]]],[11,"variant","","",281,[[["self"],["span"],["ident"],["vec",["p"]]],["variant"]]],[11,"item_enum_poly","","",281,[[["self"],["span"],["ident"],["enumdef"],["generics"]],["p",["item"]]]],[11,"item_enum","","",281,[[["self"],["span"],["ident"],["enumdef"]],["p",["item"]]]],[11,"item_struct","","",281,[[["self"],["span"],["ident"],["variantdata"]],["p",["item"]]]],[11,"item_struct_poly","","",281,[[["self"],["span"],["ident"],["variantdata"],["generics"]],["p",["item"]]]],[11,"item_mod","","",281,[[["self"],["span"],["span"],["ident"],["vec",["attribute"]],["vec",["p"]]],["p",["item"]]]],[11,"item_extern_crate","","",281,[[["self"],["span"],["ident"]],["p",["item"]]]],[11,"item_static","","",281,[[["self"],["span"],["ident"],["p",["ty"]],["mutability"],["p",["expr"]]],["p",["item"]]]],[11,"item_const","","",281,[[["self"],["span"],["ident"],["p",["ty"]],["p",["expr"]]],["p",["item"]]]],[11,"item_ty_poly","","",281,[[["self"],["span"],["ident"],["p",["ty"]],["generics"]],["p",["item"]]]],[11,"item_ty","","",281,[[["self"],["span"],["ident"],["p",["ty"]]],["p",["item"]]]],[11,"attribute","","",281,[[["self"],["span"],["metaitem"]],["attribute"]]],[11,"meta_word","","",281,[[["self"],["span"],["name"]],["metaitem"]]],[11,"meta_list_item_word","","",281,[[["self"],["span"],["name"]],["nestedmetaitem"]]],[11,"meta_list","","",281,[[["self"],["span"],["name"],["vec",["nestedmetaitem"]]],["metaitem"]]],[11,"meta_name_value","","",281,[[["self"],["span"],["name"],["litkind"]],["metaitem"]]],[11,"item_use","","",281,[[["self"],["span"],["visibility"],["p",["usetree"]]],["p",["item"]]]],[11,"item_use_simple","","",281,[[["self"],["span"],["visibility"],["path"]],["p",["item"]]]],[11,"item_use_simple_","","",281,[[["self"],["span"],["visibility"],["option",["ident"]],["path"]],["p",["item"]]]],[11,"item_use_list","","",281,N],[11,"item_use_glob","","",281,[[["self"],["span"],["visibility"],["vec",["ident"]]],["p",["item"]]]],[0,"derive","syntax::ext","",N,N],[5,"collect_derives","syntax::ext::derive","",N,[[["extctxt"],["vec"]],["vec",["path"]]]],[5,"add_derived_markers","","",N,N],[0,"expand","syntax::ext","",N,N],[3,"Invocation","syntax::ext::expand","",N,N],[12,"kind","","",296,N],[12,"fragment_kind","","",296,N],[12,"expansion_data","","",296,N],[3,"MacroExpander","","",N,N],[12,"cx","","",297,N],[12,"monotonic","","",297,N],[3,"InvocationCollector","","",N,N],[12,"cx","","",298,N],[12,"cfg","","",298,N],[12,"invocations","","",298,N],[12,"monotonic","","",298,N],[3,"ExpansionConfig","","",N,N],[12,"crate_name","","",299,N],[12,"features","","",299,N],[12,"recursion_limit","","",299,N],[12,"trace_mac","","",299,N],[12,"should_test","","",299,N],[12,"single_step","","",299,N],[12,"keep_macs","","",299,N],[3,"Marker","","",N,N],[12,"0","","",300,N],[4,"AstFragment","","A fragment of AST that can be produced by a single macro expansion. Can also serve as an input and intermediate result for macro expansion operations.",N,N],[13,"OptExpr","","",301,N],[13,"Expr","","",301,N],[13,"Pat","","",301,N],[13,"Ty","","",301,N],[13,"Stmts","","",301,N],[13,"Items","","",301,N],[13,"TraitItems","","",301,N],[13,"ImplItems","","",301,N],[13,"ForeignItems","","",301,N],[4,"AstFragmentKind","","\"Discriminant\" of an AST fragment.",N,N],[13,"OptExpr","","",302,N],[13,"Expr","","",302,N],[13,"Pat","","",302,N],[13,"Ty","","",302,N],[13,"Stmts","","",302,N],[13,"Items","","",302,N],[13,"TraitItems","","",302,N],[13,"ImplItems","","",302,N],[13,"ForeignItems","","",302,N],[4,"TogetherWith","","",N,N],[13,"None","","",303,N],[13,"Derive","","",303,N],[13,"TestBench","","",303,N],[4,"InvocationKind","","",N,N],[13,"Bang","","",304,N],[12,"mac","syntax::ext::expand::InvocationKind","",304,N],[12,"ident","","",304,N],[12,"span","","",304,N],[13,"Attr","syntax::ext::expand","",304,N],[12,"attr","syntax::ext::expand::InvocationKind","",304,N],[12,"traits","","",304,N],[12,"item","","",304,N],[12,"together_with","","",304,N],[13,"Derive","syntax::ext::expand","",304,N],[12,"path","syntax::ext::expand::InvocationKind","",304,N],[12,"item","","",304,N],[5,"macro_bang_format","syntax::ext::expand","",N,[[["path"]],["expnformat"]]],[11,"clone","","",302,[[["self"]],["astfragmentkind"]]],[11,"eq","","",302,[[["self"],["astfragmentkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",302,N],[11,"name","","",302,[[["self"]],["str"]]],[11,"make_from","","",302,[[["self"],["box",["macresult"]]],["option",["astfragment"]]]],[11,"make_opt_expr","","",301,[[["self"]],["option",["p"]]]],[11,"make_expr","","",301,[[["self"]],["p",["expr"]]]],[11,"make_pat","","",301,[[["self"]],["p",["pat"]]]],[11,"make_ty","","",301,[[["self"]],["p",["ty"]]]],[11,"make_stmts","","",301,[[["self"]],["onevector",["stmt"]]]],[11,"make_items","","",301,[[["self"]],["onevector",["p"]]]],[11,"make_trait_items","","",301,[[["self"]],["onevector",["traititem"]]]],[11,"make_impl_items","","",301,[[["self"]],["onevector",["implitem"]]]],[11,"make_foreign_items","","",301,[[["self"]],["onevector",["foreignitem"]]]],[11,"fold_with","","",301,[[["self"],["f"]],["self"]]],[11,"visit_with","","",301,[[["self"],["v"]]]],[11,"fold_opt_expr","","",297,[[["self"],["p",["expr"]]],["option",["p"]]]],[11,"fold_expr","","",297,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"fold_pat","","",297,[[["self"],["p",["pat"]]],["p",["pat"]]]],[11,"fold_ty","","",297,[[["self"],["p",["ty"]]],["p",["ty"]]]],[11,"fold_stmt","","",297,N],[11,"fold_item","","",297,N],[11,"fold_trait_item","","",297,N],[11,"fold_impl_item","","",297,N],[11,"fold_foreign_item","","",297,N],[11,"dummy","","",302,[[["self"],["span"]],["option",["astfragment"]]]],[11,"expect_from_annotatables","","",302,[[["self"],["i"]],["astfragment"]]],[11,"clone","","",303,[[["self"]],["togetherwith"]]],[11,"eq","","",303,[[["self"],["togetherwith"]],["bool"]]],[11,"span","","",296,[[["self"]],["span"]]],[11,"new","","",297,[[["extctxt"],["bool"]],["self"]]],[11,"expand_crate","","",297,[[["self"],["crate"]],["crate"]]],[11,"expand_fragment","","",297,[[["self"],["astfragment"]],["astfragment"]]],[11,"resolve_imports","","",297,[[["self"]]]],[11,"collect_invocations","","Collect all macro invocations reachable at this time in this AST fragment, and replace them with \"placeholders\" - dummy macro invocations with specially crafted `NodeId`s. Then call into resolver that builds a skeleton (\"reduced graph\") of the fragment and prepares data for resolving paths of macro invocations.",297,N],[11,"fully_configure","","",297,[[["self"],["annotatable"]],["annotatable"]]],[11,"expand_invoc","","",297,[[["self"],["invocation"],["syntaxextension"]],["option",["astfragment"]]]],[11,"expand_attr_invoc","","",297,[[["self"],["invocation"],["syntaxextension"]],["option",["astfragment"]]]],[11,"extract_proc_macro_attr_input","","",297,[[["self"],["tokenstream"],["span"]],["tokenstream"]]],[11,"gate_proc_macro_attr_item","","",297,[[["self"],["span"],["annotatable"]]]],[11,"gate_proc_macro_expansion","","",297,[[["self"],["span"],["option"]]]],[11,"expand_bang_invoc","","Expand a macro invocation. Returns the resulting expanded AST fragment.",297,[[["self"],["invocation"],["syntaxextension"]],["option",["astfragment"]]]],[11,"gate_proc_macro_expansion_kind","","",297,[[["self"],["span"],["astfragmentkind"]]]],[11,"expand_derive_invoc","","Expand a derive invocation. Returns the resulting expanded AST fragment.",297,[[["self"],["invocation"],["syntaxextension"]],["option",["astfragment"]]]],[11,"parse_ast_fragment","","",297,[[["self"],["tokenstream"],["astfragmentkind"],["path"],["span"]],["option",["astfragment"]]]],[11,"parse_ast_fragment","syntax::parse::parser","",215,[[["self"],["astfragmentkind"],["bool"]],["presult",["astfragment"]]]],[11,"ensure_complete_parse","","",215,[[["self"],["path"],["str"],["span"]]]],[11,"collect","syntax::ext::expand","",298,[[["self"],["astfragmentkind"],["invocationkind"]],["astfragment"]]],[11,"collect_bang","","",298,[[["self"],["mac"],["span"],["astfragmentkind"]],["astfragment"]]],[11,"collect_attr","","",298,[[["self"],["option",["attribute"]],["vec",["path"]],["annotatable"],["astfragmentkind"],["togetherwith"]],["astfragment"]]],[11,"find_attr_invoc","","",298,[[["self"],["vec"],["togetherwith"]],["option",["attribute"]]]],[11,"classify_item","","If `item` is an attr invocation, remove and return the macro attribute and derive traits.",298,N],[11,"classify_nonitem","","Alternative of `classify_item()` that ignores `#[derive]` so invocations fallthrough to the unused-attributes lint (making it an error on statements and expressions is a breaking change)",298,N],[11,"configure","","",298,[[["self"],["t"]],["option"]]],[11,"check_attributes","","",298,N],[11,"check_attribute","","",298,[[["self"],["attribute"]]]],[11,"check_attribute_inner","","",298,[[["self"],["attribute"],["features"]]]],[11,"fold_expr","","",298,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"fold_opt_expr","","",298,[[["self"],["p",["expr"]]],["option",["p"]]]],[11,"fold_pat","","",298,[[["self"],["p",["pat"]]],["p",["pat"]]]],[11,"fold_stmt","","",298,[[["self"],["stmt"]],["onevector",["stmt"]]]],[11,"fold_block","","",298,[[["self"],["p",["block"]]],["p",["block"]]]],[11,"fold_item","","",298,[[["self"],["p",["item"]]],["onevector",["p"]]]],[11,"fold_trait_item","","",298,[[["self"],["traititem"]],["onevector",["traititem"]]]],[11,"fold_impl_item","","",298,[[["self"],["implitem"]],["onevector",["implitem"]]]],[11,"fold_ty","","",298,[[["self"],["p",["ty"]]],["p",["ty"]]]],[11,"fold_foreign_mod","","",298,[[["self"],["foreignmod"]],["foreignmod"]]],[11,"fold_foreign_item","","",298,[[["self"],["foreignitem"]],["onevector",["foreignitem"]]]],[11,"fold_item_kind","","",298,[[["self"],["itemkind"]],["itemkind"]]],[11,"fold_generic_param","","",298,[[["self"],["genericparam"]],["genericparam"]]],[11,"fold_attribute","","",298,[[["self"],["attribute"]],["option",["attribute"]]]],[11,"new_id","","",298,[[["self"],["nodeid"]],["nodeid"]]],[11,"default","","",299,[[["string"]],["expansionconfig"]]],[11,"enable_quotes","","",299,[[["self"]],["bool"]]],[11,"enable_asm","","",299,[[["self"]],["bool"]]],[11,"enable_custom_test_frameworks","","",299,[[["self"]],["bool"]]],[11,"enable_global_asm","","",299,[[["self"]],["bool"]]],[11,"enable_log_syntax","","",299,[[["self"]],["bool"]]],[11,"enable_concat_idents","","",299,[[["self"]],["bool"]]],[11,"enable_trace_macros","","",299,[[["self"]],["bool"]]],[11,"enable_allow_internal_unstable","","",299,[[["self"]],["bool"]]],[11,"enable_custom_derive","","",299,[[["self"]],["bool"]]],[11,"enable_format_args_nl","","",299,[[["self"]],["bool"]]],[11,"macros_in_extern_enabled","","",299,[[["self"]],["bool"]]],[11,"proc_macro_mod","","",299,[[["self"]],["bool"]]],[11,"proc_macro_gen","","",299,[[["self"]],["bool"]]],[11,"proc_macro_expr","","",299,[[["self"]],["bool"]]],[11,"proc_macro_non_items","","",299,[[["self"]],["bool"]]],[11,"enable_custom_inner_attributes","","",299,[[["self"]],["bool"]]],[11,"fmt","","",300,[[["self"],["formatter"]],["result"]]],[11,"new_span","","",300,[[["self"],["span"]],["span"]]],[11,"fold_mac","","",300,[[["self"],["mac"]],["mac"]]],[0,"placeholders","syntax::ext","",N,N],[3,"PlaceholderExpander","syntax::ext::placeholders","",N,N],[12,"expanded_fragments","","",305,N],[12,"cx","","",305,N],[12,"monotonic","","",305,N],[5,"placeholder","","",N,[[["astfragmentkind"],["nodeid"]],["astfragment"]]],[11,"new","","",305,[[["extctxt"],["bool"]],["self"]]],[11,"add","","",305,[[["self"],["nodeid"],["astfragment"],["vec",["mark"]]]]],[11,"remove","","",305,[[["self"],["nodeid"]],["astfragment"]]],[11,"fold_item","","",305,[[["self"],["p",["item"]]],["onevector",["p"]]]],[11,"fold_trait_item","","",305,[[["self"],["traititem"]],["onevector",["traititem"]]]],[11,"fold_impl_item","","",305,[[["self"],["implitem"]],["onevector",["implitem"]]]],[11,"fold_foreign_item","","",305,[[["self"],["foreignitem"]],["onevector",["foreignitem"]]]],[11,"fold_expr","","",305,[[["self"],["p",["expr"]]],["p",["expr"]]]],[11,"fold_opt_expr","","",305,[[["self"],["p",["expr"]]],["option",["p"]]]],[11,"fold_stmt","","",305,[[["self"],["stmt"]],["onevector",["stmt"]]]],[11,"fold_pat","","",305,[[["self"],["p",["pat"]]],["p",["pat"]]]],[11,"fold_ty","","",305,[[["self"],["p",["ty"]]],["p",["ty"]]]],[11,"fold_block","","",305,[[["self"],["p",["block"]]],["p",["block"]]]],[11,"fold_mod","","",305,[[["self"],["mod"]],["mod"]]],[11,"fold_mac","","",305,[[["self"],["mac"]],["mac"]]],[0,"quote","syntax::ext","",N,N],[5,"unflatten","syntax::ext::quote","",N,[[["vec",["tokentree"]]],["vec",["tokentree"]]]],[5,"parse_expr_panic","","",N,[[["parser"]],["p",["expr"]]]],[5,"parse_item_panic","","",N,[[["parser"]],["option",["p"]]]],[5,"parse_pat_panic","","",N,[[["parser"]],["p",["pat"]]]],[5,"parse_arm_panic","","",N,[[["parser"]],["arm"]]],[5,"parse_ty_panic","","",N,[[["parser"]],["p",["ty"]]]],[5,"parse_stmt_panic","","",N,[[["parser"]],["option",["stmt"]]]],[5,"parse_attribute_panic","","",N,[[["parser"],["bool"]],["attribute"]]],[5,"parse_arg_panic","","",N,[[["parser"]],["arg"]]],[5,"parse_block_panic","","",N,[[["parser"]],["p",["block"]]]],[5,"parse_meta_item_panic","","",N,[[["parser"]],["metaitem"]]],[5,"parse_path_panic","","",N,[[["parser"],["pathstyle"]],["path"]]],[5,"expand_quote_tokens","","",N,N],[5,"expand_quote_expr","","",N,N],[5,"expand_quote_item","","",N,N],[5,"expand_quote_pat","","",N,N],[5,"expand_quote_arm","","",N,N],[5,"expand_quote_ty","","",N,N],[5,"expand_quote_stmt","","",N,N],[5,"expand_quote_attr","","",N,N],[5,"expand_quote_arg","","",N,N],[5,"expand_quote_block","","",N,N],[5,"expand_quote_meta_item","","",N,N],[5,"expand_quote_path","","",N,N],[5,"ids_ext","","",N,[[["vec",["string"]]],["vec",["ident"]]]],[5,"id_ext","","",N,[[["str"]],["ident"]]],[5,"mk_ident","","",N,[[["extctxt"],["span"],["ident"]],["p",["expr"]]]],[5,"mk_name","","",N,[[["extctxt"],["span"],["ident"]],["p",["expr"]]]],[5,"mk_tt_path","","",N,[[["extctxt"],["span"],["str"]],["p",["expr"]]]],[5,"mk_token_path","","",N,[[["extctxt"],["span"],["str"]],["p",["expr"]]]],[5,"mk_parser_path","","",N,N],[5,"mk_binop","","",N,[[["extctxt"],["span"],["binoptoken"]],["p",["expr"]]]],[5,"mk_delim","","",N,[[["extctxt"],["span"],["delimtoken"]],["p",["expr"]]]],[5,"expr_mk_token","","",N,[[["extctxt"],["span"],["token"]],["p",["expr"]]]],[5,"statements_mk_tt","","",N,[[["extctxt"],["tokentree"],["bool"]],["vec",["stmt"]]]],[5,"parse_arguments_to_quote","","",N,N],[5,"mk_stmts_let","","",N,[[["extctxt"],["span"]],["vec",["stmt"]]]],[5,"statements_mk_tts","","",N,[[["extctxt"],["tokenstream"]],["vec",["stmt"]]]],[5,"expand_tts","","",N,N],[5,"expand_wrapper","","",N,N],[5,"expand_parse_call","","",N,N],[0,"rt","","Quasiquoting works via token trees.",N,N],[3,"BytePos","syntax::ext::quote::rt","A byte offset. Keep this small (currently 32-bits), as AST contains a lot of them.",N,N],[12,"0","","",176,N],[3,"Span","","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",N,N],[12,"0","","",189,N],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",N,N],[4,"FileName","","Differentiates between real files and common virtual files",N,N],[13,"Real","","",167,N],[13,"Macros","","A macro.  This includes the full name of the macro, so that there are no clashes.",167,N],[13,"QuoteExpansion","","call to `quote!`",167,N],[13,"Anon","","Command line",167,N],[13,"MacroExpansion","","Hack in src/libsyntax/parse.rs FIXME(jseyfried)",167,N],[13,"ProcMacroSourceCode","","",167,N],[13,"CfgSpec","","Strings provided as --cfg [cfgspec] stored in a crate_cfg",167,N],[13,"CliCrateAttr","","Strings provided as crate attributes in the CLI",167,N],[13,"Custom","","Custom sources for explicit parser calls from plugins and drivers",167,N],[8,"ToTokens","","",N,N],[10,"to_tokens","","",306,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[8,"ExtParseUtils","","",N,N],[10,"parse_item","","",307,[[["self"],["string"]],["p",["item"]]]],[10,"parse_expr","","",307,[[["self"],["string"]],["p",["expr"]]]],[10,"parse_stmt","","",307,[[["self"],["string"]],["stmt"]]],[10,"parse_tts","","",307,[[["self"],["string"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::tokenstream","",259,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::source_map","",190,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::source_map::symbol","",2,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ast","",48,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",78,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",61,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",54,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",55,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ptr","",243,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ast","",76,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ptr","",243,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ast","",75,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",64,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ptr","",243,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",243,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ast","",66,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",82,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ptr","",243,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ast","",47,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",60,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","","",91,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"to_tokens","syntax::ext::quote::rt","",159,[[["self"],["extctxt"]],["vec",["tokentree"]]]],[11,"parse_item","syntax::ext::base","",281,[[["self"],["string"]],["p",["item"]]]],[11,"parse_stmt","","",281,[[["self"],["string"]],["stmt"]]],[11,"parse_expr","","",281,[[["self"],["string"]],["p",["expr"]]]],[11,"parse_tts","","",281,[[["self"],["string"]],["vec",["tokentree"]]]],[0,"source_util","syntax::ext","",N,N],[5,"expand_line","syntax::ext::source_util","line!(): expands to the current line number",N,N],[5,"expand_column","","",N,N],[5,"expand_column_gated","","",N,N],[5,"expand_file","","file!(): expands to the current filename */ The source_file (`loc.file`) contains a bunch more information we could spit out if we wanted.",N,N],[5,"expand_stringify","","",N,N],[5,"expand_mod","","",N,N],[5,"expand_include","","include! : parse the given file as an expr This is generally a bad idea because it's going to behave unhygienically.",N,N],[5,"expand_include_str","","",N,N],[5,"expand_include_bytes","","",N,N],[5,"res_rel_file","","",N,[[["extctxt"],["span"],["string"]],["pathbuf"]]],[0,"tt","syntax::ext","",N,N],[0,"transcribe","syntax::ext::tt","",N,N],[4,"Frame","syntax::ext::tt::transcribe","",N,N],[13,"Delimited","","",308,N],[12,"forest","syntax::ext::tt::transcribe::Frame","",308,N],[12,"idx","","",308,N],[12,"span","","",308,N],[13,"Sequence","syntax::ext::tt::transcribe","",308,N],[12,"forest","syntax::ext::tt::transcribe::Frame","",308,N],[12,"idx","","",308,N],[12,"sep","","",308,N],[4,"LockstepIterSize","syntax::ext::tt::transcribe","",N,N],[13,"Unconstrained","","",309,N],[13,"Constraint","","",309,N],[13,"Contradiction","","",309,N],[5,"transcribe","","This can do Macro-By-Example transcription. On the other hand, if `src` contains no `TokenTree::{Sequence, MetaVar, MetaVarDecl}`s, `interp` can (and should) be None.",N,[[["extctxt"],["option",["fxhashmap"]],["vec",["tokentree"]]],["tokenstream"]]],[5,"lookup_cur_matched","","",N,N],[5,"lockstep_iter_size","","",N,N],[11,"new","","",308,[[["vec",["tokentree"]]],["frame"]]],[11,"next","","",308,[[["self"]],["option",["tokentree"]]]],[11,"clone","","",309,[[["self"]],["lockstepitersize"]]],[11,"add","","",309,[[["self"],["lockstepitersize"]],["lockstepitersize"]]],[0,"macro_parser","syntax::ext::tt","This is an NFA-based parser, which calls out to the main rust parser for named nonterminals (which it commits to fully when it hits one in a grammar). There's a set of current NFA threads and a set of next ones. Instead of NTs, we have a special case for Kleene star. The big-O, in pathological cases, is worse than traditional use of NFA or Earley parsing, but it's an easier fit for Macro-by-Example-style rules.",N,N],[3,"MatcherTtFrame","syntax::ext::tt::macro_parser","An unzipping of `TokenTree`s... see the `stack` field of `MatcherPos`.",N,N],[12,"elts","","The \"parent\" matcher that we are descending into.",310,N],[12,"idx","","The position of the \"dot\" in `elts` at the time we descended.",310,N],[3,"MatcherPos","","Represents a single \"position\" (aka \"matcher position\", aka \"item\"), as described in the module documentation.",N,N],[12,"top_elts","","The token or sequence of tokens that make up the matcher",311,N],[12,"idx","","The position of the \"dot\" in this matcher",311,N],[12,"sp_open","","The first span of source source that the beginning of this matcher corresponds to. In other words, the token in the source whose span is `sp_open` is matched against the first token of the matcher.",311,N],[12,"matches","","For each named metavar in the matcher, we keep track of token trees matched against the metavar by the black box parser. In particular, there may be more than one match per metavar if we are in a repetition (each repetition matches each of the variables). Moreover, matchers and repetitions can be nested; the `matches` field is shared (hence the `Rc`) among all \"nested\" matchers. `match_lo`, `match_cur`, and `match_hi` keep track of the current position of the `self` matcher position in the shared `matches` list.",311,N],[12,"match_lo","","The position in `matches` corresponding to the first metavar in this matcher's sequence of token trees. In other words, the first metavar in the first token of `top_elts` corresponds to `matches[match_lo]`.",311,N],[12,"match_cur","","The position in `matches` corresponding to the metavar we are currently trying to match against the source token stream. `match_lo <= match_cur <= match_hi`.",311,N],[12,"match_hi","","Similar to `match_lo` except `match_hi` is the position in `matches` of the last metavar in this matcher.",311,N],[12,"seq_op","","The KleeneOp of this sequence if we are in a repetition.",311,N],[12,"sep","","The separator if we are in a repetition",311,N],[12,"up","","The \"parent\" matcher position if we are in a repetition. That is, the matcher position just before we enter the sequence.",311,N],[12,"stack","","When matching against matchers with nested delimited submatchers (e.g. `pat ( pat ( .. ) pat ) pat`), we need to keep track of the matchers we are descending into. This stack does that where the bottom of the stack is the outermost matcher.",311,N],[4,"TokenTreeOrTokenTreeSlice","","Either a sequence of token trees or a single one. This is used as the representation of the sequence of tokens that make up a matcher.",N,N],[13,"Tt","","",312,N],[13,"TtSeq","","",312,N],[4,"MatcherPosHandle","","",N,N],[13,"Ref","","",313,N],[13,"Box","","",313,N],[4,"ParseResult","","Represents the possible results of an attempted parse.",N,N],[13,"Success","","Parsed successfully.",314,N],[13,"Failure","","Arm failed to match. If the second parameter is `token::Eof`, it indicates an unexpected end of macro invocation. Otherwise, it indicates that no rules expected the given token.",314,N],[13,"Error","","Fatal error (malformed macro?). Abort compilation.",314,N],[4,"NamedMatch","","`NamedMatch` is a pattern-match result for a single `token::MATCH_NONTERMINAL`: so it is associated with a single ident in a parse, and all `MatchedNonterminal`s in the `NamedMatch` have the same nonterminal type (expr, item, etc). Each leaf in a single `NamedMatch` corresponds to a single `token::MATCH_NONTERMINAL` in the `TokenTree` that produced it.",N,N],[13,"MatchedSeq","","",315,N],[13,"MatchedNonterminal","","",315,N],[5,"count_names","","Count how many metavars are named in the given matcher `ms`.",N,N],[5,"create_matches","","Initialize `len` empty shared `Vec`s to be used to store matches of metavars.",N,[[["usize"]],["vec",["rc"]]]],[5,"initial_matcher_pos","","Generate the top-level matcher position in which the \"dot\" is before the first token of the matcher `ms` and we are going to start matching at the span `open` in the source.",N,N],[5,"nameize","","Takes a sequence of token trees `ms` representing a matcher which successfully matched input and an iterator of items that matched input and produces a `NamedParseResult`.",N,N],[5,"parse_failure_msg","","Generate an appropriate parsing failure message. For EOF, this is \"unexpected end...\". For other tokens, this is \"unexpected token...\".",N,[[["token"]],["string"]]],[5,"token_name_eq","","Perform a token equality check, ignoring syntax context (that is, an unhygienic comparison)",N,[[["token"],["token"]],["bool"]]],[5,"inner_parse_loop","","Process the matcher positions of `cur_items` until it is empty. In the process, this will produce more items in `next_items`, `eof_items`, and `bb_items`.",N,[[["parsesess"],["onevector"],["vec"],["onevector"],["onevector"],["token"],["span"]],["parseresult"]]],[5,"parse","","Use the given sequence of token trees (`ms`) as a matcher. Match the given token stream `tts` against it and return the match.",N,N],[5,"get_macro_ident","","The token is an identifier, but not `_`. We prohibit passing `_` to macros expecting `ident` for now.",N,[[["token"]],["option"]]],[5,"may_begin_with","","Checks whether a non-terminal may begin with a particular token.",N,[[["str"],["token"]],["bool"]]],[5,"parse_nt","","A call to the \"black-box\" parser to parse some rust nonterminal.",N,[[["parser"],["span"],["str"]],["nonterminal"]]],[6,"NamedParseResult","","A `ParseResult` where the `Success` variant contains a mapping of `Ident`s to `NamedMatch`es. This represents the mapping of metavars to the token trees they bind to.",N,N],[11,"clone","","",312,[[["self"]],["tokentreeortokentreeslice"]]],[11,"len","","Returns the number of constituent top-level token trees of `self` (top-level in that it will not recursively descend into subtrees).",312,[[["self"]],["usize"]]],[11,"get_tt","","The the `index`-th token tree of `self`.",312,[[["self"],["usize"]],["tokentree"]]],[11,"clone","","",310,[[["self"]],["matcherttframe"]]],[11,"clone","","",311,[[["self"]],["matcherpos"]]],[11,"push_match","","Add `m` as a named match for the `idx`-th metavar.",311,[[["self"],["usize"],["namedmatch"]]]],[11,"clone","","",313,[[["self"]],["self"]]],[11,"deref","","",313,N],[11,"deref_mut","","",313,[[["self"]],["matcherpos"]]],[11,"fmt","","",315,[[["self"],["formatter"]],["result"]]],[11,"clone","","",315,[[["self"]],["namedmatch"]]],[0,"macro_rules","syntax::ext::tt","",N,N],[3,"ParserAnyMacro","syntax::ext::tt::macro_rules","",N,N],[12,"parser","","",316,N],[12,"site_span","","Span of the expansion site of the macro this parser is for",316,N],[12,"macro_ident","","The ident of the macro we're parsing",316,N],[3,"MacroRulesMacroExpander","","",N,N],[12,"name","","",317,N],[12,"lhses","","",317,N],[12,"rhses","","",317,N],[12,"valid","","",317,N],[3,"FirstSets","","",N,N],[12,"first","","",318,N],[3,"TokenSet","","",N,N],[12,"tokens","","",319,N],[12,"maybe_empty","","",319,N],[5,"trace_macros_note","","",N,[[["extctxt"],["span"],["string"]]]],[5,"generic_extension","","Given `lhses` and `rhses`, this is the new macro we create",N,N],[5,"compile","","Converts a `macro_rules!` invocation into a syntax extension.",N,[[["parsesess"],["features"],["item"],["edition"]],["syntaxextension"]]],[5,"check_lhs_nt_follows","","",N,N],[5,"check_lhs_no_empty_seq","","Check that the lhs contains no repetition which could match an empty token tree, because then the matcher would hang indefinitely.",N,N],[5,"check_rhs","","",N,[[["parsesess"],["tokentree"]],["bool"]]],[5,"check_matcher","","",N,N],[5,"check_matcher_core","","",N,N],[5,"token_can_be_followed_by_any","","",N,[[["tokentree"]],["bool"]]],[5,"frag_can_be_followed_by_any","","True if a fragment of type `frag` can be followed by any sort of token.  We use this (among other things) as a useful approximation for when `frag` can be followed by a repetition like `$(...)*` or `$(...)+`. In general, these can be a bit tricky to reason about, so we adopt a conservative position that says that any fragment specifier which consumes at most one token tree can be followed by a fragment specifier (indeed, these fragments can be followed by ANYTHING without fear of future compatibility hazards).",N,[[["str"]],["bool"]]],[5,"is_in_follow","","True if `frag` can legally be followed by the token `tok`. For fragments that can consume an unbounded number of tokens, `tok` must be within a well-defined follow set. This is intended to guarantee future compatibility: for example, without this rule, if we expanded `expr` to include a new binary operator, we might break macros that were relying on that binary operator as a separator.",N,[[["tokentree"],["str"]],["result",["bool"]]]],[5,"has_legal_fragment_specifier","","",N,N],[5,"is_legal_fragment_specifier","","",N,N],[5,"quoted_tt_to_string","","",N,[[["tokentree"]],["string"]]],[11,"make","","",316,[[["box",["parseranymacro"]],["astfragmentkind"]],["astfragment"]]],[11,"expand","","",317,[[["self"],["extctxt"],["span"],["tokenstream"]],["box",["macresult"]]]],[11,"new","","",318,N],[11,"first","","",318,N],[11,"clone","","",319,[[["self"]],["tokenset"]]],[11,"fmt","","",319,[[["self"],["formatter"]],["result"]]],[11,"empty","","",319,[[],["self"]]],[11,"singleton","","",319,[[["tokentree"]],["self"]]],[11,"replace_with","","",319,[[["self"],["tokentree"]]]],[11,"replace_with_irrelevant","","",319,[[["self"]]]],[11,"add_one","","",319,[[["self"],["tokentree"]]]],[11,"add_one_maybe","","",319,[[["self"],["tokentree"]]]],[11,"add_all","","",319,[[["self"],["self"]]]],[0,"quoted","syntax::ext::tt","",N,N],[3,"Delimited","syntax::ext::tt::quoted","Contains the sub-token-trees of a \"delimited\" token tree, such as the contents of `(`. Note that the delimiter itself might be `NoDelim`.",N,N],[12,"delim","","",320,N],[12,"tts","","",320,N],[3,"SequenceRepetition","","",N,N],[12,"tts","","The sequence of token trees",321,N],[12,"separator","","The optional separator",321,N],[12,"op","","Whether the sequence can be repeated zero (*), or one or more times (+)",321,N],[12,"num_captures","","The number of `Match`s that appear in the sequence (and subsequences)",321,N],[4,"KleeneOp","","A Kleene-style repetition operator for token sequences.",N,N],[13,"ZeroOrMore","","Kleene star (`*`) for zero or more repetitions",322,N],[13,"OneOrMore","","Kleene plus (`+`) for one or more repetitions",322,N],[13,"ZeroOrOne","","",322,N],[4,"TokenTree","","Similar to `tokenstream::TokenTree`, except that `$i`, `$i:ident`, and `$(...)` are \"first-class\" token trees. Useful for parsing macros.",N,N],[13,"Token","","",323,N],[13,"Delimited","","",323,N],[13,"Sequence","","A kleene-style repetition sequence",323,N],[13,"MetaVar","","E.g. `$var`",323,N],[13,"MetaVarDecl","","E.g. `$var:expr`. This is only used in the left hand side of MBE macros.",323,N],[5,"parse","","Takes a `tokenstream::TokenStream` and returns a `Vec<self::TokenTree>`. Specifically, this takes a generic `TokenStream`, such as is used in the rest of the compiler, and returns a collection of `TokenTree` for use in parsing a macro.",N,N],[5,"parse_tree","","Takes a `tokenstream::TokenTree` and returns a `self::TokenTree`. Specifically, this takes a generic `TokenTree`, such as is used in the rest of the compiler, and returns a `TokenTree` for use in parsing a macro.",N,N],[5,"kleene_op","","Takes a token and returns `Some(KleeneOp)` if the token is `+` `*` or `?`. Otherwise, return `None`.",N,[[["token"]],["option",["kleeneop"]]]],[5,"parse_kleene_op","","Parse the next token tree of the input looking for a KleeneOp. Returns",N,[[["i"],["span"]],["result",["result","span"]]]],[5,"parse_sep_and_kleene_op","","Attempt to parse a single Kleene star, possibly with a separator.",N,N],[5,"parse_sep_and_kleene_op_2015","","",N,N],[5,"parse_sep_and_kleene_op_2018","","",N,N],[11,"clone","","",320,[[["self"]],["delimited"]]],[11,"eq","","",320,[[["self"],["delimited"]],["bool"]]],[11,"ne","","",320,[[["self"],["delimited"]],["bool"]]],[11,"encode","","",320,[[["self"],["__s"]],["result"]]],[11,"decode","","",320,[[["__d"]],["result",["delimited"]]]],[11,"fmt","","",320,[[["self"],["formatter"]],["result"]]],[11,"open_token","","Return the opening delimiter (possibly `NoDelim`).",320,[[["self"]],["token"]]],[11,"close_token","","Return the closing delimiter (possibly `NoDelim`).",320,[[["self"]],["token"]]],[11,"open_tt","","Return a `self::TokenTree` with a `Span` corresponding to the opening delimiter.",320,[[["self"],["span"]],["tokentree"]]],[11,"close_tt","","Return a `self::TokenTree` with a `Span` corresponding to the closing delimiter.",320,[[["self"],["span"]],["tokentree"]]],[11,"clone","","",321,[[["self"]],["sequencerepetition"]]],[11,"eq","","",321,[[["self"],["sequencerepetition"]],["bool"]]],[11,"ne","","",321,[[["self"],["sequencerepetition"]],["bool"]]],[11,"encode","","",321,[[["self"],["__s"]],["result"]]],[11,"decode","","",321,[[["__d"]],["result",["sequencerepetition"]]]],[11,"fmt","","",321,[[["self"],["formatter"]],["result"]]],[11,"clone","","",322,[[["self"]],["kleeneop"]]],[11,"eq","","",322,[[["self"],["kleeneop"]],["bool"]]],[11,"encode","","",322,[[["self"],["__s"]],["result"]]],[11,"decode","","",322,[[["__d"]],["result",["kleeneop"]]]],[11,"hash","","",322,N],[11,"fmt","","",322,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",323,[[["self"],["formatter"]],["result"]]],[11,"clone","","",323,[[["self"]],["tokentree"]]],[11,"eq","","",323,[[["self"],["tokentree"]],["bool"]]],[11,"ne","","",323,[[["self"],["tokentree"]],["bool"]]],[11,"encode","","",323,[[["self"],["__s"]],["result"]]],[11,"decode","","",323,[[["__d"]],["result",["tokentree"]]]],[11,"len","","Return the number of tokens in the tree.",323,[[["self"]],["usize"]]],[11,"is_empty","","Returns true if the given token tree contains no other tokens. This is vacuously true for single tokens or metavar/decls, but may be false for delimited trees or sequences.",323,[[["self"]],["bool"]]],[11,"get_tt","","Get the `index`-th sub-token-tree. This only makes sense for delimited trees and sequences.",323,[[["self"],["usize"]],["tokentree"]]],[11,"span","","Retrieve the `TokenTree`'s span.",323,[[["self"]],["span"]]],[0,"early_buffered_lints","syntax","Allows the buffering of lints for later.",N,N],[3,"BufferedEarlyLint","syntax::early_buffered_lints","Stores buffered lint info which can later be passed to `librustc`.",N,N],[12,"span","","The span of code that we are linting on.",324,N],[12,"msg","","The lint message.",324,N],[12,"id","","The `NodeId` of the AST node that generated the lint.",324,N],[12,"lint_id","","A lint Id that can be passed to `rustc::lint::Lint::from_parser_lint_id`.",324,N],[4,"BufferedEarlyLintId","","Since we cannot import `LintId`s from `rustc::lint`, we define some Ids here which can later be passed to `rustc::lint::Lint::from_parser_lint_id` to get a `rustc::lint::Lint`.",N,N],[13,"QuestionMarkMacroSep","","Usage of `?` as a macro separator is deprecated.",325,N],[7,"GLOBALS","syntax","",N,N],[17,"DIAGNOSTICS","","",N,N],[11,"new","","",8,[[],["globals"]]],[14,"panictry","","",N,N],[14,"unwrap_or","","",N,N],[14,"register_diagnostic","","",N,N],[14,"span_fatal","","",N,N],[14,"span_err","","",N,N],[14,"span_warn","","",N,N],[14,"struct_err","","",N,N],[14,"span_err_or_warn","","",N,N],[14,"struct_span_fatal","","",N,N],[14,"struct_span_err","","",N,N],[14,"stringify_error_code","","",N,N],[14,"type_error_struct","","",N,N],[14,"struct_span_warn","","",N,N],[14,"struct_span_err_or_warn","","",N,N],[14,"span_note","","",N,N],[14,"span_help","","",N,N],[14,"help","","",N,N],[14,"register_diagnostics","","",N,N],[14,"register_long_diagnostics","","",N,N],[14,"walk_list","","",N,N],[11,"assert_receiver_is_total_eq","syntax::diagnostics::plugin","",26,N],[11,"assert_receiver_is_total_eq","","",25,N],[11,"assert_receiver_is_total_eq","syntax::diagnostics::plugin::emitter","",10,N],[11,"decode","syntax::diagnostics::plugin","",18,[[["__d"]],["result",["substitutionpart"]]]],[11,"decode","","",17,[[["__d"]],["result",["substitution"]]]],[11,"decode","","",22,[[["__d"]],["result",["level"]]]],[11,"decode","","",15,[[["__d"]],["result",["applicability"]]]],[11,"decode","","",24,[[["__d"]],["result",["diagnostic"]]]],[11,"decode","","",27,[[["__d"]],["result",["subdiagnostic"]]]],[11,"decode","","",16,[[["__d"]],["result",["codesuggestion"]]]],[11,"decode","","",25,[[["__d"]],["result",["diagnosticid"]]]],[11,"eq","","",18,[[["self"],["substitutionpart"]],["bool"]]],[11,"ne","","",18,[[["self"],["substitutionpart"]],["bool"]]],[11,"eq","","",27,[[["self"],["subdiagnostic"]],["bool"]]],[11,"ne","","",27,[[["self"],["subdiagnostic"]],["bool"]]],[11,"eq","","",25,[[["self"],["diagnosticid"]],["bool"]]],[11,"ne","","",25,[[["self"],["diagnosticid"]],["bool"]]],[11,"eq","","",15,[[["self"],["applicability"]],["bool"]]],[11,"eq","","",17,[[["self"],["substitution"]],["bool"]]],[11,"ne","","",17,[[["self"],["substitution"]],["bool"]]],[11,"eq","","",22,[[["self"],["level"]],["bool"]]],[11,"eq","","",24,[[["self"],["diagnostic"]],["bool"]]],[11,"ne","","",24,[[["self"],["diagnostic"]],["bool"]]],[11,"eq","syntax::diagnostics::plugin::emitter","",10,[[["self"],["colorconfig"]],["bool"]]],[11,"eq","syntax::diagnostics::plugin","",16,[[["self"],["codesuggestion"]],["bool"]]],[11,"ne","","",16,[[["self"],["codesuggestion"]],["bool"]]],[11,"eq","","",26,[[["self"],["diagnosticstyledstring"]],["bool"]]],[11,"ne","","",26,[[["self"],["diagnosticstyledstring"]],["bool"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",15,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",326,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",17,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",327,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",16,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::diagnostics::plugin::emitter","",10,[[["self"],["formatter"]],["result",["error"]]]],[11,"new","syntax::diagnostics::plugin","",24,[[["level"],["str"]],["diagnostic"]]],[11,"new_with_code","","",24,[[["level"],["option",["diagnosticid"]],["str"]],["diagnostic"]]],[11,"is_error","","",24,[[["self"]],["bool"]]],[11,"cancel","","Cancel the diagnostic (a structured diagnostic must either be emitted or canceled or it will panic when dropped).",24,N],[11,"cancelled","","",24,[[["self"]],["bool"]]],[11,"span_label","","Add a span/label to be included in the resulting snippet. This is pushed onto the `MultiSpan` that was created when the diagnostic was first built. If you don't call this function at all, and you just supplied a `Span` to create the diagnostic, then the snippet will just include that `Span`, which is called the primary span.",24,[[["self"],["span"],["t"]],["diagnostic"]]],[11,"note_expected_found","","",24,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"]],["diagnostic"]]],[11,"note_expected_found_extra","","",24,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"],["display"],["display"]],["diagnostic"]]],[11,"note_trait_signature","","",24,[[["self"],["string"],["string"]],["diagnostic"]]],[11,"note","","",24,[[["self"],["str"]],["diagnostic"]]],[11,"highlighted_note","","",24,[[["self"],["vec"]],["diagnostic"]]],[11,"span_note","","",24,[[["self"],["s"],["str"]],["diagnostic"]]],[11,"warn","","",24,[[["self"],["str"]],["diagnostic"]]],[11,"span_warn","","",24,[[["self"],["s"],["str"]],["diagnostic"]]],[11,"help","","",24,[[["self"],["str"]],["diagnostic"]]],[11,"span_help","","",24,[[["self"],["s"],["str"]],["diagnostic"]]],[11,"span_suggestion_short","","Prints out a message with a suggested edit of the code. If the suggestion is presented inline it will only show the text message and not the text.",24,[[["self"],["span"],["str"],["string"]],["diagnostic"]]],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",24,[[["self"],["span"],["str"],["string"]],["diagnostic"]]],[11,"multipart_suggestion","","",24,[[["self"],["str"],["vec"]],["diagnostic"]]],[11,"span_suggestions","","Prints out a message with multiple suggested edits of the code.",24,[[["self"],["span"],["str"],["vec",["string"]]],["diagnostic"]]],[11,"span_suggestion_with_applicability","","This is a suggestion that may contain mistakes or fillers and should be read and understood by a human.",24,[[["self"],["span"],["str"],["string"],["applicability"]],["diagnostic"]]],[11,"span_suggestions_with_applicability","","",24,[[["self"],["span"],["str"],["vec",["string"]],["applicability"]],["diagnostic"]]],[11,"span_suggestion_short_with_applicability","","",24,[[["self"],["span"],["str"],["string"],["applicability"]],["diagnostic"]]],[11,"set_span","","",24,[[["self"],["s"]],["diagnostic"]]],[11,"code","","",24,[[["self"],["diagnosticid"]],["diagnostic"]]],[11,"get_code","","",24,[[["self"]],["option",["diagnosticid"]]]],[11,"message","","",24,[[["self"]],["string"]]],[11,"styled_message","","",24,[[["self"]],["vec"]]],[11,"copy_details_not_message","","Used by a lint. Copies over all details but the \"main message\".",24,N],[11,"sub","","Convenience function for internal use, clients should use one of the public methods above.",24,N],[11,"deref","","",23,[[["self"]],["diagnostic"]]],[11,"description","","",327,[[["self"]],["str"]]],[11,"description","","",326,[[["self"]],["str"]]],[11,"drop","syntax::diagnostics::plugin::emitter","",13,N],[11,"drop","syntax::diagnostics::plugin","",20,N],[11,"drop","","",23,N],[11,"hash","","",15,N],[11,"hash","","",27,N],[11,"hash","","",25,N],[11,"hash","","",16,N],[11,"hash","","",22,N],[11,"hash","","",24,N],[11,"hash","","",18,N],[11,"hash","","",17,N],[11,"fmt","","",327,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",326,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",22,[[["self"],["formatter"]],["result",["error"]]]],[11,"encode","","",17,[[["self"],["__s"]],["result"]]],[11,"encode","","",16,[[["self"],["__s"]],["result"]]],[11,"encode","","",27,[[["self"],["__s"]],["result"]]],[11,"encode","","",15,[[["self"],["__s"]],["result"]]],[11,"encode","","",22,[[["self"],["__s"]],["result"]]],[11,"encode","","",24,[[["self"],["__s"]],["result"]]],[11,"encode","","",18,[[["self"],["__s"]],["result"]]],[11,"encode","","",25,[[["self"],["__s"]],["result"]]],[11,"clone","","",27,[[["self"]],["subdiagnostic"]]],[11,"clone","","",24,[[["self"]],["diagnostic"]]],[11,"clone","","",22,[[["self"]],["level"]]],[11,"clone","","",17,[[["self"]],["substitution"]]],[11,"clone","","",16,[[["self"]],["codesuggestion"]]],[11,"clone","","",326,[[["self"]],["fatalerror"]]],[11,"clone","","",25,[[["self"]],["diagnosticid"]]],[11,"clone","syntax::diagnostics::plugin::emitter","",10,[[["self"]],["colorconfig"]]],[11,"clone","syntax::diagnostics::plugin","",23,[[["self"]],["diagnosticbuilder"]]],[11,"clone","","",15,[[["self"]],["applicability"]]],[11,"clone","","",18,[[["self"]],["substitutionpart"]]],[11,"clone","syntax::diagnostics::plugin::registry","",14,[[["self"]],["registry"]]],[11,"clone","syntax::diagnostics::plugin","",327,[[["self"]],["explicitbug"]]],[11,"deref_mut","","",23,[[["self"]],["diagnostic"]]],[11,"default","","",21,[[],["handlerflags"]]],[11,"emit","syntax::diagnostics::plugin::emitter","",11,N],[11,"should_show_explain","","",11,[[["self"]],["bool"]]],[11,"write","","",13,N],[11,"flush","","",13,[[["self"]],["result",["error"]]]],[11,"decode","syntax","",0,[[["__dt"]],["result",["thinvec"]]]],[11,"encode","","",0,[[["self"],["__st"]],["result"]]],[11,"from","","",0,[[["vec"]],["thinvec"]]],[11,"deref","","",0,N],[11,"assert_receiver_is_total_eq","","",0,N],[11,"eq","","",0,[[["self"],["thinvec"]],["bool"]]],[11,"ne","","",0,[[["self"],["thinvec"]],["bool"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result",["error"]]]],[11,"hash","","",0,N],[11,"extend","","",0,N],[11,"into","","",0,[[["self"]],["vec"]]],[11,"clone","","",0,[[["self"]],["thinvec"]]],[11,"cmp","syntax::source_map","",168,[[["self"],["spandata"]],["ordering"]]],[11,"cmp","","",177,[[["self"],["charpos"]],["ordering"]]],[11,"cmp","syntax::source_map::symbol","",3,[[["self"],["symbol"]],["ordering"]]],[11,"cmp","syntax::ext::quote::rt","",189,[[["self"],["span"]],["ordering"]]],[11,"cmp","","",176,[[["self"],["bytepos"]],["ordering"]]],[11,"cmp","syntax::source_map::symbol","",6,[[["self"],["localinternedstring"]],["ordering"]]],[11,"cmp","syntax::ext::hygiene","",160,[[["self"],["syntaxcontext"]],["ordering"]]],[11,"cmp","syntax::ext::quote::rt","",167,[[["self"],["filename"]],["ordering"]]],[11,"cmp","syntax::source_map::symbol","",7,[[["self"],["internedstring"]],["ordering"]]],[11,"assert_receiver_is_total_eq","syntax::source_map","",171,N],[11,"assert_receiver_is_total_eq","","",187,N],[11,"assert_receiver_is_total_eq","syntax::source_map::symbol","",2,N],[11,"assert_receiver_is_total_eq","syntax::source_map","",186,N],[11,"assert_receiver_is_total_eq","","",182,N],[11,"assert_receiver_is_total_eq","","",168,N],[11,"assert_receiver_is_total_eq","syntax::ext::quote::rt","",167,N],[11,"assert_receiver_is_total_eq","syntax::source_map","",177,N],[11,"assert_receiver_is_total_eq","","",173,N],[11,"assert_receiver_is_total_eq","syntax::source_map::symbol::keywords","",5,N],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",161,N],[11,"assert_receiver_is_total_eq","","",162,N],[11,"assert_receiver_is_total_eq","syntax::ext::quote::rt","",176,N],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",165,N],[11,"assert_receiver_is_total_eq","syntax::source_map","",172,N],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",164,N],[11,"assert_receiver_is_total_eq","syntax::source_map","",185,N],[11,"assert_receiver_is_total_eq","","",169,N],[11,"assert_receiver_is_total_eq","syntax::source_map::symbol","",7,N],[11,"assert_receiver_is_total_eq","","",6,N],[11,"assert_receiver_is_total_eq","","",3,N],[11,"assert_receiver_is_total_eq","syntax::source_map","",188,N],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",160,N],[11,"eq","syntax::source_map","",171,[[["self"],["multibytechar"]],["bool"]]],[11,"ne","","",171,[[["self"],["multibytechar"]],["bool"]]],[11,"eq","syntax::ext::quote::rt","",189,[[["self"],["span"]],["bool"]]],[11,"eq","syntax::source_map::symbol::keywords","",5,[[["self"],["keyword"]],["bool"]]],[11,"ne","","",5,[[["self"],["keyword"]],["bool"]]],[11,"eq","syntax::source_map::symbol","",3,[[["self"],["symbol"]],["bool"]]],[11,"ne","","",3,[[["self"],["symbol"]],["bool"]]],[11,"eq","","",7,[[["self"],["internedstring"]],["bool"]]],[11,"eq","","",6,[[["self"],["t"]],["bool"]]],[11,"eq","syntax::ext::hygiene","",161,[[["self"],["mark"]],["bool"]]],[11,"ne","","",161,[[["self"],["mark"]],["bool"]]],[11,"eq","syntax::source_map","",186,[[["self"],["spansnippeterror"]],["bool"]]],[11,"ne","","",186,[[["self"],["spansnippeterror"]],["bool"]]],[11,"eq","syntax::source_map::symbol","",3,[[["self"],["t"]],["bool"]]],[11,"eq","syntax::ext::hygiene","",164,[[["self"],["expnformat"]],["bool"]]],[11,"ne","","",164,[[["self"],["expnformat"]],["bool"]]],[11,"eq","","",165,[[["self"],["compilerdesugaringkind"]],["bool"]]],[11,"eq","syntax::source_map","",172,[[["self"],["nonnarrowchar"]],["bool"]]],[11,"ne","","",172,[[["self"],["nonnarrowchar"]],["bool"]]],[11,"eq","","",169,[[["self"],["multispan"]],["bool"]]],[11,"ne","","",169,[[["self"],["multispan"]],["bool"]]],[11,"eq","","",177,[[["self"],["charpos"]],["bool"]]],[11,"ne","","",177,[[["self"],["charpos"]],["bool"]]],[11,"eq","","",188,[[["self"],["malformedcodemappositions"]],["bool"]]],[11,"ne","","",188,[[["self"],["malformedcodemappositions"]],["bool"]]],[11,"eq","","",185,[[["self"],["spanlineserror"]],["bool"]]],[11,"ne","","",185,[[["self"],["spanlineserror"]],["bool"]]],[11,"eq","syntax::ext::quote::rt","",167,[[["self"],["filename"]],["bool"]]],[11,"ne","","",167,[[["self"],["filename"]],["bool"]]],[11,"eq","syntax::source_map","",173,[[["self"],["externalsource"]],["bool"]]],[11,"ne","","",173,[[["self"],["externalsource"]],["bool"]]],[11,"eq","syntax::source_map::symbol","",7,[[["self"],["t"]],["bool"]]],[11,"eq","syntax::source_map","",182,[[["self"],["lineinfo"]],["bool"]]],[11,"ne","","",182,[[["self"],["lineinfo"]],["bool"]]],[11,"eq","","",187,[[["self"],["distinctsources"]],["bool"]]],[11,"ne","","",187,[[["self"],["distinctsources"]],["bool"]]],[11,"eq","syntax::source_map::symbol","",2,[[["self"],["ident"]],["bool"]]],[11,"eq","syntax::source_map::edition","",1,[[["self"],["edition"]],["bool"]]],[11,"eq","syntax::source_map","",168,[[["self"],["spandata"]],["bool"]]],[11,"ne","","",168,[[["self"],["spandata"]],["bool"]]],[11,"eq","syntax::ext::quote::rt","",176,[[["self"],["bytepos"]],["bool"]]],[11,"ne","","",176,[[["self"],["bytepos"]],["bool"]]],[11,"eq","syntax::ext::hygiene","",162,[[["self"],["transparency"]],["bool"]]],[11,"eq","","",160,[[["self"],["syntaxcontext"]],["bool"]]],[11,"ne","","",160,[[["self"],["syntaxcontext"]],["bool"]]],[11,"encode","syntax::source_map::symbol","",6,[[["self"],["s"]],["result"]]],[11,"encode","syntax::ext::hygiene","",161,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::source_map::edition","",1,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::ext::hygiene","",160,[[["self"],["e"]],["result"]]],[11,"encode","","",165,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::ext::quote::rt","",167,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::source_map","",169,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::ext::hygiene","",163,[[["self"],["__s"]],["result"]]],[11,"encode","","",164,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::source_map","",171,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::source_map::symbol","",3,[[["self"],["s"]],["result"]]],[11,"encode","","",2,[[["self"],["s"]],["result"]]],[11,"encode","syntax::source_map","",172,[[["self"],["__s"]],["result"]]],[11,"encode","syntax::source_map::symbol","",7,[[["self"],["s"]],["result"]]],[11,"encode","syntax::source_map","",174,[[["self"],["s"]],["result"]]],[11,"encode","syntax::ext::quote::rt","",176,[[["self"],["s"]],["result"]]],[11,"fmt","syntax::ext::hygiene","",164,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",160,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map","",179,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",187,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",182,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",181,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::hygiene","",165,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map","",185,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map::symbol","",3,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::quote::rt","",176,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map","",186,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map::symbol","",7,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map","",180,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",174,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",169,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map::symbol","",2,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map::edition","",1,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map","",170,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::quote::rt","",189,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::hygiene","",162,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::quote::rt","",167,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map","",188,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::hygiene","",161,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map","",184,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",171,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",172,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",168,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",178,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",177,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::hygiene","",163,[[["self"],["formatter"]],["result",["error"]]]],[11,"from_str","syntax::source_map::symbol::keywords","",5,[[["str"]],["result",["keyword"]]]],[11,"from_str","syntax::source_map::edition","",1,[[["str"]],["result",["edition"]]]],[11,"deref","syntax::source_map::symbol","",6,[[["self"]],["str"]]],[11,"decode","syntax::source_map::edition","",1,[[["__d"]],["result",["edition"]]]],[11,"decode","syntax::source_map::symbol","",7,[[["d"]],["result",["internedstring"]]]],[11,"decode","syntax::ext::hygiene","",163,[[["__d"]],["result",["expninfo"]]]],[11,"decode","","",161,[[["__d"]],["result",["mark"]]]],[11,"decode","syntax::ext::quote::rt","",167,[[["__d"]],["result",["filename"]]]],[11,"decode","syntax::source_map","",169,[[["__d"]],["result",["multispan"]]]],[11,"decode","syntax::ext::hygiene","",164,[[["__d"]],["result",["expnformat"]]]],[11,"decode","syntax::ext::quote::rt","",176,[[["d"]],["result",["bytepos"]]]],[11,"decode","syntax::ext::hygiene","",160,[[["d"]],["result",["syntaxcontext"]]]],[11,"decode","syntax::source_map::symbol","",3,[[["d"]],["result",["symbol"]]]],[11,"decode","","",6,[[["d"]],["result",["localinternedstring"]]]],[11,"decode","syntax::source_map","",174,[[["d"]],["result",["sourcefile"]]]],[11,"decode","","",171,[[["__d"]],["result",["multibytechar"]]]],[11,"decode","syntax::ext::hygiene","",165,[[["__d"]],["result",["compilerdesugaringkind"]]]],[11,"decode","syntax::source_map","",172,[[["__d"]],["result",["nonnarrowchar"]]]],[11,"decode","syntax::source_map::symbol","",2,[[["d"]],["result",["ident"]]]],[11,"as_ref","","",6,[[["self"]],["u"]]],[11,"hash","syntax::ext::hygiene","",161,N],[11,"hash","syntax::ext::quote::rt","",189,N],[11,"hash","syntax::source_map::symbol","",3,N],[11,"hash","syntax::ext::hygiene","",165,N],[11,"hash","syntax::ext::quote::rt","",167,N],[11,"hash","syntax::source_map","",168,N],[11,"hash","syntax::ext::hygiene","",160,N],[11,"hash","syntax::source_map::symbol","",6,N],[11,"hash","syntax::source_map","",169,N],[11,"hash","syntax::ext::quote::rt","",176,N],[11,"hash","syntax::source_map::symbol","",2,N],[11,"hash","syntax::ext::hygiene","",163,N],[11,"hash","syntax::source_map::edition","",1,N],[11,"hash","syntax::source_map::symbol","",7,N],[11,"hash","syntax::source_map","",177,N],[11,"hash","syntax::ext::hygiene","",162,N],[11,"hash","","",164,N],[11,"from","syntax::source_map","",169,[[["span"]],["multispan"]]],[11,"from","syntax::ext::quote::rt","",167,[[["pathbuf"]],["filename"]]],[11,"from","syntax::source_map","",169,[[["vec",["span"]]],["multispan"]]],[11,"partial_cmp","syntax::ext::hygiene","",160,[[["self"],["syntaxcontext"]],["option",["ordering"]]]],[11,"lt","","",160,[[["self"],["syntaxcontext"]],["bool"]]],[11,"le","","",160,[[["self"],["syntaxcontext"]],["bool"]]],[11,"gt","","",160,[[["self"],["syntaxcontext"]],["bool"]]],[11,"ge","","",160,[[["self"],["syntaxcontext"]],["bool"]]],[11,"partial_cmp","syntax::source_map::symbol","",3,[[["self"],["symbol"]],["option",["ordering"]]]],[11,"lt","","",3,[[["self"],["symbol"]],["bool"]]],[11,"le","","",3,[[["self"],["symbol"]],["bool"]]],[11,"gt","","",3,[[["self"],["symbol"]],["bool"]]],[11,"ge","","",3,[[["self"],["symbol"]],["bool"]]],[11,"partial_cmp","syntax::source_map","",168,[[["self"],["spandata"]],["option",["ordering"]]]],[11,"lt","","",168,[[["self"],["spandata"]],["bool"]]],[11,"le","","",168,[[["self"],["spandata"]],["bool"]]],[11,"gt","","",168,[[["self"],["spandata"]],["bool"]]],[11,"ge","","",168,[[["self"],["spandata"]],["bool"]]],[11,"partial_cmp","syntax::ext::quote::rt","",176,[[["self"],["bytepos"]],["option",["ordering"]]]],[11,"lt","","",176,[[["self"],["bytepos"]],["bool"]]],[11,"le","","",176,[[["self"],["bytepos"]],["bool"]]],[11,"gt","","",176,[[["self"],["bytepos"]],["bool"]]],[11,"ge","","",176,[[["self"],["bytepos"]],["bool"]]],[11,"partial_cmp","syntax::source_map::edition","",1,[[["self"],["edition"]],["option",["ordering"]]]],[11,"partial_cmp","syntax::ext::hygiene","",162,[[["self"],["transparency"]],["option",["ordering"]]]],[11,"partial_cmp","syntax::ext::quote::rt","",167,[[["self"],["filename"]],["option",["ordering"]]]],[11,"lt","","",167,[[["self"],["filename"]],["bool"]]],[11,"le","","",167,[[["self"],["filename"]],["bool"]]],[11,"gt","","",167,[[["self"],["filename"]],["bool"]]],[11,"ge","","",167,[[["self"],["filename"]],["bool"]]],[11,"partial_cmp","syntax::source_map::symbol","",7,[[["self"],["internedstring"]],["option",["ordering"]]]],[11,"partial_cmp","syntax::source_map","",177,[[["self"],["charpos"]],["option",["ordering"]]]],[11,"lt","","",177,[[["self"],["charpos"]],["bool"]]],[11,"le","","",177,[[["self"],["charpos"]],["bool"]]],[11,"gt","","",177,[[["self"],["charpos"]],["bool"]]],[11,"ge","","",177,[[["self"],["charpos"]],["bool"]]],[11,"partial_cmp","syntax::source_map::symbol","",6,[[["self"],["localinternedstring"]],["option",["ordering"]]]],[11,"lt","","",6,[[["self"],["localinternedstring"]],["bool"]]],[11,"le","","",6,[[["self"],["localinternedstring"]],["bool"]]],[11,"gt","","",6,[[["self"],["localinternedstring"]],["bool"]]],[11,"ge","","",6,[[["self"],["localinternedstring"]],["bool"]]],[11,"partial_cmp","syntax::ext::quote::rt","",189,[[["self"],["span"]],["option",["ordering"]]]],[11,"fmt","syntax::source_map::edition","",1,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map::symbol","",7,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::ext::quote::rt","",167,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","syntax::source_map::symbol","",2,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result",["error"]]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result",["error"]]]],[11,"default_decode","syntax::ext::quote::rt","",189,[[["d"]],["result",["span"]]]],[11,"clone","syntax::source_map","",174,[[["self"]],["sourcefile"]]],[11,"clone","syntax::ext::hygiene","",163,[[["self"]],["expninfo"]]],[11,"clone","","",160,[[["self"]],["syntaxcontext"]]],[11,"clone","","",162,[[["self"]],["transparency"]]],[11,"clone","syntax::source_map","",171,[[["self"]],["multibytechar"]]],[11,"clone","syntax::source_map::symbol","",7,[[["self"]],["internedstring"]]],[11,"clone","syntax::source_map","",186,[[["self"]],["spansnippeterror"]]],[11,"clone","syntax::ext::quote::rt","",189,[[["self"]],["span"]]],[11,"clone","syntax::source_map","",170,[[["self"]],["spanlabel"]]],[11,"clone","syntax::ext::hygiene","",164,[[["self"]],["expnformat"]]],[11,"clone","","",161,[[["self"]],["mark"]]],[11,"clone","syntax::source_map::symbol","",2,[[["self"]],["ident"]]],[11,"clone","syntax::source_map","",177,[[["self"]],["charpos"]]],[11,"clone","syntax::source_map::symbol","",6,[[["self"]],["localinternedstring"]]],[11,"clone","syntax::source_map","",173,[[["self"]],["externalsource"]]],[11,"clone","syntax::source_map::symbol","",3,[[["self"]],["symbol"]]],[11,"clone","syntax::source_map","",185,[[["self"]],["spanlineserror"]]],[11,"clone","syntax::source_map::edition","",1,[[["self"]],["edition"]]],[11,"clone","syntax::source_map","",182,[[["self"]],["lineinfo"]]],[11,"clone","syntax::source_map::symbol::keywords","",5,[[["self"]],["keyword"]]],[11,"clone","syntax::ext::hygiene","",165,[[["self"]],["compilerdesugaringkind"]]],[11,"clone","syntax::ext::quote::rt","",167,[[["self"]],["filename"]]],[11,"clone","syntax::source_map","",172,[[["self"]],["nonnarrowchar"]]],[11,"clone","","",187,[[["self"]],["distinctsources"]]],[11,"clone","","",188,[[["self"]],["malformedcodemappositions"]]],[11,"clone","","",178,[[["self"]],["loc"]]],[11,"clone","","",169,[[["self"]],["multispan"]]],[11,"clone","","",168,[[["self"]],["spandata"]]],[11,"clone","syntax::ext::quote::rt","",176,[[["self"]],["bytepos"]]],[11,"add","","",176,[[["self"],["bytepos"]],["bytepos"]]],[11,"add","syntax::source_map","",177,[[["self"],["charpos"]],["charpos"]]],[11,"add","","",172,[[["self"],["bytepos"]],["nonnarrowchar"]]],[11,"default","syntax::ext::quote::rt","",189,[[],["span"]]],[11,"default","syntax::ext::hygiene","",160,[[],["syntaxcontext"]]],[11,"from_usize","syntax::ext::quote::rt","",176,[[["usize"]],["bytepos"]]],[11,"to_usize","","",176,[[["self"]],["usize"]]],[11,"from_u32","","",176,[[["u32"]],["bytepos"]]],[11,"to_u32","","",176,[[["self"]],["u32"]]],[11,"from_usize","syntax::source_map","",177,[[["usize"]],["charpos"]]],[11,"to_usize","","",177,[[["self"]],["usize"]]],[11,"from_u32","","",177,[[["u32"]],["charpos"]]],[11,"to_u32","","",177,[[["self"]],["u32"]]],[11,"default_encode","syntax::ext::quote::rt","",189,[[["self"],["s"]],["result"]]],[11,"sub","syntax::source_map","",172,[[["self"],["bytepos"]],["nonnarrowchar"]]],[11,"sub","syntax::ext::quote::rt","",176,[[["self"],["bytepos"]],["bytepos"]]],[11,"sub","syntax::source_map","",177,[[["self"],["charpos"]],["charpos"]]],[11,"assert_receiver_is_total_eq","syntax::ast","",45,N],[11,"partial_cmp","","",45,[[["self"],["floatty"]],["option",["ordering"]]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result",["error"]]]],[11,"cmp","","",45,[[["self"],["floatty"]],["ordering"]]],[11,"decode","","",45,[[["__d"]],["result",["floatty"]]]],[11,"eq","","",45,[[["self"],["floatty"]],["bool"]]],[11,"fmt","","",45,[[["self"],["formatter"]],["result",["error"]]]],[11,"hash","","",45,N],[11,"encode","","",45,[[["self"],["__s"]],["result"]]],[11,"clone","","",45,[[["self"]],["floatty"]]],[11,"new","syntax","",0,[[],["thinvec"]]],[11,"to_owned","","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"encode","","",0,[[["self"],["e"]],["result"]]],[11,"decode","","",0,[[["d"]],["result"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"lint_name","syntax::source_map::edition","",1,[[["self"]],["str"]]],[11,"feature_name","","",1,[[["self"]],["str"]]],[11,"is_stable","","",1,[[["self"]],["bool"]]],[11,"to_owned","","",1,[[["self"]],["t"]]],[11,"clone_into","","",1,N],[11,"from","","",1,[[["t"]],["t"]]],[11,"to_string","","",1,[[["self"]],["string"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"encode","","",1,[[["self"],["e"]],["result"]]],[11,"decode","","",1,[[["d"]],["result"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"new","syntax::source_map::symbol","",2,[[["symbol"],["span"]],["ident"]]],[11,"with_empty_ctxt","","",2,[[["symbol"]],["ident"]]],[11,"from_interned_str","","Maps an interned string to an identifier with an empty syntax context.",2,[[["internedstring"]],["ident"]]],[11,"from_str","","Maps a string to an identifier with an empty syntax context.",2,[[["str"]],["ident"]]],[11,"with_span_pos","","Replace `lo` and `hi` with those from `span`, but keep hygiene context.",2,[[["self"],["span"]],["ident"]]],[11,"without_first_quote","","",2,[[["self"]],["ident"]]],[11,"modern","","\"Normalize\" ident for use in comparisons using \"item hygiene\". Identifiers with same string value become same if they came from the same \"modern\" macro (e.g. `macro` item, but not `macro_rules` item) and stay different if they came from different \"modern\" macros. Technically, this operation strips all non-opaque marks from ident's syntactic context.",2,[[["self"]],["ident"]]],[11,"modern_and_legacy","","\"Normalize\" ident for use in comparisons using \"local variable hygiene\". Identifiers with same string value become same if they came from the same non-transparent macro (e.g. `macro` or `macro_rules!` items) and stay different if they came from different non-transparent macros. Technically, this operation strips all transparent marks from ident's syntactic context.",2,[[["self"]],["ident"]]],[11,"gensym","","",2,[[["self"]],["ident"]]],[11,"as_str","","",2,[[["self"]],["localinternedstring"]]],[11,"as_interned_str","","",2,[[["self"]],["internedstring"]]],[11,"is_special","","",2,[[["self"]],["bool"]]],[11,"is_used_keyword","","Returns `true` if the token is a keyword used in the language.",2,[[["self"]],["bool"]]],[11,"is_unused_keyword","","Returns `true` if the token is a keyword reserved for possible future use.",2,[[["self"]],["bool"]]],[11,"is_reserved","","Returns `true` if the token is either a special identifier or a keyword.",2,[[["self"]],["bool"]]],[11,"is_path_segment_keyword","","A keyword or reserved identifier that can be used as a path segment.",2,[[["self"]],["bool"]]],[11,"is_raw_guess","","",2,[[["self"]],["bool"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"to_string","","",2,[[["self"]],["string"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"encode","","",2,[[["self"],["e"]],["result"]]],[11,"decode","","",2,[[["d"]],["result"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"intern","","Maps a string to its interned representation.",3,[[["str"]],["symbol"]]],[11,"interned","","",3,[[["self"]],["symbol"]]],[11,"gensym","","gensym's a new usize, using the current interner.",3,[[["str"]],["symbol"]]],[11,"gensymed","","",3,[[["self"]],["symbol"]]],[11,"as_str","","",3,[[["self"]],["localinternedstring"]]],[11,"as_interned_str","","",3,[[["self"]],["internedstring"]]],[11,"as_u32","","",3,[[["self"]],["u32"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"to_string","","",3,[[["self"]],["string"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"encode","","",3,[[["self"],["e"]],["result"]]],[11,"decode","","",3,[[["d"]],["result"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"new","","",4,[[],["interner"]]],[11,"intern","","",4,[[["self"],["str"]],["symbol"]]],[11,"interned","","",4,[[["self"],["symbol"]],["symbol"]]],[11,"get","","",4,[[["self"],["symbol"]],["str"]]],[11,"fresh","","",4,[[],["interner"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"ident","syntax::source_map::symbol::keywords","",5,[[["self"]],["ident"]]],[11,"name","","",5,[[["self"]],["symbol"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"as_interned_str","syntax::source_map::symbol","",6,[[["self"]],["internedstring"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"to_string","","",6,[[["self"]],["string"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"encode","","",6,[[["self"],["e"]],["result"]]],[11,"decode","","",6,[[["d"]],["result"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"with","","",7,[[["self"],["f"]],["r"]]],[11,"as_symbol","","",7,[[["self"]],["symbol"]]],[11,"as_str","","",7,[[["self"]],["localinternedstring"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"to_string","","",7,[[["self"]],["string"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"encode","","",7,[[["self"],["e"]],["result"]]],[11,"decode","","",7,[[["d"]],["result"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from","syntax","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::diagnostics::plugin::emitter","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"stderr","","",11,[[["colorconfig"],["option",["rc"]],["bool"],["bool"]],["emitterwriter"]]],[11,"new","","",11,[[["box",["write"]],["option",["rc"]],["bool"],["bool"]],["emitterwriter"]]],[11,"ui_testing","","",11,[[["self"],["bool"]],["emitterwriter"]]],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"new","syntax::diagnostics::plugin::registry","",14,N],[11,"find_description","","",14,[[["self"],["str"]],["option",["str"]]]],[11,"to_owned","","",14,[[["self"]],["t"]]],[11,"clone_into","","",14,N],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::diagnostics::plugin","",15,[[["self"]],["t"]]],[11,"clone_into","","",15,N],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"encode","","",15,[[["self"],["e"]],["result"]]],[11,"decode","","",15,[[["d"]],["result"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"splice_lines","","Returns the assembled code suggestions and whether they should be shown with an underline.",16,[[["self"],["sourcemapper"]],["vec"]]],[11,"to_owned","","",16,[[["self"]],["t"]]],[11,"clone_into","","",16,N],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"encode","","",16,[[["self"],["e"]],["result"]]],[11,"decode","","",16,[[["d"]],["result"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"to_owned","","",17,[[["self"]],["t"]]],[11,"clone_into","","",17,N],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"encode","","",17,[[["self"],["e"]],["result"]]],[11,"decode","","",17,[[["d"]],["result"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"encode","","",18,[[["self"],["e"]],["result"]]],[11,"decode","","",18,[[["d"]],["result"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"raise","","",326,N],[11,"to_owned","","",326,[[["self"]],["t"]]],[11,"clone_into","","",326,N],[11,"from","","",326,[[["t"]],["t"]]],[11,"to_string","","",326,[[["self"]],["string"]]],[11,"into","","",326,[[["self"]],["u"]]],[11,"try_from","","",326,[[["u"]],["result"]]],[11,"borrow","","",326,[[["self"]],["t"]]],[11,"try_into","","",326,[[["self"]],["result"]]],[11,"borrow_mut","","",326,[[["self"]],["t"]]],[11,"get_type_id","","",326,[[["self"]],["typeid"]]],[11,"not_found","","",326,[[["str"],["str"]],["e"]]],[11,"from","","",328,[[["t"]],["t"]]],[11,"into","","",328,[[["self"]],["u"]]],[11,"try_from","","",328,[[["u"]],["result"]]],[11,"borrow","","",328,[[["self"]],["t"]]],[11,"try_into","","",328,[[["self"]],["result"]]],[11,"borrow_mut","","",328,[[["self"]],["t"]]],[11,"get_type_id","","",328,[[["self"]],["typeid"]]],[11,"not_found","","",328,[[["str"],["str"]],["e"]]],[11,"to_owned","","",327,[[["self"]],["t"]]],[11,"clone_into","","",327,N],[11,"from","","",327,[[["t"]],["t"]]],[11,"to_string","","",327,[[["self"]],["string"]]],[11,"into","","",327,[[["self"]],["u"]]],[11,"try_from","","",327,[[["u"]],["result"]]],[11,"borrow","","",327,[[["self"]],["t"]]],[11,"try_into","","",327,[[["self"]],["result"]]],[11,"borrow_mut","","",327,[[["self"]],["t"]]],[11,"get_type_id","","",327,[[["self"]],["typeid"]]],[11,"not_found","","",327,[[["str"],["str"]],["e"]]],[11,"with_tty_emitter","","",20,[[["colorconfig"],["bool"],["bool"],["option",["rc"]]],["handler"]]],[11,"with_tty_emitter_and_flags","","",20,[[["colorconfig"],["option",["rc"]],["handlerflags"]],["handler"]]],[11,"with_emitter","","",20,[[["bool"],["bool"],["box",["emitter"]]],["handler"]]],[11,"with_emitter_and_flags","","",20,[[["box",["emitter"]],["handlerflags"]],["handler"]]],[11,"set_continue_after_error","","",20,N],[11,"reset_err_count","","Resets the diagnostic error count as well as the cached emitted diagnostics.",20,N],[11,"struct_dummy","","",20,[[["self"]],["diagnosticbuilder"]]],[11,"struct_span_warn","","",20,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_warn_with_code","","",20,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_warn","","",20,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err","","",20,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_err_with_code","","",20,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_err","","",20,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"struct_err_with_code","","",20,[[["self"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_span_fatal","","",20,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"struct_span_fatal_with_code","","",20,[[["self"],["s"],["str"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"struct_fatal","","",20,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"cancel","","",20,N],[11,"span_fatal","","",20,[[["self"],["s"],["str"]],["fatalerror"]]],[11,"span_fatal_with_code","","",20,[[["self"],["s"],["str"],["diagnosticid"]],["fatalerror"]]],[11,"span_err","","",20,N],[11,"mut_span_err","","",20,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_err_with_code","","",20,N],[11,"span_warn","","",20,N],[11,"span_warn_with_code","","",20,N],[11,"span_bug","","",20,N],[11,"delay_span_bug","","",20,N],[11,"span_bug_no_panic","","",20,N],[11,"span_note_without_error","","",20,N],[11,"span_note_diag","","",20,[[["self"],["span"],["str"]],["diagnosticbuilder"]]],[11,"span_unimpl","","",20,N],[11,"failure","","",20,N],[11,"fatal","","",20,[[["self"],["str"]],["fatalerror"]]],[11,"err","","",20,N],[11,"warn","","",20,N],[11,"note_without_error","","",20,N],[11,"bug","","",20,N],[11,"unimpl","","",20,N],[11,"err_count","","",20,[[["self"]],["usize"]]],[11,"has_errors","","",20,[[["self"]],["bool"]]],[11,"print_error_count","","",20,N],[11,"abort_if_errors","","",20,N],[11,"emit","","",20,N],[11,"emit_with_code","","",20,N],[11,"must_teach","","`true` if we haven't taught a diagnostic with this code already. The caller must then teach the user about such a diagnostic.",20,[[["self"],["diagnosticid"]],["bool"]]],[11,"force_print_db","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"to_str","","",22,[[["self"]],["str"]]],[11,"is_failure_note","","",22,[[["self"]],["bool"]]],[11,"to_owned","","",22,[[["self"]],["t"]]],[11,"clone_into","","",22,N],[11,"from","","",22,[[["t"]],["t"]]],[11,"to_string","","",22,[[["self"]],["string"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"encode","","",22,[[["self"],["e"]],["result"]]],[11,"decode","","",22,[[["d"]],["result"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"emit","","Emit the diagnostic.",23,N],[11,"buffer","","Buffers the diagnostic for later emission.",23,N],[11,"sub","","Convenience function for internal use, clients should use one of the span_* methods instead.",23,[[["self"],["level"],["str"],["option"]],["diagnosticbuilder"]]],[11,"delay_as_bug","","Delay emission of this diagnostic as a bug.",23,N],[11,"span_label","","Add a span/label to be included in the resulting snippet. This is pushed onto the `MultiSpan` that was created when the diagnostic was first built. If you don't call this function at all, and you just supplied a `Span` to create the diagnostic, then the snippet will just include that `Span`, which is called the primary span.",23,[[["self"],["span"],["t"]],["diagnosticbuilder"]]],[11,"note_expected_found","","",23,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"]],["diagnosticbuilder"]]],[11,"note_expected_found_extra","","",23,[[["self"],["display"],["diagnosticstyledstring"],["diagnosticstyledstring"],["display"],["display"]],["diagnosticbuilder"]]],[11,"note","","",23,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"span_note","","",23,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"warn","","",23,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"span_warn","","",23,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"help","","",23,[[["self"],["str"]],["diagnosticbuilder"]]],[11,"span_help","","",23,[[["self"],["s"],["str"]],["diagnosticbuilder"]]],[11,"span_suggestion_short","","",23,[[["self"],["span"],["str"],["string"]],["diagnosticbuilder"]]],[11,"multipart_suggestion","","",23,[[["self"],["str"],["vec"]],["diagnosticbuilder"]]],[11,"span_suggestion","","",23,[[["self"],["span"],["str"],["string"]],["diagnosticbuilder"]]],[11,"span_suggestions","","",23,[[["self"],["span"],["str"],["vec",["string"]]],["diagnosticbuilder"]]],[11,"span_suggestion_with_applicability","","",23,[[["self"],["span"],["str"],["string"],["applicability"]],["diagnosticbuilder"]]],[11,"span_suggestions_with_applicability","","",23,[[["self"],["span"],["str"],["vec",["string"]],["applicability"]],["diagnosticbuilder"]]],[11,"span_suggestion_short_with_applicability","","",23,[[["self"],["span"],["str"],["string"],["applicability"]],["diagnosticbuilder"]]],[11,"set_span","","",23,[[["self"],["s"]],["diagnosticbuilder"]]],[11,"code","","",23,[[["self"],["diagnosticid"]],["diagnosticbuilder"]]],[11,"allow_suggestions","","",23,[[["self"],["bool"]],["diagnosticbuilder"]]],[11,"new","","Convenience function for internal use, clients should use one of the struct_* methods on Handler.",23,[[["handler"],["level"],["str"]],["diagnosticbuilder"]]],[11,"new_with_code","","Convenience function for internal use, clients should use one of the struct_* methods on Handler.",23,[[["handler"],["level"],["option",["diagnosticid"]],["str"]],["diagnosticbuilder"]]],[11,"new_diagnostic","","Creates a new `DiagnosticBuilder` with an already constructed diagnostic.",23,[[["handler"],["diagnostic"]],["diagnosticbuilder"]]],[11,"to_owned","","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"to_owned","","",24,[[["self"]],["t"]]],[11,"clone_into","","",24,N],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"encode","","",24,[[["self"],["e"]],["result"]]],[11,"decode","","",24,[[["d"]],["result"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"to_owned","","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"encode","","",25,[[["self"],["e"]],["result"]]],[11,"decode","","",25,[[["d"]],["result"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"new","","",26,[[],["diagnosticstyledstring"]]],[11,"push_normal","","",26,N],[11,"push_highlighted","","",26,N],[11,"normal","","",26,[[["s"]],["diagnosticstyledstring"]]],[11,"highlighted","","",26,[[["s"]],["diagnosticstyledstring"]]],[11,"content","","",26,[[["self"]],["string"]]],[11,"from","","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"message","","",27,[[["self"]],["string"]]],[11,"styled_message","","",27,[[["self"]],["vec"]]],[11,"to_owned","","",27,[[["self"]],["t"]]],[11,"clone_into","","",27,N],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"encode","","",27,[[["self"],["e"]],["result"]]],[11,"decode","","",27,[[["d"]],["result"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from","syntax::diagnostics::metadata","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"encode","","",29,[[["self"],["e"]],["result"]]],[11,"decode","","",29,[[["d"]],["result"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"encode","","",30,[[["self"],["e"]],["result"]]],[11,"decode","","",30,[[["d"]],["result"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::util","",31,[[["self"]],["t"]]],[11,"clone_into","","",31,N],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"to_owned","","",32,[[["self"]],["t"]]],[11,"clone_into","","",32,N],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from","syntax::util::node_count","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"from","syntax::util::parser","",34,[[["t"]],["t"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"from","","",35,[[["t"]],["t"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"to_owned","","",36,[[["self"]],["t"]]],[11,"clone_into","","",36,N],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"move_flat_map","syntax::ptr","",243,[[["self"],["f"]],["self"]]],[11,"from","syntax::json","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]],[11,"from","","",40,[[["t"]],["t"]]],[11,"into","","",40,[[["self"]],["u"]]],[11,"try_from","","",40,[[["u"]],["result"]]],[11,"borrow","","",40,[[["self"]],["t"]]],[11,"try_into","","",40,[[["self"]],["result"]]],[11,"borrow_mut","","",40,[[["self"]],["t"]]],[11,"get_type_id","","",40,[[["self"]],["typeid"]]],[11,"encode","","",40,[[["self"],["e"]],["result"]]],[11,"not_found","","",40,[[["str"],["str"]],["e"]]],[11,"from","","",41,[[["t"]],["t"]]],[11,"into","","",41,[[["self"]],["u"]]],[11,"try_from","","",41,[[["u"]],["result"]]],[11,"borrow","","",41,[[["self"]],["t"]]],[11,"try_into","","",41,[[["self"]],["result"]]],[11,"borrow_mut","","",41,[[["self"]],["t"]]],[11,"get_type_id","","",41,[[["self"]],["typeid"]]],[11,"encode","","",41,[[["self"],["e"]],["result"]]],[11,"not_found","","",41,[[["str"],["str"]],["e"]]],[11,"from","","",42,[[["t"]],["t"]]],[11,"into","","",42,[[["self"]],["u"]]],[11,"try_from","","",42,[[["u"]],["result"]]],[11,"borrow","","",42,[[["self"]],["t"]]],[11,"try_into","","",42,[[["self"]],["result"]]],[11,"borrow_mut","","",42,[[["self"]],["t"]]],[11,"get_type_id","","",42,[[["self"]],["typeid"]]],[11,"encode","","",42,[[["self"],["e"]],["result"]]],[11,"not_found","","",42,[[["str"],["str"]],["e"]]],[11,"from","","",43,[[["t"]],["t"]]],[11,"into","","",43,[[["self"]],["u"]]],[11,"try_from","","",43,[[["u"]],["result"]]],[11,"borrow","","",43,[[["self"]],["t"]]],[11,"try_into","","",43,[[["self"]],["result"]]],[11,"borrow_mut","","",43,[[["self"]],["t"]]],[11,"get_type_id","","",43,[[["self"]],["typeid"]]],[11,"encode","","",43,[[["self"],["e"]],["result"]]],[11,"not_found","","",43,[[["str"],["str"]],["e"]]],[11,"from","","",44,[[["t"]],["t"]]],[11,"into","","",44,[[["self"]],["u"]]],[11,"try_from","","",44,[[["u"]],["result"]]],[11,"borrow","","",44,[[["self"]],["t"]]],[11,"try_into","","",44,[[["self"]],["result"]]],[11,"borrow_mut","","",44,[[["self"]],["t"]]],[11,"get_type_id","","",44,[[["self"]],["typeid"]]],[11,"encode","","",44,[[["self"],["e"]],["result"]]],[11,"not_found","","",44,[[["str"],["str"]],["e"]]],[11,"ty_to_string","syntax::ast","",45,[[["self"]],["str"]]],[11,"bit_width","","",45,[[["self"]],["usize"]]],[11,"to_owned","","",45,[[["self"]],["t"]]],[11,"clone_into","","",45,N],[11,"from","","",45,[[["t"]],["t"]]],[11,"to_string","","",45,[[["self"]],["string"]]],[11,"into","","",45,[[["self"]],["u"]]],[11,"try_from","","",45,[[["u"]],["result"]]],[11,"borrow","","",45,[[["self"]],["t"]]],[11,"try_into","","",45,[[["self"]],["result"]]],[11,"borrow_mut","","",45,[[["self"]],["t"]]],[11,"get_type_id","","",45,[[["self"]],["typeid"]]],[11,"encode","","",45,[[["self"],["e"]],["result"]]],[11,"decode","","",45,[[["d"]],["result"]]],[11,"not_found","","",45,[[["str"],["str"]],["e"]]],[11,"to_owned","","",46,[[["self"]],["t"]]],[11,"clone_into","","",46,N],[11,"from","","",46,[[["t"]],["t"]]],[11,"into","","",46,[[["self"]],["u"]]],[11,"try_from","","",46,[[["u"]],["result"]]],[11,"borrow","","",46,[[["self"]],["t"]]],[11,"try_into","","",46,[[["self"]],["result"]]],[11,"borrow_mut","","",46,[[["self"]],["t"]]],[11,"get_type_id","","",46,[[["self"]],["typeid"]]],[11,"encode","","",46,[[["self"],["e"]],["result"]]],[11,"decode","","",46,[[["d"]],["result"]]],[11,"not_found","","",46,[[["str"],["str"]],["e"]]],[11,"to_owned","","",47,[[["self"]],["t"]]],[11,"clone_into","","",47,N],[11,"from","","",47,[[["t"]],["t"]]],[11,"into","","",47,[[["self"]],["u"]]],[11,"try_from","","",47,[[["u"]],["result"]]],[11,"borrow","","",47,[[["self"]],["t"]]],[11,"try_into","","",47,[[["self"]],["result"]]],[11,"borrow_mut","","",47,[[["self"]],["t"]]],[11,"get_type_id","","",47,[[["self"]],["typeid"]]],[11,"encode","","",47,[[["self"],["e"]],["result"]]],[11,"decode","","",47,[[["d"]],["result"]]],[11,"not_found","","",47,[[["str"],["str"]],["e"]]],[11,"to_owned","","",48,[[["self"]],["t"]]],[11,"clone_into","","",48,N],[11,"from","","",48,[[["t"]],["t"]]],[11,"to_string","","",48,[[["self"]],["string"]]],[11,"into","","",48,[[["self"]],["u"]]],[11,"try_from","","",48,[[["u"]],["result"]]],[11,"borrow","","",48,[[["self"]],["t"]]],[11,"try_into","","",48,[[["self"]],["result"]]],[11,"borrow_mut","","",48,[[["self"]],["t"]]],[11,"get_type_id","","",48,[[["self"]],["typeid"]]],[11,"encode","","",48,[[["self"],["e"]],["result"]]],[11,"decode","","",48,[[["d"]],["result"]]],[11,"not_found","","",48,[[["str"],["str"]],["e"]]],[11,"to_owned","","",49,[[["self"]],["t"]]],[11,"clone_into","","",49,N],[11,"from","","",49,[[["t"]],["t"]]],[11,"into","","",49,[[["self"]],["u"]]],[11,"try_from","","",49,[[["u"]],["result"]]],[11,"borrow","","",49,[[["self"]],["t"]]],[11,"try_into","","",49,[[["self"]],["result"]]],[11,"borrow_mut","","",49,[[["self"]],["t"]]],[11,"get_type_id","","",49,[[["self"]],["typeid"]]],[11,"encode","","",49,[[["self"],["e"]],["result"]]],[11,"decode","","",49,[[["d"]],["result"]]],[11,"not_found","","",49,[[["str"],["str"]],["e"]]],[11,"to_owned","","",50,[[["self"]],["t"]]],[11,"clone_into","","",50,N],[11,"from","","",50,[[["t"]],["t"]]],[11,"into","","",50,[[["self"]],["u"]]],[11,"try_from","","",50,[[["u"]],["result"]]],[11,"borrow","","",50,[[["self"]],["t"]]],[11,"try_into","","",50,[[["self"]],["result"]]],[11,"borrow_mut","","",50,[[["self"]],["t"]]],[11,"get_type_id","","",50,[[["self"]],["typeid"]]],[11,"encode","","",50,[[["self"],["e"]],["result"]]],[11,"decode","","",50,[[["d"]],["result"]]],[11,"not_found","","",50,[[["str"],["str"]],["e"]]],[11,"to_owned","","",51,[[["self"]],["t"]]],[11,"clone_into","","",51,N],[11,"from","","",51,[[["t"]],["t"]]],[11,"into","","",51,[[["self"]],["u"]]],[11,"try_from","","",51,[[["u"]],["result"]]],[11,"borrow","","",51,[[["self"]],["t"]]],[11,"try_into","","",51,[[["self"]],["result"]]],[11,"borrow_mut","","",51,[[["self"]],["t"]]],[11,"get_type_id","","",51,[[["self"]],["typeid"]]],[11,"encode","","",51,[[["self"],["e"]],["result"]]],[11,"decode","","",51,[[["d"]],["result"]]],[11,"not_found","","",51,[[["str"],["str"]],["e"]]],[11,"to_owned","","",52,[[["self"]],["t"]]],[11,"clone_into","","",52,N],[11,"from","","",52,[[["t"]],["t"]]],[11,"to_string","","",52,[[["self"]],["string"]]],[11,"into","","",52,[[["self"]],["u"]]],[11,"try_from","","",52,[[["u"]],["result"]]],[11,"borrow","","",52,[[["self"]],["t"]]],[11,"try_into","","",52,[[["self"]],["result"]]],[11,"borrow_mut","","",52,[[["self"]],["t"]]],[11,"get_type_id","","",52,[[["self"]],["typeid"]]],[11,"encode","","",52,[[["self"],["e"]],["result"]]],[11,"decode","","",52,[[["d"]],["result"]]],[11,"not_found","","",52,[[["str"],["str"]],["e"]]],[11,"to_owned","","",53,[[["self"]],["t"]]],[11,"clone_into","","",53,N],[11,"from","","",53,[[["t"]],["t"]]],[11,"into","","",53,[[["self"]],["u"]]],[11,"try_from","","",53,[[["u"]],["result"]]],[11,"borrow","","",53,[[["self"]],["t"]]],[11,"try_into","","",53,[[["self"]],["result"]]],[11,"borrow_mut","","",53,[[["self"]],["t"]]],[11,"get_type_id","","",53,[[["self"]],["typeid"]]],[11,"encode","","",53,[[["self"],["e"]],["result"]]],[11,"decode","","",53,[[["d"]],["result"]]],[11,"not_found","","",53,[[["str"],["str"]],["e"]]],[11,"to_owned","","",54,[[["self"]],["t"]]],[11,"clone_into","","",54,N],[11,"from","","",54,[[["t"]],["t"]]],[11,"into","","",54,[[["self"]],["u"]]],[11,"try_from","","",54,[[["u"]],["result"]]],[11,"borrow","","",54,[[["self"]],["t"]]],[11,"try_into","","",54,[[["self"]],["result"]]],[11,"borrow_mut","","",54,[[["self"]],["t"]]],[11,"get_type_id","","",54,[[["self"]],["typeid"]]],[11,"encode","","",54,[[["self"],["e"]],["result"]]],[11,"decode","","",54,[[["d"]],["result"]]],[11,"not_found","","",54,[[["str"],["str"]],["e"]]],[11,"to_owned","","",55,[[["self"]],["t"]]],[11,"clone_into","","",55,N],[11,"from","","",55,[[["t"]],["t"]]],[11,"into","","",55,[[["self"]],["u"]]],[11,"try_from","","",55,[[["u"]],["result"]]],[11,"borrow","","",55,[[["self"]],["t"]]],[11,"try_into","","",55,[[["self"]],["result"]]],[11,"borrow_mut","","",55,[[["self"]],["t"]]],[11,"get_type_id","","",55,[[["self"]],["typeid"]]],[11,"encode","","",55,[[["self"],["e"]],["result"]]],[11,"decode","","",55,[[["d"]],["result"]]],[11,"not_found","","",55,[[["str"],["str"]],["e"]]],[11,"to_owned","","",56,[[["self"]],["t"]]],[11,"clone_into","","",56,N],[11,"from","","",56,[[["t"]],["t"]]],[11,"into","","",56,[[["self"]],["u"]]],[11,"try_from","","",56,[[["u"]],["result"]]],[11,"borrow","","",56,[[["self"]],["t"]]],[11,"try_into","","",56,[[["self"]],["result"]]],[11,"borrow_mut","","",56,[[["self"]],["t"]]],[11,"get_type_id","","",56,[[["self"]],["typeid"]]],[11,"encode","","",56,[[["self"],["e"]],["result"]]],[11,"decode","","",56,[[["d"]],["result"]]],[11,"not_found","","",56,[[["str"],["str"]],["e"]]],[11,"to_owned","","",57,[[["self"]],["t"]]],[11,"clone_into","","",57,N],[11,"from","","",57,[[["t"]],["t"]]],[11,"into","","",57,[[["self"]],["u"]]],[11,"try_from","","",57,[[["u"]],["result"]]],[11,"borrow","","",57,[[["self"]],["t"]]],[11,"try_into","","",57,[[["self"]],["result"]]],[11,"borrow_mut","","",57,[[["self"]],["t"]]],[11,"get_type_id","","",57,[[["self"]],["typeid"]]],[11,"encode","","",57,[[["self"],["e"]],["result"]]],[11,"decode","","",57,[[["d"]],["result"]]],[11,"not_found","","",57,[[["str"],["str"]],["e"]]],[11,"to_owned","","",58,[[["self"]],["t"]]],[11,"clone_into","","",58,N],[11,"from","","",58,[[["t"]],["t"]]],[11,"into","","",58,[[["self"]],["u"]]],[11,"try_from","","",58,[[["u"]],["result"]]],[11,"borrow","","",58,[[["self"]],["t"]]],[11,"try_into","","",58,[[["self"]],["result"]]],[11,"borrow_mut","","",58,[[["self"]],["t"]]],[11,"get_type_id","","",58,[[["self"]],["typeid"]]],[11,"encode","","",58,[[["self"],["e"]],["result"]]],[11,"decode","","",58,[[["d"]],["result"]]],[11,"not_found","","",58,[[["str"],["str"]],["e"]]],[11,"to_owned","","",59,[[["self"]],["t"]]],[11,"clone_into","","",59,N],[11,"from","","",59,[[["t"]],["t"]]],[11,"into","","",59,[[["self"]],["u"]]],[11,"try_from","","",59,[[["u"]],["result"]]],[11,"borrow","","",59,[[["self"]],["t"]]],[11,"try_into","","",59,[[["self"]],["result"]]],[11,"borrow_mut","","",59,[[["self"]],["t"]]],[11,"get_type_id","","",59,[[["self"]],["typeid"]]],[11,"encode","","",59,[[["self"],["e"]],["result"]]],[11,"decode","","",59,[[["d"]],["result"]]],[11,"not_found","","",59,[[["str"],["str"]],["e"]]],[11,"to_owned","","",60,[[["self"]],["t"]]],[11,"clone_into","","",60,N],[11,"from","","",60,[[["t"]],["t"]]],[11,"into","","",60,[[["self"]],["u"]]],[11,"try_from","","",60,[[["u"]],["result"]]],[11,"borrow","","",60,[[["self"]],["t"]]],[11,"try_into","","",60,[[["self"]],["result"]]],[11,"borrow_mut","","",60,[[["self"]],["t"]]],[11,"get_type_id","","",60,[[["self"]],["typeid"]]],[11,"encode","","",60,[[["self"],["e"]],["result"]]],[11,"decode","","",60,[[["d"]],["result"]]],[11,"not_found","","",60,[[["str"],["str"]],["e"]]],[11,"to_owned","","",61,[[["self"]],["t"]]],[11,"clone_into","","",61,N],[11,"from","","",61,[[["t"]],["t"]]],[11,"into","","",61,[[["self"]],["u"]]],[11,"try_from","","",61,[[["u"]],["result"]]],[11,"borrow","","",61,[[["self"]],["t"]]],[11,"try_into","","",61,[[["self"]],["result"]]],[11,"borrow_mut","","",61,[[["self"]],["t"]]],[11,"get_type_id","","",61,[[["self"]],["typeid"]]],[11,"encode","","",61,[[["self"],["e"]],["result"]]],[11,"decode","","",61,[[["d"]],["result"]]],[11,"not_found","","",61,[[["str"],["str"]],["e"]]],[11,"to_owned","","",62,[[["self"]],["t"]]],[11,"clone_into","","",62,N],[11,"from","","",62,[[["t"]],["t"]]],[11,"into","","",62,[[["self"]],["u"]]],[11,"try_from","","",62,[[["u"]],["result"]]],[11,"borrow","","",62,[[["self"]],["t"]]],[11,"try_into","","",62,[[["self"]],["result"]]],[11,"borrow_mut","","",62,[[["self"]],["t"]]],[11,"get_type_id","","",62,[[["self"]],["typeid"]]],[11,"encode","","",62,[[["self"],["e"]],["result"]]],[11,"decode","","",62,[[["d"]],["result"]]],[11,"not_found","","",62,[[["str"],["str"]],["e"]]],[11,"to_owned","","",63,[[["self"]],["t"]]],[11,"clone_into","","",63,N],[11,"from","","",63,[[["t"]],["t"]]],[11,"into","","",63,[[["self"]],["u"]]],[11,"try_from","","",63,[[["u"]],["result"]]],[11,"borrow","","",63,[[["self"]],["t"]]],[11,"try_into","","",63,[[["self"]],["result"]]],[11,"borrow_mut","","",63,[[["self"]],["t"]]],[11,"get_type_id","","",63,[[["self"]],["typeid"]]],[11,"encode","","",63,[[["self"],["e"]],["result"]]],[11,"decode","","",63,[[["d"]],["result"]]],[11,"not_found","","",63,[[["str"],["str"]],["e"]]],[11,"to_owned","","",64,[[["self"]],["t"]]],[11,"clone_into","","",64,N],[11,"from","","",64,[[["t"]],["t"]]],[11,"into","","",64,[[["self"]],["u"]]],[11,"try_from","","",64,[[["u"]],["result"]]],[11,"borrow","","",64,[[["self"]],["t"]]],[11,"try_into","","",64,[[["self"]],["result"]]],[11,"borrow_mut","","",64,[[["self"]],["t"]]],[11,"get_type_id","","",64,[[["self"]],["typeid"]]],[11,"encode","","",64,[[["self"],["e"]],["result"]]],[11,"decode","","",64,[[["d"]],["result"]]],[11,"not_found","","",64,[[["str"],["str"]],["e"]]],[11,"to_owned","","",65,[[["self"]],["t"]]],[11,"clone_into","","",65,N],[11,"from","","",65,[[["t"]],["t"]]],[11,"into","","",65,[[["self"]],["u"]]],[11,"try_from","","",65,[[["u"]],["result"]]],[11,"borrow","","",65,[[["self"]],["t"]]],[11,"try_into","","",65,[[["self"]],["result"]]],[11,"borrow_mut","","",65,[[["self"]],["t"]]],[11,"get_type_id","","",65,[[["self"]],["typeid"]]],[11,"encode","","",65,[[["self"],["e"]],["result"]]],[11,"decode","","",65,[[["d"]],["result"]]],[11,"not_found","","",65,[[["str"],["str"]],["e"]]],[11,"to_owned","","",66,[[["self"]],["t"]]],[11,"clone_into","","",66,N],[11,"from","","",66,[[["t"]],["t"]]],[11,"into","","",66,[[["self"]],["u"]]],[11,"try_from","","",66,[[["u"]],["result"]]],[11,"borrow","","",66,[[["self"]],["t"]]],[11,"try_into","","",66,[[["self"]],["result"]]],[11,"borrow_mut","","",66,[[["self"]],["t"]]],[11,"get_type_id","","",66,[[["self"]],["typeid"]]],[11,"encode","","",66,[[["self"],["e"]],["result"]]],[11,"decode","","",66,[[["d"]],["result"]]],[11,"not_found","","",66,[[["str"],["str"]],["e"]]],[11,"to_owned","","",67,[[["self"]],["t"]]],[11,"clone_into","","",67,N],[11,"from","","",67,[[["t"]],["t"]]],[11,"into","","",67,[[["self"]],["u"]]],[11,"try_from","","",67,[[["u"]],["result"]]],[11,"borrow","","",67,[[["self"]],["t"]]],[11,"try_into","","",67,[[["self"]],["result"]]],[11,"borrow_mut","","",67,[[["self"]],["t"]]],[11,"get_type_id","","",67,[[["self"]],["typeid"]]],[11,"encode","","",67,[[["self"],["e"]],["result"]]],[11,"decode","","",67,[[["d"]],["result"]]],[11,"not_found","","",67,[[["str"],["str"]],["e"]]],[11,"to_owned","","",68,[[["self"]],["t"]]],[11,"clone_into","","",68,N],[11,"from","","",68,[[["t"]],["t"]]],[11,"into","","",68,[[["self"]],["u"]]],[11,"try_from","","",68,[[["u"]],["result"]]],[11,"borrow","","",68,[[["self"]],["t"]]],[11,"try_into","","",68,[[["self"]],["result"]]],[11,"borrow_mut","","",68,[[["self"]],["t"]]],[11,"get_type_id","","",68,[[["self"]],["typeid"]]],[11,"encode","","",68,[[["self"],["e"]],["result"]]],[11,"decode","","",68,[[["d"]],["result"]]],[11,"not_found","","",68,[[["str"],["str"]],["e"]]],[11,"to_owned","","",69,[[["self"]],["t"]]],[11,"clone_into","","",69,N],[11,"from","","",69,[[["t"]],["t"]]],[11,"into","","",69,[[["self"]],["u"]]],[11,"try_from","","",69,[[["u"]],["result"]]],[11,"borrow","","",69,[[["self"]],["t"]]],[11,"try_into","","",69,[[["self"]],["result"]]],[11,"borrow_mut","","",69,[[["self"]],["t"]]],[11,"get_type_id","","",69,[[["self"]],["typeid"]]],[11,"encode","","",69,[[["self"],["e"]],["result"]]],[11,"decode","","",69,[[["d"]],["result"]]],[11,"not_found","","",69,[[["str"],["str"]],["e"]]],[11,"to_owned","","",70,[[["self"]],["t"]]],[11,"clone_into","","",70,N],[11,"from","","",70,[[["t"]],["t"]]],[11,"into","","",70,[[["self"]],["u"]]],[11,"try_from","","",70,[[["u"]],["result"]]],[11,"borrow","","",70,[[["self"]],["t"]]],[11,"try_into","","",70,[[["self"]],["result"]]],[11,"borrow_mut","","",70,[[["self"]],["t"]]],[11,"get_type_id","","",70,[[["self"]],["typeid"]]],[11,"encode","","",70,[[["self"],["e"]],["result"]]],[11,"decode","","",70,[[["d"]],["result"]]],[11,"not_found","","",70,[[["str"],["str"]],["e"]]],[11,"to_owned","","",71,[[["self"]],["t"]]],[11,"clone_into","","",71,N],[11,"from","","",71,[[["t"]],["t"]]],[11,"into","","",71,[[["self"]],["u"]]],[11,"try_from","","",71,[[["u"]],["result"]]],[11,"borrow","","",71,[[["self"]],["t"]]],[11,"try_into","","",71,[[["self"]],["result"]]],[11,"borrow_mut","","",71,[[["self"]],["t"]]],[11,"get_type_id","","",71,[[["self"]],["typeid"]]],[11,"encode","","",71,[[["self"],["e"]],["result"]]],[11,"decode","","",71,[[["d"]],["result"]]],[11,"not_found","","",71,[[["str"],["str"]],["e"]]],[11,"to_owned","","",72,[[["self"]],["t"]]],[11,"clone_into","","",72,N],[11,"from","","",72,[[["t"]],["t"]]],[11,"into","","",72,[[["self"]],["u"]]],[11,"try_from","","",72,[[["u"]],["result"]]],[11,"borrow","","",72,[[["self"]],["t"]]],[11,"try_into","","",72,[[["self"]],["result"]]],[11,"borrow_mut","","",72,[[["self"]],["t"]]],[11,"get_type_id","","",72,[[["self"]],["typeid"]]],[11,"encode","","",72,[[["self"],["e"]],["result"]]],[11,"decode","","",72,[[["d"]],["result"]]],[11,"not_found","","",72,[[["str"],["str"]],["e"]]],[11,"to_owned","","",73,[[["self"]],["t"]]],[11,"clone_into","","",73,N],[11,"from","","",73,[[["t"]],["t"]]],[11,"into","","",73,[[["self"]],["u"]]],[11,"try_from","","",73,[[["u"]],["result"]]],[11,"borrow","","",73,[[["self"]],["t"]]],[11,"try_into","","",73,[[["self"]],["result"]]],[11,"borrow_mut","","",73,[[["self"]],["t"]]],[11,"get_type_id","","",73,[[["self"]],["typeid"]]],[11,"encode","","",73,[[["self"],["e"]],["result"]]],[11,"decode","","",73,[[["d"]],["result"]]],[11,"not_found","","",73,[[["str"],["str"]],["e"]]],[11,"to_owned","","",74,[[["self"]],["t"]]],[11,"clone_into","","",74,N],[11,"from","","",74,[[["t"]],["t"]]],[11,"into","","",74,[[["self"]],["u"]]],[11,"try_from","","",74,[[["u"]],["result"]]],[11,"borrow","","",74,[[["self"]],["t"]]],[11,"try_into","","",74,[[["self"]],["result"]]],[11,"borrow_mut","","",74,[[["self"]],["t"]]],[11,"get_type_id","","",74,[[["self"]],["typeid"]]],[11,"encode","","",74,[[["self"],["e"]],["result"]]],[11,"decode","","",74,[[["d"]],["result"]]],[11,"not_found","","",74,[[["str"],["str"]],["e"]]],[11,"to_owned","","",75,[[["self"]],["t"]]],[11,"clone_into","","",75,N],[11,"from","","",75,[[["t"]],["t"]]],[11,"into","","",75,[[["self"]],["u"]]],[11,"try_from","","",75,[[["u"]],["result"]]],[11,"borrow","","",75,[[["self"]],["t"]]],[11,"try_into","","",75,[[["self"]],["result"]]],[11,"borrow_mut","","",75,[[["self"]],["t"]]],[11,"get_type_id","","",75,[[["self"]],["typeid"]]],[11,"encode","","",75,[[["self"],["e"]],["result"]]],[11,"decode","","",75,[[["d"]],["result"]]],[11,"not_found","","",75,[[["str"],["str"]],["e"]]],[11,"to_owned","","",76,[[["self"]],["t"]]],[11,"clone_into","","",76,N],[11,"from","","",76,[[["t"]],["t"]]],[11,"into","","",76,[[["self"]],["u"]]],[11,"try_from","","",76,[[["u"]],["result"]]],[11,"borrow","","",76,[[["self"]],["t"]]],[11,"try_into","","",76,[[["self"]],["result"]]],[11,"borrow_mut","","",76,[[["self"]],["t"]]],[11,"get_type_id","","",76,[[["self"]],["typeid"]]],[11,"encode","","",76,[[["self"],["e"]],["result"]]],[11,"decode","","",76,[[["d"]],["result"]]],[11,"not_found","","",76,[[["str"],["str"]],["e"]]],[11,"to_owned","","",77,[[["self"]],["t"]]],[11,"clone_into","","",77,N],[11,"from","","",77,[[["t"]],["t"]]],[11,"into","","",77,[[["self"]],["u"]]],[11,"try_from","","",77,[[["u"]],["result"]]],[11,"borrow","","",77,[[["self"]],["t"]]],[11,"try_into","","",77,[[["self"]],["result"]]],[11,"borrow_mut","","",77,[[["self"]],["t"]]],[11,"get_type_id","","",77,[[["self"]],["typeid"]]],[11,"encode","","",77,[[["self"],["e"]],["result"]]],[11,"decode","","",77,[[["d"]],["result"]]],[11,"not_found","","",77,[[["str"],["str"]],["e"]]],[11,"to_owned","","",78,[[["self"]],["t"]]],[11,"clone_into","","",78,N],[11,"from","","",78,[[["t"]],["t"]]],[11,"into","","",78,[[["self"]],["u"]]],[11,"try_from","","",78,[[["u"]],["result"]]],[11,"borrow","","",78,[[["self"]],["t"]]],[11,"try_into","","",78,[[["self"]],["result"]]],[11,"borrow_mut","","",78,[[["self"]],["t"]]],[11,"get_type_id","","",78,[[["self"]],["typeid"]]],[11,"encode","","",78,[[["self"],["e"]],["result"]]],[11,"decode","","",78,[[["d"]],["result"]]],[11,"not_found","","",78,[[["str"],["str"]],["e"]]],[11,"to_owned","","",79,[[["self"]],["t"]]],[11,"clone_into","","",79,N],[11,"from","","",79,[[["t"]],["t"]]],[11,"into","","",79,[[["self"]],["u"]]],[11,"try_from","","",79,[[["u"]],["result"]]],[11,"borrow","","",79,[[["self"]],["t"]]],[11,"try_into","","",79,[[["self"]],["result"]]],[11,"borrow_mut","","",79,[[["self"]],["t"]]],[11,"get_type_id","","",79,[[["self"]],["typeid"]]],[11,"encode","","",79,[[["self"],["e"]],["result"]]],[11,"decode","","",79,[[["d"]],["result"]]],[11,"not_found","","",79,[[["str"],["str"]],["e"]]],[11,"to_owned","","",80,[[["self"]],["t"]]],[11,"clone_into","","",80,N],[11,"from","","",80,[[["t"]],["t"]]],[11,"into","","",80,[[["self"]],["u"]]],[11,"try_from","","",80,[[["u"]],["result"]]],[11,"borrow","","",80,[[["self"]],["t"]]],[11,"try_into","","",80,[[["self"]],["result"]]],[11,"borrow_mut","","",80,[[["self"]],["t"]]],[11,"get_type_id","","",80,[[["self"]],["typeid"]]],[11,"encode","","",80,[[["self"],["e"]],["result"]]],[11,"decode","","",80,[[["d"]],["result"]]],[11,"not_found","","",80,[[["str"],["str"]],["e"]]],[11,"to_owned","","",81,[[["self"]],["t"]]],[11,"clone_into","","",81,N],[11,"from","","",81,[[["t"]],["t"]]],[11,"into","","",81,[[["self"]],["u"]]],[11,"try_from","","",81,[[["u"]],["result"]]],[11,"borrow","","",81,[[["self"]],["t"]]],[11,"try_into","","",81,[[["self"]],["result"]]],[11,"borrow_mut","","",81,[[["self"]],["t"]]],[11,"get_type_id","","",81,[[["self"]],["typeid"]]],[11,"encode","","",81,[[["self"],["e"]],["result"]]],[11,"decode","","",81,[[["d"]],["result"]]],[11,"not_found","","",81,[[["str"],["str"]],["e"]]],[11,"to_owned","","",82,[[["self"]],["t"]]],[11,"clone_into","","",82,N],[11,"from","","",82,[[["t"]],["t"]]],[11,"into","","",82,[[["self"]],["u"]]],[11,"try_from","","",82,[[["u"]],["result"]]],[11,"borrow","","",82,[[["self"]],["t"]]],[11,"try_into","","",82,[[["self"]],["result"]]],[11,"borrow_mut","","",82,[[["self"]],["t"]]],[11,"get_type_id","","",82,[[["self"]],["typeid"]]],[11,"encode","","",82,[[["self"],["e"]],["result"]]],[11,"decode","","",82,[[["d"]],["result"]]],[11,"not_found","","",82,[[["str"],["str"]],["e"]]],[11,"to_owned","","",83,[[["self"]],["t"]]],[11,"clone_into","","",83,N],[11,"from","","",83,[[["t"]],["t"]]],[11,"into","","",83,[[["self"]],["u"]]],[11,"try_from","","",83,[[["u"]],["result"]]],[11,"borrow","","",83,[[["self"]],["t"]]],[11,"try_into","","",83,[[["self"]],["result"]]],[11,"borrow_mut","","",83,[[["self"]],["t"]]],[11,"get_type_id","","",83,[[["self"]],["typeid"]]],[11,"encode","","",83,[[["self"],["e"]],["result"]]],[11,"decode","","",83,[[["d"]],["result"]]],[11,"not_found","","",83,[[["str"],["str"]],["e"]]],[11,"to_owned","","",84,[[["self"]],["t"]]],[11,"clone_into","","",84,N],[11,"from","","",84,[[["t"]],["t"]]],[11,"into","","",84,[[["self"]],["u"]]],[11,"try_from","","",84,[[["u"]],["result"]]],[11,"borrow","","",84,[[["self"]],["t"]]],[11,"try_into","","",84,[[["self"]],["result"]]],[11,"borrow_mut","","",84,[[["self"]],["t"]]],[11,"get_type_id","","",84,[[["self"]],["typeid"]]],[11,"encode","","",84,[[["self"],["e"]],["result"]]],[11,"decode","","",84,[[["d"]],["result"]]],[11,"not_found","","",84,[[["str"],["str"]],["e"]]],[11,"to_owned","","",85,[[["self"]],["t"]]],[11,"clone_into","","",85,N],[11,"from","","",85,[[["t"]],["t"]]],[11,"into","","",85,[[["self"]],["u"]]],[11,"try_from","","",85,[[["u"]],["result"]]],[11,"borrow","","",85,[[["self"]],["t"]]],[11,"try_into","","",85,[[["self"]],["result"]]],[11,"borrow_mut","","",85,[[["self"]],["t"]]],[11,"get_type_id","","",85,[[["self"]],["typeid"]]],[11,"encode","","",85,[[["self"],["e"]],["result"]]],[11,"decode","","",85,[[["d"]],["result"]]],[11,"not_found","","",85,[[["str"],["str"]],["e"]]],[11,"to_owned","","",86,[[["self"]],["t"]]],[11,"clone_into","","",86,N],[11,"from","","",86,[[["t"]],["t"]]],[11,"into","","",86,[[["self"]],["u"]]],[11,"try_from","","",86,[[["u"]],["result"]]],[11,"borrow","","",86,[[["self"]],["t"]]],[11,"try_into","","",86,[[["self"]],["result"]]],[11,"borrow_mut","","",86,[[["self"]],["t"]]],[11,"get_type_id","","",86,[[["self"]],["typeid"]]],[11,"encode","","",86,[[["self"],["e"]],["result"]]],[11,"decode","","",86,[[["d"]],["result"]]],[11,"not_found","","",86,[[["str"],["str"]],["e"]]],[11,"to_owned","","",87,[[["self"]],["t"]]],[11,"clone_into","","",87,N],[11,"from","","",87,[[["t"]],["t"]]],[11,"into","","",87,[[["self"]],["u"]]],[11,"try_from","","",87,[[["u"]],["result"]]],[11,"borrow","","",87,[[["self"]],["t"]]],[11,"try_into","","",87,[[["self"]],["result"]]],[11,"borrow_mut","","",87,[[["self"]],["t"]]],[11,"get_type_id","","",87,[[["self"]],["typeid"]]],[11,"encode","","",87,[[["self"],["e"]],["result"]]],[11,"decode","","",87,[[["d"]],["result"]]],[11,"not_found","","",87,[[["str"],["str"]],["e"]]],[11,"to_owned","","",88,[[["self"]],["t"]]],[11,"clone_into","","",88,N],[11,"from","","",88,[[["t"]],["t"]]],[11,"into","","",88,[[["self"]],["u"]]],[11,"try_from","","",88,[[["u"]],["result"]]],[11,"borrow","","",88,[[["self"]],["t"]]],[11,"try_into","","",88,[[["self"]],["result"]]],[11,"borrow_mut","","",88,[[["self"]],["t"]]],[11,"get_type_id","","",88,[[["self"]],["typeid"]]],[11,"encode","","",88,[[["self"],["e"]],["result"]]],[11,"decode","","",88,[[["d"]],["result"]]],[11,"not_found","","",88,[[["str"],["str"]],["e"]]],[11,"to_owned","","",89,[[["self"]],["t"]]],[11,"clone_into","","",89,N],[11,"from","","",89,[[["t"]],["t"]]],[11,"into","","",89,[[["self"]],["u"]]],[11,"try_from","","",89,[[["u"]],["result"]]],[11,"borrow","","",89,[[["self"]],["t"]]],[11,"try_into","","",89,[[["self"]],["result"]]],[11,"borrow_mut","","",89,[[["self"]],["t"]]],[11,"get_type_id","","",89,[[["self"]],["typeid"]]],[11,"encode","","",89,[[["self"],["e"]],["result"]]],[11,"decode","","",89,[[["d"]],["result"]]],[11,"not_found","","",89,[[["str"],["str"]],["e"]]],[11,"to_owned","","",90,[[["self"]],["t"]]],[11,"clone_into","","",90,N],[11,"from","","",90,[[["t"]],["t"]]],[11,"into","","",90,[[["self"]],["u"]]],[11,"try_from","","",90,[[["u"]],["result"]]],[11,"borrow","","",90,[[["self"]],["t"]]],[11,"try_into","","",90,[[["self"]],["result"]]],[11,"borrow_mut","","",90,[[["self"]],["t"]]],[11,"get_type_id","","",90,[[["self"]],["typeid"]]],[11,"encode","","",90,[[["self"],["e"]],["result"]]],[11,"decode","","",90,[[["d"]],["result"]]],[11,"not_found","","",90,[[["str"],["str"]],["e"]]],[11,"to_owned","","",91,[[["self"]],["t"]]],[11,"clone_into","","",91,N],[11,"from","","",91,[[["t"]],["t"]]],[11,"into","","",91,[[["self"]],["u"]]],[11,"try_from","","",91,[[["u"]],["result"]]],[11,"borrow","","",91,[[["self"]],["t"]]],[11,"try_into","","",91,[[["self"]],["result"]]],[11,"borrow_mut","","",91,[[["self"]],["t"]]],[11,"get_type_id","","",91,[[["self"]],["typeid"]]],[11,"encode","","",91,[[["self"],["e"]],["result"]]],[11,"decode","","",91,[[["d"]],["result"]]],[11,"not_found","","",91,[[["str"],["str"]],["e"]]],[11,"to_owned","","",92,[[["self"]],["t"]]],[11,"clone_into","","",92,N],[11,"from","","",92,[[["t"]],["t"]]],[11,"into","","",92,[[["self"]],["u"]]],[11,"try_from","","",92,[[["u"]],["result"]]],[11,"borrow","","",92,[[["self"]],["t"]]],[11,"try_into","","",92,[[["self"]],["result"]]],[11,"borrow_mut","","",92,[[["self"]],["t"]]],[11,"get_type_id","","",92,[[["self"]],["typeid"]]],[11,"encode","","",92,[[["self"],["e"]],["result"]]],[11,"decode","","",92,[[["d"]],["result"]]],[11,"not_found","","",92,[[["str"],["str"]],["e"]]],[11,"to_owned","","",93,[[["self"]],["t"]]],[11,"clone_into","","",93,N],[11,"from","","",93,[[["t"]],["t"]]],[11,"into","","",93,[[["self"]],["u"]]],[11,"try_from","","",93,[[["u"]],["result"]]],[11,"borrow","","",93,[[["self"]],["t"]]],[11,"try_into","","",93,[[["self"]],["result"]]],[11,"borrow_mut","","",93,[[["self"]],["t"]]],[11,"get_type_id","","",93,[[["self"]],["typeid"]]],[11,"encode","","",93,[[["self"],["e"]],["result"]]],[11,"decode","","",93,[[["d"]],["result"]]],[11,"not_found","","",93,[[["str"],["str"]],["e"]]],[11,"to_owned","","",94,[[["self"]],["t"]]],[11,"clone_into","","",94,N],[11,"from","","",94,[[["t"]],["t"]]],[11,"into","","",94,[[["self"]],["u"]]],[11,"try_from","","",94,[[["u"]],["result"]]],[11,"borrow","","",94,[[["self"]],["t"]]],[11,"try_into","","",94,[[["self"]],["result"]]],[11,"borrow_mut","","",94,[[["self"]],["t"]]],[11,"get_type_id","","",94,[[["self"]],["typeid"]]],[11,"encode","","",94,[[["self"],["e"]],["result"]]],[11,"decode","","",94,[[["d"]],["result"]]],[11,"not_found","","",94,[[["str"],["str"]],["e"]]],[11,"to_owned","","",95,[[["self"]],["t"]]],[11,"clone_into","","",95,N],[11,"from","","",95,[[["t"]],["t"]]],[11,"into","","",95,[[["self"]],["u"]]],[11,"try_from","","",95,[[["u"]],["result"]]],[11,"borrow","","",95,[[["self"]],["t"]]],[11,"try_into","","",95,[[["self"]],["result"]]],[11,"borrow_mut","","",95,[[["self"]],["t"]]],[11,"get_type_id","","",95,[[["self"]],["typeid"]]],[11,"encode","","",95,[[["self"],["e"]],["result"]]],[11,"decode","","",95,[[["d"]],["result"]]],[11,"not_found","","",95,[[["str"],["str"]],["e"]]],[11,"to_owned","","",96,[[["self"]],["t"]]],[11,"clone_into","","",96,N],[11,"from","","",96,[[["t"]],["t"]]],[11,"into","","",96,[[["self"]],["u"]]],[11,"try_from","","",96,[[["u"]],["result"]]],[11,"borrow","","",96,[[["self"]],["t"]]],[11,"try_into","","",96,[[["self"]],["result"]]],[11,"borrow_mut","","",96,[[["self"]],["t"]]],[11,"get_type_id","","",96,[[["self"]],["typeid"]]],[11,"encode","","",96,[[["self"],["e"]],["result"]]],[11,"decode","","",96,[[["d"]],["result"]]],[11,"not_found","","",96,[[["str"],["str"]],["e"]]],[11,"to_owned","","",97,[[["self"]],["t"]]],[11,"clone_into","","",97,N],[11,"from","","",97,[[["t"]],["t"]]],[11,"into","","",97,[[["self"]],["u"]]],[11,"try_from","","",97,[[["u"]],["result"]]],[11,"borrow","","",97,[[["self"]],["t"]]],[11,"try_into","","",97,[[["self"]],["result"]]],[11,"borrow_mut","","",97,[[["self"]],["t"]]],[11,"get_type_id","","",97,[[["self"]],["typeid"]]],[11,"encode","","",97,[[["self"],["e"]],["result"]]],[11,"decode","","",97,[[["d"]],["result"]]],[11,"not_found","","",97,[[["str"],["str"]],["e"]]],[11,"to_owned","","",98,[[["self"]],["t"]]],[11,"clone_into","","",98,N],[11,"from","","",98,[[["t"]],["t"]]],[11,"into","","",98,[[["self"]],["u"]]],[11,"try_from","","",98,[[["u"]],["result"]]],[11,"borrow","","",98,[[["self"]],["t"]]],[11,"try_into","","",98,[[["self"]],["result"]]],[11,"borrow_mut","","",98,[[["self"]],["t"]]],[11,"get_type_id","","",98,[[["self"]],["typeid"]]],[11,"encode","","",98,[[["self"],["e"]],["result"]]],[11,"decode","","",98,[[["d"]],["result"]]],[11,"not_found","","",98,[[["str"],["str"]],["e"]]],[11,"to_owned","","",99,[[["self"]],["t"]]],[11,"clone_into","","",99,N],[11,"from","","",99,[[["t"]],["t"]]],[11,"into","","",99,[[["self"]],["u"]]],[11,"try_from","","",99,[[["u"]],["result"]]],[11,"borrow","","",99,[[["self"]],["t"]]],[11,"try_into","","",99,[[["self"]],["result"]]],[11,"borrow_mut","","",99,[[["self"]],["t"]]],[11,"get_type_id","","",99,[[["self"]],["typeid"]]],[11,"encode","","",99,[[["self"],["e"]],["result"]]],[11,"decode","","",99,[[["d"]],["result"]]],[11,"not_found","","",99,[[["str"],["str"]],["e"]]],[11,"to_owned","","",100,[[["self"]],["t"]]],[11,"clone_into","","",100,N],[11,"from","","",100,[[["t"]],["t"]]],[11,"into","","",100,[[["self"]],["u"]]],[11,"try_from","","",100,[[["u"]],["result"]]],[11,"borrow","","",100,[[["self"]],["t"]]],[11,"try_into","","",100,[[["self"]],["result"]]],[11,"borrow_mut","","",100,[[["self"]],["t"]]],[11,"get_type_id","","",100,[[["self"]],["typeid"]]],[11,"encode","","",100,[[["self"],["e"]],["result"]]],[11,"decode","","",100,[[["d"]],["result"]]],[11,"not_found","","",100,[[["str"],["str"]],["e"]]],[11,"to_owned","","",101,[[["self"]],["t"]]],[11,"clone_into","","",101,N],[11,"from","","",101,[[["t"]],["t"]]],[11,"into","","",101,[[["self"]],["u"]]],[11,"try_from","","",101,[[["u"]],["result"]]],[11,"borrow","","",101,[[["self"]],["t"]]],[11,"try_into","","",101,[[["self"]],["result"]]],[11,"borrow_mut","","",101,[[["self"]],["t"]]],[11,"get_type_id","","",101,[[["self"]],["typeid"]]],[11,"encode","","",101,[[["self"],["e"]],["result"]]],[11,"decode","","",101,[[["d"]],["result"]]],[11,"not_found","","",101,[[["str"],["str"]],["e"]]],[11,"to_owned","","",102,[[["self"]],["t"]]],[11,"clone_into","","",102,N],[11,"from","","",102,[[["t"]],["t"]]],[11,"into","","",102,[[["self"]],["u"]]],[11,"try_from","","",102,[[["u"]],["result"]]],[11,"borrow","","",102,[[["self"]],["t"]]],[11,"try_into","","",102,[[["self"]],["result"]]],[11,"borrow_mut","","",102,[[["self"]],["t"]]],[11,"get_type_id","","",102,[[["self"]],["typeid"]]],[11,"encode","","",102,[[["self"],["e"]],["result"]]],[11,"decode","","",102,[[["d"]],["result"]]],[11,"not_found","","",102,[[["str"],["str"]],["e"]]],[11,"to_owned","","",103,[[["self"]],["t"]]],[11,"clone_into","","",103,N],[11,"from","","",103,[[["t"]],["t"]]],[11,"into","","",103,[[["self"]],["u"]]],[11,"try_from","","",103,[[["u"]],["result"]]],[11,"borrow","","",103,[[["self"]],["t"]]],[11,"try_into","","",103,[[["self"]],["result"]]],[11,"borrow_mut","","",103,[[["self"]],["t"]]],[11,"get_type_id","","",103,[[["self"]],["typeid"]]],[11,"encode","","",103,[[["self"],["e"]],["result"]]],[11,"decode","","",103,[[["d"]],["result"]]],[11,"not_found","","",103,[[["str"],["str"]],["e"]]],[11,"to_owned","","",104,[[["self"]],["t"]]],[11,"clone_into","","",104,N],[11,"from","","",104,[[["t"]],["t"]]],[11,"into","","",104,[[["self"]],["u"]]],[11,"try_from","","",104,[[["u"]],["result"]]],[11,"borrow","","",104,[[["self"]],["t"]]],[11,"try_into","","",104,[[["self"]],["result"]]],[11,"borrow_mut","","",104,[[["self"]],["t"]]],[11,"get_type_id","","",104,[[["self"]],["typeid"]]],[11,"encode","","",104,[[["self"],["e"]],["result"]]],[11,"decode","","",104,[[["d"]],["result"]]],[11,"not_found","","",104,[[["str"],["str"]],["e"]]],[11,"to_owned","","",105,[[["self"]],["t"]]],[11,"clone_into","","",105,N],[11,"from","","",105,[[["t"]],["t"]]],[11,"into","","",105,[[["self"]],["u"]]],[11,"try_from","","",105,[[["u"]],["result"]]],[11,"borrow","","",105,[[["self"]],["t"]]],[11,"try_into","","",105,[[["self"]],["result"]]],[11,"borrow_mut","","",105,[[["self"]],["t"]]],[11,"get_type_id","","",105,[[["self"]],["typeid"]]],[11,"encode","","",105,[[["self"],["e"]],["result"]]],[11,"decode","","",105,[[["d"]],["result"]]],[11,"not_found","","",105,[[["str"],["str"]],["e"]]],[11,"to_owned","","",106,[[["self"]],["t"]]],[11,"clone_into","","",106,N],[11,"from","","",106,[[["t"]],["t"]]],[11,"into","","",106,[[["self"]],["u"]]],[11,"try_from","","",106,[[["u"]],["result"]]],[11,"borrow","","",106,[[["self"]],["t"]]],[11,"try_into","","",106,[[["self"]],["result"]]],[11,"borrow_mut","","",106,[[["self"]],["t"]]],[11,"get_type_id","","",106,[[["self"]],["typeid"]]],[11,"encode","","",106,[[["self"],["e"]],["result"]]],[11,"decode","","",106,[[["d"]],["result"]]],[11,"not_found","","",106,[[["str"],["str"]],["e"]]],[11,"to_owned","","",107,[[["self"]],["t"]]],[11,"clone_into","","",107,N],[11,"from","","",107,[[["t"]],["t"]]],[11,"into","","",107,[[["self"]],["u"]]],[11,"try_from","","",107,[[["u"]],["result"]]],[11,"borrow","","",107,[[["self"]],["t"]]],[11,"try_into","","",107,[[["self"]],["result"]]],[11,"borrow_mut","","",107,[[["self"]],["t"]]],[11,"get_type_id","","",107,[[["self"]],["typeid"]]],[11,"encode","","",107,[[["self"],["e"]],["result"]]],[11,"decode","","",107,[[["d"]],["result"]]],[11,"not_found","","",107,[[["str"],["str"]],["e"]]],[11,"to_owned","","",108,[[["self"]],["t"]]],[11,"clone_into","","",108,N],[11,"from","","",108,[[["t"]],["t"]]],[11,"into","","",108,[[["self"]],["u"]]],[11,"try_from","","",108,[[["u"]],["result"]]],[11,"borrow","","",108,[[["self"]],["t"]]],[11,"try_into","","",108,[[["self"]],["result"]]],[11,"borrow_mut","","",108,[[["self"]],["t"]]],[11,"get_type_id","","",108,[[["self"]],["typeid"]]],[11,"encode","","",108,[[["self"],["e"]],["result"]]],[11,"decode","","",108,[[["d"]],["result"]]],[11,"not_found","","",108,[[["str"],["str"]],["e"]]],[11,"to_owned","","",109,[[["self"]],["t"]]],[11,"clone_into","","",109,N],[11,"from","","",109,[[["t"]],["t"]]],[11,"into","","",109,[[["self"]],["u"]]],[11,"try_from","","",109,[[["u"]],["result"]]],[11,"borrow","","",109,[[["self"]],["t"]]],[11,"try_into","","",109,[[["self"]],["result"]]],[11,"borrow_mut","","",109,[[["self"]],["t"]]],[11,"get_type_id","","",109,[[["self"]],["typeid"]]],[11,"encode","","",109,[[["self"],["e"]],["result"]]],[11,"decode","","",109,[[["d"]],["result"]]],[11,"not_found","","",109,[[["str"],["str"]],["e"]]],[11,"to_owned","","",110,[[["self"]],["t"]]],[11,"clone_into","","",110,N],[11,"from","","",110,[[["t"]],["t"]]],[11,"into","","",110,[[["self"]],["u"]]],[11,"try_from","","",110,[[["u"]],["result"]]],[11,"borrow","","",110,[[["self"]],["t"]]],[11,"try_into","","",110,[[["self"]],["result"]]],[11,"borrow_mut","","",110,[[["self"]],["t"]]],[11,"get_type_id","","",110,[[["self"]],["typeid"]]],[11,"encode","","",110,[[["self"],["e"]],["result"]]],[11,"decode","","",110,[[["d"]],["result"]]],[11,"not_found","","",110,[[["str"],["str"]],["e"]]],[11,"to_owned","","",111,[[["self"]],["t"]]],[11,"clone_into","","",111,N],[11,"from","","",111,[[["t"]],["t"]]],[11,"into","","",111,[[["self"]],["u"]]],[11,"try_from","","",111,[[["u"]],["result"]]],[11,"borrow","","",111,[[["self"]],["t"]]],[11,"try_into","","",111,[[["self"]],["result"]]],[11,"borrow_mut","","",111,[[["self"]],["t"]]],[11,"get_type_id","","",111,[[["self"]],["typeid"]]],[11,"encode","","",111,[[["self"],["e"]],["result"]]],[11,"decode","","",111,[[["d"]],["result"]]],[11,"not_found","","",111,[[["str"],["str"]],["e"]]],[11,"to_owned","","",112,[[["self"]],["t"]]],[11,"clone_into","","",112,N],[11,"from","","",112,[[["t"]],["t"]]],[11,"into","","",112,[[["self"]],["u"]]],[11,"try_from","","",112,[[["u"]],["result"]]],[11,"borrow","","",112,[[["self"]],["t"]]],[11,"try_into","","",112,[[["self"]],["result"]]],[11,"borrow_mut","","",112,[[["self"]],["t"]]],[11,"get_type_id","","",112,[[["self"]],["typeid"]]],[11,"encode","","",112,[[["self"],["e"]],["result"]]],[11,"decode","","",112,[[["d"]],["result"]]],[11,"not_found","","",112,[[["str"],["str"]],["e"]]],[11,"to_owned","","",113,[[["self"]],["t"]]],[11,"clone_into","","",113,N],[11,"from","","",113,[[["t"]],["t"]]],[11,"into","","",113,[[["self"]],["u"]]],[11,"try_from","","",113,[[["u"]],["result"]]],[11,"borrow","","",113,[[["self"]],["t"]]],[11,"try_into","","",113,[[["self"]],["result"]]],[11,"borrow_mut","","",113,[[["self"]],["t"]]],[11,"get_type_id","","",113,[[["self"]],["typeid"]]],[11,"encode","","",113,[[["self"],["e"]],["result"]]],[11,"decode","","",113,[[["d"]],["result"]]],[11,"not_found","","",113,[[["str"],["str"]],["e"]]],[11,"to_owned","","",114,[[["self"]],["t"]]],[11,"clone_into","","",114,N],[11,"from","","",114,[[["t"]],["t"]]],[11,"into","","",114,[[["self"]],["u"]]],[11,"try_from","","",114,[[["u"]],["result"]]],[11,"borrow","","",114,[[["self"]],["t"]]],[11,"try_into","","",114,[[["self"]],["result"]]],[11,"borrow_mut","","",114,[[["self"]],["t"]]],[11,"get_type_id","","",114,[[["self"]],["typeid"]]],[11,"encode","","",114,[[["self"],["e"]],["result"]]],[11,"decode","","",114,[[["d"]],["result"]]],[11,"not_found","","",114,[[["str"],["str"]],["e"]]],[11,"to_owned","","",115,[[["self"]],["t"]]],[11,"clone_into","","",115,N],[11,"from","","",115,[[["t"]],["t"]]],[11,"into","","",115,[[["self"]],["u"]]],[11,"try_from","","",115,[[["u"]],["result"]]],[11,"borrow","","",115,[[["self"]],["t"]]],[11,"try_into","","",115,[[["self"]],["result"]]],[11,"borrow_mut","","",115,[[["self"]],["t"]]],[11,"get_type_id","","",115,[[["self"]],["typeid"]]],[11,"encode","","",115,[[["self"],["e"]],["result"]]],[11,"decode","","",115,[[["d"]],["result"]]],[11,"not_found","","",115,[[["str"],["str"]],["e"]]],[11,"to_owned","","",116,[[["self"]],["t"]]],[11,"clone_into","","",116,N],[11,"from","","",116,[[["t"]],["t"]]],[11,"into","","",116,[[["self"]],["u"]]],[11,"try_from","","",116,[[["u"]],["result"]]],[11,"borrow","","",116,[[["self"]],["t"]]],[11,"try_into","","",116,[[["self"]],["result"]]],[11,"borrow_mut","","",116,[[["self"]],["t"]]],[11,"get_type_id","","",116,[[["self"]],["typeid"]]],[11,"encode","","",116,[[["self"],["e"]],["result"]]],[11,"decode","","",116,[[["d"]],["result"]]],[11,"not_found","","",116,[[["str"],["str"]],["e"]]],[11,"to_owned","","",117,[[["self"]],["t"]]],[11,"clone_into","","",117,N],[11,"from","","",117,[[["t"]],["t"]]],[11,"into","","",117,[[["self"]],["u"]]],[11,"try_from","","",117,[[["u"]],["result"]]],[11,"borrow","","",117,[[["self"]],["t"]]],[11,"try_into","","",117,[[["self"]],["result"]]],[11,"borrow_mut","","",117,[[["self"]],["t"]]],[11,"get_type_id","","",117,[[["self"]],["typeid"]]],[11,"encode","","",117,[[["self"],["e"]],["result"]]],[11,"decode","","",117,[[["d"]],["result"]]],[11,"not_found","","",117,[[["str"],["str"]],["e"]]],[11,"to_owned","","",118,[[["self"]],["t"]]],[11,"clone_into","","",118,N],[11,"from","","",118,[[["t"]],["t"]]],[11,"into","","",118,[[["self"]],["u"]]],[11,"try_from","","",118,[[["u"]],["result"]]],[11,"borrow","","",118,[[["self"]],["t"]]],[11,"try_into","","",118,[[["self"]],["result"]]],[11,"borrow_mut","","",118,[[["self"]],["t"]]],[11,"get_type_id","","",118,[[["self"]],["typeid"]]],[11,"encode","","",118,[[["self"],["e"]],["result"]]],[11,"decode","","",118,[[["d"]],["result"]]],[11,"not_found","","",118,[[["str"],["str"]],["e"]]],[11,"to_owned","","",119,[[["self"]],["t"]]],[11,"clone_into","","",119,N],[11,"from","","",119,[[["t"]],["t"]]],[11,"into","","",119,[[["self"]],["u"]]],[11,"try_from","","",119,[[["u"]],["result"]]],[11,"borrow","","",119,[[["self"]],["t"]]],[11,"try_into","","",119,[[["self"]],["result"]]],[11,"borrow_mut","","",119,[[["self"]],["t"]]],[11,"get_type_id","","",119,[[["self"]],["typeid"]]],[11,"encode","","",119,[[["self"],["e"]],["result"]]],[11,"decode","","",119,[[["d"]],["result"]]],[11,"not_found","","",119,[[["str"],["str"]],["e"]]],[11,"to_owned","","",120,[[["self"]],["t"]]],[11,"clone_into","","",120,N],[11,"from","","",120,[[["t"]],["t"]]],[11,"into","","",120,[[["self"]],["u"]]],[11,"try_from","","",120,[[["u"]],["result"]]],[11,"borrow","","",120,[[["self"]],["t"]]],[11,"try_into","","",120,[[["self"]],["result"]]],[11,"borrow_mut","","",120,[[["self"]],["t"]]],[11,"get_type_id","","",120,[[["self"]],["typeid"]]],[11,"encode","","",120,[[["self"],["e"]],["result"]]],[11,"decode","","",120,[[["d"]],["result"]]],[11,"not_found","","",120,[[["str"],["str"]],["e"]]],[11,"to_owned","","",121,[[["self"]],["t"]]],[11,"clone_into","","",121,N],[11,"from","","",121,[[["t"]],["t"]]],[11,"into","","",121,[[["self"]],["u"]]],[11,"try_from","","",121,[[["u"]],["result"]]],[11,"borrow","","",121,[[["self"]],["t"]]],[11,"try_into","","",121,[[["self"]],["result"]]],[11,"borrow_mut","","",121,[[["self"]],["t"]]],[11,"get_type_id","","",121,[[["self"]],["typeid"]]],[11,"encode","","",121,[[["self"],["e"]],["result"]]],[11,"decode","","",121,[[["d"]],["result"]]],[11,"not_found","","",121,[[["str"],["str"]],["e"]]],[11,"to_owned","","",122,[[["self"]],["t"]]],[11,"clone_into","","",122,N],[11,"from","","",122,[[["t"]],["t"]]],[11,"into","","",122,[[["self"]],["u"]]],[11,"try_from","","",122,[[["u"]],["result"]]],[11,"borrow","","",122,[[["self"]],["t"]]],[11,"try_into","","",122,[[["self"]],["result"]]],[11,"borrow_mut","","",122,[[["self"]],["t"]]],[11,"get_type_id","","",122,[[["self"]],["typeid"]]],[11,"encode","","",122,[[["self"],["e"]],["result"]]],[11,"decode","","",122,[[["d"]],["result"]]],[11,"not_found","","",122,[[["str"],["str"]],["e"]]],[11,"to_owned","","",123,[[["self"]],["t"]]],[11,"clone_into","","",123,N],[11,"from","","",123,[[["t"]],["t"]]],[11,"into","","",123,[[["self"]],["u"]]],[11,"try_from","","",123,[[["u"]],["result"]]],[11,"borrow","","",123,[[["self"]],["t"]]],[11,"try_into","","",123,[[["self"]],["result"]]],[11,"borrow_mut","","",123,[[["self"]],["t"]]],[11,"get_type_id","","",123,[[["self"]],["typeid"]]],[11,"encode","","",123,[[["self"],["e"]],["result"]]],[11,"decode","","",123,[[["d"]],["result"]]],[11,"not_found","","",123,[[["str"],["str"]],["e"]]],[11,"to_owned","","",124,[[["self"]],["t"]]],[11,"clone_into","","",124,N],[11,"from","","",124,[[["t"]],["t"]]],[11,"into","","",124,[[["self"]],["u"]]],[11,"try_from","","",124,[[["u"]],["result"]]],[11,"borrow","","",124,[[["self"]],["t"]]],[11,"try_into","","",124,[[["self"]],["result"]]],[11,"borrow_mut","","",124,[[["self"]],["t"]]],[11,"get_type_id","","",124,[[["self"]],["typeid"]]],[11,"encode","","",124,[[["self"],["e"]],["result"]]],[11,"decode","","",124,[[["d"]],["result"]]],[11,"not_found","","",124,[[["str"],["str"]],["e"]]],[11,"to_owned","","",125,[[["self"]],["t"]]],[11,"clone_into","","",125,N],[11,"from","","",125,[[["t"]],["t"]]],[11,"into","","",125,[[["self"]],["u"]]],[11,"try_from","","",125,[[["u"]],["result"]]],[11,"borrow","","",125,[[["self"]],["t"]]],[11,"try_into","","",125,[[["self"]],["result"]]],[11,"borrow_mut","","",125,[[["self"]],["t"]]],[11,"get_type_id","","",125,[[["self"]],["typeid"]]],[11,"encode","","",125,[[["self"],["e"]],["result"]]],[11,"decode","","",125,[[["d"]],["result"]]],[11,"not_found","","",125,[[["str"],["str"]],["e"]]],[11,"to_owned","","",126,[[["self"]],["t"]]],[11,"clone_into","","",126,N],[11,"from","","",126,[[["t"]],["t"]]],[11,"into","","",126,[[["self"]],["u"]]],[11,"try_from","","",126,[[["u"]],["result"]]],[11,"borrow","","",126,[[["self"]],["t"]]],[11,"try_into","","",126,[[["self"]],["result"]]],[11,"borrow_mut","","",126,[[["self"]],["t"]]],[11,"get_type_id","","",126,[[["self"]],["typeid"]]],[11,"encode","","",126,[[["self"],["e"]],["result"]]],[11,"decode","","",126,[[["d"]],["result"]]],[11,"not_found","","",126,[[["str"],["str"]],["e"]]],[11,"to_owned","","",127,[[["self"]],["t"]]],[11,"clone_into","","",127,N],[11,"from","","",127,[[["t"]],["t"]]],[11,"into","","",127,[[["self"]],["u"]]],[11,"try_from","","",127,[[["u"]],["result"]]],[11,"borrow","","",127,[[["self"]],["t"]]],[11,"try_into","","",127,[[["self"]],["result"]]],[11,"borrow_mut","","",127,[[["self"]],["t"]]],[11,"get_type_id","","",127,[[["self"]],["typeid"]]],[11,"encode","","",127,[[["self"],["e"]],["result"]]],[11,"decode","","",127,[[["d"]],["result"]]],[11,"not_found","","",127,[[["str"],["str"]],["e"]]],[11,"to_owned","","",128,[[["self"]],["t"]]],[11,"clone_into","","",128,N],[11,"from","","",128,[[["t"]],["t"]]],[11,"to_string","","",128,[[["self"]],["string"]]],[11,"into","","",128,[[["self"]],["u"]]],[11,"try_from","","",128,[[["u"]],["result"]]],[11,"borrow","","",128,[[["self"]],["t"]]],[11,"try_into","","",128,[[["self"]],["result"]]],[11,"borrow_mut","","",128,[[["self"]],["t"]]],[11,"get_type_id","","",128,[[["self"]],["typeid"]]],[11,"encode","","",128,[[["self"],["e"]],["result"]]],[11,"decode","","",128,[[["d"]],["result"]]],[11,"not_found","","",128,[[["str"],["str"]],["e"]]],[11,"to_owned","","",129,[[["self"]],["t"]]],[11,"clone_into","","",129,N],[11,"from","","",129,[[["t"]],["t"]]],[11,"to_string","","",129,[[["self"]],["string"]]],[11,"into","","",129,[[["self"]],["u"]]],[11,"try_from","","",129,[[["u"]],["result"]]],[11,"borrow","","",129,[[["self"]],["t"]]],[11,"try_into","","",129,[[["self"]],["result"]]],[11,"borrow_mut","","",129,[[["self"]],["t"]]],[11,"get_type_id","","",129,[[["self"]],["typeid"]]],[11,"encode","","",129,[[["self"],["e"]],["result"]]],[11,"decode","","",129,[[["d"]],["result"]]],[11,"not_found","","",129,[[["str"],["str"]],["e"]]],[11,"to_owned","","",130,[[["self"]],["t"]]],[11,"clone_into","","",130,N],[11,"from","","",130,[[["t"]],["t"]]],[11,"into","","",130,[[["self"]],["u"]]],[11,"try_from","","",130,[[["u"]],["result"]]],[11,"borrow","","",130,[[["self"]],["t"]]],[11,"try_into","","",130,[[["self"]],["result"]]],[11,"borrow_mut","","",130,[[["self"]],["t"]]],[11,"get_type_id","","",130,[[["self"]],["typeid"]]],[11,"encode","","",130,[[["self"],["e"]],["result"]]],[11,"decode","","",130,[[["d"]],["result"]]],[11,"not_found","","",130,[[["str"],["str"]],["e"]]],[11,"to_owned","","",131,[[["self"]],["t"]]],[11,"clone_into","","",131,N],[11,"from","","",131,[[["t"]],["t"]]],[11,"into","","",131,[[["self"]],["u"]]],[11,"try_from","","",131,[[["u"]],["result"]]],[11,"borrow","","",131,[[["self"]],["t"]]],[11,"try_into","","",131,[[["self"]],["result"]]],[11,"borrow_mut","","",131,[[["self"]],["t"]]],[11,"get_type_id","","",131,[[["self"]],["typeid"]]],[11,"encode","","",131,[[["self"],["e"]],["result"]]],[11,"decode","","",131,[[["d"]],["result"]]],[11,"not_found","","",131,[[["str"],["str"]],["e"]]],[11,"to_owned","","",132,[[["self"]],["t"]]],[11,"clone_into","","",132,N],[11,"from","","",132,[[["t"]],["t"]]],[11,"into","","",132,[[["self"]],["u"]]],[11,"try_from","","",132,[[["u"]],["result"]]],[11,"borrow","","",132,[[["self"]],["t"]]],[11,"try_into","","",132,[[["self"]],["result"]]],[11,"borrow_mut","","",132,[[["self"]],["t"]]],[11,"get_type_id","","",132,[[["self"]],["typeid"]]],[11,"encode","","",132,[[["self"],["e"]],["result"]]],[11,"decode","","",132,[[["d"]],["result"]]],[11,"not_found","","",132,[[["str"],["str"]],["e"]]],[11,"to_owned","","",133,[[["self"]],["t"]]],[11,"clone_into","","",133,N],[11,"from","","",133,[[["t"]],["t"]]],[11,"into","","",133,[[["self"]],["u"]]],[11,"try_from","","",133,[[["u"]],["result"]]],[11,"borrow","","",133,[[["self"]],["t"]]],[11,"try_into","","",133,[[["self"]],["result"]]],[11,"borrow_mut","","",133,[[["self"]],["t"]]],[11,"get_type_id","","",133,[[["self"]],["typeid"]]],[11,"encode","","",133,[[["self"],["e"]],["result"]]],[11,"decode","","",133,[[["d"]],["result"]]],[11,"not_found","","",133,[[["str"],["str"]],["e"]]],[11,"to_owned","","",134,[[["self"]],["t"]]],[11,"clone_into","","",134,N],[11,"from","","",134,[[["t"]],["t"]]],[11,"into","","",134,[[["self"]],["u"]]],[11,"try_from","","",134,[[["u"]],["result"]]],[11,"borrow","","",134,[[["self"]],["t"]]],[11,"try_into","","",134,[[["self"]],["result"]]],[11,"borrow_mut","","",134,[[["self"]],["t"]]],[11,"get_type_id","","",134,[[["self"]],["typeid"]]],[11,"encode","","",134,[[["self"],["e"]],["result"]]],[11,"decode","","",134,[[["d"]],["result"]]],[11,"not_found","","",134,[[["str"],["str"]],["e"]]],[11,"to_owned","","",135,[[["self"]],["t"]]],[11,"clone_into","","",135,N],[11,"from","","",135,[[["t"]],["t"]]],[11,"to_string","","",135,[[["self"]],["string"]]],[11,"into","","",135,[[["self"]],["u"]]],[11,"try_from","","",135,[[["u"]],["result"]]],[11,"borrow","","",135,[[["self"]],["t"]]],[11,"try_into","","",135,[[["self"]],["result"]]],[11,"borrow_mut","","",135,[[["self"]],["t"]]],[11,"get_type_id","","",135,[[["self"]],["typeid"]]],[11,"encode","","",135,[[["self"],["e"]],["result"]]],[11,"decode","","",135,[[["d"]],["result"]]],[11,"not_found","","",135,[[["str"],["str"]],["e"]]],[11,"to_owned","","",136,[[["self"]],["t"]]],[11,"clone_into","","",136,N],[11,"from","","",136,[[["t"]],["t"]]],[11,"into","","",136,[[["self"]],["u"]]],[11,"try_from","","",136,[[["u"]],["result"]]],[11,"borrow","","",136,[[["self"]],["t"]]],[11,"try_into","","",136,[[["self"]],["result"]]],[11,"borrow_mut","","",136,[[["self"]],["t"]]],[11,"get_type_id","","",136,[[["self"]],["typeid"]]],[11,"encode","","",136,[[["self"],["e"]],["result"]]],[11,"decode","","",136,[[["d"]],["result"]]],[11,"not_found","","",136,[[["str"],["str"]],["e"]]],[11,"to_owned","","",137,[[["self"]],["t"]]],[11,"clone_into","","",137,N],[11,"from","","",137,[[["t"]],["t"]]],[11,"into","","",137,[[["self"]],["u"]]],[11,"try_from","","",137,[[["u"]],["result"]]],[11,"borrow","","",137,[[["self"]],["t"]]],[11,"try_into","","",137,[[["self"]],["result"]]],[11,"borrow_mut","","",137,[[["self"]],["t"]]],[11,"get_type_id","","",137,[[["self"]],["typeid"]]],[11,"encode","","",137,[[["self"],["e"]],["result"]]],[11,"decode","","",137,[[["d"]],["result"]]],[11,"not_found","","",137,[[["str"],["str"]],["e"]]],[11,"to_owned","","",138,[[["self"]],["t"]]],[11,"clone_into","","",138,N],[11,"from","","",138,[[["t"]],["t"]]],[11,"into","","",138,[[["self"]],["u"]]],[11,"try_from","","",138,[[["u"]],["result"]]],[11,"borrow","","",138,[[["self"]],["t"]]],[11,"try_into","","",138,[[["self"]],["result"]]],[11,"borrow_mut","","",138,[[["self"]],["t"]]],[11,"get_type_id","","",138,[[["self"]],["typeid"]]],[11,"encode","","",138,[[["self"],["e"]],["result"]]],[11,"decode","","",138,[[["d"]],["result"]]],[11,"not_found","","",138,[[["str"],["str"]],["e"]]],[11,"to_owned","","",139,[[["self"]],["t"]]],[11,"clone_into","","",139,N],[11,"from","","",139,[[["t"]],["t"]]],[11,"into","","",139,[[["self"]],["u"]]],[11,"try_from","","",139,[[["u"]],["result"]]],[11,"borrow","","",139,[[["self"]],["t"]]],[11,"try_into","","",139,[[["self"]],["result"]]],[11,"borrow_mut","","",139,[[["self"]],["t"]]],[11,"get_type_id","","",139,[[["self"]],["typeid"]]],[11,"encode","","",139,[[["self"],["e"]],["result"]]],[11,"decode","","",139,[[["d"]],["result"]]],[11,"not_found","","",139,[[["str"],["str"]],["e"]]],[11,"to_owned","","",140,[[["self"]],["t"]]],[11,"clone_into","","",140,N],[11,"from","","",140,[[["t"]],["t"]]],[11,"into","","",140,[[["self"]],["u"]]],[11,"try_from","","",140,[[["u"]],["result"]]],[11,"borrow","","",140,[[["self"]],["t"]]],[11,"try_into","","",140,[[["self"]],["result"]]],[11,"borrow_mut","","",140,[[["self"]],["t"]]],[11,"get_type_id","","",140,[[["self"]],["typeid"]]],[11,"encode","","",140,[[["self"],["e"]],["result"]]],[11,"decode","","",140,[[["d"]],["result"]]],[11,"not_found","","",140,[[["str"],["str"]],["e"]]],[11,"to_owned","","",141,[[["self"]],["t"]]],[11,"clone_into","","",141,N],[11,"from","","",141,[[["t"]],["t"]]],[11,"into","","",141,[[["self"]],["u"]]],[11,"try_from","","",141,[[["u"]],["result"]]],[11,"borrow","","",141,[[["self"]],["t"]]],[11,"try_into","","",141,[[["self"]],["result"]]],[11,"borrow_mut","","",141,[[["self"]],["t"]]],[11,"get_type_id","","",141,[[["self"]],["typeid"]]],[11,"encode","","",141,[[["self"],["e"]],["result"]]],[11,"decode","","",141,[[["d"]],["result"]]],[11,"not_found","","",141,[[["str"],["str"]],["e"]]],[11,"to_owned","","",142,[[["self"]],["t"]]],[11,"clone_into","","",142,N],[11,"from","","",142,[[["t"]],["t"]]],[11,"into","","",142,[[["self"]],["u"]]],[11,"try_from","","",142,[[["u"]],["result"]]],[11,"borrow","","",142,[[["self"]],["t"]]],[11,"try_into","","",142,[[["self"]],["result"]]],[11,"borrow_mut","","",142,[[["self"]],["t"]]],[11,"get_type_id","","",142,[[["self"]],["typeid"]]],[11,"encode","","",142,[[["self"],["e"]],["result"]]],[11,"decode","","",142,[[["d"]],["result"]]],[11,"not_found","","",142,[[["str"],["str"]],["e"]]],[11,"to_owned","","",143,[[["self"]],["t"]]],[11,"clone_into","","",143,N],[11,"from","","",143,[[["t"]],["t"]]],[11,"into","","",143,[[["self"]],["u"]]],[11,"try_from","","",143,[[["u"]],["result"]]],[11,"borrow","","",143,[[["self"]],["t"]]],[11,"try_into","","",143,[[["self"]],["result"]]],[11,"borrow_mut","","",143,[[["self"]],["t"]]],[11,"get_type_id","","",143,[[["self"]],["typeid"]]],[11,"encode","","",143,[[["self"],["e"]],["result"]]],[11,"decode","","",143,[[["d"]],["result"]]],[11,"not_found","","",143,[[["str"],["str"]],["e"]]],[11,"to_owned","","",144,[[["self"]],["t"]]],[11,"clone_into","","",144,N],[11,"from","","",144,[[["t"]],["t"]]],[11,"into","","",144,[[["self"]],["u"]]],[11,"try_from","","",144,[[["u"]],["result"]]],[11,"borrow","","",144,[[["self"]],["t"]]],[11,"try_into","","",144,[[["self"]],["result"]]],[11,"borrow_mut","","",144,[[["self"]],["t"]]],[11,"get_type_id","","",144,[[["self"]],["typeid"]]],[11,"encode","","",144,[[["self"],["e"]],["result"]]],[11,"decode","","",144,[[["d"]],["result"]]],[11,"not_found","","",144,[[["str"],["str"]],["e"]]],[11,"to_owned","","",145,[[["self"]],["t"]]],[11,"clone_into","","",145,N],[11,"from","","",145,[[["t"]],["t"]]],[11,"into","","",145,[[["self"]],["u"]]],[11,"try_from","","",145,[[["u"]],["result"]]],[11,"borrow","","",145,[[["self"]],["t"]]],[11,"try_into","","",145,[[["self"]],["result"]]],[11,"borrow_mut","","",145,[[["self"]],["t"]]],[11,"get_type_id","","",145,[[["self"]],["typeid"]]],[11,"encode","","",145,[[["self"],["e"]],["result"]]],[11,"decode","","",145,[[["d"]],["result"]]],[11,"not_found","","",145,[[["str"],["str"]],["e"]]],[11,"to_owned","","",146,[[["self"]],["t"]]],[11,"clone_into","","",146,N],[11,"from","","",146,[[["t"]],["t"]]],[11,"into","","",146,[[["self"]],["u"]]],[11,"try_from","","",146,[[["u"]],["result"]]],[11,"borrow","","",146,[[["self"]],["t"]]],[11,"try_into","","",146,[[["self"]],["result"]]],[11,"borrow_mut","","",146,[[["self"]],["t"]]],[11,"get_type_id","","",146,[[["self"]],["typeid"]]],[11,"encode","","",146,[[["self"],["e"]],["result"]]],[11,"decode","","",146,[[["d"]],["result"]]],[11,"not_found","","",146,[[["str"],["str"]],["e"]]],[11,"to_owned","","",147,[[["self"]],["t"]]],[11,"clone_into","","",147,N],[11,"from","","",147,[[["t"]],["t"]]],[11,"into","","",147,[[["self"]],["u"]]],[11,"try_from","","",147,[[["u"]],["result"]]],[11,"borrow","","",147,[[["self"]],["t"]]],[11,"try_into","","",147,[[["self"]],["result"]]],[11,"borrow_mut","","",147,[[["self"]],["t"]]],[11,"get_type_id","","",147,[[["self"]],["typeid"]]],[11,"encode","","",147,[[["self"],["e"]],["result"]]],[11,"decode","","",147,[[["d"]],["result"]]],[11,"not_found","","",147,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::attr","",148,[[["self"]],["t"]]],[11,"clone_into","","",148,N],[11,"from","","",148,[[["t"]],["t"]]],[11,"into","","",148,[[["self"]],["u"]]],[11,"try_from","","",148,[[["u"]],["result"]]],[11,"borrow","","",148,[[["self"]],["t"]]],[11,"try_into","","",148,[[["self"]],["result"]]],[11,"borrow_mut","","",148,[[["self"]],["t"]]],[11,"get_type_id","","",148,[[["self"]],["typeid"]]],[11,"encode","","",148,[[["self"],["e"]],["result"]]],[11,"decode","","",148,[[["d"]],["result"]]],[11,"not_found","","",148,[[["str"],["str"]],["e"]]],[11,"to_owned","","",149,[[["self"]],["t"]]],[11,"clone_into","","",149,N],[11,"from","","",149,[[["t"]],["t"]]],[11,"into","","",149,[[["self"]],["u"]]],[11,"try_from","","",149,[[["u"]],["result"]]],[11,"borrow","","",149,[[["self"]],["t"]]],[11,"try_into","","",149,[[["self"]],["result"]]],[11,"borrow_mut","","",149,[[["self"]],["t"]]],[11,"get_type_id","","",149,[[["self"]],["typeid"]]],[11,"encode","","",149,[[["self"],["e"]],["result"]]],[11,"decode","","",149,[[["d"]],["result"]]],[11,"not_found","","",149,[[["str"],["str"]],["e"]]],[11,"to_owned","","",150,[[["self"]],["t"]]],[11,"clone_into","","",150,N],[11,"from","","",150,[[["t"]],["t"]]],[11,"into","","",150,[[["self"]],["u"]]],[11,"try_from","","",150,[[["u"]],["result"]]],[11,"borrow","","",150,[[["self"]],["t"]]],[11,"try_into","","",150,[[["self"]],["result"]]],[11,"borrow_mut","","",150,[[["self"]],["t"]]],[11,"get_type_id","","",150,[[["self"]],["typeid"]]],[11,"encode","","",150,[[["self"],["e"]],["result"]]],[11,"decode","","",150,[[["d"]],["result"]]],[11,"not_found","","",150,[[["str"],["str"]],["e"]]],[11,"to_owned","","",151,[[["self"]],["t"]]],[11,"clone_into","","",151,N],[11,"from","","",151,[[["t"]],["t"]]],[11,"into","","",151,[[["self"]],["u"]]],[11,"try_from","","",151,[[["u"]],["result"]]],[11,"borrow","","",151,[[["self"]],["t"]]],[11,"try_into","","",151,[[["self"]],["result"]]],[11,"borrow_mut","","",151,[[["self"]],["t"]]],[11,"get_type_id","","",151,[[["self"]],["typeid"]]],[11,"encode","","",151,[[["self"],["e"]],["result"]]],[11,"decode","","",151,[[["d"]],["result"]]],[11,"not_found","","",151,[[["str"],["str"]],["e"]]],[11,"to_owned","","",152,[[["self"]],["t"]]],[11,"clone_into","","",152,N],[11,"from","","",152,[[["t"]],["t"]]],[11,"into","","",152,[[["self"]],["u"]]],[11,"try_from","","",152,[[["u"]],["result"]]],[11,"borrow","","",152,[[["self"]],["t"]]],[11,"try_into","","",152,[[["self"]],["result"]]],[11,"borrow_mut","","",152,[[["self"]],["t"]]],[11,"get_type_id","","",152,[[["self"]],["typeid"]]],[11,"encode","","",152,[[["self"],["e"]],["result"]]],[11,"decode","","",152,[[["d"]],["result"]]],[11,"not_found","","",152,[[["str"],["str"]],["e"]]],[11,"to_owned","","",153,[[["self"]],["t"]]],[11,"clone_into","","",153,N],[11,"from","","",153,[[["t"]],["t"]]],[11,"into","","",153,[[["self"]],["u"]]],[11,"try_from","","",153,[[["u"]],["result"]]],[11,"borrow","","",153,[[["self"]],["t"]]],[11,"try_into","","",153,[[["self"]],["result"]]],[11,"borrow_mut","","",153,[[["self"]],["t"]]],[11,"get_type_id","","",153,[[["self"]],["typeid"]]],[11,"encode","","",153,[[["self"],["e"]],["result"]]],[11,"decode","","",153,[[["d"]],["result"]]],[11,"not_found","","",153,[[["str"],["str"]],["e"]]],[11,"to_owned","","",154,[[["self"]],["t"]]],[11,"clone_into","","",154,N],[11,"from","","",154,[[["t"]],["t"]]],[11,"into","","",154,[[["self"]],["u"]]],[11,"try_from","","",154,[[["u"]],["result"]]],[11,"borrow","","",154,[[["self"]],["t"]]],[11,"try_into","","",154,[[["self"]],["result"]]],[11,"borrow_mut","","",154,[[["self"]],["t"]]],[11,"get_type_id","","",154,[[["self"]],["typeid"]]],[11,"encode","","",154,[[["self"],["e"]],["result"]]],[11,"decode","","",154,[[["d"]],["result"]]],[11,"not_found","","",154,[[["str"],["str"]],["e"]]],[11,"to_owned","","",155,[[["self"]],["t"]]],[11,"clone_into","","",155,N],[11,"from","","",155,[[["t"]],["t"]]],[11,"into","","",155,[[["self"]],["u"]]],[11,"try_from","","",155,[[["u"]],["result"]]],[11,"borrow","","",155,[[["self"]],["t"]]],[11,"try_into","","",155,[[["self"]],["result"]]],[11,"borrow_mut","","",155,[[["self"]],["t"]]],[11,"get_type_id","","",155,[[["self"]],["typeid"]]],[11,"not_found","","",155,[[["str"],["str"]],["e"]]],[11,"from","syntax::attr::builtin","",156,[[["t"]],["t"]]],[11,"into","","",156,[[["self"]],["u"]]],[11,"try_from","","",156,[[["u"]],["result"]]],[11,"borrow","","",156,[[["self"]],["t"]]],[11,"try_into","","",156,[[["self"]],["result"]]],[11,"borrow_mut","","",156,[[["self"]],["t"]]],[11,"get_type_id","","",156,[[["self"]],["typeid"]]],[11,"not_found","","",156,[[["str"],["str"]],["e"]]],[11,"attrs","syntax::source_map","",190,N],[11,"map_attrs","","",190,[[["self"],["f"]],["self"]]],[11,"attrs","syntax::ptr","",243,N],[11,"map_attrs","","",243,[[["self"],["f"]],["self"]]],[11,"empty","syntax::ext::hygiene","",160,[[],["syntaxcontext"]]],[11,"allocate_directly","","",160,[[["expninfo"]],["syntaxcontext"]]],[11,"apply_mark","","Extend a syntax context with a given mark and default transparency for that mark.",160,[[["self"],["mark"]],["syntaxcontext"]]],[11,"apply_mark_with_transparency","","Extend a syntax context with a given mark and transparency",160,[[["self"],["mark"],["transparency"]],["syntaxcontext"]]],[11,"remove_mark","","Pulls a single mark off of the syntax context. This effectively moves the context up one macro definition level. That is, if we have a nested macro definition as follows:",160,[[["self"]],["mark"]]],[11,"marks","","",160,[[["self"]],["vec"]]],[11,"adjust","","Adjust this context for resolution in a scope created by the given expansion. For example, consider the following three resolutions of `f`:",160,[[["self"],["mark"]],["option",["mark"]]]],[11,"glob_adjust","","Adjust this context for resolution in a scope created by the given expansion via a glob import with the given `SyntaxContext`. For example:",160,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"reverse_glob_adjust","","Undo `glob_adjust` if possible:",160,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"modern","","",160,[[["self"]],["syntaxcontext"]]],[11,"modern_and_legacy","","",160,[[["self"]],["syntaxcontext"]]],[11,"outer","","",160,[[["self"]],["mark"]]],[11,"to_owned","","",160,[[["self"]],["t"]]],[11,"clone_into","","",160,N],[11,"from","","",160,[[["t"]],["t"]]],[11,"into","","",160,[[["self"]],["u"]]],[11,"try_from","","",160,[[["u"]],["result"]]],[11,"borrow","","",160,[[["self"]],["t"]]],[11,"try_into","","",160,[[["self"]],["result"]]],[11,"borrow_mut","","",160,[[["self"]],["t"]]],[11,"get_type_id","","",160,[[["self"]],["typeid"]]],[11,"encode","","",160,[[["self"],["e"]],["result"]]],[11,"decode","","",160,[[["d"]],["result"]]],[11,"not_found","","",160,[[["str"],["str"]],["e"]]],[11,"fresh","","",161,[[["mark"]],["mark"]]],[11,"root","","The mark of the theoretical expansion that generates freshly parsed, unexpanded AST.",161,[[],["mark"]]],[11,"as_u32","","",161,[[["self"]],["u32"]]],[11,"from_u32","","",161,[[["u32"]],["mark"]]],[11,"parent","","",161,[[["self"]],["mark"]]],[11,"expn_info","","",161,[[["self"]],["option",["expninfo"]]]],[11,"set_expn_info","","",161,N],[11,"set_default_transparency","","",161,N],[11,"is_builtin","","",161,[[["self"]],["bool"]]],[11,"set_is_builtin","","",161,N],[11,"is_descendant_of","","",161,[[["self"],["mark"]],["bool"]]],[11,"least_ancestor","","Computes a mark such that both input marks are descendants of (or equal to) the returned mark. That is, the following holds:",161,[[["mark"],["mark"]],["mark"]]],[11,"looks_like_proc_macro_derive","","",161,[[["self"]],["bool"]]],[11,"to_owned","","",161,[[["self"]],["t"]]],[11,"clone_into","","",161,N],[11,"from","","",161,[[["t"]],["t"]]],[11,"into","","",161,[[["self"]],["u"]]],[11,"try_from","","",161,[[["u"]],["result"]]],[11,"borrow","","",161,[[["self"]],["t"]]],[11,"try_into","","",161,[[["self"]],["result"]]],[11,"borrow_mut","","",161,[[["self"]],["t"]]],[11,"get_type_id","","",161,[[["self"]],["typeid"]]],[11,"encode","","",161,[[["self"],["e"]],["result"]]],[11,"decode","","",161,[[["d"]],["result"]]],[11,"not_found","","",161,[[["str"],["str"]],["e"]]],[11,"to_owned","","",162,[[["self"]],["t"]]],[11,"clone_into","","",162,N],[11,"from","","",162,[[["t"]],["t"]]],[11,"into","","",162,[[["self"]],["u"]]],[11,"try_from","","",162,[[["u"]],["result"]]],[11,"borrow","","",162,[[["self"]],["t"]]],[11,"try_into","","",162,[[["self"]],["result"]]],[11,"borrow_mut","","",162,[[["self"]],["t"]]],[11,"get_type_id","","",162,[[["self"]],["typeid"]]],[11,"not_found","","",162,[[["str"],["str"]],["e"]]],[11,"to_owned","","",163,[[["self"]],["t"]]],[11,"clone_into","","",163,N],[11,"from","","",163,[[["t"]],["t"]]],[11,"into","","",163,[[["self"]],["u"]]],[11,"try_from","","",163,[[["u"]],["result"]]],[11,"borrow","","",163,[[["self"]],["t"]]],[11,"try_into","","",163,[[["self"]],["result"]]],[11,"borrow_mut","","",163,[[["self"]],["t"]]],[11,"get_type_id","","",163,[[["self"]],["typeid"]]],[11,"encode","","",163,[[["self"],["e"]],["result"]]],[11,"decode","","",163,[[["d"]],["result"]]],[11,"not_found","","",163,[[["str"],["str"]],["e"]]],[11,"name","","",164,[[["self"]],["symbol"]]],[11,"to_owned","","",164,[[["self"]],["t"]]],[11,"clone_into","","",164,N],[11,"from","","",164,[[["t"]],["t"]]],[11,"into","","",164,[[["self"]],["u"]]],[11,"try_from","","",164,[[["u"]],["result"]]],[11,"borrow","","",164,[[["self"]],["t"]]],[11,"try_into","","",164,[[["self"]],["result"]]],[11,"borrow_mut","","",164,[[["self"]],["t"]]],[11,"get_type_id","","",164,[[["self"]],["typeid"]]],[11,"encode","","",164,[[["self"],["e"]],["result"]]],[11,"decode","","",164,[[["d"]],["result"]]],[11,"not_found","","",164,[[["str"],["str"]],["e"]]],[11,"name","","",165,[[["self"]],["symbol"]]],[11,"to_owned","","",165,[[["self"]],["t"]]],[11,"clone_into","","",165,N],[11,"from","","",165,[[["t"]],["t"]]],[11,"into","","",165,[[["self"]],["u"]]],[11,"try_from","","",165,[[["u"]],["result"]]],[11,"borrow","","",165,[[["self"]],["t"]]],[11,"try_into","","",165,[[["self"]],["result"]]],[11,"borrow_mut","","",165,[[["self"]],["t"]]],[11,"get_type_id","","",165,[[["self"]],["typeid"]]],[11,"encode","","",165,[[["self"],["e"]],["result"]]],[11,"decode","","",165,[[["d"]],["result"]]],[11,"not_found","","",165,[[["str"],["str"]],["e"]]],[11,"new","syntax::source_map","",166,[[],["globals"]]],[11,"from","","",166,[[["t"]],["t"]]],[11,"into","","",166,[[["self"]],["u"]]],[11,"try_from","","",166,[[["u"]],["result"]]],[11,"borrow","","",166,[[["self"]],["t"]]],[11,"try_into","","",166,[[["self"]],["result"]]],[11,"borrow_mut","","",166,[[["self"]],["t"]]],[11,"get_type_id","","",166,[[["self"]],["typeid"]]],[11,"not_found","","",166,[[["str"],["str"]],["e"]]],[11,"is_real","syntax::ext::quote::rt","",167,[[["self"]],["bool"]]],[11,"is_macros","","",167,[[["self"]],["bool"]]],[11,"to_owned","","",167,[[["self"]],["t"]]],[11,"clone_into","","",167,N],[11,"from","","",167,[[["t"]],["t"]]],[11,"to_string","","",167,[[["self"]],["string"]]],[11,"into","","",167,[[["self"]],["u"]]],[11,"try_from","","",167,[[["u"]],["result"]]],[11,"borrow","","",167,[[["self"]],["t"]]],[11,"try_into","","",167,[[["self"]],["result"]]],[11,"borrow_mut","","",167,[[["self"]],["t"]]],[11,"get_type_id","","",167,[[["self"]],["typeid"]]],[11,"encode","","",167,[[["self"],["e"]],["result"]]],[11,"decode","","",167,[[["d"]],["result"]]],[11,"not_found","","",167,[[["str"],["str"]],["e"]]],[11,"with_lo","syntax::source_map","",168,[[["self"],["bytepos"]],["span"]]],[11,"with_hi","","",168,[[["self"],["bytepos"]],["span"]]],[11,"with_ctxt","","",168,[[["self"],["syntaxcontext"]],["span"]]],[11,"to_owned","","",168,[[["self"]],["t"]]],[11,"clone_into","","",168,N],[11,"from","","",168,[[["t"]],["t"]]],[11,"into","","",168,[[["self"]],["u"]]],[11,"try_from","","",168,[[["u"]],["result"]]],[11,"borrow","","",168,[[["self"]],["t"]]],[11,"try_into","","",168,[[["self"]],["result"]]],[11,"borrow_mut","","",168,[[["self"]],["t"]]],[11,"get_type_id","","",168,[[["self"]],["typeid"]]],[11,"not_found","","",168,[[["str"],["str"]],["e"]]],[11,"new","","",169,[[],["multispan"]]],[11,"from_span","","",169,[[["span"]],["multispan"]]],[11,"from_spans","","",169,[[["vec",["span"]]],["multispan"]]],[11,"push_span_label","","",169,N],[11,"primary_span","","Selects the first primary span (if any)",169,[[["self"]],["option",["span"]]]],[11,"primary_spans","","Returns all primary spans.",169,N],[11,"replace","","Replaces all occurrences of one Span with another. Used to move Spans in areas that don't display well (like std macros). Returns true if replacements occurred.",169,[[["self"],["span"],["span"]],["bool"]]],[11,"span_labels","","Returns the strings to highlight. We always ensure that there is an entry for each of the primary spans -- for each primary span P, if there is at least one label with span P, we return those labels (marked as primary). But otherwise we return `SpanLabel` instances with empty labels.",169,[[["self"]],["vec",["spanlabel"]]]],[11,"to_owned","","",169,[[["self"]],["t"]]],[11,"clone_into","","",169,N],[11,"from","","",169,[[["t"]],["t"]]],[11,"into","","",169,[[["self"]],["u"]]],[11,"try_from","","",169,[[["u"]],["result"]]],[11,"borrow","","",169,[[["self"]],["t"]]],[11,"try_into","","",169,[[["self"]],["result"]]],[11,"borrow_mut","","",169,[[["self"]],["t"]]],[11,"get_type_id","","",169,[[["self"]],["typeid"]]],[11,"encode","","",169,[[["self"],["e"]],["result"]]],[11,"decode","","",169,[[["d"]],["result"]]],[11,"not_found","","",169,[[["str"],["str"]],["e"]]],[11,"to_owned","","",170,[[["self"]],["t"]]],[11,"clone_into","","",170,N],[11,"from","","",170,[[["t"]],["t"]]],[11,"into","","",170,[[["self"]],["u"]]],[11,"try_from","","",170,[[["u"]],["result"]]],[11,"borrow","","",170,[[["self"]],["t"]]],[11,"try_into","","",170,[[["self"]],["result"]]],[11,"borrow_mut","","",170,[[["self"]],["t"]]],[11,"get_type_id","","",170,[[["self"]],["typeid"]]],[11,"not_found","","",170,[[["str"],["str"]],["e"]]],[11,"to_owned","","",171,[[["self"]],["t"]]],[11,"clone_into","","",171,N],[11,"from","","",171,[[["t"]],["t"]]],[11,"into","","",171,[[["self"]],["u"]]],[11,"try_from","","",171,[[["u"]],["result"]]],[11,"borrow","","",171,[[["self"]],["t"]]],[11,"try_into","","",171,[[["self"]],["result"]]],[11,"borrow_mut","","",171,[[["self"]],["t"]]],[11,"get_type_id","","",171,[[["self"]],["typeid"]]],[11,"encode","","",171,[[["self"],["e"]],["result"]]],[11,"decode","","",171,[[["d"]],["result"]]],[11,"not_found","","",171,[[["str"],["str"]],["e"]]],[11,"pos","","Returns the absolute offset of the character in the SourceMap",172,[[["self"]],["bytepos"]]],[11,"width","","Returns the width of the character, 0 (zero-width) or 2 (wide)",172,[[["self"]],["usize"]]],[11,"to_owned","","",172,[[["self"]],["t"]]],[11,"clone_into","","",172,N],[11,"from","","",172,[[["t"]],["t"]]],[11,"into","","",172,[[["self"]],["u"]]],[11,"try_from","","",172,[[["u"]],["result"]]],[11,"borrow","","",172,[[["self"]],["t"]]],[11,"try_into","","",172,[[["self"]],["result"]]],[11,"borrow_mut","","",172,[[["self"]],["t"]]],[11,"get_type_id","","",172,[[["self"]],["typeid"]]],[11,"encode","","",172,[[["self"],["e"]],["result"]]],[11,"decode","","",172,[[["d"]],["result"]]],[11,"not_found","","",172,[[["str"],["str"]],["e"]]],[11,"is_absent","","",173,[[["self"]],["bool"]]],[11,"get_source","","",173,[[["self"]],["option",["str"]]]],[11,"to_owned","","",173,[[["self"]],["t"]]],[11,"clone_into","","",173,N],[11,"from","","",173,[[["t"]],["t"]]],[11,"into","","",173,[[["self"]],["u"]]],[11,"try_from","","",173,[[["u"]],["result"]]],[11,"borrow","","",173,[[["self"]],["t"]]],[11,"try_into","","",173,[[["self"]],["result"]]],[11,"borrow_mut","","",173,[[["self"]],["t"]]],[11,"get_type_id","","",173,[[["self"]],["typeid"]]],[11,"not_found","","",173,[[["str"],["str"]],["e"]]],[11,"new","","",174,[[["filename"],["bool"],["filename"],["string"],["bytepos"]],["sourcefile"]]],[11,"line_begin_pos","","Return the BytePos of the beginning of the current line.",174,[[["self"],["bytepos"]],["bytepos"]]],[11,"add_external_src","","Add externally loaded source. If the hash of the input doesn't match or no input is supplied via None, it is interpreted as an error and the corresponding enum variant is set. The return value signifies whether some kind of source is present.",174,[[["self"],["f"]],["bool"]]],[11,"get_line","","Get a line from the list of pre-computed line-beginnings. The line number here is 0-based.",174,[[["self"],["usize"]],["option",["cow"]]]],[11,"is_real_file","","",174,[[["self"]],["bool"]]],[11,"is_imported","","",174,[[["self"]],["bool"]]],[11,"byte_length","","",174,[[["self"]],["u32"]]],[11,"count_lines","","",174,[[["self"]],["usize"]]],[11,"lookup_line","","Find the line containing the given position. The return value is the index into the `lines` array of this SourceFile, not the 1-based line number. If the source_file is empty or the position is located before the first line, None is returned.",174,[[["self"],["bytepos"]],["option",["usize"]]]],[11,"line_bounds","","",174,N],[11,"contains","","",174,[[["self"],["bytepos"]],["bool"]]],[11,"to_owned","","",174,[[["self"]],["t"]]],[11,"clone_into","","",174,N],[11,"from","","",174,[[["t"]],["t"]]],[11,"into","","",174,[[["self"]],["u"]]],[11,"try_from","","",174,[[["u"]],["result"]]],[11,"borrow","","",174,[[["self"]],["t"]]],[11,"try_into","","",174,[[["self"]],["result"]]],[11,"borrow_mut","","",174,[[["self"]],["t"]]],[11,"get_type_id","","",174,[[["self"]],["typeid"]]],[11,"encode","","",174,[[["self"],["e"]],["result"]]],[11,"decode","","",174,[[["d"]],["result"]]],[11,"not_found","","",174,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::ext::quote::rt","",176,[[["self"]],["t"]]],[11,"clone_into","","",176,N],[11,"from","","",176,[[["t"]],["t"]]],[11,"into","","",176,[[["self"]],["u"]]],[11,"try_from","","",176,[[["u"]],["result"]]],[11,"borrow","","",176,[[["self"]],["t"]]],[11,"try_into","","",176,[[["self"]],["result"]]],[11,"borrow_mut","","",176,[[["self"]],["t"]]],[11,"get_type_id","","",176,[[["self"]],["typeid"]]],[11,"encode","","",176,[[["self"],["e"]],["result"]]],[11,"decode","","",176,[[["d"]],["result"]]],[11,"not_found","","",176,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::source_map","",177,[[["self"]],["t"]]],[11,"clone_into","","",177,N],[11,"from","","",177,[[["t"]],["t"]]],[11,"into","","",177,[[["self"]],["u"]]],[11,"try_from","","",177,[[["u"]],["result"]]],[11,"borrow","","",177,[[["self"]],["t"]]],[11,"try_into","","",177,[[["self"]],["result"]]],[11,"borrow_mut","","",177,[[["self"]],["t"]]],[11,"get_type_id","","",177,[[["self"]],["typeid"]]],[11,"not_found","","",177,[[["str"],["str"]],["e"]]],[11,"to_owned","","",178,[[["self"]],["t"]]],[11,"clone_into","","",178,N],[11,"from","","",178,[[["t"]],["t"]]],[11,"into","","",178,[[["self"]],["u"]]],[11,"try_from","","",178,[[["u"]],["result"]]],[11,"borrow","","",178,[[["self"]],["t"]]],[11,"try_into","","",178,[[["self"]],["result"]]],[11,"borrow_mut","","",178,[[["self"]],["t"]]],[11,"get_type_id","","",178,[[["self"]],["typeid"]]],[11,"not_found","","",178,[[["str"],["str"]],["e"]]],[11,"from","","",179,[[["t"]],["t"]]],[11,"into","","",179,[[["self"]],["u"]]],[11,"try_from","","",179,[[["u"]],["result"]]],[11,"borrow","","",179,[[["self"]],["t"]]],[11,"try_into","","",179,[[["self"]],["result"]]],[11,"borrow_mut","","",179,[[["self"]],["t"]]],[11,"get_type_id","","",179,[[["self"]],["typeid"]]],[11,"not_found","","",179,[[["str"],["str"]],["e"]]],[11,"from","","",180,[[["t"]],["t"]]],[11,"into","","",180,[[["self"]],["u"]]],[11,"try_from","","",180,[[["u"]],["result"]]],[11,"borrow","","",180,[[["self"]],["t"]]],[11,"try_into","","",180,[[["self"]],["result"]]],[11,"borrow_mut","","",180,[[["self"]],["t"]]],[11,"get_type_id","","",180,[[["self"]],["typeid"]]],[11,"not_found","","",180,[[["str"],["str"]],["e"]]],[11,"from","","",181,[[["t"]],["t"]]],[11,"into","","",181,[[["self"]],["u"]]],[11,"try_from","","",181,[[["u"]],["result"]]],[11,"borrow","","",181,[[["self"]],["t"]]],[11,"try_into","","",181,[[["self"]],["result"]]],[11,"borrow_mut","","",181,[[["self"]],["t"]]],[11,"get_type_id","","",181,[[["self"]],["typeid"]]],[11,"not_found","","",181,[[["str"],["str"]],["e"]]],[11,"to_owned","","",182,[[["self"]],["t"]]],[11,"clone_into","","",182,N],[11,"from","","",182,[[["t"]],["t"]]],[11,"into","","",182,[[["self"]],["u"]]],[11,"try_from","","",182,[[["u"]],["result"]]],[11,"borrow","","",182,[[["self"]],["t"]]],[11,"try_into","","",182,[[["self"]],["result"]]],[11,"borrow_mut","","",182,[[["self"]],["t"]]],[11,"get_type_id","","",182,[[["self"]],["typeid"]]],[11,"not_found","","",182,[[["str"],["str"]],["e"]]],[11,"from","","",183,[[["t"]],["t"]]],[11,"into","","",183,[[["self"]],["u"]]],[11,"try_from","","",183,[[["u"]],["result"]]],[11,"borrow","","",183,[[["self"]],["t"]]],[11,"try_into","","",183,[[["self"]],["result"]]],[11,"borrow_mut","","",183,[[["self"]],["t"]]],[11,"get_type_id","","",183,[[["self"]],["typeid"]]],[11,"not_found","","",183,[[["str"],["str"]],["e"]]],[11,"from","","",184,[[["t"]],["t"]]],[11,"into","","",184,[[["self"]],["u"]]],[11,"try_from","","",184,[[["u"]],["result"]]],[11,"borrow","","",184,[[["self"]],["t"]]],[11,"try_into","","",184,[[["self"]],["result"]]],[11,"borrow_mut","","",184,[[["self"]],["t"]]],[11,"get_type_id","","",184,[[["self"]],["typeid"]]],[11,"not_found","","",184,[[["str"],["str"]],["e"]]],[11,"to_owned","","",185,[[["self"]],["t"]]],[11,"clone_into","","",185,N],[11,"from","","",185,[[["t"]],["t"]]],[11,"into","","",185,[[["self"]],["u"]]],[11,"try_from","","",185,[[["u"]],["result"]]],[11,"borrow","","",185,[[["self"]],["t"]]],[11,"try_into","","",185,[[["self"]],["result"]]],[11,"borrow_mut","","",185,[[["self"]],["t"]]],[11,"get_type_id","","",185,[[["self"]],["typeid"]]],[11,"not_found","","",185,[[["str"],["str"]],["e"]]],[11,"to_owned","","",186,[[["self"]],["t"]]],[11,"clone_into","","",186,N],[11,"from","","",186,[[["t"]],["t"]]],[11,"into","","",186,[[["self"]],["u"]]],[11,"try_from","","",186,[[["u"]],["result"]]],[11,"borrow","","",186,[[["self"]],["t"]]],[11,"try_into","","",186,[[["self"]],["result"]]],[11,"borrow_mut","","",186,[[["self"]],["t"]]],[11,"get_type_id","","",186,[[["self"]],["typeid"]]],[11,"not_found","","",186,[[["str"],["str"]],["e"]]],[11,"to_owned","","",187,[[["self"]],["t"]]],[11,"clone_into","","",187,N],[11,"from","","",187,[[["t"]],["t"]]],[11,"into","","",187,[[["self"]],["u"]]],[11,"try_from","","",187,[[["u"]],["result"]]],[11,"borrow","","",187,[[["self"]],["t"]]],[11,"try_into","","",187,[[["self"]],["result"]]],[11,"borrow_mut","","",187,[[["self"]],["t"]]],[11,"get_type_id","","",187,[[["self"]],["typeid"]]],[11,"not_found","","",187,[[["str"],["str"]],["e"]]],[11,"to_owned","","",188,[[["self"]],["t"]]],[11,"clone_into","","",188,N],[11,"from","","",188,[[["t"]],["t"]]],[11,"into","","",188,[[["self"]],["u"]]],[11,"try_from","","",188,[[["u"]],["result"]]],[11,"borrow","","",188,[[["self"]],["t"]]],[11,"try_into","","",188,[[["self"]],["result"]]],[11,"borrow_mut","","",188,[[["self"]],["t"]]],[11,"get_type_id","","",188,[[["self"]],["typeid"]]],[11,"not_found","","",188,[[["str"],["str"]],["e"]]],[11,"new","syntax::ext::quote::rt","",189,[[["bytepos"],["bytepos"],["syntaxcontext"]],["span"]]],[11,"data","","",189,[[["self"]],["spandata"]]],[11,"lo","","",189,[[["self"]],["bytepos"]]],[11,"with_lo","","",189,[[["self"],["bytepos"]],["span"]]],[11,"hi","","",189,[[["self"]],["bytepos"]]],[11,"with_hi","","",189,[[["self"],["bytepos"]],["span"]]],[11,"ctxt","","",189,[[["self"]],["syntaxcontext"]]],[11,"with_ctxt","","",189,[[["self"],["syntaxcontext"]],["span"]]],[11,"is_dummy","","Returns `true` if this is a dummy span with any hygienic context.",189,[[["self"]],["bool"]]],[11,"shrink_to_lo","","Returns a new span representing an empty span at the beginning of this span",189,[[["self"]],["span"]]],[11,"shrink_to_hi","","Returns a new span representing an empty span at the end of this span",189,[[["self"]],["span"]]],[11,"substitute_dummy","","Returns `self` if `self` is not the dummy span, and `other` otherwise.",189,[[["self"],["span"]],["span"]]],[11,"contains","","Return true if `self` fully encloses `other`.",189,[[["self"],["span"]],["bool"]]],[11,"source_equal","","Return true if the spans are equal with regards to the source text.",189,[[["self"],["span"]],["bool"]]],[11,"trim_start","","Returns `Some(span)`, where the start is trimmed by the end of `other`",189,[[["self"],["span"]],["option",["span"]]]],[11,"source_callsite","","Return the source span - this is either the supplied span, or the span for the macro callsite that expanded to it.",189,[[["self"]],["span"]]],[11,"parent","","The `Span` for the tokens in the previous macro expansion from which `self` was generated, if any",189,[[["self"]],["option",["span"]]]],[11,"edition","","Edition of the crate from which this span came.",189,[[["self"]],["edition"]]],[11,"source_callee","","Return the source callee.",189,[[["self"]],["option",["expninfo"]]]],[11,"allows_unstable","","Check if a span is \"internal\" to a macro in which #[unstable] items can be used (that is, a macro marked with `#[allow_internal_unstable]`).",189,[[["self"]],["bool"]]],[11,"is_compiler_desugaring","","Check if this span arises from a compiler desugaring of kind `kind`.",189,[[["self"],["compilerdesugaringkind"]],["bool"]]],[11,"compiler_desugaring_kind","","Return the compiler desugaring that created this span, or None if this span is not from a desugaring.",189,[[["self"]],["option",["compilerdesugaringkind"]]]],[11,"allows_unsafe","","Check if a span is \"internal\" to a macro in which `unsafe` can be used without triggering the `unsafe_code` lint",189,[[["self"]],["bool"]]],[11,"macro_backtrace","","",189,[[["self"]],["vec",["macrobacktrace"]]]],[11,"to","","Return a `Span` that would enclose both `self` and `end`.",189,[[["self"],["span"]],["span"]]],[11,"between","","Return a `Span` between the end of `self` to the beginning of `end`.",189,[[["self"],["span"]],["span"]]],[11,"until","","Return a `Span` between the beginning of `self` to the beginning of `end`.",189,[[["self"],["span"]],["span"]]],[11,"from_inner_byte_pos","","",189,[[["self"],["usize"],["usize"]],["span"]]],[11,"apply_mark","","",189,[[["self"],["mark"]],["span"]]],[11,"remove_mark","","",189,[[["self"]],["mark"]]],[11,"adjust","","",189,[[["self"],["mark"]],["option",["mark"]]]],[11,"glob_adjust","","",189,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"reverse_glob_adjust","","",189,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"modern","","",189,[[["self"]],["span"]]],[11,"modern_and_legacy","","",189,[[["self"]],["span"]]],[11,"to_owned","","",189,[[["self"]],["t"]]],[11,"clone_into","","",189,N],[11,"from","","",189,[[["t"]],["t"]]],[11,"into","","",189,[[["self"]],["u"]]],[11,"try_from","","",189,[[["u"]],["result"]]],[11,"borrow","","",189,[[["self"]],["t"]]],[11,"try_into","","",189,[[["self"]],["result"]]],[11,"borrow_mut","","",189,[[["self"]],["t"]]],[11,"get_type_id","","",189,[[["self"]],["typeid"]]],[11,"encode","","",189,[[["self"],["e"]],["result"]]],[11,"decode","","",189,[[["d"]],["result"]]],[11,"not_found","","",189,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::source_map","",190,[[["self"]],["t"]]],[11,"clone_into","","",190,N],[11,"from","","",190,[[["t"]],["t"]]],[11,"into","","",190,[[["self"]],["u"]]],[11,"try_from","","",190,[[["u"]],["result"]]],[11,"borrow","","",190,[[["self"]],["t"]]],[11,"try_into","","",190,[[["self"]],["result"]]],[11,"borrow_mut","","",190,[[["self"]],["t"]]],[11,"get_type_id","","",190,[[["self"]],["typeid"]]],[11,"encode","","",190,[[["self"],["e"]],["result"]]],[11,"decode","","",190,[[["d"]],["result"]]],[11,"not_found","","",190,[[["str"],["str"]],["e"]]],[11,"from","","",196,[[["t"]],["t"]]],[11,"into","","",196,[[["self"]],["u"]]],[11,"try_from","","",196,[[["u"]],["result"]]],[11,"borrow","","",196,[[["self"]],["t"]]],[11,"try_into","","",196,[[["self"]],["result"]]],[11,"borrow_mut","","",196,[[["self"]],["t"]]],[11,"get_type_id","","",196,[[["self"]],["typeid"]]],[11,"not_found","","",196,[[["str"],["str"]],["e"]]],[11,"to_owned","","",191,[[["self"]],["t"]]],[11,"clone_into","","",191,N],[11,"from","","",191,[[["t"]],["t"]]],[11,"into","","",191,[[["self"]],["u"]]],[11,"try_from","","",191,[[["u"]],["result"]]],[11,"borrow","","",191,[[["self"]],["t"]]],[11,"try_into","","",191,[[["self"]],["result"]]],[11,"borrow_mut","","",191,[[["self"]],["t"]]],[11,"get_type_id","","",191,[[["self"]],["typeid"]]],[11,"encode","","",191,[[["self"],["e"]],["result"]]],[11,"decode","","",191,[[["d"]],["result"]]],[11,"not_found","","",191,[[["str"],["str"]],["e"]]],[11,"from","","",192,[[["t"]],["t"]]],[11,"into","","",192,[[["self"]],["u"]]],[11,"try_from","","",192,[[["u"]],["result"]]],[11,"borrow","","",192,[[["self"]],["t"]]],[11,"try_into","","",192,[[["self"]],["result"]]],[11,"borrow_mut","","",192,[[["self"]],["t"]]],[11,"get_type_id","","",192,[[["self"]],["typeid"]]],[11,"not_found","","",192,[[["str"],["str"]],["e"]]],[11,"from","","",193,[[["t"]],["t"]]],[11,"into","","",193,[[["self"]],["u"]]],[11,"try_from","","",193,[[["u"]],["result"]]],[11,"borrow","","",193,[[["self"]],["t"]]],[11,"try_into","","",193,[[["self"]],["result"]]],[11,"borrow_mut","","",193,[[["self"]],["t"]]],[11,"get_type_id","","",193,[[["self"]],["typeid"]]],[11,"not_found","","",193,[[["str"],["str"]],["e"]]],[11,"to_owned","","",194,[[["self"]],["t"]]],[11,"clone_into","","",194,N],[11,"from","","",194,[[["t"]],["t"]]],[11,"into","","",194,[[["self"]],["u"]]],[11,"try_from","","",194,[[["u"]],["result"]]],[11,"borrow","","",194,[[["self"]],["t"]]],[11,"try_into","","",194,[[["self"]],["result"]]],[11,"borrow_mut","","",194,[[["self"]],["t"]]],[11,"get_type_id","","",194,[[["self"]],["typeid"]]],[11,"not_found","","",194,[[["str"],["str"]],["e"]]],[11,"from","syntax::config","",197,[[["t"]],["t"]]],[11,"into","","",197,[[["self"]],["u"]]],[11,"try_from","","",197,[[["u"]],["result"]]],[11,"borrow","","",197,[[["self"]],["t"]]],[11,"try_into","","",197,[[["self"]],["result"]]],[11,"borrow_mut","","",197,[[["self"]],["t"]]],[11,"get_type_id","","",197,[[["self"]],["typeid"]]],[11,"not_found","","",197,[[["str"],["str"]],["e"]]],[11,"from","syntax::entry","",198,[[["t"]],["t"]]],[11,"into","","",198,[[["self"]],["u"]]],[11,"try_from","","",198,[[["u"]],["result"]]],[11,"borrow","","",198,[[["self"]],["t"]]],[11,"try_into","","",198,[[["self"]],["result"]]],[11,"borrow_mut","","",198,[[["self"]],["t"]]],[11,"get_type_id","","",198,[[["self"]],["typeid"]]],[11,"not_found","","",198,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::feature_gate","",199,[[["self"]],["t"]]],[11,"clone_into","","",199,N],[11,"from","","",199,[[["t"]],["t"]]],[11,"into","","",199,[[["self"]],["u"]]],[11,"try_from","","",199,[[["u"]],["result"]]],[11,"borrow","","",199,[[["self"]],["t"]]],[11,"try_into","","",199,[[["self"]],["result"]]],[11,"borrow_mut","","",199,[[["self"]],["t"]]],[11,"get_type_id","","",199,[[["self"]],["typeid"]]],[11,"not_found","","",199,[[["str"],["str"]],["e"]]],[11,"from","","",200,[[["t"]],["t"]]],[11,"into","","",200,[[["self"]],["u"]]],[11,"try_from","","",200,[[["u"]],["result"]]],[11,"borrow","","",200,[[["self"]],["t"]]],[11,"try_into","","",200,[[["self"]],["result"]]],[11,"borrow_mut","","",200,[[["self"]],["t"]]],[11,"get_type_id","","",200,[[["self"]],["typeid"]]],[11,"not_found","","",200,[[["str"],["str"]],["e"]]],[11,"from","","",201,[[["t"]],["t"]]],[11,"into","","",201,[[["self"]],["u"]]],[11,"try_from","","",201,[[["u"]],["result"]]],[11,"borrow","","",201,[[["self"]],["t"]]],[11,"try_into","","",201,[[["self"]],["result"]]],[11,"borrow_mut","","",201,[[["self"]],["t"]]],[11,"get_type_id","","",201,[[["self"]],["typeid"]]],[11,"not_found","","",201,[[["str"],["str"]],["e"]]],[11,"from","","",202,[[["t"]],["t"]]],[11,"into","","",202,[[["self"]],["u"]]],[11,"try_from","","",202,[[["u"]],["result"]]],[11,"borrow","","",202,[[["self"]],["t"]]],[11,"try_into","","",202,[[["self"]],["result"]]],[11,"borrow_mut","","",202,[[["self"]],["t"]]],[11,"get_type_id","","",202,[[["self"]],["typeid"]]],[11,"not_found","","",202,[[["str"],["str"]],["e"]]],[11,"to_owned","","",203,[[["self"]],["t"]]],[11,"clone_into","","",203,N],[11,"from","","",203,[[["t"]],["t"]]],[11,"into","","",203,[[["self"]],["u"]]],[11,"try_from","","",203,[[["u"]],["result"]]],[11,"borrow","","",203,[[["self"]],["t"]]],[11,"try_into","","",203,[[["self"]],["result"]]],[11,"borrow_mut","","",203,[[["self"]],["t"]]],[11,"get_type_id","","",203,[[["self"]],["typeid"]]],[11,"not_found","","",203,[[["str"],["str"]],["e"]]],[11,"from","","",204,[[["t"]],["t"]]],[11,"into","","",204,[[["self"]],["u"]]],[11,"try_from","","",204,[[["u"]],["result"]]],[11,"borrow","","",204,[[["self"]],["t"]]],[11,"try_into","","",204,[[["self"]],["result"]]],[11,"borrow_mut","","",204,[[["self"]],["t"]]],[11,"get_type_id","","",204,[[["self"]],["typeid"]]],[11,"not_found","","",204,[[["str"],["str"]],["e"]]],[11,"to_owned","","",205,[[["self"]],["t"]]],[11,"clone_into","","",205,N],[11,"from","","",205,[[["t"]],["t"]]],[11,"into","","",205,[[["self"]],["u"]]],[11,"try_from","","",205,[[["u"]],["result"]]],[11,"borrow","","",205,[[["self"]],["t"]]],[11,"try_into","","",205,[[["self"]],["result"]]],[11,"borrow_mut","","",205,[[["self"]],["t"]]],[11,"get_type_id","","",205,[[["self"]],["typeid"]]],[11,"not_found","","",205,[[["str"],["str"]],["e"]]],[11,"from","","",206,[[["t"]],["t"]]],[11,"into","","",206,[[["self"]],["u"]]],[11,"try_from","","",206,[[["u"]],["result"]]],[11,"borrow","","",206,[[["self"]],["t"]]],[11,"try_into","","",206,[[["self"]],["result"]]],[11,"borrow_mut","","",206,[[["self"]],["t"]]],[11,"get_type_id","","",206,[[["self"]],["typeid"]]],[11,"not_found","","",206,[[["str"],["str"]],["e"]]],[11,"to_owned","","",207,[[["self"]],["t"]]],[11,"clone_into","","",207,N],[11,"from","","",207,[[["t"]],["t"]]],[11,"into","","",207,[[["self"]],["u"]]],[11,"try_from","","",207,[[["u"]],["result"]]],[11,"borrow","","",207,[[["self"]],["t"]]],[11,"try_into","","",207,[[["self"]],["result"]]],[11,"borrow_mut","","",207,[[["self"]],["t"]]],[11,"get_type_id","","",207,[[["self"]],["typeid"]]],[11,"not_found","","",207,[[["str"],["str"]],["e"]]],[11,"to_owned","","",208,[[["self"]],["t"]]],[11,"clone_into","","",208,N],[11,"from","","",208,[[["t"]],["t"]]],[11,"into","","",208,[[["self"]],["u"]]],[11,"try_from","","",208,[[["u"]],["result"]]],[11,"borrow","","",208,[[["self"]],["t"]]],[11,"try_into","","",208,[[["self"]],["result"]]],[11,"borrow_mut","","",208,[[["self"]],["t"]]],[11,"get_type_id","","",208,[[["self"]],["typeid"]]],[11,"not_found","","",208,[[["str"],["str"]],["e"]]],[11,"from","syntax::parse","",210,[[["t"]],["t"]]],[11,"into","","",210,[[["self"]],["u"]]],[11,"try_from","","",210,[[["u"]],["result"]]],[11,"borrow","","",210,[[["self"]],["t"]]],[11,"try_into","","",210,[[["self"]],["result"]]],[11,"borrow_mut","","",210,[[["self"]],["t"]]],[11,"get_type_id","","",210,[[["self"]],["typeid"]]],[11,"not_found","","",210,[[["str"],["str"]],["e"]]],[11,"to_owned","","",211,[[["self"]],["t"]]],[11,"clone_into","","",211,N],[11,"from","","",211,[[["t"]],["t"]]],[11,"into","","",211,[[["self"]],["u"]]],[11,"try_from","","",211,[[["u"]],["result"]]],[11,"borrow","","",211,[[["self"]],["t"]]],[11,"try_into","","",211,[[["self"]],["result"]]],[11,"borrow_mut","","",211,[[["self"]],["t"]]],[11,"get_type_id","","",211,[[["self"]],["typeid"]]],[11,"not_found","","",211,[[["str"],["str"]],["e"]]],[11,"from","","",212,[[["t"]],["t"]]],[11,"into","","",212,[[["self"]],["u"]]],[11,"try_from","","",212,[[["u"]],["result"]]],[11,"borrow","","",212,[[["self"]],["t"]]],[11,"try_into","","",212,[[["self"]],["result"]]],[11,"borrow_mut","","",212,[[["self"]],["t"]]],[11,"get_type_id","","",212,[[["self"]],["typeid"]]],[11,"not_found","","",212,[[["str"],["str"]],["e"]]],[11,"to_owned","","",213,[[["self"]],["t"]]],[11,"clone_into","","",213,N],[11,"from","","",213,[[["t"]],["t"]]],[11,"into","","",213,[[["self"]],["u"]]],[11,"try_from","","",213,[[["u"]],["result"]]],[11,"borrow","","",213,[[["self"]],["t"]]],[11,"try_into","","",213,[[["self"]],["result"]]],[11,"borrow_mut","","",213,[[["self"]],["t"]]],[11,"get_type_id","","",213,[[["self"]],["typeid"]]],[11,"not_found","","",213,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::parse::parser","",214,[[["self"]],["t"]]],[11,"clone_into","","",214,N],[11,"from","","",214,[[["t"]],["t"]]],[11,"into","","",214,[[["self"]],["u"]]],[11,"try_from","","",214,[[["u"]],["result"]]],[11,"borrow","","",214,[[["self"]],["t"]]],[11,"try_into","","",214,[[["self"]],["result"]]],[11,"borrow_mut","","",214,[[["self"]],["t"]]],[11,"get_type_id","","",214,[[["self"]],["typeid"]]],[11,"not_found","","",214,[[["str"],["str"]],["e"]]],[11,"to_owned","","",215,[[["self"]],["t"]]],[11,"clone_into","","",215,N],[11,"from","","",215,[[["t"]],["t"]]],[11,"into","","",215,[[["self"]],["u"]]],[11,"try_from","","",215,[[["u"]],["result"]]],[11,"borrow","","",215,[[["self"]],["t"]]],[11,"try_into","","",215,[[["self"]],["result"]]],[11,"borrow_mut","","",215,[[["self"]],["t"]]],[11,"get_type_id","","",215,[[["self"]],["typeid"]]],[11,"not_found","","",215,[[["str"],["str"]],["e"]]],[11,"to_owned","","",216,[[["self"]],["t"]]],[11,"clone_into","","",216,N],[11,"from","","",216,[[["t"]],["t"]]],[11,"into","","",216,[[["self"]],["u"]]],[11,"try_from","","",216,[[["u"]],["result"]]],[11,"borrow","","",216,[[["self"]],["t"]]],[11,"try_into","","",216,[[["self"]],["result"]]],[11,"borrow_mut","","",216,[[["self"]],["t"]]],[11,"get_type_id","","",216,[[["self"]],["typeid"]]],[11,"not_found","","",216,[[["str"],["str"]],["e"]]],[11,"to_owned","","",217,[[["self"]],["t"]]],[11,"clone_into","","",217,N],[11,"from","","",217,[[["t"]],["t"]]],[11,"into","","",217,[[["self"]],["u"]]],[11,"try_from","","",217,[[["u"]],["result"]]],[11,"borrow","","",217,[[["self"]],["t"]]],[11,"try_into","","",217,[[["self"]],["result"]]],[11,"borrow_mut","","",217,[[["self"]],["t"]]],[11,"get_type_id","","",217,[[["self"]],["typeid"]]],[11,"not_found","","",217,[[["str"],["str"]],["e"]]],[11,"from","","",218,[[["t"]],["t"]]],[11,"into","","",218,[[["self"]],["u"]]],[11,"try_from","","",218,[[["u"]],["result"]]],[11,"borrow","","",218,[[["self"]],["t"]]],[11,"try_into","","",218,[[["self"]],["result"]]],[11,"borrow_mut","","",218,[[["self"]],["t"]]],[11,"get_type_id","","",218,[[["self"]],["typeid"]]],[11,"not_found","","",218,[[["str"],["str"]],["e"]]],[11,"from","","",219,[[["t"]],["t"]]],[11,"into","","",219,[[["self"]],["u"]]],[11,"try_from","","",219,[[["u"]],["result"]]],[11,"borrow","","",219,[[["self"]],["t"]]],[11,"try_into","","",219,[[["self"]],["result"]]],[11,"borrow_mut","","",219,[[["self"]],["t"]]],[11,"get_type_id","","",219,[[["self"]],["typeid"]]],[11,"not_found","","",219,[[["str"],["str"]],["e"]]],[11,"from","","",220,[[["t"]],["t"]]],[11,"into","","",220,[[["self"]],["u"]]],[11,"try_from","","",220,[[["u"]],["result"]]],[11,"borrow","","",220,[[["self"]],["t"]]],[11,"try_into","","",220,[[["self"]],["result"]]],[11,"borrow_mut","","",220,[[["self"]],["t"]]],[11,"get_type_id","","",220,[[["self"]],["typeid"]]],[11,"not_found","","",220,[[["str"],["str"]],["e"]]],[11,"to_owned","","",221,[[["self"]],["t"]]],[11,"clone_into","","",221,N],[11,"from","","",221,[[["t"]],["t"]]],[11,"into","","",221,[[["self"]],["u"]]],[11,"try_from","","",221,[[["u"]],["result"]]],[11,"borrow","","",221,[[["self"]],["t"]]],[11,"try_into","","",221,[[["self"]],["result"]]],[11,"borrow_mut","","",221,[[["self"]],["t"]]],[11,"get_type_id","","",221,[[["self"]],["typeid"]]],[11,"not_found","","",221,[[["str"],["str"]],["e"]]],[11,"to_owned","","",222,[[["self"]],["t"]]],[11,"clone_into","","",222,N],[11,"from","","",222,[[["t"]],["t"]]],[11,"into","","",222,[[["self"]],["u"]]],[11,"try_from","","",222,[[["u"]],["result"]]],[11,"borrow","","",222,[[["self"]],["t"]]],[11,"try_into","","",222,[[["self"]],["result"]]],[11,"borrow_mut","","",222,[[["self"]],["t"]]],[11,"get_type_id","","",222,[[["self"]],["typeid"]]],[11,"not_found","","",222,[[["str"],["str"]],["e"]]],[11,"to_owned","","",223,[[["self"]],["t"]]],[11,"clone_into","","",223,N],[11,"from","","",223,[[["t"]],["t"]]],[11,"into","","",223,[[["self"]],["u"]]],[11,"try_from","","",223,[[["u"]],["result"]]],[11,"borrow","","",223,[[["self"]],["t"]]],[11,"try_into","","",223,[[["self"]],["result"]]],[11,"borrow_mut","","",223,[[["self"]],["t"]]],[11,"get_type_id","","",223,[[["self"]],["typeid"]]],[11,"not_found","","",223,[[["str"],["str"]],["e"]]],[11,"to_owned","","",224,[[["self"]],["t"]]],[11,"clone_into","","",224,N],[11,"from","","",224,[[["t"]],["t"]]],[11,"into","","",224,[[["self"]],["u"]]],[11,"try_from","","",224,[[["u"]],["result"]]],[11,"borrow","","",224,[[["self"]],["t"]]],[11,"try_into","","",224,[[["self"]],["result"]]],[11,"borrow_mut","","",224,[[["self"]],["t"]]],[11,"get_type_id","","",224,[[["self"]],["typeid"]]],[11,"not_found","","",224,[[["str"],["str"]],["e"]]],[11,"to_owned","","",225,[[["self"]],["t"]]],[11,"clone_into","","",225,N],[11,"from","","",225,[[["t"]],["t"]]],[11,"into","","",225,[[["self"]],["u"]]],[11,"try_from","","",225,[[["u"]],["result"]]],[11,"borrow","","",225,[[["self"]],["t"]]],[11,"try_into","","",225,[[["self"]],["result"]]],[11,"borrow_mut","","",225,[[["self"]],["t"]]],[11,"get_type_id","","",225,[[["self"]],["typeid"]]],[11,"not_found","","",225,[[["str"],["str"]],["e"]]],[11,"to_owned","","",226,[[["self"]],["t"]]],[11,"clone_into","","",226,N],[11,"from","","",226,[[["t"]],["t"]]],[11,"into","","",226,[[["self"]],["u"]]],[11,"try_from","","",226,[[["u"]],["result"]]],[11,"borrow","","",226,[[["self"]],["t"]]],[11,"try_into","","",226,[[["self"]],["result"]]],[11,"borrow_mut","","",226,[[["self"]],["t"]]],[11,"get_type_id","","",226,[[["self"]],["typeid"]]],[11,"not_found","","",226,[[["str"],["str"]],["e"]]],[11,"from","","",227,[[["t"]],["t"]]],[11,"into","","",227,[[["self"]],["u"]]],[11,"try_from","","",227,[[["u"]],["result"]]],[11,"borrow","","",227,[[["self"]],["t"]]],[11,"try_into","","",227,[[["self"]],["result"]]],[11,"borrow_mut","","",227,[[["self"]],["t"]]],[11,"get_type_id","","",227,[[["self"]],["typeid"]]],[11,"not_found","","",227,[[["str"],["str"]],["e"]]],[11,"from","","",228,[[["t"]],["t"]]],[11,"into","","",228,[[["self"]],["u"]]],[11,"try_from","","",228,[[["u"]],["result"]]],[11,"borrow","","",228,[[["self"]],["t"]]],[11,"try_into","","",228,[[["self"]],["result"]]],[11,"borrow_mut","","",228,[[["self"]],["t"]]],[11,"get_type_id","","",228,[[["self"]],["typeid"]]],[11,"not_found","","",228,[[["str"],["str"]],["e"]]],[11,"to_owned","","",229,[[["self"]],["t"]]],[11,"clone_into","","",229,N],[11,"from","","",229,[[["t"]],["t"]]],[11,"into","","",229,[[["self"]],["u"]]],[11,"try_from","","",229,[[["u"]],["result"]]],[11,"borrow","","",229,[[["self"]],["t"]]],[11,"try_into","","",229,[[["self"]],["result"]]],[11,"borrow_mut","","",229,[[["self"]],["t"]]],[11,"get_type_id","","",229,[[["self"]],["typeid"]]],[11,"not_found","","",229,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::parse::lexer","",231,[[["self"]],["t"]]],[11,"clone_into","","",231,N],[11,"from","","",231,[[["t"]],["t"]]],[11,"into","","",231,[[["self"]],["u"]]],[11,"try_from","","",231,[[["u"]],["result"]]],[11,"borrow","","",231,[[["self"]],["t"]]],[11,"try_into","","",231,[[["self"]],["result"]]],[11,"borrow_mut","","",231,[[["self"]],["t"]]],[11,"get_type_id","","",231,[[["self"]],["typeid"]]],[11,"not_found","","",231,[[["str"],["str"]],["e"]]],[11,"from","","",232,[[["t"]],["t"]]],[11,"into","","",232,[[["self"]],["u"]]],[11,"try_from","","",232,[[["u"]],["result"]]],[11,"borrow","","",232,[[["self"]],["t"]]],[11,"try_into","","",232,[[["self"]],["result"]]],[11,"borrow_mut","","",232,[[["self"]],["t"]]],[11,"get_type_id","","",232,[[["self"]],["typeid"]]],[11,"not_found","","",232,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::parse::lexer::comments","",233,[[["self"]],["t"]]],[11,"clone_into","","",233,N],[11,"from","","",233,[[["t"]],["t"]]],[11,"into","","",233,[[["self"]],["u"]]],[11,"try_from","","",233,[[["u"]],["result"]]],[11,"borrow","","",233,[[["self"]],["t"]]],[11,"try_into","","",233,[[["self"]],["result"]]],[11,"borrow_mut","","",233,[[["self"]],["t"]]],[11,"get_type_id","","",233,[[["self"]],["typeid"]]],[11,"not_found","","",233,[[["str"],["str"]],["e"]]],[11,"to_owned","","",234,[[["self"]],["t"]]],[11,"clone_into","","",234,N],[11,"from","","",234,[[["t"]],["t"]]],[11,"into","","",234,[[["self"]],["u"]]],[11,"try_from","","",234,[[["u"]],["result"]]],[11,"borrow","","",234,[[["self"]],["t"]]],[11,"try_into","","",234,[[["self"]],["result"]]],[11,"borrow_mut","","",234,[[["self"]],["t"]]],[11,"get_type_id","","",234,[[["self"]],["typeid"]]],[11,"not_found","","",234,[[["str"],["str"]],["e"]]],[11,"to_owned","","",235,[[["self"]],["t"]]],[11,"clone_into","","",235,N],[11,"from","","",235,[[["t"]],["t"]]],[11,"into","","",235,[[["self"]],["u"]]],[11,"try_from","","",235,[[["u"]],["result"]]],[11,"borrow","","",235,[[["self"]],["t"]]],[11,"try_into","","",235,[[["self"]],["result"]]],[11,"borrow_mut","","",235,[[["self"]],["t"]]],[11,"get_type_id","","",235,[[["self"]],["typeid"]]],[11,"not_found","","",235,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::parse::token","",236,[[["self"]],["t"]]],[11,"clone_into","","",236,N],[11,"from","","",236,[[["t"]],["t"]]],[11,"into","","",236,[[["self"]],["u"]]],[11,"try_from","","",236,[[["u"]],["result"]]],[11,"borrow","","",236,[[["self"]],["t"]]],[11,"try_into","","",236,[[["self"]],["result"]]],[11,"borrow_mut","","",236,[[["self"]],["t"]]],[11,"get_type_id","","",236,[[["self"]],["typeid"]]],[11,"encode","","",236,[[["self"],["e"]],["result"]]],[11,"decode","","",236,[[["d"]],["result"]]],[11,"not_found","","",236,[[["str"],["str"]],["e"]]],[11,"to_owned","","",237,[[["self"]],["t"]]],[11,"clone_into","","",237,N],[11,"from","","",237,[[["t"]],["t"]]],[11,"into","","",237,[[["self"]],["u"]]],[11,"try_from","","",237,[[["u"]],["result"]]],[11,"borrow","","",237,[[["self"]],["t"]]],[11,"try_into","","",237,[[["self"]],["result"]]],[11,"borrow_mut","","",237,[[["self"]],["t"]]],[11,"get_type_id","","",237,[[["self"]],["typeid"]]],[11,"encode","","",237,[[["self"],["e"]],["result"]]],[11,"decode","","",237,[[["d"]],["result"]]],[11,"not_found","","",237,[[["str"],["str"]],["e"]]],[11,"to_owned","","",238,[[["self"]],["t"]]],[11,"clone_into","","",238,N],[11,"from","","",238,[[["t"]],["t"]]],[11,"into","","",238,[[["self"]],["u"]]],[11,"try_from","","",238,[[["u"]],["result"]]],[11,"borrow","","",238,[[["self"]],["t"]]],[11,"try_into","","",238,[[["self"]],["result"]]],[11,"borrow_mut","","",238,[[["self"]],["t"]]],[11,"get_type_id","","",238,[[["self"]],["typeid"]]],[11,"encode","","",238,[[["self"],["e"]],["result"]]],[11,"decode","","",238,[[["d"]],["result"]]],[11,"not_found","","",238,[[["str"],["str"]],["e"]]],[11,"to_owned","","",239,[[["self"]],["t"]]],[11,"clone_into","","",239,N],[11,"from","","",239,[[["t"]],["t"]]],[11,"into","","",239,[[["self"]],["u"]]],[11,"try_from","","",239,[[["u"]],["result"]]],[11,"borrow","","",239,[[["self"]],["t"]]],[11,"try_into","","",239,[[["self"]],["result"]]],[11,"borrow_mut","","",239,[[["self"]],["t"]]],[11,"get_type_id","","",239,[[["self"]],["typeid"]]],[11,"encode","","",239,[[["self"],["e"]],["result"]]],[11,"decode","","",239,[[["d"]],["result"]]],[11,"not_found","","",239,[[["str"],["str"]],["e"]]],[11,"to_owned","","",240,[[["self"]],["t"]]],[11,"clone_into","","",240,N],[11,"from","","",240,[[["t"]],["t"]]],[11,"into","","",240,[[["self"]],["u"]]],[11,"try_from","","",240,[[["u"]],["result"]]],[11,"borrow","","",240,[[["self"]],["t"]]],[11,"try_into","","",240,[[["self"]],["result"]]],[11,"borrow_mut","","",240,[[["self"]],["t"]]],[11,"get_type_id","","",240,[[["self"]],["typeid"]]],[11,"encode","","",240,[[["self"],["e"]],["result"]]],[11,"decode","","",240,[[["d"]],["result"]]],[11,"not_found","","",240,[[["str"],["str"]],["e"]]],[11,"to_owned","","",241,[[["self"]],["t"]]],[11,"clone_into","","",241,N],[11,"from","","",241,[[["t"]],["t"]]],[11,"into","","",241,[[["self"]],["u"]]],[11,"try_from","","",241,[[["u"]],["result"]]],[11,"borrow","","",241,[[["self"]],["t"]]],[11,"try_into","","",241,[[["self"]],["result"]]],[11,"borrow_mut","","",241,[[["self"]],["t"]]],[11,"get_type_id","","",241,[[["self"]],["typeid"]]],[11,"encode","","",241,[[["self"],["e"]],["result"]]],[11,"decode","","",241,[[["d"]],["result"]]],[11,"not_found","","",241,[[["str"],["str"]],["e"]]],[11,"from","syntax::parse::attr","",242,[[["t"]],["t"]]],[11,"into","","",242,[[["self"]],["u"]]],[11,"try_from","","",242,[[["u"]],["result"]]],[11,"borrow","","",242,[[["self"]],["t"]]],[11,"try_into","","",242,[[["self"]],["result"]]],[11,"borrow_mut","","",242,[[["self"]],["t"]]],[11,"get_type_id","","",242,[[["self"]],["typeid"]]],[11,"not_found","","",242,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::ptr","",243,[[["self"]],["t"]]],[11,"clone_into","","",243,N],[11,"from","","",243,[[["t"]],["t"]]],[11,"to_string","","",243,[[["self"]],["string"]]],[11,"into_iter","","",243,[[["self"]],["i"]]],[11,"into","","",243,[[["self"]],["u"]]],[11,"try_from","","",243,[[["u"]],["result"]]],[11,"borrow","","",243,[[["self"]],["t"]]],[11,"try_into","","",243,[[["self"]],["result"]]],[11,"borrow_mut","","",243,[[["self"]],["t"]]],[11,"get_type_id","","",243,[[["self"]],["typeid"]]],[11,"encode","","",243,[[["self"],["e"]],["result"]]],[11,"decode","","",243,[[["d"]],["result"]]],[11,"not_found","","",243,[[["str"],["str"]],["e"]]],[11,"from","syntax::show_span","",244,[[["t"]],["t"]]],[11,"into","","",244,[[["self"]],["u"]]],[11,"try_from","","",244,[[["u"]],["result"]]],[11,"borrow","","",244,[[["self"]],["t"]]],[11,"try_into","","",244,[[["self"]],["result"]]],[11,"borrow_mut","","",244,[[["self"]],["t"]]],[11,"get_type_id","","",244,[[["self"]],["typeid"]]],[11,"not_found","","",244,[[["str"],["str"]],["e"]]],[11,"from","","",245,[[["t"]],["t"]]],[11,"into","","",245,[[["self"]],["u"]]],[11,"try_from","","",245,[[["u"]],["result"]]],[11,"borrow","","",245,[[["self"]],["t"]]],[11,"try_into","","",245,[[["self"]],["result"]]],[11,"borrow_mut","","",245,[[["self"]],["t"]]],[11,"get_type_id","","",245,[[["self"]],["typeid"]]],[11,"not_found","","",245,[[["str"],["str"]],["e"]]],[11,"from","syntax::test","",246,[[["t"]],["t"]]],[11,"into","","",246,[[["self"]],["u"]]],[11,"try_from","","",246,[[["u"]],["result"]]],[11,"borrow","","",246,[[["self"]],["t"]]],[11,"try_into","","",246,[[["self"]],["result"]]],[11,"borrow_mut","","",246,[[["self"]],["t"]]],[11,"get_type_id","","",246,[[["self"]],["typeid"]]],[11,"not_found","","",246,[[["str"],["str"]],["e"]]],[11,"from","","",247,[[["t"]],["t"]]],[11,"into","","",247,[[["self"]],["u"]]],[11,"try_from","","",247,[[["u"]],["result"]]],[11,"borrow","","",247,[[["self"]],["t"]]],[11,"try_into","","",247,[[["self"]],["result"]]],[11,"borrow_mut","","",247,[[["self"]],["t"]]],[11,"get_type_id","","",247,[[["self"]],["typeid"]]],[11,"not_found","","",247,[[["str"],["str"]],["e"]]],[11,"from","","",248,[[["t"]],["t"]]],[11,"into","","",248,[[["self"]],["u"]]],[11,"try_from","","",248,[[["u"]],["result"]]],[11,"borrow","","",248,[[["self"]],["t"]]],[11,"try_into","","",248,[[["self"]],["result"]]],[11,"borrow_mut","","",248,[[["self"]],["t"]]],[11,"get_type_id","","",248,[[["self"]],["typeid"]]],[11,"not_found","","",248,[[["str"],["str"]],["e"]]],[11,"from","","",249,[[["t"]],["t"]]],[11,"into","","",249,[[["self"]],["u"]]],[11,"try_from","","",249,[[["u"]],["result"]]],[11,"borrow","","",249,[[["self"]],["t"]]],[11,"try_into","","",249,[[["self"]],["result"]]],[11,"borrow_mut","","",249,[[["self"]],["t"]]],[11,"get_type_id","","",249,[[["self"]],["typeid"]]],[11,"not_found","","",249,[[["str"],["str"]],["e"]]],[11,"from","","",250,[[["t"]],["t"]]],[11,"into","","",250,[[["self"]],["u"]]],[11,"try_from","","",250,[[["u"]],["result"]]],[11,"borrow","","",250,[[["self"]],["t"]]],[11,"try_into","","",250,[[["self"]],["result"]]],[11,"borrow_mut","","",250,[[["self"]],["t"]]],[11,"get_type_id","","",250,[[["self"]],["typeid"]]],[11,"not_found","","",250,[[["str"],["str"]],["e"]]],[11,"from","","",251,[[["t"]],["t"]]],[11,"into","","",251,[[["self"]],["u"]]],[11,"try_from","","",251,[[["u"]],["result"]]],[11,"borrow","","",251,[[["self"]],["t"]]],[11,"try_into","","",251,[[["self"]],["result"]]],[11,"borrow_mut","","",251,[[["self"]],["t"]]],[11,"get_type_id","","",251,[[["self"]],["typeid"]]],[11,"not_found","","",251,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::tokenstream","",252,[[["self"]],["t"]]],[11,"clone_into","","",252,N],[11,"from","","",252,[[["t"]],["t"]]],[11,"into","","",252,[[["self"]],["u"]]],[11,"try_from","","",252,[[["u"]],["result"]]],[11,"borrow","","",252,[[["self"]],["t"]]],[11,"try_into","","",252,[[["self"]],["result"]]],[11,"borrow_mut","","",252,[[["self"]],["t"]]],[11,"get_type_id","","",252,[[["self"]],["typeid"]]],[11,"encode","","",252,[[["self"],["e"]],["result"]]],[11,"decode","","",252,[[["d"]],["result"]]],[11,"not_found","","",252,[[["str"],["str"]],["e"]]],[11,"to_owned","","",253,[[["self"]],["t"]]],[11,"clone_into","","",253,N],[11,"from","","",253,[[["t"]],["t"]]],[11,"to_string","","",253,[[["self"]],["string"]]],[11,"into","","",253,[[["self"]],["u"]]],[11,"try_from","","",253,[[["u"]],["result"]]],[11,"borrow","","",253,[[["self"]],["t"]]],[11,"try_into","","",253,[[["self"]],["result"]]],[11,"borrow_mut","","",253,[[["self"]],["t"]]],[11,"get_type_id","","",253,[[["self"]],["typeid"]]],[11,"encode","","",253,[[["self"],["e"]],["result"]]],[11,"decode","","",253,[[["d"]],["result"]]],[11,"not_found","","",253,[[["str"],["str"]],["e"]]],[11,"to_owned","","",254,[[["self"]],["t"]]],[11,"clone_into","","",254,N],[11,"from","","",254,[[["t"]],["t"]]],[11,"into","","",254,[[["self"]],["u"]]],[11,"try_from","","",254,[[["u"]],["result"]]],[11,"borrow","","",254,[[["self"]],["t"]]],[11,"try_into","","",254,[[["self"]],["result"]]],[11,"borrow_mut","","",254,[[["self"]],["t"]]],[11,"get_type_id","","",254,[[["self"]],["typeid"]]],[11,"not_found","","",254,[[["str"],["str"]],["e"]]],[11,"to_owned","","",255,[[["self"]],["t"]]],[11,"clone_into","","",255,N],[11,"from","","",255,[[["t"]],["t"]]],[11,"into_iter","","",255,[[["self"]],["i"]]],[11,"into","","",255,[[["self"]],["u"]]],[11,"try_from","","",255,[[["u"]],["result"]]],[11,"borrow","","",255,[[["self"]],["t"]]],[11,"try_into","","",255,[[["self"]],["result"]]],[11,"borrow_mut","","",255,[[["self"]],["t"]]],[11,"get_type_id","","",255,[[["self"]],["typeid"]]],[11,"not_found","","",255,[[["str"],["str"]],["e"]]],[11,"to_owned","","",256,[[["self"]],["t"]]],[11,"clone_into","","",256,N],[11,"from","","",256,[[["t"]],["t"]]],[11,"into","","",256,[[["self"]],["u"]]],[11,"try_from","","",256,[[["u"]],["result"]]],[11,"borrow","","",256,[[["self"]],["t"]]],[11,"try_into","","",256,[[["self"]],["result"]]],[11,"borrow_mut","","",256,[[["self"]],["t"]]],[11,"get_type_id","","",256,[[["self"]],["typeid"]]],[11,"not_found","","",256,[[["str"],["str"]],["e"]]],[11,"to_owned","","",257,[[["self"]],["t"]]],[11,"clone_into","","",257,N],[11,"from","","",257,[[["t"]],["t"]]],[11,"into","","",257,[[["self"]],["u"]]],[11,"try_from","","",257,[[["u"]],["result"]]],[11,"borrow","","",257,[[["self"]],["t"]]],[11,"try_into","","",257,[[["self"]],["result"]]],[11,"borrow_mut","","",257,[[["self"]],["t"]]],[11,"get_type_id","","",257,[[["self"]],["typeid"]]],[11,"encode","","",257,[[["self"],["e"]],["result"]]],[11,"decode","","",257,[[["d"]],["result"]]],[11,"not_found","","",257,[[["str"],["str"]],["e"]]],[11,"to_owned","","",258,[[["self"]],["t"]]],[11,"clone_into","","",258,N],[11,"from","","",258,[[["t"]],["t"]]],[11,"into","","",258,[[["self"]],["u"]]],[11,"try_from","","",258,[[["u"]],["result"]]],[11,"borrow","","",258,[[["self"]],["t"]]],[11,"try_into","","",258,[[["self"]],["result"]]],[11,"borrow_mut","","",258,[[["self"]],["t"]]],[11,"get_type_id","","",258,[[["self"]],["typeid"]]],[11,"encode","","",258,[[["self"],["e"]],["result"]]],[11,"decode","","",258,[[["d"]],["result"]]],[11,"not_found","","",258,[[["str"],["str"]],["e"]]],[11,"to_owned","","",259,[[["self"]],["t"]]],[11,"clone_into","","",259,N],[11,"from","","",259,[[["t"]],["t"]]],[11,"into","","",259,[[["self"]],["u"]]],[11,"try_from","","",259,[[["u"]],["result"]]],[11,"borrow","","",259,[[["self"]],["t"]]],[11,"try_into","","",259,[[["self"]],["result"]]],[11,"borrow_mut","","",259,[[["self"]],["t"]]],[11,"get_type_id","","",259,[[["self"]],["typeid"]]],[11,"encode","","",259,[[["self"],["e"]],["result"]]],[11,"decode","","",259,[[["d"]],["result"]]],[11,"not_found","","",259,[[["str"],["str"]],["e"]]],[11,"to_owned","","",260,[[["self"]],["t"]]],[11,"clone_into","","",260,N],[11,"from","","",260,[[["t"]],["t"]]],[11,"into","","",260,[[["self"]],["u"]]],[11,"try_from","","",260,[[["u"]],["result"]]],[11,"borrow","","",260,[[["self"]],["t"]]],[11,"try_into","","",260,[[["self"]],["result"]]],[11,"borrow_mut","","",260,[[["self"]],["t"]]],[11,"get_type_id","","",260,[[["self"]],["typeid"]]],[11,"not_found","","",260,[[["str"],["str"]],["e"]]],[11,"to_owned","","",261,[[["self"]],["t"]]],[11,"clone_into","","",261,N],[11,"from","","",261,[[["t"]],["t"]]],[11,"into","","",261,[[["self"]],["u"]]],[11,"try_from","","",261,[[["u"]],["result"]]],[11,"borrow","","",261,[[["self"]],["t"]]],[11,"try_into","","",261,[[["self"]],["result"]]],[11,"borrow_mut","","",261,[[["self"]],["t"]]],[11,"get_type_id","","",261,[[["self"]],["typeid"]]],[11,"not_found","","",261,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::visit","",262,[[["self"]],["t"]]],[11,"clone_into","","",262,N],[11,"from","","",262,[[["t"]],["t"]]],[11,"into","","",262,[[["self"]],["u"]]],[11,"try_from","","",262,[[["u"]],["result"]]],[11,"borrow","","",262,[[["self"]],["t"]]],[11,"try_into","","",262,[[["self"]],["result"]]],[11,"borrow_mut","","",262,[[["self"]],["t"]]],[11,"get_type_id","","",262,[[["self"]],["typeid"]]],[11,"not_found","","",262,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::print::pp","",264,[[["self"]],["t"]]],[11,"clone_into","","",264,N],[11,"from","","",264,[[["t"]],["t"]]],[11,"into","","",264,[[["self"]],["u"]]],[11,"try_from","","",264,[[["u"]],["result"]]],[11,"borrow","","",264,[[["self"]],["t"]]],[11,"try_into","","",264,[[["self"]],["result"]]],[11,"borrow_mut","","",264,[[["self"]],["t"]]],[11,"get_type_id","","",264,[[["self"]],["typeid"]]],[11,"not_found","","",264,[[["str"],["str"]],["e"]]],[11,"to_owned","","",265,[[["self"]],["t"]]],[11,"clone_into","","",265,N],[11,"from","","",265,[[["t"]],["t"]]],[11,"into","","",265,[[["self"]],["u"]]],[11,"try_from","","",265,[[["u"]],["result"]]],[11,"borrow","","",265,[[["self"]],["t"]]],[11,"try_into","","",265,[[["self"]],["result"]]],[11,"borrow_mut","","",265,[[["self"]],["t"]]],[11,"get_type_id","","",265,[[["self"]],["typeid"]]],[11,"not_found","","",265,[[["str"],["str"]],["e"]]],[11,"to_owned","","",266,[[["self"]],["t"]]],[11,"clone_into","","",266,N],[11,"from","","",266,[[["t"]],["t"]]],[11,"into","","",266,[[["self"]],["u"]]],[11,"try_from","","",266,[[["u"]],["result"]]],[11,"borrow","","",266,[[["self"]],["t"]]],[11,"try_into","","",266,[[["self"]],["result"]]],[11,"borrow_mut","","",266,[[["self"]],["t"]]],[11,"get_type_id","","",266,[[["self"]],["typeid"]]],[11,"not_found","","",266,[[["str"],["str"]],["e"]]],[11,"from","","",267,[[["t"]],["t"]]],[11,"into","","",267,[[["self"]],["u"]]],[11,"try_from","","",267,[[["u"]],["result"]]],[11,"borrow","","",267,[[["self"]],["t"]]],[11,"try_into","","",267,[[["self"]],["result"]]],[11,"borrow_mut","","",267,[[["self"]],["t"]]],[11,"get_type_id","","",267,[[["self"]],["typeid"]]],[11,"not_found","","",267,[[["str"],["str"]],["e"]]],[11,"to_owned","","",268,[[["self"]],["t"]]],[11,"clone_into","","",268,N],[11,"from","","",268,[[["t"]],["t"]]],[11,"into","","",268,[[["self"]],["u"]]],[11,"try_from","","",268,[[["u"]],["result"]]],[11,"borrow","","",268,[[["self"]],["t"]]],[11,"try_into","","",268,[[["self"]],["result"]]],[11,"borrow_mut","","",268,[[["self"]],["t"]]],[11,"get_type_id","","",268,[[["self"]],["typeid"]]],[11,"not_found","","",268,[[["str"],["str"]],["e"]]],[11,"to_owned","","",269,[[["self"]],["t"]]],[11,"clone_into","","",269,N],[11,"from","","",269,[[["t"]],["t"]]],[11,"into","","",269,[[["self"]],["u"]]],[11,"try_from","","",269,[[["u"]],["result"]]],[11,"borrow","","",269,[[["self"]],["t"]]],[11,"try_into","","",269,[[["self"]],["result"]]],[11,"borrow_mut","","",269,[[["self"]],["t"]]],[11,"get_type_id","","",269,[[["self"]],["typeid"]]],[11,"not_found","","",269,[[["str"],["str"]],["e"]]],[11,"to_owned","","",270,[[["self"]],["t"]]],[11,"clone_into","","",270,N],[11,"from","","",270,[[["t"]],["t"]]],[11,"to_string","","",270,[[["self"]],["string"]]],[11,"into","","",270,[[["self"]],["u"]]],[11,"try_from","","",270,[[["u"]],["result"]]],[11,"borrow","","",270,[[["self"]],["t"]]],[11,"try_into","","",270,[[["self"]],["result"]]],[11,"borrow_mut","","",270,[[["self"]],["t"]]],[11,"get_type_id","","",270,[[["self"]],["typeid"]]],[11,"not_found","","",270,[[["str"],["str"]],["e"]]],[11,"to_owned","","",271,[[["self"]],["t"]]],[11,"clone_into","","",271,N],[11,"from","","",271,[[["t"]],["t"]]],[11,"into","","",271,[[["self"]],["u"]]],[11,"try_from","","",271,[[["u"]],["result"]]],[11,"borrow","","",271,[[["self"]],["t"]]],[11,"try_into","","",271,[[["self"]],["result"]]],[11,"borrow_mut","","",271,[[["self"]],["t"]]],[11,"get_type_id","","",271,[[["self"]],["typeid"]]],[11,"not_found","","",271,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::print::pprust","",276,[[["self"]],["t"]]],[11,"clone_into","","",276,N],[11,"from","","",276,[[["t"]],["t"]]],[11,"into","","",276,[[["self"]],["u"]]],[11,"try_from","","",276,[[["u"]],["result"]]],[11,"borrow","","",276,[[["self"]],["t"]]],[11,"try_into","","",276,[[["self"]],["result"]]],[11,"borrow_mut","","",276,[[["self"]],["t"]]],[11,"get_type_id","","",276,[[["self"]],["typeid"]]],[11,"not_found","","",276,[[["str"],["str"]],["e"]]],[11,"from","","",272,[[["t"]],["t"]]],[11,"into","","",272,[[["self"]],["u"]]],[11,"try_from","","",272,[[["u"]],["result"]]],[11,"borrow","","",272,[[["self"]],["t"]]],[11,"try_into","","",272,[[["self"]],["result"]]],[11,"borrow_mut","","",272,[[["self"]],["t"]]],[11,"get_type_id","","",272,[[["self"]],["typeid"]]],[11,"not_found","","",272,[[["str"],["str"]],["e"]]],[11,"from","","",273,[[["t"]],["t"]]],[11,"into","","",273,[[["self"]],["u"]]],[11,"try_from","","",273,[[["u"]],["result"]]],[11,"borrow","","",273,[[["self"]],["t"]]],[11,"try_into","","",273,[[["self"]],["result"]]],[11,"borrow_mut","","",273,[[["self"]],["t"]]],[11,"get_type_id","","",273,[[["self"]],["typeid"]]],[11,"not_found","","",273,[[["str"],["str"]],["e"]]],[11,"from","syntax::ext::base","",277,[[["t"]],["t"]]],[11,"into","","",277,[[["self"]],["u"]]],[11,"try_from","","",277,[[["u"]],["result"]]],[11,"borrow","","",277,[[["self"]],["t"]]],[11,"try_into","","",277,[[["self"]],["result"]]],[11,"borrow_mut","","",277,[[["self"]],["t"]]],[11,"get_type_id","","",277,[[["self"]],["typeid"]]],[11,"not_found","","",277,[[["str"],["str"]],["e"]]],[11,"to_owned","","",278,[[["self"]],["t"]]],[11,"clone_into","","",278,N],[11,"from","","",278,[[["t"]],["t"]]],[11,"into","","",278,[[["self"]],["u"]]],[11,"try_from","","",278,[[["u"]],["result"]]],[11,"borrow","","",278,[[["self"]],["t"]]],[11,"try_into","","",278,[[["self"]],["result"]]],[11,"borrow_mut","","",278,[[["self"]],["t"]]],[11,"get_type_id","","",278,[[["self"]],["typeid"]]],[11,"not_found","","",278,[[["str"],["str"]],["e"]]],[11,"from","","",294,[[["t"]],["t"]]],[11,"into","","",294,[[["self"]],["u"]]],[11,"try_from","","",294,[[["u"]],["result"]]],[11,"borrow","","",294,[[["self"]],["t"]]],[11,"try_into","","",294,[[["self"]],["result"]]],[11,"borrow_mut","","",294,[[["self"]],["t"]]],[11,"get_type_id","","",294,[[["self"]],["typeid"]]],[11,"not_found","","",294,[[["str"],["str"]],["e"]]],[11,"to_owned","","",279,[[["self"]],["t"]]],[11,"clone_into","","",279,N],[11,"from","","",279,[[["t"]],["t"]]],[11,"into","","",279,[[["self"]],["u"]]],[11,"try_from","","",279,[[["u"]],["result"]]],[11,"borrow","","",279,[[["self"]],["t"]]],[11,"try_into","","",279,[[["self"]],["result"]]],[11,"borrow_mut","","",279,[[["self"]],["t"]]],[11,"get_type_id","","",279,[[["self"]],["typeid"]]],[11,"not_found","","",279,[[["str"],["str"]],["e"]]],[11,"to_owned","","",280,[[["self"]],["t"]]],[11,"clone_into","","",280,N],[11,"from","","",280,[[["t"]],["t"]]],[11,"into","","",280,[[["self"]],["u"]]],[11,"try_from","","",280,[[["u"]],["result"]]],[11,"borrow","","",280,[[["self"]],["t"]]],[11,"try_into","","",280,[[["self"]],["result"]]],[11,"borrow_mut","","",280,[[["self"]],["t"]]],[11,"get_type_id","","",280,[[["self"]],["typeid"]]],[11,"not_found","","",280,[[["str"],["str"]],["e"]]],[11,"from","","",281,[[["t"]],["t"]]],[11,"into","","",281,[[["self"]],["u"]]],[11,"try_from","","",281,[[["u"]],["result"]]],[11,"borrow","","",281,[[["self"]],["t"]]],[11,"try_into","","",281,[[["self"]],["result"]]],[11,"borrow_mut","","",281,[[["self"]],["t"]]],[11,"get_type_id","","",281,[[["self"]],["typeid"]]],[11,"not_found","","",281,[[["str"],["str"]],["e"]]],[11,"to_owned","","",282,[[["self"]],["t"]]],[11,"clone_into","","",282,N],[11,"from","","",282,[[["t"]],["t"]]],[11,"into","","",282,[[["self"]],["u"]]],[11,"try_from","","",282,[[["u"]],["result"]]],[11,"borrow","","",282,[[["self"]],["t"]]],[11,"try_into","","",282,[[["self"]],["result"]]],[11,"borrow_mut","","",282,[[["self"]],["t"]]],[11,"get_type_id","","",282,[[["self"]],["typeid"]]],[11,"not_found","","",282,[[["str"],["str"]],["e"]]],[11,"to_owned","","",283,[[["self"]],["t"]]],[11,"clone_into","","",283,N],[11,"from","","",283,[[["t"]],["t"]]],[11,"into","","",283,[[["self"]],["u"]]],[11,"try_from","","",283,[[["u"]],["result"]]],[11,"borrow","","",283,[[["self"]],["t"]]],[11,"try_into","","",283,[[["self"]],["result"]]],[11,"borrow_mut","","",283,[[["self"]],["t"]]],[11,"get_type_id","","",283,[[["self"]],["typeid"]]],[11,"encode","","",283,[[["self"],["e"]],["result"]]],[11,"decode","","",283,[[["d"]],["result"]]],[11,"not_found","","",283,[[["str"],["str"]],["e"]]],[11,"from","","",284,[[["t"]],["t"]]],[11,"into","","",284,[[["self"]],["u"]]],[11,"try_from","","",284,[[["u"]],["result"]]],[11,"borrow","","",284,[[["self"]],["t"]]],[11,"try_into","","",284,[[["self"]],["result"]]],[11,"borrow_mut","","",284,[[["self"]],["t"]]],[11,"get_type_id","","",284,[[["self"]],["typeid"]]],[11,"not_found","","",284,[[["str"],["str"]],["e"]]],[11,"to_owned","","",285,[[["self"]],["t"]]],[11,"clone_into","","",285,N],[11,"from","","",285,[[["t"]],["t"]]],[11,"into","","",285,[[["self"]],["u"]]],[11,"try_from","","",285,[[["u"]],["result"]]],[11,"borrow","","",285,[[["self"]],["t"]]],[11,"try_into","","",285,[[["self"]],["result"]]],[11,"borrow_mut","","",285,[[["self"]],["t"]]],[11,"get_type_id","","",285,[[["self"]],["typeid"]]],[11,"not_found","","",285,[[["str"],["str"]],["e"]]],[11,"from","syntax::ext::expand","",296,[[["t"]],["t"]]],[11,"into","","",296,[[["self"]],["u"]]],[11,"try_from","","",296,[[["u"]],["result"]]],[11,"borrow","","",296,[[["self"]],["t"]]],[11,"try_into","","",296,[[["self"]],["result"]]],[11,"borrow_mut","","",296,[[["self"]],["t"]]],[11,"get_type_id","","",296,[[["self"]],["typeid"]]],[11,"not_found","","",296,[[["str"],["str"]],["e"]]],[11,"from","","",297,[[["t"]],["t"]]],[11,"into","","",297,[[["self"]],["u"]]],[11,"try_from","","",297,[[["u"]],["result"]]],[11,"borrow","","",297,[[["self"]],["t"]]],[11,"try_into","","",297,[[["self"]],["result"]]],[11,"borrow_mut","","",297,[[["self"]],["t"]]],[11,"get_type_id","","",297,[[["self"]],["typeid"]]],[11,"not_found","","",297,[[["str"],["str"]],["e"]]],[11,"from","","",298,[[["t"]],["t"]]],[11,"into","","",298,[[["self"]],["u"]]],[11,"try_from","","",298,[[["u"]],["result"]]],[11,"borrow","","",298,[[["self"]],["t"]]],[11,"try_into","","",298,[[["self"]],["result"]]],[11,"borrow_mut","","",298,[[["self"]],["t"]]],[11,"get_type_id","","",298,[[["self"]],["typeid"]]],[11,"not_found","","",298,[[["str"],["str"]],["e"]]],[11,"from","","",299,[[["t"]],["t"]]],[11,"into","","",299,[[["self"]],["u"]]],[11,"try_from","","",299,[[["u"]],["result"]]],[11,"borrow","","",299,[[["self"]],["t"]]],[11,"try_into","","",299,[[["self"]],["result"]]],[11,"borrow_mut","","",299,[[["self"]],["t"]]],[11,"get_type_id","","",299,[[["self"]],["typeid"]]],[11,"not_found","","",299,[[["str"],["str"]],["e"]]],[11,"from","","",300,[[["t"]],["t"]]],[11,"into","","",300,[[["self"]],["u"]]],[11,"try_from","","",300,[[["u"]],["result"]]],[11,"borrow","","",300,[[["self"]],["t"]]],[11,"try_into","","",300,[[["self"]],["result"]]],[11,"borrow_mut","","",300,[[["self"]],["t"]]],[11,"get_type_id","","",300,[[["self"]],["typeid"]]],[11,"not_found","","",300,[[["str"],["str"]],["e"]]],[11,"from","","",301,[[["t"]],["t"]]],[11,"into","","",301,[[["self"]],["u"]]],[11,"try_from","","",301,[[["u"]],["result"]]],[11,"borrow","","",301,[[["self"]],["t"]]],[11,"try_into","","",301,[[["self"]],["result"]]],[11,"borrow_mut","","",301,[[["self"]],["t"]]],[11,"get_type_id","","",301,[[["self"]],["typeid"]]],[11,"not_found","","",301,[[["str"],["str"]],["e"]]],[11,"to_owned","","",302,[[["self"]],["t"]]],[11,"clone_into","","",302,N],[11,"from","","",302,[[["t"]],["t"]]],[11,"into","","",302,[[["self"]],["u"]]],[11,"try_from","","",302,[[["u"]],["result"]]],[11,"borrow","","",302,[[["self"]],["t"]]],[11,"try_into","","",302,[[["self"]],["result"]]],[11,"borrow_mut","","",302,[[["self"]],["t"]]],[11,"get_type_id","","",302,[[["self"]],["typeid"]]],[11,"not_found","","",302,[[["str"],["str"]],["e"]]],[11,"to_owned","","",303,[[["self"]],["t"]]],[11,"clone_into","","",303,N],[11,"from","","",303,[[["t"]],["t"]]],[11,"into","","",303,[[["self"]],["u"]]],[11,"try_from","","",303,[[["u"]],["result"]]],[11,"borrow","","",303,[[["self"]],["t"]]],[11,"try_into","","",303,[[["self"]],["result"]]],[11,"borrow_mut","","",303,[[["self"]],["t"]]],[11,"get_type_id","","",303,[[["self"]],["typeid"]]],[11,"not_found","","",303,[[["str"],["str"]],["e"]]],[11,"from","","",304,[[["t"]],["t"]]],[11,"into","","",304,[[["self"]],["u"]]],[11,"try_from","","",304,[[["u"]],["result"]]],[11,"borrow","","",304,[[["self"]],["t"]]],[11,"try_into","","",304,[[["self"]],["result"]]],[11,"borrow_mut","","",304,[[["self"]],["t"]]],[11,"get_type_id","","",304,[[["self"]],["typeid"]]],[11,"not_found","","",304,[[["str"],["str"]],["e"]]],[11,"make_expr","syntax::ext::tt::macro_rules","",316,[[["box",["parseranymacro"]]],["option",["p"]]]],[11,"make_pat","","",316,[[["box",["parseranymacro"]]],["option",["p"]]]],[11,"make_ty","","",316,[[["box",["parseranymacro"]]],["option",["p"]]]],[11,"make_stmts","","",316,[[["box",["parseranymacro"]]],["option",["onevector"]]]],[11,"make_items","","",316,[[["box",["parseranymacro"]]],["option",["onevector"]]]],[11,"make_trait_items","","",316,[[["box",["parseranymacro"]]],["option",["onevector"]]]],[11,"make_impl_items","","",316,[[["box",["parseranymacro"]]],["option",["onevector"]]]],[11,"make_foreign_items","","",316,[[["box",["parseranymacro"]]],["option",["onevector"]]]],[11,"from","syntax::ext::placeholders","",305,[[["t"]],["t"]]],[11,"into","","",305,[[["self"]],["u"]]],[11,"try_from","","",305,[[["u"]],["result"]]],[11,"borrow","","",305,[[["self"]],["t"]]],[11,"try_into","","",305,[[["self"]],["result"]]],[11,"borrow_mut","","",305,[[["self"]],["t"]]],[11,"get_type_id","","",305,[[["self"]],["typeid"]]],[11,"not_found","","",305,[[["str"],["str"]],["e"]]],[11,"from","syntax::ext::tt::transcribe","",308,[[["t"]],["t"]]],[11,"into_iter","","",308,[[["self"]],["i"]]],[11,"into","","",308,[[["self"]],["u"]]],[11,"try_from","","",308,[[["u"]],["result"]]],[11,"borrow","","",308,[[["self"]],["t"]]],[11,"try_into","","",308,[[["self"]],["result"]]],[11,"borrow_mut","","",308,[[["self"]],["t"]]],[11,"get_type_id","","",308,[[["self"]],["typeid"]]],[11,"not_found","","",308,[[["str"],["str"]],["e"]]],[11,"to_owned","","",309,[[["self"]],["t"]]],[11,"clone_into","","",309,N],[11,"from","","",309,[[["t"]],["t"]]],[11,"into","","",309,[[["self"]],["u"]]],[11,"try_from","","",309,[[["u"]],["result"]]],[11,"borrow","","",309,[[["self"]],["t"]]],[11,"try_into","","",309,[[["self"]],["result"]]],[11,"borrow_mut","","",309,[[["self"]],["t"]]],[11,"get_type_id","","",309,[[["self"]],["typeid"]]],[11,"not_found","","",309,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::ext::tt::macro_parser","",310,[[["self"]],["t"]]],[11,"clone_into","","",310,N],[11,"from","","",310,[[["t"]],["t"]]],[11,"into","","",310,[[["self"]],["u"]]],[11,"try_from","","",310,[[["u"]],["result"]]],[11,"borrow","","",310,[[["self"]],["t"]]],[11,"try_into","","",310,[[["self"]],["result"]]],[11,"borrow_mut","","",310,[[["self"]],["t"]]],[11,"get_type_id","","",310,[[["self"]],["typeid"]]],[11,"not_found","","",310,[[["str"],["str"]],["e"]]],[11,"to_owned","","",311,[[["self"]],["t"]]],[11,"clone_into","","",311,N],[11,"from","","",311,[[["t"]],["t"]]],[11,"into","","",311,[[["self"]],["u"]]],[11,"try_from","","",311,[[["u"]],["result"]]],[11,"borrow","","",311,[[["self"]],["t"]]],[11,"try_into","","",311,[[["self"]],["result"]]],[11,"borrow_mut","","",311,[[["self"]],["t"]]],[11,"get_type_id","","",311,[[["self"]],["typeid"]]],[11,"not_found","","",311,[[["str"],["str"]],["e"]]],[11,"to_owned","","",312,[[["self"]],["t"]]],[11,"clone_into","","",312,N],[11,"from","","",312,[[["t"]],["t"]]],[11,"into","","",312,[[["self"]],["u"]]],[11,"try_from","","",312,[[["u"]],["result"]]],[11,"borrow","","",312,[[["self"]],["t"]]],[11,"try_into","","",312,[[["self"]],["result"]]],[11,"borrow_mut","","",312,[[["self"]],["t"]]],[11,"get_type_id","","",312,[[["self"]],["typeid"]]],[11,"not_found","","",312,[[["str"],["str"]],["e"]]],[11,"to_owned","","",313,[[["self"]],["t"]]],[11,"clone_into","","",313,N],[11,"from","","",313,[[["t"]],["t"]]],[11,"into","","",313,[[["self"]],["u"]]],[11,"try_from","","",313,[[["u"]],["result"]]],[11,"borrow","","",313,[[["self"]],["t"]]],[11,"try_into","","",313,[[["self"]],["result"]]],[11,"borrow_mut","","",313,[[["self"]],["t"]]],[11,"get_type_id","","",313,[[["self"]],["typeid"]]],[11,"not_found","","",313,[[["str"],["str"]],["e"]]],[11,"from","","",314,[[["t"]],["t"]]],[11,"into","","",314,[[["self"]],["u"]]],[11,"try_from","","",314,[[["u"]],["result"]]],[11,"borrow","","",314,[[["self"]],["t"]]],[11,"try_into","","",314,[[["self"]],["result"]]],[11,"borrow_mut","","",314,[[["self"]],["t"]]],[11,"get_type_id","","",314,[[["self"]],["typeid"]]],[11,"not_found","","",314,[[["str"],["str"]],["e"]]],[11,"to_owned","","",315,[[["self"]],["t"]]],[11,"clone_into","","",315,N],[11,"from","","",315,[[["t"]],["t"]]],[11,"into","","",315,[[["self"]],["u"]]],[11,"try_from","","",315,[[["u"]],["result"]]],[11,"borrow","","",315,[[["self"]],["t"]]],[11,"try_into","","",315,[[["self"]],["result"]]],[11,"borrow_mut","","",315,[[["self"]],["t"]]],[11,"get_type_id","","",315,[[["self"]],["typeid"]]],[11,"not_found","","",315,[[["str"],["str"]],["e"]]],[11,"from","syntax::ext::tt::macro_rules","",316,[[["t"]],["t"]]],[11,"into","","",316,[[["self"]],["u"]]],[11,"try_from","","",316,[[["u"]],["result"]]],[11,"borrow","","",316,[[["self"]],["t"]]],[11,"try_into","","",316,[[["self"]],["result"]]],[11,"borrow_mut","","",316,[[["self"]],["t"]]],[11,"get_type_id","","",316,[[["self"]],["typeid"]]],[11,"not_found","","",316,[[["str"],["str"]],["e"]]],[11,"expand","","",317,[[["self"],["extctxt"],["span"],["tokenstream"]],["box",["macresult"]]]],[11,"from","","",317,[[["t"]],["t"]]],[11,"into","","",317,[[["self"]],["u"]]],[11,"try_from","","",317,[[["u"]],["result"]]],[11,"borrow","","",317,[[["self"]],["t"]]],[11,"try_into","","",317,[[["self"]],["result"]]],[11,"borrow_mut","","",317,[[["self"]],["t"]]],[11,"get_type_id","","",317,[[["self"]],["typeid"]]],[11,"not_found","","",317,[[["str"],["str"]],["e"]]],[11,"from","","",318,[[["t"]],["t"]]],[11,"into","","",318,[[["self"]],["u"]]],[11,"try_from","","",318,[[["u"]],["result"]]],[11,"borrow","","",318,[[["self"]],["t"]]],[11,"try_into","","",318,[[["self"]],["result"]]],[11,"borrow_mut","","",318,[[["self"]],["t"]]],[11,"get_type_id","","",318,[[["self"]],["typeid"]]],[11,"not_found","","",318,[[["str"],["str"]],["e"]]],[11,"to_owned","","",319,[[["self"]],["t"]]],[11,"clone_into","","",319,N],[11,"from","","",319,[[["t"]],["t"]]],[11,"into","","",319,[[["self"]],["u"]]],[11,"try_from","","",319,[[["u"]],["result"]]],[11,"borrow","","",319,[[["self"]],["t"]]],[11,"try_into","","",319,[[["self"]],["result"]]],[11,"borrow_mut","","",319,[[["self"]],["t"]]],[11,"get_type_id","","",319,[[["self"]],["typeid"]]],[11,"not_found","","",319,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax::ext::tt::quoted","",320,[[["self"]],["t"]]],[11,"clone_into","","",320,N],[11,"from","","",320,[[["t"]],["t"]]],[11,"into","","",320,[[["self"]],["u"]]],[11,"try_from","","",320,[[["u"]],["result"]]],[11,"borrow","","",320,[[["self"]],["t"]]],[11,"try_into","","",320,[[["self"]],["result"]]],[11,"borrow_mut","","",320,[[["self"]],["t"]]],[11,"get_type_id","","",320,[[["self"]],["typeid"]]],[11,"encode","","",320,[[["self"],["e"]],["result"]]],[11,"decode","","",320,[[["d"]],["result"]]],[11,"not_found","","",320,[[["str"],["str"]],["e"]]],[11,"to_owned","","",321,[[["self"]],["t"]]],[11,"clone_into","","",321,N],[11,"from","","",321,[[["t"]],["t"]]],[11,"into","","",321,[[["self"]],["u"]]],[11,"try_from","","",321,[[["u"]],["result"]]],[11,"borrow","","",321,[[["self"]],["t"]]],[11,"try_into","","",321,[[["self"]],["result"]]],[11,"borrow_mut","","",321,[[["self"]],["t"]]],[11,"get_type_id","","",321,[[["self"]],["typeid"]]],[11,"encode","","",321,[[["self"],["e"]],["result"]]],[11,"decode","","",321,[[["d"]],["result"]]],[11,"not_found","","",321,[[["str"],["str"]],["e"]]],[11,"to_owned","","",322,[[["self"]],["t"]]],[11,"clone_into","","",322,N],[11,"from","","",322,[[["t"]],["t"]]],[11,"into","","",322,[[["self"]],["u"]]],[11,"try_from","","",322,[[["u"]],["result"]]],[11,"borrow","","",322,[[["self"]],["t"]]],[11,"try_into","","",322,[[["self"]],["result"]]],[11,"borrow_mut","","",322,[[["self"]],["t"]]],[11,"get_type_id","","",322,[[["self"]],["typeid"]]],[11,"encode","","",322,[[["self"],["e"]],["result"]]],[11,"decode","","",322,[[["d"]],["result"]]],[11,"not_found","","",322,[[["str"],["str"]],["e"]]],[11,"to_owned","","",323,[[["self"]],["t"]]],[11,"clone_into","","",323,N],[11,"from","","",323,[[["t"]],["t"]]],[11,"into","","",323,[[["self"]],["u"]]],[11,"try_from","","",323,[[["u"]],["result"]]],[11,"borrow","","",323,[[["self"]],["t"]]],[11,"try_into","","",323,[[["self"]],["result"]]],[11,"borrow_mut","","",323,[[["self"]],["t"]]],[11,"get_type_id","","",323,[[["self"]],["typeid"]]],[11,"encode","","",323,[[["self"],["e"]],["result"]]],[11,"decode","","",323,[[["d"]],["result"]]],[11,"not_found","","",323,[[["str"],["str"]],["e"]]],[11,"from","syntax::early_buffered_lints","",324,[[["t"]],["t"]]],[11,"into","","",324,[[["self"]],["u"]]],[11,"try_from","","",324,[[["u"]],["result"]]],[11,"borrow","","",324,[[["self"]],["t"]]],[11,"try_into","","",324,[[["self"]],["result"]]],[11,"borrow_mut","","",324,[[["self"]],["t"]]],[11,"get_type_id","","",324,[[["self"]],["typeid"]]],[11,"not_found","","",324,[[["str"],["str"]],["e"]]],[11,"from","","",325,[[["t"]],["t"]]],[11,"into","","",325,[[["self"]],["u"]]],[11,"try_from","","",325,[[["u"]],["result"]]],[11,"borrow","","",325,[[["self"]],["t"]]],[11,"try_into","","",325,[[["self"]],["result"]]],[11,"borrow_mut","","",325,[[["self"]],["t"]]],[11,"get_type_id","","",325,[[["self"]],["typeid"]]],[11,"not_found","","",325,[[["str"],["str"]],["e"]]]],"paths":[[3,"ThinVec"],[4,"Edition"],[3,"Ident"],[3,"Symbol"],[3,"Interner"],[3,"Keyword"],[3,"LocalInternedString"],[3,"InternedString"],[3,"Globals"],[8,"Emitter"],[4,"ColorConfig"],[3,"EmitterWriter"],[4,"Destination"],[4,"WritableDst"],[3,"Registry"],[4,"Applicability"],[3,"CodeSuggestion"],[3,"Substitution"],[3,"SubstitutionPart"],[8,"SourceMapper"],[3,"Handler"],[3,"HandlerFlags"],[4,"Level"],[3,"DiagnosticBuilder"],[3,"Diagnostic"],[4,"DiagnosticId"],[3,"DiagnosticStyledString"],[3,"SubDiagnostic"],[3,"ErrorInfo"],[3,"ErrorMetadata"],[3,"ErrorLocation"],[3,"RcSlice"],[3,"RcVec"],[3,"NodeCounter"],[4,"AssocOp"],[4,"Fixity"],[4,"ExprPrecedence"],[8,"MoveMap"],[6,"OneVector"],[3,"JsonEmitter"],[3,"Diagnostic"],[3,"DiagnosticSpan"],[3,"DiagnosticSpanLine"],[3,"DiagnosticSpanMacroExpansion"],[3,"DiagnosticCode"],[4,"FloatTy"],[3,"Label"],[3,"Lifetime"],[3,"Path"],[3,"PathSegment"],[3,"AngleBracketedArgs"],[3,"ParenthesisedArgs"],[3,"NodeId"],[3,"GenericParam"],[3,"Generics"],[3,"WhereClause"],[3,"WhereBoundPredicate"],[3,"WhereRegionPredicate"],[3,"WhereEqPredicate"],[3,"Crate"],[3,"MetaItem"],[3,"Block"],[3,"Pat"],[3,"FieldPat"],[3,"Stmt"],[3,"Local"],[3,"Arm"],[3,"Field"],[3,"AnonConst"],[3,"Expr"],[3,"QSelf"],[3,"Mac_"],[3,"MacroDef"],[3,"MutTy"],[3,"MethodSig"],[3,"TraitItem"],[3,"ImplItem"],[3,"TypeBinding"],[3,"Ty"],[3,"BareFnTy"],[3,"InlineAsmOutput"],[3,"InlineAsm"],[3,"Arg"],[3,"FnDecl"],[3,"Mod"],[3,"ForeignMod"],[3,"GlobalAsm"],[3,"EnumDef"],[3,"Variant_"],[3,"UseTree"],[3,"AttrId"],[3,"Attribute"],[3,"TraitRef"],[3,"PolyTraitRef"],[3,"StructField"],[3,"Item"],[3,"FnHeader"],[3,"ForeignItem"],[4,"GenericArgs"],[4,"GenericArg"],[4,"TraitBoundModifier"],[4,"GenericBound"],[4,"GenericParamKind"],[4,"WherePredicate"],[4,"NestedMetaItemKind"],[4,"MetaItemKind"],[4,"BindingMode"],[4,"RangeEnd"],[4,"RangeSyntax"],[4,"PatKind"],[4,"Mutability"],[4,"BinOpKind"],[4,"UnOp"],[4,"StmtKind"],[4,"MacStmtStyle"],[4,"Guard"],[4,"BlockCheckMode"],[4,"UnsafeSource"],[4,"RangeLimits"],[4,"ExprKind"],[4,"CaptureBy"],[4,"Movability"],[4,"MacDelimiter"],[4,"StrStyle"],[4,"LitIntType"],[4,"LitKind"],[4,"TraitItemKind"],[4,"ImplItemKind"],[4,"IntTy"],[4,"UintTy"],[4,"TyKind"],[4,"TraitObjectSyntax"],[4,"AsmDialect"],[4,"SelfKind"],[4,"IsAuto"],[4,"Unsafety"],[4,"IsAsync"],[4,"Constness"],[4,"Defaultness"],[4,"ImplPolarity"],[4,"FunctionRetTy"],[4,"UseTreeKind"],[4,"AttrStyle"],[4,"CrateSugar"],[4,"VisibilityKind"],[4,"VariantData"],[4,"ItemKind"],[4,"ForeignItemKind"],[3,"Deprecation"],[3,"RustcDeprecation"],[3,"Stability"],[4,"InlineAttr"],[4,"IntType"],[4,"ReprAttr"],[4,"StabilityLevel"],[4,"UnwindAttr"],[4,"AttrError"],[8,"HasAttrs"],[6,"NestedMetaItem"],[6,"Lit"],[3,"SyntaxContext"],[3,"Mark"],[4,"Transparency"],[3,"ExpnInfo"],[4,"ExpnFormat"],[4,"CompilerDesugaringKind"],[3,"Globals"],[4,"FileName"],[3,"SpanData"],[3,"MultiSpan"],[3,"SpanLabel"],[3,"MultiByteChar"],[4,"NonNarrowChar"],[4,"ExternalSource"],[3,"SourceFile"],[8,"Pos"],[3,"BytePos"],[3,"CharPos"],[3,"Loc"],[3,"LocWithOpt"],[3,"SourceFileAndLine"],[3,"SourceFileAndBytePos"],[3,"LineInfo"],[3,"FileLines"],[3,"MacroBacktrace"],[4,"SpanLinesError"],[4,"SpanSnippetError"],[3,"DistinctSources"],[3,"MalformedCodemapPositions"],[3,"Span"],[3,"Spanned"],[3,"StableFilemapId"],[3,"SourceMapFiles"],[3,"SourceMap"],[3,"FilePathMapping"],[8,"FileLoader"],[3,"RealFileLoader"],[3,"StripUnconfigured"],[4,"EntryPointType"],[3,"Features"],[3,"GatedCfg"],[3,"Context"],[3,"PostExpansionVisitor"],[4,"AttributeType"],[4,"AttributeGate"],[4,"Stability"],[4,"GateIssue"],[4,"GateStrength"],[4,"UnstableFeatures"],[8,"Folder"],[3,"ParseSess"],[3,"Directory"],[3,"SeqSep"],[4,"DirectoryOwnership"],[3,"Restrictions"],[3,"Parser"],[3,"TokenCursor"],[3,"TokenCursorFrame"],[3,"ModulePath"],[3,"ModulePathSuccess"],[4,"AliasKind"],[4,"PathStyle"],[4,"SemiColonMode"],[4,"BlockMode"],[4,"PrevTokenKind"],[4,"LastToken"],[4,"TokenType"],[4,"Error"],[4,"LhsExpr"],[4,"TokenExpectType"],[8,"RecoverQPath"],[3,"TokenAndSpan"],[3,"StringReader"],[3,"Comment"],[3,"Literal"],[4,"CommentStyle"],[3,"LazyTokenStream"],[4,"BinOpToken"],[4,"DelimToken"],[4,"Lit"],[4,"Token"],[4,"Nonterminal"],[4,"InnerAttributeParsePolicy"],[3,"P"],[3,"ShowSpanVisitor"],[4,"Mode"],[3,"Test"],[3,"TestCtxt"],[3,"TestHarnessGenerator"],[3,"EntryPointCleaner"],[4,"HasTestSignature"],[4,"BadTestSignature"],[3,"Delimited"],[3,"TokenStream"],[3,"TokenStreamBuilder"],[3,"Cursor"],[3,"StreamCursor"],[3,"ThinTokenStream"],[3,"DelimSpan"],[4,"TokenTree"],[4,"TokenStreamKind"],[4,"CursorKind"],[4,"FnKind"],[8,"Visitor"],[3,"BreakToken"],[3,"BeginToken"],[3,"PrintStackElem"],[3,"Printer"],[3,"BufEntry"],[4,"Breaks"],[4,"Token"],[4,"PrintStackBreak"],[3,"State"],[4,"AnnNode"],[8,"PpAnn"],[8,"PrintState"],[3,"NoAnn"],[3,"MacEager"],[3,"DummyResult"],[3,"ModuleData"],[3,"ExpansionData"],[3,"ExtCtxt"],[4,"Annotatable"],[4,"MacroKind"],[4,"SyntaxExtension"],[4,"Determinacy"],[8,"MultiItemDecorator"],[8,"MultiItemModifier"],[8,"ProcMacro"],[8,"AttrProcMacro"],[8,"TTMacroExpander"],[8,"IdentMacroExpander"],[8,"MacResult"],[8,"Resolver"],[3,"DummyResolver"],[8,"AstBuilder"],[3,"Invocation"],[3,"MacroExpander"],[3,"InvocationCollector"],[3,"ExpansionConfig"],[3,"Marker"],[4,"AstFragment"],[4,"AstFragmentKind"],[4,"TogetherWith"],[4,"InvocationKind"],[3,"PlaceholderExpander"],[8,"ToTokens"],[8,"ExtParseUtils"],[4,"Frame"],[4,"LockstepIterSize"],[3,"MatcherTtFrame"],[3,"MatcherPos"],[4,"TokenTreeOrTokenTreeSlice"],[4,"MatcherPosHandle"],[4,"ParseResult"],[4,"NamedMatch"],[3,"ParserAnyMacro"],[3,"MacroRulesMacroExpander"],[3,"FirstSets"],[3,"TokenSet"],[3,"Delimited"],[3,"SequenceRepetition"],[4,"KleeneOp"],[4,"TokenTree"],[3,"BufferedEarlyLint"],[4,"BufferedEarlyLintId"],[3,"FatalError"],[3,"ExplicitBug"],[3,"FatalErrorMarker"]]};
searchIndex["syntax_ext"]={"doc":"Syntax extensions in the Rust compiler.","items":[[5,"register_builtins","syntax_ext","",N,[[["resolver"],["vec",["namedsyntaxextension"]],["bool"]]]],[0,"diagnostics","","",N,N],[0,"__register_diagnostic_E0660","syntax_ext::diagnostics","",N,N],[0,"__register_diagnostic_E0661","","",N,N],[0,"__register_diagnostic_E0662","","",N,N],[0,"__register_diagnostic_E0663","","",N,N],[0,"__register_diagnostic_E0664","","",N,N],[0,"__register_diagnostic_E0665","","",N,N],[0,"deriving","syntax_ext","The compiler code necessary to implement the `#[derive]` extensions.",N,N],[5,"is_builtin_trait","syntax_ext::deriving","",N,[[["name"]],["bool"]]],[5,"register_builtin_derives","","",N,[[["resolver"]]]],[5,"warn_if_deprecated","","",N,[[["extctxt"],["span"],["str"]]]],[5,"hygienic_type_parameter","","Construct a name for the inner type parameter that can't collide with any type parameters of the item. This is achieved by starting with a base and then concatenating the names of all other type parameters.",N,[[["annotatable"],["str"]],["string"]]],[5,"call_intrinsic","","Constructs an expression that calls an intrinsic",N,[[["extctxt"],["span"],["str"],["vec",["p"]]],["p",["expr"]]]],[0,"bounds","","",N,N],[5,"expand_deriving_unsafe_bound","syntax_ext::deriving::bounds","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"expand_deriving_copy","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[0,"clone","syntax_ext::deriving","",N,N],[5,"expand_deriving_clone","syntax_ext::deriving::clone","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"cs_clone_shallow","","",N,[[["str"],["extctxt"],["span"],["substructure"],["bool"]],["p",["expr"]]]],[5,"cs_clone","","",N,[[["str"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[0,"encodable","syntax_ext::deriving","The compiler code necessary to implement the `#[derive(Encodable)]` (and `Decodable`, in decodable.rs) extension.  The idea here is that type-defining items may be tagged with `#[derive(Encodable, Decodable)]`.",N,N],[5,"expand_deriving_rustc_encodable","syntax_ext::deriving::encodable","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"expand_deriving_encodable","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"expand_deriving_encodable_imp","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"],["str"]]]],[5,"encodable_substructure","","",N,[[["extctxt"],["span"],["substructure"],["str"]],["p",["expr"]]]],[0,"decodable","syntax_ext::deriving","The compiler code necessary for `#[derive(Decodable)]`. See encodable.rs for more.",N,N],[5,"expand_deriving_rustc_decodable","syntax_ext::deriving::decodable","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"expand_deriving_decodable","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"expand_deriving_decodable_imp","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"],["str"]]]],[5,"decodable_substructure","","",N,[[["extctxt"],["span"],["substructure"],["str"]],["p",["expr"]]]],[5,"decode_static_fields","","Create a decoder for a single enum variant/struct: - `outer_pat_path` is the path to this enum variant/struct - `getarg` should retrieve the `usize`-th field with name `@str`.",N,[[["extctxt"],["span"],["path"],["staticfields"],["f"]],["p",["expr"]]]],[0,"hash","syntax_ext::deriving","",N,N],[5,"expand_deriving_hash","syntax_ext::deriving::hash","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"hash_substructure","","",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[0,"debug","syntax_ext::deriving","",N,N],[5,"expand_deriving_debug","syntax_ext::deriving::debug","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"show_substructure","","We use the debug builders to do the heavy lifting here",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"stmt_let_undescore","","",N,[[["extctxt"],["span"],["p",["expr"]]],["stmt"]]],[0,"default","syntax_ext::deriving","",N,N],[5,"expand_deriving_default","syntax_ext::deriving::default","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"default_substructure","","",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[0,"custom","syntax_ext::deriving","",N,N],[3,"MarkAttrs","syntax_ext::deriving::custom","",N,N],[12,"0","","",0,N],[3,"ProcMacroDerive","","",N,N],[12,"inner","","",1,N],[12,"attrs","","",1,N],[11,"visit_attribute","","",0,[[["self"],["attribute"]]]],[11,"visit_mac","","",0,[[["self"],["mac"]]]],[11,"new","","",1,N],[11,"expand","","",1,[[["self"],["extctxt"],["span"],["metaitem"],["annotatable"]],["vec",["annotatable"]]]],[0,"partial_eq","syntax_ext::deriving","",N,N],[5,"expand_deriving_partial_eq","syntax_ext::deriving::partial_eq","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[0,"eq","syntax_ext::deriving","",N,N],[5,"expand_deriving_eq","syntax_ext::deriving::eq","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"cs_total_eq_assert","","",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[0,"partial_ord","syntax_ext::deriving","",N,N],[4,"OrderingOp","syntax_ext::deriving::partial_ord","",N,N],[13,"PartialCmpOp","","",2,N],[13,"LtOp","","",2,N],[13,"LeOp","","",2,N],[13,"GtOp","","",2,N],[13,"GeOp","","",2,N],[5,"expand_deriving_partial_ord","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"some_ordering_collapsed","","",N,N],[5,"cs_partial_cmp","","",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"cs_op","","Strict inequality.",N,[[["bool"],["bool"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[11,"clone","","",2,[[["self"]],["orderingop"]]],[0,"ord","syntax_ext::deriving","",N,N],[5,"expand_deriving_ord","syntax_ext::deriving::ord","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"],["fnmut"]]]],[5,"ordering_collapsed","","",N,N],[5,"cs_cmp","","",N,[[["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[0,"generic","syntax_ext::deriving","Some code that abstracts away much of the boilerplate of writing `derive` instances for traits. Among other things it manages getting access to the fields of the 4 different sorts of structs and enum variants, as well as creating the method and impl ast instances.",N,N],[3,"TraitDef","syntax_ext::deriving::generic","",N,N],[12,"span","","The span for the current #[derive(Foo)] header.",3,N],[12,"attributes","","",3,N],[12,"path","","Path of the trait, including any type parameters",3,N],[12,"additional_bounds","","Additional bounds required of any type parameters of the type, other than the current trait",3,N],[12,"generics","","Any extra lifetimes and/or bounds, e.g. `D: serialize::Decoder`",3,N],[12,"is_unsafe","","Is it an `unsafe` trait?",3,N],[12,"supports_unions","","Can this trait be derived for unions?",3,N],[12,"methods","","",3,N],[12,"associated_types","","",3,N],[3,"MethodDef","","",N,N],[12,"name","","name of the method",4,N],[12,"generics","","List of generics, e.g. `R: rand::Rng`",4,N],[12,"explicit_self","","Whether there is a self argument (outer Option) i.e. whether this is a static function, and whether it is a pointer (inner Option)",4,N],[12,"args","","Arguments other than the self argument",4,N],[12,"ret_ty","","Return type",4,N],[12,"attributes","","",4,N],[12,"is_unsafe","","",4,N],[12,"unify_fieldless_variants","","Can we combine fieldless variants for enums into a single match arm?",4,N],[12,"combine_substructure","","",4,N],[3,"Substructure","","All the data about the data structure/method being derived upon.",N,N],[12,"type_ident","","ident of self",5,N],[12,"method_ident","","ident of the method",5,N],[12,"self_args","","dereferenced access to any `Self_` or `Ptr(Self_, _)` arguments",5,N],[12,"nonself_args","","verbatim access to any other arguments",5,N],[12,"fields","","",5,N],[3,"FieldInfo","","Summary of the relevant parts of a struct/enum field.",N,N],[12,"span","","",6,N],[12,"name","","None for tuple structs/normal enum variants, Some for normal structs/struct enum variants.",6,N],[12,"self_","","The expression corresponding to this field of `self` (specifically, a reference to it).",6,N],[12,"other","","The expressions corresponding to references to this field in the other `Self` arguments.",6,N],[12,"attrs","","The attributes on the field",6,N],[4,"StaticFields","","Fields for a static method",N,N],[13,"Unnamed","","Tuple and unit structs/enum variants like this.",7,N],[13,"Named","","Normal structs/struct variants.",7,N],[4,"SubstructureFields","","A summary of the possible sets of fields.",N,N],[13,"Struct","","",8,N],[13,"EnumMatching","","Matching variants of the enum: variant index, variant count, ast::Variant, fields: the field name is only non-`None` in the case of a struct variant.",8,N],[13,"EnumNonMatchingCollapsed","","Non-matching variants of the enum, but with all state hidden from the consequent code.  The first component holds `Ident`s for all of the `Self` arguments; the second component is a slice of all of the variants for the enum itself, and the third component is a list of `Ident`s bound to the variant index values for each of the actual input `Self` arguments.",8,N],[13,"StaticStruct","","A static method where `Self` is a struct.",8,N],[13,"StaticEnum","","A static method where `Self` is an enum.",8,N],[5,"combine_substructure","","",N,[[["combinesubstructurefunc"]],["refcell",["combinesubstructurefunc"]]]],[5,"find_type_parameters","","This method helps to extract all the type parameters referenced from a type. For a type parameter `<T>`, it looks for either a `TyPath` that is not global and starts with `T`, or a `TyQPath`.",N,N],[5,"find_repr_type_name","","",N,N],[5,"cs_fold_fields","","",N,N],[5,"cs_fold_enumnonmatch","","",N,[[["enumnonmatchcollapsedfunc"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"cs_fold_static","","",N,[[["extctxt"],["span"]],["p",["expr"]]]],[5,"cs_fold","","Fold the fields. `use_foldl` controls whether this is done left-to-right (`true`) or right-to-left (`false`).",N,[[["bool"],["f"],["p",["expr"]],["enumnonmatchcollapsedfunc"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"cs_fold1","","Function to fold over fields, with three cases, to generate more efficient and concise code. When the `substructure` has grouped fields, there are two cases: Zero fields: call the base case function with None (like the usual base case of `cs_fold`). One or more fields: call the base case function on the first value (which depends on `use_fold`), and use that as the base case. Then perform `cs_fold` on the remainder of the fields. When the `substructure` is a `EnumNonMatchingCollapsed`, the result of `enum_nonmatch_f` is returned. Statics may not be folded over. See `cs_op` in `partial_ord.rs` for a model example.",N,[[["bool"],["f"],["b"],["enumnonmatchcollapsedfunc"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"cs_same_method","","Call the method that is being derived on all the fields, and then process the collected results. i.e.",N,[[["f"],["enumnonmatchcollapsedfunc"],["extctxt"],["span"],["substructure"]],["p",["expr"]]]],[5,"is_type_without_fields","","Return true if the type has no value fields (for an enum, no variant has any fields)",N,[[["annotatable"]],["bool"]]],[0,"ty","","A mini version of ast::Ty, which is easier to use, and features an explicit `Self` type to use when specifying impls to be derived.",N,N],[3,"Path","syntax_ext::deriving::generic::ty","A path, e.g. `::std::option::Option::<i32>` (global). Has support for type parameters and a lifetime.",N,N],[12,"path","","",9,N],[12,"lifetime","","",9,N],[12,"params","","",9,N],[12,"kind","","",9,N],[3,"LifetimeBounds","","Lifetimes and bounds on type parameters",N,N],[12,"lifetimes","","",10,N],[12,"bounds","","",10,N],[4,"PtrTy","","The types of pointers",N,N],[13,"Borrowed","","&'lifetime mut",11,N],[13,"Raw","","*mut",11,N],[4,"PathKind","","",N,N],[13,"Local","","",12,N],[13,"Global","","",12,N],[13,"Std","","",12,N],[4,"Ty","","A type. Supports pointers, Self, and literals",N,N],[13,"Self_","","",13,N],[13,"Ptr","","&/Box/ Ty",13,N],[13,"Literal","","mod::mod::Type<[lifetime], [Params...]>, including a plain type parameter, and things like `i32`",13,N],[13,"Tuple","","includes unit",13,N],[5,"borrowed_ptrty","","",N,[[],["ptrty"]]],[5,"borrowed","","",N,[[["box",["ty"]]],["ty"]]],[5,"borrowed_explicit_self","","",N,[[],["option",["option"]]]],[5,"borrowed_self","","",N,[[],["ty"]]],[5,"nil_ty","","",N,[[],["ty"]]],[5,"mk_lifetime","","",N,[[["extctxt"],["span"],["option"]],["option",["lifetime"]]]],[5,"mk_lifetimes","","",N,[[["extctxt"],["span"],["option"]],["vec",["lifetime"]]]],[5,"mk_ty_param","","",N,N],[5,"mk_generics","","",N,[[["vec",["genericparam"]],["span"]],["generics"]]],[5,"get_explicit_self","","",N,N],[11,"clone","","",11,[[["self"]],["ptrty"]]],[11,"clone","","",9,[[["self"]],["path"]]],[11,"clone","","",12,[[["self"]],["pathkind"]]],[11,"new","","",9,[[["vec",["str"]]],["path"]]],[11,"new_local","","",9,[[["str"]],["path"]]],[11,"new_","","",9,[[["vec",["str"]],["option",["str"]],["vec",["box"]],["pathkind"]],["path"]]],[11,"to_ty","","",9,[[["self"],["extctxt"],["span"],["ident"],["generics"]],["p",["ty"]]]],[11,"to_path","","",9,[[["self"],["extctxt"],["span"],["ident"],["generics"]],["path"]]],[11,"clone","","",13,[[["self"]],["ty"]]],[11,"to_ty","","",13,[[["self"],["extctxt"],["span"],["ident"],["generics"]],["p",["ty"]]]],[11,"to_path","","",13,[[["self"],["extctxt"],["span"],["ident"],["generics"]],["path"]]],[11,"clone","","",10,[[["self"]],["lifetimebounds"]]],[11,"empty","","",10,[[],["lifetimebounds"]]],[11,"to_generics","","",10,[[["self"],["extctxt"],["span"],["ident"],["generics"]],["generics"]]],[6,"CombineSubstructureFunc","syntax_ext::deriving::generic","Combine the values of all the fields together. The last argument is all the fields of all the structures.",N,N],[6,"EnumNonMatchCollapsedFunc","","Deal with non-matching enum variants.  The tuple is a list of identifiers (one for each `Self` argument, which could be any of the variants since they have been collapsed together) and the identifiers holding the variant index value for each of the `Self` arguments.  The last argument is all the non-`Self` args of the method being derived.",N,N],[11,"expand","","",3,[[["self"],["extctxt"],["metaitem"],["annotatable"],["fnmut"]]]],[11,"expand_ext","","",3,[[["self"],["extctxt"],["metaitem"],["annotatable"],["fnmut"],["bool"]]]],[11,"create_derived_impl","","Given that we are deriving a trait `DerivedTrait` for a type like:",3,[[["self"],["extctxt"],["ident"],["generics"],["vec",["p"]],["vec",["implitem"]]],["p",["item"]]]],[11,"expand_struct_def","","",3,[[["self"],["extctxt"],["variantdata"],["ident"],["generics"],["bool"],["bool"]],["p",["item"]]]],[11,"expand_enum_def","","",3,N],[11,"call_substructure_method","","",4,N],[11,"get_ret_ty","","",4,[[["self"],["extctxt"],["traitdef"],["generics"],["ident"]],["p",["ty"]]]],[11,"is_static","","",4,[[["self"]],["bool"]]],[11,"split_self_nonself_args","","",4,N],[11,"create_method","","",4,[[["self"],["extctxt"],["traitdef"],["ident"],["generics"],["abi"],["option",["explicitself"]],["vec"],["p",["expr"]]],["implitem"]]],[11,"expand_struct_method_body","","",4,N],[11,"expand_static_struct_method_body","","",4,N],[11,"expand_enum_method_body","","",4,N],[11,"build_enum_match_tuple","","Creates a match for a tuple of all `self_args`, where either all variants match, or it falls into a catch-all for when one variant does not match. There are N + 1 cases because is a case for each of the N variants where all of the variants match, and one catch-all for when one does not match. As an optimization we generate code which checks whether all variants match first which makes llvm see that C-like enums can be compiled into a simple equality check (for PartialEq). The catch-all handler is provided access the variant index values for each of the self-args, carried in precomputed variables. ```{.text} let __self0_vi = unsafe {     std::intrinsics::discriminant_value(&self) } as i32; let __self1_vi = unsafe {     std::intrinsics::discriminant_value(&arg1) } as i32; let __self2_vi = unsafe {     std::intrinsics::discriminant_value(&arg2) } as i32;",4,N],[11,"expand_static_enum_method_body","","",4,N],[11,"summarise_struct","","",3,[[["self"],["extctxt"],["variantdata"]],["staticfields"]]],[11,"create_subpatterns","","",3,[[["self"],["extctxt"],["vec",["ident"]],["mutability"],["bool"]],["vec",["p"]]]],[11,"create_struct_pattern","","",3,N],[11,"create_enum_variant_pattern","","",3,N],[0,"asm","syntax_ext","",N,N],[4,"State","syntax_ext::asm","",N,N],[13,"Asm","","",14,N],[13,"Outputs","","",14,N],[13,"Inputs","","",14,N],[13,"Clobbers","","",14,N],[13,"Options","","",14,N],[13,"StateNone","","",14,N],[5,"expand_asm","","",N,N],[17,"OPTIONS","","",N,N],[11,"next","","",14,[[["self"]],["state"]]],[0,"assert","syntax_ext","",N,N],[5,"expand_assert","syntax_ext::assert","",N,N],[0,"cfg","syntax_ext","",N,N],[5,"expand_cfg","syntax_ext::cfg","",N,N],[0,"compile_error","syntax_ext","",N,N],[5,"expand_compile_error","syntax_ext::compile_error","",N,N],[0,"concat","syntax_ext","",N,N],[5,"expand_syntax_ext","syntax_ext::concat","",N,N],[0,"concat_idents","syntax_ext","",N,N],[5,"expand_syntax_ext","syntax_ext::concat_idents","",N,N],[0,"env","syntax_ext","",N,N],[5,"expand_option_env","syntax_ext::env","",N,N],[5,"expand_env","","",N,N],[0,"format","syntax_ext","",N,N],[3,"Context","syntax_ext::format","",N,N],[12,"ecx","","",15,N],[12,"macsp","","The macro's call site. References to unstable formatting internals must use this span to pass the stability checker.",15,N],[12,"fmtsp","","The span of the format string literal.",15,N],[12,"args","","List of parsed argument expressions. Named expressions are resolved early, and are appended to the end of argument expressions.",15,N],[12,"arg_types","","Placeholder slot numbers indexed by argument.",15,N],[12,"arg_unique_types","","Unique format specs seen for each argument.",15,N],[12,"names","","Map from named arguments to their resolved indices.",15,N],[12,"literal","","The latest consecutive literal strings, or empty if there weren't any.",15,N],[12,"pieces","","Collection of the compiled `rt::Argument` structures",15,N],[12,"str_pieces","","Collection of string literals",15,N],[12,"all_pieces_simple","","Stays `true` if all formatting parameters are default (as in \"{}{}\").",15,N],[12,"arg_index_map","","Mapping between positional argument references and indices into the final generated static argument array. We record the starting indices corresponding to each positional argument, and number of references consumed so far for each argument, to facilitate correct `Position` mapping in `build_piece`. In effect this can be seen as a \"flattened\" version of `arg_unique_types`.",15,N],[12,"count_args_index_offset","","Starting offset of count argument slots.",15,N],[12,"count_args","","Count argument slots and tracking data structures. Count arguments are separately tracked for de-duplication in case multiple references are made to one argument. For example, in this format string:",15,N],[12,"count_positions","","Relative slot numbers for count arguments.",15,N],[12,"count_positions_count","","Number of count slots assigned.",15,N],[12,"curarg","","Current position of the implicit positional arg pointer, as if it still existed in this phase of processing. Used only for `all_pieces_simple` tracking in `build_piece`.",15,N],[12,"curpiece","","Current piece being evaluated, used for error reporting.",15,N],[12,"invalid_refs","","Keep track of invalid references to positional arguments.",15,N],[12,"arg_spans","","Spans of all the formatting arguments, in order.",15,N],[12,"is_literal","","Whether this formatting string is a literal or it comes from a macro.",15,N],[4,"ArgumentType","","",N,N],[13,"Placeholder","","",16,N],[13,"Count","","",16,N],[4,"Position","","",N,N],[13,"Exact","","",17,N],[13,"Named","","",17,N],[5,"parse_args","","Parses the arguments from the given list of tokens, returning None if there's a parse error so we can continue parsing other format! expressions.",N,N],[5,"expand_format_args","","",N,N],[5,"expand_format_args_nl","","",N,N],[5,"expand_preparsed_format_args","","Take the various parts of `format_args!(efmt, args..., name=names...)` and construct the appropriate formatting expression.",N,[[["extctxt"],["span"],["p",["expr"]],["vec",["p"]],["fxhashmap",["string","usize"]],["bool"]],["p",["expr"]]]],[11,"eq","","",16,[[["self"],["argumenttype"]],["bool"]]],[11,"ne","","",16,[[["self"],["argumenttype"]],["bool"]]],[11,"resolve_name_inplace","","",15,[[["self"],["piece"]]]],[11,"verify_piece","","Verifies one piece of a parse string, and remembers it if valid. All errors are not emitted as fatal so we can continue giving errors about this and possibly other format strings.",15,[[["self"],["piece"]]]],[11,"verify_count","","",15,[[["self"],["count"]]]],[11,"describe_num_args","","",15,[[["self"]],["cow",["str"]]]],[11,"report_invalid_references","","Handle invalid references to positional arguments. Output different errors for the case where all arguments are positional and for when there are named arguments or numbered positional arguments in the format string.",15,[[["self"],["bool"]]]],[11,"verify_arg_type","","Actually verifies and tracks a given format placeholder (a.k.a. argument).",15,[[["self"],["position"],["argumenttype"]]]],[11,"build_index_map","","Builds the mapping between format placeholders and argument objects.",15,[[["self"]]]],[11,"rtpath","","",15,[[["extctxt"],["str"]],["vec",["ident"]]]],[11,"build_count","","",15,[[["self"],["count"]],["p",["expr"]]]],[11,"build_literal_string","","Build a literal expression from the accumulated string literals",15,[[["self"]],["p",["expr"]]]],[11,"build_piece","","Build a static `rt::Argument` from a `parse::Piece` or append to the `literal` string.",15,[[["self"],["piece"],["vec"]],["option",["p"]]]],[11,"into_expr","","Actually builds the expression which the format_args! block will be expanded to",15,[[["self"]],["p",["expr"]]]],[11,"format_arg","","",15,[[["extctxt"],["span"],["span"],["argumenttype"],["ident"]],["p",["expr"]]]],[0,"format_foreign","syntax_ext","",N,N],[0,"printf","syntax_ext::format_foreign","",N,N],[3,"Format","syntax_ext::format_foreign::printf","A single `printf`-style formatting directive.",N,N],[12,"span","","The entire original formatting directive.",18,N],[12,"parameter","","The (1-based) parameter to be converted.",18,N],[12,"flags","","Formatting flags.",18,N],[12,"width","","Minimum width of the output.",18,N],[12,"precision","","Precision of the conversion.",18,N],[12,"length","","Length modifier for the conversion.",18,N],[12,"type_","","Type of parameter being converted.",18,N],[12,"position","","Byte offset for the start and end of this formatting directive.",18,N],[3,"Substitutions","","Iterator over substitutions in a string.",N,N],[12,"s","","",19,N],[12,"pos","","",19,N],[4,"Substitution","","Represents a single `printf`-style substitution.",N,N],[13,"Format","","A formatted output substitution with its internal byte offset.",20,N],[13,"Escape","","A literal `%%` escape.",20,N],[4,"Num","","A general number used in a `printf` formatting directive.",N,N],[13,"Num","","A specific, fixed value.",21,N],[13,"Arg","","The value is derived from a positional argument.",21,N],[13,"Next","","The value is derived from the \"next\" unconverted argument.",21,N],[4,"State","","",N,N],[13,"Start","","",22,N],[13,"Flags","","",22,N],[13,"Width","","",22,N],[13,"WidthArg","","",22,N],[13,"Prec","","",22,N],[13,"PrecInner","","",22,N],[13,"Length","","",22,N],[13,"Type","","",22,N],[5,"iter_subs","","Returns an iterator over all substitutions in a given string.",N,[[["str"]],["substitutions"]]],[5,"parse_next_substitution","","Parse the next substitution from the input string.",N,[[["str"]],["option"]]],[5,"at_next_cp_while","","",N,[[["cur"],["f"]],["cur"]]],[5,"is_digit","","",N,[[["char"]],["bool"]]],[5,"is_flag","","",N,[[["char"]],["bool"]]],[11,"clone","","",20,[[["self"]],["substitution"]]],[11,"eq","","",20,[[["self"],["substitution"]],["bool"]]],[11,"ne","","",20,[[["self"],["substitution"]],["bool"]]],[11,"fmt","","",20,[[["self"],["formatter"]],["result"]]],[11,"as_str","","",20,[[["self"]],["str"]]],[11,"position","","",20,[[["self"]],["option"]]],[11,"set_position","","",20,[[["self"],["usize"],["usize"]]]],[11,"translate","","Translate this substitution into an equivalent Rust formatting directive.",20,[[["self"]],["option",["string"]]]],[11,"clone","","",18,[[["self"]],["format"]]],[11,"eq","","",18,[[["self"],["format"]],["bool"]]],[11,"ne","","",18,[[["self"],["format"]],["bool"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"translate","","Translate this directive into an equivalent Rust formatting directive.",18,[[["self"]],["option",["string"]]]],[11,"clone","","",21,[[["self"]],["num"]]],[11,"eq","","",21,[[["self"],["num"]],["bool"]]],[11,"ne","","",21,[[["self"],["num"]],["bool"]]],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"from_str","","",21,[[["str"],["option",["str"]]],["self"]]],[11,"translate","","",21,[[["self"],["string"]],["result"]]],[11,"next","","",19,[[["self"]],["option"]]],[11,"size_hint","","",19,N],[0,"shell","syntax_ext::format_foreign","",N,N],[3,"Substitutions","syntax_ext::format_foreign::shell","Iterator over substitutions in a string.",N,N],[12,"s","","",23,N],[12,"pos","","",23,N],[4,"Substitution","","",N,N],[13,"Ordinal","","",24,N],[13,"Name","","",24,N],[13,"Escape","","",24,N],[5,"iter_subs","","Returns an iterator over all substitutions in a given string.",N,[[["str"]],["substitutions"]]],[5,"parse_next_substitution","","Parse the next substitution from the input string.",N,[[["str"]],["option"]]],[5,"at_next_cp_while","","",N,[[["cur"],["f"]],["cur"]]],[5,"is_ident_head","","",N,[[["char"]],["bool"]]],[5,"is_ident_tail","","",N,[[["char"]],["bool"]]],[11,"clone","","",24,[[["self"]],["substitution"]]],[11,"eq","","",24,[[["self"],["substitution"]],["bool"]]],[11,"ne","","",24,[[["self"],["substitution"]],["bool"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"as_str","","",24,[[["self"]],["string"]]],[11,"position","","",24,[[["self"]],["option"]]],[11,"set_position","","",24,[[["self"],["usize"],["usize"]]]],[11,"translate","","",24,[[["self"]],["option",["string"]]]],[11,"next","","",23,[[["self"]],["option"]]],[11,"size_hint","","",23,N],[0,"strcursor","syntax_ext::format_foreign","",N,N],[3,"StrCursor","syntax_ext::format_foreign::strcursor","",N,N],[12,"s","","",25,N],[12,"at","","",25,N],[5,"str_eq_literal","","",N,[[["str"],["str"]],["bool"]]],[11,"new_at","","",25,[[["str"],["usize"]],["strcursor"]]],[11,"at_next_cp","","",25,[[["self"]],["option",["strcursor"]]]],[11,"next_cp","","",25,[[["self"]],["option"]]],[11,"slice_before","","",25,[[["self"]],["str"]]],[11,"slice_after","","",25,[[["self"]],["str"]]],[11,"slice_between","","",25,[[["self"],["strcursor"]],["option",["str"]]]],[11,"cp_after","","",25,[[["self"]],["option",["char"]]]],[11,"try_seek_right_cp","","",25,[[["self"]],["bool"]]],[11,"seek_right","","",25,[[["self"],["usize"]]]],[11,"clone","","",25,[[["self"]],["strcursor"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[0,"global_asm","syntax_ext","",N,N],[5,"expand_global_asm","syntax_ext::global_asm","",N,N],[17,"MACRO","","",N,N],[0,"log_syntax","syntax_ext","",N,N],[5,"expand_syntax_ext","syntax_ext::log_syntax","",N,N],[0,"trace_macros","syntax_ext","",N,N],[5,"expand_trace_macros","syntax_ext::trace_macros","",N,N],[0,"test","syntax_ext","",N,N],[4,"ShouldPanic","syntax_ext::test","",N,N],[13,"No","","",26,N],[13,"Yes","","",26,N],[5,"expand_test","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"]],["vec",["annotatable"]]]],[5,"expand_bench","","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"]],["vec",["annotatable"]]]],[5,"expand_test_or_bench","","",N,[[["extctxt"],["span"],["annotatable"],["bool"]],["vec",["annotatable"]]]],[5,"item_path","","",N,N],[5,"should_ignore","","",N,[[["item"]],["bool"]]],[5,"should_fail","","",N,[[["item"]],["bool"]]],[5,"should_panic","","",N,[[["extctxt"],["item"]],["shouldpanic"]]],[5,"has_test_signature","","",N,[[["extctxt"],["item"]],["bool"]]],[5,"has_bench_signature","","",N,[[["extctxt"],["item"]],["bool"]]],[0,"test_case","syntax_ext","",N,N],[5,"expand","syntax_ext::test_case","",N,[[["extctxt"],["span"],["metaitem"],["annotatable"]],["vec",["annotatable"]]]],[0,"proc_macro_registrar","syntax_ext","",N,N],[3,"ProcMacroDerive","syntax_ext::proc_macro_registrar","",N,N],[12,"trait_name","","",27,N],[12,"function_name","","",27,N],[12,"span","","",27,N],[12,"attrs","","",27,N],[3,"ProcMacroDef","","",N,N],[12,"function_name","","",28,N],[12,"span","","",28,N],[3,"CollectProcMacros","","",N,N],[12,"derives","","",29,N],[12,"attr_macros","","",29,N],[12,"bang_macros","","",29,N],[12,"in_root","","",29,N],[12,"handler","","",29,N],[12,"is_proc_macro_crate","","",29,N],[12,"is_test_crate","","",29,N],[5,"modify","","",N,[[["parsesess"],["resolver"],["crate"],["bool"],["bool"],["usize"],["handler"]],["crate"]]],[5,"is_proc_macro_attr","","",N,[[["attribute"]],["bool"]]],[5,"mk_registrar","","",N,N],[17,"PROC_MACRO_KINDS","","",N,N],[11,"check_not_pub_in_root","","",29,[[["self"],["visibility"],["span"]]]],[11,"collect_custom_derive","","",29,[[["self"],["item"],["attribute"]]]],[11,"collect_attr_proc_macro","","",29,[[["self"],["item"],["attribute"]]]],[11,"collect_bang_proc_macro","","",29,[[["self"],["item"],["attribute"]]]],[11,"visit_item","","",29,[[["self"],["item"]]]],[11,"visit_mac","","",29,[[["self"],["mac"]]]],[0,"proc_macro_impl","syntax_ext","",N,N],[3,"AttrProcMacro","syntax_ext::proc_macro_impl","",N,N],[12,"inner","","",30,N],[3,"BangProcMacro","","",N,N],[12,"inner","","",31,N],[11,"expand","","",30,[[["self"],["extctxt"],["span"],["tokenstream"],["tokenstream"]],["tokenstream"]]],[11,"expand","","",31,[[["self"],["extctxt"],["span"],["tokenstream"]],["tokenstream"]]],[14,"path_local","syntax_ext","",N,N],[14,"pathvec_std","","",N,N],[14,"path_std","","",N,N],[11,"from","syntax_ext::deriving::custom","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"expand","","",1,[[["self"],["extctxt"],["span"],["metaitem"],["annotatable"]],["vec",["annotatable"]]]],[11,"to_owned","syntax_ext::deriving::partial_ord","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"from","syntax_ext::deriving::generic","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax_ext::deriving::generic::ty","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"to_owned","","",10,[[["self"]],["t"]]],[11,"clone_into","","",10,N],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"to_owned","","",11,[[["self"]],["t"]]],[11,"clone_into","","",11,N],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"to_owned","","",12,[[["self"]],["t"]]],[11,"clone_into","","",12,N],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"to_owned","","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from","syntax_ext::asm","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from","syntax_ext::format","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax_ext::format_foreign::printf","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"from","","",19,[[["t"]],["t"]]],[11,"into_iter","","",19,[[["self"]],["i"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"from","syntax_ext::format_foreign::shell","",23,[[["t"]],["t"]]],[11,"into_iter","","",23,[[["self"]],["i"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"to_owned","","",24,[[["self"]],["t"]]],[11,"clone_into","","",24,N],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax_ext::format_foreign::strcursor","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"from","syntax_ext::test","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"from","syntax_ext::proc_macro_registrar","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"from","syntax_ext::proc_macro_impl","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"expand","","",30,[[["self"],["extctxt"],["span"],["tokenstream"],["tokenstream"]],["tokenstream"]]],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"expand","","",31,[[["self"],["extctxt"],["span"],["tokenstream"]],["tokenstream"]]]],"paths":[[3,"MarkAttrs"],[3,"ProcMacroDerive"],[4,"OrderingOp"],[3,"TraitDef"],[3,"MethodDef"],[3,"Substructure"],[3,"FieldInfo"],[4,"StaticFields"],[4,"SubstructureFields"],[3,"Path"],[3,"LifetimeBounds"],[4,"PtrTy"],[4,"PathKind"],[4,"Ty"],[4,"State"],[3,"Context"],[4,"ArgumentType"],[4,"Position"],[3,"Format"],[3,"Substitutions"],[4,"Substitution"],[4,"Num"],[4,"State"],[3,"Substitutions"],[4,"Substitution"],[3,"StrCursor"],[4,"ShouldPanic"],[3,"ProcMacroDerive"],[3,"ProcMacroDef"],[3,"CollectProcMacros"],[3,"AttrProcMacro"],[3,"BangProcMacro"]]};
searchIndex["syntax_pos"]={"doc":"The source positions and related helper functions","items":[[3,"Span","syntax_pos","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",N,N],[12,"0","","",0,N],[3,"Globals","","",N,N],[12,"symbol_interner","","",1,N],[12,"span_interner","","",1,N],[12,"hygiene_data","","",1,N],[3,"SpanData","","Spans represent a region of code, used for error reporting. Positions in spans are absolute positions from the beginning of the source_map, not positions relative to SourceFiles. Methods on the SourceMap can be used to relate spans back to the original source. You must be careful if the span crosses more than one file - you will not be able to use many of the functions on spans in source_map and you cannot assume that the length of the span = hi - lo; there may be space in the BytePos range between files.",N,N],[12,"lo","","",2,N],[12,"hi","","",2,N],[12,"ctxt","","Information about where the macro came from, if this piece of code was created by a macro expansion.",2,N],[3,"MultiSpan","","A collection of spans. Spans have two orthogonal attributes:",N,N],[12,"primary_spans","","",3,N],[12,"span_labels","","",3,N],[3,"SpanLabel","","",N,N],[12,"span","","The span we are going to include in the final snippet.",4,N],[12,"is_primary","","Is this a primary span? This is the \"locus\" of the message, and is indicated with a `^^^^` underline, versus `----`.",4,N],[12,"label","","What label should we attach to this span (if any)?",4,N],[3,"MultiByteChar","","Identifies an offset of a multi-byte character in a SourceFile",N,N],[12,"pos","","The absolute offset of the character in the SourceMap",5,N],[12,"bytes","","The number of bytes, >=2",5,N],[3,"SourceFile","","A single source in the SourceMap.",N,N],[12,"name","","The name of the file that the source came from, source that doesn't originate from files has names between angle brackets by convention, e.g. `<anon>`",6,N],[12,"name_was_remapped","","True if the `name` field above has been modified by --remap-path-prefix",6,N],[12,"unmapped_path","","The unmapped path of the file that the source came from. Set to `None` if the SourceFile was imported from an external crate.",6,N],[12,"crate_of_origin","","Indicates which crate this SourceFile was imported from.",6,N],[12,"src","","The complete source code",6,N],[12,"src_hash","","The source code's hash",6,N],[12,"external_src","","The external source code (used for external crates, which will have a `None` value as `self.src`.",6,N],[12,"start_pos","","The start position of this source in the SourceMap",6,N],[12,"end_pos","","The end position of this source in the SourceMap",6,N],[12,"lines","","Locations of lines beginnings in the source code",6,N],[12,"multibyte_chars","","Locations of multi-byte characters in the source code",6,N],[12,"non_narrow_chars","","Width of characters that are not narrow in the source code",6,N],[12,"name_hash","","A hash of the filename, used for speeding up the incr. comp. hashing.",6,N],[3,"BytePos","","A byte offset. Keep this small (currently 32-bits), as AST contains a lot of them.",N,N],[12,"0","","",7,N],[3,"CharPos","","A character offset. Because of multibyte utf8 characters, a byte offset is not equivalent to a character offset. The SourceMap will convert BytePos values to CharPos values as necessary.",N,N],[12,"0","","",8,N],[3,"Loc","","A source code location used for error reporting",N,N],[12,"file","","Information about the original source",9,N],[12,"line","","The (1-based) line number",9,N],[12,"col","","The (0-based) column offset",9,N],[12,"col_display","","The (0-based) column offset when displayed",9,N],[3,"LocWithOpt","","A source code location used as the result of lookup_char_pos_adj",N,N],[12,"filename","","",10,N],[12,"line","","",10,N],[12,"col","","",10,N],[12,"file","","",10,N],[3,"SourceFileAndLine","","",N,N],[12,"fm","","",11,N],[12,"line","","",11,N],[3,"SourceFileAndBytePos","","",N,N],[12,"fm","","",12,N],[12,"pos","","",12,N],[3,"LineInfo","","",N,N],[12,"line_index","","Index of line, starting from 0.",13,N],[12,"start_col","","Column in line where span begins, starting from 0.",13,N],[12,"end_col","","Column in line where span ends, starting from 0, exclusive.",13,N],[3,"FileLines","","",N,N],[12,"file","","",14,N],[12,"lines","","",14,N],[3,"MacroBacktrace","","",N,N],[12,"call_site","","span where macro was applied to generate this code",15,N],[12,"macro_decl_name","","name of macro that was applied (e.g., \"foo!\" or \"#[derive(Eq)]\")",15,N],[12,"def_site_span","","span where macro was defined (if known)",15,N],[3,"DistinctSources","","",N,N],[12,"begin","","",16,N],[12,"end","","",16,N],[3,"MalformedCodemapPositions","","",N,N],[12,"name","","",17,N],[12,"source_len","","",17,N],[12,"begin_pos","","",17,N],[12,"end_pos","","",17,N],[4,"FileName","","Differentiates between real files and common virtual files",N,N],[13,"Real","","",18,N],[13,"Macros","","A macro.  This includes the full name of the macro, so that there are no clashes.",18,N],[13,"QuoteExpansion","","call to `quote!`",18,N],[13,"Anon","","Command line",18,N],[13,"MacroExpansion","","Hack in src/libsyntax/parse.rs FIXME(jseyfried)",18,N],[13,"ProcMacroSourceCode","","",18,N],[13,"CfgSpec","","Strings provided as --cfg [cfgspec] stored in a crate_cfg",18,N],[13,"CliCrateAttr","","Strings provided as crate attributes in the CLI",18,N],[13,"Custom","","Custom sources for explicit parser calls from plugins and drivers",18,N],[4,"NonNarrowChar","","Identifies an offset of a non-narrow character in a SourceFile",N,N],[13,"ZeroWidth","","Represents a zero-width character",19,N],[13,"Wide","","Represents a wide (fullwidth) character",19,N],[13,"Tab","","Represents a tab character, represented visually with a width of 4 characters",19,N],[4,"ExternalSource","","The state of the lazy external source loading mechanism of a SourceFile.",N,N],[13,"Present","","The external source has been loaded already.",20,N],[13,"AbsentOk","","No attempt has been made to load the external source.",20,N],[13,"AbsentErr","","A failed attempt has been made to load the external source.",20,N],[13,"Unneeded","","No external source has to be loaded, since the SourceFile represents a local crate.",20,N],[4,"SpanLinesError","","",N,N],[13,"IllFormedSpan","","",21,N],[13,"DistinctSources","","",21,N],[4,"SpanSnippetError","","",N,N],[13,"IllFormedSpan","","",22,N],[13,"DistinctSources","","",22,N],[13,"MalformedForCodemap","","",22,N],[13,"SourceNotAvailable","","",22,N],[12,"filename","syntax_pos::SpanSnippetError","",22,N],[5,"default_span_debug","syntax_pos","",N,[[["span"],["formatter"]],["result"]]],[5,"remove_bom","","Remove utf-8 BOM if any.",N,[[["string"]]]],[5,"lookup_line","","",N,N],[0,"edition","","",N,N],[4,"Edition","syntax_pos::edition","The edition of the compiler (RFC 2052)",N,N],[13,"Edition2015","","The 2015 edition",23,N],[13,"Edition2018","","The 2018 edition",23,N],[17,"ALL_EDITIONS","","",N,N],[17,"EDITION_NAME_LIST","","",N,N],[17,"DEFAULT_EDITION","","",N,N],[11,"clone","","",23,[[["self"]],["edition"]]],[11,"hash","","",23,N],[11,"eq","","",23,[[["self"],["edition"]],["bool"]]],[11,"partial_cmp","","",23,[[["self"],["edition"]],["option",["ordering"]]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"encode","","",23,[[["self"],["__s"]],["result"]]],[11,"decode","","",23,[[["__d"]],["result",["edition"]]]],[11,"fmt","","",23,[[["self"],["formatter"]],["result"]]],[11,"lint_name","","",23,[[["self"]],["str"]]],[11,"feature_name","","",23,[[["self"]],["str"]]],[11,"is_stable","","",23,[[["self"]],["bool"]]],[11,"from_str","","",23,[[["str"]],["result"]]],[0,"hygiene","syntax_pos","Machinery for hygienic macros, inspired by the `MTWT[1]` paper.",N,N],[3,"SyntaxContext","syntax_pos::hygiene","A SyntaxContext represents a chain of macro expansions (represented by marks).",N,N],[12,"0","","",24,N],[3,"SyntaxContextData","","",N,N],[12,"outer_mark","","",25,N],[12,"transparency","","",25,N],[12,"prev_ctxt","","",25,N],[12,"opaque","","",25,N],[12,"opaque_and_semitransparent","","",25,N],[3,"Mark","","A mark is a unique id associated with a macro expansion.",N,N],[12,"0","","",26,N],[3,"MarkData","","",N,N],[12,"parent","","",27,N],[12,"default_transparency","","",27,N],[12,"is_builtin","","",27,N],[12,"expn_info","","",27,N],[3,"HygieneData","","",N,N],[12,"marks","","",28,N],[12,"syntax_contexts","","",28,N],[12,"markings","","",28,N],[12,"default_edition","","",28,N],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",N,N],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",29,N],[12,"def_site","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None. This span serves only informational purpose and is not used for resolution.",29,N],[12,"format","","The format with which the macro was invoked.",29,N],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",29,N],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",29,N],[12,"local_inner_macros","","Enables the macro helper hack (`ident!(...)` -> `$crate::ident!(...)`) for a given macro.",29,N],[12,"edition","","Edition of the crate in which the macro is defined.",29,N],[4,"Transparency","","A property of a macro expansion that determines how identifiers produced by that expansion are resolved.",N,N],[13,"Transparent","","Identifier produced by a transparent expansion is always resolved at call-site. Call-site spans in procedural macros, hygiene opt-out in `macro` should use this.",30,N],[13,"SemiTransparent","","Identifier produced by a semi-transparent expansion may be resolved either at call-site or at definition-site. If it's a local variable, label or `$crate` then it's resolved at def-site. Otherwise it's resolved at call-site. `macro_rules` macros behave like this, built-in macros currently behave like this too, but that's an implementation detail.",30,N],[13,"Opaque","","Identifier produced by an opaque expansion is always resolved at definition-site. Def-site spans in procedural macros, identifiers from `macro` by default use this.",30,N],[4,"ExpnFormat","","The source of expansion.",N,N],[13,"MacroAttribute","","e.g. #[derive(...)] ",31,N],[13,"MacroBang","","e.g. `format!()`",31,N],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",31,N],[4,"CompilerDesugaringKind","","The kind of compiler desugaring.",N,N],[13,"QuestionMark","","",32,N],[13,"TryBlock","","",32,N],[13,"ExistentialReturnType","","Desugaring of an `impl Trait` in return type position to an `existential type Foo: Trait;` + replacing the `impl Trait` with `Foo`.",32,N],[13,"Async","","",32,N],[13,"ForLoop","","",32,N],[5,"default_edition","","",N,[[],["edition"]]],[5,"set_default_edition","","",N,[[["edition"]]]],[5,"clear_markings","","",N,[[]]],[11,"clone","","",24,[[["self"]],["syntaxcontext"]]],[11,"eq","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"ne","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",24,N],[11,"default","","",24,[[],["syntaxcontext"]]],[11,"partial_cmp","","",24,[[["self"],["syntaxcontext"]],["option",["ordering"]]]],[11,"lt","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"le","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"gt","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"ge","","",24,[[["self"],["syntaxcontext"]],["bool"]]],[11,"cmp","","",24,[[["self"],["syntaxcontext"]],["ordering"]]],[11,"hash","","",24,N],[11,"clone","","",25,[[["self"]],["syntaxcontextdata"]]],[11,"fmt","","",25,[[["self"],["formatter"]],["result"]]],[11,"clone","","",26,[[["self"]],["mark"]]],[11,"eq","","",26,[[["self"],["mark"]],["bool"]]],[11,"ne","","",26,[[["self"],["mark"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",26,N],[11,"hash","","",26,N],[11,"fmt","","",26,[[["self"],["formatter"]],["result"]]],[11,"encode","","",26,[[["self"],["__s"]],["result"]]],[11,"decode","","",26,[[["__d"]],["result",["mark"]]]],[11,"clone","","",27,[[["self"]],["markdata"]]],[11,"fmt","","",27,[[["self"],["formatter"]],["result"]]],[11,"clone","","",30,[[["self"]],["transparency"]]],[11,"eq","","",30,[[["self"],["transparency"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",30,N],[11,"partial_cmp","","",30,[[["self"],["transparency"]],["option",["ordering"]]]],[11,"hash","","",30,N],[11,"fmt","","",30,[[["self"],["formatter"]],["result"]]],[11,"fresh","","",26,[[["mark"]],["self"]]],[11,"root","","The mark of the theoretical expansion that generates freshly parsed, unexpanded AST.",26,[[],["self"]]],[11,"as_u32","","",26,[[["self"]],["u32"]]],[11,"from_u32","","",26,[[["u32"]],["mark"]]],[11,"parent","","",26,[[["self"]],["mark"]]],[11,"expn_info","","",26,[[["self"]],["option",["expninfo"]]]],[11,"set_expn_info","","",26,[[["self"],["expninfo"]]]],[11,"set_default_transparency","","",26,[[["self"],["transparency"]]]],[11,"is_builtin","","",26,[[["self"]],["bool"]]],[11,"set_is_builtin","","",26,[[["self"],["bool"]]]],[11,"is_descendant_of","","",26,[[["self"],["mark"]],["bool"]]],[11,"least_ancestor","","Computes a mark such that both input marks are descendants of (or equal to) the returned mark. That is, the following holds:",26,[[["mark"],["mark"]],["mark"]]],[11,"looks_like_proc_macro_derive","","",26,[[["self"]],["bool"]]],[11,"fmt","","",28,[[["self"],["formatter"]],["result"]]],[11,"new","","",28,[[],["self"]]],[11,"with","","",28,[[["f"]],["t"]]],[11,"empty","","",24,[[],["self"]]],[11,"as_u32","","",24,[[["self"]],["u32"]]],[11,"from_u32","","",24,[[["u32"]],["syntaxcontext"]]],[11,"allocate_directly","","",24,[[["expninfo"]],["self"]]],[11,"apply_mark","","Extend a syntax context with a given mark and default transparency for that mark.",24,[[["self"],["mark"]],["syntaxcontext"]]],[11,"apply_mark_with_transparency","","Extend a syntax context with a given mark and transparency",24,[[["self"],["mark"],["transparency"]],["syntaxcontext"]]],[11,"apply_mark_internal","","",24,[[["self"],["mark"],["transparency"]],["syntaxcontext"]]],[11,"remove_mark","","Pulls a single mark off of the syntax context. This effectively moves the context up one macro definition level. That is, if we have a nested macro definition as follows:",24,[[["self"]],["mark"]]],[11,"marks","","",24,[[["self"]],["vec"]]],[11,"adjust","","Adjust this context for resolution in a scope created by the given expansion. For example, consider the following three resolutions of `f`:",24,[[["self"],["mark"]],["option",["mark"]]]],[11,"glob_adjust","","Adjust this context for resolution in a scope created by the given expansion via a glob import with the given `SyntaxContext`. For example:",24,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"reverse_glob_adjust","","Undo `glob_adjust` if possible:",24,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"modern","","",24,[[["self"]],["syntaxcontext"]]],[11,"modern_and_legacy","","",24,[[["self"]],["syntaxcontext"]]],[11,"outer","","",24,[[["self"]],["mark"]]],[11,"fmt","","",24,[[["self"],["formatter"]],["result"]]],[11,"clone","","",29,[[["self"]],["expninfo"]]],[11,"hash","","",29,N],[11,"fmt","","",29,[[["self"],["formatter"]],["result"]]],[11,"encode","","",29,[[["self"],["__s"]],["result"]]],[11,"decode","","",29,[[["__d"]],["result",["expninfo"]]]],[11,"clone","","",31,[[["self"]],["expnformat"]]],[11,"hash","","",31,N],[11,"fmt","","",31,[[["self"],["formatter"]],["result"]]],[11,"eq","","",31,[[["self"],["expnformat"]],["bool"]]],[11,"ne","","",31,[[["self"],["expnformat"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",31,N],[11,"encode","","",31,[[["self"],["__s"]],["result"]]],[11,"decode","","",31,[[["__d"]],["result",["expnformat"]]]],[11,"name","","",31,[[["self"]],["symbol"]]],[11,"clone","","",32,[[["self"]],["compilerdesugaringkind"]]],[11,"hash","","",32,N],[11,"fmt","","",32,[[["self"],["formatter"]],["result"]]],[11,"eq","","",32,[[["self"],["compilerdesugaringkind"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",32,N],[11,"encode","","",32,[[["self"],["__s"]],["result"]]],[11,"decode","","",32,[[["__d"]],["result",["compilerdesugaringkind"]]]],[11,"name","","",32,[[["self"]],["symbol"]]],[11,"encode","","",24,[[["self"],["e"]],["result"]]],[11,"decode","","",24,[[["d"]],["result",["syntaxcontext"]]]],[0,"span_encoding","syntax_pos","",N,N],[3,"Span","syntax_pos::span_encoding","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",N,N],[12,"0","","",0,N],[3,"SpanInterner","","",N,N],[12,"spans","","",33,N],[12,"span_data","","",33,N],[5,"encode","","",N,[[["spandata"]],["span"]]],[5,"decode","","",N,[[["span"]],["spandata"]]],[5,"with_span_interner","","",N,[[["f"]],["t"]]],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",N,N],[17,"TAG_INLINE","","",N,N],[17,"TAG_INTERNED","","",N,N],[17,"TAG_MASK","","",N,N],[17,"BASE_INDEX","","",N,N],[17,"LEN_INDEX","","",N,N],[17,"CTXT_INDEX","","",N,N],[17,"INLINE_SIZES","","",N,N],[17,"INLINE_OFFSETS","","",N,N],[17,"INTERNED_INDEX_SIZE","","",N,N],[17,"INTERNED_INDEX_OFFSET","","",N,N],[11,"clone","syntax_pos","",0,[[["self"]],["span"]]],[11,"eq","","",0,[[["self"],["span"]],["bool"]]],[11,"hash","","",0,[[["self"],["h"]]]],[11,"new","","",0,[[["bytepos"],["bytepos"],["syntaxcontext"]],["self"]]],[11,"data","","",0,[[["self"]],["spandata"]]],[11,"default","syntax_pos::span_encoding","",33,[[],["spaninterner"]]],[11,"intern","","",33,[[["self"],["spandata"]],["u32"]]],[11,"get","","",33,[[["self"],["u32"]],["spandata"]]],[0,"symbol","syntax_pos","An \"interner\" is a data structure that associates values with usize tags and allows bidirectional lookup; i.e. given a value, one can easily find the type, and vice versa.",N,N],[3,"Ident","syntax_pos::symbol","",N,N],[12,"name","","",34,N],[12,"span","","",34,N],[3,"Symbol","","A symbol is an interned or gensymed string.",N,N],[12,"0","","",35,N],[3,"Interner","","",N,N],[12,"arena","","",36,N],[12,"names","","",36,N],[12,"strings","","",36,N],[12,"gensyms","","",36,N],[3,"LocalInternedString","","Represents a string stored in the interner. Because the interner outlives any thread which uses this type, we can safely treat `string` which points to interner data, as an immortal string, as long as this type never crosses between threads.",N,N],[12,"string","","",37,N],[3,"InternedString","","Represents a string stored in the string interner",N,N],[12,"symbol","","",38,N],[5,"with_interner","","",N,[[["f"]],["t"]]],[0,"keywords","","",N,N],[3,"Keyword","syntax_pos::symbol::keywords","",N,N],[12,"ident","","",39,N],[17,"Invalid","","",N,N],[17,"CrateRoot","","",N,N],[17,"DollarCrate","","",N,N],[17,"Underscore","","",N,N],[17,"As","","",N,N],[17,"Box","","",N,N],[17,"Break","","",N,N],[17,"Const","","",N,N],[17,"Continue","","",N,N],[17,"Crate","","",N,N],[17,"Else","","",N,N],[17,"Enum","","",N,N],[17,"Extern","","",N,N],[17,"False","","",N,N],[17,"Fn","","",N,N],[17,"For","","",N,N],[17,"If","","",N,N],[17,"Impl","","",N,N],[17,"In","","",N,N],[17,"Let","","",N,N],[17,"Loop","","",N,N],[17,"Match","","",N,N],[17,"Mod","","",N,N],[17,"Move","","",N,N],[17,"Mut","","",N,N],[17,"Pub","","",N,N],[17,"Ref","","",N,N],[17,"Return","","",N,N],[17,"SelfValue","","",N,N],[17,"SelfType","","",N,N],[17,"Static","","",N,N],[17,"Struct","","",N,N],[17,"Super","","",N,N],[17,"Trait","","",N,N],[17,"True","","",N,N],[17,"Type","","",N,N],[17,"Unsafe","","",N,N],[17,"Use","","",N,N],[17,"Where","","",N,N],[17,"While","","",N,N],[17,"Abstract","","",N,N],[17,"Become","","",N,N],[17,"Do","","",N,N],[17,"Final","","",N,N],[17,"Macro","","",N,N],[17,"Override","","",N,N],[17,"Priv","","",N,N],[17,"Typeof","","",N,N],[17,"Unsized","","",N,N],[17,"Virtual","","",N,N],[17,"Yield","","",N,N],[17,"Async","","",N,N],[17,"Try","","",N,N],[17,"UnderscoreLifetime","","",N,N],[17,"StaticLifetime","","",N,N],[17,"Auto","","",N,N],[17,"Catch","","",N,N],[17,"Default","","",N,N],[17,"Dyn","","",N,N],[17,"Union","","",N,N],[17,"Existential","","",N,N],[11,"clone","","",39,[[["self"]],["keyword"]]],[11,"eq","","",39,[[["self"],["keyword"]],["bool"]]],[11,"ne","","",39,[[["self"],["keyword"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",39,N],[11,"ident","","",39,[[["self"]],["ident"]]],[11,"name","","",39,[[["self"]],["symbol"]]],[11,"from_str","","",39,[[["str"]],["result"]]],[11,"clone","syntax_pos::symbol","",34,[[["self"]],["ident"]]],[11,"assert_receiver_is_total_eq","","",34,N],[11,"new","","",34,[[["symbol"],["span"]],["ident"]]],[11,"with_empty_ctxt","","",34,[[["symbol"]],["ident"]]],[11,"from_interned_str","","Maps an interned string to an identifier with an empty syntax context.",34,[[["internedstring"]],["ident"]]],[11,"from_str","","Maps a string to an identifier with an empty syntax context.",34,[[["str"]],["ident"]]],[11,"with_span_pos","","Replace `lo` and `hi` with those from `span`, but keep hygiene context.",34,[[["self"],["span"]],["ident"]]],[11,"without_first_quote","","",34,[[["self"]],["ident"]]],[11,"modern","","\"Normalize\" ident for use in comparisons using \"item hygiene\". Identifiers with same string value become same if they came from the same \"modern\" macro (e.g. `macro` item, but not `macro_rules` item) and stay different if they came from different \"modern\" macros. Technically, this operation strips all non-opaque marks from ident's syntactic context.",34,[[["self"]],["ident"]]],[11,"modern_and_legacy","","\"Normalize\" ident for use in comparisons using \"local variable hygiene\". Identifiers with same string value become same if they came from the same non-transparent macro (e.g. `macro` or `macro_rules!` items) and stay different if they came from different non-transparent macros. Technically, this operation strips all transparent marks from ident's syntactic context.",34,[[["self"]],["ident"]]],[11,"gensym","","",34,[[["self"]],["ident"]]],[11,"as_str","","",34,[[["self"]],["localinternedstring"]]],[11,"as_interned_str","","",34,[[["self"]],["internedstring"]]],[11,"eq","","",34,[[["self"],["self"]],["bool"]]],[11,"hash","","",34,[[["self"],["h"]]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",34,[[["self"],["formatter"]],["result"]]],[11,"encode","","",34,[[["self"],["s"]],["result"]]],[11,"decode","","",34,[[["d"]],["result",["ident"]]]],[11,"clone","","",35,[[["self"]],["symbol"]]],[11,"eq","","",35,[[["self"],["symbol"]],["bool"]]],[11,"ne","","",35,[[["self"],["symbol"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",35,N],[11,"partial_cmp","","",35,[[["self"],["symbol"]],["option",["ordering"]]]],[11,"lt","","",35,[[["self"],["symbol"]],["bool"]]],[11,"le","","",35,[[["self"],["symbol"]],["bool"]]],[11,"gt","","",35,[[["self"],["symbol"]],["bool"]]],[11,"ge","","",35,[[["self"],["symbol"]],["bool"]]],[11,"cmp","","",35,[[["self"],["symbol"]],["ordering"]]],[11,"hash","","",35,N],[11,"intern","","Maps a string to its interned representation.",35,[[["str"]],["self"]]],[11,"interned","","",35,[[["self"]],["self"]]],[11,"gensym","","gensym's a new usize, using the current interner.",35,[[["str"]],["self"]]],[11,"gensymed","","",35,[[["self"]],["self"]]],[11,"as_str","","",35,[[["self"]],["localinternedstring"]]],[11,"as_interned_str","","",35,[[["self"]],["internedstring"]]],[11,"as_u32","","",35,[[["self"]],["u32"]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",35,[[["self"],["formatter"]],["result"]]],[11,"encode","","",35,[[["self"],["s"]],["result"]]],[11,"decode","","",35,[[["d"]],["result",["symbol"]]]],[11,"eq","","",35,[[["self"],["t"]],["bool"]]],[11,"new","","",36,[[],["self"]]],[11,"prefill","","",36,N],[11,"intern","","",36,[[["self"],["str"]],["symbol"]]],[11,"interned","","",36,[[["self"],["symbol"]],["symbol"]]],[11,"gensym","","",36,[[["self"],["str"]],["symbol"]]],[11,"gensymed","","",36,[[["self"],["symbol"]],["symbol"]]],[11,"is_gensymed","","",36,[[["self"],["symbol"]],["bool"]]],[11,"get","","",36,[[["self"],["symbol"]],["str"]]],[11,"fresh","","",36,[[],["self"]]],[11,"is_unused_keyword_2018","","",35,[[["self"]],["bool"]]],[11,"is_special","","",34,[[["self"]],["bool"]]],[11,"is_used_keyword","","Returns `true` if the token is a keyword used in the language.",34,[[["self"]],["bool"]]],[11,"is_unused_keyword","","Returns `true` if the token is a keyword reserved for possible future use.",34,[[["self"]],["bool"]]],[11,"is_reserved","","Returns `true` if the token is either a special identifier or a keyword.",34,[[["self"]],["bool"]]],[11,"is_path_segment_keyword","","A keyword or reserved identifier that can be used as a path segment.",34,[[["self"]],["bool"]]],[11,"is_raw_guess","","",34,[[["self"]],["bool"]]],[11,"clone","","",37,[[["self"]],["localinternedstring"]]],[11,"hash","","",37,N],[11,"partial_cmp","","",37,[[["self"],["localinternedstring"]],["option",["ordering"]]]],[11,"lt","","",37,[[["self"],["localinternedstring"]],["bool"]]],[11,"le","","",37,[[["self"],["localinternedstring"]],["bool"]]],[11,"gt","","",37,[[["self"],["localinternedstring"]],["bool"]]],[11,"ge","","",37,[[["self"],["localinternedstring"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",37,N],[11,"cmp","","",37,[[["self"],["localinternedstring"]],["ordering"]]],[11,"as_interned_str","","",37,[[["self"]],["internedstring"]]],[11,"as_ref","","",37,[[["self"]],["u"]]],[11,"eq","","",37,[[["self"],["t"]],["bool"]]],[11,"deref","","",37,[[["self"]],["str"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",37,[[["self"],["formatter"]],["result"]]],[11,"decode","","",37,[[["d"]],["result",["localinternedstring"]]]],[11,"encode","","",37,[[["self"],["s"]],["result"]]],[11,"clone","","",38,[[["self"]],["internedstring"]]],[11,"assert_receiver_is_total_eq","","",38,N],[11,"with","","",38,[[["self"],["f"]],["r"]]],[11,"as_symbol","","",38,[[["self"]],["symbol"]]],[11,"as_str","","",38,[[["self"]],["localinternedstring"]]],[11,"hash","","",38,[[["self"],["h"]]]],[11,"partial_cmp","","",38,[[["self"],["internedstring"]],["option",["ordering"]]]],[11,"cmp","","",38,[[["self"],["internedstring"]],["ordering"]]],[11,"eq","","",38,[[["self"],["t"]],["bool"]]],[11,"eq","","",38,[[["self"],["internedstring"]],["bool"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",38,[[["self"],["formatter"]],["result"]]],[11,"decode","","",38,[[["d"]],["result",["internedstring"]]]],[11,"encode","","",38,[[["self"],["s"]],["result"]]],[0,"analyze_source_file","syntax_pos","",N,N],[5,"analyze_source_file","syntax_pos::analyze_source_file","Find all newlines, multi-byte characters, and non-narrow characters in a SourceFile.",N,N],[5,"analyze_source_file_dispatch","","",N,[[["str"],["bytepos"],["vec"],["vec"],["vec"]]]],[5,"analyze_source_file_sse2","","Check 16 byte chunks of text at a time. If the chunk contains something other than printable ASCII characters and newlines, the function falls back to the generic implementation. Otherwise it uses SSE2 intrinsics to quickly find all newlines.",N,[[["str"],["bytepos"],["vec"],["vec"],["vec"]]]],[5,"analyze_source_file_generic","","",N,[[["str"],["usize"],["bytepos"],["vec"],["vec"],["vec"]],["usize"]]],[6,"FileLinesResult","syntax_pos","",N,N],[7,"GLOBALS","","",N,N],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",N,N],[17,"NO_EXPANSION","","",N,N],[17,"SPAN_DEBUG","","",N,N],[8,"Pos","","",N,N],[10,"from_usize","","",40,[[["usize"]],["self"]]],[10,"to_usize","","",40,[[["self"]],["usize"]]],[10,"from_u32","","",40,[[["u32"]],["self"]]],[10,"to_u32","","",40,[[["self"]],["u32"]]],[11,"new","","",1,[[],["globals"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"assert_receiver_is_total_eq","","",18,N],[11,"eq","","",18,[[["self"],["filename"]],["bool"]]],[11,"ne","","",18,[[["self"],["filename"]],["bool"]]],[11,"clone","","",18,[[["self"]],["filename"]]],[11,"cmp","","",18,[[["self"],["filename"]],["ordering"]]],[11,"partial_cmp","","",18,[[["self"],["filename"]],["option",["ordering"]]]],[11,"lt","","",18,[[["self"],["filename"]],["bool"]]],[11,"le","","",18,[[["self"],["filename"]],["bool"]]],[11,"gt","","",18,[[["self"],["filename"]],["bool"]]],[11,"ge","","",18,[[["self"],["filename"]],["bool"]]],[11,"hash","","",18,N],[11,"decode","","",18,[[["__d"]],["result",["filename"]]]],[11,"encode","","",18,[[["self"],["__s"]],["result"]]],[11,"fmt","","",18,[[["self"],["formatter"]],["result"]]],[11,"from","","",18,[[["pathbuf"]],["self"]]],[11,"is_real","","",18,[[["self"]],["bool"]]],[11,"is_macros","","",18,[[["self"]],["bool"]]],[11,"clone","","",2,[[["self"]],["spandata"]]],[11,"hash","","",2,N],[11,"eq","","",2,[[["self"],["spandata"]],["bool"]]],[11,"ne","","",2,[[["self"],["spandata"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",2,N],[11,"cmp","","",2,[[["self"],["spandata"]],["ordering"]]],[11,"partial_cmp","","",2,[[["self"],["spandata"]],["option",["ordering"]]]],[11,"lt","","",2,[[["self"],["spandata"]],["bool"]]],[11,"le","","",2,[[["self"],["spandata"]],["bool"]]],[11,"gt","","",2,[[["self"],["spandata"]],["bool"]]],[11,"ge","","",2,[[["self"],["spandata"]],["bool"]]],[11,"with_lo","","",2,[[["self"],["bytepos"]],["span"]]],[11,"with_hi","","",2,[[["self"],["bytepos"]],["span"]]],[11,"with_ctxt","","",2,[[["self"],["syntaxcontext"]],["span"]]],[11,"partial_cmp","","",0,[[["self"],["self"]],["option",["ordering"]]]],[11,"cmp","","",0,[[["self"],["self"]],["ordering"]]],[11,"clone","","",3,[[["self"]],["multispan"]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"hash","","",3,N],[11,"eq","","",3,[[["self"],["multispan"]],["bool"]]],[11,"ne","","",3,[[["self"],["multispan"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",3,N],[11,"encode","","",3,[[["self"],["__s"]],["result"]]],[11,"decode","","",3,[[["__d"]],["result",["multispan"]]]],[11,"lo","","",0,[[["self"]],["bytepos"]]],[11,"with_lo","","",0,[[["self"],["bytepos"]],["span"]]],[11,"hi","","",0,[[["self"]],["bytepos"]]],[11,"with_hi","","",0,[[["self"],["bytepos"]],["span"]]],[11,"ctxt","","",0,[[["self"]],["syntaxcontext"]]],[11,"with_ctxt","","",0,[[["self"],["syntaxcontext"]],["span"]]],[11,"is_dummy","","Returns `true` if this is a dummy span with any hygienic context.",0,[[["self"]],["bool"]]],[11,"shrink_to_lo","","Returns a new span representing an empty span at the beginning of this span",0,[[["self"]],["span"]]],[11,"shrink_to_hi","","Returns a new span representing an empty span at the end of this span",0,[[["self"]],["span"]]],[11,"substitute_dummy","","Returns `self` if `self` is not the dummy span, and `other` otherwise.",0,[[["self"],["span"]],["span"]]],[11,"contains","","Return true if `self` fully encloses `other`.",0,[[["self"],["span"]],["bool"]]],[11,"source_equal","","Return true if the spans are equal with regards to the source text.",0,[[["self"],["span"]],["bool"]]],[11,"trim_start","","Returns `Some(span)`, where the start is trimmed by the end of `other`",0,[[["self"],["span"]],["option",["span"]]]],[11,"source_callsite","","Return the source span - this is either the supplied span, or the span for the macro callsite that expanded to it.",0,[[["self"]],["span"]]],[11,"parent","","The `Span` for the tokens in the previous macro expansion from which `self` was generated, if any",0,[[["self"]],["option",["span"]]]],[11,"edition","","Edition of the crate from which this span came.",0,[[["self"]],["edition"]]],[11,"source_callee","","Return the source callee.",0,[[["self"]],["option",["expninfo"]]]],[11,"allows_unstable","","Check if a span is \"internal\" to a macro in which #[unstable] items can be used (that is, a macro marked with `#[allow_internal_unstable]`).",0,[[["self"]],["bool"]]],[11,"is_compiler_desugaring","","Check if this span arises from a compiler desugaring of kind `kind`.",0,[[["self"],["compilerdesugaringkind"]],["bool"]]],[11,"compiler_desugaring_kind","","Return the compiler desugaring that created this span, or None if this span is not from a desugaring.",0,[[["self"]],["option",["compilerdesugaringkind"]]]],[11,"allows_unsafe","","Check if a span is \"internal\" to a macro in which `unsafe` can be used without triggering the `unsafe_code` lint",0,[[["self"]],["bool"]]],[11,"macro_backtrace","","",0,[[["self"]],["vec",["macrobacktrace"]]]],[11,"to","","Return a `Span` that would enclose both `self` and `end`.",0,[[["self"],["span"]],["span"]]],[11,"between","","Return a `Span` between the end of `self` to the beginning of `end`.",0,[[["self"],["span"]],["span"]]],[11,"until","","Return a `Span` between the beginning of `self` to the beginning of `end`.",0,[[["self"],["span"]],["span"]]],[11,"from_inner_byte_pos","","",0,[[["self"],["usize"],["usize"]],["span"]]],[11,"apply_mark","","",0,[[["self"],["mark"]],["span"]]],[11,"remove_mark","","",0,[[["self"]],["mark"]]],[11,"adjust","","",0,[[["self"],["mark"]],["option",["mark"]]]],[11,"glob_adjust","","",0,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"reverse_glob_adjust","","",0,[[["self"],["mark"],["syntaxcontext"]],["option",["option"]]]],[11,"modern","","",0,[[["self"]],["span"]]],[11,"modern_and_legacy","","",0,[[["self"]],["span"]]],[11,"clone","","",4,[[["self"]],["spanlabel"]]],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"default","","",0,[[],["self"]]],[11,"default_encode","","",0,[[["self"],["s"]],["result"]]],[11,"default_decode","","",0,[[["d"]],["result",["span"]]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"new","","",3,[[],["multispan"]]],[11,"from_span","","",3,[[["span"]],["multispan"]]],[11,"from_spans","","",3,[[["vec",["span"]]],["multispan"]]],[11,"push_span_label","","",3,[[["self"],["span"],["string"]]]],[11,"primary_span","","Selects the first primary span (if any)",3,[[["self"]],["option",["span"]]]],[11,"primary_spans","","Returns all primary spans.",3,N],[11,"replace","","Replaces all occurrences of one Span with another. Used to move Spans in areas that don't display well (like std macros). Returns true if replacements occurred.",3,[[["self"],["span"],["span"]],["bool"]]],[11,"span_labels","","Returns the strings to highlight. We always ensure that there is an entry for each of the primary spans -- for each primary span P, if there is at least one label with span P, we return those labels (marked as primary). But otherwise we return `SpanLabel` instances with empty labels.",3,[[["self"]],["vec",["spanlabel"]]]],[11,"from","","",3,[[["span"]],["multispan"]]],[11,"from","","",3,[[["vec",["span"]]],["multispan"]]],[11,"clone","","",5,[[["self"]],["multibytechar"]]],[11,"encode","","",5,[[["self"],["__s"]],["result"]]],[11,"decode","","",5,[[["__d"]],["result",["multibytechar"]]]],[11,"assert_receiver_is_total_eq","","",5,N],[11,"eq","","",5,[[["self"],["multibytechar"]],["bool"]]],[11,"ne","","",5,[[["self"],["multibytechar"]],["bool"]]],[11,"fmt","","",5,[[["self"],["formatter"]],["result"]]],[11,"clone","","",19,[[["self"]],["nonnarrowchar"]]],[11,"encode","","",19,[[["self"],["__s"]],["result"]]],[11,"decode","","",19,[[["__d"]],["result",["nonnarrowchar"]]]],[11,"assert_receiver_is_total_eq","","",19,N],[11,"eq","","",19,[[["self"],["nonnarrowchar"]],["bool"]]],[11,"ne","","",19,[[["self"],["nonnarrowchar"]],["bool"]]],[11,"fmt","","",19,[[["self"],["formatter"]],["result"]]],[11,"new","","",19,[[["bytepos"],["usize"]],["self"]]],[11,"pos","","Returns the absolute offset of the character in the SourceMap",19,[[["self"]],["bytepos"]]],[11,"width","","Returns the width of the character, 0 (zero-width) or 2 (wide)",19,[[["self"]],["usize"]]],[11,"add","","",19,[[["self"],["bytepos"]],["self"]]],[11,"sub","","",19,[[["self"],["bytepos"]],["self"]]],[11,"eq","","",20,[[["self"],["externalsource"]],["bool"]]],[11,"ne","","",20,[[["self"],["externalsource"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",20,N],[11,"clone","","",20,[[["self"]],["externalsource"]]],[11,"is_absent","","",20,[[["self"]],["bool"]]],[11,"get_source","","",20,[[["self"]],["option",["str"]]]],[11,"clone","","",6,[[["self"]],["sourcefile"]]],[11,"encode","","",6,[[["self"],["s"]],["result"]]],[11,"decode","","",6,[[["d"]],["result",["sourcefile"]]]],[11,"fmt","","",6,[[["self"],["formatter"]],["result"]]],[11,"new","","",6,[[["filename"],["bool"],["filename"],["string"],["bytepos"]],["sourcefile"]]],[11,"line_begin_pos","","Return the BytePos of the beginning of the current line.",6,[[["self"],["bytepos"]],["bytepos"]]],[11,"add_external_src","","Add externally loaded source. If the hash of the input doesn't match or no input is supplied via None, it is interpreted as an error and the corresponding enum variant is set. The return value signifies whether some kind of source is present.",6,[[["self"],["f"]],["bool"]]],[11,"get_line","","Get a line from the list of pre-computed line-beginnings. The line number here is 0-based.",6,[[["self"],["usize"]],["option",["cow"]]]],[11,"is_real_file","","",6,[[["self"]],["bool"]]],[11,"is_imported","","",6,[[["self"]],["bool"]]],[11,"byte_length","","",6,[[["self"]],["u32"]]],[11,"count_lines","","",6,[[["self"]],["usize"]]],[11,"lookup_line","","Find the line containing the given position. The return value is the index into the `lines` array of this SourceFile, not the 1-based line number. If the source_file is empty or the position is located before the first line, None is returned.",6,[[["self"],["bytepos"]],["option",["usize"]]]],[11,"line_bounds","","",6,N],[11,"contains","","",6,[[["self"],["bytepos"]],["bool"]]],[11,"clone","","",7,[[["self"]],["bytepos"]]],[11,"eq","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"ne","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",7,N],[11,"hash","","",7,N],[11,"partial_cmp","","",7,[[["self"],["bytepos"]],["option",["ordering"]]]],[11,"lt","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"le","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"gt","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"ge","","",7,[[["self"],["bytepos"]],["bool"]]],[11,"cmp","","",7,[[["self"],["bytepos"]],["ordering"]]],[11,"fmt","","",7,[[["self"],["formatter"]],["result"]]],[11,"clone","","",8,[[["self"]],["charpos"]]],[11,"eq","","",8,[[["self"],["charpos"]],["bool"]]],[11,"ne","","",8,[[["self"],["charpos"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",8,N],[11,"hash","","",8,N],[11,"partial_cmp","","",8,[[["self"],["charpos"]],["option",["ordering"]]]],[11,"lt","","",8,[[["self"],["charpos"]],["bool"]]],[11,"le","","",8,[[["self"],["charpos"]],["bool"]]],[11,"gt","","",8,[[["self"],["charpos"]],["bool"]]],[11,"ge","","",8,[[["self"],["charpos"]],["bool"]]],[11,"cmp","","",8,[[["self"],["charpos"]],["ordering"]]],[11,"fmt","","",8,[[["self"],["formatter"]],["result"]]],[11,"from_usize","","",7,[[["usize"]],["bytepos"]]],[11,"to_usize","","",7,[[["self"]],["usize"]]],[11,"from_u32","","",7,[[["u32"]],["bytepos"]]],[11,"to_u32","","",7,[[["self"]],["u32"]]],[11,"add","","",7,[[["self"],["bytepos"]],["bytepos"]]],[11,"sub","","",7,[[["self"],["bytepos"]],["bytepos"]]],[11,"encode","","",7,[[["self"],["s"]],["result"]]],[11,"decode","","",7,[[["d"]],["result",["bytepos"]]]],[11,"from_usize","","",8,[[["usize"]],["charpos"]]],[11,"to_usize","","",8,[[["self"]],["usize"]]],[11,"from_u32","","",8,[[["u32"]],["charpos"]]],[11,"to_u32","","",8,[[["self"]],["u32"]]],[11,"add","","",8,[[["self"],["charpos"]],["charpos"]]],[11,"sub","","",8,[[["self"],["charpos"]],["charpos"]]],[11,"fmt","","",9,[[["self"],["formatter"]],["result"]]],[11,"clone","","",9,[[["self"]],["loc"]]],[11,"fmt","","",10,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",11,[[["self"],["formatter"]],["result"]]],[11,"fmt","","",12,[[["self"],["formatter"]],["result"]]],[11,"clone","","",13,[[["self"]],["lineinfo"]]],[11,"fmt","","",13,[[["self"],["formatter"]],["result"]]],[11,"eq","","",13,[[["self"],["lineinfo"]],["bool"]]],[11,"ne","","",13,[[["self"],["lineinfo"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",13,N],[11,"fmt","","",15,[[["self"],["formatter"]],["result"]]],[11,"clone","","",21,[[["self"]],["spanlineserror"]]],[11,"eq","","",21,[[["self"],["spanlineserror"]],["bool"]]],[11,"ne","","",21,[[["self"],["spanlineserror"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",21,N],[11,"fmt","","",21,[[["self"],["formatter"]],["result"]]],[11,"clone","","",22,[[["self"]],["spansnippeterror"]]],[11,"eq","","",22,[[["self"],["spansnippeterror"]],["bool"]]],[11,"ne","","",22,[[["self"],["spansnippeterror"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",22,N],[11,"fmt","","",22,[[["self"],["formatter"]],["result"]]],[11,"clone","","",16,[[["self"]],["distinctsources"]]],[11,"eq","","",16,[[["self"],["distinctsources"]],["bool"]]],[11,"ne","","",16,[[["self"],["distinctsources"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",16,N],[11,"fmt","","",16,[[["self"],["formatter"]],["result"]]],[11,"clone","","",17,[[["self"]],["malformedcodemappositions"]]],[11,"eq","","",17,[[["self"],["malformedcodemappositions"]],["bool"]]],[11,"ne","","",17,[[["self"],["malformedcodemappositions"]],["bool"]]],[11,"assert_receiver_is_total_eq","","",17,N],[11,"fmt","","",17,[[["self"],["formatter"]],["result"]]],[11,"to_owned","","",0,[[["self"]],["t"]]],[11,"clone_into","","",0,N],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"encode","","",0,[[["self"],["e"]],["result"]]],[11,"decode","","",0,[[["d"]],["result"]]],[11,"not_found","","",0,[[["str"],["str"]],["e"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"not_found","","",1,[[["str"],["str"]],["e"]]],[11,"to_owned","","",2,[[["self"]],["t"]]],[11,"clone_into","","",2,N],[11,"from","","",2,[[["t"]],["t"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"not_found","","",2,[[["str"],["str"]],["e"]]],[11,"to_owned","","",3,[[["self"]],["t"]]],[11,"clone_into","","",3,N],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"encode","","",3,[[["self"],["e"]],["result"]]],[11,"decode","","",3,[[["d"]],["result"]]],[11,"not_found","","",3,[[["str"],["str"]],["e"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"not_found","","",4,[[["str"],["str"]],["e"]]],[11,"to_owned","","",5,[[["self"]],["t"]]],[11,"clone_into","","",5,N],[11,"from","","",5,[[["t"]],["t"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]],[11,"encode","","",5,[[["self"],["e"]],["result"]]],[11,"decode","","",5,[[["d"]],["result"]]],[11,"not_found","","",5,[[["str"],["str"]],["e"]]],[11,"to_owned","","",6,[[["self"]],["t"]]],[11,"clone_into","","",6,N],[11,"from","","",6,[[["t"]],["t"]]],[11,"into","","",6,[[["self"]],["u"]]],[11,"try_from","","",6,[[["u"]],["result"]]],[11,"borrow","","",6,[[["self"]],["t"]]],[11,"try_into","","",6,[[["self"]],["result"]]],[11,"borrow_mut","","",6,[[["self"]],["t"]]],[11,"get_type_id","","",6,[[["self"]],["typeid"]]],[11,"encode","","",6,[[["self"],["e"]],["result"]]],[11,"decode","","",6,[[["d"]],["result"]]],[11,"not_found","","",6,[[["str"],["str"]],["e"]]],[11,"to_owned","","",7,[[["self"]],["t"]]],[11,"clone_into","","",7,N],[11,"from","","",7,[[["t"]],["t"]]],[11,"into","","",7,[[["self"]],["u"]]],[11,"try_from","","",7,[[["u"]],["result"]]],[11,"borrow","","",7,[[["self"]],["t"]]],[11,"try_into","","",7,[[["self"]],["result"]]],[11,"borrow_mut","","",7,[[["self"]],["t"]]],[11,"get_type_id","","",7,[[["self"]],["typeid"]]],[11,"encode","","",7,[[["self"],["e"]],["result"]]],[11,"decode","","",7,[[["d"]],["result"]]],[11,"not_found","","",7,[[["str"],["str"]],["e"]]],[11,"to_owned","","",8,[[["self"]],["t"]]],[11,"clone_into","","",8,N],[11,"from","","",8,[[["t"]],["t"]]],[11,"into","","",8,[[["self"]],["u"]]],[11,"try_from","","",8,[[["u"]],["result"]]],[11,"borrow","","",8,[[["self"]],["t"]]],[11,"try_into","","",8,[[["self"]],["result"]]],[11,"borrow_mut","","",8,[[["self"]],["t"]]],[11,"get_type_id","","",8,[[["self"]],["typeid"]]],[11,"not_found","","",8,[[["str"],["str"]],["e"]]],[11,"to_owned","","",9,[[["self"]],["t"]]],[11,"clone_into","","",9,N],[11,"from","","",9,[[["t"]],["t"]]],[11,"into","","",9,[[["self"]],["u"]]],[11,"try_from","","",9,[[["u"]],["result"]]],[11,"borrow","","",9,[[["self"]],["t"]]],[11,"try_into","","",9,[[["self"]],["result"]]],[11,"borrow_mut","","",9,[[["self"]],["t"]]],[11,"get_type_id","","",9,[[["self"]],["typeid"]]],[11,"not_found","","",9,[[["str"],["str"]],["e"]]],[11,"from","","",10,[[["t"]],["t"]]],[11,"into","","",10,[[["self"]],["u"]]],[11,"try_from","","",10,[[["u"]],["result"]]],[11,"borrow","","",10,[[["self"]],["t"]]],[11,"try_into","","",10,[[["self"]],["result"]]],[11,"borrow_mut","","",10,[[["self"]],["t"]]],[11,"get_type_id","","",10,[[["self"]],["typeid"]]],[11,"not_found","","",10,[[["str"],["str"]],["e"]]],[11,"from","","",11,[[["t"]],["t"]]],[11,"into","","",11,[[["self"]],["u"]]],[11,"try_from","","",11,[[["u"]],["result"]]],[11,"borrow","","",11,[[["self"]],["t"]]],[11,"try_into","","",11,[[["self"]],["result"]]],[11,"borrow_mut","","",11,[[["self"]],["t"]]],[11,"get_type_id","","",11,[[["self"]],["typeid"]]],[11,"not_found","","",11,[[["str"],["str"]],["e"]]],[11,"from","","",12,[[["t"]],["t"]]],[11,"into","","",12,[[["self"]],["u"]]],[11,"try_from","","",12,[[["u"]],["result"]]],[11,"borrow","","",12,[[["self"]],["t"]]],[11,"try_into","","",12,[[["self"]],["result"]]],[11,"borrow_mut","","",12,[[["self"]],["t"]]],[11,"get_type_id","","",12,[[["self"]],["typeid"]]],[11,"not_found","","",12,[[["str"],["str"]],["e"]]],[11,"to_owned","","",13,[[["self"]],["t"]]],[11,"clone_into","","",13,N],[11,"from","","",13,[[["t"]],["t"]]],[11,"into","","",13,[[["self"]],["u"]]],[11,"try_from","","",13,[[["u"]],["result"]]],[11,"borrow","","",13,[[["self"]],["t"]]],[11,"try_into","","",13,[[["self"]],["result"]]],[11,"borrow_mut","","",13,[[["self"]],["t"]]],[11,"get_type_id","","",13,[[["self"]],["typeid"]]],[11,"not_found","","",13,[[["str"],["str"]],["e"]]],[11,"from","","",14,[[["t"]],["t"]]],[11,"into","","",14,[[["self"]],["u"]]],[11,"try_from","","",14,[[["u"]],["result"]]],[11,"borrow","","",14,[[["self"]],["t"]]],[11,"try_into","","",14,[[["self"]],["result"]]],[11,"borrow_mut","","",14,[[["self"]],["t"]]],[11,"get_type_id","","",14,[[["self"]],["typeid"]]],[11,"not_found","","",14,[[["str"],["str"]],["e"]]],[11,"from","","",15,[[["t"]],["t"]]],[11,"into","","",15,[[["self"]],["u"]]],[11,"try_from","","",15,[[["u"]],["result"]]],[11,"borrow","","",15,[[["self"]],["t"]]],[11,"try_into","","",15,[[["self"]],["result"]]],[11,"borrow_mut","","",15,[[["self"]],["t"]]],[11,"get_type_id","","",15,[[["self"]],["typeid"]]],[11,"not_found","","",15,[[["str"],["str"]],["e"]]],[11,"to_owned","","",16,[[["self"]],["t"]]],[11,"clone_into","","",16,N],[11,"from","","",16,[[["t"]],["t"]]],[11,"into","","",16,[[["self"]],["u"]]],[11,"try_from","","",16,[[["u"]],["result"]]],[11,"borrow","","",16,[[["self"]],["t"]]],[11,"try_into","","",16,[[["self"]],["result"]]],[11,"borrow_mut","","",16,[[["self"]],["t"]]],[11,"get_type_id","","",16,[[["self"]],["typeid"]]],[11,"not_found","","",16,[[["str"],["str"]],["e"]]],[11,"to_owned","","",17,[[["self"]],["t"]]],[11,"clone_into","","",17,N],[11,"from","","",17,[[["t"]],["t"]]],[11,"into","","",17,[[["self"]],["u"]]],[11,"try_from","","",17,[[["u"]],["result"]]],[11,"borrow","","",17,[[["self"]],["t"]]],[11,"try_into","","",17,[[["self"]],["result"]]],[11,"borrow_mut","","",17,[[["self"]],["t"]]],[11,"get_type_id","","",17,[[["self"]],["typeid"]]],[11,"not_found","","",17,[[["str"],["str"]],["e"]]],[11,"to_owned","","",18,[[["self"]],["t"]]],[11,"clone_into","","",18,N],[11,"from","","",18,[[["t"]],["t"]]],[11,"to_string","","",18,[[["self"]],["string"]]],[11,"into","","",18,[[["self"]],["u"]]],[11,"try_from","","",18,[[["u"]],["result"]]],[11,"borrow","","",18,[[["self"]],["t"]]],[11,"try_into","","",18,[[["self"]],["result"]]],[11,"borrow_mut","","",18,[[["self"]],["t"]]],[11,"get_type_id","","",18,[[["self"]],["typeid"]]],[11,"encode","","",18,[[["self"],["e"]],["result"]]],[11,"decode","","",18,[[["d"]],["result"]]],[11,"not_found","","",18,[[["str"],["str"]],["e"]]],[11,"to_owned","","",19,[[["self"]],["t"]]],[11,"clone_into","","",19,N],[11,"from","","",19,[[["t"]],["t"]]],[11,"into","","",19,[[["self"]],["u"]]],[11,"try_from","","",19,[[["u"]],["result"]]],[11,"borrow","","",19,[[["self"]],["t"]]],[11,"try_into","","",19,[[["self"]],["result"]]],[11,"borrow_mut","","",19,[[["self"]],["t"]]],[11,"get_type_id","","",19,[[["self"]],["typeid"]]],[11,"encode","","",19,[[["self"],["e"]],["result"]]],[11,"decode","","",19,[[["d"]],["result"]]],[11,"not_found","","",19,[[["str"],["str"]],["e"]]],[11,"to_owned","","",20,[[["self"]],["t"]]],[11,"clone_into","","",20,N],[11,"from","","",20,[[["t"]],["t"]]],[11,"into","","",20,[[["self"]],["u"]]],[11,"try_from","","",20,[[["u"]],["result"]]],[11,"borrow","","",20,[[["self"]],["t"]]],[11,"try_into","","",20,[[["self"]],["result"]]],[11,"borrow_mut","","",20,[[["self"]],["t"]]],[11,"get_type_id","","",20,[[["self"]],["typeid"]]],[11,"not_found","","",20,[[["str"],["str"]],["e"]]],[11,"to_owned","","",21,[[["self"]],["t"]]],[11,"clone_into","","",21,N],[11,"from","","",21,[[["t"]],["t"]]],[11,"into","","",21,[[["self"]],["u"]]],[11,"try_from","","",21,[[["u"]],["result"]]],[11,"borrow","","",21,[[["self"]],["t"]]],[11,"try_into","","",21,[[["self"]],["result"]]],[11,"borrow_mut","","",21,[[["self"]],["t"]]],[11,"get_type_id","","",21,[[["self"]],["typeid"]]],[11,"not_found","","",21,[[["str"],["str"]],["e"]]],[11,"to_owned","","",22,[[["self"]],["t"]]],[11,"clone_into","","",22,N],[11,"from","","",22,[[["t"]],["t"]]],[11,"into","","",22,[[["self"]],["u"]]],[11,"try_from","","",22,[[["u"]],["result"]]],[11,"borrow","","",22,[[["self"]],["t"]]],[11,"try_into","","",22,[[["self"]],["result"]]],[11,"borrow_mut","","",22,[[["self"]],["t"]]],[11,"get_type_id","","",22,[[["self"]],["typeid"]]],[11,"not_found","","",22,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax_pos::edition","",23,[[["self"]],["t"]]],[11,"clone_into","","",23,N],[11,"from","","",23,[[["t"]],["t"]]],[11,"to_string","","",23,[[["self"]],["string"]]],[11,"into","","",23,[[["self"]],["u"]]],[11,"try_from","","",23,[[["u"]],["result"]]],[11,"borrow","","",23,[[["self"]],["t"]]],[11,"try_into","","",23,[[["self"]],["result"]]],[11,"borrow_mut","","",23,[[["self"]],["t"]]],[11,"get_type_id","","",23,[[["self"]],["typeid"]]],[11,"encode","","",23,[[["self"],["e"]],["result"]]],[11,"decode","","",23,[[["d"]],["result"]]],[11,"not_found","","",23,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax_pos::hygiene","",24,[[["self"]],["t"]]],[11,"clone_into","","",24,N],[11,"from","","",24,[[["t"]],["t"]]],[11,"into","","",24,[[["self"]],["u"]]],[11,"try_from","","",24,[[["u"]],["result"]]],[11,"borrow","","",24,[[["self"]],["t"]]],[11,"try_into","","",24,[[["self"]],["result"]]],[11,"borrow_mut","","",24,[[["self"]],["t"]]],[11,"get_type_id","","",24,[[["self"]],["typeid"]]],[11,"encode","","",24,[[["self"],["e"]],["result"]]],[11,"decode","","",24,[[["d"]],["result"]]],[11,"not_found","","",24,[[["str"],["str"]],["e"]]],[11,"to_owned","","",25,[[["self"]],["t"]]],[11,"clone_into","","",25,N],[11,"from","","",25,[[["t"]],["t"]]],[11,"into","","",25,[[["self"]],["u"]]],[11,"try_from","","",25,[[["u"]],["result"]]],[11,"borrow","","",25,[[["self"]],["t"]]],[11,"try_into","","",25,[[["self"]],["result"]]],[11,"borrow_mut","","",25,[[["self"]],["t"]]],[11,"get_type_id","","",25,[[["self"]],["typeid"]]],[11,"not_found","","",25,[[["str"],["str"]],["e"]]],[11,"to_owned","","",26,[[["self"]],["t"]]],[11,"clone_into","","",26,N],[11,"from","","",26,[[["t"]],["t"]]],[11,"into","","",26,[[["self"]],["u"]]],[11,"try_from","","",26,[[["u"]],["result"]]],[11,"borrow","","",26,[[["self"]],["t"]]],[11,"try_into","","",26,[[["self"]],["result"]]],[11,"borrow_mut","","",26,[[["self"]],["t"]]],[11,"get_type_id","","",26,[[["self"]],["typeid"]]],[11,"encode","","",26,[[["self"],["e"]],["result"]]],[11,"decode","","",26,[[["d"]],["result"]]],[11,"not_found","","",26,[[["str"],["str"]],["e"]]],[11,"to_owned","","",27,[[["self"]],["t"]]],[11,"clone_into","","",27,N],[11,"from","","",27,[[["t"]],["t"]]],[11,"into","","",27,[[["self"]],["u"]]],[11,"try_from","","",27,[[["u"]],["result"]]],[11,"borrow","","",27,[[["self"]],["t"]]],[11,"try_into","","",27,[[["self"]],["result"]]],[11,"borrow_mut","","",27,[[["self"]],["t"]]],[11,"get_type_id","","",27,[[["self"]],["typeid"]]],[11,"not_found","","",27,[[["str"],["str"]],["e"]]],[11,"from","","",28,[[["t"]],["t"]]],[11,"into","","",28,[[["self"]],["u"]]],[11,"try_from","","",28,[[["u"]],["result"]]],[11,"borrow","","",28,[[["self"]],["t"]]],[11,"try_into","","",28,[[["self"]],["result"]]],[11,"borrow_mut","","",28,[[["self"]],["t"]]],[11,"get_type_id","","",28,[[["self"]],["typeid"]]],[11,"not_found","","",28,[[["str"],["str"]],["e"]]],[11,"to_owned","","",29,[[["self"]],["t"]]],[11,"clone_into","","",29,N],[11,"from","","",29,[[["t"]],["t"]]],[11,"into","","",29,[[["self"]],["u"]]],[11,"try_from","","",29,[[["u"]],["result"]]],[11,"borrow","","",29,[[["self"]],["t"]]],[11,"try_into","","",29,[[["self"]],["result"]]],[11,"borrow_mut","","",29,[[["self"]],["t"]]],[11,"get_type_id","","",29,[[["self"]],["typeid"]]],[11,"encode","","",29,[[["self"],["e"]],["result"]]],[11,"decode","","",29,[[["d"]],["result"]]],[11,"not_found","","",29,[[["str"],["str"]],["e"]]],[11,"to_owned","","",30,[[["self"]],["t"]]],[11,"clone_into","","",30,N],[11,"from","","",30,[[["t"]],["t"]]],[11,"into","","",30,[[["self"]],["u"]]],[11,"try_from","","",30,[[["u"]],["result"]]],[11,"borrow","","",30,[[["self"]],["t"]]],[11,"try_into","","",30,[[["self"]],["result"]]],[11,"borrow_mut","","",30,[[["self"]],["t"]]],[11,"get_type_id","","",30,[[["self"]],["typeid"]]],[11,"not_found","","",30,[[["str"],["str"]],["e"]]],[11,"to_owned","","",31,[[["self"]],["t"]]],[11,"clone_into","","",31,N],[11,"from","","",31,[[["t"]],["t"]]],[11,"into","","",31,[[["self"]],["u"]]],[11,"try_from","","",31,[[["u"]],["result"]]],[11,"borrow","","",31,[[["self"]],["t"]]],[11,"try_into","","",31,[[["self"]],["result"]]],[11,"borrow_mut","","",31,[[["self"]],["t"]]],[11,"get_type_id","","",31,[[["self"]],["typeid"]]],[11,"encode","","",31,[[["self"],["e"]],["result"]]],[11,"decode","","",31,[[["d"]],["result"]]],[11,"not_found","","",31,[[["str"],["str"]],["e"]]],[11,"to_owned","","",32,[[["self"]],["t"]]],[11,"clone_into","","",32,N],[11,"from","","",32,[[["t"]],["t"]]],[11,"into","","",32,[[["self"]],["u"]]],[11,"try_from","","",32,[[["u"]],["result"]]],[11,"borrow","","",32,[[["self"]],["t"]]],[11,"try_into","","",32,[[["self"]],["result"]]],[11,"borrow_mut","","",32,[[["self"]],["t"]]],[11,"get_type_id","","",32,[[["self"]],["typeid"]]],[11,"encode","","",32,[[["self"],["e"]],["result"]]],[11,"decode","","",32,[[["d"]],["result"]]],[11,"not_found","","",32,[[["str"],["str"]],["e"]]],[11,"from","syntax_pos::span_encoding","",33,[[["t"]],["t"]]],[11,"into","","",33,[[["self"]],["u"]]],[11,"try_from","","",33,[[["u"]],["result"]]],[11,"borrow","","",33,[[["self"]],["t"]]],[11,"try_into","","",33,[[["self"]],["result"]]],[11,"borrow_mut","","",33,[[["self"]],["t"]]],[11,"get_type_id","","",33,[[["self"]],["typeid"]]],[11,"not_found","","",33,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax_pos::symbol","",34,[[["self"]],["t"]]],[11,"clone_into","","",34,N],[11,"from","","",34,[[["t"]],["t"]]],[11,"to_string","","",34,[[["self"]],["string"]]],[11,"into","","",34,[[["self"]],["u"]]],[11,"try_from","","",34,[[["u"]],["result"]]],[11,"borrow","","",34,[[["self"]],["t"]]],[11,"try_into","","",34,[[["self"]],["result"]]],[11,"borrow_mut","","",34,[[["self"]],["t"]]],[11,"get_type_id","","",34,[[["self"]],["typeid"]]],[11,"encode","","",34,[[["self"],["e"]],["result"]]],[11,"decode","","",34,[[["d"]],["result"]]],[11,"not_found","","",34,[[["str"],["str"]],["e"]]],[11,"to_owned","","",35,[[["self"]],["t"]]],[11,"clone_into","","",35,N],[11,"from","","",35,[[["t"]],["t"]]],[11,"to_string","","",35,[[["self"]],["string"]]],[11,"into","","",35,[[["self"]],["u"]]],[11,"try_from","","",35,[[["u"]],["result"]]],[11,"borrow","","",35,[[["self"]],["t"]]],[11,"try_into","","",35,[[["self"]],["result"]]],[11,"borrow_mut","","",35,[[["self"]],["t"]]],[11,"get_type_id","","",35,[[["self"]],["typeid"]]],[11,"encode","","",35,[[["self"],["e"]],["result"]]],[11,"decode","","",35,[[["d"]],["result"]]],[11,"not_found","","",35,[[["str"],["str"]],["e"]]],[11,"from","","",36,[[["t"]],["t"]]],[11,"into","","",36,[[["self"]],["u"]]],[11,"try_from","","",36,[[["u"]],["result"]]],[11,"borrow","","",36,[[["self"]],["t"]]],[11,"try_into","","",36,[[["self"]],["result"]]],[11,"borrow_mut","","",36,[[["self"]],["t"]]],[11,"get_type_id","","",36,[[["self"]],["typeid"]]],[11,"not_found","","",36,[[["str"],["str"]],["e"]]],[11,"to_owned","","",37,[[["self"]],["t"]]],[11,"clone_into","","",37,N],[11,"from","","",37,[[["t"]],["t"]]],[11,"to_string","","",37,[[["self"]],["string"]]],[11,"into","","",37,[[["self"]],["u"]]],[11,"try_from","","",37,[[["u"]],["result"]]],[11,"borrow","","",37,[[["self"]],["t"]]],[11,"try_into","","",37,[[["self"]],["result"]]],[11,"borrow_mut","","",37,[[["self"]],["t"]]],[11,"get_type_id","","",37,[[["self"]],["typeid"]]],[11,"encode","","",37,[[["self"],["e"]],["result"]]],[11,"decode","","",37,[[["d"]],["result"]]],[11,"not_found","","",37,[[["str"],["str"]],["e"]]],[11,"to_owned","","",38,[[["self"]],["t"]]],[11,"clone_into","","",38,N],[11,"from","","",38,[[["t"]],["t"]]],[11,"to_string","","",38,[[["self"]],["string"]]],[11,"into","","",38,[[["self"]],["u"]]],[11,"try_from","","",38,[[["u"]],["result"]]],[11,"borrow","","",38,[[["self"]],["t"]]],[11,"try_into","","",38,[[["self"]],["result"]]],[11,"borrow_mut","","",38,[[["self"]],["t"]]],[11,"get_type_id","","",38,[[["self"]],["typeid"]]],[11,"encode","","",38,[[["self"],["e"]],["result"]]],[11,"decode","","",38,[[["d"]],["result"]]],[11,"not_found","","",38,[[["str"],["str"]],["e"]]],[11,"to_owned","syntax_pos::symbol::keywords","",39,[[["self"]],["t"]]],[11,"clone_into","","",39,N],[11,"from","","",39,[[["t"]],["t"]]],[11,"into","","",39,[[["self"]],["u"]]],[11,"try_from","","",39,[[["u"]],["result"]]],[11,"borrow","","",39,[[["self"]],["t"]]],[11,"try_into","","",39,[[["self"]],["result"]]],[11,"borrow_mut","","",39,[[["self"]],["t"]]],[11,"get_type_id","","",39,[[["self"]],["typeid"]]],[11,"not_found","","",39,[[["str"],["str"]],["e"]]]],"paths":[[3,"Span"],[3,"Globals"],[3,"SpanData"],[3,"MultiSpan"],[3,"SpanLabel"],[3,"MultiByteChar"],[3,"SourceFile"],[3,"BytePos"],[3,"CharPos"],[3,"Loc"],[3,"LocWithOpt"],[3,"SourceFileAndLine"],[3,"SourceFileAndBytePos"],[3,"LineInfo"],[3,"FileLines"],[3,"MacroBacktrace"],[3,"DistinctSources"],[3,"MalformedCodemapPositions"],[4,"FileName"],[4,"NonNarrowChar"],[4,"ExternalSource"],[4,"SpanLinesError"],[4,"SpanSnippetError"],[4,"Edition"],[3,"SyntaxContext"],[3,"SyntaxContextData"],[3,"Mark"],[3,"MarkData"],[3,"HygieneData"],[3,"ExpnInfo"],[4,"Transparency"],[4,"ExpnFormat"],[4,"CompilerDesugaringKind"],[3,"SpanInterner"],[3,"Ident"],[3,"Symbol"],[3,"Interner"],[3,"LocalInternedString"],[3,"InternedString"],[3,"Keyword"],[8,"Pos"]]};
searchIndex["tempfile"]={"doc":"Temporary files and directories.","items":[[3,"TempDir","tempfile","A directory in the filesystem that is automatically deleted when it goes out of scope.",N,N],[12,"path","","",0,N],[3,"NamedTempFile","","A named temporary file.",N,N],[12,"path","","",1,N],[12,"file","","",1,N],[3,"PersistError","","Error returned when persisting a temporary file fails.",N,N],[12,"error","","The underlying IO error.",2,N],[12,"file","","The temporary file that couldn't be persisted.",2,N],[3,"TempPath","","A path to a named temporary file without an open file handle.",N,N],[12,"path","","",3,N],[3,"Builder","","Create a new temporary file or directory with custom parameters.",N,N],[12,"random_len","","",4,N],[12,"prefix","","",4,N],[12,"suffix","","",4,N],[5,"tempdir","","Create a new temporary directory.",N,[[],["result",["tempdir"]]]],[5,"tempdir_in","","Create a new temporary directory.",N,[[["p"]],["result",["tempdir"]]]],[5,"tempfile","","Create a new temporary file.",N,[[],["result",["file"]]]],[5,"tempfile_in","","Create a new temporary file in the specified directory.",N,[[["p"]],["result",["file"]]]],[0,"dir","","",N,N],[3,"TempDir","tempfile::dir","A directory in the filesystem that is automatically deleted when it goes out of scope.",N,N],[12,"path","","",0,N],[5,"tempdir","","Create a new temporary directory.",N,[[],["result",["tempdir"]]]],[5,"tempdir_in","","Create a new temporary directory.",N,[[["p"]],["result",["tempdir"]]]],[5,"create","","",N,[[["pathbuf"]],["result",["tempdir"]]]],[11,"new","tempfile","Attempts to make a temporary directory inside of `env::temp_dir()`.",0,[[],["result",["tempdir"]]]],[11,"new_in","","Attempts to make a temporary directory inside of `dir`. The directory and everything inside it will be automatically  deleted once the returned `TempDir` is destroyed.",0,[[["p"]],["result",["tempdir"]]]],[11,"path","","Accesses the [`Path`] to the temporary directory.",0,[[["self"]],["path"]]],[11,"into_path","","Persist the temporary directory to disk, returning the [`PathBuf`] where it is located.",0,[[["self"]],["pathbuf"]]],[11,"close","","Closes and removes the temporary directory, returing a `Result`.",0,[[["self"]],["result"]]],[11,"as_ref","","",0,[[["self"]],["path"]]],[11,"fmt","","",0,[[["self"],["formatter"]],["result"]]],[11,"drop","","",0,[[["self"]]]],[0,"file","","",N,N],[3,"PathPersistError","tempfile::file","Error returned when persisting a temporary file path fails.",N,N],[12,"error","","The underlying IO error.",5,N],[12,"path","","The temporary file path that couldn't be persisted.",5,N],[3,"TempPath","","A path to a named temporary file without an open file handle.",N,N],[12,"path","","",3,N],[3,"NamedTempFile","","A named temporary file.",N,N],[12,"path","","",1,N],[12,"file","","",1,N],[3,"PersistError","","Error returned when persisting a temporary file fails.",N,N],[12,"error","","The underlying IO error.",2,N],[12,"file","","The temporary file that couldn't be persisted.",2,N],[5,"tempfile","","Create a new temporary file.",N,[[],["result",["file"]]]],[5,"tempfile_in","","Create a new temporary file in the specified directory.",N,[[["p"]],["result",["file"]]]],[5,"create_named","","",N,[[["pathbuf"]],["result",["namedtempfile"]]]],[0,"imp","","",N,N],[0,"unix","tempfile::file::imp","",N,N],[5,"cvt_err","tempfile::file::imp::unix","",N,[[["c_int"]],["result",["c_int"]]]],[5,"cstr","","",N,[[["path"]],["result",["cstring"]]]],[5,"create_named","","",N,[[["path"]],["result",["file"]]]],[5,"create_unlinked","","",N,[[["path"]],["result",["file"]]]],[5,"create","","",N,[[["path"]],["result",["file"]]]],[5,"create_unix","","",N,[[["path"]],["result",["file"]]]],[5,"stat","","",N,[[["rawfd"]],["result",["stat_t"]]]],[5,"reopen","","",N,[[["file"],["path"]],["result",["file"]]]],[5,"persist","","",N,[[["path"],["path"],["bool"]],["result"]]],[11,"fmt","tempfile::file","",5,[[["self"],["formatter"]],["result"]]],[11,"from","tempfile","",3,[[["pathpersisterror"]],["temppath"]]],[11,"fmt","tempfile::file","",5,[[["self"],["formatter"]],["result"]]],[11,"description","","",5,[[["self"]],["str"]]],[11,"cause","","",5,[[["self"]],["option",["error"]]]],[11,"close","tempfile","Close and remove the temporary file.",3,[[["self"]],["result"]]],[11,"persist","","Persist the temporary file at the target path.",3,[[["self"],["p"]],["result",["pathpersisterror"]]]],[11,"persist_noclobber","","Persist the temporary file at the target path iff no file exists there.",3,[[["self"],["p"]],["result",["pathpersisterror"]]]],[11,"fmt","","",3,[[["self"],["formatter"]],["result"]]],[11,"drop","","",3,[[["self"]]]],[11,"deref","","",3,[[["self"]],["path"]]],[11,"as_ref","","",3,[[["self"]],["path"]]],[11,"as_ref","","",3,[[["self"]],["osstr"]]],[11,"fmt","","",1,[[["self"],["formatter"]],["result"]]],[11,"as_ref","","",1,[[["self"]],["path"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"from","","",1,[[["persisterror"]],["namedtempfile"]]],[11,"fmt","","",2,[[["self"],["formatter"]],["result"]]],[11,"description","","",2,[[["self"]],["str"]]],[11,"cause","","",2,[[["self"]],["option",["error"]]]],[11,"new","","Create a new named temporary file.",1,[[],["result",["namedtempfile"]]]],[11,"new_in","","Create a new named temporary file in the specified directory.",1,[[["p"]],["result",["namedtempfile"]]]],[11,"path","","Get the temporary file's path.",1,[[["self"]],["path"]]],[11,"close","","Close and remove the temporary file.",1,[[["self"]],["result"]]],[11,"persist","","Persist the temporary file at the target path.",1,[[["self"],["p"]],["result",["file","persisterror"]]]],[11,"persist_noclobber","","Persist the temporary file at the target path iff no file exists there.",1,[[["self"],["p"]],["result",["file","persisterror"]]]],[11,"reopen","","Reopen the temporary file.",1,[[["self"]],["result",["file"]]]],[11,"as_file","","Get a reference to the underlying file.",1,[[["self"]],["file"]]],[11,"as_file_mut","","Get a mutable reference to the underlying file.",1,[[["self"]],["file"]]],[11,"into_file","","Convert the temporary file into a `std::fs::File`.",1,[[["self"]],["file"]]],[11,"into_temp_path","","Closes the file, leaving only the temporary file path.",1,[[["self"]],["temppath"]]],[11,"read","","",1,N],[11,"write","","",1,N],[11,"flush","","",1,[[["self"]],["result"]]],[11,"seek","","",1,[[["self"],["seekfrom"]],["result",["u64"]]]],[11,"as_raw_fd","","",1,[[["self"]],["rawfd"]]],[0,"util","","",N,N],[5,"tmpname","tempfile::util","",N,[[["str"],["str"],["usize"]],["osstring"]]],[5,"create_helper","","",N,[[["path"],["str"],["str"],["usize"],["f"]],["result"]]],[17,"NUM_RETRIES","tempfile","",N,N],[17,"NUM_RAND_CHARS","","",N,N],[11,"fmt","","",4,[[["self"],["formatter"]],["result"]]],[11,"clone","","",4,[[["self"]],["builder"]]],[11,"assert_receiver_is_total_eq","","",4,N],[11,"eq","","",4,[[["self"],["builder"]],["bool"]]],[11,"ne","","",4,[[["self"],["builder"]],["bool"]]],[11,"default","","",4,[[],["self"]]],[11,"new","","Create a new `Builder`.",4,[[],["self"]]],[11,"prefix","","Set a custom filename prefix.",4,[[["self"],["str"]],["self"]]],[11,"suffix","","Set a custom filename suffix.",4,[[["self"],["str"]],["self"]]],[11,"rand_bytes","","Set the number of random bytes.",4,[[["self"],["usize"]],["self"]]],[11,"tempfile","","Create the named temporary file.",4,[[["self"]],["result",["namedtempfile"]]]],[11,"tempfile_in","","Create the named temporary file in the specified directory.",4,[[["self"],["p"]],["result",["namedtempfile"]]]],[11,"tempdir","","Attempts to make a temporary directory inside of `env::temp_dir()` whose name will have the prefix, `prefix`. The directory and everything inside it will be automatically deleted once the returned `TempDir` is destroyed.",4,[[["self"]],["result",["tempdir"]]]],[11,"tempdir_in","","Attempts to make a temporary directory inside of `dir`. The directory and everything inside it will be automatically deleted once the returned `TempDir` is destroyed.",4,[[["self"],["p"]],["result",["tempdir"]]]],[11,"from","","",0,[[["t"]],["t"]]],[11,"into","","",0,[[["self"]],["u"]]],[11,"try_from","","",0,[[["u"]],["result"]]],[11,"borrow","","",0,[[["self"]],["t"]]],[11,"try_into","","",0,[[["self"]],["result"]]],[11,"borrow_mut","","",0,[[["self"]],["t"]]],[11,"get_type_id","","",0,[[["self"]],["typeid"]]],[11,"from","","",1,[[["t"]],["t"]]],[11,"into","","",1,[[["self"]],["u"]]],[11,"try_from","","",1,[[["u"]],["result"]]],[11,"borrow","","",1,[[["self"]],["t"]]],[11,"try_into","","",1,[[["self"]],["result"]]],[11,"borrow_mut","","",1,[[["self"]],["t"]]],[11,"get_type_id","","",1,[[["self"]],["typeid"]]],[11,"from","","",2,[[["t"]],["t"]]],[11,"to_string","","",2,[[["self"]],["string"]]],[11,"into","","",2,[[["self"]],["u"]]],[11,"try_from","","",2,[[["u"]],["result"]]],[11,"borrow","","",2,[[["self"]],["t"]]],[11,"try_into","","",2,[[["self"]],["result"]]],[11,"borrow_mut","","",2,[[["self"]],["t"]]],[11,"get_type_id","","",2,[[["self"]],["typeid"]]],[11,"from","","",3,[[["t"]],["t"]]],[11,"into","","",3,[[["self"]],["u"]]],[11,"try_from","","",3,[[["u"]],["result"]]],[11,"borrow","","",3,[[["self"]],["t"]]],[11,"try_into","","",3,[[["self"]],["result"]]],[11,"borrow_mut","","",3,[[["self"]],["t"]]],[11,"get_type_id","","",3,[[["self"]],["typeid"]]],[11,"to_owned","","",4,[[["self"]],["t"]]],[11,"clone_into","","",4,N],[11,"from","","",4,[[["t"]],["t"]]],[11,"into","","",4,[[["self"]],["u"]]],[11,"try_from","","",4,[[["u"]],["result"]]],[11,"borrow","","",4,[[["self"]],["t"]]],[11,"try_into","","",4,[[["self"]],["result"]]],[11,"borrow_mut","","",4,[[["self"]],["t"]]],[11,"get_type_id","","",4,[[["self"]],["typeid"]]],[11,"from","tempfile::file","",5,[[["t"]],["t"]]],[11,"to_string","","",5,[[["self"]],["string"]]],[11,"into","","",5,[[["self"]],["u"]]],[11,"try_from","","",5,[[["u"]],["result"]]],[11,"borrow","","",5,[[["self"]],["t"]]],[11,"try_into","","",5,[[["self"]],["result"]]],[11,"borrow_mut","","",5,[[["self"]],["t"]]],[11,"get_type_id","","",5,[[["self"]],["typeid"]]]],"paths":[[3,"TempDir"],[3,"NamedTempFile"],[3,"PersistError"],[3,"TempPath"],[3,"Builder"],[3,"PathPersistError"]]};
initSearch(searchIndex);
